/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var h1=["require","exports","vs/base/common/errors","vs/base/common/platform","vs/base/common/charCode","vs/base/common/functional","vs/base/common/lifecycle","vs/base/common/path","vs/base/common/event","vs/base/common/strings","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/arrays","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/map","vs/base/common/marshallingIds","vs/base/common/process","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/cache","vs/base/common/uint","vs/base/common/uri","vs/base/common/network","vs/base/common/worker/simpleWorker"],d1=function(t1){for(var t=[],g=0,e=t1.length;g<e;g++)t[g]=h1[t1[g]];return t};define(h1[10],d1([0,1]),function(t1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ob=void 0,t.$hb=g,t.$ib=e,t.$jb=q,t.$kb=R,t.$lb=n1,t.$mb=H,t.$nb=S,t.$pb=k,t.$qb=Y,t.$rb=M,t.$sb=J,t.$tb=L;function g(w,U){const P=e(w,U);if(P!==-1)return w[P]}function e(w,U,P=w.length-1){for(let j=P;j>=0;j--){const K=w[j];if(U(K))return j}return-1}function q(w,U){const P=R(w,U);return P===-1?void 0:w[P]}function R(w,U,P=0,j=w.length){let K=P,C=j;for(;K<C;){const W=Math.floor((K+C)/2);U(w[W])?K=W+1:C=W}return K-1}function n1(w,U){const P=H(w,U);return P===w.length?void 0:w[P]}function H(w,U,P=0,j=w.length){let K=P,C=j;for(;K<C;){const W=Math.floor((K+C)/2);U(w[W])?C=W:K=W+1}return K}function S(w,U,P=0,j=w.length){const K=H(w,U,P,j);return K===w.length?-1:K}class D{static{this.assertInvariants=!1}constructor(U){this.e=U,this.c=0}findLastMonotonous(U){if(D.assertInvariants){if(this.d){for(const j of this.e)if(this.d(j)&&!U(j))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=U}const P=R(this.e,U,this.c);return this.c=P+1,P===-1?void 0:this.e[P]}}t.$ob=D;function k(w,U){if(w.length===0)return;let P=w[0];for(let j=1;j<w.length;j++){const K=w[j];U(K,P)>0&&(P=K)}return P}function Y(w,U){if(w.length===0)return;let P=w[0];for(let j=1;j<w.length;j++){const K=w[j];U(K,P)>=0&&(P=K)}return P}function M(w,U){return k(w,(P,j)=>-U(P,j))}function J(w,U){if(w.length===0)return-1;let P=0;for(let j=1;j<w.length;j++){const K=w[j];U(K,w[P])>0&&(P=j)}return P}function L(w,U){for(const P of w){const j=U(P);if(j!==void 0)return j}}}),define(h1[4],d1([0,1]),function(t1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharCode=void 0;var g;(function(e){e[e.Null=0]="Null",e[e.Backspace=8]="Backspace",e[e.Tab=9]="Tab",e[e.LineFeed=10]="LineFeed",e[e.CarriageReturn=13]="CarriageReturn",e[e.Space=32]="Space",e[e.ExclamationMark=33]="ExclamationMark",e[e.DoubleQuote=34]="DoubleQuote",e[e.Hash=35]="Hash",e[e.DollarSign=36]="DollarSign",e[e.PercentSign=37]="PercentSign",e[e.Ampersand=38]="Ampersand",e[e.SingleQuote=39]="SingleQuote",e[e.OpenParen=40]="OpenParen",e[e.CloseParen=41]="CloseParen",e[e.Asterisk=42]="Asterisk",e[e.Plus=43]="Plus",e[e.Comma=44]="Comma",e[e.Dash=45]="Dash",e[e.Period=46]="Period",e[e.Slash=47]="Slash",e[e.Digit0=48]="Digit0",e[e.Digit1=49]="Digit1",e[e.Digit2=50]="Digit2",e[e.Digit3=51]="Digit3",e[e.Digit4=52]="Digit4",e[e.Digit5=53]="Digit5",e[e.Digit6=54]="Digit6",e[e.Digit7=55]="Digit7",e[e.Digit8=56]="Digit8",e[e.Digit9=57]="Digit9",e[e.Colon=58]="Colon",e[e.Semicolon=59]="Semicolon",e[e.LessThan=60]="LessThan",e[e.Equals=61]="Equals",e[e.GreaterThan=62]="GreaterThan",e[e.QuestionMark=63]="QuestionMark",e[e.AtSign=64]="AtSign",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.OpenSquareBracket=91]="OpenSquareBracket",e[e.Backslash=92]="Backslash",e[e.CloseSquareBracket=93]="CloseSquareBracket",e[e.Caret=94]="Caret",e[e.Underline=95]="Underline",e[e.BackTick=96]="BackTick",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.OpenCurlyBrace=123]="OpenCurlyBrace",e[e.Pipe=124]="Pipe",e[e.CloseCurlyBrace=125]="CloseCurlyBrace",e[e.Tilde=126]="Tilde",e[e.NoBreakSpace=160]="NoBreakSpace",e[e.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",e[e.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",e[e.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",e[e.U_Combining_Tilde=771]="U_Combining_Tilde",e[e.U_Combining_Macron=772]="U_Combining_Macron",e[e.U_Combining_Overline=773]="U_Combining_Overline",e[e.U_Combining_Breve=774]="U_Combining_Breve",e[e.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",e[e.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",e[e.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",e[e.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",e[e.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",e[e.U_Combining_Caron=780]="U_Combining_Caron",e[e.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",e[e.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",e[e.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",e[e.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",e[e.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",e[e.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",e[e.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",e[e.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",e[e.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",e[e.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",e[e.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",e[e.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",e[e.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",e[e.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",e[e.U_Combining_Horn=795]="U_Combining_Horn",e[e.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",e[e.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",e[e.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",e[e.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",e[e.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",e[e.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",e[e.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",e[e.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",e[e.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",e[e.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",e[e.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",e[e.U_Combining_Cedilla=807]="U_Combining_Cedilla",e[e.U_Combining_Ogonek=808]="U_Combining_Ogonek",e[e.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",e[e.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",e[e.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",e[e.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",e[e.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",e[e.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",e[e.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",e[e.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",e[e.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",e[e.U_Combining_Low_Line=818]="U_Combining_Low_Line",e[e.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",e[e.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",e[e.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",e[e.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",e[e.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",e[e.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",e[e.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",e[e.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",e[e.U_Combining_Square_Below=827]="U_Combining_Square_Below",e[e.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",e[e.U_Combining_X_Above=829]="U_Combining_X_Above",e[e.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",e[e.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",e[e.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",e[e.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",e[e.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",e[e.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",e[e.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",e[e.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",e[e.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",e[e.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",e[e.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",e[e.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",e[e.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",e[e.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",e[e.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",e[e.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",e[e.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",e[e.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",e[e.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",e[e.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",e[e.U_Combining_Fermata=850]="U_Combining_Fermata",e[e.U_Combining_X_Below=851]="U_Combining_X_Below",e[e.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",e[e.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",e[e.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",e[e.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",e[e.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",e[e.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",e[e.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",e[e.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",e[e.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",e[e.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",e[e.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",e[e.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",e[e.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",e[e.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",e[e.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",e[e.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",e[e.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",e[e.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",e[e.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",e[e.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",e[e.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",e[e.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",e[e.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",e[e.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",e[e.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",e[e.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",e[e.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",e[e.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",e[e.LINE_SEPARATOR=8232]="LINE_SEPARATOR",e[e.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",e[e.NEXT_LINE=133]="NEXT_LINE",e[e.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",e[e.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",e[e.U_DIAERESIS=168]="U_DIAERESIS",e[e.U_MACRON=175]="U_MACRON",e[e.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",e[e.U_CEDILLA=184]="U_CEDILLA",e[e.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",e[e.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",e[e.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",e[e.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",e[e.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",e[e.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",e[e.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",e[e.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",e[e.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",e[e.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",e[e.U_BREVE=728]="U_BREVE",e[e.U_DOT_ABOVE=729]="U_DOT_ABOVE",e[e.U_RING_ABOVE=730]="U_RING_ABOVE",e[e.U_OGONEK=731]="U_OGONEK",e[e.U_SMALL_TILDE=732]="U_SMALL_TILDE",e[e.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",e[e.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",e[e.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",e[e.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",e[e.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",e[e.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",e[e.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",e[e.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",e[e.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",e[e.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",e[e.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",e[e.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",e[e.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",e[e.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",e[e.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",e[e.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",e[e.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",e[e.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",e[e.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",e[e.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",e[e.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",e[e.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",e[e.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",e[e.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",e[e.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",e[e.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",e[e.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",e[e.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",e[e.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",e[e.U_GREEK_TONOS=900]="U_GREEK_TONOS",e[e.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",e[e.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",e[e.U_GREEK_PSILI=8127]="U_GREEK_PSILI",e[e.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",e[e.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",e[e.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",e[e.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",e[e.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",e[e.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",e[e.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",e[e.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",e[e.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",e[e.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",e[e.U_GREEK_VARIA=8175]="U_GREEK_VARIA",e[e.U_GREEK_OXIA=8189]="U_GREEK_OXIA",e[e.U_GREEK_DASIA=8190]="U_GREEK_DASIA",e[e.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",e[e.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",e[e.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",e[e.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",e[e.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",e[e.U_OVERLINE=8254]="U_OVERLINE",e[e.UTF8_BOM=65279]="UTF8_BOM",e[e.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",e[e.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(g||(t.CharCode=g={}))}),define(h1[11],d1([0,1]),function(t1,t){"use strict";var g;Object.defineProperty(t,"__esModule",{value:!0}),t.$g=void 0,t.$c=e,t.$d=q,t.$e=R,t.$f=n1;function e(S,D){const k=Object.create(null);for(const Y of S){const M=D(Y);let J=k[M];J||(J=k[M]=[]),J.push(Y)}return k}function q(S,D){const k=[],Y=[];for(const M of S)D.has(M)||k.push(M);for(const M of D)S.has(M)||Y.push(M);return{removed:k,added:Y}}function R(S,D){const k=[],Y=[];for(const[M,J]of S)D.has(M)||k.push(J);for(const[M,J]of D)S.has(M)||Y.push(J);return{removed:k,added:Y}}function n1(S,D){const k=new Set;for(const Y of D)S.has(Y)&&k.add(Y);return k}class H{static{g=Symbol.toStringTag}constructor(D,k){this.b=k,this.a=new Map,this[g]="SetWithKey";for(const Y of D)this.add(Y)}get size(){return this.a.size}add(D){const k=this.b(D);return this.a.set(k,D),this}delete(D){return this.a.delete(this.b(D))}has(D){return this.a.has(this.b(D))}*entries(){for(const D of this.a.values())yield[D,D]}keys(){return this.values()}*values(){for(const D of this.a.values())yield D}clear(){this.a.clear()}forEach(D,k){this.a.forEach(Y=>D.call(k,Y,Y,this))}[Symbol.iterator](){return this.values()}}t.$g=H}),define(h1[2],d1([0,1]),function(t1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eb=t.$db=t.$cb=t.$bb=t.$ab=t.$$=t.$7=t.$Y=t.$X=void 0,t.setUnexpectedErrorHandler=e,t.$1=q,t.$2=R,t.$3=n1,t.$4=H,t.$5=S,t.$6=k,t.$8=M,t.$9=J,t.$0=L,t.$_=U;class g{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?C.isErrorNoTelemetry(n)?new C(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(i=>{i(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}t.$X=g,t.$Y=new g;function e(c){t.$Y.setUnexpectedErrorHandler(c)}function q(c){if(!c||typeof c!="object")return!1;const n=c;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}function R(c){k(c)||t.$Y.onUnexpectedError(c)}function n1(c){k(c)||t.$Y.onUnexpectedExternalError(c)}function H(c){if(c instanceof Error){const{name:n,message:i}=c,f=c.stacktrace||c.stack;return{$isError:!0,name:n,message:i,stack:f,noTelemetry:C.isErrorNoTelemetry(c)}}return c}function S(c){let n;return c.noTelemetry?n=new C:(n=new Error,n.name=c.name),n.message=c.message,n.stack=c.stack,n}const D="Canceled";function k(c){return c instanceof Y?!0:c instanceof Error&&c.name===D&&c.message===D}class Y extends Error{constructor(){super(D),this.name=this.message}}t.$7=Y;function M(){const c=new Error(D);return c.name=c.message,c}function J(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}function L(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}class w extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$$=w;function U(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}class P extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}t.$ab=P;class j extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}t.$bb=j;class K extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$cb=K;class C extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof C)return n;const i=new C;return i.message=n.message,i.stack=n.stack,i}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}t.$db=C;class W extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,W.prototype)}}t.$eb=W}),define(h1[12],d1([0,1,2,10]),function(t1,t,g,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cc=t.$bc=t.$ac=t.$$b=t.$0b=t.CompareResult=void 0,t.$ub=q,t.$vb=R,t.$wb=n1,t.$xb=H,t.$yb=S,t.$zb=D,t.$Ab=k,t.$Bb=Y,t.$Cb=M,t.$Db=J,t.$Eb=L,t.$Fb=w,t.$Gb=U,t.top=P,t.$Ib=j,t.$Jb=C,t.$Kb=W,t.$Lb=c,t.$Mb=n,t.$Nb=i,t.$Ob=f,t.$Pb=d,t.$Qb=s,t.$Rb=r,t.$Sb=_,t.$Tb=l,t.$Ub=E,t.$Vb=$,t.$Wb=u,t.$Xb=T,t.$Yb=F,t.$Zb=N,t.$1b=v,t.$2b=G,t.$3b=i1,t.$4b=x,t.$5b=s1,t.$6b=l1,t.$7b=Q,t.$8b=L1,t.$9b=v1,t.$_b=G1,t.$dc=p1;function q(h,m=0){return h[h.length-(1+m)]}function R(h){if(h.length===0)throw new Error("Invalid tail call");return[h.slice(0,h.length-1),h[h.length-1]]}function n1(h,m,b=(I,y)=>I===y){if(h===m)return!0;if(!h||!m||h.length!==m.length)return!1;for(let I=0,y=h.length;I<y;I++)if(!b(h[I],m[I]))return!1;return!0}function H(h,m){const b=h.length-1;m<b&&(h[m]=h[b]),h.pop()}function S(h,m,b){return D(h.length,I=>b(h[I],m))}function D(h,m){let b=0,I=h-1;for(;b<=I;){const y=(b+I)/2|0,e1=m(y);if(e1<0)b=y+1;else if(e1>0)I=y-1;else return y}return-(b+1)}function k(h,m,b){if(h=h|0,h>=m.length)throw new TypeError("invalid index");const I=m[Math.floor(m.length*Math.random())],y=[],e1=[],f1=[];for(const b1 of m){const $1=b(b1,I);$1<0?y.push(b1):$1>0?e1.push(b1):f1.push(b1)}return h<y.length?k(h,y,b):h<y.length+f1.length?f1[0]:k(h-(y.length+f1.length),e1,b)}function Y(h,m){const b=[];let I;for(const y of h.slice(0).sort(m))!I||m(I[0],y)!==0?(I=[y],b.push(I)):I.push(y);return b}function*M(h,m){let b,I;for(const y of h)I!==void 0&&m(I,y)?b.push(y):(b&&(yield b),b=[y]),I=y;b&&(yield b)}function J(h,m){for(let b=0;b<=h.length;b++)m(b===0?void 0:h[b-1],b===h.length?void 0:h[b])}function L(h,m){for(let b=0;b<h.length;b++)m(b===0?void 0:h[b-1],h[b],b+1===h.length?void 0:h[b+1])}function w(h,m,b){const I=[];function y(b1,$1,A1){if($1===0&&A1.length===0)return;const U1=I[I.length-1];U1&&U1.start+U1.deleteCount===b1?(U1.deleteCount+=$1,U1.toInsert.push(...A1)):I.push({start:b1,deleteCount:$1,toInsert:A1})}let e1=0,f1=0;for(;;){if(e1===h.length){y(e1,0,m.slice(f1));break}if(f1===m.length){y(e1,h.length-e1,[]);break}const b1=h[e1],$1=m[f1],A1=b(b1,$1);A1===0?(e1+=1,f1+=1):A1<0?(y(e1,1,[]),e1+=1):A1>0&&(y(e1,0,[$1]),f1+=1)}return I}function U(h,m,b){const I=w(h,m,b),y=[],e1=[];for(const f1 of I)y.push(...h.slice(f1.start,f1.start+f1.deleteCount)),e1.push(...f1.toInsert);return{removed:y,added:e1}}function P(h,m,b){if(b===0)return[];const I=h.slice(0,b).sort(m);return K(h,m,I,b,h.length),I}function j(h,m,b,I,y){return b===0?Promise.resolve([]):new Promise((e1,f1)=>{(async()=>{const b1=h.length,$1=h.slice(0,b).sort(m);for(let A1=b,U1=Math.min(b+I,b1);A1<b1;A1=U1,U1=Math.min(U1+I,b1)){if(A1>b&&await new Promise(z=>setTimeout(z)),y&&y.isCancellationRequested)throw new g.$7;K(h,m,$1,A1,U1)}return $1})().then(e1,f1)})}function K(h,m,b,I,y){for(const e1=b.length;I<y;I++){const f1=h[I];if(m(f1,b[e1-1])<0){b.pop();const b1=(0,e.$mb)(b,$1=>m(f1,$1)<0);b.splice(b1,0,f1)}}}function C(h){return h.filter(m=>!!m)}function W(h){let m=0;for(let b=0;b<h.length;b++)h[b]&&(h[m]=h[b],m+=1);h.length=m}function c(h,m,b){h.splice(b,0,h.splice(m,1)[0])}function n(h){return!Array.isArray(h)||h.length===0}function i(h){return Array.isArray(h)&&h.length>0}function f(h,m=b=>b){const b=new Set;return h.filter(I=>{const y=m(I);return b.has(y)?!1:(b.add(y),!0)})}function d(h){const m=new Set;return b=>{const I=h(b);return m.has(I)?!1:(m.add(I),!0)}}function s(h,m){return h.length>0?h[0]:m}function r(h,m){return h.length>0?h[h.length-1]:m}function _(h,m,b=(I,y)=>I===y){let I=0;for(let y=0,e1=Math.min(h.length,m.length);y<e1&&b(h[y],m[y]);y++)I++;return I}function l(h,m){let b=typeof m=="number"?h:0;typeof m=="number"?b=h:(b=0,m=h);const I=[];if(b<=m)for(let y=b;y<m;y++)I.push(y);else for(let y=b;y>m;y--)I.push(y);return I}function E(h,m,b){return h.reduce((I,y)=>(I[m(y)]=b?b(y):y,I),Object.create(null))}function $(h,m){return h.push(m),()=>u(h,m)}function u(h,m){const b=h.indexOf(m);if(b>-1)return h.splice(b,1),m}function T(h,m,b){const I=h.slice(0,m),y=h.slice(m);return I.concat(b,y)}function F(h,m){let b;if(typeof m=="number"){let I=m;b=()=>{const y=Math.sin(I++)*179426549;return y-Math.floor(y)}}else b=Math.random;for(let I=h.length-1;I>0;I-=1){const y=Math.floor(b()*(I+1)),e1=h[I];h[I]=h[y],h[y]=e1}}function N(h,m){const b=h.indexOf(m);b>-1&&(h.splice(b,1),h.unshift(m))}function v(h,m){const b=h.indexOf(m);b>-1&&(h.splice(b,1),h.push(m))}function G(h,m){for(const b of m)h.push(b)}function i1(h,m){return Array.isArray(h)?h.map(m):m(h)}function x(h){return Array.isArray(h)?h:[h]}function s1(h){return h[Math.floor(Math.random()*h.length)]}function l1(h,m,b){const I=o1(h,m),y=h.length,e1=b.length;h.length=y+e1;for(let f1=y-1;f1>=I;f1--)h[f1+e1]=h[f1];for(let f1=0;f1<e1;f1++)h[f1+I]=b[f1]}function Q(h,m,b,I){const y=o1(h,m);let e1=h.splice(y,b);return e1===void 0&&(e1=[]),l1(h,y,I),e1}function o1(h,m){return m<0?Math.max(m+h.length,0):Math.min(m,h.length)}var a1;(function(h){function m(e1){return e1<0}h.isLessThan=m;function b(e1){return e1<=0}h.isLessThanOrEqual=b;function I(e1){return e1>0}h.isGreaterThan=I;function y(e1){return e1===0}h.isNeitherLessOrGreaterThan=y,h.greaterThan=1,h.lessThan=-1,h.neitherLessOrGreaterThan=0})(a1||(t.CompareResult=a1={}));function L1(h,m){return(b,I)=>m(h(b),h(I))}function v1(...h){return(m,b)=>{for(const I of h){const y=I(m,b);if(!a1.isNeitherLessOrGreaterThan(y))return y}return a1.neitherLessOrGreaterThan}}const I1=(h,m)=>h-m;t.$0b=I1;const M1=(h,m)=>(0,t.$0b)(h?1:0,m?1:0);t.$$b=M1;function G1(h){return(m,b)=>-h(m,b)}class H1{constructor(m){this.g=m,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(m){let b=this.c;for(;b<this.g.length&&m(this.g[b]);)b++;const I=b===this.c?null:this.g.slice(this.c,b);return this.c=b,I}takeFromEndWhile(m){let b=this.d;for(;b>=0&&m(this.g[b]);)b--;const I=b===this.d?null:this.g.slice(b+1,this.d+1);return this.d=b,I}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const m=this.g[this.c];return this.c++,m}removeLast(){const m=this.g[this.d];return this.d--,m}takeCount(m){const b=this.g.slice(this.c,this.c+m);return this.c+=m,b}}t.$ac=H1;class T1{static{this.empty=new T1(m=>{})}constructor(m){this.iterate=m}forEach(m){this.iterate(b=>(m(b),!0))}toArray(){const m=[];return this.iterate(b=>(m.push(b),!0)),m}filter(m){return new T1(b=>this.iterate(I=>m(I)?b(I):!0))}map(m){return new T1(b=>this.iterate(I=>b(m(I))))}some(m){let b=!1;return this.iterate(I=>(b=m(I),!b)),b}findFirst(m){let b;return this.iterate(I=>m(I)?(b=I,!1):!0),b}findLast(m){let b;return this.iterate(I=>(m(I)&&(b=I),!0)),b}findLastMaxBy(m){let b,I=!0;return this.iterate(y=>((I||a1.isGreaterThan(m(y,b)))&&(I=!1,b=y),!0)),b}}t.$bc=T1;class P1{constructor(m){this.c=m}static createSortPermutation(m,b){const I=Array.from(m.keys()).sort((y,e1)=>b(m[y],m[e1]));return new P1(I)}apply(m){return m.map((b,I)=>m[this.c[I]])}inverse(){const m=this.c.slice();for(let b=0;b<this.c.length;b++)m[this.c[b]]=b;return new P1(m)}}t.$cc=P1;async function p1(h,m){return(await Promise.all(h.map(async(I,y)=>({element:I,ok:await m(I,y)})))).find(I=>I.ok)?.element}}),define(h1[5],d1([0,1]),function(t1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fb=g;function g(e,q){const R=this;let n1=!1,H;return function(){if(n1)return H;if(n1=!0,q)try{H=e.apply(R,arguments)}finally{q()}else H=e.apply(R,arguments);return H}}}),define(h1[13],d1([0,1]),function(t1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var g;(function(e){function q(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}e.is=q;const R=Object.freeze([]);function n1(){return R}e.empty=n1;function*H(n){yield n}e.single=H;function S(n){return q(n)?n:H(n)}e.wrap=S;function D(n){return n||R}e.from=D;function*k(n){for(let i=n.length-1;i>=0;i--)yield n[i]}e.reverse=k;function Y(n){return!n||n[Symbol.iterator]().next().done===!0}e.isEmpty=Y;function M(n){return n[Symbol.iterator]().next().value}e.first=M;function J(n,i){let f=0;for(const d of n)if(i(d,f++))return!0;return!1}e.some=J;function L(n,i){for(const f of n)if(i(f))return f}e.find=L;function*w(n,i){for(const f of n)i(f)&&(yield f)}e.filter=w;function*U(n,i){let f=0;for(const d of n)yield i(d,f++)}e.map=U;function*P(n,i){let f=0;for(const d of n)yield*i(d,f++)}e.flatMap=P;function*j(...n){for(const i of n)yield*i}e.concat=j;function K(n,i,f){let d=f;for(const s of n)d=i(d,s);return d}e.reduce=K;function*C(n,i,f=n.length){for(i<0&&(i+=n.length),f<0?f+=n.length:f>n.length&&(f=n.length);i<f;i++)yield n[i]}e.slice=C;function W(n,i=Number.POSITIVE_INFINITY){const f=[];if(i===0)return[f,n];const d=n[Symbol.iterator]();for(let s=0;s<i;s++){const r=d.next();if(r.done)return[f,e.empty()];f.push(r.value)}return[f,{[Symbol.iterator](){return d}}]}e.consume=W;async function c(n){const i=[];for await(const f of n)i.push(f);return Promise.resolve(i)}e.asyncToArray=c})(g||(t.Iterable=g={}))}),define(h1[14],d1([0,1]),function(t1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$W=void 0;class g{constructor(q){this.d=q,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(q){this.c=q}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$W=g}),define(h1[15],d1([0,1]),function(t1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8c=void 0;class g{static{this.Undefined=new g(void 0)}constructor(R){this.element=R,this.next=g.Undefined,this.prev=g.Undefined}}class e{constructor(){this.a=g.Undefined,this.b=g.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===g.Undefined}clear(){let R=this.a;for(;R!==g.Undefined;){const n1=R.next;R.prev=g.Undefined,R.next=g.Undefined,R=n1}this.a=g.Undefined,this.b=g.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,n1){const H=new g(R);if(this.a===g.Undefined)this.a=H,this.b=H;else if(n1){const D=this.b;this.b=H,H.prev=D,D.next=H}else{const D=this.a;this.a=H,H.next=D,D.prev=H}this.c+=1;let S=!1;return()=>{S||(S=!0,this.e(H))}}shift(){if(this.a!==g.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==g.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==g.Undefined&&R.next!==g.Undefined){const n1=R.prev;n1.next=R.next,R.next.prev=n1}else R.prev===g.Undefined&&R.next===g.Undefined?(this.a=g.Undefined,this.b=g.Undefined):R.next===g.Undefined?(this.b=this.b.prev,this.b.next=g.Undefined):R.prev===g.Undefined&&(this.a=this.a.next,this.a.prev=g.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==g.Undefined;)yield R.element,R=R.next}}t.$8c=e}),define(h1[16],d1([0,1]),function(t1,t){"use strict";var g,e,q;Object.defineProperty(t,"__esModule",{value:!0}),t.$Kc=t.$Jc=t.$Ic=t.$Hc=t.$Gc=t.$Fc=t.Touch=t.$Ec=t.$Dc=void 0,t.$Ac=R,t.$Bc=n1,t.$Cc=H,t.$Lc=C;function R(W,c,n){let i=W.get(c);return i===void 0&&(i=n,W.set(c,i)),i}function n1(W){const c=[];return W.forEach((n,i)=>{c.push(`${i} => ${n}`)}),`Map(${W.size}) {${c.join(", ")}}`}function H(W){const c=[];return W.forEach(n=>{c.push(n)}),`Set(${W.size}) {${c.join(", ")}}`}class S{constructor(c,n){this.uri=c,this.value=n}}function D(W){return Array.isArray(W)}class k{static{this.c=c=>c.toString()}constructor(c,n){if(this[g]="ResourceMap",c instanceof k)this.d=new Map(c.d),this.e=n??k.c;else if(D(c)){this.d=new Map,this.e=n??k.c;for(const[i,f]of c)this.set(i,f)}else this.d=new Map,this.e=c??k.c}set(c,n){return this.d.set(this.e(c),new S(c,n)),this}get(c){return this.d.get(this.e(c))?.value}has(c){return this.d.has(this.e(c))}get size(){return this.d.size}clear(){this.d.clear()}delete(c){return this.d.delete(this.e(c))}forEach(c,n){typeof n<"u"&&(c=c.bind(n));for(const[i,f]of this.d)c(f.value,f.uri,this)}*values(){for(const c of this.d.values())yield c.value}*keys(){for(const c of this.d.values())yield c.uri}*entries(){for(const c of this.d.values())yield[c.uri,c.value]}*[(g=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.d)yield[c.uri,c.value]}}t.$Dc=k;class Y{constructor(c,n){this[e]="ResourceSet",!c||typeof c=="function"?this.c=new k(c):(this.c=new k(n),c.forEach(this.add,this))}get size(){return this.c.size}add(c){return this.c.set(c,c),this}clear(){this.c.clear()}delete(c){return this.c.delete(c)}forEach(c,n){this.c.forEach((i,f)=>c.call(n,f,f,this))}has(c){return this.c.has(c)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(e=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Ec=Y;var M;(function(W){W[W.None=0]="None",W[W.AsOld=1]="AsOld",W[W.AsNew=2]="AsNew"})(M||(t.Touch=M={}));class J{constructor(){this[q]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(c){return this.c.has(c)}get(c,n=M.None){const i=this.c.get(c);if(i)return n!==M.None&&this.m(i,n),i.value}set(c,n,i=M.None){let f=this.c.get(c);if(f)f.value=n,i!==M.None&&this.m(f,i);else{switch(f={key:c,value:n,next:void 0,previous:void 0},i){case M.None:this.k(f);break;case M.AsOld:this.j(f);break;case M.AsNew:this.k(f);break;default:this.k(f);break}this.c.set(c,f),this.f++}return this}delete(c){return!!this.remove(c)}remove(c){const n=this.c.get(c);if(n)return this.c.delete(c),this.l(n),this.f--,n.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const c=this.d;return this.c.delete(c.key),this.l(c),this.f--,c.value}forEach(c,n){const i=this.g;let f=this.d;for(;f;){if(n?c.bind(n)(f.value,f.key,this):c(f.value,f.key,this),this.g!==i)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const c=this,n=this.g;let i=this.d;const f={[Symbol.iterator](){return f},next(){if(c.g!==n)throw new Error("LinkedMap got modified during iteration.");if(i){const d={value:i.key,done:!1};return i=i.next,d}else return{value:void 0,done:!0}}};return f}values(){const c=this,n=this.g;let i=this.d;const f={[Symbol.iterator](){return f},next(){if(c.g!==n)throw new Error("LinkedMap got modified during iteration.");if(i){const d={value:i.value,done:!1};return i=i.next,d}else return{value:void 0,done:!0}}};return f}entries(){const c=this,n=this.g;let i=this.d;const f={[Symbol.iterator](){return f},next(){if(c.g!==n)throw new Error("LinkedMap got modified during iteration.");if(i){const d={value:[i.key,i.value],done:!1};return i=i.next,d}else return{value:void 0,done:!0}}};return f}[(q=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(c){if(c>=this.size)return;if(c===0){this.clear();return}let n=this.d,i=this.size;for(;n&&i>c;)this.c.delete(n.key),n=n.next,i--;this.d=n,this.f=i,n&&(n.previous=void 0),this.g++}i(c){if(c>=this.size)return;if(c===0){this.clear();return}let n=this.e,i=this.size;for(;n&&i>c;)this.c.delete(n.key),n=n.previous,i--;this.e=n,this.f=i,n&&(n.next=void 0),this.g++}j(c){if(!this.d&&!this.e)this.e=c;else if(this.d)c.next=this.d,this.d.previous=c;else throw new Error("Invalid list");this.d=c,this.g++}k(c){if(!this.d&&!this.e)this.d=c;else if(this.e)c.previous=this.e,this.e.next=c;else throw new Error("Invalid list");this.e=c,this.g++}l(c){if(c===this.d&&c===this.e)this.d=void 0,this.e=void 0;else if(c===this.d){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this.d=c.next}else if(c===this.e){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this.e=c.previous}else{const n=c.next,i=c.previous;if(!n||!i)throw new Error("Invalid list");n.previous=i,i.next=n}c.next=void 0,c.previous=void 0,this.g++}m(c,n){if(!this.d||!this.e)throw new Error("Invalid list");if(!(n!==M.AsOld&&n!==M.AsNew)){if(n===M.AsOld){if(c===this.d)return;const i=c.next,f=c.previous;c===this.e?(f.next=void 0,this.e=f):(i.previous=f,f.next=i),c.previous=void 0,c.next=this.d,this.d.previous=c,this.d=c,this.g++}else if(n===M.AsNew){if(c===this.e)return;const i=c.next,f=c.previous;c===this.d?(i.previous=void 0,this.d=i):(i.previous=f,f.next=i),c.next=void 0,c.previous=this.e,this.e.next=c,this.e=c,this.g++}}}toJSON(){const c=[];return this.forEach((n,i)=>{c.push([i,n])}),c}fromJSON(c){this.clear();for(const[n,i]of c)this.set(n,i)}}t.$Fc=J;class L extends J{constructor(c,n=1){super(),this.n=c,this.o=Math.min(Math.max(0,n),1)}get limit(){return this.n}set limit(c){this.n=c,this.p()}get ratio(){return this.o}set ratio(c){this.o=Math.min(Math.max(0,c),1),this.p()}get(c,n=M.AsNew){return super.get(c,n)}peek(c){return super.get(c,M.None)}set(c,n){return super.set(c,n,M.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class w extends L{constructor(c,n=1){super(c,n)}q(c){this.h(c)}set(c,n){return super.set(c,n),this.p(),this}}t.$Gc=w;class U extends L{constructor(c,n=1){super(c,n)}q(c){this.i(c)}set(c,n){return this.n<=this.size&&!this.has(c)&&this.q(Math.round(this.n*this.o)-1),super.set(c,n),this}}t.$Hc=U;class P{constructor(){this.c=new Map}add(c){return this.c.set(c,(this.c.get(c)||0)+1),this}delete(c){let n=this.c.get(c)||0;return n===0?!1:(n--,n===0?this.c.delete(c):this.c.set(c,n),!0)}has(c){return this.c.has(c)}}t.$Ic=P;class j{constructor(c){if(this.c=new Map,this.d=new Map,c)for(const[n,i]of c)this.set(n,i)}clear(){this.c.clear(),this.d.clear()}set(c,n){this.c.set(c,n),this.d.set(n,c)}get(c){return this.c.get(c)}getKey(c){return this.d.get(c)}delete(c){const n=this.c.get(c);return n===void 0?!1:(this.c.delete(c),this.d.delete(n),!0)}forEach(c,n){this.c.forEach((i,f)=>{c.call(n,i,f,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Jc=j;class K{constructor(){this.c=new Map}add(c,n){let i=this.c.get(c);i||(i=new Set,this.c.set(c,i)),i.add(n)}delete(c,n){const i=this.c.get(c);i&&(i.delete(n),i.size===0&&this.c.delete(c))}forEach(c,n){const i=this.c.get(c);i&&i.forEach(n)}get(c){const n=this.c.get(c);return n||new Set}}t.$Kc=K;function C(W,c){if(W===c)return!0;if(W.size!==c.size)return!1;for(const[n,i]of W)if(!c.has(n)||c.get(n)!==i)return!1;for(const[n]of c)if(!W.has(n))return!1;return!0}}),define(h1[6],d1([0,1,12,11,16,5,13]),function(t1,t,g,e,q,R,n1){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7c=t.$5c=t.$4c=t.$3c=t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Mc=void 0,t.$Nc=k,t.$Oc=Y,t.$Pc=M,t.$Qc=w,t.$Rc=U,t.$Sc=P,t.$Tc=j,t.$Uc=K,t.$Vc=C,t.$6c=l;const H=!1;let S=null;class D{constructor(){this.b=new Map}static{this.a=0}c(u){let T=this.b.get(u);return T||(T={parent:null,source:null,isSingleton:!1,value:u,idx:D.a++},this.b.set(u,T)),T}trackDisposable(u){const T=this.c(u);T.source||(T.source=new Error().stack)}setParent(u,T){const F=this.c(u);F.parent=T}markAsDisposed(u){this.b.delete(u)}markAsSingleton(u){this.c(u).isSingleton=!0}f(u,T){const F=T.get(u);if(F)return F;const N=u.parent?this.f(this.c(u.parent),T):u;return T.set(u,N),N}getTrackedDisposables(){const u=new Map;return[...this.b.entries()].filter(([,F])=>F.source!==null&&!this.f(F,u).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(u=10,T){let F;if(T)F=T;else{const x=new Map,s1=[...this.b.values()].filter(Q=>Q.source!==null&&!this.f(Q,x).isSingleton);if(s1.length===0)return;const l1=new Set(s1.map(Q=>Q.value));if(F=s1.filter(Q=>!(Q.parent&&l1.has(Q.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function N(x){function s1(Q,o1){for(;Q.length>0&&o1.some(a1=>typeof a1=="string"?a1===Q[0]:Q[0].match(a1));)Q.shift()}const l1=x.source.split(`
`).map(Q=>Q.trim().replace("at ","")).filter(Q=>Q!=="");return s1(l1,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),l1.reverse()}const v=new q.$Kc;for(const x of F){const s1=N(x);for(let l1=0;l1<=s1.length;l1++)v.add(s1.slice(0,l1).join(`
`),x)}F.sort((0,g.$8b)(x=>x.idx,g.$0b));let G="",i1=0;for(const x of F.slice(0,u)){i1++;const s1=N(x),l1=[];for(let Q=0;Q<s1.length;Q++){let o1=s1[Q];o1=`(shared with ${v.get(s1.slice(0,Q+1).join(`
`)).size}/${F.length} leaks) at ${o1}`;const L1=v.get(s1.slice(0,Q).join(`
`)),v1=(0,e.$c)([...L1].map(I1=>N(I1)[Q]),I1=>I1);delete v1[s1[Q]];for(const[I1,M1]of Object.entries(v1))l1.unshift(`    - stacktraces of ${M1.length} other leaks continue with ${I1}`);l1.unshift(o1)}G+=`


==================== Leaking disposable ${i1}/${F.length}: ${x.value.constructor.name} ====================
${l1.join(`
`)}
============================================================

`}return F.length>u&&(G+=`


... and ${F.length-u} more leaking disposables

`),{leaks:F,details:G}}}t.$Mc=D;function k($){S=$}if(H){const $="__is_disposable_tracked__";k(new class{trackDisposable(u){const T=new Error("Potentially leaked disposable").stack;setTimeout(()=>{u[$]||console.log(T)},3e3)}setParent(u,T){if(u&&u!==c.None)try{u[$]=!0}catch{}}markAsDisposed(u){if(u&&u!==c.None)try{u[$]=!0}catch{}}markAsSingleton(u){}})}function Y($){return S?.trackDisposable($),$}function M($){S?.markAsDisposed($)}function J($,u){S?.setParent($,u)}function L($,u){if(S)for(const T of $)S.setParent(T,u)}function w($){return S?.markAsSingleton($),$}function U($){return typeof $=="object"&&$!==null&&typeof $.dispose=="function"&&$.dispose.length===0}function P($){if(n1.Iterable.is($)){const u=[];for(const T of $)if(T)try{T.dispose()}catch(F){u.push(F)}if(u.length===1)throw u[0];if(u.length>1)throw new AggregateError(u,"Encountered errors while disposing of store");return Array.isArray($)?[]:$}else if($)return $.dispose(),$}function j($){for(const u of $)U(u)&&u.dispose();return[]}function K(...$){const u=C(()=>P($));return L($,u),u}function C($){const u=Y({dispose:(0,R.$fb)(()=>{M(u),$()})});return u}class W{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,Y(this)}dispose(){this.g||(M(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{P(this.f)}finally{this.f.clear()}}add(u){if(!u)return u;if(u===this)throw new Error("Cannot register a disposable on itself!");return J(u,this),this.g?W.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(u),u}delete(u){if(u){if(u===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(u),u.dispose()}}deleteAndLeak(u){u&&this.f.has(u)&&(this.f.delete(u),J(u,null))}}t.$Wc=W;class c{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new W,Y(this),J(this.q,this)}dispose(){M(this),this.q.dispose()}B(u){if(u===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(u)}}t.$Xc=c;class n{constructor(){this.b=!1,Y(this)}get value(){return this.b?void 0:this.a}set value(u){this.b||u===this.a||(this.a?.dispose(),u&&J(u,this),this.a=u)}clear(){this.value=void 0}dispose(){this.b=!0,M(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const u=this.a;return this.a=void 0,u&&J(u,null),u}}t.$Yc=n;class i{constructor(u){this.a=new n,this.b=!1,this.a.value=u}get value(){return this.a.value}set value(u){this.b||u===this.a.value||(this.a.value=u)}dispose(){this.b=!0,this.a.dispose()}}t.$Zc=i;class f{constructor(u){this.b=u,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$1c=f;class d{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,Y(this)}set(u){let T=u;return this.unset=()=>T=void 0,this.isset=()=>T!==void 0,this.dispose=()=>{T&&(T(),T=void 0,M(this))},this}}t.$2c=d;class s{constructor(){this.a=new Map}acquire(u,...T){let F=this.a.get(u);F||(F={counter:0,object:this.b(u,...T)},this.a.set(u,F));const{object:N}=F,v=(0,R.$fb)(()=>{--F.counter===0&&(this.c(u,F.object),this.a.delete(u))});return F.counter++,{object:N,dispose:v}}}t.$3c=s;class r{constructor(u){this.a=u}async acquire(u,...T){const F=this.a.acquire(u,...T);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(N){throw F.dispose(),N}}}t.$4c=r;class _{constructor(u){this.object=u}dispose(){}}t.$5c=_;function l($){const u=new W;try{$(u)}finally{u.dispose()}}class E{constructor(){this.a=new Map,this.b=!1,Y(this)}dispose(){M(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{P(this.a.values())}finally{this.a.clear()}}has(u){return this.a.has(u)}get size(){return this.a.size}get(u){return this.a.get(u)}set(u,T,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get(u)?.dispose(),this.a.set(u,T)}deleteAndDispose(u){this.a.get(u)?.dispose(),this.a.delete(u)}deleteAndLeak(u){const T=this.a.get(u);return this.a.delete(u),T}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$7c=E}),define(h1[17],d1([0,1]),function(t1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MarshalledId=void 0;var g;(function(e){e[e.Uri=1]="Uri",e[e.Regexp=2]="Regexp",e[e.ScmResource=3]="ScmResource",e[e.ScmResourceGroup=4]="ScmResourceGroup",e[e.ScmProvider=5]="ScmProvider",e[e.CommentController=6]="CommentController",e[e.CommentThread=7]="CommentThread",e[e.CommentThreadInstance=8]="CommentThreadInstance",e[e.CommentThreadReply=9]="CommentThreadReply",e[e.CommentNode=10]="CommentNode",e[e.CommentThreadNode=11]="CommentThreadNode",e[e.TimelineActionContext=12]="TimelineActionContext",e[e.NotebookCellActionContext=13]="NotebookCellActionContext",e[e.NotebookActionContext=14]="NotebookActionContext",e[e.TerminalContext=15]="TerminalContext",e[e.TestItemContext=16]="TestItemContext",e[e.Date=17]="Date",e[e.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(g||(t.MarshalledId=g={}))}),define(h1[3],d1([0,1]),function(t1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$J=t.$I=t.$H=t.$G=t.$F=t.OS=t.OperatingSystem=t.$C=t.$B=t.$A=t.$z=t.$y=t.Language=t.$x=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.Platform=t.$h=void 0,t.$i=c,t.$E=r,t.$K=_,t.$h="en";let g=!1,e=!1,q=!1,R=!1,n1=!1,H=!1,S=!1,D=!1,k=!1,Y=!1,M,J=t.$h,L=t.$h,w,U;const P=globalThis;let j;typeof P.vscode<"u"&&typeof P.vscode.process<"u"?j=P.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(j=process);const K=typeof j?.versions?.electron=="string",C=K&&j?.type==="renderer";if(typeof j=="object"){g=j.platform==="win32",e=j.platform==="darwin",q=j.platform==="linux",R=q&&!!j.env.SNAP&&!!j.env.SNAP_REVISION,S=K,k=!!j.env.CI||!!j.env.BUILD_ARTIFACTSTAGINGDIRECTORY,M=t.$h,J=t.$h;const l=j.env.VSCODE_NLS_CONFIG;if(l)try{const E=JSON.parse(l);M=E.userLocale,L=E.osLocale,J=E.resolvedLanguage||t.$h,w=E.languagePack?.translationsConfigFile}catch{}n1=!0}else typeof navigator=="object"&&!C?(U=navigator.userAgent,g=U.indexOf("Windows")>=0,e=U.indexOf("Macintosh")>=0,D=(U.indexOf("Macintosh")>=0||U.indexOf("iPad")>=0||U.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,q=U.indexOf("Linux")>=0,Y=U?.indexOf("Mobi")>=0,H=!0,J=globalThis._VSCODE_NLS_LANGUAGE||t.$h,M=navigator.language.toLowerCase(),L=M):console.error("Unable to resolve platform.");var W;(function(l){l[l.Web=0]="Web",l[l.Mac=1]="Mac",l[l.Linux=2]="Linux",l[l.Windows=3]="Windows"})(W||(t.Platform=W={}));function c(l){switch(l){case W.Web:return"Web";case W.Mac:return"Mac";case W.Linux:return"Linux";case W.Windows:return"Windows"}}let n=W.Web;e?n=W.Mac:g?n=W.Windows:q&&(n=W.Linux),t.$j=g,t.$k=e,t.$l=q,t.$m=R,t.$n=n1,t.$o=S,t.$p=H,t.$q=H&&typeof P.importScripts=="function",t.$r=t.$q?P.origin:void 0,t.$s=D,t.$t=Y,t.$u=k,t.$v=n,t.$w=U,t.$x=J;var i;(function(l){function E(){return t.$x}l.value=E;function $(){return t.$x.length===2?t.$x==="en":t.$x.length>=3?t.$x[0]==="e"&&t.$x[1]==="n"&&t.$x[2]==="-":!1}l.isDefaultVariant=$;function u(){return t.$x==="en"}l.isDefault=u})(i||(t.Language=i={})),t.$y=M,t.$z=L,t.$A=w,t.$B=typeof P.postMessage=="function"&&!P.importScripts,t.$C=(()=>{if(t.$B){const l=[];P.addEventListener("message",$=>{if($.data&&$.data.vscodeScheduleAsyncWork)for(let u=0,T=l.length;u<T;u++){const F=l[u];if(F.id===$.data.vscodeScheduleAsyncWork){l.splice(u,1),F.callback();return}}});let E=0;return $=>{const u=++E;l.push({id:u,callback:$}),P.postMessage({vscodeScheduleAsyncWork:u},"*")}}return l=>setTimeout(l)})();var f;(function(l){l[l.Windows=1]="Windows",l[l.Macintosh=2]="Macintosh",l[l.Linux=3]="Linux"})(f||(t.OperatingSystem=f={})),t.OS=e||D?f.Macintosh:g?f.Windows:f.Linux;let d=!0,s=!1;function r(){if(!s){s=!0;const l=new Uint8Array(2);l[0]=1,l[1]=2,d=new Uint16Array(l.buffer)[0]===513}return d}t.$F=!!(t.$w&&t.$w.indexOf("Chrome")>=0),t.$G=!!(t.$w&&t.$w.indexOf("Firefox")>=0),t.$H=!!(!t.$F&&t.$w&&t.$w.indexOf("Safari")>=0),t.$I=!!(t.$w&&t.$w.indexOf("Edg/")>=0),t.$J=!!(t.$w&&t.$w.indexOf("Android")>=0);function _(l){return parseFloat(l)>=20}}),define(h1[18],d1([0,1,3]),function(t1,t,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hc=t.$gc=t.env=t.cwd=void 0;let e;const q=globalThis.vscode;if(typeof q<"u"&&typeof q.process<"u"){const R=q.process;e={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"&&typeof process?.versions?.node=="string"?e={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:e={get platform(){return g.$j?"win32":g.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=e.cwd,t.env=e.env,t.$gc=e.platform,t.$hc=e.arch});var Y1=this&&this.__createBinding||(Object.create?function(t1,t,g,e){e===void 0&&(e=g);var q=Object.getOwnPropertyDescriptor(t,g);(!q||("get"in q?!t.__esModule:q.writable||q.configurable))&&(q={enumerable:!0,get:function(){return t[g]}}),Object.defineProperty(t1,e,q)}:function(t1,t,g,e){e===void 0&&(e=g),t1[e]=t[g]}),Z1=this&&this.__setModuleDefault||(Object.create?function(t1,t){Object.defineProperty(t1,"default",{enumerable:!0,value:t})}:function(t1,t){t1.default=t}),k1=this&&this.__importStar||function(t1){if(t1&&t1.__esModule)return t1;var t={};if(t1!=null)for(var g in t1)g!=="default"&&Object.prototype.hasOwnProperty.call(t1,g)&&Y1(t,t1,g);return Z1(t,t1),t};define(h1[7],d1([0,1,18]),function(t1,t,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wc=t.sep=t.$uc=t.$tc=t.$sc=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=void 0,g=k1(g);const e=65,q=97,R=90,n1=122,H=46,S=47,D=92,k=58,Y=63;class M extends Error{constructor(i,f,d){let s;typeof f=="string"&&f.indexOf("not ")===0?(s="must not be",f=f.replace(/^not /,"")):s="must be";const r=i.indexOf(".")!==-1?"property":"argument";let _=`The "${i}" ${r} ${s} of type ${f}`;_+=`. Received type ${typeof d}`,super(_),this.code="ERR_INVALID_ARG_TYPE"}}function J(n,i){if(n===null||typeof n!="object")throw new M(i,"Object",n)}function L(n,i){if(typeof n!="string")throw new M(i,"string",n)}const w=g.$gc==="win32";function U(n){return n===S||n===D}function P(n){return n===S}function j(n){return n>=e&&n<=R||n>=q&&n<=n1}function K(n,i,f,d){let s="",r=0,_=-1,l=0,E=0;for(let $=0;$<=n.length;++$){if($<n.length)E=n.charCodeAt($);else{if(d(E))break;E=S}if(d(E)){if(!(_===$-1||l===1))if(l===2){if(s.length<2||r!==2||s.charCodeAt(s.length-1)!==H||s.charCodeAt(s.length-2)!==H){if(s.length>2){const u=s.lastIndexOf(f);u===-1?(s="",r=0):(s=s.slice(0,u),r=s.length-1-s.lastIndexOf(f)),_=$,l=0;continue}else if(s.length!==0){s="",r=0,_=$,l=0;continue}}i&&(s+=s.length>0?`${f}..`:"..",r=2)}else s.length>0?s+=`${f}${n.slice(_+1,$)}`:s=n.slice(_+1,$),r=$-_-1;_=$,l=0}else E===H&&l!==-1?++l:l=-1}return s}function C(n){return n?`${n[0]==="."?"":"."}${n}`:""}function W(n,i){J(i,"pathObject");const f=i.dir||i.root,d=i.base||`${i.name||""}${C(i.ext)}`;return f?f===i.root?`${f}${d}`:`${f}${n}${d}`:d}t.$ic={resolve(...n){let i="",f="",d=!1;for(let s=n.length-1;s>=-1;s--){let r;if(s>=0){if(r=n[s],L(r,`paths[${s}]`),r.length===0)continue}else i.length===0?r=g.cwd():(r=g.env[`=${i}`]||g.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==i.toLowerCase()&&r.charCodeAt(2)===D)&&(r=`${i}\\`));const _=r.length;let l=0,E="",$=!1;const u=r.charCodeAt(0);if(_===1)U(u)&&(l=1,$=!0);else if(U(u))if($=!0,U(r.charCodeAt(1))){let T=2,F=T;for(;T<_&&!U(r.charCodeAt(T));)T++;if(T<_&&T!==F){const N=r.slice(F,T);for(F=T;T<_&&U(r.charCodeAt(T));)T++;if(T<_&&T!==F){for(F=T;T<_&&!U(r.charCodeAt(T));)T++;(T===_||T!==F)&&(E=`\\\\${N}\\${r.slice(F,T)}`,l=T)}}}else l=1;else j(u)&&r.charCodeAt(1)===k&&(E=r.slice(0,2),l=2,_>2&&U(r.charCodeAt(2))&&($=!0,l=3));if(E.length>0)if(i.length>0){if(E.toLowerCase()!==i.toLowerCase())continue}else i=E;if(d){if(i.length>0)break}else if(f=`${r.slice(l)}\\${f}`,d=$,$&&i.length>0)break}return f=K(f,!d,"\\",U),d?`${i}\\${f}`:`${i}${f}`||"."},normalize(n){L(n,"path");const i=n.length;if(i===0)return".";let f=0,d,s=!1;const r=n.charCodeAt(0);if(i===1)return P(r)?"\\":n;if(U(r))if(s=!0,U(n.charCodeAt(1))){let l=2,E=l;for(;l<i&&!U(n.charCodeAt(l));)l++;if(l<i&&l!==E){const $=n.slice(E,l);for(E=l;l<i&&U(n.charCodeAt(l));)l++;if(l<i&&l!==E){for(E=l;l<i&&!U(n.charCodeAt(l));)l++;if(l===i)return`\\\\${$}\\${n.slice(E)}\\`;l!==E&&(d=`\\\\${$}\\${n.slice(E,l)}`,f=l)}}}else f=1;else j(r)&&n.charCodeAt(1)===k&&(d=n.slice(0,2),f=2,i>2&&U(n.charCodeAt(2))&&(s=!0,f=3));let _=f<i?K(n.slice(f),!s,"\\",U):"";return _.length===0&&!s&&(_="."),_.length>0&&U(n.charCodeAt(i-1))&&(_+="\\"),d===void 0?s?`\\${_}`:_:s?`${d}\\${_}`:`${d}${_}`},isAbsolute(n){L(n,"path");const i=n.length;if(i===0)return!1;const f=n.charCodeAt(0);return U(f)||i>2&&j(f)&&n.charCodeAt(1)===k&&U(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let i,f;for(let r=0;r<n.length;++r){const _=n[r];L(_,"path"),_.length>0&&(i===void 0?i=f=_:i+=`\\${_}`)}if(i===void 0)return".";let d=!0,s=0;if(typeof f=="string"&&U(f.charCodeAt(0))){++s;const r=f.length;r>1&&U(f.charCodeAt(1))&&(++s,r>2&&(U(f.charCodeAt(2))?++s:d=!1))}if(d){for(;s<i.length&&U(i.charCodeAt(s));)s++;s>=2&&(i=`\\${i.slice(s)}`)}return t.$ic.normalize(i)},relative(n,i){if(L(n,"from"),L(i,"to"),n===i)return"";const f=t.$ic.resolve(n),d=t.$ic.resolve(i);if(f===d||(n=f.toLowerCase(),i=d.toLowerCase(),n===i))return"";let s=0;for(;s<n.length&&n.charCodeAt(s)===D;)s++;let r=n.length;for(;r-1>s&&n.charCodeAt(r-1)===D;)r--;const _=r-s;let l=0;for(;l<i.length&&i.charCodeAt(l)===D;)l++;let E=i.length;for(;E-1>l&&i.charCodeAt(E-1)===D;)E--;const $=E-l,u=_<$?_:$;let T=-1,F=0;for(;F<u;F++){const v=n.charCodeAt(s+F);if(v!==i.charCodeAt(l+F))break;v===D&&(T=F)}if(F!==u){if(T===-1)return d}else{if($>u){if(i.charCodeAt(l+F)===D)return d.slice(l+F+1);if(F===2)return d.slice(l+F)}_>u&&(n.charCodeAt(s+F)===D?T=F:F===2&&(T=3)),T===-1&&(T=0)}let N="";for(F=s+T+1;F<=r;++F)(F===r||n.charCodeAt(F)===D)&&(N+=N.length===0?"..":"\\..");return l+=T,N.length>0?`${N}${d.slice(l,E)}`:(d.charCodeAt(l)===D&&++l,d.slice(l,E))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const i=t.$ic.resolve(n);if(i.length<=2)return n;if(i.charCodeAt(0)===D){if(i.charCodeAt(1)===D){const f=i.charCodeAt(2);if(f!==Y&&f!==H)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(j(i.charCodeAt(0))&&i.charCodeAt(1)===k&&i.charCodeAt(2)===D)return`\\\\?\\${i}`;return n},dirname(n){L(n,"path");const i=n.length;if(i===0)return".";let f=-1,d=0;const s=n.charCodeAt(0);if(i===1)return U(s)?n:".";if(U(s)){if(f=d=1,U(n.charCodeAt(1))){let l=2,E=l;for(;l<i&&!U(n.charCodeAt(l));)l++;if(l<i&&l!==E){for(E=l;l<i&&U(n.charCodeAt(l));)l++;if(l<i&&l!==E){for(E=l;l<i&&!U(n.charCodeAt(l));)l++;if(l===i)return n;l!==E&&(f=d=l+1)}}}}else j(s)&&n.charCodeAt(1)===k&&(f=i>2&&U(n.charCodeAt(2))?3:2,d=f);let r=-1,_=!0;for(let l=i-1;l>=d;--l)if(U(n.charCodeAt(l))){if(!_){r=l;break}}else _=!1;if(r===-1){if(f===-1)return".";r=f}return n.slice(0,r)},basename(n,i){i!==void 0&&L(i,"suffix"),L(n,"path");let f=0,d=-1,s=!0,r;if(n.length>=2&&j(n.charCodeAt(0))&&n.charCodeAt(1)===k&&(f=2),i!==void 0&&i.length>0&&i.length<=n.length){if(i===n)return"";let _=i.length-1,l=-1;for(r=n.length-1;r>=f;--r){const E=n.charCodeAt(r);if(U(E)){if(!s){f=r+1;break}}else l===-1&&(s=!1,l=r+1),_>=0&&(E===i.charCodeAt(_)?--_===-1&&(d=r):(_=-1,d=l))}return f===d?d=l:d===-1&&(d=n.length),n.slice(f,d)}for(r=n.length-1;r>=f;--r)if(U(n.charCodeAt(r))){if(!s){f=r+1;break}}else d===-1&&(s=!1,d=r+1);return d===-1?"":n.slice(f,d)},extname(n){L(n,"path");let i=0,f=-1,d=0,s=-1,r=!0,_=0;n.length>=2&&n.charCodeAt(1)===k&&j(n.charCodeAt(0))&&(i=d=2);for(let l=n.length-1;l>=i;--l){const E=n.charCodeAt(l);if(U(E)){if(!r){d=l+1;break}continue}s===-1&&(r=!1,s=l+1),E===H?f===-1?f=l:_!==1&&(_=1):f!==-1&&(_=-1)}return f===-1||s===-1||_===0||_===1&&f===s-1&&f===d+1?"":n.slice(f,s)},format:W.bind(null,"\\"),parse(n){L(n,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return i;const f=n.length;let d=0,s=n.charCodeAt(0);if(f===1)return U(s)?(i.root=i.dir=n,i):(i.base=i.name=n,i);if(U(s)){if(d=1,U(n.charCodeAt(1))){let T=2,F=T;for(;T<f&&!U(n.charCodeAt(T));)T++;if(T<f&&T!==F){for(F=T;T<f&&U(n.charCodeAt(T));)T++;if(T<f&&T!==F){for(F=T;T<f&&!U(n.charCodeAt(T));)T++;T===f?d=T:T!==F&&(d=T+1)}}}}else if(j(s)&&n.charCodeAt(1)===k){if(f<=2)return i.root=i.dir=n,i;if(d=2,U(n.charCodeAt(2))){if(f===3)return i.root=i.dir=n,i;d=3}}d>0&&(i.root=n.slice(0,d));let r=-1,_=d,l=-1,E=!0,$=n.length-1,u=0;for(;$>=d;--$){if(s=n.charCodeAt($),U(s)){if(!E){_=$+1;break}continue}l===-1&&(E=!1,l=$+1),s===H?r===-1?r=$:u!==1&&(u=1):r!==-1&&(u=-1)}return l!==-1&&(r===-1||u===0||u===1&&r===l-1&&r===_+1?i.base=i.name=n.slice(_,l):(i.name=n.slice(_,r),i.base=n.slice(_,l),i.ext=n.slice(r,l))),_>0&&_!==d?i.dir=n.slice(0,_-1):i.dir=i.root,i},sep:"\\",delimiter:";",win32:null,posix:null};const c=(()=>{if(w){const n=/\\/g;return()=>{const i=g.cwd().replace(n,"/");return i.slice(i.indexOf("/"))}}return()=>g.cwd()})();t.$jc={resolve(...n){let i="",f=!1;for(let d=n.length-1;d>=-1&&!f;d--){const s=d>=0?n[d]:c();L(s,`paths[${d}]`),s.length!==0&&(i=`${s}/${i}`,f=s.charCodeAt(0)===S)}return i=K(i,!f,"/",P),f?`/${i}`:i.length>0?i:"."},normalize(n){if(L(n,"path"),n.length===0)return".";const i=n.charCodeAt(0)===S,f=n.charCodeAt(n.length-1)===S;return n=K(n,!i,"/",P),n.length===0?i?"/":f?"./":".":(f&&(n+="/"),i?`/${n}`:n)},isAbsolute(n){return L(n,"path"),n.length>0&&n.charCodeAt(0)===S},join(...n){if(n.length===0)return".";let i;for(let f=0;f<n.length;++f){const d=n[f];L(d,"path"),d.length>0&&(i===void 0?i=d:i+=`/${d}`)}return i===void 0?".":t.$jc.normalize(i)},relative(n,i){if(L(n,"from"),L(i,"to"),n===i||(n=t.$jc.resolve(n),i=t.$jc.resolve(i),n===i))return"";const f=1,d=n.length,s=d-f,r=1,_=i.length-r,l=s<_?s:_;let E=-1,$=0;for(;$<l;$++){const T=n.charCodeAt(f+$);if(T!==i.charCodeAt(r+$))break;T===S&&(E=$)}if($===l)if(_>l){if(i.charCodeAt(r+$)===S)return i.slice(r+$+1);if($===0)return i.slice(r+$)}else s>l&&(n.charCodeAt(f+$)===S?E=$:$===0&&(E=0));let u="";for($=f+E+1;$<=d;++$)($===d||n.charCodeAt($)===S)&&(u+=u.length===0?"..":"/..");return`${u}${i.slice(r+E)}`},toNamespacedPath(n){return n},dirname(n){if(L(n,"path"),n.length===0)return".";const i=n.charCodeAt(0)===S;let f=-1,d=!0;for(let s=n.length-1;s>=1;--s)if(n.charCodeAt(s)===S){if(!d){f=s;break}}else d=!1;return f===-1?i?"/":".":i&&f===1?"//":n.slice(0,f)},basename(n,i){i!==void 0&&L(i,"ext"),L(n,"path");let f=0,d=-1,s=!0,r;if(i!==void 0&&i.length>0&&i.length<=n.length){if(i===n)return"";let _=i.length-1,l=-1;for(r=n.length-1;r>=0;--r){const E=n.charCodeAt(r);if(E===S){if(!s){f=r+1;break}}else l===-1&&(s=!1,l=r+1),_>=0&&(E===i.charCodeAt(_)?--_===-1&&(d=r):(_=-1,d=l))}return f===d?d=l:d===-1&&(d=n.length),n.slice(f,d)}for(r=n.length-1;r>=0;--r)if(n.charCodeAt(r)===S){if(!s){f=r+1;break}}else d===-1&&(s=!1,d=r+1);return d===-1?"":n.slice(f,d)},extname(n){L(n,"path");let i=-1,f=0,d=-1,s=!0,r=0;for(let _=n.length-1;_>=0;--_){const l=n.charCodeAt(_);if(l===S){if(!s){f=_+1;break}continue}d===-1&&(s=!1,d=_+1),l===H?i===-1?i=_:r!==1&&(r=1):i!==-1&&(r=-1)}return i===-1||d===-1||r===0||r===1&&i===d-1&&i===f+1?"":n.slice(i,d)},format:W.bind(null,"/"),parse(n){L(n,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return i;const f=n.charCodeAt(0)===S;let d;f?(i.root="/",d=1):d=0;let s=-1,r=0,_=-1,l=!0,E=n.length-1,$=0;for(;E>=d;--E){const u=n.charCodeAt(E);if(u===S){if(!l){r=E+1;break}continue}_===-1&&(l=!1,_=E+1),u===H?s===-1?s=E:$!==1&&($=1):s!==-1&&($=-1)}if(_!==-1){const u=r===0&&f?1:r;s===-1||$===0||$===1&&s===_-1&&s===r+1?i.base=i.name=n.slice(u,_):(i.name=n.slice(u,s),i.base=n.slice(u,_),i.ext=n.slice(s,_))}return r>0?i.dir=n.slice(0,r-1):f&&(i.dir="/"),i},sep:"/",delimiter:":",win32:null,posix:null},t.$jc.win32=t.$ic.win32=t.$ic,t.$jc.posix=t.$ic.posix=t.$jc,t.$kc=w?t.$ic.normalize:t.$jc.normalize,t.$lc=w?t.$ic.isAbsolute:t.$jc.isAbsolute,t.$mc=w?t.$ic.join:t.$jc.join,t.$nc=w?t.$ic.resolve:t.$jc.resolve,t.$oc=w?t.$ic.relative:t.$jc.relative,t.$pc=w?t.$ic.dirname:t.$jc.dirname,t.$qc=w?t.$ic.basename:t.$jc.basename,t.$rc=w?t.$ic.extname:t.$jc.extname,t.$sc=w?t.$ic.format:t.$jc.format,t.$tc=w?t.$ic.parse:t.$jc.parse,t.$uc=w?t.$ic.toNamespacedPath:t.$jc.toNamespacedPath,t.sep=w?t.$ic.sep:t.$jc.sep,t.$wc=w?t.$ic.delimiter:t.$jc.delimiter}),define(h1[19],d1([0,1]),function(t1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ie=void 0;const g=globalThis.performance&&typeof globalThis.performance.now=="function";class e{static create(R){return new e(R)}constructor(R){this.c=g&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$ie=e}),define(h1[8],d1([0,1,2,5,6,15,19]),function(t1,t,g,e,q,R,n1){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ye=t.$xe=t.$we=t.$ve=t.$ue=t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=t.$ke=t.Event=void 0,t.$le=J;const H=!1,S=!1,D=!1;var k;(function(N){N.None=()=>q.$Xc.None;function v(z){if(D){const{onDidAddListener:B}=z,V=w.create();let p=0;z.onDidAddListener=()=>{++p===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),V.print()),B?.()}}}function G(z,B){return M1(z,()=>{},0,void 0,!0,void 0,B)}N.defer=G;function i1(z){return(B,V=null,p)=>{let Z=!1,c1;return c1=z(_1=>{if(!Z)return c1?c1.dispose():Z=!0,B.call(V,_1)},null,p),Z&&c1.dispose(),c1}}N.once=i1;function x(z,B){return N.once(N.filter(z,B))}N.onceIf=x;function s1(z,B,V){return v1((p,Z=null,c1)=>z(_1=>p.call(Z,B(_1)),null,c1),V)}N.map=s1;function l1(z,B,V){return v1((p,Z=null,c1)=>z(_1=>{B(_1),p.call(Z,_1)},null,c1),V)}N.forEach=l1;function Q(z,B,V){return v1((p,Z=null,c1)=>z(_1=>B(_1)&&p.call(Z,_1),null,c1),V)}N.filter=Q;function o1(z){return z}N.signal=o1;function a1(...z){return(B,V=null,p)=>{const Z=(0,q.$Uc)(...z.map(c1=>c1(_1=>B.call(V,_1))));return I1(Z,p)}}N.any=a1;function L1(z,B,V,p){let Z=V;return s1(z,c1=>(Z=B(Z,c1),Z),p)}N.reduce=L1;function v1(z,B){let V;const p={onWillAddFirstListener(){V=z(Z.fire,Z)},onDidRemoveLastListener(){V?.dispose()}};B||v(p);const Z=new n(p);return B?.add(Z),Z.event}function I1(z,B){return B instanceof Array?B.push(z):B&&B.add(z),z}function M1(z,B,V=100,p=!1,Z=!1,c1,_1){let g1,m1,r1,R1=0,F1;const K1={leakWarningThreshold:c1,onWillAddFirstListener(){g1=z(V1=>{R1++,m1=B(m1,V1),p&&!r1&&(j1.fire(m1),m1=void 0),F1=()=>{const B1=m1;m1=void 0,r1=void 0,(!p||R1>1)&&j1.fire(B1),R1=0},typeof V=="number"?(clearTimeout(r1),r1=setTimeout(F1,V)):r1===void 0&&(r1=0,queueMicrotask(F1))})},onWillRemoveListener(){Z&&R1>0&&F1?.()},onDidRemoveLastListener(){F1=void 0,g1.dispose()}};_1||v(K1);const j1=new n(K1);return _1?.add(j1),j1.event}N.debounce=M1;function G1(z,B=0,V){return N.debounce(z,(p,Z)=>p?(p.push(Z),p):[Z],B,void 0,!0,void 0,V)}N.accumulate=G1;function H1(z,B=(p,Z)=>p===Z,V){let p=!0,Z;return Q(z,c1=>{const _1=p||!B(c1,Z);return p=!1,Z=c1,_1},V)}N.latch=H1;function T1(z,B,V){return[N.filter(z,B,V),N.filter(z,p=>!B(p),V)]}N.split=T1;function P1(z,B=!1,V=[],p){let Z=V.slice(),c1=z(m1=>{Z?Z.push(m1):g1.fire(m1)});p&&p.add(c1);const _1=()=>{Z?.forEach(m1=>g1.fire(m1)),Z=null},g1=new n({onWillAddFirstListener(){c1||(c1=z(m1=>g1.fire(m1)),p&&p.add(c1))},onDidAddFirstListener(){Z&&(B?setTimeout(_1):_1())},onDidRemoveLastListener(){c1&&c1.dispose(),c1=null}});return p&&p.add(g1),g1.event}N.buffer=P1;function p1(z,B){return(p,Z,c1)=>{const _1=B(new m);return z(function(g1){const m1=_1.evaluate(g1);m1!==h&&p.call(Z,m1)},void 0,c1)}}N.chain=p1;const h=Symbol("HaltChainable");class m{constructor(){this.f=[]}map(B){return this.f.push(B),this}forEach(B){return this.f.push(V=>(B(V),V)),this}filter(B){return this.f.push(V=>B(V)?V:h),this}reduce(B,V){let p=V;return this.f.push(Z=>(p=B(p,Z),p)),this}latch(B=(V,p)=>V===p){let V=!0,p;return this.f.push(Z=>{const c1=V||!B(Z,p);return V=!1,p=Z,c1?Z:h}),this}evaluate(B){for(const V of this.f)if(B=V(B),B===h)break;return B}}function b(z,B,V=p=>p){const p=(...g1)=>_1.fire(V(...g1)),Z=()=>z.on(B,p),c1=()=>z.removeListener(B,p),_1=new n({onWillAddFirstListener:Z,onDidRemoveLastListener:c1});return _1.event}N.fromNodeEventEmitter=b;function I(z,B,V=p=>p){const p=(...g1)=>_1.fire(V(...g1)),Z=()=>z.addEventListener(B,p),c1=()=>z.removeEventListener(B,p),_1=new n({onWillAddFirstListener:Z,onDidRemoveLastListener:c1});return _1.event}N.fromDOMEventEmitter=I;function y(z){return new Promise(B=>i1(z)(B))}N.toPromise=y;function e1(z){const B=new n;return z.then(V=>{B.fire(V)},()=>{B.fire(void 0)}).finally(()=>{B.dispose()}),B.event}N.fromPromise=e1;function f1(z,B){return z(V=>B.fire(V))}N.forward=f1;function b1(z,B,V){return B(V),z(p=>B(p))}N.runAndSubscribe=b1;class $1{constructor(B,V){this._observable=B,this.f=0,this.g=!1;const p={onWillAddFirstListener:()=>{B.addObserver(this),this._observable.reportChanges()},onDidRemoveLastListener:()=>{B.removeObserver(this)}};V||v(p),this.emitter=new n(p),V&&V.add(this.emitter)}beginUpdate(B){this.f++}handlePossibleChange(B){}handleChange(B,V){this.g=!0}endUpdate(B){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function A1(z,B){return new $1(z,B).emitter.event}N.fromObservable=A1;function U1(z){return(B,V,p)=>{let Z=0,c1=!1;const _1={beginUpdate(){Z++},endUpdate(){Z--,Z===0&&(z.reportChanges(),c1&&(c1=!1,B.call(V)))},handlePossibleChange(){},handleChange(){c1=!0}};z.addObserver(_1),z.reportChanges();const g1={dispose(){z.removeObserver(_1)}};return p instanceof q.$Wc?p.add(g1):Array.isArray(p)&&p.push(g1),g1}}N.fromObservableLight=U1})(k||(t.Event=k={}));class Y{static{this.all=new Set}static{this.f=0}constructor(v){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${v}_${Y.f++}`,Y.all.add(this)}start(v){this.g=new n1.$ie,this.listenerCount=v}stop(){if(this.g){const v=this.g.elapsed();this.durations.push(v),this.elapsedOverall+=v,this.invocationCount+=1,this.g=void 0}}}t.$ke=Y;let M=-1;function J(N){const v=M;return M=N,{dispose(){M=v}}}class L{static{this.f=1}constructor(v,G,i1=(L.f++).toString(16).padStart(3,"0")){this.j=v,this.threshold=G,this.name=i1,this.h=0}dispose(){this.g?.clear()}check(v,G){const i1=this.threshold;if(i1<=0||G<i1)return;this.g||(this.g=new Map);const x=this.g.get(v.value)||0;if(this.g.set(v.value,x+1),this.h-=1,this.h<=0){this.h=i1*.5;const[s1,l1]=this.getMostFrequentStack(),Q=`[${this.name}] potential listener LEAK detected, having ${G} listeners already. MOST frequent listener (${l1}):`;console.warn(Q),console.warn(s1);const o1=new U(Q,s1);this.j(o1)}return()=>{const s1=this.g.get(v.value)||0;this.g.set(v.value,s1-1)}}getMostFrequentStack(){if(!this.g)return;let v,G=0;for(const[i1,x]of this.g)(!v||G<x)&&(v=[i1,x],G=x);return v}}class w{static create(){const v=new Error;return new w(v.stack??"")}constructor(v){this.value=v}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class U extends Error{constructor(v,G){super(v),this.name="ListenerLeakError",this.stack=G}}t.$me=U;class P extends Error{constructor(v,G){super(v),this.name="ListenerRefusalError",this.stack=G}}t.$ne=P;let j=0;class K{constructor(v){this.value=v,this.id=j++}}const C=2,W=(N,v)=>{if(N instanceof K)v(N);else for(let G=0;G<N.length;G++){const i1=N[G];i1&&v(i1)}};let c;if(H){const N=[];setInterval(()=>{N.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(N.join(`
`)),N.length=0)},3e3),c=new FinalizationRegistry(v=>{typeof v=="string"&&N.push(v)})}class n{constructor(v){this.z=0,this.f=v,this.g=M>0||this.f?.leakWarningThreshold?new L(v?.onListenerError??g.$2,this.f?.leakWarningThreshold??M):void 0,this.j=this.f?._profName?new Y(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(S){const v=this.u;queueMicrotask(()=>{W(v,G=>G.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(v,G,i1)=>{if(this.g&&this.z>this.g.threshold**2){const o1=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(o1);const a1=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],L1=new P(`${o1}. HINT: Stack shows most frequent listener (${a1[1]}-times)`,a1[0]);return(this.f?.onListenerError||g.$2)(L1),q.$Xc.None}if(this.m)return q.$Xc.None;G&&(v=v.bind(G));const x=new K(v);let s1,l1;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(x.stack=w.create(),s1=this.g.check(x.stack,this.z+1)),S&&(x.stack=l1??w.create()),this.u?this.u instanceof K?(this.w??=new f,this.u=[this.u,x]):this.u.push(x):(this.f?.onWillAddFirstListener?.(this),this.u=x,this.f?.onDidAddFirstListener?.(this)),this.z++;const Q=(0,q.$Vc)(()=>{c?.unregister(Q),s1?.(),this.A(x)});if(i1 instanceof q.$Wc?i1.add(Q):Array.isArray(i1)&&i1.push(Q),c){const o1=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),a1=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(o1);c.register(Q,a1?.[2]??o1,Q)}return Q},this.q}A(v){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const G=this.u,i1=G.indexOf(v);if(i1===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,G[i1]=void 0;const x=this.w.current===this;if(this.z*C<=G.length){let s1=0;for(let l1=0;l1<G.length;l1++)G[l1]?G[s1++]=G[l1]:x&&(this.w.end--,s1<this.w.i&&this.w.i--);G.length=s1}}B(v,G){if(!v)return;const i1=this.f?.onListenerError||g.$2;if(!i1){v.value(G);return}try{v.value(G)}catch(x){i1(x)}}C(v){const G=v.current.u;for(;v.i<v.end;)this.B(G[v.i++],v.value);v.reset()}fire(v){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof K)this.B(this.u,v);else{const G=this.w;G.enqueue(this,v,this.u.length),this.C(G)}this.j?.stop()}hasListeners(){return this.z>0}}t.$oe=n;const i=()=>new f;t.$pe=i;class f{constructor(){this.i=-1,this.end=0}enqueue(v,G,i1){this.i=0,this.end=i1,this.current=v,this.value=G}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class d extends n{async fireAsync(v,G,i1){if(this.u)for(this.h||(this.h=new R.$8c),W(this.u,x=>this.h.push([x.value,v]));this.h.size>0&&!G.isCancellationRequested;){const[x,s1]=this.h.shift(),l1=[],Q={...s1,token:G,waitUntil:o1=>{if(Object.isFrozen(l1))throw new Error("waitUntil can NOT be called asynchronous");i1&&(o1=i1(o1,x)),l1.push(o1)}};try{x(Q)}catch(o1){(0,g.$2)(o1);continue}Object.freeze(l1),await Promise.allSettled(l1).then(o1=>{for(const a1 of o1)a1.status==="rejected"&&(0,g.$2)(a1.reason)})}}}t.$qe=d;class s extends n{get isPaused(){return this.h!==0}constructor(v){super(v),this.h=0,this.s=new R.$8c,this.t=v?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const v=Array.from(this.s);this.s.clear(),super.fire(this.t(v))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(v){this.z&&(this.h!==0?this.s.push(v):super.fire(v))}}t.$re=s;class r extends s{constructor(v){super(v),this.k=v.delay??100}fire(v){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(v)}}t.$se=r;class _ extends n{constructor(v){super(v),this.h=[],this.k=v?.merge}fire(v){this.hasListeners()&&(this.h.push(v),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(G=>super.fire(G)),this.h=[]}))}}t.$te=_;class l{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(v){const G={event:v,listener:null};this.h.push(G),this.g&&this.m(G);const i1=()=>{this.g&&this.o(G);const x=this.h.indexOf(G);this.h.splice(x,1)};return(0,q.$Vc)((0,e.$fb)(i1))}j(){this.g=!0,this.h.forEach(v=>this.m(v))}k(){this.g=!1,this.h.forEach(v=>this.o(v))}m(v){v.listener=v.event(G=>this.f.fire(G))}o(v){v.listener?.dispose(),v.listener=null}dispose(){this.f.dispose();for(const v of this.h)v.listener?.dispose();this.h=[]}}t.$ue=l;class E{constructor(v,G,i1,x){this.f=new q.$Wc;const s1=this.f.add(new l),l1=this.f.add(new q.$7c);function Q(o1){l1.set(o1,s1.add(x(o1)))}for(const o1 of v)Q(o1);this.f.add(G(o1=>{Q(o1)})),this.f.add(i1(o1=>{l1.deleteAndDispose(o1)})),this.event=s1.event}dispose(){this.f.dispose()}}t.$ve=E;class ${constructor(){this.f=[]}wrapEvent(v,G,i1){return(x,s1,l1)=>v(Q=>{const o1=this.f[this.f.length-1];if(!G){o1?o1.buffers.push(()=>x.call(s1,Q)):x.call(s1,Q);return}const a1=o1;if(!a1){x.call(s1,G(i1,Q));return}a1.items??=[],a1.items.push(Q),a1.buffers.length===0&&o1.buffers.push(()=>{a1.reducedResult??=i1?a1.items.reduce(G,i1):a1.items.reduce(G),x.call(s1,a1.reducedResult)})},void 0,l1)}bufferEvents(v){const G={buffers:new Array};this.f.push(G);const i1=v();return this.f.pop(),G.buffers.forEach(x=>x()),i1}}t.$we=$;class u{constructor(){this.f=!1,this.g=k.None,this.h=q.$Xc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(v){this.g=v,this.f&&(this.h.dispose(),this.h=v(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$xe=u;class T{static const(v){return new F(v)}constructor(v){this.g=v,this.f=new n,this.onDidChange=this.f.event}get value(){return this.g}set value(v){v!==this.g&&(this.g=v,this.f.fire(void 0))}}t.$ye=T;class F{constructor(v){this.value=v,this.onDidChange=k.None}}}),define(h1[20],d1([0,1,8]),function(t1,t,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ze=t.CancellationToken=void 0,t.$Ae=H;const e=Object.freeze(function(S,D){const k=setTimeout(S.bind(D),0);return{dispose(){clearTimeout(k)}}});var q;(function(S){function D(k){return k===S.None||k===S.Cancelled||k instanceof R?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}S.isCancellationToken=D,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:g.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:e})})(q||(t.CancellationToken=q={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?e:(this.b||(this.b=new g.$oe),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class n1{constructor(D){this.f=void 0,this.g=void 0,this.g=D&&D.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=q.Cancelled}dispose(D=!1){D&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=q.None}}t.$ze=n1;function H(S){const D=new n1;return S.add({dispose(){D.cancel()}}),D.token}}),define(h1[21],d1([0,1,20]),function(t1,t,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cf=t.$bf=t.$_e=void 0,t.$af=q;class e{constructor(S){this.b=S,this.a=null}get(){if(this.a)return this.a;const S=new g.$ze,D=this.b(S.token);return this.a={promise:D,dispose:()=>{this.a=null,S.cancel(),S.dispose()}},this.a}}t.$_e=e;function q(H){return H}class R{constructor(S,D){this.a=void 0,this.b=void 0,typeof S=="function"?(this.c=S,this.d=q):(this.c=D,this.d=S.getCacheKey)}get(S){const D=this.d(S);return this.b!==D&&(this.b=D,this.a=this.c(S)),this.a}}t.$bf=R;class n1{get cachedValues(){return this.a}constructor(S,D){this.a=new Map,this.b=new Map,typeof S=="function"?(this.c=S,this.d=q):(this.c=D,this.d=S.getCacheKey)}get(S){const D=this.d(S);if(this.b.has(D))return this.b.get(D);const k=this.c(S);return this.a.set(S,k),this.b.set(D,k),k}}t.$cf=n1}),define(h1[22],d1([0,1]),function(t1,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Constants=void 0,t.$df=e,t.$ef=q;var g;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(g||(t.Constants=g={}));function e(R){return R<0?0:R>g.MAX_UINT_8?g.MAX_UINT_8:R|0}function q(R){return R<0?0:R>g.MAX_UINT_32?g.MAX_UINT_32:R|0}}),define(h1[9],d1([0,1,21,4,14,22]),function(t1,t,g,e,q,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gg=t.$fg=t.$eg=t.GraphemeBreakType=t.$7f=t.$Yf=t.$Rf=t.$Qf=void 0,t.$ff=n1,t.$gf=S,t.$hf=k,t.$if=Y,t.$jf=M,t.$kf=J,t.$lf=L,t.$mf=w,t.$nf=U,t.$of=P,t.$pf=j,t.$qf=K,t.$rf=C,t.$sf=W,t.$tf=c,t.$uf=n,t.$vf=i,t.$wf=f,t.$xf=d,t.$yf=s,t.$zf=r,t.$Af=_,t.$Bf=l,t.$Cf=E,t.$Df=$,t.$Ef=u,t.$Ff=T,t.$Gf=F,t.$Hf=N,t.$If=v,t.$Jf=G,t.$Kf=i1,t.$Lf=x,t.$Mf=s1,t.$Nf=l1,t.$Of=Q,t.$Pf=o1,t.$Sf=I1,t.$Tf=M1,t.$Uf=G1,t.$Vf=H1,t.$Wf=p1,t.$Xf=m,t.$Zf=b,t.$1f=I,t.$2f=y,t.$3f=e1,t.$4f=b1,t.$5f=$1,t.$6f=U1,t.$8f=z,t.$9f=B,t.$0f=V,t.$$f=p,t.$_f=Z,t.$ag=c1,t.$bg=_1,t.$cg=g1,t.$dg=K1;function n1(o){return!o||typeof o!="string"?!0:o.trim().length===0}const H=/{(\d+)}/g;function S(o,...a){return a.length===0?o:o.replace(H,function(A,O){const X=parseInt(O,10);return isNaN(X)||X<0||X>=a.length?A:a[X]})}const D=/{([^}]+)}/g;function k(o,a){return Object.keys(a).length===0?o:o.replace(D,(A,O)=>a[O]??A)}function Y(o){return o.replace(/[<>"'&]/g,a=>{switch(a){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return a})}function M(o){return o.replace(/[<>&]/g,function(a){switch(a){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return a}})}function J(o){return o.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function L(o,a){let A=0,O=o.indexOf(a);for(;O!==-1;)A++,O=o.indexOf(a,O+a.length);return A}function w(o,a,A="\u2026"){return o.length<=a?o:`${o.substr(0,a)}${A}`}function U(o,a,A="\u2026"){if(o.length<=a)return o;const O=Math.ceil(a/2)-A.length/2,X=Math.floor(a/2)-A.length/2;return`${o.substr(0,O)}${A}${o.substr(o.length-X)}`}function P(o,a=" "){const A=j(o,a);return K(A,a)}function j(o,a){if(!o||!a)return o;const A=a.length;if(A===0||o.length===0)return o;let O=0;for(;o.indexOf(a,O)===O;)O=O+A;return o.substring(O)}function K(o,a){if(!o||!a)return o;const A=a.length,O=o.length;if(A===0||O===0)return o;let X=O,u1=-1;for(;u1=o.lastIndexOf(a,X-1),!(u1===-1||u1+A!==X);){if(u1===0)return"";X=u1}return o.substring(0,X)}function C(o){return o.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function W(o){return o.replace(/\*/g,"")}function c(o,a,A={}){if(!o)throw new Error("Cannot create regex from empty string");a||(o=J(o)),A.wholeWord&&(/\B/.test(o.charAt(0))||(o="\\b"+o),/\B/.test(o.charAt(o.length-1))||(o=o+"\\b"));let O="";return A.global&&(O+="g"),A.matchCase||(O+="i"),A.multiline&&(O+="m"),A.unicode&&(O+="u"),new RegExp(o,O)}function n(o){return o.source==="^"||o.source==="^$"||o.source==="$"||o.source==="^\\s*$"?!1:!!(o.exec("")&&o.lastIndex===0)}function i(o){return o.split(/\r\n|\r|\n/)}function f(o){const a=[],A=o.split(/(\r\n|\r|\n)/);for(let O=0;O<Math.ceil(A.length/2);O++)a.push(A[2*O]+(A[2*O+1]??""));return a}function d(o){for(let a=0,A=o.length;a<A;a++){const O=o.charCodeAt(a);if(O!==e.CharCode.Space&&O!==e.CharCode.Tab)return a}return-1}function s(o,a=0,A=o.length){for(let O=a;O<A;O++){const X=o.charCodeAt(O);if(X!==e.CharCode.Space&&X!==e.CharCode.Tab)return o.substring(a,O)}return o.substring(a,A)}function r(o,a=o.length-1){for(let A=a;A>=0;A--){const O=o.charCodeAt(A);if(O!==e.CharCode.Space&&O!==e.CharCode.Tab)return A}return-1}function _(o,a,A){const O=[];let X=0;for(const u1 of o.matchAll(a)){if(O.push(o.slice(X,u1.index)),u1.index===void 0)throw new Error("match.index should be defined");X=u1.index+u1[0].length,O.push(A(u1[0],...u1.slice(1),u1.index,o,u1.groups))}return O.push(o.slice(X)),Promise.all(O).then(u1=>u1.join(""))}function l(o,a){return o<a?-1:o>a?1:0}function E(o,a,A=0,O=o.length,X=0,u1=a.length){for(;A<O&&X<u1;A++,X++){const O1=o.charCodeAt(A),D1=a.charCodeAt(X);if(O1<D1)return-1;if(O1>D1)return 1}const E1=O-A,N1=u1-X;return E1<N1?-1:E1>N1?1:0}function $(o,a){return u(o,a,0,o.length,0,a.length)}function u(o,a,A=0,O=o.length,X=0,u1=a.length){for(;A<O&&X<u1;A++,X++){let O1=o.charCodeAt(A),D1=a.charCodeAt(X);if(O1===D1)continue;if(O1>=128||D1>=128)return E(o.toLowerCase(),a.toLowerCase(),A,O,X,u1);F(O1)&&(O1-=32),F(D1)&&(D1-=32);const w1=O1-D1;if(w1!==0)return w1}const E1=O-A,N1=u1-X;return E1<N1?-1:E1>N1?1:0}function T(o){return o>=e.CharCode.Digit0&&o<=e.CharCode.Digit9}function F(o){return o>=e.CharCode.a&&o<=e.CharCode.z}function N(o){return o>=e.CharCode.A&&o<=e.CharCode.Z}function v(o,a){return o.length===a.length&&u(o,a)===0}function G(o,a){const A=a.length;return a.length>o.length?!1:u(o,a,0,A)===0}function i1(o,a){const A=Math.min(o.length,a.length);let O;for(O=0;O<A;O++)if(o.charCodeAt(O)!==a.charCodeAt(O))return O;return A}function x(o,a){const A=Math.min(o.length,a.length);let O;const X=o.length-1,u1=a.length-1;for(O=0;O<A;O++)if(o.charCodeAt(X-O)!==a.charCodeAt(u1-O))return O;return A}function s1(o){return 55296<=o&&o<=56319}function l1(o){return 56320<=o&&o<=57343}function Q(o,a){return(o-55296<<10)+(a-56320)+65536}function o1(o,a,A){const O=o.charCodeAt(A);if(s1(O)&&A+1<a){const X=o.charCodeAt(A+1);if(l1(X))return Q(O,X)}return O}function a1(o,a){const A=o.charCodeAt(a-1);if(l1(A)&&a>1){const O=o.charCodeAt(a-2);if(s1(O))return Q(O,A)}return A}class L1{get offset(){return this.e}constructor(a,A=0){this.c=a,this.d=a.length,this.e=A}setOffset(a){this.e=a}prevCodePoint(){const a=a1(this.c,this.e);return this.e-=a>=R.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,a}nextCodePoint(){const a=o1(this.c,this.d,this.e);return this.e+=a>=R.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,a}eol(){return this.e>=this.d}}t.$Qf=L1;class v1{get offset(){return this.c.offset}constructor(a,A=0){this.c=new L1(a,A)}nextGraphemeLength(){const a=R1.getInstance(),A=this.c,O=A.offset;let X=a.getGraphemeBreakType(A.nextCodePoint());for(;!A.eol();){const u1=A.offset,E1=a.getGraphemeBreakType(A.nextCodePoint());if(m1(X,E1)){A.setOffset(u1);break}X=E1}return A.offset-O}prevGraphemeLength(){const a=R1.getInstance(),A=this.c,O=A.offset;let X=a.getGraphemeBreakType(A.prevCodePoint());for(;A.offset>0;){const u1=A.offset,E1=a.getGraphemeBreakType(A.prevCodePoint());if(m1(E1,X)){A.setOffset(u1);break}X=E1}return O-A.offset}eol(){return this.c.eol()}}t.$Rf=v1;function I1(o,a){return new v1(o,a).nextGraphemeLength()}function M1(o,a){return new v1(o,a).prevGraphemeLength()}function G1(o,a){a>0&&l1(o.charCodeAt(a))&&a--;const A=a+I1(o,a);return[A-M1(o,A),A]}function H1(o){const a=new v1(o);let A=0;for(;!a.eol();)A++,a.nextGraphemeLength();return A}let T1;function P1(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function p1(o){return T1||(T1=P1()),T1.test(o)}const h=/^[\t\n\r\x20-\x7E]*$/;function m(o){return h.test(o)}t.$Yf=/[\u2028\u2029]/;function b(o){return t.$Yf.test(o)}function I(o){return o>=11904&&o<=55215||o>=63744&&o<=64255||o>=65281&&o<=65374}function y(o){return o>=127462&&o<=127487||o===8986||o===8987||o===9200||o===9203||o>=9728&&o<=10175||o===11088||o===11093||o>=127744&&o<=128591||o>=128640&&o<=128764||o>=128992&&o<=129008||o>=129280&&o<=129535||o>=129648&&o<=129782}function e1(o,a,A=""){const O=o.trimStart();if(O.length<a)return O;const X=/\b/g;let u1=0;for(;X.test(O)&&!(O.length-X.lastIndex<a);)u1=X.lastIndex,X.lastIndex+=1;return u1===0?O:A+O.substring(u1).trimStart()}const f1=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*b1(o){let a=0;for(const A of o.matchAll(f1))a!==A.index&&(yield{isCode:!1,str:o.substring(a,A.index)}),yield{isCode:!0,str:A[0]},a=A.index+A[0].length;a!==o.length&&(yield{isCode:!1,str:o.substring(a)})}function $1(o){return o&&(o=o.replace(f1,"")),o}const A1=/\\\[.*?\\\]/g;function U1(o){return $1(o).replace(A1,"")}t.$7f=String.fromCharCode(e.CharCode.UTF8_BOM);function z(o){return!!(o&&o.length>0&&o.charCodeAt(0)===e.CharCode.UTF8_BOM)}function B(o){return z(o)?o.substr(1):o}function V(o,a){if(!o||!a||o.length<a.length)return!1;const A=a.length,O=o.toLowerCase();let X=0,u1=-1;for(;X<A;){const E1=O.indexOf(a[X],u1+1);if(E1<0)return!1;u1=E1,X++}return!0}function p(o,a=!1){return o?(a&&(o=o.replace(/\\./g,"")),o.toLowerCase()!==o):!1}function Z(o){return o.charAt(0).toUpperCase()+o.slice(1)}function c1(o,a=1){if(a===0)return"";let A=-1;do A=o.indexOf(`
`,A+1),a--;while(a>0&&A>=0);return A===-1?o:(o[A-1]==="\r"&&A--,o.substr(0,A))}function _1(o){const a=e.CharCode.Z-e.CharCode.A+1;return o=o%(2*a),o<a?String.fromCharCode(e.CharCode.a+o):String.fromCharCode(e.CharCode.A+o-a)}function g1(o){return R1.getInstance().getGraphemeBreakType(o)}function m1(o,a){return o===r1.Other?a!==r1.Extend&&a!==r1.SpacingMark:o===r1.CR&&a===r1.LF?!1:o===r1.Control||o===r1.CR||o===r1.LF||a===r1.Control||a===r1.CR||a===r1.LF?!0:!(o===r1.L&&(a===r1.L||a===r1.V||a===r1.LV||a===r1.LVT)||(o===r1.LV||o===r1.V)&&(a===r1.V||a===r1.T)||(o===r1.LVT||o===r1.T)&&a===r1.T||a===r1.Extend||a===r1.ZWJ||a===r1.SpacingMark||o===r1.Prepend||o===r1.ZWJ&&a===r1.Extended_Pictographic||o===r1.Regional_Indicator&&a===r1.Regional_Indicator)}var r1;(function(o){o[o.Other=0]="Other",o[o.Prepend=1]="Prepend",o[o.CR=2]="CR",o[o.LF=3]="LF",o[o.Control=4]="Control",o[o.Extend=5]="Extend",o[o.Regional_Indicator=6]="Regional_Indicator",o[o.SpacingMark=7]="SpacingMark",o[o.L=8]="L",o[o.V=9]="V",o[o.T=10]="T",o[o.LV=11]="LV",o[o.LVT=12]="LVT",o[o.ZWJ=13]="ZWJ",o[o.Extended_Pictographic=14]="Extended_Pictographic"})(r1||(t.GraphemeBreakType=r1={}));class R1{static{this.c=null}static getInstance(){return R1.c||(R1.c=new R1),R1.c}constructor(){this.d=F1()}getGraphemeBreakType(a){if(a<32)return a===e.CharCode.LineFeed?r1.LF:a===e.CharCode.CarriageReturn?r1.CR:r1.Control;if(a<127)return r1.Other;const A=this.d,O=A.length/3;let X=1;for(;X<=O;)if(a<A[3*X])X=2*X;else if(a>A[3*X+1])X=2*X+1;else return A[3*X+2];return r1.Other}}function F1(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function K1(o,a){if(o===0)return 0;const A=j1(o,a);if(A!==void 0)return A;const O=new L1(a,o);return O.prevCodePoint(),O.offset}function j1(o,a){const A=new L1(a,o);let O=A.prevCodePoint();for(;V1(O)||O===B1.emojiVariantSelector||O===B1.enclosingKeyCap;){if(A.offset===0)return;O=A.prevCodePoint()}if(!y(O))return;let X=A.offset;return X>0&&A.prevCodePoint()===B1.zwj&&(X=A.offset),X}function V1(o){return 127995<=o&&o<=127999}var B1;(function(o){o[o.zwj=8205]="zwj",o[o.emojiVariantSelector=65039]="emojiVariantSelector",o[o.enclosingKeyCap=8419]="enclosingKeyCap"})(B1||(B1={})),t.$eg="\xA0";class W1{static{this.c=new q.$W(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new g.$bf({getCacheKey:JSON.stringify},a=>{function A(w1){const y1=new Map;for(let S1=0;S1<w1.length;S1+=2)y1.set(w1[S1],w1[S1+1]);return y1}function O(w1,y1){const S1=new Map(w1);for(const[z1,X1]of y1)S1.set(z1,X1);return S1}function X(w1,y1){if(!w1)return y1;const S1=new Map;for(const[z1,X1]of w1)y1.has(z1)&&S1.set(z1,X1);return S1}const u1=this.c.value;let E1=a.filter(w1=>!w1.startsWith("_")&&w1 in u1);E1.length===0&&(E1=["_default"]);let N1;for(const w1 of E1){const y1=A(u1[w1]);N1=X(N1,y1)}const O1=A(u1._common),D1=O(O1,N1);return new W1(D1)})}static getInstance(a){return W1.d.get(Array.from(a))}static{this.e=new q.$W(()=>Object.keys(W1.c.value).filter(a=>!a.startsWith("_")))}static getLocales(){return W1.e.value}constructor(a){this.f=a}isAmbiguous(a){return this.f.has(a)}containsAmbiguousCharacter(a){for(let A=0;A<a.length;A++){const O=a.codePointAt(A);if(typeof O=="number"&&this.isAmbiguous(O))return!0}return!1}getPrimaryConfusable(a){return this.f.get(a)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$fg=W1;class q1{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(q1.c())),this.d}static isInvisibleCharacter(a){return q1.e().has(a)}static containsInvisibleCharacter(a){for(let A=0;A<a.length;A++){const O=a.codePointAt(A);if(typeof O=="number"&&q1.isInvisibleCharacter(O))return!0}return!1}static get codePoints(){return q1.e()}}t.$gg=q1}),define(h1[23],d1([0,1,4,17,7,3]),function(t1,t,g,e,q,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URI=void 0,t.$yc=U,t.$zc=c,q=k1(q);const n1=/^\w[\w\d+.-]*$/,H=/^\//,S=/^\/\//;function D(s,r){if(!s.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!n1.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!H.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(S.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function k(s,r){return!s&&!r?"file":s}function Y(s,r){switch(s){case"https":case"http":case"file":r?r[0]!==J&&(r=J+r):r=J;break}return r}const M="",J="/",L=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class w{static isUri(r){return r instanceof w?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}constructor(r,_,l,E,$,u=!1){typeof r=="object"?(this.scheme=r.scheme||M,this.authority=r.authority||M,this.path=r.path||M,this.query=r.query||M,this.fragment=r.fragment||M):(this.scheme=k(r,u),this.authority=_||M,this.path=Y(this.scheme,l||M),this.query=E||M,this.fragment=$||M,D(this,u))}get fsPath(){return c(this,!1)}with(r){if(!r)return this;let{scheme:_,authority:l,path:E,query:$,fragment:u}=r;return _===void 0?_=this.scheme:_===null&&(_=M),l===void 0?l=this.authority:l===null&&(l=M),E===void 0?E=this.path:E===null&&(E=M),$===void 0?$=this.query:$===null&&($=M),u===void 0?u=this.fragment:u===null&&(u=M),_===this.scheme&&l===this.authority&&E===this.path&&$===this.query&&u===this.fragment?this:new j(_,l,E,$,u)}static parse(r,_=!1){const l=L.exec(r);return l?new j(l[2]||M,d(l[4]||M),d(l[5]||M),d(l[7]||M),d(l[9]||M),_):new j(M,M,M,M,M)}static file(r){let _=M;if(R.$j&&(r=r.replace(/\\/g,J)),r[0]===J&&r[1]===J){const l=r.indexOf(J,2);l===-1?(_=r.substring(2),r=J):(_=r.substring(2,l),r=r.substring(l)||J)}return new j("file",_,r,M,M)}static from(r,_){return new j(r.scheme,r.authority,r.path,r.query,r.fragment,_)}static joinPath(r,..._){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return R.$j&&r.scheme==="file"?l=w.file(q.$ic.join(c(r,!0),..._)).path:l=q.$jc.join(r.path,..._),r.with({path:l})}toString(r=!1){return n(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof w)return r;{const _=new j(r);return _._formatted=r.external??null,_._fsPath=r._sep===P?r.fsPath??null:null,_}}else return r}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}t.URI=w;function U(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}const P=R.$j?1:void 0;class j extends w{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(r=!1){return r?n(this,!0):(this._formatted||(this._formatted=n(this,!1)),this._formatted)}toJSON(){const r={$mid:e.MarshalledId.Uri};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=P),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const K={[g.CharCode.Colon]:"%3A",[g.CharCode.Slash]:"%2F",[g.CharCode.QuestionMark]:"%3F",[g.CharCode.Hash]:"%23",[g.CharCode.OpenSquareBracket]:"%5B",[g.CharCode.CloseSquareBracket]:"%5D",[g.CharCode.AtSign]:"%40",[g.CharCode.ExclamationMark]:"%21",[g.CharCode.DollarSign]:"%24",[g.CharCode.Ampersand]:"%26",[g.CharCode.SingleQuote]:"%27",[g.CharCode.OpenParen]:"%28",[g.CharCode.CloseParen]:"%29",[g.CharCode.Asterisk]:"%2A",[g.CharCode.Plus]:"%2B",[g.CharCode.Comma]:"%2C",[g.CharCode.Semicolon]:"%3B",[g.CharCode.Equals]:"%3D",[g.CharCode.Space]:"%20"};function C(s,r,_){let l,E=-1;for(let $=0;$<s.length;$++){const u=s.charCodeAt($);if(u>=g.CharCode.a&&u<=g.CharCode.z||u>=g.CharCode.A&&u<=g.CharCode.Z||u>=g.CharCode.Digit0&&u<=g.CharCode.Digit9||u===g.CharCode.Dash||u===g.CharCode.Period||u===g.CharCode.Underline||u===g.CharCode.Tilde||r&&u===g.CharCode.Slash||_&&u===g.CharCode.OpenSquareBracket||_&&u===g.CharCode.CloseSquareBracket||_&&u===g.CharCode.Colon)E!==-1&&(l+=encodeURIComponent(s.substring(E,$)),E=-1),l!==void 0&&(l+=s.charAt($));else{l===void 0&&(l=s.substr(0,$));const T=K[u];T!==void 0?(E!==-1&&(l+=encodeURIComponent(s.substring(E,$)),E=-1),l+=T):E===-1&&(E=$)}}return E!==-1&&(l+=encodeURIComponent(s.substring(E))),l!==void 0?l:s}function W(s){let r;for(let _=0;_<s.length;_++){const l=s.charCodeAt(_);l===g.CharCode.Hash||l===g.CharCode.QuestionMark?(r===void 0&&(r=s.substr(0,_)),r+=K[l]):r!==void 0&&(r+=s[_])}return r!==void 0?r:s}function c(s,r){let _;return s.authority&&s.path.length>1&&s.scheme==="file"?_=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===g.CharCode.Slash&&(s.path.charCodeAt(1)>=g.CharCode.A&&s.path.charCodeAt(1)<=g.CharCode.Z||s.path.charCodeAt(1)>=g.CharCode.a&&s.path.charCodeAt(1)<=g.CharCode.z)&&s.path.charCodeAt(2)===g.CharCode.Colon?r?_=s.path.substr(1):_=s.path[1].toLowerCase()+s.path.substr(2):_=s.path,R.$j&&(_=_.replace(/\//g,"\\")),_}function n(s,r){const _=r?W:C;let l="",{scheme:E,authority:$,path:u,query:T,fragment:F}=s;if(E&&(l+=E,l+=":"),($||E==="file")&&(l+=J,l+=J),$){let N=$.indexOf("@");if(N!==-1){const v=$.substr(0,N);$=$.substr(N+1),N=v.lastIndexOf(":"),N===-1?l+=_(v,!1,!1):(l+=_(v.substr(0,N),!1,!1),l+=":",l+=_(v.substr(N+1),!1,!0)),l+="@"}$=$.toLowerCase(),N=$.lastIndexOf(":"),N===-1?l+=_($,!1,!0):(l+=_($.substr(0,N),!1,!0),l+=$.substr(N))}if(u){if(u.length>=3&&u.charCodeAt(0)===g.CharCode.Slash&&u.charCodeAt(2)===g.CharCode.Colon){const N=u.charCodeAt(1);N>=g.CharCode.A&&N<=g.CharCode.Z&&(u=`/${String.fromCharCode(N+32)}:${u.substr(3)}`)}else if(u.length>=2&&u.charCodeAt(1)===g.CharCode.Colon){const N=u.charCodeAt(0);N>=g.CharCode.A&&N<=g.CharCode.Z&&(u=`${String.fromCharCode(N+32)}:${u.substr(2)}`)}l+=_(u,!0,!1)}return T&&(l+="?",l+=_(T,!1,!1)),F&&(l+="#",l+=r?F:C(F,!1,!1)),l}function i(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+i(s.substr(3)):s}}const f=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function d(s){return s.match(f)?s.replace(f,r=>i(r)):s}}),define(h1[24],d1([0,1,2,3,9,23,7]),function(t1,t,g,e,q,R,n1){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$3g=t.$2g=t.$1g=t.$Zg=t.$Yg=t.$Xg=t.$Vg=t.$Ug=t.$Tg=t.Schemas=void 0,t.$Rg=S,t.$Sg=D,t.$Wg=Y,g=k1(g),e=k1(e),n1=k1(n1);var H;(function(L){L.inMemory="inmemory",L.vscode="vscode",L.internal="private",L.walkThrough="walkThrough",L.walkThroughSnippet="walkThroughSnippet",L.http="http",L.https="https",L.file="file",L.mailto="mailto",L.untitled="untitled",L.data="data",L.command="command",L.vscodeRemote="vscode-remote",L.vscodeRemoteResource="vscode-remote-resource",L.vscodeManagedRemoteResource="vscode-managed-remote-resource",L.vscodeUserData="vscode-userdata",L.vscodeCustomEditor="vscode-custom-editor",L.vscodeNotebookCell="vscode-notebook-cell",L.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",L.vscodeNotebookCellMetadataDiff="vscode-notebook-cell-metadata-diff",L.vscodeNotebookCellOutput="vscode-notebook-cell-output",L.vscodeNotebookCellOutputDiff="vscode-notebook-cell-output-diff",L.vscodeInteractiveInput="vscode-interactive-input",L.vscodeSettings="vscode-settings",L.vscodeWorkspaceTrust="vscode-workspace-trust",L.vscodeTerminal="vscode-terminal",L.vscodeChatCodeBlock="vscode-chat-code-block",L.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",L.vscodeChatSesssion="vscode-chat-editor",L.webviewPanel="webview-panel",L.vscodeWebview="vscode-webview",L.extension="extension",L.vscodeFileResource="vscode-file",L.tmp="tmp",L.vsls="vsls",L.vscodeSourceControl="vscode-scm",L.commentsInput="comment",L.codeSetting="code-setting",L.outputChannel="output"})(H||(t.Schemas=H={}));function S(L,w){return R.URI.isUri(L)?(0,q.$If)(L.scheme,w):(0,q.$Jf)(L,w+":")}function D(L,...w){return w.some(U=>S(L,U))}t.$Tg="vscode-tkn",t.$Ug="tkn";class k{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(w){this.d=w}setDelegate(w){this.e=w}setServerRootPath(w,U){this.f=Y(w,U)}getServerRootPath(){return this.f}get g(){return n1.$jc.join(this.f,H.vscodeRemoteResource)}set(w,U,P){this.a[w]=U,this.b[w]=P}setConnectionToken(w,U){this.c[w]=U}getPreferredWebSchema(){return this.d}rewrite(w){if(this.e)try{return this.e(w)}catch(W){return g.$2(W),w}const U=w.authority;let P=this.a[U];P&&P.indexOf(":")!==-1&&P.indexOf("[")===-1&&(P=`[${P}]`);const j=this.b[U],K=this.c[U];let C=`path=${encodeURIComponent(w.path)}`;return typeof K=="string"&&(C+=`&${t.$Ug}=${encodeURIComponent(K)}`),R.URI.from({scheme:e.$p?this.d:H.vscodeRemoteResource,authority:`${P}:${j}`,path:this.g,query:C})}}t.$Vg=new k;function Y(L,w){return n1.$jc.join(w??"/",`${L.quality??"oss"}-${L.commit??"dev"}`)}t.$Xg="vs/../../extensions",t.$Yg="vs/../../node_modules",t.$Zg="vs/../../node_modules.asar",t.$1g="vs/../../node_modules.asar.unpacked",t.$2g="vscode-app";class M{static{this.a=t.$2g}asBrowserUri(w){const U=this.b(w,t1);return this.uriToBrowserUri(U)}uriToBrowserUri(w){return w.scheme===H.vscodeRemote?t.$Vg.rewrite(w):w.scheme===H.file&&(e.$n||e.$r===`${H.vscodeFileResource}://${M.a}`)?w.with({scheme:H.vscodeFileResource,authority:w.authority||M.a,query:null,fragment:null}):w}asFileUri(w){const U=this.b(w,t1);return this.uriToFileUri(U)}uriToFileUri(w){return w.scheme===H.vscodeFileResource?w.with({scheme:H.file,authority:w.authority!==M.a?w.authority:null,query:null,fragment:null}):w}b(w,U){if(R.URI.isUri(w))return w;if(globalThis._VSCODE_FILE_ROOT){const P=globalThis._VSCODE_FILE_ROOT;if(/^\w[\w\d+.-]*:\/\//.test(P))return R.URI.joinPath(R.URI.parse(P,!0),w);const j=n1.$mc(P,w);return R.URI.file(j)}return R.URI.parse(U.toUrl(w))}}t.$3g=new M;var J;(function(L){const w=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);L.CoopAndCoep=Object.freeze(w.get("3"));const U="vscode-coi";function P(K){let C;typeof K=="string"?C=new URL(K).searchParams:K instanceof URL?C=K.searchParams:R.URI.isUri(K)&&(C=new URL(K.toString(!0)).searchParams);const W=C?.get(U);if(W)return w.get(W)}L.getHeadersFromQuery=P;function j(K,C,W){if(!globalThis.crossOriginIsolated)return;const c=C&&W?"3":W?"2":"1";K instanceof URLSearchParams?K.set(U,c):K[U]=c}L.addSearchParam=j})(J||(t.COI=J={}))}),define(h1[25],d1([0,1,4,2,8,6,24,3,9]),function(t1,t,g,e,q,R,n1,H,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SimpleWorkerServer=t.SimpleWorkerClient=void 0,t.logOnceWebWorkerWarning=J,t.create=f,S=k1(S);const D=!1,k="default",Y="$initialize";let M=!1;function J(d){H.$p&&(M||(M=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(d.message))}var L;(function(d){d[d.Request=0]="Request",d[d.Reply=1]="Reply",d[d.SubscribeEvent=2]="SubscribeEvent",d[d.Event=3]="Event",d[d.UnsubscribeEvent=4]="UnsubscribeEvent"})(L||(L={}));class w{constructor(s,r,_,l,E){this.vsWorker=s,this.req=r,this.channel=_,this.method=l,this.args=E,this.type=L.Request}}class U{constructor(s,r,_,l){this.vsWorker=s,this.seq=r,this.res=_,this.err=l,this.type=L.Reply}}class P{constructor(s,r,_,l,E){this.vsWorker=s,this.req=r,this.channel=_,this.eventName=l,this.arg=E,this.type=L.SubscribeEvent}}class j{constructor(s,r,_){this.vsWorker=s,this.req=r,this.event=_,this.type=L.Event}}class K{constructor(s,r){this.vsWorker=s,this.req=r,this.type=L.UnsubscribeEvent}}class C{constructor(s){this.a=-1,this.g=s,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(s){this.a=s}sendMessage(s,r,_){const l=String(++this.b);return new Promise((E,$)=>{this.c[l]={resolve:E,reject:$},this.o(new w(this.a,l,s,r,_))})}listen(s,r,_){let l=null;const E=new q.$oe({onWillAddFirstListener:()=>{l=String(++this.b),this.d.set(l,E),this.o(new P(this.a,l,s,r,_))},onDidRemoveLastListener:()=>{this.d.delete(l),this.o(new K(this.a,l)),l=null}});return E.event}handleMessage(s){!s||!s.vsWorker||this.a!==-1&&s.vsWorker!==this.a||this.h(s)}createProxyToRemoteChannel(s,r){const _={get:(l,E)=>(typeof E=="string"&&!l[E]&&(n(E)?l[E]=$=>this.listen(s,E,$):c(E)?l[E]=this.listen(s,E,void 0):E.charCodeAt(0)===g.CharCode.DollarSign&&(l[E]=async(...$)=>(await r?.(),this.sendMessage(s,E,$)))),l[E])};return new Proxy(Object.create(null),_)}h(s){switch(s.type){case L.Reply:return this.j(s);case L.Request:return this.k(s);case L.SubscribeEvent:return this.l(s);case L.Event:return this.m(s);case L.UnsubscribeEvent:return this.n(s)}}j(s){if(!this.c[s.seq]){console.warn("Got reply to unknown seq");return}const r=this.c[s.seq];if(delete this.c[s.seq],s.err){let _=s.err;s.err.$isError&&(_=new Error,_.name=s.err.name,_.message=s.err.message,_.stack=s.err.stack),r.reject(_);return}r.resolve(s.res)}k(s){const r=s.req;this.g.handleMessage(s.channel,s.method,s.args).then(l=>{this.o(new U(this.a,r,l,void 0))},l=>{l.detail instanceof Error&&(l.detail=(0,e.$4)(l.detail)),this.o(new U(this.a,r,void 0,(0,e.$4)(l)))})}l(s){const r=s.req,_=this.g.handleEvent(s.channel,s.eventName,s.arg)(l=>{this.o(new j(this.a,r,l))});this.f.set(r,_)}m(s){if(!this.d.has(s.req)){console.warn("Got event for unknown req");return}this.d.get(s.req).fire(s.event)}n(s){if(!this.f.has(s.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(s.req).dispose(),this.f.delete(s.req)}o(s){const r=[];if(s.type===L.Request)for(let _=0;_<s.args.length;_++)s.args[_]instanceof ArrayBuffer&&r.push(s.args[_]);else s.type===L.Reply&&s.res instanceof ArrayBuffer&&r.push(s.res);this.g.sendMessage(s,r)}}class W extends R.$Xc{constructor(s,r){super(),this.f=new Map,this.g=new Map,this.a=this.B(s.create({amdModuleId:"vs/base/common/worker/simpleWorker",esmModuleLocation:r.esmModuleLocation,label:r.label},E=>{this.c.handleMessage(E)},E=>{(0,e.$2)(E)})),this.c=new C({sendMessage:(E,$)=>{this.a.postMessage(E,$)},handleMessage:(E,$,u)=>this.h(E,$,u),handleEvent:(E,$,u)=>this.j(E,$,u)}),this.c.setWorkerId(this.a.getId());let _=null;const l=globalThis.require;typeof l<"u"&&typeof l.getConfig=="function"?_=l.getConfig():typeof globalThis.requirejs<"u"&&(_=globalThis.requirejs.s.contexts._.config),this.b=this.c.sendMessage(k,Y,[this.a.getId(),JSON.parse(JSON.stringify(_)),r.amdModuleId]),this.proxy=this.c.createProxyToRemoteChannel(k,async()=>{await this.b}),this.b.catch(E=>{this.m("Worker failed to load "+r.amdModuleId,E)})}h(s,r,_){const l=this.f.get(s);if(!l)return Promise.reject(new Error(`Missing channel ${s} on main thread`));if(typeof l[r]!="function")return Promise.reject(new Error(`Missing method ${r} on main thread channel ${s}`));try{return Promise.resolve(l[r].apply(l,_))}catch(E){return Promise.reject(E)}}j(s,r,_){const l=this.f.get(s);if(!l)throw new Error(`Missing channel ${s} on main thread`);if(n(r)){const E=l[r].call(l,_);if(typeof E!="function")throw new Error(`Missing dynamic event ${r} on main thread channel ${s}.`);return E}if(c(r)){const E=l[r];if(typeof E!="function")throw new Error(`Missing event ${r} on main thread channel ${s}.`);return E}throw new Error(`Malformed event name ${r}`)}setChannel(s,r){this.f.set(s,r)}getChannel(s){if(!this.g.has(s)){const r=this.c.createProxyToRemoteChannel(s,async()=>{await this.b});this.g.set(s,r)}return this.g.get(s)}m(s,r){console.error(s),console.info(r)}}t.SimpleWorkerClient=W;function c(d){return d[0]==="o"&&d[1]==="n"&&S.$Hf(d.charCodeAt(2))}function n(d){return/^onDynamic/.test(d)&&S.$Hf(d.charCodeAt(9))}class i{constructor(s,r){this.d=new Map,this.f=new Map,this.a=r,this.b=null,this.c=new C({sendMessage:(_,l)=>{s(_,l)},handleMessage:(_,l,E)=>this.g(_,l,E),handleEvent:(_,l,E)=>this.h(_,l,E)})}onmessage(s){this.c.handleMessage(s)}g(s,r,_){if(s===k&&r===Y)return this.j(_[0],_[1],_[2]);const l=s===k?this.b:this.d.get(s);if(!l)return Promise.reject(new Error(`Missing channel ${s} on worker thread`));if(typeof l[r]!="function")return Promise.reject(new Error(`Missing method ${r} on worker thread channel ${s}`));try{return Promise.resolve(l[r].apply(l,_))}catch(E){return Promise.reject(E)}}h(s,r,_){const l=s===k?this.b:this.d.get(s);if(!l)throw new Error(`Missing channel ${s} on worker thread`);if(n(r)){const E=l[r].call(l,_);if(typeof E!="function")throw new Error(`Missing dynamic event ${r} on request handler.`);return E}if(c(r)){const E=l[r];if(typeof E!="function")throw new Error(`Missing event ${r} on request handler.`);return E}throw new Error(`Malformed event name ${r}`)}setChannel(s,r){this.d.set(s,r)}getChannel(s){if(!this.f.has(s)){const r=this.c.createProxyToRemoteChannel(s);this.f.set(s,r)}return this.f.get(s)}async j(s,r,_){if(this.c.setWorkerId(s),this.a){this.b=this.a(this);return}if(r&&(typeof r.baseUrl<"u"&&delete r.baseUrl,typeof r.paths<"u"&&typeof r.paths.vs<"u"&&delete r.paths.vs,typeof r.trustedTypesPolicy<"u"&&delete r.trustedTypesPolicy,r.catchError=!0,globalThis.require.config(r)),D){const l=n1.$3g.asBrowserUri(`${_}.js`).toString(!0);return new Promise((E,$)=>{t1([`${l}`],E,$)}).then(k1).then(E=>{if(this.b=E.create(this),!this.b)throw new Error("No RequestHandler!")})}return new Promise((l,E)=>{(globalThis.require||t1)([_],u=>{if(this.b=u.create(this),!this.b){E(new Error("No RequestHandler!"));return}l()},E)})}}t.SimpleWorkerServer=i;function f(d){return new i(d,null)}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/c2aa3c4625ed4b46448fa546ac5f2e93b0757718/core/vs/base/common/worker/simpleWorker.js.map
