/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls","vs/base/common/network","vs/base/common/types","electron","vs/platform/files/common/files","vs/base/common/errors","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/platform/environment/electron-main/environmentMainService","vs/base/common/arrays","vs/base/common/cancellation","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/base/common/strings","fs","os","vs/platform/product/common/productService","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/map","vs/base/common/extpath","vs/base/common/uuid","vs/platform/state/node/state","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/base/common/process","vs/base/common/objects","vs/base/common/charCode","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","child_process","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","vs/base/common/labels","vs/platform/request/common/request","vs/platform/update/common/update","vs/platform/window/common/window","vs/platform/window/electron-main/window","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/decorators","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/stopwatch","vs/base/common/ternarySearchTree","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/storage/common/storage","vs/platform/utilityProcess/electron-main/utilityProcess","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/amd","vs/base/common/lazy","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/protocol/electron-main/protocol","vs/platform/remote/common/remoteHosts","vs/platform/terminal/common/terminal","vs/platform/theme/electron-main/themeMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/common/processes","vs/base/common/codicons","vs/base/common/severity","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/cssDev/node/cssDevService","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/marshallingIds","crypto","vs/base/node/id","net","vs/base/node/processes","path","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/node/unc","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/codiconsUtil","vs/base/common/themables","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ports","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagement","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/native/electron-main/auth","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonSchema","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/uint","vs/base/common/console","vs/amdX","vs/base/common/uriIpc","vs/base/node/crypto","vs/base/node/macAddress","util","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/base/common/date","vs/base/common/jsonErrorMessages","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/issue/electron-main/processMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","string_decoder","vs/base/common/jsonc","vs/code/electron-main/main"],ue=function(K){for(var e=[],i=0,r=K.length;i<r;i++)e[i]=le[K[i]];return e};define(le[67],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=e.LoaderEventType=e.$U=e.$T=void 0,e.$T=!1,e.$U=!0;var i;(function(v){v[v.LoaderAvailable=1]="LoaderAvailable",v[v.BeginLoadingScript=10]="BeginLoadingScript",v[v.EndLoadingScriptOK=11]="EndLoadingScriptOK",v[v.EndLoadingScriptError=12]="EndLoadingScriptError",v[v.BeginInvokeFactory=21]="BeginInvokeFactory",v[v.EndInvokeFactory=22]="EndInvokeFactory",v[v.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",v[v.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",v[v.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",v[v.NodeEndNativeRequire=34]="NodeEndNativeRequire",v[v.CachedDataFound=60]="CachedDataFound",v[v.CachedDataMissed=61]="CachedDataMissed",v[v.CachedDataRejected=62]="CachedDataRejected",v[v.CachedDataCreated=63]="CachedDataCreated"})(i||(e.LoaderEventType=i={}));class r{static get(){const A=new Map,O=new Map,I=new Map,b=new Map;function l(d,f){d.has(f.detail)||d.set(f.detail,-f.timestamp)}function m(d,f){const y=d.get(f.detail);y&&(y>=0||d.set(f.detail,y+f.timestamp))}let u=[];typeof K=="function"&&typeof K.getStats=="function"&&(u=K.getStats().slice(0).sort((d,f)=>d.timestamp-f.timestamp));for(const d of u)switch(d.type){case i.BeginLoadingScript:l(A,d);break;case i.EndLoadingScriptOK:case i.EndLoadingScriptError:m(A,d);break;case i.BeginInvokeFactory:l(O,d);break;case i.EndInvokeFactory:m(O,d);break;case i.NodeBeginNativeRequire:l(I,d);break;case i.NodeEndNativeRequire:m(I,d);break;case i.NodeBeginEvaluatingScript:l(b,d);break;case i.NodeEndEvaluatingScript:m(b,d);break}let $=0;I.forEach(d=>$+=d);function p(d){const f=[];return d.forEach((y,k)=>f.push([k,y])),f}return{amdLoad:p(A),amdInvoke:p(O),nodeRequire:p(I),nodeEval:p(b),nodeRequireTotal:$}}static toMarkdownTable(A,O){let I="";const b=[];return A.forEach((l,m)=>{b[m]=l.length}),O.forEach(l=>{l.forEach((m,u)=>{typeof m>"u"&&(m=l[u]="-");const $=m.toString().length;b[u]=Math.max($,b[u])})}),A.forEach((l,m)=>{I+=`| ${l+" ".repeat(b[m]-l.toString().length)} `}),I+=`|
`,A.forEach((l,m)=>{I+=`| ${"-".repeat(b[m])} `}),I+=`|
`,O.forEach(l=>{l.forEach((m,u)=>{typeof m<"u"&&(I+=`| ${m+" ".repeat(b[u]-m.toString().length)} `)}),I+=`|
`}),I}}e.$V=r}),define(le[140],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ob=void 0,e.$hb=i,e.$ib=r,e.$jb=v,e.$kb=A,e.$lb=O,e.$mb=I,e.$nb=b,e.$pb=m,e.$qb=u,e.$rb=$,e.$sb=p,e.$tb=d;function i(f,y){const k=r(f,y);if(k!==-1)return f[k]}function r(f,y,k=f.length-1){for(let g=k;g>=0;g--){const E=f[g];if(y(E))return g}return-1}function v(f,y){const k=A(f,y);return k===-1?void 0:f[k]}function A(f,y,k=0,g=f.length){let E=k,S=g;for(;E<S;){const s=Math.floor((E+S)/2);y(f[s])?E=s+1:S=s}return E-1}function O(f,y){const k=I(f,y);return k===f.length?void 0:f[k]}function I(f,y,k=0,g=f.length){let E=k,S=g;for(;E<S;){const s=Math.floor((E+S)/2);y(f[s])?S=s:E=s+1}return E}function b(f,y,k=0,g=f.length){const E=I(f,y,k,g);return E===f.length?-1:E}class l{static{this.assertInvariants=!1}constructor(y){this.e=y,this.c=0}findLastMonotonous(y){if(l.assertInvariants){if(this.d){for(const g of this.e)if(this.d(g)&&!y(g))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=y}const k=A(this.e,y,this.c);return this.c=k+1,k===-1?void 0:this.e[k]}}e.$ob=l;function m(f,y){if(f.length===0)return;let k=f[0];for(let g=1;g<f.length;g++){const E=f[g];y(E,k)>0&&(k=E)}return k}function u(f,y){if(f.length===0)return;let k=f[0];for(let g=1;g<f.length;g++){const E=f[g];y(E,k)>=0&&(k=E)}return k}function $(f,y){return m(f,(k,g)=>-y(k,g))}function p(f,y){if(f.length===0)return-1;let k=0;for(let g=1;g<f.length;g++){const E=f[g];y(E,f[k])>0&&(k=g)}return k}function d(f,y){for(const k of f){const g=y(k);if(g!==void 0)return g}}}),define(le[39],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var i;(function(r){r[r.Null=0]="Null",r[r.Backspace=8]="Backspace",r[r.Tab=9]="Tab",r[r.LineFeed=10]="LineFeed",r[r.CarriageReturn=13]="CarriageReturn",r[r.Space=32]="Space",r[r.ExclamationMark=33]="ExclamationMark",r[r.DoubleQuote=34]="DoubleQuote",r[r.Hash=35]="Hash",r[r.DollarSign=36]="DollarSign",r[r.PercentSign=37]="PercentSign",r[r.Ampersand=38]="Ampersand",r[r.SingleQuote=39]="SingleQuote",r[r.OpenParen=40]="OpenParen",r[r.CloseParen=41]="CloseParen",r[r.Asterisk=42]="Asterisk",r[r.Plus=43]="Plus",r[r.Comma=44]="Comma",r[r.Dash=45]="Dash",r[r.Period=46]="Period",r[r.Slash=47]="Slash",r[r.Digit0=48]="Digit0",r[r.Digit1=49]="Digit1",r[r.Digit2=50]="Digit2",r[r.Digit3=51]="Digit3",r[r.Digit4=52]="Digit4",r[r.Digit5=53]="Digit5",r[r.Digit6=54]="Digit6",r[r.Digit7=55]="Digit7",r[r.Digit8=56]="Digit8",r[r.Digit9=57]="Digit9",r[r.Colon=58]="Colon",r[r.Semicolon=59]="Semicolon",r[r.LessThan=60]="LessThan",r[r.Equals=61]="Equals",r[r.GreaterThan=62]="GreaterThan",r[r.QuestionMark=63]="QuestionMark",r[r.AtSign=64]="AtSign",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.OpenSquareBracket=91]="OpenSquareBracket",r[r.Backslash=92]="Backslash",r[r.CloseSquareBracket=93]="CloseSquareBracket",r[r.Caret=94]="Caret",r[r.Underline=95]="Underline",r[r.BackTick=96]="BackTick",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.OpenCurlyBrace=123]="OpenCurlyBrace",r[r.Pipe=124]="Pipe",r[r.CloseCurlyBrace=125]="CloseCurlyBrace",r[r.Tilde=126]="Tilde",r[r.NoBreakSpace=160]="NoBreakSpace",r[r.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",r[r.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",r[r.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",r[r.U_Combining_Tilde=771]="U_Combining_Tilde",r[r.U_Combining_Macron=772]="U_Combining_Macron",r[r.U_Combining_Overline=773]="U_Combining_Overline",r[r.U_Combining_Breve=774]="U_Combining_Breve",r[r.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",r[r.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",r[r.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",r[r.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",r[r.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",r[r.U_Combining_Caron=780]="U_Combining_Caron",r[r.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",r[r.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",r[r.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",r[r.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",r[r.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",r[r.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",r[r.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",r[r.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",r[r.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",r[r.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",r[r.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",r[r.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",r[r.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",r[r.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",r[r.U_Combining_Horn=795]="U_Combining_Horn",r[r.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",r[r.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",r[r.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",r[r.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",r[r.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",r[r.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",r[r.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",r[r.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",r[r.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",r[r.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",r[r.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",r[r.U_Combining_Cedilla=807]="U_Combining_Cedilla",r[r.U_Combining_Ogonek=808]="U_Combining_Ogonek",r[r.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",r[r.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",r[r.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",r[r.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",r[r.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",r[r.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",r[r.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",r[r.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",r[r.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",r[r.U_Combining_Low_Line=818]="U_Combining_Low_Line",r[r.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",r[r.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",r[r.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",r[r.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",r[r.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",r[r.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",r[r.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",r[r.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",r[r.U_Combining_Square_Below=827]="U_Combining_Square_Below",r[r.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",r[r.U_Combining_X_Above=829]="U_Combining_X_Above",r[r.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",r[r.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",r[r.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",r[r.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",r[r.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",r[r.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",r[r.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",r[r.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",r[r.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",r[r.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",r[r.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",r[r.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",r[r.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",r[r.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",r[r.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",r[r.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",r[r.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",r[r.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",r[r.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",r[r.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",r[r.U_Combining_Fermata=850]="U_Combining_Fermata",r[r.U_Combining_X_Below=851]="U_Combining_X_Below",r[r.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",r[r.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",r[r.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",r[r.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",r[r.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",r[r.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",r[r.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",r[r.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",r[r.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",r[r.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",r[r.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",r[r.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",r[r.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",r[r.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",r[r.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",r[r.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",r[r.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",r[r.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",r[r.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",r[r.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",r[r.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",r[r.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",r[r.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",r[r.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",r[r.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",r[r.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",r[r.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",r[r.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",r[r.LINE_SEPARATOR=8232]="LINE_SEPARATOR",r[r.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",r[r.NEXT_LINE=133]="NEXT_LINE",r[r.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",r[r.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",r[r.U_DIAERESIS=168]="U_DIAERESIS",r[r.U_MACRON=175]="U_MACRON",r[r.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",r[r.U_CEDILLA=184]="U_CEDILLA",r[r.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",r[r.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",r[r.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",r[r.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",r[r.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",r[r.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",r[r.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",r[r.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",r[r.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",r[r.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",r[r.U_BREVE=728]="U_BREVE",r[r.U_DOT_ABOVE=729]="U_DOT_ABOVE",r[r.U_RING_ABOVE=730]="U_RING_ABOVE",r[r.U_OGONEK=731]="U_OGONEK",r[r.U_SMALL_TILDE=732]="U_SMALL_TILDE",r[r.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",r[r.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",r[r.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",r[r.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",r[r.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",r[r.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",r[r.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",r[r.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",r[r.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",r[r.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",r[r.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",r[r.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",r[r.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",r[r.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",r[r.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",r[r.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",r[r.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",r[r.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",r[r.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",r[r.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",r[r.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",r[r.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",r[r.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",r[r.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",r[r.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",r[r.U_GREEK_TONOS=900]="U_GREEK_TONOS",r[r.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",r[r.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",r[r.U_GREEK_PSILI=8127]="U_GREEK_PSILI",r[r.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",r[r.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",r[r.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",r[r.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",r[r.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",r[r.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",r[r.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",r[r.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",r[r.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",r[r.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",r[r.U_GREEK_VARIA=8175]="U_GREEK_VARIA",r[r.U_GREEK_OXIA=8189]="U_GREEK_OXIA",r[r.U_GREEK_DASIA=8190]="U_GREEK_DASIA",r[r.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",r[r.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",r[r.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",r[r.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",r[r.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",r[r.U_OVERLINE=8254]="U_OVERLINE",r[r.UTF8_BOM=65279]="UTF8_BOM",r[r.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",r[r.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(i||(e.CharCode=i={}))}),define(le[141],ue([0,1]),function(K,e){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$g=void 0,e.$c=r,e.$d=v,e.$e=A,e.$f=O;function r(b,l){const m=Object.create(null);for(const u of b){const $=l(u);let p=m[$];p||(p=m[$]=[]),p.push(u)}return m}function v(b,l){const m=[],u=[];for(const $ of b)l.has($)||m.push($);for(const $ of l)b.has($)||u.push($);return{removed:m,added:u}}function A(b,l){const m=[],u=[];for(const[$,p]of b)l.has($)||m.push(p);for(const[$,p]of l)b.has($)||u.push(p);return{removed:m,added:u}}function O(b,l){const m=new Set;for(const u of l)b.has(u)&&m.add(u);return m}class I{static{i=Symbol.toStringTag}constructor(l,m){this.b=m,this.a=new Map,this[i]="SetWithKey";for(const u of l)this.add(u)}get size(){return this.a.size}add(l){const m=this.b(l);return this.a.set(m,l),this}delete(l){return this.a.delete(this.b(l))}has(l){return this.a.has(this.b(l))}*entries(){for(const l of this.a.values())yield[l,l]}keys(){return this.values()}*values(){for(const l of this.a.values())yield l}clear(){this.a.clear()}forEach(l,m){this.a.forEach(u=>l.call(m,u,u,this))}[Symbol.iterator](){return this.values()}}e.$g=I}),define(le[142],ue([0,1,39]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uu=e.$tu=e.$su=e.$ru=void 0;function r(b,l){const m=Math.pow(10,l);return Math.round(b*m)/m}class v{constructor(l,m,u,$=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,l))|0,this.g=Math.min(255,Math.max(0,m))|0,this.b=Math.min(255,Math.max(0,u))|0,this.a=r(Math.max(Math.min(1,$),0),3)}static equals(l,m){return l.r===m.r&&l.g===m.g&&l.b===m.b&&l.a===m.a}}e.$ru=v;class A{constructor(l,m,u,$){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=r(Math.max(Math.min(1,m),0),3),this.l=r(Math.max(Math.min(1,u),0),3),this.a=r(Math.max(Math.min(1,$),0),3)}static equals(l,m){return l.h===m.h&&l.s===m.s&&l.l===m.l&&l.a===m.a}static fromRGBA(l){const m=l.r/255,u=l.g/255,$=l.b/255,p=l.a,d=Math.max(m,u,$),f=Math.min(m,u,$);let y=0,k=0;const g=(f+d)/2,E=d-f;if(E>0){switch(k=Math.min(g<=.5?E/(2*g):E/(2-2*g),1),d){case m:y=(u-$)/E+(u<$?6:0);break;case u:y=($-m)/E+2;break;case $:y=(m-u)/E+4;break}y*=60,y=Math.round(y)}return new A(y,k,g,p)}static i(l,m,u){return u<0&&(u+=1),u>1&&(u-=1),u<1/6?l+(m-l)*6*u:u<1/2?m:u<2/3?l+(m-l)*(2/3-u)*6:l}static toRGBA(l){const m=l.h/360,{s:u,l:$,a:p}=l;let d,f,y;if(u===0)d=f=y=$;else{const k=$<.5?$*(1+u):$+u-$*u,g=2*$-k;d=A.i(g,k,m+1/3),f=A.i(g,k,m),y=A.i(g,k,m-1/3)}return new v(Math.round(d*255),Math.round(f*255),Math.round(y*255),p)}}e.$su=A;class O{constructor(l,m,u,$){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=r(Math.max(Math.min(1,m),0),3),this.v=r(Math.max(Math.min(1,u),0),3),this.a=r(Math.max(Math.min(1,$),0),3)}static equals(l,m){return l.h===m.h&&l.s===m.s&&l.v===m.v&&l.a===m.a}static fromRGBA(l){const m=l.r/255,u=l.g/255,$=l.b/255,p=Math.max(m,u,$),d=Math.min(m,u,$),f=p-d,y=p===0?0:f/p;let k;return f===0?k=0:p===m?k=((u-$)/f%6+6)%6:p===u?k=($-m)/f+2:k=(m-u)/f+4,new O(Math.round(k*60),y,p,l.a)}static toRGBA(l){const{h:m,s:u,v:$,a:p}=l,d=$*u,f=d*(1-Math.abs(m/60%2-1)),y=$-d;let[k,g,E]=[0,0,0];return m<60?(k=d,g=f):m<120?(k=f,g=d):m<180?(g=d,E=f):m<240?(g=f,E=d):m<300?(k=f,E=d):m<=360&&(k=d,E=f),k=Math.round((k+y)*255),g=Math.round((g+y)*255),E=Math.round((E+y)*255),new v(k,g,E,p)}}e.$tu=O;class I{static fromHex(l){return I.Format.CSS.parseHex(l)||I.red}static equals(l,m){return!l&&!m?!0:!l||!m?!1:l.equals(m)}get hsla(){return this.i?this.i:A.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:O.fromRGBA(this.rgba)}constructor(l){if(l)if(l instanceof v)this.rgba=l;else if(l instanceof A)this.i=l,this.rgba=A.toRGBA(l);else if(l instanceof O)this.j=l,this.rgba=O.toRGBA(l);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(l){return!!l&&v.equals(this.rgba,l.rgba)&&A.equals(this.hsla,l.hsla)&&O.equals(this.hsva,l.hsva)}getRelativeLuminance(){const l=I.k(this.rgba.r),m=I.k(this.rgba.g),u=I.k(this.rgba.b),$=.2126*l+.7152*m+.0722*u;return r($,4)}static k(l){const m=l/255;return m<=.03928?m/12.92:Math.pow((m+.055)/1.055,2.4)}getContrastRatio(l){const m=this.getRelativeLuminance(),u=l.getRelativeLuminance();return m>u?(m+.05)/(u+.05):(u+.05)/(m+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(l){const m=this.getRelativeLuminance(),u=l.getRelativeLuminance();return m>u}isDarkerThan(l){const m=this.getRelativeLuminance(),u=l.getRelativeLuminance();return m<u}lighten(l){return new I(new A(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*l,this.hsla.a))}darken(l){return new I(new A(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*l,this.hsla.a))}transparent(l){const{r:m,g:u,b:$,a:p}=this.rgba;return new I(new v(m,u,$,p*l))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new I(new v(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(l){const m=l.rgba,u=this.rgba.a,$=m.a,p=u+$*(1-u);if(p<1e-6)return I.transparent;const d=this.rgba.r*u/p+m.r*$*(1-u)/p,f=this.rgba.g*u/p+m.g*$*(1-u)/p,y=this.rgba.b*u/p+m.b*$*(1-u)/p;return new I(new v(d,f,y,p))}makeOpaque(l){if(this.isOpaque()||l.rgba.a!==1)return this;const{r:m,g:u,b:$,a:p}=this.rgba;return new I(new v(l.rgba.r-p*(l.rgba.r-m),l.rgba.g-p*(l.rgba.g-u),l.rgba.b-p*(l.rgba.b-$),1))}flatten(...l){const m=l.reduceRight((u,$)=>I.o($,u));return I.o(this,m)}static o(l,m){const u=1-l.rgba.a;return new I(new v(u*m.rgba.r+l.rgba.a*l.rgba.r,u*m.rgba.g+l.rgba.a*l.rgba.g,u*m.rgba.b+l.rgba.a*l.rgba.b))}toString(){return this.u||(this.u=I.Format.CSS.format(this)),this.u}static getLighterColor(l,m,u){if(l.isLighterThan(m))return l;u=u||.5;const $=l.getRelativeLuminance(),p=m.getRelativeLuminance();return u=u*(p-$)/p,l.lighten(u)}static getDarkerColor(l,m,u){if(l.isDarkerThan(m))return l;u=u||.5;const $=l.getRelativeLuminance(),p=m.getRelativeLuminance();return u=u*($-p)/$,l.darken(u)}static{this.white=new I(new v(255,255,255,1))}static{this.black=new I(new v(0,0,0,1))}static{this.red=new I(new v(255,0,0,1))}static{this.blue=new I(new v(0,0,255,1))}static{this.green=new I(new v(0,255,0,1))}static{this.cyan=new I(new v(0,255,255,1))}static{this.lightgrey=new I(new v(211,211,211,1))}static{this.transparent=new I(new v(0,0,0,0))}}e.$uu=I,function(b){let l;(function(m){let u;(function($){function p(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:b.Format.CSS.formatRGBA(t)}$.formatRGB=p;function d(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}$.formatRGBA=d;function f(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:b.Format.CSS.formatHSLA(t)}$.formatHSL=f;function y(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}$.formatHSLA=y;function k(t){const o=t.toString(16);return o.length!==2?"0"+o:o}function g(t){return`#${k(t.rgba.r)}${k(t.rgba.g)}${k(t.rgba.b)}`}$.formatHex=g;function E(t,o=!1){return o&&t.rgba.a===1?b.Format.CSS.formatHex(t):`#${k(t.rgba.r)}${k(t.rgba.g)}${k(t.rgba.b)}${k(Math.round(t.rgba.a*255))}`}$.formatHexA=E;function S(t){return t.isOpaque()?b.Format.CSS.formatHex(t):b.Format.CSS.formatRGBA(t)}$.format=S;function s(t){const o=t.length;if(o===0||t.charCodeAt(0)!==i.CharCode.Hash)return null;if(o===7){const n=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),c=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),h=16*a(t.charCodeAt(5))+a(t.charCodeAt(6));return new b(new v(n,c,h,1))}if(o===9){const n=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),c=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),h=16*a(t.charCodeAt(5))+a(t.charCodeAt(6)),P=16*a(t.charCodeAt(7))+a(t.charCodeAt(8));return new b(new v(n,c,h,P/255))}if(o===4){const n=a(t.charCodeAt(1)),c=a(t.charCodeAt(2)),h=a(t.charCodeAt(3));return new b(new v(16*n+n,16*c+c,16*h+h))}if(o===5){const n=a(t.charCodeAt(1)),c=a(t.charCodeAt(2)),h=a(t.charCodeAt(3)),P=a(t.charCodeAt(4));return new b(new v(16*n+n,16*c+c,16*h+h,(16*P+P)/255))}return null}$.parseHex=s;function a(t){switch(t){case i.CharCode.Digit0:return 0;case i.CharCode.Digit1:return 1;case i.CharCode.Digit2:return 2;case i.CharCode.Digit3:return 3;case i.CharCode.Digit4:return 4;case i.CharCode.Digit5:return 5;case i.CharCode.Digit6:return 6;case i.CharCode.Digit7:return 7;case i.CharCode.Digit8:return 8;case i.CharCode.Digit9:return 9;case i.CharCode.a:return 10;case i.CharCode.A:return 10;case i.CharCode.b:return 11;case i.CharCode.B:return 11;case i.CharCode.c:return 12;case i.CharCode.C:return 12;case i.CharCode.d:return 13;case i.CharCode.D:return 13;case i.CharCode.e:return 14;case i.CharCode.E:return 14;case i.CharCode.f:return 15;case i.CharCode.F:return 15}return 0}})(u=m.CSS||(m.CSS={}))})(l=b.Format||(b.Format={}))}(I||(e.$uu=I={}))}),define(le[54],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=r,e.$bi=v,e.$ci=A;function i(O){return(I,b,l)=>{let m=null,u=null;if(typeof l.value=="function"?(m="value",u=l.value):typeof l.get=="function"&&(m="get",u=l.get),!u)throw new Error("not supported");l[m]=O(u,b)}}function r(O,I,b){let l=null,m=null;if(typeof b.value=="function"?(l="value",m=b.value,m.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(l="get",m=b.get),!m)throw new Error("not supported");const u=`$memoize$${I}`;b[l]=function(...$){return this.hasOwnProperty(u)||Object.defineProperty(this,u,{configurable:!1,enumerable:!1,writable:!1,value:m.apply(this,$)}),this[u]}}function v(O,I,b){return i((l,m)=>{const u=`$debounce$${m}`,$=`$debounce$result$${m}`;return function(...p){this[$]||(this[$]=b?b():void 0),clearTimeout(this[u]),I&&(this[$]=I(this[$],...p),p=[this[$]]),this[u]=setTimeout(()=>{l.apply(this,p),this[$]=b?b():void 0},O)}})}function A(O,I,b){return i((l,m)=>{const u=`$throttle$timer$${m}`,$=`$throttle$result$${m}`,p=`$throttle$lastRun$${m}`,d=`$throttle$pending$${m}`;return function(...f){if(this[$]||(this[$]=b?b():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),I&&(this[$]=I(this[$],...f)),this[d])return;const y=this[p]+O;y<=Date.now()?(this[p]=Date.now(),l.apply(this,[this[$]]),this[$]=b?b():void 0):(this[d]=!0,this[u]=setTimeout(()=>{this[d]=!1,this[p]=Date.now(),l.apply(this,[this[$]]),this[$]=b?b():void 0},y-Date.now()))}})}}),define(le[15],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eb=e.$db=e.$cb=e.$bb=e.$ab=e.$$=e.$7=e.$Y=e.$X=void 0,e.setUnexpectedErrorHandler=r,e.$1=v,e.$2=A,e.$3=O,e.$4=I,e.$5=b,e.$6=m,e.$8=$,e.$9=p,e.$0=d,e.$_=y;class i{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?S.isErrorNoTelemetry(t)?new S(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(o=>{o(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$X=i,e.$Y=new i;function r(a){e.$Y.setUnexpectedErrorHandler(a)}function v(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function A(a){m(a)||e.$Y.onUnexpectedError(a)}function O(a){m(a)||e.$Y.onUnexpectedExternalError(a)}function I(a){if(a instanceof Error){const{name:t,message:o}=a,n=a.stacktrace||a.stack;return{$isError:!0,name:t,message:o,stack:n,noTelemetry:S.isErrorNoTelemetry(a)}}return a}function b(a){let t;return a.noTelemetry?t=new S:(t=new Error,t.name=a.name),t.message=a.message,t.stack=a.stack,t}const l="Canceled";function m(a){return a instanceof u?!0:a instanceof Error&&a.name===l&&a.message===l}class u extends Error{constructor(){super(l),this.name=this.message}}e.$7=u;function $(){const a=new Error(l);return a.name=a.message,a}function p(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}function d(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}class f extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$$=f;function y(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}class k extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$ab=k;class g extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$bb=g;class E extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$cb=E;class S extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof S)return t;const o=new S;return o.message=t.message,o.stack=t.stack,o}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$db=S;class s extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,s.prototype)}}e.$eb=s}),define(le[21],ue([0,1,15,140]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cc=e.$bc=e.$ac=e.$$b=e.$0b=e.CompareResult=void 0,e.$ub=v,e.$vb=A,e.$wb=O,e.$xb=I,e.$yb=b,e.$zb=l,e.$Ab=m,e.$Bb=u,e.$Cb=$,e.$Db=p,e.$Eb=d,e.$Fb=f,e.$Gb=y,e.top=k,e.$Ib=g,e.$Jb=S,e.$Kb=s,e.$Lb=a,e.$Mb=t,e.$Nb=o,e.$Ob=n,e.$Pb=c,e.$Qb=h,e.$Rb=P,e.$Sb=w,e.$Tb=D,e.$Ub=L,e.$Vb=R,e.$Wb=T,e.$Xb=j,e.$Yb=G,e.$Zb=q,e.$1b=Q,e.$2b=de,e.$3b=V,e.$4b=Y,e.$5b=B,e.$6b=_,e.$7b=C,e.$8b=H,e.$9b=ne,e.$_b=oe,e.$dc=U;function v(N,ie=0){return N[N.length-(1+ie)]}function A(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}function O(N,ie,X=(z,te)=>z===te){if(N===ie)return!0;if(!N||!ie||N.length!==ie.length)return!1;for(let z=0,te=N.length;z<te;z++)if(!X(N[z],ie[z]))return!1;return!0}function I(N,ie){const X=N.length-1;ie<X&&(N[ie]=N[X]),N.pop()}function b(N,ie,X){return l(N.length,z=>X(N[z],ie))}function l(N,ie){let X=0,z=N-1;for(;X<=z;){const te=(X+z)/2|0,ae=ie(te);if(ae<0)X=te+1;else if(ae>0)z=te-1;else return te}return-(X+1)}function m(N,ie,X){if(N=N|0,N>=ie.length)throw new TypeError("invalid index");const z=ie[Math.floor(ie.length*Math.random())],te=[],ae=[],me=[];for(const be of ie){const ye=X(be,z);ye<0?te.push(be):ye>0?ae.push(be):me.push(be)}return N<te.length?m(N,te,X):N<te.length+me.length?me[0]:m(N-(te.length+me.length),ae,X)}function u(N,ie){const X=[];let z;for(const te of N.slice(0).sort(ie))!z||ie(z[0],te)!==0?(z=[te],X.push(z)):z.push(te);return X}function*$(N,ie){let X,z;for(const te of N)z!==void 0&&ie(z,te)?X.push(te):(X&&(yield X),X=[te]),z=te;X&&(yield X)}function p(N,ie){for(let X=0;X<=N.length;X++)ie(X===0?void 0:N[X-1],X===N.length?void 0:N[X])}function d(N,ie){for(let X=0;X<N.length;X++)ie(X===0?void 0:N[X-1],N[X],X+1===N.length?void 0:N[X+1])}function f(N,ie,X){const z=[];function te(be,ye,Fe){if(ye===0&&Fe.length===0)return;const Ve=z[z.length-1];Ve&&Ve.start+Ve.deleteCount===be?(Ve.deleteCount+=ye,Ve.toInsert.push(...Fe)):z.push({start:be,deleteCount:ye,toInsert:Fe})}let ae=0,me=0;for(;;){if(ae===N.length){te(ae,0,ie.slice(me));break}if(me===ie.length){te(ae,N.length-ae,[]);break}const be=N[ae],ye=ie[me],Fe=X(be,ye);Fe===0?(ae+=1,me+=1):Fe<0?(te(ae,1,[]),ae+=1):Fe>0&&(te(ae,0,[ye]),me+=1)}return z}function y(N,ie,X){const z=f(N,ie,X),te=[],ae=[];for(const me of z)te.push(...N.slice(me.start,me.start+me.deleteCount)),ae.push(...me.toInsert);return{removed:te,added:ae}}function k(N,ie,X){if(X===0)return[];const z=N.slice(0,X).sort(ie);return E(N,ie,z,X,N.length),z}function g(N,ie,X,z,te){return X===0?Promise.resolve([]):new Promise((ae,me)=>{(async()=>{const be=N.length,ye=N.slice(0,X).sort(ie);for(let Fe=X,Ve=Math.min(X+z,be);Fe<be;Fe=Ve,Ve=Math.min(Ve+z,be)){if(Fe>X&&await new Promise(Re=>setTimeout(Re)),te&&te.isCancellationRequested)throw new i.$7;E(N,ie,ye,Fe,Ve)}return ye})().then(ae,me)})}function E(N,ie,X,z,te){for(const ae=X.length;z<te;z++){const me=N[z];if(ie(me,X[ae-1])<0){X.pop();const be=(0,r.$mb)(X,ye=>ie(me,ye)<0);X.splice(be,0,me)}}}function S(N){return N.filter(ie=>!!ie)}function s(N){let ie=0;for(let X=0;X<N.length;X++)N[X]&&(N[ie]=N[X],ie+=1);N.length=ie}function a(N,ie,X){N.splice(X,0,N.splice(ie,1)[0])}function t(N){return!Array.isArray(N)||N.length===0}function o(N){return Array.isArray(N)&&N.length>0}function n(N,ie=X=>X){const X=new Set;return N.filter(z=>{const te=ie(z);return X.has(te)?!1:(X.add(te),!0)})}function c(N){const ie=new Set;return X=>{const z=N(X);return ie.has(z)?!1:(ie.add(z),!0)}}function h(N,ie){return N.length>0?N[0]:ie}function P(N,ie){return N.length>0?N[N.length-1]:ie}function w(N,ie,X=(z,te)=>z===te){let z=0;for(let te=0,ae=Math.min(N.length,ie.length);te<ae&&X(N[te],ie[te]);te++)z++;return z}function D(N,ie){let X=typeof ie=="number"?N:0;typeof ie=="number"?X=N:(X=0,ie=N);const z=[];if(X<=ie)for(let te=X;te<ie;te++)z.push(te);else for(let te=X;te>ie;te--)z.push(te);return z}function L(N,ie,X){return N.reduce((z,te)=>(z[ie(te)]=X?X(te):te,z),Object.create(null))}function R(N,ie){return N.push(ie),()=>T(N,ie)}function T(N,ie){const X=N.indexOf(ie);if(X>-1)return N.splice(X,1),ie}function j(N,ie,X){const z=N.slice(0,ie),te=N.slice(ie);return z.concat(X,te)}function G(N,ie){let X;if(typeof ie=="number"){let z=ie;X=()=>{const te=Math.sin(z++)*179426549;return te-Math.floor(te)}}else X=Math.random;for(let z=N.length-1;z>0;z-=1){const te=Math.floor(X()*(z+1)),ae=N[z];N[z]=N[te],N[te]=ae}}function q(N,ie){const X=N.indexOf(ie);X>-1&&(N.splice(X,1),N.unshift(ie))}function Q(N,ie){const X=N.indexOf(ie);X>-1&&(N.splice(X,1),N.push(ie))}function de(N,ie){for(const X of ie)N.push(X)}function V(N,ie){return Array.isArray(N)?N.map(ie):ie(N)}function Y(N){return Array.isArray(N)?N:[N]}function B(N){return N[Math.floor(Math.random()*N.length)]}function _(N,ie,X){const z=W(N,ie),te=N.length,ae=X.length;N.length=te+ae;for(let me=te-1;me>=z;me--)N[me+ae]=N[me];for(let me=0;me<ae;me++)N[me+z]=X[me]}function C(N,ie,X,z){const te=W(N,ie);let ae=N.splice(te,X);return ae===void 0&&(ae=[]),_(N,te,z),ae}function W(N,ie){return ie<0?Math.max(ie+N.length,0):Math.min(ie,N.length)}var F;(function(N){function ie(ae){return ae<0}N.isLessThan=ie;function X(ae){return ae<=0}N.isLessThanOrEqual=X;function z(ae){return ae>0}N.isGreaterThan=z;function te(ae){return ae===0}N.isNeitherLessOrGreaterThan=te,N.greaterThan=1,N.lessThan=-1,N.neitherLessOrGreaterThan=0})(F||(e.CompareResult=F={}));function H(N,ie){return(X,z)=>ie(N(X),N(z))}function ne(...N){return(ie,X)=>{for(const z of N){const te=z(ie,X);if(!F.isNeitherLessOrGreaterThan(te))return te}return F.neitherLessOrGreaterThan}}const x=(N,ie)=>N-ie;e.$0b=x;const ce=(N,ie)=>(0,e.$0b)(N?1:0,ie?1:0);e.$$b=ce;function oe(N){return(ie,X)=>-N(ie,X)}class J{constructor(ie){this.g=ie,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ie){let X=this.c;for(;X<this.g.length&&ie(this.g[X]);)X++;const z=X===this.c?null:this.g.slice(this.c,X);return this.c=X,z}takeFromEndWhile(ie){let X=this.d;for(;X>=0&&ie(this.g[X]);)X--;const z=X===this.d?null:this.g.slice(X+1,this.d+1);return this.d=X,z}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ie=this.g[this.c];return this.c++,ie}removeLast(){const ie=this.g[this.d];return this.d--,ie}takeCount(ie){const X=this.g.slice(this.c,this.c+ie);return this.c+=ie,X}}e.$ac=J;class M{static{this.empty=new M(ie=>{})}constructor(ie){this.iterate=ie}forEach(ie){this.iterate(X=>(ie(X),!0))}toArray(){const ie=[];return this.iterate(X=>(ie.push(X),!0)),ie}filter(ie){return new M(X=>this.iterate(z=>ie(z)?X(z):!0))}map(ie){return new M(X=>this.iterate(z=>X(ie(z))))}some(ie){let X=!1;return this.iterate(z=>(X=ie(z),!X)),X}findFirst(ie){let X;return this.iterate(z=>ie(z)?(X=z,!1):!0),X}findLast(ie){let X;return this.iterate(z=>(ie(z)&&(X=z),!0)),X}findLastMaxBy(ie){let X,z=!0;return this.iterate(te=>((z||F.isGreaterThan(ie(te,X)))&&(z=!1,X=te),!0)),X}}e.$bc=M;class Z{constructor(ie){this.c=ie}static createSortPermutation(ie,X){const z=Array.from(ie.keys()).sort((te,ae)=>X(ie[te],ie[ae]));return new Z(z)}apply(ie){return ie.map((X,z)=>ie[this.c[z]])}inverse(){const ie=this.c.slice();for(let X=0;X<this.c.length;X++)ie[this.c[X]]=X;return new Z(ie)}}e.$cc=Z;async function U(N,ie){return(await Promise.all(N.map(async(z,te)=>({element:z,ok:await ie(z,te)})))).find(z=>z.ok)?.element}}),define(le[143],ue([0,1,15]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=r,e.$hd=v,e.$id=A,e.$jd=O,e.$kd=I,e.$ld=b;function r(l,m){if(!l)throw new Error(m?`Assertion failed (${m})`:"Assertion Failed")}function v(l,m="Unreachable"){throw new Error(m)}function A(l,m="unexpected state"){if(!l)throw new i.$eb(`Assertion Failed: ${m}`)}function O(l){l||(0,i.$2)(new i.$eb("Soft Assertion Failed"))}function I(l){if(!l()){debugger;l(),(0,i.$2)(new i.$eb("Assertion Failed"))}}function b(l,m){let u=0;for(;u<l.length-1;){const $=l[u],p=l[u+1];if(!m($,p))return!1;u++}return!0}}),define(le[91],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fb=i;function i(r,v){const A=this;let O=!1,I;return function(){if(O)return I;if(O=!0,v)try{I=r.apply(A,arguments)}finally{v()}else I=r.apply(A,arguments);return I}}}),define(le[78],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var i;(function(r){function v(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}r.is=v;const A=Object.freeze([]);function O(){return A}r.empty=O;function*I(t){yield t}r.single=I;function b(t){return v(t)?t:I(t)}r.wrap=b;function l(t){return t||A}r.from=l;function*m(t){for(let o=t.length-1;o>=0;o--)yield t[o]}r.reverse=m;function u(t){return!t||t[Symbol.iterator]().next().done===!0}r.isEmpty=u;function $(t){return t[Symbol.iterator]().next().value}r.first=$;function p(t,o){let n=0;for(const c of t)if(o(c,n++))return!0;return!1}r.some=p;function d(t,o){for(const n of t)if(o(n))return n}r.find=d;function*f(t,o){for(const n of t)o(n)&&(yield n)}r.filter=f;function*y(t,o){let n=0;for(const c of t)yield o(c,n++)}r.map=y;function*k(t,o){let n=0;for(const c of t)yield*o(c,n++)}r.flatMap=k;function*g(...t){for(const o of t)yield*o}r.concat=g;function E(t,o,n){let c=n;for(const h of t)c=o(c,h);return c}r.reduce=E;function*S(t,o,n=t.length){for(o<0&&(o+=t.length),n<0?n+=t.length:n>t.length&&(n=t.length);o<n;o++)yield t[o]}r.slice=S;function s(t,o=Number.POSITIVE_INFINITY){const n=[];if(o===0)return[n,t];const c=t[Symbol.iterator]();for(let h=0;h<o;h++){const P=c.next();if(P.done)return[n,r.empty()];n.push(P.value)}return[n,{[Symbol.iterator](){return c}}]}r.consume=s;async function a(t){const o=[];for await(const n of t)o.push(n);return Promise.resolve(o)}r.asyncToArray=a})(i||(e.Iterable=i={}))}),define(le[43],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$1n=O,e.$2n=u,e.$3n=$,e.$4n=p,e.$5n=d,e.$6n=f,e.$7n=y,e.$8n=k,e.$9n=g,e.$0n=E,e.$$n=S;var i;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(i||(e.ScanError=i={}));var r;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(r||(e.SyntaxKind=r={}));var v;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(v||(e.ParseErrorCode=v={}));var A;(function(s){s.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function O(s,a=!1){let t=0;const o=s.length;let n="",c=0,h=r.Unknown,P=i.None;function w(q){let Q=0,de=0;for(;Q<q;){const V=s.charCodeAt(t);if(V>=m._0&&V<=m._9)de=de*16+V-m._0;else if(V>=m.A&&V<=m.F)de=de*16+V-m.A+10;else if(V>=m.a&&V<=m.f)de=de*16+V-m.a+10;else break;t++,Q++}return Q<q&&(de=-1),de}function D(q){t=q,n="",c=0,h=r.Unknown,P=i.None}function L(){const q=t;if(s.charCodeAt(t)===m._0)t++;else for(t++;t<s.length&&l(s.charCodeAt(t));)t++;if(t<s.length&&s.charCodeAt(t)===m.dot)if(t++,t<s.length&&l(s.charCodeAt(t)))for(t++;t<s.length&&l(s.charCodeAt(t));)t++;else return P=i.UnexpectedEndOfNumber,s.substring(q,t);let Q=t;if(t<s.length&&(s.charCodeAt(t)===m.E||s.charCodeAt(t)===m.e))if(t++,(t<s.length&&s.charCodeAt(t)===m.plus||s.charCodeAt(t)===m.minus)&&t++,t<s.length&&l(s.charCodeAt(t))){for(t++;t<s.length&&l(s.charCodeAt(t));)t++;Q=t}else P=i.UnexpectedEndOfNumber;return s.substring(q,Q)}function R(){let q="",Q=t;for(;;){if(t>=o){q+=s.substring(Q,t),P=i.UnexpectedEndOfString;break}const de=s.charCodeAt(t);if(de===m.doubleQuote){q+=s.substring(Q,t),t++;break}if(de===m.backslash){if(q+=s.substring(Q,t),t++,t>=o){P=i.UnexpectedEndOfString;break}switch(s.charCodeAt(t++)){case m.doubleQuote:q+='"';break;case m.backslash:q+="\\";break;case m.slash:q+="/";break;case m.b:q+="\b";break;case m.f:q+="\f";break;case m.n:q+=`
`;break;case m.r:q+="\r";break;case m.t:q+="	";break;case m.u:{const Y=w(4);Y>=0?q+=String.fromCharCode(Y):P=i.InvalidUnicode;break}default:P=i.InvalidEscapeCharacter}Q=t;continue}if(de>=0&&de<=31)if(b(de)){q+=s.substring(Q,t),P=i.UnexpectedEndOfString;break}else P=i.InvalidCharacter;t++}return q}function T(){if(n="",P=i.None,c=t,t>=o)return c=o,h=r.EOF;let q=s.charCodeAt(t);if(I(q)){do t++,n+=String.fromCharCode(q),q=s.charCodeAt(t);while(I(q));return h=r.Trivia}if(b(q))return t++,n+=String.fromCharCode(q),q===m.carriageReturn&&s.charCodeAt(t)===m.lineFeed&&(t++,n+=`
`),h=r.LineBreakTrivia;switch(q){case m.openBrace:return t++,h=r.OpenBraceToken;case m.closeBrace:return t++,h=r.CloseBraceToken;case m.openBracket:return t++,h=r.OpenBracketToken;case m.closeBracket:return t++,h=r.CloseBracketToken;case m.colon:return t++,h=r.ColonToken;case m.comma:return t++,h=r.CommaToken;case m.doubleQuote:return t++,n=R(),h=r.StringLiteral;case m.slash:{const Q=t-1;if(s.charCodeAt(t+1)===m.slash){for(t+=2;t<o&&!b(s.charCodeAt(t));)t++;return n=s.substring(Q,t),h=r.LineCommentTrivia}if(s.charCodeAt(t+1)===m.asterisk){t+=2;const de=o-1;let V=!1;for(;t<de;){if(s.charCodeAt(t)===m.asterisk&&s.charCodeAt(t+1)===m.slash){t+=2,V=!0;break}t++}return V||(t++,P=i.UnexpectedEndOfComment),n=s.substring(Q,t),h=r.BlockCommentTrivia}return n+=String.fromCharCode(q),t++,h=r.Unknown}case m.minus:if(n+=String.fromCharCode(q),t++,t===o||!l(s.charCodeAt(t)))return h=r.Unknown;case m._0:case m._1:case m._2:case m._3:case m._4:case m._5:case m._6:case m._7:case m._8:case m._9:return n+=L(),h=r.NumericLiteral;default:for(;t<o&&j(q);)t++,q=s.charCodeAt(t);if(c!==t){switch(n=s.substring(c,t),n){case"true":return h=r.TrueKeyword;case"false":return h=r.FalseKeyword;case"null":return h=r.NullKeyword}return h=r.Unknown}return n+=String.fromCharCode(q),t++,h=r.Unknown}}function j(q){if(I(q)||b(q))return!1;switch(q){case m.closeBrace:case m.closeBracket:case m.openBrace:case m.openBracket:case m.doubleQuote:case m.colon:case m.comma:case m.slash:return!1}return!0}function G(){let q;do q=T();while(q>=r.LineCommentTrivia&&q<=r.Trivia);return q}return{setPosition:D,getPosition:()=>t,scan:a?G:T,getToken:()=>h,getTokenValue:()=>n,getTokenOffset:()=>c,getTokenLength:()=>t-c,getTokenError:()=>P}}function I(s){return s===m.space||s===m.tab||s===m.verticalTab||s===m.formFeed||s===m.nonBreakingSpace||s===m.ogham||s>=m.enQuad&&s<=m.zeroWidthSpace||s===m.narrowNoBreakSpace||s===m.mathematicalSpace||s===m.ideographicSpace||s===m.byteOrderMark}function b(s){return s===m.lineFeed||s===m.carriageReturn||s===m.lineSeparator||s===m.paragraphSeparator}function l(s){return s>=m._0&&s<=m._9}var m;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(m||(m={}));function u(s,a){const t=[],o=new Object;let n;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function P(w,D,L,R){c.value=w,c.offset=D,c.length=L,c.type=R,c.colonOffset=void 0,n=c}try{E(s,{onObjectBegin:(w,D)=>{if(a<=w)throw o;n=void 0,h=a>w,t.push("")},onObjectProperty:(w,D,L)=>{if(a<D||(P(w,D,L,"property"),t[t.length-1]=w,a<=D+L))throw o},onObjectEnd:(w,D)=>{if(a<=w)throw o;n=void 0,t.pop()},onArrayBegin:(w,D)=>{if(a<=w)throw o;n=void 0,t.push(0)},onArrayEnd:(w,D)=>{if(a<=w)throw o;n=void 0,t.pop()},onLiteralValue:(w,D,L)=>{if(a<D||(P(w,D,L,S(w)),a<=D+L))throw o},onSeparator:(w,D,L)=>{if(a<=D)throw o;if(w===":"&&n&&n.type==="property")n.colonOffset=D,h=!1,n=void 0;else if(w===","){const R=t[t.length-1];typeof R=="number"?t[t.length-1]=R+1:(h=!0,t[t.length-1]=""),n=void 0}}})}catch(w){if(w!==o)throw w}return{path:t,previousNode:n,isAtPropertyKey:h,matches:w=>{let D=0;for(let L=0;D<w.length&&L<t.length;L++)if(w[D]===t[L]||w[D]==="*")D++;else if(w[D]!=="**")return!1;return D===w.length}}}function $(s,a=[],t=A.DEFAULT){let o=null,n=[];const c=[];function h(w){Array.isArray(n)?n.push(w):o!==null&&(n[o]=w)}return E(s,{onObjectBegin:()=>{const w={};h(w),c.push(n),n=w,o=null},onObjectProperty:w=>{o=w},onObjectEnd:()=>{n=c.pop()},onArrayBegin:()=>{const w=[];h(w),c.push(n),n=w,o=null},onArrayEnd:()=>{n=c.pop()},onLiteralValue:h,onError:(w,D,L)=>{a.push({error:w,offset:D,length:L})}},t),n[0]}function p(s,a=[],t=A.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(w){o.type==="property"&&(o.length=w-o.offset,o=o.parent)}function c(w){return o.children.push(w),w}E(s,{onObjectBegin:w=>{o=c({type:"object",offset:w,length:-1,parent:o,children:[]})},onObjectProperty:(w,D,L)=>{o=c({type:"property",offset:D,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:w,offset:D,length:L,parent:o})},onObjectEnd:(w,D)=>{o.length=w+D-o.offset,o=o.parent,n(w+D)},onArrayBegin:(w,D)=>{o=c({type:"array",offset:w,length:-1,parent:o,children:[]})},onArrayEnd:(w,D)=>{o.length=w+D-o.offset,o=o.parent,n(w+D)},onLiteralValue:(w,D,L)=>{c({type:S(w),offset:D,length:L,parent:o,value:w}),n(D+L)},onSeparator:(w,D,L)=>{o.type==="property"&&(w===":"?o.colonOffset=D:w===","&&n(D))},onError:(w,D,L)=>{a.push({error:w,offset:D,length:L})}},t);const P=o.children[0];return P&&delete P.parent,P}function d(s,a){if(!s)return;let t=s;for(const o of a)if(typeof o=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let n=!1;for(const c of t.children)if(Array.isArray(c.children)&&c.children[0].value===o){t=c.children[1],n=!0;break}if(!n)return}else{const n=o;if(t.type!=="array"||n<0||!Array.isArray(t.children)||n>=t.children.length)return;t=t.children[n]}return t}function f(s){if(!s.parent||!s.parent.children)return[];const a=f(s.parent);if(s.parent.type==="property"){const t=s.parent.children[0].value;a.push(t)}else if(s.parent.type==="array"){const t=s.parent.children.indexOf(s);t!==-1&&a.push(t)}return a}function y(s){switch(s.type){case"array":return s.children.map(y);case"object":{const a=Object.create(null);for(const t of s.children){const o=t.children[1];o&&(a[t.children[0].value]=y(o))}return a}case"null":case"string":case"number":case"boolean":return s.value;default:return}}function k(s,a,t=!1){return a>=s.offset&&a<s.offset+s.length||t&&a===s.offset+s.length}function g(s,a,t=!1){if(k(s,a,t)){const o=s.children;if(Array.isArray(o))for(let n=0;n<o.length&&o[n].offset<=a;n++){const c=g(o[n],a,t);if(c)return c}return s}}function E(s,a,t=A.DEFAULT){const o=O(s,!1);function n(H){return H?()=>H(o.getTokenOffset(),o.getTokenLength()):()=>!0}function c(H){return H?ne=>H(ne,o.getTokenOffset(),o.getTokenLength()):()=>!0}const h=n(a.onObjectBegin),P=c(a.onObjectProperty),w=n(a.onObjectEnd),D=n(a.onArrayBegin),L=n(a.onArrayEnd),R=c(a.onLiteralValue),T=c(a.onSeparator),j=n(a.onComment),G=c(a.onError),q=t&&t.disallowComments,Q=t&&t.allowTrailingComma;function de(){for(;;){const H=o.scan();switch(o.getTokenError()){case i.InvalidUnicode:V(v.InvalidUnicode);break;case i.InvalidEscapeCharacter:V(v.InvalidEscapeCharacter);break;case i.UnexpectedEndOfNumber:V(v.UnexpectedEndOfNumber);break;case i.UnexpectedEndOfComment:q||V(v.UnexpectedEndOfComment);break;case i.UnexpectedEndOfString:V(v.UnexpectedEndOfString);break;case i.InvalidCharacter:V(v.InvalidCharacter);break}switch(H){case r.LineCommentTrivia:case r.BlockCommentTrivia:q?V(v.InvalidCommentToken):j();break;case r.Unknown:V(v.InvalidSymbol);break;case r.Trivia:case r.LineBreakTrivia:break;default:return H}}}function V(H,ne=[],x=[]){if(G(H),ne.length+x.length>0){let ce=o.getToken();for(;ce!==r.EOF;){if(ne.indexOf(ce)!==-1){de();break}else if(x.indexOf(ce)!==-1)break;ce=de()}}}function Y(H){const ne=o.getTokenValue();return H?R(ne):P(ne),de(),!0}function B(){switch(o.getToken()){case r.NumericLiteral:{let H=0;try{H=JSON.parse(o.getTokenValue()),typeof H!="number"&&(V(v.InvalidNumberFormat),H=0)}catch{V(v.InvalidNumberFormat)}R(H);break}case r.NullKeyword:R(null);break;case r.TrueKeyword:R(!0);break;case r.FalseKeyword:R(!1);break;default:return!1}return de(),!0}function _(){return o.getToken()!==r.StringLiteral?(V(v.PropertyNameExpected,[],[r.CloseBraceToken,r.CommaToken]),!1):(Y(!1),o.getToken()===r.ColonToken?(T(":"),de(),F()||V(v.ValueExpected,[],[r.CloseBraceToken,r.CommaToken])):V(v.ColonExpected,[],[r.CloseBraceToken,r.CommaToken]),!0)}function C(){h(),de();let H=!1;for(;o.getToken()!==r.CloseBraceToken&&o.getToken()!==r.EOF;){if(o.getToken()===r.CommaToken){if(H||V(v.ValueExpected,[],[]),T(","),de(),o.getToken()===r.CloseBraceToken&&Q)break}else H&&V(v.CommaExpected,[],[]);_()||V(v.ValueExpected,[],[r.CloseBraceToken,r.CommaToken]),H=!0}return w(),o.getToken()!==r.CloseBraceToken?V(v.CloseBraceExpected,[r.CloseBraceToken],[]):de(),!0}function W(){D(),de();let H=!1;for(;o.getToken()!==r.CloseBracketToken&&o.getToken()!==r.EOF;){if(o.getToken()===r.CommaToken){if(H||V(v.ValueExpected,[],[]),T(","),de(),o.getToken()===r.CloseBracketToken&&Q)break}else H&&V(v.CommaExpected,[],[]);F()||V(v.ValueExpected,[],[r.CloseBracketToken,r.CommaToken]),H=!0}return L(),o.getToken()!==r.CloseBracketToken?V(v.CloseBracketExpected,[r.CloseBracketToken],[]):de(),!0}function F(){switch(o.getToken()){case r.OpenBracketToken:return W();case r.OpenBraceToken:return C();case r.StringLiteral:return Y(!0);default:return B()}}return de(),o.getToken()===r.EOF?t.allowEmptyContent?!0:(V(v.ValueExpected,[],[]),!1):F()?(o.getToken()!==r.EOF&&V(v.EndOfFileExpected,[],[]),!0):(V(v.ValueExpected,[],[]),!1)}function S(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}}),define(le[144],ue([0,1,43]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_n=r,e.$ao=v,e.$bo=I,e.$co=b;function r(l,m,u){let $,p,d,f,y;if(m){for(f=m.offset,y=f+m.length,d=f;d>0&&!b(l,d-1);)d--;let P=y;for(;P<l.length&&!b(l,P);)P++;p=l.substring(d,P),$=O(p,u)}else p=l,$=0,d=0,f=0,y=l.length;const k=I(u,l);let g=!1,E=0,S;u.insertSpaces?S=A(" ",u.tabSize||4):S="	";const s=(0,i.$1n)(p,!1);let a=!1;function t(){return k+A(S,$+E)}function o(){let P=s.scan();for(g=!1;P===i.SyntaxKind.Trivia||P===i.SyntaxKind.LineBreakTrivia;)g=g||P===i.SyntaxKind.LineBreakTrivia,P=s.scan();return a=P===i.SyntaxKind.Unknown||s.getTokenError()!==i.ScanError.None,P}const n=[];function c(P,w,D){!a&&w<y&&D>f&&l.substring(w,D)!==P&&n.push({offset:w,length:D-w,content:P})}let h=o();if(h!==i.SyntaxKind.EOF){const P=s.getTokenOffset()+d,w=A(S,$);c(w,d,P)}for(;h!==i.SyntaxKind.EOF;){let P=s.getTokenOffset()+s.getTokenLength()+d,w=o(),D="";for(;!g&&(w===i.SyntaxKind.LineCommentTrivia||w===i.SyntaxKind.BlockCommentTrivia);){const R=s.getTokenOffset()+d;c(" ",P,R),P=s.getTokenOffset()+s.getTokenLength()+d,D=w===i.SyntaxKind.LineCommentTrivia?t():"",w=o()}if(w===i.SyntaxKind.CloseBraceToken)h!==i.SyntaxKind.OpenBraceToken&&(E--,D=t());else if(w===i.SyntaxKind.CloseBracketToken)h!==i.SyntaxKind.OpenBracketToken&&(E--,D=t());else{switch(h){case i.SyntaxKind.OpenBracketToken:case i.SyntaxKind.OpenBraceToken:E++,D=t();break;case i.SyntaxKind.CommaToken:case i.SyntaxKind.LineCommentTrivia:D=t();break;case i.SyntaxKind.BlockCommentTrivia:g?D=t():D=" ";break;case i.SyntaxKind.ColonToken:D=" ";break;case i.SyntaxKind.StringLiteral:if(w===i.SyntaxKind.ColonToken){D="";break}case i.SyntaxKind.NullKeyword:case i.SyntaxKind.TrueKeyword:case i.SyntaxKind.FalseKeyword:case i.SyntaxKind.NumericLiteral:case i.SyntaxKind.CloseBraceToken:case i.SyntaxKind.CloseBracketToken:w===i.SyntaxKind.LineCommentTrivia||w===i.SyntaxKind.BlockCommentTrivia?D=" ":w!==i.SyntaxKind.CommaToken&&w!==i.SyntaxKind.EOF&&(a=!0);break;case i.SyntaxKind.Unknown:a=!0;break}g&&(w===i.SyntaxKind.LineCommentTrivia||w===i.SyntaxKind.BlockCommentTrivia)&&(D=t())}const L=s.getTokenOffset()+d;c(D,P,L),h=w}return n}function v(l,m){const u=JSON.stringify(l,void 0,m.insertSpaces?m.tabSize||4:"	");return m.eol!==void 0?u.replace(/\r\n|\r|\n/g,m.eol):u}function A(l,m){let u="";for(let $=0;$<m;$++)u+=l;return u}function O(l,m){let u=0,$=0;const p=m.tabSize||4;for(;u<l.length;){const d=l.charAt(u);if(d===" ")$++;else if(d==="	")$+=p;else break;u++}return Math.floor($/p)}function I(l,m){for(let u=0;u<m.length;u++){const $=m.charAt(u);if($==="\r")return u+1<m.length&&m.charAt(u+1)===`
`?`\r
`:"\r";if($===`
`)return`
`}return l&&l.eol||`
`}function b(l,m){return`\r
`.indexOf(l.charAt(m))!==-1}}),define(le[110],ue([0,1,43,144]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=v,e.$eo=A,e.$fo=O,e.$go=I,e.$ho=b;function v(l,m,u){return A(l,m,void 0,u)}function A(l,m,u,$,p){const d=m.slice(),f=[],y=(0,i.$4n)(l,f);let k,g;for(;d.length>0&&(g=d.pop(),k=(0,i.$5n)(y,d),k===void 0&&u!==void 0);)typeof g=="string"?u={[g]:u}:u=[u];if(k)if(k.type==="object"&&typeof g=="string"&&Array.isArray(k.children)){const E=(0,i.$5n)(k,[g]);if(E!==void 0)if(u===void 0){if(!E.parent)throw new Error("Malformed AST");const S=k.children.indexOf(E.parent);let s,a=E.parent.offset+E.parent.length;if(S>0){const t=k.children[S-1];s=t.offset+t.length}else s=k.offset+1,k.children.length>1&&(a=k.children[1].offset);return O(l,{offset:s,length:a-s,content:""},$)}else return O(l,{offset:E.offset,length:E.length,content:JSON.stringify(u)},$);else{if(u===void 0)return[];const S=`${JSON.stringify(g)}: ${JSON.stringify(u)}`,s=p?p(k.children.map(t=>t.children[0].value)):k.children.length;let a;if(s>0){const t=k.children[s-1];a={offset:t.offset+t.length,length:0,content:","+S}}else k.children.length===0?a={offset:k.offset+1,length:0,content:S}:a={offset:k.offset+1,length:0,content:S+","};return O(l,a,$)}}else if(k.type==="array"&&typeof g=="number"&&Array.isArray(k.children))if(u!==void 0){const E=`${JSON.stringify(u)}`;let S;if(k.children.length===0||g===0)S={offset:k.offset+1,length:0,content:k.children.length===0?E:E+","};else{const s=g===-1||g>k.children.length?k.children.length:g,a=k.children[s-1];S={offset:a.offset+a.length,length:0,content:","+E}}return O(l,S,$)}else{const E=g,S=k.children[E];let s;if(k.children.length===1)s={offset:k.offset+1,length:k.length-2,content:""};else if(k.children.length-1===E){const a=k.children[E-1],t=a.offset+a.length,o=k.offset+k.length;s={offset:t,length:o-2-t,content:""}}else s={offset:S.offset,length:k.children[E+1].offset-S.offset,content:""};return O(l,s,$)}else throw new Error(`Can not add ${typeof g!="number"?"index":"property"} to parent of type ${k.type}`);else return u===void 0?[]:O(l,{offset:y?y.offset:0,length:y?y.length:0,content:JSON.stringify(u)},$)}function O(l,m,u){let $=I(l,m),p=m.offset,d=m.offset+m.content.length;if(m.length===0||m.content.length===0){for(;p>0&&!(0,r.$co)($,p-1);)p--;for(;d<$.length&&!(0,r.$co)($,d);)d++}const f=(0,r.$_n)($,{offset:p,length:d-p},u);for(let k=f.length-1;k>=0;k--){const g=f[k];$=I($,g),p=Math.min(p,g.offset),d=Math.max(d,g.offset+g.length),d+=g.content.length-g.length}const y=l.length-($.length-d)-p;return[{offset:p,length:y,content:$.substring(p,d)}]}function I(l,m){return l.substring(0,m.offset)+m.content+l.substring(m.offset+m.length)}function b(l,m){const u=m.slice(0).sort((p,d)=>{const f=p.offset-d.offset;return f===0?p.length-d.length:f});let $=l.length;for(let p=u.length-1;p>=0;p--){const d=u[p];if(d.offset+d.length<=$)l=I(l,d);else throw new Error("Overlapping edit");$=d.offset}return l}}),define(le[145],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$j=i;function i(A){let O=!1;const I=new Map,b=new Map;if(v(A,f=>{if(A===f)return!0;const y=JSON.stringify(f);if(y.length<30)return!0;const k=I.get(y);if(!k){const g={schemas:[f]};return I.set(y,g),b.set(f,g),!0}return k.schemas.push(f),b.set(f,k),O=!0,!1}),I.clear(),!O)return JSON.stringify(A);let m="$defs";for(;A.hasOwnProperty(m);)m+="_";const u=[];function $(f){return JSON.stringify(f,(y,k)=>{if(k!==f){const g=b.get(k);if(g&&g.schemas.length>1)return g.id||(g.id=`_${u.length}`,u.push(g.schemas[0])),{$ref:`#/${m}/${g.id}`}}return k})}const p=$(A),d=[];for(let f=0;f<u.length;f++)d.push(`"_${f}":${$(u[f])}`);return d.length?`${p.substring(0,p.length-1)},"${m}":{${d.join(",")}}}`:p}function r(A){return typeof A=="object"&&A!==null}function v(A,O){if(!A||typeof A!="object")return;const I=(...p)=>{for(const d of p)r(d)&&u.push(d)},b=(...p)=>{for(const d of p)if(r(d))for(const f in d){const y=d[f];r(y)&&u.push(y)}},l=(...p)=>{for(const d of p)if(Array.isArray(d))for(const f of d)r(f)&&u.push(f)},m=p=>{if(Array.isArray(p))for(const d of p)r(d)&&u.push(d);else r(p)&&u.push(p)},u=[A];let $=u.pop();for(;$;)O($)&&(I($.additionalItems,$.additionalProperties,$.not,$.contains,$.propertyNames,$.if,$.then,$.else,$.unevaluatedItems,$.unevaluatedProperties),b($.definitions,$.$defs,$.properties,$.patternProperties,$.dependencies,$.dependentSchemas),l($.anyOf,$.allOf,$.oneOf,$.prefixItems),m($.items)),$=u.pop()}}),function(){function K(){const e=/("[^"\\]*(?:\\.[^"\\]*)*")|('[^'\\]*(?:\\.[^'\\]*)*')|(\/\*[^\/\*]*(?:(?:\*|\/)[^\/\*]*)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))|(,\s*[}\]])/g;function i(v){return v.replace(e,function(A,O,I,b,l,m){if(b)return"";if(l){const u=l.length;return l[u-1]===`
`?l[u-2]==="\r"?`\r
`:`
`:""}else return m?A.substring(1):A})}function r(v){const A=i(v);try{return JSON.parse(A)}catch{const I=A.replace(/,\s*([}\]])/g,"$1");return JSON.parse(I)}}return{stripComments:i,parse:r}}typeof define=="function"?define("vs/base/common/jsonc",[],function(){return K()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=K():console.trace("jsonc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(le[68],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W=void 0;class i{constructor(v){this.d=v,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(v){this.c=v}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$W=i}),define(le[111],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8c=void 0;class i{static{this.Undefined=new i(void 0)}constructor(A){this.element=A,this.next=i.Undefined,this.prev=i.Undefined}}class r{constructor(){this.a=i.Undefined,this.b=i.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===i.Undefined}clear(){let A=this.a;for(;A!==i.Undefined;){const O=A.next;A.prev=i.Undefined,A.next=i.Undefined,A=O}this.a=i.Undefined,this.b=i.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,O){const I=new i(A);if(this.a===i.Undefined)this.a=I,this.b=I;else if(O){const l=this.b;this.b=I,I.prev=l,l.next=I}else{const l=this.a;this.a=I,I.next=l,l.prev=I}this.c+=1;let b=!1;return()=>{b||(b=!0,this.e(I))}}shift(){if(this.a!==i.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==i.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==i.Undefined&&A.next!==i.Undefined){const O=A.prev;O.next=A.next,A.next.prev=O}else A.prev===i.Undefined&&A.next===i.Undefined?(this.a=i.Undefined,this.b=i.Undefined):A.next===i.Undefined?(this.b=this.b.prev,this.b.next=i.Undefined):A.prev===i.Undefined&&(this.a=this.a.next,this.a.prev=i.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==i.Undefined;)yield A.element,A=A.next}}e.$8c=r}),define(le[31],ue([0,1]),function(K,e){"use strict";var i,r,v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.Touch=e.$Ec=e.$Dc=void 0,e.$Ac=A,e.$Bc=O,e.$Cc=I,e.$Lc=S;function A(s,a,t){let o=s.get(a);return o===void 0&&(o=t,s.set(a,o)),o}function O(s){const a=[];return s.forEach((t,o)=>{a.push(`${o} => ${t}`)}),`Map(${s.size}) {${a.join(", ")}}`}function I(s){const a=[];return s.forEach(t=>{a.push(t)}),`Set(${s.size}) {${a.join(", ")}}`}class b{constructor(a,t){this.uri=a,this.value=t}}function l(s){return Array.isArray(s)}class m{static{this.c=a=>a.toString()}constructor(a,t){if(this[i]="ResourceMap",a instanceof m)this.d=new Map(a.d),this.e=t??m.c;else if(l(a)){this.d=new Map,this.e=t??m.c;for(const[o,n]of a)this.set(o,n)}else this.d=new Map,this.e=a??m.c}set(a,t){return this.d.set(this.e(a),new b(a,t)),this}get(a){return this.d.get(this.e(a))?.value}has(a){return this.d.has(this.e(a))}get size(){return this.d.size}clear(){this.d.clear()}delete(a){return this.d.delete(this.e(a))}forEach(a,t){typeof t<"u"&&(a=a.bind(t));for(const[o,n]of this.d)a(n.value,n.uri,this)}*values(){for(const a of this.d.values())yield a.value}*keys(){for(const a of this.d.values())yield a.uri}*entries(){for(const a of this.d.values())yield[a.uri,a.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,a]of this.d)yield[a.uri,a.value]}}e.$Dc=m;class u{constructor(a,t){this[r]="ResourceSet",!a||typeof a=="function"?this.c=new m(a):(this.c=new m(t),a.forEach(this.add,this))}get size(){return this.c.size}add(a){return this.c.set(a,a),this}clear(){this.c.clear()}delete(a){return this.c.delete(a)}forEach(a,t){this.c.forEach((o,n)=>a.call(t,n,n,this))}has(a){return this.c.has(a)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ec=u;var $;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})($||(e.Touch=$={}));class p{constructor(){this[v]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(a){return this.c.has(a)}get(a,t=$.None){const o=this.c.get(a);if(o)return t!==$.None&&this.m(o,t),o.value}set(a,t,o=$.None){let n=this.c.get(a);if(n)n.value=t,o!==$.None&&this.m(n,o);else{switch(n={key:a,value:t,next:void 0,previous:void 0},o){case $.None:this.k(n);break;case $.AsOld:this.j(n);break;case $.AsNew:this.k(n);break;default:this.k(n);break}this.c.set(a,n),this.f++}return this}delete(a){return!!this.remove(a)}remove(a){const t=this.c.get(a);if(t)return this.c.delete(a),this.l(t),this.f--,t.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const a=this.d;return this.c.delete(a.key),this.l(a),this.f--,a.value}forEach(a,t){const o=this.g;let n=this.d;for(;n;){if(t?a.bind(t)(n.value,n.key,this):a(n.value,n.key,this),this.g!==o)throw new Error("LinkedMap got modified during iteration.");n=n.next}}keys(){const a=this,t=this.g;let o=this.d;const n={[Symbol.iterator](){return n},next(){if(a.g!==t)throw new Error("LinkedMap got modified during iteration.");if(o){const c={value:o.key,done:!1};return o=o.next,c}else return{value:void 0,done:!0}}};return n}values(){const a=this,t=this.g;let o=this.d;const n={[Symbol.iterator](){return n},next(){if(a.g!==t)throw new Error("LinkedMap got modified during iteration.");if(o){const c={value:o.value,done:!1};return o=o.next,c}else return{value:void 0,done:!0}}};return n}entries(){const a=this,t=this.g;let o=this.d;const n={[Symbol.iterator](){return n},next(){if(a.g!==t)throw new Error("LinkedMap got modified during iteration.");if(o){const c={value:[o.key,o.value],done:!1};return o=o.next,c}else return{value:void 0,done:!0}}};return n}[(v=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(a){if(a>=this.size)return;if(a===0){this.clear();return}let t=this.d,o=this.size;for(;t&&o>a;)this.c.delete(t.key),t=t.next,o--;this.d=t,this.f=o,t&&(t.previous=void 0),this.g++}i(a){if(a>=this.size)return;if(a===0){this.clear();return}let t=this.e,o=this.size;for(;t&&o>a;)this.c.delete(t.key),t=t.previous,o--;this.e=t,this.f=o,t&&(t.next=void 0),this.g++}j(a){if(!this.d&&!this.e)this.e=a;else if(this.d)a.next=this.d,this.d.previous=a;else throw new Error("Invalid list");this.d=a,this.g++}k(a){if(!this.d&&!this.e)this.d=a;else if(this.e)a.previous=this.e,this.e.next=a;else throw new Error("Invalid list");this.e=a,this.g++}l(a){if(a===this.d&&a===this.e)this.d=void 0,this.e=void 0;else if(a===this.d){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this.d=a.next}else if(a===this.e){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this.e=a.previous}else{const t=a.next,o=a.previous;if(!t||!o)throw new Error("Invalid list");t.previous=o,o.next=t}a.next=void 0,a.previous=void 0,this.g++}m(a,t){if(!this.d||!this.e)throw new Error("Invalid list");if(!(t!==$.AsOld&&t!==$.AsNew)){if(t===$.AsOld){if(a===this.d)return;const o=a.next,n=a.previous;a===this.e?(n.next=void 0,this.e=n):(o.previous=n,n.next=o),a.previous=void 0,a.next=this.d,this.d.previous=a,this.d=a,this.g++}else if(t===$.AsNew){if(a===this.e)return;const o=a.next,n=a.previous;a===this.d?(o.previous=void 0,this.d=o):(o.previous=n,n.next=o),a.next=void 0,a.previous=this.e,this.e.next=a,this.e=a,this.g++}}}toJSON(){const a=[];return this.forEach((t,o)=>{a.push([o,t])}),a}fromJSON(a){this.clear();for(const[t,o]of a)this.set(t,o)}}e.$Fc=p;class d extends p{constructor(a,t=1){super(),this.n=a,this.o=Math.min(Math.max(0,t),1)}get limit(){return this.n}set limit(a){this.n=a,this.p()}get ratio(){return this.o}set ratio(a){this.o=Math.min(Math.max(0,a),1),this.p()}get(a,t=$.AsNew){return super.get(a,t)}peek(a){return super.get(a,$.None)}set(a,t){return super.set(a,t,$.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class f extends d{constructor(a,t=1){super(a,t)}q(a){this.h(a)}set(a,t){return super.set(a,t),this.p(),this}}e.$Gc=f;class y extends d{constructor(a,t=1){super(a,t)}q(a){this.i(a)}set(a,t){return this.n<=this.size&&!this.has(a)&&this.q(Math.round(this.n*this.o)-1),super.set(a,t),this}}e.$Hc=y;class k{constructor(){this.c=new Map}add(a){return this.c.set(a,(this.c.get(a)||0)+1),this}delete(a){let t=this.c.get(a)||0;return t===0?!1:(t--,t===0?this.c.delete(a):this.c.set(a,t),!0)}has(a){return this.c.has(a)}}e.$Ic=k;class g{constructor(a){if(this.c=new Map,this.d=new Map,a)for(const[t,o]of a)this.set(t,o)}clear(){this.c.clear(),this.d.clear()}set(a,t){this.c.set(a,t),this.d.set(t,a)}get(a){return this.c.get(a)}getKey(a){return this.d.get(a)}delete(a){const t=this.c.get(a);return t===void 0?!1:(this.c.delete(a),this.d.delete(t),!0)}forEach(a,t){this.c.forEach((o,n)=>{a.call(t,o,n,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Jc=g;class E{constructor(){this.c=new Map}add(a,t){let o=this.c.get(a);o||(o=new Set,this.c.set(a,o)),o.add(t)}delete(a,t){const o=this.c.get(a);o&&(o.delete(t),o.size===0&&this.c.delete(a))}forEach(a,t){const o=this.c.get(a);o&&o.forEach(t)}get(a){const t=this.c.get(a);return t||new Set}}e.$Kc=E;function S(s,a){if(s===a)return!0;if(s.size!==a.size)return!1;for(const[t,o]of s)if(!a.has(t)||a.get(t)!==o)return!1;for(const[t]of a)if(!s.has(t))return!1;return!0}}),define(le[2],ue([0,1,21,141,31,91,78]),function(K,e,i,r,v,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$5c=e.$4c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Mc=void 0,e.$Nc=m,e.$Oc=u,e.$Pc=$,e.$Qc=f,e.$Rc=y,e.$Sc=k,e.$Tc=g,e.$Uc=E,e.$Vc=S,e.$6c=D;const I=!1;let b=null;class l{constructor(){this.b=new Map}static{this.a=0}c(T){let j=this.b.get(T);return j||(j={parent:null,source:null,isSingleton:!1,value:T,idx:l.a++},this.b.set(T,j)),j}trackDisposable(T){const j=this.c(T);j.source||(j.source=new Error().stack)}setParent(T,j){const G=this.c(T);G.parent=j}markAsDisposed(T){this.b.delete(T)}markAsSingleton(T){this.c(T).isSingleton=!0}f(T,j){const G=j.get(T);if(G)return G;const q=T.parent?this.f(this.c(T.parent),j):T;return j.set(T,q),q}getTrackedDisposables(){const T=new Map;return[...this.b.entries()].filter(([,G])=>G.source!==null&&!this.f(G,T).isSingleton).flatMap(([G])=>G)}computeLeakingDisposables(T=10,j){let G;if(j)G=j;else{const Y=new Map,B=[...this.b.values()].filter(C=>C.source!==null&&!this.f(C,Y).isSingleton);if(B.length===0)return;const _=new Set(B.map(C=>C.value));if(G=B.filter(C=>!(C.parent&&_.has(C.parent))),G.length===0)throw new Error("There are cyclic diposable chains!")}if(!G)return;function q(Y){function B(C,W){for(;C.length>0&&W.some(F=>typeof F=="string"?F===C[0]:C[0].match(F));)C.shift()}const _=Y.source.split(`
`).map(C=>C.trim().replace("at ","")).filter(C=>C!=="");return B(_,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),_.reverse()}const Q=new v.$Kc;for(const Y of G){const B=q(Y);for(let _=0;_<=B.length;_++)Q.add(B.slice(0,_).join(`
`),Y)}G.sort((0,i.$8b)(Y=>Y.idx,i.$0b));let de="",V=0;for(const Y of G.slice(0,T)){V++;const B=q(Y),_=[];for(let C=0;C<B.length;C++){let W=B[C];W=`(shared with ${Q.get(B.slice(0,C+1).join(`
`)).size}/${G.length} leaks) at ${W}`;const H=Q.get(B.slice(0,C).join(`
`)),ne=(0,r.$c)([...H].map(x=>q(x)[C]),x=>x);delete ne[B[C]];for(const[x,ce]of Object.entries(ne))_.unshift(`    - stacktraces of ${ce.length} other leaks continue with ${x}`);_.unshift(W)}de+=`


==================== Leaking disposable ${V}/${G.length}: ${Y.value.constructor.name} ====================
${_.join(`
`)}
============================================================

`}return G.length>T&&(de+=`


... and ${G.length-T} more leaking disposables

`),{leaks:G,details:de}}}e.$Mc=l;function m(R){b=R}if(I){const R="__is_disposable_tracked__";m(new class{trackDisposable(T){const j=new Error("Potentially leaked disposable").stack;setTimeout(()=>{T[R]||console.log(j)},3e3)}setParent(T,j){if(T&&T!==a.None)try{T[R]=!0}catch{}}markAsDisposed(T){if(T&&T!==a.None)try{T[R]=!0}catch{}}markAsSingleton(T){}})}function u(R){return b?.trackDisposable(R),R}function $(R){b?.markAsDisposed(R)}function p(R,T){b?.setParent(R,T)}function d(R,T){if(b)for(const j of R)b.setParent(j,T)}function f(R){return b?.markAsSingleton(R),R}function y(R){return typeof R=="object"&&R!==null&&typeof R.dispose=="function"&&R.dispose.length===0}function k(R){if(O.Iterable.is(R)){const T=[];for(const j of R)if(j)try{j.dispose()}catch(G){T.push(G)}if(T.length===1)throw T[0];if(T.length>1)throw new AggregateError(T,"Encountered errors while disposing of store");return Array.isArray(R)?[]:R}else if(R)return R.dispose(),R}function g(R){for(const T of R)y(T)&&T.dispose();return[]}function E(...R){const T=S(()=>k(R));return d(R,T),T}function S(R){const T=u({dispose:(0,A.$fb)(()=>{$(T),R()})});return T}class s{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,u(this)}dispose(){this.g||($(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{k(this.f)}finally{this.f.clear()}}add(T){if(!T)return T;if(T===this)throw new Error("Cannot register a disposable on itself!");return p(T,this),this.g?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(T),T}delete(T){if(T){if(T===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(T),T.dispose()}}deleteAndLeak(T){T&&this.f.has(T)&&(this.f.delete(T),p(T,null))}}e.$Wc=s;class a{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new s,u(this),p(this.q,this)}dispose(){$(this),this.q.dispose()}B(T){if(T===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(T)}}e.$Xc=a;class t{constructor(){this.b=!1,u(this)}get value(){return this.b?void 0:this.a}set value(T){this.b||T===this.a||(this.a?.dispose(),T&&p(T,this),this.a=T)}clear(){this.value=void 0}dispose(){this.b=!0,$(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const T=this.a;return this.a=void 0,T&&p(T,null),T}}e.$Yc=t;class o{constructor(T){this.a=new t,this.b=!1,this.a.value=T}get value(){return this.a.value}set value(T){this.b||T===this.a.value||(this.a.value=T)}dispose(){this.b=!0,this.a.dispose()}}e.$Zc=o;class n{constructor(T){this.b=T,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$1c=n;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,u(this)}set(T){let j=T;return this.unset=()=>j=void 0,this.isset=()=>j!==void 0,this.dispose=()=>{j&&(j(),j=void 0,$(this))},this}}e.$2c=c;class h{constructor(){this.a=new Map}acquire(T,...j){let G=this.a.get(T);G||(G={counter:0,object:this.b(T,...j)},this.a.set(T,G));const{object:q}=G,Q=(0,A.$fb)(()=>{--G.counter===0&&(this.c(T,G.object),this.a.delete(T))});return G.counter++,{object:q,dispose:Q}}}e.$3c=h;class P{constructor(T){this.a=T}async acquire(T,...j){const G=this.a.acquire(T,...j);try{return{object:await G.object,dispose:()=>G.dispose()}}catch(q){throw G.dispose(),q}}}e.$4c=P;class w{constructor(T){this.object=T}dispose(){}}e.$5c=w;function D(R){const T=new s;try{R(T)}finally{T.dispose()}}class L{constructor(){this.a=new Map,this.b=!1,u(this)}dispose(){$(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{k(this.a.values())}finally{this.a.clear()}}has(T){return this.a.has(T)}get size(){return this.a.size}get(T){return this.a.get(T)}set(T,j,G=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),G||this.a.get(T)?.dispose(),this.a.set(T,j)}deleteAndDispose(T){this.a.get(T)?.dispose(),this.a.delete(T)}deleteAndLeak(T){const j=this.a.get(T);return this.a.delete(T),j}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$7c=L}),define(le[92],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var i;(function(r){r[r.Uri=1]="Uri",r[r.Regexp=2]="Regexp",r[r.ScmResource=3]="ScmResource",r[r.ScmResourceGroup=4]="ScmResourceGroup",r[r.ScmProvider=5]="ScmProvider",r[r.CommentController=6]="CommentController",r[r.CommentThread=7]="CommentThread",r[r.CommentThreadInstance=8]="CommentThreadInstance",r[r.CommentThreadReply=9]="CommentThreadReply",r[r.CommentNode=10]="CommentNode",r[r.CommentThreadNode=11]="CommentThreadNode",r[r.TimelineActionContext=12]="TimelineActionContext",r[r.NotebookCellActionContext=13]="NotebookCellActionContext",r[r.NotebookActionContext=14]="NotebookActionContext",r[r.TerminalContext=15]="TerminalContext",r[r.TestItemContext=16]="TestItemContext",r[r.Date=17]="Date",r[r.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(i||(e.MarshalledId=i={}))}),define(le[79],ue([0,1,31]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=void 0,e.$qm=v,e.$rm=O;const r=new i.$Gc(1e4);function v(l){return b(l,"NFC",r)}const A=new i.$Gc(1e4);function O(l){return b(l,"NFD",A)}const I=/[^\u0000-\u0080]/;function b(l,m,u){if(!l)return l;const $=u.get(l);if($)return $;let p;return I.test(l)?p=l.normalize(m):p=l,u.set(l,p),p}e.$sm=function(){const l=/[\u0300-\u036f]/g;return function(m){return O(m).replace(l,"")}}()}),define(le[146],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Rm=e.$Qm=void 0,e.$Om=i,e.rot=r,e.$Tm=I;function i(b,l,m){return Math.min(Math.max(b,l),m)}function r(b,l){return(l+b%l)%l}class v{constructor(){this.a=0}getNext(){return this.a++}}e.$Qm=v;class A{constructor(){this.a=1,this.b=0}update(l){return this.b=this.b+(l-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Rm=A;class O{constructor(l){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(l),this.c.fill(0,0,l)}update(l){const m=this.c[this.d];return this.c[this.d]=l,this.d=(this.d+1)%this.c.length,this.e-=m,this.e+=l,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Sm=O;function I(b,l,m,u,$,p,d,f){const y=d-m,k=f-u,g=$-m,E=p-u,S=b-m,s=l-u,a=y*y+k*k,t=y*g+k*E,o=y*S+k*s,n=g*g+E*E,c=g*S+E*s,h=1/(a*n-t*t),P=(n*o-t*c)*h,w=(a*c-t*o)*h;return P>=0&&w>=0&&P+w<1}}),function(){function K(v){const A=[];typeof v=="number"&&A.push("code/timeOrigin",v);function O(b){A.push(b,Date.now())}function I(){const b=[];for(let l=0;l<A.length;l+=2)b.push({name:A[l],startTime:A[l+1]});return b}return{mark:O,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(v){performance.mark(v)},getMarks(){let v=performance.timeOrigin;typeof v!="number"&&(v=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(v)}];for(const O of performance.getEntriesByType("mark"))A.push({name:O.name,startTime:Math.round(v+O.startTime)});return A}};if(typeof process=="object"){const v=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(v)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function i(v){return v.MonacoPerformanceMarks||(v.MonacoPerformanceMarks=e()),v.MonacoPerformanceMarks}var r;typeof global=="object"?r=global:typeof self=="object"?r=self:r={},typeof define=="function"?define("vs/base/common/performance",[],function(){return i(r)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=i(r):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),r.perf=i(r))}(),define(le[3],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.OS=e.OperatingSystem=e.$C=e.$B=e.$A=e.$z=e.$y=e.Language=e.$x=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.Platform=e.$h=void 0,e.$i=a,e.$E=P,e.$K=w,e.$h="en";let i=!1,r=!1,v=!1,A=!1,O=!1,I=!1,b=!1,l=!1,m=!1,u=!1,$,p=e.$h,d=e.$h,f,y;const k=globalThis;let g;typeof k.vscode<"u"&&typeof k.vscode.process<"u"?g=k.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(g=process);const E=typeof g?.versions?.electron=="string",S=E&&g?.type==="renderer";if(typeof g=="object"){i=g.platform==="win32",r=g.platform==="darwin",v=g.platform==="linux",A=v&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,b=E,m=!!g.env.CI||!!g.env.BUILD_ARTIFACTSTAGINGDIRECTORY,$=e.$h,p=e.$h;const D=g.env.VSCODE_NLS_CONFIG;if(D)try{const L=JSON.parse(D);$=L.userLocale,d=L.osLocale,p=L.resolvedLanguage||e.$h,f=L.languagePack?.translationsConfigFile}catch{}O=!0}else typeof navigator=="object"&&!S?(y=navigator.userAgent,i=y.indexOf("Windows")>=0,r=y.indexOf("Macintosh")>=0,l=(y.indexOf("Macintosh")>=0||y.indexOf("iPad")>=0||y.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,v=y.indexOf("Linux")>=0,u=y?.indexOf("Mobi")>=0,I=!0,p=globalThis._VSCODE_NLS_LANGUAGE||e.$h,$=navigator.language.toLowerCase(),d=$):console.error("Unable to resolve platform.");var s;(function(D){D[D.Web=0]="Web",D[D.Mac=1]="Mac",D[D.Linux=2]="Linux",D[D.Windows=3]="Windows"})(s||(e.Platform=s={}));function a(D){switch(D){case s.Web:return"Web";case s.Mac:return"Mac";case s.Linux:return"Linux";case s.Windows:return"Windows"}}let t=s.Web;r?t=s.Mac:i?t=s.Windows:v&&(t=s.Linux),e.$j=i,e.$k=r,e.$l=v,e.$m=A,e.$n=O,e.$o=b,e.$p=I,e.$q=I&&typeof k.importScripts=="function",e.$r=e.$q?k.origin:void 0,e.$s=l,e.$t=u,e.$u=m,e.$v=t,e.$w=y,e.$x=p;var o;(function(D){function L(){return e.$x}D.value=L;function R(){return e.$x.length===2?e.$x==="en":e.$x.length>=3?e.$x[0]==="e"&&e.$x[1]==="n"&&e.$x[2]==="-":!1}D.isDefaultVariant=R;function T(){return e.$x==="en"}D.isDefault=T})(o||(e.Language=o={})),e.$y=$,e.$z=d,e.$A=f,e.$B=typeof k.postMessage=="function"&&!k.importScripts,e.$C=(()=>{if(e.$B){const D=[];k.addEventListener("message",R=>{if(R.data&&R.data.vscodeScheduleAsyncWork)for(let T=0,j=D.length;T<j;T++){const G=D[T];if(G.id===R.data.vscodeScheduleAsyncWork){D.splice(T,1),G.callback();return}}});let L=0;return R=>{const T=++L;D.push({id:T,callback:R}),k.postMessage({vscodeScheduleAsyncWork:T},"*")}}return D=>setTimeout(D)})();var n;(function(D){D[D.Windows=1]="Windows",D[D.Macintosh=2]="Macintosh",D[D.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=r||l?n.Macintosh:i?n.Windows:n.Linux;let c=!0,h=!1;function P(){if(!h){h=!0;const D=new Uint8Array(2);D[0]=1,D[1]=2,c=new Uint16Array(D.buffer)[0]===513}return c}e.$F=!!(e.$w&&e.$w.indexOf("Chrome")>=0),e.$G=!!(e.$w&&e.$w.indexOf("Firefox")>=0),e.$H=!!(!e.$F&&e.$w&&e.$w.indexOf("Safari")>=0),e.$I=!!(e.$w&&e.$w.indexOf("Edg/")>=0),e.$J=!!(e.$w&&e.$w.indexOf("Android")>=0);function w(D){return parseFloat(D)>=20}}),define(le[37],ue([0,1,3]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hc=e.$gc=e.env=e.cwd=void 0;let r;const v=globalThis.vscode;if(typeof v<"u"&&typeof v.process<"u"){const A=v.process;r={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"&&typeof process?.versions?.node=="string"?r={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:r={get platform(){return i.$j?"win32":i.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=r.cwd,e.env=r.env,e.$gc=r.platform,e.$hc=r.arch});var Rt=this&&this.__createBinding||(Object.create?function(K,e,i,r){r===void 0&&(r=i);var v=Object.getOwnPropertyDescriptor(e,i);(!v||("get"in v?!e.__esModule:v.writable||v.configurable))&&(v={enumerable:!0,get:function(){return e[i]}}),Object.defineProperty(K,r,v)}:function(K,e,i,r){r===void 0&&(r=i),K[r]=e[i]}),Ot=this&&this.__setModuleDefault||(Object.create?function(K,e){Object.defineProperty(K,"default",{enumerable:!0,value:e})}:function(K,e){K.default=e}),Ie=this&&this.__importStar||function(K){if(K&&K.__esModule)return K;var e={};if(K!=null)for(var i in K)i!=="default"&&Object.prototype.hasOwnProperty.call(K,i)&&Rt(e,K,i);return Ot(e,K),e};define(le[9],ue([0,1,37]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.sep=e.$uc=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=void 0,i=Ie(i);const r=65,v=97,A=90,O=122,I=46,b=47,l=92,m=58,u=63;class $ extends Error{constructor(o,n,c){let h;typeof n=="string"&&n.indexOf("not ")===0?(h="must not be",n=n.replace(/^not /,"")):h="must be";const P=o.indexOf(".")!==-1?"property":"argument";let w=`The "${o}" ${P} ${h} of type ${n}`;w+=`. Received type ${typeof c}`,super(w),this.code="ERR_INVALID_ARG_TYPE"}}function p(t,o){if(t===null||typeof t!="object")throw new $(o,"Object",t)}function d(t,o){if(typeof t!="string")throw new $(o,"string",t)}const f=i.$gc==="win32";function y(t){return t===b||t===l}function k(t){return t===b}function g(t){return t>=r&&t<=A||t>=v&&t<=O}function E(t,o,n,c){let h="",P=0,w=-1,D=0,L=0;for(let R=0;R<=t.length;++R){if(R<t.length)L=t.charCodeAt(R);else{if(c(L))break;L=b}if(c(L)){if(!(w===R-1||D===1))if(D===2){if(h.length<2||P!==2||h.charCodeAt(h.length-1)!==I||h.charCodeAt(h.length-2)!==I){if(h.length>2){const T=h.lastIndexOf(n);T===-1?(h="",P=0):(h=h.slice(0,T),P=h.length-1-h.lastIndexOf(n)),w=R,D=0;continue}else if(h.length!==0){h="",P=0,w=R,D=0;continue}}o&&(h+=h.length>0?`${n}..`:"..",P=2)}else h.length>0?h+=`${n}${t.slice(w+1,R)}`:h=t.slice(w+1,R),P=R-w-1;w=R,D=0}else L===I&&D!==-1?++D:D=-1}return h}function S(t){return t?`${t[0]==="."?"":"."}${t}`:""}function s(t,o){p(o,"pathObject");const n=o.dir||o.root,c=o.base||`${o.name||""}${S(o.ext)}`;return n?n===o.root?`${n}${c}`:`${n}${t}${c}`:c}e.$ic={resolve(...t){let o="",n="",c=!1;for(let h=t.length-1;h>=-1;h--){let P;if(h>=0){if(P=t[h],d(P,`paths[${h}]`),P.length===0)continue}else o.length===0?P=i.cwd():(P=i.env[`=${o}`]||i.cwd(),(P===void 0||P.slice(0,2).toLowerCase()!==o.toLowerCase()&&P.charCodeAt(2)===l)&&(P=`${o}\\`));const w=P.length;let D=0,L="",R=!1;const T=P.charCodeAt(0);if(w===1)y(T)&&(D=1,R=!0);else if(y(T))if(R=!0,y(P.charCodeAt(1))){let j=2,G=j;for(;j<w&&!y(P.charCodeAt(j));)j++;if(j<w&&j!==G){const q=P.slice(G,j);for(G=j;j<w&&y(P.charCodeAt(j));)j++;if(j<w&&j!==G){for(G=j;j<w&&!y(P.charCodeAt(j));)j++;(j===w||j!==G)&&(L=`\\\\${q}\\${P.slice(G,j)}`,D=j)}}}else D=1;else g(T)&&P.charCodeAt(1)===m&&(L=P.slice(0,2),D=2,w>2&&y(P.charCodeAt(2))&&(R=!0,D=3));if(L.length>0)if(o.length>0){if(L.toLowerCase()!==o.toLowerCase())continue}else o=L;if(c){if(o.length>0)break}else if(n=`${P.slice(D)}\\${n}`,c=R,R&&o.length>0)break}return n=E(n,!c,"\\",y),c?`${o}\\${n}`:`${o}${n}`||"."},normalize(t){d(t,"path");const o=t.length;if(o===0)return".";let n=0,c,h=!1;const P=t.charCodeAt(0);if(o===1)return k(P)?"\\":t;if(y(P))if(h=!0,y(t.charCodeAt(1))){let D=2,L=D;for(;D<o&&!y(t.charCodeAt(D));)D++;if(D<o&&D!==L){const R=t.slice(L,D);for(L=D;D<o&&y(t.charCodeAt(D));)D++;if(D<o&&D!==L){for(L=D;D<o&&!y(t.charCodeAt(D));)D++;if(D===o)return`\\\\${R}\\${t.slice(L)}\\`;D!==L&&(c=`\\\\${R}\\${t.slice(L,D)}`,n=D)}}}else n=1;else g(P)&&t.charCodeAt(1)===m&&(c=t.slice(0,2),n=2,o>2&&y(t.charCodeAt(2))&&(h=!0,n=3));let w=n<o?E(t.slice(n),!h,"\\",y):"";return w.length===0&&!h&&(w="."),w.length>0&&y(t.charCodeAt(o-1))&&(w+="\\"),c===void 0?h?`\\${w}`:w:h?`${c}\\${w}`:`${c}${w}`},isAbsolute(t){d(t,"path");const o=t.length;if(o===0)return!1;const n=t.charCodeAt(0);return y(n)||o>2&&g(n)&&t.charCodeAt(1)===m&&y(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,n;for(let P=0;P<t.length;++P){const w=t[P];d(w,"path"),w.length>0&&(o===void 0?o=n=w:o+=`\\${w}`)}if(o===void 0)return".";let c=!0,h=0;if(typeof n=="string"&&y(n.charCodeAt(0))){++h;const P=n.length;P>1&&y(n.charCodeAt(1))&&(++h,P>2&&(y(n.charCodeAt(2))?++h:c=!1))}if(c){for(;h<o.length&&y(o.charCodeAt(h));)h++;h>=2&&(o=`\\${o.slice(h)}`)}return e.$ic.normalize(o)},relative(t,o){if(d(t,"from"),d(o,"to"),t===o)return"";const n=e.$ic.resolve(t),c=e.$ic.resolve(o);if(n===c||(t=n.toLowerCase(),o=c.toLowerCase(),t===o))return"";let h=0;for(;h<t.length&&t.charCodeAt(h)===l;)h++;let P=t.length;for(;P-1>h&&t.charCodeAt(P-1)===l;)P--;const w=P-h;let D=0;for(;D<o.length&&o.charCodeAt(D)===l;)D++;let L=o.length;for(;L-1>D&&o.charCodeAt(L-1)===l;)L--;const R=L-D,T=w<R?w:R;let j=-1,G=0;for(;G<T;G++){const Q=t.charCodeAt(h+G);if(Q!==o.charCodeAt(D+G))break;Q===l&&(j=G)}if(G!==T){if(j===-1)return c}else{if(R>T){if(o.charCodeAt(D+G)===l)return c.slice(D+G+1);if(G===2)return c.slice(D+G)}w>T&&(t.charCodeAt(h+G)===l?j=G:G===2&&(j=3)),j===-1&&(j=0)}let q="";for(G=h+j+1;G<=P;++G)(G===P||t.charCodeAt(G)===l)&&(q+=q.length===0?"..":"\\..");return D+=j,q.length>0?`${q}${c.slice(D,L)}`:(c.charCodeAt(D)===l&&++D,c.slice(D,L))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.$ic.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===l){if(o.charCodeAt(1)===l){const n=o.charCodeAt(2);if(n!==u&&n!==I)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(g(o.charCodeAt(0))&&o.charCodeAt(1)===m&&o.charCodeAt(2)===l)return`\\\\?\\${o}`;return t},dirname(t){d(t,"path");const o=t.length;if(o===0)return".";let n=-1,c=0;const h=t.charCodeAt(0);if(o===1)return y(h)?t:".";if(y(h)){if(n=c=1,y(t.charCodeAt(1))){let D=2,L=D;for(;D<o&&!y(t.charCodeAt(D));)D++;if(D<o&&D!==L){for(L=D;D<o&&y(t.charCodeAt(D));)D++;if(D<o&&D!==L){for(L=D;D<o&&!y(t.charCodeAt(D));)D++;if(D===o)return t;D!==L&&(n=c=D+1)}}}}else g(h)&&t.charCodeAt(1)===m&&(n=o>2&&y(t.charCodeAt(2))?3:2,c=n);let P=-1,w=!0;for(let D=o-1;D>=c;--D)if(y(t.charCodeAt(D))){if(!w){P=D;break}}else w=!1;if(P===-1){if(n===-1)return".";P=n}return t.slice(0,P)},basename(t,o){o!==void 0&&d(o,"suffix"),d(t,"path");let n=0,c=-1,h=!0,P;if(t.length>=2&&g(t.charCodeAt(0))&&t.charCodeAt(1)===m&&(n=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let w=o.length-1,D=-1;for(P=t.length-1;P>=n;--P){const L=t.charCodeAt(P);if(y(L)){if(!h){n=P+1;break}}else D===-1&&(h=!1,D=P+1),w>=0&&(L===o.charCodeAt(w)?--w===-1&&(c=P):(w=-1,c=D))}return n===c?c=D:c===-1&&(c=t.length),t.slice(n,c)}for(P=t.length-1;P>=n;--P)if(y(t.charCodeAt(P))){if(!h){n=P+1;break}}else c===-1&&(h=!1,c=P+1);return c===-1?"":t.slice(n,c)},extname(t){d(t,"path");let o=0,n=-1,c=0,h=-1,P=!0,w=0;t.length>=2&&t.charCodeAt(1)===m&&g(t.charCodeAt(0))&&(o=c=2);for(let D=t.length-1;D>=o;--D){const L=t.charCodeAt(D);if(y(L)){if(!P){c=D+1;break}continue}h===-1&&(P=!1,h=D+1),L===I?n===-1?n=D:w!==1&&(w=1):n!==-1&&(w=-1)}return n===-1||h===-1||w===0||w===1&&n===h-1&&n===c+1?"":t.slice(n,h)},format:s.bind(null,"\\"),parse(t){d(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const n=t.length;let c=0,h=t.charCodeAt(0);if(n===1)return y(h)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(y(h)){if(c=1,y(t.charCodeAt(1))){let j=2,G=j;for(;j<n&&!y(t.charCodeAt(j));)j++;if(j<n&&j!==G){for(G=j;j<n&&y(t.charCodeAt(j));)j++;if(j<n&&j!==G){for(G=j;j<n&&!y(t.charCodeAt(j));)j++;j===n?c=j:j!==G&&(c=j+1)}}}}else if(g(h)&&t.charCodeAt(1)===m){if(n<=2)return o.root=o.dir=t,o;if(c=2,y(t.charCodeAt(2))){if(n===3)return o.root=o.dir=t,o;c=3}}c>0&&(o.root=t.slice(0,c));let P=-1,w=c,D=-1,L=!0,R=t.length-1,T=0;for(;R>=c;--R){if(h=t.charCodeAt(R),y(h)){if(!L){w=R+1;break}continue}D===-1&&(L=!1,D=R+1),h===I?P===-1?P=R:T!==1&&(T=1):P!==-1&&(T=-1)}return D!==-1&&(P===-1||T===0||T===1&&P===D-1&&P===w+1?o.base=o.name=t.slice(w,D):(o.name=t.slice(w,P),o.base=t.slice(w,D),o.ext=t.slice(P,D))),w>0&&w!==c?o.dir=t.slice(0,w-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(f){const t=/\\/g;return()=>{const o=i.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>i.cwd()})();e.$jc={resolve(...t){let o="",n=!1;for(let c=t.length-1;c>=-1&&!n;c--){const h=c>=0?t[c]:a();d(h,`paths[${c}]`),h.length!==0&&(o=`${h}/${o}`,n=h.charCodeAt(0)===b)}return o=E(o,!n,"/",k),n?`/${o}`:o.length>0?o:"."},normalize(t){if(d(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===b,n=t.charCodeAt(t.length-1)===b;return t=E(t,!o,"/",k),t.length===0?o?"/":n?"./":".":(n&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return d(t,"path"),t.length>0&&t.charCodeAt(0)===b},join(...t){if(t.length===0)return".";let o;for(let n=0;n<t.length;++n){const c=t[n];d(c,"path"),c.length>0&&(o===void 0?o=c:o+=`/${c}`)}return o===void 0?".":e.$jc.normalize(o)},relative(t,o){if(d(t,"from"),d(o,"to"),t===o||(t=e.$jc.resolve(t),o=e.$jc.resolve(o),t===o))return"";const n=1,c=t.length,h=c-n,P=1,w=o.length-P,D=h<w?h:w;let L=-1,R=0;for(;R<D;R++){const j=t.charCodeAt(n+R);if(j!==o.charCodeAt(P+R))break;j===b&&(L=R)}if(R===D)if(w>D){if(o.charCodeAt(P+R)===b)return o.slice(P+R+1);if(R===0)return o.slice(P+R)}else h>D&&(t.charCodeAt(n+R)===b?L=R:R===0&&(L=0));let T="";for(R=n+L+1;R<=c;++R)(R===c||t.charCodeAt(R)===b)&&(T+=T.length===0?"..":"/..");return`${T}${o.slice(P+L)}`},toNamespacedPath(t){return t},dirname(t){if(d(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===b;let n=-1,c=!0;for(let h=t.length-1;h>=1;--h)if(t.charCodeAt(h)===b){if(!c){n=h;break}}else c=!1;return n===-1?o?"/":".":o&&n===1?"//":t.slice(0,n)},basename(t,o){o!==void 0&&d(o,"ext"),d(t,"path");let n=0,c=-1,h=!0,P;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let w=o.length-1,D=-1;for(P=t.length-1;P>=0;--P){const L=t.charCodeAt(P);if(L===b){if(!h){n=P+1;break}}else D===-1&&(h=!1,D=P+1),w>=0&&(L===o.charCodeAt(w)?--w===-1&&(c=P):(w=-1,c=D))}return n===c?c=D:c===-1&&(c=t.length),t.slice(n,c)}for(P=t.length-1;P>=0;--P)if(t.charCodeAt(P)===b){if(!h){n=P+1;break}}else c===-1&&(h=!1,c=P+1);return c===-1?"":t.slice(n,c)},extname(t){d(t,"path");let o=-1,n=0,c=-1,h=!0,P=0;for(let w=t.length-1;w>=0;--w){const D=t.charCodeAt(w);if(D===b){if(!h){n=w+1;break}continue}c===-1&&(h=!1,c=w+1),D===I?o===-1?o=w:P!==1&&(P=1):o!==-1&&(P=-1)}return o===-1||c===-1||P===0||P===1&&o===c-1&&o===n+1?"":t.slice(o,c)},format:s.bind(null,"/"),parse(t){d(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const n=t.charCodeAt(0)===b;let c;n?(o.root="/",c=1):c=0;let h=-1,P=0,w=-1,D=!0,L=t.length-1,R=0;for(;L>=c;--L){const T=t.charCodeAt(L);if(T===b){if(!D){P=L+1;break}continue}w===-1&&(D=!1,w=L+1),T===I?h===-1?h=L:R!==1&&(R=1):h!==-1&&(R=-1)}if(w!==-1){const T=P===0&&n?1:P;h===-1||R===0||R===1&&h===w-1&&h===P+1?o.base=o.name=t.slice(T,w):(o.name=t.slice(T,h),o.base=t.slice(T,w),o.ext=t.slice(h,w))}return P>0?o.dir=t.slice(0,P-1):n&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$jc.win32=e.$ic.win32=e.$ic,e.$jc.posix=e.$ic.posix=e.$jc,e.$kc=f?e.$ic.normalize:e.$jc.normalize,e.$lc=f?e.$ic.isAbsolute:e.$jc.isAbsolute,e.$mc=f?e.$ic.join:e.$jc.join,e.$nc=f?e.$ic.resolve:e.$jc.resolve,e.$oc=f?e.$ic.relative:e.$jc.relative,e.$pc=f?e.$ic.dirname:e.$jc.dirname,e.$qc=f?e.$ic.basename:e.$jc.basename,e.$rc=f?e.$ic.extname:e.$jc.extname,e.$sc=f?e.$ic.format:e.$jc.format,e.$tc=f?e.$ic.parse:e.$jc.parse,e.$uc=f?e.$ic.toNamespacedPath:e.$jc.toNamespacedPath,e.sep=f?e.$ic.sep:e.$jc.sep,e.$wc=f?e.$ic.delimiter:e.$jc.delimiter}),define(le[80],ue([0,1,3]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$om=A,e.$pm=O;var r;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(r||(e.Source=r={}));var v;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(v||(e.TerminateResponseCode=v={}));function A(I,...b){const l=b.reduce(($,p)=>($[p]=!0,$),{}),m=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter($=>!l[$]).forEach($=>{for(let p=0;p<m.length;p++)if($.search(m[p])!==-1){delete I[$];break}})}function O(I){I&&(delete I.DEBUG,i.$l&&delete I.LD_PRELOAD)}}),function(K,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var i=e();for(var r in i)(typeof exports=="object"?exports:K)[r]=i[r]}}(typeof self<"u"?self:this,function(){return function(K){var e={};function i(r){if(e[r])return e[r].exports;var v=e[r]={i:r,l:!1,exports:{}};return K[r].call(v.exports,v,v.exports,i),v.l=!0,v.exports}return i.m=K,i.c=e,i.d=function(r,v,A){i.o(r,v)||Object.defineProperty(r,v,{enumerable:!0,get:A})},i.r=function(r){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(r,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(r,"__esModule",{value:!0})},i.t=function(r,v){if(1&v&&(r=i(r)),8&v||4&v&&typeof r=="object"&&r&&r.__esModule)return r;var A=Object.create(null);if(i.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:r}),2&v&&typeof r!="string")for(var O in r)i.d(A,O,function(I){return r[I]}.bind(null,O));return A},i.n=function(r){var v=r&&r.__esModule?function(){return r.default}:function(){return r};return i.d(v,"a",v),v},i.o=function(r,v){return Object.prototype.hasOwnProperty.call(r,v)},i.p="",i(i.s=0)}([function(K,e,i){(function(r){var v;e=K.exports=ce,v=typeof r=="object"&&r.env&&r.env.NODE_DEBUG&&/\bsemver\b/i.test(r.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],b=e.src=[],l=0,m=l++;b[m]="0|[1-9]\\d*";var u=l++;b[u]="[0-9]+";var $=l++;b[$]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=l++;b[p]="("+b[m]+")\\.("+b[m]+")\\.("+b[m]+")";var d=l++;b[d]="("+b[u]+")\\.("+b[u]+")\\.("+b[u]+")";var f=l++;b[f]="(?:"+b[m]+"|"+b[$]+")";var y=l++;b[y]="(?:"+b[u]+"|"+b[$]+")";var k=l++;b[k]="(?:-("+b[f]+"(?:\\."+b[f]+")*))";var g=l++;b[g]="(?:-?("+b[y]+"(?:\\."+b[y]+")*))";var E=l++;b[E]="[0-9A-Za-z-]+";var S=l++;b[S]="(?:\\+("+b[E]+"(?:\\."+b[E]+")*))";var s=l++,a="v?"+b[p]+b[k]+"?"+b[S]+"?";b[s]="^"+a+"$";var t="[v=\\s]*"+b[d]+b[g]+"?"+b[S]+"?",o=l++;b[o]="^"+t+"$";var n=l++;b[n]="((?:<|>)?=?)";var c=l++;b[c]=b[u]+"|x|X|\\*";var h=l++;b[h]=b[m]+"|x|X|\\*";var P=l++;b[P]="[v=\\s]*("+b[h]+")(?:\\.("+b[h]+")(?:\\.("+b[h]+")(?:"+b[k]+")?"+b[S]+"?)?)?";var w=l++;b[w]="[v=\\s]*("+b[c]+")(?:\\.("+b[c]+")(?:\\.("+b[c]+")(?:"+b[g]+")?"+b[S]+"?)?)?";var D=l++;b[D]="^"+b[n]+"\\s*"+b[P]+"$";var L=l++;b[L]="^"+b[n]+"\\s*"+b[w]+"$";var R=l++;b[R]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var T=l++;b[T]="(?:~>?)";var j=l++;b[j]="(\\s*)"+b[T]+"\\s+",I[j]=new RegExp(b[j],"g");var G=l++;b[G]="^"+b[T]+b[P]+"$";var q=l++;b[q]="^"+b[T]+b[w]+"$";var Q=l++;b[Q]="(?:\\^)";var de=l++;b[de]="(\\s*)"+b[Q]+"\\s+",I[de]=new RegExp(b[de],"g");var V=l++;b[V]="^"+b[Q]+b[P]+"$";var Y=l++;b[Y]="^"+b[Q]+b[w]+"$";var B=l++;b[B]="^"+b[n]+"\\s*("+t+")$|^$";var _=l++;b[_]="^"+b[n]+"\\s*("+a+")$|^$";var C=l++;b[C]="(\\s*)"+b[n]+"\\s*("+t+"|"+b[P]+")",I[C]=new RegExp(b[C],"g");var W=l++;b[W]="^\\s*("+b[P]+")\\s+-\\s+("+b[P]+")\\s*$";var F=l++;b[F]="^\\s*("+b[w]+")\\s+-\\s+("+b[w]+")\\s*$";var H=l++;b[H]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)v(ne,b[ne]),I[ne]||(I[ne]=new RegExp(b[ne]));function x(ee,he){if(ee instanceof ce)return ee;if(typeof ee!="string"||ee.length>A||!(he?I[o]:I[s]).test(ee))return null;try{return new ce(ee,he)}catch{return null}}function ce(ee,he){if(ee instanceof ce){if(ee.loose===he)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof ce))return new ce(ee,he);v("SemVer",ee,he),this.loose=he;var fe=ee.trim().match(he?I[o]:I[s]);if(!fe)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(pe){if(/^[0-9]+$/.test(pe)){var ve=+pe;if(ve>=0&&ve<O)return ve}return pe}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=x,e.valid=function(ee,he){var fe=x(ee,he);return fe?fe.version:null},e.clean=function(ee,he){var fe=x(ee.trim().replace(/^[=v]+/,""),he);return fe?fe.version:null},e.SemVer=ce,ce.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ce.prototype.toString=function(){return this.version},ce.prototype.compare=function(ee){return v("SemVer.compare",this.version,this.loose,ee),ee instanceof ce||(ee=new ce(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},ce.prototype.compareMain=function(ee){return ee instanceof ce||(ee=new ce(ee,this.loose)),J(this.major,ee.major)||J(this.minor,ee.minor)||J(this.patch,ee.patch)},ce.prototype.comparePre=function(ee){if(ee instanceof ce||(ee=new ce(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var he=0;do{var fe=this.prerelease[he],pe=ee.prerelease[he];if(v("prerelease compare",he,fe,pe),fe===void 0&&pe===void 0)return 0;if(pe===void 0)return 1;if(fe===void 0)return-1;if(fe!==pe)return J(fe,pe)}while(++he)},ce.prototype.inc=function(ee,he){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",he);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",he);break;case"prepatch":this.prerelease.length=0,this.inc("patch",he),this.inc("pre",he);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",he),this.inc("pre",he);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}he&&(this.prerelease[0]===he?isNaN(this.prerelease[1])&&(this.prerelease=[he,0]):this.prerelease=[he,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,he,fe,pe){typeof fe=="string"&&(pe=fe,fe=void 0);try{return new ce(ee,fe).inc(he,pe).version}catch{return null}},e.diff=function(ee,he){if(N(ee,he))return null;var fe=x(ee),pe=x(he);if(fe.prerelease.length||pe.prerelease.length){for(var ve in fe)if((ve==="major"||ve==="minor"||ve==="patch")&&fe[ve]!==pe[ve])return"pre"+ve;return"prerelease"}for(var ve in fe)if((ve==="major"||ve==="minor"||ve==="patch")&&fe[ve]!==pe[ve])return ve},e.compareIdentifiers=J;var oe=/^[0-9]+$/;function J(ee,he){var fe=oe.test(ee),pe=oe.test(he);return fe&&pe&&(ee=+ee,he=+he),fe&&!pe?-1:pe&&!fe?1:ee<he?-1:ee>he?1:0}function M(ee,he,fe){return new ce(ee,fe).compare(new ce(he,fe))}function Z(ee,he,fe){return M(ee,he,fe)>0}function U(ee,he,fe){return M(ee,he,fe)<0}function N(ee,he,fe){return M(ee,he,fe)===0}function ie(ee,he,fe){return M(ee,he,fe)!==0}function X(ee,he,fe){return M(ee,he,fe)>=0}function z(ee,he,fe){return M(ee,he,fe)<=0}function te(ee,he,fe,pe){var ve;switch(he){case"===":typeof ee=="object"&&(ee=ee.version),typeof fe=="object"&&(fe=fe.version),ve=ee===fe;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof fe=="object"&&(fe=fe.version),ve=ee!==fe;break;case"":case"=":case"==":ve=N(ee,fe,pe);break;case"!=":ve=ie(ee,fe,pe);break;case">":ve=Z(ee,fe,pe);break;case">=":ve=X(ee,fe,pe);break;case"<":ve=U(ee,fe,pe);break;case"<=":ve=z(ee,fe,pe);break;default:throw new TypeError("Invalid operator: "+he)}return ve}function ae(ee,he){if(ee instanceof ae){if(ee.loose===he)return ee;ee=ee.value}if(!(this instanceof ae))return new ae(ee,he);v("comparator",ee,he),this.loose=he,this.parse(ee),this.semver===me?this.value="":this.value=this.operator+this.semver.version,v("comp",this)}e.rcompareIdentifiers=function(ee,he){return J(he,ee)},e.major=function(ee,he){return new ce(ee,he).major},e.minor=function(ee,he){return new ce(ee,he).minor},e.patch=function(ee,he){return new ce(ee,he).patch},e.compare=M,e.compareLoose=function(ee,he){return M(ee,he,!0)},e.rcompare=function(ee,he,fe){return M(he,ee,fe)},e.sort=function(ee,he){return ee.sort(function(fe,pe){return e.compare(fe,pe,he)})},e.rsort=function(ee,he){return ee.sort(function(fe,pe){return e.rcompare(fe,pe,he)})},e.gt=Z,e.lt=U,e.eq=N,e.neq=ie,e.gte=X,e.lte=z,e.cmp=te,e.Comparator=ae;var me={};function be(ee,he){if(ee instanceof be)return ee.loose===he?ee:new be(ee.raw,he);if(ee instanceof ae)return new be(ee.value,he);if(!(this instanceof be))return new be(ee,he);if(this.loose=he,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function ye(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function Fe(ee,he,fe,pe,ve,je,Oe,De,We,Ke,Ze,ze,Ye){return((he=ye(fe)?"":ye(pe)?">="+fe+".0.0":ye(ve)?">="+fe+"."+pe+".0":">="+he)+" "+(De=ye(We)?"":ye(Ke)?"<"+(+We+1)+".0.0":ye(Ze)?"<"+We+"."+(+Ke+1)+".0":ze?"<="+We+"."+Ke+"."+Ze+"-"+ze:"<="+De)).trim()}function Ve(ee,he){for(var fe=0;fe<ee.length;fe++)if(!ee[fe].test(he))return!1;if(he.prerelease.length){for(fe=0;fe<ee.length;fe++)if(v(ee[fe].semver),ee[fe].semver!==me&&ee[fe].semver.prerelease.length>0){var pe=ee[fe].semver;if(pe.major===he.major&&pe.minor===he.minor&&pe.patch===he.patch)return!0}return!1}return!0}function Re(ee,he,fe){try{he=new be(he,fe)}catch{return!1}return he.test(ee)}function $e(ee,he,fe,pe){var ve,je,Oe,De,We;switch(ee=new ce(ee,pe),he=new be(he,pe),fe){case">":ve=Z,je=z,Oe=U,De=">",We=">=";break;case"<":ve=U,je=X,Oe=Z,De="<",We="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Re(ee,he,pe))return!1;for(var Ke=0;Ke<he.set.length;++Ke){var Ze=he.set[Ke],ze=null,Ye=null;if(Ze.forEach(function(Qe){Qe.semver===me&&(Qe=new ae(">=0.0.0")),ze=ze||Qe,Ye=Ye||Qe,ve(Qe.semver,ze.semver,pe)?ze=Qe:Oe(Qe.semver,Ye.semver,pe)&&(Ye=Qe)}),ze.operator===De||ze.operator===We||(!Ye.operator||Ye.operator===De)&&je(ee,Ye.semver)||Ye.operator===We&&Oe(ee,Ye.semver))return!1}return!0}ae.prototype.parse=function(ee){var he=this.loose?I[B]:I[_],fe=ee.match(he);if(!fe)throw new TypeError("Invalid comparator: "+ee);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new ce(fe[2],this.loose):this.semver=me},ae.prototype.toString=function(){return this.value},ae.prototype.test=function(ee){return v("Comparator.test",ee,this.loose),this.semver===me||(typeof ee=="string"&&(ee=new ce(ee,this.loose)),te(ee,this.operator,this.semver,this.loose))},ae.prototype.intersects=function(ee,he){if(!(ee instanceof ae))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new be(ee.value,he),Re(this.value,fe,he);if(ee.operator==="")return fe=new be(this.value,he),Re(ee.semver,fe,he);var pe=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),ve=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),je=this.semver.version===ee.semver.version,Oe=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),De=te(this.semver,"<",ee.semver,he)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),We=te(this.semver,">",ee.semver,he)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return pe||ve||je&&Oe||De||We},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(ee){var he=this.loose;ee=ee.trim(),v("range",ee,he);var fe=he?I[F]:I[W];ee=ee.replace(fe,Fe),v("hyphen replace",ee),ee=ee.replace(I[C],"$1$2$3"),v("comparator trim",ee,I[C]),ee=(ee=(ee=ee.replace(I[j],"$1~")).replace(I[de],"$1^")).split(/\s+/).join(" ");var pe=he?I[B]:I[_],ve=ee.split(" ").map(function(je){return function(Oe,De){return v("comp",Oe),Oe=function(We,Ke){return We.trim().split(/\s+/).map(function(Ze){return function(ze,Ye){v("caret",ze,Ye);var Qe=Ye?I[Y]:I[V];return ze.replace(Qe,function(Je,Ce,se,ge,we){var Ee;return v("caret",ze,Je,Ce,se,ge,we),ye(Ce)?Ee="":ye(se)?Ee=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":ye(ge)?Ee=Ce==="0"?">="+Ce+"."+se+".0 <"+Ce+"."+(+se+1)+".0":">="+Ce+"."+se+".0 <"+(+Ce+1)+".0.0":we?(v("replaceCaret pr",we),we.charAt(0)!=="-"&&(we="-"+we),Ee=Ce==="0"?se==="0"?">="+Ce+"."+se+"."+ge+we+" <"+Ce+"."+se+"."+(+ge+1):">="+Ce+"."+se+"."+ge+we+" <"+Ce+"."+(+se+1)+".0":">="+Ce+"."+se+"."+ge+we+" <"+(+Ce+1)+".0.0"):(v("no pr"),Ee=Ce==="0"?se==="0"?">="+Ce+"."+se+"."+ge+" <"+Ce+"."+se+"."+(+ge+1):">="+Ce+"."+se+"."+ge+" <"+Ce+"."+(+se+1)+".0":">="+Ce+"."+se+"."+ge+" <"+(+Ce+1)+".0.0"),v("caret return",Ee),Ee})}(Ze,Ke)}).join(" ")}(Oe,De),v("caret",Oe),Oe=function(We,Ke){return We.trim().split(/\s+/).map(function(Ze){return function(ze,Ye){var Qe=Ye?I[q]:I[G];return ze.replace(Qe,function(Je,Ce,se,ge,we){var Ee;return v("tilde",ze,Je,Ce,se,ge,we),ye(Ce)?Ee="":ye(se)?Ee=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":ye(ge)?Ee=">="+Ce+"."+se+".0 <"+Ce+"."+(+se+1)+".0":we?(v("replaceTilde pr",we),we.charAt(0)!=="-"&&(we="-"+we),Ee=">="+Ce+"."+se+"."+ge+we+" <"+Ce+"."+(+se+1)+".0"):Ee=">="+Ce+"."+se+"."+ge+" <"+Ce+"."+(+se+1)+".0",v("tilde return",Ee),Ee})}(Ze,Ke)}).join(" ")}(Oe,De),v("tildes",Oe),Oe=function(We,Ke){return v("replaceXRanges",We,Ke),We.split(/\s+/).map(function(Ze){return function(ze,Ye){ze=ze.trim();var Qe=Ye?I[L]:I[D];return ze.replace(Qe,function(Je,Ce,se,ge,we,Ee){v("xRange",ze,Je,Ce,se,ge,we,Ee);var Me=ye(se),Be=Me||ye(ge),_e=Be||ye(we);return Ce==="="&&_e&&(Ce=""),Me?Je=Ce===">"||Ce==="<"?"<0.0.0":"*":Ce&&_e?(Be&&(ge=0),_e&&(we=0),Ce===">"?(Ce=">=",Be?(se=+se+1,ge=0,we=0):_e&&(ge=+ge+1,we=0)):Ce==="<="&&(Ce="<",Be?se=+se+1:ge=+ge+1),Je=Ce+se+"."+ge+"."+we):Be?Je=">="+se+".0.0 <"+(+se+1)+".0.0":_e&&(Je=">="+se+"."+ge+".0 <"+se+"."+(+ge+1)+".0"),v("xRange return",Je),Je})}(Ze,Ke)}).join(" ")}(Oe,De),v("xrange",Oe),Oe=function(We,Ke){return v("replaceStars",We,Ke),We.trim().replace(I[H],"")}(Oe,De),v("stars",Oe),Oe}(je,he)}).join(" ").split(/\s+/);return this.loose&&(ve=ve.filter(function(je){return!!je.match(pe)})),ve=ve.map(function(je){return new ae(je,he)})},be.prototype.intersects=function(ee,he){if(!(ee instanceof be))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(pe){return ee.set.some(function(ve){return ve.every(function(je){return pe.intersects(je,he)})})})})},e.toComparators=function(ee,he){return new be(ee,he).set.map(function(fe){return fe.map(function(pe){return pe.value}).join(" ").trim().split(" ")})},be.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new ce(ee,this.loose));for(var he=0;he<this.set.length;he++)if(Ve(this.set[he],ee))return!0;return!1},e.satisfies=Re,e.maxSatisfying=function(ee,he,fe){var pe=null,ve=null;try{var je=new be(he,fe)}catch{return null}return ee.forEach(function(Oe){je.test(Oe)&&(pe&&ve.compare(Oe)!==-1||(ve=new ce(pe=Oe,fe)))}),pe},e.minSatisfying=function(ee,he,fe){var pe=null,ve=null;try{var je=new be(he,fe)}catch{return null}return ee.forEach(function(Oe){je.test(Oe)&&(pe&&ve.compare(Oe)!==1||(ve=new ce(pe=Oe,fe)))}),pe},e.validRange=function(ee,he){try{return new be(ee,he).range||"*"}catch{return null}},e.ltr=function(ee,he,fe){return $e(ee,he,"<",fe)},e.gtr=function(ee,he,fe){return $e(ee,he,">",fe)},e.outside=$e,e.prerelease=function(ee,he){var fe=x(ee,he);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(ee,he,fe){return ee=new be(ee,fe),he=new be(he,fe),ee.intersects(he)},e.coerce=function(ee){if(ee instanceof ce)return ee;if(typeof ee!="string")return null;var he=ee.match(I[R]);return he==null?null:x((he[1]||"0")+"."+(he[2]||"0")+"."+(he[3]||"0"))}}).call(this,i(1))},function(K,e){var i,r,v=K.exports={};function A(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function I(y){if(i===setTimeout)return setTimeout(y,0);if((i===A||!i)&&setTimeout)return i=setTimeout,setTimeout(y,0);try{return i(y,0)}catch{try{return i.call(null,y,0)}catch{return i.call(this,y,0)}}}(function(){try{i=typeof setTimeout=="function"?setTimeout:A}catch{i=A}try{r=typeof clearTimeout=="function"?clearTimeout:O}catch{r=O}})();var b,l=[],m=!1,u=-1;function $(){m&&b&&(m=!1,b.length?l=b.concat(l):u=-1,l.length&&p())}function p(){if(!m){var y=I($);m=!0;for(var k=l.length;k;){for(b=l,l=[];++u<k;)b&&b[u].run();u=-1,k=l.length}b=null,m=!1,function(g){if(r===clearTimeout)return clearTimeout(g);if((r===O||!r)&&clearTimeout)return r=clearTimeout,clearTimeout(g);try{r(g)}catch{try{return r.call(null,g)}catch{return r.call(this,g)}}}(y)}}function d(y,k){this.fun=y,this.array=k}function f(){}v.nextTick=function(y){var k=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)k[g-1]=arguments[g];l.push(new d(y,k)),l.length!==1||m||I(p)},d.prototype.run=function(){this.fun.apply(null,this.array)},v.title="browser",v.browser=!0,v.env={},v.argv=[],v.version="",v.versions={},v.on=f,v.addListener=f,v.once=f,v.off=f,v.removeListener=f,v.removeAllListeners=f,v.emit=f,v.prependListener=f,v.prependOnceListener=f,v.listeners=function(y){return[]},v.binding=function(y){throw new Error("process.binding is not supported")},v.cwd=function(){return"/"},v.chdir=function(y){throw new Error("process.chdir is not supported")},v.umask=function(){return 0}}])}),define(le[147],ue([0,1]),function(K,e){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zs=void 0;class r{constructor(I,b,l){this.level=I,this.key=b,this.value=l,this.forward=[]}}const v=void 0;class A{constructor(I,b=2**16){this.comparator=I,this[i]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(b)|0),this.e=new r(this.c,v,v)}get size(){return this.f}clear(){this.e=new r(this.c,v,v),this.f=0}has(I){return!!A.g(this,I,this.comparator)}get(I){return A.g(this,I,this.comparator)?.value}set(I,b){return A.h(this,I,b,this.comparator)&&(this.f+=1),this}delete(I){const b=A.k(this,I,this.comparator);return b&&(this.f-=1),b}forEach(I,b){let l=this.e.forward[0];for(;l;)I.call(b,l.value,l.key,this),l=l.forward[0]}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",b=this.e.forward[0];for(;b;)I+=`node(${b.key}, ${b.value}, lvl:${b.level})`,b=b.forward[0];return I}static g(I,b,l){let m=I.e;for(let u=I.d-1;u>=0;u--)for(;m.forward[u]&&l(m.forward[u].key,b)<0;)m=m.forward[u];if(m=m.forward[0],m&&l(m.key,b)===0)return m}static h(I,b,l,m){const u=[];let $=I.e;for(let p=I.d-1;p>=0;p--){for(;$.forward[p]&&m($.forward[p].key,b)<0;)$=$.forward[p];u[p]=$}if($=$.forward[0],$&&m($.key,b)===0)return $.value=l,!1;{const p=A.j(I);if(p>I.d){for(let d=I.d;d<p;d++)u[d]=I.e;I.d=p}$=new r(p,b,l);for(let d=0;d<p;d++)$.forward[d]=u[d].forward[d],u[d].forward[d]=$;return!0}}static j(I,b=.5){let l=1;for(;Math.random()<b&&l<I.c;)l+=1;return l}static k(I,b,l){const m=[];let u=I.e;for(let $=I.d-1;$>=0;$--){for(;u.forward[$]&&l(u.forward[$].key,b)<0;)u=u.forward[$];m[$]=u}if(u=u.forward[0],!u||l(u.key,b)!==0)return!1;for(let $=0;$<I.d&&m[$].forward[$]===u;$++)m[$].forward[$]=u.forward[$];for(;I.d>0&&I.e.forward[I.d-1]===v;)I.d-=1;return!0}}e.$Zs=A}),define(le[60],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class r{static create(A){return new r(A)}constructor(A){this.c=i&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ie=r}),define(le[4],ue([0,1,15,91,2,111,60]),function(K,e,i,r,v,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$ke=e.Event=void 0,e.$le=p;const I=!1,b=!1,l=!1;var m;(function(q){q.None=()=>v.$Xc.None;function Q(Re){if(l){const{onDidAddListener:$e}=Re,ee=f.create();let he=0;Re.onDidAddListener=()=>{++he===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ee.print()),$e?.()}}}function de(Re,$e){return ce(Re,()=>{},0,void 0,!0,void 0,$e)}q.defer=de;function V(Re){return($e,ee=null,he)=>{let fe=!1,pe;return pe=Re(ve=>{if(!fe)return pe?pe.dispose():fe=!0,$e.call(ee,ve)},null,he),fe&&pe.dispose(),pe}}q.once=V;function Y(Re,$e){return q.once(q.filter(Re,$e))}q.onceIf=Y;function B(Re,$e,ee){return ne((he,fe=null,pe)=>Re(ve=>he.call(fe,$e(ve)),null,pe),ee)}q.map=B;function _(Re,$e,ee){return ne((he,fe=null,pe)=>Re(ve=>{$e(ve),he.call(fe,ve)},null,pe),ee)}q.forEach=_;function C(Re,$e,ee){return ne((he,fe=null,pe)=>Re(ve=>$e(ve)&&he.call(fe,ve),null,pe),ee)}q.filter=C;function W(Re){return Re}q.signal=W;function F(...Re){return($e,ee=null,he)=>{const fe=(0,v.$Uc)(...Re.map(pe=>pe(ve=>$e.call(ee,ve))));return x(fe,he)}}q.any=F;function H(Re,$e,ee,he){let fe=ee;return B(Re,pe=>(fe=$e(fe,pe),fe),he)}q.reduce=H;function ne(Re,$e){let ee;const he={onWillAddFirstListener(){ee=Re(fe.fire,fe)},onDidRemoveLastListener(){ee?.dispose()}};$e||Q(he);const fe=new t(he);return $e?.add(fe),fe.event}function x(Re,$e){return $e instanceof Array?$e.push(Re):$e&&$e.add(Re),Re}function ce(Re,$e,ee=100,he=!1,fe=!1,pe,ve){let je,Oe,De,We=0,Ke;const Ze={leakWarningThreshold:pe,onWillAddFirstListener(){je=Re(Ye=>{We++,Oe=$e(Oe,Ye),he&&!De&&(ze.fire(Oe),Oe=void 0),Ke=()=>{const Qe=Oe;Oe=void 0,De=void 0,(!he||We>1)&&ze.fire(Qe),We=0},typeof ee=="number"?(clearTimeout(De),De=setTimeout(Ke,ee)):De===void 0&&(De=0,queueMicrotask(Ke))})},onWillRemoveListener(){fe&&We>0&&Ke?.()},onDidRemoveLastListener(){Ke=void 0,je.dispose()}};ve||Q(Ze);const ze=new t(Ze);return ve?.add(ze),ze.event}q.debounce=ce;function oe(Re,$e=0,ee){return q.debounce(Re,(he,fe)=>he?(he.push(fe),he):[fe],$e,void 0,!0,void 0,ee)}q.accumulate=oe;function J(Re,$e=(he,fe)=>he===fe,ee){let he=!0,fe;return C(Re,pe=>{const ve=he||!$e(pe,fe);return he=!1,fe=pe,ve},ee)}q.latch=J;function M(Re,$e,ee){return[q.filter(Re,$e,ee),q.filter(Re,he=>!$e(he),ee)]}q.split=M;function Z(Re,$e=!1,ee=[],he){let fe=ee.slice(),pe=Re(Oe=>{fe?fe.push(Oe):je.fire(Oe)});he&&he.add(pe);const ve=()=>{fe?.forEach(Oe=>je.fire(Oe)),fe=null},je=new t({onWillAddFirstListener(){pe||(pe=Re(Oe=>je.fire(Oe)),he&&he.add(pe))},onDidAddFirstListener(){fe&&($e?setTimeout(ve):ve())},onDidRemoveLastListener(){pe&&pe.dispose(),pe=null}});return he&&he.add(je),je.event}q.buffer=Z;function U(Re,$e){return(he,fe,pe)=>{const ve=$e(new ie);return Re(function(je){const Oe=ve.evaluate(je);Oe!==N&&he.call(fe,Oe)},void 0,pe)}}q.chain=U;const N=Symbol("HaltChainable");class ie{constructor(){this.f=[]}map($e){return this.f.push($e),this}forEach($e){return this.f.push(ee=>($e(ee),ee)),this}filter($e){return this.f.push(ee=>$e(ee)?ee:N),this}reduce($e,ee){let he=ee;return this.f.push(fe=>(he=$e(he,fe),he)),this}latch($e=(ee,he)=>ee===he){let ee=!0,he;return this.f.push(fe=>{const pe=ee||!$e(fe,he);return ee=!1,he=fe,pe?fe:N}),this}evaluate($e){for(const ee of this.f)if($e=ee($e),$e===N)break;return $e}}function X(Re,$e,ee=he=>he){const he=(...je)=>ve.fire(ee(...je)),fe=()=>Re.on($e,he),pe=()=>Re.removeListener($e,he),ve=new t({onWillAddFirstListener:fe,onDidRemoveLastListener:pe});return ve.event}q.fromNodeEventEmitter=X;function z(Re,$e,ee=he=>he){const he=(...je)=>ve.fire(ee(...je)),fe=()=>Re.addEventListener($e,he),pe=()=>Re.removeEventListener($e,he),ve=new t({onWillAddFirstListener:fe,onDidRemoveLastListener:pe});return ve.event}q.fromDOMEventEmitter=z;function te(Re){return new Promise($e=>V(Re)($e))}q.toPromise=te;function ae(Re){const $e=new t;return Re.then(ee=>{$e.fire(ee)},()=>{$e.fire(void 0)}).finally(()=>{$e.dispose()}),$e.event}q.fromPromise=ae;function me(Re,$e){return Re(ee=>$e.fire(ee))}q.forward=me;function be(Re,$e,ee){return $e(ee),Re(he=>$e(he))}q.runAndSubscribe=be;class ye{constructor($e,ee){this._observable=$e,this.f=0,this.g=!1;const he={onWillAddFirstListener:()=>{$e.addObserver(this),this._observable.reportChanges()},onDidRemoveLastListener:()=>{$e.removeObserver(this)}};ee||Q(he),this.emitter=new t(he),ee&&ee.add(this.emitter)}beginUpdate($e){this.f++}handlePossibleChange($e){}handleChange($e,ee){this.g=!0}endUpdate($e){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Fe(Re,$e){return new ye(Re,$e).emitter.event}q.fromObservable=Fe;function Ve(Re){return($e,ee,he)=>{let fe=0,pe=!1;const ve={beginUpdate(){fe++},endUpdate(){fe--,fe===0&&(Re.reportChanges(),pe&&(pe=!1,$e.call(ee)))},handlePossibleChange(){},handleChange(){pe=!0}};Re.addObserver(ve),Re.reportChanges();const je={dispose(){Re.removeObserver(ve)}};return he instanceof v.$Wc?he.add(je):Array.isArray(he)&&he.push(je),je}}q.fromObservableLight=Ve})(m||(e.Event=m={}));class u{static{this.all=new Set}static{this.f=0}constructor(Q){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${Q}_${u.f++}`,u.all.add(this)}start(Q){this.g=new O.$ie,this.listenerCount=Q}stop(){if(this.g){const Q=this.g.elapsed();this.durations.push(Q),this.elapsedOverall+=Q,this.invocationCount+=1,this.g=void 0}}}e.$ke=u;let $=-1;function p(q){const Q=$;return $=q,{dispose(){$=Q}}}class d{static{this.f=1}constructor(Q,de,V=(d.f++).toString(16).padStart(3,"0")){this.j=Q,this.threshold=de,this.name=V,this.h=0}dispose(){this.g?.clear()}check(Q,de){const V=this.threshold;if(V<=0||de<V)return;this.g||(this.g=new Map);const Y=this.g.get(Q.value)||0;if(this.g.set(Q.value,Y+1),this.h-=1,this.h<=0){this.h=V*.5;const[B,_]=this.getMostFrequentStack(),C=`[${this.name}] potential listener LEAK detected, having ${de} listeners already. MOST frequent listener (${_}):`;console.warn(C),console.warn(B);const W=new y(C,B);this.j(W)}return()=>{const B=this.g.get(Q.value)||0;this.g.set(Q.value,B-1)}}getMostFrequentStack(){if(!this.g)return;let Q,de=0;for(const[V,Y]of this.g)(!Q||de<Y)&&(Q=[V,Y],de=Y);return Q}}class f{static create(){const Q=new Error;return new f(Q.stack??"")}constructor(Q){this.value=Q}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class y extends Error{constructor(Q,de){super(Q),this.name="ListenerLeakError",this.stack=de}}e.$me=y;class k extends Error{constructor(Q,de){super(Q),this.name="ListenerRefusalError",this.stack=de}}e.$ne=k;let g=0;class E{constructor(Q){this.value=Q,this.id=g++}}const S=2,s=(q,Q)=>{if(q instanceof E)Q(q);else for(let de=0;de<q.length;de++){const V=q[de];V&&Q(V)}};let a;if(I){const q=[];setInterval(()=>{q.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(q.join(`
`)),q.length=0)},3e3),a=new FinalizationRegistry(Q=>{typeof Q=="string"&&q.push(Q)})}class t{constructor(Q){this.z=0,this.f=Q,this.g=$>0||this.f?.leakWarningThreshold?new d(Q?.onListenerError??i.$2,this.f?.leakWarningThreshold??$):void 0,this.j=this.f?._profName?new u(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(b){const Q=this.u;queueMicrotask(()=>{s(Q,de=>de.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(Q,de,V)=>{if(this.g&&this.z>this.g.threshold**2){const W=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(W);const F=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],H=new k(`${W}. HINT: Stack shows most frequent listener (${F[1]}-times)`,F[0]);return(this.f?.onListenerError||i.$2)(H),v.$Xc.None}if(this.m)return v.$Xc.None;de&&(Q=Q.bind(de));const Y=new E(Q);let B,_;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(Y.stack=f.create(),B=this.g.check(Y.stack,this.z+1)),b&&(Y.stack=_??f.create()),this.u?this.u instanceof E?(this.w??=new n,this.u=[this.u,Y]):this.u.push(Y):(this.f?.onWillAddFirstListener?.(this),this.u=Y,this.f?.onDidAddFirstListener?.(this)),this.z++;const C=(0,v.$Vc)(()=>{a?.unregister(C),B?.(),this.A(Y)});if(V instanceof v.$Wc?V.add(C):Array.isArray(V)&&V.push(C),a){const W=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),F=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(W);a.register(C,F?.[2]??W,C)}return C},this.q}A(Q){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const de=this.u,V=de.indexOf(Q);if(V===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,de[V]=void 0;const Y=this.w.current===this;if(this.z*S<=de.length){let B=0;for(let _=0;_<de.length;_++)de[_]?de[B++]=de[_]:Y&&(this.w.end--,B<this.w.i&&this.w.i--);de.length=B}}B(Q,de){if(!Q)return;const V=this.f?.onListenerError||i.$2;if(!V){Q.value(de);return}try{Q.value(de)}catch(Y){V(Y)}}C(Q){const de=Q.current.u;for(;Q.i<Q.end;)this.B(de[Q.i++],Q.value);Q.reset()}fire(Q){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof E)this.B(this.u,Q);else{const de=this.w;de.enqueue(this,Q,this.u.length),this.C(de)}this.j?.stop()}hasListeners(){return this.z>0}}e.$oe=t;const o=()=>new n;e.$pe=o;class n{constructor(){this.i=-1,this.end=0}enqueue(Q,de,V){this.i=0,this.end=V,this.current=Q,this.value=de}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class c extends t{async fireAsync(Q,de,V){if(this.u)for(this.h||(this.h=new A.$8c),s(this.u,Y=>this.h.push([Y.value,Q]));this.h.size>0&&!de.isCancellationRequested;){const[Y,B]=this.h.shift(),_=[],C={...B,token:de,waitUntil:W=>{if(Object.isFrozen(_))throw new Error("waitUntil can NOT be called asynchronous");V&&(W=V(W,Y)),_.push(W)}};try{Y(C)}catch(W){(0,i.$2)(W);continue}Object.freeze(_),await Promise.allSettled(_).then(W=>{for(const F of W)F.status==="rejected"&&(0,i.$2)(F.reason)})}}}e.$qe=c;class h extends t{get isPaused(){return this.h!==0}constructor(Q){super(Q),this.h=0,this.s=new A.$8c,this.t=Q?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const Q=Array.from(this.s);this.s.clear(),super.fire(this.t(Q))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(Q){this.z&&(this.h!==0?this.s.push(Q):super.fire(Q))}}e.$re=h;class P extends h{constructor(Q){super(Q),this.k=Q.delay??100}fire(Q){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(Q)}}e.$se=P;class w extends t{constructor(Q){super(Q),this.h=[],this.k=Q?.merge}fire(Q){this.hasListeners()&&(this.h.push(Q),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(de=>super.fire(de)),this.h=[]}))}}e.$te=w;class D{constructor(){this.g=!1,this.h=[],this.f=new t({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(Q){const de={event:Q,listener:null};this.h.push(de),this.g&&this.m(de);const V=()=>{this.g&&this.o(de);const Y=this.h.indexOf(de);this.h.splice(Y,1)};return(0,v.$Vc)((0,r.$fb)(V))}j(){this.g=!0,this.h.forEach(Q=>this.m(Q))}k(){this.g=!1,this.h.forEach(Q=>this.o(Q))}m(Q){Q.listener=Q.event(de=>this.f.fire(de))}o(Q){Q.listener?.dispose(),Q.listener=null}dispose(){this.f.dispose();for(const Q of this.h)Q.listener?.dispose();this.h=[]}}e.$ue=D;class L{constructor(Q,de,V,Y){this.f=new v.$Wc;const B=this.f.add(new D),_=this.f.add(new v.$7c);function C(W){_.set(W,B.add(Y(W)))}for(const W of Q)C(W);this.f.add(de(W=>{C(W)})),this.f.add(V(W=>{_.deleteAndDispose(W)})),this.event=B.event}dispose(){this.f.dispose()}}e.$ve=L;class R{constructor(){this.f=[]}wrapEvent(Q,de,V){return(Y,B,_)=>Q(C=>{const W=this.f[this.f.length-1];if(!de){W?W.buffers.push(()=>Y.call(B,C)):Y.call(B,C);return}const F=W;if(!F){Y.call(B,de(V,C));return}F.items??=[],F.items.push(C),F.buffers.length===0&&W.buffers.push(()=>{F.reducedResult??=V?F.items.reduce(de,V):F.items.reduce(de),Y.call(B,F.reducedResult)})},void 0,_)}bufferEvents(Q){const de={buffers:new Array};this.f.push(de);const V=Q();return this.f.pop(),de.buffers.forEach(Y=>Y()),V}}e.$we=R;class T{constructor(){this.f=!1,this.g=m.None,this.h=v.$Xc.None,this.j=new t({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(Q){this.g=Q,this.f&&(this.h.dispose(),this.h=Q(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$xe=T;class j{static const(Q){return new G(Q)}constructor(Q){this.g=Q,this.f=new t,this.onDidChange=this.f.event}get value(){return this.g}set value(Q){Q!==this.g&&(this.g=Q,this.f.fire(void 0))}}e.$ye=j;class G{constructor(Q){this.value=Q,this.onDidChange=m.None}}}),define(le[22],ue([0,1,4]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.CancellationToken=void 0,e.$Ae=I;const r=Object.freeze(function(b,l){const m=setTimeout(b.bind(l),0);return{dispose(){clearTimeout(m)}}});var v;(function(b){function l(m){return m===b.None||m===b.Cancelled||m instanceof A?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}b.isCancellationToken=l,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:r})})(v||(e.CancellationToken=v={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?r:(this.b||(this.b=new i.$oe),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class O{constructor(l){this.f=void 0,this.g=void 0,this.g=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=v.Cancelled}dispose(l=!1){l&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=v.None}}e.$ze=O;function I(b){const l=new O;return b.add({dispose(){l.cancel()}}),l.token}}),define(le[148],ue([0,1,22]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cf=e.$bf=e.$_e=void 0,e.$af=v;class r{constructor(b){this.b=b,this.a=null}get(){if(this.a)return this.a;const b=new i.$ze,l=this.b(b.token);return this.a={promise:l,dispose:()=>{this.a=null,b.cancel(),b.dispose()}},this.a}}e.$_e=r;function v(I){return I}class A{constructor(b,l){this.a=void 0,this.b=void 0,typeof b=="function"?(this.c=b,this.d=v):(this.c=l,this.d=b.getCacheKey)}get(b){const l=this.d(b);return this.b!==l&&(this.b=l,this.a=this.c(b)),this.a}}e.$bf=A;class O{get cachedValues(){return this.a}constructor(b,l){this.a=new Map,this.b=new Map,typeof b=="function"?(this.c=b,this.d=v):(this.c=l,this.d=b.getCacheKey)}get(b){const l=this.d(b);if(this.b.has(l))return this.b.get(l);const m=this.c(b);return this.a.set(b,m),this.b.set(l,m),m}}e.$cf=O}),define(le[69],ue([0,1,15,2]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Be=v,e.$Ce=A,e.$De=O,e.$Ee=I,e.$Fe=l,e.$Ge=m,e.$He=u,e.$Ie=$,e.$Je=p,e.$Ke=d,e.$Le=f,e.$Me=y,e.$Ne=k,e.$Oe=g,e.$Pe=E;function v(S){const s=S;return s?typeof s.read=="function":!1}function A(S){const s=S;return s?[s.on,s.pause,s.resume,s.destroy].every(a=>typeof a=="function"):!1}function O(S){const s=S;return s?A(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}function I(S,s){return new b(S,s)}class b{constructor(s,a){this.e=s,this.f=a,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(s){if(!this.a.destroyed){if(this.a.flowing)this.g(s);else if(this.b.data.push(s),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(a=>this.d.push(a))}}error(s){this.a.destroyed||(this.a.flowing?this.h(s):this.b.error.push(s))}end(s){this.a.destroyed||(typeof s<"u"&&this.write(s),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(s){this.c.data.slice(0).forEach(a=>a(s))}h(s){this.c.error.length===0?(0,i.$2)(s):this.c.error.slice(0).forEach(a=>a(s))}i(){this.c.end.slice(0).forEach(s=>s())}on(s,a){if(!this.a.destroyed)switch(s){case"data":this.c.data.push(a),this.resume();break;case"end":this.c.end.push(a),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(a),this.a.flowing&&this.k();break}}removeListener(s,a){if(this.a.destroyed)return;let t;switch(s){case"data":t=this.c.data;break;case"end":t=this.c.end;break;case"error":t=this.c.error;break}if(t){const o=t.indexOf(a);o>=0&&t.splice(o,1)}}j(){if(this.b.data.length>0){const s=this.e(this.b.data);this.g(s),this.b.data.length=0;const a=[...this.d];this.d.length=0,a.forEach(t=>t())}}k(){if(this.c.error.length>0){for(const s of this.b.error)this.h(s);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l(S,s){const a=[];let t;for(;(t=S.read())!==null;)a.push(t);return s(a)}function m(S,s,a){const t=[];let o;for(;(o=S.read())!==null&&t.length<a;)t.push(o);return o===null&&t.length>0?s(t):{read:()=>{if(t.length>0)return t.shift();if(typeof o<"u"){const n=o;return o=void 0,n}return S.read()}}}function u(S,s){return new Promise((a,t)=>{const o=[];$(S,{onData:n=>{s&&o.push(n)},onError:n=>{s?t(n):a(void 0)},onEnd:()=>{a(s?s(o):void 0)}})})}function $(S,s,a){S.on("error",t=>{a?.isCancellationRequested||s.onError(t)}),S.on("end",()=>{a?.isCancellationRequested||s.onEnd()}),S.on("data",t=>{a?.isCancellationRequested||s.onData(t)})}function p(S,s){return new Promise((a,t)=>{const o=new r.$Wc,n=[],c=w=>{if(n.push(w),n.length>s)return o.dispose(),S.pause(),a({stream:S,buffer:n,ended:!1})},h=w=>(o.dispose(),t(w)),P=()=>(o.dispose(),a({stream:S,buffer:n,ended:!0}));o.add((0,r.$Vc)(()=>S.removeListener("error",h))),S.on("error",h),o.add((0,r.$Vc)(()=>S.removeListener("end",P))),S.on("end",P),o.add((0,r.$Vc)(()=>S.removeListener("data",c))),S.on("data",c)})}function d(S,s){const a=I(s);return a.end(S),a}function f(){const S=I(()=>{throw new Error("not supported")});return S.end(),S}function y(S){let s=!1;return{read:()=>s?null:(s=!0,S)}}function k(S,s,a){const t=I(a);return $(S,{onData:o=>t.write(s.data(o)),onError:o=>t.error(s.error?s.error(o):o),onEnd:()=>t.end()}),t}function g(S,s,a){let t=!1;return{read:()=>{const o=s.read();return t?o:(t=!0,o!==null?a([S,o]):S)}}}function E(S,s,a){let t=!1;const o=I(a);return $(s,{onData:n=>t?o.write(n):(t=!0,o.write(a([S,n]))),onError:n=>o.error(n),onEnd:()=>{t||(t=!0,o.write(S)),o.end()}}),o}}),define(le[17],ue([0,1,68,69]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qe=void 0,e.$Re=l,e.$Se=m,e.$Te=u,e.$Ue=$,e.$Ve=p,e.$We=d,e.$Xe=f,e.$Ye=y,e.$Ze=k,e.$1e=g,e.$2e=E,e.$3e=S,e.$4e=s,e.$5e=a,e.$6e=t,e.$7e=o,e.$8e=n,e.$9e=c,e.$0e=h,e.$$e=D,r=Ie(r);const v=typeof Buffer<"u",A=new i.$W(()=>new Uint8Array(256));let O,I;class b{static alloc(R){return v?new b(Buffer.allocUnsafe(R)):new b(new Uint8Array(R))}static wrap(R){return v&&!Buffer.isBuffer(R)&&(R=Buffer.from(R.buffer,R.byteOffset,R.byteLength)),new b(R)}static fromString(R,T){return!(T?.dontUseNodeBuffer||!1)&&v?new b(Buffer.from(R)):(O||(O=new TextEncoder),new b(O.encode(R)))}static fromByteArray(R){const T=b.alloc(R.length);for(let j=0,G=R.length;j<G;j++)T.buffer[j]=R[j];return T}static concat(R,T){if(typeof T>"u"){T=0;for(let q=0,Q=R.length;q<Q;q++)T+=R[q].byteLength}const j=b.alloc(T);let G=0;for(let q=0,Q=R.length;q<Q;q++){const de=R[q];j.set(de,G),G+=de.byteLength}return j}constructor(R){this.buffer=R,this.byteLength=this.buffer.byteLength}clone(){const R=b.alloc(this.byteLength);return R.set(this),R}toString(){return v?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(R,T){return new b(this.buffer.subarray(R,T))}set(R,T){if(R instanceof b)this.buffer.set(R.buffer,T);else if(R instanceof Uint8Array)this.buffer.set(R,T);else if(R instanceof ArrayBuffer)this.buffer.set(new Uint8Array(R),T);else if(ArrayBuffer.isView(R))this.buffer.set(new Uint8Array(R.buffer,R.byteOffset,R.byteLength),T);else throw new Error("Unknown argument 'array'")}readUInt32BE(R){return $(this.buffer,R)}writeUInt32BE(R,T){p(this.buffer,R,T)}readUInt32LE(R){return d(this.buffer,R)}writeUInt32LE(R,T){f(this.buffer,R,T)}readUInt8(R){return y(this.buffer,R)}writeUInt8(R,T){k(this.buffer,R,T)}indexOf(R,T=0){return l(this.buffer,R instanceof b?R.buffer:R,T)}}e.$Qe=b;function l(L,R,T=0){const j=R.byteLength,G=L.byteLength;if(j===0)return 0;if(j===1)return L.indexOf(R[0]);if(j>G-T)return-1;const q=A.value;q.fill(R.length);for(let Y=0;Y<R.length;Y++)q[R[Y]]=R.length-Y-1;let Q=T+R.length-1,de=Q,V=-1;for(;Q<G;)if(L[Q]===R[de]){if(de===0){V=Q;break}Q--,de--}else Q+=Math.max(R.length-de,q[L[Q]]),de=R.length-1;return V}function m(L,R){return L[R+0]<<0>>>0|L[R+1]<<8>>>0}function u(L,R,T){L[T+0]=R&255,R=R>>>8,L[T+1]=R&255}function $(L,R){return L[R]*2**24+L[R+1]*2**16+L[R+2]*2**8+L[R+3]}function p(L,R,T){L[T+3]=R,R=R>>>8,L[T+2]=R,R=R>>>8,L[T+1]=R,R=R>>>8,L[T]=R}function d(L,R){return L[R+0]<<0>>>0|L[R+1]<<8>>>0|L[R+2]<<16>>>0|L[R+3]<<24>>>0}function f(L,R,T){L[T+0]=R&255,R=R>>>8,L[T+1]=R&255,R=R>>>8,L[T+2]=R&255,R=R>>>8,L[T+3]=R&255}function y(L,R){return L[R]}function k(L,R,T){L[T]=R}function g(L){return r.$Fe(L,R=>b.concat(R))}function E(L){return r.$Me(L)}function S(L){return r.$He(L,R=>b.concat(R))}async function s(L){return L.ended?b.concat(L.buffer):b.concat([...L.buffer,await S(L.stream)])}function a(L){return r.$Ke(L,R=>b.concat(R))}function t(L){return r.$Ne(L,{data:R=>typeof R=="string"?b.fromString(R):b.wrap(R)},R=>b.concat(R))}function o(L){return r.$Ee(R=>b.concat(R),L)}function n(L,R){return r.$Oe(L,R,T=>b.concat(T))}function c(L,R){return r.$Pe(L,R,T=>b.concat(T))}function h(L){let R=0,T=0,j=0;const G=new Uint8Array(Math.floor(L.length/4*3)),q=de=>{switch(T){case 3:G[j++]=R|de,T=0;break;case 2:G[j++]=R|de>>>2,R=de<<6,T=3;break;case 1:G[j++]=R|de>>>4,R=de<<4,T=2;break;default:R=de<<2,T=1}};for(let de=0;de<L.length;de++){const V=L.charCodeAt(de);if(V>=65&&V<=90)q(V-65);else if(V>=97&&V<=122)q(V-97+26);else if(V>=48&&V<=57)q(V-48+52);else if(V===43||V===45)q(62);else if(V===47||V===95)q(63);else{if(V===61)break;throw new SyntaxError(`Unexpected base64 character ${L[de]}`)}}const Q=j;for(;T>0;)q(0);return b.wrap(G).slice(0,Q)}const P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function D({buffer:L},R=!0,T=!1){const j=T?w:P;let G="";const q=L.byteLength%3;let Q=0;for(;Q<L.byteLength-q;Q+=3){const de=L[Q+0],V=L[Q+1],Y=L[Q+2];G+=j[de>>>2],G+=j[(de<<4|V>>>4)&63],G+=j[(V<<2|Y>>>6)&63],G+=j[Y&63]}if(q===1){const de=L[Q+0];G+=j[de>>>2],G+=j[de<<4&63],R&&(G+="==")}else if(q===2){const de=L[Q+0],V=L[Q+1];G+=j[de>>>2],G+=j[(de<<4|V>>>4)&63],G+=j[V<<2&63],R&&(G+="=")}return G}}),define(le[149],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$je=void 0,e.$je=Symbol("MicrotaskDelay")}),define(le[12],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hg=i,e.$ig=r,e.$jg=v,e.$kg=A,e.$lg=O,e.$mg=I,e.$ng=b,e.$og=l,e.$pg=m,e.$qg=u,e.$rg=$,e.$sg=p,e.$tg=d,e.$ug=y,e.$vg=k,e.$wg=g,e.$xg=E,e.$yg=S,e.$zg=s;function i(a){return typeof a=="string"}function r(a){return Array.isArray(a)&&a.every(t=>i(t))}function v(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}function A(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}function O(a){return typeof a=="number"&&!isNaN(a)}function I(a){return!!a&&typeof a[Symbol.iterator]=="function"}function b(a){return a===!0||a===!1}function l(a){return typeof a>"u"}function m(a){return!u(a)}function u(a){return l(a)||a===null}function $(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function p(a){if(u(a))throw new Error("Assertion Failed: argument is undefined or null");return a}function d(...a){const t=[];for(let o=0;o<a.length;o++){const n=a[o];if(u(n))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);t.push(n)}return t}const f=Object.prototype.hasOwnProperty;function y(a){if(!v(a))return!1;for(const t in a)if(f.call(a,t))return!1;return!0}function k(a){return typeof a=="function"}function g(...a){return a.length>0&&a.every(k)}function E(a,t){const o=Math.min(a.length,t.length);for(let n=0;n<o;n++)S(a[n],t[n])}function S(a,t){if(i(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(k(t)){try{if(a instanceof t)return}catch{}if(!u(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function s(a){return a}}),define(le[112],ue([0,1,12]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=v,e.$4j=A;const r=Object.create(null);function v(O,I){if((0,i.$hg)(I)){const b=r[I];if(b===void 0)throw new Error(`${O} references an unknown codicon: ${I}`);I=b}return r[O]=I,{id:O}}function A(){return r}}),define(le[150],ue([0,1,112]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=void 0,e.$5j={add:(0,i.$3j)("add",6e4),plus:(0,i.$3j)("plus",6e4),gistNew:(0,i.$3j)("gist-new",6e4),repoCreate:(0,i.$3j)("repo-create",6e4),lightbulb:(0,i.$3j)("lightbulb",60001),lightBulb:(0,i.$3j)("light-bulb",60001),repo:(0,i.$3j)("repo",60002),repoDelete:(0,i.$3j)("repo-delete",60002),gistFork:(0,i.$3j)("gist-fork",60003),repoForked:(0,i.$3j)("repo-forked",60003),gitPullRequest:(0,i.$3j)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.$3j)("git-pull-request-abandoned",60004),recordKeys:(0,i.$3j)("record-keys",60005),keyboard:(0,i.$3j)("keyboard",60005),tag:(0,i.$3j)("tag",60006),gitPullRequestLabel:(0,i.$3j)("git-pull-request-label",60006),tagAdd:(0,i.$3j)("tag-add",60006),tagRemove:(0,i.$3j)("tag-remove",60006),person:(0,i.$3j)("person",60007),personFollow:(0,i.$3j)("person-follow",60007),personOutline:(0,i.$3j)("person-outline",60007),personFilled:(0,i.$3j)("person-filled",60007),gitBranch:(0,i.$3j)("git-branch",60008),gitBranchCreate:(0,i.$3j)("git-branch-create",60008),gitBranchDelete:(0,i.$3j)("git-branch-delete",60008),sourceControl:(0,i.$3j)("source-control",60008),mirror:(0,i.$3j)("mirror",60009),mirrorPublic:(0,i.$3j)("mirror-public",60009),star:(0,i.$3j)("star",60010),starAdd:(0,i.$3j)("star-add",60010),starDelete:(0,i.$3j)("star-delete",60010),starEmpty:(0,i.$3j)("star-empty",60010),comment:(0,i.$3j)("comment",60011),commentAdd:(0,i.$3j)("comment-add",60011),alert:(0,i.$3j)("alert",60012),warning:(0,i.$3j)("warning",60012),search:(0,i.$3j)("search",60013),searchSave:(0,i.$3j)("search-save",60013),logOut:(0,i.$3j)("log-out",60014),signOut:(0,i.$3j)("sign-out",60014),logIn:(0,i.$3j)("log-in",60015),signIn:(0,i.$3j)("sign-in",60015),eye:(0,i.$3j)("eye",60016),eyeUnwatch:(0,i.$3j)("eye-unwatch",60016),eyeWatch:(0,i.$3j)("eye-watch",60016),circleFilled:(0,i.$3j)("circle-filled",60017),primitiveDot:(0,i.$3j)("primitive-dot",60017),closeDirty:(0,i.$3j)("close-dirty",60017),debugBreakpoint:(0,i.$3j)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.$3j)("debug-breakpoint-disabled",60017),debugHint:(0,i.$3j)("debug-hint",60017),terminalDecorationSuccess:(0,i.$3j)("terminal-decoration-success",60017),primitiveSquare:(0,i.$3j)("primitive-square",60018),edit:(0,i.$3j)("edit",60019),pencil:(0,i.$3j)("pencil",60019),info:(0,i.$3j)("info",60020),issueOpened:(0,i.$3j)("issue-opened",60020),gistPrivate:(0,i.$3j)("gist-private",60021),gitForkPrivate:(0,i.$3j)("git-fork-private",60021),lock:(0,i.$3j)("lock",60021),mirrorPrivate:(0,i.$3j)("mirror-private",60021),close:(0,i.$3j)("close",60022),removeClose:(0,i.$3j)("remove-close",60022),x:(0,i.$3j)("x",60022),repoSync:(0,i.$3j)("repo-sync",60023),sync:(0,i.$3j)("sync",60023),clone:(0,i.$3j)("clone",60024),desktopDownload:(0,i.$3j)("desktop-download",60024),beaker:(0,i.$3j)("beaker",60025),microscope:(0,i.$3j)("microscope",60025),vm:(0,i.$3j)("vm",60026),deviceDesktop:(0,i.$3j)("device-desktop",60026),file:(0,i.$3j)("file",60027),fileText:(0,i.$3j)("file-text",60027),more:(0,i.$3j)("more",60028),ellipsis:(0,i.$3j)("ellipsis",60028),kebabHorizontal:(0,i.$3j)("kebab-horizontal",60028),mailReply:(0,i.$3j)("mail-reply",60029),reply:(0,i.$3j)("reply",60029),organization:(0,i.$3j)("organization",60030),organizationFilled:(0,i.$3j)("organization-filled",60030),organizationOutline:(0,i.$3j)("organization-outline",60030),newFile:(0,i.$3j)("new-file",60031),fileAdd:(0,i.$3j)("file-add",60031),newFolder:(0,i.$3j)("new-folder",60032),fileDirectoryCreate:(0,i.$3j)("file-directory-create",60032),trash:(0,i.$3j)("trash",60033),trashcan:(0,i.$3j)("trashcan",60033),history:(0,i.$3j)("history",60034),clock:(0,i.$3j)("clock",60034),folder:(0,i.$3j)("folder",60035),fileDirectory:(0,i.$3j)("file-directory",60035),symbolFolder:(0,i.$3j)("symbol-folder",60035),logoGithub:(0,i.$3j)("logo-github",60036),markGithub:(0,i.$3j)("mark-github",60036),github:(0,i.$3j)("github",60036),terminal:(0,i.$3j)("terminal",60037),console:(0,i.$3j)("console",60037),repl:(0,i.$3j)("repl",60037),zap:(0,i.$3j)("zap",60038),symbolEvent:(0,i.$3j)("symbol-event",60038),error:(0,i.$3j)("error",60039),stop:(0,i.$3j)("stop",60039),variable:(0,i.$3j)("variable",60040),symbolVariable:(0,i.$3j)("symbol-variable",60040),array:(0,i.$3j)("array",60042),symbolArray:(0,i.$3j)("symbol-array",60042),symbolModule:(0,i.$3j)("symbol-module",60043),symbolPackage:(0,i.$3j)("symbol-package",60043),symbolNamespace:(0,i.$3j)("symbol-namespace",60043),symbolObject:(0,i.$3j)("symbol-object",60043),symbolMethod:(0,i.$3j)("symbol-method",60044),symbolFunction:(0,i.$3j)("symbol-function",60044),symbolConstructor:(0,i.$3j)("symbol-constructor",60044),symbolBoolean:(0,i.$3j)("symbol-boolean",60047),symbolNull:(0,i.$3j)("symbol-null",60047),symbolNumeric:(0,i.$3j)("symbol-numeric",60048),symbolNumber:(0,i.$3j)("symbol-number",60048),symbolStructure:(0,i.$3j)("symbol-structure",60049),symbolStruct:(0,i.$3j)("symbol-struct",60049),symbolParameter:(0,i.$3j)("symbol-parameter",60050),symbolTypeParameter:(0,i.$3j)("symbol-type-parameter",60050),symbolKey:(0,i.$3j)("symbol-key",60051),symbolText:(0,i.$3j)("symbol-text",60051),symbolReference:(0,i.$3j)("symbol-reference",60052),goToFile:(0,i.$3j)("go-to-file",60052),symbolEnum:(0,i.$3j)("symbol-enum",60053),symbolValue:(0,i.$3j)("symbol-value",60053),symbolRuler:(0,i.$3j)("symbol-ruler",60054),symbolUnit:(0,i.$3j)("symbol-unit",60054),activateBreakpoints:(0,i.$3j)("activate-breakpoints",60055),archive:(0,i.$3j)("archive",60056),arrowBoth:(0,i.$3j)("arrow-both",60057),arrowDown:(0,i.$3j)("arrow-down",60058),arrowLeft:(0,i.$3j)("arrow-left",60059),arrowRight:(0,i.$3j)("arrow-right",60060),arrowSmallDown:(0,i.$3j)("arrow-small-down",60061),arrowSmallLeft:(0,i.$3j)("arrow-small-left",60062),arrowSmallRight:(0,i.$3j)("arrow-small-right",60063),arrowSmallUp:(0,i.$3j)("arrow-small-up",60064),arrowUp:(0,i.$3j)("arrow-up",60065),bell:(0,i.$3j)("bell",60066),bold:(0,i.$3j)("bold",60067),book:(0,i.$3j)("book",60068),bookmark:(0,i.$3j)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.$3j)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.$3j)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.$3j)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.$3j)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.$3j)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.$3j)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.$3j)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.$3j)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.$3j)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.$3j)("briefcase",60076),broadcast:(0,i.$3j)("broadcast",60077),browser:(0,i.$3j)("browser",60078),bug:(0,i.$3j)("bug",60079),calendar:(0,i.$3j)("calendar",60080),caseSensitive:(0,i.$3j)("case-sensitive",60081),check:(0,i.$3j)("check",60082),checklist:(0,i.$3j)("checklist",60083),chevronDown:(0,i.$3j)("chevron-down",60084),chevronLeft:(0,i.$3j)("chevron-left",60085),chevronRight:(0,i.$3j)("chevron-right",60086),chevronUp:(0,i.$3j)("chevron-up",60087),chromeClose:(0,i.$3j)("chrome-close",60088),chromeMaximize:(0,i.$3j)("chrome-maximize",60089),chromeMinimize:(0,i.$3j)("chrome-minimize",60090),chromeRestore:(0,i.$3j)("chrome-restore",60091),circleOutline:(0,i.$3j)("circle-outline",60092),circle:(0,i.$3j)("circle",60092),debugBreakpointUnverified:(0,i.$3j)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.$3j)("terminal-decoration-incomplete",60092),circleSlash:(0,i.$3j)("circle-slash",60093),circuitBoard:(0,i.$3j)("circuit-board",60094),clearAll:(0,i.$3j)("clear-all",60095),clippy:(0,i.$3j)("clippy",60096),closeAll:(0,i.$3j)("close-all",60097),cloudDownload:(0,i.$3j)("cloud-download",60098),cloudUpload:(0,i.$3j)("cloud-upload",60099),code:(0,i.$3j)("code",60100),collapseAll:(0,i.$3j)("collapse-all",60101),colorMode:(0,i.$3j)("color-mode",60102),commentDiscussion:(0,i.$3j)("comment-discussion",60103),creditCard:(0,i.$3j)("credit-card",60105),dash:(0,i.$3j)("dash",60108),dashboard:(0,i.$3j)("dashboard",60109),database:(0,i.$3j)("database",60110),debugContinue:(0,i.$3j)("debug-continue",60111),debugDisconnect:(0,i.$3j)("debug-disconnect",60112),debugPause:(0,i.$3j)("debug-pause",60113),debugRestart:(0,i.$3j)("debug-restart",60114),debugStart:(0,i.$3j)("debug-start",60115),debugStepInto:(0,i.$3j)("debug-step-into",60116),debugStepOut:(0,i.$3j)("debug-step-out",60117),debugStepOver:(0,i.$3j)("debug-step-over",60118),debugStop:(0,i.$3j)("debug-stop",60119),debug:(0,i.$3j)("debug",60120),deviceCameraVideo:(0,i.$3j)("device-camera-video",60121),deviceCamera:(0,i.$3j)("device-camera",60122),deviceMobile:(0,i.$3j)("device-mobile",60123),diffAdded:(0,i.$3j)("diff-added",60124),diffIgnored:(0,i.$3j)("diff-ignored",60125),diffModified:(0,i.$3j)("diff-modified",60126),diffRemoved:(0,i.$3j)("diff-removed",60127),diffRenamed:(0,i.$3j)("diff-renamed",60128),diff:(0,i.$3j)("diff",60129),diffSidebyside:(0,i.$3j)("diff-sidebyside",60129),discard:(0,i.$3j)("discard",60130),editorLayout:(0,i.$3j)("editor-layout",60131),emptyWindow:(0,i.$3j)("empty-window",60132),exclude:(0,i.$3j)("exclude",60133),extensions:(0,i.$3j)("extensions",60134),eyeClosed:(0,i.$3j)("eye-closed",60135),fileBinary:(0,i.$3j)("file-binary",60136),fileCode:(0,i.$3j)("file-code",60137),fileMedia:(0,i.$3j)("file-media",60138),filePdf:(0,i.$3j)("file-pdf",60139),fileSubmodule:(0,i.$3j)("file-submodule",60140),fileSymlinkDirectory:(0,i.$3j)("file-symlink-directory",60141),fileSymlinkFile:(0,i.$3j)("file-symlink-file",60142),fileZip:(0,i.$3j)("file-zip",60143),files:(0,i.$3j)("files",60144),filter:(0,i.$3j)("filter",60145),flame:(0,i.$3j)("flame",60146),foldDown:(0,i.$3j)("fold-down",60147),foldUp:(0,i.$3j)("fold-up",60148),fold:(0,i.$3j)("fold",60149),folderActive:(0,i.$3j)("folder-active",60150),folderOpened:(0,i.$3j)("folder-opened",60151),gear:(0,i.$3j)("gear",60152),gift:(0,i.$3j)("gift",60153),gistSecret:(0,i.$3j)("gist-secret",60154),gist:(0,i.$3j)("gist",60155),gitCommit:(0,i.$3j)("git-commit",60156),gitCompare:(0,i.$3j)("git-compare",60157),compareChanges:(0,i.$3j)("compare-changes",60157),gitMerge:(0,i.$3j)("git-merge",60158),githubAction:(0,i.$3j)("github-action",60159),githubAlt:(0,i.$3j)("github-alt",60160),globe:(0,i.$3j)("globe",60161),grabber:(0,i.$3j)("grabber",60162),graph:(0,i.$3j)("graph",60163),gripper:(0,i.$3j)("gripper",60164),heart:(0,i.$3j)("heart",60165),home:(0,i.$3j)("home",60166),horizontalRule:(0,i.$3j)("horizontal-rule",60167),hubot:(0,i.$3j)("hubot",60168),inbox:(0,i.$3j)("inbox",60169),issueReopened:(0,i.$3j)("issue-reopened",60171),issues:(0,i.$3j)("issues",60172),italic:(0,i.$3j)("italic",60173),jersey:(0,i.$3j)("jersey",60174),json:(0,i.$3j)("json",60175),kebabVertical:(0,i.$3j)("kebab-vertical",60176),key:(0,i.$3j)("key",60177),law:(0,i.$3j)("law",60178),lightbulbAutofix:(0,i.$3j)("lightbulb-autofix",60179),linkExternal:(0,i.$3j)("link-external",60180),link:(0,i.$3j)("link",60181),listOrdered:(0,i.$3j)("list-ordered",60182),listUnordered:(0,i.$3j)("list-unordered",60183),liveShare:(0,i.$3j)("live-share",60184),loading:(0,i.$3j)("loading",60185),location:(0,i.$3j)("location",60186),mailRead:(0,i.$3j)("mail-read",60187),mail:(0,i.$3j)("mail",60188),markdown:(0,i.$3j)("markdown",60189),megaphone:(0,i.$3j)("megaphone",60190),mention:(0,i.$3j)("mention",60191),milestone:(0,i.$3j)("milestone",60192),gitPullRequestMilestone:(0,i.$3j)("git-pull-request-milestone",60192),mortarBoard:(0,i.$3j)("mortar-board",60193),move:(0,i.$3j)("move",60194),multipleWindows:(0,i.$3j)("multiple-windows",60195),mute:(0,i.$3j)("mute",60196),noNewline:(0,i.$3j)("no-newline",60197),note:(0,i.$3j)("note",60198),octoface:(0,i.$3j)("octoface",60199),openPreview:(0,i.$3j)("open-preview",60200),package:(0,i.$3j)("package",60201),paintcan:(0,i.$3j)("paintcan",60202),pin:(0,i.$3j)("pin",60203),play:(0,i.$3j)("play",60204),run:(0,i.$3j)("run",60204),plug:(0,i.$3j)("plug",60205),preserveCase:(0,i.$3j)("preserve-case",60206),preview:(0,i.$3j)("preview",60207),project:(0,i.$3j)("project",60208),pulse:(0,i.$3j)("pulse",60209),question:(0,i.$3j)("question",60210),quote:(0,i.$3j)("quote",60211),radioTower:(0,i.$3j)("radio-tower",60212),reactions:(0,i.$3j)("reactions",60213),references:(0,i.$3j)("references",60214),refresh:(0,i.$3j)("refresh",60215),regex:(0,i.$3j)("regex",60216),remoteExplorer:(0,i.$3j)("remote-explorer",60217),remote:(0,i.$3j)("remote",60218),remove:(0,i.$3j)("remove",60219),replaceAll:(0,i.$3j)("replace-all",60220),replace:(0,i.$3j)("replace",60221),repoClone:(0,i.$3j)("repo-clone",60222),repoForcePush:(0,i.$3j)("repo-force-push",60223),repoPull:(0,i.$3j)("repo-pull",60224),repoPush:(0,i.$3j)("repo-push",60225),report:(0,i.$3j)("report",60226),requestChanges:(0,i.$3j)("request-changes",60227),rocket:(0,i.$3j)("rocket",60228),rootFolderOpened:(0,i.$3j)("root-folder-opened",60229),rootFolder:(0,i.$3j)("root-folder",60230),rss:(0,i.$3j)("rss",60231),ruby:(0,i.$3j)("ruby",60232),saveAll:(0,i.$3j)("save-all",60233),saveAs:(0,i.$3j)("save-as",60234),save:(0,i.$3j)("save",60235),screenFull:(0,i.$3j)("screen-full",60236),screenNormal:(0,i.$3j)("screen-normal",60237),searchStop:(0,i.$3j)("search-stop",60238),server:(0,i.$3j)("server",60240),settingsGear:(0,i.$3j)("settings-gear",60241),settings:(0,i.$3j)("settings",60242),shield:(0,i.$3j)("shield",60243),smiley:(0,i.$3j)("smiley",60244),sortPrecedence:(0,i.$3j)("sort-precedence",60245),splitHorizontal:(0,i.$3j)("split-horizontal",60246),splitVertical:(0,i.$3j)("split-vertical",60247),squirrel:(0,i.$3j)("squirrel",60248),starFull:(0,i.$3j)("star-full",60249),starHalf:(0,i.$3j)("star-half",60250),symbolClass:(0,i.$3j)("symbol-class",60251),symbolColor:(0,i.$3j)("symbol-color",60252),symbolConstant:(0,i.$3j)("symbol-constant",60253),symbolEnumMember:(0,i.$3j)("symbol-enum-member",60254),symbolField:(0,i.$3j)("symbol-field",60255),symbolFile:(0,i.$3j)("symbol-file",60256),symbolInterface:(0,i.$3j)("symbol-interface",60257),symbolKeyword:(0,i.$3j)("symbol-keyword",60258),symbolMisc:(0,i.$3j)("symbol-misc",60259),symbolOperator:(0,i.$3j)("symbol-operator",60260),symbolProperty:(0,i.$3j)("symbol-property",60261),wrench:(0,i.$3j)("wrench",60261),wrenchSubaction:(0,i.$3j)("wrench-subaction",60261),symbolSnippet:(0,i.$3j)("symbol-snippet",60262),tasklist:(0,i.$3j)("tasklist",60263),telescope:(0,i.$3j)("telescope",60264),textSize:(0,i.$3j)("text-size",60265),threeBars:(0,i.$3j)("three-bars",60266),thumbsdown:(0,i.$3j)("thumbsdown",60267),thumbsup:(0,i.$3j)("thumbsup",60268),tools:(0,i.$3j)("tools",60269),triangleDown:(0,i.$3j)("triangle-down",60270),triangleLeft:(0,i.$3j)("triangle-left",60271),triangleRight:(0,i.$3j)("triangle-right",60272),triangleUp:(0,i.$3j)("triangle-up",60273),twitter:(0,i.$3j)("twitter",60274),unfold:(0,i.$3j)("unfold",60275),unlock:(0,i.$3j)("unlock",60276),unmute:(0,i.$3j)("unmute",60277),unverified:(0,i.$3j)("unverified",60278),verified:(0,i.$3j)("verified",60279),versions:(0,i.$3j)("versions",60280),vmActive:(0,i.$3j)("vm-active",60281),vmOutline:(0,i.$3j)("vm-outline",60282),vmRunning:(0,i.$3j)("vm-running",60283),watch:(0,i.$3j)("watch",60284),whitespace:(0,i.$3j)("whitespace",60285),wholeWord:(0,i.$3j)("whole-word",60286),window:(0,i.$3j)("window",60287),wordWrap:(0,i.$3j)("word-wrap",60288),zoomIn:(0,i.$3j)("zoom-in",60289),zoomOut:(0,i.$3j)("zoom-out",60290),listFilter:(0,i.$3j)("list-filter",60291),listFlat:(0,i.$3j)("list-flat",60292),listSelection:(0,i.$3j)("list-selection",60293),selection:(0,i.$3j)("selection",60293),listTree:(0,i.$3j)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.$3j)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.$3j)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.$3j)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.$3j)("debug-stackframe-active",60297),circleSmallFilled:(0,i.$3j)("circle-small-filled",60298),debugStackframeDot:(0,i.$3j)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.$3j)("terminal-decoration-mark",60298),debugStackframe:(0,i.$3j)("debug-stackframe",60299),debugStackframeFocused:(0,i.$3j)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.$3j)("debug-breakpoint-unsupported",60300),symbolString:(0,i.$3j)("symbol-string",60301),debugReverseContinue:(0,i.$3j)("debug-reverse-continue",60302),debugStepBack:(0,i.$3j)("debug-step-back",60303),debugRestartFrame:(0,i.$3j)("debug-restart-frame",60304),debugAlt:(0,i.$3j)("debug-alt",60305),callIncoming:(0,i.$3j)("call-incoming",60306),callOutgoing:(0,i.$3j)("call-outgoing",60307),menu:(0,i.$3j)("menu",60308),expandAll:(0,i.$3j)("expand-all",60309),feedback:(0,i.$3j)("feedback",60310),gitPullRequestReviewer:(0,i.$3j)("git-pull-request-reviewer",60310),groupByRefType:(0,i.$3j)("group-by-ref-type",60311),ungroupByRefType:(0,i.$3j)("ungroup-by-ref-type",60312),account:(0,i.$3j)("account",60313),gitPullRequestAssignee:(0,i.$3j)("git-pull-request-assignee",60313),bellDot:(0,i.$3j)("bell-dot",60314),debugConsole:(0,i.$3j)("debug-console",60315),library:(0,i.$3j)("library",60316),output:(0,i.$3j)("output",60317),runAll:(0,i.$3j)("run-all",60318),syncIgnored:(0,i.$3j)("sync-ignored",60319),pinned:(0,i.$3j)("pinned",60320),githubInverted:(0,i.$3j)("github-inverted",60321),serverProcess:(0,i.$3j)("server-process",60322),serverEnvironment:(0,i.$3j)("server-environment",60323),pass:(0,i.$3j)("pass",60324),issueClosed:(0,i.$3j)("issue-closed",60324),stopCircle:(0,i.$3j)("stop-circle",60325),playCircle:(0,i.$3j)("play-circle",60326),record:(0,i.$3j)("record",60327),debugAltSmall:(0,i.$3j)("debug-alt-small",60328),vmConnect:(0,i.$3j)("vm-connect",60329),cloud:(0,i.$3j)("cloud",60330),merge:(0,i.$3j)("merge",60331),export:(0,i.$3j)("export",60332),graphLeft:(0,i.$3j)("graph-left",60333),magnet:(0,i.$3j)("magnet",60334),notebook:(0,i.$3j)("notebook",60335),redo:(0,i.$3j)("redo",60336),checkAll:(0,i.$3j)("check-all",60337),pinnedDirty:(0,i.$3j)("pinned-dirty",60338),passFilled:(0,i.$3j)("pass-filled",60339),circleLargeFilled:(0,i.$3j)("circle-large-filled",60340),circleLarge:(0,i.$3j)("circle-large",60341),circleLargeOutline:(0,i.$3j)("circle-large-outline",60341),combine:(0,i.$3j)("combine",60342),gather:(0,i.$3j)("gather",60342),table:(0,i.$3j)("table",60343),variableGroup:(0,i.$3j)("variable-group",60344),typeHierarchy:(0,i.$3j)("type-hierarchy",60345),typeHierarchySub:(0,i.$3j)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.$3j)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.$3j)("git-pull-request-create",60348),runAbove:(0,i.$3j)("run-above",60349),runBelow:(0,i.$3j)("run-below",60350),notebookTemplate:(0,i.$3j)("notebook-template",60351),debugRerun:(0,i.$3j)("debug-rerun",60352),workspaceTrusted:(0,i.$3j)("workspace-trusted",60353),workspaceUntrusted:(0,i.$3j)("workspace-untrusted",60354),workspaceUnknown:(0,i.$3j)("workspace-unknown",60355),terminalCmd:(0,i.$3j)("terminal-cmd",60356),terminalDebian:(0,i.$3j)("terminal-debian",60357),terminalLinux:(0,i.$3j)("terminal-linux",60358),terminalPowershell:(0,i.$3j)("terminal-powershell",60359),terminalTmux:(0,i.$3j)("terminal-tmux",60360),terminalUbuntu:(0,i.$3j)("terminal-ubuntu",60361),terminalBash:(0,i.$3j)("terminal-bash",60362),arrowSwap:(0,i.$3j)("arrow-swap",60363),copy:(0,i.$3j)("copy",60364),personAdd:(0,i.$3j)("person-add",60365),filterFilled:(0,i.$3j)("filter-filled",60366),wand:(0,i.$3j)("wand",60367),debugLineByLine:(0,i.$3j)("debug-line-by-line",60368),inspect:(0,i.$3j)("inspect",60369),layers:(0,i.$3j)("layers",60370),layersDot:(0,i.$3j)("layers-dot",60371),layersActive:(0,i.$3j)("layers-active",60372),compass:(0,i.$3j)("compass",60373),compassDot:(0,i.$3j)("compass-dot",60374),compassActive:(0,i.$3j)("compass-active",60375),azure:(0,i.$3j)("azure",60376),issueDraft:(0,i.$3j)("issue-draft",60377),gitPullRequestClosed:(0,i.$3j)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.$3j)("git-pull-request-draft",60379),debugAll:(0,i.$3j)("debug-all",60380),debugCoverage:(0,i.$3j)("debug-coverage",60381),runErrors:(0,i.$3j)("run-errors",60382),folderLibrary:(0,i.$3j)("folder-library",60383),debugContinueSmall:(0,i.$3j)("debug-continue-small",60384),beakerStop:(0,i.$3j)("beaker-stop",60385),graphLine:(0,i.$3j)("graph-line",60386),graphScatter:(0,i.$3j)("graph-scatter",60387),pieChart:(0,i.$3j)("pie-chart",60388),bracket:(0,i.$3j)("bracket",60175),bracketDot:(0,i.$3j)("bracket-dot",60389),bracketError:(0,i.$3j)("bracket-error",60390),lockSmall:(0,i.$3j)("lock-small",60391),azureDevops:(0,i.$3j)("azure-devops",60392),verifiedFilled:(0,i.$3j)("verified-filled",60393),newline:(0,i.$3j)("newline",60394),layout:(0,i.$3j)("layout",60395),layoutActivitybarLeft:(0,i.$3j)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.$3j)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.$3j)("layout-panel-left",60398),layoutPanelCenter:(0,i.$3j)("layout-panel-center",60399),layoutPanelJustify:(0,i.$3j)("layout-panel-justify",60400),layoutPanelRight:(0,i.$3j)("layout-panel-right",60401),layoutPanel:(0,i.$3j)("layout-panel",60402),layoutSidebarLeft:(0,i.$3j)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.$3j)("layout-sidebar-right",60404),layoutStatusbar:(0,i.$3j)("layout-statusbar",60405),layoutMenubar:(0,i.$3j)("layout-menubar",60406),layoutCentered:(0,i.$3j)("layout-centered",60407),target:(0,i.$3j)("target",60408),indent:(0,i.$3j)("indent",60409),recordSmall:(0,i.$3j)("record-small",60410),errorSmall:(0,i.$3j)("error-small",60411),terminalDecorationError:(0,i.$3j)("terminal-decoration-error",60411),arrowCircleDown:(0,i.$3j)("arrow-circle-down",60412),arrowCircleLeft:(0,i.$3j)("arrow-circle-left",60413),arrowCircleRight:(0,i.$3j)("arrow-circle-right",60414),arrowCircleUp:(0,i.$3j)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.$3j)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.$3j)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.$3j)("layout-sidebar-left-off",60418),blank:(0,i.$3j)("blank",60419),heartFilled:(0,i.$3j)("heart-filled",60420),map:(0,i.$3j)("map",60421),mapHorizontal:(0,i.$3j)("map-horizontal",60421),foldHorizontal:(0,i.$3j)("fold-horizontal",60421),mapFilled:(0,i.$3j)("map-filled",60422),mapHorizontalFilled:(0,i.$3j)("map-horizontal-filled",60422),foldHorizontalFilled:(0,i.$3j)("fold-horizontal-filled",60422),circleSmall:(0,i.$3j)("circle-small",60423),bellSlash:(0,i.$3j)("bell-slash",60424),bellSlashDot:(0,i.$3j)("bell-slash-dot",60425),commentUnresolved:(0,i.$3j)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.$3j)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.$3j)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.$3j)("search-fuzzy",60429),commentDraft:(0,i.$3j)("comment-draft",60430),send:(0,i.$3j)("send",60431),sparkle:(0,i.$3j)("sparkle",60432),insert:(0,i.$3j)("insert",60433),mic:(0,i.$3j)("mic",60434),thumbsdownFilled:(0,i.$3j)("thumbsdown-filled",60435),thumbsupFilled:(0,i.$3j)("thumbsup-filled",60436),coffee:(0,i.$3j)("coffee",60437),snake:(0,i.$3j)("snake",60438),game:(0,i.$3j)("game",60439),vr:(0,i.$3j)("vr",60440),chip:(0,i.$3j)("chip",60441),piano:(0,i.$3j)("piano",60442),music:(0,i.$3j)("music",60443),micFilled:(0,i.$3j)("mic-filled",60444),repoFetch:(0,i.$3j)("repo-fetch",60445),copilot:(0,i.$3j)("copilot",60446),lightbulbSparkle:(0,i.$3j)("lightbulb-sparkle",60447),robot:(0,i.$3j)("robot",60448),sparkleFilled:(0,i.$3j)("sparkle-filled",60449),diffSingle:(0,i.$3j)("diff-single",60450),diffMultiple:(0,i.$3j)("diff-multiple",60451),surroundWith:(0,i.$3j)("surround-with",60452),share:(0,i.$3j)("share",60453),gitStash:(0,i.$3j)("git-stash",60454),gitStashApply:(0,i.$3j)("git-stash-apply",60455),gitStashPop:(0,i.$3j)("git-stash-pop",60456),vscode:(0,i.$3j)("vscode",60457),vscodeInsiders:(0,i.$3j)("vscode-insiders",60458),codeOss:(0,i.$3j)("code-oss",60459),runCoverage:(0,i.$3j)("run-coverage",60460),runAllCoverage:(0,i.$3j)("run-all-coverage",60461),coverage:(0,i.$3j)("coverage",60462),githubProject:(0,i.$3j)("github-project",60463),mapVertical:(0,i.$3j)("map-vertical",60464),foldVertical:(0,i.$3j)("fold-vertical",60464),mapVerticalFilled:(0,i.$3j)("map-vertical-filled",60465),foldVerticalFilled:(0,i.$3j)("fold-vertical-filled",60465),goToSearch:(0,i.$3j)("go-to-search",60466),percentage:(0,i.$3j)("percentage",60467),sortPercentage:(0,i.$3j)("sort-percentage",60467),attach:(0,i.$3j)("attach",60468)}}),define(le[81],ue([0,1,112,150]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=e.$7j=void 0,e.$6j=v;function v(){return Object.values(e.$8j)}e.$7j={dialogError:(0,i.$3j)("dialog-error","error"),dialogWarning:(0,i.$3j)("dialog-warning","warning"),dialogInfo:(0,i.$3j)("dialog-info","info"),dialogClose:(0,i.$3j)("dialog-close","close"),treeItemExpanded:(0,i.$3j)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.$3j)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.$3j)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.$3j)("tree-filter-clear","close"),treeItemLoading:(0,i.$3j)("tree-item-loading","loading"),menuSelection:(0,i.$3j)("menu-selection","check"),menuSubmenu:(0,i.$3j)("menu-submenu","chevron-right"),menuBarMore:(0,i.$3j)("menubar-more","more"),scrollbarButtonLeft:(0,i.$3j)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.$3j)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.$3j)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.$3j)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.$3j)("toolbar-more","more"),quickInputBack:(0,i.$3j)("quick-input-back","arrow-left"),dropDownButton:(0,i.$3j)("drop-down-button",60084),symbolCustomColor:(0,i.$3j)("symbol-customcolor",60252),exportIcon:(0,i.$3j)("export",60332),workspaceUnspecified:(0,i.$3j)("workspace-unspecified",60355),newLine:(0,i.$3j)("newline",60394),thumbsDownFilled:(0,i.$3j)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.$3j)("thumbsup-filled",60436),gitFetch:(0,i.$3j)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.$3j)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.$3j)("debug-breakpoint-pending",60377)},e.$8j={...r.$5j,...e.$7j}}),define(le[38],ue([0,1,12]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$io=r,e.$jo=v,e.$ko=O,e.$lo=b,e.$mo=l,e.$no=m,e.$oo=u,e.$po=$,e.$qo=p,e.$ro=d,e.$so=f,e.$to=y,e.$uo=k;function r(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const E=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([S,s])=>{E[S]=s&&typeof s=="object"?r(s):s}),E}function v(g){if(!g||typeof g!="object")return g;const E=[g];for(;E.length>0;){const S=E.shift();Object.freeze(S);for(const s in S)if(A.call(S,s)){const a=S[s];typeof a=="object"&&!Object.isFrozen(a)&&!(0,i.$kg)(a)&&E.push(a)}}return g}const A=Object.prototype.hasOwnProperty;function O(g,E){return I(g,E,new Set)}function I(g,E,S){if((0,i.$qg)(g))return g;const s=E(g);if(typeof s<"u")return s;if(Array.isArray(g)){const a=[];for(const t of g)a.push(I(t,E,S));return a}if((0,i.$jg)(g)){if(S.has(g))throw new Error("Cannot clone recursive data-structure");S.add(g);const a={};for(const t in g)A.call(g,t)&&(a[t]=I(g[t],E,S));return S.delete(g),a}return g}function b(g,E,S=!0){return(0,i.$jg)(g)?((0,i.$jg)(E)&&Object.keys(E).forEach(s=>{s in g?S&&((0,i.$jg)(g[s])&&(0,i.$jg)(E[s])?b(g[s],E[s],S):g[s]=E[s]):g[s]=E[s]}),g):E}function l(g,E){if(g===E)return!0;if(g==null||E===null||E===void 0||typeof g!=typeof E||typeof g!="object"||Array.isArray(g)!==Array.isArray(E))return!1;let S,s;if(Array.isArray(g)){if(g.length!==E.length)return!1;for(S=0;S<g.length;S++)if(!l(g[S],E[S]))return!1}else{const a=[];for(s in g)a.push(s);a.sort();const t=[];for(s in E)t.push(s);if(t.sort(),!l(a,t))return!1;for(S=0;S<a.length;S++)if(!l(g[a[S]],E[a[S]]))return!1}return!0}function m(g){const E=new Set;return JSON.stringify(g,(S,s)=>{if((0,i.$jg)(s)||Array.isArray(s)){if(E.has(s))return"[Circular]";E.add(s)}return typeof s=="bigint"?`[BigInt ${s.toString()}]`:s})}function u(g,E){const S=Object.create(null);return!g||!E||Object.keys(E).forEach(a=>{const t=g[a],o=E[a];l(t,o)||(S[a]=o)}),S}function $(g,E){const S=E.toLowerCase(),s=Object.keys(g).find(a=>a.toLowerCase()===S);return s?g[s]:g[E]}function p(g,E){const S=Object.create(null);for(const[s,a]of Object.entries(g))E(s,a)&&(S[s]=a);return S}function d(g){let E=[];for(;Object.prototype!==g;)E=E.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return E}function f(g){const E=[];for(const S of d(g))typeof g[S]=="function"&&E.push(S);return E}function y(g,E){const S=a=>function(){const t=Array.prototype.slice.call(arguments,0);return E(a,t)},s={};for(const a of g)s[a]=S(a);return s}function k(g,E){const S={};for(const[s,a]of Object.entries(g))S[s]=E(a,s);return S}}),define(le[113],ue([0,1,81]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$9j=v;var r;(function(O){function I(b){return b&&typeof b=="object"&&typeof b.id=="string"}O.isThemeColor=I})(r||(e.ThemeColor=r={}));function v(O){return{id:O}}var A;(function(O){O.iconNameSegment="[A-Za-z0-9]+",O.iconNameExpression="[A-Za-z0-9-]+",O.iconModifierExpression="~[A-Za-z]+",O.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${O.iconNameExpression})(${O.iconModifierExpression})?$`);function b(g){const E=I.exec(g.id);if(!E)return b(i.$8j.error);const[,S,s]=E,a=["codicon","codicon-"+S];return s&&a.push("codicon-modifier-"+s.substring(1)),a}O.asClassNameArray=b;function l(g){return b(g).join(" ")}O.asClassName=l;function m(g){return"."+b(g).join(".")}O.asCSSSelector=m;function u(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(typeof g.color>"u"||r.isThemeColor(g.color))}O.isThemeIcon=u;const $=new RegExp(`^\\$\\((${O.iconNameExpression}(?:${O.iconModifierExpression})?)\\)$`);function p(g){const E=$.exec(g);if(!E)return;const[,S]=E;return{id:S}}O.fromString=p;function d(g){return{id:g}}O.fromId=d;function f(g,E){let S=g.id;const s=S.lastIndexOf("~");return s!==-1&&(S=S.substring(0,s)),E&&(S=`${S}~${E}`),{id:S}}O.modify=f;function y(g){const E=g.id.lastIndexOf("~");if(E!==-1)return g.id.substring(E+1)}O.getModifier=y;function k(g,E){return g.id===E.id&&g.color?.id===E.color?.id}O.isEqual=k})(A||(e.ThemeIcon=A={}))}),define(le[151],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$df=r,e.$ef=v;var i;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(i||(e.Constants=i={}));function r(A){return A<0?0:A>i.MAX_UINT_8?i.MAX_UINT_8:A|0}function v(A){return A<0?0:A>i.MAX_UINT_32?i.MAX_UINT_32:A|0}}),define(le[25],ue([0,1,148,39,68,151]),function(K,e,i,r,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gg=e.$fg=e.$eg=e.GraphemeBreakType=e.$7f=e.$Yf=e.$Rf=e.$Qf=void 0,e.$ff=O,e.$gf=b,e.$hf=m,e.$if=u,e.$jf=$,e.$kf=p,e.$lf=d,e.$mf=f,e.$nf=y,e.$of=k,e.$pf=g,e.$qf=E,e.$rf=S,e.$sf=s,e.$tf=a,e.$uf=t,e.$vf=o,e.$wf=n,e.$xf=c,e.$yf=h,e.$zf=P,e.$Af=w,e.$Bf=D,e.$Cf=L,e.$Df=R,e.$Ef=T,e.$Ff=j,e.$Gf=G,e.$Hf=q,e.$If=Q,e.$Jf=de,e.$Kf=V,e.$Lf=Y,e.$Mf=B,e.$Nf=_,e.$Of=C,e.$Pf=W,e.$Sf=x,e.$Tf=ce,e.$Uf=oe,e.$Vf=J,e.$Wf=U,e.$Xf=ie,e.$Zf=X,e.$1f=z,e.$2f=te,e.$3f=ae,e.$4f=be,e.$5f=ye,e.$6f=Ve,e.$8f=Re,e.$9f=$e,e.$0f=ee,e.$$f=he,e.$_f=fe,e.$ag=pe,e.$bg=ve,e.$cg=je,e.$dg=Ze;function O(se){return!se||typeof se!="string"?!0:se.trim().length===0}const I=/{(\d+)}/g;function b(se,...ge){return ge.length===0?se:se.replace(I,function(we,Ee){const Me=parseInt(Ee,10);return isNaN(Me)||Me<0||Me>=ge.length?we:ge[Me]})}const l=/{([^}]+)}/g;function m(se,ge){return Object.keys(ge).length===0?se:se.replace(l,(we,Ee)=>ge[Ee]??we)}function u(se){return se.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}function $(se){return se.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}function p(se){return se.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function d(se,ge){let we=0,Ee=se.indexOf(ge);for(;Ee!==-1;)we++,Ee=se.indexOf(ge,Ee+ge.length);return we}function f(se,ge,we="\u2026"){return se.length<=ge?se:`${se.substr(0,ge)}${we}`}function y(se,ge,we="\u2026"){if(se.length<=ge)return se;const Ee=Math.ceil(ge/2)-we.length/2,Me=Math.floor(ge/2)-we.length/2;return`${se.substr(0,Ee)}${we}${se.substr(se.length-Me)}`}function k(se,ge=" "){const we=g(se,ge);return E(we,ge)}function g(se,ge){if(!se||!ge)return se;const we=ge.length;if(we===0||se.length===0)return se;let Ee=0;for(;se.indexOf(ge,Ee)===Ee;)Ee=Ee+we;return se.substring(Ee)}function E(se,ge){if(!se||!ge)return se;const we=ge.length,Ee=se.length;if(we===0||Ee===0)return se;let Me=Ee,Be=-1;for(;Be=se.lastIndexOf(ge,Me-1),!(Be===-1||Be+we!==Me);){if(Be===0)return"";Me=Be}return se.substring(0,Me)}function S(se){return se.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function s(se){return se.replace(/\*/g,"")}function a(se,ge,we={}){if(!se)throw new Error("Cannot create regex from empty string");ge||(se=p(se)),we.wholeWord&&(/\B/.test(se.charAt(0))||(se="\\b"+se),/\B/.test(se.charAt(se.length-1))||(se=se+"\\b"));let Ee="";return we.global&&(Ee+="g"),we.matchCase||(Ee+="i"),we.multiline&&(Ee+="m"),we.unicode&&(Ee+="u"),new RegExp(se,Ee)}function t(se){return se.source==="^"||se.source==="^$"||se.source==="$"||se.source==="^\\s*$"?!1:!!(se.exec("")&&se.lastIndex===0)}function o(se){return se.split(/\r\n|\r|\n/)}function n(se){const ge=[],we=se.split(/(\r\n|\r|\n)/);for(let Ee=0;Ee<Math.ceil(we.length/2);Ee++)ge.push(we[2*Ee]+(we[2*Ee+1]??""));return ge}function c(se){for(let ge=0,we=se.length;ge<we;ge++){const Ee=se.charCodeAt(ge);if(Ee!==r.CharCode.Space&&Ee!==r.CharCode.Tab)return ge}return-1}function h(se,ge=0,we=se.length){for(let Ee=ge;Ee<we;Ee++){const Me=se.charCodeAt(Ee);if(Me!==r.CharCode.Space&&Me!==r.CharCode.Tab)return se.substring(ge,Ee)}return se.substring(ge,we)}function P(se,ge=se.length-1){for(let we=ge;we>=0;we--){const Ee=se.charCodeAt(we);if(Ee!==r.CharCode.Space&&Ee!==r.CharCode.Tab)return we}return-1}function w(se,ge,we){const Ee=[];let Me=0;for(const Be of se.matchAll(ge)){if(Ee.push(se.slice(Me,Be.index)),Be.index===void 0)throw new Error("match.index should be defined");Me=Be.index+Be[0].length,Ee.push(we(Be[0],...Be.slice(1),Be.index,se,Be.groups))}return Ee.push(se.slice(Me)),Promise.all(Ee).then(Be=>Be.join(""))}function D(se,ge){return se<ge?-1:se>ge?1:0}function L(se,ge,we=0,Ee=se.length,Me=0,Be=ge.length){for(;we<Ee&&Me<Be;we++,Me++){const rt=se.charCodeAt(we),at=ge.charCodeAt(Me);if(rt<at)return-1;if(rt>at)return 1}const _e=Ee-we,lt=Be-Me;return _e<lt?-1:_e>lt?1:0}function R(se,ge){return T(se,ge,0,se.length,0,ge.length)}function T(se,ge,we=0,Ee=se.length,Me=0,Be=ge.length){for(;we<Ee&&Me<Be;we++,Me++){let rt=se.charCodeAt(we),at=ge.charCodeAt(Me);if(rt===at)continue;if(rt>=128||at>=128)return L(se.toLowerCase(),ge.toLowerCase(),we,Ee,Me,Be);G(rt)&&(rt-=32),G(at)&&(at-=32);const tt=rt-at;if(tt!==0)return tt}const _e=Ee-we,lt=Be-Me;return _e<lt?-1:_e>lt?1:0}function j(se){return se>=r.CharCode.Digit0&&se<=r.CharCode.Digit9}function G(se){return se>=r.CharCode.a&&se<=r.CharCode.z}function q(se){return se>=r.CharCode.A&&se<=r.CharCode.Z}function Q(se,ge){return se.length===ge.length&&T(se,ge)===0}function de(se,ge){const we=ge.length;return ge.length>se.length?!1:T(se,ge,0,we)===0}function V(se,ge){const we=Math.min(se.length,ge.length);let Ee;for(Ee=0;Ee<we;Ee++)if(se.charCodeAt(Ee)!==ge.charCodeAt(Ee))return Ee;return we}function Y(se,ge){const we=Math.min(se.length,ge.length);let Ee;const Me=se.length-1,Be=ge.length-1;for(Ee=0;Ee<we;Ee++)if(se.charCodeAt(Me-Ee)!==ge.charCodeAt(Be-Ee))return Ee;return we}function B(se){return 55296<=se&&se<=56319}function _(se){return 56320<=se&&se<=57343}function C(se,ge){return(se-55296<<10)+(ge-56320)+65536}function W(se,ge,we){const Ee=se.charCodeAt(we);if(B(Ee)&&we+1<ge){const Me=se.charCodeAt(we+1);if(_(Me))return C(Ee,Me)}return Ee}function F(se,ge){const we=se.charCodeAt(ge-1);if(_(we)&&ge>1){const Ee=se.charCodeAt(ge-2);if(B(Ee))return C(Ee,we)}return we}class H{get offset(){return this.e}constructor(ge,we=0){this.c=ge,this.d=ge.length,this.e=we}setOffset(ge){this.e=ge}prevCodePoint(){const ge=F(this.c,this.e);return this.e-=ge>=A.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}nextCodePoint(){const ge=W(this.c,this.d,this.e);return this.e+=ge>=A.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}eol(){return this.e>=this.d}}e.$Qf=H;class ne{get offset(){return this.c.offset}constructor(ge,we=0){this.c=new H(ge,we)}nextGraphemeLength(){const ge=We.getInstance(),we=this.c,Ee=we.offset;let Me=ge.getGraphemeBreakType(we.nextCodePoint());for(;!we.eol();){const Be=we.offset,_e=ge.getGraphemeBreakType(we.nextCodePoint());if(Oe(Me,_e)){we.setOffset(Be);break}Me=_e}return we.offset-Ee}prevGraphemeLength(){const ge=We.getInstance(),we=this.c,Ee=we.offset;let Me=ge.getGraphemeBreakType(we.prevCodePoint());for(;we.offset>0;){const Be=we.offset,_e=ge.getGraphemeBreakType(we.prevCodePoint());if(Oe(_e,Me)){we.setOffset(Be);break}Me=_e}return Ee-we.offset}eol(){return this.c.eol()}}e.$Rf=ne;function x(se,ge){return new ne(se,ge).nextGraphemeLength()}function ce(se,ge){return new ne(se,ge).prevGraphemeLength()}function oe(se,ge){ge>0&&_(se.charCodeAt(ge))&&ge--;const we=ge+x(se,ge);return[we-ce(se,we),we]}function J(se){const ge=new ne(se);let we=0;for(;!ge.eol();)we++,ge.nextGraphemeLength();return we}let M;function Z(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function U(se){return M||(M=Z()),M.test(se)}const N=/^[\t\n\r\x20-\x7E]*$/;function ie(se){return N.test(se)}e.$Yf=/[\u2028\u2029]/;function X(se){return e.$Yf.test(se)}function z(se){return se>=11904&&se<=55215||se>=63744&&se<=64255||se>=65281&&se<=65374}function te(se){return se>=127462&&se<=127487||se===8986||se===8987||se===9200||se===9203||se>=9728&&se<=10175||se===11088||se===11093||se>=127744&&se<=128591||se>=128640&&se<=128764||se>=128992&&se<=129008||se>=129280&&se<=129535||se>=129648&&se<=129782}function ae(se,ge,we=""){const Ee=se.trimStart();if(Ee.length<ge)return Ee;const Me=/\b/g;let Be=0;for(;Me.test(Ee)&&!(Ee.length-Me.lastIndex<ge);)Be=Me.lastIndex,Me.lastIndex+=1;return Be===0?Ee:we+Ee.substring(Be).trimStart()}const me=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*be(se){let ge=0;for(const we of se.matchAll(me))ge!==we.index&&(yield{isCode:!1,str:se.substring(ge,we.index)}),yield{isCode:!0,str:we[0]},ge=we.index+we[0].length;ge!==se.length&&(yield{isCode:!1,str:se.substring(ge)})}function ye(se){return se&&(se=se.replace(me,"")),se}const Fe=/\\\[.*?\\\]/g;function Ve(se){return ye(se).replace(Fe,"")}e.$7f=String.fromCharCode(r.CharCode.UTF8_BOM);function Re(se){return!!(se&&se.length>0&&se.charCodeAt(0)===r.CharCode.UTF8_BOM)}function $e(se){return Re(se)?se.substr(1):se}function ee(se,ge){if(!se||!ge||se.length<ge.length)return!1;const we=ge.length,Ee=se.toLowerCase();let Me=0,Be=-1;for(;Me<we;){const _e=Ee.indexOf(ge[Me],Be+1);if(_e<0)return!1;Be=_e,Me++}return!0}function he(se,ge=!1){return se?(ge&&(se=se.replace(/\\./g,"")),se.toLowerCase()!==se):!1}function fe(se){return se.charAt(0).toUpperCase()+se.slice(1)}function pe(se,ge=1){if(ge===0)return"";let we=-1;do we=se.indexOf(`
`,we+1),ge--;while(ge>0&&we>=0);return we===-1?se:(se[we-1]==="\r"&&we--,se.substr(0,we))}function ve(se){const ge=r.CharCode.Z-r.CharCode.A+1;return se=se%(2*ge),se<ge?String.fromCharCode(r.CharCode.a+se):String.fromCharCode(r.CharCode.A+se-ge)}function je(se){return We.getInstance().getGraphemeBreakType(se)}function Oe(se,ge){return se===De.Other?ge!==De.Extend&&ge!==De.SpacingMark:se===De.CR&&ge===De.LF?!1:se===De.Control||se===De.CR||se===De.LF||ge===De.Control||ge===De.CR||ge===De.LF?!0:!(se===De.L&&(ge===De.L||ge===De.V||ge===De.LV||ge===De.LVT)||(se===De.LV||se===De.V)&&(ge===De.V||ge===De.T)||(se===De.LVT||se===De.T)&&ge===De.T||ge===De.Extend||ge===De.ZWJ||ge===De.SpacingMark||se===De.Prepend||se===De.ZWJ&&ge===De.Extended_Pictographic||se===De.Regional_Indicator&&ge===De.Regional_Indicator)}var De;(function(se){se[se.Other=0]="Other",se[se.Prepend=1]="Prepend",se[se.CR=2]="CR",se[se.LF=3]="LF",se[se.Control=4]="Control",se[se.Extend=5]="Extend",se[se.Regional_Indicator=6]="Regional_Indicator",se[se.SpacingMark=7]="SpacingMark",se[se.L=8]="L",se[se.V=9]="V",se[se.T=10]="T",se[se.LV=11]="LV",se[se.LVT=12]="LVT",se[se.ZWJ=13]="ZWJ",se[se.Extended_Pictographic=14]="Extended_Pictographic"})(De||(e.GraphemeBreakType=De={}));class We{static{this.c=null}static getInstance(){return We.c||(We.c=new We),We.c}constructor(){this.d=Ke()}getGraphemeBreakType(ge){if(ge<32)return ge===r.CharCode.LineFeed?De.LF:ge===r.CharCode.CarriageReturn?De.CR:De.Control;if(ge<127)return De.Other;const we=this.d,Ee=we.length/3;let Me=1;for(;Me<=Ee;)if(ge<we[3*Me])Me=2*Me;else if(ge>we[3*Me+1])Me=2*Me+1;else return we[3*Me+2];return De.Other}}function Ke(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ze(se,ge){if(se===0)return 0;const we=ze(se,ge);if(we!==void 0)return we;const Ee=new H(ge,se);return Ee.prevCodePoint(),Ee.offset}function ze(se,ge){const we=new H(ge,se);let Ee=we.prevCodePoint();for(;Ye(Ee)||Ee===Qe.emojiVariantSelector||Ee===Qe.enclosingKeyCap;){if(we.offset===0)return;Ee=we.prevCodePoint()}if(!te(Ee))return;let Me=we.offset;return Me>0&&we.prevCodePoint()===Qe.zwj&&(Me=we.offset),Me}function Ye(se){return 127995<=se&&se<=127999}var Qe;(function(se){se[se.zwj=8205]="zwj",se[se.emojiVariantSelector=65039]="emojiVariantSelector",se[se.enclosingKeyCap=8419]="enclosingKeyCap"})(Qe||(Qe={})),e.$eg="\xA0";class Je{static{this.c=new v.$W(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new i.$bf({getCacheKey:JSON.stringify},ge=>{function we(tt){const ut=new Map;for(let ct=0;ct<tt.length;ct+=2)ut.set(tt[ct],tt[ct+1]);return ut}function Ee(tt,ut){const ct=new Map(tt);for(const[ft,gt]of ut)ct.set(ft,gt);return ct}function Me(tt,ut){if(!tt)return ut;const ct=new Map;for(const[ft,gt]of tt)ut.has(ft)&&ct.set(ft,gt);return ct}const Be=this.c.value;let _e=ge.filter(tt=>!tt.startsWith("_")&&tt in Be);_e.length===0&&(_e=["_default"]);let lt;for(const tt of _e){const ut=we(Be[tt]);lt=Me(lt,ut)}const rt=we(Be._common),at=Ee(rt,lt);return new Je(at)})}static getInstance(ge){return Je.d.get(Array.from(ge))}static{this.e=new v.$W(()=>Object.keys(Je.c.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return Je.e.value}constructor(ge){this.f=ge}isAmbiguous(ge){return this.f.has(ge)}containsAmbiguousCharacter(ge){for(let we=0;we<ge.length;we++){const Ee=ge.codePointAt(we);if(typeof Ee=="number"&&this.isAmbiguous(Ee))return!0}return!1}getPrimaryConfusable(ge){return this.f.get(ge)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$fg=Je;class Ce{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ce.c())),this.d}static isInvisibleCharacter(ge){return Ce.e().has(ge)}static containsInvisibleCharacter(ge){for(let we=0;we<ge.length;we++){const Ee=ge.codePointAt(we);if(typeof Ee=="number"&&Ce.isInvisibleCharacter(Ee))return!0}return!1}static get codePoints(){return Ce.e()}}e.$gg=Ce}),define(le[32],ue([0,1,39,9,3,25,12]),function(K,e,i,r,v,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ag=I,e.$Bg=b,e.$Cg=l,e.$Dg=m,e.$Eg=u,e.$Fg=f,e.$Gg=y,e.$Hg=k,e.$Ig=g,e.$Jg=E,e.$Kg=S,e.$Lg=s,e.$Mg=a,e.$Ng=t,e.$Og=o,e.$Pg=n,e.$Qg=P;function I(w){return w===i.CharCode.Slash||w===i.CharCode.Backslash}function b(w){return w.replace(/[\\/]/g,r.$jc.sep)}function l(w){return w.indexOf("/")===-1&&(w=b(w)),/^[a-zA-Z]:(\/|$)/.test(w)&&(w="/"+w),w}function m(w,D=r.$jc.sep){if(!w)return"";const L=w.length,R=w.charCodeAt(0);if(I(R)){if(I(w.charCodeAt(1))&&!I(w.charCodeAt(2))){let j=3;const G=j;for(;j<L&&!I(w.charCodeAt(j));j++);if(G!==j&&!I(w.charCodeAt(j+1))){for(j+=1;j<L;j++)if(I(w.charCodeAt(j)))return w.slice(0,j+1).replace(/[\\/]/g,D)}}return D}else if(g(R)&&w.charCodeAt(1)===i.CharCode.Colon)return I(w.charCodeAt(2))?w.slice(0,2)+D:w.slice(0,2);let T=w.indexOf("://");if(T!==-1){for(T+=3;T<L;T++)if(I(w.charCodeAt(T)))return w.slice(0,T+1)}return""}function u(w){if(!v.$j||!w||w.length<5)return!1;let D=w.charCodeAt(0);if(D!==i.CharCode.Backslash||(D=w.charCodeAt(1),D!==i.CharCode.Backslash))return!1;let L=2;const R=L;for(;L<w.length&&(D=w.charCodeAt(L),D!==i.CharCode.Backslash);L++);return!(R===L||(D=w.charCodeAt(L+1),isNaN(D)||D===i.CharCode.Backslash))}const $=/[\\/:\*\?"<>\|]/g,p=/[/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(w,D=v.$j){const L=D?$:p;return!(!w||w.length===0||/^\s+$/.test(w)||(L.lastIndex=0,L.test(w))||D&&d.test(w)||w==="."||w===".."||D&&w[w.length-1]==="."||D&&w.length!==w.trim().length||w.length>255)}function y(w,D,L){const R=w===D;return!L||R?R:!w||!D?!1:(0,A.$If)(w,D)}function k(w,D,L,R=r.sep){if(w===D)return!0;if(!w||!D||D.length>w.length)return!1;if(L){if(!(0,A.$Jf)(w,D))return!1;if(D.length===w.length)return!0;let j=D.length;return D.charAt(D.length-1)===R&&j--,w.charAt(j)===R}return D.charAt(D.length-1)!==R&&(D+=R),w.indexOf(D)===0}function g(w){return w>=i.CharCode.A&&w<=i.CharCode.Z||w>=i.CharCode.a&&w<=i.CharCode.z}function E(w,D){return v.$j&&w.endsWith(":")&&(w+=r.sep),(0,r.$lc)(w)||(w=(0,r.$mc)(D,w)),w=(0,r.$kc)(w),S(w)}function S(w){return v.$j?(w=(0,A.$qf)(w,r.sep),w.endsWith(":")&&(w+=r.sep)):(w=(0,A.$qf)(w,r.sep),w||(w=r.sep)),w}function s(w){const D=(0,r.$kc)(w);return v.$j?w.length>3?!1:a(D)&&(w.length===2||D.charCodeAt(2)===i.CharCode.Backslash):D===r.$jc.sep}function a(w,D=v.$j){return D?g(w.charCodeAt(0))&&w.charCodeAt(1)===i.CharCode.Colon:!1}function t(w,D=v.$j){return a(w,D)?w[0]:void 0}function o(w,D,L){return D.length>w.length?-1:w===D?0:(L&&(w=w.toLowerCase(),D=D.toLowerCase()),w.indexOf(D))}function n(w){const D=w.split(":");let L,R,T;for(const j of D){const G=Number(j);(0,O.$lg)(G)?R===void 0?R=G:T===void 0&&(T=G):L=L?[L,j].join(":"):j}if(!L)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:L,line:R!==void 0?R:void 0,column:T!==void 0?T:R!==void 0?1:void 0}}const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",h="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function P(w,D,L=8){let R="";for(let j=0;j<L;j++){let G;j===0&&v.$j&&!D&&(L===3||L===4)?G=h:G=c,R+=G.charAt(Math.floor(Math.random()*G.length))}let T;return D?T=`${D}-${R}`:T=R,w?(0,r.$mc)(w,T):T}}),define(le[47],ue([0,1,25]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cj=e.$Aj=void 0,e.$wj=r,e.$xj=v,e.$yj=A,e.$zj=I,e.$Bj=f,i=Ie(i);function r(k){return v(k,0)}function v(k,g){switch(typeof k){case"object":return k===null?A(349,g):Array.isArray(k)?b(k,g):l(k,g);case"string":return I(k,g);case"boolean":return O(k,g);case"number":return A(k,g);case"undefined":return A(937,g);default:return A(617,g)}}function A(k,g){return(g<<5)-g+k|0}function O(k,g){return A(k?433:863,g)}function I(k,g){g=A(149417,g);for(let E=0,S=k.length;E<S;E++)g=A(k.charCodeAt(E),g);return g}function b(k,g){return g=A(104579,g),k.reduce((E,S)=>v(S,E),g)}function l(k,g){return g=A(181387,g),Object.keys(k).sort().reduce((E,S)=>(E=I(S,E),v(k[S],E)),g)}class m{constructor(){this.g=0}get value(){return this.g}hash(g){return this.g=v(g,this.g),this.g}}e.$Aj=m;var u;(function(k){k[k.BLOCK_SIZE=64]="BLOCK_SIZE",k[k.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(u||(u={}));function $(k,g,E=32){const S=E-g,s=~((1<<S)-1);return(k<<g|(s&k)>>>S)>>>0}function p(k,g=0,E=k.byteLength,S=0){for(let s=0;s<E;s++)k[g+s]=S}function d(k,g,E="0"){for(;k.length<g;)k=E+k;return k}function f(k,g=32){return k instanceof ArrayBuffer?Array.from(new Uint8Array(k)).map(E=>E.toString(16).padStart(2,"0")).join(""):d((k>>>0).toString(16),g/4)}class y{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(u.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(g){const E=g.length;if(E===0)return;const S=this.p;let s=this.r,a=this.u,t,o;for(a!==0?(t=a,o=-1,a=0):(t=g.charCodeAt(0),o=0);;){let n=t;if(i.$Mf(t))if(o+1<E){const c=g.charCodeAt(o+1);i.$Nf(c)?(o++,n=i.$Of(t,c)):n=u.UNICODE_REPLACEMENT}else{a=t;break}else i.$Nf(t)&&(n=u.UNICODE_REPLACEMENT);if(s=this.w(S,s,n),o++,o<E)t=g.charCodeAt(o);else break}this.r=s,this.u=a}w(g,E,S){return S<128?g[E++]=S:S<2048?(g[E++]=192|(S&1984)>>>6,g[E++]=128|(S&63)>>>0):S<65536?(g[E++]=224|(S&61440)>>>12,g[E++]=128|(S&4032)>>>6,g[E++]=128|(S&63)>>>0):(g[E++]=240|(S&1835008)>>>18,g[E++]=128|(S&258048)>>>12,g[E++]=128|(S&4032)>>>6,g[E++]=128|(S&63)>>>0),E>=u.BLOCK_SIZE&&(this.y(),E-=u.BLOCK_SIZE,this.t+=u.BLOCK_SIZE,g[0]=g[u.BLOCK_SIZE+0],g[1]=g[u.BLOCK_SIZE+1],g[2]=g[u.BLOCK_SIZE+2]),E}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,u.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),f(this.h)+f(this.l)+f(this.m)+f(this.n)+f(this.o)}x(){this.p[this.r++]=128,p(this.p,this.r),this.r>56&&(this.y(),p(this.p));const g=8*this.t;this.q.setUint32(56,Math.floor(g/4294967296),!1),this.q.setUint32(60,g%4294967296,!1),this.y()}y(){const g=y.g,E=this.q;for(let P=0;P<64;P+=4)g.setUint32(P,E.getUint32(P,!1),!1);for(let P=64;P<320;P+=4)g.setUint32(P,$(g.getUint32(P-12,!1)^g.getUint32(P-32,!1)^g.getUint32(P-56,!1)^g.getUint32(P-64,!1),1),!1);let S=this.h,s=this.l,a=this.m,t=this.n,o=this.o,n,c,h;for(let P=0;P<80;P++)P<20?(n=s&a|~s&t,c=1518500249):P<40?(n=s^a^t,c=1859775393):P<60?(n=s&a|s&t|a&t,c=2400959708):(n=s^a^t,c=3395469782),h=$(S,5)+n+o+c+g.getUint32(P*4,!1)&4294967295,o=t,t=a,a=$(s,30),s=S,S=h;this.h=this.h+S&4294967295,this.l=this.l+s&4294967295,this.m=this.m+a&4294967295,this.n=this.n+t&4294967295,this.o=this.o+o&4294967295}}e.$Cj=y}),define(le[82],ue([0,1,25]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i=Ie(i);var r;(function(v){v[v.Ignore=0]="Ignore",v[v.Info=1]="Info",v[v.Warning=2]="Warning",v[v.Error=3]="Error"})(r||(r={})),function(v){const A="error",O="warning",I="warn",b="info",l="ignore";function m($){return $?i.$If(A,$)?v.Error:i.$If(O,$)||i.$If(I,$)?v.Warning:i.$If(b,$)?v.Info:v.Ignore:v.Ignore}v.fromValue=m;function u($){switch($){case v.Error:return A;case v.Warning:return O;case v.Info:return b;default:return l}}v.toString=u}(r||(r={})),e.default=r}),define(le[61],ue([0,1,21,39,25]),function(K,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=void 0;class A{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const f=d.charCodeAt(0),y=this.b.charCodeAt(this.c);return f-y}value(){return this.b[this.c]}}e.$Ki=A;class O{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===r.CharCode.Period)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,v.$Cf)(d,this.b,0,d.length,this.c,this.d):(0,v.$Ef)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Li=O;class I{constructor(d=!0,f=!0){this.f=d,this.g=f}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let f=d.length-1;f>=0;f--,this.c--){const y=this.b.charCodeAt(f);if(!(y===r.CharCode.Slash||this.f&&y===r.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const f=this.b.charCodeAt(this.e);if(f===r.CharCode.Slash||this.f&&f===r.CharCode.Backslash)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,v.$Cf)(d,this.b,0,d.length,this.d,this.e):(0,v.$Ef)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Mi=I;var b;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(b||(b={}));class l{constructor(d,f){this.f=d,this.g=f,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push(b.Scheme),this.c.authority&&this.d.push(b.Authority),this.c.path&&(this.b=new I(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push(b.Path)),this.g(d)||(this.c.query&&this.d.push(b.Query),this.c.fragment&&this.d.push(b.Fragment)),this.e=0,this}next(){return this.d[this.e]===b.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===b.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===b.Scheme)return(0,v.$Df)(d,this.c.scheme);if(this.d[this.e]===b.Authority)return(0,v.$Df)(d,this.c.authority);if(this.d[this.e]===b.Path)return this.b.cmp(d);if(this.d[this.e]===b.Query)return(0,v.$Bf)(d,this.c.query);if(this.d[this.e]===b.Fragment)return(0,v.$Bf)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===b.Scheme)return this.c.scheme;if(this.d[this.e]===b.Authority)return this.c.authority;if(this.d[this.e]===b.Path)return this.b.value();if(this.d[this.e]===b.Query)return this.c.query;if(this.d[this.e]===b.Fragment)return this.c.fragment;throw new Error}}e.$Ni=l;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var u;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(u||(u={}));class ${static forUris(d=()=>!1,f=()=>!1){return new $(new l(d,f))}static forPaths(d=!1){return new $(new I(void 0,!d))}static forStrings(){return new $(new A)}static forConfigKeys(){return new $(new O)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,f){if(f){const y=f.slice(0);(0,i.$Yb)(y);for(const k of y)this.set(k,d)}else{const y=d.slice(0);(0,i.$Yb)(y);for(const k of y)this.set(k[0],k[1])}}set(d,f){const y=this.b.reset(d);let k;this.c||(this.c=new m,this.c.segment=y.value());const g=[];for(k=this.c;;){const S=y.cmp(k.segment);if(S>0)k.left||(k.left=new m,k.left.segment=y.value()),g.push([u.Left,k]),k=k.left;else if(S<0)k.right||(k.right=new m,k.right.segment=y.value()),g.push([u.Right,k]),k=k.right;else if(y.hasNext())y.next(),k.mid||(k.mid=new m,k.mid.segment=y.value()),g.push([u.Mid,k]),k=k.mid;else break}const E=k.value;k.value=f,k.key=d;for(let S=g.length-1;S>=0;S--){const s=g[S][1];s.updateHeight();const a=s.balanceFactor();if(a<-1||a>1){const t=g[S][0],o=g[S+1][0];if(t===u.Right&&o===u.Right)g[S][1]=s.rotateLeft();else if(t===u.Left&&o===u.Left)g[S][1]=s.rotateRight();else if(t===u.Right&&o===u.Left)s.right=g[S+1][1]=g[S+1][1].rotateRight(),g[S][1]=s.rotateLeft();else if(t===u.Left&&o===u.Right)s.left=g[S+1][1]=g[S+1][1].rotateLeft(),g[S][1]=s.rotateRight();else throw new Error;if(S>0)switch(g[S-1][0]){case u.Left:g[S-1][1].left=g[S][1];break;case u.Right:g[S-1][1].right=g[S][1];break;case u.Mid:g[S-1][1].mid=g[S][1];break}else this.c=g[0][1]}}return E}get(d){return this.d(d)?.value}d(d){const f=this.b.reset(d);let y=this.c;for(;y;){const k=f.cmp(y.segment);if(k>0)y=y.left;else if(k<0)y=y.right;else if(f.hasNext())f.next(),y=y.mid;else break}return y}has(d){const f=this.d(d);return!(f?.value===void 0&&f?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,f){const y=this.b.reset(d),k=[];let g=this.c;for(;g;){const E=y.cmp(g.segment);if(E>0)k.push([u.Left,g]),g=g.left;else if(E<0)k.push([u.Right,g]),g=g.right;else if(y.hasNext())y.next(),k.push([u.Mid,g]),g=g.mid;else break}if(g){if(f?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const E=this.f(g.right);if(E.key){const{key:S,value:s,segment:a}=E;this.e(E.key,!1),g.key=S,g.value=s,g.segment=a}}else{const E=g.left??g.right;if(k.length>0){const[S,s]=k[k.length-1];switch(S){case u.Left:s.left=E;break;case u.Mid:s.mid=E;break;case u.Right:s.right=E;break}}else this.c=E}for(let E=k.length-1;E>=0;E--){const S=k[E][1];S.updateHeight();const s=S.balanceFactor();if(s>1?(S.right.balanceFactor()>=0||(S.right=S.right.rotateRight()),k[E][1]=S.rotateLeft()):s<-1&&(S.left.balanceFactor()<=0||(S.left=S.left.rotateLeft()),k[E][1]=S.rotateRight()),E>0)switch(k[E-1][0]){case u.Left:k[E-1][1].left=k[E][1];break;case u.Right:k[E-1][1].right=k[E][1];break;case u.Mid:k[E-1][1].mid=k[E][1];break}else this.c=k[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const f=this.b.reset(d);let y=this.c,k;for(;y;){const g=f.cmp(y.segment);if(g>0)y=y.left;else if(g<0)y=y.right;else if(f.hasNext())f.next(),k=y.value||k,y=y.mid;else break}return y&&y.value||k}findSuperstr(d){return this.g(d,!1)}g(d,f){const y=this.b.reset(d);let k=this.c;for(;k;){const g=y.cmp(k.segment);if(g>0)k=k.left;else if(g<0)k=k.right;else if(y.hasNext())y.next(),k=k.mid;else return k.mid?this.h(k.mid):f?k.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[f,y]of this)d(y,f)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const f=[];return this.j(d,f),f[Symbol.iterator]()}j(d,f){d&&(d.left&&this.j(d.left,f),d.value&&f.push([d.key,d.value]),d.mid&&this.j(d.mid,f),d.right&&this.j(d.right,f))}_isBalanced(){const d=f=>{if(!f)return!0;const y=f.balanceFactor();return y<-1||y>1?!1:d(f.left)&&d(f.right)};return d(this.c)}}e.$Oi=$}),define(le[7],ue([0,1,39,92,9,3]),function(K,e,i,r,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$yc=y,e.$zc=a,v=Ie(v);const O=/^\w[\w\d+.-]*$/,I=/^\//,b=/^\/\//;function l(h,P){if(!h.scheme&&P)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${h.authority}", path: "${h.path}", query: "${h.query}", fragment: "${h.fragment}"}`);if(h.scheme&&!O.test(h.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(h.path){if(h.authority){if(!I.test(h.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(b.test(h.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(h,P){return!h&&!P?"file":h}function u(h,P){switch(h){case"https":case"http":case"file":P?P[0]!==p&&(P=p+P):P=p;break}return P}const $="",p="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(P){return P instanceof f?!0:P?typeof P.authority=="string"&&typeof P.fragment=="string"&&typeof P.path=="string"&&typeof P.query=="string"&&typeof P.scheme=="string"&&typeof P.fsPath=="string"&&typeof P.with=="function"&&typeof P.toString=="function":!1}constructor(P,w,D,L,R,T=!1){typeof P=="object"?(this.scheme=P.scheme||$,this.authority=P.authority||$,this.path=P.path||$,this.query=P.query||$,this.fragment=P.fragment||$):(this.scheme=m(P,T),this.authority=w||$,this.path=u(this.scheme,D||$),this.query=L||$,this.fragment=R||$,l(this,T))}get fsPath(){return a(this,!1)}with(P){if(!P)return this;let{scheme:w,authority:D,path:L,query:R,fragment:T}=P;return w===void 0?w=this.scheme:w===null&&(w=$),D===void 0?D=this.authority:D===null&&(D=$),L===void 0?L=this.path:L===null&&(L=$),R===void 0?R=this.query:R===null&&(R=$),T===void 0?T=this.fragment:T===null&&(T=$),w===this.scheme&&D===this.authority&&L===this.path&&R===this.query&&T===this.fragment?this:new g(w,D,L,R,T)}static parse(P,w=!1){const D=d.exec(P);return D?new g(D[2]||$,c(D[4]||$),c(D[5]||$),c(D[7]||$),c(D[9]||$),w):new g($,$,$,$,$)}static file(P){let w=$;if(A.$j&&(P=P.replace(/\\/g,p)),P[0]===p&&P[1]===p){const D=P.indexOf(p,2);D===-1?(w=P.substring(2),P=p):(w=P.substring(2,D),P=P.substring(D)||p)}return new g("file",w,P,$,$)}static from(P,w){return new g(P.scheme,P.authority,P.path,P.query,P.fragment,w)}static joinPath(P,...w){if(!P.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let D;return A.$j&&P.scheme==="file"?D=f.file(v.$ic.join(a(P,!0),...w)).path:D=v.$jc.join(P.path,...w),P.with({path:D})}toString(P=!1){return t(this,P)}toJSON(){return this}static revive(P){if(P){if(P instanceof f)return P;{const w=new g(P);return w._formatted=P.external??null,w._fsPath=P._sep===k?P.fsPath??null:null,w}}else return P}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=f;function y(h){return!h||typeof h!="object"?!1:typeof h.scheme=="string"&&(typeof h.authority=="string"||typeof h.authority>"u")&&(typeof h.path=="string"||typeof h.path>"u")&&(typeof h.query=="string"||typeof h.query>"u")&&(typeof h.fragment=="string"||typeof h.fragment>"u")}const k=A.$j?1:void 0;class g extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(P=!1){return P?t(this,!0):(this._formatted||(this._formatted=t(this,!1)),this._formatted)}toJSON(){const P={$mid:r.MarshalledId.Uri};return this._fsPath&&(P.fsPath=this._fsPath,P._sep=k),this._formatted&&(P.external=this._formatted),this.path&&(P.path=this.path),this.scheme&&(P.scheme=this.scheme),this.authority&&(P.authority=this.authority),this.query&&(P.query=this.query),this.fragment&&(P.fragment=this.fragment),P}}const E={[i.CharCode.Colon]:"%3A",[i.CharCode.Slash]:"%2F",[i.CharCode.QuestionMark]:"%3F",[i.CharCode.Hash]:"%23",[i.CharCode.OpenSquareBracket]:"%5B",[i.CharCode.CloseSquareBracket]:"%5D",[i.CharCode.AtSign]:"%40",[i.CharCode.ExclamationMark]:"%21",[i.CharCode.DollarSign]:"%24",[i.CharCode.Ampersand]:"%26",[i.CharCode.SingleQuote]:"%27",[i.CharCode.OpenParen]:"%28",[i.CharCode.CloseParen]:"%29",[i.CharCode.Asterisk]:"%2A",[i.CharCode.Plus]:"%2B",[i.CharCode.Comma]:"%2C",[i.CharCode.Semicolon]:"%3B",[i.CharCode.Equals]:"%3D",[i.CharCode.Space]:"%20"};function S(h,P,w){let D,L=-1;for(let R=0;R<h.length;R++){const T=h.charCodeAt(R);if(T>=i.CharCode.a&&T<=i.CharCode.z||T>=i.CharCode.A&&T<=i.CharCode.Z||T>=i.CharCode.Digit0&&T<=i.CharCode.Digit9||T===i.CharCode.Dash||T===i.CharCode.Period||T===i.CharCode.Underline||T===i.CharCode.Tilde||P&&T===i.CharCode.Slash||w&&T===i.CharCode.OpenSquareBracket||w&&T===i.CharCode.CloseSquareBracket||w&&T===i.CharCode.Colon)L!==-1&&(D+=encodeURIComponent(h.substring(L,R)),L=-1),D!==void 0&&(D+=h.charAt(R));else{D===void 0&&(D=h.substr(0,R));const j=E[T];j!==void 0?(L!==-1&&(D+=encodeURIComponent(h.substring(L,R)),L=-1),D+=j):L===-1&&(L=R)}}return L!==-1&&(D+=encodeURIComponent(h.substring(L))),D!==void 0?D:h}function s(h){let P;for(let w=0;w<h.length;w++){const D=h.charCodeAt(w);D===i.CharCode.Hash||D===i.CharCode.QuestionMark?(P===void 0&&(P=h.substr(0,w)),P+=E[D]):P!==void 0&&(P+=h[w])}return P!==void 0?P:h}function a(h,P){let w;return h.authority&&h.path.length>1&&h.scheme==="file"?w=`//${h.authority}${h.path}`:h.path.charCodeAt(0)===i.CharCode.Slash&&(h.path.charCodeAt(1)>=i.CharCode.A&&h.path.charCodeAt(1)<=i.CharCode.Z||h.path.charCodeAt(1)>=i.CharCode.a&&h.path.charCodeAt(1)<=i.CharCode.z)&&h.path.charCodeAt(2)===i.CharCode.Colon?P?w=h.path.substr(1):w=h.path[1].toLowerCase()+h.path.substr(2):w=h.path,A.$j&&(w=w.replace(/\//g,"\\")),w}function t(h,P){const w=P?s:S;let D="",{scheme:L,authority:R,path:T,query:j,fragment:G}=h;if(L&&(D+=L,D+=":"),(R||L==="file")&&(D+=p,D+=p),R){let q=R.indexOf("@");if(q!==-1){const Q=R.substr(0,q);R=R.substr(q+1),q=Q.lastIndexOf(":"),q===-1?D+=w(Q,!1,!1):(D+=w(Q.substr(0,q),!1,!1),D+=":",D+=w(Q.substr(q+1),!1,!0)),D+="@"}R=R.toLowerCase(),q=R.lastIndexOf(":"),q===-1?D+=w(R,!1,!0):(D+=w(R.substr(0,q),!1,!0),D+=R.substr(q))}if(T){if(T.length>=3&&T.charCodeAt(0)===i.CharCode.Slash&&T.charCodeAt(2)===i.CharCode.Colon){const q=T.charCodeAt(1);q>=i.CharCode.A&&q<=i.CharCode.Z&&(T=`/${String.fromCharCode(q+32)}:${T.substr(3)}`)}else if(T.length>=2&&T.charCodeAt(1)===i.CharCode.Colon){const q=T.charCodeAt(0);q>=i.CharCode.A&&q<=i.CharCode.Z&&(T=`${String.fromCharCode(q+32)}:${T.substr(2)}`)}D+=w(T,!0,!1)}return j&&(D+="?",D+=w(j,!1,!1)),G&&(D+="#",D+=P?G:S(G,!1,!1)),D}function o(h){try{return decodeURIComponent(h)}catch{return h.length>3?h.substr(0,3)+o(h.substr(3)):h}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function c(h){return h.match(n)?h.replace(n,P=>o(P)):h}}),define(le[152],ue([0,1,7]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=r,e.$kr=v,e.$lr=A,e.log=I;function r(l){const m=l;return m&&typeof m.type=="string"&&typeof m.severity=="string"}function v(l){const m=[];let u;try{const $=JSON.parse(l.arguments),p=$[$.length-1];p&&p.__$stack&&($.pop(),u=p.__$stack),m.push(...$)}catch{m.push("Unable to log remote console arguments",l.arguments)}return{args:m,stack:u}}function A(l){if(typeof l!="string")return A(v(l).stack);const m=l;if(m){const u=O(m),$=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(u||"");if($&&$.length===4)return{uri:i.URI.file($[1]),line:Number($[2]),column:Number($[3])}}}function O(l){if(!l)return l;const m=l.indexOf(`
`);return m===-1?l:l.substring(0,m)}function I(l,m){const{args:u,stack:$}=v(l),p=typeof u[0]=="string"&&u.length===1;let d=O($);d&&(d=`(${d.trim()})`);let f=[];if(typeof u[0]=="string"?d&&p?f=[`%c[${m}] %c${u[0]} %c${d}`,b("blue"),b(""),b("grey")]:f=[`%c[${m}] %c${u[0]}`,b("blue"),b(""),...u.slice(1)]:f=[`%c[${m}]%`,b("blue"),...u],d&&!p&&f.push(d),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,f)}function b(l){return`color: ${l}`}}),define(le[83],ue([0,1,17,7,92]),function(K,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=A,e.$ei=O,e.$fi=b;function A(l){return JSON.stringify(l,I)}function O(l){let m=JSON.parse(l);return m=b(m),m}function I(l,m){return m instanceof RegExp?{$mid:v.MarshalledId.Regexp,source:m.source,flags:m.flags}:m}function b(l,m=0){if(!l||m>200)return l;if(typeof l=="object"){switch(l.$mid){case v.MarshalledId.Uri:return r.URI.revive(l);case v.MarshalledId.Regexp:return new RegExp(l.source,l.flags);case v.MarshalledId.Date:return new Date(l.source)}if(l instanceof i.$Qe||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let u=0;u<l.length;++u)l[u]=b(l[u],m+1);else for(const u in l)Object.hasOwnProperty.call(l,u)&&(l[u]=b(l[u],m+1))}return l}}),define(le[11],ue([0,1,15,3,25,7,9]),function(K,e,i,r,v,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Vg=e.$Ug=e.$Tg=e.Schemas=void 0,e.$Rg=b,e.$Sg=l,e.$Wg=u,i=Ie(i),r=Ie(r),O=Ie(O);var I;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellMetadataDiff="vscode-notebook-cell-metadata-diff",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeNotebookCellOutputDiff="vscode-notebook-cell-output-diff",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatCodeBlock="vscode-chat-code-block",d.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm",d.commentsInput="comment",d.codeSetting="code-setting",d.outputChannel="output"})(I||(e.Schemas=I={}));function b(d,f){return A.URI.isUri(d)?(0,v.$If)(d.scheme,f):(0,v.$Jf)(d,f+":")}function l(d,...f){return f.some(y=>b(d,y))}e.$Tg="vscode-tkn",e.$Ug="tkn";class m{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(f){this.d=f}setDelegate(f){this.e=f}setServerRootPath(f,y){this.f=u(f,y)}getServerRootPath(){return this.f}get g(){return O.$jc.join(this.f,I.vscodeRemoteResource)}set(f,y,k){this.a[f]=y,this.b[f]=k}setConnectionToken(f,y){this.c[f]=y}getPreferredWebSchema(){return this.d}rewrite(f){if(this.e)try{return this.e(f)}catch(s){return i.$2(s),f}const y=f.authority;let k=this.a[y];k&&k.indexOf(":")!==-1&&k.indexOf("[")===-1&&(k=`[${k}]`);const g=this.b[y],E=this.c[y];let S=`path=${encodeURIComponent(f.path)}`;return typeof E=="string"&&(S+=`&${e.$Ug}=${encodeURIComponent(E)}`),A.URI.from({scheme:r.$p?this.d:I.vscodeRemoteResource,authority:`${k}:${g}`,path:this.g,query:S})}}e.$Vg=new m;function u(d,f){return O.$jc.join(f??"/",`${d.quality??"oss"}-${d.commit??"dev"}`)}e.$Xg="vs/../../extensions",e.$Yg="vs/../../node_modules",e.$Zg="vs/../../node_modules.asar",e.$1g="vs/../../node_modules.asar.unpacked",e.$2g="vscode-app";class ${static{this.a=e.$2g}asBrowserUri(f){const y=this.b(f,K);return this.uriToBrowserUri(y)}uriToBrowserUri(f){return f.scheme===I.vscodeRemote?e.$Vg.rewrite(f):f.scheme===I.file&&(r.$n||r.$r===`${I.vscodeFileResource}://${$.a}`)?f.with({scheme:I.vscodeFileResource,authority:f.authority||$.a,query:null,fragment:null}):f}asFileUri(f){const y=this.b(f,K);return this.uriToFileUri(y)}uriToFileUri(f){return f.scheme===I.vscodeFileResource?f.with({scheme:I.file,authority:f.authority!==$.a?f.authority:null,query:null,fragment:null}):f}b(f,y){if(A.URI.isUri(f))return f;if(globalThis._VSCODE_FILE_ROOT){const k=globalThis._VSCODE_FILE_ROOT;if(/^\w[\w\d+.-]*:\/\//.test(k))return A.URI.joinPath(A.URI.parse(k,!0),f);const g=O.$mc(k,f);return A.URI.file(g)}return A.URI.parse(y.toUrl(f))}}e.$3g=new $;var p;(function(d){const f=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(f.get("3"));const y="vscode-coi";function k(E){let S;typeof E=="string"?S=new URL(E).searchParams:E instanceof URL?S=E.searchParams:A.URI.isUri(E)&&(S=new URL(E.toString(!0)).searchParams);const s=S?.get(y);if(s)return f.get(s)}d.getHeadersFromQuery=k;function g(E,S,s){if(!globalThis.crossOriginIsolated)return;const a=S&&s?"3":s?"2":"1";E instanceof URLSearchParams?E.set(y,a):E[y]=a}d.addSearchParam=g})(p||(e.COI=p={}))}),define(le[153],ue([0,1,67,11,3,12,7]),function(K,e,i,r,v,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=u,e.$yq=$,v=Ie(v);class I{constructor(d,f,y){this.id=d,this.dependencies=f,this.callback=y}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){if(!this.d){this.d=!0,globalThis.define=(d,f,y)=>{typeof d!="string"&&(y=f,f=d,d=null),(typeof f!="object"||!Array.isArray(f))&&(y=f,f=null),this.c.push(new I(d,f,y))},globalThis.define.amd=!0;try{this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){if(d.startsWith(window.location.origin)||d.startsWith("vscode-file://vscode-app"))return d;throw new Error(`[trusted_script_src] Invalid script url: ${d}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){return d}}))}catch(d){console.warn(d)}}}async load(d){this.g();const f=await(this.a?this.i(d):this.b?this.h(d):this.j(d));if(!f){console.warn(`Did not receive a define call from script ${d}`);return}if(Array.isArray(f.dependencies)&&f.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${d}. The dependencies are: ${f.dependencies.join(", ")}`);return typeof f.callback=="function"?f.callback([]):f.callback}h(d){return new Promise((f,y)=>{const k=document.createElement("script");k.setAttribute("async","async"),k.setAttribute("type","text/javascript");const g=()=>{k.removeEventListener("load",E),k.removeEventListener("error",S)},E=s=>{g(),f(this.c.pop())},S=s=>{g(),y(s)};k.addEventListener("load",E),k.addEventListener("error",S),this.f&&(d=this.f.createScriptURL(d)),k.setAttribute("src",d),window.document.getElementsByTagName("head")[0].appendChild(k)})}async i(d){return this.f&&(d=this.f.createScriptURL(d)),i.$T?await new Promise((f,y)=>{K([d],f,y)}).then(Ie):importScripts(d),this.c.pop()}async j(d){try{const f=globalThis._VSCODE_NODE_MODULES.fs,y=globalThis._VSCODE_NODE_MODULES.vm,k=globalThis._VSCODE_NODE_MODULES.module,g=O.URI.parse(d).fsPath,E=f.readFileSync(g).toString(),S=k.wrap(E.replace(/^#!.*/,""));return new y.Script(S).runInThisContext().apply(),this.c.pop()}catch(f){throw f}}}const l=new Map;let m={};typeof globalThis.require=="object"&&(m=globalThis.require.paths??{});async function u(p,d,f){if(i.$T){f===void 0&&(f=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),m[p]&&(p=m[p]);const y=d?`${p}/${d}`:p;if(l.has(y))return l.get(y);let k;if(/^\w[\w\d+.-]*:\/\//.test(y))k=y;else{const s=`${i.$U&&f&&!v.$p?r.$Zg:r.$Yg}/${y}`;k=r.$3g.asBrowserUri(s).toString(!0)}const g=b.INSTANCE.load(k);return l.set(y,g),g}else return await new Promise((y,k)=>{K([p],y,k)}).then(Ie)}function $(p,d){(0,A.$rg)(i.$T);const y=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit,k=i.$U&&y&&!v.$p,g=`${p}/${d}`,S=`${k?r.$Zg:r.$Yg}/${g}`;return r.$3g.asBrowserUri(S).toString(!0)}}),define(le[18],ue([0,1,39,32,11,9,3,25,7]),function(K,e,i,r,v,A,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=void 0,e.$0g=l,e.$sh=u,e.$th=p,r=Ie(r),A=Ie(A);function l(d){return(0,b.$zc)(d,!0)}class m{constructor(f){this.a=f}compare(f,y,k=!1){return f===y?0:(0,I.$Bf)(this.getComparisonKey(f,k),this.getComparisonKey(y,k))}isEqual(f,y,k=!1){return f===y?!0:!f||!y?!1:this.getComparisonKey(f,k)===this.getComparisonKey(y,k)}getComparisonKey(f,y=!1){return f.with({path:this.a(f)?f.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(f){return this.a(f)}isEqualOrParent(f,y,k=!1){if(f.scheme===y.scheme){if(f.scheme===v.Schemas.file)return r.$Hg(l(f),l(y),this.a(f))&&f.query===y.query&&(k||f.fragment===y.fragment);if((0,e.$oh)(f.authority,y.authority))return r.$Hg(f.path,y.path,this.a(f),"/")&&f.query===y.query&&(k||f.fragment===y.fragment)}return!1}joinPath(f,...y){return b.URI.joinPath(f,...y)}basenameOrAuthority(f){return(0,e.$gh)(f)||f.authority}basename(f){return A.$jc.basename(f.path)}extname(f){return A.$jc.extname(f.path)}dirname(f){if(f.path.length===0)return f;let y;return f.scheme===v.Schemas.file?y=b.URI.file(A.$pc(l(f))).path:(y=A.$jc.dirname(f.path),f.authority&&y.length&&y.charCodeAt(0)!==i.CharCode.Slash&&(console.error(`dirname("${f.toString})) resulted in a relative path`),y="/")),f.with({path:y})}normalizePath(f){if(!f.path.length)return f;let y;return f.scheme===v.Schemas.file?y=b.URI.file(A.$kc(l(f))).path:y=A.$jc.normalize(f.path),f.with({path:y})}relativePath(f,y){if(f.scheme!==y.scheme||!(0,e.$oh)(f.authority,y.authority))return;if(f.scheme===v.Schemas.file){const E=A.$oc(l(f),l(y));return O.$j?r.$Bg(E):E}let k=f.path||"/";const g=y.path||"/";if(this.a(f)){let E=0;for(const S=Math.min(k.length,g.length);E<S&&!(k.charCodeAt(E)!==g.charCodeAt(E)&&k.charAt(E).toLowerCase()!==g.charAt(E).toLowerCase());E++);k=g.substr(0,E)+k.substr(E)}return A.$jc.relative(k,g)}resolvePath(f,y){if(f.scheme===v.Schemas.file){const k=b.URI.file(A.$nc(l(f),y));return f.with({authority:k.authority,path:k.path})}return y=r.$Cg(y),f.with({path:A.$jc.resolve(f.path,y)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,y){return f===y||f!==void 0&&y!==void 0&&(0,I.$If)(f,y)}hasTrailingPathSeparator(f,y=A.sep){if(f.scheme===v.Schemas.file){const k=l(f);return k.length>r.$Dg(k).length&&k[k.length-1]===y}else{const k=f.path;return k.length>1&&k.charCodeAt(k.length-1)===i.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,y=A.sep){return(0,e.$ph)(f,y)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,y=A.sep){let k=!1;if(f.scheme===v.Schemas.file){const g=l(f);k=g!==void 0&&g.length===r.$Dg(g).length&&g[g.length-1]===y}else{y="/";const g=f.path;k=g.length===1&&g.charCodeAt(g.length-1)===i.CharCode.Slash}return!k&&!(0,e.$ph)(f,y)?f.with({path:f.path+"/"}):f}}e.$$g=m,e.$_g=new m(()=>!1),e.$ah=new m(d=>d.scheme===v.Schemas.file?!O.$l:!0),e.$bh=new m(d=>!0),e.$ch=e.$_g.isEqual.bind(e.$_g),e.$dh=e.$_g.isEqualOrParent.bind(e.$_g),e.$eh=e.$_g.getComparisonKey.bind(e.$_g),e.$fh=e.$_g.basenameOrAuthority.bind(e.$_g),e.$gh=e.$_g.basename.bind(e.$_g),e.$hh=e.$_g.extname.bind(e.$_g),e.$ih=e.$_g.dirname.bind(e.$_g),e.$jh=e.$_g.joinPath.bind(e.$_g),e.$kh=e.$_g.normalizePath.bind(e.$_g),e.$lh=e.$_g.relativePath.bind(e.$_g),e.$mh=e.$_g.resolvePath.bind(e.$_g),e.$nh=e.$_g.isAbsolutePath.bind(e.$_g),e.$oh=e.$_g.isEqualAuthority.bind(e.$_g),e.$ph=e.$_g.hasTrailingPathSeparator.bind(e.$_g),e.$qh=e.$_g.removeTrailingPathSeparator.bind(e.$_g),e.$rh=e.$_g.addTrailingPathSeparator.bind(e.$_g);function u(d,f){const y=[];for(let k=0;k<d.length;k++){const g=f(d[k]);d.some((E,S)=>S===k?!1:(0,e.$dh)(g,f(E)))||y.push(d[k])}return y}var $;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function f(y){const k=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(S=>{const[s,a]=S.split(":");s&&a&&k.set(s,a)});const E=y.path.substring(0,y.path.indexOf(";"));return E&&k.set(d.META_DATA_MIME,E),k}d.parseMetaData=f})($||(e.DataUri=$={}));function p(d,f,y){if(f){let k=d.path;return k&&k[0]!==A.$jc.sep&&(k=A.$jc.sep+k),d.with({scheme:y,authority:f,path:k})}return d.with({scheme:y})}}),define(le[8],ue([0,1,22,15,4,2,18,3,149,68]),function(K,e,i,r,v,A,O,I,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=e.$0h=e.$9h=e.$8h=e.$7h=e.Promises=e.$6h=e.$5h=e.$4h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=void 0,e.$uh=m,e.$vh=u,e.$wh=$,e.$xh=p,e.$yh=d,e.$zh=f,e.$Ah=y,e.$Bh=k,e.$Jh=h,e.$Kh=P,e.$Lh=w,e.$Mh=D,e.$Nh=L,e.$3h=W,e.$$h=N;function m(X){return!!X&&typeof X.then=="function"}function u(X){const z=new i.$ze,te=X(z.token),ae=new Promise((me,be)=>{const ye=z.token.onCancellationRequested(()=>{ye.dispose(),be(new r.$7)});Promise.resolve(te).then(Fe=>{ye.dispose(),z.dispose(),me(Fe)},Fe=>{ye.dispose(),z.dispose(),be(Fe)})});return new class{cancel(){z.cancel(),z.dispose()}then(me,be){return ae.then(me,be)}catch(me){return this.then(void 0,me)}finally(me){return ae.finally(me)}}}function $(X,z,te){return new Promise((ae,me)=>{const be=z.onCancellationRequested(()=>{be.dispose(),ae(te)});X.then(ae,me).finally(()=>be.dispose())})}function p(X,z){return new Promise((te,ae)=>{const me=z.onCancellationRequested(()=>{me.dispose(),ae(new r.$7)});X.then(te,ae).finally(()=>me.dispose())})}async function d(X){let z=-1;const te=X.map((ae,me)=>ae.then(be=>(z=me,be)));try{return await Promise.race(te)}finally{X.forEach((ae,me)=>{me!==z&&ae.cancel()})}}function f(X,z,te){let ae;const me=setTimeout(()=>{ae?.(void 0),te?.()},z);return Promise.race([X.finally(()=>clearTimeout(me)),new Promise(be=>ae=be)])}function y(X){return new Promise((z,te)=>{const ae=X();m(ae)?ae.then(z,te):z(ae)})}function k(){let X,z;return{promise:new Promise((ae,me)=>{X=ae,z=me}),resolve:X,reject:z}}class g{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(z){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=z,!this.b){const te=()=>{if(this.b=null,this.f)return;const ae=this.queue(this.d);return this.d=null,ae};this.b=new Promise(ae=>{this.a.then(te,te).then(ae)})}return new Promise((te,ae)=>{this.b.then(te,ae)})}return this.a=z(),new Promise((te,ae)=>{this.a.then(me=>{this.a=null,te(me)},me=>{this.a=null,ae(me)})})}dispose(){this.f=!0}}e.$Ch=g;class E{constructor(){this.a=Promise.resolve(null)}queue(z){return this.a=this.a.then(()=>z(),()=>z())}}e.$Dh=E;class S{constructor(){this.a=new Map}queue(z,te){const me=(this.a.get(z)??Promise.resolve()).catch(()=>{}).then(te).finally(()=>{this.a.get(z)===me&&this.a.delete(z)});return this.a.set(z,me),me}}e.$Eh=S;const s=(X,z)=>{let te=!0;const ae=setTimeout(()=>{te=!1,z()},X);return{isTriggered:()=>te,dispose:()=>{clearTimeout(ae),te=!1}}},a=X=>{let z=!0;return queueMicrotask(()=>{z&&(z=!1,X())}),{isTriggered:()=>z,dispose:()=>{z=!1}}};class t{constructor(z){this.defaultDelay=z,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(z,te=this.defaultDelay){this.g=z,this.h(),this.b||(this.b=new Promise((me,be)=>{this.d=me,this.f=be}).then(()=>{if(this.b=null,this.d=null,this.g){const me=this.g;return this.g=null,me()}}));const ae=()=>{this.a=null,this.d?.(null)};return this.a=te===b.$je?a(ae):s(te,ae),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new r.$7),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Fh=t;class o{constructor(z){this.a=new t(z),this.b=new g}trigger(z,te){return this.a.trigger(()=>this.b.queue(z),te)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Gh=o;class n{constructor(){this.a=!1,this.b=new Promise((z,te)=>{this.d=z})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Hh=n;class c extends n{constructor(z){super(),this.f=setTimeout(()=>this.open(),z)}open(){clearTimeout(this.f),super.open()}}e.$Ih=c;function h(X,z){return z?new Promise((te,ae)=>{const me=setTimeout(()=>{be.dispose(),te()},X),be=z.onCancellationRequested(()=>{clearTimeout(me),be.dispose(),ae(new r.$7)})}):u(te=>h(X,te))}function P(X,z=0,te){const ae=setTimeout(()=>{X(),te&&me.dispose()},z),me=(0,A.$Vc)(()=>{clearTimeout(ae),te?.deleteAndLeak(me)});return te?.add(me),me}function w(X){const z=[];let te=0;const ae=X.length;function me(){return te<ae?X[te++]():null}function be(ye){ye!=null&&z.push(ye);const Fe=me();return Fe?Fe.then(be):Promise.resolve(z)}return Promise.resolve(null).then(be)}function D(X,z=ae=>!!ae,te=null){let ae=0;const me=X.length,be=()=>{if(ae>=me)return Promise.resolve(te);const ye=X[ae++];return Promise.resolve(ye()).then(Ve=>z(Ve)?Promise.resolve(Ve):be())};return be()}function L(X,z=ae=>!!ae,te=null){if(X.length===0)return Promise.resolve(te);let ae=X.length;const me=()=>{ae=-1;for(const be of X)be.cancel?.()};return new Promise((be,ye)=>{for(const Fe of X)Fe.then(Ve=>{--ae>=0&&z(Ve)?(me(),be(Ve)):ae===0&&be(te)}).catch(Ve=>{--ae>=0&&(me(),ye(Ve))})})}class R{constructor(z){this.a=0,this.b=!1,this.f=z,this.g=[],this.d=0,this.h=new v.$oe}whenIdle(){return this.size>0?v.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(z){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((te,ae)=>{this.g.push({factory:z,c:te,e:ae}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const z=this.g.shift();this.d++;const te=z.factory();te.then(z.c,z.e),te.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Oh=R;class T extends R{constructor(){super(1)}}e.$Ph=T;class j{constructor(){this.a=new F,this.b=0}queue(z){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,z())):this.a.run(this.b++,z())}}e.$Qh=j;class G{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const z=new x;return this.b.add(z),z.p}g(){for(const[,z]of this.a)if(z.size>0)return!1;return!0}queueSize(z,te=O.$_g){const ae=te.getComparisonKey(z);return this.a.get(ae)?.size??0}queueFor(z,te,ae=O.$_g){const me=ae.getComparisonKey(z);let be=this.a.get(me);if(!be){be=new T;const ye=this.f++,Fe=v.Event.once(be.onDrained)(()=>{be?.dispose(),this.a.delete(me),this.h(),this.d?.deleteAndDispose(ye),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$7c),this.d.set(ye,Fe),this.a.set(me,be)}return be.queue(te)}h(){this.g()&&this.j()}j(){for(const z of this.b)z.complete();this.b.clear()}dispose(){for(const[,z]of this.a)z.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Rh=G;class q{constructor(z,te){this.b=!1,this.a=-1,typeof z=="function"&&typeof te=="number"&&this.setIfNotSet(z,te)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(z,te){if(this.b)throw new r.$eb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,z()},te)}setIfNotSet(z,te){if(this.b)throw new r.$eb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,z()},te))}}e.$Sh=q;class Q{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(z,te,ae=globalThis){if(this.f)throw new r.$eb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const me=ae.setInterval(()=>{z()},te);this.d=(0,A.$Vc)(()=>{ae.clearInterval(me),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Th=Q;class de{constructor(z,te){this.b=-1,this.a=z,this.d=te,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(z=this.d){this.cancel(),this.b=setTimeout(this.f,z)}get delay(){return this.d}set delay(z){this.d=z}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Uh=de;class V{constructor(z,te){te%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${te}ms is not a multiple of 1000ms.`),this.a=z,this.b=te,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(z=this.b){z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${z}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(z/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Vh=V;class Y extends de{constructor(z,te){super(z,te),this.j=[]}work(z){this.j.push(z),this.isScheduled()||this.schedule()}h(){const z=this.j;this.j=[],this.a?.(z)}dispose(){this.j=[],super.dispose()}}e.$Wh=Y;class B extends A.$Xc{constructor(z,te){super(),this.g=z,this.h=te,this.a=[],this.b=this.B(new A.$Yc),this.f=!1}get pending(){return this.a.length}work(z){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+z.length>this.g.maxBufferedWork)return!1}else if(this.pending+z.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const te of z)this.a.push(te);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new de(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Xh=B,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Zh=(X,z)=>{(0,I.$C)(()=>{if(te)return;const ae=Date.now()+15;z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ae-Date.now())}}))});let te=!1;return{dispose(){te||(te=!0)}}}:e.$Zh=(X,z,te)=>{const ae=X.requestIdleCallback(z,typeof te=="number"?{timeout:te}:void 0);let me=!1;return{dispose(){me||(me=!0,X.cancelIdleCallback(ae))}}},e.$Yh=X=>(0,e.$Zh)(globalThis,X)}();class _{constructor(z,te){this.g=!1,this.d=()=>{try{this.j=te()}catch(ae){this.l=ae}finally{this.g=!0}},this.f=(0,e.$Zh)(z,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$1h=_;class C extends _{constructor(z){super(globalThis,z)}}e.$2h=C;async function W(X,z,te){let ae;for(let me=0;me<te;me++)try{return await X()}catch(be){ae=be,await h(z)}throw ae}class F{isRunning(z){return typeof z=="number"?this.a?.taskId===z:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(z,te,ae){return this.a={taskId:z,cancel:()=>ae?.(),promise:te},te.then(()=>this.d(z),()=>this.d(z)),te}d(z){this.a&&z===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const z=this.b;this.b=void 0,z.run().then(z.promiseResolve,z.promiseReject)}}queue(z){if(this.b)this.b.run=z;else{const{promise:te,resolve:ae,reject:me}=k();this.b={run:z,promise:te,promiseResolve:ae,promiseReject:me}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$4h=F;class H{constructor(z,te=()=>Date.now()){this.d=z,this.f=te,this.a=0,this.b=0}increment(){const z=this.f();return z-this.a>this.d&&(this.a=z,this.b=0),this.b++,this.b}}e.$5h=H;var ne;(function(X){X[X.Resolved=0]="Resolved",X[X.Rejected=1]="Rejected"})(ne||(ne={}));class x{get isRejected(){return this.d?.outcome===ne.Rejected}get isResolved(){return this.d?.outcome===ne.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===ne.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((z,te)=>{this.a=z,this.b=te})}complete(z){return new Promise(te=>{this.a(z),this.d={outcome:ne.Resolved,value:z},te()})}error(z){return new Promise(te=>{this.b(z),this.d={outcome:ne.Rejected,value:z},te()})}cancel(){return this.error(new r.$7)}}e.$6h=x;var ce;(function(X){async function z(ae){let me;const be=await Promise.all(ae.map(ye=>ye.then(Fe=>Fe,Fe=>{me||(me=Fe)})));if(typeof me<"u")throw me;return be}X.settled=z;function te(ae){return new Promise(async(me,be)=>{try{await ae(me,be)}catch(ye){be(ye)}})}X.withAsyncBody=te})(ce||(e.Promises=ce={}));class oe{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(z){this.a=void 0,this.b=void 0,this.d=!1,this.promise=z.then(te=>(this.a=te,this.d=!0,te),te=>{throw this.b=te,this.d=!0,te})}requireValue(){if(!this.d)throw new r.$eb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$7h=oe;class J{constructor(z){this.b=z,this.a=new l.$W(()=>new oe(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$8h=J;var M;(function(X){X[X.Initial=0]="Initial",X[X.DoneOK=1]="DoneOK",X[X.DoneError=2]="DoneError"})(M||(M={}));class Z{static fromArray(z){return new Z(te=>{te.emitMany(z)})}static fromPromise(z){return new Z(async te=>{te.emitMany(await z)})}static fromPromises(z){return new Z(async te=>{await Promise.all(z.map(async ae=>te.emitOne(await ae)))})}static merge(z){return new Z(async te=>{await Promise.all(z.map(async ae=>{for await(const me of ae)te.emitOne(me)}))})}static{this.EMPTY=Z.fromArray([])}constructor(z,te){this.a=M.Initial,this.b=[],this.d=null,this.f=te,this.g=new v.$oe,queueMicrotask(async()=>{const ae={emitOne:me=>this.h(me),emitMany:me=>this.j(me),reject:me=>this.l(me)};try{await Promise.resolve(z(ae)),this.k()}catch(me){this.l(me)}finally{ae.emitOne=void 0,ae.emitMany=void 0,ae.reject=void 0}})}[Symbol.asyncIterator](){let z=0;return{next:async()=>{do{if(this.a===M.DoneError)throw this.d;if(z<this.b.length)return{done:!1,value:this.b[z++]};if(this.a===M.DoneOK)return{done:!0,value:void 0};await v.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(z,te){return new Z(async ae=>{for await(const me of z)ae.emitOne(te(me))})}map(z){return Z.map(this,z)}static filter(z,te){return new Z(async ae=>{for await(const me of z)te(me)&&ae.emitOne(me)})}filter(z){return Z.filter(this,z)}static coalesce(z){return Z.filter(z,te=>!!te)}coalesce(){return Z.coalesce(this)}static async toPromise(z){const te=[];for await(const ae of z)te.push(ae);return te}toPromise(){return Z.toPromise(this)}h(z){this.a===M.Initial&&(this.b.push(z),this.g.fire())}j(z){this.a===M.Initial&&(this.b=this.b.concat(z),this.g.fire())}k(){this.a===M.Initial&&(this.a=M.DoneOK,this.g.fire())}l(z){this.a===M.Initial&&(this.a=M.DoneError,this.d=z,this.g.fire())}}e.$9h=Z;class U extends Z{constructor(z,te){super(te),this.m=z}cancel(){this.m.cancel()}}e.$0h=U;function N(X){const z=new i.$ze,te=X(z.token);return new U(z,async ae=>{const me=z.token.onCancellationRequested(()=>{me.dispose(),z.dispose(),ae.reject(new r.$7)});try{for await(const be of te){if(z.token.isCancellationRequested)return;ae.emitOne(be)}me.dispose(),z.dispose()}catch(be){me.dispose(),z.dispose(),ae.reject(be)}})}class ie{constructor(z){this.a=new x,this.b=new Z(me=>{if(te){me.reject(te);return}return ae&&me.emitMany(ae),this.d=be=>me.reject(be),this.f=be=>me.emitOne(be),this.a.p},z);let te,ae;this.f=me=>{ae||(ae=[]),ae.push(me)},this.d=me=>{te||(te=me)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(z){this.d(z),this.a.complete()}emitOne(z){this.f(z)}}e.$_h=ie}),define(le[114],ue([0,1,21,8,39,32,31,9,3,25]),function(K,e,i,r,v,A,O,I,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=e.$zk=void 0,e.$yk=m,e.$Bk=f,e.$Ck=j,e.$Dk=G,e.$Ek=q,e.$Fk=Q,e.$Gk=de,e.$Hk=_;function m(){return Object.create(null)}e.$zk="**",e.$Ak="/";const u="[/\\\\]",$="[^/\\\\]",p=/\//g;function d(C,W){switch(C){case 0:return"";case 1:return`${$}*?`;default:return`(?:${u}|${$}+${u}${W?`|${u}${$}+`:""})*?`}}function f(C,W){if(!C)return[];const F=[];let H=!1,ne=!1,x="";for(const ce of C){switch(ce){case W:if(!H&&!ne){F.push(x),x="";continue}break;case"{":H=!0;break;case"}":H=!1;break;case"[":ne=!0;break;case"]":ne=!1;break}x+=ce}return x&&F.push(x),F}function y(C){if(!C)return"";let W="";const F=f(C,e.$Ak);if(F.every(H=>H===e.$zk))W=".*";else{let H=!1;F.forEach((ne,x)=>{if(ne===e.$zk){if(H)return;W+=d(2,x===F.length-1)}else{let ce=!1,oe="",J=!1,M="";for(const Z of ne){if(Z!=="}"&&ce){oe+=Z;continue}if(J&&(Z!=="]"||!M)){let U;Z==="-"?U=Z:(Z==="^"||Z==="!")&&!M?U="^":Z===e.$Ak?U="":U=(0,l.$kf)(Z),M+=U;continue}switch(Z){case"{":ce=!0;continue;case"[":J=!0;continue;case"}":{const N=`(?:${f(oe,",").map(ie=>y(ie)).join("|")})`;W+=N,ce=!1,oe="";break}case"]":{W+="["+M+"]",J=!1,M="";break}case"?":W+=$;continue;case"*":W+=d(1);continue;default:W+=(0,l.$kf)(Z)}}x<F.length-1&&(F[x+1]!==e.$zk||x+2<F.length)&&(W+=u)}H=ne===e.$zk})}return W}const k=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,S=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new O.$Gc(1e4),o=function(){return!1},n=function(){return null};function c(C,W){if(!C)return n;let F;typeof C!="string"?F=C.pattern:F=C,F=F.trim();const H=`${F}_${!!W.trimForExclusions}`;let ne=t.get(H);if(ne)return h(ne,C);let x;return k.test(F)?ne=w(F.substr(4),F):(x=g.exec(P(F,W)))?ne=D(x[1],F):(W.trimForExclusions?S:E).test(F)?ne=L(F,W):(x=s.exec(P(F,W)))?ne=R(x[1].substr(1),F,!0):(x=a.exec(P(F,W)))?ne=R(x[1],F,!1):ne=T(F),t.set(H,ne),h(ne,C)}function h(C,W){if(typeof W=="string")return C;const F=function(H,ne){return(0,A.$Hg)(H,W.base,!b.$l)?C((0,l.$pf)(H.substr(W.base.length),I.sep),ne):null};return F.allBasenames=C.allBasenames,F.allPaths=C.allPaths,F.basenames=C.basenames,F.patterns=C.patterns,F}function P(C,W){return W.trimForExclusions&&C.endsWith("/**")?C.substr(0,C.length-2):C}function w(C,W){return function(F,H){return typeof F=="string"&&F.endsWith(C)?W:null}}function D(C,W){const F=`/${C}`,H=`\\${C}`,ne=function(ce,oe){return typeof ce!="string"?null:oe?oe===C?W:null:ce===C||ce.endsWith(F)||ce.endsWith(H)?W:null},x=[C];return ne.basenames=x,ne.patterns=[W],ne.allBasenames=x,ne}function L(C,W){const F=B(C.slice(1,-1).split(",").map(oe=>c(oe,W)).filter(oe=>oe!==n),C),H=F.length;if(!H)return n;if(H===1)return F[0];const ne=function(oe,J){for(let M=0,Z=F.length;M<Z;M++)if(F[M](oe,J))return C;return null},x=F.find(oe=>!!oe.allBasenames);x&&(ne.allBasenames=x.allBasenames);const ce=F.reduce((oe,J)=>J.allPaths?oe.concat(J.allPaths):oe,[]);return ce.length&&(ne.allPaths=ce),ne}function R(C,W,F){const H=I.sep===I.$jc.sep,ne=H?C:C.replace(p,I.sep),x=I.sep+ne,ce=I.$jc.sep+C;let oe;return F?oe=function(J,M){return typeof J=="string"&&(J===ne||J.endsWith(x)||!H&&(J===C||J.endsWith(ce)))?W:null}:oe=function(J,M){return typeof J=="string"&&(J===ne||!H&&J===C)?W:null},oe.allPaths=[(F?"*/":"./")+C],oe}function T(C){try{const W=new RegExp(`^${y(C)}$`);return function(F){return W.lastIndex=0,typeof F=="string"&&W.test(F)?C:null}}catch{return n}}function j(C,W,F){return!C||typeof W!="string"?!1:G(C)(W,void 0,F)}function G(C,W={}){if(!C)return o;if(typeof C=="string"||q(C)){const F=c(C,W);if(F===n)return o;const H=function(ne,x){return!!F(ne,x)};return F.allBasenames&&(H.allBasenames=F.allBasenames),F.allPaths&&(H.allPaths=F.allPaths),H}return V(C,W)}function q(C){const W=C;return W?typeof W.base=="string"&&typeof W.pattern=="string":!1}function Q(C){return C.allBasenames||[]}function de(C){return C.allPaths||[]}function V(C,W){const F=B(Object.getOwnPropertyNames(C).map(oe=>Y(oe,C[oe],W)).filter(oe=>oe!==n)),H=F.length;if(!H)return n;if(!F.some(oe=>!!oe.requiresSiblings)){if(H===1)return F[0];const oe=function(Z,U){let N;for(let ie=0,X=F.length;ie<X;ie++){const z=F[ie](Z,U);if(typeof z=="string")return z;(0,r.$uh)(z)&&(N||(N=[]),N.push(z))}return N?(async()=>{for(const ie of N){const X=await ie;if(typeof X=="string")return X}return null})():null},J=F.find(Z=>!!Z.allBasenames);J&&(oe.allBasenames=J.allBasenames);const M=F.reduce((Z,U)=>U.allPaths?Z.concat(U.allPaths):Z,[]);return M.length&&(oe.allPaths=M),oe}const ne=function(oe,J,M){let Z,U;for(let N=0,ie=F.length;N<ie;N++){const X=F[N];X.requiresSiblings&&M&&(J||(J=(0,I.$qc)(oe)),Z||(Z=J.substr(0,J.length-(0,I.$rc)(oe).length)));const z=X(oe,J,Z,M);if(typeof z=="string")return z;(0,r.$uh)(z)&&(U||(U=[]),U.push(z))}return U?(async()=>{for(const N of U){const ie=await N;if(typeof ie=="string")return ie}return null})():null},x=F.find(oe=>!!oe.allBasenames);x&&(ne.allBasenames=x.allBasenames);const ce=F.reduce((oe,J)=>J.allPaths?oe.concat(J.allPaths):oe,[]);return ce.length&&(ne.allPaths=ce),ne}function Y(C,W,F){if(W===!1)return n;const H=c(C,F);if(H===n)return n;if(typeof W=="boolean")return H;if(W){const ne=W.when;if(typeof ne=="string"){const x=(ce,oe,J,M)=>{if(!M||!H(ce,oe))return null;const Z=ne.replace("$(basename)",()=>J),U=M(Z);return(0,r.$uh)(U)?U.then(N=>N?C:null):U?C:null};return x.requiresSiblings=!0,x}}return H}function B(C,W){const F=C.filter(oe=>!!oe.basenames);if(F.length<2)return C;const H=F.reduce((oe,J)=>{const M=J.basenames;return M?oe.concat(M):oe},[]);let ne;if(W){ne=[];for(let oe=0,J=H.length;oe<J;oe++)ne.push(W)}else ne=F.reduce((oe,J)=>{const M=J.patterns;return M?oe.concat(M):oe},[]);const x=function(oe,J){if(typeof oe!="string")return null;if(!J){let Z;for(Z=oe.length;Z>0;Z--){const U=oe.charCodeAt(Z-1);if(U===v.CharCode.Slash||U===v.CharCode.Backslash)break}J=oe.substr(Z)}const M=H.indexOf(J);return M!==-1?ne[M]:null};x.basenames=H,x.patterns=ne,x.allBasenames=H;const ce=C.filter(oe=>!oe.basenames);return ce.push(x),ce}function _(C,W){return(0,i.$wb)(C,W,(F,H)=>typeof F=="string"&&typeof H=="string"?F===H:typeof F!="string"&&typeof H!="string"?F.base===H.base&&F.pattern===H.pattern:!1)}}),define(le[48],ue([0,1,21,32,9,3,18,25]),function(K,e,i,r,v,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7w=b,e.$8w=m,e.$9w=$,e.$0w=p,e.$$w=k,e.$_w=E,e.$ax=S,e.$bx=s,e.$cx=a,e.$dx=t;function b(n,c){const{os:h,tildify:P,relative:w}=c;if(w){const R=l(n,w,h);if(typeof R=="string")return R}let D=n.fsPath;if(h===A.OperatingSystem.Windows&&!A.$j?D=D.replace(/\//g,"\\"):h!==A.OperatingSystem.Windows&&A.$j&&(D=D.replace(/\\/g,"/")),h!==A.OperatingSystem.Windows&&P?.userHome){const R=P.userHome.fsPath;let T;n.scheme!==P.userHome.scheme&&n.path[0]===v.$jc.sep&&n.path[1]!==v.$jc.sep?T=P.userHome.with({path:n.path}).fsPath:T=D,D=$(T,R,h)}return(h===A.OperatingSystem.Windows?v.$ic:v.$jc).normalize(m(D,h===A.OperatingSystem.Windows))}function l(n,c,h){const P=h===A.OperatingSystem.Windows?v.$ic:v.$jc,w=h===A.OperatingSystem.Linux?O.$_g:O.$bh,D=c.getWorkspace(),L=(0,i.$Qb)(D.folders);if(!L)return;n.scheme!==L.uri.scheme&&n.path[0]===v.$jc.sep&&n.path[1]!==v.$jc.sep&&(n=L.uri.with({path:n.path}));const R=c.getWorkspaceFolder(n);if(!R)return;let T;if(w.isEqual(R.uri,n)?T="":T=w.relativePath(R.uri,n)??"",T&&(T=P.normalize(T)),D.folders.length>1&&!c.noPrefix){const j=R.name?R.name:w.basenameOrAuthority(R.uri);T=T?`${j} \u2022 ${T}`:j}return T}function m(n,c=A.$j){return(0,r.$Mg)(n,c)?n.charAt(0).toUpperCase()+n.slice(1):n}let u=Object.create(null);function $(n,c,h=A.OS){if(h===A.OperatingSystem.Windows||!n||!c)return n;let P=u.original===c?u.normalized:void 0;P||(P=c,A.$j&&(P=(0,r.$Bg)(P)),P=`${(0,I.$qf)(P,v.$jc.sep)}${v.$jc.sep}`,u={original:c,normalized:P});let w=n;return A.$j&&(w=(0,r.$Bg)(w)),(h===A.OperatingSystem.Linux?w.startsWith(P):(0,I.$Jf)(w,P))?`~/${w.substr(P.length)}`:n}function p(n,c){return n.replace(/^~($|\/|\\)/,`${c}$1`)}const d="\u2026",f="\\\\",y="~";function k(n,c=v.sep){const h=new Array(n.length);let P=!1;for(let w=0;w<n.length;w++){const D=n[w];if(D===""){h[w]=`.${c}`;continue}if(!D){h[w]=D;continue}P=!0;let L="",R=D;R.indexOf(f)===0?(L=R.substr(0,R.indexOf(f)+f.length),R=R.substr(R.indexOf(f)+f.length)):R.indexOf(c)===0?(L=R.substr(0,R.indexOf(c)+c.length),R=R.substr(R.indexOf(c)+c.length)):R.indexOf(y)===0&&(L=R.substr(0,R.indexOf(y)+y.length),R=R.substr(R.indexOf(y)+y.length));const T=R.split(c);for(let j=1;P&&j<=T.length;j++)for(let G=T.length-j;P&&G>=0;G--){P=!1;let q=T.slice(G,G+j).join(c);for(let Q=0;!P&&Q<n.length;Q++)if(Q!==w&&n[Q]&&n[Q].indexOf(q)>-1){const de=G+j===T.length,V=G>0&&n[Q].indexOf(c)>-1?c+q:q,Y=n[Q].endsWith(V);P=!de||Y}if(!P){let Q="";(T[0].endsWith(":")||L!=="")&&(G===1&&(G=0,j++,q=T[0]+c+q),G>0&&(Q=T[0]+c),Q=L+Q),G>0&&(Q=Q+d+c),Q=Q+q,G+j<T.length&&(Q=Q+c+d),h[w]=Q}}P&&(h[w]=D)}return h}var g;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function E(n,c=Object.create(null)){const h=[];let P=!1,w="";for(const D of n)if(D==="$"||P&&D==="{")w&&h.push({value:w,type:g.TEXT}),w="",P=!0;else if(D==="}"&&P){const L=c[w];if(typeof L=="string")L.length&&h.push({value:L,type:g.VARIABLE});else if(L){const R=h[h.length-1];(!R||R.type!==g.SEPARATOR)&&h.push({value:L.label,type:g.SEPARATOR})}w="",P=!1}else w+=D;return w&&!P&&h.push({value:w,type:g.TEXT}),h.filter((D,L)=>{if(D.type===g.SEPARATOR){const R=h[L-1],T=h[L+1];return[R,T].every(j=>j&&(j.type===g.VARIABLE||j.type===g.TEXT)&&j.value.length>0)}return!0}).map(D=>D.value).join("")}function S(n,c){return A.$k||c?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.$k?"&":"&&"):n.replace(/&&|&/g,h=>h==="&"?"&&":"&")}function s(n,c){return A.$k||c?n.replace(/\(&&\w\)|&&/g,""):A.$j?n.replace(/&&|&/g,h=>h==="&"?"&&":"&"):n.replace(/&&/g,"_")}function a(n){return n.replace(/&/g,"&&")}function t(n){if(n.endsWith("]")){const c=n.lastIndexOf(" [",n.length-2);if(c!==-1){const h=o(n.substring(0,c)),P=n.substring(c);return{name:h.name+P,parentPath:h.parentPath}}}return o(n)}function o(n){const c=n.indexOf("/")!==-1?v.$jc:v.$ic,h=c.basename(n),P=c.dirname(n);return h.length?{name:h,parentPath:P}:{name:P,parentPath:""}}}),define(le[154],ue([0,1,17,92,7]),function(K,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rn=e.$Qn=void 0,e.$Sn=b,e.$Tn=m,e.$Un=u;function A($){return $.toJSON()}class O{constructor(p){this.a=p}transformIncoming(p){const d=this.a.transformIncoming(p);return d===p?p:A(v.URI.from(d))}transformOutgoing(p){const d=this.a.transformOutgoing(p);return d===p?p:A(v.URI.from(d))}transformOutgoingURI(p){const d=this.a.transformOutgoing(p);return d===p?p:v.URI.from(d)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.$Qn=O,e.$Rn=new class{transformIncoming($){return $}transformOutgoing($){return $}transformOutgoingURI($){return $}transformOutgoingScheme($){return $}};function I($,p,d){if(!$||d>200)return null;if(typeof $=="object"){if($ instanceof v.URI)return p.transformOutgoing($);for(const f in $)if(Object.hasOwnProperty.call($,f)){const y=I($[f],p,d+1);y!==null&&($[f]=y)}}return null}function b($,p){const d=I($,p,0);return d===null?$:d}function l($,p,d,f){if(!$||f>200)return null;if(typeof $=="object"){if($.$mid===r.MarshalledId.Uri)return d?v.URI.revive(p.transformIncoming($)):p.transformIncoming($);if($ instanceof i.$Qe)return null;for(const y in $)if(Object.hasOwnProperty.call($,y)){const k=l($[y],p,d,f+1);k!==null&&($[y]=k)}}return null}function m($,p){const d=l($,p,!1,0);return d===null?$:d}function u($,p){const d=l($,p,!0,0);return d===null?$:d}}),define(le[33],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5g=void 0,e.$4g=r;const i=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function r(v){return i.test(v)}e.$5g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let v;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?v=crypto.getRandomValues.bind(crypto):v=function(I){for(let b=0;b<I.length;b++)I[b]=Math.floor(Math.random()*256);return I};const A=new Uint8Array(16),O=[];for(let I=0;I<256;I++)O.push(I.toString(16).padStart(2,"0"));return function(){v(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let b=0,l="";return l+=O[A[b++]],l+=O[A[b++]],l+=O[A[b++]],l+=O[A[b++]],l+="-",l+=O[A[b++]],l+=O[A[b++]],l+="-",l+=O[A[b++]],l+=O[A[b++]],l+="-",l+=O[A[b++]],l+=O[A[b++]],l+="-",l+=O[A[b++]],l+=O[A[b++]],l+=O[A[b++]],l+=O[A[b++]],l+=O[A[b++]],l+=O[A[b++]],l}}()}),define(le[155],ue([0,1,93,26,91]),function(K,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_X=A,i=Ie(i),r=Ie(r);async function A(O,I){if(await new Promise((m,u)=>{const $=r.createReadStream(O),p=i.createHash("sha256");$.pipe(p);const d=(0,v.$fb)((f,y)=>{$.removeAllListeners(),p.removeAllListeners(),f?u(f):m(y)});$.once("error",d),$.once("end",d),p.once("error",d),p.once("data",f=>d(void 0,f.toString("hex")))})!==I)throw new Error("Hash mismatch")}}),define(le[156],ue([0,1,27]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vn=A;const r=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function v(O){const I=O.replace(/\-/g,":").toLowerCase();return!r.has(I)}function A(){const O=(0,i.networkInterfaces)();for(const I in O){const b=O[I];if(b){for(const{mac:l}of b)if(v(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(le[94],ue([0,1,27,61,33,156,3]),function(K,e,i,r,v,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wn=void 0,e.$Xn=b,e.$Yn=u,e.$Zn=$,v=Ie(v),e.$Wn=new class{c(p){return this.a||(this.a=r.$Oi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(p)}value(){if(this.b===void 0){let p=0,d=0;const f=(0,i.networkInterfaces)();for(const y in f){const k=f[y];if(k)for(const{mac:g,internal:E}of k)E||(d+=1,this.c(g.toUpperCase())&&(p+=1))}this.b=d>0?p/d:0}return this.b}};let I;async function b(p){return I||(I=(async()=>await l(p)||v.$5g())()),I}async function l(p){try{const d=await new Promise((y,k)=>{K(["crypto"],y,k)}).then(Ie),f=(0,A.$Vn)();return d.createHash("sha256").update(f,"utf8").digest("hex")}catch(d){p(d);return}}const m="Software\\Microsoft\\SQMClient";async function u(p){if(O.$j){const d=await new Promise((f,y)=>{K(["@vscode/windows-registry"],f,y)}).then(Ie);try{return d.GetStringRegKey("HKEY_LOCAL_MACHINE",m,"MachineId")||""}catch(f){return p(f),""}}return""}async function $(p){try{return await(await new Promise((y,k)=>{K(["@vscode/deviceid"],y,k)}).then(Ie)).getDeviceId()}catch(d){return p(d),""}}}),define(le[23],ue([0,1,26,27,157,8,32,79,9,3,18,7]),function(K,e,i,r,v,A,O,I,b,l,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=y,e.readdirSync=E,e.whenDeleted=a,e.configureFlushOnWrite=h,e.writeFileSync=w,i=Ie(i);var $;(function(V){V[V.UNLINK=0]="UNLINK",V[V.MOVE=1]="MOVE"})($||(e.RimRafMode=$={}));async function p(V,Y=$.UNLINK,B){if((0,O.$Lg)(V))throw new Error("rimraf - will refuse to recursively delete root");return Y===$.UNLINK?f(V):d(V,B)}async function d(V,Y=(0,O.$Qg)((0,r.tmpdir)())){try{try{await i.promises.rename(V,Y)}catch(B){return B.code==="ENOENT"?void 0:f(V)}f(Y).catch(B=>{})}catch(B){if(B.code!=="ENOENT")throw B}}async function f(V){return i.promises.rm(V,{recursive:!0,force:!0,maxRetries:3})}function y(V){if((0,O.$Lg)(V))throw new Error("rimraf - will refuse to recursively delete root");i.rmSync(V,{recursive:!0,force:!0,maxRetries:3})}async function k(V,Y){return S(await(Y?g(V):i.promises.readdir(V)))}async function g(V){try{return await i.promises.readdir(V,{withFileTypes:!0})}catch(_){console.warn("[node.js fs] readdir with filetypes failed with error: ",_)}const Y=[],B=await k(V);for(const _ of B){let C=!1,W=!1,F=!1;try{const H=await i.promises.lstat((0,b.$mc)(V,_));C=H.isFile(),W=H.isDirectory(),F=H.isSymbolicLink()}catch(H){console.warn("[node.js fs] unexpected error from lstat after readdir: ",H)}Y.push({name:_,isFile:()=>C,isDirectory:()=>W,isSymbolicLink:()=>F})}return Y}function E(V){return S(i.readdirSync(V))}function S(V){return V.map(Y=>typeof Y=="string"?l.$k?(0,I.$qm)(Y):Y:(Y.name=l.$k?(0,I.$qm)(Y.name):Y.name,Y))}async function s(V){const Y=await k(V),B=[];for(const _ of Y)await t.existsDirectory((0,b.$mc)(V,_))&&B.push(_);return B}function a(V,Y=1e3){return new Promise(B=>{let _=!1;const C=setInterval(()=>{_||(_=!0,i.access(V,W=>{_=!1,W&&(clearInterval(C),B(void 0))}))},Y)})}var t;(function(V){async function Y(C){let W;try{if(W=await i.promises.lstat(C),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await i.promises.stat(C),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(F){if(F.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(l.$j&&F.code==="EACCES")try{return{stat:await i.promises.stat(await i.promises.readlink(C)),symbolicLink:{dangling:!1}}}catch(H){if(H.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw H}throw F}}V.stat=Y;async function B(C){try{const{stat:W,symbolicLink:F}=await V.stat(C);return W.isFile()&&F?.dangling!==!0}catch{}return!1}V.existsFile=B;async function _(C){try{const{stat:W,symbolicLink:F}=await V.stat(C);return W.isDirectory()&&F?.dangling!==!0}catch{}return!1}V.existsDirectory=_})(t||(e.SymlinkSupport=t={}));const o=new A.$Rh;function n(V,Y,B){return o.queueFor(u.URI.file(V),()=>{const _=D(B);return new Promise((C,W)=>P(V,Y,_,F=>F?W(F):C()))},m.$ah)}let c=!0;function h(V){c=V}function P(V,Y,B,_){if(!c)return i.writeFile(V,Y,{mode:B.mode,flag:B.flag},_);i.open(V,B.flag,B.mode,(C,W)=>{if(C)return _(C);i.writeFile(W,Y,F=>{if(F)return i.close(W,()=>_(F));i.fdatasync(W,H=>(H&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",H),h(!1)),i.close(W,ne=>_(ne))))})})}function w(V,Y,B){const _=D(B);if(!c)return i.writeFileSync(V,Y,{mode:_.mode,flag:_.flag});const C=i.openSync(V,_.flag,_.mode);try{i.writeFileSync(C,Y);try{i.fdatasyncSync(C)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),h(!1)}}finally{i.closeSync(C)}}function D(V){return V?{mode:typeof V.mode=="number"?V.mode:438,flag:typeof V.flag=="string"?V.flag:"w"}:{mode:438,flag:"w"}}async function L(V,Y,B=6e4){if(V!==Y)try{l.$j&&typeof B=="number"?await R(V,Y,Date.now(),B):await i.promises.rename(V,Y)}catch(_){if(V.toLowerCase()!==Y.toLowerCase()&&_.code==="EXDEV"||V.endsWith("."))await T(V,Y,{preserveSymlinks:!1}),await p(V,$.MOVE);else throw _}}async function R(V,Y,B,_,C=0){try{return await i.promises.rename(V,Y)}catch(W){if(W.code!=="EACCES"&&W.code!=="EPERM"&&W.code!=="EBUSY")throw W;if(Date.now()-B>=_)throw console.error(`[node.js fs] rename failed after ${C} retries with error: ${W}`),W;if(C===0){let F=!1;try{const{stat:H}=await t.stat(Y);H.isFile()||(F=!0)}catch{}if(F)throw W}return await(0,A.$Jh)(Math.min(100,C*10)),R(V,Y,B,_,C+1)}}async function T(V,Y,B){return G(V,Y,{root:{source:V,target:Y},options:B,handledSourcePaths:new Set})}const j=511;async function G(V,Y,B){if(B.handledSourcePaths.has(V))return;B.handledSourcePaths.add(V);const{stat:_,symbolicLink:C}=await t.stat(V);if(C){if(B.options.preserveSymlinks)try{return await de(V,Y,B)}catch{}if(C.dangling)return}return _.isDirectory()?q(V,Y,_.mode&j,B):Q(V,Y,_.mode&j)}async function q(V,Y,B,_){await i.promises.mkdir(Y,{recursive:!0,mode:B});const C=await k(V);for(const W of C)await G((0,b.$mc)(V,W),(0,b.$mc)(Y,W),_)}async function Q(V,Y,B){await i.promises.copyFile(V,Y),await i.promises.chmod(Y,B)}async function de(V,Y,B){let _=await i.promises.readlink(V);(0,O.$Hg)(_,B.root.source,!l.$l)&&(_=(0,b.$mc)(B.root.target,_.substr(B.root.source.length+1))),await i.promises.symlink(_,Y)}e.Promises=new class{get read(){return(V,Y,B,_,C)=>new Promise((W,F)=>{i.read(V,Y,B,_,C,(H,ne,x)=>H?F(H):W({bytesRead:ne,buffer:x}))})}get write(){return(V,Y,B,_,C)=>new Promise((W,F)=>{i.write(V,Y,B,_,C,(H,ne,x)=>H?F(H):W({bytesWritten:ne,buffer:x}))})}get fdatasync(){return(0,v.promisify)(i.fdatasync)}get open(){return(0,v.promisify)(i.open)}get close(){return(0,v.promisify)(i.close)}get realpath(){return(0,v.promisify)(i.realpath)}async exists(V){try{return await i.promises.access(V),!0}catch{return!1}}get readdir(){return k}get readDirsInDir(){return s}get writeFile(){return n}get rm(){return p}get rename(){return L}get copy(){return T}}}),define(le[115],ue([0,1,26,9,3,25,23]),function(K,e,i,r,v,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=I,e.$sr=b,e.$tr=l,e.$ur=m,i=Ie(i);function I($){if(v.$l)return $;const p=(0,r.$pc)($);if($===p)return $;const d=((0,r.$qc)($)||$).toLowerCase();try{const y=(0,O.readdirSync)(p).filter(k=>k.toLowerCase()===d);if(y.length===1){const k=I(p);if(k)return(0,r.$mc)(k,y[0])}else if(y.length>1){const k=y.indexOf(d);if(k>=0){const g=I(p);if(g)return(0,r.$mc)(g,y[k])}}}catch{}return null}async function b($,p){if(v.$l)return $;const d=(0,r.$pc)($);if($===d)return $;const f=((0,r.$qc)($)||$).toLowerCase();try{if(p?.isCancellationRequested)return null;const k=(await O.Promises.readdir(d)).filter(g=>g.toLowerCase()===f);if(k.length===1){const g=await b(d,p);if(g)return(0,r.$mc)(g,k[0])}else if(k.length>1){const g=k.indexOf(f);if(g>=0){const E=await b(d,p);if(E)return(0,r.$mc)(E,k[g])}}}catch{}return null}async function l($){try{return await O.Promises.realpath($)}catch{const d=u($);return await i.promises.access(d,i.constants.R_OK),d}}function m($){try{return i.realpathSync($)}catch{const d=u($);return i.accessSync(d,i.constants.R_OK),d}}function u($){return(0,A.$qf)((0,r.$kc)($),r.sep)}}),define(le[116],ue([0,1,95]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8g=void 0,e.$7g=r,e.$9g=A,i=Ie(i);function r(I,b,l,m=1){let u=!1;return new Promise($=>{const p=setTimeout(()=>{if(!u)return u=!0,$(0)},l);v(I,b,m,d=>{if(!u)return u=!0,clearTimeout(p),$(d)})})}function v(I,b,l,m){if(b===0)return m(0);const u=new i.Socket;u.once("connect",()=>(O(u),v(I+l,b-1,l,m))),u.once("data",()=>{}),u.once("error",$=>(O(u),$.code!=="ECONNREFUSED"?v(I+l,b-1,l,m):m(I))),u.connect(I,"127.0.0.1")}e.$8g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(I,b,l,m="127.0.0.1"){let u=!1,$,p=1;const d=i.createServer({pauseOnConnect:!0});function f(y,k){u||(u=!0,d.removeAllListeners(),d.close(),$&&clearTimeout($),k(y))}return new Promise(y=>{$=setTimeout(()=>{f(0,y)},l),d.on("listening",()=>{f(I,y)}),d.on("error",k=>{k&&(k.code==="EADDRINUSE"||k.code==="EACCES")&&p<b?(I++,p++,d.listen(I,m)):f(0,y)}),d.on("close",()=>{f(0,y)}),d.listen(I,m)})}function O(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(b){console.error(b)}}}),define(le[117],ue([0,1,27,9,23]),function(K,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=g,e.$Am=E,i=Ie(i),r=Ie(r),v=Ie(v);const A=/^\d+$/,O=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var b;(function(S){S[S.x64=0]="x64",S[S.x86=1]="x86",S[S.ARM=2]="ARM"})(b||(b={}));let l;switch(process.arch){case"ia32":l=b.x86;break;case"arm":case"arm64":l=b.ARM;break;default:l=b.x64;break}let m;process.env.PROCESSOR_ARCHITEW6432?m=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?b.ARM:b.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?m=b.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?m=b.x86:m=b.x64;class u{constructor(s,a,t){this.exePath=s,this.displayName=a,this.a=t}async exists(){return this.a===void 0&&(this.a=await v.SymlinkSupport.existsFile(this.exePath)),this.a}}function $({useAlternateBitness:S=!1}={}){return S?l===b.x64?process.env["ProgramFiles(x86)"]||null:m===b.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:S=!1,findPreview:s=!1}={}){const a=$({useAlternateBitness:S});if(!a)return null;const t=r.$mc(a,"PowerShell");if(!await v.SymlinkSupport.existsDirectory(t))return null;let o=-1,n=null;for(const P of await v.Promises.readdir(t)){let w=-1;if(s){const L=P.indexOf("-");if(L<0)continue;const R=P.substring(0,L);if(!A.test(R)||P.substring(L+1)!=="preview")continue;w=parseInt(R,10)}else{if(!A.test(P))continue;w=parseInt(P,10)}if(w<=o)continue;const D=r.$mc(t,P,"pwsh.exe");await v.SymlinkSupport.existsFile(D)&&(n=D,o=w)}if(!n)return null;const c=a.includes("x86")?" (x86)":"",h=s?" Preview":"";return new u(n,`PowerShell${h}${c}`,!0)}async function d({findPreview:S}={}){if(!process.env.LOCALAPPDATA)return null;const s=r.$mc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await v.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:a,pwshMsixName:t}=S?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:O,pwshMsixName:"PowerShell (Store)"};for(const o of await v.Promises.readdir(s))if(a.test(o)){const n=r.$mc(s,o,"pwsh.exe");return new u(n,t)}return null}function f(){const S=r.$mc(i.homedir(),".dotnet","tools","pwsh.exe");return new u(S,".NET Core PowerShell Global Tool")}function y(){const S=r.$mc(process.env.windir,l===b.x86&&m!==b.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new u(S,"Windows PowerShell",!0)}async function*k(){let S=await p();S&&(yield S),S=await p({useAlternateBitness:!0}),S&&(yield S),S=await d(),S&&(yield S),S=f(),S&&(yield S),S=await p({findPreview:!0}),S&&(yield S),S=await d({findPreview:!0}),S&&(yield S),S=await p({useAlternateBitness:!0,findPreview:!0}),S&&(yield S),S=y(),S&&(yield S)}async function*g(){for await(const S of k())await S.exists()&&(yield S)}async function E(){for await(const S of g())return S;return null}}),define(le[96],ue([0,1,26,9,3,37,80,12,23]),function(K,e,i,r,v,A,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$Bm=l,e.$Cm=m,r=Ie(r),v=Ie(v),A=Ie(A),I=Ie(I),b=Ie(b),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return O.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return O.TerminateResponseCode}});function l($=A.env){return $.comspec||"cmd.exe"}function m($){let p=[],d=!1;const f=function(y){if(d){p.push(y);return}(!$.send(y,g=>{if(g&&console.error(g),d=!1,p.length>0){const E=p.slice(0);p=[],E.forEach(S=>f(S))}})||v.$j)&&(d=!0)};return{send:f}}var u;(function($){async function p(d,f,y){if(r.$lc(d))return d;if(f===void 0&&(f=A.cwd()),r.$pc(d)!=="."||(y===void 0&&I.$hg(A.env.PATH)&&(y=A.env.PATH.split(r.$wc)),y===void 0||y.length===0))return r.$mc(f,d);async function g(E){if(await b.Promises.exists(E)){let S;try{S=await i.promises.stat(E)}catch(s){s.message.startsWith("EACCES")&&(S=await i.promises.lstat(E))}return S?!S.isDirectory():!1}return!1}for(const E of y){let S;if(r.$lc(E)?S=r.$mc(E,d):S=r.$mc(f,E,d),await g(S))return S;let s=S+".com";if(await g(s)||(s=S+".exe",await g(s)))return s}return r.$mc(f,d)}$.findExecutable=p})(u||(e.win32=u={}))}),define(le[118],ue([0,1,44,11]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=v;function v(O){return new Promise((I,b)=>{let l;const m=new Map;function u(p,d,f,y,k){const g=m.get(d);if(p===O||g){const E={name:$(f),cmd:f,pid:p,ppid:d,load:y,mem:k};m.set(p,E),p===O&&(l=E),g&&(g.children||(g.children=[]),g.children.push(E),g.children.length>1&&(g.children=g.children.sort((S,s)=>S.pid-s.pid)))}}function $(p){const d=/--utility-sub-type=network/i,f=/--crashes-directory/i,y=/\\pipe\\winpty-control/i,k=/conhost\.exe.+--headless/i,g=/--type=([a-zA-Z-]+)/;if(f.exec(p))return"electron-crash-reporter";if(y.exec(p))return"winpty-agent";if(k.exec(p))return"conpty-agent";let E=g.exec(p);if(E&&E.length===2)return E[1]==="renderer"?"window":E[1]==="utility"?d.exec(p)?"utility-network-service":"utility-process":E[1]==="extensionHost"?"extension-host":E[1];const S=/[a-zA-Z-]+\.js/g;let s="";do E=S.exec(p),E&&(s+=E+" ");while(E);return s&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron-nodejs (${s})`:p}if(process.platform==="win32"){const p=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substring(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substring(5):d;new Promise((d,f)=>{K(["@vscode/windows-process-tree"],d,f)}).then(Ie).then(d=>{d.getProcessList(O,f=>{if(!f){b(new Error(`Root process ${O} not found`));return}d.getProcessCpuUsage(f,y=>{const k=new Map;y.forEach(g=>{const E=p(g.commandLine||"");k.set(g.pid,{name:$(E),cmd:E,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),l=k.get(O),l?(k.forEach(g=>{const E=k.get(g.ppid);E&&(E.children||(E.children=[]),E.children.push(g))}),k.forEach(g=>{g.children&&(g.children=g.children.sort((E,S)=>E.pid-S.pid))}),I(l)):b(new Error(`Root process ${O} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let p=function(){let d=[l];const f=[];for(;d.length;){const k=d.shift();k&&(f.push(k.pid),k.children&&(d=d.concat(k.children)))}let y=JSON.stringify(r.$3g.asFileUri("vs/base/node/cpuUsage.sh").fsPath);y+=" "+f.join(" "),(0,i.exec)(y,{},(k,g,E)=>{if(k||E)b(k||new Error(E.toString()));else{const S=g.toString().split(`
`);for(let s=0;s<f.length;s++){const a=m.get(f[s]);a.load=parseFloat(S[s])}if(!l){b(new Error(`Root process ${O} not found`));return}I(l)}})};(0,i.exec)("which ps",{},(d,f,y)=>{if(d||y)if(process.platform!=="linux")b(d||new Error(y.toString()));else{const k=JSON.stringify(r.$3g.asFileUri("vs/base/node/ps.sh").fsPath);(0,i.exec)(k,{},(g,E,S)=>{g||S?b(g||new Error(S.toString())):(A(E,u),p())})}else{const k=f.toString().trim();(0,i.exec)(`${k} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(E,S,s)=>{E||s&&!s.includes("screen size is bogus")?b(E||new Error(s.toString())):(A(S,u),process.platform==="linux"?p():l?I(l):b(new Error(`Root process ${O} not found`)))})}})}})}function A(O,I){const b=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,l=O.toString().split(`
`);for(const m of l){const u=b.exec(m.trim());u&&u.length===6&&I(parseInt(u[1]),parseInt(u[2]),u[5],parseFloat(u[3]),parseFloat(u[4]))}}}),define(le[119],ue([0,1,27,3,117,96]),function(K,e,i,r,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dm=O,r=Ie(r),A=Ie(A);async function O(u,$){return u===r.OperatingSystem.Windows?r.$j?m():A.$Bm($):b(u,$)}let I=null;function b(u,$){if(r.$l&&u===r.OperatingSystem.Macintosh||r.$k&&u===r.OperatingSystem.Linux)return"/bin/bash";if(!I){let p;if(r.$j)p="/bin/bash";else{if(p=$.SHELL,!p)try{p=(0,i.userInfo)().shell}catch{}p||(p="sh"),p==="/bin/false"&&(p="/bin/bash")}I=p}return I}let l=null;async function m(){return l||(l=(await(0,v.$Am)()).exePath),l}}),function(){function K(){function e(){return process.uncHostAllowlist}function i(b){const l=new Set;if(Array.isArray(b))for(const m of b)typeof m=="string"&&l.add(m);return Array.from(l)}function r(){const b=e();return b?Array.from(b):[]}function v(b){if(process.platform!=="win32")return;const l=e();if(l)if(typeof b=="string")l.add(b.toLowerCase());else for(const m of i(b))v(m)}function A(b){if(typeof b!="string")return;const l=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let m;for(const u of l){if(b.indexOf(u)!==0)continue;const p=b.indexOf("\\",u.length);if(p===-1)continue;const d=b.substring(u.length,p);if(d){m=d;break}}return m}function O(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function I(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:r,addUNCHostToAllowlist:v,getUNCHost:A,disableUNCAccessRestrictions:O,isUNCAccessRestrictionsDisabled:I}}typeof define=="function"?define("vs/base/node/unc",[],function(){return K()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=K():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(le[158],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fY=e.$eY=void 0,e.$eY="vscode:contextmenu",e.$fY="vscode:onCloseContextMenu"});var ke=this&&this.__decorate||function(K,e,i,r){var v=arguments.length,A=v<3?e:r===null?r=Object.getOwnPropertyDescriptor(e,i):r,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(K,e,i,r);else for(var I=K.length-1;I>=0;I--)(O=K[I])&&(A=(v<3?O(A):v>3?O(e,i,A):O(e,i))||A);return v>3&&A&&Object.defineProperty(e,i,A),A};define(le[45],ue([0,1,21,8,17,22,54,15,4,2,83,25,12]),function(K,e,i,r,v,A,O,I,b,l,m,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ri=e.ProxyChannel=e.$qi=e.$ni=e.$mi=e.$li=e.RequestInitiator=e.$ki=e.$hi=e.$gi=void 0,e.$ii=h,e.$ji=P,e.$oi=j,e.$pi=G,u=Ie(u);var p;(function(C){C[C.Promise=100]="Promise",C[C.PromiseCancel=101]="PromiseCancel",C[C.EventListen=102]="EventListen",C[C.EventDispose=103]="EventDispose"})(p||(p={}));function d(C){switch(C){case p.Promise:return"req";case p.PromiseCancel:return"cancel";case p.EventListen:return"subscribe";case p.EventDispose:return"unsubscribe"}}var f;(function(C){C[C.Initialize=200]="Initialize",C[C.PromiseSuccess=201]="PromiseSuccess",C[C.PromiseError=202]="PromiseError",C[C.PromiseErrorObj=203]="PromiseErrorObj",C[C.EventFire=204]="EventFire"})(f||(f={}));function y(C){switch(C){case f.Initialize:return"init";case f.PromiseSuccess:return"reply:";case f.PromiseError:case f.PromiseErrorObj:return"replyErr:";case f.EventFire:return"event:"}}var k;(function(C){C[C.Uninitialized=0]="Uninitialized",C[C.Idle=1]="Idle"})(k||(k={}));function g(C){let W=0;for(let F=0;;F+=7){const H=C.read(1);if(W|=(H.buffer[0]&127)<<F,!(H.buffer[0]&128))return W}}const E=o(0);function S(C,W){if(W===0){C.write(E);return}let F=0;for(let ne=W;ne!==0;ne=ne>>>7)F++;const H=v.$Qe.alloc(F);for(let ne=0;W!==0;ne++)H.buffer[ne]=W&127,W=W>>>7,W>0&&(H.buffer[ne]|=128);C.write(H)}class s{constructor(W){this.b=W,this.a=0}read(W){const F=this.b.slice(this.a,this.a+W);return this.a+=F.byteLength,F}}e.$gi=s;class a{constructor(){this.a=[]}get buffer(){return v.$Qe.concat(this.a)}write(W){this.a.push(W)}}e.$hi=a;var t;(function(C){C[C.Undefined=0]="Undefined",C[C.String=1]="String",C[C.Buffer=2]="Buffer",C[C.VSBuffer=3]="VSBuffer",C[C.Array=4]="Array",C[C.Object=5]="Object",C[C.Int=6]="Int"})(t||(t={}));function o(C){const W=v.$Qe.alloc(1);return W.writeUInt8(C,0),W}const n={Undefined:o(t.Undefined),String:o(t.String),Buffer:o(t.Buffer),VSBuffer:o(t.VSBuffer),Array:o(t.Array),Object:o(t.Object),Uint:o(t.Int)},c=typeof Buffer<"u";function h(C,W){if(typeof W>"u")C.write(n.Undefined);else if(typeof W=="string"){const F=v.$Qe.fromString(W);C.write(n.String),S(C,F.byteLength),C.write(F)}else if(c&&Buffer.isBuffer(W)){const F=v.$Qe.wrap(W);C.write(n.Buffer),S(C,F.byteLength),C.write(F)}else if(W instanceof v.$Qe)C.write(n.VSBuffer),S(C,W.byteLength),C.write(W);else if(Array.isArray(W)){C.write(n.Array),S(C,W.length);for(const F of W)h(C,F)}else if(typeof W=="number"&&(W|0)===W)C.write(n.Uint),S(C,W);else{const F=v.$Qe.fromString(JSON.stringify(W));C.write(n.Object),S(C,F.byteLength),C.write(F)}}function P(C){switch(C.read(1).readUInt8(0)){case t.Undefined:return;case t.String:return C.read(g(C)).toString();case t.Buffer:return C.read(g(C)).buffer;case t.VSBuffer:return C.read(g(C));case t.Array:{const F=g(C),H=[];for(let ne=0;ne<F;ne++)H.push(P(C));return H}case t.Object:return JSON.parse(C.read(g(C)).toString());case t.Int:return g(C)}}class w{constructor(W,F,H=null,ne=1e3){this.h=W,this.j=F,this.k=H,this.l=ne,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(x=>this.q(x)),this.m({type:f.Initialize})}registerChannel(W,F){this.b.set(W,F),setTimeout(()=>this.w(W),0)}m(W){switch(W.type){case f.Initialize:{const F=this.o([W.type]);this.k?.logOutgoing(F,0,D.OtherSide,y(W.type));return}case f.PromiseSuccess:case f.PromiseError:case f.EventFire:case f.PromiseErrorObj:{const F=this.o([W.type,W.id],W.data);this.k?.logOutgoing(F,W.id,D.OtherSide,y(W.type),W.data);return}}}o(W,F=void 0){const H=new a;return h(H,W),h(H,F),this.p(H.buffer)}p(W){try{return this.h.send(W),W.byteLength}catch{return 0}}q(W){const F=new s(W),H=P(F),ne=P(F),x=H[0];switch(x){case p.Promise:return this.k?.logIncoming(W.byteLength,H[1],D.OtherSide,`${d(x)}: ${H[2]}.${H[3]}`,ne),this.s({type:x,id:H[1],channelName:H[2],name:H[3],arg:ne});case p.EventListen:return this.k?.logIncoming(W.byteLength,H[1],D.OtherSide,`${d(x)}: ${H[2]}.${H[3]}`,ne),this.t({type:x,id:H[1],channelName:H[2],name:H[3],arg:ne});case p.PromiseCancel:return this.k?.logIncoming(W.byteLength,H[1],D.OtherSide,`${d(x)}`),this.u({type:x,id:H[1]});case p.EventDispose:return this.k?.logIncoming(W.byteLength,H[1],D.OtherSide,`${d(x)}`),this.u({type:x,id:H[1]})}}s(W){const F=this.b.get(W.channelName);if(!F){this.v(W);return}const H=new A.$ze;let ne;try{ne=F.call(this.j,W.name,W.arg,H.token)}catch(oe){ne=Promise.reject(oe)}const x=W.id;ne.then(oe=>{this.m({id:x,data:oe,type:f.PromiseSuccess})},oe=>{oe instanceof Error?this.m({id:x,data:{message:oe.message,name:oe.name,stack:oe.stack?oe.stack.split(`
`):void 0},type:f.PromiseError}):this.m({id:x,data:oe,type:f.PromiseErrorObj})}).finally(()=>{ce.dispose(),this.d.delete(W.id)});const ce=(0,l.$Vc)(()=>H.cancel());this.d.set(W.id,ce)}t(W){const F=this.b.get(W.channelName);if(!F){this.v(W);return}const H=W.id,x=F.listen(this.j,W.name,W.arg)(ce=>this.m({id:H,data:ce,type:f.EventFire}));this.d.set(W.id,x)}u(W){const F=this.d.get(W.id);F&&(F.dispose(),this.d.delete(W.id))}v(W){let F=this.g.get(W.channelName);F||(F=[],this.g.set(W.channelName,F));const H=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===p.Promise&&this.m({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.l}ms`,stack:void 0},type:f.PromiseError})},this.l);F.push({request:W,timeoutTimer:H})}w(W){const F=this.g.get(W);if(F){for(const H of F)switch(clearTimeout(H.timeoutTimer),H.request.type){case p.Promise:this.s(H.request);break;case p.EventListen:this.t(H.request);break}this.g.delete(W)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,l.$Sc)(this.d.values()),this.d.clear()}}e.$ki=w;var D;(function(C){C[C.LocalSide=0]="LocalSide",C[C.OtherSide=1]="OtherSide"})(D||(e.RequestInitiator=D={}));class L{constructor(W,F=null){this.l=W,this.a=!1,this.b=k.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new b.$oe,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(H=>this.s(H)),this.j=F}getChannel(W){const F=this;return{call(H,ne,x){return F.a?Promise.reject(new I.$7):F.m(W,H,ne,x)},listen(H,ne){return F.a?b.Event.None:F.o(W,H,ne)}}}m(W,F,H,ne=A.CancellationToken.None){const x=this.g++,ce=p.Promise,oe={id:x,type:ce,channelName:W,name:F,arg:H};if(ne.isCancellationRequested)return Promise.reject(new I.$7);let J;return new Promise((Z,U)=>{if(ne.isCancellationRequested)return U(new I.$7);const N=()=>{const te=ae=>{switch(ae.type){case f.PromiseSuccess:this.f.delete(x),Z(ae.data);break;case f.PromiseError:{this.f.delete(x);const me=new Error(ae.data.message);me.stack=Array.isArray(ae.data.stack)?ae.data.stack.join(`
`):ae.data.stack,me.name=ae.data.name,U(me);break}case f.PromiseErrorObj:this.f.delete(x),U(ae.data);break}};this.f.set(x,te),this.p(oe)};let ie=null;this.b===k.Idle?N():(ie=(0,r.$vh)(te=>this.u()),ie.then(()=>{ie=null,N()}));const X=()=>{ie?(ie.cancel(),ie=null):this.p({id:x,type:p.PromiseCancel}),U(new I.$7)},z=ne.onCancellationRequested(X);J=(0,l.$Uc)((0,l.$Vc)(X),z),this.d.add(J)}).finally(()=>{J.dispose(),this.d.delete(J)})}o(W,F,H){const ne=this.g++,x=p.EventListen,ce={id:ne,type:x,channelName:W,name:F,arg:H};let oe=null;const J=new b.$oe({onWillAddFirstListener:()=>{oe=(0,r.$vh)(Z=>this.u()),oe.then(()=>{oe=null,this.d.add(J),this.p(ce)})},onDidRemoveLastListener:()=>{oe?(oe.cancel(),oe=null):(this.d.delete(J),this.p({id:ne,type:p.EventDispose}))}}),M=Z=>J.fire(Z.data);return this.f.set(ne,M),J.event}p(W){switch(W.type){case p.Promise:case p.EventListen:{const F=this.q([W.type,W.id,W.channelName,W.name],W.arg);this.j?.logOutgoing(F,W.id,D.LocalSide,`${d(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case p.PromiseCancel:case p.EventDispose:{const F=this.q([W.type,W.id]);this.j?.logOutgoing(F,W.id,D.LocalSide,d(W.type));return}}}q(W,F=void 0){const H=new a;return h(H,W),h(H,F),this.r(H.buffer)}r(W){try{return this.l.send(W),W.byteLength}catch{return 0}}s(W){const F=new s(W),H=P(F),ne=P(F),x=H[0];switch(x){case f.Initialize:return this.j?.logIncoming(W.byteLength,0,D.LocalSide,y(x)),this.t({type:H[0]});case f.PromiseSuccess:case f.PromiseError:case f.EventFire:case f.PromiseErrorObj:return this.j?.logIncoming(W.byteLength,H[1],D.LocalSide,y(x),ne),this.t({type:H[0],id:H[1],data:ne})}}t(W){if(W.type===f.Initialize){this.b=k.Idle,this.k.fire();return}this.f.get(W.id)?.(W)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}u(){return this.b===k.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,l.$Sc)(this.d.values()),this.d.clear()}}e.$li=L,ke([O.$ai],L.prototype,"onDidInitializePromise",null);class R{get connections(){const W=[];return this.f.forEach(F=>W.push(F)),W}constructor(W,F,H){this.a=new Map,this.f=new Set,this.g=new b.$oe,this.onDidAddConnection=this.g.event,this.h=new b.$oe,this.onDidRemoveConnection=this.h.event,this.j=new l.$Wc,this.j.add(W(({protocol:ne,onDidClientDisconnect:x})=>{const ce=b.Event.once(ne.onMessage);this.j.add(ce(oe=>{const J=new s(oe),M=P(J),Z=new w(ne,M,F,H),U=new L(ne,F);this.a.forEach((ie,X)=>Z.registerChannel(X,ie));const N={channelServer:Z,channelClient:U,ctx:M};this.f.add(N),this.g.fire(N),this.j.add(x(()=>{Z.dispose(),U.dispose(),this.f.delete(N),this.h.fire(N)}))}))}))}getChannel(W,F){const H=this;return{call(ne,x,ce){let oe;if((0,$.$vg)(F)){const M=(0,i.$5b)(H.connections.filter(F));oe=M?Promise.resolve(M):b.Event.toPromise(b.Event.filter(H.onDidAddConnection,F))}else oe=F.routeCall(H,ne,x);const J=oe.then(M=>M.channelClient.getChannel(W));return j(J).call(ne,x,ce)},listen(ne,x){if((0,$.$vg)(F))return H.k(W,F,ne,x);const ce=F.routeEvent(H,ne,x).then(oe=>oe.channelClient.getChannel(W));return j(ce).listen(ne,x)}}}k(W,F,H,ne){const x=this;let ce;const oe=new b.$oe({onWillAddFirstListener:()=>{ce=new l.$Wc;const J=new b.$ue,M=new Map,Z=N=>{const X=N.channelClient.getChannel(W).listen(H,ne),z=J.add(X);M.set(N,z)},U=N=>{const ie=M.get(N);ie&&(ie.dispose(),M.delete(N))};x.connections.filter(F).forEach(Z),b.Event.filter(x.onDidAddConnection,F)(Z,void 0,ce),x.onDidRemoveConnection(U,void 0,ce),J.event(oe.fire,oe,ce),ce.add(J)},onDidRemoveLastListener:()=>{ce?.dispose(),ce=void 0}});return oe.event}registerChannel(W,F){this.a.set(W,F);for(const H of this.f)H.channelServer.registerChannel(W,F)}dispose(){this.j.dispose();for(const W of this.f)W.channelClient.dispose(),W.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$mi=R;class T{constructor(W,F,H=null){const ne=new a;h(ne,F),W.send(ne.buffer),this.a=new L(W,H),this.d=new w(W,F,H)}getChannel(W){return this.a.getChannel(W)}registerChannel(W,F){this.d.registerChannel(W,F)}dispose(){this.a.dispose(),this.d.dispose()}}e.$ni=T;function j(C){return{call(W,F,H){return C.then(ne=>ne.call(W,F,H))},listen(W,F){const H=new b.$xe;return C.then(ne=>H.input=ne.listen(W,F)),H.event}}}function G(C){let W=!1;return{call(F,H,ne){return W?C.call(F,H,ne):(0,r.$Jh)(0).then(()=>W=!0).then(()=>C.call(F,H,ne))},listen(F,H){if(W)return C.listen(F,H);const ne=new b.$xe;return(0,r.$Jh)(0).then(()=>W=!0).then(()=>ne.input=C.listen(F,H)),ne.event}}}class q{constructor(W){this.a=W}routeCall(W){return this.b(W)}routeEvent(W){return this.b(W)}async b(W){for(const F of W.connections)if(await Promise.resolve(this.a(F.ctx)))return Promise.resolve(F);return await b.Event.toPromise(W.onDidAddConnection),await this.b(W)}}e.$qi=q;var Q;(function(C){function W(x,ce,oe){const J=x,M=oe&&oe.disableMarshalling,Z=new Map;for(const U in J)H(U)&&Z.set(U,b.Event.buffer(J[U],!0,void 0,ce));return new class{listen(U,N,ie){const X=Z.get(N);if(X)return X;const z=J[N];if(typeof z=="function"){if(ne(N))return z.call(J,ie);if(H(N))return Z.set(N,b.Event.buffer(J[N],!0,void 0,ce)),Z.get(N)}throw new I.$db(`Event not found: ${N}`)}call(U,N,ie){const X=J[N];if(typeof X=="function"){if(!M&&Array.isArray(ie))for(let te=0;te<ie.length;te++)ie[te]=(0,m.$fi)(ie[te]);let z=X.apply(J,ie);return z instanceof Promise||(z=Promise.resolve(z)),z}throw new I.$db(`Method not found: ${N}`)}}}C.fromService=W;function F(x,ce){const oe=ce&&ce.disableMarshalling;return new Proxy({},{get(J,M){if(typeof M=="string")return ce?.properties?.has(M)?ce.properties.get(M):ne(M)?function(Z){return x.listen(M,Z)}:H(M)?x.listen(M):async function(...Z){let U;ce&&!(0,$.$qg)(ce.context)?U=[ce.context,...Z]:U=Z;const N=await x.call(M,U);return oe?N:(0,m.$fi)(N)};throw new I.$db(`Property not found: ${String(M)}`)}})}C.toService=F;function H(x){return x[0]==="o"&&x[1]==="n"&&u.$Hf(x.charCodeAt(2))}function ne(x){return/^onDynamic/.test(x)&&u.$Hf(x.charCodeAt(9))}})(Q||(e.ProxyChannel=Q={}));const de=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function V(C){if(Array.isArray(C))return C;if(C&&typeof C=="object"&&typeof C.toString=="function"){const W=C.toString();if(W!=="[object Object]")return W}return C}function Y(C){return Array.isArray(C)?C.map(V):V(C)}function B(C,W,F,H,ne,x,ce){ce=Y(ce);const oe=de[ne],J=oe[H%oe.length];let M=[`%c[${C}]%c[${String(W).padStart(7," ")}]%c[len: ${String(F).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${x}`,"color: darkgreen","color: grey","color: grey",`color: ${J}`];/\($/.test(x)?(M=M.concat(ce),M.push(")")):M.push(ce),console.log.apply(console,M)}class _{constructor(W,F){this.d=W,this.f=F,this.a=0,this.b=0}logOutgoing(W,F,H,ne,x){this.b+=W,B(this.d,this.b,W,F,H,ne,x)}logIncoming(W,F,H,ne,x){this.a+=W,B(this.f,this.a,W,F,H,ne,x)}}e.$ri=_}),define(le[159],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mY=void 0;class i{constructor(v,A){this.a=v,this.onMessage=A}send(v){try{this.a.send("vscode:message",v.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$mY=i}),define(le[160],ue([0,1,17,4,45]),function(K,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kY=e.$jY=void 0;class A{constructor(b){this.a=b,this.onMessage=r.Event.fromDOMEventEmitter(this.a,"message",l=>l.data?i.$Qe.wrap(l.data):i.$Qe.alloc(0)),b.start()}send(b){this.a.postMessage(b.buffer)}disconnect(){this.a.close()}}e.$jY=A;class O extends v.$ni{constructor(b,l){const m=new A(b);super(m,l),this.b=m}dispose(){this.b.disconnect(),super.dispose()}}e.$kY=O}),define(le[120],ue([0,1,17,4,2,45]),function(K,e,i,r,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=e.$vi=e.$ui=e.$ti=e.ProtocolConstants=e.$si=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var O;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(O||(e.SocketDiagnosticsEventType=O={}));var I;(function(n){n.enableDiagnostics=!1,n.records=[];const c=new WeakMap;let h=0;function P(D,L){if(!c.has(D)){const R=String(++h);c.set(D,R)}return c.get(D)}function w(D,L,R,T){if(!n.enableDiagnostics)return;const j=P(D,L);if(T instanceof i.$Qe||T instanceof Uint8Array||T instanceof ArrayBuffer||ArrayBuffer.isView(T)){const G=i.$Qe.alloc(T.byteLength);G.set(T),n.records.push({timestamp:Date.now(),id:j,label:L,type:R,buff:G})}else n.records.push({timestamp:Date.now(),id:j,label:L,type:R,data:T})}n.traceSocketEvent=w})(I||(e.SocketDiagnostics=I={}));var b;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b||(e.SocketCloseEventType=b={}));let l=null;function m(){return l||(l=i.$Qe.alloc(0)),l}class u{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(c){this.a.push(c),this.b+=c.byteLength}read(c){return this.c(c,!0)}peek(c){return this.c(c,!1)}c(c,h){if(c===0)return m();if(c>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===c){const L=this.a[0];return h&&(this.a.shift(),this.b-=c),L}if(this.a[0].byteLength>c){const L=this.a[0].slice(0,c);return h&&(this.a[0]=this.a[0].slice(c),this.b-=c),L}const P=i.$Qe.alloc(c);let w=0,D=0;for(;c>0;){const L=this.a[D];if(L.byteLength>c){const R=L.slice(0,c);P.set(R,w),w+=c,h&&(this.a[D]=L.slice(c),this.b-=c),c-=c}else P.set(L,w),w+=L.byteLength,h?(this.a.shift(),this.b-=L.byteLength):D++,c-=L.byteLength}return P}}e.$si=u;var $;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume",n[n.KeepAlive=9]="KeepAlive"})($||($={}));function p(n){switch(n){case $.None:return"None";case $.Regular:return"Regular";case $.Control:return"Control";case $.Ack:return"Ack";case $.Disconnect:return"Disconnect";case $.ReplayRequest:return"ReplayRequest";case $.Pause:return"PauseWriting";case $.Resume:return"ResumeWriting";case $.KeepAlive:return"KeepAlive"}}var d;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",n[n.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(d||(e.ProtocolConstants=d={}));class f{constructor(c,h,P,w){this.type=c,this.id=h,this.ack=P,this.data=w,this.writtenTime=0}get size(){return this.data.byteLength}}class y extends v.$Xc{constructor(c){super(),this.f=this.B(new r.$oe),this.onMessage=this.f.event,this.g={readHead:!0,readLen:d.HeaderLength,messageType:$.None,id:0,ack:0},this.a=c,this.b=!1,this.c=new u,this.B(this.a.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(c){if(!(!c||c.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(c);this.c.byteLength>=this.g.readLen;){const h=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=h.readUInt32BE(9),this.g.messageType=h.readUInt8(0),this.g.id=h.readUInt32BE(1),this.g.ack=h.readUInt32BE(5),this.a.traceSocketEvent(O.ProtocolHeaderRead,{messageType:p(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const P=this.g.messageType,w=this.g.id,D=this.g.ack;if(this.g.readHead=!0,this.g.readLen=d.HeaderLength,this.g.messageType=$.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(O.ProtocolMessageRead,h),this.f.fire(new f(P,w,D,h)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class k{constructor(c){this.k=null,this.a=!1,this.b=!1,this.c=c,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(c){if(this.a)return;c.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=i.$Qe.alloc(d.HeaderLength);h.writeUInt8(c.type,0),h.writeUInt32BE(c.id,1),h.writeUInt32BE(c.ack,5),h.writeUInt32BE(c.data.byteLength,9),this.c.traceSocketEvent(O.ProtocolHeaderWrite,{messageType:p(c.type),id:c.id,ack:c.ack,messageSize:c.data.byteLength}),this.c.traceSocketEvent(O.ProtocolMessageWrite,c.data),this.j(h,c.data)}g(c,h){const P=this.f===0;return this.d.push(c,h),this.f+=c.byteLength+h.byteLength,P}h(){const c=i.$Qe.concat(this.d,this.f);return this.d.length=0,this.f=0,c}j(c,h){this.g(c,h)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const c=this.h();this.c.traceSocketEvent(O.ProtocolWrite,{byteLength:c.byteLength}),this.c.write(c)}}class g extends v.$Xc{constructor(c){super(),this.f=new r.$oe,this.onMessage=this.f.event,this.g=new r.$oe,this.onDidDispose=this.g.event,this.a=c,this.b=this.B(new k(this.a)),this.c=this.B(new y(this.a)),this.B(this.c.onMessage(h=>{h.type===$.Regular&&this.f.fire(h.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(c){this.b.write(new f($.Regular,0,0,c))}}e.$ti=g;class E extends A.$ni{static fromSocket(c,h){return new E(new g(c),h)}get onDidDispose(){return this.b.onDidDispose}constructor(c,h,P=null){super(c,h,P),this.b=c}dispose(){super.dispose();const c=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),c.end()}}e.$ui=E;class S{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new r.$oe({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(c){this.b?this.d.length>0?this.d.push(c):this.a.fire(c):this.d.push(c)}flushBuffer(){this.d=[]}}e.$vi=S;class s{constructor(c){this.data=c,this.next=null}}class a{constructor(){this.a=null,this.b=null}length(){let c=0,h=this.a;for(;h;)h=h.next,c++;return c}peek(){return this.a?this.a.data:null}toArray(){const c=[];let h=0,P=this.a;for(;P;)c[h++]=P.data,P=P.next;return c}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(c){const h=new s(c);if(!this.a){this.a=h,this.b=h;return}this.b.next=h,this.b=h}}class t{static{this.a=10}static{this.b=null}static getInstance(){return t.b||(t.b=new t),t.b}constructor(){this.c=[];const c=Date.now();for(let h=0;h<t.a;h++)this.c[h]=c-1e3*h;setInterval(()=>{for(let h=t.a;h>=1;h--)this.c[h]=this.c[h-1];this.c[0]=Date.now()},1e3)}d(){const c=Date.now(),h=(1+t.a)*1e3;let P=0;for(let w=0;w<t.a;w++)c-this.c[w]<=h&&P++;return 1-P/t.a}hasHighLoad(){return this.d()>=.5}}class o{get unacknowledgedCount(){return this.d-this.f}constructor(c){this.v=new S,this.onControlMessage=this.v.event,this.w=new S,this.onMessage=this.w.event,this.x=new S,this.onDidDispose=this.x.event,this.y=new S,this.onSocketClose=this.y.event,this.z=new S,this.onSocketTimeout=this.z.event,this.t=c.loadEstimator??t.getInstance(),this.u=c.sendKeepAlive??!0,this.a=!1,this.c=new a,this.d=0,this.f=0,this.g=null,this.h=0,this.j=0,this.k=0,this.l=null,this.n=0,this.o=Date.now(),this.s=new v.$Wc,this.p=c.socket,this.q=this.s.add(new k(this.p)),this.r=this.s.add(new y(this.p)),this.s.add(this.r.onMessage(h=>this.A(h))),this.s.add(this.p.onClose(h=>this.y.fire(h))),c.initialChunk&&this.r.acceptChunk(c.initialChunk),this.u?this.m=setInterval(()=>{this.E()},d.KeepAliveSendTime):this.m=null}dispose(){this.g&&(clearTimeout(this.g),this.g=null),this.l&&(clearTimeout(this.l),this.l=null),this.m&&(clearInterval(this.m),this.m=null),this.s.dispose()}drain(){return this.q.drain()}sendDisconnect(){if(!this.b){this.b=!0;const c=new f($.Disconnect,0,0,m());this.q.write(c),this.q.flush()}}sendPause(){const c=new f($.Pause,0,0,m());this.q.write(c)}sendResume(){const c=new f($.Resume,0,0,m());this.q.write(c)}pauseSocketWriting(){this.q.pause()}getSocket(){return this.p}getMillisSinceLastIncomingData(){return Date.now()-this.r.lastReadTime}beginAcceptReconnection(c,h){this.a=!0,this.s.dispose(),this.s=new v.$Wc,this.v.flushBuffer(),this.y.flushBuffer(),this.z.flushBuffer(),this.p.dispose(),this.n=0,this.o=Date.now(),this.p=c,this.q=this.s.add(new k(this.p)),this.r=this.s.add(new y(this.p)),this.s.add(this.r.onMessage(P=>this.A(P))),this.s.add(this.p.onClose(P=>this.y.fire(P))),this.r.acceptChunk(h)}endAcceptReconnection(){this.a=!1,this.j=this.h;const c=new f($.Ack,0,this.j,m());this.q.write(c);const h=this.c.toArray();for(let P=0,w=h.length;P<w;P++)this.q.write(h[P]);this.C()}acceptDisconnect(){this.x.fire()}A(c){if(c.ack>this.f){this.f=c.ack;do{const h=this.c.peek();if(h&&h.id<=c.ack)this.c.pop();else break}while(!0)}switch(c.type){case $.None:break;case $.Regular:{if(c.id>this.h)if(c.id!==this.h+1){const h=Date.now();h-this.n>1e4&&(this.n=h,this.q.write(new f($.ReplayRequest,0,0,m())))}else this.h=c.id,this.k=Date.now(),this.B(),this.w.fire(c.data);break}case $.Control:{this.v.fire(c.data);break}case $.Ack:break;case $.Disconnect:{this.x.fire();break}case $.ReplayRequest:{const h=this.c.toArray();for(let P=0,w=h.length;P<w;P++)this.q.write(h[P]);this.C();break}case $.Pause:{this.q.pause();break}case $.Resume:{this.q.resume();break}case $.KeepAlive:break}}readEntireBuffer(){return this.r.readEntireBuffer()}flush(){this.q.flush()}send(c){const h=++this.d;this.j=this.h;const P=new f($.Regular,h,this.j,c);this.c.push(P),this.a||(this.q.write(P),this.C())}sendControl(c){const h=new f($.Control,0,0,c);this.q.write(h)}B(){if(this.h<=this.j||this.l)return;const c=Date.now()-this.k;if(c>=d.AcknowledgeTime){this.D();return}this.l=setTimeout(()=>{this.l=null,this.B()},d.AcknowledgeTime-c+5)}C(){if(this.d<=this.f||this.g||this.a)return;const c=this.c.peek(),h=Date.now()-c.writtenTime,P=Date.now()-this.r.lastReadTime,w=Date.now()-this.o;if(h>=d.TimeoutTime&&P>=d.TimeoutTime&&w>=d.TimeoutTime&&!this.t.hasHighLoad()){this.o=Date.now(),this.z.fire({unacknowledgedMsgCount:this.c.length(),timeSinceOldestUnacknowledgedMsg:h,timeSinceLastReceivedSomeData:P});return}const D=Math.max(d.TimeoutTime-h,d.TimeoutTime-P,d.TimeoutTime-w,500);this.g=setTimeout(()=>{this.g=null,this.C()},D)}D(){if(this.h<=this.j)return;this.j=this.h;const c=new f($.Ack,0,this.j,m());this.q.write(c)}E(){this.j=this.h;const c=new f($.KeepAlive,0,this.j,m());this.q.write(c)}}e.$wi=o});var xe=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[35],ue([0,1,13,15,11]),function(K,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gY=void 0,i=xe(i);class A{constructor(){this.a=new WeakMap}on(I,b){const l=(m,...u)=>{this.b(I,m)&&b(m,...u)};return this.a.set(b,l),i.default.ipcMain.on(I,l),this}once(I,b){return i.default.ipcMain.once(I,(l,...m)=>{this.b(I,l)&&b(l,...m)}),this}handle(I,b){return i.default.ipcMain.handle(I,(l,...m)=>this.b(I,l)?b(l,...m):Promise.reject(`Invalid channel '${I}' or sender for ipcMain.handle() usage.`)),this}removeHandler(I){return i.default.ipcMain.removeHandler(I),this}removeListener(I,b){const l=this.a.get(b);return l&&(i.default.ipcMain.removeListener(I,l),this.a.delete(b)),this}b(I,b){if(!I||!I.startsWith("vscode:"))return(0,r.$2)(`Refused to handle ipcMain event for channel '${I}' because the channel is unknown.`),!1;const l=b.senderFrame,m=l.url;if(!m||m==="about:blank")return!0;let u="unknown";try{u=new URL(m).host}catch{return(0,r.$2)(`Refused to handle ipcMain event for channel '${I}' because of a malformed URL '${m}'.`),!1}return u!==v.$2g?((0,r.$2)(`Refused to handle ipcMain event for channel '${I}' because of a bad origin of '${u}'.`),!1):l.parent!==null?((0,r.$2)(`Refused to handle ipcMain event for channel '${I}' because sender of origin '${u}' is not a main frame.`),!1):!0}}e.$gY=new A}),define(le[161],ue([0,1,13,35,158]),function(K,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hY=A;function A(){r.$gY.on(v.$eY,(I,b,l,m,u)=>{const $=O(I,m,l);$.popup({x:u?u.x:void 0,y:u?u.y:void 0,positioningItem:u?u.positioningItem:void 0,callback:()=>{$&&I.sender.send(v.$fY,b)}})})}function O(I,b,l){const m=new i.Menu;return l.forEach(u=>{let $;u.type==="separator"?$=new i.MenuItem({type:u.type}):Array.isArray(u.submenu)?$=new i.MenuItem({submenu:O(I,b,u.submenu),label:u.label}):$=new i.MenuItem({label:u.label,type:u.type,accelerator:u.accelerator,checked:u.checked,enabled:u.enabled,visible:u.visible,click:(p,d,f)=>I.sender.send(b,u.id,f)}),m.append($)}),m}}),define(le[162],ue([0,1,35,17,4,2,45,159]),function(K,e,i,r,v,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nY=void 0;function b(m,u){const $=v.Event.fromNodeEventEmitter(i.$gY,u,(d,f)=>({event:d,message:f})),p=v.Event.filter($,({event:d})=>d.sender.id===m);return v.Event.map(p,({message:d})=>d&&r.$Qe.wrap(d))}class l extends O.$mi{static{this.b=new Map}static d(){const u=v.Event.fromNodeEventEmitter(i.$gY,"vscode:hello",({sender:$})=>$);return v.Event.map(u,$=>{const p=$.id;l.b.get(p)?.dispose();const f=new v.$oe;l.b.set(p,(0,A.$Vc)(()=>f.fire()));const y=b(p,"vscode:message"),k=v.Event.any(v.Event.signal(b(p,"vscode:disconnect")),f.event);return{protocol:new I.$mY($,y),onDidClientDisconnect:k}})}constructor(){super(l.d())}}e.$nY=l}),define(le[121],ue([0,1,35,4,33,160]),function(K,e,i,r,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oY=void 0,e.$pY=I;class O extends A.$kY{constructor(l,m){super({addEventListener:(u,$)=>l.addListener(u,$),removeEventListener:(u,$)=>l.removeListener(u,$),postMessage:u=>l.postMessage(u),start:()=>l.start(),close:()=>l.close()},m)}}e.$oY=O;async function I(b){if(b.isDestroyed()||b.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const l=(0,v.$5g)();b.webContents.send("vscode:createMessageChannel",l);const m=r.Event.fromNodeEventEmitter(i.$gY,"vscode:createMessageChannelResult",($,p)=>({nonce:p,port:$.ports[0]})),{port:u}=await r.Event.toPromise(r.Event.once(r.Event.filter(m,$=>$.nonce===l)));return u}}),define(le[163],ue([0,1,44,8,17,22,152,15,4,2,38,96,80,45]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=e.$nr=void 0,I=Ie(I);class d extends p.$ki{constructor(k){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:b.Event.fromNodeEventEmitter(process,"message",g=>v.$Qe.wrap(Buffer.from(g,"base64")))},k),process.once("disconnect",()=>this.dispose())}}e.$nr=d;class f{constructor(k,g){this.i=k,this.j=g,this.c=new Set,this.g=new Map,this.h=new b.$oe,this.onDidProcessExit=this.h.event;const E=g&&g.timeout?g.timeout:6e4;this.b=new r.$Fh(E),this.d=null,this.f=null}getChannel(k){const g=this;return{call(E,S,s){return g.k(k,E,S,s)},listen(E,S){return g.l(k,E,S)}}}k(k,g,E,S=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(S.isCancellationRequested)return Promise.reject(I.$8());this.b.cancel();const s=this.n(k),a=(0,r.$vh)(n=>s.call(g,E,n)),t=S.onCancellationRequested(()=>a.cancel()),o=(0,l.$Vc)(()=>a.cancel());return this.c.add(o),a.finally(()=>{t.dispose(),this.c.delete(o),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),a}l(k,g,E){if(!this.b)return b.Event.None;this.b.cancel();let S;const s=new b.$oe({onWillAddFirstListener:()=>{S=this.n(k).listen(g,E)(s.fire,s),this.c.add(S)},onDidRemoveLastListener:()=>{this.c.delete(S),S.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return s.event}get m(){if(!this.f){const k=this.j&&this.j.args?this.j.args:[],g=Object.create(null);g.env={...(0,m.$io)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(g.env={...g.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(g.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(h=>!/^--inspect(-brk)?=/.test(h)).filter(h=>!h.startsWith("--vscode-"))),(0,$.$pm)(g.env),this.d=(0,i.fork)(this.i,k,g);const E=new b.$oe,s=b.Event.fromNodeEventEmitter(this.d,"message",h=>h)(h=>{if((0,O.$jr)(h)){(0,O.log)(h,`IPC Library: ${this.j.serverName}`);return}E.fire(v.$Qe.wrap(Buffer.from(h,"base64")))}),a=this.j.useQueue?(0,u.$Cm)(this.d):this.d,t=h=>this.d&&this.d.connected&&a.send(h.buffer.toString("base64")),o=E.event,n={send:t,onMessage:o};this.f=new p.$li(n);const c=()=>this.o();process.once("exit",c),this.d.on("error",h=>console.warn('IPC "'+this.j.serverName+'" errored with '+h)),this.d.on("exit",(h,P)=>{process.removeListener("exit",c),s.dispose(),this.c.forEach(w=>(0,l.$Sc)(w)),this.c.clear(),h!==0&&P!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+h+" and signal "+P),this.b?.cancel(),this.o(),this.h.fire({code:h,signal:P})})}return this.f}n(k){let g=this.g.get(k);return g||(g=this.m.getChannel(k),this.g.set(k,g)),g}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$or=f}),define(le[122],ue([0,1,8,4,2,83,12]),function(K,e,i,r,v,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$iq=e.StorageState=e.StorageHint=void 0,e.$hq=b;var I;(function($){$[$.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",$[$.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(e.StorageHint=I={}));function b($){const p=$;return p?.changed instanceof Map||p?.deleted instanceof Set}var l;(function($){$[$.None=0]="None",$[$.Initialized=1]="Initialized",$[$.Closed=2]="Closed"})(l||(e.StorageState=l={}));class m extends v.$Xc{static{this.a=100}constructor(p,d=Object.create(null)){super(),this.r=p,this.s=d,this.b=this.B(new r.$re),this.onDidChangeStorage=this.b.event,this.c=l.None,this.f=new Map,this.g=this.B(new i.$Gh(m.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(p=>this.u(p)))}u(p){this.b.pause();try{p.changed?.forEach((d,f)=>this.w(f,d)),p.deleted?.forEach(d=>this.w(d,void 0))}finally{this.b.resume()}}w(p,d){if(this.c===l.Closed)return;let f=!1;(0,O.$qg)(d)?f=this.f.delete(p):this.f.get(p)!==d&&(this.f.set(p,d),f=!0),f&&this.b.fire({key:p,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===l.None&&(this.c=l.Initialized,this.s.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(p,d){const f=this.f.get(p);return(0,O.$qg)(f)?d:f}getBoolean(p,d){const f=this.get(p);return(0,O.$qg)(f)?d:f==="true"}getNumber(p,d){const f=this.get(p);return(0,O.$qg)(f)?d:parseInt(f,10)}getObject(p,d){const f=this.get(p);return(0,O.$qg)(f)?d:(0,A.$ei)(f)}async set(p,d,f=!1){if(this.c===l.Closed)return;if((0,O.$qg)(d))return this.delete(p,f);const y=(0,O.$jg)(d)||Array.isArray(d)?(0,A.$di)(d):String(d);if(this.f.get(p)!==y)return this.f.set(p,y),this.j.set(p,y),this.h.delete(p),this.b.fire({key:p,external:f}),this.D()}async delete(p,d=!1){if(!(this.c===l.Closed||!this.f.delete(p)))return this.h.has(p)||this.h.add(p),this.j.delete(p),this.b.fire({key:p,external:d}),this.D()}async optimize(){if(this.c!==l.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=l.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const p={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(p).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(p){if(!(this.c===l.Closed||this.m))return this.D(p)}async D(p){return this.s.hint===I.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),p)}async whenFlushed(){if(this.z)return new Promise(p=>this.n.push(p))}isInMemory(){return this.s.hint===I.STORAGE_IN_MEMORY}}e.$iq=m;class u{constructor(){this.onDidChangeItemsExternal=r.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(p){p.insert?.forEach((d,f)=>this.a.set(f,d)),p.delete?.forEach(d=>this.a.delete(d))}async optimize(){}async close(){}}e.$jq=u}),define(le[164],ue([0,1,26,8,4,31,9,23]),function(K,e,i,r,v,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LY=void 0,i=Ie(i);class b{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return v.Event.None}static{this.a=2e3}static{this.b=256}constructor(u,$=Object.create(null)){this.g=u,this.h=$,this.c=(0,O.$qc)(this.g),this.d=new l(this.h.logging),this.f=this.n(this.g)}async getItems(){const u=await this.f,$=new Map;return(await this.s(u,"SELECT * FROM ItemTable")).forEach(d=>$.set(d.key,d.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${$.size} rows`),$}async updateItems(u){const $=await this.f;return this.j($,u)}j(u,$){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${$.insert?(0,A.$Bc)($.insert):"0"}), delete(${$.delete?(0,A.$Cc)($.delete):"0"})`),this.t(u,()=>{const p=$.insert,d=$.delete;if(p&&p.size>0){const f=[];f.push([]);let y=0;p.forEach((k,g)=>{let E=f[y];E.length>b.b&&(y++,E=[],f.push(E)),E.push(g,k)}),f.forEach(k=>{this.u(u,`INSERT INTO ItemTable VALUES ${new Array(k.length/2).fill("(?,?)").join(",")}`,g=>g.run(k),()=>{const g=[];let E=0;return p.forEach((S,s)=>{g.push(s),E+=S.length}),`Keys: ${g.join(", ")} Length: ${E}`})})}if(d&&d.size){const f=[];f.push([]);let y=0;d.forEach(k=>{let g=f[y];g.length>b.b&&(y++,g=[],f.push(g)),g.push(k)}),f.forEach(k=>{this.u(u,`DELETE FROM ItemTable WHERE key IN (${new Array(k.length).fill("?").join(",")})`,g=>g.run(k),()=>{const g=[];return d.forEach(E=>{g.push(E)}),`Keys: ${g.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const u=await this.f;return this.q(u,"VACUUM")}async close(u){this.d.trace(`[storage ${this.c}] close()`);const $=await this.f;return this.k($,u)}k(u,$){return new Promise((p,d)=>{u.db.close(f=>(f&&this.o(u,`[storage ${this.c}] close(): ${f}`),this.g===b.IN_MEMORY_PATH?p():!u.isErroneous&&!u.isInMemory?this.l().then(p,y=>(this.d.error(`[storage ${this.c}] backup(): ${y}`),p())):typeof $=="function"?i.promises.unlink(this.g).then(()=>this.p(this.g).then(y=>{const k=()=>this.k(y,void 0);return this.j(y,{insert:$()}).then(()=>k(),g=>(k(),Promise.reject(g)))})).then(p,d):d(f||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const u=this.m(this.g);return I.Promises.copy(this.g,u,{preserveSymlinks:!1})}m(u){return`${u}.backup`}async checkIntegrity(u){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${u})`);const $=await this.f,p=await this.r($,u?"PRAGMA integrity_check":"PRAGMA quick_check"),d=u?p.integrity_check:p.quick_check;return $.isErroneous?`${d} (last error: ${$.lastError})`:$.isInMemory?`${d} (in-memory!)`:d}async n(u,$=!0){this.d.trace(`[storage ${this.c}] open(${u}, retryOnBusy: ${$})`);try{return await this.p(u)}catch(p){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${p}`),p.code==="SQLITE_BUSY"&&$)return await(0,r.$Jh)(b.a),this.n(u,!1);try{await i.promises.unlink(u);try{await I.Promises.rename(this.m(u),u,!1)}catch{}return await this.p(u)}catch(d){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${d}`),this.p(b.IN_MEMORY_PATH)}}}o(u,$){u.isErroneous=!0,u.lastError=$,this.d.error($)}p(u){return new Promise(($,p)=>{new Promise((d,f)=>{K(["@vscode/sqlite3"],d,f)}).then(Ie).then(d=>{const f=this.d.isTracing?d.verbose().Database:d.Database,y={db:new f(u,k=>k?y.db&&k.code!=="SQLITE_CANTOPEN"?y.db.close(()=>p(k)):p(k):this.q(y,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>$(y),g=>y.db.close(()=>p(g)))),isInMemory:u===b.IN_MEMORY_PATH};y.db.on("error",k=>this.o(y,`[storage ${this.c}] Error (event): ${k}`)),this.d.isTracing&&y.db.on("trace",k=>this.d.trace(`[storage ${this.c}] Trace (event): ${k}`))},p)})}q(u,$){return new Promise((p,d)=>{u.db.exec($,f=>f?(this.o(u,`[storage ${this.c}] exec(): ${f}`),d(f)):p())})}r(u,$){return new Promise((p,d)=>{u.db.get($,(f,y)=>f?(this.o(u,`[storage ${this.c}] get(): ${f}`),d(f)):p(y))})}s(u,$){return new Promise((p,d)=>{u.db.all($,(f,y)=>f?(this.o(u,`[storage ${this.c}] all(): ${f}`),d(f)):p(y))})}t(u,$){return new Promise((p,d)=>{u.db.serialize(()=>{u.db.run("BEGIN TRANSACTION"),$(),u.db.run("END TRANSACTION",f=>f?(this.o(u,`[storage ${this.c}] transaction(): ${f}`),d(f)):p())})})}u(u,$,p,d){const f=u.db.prepare($),y=k=>{this.o(u,`[storage ${this.c}] prepare(): ${k} (${$}). Details: ${d()}`)};f.on("error",y),p(f),f.finalize(k=>{k&&y(k),f.removeListener("error",y)})}}e.$LY=b;class l{static{this.a="VSCODE_TRACE_STORAGE"}constructor(u){u&&typeof u.logTrace=="function"&&process.env[l.a]&&(this.b=u.logTrace),u&&typeof u.logError=="function"&&(this.c=u.logError)}get isTracing(){return!!this.b}trace(u){this.b?.(u)}error(u){this.c?.(u)}}}),define(le[10],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localize=v,e.localize2=O;const i=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function r(I,b){let l;return b.length===0?l=I:l=I.replace(/\{(\d+)\}/g,(m,u)=>{const $=u[0],p=b[$];let d=m;return typeof p=="string"?d=p:(typeof p=="number"||typeof p=="boolean"||p===void 0||p===null)&&(d=String(p)),d}),i&&(l="\uFF3B"+l.replace(/[aouei]/g,"$&$&")+"\uFF3D"),l}function v(I,b,...l){return r(typeof I=="number"?A(I,b):b,l)}function A(I,b){const l=globalThis._VSCODE_NLS_MESSAGES?.[I];if(typeof l!="string"){if(typeof b=="string")return b;throw new Error(`!!! NLS MISSING: ${I} !!!`)}return l}function O(I,b,...l){let m;typeof I=="number"?m=A(I,b):m=b;const u=r(m,l);return{value:u,original:b===m?u:r(b,l)}}}),define(le[165],ue([0,1,10]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=l,e.$6m=m,e.$7m=u,e.$8m=$;const r=60,v=r*60,A=v*24,O=A*7,I=A*30,b=A*365;function l(p,d,f,y){typeof p!="number"&&(p=p.getTime());const k=Math.round((new Date().getTime()-p)/1e3);if(k<-30)return(0,i.localize)(42,null,l(new Date().getTime()+k*1e3,!1));if(!y&&k<30)return(0,i.localize)(43,null);let g;return k<r?(g=k,d?g===1?f?(0,i.localize)(44,null,g):(0,i.localize)(45,null,g):f?(0,i.localize)(46,null,g):(0,i.localize)(47,null,g):g===1?f?(0,i.localize)(48,null,g):(0,i.localize)(49,null,g):f?(0,i.localize)(50,null,g):(0,i.localize)(51,null,g)):k<v?(g=Math.floor(k/r),d?g===1?f?(0,i.localize)(52,null,g):(0,i.localize)(53,null,g):f?(0,i.localize)(54,null,g):(0,i.localize)(55,null,g):g===1?f?(0,i.localize)(56,null,g):(0,i.localize)(57,null,g):f?(0,i.localize)(58,null,g):(0,i.localize)(59,null,g)):k<A?(g=Math.floor(k/v),d?g===1?f?(0,i.localize)(60,null,g):(0,i.localize)(61,null,g):f?(0,i.localize)(62,null,g):(0,i.localize)(63,null,g):g===1?f?(0,i.localize)(64,null,g):(0,i.localize)(65,null,g):f?(0,i.localize)(66,null,g):(0,i.localize)(67,null,g)):k<O?(g=Math.floor(k/A),d?g===1?(0,i.localize)(68,null,g):(0,i.localize)(69,null,g):g===1?(0,i.localize)(70,null,g):(0,i.localize)(71,null,g)):k<I?(g=Math.floor(k/O),d?g===1?f?(0,i.localize)(72,null,g):(0,i.localize)(73,null,g):f?(0,i.localize)(74,null,g):(0,i.localize)(75,null,g):g===1?f?(0,i.localize)(76,null,g):(0,i.localize)(77,null,g):f?(0,i.localize)(78,null,g):(0,i.localize)(79,null,g)):k<b?(g=Math.floor(k/I),d?g===1?f?(0,i.localize)(80,null,g):(0,i.localize)(81,null,g):f?(0,i.localize)(82,null,g):(0,i.localize)(83,null,g):g===1?f?(0,i.localize)(84,null,g):(0,i.localize)(85,null,g):f?(0,i.localize)(86,null,g):(0,i.localize)(87,null,g)):(g=Math.floor(k/b),d?g===1?f?(0,i.localize)(88,null,g):(0,i.localize)(89,null,g):f?(0,i.localize)(90,null,g):(0,i.localize)(91,null,g):g===1?f?(0,i.localize)(92,null,g):(0,i.localize)(93,null,g):f?(0,i.localize)(94,null,g):(0,i.localize)(95,null,g))}function m(p,d,f){typeof p!="number"&&(p=p.getTime());const y=new Date;y.setHours(0,0,0,0);const k=new Date(y.getTime());return k.setDate(k.getDate()-1),p>y.getTime()?(0,i.localize)(96,null):p>k.getTime()?(0,i.localize)(97,null):l(p,d,f)}function u(p,d){const f=Math.abs(p/1e3);return f<1?d?(0,i.localize)(98,null,p):(0,i.localize)(99,null,p):f<r?d?(0,i.localize)(100,null,Math.round(p)/1e3):(0,i.localize)(101,null,Math.round(p)/1e3):f<v?d?(0,i.localize)(102,null,Math.round(p/(1e3*r))):(0,i.localize)(103,null,Math.round(p/(1e3*r))):f<A?d?(0,i.localize)(104,null,Math.round(p/(1e3*v))):(0,i.localize)(105,null,Math.round(p/(1e3*v))):(0,i.localize)(106,null,Math.round(p/(1e3*A)))}function $(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(le[55],ue([0,1,21,12,10]),function(K,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=b,e.$uj=l,e.$vj=m,i=Ie(i),r=Ie(r),v=Ie(v);function A(u,$){return $&&(u.stack||u.stacktrace)?v.localize(107,null,I(u),O(u.stack)||O(u.stacktrace)):I(u)}function O(u){return Array.isArray(u)?u.join(`
`):u}function I(u){return u.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${u.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof u.code=="string"&&typeof u.errno=="number"&&typeof u.syscall=="string"?v.localize(108,null,u.message):u.message||v.localize(109,null)}function b(u=null,$=!1){if(!u)return v.localize(110,null);if(Array.isArray(u)){const p=i.$Jb(u),d=b(p[0],$);return p.length>1?v.localize(111,null,d,p.length):d}if(r.$hg(u))return u;if(u.detail){const p=u.detail;if(p.error)return A(p.error,$);if(p.exception)return A(p.exception,$)}return u.stack?A(u,$):u.message?u.message:v.localize(112,null)}function l(u){const $=u;return $ instanceof Error&&Array.isArray($.actions)}function m(u,$){let p;return typeof u=="string"?p=new Error(u):p=u,p.actions=$,p}}),define(le[166],ue([0,1,10,43]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=v;function v(A){switch(A){case r.ParseErrorCode.InvalidSymbol:return(0,i.localize)(113,null);case r.ParseErrorCode.InvalidNumberFormat:return(0,i.localize)(114,null);case r.ParseErrorCode.PropertyNameExpected:return(0,i.localize)(115,null);case r.ParseErrorCode.ValueExpected:return(0,i.localize)(116,null);case r.ParseErrorCode.ColonExpected:return(0,i.localize)(117,null);case r.ParseErrorCode.CommaExpected:return(0,i.localize)(118,null);case r.ParseErrorCode.CloseBraceExpected:return(0,i.localize)(119,null);case r.ParseErrorCode.CloseBracketExpected:return(0,i.localize)(120,null);case r.ParseErrorCode.EndOfFileExpected:return(0,i.localize)(121,null);default:return""}}}),define(le[167],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gib=i,e.$Hib=r;function i(v){return v&&v.hasOwnProperty("folderUri")}function r(v){return v&&v.hasOwnProperty("workspace")}}),define(le[168],ue([0,1,7]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qgc=r,e.$Rgc=v,e.$Sgc=A;function r(O){return typeof O?.backupFolder=="string"}function v(O){let I=[];try{Array.isArray(O.workspaces)&&(I=O.workspaces.map(b=>({workspace:{id:b.id,configPath:i.URI.parse(b.configURIPath)},remoteAuthority:b.remoteAuthority})))}catch{}return I}function A(O){let I=[];try{Array.isArray(O.folders)&&(I=O.folders.map(b=>({folderUri:i.URI.parse(b.folderUri),remoteAuthority:b.remoteAuthority})))}catch{}return I}}),define(le[169],ue([0,1,39,15,10]),function(K,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dj=e.TokenType=void 0;var A;(function(m){m[m.LParen=0]="LParen",m[m.RParen=1]="RParen",m[m.Neg=2]="Neg",m[m.Eq=3]="Eq",m[m.NotEq=4]="NotEq",m[m.Lt=5]="Lt",m[m.LtEq=6]="LtEq",m[m.Gt=7]="Gt",m[m.GtEq=8]="GtEq",m[m.RegexOp=9]="RegexOp",m[m.RegexStr=10]="RegexStr",m[m.True=11]="True",m[m.False=12]="False",m[m.In=13]="In",m[m.Not=14]="Not",m[m.And=15]="And",m[m.Or=16]="Or",m[m.Str=17]="Str",m[m.QuotedStr=18]="QuotedStr",m[m.Error=19]="Error",m[m.EOF=20]="EOF"})(A||(e.TokenType=A={}));function O(...m){switch(m.length){case 1:return(0,v.localize)(1693,null,m[0]);case 2:return(0,v.localize)(1694,null,m[0],m[1]);case 3:return(0,v.localize)(1695,null,m[0],m[1],m[2]);default:return}}const I=(0,v.localize)(1696,null),b=(0,v.localize)(1697,null);class l{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(u){switch(u.type){case A.LParen:return"(";case A.RParen:return")";case A.Neg:return"!";case A.Eq:return u.isTripleEq?"===":"==";case A.NotEq:return u.isTripleEq?"!==":"!=";case A.Lt:return"<";case A.LtEq:return"<=";case A.Gt:return">=";case A.GtEq:return">=";case A.RegexOp:return"=~";case A.RegexStr:return u.lexeme;case A.True:return"true";case A.False:return"false";case A.In:return"in";case A.Not:return"not";case A.And:return"&&";case A.Or:return"||";case A.Str:return u.lexeme;case A.QuotedStr:return u.lexeme;case A.Error:return u.lexeme;case A.EOF:return"EOF";default:throw(0,r.$0)(`unhandled token type: ${JSON.stringify(u)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(u=>u.charCodeAt(0)))}static{this.b=new Map([["not",A.Not],["in",A.In],["false",A.False],["true",A.True]])}get errors(){return this.g}reset(u){return this.c=u,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case i.CharCode.OpenParen:this.k(A.LParen);break;case i.CharCode.CloseParen:this.k(A.RParen);break;case i.CharCode.ExclamationMark:if(this.h(i.CharCode.Equals)){const $=this.h(i.CharCode.Equals);this.f.push({type:A.NotEq,offset:this.d,isTripleEq:$})}else this.k(A.Neg);break;case i.CharCode.SingleQuote:this.o();break;case i.CharCode.Slash:this.q();break;case i.CharCode.Equals:if(this.h(i.CharCode.Equals)){const $=this.h(i.CharCode.Equals);this.f.push({type:A.Eq,offset:this.d,isTripleEq:$})}else this.h(i.CharCode.Tilde)?this.k(A.RegexOp):this.l(O("==","=~"));break;case i.CharCode.LessThan:this.k(this.h(i.CharCode.Equals)?A.LtEq:A.Lt);break;case i.CharCode.GreaterThan:this.k(this.h(i.CharCode.Equals)?A.GtEq:A.Gt);break;case i.CharCode.Ampersand:this.h(i.CharCode.Ampersand)?this.k(A.And):this.l(O("&&"));break;case i.CharCode.Pipe:this.h(i.CharCode.Pipe)?this.k(A.Or):this.l(O("||"));break;case i.CharCode.Space:case i.CharCode.CarriageReturn:case i.CharCode.Tab:case i.CharCode.LineFeed:case i.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(A.EOF),Array.from(this.f)}h(u){return this.r()||this.c.charCodeAt(this.e)!==u?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?i.CharCode.Null:this.c.charCodeAt(this.e)}k(u){this.f.push({type:u,offset:this.d})}l(u){const $=this.d,p=this.c.substring(this.d,this.e),d={type:A.Error,offset:this.d,lexeme:p};this.g.push({offset:$,lexeme:p,additionalInfo:u}),this.f.push(d)}n(){this.m.lastIndex=this.d;const u=this.m.exec(this.c);if(u){this.e=this.d+u[0].length;const $=this.c.substring(this.d,this.e),p=l.b.get($);p?this.k(p):this.f.push({type:A.Str,lexeme:$,offset:this.d})}}o(){for(;this.j()!==i.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(I);return}this.i(),this.f.push({type:A.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let u=this.e,$=!1,p=!1;for(;;){if(u>=this.c.length){this.e=u,this.l(b);return}const f=this.c.charCodeAt(u);if($)$=!1;else if(f===i.CharCode.Slash&&!p){u++;break}else f===i.CharCode.OpenSquareBracket?p=!0:f===i.CharCode.Backslash?$=!0:f===i.CharCode.CloseSquareBracket&&(p=!1);u++}for(;u<this.c.length&&l.a.has(this.c.charCodeAt(u));)u++;this.e=u;const d=this.c.substring(this.d,this.e);this.f.push({type:A.RegexStr,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}e.$Dj=l}),define(le[170],ue([0,1,4,2]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5o=e.$4o=void 0;class v{constructor(){this.a=new i.$oe,this.b=new i.$oe,this.c=new i.$oe,this.d=new i.$oe}static{this.ChannelName="extensionhostdebugservice"}call(I,b,l){switch(b){case"close":return Promise.resolve(this.a.fire({sessionId:l[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:l[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:l[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:l[0],port:l[1],subId:l[2]}))}throw new Error("Method not implemented.")}listen(I,b,l){switch(b){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$4o=v;class A extends r.$Xc{constructor(I){super(),this.b=I}reload(I){this.b.call("reload",[I])}get onReload(){return this.b.listen("reload")}close(I){this.b.call("close",[I])}get onClose(){return this.b.listen("close")}attachSession(I,b,l){this.b.call("attach",[I,b,l])}get onAttachSession(){return this.b.listen("attach")}terminateSession(I,b){this.b.call("terminate",[I,b])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(I,b){return this.b.call("openExtensionDevelopmentHostWindow",[I,b])}}e.$5o=A}),define(le[171],ue([0,1,165,54,11,9,37,18,7]),function(K,e,i,r,v,A,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=e.$9m=void 0,e.$$m=m,e.$_m=u,e.$9m=/^([^.]+\..+)[:=](.+)$/;class l{get appRoot(){return(0,A.$pc)(v.$3g.asFileUri("").fsPath)}get userHome(){return b.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return b.URI.file((0,A.$mc)(this.userDataPath,"User"))}get tmpDir(){return b.URI.file(this.b.tmpDir)}get cacheHome(){return b.URI.file(this.userDataPath)}get stateResource(){return(0,I.$jh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:v.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,I.$jh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const p=(0,i.$8m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$mc)(this.userDataPath,"logs",p)}return b.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.$jh)(b.URI.file((0,A.$mc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.$jh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.$jh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.$jh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const p=O.env.VSCODE_PORTABLE;return p?b.URI.file((0,A.$mc)(p,"argv.json")):(0,I.$jh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return b.URI.file((0,A.$mc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const p=this.args["builtin-extensions-dir"];return p?(0,A.$nc)(p):(0,A.$kc)((0,A.$mc)(v.$3g.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const p=this.args["extensions-download-dir"];return p?b.URI.file((0,A.$nc)(p)):b.URI.file((0,A.$mc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const p=this.args["extensions-dir"];if(p)return(0,A.$nc)(p);const d=O.env.VSCODE_EXTENSIONS;if(d)return d;const f=O.env.VSCODE_PORTABLE;return f?(0,A.$mc)(f,"extensions"):(0,I.$jh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const p=this.args.extensionDevelopmentPath;if(Array.isArray(p))return p.map(d=>/^[^:/?#]+?:\/\//.test(d)?b.URI.parse(d):b.URI.file((0,A.$kc)(d)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(p=>p==="ui"||p==="workspace"||p==="web"?p:"workspace")}get extensionTestsLocationURI(){const p=this.args.extensionTestsPath;if(p)return/^[^:/?#]+?:\/\//.test(p)?b.URI.parse(p):b.URI.file((0,A.$kc)(p))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const p=this.args["disable-extension"];if(p){if(typeof p=="string")return[p];if(Array.isArray(p)&&p.length>0)return p}return!1}get debugExtensionHost(){return m(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(p=>!e.$9m.test(p))}get extensionLogLevel(){const p=[];for(const d of this.args.log||[]){const f=e.$9m.exec(d);f&&f[1]&&f[2]&&p.push([f[1],f[2]])}return p.length?p:void 0}get serviceMachineIdResource(){return(0,I.$jh)(b.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const p=O.env.VSCODE_PORTABLE;return p?b.URI.file((0,A.$mc)(p,"policy.json")):(0,I.$jh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(p){this.args.continueOn=p}get args(){return this.a}constructor(p,d,f){this.a=p,this.b=d,this.c=f,this.editSessionId=this.args.editSessionId}}e.$0m=l,ke([r.$ai],l.prototype,"appRoot",null),ke([r.$ai],l.prototype,"userHome",null),ke([r.$ai],l.prototype,"userDataPath",null),ke([r.$ai],l.prototype,"appSettingsHome",null),ke([r.$ai],l.prototype,"tmpDir",null),ke([r.$ai],l.prototype,"cacheHome",null),ke([r.$ai],l.prototype,"stateResource",null),ke([r.$ai],l.prototype,"userRoamingDataHome",null),ke([r.$ai],l.prototype,"userDataSyncHome",null),ke([r.$ai],l.prototype,"sync",null),ke([r.$ai],l.prototype,"machineSettingsResource",null),ke([r.$ai],l.prototype,"workspaceStorageHome",null),ke([r.$ai],l.prototype,"localHistoryHome",null),ke([r.$ai],l.prototype,"keyboardLayoutResource",null),ke([r.$ai],l.prototype,"argvResource",null),ke([r.$ai],l.prototype,"isExtensionDevelopment",null),ke([r.$ai],l.prototype,"untitledWorkspacesHome",null),ke([r.$ai],l.prototype,"builtinExtensionsPath",null),ke([r.$ai],l.prototype,"extensionsPath",null),ke([r.$ai],l.prototype,"extensionDevelopmentLocationURI",null),ke([r.$ai],l.prototype,"extensionDevelopmentKind",null),ke([r.$ai],l.prototype,"extensionTestsLocationURI",null),ke([r.$ai],l.prototype,"debugExtensionHost",null),ke([r.$ai],l.prototype,"logLevel",null),ke([r.$ai],l.prototype,"extensionLogLevel",null),ke([r.$ai],l.prototype,"serviceMachineIdResource",null),ke([r.$ai],l.prototype,"disableTelemetry",null),ke([r.$ai],l.prototype,"disableWorkspaceTrust",null),ke([r.$ai],l.prototype,"useInMemorySecretStorage",null),ke([r.$ai],l.prototype,"policyFile",null);function m($,p){return u($["inspect-extensions"],$["inspect-brk-extensions"],5870,p,$.debugId,$.extensionEnvironment)}function u($,p,d,f,y,k){const E=Number(p||$)||(f?null:d),S=E?!!p:!1;let s;if(k)try{s=JSON.parse(k)}catch{}return{port:E,break:S,debugId:y,env:s}}});var xe=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[123],ue([0,1,283,3,10]),function(K,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=e.$Em=void 0,e.$Gm=I,e.$Hm=l,e.$Im=p,e.$Jm=d,i=xe(i);const A={o:(0,v.localize)(1713,null),e:(0,v.localize)(1714,null),t:(0,v.localize)(1715,null)};e.$Em=["tunnel","serve-web"],e.$Fm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,v.localize)(1716,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,v.localize)(1717,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,v.localize)(1718,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,v.localize)(1719,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,v.localize)(1720,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,v.localize)(1721,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,v.localize)(1722,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,v.localize)(1723,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,v.localize)(1724,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,v.localize)(1725,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,v.localize)(1726,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,v.localize)(1727,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,v.localize)(1728,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,v.localize)(1729,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,v.localize)(1730,null)},"show-versions":{type:"boolean",cat:"e",description:(0,v.localize)(1731,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,v.localize)(1732,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,v.localize)(1733,null)},"pre-release":{type:"boolean",cat:"e",description:(0,v.localize)(1734,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,v.localize)(1735,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,v.localize)(1736,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,v.localize)(1737,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,v.localize)(1738,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,v.localize)(1739,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,v.localize)(1740,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,v.localize)(1741,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,v.localize)(1742,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,v.localize)(1743,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,v.localize)(1744,null)},sync:{type:"string",cat:"t",description:(0,v.localize)(1745,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,v.localize)(1746,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,v.localize)(1747,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,v.localize)(1748,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,v.localize)(1749,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,v.localize)(1750,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,v.localize)(1751,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},_:{type:"string[]"}};const O={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function I(f,y,k=O){const g=f.find(h=>h.length>0&&h[0]!=="-"),E={},S=["_"],s=[],a={};let t;for(const h in y){const P=y[h];P.type==="subcommand"?h===g&&(t=P):(P.alias&&(E[h]=P.alias),P.type==="string"||P.type==="string[]"?(S.push(h),P.deprecates&&S.push(...P.deprecates)):P.type==="boolean"&&(s.push(h),P.deprecates&&s.push(...P.deprecates)),P.global&&(a[h]=P))}if(t&&g){const h=a;for(const L in t.options)h[L]=t.options[L];const P=f.filter(L=>L!==g),w=k.getSubcommandReporter?k.getSubcommandReporter(g):void 0,D=I(P,h,w);return{[g]:D,_:[]}}const o=(0,i.default)(f,{string:S,boolean:s,alias:E}),n={},c=o;n._=o._.map(h=>String(h)).filter(h=>h.length>0),delete c._;for(const h in y){const P=y[h];if(P.type==="subcommand")continue;P.alias&&delete c[P.alias];let w=c[h];if(P.deprecates)for(const D of P.deprecates)c.hasOwnProperty(D)&&(w||(w=c[D],w&&k.onDeprecatedOption(D,P.deprecationMessage||(0,v.localize)(1752,null,h))),delete c[D]);if(typeof w<"u"){if(P.type==="string[]"){if(Array.isArray(w)||(w=[w]),!P.allowEmptyValue){const D=w.filter(L=>L.length>0);D.length!==w.length&&(k.onEmptyValue(h),w=D.length>0?D:void 0)}}else P.type==="string"&&(Array.isArray(w)?(w=w.pop(),k.onMultipleValues(h,w)):!w&&!P.allowEmptyValue&&(k.onEmptyValue(h),w=void 0));n[h]=w,P.deprecationMessage&&k.onDeprecatedOption(h,P.deprecationMessage)}delete c[h]}for(const h in c)k.onUnknownOption(h);return n}function b(f,y){let k="";return y.args&&(Array.isArray(y.args)?k=` <${y.args.join("> <")}>`:k=` <${y.args}>`),y.alias?`-${y.alias} --${f}${k}`:`--${f}${k}`}function l(f,y){const k=[];for(const g in f){const E=f[g],S=b(g,E);k.push([S,E.description])}return m(k,y)}function m(f,y){const g=f.reduce((s,a)=>Math.max(s,a[0].length),12)+2+1;if(y-g<25)return f.reduce((s,a)=>s.concat([`  ${a[0]}`,`      ${a[1]}`]),[]);const E=y-g-1,S=[];for(const s of f){const a=s[0],t=$(s[1],E),o=u(g-a.length-2);S.push("  "+a+o+t[0]);for(let n=1;n<t.length;n++)S.push(u(g)+t[n])}return S}function u(f){return" ".repeat(f)}function $(f,y){const k=[];for(;f.length;){const g=f.length<y?f.length:f.lastIndexOf(" ",y),E=f.slice(0,g).trim();f=f.slice(g),k.push(E)}return k}function p(f,y,k,g,E){const S=process.stdout.isTTY&&process.stdout.columns||80,s=E?.noInputFiles!==!0?`[${(0,v.localize)(1753,null)}...]`:"",a=[`${f} ${k}`];a.push(""),a.push(`${(0,v.localize)(1754,null)}: ${y} [${(0,v.localize)(1755,null)}]${s}`),a.push(""),E?.noPipe!==!0&&(r.$j?a.push((0,v.localize)(1756,null,y)):a.push((0,v.localize)(1757,null,y)),a.push(""));const t={},o=[];for(const n in g){const c=g[n];if(c.type==="subcommand")c.description&&o.push({command:n,description:c.description});else if(c.description&&c.cat){let h=t[c.cat];h||(t[c.cat]=h={}),h[n]=c}}for(const n in t){const c=n,h=t[c];h&&(a.push(A[c]),a.push(...l(h,S)),a.push(""))}return o.length&&(a.push((0,v.localize)(1758,null)),a.push(...m(o.map(n=>[n.command,n.description]),S)),a.push("")),a.join(`
`)}function d(f,y){return`${f||(0,v.localize)(1759,null)}
${y||(0,v.localize)(1760,null)}
${process.arch}`}});var xe=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[70],ue([0,1,284,10,123]),function(K,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Km=I,e.$Lm=b,e.$Mm=l,e.$Nm=m,i=xe(i);function A(u,$){const p=(E,S)=>{console.warn((0,r.localize)(1761,null,E,S))},d=E=>{console.warn((0,r.localize)(1762,null,E))},f=(E,S)=>{console.warn((0,r.localize)(1763,null,E,S))},y=E=>({onUnknownOption:S=>{v.$Em.includes(E)||console.warn((0,r.localize)(1764,null,S,E))},onMultipleValues:p,onEmptyValue:d,onDeprecatedOption:f,getSubcommandReporter:v.$Em.includes(E)?y:void 0}),k={onUnknownOption:E=>{console.warn((0,r.localize)(1765,null,E))},onMultipleValues:p,onEmptyValue:d,onDeprecatedOption:f,getSubcommandReporter:y},g=(0,v.$Gm)(u,v.$Fm,$?k:void 0);return g.goto&&g._.forEach(E=>(0,i.default)(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(E),(0,r.localize)(1766,null))),g}function O(u){const $=u.findIndex(p=>!/^-/.test(p));if($>-1)return[...u.slice(0,$),...u.slice($+1)]}function I(u){let[,...$]=u;process.env.VSCODE_DEV&&($=O($)||[]);const p=!m(process.env);return A($,p)}function b(u){let[,,...$]=u;return process.env.VSCODE_DEV&&($=O($)||[]),A($,!0)}function l(u,...$){const p=u.indexOf("--");return p===-1?u.push(...$):u.splice(p,0,...$),u}function m(u){return u.VSCODE_CLI==="1"}}),function(){function K(e,i,r){function v(O,I){const b=A(O,I),l=[b];return e.isAbsolute(b)||l.unshift(r),e.resolve(...l)}function A(O,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const b=process.env.VSCODE_PORTABLE;if(b)return e.join(b,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,I);const m=O["user-data-dir"];if(m)return m;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const u=process.env.USERPROFILE;if(typeof u!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(u,"AppData","Roaming")}break;case"darwin":l=e.join(i.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(i.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,I)}return{getUserDataPath:v}}if(typeof define=="function")define(le[172],ue([97,27,37]),function(e,i,r){return K(e,i,r.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),i=require("os");module.exports=K(e,i,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[98],ue([0,1,27,171,172]),function(K,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$an=void 0,e.$bn=O,e.$cn=I;class A extends r.$0m{constructor(l,m){super(l,{homeDir:(0,i.homedir)(),tmpDir:(0,i.tmpdir)(),userDataDir:(0,v.getUserDataPath)(l,m.nameShort)},m)}}e.$an=A;function O(b,l){return(0,r.$_m)(b["inspect-ptyhost"],b["inspect-brk-ptyhost"],5877,l,b.extensionEnvironment)}function I(b,l){return(0,r.$_m)(b["inspect-sharedprocess"],b["inspect-brk-sharedprocess"],5879,l,b.extensionEnvironment)}}),define(le[173],ue([0,1,26,27,32]),function(K,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pic=A;function A(O){const I=(0,v.$Qg)((0,r.tmpdir)());try{return(0,i.writeFileSync)(I,""),O&&console.log(`Marker file for --wait created: ${I}`),I}catch(b){O&&console.error(`Failed to create marker file for --wait: ${b}`);return}}}),define(le[174],ue([0,1,12,10]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=v;function v(O,I,b,l){try{A(O,I,b,l)}catch(m){O.error(m?.message??m)}return I}function A(O,I,b,l){const m=(u,$,p)=>{const d=u[$];if((0,i.$hg)(d)){const f=d,y=f.length;if(y>1&&f[0]==="%"&&f[y-1]==="%"){const k=f.substr(1,y-2);let g=b[k];g===void 0&&l&&(g=l[k]);const E=typeof g=="string"?g:g?.message,S=l?.[k],s=typeof S=="string"?S:S?.message;if(!E){s||O.warn(`[${I.name}]: ${(0,r.localize)(1814,null,k)}`);return}if(p&&($==="title"||$==="category")&&s&&s!==E){const a={value:E,original:s};u[$]=a}else u[$]=E}}else if((0,i.$jg)(d))for(const f in d)d.hasOwnProperty(f)&&(f==="commands"?m(d,f,!0):m(d,f,p));else if(Array.isArray(d))for(let f=0;f<d.length;f++)m(d,f,p)};for(const u in I)I.hasOwnProperty(u)&&m(I,u)}}),define(le[175],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const i={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDebugCreateConfiguration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDebugCreateConfiguration.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewContainerTitle:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewContainerTitle.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:4},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookReplDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookReplDocument.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(i)}),define(le[84],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=void 0;class i{constructor(v,A=[],O=!1){this.ctor=v,this.staticArguments=A,this.supportsDelayedInstantiation=O}}e.$Fi=i}),define(le[176],ue([0,1,84]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Xs=A,e.$Ys=O;const r=[];var v;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(v||(e.InstantiationType=v={}));function A(I,b,l){b instanceof i.$Fi||(b=new i.$Fi(b,[],!!l)),r.push([I,b])}function O(){return r}}),define(le[177],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=e.$Ar=void 0;class i{constructor(A,O){this.key=A,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.$Ar=i;class r{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const O of this.a.values())O.outgoing.size===0&&A.push(O);return A}insertEdge(A,O){const I=this.lookupOrInsertNode(A),b=this.lookupOrInsertNode(O);I.outgoing.set(b.key,b),b.incoming.set(I.key,I)}removeNode(A){const O=this.b(A);this.a.delete(O);for(const I of this.a.values())I.outgoing.delete(O),I.incoming.delete(O)}lookupOrInsertNode(A){const O=this.b(A);let I=this.a.get(O);return I||(I=new i(O,A),this.a.set(O,I)),I}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[O,I]of this.a)A.push(`${O}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,O]of this.a){const I=new Set([A]),b=this.c(O,I);if(b)return b}}c(A,O){for(const[I,b]of A.outgoing){if(O.has(I))return[...O,I].join(" -> ");O.add(I);const l=this.c(b,O);if(l)return l;O.delete(I)}}}e.$Br=r}),define(le[6],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=e._util=void 0,e.$Ii=v,e.$Ji=A;var i;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function I(b){return b[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=I})(i||(e._util=i={})),e.$Hi=v("instantiationService");function r(O,I,b){I[i.DI_TARGET]===I?I[i.DI_DEPENDENCIES].push({id:O,index:b}):(I[i.DI_DEPENDENCIES]=[{id:O,index:b}],I[i.DI_TARGET]=I)}function v(O){if(i.serviceIds.has(O))return i.serviceIds.get(O);const I=function(b,l,m){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");r(I,b,m)};return I.toString=()=>O,i.serviceIds.set(O,I),I}function A(O){return O}}),define(le[85],ue([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lhc=void 0,e.$Lhc=(0,i.$Ii)("auxiliaryWindowsMainService")}),define(le[71],ue([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tgc=void 0,e.$Tgc=(0,i.$Ii)("backupMainService")}),define(le[16],ue([0,1,12,7,6]),function(K,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$cj=void 0,e.$dj=A,e.$ej=O,e.$fj=b,e.$gj=l,e.$hj=m,e.$ij=u,e.$jj=$,e.$kj=d,e.$lj=f,e.$mj=y,i=Ie(i),e.$cj=(0,v.$Ii)("configurationService");function A(k){return k&&typeof k=="object"&&(!k.overrideIdentifier||typeof k.overrideIdentifier=="string")&&(!k.resource||k.resource instanceof r.URI)}function O(k){return k&&typeof k=="object"&&(!k.overrideIdentifiers||Array.isArray(k.overrideIdentifiers))&&!k.overrideIdentifier&&(!k.resource||k.resource instanceof r.URI)}var I;(function(k){k[k.APPLICATION=1]="APPLICATION",k[k.USER=2]="USER",k[k.USER_LOCAL=3]="USER_LOCAL",k[k.USER_REMOTE=4]="USER_REMOTE",k[k.WORKSPACE=5]="WORKSPACE",k[k.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",k[k.DEFAULT=7]="DEFAULT",k[k.MEMORY=8]="MEMORY"})(I||(e.ConfigurationTarget=I={}));function b(k){switch(k){case I.APPLICATION:return"APPLICATION";case I.USER:return"USER";case I.USER_LOCAL:return"USER_LOCAL";case I.USER_REMOTE:return"USER_REMOTE";case I.WORKSPACE:return"WORKSPACE";case I.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case I.DEFAULT:return"DEFAULT";case I.MEMORY:return"MEMORY"}}function l(k){return k.applicationValue!==void 0||k.userValue!==void 0||k.userLocalValue!==void 0||k.userRemoteValue!==void 0||k.workspaceValue!==void 0||k.workspaceFolderValue!==void 0}function m(k,g){const E=Object.create(null);for(const S in k)u(E,S,k[S],g);return E}function u(k,g,E,S){const s=g.split("."),a=s.pop();let t=k;for(let o=0;o<s.length;o++){const n=s[o];let c=t[n];switch(typeof c){case"undefined":c=t[n]=Object.create(null);break;case"object":if(c===null){S(`Ignoring ${g} as ${s.slice(0,o+1).join(".")} is null`);return}break;default:S(`Ignoring ${g} as ${s.slice(0,o+1).join(".")} is ${JSON.stringify(c)}`);return}t=c}if(typeof t=="object"&&t!==null)try{t[a]=E}catch{S(`Ignoring ${g} as ${s.join(".")} is ${JSON.stringify(t)}`)}else S(`Ignoring ${g} as ${s.join(".")} is ${JSON.stringify(t)}`)}function $(k,g){const E=g.split(".");p(k,E)}function p(k,g){const E=g.shift();if(g.length===0){delete k[E];return}if(Object.keys(k).indexOf(E)!==-1){const S=k[E];typeof S=="object"&&!Array.isArray(S)&&(p(S,g),Object.keys(S).length===0&&delete k[E])}}function d(k,g,E){function S(t,o){let n=t;for(const c of o){if(typeof n!="object"||n===null)return;n=n[c]}return n}const s=g.split("."),a=S(k,s);return typeof a>"u"?E:a}function f(k,g,E){Object.keys(g).forEach(S=>{S!=="__proto__"&&(S in k?i.$jg(k[S])&&i.$jg(g[S])?f(k[S],g[S],E):E&&(k[S]=g[S]):k[S]=g[S])})}function y(k){return k.replace(/[\[\]]/g,"")}}),define(le[124],ue([0,1,39,3,25,169,6,10,15]),function(K,e,i,r,v,A,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Gj=e.$Fj=e.ContextKeyExprType=void 0,e.$Ej=m,e.$Hj=o,e.$Ij=n,e.$2j=x;const l=new Map;l.set("false",!1),l.set("true",!0),l.set("isMac",r.$k),l.set("isLinux",r.$l),l.set("isWindows",r.$j),l.set("isWeb",r.$p),l.set("isMacNative",r.$k&&!r.$p),l.set("isEdge",r.$I),l.set("isFirefox",r.$G),l.set("isChrome",r.$F),l.set("isSafari",r.$H);function m(J,M){if(l.get(J)!==void 0)throw(0,b.$9)("contextkey.setConstant(k, v) invoked with already set constant `k`");l.set(J,M)}const u=Object.prototype.hasOwnProperty;var $;(function(J){J[J.False=0]="False",J[J.True=1]="True",J[J.Defined=2]="Defined",J[J.Not=3]="Not",J[J.Equals=4]="Equals",J[J.NotEquals=5]="NotEquals",J[J.And=6]="And",J[J.Regex=7]="Regex",J[J.NotRegex=8]="NotRegex",J[J.Or=9]="Or",J[J.In=10]="In",J[J.NotIn=11]="NotIn",J[J.Greater=12]="Greater",J[J.GreaterEquals=13]="GreaterEquals",J[J.Smaller=14]="Smaller",J[J.SmallerEquals=15]="SmallerEquals"})($||(e.ContextKeyExprType=$={}));const p={regexParsingWithErrorRecovery:!0},d=(0,I.localize)(1673,null),f=(0,I.localize)(1674,null),y=(0,I.localize)(1675,null),k=(0,I.localize)(1676,null),g=(0,I.localize)(1677,null),E=(0,I.localize)(1678,null),S=(0,I.localize)(1679,null),s=(0,I.localize)(1680,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(M=p){this.k=M,this.d=new A.$Dj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(M){if(M===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:f});return}this.f=this.d.reset(M).scan(),this.g=0,this.h=[];try{const Z=this.l();if(!this.E()){const U=this.D(),N=U.type===A.TokenType.Str?E:void 0;throw this.h.push({message:g,offset:U.offset,lexeme:A.$Dj.getLexeme(U),additionalInfo:N}),a.c}return Z}catch(Z){if(Z!==a.c)throw Z;return}}l(){return this.m()}m(){const M=[this.o()];for(;this.y(A.TokenType.Or);){const Z=this.o();M.push(Z)}return M.length===1?M[0]:t.or(...M)}o(){const M=[this.s()];for(;this.y(A.TokenType.And);){const Z=this.s();M.push(Z)}return M.length===1?M[0]:t.and(...M)}s(){if(this.y(A.TokenType.Neg)){const M=this.D();switch(M.type){case A.TokenType.True:return this.z(),h.INSTANCE;case A.TokenType.False:return this.z(),P.INSTANCE;case A.TokenType.LParen:{this.z();const Z=this.l();return this.A(A.TokenType.RParen,k),Z?.negate()}case A.TokenType.Str:return this.z(),j.create(M.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",M)}}return this.t()}t(){const M=this.D();switch(M.type){case A.TokenType.True:return this.z(),t.true();case A.TokenType.False:return this.z(),t.false();case A.TokenType.LParen:{this.z();const Z=this.l();return this.A(A.TokenType.RParen,k),Z}case A.TokenType.Str:{const Z=M.lexeme;if(this.z(),this.y(A.TokenType.RegexOp)){const N=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),N.type!==A.TokenType.RegexStr)throw this.B("REGEX",N);const ie=N.lexeme,X=ie.lastIndexOf("/"),z=X===ie.length-1?void 0:this.w(ie.substring(X+1));let te;try{te=new RegExp(ie.substring(1,X),z)}catch{throw this.B("REGEX",N)}return Y.create(Z,te)}switch(N.type){case A.TokenType.RegexStr:case A.TokenType.Error:{const ie=[N.lexeme];this.z();let X=this.D(),z=0;for(let ye=0;ye<N.lexeme.length;ye++)N.lexeme.charCodeAt(ye)===i.CharCode.OpenParen?z++:N.lexeme.charCodeAt(ye)===i.CharCode.CloseParen&&z--;for(;!this.E()&&X.type!==A.TokenType.And&&X.type!==A.TokenType.Or;){switch(X.type){case A.TokenType.LParen:z++;break;case A.TokenType.RParen:z--;break;case A.TokenType.RegexStr:case A.TokenType.QuotedStr:for(let ye=0;ye<X.lexeme.length;ye++)X.lexeme.charCodeAt(ye)===i.CharCode.OpenParen?z++:N.lexeme.charCodeAt(ye)===i.CharCode.CloseParen&&z--}if(z<0)break;ie.push(A.$Dj.getLexeme(X)),this.z(),X=this.D()}const te=ie.join(""),ae=te.lastIndexOf("/"),me=ae===te.length-1?void 0:this.w(te.substring(ae+1));let be;try{be=new RegExp(te.substring(1,ae),me)}catch{throw this.B("REGEX",N)}return t.regex(Z,be)}case A.TokenType.QuotedStr:{const ie=N.lexeme;this.z();let X=null;if(!(0,v.$ff)(ie)){const z=ie.indexOf("/"),te=ie.lastIndexOf("/");if(z!==te&&z>=0){const ae=ie.slice(z+1,te),me=ie[te+1]==="i"?"i":"";try{X=new RegExp(ae,me)}catch{throw this.B("REGEX",N)}}}if(X===null)throw this.B("REGEX",N);return Y.create(Z,X)}default:throw this.B("REGEX",this.D())}}if(this.y(A.TokenType.Not)){this.A(A.TokenType.In,y);const N=this.u();return t.notIn(Z,N)}switch(this.D().type){case A.TokenType.Eq:{this.z();const N=this.u();if(this.x().type===A.TokenType.QuotedStr)return t.equals(Z,N);switch(N){case"true":return t.has(Z);case"false":return t.not(Z);default:return t.equals(Z,N)}}case A.TokenType.NotEq:{this.z();const N=this.u();if(this.x().type===A.TokenType.QuotedStr)return t.notEquals(Z,N);switch(N){case"true":return t.not(Z);case"false":return t.has(Z);default:return t.notEquals(Z,N)}}case A.TokenType.Lt:return this.z(),de.create(Z,this.u());case A.TokenType.LtEq:return this.z(),V.create(Z,this.u());case A.TokenType.Gt:return this.z(),q.create(Z,this.u());case A.TokenType.GtEq:return this.z(),Q.create(Z,this.u());case A.TokenType.In:return this.z(),t.in(Z,this.u());default:return t.has(Z)}}case A.TokenType.EOF:throw this.h.push({message:S,offset:M.offset,lexeme:"",additionalInfo:s}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const M=this.D();switch(M.type){case A.TokenType.Str:case A.TokenType.QuotedStr:return this.z(),M.lexeme;case A.TokenType.True:return this.z(),"true";case A.TokenType.False:return this.z(),"false";case A.TokenType.In:return this.z(),"in";default:return""}}w(M){return M.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(M){return this.C(M)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(M,Z){if(this.C(M))return this.z();throw this.B(Z,this.D())}B(M,Z,U){const N=(0,I.localize)(1681,null,M,A.$Dj.getLexeme(Z)),ie=Z.offset,X=A.$Dj.getLexeme(Z);return this.h.push({message:N,offset:ie,lexeme:X,additionalInfo:U}),a.c}C(M){return this.D().type===M}D(){return this.f[this.g]}E(){return this.D().type===A.TokenType.EOF}}e.$Fj=a;class t{static false(){return h.INSTANCE}static true(){return P.INSTANCE}static has(M){return w.create(M)}static equals(M,Z){return D.create(M,Z)}static notEquals(M,Z){return T.create(M,Z)}static regex(M,Z){return Y.create(M,Z)}static in(M,Z){return L.create(M,Z)}static notIn(M,Z){return R.create(M,Z)}static not(M){return j.create(M)}static and(...M){return C.create(M,null,!0)}static or(...M){return W.create(M,null,!0)}static greater(M,Z){return q.create(M,Z)}static greaterEquals(M,Z){return Q.create(M,Z)}static smaller(M,Z){return de.create(M,Z)}static smallerEquals(M,Z){return V.create(M,Z)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(M){return M==null?void 0:this.c.parse(M)}}e.$Gj=t;function o(J){const M=new a({regexParsingWithErrorRecovery:!1});return J.map(Z=>(M.parse(Z),M.lexingErrors.length>0?M.lexingErrors.map(U=>({errorMessage:U.additionalInfo?(0,I.localize)(1682,null,U.additionalInfo):(0,I.localize)(1683,null),offset:U.offset,length:U.lexeme.length})):M.parsingErrors.length>0?M.parsingErrors.map(U=>({errorMessage:U.additionalInfo?`${U.message}. ${U.additionalInfo}`:U.message,offset:U.offset,length:U.lexeme.length})):[]))}function n(J,M){const Z=J?J.substituteConstants():void 0,U=M?M.substituteConstants():void 0;return!Z&&!U?!0:!Z||!U?!1:Z.equals(U)}function c(J,M){return J.cmp(M)}class h{static{this.INSTANCE=new h}constructor(){this.type=$.False}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!1}serialize(){return"false"}keys(){return[]}map(M){return this}negate(){return P.INSTANCE}}e.$Jj=h;class P{static{this.INSTANCE=new P}constructor(){this.type=$.True}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!0}serialize(){return"true"}keys(){return[]}map(M){return this}negate(){return h.INSTANCE}}e.$Kj=P;class w{static create(M,Z=null){const U=l.get(M);return typeof U=="boolean"?U?P.INSTANCE:h.INSTANCE:new w(M,Z)}constructor(M,Z){this.key=M,this.c=Z,this.type=$.Defined}cmp(M){return M.type!==this.type?this.type-M.type:H(this.key,M.key)}equals(M){return M.type===this.type?this.key===M.key:!1}substituteConstants(){const M=l.get(this.key);return typeof M=="boolean"?M?P.INSTANCE:h.INSTANCE:this}evaluate(M){return!!M.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(M){return M.mapDefined(this.key)}negate(){return this.c||(this.c=j.create(this.key,this)),this.c}}e.$Lj=w;class D{static create(M,Z,U=null){if(typeof Z=="boolean")return Z?w.create(M,U):j.create(M,U);const N=l.get(M);return typeof N=="boolean"?Z===(N?"true":"false")?P.INSTANCE:h.INSTANCE:new D(M,Z,U)}constructor(M,Z,U){this.c=M,this.d=Z,this.f=U,this.type=$.Equals}cmp(M){return M.type!==this.type?this.type-M.type:ne(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=l.get(this.c);if(typeof M=="boolean"){const Z=M?"true":"false";return this.d===Z?P.INSTANCE:h.INSTANCE}return this}evaluate(M){return M.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(M){return M.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Mj=D;class L{static create(M,Z){return new L(M,Z)}constructor(M,Z){this.d=M,this.f=Z,this.type=$.In,this.c=null}cmp(M){return M.type!==this.type?this.type-M.type:ne(this.d,this.f,M.d,M.f)}equals(M){return M.type===this.type?this.d===M.d&&this.f===M.f:!1}substituteConstants(){return this}evaluate(M){const Z=M.getValue(this.f),U=M.getValue(this.d);return Array.isArray(Z)?Z.includes(U):typeof U=="string"&&typeof Z=="object"&&Z!==null?u.call(Z,U):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(M){return M.mapIn(this.d,this.f)}negate(){return this.c||(this.c=R.create(this.d,this.f)),this.c}}e.$Nj=L;class R{static create(M,Z){return new R(M,Z)}constructor(M,Z){this.d=M,this.f=Z,this.type=$.NotIn,this.c=L.create(M,Z)}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(M){return M.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Oj=R;class T{static create(M,Z,U=null){if(typeof Z=="boolean")return Z?j.create(M,U):w.create(M,U);const N=l.get(M);return typeof N=="boolean"?Z===(N?"true":"false")?h.INSTANCE:P.INSTANCE:new T(M,Z,U)}constructor(M,Z,U){this.c=M,this.d=Z,this.f=U,this.type=$.NotEquals}cmp(M){return M.type!==this.type?this.type-M.type:ne(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=l.get(this.c);if(typeof M=="boolean"){const Z=M?"true":"false";return this.d===Z?h.INSTANCE:P.INSTANCE}return this}evaluate(M){return M.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(M){return M.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$Pj=T;class j{static create(M,Z=null){const U=l.get(M);return typeof U=="boolean"?U?h.INSTANCE:P.INSTANCE:new j(M,Z)}constructor(M,Z){this.c=M,this.d=Z,this.type=$.Not}cmp(M){return M.type!==this.type?this.type-M.type:H(this.c,M.c)}equals(M){return M.type===this.type?this.c===M.c:!1}substituteConstants(){const M=l.get(this.c);return typeof M=="boolean"?M?h.INSTANCE:P.INSTANCE:this}evaluate(M){return!M.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(M){return M.mapNot(this.c)}negate(){return this.d||(this.d=w.create(this.c,this)),this.d}}e.$Qj=j;function G(J,M){if(typeof J=="string"){const Z=parseFloat(J);isNaN(Z)||(J=Z)}return typeof J=="string"||typeof J=="number"?M(J):h.INSTANCE}class q{static create(M,Z,U=null){return G(Z,N=>new q(M,N,U))}constructor(M,Z,U){this.c=M,this.d=Z,this.f=U,this.type=$.Greater}cmp(M){return M.type!==this.type?this.type-M.type:ne(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Rj=q;class Q{static create(M,Z,U=null){return G(Z,N=>new Q(M,N,U))}constructor(M,Z,U){this.c=M,this.d=Z,this.f=U,this.type=$.GreaterEquals}cmp(M){return M.type!==this.type?this.type-M.type:ne(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=de.create(this.c,this.d,this)),this.f}}e.$Sj=Q;class de{static create(M,Z,U=null){return G(Z,N=>new de(M,N,U))}constructor(M,Z,U){this.c=M,this.d=Z,this.f=U,this.type=$.Smaller}cmp(M){return M.type!==this.type?this.type-M.type:ne(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=Q.create(this.c,this.d,this)),this.f}}e.$Tj=de;class V{static create(M,Z,U=null){return G(Z,N=>new V(M,N,U))}constructor(M,Z,U){this.c=M,this.d=Z,this.f=U,this.type=$.SmallerEquals}cmp(M){return M.type!==this.type?this.type-M.type:ne(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Uj=V;class Y{static create(M,Z){return new Y(M,Z)}constructor(M,Z){this.d=M,this.f=Z,this.type=$.Regex,this.c=null}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.d<M.d)return-1;if(this.d>M.d)return 1;const Z=this.f?this.f.source:"",U=M.f?M.f.source:"";return Z<U?-1:Z>U?1:0}equals(M){if(M.type===this.type){const Z=this.f?this.f.source:"",U=M.f?M.f.source:"";return this.d===M.d&&Z===U}return!1}substituteConstants(){return this}evaluate(M){const Z=M.getValue(this.d);return this.f?this.f.test(Z):!1}serialize(){const M=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${M}`}keys(){return[this.d]}map(M){return M.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=B.create(this)),this.c}}e.$Vj=Y;class B{static create(M){return new B(M)}constructor(M){this.c=M,this.type=$.NotRegex}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(M){return new B(this.c.map(M))}negate(){return this.c}}e.$Wj=B;function _(J){let M=null;for(let Z=0,U=J.length;Z<U;Z++){const N=J[Z].substituteConstants();if(J[Z]!==N&&M===null){M=[];for(let ie=0;ie<Z;ie++)M[ie]=J[ie]}M!==null&&(M[Z]=N)}return M===null?J:M}class C{static create(M,Z,U){return C.d(M,Z,U)}constructor(M,Z){this.expr=M,this.c=Z,this.type=$.And}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let Z=0,U=this.expr.length;Z<U;Z++){const N=c(this.expr[Z],M.expr[Z]);if(N!==0)return N}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let Z=0,U=this.expr.length;Z<U;Z++)if(!this.expr[Z].equals(M.expr[Z]))return!1;return!0}return!1}substituteConstants(){const M=_(this.expr);return M===this.expr?this:C.create(M,this.c,!1)}evaluate(M){for(let Z=0,U=this.expr.length;Z<U;Z++)if(!this.expr[Z].evaluate(M))return!1;return!0}static d(M,Z,U){const N=[];let ie=!1;for(const X of M)if(X){if(X.type===$.True){ie=!0;continue}if(X.type===$.False)return h.INSTANCE;if(X.type===$.And){N.push(...X.expr);continue}N.push(X)}if(N.length===0&&ie)return P.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(c);for(let X=1;X<N.length;X++)N[X-1].equals(N[X])&&(N.splice(X,1),X--);if(N.length===1)return N[0];for(;N.length>1;){const X=N[N.length-1];if(X.type!==$.Or)break;N.pop();const z=N.pop(),te=N.length===0,ae=W.create(X.expr.map(me=>C.create([me,z],null,U)),null,te);ae&&(N.push(ae),N.sort(c))}if(N.length===1)return N[0];if(U){for(let X=0;X<N.length;X++)for(let z=X+1;z<N.length;z++)if(N[X].negate().equals(N[z]))return h.INSTANCE;if(N.length===1)return N[0]}return new C(N,Z)}}serialize(){return this.expr.map(M=>M.serialize()).join(" && ")}keys(){const M=[];for(const Z of this.expr)M.push(...Z.keys());return M}map(M){return new C(this.expr.map(Z=>Z.map(M)),null)}negate(){if(!this.c){const M=[];for(const Z of this.expr)M.push(Z.negate());this.c=W.create(M,this,!0)}return this.c}}e.$Xj=C;class W{static create(M,Z,U){return W.d(M,Z,U)}constructor(M,Z){this.expr=M,this.c=Z,this.type=$.Or}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let Z=0,U=this.expr.length;Z<U;Z++){const N=c(this.expr[Z],M.expr[Z]);if(N!==0)return N}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let Z=0,U=this.expr.length;Z<U;Z++)if(!this.expr[Z].equals(M.expr[Z]))return!1;return!0}return!1}substituteConstants(){const M=_(this.expr);return M===this.expr?this:W.create(M,this.c,!1)}evaluate(M){for(let Z=0,U=this.expr.length;Z<U;Z++)if(this.expr[Z].evaluate(M))return!0;return!1}static d(M,Z,U){let N=[],ie=!1;if(M){for(let X=0,z=M.length;X<z;X++){const te=M[X];if(te){if(te.type===$.False){ie=!0;continue}if(te.type===$.True)return P.INSTANCE;if(te.type===$.Or){N=N.concat(te.expr);continue}N.push(te)}}if(N.length===0&&ie)return h.INSTANCE;N.sort(c)}if(N.length!==0){if(N.length===1)return N[0];for(let X=1;X<N.length;X++)N[X-1].equals(N[X])&&(N.splice(X,1),X--);if(N.length===1)return N[0];if(U){for(let X=0;X<N.length;X++)for(let z=X+1;z<N.length;z++)if(N[X].negate().equals(N[z]))return P.INSTANCE;if(N.length===1)return N[0]}return new W(N,Z)}}serialize(){return this.expr.map(M=>M.serialize()).join(" || ")}keys(){const M=[];for(const Z of this.expr)M.push(...Z.keys());return M}map(M){return new W(this.expr.map(Z=>Z.map(M)),null)}negate(){if(!this.c){const M=[];for(const Z of this.expr)M.push(Z.negate());for(;M.length>1;){const Z=M.shift(),U=M.shift(),N=[];for(const ie of oe(Z))for(const X of oe(U))N.push(C.create([ie,X],null,!1));M.unshift(W.create(N,null,!1))}this.c=W.create(M,this,!0)}return this.c}}e.$Yj=W;class F extends w{static{this.d=[]}static all(){return F.d.values()}constructor(M,Z,U){super(M,null),this.f=Z,typeof U=="object"?F.d.push({...U,key:M}):U!==!0&&F.d.push({key:M,description:U,type:Z!=null?typeof Z:void 0})}bindTo(M){return M.createKey(this.key,this.f)}getValue(M){return M.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(M){return D.create(this.key,M)}notEqualsTo(M){return T.create(this.key,M)}}e.$Zj=F,e.$1j=(0,O.$Ii)("contextKeyService");function H(J,M){return J<M?-1:J>M?1:0}function ne(J,M,Z,U){return J<Z?-1:J>Z?1:M<U?-1:M>U?1:0}function x(J,M){if(J.type===$.False||M.type===$.True)return!0;if(J.type===$.Or)return M.type===$.Or?ce(J.expr,M.expr):!1;if(M.type===$.Or){for(const Z of M.expr)if(x(J,Z))return!0;return!1}if(J.type===$.And){if(M.type===$.And)return ce(M.expr,J.expr);for(const Z of J.expr)if(x(Z,M))return!0;return!1}return J.equals(M)}function ce(J,M){let Z=0,U=0;for(;Z<J.length&&U<M.length;){const N=J[Z].cmp(M[U]);if(N<0)return!1;N===0&&Z++,U++}return Z===J.length}function oe(J){return J.type===$.Or?J.expr:[J]}}),define(le[99],ue([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=e.$Wm=e.ID=void 0,e.$Xm=r,e.ID="diagnosticsService",e.$Wm=(0,i.$Ii)(e.ID);function r(A){return!!A.hostName&&!!A.errorMessage}class v{async getPerformanceInfo(O,I){return{}}async getSystemInfo(O,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(O,I){return""}async getWorkspaceFileExtensions(O){return{extensions:[]}}async reportWorkspaceStats(O){}}e.$Ym=v});var xe=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[125],ue([0,1,18,82,10,6,48,3,38]),function(K,e,i,r,v,A,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$gx=e.$fx=e.$ex=void 0,e.$hx=p,e.$ix=d,r=xe(r),e.$ex=(0,A.$Ii)("dialogService");var l;(function(f){f[f.Confirmation=1]="Confirmation",f[f.Prompt=2]="Prompt",f[f.Input=3]="Input"})(l||(l={}));class m{a(y){return this.d(y,l.Confirmation)}b(y){return this.d(y,l.Prompt)}c(y){return this.d(y,l.Input)}d(y,k){const g=[];switch(k){case l.Confirmation:{const E=y;E.primaryButton?g.push(E.primaryButton):g.push((0,v.localize)(1698,null)),E.cancelButton?g.push(E.cancelButton):g.push((0,v.localize)(1699,null));break}case l.Prompt:{const E=y;Array.isArray(E.buttons)&&E.buttons.length>0&&g.push(...E.buttons.map(S=>S.label)),E.cancelButton&&(E.cancelButton===!0?g.push((0,v.localize)(1700,null)):typeof E.cancelButton=="string"?g.push(E.cancelButton):E.cancelButton.label?g.push(E.cancelButton.label):g.push((0,v.localize)(1701,null))),g.length===0&&g.push((0,v.localize)(1702,null));break}case l.Input:{const E=y;E.primaryButton?g.push(E.primaryButton):g.push((0,v.localize)(1703,null)),E.cancelButton?g.push(E.cancelButton):g.push((0,v.localize)(1704,null));break}}return g}e(y){if(typeof y=="string")return y;if(typeof y=="number")return y===r.default.Info?"info":y===r.default.Error?"error":y===r.default.Warning?"warning":"none"}f(y,k,g){const E=[...y.buttons??[]];y.cancelButton&&typeof y.cancelButton!="string"&&typeof y.cancelButton!="boolean"&&E.push(y.cancelButton);let S=E[k]?.run({checkboxChecked:g});return S instanceof Promise||(S=Promise.resolve(S)),{result:S,checkboxChecked:g}}}e.$fx=m,e.$gx=(0,A.$Ii)("fileDialogService");var u;(function(f){f[f.SAVE=0]="SAVE",f[f.DONT_SAVE=1]="DONT_SAVE",f[f.CANCEL=2]="CANCEL"})(u||(e.ConfirmResult=u={}));const $=10;function p(f){const y=[];return y.push(...f.slice(0,$).map(k=>typeof k=="string"?k:(0,i.$gh)(k))),f.length>$&&(f.length-$===1?y.push((0,v.localize)(1705,null)):y.push((0,v.localize)(1706,null,f.length-$))),y.push(""),y.join(`
`)}function d(f,y){const k=(0,b.$io)(f);let g=(k.buttons??[]).map(a=>(0,O.$bx)(a)),E=(f.buttons||[]).map((a,t)=>t),S=0,s=k.cancelId??g.length-1;if(g.length>1){const a=typeof s=="number"?g[s]:void 0;if(I.$l||I.$k){if(typeof a=="string"&&g.length>1&&s!==1){g.splice(s,1),g.splice(1,0,a);const t=E[s];E.splice(s,1),E.splice(1,0,t),s=1}I.$l&&g.length>1&&(g=g.reverse(),E=E.reverse(),S=g.length-1,typeof a=="string"&&(s=S-1))}else if(I.$j&&typeof a=="string"&&g.length>1&&s!==g.length-1){g.splice(s,1),g.push(a);const t=E[s];E.splice(s,1),E.push(t),s=g.length-1}}return k.buttons=g,k.defaultId=S,k.cancelId=s,k.noLink=!0,k.title=k.title||y.nameLong,{options:k,buttonIndeces:E}}}),define(le[100],ue([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$2Y=e.$1Y=void 0,e.$3Y=A,e.$4Y=O,e.$1Y=(0,i.$Ii)("encryptionService"),e.$2Y=(0,i.$Ii)("encryptionMainService");var r;(function(I){I.kwallet="kwallet",I.kwallet5="kwallet5",I.gnomeLibsecret="gnome-libsecret",I.basic="basic"})(r||(e.PasswordStoreCLIOption=r={}));var v;(function(I){I.unknown="unknown",I.basicText="basic_text",I.gnomeAny="gnome_any",I.gnomeLibsecret="gnome_libsecret",I.gnomeKeyring="gnome_keyring",I.kwallet="kwallet",I.kwallet5="kwallet5",I.kwallet6="kwallet6",I.dplib="dpapi",I.keychainAccess="keychain_access"})(v||(e.KnownStorageProvider=v={}));function A(I){return I===v.kwallet||I===v.kwallet5||I===v.kwallet6}function O(I){return I===v.gnomeAny||I===v.gnomeLibsecret||I===v.gnomeKeyring}}),define(le[36],ue([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=void 0,e.$Pi=(0,i.$Ii)("environmentService"),e.$Qi=(0,i.$Ji)(e.$Pi)}),define(le[178],ue([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bhc=e.$Ahc=void 0,e.$Ahc=(0,i.$Ii)("extensionHostStarter"),e.$Bhc="extensionHostStarter"}),define(le[179],ue([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K$b=e.$J$b=void 0,e.$J$b=(0,i.$Ii)("externalTerminal"),e.$K$b="Terminal.app"}),define(le[180],ue([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dhc=void 0,e.$Dhc=(0,i.$Ii)("externalTerminal")}),define(le[181],ue([0,1,44,54,11,9,3,80,23,96,10,179]),function(K,e,i,r,v,A,O,I,b,l,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ghc=e.$Fhc=e.$Ehc=void 0,i=Ie(i),A=Ie(A),O=Ie(O),b=Ie(b),l=Ie(l),m=Ie(m);const $=m.localize(1851,null);class p{async getDefaultTerminalForPlatforms(){return{windows:d.getDefaultTerminalWindows(),linux:await y.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class d extends p{static{this.b="cmd.exe"}openTerminal(s,a){return this.spawnTerminal(i,s,l.$Bm(),a)}spawnTerminal(s,a,t,o){const n=a.windowsExec||d.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const c=A.$qc(n,".exe").toLowerCase();if(c==="cmder")return s.spawn(n,o?[o]:void 0),Promise.resolve(void 0);const h=["/c","start","/wait"];return n.indexOf(" ")>=0&&h.push(n),h.push(n),c==="wt"&&h.push("-d ."),new Promise((P,w)=>{const D=k(process),L=s.spawn(t,h,{cwd:o,env:D,detached:!0});L.on("error",w),L.on("exit",()=>P())})}async runInTerminal(s,a,t,o,n){const c="windowsExec"in n&&n.windowsExec?n.windowsExec:d.getDefaultTerminalWindows(),h=await d.f();return new Promise((P,w)=>{const D=`"${a} - ${$}"`,L=`"${t.join('" "')}" & pause`,R=Object.assign({},k(process),o);Object.keys(R).filter(Q=>R[Q]===null).forEach(Q=>delete R[Q]);const T={cwd:a,env:R,windowsVerbatimArguments:!0};let j,G;A.$qc(c,".exe")==="wt"?(j=c,G=["-d",".",d.b,"/c",L]):h?(j=h,G=["-d",".",c,"/c",L]):(j=d.b,G=["/c","start",D,"/wait",c,"/c",`"${L}"`]),i.spawn(j,G,T).on("error",Q=>{w(g(Q))}),P(void 0)})}static getDefaultTerminalWindows(){if(!d.d){const s=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");d.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${s?"Sysnative":"System32"}\\cmd.exe`}return d.d}static async f(){try{const s=await l.win32.findExecutable("wt");return await b.Promises.exists(s)?s:void 0}catch{return}}}e.$Ehc=d,ke([r.$ai],d,"f",null);class f extends p{static{this.b="/usr/bin/osascript"}openTerminal(s,a){return this.spawnTerminal(i,s,a)}runInTerminal(s,a,t,o,n){const c=n.osxExec||u.$K$b;return new Promise((h,P)=>{if(c===u.$K$b||c==="iTerm.app"){const w=c===u.$K$b?"TerminalHelper":"iTermHelper",L=[v.$3g.asFileUri(`vs/workbench/contrib/externalTerminal/node/${w}.scpt`).fsPath,"-t",s||$,"-w",a];for(const j of t)L.push("-a"),L.push(j);if(o){const j=Object.assign({},k(process),o);for(const G in j){const q=j[G];q===null?(L.push("-u"),L.push(G)):(L.push("-e"),L.push(`${G}=${q}`))}}let R="";const T=i.spawn(f.b,L);T.on("error",j=>{P(g(j))}),T.stderr.on("data",j=>{R+=j.toString()}),T.on("exit",j=>{if(j===0)h(void 0);else if(R){const G=R.split(`
`,1);P(new Error(G[0]))}else P(new Error(m.localize(1852,null,w,j)))})}else P(new Error(m.localize(1853,null,c)))})}spawnTerminal(s,a,t){const o=a.osxExec||u.$K$b;return new Promise((n,c)=>{const h=["-a",o];t&&h.push(t);const P=k(process),w=s.spawn("/usr/bin/open",h,{cwd:t,env:P});w.on("error",c),w.on("exit",()=>n())})}}e.$Fhc=f;class y extends p{static{this.b=m.localize(1854,null)}openTerminal(s,a){return this.spawnTerminal(i,s,a)}runInTerminal(s,a,t,o,n){const c=n.linuxExec?Promise.resolve(n.linuxExec):y.getDefaultTerminalLinuxReady();return new Promise((h,P)=>{const w=[];c.then(D=>{D.indexOf("gnome-terminal")>=0?w.push("-x"):w.push("-e"),w.push("bash"),w.push("-c");const L=`${E(t)}; echo; read -p "${y.b}" -n1;`;w.push(`''${L}''`);const R=Object.assign({},k(process),o);Object.keys(R).filter(q=>R[q]===null).forEach(q=>delete R[q]);const T={cwd:a,env:R};let j="";const G=i.spawn(D,w,T);G.on("error",q=>{P(g(q))}),G.stderr.on("data",q=>{j+=q.toString()}),G.on("exit",q=>{if(q===0)h(void 0);else if(j){const Q=j.split(`
`,1);P(new Error(Q[0]))}else P(new Error(m.localize(1855,null,D,q)))})})})}static async getDefaultTerminalLinuxReady(){if(!y.d)if(!O.$l)y.d=Promise.resolve("xterm");else{const s=await b.Promises.exists("/etc/debian_version");y.d=new Promise(a=>{s?a("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?a("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?a("konsole"):process.env.COLORTERM?a(process.env.COLORTERM):process.env.TERM?a(process.env.TERM):a("xterm")})}return y.d}spawnTerminal(s,a,t){const o=a.linuxExec?Promise.resolve(a.linuxExec):y.getDefaultTerminalLinuxReady();return new Promise((n,c)=>{o.then(h=>{const P=k(process),w=s.spawn(h,[],{cwd:t,env:P});w.on("error",c),w.on("exit",()=>n())})})}}e.$Ghc=y;function k(S){const s={...S.env};return(0,I.$om)(s),s}function g(S){return"errno"in S&&S.errno==="ENOENT"&&"path"in S&&typeof S.path=="string"?new Error(m.localize(1856,null,S.path)):S}function E(S){let s="";for(const a of S)a.indexOf(" ")>=0?s+='"'+a+'"':s+=a,s+=" ";return s}}),define(le[14],ue([0,1,61,9,25,12,7,10,6,3,11,68]),function(K,e,i,r,v,A,O,I,b,l,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=e.$Il=e.FileKind=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=e.$Cl=e.$Bl=e.FileOperationResult=e.$Al=e.$zl=e.$yl=e.$wl=e.FileChangeType=e.$vl=e.FileOperation=e.$pl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$dl=void 0,e.$el=$,e.$fl=y,e.$gl=g,e.$hl=E,e.$il=S,e.$jl=s,e.$kl=a,e.$ll=t,e.$ml=o,e.$nl=n,e.$ol=c,e.$ql=w,e.$rl=D,e.$sl=L,e.$tl=R,e.$ul=T,e.$xl=de,e.$Jl=W,e.$Kl=F,e.$Ml=ne,e.$dl=(0,b.$Ii)("fileService");function $(x){return x.create===!0}var p;(function(x){x[x.Unknown=0]="Unknown",x[x.File=1]="File",x[x.Directory=2]="Directory",x[x.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var d;(function(x){x[x.Readonly=1]="Readonly",x[x.Locked=2]="Locked"})(d||(e.FilePermission=d={}));var f;(function(x){x[x.UPDATED=2]="UPDATED",x[x.ADDED=4]="ADDED",x[x.DELETED=8]="DELETED"})(f||(e.FileChangeFilter=f={}));function y(x){const ce=x;return!!ce&&typeof ce.onDidChange=="function"}var k;(function(x){x[x.None=0]="None",x[x.FileReadWrite=2]="FileReadWrite",x[x.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",x[x.FileReadStream=16]="FileReadStream",x[x.FileFolderCopy=8]="FileFolderCopy",x[x.PathCaseSensitive=1024]="PathCaseSensitive",x[x.Readonly=2048]="Readonly",x[x.Trash=4096]="Trash",x[x.FileWriteUnlock=8192]="FileWriteUnlock",x[x.FileAtomicRead=16384]="FileAtomicRead",x[x.FileAtomicWrite=32768]="FileAtomicWrite",x[x.FileAtomicDelete=65536]="FileAtomicDelete",x[x.FileClone=131072]="FileClone"})(k||(e.FileSystemProviderCapabilities=k={}));function g(x){return!!(x.capabilities&k.FileReadWrite)}function E(x){return!!(x.capabilities&k.FileFolderCopy)}function S(x){return!!(x.capabilities&k.FileClone)}function s(x){return!!(x.capabilities&k.FileOpenReadWriteClose)}function a(x){return!!(x.capabilities&k.FileReadStream)}function t(x){return g(x)?!!(x.capabilities&k.FileAtomicRead):!1}function o(x){return g(x)?!!(x.capabilities&k.FileAtomicWrite):!1}function n(x){return!!(x.capabilities&k.FileAtomicDelete)}function c(x){return!!(x.capabilities&k.Readonly)}var h;(function(x){x.FileExists="EntryExists",x.FileNotFound="EntryNotFound",x.FileNotADirectory="EntryNotADirectory",x.FileIsADirectory="EntryIsADirectory",x.FileExceedsStorageQuota="EntryExceedsStorageQuota",x.FileTooLarge="EntryTooLarge",x.FileWriteLocked="EntryWriteLocked",x.NoPermissions="NoPermissions",x.Unavailable="Unavailable",x.Unknown="Unknown"})(h||(e.FileSystemProviderErrorCode=h={}));class P extends Error{static create(ce,oe){const J=new P(ce.toString(),oe);return L(J,oe),J}constructor(ce,oe){super(ce),this.code=oe}}e.$pl=P;function w(x,ce){return P.create(x,ce)}function D(x){return x||w((0,I.localize)(1865,null),h.Unknown)}function L(x,ce){return x.name=ce?`${ce} (FileSystemError)`:"FileSystemError",x}function R(x){if(!x)return h.Unknown;if(x instanceof P)return x.code;const ce=/^(.+) \(FileSystemError\)$/.exec(x.name);if(!ce)return h.Unknown;switch(ce[1]){case h.FileExists:return h.FileExists;case h.FileIsADirectory:return h.FileIsADirectory;case h.FileNotADirectory:return h.FileNotADirectory;case h.FileNotFound:return h.FileNotFound;case h.FileTooLarge:return h.FileTooLarge;case h.FileWriteLocked:return h.FileWriteLocked;case h.NoPermissions:return h.NoPermissions;case h.Unavailable:return h.Unavailable}return h.Unknown}function T(x){if(x instanceof V)return x.fileOperationResult;switch(R(x)){case h.FileNotFound:return _.FILE_NOT_FOUND;case h.FileIsADirectory:return _.FILE_IS_DIRECTORY;case h.FileNotADirectory:return _.FILE_NOT_DIRECTORY;case h.FileWriteLocked:return _.FILE_WRITE_LOCKED;case h.NoPermissions:return _.FILE_PERMISSION_DENIED;case h.FileExists:return _.FILE_MOVE_CONFLICT;case h.FileTooLarge:return _.FILE_TOO_LARGE;default:return _.FILE_OTHER_ERROR}}var j;(function(x){x[x.CREATE=0]="CREATE",x[x.DELETE=1]="DELETE",x[x.MOVE=2]="MOVE",x[x.COPY=3]="COPY",x[x.WRITE=4]="WRITE"})(j||(e.FileOperation=j={}));class G{constructor(ce,oe,J){this.resource=ce,this.operation=oe,this.target=J}isOperation(ce){return this.operation===ce}}e.$vl=G;var q;(function(x){x[x.UPDATED=0]="UPDATED",x[x.ADDED=1]="ADDED",x[x.DELETED=2]="DELETED"})(q||(e.FileChangeType=q={}));class Q{static{this.a=null}constructor(ce,oe){this.c=oe,this.b=void 0,this.d=new u.$W(()=>{const J=i.$Oi.forUris(()=>this.c);return J.fill(this.rawAdded.map(M=>[M,!0])),J}),this.f=new u.$W(()=>{const J=i.$Oi.forUris(()=>this.c);return J.fill(this.rawUpdated.map(M=>[M,!0])),J}),this.g=new u.$W(()=>{const J=i.$Oi.forUris(()=>this.c);return J.fill(this.rawDeleted.map(M=>[M,!0])),J}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const J of ce){switch(J.type){case q.ADDED:this.rawAdded.push(J.resource);break;case q.UPDATED:this.rawUpdated.push(J.resource);break;case q.DELETED:this.rawDeleted.push(J.resource);break}this.b!==Q.a&&(typeof J.cId=="number"?this.b===void 0?this.b=J.cId:this.b!==J.cId&&(this.b=Q.a):this.b!==void 0&&(this.b=Q.a))}}contains(ce,...oe){return this.h(ce,{includeChildren:!1},...oe)}affects(ce,...oe){return this.h(ce,{includeChildren:!0},...oe)}h(ce,oe,...J){if(!ce)return!1;const M=J.length>0;return!!((!M||J.includes(q.ADDED))&&(this.d.value.get(ce)||oe.includeChildren&&this.d.value.findSuperstr(ce))||(!M||J.includes(q.UPDATED))&&(this.f.value.get(ce)||oe.includeChildren&&this.f.value.findSuperstr(ce))||(!M||J.includes(q.DELETED))&&(this.g.value.findSubstr(ce)||oe.includeChildren&&this.g.value.findSuperstr(ce)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ce){return this.b===ce}hasCorrelation(){return typeof this.b=="number"}}e.$wl=Q;function de(x,ce,oe){return!x||!ce||x===ce||ce.length>x.length?!1:(ce.charAt(ce.length-1)!==r.sep&&(ce+=r.sep),oe?(0,v.$Jf)(x,ce):x.indexOf(ce)===0)}class V extends Error{constructor(ce,oe,J){super(ce),this.fileOperationResult=oe,this.options=J}}e.$yl=V;class Y extends V{constructor(ce,oe,J,M){super(ce,oe,M),this.fileOperationResult=oe,this.size=J}}e.$zl=Y;class B extends V{constructor(ce,oe,J){super(ce,_.FILE_NOT_MODIFIED_SINCE,J),this.stat=oe}}e.$Al=B;var _;(function(x){x[x.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",x[x.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",x[x.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",x[x.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",x[x.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",x[x.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",x[x.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",x[x.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",x[x.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",x[x.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",x[x.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(_||(e.FileOperationResult=_={})),e.$Bl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Cl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Dl="files.associations",e.$El="files.exclude",e.$Fl="files.readonlyInclude",e.$Gl="files.readonlyExclude",e.$Hl="files.readonlyFromPermissions";var C;(function(x){x[x.FILE=0]="FILE",x[x.FOLDER=1]="FOLDER",x[x.ROOT_FOLDER=2]="ROOT_FOLDER"})(C||(e.FileKind=C={})),e.$Il="";function W(x){if(!(typeof x.size!="number"||typeof x.mtime!="number"))return x.mtime.toString(29)+x.size.toString(31)}async function F(x,ce){if(!ce.hasProvider(O.URI.from({scheme:x.scheme})))return new Promise(oe=>{const J=ce.onDidChangeFileSystemProviderRegistrations(M=>{M.scheme===x.scheme&&M.added&&(J.dispose(),oe())})})}class H{static{this.KB=1024}static{this.MB=H.KB*H.KB}static{this.GB=H.MB*H.KB}static{this.TB=H.GB*H.KB}static formatSize(ce){return(0,A.$lg)(ce)||(ce=0),ce<H.KB?(0,I.localize)(1866,null,ce.toFixed(0)):ce<H.MB?(0,I.localize)(1867,null,(ce/H.KB).toFixed(2)):ce<H.GB?(0,I.localize)(1868,null,(ce/H.MB).toFixed(2)):ce<H.TB?(0,I.localize)(1869,null,(ce/H.GB).toFixed(2)):(0,I.localize)(1870,null,(ce/H.TB).toFixed(2))}}e.$Ll=H;function ne(x){const ce=typeof x=="string"||x?.scheme===m.Schemas.vscodeRemote;return typeof x!="string"&&x?.scheme===m.Schemas.file?1024*H.MB:ce?10*H.MB:l.$p?50*H.MB:1024*H.MB}}),define(le[126],ue([0,1,17,15,10,14]),function(K,e,i,r,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=O;async function O(m,u,$,p,d,f){let y;try{await I(m,u,$,p,d,f)}catch(k){y=k}finally{y&&d.errorTransformer&&(y=d.errorTransformer(y)),typeof y<"u"&&$.error(y),$.end()}}async function I(m,u,$,p,d,f){b(f);const y=await m.open(u,{create:!1});try{b(f);let k=0,g=0,E=d&&typeof d.length=="number"?d.length:void 0,S=i.$Qe.alloc(Math.min(d.bufferSize,typeof E=="number"?E:d.bufferSize)),s=d&&typeof d.position=="number"?d.position:0,a=0;do g=await m.read(y,s,S.buffer,a,S.byteLength-a),s+=g,a+=g,k+=g,typeof E=="number"&&(E-=g),a===S.byteLength&&(await $.write(p(S)),S=i.$Qe.alloc(Math.min(d.bufferSize,typeof E=="number"?E:d.bufferSize)),a=0);while(g>0&&(typeof E!="number"||E>0)&&b(f)&&l(k,d));if(a>0){let t=a;typeof E=="number"&&(t=Math.min(a,E)),$.write(p(S.slice(0,t)))}}catch(k){throw(0,A.$rl)(k)}finally{await m.close(y)}}function b(m){if(m.isCancellationRequested)throw(0,r.$8)();return!0}function l(m,u){if(typeof u?.limits?.size=="number"&&m>u.limits.size)throw(0,A.$ql)((0,v.localize)(1898,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(le[62],ue([0,1,114,2,9,3,7,14]),function(K,e,i,r,v,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=e.$ar=e.$_q=void 0,e.$0q=b,e.$$q=l,e.$cr=p,e.$dr=d,e.$er=f,e.$fr=y,e.$gr=g,e.$hr=E;function b(S){return typeof S.correlationId=="number"}function l(S){return S.recursive===!0}class m extends r.$Xc{static{this.a=5}constructor(s,a,t,o){super(),this.h=s,this.j=a,this.m=t,this.n=o,this.c=this.B(new r.$Yc),this.f=void 0,this.g=0}s(){const s=new r.$Wc;this.c.value=s,this.b=this.r(s),this.b.setVerboseLogging(this.m),s.add(this.b.onDidChangeFile(a=>this.h(a))),s.add(this.b.onDidLogMessage(a=>this.j(a))),s.add(this.b.onDidError(a=>this.t(a.error,a.request)))}t(s,a){this.u(s,a)?this.g<m.a&&this.f?(this.y(`restarting watcher after unexpected error: ${s}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${s}`):this.y(s)}u(s,a){return!(!this.n.restartOnError||a||s.indexOf("No space left on device")!==-1||s.indexOf("EMFILE")!==-1)}w(s){this.g++,this.s(),this.watch(s)}async watch(s){this.f=s,await this.b?.watch(s)}async setVerboseLogging(s){this.m=s,await this.b?.setVerboseLogging(s)}y(s){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${s}`})}z(s){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${s}`})}dispose(){return this.b=void 0,super.dispose()}}e.$_q=m;class u extends m{constructor(s,a,t){super(s,a,t,{type:"node.js",restartOnError:!1})}}e.$ar=u;class $ extends m{constructor(s,a,t){super(s,a,t,{type:"universal",restartOnError:!0})}}e.$br=$;function p(S){return S.map(s=>({type:s.type,resource:O.URI.revive(s.resource),cId:s.cId}))}function d(S){const s=new k;for(const a of S)s.processEvent(a);return s.coalesce()}function f(S,s){return typeof s=="string"&&!s.startsWith(i.$zk)&&!(0,v.$lc)(s)?{base:S,pattern:s}:s}function y(S,s){const a=[];for(const t of s)a.push((0,i.$Dk)(f(S,t)));return a}class k{constructor(){this.a=new Set,this.b=new Map}c(s){return A.$l?s.resource.fsPath:s.resource.fsPath.toLowerCase()}processEvent(s){const a=this.b.get(this.c(s));let t=!1;if(a){const o=a.type,n=s.type;a.resource.fsPath!==s.resource.fsPath&&(s.type===I.FileChangeType.DELETED||s.type===I.FileChangeType.ADDED)?t=!0:o===I.FileChangeType.ADDED&&n===I.FileChangeType.DELETED?(this.b.delete(this.c(s)),this.a.delete(a)):o===I.FileChangeType.DELETED&&n===I.FileChangeType.ADDED?a.type=I.FileChangeType.UPDATED:o===I.FileChangeType.ADDED&&n===I.FileChangeType.UPDATED||(a.type=n)}else t=!0;t&&(this.a.add(s),this.b.set(this.c(s),s))}coalesce(){const s=[],a=[];return Array.from(this.a).filter(t=>t.type!==I.FileChangeType.DELETED?(s.push(t),!1):!0).sort((t,o)=>t.resource.fsPath.length-o.resource.fsPath.length).filter(t=>a.some(o=>(0,I.$xl)(t.resource.fsPath,o,!A.$l))?!1:(a.push(t.resource.fsPath),!0)).concat(s)}}function g(S,s){if(typeof s=="number")switch(S.type){case I.FileChangeType.ADDED:return(s&I.FileChangeFilter.ADDED)===0;case I.FileChangeType.DELETED:return(s&I.FileChangeFilter.DELETED)===0;case I.FileChangeType.UPDATED:return(s&I.FileChangeFilter.UPDATED)===0}return!1}function E(S){if(typeof S=="number"){const s=[];return S&I.FileChangeFilter.ADDED&&s.push("Added"),S&I.FileChangeFilter.DELETED&&s.push("Deleted"),S&I.FileChangeFilter.UPDATED&&s.push("Updated"),s.length===0?"<all>":`[${s.join(", ")}]`}return"<none>"}}),define(le[182],ue([0,1,17,55,15,4,2,69,33,14,62]),function(K,e,i,r,v,A,O,I,b,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MR=e.$LR=void 0,e.$LR="localFilesystem";class u extends O.$Xc{constructor(p,d){super(),this.a=p,this.b=d,this.onDidChangeCapabilities=A.Event.None,this.f=this.B(new A.$oe),this.onDidChangeFile=this.f.event,this.g=this.B(new A.$oe),this.onDidWatchError=this.g.event,this.h=(0,b.$5g)(),this.j()}get capabilities(){return this.c||(this.c=l.FileSystemProviderCapabilities.FileReadWrite|l.FileSystemProviderCapabilities.FileOpenReadWriteClose|l.FileSystemProviderCapabilities.FileReadStream|l.FileSystemProviderCapabilities.FileFolderCopy|l.FileSystemProviderCapabilities.FileWriteUnlock|l.FileSystemProviderCapabilities.FileAtomicRead|l.FileSystemProviderCapabilities.FileAtomicWrite|l.FileSystemProviderCapabilities.FileAtomicDelete|l.FileSystemProviderCapabilities.FileClone,this.b.pathCaseSensitive&&(this.c|=l.FileSystemProviderCapabilities.PathCaseSensitive),this.b.trash&&(this.c|=l.FileSystemProviderCapabilities.Trash)),this.c}stat(p){return this.a.call("stat",[p])}readdir(p){return this.a.call("readdir",[p])}async readFile(p,d){const{buffer:f}=await this.a.call("readFile",[p,d]);return f}readFileStream(p,d,f){const y=(0,I.$Ee)(g=>i.$Qe.concat(g.map(E=>i.$Qe.wrap(E))).buffer),k=new O.$Wc;return k.add(this.a.listen("readFileStream",[p,d])(g=>{if(g instanceof i.$Qe)y.write(g.buffer);else{if(g==="end")y.end();else{let E;if(g instanceof Error)E=g;else{const S=g;E=(0,l.$ql)(S.message??(0,r.$tj)(S),S.code??l.FileSystemProviderErrorCode.Unknown)}y.error(E),y.end()}k.dispose()}})),k.add(f.onCancellationRequested(()=>{y.error((0,v.$8)()),y.end(),k.dispose()})),y}writeFile(p,d,f){return this.a.call("writeFile",[p,i.$Qe.wrap(d),f])}open(p,d){return this.a.call("open",[p,d])}close(p){return this.a.call("close",[p])}async read(p,d,f,y,k){const[g,E]=await this.a.call("read",[p,d,k]);return f.set(g.buffer.slice(0,E),y),E}write(p,d,f,y,k){return this.a.call("write",[p,d,i.$Qe.wrap(f),y,k])}mkdir(p){return this.a.call("mkdir",[p])}delete(p,d){return this.a.call("delete",[p,d])}rename(p,d,f){return this.a.call("rename",[p,d,f])}copy(p,d,f){return this.a.call("copy",[p,d,f])}cloneFile(p,d){return this.a.call("cloneFile",[p,d])}j(){this.B(this.a.listen("fileChange",[this.h])(p=>{if(Array.isArray(p)){const d=p;this.f.fire((0,m.$cr)(d))}else{const d=p;this.g.fire(d)}}))}watch(p,d){const f=(0,b.$5g)();return this.a.call("watch",[this.h,f,p,d]),(0,O.$Vc)(()=>this.a.call("unwatch",[this.h,f]))}}e.$MR=u}),define(le[183],ue([0,1,26,2,62,4,14,7,8]),function(K,e,i,r,v,A,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;class l extends r.$Xc{constructor(){super(),this.a=this.B(new A.$oe),this.onDidChangeFile=this.a.event,this.b=this.B(new A.$oe),this.onDidLogMessage=this.b.event,this.c=this.B(new A.$oe),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new r.$7c),this.m=new Set,this.n=this.B(new b.$Gh(this.y())),this.r=5007,this.s=new b.$6h,this.R=!1,this.B(this.f(u=>this.t(u)))}t(u){this.u(u)&&this.z(u)}u(u){return(0,v.$0q)(u)}async watch(u){this.s.isSettled||this.s.complete(),this.s=new b.$6h;try{this.h.clear(),this.g.clear();for(const $ of u)this.u($)?this.h.set($.correlationId,$):this.g.add($);for(const[$]of this.j)this.h.has($)||(this.j.deleteAndDispose($),this.m.delete($));return await this.w(!1)}finally{this.s.complete()}}w(u){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter($=>!this.j.has($.correlationId))]),u?this.y():0)}y(){return 800}isSuspended(u){return typeof u.correlationId!="number"?!1:this.m.has(u.correlationId)?"polling":this.j.has(u.correlationId)}async z(u){if(this.j.has(u.correlationId))return;const $=new r.$Wc;this.j.set(u.correlationId,$),await this.s.p,!$.isDisposed&&(this.D(u,$),this.w(!0))}C(u){this.j.deleteAndDispose(u.correlationId),this.m.delete(u.correlationId),this.w(!1)}D(u,$){this.F(u,$)?(this.P(`reusing an existing recursive watcher to monitor ${u.path}`),this.m.delete(u.correlationId)):(this.G(u,$),this.m.add(u.correlationId))}F(u,$){const p=this.O?.subscribe(u.path,(d,f)=>{$.isDisposed||(d?this.D(u,$):f?.type===O.FileChangeType.ADDED&&this.H(u))});return p?($.add(p),!0):!1}G(u,$){let p=!1;const d=(f,y)=>{if($.isDisposed)return;const k=this.I(f),g=this.I(y),E=p;p=k,!k&&(g||E)&&this.H(u)};this.P(`starting fs.watchFile() on ${u.path} (correlationId: ${u.correlationId})`);try{(0,i.watchFile)(u.path,{persistent:!1,interval:this.r},d)}catch(f){this.Q(`fs.watchFile() failed with error ${f} on path ${u.path} (correlationId: ${u.correlationId})`)}$.add((0,r.$Vc)(()=>{this.P(`stopping fs.watchFile() on ${u.path} (correlationId: ${u.correlationId})`);try{(0,i.unwatchFile)(u.path,d)}catch(f){this.Q(`fs.unwatchFile() failed with error ${f} on path ${u.path} (correlationId: ${u.correlationId})`)}}))}H(u){this.P(`detected ${u.path} exists again, resuming watcher (correlationId: ${u.correlationId})`);const $={resource:I.URI.file(u.path),type:O.FileChangeType.ADDED,cId:u.correlationId};this.a.fire([$]),this.J($,u),this.C(u)}I(u){return u.ctimeMs===0&&u.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(u,$){if(this.R){const p=` >> normalized ${u.type===O.FileChangeType.ADDED?"[ADDED]":u.type===O.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${u.resource.fsPath}`;this.L(p,$)}}L(u,$){this.R&&this.P(`${u}${typeof $.correlationId=="number"?` <${$.correlationId}> `:""}`)}M(u){return`${u.path} (excludes: ${u.excludes.length>0?u.excludes:"<none>"}, includes: ${u.includes&&u.includes.length>0?JSON.stringify(u.includes):"<all>"}, filter: ${(0,v.$hr)(u.filter)}, correlationId: ${typeof u.correlationId=="number"?u.correlationId:"<none>"})`}async setVerboseLogging(u){this.R=u}}e.$qr=l}),define(le[184],ue([0,1,26,8,22,32,2,79,9,3,18,7,115,23,14,62]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=void 0,e.$wr=k;class y extends O.$Xc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(E,S,s,a,t,o){super(),this.s=E,this.t=S,this.u=s,this.w=a,this.y=t,this.z=o,this.c=this.B(new r.$Xh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},n=>this.u(n))),this.f=this.B(new r.$Wh(n=>this.M(n),y.b)),this.g=(0,f.$fr)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,f.$fr)(this.s.path,this.s.includes):void 0,this.j=(0,f.$0q)(this.s)?this.s.filter:void 0,this.m=new v.$ze,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const E=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const S=await i.promises.stat(E);if(this.m.token.isCancellationRequested)return;this.B(await this.G(E,S.isDirectory()))}catch(E){E.code!=="ENOENT"?this.O(E):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${E})`),this.D()}}D(){this.r=!0,this.w?.()}async F(E){let S=E.path;try{S=await p.Promises.realpath(E.path),E.path===S&&(S=await(0,$.$sr)(E.path,this.m.token)??E.path),E.path!==S&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${E.path}, real: ${S})`)}catch{}return S}async G(E,S){const s=new O.$Wc;return this.H(E,S,s)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(E,S,s)),s}H(E,S,s){if(S)return!1;const a=u.URI.file(this.s.path),t=this.t?.subscribe(this.s.path,async(o,n)=>{if(!s.isDisposed)if(o){const c=await this.G(E,S);s.isDisposed?c.dispose():s.add(c)}else n&&(typeof n.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:a,type:n.type,cId:this.s.correlationId},!0)});return t?(s.add(t),!0):!1}async I(E,S,s){if(l.$k&&(0,A.$Hg)(E,"/Volumes/",!0)){this.O(`Refusing to watch ${E} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const a=new v.$ze(this.m.token);s.add((0,O.$Vc)(()=>a.dispose(!0)));const t=new O.$Wc;s.add(t);try{const o=u.URI.file(this.s.path),n=(0,b.$qc)(E),c=(0,i.watch)(E);t.add((0,O.$Vc)(()=>{c.removeAllListeners(),c.close()})),this.Q(`Started watching: '${E}'`);const h=new Set;if(S)try{for(const w of await p.Promises.readdir(E))h.add(w)}catch(w){this.O(w)}if(a.token.isCancellationRequested)return;const P=new Map;t.add((0,O.$Vc)(()=>{for(const[,w]of P)w.dispose();P.clear()})),c.on("error",(w,D)=>{a.token.isCancellationRequested||(this.O(`Failed to watch ${E} for changes using fs.watch() (${w}, ${D})`),this.D())}),c.on("change",(w,D)=>{if(a.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${w}"] ${D}`);let L="";if(D&&(L=D.toString(),l.$k&&(L=(0,I.$qm)(L))),!(!L||w!=="change"&&w!=="rename"))if(S)if(w==="rename"){P.get(L)?.dispose();const R=setTimeout(async()=>{if(P.delete(L),L===n&&!await p.Promises.exists(E)){this.J(o);return}if(a.token.isCancellationRequested)return;const T=await this.N((0,b.$mc)(E,L));if(a.token.isCancellationRequested)return;let j;T?h.has(L)?j=d.FileChangeType.UPDATED:(j=d.FileChangeType.ADDED,h.add(L)):(h.delete(L),j=d.FileChangeType.DELETED),this.L({resource:(0,m.$jh)(o,L),type:j,cId:this.s.correlationId})},y.a);P.set(L,(0,O.$Vc)(()=>clearTimeout(R)))}else{let R;h.has(L)?R=d.FileChangeType.UPDATED:(R=d.FileChangeType.ADDED,h.add(L)),this.L({resource:(0,m.$jh)(o,L),type:R,cId:this.s.correlationId})}else if(w==="rename"||L!==n){const R=setTimeout(async()=>{const T=await p.Promises.exists(E);a.token.isCancellationRequested||(T?(this.L({resource:o,type:d.FileChangeType.UPDATED,cId:this.s.correlationId},!0),t.add(await this.G(E,!1))):this.J(o))},y.a);t.clear(),t.add((0,O.$Vc)(()=>clearTimeout(R)))}else this.L({resource:o,type:d.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(o){a.token.isCancellationRequested||this.O(`Failed to watch ${E} for changes using fs.watch() (${o.toString()})`),this.D()}}J(E){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:E,type:d.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(E,S=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${E.type===d.FileChangeType.ADDED?"[ADDED]":E.type===d.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${E.resource.fsPath}`),!S&&this.g.some(s=>s(E.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${E.resource.fsPath}`):!S&&this.h&&this.h.length>0&&!this.h.some(s=>s(E.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${E.resource.fsPath}`):this.f.work(E))}M(E){const S=(0,f.$dr)(E),s=[];for(const t of S){if((0,f.$gr)(t,this.j)){this.z&&this.R(` >> ignored (filtered) ${t.resource.fsPath}`);continue}s.push(t)}if(s.length===0)return;if(this.z)for(const t of s)this.R(` >> normalized ${t.type===d.FileChangeType.ADDED?"[ADDED]":t.type===d.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${t.resource.fsPath}`);this.c.work(s)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${s[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(E){if(l.$l)return p.Promises.exists(E);try{const S=(0,b.$qc)(E);return(await p.Promises.readdir((0,b.$pc)(E))).some(a=>a===S)}catch(S){return this.Q(S),!1}}setVerboseLogging(E){this.z=E}O(E){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${E}`})}P(E){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${E}`})}Q(E){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${E}`})}R(E){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${E}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$vr=y;async function k(g,E,S,s,a=512){const t=await p.Promises.open(g,"r"),o=Buffer.allocUnsafe(a),n=new v.$ze(s);let c,h=!1;const P={path:g,excludes:[],recursive:!1},w=new y(P,void 0,D=>{(async()=>{for(const{type:L}of D)if(L===d.FileChangeType.UPDATED){if(h)return;h=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:R}=await p.Promises.read(t,o,0,a,null);if(!R||n.token.isCancellationRequested)break;E(o.slice(0,R))}}catch(R){c=new Error(R),n.dispose(!0)}finally{h=!1}}})()});return await w.ready,S(),new Promise((D,L)=>{n.token.onCancellationRequested(async()=>{w.dispose();try{await p.Promises.close(t)}catch(R){c=new Error(R)}c?L(c):D()})})}}),define(le[185],ue([0,1,4,114,183,3,184,32]),function(K,e,i,r,v,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=void 0;class b extends v.$qr{constructor(m){super(),this.O=m,this.onDidError=i.Event.None,this.watchers=new Set}async N(m){m=this.Z(m);const u=[],$=new Set(Array.from(this.watchers));for(const p of m){const d=this.W(p);d&&(0,r.$Hk)(d.request.excludes,p.excludes)&&(0,r.$Hk)(d.request.includes,p.includes)?$.delete(d):u.push(p)}u.length&&this.P(`Request to start watching: ${u.map(p=>this.M(p)).join(",")}`),$.size&&this.P(`Request to stop watching: ${Array.from($).map(p=>this.M(p.request)).join(",")}`);for(const p of $)this.Y(p);for(const p of u)this.X(p)}W(m){for(const u of this.watchers)if(typeof m.correlationId=="number"||typeof u.request.correlationId=="number"){if(u.request.correlationId===m.correlationId)return u}else if((0,I.$Gg)(u.request.path,m.path,!A.$l))return u}X(m){const u=new O.$vr(m,this.O,p=>this.a.fire(p),()=>this.c.fire(m),p=>this.b.fire(p),this.R),$={request:m,instance:u};this.watchers.add($)}async stop(){await super.stop();for(const m of this.watchers)this.Y(m)}Y(m){this.P("stopping file watcher",m),this.watchers.delete(m),m.instance.dispose()}Z(m){const u=new Map;for(const $ of m){const p=A.$l?$.path:$.path.toLowerCase();let d=u.get($.correlationId);d||(d=new Map,u.set($.correlationId,d)),d.has(p)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M($)}`),d.set(p,$)}return Array.from(u.values()).map($=>Array.from($.values())).flat()}async setVerboseLogging(m){super.setVerboseLogging(m);for(const u of this.watchers)u.instance.setVerboseLogging(m)}P(m,u){this.R&&this.b.fire({type:"trace",message:this.bb(m,u)})}Q(m){this.b.fire({type:"warn",message:this.bb(m)})}bb(m,u){return u?`[File Watcher (node.js)] ${m} (${this.M(u.request)})`:`[File Watcher (node.js)] ${m}`}}e.$xr=b}),define(le[186],ue([0,1,62,185]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=void 0;class v extends i.$ar{constructor(O,I,b){super(O,I,b),this.s()}r(O){return O.add(new r.$xr(void 0))}}e.$yr=v}),define(le[187],ue([0,1,11,45,163,62]),function(K,e,i,r,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;class O extends A.$br{constructor(b,l,m){super(b,l,m),this.s()}r(b){const l=b.add(new v.$or(i.$3g.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return b.add(l.onDidProcessExit(({code:m,signal:u})=>this.t(`terminated by itself with code ${m}, signal: ${u} (ETERM)`))),r.ProxyChannel.toService((0,r.$pi)(l.getChannel("watcher")))}}e.$pr=O}),define(le[101],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=void 0;class i{constructor(...v){this.a=new Map;for(const[A,O]of v)this.set(A,O)}set(v,A){const O=this.a.get(v);return this.a.set(v,A),O}has(v){return this.a.has(v)}get(v){return this.a.get(v)}}e.$Gi=i}),define(le[188],ue([0,1,8,15,2,84,177,6,101,111]),function(K,e,i,r,v,A,O,I,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=void 0;const m=!1;class u extends Error{constructor(y){super("cyclic dependency between services"),this.message=y.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${y.toString()}`}}class ${constructor(y=new b.$Gi,k=!1,g,E=m){this.i=y,this.j=k,this.k=g,this.l=E,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(I.$Hi,this),this._globalGraph=E?g?._globalGraph??new O.$Br(S=>S):void 0}dispose(){if(!this.f){this.f=!0,(0,v.$Sc)(this.h),this.h.clear();for(const y of this.g)(0,v.$Rc)(y)&&y.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(y,k){this.m();const g=this,E=new class extends ${dispose(){g.h.delete(E),super.dispose()}}(y,this.j,this,this.l);return this.h.add(E),k?.add(E),E}invokeFunction(y,...k){this.m();const g=d.traceInvocation(this.l,y);let E=!1;try{return y({get:s=>{if(E)throw(0,r.$0)("service accessor is only valid during the invocation of its target method");const a=this.s(s,g);if(!a)throw new Error(`[invokeFunction] unknown service '${s}'`);return a}},...k)}finally{E=!0,g.stop()}}createInstance(y,...k){this.m();let g,E;return y instanceof A.$Fi?(g=d.traceCreation(this.l,y.ctor),E=this.o(y.ctor,y.staticArguments.concat(k),g)):(g=d.traceCreation(this.l,y),E=this.o(y,k,g)),g.stop(),E}o(y,k=[],g){const E=I._util.getServiceDependencies(y).sort((a,t)=>a.index-t.index),S=[];for(const a of E){const t=this.s(a.id,g);t||this.y(`[createInstance] ${y.name} depends on UNKNOWN service ${a.id}.`,!1),S.push(t)}const s=E.length>0?E[0].index:k.length;if(k.length!==s){console.trace(`[createInstance] First service dependency of ${y.name} at position ${s+1} conflicts with ${k.length} static arguments`);const a=s-k.length;a>0?k=k.concat(new Array(a)):k=k.slice(0,s)}return Reflect.construct(y,k.concat(S))}q(y,k){if(this.i.get(y)instanceof A.$Fi)this.i.set(y,k);else if(this.k)this.k.q(y,k);else throw new Error("illegalState - setting UNKNOWN service instance")}r(y){const k=this.i.get(y);return!k&&this.k?this.k.r(y):k}s(y,k){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(y));const g=this.r(y);return g instanceof A.$Fi?this.u(y,g,k.branch(y,!0)):(k.branch(y,!1),g)}u(y,k,g){if(this.t.has(y))throw new Error(`illegal state - RECURSIVELY instantiating service '${y}'`);this.t.add(y);try{return this.v(y,k,g)}finally{this.t.delete(y)}}v(y,k,g){const E=new O.$Br(t=>t.id.toString());let S=0;const s=[{id:y,desc:k,_trace:g}],a=new Set;for(;s.length;){const t=s.pop();if(!a.has(String(t.id))){if(a.add(String(t.id)),E.lookupOrInsertNode(t),S++>1e3)throw new u(E);for(const o of I._util.getServiceDependencies(t.desc.ctor)){const n=this.r(o.id);if(n||this.y(`[createInstance] ${y} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),n instanceof A.$Fi){const c={id:o.id,desc:n,_trace:t._trace.branch(o.id,!0)};E.insertEdge(t,c),s.push(c)}}}}for(;;){const t=E.roots();if(t.length===0){if(!E.isEmpty())throw new u(E);break}for(const{data:o}of t){if(this.r(o.id)instanceof A.$Fi){const c=this.w(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.q(o.id,c)}E.removeNode(o)}}return this.r(y)}w(y,k,g=[],E,S){if(this.i.get(y)instanceof A.$Fi)return this.x(y,k,g,E,S,this.g);if(this.k)return this.k.w(y,k,g,E,S);throw new Error(`illegalState - creating UNKNOWN service instance ${k.name}`)}x(y,k,g=[],E,S,s){if(E){const a=new $(void 0,this.j,this,this.l);a.c=String(y);const t=new Map,o=new i.$2h(()=>{const n=a.o(k,g,S);for(const[c,h]of t){const P=n[c];if(typeof P=="function")for(const w of h)w.disposable=P.apply(n,w.listener)}return t.clear(),s.add(n),n});return new Proxy(Object.create(null),{get(n,c){if(!o.isInitialized&&typeof c=="string"&&(c.startsWith("onDid")||c.startsWith("onWill"))){let w=t.get(c);return w||(w=new l.$8c,t.set(c,w)),(L,R,T)=>{if(o.isInitialized)return o.value[c](L,R,T);{const j={listener:[L,R,T],disposable:void 0},G=w.push(j);return(0,v.$Vc)(()=>{G(),j.disposable?.dispose()})}}}if(c in n)return n[c];const h=o.value;let P=h[c];return typeof P!="function"||(P=P.bind(h),n[c]=P),P},set(n,c,h){return o.value[c]=h,!0},getPrototypeOf(n){return k.prototype}})}else{const a=this.o(k,g,S);return s.add(a),a}}y(y,k){if(k&&console.warn(y),this.j)throw new Error(y)}}e.$Cr=$;var p;(function(f){f[f.None=0]="None",f[f.Creation=1]="Creation",f[f.Invocation=2]="Invocation",f[f.Branch=3]="Branch"})(p||(p={}));class d{static{this.all=new Set}static{this.c=new class extends d{constructor(){super(p.None,null)}stop(){}branch(){return this}}}static traceInvocation(y,k){return y?new d(p.Invocation,k.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(y,k){return y?new d(p.Creation,k.name):d.c}static{this.f=0}constructor(y,k){this.type=y,this.name=k,this.g=Date.now(),this.h=[]}branch(y,k){const g=new d(p.Branch,y.toString());return this.h.push([y,k,g]),g}stop(){const y=Date.now()-this.g;d.f+=y;let k=!1;function g(S,s){const a=[],t=new Array(S+1).join("	");for(const[o,n,c]of s.h)if(n&&c){k=!0,a.push(`${t}CREATES -> ${o}`);const h=g(S+1,c);h&&a.push(h)}else a.push(`${t}uses -> ${o}`);return a.join(`
`)}const E=[`${this.type===p.Creation?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${y.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(y>2||k)&&d.all.add(E.join(`
`))}}e.$Dr=d}),define(le[189],ue([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hbc=e.$gbc=e.IssueSource=e.OldIssueType=void 0;var r;(function(A){A[A.Bug=0]="Bug",A[A.PerformanceIssue=1]="PerformanceIssue",A[A.FeatureRequest=2]="FeatureRequest"})(r||(e.OldIssueType=r={}));var v;(function(A){A.VSCode="vscode",A.Extension="extension",A.Marketplace="marketplace"})(v||(e.IssueSource=v={})),e.$gbc=(0,i.$Ii)("issueService"),e.$hbc=(0,i.$Ii)("processService")}),define(le[5],ue([0,1,10,55,4,47,2,31,3,18,12,7,124,6]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$gk=e.LogLevel=e.$ek=e.$dk=void 0,e.$fk=f,e.log=k,e.$rk=P,e.$sk=w,e.$tk=D,e.$uk=L,i=Ie(i),e.$dk=(0,p.$Ii)("logService"),e.$ek=(0,p.$Ii)("loggerService");function d(){return new Date().toISOString()}function f(R){return(0,m.$lg)(R)}var y;(function(R){R[R.Off=0]="Off",R[R.Trace=1]="Trace",R[R.Debug=2]="Debug",R[R.Info=3]="Info",R[R.Warning=4]="Warning",R[R.Error=5]="Error"})(y||(e.LogLevel=y={})),e.$gk=y.Info;function k(R,T,j){switch(T){case y.Trace:R.trace(j);break;case y.Debug:R.debug(j);break;case y.Info:R.info(j);break;case y.Warning:R.warn(j);break;case y.Error:R.error(j);break;case y.Off:break;default:throw new Error(`Invalid log level ${T}`)}}function g(R,T=!1){let j="";for(let G=0;G<R.length;G++){let q=R[G];if(q instanceof Error&&(q=(0,r.$tj)(q,T)),typeof q=="object")try{q=JSON.stringify(q)}catch{}j+=(G>0?" ":"")+q}return j}class E extends O.$Xc{constructor(){super(...arguments),this.b=e.$gk,this.c=this.B(new v.$oe),this.onDidChangeLogLevel=this.c.event}setLevel(T){this.b!==T&&(this.b=T,this.c.fire(this.b))}getLevel(){return this.b}f(T){return this.b!==y.Off&&this.b<=T}}e.$ik=E;class S extends E{constructor(T){super(),this.h=T}f(T){return this.h||super.f(T)}trace(T,...j){this.f(y.Trace)&&this.g(y.Trace,g([T,...j],!0))}debug(T,...j){this.f(y.Debug)&&this.g(y.Debug,g([T,...j]))}info(T,...j){this.f(y.Info)&&this.g(y.Info,g([T,...j]))}warn(T,...j){this.f(y.Warning)&&this.g(y.Warning,g([T,...j]))}error(T,...j){if(this.f(y.Error))if(T instanceof Error){const G=Array.prototype.slice.call(arguments);G[0]=T.stack,this.g(y.Error,g(G))}else this.g(y.Error,g([T,...j]))}flush(){}}e.$jk=S;class s extends E{constructor(T=e.$gk){super(),this.setLevel(T),this.g=!b.$j}trace(T,...j){this.f(y.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,T,...j):console.log(`[main ${d()}]`,T,...j))}debug(T,...j){this.f(y.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,T,...j):console.log(`[main ${d()}]`,T,...j))}info(T,...j){this.f(y.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,T,...j):console.log(`[main ${d()}]`,T,...j))}warn(T,...j){this.f(y.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,T,...j):console.warn(`[main ${d()}]`,T,...j))}error(T,...j){this.f(y.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,T,...j):console.error(`[main ${d()}]`,T,...j))}flush(){}}e.$kk=s;class a extends E{constructor(T=e.$gk,j=!0){super(),this.g=j,this.setLevel(T)}trace(T,...j){this.f(y.Trace)&&(this.g?console.log("%cTRACE","color: #888",T,...j):console.log(T,...j))}debug(T,...j){this.f(y.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",T,...j):console.log(T,...j))}info(T,...j){this.f(y.Info)&&(this.g?console.log("%c INFO","color: #33f",T,...j):console.log(T,...j))}warn(T,...j){this.f(y.Warning)&&(this.g?console.log("%c WARN","color: #993",T,...j):console.log(T,...j))}error(T,...j){this.f(y.Error)&&(this.g?console.log("%c  ERR","color: #f33",T,...j):console.error(T,...j))}flush(){}}e.$lk=a;class t extends E{constructor(T,j=e.$gk){super(),this.g=T,this.setLevel(j)}trace(T,...j){this.f(y.Trace)&&this.g.log(y.Trace,[this.h(T),...j])}debug(T,...j){this.f(y.Debug)&&this.g.log(y.Debug,[this.h(T),...j])}info(T,...j){this.f(y.Info)&&this.g.log(y.Info,[this.h(T),...j])}warn(T,...j){this.f(y.Warning)&&this.g.log(y.Warning,[this.h(T),...j])}error(T,...j){this.f(y.Error)&&this.g.log(y.Error,[this.h(T),...j])}h(T){return typeof T=="string"?T:(0,r.$tj)(T,this.f(y.Trace))}flush(){}}e.$mk=t;class o extends E{constructor(T){super(),this.g=T,T.length&&this.setLevel(T[0].getLevel())}setLevel(T){for(const j of this.g)j.setLevel(T);super.setLevel(T)}trace(T,...j){for(const G of this.g)G.trace(T,...j)}debug(T,...j){for(const G of this.g)G.debug(T,...j)}info(T,...j){for(const G of this.g)G.info(T,...j)}warn(T,...j){for(const G of this.g)G.warn(T,...j)}error(T,...j){for(const G of this.g)G.error(T,...j)}flush(){for(const T of this.g)T.flush()}dispose(){for(const T of this.g)T.dispose();super.dispose()}}e.$nk=o;class n extends O.$Xc{constructor(T,j,G){if(super(),this.h=T,this.j=j,this.b=new I.$Dc,this.c=this.B(new v.$oe),this.onDidChangeLoggers=this.c.event,this.f=this.B(new v.$oe),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new v.$oe),this.onDidChangeVisibility=this.g.event,G)for(const q of G)this.b.set(q.resource,{logger:void 0,info:q})}m(T){return(0,m.$hg)(T)?[...this.b.values()].find(j=>j.info.id===T):this.b.get(T)}getLogger(T){return this.m(T)?.logger}createLogger(T,j){const G=this.n(T),q=(0,m.$hg)(T)?T:j?.id??(0,A.$wj)(G.toString()).toString(16);let Q=this.b.get(G)?.logger;const de=j?.logLevel==="always"?y.Trace:j?.logLevel;Q||(Q=this.s(G,de??this.getLogLevel(G)??this.h,{...j,id:q}));const V={logger:Q,info:{resource:G,id:q,logLevel:de,name:j?.name,hidden:j?.hidden,extensionId:j?.extensionId,when:j?.when}};return this.registerLogger(V.info),this.b.set(G,V),Q}n(T){return(0,m.$hg)(T)?(0,l.$jh)(this.j,`${T}.log`):T}setLogLevel(T,j){if(u.URI.isUri(T)){const G=T,q=j,Q=this.b.get(G);Q&&q!==Q.info.logLevel&&(Q.info.logLevel=q===this.h?void 0:q,Q.logger?.setLevel(q),this.b.set(Q.info.resource,Q),this.f.fire([G,q]))}else{this.h=T;for(const[G,q]of this.b.entries())this.b.get(G)?.info.logLevel===void 0&&q.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(T,j){const G=this.m(T);G&&j!==!G.info.hidden&&(G.info.hidden=!j,this.b.set(G.info.resource,G),this.g.fire([G.info.resource,j]))}getLogLevel(T){let j;return T&&(j=this.b.get(T)?.info.logLevel),j??this.h}registerLogger(T){const j=this.b.get(T.resource);j?j.info.hidden!==T.hidden&&this.setVisibility(T.resource,!T.hidden):(this.b.set(T.resource,{info:T,logger:void 0}),this.c.fire({added:[T],removed:[]}))}deregisterLogger(T){const j=this.b.get(T);j&&(j.logger&&j.logger.dispose(),this.b.delete(T),this.c.fire({added:[],removed:[j.info]}))}*getRegisteredLoggers(){for(const T of this.b.values())yield T.info}getRegisteredLogger(T){return this.b.get(T)?.info}dispose(){this.b.forEach(T=>T.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ok=n;class c{constructor(){this.onDidChangeLogLevel=new v.$oe().event}setLevel(T){}getLevel(){return y.Info}trace(T,...j){}debug(T,...j){}info(T,...j){}warn(T,...j){}error(T,...j){}critical(T,...j){}dispose(){}flush(){}}e.$pk=c;class h extends c{}e.$qk=h;function P(R){if(R.verbose)return y.Trace;if(typeof R.logLevel=="string"){const T=L(R.logLevel.toLowerCase());if(T!==void 0)return T}return e.$gk}function w(R){switch(R){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}function D(R){switch(R){case y.Trace:return{original:"Trace",value:i.localize(1959,null)};case y.Debug:return{original:"Debug",value:i.localize(1960,null)};case y.Info:return{original:"Info",value:i.localize(1961,null)};case y.Warning:return{original:"Warning",value:i.localize(1962,null)};case y.Error:return{original:"Error",value:i.localize(1963,null)};case y.Off:return{original:"Off",value:i.localize(1964,null)}}}function L(R){switch(R){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.$vk=new $.$Zj("logLevel",w(y.Info))});var re=this&&this.__param||function(K,e){return function(i,r){e(i,r,K)}};define(le[86],ue([0,1,44,97,67,11,60,36,6,5]),function(K,e,i,r,v,A,O,I,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bS=e.$aS=void 0,e.$aS=(0,b.$Ii)("ICSSDevelopmentService");let m=class{constructor($,p){this.b=$,this.c=p}get isEnabled(){return!this.b.isBuilt&&v.$T}getCssModules(){return this.a??=this.d(),this.a}async d(){if(!this.isEnabled)return[];const $=await new Promise((p,d)=>{K(["@vscode/ripgrep"],p,d)}).then(Ie);return await new Promise(p=>{const d=O.$ie.create(),f=[],y=new TextDecoder,k=A.$3g.asFileUri("").fsPath,g=(0,i.spawn)($.rgPath,["-g","**/*.css","--files","--no-ignore",k],{});g.stdout.on("data",E=>{const S=y.decode(E,{stream:!0});f.push(S.split(`
`).filter(Boolean))}),g.on("error",E=>{this.c.error("[CSS_DEV] FAILED to compute CSS data",E),p([])}),g.on("close",()=>{const E=f.flat().map(S=>(0,r.relative)(k,S).replace(/\\/g,"/")).filter(Boolean).sort();p(E),this.c.info(`[CSS_DEV] DONE, ${E.length} css modules (${Math.round(d.elapsed())}ms)`)})})}};e.$bS=m,e.$bS=m=ke([re(0,I.$Pi),re(1,l.$dk)],m)}),define(le[190],ue([0,1,13,3,100,5]),function(K,e,i,r,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zhc=void 0;const O=i.safeStorage;let I=class{constructor(l){this.a=l,i.app.commandLine.getSwitchValue("password-store")===v.PasswordStoreCLIOption.basic&&(this.a.trace("[EncryptionMainService] setting usePlainTextEncryption to true..."),O.setUsePlainTextEncryption?.(!0),this.a.trace("[EncryptionMainService] set usePlainTextEncryption to true"))}async encrypt(l){this.a.trace("[EncryptionMainService] Encrypting value...");try{const m=JSON.stringify(O.encryptString(l));return this.a.trace("[EncryptionMainService] Encrypted value."),m}catch(m){throw this.a.error(m),m}}async decrypt(l){let m;try{if(m=JSON.parse(l),!m.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${l}`);const u=Buffer.from(m.data);this.a.trace("[EncryptionMainService] Decrypting value...");const $=O.decryptString(u);return this.a.trace("[EncryptionMainService] Decrypted value."),$}catch(u){throw this.a.error(u),u}}isEncryptionAvailable(){this.a.trace("[EncryptionMainService] Checking if encryption is available...");const l=O.isEncryptionAvailable();return this.a.trace("[EncryptionMainService] Encryption is available: ",l),Promise.resolve(l)}getKeyStorageProvider(){if(r.$j)return Promise.resolve(v.KnownStorageProvider.dplib);if(r.$k)return Promise.resolve(v.KnownStorageProvider.keychainAccess);if(O.getSelectedStorageBackend)try{this.a.trace("[EncryptionMainService] Getting selected storage backend...");const l=O.getSelectedStorageBackend();return this.a.trace("[EncryptionMainService] Selected storage backend: ",l),Promise.resolve(l)}catch(l){this.a.error(l)}return Promise.resolve(v.KnownStorageProvider.unknown)}async setUsePlainTextEncryption(){if(r.$j)throw new Error("Setting plain text encryption is not supported on Windows.");if(r.$k)throw new Error("Setting plain text encryption is not supported on macOS.");if(!O.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");this.a.trace("[EncryptionMainService] Setting usePlainTextEncryption to true..."),O.setUsePlainTextEncryption(!0),this.a.trace("[EncryptionMainService] Set usePlainTextEncryption to true")}};e.$zhc=I,e.$zhc=I=ke([re(0,A.$dk)],I)}),define(le[191],ue([0,1,21,8,15,4,32,2,9,62,5]),function(K,e,i,r,v,A,O,I,b,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=void 0;class u extends I.$Xc{constructor(p,d){super(),this.a=p,this.b=d,this.c=this.B(new A.$oe),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$oe),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new r.$Gh(0)),this.w=[],this.y=this.B(new r.$Gh(0))}watch(p,d){return d.recursive||this.b?.watcher?.forceUniversal?this.n(p,d):this.z(p,d)}n(p,d){const f={path:this.J(p),excludes:d.excludes,includes:d.includes,recursive:d.recursive,filter:d.filter,correlationId:d.correlationId},y=(0,i.$Vb)(this.j,f);return this.r(),(0,I.$Vc)(()=>{y(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(p=>(0,v.$2)(p))}s(){this.h||(this.h=this.B(this.t(d=>this.c.fire((0,l.$cr)(d)),d=>this.G(d),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const d of this.j)(0,l.$$q)(d)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const d of this.j)(0,l.$$q)(d)&&p.includes(d.path)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(p,d){const f={path:this.J(p),excludes:d.excludes,includes:d.includes,recursive:!1,filter:d.filter,correlationId:d.correlationId},y=(0,i.$Vb)(this.w,f);return this.C(),(0,I.$Vc)(()=>{y(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(p=>(0,v.$2)(p))}D(){return this.u||(this.u=this.B(this.F(p=>this.c.fire((0,l.$cr)(p)),p=>this.G(p),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)}))),this.u.watch(this.w)}G(p){p.type==="error"&&this.g.fire(p.message),this.H(p)}H(p){this.a[p.type](p.message)}I(p){return(0,b.$kc)(p.fsPath)}J(p){const d=this.I(p);return(0,O.$Kg)(d)}}e.$ir=u}),define(le[192],ue([0,1,21,8,17,22,4,47,78,2,61,11,72,18,69,10,14,126,5,15]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p,d,f,y,k,g,E){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=void 0;let s=class extends l.$Xc{static{S=this}constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new O.$oe),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new O.$oe),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new O.$oe),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new O.$oe),this.onDidRunOperation=this.r.event,this.X=this.B(new O.$oe),this.Y=this.B(new O.$oe),this.onDidFilesChange=this.Y.event,this.Z=this.B(new O.$oe),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new r.$Rh)}registerProvider(t,o){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,$.mark)(`code/registerFilesystem/${t}`);const n=new l.$Wc;return this.h.set(t,o),this.c.fire({added:!0,scheme:t,provider:o}),n.add(o.onDidChangeFile(c=>{const h=new y.$wl(c,!this.S(o));this.X.fire(h),h.hasCorrelation()||this.Y.fire(h)})),typeof o.onDidWatchError=="function"&&n.add(o.onDidWatchError(c=>this.Z.fire(new Error(c)))),n.add(o.onDidChangeCapabilities(()=>this.g.fire({provider:o,scheme:t}))),(0,l.$Vc)(()=>{this.c.fire({added:!1,scheme:t,provider:o}),this.h.delete(t),(0,l.$Sc)(n)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const o=[];this.f.fire({scheme:t,join(n){o.push(n)}}),!this.h.has(t)&&await r.Promises.settled(o)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,o){const n=this.h.get(t.scheme);return!!(n&&n.capabilities&o)}listCapabilities(){return b.Iterable.map(this.h,([t,o])=>({scheme:t,capabilities:o.capabilities}))}async j(t){if(!(0,p.$nh)(t))throw new y.$yl((0,f.localize)(1871,null,this.sb(t)),y.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(t.scheme);const o=this.h.get(t.scheme);if(!o){const n=new E.$db;throw n.message=(0,f.localize)(1872,null,t.toString()),n}return o}async m(t){const o=await this.j(t);if((0,y.$jl)(o)||(0,y.$gl)(o)||(0,y.$kl)(o))return o;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(t){const o=await this.j(t);if((0,y.$jl)(o)||(0,y.$gl)(o))return o;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,o){try{return await this.s(t,o)}catch(n){throw(0,y.$tl)(n)===y.FileSystemProviderErrorCode.FileNotFound?new y.$yl((0,f.localize)(1873,null,this.sb(t)),y.FileOperationResult.FILE_NOT_FOUND):(0,y.$rl)(n)}}async s(t,o){const n=await this.j(t),c=this.S(n),h=o?.resolveTo,P=o?.resolveSingleChildDescendants,w=o?.resolveMetadata,D=await n.stat(t);let L;return this.t(n,t,D,void 0,!!w,(R,T)=>(L||(L=m.$Oi.forUris(()=>!c),L.set(t,!0),h&&L.fill(!0,h)),L.get(R.resource)||L.findSuperstr(R.resource.with({query:null,fragment:null}))?!0:R.isDirectory&&P?T===1:!1))}async t(t,o,n,c,h,P){const{providerExtUri:w}=this.R(t),D={resource:o,name:w.basename(o),isFile:(n.type&y.FileType.File)!==0,isDirectory:(n.type&y.FileType.Directory)!==0,isSymbolicLink:(n.type&y.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&y.FilePermission.Readonly)||!!(t.capabilities&y.FileSystemProviderCapabilities.Readonly),locked:!!((n.permissions??0)&y.FilePermission.Locked),etag:(0,y.$Jl)({mtime:n.mtime,size:n.size}),children:void 0};if(D.isDirectory&&P(D,c)){try{const L=await t.readdir(o),R=await r.Promises.settled(L.map(async([T,j])=>{try{const G=w.joinPath(o,T),q=h?await t.stat(G):{type:j};return await this.t(t,G,q,L.length,h,P)}catch(G){return this.b.trace(G),null}}));D.children=(0,i.$Jb)(R)}catch(L){this.b.trace(L),D.children=[]}return D}return D}async resolveAll(t){return r.Promises.settled(t.map(async o=>{try{return{stat:await this.s(o.resource,o.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(t){const o=await this.j(t),n=await o.stat(t);return this.t(o,t,n,void 0,!0,()=>!1)}async exists(t){const o=await this.j(t);try{return!!await o.stat(t)}catch{return!1}}async canCreateFile(t,o){try{await this.u(t,o)}catch(n){return n}return!0}async u(t,o){if(!o?.overwrite&&await this.exists(t))throw new y.$yl((0,f.localize)(1874,null,this.sb(t)),y.FileOperationResult.FILE_MODIFIED_SINCE,o)}async createFile(t,o=v.$Qe.fromString(""),n){await this.u(t,n);const c=await this.writeFile(t,o);return this.r.fire(new y.$vl(t,y.FileOperation.CREATE,c)),c}async writeFile(t,o,n){const c=this.qb(await this.n(t),t),{providerExtUri:h}=this.R(c);let P=n;if((0,y.$ml)(c)&&!P?.atomic){const w=c.enforceAtomicWriteFile?.(t);w&&(P={...n,atomic:w})}try{await this.w(c,t,P)||await this.U(c,h.dirname(t));let D;if((0,y.$gl)(c)&&!(o instanceof v.$Qe))if((0,d.$Ce)(o)){const L=await(0,d.$Je)(o,3);L.ended?D=v.$Qe.concat(L.buffer):D=L}else D=(0,d.$Ge)(o,L=>v.$Qe.concat(L),3);else D=o;!(0,y.$jl)(c)||(0,y.$gl)(c)&&D instanceof v.$Qe||(0,y.$gl)(c)&&(0,y.$ml)(c)&&P?.atomic?await this.hb(c,t,P,D):await this.db(c,t,P,D instanceof v.$Qe?(0,v.$2e)(D):D),this.r.fire(new y.$vl(t,y.FileOperation.WRITE))}catch(w){throw new y.$yl((0,f.localize)(1875,null,this.sb(t),(0,y.$rl)(w).toString()),(0,y.$ul)(w),P)}return this.resolve(t,{resolveMetadata:!0})}async w(t,o,n){const c=!!n?.unlock;if(c&&!(t.capabilities&y.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,f.localize)(1876,null,this.sb(o)));if(!!n?.atomic){if(!(t.capabilities&y.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,f.localize)(1877,null,this.sb(o)));if(!(t.capabilities&y.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,f.localize)(1878,null,this.sb(o)));if(c)throw new Error((0,f.localize)(1879,null,this.sb(o)))}let P;try{P=await t.stat(o)}catch{return}if(P.type&y.FileType.Directory)throw new y.$yl((0,f.localize)(1880,null,this.sb(o)),y.FileOperationResult.FILE_IS_DIRECTORY,n);if(this.rb(o,P),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==y.$Il&&typeof P.mtime=="number"&&typeof P.size=="number"&&n.mtime<P.mtime&&n.etag!==(0,y.$Jl)({mtime:n.mtime,size:P.size}))throw new y.$yl((0,f.localize)(1881,null),y.FileOperationResult.FILE_MODIFIED_SINCE,n);return P}async readFile(t,o,n){const c=await this.m(t);return o?.atomic?this.z(c,t,o,n):this.C(c,t,o,n)}async z(t,o,n,c){return new Promise((h,P)=>{this.cb.queueFor(o,async()=>{try{const w=await this.C(t,o,n,c);h(w)}catch(w){P(w)}},this.R(t).providerExtUri)})}async C(t,o,n,c){const h=await this.D(t,o,{...n,preferUnbuffered:!0},c);return{...h,value:await(0,v.$3e)(h.value)}}async readFileStream(t,o,n){const c=await this.m(t);return this.D(c,t,o,n)}async D(t,o,n,c){const h=new A.$ze(c);let P=n;(0,y.$ll)(t)&&t.enforceAtomicReadFile?.(o)&&(P={...n,atomic:!0});const w=this.J(o,P).then(L=>L,L=>{throw h.dispose(!0),L});let D;try{return typeof P?.etag=="string"&&P.etag!==y.$Il&&await w,P?.atomic&&(0,y.$ll)(t)||!((0,y.$jl)(t)||(0,y.$kl)(t))||(0,y.$gl)(t)&&P?.preferUnbuffered?D=this.I(t,o,P):(0,y.$kl)(t)?D=this.G(t,o,h.token,P):D=this.H(t,o,h.token,P),D.on("end",()=>h.dispose()),D.on("error",()=>h.dispose()),{...await w,value:D}}catch(L){throw D&&await(0,d.$He)(D),this.F(L,o,P)}}F(t,o,n){const c=(0,f.localize)(1882,null,this.sb(o),(0,y.$rl)(t).toString());return t instanceof y.$Al?new y.$Al(c,t.stat,n):t instanceof y.$zl?new y.$zl(c,t.fileOperationResult,t.size,t.options):new y.$yl(c,(0,y.$ul)(t),n)}G(t,o,n,c=Object.create(null)){const h=t.readFileStream(o,c,n);return(0,d.$Ne)(h,{data:P=>P instanceof v.$Qe?P:v.$Qe.wrap(P),error:P=>this.F(P,o,c)},P=>v.$Qe.concat(P))}H(t,o,n,c=Object.create(null)){const h=(0,v.$7e)();return(0,k.$8q)(t,o,h,P=>P,{...c,bufferSize:this.a,errorTransformer:P=>this.F(P,o,c)},n),h}I(t,o,n){const c=(0,d.$Ee)(h=>v.$Qe.concat(h));return(async()=>{try{let h;n?.atomic&&(0,y.$ll)(t)?h=await t.readFile(o,{atomic:!0}):h=await t.readFile(o),typeof n?.position=="number"&&(h=h.slice(n.position)),typeof n?.length=="number"&&(h=h.slice(0,n.length)),this.L(o,h.byteLength,n),c.end(v.$Qe.wrap(h))}catch(h){c.error(h),c.end()}})(),c}async J(t,o){const n=await this.resolve(t,{resolveMetadata:!0});if(n.isDirectory)throw new y.$yl((0,f.localize)(1883,null,this.sb(t)),y.FileOperationResult.FILE_IS_DIRECTORY,o);if(typeof o?.etag=="string"&&o.etag!==y.$Il&&o.etag===n.etag)throw new y.$Al((0,f.localize)(1884,null),n,o);return this.L(t,n.size,o),n}L(t,o,n){if(typeof n?.limits?.size=="number"&&o>n.limits.size)throw new y.$zl((0,f.localize)(1885,null,this.sb(t)),y.FileOperationResult.FILE_TOO_LARGE,o,n)}async canMove(t,o,n){return this.M(t,o,"move",n)}async canCopy(t,o,n){return this.M(t,o,"copy",n)}async M(t,o,n,c){if(t.toString()!==o.toString())try{const h=n==="move"?this.qb(await this.n(t),t):await this.m(t),P=this.qb(await this.n(o),o);await this.Q(h,t,P,o,n,c)}catch(h){return h}return!0}async move(t,o,n){const c=this.qb(await this.n(t),t),h=this.qb(await this.n(o),o),P=await this.N(c,t,h,o,"move",!!n),w=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new y.$vl(t,P==="move"?y.FileOperation.MOVE:y.FileOperation.COPY,w)),w}async copy(t,o,n){const c=await this.m(t),h=this.qb(await this.n(o),o),P=await this.N(c,t,h,o,"copy",!!n),w=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new y.$vl(t,P==="copy"?y.FileOperation.COPY:y.FileOperation.MOVE,w)),w}async N(t,o,n,c,h,P){if(o.toString()===c.toString())return h;const{exists:w,isSameResourceWithDifferentPathCase:D}=await this.Q(t,o,n,c,h,P);if(w&&!D&&P&&await this.del(c,{recursive:!0}),await this.U(n,this.R(n).providerExtUri.dirname(c)),h==="copy"){if(t===n&&(0,y.$hl)(t))await t.copy(o,c,{overwrite:P});else{const L=await this.resolve(o);L.isDirectory?await this.P(t,L,n,c):await this.O(t,o,n,c)}return h}else return t===n?(await t.rename(o,c,{overwrite:P}),h):(await this.N(t,o,n,c,"copy",P),await this.del(o,{recursive:!0}),"copy")}async O(t,o,n,c){if((0,y.$jl)(t)&&(0,y.$jl)(n))return this.jb(t,o,n,c);if((0,y.$jl)(t)&&(0,y.$gl)(n))return this.pb(t,o,n,c);if((0,y.$gl)(t)&&(0,y.$jl)(n))return this.nb(t,o,n,c);if((0,y.$gl)(t)&&(0,y.$gl)(n))return this.lb(t,o,n,c)}async P(t,o,n,c){await n.mkdir(c),Array.isArray(o.children)&&await r.Promises.settled(o.children.map(async h=>{const P=this.R(n).providerExtUri.joinPath(c,h.name);return h.isDirectory?this.P(t,await this.resolve(h.resource),n,P):this.O(t,h.resource,n,P)}))}async Q(t,o,n,c,h,P){let w=!1;if(t===n){const{providerExtUri:L,isPathCaseSensitive:R}=this.R(t);if(R||(w=L.isEqual(o,c)),w&&h==="copy")throw new Error((0,f.localize)(1886,null,this.sb(o),this.sb(c)));if(!w&&L.isEqualOrParent(c,o))throw new Error((0,f.localize)(1887,null,this.sb(o),this.sb(c)))}const D=await this.exists(c);if(D&&!w){if(!P)throw new y.$yl((0,f.localize)(1888,null,this.sb(o),this.sb(c)),y.FileOperationResult.FILE_MOVE_CONFLICT);if(t===n){const{providerExtUri:L}=this.R(t);if(L.isEqualOrParent(o,c))throw new Error((0,f.localize)(1889,null,this.sb(o),this.sb(c)))}}return{exists:D,isSameResourceWithDifferentPathCase:w}}R(t){const o=this.S(t);return{providerExtUri:o?p.$_g:p.$bh,isPathCaseSensitive:o}}S(t){return!!(t.capabilities&y.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(t){const o=this.qb(await this.j(t),t);await this.U(o,t);const n=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new y.$vl(t,y.FileOperation.CREATE,n)),n}async U(t,o){const n=[],{providerExtUri:c}=this.R(t);for(;!c.isEqual(o,c.dirname(o));)try{if(!((await t.stat(o)).type&y.FileType.Directory))throw new Error((0,f.localize)(1890,null,this.sb(o)));break}catch(h){if((0,y.$tl)(h)!==y.FileSystemProviderErrorCode.FileNotFound)throw h;n.push(c.basename(o)),o=c.dirname(o)}for(let h=n.length-1;h>=0;h--){o=c.joinPath(o,n[h]);try{await t.mkdir(o)}catch(P){if((0,y.$tl)(P)!==y.FileSystemProviderErrorCode.FileExists)throw P}}}async canDelete(t,o){try{await this.W(t,o)}catch(n){return n}return!0}async W(t,o){const n=this.qb(await this.j(t),t),c=!!o?.useTrash;if(c&&!(n.capabilities&y.FileSystemProviderCapabilities.Trash))throw new Error((0,f.localize)(1891,null,this.sb(t)));const h=o?.atomic;if(h&&!(n.capabilities&y.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,f.localize)(1892,null,this.sb(t)));if(c&&h)throw new Error((0,f.localize)(1893,null,this.sb(t)));let P;try{P=await n.stat(t)}catch{}if(P)this.rb(t,P);else throw new y.$yl((0,f.localize)(1894,null,this.sb(t)),y.FileOperationResult.FILE_NOT_FOUND);if(!!!o?.recursive){const D=await this.resolve(t);if(D.isDirectory&&Array.isArray(D.children)&&D.children.length>0)throw new Error((0,f.localize)(1895,null,this.sb(t)))}return n}async del(t,o){const n=await this.W(t,o);let c=o;if((0,y.$nl)(n)&&!c?.atomic){const D=n.enforceAtomicDelete?.(t);D&&(c={...o,atomic:D})}const h=!!c?.useTrash,P=!!c?.recursive,w=c?.atomic??!1;await n.delete(t,{recursive:P,useTrash:h,atomic:w}),this.r.fire(new y.$vl(t,y.FileOperation.DELETE))}async cloneFile(t,o){const n=await this.j(t),c=this.qb(await this.n(o),o);if(!(n===c&&this.R(n).providerExtUri.isEqual(t,o)))return n===c&&(0,y.$il)(n)?n.cloneFile(t,o):(await this.U(c,this.R(c).providerExtUri.dirname(o)),n===c&&(0,y.$hl)(n)?this.cb.queueFor(t,()=>n.copy(t,o,{overwrite:!0}),this.R(n).providerExtUri):this.cb.queueFor(t,()=>this.O(n,t,c,o),this.R(n).providerExtUri))}static{this.ab=0}createWatcher(t,o){return this.watch(t,{...o,correlationId:S.ab++})}watch(t,o={recursive:!1,excludes:[]}){const n=new l.$Wc;let c=!1,h=()=>{c=!0};n.add((0,l.$Vc)(()=>h())),(async()=>{try{const w=await this.bb(t,o);c?(0,l.$Sc)(w):h=()=>(0,l.$Sc)(w)}catch(w){this.b.error(w)}})();const P=o.correlationId;if(typeof P=="number"){const w=n.add(new O.$oe);return n.add(this.X.event(L=>{L.correlates(P)&&w.fire(L)})),{onDidChange:w.event,dispose:()=>n.dispose()}}return n}async bb(t,o){const n=await this.j(t),c=(0,I.$wj)([this.R(n).providerExtUri.getComparisonKey(t),o]);let h=this.$.get(c);return h||(h={count:0,disposable:n.watch(t,o)},this.$.set(c,h)),h.count+=1,(0,l.$Vc)(()=>{h&&(h.count--,h.count===0&&((0,l.$Sc)(h.disposable),this.$.delete(c)))})}dispose(){super.dispose();for(const[,t]of this.$)(0,l.$Sc)(t.disposable);this.$.clear()}async db(t,o,n,c){return this.cb.queueFor(o,async()=>{const h=await t.open(o,{create:!0,unlock:n?.unlock??!1});try{(0,d.$Ce)(c)||(0,d.$De)(c)?await this.eb(t,h,c):await this.fb(t,h,c)}catch(P){throw(0,y.$rl)(P)}finally{await t.close(h)}},this.R(t).providerExtUri)}async eb(t,o,n){let c=0,h;if((0,d.$De)(n)){if(n.buffer.length>0){const P=v.$Qe.concat(n.buffer);await this.gb(t,o,P,P.byteLength,c,0),c+=P.byteLength}if(n.ended)return;h=n.stream}else h=n;return new Promise((P,w)=>{(0,d.$Ie)(h,{onData:async D=>{h.pause();try{await this.gb(t,o,D,D.byteLength,c,0)}catch(L){return w(L)}c+=D.byteLength,setTimeout(()=>h.resume())},onError:D=>w(D),onEnd:()=>P()})})}async fb(t,o,n){let c=0,h;for(;(h=n.read())!==null;)await this.gb(t,o,h,h.byteLength,c,0),c+=h.byteLength}async gb(t,o,n,c,h,P){let w=0;for(;w<c;){const D=await t.write(o,h+w,n.buffer,P+w,c-w);w+=D}}async hb(t,o,n,c){return this.cb.queueFor(o,()=>this.ib(t,o,n,c),this.R(t).providerExtUri)}async ib(t,o,n,c){let h;c instanceof v.$Qe?h=c:(0,d.$Ce)(c)?h=await(0,v.$3e)(c):(0,d.$De)(c)?h=await(0,v.$4e)(c):h=(0,v.$1e)(c),await t.writeFile(o,h.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async jb(t,o,n,c){return this.cb.queueFor(c,()=>this.kb(t,o,n,c),this.R(n).providerExtUri)}async kb(t,o,n,c){let h,P;try{h=await t.open(o,{create:!1}),P=await n.open(c,{create:!0,unlock:!1});const w=v.$Qe.alloc(this.a);let D=0,L=0,R=0;do R=await t.read(h,D,w.buffer,L,w.byteLength-L),await this.gb(n,P,w,R,D,L),D+=R,L+=R,L===w.byteLength&&(L=0);while(R>0)}catch(w){throw(0,y.$rl)(w)}finally{await r.Promises.settled([typeof h=="number"?t.close(h):Promise.resolve(),typeof P=="number"?n.close(P):Promise.resolve()])}}async lb(t,o,n,c){return this.cb.queueFor(c,()=>this.mb(t,o,n,c),this.R(n).providerExtUri)}async mb(t,o,n,c){return n.writeFile(c,await t.readFile(o),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(t,o,n,c){return this.cb.queueFor(c,()=>this.ob(t,o,n,c),this.R(n).providerExtUri)}async ob(t,o,n,c){const h=await n.open(c,{create:!0,unlock:!1});try{const P=await t.readFile(o);await this.gb(n,h,v.$Qe.wrap(P),P.byteLength,0,0)}catch(P){throw(0,y.$rl)(P)}finally{await n.close(h)}}async pb(t,o,n,c){const h=await(0,v.$3e)(this.H(t,o,A.CancellationToken.None));await this.hb(n,c,void 0,h)}qb(t,o){if(t.capabilities&y.FileSystemProviderCapabilities.Readonly)throw new y.$yl((0,f.localize)(1896,null,this.sb(o)),y.FileOperationResult.FILE_PERMISSION_DENIED);return t}rb(t,o){if((o.permissions??0)&y.FilePermission.Readonly)throw new y.$yl((0,f.localize)(1897,null,this.sb(t)),y.FileOperationResult.FILE_PERMISSION_DENIED)}sb(t){return t.scheme===u.Schemas.file?t.fsPath:t.toString(!0)}};e.$9q=s,e.$9q=s=S=ke([re(0,g.$dk)],s)}),define(le[102],ue([0,1,26,8,31,17,4,32,2,9,3,18,69,23,10,14,126,191,187,186]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p,d,f,y,k,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=void 0;class S extends k.$ir{static{this.L=!1}constructor(a,t){super(a,t),this.onDidChangeCapabilities=O.Event.None,this.P=new v.$Dc(o=>u.$ah.getComparisonKey(o)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=f.FileSystemProviderCapabilities.FileReadWrite|f.FileSystemProviderCapabilities.FileOpenReadWriteClose|f.FileSystemProviderCapabilities.FileReadStream|f.FileSystemProviderCapabilities.FileFolderCopy|f.FileSystemProviderCapabilities.FileWriteUnlock|f.FileSystemProviderCapabilities.FileAtomicRead|f.FileSystemProviderCapabilities.FileAtomicWrite|f.FileSystemProviderCapabilities.FileAtomicDelete|f.FileSystemProviderCapabilities.FileClone,m.$l&&(this.M|=f.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(a){try{const{stat:t,symbolicLink:o}=await p.SymlinkSupport.stat(this.I(a));return{type:this.O(t,o),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size,permissions:t.mode&128?void 0:f.FilePermission.Locked}}catch(t){throw this.hb(t)}}async N(a){try{return await this.stat(a)}catch{return}}async readdir(a){try{const t=await p.Promises.readdir(this.I(a),{withFileTypes:!0}),o=[];return await Promise.all(t.map(async n=>{try{let c;n.isSymbolicLink()?c=(await this.stat((0,u.$jh)(a,n.name))).type:c=this.O(n),o.push([n.name,c])}catch(c){this.a.trace(c)}})),o}catch(t){throw this.hb(t)}}O(a,t){let o;return t?.dangling?o=f.FileType.Unknown:a.isFile()?o=f.FileType.File:a.isDirectory()?o=f.FileType.Directory:o=f.FileType.Unknown,t&&(o|=f.FileType.SymbolicLink),o}async Q(a){const t=this.I(a);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let o;for(;o=this.P.get(a);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await o.wait();const n=new r.$Hh;return this.P.set(a,n),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,b.$Vc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.P.get(a)===n&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.P.delete(a)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),n.open()})}async readFile(a,t){let o;try{t?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(a)})`),o=await this.Q(a));const n=this.I(a);return await i.promises.readFile(n)}catch(n){throw this.hb(n)}finally{o?.dispose()}}R(a){S.L&&this.a.trace(a)}readFileStream(a,t,o){const n=(0,$.$Ee)(c=>A.$Qe.concat(c.map(h=>A.$Qe.wrap(h))).buffer);return(0,y.$8q)(this,a,n,c=>c.buffer,{...t,bufferSize:256*1024},o),n}async writeFile(a,t,o){return o?.atomic!==!1&&o?.atomic?.postfix&&await this.S(a)?this.U(a,(0,u.$jh)((0,u.$ih)(a),`${(0,u.$gh)(a)}${o.atomic.postfix}`),t,o):this.W(a,t,o)}async S(a){try{const t=this.I(a),{symbolicLink:o}=await p.SymlinkSupport.stat(t);if(o)return!1}catch{}return!0}async U(a,t,o,n){const c=new b.$Wc;try{c.add(await this.Q(a)),c.add(await this.Q(t)),await this.W(t,o,n,!0);try{await this.rename(t,a,{overwrite:!0})}catch(h){try{await this.delete(t,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw h}}finally{c.dispose()}}async W(a,t,o,n){let c;try{const h=this.I(a);if(!o.create||!o.overwrite){if(await p.Promises.exists(h)){if(!o.overwrite)throw(0,f.$ql)((0,d.localize)(1901,null),f.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,f.$ql)((0,d.localize)(1902,null),f.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(a,{create:!0,unlock:o.unlock},n),await this.write(c,0,t,0,t.byteLength)}catch(h){throw await this.ib(a,h)}finally{typeof c=="number"&&await this.close(c)}}static{this.$=!0}static configureFlushOnWrite(a){S.$=a}async open(a,t,o){const n=this.I(a);let c;(0,f.$el)(t)&&!o&&(c=await this.Q(a));let h;try{if((0,f.$el)(t)&&t.unlock)try{const{stat:w}=await p.SymlinkSupport.stat(n);w.mode&128||await i.promises.chmod(n,w.mode|128)}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}let P;if((0,f.$el)(t)){if(m.$j)try{await i.promises.truncate(n,0),P="r+"}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}P||(P="w")}else P="r";h=await p.Promises.open(n,P)}catch(P){throw c?.dispose(),(0,f.$el)(t)?await this.ib(a,P):this.hb(P)}if(this.X.set(h,0),(0,f.$el)(t)&&this.Z.set(h,a),c){const P=this.Y.get(h);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${h} (${n})`),this.Y.set(h,c),P&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${h} (${n})`),P.dispose())}return h}async close(a){const t=this.Y.get(a);try{if(this.X.delete(a),this.Z.delete(a)&&S.$)try{await p.Promises.fdatasync(a)}catch(o){S.configureFlushOnWrite(!1),this.a.error(o)}return await p.Promises.close(a)}catch(o){throw this.hb(o)}finally{t&&(this.Y.get(a)===t&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${a}`),this.Y.delete(a)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${a}`),t.dispose())}}async read(a,t,o,n,c){const h=this.ab(a,t);let P=null;try{P=(await p.Promises.read(a,o,n,c,h)).bytesRead}catch(w){throw this.hb(w)}finally{this.bb(a,h,P)}return P}ab(a,t){return t===this.X.get(a)?null:t}bb(a,t,o){const n=this.X.get(a);typeof n=="number"&&(typeof t=="number"||(typeof o=="number"?this.X.set(a,n+o):this.X.delete(a)))}async write(a,t,o,n,c){return(0,r.$3h)(()=>this.cb(a,t,o,n,c),100,3)}async cb(a,t,o,n,c){const h=this.ab(a,t);let P=null;try{P=(await p.Promises.write(a,o,n,c,h)).bytesWritten}catch(w){throw await this.ib(this.Z.get(a),w)}finally{this.bb(a,h,P)}return P}async mkdir(a){try{await i.promises.mkdir(this.I(a))}catch(t){throw this.hb(t)}}async delete(a,t){try{const o=this.I(a);if(t.recursive){let n;t?.atomic!==!1&&t.atomic.postfix&&(n=(0,l.$mc)((0,l.$pc)(o),`${(0,l.$qc)(o)}${t.atomic.postfix}`)),await p.Promises.rm(o,p.RimRafMode.MOVE,n)}else try{await i.promises.unlink(o)}catch(n){if(n.code==="EPERM"||n.code==="EISDIR"){let c=!1;try{const{stat:h,symbolicLink:P}=await p.SymlinkSupport.stat(o);c=h.isDirectory()&&!P}catch{}if(c)await i.promises.rmdir(o);else throw n}else throw n}}catch(o){throw this.hb(o)}}async rename(a,t,o){const n=this.I(a),c=this.I(t);if(n!==c)try{await this.db(a,t,"move",o.overwrite),await p.Promises.rename(n,c)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,d.localize)(1903,null,(0,l.$qc)(n),(0,l.$qc)((0,l.$pc)(c)),h.toString()))),this.hb(h)}}async copy(a,t,o){const n=this.I(a),c=this.I(t);if(n!==c)try{await this.db(a,t,"copy",o.overwrite),await p.Promises.copy(n,c,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,d.localize)(1904,null,(0,l.$qc)(n),(0,l.$qc)((0,l.$pc)(c)),h.toString()))),this.hb(h)}}async db(a,t,o,n){const c=this.I(a),h=this.I(t);let P=!1;if(!!(this.capabilities&f.FileSystemProviderCapabilities.PathCaseSensitive)||(P=(0,I.$Gg)(c,h,!0)),P){if(o==="copy")throw(0,f.$ql)((0,d.localize)(1905,null),f.FileSystemProviderErrorCode.FileExists);if(o==="move")return}const D=await this.N(a);if(!D)throw(0,f.$ql)((0,d.localize)(1906,null),f.FileSystemProviderErrorCode.FileNotFound);const L=await this.N(t);if(L){if(!n)throw(0,f.$ql)((0,d.localize)(1907,null),f.FileSystemProviderErrorCode.FileExists);D.type&f.FileType.File&&L.type&f.FileType.File||await this.delete(t,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(a,t){return this.eb(a,t,!1)}async eb(a,t,o){const n=this.I(a),c=this.I(t),h=!!(this.capabilities&f.FileSystemProviderCapabilities.PathCaseSensitive);if((0,I.$Gg)(n,c,!h))return;const P=new b.$Wc;try{P.add(await this.Q(a)),P.add(await this.Q(t)),o&&await i.promises.mkdir((0,l.$pc)(c),{recursive:!0}),await i.promises.copyFile(n,c)}catch(w){if(w.code==="ENOENT"&&!o)return this.eb(a,t,!0);throw this.hb(w)}finally{P.dispose()}}t(a,t,o){return new g.$pr(n=>a(n),n=>t(n),o)}F(a,t,o){return new E.$yr(n=>a(n),n=>t(n),o)}hb(a){if(a instanceof f.$pl)return a;let t=a,o;switch(a.code){case"ENOENT":o=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=f.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":t=`${a.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,o=f.FileSystemProviderErrorCode.Unknown;break;default:o=f.FileSystemProviderErrorCode.Unknown}return(0,f.$ql)(t,o)}async ib(a,t){let o=this.hb(t);if(a&&o.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:n}=await p.SymlinkSupport.stat(this.I(a));n.mode&128||(o=(0,f.$ql)(t,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(n){this.a.trace(n)}return o}}e.$zr=S}),define(le[193],ue([0,1,4,102,2,17,69,22]),function(K,e,i,r,v,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$s=e.$0s=void 0;class b extends v.$Xc{constructor(u,$){super(),this.a=u,this.b=$,this.F=new Map,this.G=new Map}call(u,$,p){const d=this.c(u);switch($){case"stat":return this.g(d,p[0]);case"readdir":return this.h(d,p[0]);case"open":return this.r(d,p[0],p[1]);case"close":return this.s(p[0]);case"read":return this.t(p[0],p[1],p[2]);case"readFile":return this.j(d,p[0],p[1]);case"write":return this.u(p[0],p[1],p[2],p[3],p[4]);case"writeFile":return this.n(d,p[0],p[1],p[2]);case"rename":return this.z(d,p[0],p[1],p[2]);case"copy":return this.C(d,p[0],p[1],p[2]);case"cloneFile":return this.D(d,p[0],p[1]);case"mkdir":return this.w(d,p[0]);case"delete":return this.y(d,p[0],p[1]);case"watch":return this.I(d,p[0],p[1],p[2],p[3]);case"unwatch":return this.J(p[0],p[1])}throw new Error(`IPC Command ${$} not found`)}listen(u,$,p){const d=this.c(u);switch($){case"fileChange":return this.H(d,p[0]);case"readFileStream":return this.m(d,p[0],p[1])}throw new Error(`Unknown event ${$}`)}g(u,$){const p=this.f(u,$,!0);return this.a.stat(p)}h(u,$){const p=this.f(u,$);return this.a.readdir(p)}async j(u,$,p){const d=this.f(u,$,!0),f=await this.a.readFile(d,p);return A.$Qe.wrap(f)}m(u,$,p){const d=this.f(u,$,!0),f=new I.$ze,y=new i.$oe({onDidRemoveLastListener:()=>{f.cancel()}}),k=this.a.readFileStream(d,p,f.token);return(0,O.$Ie)(k,{onData:g=>y.fire(A.$Qe.wrap(g)),onError:g=>y.fire(g),onEnd:()=>{y.fire("end"),y.dispose(),f.dispose()}}),y.event}n(u,$,p,d){const f=this.f(u,$);return this.a.writeFile(f,p.buffer,d)}r(u,$,p){const d=this.f(u,$,!0);return this.a.open(d,p)}s(u){return this.a.close(u)}async t(u,$,p){const d=A.$Qe.alloc(p),y=await this.a.read(u,$,d.buffer,0,p);return[d,y]}u(u,$,p,d,f){return this.a.write(u,$,p.buffer,d,f)}w(u,$){const p=this.f(u,$);return this.a.mkdir(p)}y(u,$,p){const d=this.f(u,$);return this.a.delete(d,p)}z(u,$,p,d){const f=this.f(u,$),y=this.f(u,p);return this.a.rename(f,y,d)}C(u,$,p,d){const f=this.f(u,$),y=this.f(u,p);return this.a.copy(f,y,d)}D(u,$,p){const d=this.f(u,$),f=this.f(u,p);return this.a.cloneFile(d,f)}H(u,$){const p=new i.$oe({onWillAddFirstListener:()=>{this.F.set($,this.L(u,p))},onDidRemoveLastListener:()=>{(0,v.$Sc)(this.F.get($)),this.F.delete($)}});return p.event}async I(u,$,p,d,f){const y=this.F.get($);if(y){const k=this.f(u,d),g=y.watch(p,k,f);this.G.set($+p,g)}}async J(u,$){const p=u+$,d=this.G.get(p);d&&((0,v.$Sc)(d),this.G.delete(p))}dispose(){super.dispose();for(const[,u]of this.G)u.dispose();this.G.clear();for(const[,u]of this.F)u.dispose();this.F.clear()}}e.$0s=b;class l extends v.$Xc{constructor(u,$,p,d){super(),this.c=u,this.f=p,this.g=d,this.a=new Map,this.b=this.B(new r.$zr(this.f,{watcher:{recursive:this.j(this.g)}})),this.h($)}h(u){const $=this.B(new i.$oe);this.B($.event(p=>{u.fire(p.map(d=>({resource:this.c.transformOutgoingURI(d.resource),type:d.type,cId:d.cId})))})),this.B(this.b.onDidChangeFile(p=>$.fire(p))),this.B(this.b.onDidWatchError(p=>u.fire(p)))}j(u){}m(u){}watch(u,$,p){const d=this.m(this.g);return Array.isArray(d)&&(p.excludes=[...p.excludes,...d]),this.a.set(u,this.b.watch($,p)),(0,v.$Vc)(()=>{(0,v.$Sc)(this.a.get(u)),this.a.delete(u)})}dispose(){for(const[,u]of this.a)u.dispose();this.a.clear(),super.dispose()}}e.$$s=l}),define(le[194],ue([0,1,13,10,3,7,14,9,193,154,55]),function(K,e,i,r,v,A,O,I,b,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hhc=void 0;class u extends b.$0s{constructor(d,f,y){super(d,f),this.M=y}c(d){return l.$Rn}f(d,f){return A.URI.revive(f)}async y(d,f,y){if(!y.useTrash)return super.y(d,f,y);const k=this.f(d,f),g=(0,I.$kc)(k.fsPath);try{await i.shell.trashItem(g)}catch(E){throw(0,O.$ql)(v.$j?(0,r.localize)(1899,null,(0,I.$qc)(g),(0,m.$tj)(E)):(0,r.localize)(1900,null,(0,I.$qc)(g),(0,m.$tj)(E)),O.FileSystemProviderErrorCode.Unknown)}}L(d,f){return new $(d,f,this.b,this.M)}}e.$Hhc=u;class $ extends b.$$s{watch(d,f,y){if(y.recursive)throw(0,O.$ql)("Recursive file watching is not supported from main process for performance reasons.",O.FileSystemProviderErrorCode.Unavailable);return super.watch(d,f,y)}}}),define(le[195],ue([0,1,5]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lec=void 0;class r extends i.$jk{constructor(A=i.$gk){super(),this.m=[],this.n=void 0,this.setLevel(A),this.B(this.onDidChangeLogLevel(O=>{this.n?.setLevel(O)}))}set logger(A){this.n=A;for(const{level:O,message:I}of this.m)(0,i.log)(A,O,I);this.m=[]}g(A,O){this.n?(0,i.log)(this.n,A,O):this.getLevel()<=A&&this.m.push({level:A,message:O})}dispose(){this.n?.dispose(),super.dispose()}flush(){this.n?.flush()}}e.$lec=r}),define(le[196],ue([0,1,7,4,5,2]),function(K,e,i,r,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bs=e.$As=e.$zs=void 0;class O extends v.$ok{constructor(u,$,p,d,f){super($,p,d),this.r=u,this.t=f,this.B(f.listen("onDidChangeLogLevel",u)(y=>{(0,v.$fk)(y)?super.setLogLevel(y):super.setLogLevel(i.URI.revive(y[0]),y[1])})),this.B(f.listen("onDidChangeVisibility",u)(([y,k])=>super.setVisibility(i.URI.revive(y),k))),this.B(f.listen("onDidChangeLoggers",u)(({added:y,removed:k})=>{for(const g of y)super.registerLogger({...g,resource:i.URI.revive(g.resource)});for(const g of k)super.deregisterLogger(g.resource)}))}createConsoleMainLogger(){return new v.$mk({log:(u,$)=>{this.t.call("consoleLog",[u,$])}})}registerLogger(u){super.registerLogger(u),this.t.call("registerLogger",[u,this.r])}deregisterLogger(u){super.deregisterLogger(u),this.t.call("deregisterLogger",[u,this.r])}setLogLevel(u,$){super.setLogLevel(u,$),this.t.call("setLogLevel",[u,$])}setVisibility(u,$){super.setVisibility(u,$),this.t.call("setVisibility",[this.n(u),$])}s(u,$,p){return new I(this.t,u,$,p,this.r)}static setLogLevel(u,$,p){return u.call("setLogLevel",[$,p])}}e.$zs=O;class I extends v.$jk{constructor(u,$,p,d,f){super(d?.logLevel==="always"),this.r=u,this.s=$,this.m=!1,this.n=[],this.setLevel(p),this.r.call("createLogger",[$,d,f]).then(()=>{this.u(this.n),this.m=!0})}g(u,$){const p=[[u,$]];this.m?this.u(p):this.n.push(...p)}u(u){this.r.call("log",[this.s,u])}}class b{constructor(u,$){this.a=u,this.b=$}listen(u,$){const p=this.b(u);switch($){case"onDidChangeLoggers":return r.Event.map(this.a.onDidChangeLoggers,d=>({added:[...d.added].map(f=>this.c(f,p)),removed:[...d.removed].map(f=>this.c(f,p))}));case"onDidChangeVisibility":return r.Event.map(this.a.onDidChangeVisibility,d=>[p.transformOutgoingURI(d[0]),d[1]]);case"onDidChangeLogLevel":return r.Event.map(this.a.onDidChangeLogLevel,d=>(0,v.$fk)(d)?d:[p.transformOutgoingURI(d[0]),d[1]])}throw new Error(`Event not found: ${$}`)}async call(u,$,p){const d=this.b(u);switch($){case"setLogLevel":return(0,v.$fk)(p[0])?this.a.setLogLevel(p[0]):this.a.setLogLevel(i.URI.revive(d.transformIncoming(p[0][0])),p[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(f=>this.c(f,d)))}throw new Error(`Call not found: ${$}`)}c(u,$){return{...u,resource:$.transformOutgoingURI(u.resource)}}}e.$As=b;class l extends A.$Xc{constructor(u,$){super(),$.call("setLogLevel",[u.getLogLevel()]),this.B(u.onDidChangeLogLevel(p=>$.call("setLogLevel",[p]))),$.call("getRegisteredLoggers").then(p=>{for(const d of p)u.registerLogger({...d,resource:i.URI.revive(d.resource)})}),this.B($.listen("onDidChangeVisibility")(([p,d])=>u.setVisibility(i.URI.revive(p),d))),this.B($.listen("onDidChangeLoggers")(({added:p,removed:d})=>{for(const f of p)u.registerLogger({...f,resource:i.URI.revive(f.resource)});for(const f of d)u.deregisterLogger(f.resource)}))}}e.$Bs=l}),define(le[197],ue([0,1,2,5]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4R=void 0;class v extends i.$Xc{constructor(O,I=[]){super(),this.a=new r.$nk([O,...I]),this.B(O.onDidChangeLogLevel(b=>this.setLevel(b)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(O){this.a.setLevel(O)}getLevel(){return this.a.getLevel()}trace(O,...I){this.a.trace(O,...I)}debug(O,...I){this.a.debug(O,...I)}info(O,...I){this.a.info(O,...I)}warn(O,...I){this.a.warn(O,...I)}error(O,...I){this.a.error(O,...I)}flush(){this.a.flush()}}e.$4R=v}),define(le[198],ue([0,1,31,7,5]),function(K,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fic=void 0;class A{constructor(I){this.b=I,this.a=new i.$Dc}listen(I,b,l){switch(b){case"onDidChangeLoggers":return l?this.b.getOnDidChangeLoggersEvent(l):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return l?this.b.getOnDidChangeLogLevelEvent(l):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return l?this.b.getOnDidChangeVisibilityEvent(l):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${b}`)}async call(I,b,l){switch(b){case"createLogger":this.c(r.URI.revive(l[0]),l[1],l[2]);return;case"log":return this.e(r.URI.revive(l[0]),l[1]);case"consoleLog":return this.d(l[0],l[1]);case"setLogLevel":return(0,v.$fk)(l[0])?this.b.setLogLevel(l[0]):this.b.setLogLevel(r.URI.revive(l[0]),l[1]);case"setVisibility":return this.b.setVisibility(r.URI.revive(l[0]),l[1]);case"registerLogger":return this.b.registerLogger({...l[0],resource:r.URI.revive(l[0].resource)},l[1]);case"deregisterLogger":return this.b.deregisterLogger(r.URI.revive(l[0]))}throw new Error(`Call not found: ${b}`)}c(I,b,l){this.a.set(I,this.b.createLogger(I,b,l))}d(I,b){let l=console.log;switch(I){case v.LogLevel.Error:l=console.error;break;case v.LogLevel.Warning:l=console.warn;break;case v.LogLevel.Info:l=console.info;break}l.call(console,...b)}e(I,b){const l=this.a.get(I);if(!l)throw new Error("Create the logger before logging");for(const[m,u]of b)(0,v.log)(l,m,u)}}e.$Fic=A}),define(le[199],ue([0,1,14,5]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SR=void 0;var v;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(v||(v={}));async function A(l,m,u,$,p){try{const d=await new Promise((y,k)=>{K(["@vscode/spdlog"],y,k)}).then(Ie);d.setFlushOn(v.Trace);const f=await d.createAsyncRotatingLogger(l,m,u,$);return p?f.clearFormatters():f.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),f}catch(d){console.error(d)}return null}function O(l,m,u){switch(m){case r.LogLevel.Trace:l.trace(u);break;case r.LogLevel.Debug:l.debug(u);break;case r.LogLevel.Info:l.info(u);break;case r.LogLevel.Warning:l.warn(u);break;case r.LogLevel.Error:l.error(u);break;case r.LogLevel.Off:break;default:throw new Error(`Invalid log level ${m}`)}}function I(l,m){switch(m){case r.LogLevel.Trace:l.setLevel(v.Trace);break;case r.LogLevel.Debug:l.setLevel(v.Debug);break;case r.LogLevel.Info:l.setLevel(v.Info);break;case r.LogLevel.Warning:l.setLevel(v.Warning);break;case r.LogLevel.Error:l.setLevel(v.Error);break;case r.LogLevel.Off:l.setLevel(v.Off);break;default:throw new Error(`Invalid log level ${m}`)}}class b extends r.$jk{constructor(m,u,$,p,d){super(),this.m=[],this.setLevel(d),this.n=this.s(m,u,$,p),this.B(this.onDidChangeLogLevel(f=>{this.r&&I(this.r,f)}))}async s(m,u,$,p){const d=$?6:1,f=30/d*i.$Ll.MB,y=await A(m,u,f,d,p);if(y){this.r=y,I(this.r,this.getLevel());for(const{level:k,message:g}of this.m)O(this.r,k,g);this.m=[]}}g(m,u){this.r?O(this.r,m,u):this.getLevel()<=m&&this.m.push({level:m,message:u})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$SR=b}),define(le[200],ue([0,1,33,5,199]),function(K,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TR=void 0;class A extends r.$ok{s(I,b,l){return new v.$SR((0,i.$5g)(),I.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,b)}}e.$TR=A}),define(le[73],ue([0,1,31,4,6,5,200]),function(K,e,i,r,v,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$chc=e.$bhc=void 0,e.$bhc=(0,v.$Ji)(A.$ek);class I extends O.$TR{constructor(){super(...arguments),this.u=new i.$Dc}createLogger(l,m,u){u!==void 0&&this.u.set(this.n(l),u);try{return super.createLogger(l,m)}catch($){throw this.u.delete(this.n(l)),$}}registerLogger(l,m){m!==void 0&&this.u.set(l.resource,m),super.registerLogger(l)}deregisterLogger(l){this.u.delete(l),super.deregisterLogger(l)}getRegisteredLoggers(l){const m=[];for(const u of super.getRegisteredLoggers())l===this.u.get(u.resource)&&m.push(u);return m}getOnDidChangeLogLevelEvent(l){return r.Event.filter(this.onDidChangeLogLevel,m=>(0,A.$fk)(m)||this.w(m[0],l))}getOnDidChangeVisibilityEvent(l){return r.Event.filter(this.onDidChangeVisibility,([m])=>this.w(m,l))}getOnDidChangeLoggersEvent(l){return r.Event.filter(r.Event.map(this.onDidChangeLoggers,m=>({added:[...m.added].filter($=>this.w($.resource,l)),removed:[...m.removed].filter($=>this.w($.resource,l))})),m=>m.added.length>0||m.removed.length>0)}deregisterLoggers(l){for(const[m,u]of this.u)u===l&&this.deregisterLogger(m)}w(l,m){const u=this.u.get(l);return u===void 0||u===m}dispose(){super.dispose(),this.u.clear()}}e.$chc=I}),define(le[201],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vhc=i,e.$Whc=r,e.$Xhc=v,e.$Yhc=A;function i(O){return O.submenu!==void 0}function r(O){return O.id==="vscode.menubar.separator"}function v(O){return O.uri!==void 0}function A(O){return!i(O)&&!r(O)&&!v(O)}}),define(le[40],ue([0,1,4,78,2,6]),function(K,e,i,r,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=e.$yo=e.$xo=void 0,e.$xo=(0,A.$Ii)("policy");class O extends v.$Xc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new i.$oe),this.onDidChange=this.h.event}async updatePolicyDefinitions(l){const m=Object.keys(this.f).length;return this.f={...l,...this.f},m!==Object.keys(this.f).length&&await this.j(l),r.Iterable.reduce(this.g.entries(),(u,[$,p])=>({...u,[$]:p}),{})}getPolicyValue(l){return this.g.get(l)}serialize(){return r.Iterable.reduce(Object.entries(this.f),(l,[m,u])=>({...l,[m]:{definition:u,value:this.g.get(m)}}),{})}}e.$yo=O;class I{constructor(){this.onDidChange=i.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$zo=I}),define(le[202],ue([0,1,8,4,78,12,14,5,40]),function(K,e,i,r,v,A,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yic=void 0;function l(u,$){const p=[];for(const d of new Set(v.Iterable.concat(u.keys(),$.keys())))u.get(d)!==$.get(d)&&p.push(d);return p}let m=class extends b.$yo{constructor($,p,d){super(),this.m=$,this.n=p,this.s=d,this.c=this.B(new i.$Gh(500));const f=r.Event.filter(p.onDidFilesChange,y=>y.affects($));this.B(p.watch($)),this.B(f(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const $=new Map;try{const p=await this.n.readFile(this.m),d=JSON.parse(p.value.toString());if(!(0,A.$jg)(d))throw new Error("Policy file isn't a JSON object");for(const f of Object.keys(d))this.f[f]&&$.set(f,d[f])}catch(p){p.fileOperationResult!==O.FileOperationResult.FILE_NOT_FOUND&&this.s.error("[FilePolicyService] Failed to read policies",p)}return $}async w(){const $=await this.u(),p=l(this.g,$);this.g=$,p.length>0&&this.h.fire(p)}};e.$Yic=m,e.$Yic=m=ke([re(1,O.$dl),re(2,I.$dk)],m)}),define(le[203],ue([0,1,4,2,40]),function(K,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vic=e.$uic=void 0;class A{constructor(b){this.b=b,this.a=new r.$Wc}listen(b,l){switch(l){case"onDidChange":return i.Event.map(this.b.onDidChange,m=>m.reduce((u,$)=>({...u,[$]:this.b.getPolicyValue($)??null}),{}),this.a)}throw new Error(`Event not found: ${l}`)}call(b,l,m){switch(l){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(m)}throw new Error(`Call not found: ${l}`)}dispose(){this.a.dispose()}}e.$uic=A;class O extends v.$yo{constructor(b,l){super(),this.a=l;for(const m in b){const{definition:u,value:$}=b[m];this.f[m]=u,$!==void 0&&this.g.set(m,$)}this.a.listen("onDidChange")(m=>{for(const u in m){const $=m[u];$===null?this.g.delete(u):this.g.set(u,$)}this.h.fire(Object.keys(m))})}async j(b){const l=await this.a.call("updatePolicyDefinitions",b);for(const m in l)this.g.set(m,l[m])}}e.$vic=O}),define(le[204],ue([0,1,40,8,2,5]),function(K,e,i,r,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xic=void 0;let O=class extends i.$yo{constructor(b,l){super(),this.m=b,this.n=l,this.a=new r.$Ch,this.b=this.B(new v.$Yc)}async j(b){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(b).length} policy definitions`);const{createWatcher:l}=await new Promise((m,u)=>{K(["@vscode/policy-watcher"],m,u)}).then(Ie);await this.a.queue(()=>new Promise((m,u)=>{try{this.b.value=l(this.n,b,$=>{this.t($),m()})}catch($){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",$),u($)}}))}t(b){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(b)}`);for(const l in b){const m=b[l];m===void 0?this.g.delete(l):this.g.set(l,m)}this.h.fire(Object.keys(b))}};e.$Xic=O,e.$Xic=O=ke([re(0,A.$dk)],O)}),define(le[63],ue([0,1,37]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let r;const v=globalThis.vscode;if(typeof v<"u"&&typeof v.context<"u"){const A=v.context.configuration();if(A)r=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(r=globalThis._VSCODE_PRODUCT_JSON,i.env.VSCODE_DEV&&Object.assign(r,{nameShort:`${r.nameShort} Dev`,nameLong:`${r.nameLong} Dev`,dataFolderName:`${r.dataFolderName}-dev`,serverDataFolderName:r.serverDataFolderName?`${r.serverDataFolderName}-dev`:void 0}),!r.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(r,{version:A.version})}}else r={},Object.keys(r).length===0&&Object.assign(r,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=r}),define(le[28],ue([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=e.$wk=void 0,e.$wk=(0,i.$Ii)("productService"),e.$xk="vscode://schemas/vscode-product"}),define(le[205],ue([0,1,8,5]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Khc=void 0;let v=class{constructor(O,I,b){this.a=O,this.b=I,this.c=b}async inspect(O){await this.d();const I=this.a.webContents.debugger;await I.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,i.$Jh)(O);const b=await I.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),b.profile}async d(){const O=this.a.webContents.debugger;O.attach(),await O.sendCommand("Profiler.enable")}async e(){const O=this.a.webContents.debugger;await O.sendCommand("Profiler.disable"),O.detach()}};e.$Khc=v,e.$Khc=v=ke([re(2,r.$dk)],v)}),define(le[74],ue([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wgc=void 0,e.$Wgc=(0,i.$Ii)("protocolMainService")}),define(le[46],ue([0,1,143,12]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vo=void 0,i=Ie(i),r=Ie(r);class v{constructor(){this.a=new Map}add(O,I){i.ok(r.$hg(O)),i.ok(r.$jg(I)),i.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,I)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.$vo=new v}),define(le[206],ue([0,1,4,145,46]),function(K,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=void 0,v=Ie(v),e.$wo={JSONContribution:"base.contributions.json"};function A(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class O{constructor(){this.b=new i.$oe,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(l,m){this.a[A(l)]=m,this.b.fire(l)}notifySchemaChanged(l){this.b.fire(l)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(l){const m=this.a[l];return m?(0,r.$$j)(m):void 0}hasSchemaContent(l){return!!this.a[l]}}const I=new O;v.$vo.add(e.$wo.JSONContribution,I)}),define(le[56],ue([0,1,21,4,12,10,16,206,46]),function(K,e,i,r,v,A,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.ConfigurationScope=e.$Ao=e.EditPresentationTypes=void 0,e.$Lo=f,e.$Mo=y,e.$No=k,e.$Oo=E,e.$Po=S,e.$Qo=s,e.$Ro=a,v=Ie(v),A=Ie(A);var l;(function(t){t.Multiline="multilineText",t.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.$Ao={Configuration:"base.contributions.configuration"};var m;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.MACHINE=2]="MACHINE",t[t.WINDOW=3]="WINDOW",t[t.RESOURCE=4]="RESOURCE",t[t.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",t[t.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(m||(e.ConfigurationScope=m={})),e.$Bo={properties:{},patternProperties:{}},e.$Co={properties:{},patternProperties:{}},e.$Do={properties:{},patternProperties:{}},e.$Eo={properties:{},patternProperties:{}},e.$Fo={properties:{},patternProperties:{}},e.$Go={properties:{},patternProperties:{}},e.$Ho="vscode://schemas/settings/resourceLanguage",e.$Io="vscode://schemas/settings/configurationDefaults";const u=b.$vo.as(I.$wo.JSONContribution);class ${constructor(){this.a=[],this.i=new Set,this.j=new r.$oe,this.onDidSchemaChange=this.j.event,this.k=new r.$oe,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:A.localize(1662,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},u.registerSchema(e.$Ho,this.h),this.z()}registerConfiguration(o,n=!0){this.registerConfigurations([o],n)}registerConfigurations(o,n=!0){const c=new Set;this.r(o,n,c),u.registerSchema(e.$Ho,this.h),this.j.fire(),this.k.fire({properties:c})}deregisterConfigurations(o){const n=new Set;this.s(o,n),u.registerSchema(e.$Ho,this.h),this.j.fire(),this.k.fire({properties:n})}updateConfigurations({add:o,remove:n}){const c=new Set;this.s(n,c),this.r(o,!1,c),u.registerSchema(e.$Ho,this.h),this.j.fire(),this.k.fire({properties:c})}registerDefaultConfigurations(o){const n=new Set;this.l(o,n),this.j.fire(),this.k.fire({properties:n,defaultsOverrides:!0})}l(o,n){this.a.push(...o);const c=[];for(const{overrides:h,source:P}of o)for(const w in h){n.add(w);const D=this.b.get(w)??this.b.set(w,{configurationDefaultOverrides:[]}).get(w),L=h[w];if(D.configurationDefaultOverrides.push({value:L,source:P}),e.$Ko.test(w)){const R=this.o(w,L,P,D.configurationDefaultOverrideValue);if(!R)continue;D.configurationDefaultOverrideValue=R,this.n(w,R,P),c.push(...f(w))}else{const R=this.p(w,L,P,D.configurationDefaultOverrideValue);if(!R)continue;D.configurationDefaultOverrideValue=R;const T=this.e[w];T&&(this.A(w,T),this.w(w,T))}}this.q(c)}deregisterDefaultConfigurations(o){const n=new Set;this.m(o,n),this.j.fire(),this.k.fire({properties:n,defaultsOverrides:!0})}m(o,n){for(const c of o){const h=this.a.indexOf(c);h!==-1&&this.a.splice(h,1)}for(const{overrides:c,source:h}of o)for(const P in c){const w=this.b.get(P);if(!w)continue;const D=w.configurationDefaultOverrides.findIndex(L=>h?L.source?.id===h.id:L.value===c[P]);if(D!==-1){if(w.configurationDefaultOverrides.splice(D,1),w.configurationDefaultOverrides.length===0&&this.b.delete(P),e.$Ko.test(P)){let L;for(const R of w.configurationDefaultOverrides)L=this.o(P,R.value,R.source,L);L&&!v.$ug(L.value)?(w.configurationDefaultOverrideValue=L,this.n(P,L,h)):(this.b.delete(P),delete this.e[P],delete this.c.properties[P])}else{let L;for(const T of w.configurationDefaultOverrides)L=this.p(P,T.value,T.source,L);w.configurationDefaultOverrideValue=L;const R=this.e[P];R&&(this.A(P,R),this.w(P,R))}n.add(P)}}this.y()}n(o,n,c){const h={type:"object",default:n.value,description:A.localize(1663,null,(0,O.$mj)(o)),$ref:e.$Ho,defaultDefaultValue:n.value,source:c,defaultValueSource:c};this.e[o]=h,this.c.properties[o]=h}o(o,n,c,h){const P=h?.value||{},w=h?.source??new Map;if(!(w instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const D of Object.keys(n)){const L=n[D];if(v.$jg(L)&&(v.$og(P[D])||v.$jg(P[D]))){if(P[D]={...P[D]??{},...L},c)for(const T in L)w.set(`${D}.${T}`,c)}else P[D]=L,c?w.set(D,c):w.delete(D)}return{value:P,source:w}}p(o,n,c,h){const P=this.e[o],w=h?.value??P?.defaultDefaultValue;let D=c;if(v.$jg(n)&&(P!==void 0&&P.type==="object"||P===void 0&&(v.$og(w)||v.$jg(w)))){if(D=h?.source??new Map,!(D instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const R in n)c&&D.set(`${o}.${R}`,c);n={...v.$jg(w)?w:{},...n}}return{value:n,source:D}}deltaConfiguration(o){let n=!1;const c=new Set;o.removedDefaults&&(this.m(o.removedDefaults,c),n=!0),o.addedDefaults&&(this.l(o.addedDefaults,c),n=!0),o.removedConfigurations&&this.s(o.removedConfigurations,c),o.addedConfigurations&&this.r(o.addedConfigurations,!1,c),this.j.fire(),this.k.fire({properties:c,defaultsOverrides:n})}notifyConfigurationSchemaUpdated(...o){this.j.fire()}registerOverrideIdentifiers(o){this.q(o),this.j.fire()}q(o){for(const n of o)this.i.add(n);this.y()}r(o,n,c){o.forEach(h=>{this.u(h,n,h.extensionInfo,h.restrictedProperties,void 0,c),this.d.push(h),this.v(h)})}s(o,n){const c=h=>{if(h.properties)for(const P in h.properties){n.add(P);const w=this.e[P];w?.policy?.name&&this.f.delete(w.policy.name),delete this.e[P],this.x(P,h.properties[P])}h.allOf?.forEach(P=>c(P))};for(const h of o){c(h);const P=this.d.indexOf(h);P!==-1&&this.d.splice(P,1)}}u(o,n=!0,c,h,P=m.WINDOW,w){P=v.$qg(o.scope)?P:o.scope;const D=o.properties;if(D)for(const R in D){const T=D[R];if(n&&E(R,T)){delete D[R];continue}if(T.source=c,T.defaultDefaultValue=D[R].default,this.A(R,T),e.$Ko.test(R)?T.scope=void 0:(T.scope=v.$qg(T.scope)?P:T.scope,T.restricted=v.$qg(T.restricted)?!!h?.includes(R):T.restricted),D[R].hasOwnProperty("included")&&!D[R].included){this.g[R]=D[R],delete D[R];continue}else this.e[R]=D[R],D[R].policy?.name&&this.f.set(D[R].policy.name,R);!D[R].deprecationMessage&&D[R].markdownDeprecationMessage&&(D[R].deprecationMessage=D[R].markdownDeprecationMessage),w.add(R)}const L=o.allOf;if(L)for(const R of L)this.u(R,n,c,h,P,w)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const o=new Map;for(const[n,c]of this.b)c.configurationDefaultOverrideValue&&o.set(n,c.configurationDefaultOverrideValue);return o}v(o){const n=c=>{const h=c.properties;if(h)for(const w in h)this.w(w,h[w]);c.allOf?.forEach(n)};n(o)}w(o,n){switch(e.$Bo.properties[o]=n,n.scope){case m.APPLICATION:e.$Co.properties[o]=n;break;case m.MACHINE:e.$Do.properties[o]=n;break;case m.MACHINE_OVERRIDABLE:e.$Eo.properties[o]=n;break;case m.WINDOW:e.$Fo.properties[o]=n;break;case m.RESOURCE:e.$Go.properties[o]=n;break;case m.LANGUAGE_OVERRIDABLE:e.$Go.properties[o]=n,this.h.properties[o]=n;break}}x(o,n){switch(delete e.$Bo.properties[o],n.scope){case m.APPLICATION:delete e.$Co.properties[o];break;case m.MACHINE:delete e.$Do.properties[o];break;case m.MACHINE_OVERRIDABLE:delete e.$Eo.properties[o];break;case m.WINDOW:delete e.$Fo.properties[o];break;case m.RESOURCE:case m.LANGUAGE_OVERRIDABLE:delete e.$Go.properties[o],delete this.h.properties[o];break}}y(){for(const o of this.i.values()){const n=`[${o}]`,c={type:"object",description:A.localize(1664,null),errorMessage:A.localize(1665,null),$ref:e.$Ho};this.A(n,c),e.$Bo.properties[n]=c,e.$Co.properties[n]=c,e.$Do.properties[n]=c,e.$Eo.properties[n]=c,e.$Fo.properties[n]=c,e.$Go.properties[n]=c}}z(){const o={type:"object",description:A.localize(1666,null),errorMessage:A.localize(1667,null),$ref:e.$Ho};e.$Bo.patternProperties[e.$Jo]=o,e.$Co.patternProperties[e.$Jo]=o,e.$Do.patternProperties[e.$Jo]=o,e.$Eo.patternProperties[e.$Jo]=o,e.$Fo.patternProperties[e.$Jo]=o,e.$Go.patternProperties[e.$Jo]=o,this.j.fire()}A(o,n){const c=this.b.get(o)?.configurationDefaultOverrideValue;let h,P;c&&(!n.disallowConfigurationDefault||!c.source)&&(h=c.value,P=c.source),v.$og(h)&&(h=n.defaultDefaultValue,P=void 0),v.$og(h)&&(h=k(n.type)),n.default=h,n.defaultValueSource=P}}const p="\\[([^\\]]+)\\]",d=new RegExp(p,"g");e.$Jo=`^(${p})+$`,e.$Ko=new RegExp(e.$Jo);function f(t){const o=[];if(e.$Ko.test(t)){let n=d.exec(t);for(;n?.length;){const c=n[1].trim();c&&o.push(c),n=d.exec(t)}}return(0,i.$Ob)(o)}function y(t){return t.reduce((o,n)=>`${o}[${n}]`,"")}function k(t){switch(Array.isArray(t)?t[0]:t){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const g=new $;b.$vo.add(e.$Ao.Configuration,g);function E(t,o){return t.trim()?e.$Ko.test(t)?A.localize(1669,null,t):g.getConfigurationProperties()[t]!==void 0?A.localize(1670,null,t):o.policy?.name&&g.getPolicyConfigurations().get(o.policy?.name)!==void 0?A.localize(1671,null,t,o.policy?.name,g.getPolicyConfigurations().get(o.policy?.name)):null:A.localize(1668,null)}function S(){const t=[],o=g.getConfigurationProperties();for(const n of Object.keys(o))t.push([n,o[n].scope]);return t.push(["launch",m.RESOURCE]),t.push(["task",m.RESOURCE]),t}function s(t){const o={};for(const n of t){const c=n.properties;if(v.$jg(c))for(const h in c)o[h]=c[h];n.allOf&&Object.assign(o,s(n.allOf))}return o}function a(t){switch(t){case"application":return m.APPLICATION;case"machine":return m.MACHINE;case"resource":return m.RESOURCE;case"machine-overridable":return m.MACHINE_OVERRIDABLE;case"language-overridable":return m.LANGUAGE_OVERRIDABLE;default:return m.WINDOW}}}),define(le[127],ue([0,1,21,4,43,2,31,38,12,7,16,56,14,46]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Vo=e.$Uo=e.$To=e.$So=void 0,e.$Wo=S,i=Ie(i),v=Ie(v),I=Ie(I),b=Ie(b);function d(o){return Object.isFrozen(o)?o:I.$jo(o)}class f{static createEmptyModel(n){return new f({},[],[],void 0,n)}constructor(n,c,h,P,w){this.b=n,this.c=c,this.d=h,this.raw=P,this.f=w,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const n=this.raw.map(c=>{if(c instanceof f)return c;const h=new y("",this.f);return h.parseRaw(c),h.configurationModel});this.g=n.reduce((c,h)=>h===c?h:c.merge(h),n[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,m.$kj)(this.contents,n):this.contents}inspect(n,c){const h=this;return{get value(){return d(h.rawConfiguration.getValue(n))},get override(){return c?d(h.rawConfiguration.getOverrideValue(n,c)):void 0},get merged(){return d(c?h.rawConfiguration.override(c).getValue(n):h.rawConfiguration.getValue(n))},get overrides(){const P=[];for(const{contents:w,identifiers:D,keys:L}of h.rawConfiguration.overrides){const R=new f(w,L,[],void 0,h.f).getValue(n);R!==void 0&&P.push({identifiers:D,value:R})}return P.length?d(P):void 0}}}getOverrideValue(n,c){const h=this.j(c);return h?n?(0,m.$kj)(h,n):h:void 0}getKeysForOverrideIdentifier(n){const c=[];for(const h of this.overrides)h.identifiers.includes(n)&&c.push(...h.keys);return i.$Ob(c)}getAllOverrideIdentifiers(){const n=[];for(const c of this.overrides)n.push(...c.identifiers);return i.$Ob(n)}override(n){let c=this.a.get(n);return c||(c=this.h(n),this.a.set(n,c)),c}merge(...n){const c=I.$io(this.contents),h=I.$io(this.overrides),P=[...this.keys],w=this.raw?.length?[...this.raw]:[this];for(const D of n)if(w.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.i(c,D.contents);for(const L of D.overrides){const[R]=h.filter(T=>i.$wb(T.identifiers,L.identifiers));R?(this.i(R.contents,L.contents),R.keys.push(...L.keys),R.keys=i.$Ob(R.keys)):h.push(I.$io(L))}for(const L of D.keys)P.indexOf(L)===-1&&P.push(L)}return new f(c,P,h,w.every(D=>D instanceof f)?void 0:w,this.f)}h(n){const c=this.j(n);if(!c||typeof c!="object"||!Object.keys(c).length)return this;const h={};for(const P of i.$Ob([...Object.keys(this.contents),...Object.keys(c)])){let w=this.contents[P];const D=c[P];D&&(typeof w=="object"&&typeof D=="object"?(w=I.$io(w),this.i(w,D)):w=D),h[P]=w}return new f(h,this.keys,this.overrides,void 0,this.f)}i(n,c){for(const h of Object.keys(c)){if(h in n&&b.$jg(n[h])&&b.$jg(c[h])){this.i(n[h],c[h]);continue}n[h]=I.$io(c[h])}}j(n){let c=null,h=null;const P=w=>{w&&(h?this.i(h,w):h=I.$io(w))};for(const w of this.overrides)w.identifiers.length===1&&w.identifiers[0]===n?c=w.contents:w.identifiers.includes(n)&&P(w.contents);return P(c),h}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,c){this.k(n,c,!0)}setValue(n,c){this.k(n,c,!1)}removeValue(n){const c=this.keys.indexOf(n);c!==-1&&(this.keys.splice(c,1),(0,m.$jj)(this.contents,n),u.$Ko.test(n)&&this.overrides.splice(this.overrides.findIndex(h=>i.$wb(h.identifiers,(0,u.$Lo)(n))),1))}k(n,c,h){if((0,m.$ij)(this.contents,n,c,P=>this.f.error(P)),h=h||this.keys.indexOf(n)===-1,h&&this.keys.push(n),u.$Ko.test(n)){const P=(0,u.$Lo)(n),w={identifiers:P,keys:Object.keys(this.contents[n]),contents:(0,m.$hj)(this.contents[n],L=>this.f.error(L))},D=this.overrides.findIndex(L=>i.$wb(L.identifiers,P));D!==-1?this.overrides[D]=w:this.overrides.push(w)}}}e.$So=f;class y{constructor(n,c){this.f=n,this.g=c,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||f.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,c){if(!b.$qg(n)){const h=this.h(n);this.parseRaw(h,c)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,c){this.a=n;const{contents:h,keys:P,overrides:w,restricted:D,hasExcludedProperties:L}=this.i(n,c);this.b=new f(h,P,w,L?[n]:void 0,this.g),this.c=D||[]}h(n){let c={},h=null,P=[];const w=[],D=[];function L(T){Array.isArray(P)?P.push(T):h!==null&&(P[h]=T)}const R={onObjectBegin:()=>{const T={};L(T),w.push(P),P=T,h=null},onObjectProperty:T=>{h=T},onObjectEnd:()=>{P=w.pop()},onArrayBegin:()=>{const T=[];L(T),w.push(P),P=T,h=null},onArrayEnd:()=>{P=w.pop()},onLiteralValue:L,onError:(T,j,G)=>{D.push({error:T,offset:j,length:G})}};if(n)try{v.$0n(n,R),c=P[0]||{}}catch(T){this.g.error(`Error while parsing settings file ${this.f}: ${T}`),this.d=[T]}return c}i(n,c){const h=p.$vo.as(u.$Ao.Configuration).getConfigurationProperties(),P=this.j(n,h,!0,c);n=P.raw;const w=(0,m.$hj)(n,R=>this.g.error(`Conflict in settings file ${this.f}: ${R}`)),D=Object.keys(n),L=this.l(n,R=>this.g.error(`Conflict in settings file ${this.f}: ${R}`));return{contents:w,keys:D,overrides:L,restricted:P.restricted,hasExcludedProperties:P.hasExcludedProperties}}j(n,c,h,P){let w=!1;if(!P?.scopes&&!P?.skipRestricted&&!P?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:w};const D={},L=[];for(const R in n)if(u.$Ko.test(R)&&h){const T=this.j(n[R],c,!1,P);D[R]=T.raw,w=w||T.hasExcludedProperties,L.push(...T.restricted)}else{const T=c[R],j=T?typeof T.scope<"u"?T.scope:u.ConfigurationScope.WINDOW:void 0;T?.restricted&&L.push(R),!P.exclude?.includes(R)&&(P.include?.includes(R)||(j===void 0||P.scopes===void 0||P.scopes.includes(j))&&!(P.skipRestricted&&T?.restricted))?D[R]=n[R]:w=!0}return{raw:D,restricted:L,hasExcludedProperties:w}}l(n,c){const h=[];for(const P of Object.keys(n))if(u.$Ko.test(P)){const w={};for(const D in n[P])w[D]=n[P][D];h.push({identifiers:(0,u.$Lo)(P),keys:Object.keys(w),contents:(0,m.$hj)(w,c)})}return h}}e.$To=y;class k extends A.$Xc{constructor(n,c,h,P,w){super(),this.c=n,this.f=c,this.g=P,this.h=w,this.b=this.B(new r.$oe),this.onDidChange=this.b.event,this.a=new y(this.c.toString(),w),this.B(this.g.watch(h.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(r.Event.any(r.Event.filter(this.g.onDidFilesChange,D=>D.contains(this.c)),r.Event.filter(this.g.onDidRunOperation,D=>(D.isOperation($.FileOperation.CREATE)||D.isOperation($.FileOperation.COPY)||D.isOperation($.FileOperation.DELETE)||D.isOperation($.FileOperation.WRITE))&&h.isEqual(D.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return f.createEmptyModel(this.h)}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Uo=k;class g{constructor(n,c,h,P,w,D,L,R,T,j,G,q,Q){this.a=n,this.b=c,this.c=h,this.overrideIdentifiers=P,this.d=w,this.f=D,this.g=L,this.h=R,this.i=T,this.j=j,this.k=G,this.l=q,this.m=Q}get value(){return d(this.c)}n(n){return n?.value!==void 0||n?.override!==void 0||n?.overrides!==void 0?n:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class E{constructor(n,c,h,P,w,D,L,R,T,j){this.j=n,this.l=c,this.m=h,this.n=P,this.p=w,this.q=D,this.r=L,this.s=R,this.t=T,this.u=j,this.h=null,this.i=new O.$Dc,this.v=null}getValue(n,c,h){return this.w(n,c,h).getValue(n)}updateValue(n,c,h={}){let P;h.resource?(P=this.t.get(h.resource),P||(P=f.createEmptyModel(this.u),this.t.set(h.resource,P))):P=this.s,c===void 0?P.removeValue(n):P.setValue(n,c),h.resource||(this.h=null)}inspect(n,c,h){const P=this.w(n,c,h),w=this.A(c.resource,h),D=c.resource?this.t.get(c.resource)||this.s:this.s,L=new Set;for(const R of P.overrides)for(const T of R.identifiers)P.getOverrideValue(n,T)!==void 0&&L.add(T);return new g(n,c,P.getValue(n),L.size?[...L]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,h?this.q:void 0,w||void 0,D)}keys(n){const c=this.A(void 0,n);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:c?c.keys.slice(0):[]}}updateDefaultConfiguration(n){this.j=n,this.h=null,this.i.clear()}updatePolicyConfiguration(n){this.l=n}updateApplicationConfiguration(n){this.m=n,this.h=null,this.i.clear()}updateLocalUserConfiguration(n){this.n=n,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(n){this.p=n,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(n){this.q=n,this.h=null,this.i.clear()}updateFolderConfiguration(n,c){this.r.set(n,c),this.i.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this.i.delete(n)}compareAndUpdateDefaultConfiguration(n,c){const h=[];if(!c){const{added:P,updated:w,removed:D}=a(this.j,n);c=[...P,...w,...D]}for(const P of c)for(const w of(0,u.$Lo)(P)){const D=this.j.getKeysForOverrideIdentifier(w),L=n.getKeysForOverrideIdentifier(w),R=[...L.filter(T=>D.indexOf(T)===-1),...D.filter(T=>L.indexOf(T)===-1),...D.filter(T=>!I.$mo(this.j.override(w).getValue(T),n.override(w).getValue(T)))];h.push([w,R])}return this.updateDefaultConfiguration(n),{keys:c,overrides:h}}compareAndUpdatePolicyConfiguration(n){const{added:c,updated:h,removed:P}=a(this.l,n),w=[...c,...h,...P];return w.length&&this.updatePolicyConfiguration(n),{keys:w,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:c,updated:h,removed:P,overrides:w}=a(this.applicationConfiguration,n),D=[...c,...h,...P];return D.length&&this.updateApplicationConfiguration(n),{keys:D,overrides:w}}compareAndUpdateLocalUserConfiguration(n){const{added:c,updated:h,removed:P,overrides:w}=a(this.localUserConfiguration,n),D=[...c,...h,...P];return D.length&&this.updateLocalUserConfiguration(n),{keys:D,overrides:w}}compareAndUpdateRemoteUserConfiguration(n){const{added:c,updated:h,removed:P,overrides:w}=a(this.remoteUserConfiguration,n),D=[...c,...h,...P];return D.length&&this.updateRemoteUserConfiguration(n),{keys:D,overrides:w}}compareAndUpdateWorkspaceConfiguration(n){const{added:c,updated:h,removed:P,overrides:w}=a(this.workspaceConfiguration,n),D=[...c,...h,...P];return D.length&&this.updateWorkspaceConfiguration(n),{keys:D,overrides:w}}compareAndUpdateFolderConfiguration(n,c){const h=this.folderConfigurations.get(n),{added:P,updated:w,removed:D,overrides:L}=a(h,c),R=[...P,...w,...D];return(R.length||!h)&&this.updateFolderConfiguration(n,c),{keys:R,overrides:L}}compareAndDeleteFolderConfiguration(n){const c=this.folderConfigurations.get(n);if(!c)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:h,updated:P,removed:w,overrides:D}=a(c,void 0);return{keys:[...h,...P,...w],overrides:D}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(n,c,h){let P=this.x(c,h);return c.overrideIdentifier&&(P=P.override(c.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(n)!==void 0&&(P=P.merge(this.l)),P}x({resource:n},c){let h=this.y();if(c&&n){const P=c.getFolder(n);P&&(h=this.z(P.uri)||h);const w=this.t.get(n);w&&(h=h.merge(w))}return h}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(n){let c=this.i.get(n);if(!c){const h=this.y(),P=this.r.get(n);P?(c=h.merge(P),this.i.set(n,c)):c=h}return c}A(n,c){if(c&&n){const h=c.getFolder(n);if(h)return this.r.get(h.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((n,c)=>{const{contents:h,overrides:P,keys:w}=this.r.get(c);return n.push([c,{contents:h,overrides:P,keys:w}]),n},[])}}allKeys(){const n=new Set;return this.j.keys.forEach(c=>n.add(c)),this.userConfiguration.keys.forEach(c=>n.add(c)),this.q.keys.forEach(c=>n.add(c)),this.r.forEach(c=>c.keys.forEach(h=>n.add(h))),[...n.values()]}B(){const n=new Set;return this.j.getAllOverrideIdentifiers().forEach(c=>n.add(c)),this.userConfiguration.getAllOverrideIdentifiers().forEach(c=>n.add(c)),this.q.getAllOverrideIdentifiers().forEach(c=>n.add(c)),this.r.forEach(c=>c.getAllOverrideIdentifiers().forEach(h=>n.add(h))),[...n.values()]}D(n){const c=new Set;return this.j.getKeysForOverrideIdentifier(n).forEach(h=>c.add(h)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(h=>c.add(h)),this.q.getKeysForOverrideIdentifier(n).forEach(h=>c.add(h)),this.r.forEach(h=>h.getKeysForOverrideIdentifier(n).forEach(P=>c.add(P))),[...c.values()]}static parse(n,c){const h=this.E(n.defaults,c),P=this.E(n.policy,c),w=this.E(n.application,c),D=this.E(n.user,c),L=this.E(n.workspace,c),R=n.folders.reduce((T,j)=>(T.set(l.URI.revive(j[0]),this.E(j[1],c)),T),new O.$Dc);return new E(h,P,w,D,f.createEmptyModel(c),L,R,f.createEmptyModel(c),new O.$Dc,c)}static E(n,c){return new f(n.contents,n.keys,n.overrides,void 0,c)}}e.$Vo=E;function S(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,c=new Map;for(const P of o)P.keys.forEach(w=>n.add(w)),P.overrides.forEach(([w,D])=>{const L=(0,O.$Ac)(c,w,new Set);D.forEach(R=>L.add(R))});const h=[];return c.forEach((P,w)=>h.push([w,[...P.values()]])),{keys:[...n.values()],overrides:h}}class s{constructor(n,c,h,P,w){this.change=n,this.f=c,this.g=h,this.h=P,this.i=w,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const D of n.keys)this.affectedKeys.add(D);for(const[,D]of n.overrides)for(const L of D)this.affectedKeys.add(L);this.d=this.a;for(const D of this.affectedKeys)this.d+=D+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=E.parse(this.f.data,this.i)),this.j}affectsConfiguration(n,c){const h=this.a+n,P=this.d.indexOf(h);if(P<0)return!1;const w=P+h.length;if(w>=this.d.length)return!1;const D=this.d.charCodeAt(w);if(D!==this.b&&D!==this.c)return!1;if(c){const L=this.previousConfiguration?this.previousConfiguration.getValue(n,c,this.f?.workspace):void 0,R=this.g.getValue(n,c,this.h);return!I.$mo(L,R)}return!0}}e.$Xo=s;function a(o,n){const{added:c,removed:h,updated:P}=t(n?.rawConfiguration,o?.rawConfiguration),w=[],D=o?.getAllOverrideIdentifiers()||[],L=n?.getAllOverrideIdentifiers()||[];if(n){const R=L.filter(T=>!D.includes(T));for(const T of R)w.push([T,n.getKeysForOverrideIdentifier(T)])}if(o){const R=D.filter(T=>!L.includes(T));for(const T of R)w.push([T,o.getKeysForOverrideIdentifier(T)])}if(n&&o){for(const R of D)if(L.includes(R)){const T=t({contents:o.getOverrideValue(void 0,R)||{},keys:o.getKeysForOverrideIdentifier(R)},{contents:n.getOverrideValue(void 0,R)||{},keys:n.getKeysForOverrideIdentifier(R)});w.push([R,[...T.added,...T.removed,...T.updated]])}}return{added:c,removed:h,updated:P,overrides:w}}function t(o,n){const c=o?n?o.keys.filter(w=>n.keys.indexOf(w)===-1):[...o.keys]:[],h=n?o?n.keys.filter(w=>o.keys.indexOf(w)===-1):[...n.keys]:[],P=[];if(o&&n){for(const w of n.keys)if(o.keys.indexOf(w)!==-1){const D=(0,m.$kj)(n.contents,w),L=(0,m.$kj)(o.contents,w);I.$mo(D,L)||P.push(w)}}return{added:c,removed:h,updated:P}}}),define(le[207],ue([0,1,21,4,2,38,12,127,56,5,40,46]),function(K,e,i,r,v,A,O,I,b,l,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=e.$Zo=e.$Yo=void 0;class $ extends v.$Xc{get configurationModel(){return this.b}constructor(y){super(),this.c=y,this.a=this.B(new r.$oe),this.onDidChangeConfiguration=this.a.event,this.b=I.$So.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(u.$vo.as(b.$Ao.Configuration).onDidUpdateConfiguration(({properties:y,defaultsOverrides:k})=>this.f(Array.from(y),k))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(y,k){this.j(y,u.$vo.as(b.$Ao.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:y})}g(){return{}}h(){this.b=I.$So.createEmptyModel(this.c);const y=u.$vo.as(b.$Ao.Configuration).getConfigurationProperties();this.j(Object.keys(y),y)}j(y,k){const g=this.g();for(const E of y){const S=g[E],s=k[E];S!==void 0?this.b.setValue(E,S):s?this.b.setValue(E,s.default):this.b.removeValue(E)}}}e.$Yo=$;class p{constructor(){this.onDidChangeConfiguration=r.Event.None,this.configurationModel=I.$So.createEmptyModel(new l.$qk)}async initialize(){return this.configurationModel}}e.$Zo=p;let d=class extends v.$Xc{get configurationModel(){return this.b}constructor(y,k,g){super(),this.c=y,this.f=k,this.g=g,this.a=this.B(new r.$oe),this.onDidChangeConfiguration=this.a.event,this.b=I.$So.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(y=>this.j(y))),this.B(this.c.onDidChangeConfiguration(async({properties:y})=>this.m(await this.h(y),!0))),this.b}async h(y){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",y);const k={},g=[],E=u.$vo.as(b.$Ao.Configuration).getConfigurationProperties();for(const S of y){const s=E[S];if(!s){g.push(S);continue}if(s.policy){if(s.type!=="string"&&s.type!=="number"){this.g.warn(`Policy ${s.policy.name} has unsupported type ${s.type}`);continue}g.push(S),k[s.policy.name]={type:s.type}}}return(0,O.$ug)(k)||await this.f.updatePolicyDefinitions(k),g}j(y){this.g.trace("PolicyConfiguration#onDidChangePolicies",y);const k=u.$vo.as(b.$Ao.Configuration).getPolicyConfigurations(),g=(0,i.$Jb)(y.map(E=>k.get(E)));this.m(g,!0)}m(y,k){this.g.trace("PolicyConfiguration#update",y);const g=u.$vo.as(b.$Ao.Configuration).getConfigurationProperties(),E=[],S=this.b.isEmpty();for(const s of y){const a=g[s]?.policy?.name;if(a){const t=this.f.getPolicyValue(a);(S?t!==void 0:!(0,A.$mo)(this.b.getValue(s),t))&&E.push([s,t])}else this.b.getValue(s)!==void 0&&E.push([s,void 0])}if(E.length){this.g.trace("PolicyConfiguration#changed",E);const s=this.b;this.b=I.$So.createEmptyModel(this.g);for(const a of s.keys)this.b.setValue(a,s.getValue(a));for(const[a,t]of E)t===void 0?this.b.removeValue(a):this.b.setValue(a,t);k&&this.a.fire(this.b)}}};e.$1o=d,e.$1o=d=ke([re(1,m.$xo),re(2,l.$dk)],d)}),define(le[208],ue([0,1,21,8,17,4,43,110,2,31,38,3,18,16,127,56,207,14,40]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p,d,f,y,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=void 0;class E extends b.$Xc{constructor(a,t,o,n){super(),this.m=a,this.n=n,this.h=this.B(new A.$oe),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new y.$Yo(n)),this.c=o instanceof g.$zo?new y.$Zo:this.B(new y.$1o(this.b,o,n)),this.f=this.B(new d.$Uo(this.m,{},$.$ah,t,n)),this.a=new d.$Vo(this.b.configurationModel,this.c.configurationModel,d.$So.createEmptyModel(n),d.$So.createEmptyModel(n),d.$So.createEmptyModel(n),d.$So.createEmptyModel(n),new l.$Dc,d.$So.createEmptyModel(n),new l.$Dc,n),this.j=new S(a,t,this),this.g=this.B(new r.$Uh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:c,properties:h})=>this.s(c,h))),this.B(this.c.onDidChangeConfiguration(c=>this.t(c))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[a,t,o]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new d.$Vo(a,t,d.$So.createEmptyModel(this.n),o,d.$So.createEmptyModel(this.n),d.$So.createEmptyModel(this.n),new l.$Dc,d.$So.createEmptyModel(this.n),new l.$Dc,this.n)}getConfigurationData(){return this.a.toData()}getValue(a,t){const o=typeof a=="string"?a:void 0,n=(0,p.$dj)(a)?a:(0,p.$dj)(t)?t:{};return this.a.getValue(o,n,void 0)}async updateValue(a,t,o,n,c){const h=(0,p.$ej)(o)?o:(0,p.$dj)(o)?{resource:o.resource,overrideIdentifiers:o.overrideIdentifier?[o.overrideIdentifier]:void 0}:void 0,P=h?n:o;if(P!==void 0&&P!==p.ConfigurationTarget.USER_LOCAL&&P!==p.ConfigurationTarget.USER)throw new Error(`Unable to write ${a} to target ${P}.`);h?.overrideIdentifiers&&(h.overrideIdentifiers=(0,i.$Ob)(h.overrideIdentifiers),h.overrideIdentifiers=h.overrideIdentifiers.length?h.overrideIdentifiers:void 0);const w=this.inspect(a,{resource:h?.resource,overrideIdentifier:h?.overrideIdentifiers?h.overrideIdentifiers[0]:void 0});if(w.policyValue!==void 0)throw new Error(`Unable to write ${a} because it is configured in system policy.`);if((0,m.$mo)(t,w.defaultValue)&&(t=void 0),h?.overrideIdentifiers?.length&&h.overrideIdentifiers.length>1){const L=h.overrideIdentifiers.sort(),R=this.a.localUserConfiguration.overrides.find(T=>(0,i.$wb)([...T.identifiers].sort(),L));R&&(h.overrideIdentifiers=R.identifiers)}const D=h?.overrideIdentifiers?.length?[(0,f.$Mo)(h.overrideIdentifiers),a]:[a];await this.j.write(D,t),await this.reloadConfiguration()}inspect(a,t={}){return this.a.inspect(a,t,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const a=await this.f.loadConfiguration();this.r(a)}r(a){const t=this.a.toData(),o=this.a.compareAndUpdateLocalUserConfiguration(a);this.u(o,t,p.ConfigurationTarget.USER)}s(a,t){const o=this.a.toData(),n=this.a.compareAndUpdateDefaultConfiguration(a,t);this.u(n,o,p.ConfigurationTarget.DEFAULT)}t(a){const t=this.a.toData(),o=this.a.compareAndUpdatePolicyConfiguration(a);this.u(o,t,p.ConfigurationTarget.DEFAULT)}u(a,t,o){const n=new d.$Xo(a,{data:t},this.a,void 0,this.n);n.source=o,this.h.fire(n)}}e.$2o=E;class S{constructor(a,t,o){this.b=a,this.c=t,this.d=o,this.a=new r.$Ph}write(a,t){return this.a.queue(()=>this.e(a,t))}async e(a,t){let o;try{o=(await this.c.readFile(this.b)).value.toString()}catch(h){if(h.fileOperationResult===k.FileOperationResult.FILE_NOT_FOUND)o="{}";else throw h}const n=[];if((0,O.$3n)(o,n,{allowTrailingComma:!0,allowEmptyContent:!0}),n.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const c=this.f(o,a,t);o=(0,I.$ho)(o,c),await this.c.writeFile(this.b,v.$Qe.fromString(o))}f(a,t,o){const{tabSize:n,insertSpaces:c,eol:h}=this.h;if(!t.length){const P=JSON.stringify(o,null,c?" ".repeat(n):"	");return[{content:P,length:P.length,offset:0}]}return(0,I.$eo)(a,t,o,{tabSize:n,insertSpaces:c,eol:h})}get h(){if(!this.g){let a=u.OS===u.OperatingSystem.Linux||u.OS===u.OperatingSystem.Macintosh?`
`:`\r
`;const t=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});t&&typeof t=="string"&&t!=="auto"&&(a=t),this.g={eol:a,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(le[209],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mic=e.$Lic=e.$Kic=void 0,e.$Kic="request",e.$Lic="remoteResourceHandler";class i{async routeCall(v,A,O){if(A!==e.$Kic)throw new Error(`Call not found: ${A}`);const I=O[0];if(I?.authority){const b=v.connections.find(l=>l.ctx===I.authority);if(b)return b}throw new Error("Caller not found")}routeEvent(v,A){throw new Error(`Event not found: ${A}`)}}e.$Mic=i}),define(le[210],ue([0,1,15,6]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xl=e.RemoteAuthorityResolverErrorCode=e.$Wl=e.$Vl=e.RemoteConnectionType=e.$Ul=void 0,e.$Yl=l,e.$Ul=(0,r.$Ii)("remoteAuthorityResolverService");var v;(function(m){m[m.WebSocket=0]="WebSocket",m[m.Managed=1]="Managed"})(v||(e.RemoteConnectionType=v={}));class A{constructor(u){this.id=u,this.type=v.Managed}toString(){return`Managed(${this.id})`}}e.$Vl=A;class O{constructor(u,$){this.host=u,this.port=$,this.type=v.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Wl=O;var I;(function(m){m.Unknown="Unknown",m.NotAvailable="NotAvailable",m.TemporarilyNotAvailable="TemporarilyNotAvailable",m.NoResolverFound="NoResolverFound",m.InvalidAuthority="InvalidAuthority"})(I||(e.RemoteAuthorityResolverErrorCode=I={}));class b extends i.$db{static isNotAvailable(u){return u instanceof b&&u._code===I.NotAvailable}static isTemporarilyNotAvailable(u){return u instanceof b&&u._code===I.TemporarilyNotAvailable}static isNoResolverFound(u){return u instanceof b&&u._code===I.NoResolverFound}static isInvalidAuthority(u){return u instanceof b&&u._code===I.InvalidAuthority}static isHandled(u){return u instanceof b&&u.isHandled}constructor(u,$=I.Unknown,p){super(u),this._message=u,this._code=$,this._detail=p,this.isHandled=$===I.NotAvailable&&p===!0,Object.setPrototypeOf(this,b.prototype)}}e.$Xl=b;function l(m){const u=m.indexOf("+");return u===-1?m:m.substring(0,u)}}),define(le[211],ue([0,1,8,17,22,15,4,2,11,72,60,33,120,210]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$4l=w,e.$5l=D,e.$6l=R,l=Ie(l);const d=30*1e3;var f;(function(oe){oe[oe.Management=1]="Management",oe[oe.ExtensionHost=2]="ExtensionHost",oe[oe.Tunnel=3]="Tunnel"})(f||(e.ConnectionType=f={}));function y(oe){switch(oe){case f.Management:return"Management";case f.ExtensionHost:return"ExtensionHost";case f.Tunnel:return"Tunnel"}}function k(oe){const J=new v.$ze;return setTimeout(()=>J.cancel(),oe),J.token}function g(oe,J){if(oe.isCancellationRequested||J.isCancellationRequested)return v.CancellationToken.Cancelled;const M=new v.$ze;return oe.onCancellationRequested(()=>M.cancel()),J.onCancellationRequested(()=>M.cancel()),M.token}class E{get didTimeout(){return this.c==="timedout"}constructor(J){this.c="pending",this.d=new I.$Wc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,i.$Bh)(),J.isCancellationRequested?this.h():this.d.add(J.onCancellationRequested(()=>this.h()))}registerDisposable(J){this.c==="pending"?this.d.add(J):J.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const J=new Error("Time limit reached");return J.code="ETIMEDOUT",J.syscall="connect",J}resolve(J){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(J))}reject(J){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(J))}}function S(oe,J){const M=new E(J);return M.registerDisposable(oe.onControlMessage(Z=>{const U=JSON.parse(Z.toString()),N=W(U);N?M.reject(N):M.resolve(U)})),M.promise}function s(oe,J,M,Z,U,N,ie,X){const z=new E(X),te=m.$ie.create(!1);return oe.info(`Creating a socket (${ie})...`),l.mark(`code/willCreateSocket/${N}`),J.connect(M,Z,U,ie).then(ae=>{z.didTimeout?(l.mark(`code/didCreateSocketError/${N}`),oe.info(`Creating a socket (${ie}) finished after ${te.elapsed()} ms, but this is too late and has timed out already.`),ae?.dispose()):(l.mark(`code/didCreateSocketOK/${N}`),oe.info(`Creating a socket (${ie}) was successful after ${te.elapsed()} ms.`),z.resolve(ae))},ae=>{l.mark(`code/didCreateSocketError/${N}`),oe.info(`Creating a socket (${ie}) returned an error after ${te.elapsed()} ms.`),oe.error(ae),z.reject(ae)}),z.promise}function a(oe,J){const M=new E(J);return oe.then(Z=>{M.didTimeout||M.resolve(Z)},Z=>{M.didTimeout||M.reject(Z)}),M.promise}async function t(oe,J,M,Z){const U=x(oe,J);oe.logService.trace(`${U} 1/6. invoking socketFactory.connect().`);let N;try{N=await s(oe.logService,oe.remoteSocketFactoryService,oe.connectTo,b.$Vg.getServerRootPath(),`reconnectionToken=${oe.reconnectionToken}&reconnection=${oe.reconnectionProtocol?"true":"false"}`,y(J),`renderer-${y(J)}-${oe.reconnectionToken}`,Z)}catch(ae){throw oe.logService.error(`${U} socketFactory.connect() failed or timed out. Error:`),oe.logService.error(ae),ae}oe.logService.trace(`${U} 2/6. socketFactory.connect() was successful.`);let ie,X;oe.reconnectionProtocol?(oe.reconnectionProtocol.beginAcceptReconnection(N,null),ie=oe.reconnectionProtocol,X=!1):(ie=new $.$wi({socket:N}),X=!0),oe.logService.trace(`${U} 3/6. sending AuthRequest control message.`);const z=await a(oe.signService.createNewMessage((0,u.$5g)()),Z),te={type:"auth",auth:oe.connectionToken||"00000000000000000000",data:z.data};ie.sendControl(r.$Qe.fromString(JSON.stringify(te)));try{const ae=await S(ie,g(Z,k(1e4)));if(ae.type!=="sign"||typeof ae.data!="string"){const Fe=new Error("Unexpected handshake message");throw Fe.code="VSCODE_CONNECTION_ERROR",Fe}if(oe.logService.trace(`${U} 4/6. received SignRequest control message.`),!await a(oe.signService.validate(z,ae.signedData),Z)){const Fe=new Error("Refused to connect to unsupported server");throw Fe.code="VSCODE_CONNECTION_ERROR",Fe}const be=await a(oe.signService.sign(ae.data),Z),ye={type:"connectionType",commit:oe.commit,signedData:be,desiredConnectionType:J};return M&&(ye.args=M),oe.logService.trace(`${U} 5/6. sending ConnectionTypeRequest control message.`),ie.sendControl(r.$Qe.fromString(JSON.stringify(ye))),{protocol:ie,ownsProtocol:X}}catch(ae){throw ae&&ae.code==="ETIMEDOUT"&&(oe.logService.error(`${U} the handshake timed out. Error:`),oe.logService.error(ae)),ae&&ae.code==="VSCODE_CONNECTION_ERROR"&&(oe.logService.error(`${U} received error control message when negotiating connection. Error:`),oe.logService.error(ae)),X&&C(ie),ae}}async function o(oe,J,M,Z){const U=Date.now(),N=x(oe,J),{protocol:ie,ownsProtocol:X}=await t(oe,J,M,Z),z=new E(Z);return z.registerDisposable(ie.onControlMessage(te=>{const ae=JSON.parse(te.toString()),me=W(ae);me?(oe.logService.error(`${N} received error control message when negotiating connection. Error:`),oe.logService.error(me),X&&C(ie),z.reject(me)):(oe.reconnectionProtocol?.endAcceptReconnection(),oe.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${ce(U)}!`),z.resolve({protocol:ie,firstMessage:ae}))})),z.promise}async function n(oe,J){const{protocol:M}=await o(oe,f.Management,void 0,J);return{protocol:M}}async function c(oe,J,M){const{protocol:Z,firstMessage:U}=await o(oe,f.ExtensionHost,J,M),N=U&&U.debugPort;return{protocol:Z,debugPort:N}}async function h(oe,J,M){const Z=Date.now(),U=x(oe,f.Tunnel),{protocol:N}=await t(oe,f.Tunnel,J,M);return oe.logService.trace(`${U} 6/6. handshake finished, connection is up and running after ${ce(Z)}!`),N}async function P(oe,J,M){const{connectTo:Z,connectionToken:U}=await oe.addressProvider.getAddress();return{commit:oe.commit,quality:oe.quality,connectTo:Z,connectionToken:U,reconnectionToken:J,reconnectionProtocol:M,remoteSocketFactoryService:oe.remoteSocketFactoryService,signService:oe.signService,logService:oe.logService}}async function w(oe,J,M){return L(oe,async Z=>{const{protocol:U}=await n(Z,v.CancellationToken.None);return new B(oe,J,M,Z.reconnectionToken,U)})}async function D(oe,J){return L(oe,async M=>{const{protocol:Z,debugPort:U}=await c(M,J,v.CancellationToken.None);return new _(oe,J,M.reconnectionToken,Z,U)})}async function L(oe,J){for(let Z=1;;Z++)try{const U=(0,u.$5g)(),N=await P(oe,U,null);return await J(N)}catch(U){if(Z<5)oe.logService.error(`[remote-connection][attempt ${Z}] An error occurred in initial connection! Will retry... Error:`),oe.logService.error(U);else throw oe.logService.error(`[remote-connection][attempt ${Z}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),oe.logService.error(U),Y.triggerPermanentFailure(0,0,p.$Xl.isHandled(U)),U}}async function R(oe,J,M){const Z=await P(oe,(0,u.$5g)(),null);return await h(Z,{host:J,port:M},v.CancellationToken.None)}function T(oe){return(0,i.$vh)(J=>new Promise((M,Z)=>{const U=setTimeout(M,oe*1e3);J.onCancellationRequested(()=>{clearTimeout(U),M()})}))}var j;(function(oe){oe[oe.ConnectionLost=0]="ConnectionLost",oe[oe.ReconnectionWait=1]="ReconnectionWait",oe[oe.ReconnectionRunning=2]="ReconnectionRunning",oe[oe.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",oe[oe.ConnectionGain=4]="ConnectionGain"})(j||(e.PersistentConnectionEventType=j={}));class G{constructor(J,M){this.reconnectionToken=J,this.millisSinceLastIncomingData=M,this.type=j.ConnectionLost}}e.$7l=G;class q{constructor(J,M,Z,U){this.reconnectionToken=J,this.millisSinceLastIncomingData=M,this.durationSeconds=Z,this.c=U,this.type=j.ReconnectionWait}skipWait(){this.c.cancel()}}e.$8l=q;class Q{constructor(J,M,Z){this.reconnectionToken=J,this.millisSinceLastIncomingData=M,this.attempt=Z,this.type=j.ReconnectionRunning}}e.$9l=Q;class de{constructor(J,M,Z){this.reconnectionToken=J,this.millisSinceLastIncomingData=M,this.attempt=Z,this.type=j.ConnectionGain}}e.$0l=de;class V{constructor(J,M,Z,U){this.reconnectionToken=J,this.millisSinceLastIncomingData=M,this.attempt=Z,this.handled=U,this.type=j.ReconnectionPermanentFailure}}e.$$l=V;class Y extends I.$Xc{static triggerPermanentFailure(J,M,Z){this._permanentFailure=!0,this.f=J,this.g=M,this.h=Z,this.j.forEach(U=>U.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(J=>J.y())}static debugPauseSocketWriting(){this.j.forEach(J=>J.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||Y._permanentFailure}constructor(J,M,Z,U,N){super(),this.t=J,this.u=M,this.reconnectionToken=Z,this.protocol=U,this.w=N,this.m=this.B(new O.$oe),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new de(this.reconnectionToken,0,0)),this.B(U.onSocketClose(ie=>{const X=ne(this.t,this.reconnectionToken,!0);ie?ie.type===$.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${X} received socket close event (hadError: ${ie.hadError}).`),ie.error&&this.u.logService.error(ie.error)):(this.u.logService.info(`${X} received socket close event (wasClean: ${ie.wasClean}, code: ${ie.code}, reason: ${ie.reason}).`),ie.event&&this.u.logService.error(ie.event)):this.u.logService.info(`${X} received socket close event.`),this.y()})),this.B(U.onSocketTimeout(ie=>{const X=ne(this.t,this.reconnectionToken,!0);this.u.logService.info(`${X} received socket timeout event (unacknowledgedMsgCount: ${ie.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ie.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ie.timeSinceLastReceivedSomeData}).`),this.y()})),Y.j.push(this),this.B((0,I.$Vc)(()=>{const ie=Y.j.indexOf(this);ie>=0&&Y.j.splice(ie,1)})),this.n&&this.D(Y.f,Y.g,Y.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const J=ne(this.t,this.reconnectionToken,!0);this.u.logService.info(`${J} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new G(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const M=[0,5,5,10,10,10,10,10,30];let Z=-1;do{Z++;const U=Z<M.length?M[Z]:M[M.length-1];try{if(U>0){const ie=T(U);this.m.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),U,ie)),this.u.logService.info(`${J} waiting for ${U} seconds before reconnecting...`);try{await ie}catch{}}if(this.n){this.u.logService.error(`${J} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Z+1)),this.u.logService.info(`${J} resolving connection...`);const N=await P(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${J} connecting to ${N.connectTo}...`),await this.G(N,k(d)),this.u.logService.info(`${J} reconnected!`),this.m.fire(new de(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Z+1));break}catch(N){if(N.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${J} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(N),this.C(this.protocol.getMillisSinceLastIncomingData(),Z+1,!1);break}if(Z>360){this.u.logService.error(`${J} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(N),this.C(this.protocol.getMillisSinceLastIncomingData(),Z+1,!1);break}if(p.$Xl.isTemporarilyNotAvailable(N)){this.u.logService.info(`${J} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(N);continue}if((N.code==="ETIMEDOUT"||N.code==="ENETUNREACH"||N.code==="ECONNREFUSED"||N.code==="ECONNRESET")&&N.syscall==="connect"){this.u.logService.info(`${J} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(N);continue}if((0,A.$6)(N)){this.u.logService.info(`${J} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(N);continue}if(N instanceof p.$Xl){this.u.logService.error(`${J} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(N),this.C(this.protocol.getMillisSinceLastIncomingData(),Z+1,p.$Xl.isHandled(N));break}this.u.logService.error(`${J} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(N),this.C(this.protocol.getMillisSinceLastIncomingData(),Z+1,!1);break}}while(!this.n&&!this.s)}C(J,M,Z){this.w?Y.triggerPermanentFailure(J,M,Z):this.D(J,M,Z)}D(J,M,Z){this.m.fire(new V(this.reconnectionToken,J,M,Z)),C(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$_l=Y;class B extends Y{constructor(J,M,Z,U,N){super(f.Management,J,U,N,!0),this.client=this.B(new $.$ui(N,{remoteAuthority:M,clientId:Z},J.ipcLogger))}async G(J,M){await n(J,M)}}e.$am=B;class _ extends Y{constructor(J,M,Z,U,N){super(f.ExtensionHost,J,Z,U,!1),this.H=M,this.debugPort=N}async G(J,M){await c(J,this.H,M)}}e.$bm=_;function C(oe){try{oe.acceptDisconnect();const J=oe.getSocket();oe.dispose(),J.dispose()}catch(J){(0,A.$2)(J)}}function W(oe){if(oe&&oe.type==="error"){const J=new Error(`Connection error: ${oe.reason}`);return J.code="VSCODE_CONNECTION_ERROR",J}return null}function F(oe,J){for(;oe.length<J;)oe+=" ";return oe}function H(oe,J){return`[remote-connection][${F(y(oe),13)}][${J.substr(0,5)}\u2026]`}function ne(oe,J,M){return`${H(oe,J)}[${M?"reconnect":"initial"}]`}function x(oe,J){return`${ne(J,oe.reconnectionToken,!!oe.reconnectionProtocol)}[${oe.connectTo}]`}function ce(oe){return`${Date.now()-oe} ms`}}),define(le[75],ue([0,1,11]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=r,e.$mn=v,e.$nn=A,e.$on=O;function r(b){return b.scheme===i.Schemas.vscodeRemote?b.authority:void 0}function v(b){if(!b)return;const l=b.indexOf("+");return l<0?b:b.substr(0,l)}function A(b){const{host:l,port:m}=I(b);if(typeof m>"u")throw new Error(`Invalid remote authority: ${b}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:l,port:m}}function O(b,l){let{host:m,port:u}=I(b);return typeof u>"u"&&(u=l),{host:m,port:u}}function I(b){const l=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(l)return{host:l[1],port:parseInt(l[2],10)};const m=b.match(/^(\[[0-9a-z:]+\])$/);if(m)return{host:m[1],port:void 0};const u=b.match(/(.*):(\d+)$/);return u?{host:u[1],port:parseInt(u[2],10)}:{host:b,port:void 0}}}),define(le[87],ue([0,1,25,6,75]),function(K,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=e.$xn=e.$wn=e.$vn=e.TargetPlatform=e.ExtensionType=e.$un=e.$sn=e.$rn=e.$qn=e.$pn=void 0,e.$tn=A,e.$yn=u,e.$zn=$,e.$An=p,e.$Bn=d,e.$Cn=f,e.$Dn=y,i=Ie(i),e.$pn="extensions.user.cache",e.$qn="extensions.builtin.cache",e.$rn="undefined_publisher",e.$sn=["ui","workspace","web"];function A(k){if(typeof k=="object"&&k!==null&&k.supported!==!0)return k.description}e.$un=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var O;(function(k){k[k.System=0]="System",k[k.User=1]="User"})(O||(e.ExtensionType=O={}));var I;(function(k){k.WIN32_X64="win32-x64",k.WIN32_ARM64="win32-arm64",k.LINUX_X64="linux-x64",k.LINUX_ARM64="linux-arm64",k.LINUX_ARMHF="linux-armhf",k.ALPINE_X64="alpine-x64",k.ALPINE_ARM64="alpine-arm64",k.DARWIN_X64="darwin-x64",k.DARWIN_ARM64="darwin-arm64",k.WEB="web",k.UNIVERSAL="universal",k.UNKNOWN="unknown",k.UNDEFINED="undefined"})(I||(e.TargetPlatform=I={}));class b{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,E){if(typeof g>"u"||g===null)return typeof E>"u"||E===null;if(typeof E>"u"||E===null)return!1;if(typeof g=="string"||typeof E=="string"){const S=typeof g=="string"?g:g.value,s=typeof E=="string"?E:E.value;return i.$If(S,s)}return g._lower===E._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$vn=b;class l{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const E of g)this.add(E)}add(g){this.c.add(b.toKey(g))}delete(g){return this.c.delete(b.toKey(g))}has(g){return this.c.has(b.toKey(g))}}e.$wn=l;class m{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete(b.toKey(g))}get(g){return this.c.get(b.toKey(g))}has(g){return this.c.has(b.toKey(g))}set(g,E){this.c.set(b.toKey(g),E)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$xn=m;function u(k){return $(k)}function $(k){return k.contributes&&k.contributes.localizations?k.contributes.localizations.length>0:!1}function p(k){return k.contributes&&k.contributes.authentication?k.contributes.authentication.length>0:!1}function d(k,g){if(g){const E=`onResolveRemoteAuthority:${(0,v.$mn)(g)}`;return!!k.activationEvents?.includes(E)}return!1}function f(k){return k.map(g=>{const[E,S]=g.split("@");return{proposalName:E,version:S?parseInt(S):void 0}})}function y(k){return k.map(g=>g.split("@")[0])}e.$En=(0,r.$Ii)("IBuiltinExtensionsScannerService")}),define(le[128],ue([0,1,3,10,87,6]),function(K,e,i,r,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.$tp=e.$sp=e.$rp=e.ExtensionManagementErrorCode=e.$qp=e.ExtensionGalleryErrorCode=e.$pp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=void 0,e.$jp=I,e.$kp=b,e.$lp=l,e.$mp=m,e.$np=u,e.$op=$,e.$cp="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$dp=new RegExp(e.$cp),e.$ep="__web_extension",e.$fp="skipWalkthrough",e.$gp="extensionInstallSource",e.$hp="dependecyOrPackExtensionInstall",e.$ip="clientTargetPlatform";var O;(function(s){s.COMMAND="command",s.SETTINGS_SYNC="settingsSync"})(O||(e.ExtensionInstallSource=O={}));function I(s){switch(s){case v.TargetPlatform.WIN32_X64:return"Windows 64 bit";case v.TargetPlatform.WIN32_ARM64:return"Windows ARM";case v.TargetPlatform.LINUX_X64:return"Linux 64 bit";case v.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case v.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case v.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case v.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case v.TargetPlatform.DARWIN_X64:return"Mac";case v.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case v.TargetPlatform.WEB:return"Web";case v.TargetPlatform.UNIVERSAL:return v.TargetPlatform.UNIVERSAL;case v.TargetPlatform.UNKNOWN:return v.TargetPlatform.UNKNOWN;case v.TargetPlatform.UNDEFINED:return v.TargetPlatform.UNDEFINED}}function b(s){switch(s){case v.TargetPlatform.WIN32_X64:return v.TargetPlatform.WIN32_X64;case v.TargetPlatform.WIN32_ARM64:return v.TargetPlatform.WIN32_ARM64;case v.TargetPlatform.LINUX_X64:return v.TargetPlatform.LINUX_X64;case v.TargetPlatform.LINUX_ARM64:return v.TargetPlatform.LINUX_ARM64;case v.TargetPlatform.LINUX_ARMHF:return v.TargetPlatform.LINUX_ARMHF;case v.TargetPlatform.ALPINE_X64:return v.TargetPlatform.ALPINE_X64;case v.TargetPlatform.ALPINE_ARM64:return v.TargetPlatform.ALPINE_ARM64;case v.TargetPlatform.DARWIN_X64:return v.TargetPlatform.DARWIN_X64;case v.TargetPlatform.DARWIN_ARM64:return v.TargetPlatform.DARWIN_ARM64;case v.TargetPlatform.WEB:return v.TargetPlatform.WEB;case v.TargetPlatform.UNIVERSAL:return v.TargetPlatform.UNIVERSAL;default:return v.TargetPlatform.UNKNOWN}}function l(s,a){switch(s){case i.Platform.Windows:return a==="x64"?v.TargetPlatform.WIN32_X64:a==="arm64"?v.TargetPlatform.WIN32_ARM64:v.TargetPlatform.UNKNOWN;case i.Platform.Linux:return a==="x64"?v.TargetPlatform.LINUX_X64:a==="arm64"?v.TargetPlatform.LINUX_ARM64:a==="arm"?v.TargetPlatform.LINUX_ARMHF:v.TargetPlatform.UNKNOWN;case"alpine":return a==="x64"?v.TargetPlatform.ALPINE_X64:a==="arm64"?v.TargetPlatform.ALPINE_ARM64:v.TargetPlatform.UNKNOWN;case i.Platform.Mac:return a==="x64"?v.TargetPlatform.DARWIN_X64:a==="arm64"?v.TargetPlatform.DARWIN_ARM64:v.TargetPlatform.UNKNOWN;case i.Platform.Web:return v.TargetPlatform.WEB}}function m(s,a){return a===v.TargetPlatform.WEB&&!s.includes(v.TargetPlatform.WEB)}function u(s,a,t){return m(a,t)?!1:s===v.TargetPlatform.UNDEFINED||s===v.TargetPlatform.UNIVERSAL?!0:s===v.TargetPlatform.UNKNOWN?!1:s===t}function $(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}var p;(function(s){s[s.NoneOrRelevance=0]="NoneOrRelevance",s[s.LastUpdatedDate=1]="LastUpdatedDate",s[s.Title=2]="Title",s[s.PublisherName=3]="PublisherName",s[s.InstallCount=4]="InstallCount",s[s.PublishedDate=10]="PublishedDate",s[s.AverageRating=6]="AverageRating",s[s.WeightedRating=12]="WeightedRating"})(p||(e.SortBy=p={}));var d;(function(s){s[s.Default=0]="Default",s[s.Ascending=1]="Ascending",s[s.Descending=2]="Descending"})(d||(e.SortOrder=d={}));var f;(function(s){s.Install="install",s.Uninstall="uninstall"})(f||(e.StatisticType=f={}));var y;(function(s){s[s.None=1]="None",s[s.Install=2]="Install",s[s.Update=3]="Update",s[s.Migrate=4]="Migrate"})(y||(e.InstallOperation=y={})),e.$pp=(0,A.$Ii)("extensionGalleryService");var k;(function(s){s.Timeout="Timeout",s.Cancelled="Cancelled",s.Failed="Failed",s.DownloadFailedWriting="DownloadFailedWriting",s.Offline="Offline"})(k||(e.ExtensionGalleryErrorCode=k={}));class g extends Error{constructor(a,t){super(a),this.code=t,this.name=t}}e.$qp=g;var E;(function(s){s.Unsupported="Unsupported",s.Deprecated="Deprecated",s.Malicious="Malicious",s.Incompatible="Incompatible",s.IncompatibleApi="IncompatibleApi",s.IncompatibleTargetPlatform="IncompatibleTargetPlatform",s.ReleaseVersionNotFound="ReleaseVersionNotFound",s.Invalid="Invalid",s.Download="Download",s.DownloadSignature="DownloadSignature",s.DownloadFailedWriting="DownloadFailedWriting",s.UpdateMetadata="UpdateMetadata",s.Extract="Extract",s.Scanning="Scanning",s.ScanningExtension="ScanningExtension",s.ReadUninstalled="ReadUninstalled",s.UnsetUninstalled="UnsetUninstalled",s.Delete="Delete",s.Rename="Rename",s.IntializeDefaultProfile="IntializeDefaultProfile",s.AddToProfile="AddToProfile",s.InstalledExtensionNotFound="InstalledExtensionNotFound",s.PostInstall="PostInstall",s.CorruptZip="CorruptZip",s.IncompleteZip="IncompleteZip",s.Signature="Signature",s.NotAllowed="NotAllowed",s.Gallery="Gallery",s.Cancelled="Cancelled",s.Unknown="Unknown",s.Internal="Internal"})(E||(e.ExtensionManagementErrorCode=E={}));class S extends Error{constructor(a,t){super(a),this.code=t,this.name=t}}e.$rp=S,e.$sp=(0,A.$Ii)("extensionManagementService"),e.$tp="extensionsIdentifiers/disabled",e.$up="extensionsIdentifiers/enabled",e.$vp=(0,A.$Ii)("IGlobalExtensionEnablementService"),e.$wp=(0,A.$Ii)("IExtensionTipsService"),e.$xp=(0,r.localize2)(1780,"Extensions"),e.$yp=(0,r.localize2)(1781,"Preferences")});var xe=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[212],ue([0,1,18,82,10,213,87,175]),function(K,e,i,r,v,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=m,e.$5p=u,e.$6p=$,e.$7p=p,e.$8p=d,e.$9p=f,e.$0p=y,e.$$p=k,r=xe(r),v=Ie(v),A=Ie(A);const b=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,l=/^-(\d{4})(\d{2})(\d{2})$/;function m(S){return S=S.trim(),S==="*"||b.test(S)}function u(S){if(!m(S))return null;if(S=S.trim(),S==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const s=S.match(b);return s?{hasCaret:s[1]==="^",hasGreaterEquals:s[1]===">=",majorBase:s[2]==="x"?0:parseInt(s[2],10),majorMustEqual:s[2]!=="x",minorBase:s[4]==="x"?0:parseInt(s[4],10),minorMustEqual:s[4]!=="x",patchBase:s[6]==="x"?0:parseInt(s[6],10),patchMustEqual:s[6]!=="x",preRelease:s[8]||null}:null}function $(S){if(!S)return null;const s=S.majorBase,a=S.majorMustEqual,t=S.minorBase;let o=S.minorMustEqual;const n=S.patchBase;let c=S.patchMustEqual;S.hasCaret&&(s===0||(o=!1),c=!1);let h=0;if(S.preRelease){const P=l.exec(S.preRelease);if(P){const[,w,D,L]=P;h=Date.UTC(Number(w),Number(D)-1,Number(L))}}return{majorBase:s,majorMustEqual:a,minorBase:t,minorMustEqual:o,patchBase:n,patchMustEqual:c,isMinimum:S.hasGreaterEquals,notBefore:h}}function p(S,s,a){let t;typeof S=="string"?t=$(u(S)):t=S;let o;s instanceof Date?o=s.getTime():typeof s=="string"&&(o=new Date(s).getTime());let n;if(typeof a=="string"?n=$(u(a)):n=a,!t||!n)return!1;const c=t.majorBase,h=t.minorBase,P=t.patchBase;let w=n.majorBase,D=n.minorBase,L=n.patchBase;const R=n.notBefore;let T=n.majorMustEqual,j=n.minorMustEqual,G=n.patchMustEqual;return n.isMinimum?c>w?!0:c<w?!1:h>D?!0:h<D||o&&o<R?!1:P>=L:(c===1&&w===0&&(!T||!j||!G)&&(w=1,D=0,L=0,T=!0,j=!1,G=!1),c<w?!1:c>w?!T:h<D?!1:h>D?!j:P<L?!1:P>L?!G:!(o&&o<R))}function d(S,s,a,t,o,n){const c=[];if(typeof t.publisher<"u"&&typeof t.publisher!="string")return c.push([r.default.Error,v.localize(1832,null)]),c;if(typeof t.name!="string")return c.push([r.default.Error,v.localize(1833,null,"name")]),c;if(typeof t.version!="string")return c.push([r.default.Error,v.localize(1834,null,"version")]),c;if(!t.engines)return c.push([r.default.Error,v.localize(1835,null,"engines")]),c;if(typeof t.engines.vscode!="string")return c.push([r.default.Error,v.localize(1836,null,"engines.vscode")]),c;if(typeof t.extensionDependencies<"u"&&!E(t.extensionDependencies))return c.push([r.default.Error,v.localize(1837,null,"extensionDependencies")]),c;if(typeof t.activationEvents<"u"){if(!E(t.activationEvents))return c.push([r.default.Error,v.localize(1838,null,"activationEvents")]),c;if(typeof t.main>"u"&&typeof t.browser>"u")return c.push([r.default.Error,v.localize(1839,null,"activationEvents","main","browser")]),c}if(typeof t.extensionKind<"u"&&typeof t.main>"u"&&c.push([r.default.Warning,v.localize(1840,null,"extensionKind")]),typeof t.main<"u"){if(typeof t.main!="string")return c.push([r.default.Error,v.localize(1841,null,"main")]),c;{const w=(0,i.$jh)(a,t.main);(0,i.$dh)(w,a)||c.push([r.default.Warning,v.localize(1842,null,w.path,a.path)])}}if(typeof t.browser<"u"){if(typeof t.browser!="string")return c.push([r.default.Error,v.localize(1843,null,"browser")]),c;{const w=(0,i.$jh)(a,t.browser);(0,i.$dh)(w,a)||c.push([r.default.Warning,v.localize(1844,null,w.path,a.path)])}}if(!A.valid(t.version))return c.push([r.default.Error,v.localize(1845,null)]),c;const h=[];if(!f(S,s,t,o,h))for(const w of h)c.push([r.default.Error,w]);if(n&&t.enabledApiProposals?.length){const w=[];if(!k([...t.enabledApiProposals],w))for(const D of w)c.push([r.default.Error,D])}return c}function f(S,s,a,t,o){return t||typeof a.main>"u"&&typeof a.browser>"u"?!0:g(S,s,a.engines.vscode,o)}function y(S,s,a){return S==="*"||g(s,a,S)}function k(S,s){if(S.length===0)return!0;const a=Array.isArray(s)?s:void 0,t=(a?void 0:s)??I.allApiProposals,o=[],n=(0,O.$Cn)(S);for(const{proposalName:c,version:h}of n){const P=t[c];P&&h&&P.version!==h&&o.push(v.localize(1846,null,c))}return a?.push(...o),o.length===0}function g(S,s,a,t=[]){const o=$(u(a));if(!o)return t.push(v.localize(1847,null,a)),!1;if(o.majorBase===0){if(!o.majorMustEqual||!o.minorMustEqual)return t.push(v.localize(1848,null,a)),!1}else if(!o.majorMustEqual)return t.push(v.localize(1849,null,a)),!1;return p(S,s,o)?!0:(t.push(v.localize(1850,null,S,a)),!1)}function E(S){if(!Array.isArray(S))return!1;for(let s=0,a=S.length;s<a;s++)if(typeof S[s]!="string")return!1;return!0}}),define(le[214],ue([0,1,2,6]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1l=e.$Zl=void 0,e.$Zl=(0,r.$Ii)("remoteSocketFactoryService");class v{constructor(){this.a={}}register(O,I){return this.a[O]??=[],this.a[O].push(I),(0,i.$Vc)(()=>{const b=this.a[O]?.indexOf(I);typeof b=="number"&&b>=0&&this.a[O]?.splice(b,1)})}b(O){return(this.a[O.type]||[]).find(b=>b.supports(O))}connect(O,I,b,l){const m=this.b(O);if(!m)throw new Error(`No socket factory found for ${O}`);return m.connect(O,I,b,l)}}e.$1l=v}),define(le[215],ue([0,1,26,27,44,97]),function(K,e,i,r,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jhc=I,i=Ie(i),r=Ie(r),v=Ie(v),A=Ie(A);let O;async function I(p=!1){return(O===void 0||p)&&(O=b()),O}async function b(){const p=l();if(p===void 0)return!1;if(p>=22e3){const d=u();if(d)return new Promise(f=>{try{v.execFile(d,["--status"],y=>f(!y))}catch{f(!1)}})}else{const d=$();if(d)try{if((await i.promises.stat(d)).isFile())return!0}catch{}}return!1}function l(){const p=/(\d+)\.(\d+)\.(\d+)/g.exec(r.release());if(p)return parseInt(p[3])}function m(p){const d=process.env.SystemRoot;if(d){const f=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return A.join(d,f?"Sysnative":"System32",p)}}function u(){return m("wsl.exe")}function $(){return m("lxss\\LxssManager.dll")}}),define(le[49],ue([0,1,17,15,2,10,56,6,5,46]),function(K,e,i,r,v,A,O,I,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$_p=void 0,e.$bq=$,e.$cq=p,e.$dq=d,e.$eq=f,e.$fq=y,e.$gq=k,e.$_p=(0,I.$Ii)("requestService");class m{constructor(s){this.b=s}toJSON(){if(!this.a){const s=Object.create(null);for(const a in this.b)a.toLowerCase()==="authorization"||a.toLowerCase()==="proxy-authorization"?s[a]="*****":s[a]=this.b[a];this.a=s}return this.a}}class u extends v.$Xc{constructor(s){super(),this.b=0,this.a=s.createLogger("network",{name:(0,A.localize)(2050,null),when:b.$vk.isEqualTo((0,b.$sk)(b.LogLevel.Trace)).serialize()})}async c(s,a,t){const o=`${s} #${++this.b}: ${a.url}`;this.a.trace(`${o} - begin`,a.type,new m(a.headers??{}));try{const n=await t();return this.a.trace(`${o} - end`,a.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.a.error(`${o} - error`,a.type,(0,r.$_)(n)),n}}}e.$aq=u;function $(S){return S.res.statusCode&&S.res.statusCode>=200&&S.res.statusCode<300||S.res.statusCode===1223}function p(S){return S.res.statusCode===204}async function d(S){return p(S)?null:(await(0,i.$3e)(S.stream)).toString()}async function f(S){if(!$(S))throw new Error("Server returned "+S.res.statusCode);return d(S)}async function y(S){if(!$(S))throw new Error("Server returned "+S.res.statusCode);if(p(S))return null;const a=(await(0,i.$3e)(S.stream)).toString();try{return JSON.parse(a)}catch(t){throw t.message+=`:
`+a,t}}function k(S){E(S)}let g;function E(S){const s=l.$vo.as(O.$Ao.Configuration),a=g;g={id:"http",order:15,title:(0,A.localize)(2051,null),type:"object",scope:S,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2052,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(2053,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(2054,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,A.localize)(2055,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(2056,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(2057,null),(0,A.localize)(2058,null),(0,A.localize)(2059,null),(0,A.localize)(2060,null)],default:"override",description:(0,A.localize)(2061,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(2062,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(2063,null),restricted:!0}}},s.updateConfigurations({add:[g],remove:a?[a]:[]})}E(O.ConfigurationScope.APPLICATION)}),define(le[216],ue([0,1,17,22]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=e.$is=void 0;class v{constructor(I){this.a=I}listen(I,b){throw new Error("Invalid listen")}call(I,b,l,m=r.CancellationToken.None){switch(b){case"request":return this.a.request(l[0],m).then(async({res:u,stream:$})=>{const p=await(0,i.$3e)($);return[{statusCode:u.statusCode,headers:u.headers},p]});case"resolveProxy":return this.a.resolveProxy(l[0]);case"lookupAuthorization":return this.a.lookupAuthorization(l[0]);case"lookupKerberosAuthorization":return this.a.lookupKerberosAuthorization(l[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$is=v;class A{constructor(I){this.a=I}async request(I,b){const[l,m]=await this.a.call("request",[I],b);return{res:l,stream:(0,i.$5e)(m)}}async resolveProxy(I){return this.a.call("resolveProxy",[I])}async lookupAuthorization(I){return this.a.call("lookupAuthorization",[I])}async lookupKerberosAuthorization(I){return this.a.call("lookupKerberosAuthorization",[I])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$js=A}),define(le[217],ue([0,1,218,12]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ks=A;function v(O,I){return O.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:O.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function A(O,I,b={}){const l=(0,i.parse)(O),m=b.proxyUrl||v(l,I);if(!m)return null;const u=(0,i.parse)(m);if(!/^https?:$/.test(u.protocol||""))return null;const $={host:u.hostname||"",port:(u.port?+u.port:0)||(u.protocol==="https"?443:80),auth:u.auth,rejectUnauthorized:(0,r.$ng)(b.strictSSL)?b.strictSSL:!0};if(l.protocol==="http:"){const p=await new Promise((d,f)=>{K(["http-proxy-agent"],d,f)}).then(Ie);return new p.HttpProxyAgent(m,$)}else{const p=await new Promise((d,f)=>{K(["https-proxy-agent"],d,f)}).then(Ie);return new p.HttpsProxyAgent(m,$)}}}),define(le[219],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7hc=e.$6hc=e.$5hc=void 0,e.$5hc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$6hc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$7hc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(le[103],ue([0,1,44,9,10,22,55,15,3,33,119,70,8,146]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=f;let d;async function f(k,g,E,S){return E["force-disable-user-env"]?(g.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):b.$j?(g.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,u.$Nm)(S)&&!E["force-user-env"]?(g.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,u.$Nm)(S)?g.trace("resolveShellEnv(): running (--force-user-env)"):g.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=$.Promises.withAsyncBody(async(s,a)=>{const t=new A.$ze;let o=1e4;const n=k.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(o=(0,p.$Om)(n,1,120)*1e3);const c=setTimeout(()=>{t.dispose(!0),a(new Error((0,v.localize)(2064,null)))},o);try{s(await y(g,t.token))}catch(h){!(0,I.$6)(h)&&!t.token.isCancellationRequested?a(new Error((0,v.localize)(2065,null,(0,O.$tj)(h)))):s({})}finally{clearTimeout(c),t.dispose()}})),d)}async function y(k,g){const E=process.env.ELECTRON_RUN_AS_NODE;k.trace("getUnixShellEnvironment#runAsNode",E);const S=process.env.ELECTRON_NO_ATTACH_CONSOLE;k.trace("getUnixShellEnvironment#noAttach",S);const s=(0,l.$5g)().replace(/-/g,"").substr(0,12),a=new RegExp(s+"({.*})"+s),t={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};k.trace("getUnixShellEnvironment#env",t);const o=await(0,m.$Dm)(b.OS,t);return k.trace("getUnixShellEnvironment#shell",o),new Promise((n,c)=>{if(g.isCancellationRequested)return c(new I.$7);const h=(0,r.$qc)(o);let P,w;const D="";/^pwsh(-preview)?$/.test(h)?(P=`& '${process.execPath}' ${D} -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,w=["-Login","-Command"]):h==="nu"?(P=`^'${process.execPath}' ${D} -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,w=["-i","-l","-c"]):h==="xonsh"?(P=`import os, json; print("${s}", json.dumps(dict(os.environ)), "${s}")`,w=["-i","-l","-c"]):(P=`'${process.execPath}' ${D} -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,h==="tcsh"||h==="csh"?w=["-ic"]:w=["-i","-l","-c"]),k.trace("getUnixShellEnvironment#spawn",JSON.stringify(w),P);const L=(0,i.spawn)(o,[...w,P],{detached:!0,stdio:["ignore","pipe","pipe"],env:t});g.onCancellationRequested(()=>(L.kill(),c(new I.$7))),L.on("error",j=>{k.error("getUnixShellEnvironment#errorChildProcess",(0,O.$tj)(j)),c(j)});const R=[];L.stdout.on("data",j=>R.push(j));const T=[];L.stderr.on("data",j=>T.push(j)),L.on("close",(j,G)=>{const q=Buffer.concat(R).toString("utf8");k.trace("getUnixShellEnvironment#raw",q);const Q=Buffer.concat(T).toString("utf8");if(Q.trim()&&k.trace("getUnixShellEnvironment#stderr",Q),j||G)return c(new Error((0,v.localize)(2066,null,j,G)));const de=a.exec(q),V=de?de[1]:"{}";try{const Y=JSON.parse(V);E?Y.ELECTRON_RUN_AS_NODE=E:delete Y.ELECTRON_RUN_AS_NODE,S?Y.ELECTRON_NO_ATTACH_CONSOLE=S:delete Y.ELECTRON_NO_ATTACH_CONSOLE,delete Y.VSCODE_RESOLVING_ENVIRONMENT,delete Y.XDG_RUNTIME_DIR,k.trace("getUnixShellEnvironment#result",Y),n(Y)}catch(Y){k.error("getUnixShellEnvironment#errorCaught",(0,O.$tj)(Y)),c(Y)}})})}}),define(le[220],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndc=void 0;class i{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(v){try{const A=await this.c();if(A){const O=String(i.a++);return this.b.set(O,A),{id:O,data:A.createNewMessage(v)}}}catch{}return{id:"",data:v}}async validate(v,A){if(!v.id)return!0;const O=this.b.get(v.id);if(!O)return!1;this.b.delete(v.id);try{return O.validate(A)==="ok"}catch{return!1}finally{O.dispose?.()}}async sign(v){try{return await this.d(v)}catch{}return v}}e.$Ndc=i}),define(le[104],ue([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3l=e.$2l=void 0,e.$2l="signService",e.$3l=(0,i.$Ii)(e.$2l)}),define(le[221],ue([0,1,153,220]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wic=void 0;class v extends r.$Ndc{c(){return this.h().then(O=>new O.validator)}d(O){return this.h().then(I=>new I.signer().sign(O))}async h(){return(0,i.$xq)("vsda","index.js")}}e.$Wic=v}),define(le[34],ue([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VR=e.$UR=void 0,e.$UR=(0,i.$Ii)("stateReadService"),e.$VR=(0,i.$Ii)("stateService")}),define(le[129],ue([0,1,8,17,2,12,36,14,5]),function(K,e,i,r,v,A,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YR=e.$XR=e.$WR=e.SaveStrategy=void 0;var l;(function(p){p[p.IMMEDIATE=0]="IMMEDIATE",p[p.DELAYED=1]="DELAYED"})(l||(e.SaveStrategy=l={}));class m extends v.$Xc{constructor(d,f,y,k){super(),this.h=d,this.j=f,this.m=y,this.n=k,this.a=Object.create(null),this.b="",this.c=this.B(new i.$Gh(this.j===l.IMMEDIATE?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(d){d.fileOperationResult!==I.FileOperationResult.FILE_NOT_FOUND&&this.m.error(d)}}getItem(d,f){const y=this.a[d];return(0,A.$qg)(y)?f:y}setItem(d,f){this.setItems([{key:d,data:f}])}setItems(d){let f=!1;for(const{key:y,data:k}of d)this.a[y]!==k&&((0,A.$qg)(k)?(0,A.$og)(this.a[y])||(this.a[y]=void 0,f=!0):(this.a[y]=k,f=!0));f&&this.s()}removeItem(d){(0,A.$og)(this.a[d])||(this.a[d]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const d=JSON.stringify(this.a,null,4);if(d!==this.b)try{await this.n.writeFile(this.h,r.$Qe.fromString(d),{atomic:{postfix:".vsctmp"}}),this.b=d}catch(f){this.m.error(f)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$WR=m;let u=class extends v.$Xc{constructor(d,f,y,k){super(),this.a=this.B(new m(f.stateResource,d,y,k))}async init(){await this.a.init()}getItem(d,f){return this.a.getItem(d,f)}};e.$XR=u,e.$XR=u=ke([re(1,O.$Pi),re(2,b.$dk),re(3,I.$dl)],u);class $ extends u{setItem(d,f){this.a.setItem(d,f)}setItems(d){this.a.setItems(d)}removeItem(d){this.a.removeItem(d)}close(){return this.a.close()}}e.$YR=$}),define(le[130],ue([0,1,3,37,33]),function(K,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=O,e.$Ap=I;function A(b){if(i.$v===i.Platform.Linux&&/^penguin(\.|$)/i.test(b))return"chromebook"}function O(b,l,m,u,$,p,d,f,y,k){const g=Object.create(null);g["common.machineId"]=p,g["common.sqmId"]=d,g["common.devDeviceId"]=f,g.sessionID=(0,v.$5g)()+Date.now(),g.commitHash=u,g.version=$,g["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,i.$i)(i.$v),g["common.nodePlatform"]=r.$gc,g["common.nodeArch"]=m,g["common.product"]=k||"desktop",y&&(g["common.msftInternal"]=y);let E=0;const S=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-S,enumerable:!0},"common.sequence":{get:()=>E++,enumerable:!0}}),i.$m&&(g["common.snap"]="true");const s=A(l);return s&&(g["common.platformDetail"]=s),g}function I(b){const l=r.env.USERDNSDOMAIN;if(!l)return!1;const m=l.toLowerCase();return b.some(u=>m===u)}}),define(le[24],ue([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=void 0,e.$cm=(0,i.$Ii)("telemetryService"),e.$dm=(0,i.$Ii)("customEndpointTelemetryService"),e.$em="telemetry.currentSessionDate",e.$fm="telemetry.firstSessionDate",e.$gm="telemetry.lastSessionDate",e.$hm="telemetry.machineId",e.$im="telemetry.sqmId",e.$jm="telemetry.devDeviceId",e.$km="telemetry",e.$lm="telemetry.telemetryLevel",e.$mm="telemetry.enableCrashReporter",e.$nm="telemetry.enableTelemetry";var r;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(r||(e.TelemetryLevel=r={}));var v;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(v||(e.TelemetryConfiguration=v={}))}),define(le[222],ue([0,1,26,27,8,43,11,9,3,60,7,94,23,118,99,14,28,24]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p,d,f,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8s=void 0,e.$5s=E,e.$6s=s,e.$7s=a,i=Ie(i),r=Ie(r);const g=new Map;async function E(o,n){const c=`${o}::${n.join(":")}`,h=g.get(c);if(h)return h;const P=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],w=new Map,D=new Map,L=2e4;function R(j,G,q,Q){const de=G.substring(j.length+1);return v.Promises.withAsyncBody(async V=>{let Y;Q.readdirCount++;try{Y=await $.Promises.readdir(G,{withFileTypes:!0})}catch{V();return}if(Q.count>=L){Q.count+=Y.length,Q.maxReached=!0,V();return}let B=Y.length;if(B===0){V();return}let _=Y;Q.count+Y.length>L&&(Q.maxReached=!0,B=L-Q.count,_=Y.slice(0,B)),Q.count+=Y.length;for(const C of _)if(C.isDirectory()){if(q.includes(C.name)||await R(j,(0,I.$mc)(G,C.name),q,Q),--B===0){V();return}}else{const W=C.name.lastIndexOf(".");if(W>=0){const F=C.name.substring(W+1);F&&w.set(F,(w.get(F)??0)+1)}for(const F of P)F.relativePathPattern?.test(de)!==!1&&F.filePattern.test(C.name)&&D.set(F.tag,(D.get(F.tag)??0)+1);if(--B===0){V();return}}})}const T=v.Promises.withAsyncBody(async j=>{const G={count:0,maxReached:!1,readdirCount:0},q=new l.$ie(!0);await R(o,o,n,G);const Q=await a(o);j({configFiles:S(D),fileTypes:S(w),fileCount:G.count,maxFilesReached:G.maxReached,launchConfigFiles:Q,totalScanTime:q.elapsed(),totalReaddirCount:G.readdirCount})});return g.set(c,T),T}function S(o){return Array.from(o.entries(),([n,c])=>({name:n,count:c})).sort((n,c)=>c.count-n.count)}function s(){const o={os:`${r.type()} ${r.arch()} ${r.release()}`,memory:`${(r.totalmem()/f.$Ll.GB).toFixed(2)}GB (${(r.freemem()/f.$Ll.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(u.$Wn.value()*100)}%`},n=r.cpus();return n&&n.length>0&&(o.cpus=`${n[0].model} (${n.length} x ${n[0].speed})`),o}async function a(o){try{const n=new Map,c=(0,I.$mc)(o,".vscode","launch.json"),h=await i.promises.readFile(c),P=[],w=(0,A.$3n)(h.toString(),P);if(P.length)return console.log(`Unable to parse ${c}`),[];if((0,A.$$n)(w)==="object"&&w.configurations)for(const D of w.configurations){const L=D.type;L&&(n.has(L)?n.set(L,n.get(L)+1):n.set(L,1))}return S(n)}catch{return[]}}let t=class{constructor(n,c){this.c=n,this.d=c}f(n){const c=[];return c.push(`OS Version:       ${n.os}`),c.push(`CPUs:             ${n.cpus}`),c.push(`Memory (System):  ${n.memory}`),c.push(`VM:               ${n.vmHint}`),c.join(`
`)}g(n){const c=[];c.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),c.push(`OS Version:       ${r.type()} ${r.arch()} ${r.release()}`);const h=r.cpus();return h&&h.length>0&&c.push(`CPUs:             ${h[0].model} (${h.length} x ${h[0].speed})`),c.push(`Memory (System):  ${(r.totalmem()/f.$Ll.GB).toFixed(2)}GB (${(r.freemem()/f.$Ll.GB).toFixed(2)}GB free)`),b.$j||c.push(`Load (avg):       ${r.loadavg().map(P=>Math.round(P)).join(", ")}`),c.push(`VM:               ${Math.round(u.$Wn.value()*100)}%`),c.push(`Screen Reader:    ${n.screenReader?"yes":"no"}`),c.push(`Process Argv:     ${n.mainArguments.join(" ")}`),c.push(`GPU Status:       ${this.j(n.gpuFeatureStatus)}`),c.join(`
`)}async getPerformanceInfo(n,c){return Promise.all([(0,p.$4s)(n.mainPID),this.k(n)]).then(async h=>{let[P,w]=h,D=this.m(n,P);return c.forEach(L=>{if((0,d.$Xm)(L))D+=`
${L.errorMessage}`,w+=`
${L.errorMessage}`;else if(D+=`

Remote: ${L.hostName}`,L.processes&&(D+=`
${this.m(n,L.processes)}`),L.workspaceMetadata){w+=`
|  Remote: ${L.hostName}`;for(const R of Object.keys(L.workspaceMetadata)){const T=L.workspaceMetadata[R];let j=`${T.fileCount} files`;T.maxFilesReached&&(j=`more than ${j}`),w+=`|    Folder (${R}): ${j}`,w+=this.h(T)}}}),{processInfo:D,workspaceInfo:w}})}async getSystemInfo(n,c){const{memory:h,vmHint:P,os:w,cpus:D}=s(),L={os:w,memory:h,cpus:D,vmHint:P,processArgs:`${n.mainArguments.join(" ")}`,gpuStatus:n.gpuFeatureStatus,screenReader:`${n.screenReader?"yes":"no"}`,remoteData:c};return b.$j||(L.load=`${r.loadavg().map(R=>Math.round(R)).join(", ")}`),b.$l&&(L.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(L)}async getDiagnostics(n,c){const h=[];return(0,p.$4s)(n.mainPID).then(async P=>(h.push(""),h.push(this.g(n)),h.push(""),h.push(this.m(n,P)),n.windows.some(w=>w.folderURIs&&w.folderURIs.length>0&&!w.remoteAuthority)&&(h.push(""),h.push("Workspace Stats: "),h.push(await this.k(n))),c.forEach(w=>{if((0,d.$Xm)(w))h.push(`
${w.errorMessage}`);else if(h.push(`

`),h.push(`Remote:           ${w.hostName}`),h.push(this.f(w.machineInfo)),w.processes&&h.push(this.m(n,w.processes)),w.workspaceMetadata)for(const D of Object.keys(w.workspaceMetadata)){const L=w.workspaceMetadata[D];let R=`${L.fileCount} files`;L.maxFilesReached&&(R=`more than ${R}`),h.push(`Folder (${D}): ${R}`),h.push(this.h(L))}}),h.push(""),h.push(""),h.join(`
`)))}h(n){const c=[];let P=0;const w=(T,j)=>{const G=` ${T}(${j})`;P+G.length>60?(c.push(D),D="|                 ",P=D.length):P+=G.length,D+=G};let D="|      File types:";const L=10,R=n.fileTypes.length>L?L:n.fileTypes.length;for(let T=0;T<R;T++){const j=n.fileTypes[T];w(j.name,j.count)}if(c.push(D),n.configFiles.length>=0&&(D="|      Conf files:",P=0,n.configFiles.forEach(T=>{w(T.name,T.count)}),c.push(D)),n.launchConfigFiles.length>0){let T="|      Launch Configs:";n.launchConfigFiles.forEach(j=>{const G=j.count>1?` ${j.name}(${j.count})`:` ${j.name}`;T+=G}),c.push(T)}return c.join(`
`)}j(n){const c=Math.max(...Object.keys(n).map(h=>h.length));return Object.keys(n).map(h=>`${h}:  ${" ".repeat(c-h.length)}  ${n[h]}`).join(`
                  `)}k(n){const c=[],h=[];return n.windows.forEach(P=>{P.folderURIs.length===0||P.remoteAuthority||(c.push(`|  Window (${P.title})`),P.folderURIs.forEach(w=>{const D=m.URI.revive(w);if(D.scheme===O.Schemas.file){const L=D.fsPath;h.push(E(L,["node_modules",".git"]).then(R=>{let T=`${R.fileCount} files`;R.maxFilesReached&&(T=`more than ${T}`),c.push(`|    Folder (${(0,I.$qc)(L)}): ${T}`),c.push(this.h(R))}).catch(R=>{c.push(`|      Error: Unable to collect workspace stats for folder ${L} (${R.toString()})`)}))}else c.push(`|    Folder (${D.toString()}): Workspace stats not available.`)}))}),Promise.all(h).then(P=>c.join(`
`)).catch(P=>`Unable to collect workspace stats: ${P}`)}m(n,c){const h=new Map;n.windows.forEach(w=>h.set(w.pid,`window [${w.id}] (${w.title})`)),n.pidToNames.forEach(({pid:w,name:D})=>h.set(w,D));const P=[];return P.push("CPU %	Mem MB	   PID	Process"),c&&this.n(n.mainPID,h,P,c,0),P.join(`
`)}n(n,c,h,P,w){const D=w===0;let L;D?L=P.pid===n?`${this.d.applicationName} main`:"remote agent":c.has(P.pid)?L=c.get(P.pid):L=`${"  ".repeat(w)} ${P.name}`;const R=process.platform==="win32"?P.mem:r.totalmem()*(P.mem/100);h.push(`${P.load.toFixed(0).padStart(5," ")}	${(R/f.$Ll.MB).toFixed(0).padStart(6," ")}	${P.pid.toFixed(0).padStart(6," ")}	${L}`),Array.isArray(P.children)&&P.children.forEach(T=>this.n(n,c,h,T,w+1))}async getWorkspaceFileExtensions(n){const c=new Set;for(const{uri:h}of n.folders){const P=m.URI.revive(h);if(P.scheme!==O.Schemas.file)continue;const w=P.fsPath;try{(await E(w,["node_modules",".git"])).fileTypes.forEach(L=>c.add(L.name))}catch{}}return{extensions:[...c]}}async reportWorkspaceStats(n){for(const{uri:c}of n.folders){const h=m.URI.revive(c);if(h.scheme!==O.Schemas.file)continue;const P=h.fsPath;try{const w=await E(P,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":n.telemetryId,rendererSessionId:n.rendererSessionId}),w.fileTypes.forEach(D=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:n.rendererSessionId,type:D.name,count:D.count})}),w.launchConfigFiles.forEach(D=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:n.rendererSessionId,type:D.name,count:D.count})}),w.configFiles.forEach(D=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:n.rendererSessionId,type:D.name,count:D.count})}),this.c.publicLog2("workspace.stats.metadata",{duration:w.totalScanTime,reachedLimit:w.maxFilesReached,fileCount:w.fileCount,readdirCount:w.totalReaddirCount})}catch{}}}};e.$8s=t,e.$8s=t=ke([re(0,k.$cm),re(1,y.$wk)],t)}),define(le[223],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$hc=e.$0hc=void 0;class i{constructor(A){this.b=A}listen(A,O){throw new Error(`Event not found: ${O}`)}call(A,O,{eventName:I,data:b}){return this.b.forEach(l=>l.log(I,b)),Promise.resolve(null)}}e.$0hc=i;class r{constructor(A){this.b=A}log(A,O){return this.b.call("log",{eventName:A,data:O}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$$hc=r}),define(le[57],ue([0,1,38,12,75,130,24]),function(K,e,i,r,v,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=e.$Gp=e.$Fp=e.$Ep=e.$Dp=e.$Cp=e.$Bp=void 0,e.$Ip=m,e.$Jp=u,e.$Kp=$,e.$Lp=p,e.$Mp=f,e.$Np=k,e.$Op=g,e.$Pp=s;class I{constructor(t){this.value=t,this.isTrustedTelemetryValue=!0}}e.$Bp=I;class b{constructor(){this.telemetryLevel=O.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Cp=b,e.$Dp=new b;class l{async publicLog(t,o,n){}async publicLogError(t,o,n){}}e.$Ep=l,e.$Fp="telemetry",e.$Gp="extensionTelemetryLog",e.$Hp={log:()=>null,flush:()=>Promise.resolve(null)};function m(a,t){return!t.isBuilt&&!t.disableTelemetry?!0:!(t.disableTelemetry||!a.enableTelemetry)}function u(a,t){return t.extensionTestsLocationURI?!0:!(t.isBuilt||t.disableTelemetry||a.enableTelemetry&&a.aiConfig?.ariaKey)}function $(a){const t=a.getValue(O.$lm),o=a.getValue(O.$mm);if(a.getValue(O.$nm)===!1||o===!1)return O.TelemetryLevel.NONE;switch(t??O.TelemetryConfiguration.ON){case O.TelemetryConfiguration.ON:return O.TelemetryLevel.USAGE;case O.TelemetryConfiguration.ERROR:return O.TelemetryLevel.ERROR;case O.TelemetryConfiguration.CRASH:return O.TelemetryLevel.CRASH;case O.TelemetryConfiguration.OFF:return O.TelemetryLevel.NONE}}function p(a){const t={},o={},n={};y(a,n);for(let c in n){c=c.length>150?c.substr(c.length-149):c;const h=n[c];typeof h=="number"?o[c]=h:typeof h=="boolean"?o[c]=h?1:0:typeof h=="string"?(h.length>8192&&console.warn(`Telemetry property: ${c} has been trimmed to 8192, the original length is ${h.length}`),t[c]=h.substring(0,8191)):typeof h<"u"&&h!==null&&(t[c]=h)}return{properties:t,measurements:o}}const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function f(a){if(!a)return"none";const t=(0,v.$mn)(a);return d.has(t)?t:"other"}function y(a,t,o=0,n){if(a)for(const c of Object.getOwnPropertyNames(a)){const h=a[c],P=n?n+c:c;Array.isArray(h)?t[P]=(0,i.$no)(h):h instanceof Date?t[P]=h.toISOString():(0,r.$jg)(h)?o<2?y(h,t,o+1,P+"."):t[P]=(0,i.$no)(h):t[P]=h}}function k(a,t){const o=a.msftInternalDomains||[],n=t.getValue("telemetry.internalTesting");return(0,A.$Ap)(o)||n}function g(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}function E(a,t){if(!a||!a.includes("/")&&!a.includes("\\"))return a;let o=a;const n=[];for(const w of t)for(;;){const D=w.exec(a);if(!D)break;n.push([D.index,w.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let P=0;for(o="";;){const w=h.exec(a);if(!w)break;const D=n.some(([L,R])=>w.index<R&&L<h.lastIndex);!c.test(w[0])&&!D&&(o+=a.substring(P,w.index)+"<REDACTED: user-file-path>",P=h.lastIndex)}return P<a.length&&(o+=a.substr(P)),o}function S(a){if(!a)return a;const t=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of t)if(o.regex.test(a))return`<REDACTED: ${o.label}>`;return a}function s(a,t){return(0,i.$ko)(a,o=>{if(o instanceof I||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let n=o.replaceAll("%20"," ");n=E(n,t);for(const c of t)n=n.replace(c,"");return n=S(n),n}})}}),define(le[131],ue([0,1,25,128,87,3,7,15,37,57]),function(K,e,i,r,v,A,O,I,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=e.$Rp=void 0,e.$Qp=m,e.$Sp=d,e.$Tp=f,e.$Up=y,e.$Vp=k,e.$Wp=g,e.$Xp=E,e.$Yp=S,e.$1p=s,e.$2p=t;function m(o,n){return o.uuid&&n.uuid?o.uuid===n.uuid:o.id===n.id?!0:(0,i.$Df)(o.id,n.id)===0}const u=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class ${static create(n){const c=n.manifest?n.manifest.version:n.version,h=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new $(n.identifier,c,h)}static parse(n){const c=u.exec(n);return c&&c[1]&&c[2]?new $({id:c[1]},c[2],c[4]||void 0):null}constructor(n,c,h=v.TargetPlatform.UNDEFINED){this.identifier=n,this.version=c,this.targetPlatform=h,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==v.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof $?m(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$Rp=$;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(o){const n=p.exec(o);return n&&n[1]?[y(n[1]),n[2]]:[y(o),void 0]}function f(o,n){return`${o}.${n}`}function y(o){return o.toLowerCase()}function k(o,n){return y(f(o??v.$rn,n))}function g(o,n){const c=[],h=P=>{for(const w of c)if(w.some(D=>m(n(D),n(P))))return w;return null};for(const P of o){const w=h(P);w?w.push(P):c.push([P])}return c}function E(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}function S(o){return{id:new l.$Bp(o.identifier.id),name:new l.$Bp(o.name),version:o.version,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.$Zp=new v.$vn("pprice.better-merge");function s(o,n){const c=[],h=n.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const P=h.shift();if(P&&c.every(w=>!m(w.identifier,{id:P}))){const w=o.filter(D=>m(D.identifier,{id:P}));w.length===1&&(c.push(w[0]),h.push(...w[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}async function a(o,n){if(!A.$l)return!1;let c;try{c=(await o.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await o.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(P){n.debug("Error while getting the os-release file.",(0,I.$_)(P))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function t(o,n){const c=await a(o,n),h=(0,r.$lp)(c?"alpine":A.$v,b.$hc);return n.debug("ComputeTargetPlatform:",h),h}});var xe=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[224],ue([0,1,2,38,3,25,10,16,56,63,28,46,24,57]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ns=void 0,l=xe(l);let d=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(k,g,E){this.k=g,this.l=E,this.d={},this.i=new i.$Wc,this.j=[],this.b=k.appenders,this.c=k.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=k.piiPaths||[],this.g=$.TelemetryLevel.USAGE,this.h=!!k.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const S of this.f)this.j.push(new RegExp((0,A.$kf)(S),"gi")),S.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$kf)(S.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(S=>{(S.affectsConfiguration($.$lm)||S.affectsConfiguration($.$nm)||S.affectsConfiguration($.$mm))&&this.m()}))}setExperimentProperty(k,g){this.d[k]=g}m(){let k=(0,p.$Kp)(this.k);const g=this.l.enabledTelemetryLevels;if(g){this.h=this.sendErrorTelemetry?g.error:!1;const E=g.usage?$.TelemetryLevel.USAGE:g.error?$.TelemetryLevel.ERROR:$.TelemetryLevel.NONE;k=Math.min(k,E)}this.g=k}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(k,g,E){this.g<g||(E=(0,r.$lo)(E,this.d),E=(0,p.$Pp)(E,this.j),E=(0,r.$lo)(E,this.c),this.b.forEach(S=>S.log(k,E)))}publicLog(k,g){this.n(k,$.TelemetryLevel.USAGE,g)}publicLog2(k,g){this.publicLog(k,g)}publicLogError(k,g){this.h&&this.n(k,$.TelemetryLevel.ERROR,g)}publicLogError2(k,g){this.publicLogError(k,g)}};e.$ns=d,e.$ns=d=ke([re(1,I.$cj),re(2,m.$wk)],d);function f(){const y=(0,O.localize)(2068,null,l.default.nameLong),k=l.default.privacyStatementUrl?(0,O.localize)(2070,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,O.localize)(2069,null,"https://aka.ms/vscode-telemetry"),g=v.$p?"":(0,O.localize)(2071,null),E=(0,O.localize)(2072,null),S=(0,O.localize)(2073,null),s=(0,O.localize)(2074,null),a=(0,O.localize)(2075,null),t=`
|       | ${E} | ${S} | ${s} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,O.localize)(2076,null);return`
${y} ${k} ${g}

&nbsp;

${a}
${t}

&nbsp;

${o}
`}u.$vo.as(b.$Ao.Configuration).registerConfiguration({id:$.$km,order:1,type:"object",title:(0,O.localize)(2077,null),properties:{[$.$lm]:{type:"string",enum:[$.TelemetryConfiguration.ON,$.TelemetryConfiguration.ERROR,$.TelemetryConfiguration.CRASH,$.TelemetryConfiguration.OFF],enumDescriptions:[(0,O.localize)(2078,null),(0,O.localize)(2079,null),(0,O.localize)(2080,null),(0,O.localize)(2081,null)],markdownDescription:f(),default:$.TelemetryConfiguration.ON,restricted:!0,scope:b.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),u.$vo.as(b.$Ao.Configuration).registerConfiguration({id:$.$km,order:110,type:"object",title:(0,O.localize)(2082,null),properties:{[$.$nm]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,O.localize)(2084,null,l.default.nameLong,l.default.privacyStatementUrl):(0,O.localize)(2083,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,O.localize)(2085,null,`\`#${$.$lm}#\``),scope:b.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(le[225],ue([0,1,3,94,24]),function(K,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zic=A,e.$Aic=O,e.$Bic=I;async function A(b,l){let m=b.getItem(v.$hm);return(typeof m!="string"||i.$k&&m==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(m=await(0,r.$Xn)(l.error.bind(l))),m}async function O(b,l){let m=b.getItem(v.$im);return typeof m!="string"&&(m=await(0,r.$Yn)(l.error.bind(l))),m}async function I(b,l){let m=b.getItem(v.$jm);return typeof m!="string"&&(m=await(0,r.$Zn)(l.error.bind(l))),m}}),define(le[226],ue([0,1,24,225]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cic=v,e.$Dic=A,e.$Eic=O;async function v(I,b){const l=await(0,r.$zic)(I,b);return I.setItem(i.$hm,l),l}async function A(I,b){const l=await(0,r.$Aic)(I,b);return I.setItem(i.$im,l),l}async function O(I,b){const l=await(0,r.$Bic)(I,b);return I.setItem(i.$jm,l),l}}),define(le[132],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var i;(function(r){r[r.Replace=1]="Replace",r[r.Append=2]="Append",r[r.Prepend=3]="Prepend"})(i||(e.EnvironmentVariableMutatorType=i={}))}),define(le[227],ue([0,1,3,132]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rs=void 0;const v=new Map([[r.EnvironmentVariableMutatorType.Append,"APPEND"],[r.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[r.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class A{constructor(m){this.collections=m,this.a=new Map,this.b=new Map,m.forEach((u,$)=>{this.d(u,$);const p=u.map.entries();let d=p.next();for(;!d.done;){const f=d.value[1],y=d.value[0];let k=this.a.get(y);if(k||(k=[],this.a.set(y,k)),k.length>0&&k[0].type===r.EnvironmentVariableMutatorType.Replace){d=p.next();continue}const g={extensionIdentifier:$,value:f.value,type:f.type,scope:f.scope,variable:f.variable,options:f.options};g.scope||delete g.scope,k.unshift(g),d=p.next()}})}async applyToProcessEnvironment(m,u,$){let p;i.$j&&(p={},Object.keys(m).forEach(d=>p[d.toLowerCase()]=d));for(const[d,f]of this.getVariableMap(u)){const y=i.$j&&p[d.toLowerCase()]||d;for(const k of f){const g=$?await $(k.value):k.value;if(k.options?.applyAtProcessCreation??!0)switch(k.type){case r.EnvironmentVariableMutatorType.Append:m[y]=(m[y]||"")+g;break;case r.EnvironmentVariableMutatorType.Prepend:m[y]=g+(m[y]||"");break;case r.EnvironmentVariableMutatorType.Replace:m[y]=g;break}if(k.options?.applyAtShellIntegration??!1){const E=`VSCODE_ENV_${v.get(k.type)}`;m[E]=(m[E]?m[E]+":":"")+d+"="+this.c(g)}}}}c(m){return m.replaceAll(":","\\x3a")}diff(m,u){const $=new Map,p=new Map,d=new Map;if(m.getVariableMap(u).forEach((f,y)=>{const k=this.getVariableMap(u).get(y),g=I(f,k);g&&$.set(y,g)}),this.getVariableMap(u).forEach((f,y)=>{const k=m.getVariableMap(u).get(y),g=I(f,k);g&&d.set(y,g)}),this.getVariableMap(u).forEach((f,y)=>{const k=m.getVariableMap(u).get(y),g=b(f,k);g&&p.set(y,g)}),!($.size===0&&p.size===0&&d.size===0))return{added:$,changed:p,removed:d}}getVariableMap(m){const u=new Map;for(const $ of this.a.values()){const p=$.filter(d=>O(d,m));p.length>0&&u.set(p[0].variable,p)}return u}getDescriptionMap(m){const u=new Map;for(const $ of this.b.values()){const p=$.filter(d=>O(d,m,!0));for(const d of p)u.set(d.extensionIdentifier,d.description)}return u}d(m,u){if(!m.descriptionMap)return;const $=m.descriptionMap.entries();let p=$.next();for(;!p.done;){const d=p.value[1],f=p.value[0];let y=this.b.get(f);y||(y=[],this.b.set(f,y));const k={extensionIdentifier:u,scope:d.scope,description:d.description};k.scope||delete k.scope,y.push(k),p=$.next()}}}e.$Rs=A;function O(l,m,u=!1){return l.scope?!!(l.scope.workspaceFolder&&m?.workspaceFolder&&l.scope.workspaceFolder.index===m.workspaceFolder.index):u?m===l.scope:!0}function I(l,m){if(!m)return l;const u=new Set;m.forEach(p=>u.add(p.extensionIdentifier));const $=[];return l.forEach(p=>{u.has(p.extensionIdentifier)||$.push(p)}),$.length===0?void 0:$}function b(l,m){if(!m)return;const u=new Map;m.forEach(p=>u.set(p.extensionIdentifier,p));const $=[];return l.forEach(p=>{const d=u.get(p.extensionIdentifier);d&&(p.type!==d.type||p.value!==d.value||p.scope?.workspaceFolder?.index!==d.scope?.workspaceFolder?.index)&&$.push(d)}),$.length===0?void 0:$}}),define(le[228],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ls=i,e.$Ms=r,e.$Ns=v,e.$Os=A,e.$Ps=O,e.$Qs=I;function i(b){return[...b.entries()]}function r(b){return b?[...b.entries()]:[]}function v(b){return new Map(b)}function A(b){return new Map(b??[])}function O(b){return Array.from(b.entries()).map(l=>[l[0],i(l[1].map),r(l[1].descriptionMap)])}function I(b){return new Map(b.map(l=>[l[0],{map:v(l[1]),descriptionMap:A(l[2])}]))}}),define(le[229],ue([0,1,8,22,4,2,5]),function(K,e,i,r,v,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cs=void 0;let I=class extends A.$Xc{constructor(l,m){super(),this.h=m,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new v.$oe),this.onCreateRequest=this.g.event,this.b=l===void 0?15e3:l,this.B((0,A.$Vc)(()=>{for(const u of this.f.values())(0,A.$Sc)(u)}))}createRequest(l){return new Promise((m,u)=>{const $=++this.a;this.c.set($,m),this.g.fire({requestId:$,...l});const p=new r.$ze;(0,i.$Jh)(this.b,p.token).then(()=>u(`Request ${$} timed out (${this.b}ms)`)),this.f.set($,[(0,A.$Vc)(()=>p.cancel())])})}acceptReply(l,m){const u=this.c.get(l);u?(this.c.delete(l),(0,A.$Sc)(this.f.get(l)||[]),this.f.delete(l),u(m)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${l}`)}};e.$Cs=I,e.$Cs=I=ke([re(1,O.$dk)],I)}),define(le[76],ue([0,1,6,124,46]),function(K,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=e.$xs=e.$ws=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$vs=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.GeneralShellType=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$us=void 0,e.$us=new r.$Zj("terminalTabFocusMode",!1,!0);var A;(function(a){a.AutomationProfile="terminal.integrated.automationProfile.",a.DefaultProfile="terminal.integrated.defaultProfile.",a.Profiles="terminal.integrated.profiles."})(A||(e.TerminalSettingPrefix=A={}));var O;(function(a){a.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",a.AutomationProfileLinux="terminal.integrated.automationProfile.linux",a.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",a.AutomationProfileWindows="terminal.integrated.automationProfile.windows",a.ProfilesWindows="terminal.integrated.profiles.windows",a.ProfilesMacOs="terminal.integrated.profiles.osx",a.ProfilesLinux="terminal.integrated.profiles.linux",a.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",a.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",a.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",a.UseWslProfiles="terminal.integrated.useWslProfiles",a.TabsDefaultColor="terminal.integrated.tabs.defaultColor",a.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",a.TabsEnabled="terminal.integrated.tabs.enabled",a.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",a.TabsHideCondition="terminal.integrated.tabs.hideCondition",a.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",a.TabsShowActions="terminal.integrated.tabs.showActions",a.TabsLocation="terminal.integrated.tabs.location",a.TabsFocusMode="terminal.integrated.tabs.focusMode",a.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",a.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",a.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",a.CopyOnSelection="terminal.integrated.copyOnSelection",a.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",a.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",a.FontFamily="terminal.integrated.fontFamily",a.FontSize="terminal.integrated.fontSize",a.LetterSpacing="terminal.integrated.letterSpacing",a.LineHeight="terminal.integrated.lineHeight",a.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",a.TabStopWidth="terminal.integrated.tabStopWidth",a.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",a.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",a.BellDuration="terminal.integrated.bellDuration",a.FontWeight="terminal.integrated.fontWeight",a.FontWeightBold="terminal.integrated.fontWeightBold",a.CursorBlinking="terminal.integrated.cursorBlinking",a.CursorStyle="terminal.integrated.cursorStyle",a.CursorStyleInactive="terminal.integrated.cursorStyleInactive",a.CursorWidth="terminal.integrated.cursorWidth",a.Scrollback="terminal.integrated.scrollback",a.DetectLocale="terminal.integrated.detectLocale",a.DefaultLocation="terminal.integrated.defaultLocation",a.GpuAcceleration="terminal.integrated.gpuAcceleration",a.TerminalTitleSeparator="terminal.integrated.tabs.separator",a.TerminalTitle="terminal.integrated.tabs.title",a.TerminalDescription="terminal.integrated.tabs.description",a.RightClickBehavior="terminal.integrated.rightClickBehavior",a.MiddleClickBehavior="terminal.integrated.middleClickBehavior",a.Cwd="terminal.integrated.cwd",a.ConfirmOnExit="terminal.integrated.confirmOnExit",a.ConfirmOnKill="terminal.integrated.confirmOnKill",a.EnableBell="terminal.integrated.enableBell",a.EnableVisualBell="terminal.integrated.enableVisualBell",a.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",a.AllowChords="terminal.integrated.allowChords",a.AllowMnemonics="terminal.integrated.allowMnemonics",a.TabFocusMode="terminal.integrated.tabFocusMode",a.EnvMacOs="terminal.integrated.env.osx",a.EnvLinux="terminal.integrated.env.linux",a.EnvWindows="terminal.integrated.env.windows",a.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",a.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",a.ExperimentalWindowsUseConptyDll="terminal.integrated.experimental.windowsUseConptyDll",a.ShowExitAlert="terminal.integrated.showExitAlert",a.SplitCwd="terminal.integrated.splitCwd",a.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",a.WordSeparators="terminal.integrated.wordSeparators",a.EnableFileLinks="terminal.integrated.enableFileLinks",a.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",a.UnicodeVersion="terminal.integrated.unicodeVersion",a.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",a.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",a.HideOnStartup="terminal.integrated.hideOnStartup",a.CustomGlyphs="terminal.integrated.customGlyphs",a.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",a.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",a.InheritEnv="terminal.integrated.inheritEnv",a.ShowLinkHover="terminal.integrated.showLinkHover",a.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",a.AutoReplies="terminal.integrated.autoReplies",a.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",a.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",a.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",a.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",a.EnableImages="terminal.integrated.enableImages",a.SmoothScrolling="terminal.integrated.smoothScrolling",a.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",a.FocusAfterRun="terminal.integrated.focusAfterRun",a.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",a.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",a.DevMode="terminal.integrated.developer.devMode"})(O||(e.TerminalSettingId=O={}));var I;(function(a){a.Bash="bash",a.Fish="fish",a.Sh="sh",a.Csh="csh",a.Ksh="ksh",a.Zsh="zsh"})(I||(e.PosixShellType=I={}));var b;(function(a){a.CommandPrompt="cmd",a.Wsl="wsl",a.GitBash="gitbash"})(b||(e.WindowsShellType=b={}));var l;(function(a){a.PowerShell="pwsh",a.Python="python",a.Julia="julia",a.NuShell="nu"})(l||(e.GeneralShellType=l={}));var m;(function(a){a[a.Api=0]="Api",a[a.Process=1]="Process",a[a.Sequence=2]="Sequence",a[a.Config=3]="Config"})(m||(e.TitleEventSource=m={}));var u;(function(a){a.LocalPty="localPty",a.PtyHost="ptyHost",a.PtyHostWindow="ptyHostWindow",a.Logger="logger",a.Heartbeat="heartbeat"})(u||(e.TerminalIpcChannels=u={}));var $;(function(a){a.Cwd="cwd",a.InitialCwd="initialCwd",a.FixedDimensions="fixedDimensions",a.Title="title",a.ShellType="shellType",a.HasChildProcesses="hasChildProcesses",a.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",a.OverrideDimensions="overrideDimensions",a.FailedShellIntegrationActivation="failedShellIntegrationActivation",a.UsedShellIntegrationInjection="usedShellIntegrationInjection"})($||(e.ProcessPropertyType=$={})),e.$vs=(0,i.$Ii)("ptyService");var p;(function(a){a[a.BeatInterval=5e3]="BeatInterval",a[a.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",a[a.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",a[a.SecondWaitMultiplier=1]="SecondWaitMultiplier",a[a.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(p||(e.HeartbeatConstants=p={}));var d;(function(a){a[a.Panel=1]="Panel",a[a.Editor=2]="Editor"})(d||(e.TerminalLocation=d={}));var f;(function(a){a.TerminalView="view",a.Editor="editor"})(f||(e.TerminalLocationString=f={}));var y;(function(a){a[a.GraceTime=6e4]="GraceTime",a[a.ShortGraceTime=6e3]="ShortGraceTime"})(y||(e.LocalReconnectConstants=y={}));var k;(function(a){a[a.HighWatermarkChars=1e5]="HighWatermarkChars",a[a.LowWatermarkChars=5e3]="LowWatermarkChars",a[a.CharCountAckSize=5e3]="CharCountAckSize"})(k||(e.FlowControlConstants=k={}));var g;(function(a){a.GitBash="Git Bash",a.Pwsh="PowerShell"})(g||(e.ProfileSource=g={}));var E;(function(a){a[a.Off=0]="Off",a[a.FinalTerm=1]="FinalTerm",a[a.VSCode=2]="VSCode"})(E||(e.ShellIntegrationStatus=E={}));var S;(function(a){a[a.Unknown=0]="Unknown",a[a.Shutdown=1]="Shutdown",a[a.Process=2]="Process",a[a.User=3]="User",a[a.Extension=4]="Extension"})(S||(e.TerminalExitReason=S={})),e.$ws={Backend:"workbench.contributions.terminal.processBackend"};class s{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const o=this.b(t.remoteAuthority);if(this.a.has(o))throw new Error(`A terminal backend with remote authority '${o}' was already registered.`);this.a.set(o,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}v.$vo.add(e.$ws.Backend,new s),e.$xs=(0,i.$Ii)("localPtyService"),e.$ys=(0,i.$Ii)("terminalLogService")}),define(le[230],ue([0,1,81,7,10,113]),function(K,e,i,r,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ds=O,e.$Es=l,e.$Fs=m,e.$Gs=u;function O($,p){const d=[{name:null,description:(0,v.localize)(2118,null)}];return d.push(...$.map(f=>({name:f.profileName,description:I(f)}))),p&&d.push(...p.map(f=>({name:f.title,description:b(f)}))),{values:d.map(f=>f.name),markdownDescriptions:d.map(f=>f.description)}}function I($){let p=`$(${A.ThemeIcon.isThemeIcon($.icon)?$.icon.id:$.icon?$.icon:i.$8j.terminal.id}) ${$.profileName}
- path: ${$.path}`;return $.args&&(typeof $.args=="string"?p+=`
- args: "${$.args}"`:p+=`
- args: [${$.args.length===0?"":`'${$.args.join("','")}'`}]`),$.overrideName!==void 0&&(p+=`
- overrideName: ${$.overrideName}`),$.color&&(p+=`
- color: ${$.color}`),$.env&&(p+=`
- env: ${JSON.stringify($.env)}`),p}function b($){return`$(${A.ThemeIcon.isThemeIcon($.icon)?$.icon.id:$.icon?$.icon:i.$8j.terminal.id}) ${$.title}
- extensionIdentifier: ${$.extensionIdentifier}`}function l($,p){if(!$&&!p)return!0;if(typeof $=="string"&&typeof p=="string")return $===p;if(Array.isArray($)&&Array.isArray(p)){if($.length!==p.length)return!1;for(let d=0;d<$.length;d++)if($[d]!==p[d])return!1;return!0}return!1}function m($,p){if(!$&&!p)return!0;if(!$||!p)return!1;if(A.ThemeIcon.isThemeIcon($)&&A.ThemeIcon.isThemeIcon(p))return $.id===p.id&&$.color===p.color;if(typeof $=="object"&&"light"in $&&"dark"in $&&typeof p=="object"&&"light"in p&&"dark"in p){const d=$,f=p;if((r.URI.isUri(d.light)||u(d.light))&&(r.URI.isUri(d.dark)||u(d.dark))&&(r.URI.isUri(f.light)||u(f.light))&&(r.URI.isUri(f.dark)||u(f.dark)))return d.light.path===f.light.path&&d.dark.path===f.dark.path}if(r.URI.isUri($)&&r.URI.isUri(p)||u($)||u(p)){const d=$,f=p;return d.path===f.path&&d.scheme===f.scheme}return!1}function u($){return $?typeof $.path=="string"&&typeof $.scheme=="string":!1}}),define(le[231],ue([0,1,81,3,10,56,46,76,230]),function(K,e,i,r,v,A,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Is=e.$Hs=void 0,e.$Js=d,e.$Ks=y,e.$Hs={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$Is={type:"string",enum:Array.from((0,i.$6j)(),k=>k.id),markdownEnumDescriptions:Array.from((0,i.$6j)(),k=>`$(${k.id})`)};const l={args:{description:(0,v.localize)(2087,null),type:"array",items:{type:"string"}},overrideName:{description:(0,v.localize)(2088,null),type:"boolean"},icon:{description:(0,v.localize)(2089,null),...e.$Is},color:{description:(0,v.localize)(2090,null),...e.$Hs},env:{markdownDescription:(0,v.localize)(2091,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},m={type:"object",required:["path"],properties:{path:{description:(0,v.localize)(2092,null),type:["string","array"],items:{type:"string"}},...l}},u={type:"object",required:["path"],properties:{path:{description:(0,v.localize)(2093,null),type:["string"],items:{type:"string"}},...l}};function $(k){const g=k===r.Platform.Linux?"linux":k===r.Platform.Mac?"osx":"windows";return(0,v.localize)(2094,null,(0,r.$i)(k),'```json\n"terminal.integrated.profile.'+g+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const p={id:"terminal",order:100,title:(0,v.localize)(2095,null),type:"object",properties:{[I.TerminalSettingId.AutomationProfileLinux]:{restricted:!0,markdownDescription:(0,v.localize)(2096,null),type:["object","null"],default:null,anyOf:[{type:"null"},u],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.AutomationProfileMacOs]:{restricted:!0,markdownDescription:(0,v.localize)(2097,null),type:["object","null"],default:null,anyOf:[{type:"null"},u],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.AutomationProfileWindows]:{restricted:!0,markdownDescription:(0,v.localize)(2098,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},u],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.ProfilesWindows]:{restricted:!0,markdownDescription:$(r.Platform.Windows),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,v.localize)(2099,null),enum:["PowerShell","Git Bash"]},...l}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,v.localize)(2100,null),type:"string"},id:{description:(0,v.localize)(2101,null),type:"string"},title:{description:(0,v.localize)(2102,null),type:"string"},...l}},{type:"null"},m]}},[I.TerminalSettingId.ProfilesMacOs]:{restricted:!0,markdownDescription:$(r.Platform.Mac),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,v.localize)(2103,null),type:"string"},id:{description:(0,v.localize)(2104,null),type:"string"},title:{description:(0,v.localize)(2105,null),type:"string"},...l}},{type:"null"},m]}},[I.TerminalSettingId.ProfilesLinux]:{restricted:!0,markdownDescription:$(r.Platform.Linux),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,v.localize)(2106,null),type:"string"},id:{description:(0,v.localize)(2107,null),type:"string"},title:{description:(0,v.localize)(2108,null),type:"string"},...l}},{type:"null"},m]}},[I.TerminalSettingId.UseWslProfiles]:{description:(0,v.localize)(2109,null),type:"boolean",default:!0},[I.TerminalSettingId.InheritEnv]:{scope:A.ConfigurationScope.APPLICATION,description:(0,v.localize)(2110,null),type:"boolean",default:!0},[I.TerminalSettingId.PersistentSessionScrollback]:{scope:A.ConfigurationScope.APPLICATION,markdownDescription:(0,v.localize)(2111,null),type:"number",default:100},[I.TerminalSettingId.ShowLinkHover]:{scope:A.ConfigurationScope.APPLICATION,description:(0,v.localize)(2112,null),type:"boolean",default:!0},[I.TerminalSettingId.IgnoreProcessNames]:{markdownDescription:(0,v.localize)(2113,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function d(){O.$vo.as(A.$Ao.Configuration).registerConfiguration(p),y()}let f;function y(k,g){const E=O.$vo.as(A.$Ao.Configuration);let S;k&&(S=(0,b.$Ds)(k?.profiles,g));const s=f;f={id:"terminal",order:100,title:(0,v.localize)(2114,null),type:"object",properties:{[I.TerminalSettingId.DefaultProfileLinux]:{restricted:!0,markdownDescription:(0,v.localize)(2115,null),type:["string","null"],default:null,enum:k?.os===r.OperatingSystem.Linux?S?.values:void 0,markdownEnumDescriptions:k?.os===r.OperatingSystem.Linux?S?.markdownDescriptions:void 0},[I.TerminalSettingId.DefaultProfileMacOs]:{restricted:!0,markdownDescription:(0,v.localize)(2116,null),type:["string","null"],default:null,enum:k?.os===r.OperatingSystem.Macintosh?S?.values:void 0,markdownEnumDescriptions:k?.os===r.OperatingSystem.Macintosh?S?.markdownDescriptions:void 0},[I.TerminalSettingId.DefaultProfileWindows]:{restricted:!0,markdownDescription:(0,v.localize)(2117,null),type:["string","null"],default:null,enum:k?.os===r.OperatingSystem.Windows?S?.values:void 0,markdownEnumDescriptions:k?.os===r.OperatingSystem.Windows?S?.markdownDescriptions:void 0}}},E.updateConfigurations({add:[f],remove:s?[s]:[]})}}),define(le[232],ue([0,1,27,11,38,9,3,37,25,12,23,132,228,227]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ss=d,e.$Ts=f,e.$Us=y,i=Ie(i),A=Ie(A),I=Ie(I),m=Ie(m);function d(){const h=/(\d+)\.(\d+)\.(\d+)/g.exec(i.release());let P=0;return h&&h.length===4&&(P=parseInt(h[3])),P}async function f(h,P,w,D=I.env,L=m.Promises.exists){if(A.$lc(h))return await L(h)?h:void 0;if(P===void 0&&(P=I.cwd()),A.$pc(h)!=="."){const G=A.$mc(P,h);return await L(G)?G:void 0}const T=(0,v.$po)(D,"PATH");if(w===void 0&&(0,l.$hg)(T)&&(w=T.split(A.$wc)),w===void 0||w.length===0){const G=A.$mc(P,h);return await L(G)?G:void 0}for(const G of w){let q;if(A.$lc(G)?q=A.$mc(G,h):q=A.$mc(P,G,h),await L(q))return q;if(O.$j){let Q=q+".com";if(await L(Q)||(Q=q+".exe",await L(Q)))return Q}}const j=A.$mc(P,h);return await L(j)?j:void 0}function y(h,P,w,D,L){const R=O.$j&&(!P.windowsEnableConpty||d()<18309);if(!P.shellIntegration.enabled||!h.executable||h.isFeatureTerminal&&!h.forceShellIntegration||h.ignoreShellIntegration||R)return;const T=h.args,j=I.$gc==="win32"?A.$qc(h.executable).toLowerCase():A.$qc(h.executable),G=A.$pc(r.$3g.asFileUri("").fsPath);let q;const Q={VSCODE_INJECTION:"1"};if(P.shellIntegration.nonce&&(Q.VSCODE_NONCE=P.shellIntegration.nonce),O.$j){if(j==="pwsh.exe"||j==="powershell.exe")return!T||n(T)?q=E.get(g.WindowsPwsh):o(T)&&(q=E.get(g.WindowsPwshLogin)),q?(q=[...q],q[q.length-1]=(0,b.$gf)(q[q.length-1],G,""),Q.VSCODE_STABLE=L.quality==="stable"?"1":"0",P.shellIntegration.suggestEnabled&&(Q.VSCODE_SUGGEST="1"),{newArgs:q,envMixin:Q}):void 0;if(j==="bash.exe")return!T||T.length===0?q=E.get(g.Bash):c(T)&&(Q.VSCODE_SHELL_LOGIN="1",k(P,Q),q=E.get(g.Bash)),q?(q=[...q],q[q.length-1]=(0,b.$gf)(q[q.length-1],G),Q.VSCODE_STABLE=L.quality==="stable"?"1":"0",{newArgs:q,envMixin:Q}):void 0;D.warn(`Shell integration cannot be enabled for executable "${h.executable}" and args`,h.args);return}switch(j){case"bash":return!T||T.length===0?q=E.get(g.Bash):c(T)&&(Q.VSCODE_SHELL_LOGIN="1",k(P,Q),q=E.get(g.Bash)),q?(q=[...q],q[q.length-1]=(0,b.$gf)(q[q.length-1],G),Q.VSCODE_STABLE=L.quality==="stable"?"1":"0",{newArgs:q,envMixin:Q}):void 0;case"fish":{const de=w?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",V=A.$mc(G,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return Q.XDG_DATA_DIRS=`${de}:${V}`,k(P,Q),{newArgs:void 0,envMixin:Q}}case"pwsh":return!T||n(T)?q=E.get(g.Pwsh):o(T)&&(q=E.get(g.PwshLogin)),q?(P.shellIntegration.suggestEnabled&&(Q.VSCODE_SUGGEST="1"),q=[...q],q[q.length-1]=(0,b.$gf)(q[q.length-1],G,""),Q.VSCODE_STABLE=L.quality==="stable"?"1":"0",{newArgs:q,envMixin:Q}):void 0;case"zsh":{if(!T||T.length===0?q=E.get(g.Zsh):c(T)?(q=E.get(g.ZshLogin),k(P,Q)):(T===E.get(g.Zsh)||T===E.get(g.ZshLogin))&&(q=T),!q)return;q=[...q],q[q.length-1]=(0,b.$gf)(q[q.length-1],G);let de;try{de=i.userInfo().username}catch{de="unknown"}const V=A.$mc(i.tmpdir(),`${de}-${L.applicationName}-zsh`);Q.ZDOTDIR=V;const Y=w?.ZDOTDIR??i.homedir()??"~";Q.USER_ZDOTDIR=Y;const B=[];return B.push({source:A.$mc(G,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:A.$mc(V,".zshrc")}),B.push({source:A.$mc(G,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:A.$mc(V,".zprofile")}),B.push({source:A.$mc(G,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:A.$mc(V,".zshenv")}),B.push({source:A.$mc(G,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:A.$mc(V,".zlogin")}),{newArgs:q,envMixin:Q,filesToCopy:B}}}D.warn(`Shell integration cannot be enabled for executable "${h.executable}" and args`,h.args)}function k(h,P){if(O.$k&&h.environmentVariableCollections){const w=(0,$.$Qs)(h.environmentVariableCollections),L=new p.$Rs(w).getVariableMap({workspaceFolder:h.workspaceFolder}).get("PATH"),R=[];if(L)for(const T of L)T.type===u.EnvironmentVariableMutatorType.Prepend&&R.push(T.value);R.length>0&&(P.VSCODE_PATH_PREFIX=R.join(""))}}var g;(function(h){h.WindowsPwsh="windows-pwsh",h.WindowsPwshLogin="windows-pwsh-login",h.Pwsh="pwsh",h.PwshLogin="pwsh-login",h.Zsh="zsh",h.ZshLogin="zsh-login",h.Bash="bash"})(g||(g={}));const E=new Map;E.set(g.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),E.set(g.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),E.set(g.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),E.set(g.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),E.set(g.Zsh,["-i"]),E.set(g.ZshLogin,["-il"]),E.set(g.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const S=["-login","-l"],s=["--login","-l"],a=["-i","--interactive"],t=["-nol","-nologo"];function o(h){return typeof h=="string"?S.includes(h.toLowerCase()):h.length===1&&S.includes(h[0].toLowerCase())||h.length===2&&(S.includes(h[0].toLowerCase())||S.includes(h[1].toLowerCase()))&&(t.includes(h[0].toLowerCase())||t.includes(h[1].toLowerCase()))}function n(h){return typeof h=="string"?t.includes(h.toLowerCase()):h.length===0||h?.length===1&&t.includes(h[0].toLowerCase())}function c(h){return typeof h!="string"&&(h=h.filter(P=>!a.includes(P.toLowerCase()))),h==="string"&&s.includes(h.toLowerCase())||typeof h!="string"&&h.length===1&&s.includes(h[0].toLowerCase())}}),define(le[233],ue([0,1,26,44,81,9,3,12,23,117,76,232,97]),function(K,e,i,r,v,A,O,I,b,l,m,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=y,i=Ie(i),r=Ie(r),b=Ie(b);var p;(function(w){w.UnixShellsPath="/etc/shells"})(p||(p={}));let d,f=!0;function y(w,D,L,R,T=process.env,j,G,q,Q){return j=j||{existsFile:b.SymlinkSupport.existsFile,readFile:i.promises.readFile},O.$j?k(L,j,T,G,R.getValue(m.TerminalSettingId.UseWslProfiles)!==!1,w&&typeof w=="object"?{...w}:R.getValue(m.TerminalSettingId.ProfilesWindows),typeof D=="string"?D:R.getValue(m.TerminalSettingId.DefaultProfileWindows),Q,q):c(j,G,L,w&&typeof w=="object"?{...w}:R.getValue(O.$l?m.TerminalSettingId.ProfilesLinux:m.TerminalSettingId.ProfilesMacOs),typeof D=="string"?D:R.getValue(O.$l?m.TerminalSettingId.DefaultProfileLinux:m.TerminalSettingId.DefaultProfileMacOs),Q,q,T)}async function k(w,D,L,R,T,j,G,q,Q){const de=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),V=`${process.env.windir}\\${de?"Sysnative":"System32"}`;let Y=!1;(0,u.$Ss)()>=16299&&(Y=!0),await s(q);const B=new Map;if(w){B.set("PowerShell",{source:m.ProfileSource.Pwsh,icon:v.$8j.terminalPowershell,isAutoDetected:!0}),B.set("Windows PowerShell",{path:`${V}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:v.$8j.terminalPowershell,isAutoDetected:!0}),B.set("Git Bash",{source:m.ProfileSource.GitBash,isAutoDetected:!0}),B.set("Command Prompt",{path:`${V}\\cmd.exe`,icon:v.$8j.terminalCmd,isAutoDetected:!0}),B.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),B.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:v.$8j.terminalBash,isAutoDetected:!0});const C=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;B.set("Cmder",{path:`${V}\\cmd.exe`,args:["/K",C],requiresPath:process.env.CMDER_ROOT?C:{path:C,isUnsafe:!0},isAutoDetected:!0})}h(j,B);const _=await g(B.entries(),G,D,L,R,Q);if(w&&T)try{const C=await o(`${V}\\${Y?"wsl":"bash"}.exe`,G);for(const W of C)(!j||!(W.profileName in j))&&_.push(W)}catch{f&&(R?.trace("WSL is not installed, so could not detect WSL profiles"),f=!1)}return _}async function g(w,D,L,R=process.env,T,j){const G=[];for(const[q,Q]of w)G.push(E(q,Q,D,L,R,T,j));return(await Promise.all(G)).filter(q=>!!q)}async function E(w,D,L,R,T=process.env,j,G){if(D===null)return;let q,Q,de;if("source"in D&&!("path"in D)){const _=d?.get(D.source);if(!_)return;q=_.paths,Q=D.args||_.args,D.icon?de=S(D.icon):_.icon&&(de=_.icon)}else q=Array.isArray(D.path)?D.path:[D.path],Q=O.$j||Array.isArray(D.args)?D.args:void 0,de=S(D.icon);let V;if(G){const _=q.map(W=>typeof W=="string"?W:W.path),C=await G(_);V=new Array(q.length);for(let W=0;W<q.length;W++)typeof q[W]=="string"?V[W]=C[W]:V[W]={path:C[W],isUnsafe:!0}}else V=q.slice();let Y;if(D.requiresPath){let _;if((0,I.$hg)(D.requiresPath)?_=D.requiresPath:(_=D.requiresPath.path,D.requiresPath.isUnsafe&&(Y=_)),!await R.existsFile(_))return}const B=await P(w,L,V,R,T,Q,D.env,D.overrideName,D.isAutoDetected,Y);if(!B){j?.debug("Terminal profile not validated",w,q);return}return B.isAutoDetected=D.isAutoDetected,B.icon=de,B.color=D.color,B}function S(w){return typeof w=="string"?{id:w}:w}async function s(w){if(d&&!w)return;const[D,L]=await Promise.all([a(),w||t()]);d=new Map,d.set(m.ProfileSource.GitBash,{profileName:"Git Bash",paths:D,args:["--login","-i"]}),d.set(m.ProfileSource.Pwsh,{profileName:"PowerShell",paths:L,icon:v.$8j.terminalPowershell})}async function a(){const w=new Set,D=await(0,u.$Ts)("git.exe");if(D){const T=(0,$.dirname)(D);w.add((0,$.resolve)(T,"../.."))}function L(T,j){j&&T.add(j)}L(w,process.env.ProgramW6432),L(w,process.env.ProgramFiles),L(w,process.env["ProgramFiles(X86)"]),L(w,`${process.env.LocalAppData}\\Program`);const R=[];for(const T of w)R.push(`${T}\\Git\\bin\\bash.exe`,`${T}\\Git\\usr\\bin\\bash.exe`,`${T}\\usr\\bin\\bash.exe`);return R.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),R.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),R}async function t(){const w=[];for await(const D of(0,l.$zm)())w.push(D.exePath);return w}async function o(w,D){const L=[],R=await new Promise((G,q)=>{r.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(Q,de)=>{if(Q)return q("Problem occurred when getting wsl distros");G(de)})});if(!R)return[];const T=new RegExp(/[\r?\n]/),j=R.split(T).filter(G=>G.trim().length>0&&G!=="");for(const G of j){if(G===""||G.startsWith("docker-desktop"))continue;const q=`${G} (WSL)`,Q={profileName:q,path:w,args:["-d",`${G}`],isDefault:q===D,icon:n(G),isAutoDetected:!1};L.push(Q)}return L}function n(w){return w.includes("Ubuntu")?v.$8j.terminalUbuntu:w.includes("Debian")?v.$8j.terminalDebian:v.$8j.terminalLinux}async function c(w,D,L,R,T,j,G,q){const Q=new Map;if(L&&await w.existsFile(p.UnixShellsPath)){const de=(await w.readFile(p.UnixShellsPath)).toString(),V=(j||de.split(`
`)).map(B=>{const _=B.indexOf("#");return _===-1?B:B.substring(0,_)}).filter(B=>B.trim().length>0),Y=new Map;for(const B of V){let _=(0,A.$qc)(B),C=Y.get(_)||0;C++,C>1&&(_=`${_} (${C})`),Y.set(_,C),Q.set(_,{path:B,isAutoDetected:!0})}}return h(R,Q),await g(Q.entries(),T,w,q,D,G)}function h(w,D){if(w)for(const[L,R]of Object.entries(w))R===null||typeof R!="object"||!("path"in R)&&!("source"in R)?D.delete(L):(R.icon=R.icon||D.get(L)?.icon,D.set(L,R))}async function P(w,D,L,R,T,j,G,q,Q,de){if(L.length===0)return Promise.resolve(void 0);const V=L.shift();if(V==="")return P(w,D,L,R,T,j,G,q,Q);const Y=typeof V!="string"&&V.isUnsafe,B=typeof V=="string"?V:V.path,_={profileName:w,path:B,args:j,env:G,overrideName:q,isAutoDetected:Q,isDefault:w===D,isUnsafePath:Y,requiresUnsafePath:de};if((0,A.$qc)(B)===B){const W=T.PATH?T.PATH.split(A.$wc):void 0,F=await(0,u.$Ts)(B,void 0,W,void 0,R.existsFile);return F?(_.path=F,_.isFromPath=!0,_):P(w,D,L,R,T,j)}return await R.existsFile((0,A.$kc)(B))?_:P(w,D,L,R,T,j,G,q,Q)}}),define(le[234],ue([0,1,4,2,3,45,16,5,196,103,229,76,231,233,119,60]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ws=void 0;var y;(function(g){g[g.MaxRestarts=5]="MaxRestarts"})(y||(y={}));let k=class extends r.$Xc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(E,S,s,a){super(),this.M=E,this.N=S,this.O=s,this.P=a,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new i.$oe),this.onPtyHostExit=this.u.event,this.w=this.B(new i.$oe),this.onPtyHostStart=this.w.event,this.y=this.B(new i.$oe),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new i.$oe),this.onPtyHostResponsive=this.z.event,this.C=this.B(new i.$oe),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new i.$oe),this.onProcessData=this.D.event,this.F=this.B(new i.$oe),this.onProcessReady=this.F.event,this.G=this.B(new i.$oe),this.onProcessReplay=this.G.event,this.H=this.B(new i.$oe),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new i.$oe),this.onDidRequestDetach=this.I.event,this.J=this.B(new i.$oe),this.onDidChangeProperty=this.J.event,this.L=this.B(new i.$oe),this.onProcessExit=this.L.event,(0,$.$Js)(),this.B(this.M),this.B((0,r.$Vc)(()=>this.W())),this.j=this.B(new m.$Cs(void 0,this.O)),this.B(this.j.onCreateRequest(this.C.fire,this.C)),this.M.onRequestConnection&&this.B(i.Event.once(this.M.onRequestConnection)(()=>this.h())),this.M.onWillShutdown&&this.B(this.M.onWillShutdown(()=>this.m=!0))}get Q(){return this.N.getValue(u.TerminalSettingId.IgnoreProcessNames)}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(v.$j)return process.env;try{return await(0,l.$Um)(this.N,this.O,{_:[]},process.env)}catch(E){return this.O.error("ptyHost was unable to resolve shell environment",E),{}}}U(){const E=this.M.start(),S=E.client;this.O.getLevel()===I.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),A.ProxyChannel.toService(S.getChannel(u.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(E.onDidProcessExit(t=>{this.u.fire(t.code),!this.m&&!this.q.isDisposed&&(this.n<=y.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${t.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${t.code}, giving up`))}));const a=A.ProxyChannel.toService(S.getChannel(u.TerminalIpcChannels.PtyHost));return this.B(a.onProcessData(t=>this.D.fire(t))),this.B(a.onProcessReady(t=>this.F.fire(t))),this.B(a.onProcessExit(t=>this.L.fire(t))),this.B(a.onDidChangeProperty(t=>this.J.fire(t))),this.B(a.onProcessReplay(t=>this.G.fire(t))),this.B(a.onProcessOrphanQuestion(t=>this.H.fire(t))),this.B(a.onDidRequestDetach(t=>this.I.fire(t))),this.B(new b.$Bs(this.P,S.getChannel(u.TerminalIpcChannels.Logger))),this.a=E,this.b=a,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async t=>{t.affectsConfiguration(u.TerminalSettingId.IgnoreProcessNames)&&await this.R()})),this.R(),[E,a]}async createProcess(E,S,s,a,t,o,n,c,h,P,w){const D=setTimeout(()=>this.$(),u.HeartbeatConstants.CreateProcessTimeout),L=await this.f.createProcess(E,S,s,a,t,o,n,c,h,P,w);return clearTimeout(D),L}updateTitle(E,S,s){return this.f.updateTitle(E,S,s)}updateIcon(E,S,s,a){return this.f.updateIcon(E,S,s,a)}attachToProcess(E){return this.f.attachToProcess(E)}detachFromProcess(E,S){return this.f.detachFromProcess(E,S)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(E){return this.f.start(E)}shutdown(E,S){return this.f.shutdown(E,S)}input(E,S){return this.f.input(E,S)}processBinary(E,S){return this.f.processBinary(E,S)}resize(E,S,s){return this.f.resize(E,S,s)}clearBuffer(E){return this.f.clearBuffer(E)}acknowledgeDataEvent(E,S){return this.f.acknowledgeDataEvent(E,S)}setUnicodeVersion(E,S){return this.f.setUnicodeVersion(E,S)}getInitialCwd(E){return this.f.getInitialCwd(E)}getCwd(E){return this.f.getCwd(E)}async getLatency(){const E=new f.$ie,S=await this.f.getLatency();return E.stop(),[{label:"ptyhostservice<->ptyhost",latency:E.elapsed()},...S]}orphanQuestionReply(E){return this.f.orphanQuestionReply(E)}installAutoReply(E,S){return this.f.installAutoReply(E,S)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(E){return this.f.uninstallAutoReply(E)}getDefaultSystemShell(E){return this.g?.getDefaultSystemShell(E)??(0,d.$Dm)(E??v.OS,process.env)}async getProfiles(E,S,s,a=!1){const t=await this.S();return(0,p.$Vs)(S,s,a,this.N,t,void 0,this.O,this.bb.bind(this,E))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(E,S){return this.f.getWslPath(E,S)}getRevivedPtyNewId(E,S){return this.f.getRevivedPtyNewId(E,S)}setTerminalLayoutInfo(E){return this.f.setTerminalLayoutInfo(E)}async getTerminalLayoutInfo(E){return this.g?.getTerminalLayoutInfo(E)}async requestDetachInstance(E,S){return this.f.requestDetachInstance(E,S)}async acceptDetachInstanceReply(E,S){return this.f.acceptDetachInstanceReply(E,S)}async freePortKillProcess(E){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(E)}async serializeTerminalState(E){return this.f.serializeTerminalState(E)}async reviveTerminalProcesses(E,S,s){return this.f.reviveTerminalProcesses(E,S,s)}async refreshProperty(E,S){return this.f.refreshProperty(E,S)}async updateProperty(E,S,s){return this.f.updateProperty(E,S,s)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(E){this.ab(),this.s=setTimeout(()=>this.Y(),E?u.HeartbeatConstants.ConnectingBeatInterval:u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier+u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${u.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(E,S){return this.j.createRequest({workspaceId:E,originalText:S})}async acceptPtyHostResolvedVariables(E,S){this.j.acceptReply(E,S)}};e.$Ws=k,e.$Ws=k=ke([re(1,O.$cj),re(2,I.$dk),re(3,I.$ek)],k)});var xe=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[77],ue([0,1,13,4,2,3,16,6,34]),function(K,e,i,r,v,A,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ygc=e.$Xgc=void 0,i=xe(i);const l="#FFFFFF",m="#1E1E1E",u="#000000",$="#FFFFFF",p="theme",d="themeBackground",f="windowSplash";var y;(function(g){g.DETECT_COLOR_SCHEME="window.autoDetectColorScheme",g.SYSTEM_COLOR_THEME="window.systemColorTheme"})(y||(y={})),e.$Xgc=(0,I.$Ii)("themeMainService");let k=class extends v.$Xc{constructor(E,S){super(),this.b=E,this.c=S,this.a=this.B(new r.$oe),this.onDidChangeColorScheme=this.a.event,A.$l||this.B(this.c.onDidChangeConfiguration(s=>{(s.affectsConfiguration(y.SYSTEM_COLOR_THEME)||s.affectsConfiguration(y.DETECT_COLOR_SCHEME))&&this.f()})),this.f(),this.B(r.Event.fromNodeEventEmitter(i.default.nativeTheme,"updated")(()=>this.a.fire(this.getColorScheme())))}f(){if(A.$l||this.c.getValue(y.DETECT_COLOR_SCHEME))i.default.nativeTheme.themeSource="system";else switch(this.c.getValue(y.SYSTEM_COLOR_THEME)){case"dark":i.default.nativeTheme.themeSource="dark";break;case"light":i.default.nativeTheme.themeSource="light";break;case"auto":switch(this.g()){case"vs":i.default.nativeTheme.themeSource="light";break;case"vs-dark":i.default.nativeTheme.themeSource="dark";break;default:i.default.nativeTheme.themeSource="system"}break;default:i.default.nativeTheme.themeSource="system";break}}getColorScheme(){if(A.$j){if(i.default.nativeTheme.shouldUseHighContrastColors)return{dark:i.default.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(A.$k){if(i.default.nativeTheme.shouldUseInvertedColorScheme||i.default.nativeTheme.shouldUseHighContrastColors)return{dark:i.default.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(A.$l&&i.default.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:i.default.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const E=this.getColorScheme();if(E.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return E.dark?u:$;let S=this.b.getItem(d,null);if(!S)switch(this.g()){case"vs":S=l;break;case"hc-black":S=u;break;case"hc-light":S=$;break;default:S=m}return A.$k&&S.toUpperCase()===m&&(S="#171717"),S}g(){switch(this.b.getItem(p,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(E,S){this.b.setItems([{key:p,data:S.baseTheme},{key:d,data:S.colorInfo.background},{key:f,data:S}]),typeof E=="number"&&this.h(E,S),this.f()}h(E,S){for(const s of i.default.BrowserWindow.getAllWindows())if(s.id===E){s.setBackgroundColor(S.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(f)}};e.$Ygc=k,e.$Ygc=k=ke([re(0,b.$VR),re(1,O.$cj)],k)}),define(le[133],ue([0,1,4,2,3,7,16,6,5]),function(K,e,i,r,v,A,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ww=e.$Vw=e.$Sw=e.$Qw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Mw=e.$Lw=void 0,e.$Nw=u,e.$Ow=p,e.$Pw=d,e.$Rw=f,e.$Tw=y,e.$Uw=k,e.$Lw=(0,I.$Ii)("tunnelService"),e.$Mw=(0,I.$Ii)("sharedTunnelsService");var l;(function(S){S.Http="http",S.Https="https"})(l||(e.TunnelProtocol=l={}));var m;(function(S){S.ConstantPrivate="constantPrivate",S.Private="private",S.Public="public"})(m||(e.TunnelPrivacyId=m={}));function u(S){return!!S.forwardPort}var $;(function(S){S[S.Notify=1]="Notify",S[S.OpenBrowser=2]="OpenBrowser",S[S.OpenPreview=3]="OpenPreview",S[S.Silent=4]="Silent",S[S.Ignore=5]="Ignore",S[S.OpenBrowserOnce=6]="OpenBrowserOnce"})($||(e.ProvidedOnAutoForward=$={}));function p(S){if(S.scheme!=="http"&&S.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(S.authority);if(s)return{address:s[1],port:+s[2]}}function d(S){if(S.scheme!=="http"&&S.scheme!=="https"||!S.query)return;const s=S.query.split("&");for(const a of s){const t=a.split("=")[1];if(/^https?:/.exec(t)){const o=p(A.URI.parse(t));if(o)return o}}}e.$Qw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function f(S){return e.$Qw.indexOf(S)>=0}e.$Sw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(S){return e.$Sw.indexOf(S)>=0}function k(S,s,a,t){if(a===v.OperatingSystem.Windows)return!1;if(a===v.OperatingSystem.Macintosh&&y(s)){const o=/(\d+)\.(\d+)\.(\d+)/g.exec(t);if(o?.length===4&&parseInt(o[1])>=18)return!1}return S<1024}class g{constructor(s,a,t){this.remoteAddress=s,this.localAddress=a,this.b=t,this.a=new i.$oe,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Vw=g;let E=class extends r.$Xc{constructor(s,a){super(),this.r=s,this.s=a,this.a=new i.$oe,this.onTunnelOpened=this.a.event,this.b=new i.$oe,this.onTunnelClosed=this.b.event,this.c=new i.$oe,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const s=this.s.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this.g=s,s?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this.h=s.elevation,this.m=s.privacyOptions,this.j=s.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const s=[],a=Array.from(this.f.values());for(const t of a){const o=Array.from(t.values());for(const n of o){const c=await n.value;c&&typeof c!="string"&&s.push(c)}}return s}async dispose(){super.dispose();for(const s of this.f.values()){for(const{value:a}of s.values())await a.then(t=>typeof t!="string"?t?.dispose():void 0);s.clear()}this.f.clear()}setEnvironmentTunnel(s,a,t,o,n){this.z(s,a,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:a,localAddress:t,privacy:o,protocol:n,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,a){(y(s)||f(s))&&(s=e.$Qw[0]);const t=this.D(s,a);if(t)return++t.refcount,t.value}openTunnel(s,a,t,o,n,c=!1,h,P){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${t} on local port ${n}.`);const w=this.g??s;if(!w)return;if(a||(a="localhost"),o||(o=this.t),this.g&&this.n.has(t)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const D=this.F(w,a,t,o,n,c,h,P);return D?D.then(L=>{if(L){if(typeof L=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(a,t),L}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(a,t);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const R=this.w(L);return(L.tunnelRemoteHost!==a||L.tunnelRemotePort!==t)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),h&&L.privacy!==h&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(R),R}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),D)}w(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const a=this.f.get(s.tunnelRemoteHost);if(a){const t=a.get(s.tunnelRemotePort);t&&(t.refcount--,await this.y(s.tunnelRemoteHost,s.tunnelRemotePort,t))}}}}async y(s,a,t){if(t.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${a}.`);const o=t.value.then(async n=>{n&&typeof n!="string"&&(await n.dispose(!0),this.b.fire({host:n.tunnelRemoteHost,port:n.tunnelRemotePort}))});return this.f.has(s)&&this.f.get(s).delete(a),o}}async closeTunnel(s,a){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${a} `);const t=this.f.get(s);if(t&&t.has(a)){const o=t.get(a);o.refcount=0,await this.y(s,a,o)}}z(s,a,t){this.f.has(s)||this.f.set(s,new Map),this.f.get(s).set(a,{refcount:1,value:t})}async C(s,a){const t=this.f.get(s);if(t){const o=t.get(a),n=o?await o.value:void 0;(!n||typeof n=="string")&&t.delete(a),t.size===0&&this.f.delete(s)}}D(s,a){const t=[s];f(s)?(t.push(...e.$Qw),t.push(...e.$Sw)):y(s)&&t.push(...e.$Sw);const o=t.map(n=>this.f.get(n));for(const n of o){const c=n?.get(a);if(c)return c}}canTunnel(s){return!!p(s)}G(s,a,t,o,n,c,h){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${t} on local port ${o}.`);const P=t;this.n.add(P);const w=o===void 0?t:o,D={elevationRequired:n?this.isPortPrivileged(w):!1},L={remoteAddress:{host:a,port:t},localAddressPort:o,privacy:c,public:c?c!==m.Private:void 0,protocol:h},R=s.forwardPort(L,D);return R?(this.z(a,t,R),R.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(P)})):this.n.delete(P),R}};e.$Ww=E,e.$Ww=E=ke([re(0,b.$dk),re(1,O.$cj)],E)}),define(le[50],ue([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fZ=e.$eZ=e.DisablementReason=e.UpdateType=e.StateType=void 0;var r;(function(O){O.Uninitialized="uninitialized",O.Idle="idle",O.Disabled="disabled",O.CheckingForUpdates="checking for updates",O.AvailableForDownload="available for download",O.Downloading="downloading",O.Downloaded="downloaded",O.Updating="updating",O.Ready="ready"})(r||(e.StateType=r={}));var v;(function(O){O[O.Setup=0]="Setup",O[O.Archive=1]="Archive",O[O.Snap=2]="Snap"})(v||(e.UpdateType=v={}));var A;(function(O){O[O.NotBuilt=0]="NotBuilt",O[O.DisabledByEnvironment=1]="DisabledByEnvironment",O[O.ManuallyDisabled=2]="ManuallyDisabled",O[O.MissingConfiguration=3]="MissingConfiguration",O[O.InvalidConfiguration=4]="InvalidConfiguration",O[O.RunningAsAdmin=5]="RunningAsAdmin"})(A||(e.DisablementReason=A={})),e.$eZ={Uninitialized:{type:r.Uninitialized},Disabled:O=>({type:r.Disabled,reason:O}),Idle:(O,I)=>({type:r.Idle,updateType:O,error:I}),CheckingForUpdates:O=>({type:r.CheckingForUpdates,explicit:O}),AvailableForDownload:O=>({type:r.AvailableForDownload,update:O}),Downloading:{type:r.Downloading},Downloaded:O=>({type:r.Downloaded,update:O}),Updating:O=>({type:r.Updating,update:O}),Ready:O=>({type:r.Ready,update:O})},e.$fZ=(0,i.$Ii)("updateService")}),define(le[235],ue([0,1,3,10,56,46]),function(K,e,i,r,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),A.$vo.as(v.$Ao.Configuration).registerConfiguration({id:"update",order:15,title:(0,r.localize)(2431,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:v.ConfigurationScope.APPLICATION,description:(0,r.localize)(2432,null),tags:["usesOnlineServices"],enumDescriptions:[(0,r.localize)(2433,null),(0,r.localize)(2434,null),(0,r.localize)(2435,null),(0,r.localize)(2436,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:v.ConfigurationScope.APPLICATION,description:(0,r.localize)(2437,null),deprecationMessage:(0,r.localize)(2438,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:v.ConfigurationScope.APPLICATION,title:(0,r.localize)(2439,null),description:(0,r.localize)(2440,null),included:i.$j&&!i.$p},"update.showReleaseNotes":{type:"boolean",default:!0,scope:v.ConfigurationScope.APPLICATION,description:(0,r.localize)(2441,null),tags:["usesOnlineServices"]}}})}),define(le[236],ue([0,1,4,50]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aic=e.$_hc=void 0;class v{constructor(I){this.a=I}listen(I,b){switch(b){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${b}`)}call(I,b,l){switch(b){case"checkForUpdates":return this.a.checkForUpdates(l);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(l)}throw new Error(`Call not found: ${b}`)}}e.$_hc=v;class A{get state(){return this.b}set state(I){this.b=I,this.a.fire(I)}constructor(I){this.c=I,this.a=new i.$oe,this.onStateChange=this.a.event,this.b=r.$eZ.Uninitialized,this.c.listen("onStateChange")(b=>this.state=b),this.c.call("_getInitialState").then(b=>this.state=b)}checkForUpdates(I){return this.c.call("checkForUpdates",I)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(I){return this.c.call("_applySpecificUpdate",I)}}e.$aic=A}),define(le[41],ue([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=void 0,e.$Nl=(0,i.$Ii)("IUriIdentityService")}),define(le[237],ue([0,1,41,176,14,18,147,4,2]),function(K,e,i,r,v,A,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1s=void 0;class l{static{this._clock=0}constructor($){this.uri=$,this.time=l._clock++}touch(){return this.time=l._clock++,this}}let m=class{constructor($){this.g=$,this.c=new b.$Wc,this.f=2**16;const p=new Map,d=f=>{let y=p.get(f.scheme);return y===void 0&&(y=$.hasProvider(f)&&!this.g.hasCapability(f,v.FileSystemProviderCapabilities.PathCaseSensitive),p.set(f.scheme,y)),y};this.c.add(I.Event.any($.onDidChangeFileSystemProviderRegistrations,$.onDidChangeFileSystemProviderCapabilities)(f=>{p.delete(f.scheme)})),this.extUri=new A.$$g(d),this.d=new O.$Zs((f,y)=>this.extUri.compare(f,y,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri($){this.g.hasProvider($)&&($=(0,A.$kh)($));const p=this.d.get($);return p?p.touch().uri.with({fragment:$.fragment}):(this.d.set($,new l($)),this.h(),$)}h(){if(this.d.size<this.f)return;const $=[...this.d.entries()].sort((d,f)=>d[1].time<f[1].time?1:d[1].time>f[1].time?-1:0);l._clock=0,this.d.clear();const p=this.f*.5;for(let d=0;d<p;d++)this.d.set($[d][0],$[d][1].touch())}};e.$1s=m,e.$1s=m=ke([re(0,v.$dl)],m),(0,r.$Xs)(i.$Nl,m,r.InstantiationType.Delayed)}),define(le[134],ue([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8Y=void 0,e.$8Y=(0,i.$Ii)("urlService")}),define(le[238],ue([0,1,7]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jic=e.$iic=e.$hic=void 0;class r{constructor(I){this.a=I}listen(I,b){throw new Error(`Event not found: ${b}`)}call(I,b,l){switch(b){case"handleURL":return this.a.handleURL(i.URI.revive(l[0]),l[1])}throw new Error(`Call not found: ${b}`)}}e.$hic=r;class v{constructor(I){this.a=I}handleURL(I,b){return this.a.call("handleURL",[I.toJSON(),b])}}e.$iic=v;class A{constructor(I,b){this.a=I,this.b=b}async routeCall(I,b,l,m){if(b!=="handleURL")throw new Error(`Call not found: ${b}`);if(Array.isArray(l)&&l.length>0){const u=i.URI.revive(l[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",u.toString(!0)),u.query){const $=/\bwindowId=(\d+)/.exec(u.query);if($){const p=$[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${p}"`,u.toString(!0));const d=new RegExp(`window:${p}`),f=I.connections.find(y=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",y.ctx),d.test(y.ctx)));if(f)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",u.toString(!0)),f;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",u.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",u.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(I,b,l,m)}routeEvent(I,b){throw new Error(`Event not found: ${b}`)}}e.$jic=A}),define(le[239],ue([0,1,8,2,7,28]),function(K,e,i,r,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Y=e.$9Y=void 0;class O extends r.$Xc{constructor(){super(...arguments),this.a=new Set}open(l,m){const u=[...this.a.values()];return(0,i.$Mh)(u.map($=>()=>$.handleURL(l,m)),void 0,!1).then($=>$||!1)}registerHandler(l){return this.a.add(l),(0,r.$Vc)(()=>this.a.delete(l))}}e.$9Y=O;let I=class extends O{constructor(l){super(),this.b=l}create(l){let{authority:m,path:u,query:$,fragment:p}=l||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return m&&u&&u.indexOf("/")!==0&&(u=`/${u}`),v.URI.from({scheme:this.b.urlProtocol,authority:m,path:u,query:$,fragment:p})}};e.$0Y=I,e.$0Y=I=ke([re(0,A.$wk)],I)}),define(le[240],ue([0,1,13,8,4,2,3,7]),function(K,e,i,r,v,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kic=void 0;class b extends A.$Xc{constructor(m,u,$,p,d,f){if(super(),this.c=u,this.f=f,this.a=[],this.b=0,m&&(f.trace("ElectronURLListener initialUrisToHandle:",m.map(g=>g.originalUrl)),this.a=m),O.$j){const g=p.isBuilt?[]:[`"${p.appRoot}"`];g.push("--open-url","--"),i.app.setAsDefaultProtocolClient(d.urlProtocol,process.execPath,g)}const y=v.Event.map(v.Event.fromNodeEventEmitter(i.app,"open-url",(g,E)=>({event:g,url:E})),({event:g,url:E})=>(g.preventDefault(),E));this.B(y(g=>{const E=this.g(g);E&&this.c.open(E,{originalUrl:g})})),$.getWindows().filter(g=>g.isReady).length>0?(f.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(f.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(v.Event.once($.onDidSignalReadyWindow)(()=>this.h())))}g(m){try{return I.URI.parse(m)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const m=[];for(const u of this.a)await this.c.open(u.uri,{originalUrl:u.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",u.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",u.originalUrl),m.push(u));m.length!==0&&(this.a=m,(0,r.$Kh)(()=>this.h(),500,this.q))}}e.$kic=b}),define(le[241],ue([0,1,4,2,14,61,31]),function(K,e,i,r,v,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zic=void 0;class I extends r.$Xc{constructor(l,m,u,$,p,d){super(),this.f=l,this.g=m,this.h=u,this.j=$,this.m=p,this.n=d,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new i.$oe),this.onDidChangeFile=this.a.event,this.b=A.$Oi.forUris(()=>!(this.capabilities&v.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new O.$Ec(f=>this.m.extUri.getComparisonKey(this.t(f))),this.r(),this.B($.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(f=>this.s(f)))}r(){this.c.clear();for(const l of this.j.profiles)this.c.add(l.settingsResource),this.c.add(l.keybindingsResource),this.c.add(l.tasksResource),this.c.add(l.extensionsResource)}open(l,m){return this.g.open(this.t(l),m)}close(l){return this.g.close(l)}read(l,m,u,$,p){return this.g.read(l,m,u,$,p)}write(l,m,u,$,p){return this.g.write(l,m,u,$,p)}watch(l,m){this.b.set(l,l);const u=this.g.watch(this.t(l),m);return(0,r.$Vc)(()=>{this.b.delete(l),u.dispose()})}stat(l){return this.g.stat(this.t(l))}mkdir(l){return this.g.mkdir(this.t(l))}rename(l,m,u){return this.g.rename(this.t(l),this.t(m),u)}readFile(l,m){return this.g.readFile(this.t(l),m)}readFileStream(l,m,u){return this.g.readFileStream(this.t(l),m,u)}readdir(l){return this.g.readdir(this.t(l))}enforceAtomicReadFile(l){return this.c.has(l)}writeFile(l,m,u){return this.g.writeFile(this.t(l),m,u)}enforceAtomicWriteFile(l){return this.c.has(l)?{postfix:".vsctmp"}:!1}delete(l,m){return this.g.delete(this.t(l),m)}copy(l,m,u){if((0,v.$hl)(this.g))return this.g.copy(this.t(l),this.t(m),u);throw new Error("copy not supported")}cloneFile(l,m){if((0,v.$il)(this.g))return this.g.cloneFile(this.t(l),this.t(m));throw new Error("clone not supported")}s(l){const m=[];for(const u of l){if(u.resource.scheme!==this.f)continue;const $=this.u(u.resource);this.b.findSubstr($)&&m.push({resource:$,type:u.type,cId:u.cId})}m.length&&(this.n.debug("User data changed"),this.a.fire(m))}t(l){return l.with({scheme:this.f})}u(l){return l.with({scheme:this.h})}}e.$Zic=I}),define(le[242],ue([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gic=void 0,e.$Gic="utilityProcessWorker"}),define(le[243],ue([0,1,6]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lic=void 0,e.$lic=(0,i.$Ii)("webviewManagerService")}),define(le[244],ue([0,1,13,2,11,7]),function(K,e,i,r,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mic=void 0;class O extends r.$Xc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const b=this.b.bind(this);i.protocol.registerFileProtocol(v.Schemas.vscodeWebview,b)}b(b,l){try{const m=A.URI.parse(b.url),u=O.a.get(m.path);if(typeof u=="string"){const $=`vs/workbench/contrib/webview/browser/pre/${u}`,p=v.$3g.asFileUri($);return l({path:p.fsPath,headers:{...v.COI.getHeadersFromQuery(b.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return l({error:-10})}catch{}return l({error:-2})}}e.$mic=O});var xe=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[51],ue([0,1,3,63]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uE=e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.$lE=void 0,e.$mE=v,e.$nE=A,e.$oE=O,e.$pE=I,e.$qE=b,e.$rE=$,e.$sE=p,e.$tE=d,e.$vE=f,e.$wE=y,e.$xE=k,r=xe(r),e.$lE={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function v(g){return typeof g.parentId=="number"}function A(g){return!!g.workspaceUri}function O(g){return!!g.folderUri}function I(g){return!!g.fileUri}function b(g){const E=p(g),S=g.getValue("window.menuBarVisibility");return S==="default"||E&&S==="compact"||i.$k&&i.$n?"classic":S}var l;(function(g){g.TITLE_BAR_STYLE="window.titleBarStyle",g.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(l||(e.TitleBarSetting=l={}));var m;(function(g){g.NATIVE="native",g.CUSTOM="custom"})(m||(e.TitlebarStyle=m={}));var u;(function(g){g.AUTO="auto",g.WINDOWED="windowed",g.NEVER="never"})(u||(e.CustomTitleBarVisibility=u={}));function $(g,E){return!0}function p(g,E){return E||(E=d(g)),E===m.NATIVE}function d(g){if(i.$p)return m.CUSTOM;const E=g.getValue("window");if(E){if(i.$k&&E.nativeTabs===!0||i.$k&&E.nativeFullScreen===!1)return m.NATIVE;const a=E.titleBarStyle;if(a===m.NATIVE||a===m.CUSTOM)return a}return i.$l?m.NATIVE:m.CUSTOM}e.$uE=35;function f(g){if(i.$k||i.$p||p(g))return!1;if(i.$l){const E=g.getValue("window.experimentalControlOverlay");return typeof E=="boolean"?E:r.default.quality!=="stable"}return!0}function y(g){const E=g.getValue("window");return!E||typeof E.nativeFullScreen!="boolean"||E.nativeTabs?!0:E.nativeFullScreen!==!1}function k(g=0){return Math.pow(1.2,g)}});var xe=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[52],ue([0,1,13]),function(K,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$Pgc=e.$Ogc=e.UnloadReason=e.LoadReason=void 0,i=xe(i);var r;(function(l){l[l.INITIAL=1]="INITIAL",l[l.LOAD=2]="LOAD",l[l.RELOAD=3]="RELOAD"})(r||(e.LoadReason=r={}));var v;(function(l){l[l.CLOSE=1]="CLOSE",l[l.QUIT=2]="QUIT",l[l.RELOAD=3]="RELOAD",l[l.LOAD=4]="LOAD"})(v||(e.UnloadReason=v={}));const A=function(l=I.Normal){return{width:1024,height:768,mode:l}};e.$Ogc=A;const O=function(){const u=i.default.screen.getPrimaryDisplay().workArea,$=Math.max(u.x+u.width/2-800/2,0),p=Math.max(u.y+u.height/2-600/2,0);return{x:$,y:p,width:800,height:600,mode:I.Normal}};e.$Pgc=O;var I;(function(l){l[l.Maximized=0]="Maximized",l[l.Normal=1]="Normal",l[l.Minimized=2]="Minimized",l[l.Fullscreen=3]="Fullscreen"})(I||(e.WindowMode=I={}));var b;(function(l){l[l.UNRESPONSIVE=1]="UNRESPONSIVE",l[l.PROCESS_GONE=2]="PROCESS_GONE",l[l.LOAD=3]="LOAD"})(b||(e.WindowError=b={}))}),define(le[245],ue([0,1,8,4,2]),function(K,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sic=void 0;class A extends v.$Xc{constructor({onDidOpenMainWindow:I,onDidFocusMainWindow:b,getActiveWindowId:l}){super(),this.a=this.B(new v.$Wc),r.Event.latch(r.Event.any(I,b))(this.f,this,this.a),this.b=(0,i.$vh)(()=>l()),(async()=>{try{const u=await this.b;this.c=typeof this.c=="number"?this.c:u}catch{}finally{this.b=void 0}})()}f(I){this.b&&(this.b.cancel(),this.b=void 0),this.c=I}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$sic=A}),define(le[30],ue([0,1,10,9,61,18,7,6,11]),function(K,e,i,r,v,A,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$i=e.$8i=e.$7i=e.$6i=e.$5i=e.$3i=e.$2i=e.WorkbenchState=e.$Vi=e.$Ui=e.$Ri=void 0,e.$Si=l,e.$Ti=m,e.$Wi=u,e.$Xi=$,e.$Yi=p,e.$Zi=f,e.$1i=y,e.$4i=E,e.$9i=S,e.$0i=s,e.$_i=a,e.$aj=t,e.$bj=o,e.$Ri=(0,I.$Ii)("contextService");function l(n){const c=n;return typeof c?.id=="string"&&O.URI.isUri(c.uri)}function m(n){return typeof n?.id=="string"&&!l(n)&&!$(n)}e.$Ui={id:"ext-dev"},e.$Vi={id:"empty-window"};function u(n,c){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,r.$qc)(n)}:c?e.$Ui:e.$Vi;const h=n;return h.configuration?{id:h.id,configPath:h.configuration}:h.folders.length===1?{id:h.id,uri:h.folders[0].uri}:{id:h.id}}function $(n){const c=n;return typeof c?.id=="string"&&O.URI.isUri(c.configPath)}function p(n){const c=n;if(c?.uri)return{id:c.id,uri:O.URI.revive(c.uri)};const h=n;if(h?.configPath)return{id:h.id,configPath:O.URI.revive(h.configPath)};if(n?.id)return{id:n.id}}var d;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(d||(e.WorkbenchState=d={}));function f(n){const c=n;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&Array.isArray(c.folders))}function y(n){const c=n;return!!(c&&typeof c=="object"&&O.URI.isUri(c.uri)&&typeof c.name=="string"&&typeof c.toResource=="function")}class k{constructor(c,h,P,w,D){this.h=c,this.j=P,this.k=w,this.l=D,this.c=v.$Oi.forUris(this.l,()=>!0),this.folders=h}update(c){this.h=c.id,this.k=c.configuration,this.j=c.transient,this.l=c.l,this.folders=c.folders}get folders(){return this.g}set folders(c){this.g=c,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(c){this.k=c}getFolder(c){return c&&this.c.findSubstr(c)||null}n(){this.c=v.$Oi.forUris(this.l,()=>!0);for(const c of this.folders)this.c.set(c.uri,c)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$2i=k;class g{constructor(c,h){this.raw=h,this.uri=c.uri,this.index=c.index,this.name=c.name}toResource(c){return(0,A.$jh)(this.uri,c)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$3i=g;function E(n){return new g({uri:n,index:0,name:(0,A.$fh)(n)},{uri:n.toString()})}e.$5i="code-workspace",e.$6i=`.${e.$5i}`,e.$7i=[{name:(0,i.localize)(2489,null),extensions:[e.$5i]}],e.$8i="workspace.json";function S(n,c){return A.$ah.isEqualOrParent(n,c.untitledWorkspacesHome)}function s(n){let c;return O.URI.isUri(n)?c=n:c=n.configuration,c?.scheme===b.Schemas.tmp}e.$$i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function a(n){return n.id===e.$$i}function t(n,c){return!S(n,c)&&!s(n)}function o(n){return(typeof n=="string"?(0,r.$rc)(n):(0,A.$hh)(n))===e.$6i}});var xe=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[53],ue([0,1,13,8,47,48,2,79,3,23,10,125,6,5,28,30]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgc=e.$Ugc=void 0,i=xe(i),e.$Ugc=(0,$.$Ii)("dialogMainService");let y=class{constructor(g,E){this.d=g,this.e=E,this.a=new Map,this.b=new Map,this.c=new r.$Ph}pickFileFolder(g,E){return this.f({...g,pickFolders:!0,pickFiles:!0,title:(0,m.localize)(1707,null)},E)}pickFolder(g,E){return this.f({...g,pickFolders:!0,title:(0,m.localize)(1708,null)},E)}pickFile(g,E){return this.f({...g,pickFiles:!0,title:(0,m.localize)(1709,null)},E)}pickWorkspace(g,E){const S=(0,m.localize)(1710,null),s=(0,A.$bx)((0,m.localize)(1711,null)),a=f.$7i;return this.f({...g,pickFiles:!0,title:S,filters:a,buttonLabel:s},E)}async f(g,E){const S={title:g.title,buttonLabel:g.buttonLabel,filters:g.filters,defaultPath:g.defaultPath};(typeof g.pickFiles=="boolean"||typeof g.pickFolders=="boolean")&&(S.properties=void 0,g.pickFiles&&g.pickFolders&&(S.properties=["multiSelections","openDirectory","openFile","createDirectory"])),S.properties||(S.properties=["multiSelections",g.pickFolders?"openDirectory":"openFile","createDirectory"]),b.$k&&S.properties.push("treatPackageAsDirectory");const s=await this.showOpenDialog(S,(E||i.default.BrowserWindow.getFocusedWindow())??void 0);if(s&&s.filePaths&&s.filePaths.length>0)return s.filePaths}g(g){if(g){let E=this.b.get(g.id);return E||(E=new r.$Ph,this.b.set(g.id,E)),E}else return this.c}showMessageBox(g,E){return this.g(E).queue(async()=>{const{options:S,buttonIndeces:s}=(0,u.$ix)(g,this.e);let a;return E?a=await i.default.dialog.showMessageBox(E,S):a=await i.default.dialog.showMessageBox(S),{response:s[a.response],checkboxChecked:a.checkboxChecked}})}async showSaveDialog(g,E){const S=this.j(g,E);if(!S)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePath:""};try{return await this.g(E).queue(async()=>{let s;return E?s=await i.default.dialog.showSaveDialog(E,g):s=await i.default.dialog.showSaveDialog(g),s.filePath=this.h(s.filePath),s})}finally{(0,O.$Sc)(S)}}h(g){return g&&b.$k&&(g=(0,I.$qm)(g)),g}i(g){return g.map(E=>this.h(E))}async showOpenDialog(g,E){g.defaultPath&&(await l.Promises.exists(g.defaultPath)||(g.defaultPath=void 0));const S=this.j(g,E);if(!S)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(E).queue(async()=>{let s;return E?s=await i.default.dialog.showOpenDialog(E,g):s=await i.default.dialog.showOpenDialog(g),s.filePaths=this.i(s.filePaths),s})}finally{(0,O.$Sc)(S)}}j(g,E){if(!E)return O.$Xc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",g);let S=this.a.get(E.id);S||(S=new Set,this.a.set(E.id,S));const s=(0,v.$wj)(g);if(!S.has(s))return this.d.trace("[DialogMainService]: new file dialog lock created",g),S.add(s),(0,O.$Vc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",g),S?.delete(s),S?.size===0&&this.a.delete(E.id)})}};e.$Vgc=y,e.$Vgc=y=ke([re(0,p.$dk),re(1,d.$wk)],y)}),define(le[246],ue([0,1,4,2,83,30]),function(K,e,i,r,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9hc=void 0;class O extends r.$Xc{static{this.a=100}constructor(b,l){super(),this.f=b,this.g=l,this.b=this.B(new i.$oe),this.c=new Map,this.h(l.applicationStorage,this.b)}h(b,l){this.B(i.Event.debounce(b.onDidChangeStorage,(m,u)=>(m?m.push(u):m=[u],m),O.a)(m=>{m.length&&l.fire(this.j(m,b))}))}j(b,l){const m=new Map,u=new Set;return b.forEach($=>{const p=l.get($.key);typeof p=="string"?m.set($.key,p):u.add($.key)}),{changed:Array.from(m.entries()),deleted:Array.from(u.values())}}listen(b,l,m){switch(l){case"onDidChangeStorage":{const u=m.profile?(0,v.$fi)(m.profile):void 0;if(!u)return this.b.event;let $=this.c.get(u.id);return $||($=this.B(new i.$oe),this.h(this.g.profileStorage(u),$),this.c.set(u.id,$)),$.event}}throw new Error(`Event not found: ${l}`)}async call(b,l,m){const u=m.profile?(0,v.$fi)(m.profile):void 0,$=(0,A.$Yi)(m.workspace),p=await this.m(u,$);switch(l){case"getItems":return Array.from(p.items.entries());case"updateItems":{const d=m;if(d.insert)for(const[f,y]of d.insert)p.set(f,y);d.delete?.forEach(f=>p.delete(f));break}case"optimize":return p.optimize();case"isUsed":{const d=m.payload;if(typeof d=="string")return this.g.isUsed(d)}default:throw new Error(`Call not found: ${l}`)}}async m(b,l){let m;l?m=this.g.workspaceStorage(l):b?m=this.g.profileStorage(b):m=this.g.applicationStorage;try{await m.init()}catch(u){this.f.error(`StorageIPC#init: Unable to init ${l?"workspace":b?"profile":"application"} storage due to ${u}`)}return m}}e.$9hc=O}),define(le[42],ue([0,1,47,4,2,18,7,10,36,14,6,5,30,31,41,8,33,25,12]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p,d,f,y,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=e.$Pl=e.ProfileResourceType=void 0,e.$Ol=S,e.$Ql=s,e.$Rl=a;var E;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(E||(e.ProfileResourceType=E={}));function S(n){const c=n;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&typeof c.isDefault=="boolean"&&typeof c.name=="string"&&O.URI.isUri(c.location)&&O.URI.isUri(c.globalStorageHome)&&O.URI.isUri(c.settingsResource)&&O.URI.isUri(c.keybindingsResource)&&O.URI.isUri(c.tasksResource)&&O.URI.isUri(c.snippetsHome)&&O.URI.isUri(c.extensionsResource))}e.$Pl=(0,m.$Ii)("IUserDataProfilesService");function s(n,c){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,icon:n.icon,location:O.URI.revive(n.location).with({scheme:c}),globalStorageHome:O.URI.revive(n.globalStorageHome).with({scheme:c}),settingsResource:O.URI.revive(n.settingsResource).with({scheme:c}),keybindingsResource:O.URI.revive(n.keybindingsResource).with({scheme:c}),tasksResource:O.URI.revive(n.tasksResource).with({scheme:c}),snippetsHome:O.URI.revive(n.snippetsHome).with({scheme:c}),extensionsResource:O.URI.revive(n.extensionsResource).with({scheme:c}),cacheHome:O.URI.revive(n.cacheHome).with({scheme:c}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}function a(n,c,h,P,w,D){return{id:n,name:c,location:h,isDefault:!1,shortName:w?.shortName,icon:w?.icon,globalStorageHome:D&&w?.useDefaultFlags?.globalState?D.globalStorageHome:(0,A.$jh)(h,"globalStorage"),settingsResource:D&&w?.useDefaultFlags?.settings?D.settingsResource:(0,A.$jh)(h,"settings.json"),keybindingsResource:D&&w?.useDefaultFlags?.keybindings?D.keybindingsResource:(0,A.$jh)(h,"keybindings.json"),tasksResource:D&&w?.useDefaultFlags?.tasks?D.tasksResource:(0,A.$jh)(h,"tasks.json"),snippetsHome:D&&w?.useDefaultFlags?.snippets?D.snippetsHome:(0,A.$jh)(h,"snippets"),extensionsResource:D&&w?.useDefaultFlags?.extensions?D.extensionsResource:(0,A.$jh)(h,"extensions.json"),cacheHome:(0,A.$jh)(P,n),useDefaultFlags:w?.useDefaultFlags,isTransient:w?.transient}}let t=class extends v.$Xc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(c,h,P,w){super(),this.t=c,this.u=h,this.w=P,this.y=w,this.f=!0,this.h=this.B(new r.$oe),this.onDidChangeProfiles=this.h.event,this.j=this.B(new r.$oe),this.onWillCreateProfile=this.j.event,this.m=this.B(new r.$oe),this.onWillRemoveProfile=this.m.event,this.n=this.B(new r.$oe),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new p.$Dc,workspaces:new p.$Dc,emptyWindows:new Map},this.profilesHome=(0,A.$jh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$jh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(c){this.f!==c&&(this.z=void 0,this.f=c)}isEnabled(){return this.f}get C(){if(!this.z){const c=this.D(),h=[c];if(this.f)try{for(const D of this.O()){if(!D.name||!(0,g.$hg)(D.name)||!D.location){this.y.warn("Skipping the invalid stored profile",D.location||D.name);continue}h.push(a((0,A.$gh)(D.location),D.name,D.location,this.g,{shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags},c))}}catch(D){this.y.error(D)}const P=new p.$Dc,w=new Map;if(h.length)try{const D=this.Q();if(D.workspaces)for(const[L,R]of Object.entries(D.workspaces)){const T=O.URI.parse(L),j=h.find(G=>G.id===R);j&&P.set(T,j)}if(D.emptyWindows)for(const[L,R]of Object.entries(D.emptyWindows)){const T=h.find(j=>j.id===R);T&&w.set(L,T)}}catch(D){this.y.error(D)}this.z={profiles:h,workspaces:P,emptyWindows:w}}return this.z}D(){const c=a("__default__profile__",(0,I.localize)(2442,null),this.t.userRoamingDataHome,this.g);return{...c,extensionsResource:this.S()??c.extensionsResource,isDefault:!0}}async createTransientProfile(c){const h="Temp",P=new RegExp(`${(0,k.$kf)(h)}\\s(\\d+)`);let w=0;for(const L of this.profiles){const R=P.exec(L.name),T=R?parseInt(R[1]):0;w=T>w?T:w}const D=`${h} ${w+1}`;return this.createProfile((0,i.$wj)((0,y.$5g)()).toString(16),D,{transient:!0},c)}async createNamedProfile(c,h,P){return this.createProfile((0,i.$wj)((0,y.$5g)()).toString(16),c,h,P)}async createProfile(c,h,P,w){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=await this.F(c,h,P);return w&&await this.setProfileForWorkspace(w,D),D}async F(c,h,P){if(!(0,g.$hg)(h)||!h)throw new Error("Name of the profile is mandatory and must be of type `string`");let w=this.r.get(h);return w||(w=(async()=>{try{if(this.profiles.find(T=>T.name===h||T.id===c))throw new Error(`Profile with ${h} name already exists`);const L=a(c,h,(0,A.$jh)(this.profilesHome,c),this.g,P,this.defaultProfile);await this.u.createFolder(L.location);const R=[];return this.j.fire({profile:L,join(T){R.push(T)}}),await f.Promises.settled(R),this.I([L],[],[]),L}finally{this.r.delete(h)}})(),this.r.set(h,w)),w}async updateProfile(c,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let P=this.profiles.find(w=>w.id===c.id);if(!P)throw new Error(`Profile '${c.name}' does not exist`);return P=a(P.id,h.name??P.name,P.location,this.g,{shortName:h.shortName??P.shortName,icon:h.icon===null?void 0:h.icon??P.icon,transient:h.transient??P.isTransient,useDefaultFlags:h.useDefaultFlags??P.useDefaultFlags},this.defaultProfile),this.I([],[],[P]),P}async removeProfile(c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(c.isDefault)throw new Error("Cannot remove default profile");const h=this.profiles.find(w=>w.id===c.id);if(!h)throw new Error(`Profile '${c.name}' does not exist`);const P=[];this.m.fire({profile:h,join(w){P.push(w)}});try{await Promise.allSettled(P)}catch(w){this.y.error(w)}for(const w of[...this.C.emptyWindows.keys()])h.id===this.C.emptyWindows.get(w)?.id&&this.C.emptyWindows.delete(w);for(const w of[...this.C.workspaces.keys()])h.id===this.C.workspaces.get(w)?.id&&this.C.workspaces.delete(w);this.M(),this.I([],[h],[]);try{await this.u.del(h.cacheHome,{recursive:!0})}catch(w){(0,l.$ul)(w)!==l.FileOperationResult.FILE_NOT_FOUND&&this.y.error(w)}}async setProfileForWorkspace(c,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const P=this.profiles.find(w=>w.id===h.id);if(!P)throw new Error(`Profile '${h.name}' does not exist`);this.L(c,P)}unsetWorkspace(c,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(c,void 0,h)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const c=await this.u.resolve(this.profilesHome);await Promise.all((c.children||[]).filter(h=>h.isDirectory&&this.profiles.every(P=>!this.w.extUri.isEqual(P.location,h.resource))).map(h=>this.u.del(h.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const c=this.s.profiles.filter(h=>!this.H(h));await Promise.allSettled(c.map(h=>this.removeProfile(h)))}getProfileForWorkspace(c){const h=this.G(c),P=O.URI.isUri(h)?this.C.workspaces.get(h):this.C.emptyWindows.get(h);return P||((0,$.$Si)(c)?this.s.folders.get(c.uri):(0,$.$Xi)(c)?this.s.workspaces.get(c.configPath):this.s.emptyWindows.get(c.id))}G(c){return(0,$.$Si)(c)?c.uri:(0,$.$Xi)(c)?c.configPath:c.id}H(c){return!!([...this.C.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.C.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.s.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.s.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.s.folders.values()].some(h=>this.w.extUri.isEqual(h.location,c.location)))}I(c,h,P){const w=[...this.profiles,...c],D=[],L=this.s.profiles;this.s.profiles=[];for(let R of w){if(R.isDefault||h.some(j=>R.id===j.id))continue;R=P.find(j=>R.id===j.id)??R;const T=L.find(j=>R.id===j.id);if(R.isTransient)this.s.profiles.push(R);else{if(T){for(const[j,G]of this.s.emptyWindows.entries())if(R.id===G.id){this.L({id:j},R);break}for(const[j,G]of this.s.workspaces.entries())if(R.id===G.id){this.L({id:"",configPath:j},R);break}for(const[j,G]of this.s.folders.entries())if(R.id===G.id){this.L({id:"",uri:j},R);break}}D.push({location:R.location,name:R.name,shortName:R.shortName,icon:R.icon,useDefaultFlags:R.useDefaultFlags})}}this.P(D),this.z=void 0,this.J(c,h,P)}J(c,h,P){this.h.fire({added:c,removed:h,updated:P,all:this.profiles})}L(c,h,P){if(P=h?.isTransient?!0:P,P)(0,$.$Si)(c)?(this.s.folders.delete(c.uri),h&&this.s.folders.set(c.uri,h)):(0,$.$Xi)(c)?(this.s.workspaces.delete(c.configPath),h&&this.s.workspaces.set(c.configPath,h)):(this.s.emptyWindows.delete(c.id),h&&this.s.emptyWindows.set(c.id,h));else{this.L(c,void 0,!0);const w=this.G(c);O.URI.isUri(w)?(this.C.workspaces.delete(w),h&&this.C.workspaces.set(w,h)):(this.C.emptyWindows.delete(w),h&&this.C.emptyWindows.set(w,h)),this.M()}}M(){const c={};for(const[P,w]of this.C.workspaces.entries())c[P.toString()]=w.id;const h={};for(const[P,w]of this.C.emptyWindows.entries())h[P.toString()]=w.id;this.R({workspaces:c,emptyWindows:h}),this.z=void 0}N(c){const h={},P=this.D();if(c.workspaces)for(const[D,L]of Object.entries(c.workspaces)){const R=O.URI.parse(L);h[D]=this.w.extUri.isEqual(R,P.location)?P.id:this.w.extUri.basename(R)}const w={};if(c.emptyWindows)for(const[D,L]of Object.entries(c.emptyWindows)){const R=O.URI.parse(L);w[D]=this.w.extUri.isEqual(R,P.location)?P.id:this.w.extUri.basename(R)}return{workspaces:h,emptyWindows:w}}O(){return[]}P(c){throw new Error("not implemented")}Q(){return{}}R(c){throw new Error("not implemented")}S(){}};e.$Sl=t,e.$Sl=t=ke([re(0,b.$Pi),re(1,l.$dl),re(2,d.$Nl),re(3,u.$dk)],t);class o extends t{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(c){this.a=c}Q(){return this.X}R(c){this.X=c}}e.$Tl=o}),define(le[88],ue([0,1,8,17,2,4,31,7,128,131,14,6,5,42,41,12,15,24]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p,d,f,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=e.$Pq=e.$Oq=e.ExtensionsProfileScanningErrorCode=void 0;var g;(function(t){t.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",t.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(g||(e.ExtensionsProfileScanningErrorCode=g={}));class E extends Error{constructor(o,n){super(o),this.code=n}}e.$Oq=E,e.$Pq=(0,u.$Ii)("IExtensionsProfileScannerService");let S=class extends v.$Xc{constructor(o,n,c,h,P,w){super(),this.j=o,this.m=n,this.n=c,this.r=h,this.s=P,this.t=w,this.b=this.B(new A.$oe),this.onAddExtensions=this.b.event,this.c=this.B(new A.$oe),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$oe),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$oe),this.onDidRemoveExtensions=this.g.event,this.h=new O.$Dc}scanProfileExtensions(o,n){return this.u(o,void 0,n)}async addExtensionsToProfile(o,n,c){const h=[],P=[];try{return await this.u(n,w=>{const D=[];if(c)D.push(...w);else for(const L of w)o.some(([R])=>(0,l.$Qp)(R.identifier,L.identifier)&&R.manifest.version!==L.version)?h.push(L):D.push(L);for(const[L,R]of o){const T=D.findIndex(G=>(0,l.$Qp)(G.identifier,L.identifier)&&G.version===L.manifest.version),j={identifier:L.identifier,version:L.manifest.version,location:L.location,metadata:R};T===-1?(P.push(j),D.push(j)):D.splice(T,1,j)}return P.length&&this.b.fire({extensions:P,profileLocation:n}),h.length&&this.f.fire({extensions:h,profileLocation:n}),D}),P.length&&this.c.fire({extensions:P,profileLocation:n}),h.length&&this.g.fire({extensions:h,profileLocation:n}),P}catch(w){throw P.length&&this.c.fire({extensions:P,error:w,profileLocation:n}),h.length&&this.g.fire({extensions:h,error:w,profileLocation:n}),w}}async updateMetadata(o,n){const c=[];return await this.u(n,h=>{const P=[];for(const w of h){const D=o.find(([L])=>(0,l.$Qp)(L.identifier,w.identifier)&&L.manifest.version===w.version);D&&(w.metadata={...w.metadata,...D[1]},c.push(w)),P.push(w)}return P}),c}async removeExtensionFromProfile(o,n){const c=[];try{await this.u(n,h=>{const P=[];for(const w of h)(0,l.$Qp)(w.identifier,o.identifier)?c.push(w):P.push(w);return c.length&&this.f.fire({extensions:c,profileLocation:n}),P}),c.length&&this.g.fire({extensions:c,profileLocation:n})}catch(h){throw c.length&&this.g.fire({extensions:c,error:h,profileLocation:n}),h}}async u(o,n,c){return this.F(o).queue(async()=>{let h=[],P;try{const w=await this.m.readFile(o);P=JSON.parse(w.value.toString().trim()||"[]")}catch(w){if((0,m.$ul)(w)!==m.FileOperationResult.FILE_NOT_FOUND)throw w;if(this.r.extUri.isEqual(o,this.n.defaultProfile.extensionsResource)&&(P=await this.D()),!P&&c?.bailOutWhenFileNotFound)throw new E((0,y.$_)(w),g.ERROR_PROFILE_NOT_FOUND)}if(P){Array.isArray(P)||this.w(o);let w=!1;for(const D of P){s(D)||this.w(o);let L;if((0,f.$hg)(D.relativeLocation)&&D.relativeLocation)L=this.z(D.relativeLocation);else if((0,f.$hg)(D.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${D.location}`);continue}else{L=I.URI.revive(D.location);const R=this.y(L);R&&(w=!0,D.relativeLocation=R)}(0,f.$og)(D.metadata?.hasPreReleaseVersion)&&D.metadata?.preRelease&&(w=!0,D.metadata.hasPreReleaseVersion=!0),h.push({identifier:D.identifier,location:L,version:D.version,metadata:D.metadata})}w&&await this.m.writeFile(o,r.$Qe.fromString(JSON.stringify(P)))}if(n){h=n(h);const w=h.map(D=>({identifier:D.identifier,version:D.version,location:D.location.toJSON(),relativeLocation:this.y(D.location),metadata:D.metadata}));await this.m.writeFile(o,r.$Qe.fromString(JSON.stringify(w)))}return h})}w(o){const n=new E(`Invalid extensions content in ${o.toString()}`,g.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}y(o){return this.r.extUri.isEqual(this.r.extUri.dirname(o),this.j)?this.r.extUri.basename(o):void 0}z(o){return this.r.extUri.joinPath(this.j,o)}async D(){return this.C||(this.C=(async()=>{const o=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),n=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let c;try{c=(await this.m.readFile(o)).value.toString()}catch(P){if((0,m.$ul)(P)===m.FileOperationResult.FILE_NOT_FOUND)return;throw P}this.t.info("Migrating extensions from old default profile location",o.toString());let h;try{const P=JSON.parse(c);Array.isArray(P)&&P.every(w=>s(w))?h=P:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",P)}catch(P){this.t.error(P)}if(h)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,r.$Qe.fromString(JSON.stringify(h)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",o.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(P){if((0,m.$ul)(P)===m.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",o.toString(),this.n.defaultProfile.extensionsResource.toString());else throw P}try{await this.m.del(o)}catch(P){(0,m.$ul)(P)!==m.FileOperationResult.FILE_NOT_FOUND&&this.t.error(P)}try{await this.m.del(n)}catch(P){(0,m.$ul)(P)!==m.FileOperationResult.FILE_NOT_FOUND&&this.t.error(P)}return h})()),this.C}F(o){let n=this.h.get(o);return n||(n=new i.$Ph,this.h.set(o,n)),n}};e.$Qq=S,e.$Qq=S=ke([re(1,m.$dl),re(2,p.$Pl),re(3,d.$Nl),re(4,k.$cm),re(5,$.$dk)],S);function s(t){return(0,f.$jg)(t)&&(0,b.$op)(t.identifier)&&(a(t.location)||(0,f.$hg)(t.location)&&t.location)&&((0,f.$og)(t.relativeLocation)||(0,f.$hg)(t.relativeLocation))&&t.version&&(0,f.$hg)(t.version)}function a(t){return t?(0,f.$hg)(t.path)&&(0,f.$hg)(t.scheme):!1}});var xe=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[135],ue([0,1,21,8,38,17,15,43,166,2,11,9,3,18,213,82,12,7,10,36,131,87,212,14,6,5,28,4,83,88,42,41,174]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p,d,f,y,k,g,E,S,s,a,t,o,n,c,h,P,w,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=e.$Vq=e.$Uq=e.$Tq=e.Translations=void 0,e.$Wq=de,v=Ie(v),u=Ie(u),$=Ie($),d=Ie(d),f=xe(f);var T;(function(Y){function B(_,C){if(_===C)return!0;const W=Object.keys(_),F=new Set;for(const H of Object.keys(C))F.add(H);if(W.length!==F.size)return!1;for(const H of W){if(_[H]!==C[H])return!1;F.delete(H)}return F.size===0}Y.equals=B})(T||(e.Translations=T={})),e.$Tq=(0,o.$Ii)("IExtensionsScannerService");let j=class extends l.$Xc{constructor(B,_,C,W,F,H,ne,x,ce,oe,J,M){super(),this.systemExtensionsLocation=B,this.userExtensionsLocation=_,this.r=C,this.s=W,this.t=F,this.u=H,this.w=ne,this.y=x,this.z=ce,this.C=oe,this.D=J,this.F=M,this.g=this.B(new h.$oe),this.onDidChangeCache=this.g.event,this.h=(0,p.$jh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(Q,this.s,this.h)),this.m=this.B(this.F.createInstance(Q,this.s,this.h)),this.n=this.B(this.F.createInstance(q,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(s.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(s.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,S.$2p)(this.w,this.y)),this.G}async scanAllExtensions(B,_,C){const[W,F]=await Promise.all([this.scanSystemExtensions(B),this.scanUserExtensions(_)]),H=C?await this.scanExtensionsUnderDevelopment(B,[...W,...F]):[];return this.L(W,F,H,await this.getTargetPlatform(),!0)}async scanSystemExtensions(B){const _=[];_.push(this.M(!!B.useCache,B.language)),_.push(this.N(B.language,!!B.checkControlFile));const[C,W]=await Promise.all(_);return this.J([...C,...W],s.ExtensionType.System,B,!1)}async scanUserExtensions(B){const _=B.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",_);const C=this.D.extUri.isEqual(B.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,W=await this.P(_,!!B.profileLocation,s.ExtensionType.User,!B.includeUninstalled,B.language,!0,C,B.productVersion??this.R()),F=B.useCache&&!W.devMode&&W.excludeObsolete?this.m:this.n;let H;try{H=await F.scanExtensions(W)}catch(ne){if(ne instanceof w.$Oq&&ne.code===w.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),H=await F.scanExtensions(W);else throw ne}return H=await this.J(H,s.ExtensionType.User,B,!0),this.y.trace("Scanned user extensions:",H.length),H}async scanExtensionsUnderDevelopment(B,_){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const C=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(W=>W.scheme===m.Schemas.file).map(async W=>{const F=await this.P(W,!1,s.ExtensionType.User,!0,B.language,!1,void 0,B.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(F)).map(ne=>(ne.type=_.find(x=>(0,S.$Qp)(x.identifier,ne.identifier))?.type??ne.type,this.n.validate(ne,F)))}))).flat();return this.J(C,"development",B,!0)}return[]}async scanExistingExtension(B,_,C){const W=await this.P(B,!1,_,!0,C.language,!0,void 0,C.productVersion??this.R()),F=await this.n.scanExtension(W);return!F||!C.includeInvalid&&!F.isValid?null:F}async scanOneOrMultipleExtensions(B,_,C){const W=await this.P(B,!1,_,!0,C.language,!0,void 0,C.productVersion??this.R()),F=await this.n.scanOneOrMultipleExtensions(W);return this.J(F,_,C,!0)}async scanMultipleExtensions(B,_,C){const W=[];return await Promise.all(B.map(async F=>{const H=await this.scanOneOrMultipleExtensions(F,_,C);W.push(...H)})),this.J(W,_,C,!0)}async scanMetadata(B){const _=(0,p.$jh)(B,"package.json"),C=(await this.w.readFile(_)).value.toString();return JSON.parse(C).__metadata}async updateMetadata(B,_){const C=(0,p.$jh)(B,"package.json"),W=(await this.w.readFile(C)).value.toString(),F=JSON.parse(W);_.isMachineScoped===!1&&delete _.isMachineScoped,_.isBuiltin===!1&&delete _.isBuiltin,F.__metadata={...F.__metadata,..._},await this.w.writeFile((0,p.$jh)(B,"package.json"),A.$Qe.fromString(JSON.stringify(F,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(B){if(B instanceof w.$Oq&&B.code===w.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw B}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const B=await this.scanUserExtensions({includeInvalid:!0});if(B.length)await this.u.addExtensionsToProfile(B.map(_=>[_,_.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$Qe.fromString(JSON.stringify([])))}catch(_){(0,t.$ul)(_)!==t.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,O.$_)(_))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(B){this.y.error(B)}finally{this.H=void 0}})()),this.H}async J(B,_,C,W){return C.includeAllVersions||(B=this.L(_===s.ExtensionType.System?B:void 0,_===s.ExtensionType.User?B:void 0,_==="development"?B:void 0,await this.getTargetPlatform(),W)),C.includeInvalid||(B=B.filter(F=>F.isValid)),B.sort((F,H)=>{const ne=u.$qc(F.location.fsPath),x=u.$qc(H.location.fsPath);return ne<x?-1:ne>x?1:0})}L(B,_,C,W,F){const H=(x,ce,oe)=>{if(x.isValid&&!ce.isValid)return!1;if(x.isValid===ce.isValid){if(F&&d.gt(x.manifest.version,ce.manifest.version))return this.y.debug(`Skipping extension ${ce.location.path} with lower version ${ce.manifest.version} in favour of ${x.location.path} with version ${x.manifest.version}`),!1;if(d.eq(x.manifest.version,ce.manifest.version)){if(x.type===s.ExtensionType.System)return this.y.debug(`Skipping extension ${ce.location.path} in favour of system extension ${x.location.path} with same version`),!1;if(x.targetPlatform===W)return this.y.debug(`Skipping extension ${ce.location.path} from different target platform ${ce.targetPlatform}`),!1}}return oe?this.y.warn(`Overwriting user extension ${x.location.path} with ${ce.location.path}.`):this.y.debug(`Overwriting user extension ${x.location.path} with ${ce.location.path}.`),!0},ne=new s.$xn;return B?.forEach(x=>{const ce=ne.get(x.identifier.id);(!ce||H(ce,x,!1))&&ne.set(x.identifier.id,x)}),_?.forEach(x=>{const ce=ne.get(x.identifier.id);if(!ce&&B&&x.type===s.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${x.location.path}.`);return}(!ce||H(ce,x,!1))&&ne.set(x.identifier.id,x)}),C?.forEach(x=>{const ce=ne.get(x.identifier.id);(!ce||H(ce,x,!0))&&ne.set(x.identifier.id,x),ne.set(x.identifier.id,x)}),[...ne.values()]}async M(B,_){this.y.trace("Started scanning system extensions");const C=await this.P(this.systemExtensionsLocation,!1,s.ExtensionType.System,!0,_,!0,void 0,this.R()),F=await(B&&!C.devMode?this.j:this.n).scanExtensions(C);return this.y.trace("Scanned system extensions:",F.length),F}async N(B,_){const C=this.z.isBuilt?[]:this.C.builtInExtensions;if(!C?.length)return[];this.y.trace("Started scanning dev system extensions");const W=_?await this.O():{},F=[],H=k.URI.file(u.$kc(u.$mc(m.$3g.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const x of C){const ce=W[x.name]||"marketplace";switch(ce){case"disabled":break;case"marketplace":F.push((0,p.$jh)(H,x.name));break;default:F.push(k.URI.file(ce));break}}const ne=await Promise.all(F.map(async x=>this.n.scanExtension(await this.P(x,!1,s.ExtensionType.System,!0,B,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",ne.length),(0,i.$Jb)(ne)}async O(){try{const B=await this.w.readFile(this.r);return JSON.parse(B.value.toString())}catch{return{}}}async P(B,_,C,W,F,H,ne,x){const ce=await this.f(F??$.$x),oe=await this.Q(B),J=_&&!this.D.extUri.isEqual(B,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,M=J?await this.Q(J):void 0;return new G(B,oe,J,M,_,ne,C,W,H,x.version,x.date,this.C.commit,!this.z.isBuilt,F,ce)}async Q(B){try{const _=await this.w.stat(B);if(typeof _.mtime=="number")return _.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Uq=j,e.$Uq=j=ke([re(4,D.$Pl),re(5,w.$Pq),re(6,t.$dl),re(7,n.$dk),re(8,E.$Pi),re(9,c.$wk),re(10,L.$Nl),re(11,o.$Hi)],j);class G{constructor(B,_,C,W,F,H,ne,x,ce,oe,J,M,Z,U,N){this.location=B,this.mtime=_,this.applicationExtensionslocation=C,this.applicationExtensionslocationMtime=W,this.profile=F,this.profileScanOptions=H,this.type=ne,this.excludeObsolete=x,this.validate=ce,this.productVersion=oe,this.productDate=J,this.productCommit=M,this.devMode=Z,this.language=U,this.translations=N}static createNlsConfiguration(B){return{language:B.language,pseudo:B.language==="pseudo",devMode:B.devMode,translations:B.translations}}static equals(B,_){return(0,p.$ch)(B.location,_.location)&&B.mtime===_.mtime&&(0,p.$ch)(B.applicationExtensionslocation,_.applicationExtensionslocation)&&B.applicationExtensionslocationMtime===_.applicationExtensionslocationMtime&&B.profile===_.profile&&v.$mo(B.profileScanOptions,_.profileScanOptions)&&B.type===_.type&&B.excludeObsolete===_.excludeObsolete&&B.validate===_.validate&&B.productVersion===_.productVersion&&B.productDate===_.productDate&&B.productCommit===_.productCommit&&B.devMode===_.devMode&&B.language===_.language&&T.equals(B.translations,_.translations)}}e.$Vq=G;let q=class extends l.$Xc{constructor(B,_,C,W,F,H,ne){super(),this.g=B,this.h=_,this.j=C,this.m=W,this.n=H,this.r=ne,this.f=F.extensionsEnabledWithApiProposalVersion?.map(x=>x.toLowerCase())??[]}async scanExtensions(B){const _=B.profile?await this.t(B):await this.s(B);let C={};if(B.excludeObsolete&&B.type===s.ExtensionType.User)try{const W=(await this.m.readFile(this.g)).value.toString();C=JSON.parse(W)}catch{}return(0,y.$ug)(C)?_:_.filter(W=>!C[S.$Rp.create(W).toString()])}async s(B){const _=await this.m.resolve(B.location);if(!_.children?.length)return[];const C=await Promise.all(_.children.map(async W=>{if(!W.isDirectory||B.type===s.ExtensionType.User&&(0,p.$gh)(W.resource).indexOf(".")===0)return null;const F=new G(W.resource,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(F)}));return(0,i.$Jb)(C).sort((W,F)=>W.location.path<F.location.path?-1:1)}async t(B){let _=await this.u(B.location,()=>!0,B);if(B.applicationExtensionslocation&&!this.j.extUri.isEqual(B.location,B.applicationExtensionslocation)){_=_.filter(W=>!W.metadata?.isApplicationScoped);const C=await this.u(B.applicationExtensionslocation,W=>!!W.metadata?.isBuiltin||!!W.metadata?.isApplicationScoped,B);_.push(...C)}return _}async u(B,_,C){const W=await this.h.scanProfileExtensions(B,C.profileScanOptions);if(!W.length)return[];const F=await Promise.all(W.map(async H=>{if(_(H)){const ne=new G(H.location,C.mtime,C.applicationExtensionslocation,C.applicationExtensionslocationMtime,C.profile,C.profileScanOptions,C.type,C.excludeObsolete,C.validate,C.productVersion,C.productDate,C.productCommit,C.devMode,C.language,C.translations);return this.scanExtension(ne,H.metadata)}return null}));return(0,i.$Jb)(F)}async scanOneOrMultipleExtensions(B){try{if(await this.m.exists((0,p.$jh)(B.location,"package.json"))){const _=await this.scanExtension(B);return _?[_]:[]}else return await this.scanExtensions(B)}catch(_){return this.r.error(`Error scanning extensions at ${B.location.path}:`,(0,O.$_)(_)),[]}}async scanExtension(B,_){try{let C=await this.w(B.location);if(C){C.publisher||(C.publisher=s.$rn),_=_??C.__metadata,delete C.__metadata;const W=(0,S.$Vp)(C.publisher,C.name),F=_?.id?{id:W,uuid:_.id}:{id:W},H=_?.isSystem?s.ExtensionType.System:B.type,ne=H===s.ExtensionType.System||!!_?.isBuiltin;C=await this.y(B.location,C,G.createNlsConfiguration(B));let x={type:H,identifier:F,manifest:C,location:B.location,isBuiltin:ne,targetPlatform:_?.targetPlatform??s.TargetPlatform.UNDEFINED,publisherDisplayName:_?.publisherDisplayName,metadata:_,isValid:!0,validations:[]};return B.validate&&(x=this.validate(x,B)),C.enabledApiProposals&&(!this.n.isBuilt||this.f.includes(W.toLowerCase()))&&(C.originalEnabledApiProposals=C.enabledApiProposals,C.enabledApiProposals=(0,s.$Dn)([...C.enabledApiProposals])),x}}catch(C){B.type!==s.ExtensionType.System&&this.r.error(C)}return null}validate(B,_){let C=!0;const W=this.n.isBuilt&&this.f.includes(B.identifier.id.toLowerCase()),F=(0,a.$8p)(_.productVersion,_.productDate,_.location,B.manifest,B.isBuiltin,W);for(const[H,ne]of F)H===f.default.Error&&(C=!1,this.r.error(this.F(_.location,ne)));return B.isValid=C,B.validations=F,B}async w(B){const _=(0,p.$jh)(B,"package.json");let C;try{C=(await this.m.readFile(_)).value.toString()}catch(F){return(0,t.$ul)(F)!==t.FileOperationResult.FILE_NOT_FOUND&&this.r.error(this.F(B,(0,g.localize)(1815,null,_.path,F.message))),null}let W;try{W=JSON.parse(C)}catch{const H=[];(0,I.$3n)(C,H);for(const ne of H)this.r.error(this.F(B,(0,g.localize)(1816,null,_.path,ne.offset,ne.length,(0,b.$Rq)(ne.error))));return null}return(0,I.$$n)(W)!=="object"?(this.r.error(this.F(B,(0,g.localize)(1817,null,_.path))),null):W}async y(B,_,C){const W=await this.z(B,_,C);if(W)try{const F=[],H=await this.C(W.default,F);if(F.length>0)return F.forEach(x=>{this.r.error(this.F(B,(0,g.localize)(1818,null,W.default?.path,(0,b.$Rq)(x.error))))}),_;if((0,I.$$n)(W)!=="object")return this.r.error(this.F(B,(0,g.localize)(1819,null,W.default?.path))),_;const ne=W.values||Object.create(null);return(0,R.$Sq)(this.r,_,ne,H)}catch{}return _}async z(B,_,C){const W=(0,p.$jh)(B,"package.nls.json"),F=(ce,oe)=>{oe.forEach(J=>{this.r.error(this.F(B,(0,g.localize)(1820,null,ce?.path,(0,b.$Rq)(J.error))))})},H=ce=>{this.r.error(this.F(B,(0,g.localize)(1821,null,ce?.path)))},ne=`${_.publisher}.${_.name}`,x=C.translations[ne];if(x)try{const ce=k.URI.file(x),oe=(await this.m.readFile(ce)).value.toString(),J=[],M=(0,I.$3n)(oe,J);return J.length>0?(F(ce,J),{values:void 0,default:W}):(0,I.$$n)(M)!=="object"?(H(ce),{values:void 0,default:W}):{values:M.contents?M.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.m.exists(W))return;let oe;try{oe=await this.D(B,C)}catch{return}if(!oe.localized)return{values:void 0,default:oe.original};try{const J=(await this.m.readFile(oe.localized)).value.toString(),M=[],Z=(0,I.$3n)(J,M);return M.length>0?(F(oe.localized,M),{values:void 0,default:oe.original}):(0,I.$$n)(Z)!=="object"?(H(oe.localized),{values:void 0,default:oe.original}):{values:Z,default:oe.original}}catch{return{values:void 0,default:oe.original}}}}async C(B,_){if(B)try{const C=(await this.m.readFile(B)).value.toString();return(0,I.$3n)(C,_)}catch{}}D(B,_){return new Promise((C,W)=>{const F=H=>{const ne=(0,p.$jh)(B,`package.nls.${H}.json`);this.m.exists(ne).then(x=>{x&&C({localized:ne,original:(0,p.$jh)(B,"package.nls.json")});const ce=H.lastIndexOf("-");ce===-1?C({localized:(0,p.$jh)(B,"package.nls.json"),original:null}):(H=H.substring(0,ce),F(H))})};if(_.devMode||_.pseudo||!_.language)return C({localized:(0,p.$jh)(B,"package.nls.json"),original:null});F(_.language)})}F(B,_){return`[${B.path}]: ${_}`}};q=ke([re(1,w.$Pq),re(2,L.$Nl),re(3,t.$dl),re(4,c.$wk),re(5,E.$Pi),re(6,n.$dk)],q);let Q=class extends q{constructor(B,_,C,W,F,H,ne,x,ce){super(_,W,F,H,ne,x,ce),this.J=B,this.L=C,this.H=this.B(new r.$Gh(3e3)),this.I=this.B(new h.$oe),this.onDidChangeCache=this.I.event}async scanExtensions(B){const _=this.P(B),C=await this.M(_);if(this.G=B,C&&C.input&&G.equals(C.input,this.G))return this.r.debug("Using cached extensions scan result",B.type===s.ExtensionType.System?"system":"user",B.location.toString()),this.H.trigger(()=>this.O()),C.result.map(F=>(F.location=k.URI.revive(F.location),F));const W=await super.scanExtensions(B);return await this.N(_,{input:B,result:W}),W}async M(B){try{const _=await this.m.readFile(B),C=JSON.parse(_.value.toString());return{result:C.result,input:(0,P.$fi)(C.input)}}catch(_){this.r.debug("Error while reading the extension cache file:",B.path,(0,O.$_)(_))}return null}async N(B,_){try{await this.m.writeFile(B,A.$Qe.fromString(JSON.stringify(_)))}catch(C){this.r.debug("Error while writing the extension cache file:",B.path,(0,O.$_)(C))}}async O(){if(!this.G)return;const B=this.P(this.G),_=await this.M(B);if(!_)return;const C=_.result,W=JSON.parse(JSON.stringify(await super.scanExtensions(this.G)));if(!v.$mo(W,C))try{this.r.info("Invalidating Cache",C,W),await this.m.del(B),this.I.fire()}catch(F){this.r.error(F)}}P(B){const _=this.Q(B);return this.j.extUri.joinPath(_.cacheHome,B.type===s.ExtensionType.System?s.$qn:s.$pn)}Q(B){return B.type===s.ExtensionType.System?this.L.defaultProfile:B.profile?this.j.extUri.isEqual(B.location,this.J.extensionsResource)?this.J:this.L.profiles.find(_=>this.j.extUri.isEqual(B.location,_.extensionsResource))??this.J:this.L.defaultProfile}};Q=ke([re(2,D.$Pl),re(3,w.$Pq),re(4,L.$Nl),re(5,t.$dl),re(6,c.$wk),re(7,E.$Pi),re(8,n.$dk)],Q);function de(Y,B){const _=(0,S.$Tp)(Y.manifest.publisher,Y.manifest.name);return{id:_,identifier:new s.$vn(_),isBuiltin:Y.type===s.ExtensionType.System,isUserBuiltin:Y.type===s.ExtensionType.User&&Y.isBuiltin,isUnderDevelopment:B,extensionLocation:Y.location,uuid:Y.identifier.uuid,targetPlatform:Y.targetPlatform,publisherDisplayName:Y.publisherDisplayName,...Y.manifest}}class V extends j{constructor(B,_,C,W,F,H,ne,x,ce,oe,J,M){super(B,_,(0,p.$jh)(C,".vscode-oss-dev","extensions","control.json"),W,F,H,ne,x,ce,oe,J,M),this.S=(async()=>{if($.$A)try{const Z=await this.w.readFile(k.URI.file($.$A));return JSON.parse(Z.value.toString())}catch{}return Object.create(null)})()}f(B){return this.S}}e.$Xq=V}),define(le[247],ue([0,1,5,42,41,24,88,14,36,7]),function(K,e,i,r,v,A,O,I,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3R=void 0;let m=class extends O.$Qq{constructor($,p,d,f,y,k){super(l.URI.file($.extensionsPath),p,d,f,y,k)}};e.$3R=m,e.$3R=m=ke([re(0,b.$Qi),re(1,I.$dl),re(2,r.$Pl),re(3,v.$Nl),re(4,A.$cm),re(5,i.$dk)],m)}),define(le[248],ue([0,1,7,36,88,135,14,6,5,28,41,42]),function(K,e,i,r,v,A,O,I,b,l,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wic=void 0;let $=class extends A.$Xq{constructor(d,f,y,k,g,E,S,s){super(i.URI.file(g.builtinExtensionsPath),i.URI.file(g.extensionsPath),g.userHome,d.defaultProfile,d,f,y,k,g,E,S,s)}};e.$wic=$,e.$wic=$=ke([re(0,u.$Pl),re(1,v.$Pq),re(2,O.$dl),re(3,b.$dk),re(4,r.$Qi),re(5,l.$wk),re(6,m.$Nl),re(7,I.$Hi)],$)}),define(le[249],ue([0,1,13,2,11,9,3,61,7,33,35,36,5,42]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qic=void 0;let d=class extends r.$Xc{constructor(y,k,g){super(),this.c=y,this.f=g,this.a=I.$Oi.forPaths(!O.$l),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp",".mp4"]),this.addValidFileRoot(y.appRoot),this.addValidFileRoot(y.extensionsPath),this.addValidFileRoot(k.defaultProfile.globalStorageHome.with({scheme:v.Schemas.file}).fsPath),this.addValidFileRoot(y.workspaceStorageHome.with({scheme:v.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:y}=i.session;y.protocol.registerFileProtocol(v.Schemas.vscodeFileResource,(k,g)=>this.j(k,g)),y.protocol.interceptFileProtocol(v.Schemas.file,(k,g)=>this.h(k,g)),this.B((0,r.$Vc)(()=>{y.protocol.unregisterProtocol(v.Schemas.vscodeFileResource),y.protocol.uninterceptProtocol(v.Schemas.file)}))}addValidFileRoot(y){const k=(0,A.$kc)(y);return this.a.get(k)?r.$Xc.None:(this.a.set(k,!0),(0,r.$Vc)(()=>this.a.delete(k)))}h(y,k){const g=b.URI.parse(y.url);return this.f.error(`Refused to load resource ${g.fsPath} from ${v.Schemas.file}: protocol (original URL: ${y.url})`),k({error:-3})}j(y,k){const g=this.m(y);let E;if(this.c.crossOriginIsolated){const S=(0,A.$qc)(g);S==="workbench.html"||S==="workbench-dev.html"||S==="workbench.esm.html"||S==="workbench-dev.esm.html"?E=v.COI.CoopAndCoep:E=v.COI.getHeadersFromQuery(y.url)}return this.a.findSubstr(g)?k({path:g,headers:E}):this.b.has((0,A.$rc)(g).toLowerCase())?k({path:g}):(this.f.error(`${v.Schemas.vscodeFileResource}: Refused to load resource ${g} from ${v.Schemas.vscodeFileResource}: protocol (original URL: ${y.url})`),k({error:-3}))}m(y){const k=b.URI.parse(y.url),g=v.$3g.uriToFileUri(k);return(0,A.$kc)(g.fsPath)}createIPCObjectUrl(){let y;const k=b.URI.from({scheme:"vscode",path:(0,l.$5g)()}),g=k.toString(),E=async()=>y;return m.$gY.handle(g,E),this.f.trace(`IPC Object URL: Registered new channel ${g}.`),{resource:k,update:S=>y=S,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${g}.`),m.$gY.removeHandler(g)}}}};e.$Qic=d,e.$Qic=d=ke([re(0,u.$Qi),re(1,p.$Pl),re(2,$.$dk)],d)}),define(le[64],ue([0,1,8,4,2,72,12,122,6,42]),function(K,e,i,r,v,A,O,I,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=e.$oq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$mq=e.$lq=e.$kq=void 0,e.$nq=p,e.$pq=f,e.$rq=k,e.$kq="__$__isNewStorageMarker",e.$lq="__$__targetStorageMarker",e.$mq=(0,b.$Ii)("storageService");var m;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(m||(e.WillSaveStateReason=m={}));var u;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(u||(e.StorageScope=u={}));var $;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})($||(e.StorageTarget=$={}));function p(g){const E=g.get(e.$lq);if(E)try{return JSON.parse(E)}catch{}return Object.create(null)}class d extends v.$Xc{static{this.a=60*1e3}constructor(E={flushInterval:d.a}){super(),this.m=E,this.b=this.B(new r.$re),this.c=this.B(new r.$re),this.onDidChangeTarget=this.c.event,this.f=this.B(new r.$oe),this.onWillSaveState=this.f.event,this.h=this.B(new i.$Uh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new v.$Yc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(E,S,s){return r.Event.filter(this.b.event,a=>a.scope===E&&(S===void 0||a.key===S),s)}n(){this.j.value=(0,i.$Yh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,v.$Sc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(E,S){const{key:s,external:a}=S;if(s===e.$lq){switch(E){case u.APPLICATION:this.H=void 0;break;case u.PROFILE:this.F=void 0;break;case u.WORKSPACE:this.C=void 0;break}this.c.fire({scope:E})}else this.b.fire({scope:E,key:s,target:this.J(E)[s],external:a})}w(E){this.f.fire({reason:E})}get(E,S,s){return this.P(S)?.get(E,s)}getBoolean(E,S,s){return this.P(S)?.getBoolean(E,s)}getNumber(E,S,s){return this.P(S)?.getNumber(E,s)}getObject(E,S,s){return this.P(S)?.getObject(E,s)}storeAll(E,S){this.y(()=>{for(const s of E)this.store(s.key,s.value,s.scope,s.target,S)})}store(E,S,s,a,t=!1){if((0,O.$qg)(S)){this.remove(E,s,t);return}this.y(()=>{this.z(E,s,a),this.P(s)?.set(E,S,t)})}remove(E,S,s=!1){this.y(()=>{this.z(E,S,void 0),this.P(S)?.delete(E,s)})}y(E){this.b.pause(),this.c.pause();try{E()}finally{this.b.resume(),this.c.resume()}}keys(E,S){const s=[],a=this.J(E);for(const t of Object.keys(a))a[t]===S&&s.push(t);return s}z(E,S,s,a=!1){const t=this.J(S);typeof s=="number"?t[E]!==s&&(t[E]=s,this.P(S)?.set(e.$lq,JSON.stringify(t),a)):typeof t[E]=="number"&&(delete t[E],this.P(S)?.set(e.$lq,JSON.stringify(t),a))}get D(){return this.C||(this.C=this.L(u.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(u.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(u.APPLICATION)),this.H}J(E){switch(E){case u.APPLICATION:return this.I;case u.PROFILE:return this.G;default:return this.D}}L(E){const S=this.P(E);return S?p(S):Object.create(null)}isNew(E){return this.getBoolean(e.$kq,E)===!0}async flush(E=m.NONE){this.f.fire({reason:E});const S=this.P(u.APPLICATION),s=this.P(u.PROFILE),a=this.P(u.WORKSPACE);switch(E){case m.NONE:await i.Promises.settled([S?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve()]);break;case m.SHUTDOWN:await i.Promises.settled([S?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve()]);break}}async log(){const E=this.P(u.APPLICATION)?.items??new Map,S=this.P(u.PROFILE)?.items??new Map,s=this.P(u.WORKSPACE)?.items??new Map;return k(E,S,s,this.Q(u.APPLICATION)??"",this.Q(u.PROFILE)??"",this.Q(u.WORKSPACE)??"")}async optimize(E){return await this.flush(),this.P(E)?.optimize()}async switch(E,S){return this.w(m.NONE),(0,l.$Ol)(E)?this.R(E,S):this.S(E,S)}M(E,S){return!(E.id===S.id||f(S)&&f(E))}N(E,S,s){this.y(()=>{const a=new Set;for(const[t,o]of E)a.add(t),S.get(t)!==o&&this.u(s,{key:t,external:!0});for(const[t]of S.items)a.has(t)||this.u(s,{key:t,external:!0})})}}e.$oq=d;function f(g){return g.isDefault||!!g.useDefaultFlags?.globalState}class y extends d{constructor(){super(),this.U=this.B(new I.$iq(new I.$jq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new I.$iq(new I.$jq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new I.$iq(new I.$jq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(E=>this.u(u.WORKSPACE,E))),this.B(this.W.onDidChangeStorage(E=>this.u(u.PROFILE,E))),this.B(this.U.onDidChangeStorage(E=>this.u(u.APPLICATION,E)))}P(E){switch(E){case u.APPLICATION:return this.U;case u.PROFILE:return this.W;default:return this.X}}Q(E){switch(E){case u.APPLICATION:return"inMemory (application)";case u.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(E){return!1}}e.$qq=y;async function k(g,E,S,s,a,t){const o=T=>{try{return JSON.parse(T)}catch{return T}},n=new Map,c=new Map;g.forEach((T,j)=>{n.set(j,T),c.set(j,o(T))});const h=new Map,P=new Map;E.forEach((T,j)=>{h.set(j,T),P.set(j,o(T))});const w=new Map,D=new Map;S.forEach((T,j)=>{w.set(j,T),D.set(j,o(T))}),console.group(s!==a?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const L=[];if(n.forEach((T,j)=>{L.push({key:j,value:T})}),console.table(L),console.groupEnd(),console.log(c),s!==a){console.group(`Storage: Profile (path: ${a}, profile specific)`);const T=[];h.forEach((j,G)=>{T.push({key:G,value:j})}),console.table(T),console.groupEnd(),console.log(P)}console.group(`Storage: Workspace (path: ${t})`);const R=[];w.forEach((T,j)=>{R.push({key:j,value:T})}),console.table(R),console.groupEnd(),console.log(D)}}),define(le[250],ue([0,1,17,33,64]),function(K,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=A;async function A(O,I,b){let l=b&&b.get("storage.serviceMachineId",v.StorageScope.APPLICATION)||null;if(l)return l;try{const u=(await I.readFile(O.serviceMachineIdResource)).value.toString();l=(0,r.$4g)(u)?u:null}catch{l=null}if(!l){l=(0,r.$5g)();try{await I.writeFile(O.serviceMachineIdResource,i.$Qe.fromString(l))}catch{}}return b?.store("storage.serviceMachineId",l,v.StorageScope.APPLICATION,v.StorageTarget.MACHINE),l}}),define(le[251],ue([0,1,250,24,57]),function(K,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=A;async function A(O,I,b,l,m,u,$){const p={"X-Market-Client-Id":`VSCode ${O}`,"User-Agent":`VSCode ${O} (${I.nameShort})`};if((0,v.$Ip)(I,b)&&(0,v.$Kp)(l)===r.TelemetryLevel.USAGE){const d=await(0,i.$sq)(b,m,u);p["X-Market-User-Id"]=d,p["VSCode-SessionId"]=$.machineId||d}return p}}),define(le[252],ue([0,1,26,21,8,4,2,9,60,7,23,122,164,5,64,24,30,11]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p,d,f,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lhc=e.$khc=e.$jhc=e.$ihc=void 0,i=Ie(i);class g extends O.$Xc{static{this.a=2e3}get storage(){return this.f}constructor(n,c){super(),this.m=n,this.n=c,this.b=this.B(new A.$oe),this.onDidChangeStorage=this.b.event,this.c=this.B(new A.$oe),this.onDidCloseStorage=this.c.event,this.f=this.B(new u.$iq(new u.$jq,{hint:u.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new v.$6h,this.whenInit=this.h.p,this.j=u.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===u.StorageState.None)try{const n=this.B(await this.t());this.f.dispose(),this.f=n,this.B(n.onDidChangeStorage(h=>this.b.fire(h))),await this.s(n);const c=n.getBoolean(d.$kq);c===void 0?n.set(d.$kq,!0):c&&n.set(d.$kq,!1)}catch(n){this.m.error(`[storage main] initialize(): Unable to init storage due to ${n}`)}finally{this.j=u.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===p.LogLevel.Trace?n=>this.m.trace(n):void 0,logError:n=>this.m.error(n)}}s(n){return n.init()}get items(){return this.f.items}get(n,c){return this.f.get(n,c)}set(n,c){return this.f.set(n,c)}delete(n){return this.f.delete(n)}optimize(){return this.f.optimize()}async close(){const n=new b.$ie(!1);await this.w(),n.stop(),n.elapsed()>g.a&&await this.u(n),this.c.fire()}async u(n){if(this.path)try{const c=(0,r.top)(Array.from(this.f.items.entries()).map(([P,w])=>({key:P,length:w.length})),(P,w)=>w.length-P.length,5).map(P=>`${P.key}:${P.length}`).join(", "),h=(await this.n.stat(l.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${n.elapsed()}ms, DB size: ${h}b, Large Keys: ${c}`)}catch(c){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",c)}}async w(){this.g&&await this.g,this.j=u.StorageState.Closed,await this.f.close()}}class E extends g{static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,I.$mc)(this.z.globalStorageHome.with({scheme:k.Schemas.file}).fsPath,E.y)}constructor(n,c,h,P){super(h,P),this.z=n,this.C=c}async t(){return new u.$iq(new $.$LY(this.path??$.$LY.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:u.StorageHint.STORAGE_IN_MEMORY})}}class S extends E{constructor(n,c,h,P){super(n,c,h,P)}}e.$ihc=S;class s extends E{constructor(n,c,h,P){super(c.defaultProfile,n,h,P)}async s(n){await super.s(n),this.G(n)}G(n){n.get(f.$fm,void 0)===void 0&&n.set(f.$fm,new Date().toUTCString());const h=n.get(f.$em,void 0),P=new Date().toUTCString();n.set(f.$gm,typeof h>"u"?null:h),n.set(f.$em,P)}}e.$jhc=s;class a extends g{static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,I.$mc)(this.F.workspaceStorageHome.with({scheme:k.Schemas.file}).fsPath,this.C.id,a.y)}constructor(n,c,h,P,w){super(h,w),this.C=n,this.D=c,this.F=P}async t(){const{storageFilePath:n,wasCreated:c}=await this.H();return new u.$iq(new $.$LY(n,{logging:this.r()}),{hint:this.D.useInMemoryStorage?u.StorageHint.STORAGE_IN_MEMORY:c?u.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:$.$LY.IN_MEMORY_PATH,wasCreated:!0};const n=(0,I.$mc)(this.F.workspaceStorageHome.with({scheme:k.Schemas.file}).fsPath,this.C.id),c=(0,I.$mc)(n,a.y);return await m.Promises.exists(n)?{storageFilePath:c,wasCreated:!1}:(await i.promises.mkdir(n,{recursive:!0}),this.I(n),{storageFilePath:c,wasCreated:!0})}async I(n){let c;if((0,y.$Si)(this.C)?c={folder:this.C.uri.toString()}:(0,y.$Xi)(this.C)&&(c={workspace:this.C.configPath.toString()}),c)try{const h=(0,I.$mc)(n,a.z);await m.Promises.exists(h)||await m.Promises.writeFile(h,JSON.stringify(c,void 0,2))}catch(h){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${h}`)}}}e.$khc=a;class t extends g{get path(){}async t(){return new u.$iq(new u.$jq,{hint:u.StorageHint.STORAGE_IN_MEMORY})}}e.$lhc=t}),define(le[253],ue([0,1,4,2,64]),function(K,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yic=void 0;class A extends r.$Xc{constructor(I,b,l){super(),this.b=I,this.c=b,this.f=l;const m=this.B(new r.$Yc);this.a=this.B(new i.$oe({onWillAddFirstListener:()=>m.value=this.g(),onDidRemoveLastListener:()=>m.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const I=new r.$Wc;return I.add(i.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(b,l)=>(b?b.push(l.key):b=[l.key],b),100)(b=>this.h(b))),I.add(i.Event.debounce(this.b.onDidChangeProfileStorage,(b,l)=>{b||(b=new Map);let m=b.get(l.profile.id);return m||b.set(l.profile.id,m={profile:l.profile,keys:[],storage:l.storage}),m.keys.push(l.key),b},100)(b=>this.j(b))),I}h(I){const b=I.includes(v.$lq)?[this.c.defaultProfile]:[],l=[];if(I=I.filter(m=>m!==v.$lq),I.length){const m=(0,v.$nq)(this.b.applicationStorage.storage);l.push({profile:this.c.defaultProfile,changes:I.map(u=>({key:u,scope:v.StorageScope.PROFILE,target:m[u]}))})}this.m(b,l)}j(I){const b=[],l=new Map;for(const[m,u]of I.entries()){u.keys.includes(v.$lq)&&b.push(u.profile);const $=u.keys.filter(p=>p!==v.$lq);if($.length){const p=(0,v.$nq)(u.storage.storage);l.set(m,{profile:u.profile,changes:$.map(d=>({key:d,scope:v.StorageScope.PROFILE,target:p[d]}))})}}this.m(b,[...l.values()])}m(I,b){(I.length||b.length)&&this.a.fire({valueChanges:b,targetChanges:I})}listen(I,b,l){switch(b){case"onDidChange":return this.a.event}throw new Error(`[ProfileStorageChangesListenerChannel] Event not found: ${b}`)}async call(I,b){throw new Error(`Call not found: ${b}`)}}e.$yic=A}),define(le[254],ue([0,1,7,36,14,5,34,41,42,12,129]),function(K,e,i,r,v,A,O,I,b,l,m){"use strict";var u,$;Object.defineProperty(e,"__esModule",{value:!0}),e.$2R=e.$1R=e.$ZR=void 0;let p=class extends b.$Sl{static{u=this}static{this.a="profileAssociationsMigration"}constructor(k,g,E,S,s){super(E,S,g,s),this.U=k,this.W=E}O(){return this.U.getItem(u.b,[]).map(g=>({...g,location:(0,l.$hg)(g.location)?this.w.extUri.joinPath(this.profilesHome,g.location):i.URI.revive(g.location)}))}Q(){const k=this.U.getItem(u.c,{});return this.U.getItem(u.a,!1)?k:this.N(k)}S(){return this.w.extUri.joinPath(i.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$ZR=p,e.$ZR=p=u=ke([re(0,O.$UR),re(1,I.$Nl),re(2,r.$Qi),re(3,v.$dl),re(4,A.$dk)],p);let d=$=class extends p{constructor(k,g,E,S,s){super(k,g,E,S,s),this.$=k}P(k){k.length?this.$.setItem($.b,k.map(g=>({...g,location:this.w.extUri.basename(g.location)}))):this.$.removeItem($.b)}O(){const k=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(k),this.$.setItem("userDataProfilesMigration",!0)),k}R(k){k.emptyWindows||k.workspaces?this.$.setItem($.c,k):this.$.removeItem($.c)}Q(){const k="workspaceAndProfileInfo",g=this.$.getItem(k,void 0);if(g){this.$.removeItem(k);const S=g.reduce((s,{workspace:a,profile:t})=>(s[i.URI.revive(a).toString()]=i.URI.revive(t).toString(),s),{});this.$.setItem($.c,{workspaces:S})}const E=super.Q();return this.$.getItem($.a,!1)||(this.R(E),this.$.setItem($.a,!0)),E}};e.$1R=d,e.$1R=d=$=ke([re(0,O.$VR),re(1,I.$Nl),re(2,r.$Qi),re(3,v.$dl),re(4,A.$dk)],d);let f=class extends d{constructor(k,g,E,S){super(new m.$YR(m.SaveStrategy.IMMEDIATE,g,S,E),k,g,E,S)}async init(){return await this.$.init(),super.init()}};e.$2R=f,e.$2R=f=ke([re(0,I.$Nl),re(1,r.$Qi),re(2,v.$dl),re(3,A.$dk)],f)}),define(le[58],ue([0,1,36,14,6,5,41,42,254,34]),function(K,e,i,r,v,A,O,I,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4gc=e.$3gc=void 0,e.$3gc=(0,v.$Ji)(I.$Pl);let m=class extends b.$1R{constructor($,p,d,f,y){super($,p,d,f,y)}getAssociatedEmptyWindows(){const $=[];for(const p of this.C.emptyWindows.keys())$.push({id:p});return $}};e.$4gc=m,e.$4gc=m=ke([re(0,l.$VR),re(1,O.$Nl),re(2,i.$Qi),re(3,r.$dl),re(4,A.$dk)],m)}),define(le[136],ue([0,1,18,7,30]),function(K,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5gc=A,e.$6gc=O,e.$7gc=I;async function A(b,l,m){for(const $ of b){const p=$.openedWorkspace;if((0,v.$Xi)(p)){const d=await m(p);if(d){if(d.folders.some(f=>i.$ah.isEqualOrParent(l,f.uri)))return $}else if(i.$ah.isEqualOrParent(l,p.configPath))return $}}const u=b.filter($=>(0,v.$Si)($.openedWorkspace)&&i.$ah.isEqualOrParent(l,$.openedWorkspace.uri));if(u.length)return u.sort(($,p)=>-($.openedWorkspace.uri.path.length-p.openedWorkspace.uri.path.length))[0]}function O(b,l){for(const m of b)if((0,v.$Xi)(m.openedWorkspace)&&i.$ah.isEqual(m.openedWorkspace.configPath,l)||(0,v.$Si)(m.openedWorkspace)&&i.$ah.isEqual(m.openedWorkspace.uri,l))return m}function I(b,l){const m=u=>l.some($=>i.$ah.isEqual(r.URI.file($),r.URI.file(u)));for(const u of b)if(u.config?.extensionDevelopmentPath?.some($=>m($)))return u}}),define(le[105],ue([0,1,32,43,110,48,11,9,3,18,7,6,75,30]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iib=void 0,e.$Jib=d,e.$Kib=f,e.$Lib=y,e.$Mib=k,e.$Nib=S,e.$Oib=a,e.$Pib=t,e.$Qib=P,e.$Rib=w,r=Ie(r),v=Ie(v),e.$Iib=(0,u.$Ii)("workspacesService");function d(D){return D.hasOwnProperty("workspace")}function f(D){return D.hasOwnProperty("folderUri")}function y(D){return D.hasOwnProperty("fileUri")}function k(D){return g(D)||E(D)}function g(D){const L=D;return typeof L?.path=="string"&&(!L.name||typeof L.name=="string")}function E(D){const L=D;return typeof L?.uri=="string"&&(!L.name||typeof L.name=="string")}function S(D,L,R,T,j){if(D.scheme!==T.scheme)return{name:R,uri:D.toString(!0)};let G=L?void 0:j.relativePath(T,D);if(G!==void 0)G.length===0?G=".":b.$j&&(G=s(G));else if(D.scheme===O.Schemas.file)G=D.fsPath,b.$j&&(G=s(G));else if(j.isEqualAuthority(D.authority,T.authority))G=D.path;else return{name:R,uri:D.toString(!0)};return{name:R,path:G}}function s(D){return D=(0,A.$8w)(D),(0,i.$Eg)(D)||(D=(0,i.$Bg)(D)),D}function a(D,L,R){const T=[],j=new Set,G=R.dirname(L);for(const q of D){let Q;if(g(q))q.path&&(Q=R.resolvePath(G,q.path));else if(E(q))try{Q=m.URI.parse(q.uri),Q.path[0]!==I.$jc.sep&&(Q=Q.with({path:I.$jc.sep+Q.path}))}catch(de){console.warn(de)}if(Q){const de=R.getComparisonKey(Q);if(!j.has(de)){j.add(de);const V=q.name||R.basenameOrAuthority(Q);T.push(new p.$3i({uri:Q,name:V,index:T.length},q))}}}return T}function t(D,L,R,T,j){const G=o(L,D),q=j.dirname(L),Q=j.dirname(T),de=[];for(const _ of G.folders){const C=g(_)?j.resolvePath(q,_.path):m.URI.parse(_.uri);let W;R?W=!1:W=!g(_)||(0,I.$lc)(_.path),de.push(S(C,W,_.name,Q,j))}const V={insertSpaces:!1,tabSize:4,eol:b.$l||b.$k?`
`:`\r
`},Y=v.$eo(D,["folders"],de,V);let B=v.$ho(D,Y);return(0,l.$oh)(G.remoteAuthority,(0,$.$ln)(T))&&(B=v.$ho(B,v.$do(B,["remoteAuthority"],V))),B}function o(D,L){const R=r.$3n(L);if(R&&Array.isArray(R.folders))R.folders=R.folders.filter(T=>k(T));else throw new Error(`${D} looks like an invalid workspace file.`);return R}function n(D){return D.workspace&&typeof D.workspace=="object"&&typeof D.workspace.id=="string"&&typeof D.workspace.configPath=="string"}function c(D){return typeof D.folderUri=="string"}function h(D){return typeof D.fileUri=="string"}function P(D,L){const R={workspaces:[],files:[]};if(D){const T=function(G,q){for(let Q=0;Q<G.length;Q++)try{q(G[Q],Q)}catch(de){L.warn(`Error restoring recent entry ${JSON.stringify(G[Q])}: ${de.toString()}. Skip entry.`)}},j=D;Array.isArray(j.entries)&&T(j.entries,G=>{const q=G.label,Q=G.remoteAuthority;n(G)?R.workspaces.push({label:q,remoteAuthority:Q,workspace:{id:G.workspace.id,configPath:m.URI.parse(G.workspace.configPath)}}):c(G)?R.workspaces.push({label:q,remoteAuthority:Q,folderUri:m.URI.parse(G.folderUri)}):h(G)&&R.files.push({label:q,remoteAuthority:Q,fileUri:m.URI.parse(G.fileUri)})})}return R}function w(D){const L={entries:[]};for(const R of D.workspaces)f(R)?L.entries.push({folderUri:R.folderUri.toString(),label:R.label,remoteAuthority:R.remoteAuthority}):L.entries.push({workspace:{id:R.workspace.id,configPath:R.workspace.configPath.toString()},label:R.label,remoteAuthority:R.remoteAuthority});for(const R of D.files)L.entries.push({fileUri:R.fileUri.toString(),label:R.label,remoteAuthority:R.remoteAuthority});return L}}),define(le[106],ue([0,1,93,11,3,18]),function(K,e,i,r,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8gc=void 0,e.$9gc=O,e.$0gc=I,e.$$gc=b,e.$8gc=128/4;function O(l){function m(){let u=l.scheme===r.Schemas.file?(0,A.$0g)(l):l.toString();return v.$l||(u=u.toLowerCase()),(0,i.createHash)("md5").update(u).digest("hex")}return{id:m(),configPath:l}}function I(l,m){function u(){if(l.scheme!==r.Schemas.file)return(0,i.createHash)("md5").update(l.toString()).digest("hex");if(!m)return;let p;return v.$l?p=m.ino:v.$k?p=m.birthtime.getTime():v.$j&&(typeof m.birthtimeMs=="number"?p=Math.floor(m.birthtimeMs):p=m.birthtime.getTime()),(0,i.createHash)("md5").update(l.fsPath).update(p?String(p):"").digest("hex")}const $=u();if(typeof $=="string")return{id:$,uri:l}}function b(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(le[107],ue([0,1,93,95,27,255,17,15,4,2,9,3,33,45,120]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$zi=e.$yi=e.$xi=void 0,e.$Ai=n,e.$Bi=c,e.$Di=w,e.$Ei=D;const f=3e4;class y{traceSocketEvent(R,T){d.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,R,T)}constructor(R,T=""){this.f=!0,this.debugLabel=T,this.socket=R,this.traceSocketEvent(d.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=G=>{if(this.traceSocketEvent(d.SocketDiagnosticsEventType.Error,{code:G?.code,message:G?.message}),G){if(G.code==="EPIPE")return;(0,I.$2)(G)}},this.socket.on("error",this.a);let j;this.b=G=>{this.traceSocketEvent(d.SocketDiagnosticsEventType.Close,{hadError:G}),this.f=!1,j&&clearTimeout(j)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(d.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,j=setTimeout(()=>R.destroy(),f)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(R){const T=j=>{this.traceSocketEvent(d.SocketDiagnosticsEventType.Read,j),R(O.$Qe.wrap(j))};return this.socket.on("data",T),{dispose:()=>this.socket.off("data",T)}}onClose(R){const T=j=>{R({type:d.SocketCloseEventType.NodeSocketCloseEvent,hadError:j,error:void 0})};return this.socket.on("close",T),{dispose:()=>this.socket.off("close",T)}}onEnd(R){const T=()=>{R()};return this.socket.on("end",T),{dispose:()=>this.socket.off("end",T)}}write(R){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(d.SocketDiagnosticsEventType.Write,R),this.socket.write(R.buffer,T=>{if(T){if(T.code==="EPIPE")return;(0,I.$2)(T)}})}catch(T){if(T.code==="EPIPE")return;(0,I.$2)(T)}}end(){this.traceSocketEvent(d.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(d.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((R,T)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(d.SocketDiagnosticsEventType.NodeDrainEnd),R();return}const j=()=>{this.socket.off("close",j),this.socket.off("end",j),this.socket.off("error",j),this.socket.off("timeout",j),this.socket.off("drain",j),this.traceSocketEvent(d.SocketDiagnosticsEventType.NodeDrainEnd),R()};this.socket.on("close",j),this.socket.on("end",j),this.socket.on("error",j),this.socket.on("timeout",j),this.socket.on("drain",j)})}}e.$xi=y;var k;(function(L){L[L.MinHeaderByteSize=2]="MinHeaderByteSize",L[L.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(k||(k={}));var g;(function(L){L[L.PeekHeader=1]="PeekHeader",L[L.ReadHeader=2]="ReadHeader",L[L.ReadBody=3]="ReadBody",L[L.Fin=4]="Fin"})(g||(g={}));class E extends l.$Xc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(R,T){this.socket.traceSocketEvent(R,T)}constructor(R,T,j,G){super(),this.f=this.B(new b.$oe),this.g=this.B(new b.$oe),this.h=!1,this.j={state:g.PeekHeader,readLen:k.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=R,this.traceSocketEvent(d.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:T,inflateBytesLength:j?.byteLength||0,recordInflateBytes:G}),this.a=this.B(new S(this,T,j,G,this.f,(q,Q)=>this.m(q,Q))),this.B(this.a.onError(q=>{console.error(q),(0,I.$2)(q),this.g.fire({type:d.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:q})})),this.b=new d.$si,this.B(this.socket.onData(q=>this.n(q))),this.B(this.socket.onClose(async q=>{this.a.isProcessingReadQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(q)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(R){return this.f.event(R)}onClose(R){return this.g.event(R)}onEnd(R){return this.socket.onEnd(R)}write(R){let T=0;for(;T<R.byteLength;)this.a.writeMessage(R.slice(T,Math.min(T+k.MaxWebSocketMessageLength,R.byteLength)),{compressed:!0,opcode:2}),T+=k.MaxWebSocketMessageLength}m(R,{compressed:T,opcode:j}){if(this.h)return;this.traceSocketEvent(d.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,R);let G=k.MinHeaderByteSize;R.byteLength<126?G+=0:R.byteLength<2**16?G+=2:G+=8;const q=O.$Qe.alloc(G),Q=T?64:0,de=j&15;if(q.writeUInt8(128|Q|de,0),R.byteLength<126)q.writeUInt8(R.byteLength,1);else if(R.byteLength<2**16){q.writeUInt8(126,1);let V=1;q.writeUInt8(R.byteLength>>>8&255,++V),q.writeUInt8(R.byteLength>>>0&255,++V)}else{q.writeUInt8(127,1);let V=1;q.writeUInt8(0,++V),q.writeUInt8(0,++V),q.writeUInt8(0,++V),q.writeUInt8(0,++V),q.writeUInt8(R.byteLength>>>24&255,++V),q.writeUInt8(R.byteLength>>>16&255,++V),q.writeUInt8(R.byteLength>>>8&255,++V),q.writeUInt8(R.byteLength>>>0&255,++V)}this.socket.write(O.$Qe.concat([q,R]))}end(){this.h=!0,this.socket.end()}n(R){if(R.byteLength!==0){for(this.b.acceptChunk(R);this.b.byteLength>=this.j.readLen;)if(this.j.state===g.PeekHeader){const T=this.b.peek(this.j.readLen),j=T.readUInt8(0),G=(j&128)>>>7,q=(j&64)>>>6,Q=j&15,de=T.readUInt8(1),V=(de&128)>>>7,Y=de&127;this.j.state=g.ReadHeader,this.j.readLen=k.MinHeaderByteSize+(V?4:0)+(Y===126?2:0)+(Y===127?8:0),this.j.fin=G,this.j.firstFrameOfMessage&&(this.j.compressed=!!q),this.j.firstFrameOfMessage=!!G,this.j.mask=0,this.j.opcode=Q,this.traceSocketEvent(d.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===g.ReadHeader){const T=this.b.read(this.j.readLen),j=T.readUInt8(1),G=(j&128)>>>7;let q=j&127,Q=1;q===126?q=T.readUInt8(++Q)*2**8+T.readUInt8(++Q):q===127&&(q=T.readUInt8(++Q)*0+T.readUInt8(++Q)*0+T.readUInt8(++Q)*0+T.readUInt8(++Q)*0+T.readUInt8(++Q)*2**24+T.readUInt8(++Q)*2**16+T.readUInt8(++Q)*2**8+T.readUInt8(++Q));let de=0;G&&(de=T.readUInt8(++Q)*2**24+T.readUInt8(++Q)*2**16+T.readUInt8(++Q)*2**8+T.readUInt8(++Q)),this.j.state=g.ReadBody,this.j.readLen=q,this.j.mask=de,this.traceSocketEvent(d.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===g.ReadBody){const T=this.b.read(this.j.readLen);this.traceSocketEvent(d.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,T),t(T,this.j.mask),this.traceSocketEvent(d.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,T),this.j.state=g.PeekHeader,this.j.readLen=k.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(T,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(T,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(d.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(d.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$yi=E;class S extends l.$Xc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:O.$Qe.alloc(0)}constructor(R,T,j,G,q,Q){super(),this.n=R,this.r=q,this.s=Q,this.a=this.B(new b.$oe),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new b.$oe),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new b.$oe),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,T?(this.b=this.B(new s(this.n,G,j,{windowBits:15})),this.f=this.B(new a(this.n,{windowBits:15})),this.B(this.b.onError(de=>this.a.fire(de))),this.B(this.f.onError(de=>this.a.fire(de)))):(this.b=null,this.f=null)}writeMessage(R,T){this.g.push({data:R,options:T}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:R,options:T}=this.g.shift();if(this.f&&T.compressed){const j=await this.w(this.f,R);this.s(j,T)}else this.s(R,{...T,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(R,T){return new Promise((j,G)=>{R.write(T),R.flush(q=>j(q))})}acceptFrame(R,T,j){this.h.push({data:R,isCompressed:T,isLastFrameOfMessage:j}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const R=this.h.shift();if(this.b&&R.isCompressed){const T=await this.C(this.b,R.data,R.isLastFrameOfMessage);this.r.fire(T)}else this.r.fire(R.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(R,T,j){return new Promise((G,q)=>{R.write(T),j&&R.write(O.$Qe.fromByteArray([0,0,255,255])),R.flush(Q=>G(Q))})}}class s extends l.$Xc{get recordedInflateBytes(){return this.j?O.$Qe.concat(this.f):O.$Qe.alloc(0)}constructor(R,T,j,G){super(),this.h=R,this.j=T,this.a=this.B(new b.$oe),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(G),this.b.on("error",q=>{this.h.traceSocketEvent(d.SocketDiagnosticsEventType.zlibInflateError,{message:q?.message,code:q?.code}),this.a.fire(q)}),this.b.on("data",q=>{this.h.traceSocketEvent(d.SocketDiagnosticsEventType.zlibInflateData,q),this.g.push(O.$Qe.wrap(q))}),j&&(this.h.traceSocketEvent(d.SocketDiagnosticsEventType.zlibInflateInitialWrite,j.buffer),this.b.write(j.buffer),this.b.flush(()=>{this.h.traceSocketEvent(d.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(R){this.j&&this.f.push(R.clone()),this.h.traceSocketEvent(d.SocketDiagnosticsEventType.zlibInflateWrite,R),this.b.write(R.buffer)}flush(R){this.b.flush(()=>{this.h.traceSocketEvent(d.SocketDiagnosticsEventType.zlibInflateFlushFired);const T=O.$Qe.concat(this.g);this.g.length=0,R(T)})}}class a extends l.$Xc{constructor(R,T){super(),this.g=R,this.a=this.B(new b.$oe),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",j=>{this.g.traceSocketEvent(d.SocketDiagnosticsEventType.zlibDeflateError,{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.g.traceSocketEvent(d.SocketDiagnosticsEventType.zlibDeflateData,j),this.f.push(O.$Qe.wrap(j))})}write(R){this.g.traceSocketEvent(d.SocketDiagnosticsEventType.zlibDeflateWrite,R.buffer),this.b.write(R.buffer)}flush(R){this.b.flush(2,()=>{this.g.traceSocketEvent(d.SocketDiagnosticsEventType.zlibDeflateFlushFired);let T=O.$Qe.concat(this.f);this.f.length=0,T=T.slice(0,T.byteLength-4),R(T)})}}function t(L,R){if(R===0)return;const T=L.byteLength>>>2;for(let V=0;V<T;V++){const Y=L.readUInt32BE(V*4);L.writeUInt32BE(Y^R,V*4)}const j=T*4,G=L.byteLength-j,q=R>>>24&255,Q=R>>>16&255,de=R>>>8&255;G>=1&&L.writeUInt8(L.readUInt8(j)^q,j),G>=2&&L.writeUInt8(L.readUInt8(j+1)^Q,j+1),G>=3&&L.writeUInt8(L.readUInt8(j+2)^de,j+2)}e.$zi=process.env.XDG_RUNTIME_DIR;const o={[u.Platform.Linux]:107,[u.Platform.Mac]:103};function n(){const L=(0,$.$5g)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${L}-sock`;const R=process.platform!=="darwin"&&e.$zi?e.$zi:(0,v.tmpdir)(),T=(0,m.$mc)(R,`vscode-ipc-${L}.sock`);return h(T),T}function c(L,R,T){const G=(0,i.createHash)("sha256").update(L).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${G}-${T}-${R}-sock`;const q=T.substr(0,4),Q=R.substr(0,6);let de;return process.platform!=="darwin"&&e.$zi&&!process.env.VSCODE_PORTABLE?de=(0,m.$mc)(e.$zi,`vscode-${G}-${q}-${Q}.sock`):de=(0,m.$mc)(L,`${q}-${Q}.sock`),h(de),de}function h(L){const R=o[u.$v];typeof R=="number"&&L.length>=R&&console.warn(`WARNING: IPC handle "${L}" is longer than ${R} chars, try a shorter --user-data-dir`)}class P extends p.$mi{static b(R){const T=b.Event.fromNodeEventEmitter(R,"connection");return b.Event.map(T,j=>({protocol:new d.$ti(new y(j,"ipc-server-connection")),onDidClientDisconnect:b.Event.once(b.Event.fromNodeEventEmitter(j,"close"))}))}constructor(R){super(P.b(R)),this.d=R}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Ci=P;function w(L){return new Promise((R,T)=>{const j=(0,r.createServer)();j.on("error",T),j.listen(L,()=>{j.removeListener("error",T),R(new P(j))})})}function D(L,R){return new Promise((T,j)=>{const G=(0,r.createConnection)(L,()=>{G.removeListener("error",j),T(d.$ui.fromSocket(new y(G,`ipc-client${R}`),R))});G.once("error",j)})}}),define(le[20],ue([0,1,54,9,3,107,36,98,6]),function(K,e,i,r,v,A,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ngc=e.$Mgc=void 0,e.$Mgc=(0,b.$Ji)(O.$Pi);class l extends I.$an{constructor(){super(...arguments),this.d={}}get backupHome(){return(0,r.$mc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,A.$Bi)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,r.$mc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(v.$l){for(const u in process.env)if(u.endsWith("_VSCODE_SNAP_ORIG")){const $=u.slice(0,-17);if(this.d[$])continue;process.env[$]&&(this.d[$]=process.env[$]),process.env[u]?process.env[$]=process.env[u]:delete process.env[$]}}}restoreSnapExportedVariables(){if(v.$l)for(const u in this.d)process.env[u]=this.d[u],delete this.d[u]}}e.$Ngc=l,ke([i.$ai],l.prototype,"backupHome",null),ke([i.$ai],l.prototype,"mainIPCHandle",null),ke([i.$ai],l.prototype,"mainLockfile",null),ke([i.$ai],l.prototype,"disableUpdates",null),ke([i.$ai],l.prototype,"crossOriginIsolated",null),ke([i.$ai],l.prototype,"codeCachePath",null),ke([i.$ai],l.prototype,"useCodeCache",null)}),define(le[256],ue([0,1,93,32,11,9,3,18,23,168,16,20,34,14,5,167,30,106]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p,d,f,y,k){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$shc=void 0;let E=class{static{g=this}static{this.a="backupWorkspaces"}constructor(s,a,t,o){this.j=s,this.k=a,this.l=t,this.m=o,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=I.$ah,this.i={isEqual:(n,c)=>(0,r.$Gg)(n,c,!O.$l)}}async initialize(){const s=this.m.getItem(g.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(s.emptyWindows),this.d=await this.u((0,l.$Rgc)(s)),this.e=await this.v((0,l.$Sgc)(s)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==p.$Cl.OFF}q(){return this.s()===p.$Cl.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||p.$Cl.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(s,a){this.d.some(o=>s.workspace.id===o.workspace.id)||(this.d.push(s),this.C());const t=(0,A.$mc)(this.c,s.workspace.id);return a?this.t(t,a).then(()=>t):t}async t(s,a){if(await b.Promises.exists(s)&&await this.z(s),await b.Promises.exists(a))try{await b.Promises.rename(a,s,!1)}catch(t){this.l.error(`Backup: Could not move backup folder to new location: ${t.toString()}`)}}registerFolderBackup(s){return this.e.some(a=>this.h.isEqual(s.folderUri,a.folderUri))||(this.e.push(s),this.C()),(0,A.$mc)(this.c,this.D(s))}registerEmptyWindowBackup(s){return this.g.some(a=>!!a.backupFolder&&this.i.isEqual(a.backupFolder,s.backupFolder))||(this.g.push(s),this.C()),(0,A.$mc)(this.c,s.backupFolder)}async u(s){if(!Array.isArray(s))return[];const a=new Set,t=[];for(const o of s){const n=o.workspace;if(!(0,y.$Xi)(n))return[];if(!a.has(n.id)){a.add(n.id);const c=(0,A.$mc)(this.c,n.id);await this.B(c)?n.configPath.scheme!==v.Schemas.file||await b.Promises.exists(n.configPath.fsPath)?t.push(o):await this.z(c):await this.x(c)}}return t}async v(s){if(!Array.isArray(s))return[];const a=[],t=new Set;for(const o of s){const n=o.folderUri,c=this.h.getComparisonKey(n);if(!t.has(c)){t.add(c);const h=(0,A.$mc)(this.c,this.D(o));await this.B(h)?n.scheme!==v.Schemas.file||await b.Promises.exists(n.fsPath)?a.push(o):await this.z(h):await this.x(h)}}return a}async w(s){if(!Array.isArray(s))return[];const a=[],t=new Set;for(const o of s){const n=o.backupFolder;if(typeof n!="string")return[];if(!t.has(n)){t.add(n);const c=(0,A.$mc)(this.c,n);await this.B(c)?a.push(o):await this.x(c)}}return a}async x(s){try{await b.Promises.rm(s,b.RimRafMode.MOVE)}catch(a){this.l.error(`Backup: Could not delete stale backup: ${a.toString()}`)}}y(){let s=(0,k.$$gc)();for(;this.g.some(a=>!!a.backupFolder&&this.i.isEqual(a.backupFolder,s.id));)s=(0,k.$$gc)();return{backupFolder:s.id}}async z(s){const a=this.y(),t=(0,A.$mc)(this.c,a.backupFolder);try{await b.Promises.rename(s,t,!1)}catch(o){return this.l.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.g.push(a),!0}async getDirtyWorkspaces(){const s=[];for(const a of this.d)await this.A(a)&&s.push(a);for(const a of this.e)await this.A(a)&&s.push(a);return s}A(s){let a;return(0,l.$Qgc)(s)?a=(0,A.$mc)(this.c,s.backupFolder):(0,f.$Gib)(s)?a=(0,A.$mc)(this.c,this.D(s)):a=(0,A.$mc)(this.c,s.workspace.id),this.B(a)}async B(s){try{const a=await b.Promises.readdir(s);for(const t of a)try{if((await b.Promises.readdir((0,A.$mc)(s,t))).length>0)return!0}catch{}}catch{}return!1}C(){const s={workspaces:this.d.map(({workspace:a,remoteAuthority:t})=>{const o={id:a.id,configURIPath:a.configPath.toString()};return t&&(o.remoteAuthority=t),o}),folders:this.e.map(({folderUri:a,remoteAuthority:t})=>{const o={folderUri:a.toString()};return t&&(o.remoteAuthority=t),o}),emptyWindows:this.g.map(({backupFolder:a,remoteAuthority:t})=>{const o={backupFolder:a};return t&&(o.remoteAuthority=t),o})};this.m.setItem(g.a,s)}D(s){const a=s.folderUri;let t;return a.scheme===v.Schemas.file?t=O.$l?a.fsPath:a.fsPath.toLowerCase():t=a.toString().toLowerCase(),(0,i.createHash)("md5").update(t).digest("hex")}};e.$shc=E,e.$shc=E=g=ke([re(0,u.$Mgc),re(1,m.$cj),re(2,d.$dk),re(3,$.$VR)],E)});var xe=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[19],ue([0,1,13,35,8,4,2,3,37,12,6,5,34,52,20]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p,d){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$hhc=e.LifecycleMainPhase=e.ShutdownReason=e.$ghc=void 0,i=xe(i),e.$ghc=(0,m.$Ii)("lifecycleMainService");var y;(function(E){E[E.QUIT=1]="QUIT",E[E.KILL=2]="KILL"})(y||(e.ShutdownReason=y={}));var k;(function(E){E[E.Starting=1]="Starting",E[E.Ready=2]="Ready",E[E.AfterWindowOpen=3]="AfterWindowOpen",E[E.Eventually=4]="Eventually"})(k||(e.LifecycleMainPhase=k={}));let g=class extends O.$Xc{static{f=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(S,s,a){super(),this.F=S,this.G=s,this.H=a,this.c=this.B(new A.$oe),this.onBeforeShutdown=this.c.event,this.f=this.B(new A.$oe),this.onWillShutdown=this.f.event,this.g=this.B(new A.$oe),this.onWillLoadWindow=this.g.event,this.h=this.B(new A.$oe),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=k.Starting,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(k.Ready).then(()=>this.J())}I(){this.m=!!this.G.getItem(f.b),this.m&&this.G.removeItem(f.b)}J(){const S=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),I.$k&&this.t===0&&this.L(y.QUIT))};i.default.app.addListener("before-quit",S);const s=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!I.$k)&&i.default.app.quit()};i.default.app.addListener("window-all-closed",s),i.default.app.once("will-quit",a=>{this.S("Lifecycle#app.on(will-quit) - begin"),a.preventDefault(),this.L(y.QUIT).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),i.default.app.removeListener("before-quit",S),i.default.app.removeListener("window-all-closed",s),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),i.default.app.quit()})})}L(S){if(this.y)return this.y;const s=this.F;this.S("Lifecycle#onWillShutdown.fire()");const a=[];return this.f.fire({reason:S,join(t,o){s.trace(`Lifecycle#onWillShutdown - begin '${t}'`),a.push(o.finally(()=>{s.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.y=(async()=>{try{await v.Promises.settled(a)}catch(t){this.F.error(t)}try{await this.G.close()}catch(t){this.F.error(t)}})(),this.y}set phase(S){if(S<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===S)return;this.S(`lifecycle (main): phase changed (value: ${S})`),this.n=S;const s=this.C.get(this.n);s&&(s.open(),this.C.delete(this.n))}async when(S){if(S<=this.n)return;let s=this.C.get(S);s||(s=new v.$Hh,this.C.set(S,s)),await s.wait()}registerWindow(S){const s=new O.$Wc;this.t++,s.add(S.onWillLoad(t=>this.g.fire({window:S,workspace:t.workspace,reason:t.reason})));const a=(0,l.$sg)(S.win);s.add(A.Event.fromNodeEventEmitter(a,"close")(t=>{const o=S.id;if(this.r.has(o)){this.r.delete(o);return}this.S(`Lifecycle#window.on('close') - window ID ${S.id}`),t.preventDefault(),this.unload(S,p.UnloadReason.CLOSE).then(n=>{if(n){this.r.delete(o);return}this.r.add(o),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this.h.fire(S),S.close()})})),s.add(A.Event.fromNodeEventEmitter(a,"closed")(()=>{this.S(`Lifecycle#window.on('closed') - window ID ${S.id}`),this.t--,s.dispose(),this.t===0&&(!I.$k||this.j)&&this.L(y.QUIT)}))}registerAuxWindow(S){const s=(0,l.$sg)(S.win),a=new O.$Wc;a.add(A.Event.fromNodeEventEmitter(s,"close")(t=>{this.S(`Lifecycle#auxWindow.on('close') - window ID ${S.id}`),this.j&&(this.S("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),t.preventDefault())})),a.add(A.Event.fromNodeEventEmitter(s,"closed")(()=>{this.S(`Lifecycle#auxWindow.on('closed') - window ID ${S.id}`),a.dispose()}))}async reload(S,s){await this.unload(S,p.UnloadReason.RELOAD)||S.reload(s)}unload(S,s){const a=this.z.get(S.id);if(a)return a;const t=this.M(S,s).finally(()=>{this.z.delete(S.id)});return this.z.set(S.id,t),t}async M(S,s){if(!S.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${S.id}`);const a=this.j?p.UnloadReason.QUIT:s,t=await this.P(S,a);return t?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${S.id})`),this.N(t)):(await this.Q(S,a),!1)}N(S){return S?(this.O(!0),this.j=!1,!0):!1}O(S){this.w&&(this.w(S),this.w=void 0,this.u=void 0)}P(S,s){return new Promise(a=>{const t=this.s++,o=`vscode:ok${t}`,n=`vscode:cancel${t}`;r.$gY.once(o,()=>{a(!1)}),r.$gY.once(n,()=>{a(!0)}),S.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:n,reason:s})})}Q(S,s){return new Promise(a=>{const o=`vscode:reply${this.s++}`;r.$gY.once(o,()=>a()),S.send("vscode:onWillUnload",{replyChannel:o,reason:s})})}quit(S){return this.R(S).then(s=>{if(!s&&S)try{if(I.$j){const a=(0,b.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.F.error(a)}return s})}R(S){return this.S(`Lifecycle#quit() - begin (willRestart: ${S})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(S&&this.G.setItem(f.b,!0),this.u=new Promise(s=>{this.w=s,this.S("Lifecycle#quit() - calling app.quit()"),i.default.app.quit()}),this.u)}S(S){this.H.args["enable-smoke-test-driver"]?this.F.info(S):this.F.trace(S)}setRelaunchHandler(S){this.D=S}async relaunch(S){this.S("Lifecycle#relaunch()");const s=process.argv.slice(1);if(S?.addArgs&&s.push(...S.addArgs),S?.removeArgs)for(const o of S.removeArgs){const n=s.indexOf(o);n>=0&&s.splice(n,1)}const a=()=>{this.D?.handleRelaunch(S)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),i.default.app.relaunch({args:s}))};i.default.app.once("quit",a),await this.quit(!0)&&i.default.app.removeListener("quit",a)}async kill(S){this.S("Lifecycle#kill()"),await this.L(y.KILL),await Promise.race([(0,v.$Jh)(1e3),(async()=>{for(const s of i.default.BrowserWindow.getAllWindows())if(s&&!s.isDestroyed()){let a;s.webContents&&!s.webContents.isDestroyed()?a=new Promise(t=>s.once("closed",t)):a=Promise.resolve(),s.destroy(),await a}})()]),i.default.app.exit(S)}};e.$hhc=g,e.$hhc=g=f=ke([re(0,u.$dk),re(1,$.$VR),re(2,d.$Mgc)],g)}),define(le[257],ue([0,1,3,4,2,6,19]),function(K,e,i,r,v,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rhc=e.$Qhc=void 0,i=Ie(i),e.$Qhc=(0,A.$Ii)("keyboardLayoutMainService");let I=class extends v.$Xc{constructor(m){super(),this.a=this.B(new r.$oe),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,m.when(O.LifecycleMainPhase.AfterWindowOpen).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const m=await new Promise((u,$)=>{K(["native-keymap"],u,$)}).then(Ie);this.c=b(m),i.$u||m.onDidChangeKeyboardLayout(()=>{this.c=b(m),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$Rhc=I,e.$Rhc=I=ke([re(0,O.$ghc)],I);function b(l){const m=l.getKeyMap(),u=l.getCurrentKeyboardLayout();return{keyboardMapping:m,keyboardLayoutInfo:u}}}),define(le[258],ue([0,1,218,8,17,15,12,16,36,103,5,49,217,255]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=void 0,e.$ms=y;let d=class extends u.$aq{constructor(g,E,S,s){super(s),this.m=g,this.n=E,this.r=S,this.s(),this.B(g.onDidChangeConfiguration(a=>{a.affectsConfiguration("http")&&this.s()}))}s(){const g=this.m.getValue("http");this.f=g?.proxy,this.g=!!g?.proxyStrictSSL,this.h=g?.proxyAuthorization}async request(g,E){const{f:S,g:s}=this;let a;try{a=await(0,l.$Um)(this.m,this.r,this.n.args,process.env)}catch(n){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,A.$_)(n)))}const t={...process.env,...a},o=g.agent?g.agent:await(0,$.$ks)(g.url||"",t,{proxyUrl:S,strictSSL:s});return g.agent=o,g.strictSSL=s,this.h&&(g.headers={...g.headers||{},"Proxy-Authorization":this.h}),this.c(g.isChromiumNetwork?"electron":"node",g,()=>y(g,E))}async resolveProxy(g){}async lookupAuthorization(g){}async lookupKerberosAuthorization(g){try{const E=await new Promise((o,n)=>{K(["kerberos"],o,n)}).then(Ie),S=new URL(g),s=this.m.getValue("http.proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${S.hostname}`:`HTTP@${S.hostname}`);return this.r.debug("RequestService#lookupKerberosAuthorization Kerberos authentication lookup",`proxyURL:${S}`,`spn:${s}`),"Negotiate "+await(await E.initializeClient(s)).step("")}catch(E){this.r.debug("RequestService#lookupKerberosAuthorization Kerberos authentication failed",E);return}}async loadCertificates(){return(await new Promise((E,S)=>{K(["@vscode/proxy-agent"],E,S)}).then(Ie)).loadSystemCertificates({log:this.r})}};e.$ls=d,e.$ls=d=ke([re(0,I.$cj),re(1,b.$Qi),re(2,m.$dk),re(3,m.$ek)],d);async function f(k){return((0,i.parse)(k.url).protocol==="https:"?await new Promise((S,s)=>{K(["https"],S,s)}).then(Ie):await new Promise((S,s)=>{K(["http"],S,s)}).then(Ie)).request}async function y(k,g){return r.Promises.withAsyncBody(async(E,S)=>{const s=(0,i.parse)(k.url),a=k.getRawRequest?k.getRawRequest(k):await f(k),t={hostname:s.hostname,port:s.port?parseInt(s.port):s.protocol==="https:"?443:80,protocol:s.protocol,path:s.path,method:k.type||"GET",headers:k.headers,agent:k.agent,rejectUnauthorized:(0,O.$ng)(k.strictSSL)?k.strictSSL:!0};k.user&&k.password&&(t.auth=k.user+":"+k.password);const o=a(t,n=>{const c=(0,O.$lg)(k.followRedirects)?k.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&c>0&&n.headers.location)y({...k,url:n.headers.location,followRedirects:c-1},g).then(E,S);else{let h=n;!k.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(h=n.pipe((0,p.createGunzip)())),E({res:n,stream:(0,v.$6e)(h)})}});o.on("error",S),k.timeout&&o.setTimeout(k.timeout),k.isChromiumNetwork&&o.removeHeader("Content-Length"),k.data&&typeof k.data=="string"&&o.write(k.data),o.end(),g.onCancellationRequested(()=>{o.abort(),S(new A.$7)})})}}),define(le[259],ue([0,1,13,258]),function(K,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vic=void 0;function v(O){return i.net.request}class A extends r.$ls{request(I,b){return super.request({...I||{},getRawRequest:v,isChromiumNetwork:!0},b)}}e.$Vic=A}),define(le[89],ue([0,1,7,4,2,36,14,6,19,5,64,252,42,58,41,11]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$phc=e.$ohc=e.$nhc=e.$mhc=void 0,e.$mhc=(0,I.$Ii)("storageMainService");let y=class extends v.$Xc{constructor(E,S,s,a,t,o){super(),this.c=E,this.f=S,this.g=s,this.h=a,this.j=t,this.m=o,this.a=void 0,this.b=this.B(new r.$oe),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(b.LifecycleMainPhase.AfterWindowOpen),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(E=>{E.window.profile&&this.profileStorage(E.window.profile).init(),E.workspace&&this.workspaceStorage(E.workspace).init()})),this.B(this.h.onWillShutdown(E=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=E.reason,E.join("applicationStorage",this.applicationStorage.close());for(const[,S]of this.t)E.join("profileStorage",S.close());for(const[,S]of this.w)E.join("workspaceStorage",S.close())})),this.B(this.g.onWillCreateProfile(E=>{E.join((async()=>{await this.j.exists(E.profile.globalStorageHome)||await this.j.createFolder(E.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(E=>{const S=this.t.get(E.profile.id);S&&E.join(S.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const E=new u.$jhc(this.n(),this.g,this.c,this.j);return this.B(r.Event.once(E.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),E}profileStorage(E){if((0,m.$pq)(E))return this.applicationStorage;let S=this.t.get(E.id);if(!S){this.c.trace(`StorageMainService: creating profile storage (${E.name})`),S=this.B(this.u(E)),this.t.set(E.id,S);const s=this.B(S.onDidChangeStorage(a=>this.b.fire({...a,storage:S,profile:E})));this.B(r.Event.once(S.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${E.name})`),this.t.delete(E.id),s.dispose()}))}return S}u(E){return this.a===b.ShutdownReason.KILL?new u.$lhc(this.c,this.j):new u.$ihc(E,this.n(),this.c,this.j)}workspaceStorage(E){let S=this.w.get(E.id);return S||(this.c.trace(`StorageMainService: creating workspace storage (${E.id})`),S=this.B(this.y(E)),this.w.set(E.id,S),this.B(r.Event.once(S.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${E.id})`),this.w.delete(E.id)}))),S}y(E){return this.a===b.ShutdownReason.KILL?new u.$lhc(this.c,this.j):new u.$khc(E,this.n(),this.c,this.f,this.j)}isUsed(E){const S=i.URI.file(E);for(const s of[this.applicationStorage,...this.t.values(),...this.w.values()])if(s.path&&this.m.extUri.isEqualOrParent(i.URI.file(s.path),S))return!0;return!1}};e.$nhc=y,e.$nhc=y=ke([re(0,l.$dk),re(1,A.$Pi),re(2,p.$3gc),re(3,b.$ghc),re(4,O.$dl),re(5,d.$Nl)],y),e.$ohc=(0,I.$Ii)("applicationStorageMainService");let k=class extends m.$oq{constructor(E,S){super(),this.s=E,this.U=S,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(E){if(E===m.StorageScope.APPLICATION)return this.U.applicationStorage.storage}Q(E){if(E===m.StorageScope.APPLICATION)return this.s.defaultProfile.globalStorageHome.with({scheme:f.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$phc=k,e.$phc=k=ke([re(0,$.$Pl),re(1,e.$mhc)],k)}),define(le[260],ue([0,1,95,27,116,107,8,2,3,16,5,28,211,214,104,133,17]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p,d,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uic=e.$Tic=e.$Sic=e.$Ric=void 0,i=Ie(i),r=Ie(r);async function k(a,t,o,n,c){let h;for(let P=3;P&&(h?.dispose(),h=await new g(a,t,o,n,c).waitForReady(),!(c&&v.$8g[c]||!v.$8g[h.tunnelLocalPort]));P--);return h}class g extends I.$Xc{constructor(t,o,n,c,h){super(),this.m=o,this.n=h,this.privacy=f.TunnelPrivacyId.Private,this.j=new Map,this.a=t,this.b=i.createServer(),this.c=new O.$Hh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=P=>this.r(P),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=c,this.tunnelRemoteHost=n}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(o=>{o()})}async waitForReady(){const t=this.n??this.tunnelRemotePort,o=(0,f.$Tw)(this.m)?"0.0.0.0":"127.0.0.1";let n=await(0,v.$9g)(t,2,1e3,o),c=null;return this.b.listen(n,this.m),await this.c.wait(),c=this.b.address(),c||(n=0,this.b.listen(n,this.m),await this.c.wait(),c=this.b.address()),this.tunnelLocalPort=c.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async r(t){t.pause();const o=(0,f.$Rw)(this.tunnelRemoteHost)||(0,f.$Tw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,n=await(0,$.$6l)(this.a,o,this.tunnelRemotePort),c=n.getSocket(),h=n.readEntireBuffer();n.dispose(),h.byteLength>0&&t.write(h.buffer),t.on("end",()=>{t.localAddress&&this.j.delete(t.localAddress),c.end()}),t.on("close",()=>c.end()),t.on("error",()=>{t.localAddress&&this.j.delete(t.localAddress),c instanceof A.$xi?c.socket.destroy():c.end()}),c instanceof A.$xi?this.t(t,c):this.s(t,c),t.localAddress&&this.j.set(t.localAddress,()=>{t.end(),c.end()})}s(t,o){o.onClose(()=>t.destroy()),o.onEnd(()=>t.end()),o.onData(n=>t.write(n.buffer)),t.on("data",n=>o.write(y.$Qe.wrap(n))),t.resume()}t(t,o){const n=o.socket;n.on("end",()=>t.end()),n.on("close",()=>t.end()),n.on("error",()=>{t.destroy()}),n.pipe(t),t.pipe(n)}}e.$Ric=g;let E=class extends f.$Ww{constructor(t,o,n,c,h){super(o,h),this.H=t,this.I=n,this.J=c}isPortPrivileged(t){return(0,f.$Uw)(t,this.t,b.OS,r.release())}F(t,o,n,c,h,P,w,D){const L=this.D(o,n);if(L)return++L.refcount,L.value;if((0,f.$Nw)(t))return this.G(t,o,n,h,P,w,D);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${o}:${n} on local port ${h}.`);const R={commit:this.J.commit,quality:this.J.quality,addressProvider:t,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},T=k(R,c,o,n,h);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(o,n,T),T}}};e.$Sic=E,e.$Sic=E=ke([re(0,p.$Zl),re(1,m.$dk),re(2,d.$3l),re(3,u.$wk),re(4,l.$cj)],E);let S=class extends E{constructor(t,o,n,c,h){super(t,o,n,c,h)}};e.$Tic=S,e.$Tic=S=ke([re(0,p.$Zl),re(1,m.$dk),re(2,d.$3l),re(3,u.$wk),re(4,l.$cj)],S);let s=class extends I.$Xc{constructor(t,o,n,c,h){super(),this.b=t,this.c=o,this.f=n,this.g=c,this.h=h,this.a=new Map}async openTunnel(t,o,n,c,h,P,w,D,L){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${n}:${c} on local port ${P}.`),!this.a.has(t)){const R=new S(this.b,this.c,this.g,this.f,this.h);this.B(R),this.a.set(t,R),R.onTunnelClosed(async()=>{(await R.tunnels).length===0&&(R.dispose(),this.a.delete(t))})}return this.a.get(t).openTunnel(o,n,c,h,P,w,D,L)}};e.$Uic=s,e.$Uic=s=ke([re(0,p.$Zl),re(1,m.$dk),re(2,u.$wk),re(3,d.$3l),re(4,l.$cj)],s)}),define(le[108],ue([0,1,8,22,4,16,20,19,5,28,49,50]),function(K,e,i,r,v,A,O,I,b,l,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cic=void 0,e.$bic=$;function $(d,f,y){return`${y.updateUrl}/api/update/${d}/${f}/${y.commit}`}let p=class{get state(){return this.b}d(f){this.j.info("update#setState",f.type),this.b=f,this.c.fire(f)}constructor(f,y,k,g,E,S){this.f=f,this.g=y,this.h=k,this.i=g,this.j=E,this.k=S,this.b=u.$eZ.Uninitialized,this.c=new v.$oe,this.onStateChange=this.c.event,f.when(I.LifecycleMainPhase.AfterWindowOpen).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(u.$eZ.Disabled(u.DisablementReason.NotBuilt));return}if(this.h.disableUpdates){this.d(u.$eZ.Disabled(u.DisablementReason.DisabledByEnvironment)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(u.$eZ.Disabled(u.DisablementReason.MissingConfiguration)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const f=this.g.getValue("update.mode"),y=this.m(f);if(!y){this.d(u.$eZ.Disabled(u.DisablementReason.ManuallyDisabled)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(y),!this.a){this.d(u.$eZ.Disabled(u.DisablementReason.InvalidConfiguration)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.g.getValue("_update.prss")){const k=new URL(this.a);k.searchParams.set("prss","true"),this.a=k.toString()}if(this.d(u.$eZ.Idle(this.q())),f==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}f==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,k=>this.j.error(k))}m(f){return f==="none"?void 0:this.k.quality}n(f=60*60*1e3){return(0,i.$Jh)(f).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(f){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type===u.StateType.Idle&&this.t(f)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type===u.StateType.AvailableForDownload&&await this.o(this.state)}async o(f){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type===u.StateType.Downloaded&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!==u.StateType.Ready||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(f=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${f}`),!f&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},r.CancellationToken.None)).res.statusCode===204}catch(y){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(y);return}}async _applySpecificUpdate(f){}q(){return u.UpdateType.Archive}r(){}};e.$cic=p,e.$cic=p=ke([re(0,I.$ghc),re(1,A.$cj),re(2,O.$Mgc),re(3,m.$_p),re(4,b.$dk),re(5,l.$wk)],p)}),define(le[261],ue([0,1,13,54,4,47,2,16,20,19,5,28,49,24,50,108]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dic=void 0,i=Ie(i);let y=class extends f.$cic{get v(){return v.Event.fromNodeEventEmitter(i.autoUpdater,"error",(g,E)=>E)}get w(){return v.Event.fromNodeEventEmitter(i.autoUpdater,"update-not-available")}get x(){return v.Event.fromNodeEventEmitter(i.autoUpdater,"update-available")}get y(){return v.Event.fromNodeEventEmitter(i.autoUpdater,"update-downloaded",(g,E,S,s)=>({version:S,productVersion:S,timestamp:s}))}constructor(g,E,S,s,a,t,o){super(g,E,s,a,t,o),this.z=S,this.u=new O.$Wc,g.setRelaunchHandler(this)}handleRelaunch(g){return g?.addArgs||g?.removeArgs||this.state.type!==d.StateType.Ready?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(g){this.z.publicLog2("update:error",{messageHash:String((0,A.$wj)(String(g)))}),this.j.error("UpdateService error:",g);const E=this.state.type===d.StateType.CheckingForUpdates&&this.state.explicit?g:void 0;this.d(d.$eZ.Idle(d.UpdateType.Archive,E))}s(g){let E;this.k.darwinUniversalAssetId?E=this.k.darwinUniversalAssetId:E=process.arch==="x64"?"darwin":"darwin-arm64";const S=(0,f.$bic)(E,g,this.k);try{i.autoUpdater.setFeedURL({url:S})}catch(s){this.j.error("Failed to set update feed URL",s);return}return S}t(g){this.d(d.$eZ.CheckingForUpdates(g)),i.autoUpdater.checkForUpdates()}E(){this.state.type===d.StateType.CheckingForUpdates&&this.d(d.$eZ.Downloading)}F(g){this.state.type===d.StateType.Downloading&&(this.d(d.$eZ.Downloaded(g)),this.z.publicLog2("update:downloaded",{version:g.version}),this.d(d.$eZ.Ready(g)))}G(){this.state.type===d.StateType.CheckingForUpdates&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(d.$eZ.Idle(d.UpdateType.Archive)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),i.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$dic=y,ke([r.$ai],y.prototype,"v",null),ke([r.$ai],y.prototype,"w",null),ke([r.$ai],y.prototype,"x",null),ke([r.$ai],y.prototype,"y",null),e.$dic=y=ke([re(0,l.$ghc),re(1,I.$cj),re(2,p.$cm),re(3,b.$Mgc),re(4,$.$_p),re(5,m.$dk),re(6,u.$wk)],y)}),define(le[262],ue([0,1,44,26,8,4,9,20,19,5,24,50]),function(K,e,i,r,v,A,O,I,b,l,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fic=void 0,O=Ie(O);let $=class{get state(){return this.a}d(f){this.g.info("update#setState",f.type),this.a=f,this.b.fire(f)}constructor(f,y,k){if(this.f=f,this.g=k,this.a=u.$eZ.Uninitialized,this.b=new A.$oe,this.onStateChange=this.b.event,y.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(u.$eZ.Idle(this.k())),this.h(30*1e3).then(void 0,g=>this.g.error(g))}h(f=60*60*1e3){return(0,v.$Jh)(f).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(f){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type===u.StateType.Idle&&this.m(f)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type===u.StateType.AvailableForDownload&&await this.i(this.state)}i(f){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type===u.StateType.Downloaded&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!==u.StateType.Ready||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(f=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${f}`),!f&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return u.UpdateType.Snap}l(){}async _applySpecificUpdate(f){}};$=ke([re(0,b.$ghc),re(1,I.$Mgc),re(2,l.$dk)],$);let p=class extends ${constructor(f,y,k,g,E,S){super(k,g,E),this.o=f,this.p=y,this.q=S;const s=(0,r.watch)(O.$pc(this.o)),a=A.Event.fromNodeEventEmitter(s,"change",(c,h)=>h),t=A.Event.filter(a,c=>c==="current"),n=A.Event.debounce(t,(c,h)=>h,2e3)(()=>this.checkForUpdates(!1));k.onWillShutdown(()=>{n.dispose(),s.close()})}m(){this.d(u.$eZ.CheckingForUpdates(!1)),this.u().then(f=>{f?this.d(u.$eZ.Ready({version:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(u.$eZ.Idle(u.UpdateType.Snap)))},f=>{this.g.error(f),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(u.$eZ.Idle(u.UpdateType.Snap,f.message||f))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,i.spawn)("sleep 3 && "+O.$qc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const f=await new Promise((k,g)=>(0,r.realpath)(`${O.$pc(this.o)}/current`,(E,S)=>E?g(E):k(S))),y=O.$qc(f);return this.p!==y}isLatestVersion(){return this.u().then(void 0,f=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$fic=p,e.$fic=p=ke([re(2,b.$ghc),re(3,I.$Mgc),re(4,l.$dk),re(5,m.$cm)],p)});var xe=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[29],ue([0,1,13,142,9,3,16,20,6,28,77,51,52]),function(K,e,i,r,v,A,O,I,b,l,m,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowStateValidator=e.OpenContext=e.$Zgc=void 0,e.$1gc=d,e.$2gc=f,i=xe(i),e.$Zgc=(0,b.$Ii)("windowsMainService");var p;(function(k){k[k.CLI=0]="CLI",k[k.DOCK=1]="DOCK",k[k.MENU=2]="MENU",k[k.DIALOG=3]="DIALOG",k[k.DESKTOP=4]="DESKTOP",k[k.API=5]="API",k[k.LINK=6]="LINK"})(p||(e.OpenContext=p={}));function d(k,g,E,S){const s=k.get(m.$Xgc),a=k.get(l.$wk),t=k.get(O.$cj),o=k.get(I.$Mgc),n=t.getValue("window"),c={backgroundColor:s.getBackgroundColor(),minWidth:u.$lE.WIDTH,minHeight:u.$lE.HEIGHT,title:a.nameLong,show:g.mode!==$.WindowMode.Maximized&&g.mode!==$.WindowMode.Fullscreen,x:g.x,y:g.y,width:g.width,height:g.height,webPreferences:{...S,enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,u.$xE)(g.zoomLevel??n?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};if(A.$l?c.icon=(0,v.$mc)(o.appRoot,"resources/linux/code.png"):A.$j&&!o.isBuilt&&(c.icon=(0,v.$mc)(o.appRoot,"resources/win32/code_150x150.png")),A.$k&&(c.acceptFirstMouse=!0,n?.clickThroughInactive===!1&&(c.acceptFirstMouse=!1)),E?.disableFullscreen?c.fullscreen=!1:A.$k&&!(0,u.$wE)(t)&&(c.fullscreenable=!1),A.$k&&n?.nativeTabs===!0&&(c.tabbingIdentifier=a.nameShort),!(0,u.$sE)(t,E?.forceNativeTitlebar?u.TitlebarStyle.NATIVE:void 0)&&(c.titleBarStyle="hidden",A.$k||(c.frame=!1),(0,u.$vE)(t))){const w=s.getWindowSplash()?.colorInfo.titleBarBackground??s.getBackgroundColor(),D=r.$uu.fromHex(w).isDarker()?"#FFFFFF":"#000000";c.titleBarOverlay={height:29,color:w,symbolColor:D}}return c}function f(k){let g,E=Number.MIN_VALUE;for(const S of k)S.lastFocusTime>E&&(E=S.lastFocusTime,g=S);return g}var y;(function(k){function g(S,s,a=i.default.screen.getAllDisplays()){if(S.trace(`window#validateWindowState: validating window state on ${a.length} display(s)`,s),typeof s.x!="number"||typeof s.y!="number"||typeof s.width!="number"||typeof s.height!="number"){S.trace("window#validateWindowState: unexpected type of state values");return}if(s.width<=0||s.height<=0){S.trace("window#validateWindowState: unexpected negative values");return}if(a.length===1){const n=E(a[0]);if(S.trace("window#validateWindowState: single monitor working area",n),n){let c=function(){!s||typeof s.x!="number"||typeof s.y!="number"||!n||(s.x<n.x&&(s.x=n.x),s.y<n.y&&(s.y=n.y))};c(),s.width>n.width&&(s.width=n.width),s.height>n.height&&(s.height=n.height),s.x>n.x+n.width-128&&(s.x=n.x+n.width-s.width),s.y>n.y+n.height-128&&(s.y=n.y+n.height-s.height),c()}return s}if(s.display&&s.mode===$.WindowMode.Fullscreen){const n=a.find(c=>c.id===s.display);if(n&&typeof n.bounds?.x=="number"&&typeof n.bounds?.y=="number"){S.trace("window#validateWindowState: restoring fullscreen to previous display");const c=(0,$.$Ogc)($.WindowMode.Fullscreen);return c.x=n.bounds.x,c.y=n.bounds.y,c}}let t,o;try{t=i.default.screen.getDisplayMatching({x:s.x,y:s.y,width:s.width,height:s.height}),o=E(t),S.trace("window#validateWindowState: multi-monitor working area",o)}catch(n){S.error("window#validateWindowState: error finding display for window state",n)}if(t&&o&&s.x+s.width>o.x&&s.y+s.height>o.y&&s.x<o.x+o.width&&s.y<o.y+o.height)return s;S.trace("window#validateWindowState: state is outside of the multi-monitor working area")}k.validateWindowState=g;function E(S){if(S.workArea.width>0&&S.workArea.height>0)return S.workArea;if(S.bounds.width>0&&S.bounds.height>0)return S.bounds}})(y||(e.WindowStateValidator=y={}))}),define(le[263],ue([0,1,95,170,123,29]),function(K,e,i,r,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$thc=void 0;class O extends r.$4o{constructor(b){super(),this.f=b}call(b,l,m){return l==="openExtensionDevelopmentHostWindow"?this.g(m[0],m[1]):super.call(b,l,m)}async g(b,l){const m=(0,v.$Gm)(b,v.$Fm);m.debugRenderer=l;const u=m.extensionDevelopmentPath;if(!u)return{success:!1};const[$]=await this.f.openExtensionDevelopmentHostWindow(u,{context:A.OpenContext.API,cli:m,forceProfile:m.profile,forceTempProfile:m["profile-temp"]});if(!l)return{success:!0};const p=$.win;if(!p)return{success:!0};const d=p.webContents.debugger;let f=d.isAttached()?1/0:0;const y=(0,i.createServer)(k=>{f++===0&&d.attach();let g=!1;const E=a=>{g||k.write(JSON.stringify(a)+"\0")},S=(a,t,o,n)=>E({method:t,params:o,sessionId:n});p.on("close",()=>{d.removeListener("message",S),k.end(),g=!0}),d.addListener("message",S);let s=Buffer.alloc(0);k.on("data",a=>{s=Buffer.concat([s,a]);for(let t=s.indexOf(0);t!==-1;t=s.indexOf(0)){let o;try{const n=s.slice(0,t).toString("utf8");s=s.slice(t+1),o=JSON.parse(n)}catch(n){console.error("error reading cdp line",n)}d.sendCommand(o.method,o.params,o.sessionId).then(n=>E({id:o.id,sessionId:o.sessionId,result:n})).catch(n=>E({id:o.id,sessionId:o.sessionId,error:{code:0,message:n.message}}))}}),k.on("error",a=>{console.error("error on cdp pipe:",a)}),k.on("close",()=>{g=!0,--f===0&&d.detach()})});return await new Promise(k=>y.listen(0,k)),p.on("close",()=>y.close()),{rendererDebugPort:y.address().port,success:!0}}}e.$thc=O}),define(le[264],ue([0,1,13,21,3,7,23,16,70,6,5,134,29]),function(K,e,i,r,v,A,O,I,b,l,m,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uhc=e.$Thc=e.ID=void 0,e.ID="launchMainService",e.$Thc=(0,l.$Ii)(e.ID);let p=class{constructor(f,y,k,g){this.a=f,this.b=y,this.c=k,this.d=g}async start(f,y){this.a.trace("Received data from other instance: ",f,y),v.$k&&i.app.focus({steal:!0});const k=this.e(f);if(k.length){let g=Promise.resolve();if(this.b.getWindowCount()===0){const E=(0,r.$Qb)(await this.b.openEmptyWindow({context:$.OpenContext.DESKTOP}));E&&(g=E.ready())}g.then(()=>{for(const{uri:E,originalUrl:S}of k)this.c.open(E,{originalUrl:S})})}else return this.f(f,y)}e(f){return f["open-url"]&&f._urls&&f._urls.length>0?(0,r.$Jb)(f._urls.map(y=>{try{return{uri:A.URI.parse(y),originalUrl:y}}catch{return null}})):[]}async f(f,y){const k=(0,b.$Nm)(y)?$.OpenContext.CLI:$.OpenContext.DESKTOP;let g=[];const E=f.wait&&f.waitMarkerFilePath?A.URI.file(f.waitMarkerFilePath):void 0,S=f.remote||void 0,s={context:k,cli:f,userEnv:f["preserve-env"]||k===$.OpenContext.CLI?y:void 0,waitMarkerFileURI:E,remoteAuthority:S,forceProfile:f.profile,forceTempProfile:f["profile-temp"]};if(f.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(f.extensionDevelopmentPath,s);else if(!f._.length&&!f["folder-uri"]&&!f["file-uri"]){let a=!1;if(f["new-window"]||s.forceProfile||s.forceTempProfile)a=!0;else if(f["reuse-window"])a=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":a=!0;break;case"off":a=!1;break;default:a=!v.$k}if(a)g=await this.b.open({...s,forceNewWindow:!0,forceEmpty:!0});else{const t=this.b.getLastActiveWindow();t?(this.b.openExistingWindow(t,s),g=[t]):g=await this.b.open({...s,forceEmpty:!0})}}else g=await this.b.open({...s,forceNewWindow:f["new-window"],preferNewWindow:!f["reuse-window"]&&!f.wait,forceReuseWindow:f["reuse-window"],diffMode:f.diff,mergeMode:f.merge,addMode:f.add,noRecentEntry:!!f["skip-add-to-recently-opened"],gotoLineMode:f.goto});if(E&&g.length===1&&g[0])return Promise.race([g[0].whenClosedOrLoaded,(0,O.whenDeleted)(E.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$Uhc=p,e.$Uhc=p=ke([re(0,m.$dk),re(1,$.$Zgc),re(2,u.$8Y),re(3,I.$cj)],p)}),define(le[137],ue([0,1,13,22,4,47,2,7,33,16,100,20,6,5,64,89,29]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p,d,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rhc=e.$qhc=void 0,e.$qhc=(0,$.$Ii)("proxyAuthService");let k=class extends O.$Xc{constructor(E,S,s,a,t,o){super(),this.h=E,this.m=S,this.n=s,this.r=a,this.s=t,this.t=o,this.a="proxy-credentials://",this.b=new Map,this.c=void 0,this.f=new Set,this.g=new Map,this.u()}u(){const E=v.Event.fromNodeEventEmitter(i.app,"login",(S,s,a,t,o)=>({event:S,authInfo:{...t,attempt:a.firstAuthAttempt?1:2},callback:o}));this.B(E(this.w,this))}async lookupAuthorization(E){return this.w({authInfo:E})}async w({event:E,authInfo:S,callback:s}){if(!S.isProxy)return;E?.preventDefault();const a=String((0,A.$wj)({scheme:S.scheme,host:S.host,port:S.port}));let t,o=this.b.get(a);if(o)this.h.trace("auth#onLogin (proxy) - pending proxy handling found"),t=await o;else{this.h.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),o=this.y(S,a),this.b.set(a,o);try{t=await o}finally{this.b.delete(a)}}return s?.(t?.username,t?.password),t}async y(E,S){this.h.trace("auth#resolveProxyCredentials (proxy) - enter");try{const s=await this.z(E,S);if(s)return this.h.trace("auth#resolveProxyCredentials (proxy) - got credentials"),s;this.h.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.h.trace("auth#resolveProxyCredentials (proxy) - exit")}}async z(E,S){if(this.h.trace("auth#doResolveProxyCredentials - enter",E),this.t.extensionTestsLocationURI){const h=this.s.getValue("integration-test.http.proxyAuth");if(h){const P=h.indexOf(":");return P!==-1?{username:h.substring(0,P),password:h.substring(P+1)}:{username:h,password:""}}return}const s=(this.s.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;if(s?.indexOf("@")!==-1){const h=I.URI.parse(s),P=h.authority.indexOf("@");if(P!==-1){if(E.attempt>1){this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - ignoring previously used config/envvar credentials");return}this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - found config/envvar credentials to use");const w=h.authority.substring(0,P),D=w.indexOf(":");return D!==-1?{username:w.substring(0,D),password:w.substring(D+1)}:{username:w,password:""}}}const a=E.attempt===1&&this.g.get(S);if(a){this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - found session credentials to use");const{username:h,password:P}=a;return{username:h,password:P}}let t,o;try{const h=this.r.get(this.a+S,d.StorageScope.APPLICATION);if(h){const P=JSON.parse(await this.n.decrypt(h));t=P.username,o=P.password}}catch(h){this.h.error(h)}if(E.attempt===1&&typeof t=="string"&&typeof o=="string")return this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.g.set(S,{username:t,password:o}),{username:t,password:o};const n=this.c,c=this.c=(async()=>{await n;const h=await this.C(E,S,t,o);return this.c===c&&(this.c=void 0),h})();return c}async C(E,S,s,a){if(this.f.has(S)){this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - login dialog was cancelled before, not showing again");return}const t=this.m.getFocusedWindow()||this.m.getLastActiveWindow();if(!t){this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.h.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${t.id} to handle proxy login`);const o=this.g.get(S),n={authInfo:E,username:o?.username??s,password:o?.password??a,replyChannel:`vscode:proxyAuthResponse:${(0,b.$5g)()}`};t.sendWhenReady("vscode:openProxyAuthenticationDialog",r.CancellationToken.None,n);const c=await new Promise(h=>{const P=async(w,D,L)=>{if(D===n.replyChannel)if(this.h.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${t.id}`),t.win?.webContents.off("ipc-message",P),L){const R={username:L.username,password:L.password};try{if(L.remember){const T=await this.n.encrypt(JSON.stringify(R));this.r.store(this.a+S,T,d.StorageScope.APPLICATION,d.StorageTarget.MACHINE)}else this.r.remove(this.a+S,d.StorageScope.APPLICATION)}catch(T){this.h.error(T)}h({username:R.username,password:R.password})}else this.f.add(S),h(void 0)};t.win?.webContents.on("ipc-message",P)});return this.g.set(S,c),c}};e.$rhc=k,e.$rhc=k=ke([re(0,p.$dk),re(1,y.$Zgc),re(2,m.$2Y),re(3,f.$ohc),re(4,l.$cj),re(5,u.$Mgc)],k)}),define(le[265],ue([0,1,2,19,52,58,30,8,29]),function(K,e,i,r,v,A,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xic=void 0;let l=class extends i.$Xc{constructor(u,$,p){super(),this.a=$,this.b=p,this.B(u.onWillLoadWindow(d=>{d.reason===v.LoadReason.LOAD&&this.c(d.window)})),this.B(u.onBeforeCloseWindow(d=>this.c(d))),this.B(new I.$Uh(()=>this.g(),30*1e3)).schedule()}async c(u){const $=this.f(u),p=this.a.getProfileForWorkspace($);p?.isTransient&&(this.a.unsetWorkspace($,p.isTransient),p.isTransient&&await this.a.cleanUpTransientProfiles())}f(u){return u.openedWorkspace??(0,O.$Wi)(u.backupPath,u.isExtensionDevelopmentHost)}g(){const u=this.a.getAssociatedEmptyWindows();if(u.length===0)return;const $=this.b.getWindows().map(p=>this.f(p));for(const p of u)$.some(d=>d.id===p.id)||this.a.unsetWorkspace(p,!1)}};e.$xic=l,e.$xic=l=ke([re(0,r.$ghc),re(1,A.$3gc),re(2,b.$Zgc)],l)});var xe=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[65],ue([0,1,13,2,4,5,285,8,11,29,82,24,19,80,38,3,109,12]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p,d,f,y,k){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$vhc=e.$uhc=void 0,m=xe(m);function E(a){return typeof a.responseWindowId=="number"}let S=class extends r.$Xc{static{g=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from(g.b.values())}constructor(t,o,n){super(),this.w=t,this.y=o,this.z=n,this.c=String(++g.a),this.f=this.B(new v.$oe),this.onStdout=this.f.event,this.g=this.B(new v.$oe),this.onStderr=this.g.event,this.h=this.B(new v.$oe),this.onMessage=this.h.event,this.j=this.B(new v.$oe),this.onSpawn=this.j.event,this.m=this.B(new v.$oe),this.onExit=this.m.event,this.n=this.B(new v.$oe),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0,this.u=!1}C(t,o){let n;switch(this.t?.correlationId?n=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`:n=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`,o){case m.default.Error:this.w.error(n);break;case m.default.Warning:this.w.warn(n);break;case m.default.Info:this.w.trace(n);break}}D(){return this.r?(this.C("Cannot start utility process because it is already running...",m.default.Error),!1):!0}start(t){const o=this.F(t);return o&&t.payload&&this.postMessage(t.payload)&&this.C("payload sent via postMessage()",m.default.Info),o}F(t){if(!this.D())return!1;this.t=t;const o=`${this.t.type}-${this.c}`,n=b.$3g.asFileUri("bootstrap-fork.js").fsPath,c=this.t.args??[],h=this.t.execArgv??[],P=this.t.allowLoadingUnsignedLibraries,w=this.t.forceAllocationsToV8Sandbox,D=this.t.respondToAuthRequestsFromMainProcess,L="pipe",R=this.G(t);return this.C("creating new...",m.default.Info),this.r=i.utilityProcess.fork(n,c,(0,k.$zg)({serviceName:o,env:R,execArgv:h,allowLoadingUnsignedLibraries:P,forceAllocationsToV8Sandbox:w,respondToAuthRequestsFromMainProcess:D,stdio:L})),this.H(this.r,this.t,o),!0}G(t){const o=t.env?{...t.env}:{...(0,d.$io)(process.env)};o.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(o.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),o.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,f.$j&&((0,y.isUNCAccessRestrictionsDisabled)()?o.NODE_DISABLE_UNC_ACCESS_CHECKS="1":o.NODE_UNC_HOST_ALLOWLIST=(0,y.getUNCHostAllowlist)().join("\\")),(0,p.$pm)(o);for(const n of Object.keys(o))o[n]=String(o[n]);return o}H(t,o,n){if(t.stdout){const c=new O.StringDecoder("utf-8");this.B(v.Event.fromNodeEventEmitter(t.stdout,"data")(h=>this.f.fire(typeof h=="string"?h:c.write(h))))}if(t.stderr){const c=new O.StringDecoder("utf-8");this.B(v.Event.fromNodeEventEmitter(t.stderr,"data")(h=>this.g.fire(typeof h=="string"?h:c.write(h))))}this.B(v.Event.fromNodeEventEmitter(t,"message")(c=>this.h.fire(c))),this.B(v.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.s=t.pid,typeof t.pid=="number"&&g.b.set(t.pid,{pid:t.pid,name:E(o)?`${o.type} [${o.responseWindowId}]`:o.type}),this.C("successfully created",m.default.Info),this.j.fire(t.pid)})),this.B(v.Event.fromNodeEventEmitter(t,"exit")(c=>{const h=this.I(c)?0:c;this.C(`received exit event with code ${h}`,m.default.Info),this.m.fire({pid:this.s,code:h,signal:"unknown"}),this.J()})),this.B(v.Event.fromNodeEventEmitter(i.app,"child-process-gone",(c,h)=>({event:c,details:h}))(({details:c})=>{c.type==="Utility"&&c.name===n&&!this.I(c.exitCode)&&(this.C(`crashed with code ${c.exitCode} and reason '${c.reason}'`,m.default.Error),this.y.publicLog2("utilityprocesscrash",{type:o.type,reason:c.reason,code:c.exitCode}),this.n.fire({pid:this.s,code:c.exitCode,reason:c.reason}),this.J())}))}once(t,o){const n=this.B(this.h.event(c=>{c===t&&(n.dispose(),o())}))}postMessage(t,o){return this.r?(this.r.postMessage(t,o),!0):!1}connect(t){const{port1:o,port2:n}=new i.MessageChannelMain;return this.postMessage(t,[n]),o}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.C("enabling inspect port",m.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.C("attempting to kill the process...",m.default.Info),this.r.kill()?(this.C("successfully killed the process",m.default.Info),this.u=!0,this.J()):this.C("unable to kill the process",m.default.Warning)}I(t){return t===0?!0:this.u&&t===15}J(){typeof this.s=="number"&&g.b.delete(this.s),this.r=void 0}async waitForExit(t){this.r&&(this.C("waiting to exit...",m.default.Info),await Promise.race([v.Event.toPromise(this.onExit),(0,I.$Jh)(t)]),this.r&&(this.C(`did not exit within ${t}ms, will kill it now...`,m.default.Info),this.kill()))}};e.$uhc=S,e.$uhc=S=g=ke([re(0,A.$dk),re(1,u.$cm),re(2,$.$ghc)],S);let s=class extends S{constructor(t,o,n,c){super(t,n,c),this.L=o}start(t){const o=this.L.getWindowById(t.responseWindowId);if(!o?.win||o.win.isDestroyed()||o.win.webContents.isDestroyed())return this.C("Refusing to start utility process because requesting window cannot be found or is destroyed...",m.default.Error),!0;if(!super.F(t))return!1;this.M(o.win,t);const c=this.connect(t.payload);return o.win.webContents.postMessage(t.responseChannel,t.responseNonce,[c]),!0}M(t,o){o.windowLifecycleBound&&(this.B(v.Event.filter(this.z.onWillLoadWindow,n=>n.window.win===t)(()=>this.kill())),this.B(v.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.$vhc=s,e.$vhc=s=ke([re(0,A.$dk),re(1,l.$Zgc),re(2,u.$cm),re(3,$.$ghc)],s)}),define(le[266],ue([0,1,8,15,4,2,19,5,24,65,29]),function(K,e,i,r,v,A,O,I,b,l,m){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Chc=void 0;let $=class extends A.$Xc{static{u=this}static{this.a=0}constructor(d,f,y,k){super(),this.f=d,this.g=f,this.h=y,this.j=k,this.b=new Map,this.c=!1,this.B(this.g.onWillShutdown(g=>{this.c=!0,g.join("extHostStarter",this._waitForAllExit(6e3))}))}dispose(){super.dispose()}m(d){const f=this.b.get(d);if(!f)throw new Error("Unknown extension host!");return f}onDynamicStdout(d){return this.m(d).onStdout}onDynamicStderr(d){return this.m(d).onStderr}onDynamicMessage(d){return this.m(d).onMessage}onDynamicExit(d){return this.m(d).onExit}async createExtensionHost(){if(this.c)throw(0,r.$8)();const d=String(++u.a),f=new l.$vhc(this.f,this.h,this.j,this.g);this.b.set(d,f);const y=f.onExit(({pid:k,code:g,signal:E})=>{y.dispose(),this.f.info(`Extension host with pid ${k} exited with code: ${g}, signal: ${E}.`),setTimeout(()=>{f.dispose(),this.b.delete(d)}),setTimeout(()=>{try{process.kill(k,0),this.f.error(`Extension host with pid ${k} still exists, forcefully killing it...`),process.kill(k)}catch{}},1e3)});return{id:d}}async start(d,f){if(this.c)throw(0,r.$8)();const y=this.m(d);return y.start({...f,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:f.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,respondToAuthRequestsFromMainProcess:!0,correlationId:d}),{pid:await v.Event.toPromise(y.onSpawn)}}async enableInspectPort(d){if(this.c)throw(0,r.$8)();const f=this.b.get(d);return f?f.enableInspectPort():!1}async kill(d){if(this.c)throw(0,r.$8)();const f=this.b.get(d);f&&f.kill()}async _killAllNow(){for(const[,d]of this.b)d.kill()}async _waitForAllExit(d){const f=[];for(const[,y]of this.b)f.push(y.waitForExit(d));return i.Promises.settled(f).then(()=>{})}};e.$Chc=$,e.$Chc=$=u=ke([re(0,I.$dk),re(1,O.$ghc),re(2,m.$Zgc),re(3,b.$cm)],$)}),define(le[267],ue([0,1,35,8,2,20,19,5,42,40,73,65,57,98,12,219,4]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p,d,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8hc=void 0;let k=class extends v.$Xc{constructor(E,S,s,a,t,o,n,c,h){super(),this.g=E,this.h=S,this.j=s,this.m=a,this.n=t,this.r=o,this.s=n,this.t=c,this.u=h,this.a=new r.$Hh,this.b=void 0,this.c=void 0,this.f=this.B(new y.$oe),this.onDidCrash=this.f.event,this.C=void 0,this.D=void 0,this.w()}w(){i.$gY.on(f.$6hc.request,(E,S)=>this.y(E,S,f.$6hc.response)),i.$gY.on(f.$7hc.request,(E,S)=>this.y(E,S,f.$7hc.response)),this.B(this.r.onWillShutdown(()=>this.z()))}async y(E,S,s){this.s.trace(`[SharedProcess] onWindowConnection for: ${s}`),this.a.isOpen()||this.a.open(),await this.whenReady();const a=await this.connect(s);if(E.sender.isDestroyed())return a.close();E.sender.postMessage(s,S,[a])}z(){this.s.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(f.$5hc.exit),this.b=void 0}whenReady(){return this.C||(this.C=(async()=>{await this.F;const E=new r.$6h;this.b?.once(f.$5hc.initDone,()=>E.complete()),await E.p,this.c?.dispose(),this.s.trace("[SharedProcess] Overall ready")})()),this.C}get F(){return this.D||(this.D=(async()=>{await this.a.wait(),this.G();const E=new r.$6h;this.b?.once(f.$5hc.ipcReady,()=>E.complete()),await E.p,this.s.trace("[SharedProcess] IPC ready")})()),this.D}G(){this.b=this.B(new u.$uhc(this.s,$.$Dp,this.r)),this.c=this.b.onMessage(s=>{typeof s.warning=="string"?this.s.warn(s.warning):typeof s.error=="string"&&this.s.error(s.error)});const E=(0,p.$cn)(this.m.args,this.m.isBuilt);let S;E.port&&(S=["--nolazy"],E.break?S.push(`--inspect-brk=${E.port}`):S.push(`--inspect=${E.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.H(),execArgv:S}),this.B(this.b.onCrash(()=>this.f.fire()))}H(){return{machineId:this.g,sqmId:this.h,devDeviceId:this.j,codeCachePath:this.m.codeCachePath,profiles:{home:this.n.profilesHome,all:this.n.profiles},args:this.m.args,logLevel:this.t.getLogLevel(),loggers:this.t.getRegisteredLoggers(),policiesData:this.u.serialize()}}async connect(E){return await this.F,(0,d.$sg)(this.b).connect(E)}};e.$8hc=k,e.$8hc=k=ke([re(3,A.$Mgc),re(4,b.$Pl),re(5,O.$ghc),re(6,I.$dk),re(7,m.$bhc),re(8,l.$xo)],k)}),define(le[268],ue([0,1,20,98,19,5,57,76,65,121,35,2,4,38,16,11]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jic=void 0;let y=class extends u.$Xc{constructor(g,E,S,s,a){super(),this.f=g,this.g=E,this.h=S,this.j=s,this.m=a,this.a=void 0,this.b=new $.$oe,this.onRequestConnection=this.b.event,this.c=new $.$oe,this.onWillShutdown=this.c.event,this.B(this.j.onWillShutdown(()=>this.c.fire())),m.$gY.on("vscode:createPtyHostMessageChannel",(t,o)=>this.r(t,o)),this.B((0,u.$Vc)(()=>{m.$gY.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new b.$uhc(this.m,O.$Dp,this.j);const g=(0,r.$bn)(this.h.args,this.h.isBuilt),E=g.port?["--nolazy",`--inspect${g.break?"-brk":""}=${g.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:E,args:["--logsPath",this.h.logsHome.with({scheme:f.Schemas.file}).fsPath],env:this.n()});const S=this.a.connect(),s=new l.$oY(S,"ptyHost"),a=new u.$Wc;return a.add(s),a.add((0,u.$Vc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:s,store:a,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const g={...(0,p.$io)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},E=this.g.getValue(I.TerminalSettingId.DeveloperPtyHostLatency);E&&typeof E=="number"&&(g.VSCODE_LATENCY=String(E));const S=this.g.getValue(I.TerminalSettingId.DeveloperPtyHostStartupDelay);return S&&typeof S=="number"&&(g.VSCODE_STARTUP_DELAY=String(S)),this.h.restoreSnapExportedVariables(),g}r(g,E){this.b.fire();const S=this.a.connect();if(g.sender.isDestroyed()){S.close();return}g.sender.postMessage("vscode:createPtyHostMessageChannelResult",E,[S])}};e.$Jic=y,e.$Jic=y=ke([re(1,d.$cj),re(2,i.$Mgc),re(3,v.$ghc),re(4,A.$dk)],y)}),define(le[269],ue([0,1,2,6,5,29,65,24,47,4,8,19]),function(K,e,i,r,v,A,O,I,b,l,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iic=e.$Hic=void 0,e.$Hic=(0,r.$Ii)("utilityProcessWorker");let $=class extends i.$Xc{constructor(f,y,k,g){super(),this.b=f,this.c=y,this.f=k,this.g=g,this.a=new Map}async createWorker(f){const y=`window: ${f.reply.windowId}, moduleId: ${f.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${y})`);const k=this.h(f);this.a.has(k)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${y})`),this.disposeWorker(f));const g=new p(this.b,this.c,this.f,this.g,f);if(!g.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(k,g);const E=new m.$6h;return l.Event.once(g.onDidTerminate)(S=>{S.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${S.code}, signal: ${S.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${S.code}, signal: ${S.signal}`),this.a.delete(k),E.complete({reason:S})}),E.p}h(f){return(0,b.$wj)({moduleId:f.process.moduleId,windowId:f.reply.windowId})}async disposeWorker(f){const y=this.h(f),k=this.a.get(y);k&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${f.reply.windowId}, moduleId: ${f.process.moduleId})`),k.kill(),k.dispose(),this.a.delete(y))}};e.$Iic=$,e.$Iic=$=ke([re(0,v.$dk),re(1,A.$Zgc),re(2,I.$cm),re(3,u.$ghc)],$);let p=class extends i.$Xc{constructor(f,y,k,g,E){super(),this.c=f,this.f=y,this.g=k,this.h=g,this.j=E,this.a=this.B(new l.$oe),this.onDidTerminate=this.a.event,this.b=this.B(new O.$vhc(this.c,this.f,this.g,this.h)),this.m()}m(){this.B(this.b.onExit(f=>this.a.fire({code:f.code,signal:f.signal}))),this.B(this.b.onCrash(f=>this.a.fire({code:f.code,signal:"ECRASH"})))}spawn(){const y=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:y,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};p=ke([re(0,v.$dk),re(1,A.$Zgc),re(2,I.$cm),re(3,u.$ghc)],p)}),define(le[270],ue([0,1,13,4,2,244,29]),function(K,e,i,r,v,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nic=void 0;let I=class extends v.$Xc{constructor(l){super(),this.b=l,this.a=this.B(new r.$oe),this.onFoundInFrame=this.a.event,this.B(new A.$mic)}async setIgnoreMenuShortcuts(l,m){let u;if(typeof l.windowId=="number"){const{windowId:$}=l,p=this.b.getWindowById($);if(!p?.win)throw new Error(`Invalid windowId: ${$}`);u=p.win.webContents}else{const{webContentsId:$}=l;if(u=i.webContents.fromId($),!u)throw new Error(`Invalid webContentsId: ${$}`)}u.isDestroyed()||u.setIgnoreMenuShortcuts(m)}async findInFrame(l,m,u,$){const d=this.c(l,m);if(typeof d.findInFrame=="function"){d.findInFrame(u,{findNext:$.findNext,forward:$.forward});const f=(y,k)=>{k.finalUpdate&&(this.a.fire(k),d.removeListener("found-in-frame",f))};d.on("found-in-frame",f)}}async stopFindInFrame(l,m,u){const p=this.c(l,m);typeof p.stopFindInFrame=="function"&&p.stopFindInFrame(u.keepSelection?"keepSelection":"clearSelection")}c(l,m){const u=this.b.getWindowById(l.windowId);if(!u?.win)throw new Error(`Invalid windowId: ${l}`);const $=u.win.webContents.mainFrame.framesInSubtree.find(p=>p.name===m);if(!$)throw new Error(`Unknown frame: ${m}`);return $}};e.$nic=I,e.$nic=I=ke([re(0,O.$Zgc)],I)});var xe=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[271],ue([0,1,13,2,3,18,7,16,19,5,34,29,52,30]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$oic=void 0,e.$pic=y,e.$qic=g,i=xe(i);let f=class extends r.$Xc{static{d=this}static{this.a="windowsState"}get state(){return this.b}constructor(s,a,t,o,n){super(),this.g=s,this.h=a,this.j=t,this.m=o,this.n=n,this.b=y(this.h.getItem(d.a)),this.c=void 0,this.f=!1,this.r()}r(){i.default.app.on("browser-window-blur",()=>{this.f||this.t()}),this.B(this.j.onBeforeCloseWindow(s=>this.u(s))),this.B(this.j.onBeforeShutdown(()=>this.s())),this.B(this.g.onDidChangeWindowsCount(s=>{s.newCount-s.oldCount>0&&(this.c=void 0)})),this.B(this.g.onDidDestroyWindow(s=>this.u(s)))}s(){this.f=!0,this.t()}t(){const s=new Set,a={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!a.lastActiveWindow){let n=this.g.getLastActiveWindow();(!n||n.isExtensionDevelopmentHost)&&(n=this.g.getWindows().find(c=>!c.isExtensionDevelopmentHost)),n&&(a.lastActiveWindow=this.w(n),a.lastActiveWindow.uiState.mode===$.WindowMode.Fullscreen&&s.add(a.lastActiveWindow.uiState.display))}const t=this.g.getWindows().find(n=>n.isExtensionDevelopmentHost&&!n.isExtensionTestHost);t&&(a.lastPluginDevelopmentHostWindow=this.w(t),a.lastPluginDevelopmentHostWindow.uiState.mode===$.WindowMode.Fullscreen&&(s.has(a.lastPluginDevelopmentHostWindow.uiState.display)?v.$k&&!t.win?.isSimpleFullScreen()&&(a.lastPluginDevelopmentHostWindow.uiState.mode=$.WindowMode.Normal):s.add(a.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(a.openedWindows=this.g.getWindows().filter(n=>!n.isExtensionDevelopmentHost).map(n=>{const c=this.w(n);return c.uiState.mode===$.WindowMode.Fullscreen&&(s.has(c.uiState.display)?v.$k&&c.windowId!==a.lastActiveWindow?.windowId&&!n.win?.isSimpleFullScreen()&&(c.uiState.mode=$.WindowMode.Normal):s.add(c.uiState.display)),c}));const o=g(a);this.h.setItem(d.a,o),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",o)}u(s){if(this.j.quitRequested)return;const a=this.w(s);s.isExtensionDevelopmentHost&&!s.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=a:!s.isExtensionDevelopmentHost&&s.openedWorkspace&&this.b.openedWindows.forEach(t=>{const o=(0,p.$Xi)(s.openedWorkspace)&&t.workspace?.id===s.openedWorkspace.id,n=(0,p.$Si)(s.openedWorkspace)&&t.folderUri&&A.$ah.isEqual(t.folderUri,s.openedWorkspace.uri);(o||n)&&(t.uiState=a.uiState)}),this.g.getWindowCount()===1&&(this.c=a)}w(s){return{windowId:s.id,workspace:(0,p.$Xi)(s.openedWorkspace)?s.openedWorkspace:void 0,folderUri:(0,p.$Si)(s.openedWorkspace)?s.openedWorkspace.uri:void 0,backupPath:s.backupPath,remoteAuthority:s.remoteAuthority,uiState:s.serializeWindowState()}}getNewWindowState(s){const a=this.z(s),t=this.n.getValue("window");if(a.mode===$.WindowMode.Fullscreen){let o;a.hasDefaultState?o=!!(t?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(t.newWindowDimensions)>=0):o=!!(this.j.wasRestarted||t?.restoreFullscreen),o||(a.mode=$.WindowMode.Normal)}return a}z(s){const a=this.g.getLastActiveWindow();if(!s.extensionTestsPath){if(s.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const P=s.workspace;if((0,p.$Xi)(P)){const D=this.state.openedWindows.filter(L=>L.workspace&&L.workspace.id===P.id).map(L=>L.uiState);if(D.length)return D[0]}if((0,p.$Si)(P)){const D=this.state.openedWindows.filter(L=>L.folderUri&&A.$ah.isEqual(L.folderUri,P.uri)).map(L=>L.uiState);if(D.length)return D[0]}else if(s.backupPath){const D=this.state.openedWindows.filter(L=>L.backupPath===s.backupPath).map(L=>L.uiState);if(D.length)return D[0]}const w=this.c||this.state.lastActiveWindow;if(!a&&w)return w.uiState}let t;const o=i.default.screen.getAllDisplays();if(o.length===1)t=o[0];else{if(v.$k){const P=i.default.screen.getCursorScreenPoint();t=i.default.screen.getDisplayNearestPoint(P)}!t&&a&&(t=i.default.screen.getDisplayMatching(a.getBounds())),t||(t=i.default.screen.getPrimaryDisplay()||o[0])}let n=(0,$.$Ogc)();n.x=Math.round(t.bounds.x+t.bounds.width/2-n.width/2),n.y=Math.round(t.bounds.y+t.bounds.height/2-n.height/2);const c=this.n.getValue("window");let h=!0;if(c?.newWindowDimensions){if(c.newWindowDimensions==="maximized")n.mode=$.WindowMode.Maximized,h=!1;else if(c.newWindowDimensions==="fullscreen")n.mode=$.WindowMode.Fullscreen,h=!1;else if((c.newWindowDimensions==="inherit"||c.newWindowDimensions==="offset")&&a){const P=a.serializeWindowState();P.mode===$.WindowMode.Fullscreen?n.mode=$.WindowMode.Fullscreen:n={...P,zoomLevel:void 0},h=n.mode!==$.WindowMode.Fullscreen&&c.newWindowDimensions==="offset"}}return h&&(n=this.C(n)),n.hasDefaultState=!0,n}C(s){if(this.g.getWindows().length===0)return s;s.x=typeof s.x=="number"?s.x:0,s.y=typeof s.y=="number"?s.y:0;const a=this.g.getWindows().map(t=>t.getBounds());for(;a.some(t=>t.x===s.x||t.y===s.y);)s.x+=30,s.y+=30;return s}};e.$oic=f,e.$oic=f=d=ke([re(0,u.$Zgc),re(1,m.$VR),re(2,b.$ghc),re(3,l.$dk),re(4,I.$cj)],f);function y(S){const s={openedWindows:[]},a=S||{openedWindows:[]};return a.lastActiveWindow&&(s.lastActiveWindow=k(a.lastActiveWindow)),a.lastPluginDevelopmentHostWindow&&(s.lastPluginDevelopmentHostWindow=k(a.lastPluginDevelopmentHostWindow)),Array.isArray(a.openedWindows)&&(s.openedWindows=a.openedWindows.map(t=>k(t))),s}function k(S){const s={uiState:S.uiState};return S.backupPath&&(s.backupPath=S.backupPath),S.remoteAuthority&&(s.remoteAuthority=S.remoteAuthority),S.folder&&(s.folderUri=O.URI.parse(S.folder)),S.workspaceIdentifier&&(s.workspace={id:S.workspaceIdentifier.id,configPath:O.URI.parse(S.workspaceIdentifier.configURIPath)}),s}function g(S){return{lastActiveWindow:S.lastActiveWindow&&E(S.lastActiveWindow),lastPluginDevelopmentHostWindow:S.lastPluginDevelopmentHostWindow&&E(S.lastPluginDevelopmentHostWindow),openedWindows:S.openedWindows.map(s=>E(s))}}function E(S){return{workspaceIdentifier:S.workspace&&{id:S.workspace.id,configURIPath:S.workspace.configPath.toString()},folder:S.folderUri&&S.folderUri.toString(),backupPath:S.backupPath,remoteAuthority:S.remoteAuthority,uiState:S.uiState}}});var xe=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[59],ue([0,1,26,13,4,43,2,11,9,18,23,10,71,53,20,6,5,58,136,30,105,106]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p,d,f,y,k,g,E,S,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ahc=e.$_gc=void 0,i=Ie(i),r=xe(r),e.$_gc=(0,f.$Ii)("workspacesManagementMainService");let a=class extends O.$Xc{constructor(o,n,c,h,P){super(),this.g=o,this.h=n,this.j=c,this.m=h,this.n=P,this.a=this.B(new v.$oe),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new v.$oe),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const o=(await m.Promises.readdir(this.c.with({scheme:I.Schemas.file}).fsPath)).map(n=>(0,l.$jh)(this.c,n,E.$8i));for(const n of o){const c=(0,s.$9gc)(n),h=await this.resolveLocalWorkspace(n);h?this.f.push({workspace:c,remoteAuthority:h.remoteAuthority}):await this.deleteUntitledWorkspace(c)}}catch(o){o.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${o}).`)}}resolveLocalWorkspace(o){return this.r(o,n=>i.promises.readFile(n,"utf8"))}r(o,n){if(this.s(o)&&o.scheme===I.Schemas.file)try{const c=n(o.fsPath);return c instanceof Promise?c.then(h=>this.t(o,h),h=>{}):this.t(o,c)}catch{return}}s(o){return(0,E.$9i)(o,this.g)||(0,E.$bj)(o)}t(o,n){try{const c=this.u(o,n),h=(0,s.$9gc)(o);return{id:h.id,configPath:h.configPath,folders:(0,S.$Oib)(c.folders,h.configPath,l.$ah),remoteAuthority:c.remoteAuthority,transient:c.transient}}catch(c){this.h.warn(c.toString())}}u(o,n){const c=(0,A.$3n)(n);if(c&&Array.isArray(c.folders))c.folders=c.folders.filter(h=>(0,S.$Mib)(h));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return c}async createUntitledWorkspace(o,n){const{workspace:c,storedWorkspace:h}=this.w(o,n),P=c.configPath.fsPath;return await i.promises.mkdir((0,b.$pc)(P),{recursive:!0}),await m.Promises.writeFile(P,JSON.stringify(h,null,"	")),this.f.push({workspace:c,remoteAuthority:n}),c}w(o=[],n){const c=(Date.now()+Math.round(Math.random()*1e3)).toString(),h=(0,l.$jh)(this.c,c),P=(0,l.$jh)(h,E.$8i),w=[];for(const D of o)w.push((0,S.$Nib)(D.uri,!0,D.name,h,l.$ah));return{workspace:(0,s.$9gc)(P),storedWorkspace:{folders:w,remoteAuthority:n}}}async getWorkspaceIdentifier(o){return(0,s.$9gc)(o)}isUntitledWorkspace(o){return(0,E.$9i)(o.configPath,this.g)}async deleteUntitledWorkspace(o){this.isUntitledWorkspace(o)&&(await this.y(o),this.j.isEnabled()&&this.j.unsetWorkspace(o),this.a.fire(o))}async y(o){const n=(0,l.$0g)(o.configPath);try{await m.Promises.rm((0,b.$pc)(n));const c=(0,b.$mc)(this.g.workspaceStorageHome.with({scheme:I.Schemas.file}).fsPath,o.id);await m.Promises.exists(c)&&await m.Promises.writeFile((0,b.$mc)(c,"obsolete"),""),this.f=this.f.filter(h=>h.workspace.id!==o.id)}catch(c){this.h.warn(`Unable to delete untitled workspace ${n} (${c}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(o,n,c){if(!o||!o.win||!o.isReady||!await this.z(o,n,c))return;const P=await this.C(o,(0,s.$9gc)(c));if(P)return this.b.fire({window:o,workspace:P.workspace}),P}async z(o,n,c){return c?(0,E.$Xi)(o.openedWorkspace)&&l.$ah.isEqual(o.openedWorkspace.configPath,c)?!1:(0,g.$6gc)(n,c)?(await this.n.showMessageBox({type:"info",buttons:[(0,u.localize)(2500,null)],message:(0,u.localize)(2501,null,(0,l.$gh)(c)),detail:(0,u.localize)(2502,null)},r.default.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(o,n){if(!o.config)return;o.focus();let c;return o.config.extensionDevelopmentPath||(o.config.backupPath?c=await this.m.registerWorkspaceBackup({workspace:n,remoteAuthority:o.remoteAuthority},o.config.backupPath):c=this.m.registerWorkspaceBackup({workspace:n,remoteAuthority:o.remoteAuthority})),(0,E.$Xi)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&await this.deleteUntitledWorkspace(o.openedWorkspace),o.config.workspace=n,o.config.backupPath=c,{workspace:n,backupPath:c}}};e.$ahc=a,e.$ahc=a=ke([re(0,d.$Mgc),re(1,y.$dk),re(2,k.$3gc),re(3,$.$Tgc),re(4,p.$Ugc)],a)}),define(le[138],ue([0,1,13,35,22,6,29,30,59,12,5,65]),function(K,e,i,r,v,A,O,I,b,l,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yhc=e.$xhc=e.ID=void 0,e.ID="diagnosticsMainService",e.$xhc=(0,A.$Ii)(e.ID);let $=class{constructor(d,f,y){this.a=d,this.b=f,this.c=y}async getRemoteDiagnostics(d){const f=this.a.getWindows();return(await Promise.all(f.map(async k=>{const g=k.remoteAuthority;if(!g)return;const E=`vscode:getDiagnosticInfoResponse${k.id}`,S={includeProcesses:d.includeProcesses,folders:d.includeWorkspaceMetadata?await this.f(k):void 0};return new Promise(s=>{k.sendWhenReady("vscode:getDiagnosticInfo",v.CancellationToken.None,{replyChannel:E,args:S}),r.$gY.once(E,(a,t)=>{t||s({hostName:g,errorMessage:`Unable to resolve connection to '${g}'.`}),s(t)}),setTimeout(()=>{s({hostName:g,errorMessage:`Connection to '${g}' could not be established`})},5e3)})}))).filter(k=>!!k)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const d=[];for(const y of i.BrowserWindow.getAllWindows()){const k=this.a.getWindowById(y.id);k?d.push(await this.d(k)):d.push(this.e(y))}const f=[];for(const{pid:y,name:k}of u.$uhc.getAll())f.push({pid:y,name:k});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:d,pidToNames:f,screenReader:!!i.app.accessibilitySupportEnabled,gpuFeatureStatus:i.app.getGPUFeatureStatus()}}async d(d){const f=await this.f(d),y=(0,l.$sg)(d.win);return this.e(y,f,d.remoteAuthority)}e(d,f=[],y){return{id:d.id,pid:d.webContents.getOSProcessId(),title:d.getTitle(),folderURIs:f,remoteAuthority:y}}async f(d){const f=[],y=d.openedWorkspace;if((0,I.$Si)(y))f.push(y.uri);else if((0,I.$Xi)(y)){const k=await this.b.resolveLocalWorkspace(y.configPath);k&&k.folders.forEach(E=>{f.push(E.uri)})}return f}};e.$yhc=$,e.$yhc=$=ke([re(0,O.$Zgc),re(1,b.$_gc),re(2,m.$dk)],$)}),define(le[66],ue([0,1,26,44,13,27,157,54,4,2,11,9,3,7,115,94,23,116,10,53,20,6,19,5,28,77,29,30,59,17,215,205,85,15,16,137,49]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p,d,f,y,k,g,E,S,s,a,t,o,n,c,h,P,w,D,L,R,T,j,G,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nhc=e.$Mhc=void 0,i=Ie(i),e.$Mhc=(0,s.$Ii)("nativeHostMainService");let Q=class extends l.$Xc{constructor(V,Y,B,_,C,W,F,H,ne,x,ce,oe){super(),this.a=V,this.b=Y,this.c=B,this.f=_,this.g=C,this.h=W,this.j=F,this.m=H,this.n=ne,this.r=x,this.s=ce,this.t=oe,this.onDidOpenMainWindow=b.Event.map(this.a.onDidOpenWindow,J=>J.id),this.onDidTriggerWindowSystemContextMenu=b.Event.any(b.Event.map(this.a.onDidTriggerSystemContextMenu,({window:J,x:M,y:Z})=>({windowId:J.id,x:M,y:Z})),b.Event.map(this.b.onDidTriggerSystemContextMenu,({window:J,x:M,y:Z})=>({windowId:J.id,x:M,y:Z}))),this.onDidMaximizeWindow=b.Event.any(b.Event.map(this.a.onDidMaximizeWindow,J=>J.id),b.Event.map(this.b.onDidMaximizeWindow,J=>J.id)),this.onDidUnmaximizeWindow=b.Event.any(b.Event.map(this.a.onDidUnmaximizeWindow,J=>J.id),b.Event.map(this.b.onDidUnmaximizeWindow,J=>J.id)),this.onDidChangeWindowFullScreen=b.Event.any(b.Event.map(this.a.onDidChangeFullScreen,J=>({windowId:J.window.id,fullscreen:J.fullscreen})),b.Event.map(this.b.onDidChangeFullScreen,J=>({windowId:J.window.id,fullscreen:J.fullscreen}))),this.onDidBlurMainWindow=b.Event.filter(b.Event.fromNodeEventEmitter(v.app,"browser-window-blur",(J,M)=>M.id),J=>!!this.a.getWindowById(J)),this.onDidFocusMainWindow=b.Event.any(b.Event.map(b.Event.filter(b.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),J=>!!J),J=>J.id),b.Event.filter(b.Event.fromNodeEventEmitter(v.app,"browser-window-focus",(J,M)=>M.id),J=>!!this.a.getWindowById(J))),this.onDidBlurMainOrAuxiliaryWindow=b.Event.any(this.onDidBlurMainWindow,b.Event.map(b.Event.filter(b.Event.fromNodeEventEmitter(v.app,"browser-window-blur",(J,M)=>this.b.getWindowByWebContents(M.webContents)),J=>!!J),J=>J.id)),this.onDidFocusMainOrAuxiliaryWindow=b.Event.any(this.onDidFocusMainWindow,b.Event.map(b.Event.filter(b.Event.fromNodeEventEmitter(v.app,"browser-window-focus",(J,M)=>this.b.getWindowByWebContents(M.webContents)),J=>!!J),J=>J.id)),this.onDidResumeOS=b.Event.fromNodeEventEmitter(v.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.u=this.B(new b.$oe),this.onDidChangePassword=this.u.event,this.onDidChangeDisplay=b.Event.debounce(b.Event.any(b.Event.filter(b.Event.fromNodeEventEmitter(v.screen,"display-metrics-changed",(J,M,Z)=>Z),J=>!(Array.isArray(J)&&J.length===1&&J[0]==="workArea")),b.Event.fromNodeEventEmitter(v.screen,"display-added"),b.Event.fromNodeEventEmitter(v.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(V,Y){const B=this.a.getWindows().map(C=>({id:C.id,workspace:C.openedWorkspace??(0,h.$Wi)(C.backupPath,C.isExtensionDevelopmentHost),title:C.win?.getTitle()??"",filename:C.getRepresentedFilename(),dirty:C.isDocumentEdited()})),_=[];return Y.includeAuxiliaryWindows&&_.push(...this.b.getWindows().map(C=>({id:C.id,parentId:C.parentId,title:C.win?.getTitle()??"",filename:C.getRepresentedFilename()}))),[...B,..._]}async getWindowCount(V){return this.a.getWindowCount()}async getActiveWindowId(V){const Y=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(Y)return Y.id}async getActiveWindowPosition(){const V=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(V)return V.getBounds()}openWindow(V,Y,B){return Array.isArray(Y)?this.w(V,Y,B):this.z(V,Y)}async w(V,Y,B=Object.create(null)){Y.length>0&&await this.a.open({context:c.OpenContext.API,contextWindowId:V,urisToOpen:Y,cli:this.g.args,forceNewWindow:B.forceNewWindow,forceReuseWindow:B.forceReuseWindow,preferNewWindow:B.preferNewWindow,diffMode:B.diffMode,mergeMode:B.mergeMode,addMode:B.addMode,gotoLineMode:B.gotoLineMode,noRecentEntry:B.noRecentEntry,waitMarkerFileURI:B.waitMarkerFileURI,remoteAuthority:B.remoteAuthority||void 0,forceProfile:B.forceProfile,forceTempProfile:B.forceTempProfile})}async z(V,Y){await this.a.openEmptyWindow({context:c.OpenContext.API,contextWindowId:V},Y)}async isFullScreen(V,Y){return this.H(Y?.targetWindowId,V)?.isFullScreen??!1}async toggleFullScreen(V,Y){this.H(Y?.targetWindowId,V)?.toggleFullScreen()}async handleTitleDoubleClick(V,Y){this.H(Y?.targetWindowId,V)?.handleTitleDoubleClick()}async getCursorScreenPoint(V){const Y=v.screen.getCursorScreenPoint(),B=v.screen.getDisplayNearestPoint(Y);return{point:Y,display:B.bounds}}async isMaximized(V,Y){return this.H(Y?.targetWindowId,V)?.win?.isMaximized()??!1}async maximizeWindow(V,Y){this.H(Y?.targetWindowId,V)?.win?.maximize()}async unmaximizeWindow(V,Y){this.H(Y?.targetWindowId,V)?.win?.unmaximize()}async minimizeWindow(V,Y){this.H(Y?.targetWindowId,V)?.win?.minimize()}async moveWindowTop(V,Y){this.H(Y?.targetWindowId,V)?.win?.moveTop()}async positionWindow(V,Y,B){const _=this.H(B?.targetWindowId,V);if(_?.win){if(_.win.isFullScreen()){const C=b.Event.toPromise(b.Event.once(b.Event.fromNodeEventEmitter(_.win,"leave-full-screen")));_.win.setFullScreen(!1),await C}_.win.setBounds(Y)}}async updateWindowControls(V,Y){this.H(Y?.targetWindowId,V)?.updateWindowControls(Y)}async focusWindow(V,Y){this.H(Y?.targetWindowId,V)?.focus({force:Y?.force??!1})}async setMinimumSize(V,Y,B){const _=this.I(V);if(_?.win){const[C,W]=_.win.getSize(),[F,H]=_.win.getMinimumSize(),[ne,x]=[Y??F,B??H],[ce,oe]=[Math.max(C,ne),Math.max(W,x)];(F!==ne||H!==x)&&_.win.setMinimumSize(ne,x),(C!==ce||W!==oe)&&_.win.setSize(ce,oe)}}async saveWindowSplash(V,Y){this.m.saveWindowSplash(V,Y)}async installShellCommand(V){const{source:Y,target:B}=await this.C();try{const{symbolicLink:_}=await y.SymlinkSupport.stat(Y);if(_&&!_.dangling){const C=await(0,d.$tr)(Y);if(B===C)return}await i.promises.unlink(Y)}catch(_){if(_.code!=="ENOENT")throw _}try{await i.promises.symlink(B,Y)}catch(_){if(_.code!=="EACCES"&&_.code!=="ENOENT")throw _;const{response:C}=await this.showMessageBox(V,{type:"info",message:(0,g.localize)(2004,null,this.j.nameShort),buttons:[(0,g.localize)(2005,null),(0,g.localize)(2006,null)]});if(C===1)throw new T.$7;try{const W=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${B}' '${Y}'\\" with administrator privileges"`;await(0,O.promisify)(r.exec)(W)}catch{throw new Error((0,g.localize)(2007,null,Y))}}}async uninstallShellCommand(V){const{source:Y}=await this.C();try{await i.promises.unlink(Y)}catch(B){switch(B.code){case"EACCES":{const{response:_}=await this.showMessageBox(V,{type:"info",message:(0,g.localize)(2008,null,this.j.nameShort),buttons:[(0,g.localize)(2009,null),(0,g.localize)(2010,null)]});if(_===1)throw new T.$7;try{const C=`osascript -e "do shell script \\"rm '${Y}'\\" with administrator privileges"`;await(0,O.promisify)(r.exec)(C)}catch{throw new Error((0,g.localize)(2011,null,Y))}break}case"ENOENT":break;default:throw B}}}async C(){const V=(0,u.$nc)(this.g.appRoot,"bin","code"),Y=`/usr/local/bin/${this.j.applicationName}`;if(!await y.Promises.exists(V))throw new Error((0,g.localize)(2012,null,V));return{source:Y,target:V}}async showMessageBox(V,Y){const B=this.H(Y?.targetWindowId,V);return this.c.showMessageBox(Y,B?.win??void 0)}async showSaveDialog(V,Y){const B=this.H(Y?.targetWindowId,V);return this.c.showSaveDialog(Y,B?.win??void 0)}async showOpenDialog(V,Y){const B=this.H(Y?.targetWindowId,V);return this.c.showOpenDialog(Y,B?.win??void 0)}async pickFileFolderAndOpen(V,Y){const B=await this.c.pickFileFolder(Y);B&&await this.D(await Promise.all(B.map(async _=>await y.SymlinkSupport.existsDirectory(_)?{folderUri:p.URI.file(_)}:{fileUri:p.URI.file(_)})),Y,V)}async pickFolderAndOpen(V,Y){const B=await this.c.pickFolder(Y);B&&await this.D(B.map(_=>({folderUri:p.URI.file(_)})),Y,V)}async pickFileAndOpen(V,Y){const B=await this.c.pickFile(Y);B&&await this.D(B.map(_=>({fileUri:p.URI.file(_)})),Y,V)}async pickWorkspaceAndOpen(V,Y){const B=await this.c.pickWorkspace(Y);B&&await this.D(B.map(_=>({workspaceUri:p.URI.file(_)})),Y,V)}async D(V,Y,B){await this.a.open({context:c.OpenContext.DIALOG,contextWindowId:B,cli:this.g.args,urisToOpen:V,forceNewWindow:Y.forceNewWindow})}async showItemInFolder(V,Y){v.shell.showItemInFolder(Y)}async setRepresentedFilename(V,Y,B){this.H(B?.targetWindowId,V)?.setRepresentedFilename(Y)}async setDocumentEdited(V,Y,B){this.H(B?.targetWindowId,V)?.setDocumentEdited(Y)}async openExternal(V,Y,B){this.g.unsetSnapExportedVariables();try{(0,m.$Sg)(Y,m.Schemas.http,m.Schemas.https)?this.F(Y,B):v.shell.openExternal(Y)}finally{this.g.restoreSnapExportedVariables()}return!0}async F(V,Y){const B=Y??this.r.getValue("workbench.externalBrowser");if(!B)return v.shell.openExternal(V);if((B.includes(u.$jc.sep)||B.includes(u.$ic.sep))&&!await y.Promises.exists(B))return this.h.error(`Configured external browser path does not exist: ${B}`),v.shell.openExternal(V);try{const{default:_}=await new Promise((W,F)=>{K(["open"],W,F)}).then(Ie);(await _(V,{app:{name:Object.hasOwn(_.apps,B)?_.apps[B]:B}})).stderr?.once("data",W=>(this.h.error(`Error openening external URL '${V}' using browser '${B}': ${W.toString()}`),v.shell.openExternal(V)))}catch(_){return this.h.error(`Unable to open external URL '${V}' using browser '${B}' due to ${_}.`),v.shell.openExternal(V)}}moveItemToTrash(V,Y){return v.shell.trashItem(Y)}async isAdmin(){let V;return $.$j?V=(await new Promise((Y,B)=>{K(["native-is-elevated"],Y,B)}).then(Ie)).default():V=process.getuid?.()===0,V}async writeElevated(V,Y,B,_){const C=await new Promise((W,F)=>{K(["@vscode/sudo-prompt"],W,F)}).then(Ie);return new Promise((W,F)=>{const H=[`"${this.G}"`];_?.unlock&&H.push("--file-chmod"),H.push("--file-write",`"${Y.fsPath}"`,`"${B.fsPath}"`);const ne={name:this.j.nameLong.replace("-",""),icns:$.$k&&this.g.isBuilt?(0,u.$mc)((0,u.$pc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};C.exec(H.join(" "),ne,(x,ce,oe)=>{ce&&this.h.trace(`[sudo-prompt] received stdout: ${ce}`),oe&&this.h.trace(`[sudo-prompt] received stderr: ${oe}`),x?F(x):W(void 0)})})}async isRunningUnderARM64Translation(){return $.$l||$.$j?!1:v.app.runningUnderARM64Translation}get G(){return $.$j?this.g.isBuilt?(0,u.$mc)((0,u.$pc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,u.$mc)(this.g.appRoot,"scripts","code-cli.bat"):$.$l?this.g.isBuilt?(0,u.$mc)((0,u.$pc)(process.execPath),"bin",`${this.j.applicationName}`):(0,u.$mc)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,u.$mc)(this.g.appRoot,"bin","code"):(0,u.$mc)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,A.totalmem)(),freemem:(0,A.freemem)(),loadavg:(0,A.loadavg)()}}async getOSProperties(){return{arch:(0,A.arch)(),platform:(0,A.platform)(),release:(0,A.release)(),type:(0,A.type)(),cpus:(0,A.cpus)()}}async getOSVirtualMachineHint(){return f.$Wn.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return $.$j&&(0,D.$Jhc)()}async getProcessId(V){return this.H(void 0,V)?.win?.webContents.getOSProcessId()}async killProcess(V,Y,B){process.kill(Y,B)}async readClipboardText(V,Y){return v.clipboard.readText(Y)}async writeClipboardText(V,Y,B){return v.clipboard.writeText(Y,B)}async readClipboardFindText(V){return v.clipboard.readFindText()}async writeClipboardFindText(V,Y){return v.clipboard.writeFindText(Y)}async writeClipboardBuffer(V,Y,B,_){return v.clipboard.writeBuffer(Y,Buffer.from(B.buffer),_)}async readClipboardBuffer(V,Y){return w.$Qe.wrap(v.clipboard.readBuffer(Y))}async hasClipboard(V,Y,B){return v.clipboard.has(Y,B)}async newWindowTab(){await this.a.open({context:c.OpenContext.API,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){v.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){v.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){v.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){v.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){v.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(V,Y){this.I(V)?.updateTouchBar(Y)}async notifyReady(V){this.I(V)?.setReady()}async relaunch(V,Y){return this.f.relaunch(Y)}async reload(V,Y){const B=this.I(V);if(B){if((0,h.$Xi)(B.openedWorkspace)){const _=B.openedWorkspace.configPath;if(_.scheme===m.Schemas.file&&(await this.n.resolveLocalWorkspace(_))?.transient)return this.openWindow(B.id,{forceReuseWindow:!0})}return this.f.reload(B,Y?.disableExtensions!==void 0?{_:[],"disable-extensions":Y.disableExtensions}:void 0)}}async closeWindow(V,Y){return this.H(Y?.targetWindowId,V)?.win?.close()}async quit(V){const Y=this.a.getLastActiveWindow();Y?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&Y.win?Y.win.close():this.f.quit()}async exit(V,Y){await this.f.kill(Y)}async resolveProxy(V,Y){if(this.g.extensionTestsLocationURI){const C=this.r.getValue("integration-test.http.proxy");if(C)return C}return this.I(V)?.win?.webContents?.session?.resolveProxy(Y)}async lookupAuthorization(V,Y){return this.t.lookupAuthorization(Y)}async lookupKerberosAuthorization(V,Y){return this.s.lookupKerberosAuthorization(Y)}async loadCertificates(V){return this.s.loadCertificates()}findFreePort(V,Y,B,_,C=1){return(0,k.$7g)(Y,B,_,C)}async openDevTools(V,Y){this.H(Y?.targetWindowId,V)?.win?.webContents.openDevTools(Y?.mode?{mode:Y.mode,activate:Y.activate}:void 0)}async toggleDevTools(V,Y){this.H(Y?.targetWindowId,V)?.win?.webContents.toggleDevTools()}async profileRenderer(V,Y,B){const _=this.I(V);if(!_||!_.win)throw new Error;return await new L.$Khc(_.win,Y,this.h).inspect(B)}async windowsGetStringRegKey(V,Y,B,_){if(!$.$j)return;const C=await new Promise((W,F)=>{K(["@vscode/windows-registry"],W,F)}).then(Ie);try{return C.GetStringRegKey(Y,B,_)}catch{return}}H(V,Y){return this.I(V)??this.J(V)??this.I(Y)}I(V){if(typeof V=="number")return this.a.getWindowById(V)}J(V){if(typeof V!="number")return;const Y=v.webContents.fromId(V);if(Y)return this.b.getWindowByWebContents(Y)}};e.$Nhc=Q,ke([I.$ai],Q.prototype,"G",null),e.$Nhc=Q=ke([re(0,c.$Zgc),re(1,R.$Lhc),re(2,E.$Ugc),re(3,a.$ghc),re(4,S.$Mgc),re(5,t.$dk),re(6,o.$wk),re(7,n.$Xgc),re(8,P.$_gc),re(9,j.$cj),re(10,q.$_p),re(11,G.$qhc)],Q)});var xe=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[272],ue([0,1,13,27,8,22,2,11,3,35,10,53,20,5,66,63,74,51,29,67,86]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p,d,f,y,k,g,E,S){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ohc=void 0,f=xe(f);let a=class{static{s=this}static{this.a="#1E1E1E"}constructor(o,n,c,h,P,w,D,L){this.d=o,this.e=n,this.f=c,this.g=h,this.h=P,this.i=w,this.j=D,this.k=L,this.b=null,this.c=null}async openReporter(o){if(this.b)this.b&&this.l(this.b);else if(this.c=i.BrowserWindow.getFocusedWindow(),this.c){const n=new O.$Wc,c=n.add(this.i.createIPCObjectUrl()),h=this.n(this.c,700,800);this.b=this.m(h,c,{backgroundColor:o.styles.backgroundColor,title:(0,m.localize)(1909,null),zoomLevel:o.zoomLevel,alwaysOnTop:!1},"issue-reporter"),c.update({appRoot:this.e.appRoot,windowId:this.b.id,userEnv:this.d,data:o,disableExtensions:!!this.e.disableExtensions,os:{type:(0,r.type)(),arch:(0,r.arch)(),release:(0,r.release)()},product:f.default,nls:{messages:globalThis._VSCODE_NLS_MESSAGES,language:globalThis._VSCODE_NLS_LANGUAGE},cssModules:this.k.isEnabled?await this.k.getCssModules():void 0}),this.b.loadURL(I.$3g.asBrowserUri(`vs/workbench/contrib/issue/electron-sandbox/issueReporter${this.e.isBuilt?"":"-dev"}.${E.$T?"esm.":""}html`).toString(!0)),this.b.on("close",()=>{this.b=null,n.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,n.dispose())})}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.h.reload(this.c.id,{disableExtensions:!0})}catch(o){this.f.error(o)}}async $showConfirmCloseDialog(){if(this.b){const{response:o}=await this.g.showMessageBox({type:"warning",message:(0,m.localize)(1910,null),buttons:[(0,m.localize)(1911,null),(0,m.localize)(1912,null)]},this.b);o===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:o}=await this.g.showMessageBox({type:"warning",message:(0,m.localize)(1913,null),buttons:[(0,m.localize)(1914,null),(0,m.localize)(1915,null)]},this.b);return o===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const o=this.j.getWindowById(this.c.id);if(!o)throw new Error("Window not found");return o}async $sendReporterMenu(o,n){const c=this.issueReporterWindowCheck(),h="vscode:triggerReporterMenu",P=new A.$ze;return c.sendWhenReady(h,P.token,{replyChannel:h,extensionId:o,extensionName:n}),await(0,v.$zh)(new Promise(D=>l.$gY.once(`vscode:triggerReporterMenuResponse:${o}`,(L,R)=>D(R))),5e3,()=>{this.f.error(`Error: Extension ${o} timed out waiting for menu response`),P.cancel()})}async $closeReporter(){this.b?.close()}l(o){o.isMinimized()&&o.restore(),o.focus()}m(o,n,c,h){const P=new i.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:o.width,height:o.height,minWidth:300,minHeight:200,x:o.x,y:o.y,title:c.title,backgroundColor:c.backgroundColor||s.a,webPreferences:{preload:I.$3g.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${n.resource.toString()}`],v8CacheOptions:this.e.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,k.$xE)(c.zoomLevel),sandbox:!0},alwaysOnTop:c.alwaysOnTop,experimentalDarkMode:!0});return P.setMenuBarVisibility(!1),P}n(o,n,c){let h;const P=i.screen.getAllDisplays();if(P.length===1)h=P[0];else{if(b.$k){const L=i.screen.getCursorScreenPoint();h=i.screen.getDisplayNearestPoint(L)}!h&&o&&(h=i.screen.getDisplayMatching(o.getBounds())),h||(h=i.screen.getPrimaryDisplay()||P[0])}const w=h.bounds,D={width:n,height:c,x:w.x+w.width/2-n/2,y:w.y+w.height/2-c/2};return w.width>0&&w.height>0&&(D.x<w.x&&(D.x=w.x),D.y<w.y&&(D.y=w.y),D.x>w.x+w.width&&(D.x=w.x),D.y>w.y+w.height&&(D.y=w.y),D.width>w.width&&(D.width=w.width),D.height>w.height&&(D.height=w.height)),D}};e.$Ohc=a,e.$Ohc=a=s=ke([re(1,$.$Mgc),re(2,p.$dk),re(3,u.$Ugc),re(4,d.$Mhc),re(5,y.$Wgc),re(6,g.$Zgc),re(7,S.$aS)],a)});var xe=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[273],ue([0,1,13,32,2,11,3,118,35,10,99,138,53,20,86,5,66,63,28,74,34,65,51,67]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p,d,f,y,k,g,E,S,s,a,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Phc=void 0,k=xe(k);const n="issue.processExplorerWindowState";let c=class{static{o=this}static{this.a="#1E1E1E"}constructor(w,D,L,R,T,j,G,q,Q,de,V){this.d=w,this.f=D,this.g=L,this.h=R,this.i=T,this.j=j,this.k=G,this.l=q,this.m=Q,this.n=de,this.o=V,this.b=null,this.c=null,this.p()}p(){b.$gY.on("vscode:listProcesses",async w=>{const D=[];try{D.push({name:(0,l.localize)(1916,null),rootProcess:await(0,I.$4s)(process.pid)}),(await this.i.getRemoteDiagnostics({includeProcesses:!0})).forEach(R=>{(0,m.$Xm)(R)?D.push({name:R.hostName,rootProcess:R}):R.processes&&D.push({name:R.hostName,rootProcess:R.processes})})}catch(L){this.g.error(`Listing processes failed: ${L}`)}this.t(w,"vscode:listProcessesResponse",D)}),b.$gY.on("vscode:workbenchCommand",(w,D)=>{const{id:L,from:R,args:T}=D;let j;switch(R){case"processExplorer":j=this.c;break;default:throw new Error(`Unexpected command source: ${R}`)}j?.webContents.send("vscode:runAction",{id:L,from:R,args:T})}),b.$gY.on("vscode:closeProcessExplorer",w=>{this.b?.close()}),b.$gY.on("vscode:pidToNameRequest",async w=>{const D=await this.i.getMainDiagnostics(),L=[];for(const R of D.windows)L.push([R.pid,`window [${R.id}] (${R.title})`]);for(const{pid:R,name:T}of s.$uhc.getAll())L.push([R,T]);this.t(w,"vscode:pidToNameResponse",L)})}async openProcessExplorer(w){if(!this.b&&(this.c=i.BrowserWindow.getFocusedWindow(),this.c)){const D=new v.$Wc,L=D.add(this.l.createIPCObjectUrl()),R=this.n.getItem(n,void 0),T=h(R)?R:this.r(this.c,800,500);this.b=this.s(T,L,{backgroundColor:w.styles.backgroundColor,title:(0,l.localize)(1917,null),zoomLevel:w.zoomLevel,alwaysOnTop:!0},"process-explorer"),L.update({appRoot:this.f.appRoot,windowId:this.b.id,userEnv:this.d,data:w,product:k.default,nls:{messages:globalThis._VSCODE_NLS_MESSAGES,language:globalThis._VSCODE_NLS_LANGUAGE},cssModules:this.o.isEnabled?await this.o.getCssModules():void 0}),this.b.loadURL(A.$3g.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.f.isBuilt?"":"-dev"}.${t.$T?"esm.":""}html`).toString(!0)),this.b.on("close",()=>{this.b=null,D.dispose()}),this.c.on("close",()=>{this.b&&(this.b.close(),this.b=null,D.dispose())});const j=()=>{if(!this.b)return;const G=this.b.getSize(),q=this.b.getPosition();if(!G||!q)return;const Q={width:G[0],height:G[1],x:q[0],y:q[1]};this.n.setItem(n,Q)};this.b.on("moved",j),this.b.on("resized",j)}this.b&&this.q(this.b)}q(w){w.isMinimized()&&w.restore(),w.focus()}r(w,D,L){let R;const T=i.screen.getAllDisplays();if(T.length===1)R=T[0];else{if(O.$k){const q=i.screen.getCursorScreenPoint();R=i.screen.getDisplayNearestPoint(q)}!R&&w&&(R=i.screen.getDisplayMatching(w.getBounds())),R||(R=i.screen.getPrimaryDisplay()||T[0])}const j=R.bounds,G={width:D,height:L,x:j.x+j.width/2-D/2,y:j.y+j.height/2-L/2};return j.width>0&&j.height>0&&(G.x<j.x&&(G.x=j.x),G.y<j.y&&(G.y=j.y),G.x>j.x+j.width&&(G.x=j.x),G.y>j.y+j.height&&(G.y=j.y),G.width>j.width&&(G.width=j.width),G.height>j.height&&(G.height=j.height)),G}async stopTracing(){if(!this.f.args.trace)return;const w=await i.contentTracing.stopRecording(`${(0,r.$Qg)(this.f.userHome.fsPath,this.m.applicationName)}.trace.txt`);await this.j.showMessageBox({type:"info",message:(0,l.localize)(1918,null),detail:(0,l.localize)(1919,null,w),buttons:[(0,l.localize)(1920,null)]},i.BrowserWindow.getFocusedWindow()??void 0),this.k.showItemInFolder(void 0,w)}async getSystemStatus(){const[w,D]=await Promise.all([this.i.getMainDiagnostics(),this.i.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.h.getDiagnostics(w,D)}async $getSystemInfo(){const[w,D]=await Promise.all([this.i.getMainDiagnostics(),this.i.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.h.getSystemInfo(w,D)}async $getPerformanceInfo(){try{const[w,D]=await Promise.all([this.i.getMainDiagnostics(),this.i.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.h.getPerformanceInfo(w,D)}catch(w){throw this.g.warn("issueService#getPerformanceInfo ",w.message),w}}s(w,D,L,R){const T=new i.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:w.width,height:w.height,minWidth:300,minHeight:200,x:w.x,y:w.y,title:L.title,backgroundColor:L.backgroundColor||o.a,webPreferences:{preload:A.$3g.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${D.resource.toString()}`],v8CacheOptions:this.f.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,a.$xE)(L.zoomLevel),sandbox:!0},alwaysOnTop:L.alwaysOnTop,experimentalDarkMode:!0});return T.setMenuBarVisibility(!1),T}t(w,D,...L){w.sender.isDestroyed()||w.sender.send(D,...L)}async closeProcessExplorer(){this.b?.close()}};e.$Phc=c,e.$Phc=c=o=ke([re(1,p.$Mgc),re(2,f.$dk),re(3,m.$Wm),re(4,u.$xhc),re(5,$.$Ugc),re(6,y.$Mhc),re(7,E.$Wgc),re(8,g.$wk),re(9,S.$VR),re(10,d.$aS)],c);function h(P){return typeof P!="object"||P===null?!1:"x"in P&&"y"in P&&"width"in P&&"height"in P}}),define(le[274],ue([0,1,22,16,20,19,5,66,28,49,24,50,108]),function(K,e,i,r,v,A,O,I,b,l,m,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eic=void 0;let p=class extends $.$cic{constructor(f,y,k,g,E,S,s,a){super(f,y,g,E,S,a),this.e=k,this.u=s}s(f){return(0,$.$bic)(`linux-${process.arch}`,f,this.k)}t(f){this.a&&(this.d(u.$eZ.CheckingForUpdates(f)),this.i.request({url:this.a},i.CancellationToken.None).then(l.$fq).then(y=>{!y||!y.url||!y.version||!y.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!f}),this.d(u.$eZ.Idle(u.UpdateType.Archive))):this.d(u.$eZ.AvailableForDownload(y))}).then(void 0,y=>{this.j.error(y);const k=f?y.message||y:void 0;this.d(u.$eZ.Idle(u.UpdateType.Archive,k))}))}async o(f){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):f.update.url&&this.u.openExternal(void 0,f.update.url),this.d(u.$eZ.Idle(u.UpdateType.Archive))}};e.$eic=p,e.$eic=p=ke([re(0,A.$ghc),re(1,r.$cj),re(2,m.$cm),re(3,v.$Mgc),re(4,l.$_p),re(5,O.$dk),re(6,I.$Mhc),re(7,b.$wk)],p)}),define(le[275],ue([0,1,44,26,27,8,22,54,47,9,7,155,23,16,20,14,19,5,66,28,49,24,50,108]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p,d,f,y,k,g,E,S,s,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gic=void 0,r=Ie(r),l=Ie(l),$=Ie($);async function o(P,w=1e3){for(;!P();)await(0,A.$Jh)(w)}let n;function c(){return typeof n>"u"&&(n=r.existsSync(l.$mc(l.$pc(process.execPath),"unins000.exe"))?a.UpdateType.Setup:a.UpdateType.Archive),n}let h=class extends t.$cic{get cachePath(){const w=l.$mc((0,v.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return r.promises.mkdir(w,{recursive:!0}).then(()=>w)}constructor(w,D,L,R,T,j,G,q,Q){super(w,D,R,T,j,Q),this.u=L,this.v=G,this.w=q,w.setRelaunchHandler(this)}handleRelaunch(w){return w?.addArgs||w?.removeArgs||this.state.type!==a.StateType.Ready||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(a.$eZ.Disabled(a.DisablementReason.RunningAsAdmin)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(w){let D=`win32-${process.arch}`;return c()===a.UpdateType.Archive?D+="-archive":this.k.target==="user"&&(D+="-user"),(0,t.$bic)(D,w,this.k)}t(w){this.a&&(this.d(a.$eZ.CheckingForUpdates(w)),this.i.request({url:this.a},O.CancellationToken.None).then(S.$fq).then(D=>{const L=c();return!D||!D.url||!D.version||!D.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!w}),this.d(a.$eZ.Idle(L)),Promise.resolve(null)):L===a.UpdateType.Archive?(this.d(a.$eZ.AvailableForDownload(D)),Promise.resolve(null)):(this.d(a.$eZ.Downloading),this.C(D.version).then(()=>this.B(D.version).then(R=>$.Promises.exists(R).then(T=>{if(T)return Promise.resolve(R);const j=`${R}.tmp`;return this.i.request({url:D.url},O.CancellationToken.None).then(G=>this.v.writeFile(m.URI.file(j),G.stream)).then(D.sha256hash?()=>(0,u.$_X)(j,D.sha256hash):()=>{}).then(()=>$.Promises.rename(j,R,!1)).then(()=>R)})).then(R=>{this.e={packagePath:R},this.d(a.$eZ.Downloaded(D)),this.g.getValue("update.enableWindowsBackgroundUpdates")?this.k.target==="user"&&this.p():this.d(a.$eZ.Ready(D))})))}).then(void 0,D=>{this.u.publicLog2("update:error",{messageHash:String((0,b.$wj)(String(D)))}),this.j.error(D);const L=w?D.message||D:void 0;this.d(a.$eZ.Idle(c(),L))}))}async o(w){w.update.url&&this.w.openExternal(void 0,w.update.url),this.d(a.$eZ.Idle(c()))}async B(w){const D=await this.cachePath;return l.$mc(D,`CodeSetup-${this.k.quality}-${w}.exe`)}async C(w=null){const D=w?j=>!new RegExp(`${this.k.quality}-${w}\\.exe$`).test(j):()=>!0,L=await this.cachePath,T=(await $.Promises.readdir(L)).filter(D).map(async j=>{try{await r.promises.unlink(l.$mc(L,j))}catch{}});await Promise.all(T)}async p(){if(this.state.type!==a.StateType.Downloaded||!this.e)return Promise.resolve(void 0);const w=this.state.update;this.d(a.$eZ.Updating(w));const D=await this.cachePath;this.e.updateFilePath=l.$mc(D,`CodeSetup-${this.k.quality}-${w.version}.flag`),await $.Promises.writeFile(this.e.updateFilePath,"flag"),(0,i.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(a.$eZ.Idle(c()))});const R=`${this.k.win32MutexName}-ready`,T=await new Promise((j,G)=>{K(["@vscode/windows-mutex"],j,G)}).then(Ie);o(()=>T.isActive(R)).then(()=>this.d(a.$eZ.Ready(w)))}r(){this.state.type!==a.StateType.Ready||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?r.unlinkSync(this.e.updateFilePath):(0,i.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return c()}async _applySpecificUpdate(w){if(this.state.type!==a.StateType.Idle)return;const D=this.g.getValue("update.enableWindowsBackgroundUpdates"),L={version:"unknown",productVersion:"unknown"};this.d(a.$eZ.Downloading),this.e={packagePath:w},this.d(a.$eZ.Downloaded(L)),D?this.k.target==="user"&&this.p():this.d(a.$eZ.Ready(L))}};e.$gic=h,ke([I.$ai],h.prototype,"cachePath",null),e.$gic=h=ke([re(0,y.$ghc),re(1,p.$cj),re(2,s.$cm),re(3,d.$Mgc),re(4,S.$_p),re(5,k.$dk),re(6,f.$dl),re(7,g.$Mhc),re(8,E.$wk)],h)});var xe=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[139],ue([0,1,13,8,22,55,4,2,11,72,3,7,10,27,71,16,53,20,70,14,19,5,28,74,251,89,24,113,77,51,29,30,59,52,40,34,58,73,21,6,67]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p,d,f,y,k,g,E,S,s,a,t,o,n,c,h,P,w,D,L,R,T,j,G,q,Q,de,V,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ehc=e.$dhc=void 0,i=xe(i);var B;(function(W){W[W.NONE=0]="NONE",W[W.NAVIGATING=1]="NAVIGATING",W[W.READY=2]="READY"})(B||(B={}));class _ extends I.$Xc{get lastFocusTime(){return this.j}get win(){return this.m}n(F,H){this.m=F,this.B(O.Event.fromNodeEventEmitter(F,"maximize")(()=>this.b.fire())),this.B(O.Event.fromNodeEventEmitter(F,"unmaximize")(()=>this.c.fire())),this.B(O.Event.fromNodeEventEmitter(F,"closed")(()=>{this.a.fire(),this.dispose()})),this.B(O.Event.fromNodeEventEmitter(F,"focus")(()=>{this.j=Date.now()})),this.B(O.Event.fromNodeEventEmitter(this.m,"enter-full-screen")(()=>this.g.fire())),this.B(O.Event.fromNodeEventEmitter(this.m,"leave-full-screen")(()=>this.h.fire()));const ne=!(0,w.$sE)(this.r,H?.titleBarStyle==="hidden"?w.TitlebarStyle.CUSTOM:void 0);if(m.$k&&ne&&F.setSheetOffset((0,m.$K)((0,p.release)())?28:22),ne&&((0,w.$vE)(this.r)||m.$k)){const x=this.s.getItem(_.D);x?this.updateWindowControls({height:x}):this.updateWindowControls({height:w.$uE})}m.$j&&ne&&F.hookWindowMessage(278,()=>{const[ce,oe]=F.getPosition(),J=i.default.screen.getCursorScreenPoint(),M=J.x-ce,Z=J.y-oe;return!(M>30&&Z>=0&&Z<=Math.max(F.getBounds().height*.15,35))||(F.setEnabled(!1),F.setEnabled(!0),this.f.fire({x:M,y:Z})),0}),this.t.args["open-devtools"]===!0&&F.webContents.openDevTools(),m.$k&&(this.B(this.onDidEnterFullScreen(()=>{this.H?.complete(!0)})),this.B(this.onDidLeaveFullScreen(()=>{this.H?.complete(!0)})))}constructor(F,H,ne,x){super(),this.r=F,this.s=H,this.t=ne,this.u=x,this.a=this.B(new O.$oe),this.onDidClose=this.a.event,this.b=this.B(new O.$oe),this.onDidMaximize=this.b.event,this.c=this.B(new O.$oe),this.onDidUnmaximize=this.c.event,this.f=this.B(new O.$oe),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new O.$oe),this.onDidEnterFullScreen=this.g.event,this.h=this.B(new O.$oe),this.onDidLeaveFullScreen=this.h.event,this.j=Date.now(),this.m=null,this.F=(0,w.$vE)(this.r),this.G=void 0,this.H=void 0}w(F,H=i.default.screen.getAllDisplays().length>0){const ne=this.r.getValue("window"),x=m.$k&&ne?.nativeTabs===!0;(m.$k||m.$j)&&H&&(!x||i.default.BrowserWindow.getAllWindows().length===1)&&[F.width,F.height,F.x,F.y].every(ce=>typeof ce=="number")&&this.m?.setBounds({width:F.width,height:F.height,x:F.x,y:F.y}),(F.mode===T.WindowMode.Maximized||F.mode===T.WindowMode.Fullscreen)&&(this.m?.maximize(),F.mode===T.WindowMode.Fullscreen&&this.I(!0,!0),this.m?.show())}setRepresentedFilename(F){m.$k?this.win?.setRepresentedFilename(F):this.z=F}getRepresentedFilename(){return m.$k?this.win?.getRepresentedFilename():this.z}setDocumentEdited(F){m.$k&&this.win?.setDocumentEdited(F),this.C=F}isDocumentEdited(){return m.$k?!!this.win?.isDocumentEdited():!!this.C}focus(F){m.$k&&F?.force&&i.default.app.focus({steal:!0});const H=this.win;H&&(H.isMinimized()&&H.restore(),H.focus())}handleTitleDoubleClick(){const F=this.win;if(F)if(m.$k)switch(i.default.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":F.minimize();break;case"None":break;case"Maximize":default:F.isMaximized()?F.unmaximize():F.maximize()}else F.isMaximized()?F.unmaximize():F.maximize()}static{this.D="windowControlHeight"}updateWindowControls(F){const H=this.win;if(H){if(F.height&&this.s.setItem(C.D,F.height),this.F)H.setTitleBarOverlay({color:F.backgroundColor?.trim()===""?void 0:F.backgroundColor,symbolColor:F.foregroundColor?.trim()===""?void 0:F.foregroundColor,height:F.height?F.height-1:void 0});else if(m.$k&&F.height!==void 0){const ne=(F.height-15)/2;ne?H.setWindowButtonPosition({x:ne,y:ne}):H.setWindowButtonPosition(null)}}}toggleFullScreen(){this.I(!this.isFullScreen,!1)}I(F,H){(0,w.$wE)(this.r)?this.J(F,H):this.M(F)}get isFullScreen(){if(m.$k&&typeof this.G=="boolean")return this.G;const F=this.win,H=F?.isFullScreen(),ne=F?.isSimpleFullScreen();return!!(H||ne)}J(F,H){const ne=this.win;ne?.isSimpleFullScreen()&&ne?.setSimpleFullScreen(!1),this.L(F,H)}L(F,H){if(m.$k){this.G=F;const x=this.H=new r.$6h;(async()=>{const ce=await Promise.race([x.p,(0,r.$Jh)(1e4).then(()=>!1)]);this.H===x&&(this.G=void 0,this.H=void 0,!ce&&F&&H&&this.win&&!this.win.isFullScreen()&&(this.u.warn("window: native macOS fullscreen transition did not happen within 10s from restoring"),this.h.fire()))})()}this.win?.setFullScreen(F)}M(F){const H=this.win;H?.isFullScreen()&&this.L(!1,!1),H?.setSimpleFullScreen(F),H?.webContents.focus()}dispose(){super.dispose(),this.m=null}}e.$dhc=_;let C=class extends _{get id(){return this.Q}get backupPath(){return this.S?.backupPath}get openedWorkspace(){return this.S?.workspace}get profile(){if(!this.config)return;const F=this.hb.profiles.find(H=>H.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&F?F:this.hb.getProfileForWorkspace(this.config.workspace??(0,L.$Wi)(this.backupPath,this.isExtensionDevelopmentHost))??this.hb.defaultProfile}get remoteAuthority(){return this.S?.remoteAuthority}get config(){return this.S}get isExtensionDevelopmentHost(){return!!this.S?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.S?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.S?.debugId}constructor(F,H,ne,x,ce,oe,J,M,Z,U,N,ie,X,z,te,ae,me,be,ye,Fe,Ve){super(U,Fe,x,H),this.fb=ne,this.gb=ce,this.hb=oe,this.ib=J,this.jb=M,this.kb=Z,this.lb=N,this.mb=ie,this.nb=X,this.ob=z,this.pb=te,this.qb=ae,this.rb=me,this.sb=be,this.tb=ye,this.N=this.B(new O.$oe),this.onWillLoad=this.N.event,this.O=this.B(new O.$oe),this.onDidSignalReady=this.O.event,this.P=this.B(new O.$oe),this.onDidDestroy=this.P.event,this.X=[],this.Y=[],this.Z=void 0,this.$=void 0,this.ab=void 0,this.bb=this.B(this.sb.createIPCObjectUrl()),this.eb=!1,this.ub=B.NONE;{const[Re,$e]=this.Eb(F.state);this.U=Re,this.u.trace("window#ctor: using window state",Re);const ee=Ve.invokeFunction(D.$1gc,this.U,void 0,{preload:b.$3g.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.bb.resource.toString()}`],v8CacheOptions:this.t.useCodeCache?"bypassHeatCheck":"none"});(0,l.mark)("code/willCreateCodeBrowserWindow"),this.m=new i.default.BrowserWindow(ee),(0,l.mark)("code/didCreateCodeBrowserWindow"),this.Q=this.m.id,this.n(this.m,ee),this.w(this.U,$e),this.j=Date.now()}this.Bb(),this.Kb(),this.vb()}setReady(){for(this.u.trace(`window#load: window reported ready (id: ${this.Q})`),this.ub=B.READY;this.X.length;)this.X.pop()(this);this.O.fire()}ready(){return new Promise(F=>{if(this.isReady)return F(this);this.X.push(F)})}get isReady(){return this.ub===B.READY}get whenClosedOrLoaded(){return new Promise(F=>{function H(){ne.dispose(),x.dispose(),F()}const ne=this.onDidClose(()=>H()),x=this.onWillLoad(()=>H())})}vb(){this.B(O.Event.fromNodeEventEmitter(this.m,"unresponsive")(()=>this.yb(T.WindowError.UNRESPONSIVE))),this.B(O.Event.fromNodeEventEmitter(this.m.webContents,"render-process-gone",(H,ne)=>ne)(H=>this.yb(T.WindowError.PROCESS_GONE,{...H}))),this.B(O.Event.fromNodeEventEmitter(this.m.webContents,"did-fail-load",(H,ne,x)=>({exitCode:ne,reason:x}))(({exitCode:H,reason:ne})=>this.yb(T.WindowError.LOAD,{reason:ne,exitCode:H}))),this.B(O.Event.fromNodeEventEmitter(this.m.webContents,"will-prevent-unload")(H=>H.preventDefault())),this.B(O.Event.fromNodeEventEmitter(this.m.webContents,"did-finish-load")(()=>{this.db&&(this.S=this.db,this.db=void 0)})),this.B(this.onDidMaximize(()=>{this.S&&(this.S.maximized=!0)})),this.B(this.onDidUnmaximize(()=>{this.S&&(this.S.maximized=!1)})),this.B(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",v.CancellationToken.None)})),this.B(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",v.CancellationToken.None)})),this.B(this.r.onDidChangeConfiguration(H=>this.Bb(H))),this.B(this.mb.onDidDeleteUntitledWorkspace(H=>this.Ab(H)));const F=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:F},async(H,ne)=>{const x=await this.xb();ne({cancel:!1,requestHeaders:Object.assign(H.requestHeaders,x)})})}xb(){return this.wb||(this.wb=(0,o.$tq)(this.rb.version,this.rb,this.t,this.r,this.ib,this.jb,this.ob)),this.wb}async yb(F,H){switch(F){case T.WindowError.PROCESS_GONE:this.u.error(`CodeWindow: renderer process gone (reason: ${H?.reason||"<unknown>"}, code: ${H?.exitCode||"<unknown>"})`);break;case T.WindowError.UNRESPONSIVE:this.u.error("CodeWindow: detected unresponsive");break;case T.WindowError.LOAD:this.u.error(`CodeWindow: failed to load (reason: ${H?.reason||"<unknown>"}, code: ${H?.exitCode||"<unknown>"})`);break}switch(this.ob.publicLog2("windowerror",{type:F,reason:H?.reason,code:H?.exitCode}),F){case T.WindowError.UNRESPONSIVE:case T.WindowError.PROCESS_GONE:if(this.isExtensionDevelopmentTestFromCli){this.qb.kill(1);return}if(this.t.args["enable-smoke-test-driver"]){await this.zb(!1,!1),this.qb.quit();return}if(F===T.WindowError.UNRESPONSIVE){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:ne,checkboxChecked:x}=await this.pb.showMessageBox({type:"warning",buttons:[(0,$.localize)(2463,null),(0,$.localize)(2464,null),(0,$.localize)(2465,null)],message:(0,$.localize)(2466,null),detail:(0,$.localize)(2467,null),checkboxLabel:this.S?.workspace?(0,$.localize)(2468,null):void 0},this.m);if(ne!==2){const ce=ne===0;await this.zb(ce,x)}}else if(F===T.WindowError.PROCESS_GONE){let ne;H?ne=(0,$.localize)(2470,null,H.reason,H.exitCode??"<unknown>"):ne=(0,$.localize)(2469,null);const{response:x,checkboxChecked:ce}=await this.pb.showMessageBox({type:"warning",buttons:[this.S?.workspace?(0,$.localize)(2471,null):(0,$.localize)(2472,null),(0,$.localize)(2473,null)],message:ne,detail:this.S?.workspace?(0,$.localize)(2474,null):(0,$.localize)(2475,null),checkboxLabel:this.S?.workspace?(0,$.localize)(2476,null):void 0},this.m),oe=x===0;await this.zb(oe,ce)}break}}async zb(F,H){const ne=this.S?.workspace;if(H&&ne)try{const x=this.kb.workspaceStorage(ne);await x.init(),x.delete("memento/workbench.parts.editor"),await x.close()}catch(x){this.u.error(x)}this.P.fire();try{if(F&&this.S){let x,ce;(0,L.$Si)(ne)?x={folderUri:ne.uri}:(0,L.$Xi)(ne)?x={workspaceUri:ne.configPath}:ce=!0,(0,de.$Qb)(await this.tb.open({context:D.OpenContext.API,userEnv:this.S.userEnv,cli:{...this.t.args,_:[]},urisToOpen:x?[x]:void 0,forceEmpty:ce,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this.m?.destroy()}}Ab(F){this.S?.workspace?.id===F.id&&(this.S.workspace=void 0)}Bb(F){if(!F||F.affectsConfiguration("window.menuBarVisibility")){const H=this.Gb();H!==this.W&&(this.W=H,this.Hb(H))}if(!F||F.affectsConfiguration("http.proxy")||F.affectsConfiguration("http.noProxy")){let H=(this.r.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;if(H?.indexOf("@")!==-1){const x=u.URI.parse(H),ce=x.authority.indexOf("@");ce!==-1&&(H=x.with({authority:x.authority.substring(ce+1)}).toString())}H?.endsWith("/")&&(H=H.substr(0,H.length-1));const ne=(this.r.getValue("http.noProxy")||[]).map(x=>x.trim()).join(",")||(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((H||"").indexOf("@")===-1&&(H!==this.Z||ne!==this.$)){this.Z=H,this.$=ne;const x=H||"",ce=ne?`${ne},<local>`:"<local>";this.u.trace(`Setting proxy to '${x}', bypassing '${ce}'`),this.m.webContents.session.setProxy({proxyRules:x,proxyBypassRules:ce,pacScript:""}),i.default.app.setProxy({proxyRules:x,proxyBypassRules:ce,pacScript:""})}}}addTabbedWindow(F){m.$k&&F.win&&this.m.addTabbedWindow(F.win)}load(F,H=Object.create(null)){this.u.trace(`window#load: attempt to load window (id: ${this.Q})`),this.isDocumentEdited()&&(!H.isReload||!this.nb.isHotExitEnabled())&&this.setDocumentEdited(!1),H.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.rb.nameLong)),this.Cb(F,H),this.ub===B.NONE?this.S=F:this.db=F,this.ub=B.NAVIGATING,this.m.loadURL(b.$3g.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.t.isBuilt?"":"-dev"}.${Y.$T?"esm.":""}html`).toString(!0));const ne=this.eb;this.eb=!0,!this.t.isBuilt&&!this.t.extensionTestsLocationURI&&this.B(new r.$Uh(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.N.fire({workspace:F.workspace,reason:H.isReload?T.LoadReason.RELOAD:ne?T.LoadReason.LOAD:T.LoadReason.INITIAL})}Cb(F,H){const ne=(this.S??this.db)?.userEnv;if(ne){const x=(0,g.$Nm)(ne)&&!(0,g.$Nm)(F.userEnv),ce=this.isExtensionDevelopmentHost;(x||ce)&&(F.userEnv={...ne,...F.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(F.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),H.disableExtensions!==void 0&&(F["disable-extensions"]=H.disableExtensions),F.fullscreen=this.isFullScreen,F.maximized=this.m.isMaximized(),F.partsSplash=this.lb.getWindowSplash(),F.zoomLevel=this.Jb(),F.isCustomZoomLevel=typeof this.ab=="number",F.isCustomZoomLevel&&F.partsSplash&&(F.partsSplash.zoomLevel=F.zoomLevel),(0,l.mark)("code/willOpenNewWindow"),F.perfMarks=(0,l.getMarks)(),this.bb.update(F)}async reload(F){const H=Object.assign({},this.S);H.workspace=await this.Db(H),delete H.filesToOpenOrCreate,delete H.filesToDiff,delete H.filesToMerge,delete H.filesToWait,this.isExtensionDevelopmentHost&&F&&(H.verbose=F.verbose,H.debugId=F.debugId,H.extensionEnvironment=F.extensionEnvironment,H["inspect-extensions"]=F["inspect-extensions"],H["inspect-brk-extensions"]=F["inspect-brk-extensions"],H["extensions-dir"]=F["extensions-dir"]),H.accessibilitySupport=i.default.app.isAccessibilitySupportEnabled(),H.isInitialStartup=!1,H.policiesData=this.gb.serialize(),H.continueOn=this.t.continueOn,H.profiles={all:this.hb.profiles,profile:this.profile||this.hb.defaultProfile,home:this.hb.profilesHome},H.logLevel=this.fb.getLogLevel(),H.loggers={window:this.fb.getRegisteredLoggers(this.id),global:this.fb.getRegisteredLoggers()},this.load(H,{isReload:!0,disableExtensions:F?.["disable-extensions"]})}async Db(F){if((0,L.$Xi)(F.workspace)){const H=F.workspace.configPath;if(H.scheme===b.Schemas.file&&!await this.ib.exists(H))return}else if((0,L.$Si)(F.workspace)){const H=F.workspace.uri;if(H.scheme===b.Schemas.file&&!await this.ib.exists(H))return}return F.workspace}serializeWindowState(){if(!this.m)return(0,T.$Ogc)();if(this.isFullScreen){let ne;try{ne=i.default.screen.getDisplayMatching(this.getBounds())}catch{}const x=(0,T.$Ogc)();return{mode:T.WindowMode.Fullscreen,display:ne?ne.id:void 0,width:this.U.width||x.width,height:this.U.height||x.height,x:this.U.x||0,y:this.U.y||0,zoomLevel:this.ab}}const F=Object.create(null);let H;if(!m.$k&&this.m.isMaximized()?H=T.WindowMode.Maximized:H=T.WindowMode.Normal,H===T.WindowMode.Maximized?F.mode=T.WindowMode.Maximized:F.mode=T.WindowMode.Normal,H===T.WindowMode.Normal||H===T.WindowMode.Maximized){let ne;H===T.WindowMode.Normal?ne=this.getBounds():ne=this.m.getNormalBounds(),F.x=ne.x,F.y=ne.y,F.width=ne.width,F.height=ne.height}return F.zoomLevel=this.ab,F}Eb(F){(0,l.mark)("code/willRestoreCodeWindowState");let H=!1;if(F){this.ab=F.zoomLevel;try{const ne=i.default.screen.getAllDisplays();H=ne.length>1,F=D.WindowStateValidator.validateWindowState(this.u,F,ne)}catch(ne){this.u.warn(`Unexpected error validating window state: ${ne}
${ne.stack}`)}}return(0,l.mark)("code/didRestoreCodeWindowState"),[F||(0,T.$Ogc)(),H]}getBounds(){const[F,H]=this.m.getPosition(),[ne,x]=this.m.getSize();return{x:F,y:H,width:ne,height:x}}I(F,H){super.I(F,H),this.sendWhenReady(F?"vscode:enterFullScreen":"vscode:leaveFullScreen",v.CancellationToken.None),this.W&&this.Hb(this.W,!1)}Gb(){let F=(0,w.$qE)(this.r);return["visible","toggle","hidden"].indexOf(F)<0&&(F="classic"),F}Hb(F,H=!0){m.$k||(F==="toggle"&&H&&this.send("vscode:showInfoMessage",(0,$.localize)(2477,null)),F==="hidden"?setTimeout(()=>{this.Ib(F)}):this.Ib(F))}Ib(F){const H=this.isFullScreen;switch(F){case"classic":this.m.setMenuBarVisibility(!H),this.m.autoHideMenuBar=H;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}notifyZoomLevel(F){this.ab=F}Jb(){return typeof this.ab=="number"?this.ab:this.r.getValue("window")?.zoomLevel}close(){this.m?.close()}sendWhenReady(F,H,...ne){this.isReady?this.send(F,...ne):this.ready().then(()=>{H.isCancellationRequested||this.send(F,...ne)})}send(F,...H){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.u.warn(`Sending IPC message to channel '${F}' for window that is destroyed`);return}try{this.m.webContents.send(F,...H)}catch(ne){this.u.warn(`Error sending IPC message to channel '${F}' of window ${this.Q}: ${(0,A.$tj)(ne)}`)}}}updateTouchBar(F){m.$k&&this.Y.forEach((H,ne)=>{const x=F[ne];H.segments=this.Mb(x)})}Kb(){if(m.$k){for(let F=0;F<10;F++){const H=this.Lb();this.Y.push(H)}this.m.setTouchBar(new i.default.TouchBar({items:this.Y}))}}Lb(F=[]){const H=this.Mb(F),ne=new i.default.TouchBar.TouchBarSegmentedControl({segments:H,mode:"buttons",segmentStyle:"automatic",change:x=>{this.sendWhenReady("vscode:runAction",v.CancellationToken.None,{id:ne.segments[x].id,from:"touchbar"})}});return ne}Mb(F=[]){return F.map(ne=>{let x;ne.icon&&!h.ThemeIcon.isThemeIcon(ne.icon)&&ne.icon?.dark?.scheme===b.Schemas.file&&(x=i.default.nativeImage.createFromPath(u.URI.revive(ne.icon.dark).fsPath),x.isEmpty()&&(x=void 0));let ce;return typeof ne.title=="string"?ce=ne.title:ce=ne.title.value,{id:ne.id,label:x?void 0:ce,icon:x}})}matches(F){return this.m?.webContents.id===F.id}dispose(){super.dispose(),this.fb.deregisterLoggers(this.id)}};e.$ehc=C,e.$ehc=C=ke([re(1,s.$dk),re(2,Q.$bhc),re(3,k.$Mgc),re(4,j.$xo),re(5,q.$3gc),re(6,E.$dl),re(7,n.$ohc),re(8,n.$mhc),re(9,f.$cj),re(10,P.$Xgc),re(11,R.$_gc),re(12,d.$Tgc),re(13,c.$cm),re(14,y.$Ugc),re(15,S.$ghc),re(16,a.$wk),re(17,t.$Wgc),re(18,D.$Zgc),re(19,G.$VR),re(20,V.$Hi)],C)}),define(le[276],ue([0,1,13,3,16,20,19,5,34,51,52,139]),function(K,e,i,r,v,A,O,I,b,l,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fhc=void 0;let $=class extends u.$dhc{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(d,f,y,k,g,E){super(k,g,f,y),this.O=d,this.P=E,this.id=this.O.id,this.parentId=-1,this.N=!1,this.tryClaimWindow()}tryClaimWindow(d){this.q.isDisposed||this.O.isDestroyed()||(this.Q(d),d&&!this.N&&(this.N=!0,this.w({x:d.x,y:d.y,width:d.width,height:d.height,mode:d.show===!1?m.WindowMode.Maximized:m.WindowMode.Normal})))}Q(d){if(this.m)return;const f=i.BrowserWindow.fromWebContents(this.O);f&&(this.u.trace("[aux window] Claimed browser window instance"),this.n(f,d),f.setMenu(null),(r.$j||r.$l)&&(0,l.$sE)(this.r,d?.titleBarStyle==="hidden"?l.TitlebarStyle.CUSTOM:void 0)&&f.setAutoHideMenuBar(!0),this.P.registerAuxWindow(this))}matches(d){return this.O.id===d.id}};e.$fhc=$,e.$fhc=$=ke([re(1,A.$Mgc),re(2,I.$dk),re(3,v.$cj),re(4,b.$VR),re(5,O.$ghc)],$)}),define(le[277],ue([0,1,13,4,2,11,35,276,6,5,52,29]),function(K,e,i,r,v,A,O,I,b,l,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nic=void 0;let $=class extends v.$Xc{constructor(d,f){super(),this.h=d,this.j=f,this.a=this.B(new r.$oe),this.onDidMaximizeWindow=this.a.event,this.b=this.B(new r.$oe),this.onDidUnmaximizeWindow=this.b.event,this.c=this.B(new r.$oe),this.onDidChangeFullScreen=this.c.event,this.f=this.B(new r.$oe),this.onDidTriggerSystemContextMenu=this.f.event,this.g=new Map,this.m()}m(){i.app.on("browser-window-created",(d,f)=>{const y=this.getWindowByWebContents(f.webContents);if(y)this.j.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),y.tryClaimWindow();else{const k=new v.$Wc;k.add(r.Event.fromNodeEventEmitter(f.webContents,"did-create-window",(g,E)=>({browserWindow:g,details:E}))(({browserWindow:g,details:E})=>{const S=this.getWindowByWebContents(g.webContents);S&&(this.j.trace('[aux window] window.on("did-create-window"): Trying to claim auxiliary window'),S.tryClaimWindow(E.options))})),k.add(r.Event.fromNodeEventEmitter(f,"closed")(()=>k.dispose()))}}),O.$gY.handle("vscode:registerAuxiliaryWindow",async(d,f)=>{const y=this.getWindowByWebContents(d.sender);return y&&(this.j.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),y.parentId=f),d.sender.id})}createWindow(d){const{state:f,overrides:y}=this.n(d);return this.h.invokeFunction(u.$1gc,f,y,{preload:A.$3g.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath})}n(d){const f={},y={},k=d.features.split(",");for(const E of k){const[S,s]=E.split("=");switch(S){case"width":f.width=parseInt(s,10);break;case"height":f.height=parseInt(s,10);break;case"left":f.x=parseInt(s,10);break;case"top":f.y=parseInt(s,10);break;case"window-maximized":f.mode=m.WindowMode.Maximized;break;case"window-fullscreen":f.mode=m.WindowMode.Fullscreen;break;case"window-disable-fullscreen":y.disableFullscreen=!0;break;case"window-native-titlebar":y.forceNativeTitlebar=!0;break}}const g=u.WindowStateValidator.validateWindowState(this.j,f)??(0,m.$Pgc)();return this.j.trace("[aux window] using window state",g),{state:g,overrides:y}}registerWindow(d){const f=new v.$Wc,y=this.h.createInstance(I.$fhc,d);this.g.set(y.id,y),f.add((0,v.$Vc)(()=>this.g.delete(y.id))),f.add(y.onDidMaximize(()=>this.a.fire(y))),f.add(y.onDidUnmaximize(()=>this.b.fire(y))),f.add(y.onDidEnterFullScreen(()=>this.c.fire({window:y,fullscreen:!0}))),f.add(y.onDidLeaveFullScreen(()=>this.c.fire({window:y,fullscreen:!1}))),f.add(y.onDidTriggerSystemContextMenu(({x:k,y:g})=>this.f.fire({window:y,x:k,y:g}))),r.Event.once(y.onDidClose)(()=>f.dispose())}getWindowByWebContents(d){const f=this.g.get(d.id);return f?.matches(d)?f:void 0}getFocusedWindow(){const d=i.BrowserWindow.getFocusedWindow();if(d)return this.getWindowByWebContents(d.webContents)}getLastActiveWindow(){return(0,u.$2gc)(Array.from(this.g.values()))}getWindows(){return Array.from(this.g.values())}};e.$Nic=$,e.$Nic=$=ke([re(0,b.$Hi),re(1,l.$dk)],$)}),define(le[90],ue([0,1,13,21,8,4,48,2,11,3,18,7,23,10,6,19,5,64,89,105,30,59,31,53]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p,d,f,y,k,g,E,S,s,a,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$1hc=e.$Zhc=void 0,e.$Zhc=(0,d.$Ii)("workspacesHistoryMainService");let n=class extends I.$Xc{static{o=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(h,P,w,D,L){super(),this.f=h,this.g=P,this.h=w,this.j=D,this.m=L,this.c=this.B(new A.$oe),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new v.$Gh(800)),this.n()}n(){this.h.when(f.LifecycleMainPhase.Eventually).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(h=>this.addRecentlyOpened([{workspace:h.workspace,remoteAuthority:h.window.remoteAuthority}])))}async addRecentlyOpened(h){let P=[],w=[];for(const L of h)if((0,E.$Jib)(L))!this.g.isUntitledWorkspace(L.workspace)&&!this.w(P,L.workspace)&&P.push(L);else if((0,E.$Kib)(L))this.y(P,L.folderUri)||P.push(L);else{const R=this.z(w,L.fileUri),T=L.fileUri.scheme===b.Schemas.file&&o.G.indexOf((0,m.$gh)(L.fileUri))>=0;!R&&!T&&(w.push(L),l.$j&&L.fileUri.scheme===b.Schemas.file&&i.app.addRecentDocument(L.fileUri.fsPath))}const D=await this.r({workspaces:P,files:w});P=D.workspaces,w=D.files,P.length>o.a&&(P.length=o.a),w.length>o.a&&(w.length=o.a),await this.t({workspaces:P,files:w}),this.c.fire(),l.$k&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(h){const P=R=>{const T=this.u(R);for(const j of h)if(m.$ah.isEqual(j,T))return!1;return!0},w=await this.getRecentlyOpened(),D=w.workspaces.filter(P),L=w.files.filter(P);(D.length!==w.workspaces.length||L.length!==w.files.length)&&(await this.t({files:L,workspaces:D}),this.c.fire(),l.$k&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(h){if(h?.confirm){const{response:P}=await this.m.showMessageBox({type:"warning",buttons:[(0,p.localize)(2490,null),(0,p.localize)(2491,null)],message:(0,p.localize)(2492,null),detail:(0,p.localize)(2493,null),cancelId:1});if(P!==0)return}await this.t({workspaces:[],files:[]}),i.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(h){const P=new a.$Dc(L=>m.$ah.getComparisonKey(L));if(h?.workspaces)for(const L of h.workspaces)P.set(this.u(L),L);const w=new a.$Dc(L=>m.$ah.getComparisonKey(L));if(h?.files)for(const L of h.files)w.set(this.u(L),L);const D=await this.s();for(const L of D.workspaces){const R=P.get(this.u(L));R?R.label=R.label??L.label:P.set(this.u(L),L)}for(const L of D.files){const R=w.get(this.u(L));R?R.label=R.label??L.label:w.set(this.u(L),L)}return{workspaces:[...P.values()],files:[...w.values()]}}async s(){await this.j.whenReady;let h;const P=this.j.get(o.b,k.StorageScope.APPLICATION);if(typeof P=="string")try{h=JSON.parse(P)}catch(w){this.f.error("Unexpected error parsing opened paths list",w)}return(0,E.$Qib)(h,this.f)}async t(h){await this.j.whenReady,this.j.store(o.b,JSON.stringify((0,E.$Rib)(h)),k.StorageScope.APPLICATION,k.StorageTarget.MACHINE)}u(h){return(0,E.$Kib)(h)?h.folderUri:(0,E.$Lib)(h)?h.fileUri:h.workspace.configPath}w(h,P){return!!h.find(w=>(0,E.$Jib)(w)&&w.workspace.id===P.id)}y(h,P){return!!h.find(w=>(0,E.$Kib)(w)&&m.$ah.isEqual(w.folderUri,P))}z(h,P){return!!h.find(w=>m.$ah.isEqual(w.fileUri,P))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG","git-rebase-todo"]}async I(){l.$j&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!l.$j)return;const h=[];if(h.push({type:"tasks",items:[{type:"task",title:(0,p.localize)(2494,null),description:(0,p.localize)(2495,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const P=[];for(const L of i.app.getJumpListSettings().removedItems){const R=L.args;if(R){const T=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(R);T&&P.push(u.URI.parse(T[2]))}}await this.removeRecentlyOpened(P);let w=!1;const D=(0,r.$Jb)((await this.getRecentlyOpened()).workspaces.slice(0,o.F).map(L=>{const R=(0,E.$Jib)(L)?L.workspace:L.folderUri,{title:T,description:j}=this.L(R,L.label);let G;return u.URI.isUri(R)?G=`--folder-uri "${R.toString()}"`:(w=!0,G=`--file-uri "${R.configPath.toString()}"`),{type:"task",title:T.substr(0,255),description:j.substr(0,255),program:process.execPath,args:G,iconPath:"explorer.exe",iconIndex:0}}));D.length>0&&h.push({type:"custom",name:w?(0,p.localize)(2496,null):(0,p.localize)(2497,null),items:D})}h.push({type:"recent"});try{const P=i.app.setJumpList(h);P&&P!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${P}`)}catch(P){this.f.warn("updateWindowsJumpList#setJumpList",P)}}L(h,P){if(P)return{title:(0,O.$dx)(P).name,description:P};if(u.URI.isUri(h))return{title:(0,m.$gh)(h),description:this.M(h)};if(this.g.isUntitledWorkspace(h))return{title:(0,p.localize)(2498,null),description:""};let w=(0,m.$gh)(h.configPath);return w.endsWith(S.$5i)&&(w=w.substr(0,w.length-S.$5i.length-1)),{title:(0,p.localize)(2499,null,w),description:this.M(h.configPath)}}M(h){return h.scheme==="file"?(0,O.$8w)(h.fsPath):h.toString()}async N(){if(!l.$k)return;i.app.clearRecentDocuments();const h=await this.getRecentlyOpened(),P=[];let w=0;for(let L=0;L<h.workspaces.length&&w<o.C;L++){const R=this.u(h.workspaces[L]);if(R.scheme===b.Schemas.file){const T=(0,m.$0g)(R);await $.Promises.exists(T)&&(P.push(T),w++)}}const D=[];for(let L=0;L<h.files.length&&w<o.D;L++){const R=this.u(h.files[L]);if(R.scheme===b.Schemas.file){const T=(0,m.$0g)(R);if(o.G.includes((0,m.$gh)(R))||P.includes(T))continue;await $.Promises.exists(T)&&(D.push(T),w++)}}D.reverse().forEach(L=>i.app.addRecentDocument(L)),P.reverse().forEach(L=>i.app.addRecentDocument(L))}};e.$1hc=n,e.$1hc=n=o=ke([re(0,y.$dk),re(1,s.$_gc),re(2,f.$ghc),re(3,g.$ohc),re(4,t.$Ugc)],n)}),define(le[278],ue([0,1,13,8,22,48,3,7,10,85,16,20,19,5,201,66,28,34,24,50,51,29,90,2]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p,d,f,y,k,g,E,S,s,a,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$2hc=void 0,b=Ie(b);const n="menu";let c=class extends t.$Xc{static{o=this}static{this.a="lastKnownMenubarData"}constructor(w,D,L,R,T,j,G,q,Q,de,V,Y){super(),this.t=w,this.u=D,this.w=L,this.y=R,this.z=T,this.C=j,this.D=G,this.F=q,this.G=Q,this.H=de,this.I=V,this.J=Y,this.s=Object.create(null),this.h=new r.$Uh(()=>this.R(),0),this.j=new r.$Uh(()=>{this.m=[]},1e4),this.n=Object.create(null),this.r=Object.create(null),(O.$k||(0,S.$sE)(D))&&this.L(),this.M(),this.f=!1,this.g=!1,this.m=[],this.W(),this.N()}L(){const w=this.D.getItem(o.a);w&&(w.menus&&(this.n=w.menus),w.keybindings&&(this.r=w.keybindings))}M(){this.s["workbench.action.files.newUntitledFile"]=(j,G,q)=>{this.lb({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.w.openEmptyWindow({context:s.OpenContext.MENU,contextWindowId:G?.id})},this.s["workbench.action.newWindow"]=(j,G,q)=>this.w.openEmptyWindow({context:s.OpenContext.MENU,contextWindowId:G?.id}),this.s["workbench.action.files.openFileFolder"]=(j,G,q)=>this.H.pickFileFolderAndOpen(void 0,{forceNewWindow:this.eb(q),telemetryExtraData:{from:n}}),this.s["workbench.action.files.openFolder"]=(j,G,q)=>this.H.pickFolderAndOpen(void 0,{forceNewWindow:this.eb(q),telemetryExtraData:{from:n}}),this.s["workbench.action.openWorkspace"]=(j,G,q)=>this.H.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.eb(q),telemetryExtraData:{from:n}}),this.s["workbench.action.clearRecentFiles"]=()=>this.C.clearRecentlyOpened({confirm:!0});const w=this.I.youTubeUrl;w&&(this.s["workbench.action.openYouTubeUrl"]=()=>this.ob(w,"openYouTubeUrl"));const D=this.I.requestFeatureUrl;D&&(this.s["workbench.action.openRequestFeatureUrl"]=()=>this.ob(D,"openUserVoiceUrl"));const L=this.I.reportIssueUrl;L&&(this.s["workbench.action.openIssueReporter"]=()=>this.ob(L,"openReportIssues"));const R=this.I.licenseUrl;R&&(this.s["workbench.action.openLicenseUrl"]=()=>{if(O.$x){const j=R.indexOf("?")>0?"&":"?";this.ob(`${R}${j}lang=${O.$x}`,"openLicenseUrl")}else this.ob(R,"openLicenseUrl")});const T=this.I.privacyStatementUrl;T&&R&&(this.s["workbench.action.openPrivacyStatementUrl"]=()=>{this.ob(T,"openPrivacyStatement")})}N(){this.B(this.F.onWillShutdown(()=>this.b=!0)),this.B(this.w.onDidChangeWindowsCount(w=>this.S(w))),this.B(this.H.onDidBlurMainWindow(()=>this.U())),this.B(this.H.onDidFocusMainWindow(()=>this.U()))}get O(){const w=this.u.getValue("window.enableMenuBarMnemonics");return typeof w!="boolean"?!0:w}get P(){if(!O.$k)return!1;const w=this.u.getValue("window.nativeTabs");return typeof w!="boolean"?!1:w}updateMenu(w,D){this.n=w.menus,this.r=w.keybindings,this.D.setItem(o.a,w),this.Q()}Q(){this.h.schedule()}R(){this.b||setTimeout(()=>{this.b||this.W()},10)}S(w){O.$k&&(w.oldCount===0&&w.newCount>0||w.oldCount>0&&w.newCount===0)&&(this.f=w.newCount===0,this.Q())}U(){if(!O.$k)return;const w=i.BrowserWindow.getFocusedWindow();this.g=!w||!!this.J.getWindowByWebContents(w.webContents),this.Q()}W(){const w=i.Menu.getApplicationMenu();if(w&&this.m.push(w),Object.keys(this.n).length===0){this.X(O.$k?new i.Menu:null);return}const D=new i.Menu;let L;if(O.$k){const T=new i.Menu;L=new i.MenuItem({label:this.I.nameShort,submenu:T}),this.Y(T),D.append(L)}if(O.$k&&!this.c){this.c=!0;const T=new i.Menu;T.append(new i.MenuItem({label:this.qb(b.localize(1968,null)),click:()=>this.w.openEmptyWindow({context:s.OpenContext.DOCK})})),i.app.dock.setMenu(T)}if(this.$("File")){const T=new i.Menu,j=new i.MenuItem({label:this.qb(b.localize(1969,null)),submenu:T});this.bb(T,"File"),D.append(j)}if(this.$("Edit")){const T=new i.Menu,j=new i.MenuItem({label:this.qb(b.localize(1970,null)),submenu:T});this.bb(T,"Edit"),D.append(j)}if(this.$("Selection")){const T=new i.Menu,j=new i.MenuItem({label:this.qb(b.localize(1971,null)),submenu:T});this.bb(T,"Selection"),D.append(j)}if(this.$("View")){const T=new i.Menu,j=new i.MenuItem({label:this.qb(b.localize(1972,null)),submenu:T});this.bb(T,"View"),D.append(j)}if(this.$("Go")){const T=new i.Menu,j=new i.MenuItem({label:this.qb(b.localize(1973,null)),submenu:T});this.bb(T,"Go"),D.append(j)}if(this.$("Run")){const T=new i.Menu,j=new i.MenuItem({label:this.qb(b.localize(1974,null)),submenu:T});this.bb(T,"Run"),D.append(j)}if(this.$("Terminal")){const T=new i.Menu,j=new i.MenuItem({label:this.qb(b.localize(1975,null)),submenu:T});this.bb(T,"Terminal"),D.append(j)}let R;if(this.$("Window")){const T=new i.Menu;R=new i.MenuItem({label:this.qb(b.localize(1976,null)),submenu:T,role:"window"}),this.hb(T)}if(R&&D.append(R),this.$("Help")){const T=new i.Menu,j=new i.MenuItem({label:this.qb(b.localize(1977,null)),submenu:T,role:"help"});this.bb(T,"Help"),D.append(j)}D.items&&D.items.length>0?this.X(D):this.X(null),this.j.schedule()}X(w){if(i.Menu.setApplicationMenu(w),w)for(const D of this.J.getWindows())D.win?.setMenu(null)}Y(w){const D=this.jb(b.localize(1978,null,this.I.nameLong),"workbench.action.showAboutDialog"),L=this.ib();let R;if(this.$("Preferences")){const Y=new i.Menu;this.bb(Y,"Preferences"),R=new i.MenuItem({label:this.qb(b.localize(1979,null)),submenu:Y})}const T=new i.Menu,j=new i.MenuItem({label:b.localize(1980,null),role:"services",submenu:T}),G=new i.MenuItem({label:b.localize(1981,null,this.I.nameLong),role:"hide",accelerator:"Command+H"}),q=new i.MenuItem({label:b.localize(1982,null),role:"hideOthers",accelerator:"Command+Alt+H"}),Q=new i.MenuItem({label:b.localize(1983,null),role:"unhide"}),de=new i.MenuItem(this.nb("workbench.action.quit",{label:b.localize(1984,null,this.I.nameLong),click:async(Y,B,_)=>{const C=this.w.getLastActiveWindow();(this.w.getWindowCount()===0||i.BrowserWindow.getFocusedWindow()||C?.win?.isMinimized())&&await this.Z(_)&&this.H.quit(void 0)}})),V=[D];V.push(...L),R&&V.push(h(),R),V.push(h(),j,h(),G,q,Q,h(),de),V.forEach(Y=>w.append(Y))}async Z(w){if(this.w.getWindowCount()===0)return!0;const D=this.u.getValue("window.confirmBeforeClose");if(D==="always"||D==="keyboardOnly"&&this.fb(w)){const{response:L}=await this.H.showMessageBox(this.w.getFocusedWindow()?.id,{type:"question",buttons:[b.localize(1985,null),b.localize(1986,null)],message:b.localize(1987,null)});return L===0}return!0}$(w){if(!O.$k&&!(0,S.$sE)(this.u))return!1;switch(w){case"File":case"Help":if(O.$k)return this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g||!!this.n&&!!this.n[w];case"Window":if(O.$k)return this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g||!!this.n;default:return this.w.getWindowCount()>0&&!!this.n&&!!this.n[w]}}ab(w,D){D.forEach(L=>{if((0,d.$Whc)(L))w.append(h());else if((0,d.$Vhc)(L)){const R=new i.Menu,T=new i.MenuItem({label:this.qb(L.label),submenu:R});this.ab(R,L.submenu.items),w.append(T)}else(0,d.$Xhc)(L)?w.append(this.db(L)):(0,d.$Yhc)(L)&&(L.id==="workbench.action.showAboutDialog"&&this.cb(w),O.$k?this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g?this.s[L.id]?w.append(new i.MenuItem(this.nb(L.id,{label:this.qb(L.label),click:this.s[L.id]}))):w.append(this.jb(L.label,L.id,!1,L.checked)):w.append(this.jb(L.label,L.id,L.enabled!==!1,!!L.checked)):w.append(this.jb(L.label,L.id,L.enabled!==!1,!!L.checked)))})}bb(w,D){this.n&&this.n[D]&&this.ab(w,this.n[D].items)}cb(w){const D=this.ib();D.length&&(D.forEach(L=>w.append(L)),w.append(h()))}db(w){const D=I.URI.revive(w.uri),L=w.id,R=L==="openRecentFile"?{fileUri:D}:L==="openRecentWorkspace"?{workspaceUri:D}:{folderUri:D};return new i.MenuItem(this.nb(L,{label:w.label,click:async(T,j,G)=>{const q=this.eb(G);(await this.w.open({context:s.OpenContext.MENU,cli:this.y.args,urisToOpen:[R],forceNewWindow:q,gotoLineMode:!1,remoteAuthority:w.remoteAuthority})).length>0||await this.C.removeRecentlyOpened([D])}},!1))}eb(w){return!!(w&&(!O.$k&&(w.ctrlKey||w.shiftKey)||O.$k&&(w.metaKey||w.altKey)))}fb(w){return!!(w.triggeredByAccelerator||w.altKey||w.ctrlKey||w.metaKey||w.shiftKey)}gb(w,D,L){const R={label:this.qb(w),role:L,enabled:!0};return new i.MenuItem(this.mb(D,R))}hb(w){const D=new i.MenuItem({label:b.localize(1988,null),role:"minimize",accelerator:"Command+M",enabled:this.w.getWindowCount()>0}),L=new i.MenuItem({label:b.localize(1989,null),role:"zoom",enabled:this.w.getWindowCount()>0}),R=new i.MenuItem({label:b.localize(1990,null),role:"front",enabled:this.w.getWindowCount()>0}),T=this.jb(b.localize(1991,null),"workbench.action.switchWindow"),j=[];this.P&&(j.push(h()),j.push(this.jb(b.localize(1992,null),"workbench.action.newWindowTab")),j.push(this.gb(b.localize(1993,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),j.push(this.gb(b.localize(1994,null),"workbench.action.showNextWindowTab","selectNextTab")),j.push(this.gb(b.localize(1995,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),j.push(this.gb(b.localize(1996,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[D,L,h(),T,...j,h(),R].forEach(G=>w.append(G))}ib(){switch(this.t.state.type){case E.StateType.Idle:return[new i.MenuItem({label:this.qb(b.localize(1997,null)),click:()=>setTimeout(()=>{this.pb("CheckForUpdate"),this.t.checkForUpdates(!0)},0)})];case E.StateType.CheckingForUpdates:return[new i.MenuItem({label:b.localize(1998,null),enabled:!1})];case E.StateType.AvailableForDownload:return[new i.MenuItem({label:this.qb(b.localize(1999,null)),click:()=>{this.t.downloadUpdate()}})];case E.StateType.Downloading:return[new i.MenuItem({label:b.localize(2e3,null),enabled:!1})];case E.StateType.Downloaded:return O.$k?[]:[new i.MenuItem({label:this.qb(b.localize(2001,null)),click:()=>{this.pb("InstallUpdate"),this.t.applyUpdate()}})];case E.StateType.Updating:return[new i.MenuItem({label:b.localize(2002,null),enabled:!1})];case E.StateType.Ready:return[new i.MenuItem({label:this.qb(b.localize(2003,null)),click:()=>{this.pb("RestartToUpdate"),this.t.quitAndInstall()}})];default:return[]}}jb(w,D,L,R){const T=this.qb(w),j=typeof D=="function"?D:(V,Y,B)=>{const _=V?V.userSettingsLabel:null;let C=D;Array.isArray(D)&&(C=this.eb(B)?D[1]:D[0]),_&&B.triggeredByAccelerator?this.lb({type:"keybinding",userSettingsLabel:_}):this.lb({type:"commandId",commandId:C})},G=typeof L=="boolean"?L:this.w.getWindowCount()>0,q=typeof R=="boolean"?R:!1,Q={label:T,click:j,enabled:G};q&&(Q.type="checkbox",Q.checked=q);let de;return typeof D=="string"?de=D:Array.isArray(D)&&(de=D[0]),O.$k&&(de==="editor.action.clipboardCutAction"?Q.role="cut":de==="editor.action.clipboardCopyAction"?Q.role="copy":de==="editor.action.clipboardPasteAction"&&(Q.role="paste"),de==="undo"?Q.click=this.kb(j,{inDevTools:V=>V.undo(),inNoWindow:()=>i.Menu.sendActionToFirstResponder("undo:")}):de==="redo"?Q.click=this.kb(j,{inDevTools:V=>V.redo(),inNoWindow:()=>i.Menu.sendActionToFirstResponder("redo:")}):de==="editor.action.selectAll"&&(Q.click=this.kb(j,{inDevTools:V=>V.selectAll(),inNoWindow:()=>i.Menu.sendActionToFirstResponder("selectAll:")}))),new i.MenuItem(this.mb(de,Q))}kb(w,D){return(L,R,T)=>{const j=i.BrowserWindow.getFocusedWindow();if(!j)return D.inNoWindow();if(j.webContents.isDevToolsFocused()&&j.webContents.devToolsWebContents)return D.inDevTools(j.webContents.devToolsWebContents);w(L,R||j,T)}}lb(w){let D=i.BrowserWindow.getFocusedWindow();if(D){const R=this.J.getWindowByWebContents(D.webContents);R&&(D=this.w.getWindowById(R.parentId)?.win??null)}if(!D){const R=this.w.getLastActiveWindow();R?.win?.isMinimized()&&(D=R.win)}const L=D?this.w.getWindowById(D.id):void 0;if(L){if(this.G.trace("menubar#runActionInRenderer",w),O.$k&&!this.y.isBuilt&&!L.isReady&&(w.type==="commandId"&&w.commandId==="workbench.action.toggleDevTools"||w.type!=="commandId"&&w.userSettingsLabel==="alt+cmd+i"))return!1;if(w.type==="commandId"){const R={id:w.commandId,from:"menu"};L.sendWhenReady("vscode:runAction",v.CancellationToken.None,R)}else{const R={userSettingsLabel:w.userSettingsLabel};L.sendWhenReady("vscode:runKeybinding",v.CancellationToken.None,R)}return!0}else return this.G.trace("menubar#runActionInRenderer: no active window found",w),!1}mb(w,D){const L=typeof w=="string"?this.r[w]:void 0;if(L?.label){if(L.isNative!==!1)D.accelerator=L.label,D.userSettingsLabel=L.userSettingsLabel;else if(typeof D.label=="string"){const R=D.label.indexOf("[");R>=0?D.label=`${D.label.substr(0,R)} [${L.label}]`:D.label=`${D.label} [${L.label}]`}}else D.accelerator=void 0;return D}nb(w,D,L=!D.accelerator){L&&(D=this.mb(w,D));const R=D.click;return D.click=(T,j,G)=>{this.pb(w),R?.(T,j,G)},D}ob(w,D){this.H.openExternal(void 0,w),this.pb(D)}pb(w){this.z.publicLog2("workbenchActionExecuted",{id:w,from:n})}qb(w){return(0,A.$ax)(w,!this.O)}};e.$2hc=c,e.$2hc=c=o=ke([re(0,E.$fZ),re(1,m.$cj),re(2,s.$Zgc),re(3,u.$Mgc),re(4,g.$cm),re(5,a.$Zhc),re(6,k.$VR),re(7,$.$ghc),re(8,p.$dk),re(9,f.$Mhc),re(10,y.$wk),re(11,l.$Lhc)],c);function h(){return new i.MenuItem({type:"separator"})}}),define(le[279],ue([0,1,6,19,5,278,2]),function(K,e,i,r,v,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4hc=e.$3hc=void 0,e.$3hc=(0,i.$Ii)("menubarMainService");let I=class extends O.$Xc{constructor(l,m,u){super(),this.b=l,this.c=m,this.f=u,this.a=this.g()}async g(){return await this.c.when(r.LifecycleMainPhase.AfterWindowOpen),this.B(this.b.createInstance(A.$2hc))}async updateMenubar(l,m){this.f.trace("menubarService#updateMenubar",l),(await this.a).updateMenu(m,l)}};e.$4hc=I,e.$4hc=I=ke([re(0,i.$Hi),re(1,r.$ghc),re(2,v.$dk)],I)});var xe=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[280],ue([0,1,26,13,109,27,21,22,39,4,32,48,2,11,9,72,3,37,18,12,7,10,71,16,53,20,14,6,19,5,63,74,75,34,51,139,29,136,271,30,106,90,59,52,77,40,58,73,85,86]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p,d,f,y,k,g,E,S,s,a,t,o,n,c,h,P,w,D,L,R,T,j,G,q,Q,de,V,Y,B,_,C,W,F,H,ne,x,ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ric=void 0,i=Ie(i),D=xe(D);function oe(Z){return(0,V.$Xi)(Z?.workspace)}function J(Z){return(0,V.$Si)(Z?.workspace)}let M=class extends $.$Xc{constructor(U,N,ie,X,z,te,ae,me,be,ye,Fe,Ve,Re,$e,ee,he,fe,pe,ve,je,Oe,De){super(),this.s=U,this.t=N,this.u=ie,this.w=X,this.z=z,this.C=te,this.D=ae,this.F=me,this.G=be,this.H=ye,this.I=Fe,this.J=Ve,this.L=Re,this.M=$e,this.N=ee,this.O=he,this.P=fe,this.Q=pe,this.R=ve,this.S=je,this.U=Oe,this.W=De,this.a=this.B(new l.$oe),this.onDidOpenWindow=this.a.event,this.b=this.B(new l.$oe),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new l.$oe),this.onDidDestroyWindow=this.c.event,this.f=this.B(new l.$oe),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new l.$oe),this.onDidMaximizeWindow=this.g.event,this.h=this.B(new l.$oe),this.onDidUnmaximizeWindow=this.h.event,this.j=this.B(new l.$oe),this.onDidChangeFullScreen=this.j.event,this.m=this.B(new l.$oe),this.onDidTriggerSystemContextMenu=this.m.event,this.n=new Map,this.r=this.B(new de.$oic(this,this.D,this.I,this.z,this.L)),this.X()}X(){this.B(this.N.onDidEnterWorkspace(U=>this.b.fire(U.window))),this.B(this.onDidSignalReadyWindow(U=>{if(U.config?.extensionDevelopmentPath||U.config?.extensionTestsPath){const N=new $.$Wc;if(N.add(l.Event.any(U.onDidClose,U.onDidDestroy)(()=>N.dispose())),U.config.extensionDevelopmentPath)for(const ie of U.config.extensionDevelopmentPath)N.add(this.R.addValidFileRoot(ie));U.config.extensionTestsPath&&N.add(this.R.addValidFileRoot(U.config.extensionTestsPath))}}))}openEmptyWindow(U,N){const ie=this.G.args,X=N?.remoteAuthority||void 0,z=!0,te=N?.forceReuseWindow,ae=!te;return this.open({...U,cli:ie,forceEmpty:z,forceNewWindow:ae,forceReuseWindow:te,remoteAuthority:X,forceTempProfile:N?.forceTempProfile,forceProfile:N?.forceProfile})}openExistingWindow(U,N){U.focus(),this.Y(N,[U])}async open(U){this.z.trace("windowsManager#open"),U.addMode&&(U.initialStartup||!this.getLastActiveWindow())&&(U.addMode=!1);const N=[],ie=[],X=[],z=[],te=[];let ae,me=0;const be=await this.eb(U);this.z.trace("windowsManager#open pathsToOpen",be);for(const $e of be)J($e)?U.addMode?N.push($e):ie.push($e):oe($e)?X.push($e):$e.fileUri?(ae||(ae={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:$e.remoteAuthority}),ae.filesToOpenOrCreate.push($e)):$e.backupPath?te.push({backupFolder:(0,d.$qc)($e.backupPath),remoteAuthority:$e.remoteAuthority}):me++;U.diffMode&&ae&&ae.filesToOpenOrCreate.length>=2&&(ae.filesToDiff=ae.filesToOpenOrCreate.slice(0,2),ae.filesToOpenOrCreate=[]),U.mergeMode&&ae&&ae.filesToOpenOrCreate.length===4&&(ae.filesToMerge=ae.filesToOpenOrCreate.slice(0,4),ae.filesToOpenOrCreate=[],ae.filesToDiff=[]),ae&&U.waitMarkerFileURI&&(ae.filesToWait={paths:(0,O.$Jb)([...ae.filesToDiff,ae.filesToMerge[3],...ae.filesToOpenOrCreate]),waitMarkerFileUri:U.waitMarkerFileURI}),U.initialStartup?(z.push(...this.N.getUntitledWorkspaces()),X.push(...z),te.push(...this.J.getEmptyWindowBackups())):te.length=0;const{windows:ye,filesOpenedInWindow:Fe}=await this.Z(U,X,ie,te,me,ae,N);if(this.z.trace(`windowsManager#open used window count ${ye.length} (workspacesToOpen: ${X.length}, foldersToOpen: ${ie.length}, emptyToRestore: ${te.length}, emptyToOpen: ${me})`),ye.length>1)if(Fe)Fe.focus();else{const $e=this.r.state.lastActiveWindow&&!U.forceEmpty&&!U.cli._.length&&!U.cli["file-uri"]&&!U.cli["folder-uri"]&&!(U.urisToOpen&&U.urisToOpen.length);let ee=!0,he=!0;if($e){const fe=ye.filter(pe=>this.r.state.lastActiveWindow&&pe.backupPath===this.r.state.lastActiveWindow.backupPath);fe.length&&(fe[0].focus(),ee=!1,he=!1)}if(ee)for(let fe=ye.length-1;fe>=0;fe--){const pe=ye[fe];if(!(pe.openedWorkspace&&z.some(ve=>pe.openedWorkspace&&ve.workspace.id===pe.openedWorkspace.id)||pe.backupPath&&te.some(ve=>pe.backupPath&&ve.backupFolder===(0,d.$qc)(pe.backupPath)))){pe.focus(),he=!1;break}}he&&ye[ye.length-1].focus()}const Ve=ae&&ae.filesToDiff.length>0,Re=ae&&ae.filesToMerge.length>0;if(!ye.some($e=>$e.isExtensionDevelopmentHost)&&!Ve&&!Re&&!U.noRecentEntry){const $e=[];for(const ee of be)oe(ee)&&!ee.transient?$e.push({label:ee.label,workspace:ee.workspace,remoteAuthority:ee.remoteAuthority}):J(ee)?$e.push({label:ee.label,folderUri:ee.workspace.uri,remoteAuthority:ee.remoteAuthority}):ee.fileUri&&$e.push({label:ee.label,fileUri:ee.fileUri,remoteAuthority:ee.remoteAuthority});this.M.addRecentlyOpened($e)}return this.Y(U,ye),ye}Y(U,N){const ie=U.waitMarkerFileURI;U.context===q.OpenContext.CLI&&ie&&N.length===1&&N[0]&&(async()=>{await N[0].whenClosedOrLoaded;try{await this.Q.del(ie)}catch{}})()}async Z(U,N,ie,X,z,te,ae){const me=[];let be;function ye(fe,pe){me.push(fe),pe&&(be=fe,te=void 0)}let{openFolderInNewWindow:Fe,openFilesInNewWindow:Ve}=this.qb(U);if(!U.initialStartup&&ae.length>0){const fe=ae[0].remoteAuthority,pe=this.wb(fe);pe&&ye(this.bb(pe,ae.map(ve=>ve.workspace.uri)))}const Re=ie.length+N.length+X.length;if(te&&Re===0){const fe=te.filesToOpenOrCreate[0]||te.filesToDiff[0]||te.filesToMerge[3],pe=this.getWindows().filter(je=>te&&(0,g.$oh)(je.remoteAuthority,te.remoteAuthority));let ve;fe?.fileUri&&!Ve&&((U.context===q.OpenContext.DESKTOP||U.context===q.OpenContext.CLI||U.context===q.OpenContext.DOCK||U.context===q.OpenContext.LINK)&&(ve=await(0,Q.$5gc)(pe,fe.fileUri,async je=>je.configPath.scheme===p.Schemas.file?this.N.resolveLocalWorkspace(je.configPath):void 0)),ve||(ve=this.xb(pe))),ve?(0,V.$Xi)(ve.openedWorkspace)?N.push({workspace:ve.openedWorkspace,remoteAuthority:ve.remoteAuthority}):(0,V.$Si)(ve.openedWorkspace)?ie.push({workspace:ve.openedWorkspace,remoteAuthority:ve.remoteAuthority}):ye(this.$(U,ve,te),!0):ye(await this.rb({userEnv:U.userEnv,cli:U.cli,initialStartup:U.initialStartup,filesToOpen:te,forceNewWindow:!0,remoteAuthority:te.remoteAuthority,forceNewTabbedWindow:U.forceNewTabbedWindow,forceProfile:U.forceProfile,forceTempProfile:U.forceTempProfile}),!0)}const $e=(0,O.$Ob)(N,fe=>fe.workspace.id);if($e.length>0){const fe=(0,O.$Jb)($e.map(pe=>(0,Q.$6gc)(this.getWindows(),pe.workspace.configPath)));if(fe.length>0){const pe=fe[0],ve=(0,g.$oh)(te?.remoteAuthority,pe.remoteAuthority)?te:void 0;ye(this.$(U,pe,ve),!!ve),Fe=!0}for(const pe of $e){if(fe.some(Oe=>Oe.openedWorkspace&&Oe.openedWorkspace.id===pe.workspace.id))continue;const ve=pe.remoteAuthority,je=(0,g.$oh)(te?.remoteAuthority,ve)?te:void 0;ye(await this.db(U,pe,Fe,je),!!je),Fe=!0}}const ee=(0,O.$Ob)(ie,fe=>g.$ah.getComparisonKey(fe.workspace.uri));if(ee.length>0){const fe=(0,O.$Jb)(ee.map(pe=>(0,Q.$6gc)(this.getWindows(),pe.workspace.uri)));if(fe.length>0){const pe=fe[0],ve=(0,g.$oh)(te?.remoteAuthority,pe.remoteAuthority)?te:void 0;ye(this.$(U,pe,ve),!!ve),Fe=!0}for(const pe of ee){if(fe.some(Oe=>(0,V.$Si)(Oe.openedWorkspace)&&g.$ah.isEqual(Oe.openedWorkspace.uri,pe.workspace.uri)))continue;const ve=pe.remoteAuthority,je=(0,g.$oh)(te?.remoteAuthority,ve)?te:void 0;ye(await this.db(U,pe,Fe,je),!!je),Fe=!0}}const he=(0,O.$Ob)(X,fe=>fe.backupFolder);if(he.length>0)for(const fe of he){const pe=fe.remoteAuthority,ve=(0,g.$oh)(te?.remoteAuthority,pe)?te:void 0;ye(await this.cb(U,!0,pe,ve,fe),!!ve),Fe=!0}if(me.length===0||te){te&&!z&&z++;const fe=te?te.remoteAuthority:U.remoteAuthority;for(let pe=0;pe<z;pe++)ye(await this.cb(U,Fe,fe,te),!!te),Fe=!0}return{windows:(0,O.$Ob)(me),filesOpenedInWindow:be}}$(U,N,ie){this.z.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:ie}),this.ab(N);const X={filesToOpenOrCreate:ie?.filesToOpenOrCreate,filesToDiff:ie?.filesToDiff,filesToMerge:ie?.filesToMerge,filesToWait:ie?.filesToWait,termProgram:U?.userEnv?.TERM_PROGRAM};return N.sendWhenReady("vscode:openFiles",I.CancellationToken.None,X),N}ab(U){let N=U;const ie=r.BrowserWindow.getFocusedWindow();if(ie&&ie.id!==U.id){const X=this.U.getWindowByWebContents(ie.webContents);X&&X.parentId===U.id&&(N=X)}N.focus()}bb(U,N){this.z.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:N}),U.focus();const ie={foldersToAdd:N};return U.sendWhenReady("vscode:addFolders",I.CancellationToken.None,ie),U}cb(U,N,ie,X,z){this.z.trace("windowsManager#doOpenEmpty",{restore:!!z,remoteAuthority:ie,filesToOpen:X,forceNewWindow:N});let te;return!N&&typeof U.contextWindowId=="number"&&(te=this.getWindowById(U.contextWindowId)),this.rb({userEnv:U.userEnv,cli:U.cli,initialStartup:U.initialStartup,remoteAuthority:ie,forceNewWindow:N,forceNewTabbedWindow:U.forceNewTabbedWindow,filesToOpen:X,windowToUse:te,emptyWindowBackupInfo:z,forceProfile:U.forceProfile,forceTempProfile:U.forceTempProfile})}db(U,N,ie,X,z){return this.z.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:N,filesToOpen:X}),!ie&&!z&&typeof U.contextWindowId=="number"&&(z=this.getWindowById(U.contextWindowId)),this.rb({workspace:N.workspace,userEnv:U.userEnv,cli:U.cli,initialStartup:U.initialStartup,remoteAuthority:N.remoteAuthority,forceNewWindow:ie,forceNewTabbedWindow:U.forceNewTabbedWindow,filesToOpen:X,windowToUse:z,forceProfile:U.forceProfile,forceTempProfile:U.forceTempProfile})}async eb(U){let N,ie=!1,X=!1;if(U.urisToOpen&&U.urisToOpen.length>0?(N=await this.fb(U),ie=!0):U.forceEmpty?N=[Object.create(null)]:U.cli._.length||U.cli["folder-uri"]||U.cli["file-uri"]?(N=await this.gb(U.cli),N.length===0&&N.push(Object.create(null)),ie=!0):(N=await this.ib(),N.length===0&&N.push(Object.create(null)),X=!0),!U.addMode&&ie){const z=N.filter(te=>J(te));if(z.length>1){const te=z[0].remoteAuthority;if(z.every(ae=>(0,g.$oh)(ae.remoteAuthority,te))){const ae=await this.N.createUntitledWorkspace(z.map(me=>({uri:me.workspace.uri})));N.push({workspace:ae,remoteAuthority:te}),N=N.filter(me=>!J(me))}}}if(U.initialStartup&&!X&&this.L.getValue("window")?.restoreWindows==="preserve"){const z=await this.ib();N.unshift(...z.filter(te=>oe(te)||J(te)||te.backupPath))}return N}async fb(U){const N={gotoLineMode:U.gotoLineMode,remoteAuthority:U.remoteAuthority},ie=await Promise.all((0,O.$Jb)(U.urisToOpen||[]).map(async X=>{const z=await this.kb(X,N);if(z)return z.label=X.label,z;const te=this.mb(X);this.P.showMessageBox({type:"info",buttons:[(0,s.localize)(2478,null)],message:te.scheme===p.Schemas.file?(0,s.localize)(2479,null):(0,s.localize)(2480,null),detail:te.scheme===p.Schemas.file?(0,s.localize)(2481,null,(0,u.$7w)(te,{os:y.OS,tildify:this.G})):(0,s.localize)(2482,null,te.toString(!0))},r.BrowserWindow.getFocusedWindow()??void 0)}));return(0,O.$Jb)(ie)}async gb(U){const N=[],ie={ignoreFileNotFound:!0,gotoLineMode:U.goto,remoteAuthority:U.remote||void 0,forceOpenWorkspaceAsFile:U.diff&&U._.length===2||U.merge&&U._.length===4},X=U["folder-uri"];if(X){const ae=await Promise.all(X.map(me=>{const be=this.hb(me);if(be)return this.kb({folderUri:be},ie)}));N.push(...(0,O.$Jb)(ae))}const z=U["file-uri"];if(z){const ae=await Promise.all(z.map(me=>{const be=this.hb(me);if(be)return this.kb((0,V.$bj)(me)?{workspaceUri:be}:{fileUri:be},ie)}));N.push(...(0,O.$Jb)(ae))}const te=await Promise.all(U._.map(ae=>ie.remoteAuthority?this.pb(ae,ie):this.nb(ae,ie)));return N.push(...(0,O.$Jb)(te)),N}hb(U){try{const N=S.URI.parse(U);if(!N.scheme){this.z.error(`Invalid URI input string, scheme missing: ${U}`);return}return N.path?N:N.with({path:"/"})}catch(N){this.z.error(`Invalid URI input string: ${U}, ${N.message}`)}}async ib(){const U=this.jb();switch(U){case"none":return[];case"one":case"all":case"preserve":case"folders":{const N=[];U!=="one"&&N.push(...this.r.state.openedWindows),this.r.state.lastActiveWindow&&N.push(this.r.state.lastActiveWindow);const ie=await Promise.all(N.map(async X=>{if(X.workspace){const z=await this.kb({workspaceUri:X.workspace.configPath},{remoteAuthority:X.remoteAuthority,rejectTransientWorkspaces:!0});if(oe(z))return z}else if(X.folderUri){const z=await this.kb({folderUri:X.folderUri},{remoteAuthority:X.remoteAuthority});if(J(z))return z}else if(U!=="folders"&&X.backupPath)return{backupPath:X.backupPath,remoteAuthority:X.remoteAuthority}}));return(0,O.$Jb)(ie)}}}jb(){let U;return this.I.wasRestarted?U="all":(U=this.L.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(U)||(U="all")),U}async kb(U,N=Object.create(null)){const ie=this.mb(U);return ie.scheme===p.Schemas.file?((0,j.$pE)(U)&&(N={...N,forceOpenWorkspaceAsFile:!0}),this.nb(ie.fsPath,N)):this.lb(U,N)}lb(U,N){let ie=this.mb(U);const X=(0,R.$ln)(ie)||N.remoteAuthority;if(ie=(0,g.$qh)((0,g.$kh)(ie)),(0,j.$pE)(U)){if(N.gotoLineMode){const{path:z,line:te,column:ae}=(0,m.$Pg)(ie.path);return{fileUri:ie.with({path:z}),options:{selection:te?{startLineNumber:te,startColumn:ae||1}:void 0},remoteAuthority:X}}return{fileUri:ie,remoteAuthority:X}}else if((0,j.$nE)(U))return{workspace:(0,Y.$9gc)(ie),remoteAuthority:X};return{workspace:(0,Y.$0gc)(ie),remoteAuthority:X}}mb(U){return(0,j.$nE)(U)?U.workspaceUri:(0,j.$oE)(U)?U.folderUri:U.fileUri}async nb(U,N,ie){let X,z;N.gotoLineMode&&({path:U,line:X,column:z}=(0,m.$Pg)(U)),U=(0,m.$Jg)((0,d.$kc)(U),(0,k.cwd)());try{const te=await i.promises.stat(U);if(te.isFile()){if(!N.forceOpenWorkspaceAsFile){const ae=await this.N.resolveLocalWorkspace(S.URI.file(U));if(ae)return ae.transient&&N.rejectTransientWorkspaces?void 0:{workspace:{id:ae.id,configPath:ae.configPath},type:c.FileType.File,exists:!0,remoteAuthority:ae.remoteAuthority,transient:ae.transient}}return{fileUri:S.URI.file(U),type:c.FileType.File,exists:!0,options:{selection:X?{startLineNumber:X,startColumn:z||1}:void 0}}}else{if(te.isDirectory())return{workspace:(0,Y.$0gc)(S.URI.file(U),te),type:c.FileType.Directory,exists:!0};if(!y.$j&&U==="/dev/null")return{fileUri:S.URI.file(U),type:c.FileType.File,exists:!0}}}catch(te){if(te.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!ie)return this.ob(U,N);const ae=S.URI.file(U);if(this.M.removeRecentlyOpened([ae]),N.ignoreFileNotFound)return{fileUri:ae,type:c.FileType.File,exists:!1}}}async ob(U,N){const ie=S.URI.file(U),{response:X,checkboxChecked:z}=await this.P.showMessageBox({type:"warning",buttons:[(0,s.localize)(2483,null),(0,s.localize)(2484,null),(0,s.localize)(2485,null)],message:(0,s.localize)(2486,null,ie.authority),detail:(0,s.localize)(2487,null,(0,u.$7w)(ie,{os:y.OS,tildify:this.G})),checkboxLabel:(0,s.localize)(2488,null,ie.authority),cancelId:1});if(X===0){if((0,v.addUNCHostToAllowlist)(ie.authority),z){const te={channel:"vscode:configureAllowedUNCHost",args:ie.authority};this.sendToFocused(te.channel,te.args),this.sendToOpeningWindow(te.channel,te.args)}return this.nb(U,N,!0)}if(X===2)return r.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.ob(U,N)}pb(U,N){const ie=U.charCodeAt(0),X=N.remoteAuthority;let z,te;N.gotoLineMode&&({path:U,line:z,column:te}=(0,m.$Pg)(U)),ie!==b.CharCode.Slash&&((0,m.$Ig)(ie)&&U.charCodeAt(U.charCodeAt(1))===b.CharCode.Colon&&(U=(0,m.$Bg)(U)),U=`/${U}`);const ae=S.URI.from({scheme:p.Schemas.vscodeRemote,authority:X,path:U});if(U.charCodeAt(U.length-1)!==b.CharCode.Slash){if((0,V.$bj)(U))return N.forceOpenWorkspaceAsFile?{fileUri:ae,options:{selection:z?{startLineNumber:z,startColumn:te||1}:void 0},remoteAuthority:N.remoteAuthority}:{workspace:(0,Y.$9gc)(ae),remoteAuthority:X};if(N.gotoLineMode||d.$jc.basename(U).indexOf(".")!==-1)return{fileUri:ae,options:{selection:z?{startLineNumber:z,startColumn:te||1}:void 0},remoteAuthority:X}}return{workspace:(0,Y.$0gc)(ae),remoteAuthority:X}}qb(U){const N=this.L.getValue("window"),ie=N?.openFoldersInNewWindow||"default",X=N?.openFilesInNewWindow||"off";let z=(U.preferNewWindow||U.forceNewWindow)&&!U.forceReuseWindow;!U.forceNewWindow&&!U.forceReuseWindow&&(ie==="on"||ie==="off")&&(z=ie==="on");let te=!1;return U.forceNewWindow||U.forceReuseWindow?te=!!U.forceNewWindow&&!U.forceReuseWindow:(y.$k?U.context===q.OpenContext.DOCK&&(te=!0):U.context!==q.OpenContext.DIALOG&&U.context!==q.OpenContext.MENU&&!(U.userEnv&&U.userEnv.TERM_PROGRAM==="vscode")&&(te=!0),!U.cli.extensionDevelopmentPath&&(X==="on"||X==="off")&&(te=X==="on")),{openFolderInNewWindow:!!z,openFilesInNewWindow:te}}async openExtensionDevelopmentHostWindow(U,N){const ie=(0,Q.$7gc)(this.getWindows(),U);if(ie)return this.I.reload(ie,N.cli),ie.focus(),[ie];let X=N.cli["folder-uri"]||[],z=N.cli["file-uri"]||[],te=N.cli._;if(!te.length&&!X.length&&!z.length&&!N.cli.extensionTestsPath){const be=this.r.state.lastPluginDevelopmentHostWindow,ye=be?.workspace??be?.folderUri;ye&&(S.URI.isUri(ye)?ye.scheme===p.Schemas.file?te=[ye.fsPath]:X=[ye.toString()]:ye.configPath.scheme===p.Schemas.file?te=[(0,g.$0g)(ye.configPath)]:z=[ye.configPath.toString()])}let ae=N.remoteAuthority;for(const be of U)if(be.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ye=S.URI.parse(be),Fe=(0,R.$ln)(ye);Fe&&(ae?(0,g.$oh)(Fe,ae)||this.z.error("more than one extension development path authority"):ae=Fe)}te=te.filter(be=>{const ye=S.URI.file(be);return(0,Q.$6gc)(this.getWindows(),ye)?!1:(0,g.$oh)((0,R.$ln)(ye),ae)}),X=X.filter(be=>{const ye=this.hb(be);return ye&&(0,Q.$6gc)(this.getWindows(),ye)?!1:ye?(0,g.$oh)((0,R.$ln)(ye),ae):!1}),z=z.filter(be=>{const ye=this.hb(be);return ye&&(0,Q.$6gc)(this.getWindows(),ye)?!1:ye?(0,g.$oh)((0,R.$ln)(ye),ae):!1}),N.cli._=te,N.cli["folder-uri"]=X,N.cli["file-uri"]=z;const me={context:N.context,cli:N.cli,forceNewWindow:!0,forceEmpty:!te.length&&!X.length&&!z.length,userEnv:N.userEnv,noRecentEntry:!0,waitMarkerFileURI:N.waitMarkerFileURI,remoteAuthority:ae,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile};return this.open(me)}async rb(U){const N=this.L.getValue("window"),ie=this.getLastActiveWindow(),z=(N?.newWindowProfile?this.H.profiles.find(me=>me.name===N.newWindowProfile):void 0)??ie?.profile??this.H.defaultProfile;let te;!U.forceNewWindow&&!U.forceNewTabbedWindow&&(te=U.windowToUse||ie,te&&te.focus());const ae={...this.G.args,...U.cli,machineId:this.s,sqmId:this.t,devDeviceId:this.u,windowId:-1,mainPid:process.pid,appRoot:this.G.appRoot,execPath:process.execPath,codeCachePath:this.G.codeCachePath,backupPath:U.emptyWindowBackupInfo?(0,d.$mc)(this.G.backupHome,U.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.H.profilesHome,all:this.H.profiles,profile:z},homeDir:this.G.userHome.with({scheme:p.Schemas.file}).fsPath,tmpDir:this.G.tmpDir.with({scheme:p.Schemas.file}).fsPath,userDataDir:this.G.userDataPath,remoteAuthority:U.remoteAuthority,workspace:U.workspace,userEnv:{...this.w,...U.userEnv},nls:{messages:globalThis._VSCODE_NLS_MESSAGES,language:globalThis._VSCODE_NLS_LANGUAGE},filesToOpenOrCreate:U.filesToOpen?.filesToOpenOrCreate,filesToDiff:U.filesToOpen?.filesToDiff,filesToMerge:U.filesToOpen?.filesToMerge,filesToWait:U.filesToOpen?.filesToWait,logLevel:this.C.getLogLevel(),loggers:{window:[],global:this.C.getRegisteredLoggers()},logsPath:this.G.logsHome.with({scheme:p.Schemas.file}).fsPath,product:D.default,isInitialStartup:U.initialStartup,perfMarks:(0,f.getMarks)(),os:{release:(0,A.release)(),hostname:(0,A.hostname)(),arch:(0,A.arch)()},autoDetectHighContrast:N?.autoDetectHighContrast??!0,autoDetectColorScheme:N?.autoDetectColorScheme??!1,accessibilitySupport:r.app.accessibilitySupportEnabled,colorScheme:this.S.getColorScheme(),policiesData:this.F.serialize(),continueOn:this.G.continueOn,cssModules:this.W.isEnabled?await this.W.getCssModules():void 0};if(te){const me=te.config;!ae.extensionDevelopmentPath&&me?.extensionDevelopmentPath&&(ae.extensionDevelopmentPath=me.extensionDevelopmentPath,ae.extensionDevelopmentKind=me.extensionDevelopmentKind,ae["enable-proposed-api"]=me["enable-proposed-api"],ae.verbose=me.verbose,ae["inspect-extensions"]=me["inspect-extensions"],ae["inspect-brk-extensions"]=me["inspect-brk-extensions"],ae.debugId=me.debugId,ae.extensionEnvironment=me.extensionEnvironment,ae["extensions-dir"]=me["extensions-dir"],ae["disable-extensions"]=me["disable-extensions"]),ae.loggers={global:ae.loggers.global,window:me?.loggers.window??ae.loggers.window}}else{const me=this.r.getNewWindowState(ae);(0,f.mark)("code/willCreateCodeWindow");const be=te=this.O.createInstance(G.$ehc,{state:me,extensionDevelopmentPath:ae.extensionDevelopmentPath,isExtensionTestHost:!!ae.extensionTestsPath});(0,f.mark)("code/didCreateCodeWindow"),U.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(be),this.n.set(be.id,be),this.a.fire(be),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const ye=new $.$Wc;ye.add(be.onDidSignalReady(()=>this.b.fire(be))),ye.add(l.Event.once(be.onDidClose)(()=>this.ub(be,ye))),ye.add(l.Event.once(be.onDidDestroy)(()=>this.vb(be))),ye.add(be.onDidMaximize(()=>this.g.fire(be))),ye.add(be.onDidUnmaximize(()=>this.h.fire(be))),ye.add(be.onDidEnterFullScreen(()=>this.j.fire({window:be,fullscreen:!0}))),ye.add(be.onDidLeaveFullScreen(()=>this.j.fire({window:be,fullscreen:!1}))),ye.add(be.onDidTriggerSystemContextMenu(({x:Ve,y:Re})=>this.m.fire({window:be,x:Ve,y:Re})));const Fe=(0,E.$sg)(be.win?.webContents);Fe.removeAllListeners("devtools-reload-page"),ye.add(l.Event.fromNodeEventEmitter(Fe,"devtools-reload-page")(()=>this.I.reload(be))),this.I.registerWindow(be)}return ae.windowId=te.id,te.isReady?this.I.unload(te,C.UnloadReason.LOAD).then(async me=>{me||await this.sb(te,ae,U,z)}):await this.sb(te,ae,U,z),te}async sb(U,N,ie,X){if(N.extensionDevelopmentPath||((0,V.$Xi)(N.workspace)?N.backupPath=this.J.registerWorkspaceBackup({workspace:N.workspace,remoteAuthority:N.remoteAuthority}):(0,V.$Si)(N.workspace)?N.backupPath=this.J.registerFolderBackup({folderUri:N.workspace.uri,remoteAuthority:N.remoteAuthority}):N.backupPath=this.J.registerEmptyWindowBackup({backupFolder:ie.emptyWindowBackupInfo?.backupFolder??(0,Y.$$gc)().id,remoteAuthority:N.remoteAuthority})),this.H.isEnabled()){const z=N.workspace??(0,V.$Wi)(N.backupPath,!1),te=this.tb(ie,z,X),ae=te instanceof Promise?await te:te;N.profiles.profile=ae,N.extensionDevelopmentPath||await this.H.setProfileForWorkspace(z,ae)}U.load(N)}tb(U,N,ie){return U.forceProfile?this.H.profiles.find(X=>X.name===U.forceProfile)??this.H.createNamedProfile(U.forceProfile):U.forceTempProfile?this.H.createTransientProfile():this.H.getProfileForWorkspace(N)??ie}ub(U,N){this.n.delete(U.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),N.dispose()}vb(U){this.n.delete(U.id),this.c.fire(U)}getFocusedWindow(){const U=r.BrowserWindow.getFocusedWindow();if(U)return this.getWindowById(U.id)}getLastActiveWindow(){return this.xb(this.getWindows())}wb(U){return this.xb(this.getWindows().filter(N=>(0,g.$oh)(N.remoteAuthority,U)))}xb(U){return(0,q.$2gc)(U)}sendToFocused(U,...N){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(U,I.CancellationToken.None,...N)}sendToOpeningWindow(U,...N){this.B(l.Event.once(this.onDidSignalReadyWindow)(ie=>{ie.sendWhenReady(U,I.CancellationToken.None,...N)}))}sendToAll(U,N,ie){for(const X of this.getWindows())ie&&ie.indexOf(X.id)>=0||X.sendWhenReady(U,I.CancellationToken.None,N)}getWindows(){return Array.from(this.n.values())}getWindowCount(){return this.n.size}getWindowById(U){return this.n.get(U)}getWindowByWebContents(U){const N=r.BrowserWindow.fromWebContents(U);if(!N)return;const ie=this.getWindowById(N.id);return ie?.matches(U)?ie:void 0}};e.$ric=M,e.$ric=M=ke([re(4,w.$dk),re(5,ne.$bhc),re(6,T.$VR),re(7,F.$xo),re(8,n.$Mgc),re(9,H.$3gc),re(10,P.$ghc),re(11,a.$Tgc),re(12,t.$cj),re(13,B.$Zhc),re(14,_.$_gc),re(15,h.$Hi),re(16,o.$Ugc),re(17,c.$dl),re(18,L.$Wgc),re(19,W.$Xgc),re(20,x.$Lhc),re(21,ce.$aS)],M)}),define(le[281],ue([0,1,71,29,90,59]),function(K,e,i,r,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tic=void 0;let O=class{constructor(b,l,m,u){this.a=b,this.b=l,this.c=m,this.d=u,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(b,l){const m=this.b.getWindowById(b);if(m)return this.a.enterWorkspace(m,this.b.getWindows(),l)}createUntitledWorkspace(b,l,m){return this.a.createUntitledWorkspace(l,m)}deleteUntitledWorkspace(b,l){return this.a.deleteUntitledWorkspace(l)}getWorkspaceIdentifier(b,l){return this.a.getWorkspaceIdentifier(l)}getRecentlyOpened(b){return this.c.getRecentlyOpened()}addRecentlyOpened(b,l){return this.c.addRecentlyOpened(l)}removeRecentlyOpened(b,l){return this.c.removeRecentlyOpened(l)}clearRecentlyOpened(b){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$tic=O,e.$tic=O=ke([re(0,A.$_gc),re(1,r.$Zgc),re(2,v.$Zhc),re(3,i.$Tgc)],O)}),define(le[282],ue([0,1,13,109,35,27,17,55,15,4,286,48,2,11,9,3,12,7,33,161,45,162,121,137,10,71,256,16,263,99,138,53,100,190,20,70,103,178,266,180,181,182,14,194,102,84,6,101,189,272,273,257,264,19,5,279,66,28,75,267,104,34,246,89,130,24,223,224,57,50,236,261,274,262,275,134,238,239,240,243,270,51,29,280,245,30,105,90,281,59,40,203,58,216,49,88,135,248,265,253,8,226,247,198,73,269,242,21,76,268,234,209,68,85,277,79,86]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p,d,f,y,k,g,E,S,s,a,t,o,n,c,h,P,w,D,L,R,T,j,G,q,Q,de,V,Y,B,_,C,W,F,H,ne,x,ce,oe,J,M,Z,U,N,ie,X,z,te,ae,me,be,ye,Fe,Ve,Re,$e,ee,he,fe,pe,ve,je,Oe,De,We,Ke,Ze,ze,Ye,Qe,Je,Ce,se,ge,we,Ee,Me,Be,_e,lt,rt,at,tt,ut,ct,ft,gt,Tt,mt,$t,Lt,jt,Mt,pt,Ft,Et,dt,Nt,Ct,wt,Wt,St,Bt,kt,Pt){"use strict";var bt;Object.defineProperty(e,"__esModule",{value:!0}),e.$Oic=void 0;let yt=class extends $.$Xc{static{bt=this}static{this.a={[p.Schemas.file]:"security.promptForLocalFileProtocolHandling",[p.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Ae,Te,Le,Se,Pe,qe,Ge,Xe,Ne,He,Ue,et){super(),this.g=Ae,this.h=Te,this.j=Le,this.m=Se,this.n=Pe,this.s=qe,this.t=Ge,this.u=Xe,this.w=Ne,this.y=He,this.z=Ue,this.C=et,this.D(),this.F()}D(){const Ae=Ne=>Ne?.startsWith(`${p.Schemas.vscodeWebview}://`),Te=new Set(["clipboard-read","clipboard-sanitized-write"]);i.session.defaultSession.setPermissionRequestHandler((Ne,He,Ue,et)=>Ae(et.requestingUrl)?Ue(Te.has(He)):Ue(!1)),i.session.defaultSession.setPermissionCheckHandler((Ne,He,Ue,et)=>Ae(et.requestingUrl)?Te.has(He):!1);const Le=new Set([p.Schemas.file,p.Schemas.vscodeFileResource,p.Schemas.vscodeRemoteResource,p.Schemas.vscodeManagedRemoteResource,"devtools"]),Se=Ne=>{for(let He=Ne;He;He=He.parent)if(He.url.startsWith(`${p.Schemas.vscodeWebview}://`))return!0;return!1},Pe=Ne=>Ne.resourceType==="xhr"||Se(Ne.frame),qe=Ne=>{const He=Ne.frame;if(!He||!this.b)return!1;const Ue=i.BrowserWindow.getAllWindows();for(const et of Ue)if(He.processId===et.webContents.mainFrame.processId)return!0;return!1},Ge=(Ne,He)=>{if(Ne.path!=="/index.html")return!0;const Ue=He.frame;if(!Ue||!this.b)return!1;for(const et of this.b.getWindows())if(et.win&&Ue.processId===et.win.webContents.mainFrame.processId)return!0;return!1};i.session.defaultSession.webRequest.onBeforeRequest((Ne,He)=>{const Ue=k.URI.parse(Ne.url);return Ue.scheme===p.Schemas.vscodeWebview&&!Ge(Ue,Ne)?(this.m.error("Blocked vscode-webview request",Ne.url),He({cancel:!0})):Ue.scheme===p.Schemas.vscodeFileResource&&!qe(Ne)?(this.m.error("Blocked vscode-file request",Ne.url),He({cancel:!0})):Ue.path.endsWith(".svg")&&!Le.has(Ue.scheme)?He({cancel:!Pe(Ne)}):He({cancel:!1})}),i.session.defaultSession.webRequest.onHeadersReceived((Ne,He)=>{const Ue=Ne.responseHeaders,et=Ue["content-type"]||Ue["Content-Type"];if(et&&Array.isArray(et)){const it=k.URI.parse(Ne.url);if(it.path.endsWith(".svg")&&Le.has(it.scheme))return Ue["Content-Type"]=["image/svg+xml"],He({cancel:!1,responseHeaders:Ue});if(!it.path.endsWith(p.Schemas.vscodeRemoteResource)&&et.some(ot=>ot.toLowerCase().includes("image/svg")))return He({cancel:!Pe(Ne)})}return He({cancel:!1})}),i.session.defaultSession.webRequest.onHeadersReceived((Ne,He)=>{if(Ne.url.startsWith("https://vscode.download.prss.microsoft.com/")){const Ue=Ne.responseHeaders??Object.create(null);if(Ue["Access-Control-Allow-Origin"]===void 0)return Ue["Access-Control-Allow-Origin"]=["*"],He({cancel:!1,responseHeaders:Ue})}return He({cancel:!1})});const Xe=i.session.defaultSession;typeof Xe.setCodeCachePath=="function"&&this.s.codeCachePath&&Xe.setCodeCachePath((0,d.$mc)(this.s.codeCachePath,"chrome")),f.$j&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,r.disableUNCAccessRestrictions)():(0,r.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,b.setUnexpectedErrorHandler)(Le=>this.G(Le)),process.on("uncaughtException",Le=>{(0,b.$1)(Le)||(0,b.$2)(Le)}),process.on("unhandledRejection",Le=>(0,b.$2)(Le)),l.Event.once(this.t.onWillShutdown)(()=>this.dispose()),(0,E.$hY)(),i.app.on("accessibility-support-changed",(Le,Se)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",Se)}),i.app.on("activate",async(Le,Se)=>{this.m.trace("app#activate"),Se||await this.b?.openEmptyWindow({context:Je.OpenContext.DOCK})}),i.app.on("web-contents-created",(Le,Se)=>{Se?.opener?.url.startsWith(`${p.Schemas.vscodeFileResource}://${p.$2g}/`)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow(Se)),Se.on("will-navigate",Pe=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),Pe.preventDefault()}),Se.setWindowOpenHandler(Pe=>Pe.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow(Pe)}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Pe.url}}`),this.f?.openExternal(void 0,Pe.url),{action:"deny"}))});let Ae=[],Te;i.app.on("open-file",(Le,Se)=>{Se=(0,kt.$qm)(Se),this.m.trace("app#open-file: ",Se),Le.preventDefault(),Ae.push((0,ge.$bj)(Se)?{workspaceUri:k.URI.file(Se)}:{fileUri:k.URI.file(Se)}),Te!==void 0&&(clearTimeout(Te),Te=void 0),Te=setTimeout(async()=>{await this.b?.open({context:Je.OpenContext.DOCK,cli:this.s.args,urisToOpen:Ae,gotoLineMode:!1,preferNewWindow:!0}),Ae=[],Te=void 0},100)}),i.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:Je.OpenContext.DESKTOP})}),v.$gY.handle("vscode:fetchShellEnv",Le=>{const Se=this.b?.getWindowByWebContents(Le.sender);let Pe,qe;return Se?.config?(Pe=Se.config,qe={...process.env,...Se.config.userEnv}):(Pe=this.s.args,qe=process.env),this.W(Pe,qe,!1)}),v.$gY.on("vscode:toggleDevTools",Le=>Le.sender.toggleDevTools()),v.$gY.on("vscode:openDevTools",Le=>Le.sender.openDevTools()),v.$gY.on("vscode:reloadWindow",Le=>Le.sender.reload()),v.$gY.handle("vscode:notifyZoomLevel",async(Le,Se)=>{const Pe=this.b?.getWindowByWebContents(Le.sender);Pe&&Pe.notifyZoomLevel(Se)})}G(Ae){if(Ae){const Te={message:`[uncaught exception in main]: ${Ae.message}`,stack:Ae.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(Te))}this.m.error(`[uncaught exception in main]: ${Ae}`),Ae.stack&&this.m.error(Ae.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const Ae=this.z.win32AppUserModelId;f.$j&&Ae&&i.app.setAppUserModelId(Ae);try{f.$k&&this.u.getValue("window.nativeTabs")===!0&&!i.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&i.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ue){this.m.error(Ue)}const Te=new s.$nY;l.Event.once(this.t.onWillShutdown)(Ue=>{Ue.reason===Z.ShutdownReason.KILL&&Te.dispose()}),this.m.trace("Resolving machine identifier...");const[Le,Se,Pe]=await Promise.all([(0,$t.$Cic)(this.w,this.m),(0,$t.$Dic)(this.w,this.m),(0,$t.$Eic)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${Le}`);const{sharedProcessReady:qe,sharedProcessClient:Ge}=this.O(Le,Se,Pe),Xe=await this.P(Le,Se,Pe,qe);Xe.invokeFunction(Ue=>Ue.get(t.$qhc)),this.B(Xe.createInstance(gt.$xic)),Xe.invokeFunction(Ue=>this.Q(Ue,Te,Ge));const Ne=await Xe.invokeFunction(Ue=>this.H(Ue,Te));this.I(Te),this.t.phase=Z.LifecycleMainPhase.Ready,await Xe.invokeFunction(Ue=>this.R(Ue,Ne)),this.t.phase=Z.LifecycleMainPhase.AfterWindowOpen,this.S(),this.B(new mt.$Uh(()=>{this.B((0,mt.$Yh)(()=>this.t.phase=Z.LifecycleMainPhase.Eventually,2500))},2500)).schedule()}async H(Ae,Te){const Le=this.b=Ae.get(Je.$Zgc),Se=Ae.get(De.$8Y),Pe=this.f=Ae.get(ie.$Mhc),qe=Ae.get(L.$Ugc),Ge=this;Se.registerHandler({async handleURL(it,ot){return Ge.N(Le,qe,Se,it,ot)}});const Xe=this.B(new se.$sic({onDidOpenMainWindow:Pe.onDidOpenMainWindow,onDidFocusMainWindow:Pe.onDidFocusMainWindow,getActiveWindowId:()=>Pe.getActiveWindowId(-1)})),Ne=new S.$qi(it=>Xe.getActiveClientId().then(ot=>it===ot)),He=new We.$jic(Ne,this.m),Ue=Te.getChannel("urlHandler",He);Se.registerHandler(new We.$iic(Ue));const et=await this.J(Le,qe);return this.B(new Ze.$kic(et?.urls,Se,Le,this.s,this.z,this.m)),et}I(Ae){const Te=()=>({statusCode:404,data:"Not found"}),Le=new Wt.$W(()=>Ae.getChannel(wt.$Lic,new wt.$Mic));i.protocol.registerBufferProtocol(p.Schemas.vscodeManagedRemoteResource,(Se,Pe)=>{const qe=k.URI.parse(Se.url);if(!qe.authority.startsWith("window:"))return Pe(Te());Le.value.call(wt.$Kic,[qe]).then(Ge=>Pe({...Ge,data:Buffer.from(Ge.body,"base64")}),Ge=>{this.m.warn("error dispatching remote resource call",Ge),Pe({statusCode:500,data:String(Ge)})})})}async J(Ae,Te){const Le=this.s.args["open-url"]?this.s.args._urls||[]:[];Le.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Le);const Se=global.getOpenUrls()||[];if(Se.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Se),Le.length+Se.length===0)return;const Pe=[...Le,...Se].map(Xe=>{try{return{uri:k.URI.parse(Xe),originalUrl:Xe}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Xe);return}}),qe=[],Ge=[];for(const Xe of Pe){if(!Xe)continue;const Ne=this.M(Xe.uri);if(Ne)if(await this.L(Ne,Ae,Te)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Xe.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Xe.uri.toString(!0),Ne),qe.push(Ne);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Xe.uri.toString(!0)),Ge.push(Xe)}return{urls:Ge,openables:qe}}async L(Ae,Te,Le){let Se,Pe;if((0,Qe.$nE)(Ae)?(Se=Ae.workspaceUri,Pe=(0,o.localize)(145,null,Se.scheme===p.Schemas.file?(0,u.$7w)(Se,{os:f.OS,tildify:this.s}):Se.toString(!0),this.z.nameShort)):(0,Qe.$oE)(Ae)?(Se=Ae.folderUri,Pe=(0,o.localize)(146,null,Se.scheme===p.Schemas.file?(0,u.$7w)(Se,{os:f.OS,tildify:this.s}):Se.toString(!0),this.z.nameShort)):(Se=Ae.fileUri,Pe=(0,o.localize)(147,null,Se.scheme===p.Schemas.file?(0,u.$7w)(Se,{os:f.OS,tildify:this.s}):Se.toString(!0),this.z.nameShort)),Se.scheme!==p.Schemas.file&&Se.scheme!==p.Schemas.vscodeRemote||this.u.getValue(bt.a[Se.scheme])===!1)return!1;const{response:Ge,checkboxChecked:Xe}=await Le.showMessageBox({type:"warning",buttons:[(0,o.localize)(148,null),(0,o.localize)(149,null)],message:Pe,detail:(0,o.localize)(150,null),checkboxLabel:Se.scheme===p.Schemas.file?(0,o.localize)(151,null):(0,o.localize)(152,null),cancelId:1});if(Ge!==0)return!0;if(Xe){const Ne={channel:"vscode:disablePromptForProtocolHandling",args:Se.scheme===p.Schemas.file?"local":"remote"};Te.sendToFocused(Ne.channel,Ne.args),Te.sendToOpeningWindow(Ne.channel,Ne.args)}return!1}M(Ae){if(Ae.path){if(Ae.authority===p.Schemas.file){const Te=k.URI.file(Ae.fsPath);return(0,ge.$bj)(Te)?{workspaceUri:Te}:{fileUri:Te}}else if(Ae.authority===p.Schemas.vscodeRemote){const Te=Ae.path.indexOf(d.$jc.sep,1);let Le,Se;Te!==-1?(Le=Ae.path.substring(1,Te),Se=Ae.path.substring(Te)):(Le=Ae.path.substring(1),Se="/");let Pe=Ae.query;const qe=new URLSearchParams(Ae.query);qe.get("windowId")==="_blank"&&(qe.delete("windowId"),Pe=qe.toString());const Ge=k.URI.from({scheme:p.Schemas.vscodeRemote,authority:Le,path:Se,query:Pe,fragment:Ae.fragment});return(0,ge.$bj)(Se)?{workspaceUri:Ge}:/:[\d]+$/.test(Se)?{fileUri:Ge}:{folderUri:Ge}}}}async N(Ae,Te,Le,Se,Pe){this.m.trace("app#handleProtocolUrl():",Se.toString(!0),Pe),Se.scheme===this.z.urlProtocol&&Se.path==="workspace"&&(Se=Se.with({authority:"file",path:k.URI.parse(Se.query).path,query:""}));let qe=!1;const Ge=new URLSearchParams(Se.query);Ge.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",Se.toString(!0)),Ge.delete("windowId"),Se=Se.with({query:Ge.toString()}),qe=!0):f.$k&&Ae.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",Se.toString(!0)),qe=!0);const Xe=Ge.get("continueOn");Xe!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",Se.toString(!0)),Ge.delete("continueOn"),Se=Se.with({query:Ge.toString()}),this.s.continueOn=Xe??void 0);const Ne=this.M(Se);return Ne?await this.L(Ne,Ae,Te)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",Se.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",Ne,Se.toString(!0)),(0,Et.$Qb)(await Ae.open({context:Je.OpenContext.LINK,cli:{...this.s.args},urisToOpen:[Ne],forceNewWindow:qe,gotoLineMode:!0}))?.focus(),!0):qe?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",Se.toString(!0)),await(0,Et.$Qb)(await Ae.open({context:Je.OpenContext.LINK,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,z.$ln)(Se)}))?.ready(),Le.open(Se,Pe)):(this.m.trace("app#handleProtocolUrl(): not handled",Se.toString(!0),Pe),!1)}O(Ae,Te,Le){const Se=this.B(this.j.createInstance(te.$8hc,Ae,Te,Le));this.B(Se.onDidCrash(()=>this.b?.sendToFocused("vscode:reportSharedProcessCrash")));const Pe=(async()=>{this.m.trace("Main->SharedProcess#connect");const Ge=await Se.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new a.$oY(Ge,"main")})();return{sharedProcessReady:(async()=>(await Se.whenReady(),Pe))(),sharedProcessClient:Pe}}async P(Ae,Te,Le,Se){const Pe=new ne.$Gi;switch(process.platform){case"win32":Pe.set(he.$fZ,new F.$Fi(Oe.$gic));break;case"linux":f.$m?Pe.set(he.$fZ,new F.$Fi(je.$fic,[process.env.SNAP,process.env.SNAP_REVISION])):Pe.set(he.$fZ,new F.$Fi(ve.$eic));break;case"darwin":Pe.set(he.$fZ,new F.$Fi(pe.$dic));break}Pe.set(Je.$Zgc,new F.$Fi(Ce.$ric,[Ae,Te,Le,this.h],!1)),Pe.set(St.$Lhc,new F.$Fi(Bt.$Nic,void 0,!1));const qe=new L.$Vgc(this.m,this.z);Pe.set(L.$Ugc,qe),Pe.set(M.$Thc,new F.$Fi(M.$Uhc,void 0,!1)),Pe.set(D.$xhc,new F.$Fi(D.$yhc,void 0,!1)),Pe.set(w.$Wm,S.ProxyChannel.toService((0,S.$oi)(Se.then(Ue=>Ue.getChannel("diagnostics"))))),Pe.set(x.$gbc,new F.$Fi(ce.$Ohc,[this.h])),Pe.set(x.$hbc,new F.$Fi(oe.$Phc,[this.h])),Pe.set(R.$2Y,new F.$Fi(T.$zhc)),Pe.set(J.$Qhc,new F.$Fi(J.$Rhc)),Pe.set(ie.$Mhc,new F.$Fi(ie.$Nhc,void 0,!1)),Pe.set(ze.$lic,new F.$Fi(Ye.$nic)),Pe.set(N.$3hc,new F.$Fi(N.$4hc)),Pe.set(Q.$Ahc,new F.$Fi(de.$Chc)),Pe.set(ye.$mhc,new F.$Fi(ye.$nhc)),Pe.set(ye.$ohc,new F.$Fi(ye.$phc));const Ge=new Nt.$Jic({graceTime:dt.LocalReconnectConstants.GraceTime,shortGraceTime:dt.LocalReconnectConstants.ShortGraceTime,scrollback:this.u.getValue(dt.TerminalSettingId.PersistentSessionScrollback)??100},this.u,this.s,this.t,this.m),Xe=new Ct.$Ws(Ge,this.u,this.m,this.n);Pe.set(dt.$xs,Xe),f.$j?Pe.set(V.$Dhc,new F.$Fi(Y.$Ehc)):f.$k?Pe.set(V.$Dhc,new F.$Fi(Y.$Fhc)):f.$l&&Pe.set(V.$Dhc,new F.$Fi(Y.$Ghc));const Ne=new c.$shc(this.s,this.u,this.m,this.w);Pe.set(n.$Tgc,Ne);const He=new Be.$ahc(this.s,this.m,this.C,Ne,qe);if(Pe.set(Be.$_gc,He),Pe.set(we.$Iib,new F.$Fi(Me.$tic,void 0,!1)),Pe.set(Ee.$Zhc,new F.$Fi(Ee.$1hc,void 0,!1)),Pe.set(De.$8Y,new F.$Fi(Ke.$0Y,void 0,!1)),(0,ee.$Ip)(this.z,this.s)){const Ue=(0,ee.$Np)(this.z,this.u),et=(0,S.$oi)(Se.then(vt=>vt.getChannel("telemetryAppender"))),it=new Re.$$hc(et),ot=(0,Fe.$zp)((0,A.release)(),(0,A.hostname)(),process.arch,this.z.commit,this.z.version,Ae,Te,Le,Ue),nt=(0,ee.$Op)(this.s),ht={appenders:[it],commonProperties:ot,piiPaths:nt,sendErrorTelemetry:!0};Pe.set(Ve.$cm,new F.$Fi($e.$ns,[ht],!1))}else Pe.set(Ve.$cm,ee.$Dp);return Pe.set(ut.$Pq,new F.$Fi(Lt.$3R,void 0,!0)),Pe.set(ct.$Tq,new F.$Fi(ft.$wic,void 0,!0)),Pe.set(pt.$Hic,new F.$Fi(pt.$Iic,void 0,!0)),Pe.set(t.$qhc,new F.$Fi(t.$rhc)),Pe.set(Pt.$aS,new F.$Fi(Pt.$bS,void 0,!0)),await mt.Promises.settled([Ne.initialize(),He.initialize()]),this.j.createChild(Pe)}Q(Ae,Te,Le){const Se=this.B(new $.$Wc),Pe=S.ProxyChannel.fromService(Ae.get(M.$Thc),Se,{disableMarshalling:!0});this.g.registerChannel("launch",Pe);const qe=S.ProxyChannel.fromService(Ae.get(D.$xhc),Se,{disableMarshalling:!0});this.g.registerChannel("diagnostics",qe);const Ge=Se.add(new lt.$uic(Ae.get(_e.$xo)));Te.registerChannel("policy",Ge),Le.then(st=>st.registerChannel("policy",Ge));const Xe=this.y.getProvider(p.Schemas.file);(0,y.$rg)(Xe instanceof W.$zr);const Ne=Se.add(new C.$Hhc(Xe,this.m,this.s));Te.registerChannel(B.$LR,Ne),Le.then(st=>st.registerChannel(B.$LR,Ne));const He=S.ProxyChannel.fromService(Ae.get(rt.$3gc),Se);Te.registerChannel("userDataProfiles",He),Le.then(st=>st.registerChannel("userDataProfiles",He));const Ue=new at.$is(Ae.get(tt.$_p));Le.then(st=>st.registerChannel("request",Ue));const et=new fe.$_hc(Ae.get(he.$fZ));Te.registerChannel("update",et);const it=S.ProxyChannel.fromService(Ae.get(x.$gbc),Se);Te.registerChannel("issue",it);const ot=S.ProxyChannel.fromService(Ae.get(x.$hbc),Se);Te.registerChannel("process",ot);const nt=S.ProxyChannel.fromService(Ae.get(R.$2Y),Se);Te.registerChannel("encryption",nt);const ht=S.ProxyChannel.fromService(Ae.get(ae.$3l),Se);Te.registerChannel("sign",ht);const vt=S.ProxyChannel.fromService(Ae.get(J.$Qhc),Se);Te.registerChannel("keyboardLayout",vt),this.f=Ae.get(ie.$Mhc);const It=S.ProxyChannel.fromService(this.f,Se);Te.registerChannel("nativeHost",It),Le.then(st=>st.registerChannel("nativeHost",It));const Ut=S.ProxyChannel.fromService(Ae.get(we.$Iib),Se);Te.registerChannel("workspaces",Ut);const zt=S.ProxyChannel.fromService(Ae.get(N.$3hc),Se);Te.registerChannel("menubar",zt);const qt=S.ProxyChannel.fromService(Ae.get(De.$8Y),Se);Te.registerChannel("url",qt);const Ht=S.ProxyChannel.fromService(Ae.get(ze.$lic),Se);Te.registerChannel("webview",Ht);const Dt=Se.add(new be.$9hc(this.m,Ae.get(ye.$mhc)));Te.registerChannel("storage",Dt),Le.then(st=>st.registerChannel("storage",Dt));const xt=Se.add(new Tt.$yic(Ae.get(ye.$mhc),Ae.get(rt.$3gc),this.m));Le.then(st=>st.registerChannel("profileStorageListener",xt));const Vt=S.ProxyChannel.fromService(Ae.get(dt.$xs),Se);Te.registerChannel(dt.TerminalIpcChannels.LocalPty,Vt);const Gt=S.ProxyChannel.fromService(Ae.get(V.$Dhc),Se);Te.registerChannel("externalTerminal",Gt);const At=new jt.$Fic(Ae.get(Mt.$bhc));Te.registerChannel("logger",At),Le.then(st=>st.registerChannel("logger",At));const Kt=new P.$thc(Ae.get(Je.$Zgc));Te.registerChannel("extensionhostdebugservice",Kt);const Xt=S.ProxyChannel.fromService(Ae.get(Q.$Ahc),Se);Te.registerChannel(Q.$Bhc,Xt);const Qt=S.ProxyChannel.fromService(Ae.get(pt.$Hic),Se);Te.registerChannel(Ft.$Gic,Qt)}async R(Ae,Te){const Le=this.b=Ae.get(Je.$Zgc);this.c=Ae.get(St.$Lhc);const Se=(0,G.$Nm)(process.env)?Je.OpenContext.CLI:Je.OpenContext.DESKTOP,Pe=this.s.args;if(Te){if(Te.openables.length>0)return Le.open({context:Se,cli:Pe,urisToOpen:Te.openables,gotoLineMode:!0,initialStartup:!0});if(Te.urls.length>0)for(const nt of Te.urls){const ht=new URLSearchParams(nt.uri.query);if(ht.get("windowId")==="_blank")return ht.delete("windowId"),nt.originalUrl=nt.uri.toString(!0),nt.uri=nt.uri.with({query:ht.toString()}),Le.open({context:Se,cli:Pe,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const qe=global.macOpenFiles,Ge=Pe._.length,Xe=!!Pe["folder-uri"],Ne=!!Pe["file-uri"],He=Pe["skip-add-to-recently-opened"]===!0,Ue=Pe.wait&&Pe.waitMarkerFilePath?k.URI.file(Pe.waitMarkerFilePath):void 0,et=Pe.remote||void 0,it=Pe.profile,ot=Pe["profile-temp"];if(!Ge&&!Xe&&!Ne){if(Pe["new-window"]||it||ot)return Le.open({context:Se,cli:Pe,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:He,waitMarkerFileURI:Ue,initialStartup:!0,remoteAuthority:et,forceProfile:it,forceTempProfile:ot});if(qe.length)return Le.open({context:Je.OpenContext.DOCK,cli:Pe,urisToOpen:qe.map(nt=>(nt=(0,kt.$qm)(nt),(0,ge.$bj)(nt)?{workspaceUri:k.URI.file(nt)}:{fileUri:k.URI.file(nt)})),noRecentEntry:He,waitMarkerFileURI:Ue,initialStartup:!0})}return Le.open({context:Se,cli:Pe,forceNewWindow:Pe["new-window"],diffMode:Pe.diff,mergeMode:Pe.merge,noRecentEntry:He,waitMarkerFileURI:Ue,gotoLineMode:Pe.goto,initialStartup:!0,remoteAuthority:et,forceProfile:it,forceTempProfile:ot})}S(){this.U(),i.protocol.registerHttpProtocol(p.Schemas.vscodeRemoteResource,(Ae,Te)=>{Te({url:Ae.url.replace(/^vscode-remote-resource:/,"http:"),method:Ae.method})}),this.W(this.s.args,process.env,!0),this.X(),f.$k&&i.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async U(){const Ae=this.z.win32MutexName;if(f.$j&&Ae)try{const Te=await new Promise((Se,Pe)=>{K(["@vscode/windows-mutex"],Se,Pe)}).then(Ie),Le=new Te.Mutex(Ae);l.Event.once(this.t.onWillShutdown)(()=>Le.release())}catch(Te){this.m.error(Te)}}async W(Ae,Te,Le){try{return await(0,q.$Um)(this.u,this.m,Ae,Te)}catch(Se){const Pe=(0,I.$tj)(Se);Le?this.b?.sendToFocused("vscode:showResolveShellEnvError",Pe):this.m.error(Pe)}return{}}async X(){try{const Te=(await this.y.readFile(this.s.argvResource)).value.toString(),Le=(0,m.parse)(Te),Pe=(0,ee.$Kp)(this.u)>=Ve.TelemetryLevel.CRASH;if(Le["enable-crash-reporter"]===void 0){const qe=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Pe},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,g.$5g)()}"`,"}"],Ge=Te.substring(0,Te.length-2).concat(`,
`,qe.join(`
`));await this.y.writeFile(this.s.argvResource,O.$Qe.fromString(Ge))}else{const qe=Te.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Pe},`);qe!==Te&&await this.y.writeFile(this.s.argvResource,O.$Qe.fromString(qe))}}catch(Ae){this.m.error(Ae),this.b?.sendToFocused("vscode:showArgvParseWarning")}}};e.$Oic=yt,e.$Oic=yt=bt=ke([re(2,H.$Hi),re(3,U.$dk),re(4,U.$ek),re(5,j.$Mgc),re(6,Z.$ghc),re(7,h.$cj),re(8,me.$VR),re(9,_.$dl),re(10,X.$wk),re(11,rt.$3gc)],yt)});var xe=this&&this.__importDefault||function(K){return K&&K.__esModule?K:{default:K}};define(le[287],ue([0,1,13,26,7,21,8,55,15,32,4,48,11,9,72,3,37,25,23,45,107,282,10,16,208,222,20,70,173,14,192,102,84,188,101,19,195,5,63,28,74,249,133,260,49,259,104,221,34,57,77,58,40,204,202,2,41,237,73,197,125,129,241,109,235]),function(K,e,i,r,v,A,O,I,b,l,m,u,$,p,d,f,y,k,g,E,S,s,a,t,o,n,c,h,P,w,D,L,R,T,j,G,q,Q,de,V,Y,B,_,C,W,F,H,ne,x,ce,oe,J,M,Z,U,N,ie,X,z,te,ae,me,be,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),de=xe(de);class Fe{main(){try{this.a()}catch($e){console.error($e.message),i.app.exit(1)}}async a(){(0,b.setUnexpectedErrorHandler)(De=>console.error(De));const[$e,ee,he,fe,pe,ve,je,Oe]=this.b();try{try{await this.d(he,Oe,fe,pe,je)}catch(De){throw this.g(he,je,De),De}await $e.invokeFunction(async De=>{const We=De.get(Q.$dk),Ke=De.get(G.$ghc),Ze=De.get(w.$dl),ze=De.get(Q.$ek),Ye=await this.f(We,he,Ke,$e,je,!0);return g.Promises.writeFile(he.mainLockfile,String(process.pid)).catch(Qe=>{We.warn(`app#startup(): Error writing main lockfile: ${Qe.stack}`)}),ve.logger=ze.createLogger("main",{name:(0,a.localize)(153,null)}),m.Event.once(Ke.onWillShutdown)(Qe=>{Ze.dispose(),fe.dispose(),Qe.join("instanceLockfile",r.promises.unlink(he.mainLockfile).catch(()=>{}))}),$e.createInstance(s.$Oic,Ye,ee).startup()})}catch(De){$e.invokeFunction(this.j,De)}}b(){const $e=new j.$Gi,ee=new N.$Wc;process.once("exit",()=>ee.dispose());const he={_serviceBrand:void 0,...de.default};$e.set(V.$wk,he);const fe=new c.$Ngc(this.k(),he),pe=this.c(fe);$e.set(c.$Mgc,fe);const ve=new z.$chc((0,Q.$rk)(fe),fe.logsHome);$e.set(z.$bhc,ve);const je=new q.$lec(ve.getLogLevel()),Oe=ee.add(new te.$4R(je,[new Q.$kk(ve.getLogLevel())]));$e.set(Q.$dk,Oe);const De=new D.$9q(Oe);$e.set(w.$dl,De);const We=new L.$zr(Oe);De.registerProvider($.Schemas.file,We);const Ke=new X.$1s(De);$e.set(ie.$Nl,Ke);const Ze=new me.$YR(me.SaveStrategy.DELAYED,fe,Oe,De);$e.set(x.$UR,Ze),$e.set(x.$VR,Ze);const ze=new J.$4gc(Ze,Ke,fe,De,Oe);$e.set(J.$3gc,ze),De.registerProvider($.Schemas.vscodeUserData,new be.$Zic($.Schemas.file,We,$.Schemas.vscodeUserData,ze,Ke,Oe));const Ye=f.$j&&he.win32RegValueName?ee.add(new Z.$Xic(Oe,he.win32RegValueName)):fe.policyFile?ee.add(new U.$Yic(fe.policyFile,De,Oe)):new M.$zo;$e.set(M.$xo,Ye);const Qe=new o.$2o(ze.defaultProfile.settingsResource,De,Ye,Oe);return $e.set(t.$cj,Qe),$e.set(G.$ghc,new R.$Fi(G.$hhc,void 0,!1)),$e.set(W.$_p,new R.$Fi(F.$Vic,void 0,!0)),$e.set(oe.$Xgc,new R.$Fi(oe.$Ygc)),$e.set(H.$3l,new R.$Fi(ne.$Wic,void 0,!1)),$e.set(_.$Lw,new R.$Fi(C.$Tic)),$e.set(Y.$Wgc,new B.$Qic(fe,ze,Oe)),[new T.$Cr($e,!0),pe,fe,Qe,Ze,je,he,ze]}c($e){const ee={VSCODE_IPC_HOOK:$e.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(he=>{const fe=process.env[he];typeof fe=="string"&&(ee[he]=fe)}),Object.assign(process.env,ee),ee}async d($e,ee,he,fe,pe){await O.Promises.settled([Promise.all([this.e($e.extensionsPath),$e.codeCachePath,$e.logsHome.with({scheme:$.Schemas.file}).fsPath,ee.defaultProfile.globalStorageHome.with({scheme:$.Schemas.file}).fsPath,$e.workspaceStorageHome.with({scheme:$.Schemas.file}).fsPath,$e.localHistoryHome.with({scheme:$.Schemas.file}).fsPath,$e.backupHome].map(ve=>ve?r.promises.mkdir(ve,{recursive:!0}):void 0)),fe.init(),he.initialize()]),ee.init()}e($e){if(f.$j){const ee=(0,ye.getUNCHost)($e);ee&&(0,ye.addUNCHostToAllowlist)(ee)}return $e}async f($e,ee,he,fe,pe,ve){let je;try{(0,d.mark)("code/willStartMainServer"),je=await(0,S.$Di)(ee.mainIPCHandle),(0,d.mark)("code/didStartMainServer"),m.Event.once(he.onWillShutdown)(()=>je.dispose())}catch(Oe){if(Oe.code!=="EADDRINUSE")throw this.g(ee,pe,Oe),Oe;let De;try{De=await(0,S.$Ei)(ee.mainIPCHandle,"main")}catch(ze){if(!ve||f.$j||ze.code!=="ECONNREFUSED")throw ze.code==="EPERM"&&this.h((0,a.localize)(154,null,pe.nameShort),(0,a.localize)(155,null),pe),ze;try{(0,r.unlinkSync)(ee.mainIPCHandle)}catch(Ye){throw $e.warn("Could not delete obsolete instance handle",Ye),Ye}return this.f($e,ee,he,fe,pe,!1)}if(ee.extensionTestsLocationURI&&!ee.debugExtensionHost.break){const ze=`Running extension tests from the command line is currently only supported if no other instance of ${pe.nameShort} is running.`;throw $e.error(ze),De.dispose(),new Error(ze)}let We;!ee.args.wait&&!ee.args.status&&(We=setTimeout(()=>{this.h((0,a.localize)(156,null,pe.nameShort),(0,a.localize)(157,null),pe)},1e4));const Ke=E.ProxyChannel.toService(De.getChannel("launch"),{disableMarshalling:!0}),Ze=E.ProxyChannel.toService(De.getChannel("diagnostics"),{disableMarshalling:!0});if(ee.args.status)return fe.invokeFunction(async()=>{const ze=new n.$8s(ce.$Dp,pe),Ye=await Ze.getMainDiagnostics(),Qe=await Ze.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Je=await ze.getDiagnostics(Ye,Qe);throw console.log(Je),new b.$cb});throw f.$j&&await this.i(Ke,$e),$e.trace("Sending env to running instance..."),await Ke.start(ee.args,process.env),De.dispose(),We&&clearTimeout(We),new b.$cb("Sent env to running instance. Terminating...")}if(ee.args.status)throw console.log((0,a.localize)(158,null,pe.nameShort)),new b.$cb("Terminating...");return process.env.VSCODE_PID=String(process.pid),je}g($e,ee,he){if(he.code==="EACCES"||he.code==="EPERM"){const fe=(0,A.$Jb)([$e.userDataPath,$e.extensionsPath,S.$zi]).map(pe=>(0,u.$7w)(v.URI.file(pe),{os:f.OS,tildify:$e}));this.h((0,a.localize)(159,null),(0,a.localize)(160,null,(0,I.$tj)(he),fe.join(`
`)),ee)}}h($e,ee,he){i.dialog.showMessageBoxSync((0,ae.$ix)({type:"warning",buttons:[(0,a.localize)(161,null)],message:$e,detail:ee},he).options)}async i($e,ee){if(f.$j){const he=await $e.getMainProcessId();ee.trace("Sending some foreground love to the running instance:",he);try{(await new Promise((fe,pe)=>{K(["windows-foreground-love"],fe,pe)}).then(Ie)).allowSetForegroundWindow(he)}catch(fe){ee.error(fe)}}}j($e,ee){const he=$e.get(Q.$dk),fe=$e.get(G.$ghc);let pe=0;ee&&(ee.isExpected?ee.message&&he.trace(ee.message):(pe=1,ee.stack?he.error(ee.stack):he.error(`Startup error: ${ee.toString()}`))),fe.kill(pe)}k(){const $e=this.l((0,h.$Km)(process.argv));if($e.wait&&!$e.waitMarkerFilePath){const ee=(0,P.$Pic)($e.verbose);ee&&((0,h.$Mm)(process.argv,"--waitMarkerFilePath",ee),$e.waitMarkerFilePath=ee)}return $e}l($e){if($e["open-url"]&&($e._urls=$e._,$e._=[]),!$e.remote){const ee=this.m($e._,$e.goto);$e._=ee}return $e}m($e,ee){const he=(0,y.cwd)(),fe=$e.map(je=>{let Oe=String(je),De;ee&&(De=(0,l.$Pg)(Oe),Oe=De.path),Oe&&(Oe=this.n(he,Oe));const We=(0,l.$Jg)(Oe,he),Ke=(0,p.$qc)(We);return Ke&&!(0,l.$Fg)(Ke)?null:ee&&De?(De.path=We,this.o(De)):We}),pe=f.$j||f.$k,ve=(0,A.$Ob)(fe,je=>je&&pe?je.toLowerCase():je||"");return(0,A.$Jb)(ve)}n($e,ee){return f.$j&&(ee=(0,k.$qf)(ee,'"')),ee=(0,k.$of)((0,k.$of)(ee," "),"	"),f.$j&&(ee=(0,p.$nc)($e,ee),ee=(0,k.$qf)(ee,".")),ee}o($e){const ee=[$e.path];return typeof $e.line=="number"&&ee.push(String($e.line)),typeof $e.column=="number"&&ee.push(String($e.column)),ee.join(":")}}new Fe().main()})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/c2aa3c4625ed4b46448fa546ac5f2e93b0757718/core/vs/code/electron-main/main.js.map
