/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var fe=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/uri","vs/platform/log/common/log","vs/nls","vs/base/common/types","vs/base/common/path","vs/base/common/buffer","vs/platform/environment/common/environment","vs/platform/storage/common/storage","vs/base/common/arrays","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/base/node/pfs","vs/base/common/map","vs/base/common/uuid","fs","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/process","os","vs/base/common/charCode","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/externalServices/common/serviceMachineId","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/hash","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/marshallingIds","vs/base/common/marshalling","vs/amdX","net","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/common/date","vs/base/node/zip","vs/platform/instantiation/common/descriptors","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationModels","vs/platform/languagePacks/common/languagePacks","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/amd","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/processes","vs/base/common/severity","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/jsonSchema","vs/base/common/desktopEnvironmentInfo","vs/base/common/mime","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/uint","vs/base/common/console","vs/base/node/macAddress","vs/base/node/id","vs/base/node/nodeStreams","vs/base/node/osDisplayProtocolInfo","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/ports","vs/base/node/processes","vs/base/node/ps","vs/base/parts/request/common/request","vs/base/parts/sandbox/node/electronTypes","vs/base/parts/ipc/node/ipc.mp","vs/base/common/jsonErrorMessages","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/node/extensionsManifestCache","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","readline","util","path","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],de=function(ce){for(var e=[],R=0,a=ce.length;R<a;R++)e[R]=fe[ce[R]];return e};define(fe[88],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=e.LoaderEventType=e.$U=e.$T=void 0,e.$T=!1,e.$U=!0;var R;(function(N){N[N.LoaderAvailable=1]="LoaderAvailable",N[N.BeginLoadingScript=10]="BeginLoadingScript",N[N.EndLoadingScriptOK=11]="EndLoadingScriptOK",N[N.EndLoadingScriptError=12]="EndLoadingScriptError",N[N.BeginInvokeFactory=21]="BeginInvokeFactory",N[N.EndInvokeFactory=22]="EndInvokeFactory",N[N.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",N[N.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",N[N.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",N[N.NodeEndNativeRequire=34]="NodeEndNativeRequire",N[N.CachedDataFound=60]="CachedDataFound",N[N.CachedDataMissed=61]="CachedDataMissed",N[N.CachedDataRejected=62]="CachedDataRejected",N[N.CachedDataCreated=63]="CachedDataCreated"})(R||(e.LoaderEventType=R={}));class a{static get(){const A=new Map,T=new Map,k=new Map,O=new Map;function y(l,d){l.has(d.detail)||l.set(d.detail,-d.timestamp)}function I(l,d){const E=l.get(d.detail);E&&(E>=0||l.set(d.detail,E+d.timestamp))}let p=[];typeof ce=="function"&&typeof ce.getStats=="function"&&(p=ce.getStats().slice(0).sort((l,d)=>l.timestamp-d.timestamp));for(const l of p)switch(l.type){case R.BeginLoadingScript:y(A,l);break;case R.EndLoadingScriptOK:case R.EndLoadingScriptError:I(A,l);break;case R.BeginInvokeFactory:y(T,l);break;case R.EndInvokeFactory:I(T,l);break;case R.NodeBeginNativeRequire:y(k,l);break;case R.NodeEndNativeRequire:I(k,l);break;case R.NodeBeginEvaluatingScript:y(O,l);break;case R.NodeEndEvaluatingScript:I(O,l);break}let $=0;k.forEach(l=>$+=l);function g(l){const d=[];return l.forEach((E,w)=>d.push([w,E])),d}return{amdLoad:g(A),amdInvoke:g(T),nodeRequire:g(k),nodeEval:g(O),nodeRequireTotal:$}}static toMarkdownTable(A,T){let k="";const O=[];return A.forEach((y,I)=>{O[I]=y.length}),T.forEach(y=>{y.forEach((I,p)=>{typeof I>"u"&&(I=y[p]="-");const $=I.toString().length;O[p]=Math.max($,O[p])})}),A.forEach((y,I)=>{k+=`| ${y+" ".repeat(O[I]-y.toString().length)} `}),k+=`|
`,A.forEach((y,I)=>{k+=`| ${"-".repeat(O[I])} `}),k+=`|
`,T.forEach(y=>{y.forEach((I,p)=>{typeof I<"u"&&(k+=`| ${I+" ".repeat(O[p]-I.toString().length)} `)}),k+=`|
`}),k}}e.$V=a}),define(fe[130],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ob=void 0,e.$hb=R,e.$ib=a,e.$jb=N,e.$kb=A,e.$lb=T,e.$mb=k,e.$nb=O,e.$pb=I,e.$qb=p,e.$rb=$,e.$sb=g,e.$tb=l;function R(d,E){const w=a(d,E);if(w!==-1)return d[w]}function a(d,E,w=d.length-1){for(let f=w;f>=0;f--){const P=d[f];if(E(P))return f}return-1}function N(d,E){const w=A(d,E);return w===-1?void 0:d[w]}function A(d,E,w=0,f=d.length){let P=w,m=f;for(;P<m;){const c=Math.floor((P+m)/2);E(d[c])?P=c+1:m=c}return P-1}function T(d,E){const w=k(d,E);return w===d.length?void 0:d[w]}function k(d,E,w=0,f=d.length){let P=w,m=f;for(;P<m;){const c=Math.floor((P+m)/2);E(d[c])?m=c:P=c+1}return P}function O(d,E,w=0,f=d.length){const P=k(d,E,w,f);return P===d.length?-1:P}class y{static{this.assertInvariants=!1}constructor(E){this.e=E,this.c=0}findLastMonotonous(E){if(y.assertInvariants){if(this.d){for(const f of this.e)if(this.d(f)&&!E(f))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=E}const w=A(this.e,E,this.c);return this.c=w+1,w===-1?void 0:this.e[w]}}e.$ob=y;function I(d,E){if(d.length===0)return;let w=d[0];for(let f=1;f<d.length;f++){const P=d[f];E(P,w)>0&&(w=P)}return w}function p(d,E){if(d.length===0)return;let w=d[0];for(let f=1;f<d.length;f++){const P=d[f];E(P,w)>=0&&(w=P)}return w}function $(d,E){return I(d,(w,f)=>-E(w,f))}function g(d,E){if(d.length===0)return-1;let w=0;for(let f=1;f<d.length;f++){const P=d[f];E(P,d[w])>0&&(w=f)}return w}function l(d,E){for(const w of d){const f=E(w);if(f!==void 0)return f}}}),define(fe[39],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var R;(function(a){a[a.Null=0]="Null",a[a.Backspace=8]="Backspace",a[a.Tab=9]="Tab",a[a.LineFeed=10]="LineFeed",a[a.CarriageReturn=13]="CarriageReturn",a[a.Space=32]="Space",a[a.ExclamationMark=33]="ExclamationMark",a[a.DoubleQuote=34]="DoubleQuote",a[a.Hash=35]="Hash",a[a.DollarSign=36]="DollarSign",a[a.PercentSign=37]="PercentSign",a[a.Ampersand=38]="Ampersand",a[a.SingleQuote=39]="SingleQuote",a[a.OpenParen=40]="OpenParen",a[a.CloseParen=41]="CloseParen",a[a.Asterisk=42]="Asterisk",a[a.Plus=43]="Plus",a[a.Comma=44]="Comma",a[a.Dash=45]="Dash",a[a.Period=46]="Period",a[a.Slash=47]="Slash",a[a.Digit0=48]="Digit0",a[a.Digit1=49]="Digit1",a[a.Digit2=50]="Digit2",a[a.Digit3=51]="Digit3",a[a.Digit4=52]="Digit4",a[a.Digit5=53]="Digit5",a[a.Digit6=54]="Digit6",a[a.Digit7=55]="Digit7",a[a.Digit8=56]="Digit8",a[a.Digit9=57]="Digit9",a[a.Colon=58]="Colon",a[a.Semicolon=59]="Semicolon",a[a.LessThan=60]="LessThan",a[a.Equals=61]="Equals",a[a.GreaterThan=62]="GreaterThan",a[a.QuestionMark=63]="QuestionMark",a[a.AtSign=64]="AtSign",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.OpenSquareBracket=91]="OpenSquareBracket",a[a.Backslash=92]="Backslash",a[a.CloseSquareBracket=93]="CloseSquareBracket",a[a.Caret=94]="Caret",a[a.Underline=95]="Underline",a[a.BackTick=96]="BackTick",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z",a[a.OpenCurlyBrace=123]="OpenCurlyBrace",a[a.Pipe=124]="Pipe",a[a.CloseCurlyBrace=125]="CloseCurlyBrace",a[a.Tilde=126]="Tilde",a[a.NoBreakSpace=160]="NoBreakSpace",a[a.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",a[a.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",a[a.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",a[a.U_Combining_Tilde=771]="U_Combining_Tilde",a[a.U_Combining_Macron=772]="U_Combining_Macron",a[a.U_Combining_Overline=773]="U_Combining_Overline",a[a.U_Combining_Breve=774]="U_Combining_Breve",a[a.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",a[a.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",a[a.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",a[a.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",a[a.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",a[a.U_Combining_Caron=780]="U_Combining_Caron",a[a.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",a[a.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",a[a.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",a[a.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",a[a.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",a[a.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",a[a.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",a[a.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",a[a.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",a[a.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",a[a.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",a[a.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",a[a.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",a[a.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",a[a.U_Combining_Horn=795]="U_Combining_Horn",a[a.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",a[a.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",a[a.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",a[a.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",a[a.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",a[a.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",a[a.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",a[a.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",a[a.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",a[a.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",a[a.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",a[a.U_Combining_Cedilla=807]="U_Combining_Cedilla",a[a.U_Combining_Ogonek=808]="U_Combining_Ogonek",a[a.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",a[a.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",a[a.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",a[a.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",a[a.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",a[a.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",a[a.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",a[a.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",a[a.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",a[a.U_Combining_Low_Line=818]="U_Combining_Low_Line",a[a.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",a[a.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",a[a.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",a[a.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",a[a.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",a[a.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",a[a.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",a[a.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",a[a.U_Combining_Square_Below=827]="U_Combining_Square_Below",a[a.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",a[a.U_Combining_X_Above=829]="U_Combining_X_Above",a[a.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",a[a.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",a[a.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",a[a.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",a[a.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",a[a.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",a[a.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",a[a.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",a[a.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",a[a.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",a[a.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",a[a.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",a[a.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",a[a.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",a[a.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",a[a.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",a[a.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",a[a.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",a[a.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",a[a.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",a[a.U_Combining_Fermata=850]="U_Combining_Fermata",a[a.U_Combining_X_Below=851]="U_Combining_X_Below",a[a.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",a[a.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",a[a.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",a[a.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",a[a.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",a[a.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",a[a.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",a[a.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",a[a.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",a[a.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",a[a.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",a[a.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",a[a.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",a[a.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",a[a.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",a[a.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",a[a.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",a[a.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",a[a.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",a[a.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",a[a.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",a[a.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",a[a.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",a[a.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",a[a.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",a[a.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",a[a.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",a[a.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",a[a.LINE_SEPARATOR=8232]="LINE_SEPARATOR",a[a.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",a[a.NEXT_LINE=133]="NEXT_LINE",a[a.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",a[a.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",a[a.U_DIAERESIS=168]="U_DIAERESIS",a[a.U_MACRON=175]="U_MACRON",a[a.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",a[a.U_CEDILLA=184]="U_CEDILLA",a[a.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",a[a.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",a[a.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",a[a.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",a[a.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",a[a.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",a[a.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",a[a.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",a[a.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",a[a.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",a[a.U_BREVE=728]="U_BREVE",a[a.U_DOT_ABOVE=729]="U_DOT_ABOVE",a[a.U_RING_ABOVE=730]="U_RING_ABOVE",a[a.U_OGONEK=731]="U_OGONEK",a[a.U_SMALL_TILDE=732]="U_SMALL_TILDE",a[a.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",a[a.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",a[a.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",a[a.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",a[a.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",a[a.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",a[a.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",a[a.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",a[a.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",a[a.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",a[a.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",a[a.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",a[a.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",a[a.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",a[a.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",a[a.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",a[a.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",a[a.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",a[a.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",a[a.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",a[a.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",a[a.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",a[a.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",a[a.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",a[a.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",a[a.U_GREEK_TONOS=900]="U_GREEK_TONOS",a[a.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",a[a.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",a[a.U_GREEK_PSILI=8127]="U_GREEK_PSILI",a[a.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",a[a.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",a[a.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",a[a.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",a[a.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",a[a.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",a[a.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",a[a.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",a[a.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",a[a.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",a[a.U_GREEK_VARIA=8175]="U_GREEK_VARIA",a[a.U_GREEK_OXIA=8189]="U_GREEK_OXIA",a[a.U_GREEK_DASIA=8190]="U_GREEK_DASIA",a[a.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",a[a.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",a[a.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",a[a.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",a[a.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",a[a.U_OVERLINE=8254]="U_OVERLINE",a[a.UTF8_BOM=65279]="UTF8_BOM",a[a.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",a[a.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(R||(e.CharCode=R={}))}),define(fe[131],de([0,1]),function(ce,e){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$g=void 0,e.$c=a,e.$d=N,e.$e=A,e.$f=T;function a(O,y){const I=Object.create(null);for(const p of O){const $=y(p);let g=I[$];g||(g=I[$]=[]),g.push(p)}return I}function N(O,y){const I=[],p=[];for(const $ of O)y.has($)||I.push($);for(const $ of y)O.has($)||p.push($);return{removed:I,added:p}}function A(O,y){const I=[],p=[];for(const[$,g]of O)y.has($)||I.push(g);for(const[$,g]of y)O.has($)||p.push(g);return{removed:I,added:p}}function T(O,y){const I=new Set;for(const p of y)O.has(p)&&I.add(p);return I}class k{static{R=Symbol.toStringTag}constructor(y,I){this.b=I,this.a=new Map,this[R]="SetWithKey";for(const p of y)this.add(p)}get size(){return this.a.size}add(y){const I=this.b(y);return this.a.set(I,y),this}delete(y){return this.a.delete(this.b(y))}has(y){return this.a.has(this.b(y))}*entries(){for(const y of this.a.values())yield[y,y]}keys(){return this.values()}*values(){for(const y of this.a.values())yield y}clear(){this.a.clear()}forEach(y,I){this.a.forEach(p=>y.call(I,p,p,this))}[Symbol.iterator](){return this.values()}}e.$g=k}),define(fe[89],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=a,e.$bi=N,e.$ci=A;function R(T){return(k,O,y)=>{let I=null,p=null;if(typeof y.value=="function"?(I="value",p=y.value):typeof y.get=="function"&&(I="get",p=y.get),!p)throw new Error("not supported");y[I]=T(p,O)}}function a(T,k,O){let y=null,I=null;if(typeof O.value=="function"?(y="value",I=O.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof O.get=="function"&&(y="get",I=O.get),!I)throw new Error("not supported");const p=`$memoize$${k}`;O[y]=function(...$){return this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,$)}),this[p]}}function N(T,k,O){return R((y,I)=>{const p=`$debounce$${I}`,$=`$debounce$result$${I}`;return function(...g){this[$]||(this[$]=O?O():void 0),clearTimeout(this[p]),k&&(this[$]=k(this[$],...g),g=[this[$]]),this[p]=setTimeout(()=>{y.apply(this,g),this[$]=O?O():void 0},T)}})}function A(T,k,O){return R((y,I)=>{const p=`$throttle$timer$${I}`,$=`$throttle$result$${I}`,g=`$throttle$lastRun$${I}`,l=`$throttle$pending$${I}`;return function(...d){if(this[$]||(this[$]=O?O():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),k&&(this[$]=k(this[$],...d)),this[l])return;const E=this[g]+T;E<=Date.now()?(this[g]=Date.now(),y.apply(this,[this[$]]),this[$]=O?O():void 0):(this[l]=!0,this[p]=setTimeout(()=>{this[l]=!1,this[g]=Date.now(),y.apply(this,[this[$]]),this[$]=O?O():void 0},E-Date.now()))}})}}),define(fe[8],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eb=e.$db=e.$cb=e.$bb=e.$ab=e.$$=e.$7=e.$Y=e.$X=void 0,e.setUnexpectedErrorHandler=a,e.$1=N,e.$2=A,e.$3=T,e.$4=k,e.$5=O,e.$6=I,e.$8=$,e.$9=g,e.$0=l,e.$_=E;class R{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?m.isErrorNoTelemetry(i)?new m(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(n=>{n(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$X=R,e.$Y=new R;function a(h){e.$Y.setUnexpectedErrorHandler(h)}function N(h){if(!h||typeof h!="object")return!1;const i=h;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function A(h){I(h)||e.$Y.onUnexpectedError(h)}function T(h){I(h)||e.$Y.onUnexpectedExternalError(h)}function k(h){if(h instanceof Error){const{name:i,message:n}=h,t=h.stacktrace||h.stack;return{$isError:!0,name:i,message:n,stack:t,noTelemetry:m.isErrorNoTelemetry(h)}}return h}function O(h){let i;return h.noTelemetry?i=new m:(i=new Error,i.name=h.name),i.message=h.message,i.stack=h.stack,i}const y="Canceled";function I(h){return h instanceof p?!0:h instanceof Error&&h.name===y&&h.message===y}class p extends Error{constructor(){super(y),this.name=this.message}}e.$7=p;function $(){const h=new Error(y);return h.name=h.message,h}function g(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}function l(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}class d extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$$=d;function E(h){return h?h.message?h.message:h.stack?h.stack.split(`
`)[0]:String(h):"Error"}class w extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$ab=w;class f extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$bb=f;class P extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$cb=P;class m extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof m)return i;const n=new m;return n.message=i.message,n.stack=i.stack,n}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$db=m;class c extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,c.prototype)}}e.$eb=c}),define(fe[17],de([0,1,8,130]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cc=e.$bc=e.$ac=e.$$b=e.$0b=e.CompareResult=void 0,e.$ub=N,e.$vb=A,e.$wb=T,e.$xb=k,e.$yb=O,e.$zb=y,e.$Ab=I,e.$Bb=p,e.$Cb=$,e.$Db=g,e.$Eb=l,e.$Fb=d,e.$Gb=E,e.top=w,e.$Ib=f,e.$Jb=m,e.$Kb=c,e.$Lb=h,e.$Mb=i,e.$Nb=n,e.$Ob=t,e.$Pb=s,e.$Qb=r,e.$Rb=o,e.$Sb=u,e.$Tb=b,e.$Ub=C,e.$Vb=S,e.$Wb=v,e.$Xb=L,e.$Yb=U,e.$Zb=j,e.$1b=F,e.$2b=G,e.$3b=V,e.$4b=x,e.$5b=H,e.$6b=te,e.$7b=B,e.$8b=ne,e.$9b=le,e.$_b=K,e.$dc=oe;function N(Z,Y=0){return Z[Z.length-(1+Y)]}function A(Z){if(Z.length===0)throw new Error("Invalid tail call");return[Z.slice(0,Z.length-1),Z[Z.length-1]]}function T(Z,Y,M=(z,ie)=>z===ie){if(Z===Y)return!0;if(!Z||!Y||Z.length!==Y.length)return!1;for(let z=0,ie=Z.length;z<ie;z++)if(!M(Z[z],Y[z]))return!1;return!0}function k(Z,Y){const M=Z.length-1;Y<M&&(Z[Y]=Z[M]),Z.pop()}function O(Z,Y,M){return y(Z.length,z=>M(Z[z],Y))}function y(Z,Y){let M=0,z=Z-1;for(;M<=z;){const ie=(M+z)/2|0,ae=Y(ie);if(ae<0)M=ie+1;else if(ae>0)z=ie-1;else return ie}return-(M+1)}function I(Z,Y,M){if(Z=Z|0,Z>=Y.length)throw new TypeError("invalid index");const z=Y[Math.floor(Y.length*Math.random())],ie=[],ae=[],ue=[];for(const pe of Y){const be=M(pe,z);be<0?ie.push(pe):be>0?ae.push(pe):ue.push(pe)}return Z<ie.length?I(Z,ie,M):Z<ie.length+ue.length?ue[0]:I(Z-(ie.length+ue.length),ae,M)}function p(Z,Y){const M=[];let z;for(const ie of Z.slice(0).sort(Y))!z||Y(z[0],ie)!==0?(z=[ie],M.push(z)):z.push(ie);return M}function*$(Z,Y){let M,z;for(const ie of Z)z!==void 0&&Y(z,ie)?M.push(ie):(M&&(yield M),M=[ie]),z=ie;M&&(yield M)}function g(Z,Y){for(let M=0;M<=Z.length;M++)Y(M===0?void 0:Z[M-1],M===Z.length?void 0:Z[M])}function l(Z,Y){for(let M=0;M<Z.length;M++)Y(M===0?void 0:Z[M-1],Z[M],M+1===Z.length?void 0:Z[M+1])}function d(Z,Y,M){const z=[];function ie(pe,be,Re){if(be===0&&Re.length===0)return;const Ae=z[z.length-1];Ae&&Ae.start+Ae.deleteCount===pe?(Ae.deleteCount+=be,Ae.toInsert.push(...Re)):z.push({start:pe,deleteCount:be,toInsert:Re})}let ae=0,ue=0;for(;;){if(ae===Z.length){ie(ae,0,Y.slice(ue));break}if(ue===Y.length){ie(ae,Z.length-ae,[]);break}const pe=Z[ae],be=Y[ue],Re=M(pe,be);Re===0?(ae+=1,ue+=1):Re<0?(ie(ae,1,[]),ae+=1):Re>0&&(ie(ae,0,[be]),ue+=1)}return z}function E(Z,Y,M){const z=d(Z,Y,M),ie=[],ae=[];for(const ue of z)ie.push(...Z.slice(ue.start,ue.start+ue.deleteCount)),ae.push(...ue.toInsert);return{removed:ie,added:ae}}function w(Z,Y,M){if(M===0)return[];const z=Z.slice(0,M).sort(Y);return P(Z,Y,z,M,Z.length),z}function f(Z,Y,M,z,ie){return M===0?Promise.resolve([]):new Promise((ae,ue)=>{(async()=>{const pe=Z.length,be=Z.slice(0,M).sort(Y);for(let Re=M,Ae=Math.min(M+z,pe);Re<pe;Re=Ae,Ae=Math.min(Ae+z,pe)){if(Re>M&&await new Promise(ye=>setTimeout(ye)),ie&&ie.isCancellationRequested)throw new R.$7;P(Z,Y,be,Re,Ae)}return be})().then(ae,ue)})}function P(Z,Y,M,z,ie){for(const ae=M.length;z<ie;z++){const ue=Z[z];if(Y(ue,M[ae-1])<0){M.pop();const pe=(0,a.$mb)(M,be=>Y(ue,be)<0);M.splice(pe,0,ue)}}}function m(Z){return Z.filter(Y=>!!Y)}function c(Z){let Y=0;for(let M=0;M<Z.length;M++)Z[M]&&(Z[Y]=Z[M],Y+=1);Z.length=Y}function h(Z,Y,M){Z.splice(M,0,Z.splice(Y,1)[0])}function i(Z){return!Array.isArray(Z)||Z.length===0}function n(Z){return Array.isArray(Z)&&Z.length>0}function t(Z,Y=M=>M){const M=new Set;return Z.filter(z=>{const ie=Y(z);return M.has(ie)?!1:(M.add(ie),!0)})}function s(Z){const Y=new Set;return M=>{const z=Z(M);return Y.has(z)?!1:(Y.add(z),!0)}}function r(Z,Y){return Z.length>0?Z[0]:Y}function o(Z,Y){return Z.length>0?Z[Z.length-1]:Y}function u(Z,Y,M=(z,ie)=>z===ie){let z=0;for(let ie=0,ae=Math.min(Z.length,Y.length);ie<ae&&M(Z[ie],Y[ie]);ie++)z++;return z}function b(Z,Y){let M=typeof Y=="number"?Z:0;typeof Y=="number"?M=Z:(M=0,Y=Z);const z=[];if(M<=Y)for(let ie=M;ie<Y;ie++)z.push(ie);else for(let ie=M;ie>Y;ie--)z.push(ie);return z}function C(Z,Y,M){return Z.reduce((z,ie)=>(z[Y(ie)]=M?M(ie):ie,z),Object.create(null))}function S(Z,Y){return Z.push(Y),()=>v(Z,Y)}function v(Z,Y){const M=Z.indexOf(Y);if(M>-1)return Z.splice(M,1),Y}function L(Z,Y,M){const z=Z.slice(0,Y),ie=Z.slice(Y);return z.concat(M,ie)}function U(Z,Y){let M;if(typeof Y=="number"){let z=Y;M=()=>{const ie=Math.sin(z++)*179426549;return ie-Math.floor(ie)}}else M=Math.random;for(let z=Z.length-1;z>0;z-=1){const ie=Math.floor(M()*(z+1)),ae=Z[z];Z[z]=Z[ie],Z[ie]=ae}}function j(Z,Y){const M=Z.indexOf(Y);M>-1&&(Z.splice(M,1),Z.unshift(Y))}function F(Z,Y){const M=Z.indexOf(Y);M>-1&&(Z.splice(M,1),Z.push(Y))}function G(Z,Y){for(const M of Y)Z.push(M)}function V(Z,Y){return Array.isArray(Z)?Z.map(Y):Y(Z)}function x(Z){return Array.isArray(Z)?Z:[Z]}function H(Z){return Z[Math.floor(Math.random()*Z.length)]}function te(Z,Y,M){const z=W(Z,Y),ie=Z.length,ae=M.length;Z.length=ie+ae;for(let ue=ie-1;ue>=z;ue--)Z[ue+ae]=Z[ue];for(let ue=0;ue<ae;ue++)Z[ue+z]=M[ue]}function B(Z,Y,M,z){const ie=W(Z,Y);let ae=Z.splice(ie,M);return ae===void 0&&(ae=[]),te(Z,ie,z),ae}function W(Z,Y){return Y<0?Math.max(Y+Z.length,0):Math.min(Y,Z.length)}var _;(function(Z){function Y(ae){return ae<0}Z.isLessThan=Y;function M(ae){return ae<=0}Z.isLessThanOrEqual=M;function z(ae){return ae>0}Z.isGreaterThan=z;function ie(ae){return ae===0}Z.isNeitherLessOrGreaterThan=ie,Z.greaterThan=1,Z.lessThan=-1,Z.neitherLessOrGreaterThan=0})(_||(e.CompareResult=_={}));function ne(Z,Y){return(M,z)=>Y(Z(M),Z(z))}function le(...Z){return(Y,M)=>{for(const z of Z){const ie=z(Y,M);if(!_.isNeitherLessOrGreaterThan(ie))return ie}return _.neitherLessOrGreaterThan}}const ee=(Z,Y)=>Z-Y;e.$0b=ee;const J=(Z,Y)=>(0,e.$0b)(Z?1:0,Y?1:0);e.$$b=J;function K(Z){return(Y,M)=>-Z(Y,M)}class q{constructor(Y){this.g=Y,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(Y){let M=this.c;for(;M<this.g.length&&Y(this.g[M]);)M++;const z=M===this.c?null:this.g.slice(this.c,M);return this.c=M,z}takeFromEndWhile(Y){let M=this.d;for(;M>=0&&Y(this.g[M]);)M--;const z=M===this.d?null:this.g.slice(M+1,this.d+1);return this.d=M,z}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const Y=this.g[this.c];return this.c++,Y}removeLast(){const Y=this.g[this.d];return this.d--,Y}takeCount(Y){const M=this.g.slice(this.c,this.c+Y);return this.c+=Y,M}}e.$ac=q;class D{static{this.empty=new D(Y=>{})}constructor(Y){this.iterate=Y}forEach(Y){this.iterate(M=>(Y(M),!0))}toArray(){const Y=[];return this.iterate(M=>(Y.push(M),!0)),Y}filter(Y){return new D(M=>this.iterate(z=>Y(z)?M(z):!0))}map(Y){return new D(M=>this.iterate(z=>M(Y(z))))}some(Y){let M=!1;return this.iterate(z=>(M=Y(z),!M)),M}findFirst(Y){let M;return this.iterate(z=>Y(z)?(M=z,!1):!0),M}findLast(Y){let M;return this.iterate(z=>(Y(z)&&(M=z),!0)),M}findLastMaxBy(Y){let M,z=!0;return this.iterate(ie=>((z||_.isGreaterThan(Y(ie,M)))&&(z=!1,M=ie),!0)),M}}e.$bc=D;class Q{constructor(Y){this.c=Y}static createSortPermutation(Y,M){const z=Array.from(Y.keys()).sort((ie,ae)=>M(Y[ie],Y[ae]));return new Q(z)}apply(Y){return Y.map((M,z)=>Y[this.c[z]])}inverse(){const Y=this.c.slice();for(let M=0;M<this.c.length;M++)Y[this.c[M]]=M;return new Q(Y)}}e.$cc=Q;async function oe(Z,Y){return(await Promise.all(Z.map(async(z,ie)=>({element:z,ok:await Y(z,ie)})))).find(z=>z.ok)?.element}}),define(fe[132],de([0,1,8]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=a,e.$hd=N,e.$id=A,e.$jd=T,e.$kd=k,e.$ld=O;function a(y,I){if(!y)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}function N(y,I="Unreachable"){throw new Error(I)}function A(y,I="unexpected state"){if(!y)throw new R.$eb(`Assertion Failed: ${I}`)}function T(y){y||(0,R.$2)(new R.$eb("Soft Assertion Failed"))}function k(y){if(!y()){debugger;y(),(0,R.$2)(new R.$eb("Assertion Failed"))}}function O(y,I){let p=0;for(;p<y.length-1;){const $=y[p],g=y[p+1];if(!I($,g))return!1;p++}return!0}}),define(fe[90],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fb=R;function R(a,N){const A=this;let T=!1,k;return function(){if(T)return k;if(T=!0,N)try{k=a.apply(A,arguments)}finally{N()}else k=a.apply(A,arguments);return k}}}),define(fe[63],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var R;(function(a){function N(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}a.is=N;const A=Object.freeze([]);function T(){return A}a.empty=T;function*k(i){yield i}a.single=k;function O(i){return N(i)?i:k(i)}a.wrap=O;function y(i){return i||A}a.from=y;function*I(i){for(let n=i.length-1;n>=0;n--)yield i[n]}a.reverse=I;function p(i){return!i||i[Symbol.iterator]().next().done===!0}a.isEmpty=p;function $(i){return i[Symbol.iterator]().next().value}a.first=$;function g(i,n){let t=0;for(const s of i)if(n(s,t++))return!0;return!1}a.some=g;function l(i,n){for(const t of i)if(n(t))return t}a.find=l;function*d(i,n){for(const t of i)n(t)&&(yield t)}a.filter=d;function*E(i,n){let t=0;for(const s of i)yield n(s,t++)}a.map=E;function*w(i,n){let t=0;for(const s of i)yield*n(s,t++)}a.flatMap=w;function*f(...i){for(const n of i)yield*n}a.concat=f;function P(i,n,t){let s=t;for(const r of i)s=n(s,r);return s}a.reduce=P;function*m(i,n,t=i.length){for(n<0&&(n+=i.length),t<0?t+=i.length:t>i.length&&(t=i.length);n<t;n++)yield i[n]}a.slice=m;function c(i,n=Number.POSITIVE_INFINITY){const t=[];if(n===0)return[t,i];const s=i[Symbol.iterator]();for(let r=0;r<n;r++){const o=s.next();if(o.done)return[t,a.empty()];t.push(o.value)}return[t,{[Symbol.iterator](){return s}}]}a.consume=c;async function h(i){const n=[];for await(const t of i)n.push(t);return Promise.resolve(n)}a.asyncToArray=h})(R||(e.Iterable=R={}))}),define(fe[36],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$1n=T,e.$2n=p,e.$3n=$,e.$4n=g,e.$5n=l,e.$6n=d,e.$7n=E,e.$8n=w,e.$9n=f,e.$0n=P,e.$$n=m;var R;(function(c){c[c.None=0]="None",c[c.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",c[c.UnexpectedEndOfString=2]="UnexpectedEndOfString",c[c.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",c[c.InvalidUnicode=4]="InvalidUnicode",c[c.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",c[c.InvalidCharacter=6]="InvalidCharacter"})(R||(e.ScanError=R={}));var a;(function(c){c[c.OpenBraceToken=1]="OpenBraceToken",c[c.CloseBraceToken=2]="CloseBraceToken",c[c.OpenBracketToken=3]="OpenBracketToken",c[c.CloseBracketToken=4]="CloseBracketToken",c[c.CommaToken=5]="CommaToken",c[c.ColonToken=6]="ColonToken",c[c.NullKeyword=7]="NullKeyword",c[c.TrueKeyword=8]="TrueKeyword",c[c.FalseKeyword=9]="FalseKeyword",c[c.StringLiteral=10]="StringLiteral",c[c.NumericLiteral=11]="NumericLiteral",c[c.LineCommentTrivia=12]="LineCommentTrivia",c[c.BlockCommentTrivia=13]="BlockCommentTrivia",c[c.LineBreakTrivia=14]="LineBreakTrivia",c[c.Trivia=15]="Trivia",c[c.Unknown=16]="Unknown",c[c.EOF=17]="EOF"})(a||(e.SyntaxKind=a={}));var N;(function(c){c[c.InvalidSymbol=1]="InvalidSymbol",c[c.InvalidNumberFormat=2]="InvalidNumberFormat",c[c.PropertyNameExpected=3]="PropertyNameExpected",c[c.ValueExpected=4]="ValueExpected",c[c.ColonExpected=5]="ColonExpected",c[c.CommaExpected=6]="CommaExpected",c[c.CloseBraceExpected=7]="CloseBraceExpected",c[c.CloseBracketExpected=8]="CloseBracketExpected",c[c.EndOfFileExpected=9]="EndOfFileExpected",c[c.InvalidCommentToken=10]="InvalidCommentToken",c[c.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",c[c.UnexpectedEndOfString=12]="UnexpectedEndOfString",c[c.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",c[c.InvalidUnicode=14]="InvalidUnicode",c[c.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",c[c.InvalidCharacter=16]="InvalidCharacter"})(N||(e.ParseErrorCode=N={}));var A;(function(c){c.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function T(c,h=!1){let i=0;const n=c.length;let t="",s=0,r=a.Unknown,o=R.None;function u(j){let F=0,G=0;for(;F<j;){const V=c.charCodeAt(i);if(V>=I._0&&V<=I._9)G=G*16+V-I._0;else if(V>=I.A&&V<=I.F)G=G*16+V-I.A+10;else if(V>=I.a&&V<=I.f)G=G*16+V-I.a+10;else break;i++,F++}return F<j&&(G=-1),G}function b(j){i=j,t="",s=0,r=a.Unknown,o=R.None}function C(){const j=i;if(c.charCodeAt(i)===I._0)i++;else for(i++;i<c.length&&y(c.charCodeAt(i));)i++;if(i<c.length&&c.charCodeAt(i)===I.dot)if(i++,i<c.length&&y(c.charCodeAt(i)))for(i++;i<c.length&&y(c.charCodeAt(i));)i++;else return o=R.UnexpectedEndOfNumber,c.substring(j,i);let F=i;if(i<c.length&&(c.charCodeAt(i)===I.E||c.charCodeAt(i)===I.e))if(i++,(i<c.length&&c.charCodeAt(i)===I.plus||c.charCodeAt(i)===I.minus)&&i++,i<c.length&&y(c.charCodeAt(i))){for(i++;i<c.length&&y(c.charCodeAt(i));)i++;F=i}else o=R.UnexpectedEndOfNumber;return c.substring(j,F)}function S(){let j="",F=i;for(;;){if(i>=n){j+=c.substring(F,i),o=R.UnexpectedEndOfString;break}const G=c.charCodeAt(i);if(G===I.doubleQuote){j+=c.substring(F,i),i++;break}if(G===I.backslash){if(j+=c.substring(F,i),i++,i>=n){o=R.UnexpectedEndOfString;break}switch(c.charCodeAt(i++)){case I.doubleQuote:j+='"';break;case I.backslash:j+="\\";break;case I.slash:j+="/";break;case I.b:j+="\b";break;case I.f:j+="\f";break;case I.n:j+=`
`;break;case I.r:j+="\r";break;case I.t:j+="	";break;case I.u:{const x=u(4);x>=0?j+=String.fromCharCode(x):o=R.InvalidUnicode;break}default:o=R.InvalidEscapeCharacter}F=i;continue}if(G>=0&&G<=31)if(O(G)){j+=c.substring(F,i),o=R.UnexpectedEndOfString;break}else o=R.InvalidCharacter;i++}return j}function v(){if(t="",o=R.None,s=i,i>=n)return s=n,r=a.EOF;let j=c.charCodeAt(i);if(k(j)){do i++,t+=String.fromCharCode(j),j=c.charCodeAt(i);while(k(j));return r=a.Trivia}if(O(j))return i++,t+=String.fromCharCode(j),j===I.carriageReturn&&c.charCodeAt(i)===I.lineFeed&&(i++,t+=`
`),r=a.LineBreakTrivia;switch(j){case I.openBrace:return i++,r=a.OpenBraceToken;case I.closeBrace:return i++,r=a.CloseBraceToken;case I.openBracket:return i++,r=a.OpenBracketToken;case I.closeBracket:return i++,r=a.CloseBracketToken;case I.colon:return i++,r=a.ColonToken;case I.comma:return i++,r=a.CommaToken;case I.doubleQuote:return i++,t=S(),r=a.StringLiteral;case I.slash:{const F=i-1;if(c.charCodeAt(i+1)===I.slash){for(i+=2;i<n&&!O(c.charCodeAt(i));)i++;return t=c.substring(F,i),r=a.LineCommentTrivia}if(c.charCodeAt(i+1)===I.asterisk){i+=2;const G=n-1;let V=!1;for(;i<G;){if(c.charCodeAt(i)===I.asterisk&&c.charCodeAt(i+1)===I.slash){i+=2,V=!0;break}i++}return V||(i++,o=R.UnexpectedEndOfComment),t=c.substring(F,i),r=a.BlockCommentTrivia}return t+=String.fromCharCode(j),i++,r=a.Unknown}case I.minus:if(t+=String.fromCharCode(j),i++,i===n||!y(c.charCodeAt(i)))return r=a.Unknown;case I._0:case I._1:case I._2:case I._3:case I._4:case I._5:case I._6:case I._7:case I._8:case I._9:return t+=C(),r=a.NumericLiteral;default:for(;i<n&&L(j);)i++,j=c.charCodeAt(i);if(s!==i){switch(t=c.substring(s,i),t){case"true":return r=a.TrueKeyword;case"false":return r=a.FalseKeyword;case"null":return r=a.NullKeyword}return r=a.Unknown}return t+=String.fromCharCode(j),i++,r=a.Unknown}}function L(j){if(k(j)||O(j))return!1;switch(j){case I.closeBrace:case I.closeBracket:case I.openBrace:case I.openBracket:case I.doubleQuote:case I.colon:case I.comma:case I.slash:return!1}return!0}function U(){let j;do j=v();while(j>=a.LineCommentTrivia&&j<=a.Trivia);return j}return{setPosition:b,getPosition:()=>i,scan:h?U:v,getToken:()=>r,getTokenValue:()=>t,getTokenOffset:()=>s,getTokenLength:()=>i-s,getTokenError:()=>o}}function k(c){return c===I.space||c===I.tab||c===I.verticalTab||c===I.formFeed||c===I.nonBreakingSpace||c===I.ogham||c>=I.enQuad&&c<=I.zeroWidthSpace||c===I.narrowNoBreakSpace||c===I.mathematicalSpace||c===I.ideographicSpace||c===I.byteOrderMark}function O(c){return c===I.lineFeed||c===I.carriageReturn||c===I.lineSeparator||c===I.paragraphSeparator}function y(c){return c>=I._0&&c<=I._9}var I;(function(c){c[c.nullCharacter=0]="nullCharacter",c[c.maxAsciiCharacter=127]="maxAsciiCharacter",c[c.lineFeed=10]="lineFeed",c[c.carriageReturn=13]="carriageReturn",c[c.lineSeparator=8232]="lineSeparator",c[c.paragraphSeparator=8233]="paragraphSeparator",c[c.nextLine=133]="nextLine",c[c.space=32]="space",c[c.nonBreakingSpace=160]="nonBreakingSpace",c[c.enQuad=8192]="enQuad",c[c.emQuad=8193]="emQuad",c[c.enSpace=8194]="enSpace",c[c.emSpace=8195]="emSpace",c[c.threePerEmSpace=8196]="threePerEmSpace",c[c.fourPerEmSpace=8197]="fourPerEmSpace",c[c.sixPerEmSpace=8198]="sixPerEmSpace",c[c.figureSpace=8199]="figureSpace",c[c.punctuationSpace=8200]="punctuationSpace",c[c.thinSpace=8201]="thinSpace",c[c.hairSpace=8202]="hairSpace",c[c.zeroWidthSpace=8203]="zeroWidthSpace",c[c.narrowNoBreakSpace=8239]="narrowNoBreakSpace",c[c.ideographicSpace=12288]="ideographicSpace",c[c.mathematicalSpace=8287]="mathematicalSpace",c[c.ogham=5760]="ogham",c[c._=95]="_",c[c.$=36]="$",c[c._0=48]="_0",c[c._1=49]="_1",c[c._2=50]="_2",c[c._3=51]="_3",c[c._4=52]="_4",c[c._5=53]="_5",c[c._6=54]="_6",c[c._7=55]="_7",c[c._8=56]="_8",c[c._9=57]="_9",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.ampersand=38]="ampersand",c[c.asterisk=42]="asterisk",c[c.at=64]="at",c[c.backslash=92]="backslash",c[c.bar=124]="bar",c[c.caret=94]="caret",c[c.closeBrace=125]="closeBrace",c[c.closeBracket=93]="closeBracket",c[c.closeParen=41]="closeParen",c[c.colon=58]="colon",c[c.comma=44]="comma",c[c.dot=46]="dot",c[c.doubleQuote=34]="doubleQuote",c[c.equals=61]="equals",c[c.exclamation=33]="exclamation",c[c.greaterThan=62]="greaterThan",c[c.lessThan=60]="lessThan",c[c.minus=45]="minus",c[c.openBrace=123]="openBrace",c[c.openBracket=91]="openBracket",c[c.openParen=40]="openParen",c[c.percent=37]="percent",c[c.plus=43]="plus",c[c.question=63]="question",c[c.semicolon=59]="semicolon",c[c.singleQuote=39]="singleQuote",c[c.slash=47]="slash",c[c.tilde=126]="tilde",c[c.backspace=8]="backspace",c[c.formFeed=12]="formFeed",c[c.byteOrderMark=65279]="byteOrderMark",c[c.tab=9]="tab",c[c.verticalTab=11]="verticalTab"})(I||(I={}));function p(c,h){const i=[],n=new Object;let t;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let r=!1;function o(u,b,C,S){s.value=u,s.offset=b,s.length=C,s.type=S,s.colonOffset=void 0,t=s}try{P(c,{onObjectBegin:(u,b)=>{if(h<=u)throw n;t=void 0,r=h>u,i.push("")},onObjectProperty:(u,b,C)=>{if(h<b||(o(u,b,C,"property"),i[i.length-1]=u,h<=b+C))throw n},onObjectEnd:(u,b)=>{if(h<=u)throw n;t=void 0,i.pop()},onArrayBegin:(u,b)=>{if(h<=u)throw n;t=void 0,i.push(0)},onArrayEnd:(u,b)=>{if(h<=u)throw n;t=void 0,i.pop()},onLiteralValue:(u,b,C)=>{if(h<b||(o(u,b,C,m(u)),h<=b+C))throw n},onSeparator:(u,b,C)=>{if(h<=b)throw n;if(u===":"&&t&&t.type==="property")t.colonOffset=b,r=!1,t=void 0;else if(u===","){const S=i[i.length-1];typeof S=="number"?i[i.length-1]=S+1:(r=!0,i[i.length-1]=""),t=void 0}}})}catch(u){if(u!==n)throw u}return{path:i,previousNode:t,isAtPropertyKey:r,matches:u=>{let b=0;for(let C=0;b<u.length&&C<i.length;C++)if(u[b]===i[C]||u[b]==="*")b++;else if(u[b]!=="**")return!1;return b===u.length}}}function $(c,h=[],i=A.DEFAULT){let n=null,t=[];const s=[];function r(u){Array.isArray(t)?t.push(u):n!==null&&(t[n]=u)}return P(c,{onObjectBegin:()=>{const u={};r(u),s.push(t),t=u,n=null},onObjectProperty:u=>{n=u},onObjectEnd:()=>{t=s.pop()},onArrayBegin:()=>{const u=[];r(u),s.push(t),t=u,n=null},onArrayEnd:()=>{t=s.pop()},onLiteralValue:r,onError:(u,b,C)=>{h.push({error:u,offset:b,length:C})}},i),t[0]}function g(c,h=[],i=A.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(u){n.type==="property"&&(n.length=u-n.offset,n=n.parent)}function s(u){return n.children.push(u),u}P(c,{onObjectBegin:u=>{n=s({type:"object",offset:u,length:-1,parent:n,children:[]})},onObjectProperty:(u,b,C)=>{n=s({type:"property",offset:b,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:u,offset:b,length:C,parent:n})},onObjectEnd:(u,b)=>{n.length=u+b-n.offset,n=n.parent,t(u+b)},onArrayBegin:(u,b)=>{n=s({type:"array",offset:u,length:-1,parent:n,children:[]})},onArrayEnd:(u,b)=>{n.length=u+b-n.offset,n=n.parent,t(u+b)},onLiteralValue:(u,b,C)=>{s({type:m(u),offset:b,length:C,parent:n,value:u}),t(b+C)},onSeparator:(u,b,C)=>{n.type==="property"&&(u===":"?n.colonOffset=b:u===","&&t(b))},onError:(u,b,C)=>{h.push({error:u,offset:b,length:C})}},i);const o=n.children[0];return o&&delete o.parent,o}function l(c,h){if(!c)return;let i=c;for(const n of h)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let t=!1;for(const s of i.children)if(Array.isArray(s.children)&&s.children[0].value===n){i=s.children[1],t=!0;break}if(!t)return}else{const t=n;if(i.type!=="array"||t<0||!Array.isArray(i.children)||t>=i.children.length)return;i=i.children[t]}return i}function d(c){if(!c.parent||!c.parent.children)return[];const h=d(c.parent);if(c.parent.type==="property"){const i=c.parent.children[0].value;h.push(i)}else if(c.parent.type==="array"){const i=c.parent.children.indexOf(c);i!==-1&&h.push(i)}return h}function E(c){switch(c.type){case"array":return c.children.map(E);case"object":{const h=Object.create(null);for(const i of c.children){const n=i.children[1];n&&(h[i.children[0].value]=E(n))}return h}case"null":case"string":case"number":case"boolean":return c.value;default:return}}function w(c,h,i=!1){return h>=c.offset&&h<c.offset+c.length||i&&h===c.offset+c.length}function f(c,h,i=!1){if(w(c,h,i)){const n=c.children;if(Array.isArray(n))for(let t=0;t<n.length&&n[t].offset<=h;t++){const s=f(n[t],h,i);if(s)return s}return c}}function P(c,h,i=A.DEFAULT){const n=T(c,!1);function t(ne){return ne?()=>ne(n.getTokenOffset(),n.getTokenLength()):()=>!0}function s(ne){return ne?le=>ne(le,n.getTokenOffset(),n.getTokenLength()):()=>!0}const r=t(h.onObjectBegin),o=s(h.onObjectProperty),u=t(h.onObjectEnd),b=t(h.onArrayBegin),C=t(h.onArrayEnd),S=s(h.onLiteralValue),v=s(h.onSeparator),L=t(h.onComment),U=s(h.onError),j=i&&i.disallowComments,F=i&&i.allowTrailingComma;function G(){for(;;){const ne=n.scan();switch(n.getTokenError()){case R.InvalidUnicode:V(N.InvalidUnicode);break;case R.InvalidEscapeCharacter:V(N.InvalidEscapeCharacter);break;case R.UnexpectedEndOfNumber:V(N.UnexpectedEndOfNumber);break;case R.UnexpectedEndOfComment:j||V(N.UnexpectedEndOfComment);break;case R.UnexpectedEndOfString:V(N.UnexpectedEndOfString);break;case R.InvalidCharacter:V(N.InvalidCharacter);break}switch(ne){case a.LineCommentTrivia:case a.BlockCommentTrivia:j?V(N.InvalidCommentToken):L();break;case a.Unknown:V(N.InvalidSymbol);break;case a.Trivia:case a.LineBreakTrivia:break;default:return ne}}}function V(ne,le=[],ee=[]){if(U(ne),le.length+ee.length>0){let J=n.getToken();for(;J!==a.EOF;){if(le.indexOf(J)!==-1){G();break}else if(ee.indexOf(J)!==-1)break;J=G()}}}function x(ne){const le=n.getTokenValue();return ne?S(le):o(le),G(),!0}function H(){switch(n.getToken()){case a.NumericLiteral:{let ne=0;try{ne=JSON.parse(n.getTokenValue()),typeof ne!="number"&&(V(N.InvalidNumberFormat),ne=0)}catch{V(N.InvalidNumberFormat)}S(ne);break}case a.NullKeyword:S(null);break;case a.TrueKeyword:S(!0);break;case a.FalseKeyword:S(!1);break;default:return!1}return G(),!0}function te(){return n.getToken()!==a.StringLiteral?(V(N.PropertyNameExpected,[],[a.CloseBraceToken,a.CommaToken]),!1):(x(!1),n.getToken()===a.ColonToken?(v(":"),G(),_()||V(N.ValueExpected,[],[a.CloseBraceToken,a.CommaToken])):V(N.ColonExpected,[],[a.CloseBraceToken,a.CommaToken]),!0)}function B(){r(),G();let ne=!1;for(;n.getToken()!==a.CloseBraceToken&&n.getToken()!==a.EOF;){if(n.getToken()===a.CommaToken){if(ne||V(N.ValueExpected,[],[]),v(","),G(),n.getToken()===a.CloseBraceToken&&F)break}else ne&&V(N.CommaExpected,[],[]);te()||V(N.ValueExpected,[],[a.CloseBraceToken,a.CommaToken]),ne=!0}return u(),n.getToken()!==a.CloseBraceToken?V(N.CloseBraceExpected,[a.CloseBraceToken],[]):G(),!0}function W(){b(),G();let ne=!1;for(;n.getToken()!==a.CloseBracketToken&&n.getToken()!==a.EOF;){if(n.getToken()===a.CommaToken){if(ne||V(N.ValueExpected,[],[]),v(","),G(),n.getToken()===a.CloseBracketToken&&F)break}else ne&&V(N.CommaExpected,[],[]);_()||V(N.ValueExpected,[],[a.CloseBracketToken,a.CommaToken]),ne=!0}return C(),n.getToken()!==a.CloseBracketToken?V(N.CloseBracketExpected,[a.CloseBracketToken],[]):G(),!0}function _(){switch(n.getToken()){case a.OpenBracketToken:return W();case a.OpenBraceToken:return B();case a.StringLiteral:return x(!0);default:return H()}}return G(),n.getToken()===a.EOF?i.allowEmptyContent?!0:(V(N.ValueExpected,[],[]),!1):_()?(n.getToken()!==a.EOF&&V(N.EndOfFileExpected,[],[]),!0):(V(N.ValueExpected,[],[]),!1)}function m(c){switch(typeof c){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(c){if(Array.isArray(c))return"array"}else return"null";return"object"}default:return"null"}}}),define(fe[45],de([0,1,36]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_n=a,e.$ao=N,e.$bo=k,e.$co=O;function a(y,I,p){let $,g,l,d,E;if(I){for(d=I.offset,E=d+I.length,l=d;l>0&&!O(y,l-1);)l--;let o=E;for(;o<y.length&&!O(y,o);)o++;g=y.substring(l,o),$=T(g,p)}else g=y,$=0,l=0,d=0,E=y.length;const w=k(p,y);let f=!1,P=0,m;p.insertSpaces?m=A(" ",p.tabSize||4):m="	";const c=(0,R.$1n)(g,!1);let h=!1;function i(){return w+A(m,$+P)}function n(){let o=c.scan();for(f=!1;o===R.SyntaxKind.Trivia||o===R.SyntaxKind.LineBreakTrivia;)f=f||o===R.SyntaxKind.LineBreakTrivia,o=c.scan();return h=o===R.SyntaxKind.Unknown||c.getTokenError()!==R.ScanError.None,o}const t=[];function s(o,u,b){!h&&u<E&&b>d&&y.substring(u,b)!==o&&t.push({offset:u,length:b-u,content:o})}let r=n();if(r!==R.SyntaxKind.EOF){const o=c.getTokenOffset()+l,u=A(m,$);s(u,l,o)}for(;r!==R.SyntaxKind.EOF;){let o=c.getTokenOffset()+c.getTokenLength()+l,u=n(),b="";for(;!f&&(u===R.SyntaxKind.LineCommentTrivia||u===R.SyntaxKind.BlockCommentTrivia);){const S=c.getTokenOffset()+l;s(" ",o,S),o=c.getTokenOffset()+c.getTokenLength()+l,b=u===R.SyntaxKind.LineCommentTrivia?i():"",u=n()}if(u===R.SyntaxKind.CloseBraceToken)r!==R.SyntaxKind.OpenBraceToken&&(P--,b=i());else if(u===R.SyntaxKind.CloseBracketToken)r!==R.SyntaxKind.OpenBracketToken&&(P--,b=i());else{switch(r){case R.SyntaxKind.OpenBracketToken:case R.SyntaxKind.OpenBraceToken:P++,b=i();break;case R.SyntaxKind.CommaToken:case R.SyntaxKind.LineCommentTrivia:b=i();break;case R.SyntaxKind.BlockCommentTrivia:f?b=i():b=" ";break;case R.SyntaxKind.ColonToken:b=" ";break;case R.SyntaxKind.StringLiteral:if(u===R.SyntaxKind.ColonToken){b="";break}case R.SyntaxKind.NullKeyword:case R.SyntaxKind.TrueKeyword:case R.SyntaxKind.FalseKeyword:case R.SyntaxKind.NumericLiteral:case R.SyntaxKind.CloseBraceToken:case R.SyntaxKind.CloseBracketToken:u===R.SyntaxKind.LineCommentTrivia||u===R.SyntaxKind.BlockCommentTrivia?b=" ":u!==R.SyntaxKind.CommaToken&&u!==R.SyntaxKind.EOF&&(h=!0);break;case R.SyntaxKind.Unknown:h=!0;break}f&&(u===R.SyntaxKind.LineCommentTrivia||u===R.SyntaxKind.BlockCommentTrivia)&&(b=i())}const C=c.getTokenOffset()+l;s(b,o,C),r=u}return t}function N(y,I){const p=JSON.stringify(y,void 0,I.insertSpaces?I.tabSize||4:"	");return I.eol!==void 0?p.replace(/\r\n|\r|\n/g,I.eol):p}function A(y,I){let p="";for(let $=0;$<I;$++)p+=y;return p}function T(y,I){let p=0,$=0;const g=I.tabSize||4;for(;p<y.length;){const l=y.charAt(p);if(l===" ")$++;else if(l==="	")$+=g;else break;p++}return Math.floor($/g)}function k(y,I){for(let p=0;p<I.length;p++){const $=I.charAt(p);if($==="\r")return p+1<I.length&&I.charAt(p+1)===`
`?`\r
`:"\r";if($===`
`)return`
`}return y&&y.eol||`
`}function O(y,I){return`\r
`.indexOf(y.charAt(I))!==-1}}),define(fe[64],de([0,1,36,45]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=N,e.$eo=A,e.$fo=T,e.$go=k,e.$ho=O;function N(y,I,p){return A(y,I,void 0,p)}function A(y,I,p,$,g){const l=I.slice(),d=[],E=(0,R.$4n)(y,d);let w,f;for(;l.length>0&&(f=l.pop(),w=(0,R.$5n)(E,l),w===void 0&&p!==void 0);)typeof f=="string"?p={[f]:p}:p=[p];if(w)if(w.type==="object"&&typeof f=="string"&&Array.isArray(w.children)){const P=(0,R.$5n)(w,[f]);if(P!==void 0)if(p===void 0){if(!P.parent)throw new Error("Malformed AST");const m=w.children.indexOf(P.parent);let c,h=P.parent.offset+P.parent.length;if(m>0){const i=w.children[m-1];c=i.offset+i.length}else c=w.offset+1,w.children.length>1&&(h=w.children[1].offset);return T(y,{offset:c,length:h-c,content:""},$)}else return T(y,{offset:P.offset,length:P.length,content:JSON.stringify(p)},$);else{if(p===void 0)return[];const m=`${JSON.stringify(f)}: ${JSON.stringify(p)}`,c=g?g(w.children.map(i=>i.children[0].value)):w.children.length;let h;if(c>0){const i=w.children[c-1];h={offset:i.offset+i.length,length:0,content:","+m}}else w.children.length===0?h={offset:w.offset+1,length:0,content:m}:h={offset:w.offset+1,length:0,content:m+","};return T(y,h,$)}}else if(w.type==="array"&&typeof f=="number"&&Array.isArray(w.children))if(p!==void 0){const P=`${JSON.stringify(p)}`;let m;if(w.children.length===0||f===0)m={offset:w.offset+1,length:0,content:w.children.length===0?P:P+","};else{const c=f===-1||f>w.children.length?w.children.length:f,h=w.children[c-1];m={offset:h.offset+h.length,length:0,content:","+P}}return T(y,m,$)}else{const P=f,m=w.children[P];let c;if(w.children.length===1)c={offset:w.offset+1,length:w.length-2,content:""};else if(w.children.length-1===P){const h=w.children[P-1],i=h.offset+h.length,n=w.offset+w.length;c={offset:i,length:n-2-i,content:""}}else c={offset:m.offset,length:w.children[P+1].offset-m.offset,content:""};return T(y,c,$)}else throw new Error(`Can not add ${typeof f!="number"?"index":"property"} to parent of type ${w.type}`);else return p===void 0?[]:T(y,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(p)},$)}function T(y,I,p){let $=k(y,I),g=I.offset,l=I.offset+I.content.length;if(I.length===0||I.content.length===0){for(;g>0&&!(0,a.$co)($,g-1);)g--;for(;l<$.length&&!(0,a.$co)($,l);)l++}const d=(0,a.$_n)($,{offset:g,length:l-g},p);for(let w=d.length-1;w>=0;w--){const f=d[w];$=k($,f),g=Math.min(g,f.offset),l=Math.max(l,f.offset+f.length),l+=f.content.length-f.length}const E=y.length-($.length-l)-g;return[{offset:g,length:E,content:$.substring(g,l)}]}function k(y,I){return y.substring(0,I.offset)+I.content+y.substring(I.offset+I.length)}function O(y,I){const p=I.slice(0).sort((g,l)=>{const d=g.offset-l.offset;return d===0?g.length-l.length:d});let $=y.length;for(let g=p.length-1;g>=0;g--){const l=p[g];if(l.offset+l.length<=$)y=k(y,l);else throw new Error("Overlapping edit");$=l.offset}return y}}),define(fe[133],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$j=R;function R(A){let T=!1;const k=new Map,O=new Map;if(N(A,d=>{if(A===d)return!0;const E=JSON.stringify(d);if(E.length<30)return!0;const w=k.get(E);if(!w){const f={schemas:[d]};return k.set(E,f),O.set(d,f),!0}return w.schemas.push(d),O.set(d,w),T=!0,!1}),k.clear(),!T)return JSON.stringify(A);let I="$defs";for(;A.hasOwnProperty(I);)I+="_";const p=[];function $(d){return JSON.stringify(d,(E,w)=>{if(w!==d){const f=O.get(w);if(f&&f.schemas.length>1)return f.id||(f.id=`_${p.length}`,p.push(f.schemas[0])),{$ref:`#/${I}/${f.id}`}}return w})}const g=$(A),l=[];for(let d=0;d<p.length;d++)l.push(`"_${d}":${$(p[d])}`);return l.length?`${g.substring(0,g.length-1)},"${I}":{${l.join(",")}}}`:g}function a(A){return typeof A=="object"&&A!==null}function N(A,T){if(!A||typeof A!="object")return;const k=(...g)=>{for(const l of g)a(l)&&p.push(l)},O=(...g)=>{for(const l of g)if(a(l))for(const d in l){const E=l[d];a(E)&&p.push(E)}},y=(...g)=>{for(const l of g)if(Array.isArray(l))for(const d of l)a(d)&&p.push(d)},I=g=>{if(Array.isArray(g))for(const l of g)a(l)&&p.push(l);else a(g)&&p.push(g)},p=[A];let $=p.pop();for(;$;)T($)&&(k($.additionalItems,$.additionalProperties,$.not,$.contains,$.propertyNames,$.if,$.then,$.else,$.unevaluatedItems,$.unevaluatedProperties),O($.definitions,$.$defs,$.properties,$.patternProperties,$.dependencies,$.dependentSchemas),y($.anyOf,$.allOf,$.oneOf,$.prefixItems),I($.items)),$=p.pop()}}),define(fe[53],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W=void 0;class R{constructor(N){this.d=N,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(N){this.c=N}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$W=R}),define(fe[91],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8c=void 0;class R{static{this.Undefined=new R(void 0)}constructor(A){this.element=A,this.next=R.Undefined,this.prev=R.Undefined}}class a{constructor(){this.a=R.Undefined,this.b=R.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===R.Undefined}clear(){let A=this.a;for(;A!==R.Undefined;){const T=A.next;A.prev=R.Undefined,A.next=R.Undefined,A=T}this.a=R.Undefined,this.b=R.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,T){const k=new R(A);if(this.a===R.Undefined)this.a=k,this.b=k;else if(T){const y=this.b;this.b=k,k.prev=y,y.next=k}else{const y=this.a;this.a=k,k.next=y,y.prev=k}this.c+=1;let O=!1;return()=>{O||(O=!0,this.e(k))}}shift(){if(this.a!==R.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==R.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==R.Undefined&&A.next!==R.Undefined){const T=A.prev;T.next=A.next,A.next.prev=T}else A.prev===R.Undefined&&A.next===R.Undefined?(this.a=R.Undefined,this.b=R.Undefined):A.next===R.Undefined?(this.b=this.b.prev,this.b.next=R.Undefined):A.prev===R.Undefined&&(this.a=this.a.next,this.a.prev=R.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==R.Undefined;)yield A.element,A=A.next}}e.$8c=a}),define(fe[31],de([0,1]),function(ce,e){"use strict";var R,a,N;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.Touch=e.$Ec=e.$Dc=void 0,e.$Ac=A,e.$Bc=T,e.$Cc=k,e.$Lc=m;function A(c,h,i){let n=c.get(h);return n===void 0&&(n=i,c.set(h,n)),n}function T(c){const h=[];return c.forEach((i,n)=>{h.push(`${n} => ${i}`)}),`Map(${c.size}) {${h.join(", ")}}`}function k(c){const h=[];return c.forEach(i=>{h.push(i)}),`Set(${c.size}) {${h.join(", ")}}`}class O{constructor(h,i){this.uri=h,this.value=i}}function y(c){return Array.isArray(c)}class I{static{this.c=h=>h.toString()}constructor(h,i){if(this[R]="ResourceMap",h instanceof I)this.d=new Map(h.d),this.e=i??I.c;else if(y(h)){this.d=new Map,this.e=i??I.c;for(const[n,t]of h)this.set(n,t)}else this.d=new Map,this.e=h??I.c}set(h,i){return this.d.set(this.e(h),new O(h,i)),this}get(h){return this.d.get(this.e(h))?.value}has(h){return this.d.has(this.e(h))}get size(){return this.d.size}clear(){this.d.clear()}delete(h){return this.d.delete(this.e(h))}forEach(h,i){typeof i<"u"&&(h=h.bind(i));for(const[n,t]of this.d)h(t.value,t.uri,this)}*values(){for(const h of this.d.values())yield h.value}*keys(){for(const h of this.d.values())yield h.uri}*entries(){for(const h of this.d.values())yield[h.uri,h.value]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(const[,h]of this.d)yield[h.uri,h.value]}}e.$Dc=I;class p{constructor(h,i){this[a]="ResourceSet",!h||typeof h=="function"?this.c=new I(h):(this.c=new I(i),h.forEach(this.add,this))}get size(){return this.c.size}add(h){return this.c.set(h,h),this}clear(){this.c.clear()}delete(h){return this.c.delete(h)}forEach(h,i){this.c.forEach((n,t)=>h.call(i,t,t,this))}has(h){return this.c.has(h)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(a=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ec=p;var $;(function(c){c[c.None=0]="None",c[c.AsOld=1]="AsOld",c[c.AsNew=2]="AsNew"})($||(e.Touch=$={}));class g{constructor(){this[N]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(h){return this.c.has(h)}get(h,i=$.None){const n=this.c.get(h);if(n)return i!==$.None&&this.m(n,i),n.value}set(h,i,n=$.None){let t=this.c.get(h);if(t)t.value=i,n!==$.None&&this.m(t,n);else{switch(t={key:h,value:i,next:void 0,previous:void 0},n){case $.None:this.k(t);break;case $.AsOld:this.j(t);break;case $.AsNew:this.k(t);break;default:this.k(t);break}this.c.set(h,t),this.f++}return this}delete(h){return!!this.remove(h)}remove(h){const i=this.c.get(h);if(i)return this.c.delete(h),this.l(i),this.f--,i.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const h=this.d;return this.c.delete(h.key),this.l(h),this.f--,h.value}forEach(h,i){const n=this.g;let t=this.d;for(;t;){if(i?h.bind(i)(t.value,t.key,this):h(t.value,t.key,this),this.g!==n)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const h=this,i=this.g;let n=this.d;const t={[Symbol.iterator](){return t},next(){if(h.g!==i)throw new Error("LinkedMap got modified during iteration.");if(n){const s={value:n.key,done:!1};return n=n.next,s}else return{value:void 0,done:!0}}};return t}values(){const h=this,i=this.g;let n=this.d;const t={[Symbol.iterator](){return t},next(){if(h.g!==i)throw new Error("LinkedMap got modified during iteration.");if(n){const s={value:n.value,done:!1};return n=n.next,s}else return{value:void 0,done:!0}}};return t}entries(){const h=this,i=this.g;let n=this.d;const t={[Symbol.iterator](){return t},next(){if(h.g!==i)throw new Error("LinkedMap got modified during iteration.");if(n){const s={value:[n.key,n.value],done:!1};return n=n.next,s}else return{value:void 0,done:!0}}};return t}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(h){if(h>=this.size)return;if(h===0){this.clear();return}let i=this.d,n=this.size;for(;i&&n>h;)this.c.delete(i.key),i=i.next,n--;this.d=i,this.f=n,i&&(i.previous=void 0),this.g++}i(h){if(h>=this.size)return;if(h===0){this.clear();return}let i=this.e,n=this.size;for(;i&&n>h;)this.c.delete(i.key),i=i.previous,n--;this.e=i,this.f=n,i&&(i.next=void 0),this.g++}j(h){if(!this.d&&!this.e)this.e=h;else if(this.d)h.next=this.d,this.d.previous=h;else throw new Error("Invalid list");this.d=h,this.g++}k(h){if(!this.d&&!this.e)this.d=h;else if(this.e)h.previous=this.e,this.e.next=h;else throw new Error("Invalid list");this.e=h,this.g++}l(h){if(h===this.d&&h===this.e)this.d=void 0,this.e=void 0;else if(h===this.d){if(!h.next)throw new Error("Invalid list");h.next.previous=void 0,this.d=h.next}else if(h===this.e){if(!h.previous)throw new Error("Invalid list");h.previous.next=void 0,this.e=h.previous}else{const i=h.next,n=h.previous;if(!i||!n)throw new Error("Invalid list");i.previous=n,n.next=i}h.next=void 0,h.previous=void 0,this.g++}m(h,i){if(!this.d||!this.e)throw new Error("Invalid list");if(!(i!==$.AsOld&&i!==$.AsNew)){if(i===$.AsOld){if(h===this.d)return;const n=h.next,t=h.previous;h===this.e?(t.next=void 0,this.e=t):(n.previous=t,t.next=n),h.previous=void 0,h.next=this.d,this.d.previous=h,this.d=h,this.g++}else if(i===$.AsNew){if(h===this.e)return;const n=h.next,t=h.previous;h===this.d?(n.previous=void 0,this.d=n):(n.previous=t,t.next=n),h.next=void 0,h.previous=this.e,this.e.next=h,this.e=h,this.g++}}}toJSON(){const h=[];return this.forEach((i,n)=>{h.push([n,i])}),h}fromJSON(h){this.clear();for(const[i,n]of h)this.set(i,n)}}e.$Fc=g;class l extends g{constructor(h,i=1){super(),this.n=h,this.o=Math.min(Math.max(0,i),1)}get limit(){return this.n}set limit(h){this.n=h,this.p()}get ratio(){return this.o}set ratio(h){this.o=Math.min(Math.max(0,h),1),this.p()}get(h,i=$.AsNew){return super.get(h,i)}peek(h){return super.get(h,$.None)}set(h,i){return super.set(h,i,$.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class d extends l{constructor(h,i=1){super(h,i)}q(h){this.h(h)}set(h,i){return super.set(h,i),this.p(),this}}e.$Gc=d;class E extends l{constructor(h,i=1){super(h,i)}q(h){this.i(h)}set(h,i){return this.n<=this.size&&!this.has(h)&&this.q(Math.round(this.n*this.o)-1),super.set(h,i),this}}e.$Hc=E;class w{constructor(){this.c=new Map}add(h){return this.c.set(h,(this.c.get(h)||0)+1),this}delete(h){let i=this.c.get(h)||0;return i===0?!1:(i--,i===0?this.c.delete(h):this.c.set(h,i),!0)}has(h){return this.c.has(h)}}e.$Ic=w;class f{constructor(h){if(this.c=new Map,this.d=new Map,h)for(const[i,n]of h)this.set(i,n)}clear(){this.c.clear(),this.d.clear()}set(h,i){this.c.set(h,i),this.d.set(i,h)}get(h){return this.c.get(h)}getKey(h){return this.d.get(h)}delete(h){const i=this.c.get(h);return i===void 0?!1:(this.c.delete(h),this.d.delete(i),!0)}forEach(h,i){this.c.forEach((n,t)=>{h.call(i,n,t,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Jc=f;class P{constructor(){this.c=new Map}add(h,i){let n=this.c.get(h);n||(n=new Set,this.c.set(h,n)),n.add(i)}delete(h,i){const n=this.c.get(h);n&&(n.delete(i),n.size===0&&this.c.delete(h))}forEach(h,i){const n=this.c.get(h);n&&n.forEach(i)}get(h){const i=this.c.get(h);return i||new Set}}e.$Kc=P;function m(c,h){if(c===h)return!0;if(c.size!==h.size)return!1;for(const[i,n]of c)if(!h.has(i)||h.get(i)!==n)return!1;for(const[i]of h)if(!c.has(i))return!1;return!0}}),define(fe[2],de([0,1,17,131,31,90,63]),function(ce,e,R,a,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$5c=e.$4c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Mc=void 0,e.$Nc=I,e.$Oc=p,e.$Pc=$,e.$Qc=d,e.$Rc=E,e.$Sc=w,e.$Tc=f,e.$Uc=P,e.$Vc=m,e.$6c=b;const k=!1;let O=null;class y{constructor(){this.b=new Map}static{this.a=0}c(v){let L=this.b.get(v);return L||(L={parent:null,source:null,isSingleton:!1,value:v,idx:y.a++},this.b.set(v,L)),L}trackDisposable(v){const L=this.c(v);L.source||(L.source=new Error().stack)}setParent(v,L){const U=this.c(v);U.parent=L}markAsDisposed(v){this.b.delete(v)}markAsSingleton(v){this.c(v).isSingleton=!0}f(v,L){const U=L.get(v);if(U)return U;const j=v.parent?this.f(this.c(v.parent),L):v;return L.set(v,j),j}getTrackedDisposables(){const v=new Map;return[...this.b.entries()].filter(([,U])=>U.source!==null&&!this.f(U,v).isSingleton).flatMap(([U])=>U)}computeLeakingDisposables(v=10,L){let U;if(L)U=L;else{const x=new Map,H=[...this.b.values()].filter(B=>B.source!==null&&!this.f(B,x).isSingleton);if(H.length===0)return;const te=new Set(H.map(B=>B.value));if(U=H.filter(B=>!(B.parent&&te.has(B.parent))),U.length===0)throw new Error("There are cyclic diposable chains!")}if(!U)return;function j(x){function H(B,W){for(;B.length>0&&W.some(_=>typeof _=="string"?_===B[0]:B[0].match(_));)B.shift()}const te=x.source.split(`
`).map(B=>B.trim().replace("at ","")).filter(B=>B!=="");return H(te,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),te.reverse()}const F=new N.$Kc;for(const x of U){const H=j(x);for(let te=0;te<=H.length;te++)F.add(H.slice(0,te).join(`
`),x)}U.sort((0,R.$8b)(x=>x.idx,R.$0b));let G="",V=0;for(const x of U.slice(0,v)){V++;const H=j(x),te=[];for(let B=0;B<H.length;B++){let W=H[B];W=`(shared with ${F.get(H.slice(0,B+1).join(`
`)).size}/${U.length} leaks) at ${W}`;const ne=F.get(H.slice(0,B).join(`
`)),le=(0,a.$c)([...ne].map(ee=>j(ee)[B]),ee=>ee);delete le[H[B]];for(const[ee,J]of Object.entries(le))te.unshift(`    - stacktraces of ${J.length} other leaks continue with ${ee}`);te.unshift(W)}G+=`


==================== Leaking disposable ${V}/${U.length}: ${x.value.constructor.name} ====================
${te.join(`
`)}
============================================================

`}return U.length>v&&(G+=`


... and ${U.length-v} more leaking disposables

`),{leaks:U,details:G}}}e.$Mc=y;function I(S){O=S}if(k){const S="__is_disposable_tracked__";I(new class{trackDisposable(v){const L=new Error("Potentially leaked disposable").stack;setTimeout(()=>{v[S]||console.log(L)},3e3)}setParent(v,L){if(v&&v!==h.None)try{v[S]=!0}catch{}}markAsDisposed(v){if(v&&v!==h.None)try{v[S]=!0}catch{}}markAsSingleton(v){}})}function p(S){return O?.trackDisposable(S),S}function $(S){O?.markAsDisposed(S)}function g(S,v){O?.setParent(S,v)}function l(S,v){if(O)for(const L of S)O.setParent(L,v)}function d(S){return O?.markAsSingleton(S),S}function E(S){return typeof S=="object"&&S!==null&&typeof S.dispose=="function"&&S.dispose.length===0}function w(S){if(T.Iterable.is(S)){const v=[];for(const L of S)if(L)try{L.dispose()}catch(U){v.push(U)}if(v.length===1)throw v[0];if(v.length>1)throw new AggregateError(v,"Encountered errors while disposing of store");return Array.isArray(S)?[]:S}else if(S)return S.dispose(),S}function f(S){for(const v of S)E(v)&&v.dispose();return[]}function P(...S){const v=m(()=>w(S));return l(S,v),v}function m(S){const v=p({dispose:(0,A.$fb)(()=>{$(v),S()})});return v}class c{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,p(this)}dispose(){this.g||($(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{w(this.f)}finally{this.f.clear()}}add(v){if(!v)return v;if(v===this)throw new Error("Cannot register a disposable on itself!");return g(v,this),this.g?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(v),v}delete(v){if(v){if(v===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(v),v.dispose()}}deleteAndLeak(v){v&&this.f.has(v)&&(this.f.delete(v),g(v,null))}}e.$Wc=c;class h{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new c,p(this),g(this.q,this)}dispose(){$(this),this.q.dispose()}B(v){if(v===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(v)}}e.$Xc=h;class i{constructor(){this.b=!1,p(this)}get value(){return this.b?void 0:this.a}set value(v){this.b||v===this.a||(this.a?.dispose(),v&&g(v,this),this.a=v)}clear(){this.value=void 0}dispose(){this.b=!0,$(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const v=this.a;return this.a=void 0,v&&g(v,null),v}}e.$Yc=i;class n{constructor(v){this.a=new i,this.b=!1,this.a.value=v}get value(){return this.a.value}set value(v){this.b||v===this.a.value||(this.a.value=v)}dispose(){this.b=!0,this.a.dispose()}}e.$Zc=n;class t{constructor(v){this.b=v,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$1c=t;class s{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,p(this)}set(v){let L=v;return this.unset=()=>L=void 0,this.isset=()=>L!==void 0,this.dispose=()=>{L&&(L(),L=void 0,$(this))},this}}e.$2c=s;class r{constructor(){this.a=new Map}acquire(v,...L){let U=this.a.get(v);U||(U={counter:0,object:this.b(v,...L)},this.a.set(v,U));const{object:j}=U,F=(0,A.$fb)(()=>{--U.counter===0&&(this.c(v,U.object),this.a.delete(v))});return U.counter++,{object:j,dispose:F}}}e.$3c=r;class o{constructor(v){this.a=v}async acquire(v,...L){const U=this.a.acquire(v,...L);try{return{object:await U.object,dispose:()=>U.dispose()}}catch(j){throw U.dispose(),j}}}e.$4c=o;class u{constructor(v){this.object=v}dispose(){}}e.$5c=u;function b(S){const v=new c;try{S(v)}finally{v.dispose()}}class C{constructor(){this.a=new Map,this.b=!1,p(this)}dispose(){$(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{w(this.a.values())}finally{this.a.clear()}}has(v){return this.a.has(v)}get size(){return this.a.size}get(v){return this.a.get(v)}set(v,L,U=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),U||this.a.get(v)?.dispose(),this.a.set(v,L)}deleteAndDispose(v){this.a.get(v)?.dispose(),this.a.delete(v)}deleteAndLeak(v){const L=this.a.get(v);return this.a.delete(v),L}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$7c=C}),define(fe[65],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var R;(function(a){a[a.Uri=1]="Uri",a[a.Regexp=2]="Regexp",a[a.ScmResource=3]="ScmResource",a[a.ScmResourceGroup=4]="ScmResourceGroup",a[a.ScmProvider=5]="ScmProvider",a[a.CommentController=6]="CommentController",a[a.CommentThread=7]="CommentThread",a[a.CommentThreadInstance=8]="CommentThreadInstance",a[a.CommentThreadReply=9]="CommentThreadReply",a[a.CommentNode=10]="CommentNode",a[a.CommentThreadNode=11]="CommentThreadNode",a[a.TimelineActionContext=12]="TimelineActionContext",a[a.NotebookCellActionContext=13]="NotebookCellActionContext",a[a.NotebookActionContext=14]="NotebookActionContext",a[a.TerminalContext=15]="TerminalContext",a[a.TestItemContext=16]="TestItemContext",a[a.Date=17]="Date",a[a.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(R||(e.MarshalledId=R={}))}),define(fe[92],de([0,1,31]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=void 0,e.$qm=N,e.$rm=T;const a=new R.$Gc(1e4);function N(y){return O(y,"NFC",a)}const A=new R.$Gc(1e4);function T(y){return O(y,"NFD",A)}const k=/[^\u0000-\u0080]/;function O(y,I,p){if(!y)return y;const $=p.get(y);if($)return $;let g;return k.test(y)?g=y.normalize(I):g=y,p.set(y,g),g}e.$sm=function(){const y=/[\u0300-\u036f]/g;return function(I){return T(I).replace(y,"")}}()}),function(){function ce(N){const A=[];typeof N=="number"&&A.push("code/timeOrigin",N);function T(O){A.push(O,Date.now())}function k(){const O=[];for(let y=0;y<A.length;y+=2)O.push({name:A[y],startTime:A[y+1]});return O}return{mark:T,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ce():{mark(N){performance.mark(N)},getMarks(){let N=performance.timeOrigin;typeof N!="number"&&(N=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(N)}];for(const T of performance.getEntriesByType("mark"))A.push({name:T.name,startTime:Math.round(N+T.startTime)});return A}};if(typeof process=="object"){const N=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ce(N)}else return console.trace("perf-util loaded in UNKNOWN environment"),ce()}function R(N){return N.MonacoPerformanceMarks||(N.MonacoPerformanceMarks=e()),N.MonacoPerformanceMarks}var a;typeof global=="object"?a=global:typeof self=="object"?a=self:a={},typeof define=="function"?define("vs/base/common/performance",[],function(){return R(a)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=R(a):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),a.perf=R(a))}(),define(fe[5],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.OS=e.OperatingSystem=e.$C=e.$B=e.$A=e.$z=e.$y=e.Language=e.$x=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.Platform=e.$h=void 0,e.$i=h,e.$E=o,e.$K=u,e.$h="en";let R=!1,a=!1,N=!1,A=!1,T=!1,k=!1,O=!1,y=!1,I=!1,p=!1,$,g=e.$h,l=e.$h,d,E;const w=globalThis;let f;typeof w.vscode<"u"&&typeof w.vscode.process<"u"?f=w.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(f=process);const P=typeof f?.versions?.electron=="string",m=P&&f?.type==="renderer";if(typeof f=="object"){R=f.platform==="win32",a=f.platform==="darwin",N=f.platform==="linux",A=N&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,O=P,I=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,$=e.$h,g=e.$h;const b=f.env.VSCODE_NLS_CONFIG;if(b)try{const C=JSON.parse(b);$=C.userLocale,l=C.osLocale,g=C.resolvedLanguage||e.$h,d=C.languagePack?.translationsConfigFile}catch{}T=!0}else typeof navigator=="object"&&!m?(E=navigator.userAgent,R=E.indexOf("Windows")>=0,a=E.indexOf("Macintosh")>=0,y=(E.indexOf("Macintosh")>=0||E.indexOf("iPad")>=0||E.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,N=E.indexOf("Linux")>=0,p=E?.indexOf("Mobi")>=0,k=!0,g=globalThis._VSCODE_NLS_LANGUAGE||e.$h,$=navigator.language.toLowerCase(),l=$):console.error("Unable to resolve platform.");var c;(function(b){b[b.Web=0]="Web",b[b.Mac=1]="Mac",b[b.Linux=2]="Linux",b[b.Windows=3]="Windows"})(c||(e.Platform=c={}));function h(b){switch(b){case c.Web:return"Web";case c.Mac:return"Mac";case c.Linux:return"Linux";case c.Windows:return"Windows"}}let i=c.Web;a?i=c.Mac:R?i=c.Windows:N&&(i=c.Linux),e.$j=R,e.$k=a,e.$l=N,e.$m=A,e.$n=T,e.$o=O,e.$p=k,e.$q=k&&typeof w.importScripts=="function",e.$r=e.$q?w.origin:void 0,e.$s=y,e.$t=p,e.$u=I,e.$v=i,e.$w=E,e.$x=g;var n;(function(b){function C(){return e.$x}b.value=C;function S(){return e.$x.length===2?e.$x==="en":e.$x.length>=3?e.$x[0]==="e"&&e.$x[1]==="n"&&e.$x[2]==="-":!1}b.isDefaultVariant=S;function v(){return e.$x==="en"}b.isDefault=v})(n||(e.Language=n={})),e.$y=$,e.$z=l,e.$A=d,e.$B=typeof w.postMessage=="function"&&!w.importScripts,e.$C=(()=>{if(e.$B){const b=[];w.addEventListener("message",S=>{if(S.data&&S.data.vscodeScheduleAsyncWork)for(let v=0,L=b.length;v<L;v++){const U=b[v];if(U.id===S.data.vscodeScheduleAsyncWork){b.splice(v,1),U.callback();return}}});let C=0;return S=>{const v=++C;b.push({id:v,callback:S}),w.postMessage({vscodeScheduleAsyncWork:v},"*")}}return b=>setTimeout(b)})();var t;(function(b){b[b.Windows=1]="Windows",b[b.Macintosh=2]="Macintosh",b[b.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=a||y?t.Macintosh:R?t.Windows:t.Linux;let s=!0,r=!1;function o(){if(!r){r=!0;const b=new Uint8Array(2);b[0]=1,b[1]=2,s=new Uint16Array(b.buffer)[0]===513}return s}e.$F=!!(e.$w&&e.$w.indexOf("Chrome")>=0),e.$G=!!(e.$w&&e.$w.indexOf("Firefox")>=0),e.$H=!!(!e.$F&&e.$w&&e.$w.indexOf("Safari")>=0),e.$I=!!(e.$w&&e.$w.indexOf("Edg/")>=0),e.$J=!!(e.$w&&e.$w.indexOf("Android")>=0);function u(b){return parseFloat(b)>=20}}),define(fe[37],de([0,1,5]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hc=e.$gc=e.env=e.cwd=void 0;let a;const N=globalThis.vscode;if(typeof N<"u"&&typeof N.process<"u"){const A=N.process;a={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"&&typeof process?.versions?.node=="string"?a={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:a={get platform(){return R.$j?"win32":R.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=a.cwd,e.env=a.env,e.$gc=a.platform,e.$hc=a.arch}),define(fe[134],de([0,1,37]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QX=T;var a;(function(k){k.UNKNOWN="UNKNOWN",k.CINNAMON="CINNAMON",k.DEEPIN="DEEPIN",k.GNOME="GNOME",k.KDE3="KDE3",k.KDE4="KDE4",k.KDE5="KDE5",k.KDE6="KDE6",k.PANTHEON="PANTHEON",k.UNITY="UNITY",k.XFCE="XFCE",k.UKUI="UKUI",k.LXQT="LXQT"})(a||(a={}));const N="XDG_CURRENT_DESKTOP",A="KDE_SESSION_VERSION";function T(){const k=R.env[N];if(k){const y=k.split(":").map(I=>I.trim()).filter(I=>I.length>0);for(const I of y)switch(I){case"Unity":{const p=R.env.DESKTOP_SESSION;return p&&p.includes("gnome-fallback")?a.GNOME:a.UNITY}case"Deepin":return a.DEEPIN;case"GNOME":return a.GNOME;case"X-Cinnamon":return a.CINNAMON;case"KDE":{const p=R.env[A];return p==="5"?a.KDE5:p==="6"?a.KDE6:a.KDE4}case"Pantheon":return a.PANTHEON;case"XFCE":return a.XFCE;case"UKUI":return a.UKUI;case"LXQt":return a.LXQT}}const O=R.env.DESKTOP_SESSION;if(O)switch(O){case"deepin":return a.DEEPIN;case"gnome":case"mate":return a.GNOME;case"kde4":case"kde-plasma":return a.KDE4;case"kde":return A in R.env?a.KDE4:a.KDE3;case"xfce":case"xubuntu":return a.XFCE;case"ukui":return a.UKUI}return"GNOME_DESKTOP_SESSION_ID"in R.env?a.GNOME:"KDE_FULL_SESSION"in R.env?A in R.env?a.KDE4:a.KDE3:a.UNKNOWN}});var kt=this&&this.__createBinding||(Object.create?function(ce,e,R,a){a===void 0&&(a=R);var N=Object.getOwnPropertyDescriptor(e,R);(!N||("get"in N?!e.__esModule:N.writable||N.configurable))&&(N={enumerable:!0,get:function(){return e[R]}}),Object.defineProperty(ce,a,N)}:function(ce,e,R,a){a===void 0&&(a=R),ce[a]=e[R]}),At=this&&this.__setModuleDefault||(Object.create?function(ce,e){Object.defineProperty(ce,"default",{enumerable:!0,value:e})}:function(ce,e){ce.default=e}),Oe=this&&this.__importStar||function(ce){if(ce&&ce.__esModule)return ce;var e={};if(ce!=null)for(var R in ce)R!=="default"&&Object.prototype.hasOwnProperty.call(ce,R)&&kt(e,ce,R);return At(e,ce),e};define(fe[13],de([0,1,37]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.sep=e.$uc=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=void 0,R=Oe(R);const a=65,N=97,A=90,T=122,k=46,O=47,y=92,I=58,p=63;class $ extends Error{constructor(n,t,s){let r;typeof t=="string"&&t.indexOf("not ")===0?(r="must not be",t=t.replace(/^not /,"")):r="must be";const o=n.indexOf(".")!==-1?"property":"argument";let u=`The "${n}" ${o} ${r} of type ${t}`;u+=`. Received type ${typeof s}`,super(u),this.code="ERR_INVALID_ARG_TYPE"}}function g(i,n){if(i===null||typeof i!="object")throw new $(n,"Object",i)}function l(i,n){if(typeof i!="string")throw new $(n,"string",i)}const d=R.$gc==="win32";function E(i){return i===O||i===y}function w(i){return i===O}function f(i){return i>=a&&i<=A||i>=N&&i<=T}function P(i,n,t,s){let r="",o=0,u=-1,b=0,C=0;for(let S=0;S<=i.length;++S){if(S<i.length)C=i.charCodeAt(S);else{if(s(C))break;C=O}if(s(C)){if(!(u===S-1||b===1))if(b===2){if(r.length<2||o!==2||r.charCodeAt(r.length-1)!==k||r.charCodeAt(r.length-2)!==k){if(r.length>2){const v=r.lastIndexOf(t);v===-1?(r="",o=0):(r=r.slice(0,v),o=r.length-1-r.lastIndexOf(t)),u=S,b=0;continue}else if(r.length!==0){r="",o=0,u=S,b=0;continue}}n&&(r+=r.length>0?`${t}..`:"..",o=2)}else r.length>0?r+=`${t}${i.slice(u+1,S)}`:r=i.slice(u+1,S),o=S-u-1;u=S,b=0}else C===k&&b!==-1?++b:b=-1}return r}function m(i){return i?`${i[0]==="."?"":"."}${i}`:""}function c(i,n){g(n,"pathObject");const t=n.dir||n.root,s=n.base||`${n.name||""}${m(n.ext)}`;return t?t===n.root?`${t}${s}`:`${t}${i}${s}`:s}e.$ic={resolve(...i){let n="",t="",s=!1;for(let r=i.length-1;r>=-1;r--){let o;if(r>=0){if(o=i[r],l(o,`paths[${r}]`),o.length===0)continue}else n.length===0?o=R.cwd():(o=R.env[`=${n}`]||R.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==n.toLowerCase()&&o.charCodeAt(2)===y)&&(o=`${n}\\`));const u=o.length;let b=0,C="",S=!1;const v=o.charCodeAt(0);if(u===1)E(v)&&(b=1,S=!0);else if(E(v))if(S=!0,E(o.charCodeAt(1))){let L=2,U=L;for(;L<u&&!E(o.charCodeAt(L));)L++;if(L<u&&L!==U){const j=o.slice(U,L);for(U=L;L<u&&E(o.charCodeAt(L));)L++;if(L<u&&L!==U){for(U=L;L<u&&!E(o.charCodeAt(L));)L++;(L===u||L!==U)&&(C=`\\\\${j}\\${o.slice(U,L)}`,b=L)}}}else b=1;else f(v)&&o.charCodeAt(1)===I&&(C=o.slice(0,2),b=2,u>2&&E(o.charCodeAt(2))&&(S=!0,b=3));if(C.length>0)if(n.length>0){if(C.toLowerCase()!==n.toLowerCase())continue}else n=C;if(s){if(n.length>0)break}else if(t=`${o.slice(b)}\\${t}`,s=S,S&&n.length>0)break}return t=P(t,!s,"\\",E),s?`${n}\\${t}`:`${n}${t}`||"."},normalize(i){l(i,"path");const n=i.length;if(n===0)return".";let t=0,s,r=!1;const o=i.charCodeAt(0);if(n===1)return w(o)?"\\":i;if(E(o))if(r=!0,E(i.charCodeAt(1))){let b=2,C=b;for(;b<n&&!E(i.charCodeAt(b));)b++;if(b<n&&b!==C){const S=i.slice(C,b);for(C=b;b<n&&E(i.charCodeAt(b));)b++;if(b<n&&b!==C){for(C=b;b<n&&!E(i.charCodeAt(b));)b++;if(b===n)return`\\\\${S}\\${i.slice(C)}\\`;b!==C&&(s=`\\\\${S}\\${i.slice(C,b)}`,t=b)}}}else t=1;else f(o)&&i.charCodeAt(1)===I&&(s=i.slice(0,2),t=2,n>2&&E(i.charCodeAt(2))&&(r=!0,t=3));let u=t<n?P(i.slice(t),!r,"\\",E):"";return u.length===0&&!r&&(u="."),u.length>0&&E(i.charCodeAt(n-1))&&(u+="\\"),s===void 0?r?`\\${u}`:u:r?`${s}\\${u}`:`${s}${u}`},isAbsolute(i){l(i,"path");const n=i.length;if(n===0)return!1;const t=i.charCodeAt(0);return E(t)||n>2&&f(t)&&i.charCodeAt(1)===I&&E(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let n,t;for(let o=0;o<i.length;++o){const u=i[o];l(u,"path"),u.length>0&&(n===void 0?n=t=u:n+=`\\${u}`)}if(n===void 0)return".";let s=!0,r=0;if(typeof t=="string"&&E(t.charCodeAt(0))){++r;const o=t.length;o>1&&E(t.charCodeAt(1))&&(++r,o>2&&(E(t.charCodeAt(2))?++r:s=!1))}if(s){for(;r<n.length&&E(n.charCodeAt(r));)r++;r>=2&&(n=`\\${n.slice(r)}`)}return e.$ic.normalize(n)},relative(i,n){if(l(i,"from"),l(n,"to"),i===n)return"";const t=e.$ic.resolve(i),s=e.$ic.resolve(n);if(t===s||(i=t.toLowerCase(),n=s.toLowerCase(),i===n))return"";let r=0;for(;r<i.length&&i.charCodeAt(r)===y;)r++;let o=i.length;for(;o-1>r&&i.charCodeAt(o-1)===y;)o--;const u=o-r;let b=0;for(;b<n.length&&n.charCodeAt(b)===y;)b++;let C=n.length;for(;C-1>b&&n.charCodeAt(C-1)===y;)C--;const S=C-b,v=u<S?u:S;let L=-1,U=0;for(;U<v;U++){const F=i.charCodeAt(r+U);if(F!==n.charCodeAt(b+U))break;F===y&&(L=U)}if(U!==v){if(L===-1)return s}else{if(S>v){if(n.charCodeAt(b+U)===y)return s.slice(b+U+1);if(U===2)return s.slice(b+U)}u>v&&(i.charCodeAt(r+U)===y?L=U:U===2&&(L=3)),L===-1&&(L=0)}let j="";for(U=r+L+1;U<=o;++U)(U===o||i.charCodeAt(U)===y)&&(j+=j.length===0?"..":"\\..");return b+=L,j.length>0?`${j}${s.slice(b,C)}`:(s.charCodeAt(b)===y&&++b,s.slice(b,C))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const n=e.$ic.resolve(i);if(n.length<=2)return i;if(n.charCodeAt(0)===y){if(n.charCodeAt(1)===y){const t=n.charCodeAt(2);if(t!==p&&t!==k)return`\\\\?\\UNC\\${n.slice(2)}`}}else if(f(n.charCodeAt(0))&&n.charCodeAt(1)===I&&n.charCodeAt(2)===y)return`\\\\?\\${n}`;return i},dirname(i){l(i,"path");const n=i.length;if(n===0)return".";let t=-1,s=0;const r=i.charCodeAt(0);if(n===1)return E(r)?i:".";if(E(r)){if(t=s=1,E(i.charCodeAt(1))){let b=2,C=b;for(;b<n&&!E(i.charCodeAt(b));)b++;if(b<n&&b!==C){for(C=b;b<n&&E(i.charCodeAt(b));)b++;if(b<n&&b!==C){for(C=b;b<n&&!E(i.charCodeAt(b));)b++;if(b===n)return i;b!==C&&(t=s=b+1)}}}}else f(r)&&i.charCodeAt(1)===I&&(t=n>2&&E(i.charCodeAt(2))?3:2,s=t);let o=-1,u=!0;for(let b=n-1;b>=s;--b)if(E(i.charCodeAt(b))){if(!u){o=b;break}}else u=!1;if(o===-1){if(t===-1)return".";o=t}return i.slice(0,o)},basename(i,n){n!==void 0&&l(n,"suffix"),l(i,"path");let t=0,s=-1,r=!0,o;if(i.length>=2&&f(i.charCodeAt(0))&&i.charCodeAt(1)===I&&(t=2),n!==void 0&&n.length>0&&n.length<=i.length){if(n===i)return"";let u=n.length-1,b=-1;for(o=i.length-1;o>=t;--o){const C=i.charCodeAt(o);if(E(C)){if(!r){t=o+1;break}}else b===-1&&(r=!1,b=o+1),u>=0&&(C===n.charCodeAt(u)?--u===-1&&(s=o):(u=-1,s=b))}return t===s?s=b:s===-1&&(s=i.length),i.slice(t,s)}for(o=i.length-1;o>=t;--o)if(E(i.charCodeAt(o))){if(!r){t=o+1;break}}else s===-1&&(r=!1,s=o+1);return s===-1?"":i.slice(t,s)},extname(i){l(i,"path");let n=0,t=-1,s=0,r=-1,o=!0,u=0;i.length>=2&&i.charCodeAt(1)===I&&f(i.charCodeAt(0))&&(n=s=2);for(let b=i.length-1;b>=n;--b){const C=i.charCodeAt(b);if(E(C)){if(!o){s=b+1;break}continue}r===-1&&(o=!1,r=b+1),C===k?t===-1?t=b:u!==1&&(u=1):t!==-1&&(u=-1)}return t===-1||r===-1||u===0||u===1&&t===r-1&&t===s+1?"":i.slice(t,r)},format:c.bind(null,"\\"),parse(i){l(i,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return n;const t=i.length;let s=0,r=i.charCodeAt(0);if(t===1)return E(r)?(n.root=n.dir=i,n):(n.base=n.name=i,n);if(E(r)){if(s=1,E(i.charCodeAt(1))){let L=2,U=L;for(;L<t&&!E(i.charCodeAt(L));)L++;if(L<t&&L!==U){for(U=L;L<t&&E(i.charCodeAt(L));)L++;if(L<t&&L!==U){for(U=L;L<t&&!E(i.charCodeAt(L));)L++;L===t?s=L:L!==U&&(s=L+1)}}}}else if(f(r)&&i.charCodeAt(1)===I){if(t<=2)return n.root=n.dir=i,n;if(s=2,E(i.charCodeAt(2))){if(t===3)return n.root=n.dir=i,n;s=3}}s>0&&(n.root=i.slice(0,s));let o=-1,u=s,b=-1,C=!0,S=i.length-1,v=0;for(;S>=s;--S){if(r=i.charCodeAt(S),E(r)){if(!C){u=S+1;break}continue}b===-1&&(C=!1,b=S+1),r===k?o===-1?o=S:v!==1&&(v=1):o!==-1&&(v=-1)}return b!==-1&&(o===-1||v===0||v===1&&o===b-1&&o===u+1?n.base=n.name=i.slice(u,b):(n.name=i.slice(u,o),n.base=i.slice(u,b),n.ext=i.slice(o,b))),u>0&&u!==s?n.dir=i.slice(0,u-1):n.dir=n.root,n},sep:"\\",delimiter:";",win32:null,posix:null};const h=(()=>{if(d){const i=/\\/g;return()=>{const n=R.cwd().replace(i,"/");return n.slice(n.indexOf("/"))}}return()=>R.cwd()})();e.$jc={resolve(...i){let n="",t=!1;for(let s=i.length-1;s>=-1&&!t;s--){const r=s>=0?i[s]:h();l(r,`paths[${s}]`),r.length!==0&&(n=`${r}/${n}`,t=r.charCodeAt(0)===O)}return n=P(n,!t,"/",w),t?`/${n}`:n.length>0?n:"."},normalize(i){if(l(i,"path"),i.length===0)return".";const n=i.charCodeAt(0)===O,t=i.charCodeAt(i.length-1)===O;return i=P(i,!n,"/",w),i.length===0?n?"/":t?"./":".":(t&&(i+="/"),n?`/${i}`:i)},isAbsolute(i){return l(i,"path"),i.length>0&&i.charCodeAt(0)===O},join(...i){if(i.length===0)return".";let n;for(let t=0;t<i.length;++t){const s=i[t];l(s,"path"),s.length>0&&(n===void 0?n=s:n+=`/${s}`)}return n===void 0?".":e.$jc.normalize(n)},relative(i,n){if(l(i,"from"),l(n,"to"),i===n||(i=e.$jc.resolve(i),n=e.$jc.resolve(n),i===n))return"";const t=1,s=i.length,r=s-t,o=1,u=n.length-o,b=r<u?r:u;let C=-1,S=0;for(;S<b;S++){const L=i.charCodeAt(t+S);if(L!==n.charCodeAt(o+S))break;L===O&&(C=S)}if(S===b)if(u>b){if(n.charCodeAt(o+S)===O)return n.slice(o+S+1);if(S===0)return n.slice(o+S)}else r>b&&(i.charCodeAt(t+S)===O?C=S:S===0&&(C=0));let v="";for(S=t+C+1;S<=s;++S)(S===s||i.charCodeAt(S)===O)&&(v+=v.length===0?"..":"/..");return`${v}${n.slice(o+C)}`},toNamespacedPath(i){return i},dirname(i){if(l(i,"path"),i.length===0)return".";const n=i.charCodeAt(0)===O;let t=-1,s=!0;for(let r=i.length-1;r>=1;--r)if(i.charCodeAt(r)===O){if(!s){t=r;break}}else s=!1;return t===-1?n?"/":".":n&&t===1?"//":i.slice(0,t)},basename(i,n){n!==void 0&&l(n,"ext"),l(i,"path");let t=0,s=-1,r=!0,o;if(n!==void 0&&n.length>0&&n.length<=i.length){if(n===i)return"";let u=n.length-1,b=-1;for(o=i.length-1;o>=0;--o){const C=i.charCodeAt(o);if(C===O){if(!r){t=o+1;break}}else b===-1&&(r=!1,b=o+1),u>=0&&(C===n.charCodeAt(u)?--u===-1&&(s=o):(u=-1,s=b))}return t===s?s=b:s===-1&&(s=i.length),i.slice(t,s)}for(o=i.length-1;o>=0;--o)if(i.charCodeAt(o)===O){if(!r){t=o+1;break}}else s===-1&&(r=!1,s=o+1);return s===-1?"":i.slice(t,s)},extname(i){l(i,"path");let n=-1,t=0,s=-1,r=!0,o=0;for(let u=i.length-1;u>=0;--u){const b=i.charCodeAt(u);if(b===O){if(!r){t=u+1;break}continue}s===-1&&(r=!1,s=u+1),b===k?n===-1?n=u:o!==1&&(o=1):n!==-1&&(o=-1)}return n===-1||s===-1||o===0||o===1&&n===s-1&&n===t+1?"":i.slice(n,s)},format:c.bind(null,"/"),parse(i){l(i,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return n;const t=i.charCodeAt(0)===O;let s;t?(n.root="/",s=1):s=0;let r=-1,o=0,u=-1,b=!0,C=i.length-1,S=0;for(;C>=s;--C){const v=i.charCodeAt(C);if(v===O){if(!b){o=C+1;break}continue}u===-1&&(b=!1,u=C+1),v===k?r===-1?r=C:S!==1&&(S=1):r!==-1&&(S=-1)}if(u!==-1){const v=o===0&&t?1:o;r===-1||S===0||S===1&&r===u-1&&r===o+1?n.base=n.name=i.slice(v,u):(n.name=i.slice(v,r),n.base=i.slice(v,u),n.ext=i.slice(r,u))}return o>0?n.dir=i.slice(0,o-1):t&&(n.dir="/"),n},sep:"/",delimiter:":",win32:null,posix:null},e.$jc.win32=e.$ic.win32=e.$ic,e.$jc.posix=e.$ic.posix=e.$jc,e.$kc=d?e.$ic.normalize:e.$jc.normalize,e.$lc=d?e.$ic.isAbsolute:e.$jc.isAbsolute,e.$mc=d?e.$ic.join:e.$jc.join,e.$nc=d?e.$ic.resolve:e.$jc.resolve,e.$oc=d?e.$ic.relative:e.$jc.relative,e.$pc=d?e.$ic.dirname:e.$jc.dirname,e.$qc=d?e.$ic.basename:e.$jc.basename,e.$rc=d?e.$ic.extname:e.$jc.extname,e.$sc=d?e.$ic.format:e.$jc.format,e.$tc=d?e.$ic.parse:e.$jc.parse,e.$uc=d?e.$ic.toNamespacedPath:e.$jc.toNamespacedPath,e.sep=d?e.$ic.sep:e.$jc.sep,e.$wc=d?e.$ic.delimiter:e.$jc.delimiter}),define(fe[135],de([0,1,13]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=void 0,e.$ft=A,e.$gt=T,e.$ht=k,e.$it=y,e.$et=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const a={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},N={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(I){const p=(0,R.$rc)(I),$=a[p.toLowerCase()];return $!==void 0?$:T(I)}function T(I){const p=(0,R.$rc)(I);return N[p.toLowerCase()]}function k(I){for(const p in N)if(N[p]===I)return p}const O=/^(.+)\/(.+?)(;.+)?$/;function y(I,p){const $=O.exec(I);return $?`${$[1].toLowerCase()}/${$[2].toLowerCase()}${$[3]??""}`:p?void 0:I}}),define(fe[93],de([0,1,5]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$om=A,e.$pm=T;var a;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(a||(e.Source=a={}));var N;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(N||(e.TerminateResponseCode=N={}));function A(k,...O){const y=O.reduce(($,g)=>($[g]=!0,$),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter($=>!y[$]).forEach($=>{for(let g=0;g<I.length;g++)if($.search(I[g])!==-1){delete k[$];break}})}function T(k){k&&(delete k.DEBUG,R.$l&&delete k.LD_PRELOAD)}}),function(ce,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var R=e();for(var a in R)(typeof exports=="object"?exports:ce)[a]=R[a]}}(typeof self<"u"?self:this,function(){return function(ce){var e={};function R(a){if(e[a])return e[a].exports;var N=e[a]={i:a,l:!1,exports:{}};return ce[a].call(N.exports,N,N.exports,R),N.l=!0,N.exports}return R.m=ce,R.c=e,R.d=function(a,N,A){R.o(a,N)||Object.defineProperty(a,N,{enumerable:!0,get:A})},R.r=function(a){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(a,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(a,"__esModule",{value:!0})},R.t=function(a,N){if(1&N&&(a=R(a)),8&N||4&N&&typeof a=="object"&&a&&a.__esModule)return a;var A=Object.create(null);if(R.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:a}),2&N&&typeof a!="string")for(var T in a)R.d(A,T,function(k){return a[k]}.bind(null,T));return A},R.n=function(a){var N=a&&a.__esModule?function(){return a.default}:function(){return a};return R.d(N,"a",N),N},R.o=function(a,N){return Object.prototype.hasOwnProperty.call(a,N)},R.p="",R(R.s=0)}([function(ce,e,R){(function(a){var N;e=ce.exports=J,N=typeof a=="object"&&a.env&&a.env.NODE_DEBUG&&/\bsemver\b/i.test(a.env.NODE_DEBUG)?function(){var re=Array.prototype.slice.call(arguments,0);re.unshift("SEMVER"),console.log.apply(console,re)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,k=e.re=[],O=e.src=[],y=0,I=y++;O[I]="0|[1-9]\\d*";var p=y++;O[p]="[0-9]+";var $=y++;O[$]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var g=y++;O[g]="("+O[I]+")\\.("+O[I]+")\\.("+O[I]+")";var l=y++;O[l]="("+O[p]+")\\.("+O[p]+")\\.("+O[p]+")";var d=y++;O[d]="(?:"+O[I]+"|"+O[$]+")";var E=y++;O[E]="(?:"+O[p]+"|"+O[$]+")";var w=y++;O[w]="(?:-("+O[d]+"(?:\\."+O[d]+")*))";var f=y++;O[f]="(?:-?("+O[E]+"(?:\\."+O[E]+")*))";var P=y++;O[P]="[0-9A-Za-z-]+";var m=y++;O[m]="(?:\\+("+O[P]+"(?:\\."+O[P]+")*))";var c=y++,h="v?"+O[g]+O[w]+"?"+O[m]+"?";O[c]="^"+h+"$";var i="[v=\\s]*"+O[l]+O[f]+"?"+O[m]+"?",n=y++;O[n]="^"+i+"$";var t=y++;O[t]="((?:<|>)?=?)";var s=y++;O[s]=O[p]+"|x|X|\\*";var r=y++;O[r]=O[I]+"|x|X|\\*";var o=y++;O[o]="[v=\\s]*("+O[r]+")(?:\\.("+O[r]+")(?:\\.("+O[r]+")(?:"+O[w]+")?"+O[m]+"?)?)?";var u=y++;O[u]="[v=\\s]*("+O[s]+")(?:\\.("+O[s]+")(?:\\.("+O[s]+")(?:"+O[f]+")?"+O[m]+"?)?)?";var b=y++;O[b]="^"+O[t]+"\\s*"+O[o]+"$";var C=y++;O[C]="^"+O[t]+"\\s*"+O[u]+"$";var S=y++;O[S]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var v=y++;O[v]="(?:~>?)";var L=y++;O[L]="(\\s*)"+O[v]+"\\s+",k[L]=new RegExp(O[L],"g");var U=y++;O[U]="^"+O[v]+O[o]+"$";var j=y++;O[j]="^"+O[v]+O[u]+"$";var F=y++;O[F]="(?:\\^)";var G=y++;O[G]="(\\s*)"+O[F]+"\\s+",k[G]=new RegExp(O[G],"g");var V=y++;O[V]="^"+O[F]+O[o]+"$";var x=y++;O[x]="^"+O[F]+O[u]+"$";var H=y++;O[H]="^"+O[t]+"\\s*("+i+")$|^$";var te=y++;O[te]="^"+O[t]+"\\s*("+h+")$|^$";var B=y++;O[B]="(\\s*)"+O[t]+"\\s*("+i+"|"+O[o]+")",k[B]=new RegExp(O[B],"g");var W=y++;O[W]="^\\s*("+O[o]+")\\s+-\\s+("+O[o]+")\\s*$";var _=y++;O[_]="^\\s*("+O[u]+")\\s+-\\s+("+O[u]+")\\s*$";var ne=y++;O[ne]="(<|>)?=?\\s*\\*";for(var le=0;le<35;le++)N(le,O[le]),k[le]||(k[le]=new RegExp(O[le]));function ee(re,he){if(re instanceof J)return re;if(typeof re!="string"||re.length>A||!(he?k[n]:k[c]).test(re))return null;try{return new J(re,he)}catch{return null}}function J(re,he){if(re instanceof J){if(re.loose===he)return re;re=re.version}else if(typeof re!="string")throw new TypeError("Invalid Version: "+re);if(re.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof J))return new J(re,he);N("SemVer",re,he),this.loose=he;var me=re.trim().match(he?k[n]:k[c]);if(!me)throw new TypeError("Invalid Version: "+re);if(this.raw=re,this.major=+me[1],this.minor=+me[2],this.patch=+me[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");me[4]?this.prerelease=me[4].split(".").map(function(Se){if(/^[0-9]+$/.test(Se)){var Pe=+Se;if(Pe>=0&&Pe<T)return Pe}return Se}):this.prerelease=[],this.build=me[5]?me[5].split("."):[],this.format()}e.parse=ee,e.valid=function(re,he){var me=ee(re,he);return me?me.version:null},e.clean=function(re,he){var me=ee(re.trim().replace(/^[=v]+/,""),he);return me?me.version:null},e.SemVer=J,J.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},J.prototype.toString=function(){return this.version},J.prototype.compare=function(re){return N("SemVer.compare",this.version,this.loose,re),re instanceof J||(re=new J(re,this.loose)),this.compareMain(re)||this.comparePre(re)},J.prototype.compareMain=function(re){return re instanceof J||(re=new J(re,this.loose)),q(this.major,re.major)||q(this.minor,re.minor)||q(this.patch,re.patch)},J.prototype.comparePre=function(re){if(re instanceof J||(re=new J(re,this.loose)),this.prerelease.length&&!re.prerelease.length)return-1;if(!this.prerelease.length&&re.prerelease.length)return 1;if(!this.prerelease.length&&!re.prerelease.length)return 0;var he=0;do{var me=this.prerelease[he],Se=re.prerelease[he];if(N("prerelease compare",he,me,Se),me===void 0&&Se===void 0)return 0;if(Se===void 0)return 1;if(me===void 0)return-1;if(me!==Se)return q(me,Se)}while(++he)},J.prototype.inc=function(re,he){switch(re){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",he);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",he);break;case"prepatch":this.prerelease.length=0,this.inc("patch",he),this.inc("pre",he);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",he),this.inc("pre",he);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var me=this.prerelease.length;--me>=0;)typeof this.prerelease[me]=="number"&&(this.prerelease[me]++,me=-2);me===-1&&this.prerelease.push(0)}he&&(this.prerelease[0]===he?isNaN(this.prerelease[1])&&(this.prerelease=[he,0]):this.prerelease=[he,0]);break;default:throw new Error("invalid increment argument: "+re)}return this.format(),this.raw=this.version,this},e.inc=function(re,he,me,Se){typeof me=="string"&&(Se=me,me=void 0);try{return new J(re,me).inc(he,Se).version}catch{return null}},e.diff=function(re,he){if(Z(re,he))return null;var me=ee(re),Se=ee(he);if(me.prerelease.length||Se.prerelease.length){for(var Pe in me)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&me[Pe]!==Se[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in me)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&me[Pe]!==Se[Pe])return Pe},e.compareIdentifiers=q;var K=/^[0-9]+$/;function q(re,he){var me=K.test(re),Se=K.test(he);return me&&Se&&(re=+re,he=+he),me&&!Se?-1:Se&&!me?1:re<he?-1:re>he?1:0}function D(re,he,me){return new J(re,me).compare(new J(he,me))}function Q(re,he,me){return D(re,he,me)>0}function oe(re,he,me){return D(re,he,me)<0}function Z(re,he,me){return D(re,he,me)===0}function Y(re,he,me){return D(re,he,me)!==0}function M(re,he,me){return D(re,he,me)>=0}function z(re,he,me){return D(re,he,me)<=0}function ie(re,he,me,Se){var Pe;switch(he){case"===":typeof re=="object"&&(re=re.version),typeof me=="object"&&(me=me.version),Pe=re===me;break;case"!==":typeof re=="object"&&(re=re.version),typeof me=="object"&&(me=me.version),Pe=re!==me;break;case"":case"=":case"==":Pe=Z(re,me,Se);break;case"!=":Pe=Y(re,me,Se);break;case">":Pe=Q(re,me,Se);break;case">=":Pe=M(re,me,Se);break;case"<":Pe=oe(re,me,Se);break;case"<=":Pe=z(re,me,Se);break;default:throw new TypeError("Invalid operator: "+he)}return Pe}function ae(re,he){if(re instanceof ae){if(re.loose===he)return re;re=re.value}if(!(this instanceof ae))return new ae(re,he);N("comparator",re,he),this.loose=he,this.parse(re),this.semver===ue?this.value="":this.value=this.operator+this.semver.version,N("comp",this)}e.rcompareIdentifiers=function(re,he){return q(he,re)},e.major=function(re,he){return new J(re,he).major},e.minor=function(re,he){return new J(re,he).minor},e.patch=function(re,he){return new J(re,he).patch},e.compare=D,e.compareLoose=function(re,he){return D(re,he,!0)},e.rcompare=function(re,he,me){return D(he,re,me)},e.sort=function(re,he){return re.sort(function(me,Se){return e.compare(me,Se,he)})},e.rsort=function(re,he){return re.sort(function(me,Se){return e.rcompare(me,Se,he)})},e.gt=Q,e.lt=oe,e.eq=Z,e.neq=Y,e.gte=M,e.lte=z,e.cmp=ie,e.Comparator=ae;var ue={};function pe(re,he){if(re instanceof pe)return re.loose===he?re:new pe(re.raw,he);if(re instanceof ae)return new pe(re.value,he);if(!(this instanceof pe))return new pe(re,he);if(this.loose=he,this.raw=re,this.set=re.split(/\s*\|\|\s*/).map(function(me){return this.parseRange(me.trim())},this).filter(function(me){return me.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+re);this.format()}function be(re){return!re||re.toLowerCase()==="x"||re==="*"}function Re(re,he,me,Se,Pe,De,Ce,Ne,Ue,Me,Ve,Fe,Be){return((he=be(me)?"":be(Se)?">="+me+".0.0":be(Pe)?">="+me+"."+Se+".0":">="+he)+" "+(Ne=be(Ue)?"":be(Me)?"<"+(+Ue+1)+".0.0":be(Ve)?"<"+Ue+"."+(+Me+1)+".0":Fe?"<="+Ue+"."+Me+"."+Ve+"-"+Fe:"<="+Ne)).trim()}function Ae(re,he){for(var me=0;me<re.length;me++)if(!re[me].test(he))return!1;if(he.prerelease.length){for(me=0;me<re.length;me++)if(N(re[me].semver),re[me].semver!==ue&&re[me].semver.prerelease.length>0){var Se=re[me].semver;if(Se.major===he.major&&Se.minor===he.minor&&Se.patch===he.patch)return!0}return!1}return!0}function ye(re,he,me){try{he=new pe(he,me)}catch{return!1}return he.test(re)}function we(re,he,me,Se){var Pe,De,Ce,Ne,Ue;switch(re=new J(re,Se),he=new pe(he,Se),me){case">":Pe=Q,De=z,Ce=oe,Ne=">",Ue=">=";break;case"<":Pe=oe,De=M,Ce=Q,Ne="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ye(re,he,Se))return!1;for(var Me=0;Me<he.set.length;++Me){var Ve=he.set[Me],Fe=null,Be=null;if(Ve.forEach(function(ze){ze.semver===ue&&(ze=new ae(">=0.0.0")),Fe=Fe||ze,Be=Be||ze,Pe(ze.semver,Fe.semver,Se)?Fe=ze:Ce(ze.semver,Be.semver,Se)&&(Be=ze)}),Fe.operator===Ne||Fe.operator===Ue||(!Be.operator||Be.operator===Ne)&&De(re,Be.semver)||Be.operator===Ue&&Ce(re,Be.semver))return!1}return!0}ae.prototype.parse=function(re){var he=this.loose?k[H]:k[te],me=re.match(he);if(!me)throw new TypeError("Invalid comparator: "+re);this.operator=me[1],this.operator==="="&&(this.operator=""),me[2]?this.semver=new J(me[2],this.loose):this.semver=ue},ae.prototype.toString=function(){return this.value},ae.prototype.test=function(re){return N("Comparator.test",re,this.loose),this.semver===ue||(typeof re=="string"&&(re=new J(re,this.loose)),ie(re,this.operator,this.semver,this.loose))},ae.prototype.intersects=function(re,he){if(!(re instanceof ae))throw new TypeError("a Comparator is required");var me;if(this.operator==="")return me=new pe(re.value,he),ye(this.value,me,he);if(re.operator==="")return me=new pe(this.value,he),ye(re.semver,me,he);var Se=!(this.operator!==">="&&this.operator!==">"||re.operator!==">="&&re.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||re.operator!=="<="&&re.operator!=="<"),De=this.semver.version===re.semver.version,Ce=!(this.operator!==">="&&this.operator!=="<="||re.operator!==">="&&re.operator!=="<="),Ne=ie(this.semver,"<",re.semver,he)&&(this.operator===">="||this.operator===">")&&(re.operator==="<="||re.operator==="<"),Ue=ie(this.semver,">",re.semver,he)&&(this.operator==="<="||this.operator==="<")&&(re.operator===">="||re.operator===">");return Se||Pe||De&&Ce||Ne||Ue},e.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(re){return re.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(re){var he=this.loose;re=re.trim(),N("range",re,he);var me=he?k[_]:k[W];re=re.replace(me,Re),N("hyphen replace",re),re=re.replace(k[B],"$1$2$3"),N("comparator trim",re,k[B]),re=(re=(re=re.replace(k[L],"$1~")).replace(k[G],"$1^")).split(/\s+/).join(" ");var Se=he?k[H]:k[te],Pe=re.split(" ").map(function(De){return function(Ce,Ne){return N("comp",Ce),Ce=function(Ue,Me){return Ue.trim().split(/\s+/).map(function(Ve){return function(Fe,Be){N("caret",Fe,Be);var ze=Be?k[x]:k[V];return Fe.replace(ze,function(We,Le,se,ge,$e){var ve;return N("caret",Fe,We,Le,se,ge,$e),be(Le)?ve="":be(se)?ve=">="+Le+".0.0 <"+(+Le+1)+".0.0":be(ge)?ve=Le==="0"?">="+Le+"."+se+".0 <"+Le+"."+(+se+1)+".0":">="+Le+"."+se+".0 <"+(+Le+1)+".0.0":$e?(N("replaceCaret pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),ve=Le==="0"?se==="0"?">="+Le+"."+se+"."+ge+$e+" <"+Le+"."+se+"."+(+ge+1):">="+Le+"."+se+"."+ge+$e+" <"+Le+"."+(+se+1)+".0":">="+Le+"."+se+"."+ge+$e+" <"+(+Le+1)+".0.0"):(N("no pr"),ve=Le==="0"?se==="0"?">="+Le+"."+se+"."+ge+" <"+Le+"."+se+"."+(+ge+1):">="+Le+"."+se+"."+ge+" <"+Le+"."+(+se+1)+".0":">="+Le+"."+se+"."+ge+" <"+(+Le+1)+".0.0"),N("caret return",ve),ve})}(Ve,Me)}).join(" ")}(Ce,Ne),N("caret",Ce),Ce=function(Ue,Me){return Ue.trim().split(/\s+/).map(function(Ve){return function(Fe,Be){var ze=Be?k[j]:k[U];return Fe.replace(ze,function(We,Le,se,ge,$e){var ve;return N("tilde",Fe,We,Le,se,ge,$e),be(Le)?ve="":be(se)?ve=">="+Le+".0.0 <"+(+Le+1)+".0.0":be(ge)?ve=">="+Le+"."+se+".0 <"+Le+"."+(+se+1)+".0":$e?(N("replaceTilde pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),ve=">="+Le+"."+se+"."+ge+$e+" <"+Le+"."+(+se+1)+".0"):ve=">="+Le+"."+se+"."+ge+" <"+Le+"."+(+se+1)+".0",N("tilde return",ve),ve})}(Ve,Me)}).join(" ")}(Ce,Ne),N("tildes",Ce),Ce=function(Ue,Me){return N("replaceXRanges",Ue,Me),Ue.split(/\s+/).map(function(Ve){return function(Fe,Be){Fe=Fe.trim();var ze=Be?k[C]:k[b];return Fe.replace(ze,function(We,Le,se,ge,$e,ve){N("xRange",Fe,We,Le,se,ge,$e,ve);var ke=be(se),Te=ke||be(ge),qe=Te||be($e);return Le==="="&&qe&&(Le=""),ke?We=Le===">"||Le==="<"?"<0.0.0":"*":Le&&qe?(Te&&(ge=0),qe&&($e=0),Le===">"?(Le=">=",Te?(se=+se+1,ge=0,$e=0):qe&&(ge=+ge+1,$e=0)):Le==="<="&&(Le="<",Te?se=+se+1:ge=+ge+1),We=Le+se+"."+ge+"."+$e):Te?We=">="+se+".0.0 <"+(+se+1)+".0.0":qe&&(We=">="+se+"."+ge+".0 <"+se+"."+(+ge+1)+".0"),N("xRange return",We),We})}(Ve,Me)}).join(" ")}(Ce,Ne),N("xrange",Ce),Ce=function(Ue,Me){return N("replaceStars",Ue,Me),Ue.trim().replace(k[ne],"")}(Ce,Ne),N("stars",Ce),Ce}(De,he)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(De){return!!De.match(Se)})),Pe=Pe.map(function(De){return new ae(De,he)})},pe.prototype.intersects=function(re,he){if(!(re instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(me){return me.every(function(Se){return re.set.some(function(Pe){return Pe.every(function(De){return Se.intersects(De,he)})})})})},e.toComparators=function(re,he){return new pe(re,he).set.map(function(me){return me.map(function(Se){return Se.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(re){if(!re)return!1;typeof re=="string"&&(re=new J(re,this.loose));for(var he=0;he<this.set.length;he++)if(Ae(this.set[he],re))return!0;return!1},e.satisfies=ye,e.maxSatisfying=function(re,he,me){var Se=null,Pe=null;try{var De=new pe(he,me)}catch{return null}return re.forEach(function(Ce){De.test(Ce)&&(Se&&Pe.compare(Ce)!==-1||(Pe=new J(Se=Ce,me)))}),Se},e.minSatisfying=function(re,he,me){var Se=null,Pe=null;try{var De=new pe(he,me)}catch{return null}return re.forEach(function(Ce){De.test(Ce)&&(Se&&Pe.compare(Ce)!==1||(Pe=new J(Se=Ce,me)))}),Se},e.validRange=function(re,he){try{return new pe(re,he).range||"*"}catch{return null}},e.ltr=function(re,he,me){return we(re,he,"<",me)},e.gtr=function(re,he,me){return we(re,he,">",me)},e.outside=we,e.prerelease=function(re,he){var me=ee(re,he);return me&&me.prerelease.length?me.prerelease:null},e.intersects=function(re,he,me){return re=new pe(re,me),he=new pe(he,me),re.intersects(he)},e.coerce=function(re){if(re instanceof J)return re;if(typeof re!="string")return null;var he=re.match(k[S]);return he==null?null:ee((he[1]||"0")+"."+(he[2]||"0")+"."+(he[3]||"0"))}}).call(this,R(1))},function(ce,e){var R,a,N=ce.exports={};function A(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function k(E){if(R===setTimeout)return setTimeout(E,0);if((R===A||!R)&&setTimeout)return R=setTimeout,setTimeout(E,0);try{return R(E,0)}catch{try{return R.call(null,E,0)}catch{return R.call(this,E,0)}}}(function(){try{R=typeof setTimeout=="function"?setTimeout:A}catch{R=A}try{a=typeof clearTimeout=="function"?clearTimeout:T}catch{a=T}})();var O,y=[],I=!1,p=-1;function $(){I&&O&&(I=!1,O.length?y=O.concat(y):p=-1,y.length&&g())}function g(){if(!I){var E=k($);I=!0;for(var w=y.length;w;){for(O=y,y=[];++p<w;)O&&O[p].run();p=-1,w=y.length}O=null,I=!1,function(f){if(a===clearTimeout)return clearTimeout(f);if((a===T||!a)&&clearTimeout)return a=clearTimeout,clearTimeout(f);try{a(f)}catch{try{return a.call(null,f)}catch{return a.call(this,f)}}}(E)}}function l(E,w){this.fun=E,this.array=w}function d(){}N.nextTick=function(E){var w=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)w[f-1]=arguments[f];y.push(new l(E,w)),y.length!==1||I||k(g)},l.prototype.run=function(){this.fun.apply(null,this.array)},N.title="browser",N.browser=!0,N.env={},N.argv=[],N.version="",N.versions={},N.on=d,N.addListener=d,N.once=d,N.off=d,N.removeListener=d,N.removeAllListeners=d,N.emit=d,N.prependListener=d,N.prependOnceListener=d,N.listeners=function(E){return[]},N.binding=function(E){throw new Error("process.binding is not supported")},N.cwd=function(){return"/"},N.chdir=function(E){throw new Error("process.chdir is not supported")},N.umask=function(){return 0}}])}),define(fe[136],de([0,1]),function(ce,e){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zs=void 0;class a{constructor(k,O,y){this.level=k,this.key=O,this.value=y,this.forward=[]}}const N=void 0;class A{constructor(k,O=2**16){this.comparator=k,this[R]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(O)|0),this.e=new a(this.c,N,N)}get size(){return this.f}clear(){this.e=new a(this.c,N,N),this.f=0}has(k){return!!A.g(this,k,this.comparator)}get(k){return A.g(this,k,this.comparator)?.value}set(k,O){return A.h(this,k,O,this.comparator)&&(this.f+=1),this}delete(k){const O=A.k(this,k,this.comparator);return O&&(this.f-=1),O}forEach(k,O){let y=this.e.forward[0];for(;y;)k.call(O,y.value,y.key,this),y=y.forward[0]}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let k=this.e.forward[0];for(;k;)yield[k.key,k.value],k=k.forward[0]}*keys(){let k=this.e.forward[0];for(;k;)yield k.key,k=k.forward[0]}*values(){let k=this.e.forward[0];for(;k;)yield k.value,k=k.forward[0]}toString(){let k="[SkipList]:",O=this.e.forward[0];for(;O;)k+=`node(${O.key}, ${O.value}, lvl:${O.level})`,O=O.forward[0];return k}static g(k,O,y){let I=k.e;for(let p=k.d-1;p>=0;p--)for(;I.forward[p]&&y(I.forward[p].key,O)<0;)I=I.forward[p];if(I=I.forward[0],I&&y(I.key,O)===0)return I}static h(k,O,y,I){const p=[];let $=k.e;for(let g=k.d-1;g>=0;g--){for(;$.forward[g]&&I($.forward[g].key,O)<0;)$=$.forward[g];p[g]=$}if($=$.forward[0],$&&I($.key,O)===0)return $.value=y,!1;{const g=A.j(k);if(g>k.d){for(let l=k.d;l<g;l++)p[l]=k.e;k.d=g}$=new a(g,O,y);for(let l=0;l<g;l++)$.forward[l]=p[l].forward[l],p[l].forward[l]=$;return!0}}static j(k,O=.5){let y=1;for(;Math.random()<O&&y<k.c;)y+=1;return y}static k(k,O,y){const I=[];let p=k.e;for(let $=k.d-1;$>=0;$--){for(;p.forward[$]&&y(p.forward[$].key,O)<0;)p=p.forward[$];I[$]=p}if(p=p.forward[0],!p||y(p.key,O)!==0)return!1;for(let $=0;$<k.d&&I[$].forward[$]===p;$++)I[$].forward[$]=p.forward[$];for(;k.d>0&&k.e.forward[k.d-1]===N;)k.d-=1;return!0}}e.$Zs=A}),define(fe[54],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=void 0;const R=globalThis.performance&&typeof globalThis.performance.now=="function";class a{static create(A){return new a(A)}constructor(A){this.c=R&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ie=a}),define(fe[3],de([0,1,8,90,2,91,54]),function(ce,e,R,a,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$ke=e.Event=void 0,e.$le=g;const k=!1,O=!1,y=!1;var I;(function(j){j.None=()=>N.$Xc.None;function F(ye){if(y){const{onDidAddListener:we}=ye,re=d.create();let he=0;ye.onDidAddListener=()=>{++he===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),re.print()),we?.()}}}function G(ye,we){return J(ye,()=>{},0,void 0,!0,void 0,we)}j.defer=G;function V(ye){return(we,re=null,he)=>{let me=!1,Se;return Se=ye(Pe=>{if(!me)return Se?Se.dispose():me=!0,we.call(re,Pe)},null,he),me&&Se.dispose(),Se}}j.once=V;function x(ye,we){return j.once(j.filter(ye,we))}j.onceIf=x;function H(ye,we,re){return le((he,me=null,Se)=>ye(Pe=>he.call(me,we(Pe)),null,Se),re)}j.map=H;function te(ye,we,re){return le((he,me=null,Se)=>ye(Pe=>{we(Pe),he.call(me,Pe)},null,Se),re)}j.forEach=te;function B(ye,we,re){return le((he,me=null,Se)=>ye(Pe=>we(Pe)&&he.call(me,Pe),null,Se),re)}j.filter=B;function W(ye){return ye}j.signal=W;function _(...ye){return(we,re=null,he)=>{const me=(0,N.$Uc)(...ye.map(Se=>Se(Pe=>we.call(re,Pe))));return ee(me,he)}}j.any=_;function ne(ye,we,re,he){let me=re;return H(ye,Se=>(me=we(me,Se),me),he)}j.reduce=ne;function le(ye,we){let re;const he={onWillAddFirstListener(){re=ye(me.fire,me)},onDidRemoveLastListener(){re?.dispose()}};we||F(he);const me=new i(he);return we?.add(me),me.event}function ee(ye,we){return we instanceof Array?we.push(ye):we&&we.add(ye),ye}function J(ye,we,re=100,he=!1,me=!1,Se,Pe){let De,Ce,Ne,Ue=0,Me;const Ve={leakWarningThreshold:Se,onWillAddFirstListener(){De=ye(Be=>{Ue++,Ce=we(Ce,Be),he&&!Ne&&(Fe.fire(Ce),Ce=void 0),Me=()=>{const ze=Ce;Ce=void 0,Ne=void 0,(!he||Ue>1)&&Fe.fire(ze),Ue=0},typeof re=="number"?(clearTimeout(Ne),Ne=setTimeout(Me,re)):Ne===void 0&&(Ne=0,queueMicrotask(Me))})},onWillRemoveListener(){me&&Ue>0&&Me?.()},onDidRemoveLastListener(){Me=void 0,De.dispose()}};Pe||F(Ve);const Fe=new i(Ve);return Pe?.add(Fe),Fe.event}j.debounce=J;function K(ye,we=0,re){return j.debounce(ye,(he,me)=>he?(he.push(me),he):[me],we,void 0,!0,void 0,re)}j.accumulate=K;function q(ye,we=(he,me)=>he===me,re){let he=!0,me;return B(ye,Se=>{const Pe=he||!we(Se,me);return he=!1,me=Se,Pe},re)}j.latch=q;function D(ye,we,re){return[j.filter(ye,we,re),j.filter(ye,he=>!we(he),re)]}j.split=D;function Q(ye,we=!1,re=[],he){let me=re.slice(),Se=ye(Ce=>{me?me.push(Ce):De.fire(Ce)});he&&he.add(Se);const Pe=()=>{me?.forEach(Ce=>De.fire(Ce)),me=null},De=new i({onWillAddFirstListener(){Se||(Se=ye(Ce=>De.fire(Ce)),he&&he.add(Se))},onDidAddFirstListener(){me&&(we?setTimeout(Pe):Pe())},onDidRemoveLastListener(){Se&&Se.dispose(),Se=null}});return he&&he.add(De),De.event}j.buffer=Q;function oe(ye,we){return(he,me,Se)=>{const Pe=we(new Y);return ye(function(De){const Ce=Pe.evaluate(De);Ce!==Z&&he.call(me,Ce)},void 0,Se)}}j.chain=oe;const Z=Symbol("HaltChainable");class Y{constructor(){this.f=[]}map(we){return this.f.push(we),this}forEach(we){return this.f.push(re=>(we(re),re)),this}filter(we){return this.f.push(re=>we(re)?re:Z),this}reduce(we,re){let he=re;return this.f.push(me=>(he=we(he,me),he)),this}latch(we=(re,he)=>re===he){let re=!0,he;return this.f.push(me=>{const Se=re||!we(me,he);return re=!1,he=me,Se?me:Z}),this}evaluate(we){for(const re of this.f)if(we=re(we),we===Z)break;return we}}function M(ye,we,re=he=>he){const he=(...De)=>Pe.fire(re(...De)),me=()=>ye.on(we,he),Se=()=>ye.removeListener(we,he),Pe=new i({onWillAddFirstListener:me,onDidRemoveLastListener:Se});return Pe.event}j.fromNodeEventEmitter=M;function z(ye,we,re=he=>he){const he=(...De)=>Pe.fire(re(...De)),me=()=>ye.addEventListener(we,he),Se=()=>ye.removeEventListener(we,he),Pe=new i({onWillAddFirstListener:me,onDidRemoveLastListener:Se});return Pe.event}j.fromDOMEventEmitter=z;function ie(ye){return new Promise(we=>V(ye)(we))}j.toPromise=ie;function ae(ye){const we=new i;return ye.then(re=>{we.fire(re)},()=>{we.fire(void 0)}).finally(()=>{we.dispose()}),we.event}j.fromPromise=ae;function ue(ye,we){return ye(re=>we.fire(re))}j.forward=ue;function pe(ye,we,re){return we(re),ye(he=>we(he))}j.runAndSubscribe=pe;class be{constructor(we,re){this._observable=we,this.f=0,this.g=!1;const he={onWillAddFirstListener:()=>{we.addObserver(this),this._observable.reportChanges()},onDidRemoveLastListener:()=>{we.removeObserver(this)}};re||F(he),this.emitter=new i(he),re&&re.add(this.emitter)}beginUpdate(we){this.f++}handlePossibleChange(we){}handleChange(we,re){this.g=!0}endUpdate(we){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Re(ye,we){return new be(ye,we).emitter.event}j.fromObservable=Re;function Ae(ye){return(we,re,he)=>{let me=0,Se=!1;const Pe={beginUpdate(){me++},endUpdate(){me--,me===0&&(ye.reportChanges(),Se&&(Se=!1,we.call(re)))},handlePossibleChange(){},handleChange(){Se=!0}};ye.addObserver(Pe),ye.reportChanges();const De={dispose(){ye.removeObserver(Pe)}};return he instanceof N.$Wc?he.add(De):Array.isArray(he)&&he.push(De),De}}j.fromObservableLight=Ae})(I||(e.Event=I={}));class p{static{this.all=new Set}static{this.f=0}constructor(F){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${F}_${p.f++}`,p.all.add(this)}start(F){this.g=new T.$ie,this.listenerCount=F}stop(){if(this.g){const F=this.g.elapsed();this.durations.push(F),this.elapsedOverall+=F,this.invocationCount+=1,this.g=void 0}}}e.$ke=p;let $=-1;function g(j){const F=$;return $=j,{dispose(){$=F}}}class l{static{this.f=1}constructor(F,G,V=(l.f++).toString(16).padStart(3,"0")){this.j=F,this.threshold=G,this.name=V,this.h=0}dispose(){this.g?.clear()}check(F,G){const V=this.threshold;if(V<=0||G<V)return;this.g||(this.g=new Map);const x=this.g.get(F.value)||0;if(this.g.set(F.value,x+1),this.h-=1,this.h<=0){this.h=V*.5;const[H,te]=this.getMostFrequentStack(),B=`[${this.name}] potential listener LEAK detected, having ${G} listeners already. MOST frequent listener (${te}):`;console.warn(B),console.warn(H);const W=new E(B,H);this.j(W)}return()=>{const H=this.g.get(F.value)||0;this.g.set(F.value,H-1)}}getMostFrequentStack(){if(!this.g)return;let F,G=0;for(const[V,x]of this.g)(!F||G<x)&&(F=[V,x],G=x);return F}}class d{static create(){const F=new Error;return new d(F.stack??"")}constructor(F){this.value=F}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class E extends Error{constructor(F,G){super(F),this.name="ListenerLeakError",this.stack=G}}e.$me=E;class w extends Error{constructor(F,G){super(F),this.name="ListenerRefusalError",this.stack=G}}e.$ne=w;let f=0;class P{constructor(F){this.value=F,this.id=f++}}const m=2,c=(j,F)=>{if(j instanceof P)F(j);else for(let G=0;G<j.length;G++){const V=j[G];V&&F(V)}};let h;if(k){const j=[];setInterval(()=>{j.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(j.join(`
`)),j.length=0)},3e3),h=new FinalizationRegistry(F=>{typeof F=="string"&&j.push(F)})}class i{constructor(F){this.z=0,this.f=F,this.g=$>0||this.f?.leakWarningThreshold?new l(F?.onListenerError??R.$2,this.f?.leakWarningThreshold??$):void 0,this.j=this.f?._profName?new p(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(O){const F=this.u;queueMicrotask(()=>{c(F,G=>G.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(F,G,V)=>{if(this.g&&this.z>this.g.threshold**2){const W=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(W);const _=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],ne=new w(`${W}. HINT: Stack shows most frequent listener (${_[1]}-times)`,_[0]);return(this.f?.onListenerError||R.$2)(ne),N.$Xc.None}if(this.m)return N.$Xc.None;G&&(F=F.bind(G));const x=new P(F);let H,te;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(x.stack=d.create(),H=this.g.check(x.stack,this.z+1)),O&&(x.stack=te??d.create()),this.u?this.u instanceof P?(this.w??=new t,this.u=[this.u,x]):this.u.push(x):(this.f?.onWillAddFirstListener?.(this),this.u=x,this.f?.onDidAddFirstListener?.(this)),this.z++;const B=(0,N.$Vc)(()=>{h?.unregister(B),H?.(),this.A(x)});if(V instanceof N.$Wc?V.add(B):Array.isArray(V)&&V.push(B),h){const W=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),_=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(W);h.register(B,_?.[2]??W,B)}return B},this.q}A(F){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const G=this.u,V=G.indexOf(F);if(V===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,G[V]=void 0;const x=this.w.current===this;if(this.z*m<=G.length){let H=0;for(let te=0;te<G.length;te++)G[te]?G[H++]=G[te]:x&&(this.w.end--,H<this.w.i&&this.w.i--);G.length=H}}B(F,G){if(!F)return;const V=this.f?.onListenerError||R.$2;if(!V){F.value(G);return}try{F.value(G)}catch(x){V(x)}}C(F){const G=F.current.u;for(;F.i<F.end;)this.B(G[F.i++],F.value);F.reset()}fire(F){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof P)this.B(this.u,F);else{const G=this.w;G.enqueue(this,F,this.u.length),this.C(G)}this.j?.stop()}hasListeners(){return this.z>0}}e.$oe=i;const n=()=>new t;e.$pe=n;class t{constructor(){this.i=-1,this.end=0}enqueue(F,G,V){this.i=0,this.end=V,this.current=F,this.value=G}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class s extends i{async fireAsync(F,G,V){if(this.u)for(this.h||(this.h=new A.$8c),c(this.u,x=>this.h.push([x.value,F]));this.h.size>0&&!G.isCancellationRequested;){const[x,H]=this.h.shift(),te=[],B={...H,token:G,waitUntil:W=>{if(Object.isFrozen(te))throw new Error("waitUntil can NOT be called asynchronous");V&&(W=V(W,x)),te.push(W)}};try{x(B)}catch(W){(0,R.$2)(W);continue}Object.freeze(te),await Promise.allSettled(te).then(W=>{for(const _ of W)_.status==="rejected"&&(0,R.$2)(_.reason)})}}}e.$qe=s;class r extends i{get isPaused(){return this.h!==0}constructor(F){super(F),this.h=0,this.s=new A.$8c,this.t=F?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const F=Array.from(this.s);this.s.clear(),super.fire(this.t(F))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(F){this.z&&(this.h!==0?this.s.push(F):super.fire(F))}}e.$re=r;class o extends r{constructor(F){super(F),this.k=F.delay??100}fire(F){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(F)}}e.$se=o;class u extends i{constructor(F){super(F),this.h=[],this.k=F?.merge}fire(F){this.hasListeners()&&(this.h.push(F),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(G=>super.fire(G)),this.h=[]}))}}e.$te=u;class b{constructor(){this.g=!1,this.h=[],this.f=new i({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(F){const G={event:F,listener:null};this.h.push(G),this.g&&this.m(G);const V=()=>{this.g&&this.o(G);const x=this.h.indexOf(G);this.h.splice(x,1)};return(0,N.$Vc)((0,a.$fb)(V))}j(){this.g=!0,this.h.forEach(F=>this.m(F))}k(){this.g=!1,this.h.forEach(F=>this.o(F))}m(F){F.listener=F.event(G=>this.f.fire(G))}o(F){F.listener?.dispose(),F.listener=null}dispose(){this.f.dispose();for(const F of this.h)F.listener?.dispose();this.h=[]}}e.$ue=b;class C{constructor(F,G,V,x){this.f=new N.$Wc;const H=this.f.add(new b),te=this.f.add(new N.$7c);function B(W){te.set(W,H.add(x(W)))}for(const W of F)B(W);this.f.add(G(W=>{B(W)})),this.f.add(V(W=>{te.deleteAndDispose(W)})),this.event=H.event}dispose(){this.f.dispose()}}e.$ve=C;class S{constructor(){this.f=[]}wrapEvent(F,G,V){return(x,H,te)=>F(B=>{const W=this.f[this.f.length-1];if(!G){W?W.buffers.push(()=>x.call(H,B)):x.call(H,B);return}const _=W;if(!_){x.call(H,G(V,B));return}_.items??=[],_.items.push(B),_.buffers.length===0&&W.buffers.push(()=>{_.reducedResult??=V?_.items.reduce(G,V):_.items.reduce(G),x.call(H,_.reducedResult)})},void 0,te)}bufferEvents(F){const G={buffers:new Array};this.f.push(G);const V=F();return this.f.pop(),G.buffers.forEach(x=>x()),V}}e.$we=S;class v{constructor(){this.f=!1,this.g=I.None,this.h=N.$Xc.None,this.j=new i({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(F){this.g=F,this.f&&(this.h.dispose(),this.h=F(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$xe=v;class L{static const(F){return new U(F)}constructor(F){this.g=F,this.f=new i,this.onDidChange=this.f.event}get value(){return this.g}set value(F){F!==this.g&&(this.g=F,this.f.fire(void 0))}}e.$ye=L;class U{constructor(F){this.value=F,this.onDidChange=I.None}}}),define(fe[25],de([0,1,3]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.CancellationToken=void 0,e.$Ae=k;const a=Object.freeze(function(O,y){const I=setTimeout(O.bind(y),0);return{dispose(){clearTimeout(I)}}});var N;(function(O){function y(I){return I===O.None||I===O.Cancelled||I instanceof A?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}O.isCancellationToken=y,O.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:R.Event.None}),O.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:a})})(N||(e.CancellationToken=N={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?a:(this.b||(this.b=new R.$oe),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class T{constructor(y){this.f=void 0,this.g=void 0,this.g=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=N.Cancelled}dispose(y=!1){y&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=N.None}}e.$ze=T;function k(O){const y=new T;return O.add({dispose(){y.cancel()}}),y.token}}),define(fe[137],de([0,1,25]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cf=e.$bf=e.$_e=void 0,e.$af=N;class a{constructor(O){this.b=O,this.a=null}get(){if(this.a)return this.a;const O=new R.$ze,y=this.b(O.token);return this.a={promise:y,dispose:()=>{this.a=null,O.cancel(),O.dispose()}},this.a}}e.$_e=a;function N(k){return k}class A{constructor(O,y){this.a=void 0,this.b=void 0,typeof O=="function"?(this.c=O,this.d=N):(this.c=y,this.d=O.getCacheKey)}get(O){const y=this.d(O);return this.b!==y&&(this.b=y,this.a=this.c(O)),this.a}}e.$bf=A;class T{get cachedValues(){return this.a}constructor(O,y){this.a=new Map,this.b=new Map,typeof O=="function"?(this.c=O,this.d=N):(this.c=y,this.d=O.getCacheKey)}get(O){const y=this.d(O);if(this.b.has(y))return this.b.get(y);const I=this.c(O);return this.a.set(O,I),this.b.set(y,I),I}}e.$cf=T}),define(fe[50],de([0,1,8,2]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Be=N,e.$Ce=A,e.$De=T,e.$Ee=k,e.$Fe=y,e.$Ge=I,e.$He=p,e.$Ie=$,e.$Je=g,e.$Ke=l,e.$Le=d,e.$Me=E,e.$Ne=w,e.$Oe=f,e.$Pe=P;function N(m){const c=m;return c?typeof c.read=="function":!1}function A(m){const c=m;return c?[c.on,c.pause,c.resume,c.destroy].every(h=>typeof h=="function"):!1}function T(m){const c=m;return c?A(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}function k(m,c){return new O(m,c)}class O{constructor(c,h){this.e=c,this.f=h,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(c){if(!this.a.destroyed){if(this.a.flowing)this.g(c);else if(this.b.data.push(c),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(h=>this.d.push(h))}}error(c){this.a.destroyed||(this.a.flowing?this.h(c):this.b.error.push(c))}end(c){this.a.destroyed||(typeof c<"u"&&this.write(c),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(c){this.c.data.slice(0).forEach(h=>h(c))}h(c){this.c.error.length===0?(0,R.$2)(c):this.c.error.slice(0).forEach(h=>h(c))}i(){this.c.end.slice(0).forEach(c=>c())}on(c,h){if(!this.a.destroyed)switch(c){case"data":this.c.data.push(h),this.resume();break;case"end":this.c.end.push(h),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(h),this.a.flowing&&this.k();break}}removeListener(c,h){if(this.a.destroyed)return;let i;switch(c){case"data":i=this.c.data;break;case"end":i=this.c.end;break;case"error":i=this.c.error;break}if(i){const n=i.indexOf(h);n>=0&&i.splice(n,1)}}j(){if(this.b.data.length>0){const c=this.e(this.b.data);this.g(c),this.b.data.length=0;const h=[...this.d];this.d.length=0,h.forEach(i=>i())}}k(){if(this.c.error.length>0){for(const c of this.b.error)this.h(c);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function y(m,c){const h=[];let i;for(;(i=m.read())!==null;)h.push(i);return c(h)}function I(m,c,h){const i=[];let n;for(;(n=m.read())!==null&&i.length<h;)i.push(n);return n===null&&i.length>0?c(i):{read:()=>{if(i.length>0)return i.shift();if(typeof n<"u"){const t=n;return n=void 0,t}return m.read()}}}function p(m,c){return new Promise((h,i)=>{const n=[];$(m,{onData:t=>{c&&n.push(t)},onError:t=>{c?i(t):h(void 0)},onEnd:()=>{h(c?c(n):void 0)}})})}function $(m,c,h){m.on("error",i=>{h?.isCancellationRequested||c.onError(i)}),m.on("end",()=>{h?.isCancellationRequested||c.onEnd()}),m.on("data",i=>{h?.isCancellationRequested||c.onData(i)})}function g(m,c){return new Promise((h,i)=>{const n=new a.$Wc,t=[],s=u=>{if(t.push(u),t.length>c)return n.dispose(),m.pause(),h({stream:m,buffer:t,ended:!1})},r=u=>(n.dispose(),i(u)),o=()=>(n.dispose(),h({stream:m,buffer:t,ended:!0}));n.add((0,a.$Vc)(()=>m.removeListener("error",r))),m.on("error",r),n.add((0,a.$Vc)(()=>m.removeListener("end",o))),m.on("end",o),n.add((0,a.$Vc)(()=>m.removeListener("data",s))),m.on("data",s)})}function l(m,c){const h=k(c);return h.end(m),h}function d(){const m=k(()=>{throw new Error("not supported")});return m.end(),m}function E(m){let c=!1;return{read:()=>c?null:(c=!0,m)}}function w(m,c,h){const i=k(h);return $(m,{onData:n=>i.write(c.data(n)),onError:n=>i.error(c.error?c.error(n):n),onEnd:()=>i.end()}),i}function f(m,c,h){let i=!1;return{read:()=>{const n=c.read();return i?n:(i=!0,n!==null?h([m,n]):m)}}}function P(m,c,h){let i=!1;const n=k(h);return $(c,{onData:t=>i?n.write(t):(i=!0,n.write(h([m,t]))),onError:t=>n.error(t),onEnd:()=>{i||(i=!0,n.write(m)),n.end()}}),n}}),define(fe[14],de([0,1,53,50]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qe=void 0,e.$Re=y,e.$Se=I,e.$Te=p,e.$Ue=$,e.$Ve=g,e.$We=l,e.$Xe=d,e.$Ye=E,e.$Ze=w,e.$1e=f,e.$2e=P,e.$3e=m,e.$4e=c,e.$5e=h,e.$6e=i,e.$7e=n,e.$8e=t,e.$9e=s,e.$0e=r,e.$$e=b,a=Oe(a);const N=typeof Buffer<"u",A=new R.$W(()=>new Uint8Array(256));let T,k;class O{static alloc(S){return N?new O(Buffer.allocUnsafe(S)):new O(new Uint8Array(S))}static wrap(S){return N&&!Buffer.isBuffer(S)&&(S=Buffer.from(S.buffer,S.byteOffset,S.byteLength)),new O(S)}static fromString(S,v){return!(v?.dontUseNodeBuffer||!1)&&N?new O(Buffer.from(S)):(T||(T=new TextEncoder),new O(T.encode(S)))}static fromByteArray(S){const v=O.alloc(S.length);for(let L=0,U=S.length;L<U;L++)v.buffer[L]=S[L];return v}static concat(S,v){if(typeof v>"u"){v=0;for(let j=0,F=S.length;j<F;j++)v+=S[j].byteLength}const L=O.alloc(v);let U=0;for(let j=0,F=S.length;j<F;j++){const G=S[j];L.set(G,U),U+=G.byteLength}return L}constructor(S){this.buffer=S,this.byteLength=this.buffer.byteLength}clone(){const S=O.alloc(this.byteLength);return S.set(this),S}toString(){return N?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(S,v){return new O(this.buffer.subarray(S,v))}set(S,v){if(S instanceof O)this.buffer.set(S.buffer,v);else if(S instanceof Uint8Array)this.buffer.set(S,v);else if(S instanceof ArrayBuffer)this.buffer.set(new Uint8Array(S),v);else if(ArrayBuffer.isView(S))this.buffer.set(new Uint8Array(S.buffer,S.byteOffset,S.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(S){return $(this.buffer,S)}writeUInt32BE(S,v){g(this.buffer,S,v)}readUInt32LE(S){return l(this.buffer,S)}writeUInt32LE(S,v){d(this.buffer,S,v)}readUInt8(S){return E(this.buffer,S)}writeUInt8(S,v){w(this.buffer,S,v)}indexOf(S,v=0){return y(this.buffer,S instanceof O?S.buffer:S,v)}}e.$Qe=O;function y(C,S,v=0){const L=S.byteLength,U=C.byteLength;if(L===0)return 0;if(L===1)return C.indexOf(S[0]);if(L>U-v)return-1;const j=A.value;j.fill(S.length);for(let x=0;x<S.length;x++)j[S[x]]=S.length-x-1;let F=v+S.length-1,G=F,V=-1;for(;F<U;)if(C[F]===S[G]){if(G===0){V=F;break}F--,G--}else F+=Math.max(S.length-G,j[C[F]]),G=S.length-1;return V}function I(C,S){return C[S+0]<<0>>>0|C[S+1]<<8>>>0}function p(C,S,v){C[v+0]=S&255,S=S>>>8,C[v+1]=S&255}function $(C,S){return C[S]*2**24+C[S+1]*2**16+C[S+2]*2**8+C[S+3]}function g(C,S,v){C[v+3]=S,S=S>>>8,C[v+2]=S,S=S>>>8,C[v+1]=S,S=S>>>8,C[v]=S}function l(C,S){return C[S+0]<<0>>>0|C[S+1]<<8>>>0|C[S+2]<<16>>>0|C[S+3]<<24>>>0}function d(C,S,v){C[v+0]=S&255,S=S>>>8,C[v+1]=S&255,S=S>>>8,C[v+2]=S&255,S=S>>>8,C[v+3]=S&255}function E(C,S){return C[S]}function w(C,S,v){C[v]=S}function f(C){return a.$Fe(C,S=>O.concat(S))}function P(C){return a.$Me(C)}function m(C){return a.$He(C,S=>O.concat(S))}async function c(C){return C.ended?O.concat(C.buffer):O.concat([...C.buffer,await m(C.stream)])}function h(C){return a.$Ke(C,S=>O.concat(S))}function i(C){return a.$Ne(C,{data:S=>typeof S=="string"?O.fromString(S):O.wrap(S)},S=>O.concat(S))}function n(C){return a.$Ee(S=>O.concat(S),C)}function t(C,S){return a.$Oe(C,S,v=>O.concat(v))}function s(C,S){return a.$Pe(C,S,v=>O.concat(v))}function r(C){let S=0,v=0,L=0;const U=new Uint8Array(Math.floor(C.length/4*3)),j=G=>{switch(v){case 3:U[L++]=S|G,v=0;break;case 2:U[L++]=S|G>>>2,S=G<<6,v=3;break;case 1:U[L++]=S|G>>>4,S=G<<4,v=2;break;default:S=G<<2,v=1}};for(let G=0;G<C.length;G++){const V=C.charCodeAt(G);if(V>=65&&V<=90)j(V-65);else if(V>=97&&V<=122)j(V-97+26);else if(V>=48&&V<=57)j(V-48+52);else if(V===43||V===45)j(62);else if(V===47||V===95)j(63);else{if(V===61)break;throw new SyntaxError(`Unexpected base64 character ${C[G]}`)}}const F=L;for(;v>0;)j(0);return O.wrap(U).slice(0,F)}const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function b({buffer:C},S=!0,v=!1){const L=v?u:o;let U="";const j=C.byteLength%3;let F=0;for(;F<C.byteLength-j;F+=3){const G=C[F+0],V=C[F+1],x=C[F+2];U+=L[G>>>2],U+=L[(G<<4|V>>>4)&63],U+=L[(V<<2|x>>>6)&63],U+=L[x&63]}if(j===1){const G=C[F+0];U+=L[G>>>2],U+=L[G<<4&63],S&&(U+="==")}else if(j===2){const G=C[F+0],V=C[F+1];U+=L[G>>>2],U+=L[(G<<4|V>>>4)&63],U+=L[V<<2&63],S&&(U+="=")}return U}}),define(fe[138],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$je=void 0,e.$je=Symbol("MicrotaskDelay")}),define(fe[12],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hg=R,e.$ig=a,e.$jg=N,e.$kg=A,e.$lg=T,e.$mg=k,e.$ng=O,e.$og=y,e.$pg=I,e.$qg=p,e.$rg=$,e.$sg=g,e.$tg=l,e.$ug=E,e.$vg=w,e.$wg=f,e.$xg=P,e.$yg=m,e.$zg=c;function R(h){return typeof h=="string"}function a(h){return Array.isArray(h)&&h.every(i=>R(i))}function N(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}function A(h){const i=Object.getPrototypeOf(Uint8Array);return typeof h=="object"&&h instanceof i}function T(h){return typeof h=="number"&&!isNaN(h)}function k(h){return!!h&&typeof h[Symbol.iterator]=="function"}function O(h){return h===!0||h===!1}function y(h){return typeof h>"u"}function I(h){return!p(h)}function p(h){return y(h)||h===null}function $(h,i){if(!h)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}function g(h){if(p(h))throw new Error("Assertion Failed: argument is undefined or null");return h}function l(...h){const i=[];for(let n=0;n<h.length;n++){const t=h[n];if(p(t))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);i.push(t)}return i}const d=Object.prototype.hasOwnProperty;function E(h){if(!N(h))return!1;for(const i in h)if(d.call(h,i))return!1;return!0}function w(h){return typeof h=="function"}function f(...h){return h.length>0&&h.every(w)}function P(h,i){const n=Math.min(h.length,i.length);for(let t=0;t<n;t++)m(h[t],i[t])}function m(h,i){if(R(i)){if(typeof h!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(w(i)){try{if(h instanceof i)return}catch{}if(!p(h)&&h.constructor===i||i.length===1&&i.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function c(h){return h}}),define(fe[29],de([0,1,12]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$io=a,e.$jo=N,e.$ko=T,e.$lo=O,e.$mo=y,e.$no=I,e.$oo=p,e.$po=$,e.$qo=g,e.$ro=l,e.$so=d,e.$to=E,e.$uo=w;function a(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const P=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([m,c])=>{P[m]=c&&typeof c=="object"?a(c):c}),P}function N(f){if(!f||typeof f!="object")return f;const P=[f];for(;P.length>0;){const m=P.shift();Object.freeze(m);for(const c in m)if(A.call(m,c)){const h=m[c];typeof h=="object"&&!Object.isFrozen(h)&&!(0,R.$kg)(h)&&P.push(h)}}return f}const A=Object.prototype.hasOwnProperty;function T(f,P){return k(f,P,new Set)}function k(f,P,m){if((0,R.$qg)(f))return f;const c=P(f);if(typeof c<"u")return c;if(Array.isArray(f)){const h=[];for(const i of f)h.push(k(i,P,m));return h}if((0,R.$jg)(f)){if(m.has(f))throw new Error("Cannot clone recursive data-structure");m.add(f);const h={};for(const i in f)A.call(f,i)&&(h[i]=k(f[i],P,m));return m.delete(f),h}return f}function O(f,P,m=!0){return(0,R.$jg)(f)?((0,R.$jg)(P)&&Object.keys(P).forEach(c=>{c in f?m&&((0,R.$jg)(f[c])&&(0,R.$jg)(P[c])?O(f[c],P[c],m):f[c]=P[c]):f[c]=P[c]}),f):P}function y(f,P){if(f===P)return!0;if(f==null||P===null||P===void 0||typeof f!=typeof P||typeof f!="object"||Array.isArray(f)!==Array.isArray(P))return!1;let m,c;if(Array.isArray(f)){if(f.length!==P.length)return!1;for(m=0;m<f.length;m++)if(!y(f[m],P[m]))return!1}else{const h=[];for(c in f)h.push(c);h.sort();const i=[];for(c in P)i.push(c);if(i.sort(),!y(h,i))return!1;for(m=0;m<h.length;m++)if(!y(f[h[m]],P[h[m]]))return!1}return!0}function I(f){const P=new Set;return JSON.stringify(f,(m,c)=>{if((0,R.$jg)(c)||Array.isArray(c)){if(P.has(c))return"[Circular]";P.add(c)}return typeof c=="bigint"?`[BigInt ${c.toString()}]`:c})}function p(f,P){const m=Object.create(null);return!f||!P||Object.keys(P).forEach(h=>{const i=f[h],n=P[h];y(i,n)||(m[h]=n)}),m}function $(f,P){const m=P.toLowerCase(),c=Object.keys(f).find(h=>h.toLowerCase()===m);return c?f[c]:f[P]}function g(f,P){const m=Object.create(null);for(const[c,h]of Object.entries(f))P(c,h)&&(m[c]=h);return m}function l(f){let P=[];for(;Object.prototype!==f;)P=P.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return P}function d(f){const P=[];for(const m of l(f))typeof f[m]=="function"&&P.push(m);return P}function E(f,P){const m=h=>function(){const i=Array.prototype.slice.call(arguments,0);return P(h,i)},c={};for(const h of f)c[h]=m(h);return c}function w(f,P){const m={};for(const[c,h]of Object.entries(f))m[c]=P(h,c);return m}}),define(fe[139],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$df=a,e.$ef=N;var R;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(R||(e.Constants=R={}));function a(A){return A<0?0:A>R.MAX_UINT_8?R.MAX_UINT_8:A|0}function N(A){return A<0?0:A>R.MAX_UINT_32?R.MAX_UINT_32:A|0}}),define(fe[26],de([0,1,137,39,53,139]),function(ce,e,R,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gg=e.$fg=e.$eg=e.GraphemeBreakType=e.$7f=e.$Yf=e.$Rf=e.$Qf=void 0,e.$ff=T,e.$gf=O,e.$hf=I,e.$if=p,e.$jf=$,e.$kf=g,e.$lf=l,e.$mf=d,e.$nf=E,e.$of=w,e.$pf=f,e.$qf=P,e.$rf=m,e.$sf=c,e.$tf=h,e.$uf=i,e.$vf=n,e.$wf=t,e.$xf=s,e.$yf=r,e.$zf=o,e.$Af=u,e.$Bf=b,e.$Cf=C,e.$Df=S,e.$Ef=v,e.$Ff=L,e.$Gf=U,e.$Hf=j,e.$If=F,e.$Jf=G,e.$Kf=V,e.$Lf=x,e.$Mf=H,e.$Nf=te,e.$Of=B,e.$Pf=W,e.$Sf=ee,e.$Tf=J,e.$Uf=K,e.$Vf=q,e.$Wf=oe,e.$Xf=Y,e.$Zf=M,e.$1f=z,e.$2f=ie,e.$3f=ae,e.$4f=pe,e.$5f=be,e.$6f=Ae,e.$8f=ye,e.$9f=we,e.$0f=re,e.$$f=he,e.$_f=me,e.$ag=Se,e.$bg=Pe,e.$cg=De,e.$dg=Ve;function T(se){return!se||typeof se!="string"?!0:se.trim().length===0}const k=/{(\d+)}/g;function O(se,...ge){return ge.length===0?se:se.replace(k,function($e,ve){const ke=parseInt(ve,10);return isNaN(ke)||ke<0||ke>=ge.length?$e:ge[ke]})}const y=/{([^}]+)}/g;function I(se,ge){return Object.keys(ge).length===0?se:se.replace(y,($e,ve)=>ge[ve]??$e)}function p(se){return se.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}function $(se){return se.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}function g(se){return se.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function l(se,ge){let $e=0,ve=se.indexOf(ge);for(;ve!==-1;)$e++,ve=se.indexOf(ge,ve+ge.length);return $e}function d(se,ge,$e="\u2026"){return se.length<=ge?se:`${se.substr(0,ge)}${$e}`}function E(se,ge,$e="\u2026"){if(se.length<=ge)return se;const ve=Math.ceil(ge/2)-$e.length/2,ke=Math.floor(ge/2)-$e.length/2;return`${se.substr(0,ve)}${$e}${se.substr(se.length-ke)}`}function w(se,ge=" "){const $e=f(se,ge);return P($e,ge)}function f(se,ge){if(!se||!ge)return se;const $e=ge.length;if($e===0||se.length===0)return se;let ve=0;for(;se.indexOf(ge,ve)===ve;)ve=ve+$e;return se.substring(ve)}function P(se,ge){if(!se||!ge)return se;const $e=ge.length,ve=se.length;if($e===0||ve===0)return se;let ke=ve,Te=-1;for(;Te=se.lastIndexOf(ge,ke-1),!(Te===-1||Te+$e!==ke);){if(Te===0)return"";ke=Te}return se.substring(0,ke)}function m(se){return se.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function c(se){return se.replace(/\*/g,"")}function h(se,ge,$e={}){if(!se)throw new Error("Cannot create regex from empty string");ge||(se=g(se)),$e.wholeWord&&(/\B/.test(se.charAt(0))||(se="\\b"+se),/\B/.test(se.charAt(se.length-1))||(se=se+"\\b"));let ve="";return $e.global&&(ve+="g"),$e.matchCase||(ve+="i"),$e.multiline&&(ve+="m"),$e.unicode&&(ve+="u"),new RegExp(se,ve)}function i(se){return se.source==="^"||se.source==="^$"||se.source==="$"||se.source==="^\\s*$"?!1:!!(se.exec("")&&se.lastIndex===0)}function n(se){return se.split(/\r\n|\r|\n/)}function t(se){const ge=[],$e=se.split(/(\r\n|\r|\n)/);for(let ve=0;ve<Math.ceil($e.length/2);ve++)ge.push($e[2*ve]+($e[2*ve+1]??""));return ge}function s(se){for(let ge=0,$e=se.length;ge<$e;ge++){const ve=se.charCodeAt(ge);if(ve!==a.CharCode.Space&&ve!==a.CharCode.Tab)return ge}return-1}function r(se,ge=0,$e=se.length){for(let ve=ge;ve<$e;ve++){const ke=se.charCodeAt(ve);if(ke!==a.CharCode.Space&&ke!==a.CharCode.Tab)return se.substring(ge,ve)}return se.substring(ge,$e)}function o(se,ge=se.length-1){for(let $e=ge;$e>=0;$e--){const ve=se.charCodeAt($e);if(ve!==a.CharCode.Space&&ve!==a.CharCode.Tab)return $e}return-1}function u(se,ge,$e){const ve=[];let ke=0;for(const Te of se.matchAll(ge)){if(ve.push(se.slice(ke,Te.index)),Te.index===void 0)throw new Error("match.index should be defined");ke=Te.index+Te[0].length,ve.push($e(Te[0],...Te.slice(1),Te.index,se,Te.groups))}return ve.push(se.slice(ke)),Promise.all(ve).then(Te=>Te.join(""))}function b(se,ge){return se<ge?-1:se>ge?1:0}function C(se,ge,$e=0,ve=se.length,ke=0,Te=ge.length){for(;$e<ve&&ke<Te;$e++,ke++){const Qe=se.charCodeAt($e),Xe=ge.charCodeAt(ke);if(Qe<Xe)return-1;if(Qe>Xe)return 1}const qe=ve-$e,xe=Te-ke;return qe<xe?-1:qe>xe?1:0}function S(se,ge){return v(se,ge,0,se.length,0,ge.length)}function v(se,ge,$e=0,ve=se.length,ke=0,Te=ge.length){for(;$e<ve&&ke<Te;$e++,ke++){let Qe=se.charCodeAt($e),Xe=ge.charCodeAt(ke);if(Qe===Xe)continue;if(Qe>=128||Xe>=128)return C(se.toLowerCase(),ge.toLowerCase(),$e,ve,ke,Te);U(Qe)&&(Qe-=32),U(Xe)&&(Xe-=32);const He=Qe-Xe;if(He!==0)return He}const qe=ve-$e,xe=Te-ke;return qe<xe?-1:qe>xe?1:0}function L(se){return se>=a.CharCode.Digit0&&se<=a.CharCode.Digit9}function U(se){return se>=a.CharCode.a&&se<=a.CharCode.z}function j(se){return se>=a.CharCode.A&&se<=a.CharCode.Z}function F(se,ge){return se.length===ge.length&&v(se,ge)===0}function G(se,ge){const $e=ge.length;return ge.length>se.length?!1:v(se,ge,0,$e)===0}function V(se,ge){const $e=Math.min(se.length,ge.length);let ve;for(ve=0;ve<$e;ve++)if(se.charCodeAt(ve)!==ge.charCodeAt(ve))return ve;return $e}function x(se,ge){const $e=Math.min(se.length,ge.length);let ve;const ke=se.length-1,Te=ge.length-1;for(ve=0;ve<$e;ve++)if(se.charCodeAt(ke-ve)!==ge.charCodeAt(Te-ve))return ve;return $e}function H(se){return 55296<=se&&se<=56319}function te(se){return 56320<=se&&se<=57343}function B(se,ge){return(se-55296<<10)+(ge-56320)+65536}function W(se,ge,$e){const ve=se.charCodeAt($e);if(H(ve)&&$e+1<ge){const ke=se.charCodeAt($e+1);if(te(ke))return B(ve,ke)}return ve}function _(se,ge){const $e=se.charCodeAt(ge-1);if(te($e)&&ge>1){const ve=se.charCodeAt(ge-2);if(H(ve))return B(ve,$e)}return $e}class ne{get offset(){return this.e}constructor(ge,$e=0){this.c=ge,this.d=ge.length,this.e=$e}setOffset(ge){this.e=ge}prevCodePoint(){const ge=_(this.c,this.e);return this.e-=ge>=A.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}nextCodePoint(){const ge=W(this.c,this.d,this.e);return this.e+=ge>=A.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}eol(){return this.e>=this.d}}e.$Qf=ne;class le{get offset(){return this.c.offset}constructor(ge,$e=0){this.c=new ne(ge,$e)}nextGraphemeLength(){const ge=Ue.getInstance(),$e=this.c,ve=$e.offset;let ke=ge.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const Te=$e.offset,qe=ge.getGraphemeBreakType($e.nextCodePoint());if(Ce(ke,qe)){$e.setOffset(Te);break}ke=qe}return $e.offset-ve}prevGraphemeLength(){const ge=Ue.getInstance(),$e=this.c,ve=$e.offset;let ke=ge.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const Te=$e.offset,qe=ge.getGraphemeBreakType($e.prevCodePoint());if(Ce(qe,ke)){$e.setOffset(Te);break}ke=qe}return ve-$e.offset}eol(){return this.c.eol()}}e.$Rf=le;function ee(se,ge){return new le(se,ge).nextGraphemeLength()}function J(se,ge){return new le(se,ge).prevGraphemeLength()}function K(se,ge){ge>0&&te(se.charCodeAt(ge))&&ge--;const $e=ge+ee(se,ge);return[$e-J(se,$e),$e]}function q(se){const ge=new le(se);let $e=0;for(;!ge.eol();)$e++,ge.nextGraphemeLength();return $e}let D;function Q(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function oe(se){return D||(D=Q()),D.test(se)}const Z=/^[\t\n\r\x20-\x7E]*$/;function Y(se){return Z.test(se)}e.$Yf=/[\u2028\u2029]/;function M(se){return e.$Yf.test(se)}function z(se){return se>=11904&&se<=55215||se>=63744&&se<=64255||se>=65281&&se<=65374}function ie(se){return se>=127462&&se<=127487||se===8986||se===8987||se===9200||se===9203||se>=9728&&se<=10175||se===11088||se===11093||se>=127744&&se<=128591||se>=128640&&se<=128764||se>=128992&&se<=129008||se>=129280&&se<=129535||se>=129648&&se<=129782}function ae(se,ge,$e=""){const ve=se.trimStart();if(ve.length<ge)return ve;const ke=/\b/g;let Te=0;for(;ke.test(ve)&&!(ve.length-ke.lastIndex<ge);)Te=ke.lastIndex,ke.lastIndex+=1;return Te===0?ve:$e+ve.substring(Te).trimStart()}const ue=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*pe(se){let ge=0;for(const $e of se.matchAll(ue))ge!==$e.index&&(yield{isCode:!1,str:se.substring(ge,$e.index)}),yield{isCode:!0,str:$e[0]},ge=$e.index+$e[0].length;ge!==se.length&&(yield{isCode:!1,str:se.substring(ge)})}function be(se){return se&&(se=se.replace(ue,"")),se}const Re=/\\\[.*?\\\]/g;function Ae(se){return be(se).replace(Re,"")}e.$7f=String.fromCharCode(a.CharCode.UTF8_BOM);function ye(se){return!!(se&&se.length>0&&se.charCodeAt(0)===a.CharCode.UTF8_BOM)}function we(se){return ye(se)?se.substr(1):se}function re(se,ge){if(!se||!ge||se.length<ge.length)return!1;const $e=ge.length,ve=se.toLowerCase();let ke=0,Te=-1;for(;ke<$e;){const qe=ve.indexOf(ge[ke],Te+1);if(qe<0)return!1;Te=qe,ke++}return!0}function he(se,ge=!1){return se?(ge&&(se=se.replace(/\\./g,"")),se.toLowerCase()!==se):!1}function me(se){return se.charAt(0).toUpperCase()+se.slice(1)}function Se(se,ge=1){if(ge===0)return"";let $e=-1;do $e=se.indexOf(`
`,$e+1),ge--;while(ge>0&&$e>=0);return $e===-1?se:(se[$e-1]==="\r"&&$e--,se.substr(0,$e))}function Pe(se){const ge=a.CharCode.Z-a.CharCode.A+1;return se=se%(2*ge),se<ge?String.fromCharCode(a.CharCode.a+se):String.fromCharCode(a.CharCode.A+se-ge)}function De(se){return Ue.getInstance().getGraphemeBreakType(se)}function Ce(se,ge){return se===Ne.Other?ge!==Ne.Extend&&ge!==Ne.SpacingMark:se===Ne.CR&&ge===Ne.LF?!1:se===Ne.Control||se===Ne.CR||se===Ne.LF||ge===Ne.Control||ge===Ne.CR||ge===Ne.LF?!0:!(se===Ne.L&&(ge===Ne.L||ge===Ne.V||ge===Ne.LV||ge===Ne.LVT)||(se===Ne.LV||se===Ne.V)&&(ge===Ne.V||ge===Ne.T)||(se===Ne.LVT||se===Ne.T)&&ge===Ne.T||ge===Ne.Extend||ge===Ne.ZWJ||ge===Ne.SpacingMark||se===Ne.Prepend||se===Ne.ZWJ&&ge===Ne.Extended_Pictographic||se===Ne.Regional_Indicator&&ge===Ne.Regional_Indicator)}var Ne;(function(se){se[se.Other=0]="Other",se[se.Prepend=1]="Prepend",se[se.CR=2]="CR",se[se.LF=3]="LF",se[se.Control=4]="Control",se[se.Extend=5]="Extend",se[se.Regional_Indicator=6]="Regional_Indicator",se[se.SpacingMark=7]="SpacingMark",se[se.L=8]="L",se[se.V=9]="V",se[se.T=10]="T",se[se.LV=11]="LV",se[se.LVT=12]="LVT",se[se.ZWJ=13]="ZWJ",se[se.Extended_Pictographic=14]="Extended_Pictographic"})(Ne||(e.GraphemeBreakType=Ne={}));class Ue{static{this.c=null}static getInstance(){return Ue.c||(Ue.c=new Ue),Ue.c}constructor(){this.d=Me()}getGraphemeBreakType(ge){if(ge<32)return ge===a.CharCode.LineFeed?Ne.LF:ge===a.CharCode.CarriageReturn?Ne.CR:Ne.Control;if(ge<127)return Ne.Other;const $e=this.d,ve=$e.length/3;let ke=1;for(;ke<=ve;)if(ge<$e[3*ke])ke=2*ke;else if(ge>$e[3*ke+1])ke=2*ke+1;else return $e[3*ke+2];return Ne.Other}}function Me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ve(se,ge){if(se===0)return 0;const $e=Fe(se,ge);if($e!==void 0)return $e;const ve=new ne(ge,se);return ve.prevCodePoint(),ve.offset}function Fe(se,ge){const $e=new ne(ge,se);let ve=$e.prevCodePoint();for(;Be(ve)||ve===ze.emojiVariantSelector||ve===ze.enclosingKeyCap;){if($e.offset===0)return;ve=$e.prevCodePoint()}if(!ie(ve))return;let ke=$e.offset;return ke>0&&$e.prevCodePoint()===ze.zwj&&(ke=$e.offset),ke}function Be(se){return 127995<=se&&se<=127999}var ze;(function(se){se[se.zwj=8205]="zwj",se[se.emojiVariantSelector=65039]="emojiVariantSelector",se[se.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.$eg="\xA0";class We{static{this.c=new N.$W(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new R.$bf({getCacheKey:JSON.stringify},ge=>{function $e(He){const _e=new Map;for(let Ye=0;Ye<He.length;Ye+=2)_e.set(He[Ye],He[Ye+1]);return _e}function ve(He,_e){const Ye=new Map(He);for(const[nt,at]of _e)Ye.set(nt,at);return Ye}function ke(He,_e){if(!He)return _e;const Ye=new Map;for(const[nt,at]of He)_e.has(nt)&&Ye.set(nt,at);return Ye}const Te=this.c.value;let qe=ge.filter(He=>!He.startsWith("_")&&He in Te);qe.length===0&&(qe=["_default"]);let xe;for(const He of qe){const _e=$e(Te[He]);xe=ke(xe,_e)}const Qe=$e(Te._common),Xe=ve(Qe,xe);return new We(Xe)})}static getInstance(ge){return We.d.get(Array.from(ge))}static{this.e=new N.$W(()=>Object.keys(We.c.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return We.e.value}constructor(ge){this.f=ge}isAmbiguous(ge){return this.f.has(ge)}containsAmbiguousCharacter(ge){for(let $e=0;$e<ge.length;$e++){const ve=ge.codePointAt($e);if(typeof ve=="number"&&this.isAmbiguous(ve))return!0}return!1}getPrimaryConfusable(ge){return this.f.get(ge)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$fg=We;class Le{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Le.c())),this.d}static isInvisibleCharacter(ge){return Le.e().has(ge)}static containsInvisibleCharacter(ge){for(let $e=0;$e<ge.length;$e++){const ve=ge.codePointAt($e);if(typeof ve=="number"&&Le.isInvisibleCharacter(ve))return!0}return!1}static get codePoints(){return Le.e()}}e.$gg=Le}),define(fe[41],de([0,1,39,13,5,26,12]),function(ce,e,R,a,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ag=k,e.$Bg=O,e.$Cg=y,e.$Dg=I,e.$Eg=p,e.$Fg=d,e.$Gg=E,e.$Hg=w,e.$Ig=f,e.$Jg=P,e.$Kg=m,e.$Lg=c,e.$Mg=h,e.$Ng=i,e.$Og=n,e.$Pg=t,e.$Qg=o;function k(u){return u===R.CharCode.Slash||u===R.CharCode.Backslash}function O(u){return u.replace(/[\\/]/g,a.$jc.sep)}function y(u){return u.indexOf("/")===-1&&(u=O(u)),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u),u}function I(u,b=a.$jc.sep){if(!u)return"";const C=u.length,S=u.charCodeAt(0);if(k(S)){if(k(u.charCodeAt(1))&&!k(u.charCodeAt(2))){let L=3;const U=L;for(;L<C&&!k(u.charCodeAt(L));L++);if(U!==L&&!k(u.charCodeAt(L+1))){for(L+=1;L<C;L++)if(k(u.charCodeAt(L)))return u.slice(0,L+1).replace(/[\\/]/g,b)}}return b}else if(f(S)&&u.charCodeAt(1)===R.CharCode.Colon)return k(u.charCodeAt(2))?u.slice(0,2)+b:u.slice(0,2);let v=u.indexOf("://");if(v!==-1){for(v+=3;v<C;v++)if(k(u.charCodeAt(v)))return u.slice(0,v+1)}return""}function p(u){if(!N.$j||!u||u.length<5)return!1;let b=u.charCodeAt(0);if(b!==R.CharCode.Backslash||(b=u.charCodeAt(1),b!==R.CharCode.Backslash))return!1;let C=2;const S=C;for(;C<u.length&&(b=u.charCodeAt(C),b!==R.CharCode.Backslash);C++);return!(S===C||(b=u.charCodeAt(C+1),isNaN(b)||b===R.CharCode.Backslash))}const $=/[\\/:\*\?"<>\|]/g,g=/[/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(u,b=N.$j){const C=b?$:g;return!(!u||u.length===0||/^\s+$/.test(u)||(C.lastIndex=0,C.test(u))||b&&l.test(u)||u==="."||u===".."||b&&u[u.length-1]==="."||b&&u.length!==u.trim().length||u.length>255)}function E(u,b,C){const S=u===b;return!C||S?S:!u||!b?!1:(0,A.$If)(u,b)}function w(u,b,C,S=a.sep){if(u===b)return!0;if(!u||!b||b.length>u.length)return!1;if(C){if(!(0,A.$Jf)(u,b))return!1;if(b.length===u.length)return!0;let L=b.length;return b.charAt(b.length-1)===S&&L--,u.charAt(L)===S}return b.charAt(b.length-1)!==S&&(b+=S),u.indexOf(b)===0}function f(u){return u>=R.CharCode.A&&u<=R.CharCode.Z||u>=R.CharCode.a&&u<=R.CharCode.z}function P(u,b){return N.$j&&u.endsWith(":")&&(u+=a.sep),(0,a.$lc)(u)||(u=(0,a.$mc)(b,u)),u=(0,a.$kc)(u),m(u)}function m(u){return N.$j?(u=(0,A.$qf)(u,a.sep),u.endsWith(":")&&(u+=a.sep)):(u=(0,A.$qf)(u,a.sep),u||(u=a.sep)),u}function c(u){const b=(0,a.$kc)(u);return N.$j?u.length>3?!1:h(b)&&(u.length===2||b.charCodeAt(2)===R.CharCode.Backslash):b===a.$jc.sep}function h(u,b=N.$j){return b?f(u.charCodeAt(0))&&u.charCodeAt(1)===R.CharCode.Colon:!1}function i(u,b=N.$j){return h(u,b)?u[0]:void 0}function n(u,b,C){return b.length>u.length?-1:u===b?0:(C&&(u=u.toLowerCase(),b=b.toLowerCase()),u.indexOf(b))}function t(u){const b=u.split(":");let C,S,v;for(const L of b){const U=Number(L);(0,T.$lg)(U)?S===void 0?S=U:v===void 0&&(v=U):C=C?[C,L].join(":"):L}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:S!==void 0?S:void 0,column:v!==void 0?v:S!==void 0?1:void 0}}const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",r="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function o(u,b,C=8){let S="";for(let L=0;L<C;L++){let U;L===0&&N.$j&&!b&&(C===3||C===4)?U=r:U=s,S+=U.charAt(Math.floor(Math.random()*U.length))}let v;return b?v=`${b}-${S}`:v=S,u?(0,a.$mc)(u,v):v}}),define(fe[55],de([0,1,26]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cj=e.$Aj=void 0,e.$wj=a,e.$xj=N,e.$yj=A,e.$zj=k,e.$Bj=d,R=Oe(R);function a(w){return N(w,0)}function N(w,f){switch(typeof w){case"object":return w===null?A(349,f):Array.isArray(w)?O(w,f):y(w,f);case"string":return k(w,f);case"boolean":return T(w,f);case"number":return A(w,f);case"undefined":return A(937,f);default:return A(617,f)}}function A(w,f){return(f<<5)-f+w|0}function T(w,f){return A(w?433:863,f)}function k(w,f){f=A(149417,f);for(let P=0,m=w.length;P<m;P++)f=A(w.charCodeAt(P),f);return f}function O(w,f){return f=A(104579,f),w.reduce((P,m)=>N(m,P),f)}function y(w,f){return f=A(181387,f),Object.keys(w).sort().reduce((P,m)=>(P=k(m,P),N(w[m],P)),f)}class I{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=N(f,this.g),this.g}}e.$Aj=I;var p;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(p||(p={}));function $(w,f,P=32){const m=P-f,c=~((1<<m)-1);return(w<<f|(c&w)>>>m)>>>0}function g(w,f=0,P=w.byteLength,m=0){for(let c=0;c<P;c++)w[f+c]=m}function l(w,f,P="0"){for(;w.length<f;)w=P+w;return w}function d(w,f=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(P=>P.toString(16).padStart(2,"0")).join(""):l((w>>>0).toString(16),f/4)}class E{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(p.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const P=f.length;if(P===0)return;const m=this.p;let c=this.r,h=this.u,i,n;for(h!==0?(i=h,n=-1,h=0):(i=f.charCodeAt(0),n=0);;){let t=i;if(R.$Mf(i))if(n+1<P){const s=f.charCodeAt(n+1);R.$Nf(s)?(n++,t=R.$Of(i,s)):t=p.UNICODE_REPLACEMENT}else{h=i;break}else R.$Nf(i)&&(t=p.UNICODE_REPLACEMENT);if(c=this.w(m,c,t),n++,n<P)i=f.charCodeAt(n);else break}this.r=c,this.u=h}w(f,P,m){return m<128?f[P++]=m:m<2048?(f[P++]=192|(m&1984)>>>6,f[P++]=128|(m&63)>>>0):m<65536?(f[P++]=224|(m&61440)>>>12,f[P++]=128|(m&4032)>>>6,f[P++]=128|(m&63)>>>0):(f[P++]=240|(m&1835008)>>>18,f[P++]=128|(m&258048)>>>12,f[P++]=128|(m&4032)>>>6,f[P++]=128|(m&63)>>>0),P>=p.BLOCK_SIZE&&(this.y(),P-=p.BLOCK_SIZE,this.t+=p.BLOCK_SIZE,f[0]=f[p.BLOCK_SIZE+0],f[1]=f[p.BLOCK_SIZE+1],f[2]=f[p.BLOCK_SIZE+2]),P}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,p.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),d(this.h)+d(this.l)+d(this.m)+d(this.n)+d(this.o)}x(){this.p[this.r++]=128,g(this.p,this.r),this.r>56&&(this.y(),g(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=E.g,P=this.q;for(let o=0;o<64;o+=4)f.setUint32(o,P.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)f.setUint32(o,$(f.getUint32(o-12,!1)^f.getUint32(o-32,!1)^f.getUint32(o-56,!1)^f.getUint32(o-64,!1),1),!1);let m=this.h,c=this.l,h=this.m,i=this.n,n=this.o,t,s,r;for(let o=0;o<80;o++)o<20?(t=c&h|~c&i,s=1518500249):o<40?(t=c^h^i,s=1859775393):o<60?(t=c&h|c&i|h&i,s=2400959708):(t=c^h^i,s=3395469782),r=$(m,5)+t+n+s+f.getUint32(o*4,!1)&4294967295,n=i,i=h,h=$(c,30),c=m,m=r;this.h=this.h+m&4294967295,this.l=this.l+c&4294967295,this.m=this.m+h&4294967295,this.n=this.n+i&4294967295,this.o=this.o+n&4294967295}}e.$Cj=E}),define(fe[94],de([0,1,26]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R=Oe(R);var a;(function(N){N[N.Ignore=0]="Ignore",N[N.Info=1]="Info",N[N.Warning=2]="Warning",N[N.Error=3]="Error"})(a||(a={})),function(N){const A="error",T="warning",k="warn",O="info",y="ignore";function I($){return $?R.$If(A,$)?N.Error:R.$If(T,$)||R.$If(k,$)?N.Warning:R.$If(O,$)?N.Info:N.Ignore:N.Ignore}N.fromValue=I;function p($){switch($){case N.Error:return A;case N.Warning:return T;case N.Info:return O;default:return y}}N.toString=p}(a||(a={})),e.default=a}),define(fe[51],de([0,1,17,39,26]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=void 0;class A{constructor(){this.b="",this.c=0}reset(l){return this.b=l,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(l){const d=l.charCodeAt(0),E=this.b.charCodeAt(this.c);return d-E}value(){return this.b[this.c]}}e.$Ki=A;class T{constructor(l=!0){this.e=l}reset(l){return this.b=l,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let l=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===a.CharCode.Period)if(l)this.c++;else break;else l=!1;return this}cmp(l){return this.e?(0,N.$Cf)(l,this.b,0,l.length,this.c,this.d):(0,N.$Ef)(l,this.b,0,l.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Li=T;class k{constructor(l=!0,d=!0){this.f=l,this.g=d}reset(l){this.d=0,this.e=0,this.b=l,this.c=l.length;for(let d=l.length-1;d>=0;d--,this.c--){const E=this.b.charCodeAt(d);if(!(E===a.CharCode.Slash||this.f&&E===a.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let l=!0;for(;this.e<this.c;this.e++){const d=this.b.charCodeAt(this.e);if(d===a.CharCode.Slash||this.f&&d===a.CharCode.Backslash)if(l)this.d++;else break;else l=!1}return this}cmp(l){return this.g?(0,N.$Cf)(l,this.b,0,l.length,this.d,this.e):(0,N.$Ef)(l,this.b,0,l.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Mi=k;var O;(function(g){g[g.Scheme=1]="Scheme",g[g.Authority=2]="Authority",g[g.Path=3]="Path",g[g.Query=4]="Query",g[g.Fragment=5]="Fragment"})(O||(O={}));class y{constructor(l,d){this.f=l,this.g=d,this.d=[],this.e=0}reset(l){return this.c=l,this.d=[],this.c.scheme&&this.d.push(O.Scheme),this.c.authority&&this.d.push(O.Authority),this.c.path&&(this.b=new k(!1,!this.f(l)),this.b.reset(l.path),this.b.value()&&this.d.push(O.Path)),this.g(l)||(this.c.query&&this.d.push(O.Query),this.c.fragment&&this.d.push(O.Fragment)),this.e=0,this}next(){return this.d[this.e]===O.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===O.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(l){if(this.d[this.e]===O.Scheme)return(0,N.$Df)(l,this.c.scheme);if(this.d[this.e]===O.Authority)return(0,N.$Df)(l,this.c.authority);if(this.d[this.e]===O.Path)return this.b.cmp(l);if(this.d[this.e]===O.Query)return(0,N.$Bf)(l,this.c.query);if(this.d[this.e]===O.Fragment)return(0,N.$Bf)(l,this.c.fragment);throw new Error}value(){if(this.d[this.e]===O.Scheme)return this.c.scheme;if(this.d[this.e]===O.Authority)return this.c.authority;if(this.d[this.e]===O.Path)return this.b.value();if(this.d[this.e]===O.Query)return this.c.query;if(this.d[this.e]===O.Fragment)return this.c.fragment;throw new Error}}e.$Ni=y;class I{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(g){g[g.Left=-1]="Left",g[g.Mid=0]="Mid",g[g.Right=1]="Right"})(p||(p={}));class ${static forUris(l=()=>!1,d=()=>!1){return new $(new y(l,d))}static forPaths(l=!1){return new $(new k(void 0,!l))}static forStrings(){return new $(new A)}static forConfigKeys(){return new $(new T)}constructor(l){this.b=l}clear(){this.c=void 0}fill(l,d){if(d){const E=d.slice(0);(0,R.$Yb)(E);for(const w of E)this.set(w,l)}else{const E=l.slice(0);(0,R.$Yb)(E);for(const w of E)this.set(w[0],w[1])}}set(l,d){const E=this.b.reset(l);let w;this.c||(this.c=new I,this.c.segment=E.value());const f=[];for(w=this.c;;){const m=E.cmp(w.segment);if(m>0)w.left||(w.left=new I,w.left.segment=E.value()),f.push([p.Left,w]),w=w.left;else if(m<0)w.right||(w.right=new I,w.right.segment=E.value()),f.push([p.Right,w]),w=w.right;else if(E.hasNext())E.next(),w.mid||(w.mid=new I,w.mid.segment=E.value()),f.push([p.Mid,w]),w=w.mid;else break}const P=w.value;w.value=d,w.key=l;for(let m=f.length-1;m>=0;m--){const c=f[m][1];c.updateHeight();const h=c.balanceFactor();if(h<-1||h>1){const i=f[m][0],n=f[m+1][0];if(i===p.Right&&n===p.Right)f[m][1]=c.rotateLeft();else if(i===p.Left&&n===p.Left)f[m][1]=c.rotateRight();else if(i===p.Right&&n===p.Left)c.right=f[m+1][1]=f[m+1][1].rotateRight(),f[m][1]=c.rotateLeft();else if(i===p.Left&&n===p.Right)c.left=f[m+1][1]=f[m+1][1].rotateLeft(),f[m][1]=c.rotateRight();else throw new Error;if(m>0)switch(f[m-1][0]){case p.Left:f[m-1][1].left=f[m][1];break;case p.Right:f[m-1][1].right=f[m][1];break;case p.Mid:f[m-1][1].mid=f[m][1];break}else this.c=f[0][1]}}return P}get(l){return this.d(l)?.value}d(l){const d=this.b.reset(l);let E=this.c;for(;E;){const w=d.cmp(E.segment);if(w>0)E=E.left;else if(w<0)E=E.right;else if(d.hasNext())d.next(),E=E.mid;else break}return E}has(l){const d=this.d(l);return!(d?.value===void 0&&d?.mid===void 0)}delete(l){return this.e(l,!1)}deleteSuperstr(l){return this.e(l,!0)}e(l,d){const E=this.b.reset(l),w=[];let f=this.c;for(;f;){const P=E.cmp(f.segment);if(P>0)w.push([p.Left,f]),f=f.left;else if(P<0)w.push([p.Right,f]),f=f.right;else if(E.hasNext())E.next(),w.push([p.Mid,f]),f=f.mid;else break}if(f){if(d?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const P=this.f(f.right);if(P.key){const{key:m,value:c,segment:h}=P;this.e(P.key,!1),f.key=m,f.value=c,f.segment=h}}else{const P=f.left??f.right;if(w.length>0){const[m,c]=w[w.length-1];switch(m){case p.Left:c.left=P;break;case p.Mid:c.mid=P;break;case p.Right:c.right=P;break}}else this.c=P}for(let P=w.length-1;P>=0;P--){const m=w[P][1];m.updateHeight();const c=m.balanceFactor();if(c>1?(m.right.balanceFactor()>=0||(m.right=m.right.rotateRight()),w[P][1]=m.rotateLeft()):c<-1&&(m.left.balanceFactor()<=0||(m.left=m.left.rotateLeft()),w[P][1]=m.rotateRight()),P>0)switch(w[P-1][0]){case p.Left:w[P-1][1].left=w[P][1];break;case p.Right:w[P-1][1].right=w[P][1];break;case p.Mid:w[P-1][1].mid=w[P][1];break}else this.c=w[0][1]}}}f(l){for(;l.left;)l=l.left;return l}findSubstr(l){const d=this.b.reset(l);let E=this.c,w;for(;E;){const f=d.cmp(E.segment);if(f>0)E=E.left;else if(f<0)E=E.right;else if(d.hasNext())d.next(),w=E.value||w,E=E.mid;else break}return E&&E.value||w}findSuperstr(l){return this.g(l,!1)}g(l,d){const E=this.b.reset(l);let w=this.c;for(;w;){const f=E.cmp(w.segment);if(f>0)w=w.left;else if(f<0)w=w.right;else if(E.hasNext())E.next(),w=w.mid;else return w.mid?this.h(w.mid):d?w.value:void 0}}hasElementOrSubtree(l){return this.g(l,!0)!==void 0}forEach(l){for(const[d,E]of this)l(E,d)}*[Symbol.iterator](){yield*this.h(this.c)}h(l){const d=[];return this.j(l,d),d[Symbol.iterator]()}j(l,d){l&&(l.left&&this.j(l.left,d),l.value&&d.push([l.key,l.value]),l.mid&&this.j(l.mid,d),l.right&&this.j(l.right,d))}_isBalanced(){const l=d=>{if(!d)return!0;const E=d.balanceFactor();return E<-1||E>1?!1:l(d.left)&&l(d.right)};return l(this.c)}}e.$Oi=$}),define(fe[9],de([0,1,39,65,13,5]),function(ce,e,R,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$yc=E,e.$zc=h,N=Oe(N);const T=/^\w[\w\d+.-]*$/,k=/^\//,O=/^\/\//;function y(r,o){if(!r.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!T.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!k.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(O.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(r,o){return!r&&!o?"file":r}function p(r,o){switch(r){case"https":case"http":case"file":o?o[0]!==g&&(o=g+o):o=g;break}return o}const $="",g="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(o){return o instanceof d?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}constructor(o,u,b,C,S,v=!1){typeof o=="object"?(this.scheme=o.scheme||$,this.authority=o.authority||$,this.path=o.path||$,this.query=o.query||$,this.fragment=o.fragment||$):(this.scheme=I(o,v),this.authority=u||$,this.path=p(this.scheme,b||$),this.query=C||$,this.fragment=S||$,y(this,v))}get fsPath(){return h(this,!1)}with(o){if(!o)return this;let{scheme:u,authority:b,path:C,query:S,fragment:v}=o;return u===void 0?u=this.scheme:u===null&&(u=$),b===void 0?b=this.authority:b===null&&(b=$),C===void 0?C=this.path:C===null&&(C=$),S===void 0?S=this.query:S===null&&(S=$),v===void 0?v=this.fragment:v===null&&(v=$),u===this.scheme&&b===this.authority&&C===this.path&&S===this.query&&v===this.fragment?this:new f(u,b,C,S,v)}static parse(o,u=!1){const b=l.exec(o);return b?new f(b[2]||$,s(b[4]||$),s(b[5]||$),s(b[7]||$),s(b[9]||$),u):new f($,$,$,$,$)}static file(o){let u=$;if(A.$j&&(o=o.replace(/\\/g,g)),o[0]===g&&o[1]===g){const b=o.indexOf(g,2);b===-1?(u=o.substring(2),o=g):(u=o.substring(2,b),o=o.substring(b)||g)}return new f("file",u,o,$,$)}static from(o,u){return new f(o.scheme,o.authority,o.path,o.query,o.fragment,u)}static joinPath(o,...u){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return A.$j&&o.scheme==="file"?b=d.file(N.$ic.join(h(o,!0),...u)).path:b=N.$jc.join(o.path,...u),o.with({path:b})}toString(o=!1){return i(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof d)return o;{const u=new f(o);return u._formatted=o.external??null,u._fsPath=o._sep===w?o.fsPath??null:null,u}}else return o}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=d;function E(r){return!r||typeof r!="object"?!1:typeof r.scheme=="string"&&(typeof r.authority=="string"||typeof r.authority>"u")&&(typeof r.path=="string"||typeof r.path>"u")&&(typeof r.query=="string"||typeof r.query>"u")&&(typeof r.fragment=="string"||typeof r.fragment>"u")}const w=A.$j?1:void 0;class f extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(o=!1){return o?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const o={$mid:a.MarshalledId.Uri};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=w),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const P={[R.CharCode.Colon]:"%3A",[R.CharCode.Slash]:"%2F",[R.CharCode.QuestionMark]:"%3F",[R.CharCode.Hash]:"%23",[R.CharCode.OpenSquareBracket]:"%5B",[R.CharCode.CloseSquareBracket]:"%5D",[R.CharCode.AtSign]:"%40",[R.CharCode.ExclamationMark]:"%21",[R.CharCode.DollarSign]:"%24",[R.CharCode.Ampersand]:"%26",[R.CharCode.SingleQuote]:"%27",[R.CharCode.OpenParen]:"%28",[R.CharCode.CloseParen]:"%29",[R.CharCode.Asterisk]:"%2A",[R.CharCode.Plus]:"%2B",[R.CharCode.Comma]:"%2C",[R.CharCode.Semicolon]:"%3B",[R.CharCode.Equals]:"%3D",[R.CharCode.Space]:"%20"};function m(r,o,u){let b,C=-1;for(let S=0;S<r.length;S++){const v=r.charCodeAt(S);if(v>=R.CharCode.a&&v<=R.CharCode.z||v>=R.CharCode.A&&v<=R.CharCode.Z||v>=R.CharCode.Digit0&&v<=R.CharCode.Digit9||v===R.CharCode.Dash||v===R.CharCode.Period||v===R.CharCode.Underline||v===R.CharCode.Tilde||o&&v===R.CharCode.Slash||u&&v===R.CharCode.OpenSquareBracket||u&&v===R.CharCode.CloseSquareBracket||u&&v===R.CharCode.Colon)C!==-1&&(b+=encodeURIComponent(r.substring(C,S)),C=-1),b!==void 0&&(b+=r.charAt(S));else{b===void 0&&(b=r.substr(0,S));const L=P[v];L!==void 0?(C!==-1&&(b+=encodeURIComponent(r.substring(C,S)),C=-1),b+=L):C===-1&&(C=S)}}return C!==-1&&(b+=encodeURIComponent(r.substring(C))),b!==void 0?b:r}function c(r){let o;for(let u=0;u<r.length;u++){const b=r.charCodeAt(u);b===R.CharCode.Hash||b===R.CharCode.QuestionMark?(o===void 0&&(o=r.substr(0,u)),o+=P[b]):o!==void 0&&(o+=r[u])}return o!==void 0?o:r}function h(r,o){let u;return r.authority&&r.path.length>1&&r.scheme==="file"?u=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===R.CharCode.Slash&&(r.path.charCodeAt(1)>=R.CharCode.A&&r.path.charCodeAt(1)<=R.CharCode.Z||r.path.charCodeAt(1)>=R.CharCode.a&&r.path.charCodeAt(1)<=R.CharCode.z)&&r.path.charCodeAt(2)===R.CharCode.Colon?o?u=r.path.substr(1):u=r.path[1].toLowerCase()+r.path.substr(2):u=r.path,A.$j&&(u=u.replace(/\//g,"\\")),u}function i(r,o){const u=o?c:m;let b="",{scheme:C,authority:S,path:v,query:L,fragment:U}=r;if(C&&(b+=C,b+=":"),(S||C==="file")&&(b+=g,b+=g),S){let j=S.indexOf("@");if(j!==-1){const F=S.substr(0,j);S=S.substr(j+1),j=F.lastIndexOf(":"),j===-1?b+=u(F,!1,!1):(b+=u(F.substr(0,j),!1,!1),b+=":",b+=u(F.substr(j+1),!1,!0)),b+="@"}S=S.toLowerCase(),j=S.lastIndexOf(":"),j===-1?b+=u(S,!1,!0):(b+=u(S.substr(0,j),!1,!0),b+=S.substr(j))}if(v){if(v.length>=3&&v.charCodeAt(0)===R.CharCode.Slash&&v.charCodeAt(2)===R.CharCode.Colon){const j=v.charCodeAt(1);j>=R.CharCode.A&&j<=R.CharCode.Z&&(v=`/${String.fromCharCode(j+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===R.CharCode.Colon){const j=v.charCodeAt(0);j>=R.CharCode.A&&j<=R.CharCode.Z&&(v=`${String.fromCharCode(j+32)}:${v.substr(2)}`)}b+=u(v,!0,!1)}return L&&(b+="?",b+=u(L,!1,!1)),U&&(b+="#",b+=o?U:m(U,!1,!1)),b}function n(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+n(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(r){return r.match(t)?r.replace(t,o=>n(o)):r}}),define(fe[140],de([0,1,9]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=a,e.$kr=N,e.$lr=A,e.log=k;function a(y){const I=y;return I&&typeof I.type=="string"&&typeof I.severity=="string"}function N(y){const I=[];let p;try{const $=JSON.parse(y.arguments),g=$[$.length-1];g&&g.__$stack&&($.pop(),p=g.__$stack),I.push(...$)}catch{I.push("Unable to log remote console arguments",y.arguments)}return{args:I,stack:p}}function A(y){if(typeof y!="string")return A(N(y).stack);const I=y;if(I){const p=T(I),$=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(p||"");if($&&$.length===4)return{uri:R.URI.file($[1]),line:Number($[2]),column:Number($[3])}}}function T(y){if(!y)return y;const I=y.indexOf(`
`);return I===-1?y:y.substring(0,I)}function k(y,I){const{args:p,stack:$}=N(y),g=typeof p[0]=="string"&&p.length===1;let l=T($);l&&(l=`(${l.trim()})`);let d=[];if(typeof p[0]=="string"?l&&g?d=[`%c[${I}] %c${p[0]} %c${l}`,O("blue"),O(""),O("grey")]:d=[`%c[${I}] %c${p[0]}`,O("blue"),O(""),...p.slice(1)]:d=[`%c[${I}]%`,O("blue"),...p],l&&!g&&d.push(l),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,d)}function O(y){return`color: ${y}`}}),define(fe[66],de([0,1,14,9,65]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=A,e.$ei=T,e.$fi=O;function A(y){return JSON.stringify(y,k)}function T(y){let I=JSON.parse(y);return I=O(I),I}function k(y,I){return I instanceof RegExp?{$mid:N.MarshalledId.Regexp,source:I.source,flags:I.flags}:I}function O(y,I=0){if(!y||I>200)return y;if(typeof y=="object"){switch(y.$mid){case N.MarshalledId.Uri:return a.URI.revive(y);case N.MarshalledId.Regexp:return new RegExp(y.source,y.flags);case N.MarshalledId.Date:return new Date(y.source)}if(y instanceof R.$Qe||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let p=0;p<y.length;++p)y[p]=O(y[p],I+1);else for(const p in y)Object.hasOwnProperty.call(y,p)&&(y[p]=O(y[p],I+1))}return y}}),define(fe[22],de([0,1,8,5,26,9,13]),function(ce,e,R,a,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Vg=e.$Ug=e.$Tg=e.Schemas=void 0,e.$Rg=O,e.$Sg=y,e.$Wg=p,R=Oe(R),a=Oe(a),T=Oe(T);var k;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellMetadataDiff="vscode-notebook-cell-metadata-diff",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeNotebookCellOutputDiff="vscode-notebook-cell-output-diff",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatCodeBlock="vscode-chat-code-block",l.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm",l.commentsInput="comment",l.codeSetting="code-setting",l.outputChannel="output"})(k||(e.Schemas=k={}));function O(l,d){return A.URI.isUri(l)?(0,N.$If)(l.scheme,d):(0,N.$Jf)(l,d+":")}function y(l,...d){return d.some(E=>O(l,E))}e.$Tg="vscode-tkn",e.$Ug="tkn";class I{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(d){this.d=d}setDelegate(d){this.e=d}setServerRootPath(d,E){this.f=p(d,E)}getServerRootPath(){return this.f}get g(){return T.$jc.join(this.f,k.vscodeRemoteResource)}set(d,E,w){this.a[d]=E,this.b[d]=w}setConnectionToken(d,E){this.c[d]=E}getPreferredWebSchema(){return this.d}rewrite(d){if(this.e)try{return this.e(d)}catch(c){return R.$2(c),d}const E=d.authority;let w=this.a[E];w&&w.indexOf(":")!==-1&&w.indexOf("[")===-1&&(w=`[${w}]`);const f=this.b[E],P=this.c[E];let m=`path=${encodeURIComponent(d.path)}`;return typeof P=="string"&&(m+=`&${e.$Ug}=${encodeURIComponent(P)}`),A.URI.from({scheme:a.$p?this.d:k.vscodeRemoteResource,authority:`${w}:${f}`,path:this.g,query:m})}}e.$Vg=new I;function p(l,d){return T.$jc.join(d??"/",`${l.quality??"oss"}-${l.commit??"dev"}`)}e.$Xg="vs/../../extensions",e.$Yg="vs/../../node_modules",e.$Zg="vs/../../node_modules.asar",e.$1g="vs/../../node_modules.asar.unpacked",e.$2g="vscode-app";class ${static{this.a=e.$2g}asBrowserUri(d){const E=this.b(d,ce);return this.uriToBrowserUri(E)}uriToBrowserUri(d){return d.scheme===k.vscodeRemote?e.$Vg.rewrite(d):d.scheme===k.file&&(a.$n||a.$r===`${k.vscodeFileResource}://${$.a}`)?d.with({scheme:k.vscodeFileResource,authority:d.authority||$.a,query:null,fragment:null}):d}asFileUri(d){const E=this.b(d,ce);return this.uriToFileUri(E)}uriToFileUri(d){return d.scheme===k.vscodeFileResource?d.with({scheme:k.file,authority:d.authority!==$.a?d.authority:null,query:null,fragment:null}):d}b(d,E){if(A.URI.isUri(d))return d;if(globalThis._VSCODE_FILE_ROOT){const w=globalThis._VSCODE_FILE_ROOT;if(/^\w[\w\d+.-]*:\/\//.test(w))return A.URI.joinPath(A.URI.parse(w,!0),d);const f=T.$mc(w,d);return A.URI.file(f)}return A.URI.parse(E.toUrl(d))}}e.$3g=new $;var g;(function(l){const d=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(d.get("3"));const E="vscode-coi";function w(P){let m;typeof P=="string"?m=new URL(P).searchParams:P instanceof URL?m=P.searchParams:A.URI.isUri(P)&&(m=new URL(P.toString(!0)).searchParams);const c=m?.get(E);if(c)return d.get(c)}l.getHeadersFromQuery=w;function f(P,m,c){if(!globalThis.crossOriginIsolated)return;const h=m&&c?"3":c?"2":"1";P instanceof URLSearchParams?P.set(E,h):P[E]=h}l.addSearchParam=f})(g||(e.COI=g={}))}),define(fe[67],de([0,1,88,22,5,12,9]),function(ce,e,R,a,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=p,e.$yq=$,N=Oe(N);class k{constructor(l,d,E){this.id=l,this.dependencies=d,this.callback=E}}class O{static{this.INSTANCE=new O}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){if(!this.d){this.d=!0,globalThis.define=(l,d,E)=>{typeof l!="string"&&(E=d,d=l,l=null),(typeof d!="object"||!Array.isArray(d))&&(E=d,d=null),this.c.push(new k(l,d,E))},globalThis.define.amd=!0;try{this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(l){if(l.startsWith(window.location.origin)||l.startsWith("vscode-file://vscode-app"))return l;throw new Error(`[trusted_script_src] Invalid script url: ${l}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(l){return l}}))}catch(l){console.warn(l)}}}async load(l){this.g();const d=await(this.a?this.i(l):this.b?this.h(l):this.j(l));if(!d){console.warn(`Did not receive a define call from script ${l}`);return}if(Array.isArray(d.dependencies)&&d.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${l}. The dependencies are: ${d.dependencies.join(", ")}`);return typeof d.callback=="function"?d.callback([]):d.callback}h(l){return new Promise((d,E)=>{const w=document.createElement("script");w.setAttribute("async","async"),w.setAttribute("type","text/javascript");const f=()=>{w.removeEventListener("load",P),w.removeEventListener("error",m)},P=c=>{f(),d(this.c.pop())},m=c=>{f(),E(c)};w.addEventListener("load",P),w.addEventListener("error",m),this.f&&(l=this.f.createScriptURL(l)),w.setAttribute("src",l),window.document.getElementsByTagName("head")[0].appendChild(w)})}async i(l){return this.f&&(l=this.f.createScriptURL(l)),R.$T?await new Promise((d,E)=>{ce([l],d,E)}).then(Oe):importScripts(l),this.c.pop()}async j(l){try{const d=globalThis._VSCODE_NODE_MODULES.fs,E=globalThis._VSCODE_NODE_MODULES.vm,w=globalThis._VSCODE_NODE_MODULES.module,f=T.URI.parse(l).fsPath,P=d.readFileSync(f).toString(),m=w.wrap(P.replace(/^#!.*/,""));return new E.Script(m).runInThisContext().apply(),this.c.pop()}catch(d){throw d}}}const y=new Map;let I={};typeof globalThis.require=="object"&&(I=globalThis.require.paths??{});async function p(g,l,d){if(R.$T){d===void 0&&(d=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),I[g]&&(g=I[g]);const E=l?`${g}/${l}`:g;if(y.has(E))return y.get(E);let w;if(/^\w[\w\d+.-]*:\/\//.test(E))w=E;else{const c=`${R.$U&&d&&!N.$p?a.$Zg:a.$Yg}/${E}`;w=a.$3g.asBrowserUri(c).toString(!0)}const f=O.INSTANCE.load(w);return y.set(E,f),f}else return await new Promise((E,w)=>{ce([g],E,w)}).then(Oe)}function $(g,l){(0,A.$rg)(R.$T);const E=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit,w=R.$U&&E&&!N.$p,f=`${g}/${l}`,m=`${w?a.$Zg:a.$Yg}/${f}`;return a.$3g.asBrowserUri(m).toString(!0)}}),define(fe[20],de([0,1,39,41,22,13,5,26,9]),function(ce,e,R,a,N,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=void 0,e.$0g=y,e.$sh=p,e.$th=g,a=Oe(a),A=Oe(A);function y(l){return(0,O.$zc)(l,!0)}class I{constructor(d){this.a=d}compare(d,E,w=!1){return d===E?0:(0,k.$Bf)(this.getComparisonKey(d,w),this.getComparisonKey(E,w))}isEqual(d,E,w=!1){return d===E?!0:!d||!E?!1:this.getComparisonKey(d,w)===this.getComparisonKey(E,w)}getComparisonKey(d,E=!1){return d.with({path:this.a(d)?d.path.toLowerCase():void 0,fragment:E?null:void 0}).toString()}ignorePathCasing(d){return this.a(d)}isEqualOrParent(d,E,w=!1){if(d.scheme===E.scheme){if(d.scheme===N.Schemas.file)return a.$Hg(y(d),y(E),this.a(d))&&d.query===E.query&&(w||d.fragment===E.fragment);if((0,e.$oh)(d.authority,E.authority))return a.$Hg(d.path,E.path,this.a(d),"/")&&d.query===E.query&&(w||d.fragment===E.fragment)}return!1}joinPath(d,...E){return O.URI.joinPath(d,...E)}basenameOrAuthority(d){return(0,e.$gh)(d)||d.authority}basename(d){return A.$jc.basename(d.path)}extname(d){return A.$jc.extname(d.path)}dirname(d){if(d.path.length===0)return d;let E;return d.scheme===N.Schemas.file?E=O.URI.file(A.$pc(y(d))).path:(E=A.$jc.dirname(d.path),d.authority&&E.length&&E.charCodeAt(0)!==R.CharCode.Slash&&(console.error(`dirname("${d.toString})) resulted in a relative path`),E="/")),d.with({path:E})}normalizePath(d){if(!d.path.length)return d;let E;return d.scheme===N.Schemas.file?E=O.URI.file(A.$kc(y(d))).path:E=A.$jc.normalize(d.path),d.with({path:E})}relativePath(d,E){if(d.scheme!==E.scheme||!(0,e.$oh)(d.authority,E.authority))return;if(d.scheme===N.Schemas.file){const P=A.$oc(y(d),y(E));return T.$j?a.$Bg(P):P}let w=d.path||"/";const f=E.path||"/";if(this.a(d)){let P=0;for(const m=Math.min(w.length,f.length);P<m&&!(w.charCodeAt(P)!==f.charCodeAt(P)&&w.charAt(P).toLowerCase()!==f.charAt(P).toLowerCase());P++);w=f.substr(0,P)+w.substr(P)}return A.$jc.relative(w,f)}resolvePath(d,E){if(d.scheme===N.Schemas.file){const w=O.URI.file(A.$nc(y(d),E));return d.with({authority:w.authority,path:w.path})}return E=a.$Cg(E),d.with({path:A.$jc.resolve(d.path,E)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,E){return d===E||d!==void 0&&E!==void 0&&(0,k.$If)(d,E)}hasTrailingPathSeparator(d,E=A.sep){if(d.scheme===N.Schemas.file){const w=y(d);return w.length>a.$Dg(w).length&&w[w.length-1]===E}else{const w=d.path;return w.length>1&&w.charCodeAt(w.length-1)===R.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,E=A.sep){return(0,e.$ph)(d,E)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,E=A.sep){let w=!1;if(d.scheme===N.Schemas.file){const f=y(d);w=f!==void 0&&f.length===a.$Dg(f).length&&f[f.length-1]===E}else{E="/";const f=d.path;w=f.length===1&&f.charCodeAt(f.length-1)===R.CharCode.Slash}return!w&&!(0,e.$ph)(d,E)?d.with({path:d.path+"/"}):d}}e.$$g=I,e.$_g=new I(()=>!1),e.$ah=new I(l=>l.scheme===N.Schemas.file?!T.$l:!0),e.$bh=new I(l=>!0),e.$ch=e.$_g.isEqual.bind(e.$_g),e.$dh=e.$_g.isEqualOrParent.bind(e.$_g),e.$eh=e.$_g.getComparisonKey.bind(e.$_g),e.$fh=e.$_g.basenameOrAuthority.bind(e.$_g),e.$gh=e.$_g.basename.bind(e.$_g),e.$hh=e.$_g.extname.bind(e.$_g),e.$ih=e.$_g.dirname.bind(e.$_g),e.$jh=e.$_g.joinPath.bind(e.$_g),e.$kh=e.$_g.normalizePath.bind(e.$_g),e.$lh=e.$_g.relativePath.bind(e.$_g),e.$mh=e.$_g.resolvePath.bind(e.$_g),e.$nh=e.$_g.isAbsolutePath.bind(e.$_g),e.$oh=e.$_g.isEqualAuthority.bind(e.$_g),e.$ph=e.$_g.hasTrailingPathSeparator.bind(e.$_g),e.$qh=e.$_g.removeTrailingPathSeparator.bind(e.$_g),e.$rh=e.$_g.addTrailingPathSeparator.bind(e.$_g);function p(l,d){const E=[];for(let w=0;w<l.length;w++){const f=d(l[w]);l.some((P,m)=>m===w?!1:(0,e.$dh)(f,d(P)))||E.push(l[w])}return E}var $;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function d(E){const w=new Map;E.path.substring(E.path.indexOf(";")+1,E.path.lastIndexOf(";")).split(";").forEach(m=>{const[c,h]=m.split(":");c&&h&&w.set(c,h)});const P=E.path.substring(0,E.path.indexOf(";"));return P&&w.set(l.META_DATA_MIME,P),w}l.parseMetaData=d})($||(e.DataUri=$={}));function g(l,d,E){if(d){let w=l.path;return w&&w[0]!==A.$jc.sep&&(w=A.$jc.sep+w),l.with({scheme:E,authority:d,path:w})}return l.with({scheme:E})}}),define(fe[6],de([0,1,25,8,3,2,20,5,138,53]),function(ce,e,R,a,N,A,T,k,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=e.$0h=e.$9h=e.$8h=e.$7h=e.Promises=e.$6h=e.$5h=e.$4h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=void 0,e.$uh=I,e.$vh=p,e.$wh=$,e.$xh=g,e.$yh=l,e.$zh=d,e.$Ah=E,e.$Bh=w,e.$Jh=r,e.$Kh=o,e.$Lh=u,e.$Mh=b,e.$Nh=C,e.$3h=W,e.$$h=Z;function I(M){return!!M&&typeof M.then=="function"}function p(M){const z=new R.$ze,ie=M(z.token),ae=new Promise((ue,pe)=>{const be=z.token.onCancellationRequested(()=>{be.dispose(),pe(new a.$7)});Promise.resolve(ie).then(Re=>{be.dispose(),z.dispose(),ue(Re)},Re=>{be.dispose(),z.dispose(),pe(Re)})});return new class{cancel(){z.cancel(),z.dispose()}then(ue,pe){return ae.then(ue,pe)}catch(ue){return this.then(void 0,ue)}finally(ue){return ae.finally(ue)}}}function $(M,z,ie){return new Promise((ae,ue)=>{const pe=z.onCancellationRequested(()=>{pe.dispose(),ae(ie)});M.then(ae,ue).finally(()=>pe.dispose())})}function g(M,z){return new Promise((ie,ae)=>{const ue=z.onCancellationRequested(()=>{ue.dispose(),ae(new a.$7)});M.then(ie,ae).finally(()=>ue.dispose())})}async function l(M){let z=-1;const ie=M.map((ae,ue)=>ae.then(pe=>(z=ue,pe)));try{return await Promise.race(ie)}finally{M.forEach((ae,ue)=>{ue!==z&&ae.cancel()})}}function d(M,z,ie){let ae;const ue=setTimeout(()=>{ae?.(void 0),ie?.()},z);return Promise.race([M.finally(()=>clearTimeout(ue)),new Promise(pe=>ae=pe)])}function E(M){return new Promise((z,ie)=>{const ae=M();I(ae)?ae.then(z,ie):z(ae)})}function w(){let M,z;return{promise:new Promise((ae,ue)=>{M=ae,z=ue}),resolve:M,reject:z}}class f{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(z){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=z,!this.b){const ie=()=>{if(this.b=null,this.f)return;const ae=this.queue(this.d);return this.d=null,ae};this.b=new Promise(ae=>{this.a.then(ie,ie).then(ae)})}return new Promise((ie,ae)=>{this.b.then(ie,ae)})}return this.a=z(),new Promise((ie,ae)=>{this.a.then(ue=>{this.a=null,ie(ue)},ue=>{this.a=null,ae(ue)})})}dispose(){this.f=!0}}e.$Ch=f;class P{constructor(){this.a=Promise.resolve(null)}queue(z){return this.a=this.a.then(()=>z(),()=>z())}}e.$Dh=P;class m{constructor(){this.a=new Map}queue(z,ie){const ue=(this.a.get(z)??Promise.resolve()).catch(()=>{}).then(ie).finally(()=>{this.a.get(z)===ue&&this.a.delete(z)});return this.a.set(z,ue),ue}}e.$Eh=m;const c=(M,z)=>{let ie=!0;const ae=setTimeout(()=>{ie=!1,z()},M);return{isTriggered:()=>ie,dispose:()=>{clearTimeout(ae),ie=!1}}},h=M=>{let z=!0;return queueMicrotask(()=>{z&&(z=!1,M())}),{isTriggered:()=>z,dispose:()=>{z=!1}}};class i{constructor(z){this.defaultDelay=z,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(z,ie=this.defaultDelay){this.g=z,this.h(),this.b||(this.b=new Promise((ue,pe)=>{this.d=ue,this.f=pe}).then(()=>{if(this.b=null,this.d=null,this.g){const ue=this.g;return this.g=null,ue()}}));const ae=()=>{this.a=null,this.d?.(null)};return this.a=ie===O.$je?h(ae):c(ie,ae),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new a.$7),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Fh=i;class n{constructor(z){this.a=new i(z),this.b=new f}trigger(z,ie){return this.a.trigger(()=>this.b.queue(z),ie)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Gh=n;class t{constructor(){this.a=!1,this.b=new Promise((z,ie)=>{this.d=z})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Hh=t;class s extends t{constructor(z){super(),this.f=setTimeout(()=>this.open(),z)}open(){clearTimeout(this.f),super.open()}}e.$Ih=s;function r(M,z){return z?new Promise((ie,ae)=>{const ue=setTimeout(()=>{pe.dispose(),ie()},M),pe=z.onCancellationRequested(()=>{clearTimeout(ue),pe.dispose(),ae(new a.$7)})}):p(ie=>r(M,ie))}function o(M,z=0,ie){const ae=setTimeout(()=>{M(),ie&&ue.dispose()},z),ue=(0,A.$Vc)(()=>{clearTimeout(ae),ie?.deleteAndLeak(ue)});return ie?.add(ue),ue}function u(M){const z=[];let ie=0;const ae=M.length;function ue(){return ie<ae?M[ie++]():null}function pe(be){be!=null&&z.push(be);const Re=ue();return Re?Re.then(pe):Promise.resolve(z)}return Promise.resolve(null).then(pe)}function b(M,z=ae=>!!ae,ie=null){let ae=0;const ue=M.length,pe=()=>{if(ae>=ue)return Promise.resolve(ie);const be=M[ae++];return Promise.resolve(be()).then(Ae=>z(Ae)?Promise.resolve(Ae):pe())};return pe()}function C(M,z=ae=>!!ae,ie=null){if(M.length===0)return Promise.resolve(ie);let ae=M.length;const ue=()=>{ae=-1;for(const pe of M)pe.cancel?.()};return new Promise((pe,be)=>{for(const Re of M)Re.then(Ae=>{--ae>=0&&z(Ae)?(ue(),pe(Ae)):ae===0&&pe(ie)}).catch(Ae=>{--ae>=0&&(ue(),be(Ae))})})}class S{constructor(z){this.a=0,this.b=!1,this.f=z,this.g=[],this.d=0,this.h=new N.$oe}whenIdle(){return this.size>0?N.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(z){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ie,ae)=>{this.g.push({factory:z,c:ie,e:ae}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const z=this.g.shift();this.d++;const ie=z.factory();ie.then(z.c,z.e),ie.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Oh=S;class v extends S{constructor(){super(1)}}e.$Ph=v;class L{constructor(){this.a=new _,this.b=0}queue(z){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,z())):this.a.run(this.b++,z())}}e.$Qh=L;class U{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const z=new ee;return this.b.add(z),z.p}g(){for(const[,z]of this.a)if(z.size>0)return!1;return!0}queueSize(z,ie=T.$_g){const ae=ie.getComparisonKey(z);return this.a.get(ae)?.size??0}queueFor(z,ie,ae=T.$_g){const ue=ae.getComparisonKey(z);let pe=this.a.get(ue);if(!pe){pe=new v;const be=this.f++,Re=N.Event.once(pe.onDrained)(()=>{pe?.dispose(),this.a.delete(ue),this.h(),this.d?.deleteAndDispose(be),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$7c),this.d.set(be,Re),this.a.set(ue,pe)}return pe.queue(ie)}h(){this.g()&&this.j()}j(){for(const z of this.b)z.complete();this.b.clear()}dispose(){for(const[,z]of this.a)z.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Rh=U;class j{constructor(z,ie){this.b=!1,this.a=-1,typeof z=="function"&&typeof ie=="number"&&this.setIfNotSet(z,ie)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(z,ie){if(this.b)throw new a.$eb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,z()},ie)}setIfNotSet(z,ie){if(this.b)throw new a.$eb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,z()},ie))}}e.$Sh=j;class F{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(z,ie,ae=globalThis){if(this.f)throw new a.$eb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const ue=ae.setInterval(()=>{z()},ie);this.d=(0,A.$Vc)(()=>{ae.clearInterval(ue),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Th=F;class G{constructor(z,ie){this.b=-1,this.a=z,this.d=ie,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(z=this.d){this.cancel(),this.b=setTimeout(this.f,z)}get delay(){return this.d}set delay(z){this.d=z}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Uh=G;class V{constructor(z,ie){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.a=z,this.b=ie,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(z=this.b){z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${z}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(z/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Vh=V;class x extends G{constructor(z,ie){super(z,ie),this.j=[]}work(z){this.j.push(z),this.isScheduled()||this.schedule()}h(){const z=this.j;this.j=[],this.a?.(z)}dispose(){this.j=[],super.dispose()}}e.$Wh=x;class H extends A.$Xc{constructor(z,ie){super(),this.g=z,this.h=ie,this.a=[],this.b=this.B(new A.$Yc),this.f=!1}get pending(){return this.a.length}work(z){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+z.length>this.g.maxBufferedWork)return!1}else if(this.pending+z.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ie of z)this.a.push(ie);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new G(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Xh=H,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Zh=(M,z)=>{(0,k.$C)(()=>{if(ie)return;const ae=Date.now()+15;z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ae-Date.now())}}))});let ie=!1;return{dispose(){ie||(ie=!0)}}}:e.$Zh=(M,z,ie)=>{const ae=M.requestIdleCallback(z,typeof ie=="number"?{timeout:ie}:void 0);let ue=!1;return{dispose(){ue||(ue=!0,M.cancelIdleCallback(ae))}}},e.$Yh=M=>(0,e.$Zh)(globalThis,M)}();class te{constructor(z,ie){this.g=!1,this.d=()=>{try{this.j=ie()}catch(ae){this.l=ae}finally{this.g=!0}},this.f=(0,e.$Zh)(z,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$1h=te;class B extends te{constructor(z){super(globalThis,z)}}e.$2h=B;async function W(M,z,ie){let ae;for(let ue=0;ue<ie;ue++)try{return await M()}catch(pe){ae=pe,await r(z)}throw ae}class _{isRunning(z){return typeof z=="number"?this.a?.taskId===z:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(z,ie,ae){return this.a={taskId:z,cancel:()=>ae?.(),promise:ie},ie.then(()=>this.d(z),()=>this.d(z)),ie}d(z){this.a&&z===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const z=this.b;this.b=void 0,z.run().then(z.promiseResolve,z.promiseReject)}}queue(z){if(this.b)this.b.run=z;else{const{promise:ie,resolve:ae,reject:ue}=w();this.b={run:z,promise:ie,promiseResolve:ae,promiseReject:ue}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$4h=_;class ne{constructor(z,ie=()=>Date.now()){this.d=z,this.f=ie,this.a=0,this.b=0}increment(){const z=this.f();return z-this.a>this.d&&(this.a=z,this.b=0),this.b++,this.b}}e.$5h=ne;var le;(function(M){M[M.Resolved=0]="Resolved",M[M.Rejected=1]="Rejected"})(le||(le={}));class ee{get isRejected(){return this.d?.outcome===le.Rejected}get isResolved(){return this.d?.outcome===le.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===le.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((z,ie)=>{this.a=z,this.b=ie})}complete(z){return new Promise(ie=>{this.a(z),this.d={outcome:le.Resolved,value:z},ie()})}error(z){return new Promise(ie=>{this.b(z),this.d={outcome:le.Rejected,value:z},ie()})}cancel(){return this.error(new a.$7)}}e.$6h=ee;var J;(function(M){async function z(ae){let ue;const pe=await Promise.all(ae.map(be=>be.then(Re=>Re,Re=>{ue||(ue=Re)})));if(typeof ue<"u")throw ue;return pe}M.settled=z;function ie(ae){return new Promise(async(ue,pe)=>{try{await ae(ue,pe)}catch(be){pe(be)}})}M.withAsyncBody=ie})(J||(e.Promises=J={}));class K{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(z){this.a=void 0,this.b=void 0,this.d=!1,this.promise=z.then(ie=>(this.a=ie,this.d=!0,ie),ie=>{throw this.b=ie,this.d=!0,ie})}requireValue(){if(!this.d)throw new a.$eb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$7h=K;class q{constructor(z){this.b=z,this.a=new y.$W(()=>new K(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$8h=q;var D;(function(M){M[M.Initial=0]="Initial",M[M.DoneOK=1]="DoneOK",M[M.DoneError=2]="DoneError"})(D||(D={}));class Q{static fromArray(z){return new Q(ie=>{ie.emitMany(z)})}static fromPromise(z){return new Q(async ie=>{ie.emitMany(await z)})}static fromPromises(z){return new Q(async ie=>{await Promise.all(z.map(async ae=>ie.emitOne(await ae)))})}static merge(z){return new Q(async ie=>{await Promise.all(z.map(async ae=>{for await(const ue of ae)ie.emitOne(ue)}))})}static{this.EMPTY=Q.fromArray([])}constructor(z,ie){this.a=D.Initial,this.b=[],this.d=null,this.f=ie,this.g=new N.$oe,queueMicrotask(async()=>{const ae={emitOne:ue=>this.h(ue),emitMany:ue=>this.j(ue),reject:ue=>this.l(ue)};try{await Promise.resolve(z(ae)),this.k()}catch(ue){this.l(ue)}finally{ae.emitOne=void 0,ae.emitMany=void 0,ae.reject=void 0}})}[Symbol.asyncIterator](){let z=0;return{next:async()=>{do{if(this.a===D.DoneError)throw this.d;if(z<this.b.length)return{done:!1,value:this.b[z++]};if(this.a===D.DoneOK)return{done:!0,value:void 0};await N.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(z,ie){return new Q(async ae=>{for await(const ue of z)ae.emitOne(ie(ue))})}map(z){return Q.map(this,z)}static filter(z,ie){return new Q(async ae=>{for await(const ue of z)ie(ue)&&ae.emitOne(ue)})}filter(z){return Q.filter(this,z)}static coalesce(z){return Q.filter(z,ie=>!!ie)}coalesce(){return Q.coalesce(this)}static async toPromise(z){const ie=[];for await(const ae of z)ie.push(ae);return ie}toPromise(){return Q.toPromise(this)}h(z){this.a===D.Initial&&(this.b.push(z),this.g.fire())}j(z){this.a===D.Initial&&(this.b=this.b.concat(z),this.g.fire())}k(){this.a===D.Initial&&(this.a=D.DoneOK,this.g.fire())}l(z){this.a===D.Initial&&(this.a=D.DoneError,this.d=z,this.g.fire())}}e.$9h=Q;class oe extends Q{constructor(z,ie){super(ie),this.m=z}cancel(){this.m.cancel()}}e.$0h=oe;function Z(M){const z=new R.$ze,ie=M(z.token);return new oe(z,async ae=>{const ue=z.token.onCancellationRequested(()=>{ue.dispose(),z.dispose(),ae.reject(new a.$7)});try{for await(const pe of ie){if(z.token.isCancellationRequested)return;ae.emitOne(pe)}ue.dispose(),z.dispose()}catch(pe){ue.dispose(),z.dispose(),ae.reject(pe)}})}class Y{constructor(z){this.a=new ee,this.b=new Q(ue=>{if(ie){ue.reject(ie);return}return ae&&ue.emitMany(ae),this.d=pe=>ue.reject(pe),this.f=pe=>ue.emitOne(pe),this.a.p},z);let ie,ae;this.f=ue=>{ae||(ae=[]),ae.push(ue)},this.d=ue=>{ie||(ie=ue)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(z){this.d(z),this.a.complete()}emitOne(z){this.f(z)}}e.$_h=Y}),define(fe[95],de([0,1,17,6,39,41,31,13,5,26]),function(ce,e,R,a,N,A,T,k,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=e.$zk=void 0,e.$yk=I,e.$Bk=d,e.$Ck=L,e.$Dk=U,e.$Ek=j,e.$Fk=F,e.$Gk=G,e.$Hk=te;function I(){return Object.create(null)}e.$zk="**",e.$Ak="/";const p="[/\\\\]",$="[^/\\\\]",g=/\//g;function l(B,W){switch(B){case 0:return"";case 1:return`${$}*?`;default:return`(?:${p}|${$}+${p}${W?`|${p}${$}+`:""})*?`}}function d(B,W){if(!B)return[];const _=[];let ne=!1,le=!1,ee="";for(const J of B){switch(J){case W:if(!ne&&!le){_.push(ee),ee="";continue}break;case"{":ne=!0;break;case"}":ne=!1;break;case"[":le=!0;break;case"]":le=!1;break}ee+=J}return ee&&_.push(ee),_}function E(B){if(!B)return"";let W="";const _=d(B,e.$Ak);if(_.every(ne=>ne===e.$zk))W=".*";else{let ne=!1;_.forEach((le,ee)=>{if(le===e.$zk){if(ne)return;W+=l(2,ee===_.length-1)}else{let J=!1,K="",q=!1,D="";for(const Q of le){if(Q!=="}"&&J){K+=Q;continue}if(q&&(Q!=="]"||!D)){let oe;Q==="-"?oe=Q:(Q==="^"||Q==="!")&&!D?oe="^":Q===e.$Ak?oe="":oe=(0,y.$kf)(Q),D+=oe;continue}switch(Q){case"{":J=!0;continue;case"[":q=!0;continue;case"}":{const Z=`(?:${d(K,",").map(Y=>E(Y)).join("|")})`;W+=Z,J=!1,K="";break}case"]":{W+="["+D+"]",q=!1,D="";break}case"?":W+=$;continue;case"*":W+=l(1);continue;default:W+=(0,y.$kf)(Q)}}ee<_.length-1&&(_[ee+1]!==e.$zk||ee+2<_.length)&&(W+=p)}ne=le===e.$zk})}return W}const w=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,P=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,m=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new T.$Gc(1e4),n=function(){return!1},t=function(){return null};function s(B,W){if(!B)return t;let _;typeof B!="string"?_=B.pattern:_=B,_=_.trim();const ne=`${_}_${!!W.trimForExclusions}`;let le=i.get(ne);if(le)return r(le,B);let ee;return w.test(_)?le=u(_.substr(4),_):(ee=f.exec(o(_,W)))?le=b(ee[1],_):(W.trimForExclusions?m:P).test(_)?le=C(_,W):(ee=c.exec(o(_,W)))?le=S(ee[1].substr(1),_,!0):(ee=h.exec(o(_,W)))?le=S(ee[1],_,!1):le=v(_),i.set(ne,le),r(le,B)}function r(B,W){if(typeof W=="string")return B;const _=function(ne,le){return(0,A.$Hg)(ne,W.base,!O.$l)?B((0,y.$pf)(ne.substr(W.base.length),k.sep),le):null};return _.allBasenames=B.allBasenames,_.allPaths=B.allPaths,_.basenames=B.basenames,_.patterns=B.patterns,_}function o(B,W){return W.trimForExclusions&&B.endsWith("/**")?B.substr(0,B.length-2):B}function u(B,W){return function(_,ne){return typeof _=="string"&&_.endsWith(B)?W:null}}function b(B,W){const _=`/${B}`,ne=`\\${B}`,le=function(J,K){return typeof J!="string"?null:K?K===B?W:null:J===B||J.endsWith(_)||J.endsWith(ne)?W:null},ee=[B];return le.basenames=ee,le.patterns=[W],le.allBasenames=ee,le}function C(B,W){const _=H(B.slice(1,-1).split(",").map(K=>s(K,W)).filter(K=>K!==t),B),ne=_.length;if(!ne)return t;if(ne===1)return _[0];const le=function(K,q){for(let D=0,Q=_.length;D<Q;D++)if(_[D](K,q))return B;return null},ee=_.find(K=>!!K.allBasenames);ee&&(le.allBasenames=ee.allBasenames);const J=_.reduce((K,q)=>q.allPaths?K.concat(q.allPaths):K,[]);return J.length&&(le.allPaths=J),le}function S(B,W,_){const ne=k.sep===k.$jc.sep,le=ne?B:B.replace(g,k.sep),ee=k.sep+le,J=k.$jc.sep+B;let K;return _?K=function(q,D){return typeof q=="string"&&(q===le||q.endsWith(ee)||!ne&&(q===B||q.endsWith(J)))?W:null}:K=function(q,D){return typeof q=="string"&&(q===le||!ne&&q===B)?W:null},K.allPaths=[(_?"*/":"./")+B],K}function v(B){try{const W=new RegExp(`^${E(B)}$`);return function(_){return W.lastIndex=0,typeof _=="string"&&W.test(_)?B:null}}catch{return t}}function L(B,W,_){return!B||typeof W!="string"?!1:U(B)(W,void 0,_)}function U(B,W={}){if(!B)return n;if(typeof B=="string"||j(B)){const _=s(B,W);if(_===t)return n;const ne=function(le,ee){return!!_(le,ee)};return _.allBasenames&&(ne.allBasenames=_.allBasenames),_.allPaths&&(ne.allPaths=_.allPaths),ne}return V(B,W)}function j(B){const W=B;return W?typeof W.base=="string"&&typeof W.pattern=="string":!1}function F(B){return B.allBasenames||[]}function G(B){return B.allPaths||[]}function V(B,W){const _=H(Object.getOwnPropertyNames(B).map(K=>x(K,B[K],W)).filter(K=>K!==t)),ne=_.length;if(!ne)return t;if(!_.some(K=>!!K.requiresSiblings)){if(ne===1)return _[0];const K=function(Q,oe){let Z;for(let Y=0,M=_.length;Y<M;Y++){const z=_[Y](Q,oe);if(typeof z=="string")return z;(0,a.$uh)(z)&&(Z||(Z=[]),Z.push(z))}return Z?(async()=>{for(const Y of Z){const M=await Y;if(typeof M=="string")return M}return null})():null},q=_.find(Q=>!!Q.allBasenames);q&&(K.allBasenames=q.allBasenames);const D=_.reduce((Q,oe)=>oe.allPaths?Q.concat(oe.allPaths):Q,[]);return D.length&&(K.allPaths=D),K}const le=function(K,q,D){let Q,oe;for(let Z=0,Y=_.length;Z<Y;Z++){const M=_[Z];M.requiresSiblings&&D&&(q||(q=(0,k.$qc)(K)),Q||(Q=q.substr(0,q.length-(0,k.$rc)(K).length)));const z=M(K,q,Q,D);if(typeof z=="string")return z;(0,a.$uh)(z)&&(oe||(oe=[]),oe.push(z))}return oe?(async()=>{for(const Z of oe){const Y=await Z;if(typeof Y=="string")return Y}return null})():null},ee=_.find(K=>!!K.allBasenames);ee&&(le.allBasenames=ee.allBasenames);const J=_.reduce((K,q)=>q.allPaths?K.concat(q.allPaths):K,[]);return J.length&&(le.allPaths=J),le}function x(B,W,_){if(W===!1)return t;const ne=s(B,_);if(ne===t)return t;if(typeof W=="boolean")return ne;if(W){const le=W.when;if(typeof le=="string"){const ee=(J,K,q,D)=>{if(!D||!ne(J,K))return null;const Q=le.replace("$(basename)",()=>q),oe=D(Q);return(0,a.$uh)(oe)?oe.then(Z=>Z?B:null):oe?B:null};return ee.requiresSiblings=!0,ee}}return ne}function H(B,W){const _=B.filter(K=>!!K.basenames);if(_.length<2)return B;const ne=_.reduce((K,q)=>{const D=q.basenames;return D?K.concat(D):K},[]);let le;if(W){le=[];for(let K=0,q=ne.length;K<q;K++)le.push(W)}else le=_.reduce((K,q)=>{const D=q.patterns;return D?K.concat(D):K},[]);const ee=function(K,q){if(typeof K!="string")return null;if(!q){let Q;for(Q=K.length;Q>0;Q--){const oe=K.charCodeAt(Q-1);if(oe===N.CharCode.Slash||oe===N.CharCode.Backslash)break}q=K.substr(Q)}const D=ne.indexOf(q);return D!==-1?le[D]:null};ee.basenames=ne,ee.patterns=le,ee.allBasenames=ne;const J=B.filter(K=>!K.basenames);return J.push(ee),J}function te(B,W){return(0,R.$wb)(B,W,(_,ne)=>typeof _=="string"&&typeof ne=="string"?_===ne:typeof _!="string"&&typeof ne!="string"?_.base===ne.base&&_.pattern===ne.pattern:!1)}}),define(fe[96],de([0,1,14,65,9]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rn=e.$Qn=void 0,e.$Sn=O,e.$Tn=I,e.$Un=p;function A($){return $.toJSON()}class T{constructor(g){this.a=g}transformIncoming(g){const l=this.a.transformIncoming(g);return l===g?g:A(N.URI.from(l))}transformOutgoing(g){const l=this.a.transformOutgoing(g);return l===g?g:A(N.URI.from(l))}transformOutgoingURI(g){const l=this.a.transformOutgoing(g);return l===g?g:N.URI.from(l)}transformOutgoingScheme(g){return this.a.transformOutgoingScheme(g)}}e.$Qn=T,e.$Rn=new class{transformIncoming($){return $}transformOutgoing($){return $}transformOutgoingURI($){return $}transformOutgoingScheme($){return $}};function k($,g,l){if(!$||l>200)return null;if(typeof $=="object"){if($ instanceof N.URI)return g.transformOutgoing($);for(const d in $)if(Object.hasOwnProperty.call($,d)){const E=k($[d],g,l+1);E!==null&&($[d]=E)}}return null}function O($,g){const l=k($,g,0);return l===null?$:l}function y($,g,l,d){if(!$||d>200)return null;if(typeof $=="object"){if($.$mid===a.MarshalledId.Uri)return l?N.URI.revive(g.transformIncoming($)):g.transformIncoming($);if($ instanceof R.$Qe)return null;for(const E in $)if(Object.hasOwnProperty.call($,E)){const w=y($[E],g,l,d+1);w!==null&&($[E]=w)}}return null}function I($,g){const l=y($,g,!1,0);return l===null?$:l}function p($,g){const l=y($,g,!0,0);return l===null?$:l}}),define(fe[32],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5g=void 0,e.$4g=a;const R=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function a(N){return R.test(N)}e.$5g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let N;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?N=crypto.getRandomValues.bind(crypto):N=function(k){for(let O=0;O<k.length;O++)k[O]=Math.floor(Math.random()*256);return k};const A=new Uint8Array(16),T=[];for(let k=0;k<256;k++)T.push(k.toString(16).padStart(2,"0"));return function(){N(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let O=0,y="";return y+=T[A[O++]],y+=T[A[O++]],y+=T[A[O++]],y+=T[A[O++]],y+="-",y+=T[A[O++]],y+=T[A[O++]],y+="-",y+=T[A[O++]],y+=T[A[O++]],y+="-",y+=T[A[O++]],y+=T[A[O++]],y+="-",y+=T[A[O++]],y+=T[A[O++]],y+=T[A[O++]],y+=T[A[O++]],y+=T[A[O++]],y+=T[A[O++]],y}}()}),define(fe[141],de([0,1,38]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vn=A;const a=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function N(T){const k=T.replace(/\-/g,":").toLowerCase();return!a.has(k)}function A(){const T=(0,R.networkInterfaces)();for(const k in T){const O=T[k];if(O){for(const{mac:y}of O)if(N(y))return y}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(fe[142],de([0,1,38,51,32,141,5]),function(ce,e,R,a,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wn=void 0,e.$Xn=O,e.$Yn=p,e.$Zn=$,N=Oe(N),e.$Wn=new class{c(g){return this.a||(this.a=a.$Oi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(g)}value(){if(this.b===void 0){let g=0,l=0;const d=(0,R.networkInterfaces)();for(const E in d){const w=d[E];if(w)for(const{mac:f,internal:P}of w)P||(l+=1,this.c(f.toUpperCase())&&(g+=1))}this.b=l>0?g/l:0}return this.b}};let k;async function O(g){return k||(k=(async()=>await y(g)||N.$5g())()),k}async function y(g){try{const l=await new Promise((E,w)=>{ce(["crypto"],E,w)}).then(Oe),d=(0,A.$Vn)();return l.createHash("sha256").update(d,"utf8").digest("hex")}catch(l){g(l);return}}const I="Software\\Microsoft\\SQMClient";async function p(g){if(T.$j){const l=await new Promise((d,E)=>{ce(["@vscode/windows-registry"],d,E)}).then(Oe);try{return l.GetStringRegKey("HKEY_LOCAL_MACHINE",I,"MachineId")||""}catch(d){return g(d),""}}return""}async function $(g){try{return await(await new Promise((E,w)=>{ce(["@vscode/deviceid"],E,w)}).then(Oe)).getDeviceId()}catch(l){return g(l),""}}}),define(fe[143],de([0,1,241,14]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aY=void 0;class N extends R.Transform{constructor(T){if(super(),typeof T=="number")this.b=T,this.c=1;else{const k=Buffer.isBuffer(T)?T:Buffer.from(T);this.b=k.length===1?k[0]:k,this.c=k.length}}_transform(T,k,O){this.a?this.a=Buffer.concat([this.a,T]):this.a=T;let y=0;for(;y<this.a.length;){const I=typeof this.b=="number"?this.a.indexOf(this.b,y):(0,a.$Re)(this.a,this.b,y);if(I===-1)break;this.push(this.a.slice(y,I+this.c)),y=I+this.c}this.a=y===this.a.length?void 0:this.a.slice(y),O()}_flush(T){this.a&&this.push(this.a),T()}}e.$aY=N}),define(fe[144],de([0,1,33,13,37]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bY=y,e.$cY=I;const A="XDG_SESSION_TYPE",T="WAYLAND_DISPLAY",k="XDG_RUNTIME_DIR";var O;(function(p){p.Wayland="wayland",p.XWayland="xwayland",p.X11="x11",p.Unknown="unknown"})(O||(O={}));async function y(p){const $=N.env[A];if($)return $===O.Wayland||$===O.X11?$:O.Unknown;if(N.env[T]){const l=N.env[k];if(l){const d=(0,a.$mc)(l,"wayland-0");try{return await R.promises.access(d,R.constants.R_OK),O.Wayland}catch(E){return p(E),O.Unknown}}else return O.Unknown}else return O.X11}function I(p,$){if($)switch($){case"auto":return p;case"x11":return p===O.Wayland?O.XWayland:O.X11;case"wayland":return O.Wayland;default:return O.Unknown}else return p===O.Wayland?O.XWayland:O.X11}}),define(fe[145],de([0,1,33,242,5]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6g=A,N=Oe(N);async function A(T){if(N.$k||N.$j)return;let k;for(const O of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{k=await R.promises.open(O,R.constants.R_OK);break}catch{}if(!k){T("Unable to retrieve release information from known identifier paths.");return}try{const O=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),y={id:"unknown"};for await(const I of(0,a.createInterface)({input:k.createReadStream(),crlfDelay:1/0})){if(!I.includes("="))continue;const p=I.split("=")[0].toUpperCase().trim();if(O.has(p)){const $=I.split("=")[1].replace(/"/g,"").toLowerCase().trim();p==="ID"||p==="DISTRIB_ID"?y.id=$:p==="ID_LIKE"?y.id_like=$:(p==="VERSION_ID"||p==="DISTRIB_RELEASE")&&(y.version_id=$)}}return y}catch(O){T(O)}}}),define(fe[30],de([0,1,33,38,243,6,41,92,13,5,20,9]),function(ce,e,R,a,N,A,T,k,O,y,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=E,e.readdirSync=P,e.whenDeleted=h,e.configureFlushOnWrite=r,e.writeFileSync=u,R=Oe(R);var $;(function(V){V[V.UNLINK=0]="UNLINK",V[V.MOVE=1]="MOVE"})($||(e.RimRafMode=$={}));async function g(V,x=$.UNLINK,H){if((0,T.$Lg)(V))throw new Error("rimraf - will refuse to recursively delete root");return x===$.UNLINK?d(V):l(V,H)}async function l(V,x=(0,T.$Qg)((0,a.tmpdir)())){try{try{await R.promises.rename(V,x)}catch(H){return H.code==="ENOENT"?void 0:d(V)}d(x).catch(H=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function d(V){return R.promises.rm(V,{recursive:!0,force:!0,maxRetries:3})}function E(V){if((0,T.$Lg)(V))throw new Error("rimraf - will refuse to recursively delete root");R.rmSync(V,{recursive:!0,force:!0,maxRetries:3})}async function w(V,x){return m(await(x?f(V):R.promises.readdir(V)))}async function f(V){try{return await R.promises.readdir(V,{withFileTypes:!0})}catch(te){console.warn("[node.js fs] readdir with filetypes failed with error: ",te)}const x=[],H=await w(V);for(const te of H){let B=!1,W=!1,_=!1;try{const ne=await R.promises.lstat((0,O.$mc)(V,te));B=ne.isFile(),W=ne.isDirectory(),_=ne.isSymbolicLink()}catch(ne){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ne)}x.push({name:te,isFile:()=>B,isDirectory:()=>W,isSymbolicLink:()=>_})}return x}function P(V){return m(R.readdirSync(V))}function m(V){return V.map(x=>typeof x=="string"?y.$k?(0,k.$qm)(x):x:(x.name=y.$k?(0,k.$qm)(x.name):x.name,x))}async function c(V){const x=await w(V),H=[];for(const te of x)await i.existsDirectory((0,O.$mc)(V,te))&&H.push(te);return H}function h(V,x=1e3){return new Promise(H=>{let te=!1;const B=setInterval(()=>{te||(te=!0,R.access(V,W=>{te=!1,W&&(clearInterval(B),H(void 0))}))},x)})}var i;(function(V){async function x(B){let W;try{if(W=await R.promises.lstat(B),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await R.promises.stat(B),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(_){if(_.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(y.$j&&_.code==="EACCES")try{return{stat:await R.promises.stat(await R.promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(ne){if(ne.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw ne}throw _}}V.stat=x;async function H(B){try{const{stat:W,symbolicLink:_}=await V.stat(B);return W.isFile()&&_?.dangling!==!0}catch{}return!1}V.existsFile=H;async function te(B){try{const{stat:W,symbolicLink:_}=await V.stat(B);return W.isDirectory()&&_?.dangling!==!0}catch{}return!1}V.existsDirectory=te})(i||(e.SymlinkSupport=i={}));const n=new A.$Rh;function t(V,x,H){return n.queueFor(p.URI.file(V),()=>{const te=b(H);return new Promise((B,W)=>o(V,x,te,_=>_?W(_):B()))},I.$ah)}let s=!0;function r(V){s=V}function o(V,x,H,te){if(!s)return R.writeFile(V,x,{mode:H.mode,flag:H.flag},te);R.open(V,H.flag,H.mode,(B,W)=>{if(B)return te(B);R.writeFile(W,x,_=>{if(_)return R.close(W,()=>te(_));R.fdatasync(W,ne=>(ne&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ne),r(!1)),R.close(W,le=>te(le))))})})}function u(V,x,H){const te=b(H);if(!s)return R.writeFileSync(V,x,{mode:te.mode,flag:te.flag});const B=R.openSync(V,te.flag,te.mode);try{R.writeFileSync(B,x);try{R.fdatasyncSync(B)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),r(!1)}}finally{R.closeSync(B)}}function b(V){return V?{mode:typeof V.mode=="number"?V.mode:438,flag:typeof V.flag=="string"?V.flag:"w"}:{mode:438,flag:"w"}}async function C(V,x,H=6e4){if(V!==x)try{y.$j&&typeof H=="number"?await S(V,x,Date.now(),H):await R.promises.rename(V,x)}catch(te){if(V.toLowerCase()!==x.toLowerCase()&&te.code==="EXDEV"||V.endsWith("."))await v(V,x,{preserveSymlinks:!1}),await g(V,$.MOVE);else throw te}}async function S(V,x,H,te,B=0){try{return await R.promises.rename(V,x)}catch(W){if(W.code!=="EACCES"&&W.code!=="EPERM"&&W.code!=="EBUSY")throw W;if(Date.now()-H>=te)throw console.error(`[node.js fs] rename failed after ${B} retries with error: ${W}`),W;if(B===0){let _=!1;try{const{stat:ne}=await i.stat(x);ne.isFile()||(_=!0)}catch{}if(_)throw W}return await(0,A.$Jh)(Math.min(100,B*10)),S(V,x,H,te,B+1)}}async function v(V,x,H){return U(V,x,{root:{source:V,target:x},options:H,handledSourcePaths:new Set})}const L=511;async function U(V,x,H){if(H.handledSourcePaths.has(V))return;H.handledSourcePaths.add(V);const{stat:te,symbolicLink:B}=await i.stat(V);if(B){if(H.options.preserveSymlinks)try{return await G(V,x,H)}catch{}if(B.dangling)return}return te.isDirectory()?j(V,x,te.mode&L,H):F(V,x,te.mode&L)}async function j(V,x,H,te){await R.promises.mkdir(x,{recursive:!0,mode:H});const B=await w(V);for(const W of B)await U((0,O.$mc)(V,W),(0,O.$mc)(x,W),te)}async function F(V,x,H){await R.promises.copyFile(V,x),await R.promises.chmod(x,H)}async function G(V,x,H){let te=await R.promises.readlink(V);(0,T.$Hg)(te,H.root.source,!y.$l)&&(te=(0,O.$mc)(H.root.target,te.substr(H.root.source.length+1))),await R.promises.symlink(te,x)}e.Promises=new class{get read(){return(V,x,H,te,B)=>new Promise((W,_)=>{R.read(V,x,H,te,B,(ne,le,ee)=>ne?_(ne):W({bytesRead:le,buffer:ee}))})}get write(){return(V,x,H,te,B)=>new Promise((W,_)=>{R.write(V,x,H,te,B,(ne,le,ee)=>ne?_(ne):W({bytesWritten:le,buffer:ee}))})}get fdatasync(){return(0,N.promisify)(R.fdatasync)}get open(){return(0,N.promisify)(R.open)}get close(){return(0,N.promisify)(R.close)}get realpath(){return(0,N.promisify)(R.realpath)}async exists(V){try{return await R.promises.access(V),!0}catch{return!1}}get readdir(){return w}get readDirsInDir(){return c}get writeFile(){return t}get rm(){return g}get rename(){return C}get copy(){return v}}}),define(fe[146],de([0,1,33,13,5,26,30]),function(ce,e,R,a,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=k,e.$sr=O,e.$tr=y,e.$ur=I,R=Oe(R);function k($){if(N.$l)return $;const g=(0,a.$pc)($);if($===g)return $;const l=((0,a.$qc)($)||$).toLowerCase();try{const E=(0,T.readdirSync)(g).filter(w=>w.toLowerCase()===l);if(E.length===1){const w=k(g);if(w)return(0,a.$mc)(w,E[0])}else if(E.length>1){const w=E.indexOf(l);if(w>=0){const f=k(g);if(f)return(0,a.$mc)(f,E[w])}}}catch{}return null}async function O($,g){if(N.$l)return $;const l=(0,a.$pc)($);if($===l)return $;const d=((0,a.$qc)($)||$).toLowerCase();try{if(g?.isCancellationRequested)return null;const w=(await T.Promises.readdir(l)).filter(f=>f.toLowerCase()===d);if(w.length===1){const f=await O(l,g);if(f)return(0,a.$mc)(f,w[0])}else if(w.length>1){const f=w.indexOf(d);if(f>=0){const P=await O(l,g);if(P)return(0,a.$mc)(P,w[f])}}}catch{}return null}async function y($){try{return await T.Promises.realpath($)}catch{const l=p($);return await R.promises.access(l,R.constants.R_OK),l}}function I($){try{return R.realpathSync($)}catch{const l=p($);return R.accessSync(l,R.constants.R_OK),l}}function p($){return(0,A.$qf)((0,a.$kc)($),a.sep)}}),define(fe[147],de([0,1,68]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8g=void 0,e.$7g=a,e.$9g=A,R=Oe(R);function a(k,O,y,I=1){let p=!1;return new Promise($=>{const g=setTimeout(()=>{if(!p)return p=!0,$(0)},y);N(k,O,I,l=>{if(!p)return p=!0,clearTimeout(g),$(l)})})}function N(k,O,y,I){if(O===0)return I(0);const p=new R.Socket;p.once("connect",()=>(T(p),N(k+y,O-1,y,I))),p.once("data",()=>{}),p.once("error",$=>(T(p),$.code!=="ECONNREFUSED"?N(k+y,O-1,y,I):I(k))),p.connect(k,"127.0.0.1")}e.$8g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(k,O,y,I="127.0.0.1"){let p=!1,$,g=1;const l=R.createServer({pauseOnConnect:!0});function d(E,w){p||(p=!0,l.removeAllListeners(),l.close(),$&&clearTimeout($),w(E))}return new Promise(E=>{$=setTimeout(()=>{d(0,E)},y),l.on("listening",()=>{d(k,E)}),l.on("error",w=>{w&&(w.code==="EADDRINUSE"||w.code==="EACCES")&&g<O?(k++,g++,l.listen(k,I)):d(0,E)}),l.on("close",()=>{d(0,E)}),l.listen(k,I)})}function T(k){try{k.removeAllListeners("connect"),k.removeAllListeners("error"),k.end(),k.destroy(),k.unref()}catch(O){console.error(O)}}}),define(fe[148],de([0,1,33,13,5,37,93,12,30]),function(ce,e,R,a,N,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$Bm=y,e.$Cm=I,a=Oe(a),N=Oe(N),A=Oe(A),k=Oe(k),O=Oe(O),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return T.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return T.TerminateResponseCode}});function y($=A.env){return $.comspec||"cmd.exe"}function I($){let g=[],l=!1;const d=function(E){if(l){g.push(E);return}(!$.send(E,f=>{if(f&&console.error(f),l=!1,g.length>0){const P=g.slice(0);g=[],P.forEach(m=>d(m))}})||N.$j)&&(l=!0)};return{send:d}}var p;(function($){async function g(l,d,E){if(a.$lc(l))return l;if(d===void 0&&(d=A.cwd()),a.$pc(l)!=="."||(E===void 0&&k.$hg(A.env.PATH)&&(E=A.env.PATH.split(a.$wc)),E===void 0||E.length===0))return a.$mc(d,l);async function f(P){if(await O.Promises.exists(P)){let m;try{m=await R.promises.stat(P)}catch(c){c.message.startsWith("EACCES")&&(m=await R.promises.lstat(P))}return m?!m.isDirectory():!1}return!1}for(const P of E){let m;if(a.$lc(P)?m=a.$mc(P,l):m=a.$mc(d,P,l),await f(m))return m;let c=m+".com";if(await f(c)||(c=m+".exe",await f(c)))return c}return a.$mc(d,l)}$.findExecutable=g})(p||(e.win32=p={}))}),define(fe[149],de([0,1,69,22]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=N;function N(T){return new Promise((k,O)=>{let y;const I=new Map;function p(g,l,d,E,w){const f=I.get(l);if(g===T||f){const P={name:$(d),cmd:d,pid:g,ppid:l,load:E,mem:w};I.set(g,P),g===T&&(y=P),f&&(f.children||(f.children=[]),f.children.push(P),f.children.length>1&&(f.children=f.children.sort((m,c)=>m.pid-c.pid)))}}function $(g){const l=/--utility-sub-type=network/i,d=/--crashes-directory/i,E=/\\pipe\\winpty-control/i,w=/conhost\.exe.+--headless/i,f=/--type=([a-zA-Z-]+)/;if(d.exec(g))return"electron-crash-reporter";if(E.exec(g))return"winpty-agent";if(w.exec(g))return"conpty-agent";let P=f.exec(g);if(P&&P.length===2)return P[1]==="renderer"?"window":P[1]==="utility"?l.exec(g)?"utility-network-service":"utility-process":P[1]==="extensionHost"?"extension-host":P[1];const m=/[a-zA-Z-]+\.js/g;let c="";do P=m.exec(g),P&&(c+=P+" ");while(P);return c&&g.indexOf("node ")<0&&g.indexOf("node.exe")<0?`electron-nodejs (${c})`:g}if(process.platform==="win32"){const g=l=>l.indexOf("\\\\?\\")===0||l.indexOf("\\??\\")===0?l.substring(4):l.indexOf('"\\\\?\\')===0||l.indexOf('"\\??\\')===0?'"'+l.substring(5):l;new Promise((l,d)=>{ce(["@vscode/windows-process-tree"],l,d)}).then(Oe).then(l=>{l.getProcessList(T,d=>{if(!d){O(new Error(`Root process ${T} not found`));return}l.getProcessCpuUsage(d,E=>{const w=new Map;E.forEach(f=>{const P=g(f.commandLine||"");w.set(f.pid,{name:$(P),cmd:P,pid:f.pid,ppid:f.ppid,load:f.cpu||0,mem:f.memory||0})}),y=w.get(T),y?(w.forEach(f=>{const P=w.get(f.ppid);P&&(P.children||(P.children=[]),P.children.push(f))}),w.forEach(f=>{f.children&&(f.children=f.children.sort((P,m)=>P.pid-m.pid))}),k(y)):O(new Error(`Root process ${T} not found`))})},l.ProcessDataFlag.CommandLine|l.ProcessDataFlag.Memory)})}else{let g=function(){let l=[y];const d=[];for(;l.length;){const w=l.shift();w&&(d.push(w.pid),w.children&&(l=l.concat(w.children)))}let E=JSON.stringify(a.$3g.asFileUri("vs/base/node/cpuUsage.sh").fsPath);E+=" "+d.join(" "),(0,R.exec)(E,{},(w,f,P)=>{if(w||P)O(w||new Error(P.toString()));else{const m=f.toString().split(`
`);for(let c=0;c<d.length;c++){const h=I.get(d[c]);h.load=parseFloat(m[c])}if(!y){O(new Error(`Root process ${T} not found`));return}k(y)}})};(0,R.exec)("which ps",{},(l,d,E)=>{if(l||E)if(process.platform!=="linux")O(l||new Error(E.toString()));else{const w=JSON.stringify(a.$3g.asFileUri("vs/base/node/ps.sh").fsPath);(0,R.exec)(w,{},(f,P,m)=>{f||m?O(f||new Error(m.toString())):(A(P,p),g())})}else{const w=d.toString().trim();(0,R.exec)(`${w} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(P,m,c)=>{P||c&&!c.includes("screen size is bogus")?O(P||new Error(c.toString())):(A(m,p),process.platform==="linux"?g():y?k(y):O(new Error(`Root process ${T} not found`)))})}})}})}function A(T,k){const O=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,y=T.toString().split(`
`);for(const I of y){const p=O.exec(I.trim());p&&p.length===6&&k(parseInt(p[1]),parseInt(p[2]),p[5],parseFloat(p[3]),parseFloat(p[4]))}}});var Ee=this&&this.__decorate||function(ce,e,R,a){var N=arguments.length,A=N<3?e:a===null?a=Object.getOwnPropertyDescriptor(e,R):a,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(ce,e,R,a);else for(var k=ce.length-1;k>=0;k--)(T=ce[k])&&(A=(N<3?T(A):N>3?T(e,R,A):T(e,R))||A);return N>3&&A&&Object.defineProperty(e,R,A),A};define(fe[42],de([0,1,17,6,14,25,89,8,3,2,66,26,12]),function(ce,e,R,a,N,A,T,k,O,y,I,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ri=e.ProxyChannel=e.$qi=e.$ni=e.$mi=e.$li=e.RequestInitiator=e.$ki=e.$hi=e.$gi=void 0,e.$ii=r,e.$ji=o,e.$oi=L,e.$pi=U,p=Oe(p);var g;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(g||(g={}));function l(B){switch(B){case g.Promise:return"req";case g.PromiseCancel:return"cancel";case g.EventListen:return"subscribe";case g.EventDispose:return"unsubscribe"}}var d;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(d||(d={}));function E(B){switch(B){case d.Initialize:return"init";case d.PromiseSuccess:return"reply:";case d.PromiseError:case d.PromiseErrorObj:return"replyErr:";case d.EventFire:return"event:"}}var w;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(w||(w={}));function f(B){let W=0;for(let _=0;;_+=7){const ne=B.read(1);if(W|=(ne.buffer[0]&127)<<_,!(ne.buffer[0]&128))return W}}const P=n(0);function m(B,W){if(W===0){B.write(P);return}let _=0;for(let le=W;le!==0;le=le>>>7)_++;const ne=N.$Qe.alloc(_);for(let le=0;W!==0;le++)ne.buffer[le]=W&127,W=W>>>7,W>0&&(ne.buffer[le]|=128);B.write(ne)}class c{constructor(W){this.b=W,this.a=0}read(W){const _=this.b.slice(this.a,this.a+W);return this.a+=_.byteLength,_}}e.$gi=c;class h{constructor(){this.a=[]}get buffer(){return N.$Qe.concat(this.a)}write(W){this.a.push(W)}}e.$hi=h;var i;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(i||(i={}));function n(B){const W=N.$Qe.alloc(1);return W.writeUInt8(B,0),W}const t={Undefined:n(i.Undefined),String:n(i.String),Buffer:n(i.Buffer),VSBuffer:n(i.VSBuffer),Array:n(i.Array),Object:n(i.Object),Uint:n(i.Int)},s=typeof Buffer<"u";function r(B,W){if(typeof W>"u")B.write(t.Undefined);else if(typeof W=="string"){const _=N.$Qe.fromString(W);B.write(t.String),m(B,_.byteLength),B.write(_)}else if(s&&Buffer.isBuffer(W)){const _=N.$Qe.wrap(W);B.write(t.Buffer),m(B,_.byteLength),B.write(_)}else if(W instanceof N.$Qe)B.write(t.VSBuffer),m(B,W.byteLength),B.write(W);else if(Array.isArray(W)){B.write(t.Array),m(B,W.length);for(const _ of W)r(B,_)}else if(typeof W=="number"&&(W|0)===W)B.write(t.Uint),m(B,W);else{const _=N.$Qe.fromString(JSON.stringify(W));B.write(t.Object),m(B,_.byteLength),B.write(_)}}function o(B){switch(B.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return B.read(f(B)).toString();case i.Buffer:return B.read(f(B)).buffer;case i.VSBuffer:return B.read(f(B));case i.Array:{const _=f(B),ne=[];for(let le=0;le<_;le++)ne.push(o(B));return ne}case i.Object:return JSON.parse(B.read(f(B)).toString());case i.Int:return f(B)}}class u{constructor(W,_,ne=null,le=1e3){this.h=W,this.j=_,this.k=ne,this.l=le,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ee=>this.q(ee)),this.m({type:d.Initialize})}registerChannel(W,_){this.b.set(W,_),setTimeout(()=>this.w(W),0)}m(W){switch(W.type){case d.Initialize:{const _=this.o([W.type]);this.k?.logOutgoing(_,0,b.OtherSide,E(W.type));return}case d.PromiseSuccess:case d.PromiseError:case d.EventFire:case d.PromiseErrorObj:{const _=this.o([W.type,W.id],W.data);this.k?.logOutgoing(_,W.id,b.OtherSide,E(W.type),W.data);return}}}o(W,_=void 0){const ne=new h;return r(ne,W),r(ne,_),this.p(ne.buffer)}p(W){try{return this.h.send(W),W.byteLength}catch{return 0}}q(W){const _=new c(W),ne=o(_),le=o(_),ee=ne[0];switch(ee){case g.Promise:return this.k?.logIncoming(W.byteLength,ne[1],b.OtherSide,`${l(ee)}: ${ne[2]}.${ne[3]}`,le),this.s({type:ee,id:ne[1],channelName:ne[2],name:ne[3],arg:le});case g.EventListen:return this.k?.logIncoming(W.byteLength,ne[1],b.OtherSide,`${l(ee)}: ${ne[2]}.${ne[3]}`,le),this.t({type:ee,id:ne[1],channelName:ne[2],name:ne[3],arg:le});case g.PromiseCancel:return this.k?.logIncoming(W.byteLength,ne[1],b.OtherSide,`${l(ee)}`),this.u({type:ee,id:ne[1]});case g.EventDispose:return this.k?.logIncoming(W.byteLength,ne[1],b.OtherSide,`${l(ee)}`),this.u({type:ee,id:ne[1]})}}s(W){const _=this.b.get(W.channelName);if(!_){this.v(W);return}const ne=new A.$ze;let le;try{le=_.call(this.j,W.name,W.arg,ne.token)}catch(K){le=Promise.reject(K)}const ee=W.id;le.then(K=>{this.m({id:ee,data:K,type:d.PromiseSuccess})},K=>{K instanceof Error?this.m({id:ee,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split(`
`):void 0},type:d.PromiseError}):this.m({id:ee,data:K,type:d.PromiseErrorObj})}).finally(()=>{J.dispose(),this.d.delete(W.id)});const J=(0,y.$Vc)(()=>ne.cancel());this.d.set(W.id,J)}t(W){const _=this.b.get(W.channelName);if(!_){this.v(W);return}const ne=W.id,ee=_.listen(this.j,W.name,W.arg)(J=>this.m({id:ne,data:J,type:d.EventFire}));this.d.set(W.id,ee)}u(W){const _=this.d.get(W.id);_&&(_.dispose(),this.d.delete(W.id))}v(W){let _=this.g.get(W.channelName);_||(_=[],this.g.set(W.channelName,_));const ne=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===g.Promise&&this.m({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.l}ms`,stack:void 0},type:d.PromiseError})},this.l);_.push({request:W,timeoutTimer:ne})}w(W){const _=this.g.get(W);if(_){for(const ne of _)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case g.Promise:this.s(ne.request);break;case g.EventListen:this.t(ne.request);break}this.g.delete(W)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,y.$Sc)(this.d.values()),this.d.clear()}}e.$ki=u;var b;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(b||(e.RequestInitiator=b={}));class C{constructor(W,_=null){this.l=W,this.a=!1,this.b=w.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new O.$oe,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.s(ne)),this.j=_}getChannel(W){const _=this;return{call(ne,le,ee){return _.a?Promise.reject(new k.$7):_.m(W,ne,le,ee)},listen(ne,le){return _.a?O.Event.None:_.o(W,ne,le)}}}m(W,_,ne,le=A.CancellationToken.None){const ee=this.g++,J=g.Promise,K={id:ee,type:J,channelName:W,name:_,arg:ne};if(le.isCancellationRequested)return Promise.reject(new k.$7);let q;return new Promise((Q,oe)=>{if(le.isCancellationRequested)return oe(new k.$7);const Z=()=>{const ie=ae=>{switch(ae.type){case d.PromiseSuccess:this.f.delete(ee),Q(ae.data);break;case d.PromiseError:{this.f.delete(ee);const ue=new Error(ae.data.message);ue.stack=Array.isArray(ae.data.stack)?ae.data.stack.join(`
`):ae.data.stack,ue.name=ae.data.name,oe(ue);break}case d.PromiseErrorObj:this.f.delete(ee),oe(ae.data);break}};this.f.set(ee,ie),this.p(K)};let Y=null;this.b===w.Idle?Z():(Y=(0,a.$vh)(ie=>this.u()),Y.then(()=>{Y=null,Z()}));const M=()=>{Y?(Y.cancel(),Y=null):this.p({id:ee,type:g.PromiseCancel}),oe(new k.$7)},z=le.onCancellationRequested(M);q=(0,y.$Uc)((0,y.$Vc)(M),z),this.d.add(q)}).finally(()=>{q.dispose(),this.d.delete(q)})}o(W,_,ne){const le=this.g++,ee=g.EventListen,J={id:le,type:ee,channelName:W,name:_,arg:ne};let K=null;const q=new O.$oe({onWillAddFirstListener:()=>{K=(0,a.$vh)(Q=>this.u()),K.then(()=>{K=null,this.d.add(q),this.p(J)})},onDidRemoveLastListener:()=>{K?(K.cancel(),K=null):(this.d.delete(q),this.p({id:le,type:g.EventDispose}))}}),D=Q=>q.fire(Q.data);return this.f.set(le,D),q.event}p(W){switch(W.type){case g.Promise:case g.EventListen:{const _=this.q([W.type,W.id,W.channelName,W.name],W.arg);this.j?.logOutgoing(_,W.id,b.LocalSide,`${l(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case g.PromiseCancel:case g.EventDispose:{const _=this.q([W.type,W.id]);this.j?.logOutgoing(_,W.id,b.LocalSide,l(W.type));return}}}q(W,_=void 0){const ne=new h;return r(ne,W),r(ne,_),this.r(ne.buffer)}r(W){try{return this.l.send(W),W.byteLength}catch{return 0}}s(W){const _=new c(W),ne=o(_),le=o(_),ee=ne[0];switch(ee){case d.Initialize:return this.j?.logIncoming(W.byteLength,0,b.LocalSide,E(ee)),this.t({type:ne[0]});case d.PromiseSuccess:case d.PromiseError:case d.EventFire:case d.PromiseErrorObj:return this.j?.logIncoming(W.byteLength,ne[1],b.LocalSide,E(ee),le),this.t({type:ne[0],id:ne[1],data:le})}}t(W){if(W.type===d.Initialize){this.b=w.Idle,this.k.fire();return}this.f.get(W.id)?.(W)}get onDidInitializePromise(){return O.Event.toPromise(this.onDidInitialize)}u(){return this.b===w.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,y.$Sc)(this.d.values()),this.d.clear()}}e.$li=C,Ee([T.$ai],C.prototype,"onDidInitializePromise",null);class S{get connections(){const W=[];return this.f.forEach(_=>W.push(_)),W}constructor(W,_,ne){this.a=new Map,this.f=new Set,this.g=new O.$oe,this.onDidAddConnection=this.g.event,this.h=new O.$oe,this.onDidRemoveConnection=this.h.event,this.j=new y.$Wc,this.j.add(W(({protocol:le,onDidClientDisconnect:ee})=>{const J=O.Event.once(le.onMessage);this.j.add(J(K=>{const q=new c(K),D=o(q),Q=new u(le,D,_,ne),oe=new C(le,_);this.a.forEach((Y,M)=>Q.registerChannel(M,Y));const Z={channelServer:Q,channelClient:oe,ctx:D};this.f.add(Z),this.g.fire(Z),this.j.add(ee(()=>{Q.dispose(),oe.dispose(),this.f.delete(Z),this.h.fire(Z)}))}))}))}getChannel(W,_){const ne=this;return{call(le,ee,J){let K;if((0,$.$vg)(_)){const D=(0,R.$5b)(ne.connections.filter(_));K=D?Promise.resolve(D):O.Event.toPromise(O.Event.filter(ne.onDidAddConnection,_))}else K=_.routeCall(ne,le,ee);const q=K.then(D=>D.channelClient.getChannel(W));return L(q).call(le,ee,J)},listen(le,ee){if((0,$.$vg)(_))return ne.k(W,_,le,ee);const J=_.routeEvent(ne,le,ee).then(K=>K.channelClient.getChannel(W));return L(J).listen(le,ee)}}}k(W,_,ne,le){const ee=this;let J;const K=new O.$oe({onWillAddFirstListener:()=>{J=new y.$Wc;const q=new O.$ue,D=new Map,Q=Z=>{const M=Z.channelClient.getChannel(W).listen(ne,le),z=q.add(M);D.set(Z,z)},oe=Z=>{const Y=D.get(Z);Y&&(Y.dispose(),D.delete(Z))};ee.connections.filter(_).forEach(Q),O.Event.filter(ee.onDidAddConnection,_)(Q,void 0,J),ee.onDidRemoveConnection(oe,void 0,J),q.event(K.fire,K,J),J.add(q)},onDidRemoveLastListener:()=>{J?.dispose(),J=void 0}});return K.event}registerChannel(W,_){this.a.set(W,_);for(const ne of this.f)ne.channelServer.registerChannel(W,_)}dispose(){this.j.dispose();for(const W of this.f)W.channelClient.dispose(),W.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$mi=S;class v{constructor(W,_,ne=null){const le=new h;r(le,_),W.send(le.buffer),this.a=new C(W,ne),this.d=new u(W,_,ne)}getChannel(W){return this.a.getChannel(W)}registerChannel(W,_){this.d.registerChannel(W,_)}dispose(){this.a.dispose(),this.d.dispose()}}e.$ni=v;function L(B){return{call(W,_,ne){return B.then(le=>le.call(W,_,ne))},listen(W,_){const ne=new O.$xe;return B.then(le=>ne.input=le.listen(W,_)),ne.event}}}function U(B){let W=!1;return{call(_,ne,le){return W?B.call(_,ne,le):(0,a.$Jh)(0).then(()=>W=!0).then(()=>B.call(_,ne,le))},listen(_,ne){if(W)return B.listen(_,ne);const le=new O.$xe;return(0,a.$Jh)(0).then(()=>W=!0).then(()=>le.input=B.listen(_,ne)),le.event}}}class j{constructor(W){this.a=W}routeCall(W){return this.b(W)}routeEvent(W){return this.b(W)}async b(W){for(const _ of W.connections)if(await Promise.resolve(this.a(_.ctx)))return Promise.resolve(_);return await O.Event.toPromise(W.onDidAddConnection),await this.b(W)}}e.$qi=j;var F;(function(B){function W(ee,J,K){const q=ee,D=K&&K.disableMarshalling,Q=new Map;for(const oe in q)ne(oe)&&Q.set(oe,O.Event.buffer(q[oe],!0,void 0,J));return new class{listen(oe,Z,Y){const M=Q.get(Z);if(M)return M;const z=q[Z];if(typeof z=="function"){if(le(Z))return z.call(q,Y);if(ne(Z))return Q.set(Z,O.Event.buffer(q[Z],!0,void 0,J)),Q.get(Z)}throw new k.$db(`Event not found: ${Z}`)}call(oe,Z,Y){const M=q[Z];if(typeof M=="function"){if(!D&&Array.isArray(Y))for(let ie=0;ie<Y.length;ie++)Y[ie]=(0,I.$fi)(Y[ie]);let z=M.apply(q,Y);return z instanceof Promise||(z=Promise.resolve(z)),z}throw new k.$db(`Method not found: ${Z}`)}}}B.fromService=W;function _(ee,J){const K=J&&J.disableMarshalling;return new Proxy({},{get(q,D){if(typeof D=="string")return J?.properties?.has(D)?J.properties.get(D):le(D)?function(Q){return ee.listen(D,Q)}:ne(D)?ee.listen(D):async function(...Q){let oe;J&&!(0,$.$qg)(J.context)?oe=[J.context,...Q]:oe=Q;const Z=await ee.call(D,oe);return K?Z:(0,I.$fi)(Z)};throw new k.$db(`Property not found: ${String(D)}`)}})}B.toService=_;function ne(ee){return ee[0]==="o"&&ee[1]==="n"&&p.$Hf(ee.charCodeAt(2))}function le(ee){return/^onDynamic/.test(ee)&&p.$Hf(ee.charCodeAt(9))}})(F||(e.ProxyChannel=F={}));const G=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function V(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const W=B.toString();if(W!=="[object Object]")return W}return B}function x(B){return Array.isArray(B)?B.map(V):V(B)}function H(B,W,_,ne,le,ee,J){J=x(J);const K=G[le],q=K[ne%K.length];let D=[`%c[${B}]%c[${String(W).padStart(7," ")}]%c[len: ${String(_).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${ee}`,"color: darkgreen","color: grey","color: grey",`color: ${q}`];/\($/.test(ee)?(D=D.concat(J),D.push(")")):D.push(J),console.log.apply(console,D)}class te{constructor(W,_){this.d=W,this.f=_,this.a=0,this.b=0}logOutgoing(W,_,ne,le,ee){this.b+=W,H(this.d,this.b,W,_,ne,le,ee)}logIncoming(W,_,ne,le,ee){this.a+=W,H(this.f,this.a,W,_,ne,le,ee)}}e.$ri=te}),define(fe[70],de([0,1,14,3,2,42]),function(ce,e,R,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=e.$vi=e.$ui=e.$ti=e.ProtocolConstants=e.$si=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(T||(e.SocketDiagnosticsEventType=T={}));var k;(function(t){t.enableDiagnostics=!1,t.records=[];const s=new WeakMap;let r=0;function o(b,C){if(!s.has(b)){const S=String(++r);s.set(b,S)}return s.get(b)}function u(b,C,S,v){if(!t.enableDiagnostics)return;const L=o(b,C);if(v instanceof R.$Qe||v instanceof Uint8Array||v instanceof ArrayBuffer||ArrayBuffer.isView(v)){const U=R.$Qe.alloc(v.byteLength);U.set(v),t.records.push({timestamp:Date.now(),id:L,label:C,type:S,buff:U})}else t.records.push({timestamp:Date.now(),id:L,label:C,type:S,data:v})}t.traceSocketEvent=u})(k||(e.SocketDiagnostics=k={}));var O;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(O||(e.SocketCloseEventType=O={}));let y=null;function I(){return y||(y=R.$Qe.alloc(0)),y}class p{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(s){this.a.push(s),this.b+=s.byteLength}read(s){return this.c(s,!0)}peek(s){return this.c(s,!1)}c(s,r){if(s===0)return I();if(s>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===s){const C=this.a[0];return r&&(this.a.shift(),this.b-=s),C}if(this.a[0].byteLength>s){const C=this.a[0].slice(0,s);return r&&(this.a[0]=this.a[0].slice(s),this.b-=s),C}const o=R.$Qe.alloc(s);let u=0,b=0;for(;s>0;){const C=this.a[b];if(C.byteLength>s){const S=C.slice(0,s);o.set(S,u),u+=s,r&&(this.a[b]=C.slice(s),this.b-=s),s-=s}else o.set(C,u),u+=C.byteLength,r?(this.a.shift(),this.b-=C.byteLength):b++,s-=C.byteLength}return o}}e.$si=p;var $;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume",t[t.KeepAlive=9]="KeepAlive"})($||($={}));function g(t){switch(t){case $.None:return"None";case $.Regular:return"Regular";case $.Control:return"Control";case $.Ack:return"Ack";case $.Disconnect:return"Disconnect";case $.ReplayRequest:return"ReplayRequest";case $.Pause:return"PauseWriting";case $.Resume:return"ResumeWriting";case $.KeepAlive:return"KeepAlive"}}var l;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",t[t.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(l||(e.ProtocolConstants=l={}));class d{constructor(s,r,o,u){this.type=s,this.id=r,this.ack=o,this.data=u,this.writtenTime=0}get size(){return this.data.byteLength}}class E extends N.$Xc{constructor(s){super(),this.f=this.B(new a.$oe),this.onMessage=this.f.event,this.g={readHead:!0,readLen:l.HeaderLength,messageType:$.None,id:0,ack:0},this.a=s,this.b=!1,this.c=new p,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(s);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent(T.ProtocolHeaderRead,{messageType:g(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const o=this.g.messageType,u=this.g.id,b=this.g.ack;if(this.g.readHead=!0,this.g.readLen=l.HeaderLength,this.g.messageType=$.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(T.ProtocolMessageRead,r),this.f.fire(new d(o,u,b,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class w{constructor(s){this.k=null,this.a=!1,this.b=!1,this.c=s,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(s){if(this.a)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=R.$Qe.alloc(l.HeaderLength);r.writeUInt8(s.type,0),r.writeUInt32BE(s.id,1),r.writeUInt32BE(s.ack,5),r.writeUInt32BE(s.data.byteLength,9),this.c.traceSocketEvent(T.ProtocolHeaderWrite,{messageType:g(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this.c.traceSocketEvent(T.ProtocolMessageWrite,s.data),this.j(r,s.data)}g(s,r){const o=this.f===0;return this.d.push(s,r),this.f+=s.byteLength+r.byteLength,o}h(){const s=R.$Qe.concat(this.d,this.f);return this.d.length=0,this.f=0,s}j(s,r){this.g(s,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const s=this.h();this.c.traceSocketEvent(T.ProtocolWrite,{byteLength:s.byteLength}),this.c.write(s)}}class f extends N.$Xc{constructor(s){super(),this.f=new a.$oe,this.onMessage=this.f.event,this.g=new a.$oe,this.onDidDispose=this.g.event,this.a=s,this.b=this.B(new w(this.a)),this.c=this.B(new E(this.a)),this.B(this.c.onMessage(r=>{r.type===$.Regular&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(s){this.b.write(new d($.Regular,0,0,s))}}e.$ti=f;class P extends A.$ni{static fromSocket(s,r){return new P(new f(s),r)}get onDidDispose(){return this.b.onDidDispose}constructor(s,r,o=null){super(s,r,o),this.b=s}dispose(){super.dispose();const s=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),s.end()}}e.$ui=P;class m{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new a.$oe({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(s){this.b?this.d.length>0?this.d.push(s):this.a.fire(s):this.d.push(s)}flushBuffer(){this.d=[]}}e.$vi=m;class c{constructor(s){this.data=s,this.next=null}}class h{constructor(){this.a=null,this.b=null}length(){let s=0,r=this.a;for(;r;)r=r.next,s++;return s}peek(){return this.a?this.a.data:null}toArray(){const s=[];let r=0,o=this.a;for(;o;)s[r++]=o.data,o=o.next;return s}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(s){const r=new c(s);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class i{static{this.a=10}static{this.b=null}static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const s=Date.now();for(let r=0;r<i.a;r++)this.c[r]=s-1e3*r;setInterval(()=>{for(let r=i.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const s=Date.now(),r=(1+i.a)*1e3;let o=0;for(let u=0;u<i.a;u++)s-this.c[u]<=r&&o++;return 1-o/i.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.d-this.f}constructor(s){this.v=new m,this.onControlMessage=this.v.event,this.w=new m,this.onMessage=this.w.event,this.x=new m,this.onDidDispose=this.x.event,this.y=new m,this.onSocketClose=this.y.event,this.z=new m,this.onSocketTimeout=this.z.event,this.t=s.loadEstimator??i.getInstance(),this.u=s.sendKeepAlive??!0,this.a=!1,this.c=new h,this.d=0,this.f=0,this.g=null,this.h=0,this.j=0,this.k=0,this.l=null,this.n=0,this.o=Date.now(),this.s=new N.$Wc,this.p=s.socket,this.q=this.s.add(new w(this.p)),this.r=this.s.add(new E(this.p)),this.s.add(this.r.onMessage(r=>this.A(r))),this.s.add(this.p.onClose(r=>this.y.fire(r))),s.initialChunk&&this.r.acceptChunk(s.initialChunk),this.u?this.m=setInterval(()=>{this.E()},l.KeepAliveSendTime):this.m=null}dispose(){this.g&&(clearTimeout(this.g),this.g=null),this.l&&(clearTimeout(this.l),this.l=null),this.m&&(clearInterval(this.m),this.m=null),this.s.dispose()}drain(){return this.q.drain()}sendDisconnect(){if(!this.b){this.b=!0;const s=new d($.Disconnect,0,0,I());this.q.write(s),this.q.flush()}}sendPause(){const s=new d($.Pause,0,0,I());this.q.write(s)}sendResume(){const s=new d($.Resume,0,0,I());this.q.write(s)}pauseSocketWriting(){this.q.pause()}getSocket(){return this.p}getMillisSinceLastIncomingData(){return Date.now()-this.r.lastReadTime}beginAcceptReconnection(s,r){this.a=!0,this.s.dispose(),this.s=new N.$Wc,this.v.flushBuffer(),this.y.flushBuffer(),this.z.flushBuffer(),this.p.dispose(),this.n=0,this.o=Date.now(),this.p=s,this.q=this.s.add(new w(this.p)),this.r=this.s.add(new E(this.p)),this.s.add(this.r.onMessage(o=>this.A(o))),this.s.add(this.p.onClose(o=>this.y.fire(o))),this.r.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.j=this.h;const s=new d($.Ack,0,this.j,I());this.q.write(s);const r=this.c.toArray();for(let o=0,u=r.length;o<u;o++)this.q.write(r[o]);this.C()}acceptDisconnect(){this.x.fire()}A(s){if(s.ack>this.f){this.f=s.ack;do{const r=this.c.peek();if(r&&r.id<=s.ack)this.c.pop();else break}while(!0)}switch(s.type){case $.None:break;case $.Regular:{if(s.id>this.h)if(s.id!==this.h+1){const r=Date.now();r-this.n>1e4&&(this.n=r,this.q.write(new d($.ReplayRequest,0,0,I())))}else this.h=s.id,this.k=Date.now(),this.B(),this.w.fire(s.data);break}case $.Control:{this.v.fire(s.data);break}case $.Ack:break;case $.Disconnect:{this.x.fire();break}case $.ReplayRequest:{const r=this.c.toArray();for(let o=0,u=r.length;o<u;o++)this.q.write(r[o]);this.C();break}case $.Pause:{this.q.pause();break}case $.Resume:{this.q.resume();break}case $.KeepAlive:break}}readEntireBuffer(){return this.r.readEntireBuffer()}flush(){this.q.flush()}send(s){const r=++this.d;this.j=this.h;const o=new d($.Regular,r,this.j,s);this.c.push(o),this.a||(this.q.write(o),this.C())}sendControl(s){const r=new d($.Control,0,0,s);this.q.write(r)}B(){if(this.h<=this.j||this.l)return;const s=Date.now()-this.k;if(s>=l.AcknowledgeTime){this.D();return}this.l=setTimeout(()=>{this.l=null,this.B()},l.AcknowledgeTime-s+5)}C(){if(this.d<=this.f||this.g||this.a)return;const s=this.c.peek(),r=Date.now()-s.writtenTime,o=Date.now()-this.r.lastReadTime,u=Date.now()-this.o;if(r>=l.TimeoutTime&&o>=l.TimeoutTime&&u>=l.TimeoutTime&&!this.t.hasHighLoad()){this.o=Date.now(),this.z.fire({unacknowledgedMsgCount:this.c.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:o});return}const b=Math.max(l.TimeoutTime-r,l.TimeoutTime-o,l.TimeoutTime-u,500);this.g=setTimeout(()=>{this.g=null,this.C()},b)}D(){if(this.h<=this.j)return;this.j=this.h;const s=new d($.Ack,0,this.j,I());this.q.write(s)}E(){this.j=this.h;const s=new d($.KeepAlive,0,this.j,I());this.q.write(s)}}e.$wi=n}),define(fe[97],de([0,1,69,6,14,25,140,8,3,2,29,148,93,42]),function(ce,e,R,a,N,A,T,k,O,y,I,p,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=e.$nr=void 0,k=Oe(k);class l extends g.$ki{constructor(w){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:O.Event.fromNodeEventEmitter(process,"message",f=>N.$Qe.wrap(Buffer.from(f,"base64")))},w),process.once("disconnect",()=>this.dispose())}}e.$nr=l;class d{constructor(w,f){this.i=w,this.j=f,this.c=new Set,this.g=new Map,this.h=new O.$oe,this.onDidProcessExit=this.h.event;const P=f&&f.timeout?f.timeout:6e4;this.b=new a.$Fh(P),this.d=null,this.f=null}getChannel(w){const f=this;return{call(P,m,c){return f.k(w,P,m,c)},listen(P,m){return f.l(w,P,m)}}}k(w,f,P,m=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(m.isCancellationRequested)return Promise.reject(k.$8());this.b.cancel();const c=this.n(w),h=(0,a.$vh)(t=>c.call(f,P,t)),i=m.onCancellationRequested(()=>h.cancel()),n=(0,y.$Vc)(()=>h.cancel());return this.c.add(n),h.finally(()=>{i.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),h}l(w,f,P){if(!this.b)return O.Event.None;this.b.cancel();let m;const c=new O.$oe({onWillAddFirstListener:()=>{m=this.n(w).listen(f,P)(c.fire,c),this.c.add(m)},onDidRemoveLastListener:()=>{this.c.delete(m),m.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return c.event}get m(){if(!this.f){const w=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,I.$io)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,$.$pm)(f.env),this.d=(0,R.fork)(this.i,w,f);const P=new O.$oe,c=O.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,T.$jr)(r)){(0,T.log)(r,`IPC Library: ${this.j.serverName}`);return}P.fire(N.$Qe.wrap(Buffer.from(r,"base64")))}),h=this.j.useQueue?(0,p.$Cm)(this.d):this.d,i=r=>this.d&&this.d.connected&&h.send(r.buffer.toString("base64")),n=P.event,t={send:i,onMessage:n};this.f=new g.$li(t);const s=()=>this.o();process.once("exit",s),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,o)=>{process.removeListener("exit",s),c.dispose(),this.c.forEach(u=>(0,y.$Sc)(u)),this.c.clear(),r!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:o})})}return this.f}n(w){let f=this.g.get(w);return f||(f=this.m.getChannel(w),this.g.set(w,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$or=d}),define(fe[150],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=void 0,e.$ap=a;const R="Offline";function a(A){return A instanceof N?!0:A instanceof Error&&A.name===R&&A.message===R}class N extends Error{constructor(){super(R),this.name=this.message}}e.$bp=N}),define(fe[151],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sY=R;function R(a){return!!a.parentPort}}),define(fe[152],de([0,1,151,14,42,3,12,17]),function(ce,e,R,a,N,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tY=void 0,e.$uY=I;class O{constructor($){this.a=$,this.onMessage=A.Event.fromNodeEventEmitter(this.a,"message",g=>g.data?a.$Qe.wrap(g.data):a.$Qe.alloc(0)),$.start()}send($){this.a.postMessage($.buffer)}disconnect(){this.a.close()}}class y extends N.$mi{static b($){(0,T.$rg)((0,R.$sY)(process),"Electron Utility Process");const g=new A.$oe;return process.parentPort.on("message",l=>{if($?.handledClientConnection(l))return;const d=(0,k.$Qb)(l.ports);d&&g.fire(d)}),A.Event.map(g.event,l=>({protocol:new O(l),onDidClientDisconnect:A.Event.fromNodeEventEmitter(l,"close")}))}constructor($){super(y.b($))}}e.$tY=y;function I(p,$,g){const l=d=>{d.data===$&&(p.removeListener("message",l),g())};p.on("message",l)}}),define(fe[71],de([0,1,6,3,2,66,12]),function(ce,e,R,a,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$iq=e.StorageState=e.StorageHint=void 0,e.$hq=O;var k;(function($){$[$.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",$[$.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(k||(e.StorageHint=k={}));function O($){const g=$;return g?.changed instanceof Map||g?.deleted instanceof Set}var y;(function($){$[$.None=0]="None",$[$.Initialized=1]="Initialized",$[$.Closed=2]="Closed"})(y||(e.StorageState=y={}));class I extends N.$Xc{static{this.a=100}constructor(g,l=Object.create(null)){super(),this.r=g,this.s=l,this.b=this.B(new a.$re),this.onDidChangeStorage=this.b.event,this.c=y.None,this.f=new Map,this.g=this.B(new R.$Gh(I.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(g=>this.u(g)))}u(g){this.b.pause();try{g.changed?.forEach((l,d)=>this.w(d,l)),g.deleted?.forEach(l=>this.w(l,void 0))}finally{this.b.resume()}}w(g,l){if(this.c===y.Closed)return;let d=!1;(0,T.$qg)(l)?d=this.f.delete(g):this.f.get(g)!==l&&(this.f.set(g,l),d=!0),d&&this.b.fire({key:g,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===y.None&&(this.c=y.Initialized,this.s.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(g,l){const d=this.f.get(g);return(0,T.$qg)(d)?l:d}getBoolean(g,l){const d=this.get(g);return(0,T.$qg)(d)?l:d==="true"}getNumber(g,l){const d=this.get(g);return(0,T.$qg)(d)?l:parseInt(d,10)}getObject(g,l){const d=this.get(g);return(0,T.$qg)(d)?l:(0,A.$ei)(d)}async set(g,l,d=!1){if(this.c===y.Closed)return;if((0,T.$qg)(l))return this.delete(g,d);const E=(0,T.$jg)(l)||Array.isArray(l)?(0,A.$di)(l):String(l);if(this.f.get(g)!==E)return this.f.set(g,E),this.j.set(g,E),this.h.delete(g),this.b.fire({key:g,external:d}),this.D()}async delete(g,l=!1){if(!(this.c===y.Closed||!this.f.delete(g)))return this.h.has(g)||this.h.add(g),this.j.delete(g),this.b.fire({key:g,external:l}),this.D()}async optimize(){if(this.c!==y.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=y.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const g={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(g).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(g){if(!(this.c===y.Closed||this.m))return this.D(g)}async D(g){return this.s.hint===k.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),g)}async whenFlushed(){if(this.z)return new Promise(g=>this.n.push(g))}isInMemory(){return this.s.hint===k.STORAGE_IN_MEMORY}}e.$iq=I;class p{constructor(){this.onDidChangeItemsExternal=a.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(g){g.insert?.forEach((l,d)=>this.a.set(d,l)),g.delete?.forEach(l=>this.a.delete(l))}async optimize(){}async close(){}}e.$jq=p}),define(fe[11],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localize=N,e.localize2=T;const R=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function a(k,O){let y;return O.length===0?y=k:y=k.replace(/\{(\d+)\}/g,(I,p)=>{const $=p[0],g=O[$];let l=I;return typeof g=="string"?l=g:(typeof g=="number"||typeof g=="boolean"||g===void 0||g===null)&&(l=String(g)),l}),R&&(y="\uFF3B"+y.replace(/[aouei]/g,"$&$&")+"\uFF3D"),y}function N(k,O,...y){return a(typeof k=="number"?A(k,O):O,y)}function A(k,O){const y=globalThis._VSCODE_NLS_MESSAGES?.[k];if(typeof y!="string"){if(typeof O=="string")return O;throw new Error(`!!! NLS MISSING: ${k} !!!`)}return y}function T(k,O,...y){let I;typeof k=="number"?I=A(k,O):I=O;const p=a(I,y);return{value:p,original:O===I?p:a(O,y)}}}),define(fe[72],de([0,1,11]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=y,e.$6m=I,e.$7m=p,e.$8m=$;const a=60,N=a*60,A=N*24,T=A*7,k=A*30,O=A*365;function y(g,l,d,E){typeof g!="number"&&(g=g.getTime());const w=Math.round((new Date().getTime()-g)/1e3);if(w<-30)return(0,R.localize)(42,null,y(new Date().getTime()+w*1e3,!1));if(!E&&w<30)return(0,R.localize)(43,null);let f;return w<a?(f=w,l?f===1?d?(0,R.localize)(44,null,f):(0,R.localize)(45,null,f):d?(0,R.localize)(46,null,f):(0,R.localize)(47,null,f):f===1?d?(0,R.localize)(48,null,f):(0,R.localize)(49,null,f):d?(0,R.localize)(50,null,f):(0,R.localize)(51,null,f)):w<N?(f=Math.floor(w/a),l?f===1?d?(0,R.localize)(52,null,f):(0,R.localize)(53,null,f):d?(0,R.localize)(54,null,f):(0,R.localize)(55,null,f):f===1?d?(0,R.localize)(56,null,f):(0,R.localize)(57,null,f):d?(0,R.localize)(58,null,f):(0,R.localize)(59,null,f)):w<A?(f=Math.floor(w/N),l?f===1?d?(0,R.localize)(60,null,f):(0,R.localize)(61,null,f):d?(0,R.localize)(62,null,f):(0,R.localize)(63,null,f):f===1?d?(0,R.localize)(64,null,f):(0,R.localize)(65,null,f):d?(0,R.localize)(66,null,f):(0,R.localize)(67,null,f)):w<T?(f=Math.floor(w/A),l?f===1?(0,R.localize)(68,null,f):(0,R.localize)(69,null,f):f===1?(0,R.localize)(70,null,f):(0,R.localize)(71,null,f)):w<k?(f=Math.floor(w/T),l?f===1?d?(0,R.localize)(72,null,f):(0,R.localize)(73,null,f):d?(0,R.localize)(74,null,f):(0,R.localize)(75,null,f):f===1?d?(0,R.localize)(76,null,f):(0,R.localize)(77,null,f):d?(0,R.localize)(78,null,f):(0,R.localize)(79,null,f)):w<O?(f=Math.floor(w/k),l?f===1?d?(0,R.localize)(80,null,f):(0,R.localize)(81,null,f):d?(0,R.localize)(82,null,f):(0,R.localize)(83,null,f):f===1?d?(0,R.localize)(84,null,f):(0,R.localize)(85,null,f):d?(0,R.localize)(86,null,f):(0,R.localize)(87,null,f)):(f=Math.floor(w/O),l?f===1?d?(0,R.localize)(88,null,f):(0,R.localize)(89,null,f):d?(0,R.localize)(90,null,f):(0,R.localize)(91,null,f):f===1?d?(0,R.localize)(92,null,f):(0,R.localize)(93,null,f):d?(0,R.localize)(94,null,f):(0,R.localize)(95,null,f))}function I(g,l,d){typeof g!="number"&&(g=g.getTime());const E=new Date;E.setHours(0,0,0,0);const w=new Date(E.getTime());return w.setDate(w.getDate()-1),g>E.getTime()?(0,R.localize)(96,null):g>w.getTime()?(0,R.localize)(97,null):y(g,l,d)}function p(g,l){const d=Math.abs(g/1e3);return d<1?l?(0,R.localize)(98,null,g):(0,R.localize)(99,null,g):d<a?l?(0,R.localize)(100,null,Math.round(g)/1e3):(0,R.localize)(101,null,Math.round(g)/1e3):d<N?l?(0,R.localize)(102,null,Math.round(g/(1e3*a))):(0,R.localize)(103,null,Math.round(g/(1e3*a))):d<A?l?(0,R.localize)(104,null,Math.round(g/(1e3*N))):(0,R.localize)(105,null,Math.round(g/(1e3*N))):(0,R.localize)(106,null,Math.round(g/(1e3*A)))}function $(g){return g.getFullYear()+"-"+String(g.getMonth()+1).padStart(2,"0")+"-"+String(g.getDate()).padStart(2,"0")+"T"+String(g.getHours()).padStart(2,"0")+":"+String(g.getMinutes()).padStart(2,"0")+":"+String(g.getSeconds()).padStart(2,"0")+"."+(g.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(fe[43],de([0,1,17,12,11]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=O,e.$uj=y,e.$vj=I,R=Oe(R),a=Oe(a),N=Oe(N);function A(p,$){return $&&(p.stack||p.stacktrace)?N.localize(107,null,k(p),T(p.stack)||T(p.stacktrace)):k(p)}function T(p){return Array.isArray(p)?p.join(`
`):p}function k(p){return p.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${p.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof p.code=="string"&&typeof p.errno=="number"&&typeof p.syscall=="string"?N.localize(108,null,p.message):p.message||N.localize(109,null)}function O(p=null,$=!1){if(!p)return N.localize(110,null);if(Array.isArray(p)){const g=R.$Jb(p),l=O(g[0],$);return g.length>1?N.localize(111,null,l,g.length):l}if(a.$hg(p))return p;if(p.detail){const g=p.detail;if(g.error)return A(g.error,$);if(g.exception)return A(g.exception,$)}return p.stack?A(p,$):p.message?p.message:N.localize(112,null)}function y(p){const $=p;return $ instanceof Error&&Array.isArray($.actions)}function I(p,$){let g;return typeof p=="string"?g=new Error(p):g=p,g.actions=$,g}}),define(fe[153],de([0,1,11,36]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=N;function N(A){switch(A){case a.ParseErrorCode.InvalidSymbol:return(0,R.localize)(113,null);case a.ParseErrorCode.InvalidNumberFormat:return(0,R.localize)(114,null);case a.ParseErrorCode.PropertyNameExpected:return(0,R.localize)(115,null);case a.ParseErrorCode.ValueExpected:return(0,R.localize)(116,null);case a.ParseErrorCode.ColonExpected:return(0,R.localize)(117,null);case a.ParseErrorCode.CommaExpected:return(0,R.localize)(118,null);case a.ParseErrorCode.CloseBraceExpected:return(0,R.localize)(119,null);case a.ParseErrorCode.CloseBracketExpected:return(0,R.localize)(120,null);case a.ParseErrorCode.EndOfFileExpected:return(0,R.localize)(121,null);default:return""}}}),define(fe[73],de([0,1,33,6,13,12,30,11]),function(ce,e,R,a,N,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=void 0,e.zip=E,e.$Jq=w,e.$Kq=P,N=Oe(N),k=Oe(k),e.$Gq="end of central directory record signature not found";const O=new RegExp(e.$Gq);class y extends Error{constructor(c,h){let i=h.message;switch(c){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=c,this.cause=h}}e.$Hq=y;function I(m){const c=m.externalFileAttributes>>16||33188;return[448,56,7].map(h=>c&h).reduce((h,i)=>h+i,c&61440)}function p(m){if(m instanceof y)return m;let c;return O.test(m.message)&&(c="CorruptZip"),new y(c,m)}function $(m,c,h,i,n,t){const s=N.$pc(c),r=N.$mc(i,s);if(!r.startsWith(i))return Promise.reject(new Error(k.localize(142,null,c)));const o=N.$mc(i,c);let u;return t.onCancellationRequested(()=>{u?.destroy()}),Promise.resolve(R.promises.mkdir(r,{recursive:!0})).then(()=>new Promise((b,C)=>{if(!t.isCancellationRequested)try{u=(0,R.createWriteStream)(o,{mode:h}),u.once("close",()=>b()),u.once("error",C),m.once("error",C),m.pipe(u)}catch(S){C(S)}}))}function g(m,c,h,i){let n=(0,a.$vh)(()=>Promise.resolve()),t=0;const s=i.onCancellationRequested(()=>{n.cancel(),m.close()});return new Promise((r,o)=>{const u=new a.$Dh,b=C=>{C.isCancellationRequested||(t++,m.readEntry())};m.once("error",o),m.once("close",()=>n.then(()=>{i.isCancellationRequested||m.entryCount===t?r():o(new y("Incomplete",new Error(k.localize(143,null,t,m.entryCount))))},o)),m.readEntry(),m.on("entry",C=>{if(i.isCancellationRequested)return;if(!h.sourcePathRegex.test(C.fileName)){b(i);return}const S=C.fileName.replace(h.sourcePathRegex,"");if(/\/$/.test(S)){const U=N.$mc(c,S);n=(0,a.$vh)(j=>R.promises.mkdir(U,{recursive:!0}).then(()=>b(j)).then(void 0,o));return}const v=d(m,C),L=I(C);n=(0,a.$vh)(U=>u.queue(()=>v.then(j=>$(j,S,L,c,h,U).then(()=>b(U)))).then(null,o))})}).finally(()=>s.dispose())}async function l(m,c=!1){const{open:h}=await new Promise((i,n)=>{ce(["yauzl"],i,n)}).then(Oe);return new Promise((i,n)=>{h(m,c?{lazyEntries:!0}:void 0,(t,s)=>{t?n(p(t)):i((0,A.$sg)(s))})})}function d(m,c){return new Promise((h,i)=>{m.openReadStream(c,(n,t)=>{n?i(p(n)):h((0,A.$sg)(t))})})}async function E(m,c){const{ZipFile:h}=await new Promise((i,n)=>{ce(["yazl"],i,n)}).then(Oe);return new Promise((i,n)=>{const t=new h;c.forEach(r=>{r.contents?t.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&t.addFile(r.localPath,r.path)}),t.end();const s=(0,R.createWriteStream)(m);t.outputStream.pipe(s),t.outputStream.once("error",n),s.once("error",n),s.once("finish",()=>i(m))})}function w(m,c,h={},i){const n=new RegExp(h.sourcePath?`^${h.sourcePath}`:"");let t=l(m,!0);return h.overwrite&&(t=t.then(s=>T.Promises.rm(c).then(()=>s))),t.then(s=>g(s,c,{sourcePathRegex:n},i))}function f(m,c){return l(m).then(h=>new Promise((i,n)=>{h.on("entry",t=>{t.fileName===c&&d(h,t).then(s=>i(s),s=>n(s))}),h.once("close",()=>n(new Error(k.localize(144,null,c))))}))}function P(m,c){return f(m,c).then(h=>new Promise((i,n)=>{const t=[];h.once("error",n),h.on("data",s=>t.push(s)),h.on("end",()=>i(Buffer.concat(t)))}))}}),define(fe[154],de([0,1,39,8,11]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dj=e.TokenType=void 0;var A;(function(I){I[I.LParen=0]="LParen",I[I.RParen=1]="RParen",I[I.Neg=2]="Neg",I[I.Eq=3]="Eq",I[I.NotEq=4]="NotEq",I[I.Lt=5]="Lt",I[I.LtEq=6]="LtEq",I[I.Gt=7]="Gt",I[I.GtEq=8]="GtEq",I[I.RegexOp=9]="RegexOp",I[I.RegexStr=10]="RegexStr",I[I.True=11]="True",I[I.False=12]="False",I[I.In=13]="In",I[I.Not=14]="Not",I[I.And=15]="And",I[I.Or=16]="Or",I[I.Str=17]="Str",I[I.QuotedStr=18]="QuotedStr",I[I.Error=19]="Error",I[I.EOF=20]="EOF"})(A||(e.TokenType=A={}));function T(...I){switch(I.length){case 1:return(0,N.localize)(1693,null,I[0]);case 2:return(0,N.localize)(1694,null,I[0],I[1]);case 3:return(0,N.localize)(1695,null,I[0],I[1],I[2]);default:return}}const k=(0,N.localize)(1696,null),O=(0,N.localize)(1697,null);class y{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(p){switch(p.type){case A.LParen:return"(";case A.RParen:return")";case A.Neg:return"!";case A.Eq:return p.isTripleEq?"===":"==";case A.NotEq:return p.isTripleEq?"!==":"!=";case A.Lt:return"<";case A.LtEq:return"<=";case A.Gt:return">=";case A.GtEq:return">=";case A.RegexOp:return"=~";case A.RegexStr:return p.lexeme;case A.True:return"true";case A.False:return"false";case A.In:return"in";case A.Not:return"not";case A.And:return"&&";case A.Or:return"||";case A.Str:return p.lexeme;case A.QuotedStr:return p.lexeme;case A.Error:return p.lexeme;case A.EOF:return"EOF";default:throw(0,a.$0)(`unhandled token type: ${JSON.stringify(p)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(p=>p.charCodeAt(0)))}static{this.b=new Map([["not",A.Not],["in",A.In],["false",A.False],["true",A.True]])}get errors(){return this.g}reset(p){return this.c=p,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case R.CharCode.OpenParen:this.k(A.LParen);break;case R.CharCode.CloseParen:this.k(A.RParen);break;case R.CharCode.ExclamationMark:if(this.h(R.CharCode.Equals)){const $=this.h(R.CharCode.Equals);this.f.push({type:A.NotEq,offset:this.d,isTripleEq:$})}else this.k(A.Neg);break;case R.CharCode.SingleQuote:this.o();break;case R.CharCode.Slash:this.q();break;case R.CharCode.Equals:if(this.h(R.CharCode.Equals)){const $=this.h(R.CharCode.Equals);this.f.push({type:A.Eq,offset:this.d,isTripleEq:$})}else this.h(R.CharCode.Tilde)?this.k(A.RegexOp):this.l(T("==","=~"));break;case R.CharCode.LessThan:this.k(this.h(R.CharCode.Equals)?A.LtEq:A.Lt);break;case R.CharCode.GreaterThan:this.k(this.h(R.CharCode.Equals)?A.GtEq:A.Gt);break;case R.CharCode.Ampersand:this.h(R.CharCode.Ampersand)?this.k(A.And):this.l(T("&&"));break;case R.CharCode.Pipe:this.h(R.CharCode.Pipe)?this.k(A.Or):this.l(T("||"));break;case R.CharCode.Space:case R.CharCode.CarriageReturn:case R.CharCode.Tab:case R.CharCode.LineFeed:case R.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(A.EOF),Array.from(this.f)}h(p){return this.r()||this.c.charCodeAt(this.e)!==p?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?R.CharCode.Null:this.c.charCodeAt(this.e)}k(p){this.f.push({type:p,offset:this.d})}l(p){const $=this.d,g=this.c.substring(this.d,this.e),l={type:A.Error,offset:this.d,lexeme:g};this.g.push({offset:$,lexeme:g,additionalInfo:p}),this.f.push(l)}n(){this.m.lastIndex=this.d;const p=this.m.exec(this.c);if(p){this.e=this.d+p[0].length;const $=this.c.substring(this.d,this.e),g=y.b.get($);g?this.k(g):this.f.push({type:A.Str,lexeme:$,offset:this.d})}}o(){for(;this.j()!==R.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(k);return}this.i(),this.f.push({type:A.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let p=this.e,$=!1,g=!1;for(;;){if(p>=this.c.length){this.e=p,this.l(O);return}const d=this.c.charCodeAt(p);if($)$=!1;else if(d===R.CharCode.Slash&&!g){p++;break}else d===R.CharCode.OpenSquareBracket?g=!0:d===R.CharCode.Backslash?$=!0:d===R.CharCode.CloseSquareBracket&&(g=!1);p++}for(;p<this.c.length&&y.a.has(this.c.charCodeAt(p));)p++;this.e=p;const l=this.c.substring(this.d,this.e);this.f.push({type:A.RegexStr,lexeme:l,offset:this.d})}r(){return this.e>=this.c.length}}e.$Dj=y}),define(fe[155],de([0,1,72,89,22,13,37,20,9]),function(ce,e,R,a,N,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=e.$9m=void 0,e.$$m=I,e.$_m=p,e.$9m=/^([^.]+\..+)[:=](.+)$/;class y{get appRoot(){return(0,A.$pc)(N.$3g.asFileUri("").fsPath)}get userHome(){return O.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return O.URI.file((0,A.$mc)(this.userDataPath,"User"))}get tmpDir(){return O.URI.file(this.b.tmpDir)}get cacheHome(){return O.URI.file(this.userDataPath)}get stateResource(){return(0,k.$jh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:N.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,k.$jh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const g=(0,R.$8m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$mc)(this.userDataPath,"logs",g)}return O.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.$jh)(O.URI.file((0,A.$mc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,k.$jh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,k.$jh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,k.$jh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=T.env.VSCODE_PORTABLE;return g?O.URI.file((0,A.$mc)(g,"argv.json")):(0,k.$jh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return O.URI.file((0,A.$mc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,A.$nc)(g):(0,A.$kc)((0,A.$mc)(N.$3g.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const g=this.args["extensions-download-dir"];return g?O.URI.file((0,A.$nc)(g)):O.URI.file((0,A.$mc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,A.$nc)(g);const l=T.env.VSCODE_EXTENSIONS;if(l)return l;const d=T.env.VSCODE_PORTABLE;return d?(0,A.$mc)(d,"extensions"):(0,k.$jh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(l=>/^[^:/?#]+?:\/\//.test(l)?O.URI.parse(l):O.URI.file((0,A.$kc)(l)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?O.URI.parse(g):O.URI.file((0,A.$kc)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(g=>!e.$9m.test(g))}get extensionLogLevel(){const g=[];for(const l of this.args.log||[]){const d=e.$9m.exec(l);d&&d[1]&&d[2]&&g.push([d[1],d[2]])}return g.length?g:void 0}get serviceMachineIdResource(){return(0,k.$jh)(O.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const g=T.env.VSCODE_PORTABLE;return g?O.URI.file((0,A.$mc)(g,"policy.json")):(0,k.$jh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(g){this.args.continueOn=g}get args(){return this.a}constructor(g,l,d){this.a=g,this.b=l,this.c=d,this.editSessionId=this.args.editSessionId}}e.$0m=y,Ee([a.$ai],y.prototype,"appRoot",null),Ee([a.$ai],y.prototype,"userHome",null),Ee([a.$ai],y.prototype,"userDataPath",null),Ee([a.$ai],y.prototype,"appSettingsHome",null),Ee([a.$ai],y.prototype,"tmpDir",null),Ee([a.$ai],y.prototype,"cacheHome",null),Ee([a.$ai],y.prototype,"stateResource",null),Ee([a.$ai],y.prototype,"userRoamingDataHome",null),Ee([a.$ai],y.prototype,"userDataSyncHome",null),Ee([a.$ai],y.prototype,"sync",null),Ee([a.$ai],y.prototype,"machineSettingsResource",null),Ee([a.$ai],y.prototype,"workspaceStorageHome",null),Ee([a.$ai],y.prototype,"localHistoryHome",null),Ee([a.$ai],y.prototype,"keyboardLayoutResource",null),Ee([a.$ai],y.prototype,"argvResource",null),Ee([a.$ai],y.prototype,"isExtensionDevelopment",null),Ee([a.$ai],y.prototype,"untitledWorkspacesHome",null),Ee([a.$ai],y.prototype,"builtinExtensionsPath",null),Ee([a.$ai],y.prototype,"extensionsPath",null),Ee([a.$ai],y.prototype,"extensionDevelopmentLocationURI",null),Ee([a.$ai],y.prototype,"extensionDevelopmentKind",null),Ee([a.$ai],y.prototype,"extensionTestsLocationURI",null),Ee([a.$ai],y.prototype,"debugExtensionHost",null),Ee([a.$ai],y.prototype,"logLevel",null),Ee([a.$ai],y.prototype,"extensionLogLevel",null),Ee([a.$ai],y.prototype,"serviceMachineIdResource",null),Ee([a.$ai],y.prototype,"disableTelemetry",null),Ee([a.$ai],y.prototype,"disableWorkspaceTrust",null),Ee([a.$ai],y.prototype,"useInMemorySecretStorage",null),Ee([a.$ai],y.prototype,"policyFile",null);function I($,g){return p($["inspect-extensions"],$["inspect-brk-extensions"],5870,g,$.debugId,$.extensionEnvironment)}function p($,g,l,d,E,w){const P=Number(g||$)||(d?null:l),m=P?!!g:!1;let c;if(w)try{c=JSON.parse(w)}catch{}return{port:P,break:m,debugId:E,env:c}}}),function(){function ce(e,R,a){function N(T,k){const O=A(T,k),y=[O];return e.isAbsolute(O)||y.unshift(a),e.resolve(...y)}function A(T,k){process.env.VSCODE_DEV&&(k="code-oss-dev");const O=process.env.VSCODE_PORTABLE;if(O)return e.join(O,"user-data");let y=process.env.VSCODE_APPDATA;if(y)return e.join(y,k);const I=T["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(y=process.env.APPDATA,!y){const p=process.env.USERPROFILE;if(typeof p!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");y=e.join(p,"AppData","Roaming")}break;case"darwin":y=e.join(R.homedir(),"Library","Application Support");break;case"linux":y=process.env.XDG_CONFIG_HOME||e.join(R.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(y,k)}return{getUserDataPath:N}}if(typeof define=="function")define(fe[156],de([244,38,37]),function(e,R,a){return ce(e,R,a.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),R=require("os");module.exports=ce(e,R,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(fe[157],de([0,1,38,155,156]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$an=void 0,e.$bn=T,e.$cn=k;class A extends a.$0m{constructor(y,I){super(y,{homeDir:(0,R.homedir)(),tmpDir:(0,R.tmpdir)(),userDataDir:(0,N.getUserDataPath)(y,I.nameShort)},I)}}e.$an=A;function T(O,y){return(0,a.$_m)(O["inspect-ptyhost"],O["inspect-brk-ptyhost"],5877,y,O.extensionEnvironment)}function k(O,y){return(0,a.$_m)(O["inspect-sharedprocess"],O["inspect-brk-sharedprocess"],5879,y,O.extensionEnvironment)}}),define(fe[158],de([0,1,12,11]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=N;function N(T,k,O,y){try{A(T,k,O,y)}catch(I){T.error(I?.message??I)}return k}function A(T,k,O,y){const I=(p,$,g)=>{const l=p[$];if((0,R.$hg)(l)){const d=l,E=d.length;if(E>1&&d[0]==="%"&&d[E-1]==="%"){const w=d.substr(1,E-2);let f=O[w];f===void 0&&y&&(f=y[w]);const P=typeof f=="string"?f:f?.message,m=y?.[w],c=typeof m=="string"?m:m?.message;if(!P){c||T.warn(`[${k.name}]: ${(0,a.localize)(1814,null,w)}`);return}if(g&&($==="title"||$==="category")&&c&&c!==P){const h={value:P,original:c};p[$]=h}else p[$]=P}}else if((0,R.$jg)(l))for(const d in l)l.hasOwnProperty(d)&&(d==="commands"?I(l,d,!0):I(l,d,g));else if(Array.isArray(l))for(let d=0;d<l.length;d++)I(l,d,g)};for(const p in k)k.hasOwnProperty(p)&&I(k,p)}}),define(fe[159],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ljc=e.$Kjc=void 0;class R{constructor(A){this.a=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A){return this.a.call("promptImportantExtensionsInstallNotification",[A])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$Kjc=R;class a{constructor(A){this.a=A}listen(A,T){throw new Error(`Event not found: ${T}`)}call(A,T,k){switch(T){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(k[0])}throw new Error(`Call not found: ${T}`)}}e.$Ljc=a}),define(fe[160],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const R={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDebugCreateConfiguration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDebugCreateConfiguration.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewContainerTitle:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewContainerTitle.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:4},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookReplDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookReplDocument.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(R)}),define(fe[74],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=void 0;class R{constructor(N,A=[],T=!1){this.ctor=N,this.staticArguments=A,this.supportsDelayedInstantiation=T}}e.$Fi=R}),define(fe[161],de([0,1,74]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Xs=A,e.$Ys=T;const a=[];var N;(function(k){k[k.Eager=0]="Eager",k[k.Delayed=1]="Delayed"})(N||(e.InstantiationType=N={}));function A(k,O,y){O instanceof R.$Fi||(O=new R.$Fi(O,[],!!y)),a.push([k,O])}function T(){return a}}),define(fe[162],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=e.$Ar=void 0;class R{constructor(A,T){this.key=A,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.$Ar=R;class a{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const T of this.a.values())T.outgoing.size===0&&A.push(T);return A}insertEdge(A,T){const k=this.lookupOrInsertNode(A),O=this.lookupOrInsertNode(T);k.outgoing.set(O.key,O),O.incoming.set(k.key,k)}removeNode(A){const T=this.b(A);this.a.delete(T);for(const k of this.a.values())k.outgoing.delete(T),k.incoming.delete(T)}lookupOrInsertNode(A){const T=this.b(A);let k=this.a.get(T);return k||(k=new R(T,A),this.a.set(T,k)),k}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[T,k]of this.a)A.push(`${T}
	(-> incoming)[${[...k.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...k.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,T]of this.a){const k=new Set([A]),O=this.c(T,k);if(O)return O}}c(A,T){for(const[k,O]of A.outgoing){if(T.has(k))return[...T,k].join(" -> ");T.add(k);const y=this.c(O,T);if(y)return y;T.delete(k)}}}e.$Br=a}),define(fe[4],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=e._util=void 0,e.$Ii=N,e.$Ji=A;var R;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function k(O){return O[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=k})(R||(e._util=R={})),e.$Hi=N("instantiationService");function a(T,k,O){k[R.DI_TARGET]===k?k[R.DI_DEPENDENCIES].push({id:T,index:O}):(k[R.DI_DEPENDENCIES]=[{id:T,index:O}],k[R.DI_TARGET]=k)}function N(T){if(R.serviceIds.has(T))return R.serviceIds.get(T);const k=function(O,y,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");a(k,O,I)};return k.toString=()=>T,R.serviceIds.set(T,k),k}function A(T){return T}}),define(fe[163],de([0,1,4]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kjc=void 0,e.$kjc=(0,R.$Ii)("checksumService")}),define(fe[21],de([0,1,12,9,4]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$cj=void 0,e.$dj=A,e.$ej=T,e.$fj=O,e.$gj=y,e.$hj=I,e.$ij=p,e.$jj=$,e.$kj=l,e.$lj=d,e.$mj=E,R=Oe(R),e.$cj=(0,N.$Ii)("configurationService");function A(w){return w&&typeof w=="object"&&(!w.overrideIdentifier||typeof w.overrideIdentifier=="string")&&(!w.resource||w.resource instanceof a.URI)}function T(w){return w&&typeof w=="object"&&(!w.overrideIdentifiers||Array.isArray(w.overrideIdentifiers))&&!w.overrideIdentifier&&(!w.resource||w.resource instanceof a.URI)}var k;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.USER=2]="USER",w[w.USER_LOCAL=3]="USER_LOCAL",w[w.USER_REMOTE=4]="USER_REMOTE",w[w.WORKSPACE=5]="WORKSPACE",w[w.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",w[w.DEFAULT=7]="DEFAULT",w[w.MEMORY=8]="MEMORY"})(k||(e.ConfigurationTarget=k={}));function O(w){switch(w){case k.APPLICATION:return"APPLICATION";case k.USER:return"USER";case k.USER_LOCAL:return"USER_LOCAL";case k.USER_REMOTE:return"USER_REMOTE";case k.WORKSPACE:return"WORKSPACE";case k.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case k.DEFAULT:return"DEFAULT";case k.MEMORY:return"MEMORY"}}function y(w){return w.applicationValue!==void 0||w.userValue!==void 0||w.userLocalValue!==void 0||w.userRemoteValue!==void 0||w.workspaceValue!==void 0||w.workspaceFolderValue!==void 0}function I(w,f){const P=Object.create(null);for(const m in w)p(P,m,w[m],f);return P}function p(w,f,P,m){const c=f.split("."),h=c.pop();let i=w;for(let n=0;n<c.length;n++){const t=c[n];let s=i[t];switch(typeof s){case"undefined":s=i[t]=Object.create(null);break;case"object":if(s===null){m(`Ignoring ${f} as ${c.slice(0,n+1).join(".")} is null`);return}break;default:m(`Ignoring ${f} as ${c.slice(0,n+1).join(".")} is ${JSON.stringify(s)}`);return}i=s}if(typeof i=="object"&&i!==null)try{i[h]=P}catch{m(`Ignoring ${f} as ${c.join(".")} is ${JSON.stringify(i)}`)}else m(`Ignoring ${f} as ${c.join(".")} is ${JSON.stringify(i)}`)}function $(w,f){const P=f.split(".");g(w,P)}function g(w,f){const P=f.shift();if(f.length===0){delete w[P];return}if(Object.keys(w).indexOf(P)!==-1){const m=w[P];typeof m=="object"&&!Array.isArray(m)&&(g(m,f),Object.keys(m).length===0&&delete w[P])}}function l(w,f,P){function m(i,n){let t=i;for(const s of n){if(typeof t!="object"||t===null)return;t=t[s]}return t}const c=f.split("."),h=m(w,c);return typeof h>"u"?P:h}function d(w,f,P){Object.keys(f).forEach(m=>{m!=="__proto__"&&(m in w?R.$jg(w[m])&&R.$jg(f[m])?d(w[m],f[m],P):P&&(w[m]=f[m]):w[m]=f[m])})}function E(w){return w.replace(/[\[\]]/g,"")}}),define(fe[98],de([0,1,39,5,26,154,4,11,8]),function(ce,e,R,a,N,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Gj=e.$Fj=e.ContextKeyExprType=void 0,e.$Ej=I,e.$Hj=n,e.$Ij=t,e.$2j=ee;const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",a.$k),y.set("isLinux",a.$l),y.set("isWindows",a.$j),y.set("isWeb",a.$p),y.set("isMacNative",a.$k&&!a.$p),y.set("isEdge",a.$I),y.set("isFirefox",a.$G),y.set("isChrome",a.$F),y.set("isSafari",a.$H);function I(q,D){if(y.get(q)!==void 0)throw(0,O.$9)("contextkey.setConstant(k, v) invoked with already set constant `k`");y.set(q,D)}const p=Object.prototype.hasOwnProperty;var $;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})($||(e.ContextKeyExprType=$={}));const g={regexParsingWithErrorRecovery:!0},l=(0,k.localize)(1673,null),d=(0,k.localize)(1674,null),E=(0,k.localize)(1675,null),w=(0,k.localize)(1676,null),f=(0,k.localize)(1677,null),P=(0,k.localize)(1678,null),m=(0,k.localize)(1679,null),c=(0,k.localize)(1680,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(D=g){this.k=D,this.d=new A.$Dj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(D){if(D===""){this.h.push({message:l,offset:0,lexeme:"",additionalInfo:d});return}this.f=this.d.reset(D).scan(),this.g=0,this.h=[];try{const Q=this.l();if(!this.E()){const oe=this.D(),Z=oe.type===A.TokenType.Str?P:void 0;throw this.h.push({message:f,offset:oe.offset,lexeme:A.$Dj.getLexeme(oe),additionalInfo:Z}),h.c}return Q}catch(Q){if(Q!==h.c)throw Q;return}}l(){return this.m()}m(){const D=[this.o()];for(;this.y(A.TokenType.Or);){const Q=this.o();D.push(Q)}return D.length===1?D[0]:i.or(...D)}o(){const D=[this.s()];for(;this.y(A.TokenType.And);){const Q=this.s();D.push(Q)}return D.length===1?D[0]:i.and(...D)}s(){if(this.y(A.TokenType.Neg)){const D=this.D();switch(D.type){case A.TokenType.True:return this.z(),r.INSTANCE;case A.TokenType.False:return this.z(),o.INSTANCE;case A.TokenType.LParen:{this.z();const Q=this.l();return this.A(A.TokenType.RParen,w),Q?.negate()}case A.TokenType.Str:return this.z(),L.create(D.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",D)}}return this.t()}t(){const D=this.D();switch(D.type){case A.TokenType.True:return this.z(),i.true();case A.TokenType.False:return this.z(),i.false();case A.TokenType.LParen:{this.z();const Q=this.l();return this.A(A.TokenType.RParen,w),Q}case A.TokenType.Str:{const Q=D.lexeme;if(this.z(),this.y(A.TokenType.RegexOp)){const Z=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Z.type!==A.TokenType.RegexStr)throw this.B("REGEX",Z);const Y=Z.lexeme,M=Y.lastIndexOf("/"),z=M===Y.length-1?void 0:this.w(Y.substring(M+1));let ie;try{ie=new RegExp(Y.substring(1,M),z)}catch{throw this.B("REGEX",Z)}return x.create(Q,ie)}switch(Z.type){case A.TokenType.RegexStr:case A.TokenType.Error:{const Y=[Z.lexeme];this.z();let M=this.D(),z=0;for(let be=0;be<Z.lexeme.length;be++)Z.lexeme.charCodeAt(be)===R.CharCode.OpenParen?z++:Z.lexeme.charCodeAt(be)===R.CharCode.CloseParen&&z--;for(;!this.E()&&M.type!==A.TokenType.And&&M.type!==A.TokenType.Or;){switch(M.type){case A.TokenType.LParen:z++;break;case A.TokenType.RParen:z--;break;case A.TokenType.RegexStr:case A.TokenType.QuotedStr:for(let be=0;be<M.lexeme.length;be++)M.lexeme.charCodeAt(be)===R.CharCode.OpenParen?z++:Z.lexeme.charCodeAt(be)===R.CharCode.CloseParen&&z--}if(z<0)break;Y.push(A.$Dj.getLexeme(M)),this.z(),M=this.D()}const ie=Y.join(""),ae=ie.lastIndexOf("/"),ue=ae===ie.length-1?void 0:this.w(ie.substring(ae+1));let pe;try{pe=new RegExp(ie.substring(1,ae),ue)}catch{throw this.B("REGEX",Z)}return i.regex(Q,pe)}case A.TokenType.QuotedStr:{const Y=Z.lexeme;this.z();let M=null;if(!(0,N.$ff)(Y)){const z=Y.indexOf("/"),ie=Y.lastIndexOf("/");if(z!==ie&&z>=0){const ae=Y.slice(z+1,ie),ue=Y[ie+1]==="i"?"i":"";try{M=new RegExp(ae,ue)}catch{throw this.B("REGEX",Z)}}}if(M===null)throw this.B("REGEX",Z);return x.create(Q,M)}default:throw this.B("REGEX",this.D())}}if(this.y(A.TokenType.Not)){this.A(A.TokenType.In,E);const Z=this.u();return i.notIn(Q,Z)}switch(this.D().type){case A.TokenType.Eq:{this.z();const Z=this.u();if(this.x().type===A.TokenType.QuotedStr)return i.equals(Q,Z);switch(Z){case"true":return i.has(Q);case"false":return i.not(Q);default:return i.equals(Q,Z)}}case A.TokenType.NotEq:{this.z();const Z=this.u();if(this.x().type===A.TokenType.QuotedStr)return i.notEquals(Q,Z);switch(Z){case"true":return i.not(Q);case"false":return i.has(Q);default:return i.notEquals(Q,Z)}}case A.TokenType.Lt:return this.z(),G.create(Q,this.u());case A.TokenType.LtEq:return this.z(),V.create(Q,this.u());case A.TokenType.Gt:return this.z(),j.create(Q,this.u());case A.TokenType.GtEq:return this.z(),F.create(Q,this.u());case A.TokenType.In:return this.z(),i.in(Q,this.u());default:return i.has(Q)}}case A.TokenType.EOF:throw this.h.push({message:m,offset:D.offset,lexeme:"",additionalInfo:c}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const D=this.D();switch(D.type){case A.TokenType.Str:case A.TokenType.QuotedStr:return this.z(),D.lexeme;case A.TokenType.True:return this.z(),"true";case A.TokenType.False:return this.z(),"false";case A.TokenType.In:return this.z(),"in";default:return""}}w(D){return D.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(D){return this.C(D)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(D,Q){if(this.C(D))return this.z();throw this.B(Q,this.D())}B(D,Q,oe){const Z=(0,k.localize)(1681,null,D,A.$Dj.getLexeme(Q)),Y=Q.offset,M=A.$Dj.getLexeme(Q);return this.h.push({message:Z,offset:Y,lexeme:M,additionalInfo:oe}),h.c}C(D){return this.D().type===D}D(){return this.f[this.g]}E(){return this.D().type===A.TokenType.EOF}}e.$Fj=h;class i{static false(){return r.INSTANCE}static true(){return o.INSTANCE}static has(D){return u.create(D)}static equals(D,Q){return b.create(D,Q)}static notEquals(D,Q){return v.create(D,Q)}static regex(D,Q){return x.create(D,Q)}static in(D,Q){return C.create(D,Q)}static notIn(D,Q){return S.create(D,Q)}static not(D){return L.create(D)}static and(...D){return B.create(D,null,!0)}static or(...D){return W.create(D,null,!0)}static greater(D,Q){return j.create(D,Q)}static greaterEquals(D,Q){return F.create(D,Q)}static smaller(D,Q){return G.create(D,Q)}static smallerEquals(D,Q){return V.create(D,Q)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(D){return D==null?void 0:this.c.parse(D)}}e.$Gj=i;function n(q){const D=new h({regexParsingWithErrorRecovery:!1});return q.map(Q=>(D.parse(Q),D.lexingErrors.length>0?D.lexingErrors.map(oe=>({errorMessage:oe.additionalInfo?(0,k.localize)(1682,null,oe.additionalInfo):(0,k.localize)(1683,null),offset:oe.offset,length:oe.lexeme.length})):D.parsingErrors.length>0?D.parsingErrors.map(oe=>({errorMessage:oe.additionalInfo?`${oe.message}. ${oe.additionalInfo}`:oe.message,offset:oe.offset,length:oe.lexeme.length})):[]))}function t(q,D){const Q=q?q.substituteConstants():void 0,oe=D?D.substituteConstants():void 0;return!Q&&!oe?!0:!Q||!oe?!1:Q.equals(oe)}function s(q,D){return q.cmp(D)}class r{static{this.INSTANCE=new r}constructor(){this.type=$.False}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return o.INSTANCE}}e.$Jj=r;class o{static{this.INSTANCE=new o}constructor(){this.type=$.True}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return r.INSTANCE}}e.$Kj=o;class u{static create(D,Q=null){const oe=y.get(D);return typeof oe=="boolean"?oe?o.INSTANCE:r.INSTANCE:new u(D,Q)}constructor(D,Q){this.key=D,this.c=Q,this.type=$.Defined}cmp(D){return D.type!==this.type?this.type-D.type:ne(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=y.get(this.key);return typeof D=="boolean"?D?o.INSTANCE:r.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.c||(this.c=L.create(this.key,this)),this.c}}e.$Lj=u;class b{static create(D,Q,oe=null){if(typeof Q=="boolean")return Q?u.create(D,oe):L.create(D,oe);const Z=y.get(D);return typeof Z=="boolean"?Q===(Z?"true":"false")?o.INSTANCE:r.INSTANCE:new b(D,Q,oe)}constructor(D,Q,oe){this.c=D,this.d=Q,this.f=oe,this.type=$.Equals}cmp(D){return D.type!==this.type?this.type-D.type:le(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){const D=y.get(this.c);if(typeof D=="boolean"){const Q=D?"true":"false";return this.d===Q?o.INSTANCE:r.INSTANCE}return this}evaluate(D){return D.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(D){return D.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Mj=b;class C{static create(D,Q){return new C(D,Q)}constructor(D,Q){this.d=D,this.f=Q,this.type=$.In,this.c=null}cmp(D){return D.type!==this.type?this.type-D.type:le(this.d,this.f,D.d,D.f)}equals(D){return D.type===this.type?this.d===D.d&&this.f===D.f:!1}substituteConstants(){return this}evaluate(D){const Q=D.getValue(this.f),oe=D.getValue(this.d);return Array.isArray(Q)?Q.includes(oe):typeof oe=="string"&&typeof Q=="object"&&Q!==null?p.call(Q,oe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(D){return D.mapIn(this.d,this.f)}negate(){return this.c||(this.c=S.create(this.d,this.f)),this.c}}e.$Nj=C;class S{static create(D,Q){return new S(D,Q)}constructor(D,Q){this.d=D,this.f=Q,this.type=$.NotIn,this.c=C.create(D,Q)}cmp(D){return D.type!==this.type?this.type-D.type:this.c.cmp(D.c)}equals(D){return D.type===this.type?this.c.equals(D.c):!1}substituteConstants(){return this}evaluate(D){return!this.c.evaluate(D)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(D){return D.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Oj=S;class v{static create(D,Q,oe=null){if(typeof Q=="boolean")return Q?L.create(D,oe):u.create(D,oe);const Z=y.get(D);return typeof Z=="boolean"?Q===(Z?"true":"false")?r.INSTANCE:o.INSTANCE:new v(D,Q,oe)}constructor(D,Q,oe){this.c=D,this.d=Q,this.f=oe,this.type=$.NotEquals}cmp(D){return D.type!==this.type?this.type-D.type:le(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){const D=y.get(this.c);if(typeof D=="boolean"){const Q=D?"true":"false";return this.d===Q?r.INSTANCE:o.INSTANCE}return this}evaluate(D){return D.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(D){return D.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.$Pj=v;class L{static create(D,Q=null){const oe=y.get(D);return typeof oe=="boolean"?oe?r.INSTANCE:o.INSTANCE:new L(D,Q)}constructor(D,Q){this.c=D,this.d=Q,this.type=$.Not}cmp(D){return D.type!==this.type?this.type-D.type:ne(this.c,D.c)}equals(D){return D.type===this.type?this.c===D.c:!1}substituteConstants(){const D=y.get(this.c);return typeof D=="boolean"?D?r.INSTANCE:o.INSTANCE:this}evaluate(D){return!D.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(D){return D.mapNot(this.c)}negate(){return this.d||(this.d=u.create(this.c,this)),this.d}}e.$Qj=L;function U(q,D){if(typeof q=="string"){const Q=parseFloat(q);isNaN(Q)||(q=Q)}return typeof q=="string"||typeof q=="number"?D(q):r.INSTANCE}class j{static create(D,Q,oe=null){return U(Q,Z=>new j(D,Z,oe))}constructor(D,Q,oe){this.c=D,this.d=Q,this.f=oe,this.type=$.Greater}cmp(D){return D.type!==this.type?this.type-D.type:le(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(D){return D.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Rj=j;class F{static create(D,Q,oe=null){return U(Q,Z=>new F(D,Z,oe))}constructor(D,Q,oe){this.c=D,this.d=Q,this.f=oe,this.type=$.GreaterEquals}cmp(D){return D.type!==this.type?this.type-D.type:le(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(D){return D.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$Sj=F;class G{static create(D,Q,oe=null){return U(Q,Z=>new G(D,Z,oe))}constructor(D,Q,oe){this.c=D,this.d=Q,this.f=oe,this.type=$.Smaller}cmp(D){return D.type!==this.type?this.type-D.type:le(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(D){return D.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Tj=G;class V{static create(D,Q,oe=null){return U(Q,Z=>new V(D,Z,oe))}constructor(D,Q,oe){this.c=D,this.d=Q,this.f=oe,this.type=$.SmallerEquals}cmp(D){return D.type!==this.type?this.type-D.type:le(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(D){return D.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Uj=V;class x{static create(D,Q){return new x(D,Q)}constructor(D,Q){this.d=D,this.f=Q,this.type=$.Regex,this.c=null}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.d<D.d)return-1;if(this.d>D.d)return 1;const Q=this.f?this.f.source:"",oe=D.f?D.f.source:"";return Q<oe?-1:Q>oe?1:0}equals(D){if(D.type===this.type){const Q=this.f?this.f.source:"",oe=D.f?D.f.source:"";return this.d===D.d&&Q===oe}return!1}substituteConstants(){return this}evaluate(D){const Q=D.getValue(this.d);return this.f?this.f.test(Q):!1}serialize(){const D=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${D}`}keys(){return[this.d]}map(D){return D.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=H.create(this)),this.c}}e.$Vj=x;class H{static create(D){return new H(D)}constructor(D){this.c=D,this.type=$.NotRegex}cmp(D){return D.type!==this.type?this.type-D.type:this.c.cmp(D.c)}equals(D){return D.type===this.type?this.c.equals(D.c):!1}substituteConstants(){return this}evaluate(D){return!this.c.evaluate(D)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(D){return new H(this.c.map(D))}negate(){return this.c}}e.$Wj=H;function te(q){let D=null;for(let Q=0,oe=q.length;Q<oe;Q++){const Z=q[Q].substituteConstants();if(q[Q]!==Z&&D===null){D=[];for(let Y=0;Y<Q;Y++)D[Y]=q[Y]}D!==null&&(D[Q]=Z)}return D===null?q:D}class B{static create(D,Q,oe){return B.d(D,Q,oe)}constructor(D,Q){this.expr=D,this.c=Q,this.type=$.And}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let Q=0,oe=this.expr.length;Q<oe;Q++){const Z=s(this.expr[Q],D.expr[Q]);if(Z!==0)return Z}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let Q=0,oe=this.expr.length;Q<oe;Q++)if(!this.expr[Q].equals(D.expr[Q]))return!1;return!0}return!1}substituteConstants(){const D=te(this.expr);return D===this.expr?this:B.create(D,this.c,!1)}evaluate(D){for(let Q=0,oe=this.expr.length;Q<oe;Q++)if(!this.expr[Q].evaluate(D))return!1;return!0}static d(D,Q,oe){const Z=[];let Y=!1;for(const M of D)if(M){if(M.type===$.True){Y=!0;continue}if(M.type===$.False)return r.INSTANCE;if(M.type===$.And){Z.push(...M.expr);continue}Z.push(M)}if(Z.length===0&&Y)return o.INSTANCE;if(Z.length!==0){if(Z.length===1)return Z[0];Z.sort(s);for(let M=1;M<Z.length;M++)Z[M-1].equals(Z[M])&&(Z.splice(M,1),M--);if(Z.length===1)return Z[0];for(;Z.length>1;){const M=Z[Z.length-1];if(M.type!==$.Or)break;Z.pop();const z=Z.pop(),ie=Z.length===0,ae=W.create(M.expr.map(ue=>B.create([ue,z],null,oe)),null,ie);ae&&(Z.push(ae),Z.sort(s))}if(Z.length===1)return Z[0];if(oe){for(let M=0;M<Z.length;M++)for(let z=M+1;z<Z.length;z++)if(Z[M].negate().equals(Z[z]))return r.INSTANCE;if(Z.length===1)return Z[0]}return new B(Z,Q)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(const Q of this.expr)D.push(...Q.keys());return D}map(D){return new B(this.expr.map(Q=>Q.map(D)),null)}negate(){if(!this.c){const D=[];for(const Q of this.expr)D.push(Q.negate());this.c=W.create(D,this,!0)}return this.c}}e.$Xj=B;class W{static create(D,Q,oe){return W.d(D,Q,oe)}constructor(D,Q){this.expr=D,this.c=Q,this.type=$.Or}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let Q=0,oe=this.expr.length;Q<oe;Q++){const Z=s(this.expr[Q],D.expr[Q]);if(Z!==0)return Z}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let Q=0,oe=this.expr.length;Q<oe;Q++)if(!this.expr[Q].equals(D.expr[Q]))return!1;return!0}return!1}substituteConstants(){const D=te(this.expr);return D===this.expr?this:W.create(D,this.c,!1)}evaluate(D){for(let Q=0,oe=this.expr.length;Q<oe;Q++)if(this.expr[Q].evaluate(D))return!0;return!1}static d(D,Q,oe){let Z=[],Y=!1;if(D){for(let M=0,z=D.length;M<z;M++){const ie=D[M];if(ie){if(ie.type===$.False){Y=!0;continue}if(ie.type===$.True)return o.INSTANCE;if(ie.type===$.Or){Z=Z.concat(ie.expr);continue}Z.push(ie)}}if(Z.length===0&&Y)return r.INSTANCE;Z.sort(s)}if(Z.length!==0){if(Z.length===1)return Z[0];for(let M=1;M<Z.length;M++)Z[M-1].equals(Z[M])&&(Z.splice(M,1),M--);if(Z.length===1)return Z[0];if(oe){for(let M=0;M<Z.length;M++)for(let z=M+1;z<Z.length;z++)if(Z[M].negate().equals(Z[z]))return o.INSTANCE;if(Z.length===1)return Z[0]}return new W(Z,Q)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(const Q of this.expr)D.push(...Q.keys());return D}map(D){return new W(this.expr.map(Q=>Q.map(D)),null)}negate(){if(!this.c){const D=[];for(const Q of this.expr)D.push(Q.negate());for(;D.length>1;){const Q=D.shift(),oe=D.shift(),Z=[];for(const Y of K(Q))for(const M of K(oe))Z.push(B.create([Y,M],null,!1));D.unshift(W.create(Z,null,!1))}this.c=W.create(D,this,!0)}return this.c}}e.$Yj=W;class _ extends u{static{this.d=[]}static all(){return _.d.values()}constructor(D,Q,oe){super(D,null),this.f=Q,typeof oe=="object"?_.d.push({...oe,key:D}):oe!==!0&&_.d.push({key:D,description:oe,type:Q!=null?typeof Q:void 0})}bindTo(D){return D.createKey(this.key,this.f)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return b.create(this.key,D)}notEqualsTo(D){return v.create(this.key,D)}}e.$Zj=_,e.$1j=(0,T.$Ii)("contextKeyService");function ne(q,D){return q<D?-1:q>D?1:0}function le(q,D,Q,oe){return q<Q?-1:q>Q?1:D<oe?-1:D>oe?1:0}function ee(q,D){if(q.type===$.False||D.type===$.True)return!0;if(q.type===$.Or)return D.type===$.Or?J(q.expr,D.expr):!1;if(D.type===$.Or){for(const Q of D.expr)if(ee(q,Q))return!0;return!1}if(q.type===$.And){if(D.type===$.And)return J(D.expr,q.expr);for(const Q of q.expr)if(ee(Q,D))return!0;return!1}return q.equals(D)}function J(q,D){let Q=0,oe=0;for(;Q<q.length&&oe<D.length;){const Z=q[Q].cmp(D[oe]);if(Z<0)return!1;Z===0&&Q++,oe++}return Q===q.length}function K(q){return q.type===$.Or?q.expr:[q]}}),define(fe[99],de([0,1,4]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=e.$Wm=e.ID=void 0,e.$Xm=a,e.ID="diagnosticsService",e.$Wm=(0,R.$Ii)(e.ID);function a(A){return!!A.hostName&&!!A.errorMessage}class N{async getPerformanceInfo(T,k){return{}}async getSystemInfo(T,k){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(T,k){return""}async getWorkspaceFileExtensions(T){return{extensions:[]}}async reportWorkspaceStats(T){}}e.$Ym=N}),define(fe[100],de([0,1,4]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6o=void 0,e.$6o=(0,R.$Ii)("downloadService")}),define(fe[15],de([0,1,4]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=void 0,e.$Pi=(0,R.$Ii)("environmentService"),e.$Qi=(0,R.$Ji)(e.$Pi)}),define(fe[75],de([0,1,4]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s8b=e.RecommendationsNotificationResult=e.RecommendationSource=void 0,e.$r8b=N;var a;(function(T){T[T.FILE=1]="FILE",T[T.WORKSPACE=2]="WORKSPACE",T[T.EXE=3]="EXE"})(a||(e.RecommendationSource=a={}));function N(T){switch(T){case a.FILE:return"file";case a.WORKSPACE:return"workspace";case a.EXE:return"exe"}}var A;(function(T){T.Ignored="ignored",T.Cancelled="cancelled",T.TooMany="toomany",T.IncompatibleWindow="incompatibleWindow",T.Accepted="reacted"})(A||(e.RecommendationsNotificationResult=A={})),e.$s8b=(0,R.$Ii)("IExtensionRecommendationNotificationService")}),define(fe[7],de([0,1,51,13,26,12,9,11,4,5,22,53]),function(ce,e,R,a,N,A,T,k,O,y,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=e.$Il=e.FileKind=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=e.$Cl=e.$Bl=e.FileOperationResult=e.$Al=e.$zl=e.$yl=e.$wl=e.FileChangeType=e.$vl=e.FileOperation=e.$pl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$dl=void 0,e.$el=$,e.$fl=E,e.$gl=f,e.$hl=P,e.$il=m,e.$jl=c,e.$kl=h,e.$ll=i,e.$ml=n,e.$nl=t,e.$ol=s,e.$ql=u,e.$rl=b,e.$sl=C,e.$tl=S,e.$ul=v,e.$xl=G,e.$Jl=W,e.$Kl=_,e.$Ml=le,e.$dl=(0,O.$Ii)("fileService");function $(ee){return ee.create===!0}var g;(function(ee){ee[ee.Unknown=0]="Unknown",ee[ee.File=1]="File",ee[ee.Directory=2]="Directory",ee[ee.SymbolicLink=64]="SymbolicLink"})(g||(e.FileType=g={}));var l;(function(ee){ee[ee.Readonly=1]="Readonly",ee[ee.Locked=2]="Locked"})(l||(e.FilePermission=l={}));var d;(function(ee){ee[ee.UPDATED=2]="UPDATED",ee[ee.ADDED=4]="ADDED",ee[ee.DELETED=8]="DELETED"})(d||(e.FileChangeFilter=d={}));function E(ee){const J=ee;return!!J&&typeof J.onDidChange=="function"}var w;(function(ee){ee[ee.None=0]="None",ee[ee.FileReadWrite=2]="FileReadWrite",ee[ee.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ee[ee.FileReadStream=16]="FileReadStream",ee[ee.FileFolderCopy=8]="FileFolderCopy",ee[ee.PathCaseSensitive=1024]="PathCaseSensitive",ee[ee.Readonly=2048]="Readonly",ee[ee.Trash=4096]="Trash",ee[ee.FileWriteUnlock=8192]="FileWriteUnlock",ee[ee.FileAtomicRead=16384]="FileAtomicRead",ee[ee.FileAtomicWrite=32768]="FileAtomicWrite",ee[ee.FileAtomicDelete=65536]="FileAtomicDelete",ee[ee.FileClone=131072]="FileClone"})(w||(e.FileSystemProviderCapabilities=w={}));function f(ee){return!!(ee.capabilities&w.FileReadWrite)}function P(ee){return!!(ee.capabilities&w.FileFolderCopy)}function m(ee){return!!(ee.capabilities&w.FileClone)}function c(ee){return!!(ee.capabilities&w.FileOpenReadWriteClose)}function h(ee){return!!(ee.capabilities&w.FileReadStream)}function i(ee){return f(ee)?!!(ee.capabilities&w.FileAtomicRead):!1}function n(ee){return f(ee)?!!(ee.capabilities&w.FileAtomicWrite):!1}function t(ee){return!!(ee.capabilities&w.FileAtomicDelete)}function s(ee){return!!(ee.capabilities&w.Readonly)}var r;(function(ee){ee.FileExists="EntryExists",ee.FileNotFound="EntryNotFound",ee.FileNotADirectory="EntryNotADirectory",ee.FileIsADirectory="EntryIsADirectory",ee.FileExceedsStorageQuota="EntryExceedsStorageQuota",ee.FileTooLarge="EntryTooLarge",ee.FileWriteLocked="EntryWriteLocked",ee.NoPermissions="NoPermissions",ee.Unavailable="Unavailable",ee.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class o extends Error{static create(J,K){const q=new o(J.toString(),K);return C(q,K),q}constructor(J,K){super(J),this.code=K}}e.$pl=o;function u(ee,J){return o.create(ee,J)}function b(ee){return ee||u((0,k.localize)(1865,null),r.Unknown)}function C(ee,J){return ee.name=J?`${J} (FileSystemError)`:"FileSystemError",ee}function S(ee){if(!ee)return r.Unknown;if(ee instanceof o)return ee.code;const J=/^(.+) \(FileSystemError\)$/.exec(ee.name);if(!J)return r.Unknown;switch(J[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}function v(ee){if(ee instanceof V)return ee.fileOperationResult;switch(S(ee)){case r.FileNotFound:return te.FILE_NOT_FOUND;case r.FileIsADirectory:return te.FILE_IS_DIRECTORY;case r.FileNotADirectory:return te.FILE_NOT_DIRECTORY;case r.FileWriteLocked:return te.FILE_WRITE_LOCKED;case r.NoPermissions:return te.FILE_PERMISSION_DENIED;case r.FileExists:return te.FILE_MOVE_CONFLICT;case r.FileTooLarge:return te.FILE_TOO_LARGE;default:return te.FILE_OTHER_ERROR}}var L;(function(ee){ee[ee.CREATE=0]="CREATE",ee[ee.DELETE=1]="DELETE",ee[ee.MOVE=2]="MOVE",ee[ee.COPY=3]="COPY",ee[ee.WRITE=4]="WRITE"})(L||(e.FileOperation=L={}));class U{constructor(J,K,q){this.resource=J,this.operation=K,this.target=q}isOperation(J){return this.operation===J}}e.$vl=U;var j;(function(ee){ee[ee.UPDATED=0]="UPDATED",ee[ee.ADDED=1]="ADDED",ee[ee.DELETED=2]="DELETED"})(j||(e.FileChangeType=j={}));class F{static{this.a=null}constructor(J,K){this.c=K,this.b=void 0,this.d=new p.$W(()=>{const q=R.$Oi.forUris(()=>this.c);return q.fill(this.rawAdded.map(D=>[D,!0])),q}),this.f=new p.$W(()=>{const q=R.$Oi.forUris(()=>this.c);return q.fill(this.rawUpdated.map(D=>[D,!0])),q}),this.g=new p.$W(()=>{const q=R.$Oi.forUris(()=>this.c);return q.fill(this.rawDeleted.map(D=>[D,!0])),q}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const q of J){switch(q.type){case j.ADDED:this.rawAdded.push(q.resource);break;case j.UPDATED:this.rawUpdated.push(q.resource);break;case j.DELETED:this.rawDeleted.push(q.resource);break}this.b!==F.a&&(typeof q.cId=="number"?this.b===void 0?this.b=q.cId:this.b!==q.cId&&(this.b=F.a):this.b!==void 0&&(this.b=F.a))}}contains(J,...K){return this.h(J,{includeChildren:!1},...K)}affects(J,...K){return this.h(J,{includeChildren:!0},...K)}h(J,K,...q){if(!J)return!1;const D=q.length>0;return!!((!D||q.includes(j.ADDED))&&(this.d.value.get(J)||K.includeChildren&&this.d.value.findSuperstr(J))||(!D||q.includes(j.UPDATED))&&(this.f.value.get(J)||K.includeChildren&&this.f.value.findSuperstr(J))||(!D||q.includes(j.DELETED))&&(this.g.value.findSubstr(J)||K.includeChildren&&this.g.value.findSuperstr(J)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(J){return this.b===J}hasCorrelation(){return typeof this.b=="number"}}e.$wl=F;function G(ee,J,K){return!ee||!J||ee===J||J.length>ee.length?!1:(J.charAt(J.length-1)!==a.sep&&(J+=a.sep),K?(0,N.$Jf)(ee,J):ee.indexOf(J)===0)}class V extends Error{constructor(J,K,q){super(J),this.fileOperationResult=K,this.options=q}}e.$yl=V;class x extends V{constructor(J,K,q,D){super(J,K,D),this.fileOperationResult=K,this.size=q}}e.$zl=x;class H extends V{constructor(J,K,q){super(J,te.FILE_NOT_MODIFIED_SINCE,q),this.stat=K}}e.$Al=H;var te;(function(ee){ee[ee.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ee[ee.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ee[ee.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ee[ee.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ee[ee.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ee[ee.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ee[ee.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ee[ee.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ee[ee.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ee[ee.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ee[ee.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(te||(e.FileOperationResult=te={})),e.$Bl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Cl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Dl="files.associations",e.$El="files.exclude",e.$Fl="files.readonlyInclude",e.$Gl="files.readonlyExclude",e.$Hl="files.readonlyFromPermissions";var B;(function(ee){ee[ee.FILE=0]="FILE",ee[ee.FOLDER=1]="FOLDER",ee[ee.ROOT_FOLDER=2]="ROOT_FOLDER"})(B||(e.FileKind=B={})),e.$Il="";function W(ee){if(!(typeof ee.size!="number"||typeof ee.mtime!="number"))return ee.mtime.toString(29)+ee.size.toString(31)}async function _(ee,J){if(!J.hasProvider(T.URI.from({scheme:ee.scheme})))return new Promise(K=>{const q=J.onDidChangeFileSystemProviderRegistrations(D=>{D.scheme===ee.scheme&&D.added&&(q.dispose(),K())})})}class ne{static{this.KB=1024}static{this.MB=ne.KB*ne.KB}static{this.GB=ne.MB*ne.KB}static{this.TB=ne.GB*ne.KB}static formatSize(J){return(0,A.$lg)(J)||(J=0),J<ne.KB?(0,k.localize)(1866,null,J.toFixed(0)):J<ne.MB?(0,k.localize)(1867,null,(J/ne.KB).toFixed(2)):J<ne.GB?(0,k.localize)(1868,null,(J/ne.MB).toFixed(2)):J<ne.TB?(0,k.localize)(1869,null,(J/ne.GB).toFixed(2)):(0,k.localize)(1870,null,(J/ne.TB).toFixed(2))}}e.$Ll=ne;function le(ee){const J=typeof ee=="string"||ee?.scheme===I.Schemas.vscodeRemote;return typeof ee!="string"&&ee?.scheme===I.Schemas.file?1024*ne.MB:J?10*ne.MB:y.$p?50*ne.MB:1024*ne.MB}});var X=this&&this.__param||function(ce,e){return function(R,a){e(R,a,ce)}};define(fe[164],de([0,1,76,50,7]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ljc=void 0;let A=class{constructor(k){this.a=k}async checksum(k){const O=(await this.a.readFileStream(k)).value;return new Promise((y,I)=>{const p=(0,R.createHash)("sha256");(0,a.$Ie)(O,{onData:$=>p.update($.buffer),onError:$=>I($),onEnd:()=>y(p.digest("base64").replace(/=+$/,""))})})}};e.$ljc=A,e.$ljc=A=Ee([X(0,N.$dl)],A)}),define(fe[101],de([0,1,14,8,11,7]),function(ce,e,R,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=T;async function T(I,p,$,g,l,d){let E;try{await k(I,p,$,g,l,d)}catch(w){E=w}finally{E&&l.errorTransformer&&(E=l.errorTransformer(E)),typeof E<"u"&&$.error(E),$.end()}}async function k(I,p,$,g,l,d){O(d);const E=await I.open(p,{create:!1});try{O(d);let w=0,f=0,P=l&&typeof l.length=="number"?l.length:void 0,m=R.$Qe.alloc(Math.min(l.bufferSize,typeof P=="number"?P:l.bufferSize)),c=l&&typeof l.position=="number"?l.position:0,h=0;do f=await I.read(E,c,m.buffer,h,m.byteLength-h),c+=f,h+=f,w+=f,typeof P=="number"&&(P-=f),h===m.byteLength&&(await $.write(g(m)),m=R.$Qe.alloc(Math.min(l.bufferSize,typeof P=="number"?P:l.bufferSize)),h=0);while(f>0&&(typeof P!="number"||P>0)&&O(d)&&y(w,l));if(h>0){let i=h;typeof P=="number"&&(i=Math.min(h,P)),$.write(g(m.slice(0,i)))}}catch(w){throw(0,A.$rl)(w)}finally{await I.close(E)}}function O(I){if(I.isCancellationRequested)throw(0,a.$8)();return!0}function y(I,p){if(typeof p?.limits?.size=="number"&&I>p.limits.size)throw(0,A.$ql)((0,N.localize)(1898,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(fe[46],de([0,1,95,2,13,5,9,7]),function(ce,e,R,a,N,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=e.$ar=e.$_q=void 0,e.$0q=O,e.$$q=y,e.$cr=g,e.$dr=l,e.$er=d,e.$fr=E,e.$gr=f,e.$hr=P;function O(m){return typeof m.correlationId=="number"}function y(m){return m.recursive===!0}class I extends a.$Xc{static{this.a=5}constructor(c,h,i,n){super(),this.h=c,this.j=h,this.m=i,this.n=n,this.c=this.B(new a.$Yc),this.f=void 0,this.g=0}s(){const c=new a.$Wc;this.c.value=c,this.b=this.r(c),this.b.setVerboseLogging(this.m),c.add(this.b.onDidChangeFile(h=>this.h(h))),c.add(this.b.onDidLogMessage(h=>this.j(h))),c.add(this.b.onDidError(h=>this.t(h.error,h.request)))}t(c,h){this.u(c,h)?this.g<I.a&&this.f?(this.y(`restarting watcher after unexpected error: ${c}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${c}`):this.y(c)}u(c,h){return!(!this.n.restartOnError||h||c.indexOf("No space left on device")!==-1||c.indexOf("EMFILE")!==-1)}w(c){this.g++,this.s(),this.watch(c)}async watch(c){this.f=c,await this.b?.watch(c)}async setVerboseLogging(c){this.m=c,await this.b?.setVerboseLogging(c)}y(c){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${c}`})}z(c){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${c}`})}dispose(){return this.b=void 0,super.dispose()}}e.$_q=I;class p extends I{constructor(c,h,i){super(c,h,i,{type:"node.js",restartOnError:!1})}}e.$ar=p;class $ extends I{constructor(c,h,i){super(c,h,i,{type:"universal",restartOnError:!0})}}e.$br=$;function g(m){return m.map(c=>({type:c.type,resource:T.URI.revive(c.resource),cId:c.cId}))}function l(m){const c=new w;for(const h of m)c.processEvent(h);return c.coalesce()}function d(m,c){return typeof c=="string"&&!c.startsWith(R.$zk)&&!(0,N.$lc)(c)?{base:m,pattern:c}:c}function E(m,c){const h=[];for(const i of c)h.push((0,R.$Dk)(d(m,i)));return h}class w{constructor(){this.a=new Set,this.b=new Map}c(c){return A.$l?c.resource.fsPath:c.resource.fsPath.toLowerCase()}processEvent(c){const h=this.b.get(this.c(c));let i=!1;if(h){const n=h.type,t=c.type;h.resource.fsPath!==c.resource.fsPath&&(c.type===k.FileChangeType.DELETED||c.type===k.FileChangeType.ADDED)?i=!0:n===k.FileChangeType.ADDED&&t===k.FileChangeType.DELETED?(this.b.delete(this.c(c)),this.a.delete(h)):n===k.FileChangeType.DELETED&&t===k.FileChangeType.ADDED?h.type=k.FileChangeType.UPDATED:n===k.FileChangeType.ADDED&&t===k.FileChangeType.UPDATED||(h.type=t)}else i=!0;i&&(this.a.add(c),this.b.set(this.c(c),c))}coalesce(){const c=[],h=[];return Array.from(this.a).filter(i=>i.type!==k.FileChangeType.DELETED?(c.push(i),!1):!0).sort((i,n)=>i.resource.fsPath.length-n.resource.fsPath.length).filter(i=>h.some(n=>(0,k.$xl)(i.resource.fsPath,n,!A.$l))?!1:(h.push(i.resource.fsPath),!0)).concat(c)}}function f(m,c){if(typeof c=="number")switch(m.type){case k.FileChangeType.ADDED:return(c&k.FileChangeFilter.ADDED)===0;case k.FileChangeType.DELETED:return(c&k.FileChangeFilter.DELETED)===0;case k.FileChangeType.UPDATED:return(c&k.FileChangeFilter.UPDATED)===0}return!1}function P(m){if(typeof m=="number"){const c=[];return m&k.FileChangeFilter.ADDED&&c.push("Added"),m&k.FileChangeFilter.DELETED&&c.push("Deleted"),m&k.FileChangeFilter.UPDATED&&c.push("Updated"),c.length===0?"<all>":`[${c.join(", ")}]`}return"<none>"}}),define(fe[165],de([0,1,14,43,8,3,2,50,32,7,46]),function(ce,e,R,a,N,A,T,k,O,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MR=e.$LR=void 0,e.$LR="localFilesystem";class p extends T.$Xc{constructor(g,l){super(),this.a=g,this.b=l,this.onDidChangeCapabilities=A.Event.None,this.f=this.B(new A.$oe),this.onDidChangeFile=this.f.event,this.g=this.B(new A.$oe),this.onDidWatchError=this.g.event,this.h=(0,O.$5g)(),this.j()}get capabilities(){return this.c||(this.c=y.FileSystemProviderCapabilities.FileReadWrite|y.FileSystemProviderCapabilities.FileOpenReadWriteClose|y.FileSystemProviderCapabilities.FileReadStream|y.FileSystemProviderCapabilities.FileFolderCopy|y.FileSystemProviderCapabilities.FileWriteUnlock|y.FileSystemProviderCapabilities.FileAtomicRead|y.FileSystemProviderCapabilities.FileAtomicWrite|y.FileSystemProviderCapabilities.FileAtomicDelete|y.FileSystemProviderCapabilities.FileClone,this.b.pathCaseSensitive&&(this.c|=y.FileSystemProviderCapabilities.PathCaseSensitive),this.b.trash&&(this.c|=y.FileSystemProviderCapabilities.Trash)),this.c}stat(g){return this.a.call("stat",[g])}readdir(g){return this.a.call("readdir",[g])}async readFile(g,l){const{buffer:d}=await this.a.call("readFile",[g,l]);return d}readFileStream(g,l,d){const E=(0,k.$Ee)(f=>R.$Qe.concat(f.map(P=>R.$Qe.wrap(P))).buffer),w=new T.$Wc;return w.add(this.a.listen("readFileStream",[g,l])(f=>{if(f instanceof R.$Qe)E.write(f.buffer);else{if(f==="end")E.end();else{let P;if(f instanceof Error)P=f;else{const m=f;P=(0,y.$ql)(m.message??(0,a.$tj)(m),m.code??y.FileSystemProviderErrorCode.Unknown)}E.error(P),E.end()}w.dispose()}})),w.add(d.onCancellationRequested(()=>{E.error((0,N.$8)()),E.end(),w.dispose()})),E}writeFile(g,l,d){return this.a.call("writeFile",[g,R.$Qe.wrap(l),d])}open(g,l){return this.a.call("open",[g,l])}close(g){return this.a.call("close",[g])}async read(g,l,d,E,w){const[f,P]=await this.a.call("read",[g,l,w]);return d.set(f.buffer.slice(0,P),E),P}write(g,l,d,E,w){return this.a.call("write",[g,l,R.$Qe.wrap(d),E,w])}mkdir(g){return this.a.call("mkdir",[g])}delete(g,l){return this.a.call("delete",[g,l])}rename(g,l,d){return this.a.call("rename",[g,l,d])}copy(g,l,d){return this.a.call("copy",[g,l,d])}cloneFile(g,l){return this.a.call("cloneFile",[g,l])}j(){this.B(this.a.listen("fileChange",[this.h])(g=>{if(Array.isArray(g)){const l=g;this.f.fire((0,I.$cr)(l))}else{const l=g;this.g.fire(l)}}))}watch(g,l){const d=(0,O.$5g)();return this.a.call("watch",[this.h,d,g,l]),(0,T.$Vc)(()=>this.a.call("unwatch",[this.h,d]))}}e.$MR=p}),define(fe[166],de([0,1,33,2,46,3,7,9,6]),function(ce,e,R,a,N,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;class y extends a.$Xc{constructor(){super(),this.a=this.B(new A.$oe),this.onDidChangeFile=this.a.event,this.b=this.B(new A.$oe),this.onDidLogMessage=this.b.event,this.c=this.B(new A.$oe),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new a.$7c),this.m=new Set,this.n=this.B(new O.$Gh(this.y())),this.r=5007,this.s=new O.$6h,this.R=!1,this.B(this.f(p=>this.t(p)))}t(p){this.u(p)&&this.z(p)}u(p){return(0,N.$0q)(p)}async watch(p){this.s.isSettled||this.s.complete(),this.s=new O.$6h;try{this.h.clear(),this.g.clear();for(const $ of p)this.u($)?this.h.set($.correlationId,$):this.g.add($);for(const[$]of this.j)this.h.has($)||(this.j.deleteAndDispose($),this.m.delete($));return await this.w(!1)}finally{this.s.complete()}}w(p){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter($=>!this.j.has($.correlationId))]),p?this.y():0)}y(){return 800}isSuspended(p){return typeof p.correlationId!="number"?!1:this.m.has(p.correlationId)?"polling":this.j.has(p.correlationId)}async z(p){if(this.j.has(p.correlationId))return;const $=new a.$Wc;this.j.set(p.correlationId,$),await this.s.p,!$.isDisposed&&(this.D(p,$),this.w(!0))}C(p){this.j.deleteAndDispose(p.correlationId),this.m.delete(p.correlationId),this.w(!1)}D(p,$){this.F(p,$)?(this.P(`reusing an existing recursive watcher to monitor ${p.path}`),this.m.delete(p.correlationId)):(this.G(p,$),this.m.add(p.correlationId))}F(p,$){const g=this.O?.subscribe(p.path,(l,d)=>{$.isDisposed||(l?this.D(p,$):d?.type===T.FileChangeType.ADDED&&this.H(p))});return g?($.add(g),!0):!1}G(p,$){let g=!1;const l=(d,E)=>{if($.isDisposed)return;const w=this.I(d),f=this.I(E),P=g;g=w,!w&&(f||P)&&this.H(p)};this.P(`starting fs.watchFile() on ${p.path} (correlationId: ${p.correlationId})`);try{(0,R.watchFile)(p.path,{persistent:!1,interval:this.r},l)}catch(d){this.Q(`fs.watchFile() failed with error ${d} on path ${p.path} (correlationId: ${p.correlationId})`)}$.add((0,a.$Vc)(()=>{this.P(`stopping fs.watchFile() on ${p.path} (correlationId: ${p.correlationId})`);try{(0,R.unwatchFile)(p.path,l)}catch(d){this.Q(`fs.unwatchFile() failed with error ${d} on path ${p.path} (correlationId: ${p.correlationId})`)}}))}H(p){this.P(`detected ${p.path} exists again, resuming watcher (correlationId: ${p.correlationId})`);const $={resource:k.URI.file(p.path),type:T.FileChangeType.ADDED,cId:p.correlationId};this.a.fire([$]),this.J($,p),this.C(p)}I(p){return p.ctimeMs===0&&p.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(p,$){if(this.R){const g=` >> normalized ${p.type===T.FileChangeType.ADDED?"[ADDED]":p.type===T.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${p.resource.fsPath}`;this.L(g,$)}}L(p,$){this.R&&this.P(`${p}${typeof $.correlationId=="number"?` <${$.correlationId}> `:""}`)}M(p){return`${p.path} (excludes: ${p.excludes.length>0?p.excludes:"<none>"}, includes: ${p.includes&&p.includes.length>0?JSON.stringify(p.includes):"<all>"}, filter: ${(0,N.$hr)(p.filter)}, correlationId: ${typeof p.correlationId=="number"?p.correlationId:"<none>"})`}async setVerboseLogging(p){this.R=p}}e.$qr=y}),define(fe[167],de([0,1,33,6,25,41,2,92,13,5,20,9,146,30,7,46]),function(ce,e,R,a,N,A,T,k,O,y,I,p,$,g,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=void 0,e.$wr=w;class E extends T.$Xc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(P,m,c,h,i,n){super(),this.s=P,this.t=m,this.u=c,this.w=h,this.y=i,this.z=n,this.c=this.B(new a.$Xh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.u(t))),this.f=this.B(new a.$Wh(t=>this.M(t),E.b)),this.g=(0,d.$fr)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,d.$fr)(this.s.path,this.s.includes):void 0,this.j=(0,d.$0q)(this.s)?this.s.filter:void 0,this.m=new N.$ze,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const P=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const m=await R.promises.stat(P);if(this.m.token.isCancellationRequested)return;this.B(await this.G(P,m.isDirectory()))}catch(P){P.code!=="ENOENT"?this.O(P):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${P})`),this.D()}}D(){this.r=!0,this.w?.()}async F(P){let m=P.path;try{m=await g.Promises.realpath(P.path),P.path===m&&(m=await(0,$.$sr)(P.path,this.m.token)??P.path),P.path!==m&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${P.path}, real: ${m})`)}catch{}return m}async G(P,m){const c=new T.$Wc;return this.H(P,m,c)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(P,m,c)),c}H(P,m,c){if(m)return!1;const h=p.URI.file(this.s.path),i=this.t?.subscribe(this.s.path,async(n,t)=>{if(!c.isDisposed)if(n){const s=await this.G(P,m);c.isDisposed?s.dispose():c.add(s)}else t&&(typeof t.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:h,type:t.type,cId:this.s.correlationId},!0)});return i?(c.add(i),!0):!1}async I(P,m,c){if(y.$k&&(0,A.$Hg)(P,"/Volumes/",!0)){this.O(`Refusing to watch ${P} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const h=new N.$ze(this.m.token);c.add((0,T.$Vc)(()=>h.dispose(!0)));const i=new T.$Wc;c.add(i);try{const n=p.URI.file(this.s.path),t=(0,O.$qc)(P),s=(0,R.watch)(P);i.add((0,T.$Vc)(()=>{s.removeAllListeners(),s.close()})),this.Q(`Started watching: '${P}'`);const r=new Set;if(m)try{for(const u of await g.Promises.readdir(P))r.add(u)}catch(u){this.O(u)}if(h.token.isCancellationRequested)return;const o=new Map;i.add((0,T.$Vc)(()=>{for(const[,u]of o)u.dispose();o.clear()})),s.on("error",(u,b)=>{h.token.isCancellationRequested||(this.O(`Failed to watch ${P} for changes using fs.watch() (${u}, ${b})`),this.D())}),s.on("change",(u,b)=>{if(h.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${u}"] ${b}`);let C="";if(b&&(C=b.toString(),y.$k&&(C=(0,k.$qm)(C))),!(!C||u!=="change"&&u!=="rename"))if(m)if(u==="rename"){o.get(C)?.dispose();const S=setTimeout(async()=>{if(o.delete(C),C===t&&!await g.Promises.exists(P)){this.J(n);return}if(h.token.isCancellationRequested)return;const v=await this.N((0,O.$mc)(P,C));if(h.token.isCancellationRequested)return;let L;v?r.has(C)?L=l.FileChangeType.UPDATED:(L=l.FileChangeType.ADDED,r.add(C)):(r.delete(C),L=l.FileChangeType.DELETED),this.L({resource:(0,I.$jh)(n,C),type:L,cId:this.s.correlationId})},E.a);o.set(C,(0,T.$Vc)(()=>clearTimeout(S)))}else{let S;r.has(C)?S=l.FileChangeType.UPDATED:(S=l.FileChangeType.ADDED,r.add(C)),this.L({resource:(0,I.$jh)(n,C),type:S,cId:this.s.correlationId})}else if(u==="rename"||C!==t){const S=setTimeout(async()=>{const v=await g.Promises.exists(P);h.token.isCancellationRequested||(v?(this.L({resource:n,type:l.FileChangeType.UPDATED,cId:this.s.correlationId},!0),i.add(await this.G(P,!1))):this.J(n))},E.a);i.clear(),i.add((0,T.$Vc)(()=>clearTimeout(S)))}else this.L({resource:n,type:l.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(n){h.token.isCancellationRequested||this.O(`Failed to watch ${P} for changes using fs.watch() (${n.toString()})`),this.D()}}J(P){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:P,type:l.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(P,m=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${P.type===l.FileChangeType.ADDED?"[ADDED]":P.type===l.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${P.resource.fsPath}`),!m&&this.g.some(c=>c(P.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${P.resource.fsPath}`):!m&&this.h&&this.h.length>0&&!this.h.some(c=>c(P.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${P.resource.fsPath}`):this.f.work(P))}M(P){const m=(0,d.$dr)(P),c=[];for(const i of m){if((0,d.$gr)(i,this.j)){this.z&&this.R(` >> ignored (filtered) ${i.resource.fsPath}`);continue}c.push(i)}if(c.length===0)return;if(this.z)for(const i of c)this.R(` >> normalized ${i.type===l.FileChangeType.ADDED?"[ADDED]":i.type===l.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`);this.c.work(c)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${c[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${c.length}, most recent change: ${c[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(P){if(y.$l)return g.Promises.exists(P);try{const m=(0,O.$qc)(P);return(await g.Promises.readdir((0,O.$pc)(P))).some(h=>h===m)}catch(m){return this.Q(m),!1}}setVerboseLogging(P){this.z=P}O(P){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${P}`})}P(P){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${P}`})}Q(P){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${P}`})}R(P){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${P}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$vr=E;async function w(f,P,m,c,h=512){const i=await g.Promises.open(f,"r"),n=Buffer.allocUnsafe(h),t=new N.$ze(c);let s,r=!1;const o={path:f,excludes:[],recursive:!1},u=new E(o,void 0,b=>{(async()=>{for(const{type:C}of b)if(C===l.FileChangeType.UPDATED){if(r)return;r=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:S}=await g.Promises.read(i,n,0,h,null);if(!S||t.token.isCancellationRequested)break;P(n.slice(0,S))}}catch(S){s=new Error(S),t.dispose(!0)}finally{r=!1}}})()});return await u.ready,m(),new Promise((b,C)=>{t.token.onCancellationRequested(async()=>{u.dispose();try{await g.Promises.close(i)}catch(S){s=new Error(S)}s?C(s):b()})})}}),define(fe[168],de([0,1,3,95,166,5,167,41]),function(ce,e,R,a,N,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=void 0;class O extends N.$qr{constructor(I){super(),this.O=I,this.onDidError=R.Event.None,this.watchers=new Set}async N(I){I=this.Z(I);const p=[],$=new Set(Array.from(this.watchers));for(const g of I){const l=this.W(g);l&&(0,a.$Hk)(l.request.excludes,g.excludes)&&(0,a.$Hk)(l.request.includes,g.includes)?$.delete(l):p.push(g)}p.length&&this.P(`Request to start watching: ${p.map(g=>this.M(g)).join(",")}`),$.size&&this.P(`Request to stop watching: ${Array.from($).map(g=>this.M(g.request)).join(",")}`);for(const g of $)this.Y(g);for(const g of p)this.X(g)}W(I){for(const p of this.watchers)if(typeof I.correlationId=="number"||typeof p.request.correlationId=="number"){if(p.request.correlationId===I.correlationId)return p}else if((0,k.$Gg)(p.request.path,I.path,!A.$l))return p}X(I){const p=new T.$vr(I,this.O,g=>this.a.fire(g),()=>this.c.fire(I),g=>this.b.fire(g),this.R),$={request:I,instance:p};this.watchers.add($)}async stop(){await super.stop();for(const I of this.watchers)this.Y(I)}Y(I){this.P("stopping file watcher",I),this.watchers.delete(I),I.instance.dispose()}Z(I){const p=new Map;for(const $ of I){const g=A.$l?$.path:$.path.toLowerCase();let l=p.get($.correlationId);l||(l=new Map,p.set($.correlationId,l)),l.has(g)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M($)}`),l.set(g,$)}return Array.from(p.values()).map($=>Array.from($.values())).flat()}async setVerboseLogging(I){super.setVerboseLogging(I);for(const p of this.watchers)p.instance.setVerboseLogging(I)}P(I,p){this.R&&this.b.fire({type:"trace",message:this.bb(I,p)})}Q(I){this.b.fire({type:"warn",message:this.bb(I)})}bb(I,p){return p?`[File Watcher (node.js)] ${I} (${this.M(p.request)})`:`[File Watcher (node.js)] ${I}`}}e.$xr=O}),define(fe[169],de([0,1,46,168]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=void 0;class N extends R.$ar{constructor(T,k,O){super(T,k,O),this.s()}r(T){return T.add(new a.$xr(void 0))}}e.$yr=N}),define(fe[170],de([0,1,22,42,97,46]),function(ce,e,R,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;class T extends A.$br{constructor(O,y,I){super(O,y,I),this.s()}r(O){const y=O.add(new N.$or(R.$3g.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return O.add(y.onDidProcessExit(({code:I,signal:p})=>this.t(`terminated by itself with code ${I}, signal: ${p} (ETERM)`))),a.ProxyChannel.toService((0,a.$pi)(y.getChannel("watcher")))}}e.$pr=T}),define(fe[77],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=void 0;class R{constructor(...N){this.a=new Map;for(const[A,T]of N)this.set(A,T)}set(N,A){const T=this.a.get(N);return this.a.set(N,A),T}has(N){return this.a.has(N)}get(N){return this.a.get(N)}}e.$Gi=R}),define(fe[171],de([0,1,6,8,2,74,162,4,77,91]),function(ce,e,R,a,N,A,T,k,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=void 0;const I=!1;class p extends Error{constructor(E){super("cyclic dependency between services"),this.message=E.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${E.toString()}`}}class ${constructor(E=new O.$Gi,w=!1,f,P=I){this.i=E,this.j=w,this.k=f,this.l=P,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(k.$Hi,this),this._globalGraph=P?f?._globalGraph??new T.$Br(m=>m):void 0}dispose(){if(!this.f){this.f=!0,(0,N.$Sc)(this.h),this.h.clear();for(const E of this.g)(0,N.$Rc)(E)&&E.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(E,w){this.m();const f=this,P=new class extends ${dispose(){f.h.delete(P),super.dispose()}}(E,this.j,this,this.l);return this.h.add(P),w?.add(P),P}invokeFunction(E,...w){this.m();const f=l.traceInvocation(this.l,E);let P=!1;try{return E({get:c=>{if(P)throw(0,a.$0)("service accessor is only valid during the invocation of its target method");const h=this.s(c,f);if(!h)throw new Error(`[invokeFunction] unknown service '${c}'`);return h}},...w)}finally{P=!0,f.stop()}}createInstance(E,...w){this.m();let f,P;return E instanceof A.$Fi?(f=l.traceCreation(this.l,E.ctor),P=this.o(E.ctor,E.staticArguments.concat(w),f)):(f=l.traceCreation(this.l,E),P=this.o(E,w,f)),f.stop(),P}o(E,w=[],f){const P=k._util.getServiceDependencies(E).sort((h,i)=>h.index-i.index),m=[];for(const h of P){const i=this.s(h.id,f);i||this.y(`[createInstance] ${E.name} depends on UNKNOWN service ${h.id}.`,!1),m.push(i)}const c=P.length>0?P[0].index:w.length;if(w.length!==c){console.trace(`[createInstance] First service dependency of ${E.name} at position ${c+1} conflicts with ${w.length} static arguments`);const h=c-w.length;h>0?w=w.concat(new Array(h)):w=w.slice(0,c)}return Reflect.construct(E,w.concat(m))}q(E,w){if(this.i.get(E)instanceof A.$Fi)this.i.set(E,w);else if(this.k)this.k.q(E,w);else throw new Error("illegalState - setting UNKNOWN service instance")}r(E){const w=this.i.get(E);return!w&&this.k?this.k.r(E):w}s(E,w){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(E));const f=this.r(E);return f instanceof A.$Fi?this.u(E,f,w.branch(E,!0)):(w.branch(E,!1),f)}u(E,w,f){if(this.t.has(E))throw new Error(`illegal state - RECURSIVELY instantiating service '${E}'`);this.t.add(E);try{return this.v(E,w,f)}finally{this.t.delete(E)}}v(E,w,f){const P=new T.$Br(i=>i.id.toString());let m=0;const c=[{id:E,desc:w,_trace:f}],h=new Set;for(;c.length;){const i=c.pop();if(!h.has(String(i.id))){if(h.add(String(i.id)),P.lookupOrInsertNode(i),m++>1e3)throw new p(P);for(const n of k._util.getServiceDependencies(i.desc.ctor)){const t=this.r(n.id);if(t||this.y(`[createInstance] ${E} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(n.id)),t instanceof A.$Fi){const s={id:n.id,desc:t,_trace:i._trace.branch(n.id,!0)};P.insertEdge(i,s),c.push(s)}}}}for(;;){const i=P.roots();if(i.length===0){if(!P.isEmpty())throw new p(P);break}for(const{data:n}of i){if(this.r(n.id)instanceof A.$Fi){const s=this.w(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this.q(n.id,s)}P.removeNode(n)}}return this.r(E)}w(E,w,f=[],P,m){if(this.i.get(E)instanceof A.$Fi)return this.x(E,w,f,P,m,this.g);if(this.k)return this.k.w(E,w,f,P,m);throw new Error(`illegalState - creating UNKNOWN service instance ${w.name}`)}x(E,w,f=[],P,m,c){if(P){const h=new $(void 0,this.j,this,this.l);h.c=String(E);const i=new Map,n=new R.$2h(()=>{const t=h.o(w,f,m);for(const[s,r]of i){const o=t[s];if(typeof o=="function")for(const u of r)u.disposable=o.apply(t,u.listener)}return i.clear(),c.add(t),t});return new Proxy(Object.create(null),{get(t,s){if(!n.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let u=i.get(s);return u||(u=new y.$8c,i.set(s,u)),(C,S,v)=>{if(n.isInitialized)return n.value[s](C,S,v);{const L={listener:[C,S,v],disposable:void 0},U=u.push(L);return(0,N.$Vc)(()=>{U(),L.disposable?.dispose()})}}}if(s in t)return t[s];const r=n.value;let o=r[s];return typeof o!="function"||(o=o.bind(r),t[s]=o),o},set(t,s,r){return n.value[s]=r,!0},getPrototypeOf(t){return w.prototype}})}else{const h=this.o(w,f,m);return c.add(h),h}}y(E,w){if(w&&console.warn(E),this.j)throw new Error(E)}}e.$Cr=$;var g;(function(d){d[d.None=0]="None",d[d.Creation=1]="Creation",d[d.Invocation=2]="Invocation",d[d.Branch=3]="Branch"})(g||(g={}));class l{static{this.all=new Set}static{this.c=new class extends l{constructor(){super(g.None,null)}stop(){}branch(){return this}}}static traceInvocation(E,w){return E?new l(g.Invocation,w.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):l.c}static traceCreation(E,w){return E?new l(g.Creation,w.name):l.c}static{this.f=0}constructor(E,w){this.type=E,this.name=w,this.g=Date.now(),this.h=[]}branch(E,w){const f=new l(g.Branch,E.toString());return this.h.push([E,w,f]),f}stop(){const E=Date.now()-this.g;l.f+=E;let w=!1;function f(m,c){const h=[],i=new Array(m+1).join("	");for(const[n,t,s]of c.h)if(t&&s){w=!0,h.push(`${i}CREATES -> ${n}`);const r=f(m+1,s);r&&h.push(r)}else h.push(`${i}uses -> ${n}`);return h.join(`
`)}const P=[`${this.type===g.Creation?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${E.toFixed(2)}ms (grand total ${l.f.toFixed(2)}ms)`];(E>2||w)&&l.all.add(P.join(`
`))}}e.$Dr=l}),define(fe[56],de([0,1,4]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ic=e.$1ic=void 0,e.$1ic=(0,R.$Ii)("mainProcessService");class a{constructor(A,T){this.a=A,this.b=T}getChannel(A){return this.a.getChannel(A,this.b)}registerChannel(A,T){this.a.registerChannel(A,T)}}e.$2ic=a}),define(fe[10],de([0,1,11,43,3,55,2,31,5,20,12,9,98,4]),function(ce,e,R,a,N,A,T,k,O,y,I,p,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$gk=e.LogLevel=e.$ek=e.$dk=void 0,e.$fk=d,e.log=w,e.$rk=o,e.$sk=u,e.$tk=b,e.$uk=C,R=Oe(R),e.$dk=(0,g.$Ii)("logService"),e.$ek=(0,g.$Ii)("loggerService");function l(){return new Date().toISOString()}function d(S){return(0,I.$lg)(S)}var E;(function(S){S[S.Off=0]="Off",S[S.Trace=1]="Trace",S[S.Debug=2]="Debug",S[S.Info=3]="Info",S[S.Warning=4]="Warning",S[S.Error=5]="Error"})(E||(e.LogLevel=E={})),e.$gk=E.Info;function w(S,v,L){switch(v){case E.Trace:S.trace(L);break;case E.Debug:S.debug(L);break;case E.Info:S.info(L);break;case E.Warning:S.warn(L);break;case E.Error:S.error(L);break;case E.Off:break;default:throw new Error(`Invalid log level ${v}`)}}function f(S,v=!1){let L="";for(let U=0;U<S.length;U++){let j=S[U];if(j instanceof Error&&(j=(0,a.$tj)(j,v)),typeof j=="object")try{j=JSON.stringify(j)}catch{}L+=(U>0?" ":"")+j}return L}class P extends T.$Xc{constructor(){super(...arguments),this.b=e.$gk,this.c=this.B(new N.$oe),this.onDidChangeLogLevel=this.c.event}setLevel(v){this.b!==v&&(this.b=v,this.c.fire(this.b))}getLevel(){return this.b}f(v){return this.b!==E.Off&&this.b<=v}}e.$ik=P;class m extends P{constructor(v){super(),this.h=v}f(v){return this.h||super.f(v)}trace(v,...L){this.f(E.Trace)&&this.g(E.Trace,f([v,...L],!0))}debug(v,...L){this.f(E.Debug)&&this.g(E.Debug,f([v,...L]))}info(v,...L){this.f(E.Info)&&this.g(E.Info,f([v,...L]))}warn(v,...L){this.f(E.Warning)&&this.g(E.Warning,f([v,...L]))}error(v,...L){if(this.f(E.Error))if(v instanceof Error){const U=Array.prototype.slice.call(arguments);U[0]=v.stack,this.g(E.Error,f(U))}else this.g(E.Error,f([v,...L]))}flush(){}}e.$jk=m;class c extends P{constructor(v=e.$gk){super(),this.setLevel(v),this.g=!O.$j}trace(v,...L){this.f(E.Trace)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,v,...L):console.log(`[main ${l()}]`,v,...L))}debug(v,...L){this.f(E.Debug)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,v,...L):console.log(`[main ${l()}]`,v,...L))}info(v,...L){this.f(E.Info)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,v,...L):console.log(`[main ${l()}]`,v,...L))}warn(v,...L){this.f(E.Warning)&&(this.g?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,v,...L):console.warn(`[main ${l()}]`,v,...L))}error(v,...L){this.f(E.Error)&&(this.g?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,v,...L):console.error(`[main ${l()}]`,v,...L))}flush(){}}e.$kk=c;class h extends P{constructor(v=e.$gk,L=!0){super(),this.g=L,this.setLevel(v)}trace(v,...L){this.f(E.Trace)&&(this.g?console.log("%cTRACE","color: #888",v,...L):console.log(v,...L))}debug(v,...L){this.f(E.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",v,...L):console.log(v,...L))}info(v,...L){this.f(E.Info)&&(this.g?console.log("%c INFO","color: #33f",v,...L):console.log(v,...L))}warn(v,...L){this.f(E.Warning)&&(this.g?console.log("%c WARN","color: #993",v,...L):console.log(v,...L))}error(v,...L){this.f(E.Error)&&(this.g?console.log("%c  ERR","color: #f33",v,...L):console.error(v,...L))}flush(){}}e.$lk=h;class i extends P{constructor(v,L=e.$gk){super(),this.g=v,this.setLevel(L)}trace(v,...L){this.f(E.Trace)&&this.g.log(E.Trace,[this.h(v),...L])}debug(v,...L){this.f(E.Debug)&&this.g.log(E.Debug,[this.h(v),...L])}info(v,...L){this.f(E.Info)&&this.g.log(E.Info,[this.h(v),...L])}warn(v,...L){this.f(E.Warning)&&this.g.log(E.Warning,[this.h(v),...L])}error(v,...L){this.f(E.Error)&&this.g.log(E.Error,[this.h(v),...L])}h(v){return typeof v=="string"?v:(0,a.$tj)(v,this.f(E.Trace))}flush(){}}e.$mk=i;class n extends P{constructor(v){super(),this.g=v,v.length&&this.setLevel(v[0].getLevel())}setLevel(v){for(const L of this.g)L.setLevel(v);super.setLevel(v)}trace(v,...L){for(const U of this.g)U.trace(v,...L)}debug(v,...L){for(const U of this.g)U.debug(v,...L)}info(v,...L){for(const U of this.g)U.info(v,...L)}warn(v,...L){for(const U of this.g)U.warn(v,...L)}error(v,...L){for(const U of this.g)U.error(v,...L)}flush(){for(const v of this.g)v.flush()}dispose(){for(const v of this.g)v.dispose();super.dispose()}}e.$nk=n;class t extends T.$Xc{constructor(v,L,U){if(super(),this.h=v,this.j=L,this.b=new k.$Dc,this.c=this.B(new N.$oe),this.onDidChangeLoggers=this.c.event,this.f=this.B(new N.$oe),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new N.$oe),this.onDidChangeVisibility=this.g.event,U)for(const j of U)this.b.set(j.resource,{logger:void 0,info:j})}m(v){return(0,I.$hg)(v)?[...this.b.values()].find(L=>L.info.id===v):this.b.get(v)}getLogger(v){return this.m(v)?.logger}createLogger(v,L){const U=this.n(v),j=(0,I.$hg)(v)?v:L?.id??(0,A.$wj)(U.toString()).toString(16);let F=this.b.get(U)?.logger;const G=L?.logLevel==="always"?E.Trace:L?.logLevel;F||(F=this.s(U,G??this.getLogLevel(U)??this.h,{...L,id:j}));const V={logger:F,info:{resource:U,id:j,logLevel:G,name:L?.name,hidden:L?.hidden,extensionId:L?.extensionId,when:L?.when}};return this.registerLogger(V.info),this.b.set(U,V),F}n(v){return(0,I.$hg)(v)?(0,y.$jh)(this.j,`${v}.log`):v}setLogLevel(v,L){if(p.URI.isUri(v)){const U=v,j=L,F=this.b.get(U);F&&j!==F.info.logLevel&&(F.info.logLevel=j===this.h?void 0:j,F.logger?.setLevel(j),this.b.set(F.info.resource,F),this.f.fire([U,j]))}else{this.h=v;for(const[U,j]of this.b.entries())this.b.get(U)?.info.logLevel===void 0&&j.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(v,L){const U=this.m(v);U&&L!==!U.info.hidden&&(U.info.hidden=!L,this.b.set(U.info.resource,U),this.g.fire([U.info.resource,L]))}getLogLevel(v){let L;return v&&(L=this.b.get(v)?.info.logLevel),L??this.h}registerLogger(v){const L=this.b.get(v.resource);L?L.info.hidden!==v.hidden&&this.setVisibility(v.resource,!v.hidden):(this.b.set(v.resource,{info:v,logger:void 0}),this.c.fire({added:[v],removed:[]}))}deregisterLogger(v){const L=this.b.get(v);L&&(L.logger&&L.logger.dispose(),this.b.delete(v),this.c.fire({added:[],removed:[L.info]}))}*getRegisteredLoggers(){for(const v of this.b.values())yield v.info}getRegisteredLogger(v){return this.b.get(v)?.info}dispose(){this.b.forEach(v=>v.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ok=t;class s{constructor(){this.onDidChangeLogLevel=new N.$oe().event}setLevel(v){}getLevel(){return E.Info}trace(v,...L){}debug(v,...L){}info(v,...L){}warn(v,...L){}error(v,...L){}critical(v,...L){}dispose(){}flush(){}}e.$pk=s;class r extends s{}e.$qk=r;function o(S){if(S.verbose)return E.Trace;if(typeof S.logLevel=="string"){const v=C(S.logLevel.toLowerCase());if(v!==void 0)return v}return e.$gk}function u(S){switch(S){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Off:return"off"}}function b(S){switch(S){case E.Trace:return{original:"Trace",value:R.localize(1959,null)};case E.Debug:return{original:"Debug",value:R.localize(1960,null)};case E.Info:return{original:"Info",value:R.localize(1961,null)};case E.Warning:return{original:"Warning",value:R.localize(1962,null)};case E.Error:return{original:"Error",value:R.localize(1963,null)};case E.Off:return{original:"Off",value:R.localize(1964,null)}}}function C(S){switch(S){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Error;case"off":return E.Off}}e.$vk=new $.$Zj("logLevel",u(E.Info))}),define(fe[172],de([0,1,6,8,2,22,13,20,30,15,10]),function(ce,e,R,a,N,A,T,k,O,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ijc=void 0;let p=class extends N.$Xc{constructor(g,l){super(),this.a=g,this.b=l,this.B(new R.$Uh(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const g=(0,k.$gh)(this.a.logsHome),l=(0,k.$ih)(this.a.logsHome.with({scheme:A.Schemas.file})).fsPath,w=(await O.Promises.readdir(l)).filter(P=>/^\d{8}T\d{6}$/.test(P)).sort().filter(P=>P!==g),f=w.slice(0,Math.max(0,w.length-9));f.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${f.join(", ")}'`),await Promise.all(f.map(P=>O.Promises.rm((0,T.$mc)(l,P)))))}catch(g){(0,a.$2)(g)}}};e.$ijc=p,e.$ijc=p=Ee([X(0,y.$Pi),X(1,I.$dk)],p)}),define(fe[173],de([0,1,17,6,8,3,41,2,13,46,10]),function(ce,e,R,a,N,A,T,k,O,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=void 0;class p extends k.$Xc{constructor(g,l){super(),this.a=g,this.b=l,this.c=this.B(new A.$oe),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$oe),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new a.$Gh(0)),this.w=[],this.y=this.B(new a.$Gh(0))}watch(g,l){return l.recursive||this.b?.watcher?.forceUniversal?this.n(g,l):this.z(g,l)}n(g,l){const d={path:this.J(g),excludes:l.excludes,includes:l.includes,recursive:l.recursive,filter:l.filter,correlationId:l.correlationId},E=(0,R.$Vb)(this.j,d);return this.r(),(0,k.$Vc)(()=>{E(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(g=>(0,N.$2)(g))}s(){this.h||(this.h=this.B(this.t(l=>this.c.fire((0,y.$cr)(l)),l=>this.G(l),this.a.getLevel()===I.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===I.LogLevel.Trace)})));const g=this.b?.watcher?.recursive?.usePolling;if(g===!0)for(const l of this.j)(0,y.$$q)(l)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(g))for(const l of this.j)(0,y.$$q)(l)&&g.includes(l.path)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(g,l){const d={path:this.J(g),excludes:l.excludes,includes:l.includes,recursive:!1,filter:l.filter,correlationId:l.correlationId},E=(0,R.$Vb)(this.w,d);return this.C(),(0,k.$Vc)(()=>{E(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(g=>(0,N.$2)(g))}D(){return this.u||(this.u=this.B(this.F(g=>this.c.fire((0,y.$cr)(g)),g=>this.G(g),this.a.getLevel()===I.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===I.LogLevel.Trace)}))),this.u.watch(this.w)}G(g){g.type==="error"&&this.g.fire(g.message),this.H(g)}H(g){this.a[g.type](g.message)}I(g){return(0,O.$kc)(g.fsPath)}J(g){const l=this.I(g);return(0,T.$Kg)(l)}}e.$ir=p}),define(fe[174],de([0,1,17,6,14,25,3,55,63,2,51,22,102,20,50,11,7,101,10,8]),function(ce,e,R,a,N,A,T,k,O,y,I,p,$,g,l,d,E,w,f,P){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=void 0;let c=class extends y.$Xc{static{m=this}constructor(i){super(),this.b=i,this.a=256*1024,this.c=this.B(new T.$oe),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new T.$oe),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new T.$oe),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new T.$oe),this.onDidRunOperation=this.r.event,this.X=this.B(new T.$oe),this.Y=this.B(new T.$oe),this.onDidFilesChange=this.Y.event,this.Z=this.B(new T.$oe),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new a.$Rh)}registerProvider(i,n){if(this.h.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,$.mark)(`code/registerFilesystem/${i}`);const t=new y.$Wc;return this.h.set(i,n),this.c.fire({added:!0,scheme:i,provider:n}),t.add(n.onDidChangeFile(s=>{const r=new E.$wl(s,!this.S(n));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof n.onDidWatchError=="function"&&t.add(n.onDidWatchError(s=>this.Z.fire(new Error(s)))),t.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:i}))),(0,y.$Vc)(()=>{this.c.fire({added:!1,scheme:i,provider:n}),this.h.delete(i),(0,y.$Sc)(t)})}getProvider(i){return this.h.get(i)}async activateProvider(i){const n=[];this.f.fire({scheme:i,join(t){n.push(t)}}),!this.h.has(i)&&await a.Promises.settled(n)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.h.has(i.scheme)}hasCapability(i,n){const t=this.h.get(i.scheme);return!!(t&&t.capabilities&n)}listCapabilities(){return O.Iterable.map(this.h,([i,n])=>({scheme:i,capabilities:n.capabilities}))}async j(i){if(!(0,g.$nh)(i))throw new E.$yl((0,d.localize)(1871,null,this.sb(i)),E.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(i.scheme);const n=this.h.get(i.scheme);if(!n){const t=new P.$db;throw t.message=(0,d.localize)(1872,null,i.toString()),t}return n}async m(i){const n=await this.j(i);if((0,E.$jl)(n)||(0,E.$gl)(n)||(0,E.$kl)(n))return n;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(i){const n=await this.j(i);if((0,E.$jl)(n)||(0,E.$gl)(n))return n;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,n){try{return await this.s(i,n)}catch(t){throw(0,E.$tl)(t)===E.FileSystemProviderErrorCode.FileNotFound?new E.$yl((0,d.localize)(1873,null,this.sb(i)),E.FileOperationResult.FILE_NOT_FOUND):(0,E.$rl)(t)}}async s(i,n){const t=await this.j(i),s=this.S(t),r=n?.resolveTo,o=n?.resolveSingleChildDescendants,u=n?.resolveMetadata,b=await t.stat(i);let C;return this.t(t,i,b,void 0,!!u,(S,v)=>(C||(C=I.$Oi.forUris(()=>!s),C.set(i,!0),r&&C.fill(!0,r)),C.get(S.resource)||C.findSuperstr(S.resource.with({query:null,fragment:null}))?!0:S.isDirectory&&o?v===1:!1))}async t(i,n,t,s,r,o){const{providerExtUri:u}=this.R(i),b={resource:n,name:u.basename(n),isFile:(t.type&E.FileType.File)!==0,isDirectory:(t.type&E.FileType.Directory)!==0,isSymbolicLink:(t.type&E.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&E.FilePermission.Readonly)||!!(i.capabilities&E.FileSystemProviderCapabilities.Readonly),locked:!!((t.permissions??0)&E.FilePermission.Locked),etag:(0,E.$Jl)({mtime:t.mtime,size:t.size}),children:void 0};if(b.isDirectory&&o(b,s)){try{const C=await i.readdir(n),S=await a.Promises.settled(C.map(async([v,L])=>{try{const U=u.joinPath(n,v),j=r?await i.stat(U):{type:L};return await this.t(i,U,j,C.length,r,o)}catch(U){return this.b.trace(U),null}}));b.children=(0,R.$Jb)(S)}catch(C){this.b.trace(C),b.children=[]}return b}return b}async resolveAll(i){return a.Promises.settled(i.map(async n=>{try{return{stat:await this.s(n.resource,n.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(i){const n=await this.j(i),t=await n.stat(i);return this.t(n,i,t,void 0,!0,()=>!1)}async exists(i){const n=await this.j(i);try{return!!await n.stat(i)}catch{return!1}}async canCreateFile(i,n){try{await this.u(i,n)}catch(t){return t}return!0}async u(i,n){if(!n?.overwrite&&await this.exists(i))throw new E.$yl((0,d.localize)(1874,null,this.sb(i)),E.FileOperationResult.FILE_MODIFIED_SINCE,n)}async createFile(i,n=N.$Qe.fromString(""),t){await this.u(i,t);const s=await this.writeFile(i,n);return this.r.fire(new E.$vl(i,E.FileOperation.CREATE,s)),s}async writeFile(i,n,t){const s=this.qb(await this.n(i),i),{providerExtUri:r}=this.R(s);let o=t;if((0,E.$ml)(s)&&!o?.atomic){const u=s.enforceAtomicWriteFile?.(i);u&&(o={...t,atomic:u})}try{await this.w(s,i,o)||await this.U(s,r.dirname(i));let b;if((0,E.$gl)(s)&&!(n instanceof N.$Qe))if((0,l.$Ce)(n)){const C=await(0,l.$Je)(n,3);C.ended?b=N.$Qe.concat(C.buffer):b=C}else b=(0,l.$Ge)(n,C=>N.$Qe.concat(C),3);else b=n;!(0,E.$jl)(s)||(0,E.$gl)(s)&&b instanceof N.$Qe||(0,E.$gl)(s)&&(0,E.$ml)(s)&&o?.atomic?await this.hb(s,i,o,b):await this.db(s,i,o,b instanceof N.$Qe?(0,N.$2e)(b):b),this.r.fire(new E.$vl(i,E.FileOperation.WRITE))}catch(u){throw new E.$yl((0,d.localize)(1875,null,this.sb(i),(0,E.$rl)(u).toString()),(0,E.$ul)(u),o)}return this.resolve(i,{resolveMetadata:!0})}async w(i,n,t){const s=!!t?.unlock;if(s&&!(i.capabilities&E.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,d.localize)(1876,null,this.sb(n)));if(!!t?.atomic){if(!(i.capabilities&E.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,d.localize)(1877,null,this.sb(n)));if(!(i.capabilities&E.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,d.localize)(1878,null,this.sb(n)));if(s)throw new Error((0,d.localize)(1879,null,this.sb(n)))}let o;try{o=await i.stat(n)}catch{return}if(o.type&E.FileType.Directory)throw new E.$yl((0,d.localize)(1880,null,this.sb(n)),E.FileOperationResult.FILE_IS_DIRECTORY,t);if(this.rb(n,o),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==E.$Il&&typeof o.mtime=="number"&&typeof o.size=="number"&&t.mtime<o.mtime&&t.etag!==(0,E.$Jl)({mtime:t.mtime,size:o.size}))throw new E.$yl((0,d.localize)(1881,null),E.FileOperationResult.FILE_MODIFIED_SINCE,t);return o}async readFile(i,n,t){const s=await this.m(i);return n?.atomic?this.z(s,i,n,t):this.C(s,i,n,t)}async z(i,n,t,s){return new Promise((r,o)=>{this.cb.queueFor(n,async()=>{try{const u=await this.C(i,n,t,s);r(u)}catch(u){o(u)}},this.R(i).providerExtUri)})}async C(i,n,t,s){const r=await this.D(i,n,{...t,preferUnbuffered:!0},s);return{...r,value:await(0,N.$3e)(r.value)}}async readFileStream(i,n,t){const s=await this.m(i);return this.D(s,i,n,t)}async D(i,n,t,s){const r=new A.$ze(s);let o=t;(0,E.$ll)(i)&&i.enforceAtomicReadFile?.(n)&&(o={...t,atomic:!0});const u=this.J(n,o).then(C=>C,C=>{throw r.dispose(!0),C});let b;try{return typeof o?.etag=="string"&&o.etag!==E.$Il&&await u,o?.atomic&&(0,E.$ll)(i)||!((0,E.$jl)(i)||(0,E.$kl)(i))||(0,E.$gl)(i)&&o?.preferUnbuffered?b=this.I(i,n,o):(0,E.$kl)(i)?b=this.G(i,n,r.token,o):b=this.H(i,n,r.token,o),b.on("end",()=>r.dispose()),b.on("error",()=>r.dispose()),{...await u,value:b}}catch(C){throw b&&await(0,l.$He)(b),this.F(C,n,o)}}F(i,n,t){const s=(0,d.localize)(1882,null,this.sb(n),(0,E.$rl)(i).toString());return i instanceof E.$Al?new E.$Al(s,i.stat,t):i instanceof E.$zl?new E.$zl(s,i.fileOperationResult,i.size,i.options):new E.$yl(s,(0,E.$ul)(i),t)}G(i,n,t,s=Object.create(null)){const r=i.readFileStream(n,s,t);return(0,l.$Ne)(r,{data:o=>o instanceof N.$Qe?o:N.$Qe.wrap(o),error:o=>this.F(o,n,s)},o=>N.$Qe.concat(o))}H(i,n,t,s=Object.create(null)){const r=(0,N.$7e)();return(0,w.$8q)(i,n,r,o=>o,{...s,bufferSize:this.a,errorTransformer:o=>this.F(o,n,s)},t),r}I(i,n,t){const s=(0,l.$Ee)(r=>N.$Qe.concat(r));return(async()=>{try{let r;t?.atomic&&(0,E.$ll)(i)?r=await i.readFile(n,{atomic:!0}):r=await i.readFile(n),typeof t?.position=="number"&&(r=r.slice(t.position)),typeof t?.length=="number"&&(r=r.slice(0,t.length)),this.L(n,r.byteLength,t),s.end(N.$Qe.wrap(r))}catch(r){s.error(r),s.end()}})(),s}async J(i,n){const t=await this.resolve(i,{resolveMetadata:!0});if(t.isDirectory)throw new E.$yl((0,d.localize)(1883,null,this.sb(i)),E.FileOperationResult.FILE_IS_DIRECTORY,n);if(typeof n?.etag=="string"&&n.etag!==E.$Il&&n.etag===t.etag)throw new E.$Al((0,d.localize)(1884,null),t,n);return this.L(i,t.size,n),t}L(i,n,t){if(typeof t?.limits?.size=="number"&&n>t.limits.size)throw new E.$zl((0,d.localize)(1885,null,this.sb(i)),E.FileOperationResult.FILE_TOO_LARGE,n,t)}async canMove(i,n,t){return this.M(i,n,"move",t)}async canCopy(i,n,t){return this.M(i,n,"copy",t)}async M(i,n,t,s){if(i.toString()!==n.toString())try{const r=t==="move"?this.qb(await this.n(i),i):await this.m(i),o=this.qb(await this.n(n),n);await this.Q(r,i,o,n,t,s)}catch(r){return r}return!0}async move(i,n,t){const s=this.qb(await this.n(i),i),r=this.qb(await this.n(n),n),o=await this.N(s,i,r,n,"move",!!t),u=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new E.$vl(i,o==="move"?E.FileOperation.MOVE:E.FileOperation.COPY,u)),u}async copy(i,n,t){const s=await this.m(i),r=this.qb(await this.n(n),n),o=await this.N(s,i,r,n,"copy",!!t),u=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new E.$vl(i,o==="copy"?E.FileOperation.COPY:E.FileOperation.MOVE,u)),u}async N(i,n,t,s,r,o){if(n.toString()===s.toString())return r;const{exists:u,isSameResourceWithDifferentPathCase:b}=await this.Q(i,n,t,s,r,o);if(u&&!b&&o&&await this.del(s,{recursive:!0}),await this.U(t,this.R(t).providerExtUri.dirname(s)),r==="copy"){if(i===t&&(0,E.$hl)(i))await i.copy(n,s,{overwrite:o});else{const C=await this.resolve(n);C.isDirectory?await this.P(i,C,t,s):await this.O(i,n,t,s)}return r}else return i===t?(await i.rename(n,s,{overwrite:o}),r):(await this.N(i,n,t,s,"copy",o),await this.del(n,{recursive:!0}),"copy")}async O(i,n,t,s){if((0,E.$jl)(i)&&(0,E.$jl)(t))return this.jb(i,n,t,s);if((0,E.$jl)(i)&&(0,E.$gl)(t))return this.pb(i,n,t,s);if((0,E.$gl)(i)&&(0,E.$jl)(t))return this.nb(i,n,t,s);if((0,E.$gl)(i)&&(0,E.$gl)(t))return this.lb(i,n,t,s)}async P(i,n,t,s){await t.mkdir(s),Array.isArray(n.children)&&await a.Promises.settled(n.children.map(async r=>{const o=this.R(t).providerExtUri.joinPath(s,r.name);return r.isDirectory?this.P(i,await this.resolve(r.resource),t,o):this.O(i,r.resource,t,o)}))}async Q(i,n,t,s,r,o){let u=!1;if(i===t){const{providerExtUri:C,isPathCaseSensitive:S}=this.R(i);if(S||(u=C.isEqual(n,s)),u&&r==="copy")throw new Error((0,d.localize)(1886,null,this.sb(n),this.sb(s)));if(!u&&C.isEqualOrParent(s,n))throw new Error((0,d.localize)(1887,null,this.sb(n),this.sb(s)))}const b=await this.exists(s);if(b&&!u){if(!o)throw new E.$yl((0,d.localize)(1888,null,this.sb(n),this.sb(s)),E.FileOperationResult.FILE_MOVE_CONFLICT);if(i===t){const{providerExtUri:C}=this.R(i);if(C.isEqualOrParent(n,s))throw new Error((0,d.localize)(1889,null,this.sb(n),this.sb(s)))}}return{exists:b,isSameResourceWithDifferentPathCase:u}}R(i){const n=this.S(i);return{providerExtUri:n?g.$_g:g.$bh,isPathCaseSensitive:n}}S(i){return!!(i.capabilities&E.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(i){const n=this.qb(await this.j(i),i);await this.U(n,i);const t=await this.resolve(i,{resolveMetadata:!0});return this.r.fire(new E.$vl(i,E.FileOperation.CREATE,t)),t}async U(i,n){const t=[],{providerExtUri:s}=this.R(i);for(;!s.isEqual(n,s.dirname(n));)try{if(!((await i.stat(n)).type&E.FileType.Directory))throw new Error((0,d.localize)(1890,null,this.sb(n)));break}catch(r){if((0,E.$tl)(r)!==E.FileSystemProviderErrorCode.FileNotFound)throw r;t.push(s.basename(n)),n=s.dirname(n)}for(let r=t.length-1;r>=0;r--){n=s.joinPath(n,t[r]);try{await i.mkdir(n)}catch(o){if((0,E.$tl)(o)!==E.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(i,n){try{await this.W(i,n)}catch(t){return t}return!0}async W(i,n){const t=this.qb(await this.j(i),i),s=!!n?.useTrash;if(s&&!(t.capabilities&E.FileSystemProviderCapabilities.Trash))throw new Error((0,d.localize)(1891,null,this.sb(i)));const r=n?.atomic;if(r&&!(t.capabilities&E.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,d.localize)(1892,null,this.sb(i)));if(s&&r)throw new Error((0,d.localize)(1893,null,this.sb(i)));let o;try{o=await t.stat(i)}catch{}if(o)this.rb(i,o);else throw new E.$yl((0,d.localize)(1894,null,this.sb(i)),E.FileOperationResult.FILE_NOT_FOUND);if(!!!n?.recursive){const b=await this.resolve(i);if(b.isDirectory&&Array.isArray(b.children)&&b.children.length>0)throw new Error((0,d.localize)(1895,null,this.sb(i)))}return t}async del(i,n){const t=await this.W(i,n);let s=n;if((0,E.$nl)(t)&&!s?.atomic){const b=t.enforceAtomicDelete?.(i);b&&(s={...n,atomic:b})}const r=!!s?.useTrash,o=!!s?.recursive,u=s?.atomic??!1;await t.delete(i,{recursive:o,useTrash:r,atomic:u}),this.r.fire(new E.$vl(i,E.FileOperation.DELETE))}async cloneFile(i,n){const t=await this.j(i),s=this.qb(await this.n(n),n);if(!(t===s&&this.R(t).providerExtUri.isEqual(i,n)))return t===s&&(0,E.$il)(t)?t.cloneFile(i,n):(await this.U(s,this.R(s).providerExtUri.dirname(n)),t===s&&(0,E.$hl)(t)?this.cb.queueFor(i,()=>t.copy(i,n,{overwrite:!0}),this.R(t).providerExtUri):this.cb.queueFor(i,()=>this.O(t,i,s,n),this.R(t).providerExtUri))}static{this.ab=0}createWatcher(i,n){return this.watch(i,{...n,correlationId:m.ab++})}watch(i,n={recursive:!1,excludes:[]}){const t=new y.$Wc;let s=!1,r=()=>{s=!0};t.add((0,y.$Vc)(()=>r())),(async()=>{try{const u=await this.bb(i,n);s?(0,y.$Sc)(u):r=()=>(0,y.$Sc)(u)}catch(u){this.b.error(u)}})();const o=n.correlationId;if(typeof o=="number"){const u=t.add(new T.$oe);return t.add(this.X.event(C=>{C.correlates(o)&&u.fire(C)})),{onDidChange:u.event,dispose:()=>t.dispose()}}return t}async bb(i,n){const t=await this.j(i),s=(0,k.$wj)([this.R(t).providerExtUri.getComparisonKey(i),n]);let r=this.$.get(s);return r||(r={count:0,disposable:t.watch(i,n)},this.$.set(s,r)),r.count+=1,(0,y.$Vc)(()=>{r&&(r.count--,r.count===0&&((0,y.$Sc)(r.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,i]of this.$)(0,y.$Sc)(i.disposable);this.$.clear()}async db(i,n,t,s){return this.cb.queueFor(n,async()=>{const r=await i.open(n,{create:!0,unlock:t?.unlock??!1});try{(0,l.$Ce)(s)||(0,l.$De)(s)?await this.eb(i,r,s):await this.fb(i,r,s)}catch(o){throw(0,E.$rl)(o)}finally{await i.close(r)}},this.R(i).providerExtUri)}async eb(i,n,t){let s=0,r;if((0,l.$De)(t)){if(t.buffer.length>0){const o=N.$Qe.concat(t.buffer);await this.gb(i,n,o,o.byteLength,s,0),s+=o.byteLength}if(t.ended)return;r=t.stream}else r=t;return new Promise((o,u)=>{(0,l.$Ie)(r,{onData:async b=>{r.pause();try{await this.gb(i,n,b,b.byteLength,s,0)}catch(C){return u(C)}s+=b.byteLength,setTimeout(()=>r.resume())},onError:b=>u(b),onEnd:()=>o()})})}async fb(i,n,t){let s=0,r;for(;(r=t.read())!==null;)await this.gb(i,n,r,r.byteLength,s,0),s+=r.byteLength}async gb(i,n,t,s,r,o){let u=0;for(;u<s;){const b=await i.write(n,r+u,t.buffer,o+u,s-u);u+=b}}async hb(i,n,t,s){return this.cb.queueFor(n,()=>this.ib(i,n,t,s),this.R(i).providerExtUri)}async ib(i,n,t,s){let r;s instanceof N.$Qe?r=s:(0,l.$Ce)(s)?r=await(0,N.$3e)(s):(0,l.$De)(s)?r=await(0,N.$4e)(s):r=(0,N.$1e)(s),await i.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1,atomic:t?.atomic??!1})}async jb(i,n,t,s){return this.cb.queueFor(s,()=>this.kb(i,n,t,s),this.R(t).providerExtUri)}async kb(i,n,t,s){let r,o;try{r=await i.open(n,{create:!1}),o=await t.open(s,{create:!0,unlock:!1});const u=N.$Qe.alloc(this.a);let b=0,C=0,S=0;do S=await i.read(r,b,u.buffer,C,u.byteLength-C),await this.gb(t,o,u,S,b,C),b+=S,C+=S,C===u.byteLength&&(C=0);while(S>0)}catch(u){throw(0,E.$rl)(u)}finally{await a.Promises.settled([typeof r=="number"?i.close(r):Promise.resolve(),typeof o=="number"?t.close(o):Promise.resolve()])}}async lb(i,n,t,s){return this.cb.queueFor(s,()=>this.mb(i,n,t,s),this.R(t).providerExtUri)}async mb(i,n,t,s){return t.writeFile(s,await i.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(i,n,t,s){return this.cb.queueFor(s,()=>this.ob(i,n,t,s),this.R(t).providerExtUri)}async ob(i,n,t,s){const r=await t.open(s,{create:!0,unlock:!1});try{const o=await i.readFile(n);await this.gb(t,r,N.$Qe.wrap(o),o.byteLength,0,0)}catch(o){throw(0,E.$rl)(o)}finally{await t.close(r)}}async pb(i,n,t,s){const r=await(0,N.$3e)(this.H(i,n,A.CancellationToken.None));await this.hb(t,s,void 0,r)}qb(i,n){if(i.capabilities&E.FileSystemProviderCapabilities.Readonly)throw new E.$yl((0,d.localize)(1896,null,this.sb(n)),E.FileOperationResult.FILE_PERMISSION_DENIED);return i}rb(i,n){if((n.permissions??0)&E.FilePermission.Readonly)throw new E.$yl((0,d.localize)(1897,null,this.sb(i)),E.FileOperationResult.FILE_PERMISSION_DENIED)}sb(i){return i.scheme===p.Schemas.file?i.fsPath:i.toString(!0)}};e.$9q=c,e.$9q=c=m=Ee([X(0,f.$dk)],c)}),define(fe[175],de([0,1,33,6,31,14,3,41,2,13,5,20,50,30,11,7,101,173,170,169]),function(ce,e,R,a,N,A,T,k,O,y,I,p,$,g,l,d,E,w,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=void 0;class m extends w.$ir{static{this.L=!1}constructor(h,i){super(h,i),this.onDidChangeCapabilities=T.Event.None,this.P=new N.$Dc(n=>p.$ah.getComparisonKey(n)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=d.FileSystemProviderCapabilities.FileReadWrite|d.FileSystemProviderCapabilities.FileOpenReadWriteClose|d.FileSystemProviderCapabilities.FileReadStream|d.FileSystemProviderCapabilities.FileFolderCopy|d.FileSystemProviderCapabilities.FileWriteUnlock|d.FileSystemProviderCapabilities.FileAtomicRead|d.FileSystemProviderCapabilities.FileAtomicWrite|d.FileSystemProviderCapabilities.FileAtomicDelete|d.FileSystemProviderCapabilities.FileClone,I.$l&&(this.M|=d.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(h){try{const{stat:i,symbolicLink:n}=await g.SymlinkSupport.stat(this.I(h));return{type:this.O(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:d.FilePermission.Locked}}catch(i){throw this.hb(i)}}async N(h){try{return await this.stat(h)}catch{return}}async readdir(h){try{const i=await g.Promises.readdir(this.I(h),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async t=>{try{let s;t.isSymbolicLink()?s=(await this.stat((0,p.$jh)(h,t.name))).type:s=this.O(t),n.push([t.name,s])}catch(s){this.a.trace(s)}})),n}catch(i){throw this.hb(i)}}O(h,i){let n;return i?.dangling?n=d.FileType.Unknown:h.isFile()?n=d.FileType.File:h.isDirectory()?n=d.FileType.Directory:n=d.FileType.Unknown,i&&(n|=d.FileType.SymbolicLink),n}async Q(h){const i=this.I(h);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.P.get(h);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const t=new a.$Hh;return this.P.set(h,t),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,O.$Vc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.P.get(h)===t&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.P.delete(h)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),t.open()})}async readFile(h,i){let n;try{i?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(h)})`),n=await this.Q(h));const t=this.I(h);return await R.promises.readFile(t)}catch(t){throw this.hb(t)}finally{n?.dispose()}}R(h){m.L&&this.a.trace(h)}readFileStream(h,i,n){const t=(0,$.$Ee)(s=>A.$Qe.concat(s.map(r=>A.$Qe.wrap(r))).buffer);return(0,E.$8q)(this,h,t,s=>s.buffer,{...i,bufferSize:256*1024},n),t}async writeFile(h,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.S(h)?this.U(h,(0,p.$jh)((0,p.$ih)(h),`${(0,p.$gh)(h)}${n.atomic.postfix}`),i,n):this.W(h,i,n)}async S(h){try{const i=this.I(h),{symbolicLink:n}=await g.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async U(h,i,n,t){const s=new O.$Wc;try{s.add(await this.Q(h)),s.add(await this.Q(i)),await this.W(i,n,t,!0);try{await this.rename(i,h,{overwrite:!0})}catch(r){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw r}}finally{s.dispose()}}async W(h,i,n,t){let s;try{const r=this.I(h);if(!n.create||!n.overwrite){if(await g.Promises.exists(r)){if(!n.overwrite)throw(0,d.$ql)((0,l.localize)(1901,null),d.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,d.$ql)((0,l.localize)(1902,null),d.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(h,{create:!0,unlock:n.unlock},t),await this.write(s,0,i,0,i.byteLength)}catch(r){throw await this.ib(h,r)}finally{typeof s=="number"&&await this.close(s)}}static{this.$=!0}static configureFlushOnWrite(h){m.$=h}async open(h,i,n){const t=this.I(h);let s;(0,d.$el)(i)&&!n&&(s=await this.Q(h));let r;try{if((0,d.$el)(i)&&i.unlock)try{const{stat:u}=await g.SymlinkSupport.stat(t);u.mode&128||await R.promises.chmod(t,u.mode|128)}catch(u){u.code!=="ENOENT"&&this.a.trace(u)}let o;if((0,d.$el)(i)){if(I.$j)try{await R.promises.truncate(t,0),o="r+"}catch(u){u.code!=="ENOENT"&&this.a.trace(u)}o||(o="w")}else o="r";r=await g.Promises.open(t,o)}catch(o){throw s?.dispose(),(0,d.$el)(i)?await this.ib(h,o):this.hb(o)}if(this.X.set(r,0),(0,d.$el)(i)&&this.Z.set(r,h),s){const o=this.Y.get(r);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${r} (${t})`),this.Y.set(r,s),o&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${r} (${t})`),o.dispose())}return r}async close(h){const i=this.Y.get(h);try{if(this.X.delete(h),this.Z.delete(h)&&m.$)try{await g.Promises.fdatasync(h)}catch(n){m.configureFlushOnWrite(!1),this.a.error(n)}return await g.Promises.close(h)}catch(n){throw this.hb(n)}finally{i&&(this.Y.get(h)===i&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${h}`),this.Y.delete(h)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${h}`),i.dispose())}}async read(h,i,n,t,s){const r=this.ab(h,i);let o=null;try{o=(await g.Promises.read(h,n,t,s,r)).bytesRead}catch(u){throw this.hb(u)}finally{this.bb(h,r,o)}return o}ab(h,i){return i===this.X.get(h)?null:i}bb(h,i,n){const t=this.X.get(h);typeof t=="number"&&(typeof i=="number"||(typeof n=="number"?this.X.set(h,t+n):this.X.delete(h)))}async write(h,i,n,t,s){return(0,a.$3h)(()=>this.cb(h,i,n,t,s),100,3)}async cb(h,i,n,t,s){const r=this.ab(h,i);let o=null;try{o=(await g.Promises.write(h,n,t,s,r)).bytesWritten}catch(u){throw await this.ib(this.Z.get(h),u)}finally{this.bb(h,r,o)}return o}async mkdir(h){try{await R.promises.mkdir(this.I(h))}catch(i){throw this.hb(i)}}async delete(h,i){try{const n=this.I(h);if(i.recursive){let t;i?.atomic!==!1&&i.atomic.postfix&&(t=(0,y.$mc)((0,y.$pc)(n),`${(0,y.$qc)(n)}${i.atomic.postfix}`)),await g.Promises.rm(n,g.RimRafMode.MOVE,t)}else try{await R.promises.unlink(n)}catch(t){if(t.code==="EPERM"||t.code==="EISDIR"){let s=!1;try{const{stat:r,symbolicLink:o}=await g.SymlinkSupport.stat(n);s=r.isDirectory()&&!o}catch{}if(s)await R.promises.rmdir(n);else throw t}else throw t}}catch(n){throw this.hb(n)}}async rename(h,i,n){const t=this.I(h),s=this.I(i);if(t!==s)try{await this.db(h,i,"move",n.overwrite),await g.Promises.rename(t,s)}catch(r){throw(r.code==="EINVAL"||r.code==="EBUSY"||r.code==="ENAMETOOLONG")&&(r=new Error((0,l.localize)(1903,null,(0,y.$qc)(t),(0,y.$qc)((0,y.$pc)(s)),r.toString()))),this.hb(r)}}async copy(h,i,n){const t=this.I(h),s=this.I(i);if(t!==s)try{await this.db(h,i,"copy",n.overwrite),await g.Promises.copy(t,s,{preserveSymlinks:!0})}catch(r){throw(r.code==="EINVAL"||r.code==="EBUSY"||r.code==="ENAMETOOLONG")&&(r=new Error((0,l.localize)(1904,null,(0,y.$qc)(t),(0,y.$qc)((0,y.$pc)(s)),r.toString()))),this.hb(r)}}async db(h,i,n,t){const s=this.I(h),r=this.I(i);let o=!1;if(!!(this.capabilities&d.FileSystemProviderCapabilities.PathCaseSensitive)||(o=(0,k.$Gg)(s,r,!0)),o){if(n==="copy")throw(0,d.$ql)((0,l.localize)(1905,null),d.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const b=await this.N(h);if(!b)throw(0,d.$ql)((0,l.localize)(1906,null),d.FileSystemProviderErrorCode.FileNotFound);const C=await this.N(i);if(C){if(!t)throw(0,d.$ql)((0,l.localize)(1907,null),d.FileSystemProviderErrorCode.FileExists);b.type&d.FileType.File&&C.type&d.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(h,i){return this.eb(h,i,!1)}async eb(h,i,n){const t=this.I(h),s=this.I(i),r=!!(this.capabilities&d.FileSystemProviderCapabilities.PathCaseSensitive);if((0,k.$Gg)(t,s,!r))return;const o=new O.$Wc;try{o.add(await this.Q(h)),o.add(await this.Q(i)),n&&await R.promises.mkdir((0,y.$pc)(s),{recursive:!0}),await R.promises.copyFile(t,s)}catch(u){if(u.code==="ENOENT"&&!n)return this.eb(h,i,!0);throw this.hb(u)}finally{o.dispose()}}t(h,i,n){return new f.$pr(t=>h(t),t=>i(t),n)}F(h,i,n){return new P.$yr(t=>h(t),t=>i(t),n)}hb(h){if(h instanceof d.$pl)return h;let i=h,n;switch(h.code){case"ENOENT":n=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=d.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${h.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=d.FileSystemProviderErrorCode.Unknown;break;default:n=d.FileSystemProviderErrorCode.Unknown}return(0,d.$ql)(i,n)}async ib(h,i){let n=this.hb(i);if(h&&n.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:t}=await g.SymlinkSupport.stat(this.I(h));t.mode&128||(n=(0,d.$ql)(i,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(t){this.a.trace(t)}return n}}e.$zr=m}),define(fe[103],de([0,1,3,2,4,10]),function(ce,e,R,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ijc=e.$Hjc=void 0,e.$Hjc=(0,N.$Ii)("sharedProcessLifecycleService");let T=class extends a.$Xc{constructor(O){super(),this.b=O,this.a=this.B(new R.$oe),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$Ijc=T,e.$Ijc=T=Ee([X(0,A.$dk)],T)}),define(fe[176],de([0,1,9,3,10,2]),function(ce,e,R,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bs=e.$As=e.$zs=void 0;class T extends N.$ok{constructor(p,$,g,l,d){super($,g,l),this.r=p,this.t=d,this.B(d.listen("onDidChangeLogLevel",p)(E=>{(0,N.$fk)(E)?super.setLogLevel(E):super.setLogLevel(R.URI.revive(E[0]),E[1])})),this.B(d.listen("onDidChangeVisibility",p)(([E,w])=>super.setVisibility(R.URI.revive(E),w))),this.B(d.listen("onDidChangeLoggers",p)(({added:E,removed:w})=>{for(const f of E)super.registerLogger({...f,resource:R.URI.revive(f.resource)});for(const f of w)super.deregisterLogger(f.resource)}))}createConsoleMainLogger(){return new N.$mk({log:(p,$)=>{this.t.call("consoleLog",[p,$])}})}registerLogger(p){super.registerLogger(p),this.t.call("registerLogger",[p,this.r])}deregisterLogger(p){super.deregisterLogger(p),this.t.call("deregisterLogger",[p,this.r])}setLogLevel(p,$){super.setLogLevel(p,$),this.t.call("setLogLevel",[p,$])}setVisibility(p,$){super.setVisibility(p,$),this.t.call("setVisibility",[this.n(p),$])}s(p,$,g){return new k(this.t,p,$,g,this.r)}static setLogLevel(p,$,g){return p.call("setLogLevel",[$,g])}}e.$zs=T;class k extends N.$jk{constructor(p,$,g,l,d){super(l?.logLevel==="always"),this.r=p,this.s=$,this.m=!1,this.n=[],this.setLevel(g),this.r.call("createLogger",[$,l,d]).then(()=>{this.u(this.n),this.m=!0})}g(p,$){const g=[[p,$]];this.m?this.u(g):this.n.push(...g)}u(p){this.r.call("log",[this.s,p])}}class O{constructor(p,$){this.a=p,this.b=$}listen(p,$){const g=this.b(p);switch($){case"onDidChangeLoggers":return a.Event.map(this.a.onDidChangeLoggers,l=>({added:[...l.added].map(d=>this.c(d,g)),removed:[...l.removed].map(d=>this.c(d,g))}));case"onDidChangeVisibility":return a.Event.map(this.a.onDidChangeVisibility,l=>[g.transformOutgoingURI(l[0]),l[1]]);case"onDidChangeLogLevel":return a.Event.map(this.a.onDidChangeLogLevel,l=>(0,N.$fk)(l)?l:[g.transformOutgoingURI(l[0]),l[1]])}throw new Error(`Event not found: ${$}`)}async call(p,$,g){const l=this.b(p);switch($){case"setLogLevel":return(0,N.$fk)(g[0])?this.a.setLogLevel(g[0]):this.a.setLogLevel(R.URI.revive(l.transformIncoming(g[0][0])),g[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(d=>this.c(d,l)))}throw new Error(`Call not found: ${$}`)}c(p,$){return{...p,resource:$.transformOutgoingURI(p.resource)}}}e.$As=O;class y extends A.$Xc{constructor(p,$){super(),$.call("setLogLevel",[p.getLogLevel()]),this.B(p.onDidChangeLogLevel(g=>$.call("setLogLevel",[g]))),$.call("getRegisteredLoggers").then(g=>{for(const l of g)p.registerLogger({...l,resource:R.URI.revive(l.resource)})}),this.B($.listen("onDidChangeVisibility")(([g,l])=>p.setVisibility(R.URI.revive(g),l))),this.B($.listen("onDidChangeLoggers")(({added:g,removed:l})=>{for(const d of g)p.registerLogger({...d,resource:R.URI.revive(d.resource)});for(const d of l)p.deregisterLogger(d.resource)}))}}e.$Bs=y}),define(fe[177],de([0,1,2,10]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4R=void 0;class N extends R.$Xc{constructor(T,k=[]){super(),this.a=new a.$nk([T,...k]),this.B(T.onDidChangeLogLevel(O=>this.setLevel(O)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(T){this.a.setLevel(T)}getLevel(){return this.a.getLevel()}trace(T,...k){this.a.trace(T,...k)}debug(T,...k){this.a.debug(T,...k)}info(T,...k){this.a.info(T,...k)}warn(T,...k){this.a.warn(T,...k)}error(T,...k){this.a.error(T,...k)}flush(){this.a.flush()}}e.$4R=N}),define(fe[57],de([0,1,4]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ihc=void 0,e.$Ihc=(0,R.$Ii)("nativeHostService")}),define(fe[178],de([0,1,42,56]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ic=void 0;let N=class{constructor(T,k){return this.windowId=T,R.ProxyChannel.toService(k.getChannel("nativeHost"),{context:T,properties:(()=>{const O=new Map;return O.set("windowId",T),O})()})}};e.$4ic=N,e.$4ic=N=Ee([X(1,a.$1ic)],N)}),define(fe[58],de([0,1,3,63,2,4]),function(ce,e,R,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=e.$yo=e.$xo=void 0,e.$xo=(0,A.$Ii)("policy");class T extends N.$Xc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new R.$oe),this.onDidChange=this.h.event}async updatePolicyDefinitions(y){const I=Object.keys(this.f).length;return this.f={...y,...this.f},I!==Object.keys(this.f).length&&await this.j(y),a.Iterable.reduce(this.g.entries(),(p,[$,g])=>({...p,[$]:g}),{})}getPolicyValue(y){return this.g.get(y)}serialize(){return a.Iterable.reduce(Object.entries(this.f),(y,[I,p])=>({...y,[I]:{definition:p,value:this.g.get(I)}}),{})}}e.$yo=T;class k{constructor(){this.onDidChange=R.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$zo=k}),define(fe[179],de([0,1,3,2,58]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vic=e.$uic=void 0;class A{constructor(O){this.b=O,this.a=new a.$Wc}listen(O,y){switch(y){case"onDidChange":return R.Event.map(this.b.onDidChange,I=>I.reduce((p,$)=>({...p,[$]:this.b.getPolicyValue($)??null}),{}),this.a)}throw new Error(`Event not found: ${y}`)}call(O,y,I){switch(y){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(I)}throw new Error(`Call not found: ${y}`)}dispose(){this.a.dispose()}}e.$uic=A;class T extends N.$yo{constructor(O,y){super(),this.a=y;for(const I in O){const{definition:p,value:$}=O[I];this.f[I]=p,$!==void 0&&this.g.set(I,$)}this.a.listen("onDidChange")(I=>{for(const p in I){const $=I[p];$===null?this.g.delete(p):this.g.set(p,$)}this.h.fire(Object.keys(I))})}async j(O){const y=await this.a.call("updatePolicyDefinitions",O);for(const I in y)this.g.set(I,y[I])}}e.$vic=T}),define(fe[104],de([0,1,37]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let a;const N=globalThis.vscode;if(typeof N<"u"&&typeof N.context<"u"){const A=N.context.configuration();if(A)a=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(a=globalThis._VSCODE_PRODUCT_JSON,R.env.VSCODE_DEV&&Object.assign(a,{nameShort:`${a.nameShort} Dev`,nameLong:`${a.nameLong} Dev`,dataFolderName:`${a.dataFolderName}-dev`,serverDataFolderName:a.serverDataFolderName?`${a.serverDataFolderName}-dev`:void 0}),!a.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(a,{version:A.version})}}else a={},Object.keys(a).length===0&&Object.assign(a,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=a}),define(fe[23],de([0,1,4]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=e.$wk=void 0,e.$wk=(0,R.$Ii)("productService"),e.$xk="vscode://schemas/vscode-product"}),define(fe[180],de([0,1,33,6,8,2,13,30,10,23]),function(ce,e,R,a,N,A,T,k,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fjc=void 0,R=Oe(R);let I=class extends A.$Xc{constructor($,g,l){super(),this.b=g,this.c=l,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,$&&this.B(new a.$Uh(()=>{this.f($)},3e4)).schedule()}async f($){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const g=Date.now(),l=(0,T.$pc)($),d=(0,T.$qc)($),E=await k.Promises.readdir(l);await Promise.all(E.map(async w=>{if(w===d)return;const f=(0,T.$mc)(l,w),P=await R.promises.stat(f);if(P.isDirectory()&&g-P.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${w}.`),k.Promises.rm(f)}))}catch(g){(0,N.$2)(g)}}};e.$fjc=I,e.$fjc=I=Ee([X(1,y.$wk),X(2,O.$dk)],I)}),define(fe[181],de([0,1,33,6,8,2,13,30,15,10,23]),function(ce,e,R,a,N,A,T,k,O,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gjc=void 0,R=Oe(R);let p=class extends A.$Xc{constructor(g,l,d){super(),this.b=g,this.c=l,this.f=d,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new a.$Uh(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const g=Object.create(null),l=JSON.parse(await R.promises.readFile((0,T.$mc)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const P of Object.keys(l)){const m=l[P];g[`${m.hash}.${P}`]=!0}const d=(0,T.$mc)(this.b.userDataPath,"clp");if(!await k.Promises.exists(d))return;const w=await k.Promises.readdir(d);for(const P of w){if(g[P]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${P}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${P}`),await k.Promises.rm((0,T.$mc)(d,P))}const f=Date.now();for(const P of Object.keys(g)){const m=(0,T.$mc)(d,P),c=await k.Promises.readdir(m);for(const h of c){if(h==="tcf.json")continue;const i=(0,T.$mc)(m,h),n=await R.promises.stat(i);n.isDirectory()&&f-n.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,T.$mc)(P,h)}`),await k.Promises.rm(i))}}}catch(g){(0,N.$2)(g)}}};e.$gjc=p,e.$gjc=p=Ee([X(0,O.$Qi),X(1,y.$dk),X(2,I.$wk)],p)}),define(fe[182],de([0,1,13,4]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$dH=void 0,e.$dH=(0,a.$Ii)("IV8InspectProfilingService");var N;(function(A){function T(O){return!!(O.samples&&O.timeDeltas)}A.isValidProfile=T;function k(O,y="noAbsolutePaths"){for(const I of O.nodes)I.callFrame&&I.callFrame.url&&((0,R.$lc)(I.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(I.callFrame.url))&&(I.callFrame.url=(0,R.$mc)(y,(0,R.$qc)(I.callFrame.url)));return O}A.rewriteAbsolutePaths=k})(N||(e.Utils=N={}))}),define(fe[183],de([0,1,32]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xjc=void 0;class a{constructor(){this.a=new Map}async startProfiling(A){const k=await(await new Promise((y,I)=>{ce(["v8-inspect-profiler"],y,I)}).then(Oe)).startProfiling({host:A.host,port:A.port,checkForPaused:!0}),O=(0,R.$5g)();return this.a.set(O,k),O}async stopProfiling(A){const T=this.a.get(A);if(!T)throw new Error(`UNKNOWN session '${A}'`);const k=await T.stop();return this.a.delete(A),k.profile}}e.$xjc=a}),define(fe[44],de([0,1,132,12]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vo=void 0,R=Oe(R),a=Oe(a);class N{constructor(){this.a=new Map}add(T,k){R.ok(a.$hg(T)),R.ok(a.$jg(k)),R.ok(!this.a.has(T),"There is already an extension with this id"),this.a.set(T,k)}knows(T){return this.a.has(T)}as(T){return this.a.get(T)||null}}e.$vo=new N}),define(fe[105],de([0,1,3,133,44]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=void 0,N=Oe(N),e.$wo={JSONContribution:"base.contributions.json"};function A(O){return O.length>0&&O.charAt(O.length-1)==="#"?O.substring(0,O.length-1):O}class T{constructor(){this.b=new R.$oe,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(y,I){this.a[A(y)]=I,this.b.fire(y)}notifySchemaChanged(y){this.b.fire(y)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(y){const I=this.a[y];return I?(0,a.$$j)(I):void 0}hasSchemaContent(y){return!!this.a[y]}}const k=new T;N.$vo.add(e.$wo.JSONContribution,k)}),define(fe[47],de([0,1,17,3,12,11,21,105,44]),function(ce,e,R,a,N,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.ConfigurationScope=e.$Ao=e.EditPresentationTypes=void 0,e.$Lo=d,e.$Mo=E,e.$No=w,e.$Oo=P,e.$Po=m,e.$Qo=c,e.$Ro=h,N=Oe(N),A=Oe(A);var y;(function(i){i.Multiline="multilineText",i.Singleline="singlelineText"})(y||(e.EditPresentationTypes=y={})),e.$Ao={Configuration:"base.contributions.configuration"};var I;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.MACHINE=2]="MACHINE",i[i.WINDOW=3]="WINDOW",i[i.RESOURCE=4]="RESOURCE",i[i.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",i[i.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I||(e.ConfigurationScope=I={})),e.$Bo={properties:{},patternProperties:{}},e.$Co={properties:{},patternProperties:{}},e.$Do={properties:{},patternProperties:{}},e.$Eo={properties:{},patternProperties:{}},e.$Fo={properties:{},patternProperties:{}},e.$Go={properties:{},patternProperties:{}},e.$Ho="vscode://schemas/settings/resourceLanguage",e.$Io="vscode://schemas/settings/configurationDefaults";const p=O.$vo.as(k.$wo.JSONContribution);class ${constructor(){this.a=[],this.i=new Set,this.j=new a.$oe,this.onDidSchemaChange=this.j.event,this.k=new a.$oe,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:A.localize(1662,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},p.registerSchema(e.$Ho,this.h),this.z()}registerConfiguration(n,t=!0){this.registerConfigurations([n],t)}registerConfigurations(n,t=!0){const s=new Set;this.r(n,t,s),p.registerSchema(e.$Ho,this.h),this.j.fire(),this.k.fire({properties:s})}deregisterConfigurations(n){const t=new Set;this.s(n,t),p.registerSchema(e.$Ho,this.h),this.j.fire(),this.k.fire({properties:t})}updateConfigurations({add:n,remove:t}){const s=new Set;this.s(t,s),this.r(n,!1,s),p.registerSchema(e.$Ho,this.h),this.j.fire(),this.k.fire({properties:s})}registerDefaultConfigurations(n){const t=new Set;this.l(n,t),this.j.fire(),this.k.fire({properties:t,defaultsOverrides:!0})}l(n,t){this.a.push(...n);const s=[];for(const{overrides:r,source:o}of n)for(const u in r){t.add(u);const b=this.b.get(u)??this.b.set(u,{configurationDefaultOverrides:[]}).get(u),C=r[u];if(b.configurationDefaultOverrides.push({value:C,source:o}),e.$Ko.test(u)){const S=this.o(u,C,o,b.configurationDefaultOverrideValue);if(!S)continue;b.configurationDefaultOverrideValue=S,this.n(u,S,o),s.push(...d(u))}else{const S=this.p(u,C,o,b.configurationDefaultOverrideValue);if(!S)continue;b.configurationDefaultOverrideValue=S;const v=this.e[u];v&&(this.A(u,v),this.w(u,v))}}this.q(s)}deregisterDefaultConfigurations(n){const t=new Set;this.m(n,t),this.j.fire(),this.k.fire({properties:t,defaultsOverrides:!0})}m(n,t){for(const s of n){const r=this.a.indexOf(s);r!==-1&&this.a.splice(r,1)}for(const{overrides:s,source:r}of n)for(const o in s){const u=this.b.get(o);if(!u)continue;const b=u.configurationDefaultOverrides.findIndex(C=>r?C.source?.id===r.id:C.value===s[o]);if(b!==-1){if(u.configurationDefaultOverrides.splice(b,1),u.configurationDefaultOverrides.length===0&&this.b.delete(o),e.$Ko.test(o)){let C;for(const S of u.configurationDefaultOverrides)C=this.o(o,S.value,S.source,C);C&&!N.$ug(C.value)?(u.configurationDefaultOverrideValue=C,this.n(o,C,r)):(this.b.delete(o),delete this.e[o],delete this.c.properties[o])}else{let C;for(const v of u.configurationDefaultOverrides)C=this.p(o,v.value,v.source,C);u.configurationDefaultOverrideValue=C;const S=this.e[o];S&&(this.A(o,S),this.w(o,S))}t.add(o)}}this.y()}n(n,t,s){const r={type:"object",default:t.value,description:A.localize(1663,null,(0,T.$mj)(n)),$ref:e.$Ho,defaultDefaultValue:t.value,source:s,defaultValueSource:s};this.e[n]=r,this.c.properties[n]=r}o(n,t,s,r){const o=r?.value||{},u=r?.source??new Map;if(!(u instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const b of Object.keys(t)){const C=t[b];if(N.$jg(C)&&(N.$og(o[b])||N.$jg(o[b]))){if(o[b]={...o[b]??{},...C},s)for(const v in C)u.set(`${b}.${v}`,s)}else o[b]=C,s?u.set(b,s):u.delete(b)}return{value:o,source:u}}p(n,t,s,r){const o=this.e[n],u=r?.value??o?.defaultDefaultValue;let b=s;if(N.$jg(t)&&(o!==void 0&&o.type==="object"||o===void 0&&(N.$og(u)||N.$jg(u)))){if(b=r?.source??new Map,!(b instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const S in t)s&&b.set(`${n}.${S}`,s);t={...N.$jg(u)?u:{},...t}}return{value:t,source:b}}deltaConfiguration(n){let t=!1;const s=new Set;n.removedDefaults&&(this.m(n.removedDefaults,s),t=!0),n.addedDefaults&&(this.l(n.addedDefaults,s),t=!0),n.removedConfigurations&&this.s(n.removedConfigurations,s),n.addedConfigurations&&this.r(n.addedConfigurations,!1,s),this.j.fire(),this.k.fire({properties:s,defaultsOverrides:t})}notifyConfigurationSchemaUpdated(...n){this.j.fire()}registerOverrideIdentifiers(n){this.q(n),this.j.fire()}q(n){for(const t of n)this.i.add(t);this.y()}r(n,t,s){n.forEach(r=>{this.u(r,t,r.extensionInfo,r.restrictedProperties,void 0,s),this.d.push(r),this.v(r)})}s(n,t){const s=r=>{if(r.properties)for(const o in r.properties){t.add(o);const u=this.e[o];u?.policy?.name&&this.f.delete(u.policy.name),delete this.e[o],this.x(o,r.properties[o])}r.allOf?.forEach(o=>s(o))};for(const r of n){s(r);const o=this.d.indexOf(r);o!==-1&&this.d.splice(o,1)}}u(n,t=!0,s,r,o=I.WINDOW,u){o=N.$qg(n.scope)?o:n.scope;const b=n.properties;if(b)for(const S in b){const v=b[S];if(t&&P(S,v)){delete b[S];continue}if(v.source=s,v.defaultDefaultValue=b[S].default,this.A(S,v),e.$Ko.test(S)?v.scope=void 0:(v.scope=N.$qg(v.scope)?o:v.scope,v.restricted=N.$qg(v.restricted)?!!r?.includes(S):v.restricted),b[S].hasOwnProperty("included")&&!b[S].included){this.g[S]=b[S],delete b[S];continue}else this.e[S]=b[S],b[S].policy?.name&&this.f.set(b[S].policy.name,S);!b[S].deprecationMessage&&b[S].markdownDeprecationMessage&&(b[S].deprecationMessage=b[S].markdownDeprecationMessage),u.add(S)}const C=n.allOf;if(C)for(const S of C)this.u(S,t,s,r,o,u)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const n=new Map;for(const[t,s]of this.b)s.configurationDefaultOverrideValue&&n.set(t,s.configurationDefaultOverrideValue);return n}v(n){const t=s=>{const r=s.properties;if(r)for(const u in r)this.w(u,r[u]);s.allOf?.forEach(t)};t(n)}w(n,t){switch(e.$Bo.properties[n]=t,t.scope){case I.APPLICATION:e.$Co.properties[n]=t;break;case I.MACHINE:e.$Do.properties[n]=t;break;case I.MACHINE_OVERRIDABLE:e.$Eo.properties[n]=t;break;case I.WINDOW:e.$Fo.properties[n]=t;break;case I.RESOURCE:e.$Go.properties[n]=t;break;case I.LANGUAGE_OVERRIDABLE:e.$Go.properties[n]=t,this.h.properties[n]=t;break}}x(n,t){switch(delete e.$Bo.properties[n],t.scope){case I.APPLICATION:delete e.$Co.properties[n];break;case I.MACHINE:delete e.$Do.properties[n];break;case I.MACHINE_OVERRIDABLE:delete e.$Eo.properties[n];break;case I.WINDOW:delete e.$Fo.properties[n];break;case I.RESOURCE:case I.LANGUAGE_OVERRIDABLE:delete e.$Go.properties[n],delete this.h.properties[n];break}}y(){for(const n of this.i.values()){const t=`[${n}]`,s={type:"object",description:A.localize(1664,null),errorMessage:A.localize(1665,null),$ref:e.$Ho};this.A(t,s),e.$Bo.properties[t]=s,e.$Co.properties[t]=s,e.$Do.properties[t]=s,e.$Eo.properties[t]=s,e.$Fo.properties[t]=s,e.$Go.properties[t]=s}}z(){const n={type:"object",description:A.localize(1666,null),errorMessage:A.localize(1667,null),$ref:e.$Ho};e.$Bo.patternProperties[e.$Jo]=n,e.$Co.patternProperties[e.$Jo]=n,e.$Do.patternProperties[e.$Jo]=n,e.$Eo.patternProperties[e.$Jo]=n,e.$Fo.patternProperties[e.$Jo]=n,e.$Go.patternProperties[e.$Jo]=n,this.j.fire()}A(n,t){const s=this.b.get(n)?.configurationDefaultOverrideValue;let r,o;s&&(!t.disallowConfigurationDefault||!s.source)&&(r=s.value,o=s.source),N.$og(r)&&(r=t.defaultDefaultValue,o=void 0),N.$og(r)&&(r=w(t.type)),t.default=r,t.defaultValueSource=o}}const g="\\[([^\\]]+)\\]",l=new RegExp(g,"g");e.$Jo=`^(${g})+$`,e.$Ko=new RegExp(e.$Jo);function d(i){const n=[];if(e.$Ko.test(i)){let t=l.exec(i);for(;t?.length;){const s=t[1].trim();s&&n.push(s),t=l.exec(i)}}return(0,R.$Ob)(n)}function E(i){return i.reduce((n,t)=>`${n}[${t}]`,"")}function w(i){switch(Array.isArray(i)?i[0]:i){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const f=new $;O.$vo.add(e.$Ao.Configuration,f);function P(i,n){return i.trim()?e.$Ko.test(i)?A.localize(1669,null,i):f.getConfigurationProperties()[i]!==void 0?A.localize(1670,null,i):n.policy?.name&&f.getPolicyConfigurations().get(n.policy?.name)!==void 0?A.localize(1671,null,i,n.policy?.name,f.getPolicyConfigurations().get(n.policy?.name)):null:A.localize(1668,null)}function m(){const i=[],n=f.getConfigurationProperties();for(const t of Object.keys(n))i.push([t,n[t].scope]);return i.push(["launch",I.RESOURCE]),i.push(["task",I.RESOURCE]),i}function c(i){const n={};for(const t of i){const s=t.properties;if(N.$jg(s))for(const r in s)n[r]=s[r];t.allOf&&Object.assign(n,c(t.allOf))}return n}function h(i){switch(i){case"application":return I.APPLICATION;case"machine":return I.MACHINE;case"resource":return I.RESOURCE;case"machine-overridable":return I.MACHINE_OVERRIDABLE;case"language-overridable":return I.LANGUAGE_OVERRIDABLE;default:return I.WINDOW}}}),define(fe[78],de([0,1,17,3,36,2,31,29,12,9,21,47,7,44]),function(ce,e,R,a,N,A,T,k,O,y,I,p,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Vo=e.$Uo=e.$To=e.$So=void 0,e.$Wo=m,R=Oe(R),N=Oe(N),k=Oe(k),O=Oe(O);function l(n){return Object.isFrozen(n)?n:k.$jo(n)}class d{static createEmptyModel(t){return new d({},[],[],void 0,t)}constructor(t,s,r,o,u){this.b=t,this.c=s,this.d=r,this.raw=o,this.f=u,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const t=this.raw.map(s=>{if(s instanceof d)return s;const r=new E("",this.f);return r.parseRaw(s),r.configurationModel});this.g=t.reduce((s,r)=>r===s?r:s.merge(r),t[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,I.$kj)(this.contents,t):this.contents}inspect(t,s){const r=this;return{get value(){return l(r.rawConfiguration.getValue(t))},get override(){return s?l(r.rawConfiguration.getOverrideValue(t,s)):void 0},get merged(){return l(s?r.rawConfiguration.override(s).getValue(t):r.rawConfiguration.getValue(t))},get overrides(){const o=[];for(const{contents:u,identifiers:b,keys:C}of r.rawConfiguration.overrides){const S=new d(u,C,[],void 0,r.f).getValue(t);S!==void 0&&o.push({identifiers:b,value:S})}return o.length?l(o):void 0}}}getOverrideValue(t,s){const r=this.j(s);return r?t?(0,I.$kj)(r,t):r:void 0}getKeysForOverrideIdentifier(t){const s=[];for(const r of this.overrides)r.identifiers.includes(t)&&s.push(...r.keys);return R.$Ob(s)}getAllOverrideIdentifiers(){const t=[];for(const s of this.overrides)t.push(...s.identifiers);return R.$Ob(t)}override(t){let s=this.a.get(t);return s||(s=this.h(t),this.a.set(t,s)),s}merge(...t){const s=k.$io(this.contents),r=k.$io(this.overrides),o=[...this.keys],u=this.raw?.length?[...this.raw]:[this];for(const b of t)if(u.push(...b.raw?.length?b.raw:[b]),!b.isEmpty()){this.i(s,b.contents);for(const C of b.overrides){const[S]=r.filter(v=>R.$wb(v.identifiers,C.identifiers));S?(this.i(S.contents,C.contents),S.keys.push(...C.keys),S.keys=R.$Ob(S.keys)):r.push(k.$io(C))}for(const C of b.keys)o.indexOf(C)===-1&&o.push(C)}return new d(s,o,r,u.every(b=>b instanceof d)?void 0:u,this.f)}h(t){const s=this.j(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const r={};for(const o of R.$Ob([...Object.keys(this.contents),...Object.keys(s)])){let u=this.contents[o];const b=s[o];b&&(typeof u=="object"&&typeof b=="object"?(u=k.$io(u),this.i(u,b)):u=b),r[o]=u}return new d(r,this.keys,this.overrides,void 0,this.f)}i(t,s){for(const r of Object.keys(s)){if(r in t&&O.$jg(t[r])&&O.$jg(s[r])){this.i(t[r],s[r]);continue}t[r]=k.$io(s[r])}}j(t){let s=null,r=null;const o=u=>{u&&(r?this.i(r,u):r=k.$io(u))};for(const u of this.overrides)u.identifiers.length===1&&u.identifiers[0]===t?s=u.contents:u.identifiers.includes(t)&&o(u.contents);return o(s),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,s){this.k(t,s,!0)}setValue(t,s){this.k(t,s,!1)}removeValue(t){const s=this.keys.indexOf(t);s!==-1&&(this.keys.splice(s,1),(0,I.$jj)(this.contents,t),p.$Ko.test(t)&&this.overrides.splice(this.overrides.findIndex(r=>R.$wb(r.identifiers,(0,p.$Lo)(t))),1))}k(t,s,r){if((0,I.$ij)(this.contents,t,s,o=>this.f.error(o)),r=r||this.keys.indexOf(t)===-1,r&&this.keys.push(t),p.$Ko.test(t)){const o=(0,p.$Lo)(t),u={identifiers:o,keys:Object.keys(this.contents[t]),contents:(0,I.$hj)(this.contents[t],C=>this.f.error(C))},b=this.overrides.findIndex(C=>R.$wb(C.identifiers,o));b!==-1?this.overrides[b]=u:this.overrides.push(u)}}}e.$So=d;class E{constructor(t,s){this.f=t,this.g=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||d.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,s){if(!O.$qg(t)){const r=this.h(t);this.parseRaw(r,s)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,s){this.a=t;const{contents:r,keys:o,overrides:u,restricted:b,hasExcludedProperties:C}=this.i(t,s);this.b=new d(r,o,u,C?[t]:void 0,this.g),this.c=b||[]}h(t){let s={},r=null,o=[];const u=[],b=[];function C(v){Array.isArray(o)?o.push(v):r!==null&&(o[r]=v)}const S={onObjectBegin:()=>{const v={};C(v),u.push(o),o=v,r=null},onObjectProperty:v=>{r=v},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{const v=[];C(v),u.push(o),o=v,r=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:C,onError:(v,L,U)=>{b.push({error:v,offset:L,length:U})}};if(t)try{N.$0n(t,S),s=o[0]||{}}catch(v){this.g.error(`Error while parsing settings file ${this.f}: ${v}`),this.d=[v]}return s}i(t,s){const r=g.$vo.as(p.$Ao.Configuration).getConfigurationProperties(),o=this.j(t,r,!0,s);t=o.raw;const u=(0,I.$hj)(t,S=>this.g.error(`Conflict in settings file ${this.f}: ${S}`)),b=Object.keys(t),C=this.l(t,S=>this.g.error(`Conflict in settings file ${this.f}: ${S}`));return{contents:u,keys:b,overrides:C,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}j(t,s,r,o){let u=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:u};const b={},C=[];for(const S in t)if(p.$Ko.test(S)&&r){const v=this.j(t[S],s,!1,o);b[S]=v.raw,u=u||v.hasExcludedProperties,C.push(...v.restricted)}else{const v=s[S],L=v?typeof v.scope<"u"?v.scope:p.ConfigurationScope.WINDOW:void 0;v?.restricted&&C.push(S),!o.exclude?.includes(S)&&(o.include?.includes(S)||(L===void 0||o.scopes===void 0||o.scopes.includes(L))&&!(o.skipRestricted&&v?.restricted))?b[S]=t[S]:u=!0}return{raw:b,restricted:C,hasExcludedProperties:u}}l(t,s){const r=[];for(const o of Object.keys(t))if(p.$Ko.test(o)){const u={};for(const b in t[o])u[b]=t[o][b];r.push({identifiers:(0,p.$Lo)(o),keys:Object.keys(u),contents:(0,I.$hj)(u,s)})}return r}}e.$To=E;class w extends A.$Xc{constructor(t,s,r,o,u){super(),this.c=t,this.f=s,this.g=o,this.h=u,this.b=this.B(new a.$oe),this.onDidChange=this.b.event,this.a=new E(this.c.toString(),u),this.B(this.g.watch(r.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(a.Event.any(a.Event.filter(this.g.onDidFilesChange,b=>b.contains(this.c)),a.Event.filter(this.g.onDidRunOperation,b=>(b.isOperation($.FileOperation.CREATE)||b.isOperation($.FileOperation.COPY)||b.isOperation($.FileOperation.DELETE)||b.isOperation($.FileOperation.WRITE))&&r.isEqual(b.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return d.createEmptyModel(this.h)}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Uo=w;class f{constructor(t,s,r,o,u,b,C,S,v,L,U,j,F){this.a=t,this.b=s,this.c=r,this.overrideIdentifiers=o,this.d=u,this.f=b,this.g=C,this.h=S,this.i=v,this.j=L,this.k=U,this.l=j,this.m=F}get value(){return l(this.c)}n(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class P{constructor(t,s,r,o,u,b,C,S,v,L){this.j=t,this.l=s,this.m=r,this.n=o,this.p=u,this.q=b,this.r=C,this.s=S,this.t=v,this.u=L,this.h=null,this.i=new T.$Dc,this.v=null}getValue(t,s,r){return this.w(t,s,r).getValue(t)}updateValue(t,s,r={}){let o;r.resource?(o=this.t.get(r.resource),o||(o=d.createEmptyModel(this.u),this.t.set(r.resource,o))):o=this.s,s===void 0?o.removeValue(t):o.setValue(t,s),r.resource||(this.h=null)}inspect(t,s,r){const o=this.w(t,s,r),u=this.A(s.resource,r),b=s.resource?this.t.get(s.resource)||this.s:this.s,C=new Set;for(const S of o.overrides)for(const v of S.identifiers)o.getOverrideValue(t,v)!==void 0&&C.add(v);return new f(t,s,o.getValue(t),C.size?[...C]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.q:void 0,u||void 0,b)}keys(t){const s=this.A(void 0,t);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(t){this.j=t,this.h=null,this.i.clear()}updatePolicyConfiguration(t){this.l=t}updateApplicationConfiguration(t){this.m=t,this.h=null,this.i.clear()}updateLocalUserConfiguration(t){this.n=t,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(t){this.p=t,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(t){this.q=t,this.h=null,this.i.clear()}updateFolderConfiguration(t,s){this.r.set(t,s),this.i.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.i.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const r=[];if(!s){const{added:o,updated:u,removed:b}=h(this.j,t);s=[...o,...u,...b]}for(const o of s)for(const u of(0,p.$Lo)(o)){const b=this.j.getKeysForOverrideIdentifier(u),C=t.getKeysForOverrideIdentifier(u),S=[...C.filter(v=>b.indexOf(v)===-1),...b.filter(v=>C.indexOf(v)===-1),...b.filter(v=>!k.$mo(this.j.override(u).getValue(v),t.override(u).getValue(v)))];r.push([u,S])}return this.updateDefaultConfiguration(t),{keys:s,overrides:r}}compareAndUpdatePolicyConfiguration(t){const{added:s,updated:r,removed:o}=h(this.l,t),u=[...s,...r,...o];return u.length&&this.updatePolicyConfiguration(t),{keys:u,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:s,updated:r,removed:o,overrides:u}=h(this.applicationConfiguration,t),b=[...s,...r,...o];return b.length&&this.updateApplicationConfiguration(t),{keys:b,overrides:u}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:r,removed:o,overrides:u}=h(this.localUserConfiguration,t),b=[...s,...r,...o];return b.length&&this.updateLocalUserConfiguration(t),{keys:b,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:r,removed:o,overrides:u}=h(this.remoteUserConfiguration,t),b=[...s,...r,...o];return b.length&&this.updateRemoteUserConfiguration(t),{keys:b,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:r,removed:o,overrides:u}=h(this.workspaceConfiguration,t),b=[...s,...r,...o];return b.length&&this.updateWorkspaceConfiguration(t),{keys:b,overrides:u}}compareAndUpdateFolderConfiguration(t,s){const r=this.folderConfigurations.get(t),{added:o,updated:u,removed:b,overrides:C}=h(r,s),S=[...o,...u,...b];return(S.length||!r)&&this.updateFolderConfiguration(t,s),{keys:S,overrides:C}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:o,removed:u,overrides:b}=h(s,void 0);return{keys:[...r,...o,...u],overrides:b}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(t,s,r){let o=this.x(s,r);return s.overrideIdentifier&&(o=o.override(s.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(t)!==void 0&&(o=o.merge(this.l)),o}x({resource:t},s){let r=this.y();if(s&&t){const o=s.getFolder(t);o&&(r=this.z(o.uri)||r);const u=this.t.get(t);u&&(r=r.merge(u))}return r}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(t){let s=this.i.get(t);if(!s){const r=this.y(),o=this.r.get(t);o?(s=r.merge(o),this.i.set(t,s)):s=r}return s}A(t,s){if(s&&t){const r=s.getFolder(t);if(r)return this.r.get(r.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((t,s)=>{const{contents:r,overrides:o,keys:u}=this.r.get(s);return t.push([s,{contents:r,overrides:o,keys:u}]),t},[])}}allKeys(){const t=new Set;return this.j.keys.forEach(s=>t.add(s)),this.userConfiguration.keys.forEach(s=>t.add(s)),this.q.keys.forEach(s=>t.add(s)),this.r.forEach(s=>s.keys.forEach(r=>t.add(r))),[...t.values()]}B(){const t=new Set;return this.j.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.q.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.r.forEach(s=>s.getAllOverrideIdentifiers().forEach(r=>t.add(r))),[...t.values()]}D(t){const s=new Set;return this.j.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this.q.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this.r.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o))),[...s.values()]}static parse(t,s){const r=this.E(t.defaults,s),o=this.E(t.policy,s),u=this.E(t.application,s),b=this.E(t.user,s),C=this.E(t.workspace,s),S=t.folders.reduce((v,L)=>(v.set(y.URI.revive(L[0]),this.E(L[1],s)),v),new T.$Dc);return new P(r,o,u,b,d.createEmptyModel(s),C,S,d.createEmptyModel(s),new T.$Dc,s)}static E(t,s){return new d(t.contents,t.keys,t.overrides,void 0,s)}}e.$Vo=P;function m(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const t=new Set,s=new Map;for(const o of n)o.keys.forEach(u=>t.add(u)),o.overrides.forEach(([u,b])=>{const C=(0,T.$Ac)(s,u,new Set);b.forEach(S=>C.add(S))});const r=[];return s.forEach((o,u)=>r.push([u,[...o.values()]])),{keys:[...t.values()],overrides:r}}class c{constructor(t,s,r,o,u){this.change=t,this.f=s,this.g=r,this.h=o,this.i=u,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const b of t.keys)this.affectedKeys.add(b);for(const[,b]of t.overrides)for(const C of b)this.affectedKeys.add(C);this.d=this.a;for(const b of this.affectedKeys)this.d+=b+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=P.parse(this.f.data,this.i)),this.j}affectsConfiguration(t,s){const r=this.a+t,o=this.d.indexOf(r);if(o<0)return!1;const u=o+r.length;if(u>=this.d.length)return!1;const b=this.d.charCodeAt(u);if(b!==this.b&&b!==this.c)return!1;if(s){const C=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.f?.workspace):void 0,S=this.g.getValue(t,s,this.h);return!k.$mo(C,S)}return!0}}e.$Xo=c;function h(n,t){const{added:s,removed:r,updated:o}=i(t?.rawConfiguration,n?.rawConfiguration),u=[],b=n?.getAllOverrideIdentifiers()||[],C=t?.getAllOverrideIdentifiers()||[];if(t){const S=C.filter(v=>!b.includes(v));for(const v of S)u.push([v,t.getKeysForOverrideIdentifier(v)])}if(n){const S=b.filter(v=>!C.includes(v));for(const v of S)u.push([v,n.getKeysForOverrideIdentifier(v)])}if(t&&n){for(const S of b)if(C.includes(S)){const v=i({contents:n.getOverrideValue(void 0,S)||{},keys:n.getKeysForOverrideIdentifier(S)},{contents:t.getOverrideValue(void 0,S)||{},keys:t.getKeysForOverrideIdentifier(S)});u.push([S,[...v.added,...v.removed,...v.updated]])}}return{added:s,removed:r,updated:o,overrides:u}}function i(n,t){const s=n?t?n.keys.filter(u=>t.keys.indexOf(u)===-1):[...n.keys]:[],r=t?n?t.keys.filter(u=>n.keys.indexOf(u)===-1):[...t.keys]:[],o=[];if(n&&t){for(const u of t.keys)if(n.keys.indexOf(u)!==-1){const b=(0,I.$kj)(t.contents,u),C=(0,I.$kj)(n.contents,u);k.$mo(b,C)||o.push(u)}}return{added:s,removed:r,updated:o}}}),define(fe[184],de([0,1,17,3,2,29,12,78,47,10,58,44]),function(ce,e,R,a,N,A,T,k,O,y,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=e.$Zo=e.$Yo=void 0;class $ extends N.$Xc{get configurationModel(){return this.b}constructor(E){super(),this.c=E,this.a=this.B(new a.$oe),this.onDidChangeConfiguration=this.a.event,this.b=k.$So.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(p.$vo.as(O.$Ao.Configuration).onDidUpdateConfiguration(({properties:E,defaultsOverrides:w})=>this.f(Array.from(E),w))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(E,w){this.j(E,p.$vo.as(O.$Ao.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:E})}g(){return{}}h(){this.b=k.$So.createEmptyModel(this.c);const E=p.$vo.as(O.$Ao.Configuration).getConfigurationProperties();this.j(Object.keys(E),E)}j(E,w){const f=this.g();for(const P of E){const m=f[P],c=w[P];m!==void 0?this.b.setValue(P,m):c?this.b.setValue(P,c.default):this.b.removeValue(P)}}}e.$Yo=$;class g{constructor(){this.onDidChangeConfiguration=a.Event.None,this.configurationModel=k.$So.createEmptyModel(new y.$qk)}async initialize(){return this.configurationModel}}e.$Zo=g;let l=class extends N.$Xc{get configurationModel(){return this.b}constructor(E,w,f){super(),this.c=E,this.f=w,this.g=f,this.a=this.B(new a.$oe),this.onDidChangeConfiguration=this.a.event,this.b=k.$So.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(E=>this.j(E))),this.B(this.c.onDidChangeConfiguration(async({properties:E})=>this.m(await this.h(E),!0))),this.b}async h(E){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",E);const w={},f=[],P=p.$vo.as(O.$Ao.Configuration).getConfigurationProperties();for(const m of E){const c=P[m];if(!c){f.push(m);continue}if(c.policy){if(c.type!=="string"&&c.type!=="number"){this.g.warn(`Policy ${c.policy.name} has unsupported type ${c.type}`);continue}f.push(m),w[c.policy.name]={type:c.type}}}return(0,T.$ug)(w)||await this.f.updatePolicyDefinitions(w),f}j(E){this.g.trace("PolicyConfiguration#onDidChangePolicies",E);const w=p.$vo.as(O.$Ao.Configuration).getPolicyConfigurations(),f=(0,R.$Jb)(E.map(P=>w.get(P)));this.m(f,!0)}m(E,w){this.g.trace("PolicyConfiguration#update",E);const f=p.$vo.as(O.$Ao.Configuration).getConfigurationProperties(),P=[],m=this.b.isEmpty();for(const c of E){const h=f[c]?.policy?.name;if(h){const i=this.f.getPolicyValue(h);(m?i!==void 0:!(0,A.$mo)(this.b.getValue(c),i))&&P.push([c,i])}else this.b.getValue(c)!==void 0&&P.push([c,void 0])}if(P.length){this.g.trace("PolicyConfiguration#changed",P);const c=this.b;this.b=k.$So.createEmptyModel(this.g);for(const h of c.keys)this.b.setValue(h,c.getValue(h));for(const[h,i]of P)i===void 0?this.b.removeValue(h):this.b.setValue(h,i);w&&this.a.fire(this.b)}}};e.$1o=l,e.$1o=l=Ee([X(1,I.$xo),X(2,y.$dk)],l)}),define(fe[185],de([0,1,17,6,14,3,36,64,2,31,29,5,20,21,78,47,184,7,58]),function(ce,e,R,a,N,A,T,k,O,y,I,p,$,g,l,d,E,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=void 0;class P extends O.$Xc{constructor(h,i,n,t){super(),this.m=h,this.n=t,this.h=this.B(new A.$oe),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new E.$Yo(t)),this.c=n instanceof f.$zo?new E.$Zo:this.B(new E.$1o(this.b,n,t)),this.f=this.B(new l.$Uo(this.m,{},$.$ah,i,t)),this.a=new l.$Vo(this.b.configurationModel,this.c.configurationModel,l.$So.createEmptyModel(t),l.$So.createEmptyModel(t),l.$So.createEmptyModel(t),l.$So.createEmptyModel(t),new y.$Dc,l.$So.createEmptyModel(t),new y.$Dc,t),this.j=new m(h,i,this),this.g=this.B(new a.$Uh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:s,properties:r})=>this.s(s,r))),this.B(this.c.onDidChangeConfiguration(s=>this.t(s))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[h,i,n]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new l.$Vo(h,i,l.$So.createEmptyModel(this.n),n,l.$So.createEmptyModel(this.n),l.$So.createEmptyModel(this.n),new y.$Dc,l.$So.createEmptyModel(this.n),new y.$Dc,this.n)}getConfigurationData(){return this.a.toData()}getValue(h,i){const n=typeof h=="string"?h:void 0,t=(0,g.$dj)(h)?h:(0,g.$dj)(i)?i:{};return this.a.getValue(n,t,void 0)}async updateValue(h,i,n,t,s){const r=(0,g.$ej)(n)?n:(0,g.$dj)(n)?{resource:n.resource,overrideIdentifiers:n.overrideIdentifier?[n.overrideIdentifier]:void 0}:void 0,o=r?t:n;if(o!==void 0&&o!==g.ConfigurationTarget.USER_LOCAL&&o!==g.ConfigurationTarget.USER)throw new Error(`Unable to write ${h} to target ${o}.`);r?.overrideIdentifiers&&(r.overrideIdentifiers=(0,R.$Ob)(r.overrideIdentifiers),r.overrideIdentifiers=r.overrideIdentifiers.length?r.overrideIdentifiers:void 0);const u=this.inspect(h,{resource:r?.resource,overrideIdentifier:r?.overrideIdentifiers?r.overrideIdentifiers[0]:void 0});if(u.policyValue!==void 0)throw new Error(`Unable to write ${h} because it is configured in system policy.`);if((0,I.$mo)(i,u.defaultValue)&&(i=void 0),r?.overrideIdentifiers?.length&&r.overrideIdentifiers.length>1){const C=r.overrideIdentifiers.sort(),S=this.a.localUserConfiguration.overrides.find(v=>(0,R.$wb)([...v.identifiers].sort(),C));S&&(r.overrideIdentifiers=S.identifiers)}const b=r?.overrideIdentifiers?.length?[(0,d.$Mo)(r.overrideIdentifiers),h]:[h];await this.j.write(b,i),await this.reloadConfiguration()}inspect(h,i={}){return this.a.inspect(h,i,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const h=await this.f.loadConfiguration();this.r(h)}r(h){const i=this.a.toData(),n=this.a.compareAndUpdateLocalUserConfiguration(h);this.u(n,i,g.ConfigurationTarget.USER)}s(h,i){const n=this.a.toData(),t=this.a.compareAndUpdateDefaultConfiguration(h,i);this.u(t,n,g.ConfigurationTarget.DEFAULT)}t(h){const i=this.a.toData(),n=this.a.compareAndUpdatePolicyConfiguration(h);this.u(n,i,g.ConfigurationTarget.DEFAULT)}u(h,i,n){const t=new l.$Xo(h,{data:i},this.a,void 0,this.n);t.source=n,this.h.fire(t)}}e.$2o=P;class m{constructor(h,i,n){this.b=h,this.c=i,this.d=n,this.a=new a.$Ph}write(h,i){return this.a.queue(()=>this.e(h,i))}async e(h,i){let n;try{n=(await this.c.readFile(this.b)).value.toString()}catch(r){if(r.fileOperationResult===w.FileOperationResult.FILE_NOT_FOUND)n="{}";else throw r}const t=[];if((0,T.$3n)(n,t,{allowTrailingComma:!0,allowEmptyContent:!0}),t.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const s=this.f(n,h,i);n=(0,k.$ho)(n,s),await this.c.writeFile(this.b,N.$Qe.fromString(n))}f(h,i,n){const{tabSize:t,insertSpaces:s,eol:r}=this.h;if(!i.length){const o=JSON.stringify(n,null,s?" ".repeat(t):"	");return[{content:o,length:o.length,offset:0}]}return(0,k.$eo)(h,i,n,{tabSize:t,insertSpaces:s,eol:r})}get h(){if(!this.g){let h=p.OS===p.OperatingSystem.Linux||p.OS===p.OperatingSystem.Macintosh?`
`:`\r
`;const i=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});i&&typeof i=="string"&&i!=="auto"&&(h=i),this.g={eol:h,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(fe[186],de([0,1,14,3,2,70]),function(ce,e,R,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_xb=e.$0xb=e.$9xb=void 0,e.$$xb=k;const T=(y,I,p)=>{const $=new Uint8Array(16);for(let d=0;d<16;d++)$[d]=Math.round(Math.random()*256);const g=(0,R.$$e)(R.$Qe.wrap($));return[`GET ws://localhost${y}?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${g}`].join(`\r
`)+`\r
\r
`};e.$9xb=T,e.$0xb=R.$Qe.fromString(`\r
\r
`);async function k(y,I,p,$,g){y.write(R.$Qe.fromString((0,e.$9xb)(I,p,$)));const l=new N.$Wc;try{return await new Promise((d,E)=>{let w;l.add(y.onData(f=>{w?w=R.$Qe.concat([w,f],w.byteLength+f.byteLength):w=f;const P=w.indexOf(e.$0xb);if(P===-1)return;d(y),y.pauseData();const m=w.slice(P+e.$0xb.byteLength);m.byteLength&&g.onData.fire(m)})),l.add(y.onClose(f=>E(f??new Error("socket closed")))),l.add(y.onEnd(()=>E(new Error("socket ended"))))})}catch(d){throw y.dispose(),d}finally{l.dispose()}}class O extends N.$Xc{constructor(I,p){super(),this.g=I,this.a=this.B(new a.$re),this.onData=(...$)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...$)),this.b=this.B(new a.$oe),this.onDidDispose=this.b.event,this.f=!1,this.B(p.onData),this.B(p.onData.event($=>this.a.fire($))),this.onClose=this.B(p.onClose).event,this.onEnd=this.B(p.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(I,p){A.SocketDiagnostics.traceSocketEvent(this,this.g,I,p)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$_xb=O}),define(fe[106],de([0,1,8,4]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xl=e.RemoteAuthorityResolverErrorCode=e.$Wl=e.$Vl=e.RemoteConnectionType=e.$Ul=void 0,e.$Yl=y,e.$Ul=(0,a.$Ii)("remoteAuthorityResolverService");var N;(function(I){I[I.WebSocket=0]="WebSocket",I[I.Managed=1]="Managed"})(N||(e.RemoteConnectionType=N={}));class A{constructor(p){this.id=p,this.type=N.Managed}toString(){return`Managed(${this.id})`}}e.$Vl=A;class T{constructor(p,$){this.host=p,this.port=$,this.type=N.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Wl=T;var k;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound",I.InvalidAuthority="InvalidAuthority"})(k||(e.RemoteAuthorityResolverErrorCode=k={}));class O extends R.$db{static isNotAvailable(p){return p instanceof O&&p._code===k.NotAvailable}static isTemporarilyNotAvailable(p){return p instanceof O&&p._code===k.TemporarilyNotAvailable}static isNoResolverFound(p){return p instanceof O&&p._code===k.NoResolverFound}static isInvalidAuthority(p){return p instanceof O&&p._code===k.InvalidAuthority}static isHandled(p){return p instanceof O&&p.isHandled}constructor(p,$=k.Unknown,g){super(p),this._message=p,this._code=$,this._detail=g,this.isHandled=$===k.NotAvailable&&g===!0,Object.setPrototypeOf(this,O.prototype)}}e.$Xl=O;function y(I){const p=I.indexOf("+");return p===-1?I:I.substring(0,p)}}),define(fe[187],de([0,1,6,14,25,8,3,2,22,102,54,32,70,106]),function(ce,e,R,a,N,A,T,k,O,y,I,p,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$4l=u,e.$5l=b,e.$6l=S,y=Oe(y);const l=30*1e3;var d;(function(K){K[K.Management=1]="Management",K[K.ExtensionHost=2]="ExtensionHost",K[K.Tunnel=3]="Tunnel"})(d||(e.ConnectionType=d={}));function E(K){switch(K){case d.Management:return"Management";case d.ExtensionHost:return"ExtensionHost";case d.Tunnel:return"Tunnel"}}function w(K){const q=new N.$ze;return setTimeout(()=>q.cancel(),K),q.token}function f(K,q){if(K.isCancellationRequested||q.isCancellationRequested)return N.CancellationToken.Cancelled;const D=new N.$ze;return K.onCancellationRequested(()=>D.cancel()),q.onCancellationRequested(()=>D.cancel()),D.token}class P{get didTimeout(){return this.c==="timedout"}constructor(q){this.c="pending",this.d=new k.$Wc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,R.$Bh)(),q.isCancellationRequested?this.h():this.d.add(q.onCancellationRequested(()=>this.h()))}registerDisposable(q){this.c==="pending"?this.d.add(q):q.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const q=new Error("Time limit reached");return q.code="ETIMEDOUT",q.syscall="connect",q}resolve(q){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(q))}reject(q){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(q))}}function m(K,q){const D=new P(q);return D.registerDisposable(K.onControlMessage(Q=>{const oe=JSON.parse(Q.toString()),Z=W(oe);Z?D.reject(Z):D.resolve(oe)})),D.promise}function c(K,q,D,Q,oe,Z,Y,M){const z=new P(M),ie=I.$ie.create(!1);return K.info(`Creating a socket (${Y})...`),y.mark(`code/willCreateSocket/${Z}`),q.connect(D,Q,oe,Y).then(ae=>{z.didTimeout?(y.mark(`code/didCreateSocketError/${Z}`),K.info(`Creating a socket (${Y}) finished after ${ie.elapsed()} ms, but this is too late and has timed out already.`),ae?.dispose()):(y.mark(`code/didCreateSocketOK/${Z}`),K.info(`Creating a socket (${Y}) was successful after ${ie.elapsed()} ms.`),z.resolve(ae))},ae=>{y.mark(`code/didCreateSocketError/${Z}`),K.info(`Creating a socket (${Y}) returned an error after ${ie.elapsed()} ms.`),K.error(ae),z.reject(ae)}),z.promise}function h(K,q){const D=new P(q);return K.then(Q=>{D.didTimeout||D.resolve(Q)},Q=>{D.didTimeout||D.reject(Q)}),D.promise}async function i(K,q,D,Q){const oe=ee(K,q);K.logService.trace(`${oe} 1/6. invoking socketFactory.connect().`);let Z;try{Z=await c(K.logService,K.remoteSocketFactoryService,K.connectTo,O.$Vg.getServerRootPath(),`reconnectionToken=${K.reconnectionToken}&reconnection=${K.reconnectionProtocol?"true":"false"}`,E(q),`renderer-${E(q)}-${K.reconnectionToken}`,Q)}catch(ae){throw K.logService.error(`${oe} socketFactory.connect() failed or timed out. Error:`),K.logService.error(ae),ae}K.logService.trace(`${oe} 2/6. socketFactory.connect() was successful.`);let Y,M;K.reconnectionProtocol?(K.reconnectionProtocol.beginAcceptReconnection(Z,null),Y=K.reconnectionProtocol,M=!1):(Y=new $.$wi({socket:Z}),M=!0),K.logService.trace(`${oe} 3/6. sending AuthRequest control message.`);const z=await h(K.signService.createNewMessage((0,p.$5g)()),Q),ie={type:"auth",auth:K.connectionToken||"00000000000000000000",data:z.data};Y.sendControl(a.$Qe.fromString(JSON.stringify(ie)));try{const ae=await m(Y,f(Q,w(1e4)));if(ae.type!=="sign"||typeof ae.data!="string"){const Re=new Error("Unexpected handshake message");throw Re.code="VSCODE_CONNECTION_ERROR",Re}if(K.logService.trace(`${oe} 4/6. received SignRequest control message.`),!await h(K.signService.validate(z,ae.signedData),Q)){const Re=new Error("Refused to connect to unsupported server");throw Re.code="VSCODE_CONNECTION_ERROR",Re}const pe=await h(K.signService.sign(ae.data),Q),be={type:"connectionType",commit:K.commit,signedData:pe,desiredConnectionType:q};return D&&(be.args=D),K.logService.trace(`${oe} 5/6. sending ConnectionTypeRequest control message.`),Y.sendControl(a.$Qe.fromString(JSON.stringify(be))),{protocol:Y,ownsProtocol:M}}catch(ae){throw ae&&ae.code==="ETIMEDOUT"&&(K.logService.error(`${oe} the handshake timed out. Error:`),K.logService.error(ae)),ae&&ae.code==="VSCODE_CONNECTION_ERROR"&&(K.logService.error(`${oe} received error control message when negotiating connection. Error:`),K.logService.error(ae)),M&&B(Y),ae}}async function n(K,q,D,Q){const oe=Date.now(),Z=ee(K,q),{protocol:Y,ownsProtocol:M}=await i(K,q,D,Q),z=new P(Q);return z.registerDisposable(Y.onControlMessage(ie=>{const ae=JSON.parse(ie.toString()),ue=W(ae);ue?(K.logService.error(`${Z} received error control message when negotiating connection. Error:`),K.logService.error(ue),M&&B(Y),z.reject(ue)):(K.reconnectionProtocol?.endAcceptReconnection(),K.logService.trace(`${Z} 6/6. handshake finished, connection is up and running after ${J(oe)}!`),z.resolve({protocol:Y,firstMessage:ae}))})),z.promise}async function t(K,q){const{protocol:D}=await n(K,d.Management,void 0,q);return{protocol:D}}async function s(K,q,D){const{protocol:Q,firstMessage:oe}=await n(K,d.ExtensionHost,q,D),Z=oe&&oe.debugPort;return{protocol:Q,debugPort:Z}}async function r(K,q,D){const Q=Date.now(),oe=ee(K,d.Tunnel),{protocol:Z}=await i(K,d.Tunnel,q,D);return K.logService.trace(`${oe} 6/6. handshake finished, connection is up and running after ${J(Q)}!`),Z}async function o(K,q,D){const{connectTo:Q,connectionToken:oe}=await K.addressProvider.getAddress();return{commit:K.commit,quality:K.quality,connectTo:Q,connectionToken:oe,reconnectionToken:q,reconnectionProtocol:D,remoteSocketFactoryService:K.remoteSocketFactoryService,signService:K.signService,logService:K.logService}}async function u(K,q,D){return C(K,async Q=>{const{protocol:oe}=await t(Q,N.CancellationToken.None);return new H(K,q,D,Q.reconnectionToken,oe)})}async function b(K,q){return C(K,async D=>{const{protocol:Q,debugPort:oe}=await s(D,q,N.CancellationToken.None);return new te(K,q,D.reconnectionToken,Q,oe)})}async function C(K,q){for(let Q=1;;Q++)try{const oe=(0,p.$5g)(),Z=await o(K,oe,null);return await q(Z)}catch(oe){if(Q<5)K.logService.error(`[remote-connection][attempt ${Q}] An error occurred in initial connection! Will retry... Error:`),K.logService.error(oe);else throw K.logService.error(`[remote-connection][attempt ${Q}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),K.logService.error(oe),x.triggerPermanentFailure(0,0,g.$Xl.isHandled(oe)),oe}}async function S(K,q,D){const Q=await o(K,(0,p.$5g)(),null);return await r(Q,{host:q,port:D},N.CancellationToken.None)}function v(K){return(0,R.$vh)(q=>new Promise((D,Q)=>{const oe=setTimeout(D,K*1e3);q.onCancellationRequested(()=>{clearTimeout(oe),D()})}))}var L;(function(K){K[K.ConnectionLost=0]="ConnectionLost",K[K.ReconnectionWait=1]="ReconnectionWait",K[K.ReconnectionRunning=2]="ReconnectionRunning",K[K.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",K[K.ConnectionGain=4]="ConnectionGain"})(L||(e.PersistentConnectionEventType=L={}));class U{constructor(q,D){this.reconnectionToken=q,this.millisSinceLastIncomingData=D,this.type=L.ConnectionLost}}e.$7l=U;class j{constructor(q,D,Q,oe){this.reconnectionToken=q,this.millisSinceLastIncomingData=D,this.durationSeconds=Q,this.c=oe,this.type=L.ReconnectionWait}skipWait(){this.c.cancel()}}e.$8l=j;class F{constructor(q,D,Q){this.reconnectionToken=q,this.millisSinceLastIncomingData=D,this.attempt=Q,this.type=L.ReconnectionRunning}}e.$9l=F;class G{constructor(q,D,Q){this.reconnectionToken=q,this.millisSinceLastIncomingData=D,this.attempt=Q,this.type=L.ConnectionGain}}e.$0l=G;class V{constructor(q,D,Q,oe){this.reconnectionToken=q,this.millisSinceLastIncomingData=D,this.attempt=Q,this.handled=oe,this.type=L.ReconnectionPermanentFailure}}e.$$l=V;class x extends k.$Xc{static triggerPermanentFailure(q,D,Q){this._permanentFailure=!0,this.f=q,this.g=D,this.h=Q,this.j.forEach(oe=>oe.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(q=>q.y())}static debugPauseSocketWriting(){this.j.forEach(q=>q.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||x._permanentFailure}constructor(q,D,Q,oe,Z){super(),this.t=q,this.u=D,this.reconnectionToken=Q,this.protocol=oe,this.w=Z,this.m=this.B(new T.$oe),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new G(this.reconnectionToken,0,0)),this.B(oe.onSocketClose(Y=>{const M=le(this.t,this.reconnectionToken,!0);Y?Y.type===$.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${M} received socket close event (hadError: ${Y.hadError}).`),Y.error&&this.u.logService.error(Y.error)):(this.u.logService.info(`${M} received socket close event (wasClean: ${Y.wasClean}, code: ${Y.code}, reason: ${Y.reason}).`),Y.event&&this.u.logService.error(Y.event)):this.u.logService.info(`${M} received socket close event.`),this.y()})),this.B(oe.onSocketTimeout(Y=>{const M=le(this.t,this.reconnectionToken,!0);this.u.logService.info(`${M} received socket timeout event (unacknowledgedMsgCount: ${Y.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Y.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Y.timeSinceLastReceivedSomeData}).`),this.y()})),x.j.push(this),this.B((0,k.$Vc)(()=>{const Y=x.j.indexOf(this);Y>=0&&x.j.splice(Y,1)})),this.n&&this.D(x.f,x.g,x.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const q=le(this.t,this.reconnectionToken,!0);this.u.logService.info(`${q} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const D=[0,5,5,10,10,10,10,10,30];let Q=-1;do{Q++;const oe=Q<D.length?D[Q]:D[D.length-1];try{if(oe>0){const Y=v(oe);this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),oe,Y)),this.u.logService.info(`${q} waiting for ${oe} seconds before reconnecting...`);try{await Y}catch{}}if(this.n){this.u.logService.error(`${q} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Q+1)),this.u.logService.info(`${q} resolving connection...`);const Z=await o(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${q} connecting to ${Z.connectTo}...`),await this.G(Z,w(l)),this.u.logService.info(`${q} reconnected!`),this.m.fire(new G(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Q+1));break}catch(Z){if(Z.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${q} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(Z),this.C(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}if(Q>360){this.u.logService.error(`${q} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(Z),this.C(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}if(g.$Xl.isTemporarilyNotAvailable(Z)){this.u.logService.info(`${q} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Z);continue}if((Z.code==="ETIMEDOUT"||Z.code==="ENETUNREACH"||Z.code==="ECONNREFUSED"||Z.code==="ECONNRESET")&&Z.syscall==="connect"){this.u.logService.info(`${q} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Z);continue}if((0,A.$6)(Z)){this.u.logService.info(`${q} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Z);continue}if(Z instanceof g.$Xl){this.u.logService.error(`${q} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(Z),this.C(this.protocol.getMillisSinceLastIncomingData(),Q+1,g.$Xl.isHandled(Z));break}this.u.logService.error(`${q} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(Z),this.C(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}}while(!this.n&&!this.s)}C(q,D,Q){this.w?x.triggerPermanentFailure(q,D,Q):this.D(q,D,Q)}D(q,D,Q){this.m.fire(new V(this.reconnectionToken,q,D,Q)),B(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$_l=x;class H extends x{constructor(q,D,Q,oe,Z){super(d.Management,q,oe,Z,!0),this.client=this.B(new $.$ui(Z,{remoteAuthority:D,clientId:Q},q.ipcLogger))}async G(q,D){await t(q,D)}}e.$am=H;class te extends x{constructor(q,D,Q,oe,Z){super(d.ExtensionHost,q,Q,oe,!1),this.H=D,this.debugPort=Z}async G(q,D){await s(q,this.H,D)}}e.$bm=te;function B(K){try{K.acceptDisconnect();const q=K.getSocket();K.dispose(),q.dispose()}catch(q){(0,A.$2)(q)}}function W(K){if(K&&K.type==="error"){const q=new Error(`Connection error: ${K.reason}`);return q.code="VSCODE_CONNECTION_ERROR",q}return null}function _(K,q){for(;K.length<q;)K+=" ";return K}function ne(K,q){return`[remote-connection][${_(E(K),13)}][${q.substr(0,5)}\u2026]`}function le(K,q,D){return`${ne(K,q)}[${D?"reconnect":"initial"}]`}function ee(K,q){return`${le(q,K.reconnectionToken,!!K.reconnectionProtocol)}[${K.connectTo}]`}function J(K){return`${Date.now()-K} ms`}}),define(fe[107],de([0,1,22]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=a,e.$mn=N,e.$nn=A,e.$on=T;function a(O){return O.scheme===R.Schemas.vscodeRemote?O.authority:void 0}function N(O){if(!O)return;const y=O.indexOf("+");return y<0?O:O.substr(0,y)}function A(O){const{host:y,port:I}=k(O);if(typeof I>"u")throw new Error(`Invalid remote authority: ${O}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:y,port:I}}function T(O,y){let{host:I,port:p}=k(O);return typeof p>"u"&&(p=y),{host:I,port:p}}function k(O){const y=O.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(y)return{host:y[1],port:parseInt(y[2],10)};const I=O.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const p=O.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:O,port:void 0}}}),define(fe[34],de([0,1,26,4,107]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=e.$xn=e.$wn=e.$vn=e.TargetPlatform=e.ExtensionType=e.$un=e.$sn=e.$rn=e.$qn=e.$pn=void 0,e.$tn=A,e.$yn=p,e.$zn=$,e.$An=g,e.$Bn=l,e.$Cn=d,e.$Dn=E,R=Oe(R),e.$pn="extensions.user.cache",e.$qn="extensions.builtin.cache",e.$rn="undefined_publisher",e.$sn=["ui","workspace","web"];function A(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.$un=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(T||(e.ExtensionType=T={}));var k;(function(w){w.WIN32_X64="win32-x64",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(k||(e.TargetPlatform=k={}));class O{constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,P){if(typeof f>"u"||f===null)return typeof P>"u"||P===null;if(typeof P>"u"||P===null)return!1;if(typeof f=="string"||typeof P=="string"){const m=typeof f=="string"?f:f.value,c=typeof P=="string"?P:P.value;return R.$If(m,c)}return f._lower===P._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.$vn=O;class y{get size(){return this.c.size}constructor(f){if(this.c=new Set,f)for(const P of f)this.add(P)}add(f){this.c.add(O.toKey(f))}delete(f){return this.c.delete(O.toKey(f))}has(f){return this.c.has(O.toKey(f))}}e.$wn=y;class I{constructor(){this.c=new Map}clear(){this.c.clear()}delete(f){this.c.delete(O.toKey(f))}get(f){return this.c.get(O.toKey(f))}has(f){return this.c.has(O.toKey(f))}set(f,P){this.c.set(O.toKey(f),P)}values(){return this.c.values()}forEach(f){this.c.forEach(f)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$xn=I;function p(w){return $(w)}function $(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}function g(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}function l(w,f){if(f){const P=`onResolveRemoteAuthority:${(0,N.$mn)(f)}`;return!!w.activationEvents?.includes(P)}return!1}function d(w){return w.map(f=>{const[P,m]=f.split("@");return{proposalName:P,version:m?parseInt(m):void 0}})}function E(w){return w.map(f=>f.split("@")[0])}e.$En=(0,a.$Ii)("IBuiltinExtensionsScannerService")}),define(fe[27],de([0,1,5,11,34,4]),function(ce,e,R,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.$tp=e.$sp=e.$rp=e.ExtensionManagementErrorCode=e.$qp=e.ExtensionGalleryErrorCode=e.$pp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=void 0,e.$jp=k,e.$kp=O,e.$lp=y,e.$mp=I,e.$np=p,e.$op=$,e.$cp="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$dp=new RegExp(e.$cp),e.$ep="__web_extension",e.$fp="skipWalkthrough",e.$gp="extensionInstallSource",e.$hp="dependecyOrPackExtensionInstall",e.$ip="clientTargetPlatform";var T;(function(c){c.COMMAND="command",c.SETTINGS_SYNC="settingsSync"})(T||(e.ExtensionInstallSource=T={}));function k(c){switch(c){case N.TargetPlatform.WIN32_X64:return"Windows 64 bit";case N.TargetPlatform.WIN32_ARM64:return"Windows ARM";case N.TargetPlatform.LINUX_X64:return"Linux 64 bit";case N.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case N.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case N.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case N.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case N.TargetPlatform.DARWIN_X64:return"Mac";case N.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case N.TargetPlatform.WEB:return"Web";case N.TargetPlatform.UNIVERSAL:return N.TargetPlatform.UNIVERSAL;case N.TargetPlatform.UNKNOWN:return N.TargetPlatform.UNKNOWN;case N.TargetPlatform.UNDEFINED:return N.TargetPlatform.UNDEFINED}}function O(c){switch(c){case N.TargetPlatform.WIN32_X64:return N.TargetPlatform.WIN32_X64;case N.TargetPlatform.WIN32_ARM64:return N.TargetPlatform.WIN32_ARM64;case N.TargetPlatform.LINUX_X64:return N.TargetPlatform.LINUX_X64;case N.TargetPlatform.LINUX_ARM64:return N.TargetPlatform.LINUX_ARM64;case N.TargetPlatform.LINUX_ARMHF:return N.TargetPlatform.LINUX_ARMHF;case N.TargetPlatform.ALPINE_X64:return N.TargetPlatform.ALPINE_X64;case N.TargetPlatform.ALPINE_ARM64:return N.TargetPlatform.ALPINE_ARM64;case N.TargetPlatform.DARWIN_X64:return N.TargetPlatform.DARWIN_X64;case N.TargetPlatform.DARWIN_ARM64:return N.TargetPlatform.DARWIN_ARM64;case N.TargetPlatform.WEB:return N.TargetPlatform.WEB;case N.TargetPlatform.UNIVERSAL:return N.TargetPlatform.UNIVERSAL;default:return N.TargetPlatform.UNKNOWN}}function y(c,h){switch(c){case R.Platform.Windows:return h==="x64"?N.TargetPlatform.WIN32_X64:h==="arm64"?N.TargetPlatform.WIN32_ARM64:N.TargetPlatform.UNKNOWN;case R.Platform.Linux:return h==="x64"?N.TargetPlatform.LINUX_X64:h==="arm64"?N.TargetPlatform.LINUX_ARM64:h==="arm"?N.TargetPlatform.LINUX_ARMHF:N.TargetPlatform.UNKNOWN;case"alpine":return h==="x64"?N.TargetPlatform.ALPINE_X64:h==="arm64"?N.TargetPlatform.ALPINE_ARM64:N.TargetPlatform.UNKNOWN;case R.Platform.Mac:return h==="x64"?N.TargetPlatform.DARWIN_X64:h==="arm64"?N.TargetPlatform.DARWIN_ARM64:N.TargetPlatform.UNKNOWN;case R.Platform.Web:return N.TargetPlatform.WEB}}function I(c,h){return h===N.TargetPlatform.WEB&&!c.includes(N.TargetPlatform.WEB)}function p(c,h,i){return I(h,i)?!1:c===N.TargetPlatform.UNDEFINED||c===N.TargetPlatform.UNIVERSAL?!0:c===N.TargetPlatform.UNKNOWN?!1:c===i}function $(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}var g;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(g||(e.SortBy=g={}));var l;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(l||(e.SortOrder=l={}));var d;(function(c){c.Install="install",c.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var E;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(E||(e.InstallOperation=E={})),e.$pp=(0,A.$Ii)("extensionGalleryService");var w;(function(c){c.Timeout="Timeout",c.Cancelled="Cancelled",c.Failed="Failed",c.DownloadFailedWriting="DownloadFailedWriting",c.Offline="Offline"})(w||(e.ExtensionGalleryErrorCode=w={}));class f extends Error{constructor(h,i){super(h),this.code=i,this.name=i}}e.$qp=f;var P;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleApi="IncompatibleApi",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.DownloadSignature="DownloadSignature",c.DownloadFailedWriting="DownloadFailedWriting",c.UpdateMetadata="UpdateMetadata",c.Extract="Extract",c.Scanning="Scanning",c.ScanningExtension="ScanningExtension",c.ReadUninstalled="ReadUninstalled",c.UnsetUninstalled="UnsetUninstalled",c.Delete="Delete",c.Rename="Rename",c.IntializeDefaultProfile="IntializeDefaultProfile",c.AddToProfile="AddToProfile",c.InstalledExtensionNotFound="InstalledExtensionNotFound",c.PostInstall="PostInstall",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.NotAllowed="NotAllowed",c.Gallery="Gallery",c.Cancelled="Cancelled",c.Unknown="Unknown",c.Internal="Internal"})(P||(e.ExtensionManagementErrorCode=P={}));class m extends Error{constructor(h,i){super(h),this.code=i,this.name=i}}e.$rp=m,e.$sp=(0,A.$Ii)("extensionManagementService"),e.$tp="extensionsIdentifiers/disabled",e.$up="extensionsIdentifiers/enabled",e.$vp=(0,A.$Ii)("IGlobalExtensionEnablementService"),e.$wp=(0,A.$Ii)("IExtensionTipsService"),e.$xp=(0,a.localize2)(1780,"Extensions"),e.$yp=(0,a.localize2)(1781,"Preferences")}),define(fe[188],de([0,1,3,2,29,9,96,27]),function(ce,e,R,a,N,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Eq=e.$Dq=void 0;function O(E,w){return E?A.URI.revive(w?w.transformIncoming(E):E):void 0}function y(E,w){return w?w.transformOutgoingURI(E):E}function I(E,w){w=w||T.$Rn;const f=E.manifest;return{...(0,T.$Un)({...E,manifest:void 0},w),manifest:f}}function p(E,w){return E?.profileLocation?(0,T.$Un)(E,w??T.$Rn):E}function $(E,w){return w?(0,N.$ko)(E,f=>f instanceof A.URI?w.transformOutgoingURI(f):void 0):E}class g{constructor(w,f){this.a=w,this.b=f,this.onInstallExtension=R.Event.buffer(w.onInstallExtension,!0),this.onDidInstallExtensions=R.Event.buffer(w.onDidInstallExtensions,!0),this.onUninstallExtension=R.Event.buffer(w.onUninstallExtension,!0),this.onDidUninstallExtension=R.Event.buffer(w.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=R.Event.buffer(w.onDidUpdateExtensionMetadata,!0)}listen(w,f){const P=this.b(w);switch(f){case"onInstallExtension":return R.Event.map(this.onInstallExtension,m=>({...m,profileLocation:m.profileLocation?y(m.profileLocation,P):m.profileLocation}));case"onDidInstallExtensions":return R.Event.map(this.onDidInstallExtensions,m=>m.map(c=>({...c,local:c.local?$(c.local,P):c.local,profileLocation:c.profileLocation?y(c.profileLocation,P):c.profileLocation})));case"onUninstallExtension":return R.Event.map(this.onUninstallExtension,m=>({...m,profileLocation:m.profileLocation?y(m.profileLocation,P):m.profileLocation}));case"onDidUninstallExtension":return R.Event.map(this.onDidUninstallExtension,m=>({...m,profileLocation:m.profileLocation?y(m.profileLocation,P):m.profileLocation}));case"onDidUpdateExtensionMetadata":return R.Event.map(this.onDidUpdateExtensionMetadata,m=>({local:$(m.local,P),profileLocation:y(m.profileLocation,P)}))}throw new Error("Invalid listen")}async call(w,f,P){const m=this.b(w);switch(f){case"zip":{const c=I(P[0],m),h=await this.a.zip(c);return y(h,m)}case"install":return this.a.install(O(P[0],m),p(P[1],m));case"installFromLocation":return this.a.installFromLocation(O(P[0],m),O(P[1],m));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(P[0],O(P[1],m),O(P[2],m));case"getManifest":return this.a.getManifest(O(P[0],m));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(P[0]);case"installFromGallery":return this.a.installFromGallery(P[0],p(P[1],m));case"installGalleryExtensions":{const c=P[0];return this.a.installGalleryExtensions(c.map(({extension:h,options:i})=>({extension:h,options:p(i,m)??{}})))}case"uninstall":return this.a.uninstall(I(P[0],m),p(P[1],m));case"uninstallExtensions":{const c=P[0];return this.a.uninstallExtensions(c.map(({extension:h,options:i})=>({extension:I(h,m),options:p(i,m)})))}case"reinstallFromGallery":return this.a.reinstallFromGallery(I(P[0],m));case"getInstalled":return(await this.a.getInstalled(P[0],O(P[1],m),P[2])).map(h=>$(h,m));case"toggleAppliationScope":{const c=await this.a.toggleAppliationScope(I(P[0],m),O(P[1],m));return $(c,m)}case"copyExtensions":return this.a.copyExtensions(O(P[0],m),O(P[1],m));case"updateMetadata":{const c=await this.a.updateMetadata(I(P[0],m),P[1],O(P[2],m));return $(c,m)}case"resetPinnedStateForAllUserExtensions":return this.a.resetPinnedStateForAllUserExtensions(P[0]);case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(P[0],P[1],P[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$Dq=g;class l extends a.$Xc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(w){super(),this.m=w,this.c=this.B(new R.$oe),this.f=this.B(new R.$oe),this.g=this.B(new R.$oe),this.h=this.B(new R.$oe),this.j=this.B(new R.$oe),this.B(this.m.listen("onInstallExtension")(f=>this.n(this.c,{...f,source:this.r(f.source)?A.URI.revive(f.source):f.source,profileLocation:A.URI.revive(f.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(f=>this.n(this.f,f.map(P=>({...P,local:P.local?I(P.local,null):P.local,source:this.r(P.source)?A.URI.revive(P.source):P.source,profileLocation:A.URI.revive(P.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(f=>this.n(this.g,{...f,profileLocation:A.URI.revive(f.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(f=>this.n(this.h,{...f,profileLocation:A.URI.revive(f.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(f=>this.n(this.j,{profileLocation:A.URI.revive(f.profileLocation),local:I(f.local,null)})))}n(w,f){w.fire(f)}r(w){return w?typeof w.path=="string"&&typeof w.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(w){const f=await this.getTargetPlatform();return w.allTargetPlatforms.some(P=>(0,k.$np)(P,w.allTargetPlatforms,f))}zip(w){return Promise.resolve(this.m.call("zip",[w]).then(f=>A.URI.revive(f)))}install(w,f){return Promise.resolve(this.m.call("install",[w,f])).then(P=>I(P,null))}installFromLocation(w,f){return Promise.resolve(this.m.call("installFromLocation",[w,f])).then(P=>I(P,null))}async installExtensionsFromProfile(w,f,P){return(await this.m.call("installExtensionsFromProfile",[w,f,P])).map(c=>I(c,null))}getManifest(w){return Promise.resolve(this.m.call("getManifest",[w]))}installFromGallery(w,f){return Promise.resolve(this.m.call("installFromGallery",[w,f])).then(P=>I(P,null))}async installGalleryExtensions(w){return(await this.m.call("installGalleryExtensions",[w])).map(P=>({...P,local:P.local?I(P.local,null):P.local,source:this.r(P.source)?A.URI.revive(P.source):P.source,profileLocation:A.URI.revive(P.profileLocation)}))}uninstall(w,f){if(w.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstall",[w,f]))}uninstallExtensions(w){if(w.some(f=>f.extension.isWorkspaceScoped))throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstallExtensions",[w]))}reinstallFromGallery(w){return Promise.resolve(this.m.call("reinstallFromGallery",[w])).then(f=>I(f,null))}getInstalled(w=null,f,P){return Promise.resolve(this.m.call("getInstalled",[w,f,P])).then(m=>m.map(c=>I(c,null)))}updateMetadata(w,f,P){return Promise.resolve(this.m.call("updateMetadata",[w,f,P])).then(m=>I(m,null))}resetPinnedStateForAllUserExtensions(w){return this.m.call("resetPinnedStateForAllUserExtensions",[w])}toggleAppliationScope(w,f){return this.m.call("toggleAppliationScope",[w,f]).then(P=>I(P,null))}copyExtensions(w,f){return this.m.call("copyExtensions",[w,f])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(w,f,P){const m=await this.m.call("download",[w,f,P]);return A.URI.revive(m)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$Eq=l;class d{constructor(w){this.a=w}listen(w,f){throw new Error("Invalid listen")}call(w,f,P){switch(f){case"getConfigBasedTips":return this.a.getConfigBasedTips(A.URI.revive(P[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$Fq=d}),define(fe[189],de([0,1,2,34,7]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=void 0;class A extends R.$Xc{constructor(k,O,y,I,p){super(),this.a=k,this.b=O,this.c=y,this.f=p,this.B(I.onDidInstallExtensions($=>this.g($))),this.B(I.onDidUninstallExtension($=>this.h($)))}g(k){for(const O of k)O.local&&this.invalidate(O.profileLocation)}h(k){k.error||this.invalidate(k.profileLocation)}async invalidate(k){if(k)for(const O of this.a.profiles)this.c.extUri.isEqual(O.extensionsResource,k)&&await this.j(O);else await this.j(this.a.defaultProfile)}async j(k){try{await this.b.del(this.c.extUri.joinPath(k.cacheHome,a.$pn))}catch(O){(0,N.$ul)(O)!==N.FileOperationResult.FILE_NOT_FOUND&&this.f.error(O)}}}e.$3q=A});var it=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(fe[59],de([0,1,20,94,11,60,34,160]),function(ce,e,R,a,N,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=I,e.$5p=p,e.$6p=$,e.$7p=g,e.$8p=l,e.$9p=d,e.$0p=E,e.$$p=w,a=it(a),N=Oe(N),A=Oe(A);const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,y=/^-(\d{4})(\d{2})(\d{2})$/;function I(m){return m=m.trim(),m==="*"||O.test(m)}function p(m){if(!I(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=m.match(O);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}function $(m){if(!m)return null;const c=m.majorBase,h=m.majorMustEqual,i=m.minorBase;let n=m.minorMustEqual;const t=m.patchBase;let s=m.patchMustEqual;m.hasCaret&&(c===0||(n=!1),s=!1);let r=0;if(m.preRelease){const o=y.exec(m.preRelease);if(o){const[,u,b,C]=o;r=Date.UTC(Number(u),Number(b)-1,Number(C))}}return{majorBase:c,majorMustEqual:h,minorBase:i,minorMustEqual:n,patchBase:t,patchMustEqual:s,isMinimum:m.hasGreaterEquals,notBefore:r}}function g(m,c,h){let i;typeof m=="string"?i=$(p(m)):i=m;let n;c instanceof Date?n=c.getTime():typeof c=="string"&&(n=new Date(c).getTime());let t;if(typeof h=="string"?t=$(p(h)):t=h,!i||!t)return!1;const s=i.majorBase,r=i.minorBase,o=i.patchBase;let u=t.majorBase,b=t.minorBase,C=t.patchBase;const S=t.notBefore;let v=t.majorMustEqual,L=t.minorMustEqual,U=t.patchMustEqual;return t.isMinimum?s>u?!0:s<u?!1:r>b?!0:r<b||n&&n<S?!1:o>=C:(s===1&&u===0&&(!v||!L||!U)&&(u=1,b=0,C=0,v=!0,L=!1,U=!1),s<u?!1:s>u?!v:r<b?!1:r>b?!L:o<C?!1:o>C?!U:!(n&&n<S))}function l(m,c,h,i,n,t){const s=[];if(typeof i.publisher<"u"&&typeof i.publisher!="string")return s.push([a.default.Error,N.localize(1832,null)]),s;if(typeof i.name!="string")return s.push([a.default.Error,N.localize(1833,null,"name")]),s;if(typeof i.version!="string")return s.push([a.default.Error,N.localize(1834,null,"version")]),s;if(!i.engines)return s.push([a.default.Error,N.localize(1835,null,"engines")]),s;if(typeof i.engines.vscode!="string")return s.push([a.default.Error,N.localize(1836,null,"engines.vscode")]),s;if(typeof i.extensionDependencies<"u"&&!P(i.extensionDependencies))return s.push([a.default.Error,N.localize(1837,null,"extensionDependencies")]),s;if(typeof i.activationEvents<"u"){if(!P(i.activationEvents))return s.push([a.default.Error,N.localize(1838,null,"activationEvents")]),s;if(typeof i.main>"u"&&typeof i.browser>"u")return s.push([a.default.Error,N.localize(1839,null,"activationEvents","main","browser")]),s}if(typeof i.extensionKind<"u"&&typeof i.main>"u"&&s.push([a.default.Warning,N.localize(1840,null,"extensionKind")]),typeof i.main<"u"){if(typeof i.main!="string")return s.push([a.default.Error,N.localize(1841,null,"main")]),s;{const u=(0,R.$jh)(h,i.main);(0,R.$dh)(u,h)||s.push([a.default.Warning,N.localize(1842,null,u.path,h.path)])}}if(typeof i.browser<"u"){if(typeof i.browser!="string")return s.push([a.default.Error,N.localize(1843,null,"browser")]),s;{const u=(0,R.$jh)(h,i.browser);(0,R.$dh)(u,h)||s.push([a.default.Warning,N.localize(1844,null,u.path,h.path)])}}if(!A.valid(i.version))return s.push([a.default.Error,N.localize(1845,null)]),s;const r=[];if(!d(m,c,i,n,r))for(const u of r)s.push([a.default.Error,u]);if(t&&i.enabledApiProposals?.length){const u=[];if(!w([...i.enabledApiProposals],u))for(const b of u)s.push([a.default.Error,b])}return s}function d(m,c,h,i,n){return i||typeof h.main>"u"&&typeof h.browser>"u"?!0:f(m,c,h.engines.vscode,n)}function E(m,c,h){return m==="*"||f(c,h,m)}function w(m,c){if(m.length===0)return!0;const h=Array.isArray(c)?c:void 0,i=(h?void 0:c)??k.allApiProposals,n=[],t=(0,T.$Cn)(m);for(const{proposalName:s,version:r}of t){const o=i[s];o&&r&&o.version!==r&&n.push(N.localize(1846,null,s))}return h?.push(...n),n.length===0}function f(m,c,h,i=[]){const n=$(p(h));if(!n)return i.push(N.localize(1847,null,h)),!1;if(n.majorBase===0){if(!n.majorMustEqual||!n.minorMustEqual)return i.push(N.localize(1848,null,h)),!1}else if(!n.majorMustEqual)return i.push(N.localize(1849,null,h)),!1;return g(m,c,n)?!0:(i.push(N.localize(1850,null,m,h)),!1)}function P(m){if(!Array.isArray(m))return!1;for(let c=0,h=m.length;c<h;c++)if(typeof m[c]!="string")return!1;return!0}}),define(fe[79],de([0,1,25,2,5,11,27,4]),function(ce,e,R,a,N,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gs=e.$fs=void 0,e.$es=O;function O(I){return I.tags.find(p=>p.startsWith("lp-"))?.split("lp-")[1]}e.$fs=(0,k.$Ii)("languagePackService");let y=class extends a.$Xc{constructor(p){super(),this.c=p}async getAvailableLanguages(){const p=new R.$ze;setTimeout(()=>p.cancel(),1e3);let $;try{$=await this.c.query({text:'category:"language packs"',pageSize:20},p.token)}catch{return[]}const l=$.firstPage.filter(d=>d.properties.localizedLanguages?.length&&d.tags.some(E=>E.startsWith("lp-"))).map(d=>{const E=d.properties.localizedLanguages?.[0],w=O(d);return{...this.f(w,E,d),extensionId:d.identifier.id,galleryExtension:d}});return l.push(this.f("en","English")),l}f(p,$,g){const l=$??p;let d;if(l!==p&&(d=`(${p})`),p.toLowerCase()===N.$x.toLowerCase()&&(d??="",d+=(0,A.localize)(1928,null)),g?.installCount){d??="";const E=g.installCount;let w;E>1e6?w=`${Math.floor(E/1e5)/10}M`:E>1e3?w=`${Math.floor(E/1e3)}K`:w=String(E),d+=` $(cloud-download) ${w}`}return{id:p,label:l,description:d}}};e.$gs=y,e.$gs=y=Ee([X(0,T.$pp)],y)}),define(fe[190],de([0,1,2,79]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hjc=void 0;let N=class extends R.$Xc{constructor(T){super(),this.a=T,this.b()}b(){this.a.update()}};e.$hjc=N,e.$hjc=N=Ee([X(0,a.$fs)],N)}),define(fe[108],de([0,1,2,4]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1l=e.$Zl=void 0,e.$Zl=(0,a.$Ii)("remoteSocketFactoryService");class N{constructor(){this.a={}}register(T,k){return this.a[T]??=[],this.a[T].push(k),(0,R.$Vc)(()=>{const O=this.a[T]?.indexOf(k);typeof O=="number"&&O>=0&&this.a[T]?.splice(O,1)})}b(T){return(this.a[T.type]||[]).find(O=>O.supports(T))}connect(T,k,O,y){const I=this.b(T);if(!I)throw new Error(`No socket factory found for ${T}`);return I.connect(T,k,O,y)}}e.$1l=N}),define(fe[191],de([0,1,4]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vjc=e.$ujc=void 0,e.$ujc=(0,R.$Ii)("sharedProcessTunnelService"),e.$vjc="sharedProcessTunnel"}),define(fe[109],de([0,1,4,11]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fjc=e.$Ejc=e.$Djc=e.$Cjc=e.$Bjc=e.TunnelStates=e.$Ajc=e.$zjc=void 0,e.$zjc=(0,R.$Ii)("IRemoteTunnelService"),e.$Ajc={active:!1};var N;(function(A){A.disconnected=T=>({type:"disconnected",onTokenFailed:T}),A.connected=(T,k)=>({type:"connected",info:T,serviceInstallFailed:k}),A.connecting=T=>({type:"connecting",progress:T}),A.uninitialized={type:"uninitialized"}})(N||(e.TunnelStates=N={})),e.$Bjc="remote.tunnels.access",e.$Cjc=e.$Bjc+".hostNameOverride",e.$Djc=e.$Bjc+".preventSleep",e.$Ejc="remoteTunnelService",e.$Fjc=(0,a.localize)(2044,null)}),define(fe[61],de([0,1,14,8,2,11,47,4,10,44]),function(ce,e,R,a,N,A,T,k,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$_p=void 0,e.$bq=$,e.$cq=g,e.$dq=l,e.$eq=d,e.$fq=E,e.$gq=w,e.$_p=(0,k.$Ii)("requestService");class I{constructor(c){this.b=c}toJSON(){if(!this.a){const c=Object.create(null);for(const h in this.b)h.toLowerCase()==="authorization"||h.toLowerCase()==="proxy-authorization"?c[h]="*****":c[h]=this.b[h];this.a=c}return this.a}}class p extends N.$Xc{constructor(c){super(),this.b=0,this.a=c.createLogger("network",{name:(0,A.localize)(2050,null),when:O.$vk.isEqualTo((0,O.$sk)(O.LogLevel.Trace)).serialize()})}async c(c,h,i){const n=`${c} #${++this.b}: ${h.url}`;this.a.trace(`${n} - begin`,h.type,new I(h.headers??{}));try{const t=await i();return this.a.trace(`${n} - end`,h.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.a.error(`${n} - error`,h.type,(0,a.$_)(t)),t}}}e.$aq=p;function $(m){return m.res.statusCode&&m.res.statusCode>=200&&m.res.statusCode<300||m.res.statusCode===1223}function g(m){return m.res.statusCode===204}async function l(m){return g(m)?null:(await(0,R.$3e)(m.stream)).toString()}async function d(m){if(!$(m))throw new Error("Server returned "+m.res.statusCode);return l(m)}async function E(m){if(!$(m))throw new Error("Server returned "+m.res.statusCode);if(g(m))return null;const h=(await(0,R.$3e)(m.stream)).toString();try{return JSON.parse(h)}catch(i){throw i.message+=`:
`+h,i}}function w(m){P(m)}let f;function P(m){const c=y.$vo.as(T.$Ao.Configuration),h=f;f={id:"http",order:15,title:(0,A.localize)(2051,null),type:"object",scope:m,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2052,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(2053,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(2054,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,A.localize)(2055,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(2056,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(2057,null),(0,A.localize)(2058,null),(0,A.localize)(2059,null),(0,A.localize)(2060,null)],default:"override",description:(0,A.localize)(2061,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(2062,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(2063,null),restricted:!0}}},c.updateConfigurations({add:[f],remove:h?[h]:[]})}P(T.ConfigurationScope.APPLICATION)}),define(fe[192],de([0,1,25,22,7,61]),function(ce,e,R,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iS=void 0;let T=class{constructor(O,y){this.a=O,this.b=y}async download(O,y,I=R.CancellationToken.None){if(O.scheme===a.Schemas.file||O.scheme===a.Schemas.vscodeRemote){await this.b.copy(O,y);return}const p={type:"GET",url:O.toString(!0)},$=await this.a.request(p,I);if($.res.statusCode===200)await this.b.writeFile(y,$.stream);else{const g=await(0,A.$eq)($);throw new Error(`Expected 200, got back ${$.res.statusCode} instead.

${g}`)}}};e.$iS=T,e.$iS=T=Ee([X(0,A.$_p),X(1,N.$dl)],T)}),define(fe[193],de([0,1,14,25]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=e.$is=void 0;class N{constructor(k){this.a=k}listen(k,O){throw new Error("Invalid listen")}call(k,O,y,I=a.CancellationToken.None){switch(O){case"request":return this.a.request(y[0],I).then(async({res:p,stream:$})=>{const g=await(0,R.$3e)($);return[{statusCode:p.statusCode,headers:p.headers},g]});case"resolveProxy":return this.a.resolveProxy(y[0]);case"lookupAuthorization":return this.a.lookupAuthorization(y[0]);case"lookupKerberosAuthorization":return this.a.lookupKerberosAuthorization(y[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$is=N;class A{constructor(k){this.a=k}async request(k,O){const[y,I]=await this.a.call("request",[k],O);return{res:y,stream:(0,R.$5e)(I)}}async resolveProxy(k){return this.a.call("resolveProxy",[k])}async lookupAuthorization(k){return this.a.call("lookupAuthorization",[k])}async lookupKerberosAuthorization(k){return this.a.call("lookupKerberosAuthorization",[k])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$js=A}),define(fe[194],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7hc=e.$6hc=e.$5hc=void 0,e.$5hc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$6hc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$7hc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(fe[195],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndc=void 0;class R{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(N){try{const A=await this.c();if(A){const T=String(R.a++);return this.b.set(T,A),{id:T,data:A.createNewMessage(N)}}}catch{}return{id:"",data:N}}async validate(N,A){if(!N.id)return!0;const T=this.b.get(N.id);if(!T)return!1;this.b.delete(N.id);try{return T.validate(A)==="ok"}catch{return!1}finally{T.dispose?.()}}async sign(N){try{return await this.d(N)}catch{}return N}}e.$Ndc=R}),define(fe[110],de([0,1,4]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3l=e.$2l=void 0,e.$2l="signService",e.$3l=(0,R.$Ii)(e.$2l)}),define(fe[196],de([0,1,67,195]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wic=void 0;class N extends a.$Ndc{c(){return this.h().then(T=>new T.validator)}d(T){return this.h().then(k=>new k.signer().sign(T))}async h(){return(0,R.$xq)("vsda","index.js")}}e.$Wic=N}),define(fe[80],de([0,1,3,2]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HNb=e.$GNb=e.$FNb=e.$ENb=void 0;class N extends a.$Xc{constructor(p,$,g){super(),this.a=p,this.b=$,this.c=g}async getItems(){const p={profile:this.b,workspace:this.c},$=await this.a.call("getItems",p);return new Map($)}updateItems(p){const $={profile:this.b,workspace:this.c};return p.insert&&($.insert=Array.from(p.insert.entries())),p.delete&&($.delete=Array.from(p.delete.values())),this.a.call("updateItems",$)}optimize(){const p={profile:this.b,workspace:this.c};return this.a.call("optimize",p)}}class A extends N{constructor(p,$){super(p,$,void 0),this.f=this.B(new R.$oe),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(p=>this.h(p)))}h(p){(Array.isArray(p.changed)||Array.isArray(p.deleted))&&this.f.fire({changed:p.changed?new Map(p.changed):void 0,deleted:p.deleted?new Set(p.deleted):void 0})}}class T extends A{constructor(p){super(p,void 0)}async close(){this.dispose()}}e.$ENb=T;class k extends A{constructor(p,$){super(p,$)}async close(){this.dispose()}}e.$FNb=k;class O extends N{constructor(p,$){super(p,void 0,$),this.onDidChangeItemsExternal=R.Event.None}async close(){this.dispose()}}e.$GNb=O;class y{constructor(p){this.a=p}isUsed(p){const $={payload:p,profile:void 0,workspace:void 0};return this.a.call("isUsed",$)}}e.$HNb=y}),define(fe[111],de([0,1,5,37,32]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=T,e.$Ap=k;function A(O){if(R.$v===R.Platform.Linux&&/^penguin(\.|$)/i.test(O))return"chromebook"}function T(O,y,I,p,$,g,l,d,E,w){const f=Object.create(null);f["common.machineId"]=g,f["common.sqmId"]=l,f["common.devDeviceId"]=d,f.sessionID=(0,N.$5g)()+Date.now(),f.commitHash=p,f.version=$,f["common.platformVersion"]=(O||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,R.$i)(R.$v),f["common.nodePlatform"]=a.$gc,f["common.nodeArch"]=I,f["common.product"]=w||"desktop",E&&(f["common.msftInternal"]=E);let P=0;const m=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-m,enumerable:!0},"common.sequence":{get:()=>P++,enumerable:!0}}),R.$m&&(f["common.snap"]="true");const c=A(y);return c&&(f["common.platformDetail"]=c),f}function k(O){const y=a.env.USERDNSDOMAIN;if(!y)return!1;const I=y.toLowerCase();return O.some(p=>I===p)}}),define(fe[18],de([0,1,4]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=void 0,e.$cm=(0,R.$Ii)("telemetryService"),e.$dm=(0,R.$Ii)("customEndpointTelemetryService"),e.$em="telemetry.currentSessionDate",e.$fm="telemetry.firstSessionDate",e.$gm="telemetry.lastSessionDate",e.$hm="telemetry.machineId",e.$im="telemetry.sqmId",e.$jm="telemetry.devDeviceId",e.$km="telemetry",e.$lm="telemetry.telemetryLevel",e.$mm="telemetry.enableCrashReporter",e.$nm="telemetry.enableTelemetry";var a;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(a||(e.TelemetryLevel=a={}));var N;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(N||(e.TelemetryConfiguration=N={}))}),define(fe[197],de([0,1,33,38,6,36,22,13,5,54,9,142,30,149,99,7,23,18]),function(ce,e,R,a,N,A,T,k,O,y,I,p,$,g,l,d,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8s=void 0,e.$5s=P,e.$6s=c,e.$7s=h,R=Oe(R),a=Oe(a);const f=new Map;async function P(n,t){const s=`${n}::${t.join(":")}`,r=f.get(s);if(r)return r;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],u=new Map,b=new Map,C=2e4;function S(L,U,j,F){const G=U.substring(L.length+1);return N.Promises.withAsyncBody(async V=>{let x;F.readdirCount++;try{x=await $.Promises.readdir(U,{withFileTypes:!0})}catch{V();return}if(F.count>=C){F.count+=x.length,F.maxReached=!0,V();return}let H=x.length;if(H===0){V();return}let te=x;F.count+x.length>C&&(F.maxReached=!0,H=C-F.count,te=x.slice(0,H)),F.count+=x.length;for(const B of te)if(B.isDirectory()){if(j.includes(B.name)||await S(L,(0,k.$mc)(U,B.name),j,F),--H===0){V();return}}else{const W=B.name.lastIndexOf(".");if(W>=0){const _=B.name.substring(W+1);_&&u.set(_,(u.get(_)??0)+1)}for(const _ of o)_.relativePathPattern?.test(G)!==!1&&_.filePattern.test(B.name)&&b.set(_.tag,(b.get(_.tag)??0)+1);if(--H===0){V();return}}})}const v=N.Promises.withAsyncBody(async L=>{const U={count:0,maxReached:!1,readdirCount:0},j=new y.$ie(!0);await S(n,n,t,U);const F=await h(n);L({configFiles:m(b),fileTypes:m(u),fileCount:U.count,maxFilesReached:U.maxReached,launchConfigFiles:F,totalScanTime:j.elapsed(),totalReaddirCount:U.readdirCount})});return f.set(s,v),v}function m(n){return Array.from(n.entries(),([t,s])=>({name:t,count:s})).sort((t,s)=>s.count-t.count)}function c(){const n={os:`${a.type()} ${a.arch()} ${a.release()}`,memory:`${(a.totalmem()/d.$Ll.GB).toFixed(2)}GB (${(a.freemem()/d.$Ll.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(p.$Wn.value()*100)}%`},t=a.cpus();return t&&t.length>0&&(n.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),n}async function h(n){try{const t=new Map,s=(0,k.$mc)(n,".vscode","launch.json"),r=await R.promises.readFile(s),o=[],u=(0,A.$3n)(r.toString(),o);if(o.length)return console.log(`Unable to parse ${s}`),[];if((0,A.$$n)(u)==="object"&&u.configurations)for(const b of u.configurations){const C=b.type;C&&(t.has(C)?t.set(C,t.get(C)+1):t.set(C,1))}return m(t)}catch{return[]}}let i=class{constructor(t,s){this.c=t,this.d=s}f(t){const s=[];return s.push(`OS Version:       ${t.os}`),s.push(`CPUs:             ${t.cpus}`),s.push(`Memory (System):  ${t.memory}`),s.push(`VM:               ${t.vmHint}`),s.join(`
`)}g(t){const s=[];s.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),s.push(`OS Version:       ${a.type()} ${a.arch()} ${a.release()}`);const r=a.cpus();return r&&r.length>0&&s.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),s.push(`Memory (System):  ${(a.totalmem()/d.$Ll.GB).toFixed(2)}GB (${(a.freemem()/d.$Ll.GB).toFixed(2)}GB free)`),O.$j||s.push(`Load (avg):       ${a.loadavg().map(o=>Math.round(o)).join(", ")}`),s.push(`VM:               ${Math.round(p.$Wn.value()*100)}%`),s.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${t.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.j(t.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(t,s){return Promise.all([(0,g.$4s)(t.mainPID),this.k(t)]).then(async r=>{let[o,u]=r,b=this.m(t,o);return s.forEach(C=>{if((0,l.$Xm)(C))b+=`
${C.errorMessage}`,u+=`
${C.errorMessage}`;else if(b+=`

Remote: ${C.hostName}`,C.processes&&(b+=`
${this.m(t,C.processes)}`),C.workspaceMetadata){u+=`
|  Remote: ${C.hostName}`;for(const S of Object.keys(C.workspaceMetadata)){const v=C.workspaceMetadata[S];let L=`${v.fileCount} files`;v.maxFilesReached&&(L=`more than ${L}`),u+=`|    Folder (${S}): ${L}`,u+=this.h(v)}}}),{processInfo:b,workspaceInfo:u}})}async getSystemInfo(t,s){const{memory:r,vmHint:o,os:u,cpus:b}=c(),C={os:u,memory:r,cpus:b,vmHint:o,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:s};return O.$j||(C.load=`${a.loadavg().map(S=>Math.round(S)).join(", ")}`),O.$l&&(C.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(C)}async getDiagnostics(t,s){const r=[];return(0,g.$4s)(t.mainPID).then(async o=>(r.push(""),r.push(this.g(t)),r.push(""),r.push(this.m(t,o)),t.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.k(t))),s.forEach(u=>{if((0,l.$Xm)(u))r.push(`
${u.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${u.hostName}`),r.push(this.f(u.machineInfo)),u.processes&&r.push(this.m(t,u.processes)),u.workspaceMetadata)for(const b of Object.keys(u.workspaceMetadata)){const C=u.workspaceMetadata[b];let S=`${C.fileCount} files`;C.maxFilesReached&&(S=`more than ${S}`),r.push(`Folder (${b}): ${S}`),r.push(this.h(C))}}),r.push(""),r.push(""),r.join(`
`)))}h(t){const s=[];let o=0;const u=(v,L)=>{const U=` ${v}(${L})`;o+U.length>60?(s.push(b),b="|                 ",o=b.length):o+=U.length,b+=U};let b="|      File types:";const C=10,S=t.fileTypes.length>C?C:t.fileTypes.length;for(let v=0;v<S;v++){const L=t.fileTypes[v];u(L.name,L.count)}if(s.push(b),t.configFiles.length>=0&&(b="|      Conf files:",o=0,t.configFiles.forEach(v=>{u(v.name,v.count)}),s.push(b)),t.launchConfigFiles.length>0){let v="|      Launch Configs:";t.launchConfigFiles.forEach(L=>{const U=L.count>1?` ${L.name}(${L.count})`:` ${L.name}`;v+=U}),s.push(v)}return s.join(`
`)}j(t){const s=Math.max(...Object.keys(t).map(r=>r.length));return Object.keys(t).map(r=>`${r}:  ${" ".repeat(s-r.length)}  ${t[r]}`).join(`
                  `)}k(t){const s=[],r=[];return t.windows.forEach(o=>{o.folderURIs.length===0||o.remoteAuthority||(s.push(`|  Window (${o.title})`),o.folderURIs.forEach(u=>{const b=I.URI.revive(u);if(b.scheme===T.Schemas.file){const C=b.fsPath;r.push(P(C,["node_modules",".git"]).then(S=>{let v=`${S.fileCount} files`;S.maxFilesReached&&(v=`more than ${v}`),s.push(`|    Folder (${(0,k.$qc)(C)}): ${v}`),s.push(this.h(S))}).catch(S=>{s.push(`|      Error: Unable to collect workspace stats for folder ${C} (${S.toString()})`)}))}else s.push(`|    Folder (${b.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(o=>s.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}m(t,s){const r=new Map;t.windows.forEach(u=>r.set(u.pid,`window [${u.id}] (${u.title})`)),t.pidToNames.forEach(({pid:u,name:b})=>r.set(u,b));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),s&&this.n(t.mainPID,r,o,s,0),o.join(`
`)}n(t,s,r,o,u){const b=u===0;let C;b?C=o.pid===t?`${this.d.applicationName} main`:"remote agent":s.has(o.pid)?C=s.get(o.pid):C=`${"  ".repeat(u)} ${o.name}`;const S=process.platform==="win32"?o.mem:a.totalmem()*(o.mem/100);r.push(`${o.load.toFixed(0).padStart(5," ")}	${(S/d.$Ll.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${C}`),Array.isArray(o.children)&&o.children.forEach(v=>this.n(t,s,r,v,u+1))}async getWorkspaceFileExtensions(t){const s=new Set;for(const{uri:r}of t.folders){const o=I.URI.revive(r);if(o.scheme!==T.Schemas.file)continue;const u=o.fsPath;try{(await P(u,["node_modules",".git"])).fileTypes.forEach(C=>s.add(C.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(t){for(const{uri:s}of t.folders){const r=I.URI.revive(s);if(r.scheme!==T.Schemas.file)continue;const o=r.fsPath;try{const u=await P(o,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),u.fileTypes.forEach(b=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:b.name,count:b.count})}),u.launchConfigFiles.forEach(b=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:b.name,count:b.count})}),u.configFiles.forEach(b=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:b.name,count:b.count})}),this.c.publicLog2("workspace.stats.metadata",{duration:u.totalScanTime,reachedLimit:u.maxFilesReached,fileCount:u.fileCount,readdirCount:u.totalReaddirCount})}catch{}}}};e.$8s=i,e.$8s=i=Ee([X(0,w.$cm),X(1,E.$wk)],i)}),define(fe[112],de([0,1,67,8,4,10,18]),function(ce,e,R,a,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=e.$Aq=e.ExtensionSignatureVerificationCode=e.$zq=void 0,e.$zq=(0,N.$Ii)("IExtensionSignatureVerificationService");var k;(function(I){I.Success="Success",I.RequiredArgumentMissing="RequiredArgumentMissing",I.InvalidArgument="InvalidArgument",I.PackageIsUnreadable="PackageIsUnreadable",I.UnhandledException="UnhandledException",I.SignatureManifestIsMissing="SignatureManifestIsMissing",I.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",I.SignatureIsMissing="SignatureIsMissing",I.SignatureIsUnreadable="SignatureIsUnreadable",I.CertificateIsUnreadable="CertificateIsUnreadable",I.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",I.FileAlreadyExists="FileAlreadyExists",I.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",I.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",I.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",I.SignatureIsInvalid="SignatureIsInvalid",I.SignatureManifestIsInvalid="SignatureManifestIsInvalid",I.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",I.EntryIsMissing="EntryIsMissing",I.EntryIsTampered="EntryIsTampered",I.Untrusted="Untrusted",I.CertificateRevoked="CertificateRevoked",I.SignatureIsNotValid="SignatureIsNotValid",I.UnknownError="UnknownError",I.PackageIsInvalidZip="PackageIsInvalidZip",I.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(k||(e.ExtensionSignatureVerificationCode=k={}));class O extends Error{constructor(p){super(p),this.code=p}}e.$Aq=O;let y=class{constructor(p,$){this.b=p,this.c=$}d(){return this.a||(this.a=this.f()),this.a}async f(){return(0,R.$xq)("@vscode/vsce-sign","src/main.js")}async verify(p,$,g,l){let d;const E=p.identifier.id;try{d=await this.d()}catch(m){return this.b.error("Could not load vsce-sign module",(0,a.$_)(m)),this.b.info(`Extension signature verification is not done: ${E}`),!1}const w=new Date().getTime();let f;try{this.b.trace(`Verifying extension signature for ${E}...`),f=await d.verify($,g,this.b.getLevel()===A.LogLevel.Trace)}catch(m){f={code:k.UnknownError,didExecute:!1,output:(0,a.$_)(m)}}const P=new Date().getTime()-w;if(this.b.info(`Extension signature verification result for ${E}: ${f.code}. Executed: ${f.didExecute}. Duration: ${P}ms.`),this.b.trace(`Extension signature verification output for ${E}:
${f.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:E,extensionVersion:p.version,code:f.code,internalCode:f.internalCode,duration:P,didExecute:f.didExecute,clientTargetPlatform:l}),f.code===k.Success)return!0;throw new O(f.code)}};e.$Bq=y,e.$Bq=y=Ee([X(0,A.$dk),X(1,T.$cm)],y)}),define(fe[113],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$hc=e.$0hc=void 0;class R{constructor(A){this.b=A}listen(A,T){throw new Error(`Event not found: ${T}`)}call(A,T,{eventName:k,data:O}){return this.b.forEach(y=>y.log(k,O)),Promise.resolve(null)}}e.$0hc=R;class a{constructor(A){this.b=A}log(A,T){return this.b.call("log",{eventName:A,data:T}).then(void 0,k=>`Failed to log telemetry: ${console.warn(k)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$$hc=a}),define(fe[48],de([0,1,29,12,107,111,18]),function(ce,e,R,a,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=e.$Gp=e.$Fp=e.$Ep=e.$Dp=e.$Cp=e.$Bp=void 0,e.$Ip=I,e.$Jp=p,e.$Kp=$,e.$Lp=g,e.$Mp=d,e.$Np=w,e.$Op=f,e.$Pp=c;class k{constructor(i){this.value=i,this.isTrustedTelemetryValue=!0}}e.$Bp=k;class O{constructor(){this.telemetryLevel=T.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Cp=O,e.$Dp=new O;class y{async publicLog(i,n,t){}async publicLogError(i,n,t){}}e.$Ep=y,e.$Fp="telemetry",e.$Gp="extensionTelemetryLog",e.$Hp={log:()=>null,flush:()=>Promise.resolve(null)};function I(h,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!h.enableTelemetry)}function p(h,i){return i.extensionTestsLocationURI?!0:!(i.isBuilt||i.disableTelemetry||h.enableTelemetry&&h.aiConfig?.ariaKey)}function $(h){const i=h.getValue(T.$lm),n=h.getValue(T.$mm);if(h.getValue(T.$nm)===!1||n===!1)return T.TelemetryLevel.NONE;switch(i??T.TelemetryConfiguration.ON){case T.TelemetryConfiguration.ON:return T.TelemetryLevel.USAGE;case T.TelemetryConfiguration.ERROR:return T.TelemetryLevel.ERROR;case T.TelemetryConfiguration.CRASH:return T.TelemetryLevel.CRASH;case T.TelemetryConfiguration.OFF:return T.TelemetryLevel.NONE}}function g(h){const i={},n={},t={};E(h,t);for(let s in t){s=s.length>150?s.substr(s.length-149):s;const r=t[s];typeof r=="number"?n[s]=r:typeof r=="boolean"?n[s]=r?1:0:typeof r=="string"?(r.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${r.length}`),i[s]=r.substring(0,8191)):typeof r<"u"&&r!==null&&(i[s]=r)}return{properties:i,measurements:n}}const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function d(h){if(!h)return"none";const i=(0,N.$mn)(h);return l.has(i)?i:"other"}function E(h,i,n=0,t){if(h)for(const s of Object.getOwnPropertyNames(h)){const r=h[s],o=t?t+s:s;Array.isArray(r)?i[o]=(0,R.$no)(r):r instanceof Date?i[o]=r.toISOString():(0,a.$jg)(r)?n<2?E(r,i,n+1,o+"."):i[o]=(0,R.$no)(r):i[o]=r}}function w(h,i){const n=h.msftInternalDomains||[],t=i.getValue("telemetry.internalTesting");return(0,A.$Ap)(n)||t}function f(h){return[h.appRoot,h.extensionsPath,h.userHome.fsPath,h.tmpDir.fsPath,h.userDataPath]}function P(h,i){if(!h||!h.includes("/")&&!h.includes("\\"))return h;let n=h;const t=[];for(const u of i)for(;;){const b=u.exec(h);if(!b)break;t.push([b.index,u.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(n="";;){const u=r.exec(h);if(!u)break;const b=t.some(([C,S])=>u.index<S&&C<r.lastIndex);!s.test(u[0])&&!b&&(n+=h.substring(o,u.index)+"<REDACTED: user-file-path>",o=r.lastIndex)}return o<h.length&&(n+=h.substr(o)),n}function m(h){if(!h)return h;const i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of i)if(n.regex.test(h))return`<REDACTED: ${n.label}>`;return h}function c(h,i){return(0,R.$ko)(h,n=>{if(n instanceof k||Object.hasOwnProperty.call(n,"isTrustedTelemetryValue"))return n.value;if(typeof n=="string"){let t=n.replaceAll("%20"," ");t=P(t,i);for(const s of i)t=t.replace(s,"");return t=m(t),t}})}}),define(fe[35],de([0,1,26,27,34,5,9,8,37,48]),function(ce,e,R,a,N,A,T,k,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=e.$Rp=void 0,e.$Qp=I,e.$Sp=l,e.$Tp=d,e.$Up=E,e.$Vp=w,e.$Wp=f,e.$Xp=P,e.$Yp=m,e.$1p=c,e.$2p=i;function I(n,t){return n.uuid&&t.uuid?n.uuid===t.uuid:n.id===t.id?!0:(0,R.$Df)(n.id,t.id)===0}const p=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class ${static create(t){const s=t.manifest?t.manifest.version:t.version,r=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new $(t.identifier,s,r)}static parse(t){const s=p.exec(t);return s&&s[1]&&s[2]?new $({id:s[1]},s[2],s[4]||void 0):null}constructor(t,s,r=N.TargetPlatform.UNDEFINED){this.identifier=t,this.version=s,this.targetPlatform=r,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==N.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof $?I(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.$Rp=$;const g=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function l(n){const t=g.exec(n);return t&&t[1]?[E(t[1]),t[2]]:[E(n),void 0]}function d(n,t){return`${n}.${t}`}function E(n){return n.toLowerCase()}function w(n,t){return E(d(n??N.$rn,t))}function f(n,t){const s=[],r=o=>{for(const u of s)if(u.some(b=>I(t(b),t(o))))return u;return null};for(const o of n){const u=r(o);u?u.push(o):s.push([o])}return s}function P(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}function m(n){return{id:new y.$Bp(n.identifier.id),name:new y.$Bp(n.name),version:n.version,galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$Zp=new N.$vn("pprice.better-merge");function c(n,t){const s=[],r=t.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const o=r.shift();if(o&&s.every(u=>!I(u.identifier,{id:o}))){const u=n.filter(b=>I(b.identifier,{id:o}));u.length===1&&(s.push(u[0]),r.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function h(n,t){if(!A.$l)return!1;let s;try{s=(await n.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await n.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(o){t.debug("Error while getting the os-release file.",(0,k.$_)(o))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function i(n,t){const s=await h(n,t),r=(0,a.$lp)(s?"alpine":A.$v,O.$hc);return t.debug("ComputeTargetPlatform:",r),r}}),define(fe[198],de([0,1,25,27,35,34]),function(ce,e,R,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K8b=T;async function T(k,O,y,I,p){try{const $=await k.getExtensionsControlManifest();if(!$.deprecated)return;const g=await k.getInstalled(A.ExtensionType.User);for(const[l,d]of Object.entries($.deprecated)){if(!d?.extension)continue;const{id:E,autoMigrate:w,preRelease:f}=d.extension;if(!w)continue;const P=g.find(c=>(0,N.$Qp)(c.identifier,{id:l}));if(!P)continue;const m=(await O.getExtensions([{id:E,preRelease:f}],{targetPlatform:await k.getTargetPlatform(),compatible:!0},R.CancellationToken.None))[0];if(!m){p.info(`Skipping migrating '${P.identifier.id}' extension because, the comaptible target '${E}' extension is not found`);continue}try{p.info(`Migrating '${P.identifier.id}' extension to '${E}' extension...`);const c=!I.getDisabledExtensions().some(i=>(0,N.$Qp)(i,P.identifier));await k.uninstall(P),p.info(`Uninstalled the unsupported extension '${P.identifier.id}'`);let h=g.find(i=>(0,N.$Qp)(i.identifier,{id:E}));(!h||!h.isPreReleaseVersion&&c)&&(h=await k.installFromGallery(m,{installPreReleaseVersion:!0,isMachineScoped:P.isMachineScoped,operation:a.InstallOperation.Migrate}),p.info(`Installed the pre-release extension '${h.identifier.id}'`),c||(await I.disableExtension(h.identifier),p.info(`Disabled the pre-release extension '${h.identifier.id}' because the unsupported extension '${P.identifier.id}' is disabled`)),w.storage&&(y.addToMigrationList((0,N.$Tp)(P.manifest.publisher,P.manifest.name),(0,N.$Tp)(h.manifest.publisher,h.manifest.name)),p.info("Added pre-release extension to the storage migration list"))),p.info(`Migrated '${P.identifier.id}' extension to '${E}' extension.`)}catch(c){p.error(c)}}}catch($){p.error($)}}}),define(fe[199],de([0,1,8,3,2,31,35,34,7]),function(ce,e,R,a,N,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=void 0;class y extends N.$Xc{constructor(p,$,g,l,d,E,w){super(),this.f=p,this.g=$,this.h=g,this.j=l,this.m=d,this.n=E,this.r=w,this.a=this.B(new a.$oe),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new N.$7c),this.s().then(null,f=>w.error("Error while initializing Extensions Watcher",(0,R.$_)(f)))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(p=>this.u(p.added))),this.B(this.j.onAddExtensions(p=>this.w(p))),this.B(this.j.onDidAddExtensions(p=>this.y(p))),this.B(this.j.onRemoveExtensions(p=>this.z(p))),this.B(this.j.onDidRemoveExtensions(p=>this.C(p))),this.B(this.n.onDidFilesChange(p=>this.D(p)))}async u(p){try{p.length&&await Promise.all(p.map($=>(this.c.set($.id,(0,N.$Uc)(this.n.watch(this.m.extUri.dirname($.extensionsResource)),this.n.watch($.extensionsResource))),this.G($.extensionsResource))))}catch($){throw this.r.error($),$}}async w(p){for(const $ of p.extensions)this.I(this.L($.identifier,$.version),p.profileLocation)}async y(p){for(const $ of p.extensions){const g=this.L($.identifier,$.version);p.error?this.J(g,p.profileLocation):this.I(g,p.profileLocation)}}async z(p){for(const $ of p.extensions)this.J(this.L($.identifier,$.version),p.profileLocation)}async C(p){const $=[],g=[];for(const l of p.extensions){const d=this.L(l.identifier,l.version);p.error?this.I(d,p.profileLocation):(this.J(d,p.profileLocation),this.b.has(d)||(this.r.debug("Extension is removed from all profiles",l.identifier.id,l.version),g.push(this.f.scanInstalledExtensionAtLocation(l.location).then(E=>{E?$.push(E):this.r.info("Extension not found at the location",l.location.toString())},E=>this.r.error(E)))))}try{await Promise.all(g),$.length&&await this.H($)}catch(l){this.r.error(l)}}D(p){for(const $ of this.h.profiles)p.contains($.extensionsResource,O.FileChangeType.UPDATED,O.FileChangeType.ADDED)&&this.F($.extensionsResource)}async F(p){const $=[],g=[],l=await this.j.scanProfileExtensions(p),d=new Set,E=new Set;for(const[w,f]of this.b)f.has(p)&&E.add(w);for(const w of l){const f=this.L(w.identifier,w.version);d.add(f),E.has(f)||($.push(w.identifier),this.I(f,p))}for(const w of E)if(!d.has(w)){const f=this.M(w);f&&(g.push(f.identifier),this.J(w,p))}($.length||g.length)&&this.a.fire({added:$.length?{extensions:$,profileLocation:p}:void 0,removed:g.length?{extensions:g,profileLocation:p}:void 0})}async G(p){const $=await this.j.scanProfileExtensions(p);for(const g of $)this.I(this.L(g.identifier,g.version),p)}async H(p){p||(p=(await this.f.scanAllUserInstalledExtensions()).filter(g=>!this.b.has(this.L(g.identifier,g.manifest.version)))),p.length&&await this.f.markAsUninstalled(...p)}I(p,$){let g=this.b.get(p);g||this.b.set(p,g=new A.$Ec(l=>this.m.extUri.getComparisonKey(l))),g.add($)}J(p,$){const g=this.b.get(p);g&&g.delete($),g?.size||this.b.delete(p)}L(p,$){return`${k.$vn.toKey(p.id)}@${$}`}M(p){const[$,g]=(0,T.$Sp)(p);return g?{identifier:{id:$},version:g}:void 0}}e.$4q=y}),define(fe[200],de([0,1,33,76,17,6,2,22,13,30,15,27,35,10,79,9]),function(ce,e,R,a,N,A,T,k,O,y,I,p,$,g,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hs=void 0,R=Oe(R);let E=class extends l.$gs{constructor(m,c,h,i){super(h),this.h=m,this.j=i,this.g=this.B(new w(c,i)),this.h.registerParticipant({postInstall:async n=>this.m(n),postUninstall:async n=>this.n(n)})}async getBuiltInExtensionTranslationsUri(m,c){const i=(await this.g.getLanguagePacks())[c];if(!i){this.j.warn(`No language pack found for ${c}`);return}const n=i.translations[m];return n?d.URI.file(n):void 0}async getInstalledLanguages(){const m=await this.g.getLanguagePacks(),c=Object.keys(m).map(h=>{const i=m[h];return{...this.f(h,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return c.push(this.f("en","English")),c.sort((h,i)=>h.label.localeCompare(i.label)),c}async m(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",m.identifier.id),await this.update())}async n(m){const c=await this.g.getLanguagePacks();Object.keys(c).some(h=>c[h]&&c[h].extensions.some(i=>(0,$.$Qp)(i.extensionIdentifier,m.identifier)))&&(this.j.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,c]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),h=await this.g.update(c);return!(0,N.$wb)(Object.keys(m),Object.keys(h))}};e.$hs=E,e.$hs=E=Ee([X(0,p.$sp),X(1,I.$Qi),X(2,p.$pp),X(3,g.$dk)],E);let w=class extends T.$Xc{constructor(m,c){super(),this.j=c,this.c={},this.f=(0,O.$mc)(m.userDataPath,"languagepacks.json"),this.g=new A.$Ph}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(m){return this.s(c=>{Object.keys(c).forEach(h=>delete c[h]),this.m(c,...m)}).then(()=>this.c)}m(m,...c){for(const h of c)h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&this.n(m,h);Object.keys(m).forEach(h=>this.r(m[h]))}n(m,c){const h=c.identifier,i=c.manifest.contributes&&c.manifest.contributes.localizations?c.manifest.contributes.localizations:[];for(const n of i)if(c.location.scheme===k.Schemas.file&&f(n)){let t=m[n.languageId];t||(t={hash:"",extensions:[],translations:{},label:n.localizedLanguageName??n.languageName},m[n.languageId]=t);const s=t.extensions.filter(r=>(0,$.$Qp)(r.extensionIdentifier,h))[0];s?s.version=c.manifest.version:t.extensions.push({extensionIdentifier:h,version:c.manifest.version});for(const r of n.translations)t.translations[r.id]=(0,O.$mc)(c.location.fsPath,r.path)}}r(m){if(m){const c=(0,a.createHash)("md5");for(const h of m.extensions)c.update(h.extensionIdentifier.uuid||h.extensionIdentifier.id).update(h.version);m.hash=c.digest("hex")}}s(m=()=>null){return this.g.queue(()=>{let c=null;return R.promises.readFile(this.f,"utf8").then(void 0,h=>h.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(h)).then(h=>{try{return JSON.parse(h)}catch{return{}}}).then(h=>(c=m(h),h)).then(h=>{for(const n of Object.keys(h))h[n]||delete h[n];this.c=h,this.h=!0;const i=JSON.stringify(this.c);return this.j.debug("Writing language packs",i),y.Promises.writeFile(this.f,i)}).then(()=>c,h=>this.j.error(h))})}};w=Ee([X(0,I.$Qi),X(1,g.$dk)],w);function f(P){if(typeof P.languageId!="string"||!Array.isArray(P.translations)||P.translations.length===0)return!1;for(const m of P.translations)if(typeof m.id!="string"||typeof m.path!="string")return!1;return!(P.languageName&&typeof P.languageName!="string"||P.localizedLanguageName&&typeof P.localizedLanguageName!="string")}}),define(fe[201],de([0,1,67,88,8,29,5,48]),function(ce,e,R,a,N,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QR=void 0;const O="https://mobile.events.data.microsoft.com/OneCollector/1.0",y="https://mobile.events.data.microsoft.com/ping";async function I($,g,l){const d=await(0,R.$xq)("@microsoft/1ds-core-js","dist/ms.core.js"),E=await(0,R.$xq)("@microsoft/1ds-post-js","dist/ms.post.js"),w=new d.AppInsightsCore,f=new E.PostChannel,P={instrumentationKey:$,endpointUrl:O,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[f]]};if(l){P.extensionConfig={};const m={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:l};P.extensionConfig[f.identifier]=m}return w.initialize(P,[]),w.addTelemetryInitializer(m=>{m.ext=m.ext??{},m.ext.web=m.ext.web??{},m.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',g&&(m.ext.utc=m.ext.utc??{},m.ext.utc.flags=8462029)}),w}class p{constructor(g,l,d,E,w){this.f=g,this.g=l,this.h=d,this.i=w,this.c=O,this.d=y,this.e=!1,this.h||(this.h={}),typeof E=="function"?this.a=E():this.a=E,this.b=null}j(g){if(this.a){if(typeof this.a!="string"){g(this.a);return}this.b||(this.b=I(this.a,this.f,this.i)),this.b.then(l=>{g(l)},l=>{a.$T&&T.$p&&this.e||(this.e=!0,(0,N.$2)(l),console.error(l))})}}log(g,l){if(!this.a)return;l=(0,A.$lo)(l,this.h),l=(0,k.$Lp)(l);const d=this.g+"/"+g;try{this.j(E=>{E.pluginVersionString=l?.properties.version??"Unknown",E.track({name:d,baseData:{name:d,properties:l?.properties,measurements:l?.measurements}})})}catch{}}flush(){return this.a?new Promise(g=>{this.j(l=>{l.unload(!0,()=>{this.a=void 0,g(void 0)})})}):Promise.resolve(void 0)}}e.$QR=p}),define(fe[114],de([0,1,2,11,15,10,23,48]),function(ce,e,R,a,N,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lfc=void 0;let O=class extends R.$Xc{constructor(I,p,$,g,l=""){super(),this.b=l;const d=p.getLogger(k.$Fp);if(d)this.a=this.B(d);else{const w=(0,k.$Jp)(g,$)?" (Not Sent)":"",f=()=>(0,k.$Ip)(g,$)&&I.getLevel()===A.LogLevel.Trace;this.a=this.B(p.createLogger(k.$Fp,{name:(0,a.localize)(2067,null,w),hidden:!f()})),this.B(I.onDidChangeLogLevel(()=>p.setVisibility(k.$Fp,f()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(I,p){this.a.trace(`${this.b}telemetry/${I}`,(0,k.$Lp)(p))}};e.$lfc=O,e.$lfc=O=Ee([X(0,A.$dk),X(1,A.$ek),X(2,N.$Pi),X(3,T.$wk)],O)});var it=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(fe[115],de([0,1,2,29,5,26,11,21,47,104,23,44,18,48]),function(ce,e,R,a,N,A,T,k,O,y,I,p,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ns=void 0,y=it(y);let l=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(w,f,P){this.k=f,this.l=P,this.d={},this.i=new R.$Wc,this.j=[],this.b=w.appenders,this.c=w.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=w.piiPaths||[],this.g=$.TelemetryLevel.USAGE,this.h=!!w.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const m of this.f)this.j.push(new RegExp((0,A.$kf)(m),"gi")),m.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$kf)(m.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(m=>{(m.affectsConfiguration($.$lm)||m.affectsConfiguration($.$nm)||m.affectsConfiguration($.$mm))&&this.m()}))}setExperimentProperty(w,f){this.d[w]=f}m(){let w=(0,g.$Kp)(this.k);const f=this.l.enabledTelemetryLevels;if(f){this.h=this.sendErrorTelemetry?f.error:!1;const P=f.usage?$.TelemetryLevel.USAGE:f.error?$.TelemetryLevel.ERROR:$.TelemetryLevel.NONE;w=Math.min(w,P)}this.g=w}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(w,f,P){this.g<f||(P=(0,a.$lo)(P,this.d),P=(0,g.$Pp)(P,this.j),P=(0,a.$lo)(P,this.c),this.b.forEach(m=>m.log(w,P)))}publicLog(w,f){this.n(w,$.TelemetryLevel.USAGE,f)}publicLog2(w,f){this.publicLog(w,f)}publicLogError(w,f){this.h&&this.n(w,$.TelemetryLevel.ERROR,f)}publicLogError2(w,f){this.publicLogError(w,f)}};e.$ns=l,e.$ns=l=Ee([X(1,k.$cj),X(2,I.$wk)],l);function d(){const E=(0,T.localize)(2068,null,y.default.nameLong),w=y.default.privacyStatementUrl?(0,T.localize)(2070,null,"https://aka.ms/vscode-telemetry",y.default.privacyStatementUrl):(0,T.localize)(2069,null,"https://aka.ms/vscode-telemetry"),f=N.$p?"":(0,T.localize)(2071,null),P=(0,T.localize)(2072,null),m=(0,T.localize)(2073,null),c=(0,T.localize)(2074,null),h=(0,T.localize)(2075,null),i=`
|       | ${P} | ${m} | ${c} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,T.localize)(2076,null);return`
${E} ${w} ${f}

&nbsp;

${h}
${i}

&nbsp;

${n}
`}p.$vo.as(O.$Ao.Configuration).registerConfiguration({id:$.$km,order:1,type:"object",title:(0,T.localize)(2077,null),properties:{[$.$lm]:{type:"string",enum:[$.TelemetryConfiguration.ON,$.TelemetryConfiguration.ERROR,$.TelemetryConfiguration.CRASH,$.TelemetryConfiguration.OFF],enumDescriptions:[(0,T.localize)(2078,null),(0,T.localize)(2079,null),(0,T.localize)(2080,null),(0,T.localize)(2081,null)],markdownDescription:d(),default:$.TelemetryConfiguration.ON,restricted:!0,scope:O.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),p.$vo.as(O.$Ao.Configuration).registerConfiguration({id:$.$km,order:110,type:"object",title:(0,T.localize)(2082,null),properties:{[$.$nm]:{type:"boolean",markdownDescription:y.default.privacyStatementUrl?(0,T.localize)(2084,null,y.default.nameLong,y.default.privacyStatementUrl):(0,T.localize)(2083,null,y.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(2085,null,`\`#${$.$lm}#\``),scope:O.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(fe[202],de([0,1,14,25,245,201]),function(ce,e,R,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RR=void 0,N=Oe(N);async function T(I,p){const $=await p.request(I,a.CancellationToken.None),g=(await(0,R.$3e)($.stream)).toString(),l=$.res.statusCode??200;return{headers:$.res.headers,statusCode:l,responseData:g}}async function k(I){const p={method:I.type,headers:I.headers};return new Promise((g,l)=>{const d=N.request(I.url??"",p,E=>{E.on("data",function(w){g({headers:E.headers,statusCode:E.statusCode??200,responseData:w.toString()})}),E.on("error",function(w){l(w)})});d.write(I.data,E=>{E&&l(E)}),d.end()})}async function O(I,p,$){const g=typeof p.data=="string"?p.data:new TextDecoder().decode(p.data),l={type:"POST",headers:{...p.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(p.data).toString()},url:p.urlString,data:g};try{const d=I?await T(l,I):await k(l);$(d.statusCode,d.headers,d.responseData)}catch{$(0,{})}}class y extends A.$QR{constructor(p,$,g,l,d){const E={sendPOST:(w,f)=>{O(p,w,f)}};super($,g,l,d,E)}}e.$RR=y}),define(fe[203],de([0,1,22,97,21,15,10,23,18,113,114,115]),function(ce,e,R,a,N,A,T,k,O,y,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mjc=void 0;let $=class{constructor(l,d,E,w,f,P){this.b=l,this.c=d,this.d=E,this.e=w,this.f=f,this.g=P,this.a=new Map}h(l){if(!this.a.has(l.id)){const d=Object.create(null);d["common.vscodemachineid"]=this.c.machineId,d["common.vscodesessionid"]=this.c.sessionId;const E=[l.id,JSON.stringify(d),l.aiKey],f=new a.$or(R.$3g.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:E,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),P=[new y.$$hc(f),new I.$lfc(this.d,this.e,this.f,this.g,`[${l.id}] `)];this.a.set(l.id,new p.$ns({appenders:P,sendErrorTelemetry:l.sendErrorTelemetry},this.b,this.g))}return this.a.get(l.id)}publicLog(l,d,E){this.h(l).publicLog(d,E)}publicLogError(l,d,E){this.h(l).publicLogError(d,E)}};e.$mjc=$,e.$mjc=$=Ee([X(0,N.$cj),X(1,O.$cm),X(2,T.$dk),X(3,T.$ek),X(4,A.$Pi),X(5,k.$wk)],$)}),define(fe[81],de([0,1,3,2,5,9,21,4,10]),function(ce,e,R,a,N,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ww=e.$Vw=e.$Sw=e.$Qw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Mw=e.$Lw=void 0,e.$Nw=p,e.$Ow=g,e.$Pw=l,e.$Rw=d,e.$Tw=E,e.$Uw=w,e.$Lw=(0,k.$Ii)("tunnelService"),e.$Mw=(0,k.$Ii)("sharedTunnelsService");var y;(function(m){m.Http="http",m.Https="https"})(y||(e.TunnelProtocol=y={}));var I;(function(m){m.ConstantPrivate="constantPrivate",m.Private="private",m.Public="public"})(I||(e.TunnelPrivacyId=I={}));function p(m){return!!m.forwardPort}var $;(function(m){m[m.Notify=1]="Notify",m[m.OpenBrowser=2]="OpenBrowser",m[m.OpenPreview=3]="OpenPreview",m[m.Silent=4]="Silent",m[m.Ignore=5]="Ignore",m[m.OpenBrowserOnce=6]="OpenBrowserOnce"})($||(e.ProvidedOnAutoForward=$={}));function g(m){if(m.scheme!=="http"&&m.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(m.authority);if(c)return{address:c[1],port:+c[2]}}function l(m){if(m.scheme!=="http"&&m.scheme!=="https"||!m.query)return;const c=m.query.split("&");for(const h of c){const i=h.split("=")[1];if(/^https?:/.exec(i)){const n=g(A.URI.parse(i));if(n)return n}}}e.$Qw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function d(m){return e.$Qw.indexOf(m)>=0}e.$Sw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(m){return e.$Sw.indexOf(m)>=0}function w(m,c,h,i){if(h===N.OperatingSystem.Windows)return!1;if(h===N.OperatingSystem.Macintosh&&E(c)){const n=/(\d+)\.(\d+)\.(\d+)/g.exec(i);if(n?.length===4&&parseInt(n[1])>=18)return!1}return m<1024}class f{constructor(c,h,i){this.remoteAddress=c,this.localAddress=h,this.b=i,this.a=new R.$oe,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Vw=f;let P=class extends a.$Xc{constructor(c,h){super(),this.r=c,this.s=h,this.a=new R.$oe,this.onTunnelOpened=this.a.event,this.b=new R.$oe,this.onTunnelClosed=this.b.event,this.c=new R.$oe,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const c=this.s.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(c){return this.g=c,c?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(c){this.h=c.elevation,this.m=c.privacyOptions,this.j=c.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const c=[],h=Array.from(this.f.values());for(const i of h){const n=Array.from(i.values());for(const t of n){const s=await t.value;s&&typeof s!="string"&&c.push(s)}}return c}async dispose(){super.dispose();for(const c of this.f.values()){for(const{value:h}of c.values())await h.then(i=>typeof i!="string"?i?.dispose():void 0);c.clear()}this.f.clear()}setEnvironmentTunnel(c,h,i,n,t){this.z(c,h,Promise.resolve({tunnelRemoteHost:c,tunnelRemotePort:h,localAddress:i,privacy:n,protocol:t,dispose:()=>Promise.resolve()}))}async getExistingTunnel(c,h){(E(c)||d(c))&&(c=e.$Qw[0]);const i=this.D(c,h);if(i)return++i.refcount,i.value}openTunnel(c,h,i,n,t,s=!1,r,o){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${i} on local port ${t}.`);const u=this.g??c;if(!u)return;if(h||(h="localhost"),n||(n=this.t),this.g&&this.n.has(i)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const b=this.F(u,h,i,n,t,s,r,o);return b?b.then(C=>{if(C){if(typeof C=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(h,i),C}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(h,i);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const S=this.w(C);return(C.tunnelRemoteHost!==h||C.tunnelRemotePort!==i)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&C.privacy!==r&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(S),S}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),b)}w(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,privacy:c.privacy,protocol:c.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const h=this.f.get(c.tunnelRemoteHost);if(h){const i=h.get(c.tunnelRemotePort);i&&(i.refcount--,await this.y(c.tunnelRemoteHost,c.tunnelRemotePort,i))}}}}async y(c,h,i){if(i.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${h}.`);const n=i.value.then(async t=>{t&&typeof t!="string"&&(await t.dispose(!0),this.b.fire({host:t.tunnelRemoteHost,port:t.tunnelRemotePort}))});return this.f.has(c)&&this.f.get(c).delete(h),n}}async closeTunnel(c,h){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${h} `);const i=this.f.get(c);if(i&&i.has(h)){const n=i.get(h);n.refcount=0,await this.y(c,h,n)}}z(c,h,i){this.f.has(c)||this.f.set(c,new Map),this.f.get(c).set(h,{refcount:1,value:i})}async C(c,h){const i=this.f.get(c);if(i){const n=i.get(h),t=n?await n.value:void 0;(!t||typeof t=="string")&&i.delete(h),i.size===0&&this.f.delete(c)}}D(c,h){const i=[c];d(c)?(i.push(...e.$Qw),i.push(...e.$Sw)):E(c)&&i.push(...e.$Sw);const n=i.map(t=>this.f.get(t));for(const t of n){const s=t?.get(h);if(s)return s}}canTunnel(c){return!!g(c)}G(c,h,i,n,t,s,r){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${i} on local port ${n}.`);const o=i;this.n.add(o);const u=n===void 0?i:n,b={elevationRequired:t?this.isPortPrivileged(u):!1},C={remoteAddress:{host:h,port:i},localAddressPort:n,privacy:s,public:s?s!==I.Private:void 0,protocol:r},S=c.forwardPort(C,b);return S?(this.z(h,i,S),S.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(o)})):this.n.delete(o),S}};e.$Ww=P,e.$Ww=P=Ee([X(0,O.$dk),X(1,T.$cj)],P)}),define(fe[204],de([0,1,10,81,2,8,6]),function(ce,e,R,a,N,A,T){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$wjc=void 0;class O extends N.$Xc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new T.$6h),this.b.p)}setAddress(p){this.a=p,this.b&&(this.b.complete(p),this.b=null)}setTunnel(p){this.B(p)}}let y=class extends N.$Xc{static{k=this}static{this.a=0}constructor(p,$){super(),this.f=p,this.g=$,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(p=>p.dispose())}async createTunnel(){return{id:String(++k.a)}}async startTunnel(p,$,g,l,d,E,w){const f=new O,P=await Promise.resolve(this.f.openTunnel(p,f,g,l,d,E,w));if(!P||typeof P=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${g}:${l} (remote).`),f.dispose(),new Error("Could not create tunnel");if(this.c.has($))throw this.c.delete($),f.dispose(),await P.dispose(),(0,A.$8)();return f.setTunnel(P),this.b.set($,f),this.g.info(`[SharedProcessTunnelService] Created tunnel ${$}: ${P.localAddress} (local) to ${g}:${l} (remote).`),{tunnelLocalPort:P.tunnelLocalPort,localAddress:P.localAddress}}async setAddress(p,$){const g=this.b.get(p);g&&g.setAddress($)}async destroyTunnel(p){const $=this.b.get(p);if($){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${p}.`),this.b.delete(p),await $.dispose();return}this.c.add(p)}};e.$wjc=y,e.$wjc=y=k=Ee([X(0,a.$Mw),X(1,R.$dk)],y)}),define(fe[28],de([0,1,4]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=void 0,e.$Nl=(0,R.$Ii)("IUriIdentityService")}),define(fe[205],de([0,1,28,161,7,20,136,3,2]),function(ce,e,R,a,N,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1s=void 0;class y{static{this._clock=0}constructor($){this.uri=$,this.time=y._clock++}touch(){return this.time=y._clock++,this}}let I=class{constructor($){this.g=$,this.c=new O.$Wc,this.f=2**16;const g=new Map,l=d=>{let E=g.get(d.scheme);return E===void 0&&(E=$.hasProvider(d)&&!this.g.hasCapability(d,N.FileSystemProviderCapabilities.PathCaseSensitive),g.set(d.scheme,E)),E};this.c.add(k.Event.any($.onDidChangeFileSystemProviderRegistrations,$.onDidChangeFileSystemProviderCapabilities)(d=>{g.delete(d.scheme)})),this.extUri=new A.$$g(l),this.d=new T.$Zs((d,E)=>this.extUri.compare(d,E,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri($){this.g.hasProvider($)&&($=(0,A.$kh)($));const g=this.d.get($);return g?g.touch().uri.with({fragment:$.fragment}):(this.d.set($,new y($)),this.h(),$)}h(){if(this.d.size<this.f)return;const $=[...this.d.entries()].sort((l,d)=>l[1].time<d[1].time?1:l[1].time>d[1].time?-1:0);y._clock=0,this.d.clear();const g=this.f*.5;for(let l=0;l<g;l++)this.d.set($[l][0],$[l][1].touch())}};e.$1s=I,e.$1s=I=Ee([X(0,N.$dl)],I),(0,a.$Xs)(R.$Nl,I,a.InstantiationType.Delayed)}),define(fe[206],de([0,1,3,2,7,51,31]),function(ce,e,R,a,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zic=void 0;class k extends a.$Xc{constructor(y,I,p,$,g,l){super(),this.f=y,this.g=I,this.h=p,this.j=$,this.m=g,this.n=l,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new R.$oe),this.onDidChangeFile=this.a.event,this.b=A.$Oi.forUris(()=>!(this.capabilities&N.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new T.$Ec(d=>this.m.extUri.getComparisonKey(this.t(d))),this.r(),this.B($.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(d=>this.s(d)))}r(){this.c.clear();for(const y of this.j.profiles)this.c.add(y.settingsResource),this.c.add(y.keybindingsResource),this.c.add(y.tasksResource),this.c.add(y.extensionsResource)}open(y,I){return this.g.open(this.t(y),I)}close(y){return this.g.close(y)}read(y,I,p,$,g){return this.g.read(y,I,p,$,g)}write(y,I,p,$,g){return this.g.write(y,I,p,$,g)}watch(y,I){this.b.set(y,y);const p=this.g.watch(this.t(y),I);return(0,a.$Vc)(()=>{this.b.delete(y),p.dispose()})}stat(y){return this.g.stat(this.t(y))}mkdir(y){return this.g.mkdir(this.t(y))}rename(y,I,p){return this.g.rename(this.t(y),this.t(I),p)}readFile(y,I){return this.g.readFile(this.t(y),I)}readFileStream(y,I,p){return this.g.readFileStream(this.t(y),I,p)}readdir(y){return this.g.readdir(this.t(y))}enforceAtomicReadFile(y){return this.c.has(y)}writeFile(y,I,p){return this.g.writeFile(this.t(y),I,p)}enforceAtomicWriteFile(y){return this.c.has(y)?{postfix:".vsctmp"}:!1}delete(y,I){return this.g.delete(this.t(y),I)}copy(y,I,p){if((0,N.$hl)(this.g))return this.g.copy(this.t(y),this.t(I),p);throw new Error("copy not supported")}cloneFile(y,I){if((0,N.$il)(this.g))return this.g.cloneFile(this.t(y),this.t(I));throw new Error("clone not supported")}s(y){const I=[];for(const p of y){if(p.resource.scheme!==this.f)continue;const $=this.u(p.resource);this.b.findSubstr($)&&I.push({resource:$,type:p.type,cId:p.cId})}I.length&&(this.n.debug("User data changed"),this.a.fire(I))}t(y){return y.with({scheme:this.f})}u(y){return y.with({scheme:this.h})}}e.$Zic=k}),define(fe[82],de([0,1,64]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.edit=a,e.$kNb=N,e.$lNb=A;function a(T,k,O,y){const I=(0,R.$eo)(T,k,O,y)[0];return I&&(T=T.substring(0,I.offset)+I.content+T.substring(I.offset+I.length)),T}function N(T,k,O){let y=O;for(;y>=0;){if(T.charAt(y)===k.charAt(k.length-1)&&k.length===1)return y+1;if(y--,k.length===2&&y>=0&&T.charAt(y)===k.charAt(0))return y+2}return 0}function A(T,k,O){let y=O;for(;y>=0;)if(T.charAt(y)===k.charAt(k.length-1)&&k.length===1||(y++,k.length===2&&y>=0&&T.charAt(y)===k.charAt(1)))return y;return T.length-1}}),define(fe[207],de([0,1,29,60,12]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1dc=A,a=Oe(a);function A(g,l,d,E,w,f){const P=[],m=[],c=[];if(!l){const F=g.filter(({identifier:G})=>w.every(V=>V.toLowerCase()!==G.id.toLowerCase()));return{local:{added:P,removed:m,updated:c},remote:F.length>0?{added:F,updated:[],removed:[],all:F}:null}}g=g.map(p),l=l.map(p),d=d?d.map(p):null;const h=new Map,i=F=>{F.uuid&&h.set(F.id.toLowerCase(),F.uuid)};g.forEach(({identifier:F})=>i(F)),l.forEach(({identifier:F})=>i(F)),d?.forEach(({identifier:F})=>i(F)),E?.forEach(({identifier:F})=>i(F)),f?.forEach(F=>i(F));const n=F=>{const G=F.identifier.uuid||h.get(F.identifier.id.toLowerCase());return G?`uuid:${G}`:`id:${F.identifier.id.toLowerCase()}`},t=(F,G)=>(F.set(n(G),G),F),s=g.reduce(t,new Map),r=l.reduce(t,new Map),o=l.reduce((F,G)=>t(F,(0,R.$io)(G)),new Map),u=d?d.reduce(t,new Map):null,b=E.reduce(t,new Map),C=w.reduce((F,G)=>{const V=h.get(G.toLowerCase());return F.add(V?`uuid:${V}`:`id:${G.toLowerCase()}`)},new Set),S=f?f.reduce((F,{id:G,uuid:V})=>(V=V??h.get(G.toLowerCase()),F.add(V?`uuid:${V}`:`id:${G.toLowerCase()}`)),new Set):null,v=T(s,r,C,!1);if(v.added.size>0||v.removed.size>0||v.updated.size>0){const F=T(u,s,C,!1),G=T(u,r,C,!0),V=(x,H,te,B)=>{let W,_,ne;return H.installed?(W=B.pinned,ne=B.preRelease,W&&(_=B.version)):(W=te.pinned,ne=te.preRelease,W&&(_=te.version)),W===void 0&&(W=H.pinned,W&&(_=H.version)),ne===void 0&&(ne=H.preRelease),{...B,installed:H.installed||te.installed,pinned:W,preRelease:ne,version:_??(te.version&&(!H.installed||a.gt(te.version,H.version))?te.version:H.version),state:O(H,te,u?.get(x))}};for(const x of G.removed.values()){const H=s.get(x);if(!H)continue;const te=(0,N.$sg)(u?.get(x)),B=S&&!S.has(x)&&te.installed;H.installed&&B?m.push(H.identifier):o.set(x,H)}for(const x of G.added.values()){const H=(0,N.$sg)(r.get(x)),te=s.get(x);if(te){if(v.updated.has(x)){const B=V(x,te,H,H);k(te,H,!1,!1)||c.push($(B,x)),o.set(x,B)}}else H.installed&&P.push($(H,x))}for(const x of G.updated.values()){const H=(0,N.$sg)(r.get(x)),te=(0,N.$sg)(u?.get(x)),B=s.get(x);if(B)if(S&&!S.has(x)&&te.installed&&B.installed&&!H.installed)m.push(B.identifier);else{const _=V(x,B,H,H);c.push($(_,x)),o.set(x,_)}else H.installed&&P.push($(H,x))}for(const x of F.added.values())G.added.has(x)||o.set(x,(0,N.$sg)(s.get(x)));for(const x of F.updated.values()){if(G.removed.has(x)||G.updated.has(x))continue;const H=(0,N.$sg)(s.get(x)),te=(0,N.$sg)(r.get(x));o.set(x,V(x,H,te,H))}for(const x of F.removed.values())G.updated.has(x)||G.removed.has(x)||b.has(x)||(0,N.$sg)(r.get(x)).installed&&S&&(S.has(x)||!(0,N.$sg)(u?.get(x)).installed||o.delete(x))}const L=[],U=T(r,o,new Set,!0),j=U.added.size>0||U.updated.size>0||U.removed.size>0;return j&&o.forEach((F,G)=>L.push($(F,G))),{local:{added:P,removed:m,updated:c},remote:j?{added:[...U.added].map(F=>o.get(F)),updated:[...U.updated].map(F=>o.get(F)),removed:[...U.removed].map(F=>r.get(F)),all:L}:null}}function T(g,l,d,E){const w=g?[...g.keys()].filter(h=>!d.has(h)):[],f=[...l.keys()].filter(h=>!d.has(h)),P=f.filter(h=>!w.includes(h)).reduce((h,i)=>(h.add(i),h),new Set),m=w.filter(h=>!f.includes(h)).reduce((h,i)=>(h.add(i),h),new Set),c=new Set;for(const h of w){if(m.has(h))continue;const i=g.get(h),n=l.get(h);(!n||!k(i,n,E,!0))&&c.add(h)}return{added:P,removed:m,updated:c}}function k(g,l,d,E){return!(g.disabled!==l.disabled||!!g.isApplicationScoped!=!!l.isApplicationScoped||E&&g.installed!==l.installed||g.installed&&l.installed&&(g.preRelease!==l.preRelease||g.pinned!==l.pinned||l.pinned&&g.version!==l.version)||!I(g.state,l.state)||d&&g.version!==l.version)}function O(g,l,d){const E=g.state,w=l.state,f=d?.state;if(!l.version||E&&a.gt(g.version,l.version))return E;if(w&&a.gt(l.version,g.version)||!E)return w;if(!w)return E;const P=(0,R.$io)(E),m=f?y(f,w):{added:Object.keys(w).reduce((h,i)=>(h.add(i),h),new Set),removed:new Set,updated:new Set},c=f?y(f,E):{added:Object.keys(E).reduce((h,i)=>(h.add(i),h),new Set),removed:new Set,updated:new Set};for(const h of[...m.added.values(),...m.updated.values()])P[h]=w[h];for(const h of m.removed.values())c.updated.has(h)||delete P[h];return P}function y(g,l){const d=Object.keys(g),E=Object.keys(l),w=E.filter(m=>!d.includes(m)).reduce((m,c)=>(m.add(c),m),new Set),f=d.filter(m=>!E.includes(m)).reduce((m,c)=>(m.add(c),m),new Set),P=new Set;for(const m of d){if(f.has(m))continue;const c=g[m],h=l[m];(0,R.$mo)(c,h)||P.add(m)}return{added:w,removed:f,updated:P}}function I(g={},l={}){const{added:d,removed:E,updated:w}=y(g,l);return d.size===0&&E.size===0&&w.size===0}function p(g){return{...g,disabled:!!g.disabled,installed:!!g.installed}}function $(g,l){const d={...g,identifier:{id:g.identifier.id,uuid:l.startsWith("uuid:")?l.substring(5):void 0},preRelease:!!g.preRelease,pinned:!!g.pinned};return g.disabled||delete d.disabled,g.installed||delete d.installed,g.state||delete d.state,g.isApplicationScoped||delete d.isApplicationScoped,d}}),define(fe[116],de([0,1,17,21,4]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EPb=e.$DPb=void 0,e.$DPb=(0,N.$Ii)("IIgnoredExtensionsManagementService");let A=class{constructor(k){this.a=k}hasToNeverSyncExtension(k){return this.b().includes(k.toLowerCase())}hasToAlwaysSyncExtension(k){return this.b().includes(`-${k.toLowerCase()}`)}updateIgnoredExtensions(k,O){let y=[...this.a.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return y=y.filter(I=>I!==k&&I!==`-${k}`),O&&y.push(k.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",y.length?y:void 0,a.ConfigurationTarget.USER)}updateSynchronizedExtensions(k,O){let y=[...this.a.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return y=y.filter(I=>I!==k&&I!==`-${k}`),O&&y.push(`-${k.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",y.length?y:void 0,a.ConfigurationTarget.USER)}getIgnoredExtensions(k){const O=k.filter($=>$.isMachineScoped).map($=>$.identifier.id.toLowerCase()),y=this.b().map($=>$.toLowerCase()),I=[],p=[];if(Array.isArray(y))for(const $ of y)$.startsWith("-")?p.push($.substring(1)):I.push($);return(0,R.$Ob)([...O,...I].filter($=>!p.includes($)))}b(){let k=this.a.inspect("settingsSync.ignoredExtensions").userValue;return k!==void 0||(k=this.a.inspect("sync.ignoredExtensions").userValue,k!==void 0)?k:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(O=>O.toLowerCase())}};e.$EPb=A,e.$EPb=A=Ee([X(0,a.$cj)],A)}),define(fe[208],de([0,1,17,36,29,98,82]),function(ce,e,R,a,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7dc=O,N=Oe(N),T=Oe(T);function k(m){return(0,a.$3n)(m)||[]}async function O(m,c,h,i,n){const t=k(m),s=k(c),r=h?k(h):null,o=[...t,...s,...r||[]].map(V=>V.key),u=await n.resolveUserBindings(o),b=I(t,s,r,u);if(!b.hasLocalForwarded&&!b.hasRemoteForwarded)return{mergeContent:m,hasChanges:!1,hasConflicts:!1};if(!b.hasLocalForwarded&&b.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};if(b.hasLocalForwarded&&!b.hasRemoteForwarded)return{mergeContent:m,hasChanges:!0,hasConflicts:!1};const C=$(t),S=$(s),v=r?$(r):null,L=l(C,S,u),U=v?l(v,C,u):{added:[...C.keys()].reduce((V,x)=>(V.add(x),V),new Set),removed:new Set,updated:new Set},j=v?l(v,S,u):{added:[...S.keys()].reduce((V,x)=>(V.add(x),V),new Set),removed:new Set,updated:new Set},F=y(L,U,j);let G=m;for(const V of F.removed.values())F.conflicts.has(V)||(G=f(G,V,i));for(const V of F.added.values()){if(F.conflicts.has(V))continue;const x=S.get(V);if(x.some(H=>H.command!==`-${V}`&&b.conflicts.has(u[H.key]))){F.conflicts.add(V);continue}G=w(G,x,i)}for(const V of F.updated.values()){if(F.conflicts.has(V))continue;const x=S.get(V);if(x.some(H=>H.command!==`-${V}`&&b.conflicts.has(u[H.key]))){F.conflicts.add(V);continue}G=P(G,V,x,i)}return{mergeContent:G,hasChanges:!0,hasConflicts:F.conflicts.size>0}}function y(m,c,h){const i=new Set,n=new Set,t=new Set,s=new Set;for(const r of c.removed.values())h.updated.has(r)&&s.add(r);for(const r of h.removed.values())s.has(r)||(c.updated.has(r)?s.add(r):n.add(r));for(const r of c.added.values())s.has(r)||h.added.has(r)&&m.updated.has(r)&&s.add(r);for(const r of h.added.values())s.has(r)||(c.added.has(r)?m.updated.has(r)&&s.add(r):i.add(r));for(const r of c.updated.values())s.has(r)||h.updated.has(r)&&m.updated.has(r)&&s.add(r);for(const r of h.updated.values())s.has(r)||(c.updated.has(r)?m.updated.has(r)&&s.add(r):t.add(r));return{added:i,removed:n,updated:t,conflicts:s}}function I(m,c,h,i){const n=new Set,t=p(m,i),s=p(c,i),r=h?p(h,i):null,o=g(t,s);if(o.added.size===0&&o.removed.size===0&&o.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const u=r?g(r,t):{added:[...t.keys()].reduce((U,j)=>(U.add(j),U),new Set),removed:new Set,updated:new Set};if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const b=r?g(r,s):{added:[...s.keys()].reduce((U,j)=>(U.add(j),U),new Set),removed:new Set,updated:new Set};if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:C,removed:S,updated:v,conflicts:L}=y(o,u,b);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:C,removed:S,updated:v,conflicts:L}}function p(m,c){const h=new Map;for(const i of m){const n=c[i.key];let t=h.get(n);t||(t=[],h.set(n,t)),t.push(i)}return h}function $(m){const c=new Map;for(const h of m){const i=h.command[0]==="-"?h.command.substring(1):h.command;let n=c.get(i);n||(n=[],c.set(i,n)),n.push(h)}return c}function g(m,c){const h=[...m.keys()],i=[...c.keys()],n=i.filter(r=>!h.includes(r)).reduce((r,o)=>(r.add(o),r),new Set),t=h.filter(r=>!i.includes(r)).reduce((r,o)=>(r.add(o),r),new Set),s=new Set;for(const r of h){if(t.has(r))continue;const o=m.get(r).map(b=>({...b,key:r})),u=c.get(r).map(b=>({...b,key:r}));(0,R.$wb)(o,u,(b,C)=>E(b,C))||s.add(r)}return{added:n,removed:t,updated:s}}function l(m,c,h){const i=[...m.keys()],n=[...c.keys()],t=n.filter(o=>!i.includes(o)).reduce((o,u)=>(o.add(u),o),new Set),s=i.filter(o=>!n.includes(o)).reduce((o,u)=>(o.add(u),o),new Set),r=new Set;for(const o of i){if(s.has(o))continue;const u=m.get(o).map(C=>({...C,key:h[C.key]})),b=c.get(o).map(C=>({...C,key:h[C.key]}));d(u,b)||r.add(o)}return{added:t,removed:s,updated:r}}function d(m,c){return!(!(0,R.$wb)(m.filter(({command:h})=>h[0]!=="-"),c.filter(({command:h})=>h[0]!=="-"),(h,i)=>E(h,i))||!(0,R.$wb)(m.filter(({command:h})=>h[0]==="-"),c.filter(({command:h})=>h[0]==="-"),(h,i)=>E(h,i)))}function E(m,c){if(m.command!==c.command||m.key!==c.key)return!1;const h=A.$Gj.deserialize(m.when),i=A.$Gj.deserialize(c.when);return!(h&&!i||!h&&i||h&&i&&!h.equals(i)||!N.$mo(m.args,c.args))}function w(m,c,h){for(const i of c)m=T.edit(m,[-1],i,h);return m}function f(m,c,h){const i=k(m);for(let n=i.length-1;n>=0;n--)(i[n].command===c||i[n].command===`-${c}`)&&(m=T.edit(m,[n],void 0,h));return m}function P(m,c,h,i){const n=k(m),t=n.findIndex(s=>s.command===c||s.command===`-${c}`);for(let s=n.length-1;s>=0;s--)(n[s].command===c||n[s].command===`-${c}`)&&(m=T.edit(m,[s],void 0,i));for(let s=h.length-1;s>=0;s--)m=T.edit(m,[t],h[s],i);return m}}),define(fe[209],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bec=R,e.$cec=N;function R(A,T,k){const O={},y={},I=new Set;if(!T)return{local:{added:O,updated:y,removed:[...I.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const p=a(A,T);if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{local:{added:O,updated:y,removed:[...I.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const $=a(k,A),g=a(k,T),l={},d={},E=new Set,w=new Set;for(const f of $.removed.values())g.updated.has(f)?O[f]=T[f]:E.add(f);for(const f of g.removed.values())w.has(f)||($.updated.has(f)?w.add(f):I.add(f));for(const f of $.updated.values())w.has(f)||(g.updated.has(f)?p.updated.has(f)&&w.add(f):d[f]=A[f]);for(const f of g.updated.values())w.has(f)||($.updated.has(f)?p.updated.has(f)&&w.add(f):A[f]!==void 0&&(y[f]=T[f]));for(const f of $.added.values())w.has(f)||(g.added.has(f)?p.updated.has(f)&&w.add(f):l[f]=A[f]);for(const f of g.added.values())w.has(f)||($.added.has(f)?p.updated.has(f)&&w.add(f):O[f]=T[f]);return{local:{added:O,removed:[...I.values()],updated:y},remote:{added:l,removed:[...E.values()],updated:d},conflicts:[...w.values()]}}function a(A,T){const k=A?Object.keys(A):[],O=T?Object.keys(T):[],y=O.filter($=>!k.includes($)).reduce(($,g)=>($.add(g),$),new Set),I=k.filter($=>!O.includes($)).reduce(($,g)=>($.add(g),$),new Set),p=new Set;for(const $ of k){if(I.has($))continue;const g=A[$],l=T[$];g!==l&&p.add($)}return{added:y,removed:I,updated:p}}function N(A,T){const{added:k,removed:O,updated:y}=a(A,T);return k.size===0&&O.size===0&&y.size===0}}),define(fe[210],de([0,1,29]),function(ce,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2fc=a;function a(A,T,k,O){const y={added:[],removed:[],updated:[]};let I={added:[],removed:[],updated:[]};if(!T){const $=A.filter(({id:g})=>!O.includes(g));return $.length?I.added=$:I=null,{local:y,remote:I}}const p=N(A,T,O);if(p.added.length>0||p.removed.length>0||p.updated.length>0){const $=N(k,A,O),g=N(k,T,O);for(const l of g.removed){const d=A.find(E=>E.id===l);d&&y.removed.push(d)}for(const l of g.added){const d=T.find(E=>E.id===l);$.added.includes(l)?p.updated.includes(l)&&y.updated.push(d):y.added.push(d)}for(const l of g.updated)y.updated.push(T.find(d=>d.id===l));for(const l of $.added)g.added.includes(l)||I.added.push(A.find(d=>d.id===l));for(const l of $.updated)g.removed.includes(l)||g.updated.includes(l)||I.updated.push(A.find(d=>d.id===l));for(const l of $.removed){const d=T.find(E=>E.id===l);d&&I.removed.push(d)}}return I.added.length===0&&I.removed.length===0&&I.updated.length===0&&(I=null),{local:y,remote:I}}function N(A,T,k){A=A?A.filter(({id:g})=>!k.includes(g)):[],T=T.filter(({id:g})=>!k.includes(g));const O=A.map(({id:g})=>g),y=T.map(({id:g})=>g),I=y.filter(g=>!O.includes(g)),p=O.filter(g=>!y.includes(g)),$=[];for(const{id:g,name:l,shortName:d,icon:E,useDefaultFlags:w}of A){if(p.includes(g))continue;const f=T.find(P=>P.id===g);(!f||f.name!==l||f.shortName!==d||f.icon!==E||!(0,R.$mo)(f.useDefaultFlags,w))&&$.push(g)}return{added:I,removed:p,updated:$}}}),define(fe[24],de([0,1,17,12,11,47,27,4,105,44]),function(ce,e,R,a,N,A,T,k,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cob=e.$Bob=e.$Aob=e.$zob=e.$yob=e.$xob=e.$wob=e.$vob=e.$uob=e.$sob=e.MergeState=e.Change=e.SyncStatus=e.$rob=e.$qob=e.$pob=e.UserDataSyncErrorCode=e.$nob=e.$mob=e.$lob=e.$kob=e.$job=e.$gob=e.SyncResource=e.$dob=e.$cob=void 0,e.$_nb=I,e.$aob=p,e.$bob=$,e.$eob=l,e.$fob=d,e.$hob=w,e.$iob=f,e.$oob=P,e.$tob=r;function I(){const o=y.$vo.as(A.$Ao.Configuration).getConfigurationProperties();return Object.keys(o).filter(u=>!!o[u].disallowSyncIgnore)}function p(o=!1){const u=y.$vo.as(A.$Ao.Configuration).getConfigurationProperties(),b=g(u,o),C=I();return(0,R.$Ob)([...b,...C])}function $(o){if(!o.contributes?.configuration)return[];const u=Array.isArray(o.contributes.configuration)?o.contributes.configuration:[o.contributes.configuration];if(!u.length)return[];const b=(0,A.$Qo)(u);return g(b,!1)}function g(o,u){const b=new Set;for(const C in o){if(u&&o[C].source)continue;const S=(0,a.$hg)(o[C].scope)?(0,A.$Ro)(o[C].scope):o[C].scope;(o[C].ignoreSync||S===A.ConfigurationScope.MACHINE||S===A.ConfigurationScope.MACHINE_OVERRIDABLE)&&b.add(C)}return[...b.values()]}e.$cob="settingsSync",e.$dob="settingsSync.keybindingsPerPlatform";function l(){const o="vscode://schemas/ignoredSettings",u=y.$vo.as(A.$Ao.Configuration);u.registerConfiguration({id:"settingsSync",order:30,title:(0,N.localize)(2455,null),type:"object",properties:{[e.$dob]:{type:"boolean",description:(0,N.localize)(2456,null),default:!0,scope:A.ConfigurationScope.APPLICATION,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,N.localize)(2457,null),items:[{type:"string",pattern:T.$cp,errorMessage:(0,N.localize)(2458,null)}],default:[],scope:A.ConfigurationScope.APPLICATION,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,N.localize)(2459,null),default:[],scope:A.ConfigurationScope.APPLICATION,$ref:o,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const b=y.$vo.as(O.$wo.JSONContribution),C=()=>{const S=I(),v=p(),L=Object.keys(A.$Bo.properties).filter(F=>!v.includes(F)),U=v.filter(F=>!S.includes(F)),j={items:{type:"string",enum:[...L,...U.map(F=>`-${F}`)]}};b.registerSchema(o,j)};return u.onDidUpdateConfiguration(()=>C())}function d(o){return o&&(0,a.$jg)(o)&&(0,a.$hg)(o.id)&&Array.isArray(o.scopes)}var E;(function(o){o.Settings="settings",o.Keybindings="keybindings",o.Snippets="snippets",o.Tasks="tasks",o.Extensions="extensions",o.GlobalState="globalState",o.Profiles="profiles",o.WorkspaceState="workspaceState"})(E||(e.SyncResource=E={})),e.$gob=[E.Settings,E.Keybindings,E.Snippets,E.Tasks,E.Extensions,E.GlobalState,E.Profiles];function w(o,...u){return o?[o,...u]:u}function f(o,u,b,C){return C.joinPath(b.userDataSyncHome,...w(o,u,`lastSync${u}.json`))}e.$job=(0,k.$Ii)("IUserDataSyncStoreManagementService"),e.$kob=(0,k.$Ii)("IUserDataSyncStoreService"),e.$lob=(0,k.$Ii)("IUserDataSyncLocalStoreService"),e.$mob="x-operation-id",e.$nob="X-Execution-Id";function P(o){const u={};return u[e.$nob]=o,u}var m;(function(o){o.Unauthorized="Unauthorized",o.Forbidden="Forbidden",o.NotFound="NotFound",o.MethodNotFound="MethodNotFound",o.Conflict="Conflict",o.Gone="Gone",o.PreconditionFailed="PreconditionFailed",o.TooLarge="TooLarge",o.UpgradeRequired="UpgradeRequired",o.PreconditionRequired="PreconditionRequired",o.TooManyRequests="RemoteTooManyRequests",o.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",o.RequestFailed="RequestFailed",o.RequestCanceled="RequestCanceled",o.RequestTimeout="RequestTimeout",o.RequestProtocolNotSupported="RequestProtocolNotSupported",o.RequestPathNotEscaped="RequestPathNotEscaped",o.RequestHeadersNotObject="RequestHeadersNotObject",o.NoCollection="NoCollection",o.NoRef="NoRef",o.EmptyResponse="EmptyResponse",o.TurnedOff="TurnedOff",o.SessionExpired="SessionExpired",o.ServiceChanged="ServiceChanged",o.DefaultServiceChanged="DefaultServiceChanged",o.LocalTooManyProfiles="LocalTooManyProfiles",o.LocalTooManyRequests="LocalTooManyRequests",o.LocalPreconditionFailed="LocalPreconditionFailed",o.LocalInvalidContent="LocalInvalidContent",o.LocalError="LocalError",o.IncompatibleLocalContent="IncompatibleLocalContent",o.IncompatibleRemoteContent="IncompatibleRemoteContent",o.Unknown="Unknown"})(m||(e.UserDataSyncErrorCode=m={}));class c extends Error{constructor(u,b,C,S){super(u),this.code=b,this.resource=C,this.operationId=S,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$pob=c;class h extends c{constructor(u,b,C,S,v){super(u,C,void 0,v),this.url=b,this.serverCode=S}}e.$qob=h;class i extends c{constructor(u,b){super(u,b)}}e.$rob=i,function(o){function u(b){if(b instanceof o)return b;const C=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(b.name);if(C&&C[1]){const S=C[2]==="unknown"?void 0:C[2],v=C[3]==="unknown"?void 0:C[3];return new o(b.message,C[1],S,v)}return new o(b.message,m.Unknown)}o.toUserDataSyncError=u}(c||(e.$pob=c={}));var n;(function(o){o.Uninitialized="uninitialized",o.Idle="idle",o.Syncing="syncing",o.HasConflicts="hasConflicts"})(n||(e.SyncStatus=n={}));var t;(function(o){o[o.None=0]="None",o[o.Added=1]="Added",o[o.Modified=2]="Modified",o[o.Deleted=3]="Deleted"})(t||(e.Change=t={}));var s;(function(o){o.Preview="preview",o.Conflict="conflict",o.Accepted="accepted"})(s||(e.MergeState=s={})),e.$sob="sync.store.url.type";function r(o){return`sync.enable.${o}`}e.$uob=(0,k.$Ii)("IUserDataSyncEnablementService"),e.$vob=(0,k.$Ii)("IUserDataSyncService"),e.$wob=(0,k.$Ii)("IUserDataSyncResourceProviderService"),e.$xob=(0,k.$Ii)("IUserDataAutoSyncService"),e.$yob=(0,k.$Ii)("IUserDataSyncUtilService"),e.$zob=(0,k.$Ii)("IUserDataSyncLogService"),e.$Aob="userDataSync",e.$Bob="vscode-userdata-sync",e.$Cob="preview"}),define(fe[211],de([0,1,29,24]),function(ce,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OOb=N,R=Oe(R);function N(T,k,O,y,I){if(!k)return{remote:{added:Object.keys(T),removed:[],updated:[],all:Object.keys(T).length>0?T:null},local:{added:{},removed:[],updated:{}}};const p=A(T,k);if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const $=O?A(O,k):{added:Object.keys(k).reduce((f,P)=>(f.add(P),f),new Set),removed:new Set,updated:new Set},g=O?A(O,T):{added:Object.keys(T).reduce((f,P)=>(f.add(P),f),new Set),removed:new Set,updated:new Set},l={added:{},removed:[],updated:{}},d=R.$io(k),E=!O;for(const f of g.added.values())f!==a.$sob&&E&&$.added.has(f)||(d[f]=T[f]);for(const f of g.updated.values())d[f]=T[f];for(const f of g.removed.values())y.unregistered.includes(f)||delete d[f];for(const f of $.added.values()){const P=k[f];if(y.machine.includes(f)){I.info(`GlobalState: Skipped adding ${f} in local storage because it is declared as machine scoped.`);continue}if(O&&g.added.has(f))continue;const m=T[f];m&&m.value===P.value||f===a.$sob&&E&&g.added.has(f)||(m?l.updated[f]=P:l.added[f]=P)}for(const f of $.updated.values()){const P=k[f];if(y.machine.includes(f)){I.info(`GlobalState: Skipped updating ${f} in local storage because it is declared as machine scoped.`);continue}if(g.updated.has(f)||g.removed.has(f))continue;const m=T[f];m&&m.value===P.value||(l.updated[f]=P)}for(const f of $.removed.values()){if(y.machine.includes(f)){I.trace(`GlobalState: Skipped removing ${f} in local storage because it is declared as machine scoped.`);continue}g.updated.has(f)||g.removed.has(f)||l.removed.push(f)}const w=A(k,d);return{local:l,remote:{added:[...w.added],updated:[...w.updated],removed:[...w.removed],all:w.added.size===0&&w.removed.size===0&&w.updated.size===0?null:d}}}function A(T,k){const O=Object.keys(T),y=Object.keys(k),I=y.filter(g=>!O.includes(g)).reduce((g,l)=>(g.add(l),g),new Set),p=O.filter(g=>!y.includes(g)).reduce((g,l)=>(g.add(l),g),new Set),$=new Set;for(const g of O){if(p.has(g))continue;const l=T[g],d=k[g];R.$mo(l,d)||$.add(g)}return{added:I,removed:p,updated:$}}}),define(fe[212],de([0,1,17,36,64,45,29,82,24]),function(ce,e,R,a,N,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mNb=y,e.$nNb=$,e.$oNb=g,e.$pNb=l,e.$qNb=E,e.$rNb=f,T=Oe(T),k=Oe(k);function y(o,u,b){let C=[];b?C=p(b):C=I(u);const S=[],v=[...(0,O.$_nb)()];if(Array.isArray(C))for(const L of C)L.startsWith("-")?v.push(L.substring(1)):S.push(L);return(0,R.$Ob)([...o,...S].filter(L=>!v.includes(L)))}function I(o){let u=o.inspect("settingsSync.ignoredSettings").userValue;return u!==void 0||(u=o.inspect("sync.ignoredSettings").userValue,u!==void 0)?u:o.getValue("settingsSync.ignoredSettings")||[]}function p(o){const u=(0,a.$3n)(o);return u?u["settingsSync.ignoredSettings"]||u["sync.ignoredSettings"]||[]:[]}function $(o,u){const b=(0,a.$3n)(o)||{};let C="{}";for(const S of Object.keys(b)){const v=(0,N.$eo)(C,[S],b[S],u);C=(0,N.$ho)(C,v)}return C}function g(o,u,b,C){if(b.length){const S=r(u),v=(0,a.$3n)(u)||{},L=(0,a.$3n)(o);if(!L)return o;const U=[];for(const j of b){const F=v[j],G=L[j];F===void 0?o=k.edit(o,[j],void 0,C):G!==void 0?o=k.edit(o,[j],F,C):U.push(h(j,S))}U.sort((j,F)=>j.startOffset-F.startOffset),U.forEach(j=>o=f(j.setting.key,u,o,C))}return o}function l(o,u,b,C,S,v){const L=g(o,u,C,v),U=b!==L,j=b!==u;if(!U&&!j)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(U&&!j)return{conflictsSettings:[],localContent:null,remoteContent:L,hasConflicts:!1};if(j&&!U)return{conflictsSettings:[],localContent:g(u,o,C,v),remoteContent:null,hasConflicts:!1};if(b===null&&E(o)){const D=d(o,u,C)?null:g(u,o,C,v);return{conflictsSettings:[],localContent:D,remoteContent:null,hasConflicts:!1}}let F=o,G=u;const V=(0,a.$3n)(o),x=(0,a.$3n)(u),H=b?(0,a.$3n)(b):null,te=C.reduce((D,Q)=>(D.add(Q),D),new Set),B=w(V,x,te),W=w(H,V,te),_=w(H,x,te),ne=new Map,le=new Set,ee=D=>{le.add(D);const Q=S.filter(({key:oe})=>oe===D)[0];Q?(F=k.edit(F,[D],Q.value,v),G=k.edit(G,[D],Q.value,v)):ne.set(D,{key:D,localValue:V[D],remoteValue:x[D]})};for(const D of W.removed.values())_.updated.has(D)?ee(D):G=k.edit(G,[D],void 0,v);for(const D of _.removed.values())le.has(D)||(W.updated.has(D)?ee(D):F=k.edit(F,[D],void 0,v));for(const D of W.updated.values())le.has(D)||(_.updated.has(D)?B.updated.has(D)&&ee(D):G=k.edit(G,[D],V[D],v));for(const D of _.updated.values())le.has(D)||(W.updated.has(D)?B.updated.has(D)&&ee(D):F=k.edit(F,[D],x[D],v));for(const D of W.added.values())le.has(D)||(_.added.has(D)?B.updated.has(D)&&ee(D):G=f(D,F,G,v));for(const D of _.added.values())le.has(D)||(W.added.has(D)?B.updated.has(D)&&ee(D):F=f(D,G,F,v));const J=ne.size>0||!d(F,G,C),K=J||!d(F,o,[]),q=J||!d(G,u,[]);return{localContent:K?F:null,remoteContent:q?G:null,conflictsSettings:[...ne.values()],hasConflicts:J}}function d(o,u,b){if(o===u)return!0;const C=(0,a.$3n)(o),S=(0,a.$3n)(u),v=b.reduce((j,F)=>(j.add(F),j),new Set),L=r(o).filter(j=>!(j.setting&&v.has(j.setting.key))),U=r(u).filter(j=>!(j.setting&&v.has(j.setting.key)));if(L.length!==U.length)return!1;for(let j=0;j<L.length;j++){const F=L[j],G=U[j];if(F.setting&&G.setting){if(F.setting.key!==G.setting.key||!T.$mo(C[F.setting.key],S[F.setting.key]))return!1}else if(!F.setting&&!G.setting){if(F.value!==G.value)return!1}else return!1}return!0}function E(o){return o?r(o).length===0:!0}function w(o,u,b){const C=o?Object.keys(o).filter(j=>!b.has(j)):[],S=Object.keys(u).filter(j=>!b.has(j)),v=S.filter(j=>!C.includes(j)).reduce((j,F)=>(j.add(F),j),new Set),L=C.filter(j=>!S.includes(j)).reduce((j,F)=>(j.add(F),j),new Set),U=new Set;if(o)for(const j of C){if(L.has(j))continue;const F=o[j],G=u[j];T.$mo(F,G)||U.add(j)}return{added:v,removed:L,updated:U}}function f(o,u,b,C){const S=(0,a.$3n)(u),v=r(u),L=r(b),U=P(o,v,L);return m(b,o,S[o],U,L,C)}function P(o,u,b){const C=u.findIndex(v=>v.setting?.key===o),S=u[C-1];if(S){if(S.setting){const L=h(S.setting.key,b);if(L)return{index:b.indexOf(L),insertAfter:!0}}else{const L=i(C,u);if(L){const U=h(L.setting.key,b);if(U){const j=n(b.indexOf(U),b),F=t(u,L,u[C]);if(j){const G=t(b,U,j),V=s(F,G);return V?{index:b.indexOf(V),insertAfter:!0}:{index:b.indexOf(j),insertAfter:!1}}else{const G=t(b,U,b[b.length-1]),V=s(F,G);return V?{index:b.indexOf(V),insertAfter:!0}:{index:b.length-1,insertAfter:!0}}}}}const v=u[C+1];if(v)if(v.setting){const L=h(v.setting.key,b);if(L)return{index:b.indexOf(L),insertAfter:!1}}else{const L=n(C,u);if(L){const U=h(L.setting.key,b);if(U){const j=i(b.indexOf(U),b),F=t(u,u[C],L);if(j){const G=t(b,j,U),V=s(F.reverse(),G.reverse());return V?{index:b.indexOf(V),insertAfter:!1}:{index:b.indexOf(j),insertAfter:!0}}else{const G=t(b,b[0],U),V=s(F.reverse(),G.reverse());return V?{index:b.indexOf(V),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:b.length-1,insertAfter:!0}}function m(o,u,b,C,S,v){let L;return C.index===-1?L=(0,N.$eo)(o,[u],b,v):L=c(o,u,b,C,S,v).map(U=>(0,N.$fo)(o,U,v)[0]),(0,N.$ho)(o,L)}function c(o,u,b,C,S,v){const L=`${JSON.stringify(u)}: ${JSON.stringify(b)}`,U=(0,A.$bo)(v,o),j=S[C.index];if(C.insertAfter){const F=[];if(j.setting)F.push({offset:j.endOffset,length:0,content:","+L});else{const G=n(C.index,S),V=i(C.index,S),x=V?.setting?.commaOffset;V&&x===void 0&&F.push({offset:V.endOffset,length:0,content:","});const H=x!==void 0&&x>j.endOffset;F.push({offset:H?x+1:j.endOffset,length:0,content:G?U+L+",":U+L})}return F}else{if(j.setting)return[{offset:j.startOffset,length:0,content:L+","}];const F=(S[C.index-1]&&!S[C.index-1].setting?U:"")+L+(n(C.index,S)?",":"")+U;return[{offset:j.startOffset,length:0,content:F}]}}function h(o,u){return u.filter(b=>b.setting?.key===o)[0]}function i(o,u){for(let b=o-1;b>=0;b--)if(u[b].setting)return u[b]}function n(o,u){for(let b=o+1;b<u.length;b++)if(u[b].setting)return u[b]}function t(o,u,b){const C=o.indexOf(u),S=o.indexOf(b);return o.filter((v,L)=>C<L&&L<S)}function s(o,u){if(o.length&&u.length){let b=0;for(;b<u.length&&b<o.length;b++)if(o[b].value!==u[b].value)return u[b-1];return u[b-1]}}function r(o){const u=[];let b=-1,C,S;const v={onObjectBegin:L=>{b++},onObjectProperty:(L,U,j)=>{b===0&&(C=U,S=L)},onObjectEnd:(L,U)=>{b--,b===0&&u.push({startOffset:C,endOffset:L+U,value:o.substring(C,L+U),setting:{key:S,commaOffset:void 0}})},onArrayBegin:(L,U)=>{b++},onArrayEnd:(L,U)=>{b--,b===0&&u.push({startOffset:C,endOffset:L+U,value:o.substring(C,L+U),setting:{key:S,commaOffset:void 0}})},onLiteralValue:(L,U,j)=>{b===0&&u.push({startOffset:C,endOffset:U+j,value:o.substring(C,U+j),setting:{key:S,commaOffset:void 0}})},onSeparator:(L,U,j)=>{if(b===0&&L===","){let F=u.length-1;for(;F>=0&&!u[F].setting;F--);const G=u[F];G&&u.splice(F,1,{startOffset:G.startOffset,endOffset:G.endOffset,value:G.value,setting:{key:G.setting.key,commaOffset:U}})}},onComment:(L,U)=>{b===0&&u.push({startOffset:L,endOffset:L+U,value:o.substring(L,L+U)})}};return(0,a.$0n)(o,v),u}}),define(fe[83],de([0,1,3,2,4,24]),function(ce,e,R,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Mb=e.$9Mb=void 0,e.$9Mb=(0,N.$Ii)("IUserDataSyncAccountService");let T=class extends a.$Xc{get account(){return this.a}constructor(O,y){super(),this.g=O,this.h=y,this.b=this.B(new R.$oe),this.onDidChangeAccount=this.b.event,this.c=this.B(new R.$oe),this.onTokenFailed=this.c.event,this.f=!1,this.B(O.onTokenFailed(I=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,I),this.updateAccount(void 0),I===A.UserDataSyncErrorCode.Forbidden?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(O.onTokenSucceed(()=>this.f=!1))}async updateAccount(O){(O&&this.a?O.token!==this.a.token||O.authenticationProviderId!==this.a.authenticationProviderId:O!==this.a)&&(this.a=O,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(O))}};e.$0Mb=T,e.$0Mb=T=Ee([X(0,A.$kob),X(1,A.$zob)],T)}),define(fe[213],de([0,1,20,11,15,10,24]),function(ce,e,R,a,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FPb=void 0;let k=class extends A.$ik{constructor(y,I){super(),this.g=this.B(y.createLogger((0,R.$jh)(I.logsHome,`${T.$Aob}.log`),{id:T.$Aob,name:(0,a.localize)(2460,null)}))}trace(y,...I){this.g.trace(y,...I)}debug(y,...I){this.g.debug(y,...I)}info(y,...I){this.g.info(y,...I)}warn(y,...I){this.g.warn(y,...I)}error(y,...I){this.g.error(y,...I)}flush(){this.g.flush()}};e.$FPb=k,e.$FPb=k=Ee([X(0,A.$ek),X(1,N.$Pi)],k)}),define(fe[214],de([0,1,6,3,2]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sic=void 0;class A extends N.$Xc{constructor({onDidOpenMainWindow:k,onDidFocusMainWindow:O,getActiveWindowId:y}){super(),this.a=this.B(new N.$Wc),a.Event.latch(a.Event.any(k,O))(this.f,this,this.a),this.b=(0,R.$vh)(()=>y()),(async()=>{try{const p=await this.b;this.c=typeof this.c=="number"?this.c:p}catch{}finally{this.b=void 0}})()}f(k){this.b&&(this.b.cancel(),this.b=void 0),this.c=k}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$sic=A}),define(fe[117],de([0,1,11,13,51,20,9,4,22]),function(ce,e,R,a,N,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$i=e.$8i=e.$7i=e.$6i=e.$5i=e.$3i=e.$2i=e.WorkbenchState=e.$Vi=e.$Ui=e.$Ri=void 0,e.$Si=y,e.$Ti=I,e.$Wi=p,e.$Xi=$,e.$Yi=g,e.$Zi=d,e.$1i=E,e.$4i=P,e.$9i=m,e.$0i=c,e.$_i=h,e.$aj=i,e.$bj=n,e.$Ri=(0,k.$Ii)("contextService");function y(t){const s=t;return typeof s?.id=="string"&&T.URI.isUri(s.uri)}function I(t){return typeof t?.id=="string"&&!y(t)&&!$(t)}e.$Ui={id:"ext-dev"},e.$Vi={id:"empty-window"};function p(t,s){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,a.$qc)(t)}:s?e.$Ui:e.$Vi;const r=t;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}function $(t){const s=t;return typeof s?.id=="string"&&T.URI.isUri(s.configPath)}function g(t){const s=t;if(s?.uri)return{id:s.id,uri:T.URI.revive(s.uri)};const r=t;if(r?.configPath)return{id:r.id,configPath:T.URI.revive(r.configPath)};if(t?.id)return{id:t.id}}var l;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(l||(e.WorkbenchState=l={}));function d(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function E(t){const s=t;return!!(s&&typeof s=="object"&&T.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class w{constructor(s,r,o,u,b){this.h=s,this.j=o,this.k=u,this.l=b,this.c=N.$Oi.forUris(this.l,()=>!0),this.folders=r}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=N.$Oi.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$2i=w;class f{constructor(s,r){this.raw=r,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,A.$jh)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$3i=f;function P(t){return new f({uri:t,index:0,name:(0,A.$fh)(t)},{uri:t.toString()})}e.$5i="code-workspace",e.$6i=`.${e.$5i}`,e.$7i=[{name:(0,R.localize)(2489,null),extensions:[e.$5i]}],e.$8i="workspace.json";function m(t,s){return A.$ah.isEqualOrParent(t,s.untitledWorkspacesHome)}function c(t){let s;return T.URI.isUri(t)?s=t:s=t.configuration,s?.scheme===O.Schemas.tmp}e.$$i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function h(t){return t.id===e.$$i}function i(t,s){return!m(t,s)&&!c(t)}function n(t){return(typeof t=="string"?(0,a.$rc)(t):(0,A.$hh)(t))===e.$6i}}),define(fe[19],de([0,1,55,3,2,20,9,11,15,7,4,10,117,31,28,6,32,26,12]),function(ce,e,R,a,N,A,T,k,O,y,I,p,$,g,l,d,E,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=e.$Pl=e.ProfileResourceType=void 0,e.$Ol=m,e.$Ql=c,e.$Rl=h;var P;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState"})(P||(e.ProfileResourceType=P={}));function m(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&T.URI.isUri(s.location)&&T.URI.isUri(s.globalStorageHome)&&T.URI.isUri(s.settingsResource)&&T.URI.isUri(s.keybindingsResource)&&T.URI.isUri(s.tasksResource)&&T.URI.isUri(s.snippetsHome)&&T.URI.isUri(s.extensionsResource))}e.$Pl=(0,I.$Ii)("IUserDataProfilesService");function c(t,s){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,icon:t.icon,location:T.URI.revive(t.location).with({scheme:s}),globalStorageHome:T.URI.revive(t.globalStorageHome).with({scheme:s}),settingsResource:T.URI.revive(t.settingsResource).with({scheme:s}),keybindingsResource:T.URI.revive(t.keybindingsResource).with({scheme:s}),tasksResource:T.URI.revive(t.tasksResource).with({scheme:s}),snippetsHome:T.URI.revive(t.snippetsHome).with({scheme:s}),extensionsResource:T.URI.revive(t.extensionsResource).with({scheme:s}),cacheHome:T.URI.revive(t.cacheHome).with({scheme:s}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}function h(t,s,r,o,u,b){return{id:t,name:s,location:r,isDefault:!1,shortName:u?.shortName,icon:u?.icon,globalStorageHome:b&&u?.useDefaultFlags?.globalState?b.globalStorageHome:(0,A.$jh)(r,"globalStorage"),settingsResource:b&&u?.useDefaultFlags?.settings?b.settingsResource:(0,A.$jh)(r,"settings.json"),keybindingsResource:b&&u?.useDefaultFlags?.keybindings?b.keybindingsResource:(0,A.$jh)(r,"keybindings.json"),tasksResource:b&&u?.useDefaultFlags?.tasks?b.tasksResource:(0,A.$jh)(r,"tasks.json"),snippetsHome:b&&u?.useDefaultFlags?.snippets?b.snippetsHome:(0,A.$jh)(r,"snippets"),extensionsResource:b&&u?.useDefaultFlags?.extensions?b.extensionsResource:(0,A.$jh)(r,"extensions.json"),cacheHome:(0,A.$jh)(o,t),useDefaultFlags:u?.useDefaultFlags,isTransient:u?.transient}}let i=class extends N.$Xc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,r,o,u){super(),this.t=s,this.u=r,this.w=o,this.y=u,this.f=!0,this.h=this.B(new a.$oe),this.onDidChangeProfiles=this.h.event,this.j=this.B(new a.$oe),this.onWillCreateProfile=this.j.event,this.m=this.B(new a.$oe),this.onWillRemoveProfile=this.m.event,this.n=this.B(new a.$oe),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new g.$Dc,workspaces:new g.$Dc,emptyWindows:new Map},this.profilesHome=(0,A.$jh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$jh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),r=[s];if(this.f)try{for(const b of this.O()){if(!b.name||!(0,f.$hg)(b.name)||!b.location){this.y.warn("Skipping the invalid stored profile",b.location||b.name);continue}r.push(h((0,A.$gh)(b.location),b.name,b.location,this.g,{shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags},s))}}catch(b){this.y.error(b)}const o=new g.$Dc,u=new Map;if(r.length)try{const b=this.Q();if(b.workspaces)for(const[C,S]of Object.entries(b.workspaces)){const v=T.URI.parse(C),L=r.find(U=>U.id===S);L&&o.set(v,L)}if(b.emptyWindows)for(const[C,S]of Object.entries(b.emptyWindows)){const v=r.find(L=>L.id===S);v&&u.set(C,v)}}catch(b){this.y.error(b)}this.z={profiles:r,workspaces:o,emptyWindows:u}}return this.z}D(){const s=h("__default__profile__",(0,k.localize)(2442,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const r="Temp",o=new RegExp(`${(0,w.$kf)(r)}\\s(\\d+)`);let u=0;for(const C of this.profiles){const S=o.exec(C.name),v=S?parseInt(S[1]):0;u=v>u?v:u}const b=`${r} ${u+1}`;return this.createProfile((0,R.$wj)((0,E.$5g)()).toString(16),b,{transient:!0},s)}async createNamedProfile(s,r,o){return this.createProfile((0,R.$wj)((0,E.$5g)()).toString(16),s,r,o)}async createProfile(s,r,o,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=await this.F(s,r,o);return u&&await this.setProfileForWorkspace(u,b),b}async F(s,r,o){if(!(0,f.$hg)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let u=this.r.get(r);return u||(u=(async()=>{try{if(this.profiles.find(v=>v.name===r||v.id===s))throw new Error(`Profile with ${r} name already exists`);const C=h(s,r,(0,A.$jh)(this.profilesHome,s),this.g,o,this.defaultProfile);await this.u.createFolder(C.location);const S=[];return this.j.fire({profile:C,join(v){S.push(v)}}),await d.Promises.settled(S),this.I([C],[],[]),C}finally{this.r.delete(r)}})(),this.r.set(r,u)),u}async updateProfile(s,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let o=this.profiles.find(u=>u.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);return o=h(o.id,r.name??o.name,o.location,this.g,{shortName:r.shortName??o.shortName,icon:r.icon===null?void 0:r.icon??o.icon,transient:r.transient??o.isTransient,useDefaultFlags:r.useDefaultFlags??o.useDefaultFlags},this.defaultProfile),this.I([],[],[o]),o}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(u=>u.id===s.id);if(!r)throw new Error(`Profile '${s.name}' does not exist`);const o=[];this.m.fire({profile:r,join(u){o.push(u)}});try{await Promise.allSettled(o)}catch(u){this.y.error(u)}for(const u of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(u)?.id&&this.C.emptyWindows.delete(u);for(const u of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(u)?.id&&this.C.workspaces.delete(u);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(u){(0,y.$ul)(u)!==y.FileOperationResult.FILE_NOT_FOUND&&this.y.error(u)}}async setProfileForWorkspace(s,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const o=this.profiles.find(u=>u.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.L(s,o)}unsetWorkspace(s,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,r)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.w.extUri.isEqual(o.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(s.map(r=>this.removeProfile(r)))}getProfileForWorkspace(s){const r=this.G(s),o=T.URI.isUri(r)?this.C.workspaces.get(r):this.C.emptyWindows.get(r);return o||((0,$.$Si)(s)?this.s.folders.get(s.uri):(0,$.$Xi)(s)?this.s.workspaces.get(s.configPath):this.s.emptyWindows.get(s.id))}G(s){return(0,$.$Si)(s)?s.uri:(0,$.$Xi)(s)?s.configPath:s.id}H(s){return!!([...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,s.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,s.location))||[...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,s.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,s.location))||[...this.s.folders.values()].some(r=>this.w.extUri.isEqual(r.location,s.location)))}I(s,r,o){const u=[...this.profiles,...s],b=[],C=this.s.profiles;this.s.profiles=[];for(let S of u){if(S.isDefault||r.some(L=>S.id===L.id))continue;S=o.find(L=>S.id===L.id)??S;const v=C.find(L=>S.id===L.id);if(S.isTransient)this.s.profiles.push(S);else{if(v){for(const[L,U]of this.s.emptyWindows.entries())if(S.id===U.id){this.L({id:L},S);break}for(const[L,U]of this.s.workspaces.entries())if(S.id===U.id){this.L({id:"",configPath:L},S);break}for(const[L,U]of this.s.folders.entries())if(S.id===U.id){this.L({id:"",uri:L},S);break}}b.push({location:S.location,name:S.name,shortName:S.shortName,icon:S.icon,useDefaultFlags:S.useDefaultFlags})}}this.P(b),this.z=void 0,this.J(s,r,o)}J(s,r,o){this.h.fire({added:s,removed:r,updated:o,all:this.profiles})}L(s,r,o){if(o=r?.isTransient?!0:o,o)(0,$.$Si)(s)?(this.s.folders.delete(s.uri),r&&this.s.folders.set(s.uri,r)):(0,$.$Xi)(s)?(this.s.workspaces.delete(s.configPath),r&&this.s.workspaces.set(s.configPath,r)):(this.s.emptyWindows.delete(s.id),r&&this.s.emptyWindows.set(s.id,r));else{this.L(s,void 0,!0);const u=this.G(s);T.URI.isUri(u)?(this.C.workspaces.delete(u),r&&this.C.workspaces.set(u,r)):(this.C.emptyWindows.delete(u),r&&this.C.emptyWindows.set(u,r)),this.M()}}M(){const s={};for(const[o,u]of this.C.workspaces.entries())s[o.toString()]=u.id;const r={};for(const[o,u]of this.C.emptyWindows.entries())r[o.toString()]=u.id;this.R({workspaces:s,emptyWindows:r}),this.z=void 0}N(s){const r={},o=this.D();if(s.workspaces)for(const[b,C]of Object.entries(s.workspaces)){const S=T.URI.parse(C);r[b]=this.w.extUri.isEqual(S,o.location)?o.id:this.w.extUri.basename(S)}const u={};if(s.emptyWindows)for(const[b,C]of Object.entries(s.emptyWindows)){const S=T.URI.parse(C);u[b]=this.w.extUri.isEqual(S,o.location)?o.id:this.w.extUri.basename(S)}return{workspaces:r,emptyWindows:u}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$Sl=i,e.$Sl=i=Ee([X(0,O.$Pi),X(1,y.$dl),X(2,l.$Nl),X(3,p.$dk)],i);class n extends i{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$Tl=n}),define(fe[215],de([0,1,6,2,19]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yjc=void 0;let A=class extends a.$Xc{constructor(k){super(),this.B(new R.$Uh(()=>{k.cleanUp()},10*1e3)).schedule()}};e.$yjc=A,e.$yjc=A=Ee([X(0,N.$Pl)],A)}),define(fe[84],de([0,1,17,6,25,8,3,2,31,5,12,9,11,27,35,34,59,10,23,18,28,19]),function(ce,e,R,a,N,A,T,k,O,y,I,p,$,g,l,d,E,w,f,P,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=e.$Lq=void 0,e.$Mq=i,$=Oe($);let h=class extends k.$Xc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(r,o,u,b,C,S){super(),this.z=r,this.C=o,this.D=u,this.F=b,this.G=C,this.H=S,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new T.$oe),this.s=this.B(new T.$oe),this.t=this.B(new T.$oe),this.u=this.B(new T.$oe),this.w=this.B(new T.$oe),this.y=[],this.B((0,k.$Vc)(()=>{this.j.forEach(({task:v})=>v.cancel()),this.m.forEach(v=>v.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(r){const o=await this.getTargetPlatform();return r.allTargetPlatforms.some(u=>(0,g.$np)(u,r.allTargetPlatforms,o))}async installFromGallery(r,o={}){try{const b=(await this.installGalleryExtensions([{extension:r,options:o}])).find(({identifier:C})=>(0,l.$Qp)(C,r.identifier));if(b?.local)return b?.local;throw b?.error?b.error:new g.$rp(`Unknown error while installing extension ${r.identifier.id}`,g.ExtensionManagementErrorCode.Unknown)}catch(u){throw i(u)}}async installGalleryExtensions(r){if(!this.z.isEnabled())throw new g.$rp($.localize(1767,null),g.ExtensionManagementErrorCode.NotAllowed);const o=[],u=[];return await Promise.allSettled(r.map(async({extension:b,options:C})=>{try{const S=await this.N(b,!!C?.installGivenVersion,!!C?.installPreReleaseVersion,C.productVersion??{version:this.G.version,date:this.G.date});u.push({...S,options:C})}catch(S){o.push({identifier:b.identifier,operation:g.InstallOperation.Install,source:b,error:S,profileLocation:C.profileLocation??this.W()})}})),u.length&&o.push(...await this.I(u)),o}async uninstall(r,o){return this.F.trace("ExtensionManagementService#uninstall",r.identifier.id),this.uninstallExtensions([{extension:r,options:o}])}async toggleAppliationScope(r,o){if((0,d.$yn)(r.manifest)||r.isBuiltin)return r;if(r.isApplicationScoped){let u=await this.updateMetadata(r,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)||(u=await this.Z(r,this.H.defaultProfile.extensionsResource,o));for(const b of this.H.profiles){const C=(await this.getInstalled(d.ExtensionType.User,b.extensionsResource)).find(S=>(0,l.$Qp)(S.identifier,r.identifier));C?this.w.fire({local:C,profileLocation:b.extensionsResource}):this.u.fire({identifier:r.identifier,profileLocation:b.extensionsResource})}return u}else{const u=this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(r,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.Z(r,o,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:u.identifier,operation:g.InstallOperation.Install,local:u,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),u}}getExtensionsControlManifest(){const r=new Date().getTime();return(!this.g||r-this.h>1e3*60*5)&&(this.g=this.U(),this.h=r),this.g}registerParticipant(r){this.y.push(r)}async resetPinnedStateForAllUserExtensions(r){try{await this.L(this.H.profiles.map(async o=>{const u=await this.getInstalled(d.ExtensionType.User,o.extensionsResource);await this.L(u.map(async b=>{b.pinned!==r&&await this.updateMetadata(b,{pinned:r},o.extensionsResource)}))}))}catch(o){throw this.F.error("Error while resetting pinned state for all user extensions",(0,A.$_)(o)),o}}async I(r){const o=new Map,u=new Map,b=[],C=(v,L)=>`${l.$Rp.create(v).toString()}-${L.toString()}`,S=(v,L,U,j)=>{const F=this.X(v,L,U),G=`${(0,l.$Vp)(v.publisher,v.name)}-${U.profileLocation.toString()}`;u.set(G,{task:F,root:j}),this.n.fire({identifier:F.identifier,source:L,profileLocation:U.profileLocation}),this.F.info("Installing extension:",F.identifier.id,U),p.URI.isUri(L)||this.j.set(C(L,U.profileLocation),{task:F,waitingTasks:[]})};try{for(const{manifest:v,extension:L,options:U}of r){const j=U.isApplicationScoped||U.isBuiltin||(0,d.$yn)(v),F={...U,installOnlyNewlyAddedFromExtensionPack:U.installOnlyNewlyAddedFromExtensionPack??!p.URI.isUri(L),isApplicationScoped:j,profileLocation:j?this.H.defaultProfile.extensionsResource:U.profileLocation??this.W(),productVersion:U.productVersion??{version:this.G.version,date:this.G.date}},G=p.URI.isUri(L)?void 0:this.j.get(C(L,F.profileLocation));G?(this.F.info("Extension is already requested to install",G.task.identifier.id,F.profileLocation.toString()),b.push(G.task.waitUntilTaskIsFinished())):S(v,L,F,void 0)}return await Promise.all([...u.values()].map(async({task:v})=>{if(v.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",v.identifier.id);else try{const L=await this.M(v.identifier,v.manifest,!!v.options.installOnlyNewlyAddedFromExtensionPack,!!v.options.installPreReleaseVersion,v.options.profileLocation,v.options.productVersion),U=await this.getInstalled(void 0,v.options.profileLocation,v.options.productVersion),j={...v.options,context:{...v.options.context,[g.$hp]:!0}};for(const{gallery:F,manifest:G}of(0,R.$Ob)(L,({gallery:V})=>V.identifier.id)){if(u.has(`${F.identifier.id.toLowerCase()}-${j.profileLocation.toString()}`))continue;const V=this.j.get(C(F,j.profileLocation));if(V){if(this.J(v,V.task)){const x=V.task.identifier;this.F.info("Waiting for already requested installing extension",x.id,v.identifier.id,j.profileLocation.toString()),V.waitingTasks.push(v),b.push(T.Event.toPromise(T.Event.filter(this.onDidInstallExtensions,H=>H.some(te=>(0,l.$Qp)(te.identifier,x)))).then(H=>{if(this.F.info("Finished waiting for already requested installing extension",x.id,v.identifier.id,j.profileLocation.toString()),!H.find(B=>(0,l.$Qp)(B.identifier,x))?.local)throw new Error(`Extension ${x.id} is not installed`)}))}}else U.some(({identifier:x})=>(0,l.$Qp)(x,F.identifier))||S(G,F,j,v)}}catch(L){if(p.URI.isUri(v.source))(0,R.$Nb)(v.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",v.identifier.id,L.message),(0,R.$Nb)(v.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",v.identifier.id,L.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",v.identifier.id),L}})),await this.L([...u.entries()].map(async([v,{task:L}])=>{const U=new Date().getTime();let j;try{j=await L.run(),await this.L(this.y.map(F=>F.postInstall(j,L.source,L.options,N.CancellationToken.None)),g.ExtensionManagementErrorCode.PostInstall)}catch(F){const G=i(F);throw p.URI.isUri(L.source)||n(this.C,L.operation===g.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$Yp)(L.source),error:G,source:L.options.context?.[g.$gp]}),o.set(v,{error:G,identifier:L.identifier,operation:L.operation,source:L.source,context:L.options.context,profileLocation:L.options.profileLocation,applicationScoped:L.options.isApplicationScoped}),this.F.error("Error while installing the extension",L.identifier.id,(0,A.$_)(G),L.options.profileLocation.toString()),G}if(!p.URI.isUri(L.source)){const F=L.operation===g.InstallOperation.Update,G=F?void 0:(new Date().getTime()-L.source.lastUpdated)/1e3;if(n(this.C,F?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$Yp)(L.source),verificationStatus:L.verificationStatus,duration:new Date().getTime()-U,durationSinceUpdate:G,source:L.options.context?.[g.$gp]}),y.$p&&L.operation!==g.InstallOperation.Update)try{await this.z.reportStatistic(j.manifest.publisher,j.manifest.name,j.manifest.version,g.StatisticType.Install)}catch{}}o.set(v,{local:j,identifier:L.identifier,operation:L.operation,source:L.source,context:L.options.context,profileLocation:L.options.profileLocation,applicationScoped:j.isApplicationScoped})})),b.length&&await this.L(b),[...o.values()]}catch(v){const L=(F,G,V)=>{const x=[];F.manifest.extensionDependencies?.length&&x.push(...F.manifest.extensionDependencies),F.manifest.extensionPack?.length&&x.push(...F.manifest.extensionPack);for(const H of x){if(V.includes(H.toLowerCase()))continue;V.push(H.toLowerCase());const te=o.get(`${H.toLowerCase()}-${G.toString()}`);te?.local&&(V=L(te.local,G,V))}return V},U=F=>({identifier:F.identifier,operation:g.InstallOperation.Install,source:F.source,context:F.options.context,profileLocation:F.options.profileLocation,error:v}),j=[];for(const[F,{task:G,root:V}]of u){const x=o.get(F);x?x.local&&V&&!o.get(`${V.identifier.id.toLowerCase()}-${G.options.profileLocation.toString()}`)?.local&&(j.push(this.Y(x.local,{versionOnly:!0,profileLocation:G.options.profileLocation})),o.set(F,U(G))):(G.cancel(),o.set(F,U(G)))}for(const[F,{task:G}]of u){const V=o.get(F);if(!V?.local||G.options.donotIncludePackAndDependencies)continue;L(V.local,G.options.profileLocation,[V.local.identifier.id.toLowerCase()]).slice(1).some(H=>u.has(`${H.toLowerCase()}-${G.options.profileLocation.toString()}`)&&!o.get(`${H.toLowerCase()}-${G.options.profileLocation.toString()}`)?.local)&&(j.push(this.Y(V.local,{versionOnly:!0,profileLocation:G.options.profileLocation})),o.set(F,U(G)))}throw j.length&&await Promise.allSettled(j.map(async F=>{try{await F.run(),this.F.info("Rollback: Uninstalled extension",F.extension.identifier.id)}catch(G){this.F.warn("Rollback: Error while uninstalling extension",F.extension.identifier.id,(0,A.$_)(G))}})),v}finally{for(const{task:v}of u.values())v.source&&!p.URI.isUri(v.source)&&this.j.delete(C(v.source,v.options.profileLocation));if(o.size){const v=[...o.values()];for(const L of v)L.local&&this.F.info("Extension installed successfully:",L.identifier.id,L.profileLocation.toString());this.s.fire(v)}}}J(r,o){for(const[,{task:u,waitingTasks:b}]of this.j.entries())if(u===r&&(b.includes(o)||b.some(C=>this.J(C,o)))||u===o&&b[0]&&!this.J(r,b[0]))return!1;return!0}async L(r,o){const u=[],b=[],C=await Promise.allSettled(r);for(const v of C)v.status==="fulfilled"?u.push(v.value):b.push(i(v.reason,o));if(!b.length)return u;if(b.length===1)throw b[0];let S=new g.$rp("",g.ExtensionManagementErrorCode.Unknown);for(const v of b)S=new g.$rp(S.message?`${S.message}, ${v.message}`:v.message,v.code!==g.ExtensionManagementErrorCode.Unknown&&v.code!==g.ExtensionManagementErrorCode.Internal?v.code:S.code);throw S}async M(r,o,u,b,C,S){if(!this.z.isEnabled())return[];const v=await this.getInstalled(void 0,C,S),L=[],U=[],j=async(F,G)=>{L.push(F);const V=G.extensionDependencies||[],x=[...V];if(G.extensionPack){const H=u?v.find(te=>(0,l.$Qp)(te.identifier,F)):void 0;for(const te of G.extensionPack)H&&H.manifest.extensionPack&&H.manifest.extensionPack.some(B=>(0,l.$Qp)({id:B},{id:te}))||x.every(B=>!(0,l.$Qp)({id:B},{id:te}))&&x.push(te)}if(x.length){const H=x.filter(te=>L.every(B=>!(0,l.$Qp)(B,{id:te})));if(H.length){const te=await this.z.getExtensions(H.map(B=>({id:B,preRelease:b})),N.CancellationToken.None);for(const B of te){if(L.find(ne=>(0,l.$Qp)(ne,B.identifier)))continue;const W=V.some(ne=>(0,l.$Qp)({id:ne},B.identifier));let _;try{_=await this.N(B,!1,b,S)}catch(ne){if(W)throw ne;this.F.info("Skipping the packed extension as it cannot be installed",B.identifier.id,(0,A.$_)(ne));continue}U.push({gallery:_.extension,manifest:_.manifest}),await j(_.extension.identifier,_.manifest)}}}};return await j(r,o),U}async N(r,o,u,b){let C;const S=await this.getExtensionsControlManifest();if(S.malicious.some(U=>(0,l.$Qp)(r.identifier,U)))throw new g.$rp($.localize(1768,null,r.identifier.id),g.ExtensionManagementErrorCode.Malicious);const v=S.deprecated[r.identifier.id.toLowerCase()];if(v?.extension?.autoMigrate){if(this.F.info(`The '${r.identifier.id}' extension is deprecated, fetching the compatible '${v.extension.id}' extension instead.`),C=(await this.z.getExtensions([{id:v.extension.id,preRelease:v.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:b},N.CancellationToken.None))[0],!C)throw new g.$rp($.localize(1769,null,r.identifier.id,v.extension.id),g.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(r)){const U=await this.getTargetPlatform();throw new g.$rp($.localize(1770,null,r.identifier.id,this.G.nameLong,(0,g.$jp)(U)),g.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(C=await this.O(r,o,u,b),!C){const U=[];throw(0,E.$$p)(r.properties.enabledApiProposals??[],U)?!u&&r.properties.isPreReleaseVersion&&(await this.z.getExtensions([r.identifier],N.CancellationToken.None))[0]?new g.$rp($.localize(1772,null,r.displayName??r.identifier.id),g.ExtensionManagementErrorCode.ReleaseVersionNotFound):new g.$rp($.localize(1773,null,r.identifier.id,this.G.nameLong,this.G.version),g.ExtensionManagementErrorCode.Incompatible):new g.$rp($.localize(1771,null,r.displayName??r.identifier.id,U[0]),g.ExtensionManagementErrorCode.IncompatibleApi)}}this.F.info("Getting Manifest...",C.identifier.id);const L=await this.z.getManifest(C,N.CancellationToken.None);if(L===null)throw new g.$rp(`Missing manifest for extension ${C.identifier.id}`,g.ExtensionManagementErrorCode.Invalid);if(L.version!==C.version)throw new g.$rp(`Cannot install '${C.identifier.id}' extension because of version mismatch in Marketplace`,g.ExtensionManagementErrorCode.Invalid);return{extension:C,manifest:L}}async O(r,o,u,b){const C=await this.getTargetPlatform();let S=null;return!o&&r.hasPreReleaseVersion&&r.properties.isPreReleaseVersion!==u&&(S=(await this.z.getExtensions([{...r.identifier,preRelease:u}],{targetPlatform:C,compatible:!0,productVersion:b},N.CancellationToken.None))[0]||null),!S&&await this.z.isExtensionCompatible(r,u,C,b)&&(S=r),S||(o?S=(await this.z.getExtensions([{...r.identifier,version:r.version}],{targetPlatform:C,compatible:!0,productVersion:b},N.CancellationToken.None))[0]||null:S=await this.z.getCompatibleExtension(r,u,C,b)),S}async uninstallExtensions(r){const o=(U,j)=>`${U.identifier.id.toLowerCase()}${j.versionOnly?`-${U.manifest.version}`:""}@${j.profileLocation.toString()}`,u=(U,j)=>{const F=this.Y(U,j);return this.m.set(o(F.extension,j),F),this.F.info("Uninstalling extension from the profile:",`${U.identifier.id}@${U.manifest.version}`,j.profileLocation.toString()),this.t.fire({identifier:U.identifier,profileLocation:j.profileLocation,applicationScoped:U.isApplicationScoped}),F},b=(U,j,F)=>{F?this.F.error("Failed to uninstall extension from the profile:",`${U.identifier.id}@${U.manifest.version}`,j.profileLocation.toString(),F.message):this.F.info("Successfully uninstalled extension from the profile",`${U.identifier.id}@${U.manifest.version}`,j.profileLocation.toString()),n(this.C,"extensionGallery:uninstall",{extensionData:(0,l.$Xp)(U),error:F}),this.u.fire({identifier:U.identifier,error:F?.code,profileLocation:j.profileLocation,applicationScoped:U.isApplicationScoped})},C=[],S=[],v=[],L=new O.$Dc;for(const{extension:U,options:j}of r){const F={...j,profileLocation:U.isApplicationScoped?this.H.defaultProfile.extensionsResource:j?.profileLocation??this.W()},G=this.m.get(o(U,F));G?(this.F.info("Extensions is already requested to uninstall",U.identifier.id),v.push(G.waitUntilTaskIsFinished())):C.push(u(U,F))}try{for(const U of C.slice(0)){let j=L.get(U.options.profileLocation);if(j||L.set(U.options.profileLocation,j=await this.getInstalled(d.ExtensionType.User,U.options.profileLocation)),U.options.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${U.extension.identifier.id}@${U.extension.manifest.version}`);else{const F=this.R(U.extension,j);for(const G of F)this.m.has(o(G,U.options))?this.F.info("Extensions is already requested to uninstall",G.identifier.id):C.push(u(G,U.options))}U.options.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${U.extension.identifier.id}@${U.extension.manifest.version}`):this.P(C.map(F=>F.extension),j,U.extension)}await this.L(C.map(async U=>{try{if(await U.run(),await this.L(this.y.map(j=>j.postUninstall(U.extension,U.options,N.CancellationToken.None))),U.extension.identifier.uuid)try{await this.z.reportStatistic(U.extension.manifest.publisher,U.extension.manifest.name,U.extension.manifest.version,g.StatisticType.Uninstall)}catch{}}catch(j){const F=i(j);throw b(U.extension,U.options,F),F}finally{S.push(U)}})),v.length&&await this.L(v);for(const U of C)b(U.extension,U.options)}catch(U){const j=i(U);for(const F of C){try{F.cancel()}catch{}S.includes(F)||b(F.extension,F.options,j)}throw j}finally{for(const U of C)this.m.delete(o(U.extension,U.options))||this.F.warn("Uninstallation task is not found in the cache",U.extension.identifier.id)}}P(r,o,u){for(const b of r){const C=this.S(b,o);if(C.length){const S=C.filter(v=>!r.some(L=>(0,l.$Qp)(L.identifier,v.identifier)));if(S.length)throw new Error(this.Q(b,S,u))}}}Q(r,o,u){return u===r?o.length===1?$.localize(1774,null,u.manifest.displayName||u.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?$.localize(1775,null,u.manifest.displayName||u.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):$.localize(1776,null,u.manifest.displayName||u.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?$.localize(1777,null,u.manifest.displayName||u.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?$.localize(1778,null,u.manifest.displayName||u.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):$.localize(1779,null,u.manifest.displayName||u.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}R(r,o,u=[]){if(u.indexOf(r)!==-1)return[];u.push(r);const b=r.manifest.extensionPack?r.manifest.extensionPack:[];if(b.length){const C=o.filter(v=>!v.isBuiltin&&b.some(L=>(0,l.$Qp)({id:L},v.identifier))),S=[];for(const v of C)S.push(...this.R(v,o,u));return[...C,...S]}return[]}S(r,o){return o.filter(u=>u.manifest.extensionDependencies&&u.manifest.extensionDependencies.some(b=>(0,l.$Qp)({id:b},r.identifier)))}async U(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(r){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,A.$_)(r)),{malicious:[],deprecated:{},search:[]}}}};e.$Lq=h,e.$Lq=h=Ee([X(0,g.$pp),X(1,P.$cm),X(2,m.$Nl),X(3,w.$dk),X(4,f.$wk),X(5,c.$Pl)],h);function i(s,r){if(s instanceof g.$rp)return s;let o;return s instanceof g.$qp?o=new g.$rp(s.message,s.code===g.ExtensionGalleryErrorCode.DownloadFailedWriting?g.ExtensionManagementErrorCode.DownloadFailedWriting:g.ExtensionManagementErrorCode.Gallery):o=new g.$rp(s.message,(0,A.$6)(s)?g.ExtensionManagementErrorCode.Cancelled:r??g.ExtensionManagementErrorCode.Internal),o.stack=s.stack,o}function n(s,r,{extensionData:o,verificationStatus:u,duration:b,error:C,source:S,durationSinceUpdate:v}){let L,U;(0,I.$pg)(u)&&(u===!0?u="Verified":(u===!1||(L=g.ExtensionManagementErrorCode.Signature,U=u),u="Unverified")),C&&(L=C.code,C.code===g.ExtensionManagementErrorCode.Signature&&(U=C.message)),s.publicLog(r,{...o,verificationStatus:u,success:!C,duration:b,errorcode:L,errorcodeDetail:U,durationSinceUpdate:v,source:S})}class t{constructor(){this.d=new a.$Hh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,a.$vh)(r=>this.h(r))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,a.$vh)(r=>new Promise((o,u)=>{const b=r.onCancellationRequested(()=>{b.dispose(),u(new A.$7)})})),this.d.open()),this.g.cancel()}}e.$Nq=t}),define(fe[52],de([0,1,6,14,2,3,31,9,27,35,7,4,10,19,28,12,8,18]),function(ce,e,R,a,N,A,T,k,O,y,I,p,$,g,l,d,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=e.$Pq=e.$Oq=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(i){i.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",i.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f||(e.ExtensionsProfileScanningErrorCode=f={}));class P extends Error{constructor(n,t){super(n),this.code=t}}e.$Oq=P,e.$Pq=(0,p.$Ii)("IExtensionsProfileScannerService");let m=class extends N.$Xc{constructor(n,t,s,r,o,u){super(),this.j=n,this.m=t,this.n=s,this.r=r,this.s=o,this.t=u,this.b=this.B(new A.$oe),this.onAddExtensions=this.b.event,this.c=this.B(new A.$oe),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$oe),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$oe),this.onDidRemoveExtensions=this.g.event,this.h=new T.$Dc}scanProfileExtensions(n,t){return this.u(n,void 0,t)}async addExtensionsToProfile(n,t,s){const r=[],o=[];try{return await this.u(t,u=>{const b=[];if(s)b.push(...u);else for(const C of u)n.some(([S])=>(0,y.$Qp)(S.identifier,C.identifier)&&S.manifest.version!==C.version)?r.push(C):b.push(C);for(const[C,S]of n){const v=b.findIndex(U=>(0,y.$Qp)(U.identifier,C.identifier)&&U.version===C.manifest.version),L={identifier:C.identifier,version:C.manifest.version,location:C.location,metadata:S};v===-1?(o.push(L),b.push(L)):b.splice(v,1,L)}return o.length&&this.b.fire({extensions:o,profileLocation:t}),r.length&&this.f.fire({extensions:r,profileLocation:t}),b}),o.length&&this.c.fire({extensions:o,profileLocation:t}),r.length&&this.g.fire({extensions:r,profileLocation:t}),o}catch(u){throw o.length&&this.c.fire({extensions:o,error:u,profileLocation:t}),r.length&&this.g.fire({extensions:r,error:u,profileLocation:t}),u}}async updateMetadata(n,t){const s=[];return await this.u(t,r=>{const o=[];for(const u of r){const b=n.find(([C])=>(0,y.$Qp)(C.identifier,u.identifier)&&C.manifest.version===u.version);b&&(u.metadata={...u.metadata,...b[1]},s.push(u)),o.push(u)}return o}),s}async removeExtensionFromProfile(n,t){const s=[];try{await this.u(t,r=>{const o=[];for(const u of r)(0,y.$Qp)(u.identifier,n.identifier)?s.push(u):o.push(u);return s.length&&this.f.fire({extensions:s,profileLocation:t}),o}),s.length&&this.g.fire({extensions:s,profileLocation:t})}catch(r){throw s.length&&this.g.fire({extensions:s,error:r,profileLocation:t}),r}}async u(n,t,s){return this.F(n).queue(async()=>{let r=[],o;try{const u=await this.m.readFile(n);o=JSON.parse(u.value.toString().trim()||"[]")}catch(u){if((0,I.$ul)(u)!==I.FileOperationResult.FILE_NOT_FOUND)throw u;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(o=await this.D()),!o&&s?.bailOutWhenFileNotFound)throw new P((0,E.$_)(u),f.ERROR_PROFILE_NOT_FOUND)}if(o){Array.isArray(o)||this.w(n);let u=!1;for(const b of o){c(b)||this.w(n);let C;if((0,d.$hg)(b.relativeLocation)&&b.relativeLocation)C=this.z(b.relativeLocation);else if((0,d.$hg)(b.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${b.location}`);continue}else{C=k.URI.revive(b.location);const S=this.y(C);S&&(u=!0,b.relativeLocation=S)}(0,d.$og)(b.metadata?.hasPreReleaseVersion)&&b.metadata?.preRelease&&(u=!0,b.metadata.hasPreReleaseVersion=!0),r.push({identifier:b.identifier,location:C,version:b.version,metadata:b.metadata})}u&&await this.m.writeFile(n,a.$Qe.fromString(JSON.stringify(o)))}if(t){r=t(r);const u=r.map(b=>({identifier:b.identifier,version:b.version,location:b.location.toJSON(),relativeLocation:this.y(b.location),metadata:b.metadata}));await this.m.writeFile(n,a.$Qe.fromString(JSON.stringify(u)))}return r})}w(n){const t=new P(`Invalid extensions content in ${n.toString()}`,f.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),t=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(n)).value.toString()}catch(o){if((0,I.$ul)(o)===I.FileOperationResult.FILE_NOT_FOUND)return;throw o}this.t.info("Migrating extensions from old default profile location",n.toString());let r;try{const o=JSON.parse(s);Array.isArray(o)&&o.every(u=>c(u))?r=o:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",o)}catch(o){this.t.error(o)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,a.$Qe.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(o){if((0,I.$ul)(o)===I.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw o}try{await this.m.del(n)}catch(o){(0,I.$ul)(o)!==I.FileOperationResult.FILE_NOT_FOUND&&this.t.error(o)}try{await this.m.del(t)}catch(o){(0,I.$ul)(o)!==I.FileOperationResult.FILE_NOT_FOUND&&this.t.error(o)}return r})()),this.C}F(n){let t=this.h.get(n);return t||(t=new R.$Ph,this.h.set(n,t)),t}};e.$Qq=m,e.$Qq=m=Ee([X(1,I.$dl),X(2,g.$Pl),X(3,l.$Nl),X(4,w.$cm),X(5,$.$dk)],m);function c(i){return(0,d.$jg)(i)&&(0,O.$op)(i.identifier)&&(h(i.location)||(0,d.$hg)(i.location)&&i.location)&&((0,d.$og)(i.relativeLocation)||(0,d.$hg)(i.relativeLocation))&&i.version&&(0,d.$hg)(i.version)}function h(i){return i?(0,d.$hg)(i.path)&&(0,d.$hg)(i.scheme):!1}});var it=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(fe[85],de([0,1,17,6,29,14,8,36,153,2,22,13,5,20,60,94,12,9,11,15,35,34,59,7,4,10,23,3,66,52,19,28,158]),function(ce,e,R,a,N,A,T,k,O,y,I,p,$,g,l,d,E,w,f,P,m,c,h,i,n,t,s,r,o,u,b,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=e.$Vq=e.$Uq=e.$Tq=e.Translations=void 0,e.$Wq=G,N=Oe(N),p=Oe(p),$=Oe($),l=Oe(l),d=it(d);var v;(function(x){function H(te,B){if(te===B)return!0;const W=Object.keys(te),_=new Set;for(const ne of Object.keys(B))_.add(ne);if(W.length!==_.size)return!1;for(const ne of W){if(te[ne]!==B[ne])return!1;_.delete(ne)}return _.size===0}x.equals=H})(v||(e.Translations=v={})),e.$Tq=(0,n.$Ii)("IExtensionsScannerService");let L=class extends y.$Xc{constructor(H,te,B,W,_,ne,le,ee,J,K,q,D){super(),this.systemExtensionsLocation=H,this.userExtensionsLocation=te,this.r=B,this.s=W,this.t=_,this.u=ne,this.w=le,this.y=ee,this.z=J,this.C=K,this.D=q,this.F=D,this.g=this.B(new r.$oe),this.onDidChangeCache=this.g.event,this.h=(0,g.$jh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(F,this.s,this.h)),this.m=this.B(this.F.createInstance(F,this.s,this.h)),this.n=this.B(this.F.createInstance(j,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(c.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(c.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,m.$2p)(this.w,this.y)),this.G}async scanAllExtensions(H,te,B){const[W,_]=await Promise.all([this.scanSystemExtensions(H),this.scanUserExtensions(te)]),ne=B?await this.scanExtensionsUnderDevelopment(H,[...W,..._]):[];return this.L(W,_,ne,await this.getTargetPlatform(),!0)}async scanSystemExtensions(H){const te=[];te.push(this.M(!!H.useCache,H.language)),te.push(this.N(H.language,!!H.checkControlFile));const[B,W]=await Promise.all(te);return this.J([...B,...W],c.ExtensionType.System,H,!1)}async scanUserExtensions(H){const te=H.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",te);const B=this.D.extUri.isEqual(H.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,W=await this.P(te,!!H.profileLocation,c.ExtensionType.User,!H.includeUninstalled,H.language,!0,B,H.productVersion??this.R()),_=H.useCache&&!W.devMode&&W.excludeObsolete?this.m:this.n;let ne;try{ne=await _.scanExtensions(W)}catch(le){if(le instanceof u.$Oq&&le.code===u.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),ne=await _.scanExtensions(W);else throw le}return ne=await this.J(ne,c.ExtensionType.User,H,!0),this.y.trace("Scanned user extensions:",ne.length),ne}async scanExtensionsUnderDevelopment(H,te){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const B=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(W=>W.scheme===I.Schemas.file).map(async W=>{const _=await this.P(W,!1,c.ExtensionType.User,!0,H.language,!1,void 0,H.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(_)).map(le=>(le.type=te.find(ee=>(0,m.$Qp)(ee.identifier,le.identifier))?.type??le.type,this.n.validate(le,_)))}))).flat();return this.J(B,"development",H,!0)}return[]}async scanExistingExtension(H,te,B){const W=await this.P(H,!1,te,!0,B.language,!0,void 0,B.productVersion??this.R()),_=await this.n.scanExtension(W);return!_||!B.includeInvalid&&!_.isValid?null:_}async scanOneOrMultipleExtensions(H,te,B){const W=await this.P(H,!1,te,!0,B.language,!0,void 0,B.productVersion??this.R()),_=await this.n.scanOneOrMultipleExtensions(W);return this.J(_,te,B,!0)}async scanMultipleExtensions(H,te,B){const W=[];return await Promise.all(H.map(async _=>{const ne=await this.scanOneOrMultipleExtensions(_,te,B);W.push(...ne)})),this.J(W,te,B,!0)}async scanMetadata(H){const te=(0,g.$jh)(H,"package.json"),B=(await this.w.readFile(te)).value.toString();return JSON.parse(B).__metadata}async updateMetadata(H,te){const B=(0,g.$jh)(H,"package.json"),W=(await this.w.readFile(B)).value.toString(),_=JSON.parse(W);te.isMachineScoped===!1&&delete te.isMachineScoped,te.isBuiltin===!1&&delete te.isBuiltin,_.__metadata={..._.__metadata,...te},await this.w.writeFile((0,g.$jh)(H,"package.json"),A.$Qe.fromString(JSON.stringify(_,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(H){if(H instanceof u.$Oq&&H.code===u.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw H}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const H=await this.scanUserExtensions({includeInvalid:!0});if(H.length)await this.u.addExtensionsToProfile(H.map(te=>[te,te.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$Qe.fromString(JSON.stringify([])))}catch(te){(0,i.$ul)(te)!==i.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,T.$_)(te))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(H){this.y.error(H)}finally{this.H=void 0}})()),this.H}async J(H,te,B,W){return B.includeAllVersions||(H=this.L(te===c.ExtensionType.System?H:void 0,te===c.ExtensionType.User?H:void 0,te==="development"?H:void 0,await this.getTargetPlatform(),W)),B.includeInvalid||(H=H.filter(_=>_.isValid)),H.sort((_,ne)=>{const le=p.$qc(_.location.fsPath),ee=p.$qc(ne.location.fsPath);return le<ee?-1:le>ee?1:0})}L(H,te,B,W,_){const ne=(ee,J,K)=>{if(ee.isValid&&!J.isValid)return!1;if(ee.isValid===J.isValid){if(_&&l.gt(ee.manifest.version,J.manifest.version))return this.y.debug(`Skipping extension ${J.location.path} with lower version ${J.manifest.version} in favour of ${ee.location.path} with version ${ee.manifest.version}`),!1;if(l.eq(ee.manifest.version,J.manifest.version)){if(ee.type===c.ExtensionType.System)return this.y.debug(`Skipping extension ${J.location.path} in favour of system extension ${ee.location.path} with same version`),!1;if(ee.targetPlatform===W)return this.y.debug(`Skipping extension ${J.location.path} from different target platform ${J.targetPlatform}`),!1}}return K?this.y.warn(`Overwriting user extension ${ee.location.path} with ${J.location.path}.`):this.y.debug(`Overwriting user extension ${ee.location.path} with ${J.location.path}.`),!0},le=new c.$xn;return H?.forEach(ee=>{const J=le.get(ee.identifier.id);(!J||ne(J,ee,!1))&&le.set(ee.identifier.id,ee)}),te?.forEach(ee=>{const J=le.get(ee.identifier.id);if(!J&&H&&ee.type===c.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${ee.location.path}.`);return}(!J||ne(J,ee,!1))&&le.set(ee.identifier.id,ee)}),B?.forEach(ee=>{const J=le.get(ee.identifier.id);(!J||ne(J,ee,!0))&&le.set(ee.identifier.id,ee),le.set(ee.identifier.id,ee)}),[...le.values()]}async M(H,te){this.y.trace("Started scanning system extensions");const B=await this.P(this.systemExtensionsLocation,!1,c.ExtensionType.System,!0,te,!0,void 0,this.R()),_=await(H&&!B.devMode?this.j:this.n).scanExtensions(B);return this.y.trace("Scanned system extensions:",_.length),_}async N(H,te){const B=this.z.isBuilt?[]:this.C.builtInExtensions;if(!B?.length)return[];this.y.trace("Started scanning dev system extensions");const W=te?await this.O():{},_=[],ne=w.URI.file(p.$kc(p.$mc(I.$3g.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ee of B){const J=W[ee.name]||"marketplace";switch(J){case"disabled":break;case"marketplace":_.push((0,g.$jh)(ne,ee.name));break;default:_.push(w.URI.file(J));break}}const le=await Promise.all(_.map(async ee=>this.n.scanExtension(await this.P(ee,!1,c.ExtensionType.System,!0,H,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",le.length),(0,R.$Jb)(le)}async O(){try{const H=await this.w.readFile(this.r);return JSON.parse(H.value.toString())}catch{return{}}}async P(H,te,B,W,_,ne,le,ee){const J=await this.f(_??$.$x),K=await this.Q(H),q=te&&!this.D.extUri.isEqual(H,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,D=q?await this.Q(q):void 0;return new U(H,K,q,D,te,le,B,W,ne,ee.version,ee.date,this.C.commit,!this.z.isBuilt,_,J)}async Q(H){try{const te=await this.w.stat(H);if(typeof te.mtime=="number")return te.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Uq=L,e.$Uq=L=Ee([X(4,b.$Pl),X(5,u.$Pq),X(6,i.$dl),X(7,t.$dk),X(8,P.$Pi),X(9,s.$wk),X(10,C.$Nl),X(11,n.$Hi)],L);class U{constructor(H,te,B,W,_,ne,le,ee,J,K,q,D,Q,oe,Z){this.location=H,this.mtime=te,this.applicationExtensionslocation=B,this.applicationExtensionslocationMtime=W,this.profile=_,this.profileScanOptions=ne,this.type=le,this.excludeObsolete=ee,this.validate=J,this.productVersion=K,this.productDate=q,this.productCommit=D,this.devMode=Q,this.language=oe,this.translations=Z}static createNlsConfiguration(H){return{language:H.language,pseudo:H.language==="pseudo",devMode:H.devMode,translations:H.translations}}static equals(H,te){return(0,g.$ch)(H.location,te.location)&&H.mtime===te.mtime&&(0,g.$ch)(H.applicationExtensionslocation,te.applicationExtensionslocation)&&H.applicationExtensionslocationMtime===te.applicationExtensionslocationMtime&&H.profile===te.profile&&N.$mo(H.profileScanOptions,te.profileScanOptions)&&H.type===te.type&&H.excludeObsolete===te.excludeObsolete&&H.validate===te.validate&&H.productVersion===te.productVersion&&H.productDate===te.productDate&&H.productCommit===te.productCommit&&H.devMode===te.devMode&&H.language===te.language&&v.equals(H.translations,te.translations)}}e.$Vq=U;let j=class extends y.$Xc{constructor(H,te,B,W,_,ne,le){super(),this.g=H,this.h=te,this.j=B,this.m=W,this.n=ne,this.r=le,this.f=_.extensionsEnabledWithApiProposalVersion?.map(ee=>ee.toLowerCase())??[]}async scanExtensions(H){const te=H.profile?await this.t(H):await this.s(H);let B={};if(H.excludeObsolete&&H.type===c.ExtensionType.User)try{const W=(await this.m.readFile(this.g)).value.toString();B=JSON.parse(W)}catch{}return(0,E.$ug)(B)?te:te.filter(W=>!B[m.$Rp.create(W).toString()])}async s(H){const te=await this.m.resolve(H.location);if(!te.children?.length)return[];const B=await Promise.all(te.children.map(async W=>{if(!W.isDirectory||H.type===c.ExtensionType.User&&(0,g.$gh)(W.resource).indexOf(".")===0)return null;const _=new U(W.resource,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(_)}));return(0,R.$Jb)(B).sort((W,_)=>W.location.path<_.location.path?-1:1)}async t(H){let te=await this.u(H.location,()=>!0,H);if(H.applicationExtensionslocation&&!this.j.extUri.isEqual(H.location,H.applicationExtensionslocation)){te=te.filter(W=>!W.metadata?.isApplicationScoped);const B=await this.u(H.applicationExtensionslocation,W=>!!W.metadata?.isBuiltin||!!W.metadata?.isApplicationScoped,H);te.push(...B)}return te}async u(H,te,B){const W=await this.h.scanProfileExtensions(H,B.profileScanOptions);if(!W.length)return[];const _=await Promise.all(W.map(async ne=>{if(te(ne)){const le=new U(ne.location,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(le,ne.metadata)}return null}));return(0,R.$Jb)(_)}async scanOneOrMultipleExtensions(H){try{if(await this.m.exists((0,g.$jh)(H.location,"package.json"))){const te=await this.scanExtension(H);return te?[te]:[]}else return await this.scanExtensions(H)}catch(te){return this.r.error(`Error scanning extensions at ${H.location.path}:`,(0,T.$_)(te)),[]}}async scanExtension(H,te){try{let B=await this.w(H.location);if(B){B.publisher||(B.publisher=c.$rn),te=te??B.__metadata,delete B.__metadata;const W=(0,m.$Vp)(B.publisher,B.name),_=te?.id?{id:W,uuid:te.id}:{id:W},ne=te?.isSystem?c.ExtensionType.System:H.type,le=ne===c.ExtensionType.System||!!te?.isBuiltin;B=await this.y(H.location,B,U.createNlsConfiguration(H));let ee={type:ne,identifier:_,manifest:B,location:H.location,isBuiltin:le,targetPlatform:te?.targetPlatform??c.TargetPlatform.UNDEFINED,publisherDisplayName:te?.publisherDisplayName,metadata:te,isValid:!0,validations:[]};return H.validate&&(ee=this.validate(ee,H)),B.enabledApiProposals&&(!this.n.isBuilt||this.f.includes(W.toLowerCase()))&&(B.originalEnabledApiProposals=B.enabledApiProposals,B.enabledApiProposals=(0,c.$Dn)([...B.enabledApiProposals])),ee}}catch(B){H.type!==c.ExtensionType.System&&this.r.error(B)}return null}validate(H,te){let B=!0;const W=this.n.isBuilt&&this.f.includes(H.identifier.id.toLowerCase()),_=(0,h.$8p)(te.productVersion,te.productDate,te.location,H.manifest,H.isBuiltin,W);for(const[ne,le]of _)ne===d.default.Error&&(B=!1,this.r.error(this.F(te.location,le)));return H.isValid=B,H.validations=_,H}async w(H){const te=(0,g.$jh)(H,"package.json");let B;try{B=(await this.m.readFile(te)).value.toString()}catch(_){return(0,i.$ul)(_)!==i.FileOperationResult.FILE_NOT_FOUND&&this.r.error(this.F(H,(0,f.localize)(1815,null,te.path,_.message))),null}let W;try{W=JSON.parse(B)}catch{const ne=[];(0,k.$3n)(B,ne);for(const le of ne)this.r.error(this.F(H,(0,f.localize)(1816,null,te.path,le.offset,le.length,(0,O.$Rq)(le.error))));return null}return(0,k.$$n)(W)!=="object"?(this.r.error(this.F(H,(0,f.localize)(1817,null,te.path))),null):W}async y(H,te,B){const W=await this.z(H,te,B);if(W)try{const _=[],ne=await this.C(W.default,_);if(_.length>0)return _.forEach(ee=>{this.r.error(this.F(H,(0,f.localize)(1818,null,W.default?.path,(0,O.$Rq)(ee.error))))}),te;if((0,k.$$n)(W)!=="object")return this.r.error(this.F(H,(0,f.localize)(1819,null,W.default?.path))),te;const le=W.values||Object.create(null);return(0,S.$Sq)(this.r,te,le,ne)}catch{}return te}async z(H,te,B){const W=(0,g.$jh)(H,"package.nls.json"),_=(J,K)=>{K.forEach(q=>{this.r.error(this.F(H,(0,f.localize)(1820,null,J?.path,(0,O.$Rq)(q.error))))})},ne=J=>{this.r.error(this.F(H,(0,f.localize)(1821,null,J?.path)))},le=`${te.publisher}.${te.name}`,ee=B.translations[le];if(ee)try{const J=w.URI.file(ee),K=(await this.m.readFile(J)).value.toString(),q=[],D=(0,k.$3n)(K,q);return q.length>0?(_(J,q),{values:void 0,default:W}):(0,k.$$n)(D)!=="object"?(ne(J),{values:void 0,default:W}):{values:D.contents?D.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.m.exists(W))return;let K;try{K=await this.D(H,B)}catch{return}if(!K.localized)return{values:void 0,default:K.original};try{const q=(await this.m.readFile(K.localized)).value.toString(),D=[],Q=(0,k.$3n)(q,D);return D.length>0?(_(K.localized,D),{values:void 0,default:K.original}):(0,k.$$n)(Q)!=="object"?(ne(K.localized),{values:void 0,default:K.original}):{values:Q,default:K.original}}catch{return{values:void 0,default:K.original}}}}async C(H,te){if(H)try{const B=(await this.m.readFile(H)).value.toString();return(0,k.$3n)(B,te)}catch{}}D(H,te){return new Promise((B,W)=>{const _=ne=>{const le=(0,g.$jh)(H,`package.nls.${ne}.json`);this.m.exists(le).then(ee=>{ee&&B({localized:le,original:(0,g.$jh)(H,"package.nls.json")});const J=ne.lastIndexOf("-");J===-1?B({localized:(0,g.$jh)(H,"package.nls.json"),original:null}):(ne=ne.substring(0,J),_(ne))})};if(te.devMode||te.pseudo||!te.language)return B({localized:(0,g.$jh)(H,"package.nls.json"),original:null});_(te.language)})}F(H,te){return`[${H.path}]: ${te}`}};j=Ee([X(1,u.$Pq),X(2,C.$Nl),X(3,i.$dl),X(4,s.$wk),X(5,P.$Pi),X(6,t.$dk)],j);let F=class extends j{constructor(H,te,B,W,_,ne,le,ee,J){super(te,W,_,ne,le,ee,J),this.J=H,this.L=B,this.H=this.B(new a.$Gh(3e3)),this.I=this.B(new r.$oe),this.onDidChangeCache=this.I.event}async scanExtensions(H){const te=this.P(H),B=await this.M(te);if(this.G=H,B&&B.input&&U.equals(B.input,this.G))return this.r.debug("Using cached extensions scan result",H.type===c.ExtensionType.System?"system":"user",H.location.toString()),this.H.trigger(()=>this.O()),B.result.map(_=>(_.location=w.URI.revive(_.location),_));const W=await super.scanExtensions(H);return await this.N(te,{input:H,result:W}),W}async M(H){try{const te=await this.m.readFile(H),B=JSON.parse(te.value.toString());return{result:B.result,input:(0,o.$fi)(B.input)}}catch(te){this.r.debug("Error while reading the extension cache file:",H.path,(0,T.$_)(te))}return null}async N(H,te){try{await this.m.writeFile(H,A.$Qe.fromString(JSON.stringify(te)))}catch(B){this.r.debug("Error while writing the extension cache file:",H.path,(0,T.$_)(B))}}async O(){if(!this.G)return;const H=this.P(this.G),te=await this.M(H);if(!te)return;const B=te.result,W=JSON.parse(JSON.stringify(await super.scanExtensions(this.G)));if(!N.$mo(W,B))try{this.r.info("Invalidating Cache",B,W),await this.m.del(H),this.I.fire()}catch(_){this.r.error(_)}}P(H){const te=this.Q(H);return this.j.extUri.joinPath(te.cacheHome,H.type===c.ExtensionType.System?c.$qn:c.$pn)}Q(H){return H.type===c.ExtensionType.System?this.L.defaultProfile:H.profile?this.j.extUri.isEqual(H.location,this.J.extensionsResource)?this.J:this.L.profiles.find(te=>this.j.extUri.isEqual(H.location,te.extensionsResource))??this.J:this.L.defaultProfile}};F=Ee([X(2,b.$Pl),X(3,u.$Pq),X(4,C.$Nl),X(5,i.$dl),X(6,s.$wk),X(7,P.$Pi),X(8,t.$dk)],F);function G(x,H){const te=(0,m.$Tp)(x.manifest.publisher,x.manifest.name);return{id:te,identifier:new c.$vn(te),isBuiltin:x.type===c.ExtensionType.System,isUserBuiltin:x.type===c.ExtensionType.User&&x.isBuiltin,isUnderDevelopment:H,extensionLocation:x.location,uuid:x.identifier.uuid,targetPlatform:x.targetPlatform,publisherDisplayName:x.publisherDisplayName,...x.manifest}}class V extends L{constructor(H,te,B,W,_,ne,le,ee,J,K,q,D){super(H,te,(0,g.$jh)(B,".vscode-oss-dev","extensions","control.json"),W,_,ne,le,ee,J,K,q,D),this.S=(async()=>{if($.$A)try{const Q=await this.w.readFile(w.URI.file($.$A));return JSON.parse(Q.value.toString())}catch{}return Object.create(null)})()}f(H){return this.S}}e.$Xq=V}),define(fe[216],de([0,1,69,6,43,3,2,22,13,30,10,19]),function(ce,e,R,a,N,A,T,k,O,y,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=void 0;let $=class extends T.$Xc{constructor(l,d){super(),this.b=l,this.f=d,this.a=new a.$Oh(5)}async postUninstall(l){const d=this.g(l,"uninstall");d&&(this.f.info(l.identifier.id,l.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(d.script,"uninstall",d.args,!0,l),this.f.info("Finished running post uninstall script",l.identifier.id,l.manifest.version)}catch(E){this.f.error("Failed to run post uninstall script",l.identifier.id,l.manifest.version),this.f.error(E)}}));try{await y.Promises.rm(this.m(l))}catch(E){this.f.error("Error while removing extension storage path",l.identifier.id),this.f.error(E)}}g(l,d){const E=`vscode:${d}`;if(l.location.scheme===k.Schemas.file&&l.manifest&&l.manifest.scripts&&typeof l.manifest.scripts[E]=="string"){const w=l.manifest.scripts[E].split(" ");return w.length<2||w[0]!=="node"||!w[1]?(this.f.warn(l.identifier.id,l.manifest.version,`${E} should be a node script`),null):{script:(0,O.$mc)(l.location.fsPath,w[1]),args:w.slice(2)||[]}}return null}h(l,d,E,w,f){return new Promise((P,m)=>{const c=this.j(l,d,E,f);let h;const i=n=>{h&&(clearTimeout(h),h=null),n?m(n):P(void 0)};c.on("error",n=>{i((0,N.$tj)(n)||"Unknown")}),c.on("exit",(n,t)=>{i(n?`post-${d} process exited with code ${n}`:void 0)}),w&&(h=setTimeout(()=>{h=null,c.kill(),m("timed out")},5e3))})}j(l,d,E,w){const f={silent:!0,execArgv:void 0},P=(0,R.fork)(l,[`--type=extension-post-${d}`,...E],f);P.stdout.setEncoding("utf8"),P.stderr.setEncoding("utf8");const m=A.Event.fromNodeEventEmitter(P.stdout,"data"),c=A.Event.fromNodeEventEmitter(P.stderr,"data");this.B(m(n=>this.f.info(w.identifier.id,w.manifest.version,`post-${d}`,n))),this.B(c(n=>this.f.error(w.identifier.id,w.manifest.version,`post-${d}`,n)));const h=A.Event.any(A.Event.map(m,n=>({data:`%c${n}`,format:[""]}),this.q),A.Event.map(c,n=>({data:`%c${n}`,format:["color: red"]}),this.q));return A.Event.debounce(h,(n,t)=>n?{data:n.data+t.data,format:[...n.format,...t.format]}:{data:t.data,format:t.format},100,void 0,void 0,void 0,this.q)(n=>{console.group(w.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),P}m(l){return(0,O.$mc)(this.b.defaultProfile.globalStorageHome.fsPath,l.identifier.id.toLowerCase())}};e.$2q=$,e.$2q=$=Ee([X(0,p.$Pl),X(1,I.$dk)],$)}),define(fe[118],de([0,1,73,11,84,27]),function(ce,e,R,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=T,e.$Zq=k;function T(O){let y=A.ExtensionManagementErrorCode.Extract;return O instanceof R.$Hq&&(O.type==="CorruptZip"?y=A.ExtensionManagementErrorCode.CorruptZip:O.type==="Incomplete"&&(y=A.ExtensionManagementErrorCode.IncompleteZip)),(0,N.$Mq)(O,y)}async function k(O){let y;try{y=await(0,R.$Kq)(O,"extension/package.json")}catch(I){throw T(I)}try{return JSON.parse(y.toString("utf8"))}catch{throw new A.$rp((0,a.localize)(1831,null),A.ExtensionManagementErrorCode.Invalid)}}}),define(fe[217],de([0,1,6,8,2,22,20,60,12,32,30,73,21,15,84,27,35,118,112,7,10,18]),function(ce,e,R,a,N,A,T,k,O,y,I,p,$,g,l,d,E,w,f,P,m,c){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=void 0,k=Oe(k);let i=class extends N.$Xc{static{h=this}static{this.c=".sigzip"}constructor(t,s,r,o,u,b,C){super(),this.h=s,this.j=r,this.m=o,this.n=u,this.r=b,this.t=C,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(t,s,r,o){await this.g;const u=await this.w(t,s);let b=!1;if(r&&this.u(t)){let C;try{C=await this.y(t)}catch(S){try{await this.delete(u)}catch(v){this.t.error(v)}throw S}try{b=await this.n.verify(t,u.fsPath,C.fsPath,o)}catch(S){if(b=S.code,b===f.ExtensionSignatureVerificationCode.PackageIsInvalidZip||b===f.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(u)}catch(v){this.t.error(v)}throw new d.$rp(p.$Gq,d.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(C)}catch(S){this.t.error(S)}}}return{location:u,verificationStatus:b}}u(t){if(!t.isSigned)return this.t.info(`Extension is not signed: ${t.identifier.id}`),!1;const s=this.m.getValue("extensions.verifySignature");return(0,O.$ng)(s)?s:!0}async w(t,s){try{const r=(0,T.$jh)(this.extensionsDownloadDir,this.G(t)),o=await this.C(t,"vsix",async()=>{await this.z(t,r,u=>this.j.download(t,u,s));try{await this.D(r.fsPath,"extension/package.json")}catch(u){try{await this.h.del(r)}catch(b){this.t.warn(`Error while deleting: ${r.path}`,(0,a.$_)(b))}throw u}},2);return o>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:t.identifier.id,attempts:o}),r}catch(r){throw(0,l.$Mq)(r,d.ExtensionManagementErrorCode.Download)}}async y(t){try{const s=(0,T.$jh)(this.extensionsDownloadDir,`.${(0,y.$5g)()}`),r=await this.C(t,"sigzip",async()=>{await this.j.downloadSignatureArchive(t,s);try{await this.D(s.fsPath,".signature.p7s")}catch(o){try{await this.h.del(s)}catch(u){this.t.warn(`Error while deleting: ${s.path}`,(0,a.$_)(u))}throw o}},2);return r>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:t.identifier.id,attempts:r}),s}catch(s){throw(0,l.$Mq)(s,d.ExtensionManagementErrorCode.DownloadSignature)}}async z(t,s,r){if(await this.h.exists(s))return;if(s.scheme!==A.Schemas.file){await r(s);return}const o=(0,T.$jh)(this.extensionsDownloadDir,`.${(0,y.$5g)()}`);try{await r(o)}catch(u){try{await this.h.del(o)}catch{}throw u}try{await I.Promises.rename(o.fsPath,s.fsPath,2*60*1e3)}catch(u){try{await this.h.del(o)}catch{}let b=!1;try{b=await this.h.exists(s)}catch{}if(b)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,s.path);else throw this.t.info(`Rename failed because of ${(0,a.$_)(u)}. Deleted the file from downloaded location`,o.path),u}}async C(t,s,r,o){let u=1;for(;;)try{return await r(),u}catch(b){if(u++>o)throw b;this.t.warn(`Failed downloading ${s}. ${(0,a.$_)(b)}. Retry again...`,t.identifier.id)}}async D(t,s){try{await(0,p.$Kq)(t,s)}catch(r){throw(0,w.$Yq)(r)}}async delete(t){await this.g,await this.h.del(t)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const s=[],r=[],o=[];for(const C of t.children)if(C.name.endsWith(h.c))o.push(C.resource);else{const S=E.$Rp.parse(C.name);S&&r.push([S,C])}const u=(0,E.$Wp)(r,([C])=>C),b=[];for(const C of u)C.sort((S,v)=>k.rcompare(S[0].version,v[0].version)),s.push(...C.slice(1).map(S=>S[1].resource)),b.push(C[0][1]);b.sort((C,S)=>C.mtime-S.mtime),s.push(...b.slice(0,Math.max(0,b.length-this.f)).map(C=>C.resource)),s.push(...o),await R.Promises.settled(s.map(C=>(this.t.trace("Deleting from cache",C.path),this.h.del(C))))}}catch(t){this.t.error(t)}}G(t){return this.f?E.$Rp.create(t).toString().toLowerCase():(0,y.$5g)()}};e.$1q=i,e.$1q=i=h=Ee([X(0,g.$Qi),X(1,P.$dl),X(2,d.$pp),X(3,$.$cj),X(4,f.$zq),X(5,c.$cm),X(6,m.$dk)],i)}),define(fe[119],de([0,1,33,6,14,25,43,8,3,55,2,31,22,13,20,60,12,9,32,30,73,11,100,15,84,27,35,52,85,217,216,118,189,199,34,59,7,4,10,23,18,28,19]),function(ce,e,R,a,N,A,T,k,O,y,I,p,$,g,l,d,E,w,f,P,m,c,h,i,n,t,s,r,o,u,b,C,S,v,L,U,j,F,G,V,x,H,te){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=e.$6q=e.$5q=void 0,R=Oe(R),g=Oe(g),d=Oe(d),P=Oe(P),c=Oe(c),e.$5q=(0,F.$Ji)(t.$sp);const B=".vsctmp";let W=class extends n.$Lq{constructor(J,K,q,D,Q,oe,Z,Y,M,z,ie,ae){super(J,K,ie,q,z,ae),this.db=Q,this.eb=oe,this.fb=Z,this.gb=Y,this.hb=M,this.cb=new Map,this.sb=new p.$Ec;const ue=this.B(Y.createInstance(b.$2q));this.$=this.B(Y.createInstance(_,be=>ue.postUninstall(be))),this.ab=this.B(new S.$3q(ae,M,ie,this,this.F)),this.bb=this.B(Y.createInstance(u.$1q));const pe=this.B(new v.$4q(this,this.db,ae,oe,ie,M,q));this.B(pe.onDidChangeExtensionsByAnotherSource(be=>this.rb(be))),this.tb()}getTargetPlatform(){return this.ib||(this.ib=(0,s.$2p)(this.hb,this.F)),this.ib}async zip(J){this.F.trace("ExtensionManagementService#zip",J.identifier.id);const K=await this.qb(J),q=await(0,m.zip)((0,l.$jh)(this.bb.extensionsDownloadDir,(0,f.$5g)()).fsPath,K);return w.URI.file(q)}async getManifest(J){const{location:K,cleanup:q}=await this.kb(J),D=g.$nc(K.fsPath);try{return await(0,C.$Zq)(D)}finally{await q()}}getInstalled(J,K=this.H.defaultProfile.extensionsResource,q={version:this.G.version,date:this.G.date}){return this.$.scanExtensions(J??null,K,q)}scanAllUserInstalledExtensions(){return this.$.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(J){return this.$.scanUserExtensionAtLocation(J)}async install(J,K={}){this.F.trace("ExtensionManagementService#install",J.toString());const{location:q,cleanup:D}=await this.kb(J);try{const Q=await(0,C.$Zq)(g.$nc(q.fsPath)),oe=(0,s.$Vp)(Q.publisher,Q.name);if(Q.engines&&Q.engines.vscode&&!(0,U.$0p)(Q.engines.vscode,this.G.version,this.G.date))throw new Error(c.localize(1822,null,oe,this.G.version));const Y=(await this.I([{manifest:Q,extension:q,options:K}])).find(({identifier:M})=>(0,s.$Qp)(M,{id:oe}));if(Y?.local)return Y.local;throw Y?.error?Y.error:(0,n.$Mq)(new Error(`Unknown error while installing extension ${oe}`))}finally{await D()}}async installFromLocation(J,K){this.F.trace("ExtensionManagementService#installFromLocation",J.toString());const q=await this.$.scanUserExtensionAtLocation(J);if(!q||!q.manifest.name||!q.manifest.version)throw new Error(`Cannot find a valid extension from the location ${J.toString()}`);return await this.vb([[q,{source:"resource"}]],K),this.F.info("Successfully installed extension",q.identifier.id,K.toString()),q}async installExtensionsFromProfile(J,K,q){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",J,K.toString(),q.toString());const D=(await this.getInstalled(L.ExtensionType.User,K)).filter(Q=>J.some(oe=>(0,s.$Qp)(oe,Q.identifier)));if(D.length){const Q=await Promise.all(D.map(oe=>this.$.scanMetadata(oe,K)));await this.vb(D.map((oe,Z)=>[oe,Q[Z]]),q),this.F.info("Successfully installed extensions",D.map(oe=>oe.identifier.id),q.toString())}return D}async updateMetadata(J,K,q){return this.F.trace("ExtensionManagementService#updateMetadata",J.identifier.id),K.isPreReleaseVersion&&(K.preRelease=!0,K.hasPreReleaseVersion=!0),K.isMachineScoped===!1&&(K.isMachineScoped=void 0),K.isBuiltin===!1&&(K.isBuiltin=void 0),K.pinned===!1&&(K.pinned=void 0),J=await this.$.updateMetadata(J,K,q),this.ab.invalidate(q),this.w.fire({local:J,profileLocation:q}),J}async reinstallFromGallery(J){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",J.identifier.id),!this.z.isEnabled())throw new Error(c.localize(1823,null));const K=await this.getTargetPlatform(),[q]=await this.z.getExtensions([{...J.identifier,preRelease:J.preRelease}],{targetPlatform:K,compatible:!0},A.CancellationToken.None);if(!q)throw new Error(c.localize(1824,null));await this.$.setUninstalled(J);try{await this.$.removeUninstalledExtension(J)}catch(D){throw new Error(c.localize(1825,null,(0,T.$tj)(D)))}return this.installFromGallery(q)}Z(J,K,q,D){return this.$.copyExtension(J,K,q,D)}copyExtensions(J,K){return this.$.copyExtensions(J,K,{version:this.G.version,date:this.G.date})}markAsUninstalled(...J){return this.$.setUninstalled(...J)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.$.cleanUp()}catch(J){this.F.error(J)}}async download(J,K,q){const{location:D}=await this.bb.download(J,K,!q);return D}async kb(J){if(J.scheme===$.Schemas.file)return{location:J,async cleanup(){}};this.F.trace("Downloading extension from",J.toString());const K=(0,l.$jh)(this.bb.extensionsDownloadDir,(0,f.$5g)());return await this.fb.download(J,K),this.F.info("Downloaded extension to",K.toString()),{location:K,cleanup:async()=>{try{await this.hb.del(K)}catch(D){this.F.error(D)}}}}W(){return this.H.defaultProfile.extensionsResource}X(J,K,q){const D=K instanceof w.URI?new s.$Rp({id:(0,s.$Vp)(J.publisher,J.name)},J.version):s.$Rp.create(K);return this.gb.createInstance(ne,D,J,K,q,(Q,oe)=>{if(K instanceof w.URI)return this.pb(D,K,q,oe);let Z=this.cb.get(D.toString());return Z||(this.cb.set(D.toString(),Z=this.ob(D,K,Q,q,oe)),Z.finally(()=>this.cb.delete(D.toString()))),Z},this.$)}Y(J,K){return new le(J,K,this.eb)}async ob(J,K,q,D,Q){const{verificationStatus:oe,location:Z}=await this.bb.download(K,q,!D.donotVerifySignature,D.context?.[t.$ip]);try{if(Q.isCancellationRequested)throw new k.$7;const Y=await(0,C.$Zq)(Z.fsPath);if(!new s.$Rp(K.identifier,K.version).equals(new s.$Rp({id:(0,s.$Vp)(Y.publisher,Y.name)},Y.version)))throw new t.$rp(c.localize(1826,null,K.identifier.id),t.ExtensionManagementErrorCode.Invalid);return{local:await this.$.extractUserExtension(J,Z.fsPath,{id:K.identifier.uuid,publisherId:K.publisherId,publisherDisplayName:K.publisherDisplayName,targetPlatform:K.properties.targetPlatform,isApplicationScoped:D.isApplicationScoped,isMachineScoped:D.isMachineScoped,isBuiltin:D.isBuiltin,isPreReleaseVersion:K.properties.isPreReleaseVersion,hasPreReleaseVersion:K.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:D.installGivenVersion?!0:!!D.pinned,preRelease:(0,E.$ng)(D.preRelease)?D.preRelease:D.installPreReleaseVersion||K.properties.isPreReleaseVersion,source:"gallery"},!1,Q),verificationStatus:oe}}catch(Y){try{await this.bb.delete(Z)}catch(M){this.F.warn("Error while deleting the downloaded file",Z.toString(),(0,k.$_)(M))}throw(0,n.$Mq)(Y)}}async pb(J,K,q,D){return{local:await this.$.extractUserExtension(J,g.$nc(K.fsPath),{isApplicationScoped:q.isApplicationScoped,isMachineScoped:q.isMachineScoped,isBuiltin:q.isBuiltin,installedTimestamp:Date.now(),pinned:q.installGivenVersion?!0:!!q.pinned,source:"vsix"},q.keepExisting??!0,D)}}async qb(J){const K=async D=>{let Q=await P.Promises.readdir(D);Q=Q.map(Y=>g.$mc(D,Y));const oe=await Promise.all(Q.map(Y=>R.promises.stat(Y)));let Z=Promise.resolve([]);return oe.forEach((Y,M)=>{const z=Q[M];Y.isFile()&&(Z=Z.then(ie=>[...ie,z])),Y.isDirectory()&&(Z=Z.then(ie=>K(z).then(ae=>[...ie,...ae])))}),Z};return(await K(J.location.fsPath)).map(D=>({path:`extension/${g.$oc(J.location.fsPath,D)}`,localPath:D}))}async rb({added:J,removed:K}){if(K){const q=J&&this.D.extUri.isEqual(K.profileLocation,J.profileLocation)?K.extensions.filter(D=>J.extensions.every(Q=>!(0,s.$Qp)(Q,D))):K.extensions;for(const D of q)this.F.info("Extensions removed from another source",D.id,K.profileLocation.toString()),this.u.fire({identifier:D,profileLocation:K.profileLocation})}if(J){const D=(await this.getInstalled(L.ExtensionType.User,J.profileLocation)).filter(Q=>J.extensions.some(oe=>(0,s.$Qp)(oe,Q.identifier)));this.s.fire(D.map(Q=>(this.F.info("Extensions added from another source",Q.identifier.id,J.profileLocation.toString()),{identifier:Q.identifier,local:Q,profileLocation:J.profileLocation,operation:t.InstallOperation.None})))}}async tb(){this.B(this.$.onExtract(K=>this.sb.add(K)));const J=await this.hb.resolve(this.db.userExtensionsLocation);for(const K of J.children??[])K.isDirectory&&this.sb.add(K.resource);this.B(this.hb.watch(this.db.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(K=>this.ub(K)))}async ub(J){if(!J.affects(this.db.userExtensionsLocation,j.FileChangeType.ADDED))return;const K=[];for(const q of J.rawAdded){if(this.sb.has(q)||!this.D.extUri.isEqual(this.D.extUri.dirname(q),this.db.userExtensionsLocation)||this.D.extUri.isEqual(q,this.D.extUri.joinPath(this.db.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(q).startsWith(".")||!(await this.hb.stat(q)).isDirectory)continue;const D=await this.$.scanUserExtensionAtLocation(q);D&&D.installedTimestamp===void 0&&(this.sb.add(q),K.push(D))}K.length&&(await this.vb(K.map(q=>[q,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",K.map(q=>q.identifier.id)))}async vb(J,K){const q=J.map(D=>D[0]);await this.wb(q),await this.eb.addExtensionsToProfile(J,K),this.s.fire(q.map(D=>({local:D,identifier:D.identifier,operation:t.InstallOperation.None,profileLocation:K})))}async wb(J){const K=await this.$.getUninstalledExtensions();for(const q of J){const D=s.$Rp.create(q);K[D.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",D.id),await this.$.setInstalled(D),this.F.info("Removed the extension from uninstalled list:",D.id))}}};e.$6q=W,e.$6q=W=Ee([X(0,t.$pp),X(1,x.$cm),X(2,G.$dk),X(3,i.$Qi),X(4,o.$Tq),X(5,r.$Pq),X(6,h.$6o),X(7,F.$Hi),X(8,j.$dl),X(9,V.$wk),X(10,H.$Nl),X(11,te.$Pl)],W);let _=class extends I.$Xc{constructor(J,K,q,D,Q,oe,Z){super(),this.n=J,this.s=K,this.t=q,this.u=D,this.w=Q,this.y=oe,this.z=Z,this.h=this.B(new O.$oe),this.onExtract=this.h.event,this.j=new p.$Dc,this.m=new p.$Dc,this.c=(0,l.$jh)(this.t.userExtensionsLocation,".obsolete"),this.g=new a.$Ph}async cleanUp(){await this.J(),await this.I()}async scanExtensions(J,K,q){try{const D={includeInvalid:!0,profileLocation:K,productVersion:q};let Q=[];if(J===null||J===L.ExtensionType.System){let oe=this.j.get(K);oe||(oe=this.t.scanAllExtensions({includeInvalid:!0,useCache:!0},D,!1).finally(()=>this.j.delete(K)),this.j.set(K,oe)),Q.push(...await oe)}else if(J===L.ExtensionType.User){let oe=this.m.get(K);oe||(oe=this.t.scanUserExtensions(D).finally(()=>this.m.delete(K)),this.m.set(K,oe)),Q.push(...await oe)}return Q=J!==null?Q.filter(oe=>oe.type===J):Q,await Promise.all(Q.map(oe=>this.H(oe)))}catch(D){throw(0,n.$Mq)(D,t.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(J){try{const K=await this.t.scanUserExtensions({includeAllVersions:!J,includeInvalid:!0});return await Promise.all(K.map(q=>this.H(q)))}catch(K){throw(0,n.$Mq)(K,t.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(J){try{const K=await this.t.scanExistingExtension(J,L.ExtensionType.User,{includeInvalid:!0});if(K)return await this.H(K)}catch(K){this.z.error(K)}return null}async extractUserExtension(J,K,q,D,Q){const oe=J.toString(),Z=w.URI.file(g.$mc(this.t.userExtensionsLocation.fsPath,`.${(0,f.$5g)()}`)),Y=w.URI.file(g.$mc(this.t.userExtensionsLocation.fsPath,oe));if(await this.s.exists(Y)){if(!D)try{return await this.scanLocalExtension(Y,L.ExtensionType.User)}catch(M){this.z.warn(`Error while scanning the existing extension at ${Y.path}. Deleting the existing extension and extracting it.`,(0,k.$_)(M))}try{await this.D(J.id,Y,"removeExisting")}catch{throw new t.$rp(c.localize(1827,null,Y.fsPath,J.id),t.ExtensionManagementErrorCode.Delete)}}try{if(Q.isCancellationRequested)throw new k.$7;try{this.z.trace(`Started extracting the extension from ${K} to ${Y.fsPath}`),await(0,m.$Jq)(K,Z.fsPath,{sourcePath:"extension",overwrite:!0},Q),this.z.info(`Extracted extension to ${Y}:`,J.id)}catch(M){throw(0,C.$Yq)(M)}try{await this.t.updateMetadata(Z,q)}catch(M){throw this.y.publicLog2("extension:extract",{extensionId:J.id,code:`${(0,j.$ul)(M)}`}),(0,n.$Mq)(M,t.ExtensionManagementErrorCode.UpdateMetadata)}if(Q.isCancellationRequested)throw new k.$7;try{this.z.trace(`Started renaming the extension from ${Z.fsPath} to ${Y.fsPath}`),await this.G(Z.fsPath,Y.fsPath),this.z.info("Renamed to",Y.fsPath)}catch(M){if(M.code==="ENOTEMPTY"){this.z.info("Rename failed because extension was installed by another source. So ignoring renaming.",J.id);try{await this.s.del(Z,{recursive:!0})}catch{}}else throw this.z.info(`Rename failed because of ${(0,k.$_)(M)}. Deleted from extracted location`,Z),M}this.h.fire(Y)}catch(M){try{await this.s.del(Z,{recursive:!0})}catch{}throw M}return this.scanLocalExtension(Y,L.ExtensionType.User)}async scanMetadata(J,K){return K?(await this.C(J,K))?.metadata:this.t.scanMetadata(J.location)}async C(J,K){return(await this.u.scanProfileExtensions(K)).find(D=>(0,s.$Qp)(D.identifier,J.identifier))}async updateMetadata(J,K,q){try{q?await this.u.updateMetadata([[J,K]],q):await this.t.updateMetadata(J.location,K)}catch(D){throw this.y.publicLog2("extension:extract",{extensionId:J.identifier.id,code:`${(0,j.$ul)(D)}`,isProfile:!!q}),(0,n.$Mq)(D,t.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(J.location,J.type,q)}async getUninstalledExtensions(){try{return await this.F()}catch(J){throw(0,n.$Mq)(J,t.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...J){const K=J.map(q=>s.$Rp.create(q));await this.F(q=>K.forEach(D=>{q[D.toString()]=!0,this.z.info("Marked extension as uninstalled",D.toString())}))}async setInstalled(J){try{await this.F(K=>delete K[J.toString()])}catch(K){throw(0,n.$Mq)(K,t.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(J,K){if(this.w.extUri.isEqualOrParent(J.location,this.t.userExtensionsLocation))return this.D(J.identifier.id,J.location,K)}async removeUninstalledExtension(J){await this.removeExtension(J,"uninstalled"),await this.F(K=>delete K[s.$Rp.create(J).toString()])}async copyExtension(J,K,q,D){const Q=await this.C(J,K),oe=await this.C(J,q);if(D={...Q?.metadata,...D},oe)if(this.w.extUri.isEqual(oe.location,J.location))await this.u.updateMetadata([[J,{...oe.metadata,...D}]],q);else{const Z=await this.scanLocalExtension(oe.location,J.type,q);await this.u.removeExtensionFromProfile(Z,q),await this.u.addExtensionsToProfile([[J,{...oe.metadata,...D}]],q)}else await this.u.addExtensionsToProfile([[J,D]],q);return this.scanLocalExtension(J.location,J.type,q)}async copyExtensions(J,K,q){const D=await this.scanExtensions(L.ExtensionType.User,J,q),Q=await Promise.all(D.filter(oe=>!oe.isApplicationScoped).map(async oe=>[oe,await this.scanMetadata(oe,J)]));await this.u.addExtensionsToProfile(Q,K)}async D(J,K,q){this.z.trace(`Deleting ${q} extension from disk`,J,K.fsPath);const D=this.w.extUri.joinPath(this.w.extUri.dirname(K),`${this.w.extUri.basename(K)}.${(0,y.$wj)((0,f.$5g)()).toString(16)}${B}`);await this.G(K.fsPath,D.fsPath),await this.s.del(D,{recursive:!0}),this.z.info(`Deleted ${q} extension from disk`,J,K.fsPath)}F(J){return this.g.queue(async()=>{let K;try{K=(await this.s.readFile(this.c,"utf8")).value.toString()}catch(D){if((0,j.$ul)(D)!==j.FileOperationResult.FILE_NOT_FOUND)throw D}let q={};if(K)try{q=JSON.parse(K)}catch{}return J&&(J(q),Object.keys(q).length?await this.s.writeFile(this.c,N.$Qe.fromString(JSON.stringify(q))):await this.s.del(this.c)),q})}async G(J,K){try{await P.Promises.rename(J,K,2*60*1e3)}catch(q){throw(0,n.$Mq)(q,t.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(J,K,q){try{if(q){const Q=(await this.t.scanUserExtensions({profileLocation:q})).find(oe=>this.w.extUri.isEqual(oe.location,J));if(Q)return await this.H(Q)}else{const D=await this.t.scanExistingExtension(J,K,{includeInvalid:!0});if(D)return await this.H(D)}throw new t.$rp(c.localize(1828,null,J.path),t.ExtensionManagementErrorCode.ScanningExtension)}catch(D){throw(0,n.$Mq)(D,t.ExtensionManagementErrorCode.ScanningExtension)}}async H(J){const K=await this.s.resolve(J.location);let q,D;return K.children&&(q=K.children.find(({name:Q})=>/^readme(\.txt|\.md|)$/i.test(Q))?.resource,D=K.children.find(({name:Q})=>/^changelog(\.txt|\.md|)$/i.test(Q))?.resource),{identifier:J.identifier,type:J.type,isBuiltin:J.isBuiltin||!!J.metadata?.isBuiltin,location:J.location,manifest:J.manifest,targetPlatform:J.targetPlatform,validations:J.validations,isValid:J.isValid,readmeUrl:q,changelogUrl:D,publisherDisplayName:J.metadata?.publisherDisplayName,publisherId:J.metadata?.publisherId||null,isApplicationScoped:!!J.metadata?.isApplicationScoped,isMachineScoped:!!J.metadata?.isMachineScoped,isPreReleaseVersion:!!J.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!J.metadata?.hasPreReleaseVersion,preRelease:!!J.metadata?.preRelease,installedTimestamp:J.metadata?.installedTimestamp,updated:!!J.metadata?.updated,pinned:!!J.metadata?.pinned,isWorkspaceScoped:!1,source:J.metadata?.source??(J.identifier.uuid?"gallery":"vsix")}}async I(){const J=await this.getUninstalledExtensions();if(Object.keys(J).length===0){this.z.debug("No uninstalled extensions found.");return}this.z.debug("Removing uninstalled extensions:",Object.keys(J));const K=await this.t.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),q=new Set;for(const Q of K)J[s.$Rp.create(Q).toString()]||q.add(Q.identifier.id.toLowerCase());try{const Q=(0,s.$Wp)(K,oe=>oe.identifier);await a.Promises.settled(Q.map(async oe=>{const Z=oe.sort((Y,M)=>d.rcompare(Y.manifest.version,M.manifest.version))[0];q.has(Z.identifier.id.toLowerCase())||await this.n(await this.H(Z))}))}catch(Q){this.z.error(Q)}const D=K.filter(Q=>Q.metadata&&J[s.$Rp.create(Q).toString()]);await Promise.allSettled(D.map(Q=>this.removeUninstalledExtension(Q)))}async J(){this.z.trace("ExtensionManagementService#removeTempDeleteFolders");let J;try{J=await this.s.resolve(this.t.userExtensionsLocation)}catch(K){(0,j.$ul)(K)!==j.FileOperationResult.FILE_NOT_FOUND&&this.z.error(K);return}if(J?.children)try{await Promise.allSettled(J.children.map(async K=>{if(!(!K.isDirectory||!K.name.endsWith(B))){this.z.trace("Deleting the temporarily deleted folder",K.resource.toString());try{await this.s.del(K.resource,{recursive:!0}),this.z.trace("Deleted the temporarily deleted folder",K.resource.toString())}catch(q){(0,j.$ul)(q)!==j.FileOperationResult.FILE_NOT_FOUND&&this.z.error(q)}}}))}catch{}}};e.$7q=_,e.$7q=_=Ee([X(1,j.$dl),X(2,o.$Tq),X(3,r.$Pq),X(4,H.$Nl),X(5,x.$cm),X(6,G.$dk)],_);let ne=class extends n.$Nq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(J,K,q,D,Q,oe,Z,Y,M,z,ie,ae){super(),this.l=J,this.manifest=K,this.source=q,this.options=D,this.m=Q,this.n=oe,this.o=Z,this.p=Y,this.q=M,this.s=z,this.t=ie,this.u=ae,this.j=t.InstallOperation.Install,this.identifier=this.l.identifier}async h(J){const q=(await this.n.scanExtensions(L.ExtensionType.User,this.options.profileLocation,this.options.productVersion)).find(Z=>(0,s.$Qp)(Z.identifier,this.identifier));q&&(this.j=t.InstallOperation.Update);const D={isApplicationScoped:this.options.isApplicationScoped||q?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||q?.isMachineScoped,isBuiltin:this.options.isBuiltin||q?.isBuiltin,isSystem:q?.type===L.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??q?.pinned,source:this.source instanceof w.URI?"vsix":"gallery"};let Q;if(this.source instanceof w.URI){if(q&&this.l.equals(new s.$Rp(q.identifier,q.manifest.version)))try{await this.n.removeExtension(q,"existing")}catch{throw new Error(c.localize(1829,null,this.manifest.displayName||this.manifest.name))}const Z=await this.w(this.l);if(Z)try{await this.n.removeExtension(Z,"existing")}catch{throw new Error(c.localize(1830,null,this.manifest.displayName||this.manifest.name))}}else{if(D.id=this.source.identifier.uuid,D.publisherId=this.source.publisherId,D.publisherDisplayName=this.source.publisherDisplayName,D.targetPlatform=this.source.properties.targetPlatform,D.updated=!!q,D.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,D.hasPreReleaseVersion=q?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,D.preRelease=(0,E.$ng)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||q?.preRelease,q&&q.type!==L.ExtensionType.System&&q.manifest.version===this.source.version)return this.n.updateMetadata(q,D,this.options.profileLocation);Q=await this.w(this.l)}if(J.isCancellationRequested)throw(0,n.$Mq)(new k.$7);if(!Q){const Z=await this.m(this.operation,J);Q=Z.local,this.k=Z.verificationStatus}if(this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(Z){throw(0,n.$Mq)(Z,t.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(J.isCancellationRequested)throw(0,n.$Mq)(new k.$7);try{await this.t.addExtensionsToProfile([[Q,D]],this.options.profileLocation,!Q.isValid)}catch(Z){throw(0,n.$Mq)(Z,t.ExtensionManagementErrorCode.AddToProfile)}const oe=await this.n.scanLocalExtension(Q.location,L.ExtensionType.User,this.options.profileLocation);if(!oe)throw new t.$rp("Cannot find the installed extension",t.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof w.URI&&this.x(Q,J),oe}async w(J){return(await this.n.getUninstalledExtensions())[J.toString()]?(this.u.trace("Removing the extension from uninstalled list:",J.id),await this.n.setInstalled(J),this.u.info("Removed the extension from uninstalled list:",J.id),(await this.n.scanAllUserExtensions(!0)).find(D=>s.$Rp.create(D).equals(J))):void 0}async x(J,K){try{let[q]=await this.p.getExtensions([{id:J.identifier.id,version:J.manifest.version}],K);if(q||([q]=await this.p.getExtensions([{id:J.identifier.id}],K)),q){const D={id:q.identifier.uuid,publisherDisplayName:q.publisherDisplayName,publisherId:q.publisherId,isPreReleaseVersion:q.properties.isPreReleaseVersion,hasPreReleaseVersion:J.hasPreReleaseVersion||q.properties.isPreReleaseVersion,preRelease:q.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(J,D,this.options.profileLocation)}}catch{}}};ne=Ee([X(6,H.$Nl),X(7,t.$pp),X(8,te.$Pl),X(9,o.$Tq),X(10,r.$Pq),X(11,G.$dk)],ne);class le extends n.$Nq{constructor(J,K,q){super(),this.extension=J,this.options=K,this.j=q}async h(J){await this.j.removeExtensionFromProfile(this.extension,this.options.profileLocation)}}}),define(fe[218],de([0,1,10,19,28,18,52,7,15,9]),function(ce,e,R,a,N,A,T,k,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3R=void 0;let I=class extends T.$Qq{constructor($,g,l,d,E,w){super(y.URI.file($.extensionsPath),g,l,d,E,w)}};e.$3R=I,e.$3R=I=Ee([X(0,O.$Qi),X(1,k.$dl),X(2,a.$Pl),X(3,N.$Nl),X(4,A.$cm),X(5,R.$dk)],I)}),define(fe[219],de([0,1,9,15,52,85,7,4,10,23,28,19]),function(ce,e,R,a,N,A,T,k,O,y,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wic=void 0;let $=class extends A.$Xq{constructor(l,d,E,w,f,P,m,c){super(R.URI.file(f.builtinExtensionsPath),R.URI.file(f.extensionsPath),f.userHome,l.defaultProfile,l,d,E,w,f,P,m,c)}};e.$wic=$,e.$wic=$=Ee([X(0,p.$Pl),X(1,N.$Pq),X(2,T.$dl),X(3,O.$dk),X(4,a.$Qi),X(5,y.$wk),X(6,I.$Nl),X(7,k.$Hi)],$)}),define(fe[16],de([0,1,6,3,2,102,12,71,4,19]),function(ce,e,R,a,N,A,T,k,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=e.$oq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$mq=e.$lq=e.$kq=void 0,e.$nq=g,e.$pq=d,e.$rq=w,e.$kq="__$__isNewStorageMarker",e.$lq="__$__targetStorageMarker",e.$mq=(0,O.$Ii)("storageService");var I;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(I||(e.WillSaveStateReason=I={}));var p;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(p||(e.StorageScope=p={}));var $;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})($||(e.StorageTarget=$={}));function g(f){const P=f.get(e.$lq);if(P)try{return JSON.parse(P)}catch{}return Object.create(null)}class l extends N.$Xc{static{this.a=60*1e3}constructor(P={flushInterval:l.a}){super(),this.m=P,this.b=this.B(new a.$re),this.c=this.B(new a.$re),this.onDidChangeTarget=this.c.event,this.f=this.B(new a.$oe),this.onWillSaveState=this.f.event,this.h=this.B(new R.$Uh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new N.$Yc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(P,m,c){return a.Event.filter(this.b.event,h=>h.scope===P&&(m===void 0||h.key===m),c)}n(){this.j.value=(0,R.$Yh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,N.$Sc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(P,m){const{key:c,external:h}=m;if(c===e.$lq){switch(P){case p.APPLICATION:this.H=void 0;break;case p.PROFILE:this.F=void 0;break;case p.WORKSPACE:this.C=void 0;break}this.c.fire({scope:P})}else this.b.fire({scope:P,key:c,target:this.J(P)[c],external:h})}w(P){this.f.fire({reason:P})}get(P,m,c){return this.P(m)?.get(P,c)}getBoolean(P,m,c){return this.P(m)?.getBoolean(P,c)}getNumber(P,m,c){return this.P(m)?.getNumber(P,c)}getObject(P,m,c){return this.P(m)?.getObject(P,c)}storeAll(P,m){this.y(()=>{for(const c of P)this.store(c.key,c.value,c.scope,c.target,m)})}store(P,m,c,h,i=!1){if((0,T.$qg)(m)){this.remove(P,c,i);return}this.y(()=>{this.z(P,c,h),this.P(c)?.set(P,m,i)})}remove(P,m,c=!1){this.y(()=>{this.z(P,m,void 0),this.P(m)?.delete(P,c)})}y(P){this.b.pause(),this.c.pause();try{P()}finally{this.b.resume(),this.c.resume()}}keys(P,m){const c=[],h=this.J(P);for(const i of Object.keys(h))h[i]===m&&c.push(i);return c}z(P,m,c,h=!1){const i=this.J(m);typeof c=="number"?i[P]!==c&&(i[P]=c,this.P(m)?.set(e.$lq,JSON.stringify(i),h)):typeof i[P]=="number"&&(delete i[P],this.P(m)?.set(e.$lq,JSON.stringify(i),h))}get D(){return this.C||(this.C=this.L(p.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(p.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(p.APPLICATION)),this.H}J(P){switch(P){case p.APPLICATION:return this.I;case p.PROFILE:return this.G;default:return this.D}}L(P){const m=this.P(P);return m?g(m):Object.create(null)}isNew(P){return this.getBoolean(e.$kq,P)===!0}async flush(P=I.NONE){this.f.fire({reason:P});const m=this.P(p.APPLICATION),c=this.P(p.PROFILE),h=this.P(p.WORKSPACE);switch(P){case I.NONE:await R.Promises.settled([m?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),h?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await R.Promises.settled([m?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),h?.flush(0)??Promise.resolve()]);break}}async log(){const P=this.P(p.APPLICATION)?.items??new Map,m=this.P(p.PROFILE)?.items??new Map,c=this.P(p.WORKSPACE)?.items??new Map;return w(P,m,c,this.Q(p.APPLICATION)??"",this.Q(p.PROFILE)??"",this.Q(p.WORKSPACE)??"")}async optimize(P){return await this.flush(),this.P(P)?.optimize()}async switch(P,m){return this.w(I.NONE),(0,y.$Ol)(P)?this.R(P,m):this.S(P,m)}M(P,m){return!(P.id===m.id||d(m)&&d(P))}N(P,m,c){this.y(()=>{const h=new Set;for(const[i,n]of P)h.add(i),m.get(i)!==n&&this.u(c,{key:i,external:!0});for(const[i]of m.items)h.has(i)||this.u(c,{key:i,external:!0})})}}e.$oq=l;function d(f){return f.isDefault||!!f.useDefaultFlags?.globalState}class E extends l{constructor(){super(),this.U=this.B(new k.$iq(new k.$jq,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new k.$iq(new k.$jq,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new k.$iq(new k.$jq,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(P=>this.u(p.WORKSPACE,P))),this.B(this.W.onDidChangeStorage(P=>this.u(p.PROFILE,P))),this.B(this.U.onDidChangeStorage(P=>this.u(p.APPLICATION,P)))}P(P){switch(P){case p.APPLICATION:return this.U;case p.PROFILE:return this.W;default:return this.X}}Q(P){switch(P){case p.APPLICATION:return"inMemory (application)";case p.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(P){return!1}}e.$qq=E;async function w(f,P,m,c,h,i){const n=v=>{try{return JSON.parse(v)}catch{return v}},t=new Map,s=new Map;f.forEach((v,L)=>{t.set(L,v),s.set(L,n(v))});const r=new Map,o=new Map;P.forEach((v,L)=>{r.set(L,v),o.set(L,n(v))});const u=new Map,b=new Map;m.forEach((v,L)=>{u.set(L,v),b.set(L,n(v))}),console.group(c!==h?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const C=[];if(t.forEach((v,L)=>{C.push({key:L,value:v})}),console.table(C),console.groupEnd(),console.log(s),c!==h){console.group(`Storage: Profile (path: ${h}, profile specific)`);const v=[];r.forEach((L,U)=>{v.push({key:U,value:L})}),console.table(v),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${i})`);const S=[];u.forEach((v,L)=>{S.push({key:L,value:v})}),console.table(S),console.groupEnd(),console.log(b)}}),define(fe[120],de([0,1,3,2,12,27,35,16]),function(ce,e,R,a,N,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8Mb=e.$7Mb=void 0;let O=class extends a.$Xc{constructor(p,$){super(),this.a=new R.$oe,this.onDidChangeEnablement=this.a.event,this.b=this.B(new y(p)),this.B(this.b.onDidChange(g=>this.a.fire({extensions:g,source:"storage"}))),this.B($.onDidInstallExtensions(g=>g.forEach(({local:l,operation:d})=>{l&&d===A.InstallOperation.Migrate&&this.f(l.identifier)})))}async enableExtension(p,$){return this.f(p)?(this.a.fire({extensions:[p],source:$}),!0):!1}async disableExtension(p,$){return this.c(p)?(this.a.fire({extensions:[p],source:$}),!0):!1}getDisabledExtensions(){return this.h(A.$tp)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(p){const $=this.getDisabledExtensions();return $.every(g=>!(0,T.$Qp)(g,p))?($.push(p),this.g($),!0):!1}f(p){const $=this.getDisabledExtensions();for(let g=0;g<$.length;g++){const l=$[g];if((0,T.$Qp)(l,p))return $.splice(g,1),this.g($),!0}return!1}g(p){this.j(A.$tp,p)}h(p){return this.b.get(p,k.StorageScope.PROFILE)}j(p,$){this.b.set(p,$,k.StorageScope.PROFILE)}};e.$7Mb=O,e.$7Mb=O=Ee([X(0,k.$mq),X(1,A.$sp)],O);class y extends a.$Xc{constructor(p){super(),this.c=p,this.a=Object.create(null),this.b=this.B(new R.$oe),this.onDidChange=this.b.event,this.B(p.onDidChangeValue(k.StorageScope.PROFILE,void 0,this.B(new a.$Wc))($=>this.f($)))}get(p,$){let g;return $===k.StorageScope.PROFILE?((0,N.$qg)(this.a[p])&&(this.a[p]=this.g(p,$)),g=this.a[p]):g=this.g(p,$),JSON.parse(g)}set(p,$,g){const l=JSON.stringify($.map(({id:E,uuid:w})=>({id:E,uuid:w})));this.g(p,g)!==l&&(g===k.StorageScope.PROFILE&&($.length?this.a[p]=l:delete this.a[p]),this.h(p,$.length?l:void 0,g))}f(p){if(!(0,N.$qg)(this.a[p.key])&&this.g(p.key,p.scope)!==this.a[p.key]){const g=this.get(p.key,p.scope);delete this.a[p.key];const l=this.get(p.key,p.scope),d=g.filter(w=>!l.some(f=>(0,T.$Qp)(w,f))),E=l.filter(w=>!g.some(f=>(0,T.$Qp)(f,w)));(d.length||E.length)&&this.b.fire([...d,...E])}}g(p,$){return this.c.get(p,$,"[]")}h(p,$,g){$?this.c.store(p,$,g,k.StorageTarget.MACHINE):this.c.remove(p,g)}}e.$8Mb=y}),define(fe[86],de([0,1,4,3,2,16,35,23,17,10,12]),function(ce,e,R,a,N,A,T,k,O,y,I){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$yw=e.$xw=void 0,e.$xw=(0,R.$Ii)("IExtensionStorageService");const $=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let g=class extends N.$Xc{static{p=this}static{this.a=512*1024}static b(d){return`extensionKeys/${(0,T.$Up)(d.id)}@${d.version}`}static c(d){const E=$.exec(d);if(E&&E[1])return{id:E[1],version:E[2]}}static async removeOutdatedExtensionVersions(d,E){const w=await d.getInstalled(),f=[];for(const[P,m]of p.f(E)){const c=w.find(h=>(0,T.$Qp)(h.identifier,{id:P}))?.manifest.version;for(const h of m)c!==h&&f.push(p.b({id:P,version:h}))}for(const P of f)E.remove(P,A.StorageScope.PROFILE)}static f(d){const E=new Map,w=d.keys(A.StorageScope.PROFILE,A.StorageTarget.MACHINE);for(const f of w){const P=p.c(f);if(P){let m=E.get(P.id.toLowerCase());m||E.set(P.id.toLowerCase(),m=[]),m.push(P.version)}}return E}constructor(d,E,w){super(),this.j=d,this.m=E,this.n=w,this.g=this.B(new a.$oe),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=p.f(d),this.B(this.j.onDidChangeValue(A.StorageScope.PROFILE,void 0,this.B(new N.$Wc))(f=>this.r(f)))}r(d){if(this.h.has(d.key.toLowerCase())){this.g.fire();return}const E=p.c(d.key);if(E){if(this.j.get(d.key,A.StorageScope.PROFILE)===void 0)this.h.delete(E.id.toLowerCase());else{let w=this.h.get(E.id.toLowerCase());w||this.h.set(E.id.toLowerCase(),w=[]),w.push(E.version),this.g.fire()}return}}s(d){if((0,I.$hg)(d))return d;const E=d.manifest?d.manifest.publisher:d.publisher,w=d.manifest?d.manifest.name:d.name;return(0,T.$Tp)(E,w)}getExtensionState(d,E){const w=this.s(d),f=this.getExtensionStateRaw(d,E);if(f)try{return JSON.parse(f)}catch(P){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${w}, global: ${E}): ${P}`)}}getExtensionStateRaw(d,E){const w=this.s(d),f=this.j.get(w,E?A.StorageScope.PROFILE:A.StorageScope.WORKSPACE);return f&&f?.length>p.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${w}, global: ${E}): ${f.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),f}setExtensionState(d,E,w){const f=this.s(d);E===void 0?this.j.remove(f,w?A.StorageScope.PROFILE:A.StorageScope.WORKSPACE):this.j.store(f,JSON.stringify(E),w?A.StorageScope.PROFILE:A.StorageScope.WORKSPACE,A.StorageTarget.MACHINE)}setKeysForSync(d,E){this.j.store(p.b(d),JSON.stringify(E),A.StorageScope.PROFILE,A.StorageTarget.MACHINE)}getKeysForSync(d){const E=this.m.extensionSyncedKeys?.[d.id.toLowerCase()],w=this.j.get(p.b(d),A.StorageScope.PROFILE),f=w?JSON.parse(w):void 0;return f&&E?(0,O.$Ob)([...f,...E]):f||E}addToMigrationList(d,E){if(d!==E){const w=this.t.filter(f=>!f.includes(d)&&!f.includes(E));w.push([d,E]),this.t=w}}getSourceExtensionToMigrate(d){const E=this.t.find(([,w])=>d===w);return E?E[0]:void 0}get t(){const d=this.j.get("extensionStorage.migrationList",A.StorageScope.APPLICATION,"[]");try{const E=JSON.parse(d);if(Array.isArray(E))return E}catch{}return[]}set t(d){d.length?this.j.store("extensionStorage.migrationList",JSON.stringify(d),A.StorageScope.APPLICATION,A.StorageTarget.MACHINE):this.j.remove("extensionStorage.migrationList",A.StorageScope.APPLICATION)}};e.$yw=g,e.$yw=g=p=Ee([X(0,A.$mq),X(1,k.$wk),X(2,y.$dk)],g)}),define(fe[220],de([0,1,2,27,86,198,119,10,16]),function(ce,e,R,a,N,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gjc=void 0;let y=class extends R.$Xc{constructor(p,$,g,l,d,E){super(),p.cleanUp(),(0,A.$K8b)(p,$,g,l,E),N.$yw.removeOutdatedExtensionVersions(p,d)}};e.$Gjc=y,e.$Gjc=y=Ee([X(0,T.$5q),X(1,a.$pp),X(2,N.$xw),X(3,a.$vp),X(4,O.$mq),X(5,k.$dk)],y)}),define(fe[221],de([0,1,17,2,20,9,7,23,6,3,13,5,37,35,75,34,16]),function(ce,e,R,a,N,A,T,k,O,y,I,p,$,g,l,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yfc=e.$Xfc=void 0;let w=class extends a.$Xc{constructor(h,i){super(),this.b=h,this.c=i,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,n])=>this.a.set(n.configPath,n))}getConfigBasedTips(h){return this.f(h)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(h){const i=[];for(const[n,t]of this.a)if(!(t.configScheme&&t.configScheme!==h.scheme))try{const s=(await this.b.readFile((0,N.$jh)(h,n))).value.toString();for(const[r,o]of Object.entries(t.recommendations))(!o.contentPattern||new RegExp(o.contentPattern,"mig").test(s))&&i.push({extensionId:r,extensionName:o.name,configName:t.configName,important:!!o.important,isExtensionPack:!!o.isExtensionPack,whenNotInstalled:o.whenNotInstalled})}catch{}return i}};e.$Xfc=w,e.$Xfc=w=Ee([X(0,T.$dl),X(1,k.$wk)],w);const f="extensionTips/promptedExecutableTips",P="extensionTips/lastPromptedMediumImpExeTime";class m extends w{constructor(h,i,n,t,s,r,o,u){super(o,u),this.r=h,this.s=i,this.t=n,this.u=t,this.w=s,this.z=r,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,u.exeBasedExtensionTips&&Object.entries(u.exeBasedExtensionTips).forEach(([b,C])=>{const S=[],v=[],L=[];Object.entries(C.recommendations).forEach(([U,j])=>{j.important?C.important?S.push({extensionId:U,extensionName:j.name,isExtensionPack:!!j.isExtensionPack}):v.push({extensionId:U,extensionName:j.name,isExtensionPack:!!j.isExtensionPack}):L.push({extensionId:U,extensionName:j.name,isExtensionPack:!!j.isExtensionPack})}),S.length&&this.g.set(b,{exeFriendlyName:C.friendlyName,windowsPath:C.windowsPath,recommendations:S}),v.length&&this.h.set(b,{exeFriendlyName:C.friendlyName,windowsPath:C.windowsPath,recommendations:v}),L.length&&this.j.set(b,{exeFriendlyName:C.friendlyName,windowsPath:C.windowsPath,recommendations:L})}),(0,O.$Kh)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const h=await this.O(this.g),i=await this.O(this.h);return[...h,...i]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const h=await this.O(this.g),i=await this.O(this.h),n=await this.u.getInstalled();this.m=this.D(h,n),this.n=this.D(i,n)}D(h,i){const n=new Map;h.forEach(u=>n.set(u.extensionId.toLowerCase(),u));const{installed:t,uninstalled:s}=this.N([...n.keys()],i);for(const u of t){const b=n.get(u);b&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:u,exeName:b.exeName})}for(const u of s){const b=n.get(u);b&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:u,exeName:b.exeName})}const r=this.L(),o=new Map;for(const u of s){const b=n.get(u);if(b&&(!r[b.exeName]||!r[b.exeName].includes(b.extensionId))){let C=o.get(b.exeName);C||(C=[],o.set(b.exeName,C)),C.push(b)}}return o}F(){if(this.m.size===0)return;const[h,i]=[...this.m.entries()][0];this.H(i).then(n=>{switch(n){case l.RecommendationsNotificationResult.Accepted:this.M(i[0].exeName,i);break;case l.RecommendationsNotificationResult.Ignored:this.m.delete(h);break;case l.RecommendationsNotificationResult.IncompatibleWindow:{const t=y.Event.once(y.Event.latch(y.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(t(()=>this.F()));break}case l.RecommendationsNotificationResult.TooMany:{const t=this.B(new a.$Yc);t.value=(0,O.$Kh)(()=>{t.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const h=this.I(),i=Date.now()-h,n=7*24*60*60*1e3;if(i<n){const r=this.B(new a.$Yc);r.value=(0,O.$Kh)(()=>{r.dispose(),this.G()},n-i);return}const[t,s]=[...this.n.entries()][0];this.H(s).then(r=>{switch(r){case l.RecommendationsNotificationResult.Accepted:{this.J(Date.now()),this.n.delete(t),this.M(s[0].exeName,s);const o=this.B(new a.$Yc);o.value=(0,O.$Kh)(()=>{o.dispose(),this.G()},n);break}case l.RecommendationsNotificationResult.Ignored:this.n.delete(t),this.G();break;case l.RecommendationsNotificationResult.IncompatibleWindow:{const o=y.Event.once(y.Event.latch(y.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(o(()=>this.G()));break}case l.RecommendationsNotificationResult.TooMany:{const o=this.B(new a.$Yc);o.value=(0,O.$Kh)(()=>{o.dispose(),this.G()},60*60*1e3);break}}})}async H(h){const i=await this.u.getInstalled(d.ExtensionType.User),n=h.filter(t=>!t.whenNotInstalled||t.whenNotInstalled.every(s=>i.every(r=>!(0,g.$Qp)(r.identifier,{id:s})))).map(({extensionId:t})=>t.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:n,source:l.RecommendationSource.EXE,name:h[0].exeFriendlyName,searchValue:`@exe:"${h[0].exeName}"`})}I(){let h=this.w.getNumber(P,E.StorageScope.APPLICATION);return h||(h=Date.now(),this.J(h)),h}J(h){this.w.store(P,h,E.StorageScope.APPLICATION,E.StorageTarget.MACHINE)}L(){return JSON.parse(this.w.get(f,E.StorageScope.APPLICATION,"{}"))}M(h,i){const n=this.L();n[h]=i.map(({extensionId:t})=>t.toLowerCase()),this.w.store(f,JSON.stringify(n),E.StorageScope.APPLICATION,E.StorageTarget.USER)}N(h,i){const n=[],t=[],s=i.reduce((r,o)=>(r.add(o.identifier.id.toLowerCase()),r),new Set);return h.forEach(r=>{s.has(r.toLowerCase())?n.push(r):t.push(r)}),{installed:n,uninstalled:t}}async O(h){const i=[],n=new Map;for(const t of h.keys()){const s=h.get(t);if(!s||!(0,R.$Nb)(s.recommendations))continue;const r=[];p.$j?s.windowsPath&&r.push(s.windowsPath.replace("%USERPROFILE%",()=>$.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>$.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>$.env.ProgramFiles).replace("%APPDATA%",()=>$.env.APPDATA).replace("%WINDIR%",()=>$.env.WINDIR)):(r.push((0,I.$mc)("/usr/local/bin",t)),r.push((0,I.$mc)("/usr/bin",t)),r.push((0,I.$mc)(this.r.fsPath,t)));for(const o of r){let u=n.get(o);if(u===void 0&&(u=await this.b.exists(A.URI.file(o)),n.set(o,u)),u)for(const{extensionId:b,extensionName:C,isExtensionPack:S,whenNotInstalled:v}of s.recommendations)i.push({extensionId:b,extensionName:C,isExtensionPack:S,exeName:t,exeFriendlyName:s.exeFriendlyName,windowsPath:s.windowsPath,whenNotInstalled:v})}}return i}}e.$Yfc=m}),define(fe[222],de([0,1,27,7,23,15,75,57,16,18,221]),function(ce,e,R,a,N,A,T,k,O,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Njc=void 0;let p=class extends I.$Yfc{constructor(g,l,d,E,w,f,P,m){super(g.userHome,w,l,d,E,f,P,m)}};e.$Njc=p,e.$Njc=p=Ee([X(0,A.$Qi),X(1,y.$cm),X(2,R.$sp),X(3,O.$mq),X(4,k.$Ihc),X(5,T.$s8b),X(6,a.$dl),X(7,N.$wk)],p)}),define(fe[49],de([0,1,14,32,16]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=A;async function A(T,k,O){let y=O&&O.get("storage.serviceMachineId",N.StorageScope.APPLICATION)||null;if(y)return y;try{const p=(await k.readFile(T.serviceMachineIdResource)).value.toString();y=(0,a.$4g)(p)?p:null}catch{y=null}if(!y){y=(0,a.$5g)();try{await k.writeFile(T.serviceMachineIdResource,R.$Qe.fromString(y))}catch{}}return O?.store("storage.serviceMachineId",y,N.StorageScope.APPLICATION,N.StorageTarget.MACHINE),y}}),define(fe[223],de([0,1,49,18,48]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=A;async function A(T,k,O,y,I,p,$){const g={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T} (${k.nameShort})`};if((0,N.$Ip)(k,O)&&(0,N.$Kp)(y)===a.TelemetryLevel.USAGE){const l=await(0,R.$sq)(O,I,p);g["X-Market-User-Id"]=l,g["VSCode-SessionId"]=$.machineId||l}return g}}),define(fe[224],de([0,1,17,25,8,5,37,12,9,150,21,15,27,35,34,59,7,10,23,61,223,16,18,54]),function(ce,e,R,a,N,A,T,k,O,y,I,p,$,g,l,d,E,w,f,P,m,c,h,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=e.$vq=void 0,e.$uq=K;const n=A.$p?l.TargetPlatform.WEB:(0,$.$lp)(A.$v,T.$hc),t="X-Market-Search-Activity-Id";var s;(function(Y){Y[Y.None=0]="None",Y[Y.IncludeVersions=1]="IncludeVersions",Y[Y.IncludeFiles=2]="IncludeFiles",Y[Y.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",Y[Y.IncludeSharedAccounts=8]="IncludeSharedAccounts",Y[Y.IncludeVersionProperties=16]="IncludeVersionProperties",Y[Y.ExcludeNonValidated=32]="ExcludeNonValidated",Y[Y.IncludeInstallationTargets=64]="IncludeInstallationTargets",Y[Y.IncludeAssetUri=128]="IncludeAssetUri",Y[Y.IncludeStatistics=256]="IncludeStatistics",Y[Y.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",Y[Y.Unpublished=4096]="Unpublished",Y[Y.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function r(...Y){return String(Y.reduce((M,z)=>M|z,0))}var o;(function(Y){Y[Y.Tag=1]="Tag",Y[Y.ExtensionId=4]="ExtensionId",Y[Y.Category=5]="Category",Y[Y.ExtensionName=7]="ExtensionName",Y[Y.Target=8]="Target",Y[Y.Featured=9]="Featured",Y[Y.SearchText=10]="SearchText",Y[Y.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const u={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},b={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",EnabledApiProposals:"Microsoft.VisualStudio.Code.EnabledApiProposals",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support",ExecutesCode:"Microsoft.VisualStudio.Code.ExecutesCode"},S={pageNumber:1,pageSize:10,sortBy:$.SortBy.NoneOrRelevance,sortOrder:$.SortOrder.Default,flags:s.None,criteria:[],assetTypes:[]};class v{constructor(M=S){this.d=M}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(M,z=this.d.pageSize){return new v({...this.d,pageNumber:M,pageSize:z})}withFilter(M,...z){const ie=[...this.d.criteria,...z.length?z.map(ae=>({filterType:M,value:ae})):[{filterType:M}]];return new v({...this.d,criteria:ie})}withSortBy(M){return new v({...this.d,sortBy:M})}withSortOrder(M){return new v({...this.d,sortOrder:M})}withFlags(...M){return new v({...this.d,flags:M.reduce((z,ie)=>z|ie,0)})}withAssetTypes(...M){return new v({...this.d,assetTypes:M})}withSource(M){return new v({...this.d,source:M})}get raw(){const{criteria:M,pageNumber:z,pageSize:ie,sortBy:ae,sortOrder:ue,flags:pe,assetTypes:be}=this.d;return{filters:[{criteria:M,pageNumber:z,pageSize:ie,sortBy:ae,sortOrder:ue}],assetTypes:be,flags:pe}}get searchText(){const M=this.d.criteria.filter(z=>z.filterType===o.SearchText)[0];return M&&M.value?M.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(M=>String(M.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function L(Y,M){const z=(Y||[]).filter(ie=>ie.statisticName===M)[0];return z?z.value:0}function U(Y){const M="Microsoft.VisualStudio.Code.Translation.";return Y.files.filter(ie=>ie.assetType.indexOf(M)===0).reduce((ie,ae)=>{const ue=G(Y,ae.assetType);return ue&&ie.push([ae.assetType.substring(M.length),ue]),ie},[])}function j(Y){if(Y.properties){const M=Y.properties.filter(ae=>ae.key===u.Repository),z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ie=M.filter(ae=>z.test(ae.value))[0];return ie?{uri:ie.value,fallbackUri:ie.value}:null}return G(Y,u.Repository)}function F(Y){return{uri:`${Y.fallbackAssetUri}/${u.VSIX}?redirect=true${Y.targetPlatform?`&targetPlatform=${Y.targetPlatform}`:""}`,fallbackUri:`${Y.fallbackAssetUri}/${u.VSIX}${Y.targetPlatform?`?targetPlatform=${Y.targetPlatform}`:""}`}}function G(Y,M){return Y.files.filter(ie=>ie.assetType===M)[0]?{uri:`${Y.assetUri}/${M}${Y.targetPlatform?`?targetPlatform=${Y.targetPlatform}`:""}`,fallbackUri:`${Y.fallbackAssetUri}/${M}${Y.targetPlatform?`?targetPlatform=${Y.targetPlatform}`:""}`}:null}function V(Y,M){const z=Y.properties?Y.properties.filter(ae=>ae.key===M):[],ie=z.length>0&&z[0].value;return ie?ie.split(",").map(ae=>(0,g.$Up)(ae)):[]}function x(Y){const M=Y.properties?Y.properties.filter(z=>z.key===b.Engine):[];return M.length>0&&M[0].value||""}function H(Y){const M=Y.properties?Y.properties.filter(z=>z.key===b.PreRelease):[];return M.length>0&&M[0].value==="true"}function te(Y){const M=Y.properties?Y.properties.filter(z=>z.key===b.ExecutesCode):[];return M.length>0?M[0].value==="true":void 0}function B(Y){const M=Y.properties?Y.properties.filter(ie=>ie.key===b.EnabledApiProposals):[],z=M.length>0&&M[0].value||"";return z?z.split(","):[]}function W(Y){const M=Y.properties?Y.properties.filter(ie=>ie.key===b.LocalizedLanguages):[],z=M.length>0&&M[0].value||"";return z?z.split(","):[]}function _(Y){return Y.properties?.find(M=>M.key===b.SponsorLink)?.value}function ne(Y){return Y.properties?.find(M=>M.key===b.SupportLink)?.value}function le(Y){return Y.indexOf("preview")!==-1}function ee(Y){return Y.targetPlatform?(0,$.$kp)(Y.targetPlatform):l.TargetPlatform.UNDEFINED}function J(Y){const M=(0,R.$Ob)(Y.versions.map(ee)),z=!!Y.tags?.includes($.$ep),ie=M.indexOf(l.TargetPlatform.WEB);return z?ie===-1&&M.push(l.TargetPlatform.WEB):ie!==-1&&M.splice(ie,1),M}function K(Y,M){for(let z=0;z<Y.length;z++){const ie=Y[z];if(ie.version===Y[z-1]?.version){let ae=z;if(ee(ie)===M)for(;ae>0&&Y[ae-1].version===ie.version;)ae--;ae!==z&&(Y.splice(z,1),Y.splice(ae,0,ie))}}return Y}function q(Y,M,z){Y.telemetryData={index:M,querySource:z,queryActivityId:Y.queryContext?.[t]}}function D(Y,M,z,ie){const ae=Y.versions[0],ue={manifest:G(M,u.Manifest),readme:G(M,u.Details),changelog:G(M,u.Changelog),license:G(M,u.License),repository:j(M),download:F(M),icon:G(M,u.Icon),signature:G(M,u.Signature),coreTranslations:U(M)};return{type:"gallery",identifier:{id:(0,g.$Vp)(Y.publisher.publisherName,Y.extensionName),uuid:Y.extensionId},name:Y.extensionName,version:M.version,displayName:Y.displayName,publisherId:Y.publisher.publisherId,publisher:Y.publisher.publisherName,publisherDisplayName:Y.publisher.displayName,publisherDomain:Y.publisher.domain?{link:Y.publisher.domain,verified:!!Y.publisher.isDomainVerified}:void 0,publisherSponsorLink:_(ae),description:Y.shortDescription??"",installCount:L(Y.statistics,"install"),rating:L(Y.statistics,"averagerating"),ratingCount:L(Y.statistics,"ratingcount"),categories:Y.categories||[],tags:Y.tags||[],releaseDate:Date.parse(Y.releaseDate),lastUpdated:Date.parse(Y.lastUpdated),allTargetPlatforms:z,assets:ue,properties:{dependencies:V(M,b.Dependency),extensionPack:V(M,b.ExtensionPack),engine:x(M),enabledApiProposals:B(M),localizedLanguages:W(M),targetPlatform:ee(M),isPreReleaseVersion:H(M),executesCode:te(M)},hasPreReleaseVersion:H(ae),hasReleaseVersion:!0,preview:le(Y.flags),isSigned:!!ue.signature,queryContext:ie,supportLink:ne(ae)}}let Q=class{constructor(M,z,ie,ae,ue,pe,be,Re){this.l=z,this.n=ie,this.o=ae,this.q=ue,this.u=pe,this.w=be,this.x=Re;const Ae=be.extensionsGallery,ye=Ae?.servicePPEUrl&&Re.getValue("_extensionsGallery.enablePPE");this.d=ye?Ae.servicePPEUrl:Ae?.serviceUrl,this.g=ye?void 0:Ae?.searchUrl,this.h=Ae?.controlUrl,this.k=be.extensionsEnabledWithApiProposalVersion?.map(we=>we.toLowerCase())??[],this.j=(0,m.$tq)(be.version,be,this.o,this.x,this.u,M,this.q)}y(M=""){return`${this.d}${M}`}isEnabled(){return!!this.d}async getExtensions(M,z,ie){const ae=a.CancellationToken.isCancellationToken(z)?{}:z,ue=a.CancellationToken.isCancellationToken(z)?z:ie,pe=[],be=[],Re=[],Ae=[];let ye=!0;for(const he of M){he.uuid?be.push(he.uuid):pe.push(he.id);const me=!!(he.version||he.preRelease);Re.push({id:he.id,uuid:he.uuid,includePreRelease:me}),he.version&&Ae.push({id:he.id,uuid:he.uuid,version:he.version}),ye=ye&&!!he.hasPreRelease&&!me}if(!be.length&&!pe.length)return[];let we=new v().withPage(1,M.length);be.length&&(we=we.withFilter(o.ExtensionId,...be)),pe.length&&(we=we.withFilter(o.ExtensionName,...pe)),(ae.queryAllVersions||ye)&&(we=we.withFlags(we.flags,s.IncludeVersions)),ae.source&&(we=we.withSource(ae.source));const{extensions:re}=await this.B(we,{targetPlatform:ae.targetPlatform??n,includePreRelease:Re,versions:Ae,compatible:!!ae.compatible,productVersion:ae.productVersion??{version:this.w.version,date:this.w.date}},ue);return ae.source&&re.forEach((he,me)=>q(he,me,ae.source)),re}async getCompatibleExtension(M,z,ie,ae={version:this.w.version,date:this.w.date}){if((0,$.$mp)(M.allTargetPlatforms,ie))return null;if(await this.isExtensionCompatible(M,z,ie))return M;const ue=new v().withFlags(s.IncludeVersions).withPage(1,1).withFilter(o.ExtensionId,M.identifier.uuid),{extensions:pe}=await this.B(ue,{targetPlatform:ie,compatible:!0,includePreRelease:z,productVersion:ae},a.CancellationToken.None);return pe[0]||null}async isExtensionCompatible(M,z,ie,ae={version:this.w.version,date:this.w.date}){if(!(0,$.$np)(M.properties.targetPlatform,M.allTargetPlatforms,ie)||!z&&M.properties.isPreReleaseVersion)return!1;let ue=M.properties.engine;if(!ue){const pe=await this.getManifest(M,a.CancellationToken.None);if(!pe)throw new Error("Manifest was not found");ue=pe.engines.vscode}return!(!(0,d.$0p)(ue,ae.version,ae.date)||!this.z(M.identifier,M.properties.enabledApiProposals))}z(M,z){return!z||!this.k.includes(M.id.toLowerCase())?!0:(0,d.$$p)(z)}async A(M,z,ie,ae,ue,pe,be={version:this.w.version,date:this.w.date}){if(!(0,$.$np)(ee(z),ue,pe)||ie!=="any"&&H(z)!==(ie==="prerelease"))return!1;if(ae)try{const Re=await this.G(M,z);if(!(0,d.$0p)(Re,be.version,be.date))return!1}catch(Re){return this.n.error(`Error while getting the engine for the version ${z.version}.`,(0,N.$_)(Re)),!1}return!0}async query(M,z){let ie=M.text||"";const ae=M.pageSize??50;let ue=new v().withPage(1,ae);ie?(ie=ie.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ye,we,re)=>(ue=ue.withFilter(o.Category,re||we),"")),ie=ie.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ye,we,re)=>(ue=ue.withFilter(o.Tag,re||we),"")),ie=ie.replace(/\bfeatured(\s+|\b|$)/g,()=>(ue=ue.withFilter(o.Featured),"")),ie=ie.trim(),ie&&(ie=ie.length<200?ie:ie.substring(0,200),ue=ue.withFilter(o.SearchText,ie)),ue=ue.withSortBy($.SortBy.NoneOrRelevance)):M.ids?ue=ue.withFilter(o.ExtensionId,...M.ids):M.names?ue=ue.withFilter(o.ExtensionName,...M.names):ue=ue.withSortBy($.SortBy.InstallCount),typeof M.sortBy=="number"&&(ue=ue.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(ue=ue.withSortOrder(M.sortOrder)),M.source&&(ue=ue.withSource(M.source));const pe=async(ye,we)=>{const{extensions:re,total:he}=await this.B(ye,{targetPlatform:n,compatible:!1,includePreRelease:!!M.includePreRelease,productVersion:M.productVersion??{version:this.w.version,date:this.w.date}},we);return re.forEach((me,Se)=>q(me,(ye.pageNumber-1)*ye.pageSize+Se,M.source)),{extensions:re,total:he}},{extensions:be,total:Re}=await pe(ue,z),Ae=async(ye,we)=>{if(we.isCancellationRequested)throw new N.$7;const{extensions:re}=await pe(ue.withPage(ye+1),we);return re};return{firstPage:be,total:Re,pageSize:ue.pageSize,getPage:Ae}}async B(M,z,ie){const ae=M.flags;M.flags&s.IncludeLatestVersionOnly&&M.flags&s.IncludeVersions&&(M=M.withFlags(M.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(M.flags&s.IncludeLatestVersionOnly)&&!(M.flags&s.IncludeVersions)&&(M=M.withFlags(M.flags,s.IncludeLatestVersionOnly)),z.versions?.length&&(M=M.withFlags(M.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),M=M.withFlags(M.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:ue,total:pe,context:be}=await this.D(M,ie);if(!(M.flags&s.IncludeLatestVersionOnly)){const we=[];for(const re of ue){const he=await this.C(re,z,be);he&&we.push(he)}return{extensions:we,total:pe}}const Ae=[],ye=new Map;for(let we=0;we<ue.length;we++){const re=ue[we],he={id:(0,g.$Vp)(re.publisher.publisherName,re.extensionName),uuid:re.extensionId},me=(0,k.$ng)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(Pe=>(0,g.$Qp)(Pe,he))?.includePreRelease;if(z.compatible&&(0,$.$mp)(J(re),z.targetPlatform))continue;const Se=await this.C(re,z,be);!Se||Se.properties.isPreReleaseVersion&&(!me||!Se.hasReleaseVersion)||!Se.properties.isPreReleaseVersion&&Se.properties.targetPlatform!==z.targetPlatform&&Se.hasPreReleaseVersion?ye.set(re.extensionId,we):Ae.push([we,Se])}if(ye.size){const we=new i.$ie,re=new v().withFlags(ae&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,ye.size).withFilter(o.ExtensionId,...ye.keys()),{extensions:he}=await this.B(re,z,ie);this.q.publicLog2("galleryService:additionalQuery",{duration:we.elapsed(),count:ye.size});for(const me of he){const Se=ye.get(me.identifier.uuid);Ae.push([Se,me])}}return{extensions:Ae.sort((we,re)=>we[0]-re[0]).map(([,we])=>we),total:pe}}async C(M,z,ie){const ae={id:(0,g.$Vp)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},ue=z.versions?.find(Ae=>(0,g.$Qp)(Ae,ae))?.version,pe=(0,k.$ng)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(Ae=>(0,g.$Qp)(Ae,ae))?.includePreRelease,be=J(M),Re=K(M.versions,z.targetPlatform);if(z.compatible&&(0,$.$mp)(be,z.targetPlatform))return null;for(let Ae=0;Ae<Re.length;Ae++){const ye=Re[Ae];if(!(ue&&ye.version!==ue)){if(await this.A(ae.id,ye,pe?"any":"release",z.compatible,be,z.targetPlatform,z.productVersion))return z.compatible&&!this.z(ae,B(ye))?null:D(M,ye,be,ie);if(ue&&ye.version===ue)return null}}return ue||z.compatible?null:D(M,M.versions[0],be)}async D(M,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");M=M.withFlags(M.flags,s.ExcludeNonValidated).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExcludeWithFlags,r(s.Unpublished));const ie=await this.j,ae=JSON.stringify(M.raw),ue={...ie,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ae.length)},pe=new i.$ie;let be,Re,Ae=0;try{if(be=await this.l.request({type:"POST",url:this.g&&M.criteria.some(we=>we.filterType===o.SearchText)?this.g:this.y("/extensionquery"),data:ae,headers:ue},z),be.res.statusCode&&be.res.statusCode>=400&&be.res.statusCode<500)return{galleryExtensions:[],total:Ae};const ye=await(0,P.$fq)(be);if(ye){const we=ye.results[0],re=we.extensions,he=we.resultMetadata&&we.resultMetadata.filter(me=>me.metadataType==="ResultCount")[0];return Ae=he&&he.metadataItems.filter(me=>me.name==="TotalCount")[0].count||0,{galleryExtensions:re,total:Ae,context:be.res.headers.activityid?{[t]:be.res.headers.activityid}:{}}}return{galleryExtensions:[],total:Ae}}catch(ye){if((0,N.$6)(ye))throw Re=$.ExtensionGalleryErrorCode.Cancelled,ye;{const we=(0,N.$_)(ye);throw Re=(0,y.$ap)(ye)?$.ExtensionGalleryErrorCode.Offline:we.startsWith("XHR timeout")?$.ExtensionGalleryErrorCode.Timeout:$.ExtensionGalleryErrorCode.Failed,new $.$qp(we,Re)}}finally{this.q.publicLog2("galleryService:query",{...M.telemetryData,requestBodySize:String(ae.length),duration:pe.elapsed(),success:!!be&&(0,P.$bq)(be),responseBodySize:be?.res.headers["Content-Length"],statusCode:be?String(be.res.statusCode):void 0,errorCode:Re,count:String(Ae)})}}async reportStatistic(M,z,ie,ae){if(!this.isEnabled())return;const ue=A.$p?this.y(`/itemName/${M}.${z}/version/${ie}/statType/${ae===$.StatisticType.Install?"1":"3"}/vscodewebextension`):this.y(`/publishers/${M}/extensions/${z}/${ie}/stats?statType=${ae}`),pe=A.$p?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Re={...await this.j,Accept:pe};try{await this.l.request({type:"POST",url:ue,headers:Re},a.CancellationToken.None)}catch{}}async download(M,z,ie){this.n.trace("ExtensionGalleryService#download",M.identifier.id);const ae=(0,g.$Yp)(M),ue=new Date().getTime(),pe=ie===$.InstallOperation.Install?"install":ie===$.InstallOperation.Update?"update":"",be=pe?{uri:`${M.assets.download.uri}${O.URI.parse(M.assets.download.uri).query?"&":"?"}${pe}=true`,fallbackUri:`${M.assets.download.fallbackUri}${O.URI.parse(M.assets.download.fallbackUri).query?"&":"?"}${pe}=true`}:M.assets.download,Re=M.queryContext?.[t]?{[t]:M.queryContext[t]}:void 0,Ae=await this.F(M.identifier.id,be,u.VSIX,Re?{headers:Re}:void 0);try{await this.u.writeFile(z,Ae.stream)}catch(ye){try{await this.u.del(z)}catch(we){this.n.warn(`Error while deleting the file ${z.toString()}`,(0,N.$_)(we))}throw new $.$qp((0,N.$_)(ye),$.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.q.publicLog("galleryService:downloadVSIX",{...ae,duration:new Date().getTime()-ue})}async downloadSignatureArchive(M,z){if(!M.assets.signature)throw new Error("No signature asset found");this.n.trace("ExtensionGalleryService#downloadSignatureArchive",M.identifier.id);const ie=await this.F(M.identifier.id,M.assets.signature,u.Signature);try{await this.u.writeFile(z,ie.stream)}catch(ae){try{await this.u.del(z)}catch(ue){this.n.warn(`Error while deleting the file ${z.toString()}`,(0,N.$_)(ue))}throw new $.$qp((0,N.$_)(ae),$.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(M,z){if(M.assets.readme){const ie=await this.F(M.identifier.id,M.assets.readme,u.Details,{},z);return await(0,P.$eq)(ie)||""}return""}async getManifest(M,z){if(M.assets.manifest){const ie=await this.F(M.identifier.id,M.assets.manifest,u.Manifest,{},z),ae=await(0,P.$eq)(ie);return ae?JSON.parse(ae):null}return null}async E(M,z,ie){const ae=G(z,u.Manifest);if(!ae)throw new Error("Manifest was not found");const ue={"Accept-Encoding":"gzip"},pe=await this.F(M,ae,u.Manifest,{headers:ue});return await(0,P.$fq)(pe)}async getCoreTranslation(M,z){const ie=M.assets.coreTranslations.filter(ae=>ae[0]===z.toUpperCase())[0];if(ie){const ae=await this.F(M.identifier.id,ie[1],ie[0]),ue=await(0,P.$eq)(ae);return ue?JSON.parse(ue):null}return null}async getChangelog(M,z){if(M.assets.changelog){const ie=await this.F(M.identifier.id,M.assets.changelog,u.Changelog,{},z);return await(0,P.$eq)(ie)||""}return""}async getAllCompatibleVersions(M,z,ie){let ae=new v().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);M.uuid?ae=ae.withFilter(o.ExtensionId,M.uuid):ae=ae.withFilter(o.ExtensionName,M.id);const{galleryExtensions:ue}=await this.D(ae,a.CancellationToken.None);if(!ue.length)return[];const pe=J(ue[0]);if((0,$.$mp)(pe,ie))return[];const be=[];await Promise.all(ue[0].versions.map(async ye=>{try{await this.A(M.id,ye,z?"any":"release",!0,pe,ie)&&this.z(M,B(ye))&&be.push(ye)}catch{}}));const Re=[],Ae=new Set;for(const ye of K(be,ie))Ae.has(ye.version)||(Ae.add(ye.version),Re.push({version:ye.version,date:ye.lastUpdated,isPreReleaseVersion:H(ye)}));return Re}async F(M,z,ie,ae={},ue=a.CancellationToken.None){const pe=await this.j,be={type:"GET"},Re={...pe,...ae.headers||{}};ae={...ae,...be,headers:Re};const Ae=z.uri,ye=z.fallbackUri,we={...ae,url:Ae};try{const re=await this.l.request(we,ue);if(re.res.statusCode===200)return re;const he=await(0,P.$eq)(re);throw new Error(`Expected 200, got back ${re.res.statusCode} instead.

${he}`)}catch(re){if((0,N.$6)(re))throw re;const he=(0,N.$_)(re);this.q.publicLog2("galleryService:cdnFallback",{extension:M,assetType:ie,message:he});const me={...ae,url:ye};return this.l.request(me,ue)}}async G(M,z){let ie=x(z);if(!ie){this.q.publicLog2("galleryService:engineFallback",{extension:M,version:z.version});const ae=await this.E(M,z,a.CancellationToken.None);if(!ae)throw new Error("Manifest was not found");ie=ae.engines.vscode}return ie}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const M=await this.l.request({type:"GET",url:this.h},a.CancellationToken.None);if(M.res.statusCode!==200)throw new Error("Could not get extensions report.");const z=await(0,P.$fq)(M),ie=[],ae={},ue=[],pe=[];if(z){for(const be of z.malicious)ie.push({id:be});if(z.migrateToPreRelease)for(const[be,Re]of Object.entries(z.migrateToPreRelease))(!Re.engine||(0,d.$0p)(Re.engine,this.w.version,this.w.date))&&(ae[be.toLowerCase()]={disallowInstall:!0,extension:{id:Re.id,displayName:Re.displayName,autoMigrate:{storage:!!Re.migrateStorage},preRelease:!0}});if(z.deprecated)for(const[be,Re]of Object.entries(z.deprecated))Re&&(ae[be.toLowerCase()]=(0,k.$ng)(Re)?{}:Re);if(z.search)for(const be of z.search)ue.push(be);if(Array.isArray(z.extensionsEnabledWithPreRelease))for(const be of z.extensionsEnabledWithPreRelease)pe.push(be.toLowerCase())}return{malicious:ie,deprecated:ae,search:ue,extensionsEnabledWithPreRelease:pe}}};Q=Ee([X(1,P.$_p),X(2,w.$dk),X(3,p.$Pi),X(4,h.$cm),X(5,E.$dl),X(6,f.$wk),X(7,I.$cj)],Q);let oe=class extends Q{constructor(M,z,ie,ae,ue,pe,be,Re){super(M,z,ie,ae,ue,pe,be,Re)}};e.$vq=oe,e.$vq=oe=Ee([X(0,c.$mq),X(1,P.$_p),X(2,w.$dk),X(3,p.$Pi),X(4,h.$cm),X(5,E.$dl),X(6,f.$wk),X(7,I.$cj)],oe);let Z=class extends Q{constructor(M,z,ie,ae,ue,pe,be){super(void 0,M,z,ie,ae,ue,pe,be)}};e.$wq=Z,e.$wq=Z=Ee([X(0,P.$_p),X(1,w.$dk),X(2,p.$Pi),X(3,h.$cm),X(4,E.$dl),X(5,f.$wk),X(6,I.$cj)],Z)}),define(fe[225],de([0,1,109,3,18,15,2,10,13,69,23,5,6,103,21,11,38,16,12,143,20]),function(ce,e,R,a,N,A,T,k,O,y,I,p,$,g,l,d,E,w,f,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jjc=void 0;const c=[R.$Cjc,R.$Djc],h="remoteTunnelSession",i="remoteTunnelIsService";let n=class extends T.$Xc{constructor(o,u,b,C,S,v,L){super(),this.y=o,this.z=u,this.C=b,this.D=v,this.F=L,this.f=new a.$oe,this.onDidTokenFailed=this.f.event,this.g=new a.$oe,this.onDidChangeTunnelStatus=this.g.event,this.h=new a.$oe,this.onDidChangeMode=this.h.event,this.n=R.$Ajc,this.w=!1,this.I=(U,j)=>{j?this.j.error(U):this.j.info(U)},this.j=this.B(C.createLogger((0,m.$jh)(b.logsHome,`${R.$Ejc}.log`),{id:R.$Ejc,name:R.$Fjc})),this.t=new $.$Fh(100),this.B(this.j.onDidChangeLogLevel(U=>this.j.info("Log level changed to "+(0,k.$sk)(U)))),this.B(S.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(v.onDidChangeConfiguration(U=>{c.some(j=>U.affectsConfiguration(j))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=R.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(o){this.s=o,this.g.fire(o)}H(o){s(this.n,o)||(this.n=o,this.S(o),this.h.fire(this.n),o.active?(this.j.info(`Session updated: ${o.session.accountLabel} (${o.session.providerId}) (service=${o.asService})`),o.session.token&&this.j.info(`Session token updated: ${o.session.accountLabel} (${o.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(o){if(this.w)return this.s;this.w=!0,this.H(o);try{await this.t.trigger(()=>this.L())}catch(u){this.j.error(u)}return this.s}J(){if(!this.u){let o;p.$k?o=this.C.appRoot:o=(0,O.$pc)((0,O.$pc)(this.C.appRoot)),this.u=(0,O.$mc)(o,"bin",`${this.z.tunnelApplicationName}${p.$j?".exe":""}`)}return this.u}async startTunnel(o){if(s(this.n,o)&&this.s.type!=="disconnected")return this.s;this.H(o);try{await this.t.trigger(()=>this.L())}catch(u){this.j.error(u)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),this.n.active){const o=this.n.asService;this.H(R.$Ajc);try{o&&this.O("uninstallService",["service","uninstall"])}catch(u){this.j.error(u)}}try{await this.O("stop",["kill"])}catch(o){this.j.error(o)}this.G(R.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let o="",u=!1;const b=(j,F)=>{F?this.j.error(j):o+=j,!this.C.isBuilt&&j.startsWith("   Compiling")&&this.G(R.TunnelStates.connecting((0,d.localize)(2045,null)))},C=this.O("status",["status"],b);this.r=C;try{if(await C,this.r!==C)return;let j;try{j=JSON.parse(o.trim().split(`
`).find(F=>F.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(o.trim())}`),this.G(R.TunnelStates.disconnected());return}if(u=j.service_installed,this.j.info(j.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!j.tunnel&&!this.n.active){this.G(R.TunnelStates.disconnected());return}}catch(j){this.j.error(j),this.G(R.TunnelStates.disconnected());return}finally{this.r===C&&(this.r=void 0)}const S=this.n.active?this.n.session:void 0;if(S&&S.token){const j=S.token;this.G(R.TunnelStates.connecting((0,d.localize)(2046,null,S.accountLabel,S.providerId)));const F=(V,x)=>{V=V.replaceAll(j,"*".repeat(4)),b(V,x)},G=this.O("login",["user","login","--provider",S.providerId,"--log",(0,k.$sk)(this.j.getLevel())],F,{VSCODE_CLI_ACCESS_TOKEN:j});this.r=G;try{if(await G,this.r!==G)return}catch(V){this.j.error(V),this.r=void 0,this.f.fire(S),this.G(R.TunnelStates.disconnected(S));return}}const v=this.Q();v?this.G(R.TunnelStates.connecting((0,d.localize)(2047,null,v))):this.G(R.TunnelStates.connecting((0,d.localize)(2048,null)));const L=["--accept-server-license-terms","--log",(0,k.$sk)(this.j.getLevel())];v?L.push("--name",v):L.push("--random-name");let U=!1;return this.n.active&&this.n.asService&&!u&&(U=await this.M(L)===!1),this.N(S,L,U)}async M(o){let u;try{u=await this.O("serviceInstall",["service","install",...o])}catch(b){this.j.error(b),u=1}if(u!==0){const b=(0,d.localize)(2049,null);return this.j.warn(b),this.G(R.TunnelStates.connecting(b)),!1}return!0}async N(o,u,b){u.push("--parent-process-id",String(process.pid)),this.P()&&u.push("--no-sleep");let C=!1;const S=this.O("tunnel",u,(v,L)=>{L?this.j.error(v):this.j.info(v),v.includes("Connected to an existing tunnel process")&&(C=!0);const U=v.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(U){const j={link:U[1],domain:U[2],tunnelName:U[4],isAttached:C};this.G(R.TunnelStates.connected(j,b))}else v.match(/error refreshing token/)&&(S.cancel(),this.f.fire(o),this.G(R.TunnelStates.disconnected(o)))});this.r=S,S.finally(()=>{S===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=R.$Ajc,this.G(R.TunnelStates.disconnected()))})}O(o,u,b=this.I,C){return(0,$.$vh)(S=>new Promise((v,L)=>{S.isCancellationRequested&&v(-1);let U;const j=["ignore","pipe","pipe"];if(S.onCancellationRequested(()=>{U&&(this.j.info(`${o} terminating(${U.pid})`),U.kill())}),!this.C.isBuilt)b(`Building tunnel CLI from sources and run
`,!1),b(`${o} Spawning: cargo run -- tunnel ${u.join(" ")}
`,!1),U=(0,y.spawn)("cargo",["run","--","tunnel",...u],{cwd:(0,O.$mc)(this.C.appRoot,"cli"),stdio:j,env:{...process.env,RUST_BACKTRACE:"1",...C}});else{b(`Running tunnel CLI
`,!1);const F=this.J();b(`${o} Spawning: ${F} tunnel ${u.join(" ")}
`,!1),U=(0,y.spawn)(F,["tunnel",...u],{cwd:(0,E.homedir)(),stdio:j,env:{...process.env,...C}})}U.stdout.pipe(new P.$aY(`
`)).on("data",F=>{if(U){const G=F.toString();b(G,!1)}}),U.stderr.pipe(new P.$aY(`
`)).on("data",F=>{if(U){const G=F.toString();b(G,!0)}}),U.on("exit",F=>{U&&(b(`${o} exit(${U.pid}): + ${F} `,!1),U=void 0,v(F||0))}),U.on("error",F=>{U&&(b(`${o} error(${U.pid}): + ${F} `,!0),U=void 0,L())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(R.$Djc)}Q(){let o=this.D.getValue(R.$Cjc)||(0,E.hostname)();return o=o.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),o||void 0}R(){try{const o=this.F.get(h,w.StorageScope.APPLICATION),u=this.F.getBoolean(i,w.StorageScope.APPLICATION,!1);if(o){const b=JSON.parse(o);if(b&&(0,f.$hg)(b.accountLabel)&&(0,f.$hg)(b.sessionId)&&(0,f.$hg)(b.providerId))return{active:!0,session:b,asService:u};this.j.error("Problems restoring session from storage, invalid format",b)}}catch(o){this.j.error("Problems restoring session from storage",o)}return R.$Ajc}S(o){if(o.active){const u={providerId:o.session.providerId,sessionId:o.session.sessionId,accountLabel:o.session.accountLabel};this.F.store(h,JSON.stringify(u),w.StorageScope.APPLICATION,w.StorageTarget.MACHINE),this.F.store(i,o.asService,w.StorageScope.APPLICATION,w.StorageTarget.MACHINE)}else this.F.remove(h,w.StorageScope.APPLICATION),this.F.remove(i,w.StorageScope.APPLICATION)}};e.$Jjc=n,e.$Jjc=n=Ee([X(0,N.$cm),X(1,I.$wk),X(2,A.$Qi),X(3,k.$ek),X(4,g.$Hjc),X(5,l.$cj),X(6,w.$mq)],n);function t(r,o){return r&&o?r.sessionId===o.sessionId&&r.providerId===o.providerId&&r.token===o.token:r===o}const s=(r,o)=>r.active!==o.active?!1:r.active&&o.active?r.asService===o.asService&&t(r.session,o.session):!0}),define(fe[226],de([0,1,6,2,22,20,71,16,80,19]),function(ce,e,R,a,N,A,T,k,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ojc=void 0;class I extends k.$oq{constructor($,g,l,d){super(),this.bb=$,this.cb=g,this.db=l,this.eb=d,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new a.$Wc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new a.$Wc),this.ab=this.hb(this.bb)}fb(){const $=this.B(new O.$ENb(this.db.getChannel("storage"))),g=this.B(new T.$iq($));return this.B(g.onDidChangeStorage(l=>this.u(k.StorageScope.APPLICATION,l))),g}gb($){this.X.clear(),this.W=$;let g;if((0,k.$pq)($))g=this.U;else{const l=this.X.add(new O.$FNb(this.db.getChannel("storage"),$));g=this.X.add(new T.$iq(l))}return this.X.add(g.onDidChangeStorage(l=>this.u(k.StorageScope.PROFILE,l))),g}hb($){this.$.clear(),this.Z=$?.id;let g;if($){const l=this.$.add(new O.$GNb(this.db.getChannel("storage"),$));g=this.$.add(new T.$iq(l)),this.$.add(g.onDidChangeStorage(d=>this.u(k.StorageScope.WORKSPACE,d)))}return g}async O(){await R.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P($){switch($){case k.StorageScope.APPLICATION:return this.U;case k.StorageScope.PROFILE:return this.Y;default:return this.ab}}Q($){switch($){case k.StorageScope.APPLICATION:return this.s.globalStorageHome.with({scheme:N.Schemas.file}).fsPath;case k.StorageScope.PROFILE:return this.W?.globalStorageHome.with({scheme:N.Schemas.file}).fsPath;default:return this.Z?`${(0,A.$jh)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:N.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(k.WillSaveStateReason.SHUTDOWN),await R.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R($){if(!this.M(this.W,$))return;const g=this.Y,l=g.items;g!==this.U&&await g.close(),this.Y=this.gb($),await this.Y.init(),this.N(l,this.Y,k.StorageScope.PROFILE)}async S($,g){const l=this.ab,d=l?.items??new Map;await l?.close(),this.ab=this.hb($),await this.ab.init(),this.N(d,this.ab,k.StorageScope.WORKSPACE)}hasScope($){return(0,y.$Ol)($)?this.W.id===$.id:this.Z===$.id}}e.$Ojc=I}),define(fe[227],de([0,1,3,2,19,96]),function(ce,e,R,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$R=e.$0R=void 0;class T{constructor(y,I){this.a=y,this.b=I}listen(y,I){const p=this.b(y);switch(I){case"onDidChangeProfiles":return R.Event.map(this.a.onDidChangeProfiles,$=>({all:$.all.map(g=>(0,A.$Sn)({...g},p)),added:$.added.map(g=>(0,A.$Sn)({...g},p)),removed:$.removed.map(g=>(0,A.$Sn)({...g},p)),updated:$.updated.map(g=>(0,A.$Sn)({...g},p))}))}throw new Error(`Invalid listen ${I}`)}async call(y,I,p){const $=this.b(y);switch(I){case"createProfile":{const g=await this.a.createProfile(p[0],p[1],p[2]);return(0,A.$Sn)({...g},$)}case"updateProfile":{let g=(0,N.$Ql)((0,A.$Tn)(p[0],$),this.a.profilesHome.scheme);return g=await this.a.updateProfile(g,p[1]),(0,A.$Sn)({...g},$)}case"removeProfile":{const g=(0,N.$Ql)((0,A.$Tn)(p[0],$),this.a.profilesHome.scheme);return this.a.removeProfile(g)}}throw new Error(`Invalid call ${I}`)}}e.$0R=T;class k extends a.$Xc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(y,I,p){super(),this.profilesHome=I,this.f=p,this.a=[],this.b=this.B(new R.$oe),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=y.map($=>(0,N.$Ql)($,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")($=>{const g=$.added.map(E=>(0,N.$Ql)(E,this.profilesHome.scheme)),l=$.removed.map(E=>(0,N.$Ql)(E,this.profilesHome.scheme)),d=$.updated.map(E=>(0,N.$Ql)(E,this.profilesHome.scheme));this.a=$.all.map(E=>(0,N.$Ql)(E,this.profilesHome.scheme)),this.b.fire({added:g,removed:l,updated:d,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(y){this.c=y}isEnabled(){return this.c}async createNamedProfile(y,I,p){const $=await this.f.call("createNamedProfile",[y,I,p]);return(0,N.$Ql)($,this.profilesHome.scheme)}async createProfile(y,I,p,$){const g=await this.f.call("createProfile",[y,I,p,$]);return(0,N.$Ql)(g,this.profilesHome.scheme)}async createTransientProfile(y){const I=await this.f.call("createTransientProfile",[y]);return(0,N.$Ql)(I,this.profilesHome.scheme)}async setProfileForWorkspace(y,I){await this.f.call("setProfileForWorkspace",[y,I])}removeProfile(y){return this.f.call("removeProfile",[y])}async updateProfile(y,I){const p=await this.f.call("updateProfile",[y,I]);return(0,N.$Ql)(p,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$$R=k}),define(fe[62],de([0,1,2,71,4,16,3,80,19]),function(ce,e,R,a,N,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KNb=e.$JNb=e.$INb=void 0,e.$INb=(0,N.$Ii)("IUserDataProfileStorageService");let y=class extends R.$Xc{constructor(g,l){super(),this.b=l,g&&(this.a=this.B(new R.$7c))}async readStorageData(g){return this.withProfileScopedStorageService(g,async l=>this.c(l))}async updateStorageData(g,l,d){return this.withProfileScopedStorageService(g,async E=>this.f(E,l,d))}async withProfileScopedStorageService(g,l){if(this.b.hasScope(g))return l(this.b);let d=this.a?.get(g.id);if(!d){d=new p(this.g(g)),this.a?.set(g.id,d);try{await d.initialize()}catch(E){throw this.a?.has(g.id)?this.a.deleteAndDispose(g.id):d.dispose(),E}}try{const E=await l(d);return await d.flush(),E}finally{this.a?.has(g.id)||d.dispose()}}c(g){const l=new Map,d=E=>{for(const w of g.keys(A.StorageScope.PROFILE,E))l.set(w,{value:g.get(w,A.StorageScope.PROFILE),target:E})};return d(A.StorageTarget.USER),d(A.StorageTarget.MACHINE),l}f(g,l,d){g.storeAll(Array.from(l.entries()).map(([E,w])=>({key:E,value:w,scope:A.StorageScope.PROFILE,target:d})),!0)}};e.$JNb=y,e.$JNb=y=Ee([X(1,A.$mq)],y);class I extends y{constructor(g,l,d,E,w){super(g,E),this.j=l;const f=l.getChannel("profileStorageListener"),P=this.B(new R.$Yc);this.h=this.B(new T.$oe({onWillAddFirstListener:()=>{P.value=f.listen("onDidChange")(m=>{w.trace("profile storage changes",m),this.h.fire({targetChanges:m.targetChanges.map(c=>(0,O.$Ql)(c,d.profilesHome.scheme)),valueChanges:m.valueChanges.map(c=>({...c,profile:(0,O.$Ql)(c.profile,d.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>P.value=void 0})),this.onDidChange=this.h.event}async g(g){const l=this.j.getChannel("storage");return(0,A.$pq)(g)?new k.$ENb(l):new k.$FNb(l,g)}}e.$KNb=I;class p extends A.$oq{constructor(g){super({flushInterval:100}),this.U=g}async O(){const g=await this.U,l=new a.$iq(g);return this.B(l.onDidChangeStorage(d=>{this.u(A.StorageScope.PROFILE,d)})),this.B((0,R.$Vc)(()=>{l.close(),l.dispose(),(0,R.$Rc)(g)&&g.dispose()})),this.s=l,this.s.init()}P(g){return g===A.StorageScope.PROFILE?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(fe[228],de([0,1,16,10,19,56,62]),function(ce,e,R,a,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tjc=void 0;let k=class extends T.$KNb{constructor(y,I,p,$){super(!0,y,I,p,$)}};e.$tjc=k,e.$tjc=k=Ee([X(0,A.$1ic),X(1,N.$Pl),X(2,R.$mq),X(3,a.$dk)],k)}),define(fe[40],de([0,1,17,6,14,25,3,36,2,26,12,11,21,15,7,10,49,16,18,28,24,19]),function(ce,e,R,a,N,A,T,k,O,y,I,p,$,g,l,d,E,w,f,P,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NOb=e.$MOb=e.$LOb=e.$KOb=void 0,e.$HOb=h,e.$IOb=i,e.$JOb=n;function h(u){return!!(u&&u.ref!==void 0&&typeof u.ref=="string"&&u.ref!==""&&u.syncData!==void 0&&(u.syncData===null||i(u.syncData)))}function i(u){return!!(u&&u.version!==void 0&&typeof u.version=="number"&&u.content!==void 0&&typeof u.content=="string"&&(Object.keys(u).length===2||Object.keys(u).length===3&&u.machineId!==void 0&&typeof u.machineId=="string"))}function n(u,b){return`${(0,y.$_f)(u)}${b.isDefault?"":` (${b.name})`}`}let t=class extends O.$Xc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(b,C,S,v,L,U,j,F,G,V,x,H){super(),this.syncResource=b,this.collection=C,this.G=S,this.H=v,this.I=L,this.J=U,this.L=j,this.M=F,this.N=G,this.O=V,this.P=x,this.c=null,this.m=m.SyncStatus.Idle,this.n=this.B(new T.$oe),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new T.$oe),this.onDidChangeConflicts=this.t.event,this.u=this.B(new a.$Gh(50)),this.w=this.B(new T.$oe),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=n(b.syncResource,b.profile),this.h=H.extUri,this.f=this.h.joinPath(v.userDataSyncHome,...(0,m.$hob)(b.profile.isDefault?void 0:b.profile.id,b.syncResource)),this.g=this.h.joinPath(this.f,m.$Cob),this.y=(0,m.$iob)(b.profile.isDefault?void 0:b.profile.id,b.syncResource,v,this.h),this.j=(0,E.$sq)(v,S,L)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status===m.SyncStatus.HasConflicts){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const b=await this.c;this.c=null;const C=await this.Y(b.remoteUserData,b.lastSyncUserData,!0,this.ob());this.S(C)}else{this.O.trace(`${this.D}: Checking for local changes...`);const b=await this.getLastSyncUserData();(b?await this.ub(b):!0)&&this.w.fire()}}S(b){this.m!==b&&(this.m=b,this.n.fire(b))}async sync(b,C={}){await this.U(b,!0,this.ob(),C)}async preview(b,C,S={}){return this.U(b,!1,C,S)}async apply(b,C={}){try{this.F={...C};const S=await this.ab(b);return this.S(S),this.c}finally{this.F={}}}async U(b,C,S,v){try{if(this.F={...v},this.status===m.SyncStatus.HasConflicts)return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status===m.SyncStatus.Syncing)return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S(m.SyncStatus.Syncing);let L=m.SyncStatus.Idle;try{const U=await this.getLastSyncUserData(),j=await this.X(b,U);return L=await this.Y(j,U,C,S),L===m.SyncStatus.HasConflicts?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):L===m.SyncStatus.Idle&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(L)}}finally{this.F={}}}async replace(b){const C=this.kb(b);if(!C)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S(m.SyncStatus.Syncing);const S=await this.getLastSyncUserData(),v=await this.X(null,S),L=await this.W(v),U=await this.qb({ref:v.ref,syncData:C},S,L,this.ob(),A.CancellationToken.None),j=[];for(const F of U){const G=await this.sb(F,F.remoteResource,void 0,A.CancellationToken.None),{remoteChange:V}=await this.sb(F,F.previewResource,F.remoteContent,A.CancellationToken.None);j.push([F,{...G,remoteChange:V!==m.Change.None?V:m.Change.Modified}])}await this.tb(v,S,j,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S(m.SyncStatus.Idle)}return!0}async W(b){const C=await this.j;return!!b.syncData?.machineId&&b.syncData.machineId===C}async X(b,C){if(C){const S=b?b[this.resource]:void 0;if(C.ref===S||S===void 0&&C.syncData===null)return C}return this.getRemoteUserData(C)}async Y(b,C,S,v){if(b.syncData&&b.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new m.$pob((0,p.localize)(2443,null,this.resource,this.pb,b.syncData.version),m.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.Z(b,C,S,v)}catch(L){if(L instanceof m.$pob)switch(L.code){case m.UserDataSyncErrorCode.LocalPreconditionFailed:return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(b,C,S,v);case m.UserDataSyncErrorCode.Conflict:case m.UserDataSyncErrorCode.PreconditionFailed:return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),b=await this.getRemoteUserData(null),C=await this.getLastSyncUserData(),this.Y(b,C,S,v)}throw L}}async Z(b,C,S,v){try{const L=await this.W(b),U=!L&&C===null&&this.gb()!==void 0,j=S&&!U;this.c||(this.c=(0,a.$vh)(G=>this.eb(b,C,L,j,v,G)));let F=await this.c;if(S&&U){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const G of F.resourcePreviews)F=await this.accept(G.remoteResource)||F}return this.cb(F.resourcePreviews),F.resourcePreviews.some(({mergeState:G})=>G===m.MergeState.Conflict)?m.SyncStatus.HasConflicts:S?await this.ab(!1):m.SyncStatus.Syncing}catch(L){throw this.c=null,L}}async merge(b){return await this.$(b,async C=>{const S=await this.rb(C,A.CancellationToken.None);await this.G.writeFile(C.previewResource,N.$Qe.fromString(S?.content||""));const v=S&&!S.hasConflicts?await this.sb(C,C.previewResource,void 0,A.CancellationToken.None):void 0;return C.acceptResult=v,C.mergeState=S.hasConflicts?m.MergeState.Conflict:v?m.MergeState.Accepted:m.MergeState.Preview,C.localChange=v?v.localChange:S.localChange,C.remoteChange=v?v.remoteChange:S.remoteChange,C}),this.c}async accept(b,C){return await this.$(b,async S=>{const v=await this.sb(S,b,C,A.CancellationToken.None);return S.acceptResult=v,S.mergeState=m.MergeState.Accepted,S.localChange=v.localChange,S.remoteChange=v.remoteChange,S}),this.c}async discard(b){return await this.$(b,async C=>{const S=await this.rb(C,A.CancellationToken.None);return await this.G.writeFile(C.previewResource,N.$Qe.fromString(S.content||"")),C.acceptResult=void 0,C.mergeState=m.MergeState.Preview,C.localChange=S.localChange,C.remoteChange=S.remoteChange,C}),this.c}async $(b,C){if(!this.c)return;let S=await this.c;const v=S.resourcePreviews.findIndex(({localResource:L,remoteResource:U,previewResource:j})=>this.h.isEqual(L,b)||this.h.isEqual(U,b)||this.h.isEqual(j,b));v!==-1&&(this.c=(0,a.$vh)(async L=>{const U=[...S.resourcePreviews];return U[v]=await C(U[v]),{...S,resourcePreviews:U}}),S=await this.c,this.cb(S.resourcePreviews),S.resourcePreviews.some(({mergeState:L})=>L===m.MergeState.Conflict)?this.S(m.SyncStatus.HasConflicts):this.S(m.SyncStatus.Syncing))}async ab(b){if(!this.c)return m.SyncStatus.Idle;const C=await this.c;return C.resourcePreviews.some(({mergeState:S})=>S===m.MergeState.Conflict)?m.SyncStatus.HasConflicts:C.resourcePreviews.some(({mergeState:S})=>S!==m.MergeState.Accepted)?m.SyncStatus.Syncing:(await this.tb(C.remoteUserData,C.lastSyncUserData,C.resourcePreviews.map(S=>[S,S.acceptResult]),b),this.c=null,await this.bb(),m.SyncStatus.Idle)}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(b){const C=b.filter(({mergeState:S})=>S===m.MergeState.Conflict);(0,R.$wb)(this.s,C,(S,v)=>this.h.isEqual(S.previewResource,v.previewResource))||(this.s=C,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const b=await this.getLastSyncUserData();return!!b&&b.syncData!==null}async db(b){const C=this.c?await this.c:null;if(C)for(const S of C.resourcePreviews){if(this.h.isEqual(S.acceptedResource,b))return S.acceptResult?S.acceptResult.content:null;if(this.h.isEqual(S.remoteResource,b))return S.remoteContent;if(this.h.isEqual(S.localResource,b))return S.localContent;if(this.h.isEqual(S.baseResource,b))return S.baseContent}return null}async resetLocal(){this.I.remove(this.z,w.StorageScope.APPLICATION);try{await this.G.del(this.y)}catch(b){(0,l.$ul)(b)!==l.FileOperationResult.FILE_NOT_FOUND&&this.O.error(b)}}async eb(b,C,S,v,L,U){const j=await this.qb(b,C,S,L,U),F=[];for(const G of j){const V=G.previewResource.with({scheme:m.$Bob,authority:"accepted"});if(G.localChange===m.Change.None&&G.remoteChange===m.Change.None)F.push({...G,acceptedResource:V,acceptResult:{content:null,localChange:m.Change.None,remoteChange:m.Change.None},mergeState:m.MergeState.Accepted});else{const x=v?await this.rb(G,U):void 0;if(U.isCancellationRequested)break;await this.G.writeFile(G.previewResource,N.$Qe.fromString(x?.content||""));const H=x&&!x.hasConflicts?await this.sb(G,G.previewResource,void 0,U):void 0;F.push({...G,acceptResult:H,mergeState:x?.hasConflicts?m.MergeState.Conflict:H?m.MergeState.Accepted:m.MergeState.Preview,localChange:H?H.localChange:x?x.localChange:G.localChange,remoteChange:H?H.remoteChange:x?x.remoteChange:G.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:b,lastSyncUserData:C,resourcePreviews:F,isLastSyncFromCurrentMachine:S}}async getLastSyncUserData(){let b=this.gb();if(b||(b=await this.jb()),!b)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const C=JSON.parse(b),S=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!C.version&&!!S&&C.version!==S,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${C.version} is not compatible with current sync state version ${S}.`),await this.resetLocal(),null;let v,L=1;for(;v===void 0&&L++<6;)try{const U=await this.hb();U&&(U.ref===C.ref?v=U.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(U){if(U instanceof l.$yl&&U.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(U instanceof m.$pob)throw U;this.O.error(U,L)}}if(v===void 0)try{const U=await this.J.resolveResourceContent(this.resource,C.ref,this.collection,this.F);v=U===null?null:this.kb(U),await this.ib({ref:C.ref,syncData:v})}catch(U){if(U instanceof m.$pob&&U.code===m.UserDataSyncErrorCode.NotFound)this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw U}return v===void 0?null:{...C,syncData:v}}async fb(b,C={}){if(C.ref||C.version)throw new Error("Cannot have core properties as additional");const S=this.M.getResourceSyncStateVersion(this.resource),v={ref:b.ref,version:S,...C};this.I.store(this.z,JSON.stringify(v),w.StorageScope.APPLICATION,w.StorageTarget.MACHINE),await this.ib(b)}gb(){return this.I.get(this.z,w.StorageScope.APPLICATION)}async hb(){const b=(await this.G.readFile(this.y)).value.toString();try{const C=b?JSON.parse(b):void 0;if(h(C))return C}catch(C){this.O.error(C)}}async ib(b){await this.G.writeFile(this.y,N.$Qe.fromString(JSON.stringify(b)))}async jb(){try{const b=await this.G.readFile(this.y),C=JSON.parse(b.value.toString());await this.G.del(this.y),C.ref&&C.content!==void 0?(this.I.store(this.z,JSON.stringify({...C,content:void 0}),w.StorageScope.APPLICATION,w.StorageTarget.MACHINE),await this.ib({ref:C.ref,syncData:C.content===null?null:JSON.parse(C.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,C)}catch(b){b instanceof l.$yl&&b.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(b)}return this.I.get(this.z,w.StorageScope.APPLICATION)}async getRemoteUserData(b){const{ref:C,content:S}=await this.lb(b);let v=null;return S!==null&&(v=this.kb(S)),{ref:C,syncData:v}}kb(b){try{const C=JSON.parse(b);if(i(C))return C}catch(C){this.O.error(C)}throw new m.$pob((0,p.localize)(2444,null),m.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async lb(b){const C=b?{ref:b.ref,content:b.syncData?JSON.stringify(b.syncData):null}:null;return this.J.readResource(this.resource,C,this.collection,this.F)}async mb(b,C){const S=await this.j,v={version:this.pb,machineId:S,content:b};try{return C=await this.J.writeResource(this.resource,JSON.stringify(v),C,this.collection,this.F),{ref:C,syncData:v}}catch(L){throw L instanceof m.$pob&&L.code===m.UserDataSyncErrorCode.TooLarge&&(L=new m.$pob(L.message,L.code,this.resource)),L}}async nb(b){const C={version:this.pb,content:b};return this.L.writeResource(this.resource,JSON.stringify(C),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!==m.SyncStatus.Idle&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S(m.SyncStatus.Idle),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(m.$cob)}};e.$KOb=t,e.$KOb=t=Ee([X(2,l.$dl),X(3,g.$Pi),X(4,w.$mq),X(5,m.$kob),X(6,m.$lob),X(7,m.$uob),X(8,f.$cm),X(9,m.$zob),X(10,$.$cj),X(11,P.$Nl)],t);let s=class extends t{constructor(b,C,S,v,L,U,j,F,G,V,x,H,te){super(C,S,v,L,U,j,F,G,V,x,H,te),this.r=b,this.B(this.G.watch(this.h.dirname(b))),this.B(this.G.onDidFilesChange(B=>this.yb(B)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(b,C,S){try{C?await this.G.writeFile(this.r,N.$Qe.fromString(b),S?void 0:C):await this.G.createFile(this.r,N.$Qe.fromString(b),{overwrite:S})}catch(v){throw v instanceof l.$yl&&v.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND||v instanceof l.$yl&&v.fileOperationResult===l.FileOperationResult.FILE_MODIFIED_SINCE?new m.$pob(v.message,m.UserDataSyncErrorCode.LocalPreconditionFailed):v}}async xb(){try{await this.G.del(this.r)}catch(b){if(!(b instanceof l.$yl&&b.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND))throw b}}yb(b){b.contains(this.r)&&this.Q()}};e.$LOb=s,e.$LOb=s=Ee([X(3,l.$dl),X(4,g.$Pi),X(5,w.$mq),X(6,m.$kob),X(7,m.$lob),X(8,m.$uob),X(9,f.$cm),X(10,m.$zob),X(11,$.$cj),X(12,P.$Nl)],s);let r=class extends s{constructor(b,C,S,v,L,U,j,F,G,V,x,H,te,B){super(b,C,S,v,L,U,j,F,G,V,x,te,B),this.zb=H,this.Bb=void 0}Ab(b,C){const S=[],v=(0,k.$3n)(b,S,{allowEmptyContent:!0,allowTrailingComma:!0});return S.length>0||!(0,I.$og)(v)&&C!==Array.isArray(v)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$MOb=r,e.$MOb=r=Ee([X(3,l.$dl),X(4,g.$Pi),X(5,w.$mq),X(6,m.$kob),X(7,m.$lob),X(8,m.$uob),X(9,f.$cm),X(10,m.$zob),X(11,m.$yob),X(12,$.$cj),X(13,P.$Nl)],r);let o=class{constructor(b,C,S,v,L,U,j){this.resource=b,this.g=C,this.h=S,this.j=v,this.k=L,this.l=U,this.d=j.extUri,this.f=(0,m.$iob)(void 0,this.resource,S,this.d)}async initialize({ref:b,content:C}){if(!C){this.j.info("Remote content does not exist.",this.resource);return}const S=this.m(C);if(S)try{await this.o({ref:b,syncData:S})}catch(v){this.j.error(v)}}m(b){try{const C=JSON.parse(b);if(i(C))return C}catch(C){this.j.error(C)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(b,C={}){if(C.ref||C.version)throw new Error("Cannot have core properties as additional");const S={ref:b.ref,version:void 0,...C};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(S),w.StorageScope.APPLICATION,w.StorageTarget.MACHINE),await this.k.writeFile(this.f,N.$Qe.fromString(JSON.stringify(b)))}};e.$NOb=o,e.$NOb=o=Ee([X(1,c.$Pl),X(2,g.$Pi),X(3,d.$dk),X(4,l.$dl),X(5,w.$mq),X(6,P.$Nl)],o)}),define(fe[121],de([0,1,6,25,8,3,45,2,26,21,15,120,27,35,86,34,7,4,77,10,16,18,28,19,40,207,116,24,62]),function(ce,e,R,a,N,A,T,k,O,y,I,p,$,g,l,d,E,w,f,P,m,c,h,i,n,t,s,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6dc=e.$5dc=e.$4dc=void 0,e.$2dc=b,e.$3dc=C;async function u(U,j){const F=JSON.parse(U.content);if(U.version===1||U.version===2){const G=(await j.getInstalled(d.ExtensionType.System)).filter(V=>V.isBuiltin);for(const V of F)U.version===1&&(V.enabled===!1&&(V.disabled=!0),delete V.enabled),U.version===2&&G.every(x=>!(0,g.$Qp)(x.identifier,V.identifier))&&(V.installed=!0)}return F}function b(U){return JSON.parse(U.content)}function C(U,j){return U.sort((F,G)=>!F.identifier.uuid&&G.identifier.uuid?-1:F.identifier.uuid&&!G.identifier.uuid?1:(0,O.$Bf)(F.identifier.id,G.identifier.id)),j?(0,T.$ao)(U,{}):JSON.stringify(U)}let S=class extends n.$KOb{constructor(j,F,G,V,x,H,te,B,W,_,ne,le,ee,J,K,q,D){super({syncResource:r.SyncResource.Extensions,profile:j},F,V,G,x,H,te,le,ee,_,ne,K),this.Cb=B,this.Db=W,this.Eb=D,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$Bob,authority:"base"}),this.yb=this.wb.with({scheme:r.$Bob,authority:"local"}),this.zb=this.wb.with({scheme:r.$Bob,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$Bob,authority:"accepted"}),this.Bb=this.Eb.createInstance(v),this.B(A.Event.any(A.Event.filter(this.Cb.onDidInstallExtensions,Q=>Q.some(({local:oe})=>!!oe)),A.Event.filter(this.Cb.onDidUninstallExtension,Q=>!Q.error),A.Event.filter(q.onDidChange,Q=>Q.valueChanges.some(({profile:oe,changes:Z})=>this.syncResource.profile.id===oe.id&&Z.some(Y=>Y.key===$.$tp))),J.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(j,F){const G=j.syncData?await u(j.syncData,this.Cb):null,V=F?.skippedExtensions??[],x=F?.builtinExtensions??null,H=F?.syncData?await u(F.syncData,this.Cb):null,{localExtensions:te,ignoredExtensions:B}=await this.Bb.getLocalExtensions(this.syncResource.profile);G?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:W,remote:_}=(0,t.$1dc)(te,G,H,V,B,x),ne={local:W,remote:_,content:this.Hb(te,W.added,W.updated,W.removed),localChange:W.added.length>0||W.removed.length>0||W.updated.length>0?r.Change.Modified:r.Change.None,remoteChange:_!==null?r.Change.Modified:r.Change.None},le=this.Ob(te,!1);return[{skippedExtensions:V,builtinExtensions:x,baseResource:this.xb,baseContent:H?this.Ob(H,!1):le,localResource:this.yb,localContent:le,localExtensions:te,remoteResource:this.zb,remoteExtensions:G,remoteContent:G?this.Ob(G,!1):null,previewResource:this.wb,previewResult:ne,localChange:ne.localChange,remoteChange:ne.remoteChange,acceptedResource:this.Ab}]}async ub(j){const F=j.syncData?await u(j.syncData,this.Cb):null,{localExtensions:G,ignoredExtensions:V}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:x}=(0,t.$1dc)(G,F,F,j.skippedExtensions||[],V,j.builtinExtensions||[]);return x!==null}Hb(j,F,G,V){const x=[...F,...G],H=new Set,te=B=>{H.add(B.id.toLowerCase()),B.uuid&&H.add(B.uuid)};x.forEach(({identifier:B})=>te(B)),V.forEach(te);for(const B of j)H.has(B.identifier.id.toLowerCase())||B.identifier.uuid&&H.has(B.identifier.uuid)||x.push(B);return this.Ob(x,!1)}async rb(j,F){return{...j.previewResult,hasConflicts:!1}}async sb(j,F,G,V){if(this.h.isEqual(F,this.yb))return this.Kb(j);if(this.h.isEqual(F,this.zb))return this.Lb(j);if(this.h.isEqual(F,this.wb))return j.previewResult;throw new Error(`Invalid Resource: ${F.toString()}`)}async Kb(j){const F=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),G=this.Db.getIgnoredExtensions(F),V=(0,t.$1dc)(j.localExtensions,null,null,j.skippedExtensions,G,j.builtinExtensions),{local:x,remote:H}=V;return{content:j.localContent,local:x,remote:H,localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?r.Change.Modified:r.Change.None,remoteChange:H!==null?r.Change.Modified:r.Change.None}}async Lb(j){const F=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),G=this.Db.getIgnoredExtensions(F),V=j.remoteContent?JSON.parse(j.remoteContent):null;if(V!==null){const x=(0,t.$1dc)(j.localExtensions,V,j.localExtensions,[],G,j.builtinExtensions),{local:H,remote:te}=x;return{content:j.remoteContent,local:H,remote:te,localChange:H.added.length>0||H.removed.length>0||H.updated.length>0?r.Change.Modified:r.Change.None,remoteChange:te!==null?r.Change.Modified:r.Change.None}}else return{content:j.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:r.Change.None,remoteChange:r.Change.None}}async tb(j,F,G,V){let{skippedExtensions:x,builtinExtensions:H,localExtensions:te}=G[0][0];const{local:B,remote:W,localChange:_,remoteChange:ne}=G[0][1];if(_===r.Change.None&&ne===r.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),_!==r.Change.None&&(await this.nb(JSON.stringify(te)),x=await this.Bb.updateLocalExtensions(B.added,B.removed,B.updated,x,this.syncResource.profile)),W){this.O.trace(`${this.D}: Updating remote extensions...`);const le=JSON.stringify(W.all);j=await this.mb(le,V?null:j.ref),this.O.info(`${this.D}: Updated remote extensions.${W.added.length?` Added: ${JSON.stringify(W.added.map(ee=>ee.identifier.id))}.`:""}${W.updated.length?` Updated: ${JSON.stringify(W.updated.map(ee=>ee.identifier.id))}.`:""}${W.removed.length?` Removed: ${JSON.stringify(W.removed.map(ee=>ee.identifier.id))}.`:""}`)}F?.ref!==j.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),H=this.Nb(te,H),await this.fb(j,{skippedExtensions:x,builtinExtensions:H}),this.O.info(`${this.D}: Updated last synchronized extensions.${x.length?` Skipped: ${JSON.stringify(x.map(le=>le.identifier.id))}.`:""}`))}Nb(j,F){const G=new Set,V=[];for(const x of j)G.add(x.identifier.id.toLowerCase()),x.installed||V.push(x.identifier);if(F)for(const x of F)G.has(x.id.toLowerCase())||V.push(x);return V}async resolveContent(j){if(this.h.isEqual(this.zb,j)||this.h.isEqual(this.xb,j)||this.h.isEqual(this.yb,j)||this.h.isEqual(this.Ab,j)){const F=await this.db(j);return F&&this.Ob(JSON.parse(F),!0)}return null}Ob(j,F){return C(j,F)}async hasLocalData(){try{const{localExtensions:j}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(j.some(F=>F.installed||F.disabled))return!0}catch{}return!1}};e.$4dc=S,e.$4dc=S=Ee([X(2,I.$Pi),X(3,E.$dl),X(4,m.$mq),X(5,r.$kob),X(6,r.$lob),X(7,$.$sp),X(8,s.$DPb),X(9,r.$zob),X(10,y.$cj),X(11,r.$uob),X(12,c.$cm),X(13,l.$xw),X(14,h.$Nl),X(15,o.$INb),X(16,w.$Hi)],S);let v=class{constructor(j,F,G,V,x,H){this.a=j,this.b=F,this.c=G,this.d=V,this.f=x,this.g=H}async getLocalExtensions(j){const F=await this.a.getInstalled(void 0,j.extensionsResource),G=this.d.getIgnoredExtensions(F);return{localExtensions:await this.j(j,async(x,H)=>{const te=x.getDisabledExtensions();return F.map(B=>{const{identifier:W,isBuiltin:_,manifest:ne,preRelease:le,pinned:ee,isApplicationScoped:J}=B,K={identifier:W,preRelease:le,version:ne.version,pinned:!!ee};J&&!(0,d.$yn)(ne)&&(K.isApplicationScoped=J),te.some(q=>(0,g.$Qp)(q,W))&&(K.disabled=!0),_||(K.installed=!0);try{const q=H.getKeysForSync({id:W.id,version:ne.version});if(q){const D=H.getExtensionState(B,!0)||{};K.state=Object.keys(D).reduce((Q,oe)=>(q.includes(oe)&&(Q[oe]=D[oe]),Q),{})}}catch(q){this.g.info(`${(0,n.$JOb)(r.SyncResource.Extensions,j)}: Error while parsing extension state`,(0,N.$_)(q))}return K})}),ignoredExtensions:G}}async updateLocalExtensions(j,F,G,V,x){const H=(0,n.$JOb)(r.SyncResource.Extensions,x),te=[],B=new Map,W=[],_=[],ne=await this.a.getInstalled(void 0,x.extensionsResource);if((j.length||G.length)&&await this.j(x,async(J,K)=>{await R.Promises.settled([...j,...G].map(async q=>{const D=ne.find(Z=>(0,g.$Qp)(Z.identifier,q.identifier));if(D&&D.isBuiltin){q.state&&D.manifest.version===q.version&&this.h(q.state,D,D.manifest.version,K),J.getDisabledExtensions().some(Y=>(0,g.$Qp)(Y,q.identifier))!==!!q.disabled&&(q.disabled?(this.g.trace(`${H}: Disabling extension...`,q.identifier.id),await J.disableExtension(q.identifier),this.g.info(`${H}: Disabled extension`,q.identifier.id)):(this.g.trace(`${H}: Enabling extension...`,q.identifier.id),await J.enableExtension(q.identifier),this.g.info(`${H}: Enabled extension`,q.identifier.id))),W.push(q.identifier);return}const Q=q.pinned?q.version:void 0,oe=(await this.c.getExtensions([{...q.identifier,version:Q,preRelease:Q?void 0:q.preRelease}],a.CancellationToken.None))[0];if(q.state&&(D?D.manifest.version===q.version:oe)&&this.h(q.state,D||oe,D?.manifest.version,K),oe)try{J.getDisabledExtensions().some(Y=>(0,g.$Qp)(Y,q.identifier))!==!!q.disabled&&(q.disabled?(this.g.trace(`${H}: Disabling extension...`,q.identifier.id,oe.version),await J.disableExtension(oe.identifier),this.g.info(`${H}: Disabled extension`,q.identifier.id,oe.version)):(this.g.trace(`${H}: Enabling extension...`,q.identifier.id,oe.version),await J.enableExtension(oe.identifier),this.g.info(`${H}: Enabled extension`,q.identifier.id,oe.version))),(!D||D.preRelease!==q.preRelease||D.pinned!==q.pinned||Q&&D.manifest.version!==Q)&&(await this.a.canInstall(oe)?(te.push({extension:oe,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:q.pinned&&!!q.version,pinned:q.pinned,installPreReleaseVersion:q.preRelease,profileLocation:x.extensionsResource,isApplicationScoped:q.isApplicationScoped,context:{[$.$fp]:!0,[$.$gp]:$.ExtensionInstallSource.SETTINGS_SYNC}}}),B.set(oe.identifier.id.toLowerCase(),q)):(this.g.info(`${H}: Skipped synchronizing extension because it cannot be installed.`,oe.displayName||oe.identifier.id),_.push(q)))}catch(Z){_.push(q),this.g.error(Z),this.g.info(`${H}: Skipped synchronizing extension`,oe.displayName||oe.identifier.id)}else _.push(q),this.g.info(`${H}: Skipped synchronizing extension because the extension is not found.`,q.identifier.id)}))}),F.length){const J=ne.filter(({identifier:K,isBuiltin:q})=>!q&&F.some(D=>(0,g.$Qp)(K,D)));await R.Promises.settled(J.map(async K=>{this.g.trace(`${H}: Uninstalling local extension...`,K.identifier.id),await this.a.uninstall(K,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:x.extensionsResource}),this.g.info(`${H}: Uninstalled local extension.`,K.identifier.id),W.push(K.identifier)}))}const le=await this.a.installGalleryExtensions(te);for(const{identifier:J,local:K,error:q,source:D}of le){const Q=D;if(K)this.g.info(`${H}: Installed extension.`,J.id,Q.version),W.push(J);else{const oe=B.get(J.id.toLowerCase());oe&&(_.push(oe),this.g.info(`${H}: Skipped synchronizing extension`,Q.displayName||Q.identifier.id)),q instanceof $.$rp&&[$.ExtensionManagementErrorCode.Incompatible,$.ExtensionManagementErrorCode.IncompatibleApi,$.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(q.code)?this.g.info(`${H}: Skipped synchronizing extension because the compatible extension is not found.`,Q.displayName||Q.identifier.id):q&&this.g.error(q)}}const ee=[];for(const J of V)W.some(K=>(0,g.$Qp)(K,J.identifier))||ee.push(J);for(const J of _)ee.some(K=>(0,g.$Qp)(K.identifier,J.identifier))||ee.push(J);return ee}h(j,F,G,V){const x=V.getExtensionState(F,!0)||{},H=G?V.getKeysForSync({id:F.identifier.id,version:G}):void 0;H?H.forEach(te=>{x[te]=j[te]}):Object.keys(j).forEach(te=>x[te]=j[te]),V.setExtensionState(F,x,!0)}async j(j,F){return this.b.withProfileScopedStorageService(j,async G=>{const V=new k.$Wc,x=V.add(this.f.createChild(new f.$Gi([m.$mq,G]))),H=V.add(x.createInstance(p.$7Mb)),te=V.add(x.createInstance(l.$yw));try{return await F(H,te)}finally{V.dispose()}})}};e.$5dc=v,e.$5dc=v=Ee([X(0,$.$sp),X(1,o.$INb),X(2,$.$pp),X(3,s.$DPb),X(4,w.$Hi),X(5,r.$zob)],v);let L=class extends n.$NOb{constructor(j,F,G,V,x,H,te,B){super(r.SyncResource.Extensions,V,x,H,G,te,B),this.p=j,this.q=F}async t(j){return j.syncData?await u(j.syncData,this.p):null}u(j,F){const G=[],V=[],x=[];for(const H of j){if(this.q.hasToNeverSyncExtension(H.identifier.id))continue;const te=F.find(B=>(0,g.$Qp)(B.identifier,H.identifier));te?(G.push(te),H.disabled&&x.push(H.identifier)):H.installed&&(V.push({...H.identifier,preRelease:!!H.preRelease}),H.disabled&&x.push(H.identifier))}return{installedExtensions:G,newExtensions:V,disabledExtensions:x,remoteExtensions:j}}};e.$6dc=L,e.$6dc=L=Ee([X(0,$.$sp),X(1,s.$DPb),X(2,E.$dl),X(3,i.$Pl),X(4,I.$Pi),X(5,P.$dk),X(6,m.$mq),X(7,h.$Nl)],L)}),define(fe[122],de([0,1,14,8,3,36,45,5,32,21,15,7,10,49,16,18,28,40,82,211,24,19,62,4]),function(ce,e,R,a,N,A,T,k,O,y,I,p,$,g,l,d,E,w,f,P,m,c,h,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TOb=e.$SOb=e.$ROb=e.$QOb=void 0,e.$POb=s;const n="globalState.argv.",t=["locale"];function s(S,v){const L=S.storage?Object.keys(S.storage).sort():[],U={};return L.forEach(j=>U[j]=S.storage[j]),S.storage=U,v?(0,T.$ao)(S,{}):JSON.stringify(S)}const r=1;let o=class extends w.$KOb{constructor(v,L,U,j,F,G,V,x,H,te,B,W,_,ne){super({syncResource:m.SyncResource.GlobalState,profile:v},L,j,x,W,F,G,H,te,V,B,_),this.Bb=U,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:m.$Bob,authority:"base"}),this.xb=this.vb.with({scheme:m.$Bob,authority:"local"}),this.yb=this.vb.with({scheme:m.$Bob,authority:"remote"}),this.zb=this.vb.with({scheme:m.$Bob,authority:"accepted"}),this.Ab=ne.createInstance(u),this.B(j.watch(this.h.dirname(this.H.argvResource))),this.B(N.Event.any(N.Event.filter(j.onDidFilesChange,le=>le.contains(this.H.argvResource)),N.Event.filter(U.onDidChange,le=>!!(le.targetChanges.some(ee=>this.syncResource.profile.id===ee.id)||le.valueChanges.some(({profile:ee,changes:J})=>this.syncResource.profile.id===ee.id&&J.some(K=>K.target===l.StorageTarget.USER)))))(()=>this.Q()))}async qb(v,L,U){const j=v.syncData?JSON.parse(v.syncData.content):null;L=L===null&&U?v:L;const F=L&&L.syncData?JSON.parse(L.syncData.content):null,G=await this.Ab.getLocalGlobalState(this.syncResource.profile);j?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const V=await this.Jb(F),{local:x,remote:H}=(0,P.$OOb)(G.storage,j?j.storage:null,F?F.storage:null,V,this.O),te={content:null,local:x,remote:H,localChange:Object.keys(x.added).length>0||Object.keys(x.updated).length>0||x.removed.length>0?m.Change.Modified:m.Change.None,remoteChange:H.all!==null?m.Change.Modified:m.Change.None},B=s(G,!1);return[{baseResource:this.wb,baseContent:F?s(F,!1):B,localResource:this.xb,localContent:B,localUserData:G,remoteResource:this.yb,remoteContent:j?s(j,!1):null,previewResource:this.vb,previewResult:te,localChange:te.localChange,remoteChange:te.remoteChange,acceptedResource:this.zb,storageKeys:V}]}async ub(v){const L=v.syncData?JSON.parse(v.syncData.content):null;if(L===null)return!0;const U=await this.Ab.getLocalGlobalState(this.syncResource.profile),j=await this.Jb(L),{remote:F}=(0,P.$OOb)(U.storage,L.storage,L.storage,j,this.O);return F.all!==null}async rb(v,L){return{...v.previewResult,hasConflicts:!1}}async sb(v,L,U,j){if(this.h.isEqual(L,this.xb))return this.Gb(v);if(this.h.isEqual(L,this.yb))return this.Hb(v);if(this.h.isEqual(L,this.vb))return v.previewResult;throw new Error(`Invalid Resource: ${L.toString()}`)}async Gb(v){return{content:v.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(v.localUserData.storage),removed:[],updated:[],all:v.localUserData.storage},localChange:m.Change.None,remoteChange:m.Change.Modified}}async Hb(v){if(v.remoteContent!==null){const L=JSON.parse(v.remoteContent),{local:U,remote:j}=(0,P.$OOb)(v.localUserData.storage,L.storage,null,v.storageKeys,this.O);return{content:v.remoteContent,local:U,remote:j,localChange:Object.keys(U.added).length>0||Object.keys(U.updated).length>0||U.removed.length>0?m.Change.Modified:m.Change.None,remoteChange:j!==null?m.Change.Modified:m.Change.None}}else return{content:v.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:m.Change.None,remoteChange:m.Change.None}}async tb(v,L,U,j){const{localUserData:F}=U[0][0],{local:G,remote:V,localChange:x,remoteChange:H}=U[0][1];if(x===m.Change.None&&H===m.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),x!==m.Change.None&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(F)),await this.Ab.writeLocalGlobalState(G,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),H!==m.Change.None){this.O.trace(`${this.D}: Updating remote ui state...`);const te=JSON.stringify({storage:V.all});v=await this.mb(te,j?null:v.ref),this.O.info(`${this.D}: Updated remote ui state.${V.added.length?` Added: ${V.added}.`:""}${V.updated.length?` Updated: ${V.updated}.`:""}${V.removed.length?` Removed: ${V.removed}.`:""}`)}L?.ref!==v.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(v),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(v){if(this.h.isEqual(this.yb,v)||this.h.isEqual(this.wb,v)||this.h.isEqual(this.xb,v)||this.h.isEqual(this.zb,v)){const L=await this.db(v);return L&&s(JSON.parse(L),!0)}return null}async hasLocalData(){try{const{storage:v}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(v).length>1||v[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(v){const L=await this.Bb.readStorageData(this.syncResource.profile),U=[],j=[];for(const[V,x]of L)x.target===l.StorageTarget.USER?U.push(V):x.target===l.StorageTarget.MACHINE&&j.push(V);const F=[...U,...j],G=v?.storage?Object.keys(v.storage).filter(V=>!V.startsWith(n)&&!F.includes(V)&&L.get(V)!==void 0):[];if(!k.$p){const V=[...m.$gob.map(x=>(0,m.$tob)(x)),m.$sob];G.push(...V),j.push(...V)}return{user:U,machine:j,unregistered:G}}};e.$QOb=o,e.$QOb=o=Ee([X(2,h.$INb),X(3,p.$dl),X(4,m.$kob),X(5,m.$lob),X(6,m.$zob),X(7,I.$Pi),X(8,m.$uob),X(9,d.$cm),X(10,y.$cj),X(11,l.$mq),X(12,E.$Nl),X(13,i.$Hi)],o);let u=class{constructor(v,L,U,j){this.a=v,this.b=L,this.c=U,this.d=j}async getLocalGlobalState(v){const L={};if(v.isDefault){const j=await this.f(),F=(0,A.$3n)(j);for(const G of t)F[G]!==void 0&&(L[`${n}${G}`]={version:1,value:F[G]})}const U=await this.c.readStorageData(v);for(const[j,F]of U)F.value&&F.target===l.StorageTarget.USER&&(L[j]={version:1,value:F.value});return{storage:L}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const v=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),v.value.toString()}catch(v){this.d.debug((0,a.$_)(v))}return"{}"}async writeLocalGlobalState({added:v,removed:L,updated:U},j){const F=(0,w.$JOb)(m.SyncResource.GlobalState,j),G={},V=new Map,x=await this.c.readStorageData(j),H=(te,B)=>{for(const W of te){if(W.startsWith(n)){G[W.substring(n.length)]=B?B[W].value:void 0;continue}if(B){const _=B[W];_.value!==x.get(W)?.value&&V.set(W,_.value)}else x.get(W)!==void 0&&V.set(W,void 0)}};if(H(Object.keys(v),v),H(Object.keys(U),U),H(L),Object.keys(G).length){this.d.trace(`${F}: Updating locale...`);const te=await this.f();let B=te;for(const W of Object.keys(G))B=(0,f.edit)(B,[W],G[W],{});te!==B&&(this.d.trace(`${F}: Updating locale...`),await this.a.writeFile(this.b.argvResource,R.$Qe.fromString(B)),this.d.info(`${F}: Updated locale.`)),this.d.info(`${F}: Updated locale`)}V.size&&(this.d.trace(`${F}: Updating global state...`),await this.c.updateStorageData(j,V,l.StorageTarget.USER),this.d.info(`${F}: Updated global state`,[...V.keys()]))}};e.$ROb=u,e.$ROb=u=Ee([X(0,p.$dl),X(1,I.$Pi),X(2,h.$INb),X(3,m.$zob)],u);let b=class extends w.$NOb{constructor(v,L,U,j,F,G){super(m.SyncResource.GlobalState,U,j,F,L,v,G)}async o(v){const L=v.syncData?JSON.parse(v.syncData.content):null;if(!L){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const U={},j={};for(const F of Object.keys(L.storage))F.startsWith(n)?U[F.substring(n.length)]=L.storage[F].value:this.l.get(F,l.StorageScope.PROFILE)===void 0&&(j[F]=L.storage[F].value);if(Object.keys(U).length){let F="{}";try{F=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const G of Object.keys(U))F=(0,f.edit)(F,[G],U[G],{});await this.k.writeFile(this.h.argvResource,R.$Qe.fromString(F))}if(Object.keys(j).length){const F=[];for(const G of Object.keys(j))F.push({key:G,value:j[G],scope:l.StorageScope.PROFILE,target:l.StorageTarget.USER});this.l.storeAll(F,!0)}}};e.$SOb=b,e.$SOb=b=Ee([X(0,l.$mq),X(1,p.$dl),X(2,c.$Pl),X(3,I.$Pi),X(4,m.$zob),X(5,E.$Nl)],b);let C=class{constructor(v,L,U,j,F){this.a=v,this.b=L,this.c=U,this.d=j,this.f=F}getSyncStoreType(v){return this.h(v)?.storage[m.$sob]?.value}async sync(v){const L=(0,m.$oob)((0,O.$5g)());try{return await this.g(v,L)}catch(U){if(U instanceof m.$pob)switch(U.code){case m.UserDataSyncErrorCode.PreconditionFailed:return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(v,L)}throw U}}async g(v,L){const U=await this.a.readResource(m.SyncResource.GlobalState,null,void 0,L),j=this.h(U)||{storage:{}};j.storage[m.$sob]={value:v,version:r};const F=await(0,g.$sq)(this.c,this.d,this.b),G={version:r,machineId:F,content:s(j,!1)};await this.a.writeResource(m.SyncResource.GlobalState,JSON.stringify(G),U.ref,void 0,L)}h({content:v}){if(!v)return null;const L=JSON.parse(v);if((0,w.$IOb)(L))return L?JSON.parse(L.content):null;throw new Error("Invalid remote data")}};e.$TOb=C,e.$TOb=C=Ee([X(1,l.$mq),X(2,I.$Pi),X(3,p.$dl),X(4,$.$dk)],C)}),define(fe[123],de([0,1,17,14,3,36,5,12,11,21,15,7,16,18,28,19,40,208,24]),function(ce,e,R,a,N,A,T,k,O,y,I,p,$,g,l,d,E,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0dc=e.$9dc=void 0,e.$8dc=P;function P(h,i,n){try{const t=JSON.parse(h);if(!i)return(0,k.$og)(t.all)?null:t.all;switch(T.OS){case T.OperatingSystem.Macintosh:return(0,k.$og)(t.mac)?null:t.mac;case T.OperatingSystem.Linux:return(0,k.$og)(t.linux)?null:t.linux;case T.OperatingSystem.Windows:return(0,k.$og)(t.windows)?null:t.windows}}catch(t){return n.error(t),null}}let m=class extends E.$MOb{constructor(i,n,t,s,r,o,u,b,C,S,v,L,U){super(i.keybindingsResource,{syncResource:f.SyncResource.Keybindings,profile:i},n,b,C,S,t,s,u,L,r,v,o,U),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:f.$Bob,authority:"base"}),this.Gb=this.Eb.with({scheme:f.$Bob,authority:"local"}),this.Hb=this.Eb.with({scheme:f.$Bob,authority:"remote"}),this.Ib=this.Eb.with({scheme:f.$Bob,authority:"accepted"}),this.B(N.Event.filter(o.onDidChangeConfiguration,j=>j.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(i,n,t,s){const r=i.syncData?P(i.syncData.content,s.keybindingsPerPlatform??this.Qb(),this.O):null;n=n===null&&t?i:n;const o=n?this.Ob(n):null,u=await this.vb(),b=await this.Cb();let C=null,S=!1,v=!1,L=!1;if(r){let F=u?u.value.toString():"[]";if(F=F||"[]",this.Ab(F,!0))throw new f.$pob((0,O.localize)(2445,null),f.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!o||o!==F||o!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const G=await(0,w.$7dc)(F,r,o,b,this.zb);G.hasChanges&&(C=G.mergeContent,L=G.hasConflicts,S=L||G.mergeContent!==F,v=L||G.mergeContent!==r)}}else u&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),C=u.value.toString(),v=!0);const U={content:L?o:C,localChange:S?u?f.Change.Modified:f.Change.Added:f.Change.None,remoteChange:v?f.Change.Modified:f.Change.None,hasConflicts:L},j=u?u.value.toString():null;return[{fileContent:u,baseResource:this.Fb,baseContent:o,localResource:this.Gb,localContent:j,localChange:U.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:U.remoteChange,previewResource:this.Eb,previewResult:U,acceptedResource:this.Ib}]}async ub(i){const n=this.Ob(i);if(n===null)return!0;const t=await this.vb(),s=t?t.value.toString():"",r=await this.Cb(),o=await(0,w.$7dc)(s||"[]",n,n,r,this.zb);return o.hasConflicts||o.mergeContent!==n}async rb(i,n){return i.previewResult}async sb(i,n,t,s){if(this.h.isEqual(n,this.Gb))return{content:i.fileContent?i.fileContent.value.toString():null,localChange:f.Change.None,remoteChange:f.Change.Modified};if(this.h.isEqual(n,this.Hb))return{content:i.remoteContent,localChange:f.Change.Modified,remoteChange:f.Change.None};if(this.h.isEqual(n,this.Eb))return t===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:t,localChange:f.Change.Modified,remoteChange:f.Change.Modified};throw new Error(`Invalid Resource: ${n.toString()}`)}async tb(i,n,t,s){const{fileContent:r}=t[0][0];let{content:o,localChange:u,remoteChange:b}=t[0][1];if(u===f.Change.None&&b===f.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.Ab(o,!0)))throw new f.$pob((0,O.localize)(2446,null),f.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(u!==f.Change.None&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(o||"[]",r,s),this.O.info(`${this.D}: Updated local keybindings`)),b!==f.Change.None){this.O.trace(`${this.D}: Updating remote keybindings...`);const C=this.Pb(o||"[]",i.syncData?.content);i=await this.mb(C,s?null:i.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}n?.ref!==i.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(i,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const i=await this.vb();if(i){const n=(0,A.$3n)(i.value.toString());if((0,R.$Nb)(n))return!0}}catch(i){if(i.fileOperationResult!==p.FileOperationResult.FILE_NOT_FOUND)return!0}return!1}async resolveContent(i){return this.h.isEqual(this.Hb,i)||this.h.isEqual(this.Fb,i)||this.h.isEqual(this.Gb,i)||this.h.isEqual(this.Ib,i)?this.db(i):null}Ob(i){return!i.syncData||i.platformSpecific!==void 0&&i.platformSpecific!==this.Qb()?null:P(i.syncData.content,this.Qb(),this.O)}Pb(i,n){let t={};try{t=JSON.parse(n||"{}")}catch(s){this.O.error(s)}switch(this.Qb()?delete t.all:t.all=i,T.OS){case T.OperatingSystem.Macintosh:t.mac=i;break;case T.OperatingSystem.Linux:t.linux=i;break;case T.OperatingSystem.Windows:t.windows=i;break}return JSON.stringify(t)}Qb(){return!!this.P.getValue(f.$dob)}};e.$9dc=m,e.$9dc=m=Ee([X(2,f.$kob),X(3,f.$lob),X(4,f.$zob),X(5,y.$cj),X(6,f.$uob),X(7,p.$dl),X(8,I.$Pi),X(9,$.$mq),X(10,f.$yob),X(11,g.$cm),X(12,l.$Nl)],m);let c=class extends E.$NOb{constructor(i,n,t,s,r,o){super(f.SyncResource.Keybindings,n,t,s,i,r,o)}async o(i){const n=i.syncData?this.p(i.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,a.$Qe.fromString(n)),await this.n(i)}async i(){try{const i=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,A.$3n)(i.value.toString());return!(0,R.$Nb)(n)}catch(i){return i.fileOperationResult===p.FileOperationResult.FILE_NOT_FOUND}}p(i){try{return P(i,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$0dc=c,e.$0dc=c=Ee([X(0,p.$dl),X(1,d.$Pl),X(2,I.$Pi),X(3,f.$zob),X(4,$.$mq),X(5,l.$Nl)],c)}),define(fe[124],de([0,1,17,14,3,11,21,78,15,27,34,7,16,18,28,19,40,212,24]),function(ce,e,R,a,N,A,T,k,O,y,I,p,$,g,l,d,E,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aec=e.$_dc=void 0,e.$$dc=m;function P(i){return i&&i.settings&&typeof i.settings=="string"&&Object.keys(i).length===1}function m(i){const n=JSON.parse(i);return P(n)?n:{settings:i}}let c=class extends E.$MOb{constructor(n,t,s,r,o,u,b,C,S,v,L,U,j,F){super(n.settingsResource,{syncResource:f.SyncResource.Settings,profile:n},t,s,r,o,u,b,L,U,C,S,v,F),this.Eb=n,this.Fb=j,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:f.$Bob,authority:"base"}),this.localResource=this.previewResource.with({scheme:f.$Bob,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:f.$Bob,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:f.$Bob,authority:"accepted"}),this.Pb=void 0,this.Qb=void 0,this.Rb=void 0}async getRemoteUserDataSyncConfiguration(n){const t=await this.getLastSyncUserData(),s=await this.X(n,t),r=this.Mb(s),o=new k.$To(f.$cob,this.O);return r?.settings&&o.parse(r.settings),o.configurationModel.getValue(f.$cob)||{}}async qb(n,t,s){const r=await this.vb(),o=await this.Cb(),u=this.Mb(n);t=t===null&&s?n:t;const b=t?this.Mb(t):null,C=await this.Sb();let S=null,v=!1,L=!1,U=!1;if(u){let V=r?r.value.toString().trim():"{}";V=V||"{}",this.Vb(V),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const x=(0,w.$pNb)(V,u.settings,b?b.settings:null,C,[],o);S=x.localContent||x.remoteContent,v=x.localContent!==null,L=x.remoteContent!==null,U=x.hasConflicts}else r&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),S=r.value.toString().trim()||"{}",this.Vb(S),L=!0);const j=r?r.value.toString():null,F=b?.settings??null,G={content:U?F:S,localChange:v?f.Change.Modified:f.Change.None,remoteChange:L?f.Change.Modified:f.Change.None,hasConflicts:U};return[{fileContent:r,baseResource:this.baseResource,baseContent:F,localResource:this.localResource,localContent:j,localChange:G.localChange,remoteResource:this.remoteResource,remoteContent:u?u.settings:null,remoteChange:G.remoteChange,previewResource:this.previewResource,previewResult:G,acceptedResource:this.acceptedResource}]}async ub(n){const t=this.Mb(n);if(t===null)return!0;const s=await this.vb(),r=s?s.value.toString().trim():"",o=await this.Sb(),u=await this.Cb();return(0,w.$pNb)(r||"{}",t.settings,t.settings,o,[],u).remoteContent!==null}async rb(n,t){const s=await this.Cb(),r=await this.Sb();return{...n.previewResult,content:n.previewResult.content?(0,w.$oNb)(n.previewResult.content,"{}",r,s):null}}async sb(n,t,s,r){const o=await this.Cb(),u=await this.Sb();if(this.h.isEqual(t,this.localResource))return{content:n.fileContent?(0,w.$oNb)(n.fileContent.value.toString(),"{}",u,o):null,localChange:f.Change.None,remoteChange:f.Change.Modified};if(this.h.isEqual(t,this.remoteResource))return{content:n.remoteContent!==null?(0,w.$oNb)(n.remoteContent,n.fileContent?n.fileContent.value.toString():"{}",u,o):null,localChange:f.Change.Modified,remoteChange:f.Change.None};if(this.h.isEqual(t,this.previewResource))return s===void 0?{content:n.previewResult.content,localChange:n.previewResult.localChange,remoteChange:n.previewResult.remoteChange}:{content:s!==null?(0,w.$oNb)(s,n.fileContent?n.fileContent.value.toString():"{}",u,o):null,localChange:f.Change.Modified,remoteChange:f.Change.Modified};throw new Error(`Invalid Resource: ${t.toString()}`)}async tb(n,t,s,r){const{fileContent:o}=s[0][0];let{content:u,localChange:b,remoteChange:C}=s[0][1];if(b===f.Change.None&&C===f.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),u=u?u.trim():"{}",u=u||"{}",this.Vb(u),b!==f.Change.None&&(this.O.trace(`${this.D}: Updating local settings...`),o&&await this.nb(JSON.stringify(this.Ob(o.value.toString()))),await this.wb(u,o,r),await this.P.reloadConfiguration(T.ConfigurationTarget.USER_LOCAL),this.O.info(`${this.D}: Updated local settings`)),C!==f.Change.None){const S=await this.Cb(),v=this.Mb(n),L=await this.Sb(u);u=(0,w.$oNb)(u,v?v.settings:"{}",L,S),this.O.trace(`${this.D}: Updating remote settings...`),n=await this.mb(JSON.stringify(this.Ob(u)),r?null:n.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}t?.ref!==n.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(n),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const n=await this.vb();if(n)return!(0,w.$qNb)(n.value.toString())}catch(n){if(n.fileOperationResult!==p.FileOperationResult.FILE_NOT_FOUND)return!0}return!1}async resolveContent(n){return this.h.isEqual(this.remoteResource,n)||this.h.isEqual(this.localResource,n)||this.h.isEqual(this.acceptedResource,n)||this.h.isEqual(this.baseResource,n)?this.db(n):null}async db(n){let t=await super.db(n);if(t){const s=await this.Cb(),r=await this.Sb();t=(0,w.$oNb)(t,"{}",r,s)}return t}Mb(n){return n.syncData?this.Nb(n.syncData.content):null}Nb(n){try{return m(n)}catch(t){this.O.error(t)}return null}Ob(n){return{settings:n}}async Sb(n){if(this.Pb||(this.Pb=this.zb.resolveDefaultCoreIgnoredSettings()),this.Qb||(this.Qb=this.Tb()),!this.Rb){this.Rb=this.Ub();const s=this.B(N.Event.any(N.Event.filter(this.Fb.onDidInstallExtensions,r=>r.some(({local:o})=>!!o)),N.Event.filter(this.Fb.onDidUninstallExtension,r=>!r.error))(()=>{s.dispose(),this.Rb=void 0}))}const t=(await Promise.all([this.Pb,this.Qb,this.Rb])).flat();return(0,w.$mNb)(t,this.P,n)}async Tb(){const n=await this.Fb.getInstalled(I.ExtensionType.System);return(0,R.$Ob)(n.map(t=>(0,f.$bob)(t.manifest)).flat())}async Ub(){const n=await this.Fb.getInstalled(I.ExtensionType.User,this.Eb.extensionsResource);return(0,R.$Ob)(n.map(t=>(0,f.$bob)(t.manifest)).flat())}Vb(n){if(this.Ab(n,!1))throw new f.$pob((0,A.localize)(2447,null),f.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}};e.$_dc=c,e.$_dc=c=Ee([X(2,p.$dl),X(3,O.$Pi),X(4,$.$mq),X(5,f.$kob),X(6,f.$lob),X(7,f.$zob),X(8,f.$yob),X(9,T.$cj),X(10,f.$uob),X(11,g.$cm),X(12,y.$sp),X(13,l.$Nl)],c);let h=class extends E.$NOb{constructor(n,t,s,r,o,u){super(f.SyncResource.Settings,t,s,r,n,o,u)}async o(n){const t=n.syncData?this.p(n.syncData.content):null;if(!t){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,a.$Qe.fromString(t.settings)),await this.n(n)}async i(){try{const n=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,w.$qNb)(n.value.toString().trim())}catch(n){return n.fileOperationResult===p.FileOperationResult.FILE_NOT_FOUND}}p(n){try{return m(n)}catch(t){this.j.error(t)}return null}};e.$aec=h,e.$aec=h=Ee([X(0,p.$dl),X(1,d.$Pl),X(2,O.$Pi),X(3,f.$zob),X(4,$.$mq),X(5,l.$Nl)],h)}),define(fe[125],de([0,1,14,3,29,21,15,7,16,18,28,19,40,209,24]),function(ce,e,R,a,N,A,T,k,O,y,I,p,$,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fec=e.$eec=void 0,e.$dec=d;function d(f){return JSON.parse(f.content)}let E=class extends $.$KOb{constructor(P,m,c,h,i,n,t,s,r,o,u,b){super({syncResource:l.SyncResource.Snippets,profile:P},m,h,c,i,n,t,o,u,s,r,b),this.pb=1,this.vb=P.snippetsHome,this.B(this.G.watch(c.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(a.Event.filter(this.G.onDidFilesChange,C=>C.affects(this.vb))(()=>this.Q()))}async qb(P,m,c){const h=await this.Hb(),i=this.Gb(h),n=P.syncData?this.Fb(P.syncData):null;m=m===null&&c?P:m;const t=m&&m.syncData?this.Fb(m.syncData):null;n?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const s=(0,g.$bec)(i,n,t);return this.Bb(s,h,n||{},t||{})}async ub(P){const m=P.syncData?this.Fb(P.syncData):null;if(m===null)return!0;const c=await this.Hb(),h=this.Gb(c),i=(0,g.$bec)(h,m,m);return Object.keys(i.remote.added).length>0||Object.keys(i.remote.updated).length>0||i.remote.removed.length>0||i.conflicts.length>0}async rb(P,m){return P.previewResult}async sb(P,m,c,h){if(this.h.isEqualOrParent(m,this.g.with({scheme:l.$Bob,authority:"local"})))return{content:P.fileContent?P.fileContent.value.toString():null,localChange:l.Change.None,remoteChange:P.fileContent?P.remoteContent!==null?l.Change.Modified:l.Change.Added:l.Change.Deleted};if(this.h.isEqualOrParent(m,this.g.with({scheme:l.$Bob,authority:"remote"})))return{content:P.remoteContent,localChange:P.remoteContent!==null?P.fileContent?l.Change.Modified:l.Change.Added:l.Change.Deleted,remoteChange:l.Change.None};if(this.h.isEqualOrParent(m,this.g))return c===void 0?{content:P.previewResult.content,localChange:P.previewResult.localChange,remoteChange:P.previewResult.remoteChange}:{content:c,localChange:c===null?P.fileContent!==null?l.Change.Deleted:l.Change.None:l.Change.Modified,remoteChange:c===null?P.remoteContent!==null?l.Change.Deleted:l.Change.None:l.Change.Modified};throw new Error(`Invalid Resource: ${m.toString()}`)}async tb(P,m,c,h){const i=c.map(([n,t])=>({...n,acceptResult:t}));i.every(({localChange:n,remoteChange:t})=>n===l.Change.None&&t===l.Change.None)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),i.some(({localChange:n})=>n!==l.Change.None)&&(await this.Cb(i),await this.Db(i,h)),i.some(({remoteChange:n})=>n!==l.Change.None)&&(P=await this.Eb(i,P,h)),m?.ref!==P.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(P),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:n}of i)try{await this.G.del(n)}catch{}}Bb(P,m,c,h){const i=new Map;for(const n of Object.keys(P.local.added)){const t={content:P.local.added[n],hasConflicts:!1,localChange:l.Change.Added,remoteChange:l.Change.None};i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$Bob,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$Bob,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$Bob,authority:"remote"}),remoteContent:c[n],previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$Bob,authority:"accepted"})})}for(const n of Object.keys(P.local.updated)){const t={content:P.local.updated[n],hasConflicts:!1,localChange:l.Change.Modified,remoteChange:l.Change.None},s=m[n]?m[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$Bob,authority:"base"}),baseContent:h[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$Bob,authority:"local"}),fileContent:m[n],localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$Bob,authority:"remote"}),remoteContent:c[n],previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$Bob,authority:"accepted"})})}for(const n of P.local.removed){const t={content:null,hasConflicts:!1,localChange:l.Change.Deleted,remoteChange:l.Change.None},s=m[n]?m[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$Bob,authority:"base"}),baseContent:h[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$Bob,authority:"local"}),fileContent:m[n],localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$Bob,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$Bob,authority:"accepted"})})}for(const n of Object.keys(P.remote.added)){const t={content:P.remote.added[n],hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Added},s=m[n]?m[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$Bob,authority:"base"}),baseContent:h[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$Bob,authority:"local"}),fileContent:m[n],localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$Bob,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$Bob,authority:"accepted"})})}for(const n of Object.keys(P.remote.updated)){const t={content:P.remote.updated[n],hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Modified},s=m[n]?m[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$Bob,authority:"base"}),baseContent:h[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$Bob,authority:"local"}),fileContent:m[n],localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$Bob,authority:"remote"}),remoteContent:c[n],previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$Bob,authority:"accepted"})})}for(const n of P.remote.removed){const t={content:null,hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Deleted};i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$Bob,authority:"base"}),baseContent:h[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$Bob,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$Bob,authority:"remote"}),remoteContent:c[n],previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$Bob,authority:"accepted"})})}for(const n of P.conflicts){const t={content:h[n]??null,hasConflicts:!0,localChange:m[n]?l.Change.Modified:l.Change.Added,remoteChange:c[n]?l.Change.Modified:l.Change.Added},s=m[n]?m[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$Bob,authority:"base"}),baseContent:h[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$Bob,authority:"local"}),fileContent:m[n]||null,localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$Bob,authority:"remote"}),remoteContent:c[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$Bob,authority:"accepted"})})}for(const n of Object.keys(m))if(!i.has(n)){const t={content:m[n]?m[n].value.toString():null,hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.None},s=m[n]?m[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$Bob,authority:"base"}),baseContent:h[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$Bob,authority:"local"}),fileContent:m[n]||null,localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$Bob,authority:"remote"}),remoteContent:c[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$Bob,authority:"accepted"})})}return[...i.values()]}async resolveContent(P){return this.h.isEqualOrParent(P,this.g.with({scheme:l.$Bob,authority:"remote"}))||this.h.isEqualOrParent(P,this.g.with({scheme:l.$Bob,authority:"local"}))||this.h.isEqualOrParent(P,this.g.with({scheme:l.$Bob,authority:"base"}))||this.h.isEqualOrParent(P,this.g.with({scheme:l.$Bob,authority:"accepted"}))?this.db(P):null}async hasLocalData(){try{const P=await this.Hb();if(Object.keys(P).length)return!0}catch{}return!1}async Cb(P){const m={};for(const c of P)c.fileContent&&(m[this.h.basename(c.localResource)]=c.fileContent);await this.nb(JSON.stringify(this.Gb(m)))}async Db(P,m){for(const{fileContent:c,acceptResult:h,localResource:i,remoteResource:n,localChange:t}of P)if(t!==l.Change.None){const s=n?this.h.basename(n):this.h.basename(i),r=this.h.joinPath(this.vb,s);t===l.Change.Deleted?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):t===l.Change.Added?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,R.$Qe.fromString(h.content),{overwrite:m}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,R.$Qe.fromString(h.content),m?void 0:c),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb(P,m,c){const h=m.syncData?this.Fb(m.syncData):{},i=(0,N.$io)(h);for(const{acceptResult:n,localResource:t,remoteResource:s,remoteChange:r}of P)if(r!==l.Change.None){const o=t?this.h.basename(t):this.h.basename(s);r===l.Change.Deleted?delete i[o]:i[o]=n.content}return(0,g.$cec)(h,i)||(this.O.trace(`${this.D}: Updating remote snippets...`),m=await this.mb(JSON.stringify(i),c?null:m.ref),this.O.info(`${this.D}: Updated remote snippets`)),m}Fb(P){return d(P)}Gb(P){const m={};for(const c of Object.keys(P))m[c]=P[c].value.toString();return m}async Hb(){const P={};let m;try{m=await this.G.resolve(this.vb)}catch(c){if(c instanceof k.$yl&&c.fileOperationResult===k.FileOperationResult.FILE_NOT_FOUND)return P;throw c}for(const c of m.children||[]){const h=c.resource,i=this.h.extname(h);if(i===".json"||i===".code-snippets"){const n=this.h.relativePath(this.vb,h),t=await this.G.readFile(h);P[n]=t}}return P}};e.$eec=E,e.$eec=E=Ee([X(2,T.$Pi),X(3,k.$dl),X(4,O.$mq),X(5,l.$kob),X(6,l.$lob),X(7,l.$zob),X(8,A.$cj),X(9,l.$uob),X(10,y.$cm),X(11,I.$Nl)],E);let w=class extends $.$NOb{constructor(P,m,c,h,i,n){super(l.SyncResource.Snippets,m,c,h,P,i,n)}async o(P){const m=P.syncData?JSON.parse(P.syncData.content):null;if(!m){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const h of Object.keys(m)){const i=m[h];if(i){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,h);await this.k.createFile(n,R.$Qe.fromString(i)),this.j.info("Created snippet",this.d.basename(n))}}await this.n(P)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(P){return P.fileOperationResult===k.FileOperationResult.FILE_NOT_FOUND}}};e.$fec=w,e.$fec=w=Ee([X(0,k.$dl),X(1,p.$Pl),X(2,T.$Pi),X(3,l.$zob),X(4,O.$mq),X(5,I.$Nl)],w)}),define(fe[126],de([0,1,14,21,15,7,16,18,28,19,40,24]),function(ce,e,R,a,N,A,T,k,O,y,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iec=e.$hec=void 0,e.$gec=$;function $(E,w){try{return JSON.parse(E).tasks??null}catch(f){return w.error(f),null}}let g=class extends I.$LOb{constructor(w,f,P,m,c,h,i,n,t,s,r,o){super(w.tasksResource,{syncResource:p.SyncResource.Tasks,profile:w},f,n,t,s,P,m,i,r,c,h,o),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:p.$Bob,authority:"base"}),this.Cb=this.Ab.with({scheme:p.$Bob,authority:"local"}),this.Db=this.Ab.with({scheme:p.$Bob,authority:"remote"}),this.Eb=this.Ab.with({scheme:p.$Bob,authority:"accepted"})}async qb(w,f,P,m){const c=w.syncData?$(w.syncData.content,this.O):null;f=f===null&&P?w:f;const h=f?.syncData?$(f.syncData.content,this.O):null,i=await this.vb();let n=null,t=!1,s=!1,r=!1;if(w.syncData){const b=i?i.value.toString():null;if(!h||h!==b||h!==c){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const C=d(b,c,h);n=C.content,r=C.hasConflicts,t=C.hasLocalChanged,s=C.hasRemoteChanged}}else i&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=i.value.toString(),s=!0);const o={content:r?h:n,localChange:t?i?p.Change.Modified:p.Change.Added:p.Change.None,remoteChange:s?p.Change.Modified:p.Change.None,hasConflicts:r},u=i?i.value.toString():null;return[{fileContent:i,baseResource:this.Bb,baseContent:h,localResource:this.Cb,localContent:u,localChange:o.localChange,remoteResource:this.Db,remoteContent:c,remoteChange:o.remoteChange,previewResource:this.Ab,previewResult:o,acceptedResource:this.Eb}]}async ub(w){const f=w?.syncData?$(w.syncData.content,this.O):null;if(f===null)return!0;const P=await this.vb(),m=P?P.value.toString():null,c=d(m,f,f);return c.hasLocalChanged||c.hasRemoteChanged}async rb(w,f){return w.previewResult}async sb(w,f,P,m){if(this.h.isEqual(f,this.Cb))return{content:w.fileContent?w.fileContent.value.toString():null,localChange:p.Change.None,remoteChange:p.Change.Modified};if(this.h.isEqual(f,this.Db))return{content:w.remoteContent,localChange:p.Change.Modified,remoteChange:p.Change.None};if(this.h.isEqual(f,this.Ab))return P===void 0?{content:w.previewResult.content,localChange:w.previewResult.localChange,remoteChange:w.previewResult.remoteChange}:{content:P,localChange:p.Change.Modified,remoteChange:p.Change.Modified};throw new Error(`Invalid Resource: ${f.toString()}`)}async tb(w,f,P,m){const{fileContent:c}=P[0][0],{content:h,localChange:i,remoteChange:n}=P[0][1];if(i===p.Change.None&&n===p.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),i!==p.Change.None&&(this.O.trace(`${this.D}: Updating local tasks...`),c&&await this.nb(JSON.stringify(this.Kb(c.value.toString()))),h?await this.wb(h,c,m):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),n!==p.Change.None){this.O.trace(`${this.D}: Updating remote tasks...`);const t=JSON.stringify(this.Kb(h));w=await this.mb(t,m?null:w.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}f?.ref!==w.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(w),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(w){return this.h.isEqual(this.Db,w)||this.h.isEqual(this.Bb,w)||this.h.isEqual(this.Cb,w)||this.h.isEqual(this.Eb,w)?this.db(w):null}Kb(w){return w?{tasks:w}:{}}};e.$hec=g,e.$hec=g=Ee([X(2,p.$kob),X(3,p.$lob),X(4,p.$zob),X(5,a.$cj),X(6,p.$uob),X(7,A.$dl),X(8,N.$Pi),X(9,T.$mq),X(10,k.$cm),X(11,O.$Nl)],g);let l=class extends I.$NOb{constructor(w,f,P,m,c,h){super(p.SyncResource.Tasks,f,P,m,w,c,h),this.c=this.g.defaultProfile.tasksResource}async o(w){const f=w.syncData?$(w.syncData.content,this.j):null;if(!f){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,R.$Qe.fromString(f)),await this.n(w)}async p(){return this.k.exists(this.c)}};e.$iec=l,e.$iec=l=Ee([X(0,A.$dl),X(1,y.$Pl),X(2,N.$Pi),X(3,p.$zob),X(4,T.$mq),X(5,O.$Nl)],l);function d(E,w,f){if(E===null&&w===null&&f===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(E===w)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const P=f!==E,m=f!==w;return!P&&!m?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:P&&!m?{content:E,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:m&&!P?{content:w,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:E,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(fe[127],de([0,1,45,21,15,7,16,18,28,19,40,210,24]),function(ce,e,R,a,N,A,T,k,O,y,I,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3fc=void 0,e.$4fc=l,e.$5fc=d;let g=class extends I.$KOb{constructor(w,f,P,m,c,h,i,n,t,s,r,o,u){super({syncResource:$.SyncResource.Profiles,profile:w},f,m,c,h,i,n,r,o,t,s,u),this.vb=P,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:$.$Bob,authority:"base"}),this.localResource=this.previewResource.with({scheme:$.$Bob,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:$.$Bob,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:$.$Bob,authority:"accepted"}),this.B(P.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const w=await this.getLastSyncUserData();return w?.syncData?d(w.syncData):null}async getRemoteSyncedProfiles(w){const f=await this.getLastSyncUserData(),P=await this.X(w,f);return P?.syncData?d(P.syncData):null}async qb(w,f,P){if(!this.vb.isEnabled())throw new $.$pob("Cannot sync profiles because they are disabled",$.UserDataSyncErrorCode.LocalError);const m=w.syncData?d(w.syncData):null,c=f?.syncData?d(f.syncData):null,h=this.Db(),{local:i,remote:n}=(0,p.$2fc)(h,m,c,[]),t={local:i,remote:n,content:c?this.Eb(c):null,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?$.Change.Modified:$.Change.None,remoteChange:n!==null?$.Change.Modified:$.Change.None},s=l(h,!1);return[{baseResource:this.baseResource,baseContent:c?this.Eb(c):null,localResource:this.localResource,localContent:s,remoteResource:this.remoteResource,remoteContent:m?this.Eb(m):null,remoteProfiles:m,previewResource:this.previewResource,previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.acceptedResource}]}async ub(w){const f=w?.syncData?d(w.syncData):null,P=this.Db(),{remote:m}=(0,p.$2fc)(P,f,f,[]);return!!m?.added.length||!!m?.removed.length||!!m?.updated.length}async rb(w,f){return{...w.previewResult,hasConflicts:!1}}async sb(w,f,P,m){if(this.h.isEqual(f,this.localResource))return this.Ab(w);if(this.h.isEqual(f,this.remoteResource))return this.Bb(w);if(this.h.isEqual(f,this.previewResource))return w.previewResult;throw new Error(`Invalid Resource: ${f.toString()}`)}async Ab(w){const f=this.Db(),P=(0,p.$2fc)(f,null,null,[]),{local:m,remote:c}=P;return{content:w.localContent,local:m,remote:c,localChange:m.added.length>0||m.removed.length>0||m.updated.length>0?$.Change.Modified:$.Change.None,remoteChange:c!==null?$.Change.Modified:$.Change.None}}async Bb(w){const f=w.remoteContent?JSON.parse(w.remoteContent):null,P=[],m=[];for(const c of this.Db()){const h=f?.find(i=>i.id===c.id);h&&(P.push({id:c.id,name:c.name,collection:h.collection}),m.push(c))}if(f!==null){const c=(0,p.$2fc)(m,f,P,[]),{local:h,remote:i}=c;return{content:w.remoteContent,local:h,remote:i,localChange:h.added.length>0||h.removed.length>0||h.updated.length>0?$.Change.Modified:$.Change.None,remoteChange:i!==null?$.Change.Modified:$.Change.None}}else return{content:w.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:$.Change.None,remoteChange:$.Change.None}}async tb(w,f,P,m){const{local:c,remote:h,localChange:i,remoteChange:n}=P[0][1];i===$.Change.None&&n===$.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const t=P[0][0].remoteProfiles||[];if(t.length+(h?.added.length??0)-(h?.removed.length??0)>20)throw new $.$pob("Too many profiles to sync. Please remove some profiles and try again.",$.UserDataSyncErrorCode.LocalTooManyProfiles);if(i!==$.Change.None&&(await this.nb(l(this.Db(),!1)),await Promise.all(c.removed.map(async s=>{this.O.trace(`${this.D}: Removing '${s.name}' profile...`),await this.vb.removeProfile(s),this.O.info(`${this.D}: Removed profile '${s.name}'.`)})),await Promise.all(c.added.map(async s=>{this.O.trace(`${this.D}: Creating '${s.name}' profile...`),await this.vb.createProfile(s.id,s.name,{shortName:s.shortName,icon:s.icon,useDefaultFlags:s.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${s.name}'.`)})),await Promise.all(c.updated.map(async s=>{const r=this.vb.profiles.find(o=>o.id===s.id);r?(this.O.trace(`${this.D}: Updating '${s.name}' profile...`),await this.vb.updateProfile(r,{name:s.name,shortName:s.shortName,icon:s.icon,useDefaultFlags:s.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${s.name}'.`)):this.O.info(`${this.D}: Could not find profile with id '${s.id}' to update.`)}))),n!==$.Change.None){this.O.trace(`${this.D}: Updating remote profiles...`);const s=[],r=t.length+(h?.added.length??0)<=20;if(r)for(const o of h?.added||[]){const u=await this.J.createCollection(this.F);s.push(u),t.push({id:o.id,name:o.name,collection:u,shortName:o.shortName,icon:o.icon,useDefaultFlags:o.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const o of h?.removed||[])t.splice(t.findIndex(({id:u})=>o.id===u),1);for(const o of h?.updated||[]){const u=t.find(({id:b})=>o.id===b);u&&t.splice(t.indexOf(u),1,{...u,id:o.id,name:o.name,shortName:o.shortName,icon:o.icon,useDefaultFlags:o.useDefaultFlags})}try{w=await this.updateRemoteProfiles(t,m?null:w.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&h?.added.length?` Added: ${JSON.stringify(h.added.map(o=>o.name))}.`:""}${h?.updated.length?` Updated: ${JSON.stringify(h.updated.map(o=>o.name))}.`:""}${h?.removed.length?` Removed: ${JSON.stringify(h.removed.map(o=>o.name))}.`:""}`)}catch(o){if(s.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const u of s)await this.J.deleteCollection(u,this.F)}throw o}for(const o of h?.removed||[])await this.J.deleteCollection(o.collection,this.F)}f?.ref!==w.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(w),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(w,f){return this.mb(this.Eb(w),f)}async hasLocalData(){return this.Db().length>0}async resolveContent(w){if(this.h.isEqual(this.remoteResource,w)||this.h.isEqual(this.baseResource,w)||this.h.isEqual(this.localResource,w)||this.h.isEqual(this.acceptedResource,w)){const f=await this.db(w);return f&&(0,R.$ao)(JSON.parse(f),{})}return null}Db(){return this.vb.profiles.filter(w=>!w.isDefault&&!w.isTransient)}Eb(w){return JSON.stringify([...w].sort((f,P)=>f.name.localeCompare(P.name)))}};e.$3fc=g,e.$3fc=g=Ee([X(2,y.$Pl),X(3,A.$dl),X(4,N.$Pi),X(5,T.$mq),X(6,$.$kob),X(7,$.$lob),X(8,$.$zob),X(9,a.$cj),X(10,$.$uob),X(11,k.$cm),X(12,O.$Nl)],g);function l(E,w){const f=[...E].sort((P,m)=>P.name.localeCompare(m.name)).map(P=>({id:P.id,name:P.name}));return w?(0,R.$ao)(f,{}):JSON.stringify(f)}function d(E){return JSON.parse(E.content)}}),define(fe[229],de([0,1,3,2,5,15,16,18,24]),function(ce,e,R,a,N,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pfc=void 0;const y="sync.enable";let I=class extends a.$Xc{constructor($,g,l,d){super(),this.c=$,this.f=g,this.g=l,this.h=d,this.a=new R.$oe,this.onDidChangeEnablement=this.a.event,this.b=new R.$oe,this.onDidChangeResourceEnablement=this.b.event,this.B($.onDidChangeValue(T.StorageScope.APPLICATION,void 0,this.B(new a.$Wc))(E=>this.m(E)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(y,T.StorageScope.APPLICATION,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement($){$&&!this.canToggleEnablement()||(this.f.publicLog2(y,{enabled:$}),this.c.store(y,$,T.StorageScope.APPLICATION,T.StorageTarget.MACHINE))}isResourceEnabled($){return this.c.getBoolean((0,O.$tob)($),T.StorageScope.APPLICATION,!0)}setResourceEnablement($,g){if(this.isResourceEnabled($)!==g){const l=(0,O.$tob)($);this.j(l,g)}}getResourceSyncStateVersion($){}j($,g){this.c.store($,g,T.StorageScope.APPLICATION,N.$p?T.StorageTarget.USER:T.StorageTarget.MACHINE)}m($){if(y===$.key){this.a.fire(this.isEnabled());return}const g=O.$gob.filter(l=>(0,O.$tob)(l)===$.key)[0];if(g){this.b.fire([g,this.isResourceEnabled(g)]);return}}};e.$Pfc=I,e.$Pfc=I=Ee([X(0,T.$mq),X(1,k.$cm),X(2,A.$Pi),X(3,O.$job)],I)}),define(fe[230],de([0,1,6,14,72,2,20,21,15,7,19,24]),function(ce,e,R,a,N,A,T,k,O,y,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1fc=void 0;let $=class extends A.$Xc{constructor(l,d,E,w,f){super(),this.a=l,this.b=d,this.c=E,this.f=w,this.g=f,this.h()}async h(){for(const d of this.g.profiles)for(const E of p.$gob)try{await this.m(this.j(E,d.isDefault?void 0:d.id))}catch(w){this.f.error(w)}let l;try{l=await this.b.resolve(this.a.userDataSyncHome)}catch(d){(0,y.$ul)(d)!==y.FileOperationResult.FILE_NOT_FOUND&&this.f.error(d);return}if(l.children){for(const d of l.children)if(d.isDirectory&&!p.$gob.includes(d.name)&&!this.g.profiles.some(E=>E.id===d.name))try{this.f.info("Deleting non existing profile from backup",d.resource.path),await this.b.del(d.resource,{recursive:!0})}catch(E){this.f.error(E)}}}async getAllResourceRefs(l,d,E){const w=this.j(l,d,E);try{const f=await this.b.resolve(w);if(f.children)return f.children.filter(m=>m.isFile&&!m.name.startsWith("lastSync")).sort().reverse().map(m=>({ref:m.name,created:this.n(m)}))}catch(f){if((0,y.$ul)(f)!==y.FileOperationResult.FILE_NOT_FOUND)throw f}return[]}async resolveResourceContent(l,d,E,w){const f=this.j(l,E,w),P=(0,T.$jh)(f,d);try{return(await this.b.readFile(P)).value.toString()}catch(m){return this.f.error(m),null}}async writeResource(l,d,E,w,f){const P=this.j(l,w,f),m=(0,T.$jh)(P,`${(0,N.$8m)(E).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(m,a.$Qe.fromString(d))}catch(c){this.f.error(c)}}j(l,d,E=this.a.userDataSyncHome){return(0,T.$jh)(E,...d?[d,l]:[l])}async m(l){try{try{if(!await this.b.exists(l))return}catch{return}const d=await this.b.resolve(l);if(d.children){const E=d.children.filter(m=>m.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(m.name)).sort(),w=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let f=E.filter(m=>Date.now()-this.n(m)>w);const P=E.length-f.length;P<10&&(f=f.slice(10-P)),await R.Promises.settled(f.map(async m=>{this.f.info("Deleting from backup",m.resource.path),await this.b.del(m.resource)}))}}catch(d){this.f.error(d)}}n(l){return new Date(parseInt(l.name.substring(0,4)),parseInt(l.name.substring(4,6))-1,parseInt(l.name.substring(6,8)),parseInt(l.name.substring(9,11)),parseInt(l.name.substring(11,13)),parseInt(l.name.substring(13,15))).getTime()}};e.$1fc=$,e.$1fc=$=Ee([X(0,O.$Pi),X(1,y.$dl),X(2,k.$cj),X(3,p.$zob),X(4,I.$Pl)],$)}),define(fe[87],de([0,1,3,2,5,26,11,15,7,4,23,49,16,24]),function(ce,e,R,a,N,A,T,k,O,y,I,p,$,g){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$$nb=e.$9nb=void 0,e.$0nb=c,e.$9nb=(0,y.$Ii)("IUserDataSyncMachinesService");const d="sync.currentMachineName",E="Safari",w="Chrome",f="Edge",P="Firefox",m="Android";function c(n){switch(n){case E:case w:case f:case P:case m:case(0,N.$i)(N.Platform.Web):return!0}return!1}function h(){return N.$H?E:N.$F?w:N.$I?f:N.$G?P:N.$J?m:(0,N.$i)(N.$p?N.Platform.Web:N.$v)}let i=class extends a.$Xc{static{l=this}static{this.a=1}static{this.b="machines"}constructor(t,s,r,o,u,b){super(),this.h=r,this.j=o,this.m=u,this.n=b,this.c=this.B(new R.$oe),this.onDidChange=this.c.event,this.g=null,this.f=(0,p.$sq)(t,s,r)}async getMachines(t){const s=await this.f;return(await this.s(t)).machines.map(o=>({...o,isCurrent:o.id===s}))}async addCurrentMachine(t){const s=await this.f,r=await this.s(t);r.machines.some(({id:o})=>o===s)||(r.machines.push({id:s,name:this.r(r.machines),platform:h()}),await this.t(r))}async removeCurrentMachine(t){const s=await this.f,r=await this.s(t),o=r.machines.filter(({id:u})=>u!==s);o.length!==r.machines.length&&(r.machines=o,await this.t(r))}async renameMachine(t,s,r){const o=await this.s(r),u=o.machines.find(({id:b})=>b===t);if(u){u.name=s,await this.t(o);const b=await this.f;t===b&&this.h.store(d,s,$.StorageScope.APPLICATION,$.StorageTarget.MACHINE)}}async setEnablements(t){const s=await this.s();for(const[r,o]of t){const u=s.machines.find(b=>b.id===r);u&&(u.disabled=o?void 0:!0)}await this.t(s)}r(t){const s=this.h.get(d,$.StorageScope.APPLICATION);if(s)return s;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${h()} (${this.n.nameShort})`,o=new RegExp(`${(0,A.$kf)(r)}\\s#(\\d+)`);let u=0;for(const b of t){const C=o.exec(b.name),S=C?parseInt(C[1]):0;u=S>u?S:u}return`${r} #${u+1}`}async s(t){this.g=await this.u(t);const s=this.w(this.g);if(s.version!==l.a)throw new Error((0,T.localize)(2461,null,this.n.nameLong));return s}async t(t){const s=JSON.stringify(t),r=await this.j.writeResource(l.b,s,this.g?.ref||null);this.g={ref:r,content:s},this.c.fire()}async u(t){if(this.g){const s=t&&t.latest?t.latest[l.b]:void 0;if(this.g.ref===s)return this.g;if(s===void 0&&this.g.content===null)return this.g}return this.j.readResource(l.b,this.g)}w(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(s){this.m.error(s)}return{version:l.a,machines:[]}}};e.$$nb=i,e.$$nb=i=l=Ee([X(0,k.$Pi),X(1,O.$dl),X(2,$.$mq),X(3,g.$kob),X(4,g.$zob),X(5,I.$wk)],i)}),define(fe[231],de([0,1,6,72,43,8,3,2,5,20,9,11,23,16,18,24,83,87]),function(ce,e,R,a,N,A,T,k,O,y,I,p,$,g,l,d,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7fc=void 0;const f="sync.disableMachineEventually",P="sync.sessionId",m="sync.storeUrl",c="sync.productQuality";let h=class extends k.$Xc{get n(){const t=this.H.get(m,g.StorageScope.APPLICATION);return t?I.URI.parse(t):void 0}set n(t){t?this.H.store(m,t.toString(),g.StorageScope.APPLICATION,g.StorageTarget.MACHINE):this.H.remove(m,g.StorageScope.APPLICATION)}get s(){return this.H.get(c,g.StorageScope.APPLICATION)}set s(t){t?this.H.store(c,t,g.StorageScope.APPLICATION,g.StorageTarget.MACHINE):this.H.remove(c,g.StorageScope.APPLICATION)}constructor(t,s,r,o,u,b,C,S,v,L){super(),this.u=s,this.w=r,this.y=o,this.z=u,this.C=b,this.D=C,this.F=S,this.G=v,this.H=L,this.a=this.B(new k.$Yc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new T.$oe),this.onError=this.h.event,this.S=[],this.f=this.B(new R.$Gh(this.U())),this.j=this.n,this.n=s.userDataSyncStore?.url,this.r=this.s,this.s=t.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(s.onDidChangeUserDataSyncStore(()=>{(0,y.$ch)(this.n,s.userDataSyncStore?.url)||(this.j=this.n,this.n=s.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(C.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(u.onDidChangeLocal(U=>this.triggerSync([U],!1,!1))),this.B(T.Event.filter(this.y.onDidChangeResourceEnablement,([,U])=>U)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:t,message:s}=this.L();t?this.a.value===void 0&&(this.a.value=new i(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(s&&this.C.info(s),this.a.clear()):s&&this.y.isEnabled()&&this.C.info(s))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,a.$8m)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(t,s,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(P,g.StorageScope.APPLICATION),t?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(o){if(this.C.error(o),s)this.M(!1);else throw o}}M(t){this.y.isEnabled()!==t&&(this.y.setEnablement(t),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(t){if(!t){this.b=0;return}const s=d.$pob.toUserDataSyncError(t);s instanceof d.$rob&&this.F.publicLog2("autosync/error",{code:s.code,service:this.u.userDataSyncStore.url.toString()}),s.code===d.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):s.code===d.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code===d.UserDataSyncErrorCode.LocalTooManyRequests?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):s.code===d.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code===d.UserDataSyncErrorCode.MethodNotFound?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):s.code===d.UserDataSyncErrorCode.UpgradeRequired||s.code===d.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code===d.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code===d.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code===d.UserDataSyncErrorCode.ServiceChanged||s.code===d.UserDataSyncErrorCode.DefaultServiceChanged?O.$p&&s.code===d.UserDataSyncErrorCode.DefaultServiceChanged&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(s),this.b++),this.h.fire(s)}async P(){this.H.store(f,!0,g.StorageScope.APPLICATION,g.StorageTarget.MACHINE),await(0,R.$Jh)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(f,g.StorageScope.APPLICATION,!1)}R(){this.H.remove(f,g.StorageScope.APPLICATION)}async triggerSync(t,s,r){if(this.a.value===void 0)return this.f.cancel();if(s&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...t),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const o=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:o}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$7fc=h,e.$7fc=h=Ee([X(0,$.$wk),X(1,d.$job),X(2,d.$kob),X(3,d.$uob),X(4,d.$vob),X(5,d.$zob),X(6,E.$9Mb),X(7,l.$cm),X(8,w.$9nb),X(9,g.$mq)],h);class i extends k.$Xc{static{this.a="Interval"}constructor(t,s,r,o,u,b,C,S,v){super(),this.m=t,this.n=s,this.r=r,this.s=o,this.u=u,this.w=b,this.y=C,this.z=S,this.C=v,this.b=this.B(new k.$Yc),this.c=this.B(new T.$oe),this.onDidStartSync=this.c.event,this.f=this.B(new T.$oe),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,k.$Vc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(i.a,!1)}D(){this.b.value=(0,R.$Kh)(()=>{this.sync(i.a,!1),this.b.value=void 0},this.n)}sync(t,s){const r=(0,R.$vh)(async o=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(u){if((0,A.$6)(u))return}return this.H(t,s,o)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,y.$ch)(this.m,this.r.userDataSyncStore?.url)}async G(){const t=await this.r.getPreviousUserDataSyncStore(),s=this.r.userDataSyncStore;return!!s&&!!t&&(!(0,y.$ch)(s.defaultUrl,t.defaultUrl)||!(0,y.$ch)(s.insidersUrl,t.insidersUrl)||!(0,y.$ch)(s.stableUrl,t.stableUrl))}async H(t,s,r){this.y.info(`Auto Sync: Triggered by ${t}`),this.c.fire();let o;try{await this.I(s,r)}catch(u){if(this.y.error(u),o=u,d.$pob.toUserDataSyncError(u).code===d.UserDataSyncErrorCode.MethodNotFound)try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(s,r),o=void 0}catch(b){this.y.error(b),o=b}}this.f.fire(o)}async I(t,s){if(this.h=await this.u.createSyncTask(this.g,t),s.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new d.$rob((0,p.localize)(2448,null),d.UserDataSyncErrorCode.DefaultServiceChanged):new d.$rob((0,p.localize)(2449,null),d.UserDataSyncErrorCode.ServiceChanged):new d.$rob((0,p.localize)(2450,null),d.UserDataSyncErrorCode.TurnedOff);const r=this.C.get(P,g.StorageScope.APPLICATION);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new d.$rob((0,p.localize)(2451,null),d.UserDataSyncErrorCode.DefaultServiceChanged):new d.$rob((0,p.localize)(2452,null),d.UserDataSyncErrorCode.ServiceChanged):new d.$rob((0,p.localize)(2453,null),d.UserDataSyncErrorCode.SessionExpired);const o=await this.w.getMachines(this.g||void 0);if(s.isCancellationRequested)return;const u=o.find(C=>C.isCurrent);if(u?.disabled)throw new d.$rob((0,p.localize)(2454,null),d.UserDataSyncErrorCode.TurnedOff);const b=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-b}),this.g===null)try{this.g=await this.s.manifest(null)}catch(C){throw new d.$rob((0,N.$tj)(C),C instanceof d.$pob?C.code:d.UserDataSyncErrorCode.Unknown)}this.g&&this.g.session!==r&&this.C.store(P,this.g.session,g.StorageScope.APPLICATION,g.StorageTarget.MACHINE),!s.isCancellationRequested&&(u||await this.w.addCurrentMachine(this.g||void 0))}register(t){return super.B(t)}}}),define(fe[232],de([0,1,9,11,15,7,49,16,28,24,19,40,125,124,123,21,126,121,122,4,127,45,26]),function(ce,e,R,a,N,A,T,k,O,y,I,p,$,g,l,d,E,w,f,P,m,c,h){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kgc=void 0;let n=class{static{i=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(s,r,o,u,b,C,S,v,L,U){this.e=s,this.f=r,this.g=o,this.h=b,this.i=C,this.j=S,this.k=v,this.l=L,this.n=U,this.d=u.extUri}async getRemoteSyncedProfiles(){const s=await this.e.readResource(y.SyncResource.Profiles,null,void 0);if(s.content){const r=this.L(s.content,y.SyncResource.Profiles);return(0,m.$5fc)(r)}return[]}async getLocalSyncedProfiles(s){const r=await this.f.getAllResourceRefs(y.SyncResource.Profiles,void 0,s);if(r.length){const o=await this.f.resolveResourceContent(y.SyncResource.Profiles,r[0].ref,void 0,s);if(o){const u=this.L(o,y.SyncResource.Profiles);return(0,m.$5fc)(u)}}return[]}async getLocalSyncedMachines(s){const r=await this.f.getAllResourceRefs("machines",void 0,s);if(r.length){const o=await this.f.resolveResourceContent("machines",r[0].ref,void 0,s);if(o)return JSON.parse(o).machines.map(b=>({...b,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(s,r){return(await this.e.getAllResourceRefs(s,r?.collection)).map(({created:u,ref:b})=>({created:u,uri:this.J({remote:!0,syncResource:s,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:b,node:void 0})}))}async getLocalSyncResourceHandles(s,r,o){return(await this.f.getAllResourceRefs(s,r?.collection,o)).map(({created:b,ref:C})=>({created:b,uri:this.J({remote:!1,syncResource:s,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:C,node:void 0,location:o})}))}resolveUserDataSyncResource({uri:s}){const r=this.K(s),o=r?this.k.profiles.find(u=>u.id===r.profile):void 0;return r&&o?{profile:o,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:s}){const r=this.K(s);if(!r)return[];const o=this.k.profiles.find(u=>u.id===r.profile);switch(r.syncResource){case y.SyncResource.Settings:return this.s(s,o);case y.SyncResource.Keybindings:return this.u(s,o);case y.SyncResource.Tasks:return this.w(s,o);case y.SyncResource.Snippets:return this.y(s,o);case y.SyncResource.GlobalState:return this.D(s,o);case y.SyncResource.Extensions:return this.A(s,o);case y.SyncResource.Profiles:return this.G(s,o);case y.SyncResource.WorkspaceState:return[]}}async getMachineId({uri:s}){const r=this.K(s);if(r){if(r.remote){if(r.ref){const{content:o}=await this.M(r.syncResource,r.ref,r.collection);if(o)return this.L(o,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const o=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(o)return this.L(o,r.syncResource)?.machineId}return}return(0,T.$sq)(this.h,this.j,this.i)}}async resolveContent(s){const r=this.K(s);if(!r||r.node===i.a)return null;if(r.ref){const o=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&o?this.q(r.syncResource,o,r.node):o}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(s,r,o,u,b){if(s){const{content:C}=await this.M(r,u,o);return C}return this.f.resolveResourceContent(r,u,o,b)}q(s,r,o){const u=this.L(r,s);switch(s){case y.SyncResource.Settings:return this.t(u,o);case y.SyncResource.Keybindings:return this.v(u,o);case y.SyncResource.Tasks:return this.x(u,o);case y.SyncResource.Snippets:return this.z(u,o);case y.SyncResource.GlobalState:return this.E(u,o);case y.SyncResource.Extensions:return this.B(u,o);case y.SyncResource.Profiles:return this.H(u,o);case y.SyncResource.WorkspaceState:return null}}async r(s,r){const o=this.k.profiles.find(u=>u.id===r);if(!o)return null;switch(s){case y.SyncResource.GlobalState:return this.F(o);case y.SyncResource.Extensions:return this.C(o);case y.SyncResource.Profiles:return this.I(o);case y.SyncResource.Settings:return null;case y.SyncResource.Keybindings:return null;case y.SyncResource.Tasks:return null;case y.SyncResource.Snippets:return null;case y.SyncResource.WorkspaceState:return null}}s(s,r){const o=this.d.joinPath(s,"settings.json"),u=r?r.settingsResource:this.d.joinPath(s,i.a);return[{resource:o,comparableResource:u}]}t(s,r){switch(r){case"settings.json":return(0,g.$$dc)(s.content).settings}return null}u(s,r){const o=this.d.joinPath(s,"keybindings.json"),u=r?r.keybindingsResource:this.d.joinPath(s,i.a);return[{resource:o,comparableResource:u}]}v(s,r){switch(r){case"keybindings.json":return(0,l.$8dc)(s.content,!!this.l.getValue(y.$dob),this.g)}return null}w(s,r){const o=this.d.joinPath(s,"tasks.json"),u=r?r.tasksResource:this.d.joinPath(s,i.a);return[{resource:o,comparableResource:u}]}x(s,r){switch(r){case"tasks.json":return(0,E.$gec)(s.content,this.g)}return null}async y(s,r){const o=await this.resolveContent(s);if(o){const u=this.L(o,y.SyncResource.Snippets);if(u){const b=(0,$.$dec)(u),C=[];for(const S of Object.keys(b)){const v=this.d.joinPath(s,S),L=r?this.d.joinPath(r.snippetsHome,S):this.d.joinPath(s,i.a);C.push({resource:v,comparableResource:L})}return C}}return[]}z(s,r){return(0,$.$dec)(s)[r]||null}A(s,r){const o=this.d.joinPath(s,"extensions.json"),u=r?this.J({remote:!1,syncResource:y.SyncResource.Extensions,profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(s,i.a);return[{resource:o,comparableResource:u}]}B(s,r){switch(r){case"extensions.json":return(0,w.$3dc)((0,w.$2dc)(s),!0)}return null}async C(s){const{localExtensions:r}=await this.n.createInstance(w.$5dc).getLocalExtensions(s);return(0,w.$3dc)(r,!0)}D(s,r){const o=this.d.joinPath(s,"globalState.json"),u=r?this.J({remote:!1,syncResource:y.SyncResource.GlobalState,profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(s,i.a);return[{resource:o,comparableResource:u}]}E(s,r){switch(r){case"globalState.json":return(0,f.$POb)(JSON.parse(s.content),!0)}return null}async F(s){const r=await this.n.createInstance(f.$ROb).getLocalGlobalState(s);return(0,f.$POb)(r,!0)}G(s,r){const o=this.d.joinPath(s,"profiles.json"),u=this.J({remote:!1,syncResource:y.SyncResource.Profiles,profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:o,comparableResource:u}]}H(s,r){switch(r){case"profiles.json":return(0,c.$ao)(JSON.parse(s.content),{})}return null}async I(s){return(0,m.$4fc)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(s){const r=s.remote?i.b:i.c,o=[];return s.location&&(o.push(`scheme:${s.location.scheme}`),o.push(`authority:${s.location.authority}`),o.push((0,h.$of)(s.location.path,"/"))),o.push(`syncResource:${s.syncResource}`),o.push(`profile:${s.profile}`),s.collection&&o.push(`collection:${s.collection}`),s.ref&&o.push(`ref:${s.ref}`),s.node&&o.push(s.node),this.d.joinPath(R.URI.from({scheme:y.$Bob,authority:r,path:"/",query:s.location?.query,fragment:s.location?.fragment}),...o)}K(s){if(s.scheme!==y.$Bob)return;const r=[];for(;s.path!=="/";)r.unshift(this.d.basename(s)),s=this.d.dirname(s);if(r.length<2)return;const o=s.authority===i.b;let u,b;const C=[];let S,v,L,U,j;for(;r.length;){const F=r.shift();F.startsWith("scheme:")?u=F.substring(7):F.startsWith("authority:")?b=F.substring(10):F.startsWith("syncResource:")?S=F.substring(13):F.startsWith("profile:")?v=F.substring(8):F.startsWith("collection:")?L=F.substring(11):F.startsWith("ref:")?U=F.substring(4):S?j=F:C.push(F)}return{remote:o,syncResource:S,profile:v,collection:L,ref:U,node:j,location:u&&b!==void 0?this.d.joinPath(R.URI.from({scheme:u,authority:b,query:s.query,fragment:s.fragment,path:"/"}),...C):void 0}}L(s,r){try{const o=JSON.parse(s);if((0,p.$IOb)(o))return o}catch(o){this.g.error(o)}throw new y.$pob((0,a.localize)(2462,null),y.UserDataSyncErrorCode.IncompatibleRemoteContent,r)}async M(s,r,o){const u=await this.e.resolveResourceContent(s,r,o);return{ref:r,content:u}}};e.$Kgc=n,e.$Kgc=n=i=Ee([X(0,y.$kob),X(1,y.$lob),X(2,y.$zob),X(3,O.$Nl),X(4,N.$Pi),X(5,k.$mq),X(6,A.$dl),X(7,I.$Pl),X(8,d.$cj),X(9,P.$Hi)],n)}),define(fe[233],de([0,1,17,6,25,43,3,2,20,12,32,21,27,7,4,16,18,19,121,122,123,124,125,126,127,24]),function(ce,e,R,a,N,A,T,k,O,y,I,p,$,g,l,d,E,w,f,P,m,c,h,i,n,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6fc=void 0;const s="sync.lastSyncTime";let r=class extends k.$Xc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(S,v,L,U,j,F,G,V,x,H,te){super(),this.C=S,this.D=v,this.F=L,this.G=U,this.H=j,this.I=F,this.J=G,this.L=V,this.M=x,this.N=H,this.O=te,this.f=t.SyncStatus.Uninitialized,this.g=this.B(new T.$oe),this.onDidChangeStatus=this.g.event,this.h=this.B(new T.$oe),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new T.$oe),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new T.$oe),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new T.$oe),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new T.$oe),this.onDidResetLocal=this.w.event,this.y=this.B(new T.$oe),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=L.userDataSyncStore?t.SyncStatus.Idle:t.SyncStatus.Uninitialized,this.t=this.J.getNumber(s,d.StorageScope.APPLICATION,void 0),this.B((0,k.$Vc)(()=>this.cb())),this.B(new a.$Uh(()=>this.W(),5*1e3)).schedule()}async createSyncTask(S,v){this.db(),this.H.info("Sync started.");const L=new Date().getTime(),U=(0,I.$5g)();try{const V=(0,t.$oob)(U);v&&(V["Cache-Control"]="no-cache"),S=await this.D.manifest(S,V)}catch(V){const x=t.$pob.toUserDataSyncError(V);throw b(x,U,this.F,this.I),x}const j=!1,F=this;let G;return{manifest:S,async run(){if(j)throw new Error("Can run a task only once");G=(0,a.$vh)(V=>F.P(S,!1,U,V)),await G.finally(()=>G=void 0),F.H.info(`Sync done. Took ${new Date().getTime()-L}ms`),F.ab()},stop(){return G?.cancel(),F.U()}}}async createManualSyncTask(){if(this.db(),this.L.isEnabled())throw new t.$pob("Cannot start manual sync when sync is enabled",t.UserDataSyncErrorCode.LocalError);this.H.info("Sync started.");const S=new Date().getTime(),v=(0,I.$5g)(),L=(0,t.$oob)(v);let U;try{U=await this.D.manifest(null,L)}catch(G){const V=t.$pob.toUserDataSyncError(G);throw b(V,v,this.F,this.I),V}await this.resetLocal();const j=this,F=new N.$ze;return{id:v,async merge(){return j.P(U,!0,v,F.token)},async apply(){try{try{await j.R(U,v,F.token)}catch(G){if(t.$pob.toUserDataSyncError(G).code===t.UserDataSyncErrorCode.MethodNotFound)j.H.info("Client is making invalid requests. Cleaning up data..."),await j.cleanUpRemoteData(),j.H.info("Applying manual sync again..."),await j.R(U,v,F.token);else throw G}}catch(G){throw j.H.error(G),G}j.H.info(`Sync done. Took ${new Date().getTime()-S}ms`),j.ab()},async stop(){F.cancel(),await j.U(),await j.resetLocal()}}}async P(S,v,L,U){this.n=[];try{this.status!==t.SyncStatus.HasConflicts&&this.Z(t.SyncStatus.Syncing);const j=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(j,S,v,L,U));const F=j.enabled.find(G=>G.resource===t.SyncResource.Profiles);if(F){const G=await F.getLastSyncedProfiles()||[];if(U.isCancellationRequested)return;await this.Q(G,S,v,L,U)}}finally{this.status!==t.SyncStatus.HasConflicts&&this.Z(t.SyncStatus.Idle),this.r.fire(this.n)}}async Q(S,v,L,U,j){for(const F of S){if(j.isCancellationRequested)return;const G=this.M.profiles.find(x=>x.id===F.id);if(!G){this.H.error(`Profile with id:${F.id} and name: ${F.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",F.name);const V=this.getOrCreateActiveProfileSynchronizer(G,F);this.n.push(...await this.S(V,v,L,U,j))}for(const[F,G]of this.z.entries())this.M.profiles.some(V=>V.id===G[0].profile.id)||(await G[0].resetLocal(),G[1].dispose(),this.z.delete(F))}async R(S,v,L){const U=this.bb();for(const x of U){if(L.isCancellationRequested)return;await x.apply(v,L)}const j=U.find(x=>x.profile.isDefault);if(!j)return;const F=j.enabled.find(x=>x.resource===t.SyncResource.Profiles);if(!F)return;const V=(await F.getRemoteSyncedProfiles(S?.latest??null)||[]).filter(x=>U.every(H=>H.profile.id!==x.id));V.length&&await this.Q(V,S,!1,v,L)}async S(S,v,L,U,j){return(await S.sync(v,L,U,j)).map(([G,V])=>({profile:S.profile,syncResource:G,error:V}))}async U(){this.status!==t.SyncStatus.Idle&&await Promise.allSettled(this.bb().map(S=>S.stop()))}async resolveContent(S){const v=await this.N.resolveContent(S);if(v)return v;for(const L of this.bb())for(const U of L.enabled){const j=await U.resolveContent(S);if(j)return j}return null}async replace(S){this.db();const v=this.N.resolveUserDataSyncResource(S);if(!v)return;const L=await this.resolveContent(S.uri);L&&await this.X(v.profile,async U=>{if(v.syncResource===U.resource)return await U.replace(L),!0})}async accept(S,v,L,U){this.db(),await this.X(S.profile,async j=>{if(S.syncResource===j.resource)return await j.accept(v,L),U&&await j.apply((0,y.$ng)(U)?!1:U.force,(0,t.$oob)((0,I.$5g)())),!0})}async hasLocalData(){return!!await this.X(this.M.defaultProfile,async v=>{if(v.resource!==t.SyncResource.GlobalState&&await v.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.X(this.M.defaultProfile,async v=>{if(await v.hasPreviouslySynced())return!0})}async reset(){this.db(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.db();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(S){this.H.error(S)}this.y.fire()}async resetLocal(){this.db(),this.t=void 0,this.J.remove(s,d.StorageScope.APPLICATION);for(const[S]of this.z.values())try{await S.resetLocal()}catch(v){this.H.error(v)}this.cb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async W(){const S=this.J.keys(d.StorageScope.APPLICATION,d.StorageTarget.MACHINE),v=[];for(const U of S){if(!U.endsWith(".lastSyncUserData"))continue;const j=U.split(".");j.length===3&&v.push([U,j[0]])}if(!v.length)return;const L=new k.$Wc;try{let U=this.z.get(this.M.defaultProfile.id)?.[0];U||(U=L.add(this.G.createInstance(o,this.M.defaultProfile,void 0)));const j=U.enabled.find(V=>V.resource===t.SyncResource.Profiles);if(!j)return;const G=(await j.getLastSyncedProfiles())?.map(V=>V.collection)??[];for(const[V,x]of v)G.includes(x)||(this.H.info(`Removing last sync state for stale profile: ${x}`),this.J.remove(V,d.StorageScope.APPLICATION))}finally{L.dispose()}}async cleanUpRemoteData(){const S=await this.N.getRemoteSyncedProfiles(),v=S.map(F=>F.collection),L=await this.D.getAllCollections(),U=L.filter(F=>!v.includes(F));U.length&&(this.H.info(`Deleting ${U.length} redundant collections on server`),await Promise.allSettled(U.map(F=>this.D.deleteCollection(F))),this.H.info("Deleted redundant collections on server"));const j=S.filter(F=>L.includes(F.collection));if(j.length!==S.length){const F=this.G.createInstance(n.$3fc,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await F.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await F.updateRemoteProfiles(j,null),this.H.info("Updated remote profiles on server")}finally{F.dispose()}}}async saveRemoteActivityData(S){this.db();const v=await this.D.getActivityData();await this.C.writeFile(S,v)}async extractActivityData(S,v){const L=(await this.C.readFile(S)).value.toString(),U=JSON.parse(L);if(U.resources)for(const j in U.resources)for(const F of U.resources[j])await this.O.writeResource(j,F.content,new Date(F.created*1e3),void 0,v);if(U.collections)for(const j in U.collections)for(const F in U.collections[j].resources)for(const G of U.collections[j].resources?.[F]??[])await this.O.writeResource(F,G.content,new Date(G.created*1e3),j,v)}async X(S,v){const L=new k.$Wc;try{const U=this.z.get(S.id);if(U){const x=await this.Y(U[0],v,L);return(0,y.$og)(x)?null:x}if(S.isDefault){const x=L.add(this.G.createInstance(o,S,void 0)),H=await this.Y(x,v,L);return(0,y.$og)(H)?null:H}if(this.M.isEnabled())return null;const j=L.add(this.G.createInstance(n.$3fc,S,void 0)),F=await this.D.manifest(null),V=(await j.getRemoteSyncedProfiles(F?.latest??null)||[]).find(x=>x.id===S.id);if(V){const x=L.add(this.G.createInstance(o,S,V.collection)),H=await this.Y(x,v,L);return(0,y.$og)(H)?null:H}return null}finally{L.dispose()}}async Y(S,v,L){const U=[...S.enabled,...S.disabled.reduce((j,F)=>(F!==t.SyncResource.WorkspaceState&&j.push(L.add(S.createSynchronizer(F))),j),[])];for(const j of U){const F=await v(j);if(!(0,y.$og)(F))return F}}Z(S){const v=this.f;this.f!==S&&(this.f=S,this.g.fire(S),v===t.SyncStatus.HasConflicts&&this.ab())}$(){const S=this.bb().map(v=>v.conflicts).flat();(0,R.$wb)(this.j,S,(v,L)=>v.profile.id===L.profile.id&&v.syncResource===L.syncResource&&(0,R.$wb)(v.conflicts,L.conflicts,(U,j)=>(0,O.$ch)(U.previewResource,j.previewResource)))||(this.j=S,this.m.fire(S))}ab(){this.status===t.SyncStatus.Idle&&(this.t=new Date().getTime(),this.J.store(s,this.t,d.StorageScope.APPLICATION,d.StorageTarget.MACHINE),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(S,v){let L=this.z.get(S.id);if(L&&L[0].collection!==v?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),L[1].dispose(),L=void 0,this.z.delete(S.id)),!L){const U=new k.$Wc,j=U.add(this.G.createInstance(o,S,v?.collection));U.add(j.onDidChangeStatus(F=>this.Z(F))),U.add(j.onDidChangeConflicts(F=>this.$())),U.add(j.onDidChangeLocal(F=>this.h.fire(F))),this.z.set(S.id,L=[j,U])}return L[0]}bb(){const S=[];for(const[v]of this.z.values())S.push(v);return S}cb(){this.z.forEach(([,S])=>S.dispose()),this.z.clear()}db(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$6fc=r,e.$6fc=r=Ee([X(0,g.$dl),X(1,t.$kob),X(2,t.$job),X(3,l.$Hi),X(4,t.$zob),X(5,E.$cm),X(6,d.$mq),X(7,t.$uob),X(8,w.$Pl),X(9,t.$wob),X(10,t.$lob)],r);let o=class extends k.$Xc{get enabled(){return this.f.sort((S,v)=>S[1]-v[1]).map(([S])=>S)}get disabled(){return t.$gob.filter(S=>!this.r.isResourceEnabled(S))}get status(){return this.g}get conflicts(){return this.m}constructor(S,v,L,U,j,F,G,V,x,H){super(),this.profile=S,this.collection=v,this.r=L,this.t=U,this.u=j,this.w=F,this.y=G,this.z=V,this.C=x,this.D=H,this.f=[],this.g=t.SyncStatus.Idle,this.h=this.B(new T.$oe),this.onDidChangeStatus=this.h.event,this.j=this.B(new T.$oe),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new T.$oe),this.onDidChangeConflicts=this.n.event,this.B(L.onDidChangeResourceEnablement(([te,B])=>this.F(te,B))),this.B((0,k.$Vc)(()=>this.f.splice(0,this.f.length).forEach(([,,te])=>te.dispose())));for(const te of t.$gob)L.isResourceEnabled(te)&&this.G(te)}F(S,v){v?this.G(S):this.H(S)}G(S){if(this.f.some(([j])=>j.resource===S))return;if(S===t.SyncResource.Extensions&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(S===t.SyncResource.Profiles&&(!this.profile.isDefault||!this.C.isEnabled())||S===t.SyncResource.WorkspaceState)return;if(S!==t.SyncResource.Profiles&&this.profile.useDefaultFlags?.[S]){this.z.debug(`Skipping syncing ${S} in ${this.profile.name} because it is already synced by default profile`);return}const v=new k.$Wc,L=v.add(this.createSynchronizer(S));v.add(L.onDidChangeStatus(()=>this.L())),v.add(L.onDidChangeConflicts(()=>this.M())),v.add(L.onDidChangeLocal(()=>this.j.fire(S)));const U=this.N(S);this.f.push([L,U,v])}H(S){const v=this.f.findIndex(([L])=>L.resource===S);if(v!==-1){const[[L,,U]]=this.f.splice(v,1);U.dispose(),this.L(),L.stop().then(null,j=>this.z.error(j))}}createSynchronizer(S){switch(S){case t.SyncResource.Settings:return this.t.createInstance(c.$_dc,this.profile,this.collection);case t.SyncResource.Keybindings:return this.t.createInstance(m.$9dc,this.profile,this.collection);case t.SyncResource.Snippets:return this.t.createInstance(h.$eec,this.profile,this.collection);case t.SyncResource.Tasks:return this.t.createInstance(i.$hec,this.profile,this.collection);case t.SyncResource.GlobalState:return this.t.createInstance(P.$QOb,this.profile,this.collection);case t.SyncResource.Extensions:return this.t.createInstance(f.$4dc,this.profile,this.collection);case t.SyncResource.Profiles:return this.t.createInstance(n.$3fc,this.profile,this.collection)}}async sync(S,v,L,U){if(U.isCancellationRequested)return[];const j=this.enabled;if(!j.length)return[];try{const F=[],G=(0,t.$oob)(L),V=(this.collection?S?.collections?.[this.collection]?.latest:S?.latest)??null,x=v?await this.I(V):{};for(const H of j){if(U.isCancellationRequested)return[];if(!this.r.isResourceEnabled(H.resource))return[];try{if(v){const te=await H.preview(V,x,G);if(te)for(const B of te.resourcePreviews)(B.localChange!==t.Change.None||B.remoteChange!==t.Change.None)&&B.mergeState===t.MergeState.Preview&&await H.merge(B.previewResource)}else await H.sync(V,G)}catch(te){const B=t.$pob.toUserDataSyncError(te);if(b(B,L,this.w,this.y),u(te))throw B;this.z.error(te),this.z.error(`${H.resource}: ${(0,A.$tj)(te)}`),F.push([H.resource,B])}}return F}finally{this.L()}}async apply(S,v){const L=(0,t.$oob)(S);for(const U of this.enabled){if(v.isCancellationRequested)return;try{await U.apply(!1,L)}catch(j){const F=t.$pob.toUserDataSyncError(j);if(b(F,S,this.w,this.y),u(j))throw F;this.z.error(j),this.z.error(`${U.resource}: ${(0,A.$tj)(j)}`)}}}async stop(){for(const S of this.enabled)try{S.status!==t.SyncStatus.Idle&&await S.stop()}catch(v){this.z.error(v)}}async resetLocal(){for(const S of this.enabled)try{await S.resetLocal()}catch(v){this.z.error(`${S.resource}: ${(0,A.$tj)(v)}`),this.z.error(v)}}async I(S){if(!this.profile.isDefault)return{};const v=this.D.getValue(t.$cob),L=this.enabled.find(U=>U instanceof c.$_dc);if(L){const U=await L.getRemoteUserDataSyncConfiguration(S);return{...v,...U}}return v}J(S){this.g!==S&&(this.g=S,this.h.fire(S))}L(){return this.M(),this.enabled.some(S=>S.status===t.SyncStatus.HasConflicts)?this.J(t.SyncStatus.HasConflicts):this.enabled.some(S=>S.status===t.SyncStatus.Syncing)?this.J(t.SyncStatus.Syncing):this.J(t.SyncStatus.Idle)}M(){const S=this.enabled.filter(v=>v.status===t.SyncStatus.HasConflicts).filter(v=>v.conflicts.conflicts.length>0).map(v=>v.conflicts);(0,R.$wb)(this.m,S,(v,L)=>v.syncResource===L.syncResource&&(0,R.$wb)(v.conflicts,L.conflicts,(U,j)=>(0,O.$ch)(U.previewResource,j.previewResource)))||(this.m=S,this.n.fire(S))}N(S){switch(S){case t.SyncResource.Settings:return 0;case t.SyncResource.Keybindings:return 1;case t.SyncResource.Snippets:return 2;case t.SyncResource.Tasks:return 3;case t.SyncResource.GlobalState:return 4;case t.SyncResource.Extensions:return 5;case t.SyncResource.Profiles:return 6;case t.SyncResource.WorkspaceState:return 7}}};o=Ee([X(2,t.$uob),X(3,l.$Hi),X(4,$.$pp),X(5,t.$job),X(6,E.$cm),X(7,t.$zob),X(8,w.$Pl),X(9,p.$cj)],o);function u(C){if(C instanceof t.$pob)switch(C.code){case t.UserDataSyncErrorCode.MethodNotFound:case t.UserDataSyncErrorCode.TooLarge:case t.UserDataSyncErrorCode.TooManyRequests:case t.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case t.UserDataSyncErrorCode.LocalTooManyRequests:case t.UserDataSyncErrorCode.LocalTooManyProfiles:case t.UserDataSyncErrorCode.Gone:case t.UserDataSyncErrorCode.UpgradeRequired:case t.UserDataSyncErrorCode.IncompatibleRemoteContent:case t.UserDataSyncErrorCode.IncompatibleLocalContent:return!0}return!1}function b(C,S,v,L){L.publicLog2("sync/error",{code:C.code,serverCode:C instanceof t.$qob?String(C.serverCode):void 0,url:C instanceof t.$qob?C.url:void 0,resource:C.resource,executionId:S,service:v.userDataSyncStore.url.toString()})}}),define(fe[234],de([0,1,3,2,9,19,24]),function(ce,e,R,a,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sjc=e.$rjc=void 0;function k($,g){return{...$,profile:(0,A.$Ql)($.profile,g.profilesHome.scheme)}}function O($){return{created:$.created,uri:N.URI.revive($.uri)}}class y{constructor(g,l,d){this.c=g,this.d=l,this.f=d,this.a=new Map,this.b=new R.$oe}listen(g,l){switch(l){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`[UserDataSyncServiceChannel] Event not found: ${l}`)}async call(g,l,d){try{return await this.g(g,l,d)}catch(E){throw this.f.error(E),E}}async g(g,l,d){switch(l){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(N.URI.revive(d[0]));case"accept":return this.c.accept(k(d[0],this.d),N.URI.revive(d[1]),d[2],d[3]);case"replace":return this.c.replace(O(d[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(N.URI.revive(d[0]));case"extractActivityData":return this.c.extractActivityData(N.URI.revive(d[0]),N.URI.revive(d[1]));case"createManualSyncTask":return this.i()}if(l.startsWith("manualSync/")){const E=l.substring(11),w=d[0],f=this.h(w);switch(d=d.slice(1),E){case"merge":return f.merge();case"apply":return f.apply().then(()=>this.a.delete(this.j(f.id)));case"stop":return f.stop().finally(()=>this.a.delete(this.j(f.id)))}}throw new Error("Invalid call")}h(g){const l=this.a.get(this.j(g));if(!l)throw new Error(`Manual sync taks not found: ${g}`);return l}async i(){const g=await this.c.createManualSyncTask();return this.a.set(this.j(g.id),g),g.id}j(g){return`manualSyncTask-${g}`}}e.$rjc=y;let I=class extends a.$Xc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(g,l){super(),this.n=l,this.b=T.SyncStatus.Uninitialized,this.c=this.B(new R.$oe),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new R.$oe),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new R.$oe),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new R.$oe),this.onSyncErrors=this.m.event,this.a={call(d,E,w){return g.call(d,E,w).then(null,f=>{throw T.$pob.toUserDataSyncError(f)})},listen(d,E){return g.listen(d,E)}},this.a.call("_getInitialData").then(([d,E,w])=>{this.s(d),this.t(E),w&&this.u(w),this.B(this.a.listen("onDidChangeStatus")(f=>this.s(f))),this.B(this.a.listen("onDidChangeLastSyncTime")(f=>this.u(f)))}),this.B(this.a.listen("onDidChangeConflicts")(d=>this.t(d))),this.B(this.a.listen("onSyncErrors")(d=>this.m.fire(d.map(E=>({...E,error:T.$pob.toUserDataSyncError(E.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const g=await this.a.call("createManualSyncTask"),l=this;return new p(g,{async call(E,w,f){return l.a.call(`manualSync/${E}`,[g,...Array.isArray(w)?w:[w]],f)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(g,l,d,E){return this.a.call("accept",[g,l,d,E])}resolveContent(g){return this.a.call("resolveContent",[g])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(g){return this.a.call("replace",[g])}saveRemoteActivityData(g){return this.a.call("getRemoteActivityData",[g])}extractActivityData(g,l){return this.a.call("extractActivityData",[g,l])}async s(g){this.b=g,this.c.fire(g)}async t(g){this.f=g.map(l=>({syncResource:l.syncResource,profile:(0,A.$Ql)(l.profile,this.n.profilesHome.scheme),conflicts:l.conflicts.map(d=>({...d,baseResource:N.URI.revive(d.baseResource),localResource:N.URI.revive(d.localResource),remoteResource:N.URI.revive(d.remoteResource),previewResource:N.URI.revive(d.previewResource)}))})),this.g.fire(this.f)}u(g){this.h!==g&&(this.h=g,this.j.fire(g))}};e.$sjc=I,e.$sjc=I=Ee([X(1,A.$Pl)],I);class p extends a.$Xc{constructor(g,l){super(),this.id=g,this.a=l}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose"),super.dispose()}}}),define(fe[128],de([0,1,6,25,8,3,2,135,5,20,12,9,32,21,15,7,23,61,49,16,24]),function(ce,e,R,a,N,A,T,k,O,y,I,p,$,g,l,d,E,w,f,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GOb=e.$FOb=e.$EOb=e.$DOb=e.$COb=void 0;const c="configurationSync.store",h="sync.previous.store",i="sync.donot-make-requests-until",n="sync.user-session-id",t="sync.machine-session-id",s=100,r=1e3*60*5;let o=class extends T.$Xc{get userDataSyncStore(){return this.b}get c(){return this.h.get(m.$sob,P.StorageScope.APPLICATION)}set c(L){this.h.store(m.$sob,L,P.StorageScope.APPLICATION,O.$p?P.StorageTarget.USER:P.StorageTarget.MACHINE)}constructor(L,U,j){super(),this.f=L,this.g=U,this.h=j,this.a=this.B(new A.$oe),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const F=this.B(new T.$Wc);this.B(A.Event.filter(j.onDidChangeValue(P.StorageScope.APPLICATION,m.$sob,F),()=>this.c!==this.userDataSyncStore?.type,F)(()=>this.j()))}j(){this.b=this.m(this.f[c]),this.a.fire()}m(L){if(L&&(L=O.$p&&L.web?{...L,...L.web}:L,(0,I.$hg)(L.url)&&(0,I.$jg)(L.authenticationProviders)&&Object.keys(L.authenticationProviders).every(U=>Array.isArray(L.authenticationProviders[U].scopes)))){const U=L,j=!!U.canSwitch,F=U.url===U.insidersUrl?"insiders":"stable",G=(j?this.c:void 0)||F,V=G==="insiders"?U.insidersUrl:G==="stable"?U.stableUrl:U.url;return{url:p.URI.parse(V),type:G,defaultType:F,defaultUrl:p.URI.parse(U.url),stableUrl:p.URI.parse(U.stableUrl),insidersUrl:p.URI.parse(U.insidersUrl),canSwitch:j,authenticationProviders:Object.keys(U.authenticationProviders).reduce((x,H)=>(x.push({id:H,scopes:U.authenticationProviders[H].scopes}),x),[])}}}};e.$COb=o,e.$COb=o=Ee([X(0,E.$wk),X(1,g.$cj),X(2,P.$mq)],o);let u=class extends o{constructor(L,U,j){super(L,U,j);const F=this.h.get(h,P.StorageScope.APPLICATION);F&&(this.n=JSON.parse(F));const G=this.f[c];G?this.h.store(h,JSON.stringify(G),P.StorageScope.APPLICATION,P.StorageTarget.MACHINE):this.h.remove(h,P.StorageScope.APPLICATION)}async switch(L){L!==this.c&&(this.c=L,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$DOb=u,e.$DOb=u=Ee([X(0,E.$wk),X(1,g.$cj),X(2,P.$mq)],u);let b=class extends T.$Xc{get donotMakeRequestsUntil(){return this.j}constructor(L,U,j,F,G,V,x){super(),this.n=j,this.r=F,this.s=x,this.g=this.B(new A.$oe),this.onTokenFailed=this.g.event,this.h=this.B(new A.$oe),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new A.$oe),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(L),this.c=(0,f.$sq)(G,V,x).then(H=>{const te={"X-Client-Name":`${U.applicationName}${O.$p?"-web":""}`,"X-Client-Version":U.version};return U.commit&&(te["X-Client-Commit"]=U.commit),te}),this.f=new S(s,r,this.n,this.r),this.u(),this.B((0,T.$Vc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(L,U){this.b={token:L,type:U}}t(L){this.a=L?(0,y.$jh)(L,"v1"):void 0}u(){const L=this.s.getNumber(i,P.StorageScope.APPLICATION);L&&Date.now()<L&&this.y(new Date(L))}y(L){this.j?.getTime()!==L?.getTime()&&(this.j=L,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(i,this.j.getTime(),P.StorageScope.APPLICATION,P.StorageTarget.MACHINE),this.w=(0,R.$vh)(U=>(0,R.$Jh)(this.j.getTime()-Date.now(),U).then(()=>this.y(void 0))),this.w.then(null,U=>null)):this.s.remove(i,P.StorageScope.APPLICATION),this.m.fire())}async getAllCollections(L={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,y.$jh)(this.a,"collection").toString();L={...L},L["Content-Type"]="application/json";const j=await this.D(U,{type:"GET",headers:L},[],a.CancellationToken.None);return(await(0,w.$fq)(j))?.map(({id:F})=>F)||[]}async createCollection(L={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,y.$jh)(this.a,"collection").toString();L={...L},L["Content-Type"]=k.$et.text;const j=await this.D(U,{type:"POST",headers:L},[],a.CancellationToken.None),F=await(0,w.$eq)(j);if(!F)throw new m.$qob("Server did not return the collection id",U,m.UserDataSyncErrorCode.NoCollection,j.res.statusCode,j.res.headers[m.$mob]);return F}async deleteCollection(L,U={}){if(!this.a)throw new Error("No settings sync store url configured.");const j=L?(0,y.$jh)(this.a,"collection",L).toString():(0,y.$jh)(this.a,"collection").toString();U={...U},await this.D(j,{type:"DELETE",headers:U},[],a.CancellationToken.None)}async getAllResourceRefs(L,U){if(!this.a)throw new Error("No settings sync store url configured.");const j=this.z(this.a,U,L),F={},G=await this.D(j.toString(),{type:"GET",headers:F},[],a.CancellationToken.None);return(await(0,w.$fq)(G)||[]).map(({url:x,created:H})=>({ref:(0,y.$lh)(j,j.with({path:x})),created:H*1e3}))}async resolveResourceContent(L,U,j,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const G=(0,y.$jh)(this.z(this.a,j,L),U).toString();F={...F},F["Cache-Control"]="no-cache";const V=await this.D(G,{type:"GET",headers:F},[],a.CancellationToken.None);return await(0,w.$eq)(V)}async deleteResource(L,U,j){if(!this.a)throw new Error("No settings sync store url configured.");const F=U!==null?(0,y.$jh)(this.z(this.a,j,L),U).toString():this.z(this.a,j,L).toString(),G={};await this.D(F,{type:"DELETE",headers:G},[],a.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const L=(0,y.$jh)(this.a,"resource").toString(),U={"Content-Type":k.$et.text};await this.D(L,{type:"DELETE",headers:U},[],a.CancellationToken.None)}async readResource(L,U,j,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const G=(0,y.$jh)(this.z(this.a,j,L),"latest").toString();F={...F},F["Cache-Control"]="no-cache",U&&(F["If-None-Match"]=U.ref);const V=await this.D(G,{type:"GET",headers:F},[304],a.CancellationToken.None);let x=null;if(V.res.statusCode===304&&(x=U),x===null){const H=V.res.headers.etag;if(!H)throw new m.$qob("Server did not return the ref",G,m.UserDataSyncErrorCode.NoRef,V.res.statusCode,V.res.headers[m.$mob]);const te=await(0,w.$eq)(V);if(!te&&V.res.statusCode===304)throw new m.$qob("Empty response",G,m.UserDataSyncErrorCode.EmptyResponse,V.res.statusCode,V.res.headers[m.$mob]);x={ref:H,content:te}}return x}async writeResource(L,U,j,F,G={}){if(!this.a)throw new Error("No settings sync store url configured.");const V=this.z(this.a,F,L).toString();G={...G},G["Content-Type"]=k.$et.text,j&&(G["If-Match"]=j);const x=await this.D(V,{type:"POST",data:U,headers:G},[],a.CancellationToken.None),H=x.res.headers.etag;if(!H)throw new m.$qob("Server did not return the ref",V,m.UserDataSyncErrorCode.NoRef,x.res.statusCode,x.res.headers[m.$mob]);return H}async manifest(L,U={}){if(!this.a)throw new Error("No settings sync store url configured.");const j=(0,y.$jh)(this.a,"manifest").toString();U={...U},U["Content-Type"]="application/json",L&&(U["If-None-Match"]=L.ref);const F=await this.D(j,{type:"GET",headers:U},[304],a.CancellationToken.None);let G=null;if(F.res.statusCode===304&&(G=L),!G){const x=F.res.headers.etag;if(!x)throw new m.$qob("Server did not return the ref",j,m.UserDataSyncErrorCode.NoRef,F.res.statusCode,F.res.headers[m.$mob]);const H=await(0,w.$eq)(F);if(!H&&F.res.statusCode===304)throw new m.$qob("Empty response",j,m.UserDataSyncErrorCode.EmptyResponse,F.res.statusCode,F.res.headers[m.$mob]);H&&(G={...JSON.parse(H),ref:x})}const V=this.s.get(n,P.StorageScope.APPLICATION);return V&&G&&V!==G.session&&this.C(),G===null&&V&&this.C(),G&&this.s.store(n,G.session,P.StorageScope.APPLICATION,P.StorageTarget.MACHINE),G}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const L=(0,y.$jh)(this.a,"download").toString(),U={},j=await this.D(L,{type:"GET",headers:U},[],a.CancellationToken.None);if(!(0,w.$bq)(j))throw new m.$qob("Server returned "+j.res.statusCode,L,m.UserDataSyncErrorCode.EmptyResponse,j.res.statusCode,j.res.headers[m.$mob]);if((0,w.$cq)(j))throw new m.$qob("Empty response",L,m.UserDataSyncErrorCode.EmptyResponse,j.res.statusCode,j.res.headers[m.$mob]);return j.stream}z(L,U,j){return U?(0,y.$jh)(L,"collection",U,"resource",j):(0,y.$jh)(L,"resource",j)}C(){this.s.remove(n,P.StorageScope.APPLICATION),this.s.remove(t,P.StorageScope.APPLICATION)}async D(L,U,j,F){if(!this.b)throw new m.$qob("No Auth Token Available",L,m.UserDataSyncErrorCode.Unauthorized,void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new m.$qob(`${U.type} request '${L}' failed because of too many requests (429).`,L,m.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0,void 0);this.y(void 0);const G=await this.c;U.headers={...U.headers||{},...G,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(U.headers),this.r.trace("Sending request to server",{url:L,type:U.type,headers:{...U.headers,authorization:void 0}});let V;try{V=await this.f.request(L,U,F)}catch(W){if(!(W instanceof m.$qob)){let _=m.UserDataSyncErrorCode.RequestFailed;const ne=(0,N.$_)(W).toLowerCase();ne.includes("xhr timeout")?_=m.UserDataSyncErrorCode.RequestTimeout:ne.includes("protocol")&&ne.includes("not supported")?_=m.UserDataSyncErrorCode.RequestProtocolNotSupported:ne.includes("request path contains unescaped characters")?_=m.UserDataSyncErrorCode.RequestPathNotEscaped:ne.includes("headers must be an object")?_=m.UserDataSyncErrorCode.RequestHeadersNotObject:(0,N.$6)(W)&&(_=m.UserDataSyncErrorCode.RequestCanceled),W=new m.$qob(`Connection refused for the request '${L}'.`,L,_,void 0,void 0)}throw this.r.info("Request failed",L),W}const x=V.res.headers[m.$mob],H={url:L,status:V.res.statusCode,"execution-id":U.headers[m.$nob],"operation-id":x},te=(0,w.$bq)(V)||V.res.statusCode&&j.includes(V.res.statusCode);let B="";if(te?this.r.trace("Request succeeded",H):(B=await(0,w.$dq)(V)||"",this.r.info("Request failed",H,B)),V.res.statusCode===401||V.res.statusCode===403){if(this.b=void 0,V.res.statusCode===401)throw this.g.fire(m.UserDataSyncErrorCode.Unauthorized),new m.$qob(`${U.type} request '${L}' failed because of Unauthorized (401).`,L,m.UserDataSyncErrorCode.Unauthorized,V.res.statusCode,x);if(V.res.statusCode===403)throw this.g.fire(m.UserDataSyncErrorCode.Forbidden),new m.$qob(`${U.type} request '${L}' failed because the access is forbidden (403).`,L,m.UserDataSyncErrorCode.Forbidden,V.res.statusCode,x)}if(this.h.fire(),V.res.statusCode===404)throw new m.$qob(`${U.type} request '${L}' failed because the requested resource is not found (404).`,L,m.UserDataSyncErrorCode.NotFound,V.res.statusCode,x);if(V.res.statusCode===405)throw new m.$qob(`${U.type} request '${L}' failed because the requested endpoint is not found (405). ${B}`,L,m.UserDataSyncErrorCode.MethodNotFound,V.res.statusCode,x);if(V.res.statusCode===409)throw new m.$qob(`${U.type} request '${L}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,L,m.UserDataSyncErrorCode.Conflict,V.res.statusCode,x);if(V.res.statusCode===410)throw new m.$qob(`${U.type} request '${L}' failed because the requested resource is not longer available (410).`,L,m.UserDataSyncErrorCode.Gone,V.res.statusCode,x);if(V.res.statusCode===412)throw new m.$qob(`${U.type} request '${L}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,L,m.UserDataSyncErrorCode.PreconditionFailed,V.res.statusCode,x);if(V.res.statusCode===413)throw new m.$qob(`${U.type} request '${L}' failed because of too large payload (413).`,L,m.UserDataSyncErrorCode.TooLarge,V.res.statusCode,x);if(V.res.statusCode===426)throw new m.$qob(`${U.type} request '${L}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,L,m.UserDataSyncErrorCode.UpgradeRequired,V.res.statusCode,x);if(V.res.statusCode===429){const W=V.res.headers["retry-after"];throw W?(this.y(new Date(Date.now()+parseInt(W)*1e3)),new m.$qob(`${U.type} request '${L}' failed because of too many requests (429).`,L,m.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,V.res.statusCode,x)):new m.$qob(`${U.type} request '${L}' failed because of too many requests (429).`,L,m.UserDataSyncErrorCode.TooManyRequests,V.res.statusCode,x)}if(!te)throw new m.$qob("Server returned "+V.res.statusCode,L,m.UserDataSyncErrorCode.Unknown,V.res.statusCode,x);return V}F(L){let U=this.s.get(t,P.StorageScope.APPLICATION);U===void 0&&(U=(0,$.$5g)(),this.s.store(t,U,P.StorageScope.APPLICATION,P.StorageTarget.MACHINE)),L["X-Machine-Session-Id"]=U;const j=this.s.get(n,P.StorageScope.APPLICATION);j!==void 0&&(L["X-User-Session-Id"]=j)}};e.$EOb=b,e.$EOb=b=Ee([X(1,E.$wk),X(2,w.$_p),X(3,m.$zob),X(4,l.$Pi),X(5,d.$dl),X(6,P.$mq)],b);let C=class extends b{constructor(L,U,j,F,G,V,x){super(L.userDataSyncStore?.url,U,j,F,G,V,x),this.B(L.onDidChangeUserDataSyncStore(()=>this.t(L.userDataSyncStore?.url)))}};e.$FOb=C,e.$FOb=C=Ee([X(0,m.$job),X(1,E.$wk),X(2,w.$_p),X(3,m.$zob),X(4,l.$Pi),X(5,d.$dl),X(6,P.$mq)],C);class S{constructor(L,U,j,F){this.c=L,this.d=U,this.f=j,this.g=F,this.a=[],this.b=void 0}request(L,U,j){if(this.h()&&this.i(),U.url=L,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new m.$qob(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,L,m.UserDataSyncErrorCode.LocalTooManyRequests,void 0,void 0);return this.b=this.b||new Date,this.a.push(L),this.f.request(U,j)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$GOb=S}),define(fe[235],de([0,1,3,2,9,21,23,16,128]),function(ce,e,R,a,N,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qjc=e.$pjc=e.$ojc=e.$njc=void 0;class y{constructor(l){this.a=l}listen(l,d){switch(d){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`[UserDataSyncAccountServiceChannel] Event not found: ${d}`)}call(l,d,E){switch(d){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(E)}throw new Error("Invalid call")}}e.$njc=y;class I extends a.$Xc{get account(){return this.a}get onTokenFailed(){return this.c.listen("onTokenFailed")}constructor(l){super(),this.c=l,this.b=this.B(new R.$oe),this.onDidChangeAccount=this.b.event,this.c.call("_getInitialData").then(d=>{this.a=d,this.B(this.c.listen("onDidChangeAccount")(E=>{this.a=E,this.b.fire(E)}))})}updateAccount(l){return this.c.call("updateAccount",l)}}e.$ojc=I;class p{constructor(l){this.a=l}listen(l,d){switch(d){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`[UserDataSyncStoreManagementServiceChannel] Event not found: ${d}`)}call(l,d,E){switch(d){case"switch":return this.a.switch(E[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$pjc=p;let $=class extends O.$COb{constructor(l,d,E,w){super(d,E,w),this.n=l,this.B(this.n.listen("onDidChangeUserDataSyncStore")(()=>this.j()))}async switch(l){return this.n.call("switch",[l])}async getPreviousUserDataSyncStore(){const l=await this.n.call("getPreviousUserDataSyncStore");return this.r(l)}r(l){return{url:N.URI.revive(l.url),type:l.type,defaultUrl:N.URI.revive(l.defaultUrl),insidersUrl:N.URI.revive(l.insidersUrl),stableUrl:N.URI.revive(l.stableUrl),canSwitch:l.canSwitch,authenticationProviders:l.authenticationProviders}}};e.$qjc=$,e.$qjc=$=Ee([X(1,T.$wk),X(2,A.$cj),X(3,k.$mq)],$)}),define(fe[236],de([0,1,3,57,23,16,18,231,24,83,87]),function(ce,e,R,a,N,A,T,k,O,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mjc=void 0;let p=class extends k.$7fc{constructor(g,l,d,E,w,f,P,m,c,h,i){super(g,l,d,E,w,P,m,c,h,i),this.B(R.Event.debounce(R.Event.any(R.Event.map(f.onDidFocusMainWindow,()=>"windowFocus"),R.Event.map(f.onDidOpenMainWindow,()=>"windowOpen")),(n,t)=>n?[...n,t]:[t],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$Mjc=p,e.$Mjc=p=Ee([X(0,N.$wk),X(1,O.$job),X(2,O.$kob),X(3,O.$uob),X(4,O.$vob),X(5,a.$Ihc),X(6,O.$zob),X(7,y.$9Mb),X(8,T.$cm),X(9,I.$9nb),X(10,A.$mq)],p)}),define(fe[237],de([0,1,76,22,5,20]),function(ce,e,R,a,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8gc=void 0,e.$9gc=T,e.$0gc=k,e.$$gc=O,e.$8gc=128/4;function T(y){function I(){let p=y.scheme===a.Schemas.file?(0,A.$0g)(y):y.toString();return N.$l||(p=p.toLowerCase()),(0,R.createHash)("md5").update(p).digest("hex")}return{id:I(),configPath:y}}function k(y,I){function p(){if(y.scheme!==a.Schemas.file)return(0,R.createHash)("md5").update(y.toString()).digest("hex");if(!I)return;let g;return N.$l?g=I.ino:N.$k?g=I.birthtime.getTime():N.$j&&(typeof I.birthtimeMs=="number"?g=Math.floor(I.birthtimeMs):g=I.birthtime.getTime()),(0,R.createHash)("md5").update(y.fsPath).update(g?String(g):"").digest("hex")}const $=p();if(typeof $=="string")return{id:$,uri:y}}function O(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(fe[238],de([0,1,6,8,2,13,30,15,10,80,117,237,57,56,22]),function(ce,e,R,a,N,A,T,k,O,y,I,p,$,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jjc=void 0;let d=class extends N.$Xc{constructor(w,f,P,m){super(),this.a=w,this.b=f,this.c=P,this.f=m,this.B(new R.$Uh(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const w=this.a.workspaceStorageHome.with({scheme:l.Schemas.file}).fsPath,f=await T.Promises.readdir(w),P=new y.$HNb(this.f.getChannel("storage"));await Promise.all(f.map(async m=>{const c=(0,A.$mc)(w,m);m.length===p.$8gc||m===I.$Ui.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(n=>n.workspace?.id===m)||await P.isUsed(c)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${m} as it seems to be an unused empty workspace.`),await T.Promises.rm(c))}))}catch(w){(0,a.$2)(w)}}};e.$jjc=d,e.$jjc=d=Ee([X(0,k.$Qi),X(1,O.$dk),X(2,$.$Ihc),X(3,g.$1ic)],d)}),define(fe[129],de([0,1,76,68,38,246,14,8,3,2,13,5,32,42,70]),function(ce,e,R,a,N,A,T,k,O,y,I,p,$,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$zi=e.$yi=e.$xi=void 0,e.$Ai=t,e.$Bi=s,e.$Di=u,e.$Ei=b;const d=3e4;class E{traceSocketEvent(S,v){l.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,S,v)}constructor(S,v=""){this.f=!0,this.debugLabel=v,this.socket=S,this.traceSocketEvent(l.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=U=>{if(this.traceSocketEvent(l.SocketDiagnosticsEventType.Error,{code:U?.code,message:U?.message}),U){if(U.code==="EPIPE")return;(0,k.$2)(U)}},this.socket.on("error",this.a);let L;this.b=U=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.Close,{hadError:U}),this.f=!1,L&&clearTimeout(L)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,L=setTimeout(()=>S.destroy(),d)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(S){const v=L=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.Read,L),S(T.$Qe.wrap(L))};return this.socket.on("data",v),{dispose:()=>this.socket.off("data",v)}}onClose(S){const v=L=>{S({type:l.SocketCloseEventType.NodeSocketCloseEvent,hadError:L,error:void 0})};return this.socket.on("close",v),{dispose:()=>this.socket.off("close",v)}}onEnd(S){const v=()=>{S()};return this.socket.on("end",v),{dispose:()=>this.socket.off("end",v)}}write(S){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(l.SocketDiagnosticsEventType.Write,S),this.socket.write(S.buffer,v=>{if(v){if(v.code==="EPIPE")return;(0,k.$2)(v)}})}catch(v){if(v.code==="EPIPE")return;(0,k.$2)(v)}}end(){this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((S,v)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainEnd),S();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainEnd),S()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.$xi=E;var w;(function(C){C[C.MinHeaderByteSize=2]="MinHeaderByteSize",C[C.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(w||(w={}));var f;(function(C){C[C.PeekHeader=1]="PeekHeader",C[C.ReadHeader=2]="ReadHeader",C[C.ReadBody=3]="ReadBody",C[C.Fin=4]="Fin"})(f||(f={}));class P extends y.$Xc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(S,v){this.socket.traceSocketEvent(S,v)}constructor(S,v,L,U){super(),this.f=this.B(new O.$oe),this.g=this.B(new O.$oe),this.h=!1,this.j={state:f.PeekHeader,readLen:w.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=S,this.traceSocketEvent(l.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:v,inflateBytesLength:L?.byteLength||0,recordInflateBytes:U}),this.a=this.B(new m(this,v,L,U,this.f,(j,F)=>this.m(j,F))),this.B(this.a.onError(j=>{console.error(j),(0,k.$2)(j),this.g.fire({type:l.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:j})})),this.b=new l.$si,this.B(this.socket.onData(j=>this.n(j))),this.B(this.socket.onClose(async j=>{this.a.isProcessingReadQueue()&&await O.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(j)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(S){return this.f.event(S)}onClose(S){return this.g.event(S)}onEnd(S){return this.socket.onEnd(S)}write(S){let v=0;for(;v<S.byteLength;)this.a.writeMessage(S.slice(v,Math.min(v+w.MaxWebSocketMessageLength,S.byteLength)),{compressed:!0,opcode:2}),v+=w.MaxWebSocketMessageLength}m(S,{compressed:v,opcode:L}){if(this.h)return;this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,S);let U=w.MinHeaderByteSize;S.byteLength<126?U+=0:S.byteLength<2**16?U+=2:U+=8;const j=T.$Qe.alloc(U),F=v?64:0,G=L&15;if(j.writeUInt8(128|F|G,0),S.byteLength<126)j.writeUInt8(S.byteLength,1);else if(S.byteLength<2**16){j.writeUInt8(126,1);let V=1;j.writeUInt8(S.byteLength>>>8&255,++V),j.writeUInt8(S.byteLength>>>0&255,++V)}else{j.writeUInt8(127,1);let V=1;j.writeUInt8(0,++V),j.writeUInt8(0,++V),j.writeUInt8(0,++V),j.writeUInt8(0,++V),j.writeUInt8(S.byteLength>>>24&255,++V),j.writeUInt8(S.byteLength>>>16&255,++V),j.writeUInt8(S.byteLength>>>8&255,++V),j.writeUInt8(S.byteLength>>>0&255,++V)}this.socket.write(T.$Qe.concat([j,S]))}end(){this.h=!0,this.socket.end()}n(S){if(S.byteLength!==0){for(this.b.acceptChunk(S);this.b.byteLength>=this.j.readLen;)if(this.j.state===f.PeekHeader){const v=this.b.peek(this.j.readLen),L=v.readUInt8(0),U=(L&128)>>>7,j=(L&64)>>>6,F=L&15,G=v.readUInt8(1),V=(G&128)>>>7,x=G&127;this.j.state=f.ReadHeader,this.j.readLen=w.MinHeaderByteSize+(V?4:0)+(x===126?2:0)+(x===127?8:0),this.j.fin=U,this.j.firstFrameOfMessage&&(this.j.compressed=!!j),this.j.firstFrameOfMessage=!!U,this.j.mask=0,this.j.opcode=F,this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===f.ReadHeader){const v=this.b.read(this.j.readLen),L=v.readUInt8(1),U=(L&128)>>>7;let j=L&127,F=1;j===126?j=v.readUInt8(++F)*2**8+v.readUInt8(++F):j===127&&(j=v.readUInt8(++F)*0+v.readUInt8(++F)*0+v.readUInt8(++F)*0+v.readUInt8(++F)*0+v.readUInt8(++F)*2**24+v.readUInt8(++F)*2**16+v.readUInt8(++F)*2**8+v.readUInt8(++F));let G=0;U&&(G=v.readUInt8(++F)*2**24+v.readUInt8(++F)*2**16+v.readUInt8(++F)*2**8+v.readUInt8(++F)),this.j.state=f.ReadBody,this.j.readLen=j,this.j.mask=G,this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===f.ReadBody){const v=this.b.read(this.j.readLen);this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,v),i(v,this.j.mask),this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,v),this.j.state=f.PeekHeader,this.j.readLen=w.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(v,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(v,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await O.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$yi=P;class m extends y.$Xc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:T.$Qe.alloc(0)}constructor(S,v,L,U,j,F){super(),this.n=S,this.r=j,this.s=F,this.a=this.B(new O.$oe),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new O.$oe),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new O.$oe),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,v?(this.b=this.B(new c(this.n,U,L,{windowBits:15})),this.f=this.B(new h(this.n,{windowBits:15})),this.B(this.b.onError(G=>this.a.fire(G))),this.B(this.f.onError(G=>this.a.fire(G)))):(this.b=null,this.f=null)}writeMessage(S,v){this.g.push({data:S,options:v}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:S,options:v}=this.g.shift();if(this.f&&v.compressed){const L=await this.w(this.f,S);this.s(L,v)}else this.s(S,{...v,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(S,v){return new Promise((L,U)=>{S.write(v),S.flush(j=>L(j))})}acceptFrame(S,v,L){this.h.push({data:S,isCompressed:v,isLastFrameOfMessage:L}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const S=this.h.shift();if(this.b&&S.isCompressed){const v=await this.C(this.b,S.data,S.isLastFrameOfMessage);this.r.fire(v)}else this.r.fire(S.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(S,v,L){return new Promise((U,j)=>{S.write(v),L&&S.write(T.$Qe.fromByteArray([0,0,255,255])),S.flush(F=>U(F))})}}class c extends y.$Xc{get recordedInflateBytes(){return this.j?T.$Qe.concat(this.f):T.$Qe.alloc(0)}constructor(S,v,L,U){super(),this.h=S,this.j=v,this.a=this.B(new O.$oe),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(U),this.b.on("error",j=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateError,{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateData,j),this.g.push(T.$Qe.wrap(j))}),L&&(this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateInitialWrite,L.buffer),this.b.write(L.buffer),this.b.flush(()=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(S){this.j&&this.f.push(S.clone()),this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateWrite,S),this.b.write(S.buffer)}flush(S){this.b.flush(()=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateFlushFired);const v=T.$Qe.concat(this.g);this.g.length=0,S(v)})}}class h extends y.$Xc{constructor(S,v){super(),this.g=S,this.a=this.B(new O.$oe),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",L=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateError,{message:L?.message,code:L?.code}),this.a.fire(L)}),this.b.on("data",L=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateData,L),this.f.push(T.$Qe.wrap(L))})}write(S){this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateWrite,S.buffer),this.b.write(S.buffer)}flush(S){this.b.flush(2,()=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateFlushFired);let v=T.$Qe.concat(this.f);this.f.length=0,v=v.slice(0,v.byteLength-4),S(v)})}}function i(C,S){if(S===0)return;const v=C.byteLength>>>2;for(let V=0;V<v;V++){const x=C.readUInt32BE(V*4);C.writeUInt32BE(x^S,V*4)}const L=v*4,U=C.byteLength-L,j=S>>>24&255,F=S>>>16&255,G=S>>>8&255;U>=1&&C.writeUInt8(C.readUInt8(L)^j,L),U>=2&&C.writeUInt8(C.readUInt8(L+1)^F,L+1),U>=3&&C.writeUInt8(C.readUInt8(L+2)^G,L+2)}e.$zi=process.env.XDG_RUNTIME_DIR;const n={[p.Platform.Linux]:107,[p.Platform.Mac]:103};function t(){const C=(0,$.$5g)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${C}-sock`;const S=process.platform!=="darwin"&&e.$zi?e.$zi:(0,N.tmpdir)(),v=(0,I.$mc)(S,`vscode-ipc-${C}.sock`);return r(v),v}function s(C,S,v){const U=(0,R.createHash)("sha256").update(C).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${U}-${v}-${S}-sock`;const j=v.substr(0,4),F=S.substr(0,6);let G;return process.platform!=="darwin"&&e.$zi&&!process.env.VSCODE_PORTABLE?G=(0,I.$mc)(e.$zi,`vscode-${U}-${j}-${F}.sock`):G=(0,I.$mc)(C,`${j}-${F}.sock`),r(G),G}function r(C){const S=n[p.$v];typeof S=="number"&&C.length>=S&&console.warn(`WARNING: IPC handle "${C}" is longer than ${S} chars, try a shorter --user-data-dir`)}class o extends g.$mi{static b(S){const v=O.Event.fromNodeEventEmitter(S,"connection");return O.Event.map(v,L=>({protocol:new l.$ti(new E(L,"ipc-server-connection")),onDidClientDisconnect:O.Event.once(O.Event.fromNodeEventEmitter(L,"close"))}))}constructor(S){super(o.b(S)),this.d=S}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Ci=o;function u(C){return new Promise((S,v)=>{const L=(0,a.createServer)();L.on("error",v),L.listen(C,()=>{L.removeListener("error",v),S(new o(L))})})}function b(C,S){return new Promise((v,L)=>{const U=(0,a.createConnection)(C,()=>{U.removeListener("error",L),v(l.$ui.fromSocket(new E(U,`ipc-client${S}`),S))});U.once("error",L)})}}),define(fe[239],de([0,1,68,129,186]),function(ce,e,R,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pjc=void 0,R=Oe(R),e.$Pjc=new class{supports(A){return!0}connect({host:A,port:T},k,O,y){return new Promise((I,p)=>{const $=R.createConnection({host:A,port:T},()=>{$.removeListener("error",p),$.write((0,N.$9xb)(k,O,y));const g=l=>{l.toString().indexOf(`\r
\r
`)>=0&&($.off("data",g),I(new a.$xi($,y)))};$.on("data",g)});$.setNoDelay(!0),$.once("error",p)})}}}),define(fe[240],de([0,1,68,38,147,129,6,2,5,21,10,23,187,108,110,81,14]),function(ce,e,R,a,N,A,T,k,O,y,I,p,$,g,l,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uic=e.$Tic=e.$Sic=e.$Ric=void 0,R=Oe(R),a=Oe(a);async function w(h,i,n,t,s){let r;for(let o=3;o&&(r?.dispose(),r=await new f(h,i,n,t,s).waitForReady(),!(s&&N.$8g[s]||!N.$8g[r.tunnelLocalPort]));o--);return r}class f extends k.$Xc{constructor(i,n,t,s,r){super(),this.m=n,this.n=r,this.privacy=d.TunnelPrivacyId.Private,this.j=new Map,this.a=i,this.b=R.createServer(),this.c=new T.$Hh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=o=>this.r(o),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=s,this.tunnelRemoteHost=t}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(n=>{n()})}async waitForReady(){const i=this.n??this.tunnelRemotePort,n=(0,d.$Tw)(this.m)?"0.0.0.0":"127.0.0.1";let t=await(0,N.$9g)(i,2,1e3,n),s=null;return this.b.listen(t,this.m),await this.c.wait(),s=this.b.address(),s||(t=0,this.b.listen(t,this.m),await this.c.wait(),s=this.b.address()),this.tunnelLocalPort=s.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${s.port}`,this}async r(i){i.pause();const n=(0,d.$Rw)(this.tunnelRemoteHost)||(0,d.$Tw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,t=await(0,$.$6l)(this.a,n,this.tunnelRemotePort),s=t.getSocket(),r=t.readEntireBuffer();t.dispose(),r.byteLength>0&&i.write(r.buffer),i.on("end",()=>{i.localAddress&&this.j.delete(i.localAddress),s.end()}),i.on("close",()=>s.end()),i.on("error",()=>{i.localAddress&&this.j.delete(i.localAddress),s instanceof A.$xi?s.socket.destroy():s.end()}),s instanceof A.$xi?this.t(i,s):this.s(i,s),i.localAddress&&this.j.set(i.localAddress,()=>{i.end(),s.end()})}s(i,n){n.onClose(()=>i.destroy()),n.onEnd(()=>i.end()),n.onData(t=>i.write(t.buffer)),i.on("data",t=>n.write(E.$Qe.wrap(t))),i.resume()}t(i,n){const t=n.socket;t.on("end",()=>i.end()),t.on("close",()=>i.end()),t.on("error",()=>{i.destroy()}),t.pipe(i),i.pipe(t)}}e.$Ric=f;let P=class extends d.$Ww{constructor(i,n,t,s,r){super(n,r),this.H=i,this.I=t,this.J=s}isPortPrivileged(i){return(0,d.$Uw)(i,this.t,O.OS,a.release())}F(i,n,t,s,r,o,u,b){const C=this.D(n,t);if(C)return++C.refcount,C.value;if((0,d.$Nw)(i))return this.G(i,n,t,r,o,u,b);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${t} on local port ${r}.`);const S={commit:this.J.commit,quality:this.J.quality,addressProvider:i,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},v=w(S,s,n,t,r);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(n,t,v),v}}};e.$Sic=P,e.$Sic=P=Ee([X(0,g.$Zl),X(1,I.$dk),X(2,l.$3l),X(3,p.$wk),X(4,y.$cj)],P);let m=class extends P{constructor(i,n,t,s,r){super(i,n,t,s,r)}};e.$Tic=m,e.$Tic=m=Ee([X(0,g.$Zl),X(1,I.$dk),X(2,l.$3l),X(3,p.$wk),X(4,y.$cj)],m);let c=class extends k.$Xc{constructor(i,n,t,s,r){super(),this.b=i,this.c=n,this.f=t,this.g=s,this.h=r,this.a=new Map}async openTunnel(i,n,t,s,r,o,u,b,C){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${t}:${s} on local port ${o}.`),!this.a.has(i)){const S=new m(this.b,this.c,this.g,this.f,this.h);this.B(S),this.a.set(i,S),S.onTunnelClosed(async()=>{(await S.tunnels).length===0&&(S.dispose(),this.a.delete(i))})}return this.a.get(i).openTunnel(n,t,s,r,o,u,b,C)}};e.$Uic=c,e.$Uic=c=Ee([X(0,g.$Zl),X(1,I.$dk),X(2,p.$wk),X(3,l.$3l),X(4,y.$cj)],c)});var it=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(fe[247],de([0,1,38,43,8,2,22,9,17,3,42,152,180,181,190,172,238,163,164,21,185,99,197,100,192,15,120,224,27,112,188,119,75,7,174,175,74,4,171,77,79,200,10,176,104,23,61,16,111,18,113,114,115,48,203,86,116,24,83,230,235,213,87,229,233,234,128,62,228,214,110,196,81,240,191,204,28,205,5,206,165,183,182,85,219,19,52,179,58,227,202,215,109,232,220,11,177,103,225,218,193,159,57,178,236,222,56,226,108,106,239,157,194,145,134,144]),function(ce,e,R,a,N,A,T,k,O,y,I,p,$,g,l,d,E,w,f,P,m,c,h,i,n,t,s,r,o,u,b,C,S,v,L,U,j,F,G,V,x,H,te,B,W,_,ne,le,ee,J,K,q,D,Q,oe,Z,Y,M,z,ie,ae,ue,pe,be,Re,Ae,ye,we,re,he,me,Se,Pe,De,Ce,Ne,Ue,Me,Ve,Fe,Be,ze,We,Le,se,ge,$e,ve,ke,Te,qe,xe,Qe,Xe,He,_e,Ye,nt,at,Nt,Ct,Lt,Tt,Dt,jt,Ut,yt,Ft,vt,Mt,qt,Bt,ht,zt,Wt,Et){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=St,W=it(W);class Vt extends A.$Xc{constructor(Ie){super(),this.f=Ie,this.a=this.B(new p.$tY(this)),this.b=void 0,this.c=this.B(new y.$oe),this.g()}g(){let Ie=!1;const je=()=>{Ie||(Ie=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",je),(0,p.$uY)(process.parentPort,ht.$5hc.exit,je)}async init(){const Ie=await this.h();(0,M.$eob)(),Ie.invokeFunction(je=>{const Ke=je.get(te.$dk),Ge=je.get(J.$cm),et=je.get(ge.$Pl);Ke.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(je),this.m(Ke),this.n(Ge,et),this.B(et.onDidChangeProfiles(()=>this.n(Ge,et))),this.r(Ge,Ke)}),this.B((0,A.$Uc)(Ie.createInstance($.$fjc,this.f.codeCachePath),Ie.createInstance(g.$gjc),Ie.createInstance(E.$jjc),Ie.createInstance(d.$ijc),Ie.createInstance(l.$hjc),Ie.createInstance(He.$Gjc),Ie.createInstance(xe.$yjc)))}async h(){const Ie=new V.$Gi,je={_serviceBrand:void 0,...W.default};Ie.set(_.$wk,je);const Ke=new I.$qi(Ze=>Ze==="main"),Ge=new yt.$2ic(this.a,Ke);Ie.set(yt.$1ic,Ge);const et=this.f.policiesData?new ve.$vic(this.f.policiesData,Ge.getChannel("policy")):new ke.$zo;Ie.set(ke.$xo,et);const Je=new Bt.$an(this.f.args,je);Ie.set(t.$Qi,Je);const ot=new B.$zs(void 0,this.f.logLevel,Je.logsHome,this.f.loggers.map(Ze=>({...Ze,resource:k.URI.revive(Ze.resource)})),Ge.getChannel("logger"));Ie.set(te.$ek,ot);const ft=this.B(ot.createLogger("sharedprocess",{name:(0,_e.localize)(172,null)})),$t=this.B(new te.$lk(ft.getLevel())),tt=this.B(new Ye.$4R(ft,[$t]));Ie.set(te.$dk,tt),this.b=this.B(new nt.$Ijc(tt)),Ie.set(nt.$Hjc,this.b);const st=this.B(new L.$9q(tt));Ie.set(v.$dl,st);const pt=this.B(new U.$zr(tt));st.registerProvider(T.Schemas.file,pt);const dt=new Me.$1s(st);Ie.set(Ue.$Nl,dt);const rt=this.B(new Te.$$R(this.f.profiles.all,k.URI.revive(this.f.profiles.home).with({scheme:Je.userRoamingDataHome.scheme}),Ge.getChannel("userDataProfiles")));Ie.set(ge.$Pl,rt);const wt=this.B(new Fe.$Zic(T.Schemas.file,this.B(new Be.$MR(Ge.getChannel(Be.$LR),{pathCaseSensitive:Ve.$l})),T.Schemas.vscodeUserData,rt,dt,tt));st.registerProvider(T.Schemas.vscodeUserData,wt);const ct=this.B(new m.$2o(rt.defaultProfile.settingsResource,st,et,tt));Ie.set(P.$cj,ct);const bt=new Ft.$Ojc(void 0,{defaultProfile:rt.defaultProfile,currentProfile:rt.defaultProfile},Ge,Je);Ie.set(le.$mq,bt),this.B((0,A.$Vc)(()=>bt.flush())),await Promise.all([ct.initialize(),bt.initialize()]);const It=new Ct.$js(Ge.getChannel("request"));Ie.set(ne.$_p,It),Ie.set(w.$kjc,new j.$Fi(f.$ljc,void 0,!1)),Ie.set(We.$dH,new j.$Fi(ze.$xjc,void 0,!1));const Rt=new Dt.$4ic(-1,Ge);Ie.set(Tt.$Ihc,Rt),Ie.set(i.$6o,new j.$Fi(n.$iS,void 0,!0));const Gt=this.B(new he.$sic(Rt)),Kt=new I.$qi(Ze=>Gt.getActiveClientId().then(mt=>Ze===mt));Ie.set(S.$s8b,new Lt.$Kjc(this.a.getChannel("extensionRecommendationNotification",Kt)));let gt;const lt=[],Pt=(0,Q.$Np)(je,ct);if((0,Q.$Ip)(je,Je)){const Ze=new q.$lfc(tt,ot,Je,je);if(lt.push(Ze),!(0,Q.$Jp)(je,Je)&&je.aiConfig?.ariaKey){const mt=new qe.$RR(It,Pt,"monacoworkbench",null,je.aiConfig.ariaKey);this.B((0,A.$Vc)(()=>mt.flush())),lt.push(mt)}gt=new D.$ns({appenders:lt,commonProperties:(0,ee.$zp)((0,R.release)(),(0,R.hostname)(),process.arch,je.commit,je.version,this.f.machineId,this.f.sqmId,this.f.devDeviceId,Pt),sendErrorTelemetry:!0,piiPaths:(0,Q.$Op)(Je)},ct,je)}else{gt=Q.$Dp;const Ze=Q.$Hp;lt.push(Ze)}this.a.registerChannel("telemetryAppender",new K.$0hc(lt)),Ie.set(J.$cm,gt);const Qt=new oe.$mjc(ct,gt,tt,ot,Je,je);Ie.set(J.$dm,Qt),Ie.set($e.$Pq,new j.$Fi(Nt.$3R,void 0,!0)),Ie.set(Le.$Tq,new j.$Fi(se.$wic,void 0,!0)),Ie.set(u.$zq,new j.$Fi(u.$Bq,void 0,!0)),Ie.set(C.$5q,new j.$Fi(C.$6q,void 0,!0)),Ie.set(o.$pp,new j.$Fi(r.$vq,void 0,!0)),Ie.set(o.$wp,new j.$Fi(Ut.$Njc,void 0,!1)),Ie.set(x.$fs,new j.$Fi(H.$hs,void 0,!1)),Ie.set(c.$Wm,new j.$Fi(h.$8s,void 0,!1)),Ie.set(z.$9Mb,new j.$Fi(z.$0Mb,void 0,!0)),Ie.set(M.$zob,new j.$Fi(ue.$FPb,void 0,!0)),Ie.set(M.$yob,I.ProxyChannel.toService(this.a.getChannel("userDataSyncUtil",Ze=>Ze.ctx!=="main"))),Ie.set(o.$vp,new j.$Fi(s.$7Mb,void 0,!1)),Ie.set(Y.$DPb,new j.$Fi(Y.$EPb,void 0,!0)),Ie.set(Z.$xw,new j.$Fi(Z.$yw)),Ie.set(M.$job,new j.$Fi(ye.$DOb,void 0,!0)),Ie.set(M.$kob,new j.$Fi(ye.$FOb,void 0,!0)),Ie.set(pe.$9nb,new j.$Fi(pe.$$nb,void 0,!0)),Ie.set(M.$lob,new j.$Fi(ie.$1fc,void 0,!1)),Ie.set(M.$uob,new j.$Fi(be.$Pfc,void 0,!0)),Ie.set(M.$vob,new j.$Fi(Re.$6fc,void 0,!1)),Ie.set(we.$INb,new j.$Fi(re.$tjc,void 0,!0)),Ie.set(M.$wob,new j.$Fi(Xe.$Kgc,void 0,!0)),Ie.set(me.$3l,new j.$Fi(Se.$Wic,void 0,!1));const Ot=new vt.$1l;return Ie.set(vt.$Zl,Ot),Ot.register(Mt.RemoteConnectionType.WebSocket,qt.$Pjc),Ie.set(Pe.$Mw,new j.$Fi(De.$Uic)),Ie.set(Ce.$ujc,new j.$Fi(Ne.$wjc)),Ie.set(Qe.$zjc,new j.$Fi(at.$Jjc)),new G.$Cr(Ie)}j(Ie){const je=new b.$Dq(Ie.get(o.$sp),()=>null);this.a.registerChannel("extensions",je);const Ke=I.ProxyChannel.fromService(Ie.get(x.$fs),this.q);this.a.registerChannel("languagePacks",Ke);const Ge=I.ProxyChannel.fromService(Ie.get(c.$Wm),this.q);this.a.registerChannel("diagnostics",Ge);const et=new b.$Fq(Ie.get(o.$wp));this.a.registerChannel("extensionTipsService",et);const Je=I.ProxyChannel.fromService(Ie.get(w.$kjc),this.q);this.a.registerChannel("checksum",Je);const ot=I.ProxyChannel.fromService(Ie.get(We.$dH),this.q);this.a.registerChannel("v8InspectProfiling",ot);const ft=I.ProxyChannel.fromService(Ie.get(pe.$9nb),this.q);this.a.registerChannel("userDataSyncMachines",ft);const $t=I.ProxyChannel.fromService(Ie.get(J.$dm),this.q);this.a.registerChannel("customEndpointTelemetry",$t);const tt=new ae.$njc(Ie.get(z.$9Mb));this.a.registerChannel("userDataSyncAccount",tt);const st=new ae.$pjc(Ie.get(M.$job));this.a.registerChannel("userDataSyncStoreManagement",st);const pt=new Ae.$rjc(Ie.get(M.$vob),Ie.get(ge.$Pl),Ie.get(te.$dk));this.a.registerChannel("userDataSync",pt);const dt=this.B(Ie.get(F.$Hi).createInstance(jt.$Mjc));this.a.registerChannel("userDataAutoSync",I.ProxyChannel.fromService(dt,this.q)),this.a.registerChannel("IUserDataSyncResourceProviderService",I.ProxyChannel.fromService(Ie.get(M.$wob),this.q));const rt=I.ProxyChannel.fromService(Ie.get(Ce.$ujc),this.q);this.a.registerChannel(Ce.$vjc,rt);const wt=I.ProxyChannel.fromService(Ie.get(Qe.$zjc),this.q);this.a.registerChannel("remoteTunnel",wt)}m(Ie){process.on("uncaughtException",je=>(0,N.$2)(je)),process.on("unhandledRejection",je=>(0,N.$2)(je)),(0,N.setUnexpectedErrorHandler)(je=>{const Ke=(0,a.$tj)(je,!0);Ke&&Ie.error(`[uncaught exception in sharedProcess]: ${Ke}`)})}n(Ie,je){Ie.publicLog2("profilesInfo",{count:je.profiles.length})}async r(Ie,je){if(Ve.$l){const[Ke,Ge]=await Promise.all([(0,zt.$6g)(je.error.bind(je)),(0,Et.$bY)(je.error.bind(je))]),et=(0,Wt.$QX)(),Je=(0,Et.$cY)(Ge,this.f.args["ozone-platform"]);Ke&&Ie.publicLog2("clientPlatformInfo",{platformId:Ke.id,platformVersionId:Ke.version_id,platformIdLike:Ke.id_like,desktopEnvironment:et,displayProtocol:Ge,codeDisplayProtocol:Je})}}handledClientConnection(Ie){if(Ie.data!==ht.$7hc.response)return!1;const je=(0,O.$Qb)(Ie.ports);return je?(this.c.fire(je),!0):!1}}async function St(ut){try{const Ie=new Vt(ut);process.parentPort.postMessage(ht.$5hc.ipcReady),await Ie.init(),process.parentPort.postMessage(ht.$5hc.initDone)}catch(Ie){process.parentPort.postMessage({error:Ie.toString()})}}const Ht=setTimeout(()=>{process.parentPort.postMessage({warning:"[SharedProcess] did not receive configuration within 30s..."})},3e4);process.parentPort.once("message",ut=>{clearTimeout(Ht),St(ut.data)})})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/c2aa3c4625ed4b46448fa546ac5f2e93b0757718/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
