/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Re=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/async","vs/nls","vs/workbench/api/common/extHostTypes","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/base/common/charCode","vs/platform/files/common/files","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/extpath","vs/base/common/uuid","vs/base/node/pfs","vs/workbench/api/common/extHostCommands","vs/workbench/services/search/common/search","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/iterator","vs/base/common/marshallingIds","vs/workbench/api/common/extHostConfiguration","vs/base/common/stopwatch","vs/base/common/severity","fs","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","child_process","vs/editor/common/core/position","vs/editor/common/model","vs/workbench/services/search/common/searchExtTypes","vs/base/common/decorators","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","os","net","vs/base/parts/ipc/common/ipc.net","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/codicons","vs/base/common/uint","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/progress/common/progress","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/common/codiconsUtil","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/textModelSearch","vs/platform/instantiation/common/descriptors","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/serviceCollection","vs/platform/product/common/productService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/comparers","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/iconLabels","vs/amdX","vs/base/common/uriIpc","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/services/semanticTokensDto","vs/platform/extensions/common/extensionsApiProposals","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/platform/telemetry/common/telemetry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/common/editor","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtConversionTypes","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/equals","vs/base/common/json","vs/base/common/jsonSchema","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/scrollable","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/console","vs/base/common/dataTransfer","vs/base/node/ports","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/base/common/actions","vs/base/common/date","vs/platform/contextkey/common/scanner","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensionValidator","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/request/common/request","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguageModelTools","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ce=function(ge){for(var e=[],s=0,h=ge.length;s<h;s++)e[s]=Re[ge[s]];return e};define(Re[131],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=e.LoaderEventType=e.$U=e.$T=void 0,e.$T=!1,e.$U=!0;var s;(function(R){R[R.LoaderAvailable=1]="LoaderAvailable",R[R.BeginLoadingScript=10]="BeginLoadingScript",R[R.EndLoadingScriptOK=11]="EndLoadingScriptOK",R[R.EndLoadingScriptError=12]="EndLoadingScriptError",R[R.BeginInvokeFactory=21]="BeginInvokeFactory",R[R.EndInvokeFactory=22]="EndInvokeFactory",R[R.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",R[R.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",R[R.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",R[R.NodeEndNativeRequire=34]="NodeEndNativeRequire",R[R.CachedDataFound=60]="CachedDataFound",R[R.CachedDataMissed=61]="CachedDataMissed",R[R.CachedDataRejected=62]="CachedDataRejected",R[R.CachedDataCreated=63]="CachedDataCreated"})(s||(e.LoaderEventType=s={}));class h{static get(){const A=new Map,O=new Map,C=new Map,m=new Map;function c(b,a){b.has(a.detail)||b.set(a.detail,-a.timestamp)}function I(b,a){const $=b.get(a.detail);$&&($>=0||b.set(a.detail,$+a.timestamp))}let E=[];typeof ge=="function"&&typeof ge.getStats=="function"&&(E=ge.getStats().slice(0).sort((b,a)=>b.timestamp-a.timestamp));for(const b of E)switch(b.type){case s.BeginLoadingScript:c(A,b);break;case s.EndLoadingScriptOK:case s.EndLoadingScriptError:I(A,b);break;case s.BeginInvokeFactory:c(O,b);break;case s.EndInvokeFactory:I(O,b);break;case s.NodeBeginNativeRequire:c(C,b);break;case s.NodeEndNativeRequire:I(C,b);break;case s.NodeBeginEvaluatingScript:c(m,b);break;case s.NodeEndEvaluatingScript:I(m,b);break}let g=0;C.forEach(b=>g+=b);function P(b){const a=[];return b.forEach(($,p)=>a.push([p,$])),a}return{amdLoad:P(A),amdInvoke:P(O),nodeRequire:P(C),nodeEval:P(m),nodeRequireTotal:g}}static toMarkdownTable(A,O){let C="";const m=[];return A.forEach((c,I)=>{m[I]=c.length}),O.forEach(c=>{c.forEach((I,E)=>{typeof I>"u"&&(I=c[E]="-");const g=I.toString().length;m[E]=Math.max(g,m[E])})}),A.forEach((c,I)=>{C+=`| ${c+" ".repeat(m[I]-c.toString().length)} `}),C+=`|
`,A.forEach((c,I)=>{C+=`| ${"-".repeat(m[I])} `}),C+=`|
`,O.forEach(c=>{c.forEach((I,E)=>{typeof I<"u"&&(C+=`| ${I+" ".repeat(m[E]-I.toString().length)} `)}),C+=`|
`}),C}}e.$V=h}),define(Re[132],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ob=void 0,e.$hb=s,e.$ib=h,e.$jb=R,e.$kb=A,e.$lb=O,e.$mb=C,e.$nb=m,e.$pb=I,e.$qb=E,e.$rb=g,e.$sb=P,e.$tb=b;function s(a,$){const p=h(a,$);if(p!==-1)return a[p]}function h(a,$,p=a.length-1){for(let u=p;u>=0;u--){const i=a[u];if($(i))return u}return-1}function R(a,$){const p=A(a,$);return p===-1?void 0:a[p]}function A(a,$,p=0,u=a.length){let i=p,o=u;for(;i<o;){const t=Math.floor((i+o)/2);$(a[t])?i=t+1:o=t}return i-1}function O(a,$){const p=C(a,$);return p===a.length?void 0:a[p]}function C(a,$,p=0,u=a.length){let i=p,o=u;for(;i<o;){const t=Math.floor((i+o)/2);$(a[t])?o=t:i=t+1}return i}function m(a,$,p=0,u=a.length){const i=C(a,$,p,u);return i===a.length?-1:i}class c{static{this.assertInvariants=!1}constructor($){this.e=$,this.c=0}findLastMonotonous($){if(c.assertInvariants){if(this.d){for(const u of this.e)if(this.d(u)&&!$(u))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=$}const p=A(this.e,$,this.c);return this.c=p+1,p===-1?void 0:this.e[p]}}e.$ob=c;function I(a,$){if(a.length===0)return;let p=a[0];for(let u=1;u<a.length;u++){const i=a[u];$(i,p)>0&&(p=i)}return p}function E(a,$){if(a.length===0)return;let p=a[0];for(let u=1;u<a.length;u++){const i=a[u];$(i,p)>=0&&(p=i)}return p}function g(a,$){return I(a,(p,u)=>-$(p,u))}function P(a,$){if(a.length===0)return-1;let p=0;for(let u=1;u<a.length;u++){const i=a[u];$(i,a[p])>0&&(p=u)}return p}function b(a,$){for(const p of a){const u=$(p);if(u!==void 0)return u}}}),define(Re[26],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var s;(function(h){h[h.Null=0]="Null",h[h.Backspace=8]="Backspace",h[h.Tab=9]="Tab",h[h.LineFeed=10]="LineFeed",h[h.CarriageReturn=13]="CarriageReturn",h[h.Space=32]="Space",h[h.ExclamationMark=33]="ExclamationMark",h[h.DoubleQuote=34]="DoubleQuote",h[h.Hash=35]="Hash",h[h.DollarSign=36]="DollarSign",h[h.PercentSign=37]="PercentSign",h[h.Ampersand=38]="Ampersand",h[h.SingleQuote=39]="SingleQuote",h[h.OpenParen=40]="OpenParen",h[h.CloseParen=41]="CloseParen",h[h.Asterisk=42]="Asterisk",h[h.Plus=43]="Plus",h[h.Comma=44]="Comma",h[h.Dash=45]="Dash",h[h.Period=46]="Period",h[h.Slash=47]="Slash",h[h.Digit0=48]="Digit0",h[h.Digit1=49]="Digit1",h[h.Digit2=50]="Digit2",h[h.Digit3=51]="Digit3",h[h.Digit4=52]="Digit4",h[h.Digit5=53]="Digit5",h[h.Digit6=54]="Digit6",h[h.Digit7=55]="Digit7",h[h.Digit8=56]="Digit8",h[h.Digit9=57]="Digit9",h[h.Colon=58]="Colon",h[h.Semicolon=59]="Semicolon",h[h.LessThan=60]="LessThan",h[h.Equals=61]="Equals",h[h.GreaterThan=62]="GreaterThan",h[h.QuestionMark=63]="QuestionMark",h[h.AtSign=64]="AtSign",h[h.A=65]="A",h[h.B=66]="B",h[h.C=67]="C",h[h.D=68]="D",h[h.E=69]="E",h[h.F=70]="F",h[h.G=71]="G",h[h.H=72]="H",h[h.I=73]="I",h[h.J=74]="J",h[h.K=75]="K",h[h.L=76]="L",h[h.M=77]="M",h[h.N=78]="N",h[h.O=79]="O",h[h.P=80]="P",h[h.Q=81]="Q",h[h.R=82]="R",h[h.S=83]="S",h[h.T=84]="T",h[h.U=85]="U",h[h.V=86]="V",h[h.W=87]="W",h[h.X=88]="X",h[h.Y=89]="Y",h[h.Z=90]="Z",h[h.OpenSquareBracket=91]="OpenSquareBracket",h[h.Backslash=92]="Backslash",h[h.CloseSquareBracket=93]="CloseSquareBracket",h[h.Caret=94]="Caret",h[h.Underline=95]="Underline",h[h.BackTick=96]="BackTick",h[h.a=97]="a",h[h.b=98]="b",h[h.c=99]="c",h[h.d=100]="d",h[h.e=101]="e",h[h.f=102]="f",h[h.g=103]="g",h[h.h=104]="h",h[h.i=105]="i",h[h.j=106]="j",h[h.k=107]="k",h[h.l=108]="l",h[h.m=109]="m",h[h.n=110]="n",h[h.o=111]="o",h[h.p=112]="p",h[h.q=113]="q",h[h.r=114]="r",h[h.s=115]="s",h[h.t=116]="t",h[h.u=117]="u",h[h.v=118]="v",h[h.w=119]="w",h[h.x=120]="x",h[h.y=121]="y",h[h.z=122]="z",h[h.OpenCurlyBrace=123]="OpenCurlyBrace",h[h.Pipe=124]="Pipe",h[h.CloseCurlyBrace=125]="CloseCurlyBrace",h[h.Tilde=126]="Tilde",h[h.NoBreakSpace=160]="NoBreakSpace",h[h.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",h[h.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",h[h.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",h[h.U_Combining_Tilde=771]="U_Combining_Tilde",h[h.U_Combining_Macron=772]="U_Combining_Macron",h[h.U_Combining_Overline=773]="U_Combining_Overline",h[h.U_Combining_Breve=774]="U_Combining_Breve",h[h.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",h[h.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",h[h.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",h[h.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",h[h.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",h[h.U_Combining_Caron=780]="U_Combining_Caron",h[h.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",h[h.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",h[h.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",h[h.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",h[h.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",h[h.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",h[h.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",h[h.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",h[h.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",h[h.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",h[h.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",h[h.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",h[h.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",h[h.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",h[h.U_Combining_Horn=795]="U_Combining_Horn",h[h.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",h[h.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",h[h.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",h[h.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",h[h.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",h[h.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",h[h.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",h[h.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",h[h.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",h[h.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",h[h.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",h[h.U_Combining_Cedilla=807]="U_Combining_Cedilla",h[h.U_Combining_Ogonek=808]="U_Combining_Ogonek",h[h.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",h[h.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",h[h.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",h[h.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",h[h.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",h[h.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",h[h.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",h[h.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",h[h.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",h[h.U_Combining_Low_Line=818]="U_Combining_Low_Line",h[h.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",h[h.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",h[h.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",h[h.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",h[h.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",h[h.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",h[h.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",h[h.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",h[h.U_Combining_Square_Below=827]="U_Combining_Square_Below",h[h.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",h[h.U_Combining_X_Above=829]="U_Combining_X_Above",h[h.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",h[h.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",h[h.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",h[h.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",h[h.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",h[h.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",h[h.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",h[h.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",h[h.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",h[h.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",h[h.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",h[h.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",h[h.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",h[h.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",h[h.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",h[h.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",h[h.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",h[h.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",h[h.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",h[h.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",h[h.U_Combining_Fermata=850]="U_Combining_Fermata",h[h.U_Combining_X_Below=851]="U_Combining_X_Below",h[h.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",h[h.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",h[h.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",h[h.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",h[h.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",h[h.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",h[h.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",h[h.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",h[h.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",h[h.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",h[h.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",h[h.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",h[h.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",h[h.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",h[h.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",h[h.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",h[h.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",h[h.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",h[h.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",h[h.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",h[h.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",h[h.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",h[h.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",h[h.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",h[h.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",h[h.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",h[h.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",h[h.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",h[h.LINE_SEPARATOR=8232]="LINE_SEPARATOR",h[h.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",h[h.NEXT_LINE=133]="NEXT_LINE",h[h.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",h[h.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",h[h.U_DIAERESIS=168]="U_DIAERESIS",h[h.U_MACRON=175]="U_MACRON",h[h.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",h[h.U_CEDILLA=184]="U_CEDILLA",h[h.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",h[h.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",h[h.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",h[h.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",h[h.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",h[h.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",h[h.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",h[h.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",h[h.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",h[h.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",h[h.U_BREVE=728]="U_BREVE",h[h.U_DOT_ABOVE=729]="U_DOT_ABOVE",h[h.U_RING_ABOVE=730]="U_RING_ABOVE",h[h.U_OGONEK=731]="U_OGONEK",h[h.U_SMALL_TILDE=732]="U_SMALL_TILDE",h[h.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",h[h.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",h[h.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",h[h.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",h[h.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",h[h.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",h[h.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",h[h.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",h[h.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",h[h.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",h[h.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",h[h.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",h[h.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",h[h.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",h[h.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",h[h.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",h[h.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",h[h.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",h[h.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",h[h.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",h[h.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",h[h.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",h[h.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",h[h.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",h[h.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",h[h.U_GREEK_TONOS=900]="U_GREEK_TONOS",h[h.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",h[h.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",h[h.U_GREEK_PSILI=8127]="U_GREEK_PSILI",h[h.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",h[h.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",h[h.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",h[h.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",h[h.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",h[h.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",h[h.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",h[h.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",h[h.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",h[h.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",h[h.U_GREEK_VARIA=8175]="U_GREEK_VARIA",h[h.U_GREEK_OXIA=8189]="U_GREEK_OXIA",h[h.U_GREEK_DASIA=8190]="U_GREEK_DASIA",h[h.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",h[h.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",h[h.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",h[h.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",h[h.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",h[h.U_OVERLINE=8254]="U_OVERLINE",h[h.UTF8_BOM=65279]="UTF8_BOM",h[h.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",h[h.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(s||(e.CharCode=s={}))}),define(Re[80],Ce([1,0]),function(ge,e){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$g=void 0,e.$c=h,e.$d=R,e.$e=A,e.$f=O;function h(m,c){const I=Object.create(null);for(const E of m){const g=c(E);let P=I[g];P||(P=I[g]=[]),P.push(E)}return I}function R(m,c){const I=[],E=[];for(const g of m)c.has(g)||I.push(g);for(const g of c)m.has(g)||E.push(g);return{removed:I,added:E}}function A(m,c){const I=[],E=[];for(const[g,P]of m)c.has(g)||I.push(P);for(const[g,P]of c)m.has(g)||E.push(P);return{removed:I,added:E}}function O(m,c){const I=new Set;for(const E of c)m.has(E)&&I.add(E);return I}class C{static{s=Symbol.toStringTag}constructor(c,I){this.b=I,this.a=new Map,this[s]="SetWithKey";for(const E of c)this.add(E)}get size(){return this.a.size}add(c){const I=this.b(c);return this.a.set(I,c),this}delete(c){return this.a.delete(this.b(c))}has(c){return this.a.has(this.b(c))}*entries(){for(const c of this.a.values())yield[c,c]}keys(){return this.values()}*values(){for(const c of this.a.values())yield c}clear(){this.a.clear()}forEach(c,I){this.a.forEach(E=>c.call(I,E,E,this))}[Symbol.iterator](){return this.values()}}e.$g=C}),define(Re[60],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=h,e.$bi=R,e.$ci=A;function s(O){return(C,m,c)=>{let I=null,E=null;if(typeof c.value=="function"?(I="value",E=c.value):typeof c.get=="function"&&(I="get",E=c.get),!E)throw new Error("not supported");c[I]=O(E,m)}}function h(O,C,m){let c=null,I=null;if(typeof m.value=="function"?(c="value",I=m.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(c="get",I=m.get),!I)throw new Error("not supported");const E=`$memoize$${C}`;m[c]=function(...g){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,g)}),this[E]}}function R(O,C,m){return s((c,I)=>{const E=`$debounce$${I}`,g=`$debounce$result$${I}`;return function(...P){this[g]||(this[g]=m?m():void 0),clearTimeout(this[E]),C&&(this[g]=C(this[g],...P),P=[this[g]]),this[E]=setTimeout(()=>{c.apply(this,P),this[g]=m?m():void 0},O)}})}function A(O,C,m){return s((c,I)=>{const E=`$throttle$timer$${I}`,g=`$throttle$result$${I}`,P=`$throttle$lastRun$${I}`,b=`$throttle$pending$${I}`;return function(...a){if(this[g]||(this[g]=m?m():void 0),(this[P]===null||this[P]===void 0)&&(this[P]=-Number.MAX_VALUE),C&&(this[g]=C(this[g],...a)),this[b])return;const $=this[P]+O;$<=Date.now()?(this[P]=Date.now(),c.apply(this,[this[g]]),this[g]=m?m():void 0):(this[b]=!0,this[E]=setTimeout(()=>{this[b]=!1,this[P]=Date.now(),c.apply(this,[this[g]]),this[g]=m?m():void 0},$-Date.now()))}})}}),define(Re[12],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eb=e.$db=e.$cb=e.$bb=e.$ab=e.$$=e.$7=e.$Y=e.$X=void 0,e.setUnexpectedErrorHandler=h,e.$1=R,e.$2=A,e.$3=O,e.$4=C,e.$5=m,e.$6=I,e.$8=g,e.$9=P,e.$0=b,e.$_=$;class s{constructor(){this.b=[],this.a=function(r){setTimeout(()=>{throw r.stack?o.isErrorNoTelemetry(r)?new o(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.b.push(r),()=>{this.d(r)}}c(r){this.b.forEach(d=>{d(r)})}d(r){this.b.splice(this.b.indexOf(r),1)}setUnexpectedErrorHandler(r){this.a=r}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(r){this.a(r),this.c(r)}onUnexpectedExternalError(r){this.a(r)}}e.$X=s,e.$Y=new s;function h(n){e.$Y.setUnexpectedErrorHandler(n)}function R(n){if(!n||typeof n!="object")return!1;const r=n;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}function A(n){I(n)||e.$Y.onUnexpectedError(n)}function O(n){I(n)||e.$Y.onUnexpectedExternalError(n)}function C(n){if(n instanceof Error){const{name:r,message:d}=n,l=n.stacktrace||n.stack;return{$isError:!0,name:r,message:d,stack:l,noTelemetry:o.isErrorNoTelemetry(n)}}return n}function m(n){let r;return n.noTelemetry?r=new o:(r=new Error,r.name=n.name),r.message=n.message,r.stack=n.stack,r}const c="Canceled";function I(n){return n instanceof E?!0:n instanceof Error&&n.name===c&&n.message===c}class E extends Error{constructor(){super(c),this.name=this.message}}e.$7=E;function g(){const n=new Error(c);return n.name=n.message,n}function P(n){return n?new Error(`Illegal argument: ${n}`):new Error("Illegal argument")}function b(n){return n?new Error(`Illegal state: ${n}`):new Error("Illegal state")}class a extends TypeError{constructor(r){super(r?`${r} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$$=a;function $(n){return n?n.message?n.message:n.stack?n.stack.split(`
`)[0]:String(n):"Error"}class p extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}e.$ab=p;class u extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}e.$bb=u;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$cb=i;class o extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof o)return r;const d=new o;return d.message=r.message,d.stack=r.stack,d}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}e.$db=o;class t extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,t.prototype)}}e.$eb=t}),define(Re[18],Ce([1,0,12,132]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cc=e.$bc=e.$ac=e.$$b=e.$0b=e.CompareResult=void 0,e.$ub=R,e.$vb=A,e.$wb=O,e.$xb=C,e.$yb=m,e.$zb=c,e.$Ab=I,e.$Bb=E,e.$Cb=g,e.$Db=P,e.$Eb=b,e.$Fb=a,e.$Gb=$,e.top=p,e.$Ib=u,e.$Jb=o,e.$Kb=t,e.$Lb=n,e.$Mb=r,e.$Nb=d,e.$Ob=l,e.$Pb=f,e.$Qb=y,e.$Rb=k,e.$Sb=S,e.$Tb=D,e.$Ub=T,e.$Vb=v,e.$Wb=w,e.$Xb=M,e.$Yb=L,e.$Zb=N,e.$1b=F,e.$2b=V,e.$3b=j,e.$4b=U,e.$5b=z,e.$6b=_,e.$7b=W,e.$8b=x,e.$9b=oe,e.$_b=ue,e.$dc=be;function R(ae,we=0){return ae[ae.length-(1+we)]}function A(ae){if(ae.length===0)throw new Error("Invalid tail call");return[ae.slice(0,ae.length-1),ae[ae.length-1]]}function O(ae,we,$e=(pe,Ae)=>pe===Ae){if(ae===we)return!0;if(!ae||!we||ae.length!==we.length)return!1;for(let pe=0,Ae=ae.length;pe<Ae;pe++)if(!$e(ae[pe],we[pe]))return!1;return!0}function C(ae,we){const $e=ae.length-1;we<$e&&(ae[we]=ae[$e]),ae.pop()}function m(ae,we,$e){return c(ae.length,pe=>$e(ae[pe],we))}function c(ae,we){let $e=0,pe=ae-1;for(;$e<=pe;){const Ae=($e+pe)/2|0,je=we(Ae);if(je<0)$e=Ae+1;else if(je>0)pe=Ae-1;else return Ae}return-($e+1)}function I(ae,we,$e){if(ae=ae|0,ae>=we.length)throw new TypeError("invalid index");const pe=we[Math.floor(we.length*Math.random())],Ae=[],je=[],He=[];for(const Ye of we){const xe=$e(Ye,pe);xe<0?Ae.push(Ye):xe>0?je.push(Ye):He.push(Ye)}return ae<Ae.length?I(ae,Ae,$e):ae<Ae.length+He.length?He[0]:I(ae-(Ae.length+He.length),je,$e)}function E(ae,we){const $e=[];let pe;for(const Ae of ae.slice(0).sort(we))!pe||we(pe[0],Ae)!==0?(pe=[Ae],$e.push(pe)):pe.push(Ae);return $e}function*g(ae,we){let $e,pe;for(const Ae of ae)pe!==void 0&&we(pe,Ae)?$e.push(Ae):($e&&(yield $e),$e=[Ae]),pe=Ae;$e&&(yield $e)}function P(ae,we){for(let $e=0;$e<=ae.length;$e++)we($e===0?void 0:ae[$e-1],$e===ae.length?void 0:ae[$e])}function b(ae,we){for(let $e=0;$e<ae.length;$e++)we($e===0?void 0:ae[$e-1],ae[$e],$e+1===ae.length?void 0:ae[$e+1])}function a(ae,we,$e){const pe=[];function Ae(Ye,xe,Fe){if(xe===0&&Fe.length===0)return;const We=pe[pe.length-1];We&&We.start+We.deleteCount===Ye?(We.deleteCount+=xe,We.toInsert.push(...Fe)):pe.push({start:Ye,deleteCount:xe,toInsert:Fe})}let je=0,He=0;for(;;){if(je===ae.length){Ae(je,0,we.slice(He));break}if(He===we.length){Ae(je,ae.length-je,[]);break}const Ye=ae[je],xe=we[He],Fe=$e(Ye,xe);Fe===0?(je+=1,He+=1):Fe<0?(Ae(je,1,[]),je+=1):Fe>0&&(Ae(je,0,[xe]),He+=1)}return pe}function $(ae,we,$e){const pe=a(ae,we,$e),Ae=[],je=[];for(const He of pe)Ae.push(...ae.slice(He.start,He.start+He.deleteCount)),je.push(...He.toInsert);return{removed:Ae,added:je}}function p(ae,we,$e){if($e===0)return[];const pe=ae.slice(0,$e).sort(we);return i(ae,we,pe,$e,ae.length),pe}function u(ae,we,$e,pe,Ae){return $e===0?Promise.resolve([]):new Promise((je,He)=>{(async()=>{const Ye=ae.length,xe=ae.slice(0,$e).sort(we);for(let Fe=$e,We=Math.min($e+pe,Ye);Fe<Ye;Fe=We,We=Math.min(We+pe,Ye)){if(Fe>$e&&await new Promise(Ne=>setTimeout(Ne)),Ae&&Ae.isCancellationRequested)throw new s.$7;i(ae,we,xe,Fe,We)}return xe})().then(je,He)})}function i(ae,we,$e,pe,Ae){for(const je=$e.length;pe<Ae;pe++){const He=ae[pe];if(we(He,$e[je-1])<0){$e.pop();const Ye=(0,h.$mb)($e,xe=>we(He,xe)<0);$e.splice(Ye,0,He)}}}function o(ae){return ae.filter(we=>!!we)}function t(ae){let we=0;for(let $e=0;$e<ae.length;$e++)ae[$e]&&(ae[we]=ae[$e],we+=1);ae.length=we}function n(ae,we,$e){ae.splice($e,0,ae.splice(we,1)[0])}function r(ae){return!Array.isArray(ae)||ae.length===0}function d(ae){return Array.isArray(ae)&&ae.length>0}function l(ae,we=$e=>$e){const $e=new Set;return ae.filter(pe=>{const Ae=we(pe);return $e.has(Ae)?!1:($e.add(Ae),!0)})}function f(ae){const we=new Set;return $e=>{const pe=ae($e);return we.has(pe)?!1:(we.add(pe),!0)}}function y(ae,we){return ae.length>0?ae[0]:we}function k(ae,we){return ae.length>0?ae[ae.length-1]:we}function S(ae,we,$e=(pe,Ae)=>pe===Ae){let pe=0;for(let Ae=0,je=Math.min(ae.length,we.length);Ae<je&&$e(ae[Ae],we[Ae]);Ae++)pe++;return pe}function D(ae,we){let $e=typeof we=="number"?ae:0;typeof we=="number"?$e=ae:($e=0,we=ae);const pe=[];if($e<=we)for(let Ae=$e;Ae<we;Ae++)pe.push(Ae);else for(let Ae=$e;Ae>we;Ae--)pe.push(Ae);return pe}function T(ae,we,$e){return ae.reduce((pe,Ae)=>(pe[we(Ae)]=$e?$e(Ae):Ae,pe),Object.create(null))}function v(ae,we){return ae.push(we),()=>w(ae,we)}function w(ae,we){const $e=ae.indexOf(we);if($e>-1)return ae.splice($e,1),we}function M(ae,we,$e){const pe=ae.slice(0,we),Ae=ae.slice(we);return pe.concat($e,Ae)}function L(ae,we){let $e;if(typeof we=="number"){let pe=we;$e=()=>{const Ae=Math.sin(pe++)*179426549;return Ae-Math.floor(Ae)}}else $e=Math.random;for(let pe=ae.length-1;pe>0;pe-=1){const Ae=Math.floor($e()*(pe+1)),je=ae[pe];ae[pe]=ae[Ae],ae[Ae]=je}}function N(ae,we){const $e=ae.indexOf(we);$e>-1&&(ae.splice($e,1),ae.unshift(we))}function F(ae,we){const $e=ae.indexOf(we);$e>-1&&(ae.splice($e,1),ae.push(we))}function V(ae,we){for(const $e of we)ae.push($e)}function j(ae,we){return Array.isArray(ae)?ae.map(we):we(ae)}function U(ae){return Array.isArray(ae)?ae:[ae]}function z(ae){return ae[Math.floor(Math.random()*ae.length)]}function _(ae,we,$e){const pe=B(ae,we),Ae=ae.length,je=$e.length;ae.length=Ae+je;for(let He=Ae-1;He>=pe;He--)ae[He+je]=ae[He];for(let He=0;He<je;He++)ae[He+pe]=$e[He]}function W(ae,we,$e,pe){const Ae=B(ae,we);let je=ae.splice(Ae,$e);return je===void 0&&(je=[]),_(ae,Ae,pe),je}function B(ae,we){return we<0?Math.max(we+ae.length,0):Math.min(we,ae.length)}var Y;(function(ae){function we(je){return je<0}ae.isLessThan=we;function $e(je){return je<=0}ae.isLessThanOrEqual=$e;function pe(je){return je>0}ae.isGreaterThan=pe;function Ae(je){return je===0}ae.isNeitherLessOrGreaterThan=Ae,ae.greaterThan=1,ae.lessThan=-1,ae.neitherLessOrGreaterThan=0})(Y||(e.CompareResult=Y={}));function x(ae,we){return($e,pe)=>we(ae($e),ae(pe))}function oe(...ae){return(we,$e)=>{for(const pe of ae){const Ae=pe(we,$e);if(!Y.isNeitherLessOrGreaterThan(Ae))return Ae}return Y.neitherLessOrGreaterThan}}const ie=(ae,we)=>ae-we;e.$0b=ie;const me=(ae,we)=>(0,e.$0b)(ae?1:0,we?1:0);e.$$b=me;function ue(ae){return(we,$e)=>-ae(we,$e)}class X{constructor(we){this.g=we,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(we){let $e=this.c;for(;$e<this.g.length&&we(this.g[$e]);)$e++;const pe=$e===this.c?null:this.g.slice(this.c,$e);return this.c=$e,pe}takeFromEndWhile(we){let $e=this.d;for(;$e>=0&&we(this.g[$e]);)$e--;const pe=$e===this.d?null:this.g.slice($e+1,this.d+1);return this.d=$e,pe}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const we=this.g[this.c];return this.c++,we}removeLast(){const we=this.g[this.d];return this.d--,we}takeCount(we){const $e=this.g.slice(this.c,this.c+we);return this.c+=we,$e}}e.$ac=X;class q{static{this.empty=new q(we=>{})}constructor(we){this.iterate=we}forEach(we){this.iterate($e=>(we($e),!0))}toArray(){const we=[];return this.iterate($e=>(we.push($e),!0)),we}filter(we){return new q($e=>this.iterate(pe=>we(pe)?$e(pe):!0))}map(we){return new q($e=>this.iterate(pe=>$e(we(pe))))}some(we){let $e=!1;return this.iterate(pe=>($e=we(pe),!$e)),$e}findFirst(we){let $e;return this.iterate(pe=>we(pe)?($e=pe,!1):!0),$e}findLast(we){let $e;return this.iterate(pe=>(we(pe)&&($e=pe),!0)),$e}findLastMaxBy(we){let $e,pe=!0;return this.iterate(Ae=>((pe||Y.isGreaterThan(we(Ae,$e)))&&(pe=!1,$e=Ae),!0)),$e}}e.$bc=q;class se{constructor(we){this.c=we}static createSortPermutation(we,$e){const pe=Array.from(we.keys()).sort((Ae,je)=>$e(we[Ae],we[je]));return new se(pe)}apply(we){return we.map(($e,pe)=>we[this.c[pe]])}inverse(){const we=this.c.slice();for(let $e=0;$e<this.c.length;$e++)we[this.c[$e]]=$e;return new se(we)}}e.$cc=se;async function be(ae,we){return(await Promise.all(ae.map(async(pe,Ae)=>({element:pe,ok:await we(pe,Ae)})))).find(pe=>pe.ok)?.element}}),define(Re[67],Ce([1,0,12]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=h,e.$hd=R,e.$id=A,e.$jd=O,e.$kd=C,e.$ld=m;function h(c,I){if(!c)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}function R(c,I="Unreachable"){throw new Error(I)}function A(c,I="unexpected state"){if(!c)throw new s.$eb(`Assertion Failed: ${I}`)}function O(c){c||(0,s.$2)(new s.$eb("Soft Assertion Failed"))}function C(c){if(!c()){debugger;c(),(0,s.$2)(new s.$eb("Assertion Failed"))}}function m(c,I){let E=0;for(;E<c.length-1;){const g=c[E],P=c[E+1];if(!I(g,P))return!1;E++}return!0}});var Qn=this&&this.__createBinding||(Object.create?function(ge,e,s,h){h===void 0&&(h=s);var R=Object.getOwnPropertyDescriptor(e,s);(!R||("get"in R?!e.__esModule:R.writable||R.configurable))&&(R={enumerable:!0,get:function(){return e[s]}}),Object.defineProperty(ge,h,R)}:function(ge,e,s,h){h===void 0&&(h=s),ge[h]=e[s]}),Gn=this&&this.__setModuleDefault||(Object.create?function(ge,e){Object.defineProperty(ge,"default",{enumerable:!0,value:e})}:function(ge,e){ge.default=e}),Ue=this&&this.__importStar||function(ge){if(ge&&ge.__esModule)return ge;var e={};if(ge!=null)for(var s in ge)s!=="default"&&Object.prototype.hasOwnProperty.call(ge,s)&&Qn(e,ge,s);return Gn(e,ge),e};define(Re[178],Ce([1,0,18]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9c=void 0,e.$0c=R,e.$$c=A,e.$_c=O,e.$ad=C,e.$bd=m,e.$cd=c,s=Ue(s);const h=(P,b)=>P===b;e.$9c=h;function R(P=e.$9c){return(b,a)=>s.$wb(b,a,P)}function A(){return(P,b)=>JSON.stringify(P)===JSON.stringify(b)}function O(){return(P,b)=>P.equals(b)}function C(P,b,a){if(a!==void 0){const $=P;return $==null||b===void 0||b===null?b===$:a($,b)}else{const $=P;return(p,u)=>p==null||u===void 0||u===null?u===p:$(p,u)}}function m(P,b){if(P===b)return!0;if(Array.isArray(P)&&Array.isArray(b)){if(P.length!==b.length)return!1;for(let a=0;a<P.length;a++)if(!m(P[a],b[a]))return!1;return!0}if(P&&typeof P=="object"&&b&&typeof b=="object"&&Object.getPrototypeOf(P)===Object.prototype&&Object.getPrototypeOf(b)===Object.prototype){const a=P,$=b,p=Object.keys(a),u=Object.keys($),i=new Set(u);if(p.length!==u.length)return!1;for(const o of p)if(!i.has(o)||!m(a[o],$[o]))return!1;return!0}return!1}function c(P){return JSON.stringify(g(P))}let I=0;const E=new WeakMap;function g(P){if(Array.isArray(P))return P.map(g);if(P&&typeof P=="object")if(Object.getPrototypeOf(P)===Object.prototype){const b=P,a=Object.create(null);for(const $ of Object.keys(b).sort())a[$]=g(b[$]);return a}else{let b=E.get(P);return b===void 0&&(b=I++,E.set(P,b)),b+"----2b76a038c20c4bcc"}return P}}),define(Re[81],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fb=s;function s(h,R){const A=this;let O=!1,C;return function(){if(O)return C;if(O=!0,R)try{C=h.apply(A,arguments)}finally{R()}else C=h.apply(A,arguments);return C}}}),define(Re[133],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JQ=e.$IQ=void 0;class s{constructor(R){this.a=R,this.b=0}nextId(){return this.a+ ++this.b}}e.$IQ=s,e.$JQ=new s("id#")}),define(Re[40],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var s;(function(h){function R(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}h.is=R;const A=Object.freeze([]);function O(){return A}h.empty=O;function*C(r){yield r}h.single=C;function m(r){return R(r)?r:C(r)}h.wrap=m;function c(r){return r||A}h.from=c;function*I(r){for(let d=r.length-1;d>=0;d--)yield r[d]}h.reverse=I;function E(r){return!r||r[Symbol.iterator]().next().done===!0}h.isEmpty=E;function g(r){return r[Symbol.iterator]().next().value}h.first=g;function P(r,d){let l=0;for(const f of r)if(d(f,l++))return!0;return!1}h.some=P;function b(r,d){for(const l of r)if(d(l))return l}h.find=b;function*a(r,d){for(const l of r)d(l)&&(yield l)}h.filter=a;function*$(r,d){let l=0;for(const f of r)yield d(f,l++)}h.map=$;function*p(r,d){let l=0;for(const f of r)yield*d(f,l++)}h.flatMap=p;function*u(...r){for(const d of r)yield*d}h.concat=u;function i(r,d,l){let f=l;for(const y of r)f=d(f,y);return f}h.reduce=i;function*o(r,d,l=r.length){for(d<0&&(d+=r.length),l<0?l+=r.length:l>r.length&&(l=r.length);d<l;d++)yield r[d]}h.slice=o;function t(r,d=Number.POSITIVE_INFINITY){const l=[];if(d===0)return[l,r];const f=r[Symbol.iterator]();for(let y=0;y<d;y++){const k=f.next();if(k.done)return[l,h.empty()];l.push(k.value)}return[l,{[Symbol.iterator](){return f}}]}h.consume=t;async function n(r){const d=[];for await(const l of r)d.push(l);return Promise.resolve(d)}h.asyncToArray=n})(s||(e.Iterable=s={}))}),define(Re[179],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$1n=O,e.$2n=E,e.$3n=g,e.$4n=P,e.$5n=b,e.$6n=a,e.$7n=$,e.$8n=p,e.$9n=u,e.$0n=i,e.$$n=o;var s;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(s||(e.ScanError=s={}));var h;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(h||(e.SyntaxKind=h={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R||(e.ParseErrorCode=R={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function O(t,n=!1){let r=0;const d=t.length;let l="",f=0,y=h.Unknown,k=s.None;function S(N){let F=0,V=0;for(;F<N;){const j=t.charCodeAt(r);if(j>=I._0&&j<=I._9)V=V*16+j-I._0;else if(j>=I.A&&j<=I.F)V=V*16+j-I.A+10;else if(j>=I.a&&j<=I.f)V=V*16+j-I.a+10;else break;r++,F++}return F<N&&(V=-1),V}function D(N){r=N,l="",f=0,y=h.Unknown,k=s.None}function T(){const N=r;if(t.charCodeAt(r)===I._0)r++;else for(r++;r<t.length&&c(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===I.dot)if(r++,r<t.length&&c(t.charCodeAt(r)))for(r++;r<t.length&&c(t.charCodeAt(r));)r++;else return k=s.UnexpectedEndOfNumber,t.substring(N,r);let F=r;if(r<t.length&&(t.charCodeAt(r)===I.E||t.charCodeAt(r)===I.e))if(r++,(r<t.length&&t.charCodeAt(r)===I.plus||t.charCodeAt(r)===I.minus)&&r++,r<t.length&&c(t.charCodeAt(r))){for(r++;r<t.length&&c(t.charCodeAt(r));)r++;F=r}else k=s.UnexpectedEndOfNumber;return t.substring(N,F)}function v(){let N="",F=r;for(;;){if(r>=d){N+=t.substring(F,r),k=s.UnexpectedEndOfString;break}const V=t.charCodeAt(r);if(V===I.doubleQuote){N+=t.substring(F,r),r++;break}if(V===I.backslash){if(N+=t.substring(F,r),r++,r>=d){k=s.UnexpectedEndOfString;break}switch(t.charCodeAt(r++)){case I.doubleQuote:N+='"';break;case I.backslash:N+="\\";break;case I.slash:N+="/";break;case I.b:N+="\b";break;case I.f:N+="\f";break;case I.n:N+=`
`;break;case I.r:N+="\r";break;case I.t:N+="	";break;case I.u:{const U=S(4);U>=0?N+=String.fromCharCode(U):k=s.InvalidUnicode;break}default:k=s.InvalidEscapeCharacter}F=r;continue}if(V>=0&&V<=31)if(m(V)){N+=t.substring(F,r),k=s.UnexpectedEndOfString;break}else k=s.InvalidCharacter;r++}return N}function w(){if(l="",k=s.None,f=r,r>=d)return f=d,y=h.EOF;let N=t.charCodeAt(r);if(C(N)){do r++,l+=String.fromCharCode(N),N=t.charCodeAt(r);while(C(N));return y=h.Trivia}if(m(N))return r++,l+=String.fromCharCode(N),N===I.carriageReturn&&t.charCodeAt(r)===I.lineFeed&&(r++,l+=`
`),y=h.LineBreakTrivia;switch(N){case I.openBrace:return r++,y=h.OpenBraceToken;case I.closeBrace:return r++,y=h.CloseBraceToken;case I.openBracket:return r++,y=h.OpenBracketToken;case I.closeBracket:return r++,y=h.CloseBracketToken;case I.colon:return r++,y=h.ColonToken;case I.comma:return r++,y=h.CommaToken;case I.doubleQuote:return r++,l=v(),y=h.StringLiteral;case I.slash:{const F=r-1;if(t.charCodeAt(r+1)===I.slash){for(r+=2;r<d&&!m(t.charCodeAt(r));)r++;return l=t.substring(F,r),y=h.LineCommentTrivia}if(t.charCodeAt(r+1)===I.asterisk){r+=2;const V=d-1;let j=!1;for(;r<V;){if(t.charCodeAt(r)===I.asterisk&&t.charCodeAt(r+1)===I.slash){r+=2,j=!0;break}r++}return j||(r++,k=s.UnexpectedEndOfComment),l=t.substring(F,r),y=h.BlockCommentTrivia}return l+=String.fromCharCode(N),r++,y=h.Unknown}case I.minus:if(l+=String.fromCharCode(N),r++,r===d||!c(t.charCodeAt(r)))return y=h.Unknown;case I._0:case I._1:case I._2:case I._3:case I._4:case I._5:case I._6:case I._7:case I._8:case I._9:return l+=T(),y=h.NumericLiteral;default:for(;r<d&&M(N);)r++,N=t.charCodeAt(r);if(f!==r){switch(l=t.substring(f,r),l){case"true":return y=h.TrueKeyword;case"false":return y=h.FalseKeyword;case"null":return y=h.NullKeyword}return y=h.Unknown}return l+=String.fromCharCode(N),r++,y=h.Unknown}}function M(N){if(C(N)||m(N))return!1;switch(N){case I.closeBrace:case I.closeBracket:case I.openBrace:case I.openBracket:case I.doubleQuote:case I.colon:case I.comma:case I.slash:return!1}return!0}function L(){let N;do N=w();while(N>=h.LineCommentTrivia&&N<=h.Trivia);return N}return{setPosition:D,getPosition:()=>r,scan:n?L:w,getToken:()=>y,getTokenValue:()=>l,getTokenOffset:()=>f,getTokenLength:()=>r-f,getTokenError:()=>k}}function C(t){return t===I.space||t===I.tab||t===I.verticalTab||t===I.formFeed||t===I.nonBreakingSpace||t===I.ogham||t>=I.enQuad&&t<=I.zeroWidthSpace||t===I.narrowNoBreakSpace||t===I.mathematicalSpace||t===I.ideographicSpace||t===I.byteOrderMark}function m(t){return t===I.lineFeed||t===I.carriageReturn||t===I.lineSeparator||t===I.paragraphSeparator}function c(t){return t>=I._0&&t<=I._9}var I;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(I||(I={}));function E(t,n){const r=[],d=new Object;let l;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let y=!1;function k(S,D,T,v){f.value=S,f.offset=D,f.length=T,f.type=v,f.colonOffset=void 0,l=f}try{i(t,{onObjectBegin:(S,D)=>{if(n<=S)throw d;l=void 0,y=n>S,r.push("")},onObjectProperty:(S,D,T)=>{if(n<D||(k(S,D,T,"property"),r[r.length-1]=S,n<=D+T))throw d},onObjectEnd:(S,D)=>{if(n<=S)throw d;l=void 0,r.pop()},onArrayBegin:(S,D)=>{if(n<=S)throw d;l=void 0,r.push(0)},onArrayEnd:(S,D)=>{if(n<=S)throw d;l=void 0,r.pop()},onLiteralValue:(S,D,T)=>{if(n<D||(k(S,D,T,o(S)),n<=D+T))throw d},onSeparator:(S,D,T)=>{if(n<=D)throw d;if(S===":"&&l&&l.type==="property")l.colonOffset=D,y=!1,l=void 0;else if(S===","){const v=r[r.length-1];typeof v=="number"?r[r.length-1]=v+1:(y=!0,r[r.length-1]=""),l=void 0}}})}catch(S){if(S!==d)throw S}return{path:r,previousNode:l,isAtPropertyKey:y,matches:S=>{let D=0;for(let T=0;D<S.length&&T<r.length;T++)if(S[D]===r[T]||S[D]==="*")D++;else if(S[D]!=="**")return!1;return D===S.length}}}function g(t,n=[],r=A.DEFAULT){let d=null,l=[];const f=[];function y(S){Array.isArray(l)?l.push(S):d!==null&&(l[d]=S)}return i(t,{onObjectBegin:()=>{const S={};y(S),f.push(l),l=S,d=null},onObjectProperty:S=>{d=S},onObjectEnd:()=>{l=f.pop()},onArrayBegin:()=>{const S=[];y(S),f.push(l),l=S,d=null},onArrayEnd:()=>{l=f.pop()},onLiteralValue:y,onError:(S,D,T)=>{n.push({error:S,offset:D,length:T})}},r),l[0]}function P(t,n=[],r=A.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(S){d.type==="property"&&(d.length=S-d.offset,d=d.parent)}function f(S){return d.children.push(S),S}i(t,{onObjectBegin:S=>{d=f({type:"object",offset:S,length:-1,parent:d,children:[]})},onObjectProperty:(S,D,T)=>{d=f({type:"property",offset:D,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:S,offset:D,length:T,parent:d})},onObjectEnd:(S,D)=>{d.length=S+D-d.offset,d=d.parent,l(S+D)},onArrayBegin:(S,D)=>{d=f({type:"array",offset:S,length:-1,parent:d,children:[]})},onArrayEnd:(S,D)=>{d.length=S+D-d.offset,d=d.parent,l(S+D)},onLiteralValue:(S,D,T)=>{f({type:o(S),offset:D,length:T,parent:d,value:S}),l(D+T)},onSeparator:(S,D,T)=>{d.type==="property"&&(S===":"?d.colonOffset=D:S===","&&l(D))},onError:(S,D,T)=>{n.push({error:S,offset:D,length:T})}},r);const k=d.children[0];return k&&delete k.parent,k}function b(t,n){if(!t)return;let r=t;for(const d of n)if(typeof d=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let l=!1;for(const f of r.children)if(Array.isArray(f.children)&&f.children[0].value===d){r=f.children[1],l=!0;break}if(!l)return}else{const l=d;if(r.type!=="array"||l<0||!Array.isArray(r.children)||l>=r.children.length)return;r=r.children[l]}return r}function a(t){if(!t.parent||!t.parent.children)return[];const n=a(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;n.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&n.push(r)}return n}function $(t){switch(t.type){case"array":return t.children.map($);case"object":{const n=Object.create(null);for(const r of t.children){const d=r.children[1];d&&(n[r.children[0].value]=$(d))}return n}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function p(t,n,r=!1){return n>=t.offset&&n<t.offset+t.length||r&&n===t.offset+t.length}function u(t,n,r=!1){if(p(t,n,r)){const d=t.children;if(Array.isArray(d))for(let l=0;l<d.length&&d[l].offset<=n;l++){const f=u(d[l],n,r);if(f)return f}return t}}function i(t,n,r=A.DEFAULT){const d=O(t,!1);function l(x){return x?()=>x(d.getTokenOffset(),d.getTokenLength()):()=>!0}function f(x){return x?oe=>x(oe,d.getTokenOffset(),d.getTokenLength()):()=>!0}const y=l(n.onObjectBegin),k=f(n.onObjectProperty),S=l(n.onObjectEnd),D=l(n.onArrayBegin),T=l(n.onArrayEnd),v=f(n.onLiteralValue),w=f(n.onSeparator),M=l(n.onComment),L=f(n.onError),N=r&&r.disallowComments,F=r&&r.allowTrailingComma;function V(){for(;;){const x=d.scan();switch(d.getTokenError()){case s.InvalidUnicode:j(R.InvalidUnicode);break;case s.InvalidEscapeCharacter:j(R.InvalidEscapeCharacter);break;case s.UnexpectedEndOfNumber:j(R.UnexpectedEndOfNumber);break;case s.UnexpectedEndOfComment:N||j(R.UnexpectedEndOfComment);break;case s.UnexpectedEndOfString:j(R.UnexpectedEndOfString);break;case s.InvalidCharacter:j(R.InvalidCharacter);break}switch(x){case h.LineCommentTrivia:case h.BlockCommentTrivia:N?j(R.InvalidCommentToken):M();break;case h.Unknown:j(R.InvalidSymbol);break;case h.Trivia:case h.LineBreakTrivia:break;default:return x}}}function j(x,oe=[],ie=[]){if(L(x),oe.length+ie.length>0){let me=d.getToken();for(;me!==h.EOF;){if(oe.indexOf(me)!==-1){V();break}else if(ie.indexOf(me)!==-1)break;me=V()}}}function U(x){const oe=d.getTokenValue();return x?v(oe):k(oe),V(),!0}function z(){switch(d.getToken()){case h.NumericLiteral:{let x=0;try{x=JSON.parse(d.getTokenValue()),typeof x!="number"&&(j(R.InvalidNumberFormat),x=0)}catch{j(R.InvalidNumberFormat)}v(x);break}case h.NullKeyword:v(null);break;case h.TrueKeyword:v(!0);break;case h.FalseKeyword:v(!1);break;default:return!1}return V(),!0}function _(){return d.getToken()!==h.StringLiteral?(j(R.PropertyNameExpected,[],[h.CloseBraceToken,h.CommaToken]),!1):(U(!1),d.getToken()===h.ColonToken?(w(":"),V(),Y()||j(R.ValueExpected,[],[h.CloseBraceToken,h.CommaToken])):j(R.ColonExpected,[],[h.CloseBraceToken,h.CommaToken]),!0)}function W(){y(),V();let x=!1;for(;d.getToken()!==h.CloseBraceToken&&d.getToken()!==h.EOF;){if(d.getToken()===h.CommaToken){if(x||j(R.ValueExpected,[],[]),w(","),V(),d.getToken()===h.CloseBraceToken&&F)break}else x&&j(R.CommaExpected,[],[]);_()||j(R.ValueExpected,[],[h.CloseBraceToken,h.CommaToken]),x=!0}return S(),d.getToken()!==h.CloseBraceToken?j(R.CloseBraceExpected,[h.CloseBraceToken],[]):V(),!0}function B(){D(),V();let x=!1;for(;d.getToken()!==h.CloseBracketToken&&d.getToken()!==h.EOF;){if(d.getToken()===h.CommaToken){if(x||j(R.ValueExpected,[],[]),w(","),V(),d.getToken()===h.CloseBracketToken&&F)break}else x&&j(R.CommaExpected,[],[]);Y()||j(R.ValueExpected,[],[h.CloseBracketToken,h.CommaToken]),x=!0}return T(),d.getToken()!==h.CloseBracketToken?j(R.CloseBracketExpected,[h.CloseBracketToken],[]):V(),!0}function Y(){switch(d.getToken()){case h.OpenBracketToken:return B();case h.OpenBraceToken:return W();case h.StringLiteral:return U(!0);default:return z()}}return V(),d.getToken()===h.EOF?r.allowEmptyContent?!0:(j(R.ValueExpected,[],[]),!1):Y()?(d.getToken()!==h.EOF&&j(R.EndOfFileExpected,[],[]),!0):(j(R.ValueExpected,[],[]),!1)}function o(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(Re[180],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$j=s;function s(A){let O=!1;const C=new Map,m=new Map;if(R(A,a=>{if(A===a)return!0;const $=JSON.stringify(a);if($.length<30)return!0;const p=C.get($);if(!p){const u={schemas:[a]};return C.set($,u),m.set(a,u),!0}return p.schemas.push(a),m.set(a,p),O=!0,!1}),C.clear(),!O)return JSON.stringify(A);let I="$defs";for(;A.hasOwnProperty(I);)I+="_";const E=[];function g(a){return JSON.stringify(a,($,p)=>{if(p!==a){const u=m.get(p);if(u&&u.schemas.length>1)return u.id||(u.id=`_${E.length}`,E.push(u.schemas[0])),{$ref:`#/${I}/${u.id}`}}return p})}const P=g(A),b=[];for(let a=0;a<E.length;a++)b.push(`"_${a}":${g(E[a])}`);return b.length?`${P.substring(0,P.length-1)},"${I}":{${b.join(",")}}}`:P}function h(A){return typeof A=="object"&&A!==null}function R(A,O){if(!A||typeof A!="object")return;const C=(...P)=>{for(const b of P)h(b)&&E.push(b)},m=(...P)=>{for(const b of P)if(h(b))for(const a in b){const $=b[a];h($)&&E.push($)}},c=(...P)=>{for(const b of P)if(Array.isArray(b))for(const a of b)h(a)&&E.push(a)},I=P=>{if(Array.isArray(P))for(const b of P)h(b)&&E.push(b);else h(P)&&E.push(P)},E=[A];let g=E.pop();for(;g;)O(g)&&(C(g.additionalItems,g.additionalProperties,g.not,g.contains,g.propertyNames,g.if,g.then,g.else,g.unevaluatedItems,g.unevaluatedProperties),m(g.definitions,g.$defs,g.properties,g.patternProperties,g.dependencies,g.dependentSchemas),c(g.anyOf,g.allOf,g.oneOf,g.prefixItems),I(g.items)),g=E.pop()}}),define(Re[50],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W=void 0;class s{constructor(R){this.d=R,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(R){this.c=R}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$W=s}),define(Re[82],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8c=void 0;class s{static{this.Undefined=new s(void 0)}constructor(A){this.element=A,this.next=s.Undefined,this.prev=s.Undefined}}class h{constructor(){this.a=s.Undefined,this.b=s.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===s.Undefined}clear(){let A=this.a;for(;A!==s.Undefined;){const O=A.next;A.prev=s.Undefined,A.next=s.Undefined,A=O}this.a=s.Undefined,this.b=s.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,O){const C=new s(A);if(this.a===s.Undefined)this.a=C,this.b=C;else if(O){const c=this.b;this.b=C,C.prev=c,c.next=C}else{const c=this.a;this.a=C,C.next=c,c.prev=C}this.c+=1;let m=!1;return()=>{m||(m=!0,this.e(C))}}shift(){if(this.a!==s.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==s.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==s.Undefined&&A.next!==s.Undefined){const O=A.prev;O.next=A.next,A.next.prev=O}else A.prev===s.Undefined&&A.next===s.Undefined?(this.a=s.Undefined,this.b=s.Undefined):A.next===s.Undefined?(this.b=this.b.prev,this.b.next=s.Undefined):A.prev===s.Undefined&&(this.a=this.a.next,this.a.prev=s.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==s.Undefined;)yield A.element,A=A.next}}e.$8c=h}),define(Re[28],Ce([1,0]),function(ge,e){"use strict";var s,h,R;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.Touch=e.$Ec=e.$Dc=void 0,e.$Ac=A,e.$Bc=O,e.$Cc=C,e.$Lc=o;function A(t,n,r){let d=t.get(n);return d===void 0&&(d=r,t.set(n,d)),d}function O(t){const n=[];return t.forEach((r,d)=>{n.push(`${d} => ${r}`)}),`Map(${t.size}) {${n.join(", ")}}`}function C(t){const n=[];return t.forEach(r=>{n.push(r)}),`Set(${t.size}) {${n.join(", ")}}`}class m{constructor(n,r){this.uri=n,this.value=r}}function c(t){return Array.isArray(t)}class I{static{this.c=n=>n.toString()}constructor(n,r){if(this[s]="ResourceMap",n instanceof I)this.d=new Map(n.d),this.e=r??I.c;else if(c(n)){this.d=new Map,this.e=r??I.c;for(const[d,l]of n)this.set(d,l)}else this.d=new Map,this.e=n??I.c}set(n,r){return this.d.set(this.e(n),new m(n,r)),this}get(n){return this.d.get(this.e(n))?.value}has(n){return this.d.has(this.e(n))}get size(){return this.d.size}clear(){this.d.clear()}delete(n){return this.d.delete(this.e(n))}forEach(n,r){typeof r<"u"&&(n=n.bind(r));for(const[d,l]of this.d)n(l.value,l.uri,this)}*values(){for(const n of this.d.values())yield n.value}*keys(){for(const n of this.d.values())yield n.uri}*entries(){for(const n of this.d.values())yield[n.uri,n.value]}*[(s=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.d)yield[n.uri,n.value]}}e.$Dc=I;class E{constructor(n,r){this[h]="ResourceSet",!n||typeof n=="function"?this.c=new I(n):(this.c=new I(r),n.forEach(this.add,this))}get size(){return this.c.size}add(n){return this.c.set(n,n),this}clear(){this.c.clear()}delete(n){return this.c.delete(n)}forEach(n,r){this.c.forEach((d,l)=>n.call(r,l,l,this))}has(n){return this.c.has(n)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(h=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ec=E;var g;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(g||(e.Touch=g={}));class P{constructor(){this[R]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(n){return this.c.has(n)}get(n,r=g.None){const d=this.c.get(n);if(d)return r!==g.None&&this.m(d,r),d.value}set(n,r,d=g.None){let l=this.c.get(n);if(l)l.value=r,d!==g.None&&this.m(l,d);else{switch(l={key:n,value:r,next:void 0,previous:void 0},d){case g.None:this.k(l);break;case g.AsOld:this.j(l);break;case g.AsNew:this.k(l);break;default:this.k(l);break}this.c.set(n,l),this.f++}return this}delete(n){return!!this.remove(n)}remove(n){const r=this.c.get(n);if(r)return this.c.delete(n),this.l(r),this.f--,r.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const n=this.d;return this.c.delete(n.key),this.l(n),this.f--,n.value}forEach(n,r){const d=this.g;let l=this.d;for(;l;){if(r?n.bind(r)(l.value,l.key,this):n(l.value,l.key,this),this.g!==d)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const n=this,r=this.g;let d=this.d;const l={[Symbol.iterator](){return l},next(){if(n.g!==r)throw new Error("LinkedMap got modified during iteration.");if(d){const f={value:d.key,done:!1};return d=d.next,f}else return{value:void 0,done:!0}}};return l}values(){const n=this,r=this.g;let d=this.d;const l={[Symbol.iterator](){return l},next(){if(n.g!==r)throw new Error("LinkedMap got modified during iteration.");if(d){const f={value:d.value,done:!1};return d=d.next,f}else return{value:void 0,done:!0}}};return l}entries(){const n=this,r=this.g;let d=this.d;const l={[Symbol.iterator](){return l},next(){if(n.g!==r)throw new Error("LinkedMap got modified during iteration.");if(d){const f={value:[d.key,d.value],done:!1};return d=d.next,f}else return{value:void 0,done:!0}}};return l}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(n){if(n>=this.size)return;if(n===0){this.clear();return}let r=this.d,d=this.size;for(;r&&d>n;)this.c.delete(r.key),r=r.next,d--;this.d=r,this.f=d,r&&(r.previous=void 0),this.g++}i(n){if(n>=this.size)return;if(n===0){this.clear();return}let r=this.e,d=this.size;for(;r&&d>n;)this.c.delete(r.key),r=r.previous,d--;this.e=r,this.f=d,r&&(r.next=void 0),this.g++}j(n){if(!this.d&&!this.e)this.e=n;else if(this.d)n.next=this.d,this.d.previous=n;else throw new Error("Invalid list");this.d=n,this.g++}k(n){if(!this.d&&!this.e)this.d=n;else if(this.e)n.previous=this.e,this.e.next=n;else throw new Error("Invalid list");this.e=n,this.g++}l(n){if(n===this.d&&n===this.e)this.d=void 0,this.e=void 0;else if(n===this.d){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.d=n.next}else if(n===this.e){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.e=n.previous}else{const r=n.next,d=n.previous;if(!r||!d)throw new Error("Invalid list");r.previous=d,d.next=r}n.next=void 0,n.previous=void 0,this.g++}m(n,r){if(!this.d||!this.e)throw new Error("Invalid list");if(!(r!==g.AsOld&&r!==g.AsNew)){if(r===g.AsOld){if(n===this.d)return;const d=n.next,l=n.previous;n===this.e?(l.next=void 0,this.e=l):(d.previous=l,l.next=d),n.previous=void 0,n.next=this.d,this.d.previous=n,this.d=n,this.g++}else if(r===g.AsNew){if(n===this.e)return;const d=n.next,l=n.previous;n===this.d?(d.previous=void 0,this.d=d):(d.previous=l,l.next=d),n.next=void 0,n.previous=this.e,this.e.next=n,this.e=n,this.g++}}}toJSON(){const n=[];return this.forEach((r,d)=>{n.push([d,r])}),n}fromJSON(n){this.clear();for(const[r,d]of n)this.set(r,d)}}e.$Fc=P;class b extends P{constructor(n,r=1){super(),this.n=n,this.o=Math.min(Math.max(0,r),1)}get limit(){return this.n}set limit(n){this.n=n,this.p()}get ratio(){return this.o}set ratio(n){this.o=Math.min(Math.max(0,n),1),this.p()}get(n,r=g.AsNew){return super.get(n,r)}peek(n){return super.get(n,g.None)}set(n,r){return super.set(n,r,g.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class a extends b{constructor(n,r=1){super(n,r)}q(n){this.h(n)}set(n,r){return super.set(n,r),this.p(),this}}e.$Gc=a;class $ extends b{constructor(n,r=1){super(n,r)}q(n){this.i(n)}set(n,r){return this.n<=this.size&&!this.has(n)&&this.q(Math.round(this.n*this.o)-1),super.set(n,r),this}}e.$Hc=$;class p{constructor(){this.c=new Map}add(n){return this.c.set(n,(this.c.get(n)||0)+1),this}delete(n){let r=this.c.get(n)||0;return r===0?!1:(r--,r===0?this.c.delete(n):this.c.set(n,r),!0)}has(n){return this.c.has(n)}}e.$Ic=p;class u{constructor(n){if(this.c=new Map,this.d=new Map,n)for(const[r,d]of n)this.set(r,d)}clear(){this.c.clear(),this.d.clear()}set(n,r){this.c.set(n,r),this.d.set(r,n)}get(n){return this.c.get(n)}getKey(n){return this.d.get(n)}delete(n){const r=this.c.get(n);return r===void 0?!1:(this.c.delete(n),this.d.delete(r),!0)}forEach(n,r){this.c.forEach((d,l)=>{n.call(r,d,l,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Jc=u;class i{constructor(){this.c=new Map}add(n,r){let d=this.c.get(n);d||(d=new Set,this.c.set(n,d)),d.add(r)}delete(n,r){const d=this.c.get(n);d&&(d.delete(r),d.size===0&&this.c.delete(n))}forEach(n,r){const d=this.c.get(n);d&&d.forEach(r)}get(n){const r=this.c.get(n);return r||new Set}}e.$Kc=i;function o(t,n){if(t===n)return!0;if(t.size!==n.size)return!1;for(const[r,d]of t)if(!n.has(r)||n.get(r)!==d)return!1;for(const[r]of n)if(!t.has(r))return!1;return!0}}),define(Re[3],Ce([1,0,18,80,28,81,40]),function(ge,e,s,h,R,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$5c=e.$4c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Mc=void 0,e.$Nc=I,e.$Oc=E,e.$Pc=g,e.$Qc=a,e.$Rc=$,e.$Sc=p,e.$Tc=u,e.$Uc=i,e.$Vc=o,e.$6c=D;const C=!1;let m=null;class c{constructor(){this.b=new Map}static{this.a=0}c(w){let M=this.b.get(w);return M||(M={parent:null,source:null,isSingleton:!1,value:w,idx:c.a++},this.b.set(w,M)),M}trackDisposable(w){const M=this.c(w);M.source||(M.source=new Error().stack)}setParent(w,M){const L=this.c(w);L.parent=M}markAsDisposed(w){this.b.delete(w)}markAsSingleton(w){this.c(w).isSingleton=!0}f(w,M){const L=M.get(w);if(L)return L;const N=w.parent?this.f(this.c(w.parent),M):w;return M.set(w,N),N}getTrackedDisposables(){const w=new Map;return[...this.b.entries()].filter(([,L])=>L.source!==null&&!this.f(L,w).isSingleton).flatMap(([L])=>L)}computeLeakingDisposables(w=10,M){let L;if(M)L=M;else{const U=new Map,z=[...this.b.values()].filter(W=>W.source!==null&&!this.f(W,U).isSingleton);if(z.length===0)return;const _=new Set(z.map(W=>W.value));if(L=z.filter(W=>!(W.parent&&_.has(W.parent))),L.length===0)throw new Error("There are cyclic diposable chains!")}if(!L)return;function N(U){function z(W,B){for(;W.length>0&&B.some(Y=>typeof Y=="string"?Y===W[0]:W[0].match(Y));)W.shift()}const _=U.source.split(`
`).map(W=>W.trim().replace("at ","")).filter(W=>W!=="");return z(_,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),_.reverse()}const F=new R.$Kc;for(const U of L){const z=N(U);for(let _=0;_<=z.length;_++)F.add(z.slice(0,_).join(`
`),U)}L.sort((0,s.$8b)(U=>U.idx,s.$0b));let V="",j=0;for(const U of L.slice(0,w)){j++;const z=N(U),_=[];for(let W=0;W<z.length;W++){let B=z[W];B=`(shared with ${F.get(z.slice(0,W+1).join(`
`)).size}/${L.length} leaks) at ${B}`;const x=F.get(z.slice(0,W).join(`
`)),oe=(0,h.$c)([...x].map(ie=>N(ie)[W]),ie=>ie);delete oe[z[W]];for(const[ie,me]of Object.entries(oe))_.unshift(`    - stacktraces of ${me.length} other leaks continue with ${ie}`);_.unshift(B)}V+=`


==================== Leaking disposable ${j}/${L.length}: ${U.value.constructor.name} ====================
${_.join(`
`)}
============================================================

`}return L.length>w&&(V+=`


... and ${L.length-w} more leaking disposables

`),{leaks:L,details:V}}}e.$Mc=c;function I(v){m=v}if(C){const v="__is_disposable_tracked__";I(new class{trackDisposable(w){const M=new Error("Potentially leaked disposable").stack;setTimeout(()=>{w[v]||console.log(M)},3e3)}setParent(w,M){if(w&&w!==n.None)try{w[v]=!0}catch{}}markAsDisposed(w){if(w&&w!==n.None)try{w[v]=!0}catch{}}markAsSingleton(w){}})}function E(v){return m?.trackDisposable(v),v}function g(v){m?.markAsDisposed(v)}function P(v,w){m?.setParent(v,w)}function b(v,w){if(m)for(const M of v)m.setParent(M,w)}function a(v){return m?.markAsSingleton(v),v}function $(v){return typeof v=="object"&&v!==null&&typeof v.dispose=="function"&&v.dispose.length===0}function p(v){if(O.Iterable.is(v)){const w=[];for(const M of v)if(M)try{M.dispose()}catch(L){w.push(L)}if(w.length===1)throw w[0];if(w.length>1)throw new AggregateError(w,"Encountered errors while disposing of store");return Array.isArray(v)?[]:v}else if(v)return v.dispose(),v}function u(v){for(const w of v)$(w)&&w.dispose();return[]}function i(...v){const w=o(()=>p(v));return b(v,w),w}function o(v){const w=E({dispose:(0,A.$fb)(()=>{g(w),v()})});return w}class t{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,E(this)}dispose(){this.g||(g(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{p(this.f)}finally{this.f.clear()}}add(w){if(!w)return w;if(w===this)throw new Error("Cannot register a disposable on itself!");return P(w,this),this.g?t.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(w),w}delete(w){if(w){if(w===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(w),w.dispose()}}deleteAndLeak(w){w&&this.f.has(w)&&(this.f.delete(w),P(w,null))}}e.$Wc=t;class n{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new t,E(this),P(this.q,this)}dispose(){g(this),this.q.dispose()}B(w){if(w===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(w)}}e.$Xc=n;class r{constructor(){this.b=!1,E(this)}get value(){return this.b?void 0:this.a}set value(w){this.b||w===this.a||(this.a?.dispose(),w&&P(w,this),this.a=w)}clear(){this.value=void 0}dispose(){this.b=!0,g(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const w=this.a;return this.a=void 0,w&&P(w,null),w}}e.$Yc=r;class d{constructor(w){this.a=new r,this.b=!1,this.a.value=w}get value(){return this.a.value}set value(w){this.b||w===this.a.value||(this.a.value=w)}dispose(){this.b=!0,this.a.dispose()}}e.$Zc=d;class l{constructor(w){this.b=w,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$1c=l;class f{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,E(this)}set(w){let M=w;return this.unset=()=>M=void 0,this.isset=()=>M!==void 0,this.dispose=()=>{M&&(M(),M=void 0,g(this))},this}}e.$2c=f;class y{constructor(){this.a=new Map}acquire(w,...M){let L=this.a.get(w);L||(L={counter:0,object:this.b(w,...M)},this.a.set(w,L));const{object:N}=L,F=(0,A.$fb)(()=>{--L.counter===0&&(this.c(w,L.object),this.a.delete(w))});return L.counter++,{object:N,dispose:F}}}e.$3c=y;class k{constructor(w){this.a=w}async acquire(w,...M){const L=this.a.acquire(w,...M);try{return{object:await L.object,dispose:()=>L.dispose()}}catch(N){throw L.dispose(),N}}}e.$4c=k;class S{constructor(w){this.object=w}dispose(){}}e.$5c=S;function D(v){const w=new t;try{v(w)}finally{w.dispose()}}class T{constructor(){this.a=new Map,this.b=!1,E(this)}dispose(){g(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{p(this.a.values())}finally{this.a.clear()}}has(w){return this.a.has(w)}get size(){return this.a.size}get(w){return this.a.get(w)}set(w,M,L=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),L||this.a.get(w)?.dispose(),this.a.set(w,M)}deleteAndDispose(w){this.a.get(w)?.dispose(),this.a.delete(w)}deleteAndLeak(w){const M=this.a.get(w);return this.a.delete(w),M}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$7c=T}),function(ge,e){typeof define=="function"&&define.amd?define(Re[181],Ce([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ge=typeof globalThis<"u"?globalThis:ge||self,e(ge.marked={}))}(this,function(ge){"use strict";function e(){return{async:!1,breaks:!1,extensions:null,gfm:!0,hooks:null,pedantic:!1,renderer:null,silent:!1,tokenizer:null,walkTokens:null}}ge.defaults=e();function s(it){ge.defaults=it}const h=/[&<>"']/,R=new RegExp(h.source,"g"),A=/[<>"']|&(?!(#\d{1,7}|#[Xx][a-fA-F0-9]{1,6}|\w+);)/,O=new RegExp(A.source,"g"),C={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=it=>C[it];function c(it,Ie){if(Ie){if(h.test(it))return it.replace(R,m)}else if(A.test(it))return it.replace(O,m);return it}const I=/(^|[^\[])\^/g;function E(it,Ie){let re=typeof it=="string"?it:it.source;Ie=Ie||"";const ce={replace:(Se,de)=>{let ke=typeof de=="string"?de:de.source;return ke=ke.replace(I,"$1"),re=re.replace(Se,ke),ce},getRegex:()=>new RegExp(re,Ie)};return ce}function g(it){try{it=encodeURI(it).replace(/%25/g,"%")}catch{return null}return it}const P={exec:()=>null};function b(it,Ie){const re=it.replace(/\|/g,(de,ke,ne)=>{let J=!1,Pe=ke;for(;--Pe>=0&&ne[Pe]==="\\";)J=!J;return J?"|":" |"}),ce=re.split(/ \|/);let Se=0;if(ce[0].trim()||ce.shift(),ce.length>0&&!ce[ce.length-1].trim()&&ce.pop(),Ie)if(ce.length>Ie)ce.splice(Ie);else for(;ce.length<Ie;)ce.push("");for(;Se<ce.length;Se++)ce[Se]=ce[Se].trim().replace(/\\\|/g,"|");return ce}function a(it,Ie,re){const ce=it.length;if(ce===0)return"";let Se=0;for(;Se<ce;){const de=it.charAt(ce-Se-1);if(de===Ie&&!re)Se++;else if(de!==Ie&&re)Se++;else break}return it.slice(0,ce-Se)}function $(it,Ie){if(it.indexOf(Ie[1])===-1)return-1;let re=0;for(let ce=0;ce<it.length;ce++)if(it[ce]==="\\")ce++;else if(it[ce]===Ie[0])re++;else if(it[ce]===Ie[1]&&(re--,re<0))return ce;return-1}function p(it,Ie,re,ce){const Se=Ie.href,de=Ie.title?c(Ie.title):null,ke=it[1].replace(/\\([\[\]])/g,"$1");if(it[0].charAt(0)!=="!"){ce.state.inLink=!0;const ne={type:"link",raw:re,href:Se,title:de,text:ke,tokens:ce.inlineTokens(ke)};return ce.state.inLink=!1,ne}return{type:"image",raw:re,href:Se,title:de,text:c(ke)}}function u(it,Ie){const re=it.match(/^(\s+)(?:```)/);if(re===null)return Ie;const ce=re[1];return Ie.split(`
`).map(Se=>{const de=Se.match(/^\s+/);if(de===null)return Se;const[ke]=de;return ke.length>=ce.length?Se.slice(ce.length):Se}).join(`
`)}class i{options;rules;lexer;constructor(Ie){this.options=Ie||ge.defaults}space(Ie){const re=this.rules.block.newline.exec(Ie);if(re&&re[0].length>0)return{type:"space",raw:re[0]}}code(Ie){const re=this.rules.block.code.exec(Ie);if(re){const ce=re[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:re[0],codeBlockStyle:"indented",text:this.options.pedantic?ce:a(ce,`
`)}}}fences(Ie){const re=this.rules.block.fences.exec(Ie);if(re){const ce=re[0],Se=u(ce,re[3]||"");return{type:"code",raw:ce,lang:re[2]?re[2].trim().replace(this.rules.inline.anyPunctuation,"$1"):re[2],text:Se}}}heading(Ie){const re=this.rules.block.heading.exec(Ie);if(re){let ce=re[2].trim();if(/#$/.test(ce)){const Se=a(ce,"#");(this.options.pedantic||!Se||/ $/.test(Se))&&(ce=Se.trim())}return{type:"heading",raw:re[0],depth:re[1].length,text:ce,tokens:this.lexer.inline(ce)}}}hr(Ie){const re=this.rules.block.hr.exec(Ie);if(re)return{type:"hr",raw:a(re[0],`
`)}}blockquote(Ie){const re=this.rules.block.blockquote.exec(Ie);if(re){let ce=a(re[0],`
`).split(`
`),Se="",de="";const ke=[];for(;ce.length>0;){let ne=!1;const J=[];let Pe;for(Pe=0;Pe<ce.length;Pe++)if(/^ {0,3}>/.test(ce[Pe]))J.push(ce[Pe]),ne=!0;else if(!ne)J.push(ce[Pe]);else break;ce=ce.slice(Pe);const Ge=J.join(`
`),Je=Ge.replace(/\n {0,3}((?:=+|-+) *)(?=\n|$)/g,`
    $1`).replace(/^ {0,3}>[ \t]?/gm,"");Se=Se?`${Se}
${Ge}`:Ge,de=de?`${de}
${Je}`:Je;const st=this.lexer.state.top;if(this.lexer.state.top=!0,this.lexer.blockTokens(Je,ke,!0),this.lexer.state.top=st,ce.length===0)break;const ht=ke[ke.length-1];if(ht?.type==="code")break;if(ht?.type==="blockquote"){const ft=ht,St=ft.raw+`
`+ce.join(`
`),At=this.blockquote(St);ke[ke.length-1]=At,Se=Se.substring(0,Se.length-ft.raw.length)+At.raw,de=de.substring(0,de.length-ft.text.length)+At.text;break}else if(ht?.type==="list"){const ft=ht,St=ft.raw+`
`+ce.join(`
`),At=this.list(St);ke[ke.length-1]=At,Se=Se.substring(0,Se.length-ht.raw.length)+At.raw,de=de.substring(0,de.length-ft.raw.length)+At.raw,ce=St.substring(ke[ke.length-1].raw.length).split(`
`);continue}}return{type:"blockquote",raw:Se,tokens:ke,text:de}}}list(Ie){let re=this.rules.block.list.exec(Ie);if(re){let ce=re[1].trim();const Se=ce.length>1,de={type:"list",raw:"",ordered:Se,start:Se?+ce.slice(0,-1):"",loose:!1,items:[]};ce=Se?`\\d{1,9}\\${ce.slice(-1)}`:`\\${ce}`,this.options.pedantic&&(ce=Se?ce:"[*+-]");const ke=new RegExp(`^( {0,3}${ce})((?:[	 ][^\\n]*)?(?:\\n|$))`);let ne=!1;for(;Ie;){let J=!1,Pe="",Ge="";if(!(re=ke.exec(Ie))||this.rules.block.hr.test(Ie))break;Pe=re[0],Ie=Ie.substring(Pe.length);let Je=re[2].split(`
`,1)[0].replace(/^\t+/,Qt=>" ".repeat(3*Qt.length)),st=Ie.split(`
`,1)[0],ht=!Je.trim(),ft=0;if(this.options.pedantic?(ft=2,Ge=Je.trimStart()):ht?ft=re[1].length+1:(ft=re[2].search(/[^ ]/),ft=ft>4?1:ft,Ge=Je.slice(ft),ft+=re[1].length),ht&&/^ *$/.test(st)&&(Pe+=st+`
`,Ie=Ie.substring(st.length+1),J=!0),!J){const Qt=new RegExp(`^ {0,${Math.min(3,ft-1)}}(?:[*+-]|\\d{1,9}[.)])((?:[ 	][^\\n]*)?(?:\\n|$))`),ei=new RegExp(`^ {0,${Math.min(3,ft-1)}}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)`),tt=new RegExp(`^ {0,${Math.min(3,ft-1)}}(?:\`\`\`|~~~)`),Ot=new RegExp(`^ {0,${Math.min(3,ft-1)}}#`);for(;Ie;){const zt=Ie.split(`
`,1)[0];if(st=zt,this.options.pedantic&&(st=st.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),tt.test(st)||Ot.test(st)||Qt.test(st)||ei.test(Ie))break;if(st.search(/[^ ]/)>=ft||!st.trim())Ge+=`
`+st.slice(ft);else{if(ht||Je.search(/[^ ]/)>=4||tt.test(Je)||Ot.test(Je)||ei.test(Je))break;Ge+=`
`+st}!ht&&!st.trim()&&(ht=!0),Pe+=zt+`
`,Ie=Ie.substring(zt.length+1),Je=st.slice(ft)}}de.loose||(ne?de.loose=!0:/\n *\n *$/.test(Pe)&&(ne=!0));let St=null,At;this.options.gfm&&(St=/^\[[ xX]\] /.exec(Ge),St&&(At=St[0]!=="[ ] ",Ge=Ge.replace(/^\[[ xX]\] +/,""))),de.items.push({type:"list_item",raw:Pe,task:!!St,checked:At,loose:!1,text:Ge,tokens:[]}),de.raw+=Pe}de.items[de.items.length-1].raw=de.items[de.items.length-1].raw.trimEnd(),de.items[de.items.length-1].text=de.items[de.items.length-1].text.trimEnd(),de.raw=de.raw.trimEnd();for(let J=0;J<de.items.length;J++)if(this.lexer.state.top=!1,de.items[J].tokens=this.lexer.blockTokens(de.items[J].text,[]),!de.loose){const Pe=de.items[J].tokens.filter(Je=>Je.type==="space"),Ge=Pe.length>0&&Pe.some(Je=>/\n.*\n/.test(Je.raw));de.loose=Ge}if(de.loose)for(let J=0;J<de.items.length;J++)de.items[J].loose=!0;return de}}html(Ie){const re=this.rules.block.html.exec(Ie);if(re)return{type:"html",block:!0,raw:re[0],pre:re[1]==="pre"||re[1]==="script"||re[1]==="style",text:re[0]}}def(Ie){const re=this.rules.block.def.exec(Ie);if(re){const ce=re[1].toLowerCase().replace(/\s+/g," "),Se=re[2]?re[2].replace(/^<(.*)>$/,"$1").replace(this.rules.inline.anyPunctuation,"$1"):"",de=re[3]?re[3].substring(1,re[3].length-1).replace(this.rules.inline.anyPunctuation,"$1"):re[3];return{type:"def",tag:ce,raw:re[0],href:Se,title:de}}}table(Ie){const re=this.rules.block.table.exec(Ie);if(!re||!/[:|]/.test(re[2]))return;const ce=b(re[1]),Se=re[2].replace(/^\||\| *$/g,"").split("|"),de=re[3]&&re[3].trim()?re[3].replace(/\n[ \t]*$/,"").split(`
`):[],ke={type:"table",raw:re[0],header:[],align:[],rows:[]};if(ce.length===Se.length){for(const ne of Se)/^ *-+: *$/.test(ne)?ke.align.push("right"):/^ *:-+: *$/.test(ne)?ke.align.push("center"):/^ *:-+ *$/.test(ne)?ke.align.push("left"):ke.align.push(null);for(let ne=0;ne<ce.length;ne++)ke.header.push({text:ce[ne],tokens:this.lexer.inline(ce[ne]),header:!0,align:ke.align[ne]});for(const ne of de)ke.rows.push(b(ne,ke.header.length).map((J,Pe)=>({text:J,tokens:this.lexer.inline(J),header:!1,align:ke.align[Pe]})));return ke}}lheading(Ie){const re=this.rules.block.lheading.exec(Ie);if(re)return{type:"heading",raw:re[0],depth:re[2].charAt(0)==="="?1:2,text:re[1],tokens:this.lexer.inline(re[1])}}paragraph(Ie){const re=this.rules.block.paragraph.exec(Ie);if(re){const ce=re[1].charAt(re[1].length-1)===`
`?re[1].slice(0,-1):re[1];return{type:"paragraph",raw:re[0],text:ce,tokens:this.lexer.inline(ce)}}}text(Ie){const re=this.rules.block.text.exec(Ie);if(re)return{type:"text",raw:re[0],text:re[0],tokens:this.lexer.inline(re[0])}}escape(Ie){const re=this.rules.inline.escape.exec(Ie);if(re)return{type:"escape",raw:re[0],text:c(re[1])}}tag(Ie){const re=this.rules.inline.tag.exec(Ie);if(re)return!this.lexer.state.inLink&&/^<a /i.test(re[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(re[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(re[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(re[0])&&(this.lexer.state.inRawBlock=!1),{type:"html",raw:re[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,block:!1,text:re[0]}}link(Ie){const re=this.rules.inline.link.exec(Ie);if(re){const ce=re[2].trim();if(!this.options.pedantic&&/^</.test(ce)){if(!/>$/.test(ce))return;const ke=a(ce.slice(0,-1),"\\");if((ce.length-ke.length)%2===0)return}else{const ke=$(re[2],"()");if(ke>-1){const J=(re[0].indexOf("!")===0?5:4)+re[1].length+ke;re[2]=re[2].substring(0,ke),re[0]=re[0].substring(0,J).trim(),re[3]=""}}let Se=re[2],de="";if(this.options.pedantic){const ke=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Se);ke&&(Se=ke[1],de=ke[3])}else de=re[3]?re[3].slice(1,-1):"";return Se=Se.trim(),/^</.test(Se)&&(this.options.pedantic&&!/>$/.test(ce)?Se=Se.slice(1):Se=Se.slice(1,-1)),p(re,{href:Se&&Se.replace(this.rules.inline.anyPunctuation,"$1"),title:de&&de.replace(this.rules.inline.anyPunctuation,"$1")},re[0],this.lexer)}}reflink(Ie,re){let ce;if((ce=this.rules.inline.reflink.exec(Ie))||(ce=this.rules.inline.nolink.exec(Ie))){const Se=(ce[2]||ce[1]).replace(/\s+/g," "),de=re[Se.toLowerCase()];if(!de){const ke=ce[0].charAt(0);return{type:"text",raw:ke,text:ke}}return p(ce,de,ce[0],this.lexer)}}emStrong(Ie,re,ce=""){let Se=this.rules.inline.emStrongLDelim.exec(Ie);if(!Se||Se[3]&&ce.match(/[\p{L}\p{N}]/u))return;if(!(Se[1]||Se[2]||"")||!ce||this.rules.inline.punctuation.exec(ce)){const ke=[...Se[0]].length-1;let ne,J,Pe=ke,Ge=0;const Je=Se[0][0]==="*"?this.rules.inline.emStrongRDelimAst:this.rules.inline.emStrongRDelimUnd;for(Je.lastIndex=0,re=re.slice(-1*Ie.length+ke);(Se=Je.exec(re))!=null;){if(ne=Se[1]||Se[2]||Se[3]||Se[4]||Se[5]||Se[6],!ne)continue;if(J=[...ne].length,Se[3]||Se[4]){Pe+=J;continue}else if((Se[5]||Se[6])&&ke%3&&!((ke+J)%3)){Ge+=J;continue}if(Pe-=J,Pe>0)continue;J=Math.min(J,J+Pe+Ge);const st=[...Se[0]][0].length,ht=Ie.slice(0,ke+Se.index+st+J);if(Math.min(ke,J)%2){const St=ht.slice(1,-1);return{type:"em",raw:ht,text:St,tokens:this.lexer.inlineTokens(St)}}const ft=ht.slice(2,-2);return{type:"strong",raw:ht,text:ft,tokens:this.lexer.inlineTokens(ft)}}}}codespan(Ie){const re=this.rules.inline.code.exec(Ie);if(re){let ce=re[2].replace(/\n/g," ");const Se=/[^ ]/.test(ce),de=/^ /.test(ce)&&/ $/.test(ce);return Se&&de&&(ce=ce.substring(1,ce.length-1)),ce=c(ce,!0),{type:"codespan",raw:re[0],text:ce}}}br(Ie){const re=this.rules.inline.br.exec(Ie);if(re)return{type:"br",raw:re[0]}}del(Ie){const re=this.rules.inline.del.exec(Ie);if(re)return{type:"del",raw:re[0],text:re[2],tokens:this.lexer.inlineTokens(re[2])}}autolink(Ie){const re=this.rules.inline.autolink.exec(Ie);if(re){let ce,Se;return re[2]==="@"?(ce=c(re[1]),Se="mailto:"+ce):(ce=c(re[1]),Se=ce),{type:"link",raw:re[0],text:ce,href:Se,tokens:[{type:"text",raw:ce,text:ce}]}}}url(Ie){let re;if(re=this.rules.inline.url.exec(Ie)){let ce,Se;if(re[2]==="@")ce=c(re[0]),Se="mailto:"+ce;else{let de;do de=re[0],re[0]=this.rules.inline._backpedal.exec(re[0])?.[0]??"";while(de!==re[0]);ce=c(re[0]),re[1]==="www."?Se="http://"+re[0]:Se=re[0]}return{type:"link",raw:re[0],text:ce,href:Se,tokens:[{type:"text",raw:ce,text:ce}]}}}inlineText(Ie){const re=this.rules.inline.text.exec(Ie);if(re){let ce;return this.lexer.state.inRawBlock?ce=re[0]:ce=c(re[0]),{type:"text",raw:re[0],text:ce}}}}const o=/^(?: *(?:\n|$))+/,t=/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,n=/^ {0,3}(`{3,}(?=[^`\n]*(?:\n|$))|~{3,})([^\n]*)(?:\n|$)(?:|([\s\S]*?)(?:\n|$))(?: {0,3}\1[~`]* *(?=\n|$)|$)/,r=/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,d=/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,l=/(?:[*+-]|\d{1,9}[.)])/,f=E(/^(?!bull |blockCode|fences|blockquote|heading|html)((?:.|\n(?!\s*?\n|bull |blockCode|fences|blockquote|heading|html))+?)\n {0,3}(=+|-+) *(?:\n+|$)/).replace(/bull/g,l).replace(/blockCode/g,/ {4}/).replace(/fences/g,/ {0,3}(?:`{3,}|~{3,})/).replace(/blockquote/g,/ {0,3}>/).replace(/heading/g,/ {0,3}#{1,6}/).replace(/html/g,/ {0,3}<[^\n>]+>\n/).getRegex(),y=/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,k=/^[^\n]+/,S=/(?!\s*\])(?:\\.|[^\[\]\\])+/,D=E(/^ {0,3}\[(label)\]: *(?:\n *)?([^<\s][^\s]*|<.*?>)(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/).replace("label",S).replace("title",/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/).getRegex(),T=E(/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/).replace(/bull/g,l).getRegex(),v="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|search|section|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",w=/<!--(?:-?>|[\s\S]*?(?:-->|$))/,M=E("^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))","i").replace("comment",w).replace("tag",v).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),L=E(y).replace("hr",r).replace("heading"," {0,3}#{1,6}(?:\\s|$)").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",v).getRegex(),F={blockquote:E(/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/).replace("paragraph",L).getRegex(),code:t,def:D,fences:n,heading:d,hr:r,html:M,lheading:f,list:T,newline:o,paragraph:L,table:P,text:k},V=E("^ *([^\\n ].*)\\n {0,3}((?:\\| *)?:?-+:? *(?:\\| *:?-+:? *)*(?:\\| *)?)(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)").replace("hr",r).replace("heading"," {0,3}#{1,6}(?:\\s|$)").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",v).getRegex(),j={...F,table:V,paragraph:E(y).replace("hr",r).replace("heading"," {0,3}#{1,6}(?:\\s|$)").replace("|lheading","").replace("table",V).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",v).getRegex()},U={...F,html:E(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",w).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:P,lheading:/^(.+?)\n {0,3}(=+|-+) *(?:\n+|$)/,paragraph:E(y).replace("hr",r).replace("heading",` *#{1,6} *[^
]`).replace("lheading",f).replace("|table","").replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").replace("|tag","").getRegex()},z=/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,_=/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,W=/^( {2,}|\\)\n(?!\s*$)/,B=/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,Y="\\p{P}\\p{S}",x=E(/^((?![*_])[\spunctuation])/,"u").replace(/punctuation/g,Y).getRegex(),oe=/\[[^[\]]*?\]\([^\(\)]*?\)|`[^`]*?`|<[^<>]*?>/g,ie=E(/^(?:\*+(?:((?!\*)[punct])|[^\s*]))|^_+(?:((?!_)[punct])|([^\s_]))/,"u").replace(/punct/g,Y).getRegex(),me=E("^[^_*]*?__[^_*]*?\\*[^_*]*?(?=__)|[^*]+(?=[^*])|(?!\\*)[punct](\\*+)(?=[\\s]|$)|[^punct\\s](\\*+)(?!\\*)(?=[punct\\s]|$)|(?!\\*)[punct\\s](\\*+)(?=[^punct\\s])|[\\s](\\*+)(?!\\*)(?=[punct])|(?!\\*)[punct](\\*+)(?!\\*)(?=[punct])|[^punct\\s](\\*+)(?=[^punct\\s])","gu").replace(/punct/g,Y).getRegex(),ue=E("^[^_*]*?\\*\\*[^_*]*?_[^_*]*?(?=\\*\\*)|[^_]+(?=[^_])|(?!_)[punct](_+)(?=[\\s]|$)|[^punct\\s](_+)(?!_)(?=[punct\\s]|$)|(?!_)[punct\\s](_+)(?=[^punct\\s])|[\\s](_+)(?!_)(?=[punct])|(?!_)[punct](_+)(?!_)(?=[punct])","gu").replace(/punct/g,Y).getRegex(),X=E(/\\([punct])/,"gu").replace(/punct/g,Y).getRegex(),q=E(/^<(scheme:[^\s\x00-\x1f<>]*|email)>/).replace("scheme",/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/).replace("email",/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/).getRegex(),se=E(w).replace("(?:-->|$)","-->").getRegex(),be=E("^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>").replace("comment",se).replace("attribute",/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/).getRegex(),ae=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,we=E(/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/).replace("label",ae).replace("href",/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/).replace("title",/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/).getRegex(),$e=E(/^!?\[(label)\]\[(ref)\]/).replace("label",ae).replace("ref",S).getRegex(),pe=E(/^!?\[(ref)\](?:\[\])?/).replace("ref",S).getRegex(),Ae=E("reflink|nolink(?!\\()","g").replace("reflink",$e).replace("nolink",pe).getRegex(),je={_backpedal:P,anyPunctuation:X,autolink:q,blockSkip:oe,br:W,code:_,del:P,emStrongLDelim:ie,emStrongRDelimAst:me,emStrongRDelimUnd:ue,escape:z,link:we,nolink:pe,punctuation:x,reflink:$e,reflinkSearch:Ae,tag:be,text:B,url:P},He={...je,link:E(/^!?\[(label)\]\((.*?)\)/).replace("label",ae).getRegex(),reflink:E(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ae).getRegex()},Ye={...je,escape:E(z).replace("])","~|])").getRegex(),url:E(/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,"i").replace("email",/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/).getRegex(),_backpedal:/(?:[^?!.,:;*_'"~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_'"~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/},xe={...Ye,br:E(W).replace("{2,}","*").getRegex(),text:E(Ye.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()},Fe={normal:F,gfm:j,pedantic:U},We={normal:je,gfm:Ye,breaks:xe,pedantic:He};class Ne{tokens;options;state;tokenizer;inlineQueue;constructor(Ie){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ie||ge.defaults,this.options.tokenizer=this.options.tokenizer||new i,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};const re={block:Fe.normal,inline:We.normal};this.options.pedantic?(re.block=Fe.pedantic,re.inline=We.pedantic):this.options.gfm&&(re.block=Fe.gfm,this.options.breaks?re.inline=We.breaks:re.inline=We.gfm),this.tokenizer.rules=re}static get rules(){return{block:Fe,inline:We}}static lex(Ie,re){return new Ne(re).lex(Ie)}static lexInline(Ie,re){return new Ne(re).inlineTokens(Ie)}lex(Ie){Ie=Ie.replace(/\r\n|\r/g,`
`),this.blockTokens(Ie,this.tokens);for(let re=0;re<this.inlineQueue.length;re++){const ce=this.inlineQueue[re];this.inlineTokens(ce.src,ce.tokens)}return this.inlineQueue=[],this.tokens}blockTokens(Ie,re=[],ce=!1){this.options.pedantic?Ie=Ie.replace(/\t/g,"    ").replace(/^ +$/gm,""):Ie=Ie.replace(/^( *)(\t+)/gm,(ne,J,Pe)=>J+"    ".repeat(Pe.length));let Se,de,ke;for(;Ie;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(ne=>(Se=ne.call({lexer:this},Ie,re))?(Ie=Ie.substring(Se.raw.length),re.push(Se),!0):!1))){if(Se=this.tokenizer.space(Ie)){Ie=Ie.substring(Se.raw.length),Se.raw.length===1&&re.length>0?re[re.length-1].raw+=`
`:re.push(Se);continue}if(Se=this.tokenizer.code(Ie)){Ie=Ie.substring(Se.raw.length),de=re[re.length-1],de&&(de.type==="paragraph"||de.type==="text")?(de.raw+=`
`+Se.raw,de.text+=`
`+Se.text,this.inlineQueue[this.inlineQueue.length-1].src=de.text):re.push(Se);continue}if(Se=this.tokenizer.fences(Ie)){Ie=Ie.substring(Se.raw.length),re.push(Se);continue}if(Se=this.tokenizer.heading(Ie)){Ie=Ie.substring(Se.raw.length),re.push(Se);continue}if(Se=this.tokenizer.hr(Ie)){Ie=Ie.substring(Se.raw.length),re.push(Se);continue}if(Se=this.tokenizer.blockquote(Ie)){Ie=Ie.substring(Se.raw.length),re.push(Se);continue}if(Se=this.tokenizer.list(Ie)){Ie=Ie.substring(Se.raw.length),re.push(Se);continue}if(Se=this.tokenizer.html(Ie)){Ie=Ie.substring(Se.raw.length),re.push(Se);continue}if(Se=this.tokenizer.def(Ie)){Ie=Ie.substring(Se.raw.length),de=re[re.length-1],de&&(de.type==="paragraph"||de.type==="text")?(de.raw+=`
`+Se.raw,de.text+=`
`+Se.raw,this.inlineQueue[this.inlineQueue.length-1].src=de.text):this.tokens.links[Se.tag]||(this.tokens.links[Se.tag]={href:Se.href,title:Se.title});continue}if(Se=this.tokenizer.table(Ie)){Ie=Ie.substring(Se.raw.length),re.push(Se);continue}if(Se=this.tokenizer.lheading(Ie)){Ie=Ie.substring(Se.raw.length),re.push(Se);continue}if(ke=Ie,this.options.extensions&&this.options.extensions.startBlock){let ne=1/0;const J=Ie.slice(1);let Pe;this.options.extensions.startBlock.forEach(Ge=>{Pe=Ge.call({lexer:this},J),typeof Pe=="number"&&Pe>=0&&(ne=Math.min(ne,Pe))}),ne<1/0&&ne>=0&&(ke=Ie.substring(0,ne+1))}if(this.state.top&&(Se=this.tokenizer.paragraph(ke))){de=re[re.length-1],ce&&de?.type==="paragraph"?(de.raw+=`
`+Se.raw,de.text+=`
`+Se.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=de.text):re.push(Se),ce=ke.length!==Ie.length,Ie=Ie.substring(Se.raw.length);continue}if(Se=this.tokenizer.text(Ie)){Ie=Ie.substring(Se.raw.length),de=re[re.length-1],de&&de.type==="text"?(de.raw+=`
`+Se.raw,de.text+=`
`+Se.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=de.text):re.push(Se);continue}if(Ie){const ne="Infinite loop on byte: "+Ie.charCodeAt(0);if(this.options.silent){console.error(ne);break}else throw new Error(ne)}}return this.state.top=!0,re}inline(Ie,re=[]){return this.inlineQueue.push({src:Ie,tokens:re}),re}inlineTokens(Ie,re=[]){let ce,Se,de,ke=Ie,ne,J,Pe;if(this.tokens.links){const Ge=Object.keys(this.tokens.links);if(Ge.length>0)for(;(ne=this.tokenizer.rules.inline.reflinkSearch.exec(ke))!=null;)Ge.includes(ne[0].slice(ne[0].lastIndexOf("[")+1,-1))&&(ke=ke.slice(0,ne.index)+"["+"a".repeat(ne[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ne=this.tokenizer.rules.inline.blockSkip.exec(ke))!=null;)ke=ke.slice(0,ne.index)+"["+"a".repeat(ne[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ne=this.tokenizer.rules.inline.anyPunctuation.exec(ke))!=null;)ke=ke.slice(0,ne.index)+"++"+ke.slice(this.tokenizer.rules.inline.anyPunctuation.lastIndex);for(;Ie;)if(J||(Pe=""),J=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(Ge=>(ce=Ge.call({lexer:this},Ie,re))?(Ie=Ie.substring(ce.raw.length),re.push(ce),!0):!1))){if(ce=this.tokenizer.escape(Ie)){Ie=Ie.substring(ce.raw.length),re.push(ce);continue}if(ce=this.tokenizer.tag(Ie)){Ie=Ie.substring(ce.raw.length),Se=re[re.length-1],Se&&ce.type==="text"&&Se.type==="text"?(Se.raw+=ce.raw,Se.text+=ce.text):re.push(ce);continue}if(ce=this.tokenizer.link(Ie)){Ie=Ie.substring(ce.raw.length),re.push(ce);continue}if(ce=this.tokenizer.reflink(Ie,this.tokens.links)){Ie=Ie.substring(ce.raw.length),Se=re[re.length-1],Se&&ce.type==="text"&&Se.type==="text"?(Se.raw+=ce.raw,Se.text+=ce.text):re.push(ce);continue}if(ce=this.tokenizer.emStrong(Ie,ke,Pe)){Ie=Ie.substring(ce.raw.length),re.push(ce);continue}if(ce=this.tokenizer.codespan(Ie)){Ie=Ie.substring(ce.raw.length),re.push(ce);continue}if(ce=this.tokenizer.br(Ie)){Ie=Ie.substring(ce.raw.length),re.push(ce);continue}if(ce=this.tokenizer.del(Ie)){Ie=Ie.substring(ce.raw.length),re.push(ce);continue}if(ce=this.tokenizer.autolink(Ie)){Ie=Ie.substring(ce.raw.length),re.push(ce);continue}if(!this.state.inLink&&(ce=this.tokenizer.url(Ie))){Ie=Ie.substring(ce.raw.length),re.push(ce);continue}if(de=Ie,this.options.extensions&&this.options.extensions.startInline){let Ge=1/0;const Je=Ie.slice(1);let st;this.options.extensions.startInline.forEach(ht=>{st=ht.call({lexer:this},Je),typeof st=="number"&&st>=0&&(Ge=Math.min(Ge,st))}),Ge<1/0&&Ge>=0&&(de=Ie.substring(0,Ge+1))}if(ce=this.tokenizer.inlineText(de)){Ie=Ie.substring(ce.raw.length),ce.raw.slice(-1)!=="_"&&(Pe=ce.raw.slice(-1)),J=!0,Se=re[re.length-1],Se&&Se.type==="text"?(Se.raw+=ce.raw,Se.text+=ce.text):re.push(ce);continue}if(Ie){const Ge="Infinite loop on byte: "+Ie.charCodeAt(0);if(this.options.silent){console.error(Ge);break}else throw new Error(Ge)}}return re}}class H{options;parser;constructor(Ie){this.options=Ie||ge.defaults}space(Ie){return""}code({text:Ie,lang:re,escaped:ce}){const Se=(re||"").match(/^\S*/)?.[0],de=Ie.replace(/\n$/,"")+`
`;return Se?'<pre><code class="language-'+c(Se)+'">'+(ce?de:c(de,!0))+`</code></pre>
`:"<pre><code>"+(ce?de:c(de,!0))+`</code></pre>
`}blockquote({tokens:Ie}){return`<blockquote>
${this.parser.parse(Ie)}</blockquote>
`}html({text:Ie}){return Ie}heading({tokens:Ie,depth:re}){return`<h${re}>${this.parser.parseInline(Ie)}</h${re}>
`}hr(Ie){return`<hr>
`}list(Ie){const re=Ie.ordered,ce=Ie.start;let Se="";for(let ne=0;ne<Ie.items.length;ne++){const J=Ie.items[ne];Se+=this.listitem(J)}const de=re?"ol":"ul",ke=re&&ce!==1?' start="'+ce+'"':"";return"<"+de+ke+`>
`+Se+"</"+de+`>
`}listitem(Ie){let re="";if(Ie.task){const ce=this.checkbox({checked:!!Ie.checked});Ie.loose?Ie.tokens.length>0&&Ie.tokens[0].type==="paragraph"?(Ie.tokens[0].text=ce+" "+Ie.tokens[0].text,Ie.tokens[0].tokens&&Ie.tokens[0].tokens.length>0&&Ie.tokens[0].tokens[0].type==="text"&&(Ie.tokens[0].tokens[0].text=ce+" "+Ie.tokens[0].tokens[0].text)):Ie.tokens.unshift({type:"text",raw:ce+" ",text:ce+" "}):re+=ce+" "}return re+=this.parser.parse(Ie.tokens,!!Ie.loose),`<li>${re}</li>
`}checkbox({checked:Ie}){return"<input "+(Ie?'checked="" ':"")+'disabled="" type="checkbox">'}paragraph({tokens:Ie}){return`<p>${this.parser.parseInline(Ie)}</p>
`}table(Ie){let re="",ce="";for(let de=0;de<Ie.header.length;de++)ce+=this.tablecell(Ie.header[de]);re+=this.tablerow({text:ce});let Se="";for(let de=0;de<Ie.rows.length;de++){const ke=Ie.rows[de];ce="";for(let ne=0;ne<ke.length;ne++)ce+=this.tablecell(ke[ne]);Se+=this.tablerow({text:ce})}return Se&&(Se=`<tbody>${Se}</tbody>`),`<table>
<thead>
`+re+`</thead>
`+Se+`</table>
`}tablerow({text:Ie}){return`<tr>
${Ie}</tr>
`}tablecell(Ie){const re=this.parser.parseInline(Ie.tokens),ce=Ie.header?"th":"td";return(Ie.align?`<${ce} align="${Ie.align}">`:`<${ce}>`)+re+`</${ce}>
`}strong({tokens:Ie}){return`<strong>${this.parser.parseInline(Ie)}</strong>`}em({tokens:Ie}){return`<em>${this.parser.parseInline(Ie)}</em>`}codespan({text:Ie}){return`<code>${Ie}</code>`}br(Ie){return"<br>"}del({tokens:Ie}){return`<del>${this.parser.parseInline(Ie)}</del>`}link({href:Ie,title:re,tokens:ce}){const Se=this.parser.parseInline(ce),de=g(Ie);if(de===null)return Se;Ie=de;let ke='<a href="'+Ie+'"';return re&&(ke+=' title="'+re+'"'),ke+=">"+Se+"</a>",ke}image({href:Ie,title:re,text:ce}){const Se=g(Ie);if(Se===null)return ce;Ie=Se;let de=`<img src="${Ie}" alt="${ce}"`;return re&&(de+=` title="${re}"`),de+=">",de}text(Ie){return"tokens"in Ie&&Ie.tokens?this.parser.parseInline(Ie.tokens):Ie.text}}class G{strong({text:Ie}){return Ie}em({text:Ie}){return Ie}codespan({text:Ie}){return Ie}del({text:Ie}){return Ie}html({text:Ie}){return Ie}text({text:Ie}){return Ie}link({text:Ie}){return""+Ie}image({text:Ie}){return""+Ie}br(){return""}}class Z{options;renderer;textRenderer;constructor(Ie){this.options=Ie||ge.defaults,this.options.renderer=this.options.renderer||new H,this.renderer=this.options.renderer,this.renderer.options=this.options,this.renderer.parser=this,this.textRenderer=new G}static parse(Ie,re){return new Z(re).parse(Ie)}static parseInline(Ie,re){return new Z(re).parseInline(Ie)}parse(Ie,re=!0){let ce="";for(let Se=0;Se<Ie.length;Se++){const de=Ie[Se];if(this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[de.type]){const ne=de,J=this.options.extensions.renderers[ne.type].call({parser:this},ne);if(J!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ne.type)){ce+=J||"";continue}}const ke=de;switch(ke.type){case"space":{ce+=this.renderer.space(ke);continue}case"hr":{ce+=this.renderer.hr(ke);continue}case"heading":{ce+=this.renderer.heading(ke);continue}case"code":{ce+=this.renderer.code(ke);continue}case"table":{ce+=this.renderer.table(ke);continue}case"blockquote":{ce+=this.renderer.blockquote(ke);continue}case"list":{ce+=this.renderer.list(ke);continue}case"html":{ce+=this.renderer.html(ke);continue}case"paragraph":{ce+=this.renderer.paragraph(ke);continue}case"text":{let ne=ke,J=this.renderer.text(ne);for(;Se+1<Ie.length&&Ie[Se+1].type==="text";)ne=Ie[++Se],J+=`
`+this.renderer.text(ne);re?ce+=this.renderer.paragraph({type:"paragraph",raw:J,text:J,tokens:[{type:"text",raw:J,text:J}]}):ce+=J;continue}default:{const ne='Token with "'+ke.type+'" type was not found.';if(this.options.silent)return console.error(ne),"";throw new Error(ne)}}}return ce}parseInline(Ie,re){re=re||this.renderer;let ce="";for(let Se=0;Se<Ie.length;Se++){const de=Ie[Se];if(this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[de.type]){const ne=this.options.extensions.renderers[de.type].call({parser:this},de);if(ne!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(de.type)){ce+=ne||"";continue}}const ke=de;switch(ke.type){case"escape":{ce+=re.text(ke);break}case"html":{ce+=re.html(ke);break}case"link":{ce+=re.link(ke);break}case"image":{ce+=re.image(ke);break}case"strong":{ce+=re.strong(ke);break}case"em":{ce+=re.em(ke);break}case"codespan":{ce+=re.codespan(ke);break}case"br":{ce+=re.br(ke);break}case"del":{ce+=re.del(ke);break}case"text":{ce+=re.text(ke);break}default:{const ne='Token with "'+ke.type+'" type was not found.';if(this.options.silent)return console.error(ne),"";throw new Error(ne)}}}return ce}}class ee{options;constructor(Ie){this.options=Ie||ge.defaults}static passThroughHooks=new Set(["preprocess","postprocess","processAllTokens"]);preprocess(Ie){return Ie}postprocess(Ie){return Ie}processAllTokens(Ie){return Ie}}class le{defaults=e();options=this.setOptions;parse=this.parseMarkdown(Ne.lex,Z.parse);parseInline=this.parseMarkdown(Ne.lexInline,Z.parseInline);Parser=Z;Renderer=H;TextRenderer=G;Lexer=Ne;Tokenizer=i;Hooks=ee;constructor(...Ie){this.use(...Ie)}walkTokens(Ie,re){let ce=[];for(const Se of Ie)switch(ce=ce.concat(re.call(this,Se)),Se.type){case"table":{const de=Se;for(const ke of de.header)ce=ce.concat(this.walkTokens(ke.tokens,re));for(const ke of de.rows)for(const ne of ke)ce=ce.concat(this.walkTokens(ne.tokens,re));break}case"list":{const de=Se;ce=ce.concat(this.walkTokens(de.items,re));break}default:{const de=Se;this.defaults.extensions?.childTokens?.[de.type]?this.defaults.extensions.childTokens[de.type].forEach(ke=>{const ne=de[ke].flat(1/0);ce=ce.concat(this.walkTokens(ne,re))}):de.tokens&&(ce=ce.concat(this.walkTokens(de.tokens,re)))}}return ce}use(...Ie){const re=this.defaults.extensions||{renderers:{},childTokens:{}};return Ie.forEach(ce=>{const Se={...ce};if(Se.async=this.defaults.async||Se.async||!1,ce.extensions&&(ce.extensions.forEach(de=>{if(!de.name)throw new Error("extension name required");if("renderer"in de){const ke=re.renderers[de.name];ke?re.renderers[de.name]=function(...ne){let J=de.renderer.apply(this,ne);return J===!1&&(J=ke.apply(this,ne)),J}:re.renderers[de.name]=de.renderer}if("tokenizer"in de){if(!de.level||de.level!=="block"&&de.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");const ke=re[de.level];ke?ke.unshift(de.tokenizer):re[de.level]=[de.tokenizer],de.start&&(de.level==="block"?re.startBlock?re.startBlock.push(de.start):re.startBlock=[de.start]:de.level==="inline"&&(re.startInline?re.startInline.push(de.start):re.startInline=[de.start]))}"childTokens"in de&&de.childTokens&&(re.childTokens[de.name]=de.childTokens)}),Se.extensions=re),ce.renderer){const de=this.defaults.renderer||new H(this.defaults);for(const ke in ce.renderer){if(!(ke in de))throw new Error(`renderer '${ke}' does not exist`);if(["options","parser"].includes(ke))continue;const ne=ke,J=ce.renderer[ne],Pe=de[ne];de[ne]=(...Ge)=>{let Je=J.apply(de,Ge);return Je===!1&&(Je=Pe.apply(de,Ge)),Je||""}}Se.renderer=de}if(ce.tokenizer){const de=this.defaults.tokenizer||new i(this.defaults);for(const ke in ce.tokenizer){if(!(ke in de))throw new Error(`tokenizer '${ke}' does not exist`);if(["options","rules","lexer"].includes(ke))continue;const ne=ke,J=ce.tokenizer[ne],Pe=de[ne];de[ne]=(...Ge)=>{let Je=J.apply(de,Ge);return Je===!1&&(Je=Pe.apply(de,Ge)),Je}}Se.tokenizer=de}if(ce.hooks){const de=this.defaults.hooks||new ee;for(const ke in ce.hooks){if(!(ke in de))throw new Error(`hook '${ke}' does not exist`);if(ke==="options")continue;const ne=ke,J=ce.hooks[ne],Pe=de[ne];ee.passThroughHooks.has(ke)?de[ne]=Ge=>{if(this.defaults.async)return Promise.resolve(J.call(de,Ge)).then(st=>Pe.call(de,st));const Je=J.call(de,Ge);return Pe.call(de,Je)}:de[ne]=(...Ge)=>{let Je=J.apply(de,Ge);return Je===!1&&(Je=Pe.apply(de,Ge)),Je}}Se.hooks=de}if(ce.walkTokens){const de=this.defaults.walkTokens,ke=ce.walkTokens;Se.walkTokens=function(ne){let J=[];return J.push(ke.call(this,ne)),de&&(J=J.concat(de.call(this,ne))),J}}this.defaults={...this.defaults,...Se}}),this}setOptions(Ie){return this.defaults={...this.defaults,...Ie},this}lexer(Ie,re){return Ne.lex(Ie,re??this.defaults)}parser(Ie,re){return Z.parse(Ie,re??this.defaults)}parseMarkdown(Ie,re){return(Se,de)=>{const ke={...de},ne={...this.defaults,...ke},J=this.onError(!!ne.silent,!!ne.async);if(this.defaults.async===!0&&ke.async===!1)return J(new Error("marked(): The async option was set to true by an extension. Remove async: false from the parse options object to return a Promise."));if(typeof Se>"u"||Se===null)return J(new Error("marked(): input parameter is undefined or null"));if(typeof Se!="string")return J(new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Se)+", string expected"));if(ne.hooks&&(ne.hooks.options=ne),ne.async)return Promise.resolve(ne.hooks?ne.hooks.preprocess(Se):Se).then(Pe=>Ie(Pe,ne)).then(Pe=>ne.hooks?ne.hooks.processAllTokens(Pe):Pe).then(Pe=>ne.walkTokens?Promise.all(this.walkTokens(Pe,ne.walkTokens)).then(()=>Pe):Pe).then(Pe=>re(Pe,ne)).then(Pe=>ne.hooks?ne.hooks.postprocess(Pe):Pe).catch(J);try{ne.hooks&&(Se=ne.hooks.preprocess(Se));let Pe=Ie(Se,ne);ne.hooks&&(Pe=ne.hooks.processAllTokens(Pe)),ne.walkTokens&&this.walkTokens(Pe,ne.walkTokens);let Ge=re(Pe,ne);return ne.hooks&&(Ge=ne.hooks.postprocess(Ge)),Ge}catch(Pe){return J(Pe)}}}onError(Ie,re){return ce=>{if(ce.message+=`
Please report this to https://github.com/markedjs/marked.`,Ie){const Se="<p>An error occurred:</p><pre>"+c(ce.message+"",!0)+"</pre>";return re?Promise.resolve(Se):Se}if(re)return Promise.reject(ce);throw ce}}}const ye=new le;function Te(it,Ie){return ye.parse(it,Ie)}Te.options=Te.setOptions=function(it){return ye.setOptions(it),Te.defaults=ye.defaults,s(Te.defaults),Te},Te.getDefaults=e,Te.defaults=ge.defaults,Te.use=function(...it){return ye.use(...it),Te.defaults=ye.defaults,s(Te.defaults),Te},Te.walkTokens=function(it,Ie){return ye.walkTokens(it,Ie)},Te.parseInline=ye.parseInline,Te.Parser=Z,Te.parser=Z.parse,Te.Renderer=H,Te.TextRenderer=G,Te.Lexer=Ne,Te.lexer=Ne.lex,Te.Tokenizer=i,Te.Hooks=ee,Te.parse=Te;const Ve=Te.options,Ke=Te.setOptions,rt=Te.use,ot=Te.walkTokens,ut=Te.parseInline,at=Te,lt=Z.parse,$t=Ne.lex;ge.Hooks=ee,ge.Lexer=Ne,ge.Marked=le,ge.Parser=Z,ge.Renderer=H,ge.TextRenderer=G,ge.Tokenizer=i,ge.getDefaults=e,ge.lexer=$t,ge.marked=Te,ge.options=Ve,ge.parse=at,ge.parseInline=ut,ge.parser=lt,ge.setOptions=Ke,ge.use=rt,ge.walkTokens=ot}),define(Re[41],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var s;(function(h){h[h.Uri=1]="Uri",h[h.Regexp=2]="Regexp",h[h.ScmResource=3]="ScmResource",h[h.ScmResourceGroup=4]="ScmResourceGroup",h[h.ScmProvider=5]="ScmProvider",h[h.CommentController=6]="CommentController",h[h.CommentThread=7]="CommentThread",h[h.CommentThreadInstance=8]="CommentThreadInstance",h[h.CommentThreadReply=9]="CommentThreadReply",h[h.CommentNode=10]="CommentNode",h[h.CommentThreadNode=11]="CommentThreadNode",h[h.TimelineActionContext=12]="TimelineActionContext",h[h.NotebookCellActionContext=13]="NotebookCellActionContext",h[h.NotebookActionContext=14]="NotebookActionContext",h[h.TerminalContext=15]="TerminalContext",h[h.TestItemContext=16]="TestItemContext",h[h.Date=17]="Date",h[h.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(s||(e.MarshalledId=s={}))}),define(Re[182],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=s;function s(a){const $=A(a);if($&&$.length>0)return new Uint32Array($)}let h=0;const R=new Uint32Array(10);function A(a){if(h=0,O(a,E,m.InitialConsonant),h>0||(O(a,g,m.Vowel),h>0)||(O(a,P,m.FinalConsonant),h>0)||(O(a,b,m.CompatibilityJamo),h))return R.subarray(0,h);if(a>=44032&&a<=55203){const $=a-44032,p=$%588,u=Math.floor($/588),i=Math.floor(p/28),o=p%28-1;if(u<E.length?O(u,E,0):m.InitialConsonant+u-m.CompatibilityJamo<b.length&&O(m.InitialConsonant+u,b,m.CompatibilityJamo),i<g.length?O(i,g,0):m.Vowel+i-m.CompatibilityJamo<b.length&&O(m.Vowel+i-m.CompatibilityJamo,b,m.CompatibilityJamo),o>=0&&(o<P.length?O(o,P,0):m.FinalConsonant+o-m.CompatibilityJamo<b.length&&O(m.FinalConsonant+o-m.CompatibilityJamo,b,m.CompatibilityJamo)),h>0)return R.subarray(0,h)}}function O(a,$,p){a>=p&&a<p+$.length&&C($[a-p])}function C(a){a!==c.NUL&&(R[h++]=a&255,a>>8&&(R[h++]=a>>8&255),a>>16&&(R[h++]=a>>16&255))}var m;(function(a){a[a.InitialConsonant=4352]="InitialConsonant",a[a.Vowel=4449]="Vowel",a[a.FinalConsonant=4520]="FinalConsonant",a[a.CompatibilityJamo=12593]="CompatibilityJamo"})(m||(m={}));var c;(function(a){a[a.NUL=0]="NUL",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z"})(c||(c={}));var I;(function(a){a[a.fa=24934]="fa",a[a.fg=26470]="fg",a[a.fq=29030]="fq",a[a.fr=29286]="fr",a[a.ft=29798]="ft",a[a.fv=30310]="fv",a[a.fx=30822]="fx",a[a.hk=27496]="hk",a[a.hl=27752]="hl",a[a.ho=28520]="ho",a[a.ml=27757]="ml",a[a.nj=27246]="nj",a[a.nl=27758]="nl",a[a.np=28782]="np",a[a.qt=29809]="qt",a[a.rt=29810]="rt",a[a.sg=26483]="sg",a[a.sw=30579]="sw"})(I||(I={}));const E=new Uint8Array([c.r,c.R,c.s,c.e,c.E,c.f,c.a,c.q,c.Q,c.t,c.T,c.d,c.w,c.W,c.c,c.z,c.x,c.v,c.g]),g=new Uint16Array([c.k,c.o,c.i,c.O,c.j,c.p,c.u,c.P,c.h,I.hk,I.ho,I.hl,c.y,c.n,I.nj,I.np,I.nl,c.b,c.m,I.ml,c.l]),P=new Uint16Array([c.r,c.R,I.rt,c.s,I.sw,I.sg,c.e,c.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,c.a,c.q,I.qt,c.t,c.T,c.d,c.w,c.c,c.z,c.x,c.v,c.g]),b=new Uint16Array([c.r,c.R,I.rt,c.s,I.sw,I.sg,c.e,c.E,c.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,c.a,c.q,c.Q,I.qt,c.t,c.T,c.d,c.w,c.W,c.c,c.z,c.x,c.v,c.g,c.k,c.o,c.i,c.O,c.j,c.p,c.u,c.P,c.h,I.hk,I.ho,I.hl,c.y,c.n,I.nj,I.np,I.nl,c.b,c.m,I.ml,c.l])}),define(Re[83],Ce([1,0,28]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=void 0,e.$qm=R,e.$rm=O;const h=new s.$Gc(1e4);function R(c){return m(c,"NFC",h)}const A=new s.$Gc(1e4);function O(c){return m(c,"NFD",A)}const C=/[^\u0000-\u0080]/;function m(c,I,E){if(!c)return c;const g=E.get(c);if(g)return g;let P;return C.test(c)?P=c.normalize(I):P=c,E.set(c,P),P}e.$sm=function(){const c=/[\u0300-\u036f]/g;return function(I){return O(I).replace(c,"")}}()}),define(Re[134],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Rm=e.$Qm=void 0,e.$Om=s,e.rot=h,e.$Tm=C;function s(m,c,I){return Math.min(Math.max(m,c),I)}function h(m,c){return(c+m%c)%c}class R{constructor(){this.a=0}getNext(){return this.a++}}e.$Qm=R;class A{constructor(){this.a=1,this.b=0}update(c){return this.b=this.b+(c-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Rm=A;class O{constructor(c){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(c),this.c.fill(0,0,c)}update(c){const I=this.c[this.d];return this.c[this.d]=c,this.d=(this.d+1)%this.c.length,this.e-=I,this.e+=c,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Sm=O;function C(m,c,I,E,g,P,b,a){const $=b-I,p=a-E,u=g-I,i=P-E,o=m-I,t=c-E,n=$*$+p*p,r=$*u+p*i,d=$*o+p*t,l=u*u+i*i,f=u*o+i*t,y=1/(n*l-r*r),k=(l*d-r*f)*y,S=(n*f-r*d)*y;return k>=0&&S>=0&&k+S<1}}),define(Re[183],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dd=void 0,e.$ed=A,e.$fd=g;class s{constructor(b,a,$){this.owner=b,this.debugNameSource=a,this.referenceFn=$}getDebugName(b){return A(b,this)}}e.$dd=s;const h=new Map,R=new WeakMap;function A(P,b){const a=R.get(P);if(a)return a;const $=O(P,b);if($){let p=h.get($)??0;p++,h.set($,p);const u=p===1?$:`${$}#${p}`;return R.set(P,u),u}}function O(P,b){const a=R.get(P);if(a)return a;const $=b.owner?I(b.owner)+".":"";let p;const u=b.debugNameSource;if(u!==void 0)if(typeof u=="function"){if(p=u(),p!==void 0)return $+p}else return $+u;const i=b.referenceFn;if(i!==void 0&&(p=g(i),p!==void 0))return $+p;if(b.owner!==void 0){const o=C(b.owner,P);if(o!==void 0)return $+o}}function C(P,b){for(const a in P)if(P[a]===b)return a}const m=new Map,c=new WeakMap;function I(P){const b=c.get(P);if(b)return b;const a=E(P);let $=m.get(a)??0;$++,m.set(a,$);const p=$===1?a:`${a}#${$}`;return c.set(P,p),p}function E(P){const b=P.constructor;return b?b.name:"Object"}function g(P){const b=P.toString(),$=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(b);return($?$[1]:void 0)?.trim()}}),define(Re[184],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pd=void 0,e.$Nd=h,e.$Od=R;let s;function h(a){s=a}function R(){return s}class A{constructor(){this.a=0,this.d=new WeakMap}b($){return O([C(P("|  ",this.a)),$])}c($){return $.hadValue?$.didChange?[C(" "),c(I($.oldValue,70),{color:"red",strikeThrough:!0}),C(" "),c(I($.newValue,60),{color:"green"})]:[C(" (unchanged)")]:[C(" "),c(I($.newValue,60),{color:"green"}),C(" (initial)")]}handleObservableChanged($,p){console.log(...this.b([m("observable value changed"),c($.debugName,{color:"BlueViolet"}),...this.c(p)]))}formatChanges($){if($.size!==0)return c(" (changed deps: "+[...$].map(p=>p.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated($){const p=$.handleChange;this.d.set($,new Set),$.handleChange=(u,i)=>(this.d.get($).add(u),p.apply($,[u,i]))}handleDerivedRecomputed($,p){const u=this.d.get($);console.log(...this.b([m("derived recomputed"),c($.debugName,{color:"BlueViolet"}),...this.c(p),this.formatChanges(u),{data:[{fn:$._debugNameData.referenceFn??$._computeFn}]}])),u.clear()}handleFromEventObservableTriggered($,p){console.log(...this.b([m("observable from event triggered"),c($.debugName,{color:"BlueViolet"}),...this.c(p),{data:[{fn:$._getValue}]}]))}handleAutorunCreated($){const p=$.handleChange;this.d.set($,new Set),$.handleChange=(u,i)=>(this.d.get($).add(u),p.apply($,[u,i]))}handleAutorunTriggered($){const p=this.d.get($);console.log(...this.b([m("autorun"),c($.debugName,{color:"BlueViolet"}),this.formatChanges(p),{data:[{fn:$._debugNameData.referenceFn??$._runFn}]}])),p.clear(),this.a++}handleAutorunFinished($){this.a--}handleBeginTransaction($){let p=$.getDebugName();p===void 0&&(p=""),console.log(...this.b([m("transaction"),c(p,{color:"BlueViolet"}),{data:[{fn:$._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Pd=A;function O(a){const $=new Array,p=[];let u="";function i(t){if("length"in t)for(const n of t)n&&i(n);else"text"in t?(u+=`%c${t.text}`,$.push(t.style),t.data&&p.push(...t.data)):"data"in t&&p.push(...t.data)}i(a);const o=[u,...$];return o.push(...p),o}function C(a){return c(a,{color:"black"})}function m(a){return c(b(`${a}: `,10),{color:"black",bold:!0})}function c(a,$={color:"black"}){function p(i){return Object.entries(i).reduce((o,[t,n])=>`${o}${t}:${n};`,"")}const u={color:$.color};return $.strikeThrough&&(u["text-decoration"]="line-through"),$.bold&&(u["font-weight"]="bold"),{text:a,style:p(u)}}function I(a,$){switch(typeof a){case"number":return""+a;case"string":return a.length+2<=$?`"${a}"`:`"${a.substr(0,$-7)}"+...`;case"boolean":return a?"true":"false";case"undefined":return"undefined";case"object":return a===null?"null":Array.isArray(a)?E(a,$):g(a,$);case"symbol":return a.toString();case"function":return`[[Function${a.name?" "+a.name:""}]]`;default:return""+a}}function E(a,$){let p="[ ",u=!0;for(const i of a){if(u||(p+=", "),p.length-5>$){p+="...";break}u=!1,p+=`${I(i,$-p.length)}`}return p+=" ]",p}function g(a,$){let p="{ ",u=!0;for(const[i,o]of Object.entries(a)){if(u||(p+=", "),p.length-5>$){p+="...";break}u=!1,p+=`${i}: ${I(o,$-p.length)}`}return p+=" }",p}function P(a,$){let p="";for(let u=1;u<=$;u++)p+=a;return p}function b(a,$){for(;a.length<$;)a+=" ";return a}}),define(Re[185],Ce([1,0,178,183,184]),function(ge,e,s,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_d=e.$0d=e.$8d=e.$3d=e.$2d=void 0,e.$Yd=O,e.$Zd=m,e.$1d=I,e.$4d=P,e.$5d=a,e.$6d=$,e.$7d=p,e.$9d=i,e.$$d=t;let A;function O(r){A=r}let C;function m(r){C=r}let c;function I(r){c=r}class E{get TChange(){return null}reportChanges(){this.get()}read(d){return d?d.readObservable(this):this.get()}map(d,l){const f=l===void 0?void 0:d,y=l===void 0?d:l;return c({owner:f,debugName:()=>{const k=(0,h.$fd)(y);if(k!==void 0)return k;const D=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(y.toString());if(D)return`${this.debugName}.${D[2]}`;if(!f)return`${this.debugName} (mapped)`},debugReferenceFn:y},k=>y(this.read(k),k))}flatten(){return c({owner:void 0,debugName:()=>`${this.debugName} (flattened)`},d=>this.read(d).read(d))}recomputeInitiallyAndOnChange(d,l){return d.add(A(this,l)),this}keepObserved(d){return d.add(C(this)),this}get a(){return this.get()}}e.$2d=E;class g extends E{constructor(){super(...arguments),this.b=new Set}addObserver(d){const l=this.b.size;this.b.add(d),l===0&&this.c()}removeObserver(d){this.b.delete(d)&&this.b.size===0&&this.f()}c(){}f(){}}e.$3d=g;function P(r,d){const l=new u(r,d);try{r(l)}finally{l.finish()}}let b;function a(r){if(b)r(b);else{const d=new u(r,void 0);b=d;try{r(d)}finally{d.finish(),b=void 0}}}async function $(r,d){const l=new u(r,d);try{await r(l)}finally{l.finish()}}function p(r,d,l){r?d(r):P(d,l)}class u{constructor(d,l){this._fn=d,this.b=l,this.a=[],(0,R.$Od)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,h.$fd)(this._fn)}updateObserver(d,l){this.a.push({observer:d,observable:l}),d.beginUpdate(l)}finish(){const d=this.a;for(let l=0;l<d.length;l++){const{observer:f,observable:y}=d[l];f.endUpdate(y)}this.a=null,(0,R.$Od)()?.handleEndTransaction()}}e.$8d=u;function i(r,d){let l;return typeof r=="string"?l=new h.$dd(void 0,r,void 0):l=new h.$dd(r,void 0,void 0),new o(l,d,s.$9c)}class o extends g{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(d,l,f){super(),this.e=d,this.g=f,this.d=l}get(){return this.d}set(d,l,f){if(f===void 0&&this.g(this.d,d))return;let y;l||(l=y=new u(()=>{},()=>`Setting ${this.debugName}`));try{const k=this.d;this.h(d),(0,R.$Od)()?.handleObservableChanged(this,{oldValue:k,newValue:d,change:f,didChange:!0,hadValue:!0});for(const S of this.b)l.updateObserver(S,this),S.handleChange(this,f)}finally{y&&y.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(d){this.d=d}}e.$0d=o;function t(r,d){let l;return typeof r=="string"?l=new h.$dd(void 0,r,void 0):l=new h.$dd(r,void 0,void 0),new n(l,d,s.$9c)}class n extends o{h(d){this.d!==d&&(this.d&&this.d.dispose(),this.d=d)}dispose(){this.d?.dispose()}}e.$_d=n}),function(){function ge(R){const A=[];typeof R=="number"&&A.push("code/timeOrigin",R);function O(m){A.push(m,Date.now())}function C(){const m=[];for(let c=0;c<A.length;c+=2)m.push({name:A[c],startTime:A[c+1]});return m}return{mark:O,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ge():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const O of performance.getEntriesByType("mark"))A.push({name:O.name,startTime:Math.round(R+O.startTime)});return A}};if(typeof process=="object"){const R=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ge(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),ge()}function s(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var h;typeof global=="object"?h=global:typeof self=="object"?h=self:h={},typeof define=="function"?define("vs/base/common/performance",[],function(){return s(h)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=s(h):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),h.perf=s(h))}(),define(Re[10],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.OS=e.OperatingSystem=e.$C=e.$B=e.$A=e.$z=e.$y=e.Language=e.$x=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.Platform=e.$h=void 0,e.$i=n,e.$E=k,e.$K=S,e.$h="en";let s=!1,h=!1,R=!1,A=!1,O=!1,C=!1,m=!1,c=!1,I=!1,E=!1,g,P=e.$h,b=e.$h,a,$;const p=globalThis;let u;typeof p.vscode<"u"&&typeof p.vscode.process<"u"?u=p.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(u=process);const i=typeof u?.versions?.electron=="string",o=i&&u?.type==="renderer";if(typeof u=="object"){s=u.platform==="win32",h=u.platform==="darwin",R=u.platform==="linux",A=R&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,m=i,I=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,g=e.$h,P=e.$h;const D=u.env.VSCODE_NLS_CONFIG;if(D)try{const T=JSON.parse(D);g=T.userLocale,b=T.osLocale,P=T.resolvedLanguage||e.$h,a=T.languagePack?.translationsConfigFile}catch{}O=!0}else typeof navigator=="object"&&!o?($=navigator.userAgent,s=$.indexOf("Windows")>=0,h=$.indexOf("Macintosh")>=0,c=($.indexOf("Macintosh")>=0||$.indexOf("iPad")>=0||$.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=$.indexOf("Linux")>=0,E=$?.indexOf("Mobi")>=0,C=!0,P=globalThis._VSCODE_NLS_LANGUAGE||e.$h,g=navigator.language.toLowerCase(),b=g):console.error("Unable to resolve platform.");var t;(function(D){D[D.Web=0]="Web",D[D.Mac=1]="Mac",D[D.Linux=2]="Linux",D[D.Windows=3]="Windows"})(t||(e.Platform=t={}));function n(D){switch(D){case t.Web:return"Web";case t.Mac:return"Mac";case t.Linux:return"Linux";case t.Windows:return"Windows"}}let r=t.Web;h?r=t.Mac:s?r=t.Windows:R&&(r=t.Linux),e.$j=s,e.$k=h,e.$l=R,e.$m=A,e.$n=O,e.$o=m,e.$p=C,e.$q=C&&typeof p.importScripts=="function",e.$r=e.$q?p.origin:void 0,e.$s=c,e.$t=E,e.$u=I,e.$v=r,e.$w=$,e.$x=P;var d;(function(D){function T(){return e.$x}D.value=T;function v(){return e.$x.length===2?e.$x==="en":e.$x.length>=3?e.$x[0]==="e"&&e.$x[1]==="n"&&e.$x[2]==="-":!1}D.isDefaultVariant=v;function w(){return e.$x==="en"}D.isDefault=w})(d||(e.Language=d={})),e.$y=g,e.$z=b,e.$A=a,e.$B=typeof p.postMessage=="function"&&!p.importScripts,e.$C=(()=>{if(e.$B){const D=[];p.addEventListener("message",v=>{if(v.data&&v.data.vscodeScheduleAsyncWork)for(let w=0,M=D.length;w<M;w++){const L=D[w];if(L.id===v.data.vscodeScheduleAsyncWork){D.splice(w,1),L.callback();return}}});let T=0;return v=>{const w=++T;D.push({id:w,callback:v}),p.postMessage({vscodeScheduleAsyncWork:w},"*")}}return D=>setTimeout(D)})();var l;(function(D){D[D.Windows=1]="Windows",D[D.Macintosh=2]="Macintosh",D[D.Linux=3]="Linux"})(l||(e.OperatingSystem=l={})),e.OS=h||c?l.Macintosh:s?l.Windows:l.Linux;let f=!0,y=!1;function k(){if(!y){y=!0;const D=new Uint8Array(2);D[0]=1,D[1]=2,f=new Uint16Array(D.buffer)[0]===513}return f}e.$F=!!(e.$w&&e.$w.indexOf("Chrome")>=0),e.$G=!!(e.$w&&e.$w.indexOf("Firefox")>=0),e.$H=!!(!e.$F&&e.$w&&e.$w.indexOf("Safari")>=0),e.$I=!!(e.$w&&e.$w.indexOf("Edg/")>=0),e.$J=!!(e.$w&&e.$w.indexOf("Android")>=0);function S(D){return parseFloat(D)>=20}}),define(Re[186],Ce([1,0,40]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lJ=void 0;const h=Symbol("unset");class R{constructor(){this.a=new O,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||s.Iterable.empty()}get entries(){return this.a.children?.entries()||s.Iterable.empty()}insert(m,c,I){this.d(m,E=>E._value=c,I)}mutate(m,c){this.d(m,I=>I._value=c(I._value===h?void 0:I._value))}mutatePath(m,c){this.d(m,()=>{},I=>c(I))}delete(m){const c=this.c(m);if(!c)return;let I=c.length-1;const E=c[I].node._value;if(E!==h){for(this.b--,c[I].node._value=h;I>0;I--){const{node:g,part:P}=c[I];if(g.children?.size||g._value!==h)break;c[I-1].node.children.delete(P)}return E}}*deleteRecursive(m){const c=this.c(m);if(!c)return;const I=c[c.length-1].node;for(let E=c.length-1;E>0;E--){const g=c[E-1];if(g.node.children.delete(c[E].part),g.node.children.size>0||g.node._value!==h)break}for(const E of A(I))E._value!==h&&(this.b--,yield E._value)}find(m){let c=this.a;for(const I of m){const E=c.children?.get(I);if(!E)return;c=E}return c._value===h?void 0:c._value}hasKeyOrParent(m){let c=this.a;for(const I of m){const E=c.children?.get(I);if(!E)return!1;if(E._value!==h)return!0;c=E}return!1}hasKeyOrChildren(m){let c=this.a;for(const I of m){const E=c.children?.get(I);if(!E)return!1;c=E}return!0}hasKey(m){let c=this.a;for(const I of m){const E=c.children?.get(I);if(!E)return!1;c=E}return c._value!==h}c(m){const c=[{part:"",node:this.a}];let I=0;for(const E of m){const g=c[I].node.children?.get(E);if(!g)return;c.push({part:E,node:g}),I++}return c}d(m,c,I){let E=this.a;for(const b of m){if(E.children)if(E.children.has(b))E=E.children.get(b);else{const a=new O;E.children.set(b,a),E=a}else{const a=new O;E.children=new Map([[b,a]]),E=a}I?.(E)}const g=E._value===h?0:1;c(E);const P=E._value===h?0:1;this.b+=P-g}*values(){for(const{_value:m}of A(this.a))m!==h&&(yield m)}}e.$lJ=R;function*A(C){const m=[C];for(;m.length>0;){const c=m.pop();if(yield c,c.children)for(const I of c.children.values())m.push(I)}}class O{constructor(){this._value=h}get value(){return this._value===h?void 0:this._value}set value(m){this._value=m===void 0?h:m}}}),define(Re[55],Ce([1,0,10]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hc=e.$gc=e.env=e.cwd=void 0;let h;const R=globalThis.vscode;if(typeof R<"u"&&typeof R.process<"u"){const A=R.process;h={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"&&typeof process?.versions?.node=="string"?h={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:h={get platform(){return s.$j?"win32":s.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=h.cwd,e.env=h.env,e.$gc=h.platform,e.$hc=h.arch}),define(Re[16],Ce([1,0,55]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.sep=e.$uc=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=void 0,s=Ue(s);const h=65,R=97,A=90,O=122,C=46,m=47,c=92,I=58,E=63;class g extends Error{constructor(d,l,f){let y;typeof l=="string"&&l.indexOf("not ")===0?(y="must not be",l=l.replace(/^not /,"")):y="must be";const k=d.indexOf(".")!==-1?"property":"argument";let S=`The "${d}" ${k} ${y} of type ${l}`;S+=`. Received type ${typeof f}`,super(S),this.code="ERR_INVALID_ARG_TYPE"}}function P(r,d){if(r===null||typeof r!="object")throw new g(d,"Object",r)}function b(r,d){if(typeof r!="string")throw new g(d,"string",r)}const a=s.$gc==="win32";function $(r){return r===m||r===c}function p(r){return r===m}function u(r){return r>=h&&r<=A||r>=R&&r<=O}function i(r,d,l,f){let y="",k=0,S=-1,D=0,T=0;for(let v=0;v<=r.length;++v){if(v<r.length)T=r.charCodeAt(v);else{if(f(T))break;T=m}if(f(T)){if(!(S===v-1||D===1))if(D===2){if(y.length<2||k!==2||y.charCodeAt(y.length-1)!==C||y.charCodeAt(y.length-2)!==C){if(y.length>2){const w=y.lastIndexOf(l);w===-1?(y="",k=0):(y=y.slice(0,w),k=y.length-1-y.lastIndexOf(l)),S=v,D=0;continue}else if(y.length!==0){y="",k=0,S=v,D=0;continue}}d&&(y+=y.length>0?`${l}..`:"..",k=2)}else y.length>0?y+=`${l}${r.slice(S+1,v)}`:y=r.slice(S+1,v),k=v-S-1;S=v,D=0}else T===C&&D!==-1?++D:D=-1}return y}function o(r){return r?`${r[0]==="."?"":"."}${r}`:""}function t(r,d){P(d,"pathObject");const l=d.dir||d.root,f=d.base||`${d.name||""}${o(d.ext)}`;return l?l===d.root?`${l}${f}`:`${l}${r}${f}`:f}e.$ic={resolve(...r){let d="",l="",f=!1;for(let y=r.length-1;y>=-1;y--){let k;if(y>=0){if(k=r[y],b(k,`paths[${y}]`),k.length===0)continue}else d.length===0?k=s.cwd():(k=s.env[`=${d}`]||s.cwd(),(k===void 0||k.slice(0,2).toLowerCase()!==d.toLowerCase()&&k.charCodeAt(2)===c)&&(k=`${d}\\`));const S=k.length;let D=0,T="",v=!1;const w=k.charCodeAt(0);if(S===1)$(w)&&(D=1,v=!0);else if($(w))if(v=!0,$(k.charCodeAt(1))){let M=2,L=M;for(;M<S&&!$(k.charCodeAt(M));)M++;if(M<S&&M!==L){const N=k.slice(L,M);for(L=M;M<S&&$(k.charCodeAt(M));)M++;if(M<S&&M!==L){for(L=M;M<S&&!$(k.charCodeAt(M));)M++;(M===S||M!==L)&&(T=`\\\\${N}\\${k.slice(L,M)}`,D=M)}}}else D=1;else u(w)&&k.charCodeAt(1)===I&&(T=k.slice(0,2),D=2,S>2&&$(k.charCodeAt(2))&&(v=!0,D=3));if(T.length>0)if(d.length>0){if(T.toLowerCase()!==d.toLowerCase())continue}else d=T;if(f){if(d.length>0)break}else if(l=`${k.slice(D)}\\${l}`,f=v,v&&d.length>0)break}return l=i(l,!f,"\\",$),f?`${d}\\${l}`:`${d}${l}`||"."},normalize(r){b(r,"path");const d=r.length;if(d===0)return".";let l=0,f,y=!1;const k=r.charCodeAt(0);if(d===1)return p(k)?"\\":r;if($(k))if(y=!0,$(r.charCodeAt(1))){let D=2,T=D;for(;D<d&&!$(r.charCodeAt(D));)D++;if(D<d&&D!==T){const v=r.slice(T,D);for(T=D;D<d&&$(r.charCodeAt(D));)D++;if(D<d&&D!==T){for(T=D;D<d&&!$(r.charCodeAt(D));)D++;if(D===d)return`\\\\${v}\\${r.slice(T)}\\`;D!==T&&(f=`\\\\${v}\\${r.slice(T,D)}`,l=D)}}}else l=1;else u(k)&&r.charCodeAt(1)===I&&(f=r.slice(0,2),l=2,d>2&&$(r.charCodeAt(2))&&(y=!0,l=3));let S=l<d?i(r.slice(l),!y,"\\",$):"";return S.length===0&&!y&&(S="."),S.length>0&&$(r.charCodeAt(d-1))&&(S+="\\"),f===void 0?y?`\\${S}`:S:y?`${f}\\${S}`:`${f}${S}`},isAbsolute(r){b(r,"path");const d=r.length;if(d===0)return!1;const l=r.charCodeAt(0);return $(l)||d>2&&u(l)&&r.charCodeAt(1)===I&&$(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let d,l;for(let k=0;k<r.length;++k){const S=r[k];b(S,"path"),S.length>0&&(d===void 0?d=l=S:d+=`\\${S}`)}if(d===void 0)return".";let f=!0,y=0;if(typeof l=="string"&&$(l.charCodeAt(0))){++y;const k=l.length;k>1&&$(l.charCodeAt(1))&&(++y,k>2&&($(l.charCodeAt(2))?++y:f=!1))}if(f){for(;y<d.length&&$(d.charCodeAt(y));)y++;y>=2&&(d=`\\${d.slice(y)}`)}return e.$ic.normalize(d)},relative(r,d){if(b(r,"from"),b(d,"to"),r===d)return"";const l=e.$ic.resolve(r),f=e.$ic.resolve(d);if(l===f||(r=l.toLowerCase(),d=f.toLowerCase(),r===d))return"";let y=0;for(;y<r.length&&r.charCodeAt(y)===c;)y++;let k=r.length;for(;k-1>y&&r.charCodeAt(k-1)===c;)k--;const S=k-y;let D=0;for(;D<d.length&&d.charCodeAt(D)===c;)D++;let T=d.length;for(;T-1>D&&d.charCodeAt(T-1)===c;)T--;const v=T-D,w=S<v?S:v;let M=-1,L=0;for(;L<w;L++){const F=r.charCodeAt(y+L);if(F!==d.charCodeAt(D+L))break;F===c&&(M=L)}if(L!==w){if(M===-1)return f}else{if(v>w){if(d.charCodeAt(D+L)===c)return f.slice(D+L+1);if(L===2)return f.slice(D+L)}S>w&&(r.charCodeAt(y+L)===c?M=L:L===2&&(M=3)),M===-1&&(M=0)}let N="";for(L=y+M+1;L<=k;++L)(L===k||r.charCodeAt(L)===c)&&(N+=N.length===0?"..":"\\..");return D+=M,N.length>0?`${N}${f.slice(D,T)}`:(f.charCodeAt(D)===c&&++D,f.slice(D,T))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const d=e.$ic.resolve(r);if(d.length<=2)return r;if(d.charCodeAt(0)===c){if(d.charCodeAt(1)===c){const l=d.charCodeAt(2);if(l!==E&&l!==C)return`\\\\?\\UNC\\${d.slice(2)}`}}else if(u(d.charCodeAt(0))&&d.charCodeAt(1)===I&&d.charCodeAt(2)===c)return`\\\\?\\${d}`;return r},dirname(r){b(r,"path");const d=r.length;if(d===0)return".";let l=-1,f=0;const y=r.charCodeAt(0);if(d===1)return $(y)?r:".";if($(y)){if(l=f=1,$(r.charCodeAt(1))){let D=2,T=D;for(;D<d&&!$(r.charCodeAt(D));)D++;if(D<d&&D!==T){for(T=D;D<d&&$(r.charCodeAt(D));)D++;if(D<d&&D!==T){for(T=D;D<d&&!$(r.charCodeAt(D));)D++;if(D===d)return r;D!==T&&(l=f=D+1)}}}}else u(y)&&r.charCodeAt(1)===I&&(l=d>2&&$(r.charCodeAt(2))?3:2,f=l);let k=-1,S=!0;for(let D=d-1;D>=f;--D)if($(r.charCodeAt(D))){if(!S){k=D;break}}else S=!1;if(k===-1){if(l===-1)return".";k=l}return r.slice(0,k)},basename(r,d){d!==void 0&&b(d,"suffix"),b(r,"path");let l=0,f=-1,y=!0,k;if(r.length>=2&&u(r.charCodeAt(0))&&r.charCodeAt(1)===I&&(l=2),d!==void 0&&d.length>0&&d.length<=r.length){if(d===r)return"";let S=d.length-1,D=-1;for(k=r.length-1;k>=l;--k){const T=r.charCodeAt(k);if($(T)){if(!y){l=k+1;break}}else D===-1&&(y=!1,D=k+1),S>=0&&(T===d.charCodeAt(S)?--S===-1&&(f=k):(S=-1,f=D))}return l===f?f=D:f===-1&&(f=r.length),r.slice(l,f)}for(k=r.length-1;k>=l;--k)if($(r.charCodeAt(k))){if(!y){l=k+1;break}}else f===-1&&(y=!1,f=k+1);return f===-1?"":r.slice(l,f)},extname(r){b(r,"path");let d=0,l=-1,f=0,y=-1,k=!0,S=0;r.length>=2&&r.charCodeAt(1)===I&&u(r.charCodeAt(0))&&(d=f=2);for(let D=r.length-1;D>=d;--D){const T=r.charCodeAt(D);if($(T)){if(!k){f=D+1;break}continue}y===-1&&(k=!1,y=D+1),T===C?l===-1?l=D:S!==1&&(S=1):l!==-1&&(S=-1)}return l===-1||y===-1||S===0||S===1&&l===y-1&&l===f+1?"":r.slice(l,y)},format:t.bind(null,"\\"),parse(r){b(r,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return d;const l=r.length;let f=0,y=r.charCodeAt(0);if(l===1)return $(y)?(d.root=d.dir=r,d):(d.base=d.name=r,d);if($(y)){if(f=1,$(r.charCodeAt(1))){let M=2,L=M;for(;M<l&&!$(r.charCodeAt(M));)M++;if(M<l&&M!==L){for(L=M;M<l&&$(r.charCodeAt(M));)M++;if(M<l&&M!==L){for(L=M;M<l&&!$(r.charCodeAt(M));)M++;M===l?f=M:M!==L&&(f=M+1)}}}}else if(u(y)&&r.charCodeAt(1)===I){if(l<=2)return d.root=d.dir=r,d;if(f=2,$(r.charCodeAt(2))){if(l===3)return d.root=d.dir=r,d;f=3}}f>0&&(d.root=r.slice(0,f));let k=-1,S=f,D=-1,T=!0,v=r.length-1,w=0;for(;v>=f;--v){if(y=r.charCodeAt(v),$(y)){if(!T){S=v+1;break}continue}D===-1&&(T=!1,D=v+1),y===C?k===-1?k=v:w!==1&&(w=1):k!==-1&&(w=-1)}return D!==-1&&(k===-1||w===0||w===1&&k===D-1&&k===S+1?d.base=d.name=r.slice(S,D):(d.name=r.slice(S,k),d.base=r.slice(S,D),d.ext=r.slice(k,D))),S>0&&S!==f?d.dir=r.slice(0,S-1):d.dir=d.root,d},sep:"\\",delimiter:";",win32:null,posix:null};const n=(()=>{if(a){const r=/\\/g;return()=>{const d=s.cwd().replace(r,"/");return d.slice(d.indexOf("/"))}}return()=>s.cwd()})();e.$jc={resolve(...r){let d="",l=!1;for(let f=r.length-1;f>=-1&&!l;f--){const y=f>=0?r[f]:n();b(y,`paths[${f}]`),y.length!==0&&(d=`${y}/${d}`,l=y.charCodeAt(0)===m)}return d=i(d,!l,"/",p),l?`/${d}`:d.length>0?d:"."},normalize(r){if(b(r,"path"),r.length===0)return".";const d=r.charCodeAt(0)===m,l=r.charCodeAt(r.length-1)===m;return r=i(r,!d,"/",p),r.length===0?d?"/":l?"./":".":(l&&(r+="/"),d?`/${r}`:r)},isAbsolute(r){return b(r,"path"),r.length>0&&r.charCodeAt(0)===m},join(...r){if(r.length===0)return".";let d;for(let l=0;l<r.length;++l){const f=r[l];b(f,"path"),f.length>0&&(d===void 0?d=f:d+=`/${f}`)}return d===void 0?".":e.$jc.normalize(d)},relative(r,d){if(b(r,"from"),b(d,"to"),r===d||(r=e.$jc.resolve(r),d=e.$jc.resolve(d),r===d))return"";const l=1,f=r.length,y=f-l,k=1,S=d.length-k,D=y<S?y:S;let T=-1,v=0;for(;v<D;v++){const M=r.charCodeAt(l+v);if(M!==d.charCodeAt(k+v))break;M===m&&(T=v)}if(v===D)if(S>D){if(d.charCodeAt(k+v)===m)return d.slice(k+v+1);if(v===0)return d.slice(k+v)}else y>D&&(r.charCodeAt(l+v)===m?T=v:v===0&&(T=0));let w="";for(v=l+T+1;v<=f;++v)(v===f||r.charCodeAt(v)===m)&&(w+=w.length===0?"..":"/..");return`${w}${d.slice(k+T)}`},toNamespacedPath(r){return r},dirname(r){if(b(r,"path"),r.length===0)return".";const d=r.charCodeAt(0)===m;let l=-1,f=!0;for(let y=r.length-1;y>=1;--y)if(r.charCodeAt(y)===m){if(!f){l=y;break}}else f=!1;return l===-1?d?"/":".":d&&l===1?"//":r.slice(0,l)},basename(r,d){d!==void 0&&b(d,"ext"),b(r,"path");let l=0,f=-1,y=!0,k;if(d!==void 0&&d.length>0&&d.length<=r.length){if(d===r)return"";let S=d.length-1,D=-1;for(k=r.length-1;k>=0;--k){const T=r.charCodeAt(k);if(T===m){if(!y){l=k+1;break}}else D===-1&&(y=!1,D=k+1),S>=0&&(T===d.charCodeAt(S)?--S===-1&&(f=k):(S=-1,f=D))}return l===f?f=D:f===-1&&(f=r.length),r.slice(l,f)}for(k=r.length-1;k>=0;--k)if(r.charCodeAt(k)===m){if(!y){l=k+1;break}}else f===-1&&(y=!1,f=k+1);return f===-1?"":r.slice(l,f)},extname(r){b(r,"path");let d=-1,l=0,f=-1,y=!0,k=0;for(let S=r.length-1;S>=0;--S){const D=r.charCodeAt(S);if(D===m){if(!y){l=S+1;break}continue}f===-1&&(y=!1,f=S+1),D===C?d===-1?d=S:k!==1&&(k=1):d!==-1&&(k=-1)}return d===-1||f===-1||k===0||k===1&&d===f-1&&d===l+1?"":r.slice(d,f)},format:t.bind(null,"/"),parse(r){b(r,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return d;const l=r.charCodeAt(0)===m;let f;l?(d.root="/",f=1):f=0;let y=-1,k=0,S=-1,D=!0,T=r.length-1,v=0;for(;T>=f;--T){const w=r.charCodeAt(T);if(w===m){if(!D){k=T+1;break}continue}S===-1&&(D=!1,S=T+1),w===C?y===-1?y=T:v!==1&&(v=1):y!==-1&&(v=-1)}if(S!==-1){const w=k===0&&l?1:k;y===-1||v===0||v===1&&y===S-1&&y===k+1?d.base=d.name=r.slice(w,S):(d.name=r.slice(w,y),d.base=r.slice(w,S),d.ext=r.slice(y,S))}return k>0?d.dir=r.slice(0,k-1):l&&(d.dir="/"),d},sep:"/",delimiter:":",win32:null,posix:null},e.$jc.win32=e.$ic.win32=e.$ic,e.$jc.posix=e.$ic.posix=e.$jc,e.$kc=a?e.$ic.normalize:e.$jc.normalize,e.$lc=a?e.$ic.isAbsolute:e.$jc.isAbsolute,e.$mc=a?e.$ic.join:e.$jc.join,e.$nc=a?e.$ic.resolve:e.$jc.resolve,e.$oc=a?e.$ic.relative:e.$jc.relative,e.$pc=a?e.$ic.dirname:e.$jc.dirname,e.$qc=a?e.$ic.basename:e.$jc.basename,e.$rc=a?e.$ic.extname:e.$jc.extname,e.$sc=a?e.$ic.format:e.$jc.format,e.$tc=a?e.$ic.parse:e.$jc.parse,e.$uc=a?e.$ic.toNamespacedPath:e.$jc.toNamespacedPath,e.sep=a?e.$ic.sep:e.$jc.sep,e.$wc=a?e.$ic.delimiter:e.$jc.delimiter}),define(Re[135],Ce([1,0,50,16]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gr=C,e.$Hr=m,e.$Ir=c,e.$Jr=I,e.$Kr=E,e.$Lr=g,e.$Mr=P,e.$Nr=b,e.$Or=a,e.$Pr=$,e.$Qr=f,e.$Rr=y,e.$Sr=k;const R=new s.$W(()=>{const S=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:S,collatorIsNumeric:S.resolvedOptions().numeric}}),A=new s.$W(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),O=new s.$W(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function C(S,D,T=!1){const v=S||"",w=D||"",M=R.value.collator.compare(v,w);return R.value.collatorIsNumeric&&M===0&&v!==w?v<w?-1:1:M}function m(S,D){const T=A.value.collator;return S=S||"",D=D||"",o(T,S,D)}function c(S,D){const T=A.value.collator;return S=S||"",D=D||"",d(S,D)||o(T,S,D)}function I(S,D){const T=A.value.collator;return S=S||"",D=D||"",r(S,D)||o(T,S,D)}function E(S,D){return S=S||"",D=D||"",S===D?0:S<D?-1:1}function g(S,D){const[T,v]=u(S),[w,M]=u(D);let L=R.value.collator.compare(v,M);if(L===0){if(R.value.collatorIsNumeric&&v!==M)return v<M?-1:1;if(L=R.value.collator.compare(T,w),R.value.collatorIsNumeric&&L===0&&T!==w)return T<w?-1:1}return L}function P(S,D){S=S||"",D=D||"";const T=i(S),v=i(D),w=A.value.collator,M=O.value.collator;return o(M,T,v)||o(w,S,D)}function b(S,D){S=S||"",D=D||"";const T=i(S),v=i(D),w=A.value.collator,M=O.value.collator;return o(M,T,v)||d(S,D)||o(w,S,D)}function a(S,D){S=S||"",D=D||"";const T=i(S),v=i(D),w=A.value.collator,M=O.value.collator;return o(M,T,v)||r(S,D)||o(w,S,D)}function $(S,D){S=S||"",D=D||"";const T=i(S).toLowerCase(),v=i(D).toLowerCase();return T!==v?T<v?-1:1:S!==D?S<D?-1:1:0}const p=/^(.*?)(\.([^.]*))?$/;function u(S,D=!1){const T=S?p.exec(S):[];let v=[T&&T[1]||"",T&&T[3]||""];return D&&(!v[0]&&v[1]||v[0]&&v[0].charAt(0)===".")&&(v=[v[0]+"."+v[1],""]),v}function i(S){const D=S?p.exec(S):[];return D&&D[1]&&D[1].charAt(0)!=="."&&D[3]||""}function o(S,D,T){const v=S.compare(D,T);return v!==0?v:D.length!==T.length?D.length<T.length?-1:1:0}function t(S){const D=S.charAt(0);return D.toLocaleUpperCase()!==D}function n(S){const D=S.charAt(0);return D.toLocaleLowerCase()!==D}function r(S,D){return t(S)&&n(D)?-1:n(S)&&t(D)?1:0}function d(S,D){return n(S)&&t(D)?-1:t(S)&&n(D)?1:0}function l(S,D,T=!1){return T||(S=S&&S.toLowerCase(),D=D&&D.toLowerCase()),S===D?0:S<D?-1:1}function f(S,D,T=!1){const v=S.split(h.sep),w=D.split(h.sep),M=v.length-1,L=w.length-1;let N,F;for(let V=0;;V++){if(N=M===V,F=L===V,N&&F)return C(v[V],w[V],T);if(N)return-1;if(F)return 1;const j=l(v[V],w[V],T);if(j!==0)return j}}function y(S,D,T){const v=S.toLowerCase(),w=D.toLowerCase(),M=k(S,D,T);if(M)return M;const L=v.endsWith(T),N=w.endsWith(T);if(L!==N)return L?-1:1;const F=C(v,w);return F!==0?F:v.localeCompare(w)}function k(S,D,T){const v=S.toLowerCase(),w=D.toLowerCase(),M=v.startsWith(T),L=w.startsWith(T);if(M!==L)return M?-1:1;if(M&&L){if(v.length<w.length)return-1;if(v.length>w.length)return 1}return 0}}),define(Re[103],Ce([1,0,16]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=void 0,e.$ft=A,e.$gt=O,e.$ht=C,e.$it=c,e.$et=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const h={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},R={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(I){const E=(0,s.$rc)(I),g=h[E.toLowerCase()];return g!==void 0?g:O(I)}function O(I){const E=(0,s.$rc)(I);return R[E.toLowerCase()]}function C(I){for(const E in R)if(R[E]===I)return E}const m=/^(.+)\/(.+?)(;.+)?$/;function c(I,E){const g=m.exec(I);return g?`${g[1].toLowerCase()}/${g[2].toLowerCase()}${g[3]??""}`:E?void 0:I}}),define(Re[104],Ce([1,0,10]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$om=A,e.$pm=O;var h;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(h||(e.Source=h={}));var R;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(R||(e.TerminateResponseCode=R={}));function A(C,...m){const c=m.reduce((g,P)=>(g[P]=!0,g),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(g=>!c[g]).forEach(g=>{for(let P=0;P<I.length;P++)if(g.search(I[P])!==-1){delete C[g];break}})}function O(C){C&&(delete C.DEBUG,s.$l&&delete C.LD_PRELOAD)}}),function(ge,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var s=e();for(var h in s)(typeof exports=="object"?exports:ge)[h]=s[h]}}(typeof self<"u"?self:this,function(){return function(ge){var e={};function s(h){if(e[h])return e[h].exports;var R=e[h]={i:h,l:!1,exports:{}};return ge[h].call(R.exports,R,R.exports,s),R.l=!0,R.exports}return s.m=ge,s.c=e,s.d=function(h,R,A){s.o(h,R)||Object.defineProperty(h,R,{enumerable:!0,get:A})},s.r=function(h){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(h,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(h,"__esModule",{value:!0})},s.t=function(h,R){if(1&R&&(h=s(h)),8&R||4&R&&typeof h=="object"&&h&&h.__esModule)return h;var A=Object.create(null);if(s.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:h}),2&R&&typeof h!="string")for(var O in h)s.d(A,O,function(C){return h[C]}.bind(null,O));return A},s.n=function(h){var R=h&&h.__esModule?function(){return h.default}:function(){return h};return s.d(R,"a",R),R},s.o=function(h,R){return Object.prototype.hasOwnProperty.call(h,R)},s.p="",s(s.s=0)}([function(ge,e,s){(function(h){var R;e=ge.exports=me,R=typeof h=="object"&&h.env&&h.env.NODE_DEBUG&&/\bsemver\b/i.test(h.env.NODE_DEBUG)?function(){var G=Array.prototype.slice.call(arguments,0);G.unshift("SEMVER"),console.log.apply(console,G)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,C=e.re=[],m=e.src=[],c=0,I=c++;m[I]="0|[1-9]\\d*";var E=c++;m[E]="[0-9]+";var g=c++;m[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var P=c++;m[P]="("+m[I]+")\\.("+m[I]+")\\.("+m[I]+")";var b=c++;m[b]="("+m[E]+")\\.("+m[E]+")\\.("+m[E]+")";var a=c++;m[a]="(?:"+m[I]+"|"+m[g]+")";var $=c++;m[$]="(?:"+m[E]+"|"+m[g]+")";var p=c++;m[p]="(?:-("+m[a]+"(?:\\."+m[a]+")*))";var u=c++;m[u]="(?:-?("+m[$]+"(?:\\."+m[$]+")*))";var i=c++;m[i]="[0-9A-Za-z-]+";var o=c++;m[o]="(?:\\+("+m[i]+"(?:\\."+m[i]+")*))";var t=c++,n="v?"+m[P]+m[p]+"?"+m[o]+"?";m[t]="^"+n+"$";var r="[v=\\s]*"+m[b]+m[u]+"?"+m[o]+"?",d=c++;m[d]="^"+r+"$";var l=c++;m[l]="((?:<|>)?=?)";var f=c++;m[f]=m[E]+"|x|X|\\*";var y=c++;m[y]=m[I]+"|x|X|\\*";var k=c++;m[k]="[v=\\s]*("+m[y]+")(?:\\.("+m[y]+")(?:\\.("+m[y]+")(?:"+m[p]+")?"+m[o]+"?)?)?";var S=c++;m[S]="[v=\\s]*("+m[f]+")(?:\\.("+m[f]+")(?:\\.("+m[f]+")(?:"+m[u]+")?"+m[o]+"?)?)?";var D=c++;m[D]="^"+m[l]+"\\s*"+m[k]+"$";var T=c++;m[T]="^"+m[l]+"\\s*"+m[S]+"$";var v=c++;m[v]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var w=c++;m[w]="(?:~>?)";var M=c++;m[M]="(\\s*)"+m[w]+"\\s+",C[M]=new RegExp(m[M],"g");var L=c++;m[L]="^"+m[w]+m[k]+"$";var N=c++;m[N]="^"+m[w]+m[S]+"$";var F=c++;m[F]="(?:\\^)";var V=c++;m[V]="(\\s*)"+m[F]+"\\s+",C[V]=new RegExp(m[V],"g");var j=c++;m[j]="^"+m[F]+m[k]+"$";var U=c++;m[U]="^"+m[F]+m[S]+"$";var z=c++;m[z]="^"+m[l]+"\\s*("+r+")$|^$";var _=c++;m[_]="^"+m[l]+"\\s*("+n+")$|^$";var W=c++;m[W]="(\\s*)"+m[l]+"\\s*("+r+"|"+m[k]+")",C[W]=new RegExp(m[W],"g");var B=c++;m[B]="^\\s*("+m[k]+")\\s+-\\s+("+m[k]+")\\s*$";var Y=c++;m[Y]="^\\s*("+m[S]+")\\s+-\\s+("+m[S]+")\\s*$";var x=c++;m[x]="(<|>)?=?\\s*\\*";for(var oe=0;oe<35;oe++)R(oe,m[oe]),C[oe]||(C[oe]=new RegExp(m[oe]));function ie(G,Z){if(G instanceof me)return G;if(typeof G!="string"||G.length>A||!(Z?C[d]:C[t]).test(G))return null;try{return new me(G,Z)}catch{return null}}function me(G,Z){if(G instanceof me){if(G.loose===Z)return G;G=G.version}else if(typeof G!="string")throw new TypeError("Invalid Version: "+G);if(G.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof me))return new me(G,Z);R("SemVer",G,Z),this.loose=Z;var ee=G.trim().match(Z?C[d]:C[t]);if(!ee)throw new TypeError("Invalid Version: "+G);if(this.raw=G,this.major=+ee[1],this.minor=+ee[2],this.patch=+ee[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");ee[4]?this.prerelease=ee[4].split(".").map(function(le){if(/^[0-9]+$/.test(le)){var ye=+le;if(ye>=0&&ye<O)return ye}return le}):this.prerelease=[],this.build=ee[5]?ee[5].split("."):[],this.format()}e.parse=ie,e.valid=function(G,Z){var ee=ie(G,Z);return ee?ee.version:null},e.clean=function(G,Z){var ee=ie(G.trim().replace(/^[=v]+/,""),Z);return ee?ee.version:null},e.SemVer=me,me.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},me.prototype.toString=function(){return this.version},me.prototype.compare=function(G){return R("SemVer.compare",this.version,this.loose,G),G instanceof me||(G=new me(G,this.loose)),this.compareMain(G)||this.comparePre(G)},me.prototype.compareMain=function(G){return G instanceof me||(G=new me(G,this.loose)),X(this.major,G.major)||X(this.minor,G.minor)||X(this.patch,G.patch)},me.prototype.comparePre=function(G){if(G instanceof me||(G=new me(G,this.loose)),this.prerelease.length&&!G.prerelease.length)return-1;if(!this.prerelease.length&&G.prerelease.length)return 1;if(!this.prerelease.length&&!G.prerelease.length)return 0;var Z=0;do{var ee=this.prerelease[Z],le=G.prerelease[Z];if(R("prerelease compare",Z,ee,le),ee===void 0&&le===void 0)return 0;if(le===void 0)return 1;if(ee===void 0)return-1;if(ee!==le)return X(ee,le)}while(++Z)},me.prototype.inc=function(G,Z){switch(G){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Z);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Z);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Z),this.inc("pre",Z);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Z),this.inc("pre",Z);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ee=this.prerelease.length;--ee>=0;)typeof this.prerelease[ee]=="number"&&(this.prerelease[ee]++,ee=-2);ee===-1&&this.prerelease.push(0)}Z&&(this.prerelease[0]===Z?isNaN(this.prerelease[1])&&(this.prerelease=[Z,0]):this.prerelease=[Z,0]);break;default:throw new Error("invalid increment argument: "+G)}return this.format(),this.raw=this.version,this},e.inc=function(G,Z,ee,le){typeof ee=="string"&&(le=ee,ee=void 0);try{return new me(G,ee).inc(Z,le).version}catch{return null}},e.diff=function(G,Z){if(ae(G,Z))return null;var ee=ie(G),le=ie(Z);if(ee.prerelease.length||le.prerelease.length){for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==le[ye])return"pre"+ye;return"prerelease"}for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==le[ye])return ye},e.compareIdentifiers=X;var ue=/^[0-9]+$/;function X(G,Z){var ee=ue.test(G),le=ue.test(Z);return ee&&le&&(G=+G,Z=+Z),ee&&!le?-1:le&&!ee?1:G<Z?-1:G>Z?1:0}function q(G,Z,ee){return new me(G,ee).compare(new me(Z,ee))}function se(G,Z,ee){return q(G,Z,ee)>0}function be(G,Z,ee){return q(G,Z,ee)<0}function ae(G,Z,ee){return q(G,Z,ee)===0}function we(G,Z,ee){return q(G,Z,ee)!==0}function $e(G,Z,ee){return q(G,Z,ee)>=0}function pe(G,Z,ee){return q(G,Z,ee)<=0}function Ae(G,Z,ee,le){var ye;switch(Z){case"===":typeof G=="object"&&(G=G.version),typeof ee=="object"&&(ee=ee.version),ye=G===ee;break;case"!==":typeof G=="object"&&(G=G.version),typeof ee=="object"&&(ee=ee.version),ye=G!==ee;break;case"":case"=":case"==":ye=ae(G,ee,le);break;case"!=":ye=we(G,ee,le);break;case">":ye=se(G,ee,le);break;case">=":ye=$e(G,ee,le);break;case"<":ye=be(G,ee,le);break;case"<=":ye=pe(G,ee,le);break;default:throw new TypeError("Invalid operator: "+Z)}return ye}function je(G,Z){if(G instanceof je){if(G.loose===Z)return G;G=G.value}if(!(this instanceof je))return new je(G,Z);R("comparator",G,Z),this.loose=Z,this.parse(G),this.semver===He?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(G,Z){return X(Z,G)},e.major=function(G,Z){return new me(G,Z).major},e.minor=function(G,Z){return new me(G,Z).minor},e.patch=function(G,Z){return new me(G,Z).patch},e.compare=q,e.compareLoose=function(G,Z){return q(G,Z,!0)},e.rcompare=function(G,Z,ee){return q(Z,G,ee)},e.sort=function(G,Z){return G.sort(function(ee,le){return e.compare(ee,le,Z)})},e.rsort=function(G,Z){return G.sort(function(ee,le){return e.rcompare(ee,le,Z)})},e.gt=se,e.lt=be,e.eq=ae,e.neq=we,e.gte=$e,e.lte=pe,e.cmp=Ae,e.Comparator=je;var He={};function Ye(G,Z){if(G instanceof Ye)return G.loose===Z?G:new Ye(G.raw,Z);if(G instanceof je)return new Ye(G.value,Z);if(!(this instanceof Ye))return new Ye(G,Z);if(this.loose=Z,this.raw=G,this.set=G.split(/\s*\|\|\s*/).map(function(ee){return this.parseRange(ee.trim())},this).filter(function(ee){return ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+G);this.format()}function xe(G){return!G||G.toLowerCase()==="x"||G==="*"}function Fe(G,Z,ee,le,ye,Te,Ve,Ke,rt,ot,ut,at,lt){return((Z=xe(ee)?"":xe(le)?">="+ee+".0.0":xe(ye)?">="+ee+"."+le+".0":">="+Z)+" "+(Ke=xe(rt)?"":xe(ot)?"<"+(+rt+1)+".0.0":xe(ut)?"<"+rt+"."+(+ot+1)+".0":at?"<="+rt+"."+ot+"."+ut+"-"+at:"<="+Ke)).trim()}function We(G,Z){for(var ee=0;ee<G.length;ee++)if(!G[ee].test(Z))return!1;if(Z.prerelease.length){for(ee=0;ee<G.length;ee++)if(R(G[ee].semver),G[ee].semver!==He&&G[ee].semver.prerelease.length>0){var le=G[ee].semver;if(le.major===Z.major&&le.minor===Z.minor&&le.patch===Z.patch)return!0}return!1}return!0}function Ne(G,Z,ee){try{Z=new Ye(Z,ee)}catch{return!1}return Z.test(G)}function H(G,Z,ee,le){var ye,Te,Ve,Ke,rt;switch(G=new me(G,le),Z=new Ye(Z,le),ee){case">":ye=se,Te=pe,Ve=be,Ke=">",rt=">=";break;case"<":ye=be,Te=$e,Ve=se,Ke="<",rt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(G,Z,le))return!1;for(var ot=0;ot<Z.set.length;++ot){var ut=Z.set[ot],at=null,lt=null;if(ut.forEach(function($t){$t.semver===He&&($t=new je(">=0.0.0")),at=at||$t,lt=lt||$t,ye($t.semver,at.semver,le)?at=$t:Ve($t.semver,lt.semver,le)&&(lt=$t)}),at.operator===Ke||at.operator===rt||(!lt.operator||lt.operator===Ke)&&Te(G,lt.semver)||lt.operator===rt&&Ve(G,lt.semver))return!1}return!0}je.prototype.parse=function(G){var Z=this.loose?C[z]:C[_],ee=G.match(Z);if(!ee)throw new TypeError("Invalid comparator: "+G);this.operator=ee[1],this.operator==="="&&(this.operator=""),ee[2]?this.semver=new me(ee[2],this.loose):this.semver=He},je.prototype.toString=function(){return this.value},je.prototype.test=function(G){return R("Comparator.test",G,this.loose),this.semver===He||(typeof G=="string"&&(G=new me(G,this.loose)),Ae(G,this.operator,this.semver,this.loose))},je.prototype.intersects=function(G,Z){if(!(G instanceof je))throw new TypeError("a Comparator is required");var ee;if(this.operator==="")return ee=new Ye(G.value,Z),Ne(this.value,ee,Z);if(G.operator==="")return ee=new Ye(this.value,Z),Ne(G.semver,ee,Z);var le=!(this.operator!==">="&&this.operator!==">"||G.operator!==">="&&G.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||G.operator!=="<="&&G.operator!=="<"),Te=this.semver.version===G.semver.version,Ve=!(this.operator!==">="&&this.operator!=="<="||G.operator!==">="&&G.operator!=="<="),Ke=Ae(this.semver,"<",G.semver,Z)&&(this.operator===">="||this.operator===">")&&(G.operator==="<="||G.operator==="<"),rt=Ae(this.semver,">",G.semver,Z)&&(this.operator==="<="||this.operator==="<")&&(G.operator===">="||G.operator===">");return le||ye||Te&&Ve||Ke||rt},e.Range=Ye,Ye.prototype.format=function(){return this.range=this.set.map(function(G){return G.join(" ").trim()}).join("||").trim(),this.range},Ye.prototype.toString=function(){return this.range},Ye.prototype.parseRange=function(G){var Z=this.loose;G=G.trim(),R("range",G,Z);var ee=Z?C[Y]:C[B];G=G.replace(ee,Fe),R("hyphen replace",G),G=G.replace(C[W],"$1$2$3"),R("comparator trim",G,C[W]),G=(G=(G=G.replace(C[M],"$1~")).replace(C[V],"$1^")).split(/\s+/).join(" ");var le=Z?C[z]:C[_],ye=G.split(" ").map(function(Te){return function(Ve,Ke){return R("comp",Ve),Ve=function(rt,ot){return rt.trim().split(/\s+/).map(function(ut){return function(at,lt){R("caret",at,lt);var $t=lt?C[U]:C[j];return at.replace($t,function(it,Ie,re,ce,Se){var de;return R("caret",at,it,Ie,re,ce,Se),xe(Ie)?de="":xe(re)?de=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":xe(ce)?de=Ie==="0"?">="+Ie+"."+re+".0 <"+Ie+"."+(+re+1)+".0":">="+Ie+"."+re+".0 <"+(+Ie+1)+".0.0":Se?(R("replaceCaret pr",Se),Se.charAt(0)!=="-"&&(Se="-"+Se),de=Ie==="0"?re==="0"?">="+Ie+"."+re+"."+ce+Se+" <"+Ie+"."+re+"."+(+ce+1):">="+Ie+"."+re+"."+ce+Se+" <"+Ie+"."+(+re+1)+".0":">="+Ie+"."+re+"."+ce+Se+" <"+(+Ie+1)+".0.0"):(R("no pr"),de=Ie==="0"?re==="0"?">="+Ie+"."+re+"."+ce+" <"+Ie+"."+re+"."+(+ce+1):">="+Ie+"."+re+"."+ce+" <"+Ie+"."+(+re+1)+".0":">="+Ie+"."+re+"."+ce+" <"+(+Ie+1)+".0.0"),R("caret return",de),de})}(ut,ot)}).join(" ")}(Ve,Ke),R("caret",Ve),Ve=function(rt,ot){return rt.trim().split(/\s+/).map(function(ut){return function(at,lt){var $t=lt?C[N]:C[L];return at.replace($t,function(it,Ie,re,ce,Se){var de;return R("tilde",at,it,Ie,re,ce,Se),xe(Ie)?de="":xe(re)?de=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":xe(ce)?de=">="+Ie+"."+re+".0 <"+Ie+"."+(+re+1)+".0":Se?(R("replaceTilde pr",Se),Se.charAt(0)!=="-"&&(Se="-"+Se),de=">="+Ie+"."+re+"."+ce+Se+" <"+Ie+"."+(+re+1)+".0"):de=">="+Ie+"."+re+"."+ce+" <"+Ie+"."+(+re+1)+".0",R("tilde return",de),de})}(ut,ot)}).join(" ")}(Ve,Ke),R("tildes",Ve),Ve=function(rt,ot){return R("replaceXRanges",rt,ot),rt.split(/\s+/).map(function(ut){return function(at,lt){at=at.trim();var $t=lt?C[T]:C[D];return at.replace($t,function(it,Ie,re,ce,Se,de){R("xRange",at,it,Ie,re,ce,Se,de);var ke=xe(re),ne=ke||xe(ce),J=ne||xe(Se);return Ie==="="&&J&&(Ie=""),ke?it=Ie===">"||Ie==="<"?"<0.0.0":"*":Ie&&J?(ne&&(ce=0),J&&(Se=0),Ie===">"?(Ie=">=",ne?(re=+re+1,ce=0,Se=0):J&&(ce=+ce+1,Se=0)):Ie==="<="&&(Ie="<",ne?re=+re+1:ce=+ce+1),it=Ie+re+"."+ce+"."+Se):ne?it=">="+re+".0.0 <"+(+re+1)+".0.0":J&&(it=">="+re+"."+ce+".0 <"+re+"."+(+ce+1)+".0"),R("xRange return",it),it})}(ut,ot)}).join(" ")}(Ve,Ke),R("xrange",Ve),Ve=function(rt,ot){return R("replaceStars",rt,ot),rt.trim().replace(C[x],"")}(Ve,Ke),R("stars",Ve),Ve}(Te,Z)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(Te){return!!Te.match(le)})),ye=ye.map(function(Te){return new je(Te,Z)})},Ye.prototype.intersects=function(G,Z){if(!(G instanceof Ye))throw new TypeError("a Range is required");return this.set.some(function(ee){return ee.every(function(le){return G.set.some(function(ye){return ye.every(function(Te){return le.intersects(Te,Z)})})})})},e.toComparators=function(G,Z){return new Ye(G,Z).set.map(function(ee){return ee.map(function(le){return le.value}).join(" ").trim().split(" ")})},Ye.prototype.test=function(G){if(!G)return!1;typeof G=="string"&&(G=new me(G,this.loose));for(var Z=0;Z<this.set.length;Z++)if(We(this.set[Z],G))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(G,Z,ee){var le=null,ye=null;try{var Te=new Ye(Z,ee)}catch{return null}return G.forEach(function(Ve){Te.test(Ve)&&(le&&ye.compare(Ve)!==-1||(ye=new me(le=Ve,ee)))}),le},e.minSatisfying=function(G,Z,ee){var le=null,ye=null;try{var Te=new Ye(Z,ee)}catch{return null}return G.forEach(function(Ve){Te.test(Ve)&&(le&&ye.compare(Ve)!==1||(ye=new me(le=Ve,ee)))}),le},e.validRange=function(G,Z){try{return new Ye(G,Z).range||"*"}catch{return null}},e.ltr=function(G,Z,ee){return H(G,Z,"<",ee)},e.gtr=function(G,Z,ee){return H(G,Z,">",ee)},e.outside=H,e.prerelease=function(G,Z){var ee=ie(G,Z);return ee&&ee.prerelease.length?ee.prerelease:null},e.intersects=function(G,Z,ee){return G=new Ye(G,ee),Z=new Ye(Z,ee),G.intersects(Z)},e.coerce=function(G){if(G instanceof me)return G;if(typeof G!="string")return null;var Z=G.match(C[v]);return Z==null?null:ie((Z[1]||"0")+"."+(Z[2]||"0")+"."+(Z[3]||"0"))}}).call(this,s(1))},function(ge,e){var s,h,R=ge.exports={};function A(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function C($){if(s===setTimeout)return setTimeout($,0);if((s===A||!s)&&setTimeout)return s=setTimeout,setTimeout($,0);try{return s($,0)}catch{try{return s.call(null,$,0)}catch{return s.call(this,$,0)}}}(function(){try{s=typeof setTimeout=="function"?setTimeout:A}catch{s=A}try{h=typeof clearTimeout=="function"?clearTimeout:O}catch{h=O}})();var m,c=[],I=!1,E=-1;function g(){I&&m&&(I=!1,m.length?c=m.concat(c):E=-1,c.length&&P())}function P(){if(!I){var $=C(g);I=!0;for(var p=c.length;p;){for(m=c,c=[];++E<p;)m&&m[E].run();E=-1,p=c.length}m=null,I=!1,function(u){if(h===clearTimeout)return clearTimeout(u);if((h===O||!h)&&clearTimeout)return h=clearTimeout,clearTimeout(u);try{h(u)}catch{try{return h.call(null,u)}catch{return h.call(this,u)}}}($)}}function b($,p){this.fun=$,this.array=p}function a(){}R.nextTick=function($){var p=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)p[u-1]=arguments[u];c.push(new b($,p)),c.length!==1||I||C(P)},b.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=a,R.addListener=a,R.once=a,R.off=a,R.removeListener=a,R.removeAllListeners=a,R.emit=a,R.prependListener=a,R.prependOnceListener=a,R.listeners=function($){return[]},R.binding=function($){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function($){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(Re[43],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=void 0;const s=globalThis.performance&&typeof globalThis.performance.now=="function";class h{static create(A){return new h(A)}constructor(A){this.c=s&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ie=h}),define(Re[4],Ce([1,0,12,81,3,82,43]),function(ge,e,s,h,R,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$ke=e.Event=void 0,e.$le=P;const C=!1,m=!1,c=!1;var I;(function(N){N.None=()=>R.$Xc.None;function F(Ne){if(c){const{onDidAddListener:H}=Ne,G=a.create();let Z=0;Ne.onDidAddListener=()=>{++Z===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),G.print()),H?.()}}}function V(Ne,H){return me(Ne,()=>{},0,void 0,!0,void 0,H)}N.defer=V;function j(Ne){return(H,G=null,Z)=>{let ee=!1,le;return le=Ne(ye=>{if(!ee)return le?le.dispose():ee=!0,H.call(G,ye)},null,Z),ee&&le.dispose(),le}}N.once=j;function U(Ne,H){return N.once(N.filter(Ne,H))}N.onceIf=U;function z(Ne,H,G){return oe((Z,ee=null,le)=>Ne(ye=>Z.call(ee,H(ye)),null,le),G)}N.map=z;function _(Ne,H,G){return oe((Z,ee=null,le)=>Ne(ye=>{H(ye),Z.call(ee,ye)},null,le),G)}N.forEach=_;function W(Ne,H,G){return oe((Z,ee=null,le)=>Ne(ye=>H(ye)&&Z.call(ee,ye),null,le),G)}N.filter=W;function B(Ne){return Ne}N.signal=B;function Y(...Ne){return(H,G=null,Z)=>{const ee=(0,R.$Uc)(...Ne.map(le=>le(ye=>H.call(G,ye))));return ie(ee,Z)}}N.any=Y;function x(Ne,H,G,Z){let ee=G;return z(Ne,le=>(ee=H(ee,le),ee),Z)}N.reduce=x;function oe(Ne,H){let G;const Z={onWillAddFirstListener(){G=Ne(ee.fire,ee)},onDidRemoveLastListener(){G?.dispose()}};H||F(Z);const ee=new r(Z);return H?.add(ee),ee.event}function ie(Ne,H){return H instanceof Array?H.push(Ne):H&&H.add(Ne),Ne}function me(Ne,H,G=100,Z=!1,ee=!1,le,ye){let Te,Ve,Ke,rt=0,ot;const ut={leakWarningThreshold:le,onWillAddFirstListener(){Te=Ne(lt=>{rt++,Ve=H(Ve,lt),Z&&!Ke&&(at.fire(Ve),Ve=void 0),ot=()=>{const $t=Ve;Ve=void 0,Ke=void 0,(!Z||rt>1)&&at.fire($t),rt=0},typeof G=="number"?(clearTimeout(Ke),Ke=setTimeout(ot,G)):Ke===void 0&&(Ke=0,queueMicrotask(ot))})},onWillRemoveListener(){ee&&rt>0&&ot?.()},onDidRemoveLastListener(){ot=void 0,Te.dispose()}};ye||F(ut);const at=new r(ut);return ye?.add(at),at.event}N.debounce=me;function ue(Ne,H=0,G){return N.debounce(Ne,(Z,ee)=>Z?(Z.push(ee),Z):[ee],H,void 0,!0,void 0,G)}N.accumulate=ue;function X(Ne,H=(Z,ee)=>Z===ee,G){let Z=!0,ee;return W(Ne,le=>{const ye=Z||!H(le,ee);return Z=!1,ee=le,ye},G)}N.latch=X;function q(Ne,H,G){return[N.filter(Ne,H,G),N.filter(Ne,Z=>!H(Z),G)]}N.split=q;function se(Ne,H=!1,G=[],Z){let ee=G.slice(),le=Ne(Ve=>{ee?ee.push(Ve):Te.fire(Ve)});Z&&Z.add(le);const ye=()=>{ee?.forEach(Ve=>Te.fire(Ve)),ee=null},Te=new r({onWillAddFirstListener(){le||(le=Ne(Ve=>Te.fire(Ve)),Z&&Z.add(le))},onDidAddFirstListener(){ee&&(H?setTimeout(ye):ye())},onDidRemoveLastListener(){le&&le.dispose(),le=null}});return Z&&Z.add(Te),Te.event}N.buffer=se;function be(Ne,H){return(Z,ee,le)=>{const ye=H(new we);return Ne(function(Te){const Ve=ye.evaluate(Te);Ve!==ae&&Z.call(ee,Ve)},void 0,le)}}N.chain=be;const ae=Symbol("HaltChainable");class we{constructor(){this.f=[]}map(H){return this.f.push(H),this}forEach(H){return this.f.push(G=>(H(G),G)),this}filter(H){return this.f.push(G=>H(G)?G:ae),this}reduce(H,G){let Z=G;return this.f.push(ee=>(Z=H(Z,ee),Z)),this}latch(H=(G,Z)=>G===Z){let G=!0,Z;return this.f.push(ee=>{const le=G||!H(ee,Z);return G=!1,Z=ee,le?ee:ae}),this}evaluate(H){for(const G of this.f)if(H=G(H),H===ae)break;return H}}function $e(Ne,H,G=Z=>Z){const Z=(...Te)=>ye.fire(G(...Te)),ee=()=>Ne.on(H,Z),le=()=>Ne.removeListener(H,Z),ye=new r({onWillAddFirstListener:ee,onDidRemoveLastListener:le});return ye.event}N.fromNodeEventEmitter=$e;function pe(Ne,H,G=Z=>Z){const Z=(...Te)=>ye.fire(G(...Te)),ee=()=>Ne.addEventListener(H,Z),le=()=>Ne.removeEventListener(H,Z),ye=new r({onWillAddFirstListener:ee,onDidRemoveLastListener:le});return ye.event}N.fromDOMEventEmitter=pe;function Ae(Ne){return new Promise(H=>j(Ne)(H))}N.toPromise=Ae;function je(Ne){const H=new r;return Ne.then(G=>{H.fire(G)},()=>{H.fire(void 0)}).finally(()=>{H.dispose()}),H.event}N.fromPromise=je;function He(Ne,H){return Ne(G=>H.fire(G))}N.forward=He;function Ye(Ne,H,G){return H(G),Ne(Z=>H(Z))}N.runAndSubscribe=Ye;class xe{constructor(H,G){this._observable=H,this.f=0,this.g=!1;const Z={onWillAddFirstListener:()=>{H.addObserver(this),this._observable.reportChanges()},onDidRemoveLastListener:()=>{H.removeObserver(this)}};G||F(Z),this.emitter=new r(Z),G&&G.add(this.emitter)}beginUpdate(H){this.f++}handlePossibleChange(H){}handleChange(H,G){this.g=!0}endUpdate(H){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Fe(Ne,H){return new xe(Ne,H).emitter.event}N.fromObservable=Fe;function We(Ne){return(H,G,Z)=>{let ee=0,le=!1;const ye={beginUpdate(){ee++},endUpdate(){ee--,ee===0&&(Ne.reportChanges(),le&&(le=!1,H.call(G)))},handlePossibleChange(){},handleChange(){le=!0}};Ne.addObserver(ye),Ne.reportChanges();const Te={dispose(){Ne.removeObserver(ye)}};return Z instanceof R.$Wc?Z.add(Te):Array.isArray(Z)&&Z.push(Te),Te}}N.fromObservableLight=We})(I||(e.Event=I={}));class E{static{this.all=new Set}static{this.f=0}constructor(F){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${F}_${E.f++}`,E.all.add(this)}start(F){this.g=new O.$ie,this.listenerCount=F}stop(){if(this.g){const F=this.g.elapsed();this.durations.push(F),this.elapsedOverall+=F,this.invocationCount+=1,this.g=void 0}}}e.$ke=E;let g=-1;function P(N){const F=g;return g=N,{dispose(){g=F}}}class b{static{this.f=1}constructor(F,V,j=(b.f++).toString(16).padStart(3,"0")){this.j=F,this.threshold=V,this.name=j,this.h=0}dispose(){this.g?.clear()}check(F,V){const j=this.threshold;if(j<=0||V<j)return;this.g||(this.g=new Map);const U=this.g.get(F.value)||0;if(this.g.set(F.value,U+1),this.h-=1,this.h<=0){this.h=j*.5;const[z,_]=this.getMostFrequentStack(),W=`[${this.name}] potential listener LEAK detected, having ${V} listeners already. MOST frequent listener (${_}):`;console.warn(W),console.warn(z);const B=new $(W,z);this.j(B)}return()=>{const z=this.g.get(F.value)||0;this.g.set(F.value,z-1)}}getMostFrequentStack(){if(!this.g)return;let F,V=0;for(const[j,U]of this.g)(!F||V<U)&&(F=[j,U],V=U);return F}}class a{static create(){const F=new Error;return new a(F.stack??"")}constructor(F){this.value=F}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class $ extends Error{constructor(F,V){super(F),this.name="ListenerLeakError",this.stack=V}}e.$me=$;class p extends Error{constructor(F,V){super(F),this.name="ListenerRefusalError",this.stack=V}}e.$ne=p;let u=0;class i{constructor(F){this.value=F,this.id=u++}}const o=2,t=(N,F)=>{if(N instanceof i)F(N);else for(let V=0;V<N.length;V++){const j=N[V];j&&F(j)}};let n;if(C){const N=[];setInterval(()=>{N.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(N.join(`
`)),N.length=0)},3e3),n=new FinalizationRegistry(F=>{typeof F=="string"&&N.push(F)})}class r{constructor(F){this.z=0,this.f=F,this.g=g>0||this.f?.leakWarningThreshold?new b(F?.onListenerError??s.$2,this.f?.leakWarningThreshold??g):void 0,this.j=this.f?._profName?new E(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(m){const F=this.u;queueMicrotask(()=>{t(F,V=>V.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(F,V,j)=>{if(this.g&&this.z>this.g.threshold**2){const B=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(B);const Y=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],x=new p(`${B}. HINT: Stack shows most frequent listener (${Y[1]}-times)`,Y[0]);return(this.f?.onListenerError||s.$2)(x),R.$Xc.None}if(this.m)return R.$Xc.None;V&&(F=F.bind(V));const U=new i(F);let z,_;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(U.stack=a.create(),z=this.g.check(U.stack,this.z+1)),m&&(U.stack=_??a.create()),this.u?this.u instanceof i?(this.w??=new l,this.u=[this.u,U]):this.u.push(U):(this.f?.onWillAddFirstListener?.(this),this.u=U,this.f?.onDidAddFirstListener?.(this)),this.z++;const W=(0,R.$Vc)(()=>{n?.unregister(W),z?.(),this.A(U)});if(j instanceof R.$Wc?j.add(W):Array.isArray(j)&&j.push(W),n){const B=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),Y=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(B);n.register(W,Y?.[2]??B,W)}return W},this.q}A(F){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const V=this.u,j=V.indexOf(F);if(j===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,V[j]=void 0;const U=this.w.current===this;if(this.z*o<=V.length){let z=0;for(let _=0;_<V.length;_++)V[_]?V[z++]=V[_]:U&&(this.w.end--,z<this.w.i&&this.w.i--);V.length=z}}B(F,V){if(!F)return;const j=this.f?.onListenerError||s.$2;if(!j){F.value(V);return}try{F.value(V)}catch(U){j(U)}}C(F){const V=F.current.u;for(;F.i<F.end;)this.B(V[F.i++],F.value);F.reset()}fire(F){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof i)this.B(this.u,F);else{const V=this.w;V.enqueue(this,F,this.u.length),this.C(V)}this.j?.stop()}hasListeners(){return this.z>0}}e.$oe=r;const d=()=>new l;e.$pe=d;class l{constructor(){this.i=-1,this.end=0}enqueue(F,V,j){this.i=0,this.end=j,this.current=F,this.value=V}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class f extends r{async fireAsync(F,V,j){if(this.u)for(this.h||(this.h=new A.$8c),t(this.u,U=>this.h.push([U.value,F]));this.h.size>0&&!V.isCancellationRequested;){const[U,z]=this.h.shift(),_=[],W={...z,token:V,waitUntil:B=>{if(Object.isFrozen(_))throw new Error("waitUntil can NOT be called asynchronous");j&&(B=j(B,U)),_.push(B)}};try{U(W)}catch(B){(0,s.$2)(B);continue}Object.freeze(_),await Promise.allSettled(_).then(B=>{for(const Y of B)Y.status==="rejected"&&(0,s.$2)(Y.reason)})}}}e.$qe=f;class y extends r{get isPaused(){return this.h!==0}constructor(F){super(F),this.h=0,this.s=new A.$8c,this.t=F?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const F=Array.from(this.s);this.s.clear(),super.fire(this.t(F))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(F){this.z&&(this.h!==0?this.s.push(F):super.fire(F))}}e.$re=y;class k extends y{constructor(F){super(F),this.k=F.delay??100}fire(F){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(F)}}e.$se=k;class S extends r{constructor(F){super(F),this.h=[],this.k=F?.merge}fire(F){this.hasListeners()&&(this.h.push(F),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(V=>super.fire(V)),this.h=[]}))}}e.$te=S;class D{constructor(){this.g=!1,this.h=[],this.f=new r({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(F){const V={event:F,listener:null};this.h.push(V),this.g&&this.m(V);const j=()=>{this.g&&this.o(V);const U=this.h.indexOf(V);this.h.splice(U,1)};return(0,R.$Vc)((0,h.$fb)(j))}j(){this.g=!0,this.h.forEach(F=>this.m(F))}k(){this.g=!1,this.h.forEach(F=>this.o(F))}m(F){F.listener=F.event(V=>this.f.fire(V))}o(F){F.listener?.dispose(),F.listener=null}dispose(){this.f.dispose();for(const F of this.h)F.listener?.dispose();this.h=[]}}e.$ue=D;class T{constructor(F,V,j,U){this.f=new R.$Wc;const z=this.f.add(new D),_=this.f.add(new R.$7c);function W(B){_.set(B,z.add(U(B)))}for(const B of F)W(B);this.f.add(V(B=>{W(B)})),this.f.add(j(B=>{_.deleteAndDispose(B)})),this.event=z.event}dispose(){this.f.dispose()}}e.$ve=T;class v{constructor(){this.f=[]}wrapEvent(F,V,j){return(U,z,_)=>F(W=>{const B=this.f[this.f.length-1];if(!V){B?B.buffers.push(()=>U.call(z,W)):U.call(z,W);return}const Y=B;if(!Y){U.call(z,V(j,W));return}Y.items??=[],Y.items.push(W),Y.buffers.length===0&&B.buffers.push(()=>{Y.reducedResult??=j?Y.items.reduce(V,j):Y.items.reduce(V),U.call(z,Y.reducedResult)})},void 0,_)}bufferEvents(F){const V={buffers:new Array};this.f.push(V);const j=F();return this.f.pop(),V.buffers.forEach(U=>U()),j}}e.$we=v;class w{constructor(){this.f=!1,this.g=I.None,this.h=R.$Xc.None,this.j=new r({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(F){this.g=F,this.f&&(this.h.dispose(),this.h=F(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$xe=w;class M{static const(F){return new L(F)}constructor(F){this.g=F,this.f=new r,this.onDidChange=this.f.event}get value(){return this.g}set value(F){F!==this.g&&(this.g=F,this.f.fire(void 0))}}e.$ye=M;class L{constructor(F){this.value=F,this.onDidChange=I.None}}}),define(Re[20],Ce([1,0,4]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.CancellationToken=void 0,e.$Ae=C;const h=Object.freeze(function(m,c){const I=setTimeout(m.bind(c),0);return{dispose(){clearTimeout(I)}}});var R;(function(m){function c(I){return I===m.None||I===m.Cancelled||I instanceof A?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}m.isCancellationToken=c,m.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:s.Event.None}),m.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:h})})(R||(e.CancellationToken=R={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?h:(this.b||(this.b=new s.$oe),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class O{constructor(c){this.f=void 0,this.g=void 0,this.g=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=R.Cancelled}dispose(c=!1){c&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=R.None}}e.$ze=O;function C(m){const c=new O;return m.add({dispose(){c.cancel()}}),c.token}}),define(Re[187],Ce([1,0,20]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cf=e.$bf=e.$_e=void 0,e.$af=R;class h{constructor(m){this.b=m,this.a=null}get(){if(this.a)return this.a;const m=new s.$ze,c=this.b(m.token);return this.a={promise:c,dispose:()=>{this.a=null,m.cancel(),m.dispose()}},this.a}}e.$_e=h;function R(C){return C}class A{constructor(m,c){this.a=void 0,this.b=void 0,typeof m=="function"?(this.c=m,this.d=R):(this.c=c,this.d=m.getCacheKey)}get(m){const c=this.d(m);return this.b!==c&&(this.b=c,this.a=this.c(m)),this.a}}e.$bf=A;class O{get cachedValues(){return this.a}constructor(m,c){this.a=new Map,this.b=new Map,typeof m=="function"?(this.c=m,this.d=R):(this.c=c,this.d=m.getCacheKey)}get(m){const c=this.d(m);if(this.b.has(c))return this.b.get(c);const I=this.c(m);return this.a.set(m,I),this.b.set(c,I),I}}e.$cf=O}),define(Re[188],Ce([1,0,4,3]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mt=e.$lt=e.$kt=e.$jt=e.ScrollbarVisibility=void 0;var R;(function(P){P[P.Auto=1]="Auto",P[P.Hidden=2]="Hidden",P[P.Visible=3]="Visible"})(R||(e.ScrollbarVisibility=R={}));class A{constructor(b,a,$,p,u,i,o){this.c=b,this._scrollStateBrand=void 0,this.c&&(a=a|0,$=$|0,p=p|0,u=u|0,i=i|0,o=o|0),this.rawScrollLeft=p,this.rawScrollTop=o,a<0&&(a=0),p+a>$&&(p=$-a),p<0&&(p=0),u<0&&(u=0),o+u>i&&(o=i-u),o<0&&(o=0),this.width=a,this.scrollWidth=$,this.scrollLeft=p,this.height=u,this.scrollHeight=i,this.scrollTop=o}equals(b){return this.rawScrollLeft===b.rawScrollLeft&&this.rawScrollTop===b.rawScrollTop&&this.width===b.width&&this.scrollWidth===b.scrollWidth&&this.scrollLeft===b.scrollLeft&&this.height===b.height&&this.scrollHeight===b.scrollHeight&&this.scrollTop===b.scrollTop}withScrollDimensions(b,a){return new A(this.c,typeof b.width<"u"?b.width:this.width,typeof b.scrollWidth<"u"?b.scrollWidth:this.scrollWidth,a?this.rawScrollLeft:this.scrollLeft,typeof b.height<"u"?b.height:this.height,typeof b.scrollHeight<"u"?b.scrollHeight:this.scrollHeight,a?this.rawScrollTop:this.scrollTop)}withScrollPosition(b){return new A(this.c,this.width,this.scrollWidth,typeof b.scrollLeft<"u"?b.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof b.scrollTop<"u"?b.scrollTop:this.rawScrollTop)}createScrollEvent(b,a){const $=this.width!==b.width,p=this.scrollWidth!==b.scrollWidth,u=this.scrollLeft!==b.scrollLeft,i=this.height!==b.height,o=this.scrollHeight!==b.scrollHeight,t=this.scrollTop!==b.scrollTop;return{inSmoothScrolling:a,oldWidth:b.width,oldScrollWidth:b.scrollWidth,oldScrollLeft:b.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:b.height,oldScrollHeight:b.scrollHeight,oldScrollTop:b.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:$,scrollWidthChanged:p,scrollLeftChanged:u,heightChanged:i,scrollHeightChanged:o,scrollTopChanged:t}}}e.$jt=A;class O extends h.$Xc{constructor(b){super(),this._scrollableBrand=void 0,this.j=this.B(new s.$oe),this.onScroll=this.j.event,this.c=b.smoothScrollDuration,this.f=b.scheduleAtNextAnimationFrame,this.g=new A(b.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(b){this.c=b}validateScrollPosition(b){return this.g.withScrollPosition(b)}getScrollDimensions(){return this.g}setScrollDimensions(b,a){const $=this.g.withScrollDimensions(b,a);this.n($,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(b){const a=this.g.withScrollPosition(b);this.h&&(this.h.dispose(),this.h=null),this.n(a,!1)}setScrollPositionSmooth(b,a){if(this.c===0)return this.setScrollPositionNow(b);if(this.h){b={scrollLeft:typeof b.scrollLeft>"u"?this.h.to.scrollLeft:b.scrollLeft,scrollTop:typeof b.scrollTop>"u"?this.h.to.scrollTop:b.scrollTop};const $=this.g.withScrollPosition(b);if(this.h.to.scrollLeft===$.scrollLeft&&this.h.to.scrollTop===$.scrollTop)return;let p;a?p=new I(this.h.from,$,this.h.startTime,this.h.duration):p=this.h.combine(this.g,$,this.c),this.h.dispose(),this.h=p}else{const $=this.g.withScrollPosition(b);this.h=I.start(this.g,$,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const b=this.h.tick(),a=this.g.withScrollPosition(b);if(this.n(a,!0),!!this.h){if(b.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(b,a){const $=this.g;$.equals(b)||(this.g=b,this.j.fire(this.g.createScrollEvent($,a)))}}e.$kt=O;class C{constructor(b,a,$){this.scrollLeft=b,this.scrollTop=a,this.isDone=$}}e.$lt=C;function m(P,b){const a=b-P;return function($){return P+a*g($)}}function c(P,b,a){return function($){return $<a?P($/a):b(($-a)/(1-a))}}class I{constructor(b,a,$,p){this.from=b,this.to=a,this.duration=p,this.startTime=$,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(b,a,$){if(Math.abs(b-a)>2.5*$){let u,i;return b<a?(u=b+.75*$,i=a-.75*$):(u=b-.75*$,i=a+.75*$),c(m(b,u),m(i,a),.33)}return m(b,a)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(b){this.to=b.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(b){const a=(b-this.startTime)/this.duration;if(a<1){const $=this.c(a),p=this.d(a);return new C($,p,!1)}return new C(this.to.scrollLeft,this.to.scrollTop,!0)}combine(b,a,$){return I.start(b,a,$)}static start(b,a,$){$=$+10;const p=Date.now()-10;return new I(b,a,p,$)}}e.$mt=I;function E(P){return Math.pow(P,3)}function g(P){return 1-E(1-P)}}),define(Re[105],Ce([1,0,12,3]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Be=R,e.$Ce=A,e.$De=O,e.$Ee=C,e.$Fe=c,e.$Ge=I,e.$He=E,e.$Ie=g,e.$Je=P,e.$Ke=b,e.$Le=a,e.$Me=$,e.$Ne=p,e.$Oe=u,e.$Pe=i;function R(o){const t=o;return t?typeof t.read=="function":!1}function A(o){const t=o;return t?[t.on,t.pause,t.resume,t.destroy].every(n=>typeof n=="function"):!1}function O(o){const t=o;return t?A(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function C(o,t){return new m(o,t)}class m{constructor(t,n){this.e=t,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(n=>n(t))}h(t){this.c.error.length===0?(0,s.$2)(t):this.c.error.slice(0).forEach(n=>n(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,n){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(t,n){if(this.a.destroyed)return;let r;switch(t){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const d=r.indexOf(n);d>=0&&r.splice(d,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(o,t){const n=[];let r;for(;(r=o.read())!==null;)n.push(r);return t(n)}function I(o,t,n){const r=[];let d;for(;(d=o.read())!==null&&r.length<n;)r.push(d);return d===null&&r.length>0?t(r):{read:()=>{if(r.length>0)return r.shift();if(typeof d<"u"){const l=d;return d=void 0,l}return o.read()}}}function E(o,t){return new Promise((n,r)=>{const d=[];g(o,{onData:l=>{t&&d.push(l)},onError:l=>{t?r(l):n(void 0)},onEnd:()=>{n(t?t(d):void 0)}})})}function g(o,t,n){o.on("error",r=>{n?.isCancellationRequested||t.onError(r)}),o.on("end",()=>{n?.isCancellationRequested||t.onEnd()}),o.on("data",r=>{n?.isCancellationRequested||t.onData(r)})}function P(o,t){return new Promise((n,r)=>{const d=new h.$Wc,l=[],f=S=>{if(l.push(S),l.length>t)return d.dispose(),o.pause(),n({stream:o,buffer:l,ended:!1})},y=S=>(d.dispose(),r(S)),k=()=>(d.dispose(),n({stream:o,buffer:l,ended:!0}));d.add((0,h.$Vc)(()=>o.removeListener("error",y))),o.on("error",y),d.add((0,h.$Vc)(()=>o.removeListener("end",k))),o.on("end",k),d.add((0,h.$Vc)(()=>o.removeListener("data",f))),o.on("data",f)})}function b(o,t){const n=C(t);return n.end(o),n}function a(){const o=C(()=>{throw new Error("not supported")});return o.end(),o}function $(o){let t=!1;return{read:()=>t?null:(t=!0,o)}}function p(o,t,n){const r=C(n);return g(o,{onData:d=>r.write(t.data(d)),onError:d=>r.error(t.error?t.error(d):d),onEnd:()=>r.end()}),r}function u(o,t,n){let r=!1;return{read:()=>{const d=t.read();return r?d:(r=!0,d!==null?n([o,d]):o)}}}function i(o,t,n){let r=!1;const d=C(n);return g(t,{onData:l=>r?d.write(l):(r=!0,d.write(n([o,l]))),onError:l=>d.error(l),onEnd:()=>{r||(r=!0,d.write(o)),d.end()}}),d}}),define(Re[21],Ce([1,0,50,105]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qe=void 0,e.$Re=c,e.$Se=I,e.$Te=E,e.$Ue=g,e.$Ve=P,e.$We=b,e.$Xe=a,e.$Ye=$,e.$Ze=p,e.$1e=u,e.$2e=i,e.$3e=o,e.$4e=t,e.$5e=n,e.$6e=r,e.$7e=d,e.$8e=l,e.$9e=f,e.$0e=y,e.$$e=D,h=Ue(h);const R=typeof Buffer<"u",A=new s.$W(()=>new Uint8Array(256));let O,C;class m{static alloc(v){return R?new m(Buffer.allocUnsafe(v)):new m(new Uint8Array(v))}static wrap(v){return R&&!Buffer.isBuffer(v)&&(v=Buffer.from(v.buffer,v.byteOffset,v.byteLength)),new m(v)}static fromString(v,w){return!(w?.dontUseNodeBuffer||!1)&&R?new m(Buffer.from(v)):(O||(O=new TextEncoder),new m(O.encode(v)))}static fromByteArray(v){const w=m.alloc(v.length);for(let M=0,L=v.length;M<L;M++)w.buffer[M]=v[M];return w}static concat(v,w){if(typeof w>"u"){w=0;for(let N=0,F=v.length;N<F;N++)w+=v[N].byteLength}const M=m.alloc(w);let L=0;for(let N=0,F=v.length;N<F;N++){const V=v[N];M.set(V,L),L+=V.byteLength}return M}constructor(v){this.buffer=v,this.byteLength=this.buffer.byteLength}clone(){const v=m.alloc(this.byteLength);return v.set(this),v}toString(){return R?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(v,w){return new m(this.buffer.subarray(v,w))}set(v,w){if(v instanceof m)this.buffer.set(v.buffer,w);else if(v instanceof Uint8Array)this.buffer.set(v,w);else if(v instanceof ArrayBuffer)this.buffer.set(new Uint8Array(v),w);else if(ArrayBuffer.isView(v))this.buffer.set(new Uint8Array(v.buffer,v.byteOffset,v.byteLength),w);else throw new Error("Unknown argument 'array'")}readUInt32BE(v){return g(this.buffer,v)}writeUInt32BE(v,w){P(this.buffer,v,w)}readUInt32LE(v){return b(this.buffer,v)}writeUInt32LE(v,w){a(this.buffer,v,w)}readUInt8(v){return $(this.buffer,v)}writeUInt8(v,w){p(this.buffer,v,w)}indexOf(v,w=0){return c(this.buffer,v instanceof m?v.buffer:v,w)}}e.$Qe=m;function c(T,v,w=0){const M=v.byteLength,L=T.byteLength;if(M===0)return 0;if(M===1)return T.indexOf(v[0]);if(M>L-w)return-1;const N=A.value;N.fill(v.length);for(let U=0;U<v.length;U++)N[v[U]]=v.length-U-1;let F=w+v.length-1,V=F,j=-1;for(;F<L;)if(T[F]===v[V]){if(V===0){j=F;break}F--,V--}else F+=Math.max(v.length-V,N[T[F]]),V=v.length-1;return j}function I(T,v){return T[v+0]<<0>>>0|T[v+1]<<8>>>0}function E(T,v,w){T[w+0]=v&255,v=v>>>8,T[w+1]=v&255}function g(T,v){return T[v]*2**24+T[v+1]*2**16+T[v+2]*2**8+T[v+3]}function P(T,v,w){T[w+3]=v,v=v>>>8,T[w+2]=v,v=v>>>8,T[w+1]=v,v=v>>>8,T[w]=v}function b(T,v){return T[v+0]<<0>>>0|T[v+1]<<8>>>0|T[v+2]<<16>>>0|T[v+3]<<24>>>0}function a(T,v,w){T[w+0]=v&255,v=v>>>8,T[w+1]=v&255,v=v>>>8,T[w+2]=v&255,v=v>>>8,T[w+3]=v&255}function $(T,v){return T[v]}function p(T,v,w){T[w]=v}function u(T){return h.$Fe(T,v=>m.concat(v))}function i(T){return h.$Me(T)}function o(T){return h.$He(T,v=>m.concat(v))}async function t(T){return T.ended?m.concat(T.buffer):m.concat([...T.buffer,await o(T.stream)])}function n(T){return h.$Ke(T,v=>m.concat(v))}function r(T){return h.$Ne(T,{data:v=>typeof v=="string"?m.fromString(v):m.wrap(v)},v=>m.concat(v))}function d(T){return h.$Ee(v=>m.concat(v),T)}function l(T,v){return h.$Oe(T,v,w=>m.concat(w))}function f(T,v){return h.$Pe(T,v,w=>m.concat(w))}function y(T){let v=0,w=0,M=0;const L=new Uint8Array(Math.floor(T.length/4*3)),N=V=>{switch(w){case 3:L[M++]=v|V,w=0;break;case 2:L[M++]=v|V>>>2,v=V<<6,w=3;break;case 1:L[M++]=v|V>>>4,v=V<<4,w=2;break;default:v=V<<2,w=1}};for(let V=0;V<T.length;V++){const j=T.charCodeAt(V);if(j>=65&&j<=90)N(j-65);else if(j>=97&&j<=122)N(j-97+26);else if(j>=48&&j<=57)N(j-48+52);else if(j===43||j===45)N(62);else if(j===47||j===95)N(63);else{if(j===61)break;throw new SyntaxError(`Unexpected base64 character ${T[V]}`)}}const F=M;for(;w>0;)N(0);return m.wrap(L).slice(0,F)}const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function D({buffer:T},v=!0,w=!1){const M=w?S:k;let L="";const N=T.byteLength%3;let F=0;for(;F<T.byteLength-N;F+=3){const V=T[F+0],j=T[F+1],U=T[F+2];L+=M[V>>>2],L+=M[(V<<4|j>>>4)&63],L+=M[(j<<2|U>>>6)&63],L+=M[U&63]}if(N===1){const V=T[F+0];L+=M[V>>>2],L+=M[V<<4&63],v&&(L+="==")}else if(N===2){const V=T[F+0],j=T[F+1];L+=M[V>>>2],L+=M[(V<<4|j>>>4)&63],L+=M[j<<2&63],v&&(L+="=")}return L}}),define(Re[189],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$je=void 0,e.$je=Symbol("MicrotaskDelay")}),define(Re[17],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hg=s,e.$ig=h,e.$jg=R,e.$kg=A,e.$lg=O,e.$mg=C,e.$ng=m,e.$og=c,e.$pg=I,e.$qg=E,e.$rg=g,e.$sg=P,e.$tg=b,e.$ug=$,e.$vg=p,e.$wg=u,e.$xg=i,e.$yg=o,e.$zg=t;function s(n){return typeof n=="string"}function h(n){return Array.isArray(n)&&n.every(r=>s(r))}function R(n){return typeof n=="object"&&n!==null&&!Array.isArray(n)&&!(n instanceof RegExp)&&!(n instanceof Date)}function A(n){const r=Object.getPrototypeOf(Uint8Array);return typeof n=="object"&&n instanceof r}function O(n){return typeof n=="number"&&!isNaN(n)}function C(n){return!!n&&typeof n[Symbol.iterator]=="function"}function m(n){return n===!0||n===!1}function c(n){return typeof n>"u"}function I(n){return!E(n)}function E(n){return c(n)||n===null}function g(n,r){if(!n)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}function P(n){if(E(n))throw new Error("Assertion Failed: argument is undefined or null");return n}function b(...n){const r=[];for(let d=0;d<n.length;d++){const l=n[d];if(E(l))throw new Error(`Assertion Failed: argument at index ${d} is undefined or null`);r.push(l)}return r}const a=Object.prototype.hasOwnProperty;function $(n){if(!R(n))return!1;for(const r in n)if(a.call(n,r))return!1;return!0}function p(n){return typeof n=="function"}function u(...n){return n.length>0&&n.every(p)}function i(n,r){const d=Math.min(n.length,r.length);for(let l=0;l<d;l++)o(n[l],r[l])}function o(n,r){if(s(r)){if(typeof n!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(p(r)){try{if(n instanceof r)return}catch{}if(!E(n)&&n.constructor===r||r.length===1&&r.call(void 0,n)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function t(n){return n}}),define(Re[106],Ce([1,0,17]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=R,e.$4j=A;const h=Object.create(null);function R(O,C){if((0,s.$hg)(C)){const m=h[C];if(m===void 0)throw new Error(`${O} references an unknown codicon: ${C}`);C=m}return h[O]=C,{id:O}}function A(){return h}}),define(Re[190],Ce([1,0,106]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=void 0,e.$5j={add:(0,s.$3j)("add",6e4),plus:(0,s.$3j)("plus",6e4),gistNew:(0,s.$3j)("gist-new",6e4),repoCreate:(0,s.$3j)("repo-create",6e4),lightbulb:(0,s.$3j)("lightbulb",60001),lightBulb:(0,s.$3j)("light-bulb",60001),repo:(0,s.$3j)("repo",60002),repoDelete:(0,s.$3j)("repo-delete",60002),gistFork:(0,s.$3j)("gist-fork",60003),repoForked:(0,s.$3j)("repo-forked",60003),gitPullRequest:(0,s.$3j)("git-pull-request",60004),gitPullRequestAbandoned:(0,s.$3j)("git-pull-request-abandoned",60004),recordKeys:(0,s.$3j)("record-keys",60005),keyboard:(0,s.$3j)("keyboard",60005),tag:(0,s.$3j)("tag",60006),gitPullRequestLabel:(0,s.$3j)("git-pull-request-label",60006),tagAdd:(0,s.$3j)("tag-add",60006),tagRemove:(0,s.$3j)("tag-remove",60006),person:(0,s.$3j)("person",60007),personFollow:(0,s.$3j)("person-follow",60007),personOutline:(0,s.$3j)("person-outline",60007),personFilled:(0,s.$3j)("person-filled",60007),gitBranch:(0,s.$3j)("git-branch",60008),gitBranchCreate:(0,s.$3j)("git-branch-create",60008),gitBranchDelete:(0,s.$3j)("git-branch-delete",60008),sourceControl:(0,s.$3j)("source-control",60008),mirror:(0,s.$3j)("mirror",60009),mirrorPublic:(0,s.$3j)("mirror-public",60009),star:(0,s.$3j)("star",60010),starAdd:(0,s.$3j)("star-add",60010),starDelete:(0,s.$3j)("star-delete",60010),starEmpty:(0,s.$3j)("star-empty",60010),comment:(0,s.$3j)("comment",60011),commentAdd:(0,s.$3j)("comment-add",60011),alert:(0,s.$3j)("alert",60012),warning:(0,s.$3j)("warning",60012),search:(0,s.$3j)("search",60013),searchSave:(0,s.$3j)("search-save",60013),logOut:(0,s.$3j)("log-out",60014),signOut:(0,s.$3j)("sign-out",60014),logIn:(0,s.$3j)("log-in",60015),signIn:(0,s.$3j)("sign-in",60015),eye:(0,s.$3j)("eye",60016),eyeUnwatch:(0,s.$3j)("eye-unwatch",60016),eyeWatch:(0,s.$3j)("eye-watch",60016),circleFilled:(0,s.$3j)("circle-filled",60017),primitiveDot:(0,s.$3j)("primitive-dot",60017),closeDirty:(0,s.$3j)("close-dirty",60017),debugBreakpoint:(0,s.$3j)("debug-breakpoint",60017),debugBreakpointDisabled:(0,s.$3j)("debug-breakpoint-disabled",60017),debugHint:(0,s.$3j)("debug-hint",60017),terminalDecorationSuccess:(0,s.$3j)("terminal-decoration-success",60017),primitiveSquare:(0,s.$3j)("primitive-square",60018),edit:(0,s.$3j)("edit",60019),pencil:(0,s.$3j)("pencil",60019),info:(0,s.$3j)("info",60020),issueOpened:(0,s.$3j)("issue-opened",60020),gistPrivate:(0,s.$3j)("gist-private",60021),gitForkPrivate:(0,s.$3j)("git-fork-private",60021),lock:(0,s.$3j)("lock",60021),mirrorPrivate:(0,s.$3j)("mirror-private",60021),close:(0,s.$3j)("close",60022),removeClose:(0,s.$3j)("remove-close",60022),x:(0,s.$3j)("x",60022),repoSync:(0,s.$3j)("repo-sync",60023),sync:(0,s.$3j)("sync",60023),clone:(0,s.$3j)("clone",60024),desktopDownload:(0,s.$3j)("desktop-download",60024),beaker:(0,s.$3j)("beaker",60025),microscope:(0,s.$3j)("microscope",60025),vm:(0,s.$3j)("vm",60026),deviceDesktop:(0,s.$3j)("device-desktop",60026),file:(0,s.$3j)("file",60027),fileText:(0,s.$3j)("file-text",60027),more:(0,s.$3j)("more",60028),ellipsis:(0,s.$3j)("ellipsis",60028),kebabHorizontal:(0,s.$3j)("kebab-horizontal",60028),mailReply:(0,s.$3j)("mail-reply",60029),reply:(0,s.$3j)("reply",60029),organization:(0,s.$3j)("organization",60030),organizationFilled:(0,s.$3j)("organization-filled",60030),organizationOutline:(0,s.$3j)("organization-outline",60030),newFile:(0,s.$3j)("new-file",60031),fileAdd:(0,s.$3j)("file-add",60031),newFolder:(0,s.$3j)("new-folder",60032),fileDirectoryCreate:(0,s.$3j)("file-directory-create",60032),trash:(0,s.$3j)("trash",60033),trashcan:(0,s.$3j)("trashcan",60033),history:(0,s.$3j)("history",60034),clock:(0,s.$3j)("clock",60034),folder:(0,s.$3j)("folder",60035),fileDirectory:(0,s.$3j)("file-directory",60035),symbolFolder:(0,s.$3j)("symbol-folder",60035),logoGithub:(0,s.$3j)("logo-github",60036),markGithub:(0,s.$3j)("mark-github",60036),github:(0,s.$3j)("github",60036),terminal:(0,s.$3j)("terminal",60037),console:(0,s.$3j)("console",60037),repl:(0,s.$3j)("repl",60037),zap:(0,s.$3j)("zap",60038),symbolEvent:(0,s.$3j)("symbol-event",60038),error:(0,s.$3j)("error",60039),stop:(0,s.$3j)("stop",60039),variable:(0,s.$3j)("variable",60040),symbolVariable:(0,s.$3j)("symbol-variable",60040),array:(0,s.$3j)("array",60042),symbolArray:(0,s.$3j)("symbol-array",60042),symbolModule:(0,s.$3j)("symbol-module",60043),symbolPackage:(0,s.$3j)("symbol-package",60043),symbolNamespace:(0,s.$3j)("symbol-namespace",60043),symbolObject:(0,s.$3j)("symbol-object",60043),symbolMethod:(0,s.$3j)("symbol-method",60044),symbolFunction:(0,s.$3j)("symbol-function",60044),symbolConstructor:(0,s.$3j)("symbol-constructor",60044),symbolBoolean:(0,s.$3j)("symbol-boolean",60047),symbolNull:(0,s.$3j)("symbol-null",60047),symbolNumeric:(0,s.$3j)("symbol-numeric",60048),symbolNumber:(0,s.$3j)("symbol-number",60048),symbolStructure:(0,s.$3j)("symbol-structure",60049),symbolStruct:(0,s.$3j)("symbol-struct",60049),symbolParameter:(0,s.$3j)("symbol-parameter",60050),symbolTypeParameter:(0,s.$3j)("symbol-type-parameter",60050),symbolKey:(0,s.$3j)("symbol-key",60051),symbolText:(0,s.$3j)("symbol-text",60051),symbolReference:(0,s.$3j)("symbol-reference",60052),goToFile:(0,s.$3j)("go-to-file",60052),symbolEnum:(0,s.$3j)("symbol-enum",60053),symbolValue:(0,s.$3j)("symbol-value",60053),symbolRuler:(0,s.$3j)("symbol-ruler",60054),symbolUnit:(0,s.$3j)("symbol-unit",60054),activateBreakpoints:(0,s.$3j)("activate-breakpoints",60055),archive:(0,s.$3j)("archive",60056),arrowBoth:(0,s.$3j)("arrow-both",60057),arrowDown:(0,s.$3j)("arrow-down",60058),arrowLeft:(0,s.$3j)("arrow-left",60059),arrowRight:(0,s.$3j)("arrow-right",60060),arrowSmallDown:(0,s.$3j)("arrow-small-down",60061),arrowSmallLeft:(0,s.$3j)("arrow-small-left",60062),arrowSmallRight:(0,s.$3j)("arrow-small-right",60063),arrowSmallUp:(0,s.$3j)("arrow-small-up",60064),arrowUp:(0,s.$3j)("arrow-up",60065),bell:(0,s.$3j)("bell",60066),bold:(0,s.$3j)("bold",60067),book:(0,s.$3j)("book",60068),bookmark:(0,s.$3j)("bookmark",60069),debugBreakpointConditionalUnverified:(0,s.$3j)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,s.$3j)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,s.$3j)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,s.$3j)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,s.$3j)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,s.$3j)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,s.$3j)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,s.$3j)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,s.$3j)("debug-breakpoint-log-disabled",60075),briefcase:(0,s.$3j)("briefcase",60076),broadcast:(0,s.$3j)("broadcast",60077),browser:(0,s.$3j)("browser",60078),bug:(0,s.$3j)("bug",60079),calendar:(0,s.$3j)("calendar",60080),caseSensitive:(0,s.$3j)("case-sensitive",60081),check:(0,s.$3j)("check",60082),checklist:(0,s.$3j)("checklist",60083),chevronDown:(0,s.$3j)("chevron-down",60084),chevronLeft:(0,s.$3j)("chevron-left",60085),chevronRight:(0,s.$3j)("chevron-right",60086),chevronUp:(0,s.$3j)("chevron-up",60087),chromeClose:(0,s.$3j)("chrome-close",60088),chromeMaximize:(0,s.$3j)("chrome-maximize",60089),chromeMinimize:(0,s.$3j)("chrome-minimize",60090),chromeRestore:(0,s.$3j)("chrome-restore",60091),circleOutline:(0,s.$3j)("circle-outline",60092),circle:(0,s.$3j)("circle",60092),debugBreakpointUnverified:(0,s.$3j)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,s.$3j)("terminal-decoration-incomplete",60092),circleSlash:(0,s.$3j)("circle-slash",60093),circuitBoard:(0,s.$3j)("circuit-board",60094),clearAll:(0,s.$3j)("clear-all",60095),clippy:(0,s.$3j)("clippy",60096),closeAll:(0,s.$3j)("close-all",60097),cloudDownload:(0,s.$3j)("cloud-download",60098),cloudUpload:(0,s.$3j)("cloud-upload",60099),code:(0,s.$3j)("code",60100),collapseAll:(0,s.$3j)("collapse-all",60101),colorMode:(0,s.$3j)("color-mode",60102),commentDiscussion:(0,s.$3j)("comment-discussion",60103),creditCard:(0,s.$3j)("credit-card",60105),dash:(0,s.$3j)("dash",60108),dashboard:(0,s.$3j)("dashboard",60109),database:(0,s.$3j)("database",60110),debugContinue:(0,s.$3j)("debug-continue",60111),debugDisconnect:(0,s.$3j)("debug-disconnect",60112),debugPause:(0,s.$3j)("debug-pause",60113),debugRestart:(0,s.$3j)("debug-restart",60114),debugStart:(0,s.$3j)("debug-start",60115),debugStepInto:(0,s.$3j)("debug-step-into",60116),debugStepOut:(0,s.$3j)("debug-step-out",60117),debugStepOver:(0,s.$3j)("debug-step-over",60118),debugStop:(0,s.$3j)("debug-stop",60119),debug:(0,s.$3j)("debug",60120),deviceCameraVideo:(0,s.$3j)("device-camera-video",60121),deviceCamera:(0,s.$3j)("device-camera",60122),deviceMobile:(0,s.$3j)("device-mobile",60123),diffAdded:(0,s.$3j)("diff-added",60124),diffIgnored:(0,s.$3j)("diff-ignored",60125),diffModified:(0,s.$3j)("diff-modified",60126),diffRemoved:(0,s.$3j)("diff-removed",60127),diffRenamed:(0,s.$3j)("diff-renamed",60128),diff:(0,s.$3j)("diff",60129),diffSidebyside:(0,s.$3j)("diff-sidebyside",60129),discard:(0,s.$3j)("discard",60130),editorLayout:(0,s.$3j)("editor-layout",60131),emptyWindow:(0,s.$3j)("empty-window",60132),exclude:(0,s.$3j)("exclude",60133),extensions:(0,s.$3j)("extensions",60134),eyeClosed:(0,s.$3j)("eye-closed",60135),fileBinary:(0,s.$3j)("file-binary",60136),fileCode:(0,s.$3j)("file-code",60137),fileMedia:(0,s.$3j)("file-media",60138),filePdf:(0,s.$3j)("file-pdf",60139),fileSubmodule:(0,s.$3j)("file-submodule",60140),fileSymlinkDirectory:(0,s.$3j)("file-symlink-directory",60141),fileSymlinkFile:(0,s.$3j)("file-symlink-file",60142),fileZip:(0,s.$3j)("file-zip",60143),files:(0,s.$3j)("files",60144),filter:(0,s.$3j)("filter",60145),flame:(0,s.$3j)("flame",60146),foldDown:(0,s.$3j)("fold-down",60147),foldUp:(0,s.$3j)("fold-up",60148),fold:(0,s.$3j)("fold",60149),folderActive:(0,s.$3j)("folder-active",60150),folderOpened:(0,s.$3j)("folder-opened",60151),gear:(0,s.$3j)("gear",60152),gift:(0,s.$3j)("gift",60153),gistSecret:(0,s.$3j)("gist-secret",60154),gist:(0,s.$3j)("gist",60155),gitCommit:(0,s.$3j)("git-commit",60156),gitCompare:(0,s.$3j)("git-compare",60157),compareChanges:(0,s.$3j)("compare-changes",60157),gitMerge:(0,s.$3j)("git-merge",60158),githubAction:(0,s.$3j)("github-action",60159),githubAlt:(0,s.$3j)("github-alt",60160),globe:(0,s.$3j)("globe",60161),grabber:(0,s.$3j)("grabber",60162),graph:(0,s.$3j)("graph",60163),gripper:(0,s.$3j)("gripper",60164),heart:(0,s.$3j)("heart",60165),home:(0,s.$3j)("home",60166),horizontalRule:(0,s.$3j)("horizontal-rule",60167),hubot:(0,s.$3j)("hubot",60168),inbox:(0,s.$3j)("inbox",60169),issueReopened:(0,s.$3j)("issue-reopened",60171),issues:(0,s.$3j)("issues",60172),italic:(0,s.$3j)("italic",60173),jersey:(0,s.$3j)("jersey",60174),json:(0,s.$3j)("json",60175),kebabVertical:(0,s.$3j)("kebab-vertical",60176),key:(0,s.$3j)("key",60177),law:(0,s.$3j)("law",60178),lightbulbAutofix:(0,s.$3j)("lightbulb-autofix",60179),linkExternal:(0,s.$3j)("link-external",60180),link:(0,s.$3j)("link",60181),listOrdered:(0,s.$3j)("list-ordered",60182),listUnordered:(0,s.$3j)("list-unordered",60183),liveShare:(0,s.$3j)("live-share",60184),loading:(0,s.$3j)("loading",60185),location:(0,s.$3j)("location",60186),mailRead:(0,s.$3j)("mail-read",60187),mail:(0,s.$3j)("mail",60188),markdown:(0,s.$3j)("markdown",60189),megaphone:(0,s.$3j)("megaphone",60190),mention:(0,s.$3j)("mention",60191),milestone:(0,s.$3j)("milestone",60192),gitPullRequestMilestone:(0,s.$3j)("git-pull-request-milestone",60192),mortarBoard:(0,s.$3j)("mortar-board",60193),move:(0,s.$3j)("move",60194),multipleWindows:(0,s.$3j)("multiple-windows",60195),mute:(0,s.$3j)("mute",60196),noNewline:(0,s.$3j)("no-newline",60197),note:(0,s.$3j)("note",60198),octoface:(0,s.$3j)("octoface",60199),openPreview:(0,s.$3j)("open-preview",60200),package:(0,s.$3j)("package",60201),paintcan:(0,s.$3j)("paintcan",60202),pin:(0,s.$3j)("pin",60203),play:(0,s.$3j)("play",60204),run:(0,s.$3j)("run",60204),plug:(0,s.$3j)("plug",60205),preserveCase:(0,s.$3j)("preserve-case",60206),preview:(0,s.$3j)("preview",60207),project:(0,s.$3j)("project",60208),pulse:(0,s.$3j)("pulse",60209),question:(0,s.$3j)("question",60210),quote:(0,s.$3j)("quote",60211),radioTower:(0,s.$3j)("radio-tower",60212),reactions:(0,s.$3j)("reactions",60213),references:(0,s.$3j)("references",60214),refresh:(0,s.$3j)("refresh",60215),regex:(0,s.$3j)("regex",60216),remoteExplorer:(0,s.$3j)("remote-explorer",60217),remote:(0,s.$3j)("remote",60218),remove:(0,s.$3j)("remove",60219),replaceAll:(0,s.$3j)("replace-all",60220),replace:(0,s.$3j)("replace",60221),repoClone:(0,s.$3j)("repo-clone",60222),repoForcePush:(0,s.$3j)("repo-force-push",60223),repoPull:(0,s.$3j)("repo-pull",60224),repoPush:(0,s.$3j)("repo-push",60225),report:(0,s.$3j)("report",60226),requestChanges:(0,s.$3j)("request-changes",60227),rocket:(0,s.$3j)("rocket",60228),rootFolderOpened:(0,s.$3j)("root-folder-opened",60229),rootFolder:(0,s.$3j)("root-folder",60230),rss:(0,s.$3j)("rss",60231),ruby:(0,s.$3j)("ruby",60232),saveAll:(0,s.$3j)("save-all",60233),saveAs:(0,s.$3j)("save-as",60234),save:(0,s.$3j)("save",60235),screenFull:(0,s.$3j)("screen-full",60236),screenNormal:(0,s.$3j)("screen-normal",60237),searchStop:(0,s.$3j)("search-stop",60238),server:(0,s.$3j)("server",60240),settingsGear:(0,s.$3j)("settings-gear",60241),settings:(0,s.$3j)("settings",60242),shield:(0,s.$3j)("shield",60243),smiley:(0,s.$3j)("smiley",60244),sortPrecedence:(0,s.$3j)("sort-precedence",60245),splitHorizontal:(0,s.$3j)("split-horizontal",60246),splitVertical:(0,s.$3j)("split-vertical",60247),squirrel:(0,s.$3j)("squirrel",60248),starFull:(0,s.$3j)("star-full",60249),starHalf:(0,s.$3j)("star-half",60250),symbolClass:(0,s.$3j)("symbol-class",60251),symbolColor:(0,s.$3j)("symbol-color",60252),symbolConstant:(0,s.$3j)("symbol-constant",60253),symbolEnumMember:(0,s.$3j)("symbol-enum-member",60254),symbolField:(0,s.$3j)("symbol-field",60255),symbolFile:(0,s.$3j)("symbol-file",60256),symbolInterface:(0,s.$3j)("symbol-interface",60257),symbolKeyword:(0,s.$3j)("symbol-keyword",60258),symbolMisc:(0,s.$3j)("symbol-misc",60259),symbolOperator:(0,s.$3j)("symbol-operator",60260),symbolProperty:(0,s.$3j)("symbol-property",60261),wrench:(0,s.$3j)("wrench",60261),wrenchSubaction:(0,s.$3j)("wrench-subaction",60261),symbolSnippet:(0,s.$3j)("symbol-snippet",60262),tasklist:(0,s.$3j)("tasklist",60263),telescope:(0,s.$3j)("telescope",60264),textSize:(0,s.$3j)("text-size",60265),threeBars:(0,s.$3j)("three-bars",60266),thumbsdown:(0,s.$3j)("thumbsdown",60267),thumbsup:(0,s.$3j)("thumbsup",60268),tools:(0,s.$3j)("tools",60269),triangleDown:(0,s.$3j)("triangle-down",60270),triangleLeft:(0,s.$3j)("triangle-left",60271),triangleRight:(0,s.$3j)("triangle-right",60272),triangleUp:(0,s.$3j)("triangle-up",60273),twitter:(0,s.$3j)("twitter",60274),unfold:(0,s.$3j)("unfold",60275),unlock:(0,s.$3j)("unlock",60276),unmute:(0,s.$3j)("unmute",60277),unverified:(0,s.$3j)("unverified",60278),verified:(0,s.$3j)("verified",60279),versions:(0,s.$3j)("versions",60280),vmActive:(0,s.$3j)("vm-active",60281),vmOutline:(0,s.$3j)("vm-outline",60282),vmRunning:(0,s.$3j)("vm-running",60283),watch:(0,s.$3j)("watch",60284),whitespace:(0,s.$3j)("whitespace",60285),wholeWord:(0,s.$3j)("whole-word",60286),window:(0,s.$3j)("window",60287),wordWrap:(0,s.$3j)("word-wrap",60288),zoomIn:(0,s.$3j)("zoom-in",60289),zoomOut:(0,s.$3j)("zoom-out",60290),listFilter:(0,s.$3j)("list-filter",60291),listFlat:(0,s.$3j)("list-flat",60292),listSelection:(0,s.$3j)("list-selection",60293),selection:(0,s.$3j)("selection",60293),listTree:(0,s.$3j)("list-tree",60294),debugBreakpointFunctionUnverified:(0,s.$3j)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,s.$3j)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,s.$3j)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,s.$3j)("debug-stackframe-active",60297),circleSmallFilled:(0,s.$3j)("circle-small-filled",60298),debugStackframeDot:(0,s.$3j)("debug-stackframe-dot",60298),terminalDecorationMark:(0,s.$3j)("terminal-decoration-mark",60298),debugStackframe:(0,s.$3j)("debug-stackframe",60299),debugStackframeFocused:(0,s.$3j)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,s.$3j)("debug-breakpoint-unsupported",60300),symbolString:(0,s.$3j)("symbol-string",60301),debugReverseContinue:(0,s.$3j)("debug-reverse-continue",60302),debugStepBack:(0,s.$3j)("debug-step-back",60303),debugRestartFrame:(0,s.$3j)("debug-restart-frame",60304),debugAlt:(0,s.$3j)("debug-alt",60305),callIncoming:(0,s.$3j)("call-incoming",60306),callOutgoing:(0,s.$3j)("call-outgoing",60307),menu:(0,s.$3j)("menu",60308),expandAll:(0,s.$3j)("expand-all",60309),feedback:(0,s.$3j)("feedback",60310),gitPullRequestReviewer:(0,s.$3j)("git-pull-request-reviewer",60310),groupByRefType:(0,s.$3j)("group-by-ref-type",60311),ungroupByRefType:(0,s.$3j)("ungroup-by-ref-type",60312),account:(0,s.$3j)("account",60313),gitPullRequestAssignee:(0,s.$3j)("git-pull-request-assignee",60313),bellDot:(0,s.$3j)("bell-dot",60314),debugConsole:(0,s.$3j)("debug-console",60315),library:(0,s.$3j)("library",60316),output:(0,s.$3j)("output",60317),runAll:(0,s.$3j)("run-all",60318),syncIgnored:(0,s.$3j)("sync-ignored",60319),pinned:(0,s.$3j)("pinned",60320),githubInverted:(0,s.$3j)("github-inverted",60321),serverProcess:(0,s.$3j)("server-process",60322),serverEnvironment:(0,s.$3j)("server-environment",60323),pass:(0,s.$3j)("pass",60324),issueClosed:(0,s.$3j)("issue-closed",60324),stopCircle:(0,s.$3j)("stop-circle",60325),playCircle:(0,s.$3j)("play-circle",60326),record:(0,s.$3j)("record",60327),debugAltSmall:(0,s.$3j)("debug-alt-small",60328),vmConnect:(0,s.$3j)("vm-connect",60329),cloud:(0,s.$3j)("cloud",60330),merge:(0,s.$3j)("merge",60331),export:(0,s.$3j)("export",60332),graphLeft:(0,s.$3j)("graph-left",60333),magnet:(0,s.$3j)("magnet",60334),notebook:(0,s.$3j)("notebook",60335),redo:(0,s.$3j)("redo",60336),checkAll:(0,s.$3j)("check-all",60337),pinnedDirty:(0,s.$3j)("pinned-dirty",60338),passFilled:(0,s.$3j)("pass-filled",60339),circleLargeFilled:(0,s.$3j)("circle-large-filled",60340),circleLarge:(0,s.$3j)("circle-large",60341),circleLargeOutline:(0,s.$3j)("circle-large-outline",60341),combine:(0,s.$3j)("combine",60342),gather:(0,s.$3j)("gather",60342),table:(0,s.$3j)("table",60343),variableGroup:(0,s.$3j)("variable-group",60344),typeHierarchy:(0,s.$3j)("type-hierarchy",60345),typeHierarchySub:(0,s.$3j)("type-hierarchy-sub",60346),typeHierarchySuper:(0,s.$3j)("type-hierarchy-super",60347),gitPullRequestCreate:(0,s.$3j)("git-pull-request-create",60348),runAbove:(0,s.$3j)("run-above",60349),runBelow:(0,s.$3j)("run-below",60350),notebookTemplate:(0,s.$3j)("notebook-template",60351),debugRerun:(0,s.$3j)("debug-rerun",60352),workspaceTrusted:(0,s.$3j)("workspace-trusted",60353),workspaceUntrusted:(0,s.$3j)("workspace-untrusted",60354),workspaceUnknown:(0,s.$3j)("workspace-unknown",60355),terminalCmd:(0,s.$3j)("terminal-cmd",60356),terminalDebian:(0,s.$3j)("terminal-debian",60357),terminalLinux:(0,s.$3j)("terminal-linux",60358),terminalPowershell:(0,s.$3j)("terminal-powershell",60359),terminalTmux:(0,s.$3j)("terminal-tmux",60360),terminalUbuntu:(0,s.$3j)("terminal-ubuntu",60361),terminalBash:(0,s.$3j)("terminal-bash",60362),arrowSwap:(0,s.$3j)("arrow-swap",60363),copy:(0,s.$3j)("copy",60364),personAdd:(0,s.$3j)("person-add",60365),filterFilled:(0,s.$3j)("filter-filled",60366),wand:(0,s.$3j)("wand",60367),debugLineByLine:(0,s.$3j)("debug-line-by-line",60368),inspect:(0,s.$3j)("inspect",60369),layers:(0,s.$3j)("layers",60370),layersDot:(0,s.$3j)("layers-dot",60371),layersActive:(0,s.$3j)("layers-active",60372),compass:(0,s.$3j)("compass",60373),compassDot:(0,s.$3j)("compass-dot",60374),compassActive:(0,s.$3j)("compass-active",60375),azure:(0,s.$3j)("azure",60376),issueDraft:(0,s.$3j)("issue-draft",60377),gitPullRequestClosed:(0,s.$3j)("git-pull-request-closed",60378),gitPullRequestDraft:(0,s.$3j)("git-pull-request-draft",60379),debugAll:(0,s.$3j)("debug-all",60380),debugCoverage:(0,s.$3j)("debug-coverage",60381),runErrors:(0,s.$3j)("run-errors",60382),folderLibrary:(0,s.$3j)("folder-library",60383),debugContinueSmall:(0,s.$3j)("debug-continue-small",60384),beakerStop:(0,s.$3j)("beaker-stop",60385),graphLine:(0,s.$3j)("graph-line",60386),graphScatter:(0,s.$3j)("graph-scatter",60387),pieChart:(0,s.$3j)("pie-chart",60388),bracket:(0,s.$3j)("bracket",60175),bracketDot:(0,s.$3j)("bracket-dot",60389),bracketError:(0,s.$3j)("bracket-error",60390),lockSmall:(0,s.$3j)("lock-small",60391),azureDevops:(0,s.$3j)("azure-devops",60392),verifiedFilled:(0,s.$3j)("verified-filled",60393),newline:(0,s.$3j)("newline",60394),layout:(0,s.$3j)("layout",60395),layoutActivitybarLeft:(0,s.$3j)("layout-activitybar-left",60396),layoutActivitybarRight:(0,s.$3j)("layout-activitybar-right",60397),layoutPanelLeft:(0,s.$3j)("layout-panel-left",60398),layoutPanelCenter:(0,s.$3j)("layout-panel-center",60399),layoutPanelJustify:(0,s.$3j)("layout-panel-justify",60400),layoutPanelRight:(0,s.$3j)("layout-panel-right",60401),layoutPanel:(0,s.$3j)("layout-panel",60402),layoutSidebarLeft:(0,s.$3j)("layout-sidebar-left",60403),layoutSidebarRight:(0,s.$3j)("layout-sidebar-right",60404),layoutStatusbar:(0,s.$3j)("layout-statusbar",60405),layoutMenubar:(0,s.$3j)("layout-menubar",60406),layoutCentered:(0,s.$3j)("layout-centered",60407),target:(0,s.$3j)("target",60408),indent:(0,s.$3j)("indent",60409),recordSmall:(0,s.$3j)("record-small",60410),errorSmall:(0,s.$3j)("error-small",60411),terminalDecorationError:(0,s.$3j)("terminal-decoration-error",60411),arrowCircleDown:(0,s.$3j)("arrow-circle-down",60412),arrowCircleLeft:(0,s.$3j)("arrow-circle-left",60413),arrowCircleRight:(0,s.$3j)("arrow-circle-right",60414),arrowCircleUp:(0,s.$3j)("arrow-circle-up",60415),layoutSidebarRightOff:(0,s.$3j)("layout-sidebar-right-off",60416),layoutPanelOff:(0,s.$3j)("layout-panel-off",60417),layoutSidebarLeftOff:(0,s.$3j)("layout-sidebar-left-off",60418),blank:(0,s.$3j)("blank",60419),heartFilled:(0,s.$3j)("heart-filled",60420),map:(0,s.$3j)("map",60421),mapHorizontal:(0,s.$3j)("map-horizontal",60421),foldHorizontal:(0,s.$3j)("fold-horizontal",60421),mapFilled:(0,s.$3j)("map-filled",60422),mapHorizontalFilled:(0,s.$3j)("map-horizontal-filled",60422),foldHorizontalFilled:(0,s.$3j)("fold-horizontal-filled",60422),circleSmall:(0,s.$3j)("circle-small",60423),bellSlash:(0,s.$3j)("bell-slash",60424),bellSlashDot:(0,s.$3j)("bell-slash-dot",60425),commentUnresolved:(0,s.$3j)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,s.$3j)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,s.$3j)("git-pull-request-new-changes",60428),searchFuzzy:(0,s.$3j)("search-fuzzy",60429),commentDraft:(0,s.$3j)("comment-draft",60430),send:(0,s.$3j)("send",60431),sparkle:(0,s.$3j)("sparkle",60432),insert:(0,s.$3j)("insert",60433),mic:(0,s.$3j)("mic",60434),thumbsdownFilled:(0,s.$3j)("thumbsdown-filled",60435),thumbsupFilled:(0,s.$3j)("thumbsup-filled",60436),coffee:(0,s.$3j)("coffee",60437),snake:(0,s.$3j)("snake",60438),game:(0,s.$3j)("game",60439),vr:(0,s.$3j)("vr",60440),chip:(0,s.$3j)("chip",60441),piano:(0,s.$3j)("piano",60442),music:(0,s.$3j)("music",60443),micFilled:(0,s.$3j)("mic-filled",60444),repoFetch:(0,s.$3j)("repo-fetch",60445),copilot:(0,s.$3j)("copilot",60446),lightbulbSparkle:(0,s.$3j)("lightbulb-sparkle",60447),robot:(0,s.$3j)("robot",60448),sparkleFilled:(0,s.$3j)("sparkle-filled",60449),diffSingle:(0,s.$3j)("diff-single",60450),diffMultiple:(0,s.$3j)("diff-multiple",60451),surroundWith:(0,s.$3j)("surround-with",60452),share:(0,s.$3j)("share",60453),gitStash:(0,s.$3j)("git-stash",60454),gitStashApply:(0,s.$3j)("git-stash-apply",60455),gitStashPop:(0,s.$3j)("git-stash-pop",60456),vscode:(0,s.$3j)("vscode",60457),vscodeInsiders:(0,s.$3j)("vscode-insiders",60458),codeOss:(0,s.$3j)("code-oss",60459),runCoverage:(0,s.$3j)("run-coverage",60460),runAllCoverage:(0,s.$3j)("run-all-coverage",60461),coverage:(0,s.$3j)("coverage",60462),githubProject:(0,s.$3j)("github-project",60463),mapVertical:(0,s.$3j)("map-vertical",60464),foldVertical:(0,s.$3j)("fold-vertical",60464),mapVerticalFilled:(0,s.$3j)("map-vertical-filled",60465),foldVerticalFilled:(0,s.$3j)("fold-vertical-filled",60465),goToSearch:(0,s.$3j)("go-to-search",60466),percentage:(0,s.$3j)("percentage",60467),sortPercentage:(0,s.$3j)("sort-percentage",60467),attach:(0,s.$3j)("attach",60468)}}),define(Re[84],Ce([1,0,106,190]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=e.$7j=void 0,e.$6j=R;function R(){return Object.values(e.$8j)}e.$7j={dialogError:(0,s.$3j)("dialog-error","error"),dialogWarning:(0,s.$3j)("dialog-warning","warning"),dialogInfo:(0,s.$3j)("dialog-info","info"),dialogClose:(0,s.$3j)("dialog-close","close"),treeItemExpanded:(0,s.$3j)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,s.$3j)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,s.$3j)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,s.$3j)("tree-filter-clear","close"),treeItemLoading:(0,s.$3j)("tree-item-loading","loading"),menuSelection:(0,s.$3j)("menu-selection","check"),menuSubmenu:(0,s.$3j)("menu-submenu","chevron-right"),menuBarMore:(0,s.$3j)("menubar-more","more"),scrollbarButtonLeft:(0,s.$3j)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,s.$3j)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,s.$3j)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,s.$3j)("scrollbar-button-down","triangle-down"),toolBarMore:(0,s.$3j)("toolbar-more","more"),quickInputBack:(0,s.$3j)("quick-input-back","arrow-left"),dropDownButton:(0,s.$3j)("drop-down-button",60084),symbolCustomColor:(0,s.$3j)("symbol-customcolor",60252),exportIcon:(0,s.$3j)("export",60332),workspaceUnspecified:(0,s.$3j)("workspace-unspecified",60355),newLine:(0,s.$3j)("newline",60394),thumbsDownFilled:(0,s.$3j)("thumbsdown-filled",60435),thumbsUpFilled:(0,s.$3j)("thumbsup-filled",60436),gitFetch:(0,s.$3j)("git-fetch",60445),lightbulbSparkleAutofix:(0,s.$3j)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,s.$3j)("debug-breakpoint-pending",60377)},e.$8j={...h.$5j,...e.$7j}}),define(Re[24],Ce([1,0,17]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$io=h,e.$jo=R,e.$ko=O,e.$lo=m,e.$mo=c,e.$no=I,e.$oo=E,e.$po=g,e.$qo=P,e.$ro=b,e.$so=a,e.$to=$,e.$uo=p;function h(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const i=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([o,t])=>{i[o]=t&&typeof t=="object"?h(t):t}),i}function R(u){if(!u||typeof u!="object")return u;const i=[u];for(;i.length>0;){const o=i.shift();Object.freeze(o);for(const t in o)if(A.call(o,t)){const n=o[t];typeof n=="object"&&!Object.isFrozen(n)&&!(0,s.$kg)(n)&&i.push(n)}}return u}const A=Object.prototype.hasOwnProperty;function O(u,i){return C(u,i,new Set)}function C(u,i,o){if((0,s.$qg)(u))return u;const t=i(u);if(typeof t<"u")return t;if(Array.isArray(u)){const n=[];for(const r of u)n.push(C(r,i,o));return n}if((0,s.$jg)(u)){if(o.has(u))throw new Error("Cannot clone recursive data-structure");o.add(u);const n={};for(const r in u)A.call(u,r)&&(n[r]=C(u[r],i,o));return o.delete(u),n}return u}function m(u,i,o=!0){return(0,s.$jg)(u)?((0,s.$jg)(i)&&Object.keys(i).forEach(t=>{t in u?o&&((0,s.$jg)(u[t])&&(0,s.$jg)(i[t])?m(u[t],i[t],o):u[t]=i[t]):u[t]=i[t]}),u):i}function c(u,i){if(u===i)return!0;if(u==null||i===null||i===void 0||typeof u!=typeof i||typeof u!="object"||Array.isArray(u)!==Array.isArray(i))return!1;let o,t;if(Array.isArray(u)){if(u.length!==i.length)return!1;for(o=0;o<u.length;o++)if(!c(u[o],i[o]))return!1}else{const n=[];for(t in u)n.push(t);n.sort();const r=[];for(t in i)r.push(t);if(r.sort(),!c(n,r))return!1;for(o=0;o<n.length;o++)if(!c(u[n[o]],i[n[o]]))return!1}return!0}function I(u){const i=new Set;return JSON.stringify(u,(o,t)=>{if((0,s.$jg)(t)||Array.isArray(t)){if(i.has(t))return"[Circular]";i.add(t)}return typeof t=="bigint"?`[BigInt ${t.toString()}]`:t})}function E(u,i){const o=Object.create(null);return!u||!i||Object.keys(i).forEach(n=>{const r=u[n],d=i[n];c(r,d)||(o[n]=d)}),o}function g(u,i){const o=i.toLowerCase(),t=Object.keys(u).find(n=>n.toLowerCase()===o);return t?u[t]:u[i]}function P(u,i){const o=Object.create(null);for(const[t,n]of Object.entries(u))i(t,n)&&(o[t]=n);return o}function b(u){let i=[];for(;Object.prototype!==u;)i=i.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return i}function a(u){const i=[];for(const o of b(u))typeof u[o]=="function"&&i.push(o);return i}function $(u,i){const o=n=>function(){const r=Array.prototype.slice.call(arguments,0);return i(n,r)},t={};for(const n of u)t[n]=o(n);return t}function p(u,i){const o={};for(const[t,n]of Object.entries(u))o[t]=i(n,t);return o}}),define(Re[51],Ce([1,0,84]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$9j=R;var h;(function(O){function C(m){return m&&typeof m=="object"&&typeof m.id=="string"}O.isThemeColor=C})(h||(e.ThemeColor=h={}));function R(O){return{id:O}}var A;(function(O){O.iconNameSegment="[A-Za-z0-9]+",O.iconNameExpression="[A-Za-z0-9-]+",O.iconModifierExpression="~[A-Za-z]+",O.iconNameCharacter="[A-Za-z0-9~-]";const C=new RegExp(`^(${O.iconNameExpression})(${O.iconModifierExpression})?$`);function m(u){const i=C.exec(u.id);if(!i)return m(s.$8j.error);const[,o,t]=i,n=["codicon","codicon-"+o];return t&&n.push("codicon-modifier-"+t.substring(1)),n}O.asClassNameArray=m;function c(u){return m(u).join(" ")}O.asClassName=c;function I(u){return"."+m(u).join(".")}O.asCSSSelector=I;function E(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color>"u"||h.isThemeColor(u.color))}O.isThemeIcon=E;const g=new RegExp(`^\\$\\((${O.iconNameExpression}(?:${O.iconModifierExpression})?)\\)$`);function P(u){const i=g.exec(u);if(!i)return;const[,o]=i;return{id:o}}O.fromString=P;function b(u){return{id:u}}O.fromId=b;function a(u,i){let o=u.id;const t=o.lastIndexOf("~");return t!==-1&&(o=o.substring(0,t)),i&&(o=`${o}~${i}`),{id:o}}O.modify=a;function $(u){const i=u.id.lastIndexOf("~");if(i!==-1)return u.id.substring(i+1)}O.getModifier=$;function p(u,i){return u.id===i.id&&u.color?.id===i.color?.id}O.isEqual=p})(A||(e.ThemeIcon=A={}))}),define(Re[85],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$df=h,e.$ef=R;var s;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(s||(e.Constants=s={}));function h(A){return A<0?0:A>s.MAX_UINT_8?s.MAX_UINT_8:A|0}function R(A){return A<0?0:A>s.MAX_UINT_32?s.MAX_UINT_32:A|0}}),define(Re[13],Ce([1,0,187,26,50,85]),function(ge,e,s,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gg=e.$fg=e.$eg=e.GraphemeBreakType=e.$7f=e.$Yf=e.$Rf=e.$Qf=void 0,e.$ff=O,e.$gf=m,e.$hf=I,e.$if=E,e.$jf=g,e.$kf=P,e.$lf=b,e.$mf=a,e.$nf=$,e.$of=p,e.$pf=u,e.$qf=i,e.$rf=o,e.$sf=t,e.$tf=n,e.$uf=r,e.$vf=d,e.$wf=l,e.$xf=f,e.$yf=y,e.$zf=k,e.$Af=S,e.$Bf=D,e.$Cf=T,e.$Df=v,e.$Ef=w,e.$Ff=M,e.$Gf=L,e.$Hf=N,e.$If=F,e.$Jf=V,e.$Kf=j,e.$Lf=U,e.$Mf=z,e.$Nf=_,e.$Of=W,e.$Pf=B,e.$Sf=ie,e.$Tf=me,e.$Uf=ue,e.$Vf=X,e.$Wf=be,e.$Xf=we,e.$Zf=$e,e.$1f=pe,e.$2f=Ae,e.$3f=je,e.$4f=Ye,e.$5f=xe,e.$6f=We,e.$8f=Ne,e.$9f=H,e.$0f=G,e.$$f=Z,e.$_f=ee,e.$ag=le,e.$bg=ye,e.$cg=Te,e.$dg=ut;function O(re){return!re||typeof re!="string"?!0:re.trim().length===0}const C=/{(\d+)}/g;function m(re,...ce){return ce.length===0?re:re.replace(C,function(Se,de){const ke=parseInt(de,10);return isNaN(ke)||ke<0||ke>=ce.length?Se:ce[ke]})}const c=/{([^}]+)}/g;function I(re,ce){return Object.keys(ce).length===0?re:re.replace(c,(Se,de)=>ce[de]??Se)}function E(re){return re.replace(/[<>"'&]/g,ce=>{switch(ce){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ce})}function g(re){return re.replace(/[<>&]/g,function(ce){switch(ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ce}})}function P(re){return re.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function b(re,ce){let Se=0,de=re.indexOf(ce);for(;de!==-1;)Se++,de=re.indexOf(ce,de+ce.length);return Se}function a(re,ce,Se="\u2026"){return re.length<=ce?re:`${re.substr(0,ce)}${Se}`}function $(re,ce,Se="\u2026"){if(re.length<=ce)return re;const de=Math.ceil(ce/2)-Se.length/2,ke=Math.floor(ce/2)-Se.length/2;return`${re.substr(0,de)}${Se}${re.substr(re.length-ke)}`}function p(re,ce=" "){const Se=u(re,ce);return i(Se,ce)}function u(re,ce){if(!re||!ce)return re;const Se=ce.length;if(Se===0||re.length===0)return re;let de=0;for(;re.indexOf(ce,de)===de;)de=de+Se;return re.substring(de)}function i(re,ce){if(!re||!ce)return re;const Se=ce.length,de=re.length;if(Se===0||de===0)return re;let ke=de,ne=-1;for(;ne=re.lastIndexOf(ce,ke-1),!(ne===-1||ne+Se!==ke);){if(ne===0)return"";ke=ne}return re.substring(0,ke)}function o(re){return re.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function t(re){return re.replace(/\*/g,"")}function n(re,ce,Se={}){if(!re)throw new Error("Cannot create regex from empty string");ce||(re=P(re)),Se.wholeWord&&(/\B/.test(re.charAt(0))||(re="\\b"+re),/\B/.test(re.charAt(re.length-1))||(re=re+"\\b"));let de="";return Se.global&&(de+="g"),Se.matchCase||(de+="i"),Se.multiline&&(de+="m"),Se.unicode&&(de+="u"),new RegExp(re,de)}function r(re){return re.source==="^"||re.source==="^$"||re.source==="$"||re.source==="^\\s*$"?!1:!!(re.exec("")&&re.lastIndex===0)}function d(re){return re.split(/\r\n|\r|\n/)}function l(re){const ce=[],Se=re.split(/(\r\n|\r|\n)/);for(let de=0;de<Math.ceil(Se.length/2);de++)ce.push(Se[2*de]+(Se[2*de+1]??""));return ce}function f(re){for(let ce=0,Se=re.length;ce<Se;ce++){const de=re.charCodeAt(ce);if(de!==h.CharCode.Space&&de!==h.CharCode.Tab)return ce}return-1}function y(re,ce=0,Se=re.length){for(let de=ce;de<Se;de++){const ke=re.charCodeAt(de);if(ke!==h.CharCode.Space&&ke!==h.CharCode.Tab)return re.substring(ce,de)}return re.substring(ce,Se)}function k(re,ce=re.length-1){for(let Se=ce;Se>=0;Se--){const de=re.charCodeAt(Se);if(de!==h.CharCode.Space&&de!==h.CharCode.Tab)return Se}return-1}function S(re,ce,Se){const de=[];let ke=0;for(const ne of re.matchAll(ce)){if(de.push(re.slice(ke,ne.index)),ne.index===void 0)throw new Error("match.index should be defined");ke=ne.index+ne[0].length,de.push(Se(ne[0],...ne.slice(1),ne.index,re,ne.groups))}return de.push(re.slice(ke)),Promise.all(de).then(ne=>ne.join(""))}function D(re,ce){return re<ce?-1:re>ce?1:0}function T(re,ce,Se=0,de=re.length,ke=0,ne=ce.length){for(;Se<de&&ke<ne;Se++,ke++){const Ge=re.charCodeAt(Se),Je=ce.charCodeAt(ke);if(Ge<Je)return-1;if(Ge>Je)return 1}const J=de-Se,Pe=ne-ke;return J<Pe?-1:J>Pe?1:0}function v(re,ce){return w(re,ce,0,re.length,0,ce.length)}function w(re,ce,Se=0,de=re.length,ke=0,ne=ce.length){for(;Se<de&&ke<ne;Se++,ke++){let Ge=re.charCodeAt(Se),Je=ce.charCodeAt(ke);if(Ge===Je)continue;if(Ge>=128||Je>=128)return T(re.toLowerCase(),ce.toLowerCase(),Se,de,ke,ne);L(Ge)&&(Ge-=32),L(Je)&&(Je-=32);const st=Ge-Je;if(st!==0)return st}const J=de-Se,Pe=ne-ke;return J<Pe?-1:J>Pe?1:0}function M(re){return re>=h.CharCode.Digit0&&re<=h.CharCode.Digit9}function L(re){return re>=h.CharCode.a&&re<=h.CharCode.z}function N(re){return re>=h.CharCode.A&&re<=h.CharCode.Z}function F(re,ce){return re.length===ce.length&&w(re,ce)===0}function V(re,ce){const Se=ce.length;return ce.length>re.length?!1:w(re,ce,0,Se)===0}function j(re,ce){const Se=Math.min(re.length,ce.length);let de;for(de=0;de<Se;de++)if(re.charCodeAt(de)!==ce.charCodeAt(de))return de;return Se}function U(re,ce){const Se=Math.min(re.length,ce.length);let de;const ke=re.length-1,ne=ce.length-1;for(de=0;de<Se;de++)if(re.charCodeAt(ke-de)!==ce.charCodeAt(ne-de))return de;return Se}function z(re){return 55296<=re&&re<=56319}function _(re){return 56320<=re&&re<=57343}function W(re,ce){return(re-55296<<10)+(ce-56320)+65536}function B(re,ce,Se){const de=re.charCodeAt(Se);if(z(de)&&Se+1<ce){const ke=re.charCodeAt(Se+1);if(_(ke))return W(de,ke)}return de}function Y(re,ce){const Se=re.charCodeAt(ce-1);if(_(Se)&&ce>1){const de=re.charCodeAt(ce-2);if(z(de))return W(de,Se)}return Se}class x{get offset(){return this.e}constructor(ce,Se=0){this.c=ce,this.d=ce.length,this.e=Se}setOffset(ce){this.e=ce}prevCodePoint(){const ce=Y(this.c,this.e);return this.e-=ce>=A.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ce}nextCodePoint(){const ce=B(this.c,this.d,this.e);return this.e+=ce>=A.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ce}eol(){return this.e>=this.d}}e.$Qf=x;class oe{get offset(){return this.c.offset}constructor(ce,Se=0){this.c=new x(ce,Se)}nextGraphemeLength(){const ce=rt.getInstance(),Se=this.c,de=Se.offset;let ke=ce.getGraphemeBreakType(Se.nextCodePoint());for(;!Se.eol();){const ne=Se.offset,J=ce.getGraphemeBreakType(Se.nextCodePoint());if(Ve(ke,J)){Se.setOffset(ne);break}ke=J}return Se.offset-de}prevGraphemeLength(){const ce=rt.getInstance(),Se=this.c,de=Se.offset;let ke=ce.getGraphemeBreakType(Se.prevCodePoint());for(;Se.offset>0;){const ne=Se.offset,J=ce.getGraphemeBreakType(Se.prevCodePoint());if(Ve(J,ke)){Se.setOffset(ne);break}ke=J}return de-Se.offset}eol(){return this.c.eol()}}e.$Rf=oe;function ie(re,ce){return new oe(re,ce).nextGraphemeLength()}function me(re,ce){return new oe(re,ce).prevGraphemeLength()}function ue(re,ce){ce>0&&_(re.charCodeAt(ce))&&ce--;const Se=ce+ie(re,ce);return[Se-me(re,Se),Se]}function X(re){const ce=new oe(re);let Se=0;for(;!ce.eol();)Se++,ce.nextGraphemeLength();return Se}let q;function se(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function be(re){return q||(q=se()),q.test(re)}const ae=/^[\t\n\r\x20-\x7E]*$/;function we(re){return ae.test(re)}e.$Yf=/[\u2028\u2029]/;function $e(re){return e.$Yf.test(re)}function pe(re){return re>=11904&&re<=55215||re>=63744&&re<=64255||re>=65281&&re<=65374}function Ae(re){return re>=127462&&re<=127487||re===8986||re===8987||re===9200||re===9203||re>=9728&&re<=10175||re===11088||re===11093||re>=127744&&re<=128591||re>=128640&&re<=128764||re>=128992&&re<=129008||re>=129280&&re<=129535||re>=129648&&re<=129782}function je(re,ce,Se=""){const de=re.trimStart();if(de.length<ce)return de;const ke=/\b/g;let ne=0;for(;ke.test(de)&&!(de.length-ke.lastIndex<ce);)ne=ke.lastIndex,ke.lastIndex+=1;return ne===0?de:Se+de.substring(ne).trimStart()}const He=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*Ye(re){let ce=0;for(const Se of re.matchAll(He))ce!==Se.index&&(yield{isCode:!1,str:re.substring(ce,Se.index)}),yield{isCode:!0,str:Se[0]},ce=Se.index+Se[0].length;ce!==re.length&&(yield{isCode:!1,str:re.substring(ce)})}function xe(re){return re&&(re=re.replace(He,"")),re}const Fe=/\\\[.*?\\\]/g;function We(re){return xe(re).replace(Fe,"")}e.$7f=String.fromCharCode(h.CharCode.UTF8_BOM);function Ne(re){return!!(re&&re.length>0&&re.charCodeAt(0)===h.CharCode.UTF8_BOM)}function H(re){return Ne(re)?re.substr(1):re}function G(re,ce){if(!re||!ce||re.length<ce.length)return!1;const Se=ce.length,de=re.toLowerCase();let ke=0,ne=-1;for(;ke<Se;){const J=de.indexOf(ce[ke],ne+1);if(J<0)return!1;ne=J,ke++}return!0}function Z(re,ce=!1){return re?(ce&&(re=re.replace(/\\./g,"")),re.toLowerCase()!==re):!1}function ee(re){return re.charAt(0).toUpperCase()+re.slice(1)}function le(re,ce=1){if(ce===0)return"";let Se=-1;do Se=re.indexOf(`
`,Se+1),ce--;while(ce>0&&Se>=0);return Se===-1?re:(re[Se-1]==="\r"&&Se--,re.substr(0,Se))}function ye(re){const ce=h.CharCode.Z-h.CharCode.A+1;return re=re%(2*ce),re<ce?String.fromCharCode(h.CharCode.a+re):String.fromCharCode(h.CharCode.A+re-ce)}function Te(re){return rt.getInstance().getGraphemeBreakType(re)}function Ve(re,ce){return re===Ke.Other?ce!==Ke.Extend&&ce!==Ke.SpacingMark:re===Ke.CR&&ce===Ke.LF?!1:re===Ke.Control||re===Ke.CR||re===Ke.LF||ce===Ke.Control||ce===Ke.CR||ce===Ke.LF?!0:!(re===Ke.L&&(ce===Ke.L||ce===Ke.V||ce===Ke.LV||ce===Ke.LVT)||(re===Ke.LV||re===Ke.V)&&(ce===Ke.V||ce===Ke.T)||(re===Ke.LVT||re===Ke.T)&&ce===Ke.T||ce===Ke.Extend||ce===Ke.ZWJ||ce===Ke.SpacingMark||re===Ke.Prepend||re===Ke.ZWJ&&ce===Ke.Extended_Pictographic||re===Ke.Regional_Indicator&&ce===Ke.Regional_Indicator)}var Ke;(function(re){re[re.Other=0]="Other",re[re.Prepend=1]="Prepend",re[re.CR=2]="CR",re[re.LF=3]="LF",re[re.Control=4]="Control",re[re.Extend=5]="Extend",re[re.Regional_Indicator=6]="Regional_Indicator",re[re.SpacingMark=7]="SpacingMark",re[re.L=8]="L",re[re.V=9]="V",re[re.T=10]="T",re[re.LV=11]="LV",re[re.LVT=12]="LVT",re[re.ZWJ=13]="ZWJ",re[re.Extended_Pictographic=14]="Extended_Pictographic"})(Ke||(e.GraphemeBreakType=Ke={}));class rt{static{this.c=null}static getInstance(){return rt.c||(rt.c=new rt),rt.c}constructor(){this.d=ot()}getGraphemeBreakType(ce){if(ce<32)return ce===h.CharCode.LineFeed?Ke.LF:ce===h.CharCode.CarriageReturn?Ke.CR:Ke.Control;if(ce<127)return Ke.Other;const Se=this.d,de=Se.length/3;let ke=1;for(;ke<=de;)if(ce<Se[3*ke])ke=2*ke;else if(ce>Se[3*ke+1])ke=2*ke+1;else return Se[3*ke+2];return Ke.Other}}function ot(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ut(re,ce){if(re===0)return 0;const Se=at(re,ce);if(Se!==void 0)return Se;const de=new x(ce,re);return de.prevCodePoint(),de.offset}function at(re,ce){const Se=new x(ce,re);let de=Se.prevCodePoint();for(;lt(de)||de===$t.emojiVariantSelector||de===$t.enclosingKeyCap;){if(Se.offset===0)return;de=Se.prevCodePoint()}if(!Ae(de))return;let ke=Se.offset;return ke>0&&Se.prevCodePoint()===$t.zwj&&(ke=Se.offset),ke}function lt(re){return 127995<=re&&re<=127999}var $t;(function(re){re[re.zwj=8205]="zwj",re[re.emojiVariantSelector=65039]="emojiVariantSelector",re[re.enclosingKeyCap=8419]="enclosingKeyCap"})($t||($t={})),e.$eg="\xA0";class it{static{this.c=new R.$W(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new s.$bf({getCacheKey:JSON.stringify},ce=>{function Se(st){const ht=new Map;for(let ft=0;ft<st.length;ft+=2)ht.set(st[ft],st[ft+1]);return ht}function de(st,ht){const ft=new Map(st);for(const[St,At]of ht)ft.set(St,At);return ft}function ke(st,ht){if(!st)return ht;const ft=new Map;for(const[St,At]of st)ht.has(St)&&ft.set(St,At);return ft}const ne=this.c.value;let J=ce.filter(st=>!st.startsWith("_")&&st in ne);J.length===0&&(J=["_default"]);let Pe;for(const st of J){const ht=Se(ne[st]);Pe=ke(Pe,ht)}const Ge=Se(ne._common),Je=de(Ge,Pe);return new it(Je)})}static getInstance(ce){return it.d.get(Array.from(ce))}static{this.e=new R.$W(()=>Object.keys(it.c.value).filter(ce=>!ce.startsWith("_")))}static getLocales(){return it.e.value}constructor(ce){this.f=ce}isAmbiguous(ce){return this.f.has(ce)}containsAmbiguousCharacter(ce){for(let Se=0;Se<ce.length;Se++){const de=ce.codePointAt(Se);if(typeof de=="number"&&this.isAmbiguous(de))return!0}return!1}getPrimaryConfusable(ce){return this.f.get(ce)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$fg=it;class Ie{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ie.c())),this.d}static isInvisibleCharacter(ce){return Ie.e().has(ce)}static containsInvisibleCharacter(ce){for(let Se=0;Se<ce.length;Se++){const de=ce.codePointAt(Se);if(typeof de=="number"&&Ie.isInvisibleCharacter(de))return!0}return!1}static get codePoints(){return Ie.e()}}e.$gg=Ie}),define(Re[31],Ce([1,0,26,16,10,13,17]),function(ge,e,s,h,R,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ag=C,e.$Bg=m,e.$Cg=c,e.$Dg=I,e.$Eg=E,e.$Fg=a,e.$Gg=$,e.$Hg=p,e.$Ig=u,e.$Jg=i,e.$Kg=o,e.$Lg=t,e.$Mg=n,e.$Ng=r,e.$Og=d,e.$Pg=l,e.$Qg=k;function C(S){return S===s.CharCode.Slash||S===s.CharCode.Backslash}function m(S){return S.replace(/[\\/]/g,h.$jc.sep)}function c(S){return S.indexOf("/")===-1&&(S=m(S)),/^[a-zA-Z]:(\/|$)/.test(S)&&(S="/"+S),S}function I(S,D=h.$jc.sep){if(!S)return"";const T=S.length,v=S.charCodeAt(0);if(C(v)){if(C(S.charCodeAt(1))&&!C(S.charCodeAt(2))){let M=3;const L=M;for(;M<T&&!C(S.charCodeAt(M));M++);if(L!==M&&!C(S.charCodeAt(M+1))){for(M+=1;M<T;M++)if(C(S.charCodeAt(M)))return S.slice(0,M+1).replace(/[\\/]/g,D)}}return D}else if(u(v)&&S.charCodeAt(1)===s.CharCode.Colon)return C(S.charCodeAt(2))?S.slice(0,2)+D:S.slice(0,2);let w=S.indexOf("://");if(w!==-1){for(w+=3;w<T;w++)if(C(S.charCodeAt(w)))return S.slice(0,w+1)}return""}function E(S){if(!R.$j||!S||S.length<5)return!1;let D=S.charCodeAt(0);if(D!==s.CharCode.Backslash||(D=S.charCodeAt(1),D!==s.CharCode.Backslash))return!1;let T=2;const v=T;for(;T<S.length&&(D=S.charCodeAt(T),D!==s.CharCode.Backslash);T++);return!(v===T||(D=S.charCodeAt(T+1),isNaN(D)||D===s.CharCode.Backslash))}const g=/[\\/:\*\?"<>\|]/g,P=/[/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function a(S,D=R.$j){const T=D?g:P;return!(!S||S.length===0||/^\s+$/.test(S)||(T.lastIndex=0,T.test(S))||D&&b.test(S)||S==="."||S===".."||D&&S[S.length-1]==="."||D&&S.length!==S.trim().length||S.length>255)}function $(S,D,T){const v=S===D;return!T||v?v:!S||!D?!1:(0,A.$If)(S,D)}function p(S,D,T,v=h.sep){if(S===D)return!0;if(!S||!D||D.length>S.length)return!1;if(T){if(!(0,A.$Jf)(S,D))return!1;if(D.length===S.length)return!0;let M=D.length;return D.charAt(D.length-1)===v&&M--,S.charAt(M)===v}return D.charAt(D.length-1)!==v&&(D+=v),S.indexOf(D)===0}function u(S){return S>=s.CharCode.A&&S<=s.CharCode.Z||S>=s.CharCode.a&&S<=s.CharCode.z}function i(S,D){return R.$j&&S.endsWith(":")&&(S+=h.sep),(0,h.$lc)(S)||(S=(0,h.$mc)(D,S)),S=(0,h.$kc)(S),o(S)}function o(S){return R.$j?(S=(0,A.$qf)(S,h.sep),S.endsWith(":")&&(S+=h.sep)):(S=(0,A.$qf)(S,h.sep),S||(S=h.sep)),S}function t(S){const D=(0,h.$kc)(S);return R.$j?S.length>3?!1:n(D)&&(S.length===2||D.charCodeAt(2)===s.CharCode.Backslash):D===h.$jc.sep}function n(S,D=R.$j){return D?u(S.charCodeAt(0))&&S.charCodeAt(1)===s.CharCode.Colon:!1}function r(S,D=R.$j){return n(S,D)?S[0]:void 0}function d(S,D,T){return D.length>S.length?-1:S===D?0:(T&&(S=S.toLowerCase(),D=D.toLowerCase()),S.indexOf(D))}function l(S){const D=S.split(":");let T,v,w;for(const M of D){const L=Number(M);(0,O.$lg)(L)?v===void 0?v=L:w===void 0&&(w=L):T=T?[T,M].join(":"):M}if(!T)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:T,line:v!==void 0?v:void 0,column:w!==void 0?w:v!==void 0?1:void 0}}const f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",y="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function k(S,D,T=8){let v="";for(let M=0;M<T;M++){let L;M===0&&R.$j&&!D&&(T===3||T===4)?L=y:L=f,v+=L.charAt(Math.floor(Math.random()*L.length))}let w;return D?w=`${D}-${v}`:w=v,S?(0,h.$mc)(S,w):w}}),define(Re[136],Ce([1,0,26,28,182,13]),function(ge,e,s,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wk=e.FuzzyScore=e.$Lk=e.$Kk=void 0,e.or=O,e.$Mk=m,e.$Nk=c,e.$Ok=g,e.$Pk=k,e.$Qk=S,e.$Rk=L,e.$Sk=N,e.$Tk=F,e.$Uk=V,e.$Vk=se,e.$Xk=$e,e.$Yk=je,e.$Zk=He,A=Ue(A);function O(...Fe){return function(We,Ne){for(let H=0,G=Fe.length;H<G;H++){const Z=Fe[H](We,Ne);if(Z)return Z}return null}}e.$Kk=C.bind(void 0,!1),e.$Lk=C.bind(void 0,!0);function C(Fe,We,Ne){if(!Ne||Ne.length<We.length)return null;let H;return Fe?H=A.$Jf(Ne,We):H=Ne.indexOf(We)===0,H?We.length>0?[{start:0,end:We.length}]:[]:null}function m(Fe,We){const Ne=We.toLowerCase().indexOf(Fe.toLowerCase());return Ne===-1?null:[{start:Ne,end:Ne+Fe.length}]}function c(Fe,We){return I(Fe.toLowerCase(),We.toLowerCase(),0,0)}function I(Fe,We,Ne,H){if(Ne===Fe.length)return[];if(H===We.length)return null;if(Fe[Ne]===We[H]){let G=null;return(G=I(Fe,We,Ne+1,H+1))?t({start:H,end:H+1},G):null}return I(Fe,We,Ne,H+1)}function E(Fe){return s.CharCode.a<=Fe&&Fe<=s.CharCode.z}function g(Fe){return s.CharCode.A<=Fe&&Fe<=s.CharCode.Z}function P(Fe){return s.CharCode.Digit0<=Fe&&Fe<=s.CharCode.Digit9}function b(Fe){return Fe===s.CharCode.Space||Fe===s.CharCode.Tab||Fe===s.CharCode.LineFeed||Fe===s.CharCode.CarriageReturn}const a=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Fe=>a.add(Fe.charCodeAt(0)));function $(Fe){return b(Fe)||a.has(Fe)}function p(Fe,We){return Fe===We||$(Fe)&&$(We)}const u=new Map;function i(Fe){if(u.has(Fe))return u.get(Fe);let We;const Ne=(0,R.$Ik)(Fe);return Ne&&(We=Ne),u.set(Fe,We),We}function o(Fe){return E(Fe)||g(Fe)||P(Fe)}function t(Fe,We){return We.length===0?We=[Fe]:Fe.end===We[0].start?We[0].start=Fe.start:We.unshift(Fe),We}function n(Fe,We){for(let Ne=We;Ne<Fe.length;Ne++){const H=Fe.charCodeAt(Ne);if(g(H)||P(H)||Ne>0&&!o(Fe.charCodeAt(Ne-1)))return Ne}return Fe.length}function r(Fe,We,Ne,H){if(Ne===Fe.length)return[];if(H===We.length)return null;if(Fe[Ne]!==We[H].toLowerCase())return null;{let G=null,Z=H+1;for(G=r(Fe,We,Ne+1,H+1);!G&&(Z=n(We,Z))<We.length;)G=r(Fe,We,Ne+1,Z),Z++;return G===null?null:t({start:H,end:H+1},G)}}function d(Fe){let We=0,Ne=0,H=0,G=0,Z=0;for(let Ve=0;Ve<Fe.length;Ve++)Z=Fe.charCodeAt(Ve),g(Z)&&We++,E(Z)&&Ne++,o(Z)&&H++,P(Z)&&G++;const ee=We/Fe.length,le=Ne/Fe.length,ye=H/Fe.length,Te=G/Fe.length;return{upperPercent:ee,lowerPercent:le,alphaPercent:ye,numericPercent:Te}}function l(Fe){const{upperPercent:We,lowerPercent:Ne}=Fe;return Ne===0&&We>.6}function f(Fe){const{upperPercent:We,lowerPercent:Ne,alphaPercent:H,numericPercent:G}=Fe;return Ne>.2&&We<.8&&H>.6&&G<.2}function y(Fe){let We=0,Ne=0,H=0,G=0;for(let Z=0;Z<Fe.length;Z++)H=Fe.charCodeAt(Z),g(H)&&We++,E(H)&&Ne++,b(H)&&G++;return(We===0||Ne===0)&&G===0?Fe.length<=30:We<=5}function k(Fe,We){if(!We||(We=We.trim(),We.length===0)||!y(Fe))return null;We.length>60&&(We=We.substring(0,60));const Ne=d(We);if(!f(Ne)){if(!l(Ne))return null;We=We.toLowerCase()}let H=null,G=0;for(Fe=Fe.toLowerCase();G<We.length&&(H=r(Fe,We,0,G))===null;)G=n(We,G+1);return H}function S(Fe,We,Ne=!1){if(!We||We.length===0)return null;let H=null,G=0;for(Fe=Fe.toLowerCase(),We=We.toLowerCase();G<We.length&&(H=D(Fe,We,0,G,Ne),H===null);)G=T(We,G+1);return H}function D(Fe,We,Ne,H,G){let Z=0;if(Ne===Fe.length)return[];if(H===We.length)return null;if(!p(Fe.charCodeAt(Ne),We.charCodeAt(H))){const ye=i(Fe.charCodeAt(Ne));if(!ye)return null;for(let Te=0;Te<ye.length;Te++)if(!p(ye[Te],We.charCodeAt(H+Te)))return null;Z+=ye.length-1}let ee=null,le=H+Z+1;if(ee=D(Fe,We,Ne+1,le,G),!G)for(;!ee&&(le=T(We,le))<We.length;)ee=D(Fe,We,Ne+1,le,G),le++;if(!ee)return null;if(Fe.charCodeAt(Ne)!==We.charCodeAt(H)){const ye=i(Fe.charCodeAt(Ne));if(!ye)return ee;for(let Te=0;Te<ye.length;Te++)if(ye[Te]!==We.charCodeAt(H+Te))return ee}return t({start:H,end:H+Z+1},ee)}function T(Fe,We){for(let Ne=We;Ne<Fe.length;Ne++)if($(Fe.charCodeAt(Ne))||Ne>0&&$(Fe.charCodeAt(Ne-1)))return Ne;return Fe.length}const v=O(e.$Lk,k,m),w=O(e.$Lk,k,c),M=new h.$Gc(1e4);function L(Fe,We,Ne=!1){if(typeof Fe!="string"||typeof We!="string")return null;let H=M.get(Fe);H||(H=new RegExp(A.$rf(Fe),"i"),M.set(Fe,H));const G=H.exec(We);return G?[{start:G.index,end:G.index+G[0].length}]:Ne?w(Fe,We):v(Fe,We)}function N(Fe,We){const Ne=$e(Fe,Fe.toLowerCase(),0,We,We.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ne?V(Ne):null}function F(Fe,We,Ne,H,G,Z){const ee=Math.min(13,Fe.length);for(;Ne<ee;Ne++){const le=$e(Fe,We,Ne,H,G,Z,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(le)return le}return[0,Z]}function V(Fe){if(typeof Fe>"u")return[];const We=[],Ne=Fe[1];for(let H=Fe.length-1;H>1;H--){const G=Fe[H]+Ne,Z=We[We.length-1];Z&&Z.end===G?Z.end=G+1:We.push({start:G,end:G+1})}return We}const j=128;function U(){const Fe=[],We=[];for(let Ne=0;Ne<=j;Ne++)We[Ne]=0;for(let Ne=0;Ne<=j;Ne++)Fe.push(We.slice(0));return Fe}function z(Fe){const We=[];for(let Ne=0;Ne<=Fe;Ne++)We[Ne]=0;return We}const _=z(2*j),W=z(2*j),B=U(),Y=U(),x=U(),oe=!1;function ie(Fe,We,Ne,H,G){function Z(le,ye,Te=" "){for(;le.length<ye;)le=Te+le;return le}let ee=` |   |${H.split("").map(le=>Z(le,3)).join("|")}
`;for(let le=0;le<=Ne;le++)le===0?ee+=" |":ee+=`${We[le-1]}|`,ee+=Fe[le].slice(0,G+1).map(ye=>Z(ye.toString(),3)).join("|")+`
`;return ee}function me(Fe,We,Ne,H){Fe=Fe.substr(We),Ne=Ne.substr(H),console.log(ie(Y,Fe,Fe.length,Ne,Ne.length)),console.log(ie(x,Fe,Fe.length,Ne,Ne.length)),console.log(ie(B,Fe,Fe.length,Ne,Ne.length))}function ue(Fe,We){if(We<0||We>=Fe.length)return!1;const Ne=Fe.codePointAt(We);switch(Ne){case s.CharCode.Underline:case s.CharCode.Dash:case s.CharCode.Period:case s.CharCode.Space:case s.CharCode.Slash:case s.CharCode.Backslash:case s.CharCode.SingleQuote:case s.CharCode.DoubleQuote:case s.CharCode.Colon:case s.CharCode.DollarSign:case s.CharCode.LessThan:case s.CharCode.GreaterThan:case s.CharCode.OpenParen:case s.CharCode.CloseParen:case s.CharCode.OpenSquareBracket:case s.CharCode.CloseSquareBracket:case s.CharCode.OpenCurlyBrace:case s.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!A.$2f(Ne)}}function X(Fe,We){if(We<0||We>=Fe.length)return!1;switch(Fe.charCodeAt(We)){case s.CharCode.Space:case s.CharCode.Tab:return!0;default:return!1}}function q(Fe,We,Ne){return We[Fe]!==Ne[Fe]}function se(Fe,We,Ne,H,G,Z,ee=!1){for(;We<Ne&&G<Z;)Fe[We]===H[G]&&(ee&&(_[We]=G),We+=1),G+=1;return We===Ne}var be;(function(Fe){Fe[Fe.Diag=1]="Diag",Fe[Fe.Left=2]="Left",Fe[Fe.LeftLeft=3]="LeftLeft"})(be||(be={}));var ae;(function(Fe){Fe.Default=[-100,0];function We(Ne){return!Ne||Ne.length===2&&Ne[0]===-100&&Ne[1]===0}Fe.isDefault=We})(ae||(e.FuzzyScore=ae={}));class we{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(We,Ne){this.firstMatchCanBeWeak=We,this.boostFullMatch=Ne}}e.$Wk=we;function $e(Fe,We,Ne,H,G,Z,ee=we.default){const le=Fe.length>j?j:Fe.length,ye=H.length>j?j:H.length;if(Ne>=le||Z>=ye||le-Ne>ye-Z||!se(We,Ne,le,G,Z,ye,!0))return;pe(le,ye,Ne,Z,We,G);let Te=1,Ve=1,Ke=Ne,rt=Z;const ot=[!1];for(Te=1,Ke=Ne;Ke<le;Te++,Ke++){const it=_[Ke],Ie=W[Ke],re=Ke+1<le?W[Ke+1]:ye;for(Ve=it-Z+1,rt=it;rt<re;Ve++,rt++){let ce=Number.MIN_SAFE_INTEGER,Se=!1;rt<=Ie&&(ce=Ae(Fe,We,Ke,Ne,H,G,rt,ye,Z,B[Te-1][Ve-1]===0,ot));let de=0;ce!==Number.MAX_SAFE_INTEGER&&(Se=!0,de=ce+Y[Te-1][Ve-1]);const ke=rt>it,ne=ke?Y[Te][Ve-1]+(B[Te][Ve-1]>0?-5:0):0,J=rt>it+1&&B[Te][Ve-1]>0,Pe=J?Y[Te][Ve-2]+(B[Te][Ve-2]>0?-5:0):0;if(J&&(!ke||Pe>=ne)&&(!Se||Pe>=de))Y[Te][Ve]=Pe,x[Te][Ve]=be.LeftLeft,B[Te][Ve]=0;else if(ke&&(!Se||ne>=de))Y[Te][Ve]=ne,x[Te][Ve]=be.Left,B[Te][Ve]=0;else if(Se)Y[Te][Ve]=de,x[Te][Ve]=be.Diag,B[Te][Ve]=B[Te-1][Ve-1]+1;else throw new Error("not possible")}}if(oe&&me(Fe,Ne,H,Z),!ot[0]&&!ee.firstMatchCanBeWeak)return;Te--,Ve--;const ut=[Y[Te][Ve],Z];let at=0,lt=0;for(;Te>=1;){let it=Ve;do{const Ie=x[Te][it];if(Ie===be.LeftLeft)it=it-2;else if(Ie===be.Left)it=it-1;else break}while(it>=1);at>1&&We[Ne+Te-1]===G[Z+Ve-1]&&!q(it+Z-1,H,G)&&at+1>B[Te][it]&&(it=Ve),it===Ve?at++:at=1,lt||(lt=it),Te--,Ve=it-1,ut.push(Ve)}ye-Z===le&&ee.boostFullMatch&&(ut[0]+=2);const $t=lt-le;return ut[0]-=$t,ut}function pe(Fe,We,Ne,H,G,Z){let ee=Fe-1,le=We-1;for(;ee>=Ne&&le>=H;)G[ee]===Z[le]&&(W[ee]=le,ee--),le--}function Ae(Fe,We,Ne,H,G,Z,ee,le,ye,Te,Ve){if(We[Ne]!==Z[ee])return Number.MIN_SAFE_INTEGER;let Ke=1,rt=!1;return ee===Ne-H?Ke=Fe[Ne]===G[ee]?7:5:q(ee,G,Z)&&(ee===0||!q(ee-1,G,Z))?(Ke=Fe[Ne]===G[ee]?7:5,rt=!0):ue(Z,ee)&&(ee===0||!ue(Z,ee-1))?Ke=5:(ue(Z,ee-1)||X(Z,ee-1))&&(Ke=5,rt=!0),Ke>1&&Ne===H&&(Ve[0]=!0),rt||(rt=q(ee,G,Z)||ue(Z,ee-1)||X(Z,ee-1)),Ne===H?ee>ye&&(Ke-=rt?3:5):Te?Ke+=rt?2:0:Ke+=rt?0:1,ee+1===le&&(Ke-=rt?3:5),Ke}function je(Fe,We,Ne,H,G,Z,ee){return Ye(Fe,We,Ne,H,G,Z,!0,ee)}function He(Fe,We,Ne,H,G,Z,ee){return Ye(Fe,We,Ne,H,G,Z,!1,ee)}function Ye(Fe,We,Ne,H,G,Z,ee,le){let ye=$e(Fe,We,Ne,H,G,Z,le);if(ye&&!ee)return ye;if(Fe.length>=3){const Te=Math.min(7,Fe.length-1);for(let Ve=Ne+1;Ve<Te;Ve++){const Ke=xe(Fe,Ve);if(Ke){const rt=$e(Ke,Ke.toLowerCase(),Ne,H,G,Z,le);rt&&(rt[0]-=3,(!ye||rt[0]>ye[0])&&(ye=rt))}}}return ye}function xe(Fe,We){if(We+1>=Fe.length)return;const Ne=Fe[We],H=Fe[We+1];if(Ne!==H)return Fe.slice(0,We)+H+Ne+Fe.slice(We+2)}}),define(Re[61],Ce([1,0,13]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cj=e.$Aj=void 0,e.$wj=h,e.$xj=R,e.$yj=A,e.$zj=C,e.$Bj=a,s=Ue(s);function h(p){return R(p,0)}function R(p,u){switch(typeof p){case"object":return p===null?A(349,u):Array.isArray(p)?m(p,u):c(p,u);case"string":return C(p,u);case"boolean":return O(p,u);case"number":return A(p,u);case"undefined":return A(937,u);default:return A(617,u)}}function A(p,u){return(u<<5)-u+p|0}function O(p,u){return A(p?433:863,u)}function C(p,u){u=A(149417,u);for(let i=0,o=p.length;i<o;i++)u=A(p.charCodeAt(i),u);return u}function m(p,u){return u=A(104579,u),p.reduce((i,o)=>R(o,i),u)}function c(p,u){return u=A(181387,u),Object.keys(p).sort().reduce((i,o)=>(i=C(o,i),R(p[o],i)),u)}class I{constructor(){this.g=0}get value(){return this.g}hash(u){return this.g=R(u,this.g),this.g}}e.$Aj=I;var E;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function g(p,u,i=32){const o=i-u,t=~((1<<o)-1);return(p<<u|(t&p)>>>o)>>>0}function P(p,u=0,i=p.byteLength,o=0){for(let t=0;t<i;t++)p[u+t]=o}function b(p,u,i="0"){for(;p.length<u;)p=i+p;return p}function a(p,u=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(i=>i.toString(16).padStart(2,"0")).join(""):b((p>>>0).toString(16),u/4)}class ${static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(E.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(u){const i=u.length;if(i===0)return;const o=this.p;let t=this.r,n=this.u,r,d;for(n!==0?(r=n,d=-1,n=0):(r=u.charCodeAt(0),d=0);;){let l=r;if(s.$Mf(r))if(d+1<i){const f=u.charCodeAt(d+1);s.$Nf(f)?(d++,l=s.$Of(r,f)):l=E.UNICODE_REPLACEMENT}else{n=r;break}else s.$Nf(r)&&(l=E.UNICODE_REPLACEMENT);if(t=this.w(o,t,l),d++,d<i)r=u.charCodeAt(d);else break}this.r=t,this.u=n}w(u,i,o){return o<128?u[i++]=o:o<2048?(u[i++]=192|(o&1984)>>>6,u[i++]=128|(o&63)>>>0):o<65536?(u[i++]=224|(o&61440)>>>12,u[i++]=128|(o&4032)>>>6,u[i++]=128|(o&63)>>>0):(u[i++]=240|(o&1835008)>>>18,u[i++]=128|(o&258048)>>>12,u[i++]=128|(o&4032)>>>6,u[i++]=128|(o&63)>>>0),i>=E.BLOCK_SIZE&&(this.y(),i-=E.BLOCK_SIZE,this.t+=E.BLOCK_SIZE,u[0]=u[E.BLOCK_SIZE+0],u[1]=u[E.BLOCK_SIZE+1],u[2]=u[E.BLOCK_SIZE+2]),i}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,E.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),a(this.h)+a(this.l)+a(this.m)+a(this.n)+a(this.o)}x(){this.p[this.r++]=128,P(this.p,this.r),this.r>56&&(this.y(),P(this.p));const u=8*this.t;this.q.setUint32(56,Math.floor(u/4294967296),!1),this.q.setUint32(60,u%4294967296,!1),this.y()}y(){const u=$.g,i=this.q;for(let k=0;k<64;k+=4)u.setUint32(k,i.getUint32(k,!1),!1);for(let k=64;k<320;k+=4)u.setUint32(k,g(u.getUint32(k-12,!1)^u.getUint32(k-32,!1)^u.getUint32(k-56,!1)^u.getUint32(k-64,!1),1),!1);let o=this.h,t=this.l,n=this.m,r=this.n,d=this.o,l,f,y;for(let k=0;k<80;k++)k<20?(l=t&n|~t&r,f=1518500249):k<40?(l=t^n^r,f=1859775393):k<60?(l=t&n|t&r|n&r,f=2400959708):(l=t^n^r,f=3395469782),y=g(o,5)+l+d+f+u.getUint32(k*4,!1)&4294967295,d=r,r=n,n=g(t,30),t=o,o=y;this.h=this.h+o&4294967295,this.l=this.l+t&4294967295,this.m=this.m+n&4294967295,this.n=this.n+r&4294967295,this.o=this.o+d&4294967295}}e.$Cj=$}),define(Re[137],Ce([1,0,26,135,136,61,16,10,13]),function(ge,e,s,h,R,A,O,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tr=E,e.$Ur=p,e.$Vr=l,e.$Wr=v,e.$Xr=V,e.$Yr=U;const c=0,I=[c,[]];function E(z,_,W,B){if(!z||!_)return I;const Y=z.length,x=_.length;if(Y<x)return I;const oe=z.toLowerCase();return g(_,W,x,z,oe,Y,B)}function g(z,_,W,B,Y,x,oe){const ie=[],me=[];for(let se=0;se<W;se++){const be=se*x,ae=be-x,we=se>0,$e=z[se],pe=_[se];for(let Ae=0;Ae<x;Ae++){const je=Ae>0,He=be+Ae,Ye=He-1,xe=ae+Ae-1,Fe=je?ie[Ye]:0,We=we&&je?ie[xe]:0,Ne=we&&je?me[xe]:0;let H;!We&&we?H=0:H=P($e,pe,B,Y,Ae,Ne),H&&We+H>=Fe&&(oe||we||Y.startsWith(_,Ae))?(me[He]=Ne+1,ie[He]=We+H):(me[He]=c,ie[He]=Fe)}}const ue=[];let X=W-1,q=x-1;for(;X>=0&&q>=0;){const se=X*x+q;me[se]===c||(ue.push(q),X--),q--}return[ie[W*x-1],ue.reverse()]}function P(z,_,W,B,Y,x){let oe=0;if(!b(_,B[Y]))return oe;if(oe+=1,x>0&&(oe+=x*5),z===W[Y]&&(oe+=1),Y===0)oe+=8;else{const ie=a(W.charCodeAt(Y-1));ie?oe+=ie:(0,R.$Ok)(W.charCodeAt(Y))&&x===0&&(oe+=2)}return oe}function b(z,_){return z===_?!0:z==="/"||z==="\\"?_==="/"||_==="\\":!1}function a(z){switch(z){case s.CharCode.Slash:case s.CharCode.Backslash:return 5;case s.CharCode.Underline:case s.CharCode.Dash:case s.CharCode.Period:case s.CharCode.Space:case s.CharCode.SingleQuote:case s.CharCode.DoubleQuote:case s.CharCode.Colon:return 4;default:return 0}}const $=[void 0,[]];function p(z,_,W=0,B=0){const Y=_;return Y.values&&Y.values.length>1?u(z,Y.values,W,B):i(z,_,W,B)}function u(z,_,W,B){let Y=0;const x=[];for(const oe of _){const[ie,me]=i(z,oe,W,B);if(typeof ie!="number")return $;Y+=ie,x.push(...me)}return[Y,D(x)]}function i(z,_,W,B){const Y=(0,R.$Xk)(_.original,_.originalLowercase,W,z,z.toLowerCase(),B,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Y?[Y[0],(0,R.$Uk)(Y)]:$}const o=Object.freeze({score:0}),t=1<<18,n=1<<17,r=65536;function d(z,_,W,B){const Y=B.values?B.values:[B];return(0,A.$wj)({[B.normalized]:{values:Y.map(oe=>({value:oe.normalized,expectContiguousMatch:oe.expectContiguousMatch})),label:z,description:_,allowNonContiguousMatches:W}})}function l(z,_,W,B,Y){if(!z||!_.normalized)return o;const x=B.getItemLabel(z);if(!x)return o;const oe=B.getItemDescription(z),ie=d(x,oe,W,_),me=Y[ie];if(me)return me;const ue=f(x,oe,B.getItemPath(z),_,W);return Y[ie]=ue,ue}function f(z,_,W,B,Y){const x=!W||!B.containsPathSeparator;return W&&(C.$l?B.pathNormalized===W:(0,m.$If)(B.pathNormalized,W))?{score:t,labelMatch:[{start:0,end:z.length}],descriptionMatch:_?[{start:0,end:_.length}]:void 0}:B.values&&B.values.length>1?y(z,_,W,B.values,x,Y):k(z,_,W,B,x,Y)}function y(z,_,W,B,Y,x){let oe=0;const ie=[],me=[];for(const ue of B){const{score:X,labelMatch:q,descriptionMatch:se}=k(z,_,W,ue,Y,x);if(X===c)return o;oe+=X,q&&ie.push(...q),se&&me.push(...se)}return{score:oe,labelMatch:D(ie),descriptionMatch:D(me)}}function k(z,_,W,B,Y,x){if(Y||!_){const[oe,ie]=E(z,B.normalized,B.normalizedLowercase,x&&!B.expectContiguousMatch);if(oe){const me=(0,R.$Lk)(B.normalized,z);let ue;if(me){ue=n;const X=Math.round(B.normalized.length/z.length*100);ue+=X}else ue=r;return{score:ue+oe,labelMatch:me||S(ie)}}}if(_){let oe=_;W&&(oe=`${_}${O.sep}`);const ie=oe.length,me=`${oe}${z}`,[ue,X]=E(me,B.normalized,B.normalizedLowercase,x&&!B.expectContiguousMatch);if(ue){const q=S(X),se=[],be=[];return q.forEach(ae=>{ae.start<ie&&ae.end>ie?(se.push({start:0,end:ae.end-ie}),be.push({start:ae.start,end:ie})):ae.start>=ie?se.push({start:ae.start-ie,end:ae.end-ie}):be.push(ae)}),{score:ue,labelMatch:se,descriptionMatch:be}}}return o}function S(z){const _=[];if(!z)return _;let W;for(const B of z)W&&W.end===B?W.end+=1:(W={start:B,end:B+1},_.push(W));return _}function D(z){const _=z.sort((Y,x)=>Y.start-x.start),W=[];let B;for(const Y of _)!B||!T(B,Y)?(B=Y,W.push(Y)):(B.start=Math.min(B.start,Y.start),B.end=Math.max(B.end,Y.end));return W}function T(z,_){return!(z.end<_.start||_.end<z.start)}function v(z,_,W,B,Y,x){const oe=l(z,W,B,Y,x),ie=l(_,W,B,Y,x),me=oe.score,ue=ie.score;if((me===t||ue===t)&&me!==ue)return me===t?-1:1;if(me>r||ue>r){if(me!==ue)return me>ue?-1:1;if(me<n&&ue<n){const $e=M(oe.labelMatch,ie.labelMatch);if($e!==0)return $e}const ae=Y.getItemLabel(z)||"",we=Y.getItemLabel(_)||"";if(ae.length!==we.length)return ae.length-we.length}if(me!==ue)return me>ue?-1:1;const X=Array.isArray(oe.labelMatch)&&oe.labelMatch.length>0,q=Array.isArray(ie.labelMatch)&&ie.labelMatch.length>0;if(X&&!q)return-1;if(q&&!X)return 1;const se=w(z,oe,Y),be=w(_,ie,Y);return se&&be&&se!==be?be>se?-1:1:L(z,_,W,Y)}function w(z,_,W){let B=-1,Y=-1;if(_.descriptionMatch&&_.descriptionMatch.length?B=_.descriptionMatch[0].start:_.labelMatch&&_.labelMatch.length&&(B=_.labelMatch[0].start),_.labelMatch&&_.labelMatch.length){if(Y=_.labelMatch[_.labelMatch.length-1].end,_.descriptionMatch&&_.descriptionMatch.length){const x=W.getItemDescription(z);x&&(Y+=x.length)}}else _.descriptionMatch&&_.descriptionMatch.length&&(Y=_.descriptionMatch[_.descriptionMatch.length-1].end);return Y-B}function M(z,_){if(!z&&!_||(!z||!z.length)&&(!_||!_.length))return 0;if(!_||!_.length)return-1;if(!z||!z.length)return 1;const W=z[0].start,Y=z[z.length-1].end-W,x=_[0].start,ie=_[_.length-1].end-x;return Y===ie?0:ie<Y?1:-1}function L(z,_,W,B){const Y=B.getItemLabel(z)||"",x=B.getItemLabel(_)||"",oe=B.getItemDescription(z),ie=B.getItemDescription(_),me=Y.length+(oe?oe.length:0),ue=x.length+(ie?ie.length:0);if(me!==ue)return me-ue;const X=B.getItemPath(z),q=B.getItemPath(_);return X&&q&&X.length!==q.length?X.length-q.length:Y!==x?(0,h.$Rr)(Y,x,W.normalized):oe&&ie&&oe!==ie?(0,h.$Rr)(oe,ie,W.normalized):X&&q&&X!==q?(0,h.$Rr)(X,q,W.normalized):0}function N(z){return z.startsWith('"')&&z.endsWith('"')}const F=" ";function V(z){typeof z!="string"&&(z="");const _=z.toLowerCase(),{pathNormalized:W,normalized:B,normalizedLowercase:Y}=j(z),x=W.indexOf(O.sep)>=0,oe=N(z);let ie;const me=z.split(F);if(me.length>1)for(const ue of me){const X=N(ue),{pathNormalized:q,normalized:se,normalizedLowercase:be}=j(ue);se&&(ie||(ie=[]),ie.push({original:ue,originalLowercase:ue.toLowerCase(),pathNormalized:q,normalized:se,normalizedLowercase:be,expectContiguousMatch:X}))}return{original:z,originalLowercase:_,pathNormalized:W,normalized:B,normalizedLowercase:Y,values:ie,containsPathSeparator:x,expectContiguousMatch:oe}}function j(z){let _;C.$j?_=z.replace(/\//g,O.sep):_=z.replace(/\\/g,O.sep);const W=(0,m.$sf)(_).replace(/\s|"/g,"");return{pathNormalized:_,normalized:W,normalizedLowercase:W.toLowerCase()}}function U(z){return Array.isArray(z)?V(z.map(_=>_.original).join(F)):V(z.original)}}),define(Re[138],Ce([1,0,136,13,51]),function(ge,e,s,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1k=m,e.$2k=I,e.$3k=g,e.$4k=P,e.$5k=a,e.$6k=$;const A="$(",O=new RegExp(`\\$\\(${R.ThemeIcon.iconNameExpression}(?:${R.ThemeIcon.iconModifierExpression})?\\)`,"g"),C=new RegExp(`(\\\\)?${O.source}`,"g");function m(p){return p.replace(C,(u,i)=>i?u:`\\${u}`)}const c=new RegExp(`\\\\${O.source}`,"g");function I(p){return p.replace(c,u=>`\\${u}`)}const E=new RegExp(`(\\s)?(\\\\)?${O.source}(\\s)?`,"g");function g(p){return p.indexOf(A)===-1?p:p.replace(E,(u,i,o,t)=>o?u:i||t||"")}function P(p){return p?p.replace(/\$\((.*?)\)/g,(u,i)=>` ${i} `).trim():""}const b=new RegExp(`\\$\\(${R.ThemeIcon.iconNameCharacter}+\\)`,"g");function a(p){b.lastIndex=0;let u="";const i=[];let o=0;for(;;){const t=b.lastIndex,n=b.exec(p),r=p.substring(t,n?.index);if(r.length>0){u+=r;for(let d=0;d<r.length;d++)i.push(o)}if(!n)break;o+=n[0].length}return{text:u,iconOffsets:i}}function $(p,u,i=!1){const{text:o,iconOffsets:t}=u;if(!t||t.length===0)return(0,s.$Rk)(p,o,i);const n=(0,h.$pf)(o," "),r=o.length-n.length,d=(0,s.$Rk)(p,n,i);if(d)for(const l of d){const f=t[l.start+r]+r;l.start+=f,l.end+=f}return d}}),define(Re[44],Ce([1,0,13]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),s=Ue(s);var h;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(h||(h={})),function(R){const A="error",O="warning",C="warn",m="info",c="ignore";function I(g){return g?s.$If(A,g)?R.Error:s.$If(O,g)||s.$If(C,g)?R.Warning:s.$If(m,g)?R.Info:R.Ignore:R.Ignore}R.fromValue=I;function E(g){switch(g){case R.Error:return A;case R.Warning:return O;case R.Info:return m;default:return c}}R.toString=E}(h||(h={})),e.default=h}),define(Re[62],Ce([1,0,18,26,13]),function(ge,e,s,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=void 0;class A{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const a=b.charCodeAt(0),$=this.b.charCodeAt(this.c);return a-$}value(){return this.b[this.c]}}e.$Ki=A;class O{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===h.CharCode.Period)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,R.$Cf)(b,this.b,0,b.length,this.c,this.d):(0,R.$Ef)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Li=O;class C{constructor(b=!0,a=!0){this.f=b,this.g=a}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let a=b.length-1;a>=0;a--,this.c--){const $=this.b.charCodeAt(a);if(!($===h.CharCode.Slash||this.f&&$===h.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const a=this.b.charCodeAt(this.e);if(a===h.CharCode.Slash||this.f&&a===h.CharCode.Backslash)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,R.$Cf)(b,this.b,0,b.length,this.d,this.e):(0,R.$Ef)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Mi=C;var m;(function(P){P[P.Scheme=1]="Scheme",P[P.Authority=2]="Authority",P[P.Path=3]="Path",P[P.Query=4]="Query",P[P.Fragment=5]="Fragment"})(m||(m={}));class c{constructor(b,a){this.f=b,this.g=a,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push(m.Scheme),this.c.authority&&this.d.push(m.Authority),this.c.path&&(this.b=new C(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push(m.Path)),this.g(b)||(this.c.query&&this.d.push(m.Query),this.c.fragment&&this.d.push(m.Fragment)),this.e=0,this}next(){return this.d[this.e]===m.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===m.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===m.Scheme)return(0,R.$Df)(b,this.c.scheme);if(this.d[this.e]===m.Authority)return(0,R.$Df)(b,this.c.authority);if(this.d[this.e]===m.Path)return this.b.cmp(b);if(this.d[this.e]===m.Query)return(0,R.$Bf)(b,this.c.query);if(this.d[this.e]===m.Fragment)return(0,R.$Bf)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===m.Scheme)return this.c.scheme;if(this.d[this.e]===m.Authority)return this.c.authority;if(this.d[this.e]===m.Path)return this.b.value();if(this.d[this.e]===m.Query)return this.c.query;if(this.d[this.e]===m.Fragment)return this.c.fragment;throw new Error}}e.$Ni=c;class I{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var E;(function(P){P[P.Left=-1]="Left",P[P.Mid=0]="Mid",P[P.Right=1]="Right"})(E||(E={}));class g{static forUris(b=()=>!1,a=()=>!1){return new g(new c(b,a))}static forPaths(b=!1){return new g(new C(void 0,!b))}static forStrings(){return new g(new A)}static forConfigKeys(){return new g(new O)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,a){if(a){const $=a.slice(0);(0,s.$Yb)($);for(const p of $)this.set(p,b)}else{const $=b.slice(0);(0,s.$Yb)($);for(const p of $)this.set(p[0],p[1])}}set(b,a){const $=this.b.reset(b);let p;this.c||(this.c=new I,this.c.segment=$.value());const u=[];for(p=this.c;;){const o=$.cmp(p.segment);if(o>0)p.left||(p.left=new I,p.left.segment=$.value()),u.push([E.Left,p]),p=p.left;else if(o<0)p.right||(p.right=new I,p.right.segment=$.value()),u.push([E.Right,p]),p=p.right;else if($.hasNext())$.next(),p.mid||(p.mid=new I,p.mid.segment=$.value()),u.push([E.Mid,p]),p=p.mid;else break}const i=p.value;p.value=a,p.key=b;for(let o=u.length-1;o>=0;o--){const t=u[o][1];t.updateHeight();const n=t.balanceFactor();if(n<-1||n>1){const r=u[o][0],d=u[o+1][0];if(r===E.Right&&d===E.Right)u[o][1]=t.rotateLeft();else if(r===E.Left&&d===E.Left)u[o][1]=t.rotateRight();else if(r===E.Right&&d===E.Left)t.right=u[o+1][1]=u[o+1][1].rotateRight(),u[o][1]=t.rotateLeft();else if(r===E.Left&&d===E.Right)t.left=u[o+1][1]=u[o+1][1].rotateLeft(),u[o][1]=t.rotateRight();else throw new Error;if(o>0)switch(u[o-1][0]){case E.Left:u[o-1][1].left=u[o][1];break;case E.Right:u[o-1][1].right=u[o][1];break;case E.Mid:u[o-1][1].mid=u[o][1];break}else this.c=u[0][1]}}return i}get(b){return this.d(b)?.value}d(b){const a=this.b.reset(b);let $=this.c;for(;$;){const p=a.cmp($.segment);if(p>0)$=$.left;else if(p<0)$=$.right;else if(a.hasNext())a.next(),$=$.mid;else break}return $}has(b){const a=this.d(b);return!(a?.value===void 0&&a?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,a){const $=this.b.reset(b),p=[];let u=this.c;for(;u;){const i=$.cmp(u.segment);if(i>0)p.push([E.Left,u]),u=u.left;else if(i<0)p.push([E.Right,u]),u=u.right;else if($.hasNext())$.next(),p.push([E.Mid,u]),u=u.mid;else break}if(u){if(a?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const i=this.f(u.right);if(i.key){const{key:o,value:t,segment:n}=i;this.e(i.key,!1),u.key=o,u.value=t,u.segment=n}}else{const i=u.left??u.right;if(p.length>0){const[o,t]=p[p.length-1];switch(o){case E.Left:t.left=i;break;case E.Mid:t.mid=i;break;case E.Right:t.right=i;break}}else this.c=i}for(let i=p.length-1;i>=0;i--){const o=p[i][1];o.updateHeight();const t=o.balanceFactor();if(t>1?(o.right.balanceFactor()>=0||(o.right=o.right.rotateRight()),p[i][1]=o.rotateLeft()):t<-1&&(o.left.balanceFactor()<=0||(o.left=o.left.rotateLeft()),p[i][1]=o.rotateRight()),i>0)switch(p[i-1][0]){case E.Left:p[i-1][1].left=p[i][1];break;case E.Right:p[i-1][1].right=p[i][1];break;case E.Mid:p[i-1][1].mid=p[i][1];break}else this.c=p[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const a=this.b.reset(b);let $=this.c,p;for(;$;){const u=a.cmp($.segment);if(u>0)$=$.left;else if(u<0)$=$.right;else if(a.hasNext())a.next(),p=$.value||p,$=$.mid;else break}return $&&$.value||p}findSuperstr(b){return this.g(b,!1)}g(b,a){const $=this.b.reset(b);let p=this.c;for(;p;){const u=$.cmp(p.segment);if(u>0)p=p.left;else if(u<0)p=p.right;else if($.hasNext())$.next(),p=p.mid;else return p.mid?this.h(p.mid):a?p.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[a,$]of this)b($,a)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const a=[];return this.j(b,a),a[Symbol.iterator]()}j(b,a){b&&(b.left&&this.j(b.left,a),b.value&&a.push([b.key,b.value]),b.mid&&this.j(b.mid,a),b.right&&this.j(b.right,a))}_isBalanced(){const b=a=>{if(!a)return!0;const $=a.balanceFactor();return $<-1||$>1?!1:b(a.left)&&b(a.right)};return b(this.c)}}e.$Oi=g}),define(Re[2],Ce([1,0,26,41,16,10]),function(ge,e,s,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$yc=$,e.$zc=n,R=Ue(R);const O=/^\w[\w\d+.-]*$/,C=/^\//,m=/^\/\//;function c(y,k){if(!y.scheme&&k)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${y.authority}", path: "${y.path}", query: "${y.query}", fragment: "${y.fragment}"}`);if(y.scheme&&!O.test(y.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(y.path){if(y.authority){if(!C.test(y.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(m.test(y.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(y,k){return!y&&!k?"file":y}function E(y,k){switch(y){case"https":case"http":case"file":k?k[0]!==P&&(k=P+k):k=P;break}return k}const g="",P="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class a{static isUri(k){return k instanceof a?!0:k?typeof k.authority=="string"&&typeof k.fragment=="string"&&typeof k.path=="string"&&typeof k.query=="string"&&typeof k.scheme=="string"&&typeof k.fsPath=="string"&&typeof k.with=="function"&&typeof k.toString=="function":!1}constructor(k,S,D,T,v,w=!1){typeof k=="object"?(this.scheme=k.scheme||g,this.authority=k.authority||g,this.path=k.path||g,this.query=k.query||g,this.fragment=k.fragment||g):(this.scheme=I(k,w),this.authority=S||g,this.path=E(this.scheme,D||g),this.query=T||g,this.fragment=v||g,c(this,w))}get fsPath(){return n(this,!1)}with(k){if(!k)return this;let{scheme:S,authority:D,path:T,query:v,fragment:w}=k;return S===void 0?S=this.scheme:S===null&&(S=g),D===void 0?D=this.authority:D===null&&(D=g),T===void 0?T=this.path:T===null&&(T=g),v===void 0?v=this.query:v===null&&(v=g),w===void 0?w=this.fragment:w===null&&(w=g),S===this.scheme&&D===this.authority&&T===this.path&&v===this.query&&w===this.fragment?this:new u(S,D,T,v,w)}static parse(k,S=!1){const D=b.exec(k);return D?new u(D[2]||g,f(D[4]||g),f(D[5]||g),f(D[7]||g),f(D[9]||g),S):new u(g,g,g,g,g)}static file(k){let S=g;if(A.$j&&(k=k.replace(/\\/g,P)),k[0]===P&&k[1]===P){const D=k.indexOf(P,2);D===-1?(S=k.substring(2),k=P):(S=k.substring(2,D),k=k.substring(D)||P)}return new u("file",S,k,g,g)}static from(k,S){return new u(k.scheme,k.authority,k.path,k.query,k.fragment,S)}static joinPath(k,...S){if(!k.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let D;return A.$j&&k.scheme==="file"?D=a.file(R.$ic.join(n(k,!0),...S)).path:D=R.$jc.join(k.path,...S),k.with({path:D})}toString(k=!1){return r(this,k)}toJSON(){return this}static revive(k){if(k){if(k instanceof a)return k;{const S=new u(k);return S._formatted=k.external??null,S._fsPath=k._sep===p?k.fsPath??null:null,S}}else return k}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=a;function $(y){return!y||typeof y!="object"?!1:typeof y.scheme=="string"&&(typeof y.authority=="string"||typeof y.authority>"u")&&(typeof y.path=="string"||typeof y.path>"u")&&(typeof y.query=="string"||typeof y.query>"u")&&(typeof y.fragment=="string"||typeof y.fragment>"u")}const p=A.$j?1:void 0;class u extends a{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=n(this,!1)),this._fsPath}toString(k=!1){return k?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const k={$mid:h.MarshalledId.Uri};return this._fsPath&&(k.fsPath=this._fsPath,k._sep=p),this._formatted&&(k.external=this._formatted),this.path&&(k.path=this.path),this.scheme&&(k.scheme=this.scheme),this.authority&&(k.authority=this.authority),this.query&&(k.query=this.query),this.fragment&&(k.fragment=this.fragment),k}}const i={[s.CharCode.Colon]:"%3A",[s.CharCode.Slash]:"%2F",[s.CharCode.QuestionMark]:"%3F",[s.CharCode.Hash]:"%23",[s.CharCode.OpenSquareBracket]:"%5B",[s.CharCode.CloseSquareBracket]:"%5D",[s.CharCode.AtSign]:"%40",[s.CharCode.ExclamationMark]:"%21",[s.CharCode.DollarSign]:"%24",[s.CharCode.Ampersand]:"%26",[s.CharCode.SingleQuote]:"%27",[s.CharCode.OpenParen]:"%28",[s.CharCode.CloseParen]:"%29",[s.CharCode.Asterisk]:"%2A",[s.CharCode.Plus]:"%2B",[s.CharCode.Comma]:"%2C",[s.CharCode.Semicolon]:"%3B",[s.CharCode.Equals]:"%3D",[s.CharCode.Space]:"%20"};function o(y,k,S){let D,T=-1;for(let v=0;v<y.length;v++){const w=y.charCodeAt(v);if(w>=s.CharCode.a&&w<=s.CharCode.z||w>=s.CharCode.A&&w<=s.CharCode.Z||w>=s.CharCode.Digit0&&w<=s.CharCode.Digit9||w===s.CharCode.Dash||w===s.CharCode.Period||w===s.CharCode.Underline||w===s.CharCode.Tilde||k&&w===s.CharCode.Slash||S&&w===s.CharCode.OpenSquareBracket||S&&w===s.CharCode.CloseSquareBracket||S&&w===s.CharCode.Colon)T!==-1&&(D+=encodeURIComponent(y.substring(T,v)),T=-1),D!==void 0&&(D+=y.charAt(v));else{D===void 0&&(D=y.substr(0,v));const M=i[w];M!==void 0?(T!==-1&&(D+=encodeURIComponent(y.substring(T,v)),T=-1),D+=M):T===-1&&(T=v)}}return T!==-1&&(D+=encodeURIComponent(y.substring(T))),D!==void 0?D:y}function t(y){let k;for(let S=0;S<y.length;S++){const D=y.charCodeAt(S);D===s.CharCode.Hash||D===s.CharCode.QuestionMark?(k===void 0&&(k=y.substr(0,S)),k+=i[D]):k!==void 0&&(k+=y[S])}return k!==void 0?k:y}function n(y,k){let S;return y.authority&&y.path.length>1&&y.scheme==="file"?S=`//${y.authority}${y.path}`:y.path.charCodeAt(0)===s.CharCode.Slash&&(y.path.charCodeAt(1)>=s.CharCode.A&&y.path.charCodeAt(1)<=s.CharCode.Z||y.path.charCodeAt(1)>=s.CharCode.a&&y.path.charCodeAt(1)<=s.CharCode.z)&&y.path.charCodeAt(2)===s.CharCode.Colon?k?S=y.path.substr(1):S=y.path[1].toLowerCase()+y.path.substr(2):S=y.path,A.$j&&(S=S.replace(/\//g,"\\")),S}function r(y,k){const S=k?t:o;let D="",{scheme:T,authority:v,path:w,query:M,fragment:L}=y;if(T&&(D+=T,D+=":"),(v||T==="file")&&(D+=P,D+=P),v){let N=v.indexOf("@");if(N!==-1){const F=v.substr(0,N);v=v.substr(N+1),N=F.lastIndexOf(":"),N===-1?D+=S(F,!1,!1):(D+=S(F.substr(0,N),!1,!1),D+=":",D+=S(F.substr(N+1),!1,!0)),D+="@"}v=v.toLowerCase(),N=v.lastIndexOf(":"),N===-1?D+=S(v,!1,!0):(D+=S(v.substr(0,N),!1,!0),D+=v.substr(N))}if(w){if(w.length>=3&&w.charCodeAt(0)===s.CharCode.Slash&&w.charCodeAt(2)===s.CharCode.Colon){const N=w.charCodeAt(1);N>=s.CharCode.A&&N<=s.CharCode.Z&&(w=`/${String.fromCharCode(N+32)}:${w.substr(3)}`)}else if(w.length>=2&&w.charCodeAt(1)===s.CharCode.Colon){const N=w.charCodeAt(0);N>=s.CharCode.A&&N<=s.CharCode.Z&&(w=`${String.fromCharCode(N+32)}:${w.substr(2)}`)}D+=S(w,!0,!1)}return M&&(D+="?",D+=S(M,!1,!1)),L&&(D+="#",D+=k?L:o(L,!1,!1)),D}function d(y){try{return decodeURIComponent(y)}catch{return y.length>3?y.substr(0,3)+d(y.substr(3)):y}}const l=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function f(y){return y.match(l)?y.replace(l,k=>d(k)):y}}),define(Re[191],Ce([1,0,2]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=h,e.$kr=R,e.$lr=A,e.log=C;function h(c){const I=c;return I&&typeof I.type=="string"&&typeof I.severity=="string"}function R(c){const I=[];let E;try{const g=JSON.parse(c.arguments),P=g[g.length-1];P&&P.__$stack&&(g.pop(),E=P.__$stack),I.push(...g)}catch{I.push("Unable to log remote console arguments",c.arguments)}return{args:I,stack:E}}function A(c){if(typeof c!="string")return A(R(c).stack);const I=c;if(I){const E=O(I),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(g&&g.length===4)return{uri:s.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}function O(c){if(!c)return c;const I=c.indexOf(`
`);return I===-1?c:c.substring(0,I)}function C(c,I){const{args:E,stack:g}=R(c),P=typeof E[0]=="string"&&E.length===1;let b=O(g);b&&(b=`(${b.trim()})`);let a=[];if(typeof E[0]=="string"?b&&P?a=[`%c[${I}] %c${E[0]} %c${b}`,m("blue"),m(""),m("grey")]:a=[`%c[${I}] %c${E[0]}`,m("blue"),m(""),...E.slice(1)]:a=[`%c[${I}]%`,m("blue"),...E],b&&!P&&a.push(b),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,a)}function m(c){return`color: ${c}`}}),define(Re[38],Ce([1,0,21,2,41]),function(ge,e,s,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=A,e.$ei=O,e.$fi=m;function A(c){return JSON.stringify(c,C)}function O(c){let I=JSON.parse(c);return I=m(I),I}function C(c,I){return I instanceof RegExp?{$mid:R.MarshalledId.Regexp,source:I.source,flags:I.flags}:I}function m(c,I=0){if(!c||I>200)return c;if(typeof c=="object"){switch(c.$mid){case R.MarshalledId.Uri:return h.URI.revive(c);case R.MarshalledId.Regexp:return new RegExp(c.source,c.flags);case R.MarshalledId.Date:return new Date(c.source)}if(c instanceof s.$Qe||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let E=0;E<c.length;++E)c[E]=m(c[E],I+1);else for(const E in c)Object.hasOwnProperty.call(c,E)&&(c[E]=m(c[E],I+1))}return c}}),define(Re[14],Ce([1,0,12,10,13,2,16]),function(ge,e,s,h,R,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Vg=e.$Ug=e.$Tg=e.Schemas=void 0,e.$Rg=m,e.$Sg=c,e.$Wg=E,s=Ue(s),h=Ue(h),O=Ue(O);var C;(function(b){b.inMemory="inmemory",b.vscode="vscode",b.internal="private",b.walkThrough="walkThrough",b.walkThroughSnippet="walkThroughSnippet",b.http="http",b.https="https",b.file="file",b.mailto="mailto",b.untitled="untitled",b.data="data",b.command="command",b.vscodeRemote="vscode-remote",b.vscodeRemoteResource="vscode-remote-resource",b.vscodeManagedRemoteResource="vscode-managed-remote-resource",b.vscodeUserData="vscode-userdata",b.vscodeCustomEditor="vscode-custom-editor",b.vscodeNotebookCell="vscode-notebook-cell",b.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",b.vscodeNotebookCellMetadataDiff="vscode-notebook-cell-metadata-diff",b.vscodeNotebookCellOutput="vscode-notebook-cell-output",b.vscodeNotebookCellOutputDiff="vscode-notebook-cell-output-diff",b.vscodeInteractiveInput="vscode-interactive-input",b.vscodeSettings="vscode-settings",b.vscodeWorkspaceTrust="vscode-workspace-trust",b.vscodeTerminal="vscode-terminal",b.vscodeChatCodeBlock="vscode-chat-code-block",b.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",b.vscodeChatSesssion="vscode-chat-editor",b.webviewPanel="webview-panel",b.vscodeWebview="vscode-webview",b.extension="extension",b.vscodeFileResource="vscode-file",b.tmp="tmp",b.vsls="vsls",b.vscodeSourceControl="vscode-scm",b.commentsInput="comment",b.codeSetting="code-setting",b.outputChannel="output"})(C||(e.Schemas=C={}));function m(b,a){return A.URI.isUri(b)?(0,R.$If)(b.scheme,a):(0,R.$Jf)(b,a+":")}function c(b,...a){return a.some($=>m(b,$))}e.$Tg="vscode-tkn",e.$Ug="tkn";class I{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(a){this.d=a}setDelegate(a){this.e=a}setServerRootPath(a,$){this.f=E(a,$)}getServerRootPath(){return this.f}get g(){return O.$jc.join(this.f,C.vscodeRemoteResource)}set(a,$,p){this.a[a]=$,this.b[a]=p}setConnectionToken(a,$){this.c[a]=$}getPreferredWebSchema(){return this.d}rewrite(a){if(this.e)try{return this.e(a)}catch(t){return s.$2(t),a}const $=a.authority;let p=this.a[$];p&&p.indexOf(":")!==-1&&p.indexOf("[")===-1&&(p=`[${p}]`);const u=this.b[$],i=this.c[$];let o=`path=${encodeURIComponent(a.path)}`;return typeof i=="string"&&(o+=`&${e.$Ug}=${encodeURIComponent(i)}`),A.URI.from({scheme:h.$p?this.d:C.vscodeRemoteResource,authority:`${p}:${u}`,path:this.g,query:o})}}e.$Vg=new I;function E(b,a){return O.$jc.join(a??"/",`${b.quality??"oss"}-${b.commit??"dev"}`)}e.$Xg="vs/../../extensions",e.$Yg="vs/../../node_modules",e.$Zg="vs/../../node_modules.asar",e.$1g="vs/../../node_modules.asar.unpacked",e.$2g="vscode-app";class g{static{this.a=e.$2g}asBrowserUri(a){const $=this.b(a,ge);return this.uriToBrowserUri($)}uriToBrowserUri(a){return a.scheme===C.vscodeRemote?e.$Vg.rewrite(a):a.scheme===C.file&&(h.$n||h.$r===`${C.vscodeFileResource}://${g.a}`)?a.with({scheme:C.vscodeFileResource,authority:a.authority||g.a,query:null,fragment:null}):a}asFileUri(a){const $=this.b(a,ge);return this.uriToFileUri($)}uriToFileUri(a){return a.scheme===C.vscodeFileResource?a.with({scheme:C.file,authority:a.authority!==g.a?a.authority:null,query:null,fragment:null}):a}b(a,$){if(A.URI.isUri(a))return a;if(globalThis._VSCODE_FILE_ROOT){const p=globalThis._VSCODE_FILE_ROOT;if(/^\w[\w\d+.-]*:\/\//.test(p))return A.URI.joinPath(A.URI.parse(p,!0),a);const u=O.$mc(p,a);return A.URI.file(u)}return A.URI.parse($.toUrl(a))}}e.$3g=new g;var P;(function(b){const a=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);b.CoopAndCoep=Object.freeze(a.get("3"));const $="vscode-coi";function p(i){let o;typeof i=="string"?o=new URL(i).searchParams:i instanceof URL?o=i.searchParams:A.URI.isUri(i)&&(o=new URL(i.toString(!0)).searchParams);const t=o?.get($);if(t)return a.get(t)}b.getHeadersFromQuery=p;function u(i,o,t){if(!globalThis.crossOriginIsolated)return;const n=o&&t?"3":t?"2":"1";i instanceof URLSearchParams?i.set($,n):i[$]=n}b.addSearchParam=u})(P||(e.COI=P={}))}),define(Re[139],Ce([1,0,131,14,10,17,2]),function(ge,e,s,h,R,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=E,e.$yq=g,R=Ue(R);class C{constructor(b,a,$){this.id=b,this.dependencies=a,this.callback=$}}class m{static{this.INSTANCE=new m}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){if(!this.d){this.d=!0,globalThis.define=(b,a,$)=>{typeof b!="string"&&($=a,a=b,b=null),(typeof a!="object"||!Array.isArray(a))&&($=a,a=null),this.c.push(new C(b,a,$))},globalThis.define.amd=!0;try{this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){if(b.startsWith(window.location.origin)||b.startsWith("vscode-file://vscode-app"))return b;throw new Error(`[trusted_script_src] Invalid script url: ${b}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){return b}}))}catch(b){console.warn(b)}}}async load(b){this.g();const a=await(this.a?this.i(b):this.b?this.h(b):this.j(b));if(!a){console.warn(`Did not receive a define call from script ${b}`);return}if(Array.isArray(a.dependencies)&&a.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${b}. The dependencies are: ${a.dependencies.join(", ")}`);return typeof a.callback=="function"?a.callback([]):a.callback}h(b){return new Promise((a,$)=>{const p=document.createElement("script");p.setAttribute("async","async"),p.setAttribute("type","text/javascript");const u=()=>{p.removeEventListener("load",i),p.removeEventListener("error",o)},i=t=>{u(),a(this.c.pop())},o=t=>{u(),$(t)};p.addEventListener("load",i),p.addEventListener("error",o),this.f&&(b=this.f.createScriptURL(b)),p.setAttribute("src",b),window.document.getElementsByTagName("head")[0].appendChild(p)})}async i(b){return this.f&&(b=this.f.createScriptURL(b)),s.$T?await new Promise((a,$)=>{ge([b],a,$)}).then(Ue):importScripts(b),this.c.pop()}async j(b){try{const a=globalThis._VSCODE_NODE_MODULES.fs,$=globalThis._VSCODE_NODE_MODULES.vm,p=globalThis._VSCODE_NODE_MODULES.module,u=O.URI.parse(b).fsPath,i=a.readFileSync(u).toString(),o=p.wrap(i.replace(/^#!.*/,""));return new $.Script(o).runInThisContext().apply(),this.c.pop()}catch(a){throw a}}}const c=new Map;let I={};typeof globalThis.require=="object"&&(I=globalThis.require.paths??{});async function E(P,b,a){if(s.$T){a===void 0&&(a=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),I[P]&&(P=I[P]);const $=b?`${P}/${b}`:P;if(c.has($))return c.get($);let p;if(/^\w[\w\d+.-]*:\/\//.test($))p=$;else{const t=`${s.$U&&a&&!R.$p?h.$Zg:h.$Yg}/${$}`;p=h.$3g.asBrowserUri(t).toString(!0)}const u=m.INSTANCE.load(p);return c.set($,u),u}else return await new Promise(($,p)=>{ge([P],$,p)}).then(Ue)}function g(P,b){(0,A.$rg)(s.$T);const $=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit,p=s.$U&&$&&!R.$p,u=`${P}/${b}`,o=`${p?h.$Zg:h.$Yg}/${u}`;return h.$3g.asBrowserUri(o).toString(!0)}}),define(Re[22],Ce([1,0,26,31,14,16,10,13,2]),function(ge,e,s,h,R,A,O,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=void 0,e.$0g=c,e.$sh=E,e.$th=P,h=Ue(h),A=Ue(A);function c(b){return(0,m.$zc)(b,!0)}class I{constructor(a){this.a=a}compare(a,$,p=!1){return a===$?0:(0,C.$Bf)(this.getComparisonKey(a,p),this.getComparisonKey($,p))}isEqual(a,$,p=!1){return a===$?!0:!a||!$?!1:this.getComparisonKey(a,p)===this.getComparisonKey($,p)}getComparisonKey(a,$=!1){return a.with({path:this.a(a)?a.path.toLowerCase():void 0,fragment:$?null:void 0}).toString()}ignorePathCasing(a){return this.a(a)}isEqualOrParent(a,$,p=!1){if(a.scheme===$.scheme){if(a.scheme===R.Schemas.file)return h.$Hg(c(a),c($),this.a(a))&&a.query===$.query&&(p||a.fragment===$.fragment);if((0,e.$oh)(a.authority,$.authority))return h.$Hg(a.path,$.path,this.a(a),"/")&&a.query===$.query&&(p||a.fragment===$.fragment)}return!1}joinPath(a,...$){return m.URI.joinPath(a,...$)}basenameOrAuthority(a){return(0,e.$gh)(a)||a.authority}basename(a){return A.$jc.basename(a.path)}extname(a){return A.$jc.extname(a.path)}dirname(a){if(a.path.length===0)return a;let $;return a.scheme===R.Schemas.file?$=m.URI.file(A.$pc(c(a))).path:($=A.$jc.dirname(a.path),a.authority&&$.length&&$.charCodeAt(0)!==s.CharCode.Slash&&(console.error(`dirname("${a.toString})) resulted in a relative path`),$="/")),a.with({path:$})}normalizePath(a){if(!a.path.length)return a;let $;return a.scheme===R.Schemas.file?$=m.URI.file(A.$kc(c(a))).path:$=A.$jc.normalize(a.path),a.with({path:$})}relativePath(a,$){if(a.scheme!==$.scheme||!(0,e.$oh)(a.authority,$.authority))return;if(a.scheme===R.Schemas.file){const i=A.$oc(c(a),c($));return O.$j?h.$Bg(i):i}let p=a.path||"/";const u=$.path||"/";if(this.a(a)){let i=0;for(const o=Math.min(p.length,u.length);i<o&&!(p.charCodeAt(i)!==u.charCodeAt(i)&&p.charAt(i).toLowerCase()!==u.charAt(i).toLowerCase());i++);p=u.substr(0,i)+p.substr(i)}return A.$jc.relative(p,u)}resolvePath(a,$){if(a.scheme===R.Schemas.file){const p=m.URI.file(A.$nc(c(a),$));return a.with({authority:p.authority,path:p.path})}return $=h.$Cg($),a.with({path:A.$jc.resolve(a.path,$)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,$){return a===$||a!==void 0&&$!==void 0&&(0,C.$If)(a,$)}hasTrailingPathSeparator(a,$=A.sep){if(a.scheme===R.Schemas.file){const p=c(a);return p.length>h.$Dg(p).length&&p[p.length-1]===$}else{const p=a.path;return p.length>1&&p.charCodeAt(p.length-1)===s.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,$=A.sep){return(0,e.$ph)(a,$)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,$=A.sep){let p=!1;if(a.scheme===R.Schemas.file){const u=c(a);p=u!==void 0&&u.length===h.$Dg(u).length&&u[u.length-1]===$}else{$="/";const u=a.path;p=u.length===1&&u.charCodeAt(u.length-1)===s.CharCode.Slash}return!p&&!(0,e.$ph)(a,$)?a.with({path:a.path+"/"}):a}}e.$$g=I,e.$_g=new I(()=>!1),e.$ah=new I(b=>b.scheme===R.Schemas.file?!O.$l:!0),e.$bh=new I(b=>!0),e.$ch=e.$_g.isEqual.bind(e.$_g),e.$dh=e.$_g.isEqualOrParent.bind(e.$_g),e.$eh=e.$_g.getComparisonKey.bind(e.$_g),e.$fh=e.$_g.basenameOrAuthority.bind(e.$_g),e.$gh=e.$_g.basename.bind(e.$_g),e.$hh=e.$_g.extname.bind(e.$_g),e.$ih=e.$_g.dirname.bind(e.$_g),e.$jh=e.$_g.joinPath.bind(e.$_g),e.$kh=e.$_g.normalizePath.bind(e.$_g),e.$lh=e.$_g.relativePath.bind(e.$_g),e.$mh=e.$_g.resolvePath.bind(e.$_g),e.$nh=e.$_g.isAbsolutePath.bind(e.$_g),e.$oh=e.$_g.isEqualAuthority.bind(e.$_g),e.$ph=e.$_g.hasTrailingPathSeparator.bind(e.$_g),e.$qh=e.$_g.removeTrailingPathSeparator.bind(e.$_g),e.$rh=e.$_g.addTrailingPathSeparator.bind(e.$_g);function E(b,a){const $=[];for(let p=0;p<b.length;p++){const u=a(b[p]);b.some((i,o)=>o===p?!1:(0,e.$dh)(u,a(i)))||$.push(b[p])}return $}var g;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function a($){const p=new Map;$.path.substring($.path.indexOf(";")+1,$.path.lastIndexOf(";")).split(";").forEach(o=>{const[t,n]=o.split(":");t&&n&&p.set(t,n)});const i=$.path.substring(0,$.path.indexOf(";"));return i&&p.set(b.META_DATA_MIME,i),p}b.parseMetaData=a})(g||(e.DataUri=g={}));function P(b,a,$){if(a){let p=b.path;return p&&p[0]!==A.$jc.sep&&(p=A.$jc.sep+p),b.with({scheme:$,authority:a,path:p})}return b.with({scheme:$})}}),define(Re[7],Ce([1,0,20,12,4,3,22,10,189,50]),function(ge,e,s,h,R,A,O,C,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=e.$0h=e.$9h=e.$8h=e.$7h=e.Promises=e.$6h=e.$5h=e.$4h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=void 0,e.$uh=I,e.$vh=E,e.$wh=g,e.$xh=P,e.$yh=b,e.$zh=a,e.$Ah=$,e.$Bh=p,e.$Jh=y,e.$Kh=k,e.$Lh=S,e.$Mh=D,e.$Nh=T,e.$3h=B,e.$$h=ae;function I($e){return!!$e&&typeof $e.then=="function"}function E($e){const pe=new s.$ze,Ae=$e(pe.token),je=new Promise((He,Ye)=>{const xe=pe.token.onCancellationRequested(()=>{xe.dispose(),Ye(new h.$7)});Promise.resolve(Ae).then(Fe=>{xe.dispose(),pe.dispose(),He(Fe)},Fe=>{xe.dispose(),pe.dispose(),Ye(Fe)})});return new class{cancel(){pe.cancel(),pe.dispose()}then(He,Ye){return je.then(He,Ye)}catch(He){return this.then(void 0,He)}finally(He){return je.finally(He)}}}function g($e,pe,Ae){return new Promise((je,He)=>{const Ye=pe.onCancellationRequested(()=>{Ye.dispose(),je(Ae)});$e.then(je,He).finally(()=>Ye.dispose())})}function P($e,pe){return new Promise((Ae,je)=>{const He=pe.onCancellationRequested(()=>{He.dispose(),je(new h.$7)});$e.then(Ae,je).finally(()=>He.dispose())})}async function b($e){let pe=-1;const Ae=$e.map((je,He)=>je.then(Ye=>(pe=He,Ye)));try{return await Promise.race(Ae)}finally{$e.forEach((je,He)=>{He!==pe&&je.cancel()})}}function a($e,pe,Ae){let je;const He=setTimeout(()=>{je?.(void 0),Ae?.()},pe);return Promise.race([$e.finally(()=>clearTimeout(He)),new Promise(Ye=>je=Ye)])}function $($e){return new Promise((pe,Ae)=>{const je=$e();I(je)?je.then(pe,Ae):pe(je)})}function p(){let $e,pe;return{promise:new Promise((je,He)=>{$e=je,pe=He}),resolve:$e,reject:pe}}class u{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(pe){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=pe,!this.b){const Ae=()=>{if(this.b=null,this.f)return;const je=this.queue(this.d);return this.d=null,je};this.b=new Promise(je=>{this.a.then(Ae,Ae).then(je)})}return new Promise((Ae,je)=>{this.b.then(Ae,je)})}return this.a=pe(),new Promise((Ae,je)=>{this.a.then(He=>{this.a=null,Ae(He)},He=>{this.a=null,je(He)})})}dispose(){this.f=!0}}e.$Ch=u;class i{constructor(){this.a=Promise.resolve(null)}queue(pe){return this.a=this.a.then(()=>pe(),()=>pe())}}e.$Dh=i;class o{constructor(){this.a=new Map}queue(pe,Ae){const He=(this.a.get(pe)??Promise.resolve()).catch(()=>{}).then(Ae).finally(()=>{this.a.get(pe)===He&&this.a.delete(pe)});return this.a.set(pe,He),He}}e.$Eh=o;const t=($e,pe)=>{let Ae=!0;const je=setTimeout(()=>{Ae=!1,pe()},$e);return{isTriggered:()=>Ae,dispose:()=>{clearTimeout(je),Ae=!1}}},n=$e=>{let pe=!0;return queueMicrotask(()=>{pe&&(pe=!1,$e())}),{isTriggered:()=>pe,dispose:()=>{pe=!1}}};class r{constructor(pe){this.defaultDelay=pe,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(pe,Ae=this.defaultDelay){this.g=pe,this.h(),this.b||(this.b=new Promise((He,Ye)=>{this.d=He,this.f=Ye}).then(()=>{if(this.b=null,this.d=null,this.g){const He=this.g;return this.g=null,He()}}));const je=()=>{this.a=null,this.d?.(null)};return this.a=Ae===m.$je?n(je):t(Ae,je),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new h.$7),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Fh=r;class d{constructor(pe){this.a=new r(pe),this.b=new u}trigger(pe,Ae){return this.a.trigger(()=>this.b.queue(pe),Ae)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Gh=d;class l{constructor(){this.a=!1,this.b=new Promise((pe,Ae)=>{this.d=pe})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Hh=l;class f extends l{constructor(pe){super(),this.f=setTimeout(()=>this.open(),pe)}open(){clearTimeout(this.f),super.open()}}e.$Ih=f;function y($e,pe){return pe?new Promise((Ae,je)=>{const He=setTimeout(()=>{Ye.dispose(),Ae()},$e),Ye=pe.onCancellationRequested(()=>{clearTimeout(He),Ye.dispose(),je(new h.$7)})}):E(Ae=>y($e,Ae))}function k($e,pe=0,Ae){const je=setTimeout(()=>{$e(),Ae&&He.dispose()},pe),He=(0,A.$Vc)(()=>{clearTimeout(je),Ae?.deleteAndLeak(He)});return Ae?.add(He),He}function S($e){const pe=[];let Ae=0;const je=$e.length;function He(){return Ae<je?$e[Ae++]():null}function Ye(xe){xe!=null&&pe.push(xe);const Fe=He();return Fe?Fe.then(Ye):Promise.resolve(pe)}return Promise.resolve(null).then(Ye)}function D($e,pe=je=>!!je,Ae=null){let je=0;const He=$e.length,Ye=()=>{if(je>=He)return Promise.resolve(Ae);const xe=$e[je++];return Promise.resolve(xe()).then(We=>pe(We)?Promise.resolve(We):Ye())};return Ye()}function T($e,pe=je=>!!je,Ae=null){if($e.length===0)return Promise.resolve(Ae);let je=$e.length;const He=()=>{je=-1;for(const Ye of $e)Ye.cancel?.()};return new Promise((Ye,xe)=>{for(const Fe of $e)Fe.then(We=>{--je>=0&&pe(We)?(He(),Ye(We)):je===0&&Ye(Ae)}).catch(We=>{--je>=0&&(He(),xe(We))})})}class v{constructor(pe){this.a=0,this.b=!1,this.f=pe,this.g=[],this.d=0,this.h=new R.$oe}whenIdle(){return this.size>0?R.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(pe){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Ae,je)=>{this.g.push({factory:pe,c:Ae,e:je}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const pe=this.g.shift();this.d++;const Ae=pe.factory();Ae.then(pe.c,pe.e),Ae.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Oh=v;class w extends v{constructor(){super(1)}}e.$Ph=w;class M{constructor(){this.a=new Y,this.b=0}queue(pe){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,pe())):this.a.run(this.b++,pe())}}e.$Qh=M;class L{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const pe=new ie;return this.b.add(pe),pe.p}g(){for(const[,pe]of this.a)if(pe.size>0)return!1;return!0}queueSize(pe,Ae=O.$_g){const je=Ae.getComparisonKey(pe);return this.a.get(je)?.size??0}queueFor(pe,Ae,je=O.$_g){const He=je.getComparisonKey(pe);let Ye=this.a.get(He);if(!Ye){Ye=new w;const xe=this.f++,Fe=R.Event.once(Ye.onDrained)(()=>{Ye?.dispose(),this.a.delete(He),this.h(),this.d?.deleteAndDispose(xe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$7c),this.d.set(xe,Fe),this.a.set(He,Ye)}return Ye.queue(Ae)}h(){this.g()&&this.j()}j(){for(const pe of this.b)pe.complete();this.b.clear()}dispose(){for(const[,pe]of this.a)pe.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Rh=L;class N{constructor(pe,Ae){this.b=!1,this.a=-1,typeof pe=="function"&&typeof Ae=="number"&&this.setIfNotSet(pe,Ae)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(pe,Ae){if(this.b)throw new h.$eb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,pe()},Ae)}setIfNotSet(pe,Ae){if(this.b)throw new h.$eb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,pe()},Ae))}}e.$Sh=N;class F{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(pe,Ae,je=globalThis){if(this.f)throw new h.$eb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const He=je.setInterval(()=>{pe()},Ae);this.d=(0,A.$Vc)(()=>{je.clearInterval(He),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Th=F;class V{constructor(pe,Ae){this.b=-1,this.a=pe,this.d=Ae,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(pe=this.d){this.cancel(),this.b=setTimeout(this.f,pe)}get delay(){return this.d}set delay(pe){this.d=pe}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Uh=V;class j{constructor(pe,Ae){Ae%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Ae}ms is not a multiple of 1000ms.`),this.a=pe,this.b=Ae,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(pe=this.b){pe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${pe}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(pe/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Vh=j;class U extends V{constructor(pe,Ae){super(pe,Ae),this.j=[]}work(pe){this.j.push(pe),this.isScheduled()||this.schedule()}h(){const pe=this.j;this.j=[],this.a?.(pe)}dispose(){this.j=[],super.dispose()}}e.$Wh=U;class z extends A.$Xc{constructor(pe,Ae){super(),this.g=pe,this.h=Ae,this.a=[],this.b=this.B(new A.$Yc),this.f=!1}get pending(){return this.a.length}work(pe){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+pe.length>this.g.maxBufferedWork)return!1}else if(this.pending+pe.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Ae of pe)this.a.push(Ae);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new V(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Xh=z,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Zh=($e,pe)=>{(0,C.$C)(()=>{if(Ae)return;const je=Date.now()+15;pe(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,je-Date.now())}}))});let Ae=!1;return{dispose(){Ae||(Ae=!0)}}}:e.$Zh=($e,pe,Ae)=>{const je=$e.requestIdleCallback(pe,typeof Ae=="number"?{timeout:Ae}:void 0);let He=!1;return{dispose(){He||(He=!0,$e.cancelIdleCallback(je))}}},e.$Yh=$e=>(0,e.$Zh)(globalThis,$e)}();class _{constructor(pe,Ae){this.g=!1,this.d=()=>{try{this.j=Ae()}catch(je){this.l=je}finally{this.g=!0}},this.f=(0,e.$Zh)(pe,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$1h=_;class W extends _{constructor(pe){super(globalThis,pe)}}e.$2h=W;async function B($e,pe,Ae){let je;for(let He=0;He<Ae;He++)try{return await $e()}catch(Ye){je=Ye,await y(pe)}throw je}class Y{isRunning(pe){return typeof pe=="number"?this.a?.taskId===pe:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(pe,Ae,je){return this.a={taskId:pe,cancel:()=>je?.(),promise:Ae},Ae.then(()=>this.d(pe),()=>this.d(pe)),Ae}d(pe){this.a&&pe===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const pe=this.b;this.b=void 0,pe.run().then(pe.promiseResolve,pe.promiseReject)}}queue(pe){if(this.b)this.b.run=pe;else{const{promise:Ae,resolve:je,reject:He}=p();this.b={run:pe,promise:Ae,promiseResolve:je,promiseReject:He}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$4h=Y;class x{constructor(pe,Ae=()=>Date.now()){this.d=pe,this.f=Ae,this.a=0,this.b=0}increment(){const pe=this.f();return pe-this.a>this.d&&(this.a=pe,this.b=0),this.b++,this.b}}e.$5h=x;var oe;(function($e){$e[$e.Resolved=0]="Resolved",$e[$e.Rejected=1]="Rejected"})(oe||(oe={}));class ie{get isRejected(){return this.d?.outcome===oe.Rejected}get isResolved(){return this.d?.outcome===oe.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===oe.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((pe,Ae)=>{this.a=pe,this.b=Ae})}complete(pe){return new Promise(Ae=>{this.a(pe),this.d={outcome:oe.Resolved,value:pe},Ae()})}error(pe){return new Promise(Ae=>{this.b(pe),this.d={outcome:oe.Rejected,value:pe},Ae()})}cancel(){return this.error(new h.$7)}}e.$6h=ie;var me;(function($e){async function pe(je){let He;const Ye=await Promise.all(je.map(xe=>xe.then(Fe=>Fe,Fe=>{He||(He=Fe)})));if(typeof He<"u")throw He;return Ye}$e.settled=pe;function Ae(je){return new Promise(async(He,Ye)=>{try{await je(He,Ye)}catch(xe){Ye(xe)}})}$e.withAsyncBody=Ae})(me||(e.Promises=me={}));class ue{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(pe){this.a=void 0,this.b=void 0,this.d=!1,this.promise=pe.then(Ae=>(this.a=Ae,this.d=!0,Ae),Ae=>{throw this.b=Ae,this.d=!0,Ae})}requireValue(){if(!this.d)throw new h.$eb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$7h=ue;class X{constructor(pe){this.b=pe,this.a=new c.$W(()=>new ue(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$8h=X;var q;(function($e){$e[$e.Initial=0]="Initial",$e[$e.DoneOK=1]="DoneOK",$e[$e.DoneError=2]="DoneError"})(q||(q={}));class se{static fromArray(pe){return new se(Ae=>{Ae.emitMany(pe)})}static fromPromise(pe){return new se(async Ae=>{Ae.emitMany(await pe)})}static fromPromises(pe){return new se(async Ae=>{await Promise.all(pe.map(async je=>Ae.emitOne(await je)))})}static merge(pe){return new se(async Ae=>{await Promise.all(pe.map(async je=>{for await(const He of je)Ae.emitOne(He)}))})}static{this.EMPTY=se.fromArray([])}constructor(pe,Ae){this.a=q.Initial,this.b=[],this.d=null,this.f=Ae,this.g=new R.$oe,queueMicrotask(async()=>{const je={emitOne:He=>this.h(He),emitMany:He=>this.j(He),reject:He=>this.l(He)};try{await Promise.resolve(pe(je)),this.k()}catch(He){this.l(He)}finally{je.emitOne=void 0,je.emitMany=void 0,je.reject=void 0}})}[Symbol.asyncIterator](){let pe=0;return{next:async()=>{do{if(this.a===q.DoneError)throw this.d;if(pe<this.b.length)return{done:!1,value:this.b[pe++]};if(this.a===q.DoneOK)return{done:!0,value:void 0};await R.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(pe,Ae){return new se(async je=>{for await(const He of pe)je.emitOne(Ae(He))})}map(pe){return se.map(this,pe)}static filter(pe,Ae){return new se(async je=>{for await(const He of pe)Ae(He)&&je.emitOne(He)})}filter(pe){return se.filter(this,pe)}static coalesce(pe){return se.filter(pe,Ae=>!!Ae)}coalesce(){return se.coalesce(this)}static async toPromise(pe){const Ae=[];for await(const je of pe)Ae.push(je);return Ae}toPromise(){return se.toPromise(this)}h(pe){this.a===q.Initial&&(this.b.push(pe),this.g.fire())}j(pe){this.a===q.Initial&&(this.b=this.b.concat(pe),this.g.fire())}k(){this.a===q.Initial&&(this.a=q.DoneOK,this.g.fire())}l(pe){this.a===q.Initial&&(this.a=q.DoneError,this.d=pe,this.g.fire())}}e.$9h=se;class be extends se{constructor(pe,Ae){super(Ae),this.m=pe}cancel(){this.m.cancel()}}e.$0h=be;function ae($e){const pe=new s.$ze,Ae=$e(pe.token);return new be(pe,async je=>{const He=pe.token.onCancellationRequested(()=>{He.dispose(),pe.dispose(),je.reject(new h.$7)});try{for await(const Ye of Ae){if(pe.token.isCancellationRequested)return;je.emitOne(Ye)}He.dispose(),pe.dispose()}catch(Ye){He.dispose(),pe.dispose(),je.reject(Ye)}})}class we{constructor(pe){this.a=new ie,this.b=new se(He=>{if(Ae){He.reject(Ae);return}return je&&He.emitMany(je),this.d=Ye=>He.reject(Ye),this.f=Ye=>He.emitOne(Ye),this.a.p},pe);let Ae,je;this.f=He=>{je||(je=[]),je.push(He)},this.d=He=>{Ae||(Ae=He)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(pe){this.d(pe),this.a.complete()}emitOne(pe){this.f(pe)}}e.$_h=we}),define(Re[39],Ce([1,0,18,7,26,31,28,16,10,13]),function(ge,e,s,h,R,A,O,C,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=e.$zk=void 0,e.$yk=I,e.$Bk=a,e.$Ck=M,e.$Dk=L,e.$Ek=N,e.$Fk=F,e.$Gk=V,e.$Hk=_;function I(){return Object.create(null)}e.$zk="**",e.$Ak="/";const E="[/\\\\]",g="[^/\\\\]",P=/\//g;function b(W,B){switch(W){case 0:return"";case 1:return`${g}*?`;default:return`(?:${E}|${g}+${E}${B?`|${E}${g}+`:""})*?`}}function a(W,B){if(!W)return[];const Y=[];let x=!1,oe=!1,ie="";for(const me of W){switch(me){case B:if(!x&&!oe){Y.push(ie),ie="";continue}break;case"{":x=!0;break;case"}":x=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}ie+=me}return ie&&Y.push(ie),Y}function $(W){if(!W)return"";let B="";const Y=a(W,e.$Ak);if(Y.every(x=>x===e.$zk))B=".*";else{let x=!1;Y.forEach((oe,ie)=>{if(oe===e.$zk){if(x)return;B+=b(2,ie===Y.length-1)}else{let me=!1,ue="",X=!1,q="";for(const se of oe){if(se!=="}"&&me){ue+=se;continue}if(X&&(se!=="]"||!q)){let be;se==="-"?be=se:(se==="^"||se==="!")&&!q?be="^":se===e.$Ak?be="":be=(0,c.$kf)(se),q+=be;continue}switch(se){case"{":me=!0;continue;case"[":X=!0;continue;case"}":{const ae=`(?:${a(ue,",").map(we=>$(we)).join("|")})`;B+=ae,me=!1,ue="";break}case"]":{B+="["+q+"]",X=!1,q="";break}case"?":B+=g;continue;case"*":B+=b(1);continue;default:B+=(0,c.$kf)(se)}}ie<Y.length-1&&(Y[ie+1]!==e.$zk||ie+2<Y.length)&&(B+=E)}x=oe===e.$zk})}return B}const p=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,o=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,n=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new O.$Gc(1e4),d=function(){return!1},l=function(){return null};function f(W,B){if(!W)return l;let Y;typeof W!="string"?Y=W.pattern:Y=W,Y=Y.trim();const x=`${Y}_${!!B.trimForExclusions}`;let oe=r.get(x);if(oe)return y(oe,W);let ie;return p.test(Y)?oe=S(Y.substr(4),Y):(ie=u.exec(k(Y,B)))?oe=D(ie[1],Y):(B.trimForExclusions?o:i).test(Y)?oe=T(Y,B):(ie=t.exec(k(Y,B)))?oe=v(ie[1].substr(1),Y,!0):(ie=n.exec(k(Y,B)))?oe=v(ie[1],Y,!1):oe=w(Y),r.set(x,oe),y(oe,W)}function y(W,B){if(typeof B=="string")return W;const Y=function(x,oe){return(0,A.$Hg)(x,B.base,!m.$l)?W((0,c.$pf)(x.substr(B.base.length),C.sep),oe):null};return Y.allBasenames=W.allBasenames,Y.allPaths=W.allPaths,Y.basenames=W.basenames,Y.patterns=W.patterns,Y}function k(W,B){return B.trimForExclusions&&W.endsWith("/**")?W.substr(0,W.length-2):W}function S(W,B){return function(Y,x){return typeof Y=="string"&&Y.endsWith(W)?B:null}}function D(W,B){const Y=`/${W}`,x=`\\${W}`,oe=function(me,ue){return typeof me!="string"?null:ue?ue===W?B:null:me===W||me.endsWith(Y)||me.endsWith(x)?B:null},ie=[W];return oe.basenames=ie,oe.patterns=[B],oe.allBasenames=ie,oe}function T(W,B){const Y=z(W.slice(1,-1).split(",").map(ue=>f(ue,B)).filter(ue=>ue!==l),W),x=Y.length;if(!x)return l;if(x===1)return Y[0];const oe=function(ue,X){for(let q=0,se=Y.length;q<se;q++)if(Y[q](ue,X))return W;return null},ie=Y.find(ue=>!!ue.allBasenames);ie&&(oe.allBasenames=ie.allBasenames);const me=Y.reduce((ue,X)=>X.allPaths?ue.concat(X.allPaths):ue,[]);return me.length&&(oe.allPaths=me),oe}function v(W,B,Y){const x=C.sep===C.$jc.sep,oe=x?W:W.replace(P,C.sep),ie=C.sep+oe,me=C.$jc.sep+W;let ue;return Y?ue=function(X,q){return typeof X=="string"&&(X===oe||X.endsWith(ie)||!x&&(X===W||X.endsWith(me)))?B:null}:ue=function(X,q){return typeof X=="string"&&(X===oe||!x&&X===W)?B:null},ue.allPaths=[(Y?"*/":"./")+W],ue}function w(W){try{const B=new RegExp(`^${$(W)}$`);return function(Y){return B.lastIndex=0,typeof Y=="string"&&B.test(Y)?W:null}}catch{return l}}function M(W,B,Y){return!W||typeof B!="string"?!1:L(W)(B,void 0,Y)}function L(W,B={}){if(!W)return d;if(typeof W=="string"||N(W)){const Y=f(W,B);if(Y===l)return d;const x=function(oe,ie){return!!Y(oe,ie)};return Y.allBasenames&&(x.allBasenames=Y.allBasenames),Y.allPaths&&(x.allPaths=Y.allPaths),x}return j(W,B)}function N(W){const B=W;return B?typeof B.base=="string"&&typeof B.pattern=="string":!1}function F(W){return W.allBasenames||[]}function V(W){return W.allPaths||[]}function j(W,B){const Y=z(Object.getOwnPropertyNames(W).map(ue=>U(ue,W[ue],B)).filter(ue=>ue!==l)),x=Y.length;if(!x)return l;if(!Y.some(ue=>!!ue.requiresSiblings)){if(x===1)return Y[0];const ue=function(se,be){let ae;for(let we=0,$e=Y.length;we<$e;we++){const pe=Y[we](se,be);if(typeof pe=="string")return pe;(0,h.$uh)(pe)&&(ae||(ae=[]),ae.push(pe))}return ae?(async()=>{for(const we of ae){const $e=await we;if(typeof $e=="string")return $e}return null})():null},X=Y.find(se=>!!se.allBasenames);X&&(ue.allBasenames=X.allBasenames);const q=Y.reduce((se,be)=>be.allPaths?se.concat(be.allPaths):se,[]);return q.length&&(ue.allPaths=q),ue}const oe=function(ue,X,q){let se,be;for(let ae=0,we=Y.length;ae<we;ae++){const $e=Y[ae];$e.requiresSiblings&&q&&(X||(X=(0,C.$qc)(ue)),se||(se=X.substr(0,X.length-(0,C.$rc)(ue).length)));const pe=$e(ue,X,se,q);if(typeof pe=="string")return pe;(0,h.$uh)(pe)&&(be||(be=[]),be.push(pe))}return be?(async()=>{for(const ae of be){const we=await ae;if(typeof we=="string")return we}return null})():null},ie=Y.find(ue=>!!ue.allBasenames);ie&&(oe.allBasenames=ie.allBasenames);const me=Y.reduce((ue,X)=>X.allPaths?ue.concat(X.allPaths):ue,[]);return me.length&&(oe.allPaths=me),oe}function U(W,B,Y){if(B===!1)return l;const x=f(W,Y);if(x===l)return l;if(typeof B=="boolean")return x;if(B){const oe=B.when;if(typeof oe=="string"){const ie=(me,ue,X,q)=>{if(!q||!x(me,ue))return null;const se=oe.replace("$(basename)",()=>X),be=q(se);return(0,h.$uh)(be)?be.then(ae=>ae?W:null):be?W:null};return ie.requiresSiblings=!0,ie}}return x}function z(W,B){const Y=W.filter(ue=>!!ue.basenames);if(Y.length<2)return W;const x=Y.reduce((ue,X)=>{const q=X.basenames;return q?ue.concat(q):ue},[]);let oe;if(B){oe=[];for(let ue=0,X=x.length;ue<X;ue++)oe.push(B)}else oe=Y.reduce((ue,X)=>{const q=X.patterns;return q?ue.concat(q):ue},[]);const ie=function(ue,X){if(typeof ue!="string")return null;if(!X){let se;for(se=ue.length;se>0;se--){const be=ue.charCodeAt(se-1);if(be===R.CharCode.Slash||be===R.CharCode.Backslash)break}X=ue.substr(se)}const q=x.indexOf(X);return q!==-1?oe[q]:null};ie.basenames=x,ie.patterns=oe,ie.allBasenames=x;const me=W.filter(ue=>!ue.basenames);return me.push(ie),me}function _(W,B){return(0,s.$wb)(W,B,(Y,x)=>typeof Y=="string"&&typeof x=="string"?Y===x:typeof Y!="string"&&typeof x!="string"?Y.base===x.base&&Y.pattern===x.pattern:!1)}}),define(Re[86],Ce([1,0,12,138,22,13,2]),function(ge,e,s,h,R,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7k=e.MarkdownStringTextNewlineStyle=void 0,e.$8k=c,e.$9k=I,e.$0k=E,e.$$k=g,e.$_k=P,e.$al=b,e.$bl=a,e.$cl=$;var C;(function(p){p[p.Paragraph=0]="Paragraph",p[p.Break=1]="Break"})(C||(e.MarkdownStringTextNewlineStyle=C={}));class m{constructor(u="",i=!1){if(this.value=u,typeof this.value!="string")throw(0,s.$9)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(u,i=C.Paragraph){return this.value+=g(this.supportThemeIcons?(0,h.$1k)(u):u).replace(/([ \t]+)/g,(o,t)=>"&nbsp;".repeat(t.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===C.Break?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,i){return this.value+=`
${P(i,u)}
`,this}appendLink(u,i,o){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(u),")"),o&&(this.value+=` "${this.c(this.c(o,'"'),")")}"`),this.value+=")",this}c(u,i){const o=new RegExp((0,A.$kf)(i),"g");return u.replace(o,(t,n)=>u.charAt(n-1)!=="\\"?`\\${t}`:t)}}e.$7k=m;function c(p){return I(p)?!p.value:Array.isArray(p)?p.every(c):!0}function I(p){return p instanceof m?!0:p&&typeof p=="object"?typeof p.value=="string"&&(typeof p.isTrusted=="boolean"||typeof p.isTrusted=="object"||p.isTrusted===void 0)&&(typeof p.supportThemeIcons=="boolean"||p.supportThemeIcons===void 0):!1}function E(p,u){return p===u?!0:!p||!u?!1:p.value===u.value&&p.isTrusted===u.isTrusted&&p.supportThemeIcons===u.supportThemeIcons&&p.supportHtml===u.supportHtml&&(p.baseUri===u.baseUri||!!p.baseUri&&!!u.baseUri&&(0,R.$ch)(O.URI.from(p.baseUri),O.URI.from(u.baseUri)))}function g(p){return p.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function P(p,u){const i=p.match(/^`+/gm)?.reduce((t,n)=>t.length>n.length?t:n).length??0,o=i>=3?i+1:3;return[`${"`".repeat(o)}${u}`,p,`${"`".repeat(o)}`].join(`
`)}function b(p){return p.replace(/"/g,"&quot;")}function a(p){return p&&p.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function $(p){const u=[],i=p.split("|").map(t=>t.trim());p=i[0];const o=i[1];if(o){const t=/height=(\d+)/.exec(o),n=/width=(\d+)/.exec(o),r=t?t[1]:"",d=n?n[1]:"",l=isFinite(parseInt(d)),f=isFinite(parseInt(r));l&&u.push(`width="${d}"`),f&&u.push(`height="${r}"`)}return{href:p,dimensions:u}}}),define(Re[107],Ce([1,0,18,31,16,10,22,13]),function(ge,e,s,h,R,A,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7w=m,e.$8w=I,e.$9w=g,e.$0w=P,e.$$w=p,e.$_w=i,e.$ax=o,e.$bx=t,e.$cx=n,e.$dx=r;function m(l,f){const{os:y,tildify:k,relative:S}=f;if(S){const v=c(l,S,y);if(typeof v=="string")return v}let D=l.fsPath;if(y===A.OperatingSystem.Windows&&!A.$j?D=D.replace(/\//g,"\\"):y!==A.OperatingSystem.Windows&&A.$j&&(D=D.replace(/\\/g,"/")),y!==A.OperatingSystem.Windows&&k?.userHome){const v=k.userHome.fsPath;let w;l.scheme!==k.userHome.scheme&&l.path[0]===R.$jc.sep&&l.path[1]!==R.$jc.sep?w=k.userHome.with({path:l.path}).fsPath:w=D,D=g(w,v,y)}return(y===A.OperatingSystem.Windows?R.$ic:R.$jc).normalize(I(D,y===A.OperatingSystem.Windows))}function c(l,f,y){const k=y===A.OperatingSystem.Windows?R.$ic:R.$jc,S=y===A.OperatingSystem.Linux?O.$_g:O.$bh,D=f.getWorkspace(),T=(0,s.$Qb)(D.folders);if(!T)return;l.scheme!==T.uri.scheme&&l.path[0]===R.$jc.sep&&l.path[1]!==R.$jc.sep&&(l=T.uri.with({path:l.path}));const v=f.getWorkspaceFolder(l);if(!v)return;let w;if(S.isEqual(v.uri,l)?w="":w=S.relativePath(v.uri,l)??"",w&&(w=k.normalize(w)),D.folders.length>1&&!f.noPrefix){const M=v.name?v.name:S.basenameOrAuthority(v.uri);w=w?`${M} \u2022 ${w}`:M}return w}function I(l,f=A.$j){return(0,h.$Mg)(l,f)?l.charAt(0).toUpperCase()+l.slice(1):l}let E=Object.create(null);function g(l,f,y=A.OS){if(y===A.OperatingSystem.Windows||!l||!f)return l;let k=E.original===f?E.normalized:void 0;k||(k=f,A.$j&&(k=(0,h.$Bg)(k)),k=`${(0,C.$qf)(k,R.$jc.sep)}${R.$jc.sep}`,E={original:f,normalized:k});let S=l;return A.$j&&(S=(0,h.$Bg)(S)),(y===A.OperatingSystem.Linux?S.startsWith(k):(0,C.$Jf)(S,k))?`~/${S.substr(k.length)}`:l}function P(l,f){return l.replace(/^~($|\/|\\)/,`${f}$1`)}const b="\u2026",a="\\\\",$="~";function p(l,f=R.sep){const y=new Array(l.length);let k=!1;for(let S=0;S<l.length;S++){const D=l[S];if(D===""){y[S]=`.${f}`;continue}if(!D){y[S]=D;continue}k=!0;let T="",v=D;v.indexOf(a)===0?(T=v.substr(0,v.indexOf(a)+a.length),v=v.substr(v.indexOf(a)+a.length)):v.indexOf(f)===0?(T=v.substr(0,v.indexOf(f)+f.length),v=v.substr(v.indexOf(f)+f.length)):v.indexOf($)===0&&(T=v.substr(0,v.indexOf($)+$.length),v=v.substr(v.indexOf($)+$.length));const w=v.split(f);for(let M=1;k&&M<=w.length;M++)for(let L=w.length-M;k&&L>=0;L--){k=!1;let N=w.slice(L,L+M).join(f);for(let F=0;!k&&F<l.length;F++)if(F!==S&&l[F]&&l[F].indexOf(N)>-1){const V=L+M===w.length,j=L>0&&l[F].indexOf(f)>-1?f+N:N,U=l[F].endsWith(j);k=!V||U}if(!k){let F="";(w[0].endsWith(":")||T!=="")&&(L===1&&(L=0,M++,N=w[0]+f+N),L>0&&(F=w[0]+f),F=T+F),L>0&&(F=F+b+f),F=F+N,L+M<w.length&&(F=F+f+b),y[S]=F}}k&&(y[S]=D)}return y}var u;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function i(l,f=Object.create(null)){const y=[];let k=!1,S="";for(const D of l)if(D==="$"||k&&D==="{")S&&y.push({value:S,type:u.TEXT}),S="",k=!0;else if(D==="}"&&k){const T=f[S];if(typeof T=="string")T.length&&y.push({value:T,type:u.VARIABLE});else if(T){const v=y[y.length-1];(!v||v.type!==u.SEPARATOR)&&y.push({value:T.label,type:u.SEPARATOR})}S="",k=!1}else S+=D;return S&&!k&&y.push({value:S,type:u.TEXT}),y.filter((D,T)=>{if(D.type===u.SEPARATOR){const v=y[T-1],w=y[T+1];return[v,w].every(M=>M&&(M.type===u.VARIABLE||M.type===u.TEXT)&&M.value.length>0)}return!0}).map(D=>D.value).join("")}function o(l,f){return A.$k||f?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.$k?"&":"&&"):l.replace(/&&|&/g,y=>y==="&"?"&&":"&")}function t(l,f){return A.$k||f?l.replace(/\(&&\w\)|&&/g,""):A.$j?l.replace(/&&|&/g,y=>y==="&"?"&&":"&"):l.replace(/&&/g,"_")}function n(l){return l.replace(/&/g,"&&")}function r(l){if(l.endsWith("]")){const f=l.lastIndexOf(" [",l.length-2);if(f!==-1){const y=d(l.substring(0,f)),k=l.substring(f);return{name:y.name+k,parentPath:y.parentPath}}}return d(l)}function d(l){const f=l.indexOf("/")!==-1?R.$jc:R.$ic,y=f.basename(l),k=f.dirname(l);return y.length?{name:y,parentPath:k}:{name:k,parentPath:""}}}),define(Re[140],Ce([1,0,21,41,2]),function(ge,e,s,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rn=e.$Qn=void 0,e.$Sn=m,e.$Tn=I,e.$Un=E;function A(g){return g.toJSON()}class O{constructor(P){this.a=P}transformIncoming(P){const b=this.a.transformIncoming(P);return b===P?P:A(R.URI.from(b))}transformOutgoing(P){const b=this.a.transformOutgoing(P);return b===P?P:A(R.URI.from(b))}transformOutgoingURI(P){const b=this.a.transformOutgoing(P);return b===P?P:R.URI.from(b)}transformOutgoingScheme(P){return this.a.transformOutgoingScheme(P)}}e.$Qn=O,e.$Rn=new class{transformIncoming(g){return g}transformOutgoing(g){return g}transformOutgoingURI(g){return g}transformOutgoingScheme(g){return g}};function C(g,P,b){if(!g||b>200)return null;if(typeof g=="object"){if(g instanceof R.URI)return P.transformOutgoing(g);for(const a in g)if(Object.hasOwnProperty.call(g,a)){const $=C(g[a],P,b+1);$!==null&&(g[a]=$)}}return null}function m(g,P){const b=C(g,P,0);return b===null?g:b}function c(g,P,b,a){if(!g||a>200)return null;if(typeof g=="object"){if(g.$mid===h.MarshalledId.Uri)return b?R.URI.revive(P.transformIncoming(g)):P.transformIncoming(g);if(g instanceof s.$Qe)return null;for(const $ in g)if(Object.hasOwnProperty.call(g,$)){const p=c(g[$],P,b,a+1);p!==null&&(g[$]=p)}}return null}function I(g,P){const b=c(g,P,!1,0);return b===null?g:b}function E(g,P){const b=c(g,P,!0,0);return b===null?g:b}}),define(Re[32],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5g=void 0,e.$4g=h;const s=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function h(R){return s.test(R)}e.$5g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(C){for(let m=0;m<C.length;m++)C[m]=Math.floor(Math.random()*256);return C};const A=new Uint8Array(16),O=[];for(let C=0;C<256;C++)O.push(C.toString(16).padStart(2,"0"));return function(){R(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let m=0,c="";return c+=O[A[m++]],c+=O[A[m++]],c+=O[A[m++]],c+=O[A[m++]],c+="-",c+=O[A[m++]],c+=O[A[m++]],c+="-",c+=O[A[m++]],c+=O[A[m++]],c+="-",c+=O[A[m++]],c+=O[A[m++]],c+="-",c+=O[A[m++]],c+=O[A[m++]],c+=O[A[m++]],c+=O[A[m++]],c+=O[A[m++]],c+=O[A[m++]],c}}()}),define(Re[192],Ce([1,0,18,40,32]),function(ge,e,s,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zu=e.$xu=void 0,e.$vu=A,e.$wu=O,e.$yu=c;function A(E){return{asString:async()=>E,asFile:()=>{},value:typeof E=="string"?E:void 0}}function O(E,g,P){const b={id:(0,R.$5g)(),name:E,uri:g,data:P};return{asString:async()=>"",asFile:()=>b,value:void 0}}class C{constructor(){this.a=new Map}get size(){let g=0;for(const P of this.a)g++;return g}has(g){return this.a.has(this.b(g))}matches(g){const P=[...this.a.keys()];return h.Iterable.some(this,([b,a])=>a.asFile())&&P.push("files"),I(m(g),P)}get(g){return this.a.get(this.b(g))?.[0]}append(g,P){const b=this.a.get(g);b?b.push(P):this.a.set(this.b(g),[P])}replace(g,P){this.a.set(this.b(g),[P])}delete(g){this.a.delete(this.b(g))}*[Symbol.iterator](){for(const[g,P]of this.a)for(const b of P)yield[g,b]}b(g){return m(g)}}e.$xu=C;function m(E){return E.toLowerCase()}function c(E,g){return I(m(E),g.map(m))}function I(E,g){if(E==="*/*")return g.length>0;if(g.includes(E))return!0;const P=E.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!P)return!1;const[b,a,$]=P;return $==="*"?g.some(p=>p.startsWith(a+"/")):!1}e.$zu=Object.freeze({create:E=>(0,s.$Ob)(E.map(g=>g.toString())).join(`\r
`),split:E=>E.split(`\r
`),parse:E=>e.$zu.split(E).filter(g=>!g.startsWith("#"))})}),define(Re[33],Ce([1,0,45,68,361,7,31,83,16,10,22,2]),function(ge,e,s,h,R,A,O,C,m,c,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=$,e.readdirSync=i,e.whenDeleted=n,e.configureFlushOnWrite=y,e.writeFileSync=S,s=Ue(s);var g;(function(j){j[j.UNLINK=0]="UNLINK",j[j.MOVE=1]="MOVE"})(g||(e.RimRafMode=g={}));async function P(j,U=g.UNLINK,z){if((0,O.$Lg)(j))throw new Error("rimraf - will refuse to recursively delete root");return U===g.UNLINK?a(j):b(j,z)}async function b(j,U=(0,O.$Qg)((0,h.tmpdir)())){try{try{await s.promises.rename(j,U)}catch(z){return z.code==="ENOENT"?void 0:a(j)}a(U).catch(z=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function a(j){return s.promises.rm(j,{recursive:!0,force:!0,maxRetries:3})}function $(j){if((0,O.$Lg)(j))throw new Error("rimraf - will refuse to recursively delete root");s.rmSync(j,{recursive:!0,force:!0,maxRetries:3})}async function p(j,U){return o(await(U?u(j):s.promises.readdir(j)))}async function u(j){try{return await s.promises.readdir(j,{withFileTypes:!0})}catch(_){console.warn("[node.js fs] readdir with filetypes failed with error: ",_)}const U=[],z=await p(j);for(const _ of z){let W=!1,B=!1,Y=!1;try{const x=await s.promises.lstat((0,m.$mc)(j,_));W=x.isFile(),B=x.isDirectory(),Y=x.isSymbolicLink()}catch(x){console.warn("[node.js fs] unexpected error from lstat after readdir: ",x)}U.push({name:_,isFile:()=>W,isDirectory:()=>B,isSymbolicLink:()=>Y})}return U}function i(j){return o(s.readdirSync(j))}function o(j){return j.map(U=>typeof U=="string"?c.$k?(0,C.$qm)(U):U:(U.name=c.$k?(0,C.$qm)(U.name):U.name,U))}async function t(j){const U=await p(j),z=[];for(const _ of U)await r.existsDirectory((0,m.$mc)(j,_))&&z.push(_);return z}function n(j,U=1e3){return new Promise(z=>{let _=!1;const W=setInterval(()=>{_||(_=!0,s.access(j,B=>{_=!1,B&&(clearInterval(W),z(void 0))}))},U)})}var r;(function(j){async function U(W){let B;try{if(B=await s.promises.lstat(W),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await s.promises.stat(W),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Y){if(Y.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(c.$j&&Y.code==="EACCES")try{return{stat:await s.promises.stat(await s.promises.readlink(W)),symbolicLink:{dangling:!1}}}catch(x){if(x.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw x}throw Y}}j.stat=U;async function z(W){try{const{stat:B,symbolicLink:Y}=await j.stat(W);return B.isFile()&&Y?.dangling!==!0}catch{}return!1}j.existsFile=z;async function _(W){try{const{stat:B,symbolicLink:Y}=await j.stat(W);return B.isDirectory()&&Y?.dangling!==!0}catch{}return!1}j.existsDirectory=_})(r||(e.SymlinkSupport=r={}));const d=new A.$Rh;function l(j,U,z){return d.queueFor(E.URI.file(j),()=>{const _=D(z);return new Promise((W,B)=>k(j,U,_,Y=>Y?B(Y):W()))},I.$ah)}let f=!0;function y(j){f=j}function k(j,U,z,_){if(!f)return s.writeFile(j,U,{mode:z.mode,flag:z.flag},_);s.open(j,z.flag,z.mode,(W,B)=>{if(W)return _(W);s.writeFile(B,U,Y=>{if(Y)return s.close(B,()=>_(Y));s.fdatasync(B,x=>(x&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",x),y(!1)),s.close(B,oe=>_(oe))))})})}function S(j,U,z){const _=D(z);if(!f)return s.writeFileSync(j,U,{mode:_.mode,flag:_.flag});const W=s.openSync(j,_.flag,_.mode);try{s.writeFileSync(W,U);try{s.fdatasyncSync(W)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),y(!1)}}finally{s.closeSync(W)}}function D(j){return j?{mode:typeof j.mode=="number"?j.mode:438,flag:typeof j.flag=="string"?j.flag:"w"}:{mode:438,flag:"w"}}async function T(j,U,z=6e4){if(j!==U)try{c.$j&&typeof z=="number"?await v(j,U,Date.now(),z):await s.promises.rename(j,U)}catch(_){if(j.toLowerCase()!==U.toLowerCase()&&_.code==="EXDEV"||j.endsWith("."))await w(j,U,{preserveSymlinks:!1}),await P(j,g.MOVE);else throw _}}async function v(j,U,z,_,W=0){try{return await s.promises.rename(j,U)}catch(B){if(B.code!=="EACCES"&&B.code!=="EPERM"&&B.code!=="EBUSY")throw B;if(Date.now()-z>=_)throw console.error(`[node.js fs] rename failed after ${W} retries with error: ${B}`),B;if(W===0){let Y=!1;try{const{stat:x}=await r.stat(U);x.isFile()||(Y=!0)}catch{}if(Y)throw B}return await(0,A.$Jh)(Math.min(100,W*10)),v(j,U,z,_,W+1)}}async function w(j,U,z){return L(j,U,{root:{source:j,target:U},options:z,handledSourcePaths:new Set})}const M=511;async function L(j,U,z){if(z.handledSourcePaths.has(j))return;z.handledSourcePaths.add(j);const{stat:_,symbolicLink:W}=await r.stat(j);if(W){if(z.options.preserveSymlinks)try{return await V(j,U,z)}catch{}if(W.dangling)return}return _.isDirectory()?N(j,U,_.mode&M,z):F(j,U,_.mode&M)}async function N(j,U,z,_){await s.promises.mkdir(U,{recursive:!0,mode:z});const W=await p(j);for(const B of W)await L((0,m.$mc)(j,B),(0,m.$mc)(U,B),_)}async function F(j,U,z){await s.promises.copyFile(j,U),await s.promises.chmod(U,z)}async function V(j,U,z){let _=await s.promises.readlink(j);(0,O.$Hg)(_,z.root.source,!c.$l)&&(_=(0,m.$mc)(z.root.target,_.substr(z.root.source.length+1))),await s.promises.symlink(_,U)}e.Promises=new class{get read(){return(j,U,z,_,W)=>new Promise((B,Y)=>{s.read(j,U,z,_,W,(x,oe,ie)=>x?Y(x):B({bytesRead:oe,buffer:ie}))})}get write(){return(j,U,z,_,W)=>new Promise((B,Y)=>{s.write(j,U,z,_,W,(x,oe,ie)=>x?Y(x):B({bytesWritten:oe,buffer:ie}))})}get fdatasync(){return(0,R.promisify)(s.fdatasync)}get open(){return(0,R.promisify)(s.open)}get close(){return(0,R.promisify)(s.close)}get realpath(){return(0,R.promisify)(s.realpath)}async exists(j){try{return await s.promises.access(j),!0}catch{return!1}}get readdir(){return p}get readDirsInDir(){return t}get writeFile(){return l}get rm(){return P}get rename(){return T}get copy(){return w}}}),define(Re[108],Ce([1,0,45,16,10,13,33]),function(ge,e,s,h,R,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=C,e.$sr=m,e.$tr=c,e.$ur=I,s=Ue(s);function C(g){if(R.$l)return g;const P=(0,h.$pc)(g);if(g===P)return g;const b=((0,h.$qc)(g)||g).toLowerCase();try{const $=(0,O.readdirSync)(P).filter(p=>p.toLowerCase()===b);if($.length===1){const p=C(P);if(p)return(0,h.$mc)(p,$[0])}else if($.length>1){const p=$.indexOf(b);if(p>=0){const u=C(P);if(u)return(0,h.$mc)(u,$[p])}}}catch{}return null}async function m(g,P){if(R.$l)return g;const b=(0,h.$pc)(g);if(g===b)return g;const a=((0,h.$qc)(g)||g).toLowerCase();try{if(P?.isCancellationRequested)return null;const p=(await O.Promises.readdir(b)).filter(u=>u.toLowerCase()===a);if(p.length===1){const u=await m(b,P);if(u)return(0,h.$mc)(u,p[0])}else if(p.length>1){const u=p.indexOf(a);if(u>=0){const i=await m(b,P);if(i)return(0,h.$mc)(i,p[u])}}}catch{}return null}async function c(g){try{return await O.Promises.realpath(g)}catch{const b=E(g);return await s.promises.access(b,s.constants.R_OK),b}}function I(g){try{return s.realpathSync(g)}catch{const b=E(g);return s.accessSync(b,s.constants.R_OK),b}}function E(g){return(0,A.$qf)((0,h.$kc)(g),h.sep)}}),define(Re[193],Ce([1,0,69]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8g=void 0,e.$7g=h,e.$9g=A,s=Ue(s);function h(C,m,c,I=1){let E=!1;return new Promise(g=>{const P=setTimeout(()=>{if(!E)return E=!0,g(0)},c);R(C,m,I,b=>{if(!E)return E=!0,clearTimeout(P),g(b)})})}function R(C,m,c,I){if(m===0)return I(0);const E=new s.Socket;E.once("connect",()=>(O(E),R(C+c,m-1,c,I))),E.once("data",()=>{}),E.once("error",g=>(O(E),g.code!=="ECONNREFUSED"?R(C+c,m-1,c,I):I(C))),E.connect(C,"127.0.0.1")}e.$8g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(C,m,c,I="127.0.0.1"){let E=!1,g,P=1;const b=s.createServer({pauseOnConnect:!0});function a($,p){E||(E=!0,b.removeAllListeners(),b.close(),g&&clearTimeout(g),p($))}return new Promise($=>{g=setTimeout(()=>{a(0,$)},c),b.on("listening",()=>{a(C,$)}),b.on("error",p=>{p&&(p.code==="EADDRINUSE"||p.code==="EACCES")&&P<m?(C++,P++,b.listen(C,I)):a(0,$)}),b.on("close",()=>{a(0,$)}),b.listen(C,I)})}function O(C){try{C.removeAllListeners("connect"),C.removeAllListeners("error"),C.end(),C.destroy(),C.unref()}catch(m){console.error(m)}}}),define(Re[109],Ce([1,0,45,16,10,55,104,17,33]),function(ge,e,s,h,R,A,O,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$Bm=c,e.$Cm=I,h=Ue(h),R=Ue(R),A=Ue(A),C=Ue(C),m=Ue(m),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return O.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return O.TerminateResponseCode}});function c(g=A.env){return g.comspec||"cmd.exe"}function I(g){let P=[],b=!1;const a=function($){if(b){P.push($);return}(!g.send($,u=>{if(u&&console.error(u),b=!1,P.length>0){const i=P.slice(0);P=[],i.forEach(o=>a(o))}})||R.$j)&&(b=!0)};return{send:a}}var E;(function(g){async function P(b,a,$){if(h.$lc(b))return b;if(a===void 0&&(a=A.cwd()),h.$pc(b)!=="."||($===void 0&&C.$hg(A.env.PATH)&&($=A.env.PATH.split(h.$wc)),$===void 0||$.length===0))return h.$mc(a,b);async function u(i){if(await m.Promises.exists(i)){let o;try{o=await s.promises.stat(i)}catch(t){t.message.startsWith("EACCES")&&(o=await s.promises.lstat(i))}return o?!o.isDirectory():!1}return!1}for(const i of $){let o;if(h.$lc(i)?o=h.$mc(i,b):o=h.$mc(a,i,b),await u(o))return o;let t=o+".com";if(await u(t)||(t=o+".exe",await u(t)))return t}return h.$mc(a,b)}g.findExecutable=P})(E||(e.win32=E={}))});var Ze=this&&this.__decorate||function(ge,e,s,h){var R=arguments.length,A=R<3?e:h===null?h=Object.getOwnPropertyDescriptor(e,s):h,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(ge,e,s,h);else for(var C=ge.length-1;C>=0;C--)(O=ge[C])&&(A=(R<3?O(A):R>3?O(e,s,A):O(e,s))||A);return R>3&&A&&Object.defineProperty(e,s,A),A};define(Re[87],Ce([1,0,18,7,21,20,60,12,4,3,38,13,17]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ri=e.ProxyChannel=e.$qi=e.$ni=e.$mi=e.$li=e.RequestInitiator=e.$ki=e.$hi=e.$gi=void 0,e.$ii=y,e.$ji=k,e.$oi=M,e.$pi=L,E=Ue(E);var P;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(P||(P={}));function b(W){switch(W){case P.Promise:return"req";case P.PromiseCancel:return"cancel";case P.EventListen:return"subscribe";case P.EventDispose:return"unsubscribe"}}var a;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(a||(a={}));function $(W){switch(W){case a.Initialize:return"init";case a.PromiseSuccess:return"reply:";case a.PromiseError:case a.PromiseErrorObj:return"replyErr:";case a.EventFire:return"event:"}}var p;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(p||(p={}));function u(W){let B=0;for(let Y=0;;Y+=7){const x=W.read(1);if(B|=(x.buffer[0]&127)<<Y,!(x.buffer[0]&128))return B}}const i=d(0);function o(W,B){if(B===0){W.write(i);return}let Y=0;for(let oe=B;oe!==0;oe=oe>>>7)Y++;const x=R.$Qe.alloc(Y);for(let oe=0;B!==0;oe++)x.buffer[oe]=B&127,B=B>>>7,B>0&&(x.buffer[oe]|=128);W.write(x)}class t{constructor(B){this.b=B,this.a=0}read(B){const Y=this.b.slice(this.a,this.a+B);return this.a+=Y.byteLength,Y}}e.$gi=t;class n{constructor(){this.a=[]}get buffer(){return R.$Qe.concat(this.a)}write(B){this.a.push(B)}}e.$hi=n;var r;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object",W[W.Int=6]="Int"})(r||(r={}));function d(W){const B=R.$Qe.alloc(1);return B.writeUInt8(W,0),B}const l={Undefined:d(r.Undefined),String:d(r.String),Buffer:d(r.Buffer),VSBuffer:d(r.VSBuffer),Array:d(r.Array),Object:d(r.Object),Uint:d(r.Int)},f=typeof Buffer<"u";function y(W,B){if(typeof B>"u")W.write(l.Undefined);else if(typeof B=="string"){const Y=R.$Qe.fromString(B);W.write(l.String),o(W,Y.byteLength),W.write(Y)}else if(f&&Buffer.isBuffer(B)){const Y=R.$Qe.wrap(B);W.write(l.Buffer),o(W,Y.byteLength),W.write(Y)}else if(B instanceof R.$Qe)W.write(l.VSBuffer),o(W,B.byteLength),W.write(B);else if(Array.isArray(B)){W.write(l.Array),o(W,B.length);for(const Y of B)y(W,Y)}else if(typeof B=="number"&&(B|0)===B)W.write(l.Uint),o(W,B);else{const Y=R.$Qe.fromString(JSON.stringify(B));W.write(l.Object),o(W,Y.byteLength),W.write(Y)}}function k(W){switch(W.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return W.read(u(W)).toString();case r.Buffer:return W.read(u(W)).buffer;case r.VSBuffer:return W.read(u(W));case r.Array:{const Y=u(W),x=[];for(let oe=0;oe<Y;oe++)x.push(k(W));return x}case r.Object:return JSON.parse(W.read(u(W)).toString());case r.Int:return u(W)}}class S{constructor(B,Y,x=null,oe=1e3){this.h=B,this.j=Y,this.k=x,this.l=oe,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ie=>this.q(ie)),this.m({type:a.Initialize})}registerChannel(B,Y){this.b.set(B,Y),setTimeout(()=>this.w(B),0)}m(B){switch(B.type){case a.Initialize:{const Y=this.o([B.type]);this.k?.logOutgoing(Y,0,D.OtherSide,$(B.type));return}case a.PromiseSuccess:case a.PromiseError:case a.EventFire:case a.PromiseErrorObj:{const Y=this.o([B.type,B.id],B.data);this.k?.logOutgoing(Y,B.id,D.OtherSide,$(B.type),B.data);return}}}o(B,Y=void 0){const x=new n;return y(x,B),y(x,Y),this.p(x.buffer)}p(B){try{return this.h.send(B),B.byteLength}catch{return 0}}q(B){const Y=new t(B),x=k(Y),oe=k(Y),ie=x[0];switch(ie){case P.Promise:return this.k?.logIncoming(B.byteLength,x[1],D.OtherSide,`${b(ie)}: ${x[2]}.${x[3]}`,oe),this.s({type:ie,id:x[1],channelName:x[2],name:x[3],arg:oe});case P.EventListen:return this.k?.logIncoming(B.byteLength,x[1],D.OtherSide,`${b(ie)}: ${x[2]}.${x[3]}`,oe),this.t({type:ie,id:x[1],channelName:x[2],name:x[3],arg:oe});case P.PromiseCancel:return this.k?.logIncoming(B.byteLength,x[1],D.OtherSide,`${b(ie)}`),this.u({type:ie,id:x[1]});case P.EventDispose:return this.k?.logIncoming(B.byteLength,x[1],D.OtherSide,`${b(ie)}`),this.u({type:ie,id:x[1]})}}s(B){const Y=this.b.get(B.channelName);if(!Y){this.v(B);return}const x=new A.$ze;let oe;try{oe=Y.call(this.j,B.name,B.arg,x.token)}catch(ue){oe=Promise.reject(ue)}const ie=B.id;oe.then(ue=>{this.m({id:ie,data:ue,type:a.PromiseSuccess})},ue=>{ue instanceof Error?this.m({id:ie,data:{message:ue.message,name:ue.name,stack:ue.stack?ue.stack.split(`
`):void 0},type:a.PromiseError}):this.m({id:ie,data:ue,type:a.PromiseErrorObj})}).finally(()=>{me.dispose(),this.d.delete(B.id)});const me=(0,c.$Vc)(()=>x.cancel());this.d.set(B.id,me)}t(B){const Y=this.b.get(B.channelName);if(!Y){this.v(B);return}const x=B.id,ie=Y.listen(this.j,B.name,B.arg)(me=>this.m({id:x,data:me,type:a.EventFire}));this.d.set(B.id,ie)}u(B){const Y=this.d.get(B.id);Y&&(Y.dispose(),this.d.delete(B.id))}v(B){let Y=this.g.get(B.channelName);Y||(Y=[],this.g.set(B.channelName,Y));const x=setTimeout(()=>{console.error(`Unknown channel: ${B.channelName}`),B.type===P.Promise&&this.m({id:B.id,data:{name:"Unknown channel",message:`Channel name '${B.channelName}' timed out after ${this.l}ms`,stack:void 0},type:a.PromiseError})},this.l);Y.push({request:B,timeoutTimer:x})}w(B){const Y=this.g.get(B);if(Y){for(const x of Y)switch(clearTimeout(x.timeoutTimer),x.request.type){case P.Promise:this.s(x.request);break;case P.EventListen:this.t(x.request);break}this.g.delete(B)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Sc)(this.d.values()),this.d.clear()}}e.$ki=S;var D;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(D||(e.RequestInitiator=D={}));class T{constructor(B,Y=null){this.l=B,this.a=!1,this.b=p.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new m.$oe,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(x=>this.s(x)),this.j=Y}getChannel(B){const Y=this;return{call(x,oe,ie){return Y.a?Promise.reject(new C.$7):Y.m(B,x,oe,ie)},listen(x,oe){return Y.a?m.Event.None:Y.o(B,x,oe)}}}m(B,Y,x,oe=A.CancellationToken.None){const ie=this.g++,me=P.Promise,ue={id:ie,type:me,channelName:B,name:Y,arg:x};if(oe.isCancellationRequested)return Promise.reject(new C.$7);let X;return new Promise((se,be)=>{if(oe.isCancellationRequested)return be(new C.$7);const ae=()=>{const Ae=je=>{switch(je.type){case a.PromiseSuccess:this.f.delete(ie),se(je.data);break;case a.PromiseError:{this.f.delete(ie);const He=new Error(je.data.message);He.stack=Array.isArray(je.data.stack)?je.data.stack.join(`
`):je.data.stack,He.name=je.data.name,be(He);break}case a.PromiseErrorObj:this.f.delete(ie),be(je.data);break}};this.f.set(ie,Ae),this.p(ue)};let we=null;this.b===p.Idle?ae():(we=(0,h.$vh)(Ae=>this.u()),we.then(()=>{we=null,ae()}));const $e=()=>{we?(we.cancel(),we=null):this.p({id:ie,type:P.PromiseCancel}),be(new C.$7)},pe=oe.onCancellationRequested($e);X=(0,c.$Uc)((0,c.$Vc)($e),pe),this.d.add(X)}).finally(()=>{X.dispose(),this.d.delete(X)})}o(B,Y,x){const oe=this.g++,ie=P.EventListen,me={id:oe,type:ie,channelName:B,name:Y,arg:x};let ue=null;const X=new m.$oe({onWillAddFirstListener:()=>{ue=(0,h.$vh)(se=>this.u()),ue.then(()=>{ue=null,this.d.add(X),this.p(me)})},onDidRemoveLastListener:()=>{ue?(ue.cancel(),ue=null):(this.d.delete(X),this.p({id:oe,type:P.EventDispose}))}}),q=se=>X.fire(se.data);return this.f.set(oe,q),X.event}p(B){switch(B.type){case P.Promise:case P.EventListen:{const Y=this.q([B.type,B.id,B.channelName,B.name],B.arg);this.j?.logOutgoing(Y,B.id,D.LocalSide,`${b(B.type)}: ${B.channelName}.${B.name}`,B.arg);return}case P.PromiseCancel:case P.EventDispose:{const Y=this.q([B.type,B.id]);this.j?.logOutgoing(Y,B.id,D.LocalSide,b(B.type));return}}}q(B,Y=void 0){const x=new n;return y(x,B),y(x,Y),this.r(x.buffer)}r(B){try{return this.l.send(B),B.byteLength}catch{return 0}}s(B){const Y=new t(B),x=k(Y),oe=k(Y),ie=x[0];switch(ie){case a.Initialize:return this.j?.logIncoming(B.byteLength,0,D.LocalSide,$(ie)),this.t({type:x[0]});case a.PromiseSuccess:case a.PromiseError:case a.EventFire:case a.PromiseErrorObj:return this.j?.logIncoming(B.byteLength,x[1],D.LocalSide,$(ie),oe),this.t({type:x[0],id:x[1],data:oe})}}t(B){if(B.type===a.Initialize){this.b=p.Idle,this.k.fire();return}this.f.get(B.id)?.(B)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}u(){return this.b===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Sc)(this.d.values()),this.d.clear()}}e.$li=T,Ze([O.$ai],T.prototype,"onDidInitializePromise",null);class v{get connections(){const B=[];return this.f.forEach(Y=>B.push(Y)),B}constructor(B,Y,x){this.a=new Map,this.f=new Set,this.g=new m.$oe,this.onDidAddConnection=this.g.event,this.h=new m.$oe,this.onDidRemoveConnection=this.h.event,this.j=new c.$Wc,this.j.add(B(({protocol:oe,onDidClientDisconnect:ie})=>{const me=m.Event.once(oe.onMessage);this.j.add(me(ue=>{const X=new t(ue),q=k(X),se=new S(oe,q,Y,x),be=new T(oe,Y);this.a.forEach((we,$e)=>se.registerChannel($e,we));const ae={channelServer:se,channelClient:be,ctx:q};this.f.add(ae),this.g.fire(ae),this.j.add(ie(()=>{se.dispose(),be.dispose(),this.f.delete(ae),this.h.fire(ae)}))}))}))}getChannel(B,Y){const x=this;return{call(oe,ie,me){let ue;if((0,g.$vg)(Y)){const q=(0,s.$5b)(x.connections.filter(Y));ue=q?Promise.resolve(q):m.Event.toPromise(m.Event.filter(x.onDidAddConnection,Y))}else ue=Y.routeCall(x,oe,ie);const X=ue.then(q=>q.channelClient.getChannel(B));return M(X).call(oe,ie,me)},listen(oe,ie){if((0,g.$vg)(Y))return x.k(B,Y,oe,ie);const me=Y.routeEvent(x,oe,ie).then(ue=>ue.channelClient.getChannel(B));return M(me).listen(oe,ie)}}}k(B,Y,x,oe){const ie=this;let me;const ue=new m.$oe({onWillAddFirstListener:()=>{me=new c.$Wc;const X=new m.$ue,q=new Map,se=ae=>{const $e=ae.channelClient.getChannel(B).listen(x,oe),pe=X.add($e);q.set(ae,pe)},be=ae=>{const we=q.get(ae);we&&(we.dispose(),q.delete(ae))};ie.connections.filter(Y).forEach(se),m.Event.filter(ie.onDidAddConnection,Y)(se,void 0,me),ie.onDidRemoveConnection(be,void 0,me),X.event(ue.fire,ue,me),me.add(X)},onDidRemoveLastListener:()=>{me?.dispose(),me=void 0}});return ue.event}registerChannel(B,Y){this.a.set(B,Y);for(const x of this.f)x.channelServer.registerChannel(B,Y)}dispose(){this.j.dispose();for(const B of this.f)B.channelClient.dispose(),B.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$mi=v;class w{constructor(B,Y,x=null){const oe=new n;y(oe,Y),B.send(oe.buffer),this.a=new T(B,x),this.d=new S(B,Y,x)}getChannel(B){return this.a.getChannel(B)}registerChannel(B,Y){this.d.registerChannel(B,Y)}dispose(){this.a.dispose(),this.d.dispose()}}e.$ni=w;function M(W){return{call(B,Y,x){return W.then(oe=>oe.call(B,Y,x))},listen(B,Y){const x=new m.$xe;return W.then(oe=>x.input=oe.listen(B,Y)),x.event}}}function L(W){let B=!1;return{call(Y,x,oe){return B?W.call(Y,x,oe):(0,h.$Jh)(0).then(()=>B=!0).then(()=>W.call(Y,x,oe))},listen(Y,x){if(B)return W.listen(Y,x);const oe=new m.$xe;return(0,h.$Jh)(0).then(()=>B=!0).then(()=>oe.input=W.listen(Y,x)),oe.event}}}class N{constructor(B){this.a=B}routeCall(B){return this.b(B)}routeEvent(B){return this.b(B)}async b(B){for(const Y of B.connections)if(await Promise.resolve(this.a(Y.ctx)))return Promise.resolve(Y);return await m.Event.toPromise(B.onDidAddConnection),await this.b(B)}}e.$qi=N;var F;(function(W){function B(ie,me,ue){const X=ie,q=ue&&ue.disableMarshalling,se=new Map;for(const be in X)x(be)&&se.set(be,m.Event.buffer(X[be],!0,void 0,me));return new class{listen(be,ae,we){const $e=se.get(ae);if($e)return $e;const pe=X[ae];if(typeof pe=="function"){if(oe(ae))return pe.call(X,we);if(x(ae))return se.set(ae,m.Event.buffer(X[ae],!0,void 0,me)),se.get(ae)}throw new C.$db(`Event not found: ${ae}`)}call(be,ae,we){const $e=X[ae];if(typeof $e=="function"){if(!q&&Array.isArray(we))for(let Ae=0;Ae<we.length;Ae++)we[Ae]=(0,I.$fi)(we[Ae]);let pe=$e.apply(X,we);return pe instanceof Promise||(pe=Promise.resolve(pe)),pe}throw new C.$db(`Method not found: ${ae}`)}}}W.fromService=B;function Y(ie,me){const ue=me&&me.disableMarshalling;return new Proxy({},{get(X,q){if(typeof q=="string")return me?.properties?.has(q)?me.properties.get(q):oe(q)?function(se){return ie.listen(q,se)}:x(q)?ie.listen(q):async function(...se){let be;me&&!(0,g.$qg)(me.context)?be=[me.context,...se]:be=se;const ae=await ie.call(q,be);return ue?ae:(0,I.$fi)(ae)};throw new C.$db(`Property not found: ${String(q)}`)}})}W.toService=Y;function x(ie){return ie[0]==="o"&&ie[1]==="n"&&E.$Hf(ie.charCodeAt(2))}function oe(ie){return/^onDynamic/.test(ie)&&E.$Hf(ie.charCodeAt(9))}})(F||(e.ProxyChannel=F={}));const V=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function j(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){const B=W.toString();if(B!=="[object Object]")return B}return W}function U(W){return Array.isArray(W)?W.map(j):j(W)}function z(W,B,Y,x,oe,ie,me){me=U(me);const ue=V[oe],X=ue[x%ue.length];let q=[`%c[${W}]%c[${String(B).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(x).padStart(5," ")} - ${ie}`,"color: darkgreen","color: grey","color: grey",`color: ${X}`];/\($/.test(ie)?(q=q.concat(me),q.push(")")):q.push(me),console.log.apply(console,q)}class _{constructor(B,Y){this.d=B,this.f=Y,this.a=0,this.b=0}logOutgoing(B,Y,x,oe,ie){this.b+=B,z(this.d,this.b,B,Y,x,oe,ie)}logIncoming(B,Y,x,oe,ie){this.a+=B,z(this.f,this.a,B,Y,x,oe,ie)}}e.$ri=_}),define(Re[70],Ce([1,0,21,4,3,87]),function(ge,e,s,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=e.$vi=e.$ui=e.$ti=e.ProtocolConstants=e.$si=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var O;(function(l){l.Created="created",l.Read="read",l.Write="write",l.Open="open",l.Error="error",l.Close="close",l.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",l.NodeEndReceived="nodeEndReceived",l.NodeEndSent="nodeEndSent",l.NodeDrainBegin="nodeDrainBegin",l.NodeDrainEnd="nodeDrainEnd",l.zlibInflateError="zlibInflateError",l.zlibInflateData="zlibInflateData",l.zlibInflateInitialWrite="zlibInflateInitialWrite",l.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",l.zlibInflateWrite="zlibInflateWrite",l.zlibInflateFlushFired="zlibInflateFlushFired",l.zlibDeflateError="zlibDeflateError",l.zlibDeflateData="zlibDeflateData",l.zlibDeflateWrite="zlibDeflateWrite",l.zlibDeflateFlushFired="zlibDeflateFlushFired",l.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",l.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",l.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",l.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",l.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",l.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",l.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",l.ProtocolHeaderRead="protocolHeaderRead",l.ProtocolMessageRead="protocolMessageRead",l.ProtocolHeaderWrite="protocolHeaderWrite",l.ProtocolMessageWrite="protocolMessageWrite",l.ProtocolWrite="protocolWrite"})(O||(e.SocketDiagnosticsEventType=O={}));var C;(function(l){l.enableDiagnostics=!1,l.records=[];const f=new WeakMap;let y=0;function k(D,T){if(!f.has(D)){const v=String(++y);f.set(D,v)}return f.get(D)}function S(D,T,v,w){if(!l.enableDiagnostics)return;const M=k(D,T);if(w instanceof s.$Qe||w instanceof Uint8Array||w instanceof ArrayBuffer||ArrayBuffer.isView(w)){const L=s.$Qe.alloc(w.byteLength);L.set(w),l.records.push({timestamp:Date.now(),id:M,label:T,type:v,buff:L})}else l.records.push({timestamp:Date.now(),id:M,label:T,type:v,data:w})}l.traceSocketEvent=S})(C||(e.SocketDiagnostics=C={}));var m;(function(l){l[l.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",l[l.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(m||(e.SocketCloseEventType=m={}));let c=null;function I(){return c||(c=s.$Qe.alloc(0)),c}class E{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(f){this.a.push(f),this.b+=f.byteLength}read(f){return this.c(f,!0)}peek(f){return this.c(f,!1)}c(f,y){if(f===0)return I();if(f>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===f){const T=this.a[0];return y&&(this.a.shift(),this.b-=f),T}if(this.a[0].byteLength>f){const T=this.a[0].slice(0,f);return y&&(this.a[0]=this.a[0].slice(f),this.b-=f),T}const k=s.$Qe.alloc(f);let S=0,D=0;for(;f>0;){const T=this.a[D];if(T.byteLength>f){const v=T.slice(0,f);k.set(v,S),S+=f,y&&(this.a[D]=T.slice(f),this.b-=f),f-=f}else k.set(T,S),S+=T.byteLength,y?(this.a.shift(),this.b-=T.byteLength):D++,f-=T.byteLength}return k}}e.$si=E;var g;(function(l){l[l.None=0]="None",l[l.Regular=1]="Regular",l[l.Control=2]="Control",l[l.Ack=3]="Ack",l[l.Disconnect=5]="Disconnect",l[l.ReplayRequest=6]="ReplayRequest",l[l.Pause=7]="Pause",l[l.Resume=8]="Resume",l[l.KeepAlive=9]="KeepAlive"})(g||(g={}));function P(l){switch(l){case g.None:return"None";case g.Regular:return"Regular";case g.Control:return"Control";case g.Ack:return"Ack";case g.Disconnect:return"Disconnect";case g.ReplayRequest:return"ReplayRequest";case g.Pause:return"PauseWriting";case g.Resume:return"ResumeWriting";case g.KeepAlive:return"KeepAlive"}}var b;(function(l){l[l.HeaderLength=13]="HeaderLength",l[l.AcknowledgeTime=2e3]="AcknowledgeTime",l[l.TimeoutTime=2e4]="TimeoutTime",l[l.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",l[l.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",l[l.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(b||(e.ProtocolConstants=b={}));class a{constructor(f,y,k,S){this.type=f,this.id=y,this.ack=k,this.data=S,this.writtenTime=0}get size(){return this.data.byteLength}}class $ extends R.$Xc{constructor(f){super(),this.f=this.B(new h.$oe),this.onMessage=this.f.event,this.g={readHead:!0,readLen:b.HeaderLength,messageType:g.None,id:0,ack:0},this.a=f,this.b=!1,this.c=new E,this.B(this.a.onData(y=>this.acceptChunk(y))),this.lastReadTime=Date.now()}acceptChunk(f){if(!(!f||f.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(f);this.c.byteLength>=this.g.readLen;){const y=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=y.readUInt32BE(9),this.g.messageType=y.readUInt8(0),this.g.id=y.readUInt32BE(1),this.g.ack=y.readUInt32BE(5),this.a.traceSocketEvent(O.ProtocolHeaderRead,{messageType:P(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const k=this.g.messageType,S=this.g.id,D=this.g.ack;if(this.g.readHead=!0,this.g.readLen=b.HeaderLength,this.g.messageType=g.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(O.ProtocolMessageRead,y),this.f.fire(new a(k,S,D,y)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class p{constructor(f){this.k=null,this.a=!1,this.b=!1,this.c=f,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(f){if(this.a)return;f.writtenTime=Date.now(),this.lastWriteTime=Date.now();const y=s.$Qe.alloc(b.HeaderLength);y.writeUInt8(f.type,0),y.writeUInt32BE(f.id,1),y.writeUInt32BE(f.ack,5),y.writeUInt32BE(f.data.byteLength,9),this.c.traceSocketEvent(O.ProtocolHeaderWrite,{messageType:P(f.type),id:f.id,ack:f.ack,messageSize:f.data.byteLength}),this.c.traceSocketEvent(O.ProtocolMessageWrite,f.data),this.j(y,f.data)}g(f,y){const k=this.f===0;return this.d.push(f,y),this.f+=f.byteLength+y.byteLength,k}h(){const f=s.$Qe.concat(this.d,this.f);return this.d.length=0,this.f=0,f}j(f,y){this.g(f,y)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const f=this.h();this.c.traceSocketEvent(O.ProtocolWrite,{byteLength:f.byteLength}),this.c.write(f)}}class u extends R.$Xc{constructor(f){super(),this.f=new h.$oe,this.onMessage=this.f.event,this.g=new h.$oe,this.onDidDispose=this.g.event,this.a=f,this.b=this.B(new p(this.a)),this.c=this.B(new $(this.a)),this.B(this.c.onMessage(y=>{y.type===g.Regular&&this.f.fire(y.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(f){this.b.write(new a(g.Regular,0,0,f))}}e.$ti=u;class i extends A.$ni{static fromSocket(f,y){return new i(new u(f),y)}get onDidDispose(){return this.b.onDidDispose}constructor(f,y,k=null){super(f,y,k),this.b=f}dispose(){super.dispose();const f=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),f.end()}}e.$ui=i;class o{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new h.$oe({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(f){this.b?this.d.length>0?this.d.push(f):this.a.fire(f):this.d.push(f)}flushBuffer(){this.d=[]}}e.$vi=o;class t{constructor(f){this.data=f,this.next=null}}class n{constructor(){this.a=null,this.b=null}length(){let f=0,y=this.a;for(;y;)y=y.next,f++;return f}peek(){return this.a?this.a.data:null}toArray(){const f=[];let y=0,k=this.a;for(;k;)f[y++]=k.data,k=k.next;return f}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(f){const y=new t(f);if(!this.a){this.a=y,this.b=y;return}this.b.next=y,this.b=y}}class r{static{this.a=10}static{this.b=null}static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const f=Date.now();for(let y=0;y<r.a;y++)this.c[y]=f-1e3*y;setInterval(()=>{for(let y=r.a;y>=1;y--)this.c[y]=this.c[y-1];this.c[0]=Date.now()},1e3)}d(){const f=Date.now(),y=(1+r.a)*1e3;let k=0;for(let S=0;S<r.a;S++)f-this.c[S]<=y&&k++;return 1-k/r.a}hasHighLoad(){return this.d()>=.5}}class d{get unacknowledgedCount(){return this.d-this.f}constructor(f){this.v=new o,this.onControlMessage=this.v.event,this.w=new o,this.onMessage=this.w.event,this.x=new o,this.onDidDispose=this.x.event,this.y=new o,this.onSocketClose=this.y.event,this.z=new o,this.onSocketTimeout=this.z.event,this.t=f.loadEstimator??r.getInstance(),this.u=f.sendKeepAlive??!0,this.a=!1,this.c=new n,this.d=0,this.f=0,this.g=null,this.h=0,this.j=0,this.k=0,this.l=null,this.n=0,this.o=Date.now(),this.s=new R.$Wc,this.p=f.socket,this.q=this.s.add(new p(this.p)),this.r=this.s.add(new $(this.p)),this.s.add(this.r.onMessage(y=>this.A(y))),this.s.add(this.p.onClose(y=>this.y.fire(y))),f.initialChunk&&this.r.acceptChunk(f.initialChunk),this.u?this.m=setInterval(()=>{this.E()},b.KeepAliveSendTime):this.m=null}dispose(){this.g&&(clearTimeout(this.g),this.g=null),this.l&&(clearTimeout(this.l),this.l=null),this.m&&(clearInterval(this.m),this.m=null),this.s.dispose()}drain(){return this.q.drain()}sendDisconnect(){if(!this.b){this.b=!0;const f=new a(g.Disconnect,0,0,I());this.q.write(f),this.q.flush()}}sendPause(){const f=new a(g.Pause,0,0,I());this.q.write(f)}sendResume(){const f=new a(g.Resume,0,0,I());this.q.write(f)}pauseSocketWriting(){this.q.pause()}getSocket(){return this.p}getMillisSinceLastIncomingData(){return Date.now()-this.r.lastReadTime}beginAcceptReconnection(f,y){this.a=!0,this.s.dispose(),this.s=new R.$Wc,this.v.flushBuffer(),this.y.flushBuffer(),this.z.flushBuffer(),this.p.dispose(),this.n=0,this.o=Date.now(),this.p=f,this.q=this.s.add(new p(this.p)),this.r=this.s.add(new $(this.p)),this.s.add(this.r.onMessage(k=>this.A(k))),this.s.add(this.p.onClose(k=>this.y.fire(k))),this.r.acceptChunk(y)}endAcceptReconnection(){this.a=!1,this.j=this.h;const f=new a(g.Ack,0,this.j,I());this.q.write(f);const y=this.c.toArray();for(let k=0,S=y.length;k<S;k++)this.q.write(y[k]);this.C()}acceptDisconnect(){this.x.fire()}A(f){if(f.ack>this.f){this.f=f.ack;do{const y=this.c.peek();if(y&&y.id<=f.ack)this.c.pop();else break}while(!0)}switch(f.type){case g.None:break;case g.Regular:{if(f.id>this.h)if(f.id!==this.h+1){const y=Date.now();y-this.n>1e4&&(this.n=y,this.q.write(new a(g.ReplayRequest,0,0,I())))}else this.h=f.id,this.k=Date.now(),this.B(),this.w.fire(f.data);break}case g.Control:{this.v.fire(f.data);break}case g.Ack:break;case g.Disconnect:{this.x.fire();break}case g.ReplayRequest:{const y=this.c.toArray();for(let k=0,S=y.length;k<S;k++)this.q.write(y[k]);this.C();break}case g.Pause:{this.q.pause();break}case g.Resume:{this.q.resume();break}case g.KeepAlive:break}}readEntireBuffer(){return this.r.readEntireBuffer()}flush(){this.q.flush()}send(f){const y=++this.d;this.j=this.h;const k=new a(g.Regular,y,this.j,f);this.c.push(k),this.a||(this.q.write(k),this.C())}sendControl(f){const y=new a(g.Control,0,0,f);this.q.write(y)}B(){if(this.h<=this.j||this.l)return;const f=Date.now()-this.k;if(f>=b.AcknowledgeTime){this.D();return}this.l=setTimeout(()=>{this.l=null,this.B()},b.AcknowledgeTime-f+5)}C(){if(this.d<=this.f||this.g||this.a)return;const f=this.c.peek(),y=Date.now()-f.writtenTime,k=Date.now()-this.r.lastReadTime,S=Date.now()-this.o;if(y>=b.TimeoutTime&&k>=b.TimeoutTime&&S>=b.TimeoutTime&&!this.t.hasHighLoad()){this.o=Date.now(),this.z.fire({unacknowledgedMsgCount:this.c.length(),timeSinceOldestUnacknowledgedMsg:y,timeSinceLastReceivedSomeData:k});return}const D=Math.max(b.TimeoutTime-y,b.TimeoutTime-k,b.TimeoutTime-S,500);this.g=setTimeout(()=>{this.g=null,this.C()},D)}D(){if(this.h<=this.j)return;this.j=this.h;const f=new a(g.Ack,0,this.j,I());this.q.write(f)}E(){this.j=this.h;const f=new a(g.KeepAlive,0,this.j,I());this.q.write(f)}}e.$wi=d}),define(Re[194],Ce([1,0,56,7,21,20,191,12,4,3,24,109,104,87]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=e.$nr=void 0,C=Ue(C);class b extends P.$ki{constructor(p){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:m.Event.fromNodeEventEmitter(process,"message",u=>R.$Qe.wrap(Buffer.from(u,"base64")))},p),process.once("disconnect",()=>this.dispose())}}e.$nr=b;class a{constructor(p,u){this.i=p,this.j=u,this.c=new Set,this.g=new Map,this.h=new m.$oe,this.onDidProcessExit=this.h.event;const i=u&&u.timeout?u.timeout:6e4;this.b=new h.$Fh(i),this.d=null,this.f=null}getChannel(p){const u=this;return{call(i,o,t){return u.k(p,i,o,t)},listen(i,o){return u.l(p,i,o)}}}k(p,u,i,o=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(C.$8());this.b.cancel();const t=this.n(p),n=(0,h.$vh)(l=>t.call(u,i,l)),r=o.onCancellationRequested(()=>n.cancel()),d=(0,c.$Vc)(()=>n.cancel());return this.c.add(d),n.finally(()=>{r.dispose(),this.c.delete(d),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),n}l(p,u,i){if(!this.b)return m.Event.None;this.b.cancel();let o;const t=new m.$oe({onWillAddFirstListener:()=>{o=this.n(p).listen(u,i)(t.fire,t),this.c.add(o)},onDidRemoveLastListener:()=>{this.c.delete(o),o.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return t.event}get m(){if(!this.f){const p=this.j&&this.j.args?this.j.args:[],u=Object.create(null);u.env={...(0,I.$io)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(u.env={...u.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(u.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(y=>!/^--inspect(-brk)?=/.test(y)).filter(y=>!y.startsWith("--vscode-"))),(0,g.$pm)(u.env),this.d=(0,s.fork)(this.i,p,u);const i=new m.$oe,t=m.Event.fromNodeEventEmitter(this.d,"message",y=>y)(y=>{if((0,O.$jr)(y)){(0,O.log)(y,`IPC Library: ${this.j.serverName}`);return}i.fire(R.$Qe.wrap(Buffer.from(y,"base64")))}),n=this.j.useQueue?(0,E.$Cm)(this.d):this.d,r=y=>this.d&&this.d.connected&&n.send(y.buffer.toString("base64")),d=i.event,l={send:r,onMessage:d};this.f=new P.$li(l);const f=()=>this.o();process.once("exit",f),this.d.on("error",y=>console.warn('IPC "'+this.j.serverName+'" errored with '+y)),this.d.on("exit",(y,k)=>{process.removeListener("exit",f),t.dispose(),this.c.forEach(S=>(0,c.$Sc)(S)),this.c.clear(),y!==0&&k!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+y+" and signal "+k),this.b?.cancel(),this.o(),this.h.fire({code:y,signal:k})})}return this.f}n(p){let u=this.g.get(p);return u||(u=this.m.getChannel(p),this.g.set(p,u)),u}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$or=a}),define(Re[195],Ce([1,0,7,4,3,38,17]),function(ge,e,s,h,R,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$iq=e.StorageState=e.StorageHint=void 0,e.$hq=m;var C;(function(g){g[g.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",g[g.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(C||(e.StorageHint=C={}));function m(g){const P=g;return P?.changed instanceof Map||P?.deleted instanceof Set}var c;(function(g){g[g.None=0]="None",g[g.Initialized=1]="Initialized",g[g.Closed=2]="Closed"})(c||(e.StorageState=c={}));class I extends R.$Xc{static{this.a=100}constructor(P,b=Object.create(null)){super(),this.r=P,this.s=b,this.b=this.B(new h.$re),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new s.$Gh(I.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(P=>this.u(P)))}u(P){this.b.pause();try{P.changed?.forEach((b,a)=>this.w(a,b)),P.deleted?.forEach(b=>this.w(b,void 0))}finally{this.b.resume()}}w(P,b){if(this.c===c.Closed)return;let a=!1;(0,O.$qg)(b)?a=this.f.delete(P):this.f.get(P)!==b&&(this.f.set(P,b),a=!0),a&&this.b.fire({key:P,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==C.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(P,b){const a=this.f.get(P);return(0,O.$qg)(a)?b:a}getBoolean(P,b){const a=this.get(P);return(0,O.$qg)(a)?b:a==="true"}getNumber(P,b){const a=this.get(P);return(0,O.$qg)(a)?b:parseInt(a,10)}getObject(P,b){const a=this.get(P);return(0,O.$qg)(a)?b:(0,A.$ei)(a)}async set(P,b,a=!1){if(this.c===c.Closed)return;if((0,O.$qg)(b))return this.delete(P,a);const $=(0,O.$jg)(b)||Array.isArray(b)?(0,A.$di)(b):String(b);if(this.f.get(P)!==$)return this.f.set(P,$),this.j.set(P,$),this.h.delete(P),this.b.fire({key:P,external:a}),this.D()}async delete(P,b=!1){if(!(this.c===c.Closed||!this.f.delete(P)))return this.h.has(P)||this.h.add(P),this.j.delete(P),this.b.fire({key:P,external:b}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const P={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(P).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(P){if(!(this.c===c.Closed||this.m))return this.D(P)}async D(P){return this.s.hint===C.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),P)}async whenFlushed(){if(this.z)return new Promise(P=>this.n.push(P))}isInMemory(){return this.s.hint===C.STORAGE_IN_MEMORY}}e.$iq=I;class E{constructor(){this.onDidChangeItemsExternal=h.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(P){P.insert?.forEach((b,a)=>this.a.set(a,b)),P.delete?.forEach(b=>this.a.delete(b))}async optimize(){}async close(){}}e.$jq=E}),define(Re[141],Ce([1,0,85]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ou=e.$nu=void 0;class h{constructor(C){const m=(0,s.$df)(C);this.c=m,this.a=h.d(m),this.b=new Map}static d(C){const m=new Uint8Array(256);return m.fill(C),m}set(C,m){const c=(0,s.$df)(m);C>=0&&C<256?this.a[C]=c:this.b.set(C,c)}get(C){return C>=0&&C<256?this.a[C]:this.b.get(C)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$nu=h;var R;(function(O){O[O.False=0]="False",O[O.True=1]="True"})(R||(R={}));class A{constructor(){this.a=new h(R.False)}add(C){this.a.set(C,R.True)}has(C){return this.a.get(C)===R.True}clear(){return this.a.clear()}}e.$ou=A}),define(Re[196],Ce([1,0,26]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Fu=R;var h;(function(A){A[A.Unknown=0]="Unknown",A[A.Invalid=3]="Invalid",A[A.LF=1]="LF",A[A.CRLF=2]="CRLF"})(h||(e.StringEOL=h={}));function R(A){let O=0,C=0,m=0,c=h.Unknown;for(let I=0,E=A.length;I<E;I++){const g=A.charCodeAt(I);g===s.CharCode.CarriageReturn?(O===0&&(C=I),O++,I+1<E&&A.charCodeAt(I+1)===s.CharCode.LineFeed?(c|=h.CRLF,I++):c|=h.Invalid,m=I+1):g===s.CharCode.LineFeed&&(c|=h.LF,O===0&&(C=I),O++,m=I+1)}return O===0&&(C=A.length),[O,C,A.length-m,c]}}),define(Re[57],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tt=void 0;class s{constructor(R,A){this.lineNumber=R,this.column=A}with(R=this.lineNumber,A=this.column){return R===this.lineNumber&&A===this.column?this:new s(R,A)}delta(R=0,A=0){return this.with(this.lineNumber+R,this.column+A)}equals(R){return s.equals(this,R)}static equals(R,A){return!R&&!A?!0:!!R&&!!A&&R.lineNumber===A.lineNumber&&R.column===A.column}isBefore(R){return s.isBefore(this,R)}static isBefore(R,A){return R.lineNumber<A.lineNumber?!0:A.lineNumber<R.lineNumber?!1:R.column<A.column}isBeforeOrEqual(R){return s.isBeforeOrEqual(this,R)}static isBeforeOrEqual(R,A){return R.lineNumber<A.lineNumber?!0:A.lineNumber<R.lineNumber?!1:R.column<=A.column}static compare(R,A){const O=R.lineNumber|0,C=A.lineNumber|0;if(O===C){const m=R.column|0,c=A.column|0;return m-c}return O-C}clone(){return new s(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(R){return new s(R.lineNumber,R.column)}static isIPosition(R){return R&&typeof R.lineNumber=="number"&&typeof R.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Tt=s}),define(Re[30],Ce([1,0,57]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ut=void 0;class h{constructor(A,O,C,m){A>C||A===C&&O>m?(this.startLineNumber=C,this.startColumn=m,this.endLineNumber=A,this.endColumn=O):(this.startLineNumber=A,this.startColumn=O,this.endLineNumber=C,this.endColumn=m)}isEmpty(){return h.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return h.containsPosition(this,A)}static containsPosition(A,O){return!(O.lineNumber<A.startLineNumber||O.lineNumber>A.endLineNumber||O.lineNumber===A.startLineNumber&&O.column<A.startColumn||O.lineNumber===A.endLineNumber&&O.column>A.endColumn)}static strictContainsPosition(A,O){return!(O.lineNumber<A.startLineNumber||O.lineNumber>A.endLineNumber||O.lineNumber===A.startLineNumber&&O.column<=A.startColumn||O.lineNumber===A.endLineNumber&&O.column>=A.endColumn)}containsRange(A){return h.containsRange(this,A)}static containsRange(A,O){return!(O.startLineNumber<A.startLineNumber||O.endLineNumber<A.startLineNumber||O.startLineNumber>A.endLineNumber||O.endLineNumber>A.endLineNumber||O.startLineNumber===A.startLineNumber&&O.startColumn<A.startColumn||O.endLineNumber===A.endLineNumber&&O.endColumn>A.endColumn)}strictContainsRange(A){return h.strictContainsRange(this,A)}static strictContainsRange(A,O){return!(O.startLineNumber<A.startLineNumber||O.endLineNumber<A.startLineNumber||O.startLineNumber>A.endLineNumber||O.endLineNumber>A.endLineNumber||O.startLineNumber===A.startLineNumber&&O.startColumn<=A.startColumn||O.endLineNumber===A.endLineNumber&&O.endColumn>=A.endColumn)}plusRange(A){return h.plusRange(this,A)}static plusRange(A,O){let C,m,c,I;return O.startLineNumber<A.startLineNumber?(C=O.startLineNumber,m=O.startColumn):O.startLineNumber===A.startLineNumber?(C=O.startLineNumber,m=Math.min(O.startColumn,A.startColumn)):(C=A.startLineNumber,m=A.startColumn),O.endLineNumber>A.endLineNumber?(c=O.endLineNumber,I=O.endColumn):O.endLineNumber===A.endLineNumber?(c=O.endLineNumber,I=Math.max(O.endColumn,A.endColumn)):(c=A.endLineNumber,I=A.endColumn),new h(C,m,c,I)}intersectRanges(A){return h.intersectRanges(this,A)}static intersectRanges(A,O){let C=A.startLineNumber,m=A.startColumn,c=A.endLineNumber,I=A.endColumn;const E=O.startLineNumber,g=O.startColumn,P=O.endLineNumber,b=O.endColumn;return C<E?(C=E,m=g):C===E&&(m=Math.max(m,g)),c>P?(c=P,I=b):c===P&&(I=Math.min(I,b)),C>c||C===c&&m>I?null:new h(C,m,c,I)}equalsRange(A){return h.equalsRange(this,A)}static equalsRange(A,O){return!A&&!O?!0:!!A&&!!O&&A.startLineNumber===O.startLineNumber&&A.startColumn===O.startColumn&&A.endLineNumber===O.endLineNumber&&A.endColumn===O.endColumn}getEndPosition(){return h.getEndPosition(this)}static getEndPosition(A){return new s.$Tt(A.endLineNumber,A.endColumn)}getStartPosition(){return h.getStartPosition(this)}static getStartPosition(A){return new s.$Tt(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,O){return new h(this.startLineNumber,this.startColumn,A,O)}setStartPosition(A,O){return new h(A,O,this.endLineNumber,this.endColumn)}collapseToStart(){return h.collapseToStart(this)}static collapseToStart(A){return new h(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}collapseToEnd(){return h.collapseToEnd(this)}static collapseToEnd(A){return new h(A.endLineNumber,A.endColumn,A.endLineNumber,A.endColumn)}delta(A){return new h(this.startLineNumber+A,this.startColumn,this.endLineNumber+A,this.endColumn)}static fromPositions(A,O=A){return new h(A.lineNumber,A.column,O.lineNumber,O.column)}static lift(A){return A?new h(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,O){return!(A.endLineNumber<O.startLineNumber||A.endLineNumber===O.startLineNumber&&A.endColumn<O.startColumn||O.endLineNumber<A.startLineNumber||O.endLineNumber===A.startLineNumber&&O.endColumn<A.startColumn)}static areIntersecting(A,O){return!(A.endLineNumber<O.startLineNumber||A.endLineNumber===O.startLineNumber&&A.endColumn<=O.startColumn||O.endLineNumber<A.startLineNumber||O.endLineNumber===A.startLineNumber&&O.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,O){if(A&&O){const c=A.startLineNumber|0,I=O.startLineNumber|0;if(c===I){const E=A.startColumn|0,g=O.startColumn|0;if(E===g){const P=A.endLineNumber|0,b=O.endLineNumber|0;if(P===b){const a=A.endColumn|0,$=O.endColumn|0;return a-$}return P-b}return E-g}return c-I}return(A?1:0)-(O?1:0)}static compareRangesUsingEnds(A,O){return A.endLineNumber===O.endLineNumber?A.endColumn===O.endColumn?A.startLineNumber===O.startLineNumber?A.startColumn-O.startColumn:A.startLineNumber-O.startLineNumber:A.endColumn-O.endColumn:A.endLineNumber-O.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}toJSON(){return this}}e.$Ut=h}),define(Re[197],Ce([1,0,30]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vt=void 0;class h{static insert(A,O){return{range:new s.$Ut(A.lineNumber,A.column,A.lineNumber,A.column),text:O,forceMoveMarkers:!0}}static delete(A){return{range:A,text:null}}static replace(A,O){return{range:A,text:O}}static replaceMove(A,O){return{range:A,text:O,forceMoveMarkers:!0}}}e.$Vt=h}),define(Re[198],Ce([1,0,57,30]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wt=e.SelectionDirection=void 0;var R;(function(O){O[O.LTR=0]="LTR",O[O.RTL=1]="RTL"})(R||(e.SelectionDirection=R={}));class A extends h.$Ut{constructor(C,m,c,I){super(C,m,c,I),this.selectionStartLineNumber=C,this.selectionStartColumn=m,this.positionLineNumber=c,this.positionColumn=I}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(C){return A.selectionsEqual(this,C)}static selectionsEqual(C,m){return C.selectionStartLineNumber===m.selectionStartLineNumber&&C.selectionStartColumn===m.selectionStartColumn&&C.positionLineNumber===m.positionLineNumber&&C.positionColumn===m.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?R.LTR:R.RTL}setEndPosition(C,m){return this.getDirection()===R.LTR?new A(this.startLineNumber,this.startColumn,C,m):new A(C,m,this.startLineNumber,this.startColumn)}getPosition(){return new s.$Tt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new s.$Tt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(C,m){return this.getDirection()===R.LTR?new A(C,m,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,C,m)}static fromPositions(C,m=C){return new A(C.lineNumber,C.column,m.lineNumber,m.column)}static fromRange(C,m){return m===R.LTR?new A(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn):new A(C.endLineNumber,C.endColumn,C.startLineNumber,C.startColumn)}static liftSelection(C){return new A(C.selectionStartLineNumber,C.selectionStartColumn,C.positionLineNumber,C.positionColumn)}static selectionsArrEqual(C,m){if(C&&!m||!C&&m)return!1;if(!C&&!m)return!0;if(C.length!==m.length)return!1;for(let c=0,I=C.length;c<I;c++)if(!this.selectionsEqual(C[c],m[c]))return!1;return!0}static isISelection(C){return C&&typeof C.selectionStartLineNumber=="number"&&typeof C.selectionStartColumn=="number"&&typeof C.positionLineNumber=="number"&&typeof C.positionColumn=="number"}static createWithDirection(C,m,c,I,E){return E===R.LTR?new A(C,m,c,I):new A(c,I,C,m)}}e.$Wt=A}),define(Re[199],Ce([1,0,13,10,21]),function(ge,e,s,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ku=void 0,e.$iu=I,e.$ju=E,s=Ue(s),h=Ue(h),R=Ue(R);let A;function O(){return A||(A=new TextDecoder("UTF-16LE")),A}let C;function m(){return C||(C=new TextDecoder("UTF-16BE")),C}let c;function I(){return c||(c=h.$E()?O():m()),c}function E(b,a,$){const p=new Uint16Array(b.buffer,a,$);return $>0&&(p[0]===65279||p[0]===65534)?g(b,a,$):O().decode(p)}function g(b,a,$){const p=[];let u=0;for(let i=0;i<$;i++){const o=R.$Se(b,a);a+=2,p[u++]=String.fromCharCode(o)}return p.join("")}class P{constructor(a){this.a=a|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const a=new Uint16Array(this.b.buffer,0,this.d);return I().decode(a)}f(){const a=this.e();this.d=0,this.c===null?this.c=[a]:this.c[this.c.length]=a}appendCharCode(a){const $=this.a-this.d;$<=1&&($===0||s.$Mf(a))&&this.f(),this.b[this.d++]=a}appendASCIICharCode(a){this.d===this.a&&this.f(),this.b[this.d++]=a}appendString(a){const $=a.length;if(this.d+$>=this.a){this.f(),this.c[this.c.length]=a;return}for(let p=0;p<$;p++)this.b[this.d++]=a.charCodeAt(p)}}e.$ku=P}),define(Re[200],Ce([1,0,21,199]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lu=void 0,e.$mu=O,s=Ue(s);function R(m){return m.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class A{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(c,I,E,g){this.oldPosition=c,this.oldText=I,this.newPosition=E,this.newText=g}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${R(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${R(this.oldText)}")`:`(replace@${this.oldPosition} "${R(this.oldText)}" with "${R(this.newText)}")`}static a(c){return 4+2*c.length}static c(c,I,E){const g=I.length;s.$Ve(c,g,E),E+=4;for(let P=0;P<g;P++)s.$Te(c,I.charCodeAt(P),E),E+=2;return E}static d(c,I){const E=s.$Ue(c,I);return I+=4,(0,h.$ju)(c,I,E)}writeSize(){return 8+A.a(this.oldText)+A.a(this.newText)}write(c,I){return s.$Ve(c,this.oldPosition,I),I+=4,s.$Ve(c,this.newPosition,I),I+=4,I=A.c(c,this.oldText,I),I=A.c(c,this.newText,I),I}static read(c,I,E){const g=s.$Ue(c,I);I+=4;const P=s.$Ue(c,I);I+=4;const b=A.d(c,I);I+=A.a(b);const a=A.d(c,I);return I+=A.a(a),E.push(new A(g,b,P,a)),I}}e.$lu=A;function O(m,c){return m===null||m.length===0?c:new C(m,c).compress()}class C{constructor(c,I){this.a=c,this.c=I,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let c=0,I=0,E=this.n(c),g=this.l(I);for(;c<this.f||I<this.h;){if(E===null){this.k(g),g=this.l(++I);continue}if(g===null){this.m(E),E=this.n(++c);continue}if(g.oldEnd<=E.newPosition){this.k(g),g=this.l(++I);continue}if(E.newEnd<=g.oldPosition){this.m(E),E=this.n(++c);continue}if(g.oldPosition<E.newPosition){const[p,u]=C.r(g,E.newPosition-g.oldPosition);this.k(p),g=u;continue}if(E.newPosition<g.oldPosition){const[p,u]=C.q(E,g.oldPosition-E.newPosition);this.m(p),E=u;continue}let a,$;if(g.oldEnd===E.newEnd)a=E,$=g,E=this.n(++c),g=this.l(++I);else if(g.oldEnd<E.newEnd){const[p,u]=C.q(E,g.oldLength);a=p,$=g,E=u,g=this.l(++I)}else{const[p,u]=C.r(g,E.newLength);a=E,$=p,E=this.n(++c),g=u}this.d[this.e++]=new A(a.oldPosition,a.oldText,$.newPosition,$.newText),this.g+=a.newLength-a.oldLength,this.j+=$.newLength-$.oldLength}const P=C.s(this.d);return C.t(P)}k(c){this.d[this.e++]=C.o(this.g,c),this.j+=c.newLength-c.oldLength}l(c){return c<this.h?this.c[c]:null}m(c){this.d[this.e++]=C.p(this.j,c),this.g+=c.newLength-c.oldLength}n(c){return c<this.f?this.a[c]:null}static o(c,I){return new A(I.oldPosition-c,I.oldText,I.newPosition,I.newText)}static p(c,I){return new A(I.oldPosition,I.oldText,I.newPosition+c,I.newText)}static q(c,I){const E=c.newText.substr(0,I),g=c.newText.substr(I);return[new A(c.oldPosition,c.oldText,c.newPosition,E),new A(c.oldEnd,"",c.newPosition+I,g)]}static r(c,I){const E=c.oldText.substr(0,I),g=c.oldText.substr(I);return[new A(c.oldPosition,E,c.newPosition,c.newText),new A(c.oldPosition+I,g,c.newEnd,"")]}static s(c){if(c.length===0)return c;const I=[];let E=0,g=c[0];for(let P=1;P<c.length;P++){const b=c[P];g.oldEnd===b.oldPosition?g=new A(g.oldPosition,g.oldText+b.oldText,g.newPosition,g.newText+b.newText):(I[E++]=g,g=b)}return I[E++]=g,I}static t(c){if(c.length===0)return c;const I=[];let E=0;for(let g=0;g<c.length;g++){const P=c[g];P.oldText!==P.newText&&(I[E++]=P)}return I}}}),define(Re[201],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rt=void 0,e.$rt={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Re[202],Ce([1,0,26,28,141]),function(ge,e,s,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pu=e.WordCharacterClass=void 0,e.$qu=m;var A;(function(c){c[c.Regular=0]="Regular",c[c.Whitespace=1]="Whitespace",c[c.WordSeparator=2]="WordSeparator"})(A||(e.WordCharacterClass=A={}));class O extends R.$nu{constructor(I,E){super(A.Regular),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=E,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let g=0,P=I.length;g<P;g++)this.set(I.charCodeAt(g),A.WordSeparator);this.set(s.CharCode.Space,A.Whitespace),this.set(s.CharCode.Tab,A.Whitespace)}findPrevIntlWordBeforeOrAtOffset(I,E){let g=null;for(const P of this.h(I)){if(P.index>E)break;g=P}return g}findNextIntlWordAtOrAfterOffset(I,E){for(const g of this.h(I))if(!(g.index<E))return g;return null}h(I){return this.e?this.f===I?this.g:(this.f=I,this.g=this.j(this.e.segment(I)),this.g):[]}j(I){const E=[];for(const g of I)this.k(g)&&E.push(g);return E}k(I){return!!I.isWordLike}}e.$pu=O;const C=new h.$Gc(10);function m(c,I){const E=`${c}/${I.join(",")}`;let g=C.get(E);return g||(g=new O(c,I),C.set(E,g)),g}}),define(Re[142],Ce([1,0,40,3,82]),function(ge,e,s,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=e.$st=void 0,e.$ut=O,e.$vt=m,e.$wt=c,e.$st="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function A(E=""){let g="(-?\\d*\\.\\d\\w*)|([^";for(const P of e.$st)E.indexOf(P)>=0||(g+="\\"+P);return g+="\\s]+)",new RegExp(g,"g")}e.$tt=A();function O(E){let g=e.$tt;if(E&&E instanceof RegExp)if(E.global)g=E;else{let P="g";E.ignoreCase&&(P+="i"),E.multiline&&(P+="m"),E.unicode&&(P+="u"),g=new RegExp(E.source,P)}return g.lastIndex=0,g}const C=new R.$8c;C.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function m(E){const g=C.unshift(E);return(0,h.$Vc)(g)}function c(E,g,P,b,a){if(g=O(g),a||(a=s.Iterable.first(C)),P.length>a.maxLen){let o=E-a.maxLen/2;return o<0?o=0:b+=o,P=P.substring(o,E+a.maxLen/2),c(E,g,P,b,a)}const $=Date.now(),p=E-1-b;let u=-1,i=null;for(let o=1;!(Date.now()-$>=a.timeBudget);o++){const t=p-a.windowSize*o;g.lastIndex=Math.max(0,t);const n=I(g,P,p,u);if(!n&&i||(i=n,t<=0))break;u=t}if(i){const o={word:i[0],startColumn:b+1+i.index,endColumn:b+1+i.index+i[0].length};return g.lastIndex=0,o}return null}function I(E,g,P,b){let a;for(;a=E.exec(g);){const $=a.index||0;if($<=P&&E.lastIndex>=P)return a;if(b>0&&$>b)return null}return null}}),define(Re[110],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bu=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var s;(function(m){m[m.Null=0]="Null",m[m.PlainText=1]="PlainText"})(s||(e.LanguageId=s={}));var h;(function(m){m[m.NotSet=-1]="NotSet",m[m.None=0]="None",m[m.Italic=1]="Italic",m[m.Bold=2]="Bold",m[m.Underline=4]="Underline",m[m.Strikethrough=8]="Strikethrough"})(h||(e.FontStyle=h={}));var R;(function(m){m[m.None=0]="None",m[m.DefaultForeground=1]="DefaultForeground",m[m.DefaultBackground=2]="DefaultBackground"})(R||(e.ColorId=R={}));var A;(function(m){m[m.Other=0]="Other",m[m.Comment=1]="Comment",m[m.String=2]="String",m[m.RegEx=3]="RegEx"})(A||(e.StandardTokenType=A={}));var O;(function(m){m[m.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",m[m.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",m[m.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",m[m.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",m[m.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",m[m.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",m[m.ITALIC_MASK=2048]="ITALIC_MASK",m[m.BOLD_MASK=4096]="BOLD_MASK",m[m.UNDERLINE_MASK=8192]="UNDERLINE_MASK",m[m.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",m[m.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",m[m.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",m[m.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",m[m.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",m[m.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",m[m.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",m[m.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",m[m.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",m[m.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",m[m.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",m[m.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",m[m.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(O||(e.MetadataConsts=O={}));class C{static getLanguageId(c){return(c&O.LANGUAGEID_MASK)>>>O.LANGUAGEID_OFFSET}static getTokenType(c){return(c&O.TOKEN_TYPE_MASK)>>>O.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(c){return(c&O.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(c){return(c&O.FONT_STYLE_MASK)>>>O.FONT_STYLE_OFFSET}static getForeground(c){return(c&O.FOREGROUND_MASK)>>>O.FOREGROUND_OFFSET}static getBackground(c){return(c&O.BACKGROUND_MASK)>>>O.BACKGROUND_OFFSET}static getClassNameFromMetadata(c){let E="mtk"+this.getForeground(c);const g=this.getFontStyle(c);return g&h.Italic&&(E+=" mtki"),g&h.Bold&&(E+=" mtkb"),g&h.Underline&&(E+=" mtku"),g&h.Strikethrough&&(E+=" mtks"),E}static getInlineStyleFromMetadata(c,I){const E=this.getForeground(c),g=this.getFontStyle(c);let P=`color: ${I[E]};`;g&h.Italic&&(P+="font-style: italic;"),g&h.Bold&&(P+="font-weight: bold;");let b="";return g&h.Underline&&(b+=" underline"),g&h.Strikethrough&&(b+=" line-through"),b&&(P+=`text-decoration:${b};`),P}static getPresentationFromMetadata(c){const I=this.getForeground(c),E=this.getFontStyle(c);return{foreground:I,italic:!!(E&h.Italic),bold:!!(E&h.Bold),underline:!!(E&h.Underline),strikethrough:!!(E&h.Strikethrough)}}}e.$Bu=C}),define(Re[203],Ce([1,0,39,16]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cu=R,e.$Du=A;function R(O,C,m,c,I,E){if(Array.isArray(O)){let g=0;for(const P of O){const b=R(P,C,m,c,I,E);if(b===10)return b;b>g&&(g=b)}return g}else{if(typeof O=="string")return c?O==="*"?5:O===m?10:0:0;if(O){const{language:g,pattern:P,scheme:b,hasAccessToAllModels:a,notebookType:$}=O;if(!c&&!a)return 0;$&&I&&(C=I);let p=0;if(b)if(b===C.scheme)p=10;else if(b==="*")p=5;else return 0;if(g)if(g===m)p=10;else if(g==="*")p=Math.max(p,5);else return 0;if($)if($===E)p=10;else if($==="*"&&E!==void 0)p=Math.max(p,5);else return 0;if(P){let u;if(typeof P=="string"?u=P:u={...P,base:(0,h.$kc)(P.base)},u===C.fsPath||(0,s.$Ck)(u,C.fsPath))p=10;else return 0}return p}else return 0}}function A(O){return typeof O=="string"?!1:Array.isArray(O)?O.some(A):!!O.notebookType}}),define(Re[204],Ce([1,0,26,110]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5u=e.$4u=e.IndentAction=void 0;var R;(function(m){m[m.None=0]="None",m[m.Indent=1]="Indent",m[m.IndentOutdent=2]="IndentOutdent",m[m.Outdent=3]="Outdent"})(R||(e.IndentAction=R={}));class A{constructor(c){if(this.e=null,this.f=!1,this.open=c.open,this.close=c.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(c.notIn))for(let I=0,E=c.notIn.length;I<E;I++)switch(c.notIn[I]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(c){switch(c){case h.StandardTokenType.Other:return!0;case h.StandardTokenType.Comment:return this.c;case h.StandardTokenType.String:return this.b;case h.StandardTokenType.RegEx:return this.d}}shouldAutoClose(c,I){if(c.getTokenCount()===0)return!0;const E=c.findTokenIndexAtOffset(I-2),g=c.getStandardTokenType(E);return this.isOK(g)}g(c,I){for(let E=c;E<=I;E++){const g=String.fromCharCode(E);if(!this.open.includes(g)&&!this.close.includes(g))return g}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(s.CharCode.Digit0,s.CharCode.Digit9)),this.e||(this.e=this.g(s.CharCode.a,s.CharCode.z)),this.e||(this.e=this.g(s.CharCode.A,s.CharCode.Z))),this.e}}e.$4u=A;class O{constructor(c){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const I of c)C(this.autoClosingPairsOpenByStart,I.open.charAt(0),I),C(this.autoClosingPairsOpenByEnd,I.open.charAt(I.open.length-1),I),C(this.autoClosingPairsCloseByStart,I.close.charAt(0),I),C(this.autoClosingPairsCloseByEnd,I.close.charAt(I.close.length-1),I),I.close.length===1&&I.open.length===1&&C(this.autoClosingPairsCloseSingleChar,I.close,I)}}e.$5u=O;function C(m,c,I){m.has(c)?m.get(c).push(I):m.set(c,[I])}}),define(Re[205],Ce([1,0,26,141]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$44=e.$34=e.State=void 0,e.$54=P;var R;(function(b){b[b.Invalid=0]="Invalid",b[b.Start=1]="Start",b[b.H=2]="H",b[b.HT=3]="HT",b[b.HTT=4]="HTT",b[b.HTTP=5]="HTTP",b[b.F=6]="F",b[b.FI=7]="FI",b[b.FIL=8]="FIL",b[b.BeforeColon=9]="BeforeColon",b[b.AfterColon=10]="AfterColon",b[b.AlmostThere=11]="AlmostThere",b[b.End=12]="End",b[b.Accept=13]="Accept",b[b.LastKnownState=14]="LastKnownState"})(R||(e.State=R={}));class A{constructor(a,$,p){const u=new Uint8Array(a*$);for(let i=0,o=a*$;i<o;i++)u[i]=p;this.a=u,this.rows=a,this.cols=$}get(a,$){return this.a[a*this.cols+$]}set(a,$,p){this.a[a*this.cols+$]=p}}class O{constructor(a){let $=0,p=R.Invalid;for(let i=0,o=a.length;i<o;i++){const[t,n,r]=a[i];n>$&&($=n),t>p&&(p=t),r>p&&(p=r)}$++,p++;const u=new A(p,$,R.Invalid);for(let i=0,o=a.length;i<o;i++){const[t,n,r]=a[i];u.set(t,n,r)}this.a=u,this.b=$}nextState(a,$){return $<0||$>=this.b?R.Invalid:this.a.get(a,$)}}e.$34=O;let C=null;function m(){return C===null&&(C=new O([[R.Start,s.CharCode.h,R.H],[R.Start,s.CharCode.H,R.H],[R.Start,s.CharCode.f,R.F],[R.Start,s.CharCode.F,R.F],[R.H,s.CharCode.t,R.HT],[R.H,s.CharCode.T,R.HT],[R.HT,s.CharCode.t,R.HTT],[R.HT,s.CharCode.T,R.HTT],[R.HTT,s.CharCode.p,R.HTTP],[R.HTT,s.CharCode.P,R.HTTP],[R.HTTP,s.CharCode.s,R.BeforeColon],[R.HTTP,s.CharCode.S,R.BeforeColon],[R.HTTP,s.CharCode.Colon,R.AfterColon],[R.F,s.CharCode.i,R.FI],[R.F,s.CharCode.I,R.FI],[R.FI,s.CharCode.l,R.FIL],[R.FI,s.CharCode.L,R.FIL],[R.FIL,s.CharCode.e,R.BeforeColon],[R.FIL,s.CharCode.E,R.BeforeColon],[R.BeforeColon,s.CharCode.Colon,R.AfterColon],[R.AfterColon,s.CharCode.Slash,R.AlmostThere],[R.AlmostThere,s.CharCode.Slash,R.End]])),C}var c;(function(b){b[b.None=0]="None",b[b.ForceTermination=1]="ForceTermination",b[b.CannotEndIn=2]="CannotEndIn"})(c||(c={}));let I=null;function E(){if(I===null){I=new h.$nu(c.None);const b=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let $=0;$<b.length;$++)I.set(b.charCodeAt($),c.ForceTermination);const a=".,;:";for(let $=0;$<a.length;$++)I.set(a.charCodeAt($),c.CannotEndIn)}return I}class g{static a(a,$,p,u,i){let o=i-1;do{const t=$.charCodeAt(o);if(a.get(t)!==c.CannotEndIn)break;o--}while(o>u);if(u>0){const t=$.charCodeAt(u-1),n=$.charCodeAt(o);(t===s.CharCode.OpenParen&&n===s.CharCode.CloseParen||t===s.CharCode.OpenSquareBracket&&n===s.CharCode.CloseSquareBracket||t===s.CharCode.OpenCurlyBrace&&n===s.CharCode.CloseCurlyBrace)&&o--}return{range:{startLineNumber:p,startColumn:u+1,endLineNumber:p,endColumn:o+2},url:$.substring(u,o+1)}}static computeLinks(a,$=m()){const p=E(),u=[];for(let i=1,o=a.getLineCount();i<=o;i++){const t=a.getLineContent(i),n=t.length;let r=0,d=0,l=0,f=R.Start,y=!1,k=!1,S=!1,D=!1;for(;r<n;){let T=!1;const v=t.charCodeAt(r);if(f===R.Accept){let w;switch(v){case s.CharCode.OpenParen:y=!0,w=c.None;break;case s.CharCode.CloseParen:w=y?c.None:c.ForceTermination;break;case s.CharCode.OpenSquareBracket:S=!0,k=!0,w=c.None;break;case s.CharCode.CloseSquareBracket:S=!1,w=k?c.None:c.ForceTermination;break;case s.CharCode.OpenCurlyBrace:D=!0,w=c.None;break;case s.CharCode.CloseCurlyBrace:w=D?c.None:c.ForceTermination;break;case s.CharCode.SingleQuote:case s.CharCode.DoubleQuote:case s.CharCode.BackTick:l===v?w=c.ForceTermination:l===s.CharCode.SingleQuote||l===s.CharCode.DoubleQuote||l===s.CharCode.BackTick?w=c.None:w=c.ForceTermination;break;case s.CharCode.Asterisk:w=l===s.CharCode.Asterisk?c.ForceTermination:c.None;break;case s.CharCode.Pipe:w=l===s.CharCode.Pipe?c.ForceTermination:c.None;break;case s.CharCode.Space:w=S?c.None:c.ForceTermination;break;default:w=p.get(v)}w===c.ForceTermination&&(u.push(g.a(p,t,i,d,r)),T=!0)}else if(f===R.End){let w;v===s.CharCode.OpenSquareBracket?(k=!0,w=c.None):w=p.get(v),w===c.ForceTermination?T=!0:f=R.Accept}else f=$.nextState(f,v),f===R.Invalid&&(T=!0);T&&(f=R.Start,y=!1,k=!1,D=!1,d=r+1,l=v),r++}f===R.Accept&&u.push(g.a(p,t,i,d,n))}return u}}e.$44=g;function P(b){return!b||typeof b.getLineCount!="function"||typeof b.getLineContent!="function"?[]:g.computeLinks(b)}}),define(Re[58],Ce([1,0,24]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pw=e.$ow=e.$nw=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$lw=e.$kw=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$mw=b,e.$qw=o;var h;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(h||(e.OverviewRulerLane=h={}));var R;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=3]="Right"})(R||(e.GlyphMarginLane=R={}));var A;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(A||(e.MinimapPosition=A={}));var O;(function(t){t[t.Normal=1]="Normal",t[t.Underlined=2]="Underlined"})(O||(e.MinimapSectionHeaderStyle=O={}));var C;(function(t){t[t.Both=0]="Both",t[t.Right=1]="Right",t[t.Left=2]="Left",t[t.None=3]="None"})(C||(e.InjectedTextCursorStops=C={}));var m;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(m||(e.EndOfLinePreference=m={}));var c;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(c||(e.DefaultEndOfLine=c={}));var I;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(I||(e.EndOfLineSequence=I={}));class E{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(n){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,n.tabSize|0),n.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,n.indentSize|0),this.a=!1),this.insertSpaces=!!n.insertSpaces,this.defaultEOL=n.defaultEOL|0,this.trimAutoWhitespace=!!n.trimAutoWhitespace,this.bracketPairColorizationOptions=n.bracketPairColorizationOptions}equals(n){return this.tabSize===n.tabSize&&this.a===n.a&&this.indentSize===n.indentSize&&this.insertSpaces===n.insertSpaces&&this.defaultEOL===n.defaultEOL&&this.trimAutoWhitespace===n.trimAutoWhitespace&&(0,s.$mo)(this.bracketPairColorizationOptions,n.bracketPairColorizationOptions)}createChangeEvent(n){return{tabSize:this.tabSize!==n.tabSize,indentSize:this.indentSize!==n.indentSize,insertSpaces:this.insertSpaces!==n.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==n.trimAutoWhitespace}}}e.$kw=E;class g{constructor(n,r){this._findMatchBrand=void 0,this.range=n,this.matches=r}}e.$lw=g;var P;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(P||(e.TrackedRangeStickiness=P={}));function b(t){return t&&typeof t.read=="function"}var a;(function(t){t[t.Left=0]="Left",t[t.Right=1]="Right",t[t.None=2]="None",t[t.LeftOfInjectedText=3]="LeftOfInjectedText",t[t.RightOfInjectedText=4]="RightOfInjectedText"})(a||(e.PositionAffinity=a={}));var $;(function(t){t[t.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})($||(e.ModelConstants=$={}));class p{constructor(n,r,d,l,f,y){this.identifier=n,this.range=r,this.text=d,this.forceMoveMarkers=l,this.isAutoWhitespaceEdit=f,this._isTracked=y}}e.$nw=p;class u{constructor(n,r,d){this.regex=n,this.wordSeparators=r,this.simpleSearch=d}}e.$ow=u;class i{constructor(n,r,d){this.reverseEdits=n,this.changes=r,this.trimAutoWhitespaceLineNumbers=d}}e.$pw=i;function o(t){return!t.isTooLargeForSyncing()&&!t.isForSimpleWidget}}),define(Re[206],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mD=e.NodeColor=e.$lD=void 0,e.$nD=R,e.$oD=A,e.$pD=c,e.$qD=I,e.$rD=E,e.$sD=g,e.$tD=P,e.$uD=b;class s{constructor($,p){this.piece=$,this.color=p,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$mD)return R(this.right);let $=this;for(;$.parent!==e.$mD&&$.parent.left!==$;)$=$.parent;return $.parent===e.$mD?e.$mD:$.parent}prev(){if(this.left!==e.$mD)return A(this.left);let $=this;for(;$.parent!==e.$mD&&$.parent.right!==$;)$=$.parent;return $.parent===e.$mD?e.$mD:$.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$lD=s;var h;(function(a){a[a.Black=0]="Black",a[a.Red=1]="Red"})(h||(e.NodeColor=h={})),e.$mD=new s(null,h.Black),e.$mD.parent=e.$mD,e.$mD.left=e.$mD,e.$mD.right=e.$mD,e.$mD.color=h.Black;function R(a){for(;a.left!==e.$mD;)a=a.left;return a}function A(a){for(;a.right!==e.$mD;)a=a.right;return a}function O(a){return a===e.$mD?0:a.size_left+a.piece.length+O(a.right)}function C(a){return a===e.$mD?0:a.lf_left+a.piece.lineFeedCnt+C(a.right)}function m(){e.$mD.parent=e.$mD}function c(a,$){const p=$.right;p.size_left+=$.size_left+($.piece?$.piece.length:0),p.lf_left+=$.lf_left+($.piece?$.piece.lineFeedCnt:0),$.right=p.left,p.left!==e.$mD&&(p.left.parent=$),p.parent=$.parent,$.parent===e.$mD?a.root=p:$.parent.left===$?$.parent.left=p:$.parent.right=p,p.left=$,$.parent=p}function I(a,$){const p=$.left;$.left=p.right,p.right!==e.$mD&&(p.right.parent=$),p.parent=$.parent,$.size_left-=p.size_left+(p.piece?p.piece.length:0),$.lf_left-=p.lf_left+(p.piece?p.piece.lineFeedCnt:0),$.parent===e.$mD?a.root=p:$===$.parent.right?$.parent.right=p:$.parent.left=p,p.right=$,$.parent=p}function E(a,$){let p,u;if($.left===e.$mD?(u=$,p=u.right):$.right===e.$mD?(u=$,p=u.left):(u=R($.right),p=u.right),u===a.root){a.root=p,p.color=h.Black,$.detach(),m(),a.root.parent=e.$mD;return}const i=u.color===h.Red;if(u===u.parent.left?u.parent.left=p:u.parent.right=p,u===$?(p.parent=u.parent,b(a,p)):(u.parent===$?p.parent=u:p.parent=u.parent,b(a,p),u.left=$.left,u.right=$.right,u.parent=$.parent,u.color=$.color,$===a.root?a.root=u:$===$.parent.left?$.parent.left=u:$.parent.right=u,u.left!==e.$mD&&(u.left.parent=u),u.right!==e.$mD&&(u.right.parent=u),u.size_left=$.size_left,u.lf_left=$.lf_left,b(a,u)),$.detach(),p.parent.left===p){const t=O(p),n=C(p);if(t!==p.parent.size_left||n!==p.parent.lf_left){const r=t-p.parent.size_left,d=n-p.parent.lf_left;p.parent.size_left=t,p.parent.lf_left=n,P(a,p.parent,r,d)}}if(b(a,p.parent),i){m();return}let o;for(;p!==a.root&&p.color===h.Black;)p===p.parent.left?(o=p.parent.right,o.color===h.Red&&(o.color=h.Black,p.parent.color=h.Red,c(a,p.parent),o=p.parent.right),o.left.color===h.Black&&o.right.color===h.Black?(o.color=h.Red,p=p.parent):(o.right.color===h.Black&&(o.left.color=h.Black,o.color=h.Red,I(a,o),o=p.parent.right),o.color=p.parent.color,p.parent.color=h.Black,o.right.color=h.Black,c(a,p.parent),p=a.root)):(o=p.parent.left,o.color===h.Red&&(o.color=h.Black,p.parent.color=h.Red,I(a,p.parent),o=p.parent.left),o.left.color===h.Black&&o.right.color===h.Black?(o.color=h.Red,p=p.parent):(o.left.color===h.Black&&(o.right.color=h.Black,o.color=h.Red,c(a,o),o=p.parent.left),o.color=p.parent.color,p.parent.color=h.Black,o.left.color=h.Black,I(a,p.parent),p=a.root));p.color=h.Black,m()}function g(a,$){for(b(a,$);$!==a.root&&$.parent.color===h.Red;)if($.parent===$.parent.parent.left){const p=$.parent.parent.right;p.color===h.Red?($.parent.color=h.Black,p.color=h.Black,$.parent.parent.color=h.Red,$=$.parent.parent):($===$.parent.right&&($=$.parent,c(a,$)),$.parent.color=h.Black,$.parent.parent.color=h.Red,I(a,$.parent.parent))}else{const p=$.parent.parent.left;p.color===h.Red?($.parent.color=h.Black,p.color=h.Black,$.parent.parent.color=h.Red,$=$.parent.parent):($===$.parent.left&&($=$.parent,I(a,$)),$.parent.color=h.Black,$.parent.parent.color=h.Red,c(a,$.parent.parent))}a.root.color=h.Black}function P(a,$,p,u){for(;$!==a.root&&$!==e.$mD;)$.parent.left===$&&($.parent.size_left+=p,$.parent.lf_left+=u),$=$.parent}function b(a,$){let p=0,u=0;if($!==a.root){for(;$!==a.root&&$===$.parent.right;)$=$.parent;if($!==a.root)for($=$.parent,p=O($.left)-$.size_left,u=C($.left)-$.lf_left,$.size_left+=p,$.lf_left+=u;$!==a.root&&(p!==0||u!==0);)$.parent.left===$&&($.parent.size_left+=p,$.parent.lf_left+=u),$=$.parent}}}),define(Re[207],Ce([1,0,18,85]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vw=e.$uw=e.$tw=void 0;class R{constructor(m){this.a=m,this.b=new Uint32Array(m.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(m,c){m=(0,h.$ef)(m);const I=this.a,E=this.b,g=c.length;return g===0?!1:(this.a=new Uint32Array(I.length+g),this.a.set(I.subarray(0,m),0),this.a.set(I.subarray(m),m+g),this.a.set(c,m),m-1<this.c[0]&&(this.c[0]=m-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(E.subarray(0,this.c[0]+1)),!0)}setValue(m,c){return m=(0,h.$ef)(m),c=(0,h.$ef)(c),this.a[m]===c?!1:(this.a[m]=c,m-1<this.c[0]&&(this.c[0]=m-1),!0)}removeValues(m,c){m=(0,h.$ef)(m),c=(0,h.$ef)(c);const I=this.a,E=this.b;if(m>=I.length)return!1;const g=I.length-m;return c>=g&&(c=g),c===0?!1:(this.a=new Uint32Array(I.length-c),this.a.set(I.subarray(0,m),0),this.a.set(I.subarray(m+c),m),this.b=new Uint32Array(this.a.length),m-1<this.c[0]&&(this.c[0]=m-1),this.c[0]>=0&&this.b.set(E.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(m){return m<0?0:(m=(0,h.$ef)(m),this.d(m))}d(m){if(m<=this.c[0])return this.b[m];let c=this.c[0]+1;c===0&&(this.b[0]=this.a[0],c++),m>=this.a.length&&(m=this.a.length-1);for(let I=c;I<=m;I++)this.b[I]=this.b[I-1]+this.a[I];return this.c[0]=Math.max(this.c[0],m),this.b[m]}getIndexOf(m){m=Math.floor(m),this.getTotalSum();let c=0,I=this.a.length-1,E=0,g=0,P=0;for(;c<=I;)if(E=c+(I-c)/2|0,g=this.b[E],P=g-this.a[E],m<P)I=E-1;else if(m>=g)c=E+1;else break;return new O(E,m-P)}}e.$tw=R;class A{constructor(m){this.a=m,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(m){return this.g(),m===0?0:this.d[m-1]}getIndexOf(m){this.g();const c=this.e[m],I=c>0?this.d[c-1]:0;return new O(c,m-I)}removeValues(m,c){this.a.splice(m,c),this.f(m)}insertValues(m,c){this.a=(0,s.$Xb)(this.a,m,c),this.f(m)}f(m){this.b=!1,this.c=Math.min(this.c,m-1)}g(){if(!this.b){for(let m=this.c+1,c=this.a.length;m<c;m++){const I=this.a[m],E=m>0?this.d[m-1]:0;this.d[m]=E+I;for(let g=0;g<I;g++)this.e[E+g]=m}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(m,c){this.a[m]!==c&&(this.a[m]=c,this.f(m))}}e.$uw=A;class O{constructor(m,c){this.index=m,this.remainder=c,this._prefixSumIndexOfResultBrand=void 0,this.index=m,this.remainder=c}}e.$vw=O}),define(Re[208],Ce([1,0,13,57,207]),function(ge,e,s,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ww=void 0;class A{constructor(C,m,c,I){this.a=C,this.b=m,this.c=c,this.d=I,this.f=null,this.g=null}dispose(){this.b.length=0}get version(){return this.d}getText(){return this.g===null&&(this.g=this.b.join(this.c)),this.g}onEvents(C){C.eol&&C.eol!==this.c&&(this.c=C.eol,this.f=null);const m=C.changes;for(const c of m)this.k(c.range),this.l(new h.$Tt(c.range.startLineNumber,c.range.startColumn),c.text);this.d=C.versionId,this.g=null}h(){if(!this.f){const C=this.c.length,m=this.b.length,c=new Uint32Array(m);for(let I=0;I<m;I++)c[I]=this.b[I].length+C;this.f=new R.$tw(c)}}j(C,m){this.b[C]=m,this.f&&this.f.setValue(C,this.b[C].length+this.c.length)}k(C){if(C.startLineNumber===C.endLineNumber){if(C.startColumn===C.endColumn)return;this.j(C.startLineNumber-1,this.b[C.startLineNumber-1].substring(0,C.startColumn-1)+this.b[C.startLineNumber-1].substring(C.endColumn-1));return}this.j(C.startLineNumber-1,this.b[C.startLineNumber-1].substring(0,C.startColumn-1)+this.b[C.endLineNumber-1].substring(C.endColumn-1)),this.b.splice(C.startLineNumber,C.endLineNumber-C.startLineNumber),this.f&&this.f.removeValues(C.startLineNumber,C.endLineNumber-C.startLineNumber)}l(C,m){if(m.length===0)return;const c=(0,s.$vf)(m);if(c.length===1){this.j(C.lineNumber-1,this.b[C.lineNumber-1].substring(0,C.column-1)+c[0]+this.b[C.lineNumber-1].substring(C.column-1));return}c[c.length-1]+=this.b[C.lineNumber-1].substring(C.column-1),this.j(C.lineNumber-1,this.b[C.lineNumber-1].substring(0,C.column-1)+c[0]);const I=new Uint32Array(c.length-1);for(let E=1;E<c.length;E++)this.b.splice(C.lineNumber+E-1,0,c[E]),I[E-1]=c[E].length+this.c.length;this.f&&this.f.insertValues(C.lineNumber,I)}}e.$ww=A}),define(Re[111],Ce([1,0,26,13,202,57,30,58]),function(ge,e,s,h,R,A,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AD=e.$yD=e.$vD=void 0,e.$wD=I,e.$xD=E,e.$zD=$,h=Ue(h);const m=999;class c{constructor(i,o,t,n){this.searchString=i,this.isRegex=o,this.matchCase=t,this.wordSeparators=n}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=I(this.searchString):i=this.searchString.indexOf(`
`)>=0;let o=null;try{o=h.$tf(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!o)return null;let t=!this.isRegex&&!i;return t&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(t=this.matchCase),new C.$ow(o,this.wordSeparators?(0,R.$qu)(this.wordSeparators,[]):null,t?this.searchString:null)}}e.$vD=c;function I(u){if(!u||u.length===0)return!1;for(let i=0,o=u.length;i<o;i++){const t=u.charCodeAt(i);if(t===s.CharCode.LineFeed)return!0;if(t===s.CharCode.Backslash){if(i++,i>=o)break;const n=u.charCodeAt(i);if(n===s.CharCode.n||n===s.CharCode.r||n===s.CharCode.W)return!0}}return!1}function E(u,i,o){if(!o)return new C.$lw(u,null);const t=[];for(let n=0,r=i.length;n<r;n++)t[n]=i[n];return new C.$lw(u,t)}class g{constructor(i){const o=[];let t=0;for(let n=0,r=i.length;n<r;n++)i.charCodeAt(n)===s.CharCode.LineFeed&&(o[t++]=n);this.a=o}findLineFeedCountBeforeOffset(i){const o=this.a;let t=0,n=o.length-1;if(n===-1||i<=o[0])return 0;for(;t<n;){const r=t+((n-t)/2>>0);o[r]>=i?n=r-1:o[r+1]>=i?(t=r,n=r):t=r+1}return t+1}}class P{static findMatches(i,o,t,n,r){const d=o.parseSearchRequest();return d?d.regex.multiline?this.b(i,t,new p(d.wordSeparators,d.regex),n,r):this.c(i,t,d,n,r):[]}static a(i,o,t,n,r,d){let l,f=0;n?(f=n.findLineFeedCountBeforeOffset(r),l=o+r+f):l=o+r;let y;if(n){const T=n.findLineFeedCountBeforeOffset(r+d.length)-f;y=l+d.length+T}else y=l+d.length;const k=i.getPositionAt(l),S=i.getPositionAt(y);return new O.$Ut(k.lineNumber,k.column,S.lineNumber,S.column)}static b(i,o,t,n,r){const d=i.getOffsetAt(o.getStartPosition()),l=i.getValueInRange(o,C.EndOfLinePreference.LF),f=i.getEOL()===`\r
`?new g(l):null,y=[];let k=0,S;for(t.reset(0);S=t.next(l);)if(y[k++]=E(this.a(i,d,l,f,S.index,S[0]),S,n),k>=r)return y;return y}static c(i,o,t,n,r){const d=[];let l=0;if(o.startLineNumber===o.endLineNumber){const y=i.getLineContent(o.startLineNumber).substring(o.startColumn-1,o.endColumn-1);return l=this.d(t,y,o.startLineNumber,o.startColumn-1,l,d,n,r),d}const f=i.getLineContent(o.startLineNumber).substring(o.startColumn-1);l=this.d(t,f,o.startLineNumber,o.startColumn-1,l,d,n,r);for(let y=o.startLineNumber+1;y<o.endLineNumber&&l<r;y++)l=this.d(t,i.getLineContent(y),y,0,l,d,n,r);if(l<r){const y=i.getLineContent(o.endLineNumber).substring(0,o.endColumn-1);l=this.d(t,y,o.endLineNumber,0,l,d,n,r)}return d}static d(i,o,t,n,r,d,l,f){const y=i.wordSeparators;if(!l&&i.simpleSearch){const D=i.simpleSearch,T=D.length,v=o.length;let w=-T;for(;(w=o.indexOf(D,w+T))!==-1;)if((!y||$(y,o,v,w,T))&&(d[r++]=new C.$lw(new O.$Ut(t,w+1+n,t,w+1+T+n),null),r>=f))return r;return r}const k=new p(i.wordSeparators,i.regex);let S;k.reset(0);do if(S=k.next(o),S&&(d[r++]=E(new O.$Ut(t,S.index+1+n,t,S.index+1+S[0].length+n),S,l),r>=f))return r;while(S);return r}static findNextMatch(i,o,t,n){const r=o.parseSearchRequest();if(!r)return null;const d=new p(r.wordSeparators,r.regex);return r.regex.multiline?this.e(i,t,d,n):this.f(i,t,d,n)}static e(i,o,t,n){const r=new A.$Tt(o.lineNumber,1),d=i.getOffsetAt(r),l=i.getLineCount(),f=i.getValueInRange(new O.$Ut(r.lineNumber,r.column,l,i.getLineMaxColumn(l)),C.EndOfLinePreference.LF),y=i.getEOL()===`\r
`?new g(f):null;t.reset(o.column-1);const k=t.next(f);return k?E(this.a(i,d,f,y,k.index,k[0]),k,n):o.lineNumber!==1||o.column!==1?this.e(i,new A.$Tt(1,1),t,n):null}static f(i,o,t,n){const r=i.getLineCount(),d=o.lineNumber,l=i.getLineContent(d),f=this.g(t,l,d,o.column,n);if(f)return f;for(let y=1;y<=r;y++){const k=(d+y-1)%r,S=i.getLineContent(k+1),D=this.g(t,S,k+1,1,n);if(D)return D}return null}static g(i,o,t,n,r){i.reset(n-1);const d=i.next(o);return d?E(new O.$Ut(t,d.index+1,t,d.index+1+d[0].length),d,r):null}static findPreviousMatch(i,o,t,n){const r=o.parseSearchRequest();if(!r)return null;const d=new p(r.wordSeparators,r.regex);return r.regex.multiline?this.h(i,t,d,n):this.j(i,t,d,n)}static h(i,o,t,n){const r=this.b(i,new O.$Ut(1,1,o.lineNumber,o.column),t,n,10*m);if(r.length>0)return r[r.length-1];const d=i.getLineCount();return o.lineNumber!==d||o.column!==i.getLineMaxColumn(d)?this.h(i,new A.$Tt(d,i.getLineMaxColumn(d)),t,n):null}static j(i,o,t,n){const r=i.getLineCount(),d=o.lineNumber,l=i.getLineContent(d).substring(0,o.column-1),f=this.k(t,l,d,n);if(f)return f;for(let y=1;y<=r;y++){const k=(r+d-y-1)%r,S=i.getLineContent(k+1),D=this.k(t,S,k+1,n);if(D)return D}return null}static k(i,o,t,n){let r=null,d;for(i.reset(0);d=i.next(o);)r=E(new O.$Ut(t,d.index+1,t,d.index+1+d[0].length),d,n);return r}}e.$yD=P;function b(u,i,o,t,n){if(t===0)return!0;const r=i.charCodeAt(t-1);if(u.get(r)!==R.WordCharacterClass.Regular||r===s.CharCode.CarriageReturn||r===s.CharCode.LineFeed)return!0;if(n>0){const d=i.charCodeAt(t);if(u.get(d)!==R.WordCharacterClass.Regular)return!0}return!1}function a(u,i,o,t,n){if(t+n===o)return!0;const r=i.charCodeAt(t+n);if(u.get(r)!==R.WordCharacterClass.Regular||r===s.CharCode.CarriageReturn||r===s.CharCode.LineFeed)return!0;if(n>0){const d=i.charCodeAt(t+n-1);if(u.get(d)!==R.WordCharacterClass.Regular)return!0}return!1}function $(u,i,o,t,n){return b(u,i,o,t,n)&&a(u,i,o,t,n)}class p{constructor(i,o){this._wordSeparators=i,this.a=o,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const o=i.length;let t;do{if(this.b+this.c===o||(t=this.a.exec(i),!t))return null;const n=t.index,r=t[0].length;if(n===this.b&&r===this.c){if(r===0){h.$Pf(i,o,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=n,this.c=r,!this._wordSeparators||$(this._wordSeparators,i,o,n,r))return t}while(t);return null}}e.$AD=p}),define(Re[143],Ce([1,0,26,57,30,58,206,111]),function(ge,e,s,h,R,A,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FD=e.$ED=e.$DD=void 0,e.$BD=E,e.$CD=g;const m=65535;function c(u){let i;return u[u.length-1]<65536?i=new Uint16Array(u.length):i=new Uint32Array(u.length),i.set(u,0),i}class I{constructor(i,o,t,n,r){this.lineStarts=i,this.cr=o,this.lf=t,this.crlf=n,this.isBasicASCII=r}}function E(u,i=!0){const o=[0];let t=1;for(let n=0,r=u.length;n<r;n++){const d=u.charCodeAt(n);d===s.CharCode.CarriageReturn?n+1<r&&u.charCodeAt(n+1)===s.CharCode.LineFeed?(o[t++]=n+2,n++):o[t++]=n+1:d===s.CharCode.LineFeed&&(o[t++]=n+1)}return i?c(o):o}function g(u,i){u.length=0,u[0]=0;let o=1,t=0,n=0,r=0,d=!0;for(let f=0,y=i.length;f<y;f++){const k=i.charCodeAt(f);k===s.CharCode.CarriageReturn?f+1<y&&i.charCodeAt(f+1)===s.CharCode.LineFeed?(r++,u[o++]=f+2,f++):(t++,u[o++]=f+1):k===s.CharCode.LineFeed?(n++,u[o++]=f+1):d&&k!==s.CharCode.Tab&&(k<32||k>126)&&(d=!1)}const l=new I(c(u),t,n,r,d);return u.length=0,l}class P{constructor(i,o,t,n,r){this.bufferIndex=i,this.start=o,this.end=t,this.lineFeedCnt=n,this.length=r}}e.$DD=P;class b{constructor(i,o){this.buffer=i,this.lineStarts=o}}e.$ED=b;class a{constructor(i,o){this.a=[],this.c=i,this.d=o,this.b=0,i.root!==O.$mD&&i.iterate(i.root,t=>(t!==O.$mD&&this.a.push(t.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class ${constructor(i){this.a=i,this.b=[]}get(i){for(let o=this.b.length-1;o>=0;o--){const t=this.b[o];if(t.nodeStartOffset<=i&&t.nodeStartOffset+t.node.piece.length>=i)return t}return null}get2(i){for(let o=this.b.length-1;o>=0;o--){const t=this.b[o];if(t.nodeStartLineNumber&&t.nodeStartLineNumber<i&&t.nodeStartLineNumber+t.node.piece.lineFeedCnt>=i)return t}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let o=!1;const t=this.b;for(let n=0;n<t.length;n++){const r=t[n];if(r.node.parent===null||r.nodeStartOffset>=i){t[n]=null,o=!0;continue}}if(o){const n=[];for(const r of t)r!==null&&n.push(r);this.b=n}}}class p{constructor(i,o,t){this.create(i,o,t)}create(i,o,t){this.a=[new b("",[0])],this.g={line:0,column:0},this.root=O.$mD,this.b=1,this.c=0,this.d=o,this.e=o.length,this.f=t;let n=null;for(let r=0,d=i.length;r<d;r++)if(i[r].buffer.length>0){i[r].lineStarts||(i[r].lineStarts=E(i[r].buffer));const l=new P(r+1,{line:0,column:0},{line:i[r].lineStarts.length-1,column:i[r].buffer.length-i[r].lineStarts[i[r].lineStarts.length-1]},i[r].lineStarts.length-1,i[r].buffer.length);this.a.push(i[r]),n=this.S(n,l)}this.h=new $(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const o=m,t=o-Math.floor(o/3),n=t*2;let r="",d=0;const l=[];if(this.iterate(this.root,f=>{const y=this.R(f),k=y.length;if(d<=t||d+k<n)return r+=y,d+=k,!0;const S=r.replace(/\r\n|\r|\n/g,i);return l.push(new b(S,E(S))),r=y,d=k,!0}),d>0){const f=r.replace(/\r\n|\r|\n/g,i);l.push(new b(f,E(f)))}this.create(l,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new a(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let o=0;return this.iterate(this.root,n=>{if(n===O.$mD)return!0;const r=this.R(n),d=r.length,l=i.G(o),f=i.G(o+d),y=i.getValueInRange2(l,f);return o+=d,r===y})}getOffsetAt(i,o){let t=0,n=this.root;for(;n!==O.$mD;)if(n.left!==O.$mD&&n.lf_left+1>=i)n=n.left;else if(n.lf_left+n.piece.lineFeedCnt+1>=i){t+=n.size_left;const r=this.B(n,i-n.lf_left-2);return t+=r+o-1}else i-=n.lf_left+n.piece.lineFeedCnt,t+=n.size_left+n.piece.length,n=n.right;return t}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let o=this.root,t=0;const n=i;for(;o!==O.$mD;)if(o.size_left!==0&&o.size_left>=i)o=o.left;else if(o.size_left+o.piece.length>=i){const r=this.A(o,i-o.size_left);if(t+=o.lf_left+r.index,r.index===0){const d=this.getOffsetAt(t+1,1),l=n-d;return new h.$Tt(t+1,l+1)}return new h.$Tt(t+1,r.remainder+1)}else if(i-=o.size_left+o.piece.length,t+=o.lf_left+o.piece.lineFeedCnt,o.right===O.$mD){const r=this.getOffsetAt(t+1,1),d=n-i-r;return new h.$Tt(t+1,d+1)}else o=o.right;return new h.$Tt(1,1)}getValueInRange(i,o){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const t=this.H(i.startLineNumber,i.startColumn),n=this.H(i.endLineNumber,i.endColumn),r=this.getValueInRange2(t,n);return o?o!==this.d||!this.f?r.replace(/\r\n|\r|\n/g,o):o===this.getEOL()&&this.f?r:r.replace(/\r\n|\r|\n/g,o):r}getValueInRange2(i,o){if(i.node===o.node){const l=i.node,f=this.a[l.piece.bufferIndex].buffer,y=this.u(l.piece.bufferIndex,l.piece.start);return f.substring(y+i.remainder,y+o.remainder)}let t=i.node;const n=this.a[t.piece.bufferIndex].buffer,r=this.u(t.piece.bufferIndex,t.piece.start);let d=n.substring(r+i.remainder,r+t.piece.length);for(t=t.next();t!==O.$mD;){const l=this.a[t.piece.bufferIndex].buffer,f=this.u(t.piece.bufferIndex,t.piece.start);if(t===o.node){d+=l.substring(f,f+o.remainder);break}else d+=l.substr(f,t.piece.length);t=t.next()}return d}getLinesContent(){const i=[];let o=0,t="",n=!1;return this.iterate(this.root,r=>{if(r===O.$mD)return!0;const d=r.piece;let l=d.length;if(l===0)return!0;const f=this.a[d.bufferIndex].buffer,y=this.a[d.bufferIndex].lineStarts,k=d.start.line,S=d.end.line;let D=y[k]+d.start.column;if(n&&(f.charCodeAt(D)===s.CharCode.LineFeed&&(D++,l--),i[o++]=t,t="",n=!1,l===0))return!0;if(k===S)return!this.f&&f.charCodeAt(D+l-1)===s.CharCode.CarriageReturn?(n=!0,t+=f.substr(D,l-1)):t+=f.substr(D,l),!0;t+=this.f?f.substring(D,Math.max(D,y[k+1]-this.e)):f.substring(D,y[k+1]).replace(/(\r\n|\r|\n)$/,""),i[o++]=t;for(let T=k+1;T<S;T++)t=this.f?f.substring(y[T],y[T+1]-this.e):f.substring(y[T],y[T+1]).replace(/(\r\n|\r|\n)$/,""),i[o++]=t;return!this.f&&f.charCodeAt(y[S]+d.end.column-1)===s.CharCode.CarriageReturn?(n=!0,d.end.column===0?o--:t=f.substr(y[S],d.end.column-1)):t=f.substr(y[S],d.end.column),!0}),n&&(i[o++]=t,t=""),i[o++]=t,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const o=i.node.next();if(!o)return 0;const t=this.a[o.piece.bufferIndex],n=this.u(o.piece.bufferIndex,o.piece.start);return t.buffer.charCodeAt(n)}else{const o=this.a[i.node.piece.bufferIndex],n=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return o.buffer.charCodeAt(n)}}getLineCharCode(i,o){const t=this.H(i,o+1);return this.l(t)}getLineLength(i){if(i===this.getLineCount()){const o=this.getOffsetAt(i,1);return this.getLength()-o}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const o=this.G(i);return this.l(o)}getNearestChunk(i){const o=this.G(i);if(o.remainder===o.node.piece.length){const t=o.node.next();if(!t||t===O.$mD)return"";const n=this.a[t.piece.bufferIndex],r=this.u(t.piece.bufferIndex,t.piece.start);return n.buffer.substring(r,r+t.piece.length)}else{const t=this.a[o.node.piece.bufferIndex],n=this.u(o.node.piece.bufferIndex,o.node.piece.start),r=n+o.remainder,d=n+o.node.piece.length;return t.buffer.substring(r,d)}}findMatchesInNode(i,o,t,n,r,d,l,f,y,k,S){const D=this.a[i.piece.bufferIndex],T=this.u(i.piece.bufferIndex,i.piece.start),v=this.u(i.piece.bufferIndex,r),w=this.u(i.piece.bufferIndex,d);let M;const L={line:0,column:0};let N,F;o._wordSeparators?(N=D.buffer.substring(v,w),F=V=>V+v,o.reset(0)):(N=D.buffer,F=V=>V,o.reset(v));do if(M=o.next(N),M){if(F(M.index)>=w)return k;this.s(i,F(M.index)-T,L);const V=this.t(i.piece.bufferIndex,r,L),j=L.line===r.line?L.column-r.column+n:L.column+1,U=j+M[0].length;if(S[k++]=(0,C.$xD)(new R.$Ut(t+V,j,t+V,U),M,f),F(M.index)+M[0].length>=w||k>=y)return k}while(M);return k}findMatchesLineByLine(i,o,t,n){const r=[];let d=0;const l=new C.$AD(o.wordSeparators,o.regex);let f=this.H(i.startLineNumber,i.startColumn);if(f===null)return[];const y=this.H(i.endLineNumber,i.endColumn);if(y===null)return[];let k=this.s(f.node,f.remainder);const S=this.s(y.node,y.remainder);if(f.node===y.node)return this.findMatchesInNode(f.node,l,i.startLineNumber,i.startColumn,k,S,o,t,n,d,r),r;let D=i.startLineNumber,T=f.node;for(;T!==y.node;){const w=this.t(T.piece.bufferIndex,k,T.piece.end);if(w>=1){const L=this.a[T.piece.bufferIndex].lineStarts,N=this.u(T.piece.bufferIndex,T.piece.start),F=L[k.line+w],V=D===i.startLineNumber?i.startColumn:1;if(d=this.findMatchesInNode(T,l,D,V,k,this.s(T,F-N),o,t,n,d,r),d>=n)return r;D+=w}const M=D===i.startLineNumber?i.startColumn-1:0;if(D===i.endLineNumber){const L=this.getLineContent(D).substring(M,i.endColumn-1);return d=this.n(o,l,L,i.endLineNumber,M,d,r,t,n),r}if(d=this.n(o,l,this.getLineContent(D).substr(M),D,M,d,r,t,n),d>=n)return r;D++,f=this.H(D,1),T=f.node,k=this.s(f.node,f.remainder)}if(D===i.endLineNumber){const w=D===i.startLineNumber?i.startColumn-1:0,M=this.getLineContent(D).substring(w,i.endColumn-1);return d=this.n(o,l,M,i.endLineNumber,w,d,r,t,n),r}const v=D===i.startLineNumber?i.startColumn:1;return d=this.findMatchesInNode(y.node,l,D,v,k,S,o,t,n,d,r),r}n(i,o,t,n,r,d,l,f,y){const k=i.wordSeparators;if(!f&&i.simpleSearch){const D=i.simpleSearch,T=D.length,v=t.length;let w=-T;for(;(w=t.indexOf(D,w+T))!==-1;)if((!k||(0,C.$zD)(k,t,v,w,T))&&(l[d++]=new A.$lw(new R.$Ut(n,w+1+r,n,w+1+T+r),null),d>=y))return d;return d}let S;o.reset(0);do if(S=o.next(t),S&&(l[d++]=(0,C.$xD)(new R.$Ut(n,S.index+1+r,n,S.index+1+S[0].length+r),S,f),d>=y))return d;while(S);return d}insert(i,o,t=!1){if(this.f=this.f&&t,this.j.lineNumber=0,this.j.value="",this.root!==O.$mD){const{node:n,remainder:r,nodeStartOffset:d}=this.G(i),l=n.piece,f=l.bufferIndex,y=this.s(n,r);if(n.piece.bufferIndex===0&&l.end.line===this.g.line&&l.end.column===this.g.column&&d+l.length===i&&o.length<m){this.F(n,o),this.y();return}if(d===i)this.o(o,n),this.h.validate(i);else if(d+n.piece.length>i){const k=[];let S=new P(l.bufferIndex,y,l.end,this.t(l.bufferIndex,y,l.end),this.u(f,l.end)-this.u(f,y));if(this.K()&&this.M(o)&&this.I(n,r)===10){const w={line:S.start.line+1,column:0};S=new P(S.bufferIndex,w,S.end,this.t(S.bufferIndex,w,S.end),S.length-1),o+=`
`}if(this.K()&&this.L(o))if(this.I(n,r-1)===13){const w=this.s(n,r-1);this.C(n,w),o="\r"+o,n.piece.length===0&&k.push(n)}else this.C(n,y);else this.C(n,y);const D=this.w(o);S.length>0&&this.S(n,S);let T=n;for(let v=0;v<D.length;v++)T=this.S(T,D[v]);this.v(k)}else this.q(o,n)}else{const n=this.w(o);let r=this.T(null,n[0]);for(let d=1;d<n.length;d++)r=this.S(r,n[d])}this.y()}delete(i,o){if(this.j.lineNumber=0,this.j.value="",o<=0||this.root===O.$mD)return;const t=this.G(i),n=this.G(i+o),r=t.node,d=n.node;if(r===d){const D=this.s(r,t.remainder),T=this.s(r,n.remainder);if(t.nodeStartOffset===i){if(o===r.piece.length){const v=r.next();(0,O.$rD)(this,r),this.N(v),this.y();return}this.D(r,T),this.h.validate(i),this.N(r),this.y();return}if(t.nodeStartOffset+r.piece.length===i+o){this.C(r,D),this.O(r),this.y();return}this.E(r,D,T),this.y();return}const l=[],f=this.s(r,t.remainder);this.C(r,f),this.h.validate(i),r.piece.length===0&&l.push(r);const y=this.s(d,n.remainder);this.D(d,y),d.piece.length===0&&l.push(d);const k=r.next();for(let D=k;D!==O.$mD&&D!==d;D=D.next())l.push(D);const S=r.piece.length===0?r.prev():r;this.v(l),this.O(S),this.y()}o(i,o){const t=[];if(this.K()&&this.M(i)&&this.L(o)){const d=o.piece,l={line:d.start.line+1,column:0},f=new P(d.bufferIndex,l,d.end,this.t(d.bufferIndex,l,d.end),d.length-1);o.piece=f,i+=`
`,(0,O.$tD)(this,o,-1,-1),o.piece.length===0&&t.push(o)}const n=this.w(i);let r=this.T(o,n[n.length-1]);for(let d=n.length-2;d>=0;d--)r=this.T(r,n[d]);this.N(r),this.v(t)}q(i,o){this.Q(i,o)&&(i+=`
`);const t=this.w(i),n=this.S(o,t[0]);let r=n;for(let d=1;d<t.length;d++)r=this.S(r,t[d]);this.N(n)}s(i,o,t){const n=i.piece,r=i.piece.bufferIndex,d=this.a[r].lineStarts,f=d[n.start.line]+n.start.column+o;let y=n.start.line,k=n.end.line,S=0,D=0,T=0;for(;y<=k&&(S=y+(k-y)/2|0,T=d[S],S!==k);)if(D=d[S+1],f<T)k=S-1;else if(f>=D)y=S+1;else break;return t?(t.line=S,t.column=f-T,null):{line:S,column:f-T}}t(i,o,t){if(t.column===0)return t.line-o.line;const n=this.a[i].lineStarts;if(t.line===n.length-1)return t.line-o.line;const r=n[t.line+1],d=n[t.line]+t.column;if(r>d+1)return t.line-o.line;const l=d-1;return this.a[i].buffer.charCodeAt(l)===13?t.line-o.line+1:t.line-o.line}u(i,o){return this.a[i].lineStarts[o.line]+o.column}v(i){for(let o=0;o<i.length;o++)(0,O.$rD)(this,i[o])}w(i){if(i.length>m){const k=[];for(;i.length>m;){const D=i.charCodeAt(m-1);let T;D===s.CharCode.CarriageReturn||D>=55296&&D<=56319?(T=i.substring(0,m-1),i=i.substring(m-1)):(T=i.substring(0,m),i=i.substring(m));const v=E(T);k.push(new P(this.a.length,{line:0,column:0},{line:v.length-1,column:T.length-v[v.length-1]},v.length-1,T.length)),this.a.push(new b(T,v))}const S=E(i);return k.push(new P(this.a.length,{line:0,column:0},{line:S.length-1,column:i.length-S[S.length-1]},S.length-1,i.length)),this.a.push(new b(i,S)),k}let o=this.a[0].buffer.length;const t=E(i,!1);let n=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===o&&o!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},n=this.g;for(let k=0;k<t.length;k++)t[k]+=o+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+="_"+i,o+=1}else{if(o!==0)for(let k=0;k<t.length;k++)t[k]+=o;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+=i}const r=this.a[0].buffer.length,d=this.a[0].lineStarts.length-1,l=r-this.a[0].lineStarts[d],f={line:d,column:l},y=new P(0,n,f,this.t(0,n,f),r-o);return this.g=f,[y]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,o=0){let t=this.root,n="";const r=this.h.get2(i);if(r){t=r.node;const d=this.B(t,i-r.nodeStartLineNumber-1),l=this.a[t.piece.bufferIndex].buffer,f=this.u(t.piece.bufferIndex,t.piece.start);if(r.nodeStartLineNumber+t.piece.lineFeedCnt===i)n=l.substring(f+d,f+t.piece.length);else{const y=this.B(t,i-r.nodeStartLineNumber);return l.substring(f+d,f+y-o)}}else{let d=0;const l=i;for(;t!==O.$mD;)if(t.left!==O.$mD&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const f=this.B(t,i-t.lf_left-2),y=this.B(t,i-t.lf_left-1),k=this.a[t.piece.bufferIndex].buffer,S=this.u(t.piece.bufferIndex,t.piece.start);return d+=t.size_left,this.h.set({node:t,nodeStartOffset:d,nodeStartLineNumber:l-(i-1-t.lf_left)}),k.substring(S+f,S+y-o)}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const f=this.B(t,i-t.lf_left-2),y=this.a[t.piece.bufferIndex].buffer,k=this.u(t.piece.bufferIndex,t.piece.start);n=y.substring(k+f,k+t.piece.length);break}else i-=t.lf_left+t.piece.lineFeedCnt,d+=t.size_left+t.piece.length,t=t.right}for(t=t.next();t!==O.$mD;){const d=this.a[t.piece.bufferIndex].buffer;if(t.piece.lineFeedCnt>0){const l=this.B(t,0),f=this.u(t.piece.bufferIndex,t.piece.start);return n+=d.substring(f,f+l-o),n}else{const l=this.u(t.piece.bufferIndex,t.piece.start);n+=d.substr(l,t.piece.length)}t=t.next()}return n}y(){let i=this.root,o=1,t=0;for(;i!==O.$mD;)o+=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;this.b=o,this.c=t,this.h.validate(this.c)}A(i,o){const t=i.piece,n=this.s(i,o),r=n.line-t.start.line;if(this.u(t.bufferIndex,t.end)-this.u(t.bufferIndex,t.start)===o){const d=this.t(i.piece.bufferIndex,t.start,n);if(d!==r)return{index:d,remainder:0}}return{index:r,remainder:n.column}}B(i,o){if(o<0)return 0;const t=i.piece,n=this.a[t.bufferIndex].lineStarts,r=t.start.line+o+1;return r>t.end.line?n[t.end.line]+t.end.column-n[t.start.line]-t.start.column:n[r]-n[t.start.line]-t.start.column}C(i,o){const t=i.piece,n=t.lineFeedCnt,r=this.u(t.bufferIndex,t.end),d=o,l=this.u(t.bufferIndex,d),f=this.t(t.bufferIndex,t.start,d),y=f-n,k=l-r,S=t.length+k;i.piece=new P(t.bufferIndex,t.start,d,f,S),(0,O.$tD)(this,i,k,y)}D(i,o){const t=i.piece,n=t.lineFeedCnt,r=this.u(t.bufferIndex,t.start),d=o,l=this.t(t.bufferIndex,d,t.end),f=this.u(t.bufferIndex,d),y=l-n,k=r-f,S=t.length+k;i.piece=new P(t.bufferIndex,d,t.end,l,S),(0,O.$tD)(this,i,k,y)}E(i,o,t){const n=i.piece,r=n.start,d=n.end,l=n.length,f=n.lineFeedCnt,y=o,k=this.t(n.bufferIndex,n.start,y),S=this.u(n.bufferIndex,o)-this.u(n.bufferIndex,r);i.piece=new P(n.bufferIndex,n.start,y,k,S),(0,O.$tD)(this,i,S-l,k-f);const D=new P(n.bufferIndex,t,d,this.t(n.bufferIndex,t,d),this.u(n.bufferIndex,d)-this.u(n.bufferIndex,t)),T=this.S(i,D);this.N(T)}F(i,o){this.Q(o,i)&&(o+=`
`);const t=this.K()&&this.L(o)&&this.M(i),n=this.a[0].buffer.length;this.a[0].buffer+=o;const r=E(o,!1);for(let T=0;T<r.length;T++)r[T]+=n;if(t){const T=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:n-T}}this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1));const d=this.a[0].lineStarts.length-1,l=this.a[0].buffer.length-this.a[0].lineStarts[d],f={line:d,column:l},y=i.piece.length+o.length,k=i.piece.lineFeedCnt,S=this.t(0,i.piece.start,f),D=S-k;i.piece=new P(i.piece.bufferIndex,i.piece.start,f,S,y),this.g=f,(0,O.$tD)(this,i,o.length,D)}G(i){let o=this.root;const t=this.h.get(i);if(t)return{node:t.node,nodeStartOffset:t.nodeStartOffset,remainder:i-t.nodeStartOffset};let n=0;for(;o!==O.$mD;)if(o.size_left>i)o=o.left;else if(o.size_left+o.piece.length>=i){n+=o.size_left;const r={node:o,remainder:i-o.size_left,nodeStartOffset:n};return this.h.set(r),r}else i-=o.size_left+o.piece.length,n+=o.size_left+o.piece.length,o=o.right;return null}H(i,o){let t=this.root,n=0;for(;t!==O.$mD;)if(t.left!==O.$mD&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const r=this.B(t,i-t.lf_left-2),d=this.B(t,i-t.lf_left-1);return n+=t.size_left,{node:t,remainder:Math.min(r+o-1,d),nodeStartOffset:n}}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const r=this.B(t,i-t.lf_left-2);if(r+o-1<=t.piece.length)return{node:t,remainder:r+o-1,nodeStartOffset:n};o-=t.piece.length-r;break}else i-=t.lf_left+t.piece.lineFeedCnt,n+=t.size_left+t.piece.length,t=t.right;for(t=t.next();t!==O.$mD;){if(t.piece.lineFeedCnt>0){const r=this.B(t,0),d=this.J(t);return{node:t,remainder:Math.min(o-1,r),nodeStartOffset:d}}else if(t.piece.length>=o-1){const r=this.J(t);return{node:t,remainder:o-1,nodeStartOffset:r}}else o-=t.piece.length;t=t.next()}return null}I(i,o){if(i.piece.lineFeedCnt<1)return-1;const t=this.a[i.piece.bufferIndex],n=this.u(i.piece.bufferIndex,i.piece.start)+o;return t.buffer.charCodeAt(n)}J(i){if(!i)return 0;let o=i.size_left;for(;i!==this.root;)i.parent.right===i&&(o+=i.parent.size_left+i.parent.piece.length),i=i.parent;return o}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===O.$mD||i.piece.lineFeedCnt===0)return!1;const o=i.piece,t=this.a[o.bufferIndex].lineStarts,n=o.start.line,r=t[n]+o.start.column;return n===t.length-1||t[n+1]>r+1?!1:this.a[o.bufferIndex].buffer.charCodeAt(r)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===O.$mD||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const o=i.prev();this.M(o)&&this.P(o,i)}}O(i){if(this.K()&&this.M(i)){const o=i.next();this.L(o)&&this.P(i,o)}}P(i,o){const t=[],n=this.a[i.piece.bufferIndex].lineStarts;let r;i.piece.end.column===0?r={line:i.piece.end.line-1,column:n[i.piece.end.line]-n[i.piece.end.line-1]-1}:r={line:i.piece.end.line,column:i.piece.end.column-1};const d=i.piece.length-1,l=i.piece.lineFeedCnt-1;i.piece=new P(i.piece.bufferIndex,i.piece.start,r,l,d),(0,O.$tD)(this,i,-1,-1),i.piece.length===0&&t.push(i);const f={line:o.piece.start.line+1,column:0},y=o.piece.length-1,k=this.t(o.piece.bufferIndex,f,o.piece.end);o.piece=new P(o.piece.bufferIndex,f,o.piece.end,k,y),(0,O.$tD)(this,o,-1,-1),o.piece.length===0&&t.push(o);const S=this.w(`\r
`);this.S(i,S[0]);for(let D=0;D<t.length;D++)(0,O.$rD)(this,t[D])}Q(i,o){if(this.K()&&this.M(i)){const t=o.next();if(this.L(t)){if(i+=`
`,t.piece.length===1)(0,O.$rD)(this,t);else{const n=t.piece,r={line:n.start.line+1,column:0},d=n.length-1,l=this.t(n.bufferIndex,r,n.end);t.piece=new P(n.bufferIndex,r,n.end,l,d),(0,O.$tD)(this,t,-1,-1)}return!0}}return!1}iterate(i,o){if(i===O.$mD)return o(O.$mD);const t=this.iterate(i.left,o);return t&&o(i)&&this.iterate(i.right,o)}R(i){if(i===O.$mD)return"";const o=this.a[i.piece.bufferIndex],t=i.piece,n=this.u(t.bufferIndex,t.start),r=this.u(t.bufferIndex,t.end);return o.buffer.substring(n,r)}getPieceContent(i){const o=this.a[i.bufferIndex],t=this.u(i.bufferIndex,i.start),n=this.u(i.bufferIndex,i.end);return o.buffer.substring(t,n)}S(i,o){const t=new O.$lD(o,O.NodeColor.Red);if(t.left=O.$mD,t.right=O.$mD,t.parent=O.$mD,t.size_left=0,t.lf_left=0,this.root===O.$mD)this.root=t,t.color=O.NodeColor.Black;else if(i.right===O.$mD)i.right=t,t.parent=i;else{const r=(0,O.$nD)(i.right);r.left=t,t.parent=r}return(0,O.$sD)(this,t),t}T(i,o){const t=new O.$lD(o,O.NodeColor.Red);if(t.left=O.$mD,t.right=O.$mD,t.parent=O.$mD,t.size_left=0,t.lf_left=0,this.root===O.$mD)this.root=t,t.color=O.NodeColor.Black;else if(i.left===O.$mD)i.left=t,t.parent=i;else{const n=(0,O.$oD)(i.left);n.right=t,t.parent=n}return(0,O.$sD)(this,t),t}U(i){let o="";return this.iterate(i,t=>(o+=this.R(t),!0)),o}}e.$FD=p}),define(Re[209],Ce([1,0,4,13,30,58,143,196,200,3]),function(ge,e,s,h,R,A,O,C,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GD=void 0,h=Ue(h);class I extends c.$Xc{constructor(g,P,b,a,$,p,u){super(),this.m=this.B(new s.$oe),this.onDidChangeContent=this.m.event,this.f=P,this.j=!p,this.g=a,this.h=$,this.c=new O.$FD(g,b,u)}equals(g){return!(g instanceof I)||this.f!==g.f||this.getEOL()!==g.getEOL()?!1:this.c.equal(g.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(g){return this.c.createSnapshot(g?this.f:"")}getOffsetAt(g,P){return this.c.getOffsetAt(g,P)}getPositionAt(g){return this.c.getPositionAt(g)}getRangeAt(g,P){const b=g+P,a=this.getPositionAt(g),$=this.getPositionAt(b);return new R.$Ut(a.lineNumber,a.column,$.lineNumber,$.column)}getValueInRange(g,P=A.EndOfLinePreference.TextDefined){if(g.isEmpty())return"";const b=this.n(P);return this.c.getValueInRange(g,b)}getValueLengthInRange(g,P=A.EndOfLinePreference.TextDefined){if(g.isEmpty())return 0;if(g.startLineNumber===g.endLineNumber)return g.endColumn-g.startColumn;const b=this.getOffsetAt(g.startLineNumber,g.startColumn),a=this.getOffsetAt(g.endLineNumber,g.endColumn);let $=0;const p=this.n(P),u=this.getEOL();if(p.length!==u.length){const i=p.length-u.length,o=g.endLineNumber-g.startLineNumber;$=i*o}return a-b+$}getCharacterCountInRange(g,P=A.EndOfLinePreference.TextDefined){if(this.j){let b=0;const a=g.startLineNumber,$=g.endLineNumber;for(let p=a;p<=$;p++){const u=this.getLineContent(p),i=p===a?g.startColumn-1:0,o=p===$?g.endColumn-1:u.length;for(let t=i;t<o;t++)h.$Mf(u.charCodeAt(t))?(b=b+1,t=t+1):b=b+1}return b+=this.n(P).length*($-a),b}return this.getValueLengthInRange(g,P)}getNearestChunk(g){return this.c.getNearestChunk(g)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(g){return this.c.getLineContent(g)}getLineCharCode(g,P){return this.c.getLineCharCode(g,P)}getCharCode(g){return this.c.getCharCode(g)}getLineLength(g){return this.c.getLineLength(g)}getLineMinColumn(g){return 1}getLineMaxColumn(g){return this.getLineLength(g)+1}getLineFirstNonWhitespaceColumn(g){const P=h.$xf(this.getLineContent(g));return P===-1?0:P+1}getLineLastNonWhitespaceColumn(g){const P=h.$zf(this.getLineContent(g));return P===-1?0:P+2}n(g){switch(g){case A.EndOfLinePreference.LF:return`
`;case A.EndOfLinePreference.CRLF:return`\r
`;case A.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(g){this.c.setEOL(g)}applyEdits(g,P,b){let a=this.g,$=this.h,p=this.j,u=!0,i=[];for(let f=0;f<g.length;f++){const y=g[f];u&&y._isTracked&&(u=!1);const k=y.range;if(y.text){let w=!0;p||(w=!h.$Xf(y.text),p=w),!a&&w&&(a=h.$Wf(y.text)),!$&&w&&($=h.$Zf(y.text))}let S="",D=0,T=0,v=0;if(y.text){let w;[D,T,v,w]=(0,C.$Fu)(y.text);const M=this.getEOL(),L=M===`\r
`?C.StringEOL.CRLF:C.StringEOL.LF;w===C.StringEOL.Unknown||w===L?S=y.text:S=y.text.replace(/\r\n|\r|\n/g,M)}i[f]={sortIndex:f,identifier:y.identifier||null,range:k,rangeOffset:this.getOffsetAt(k.startLineNumber,k.startColumn),rangeLength:this.getValueLengthInRange(k),text:S,eolCount:D,firstLineLength:T,lastLineLength:v,forceMoveMarkers:!!y.forceMoveMarkers,isAutoWhitespaceEdit:y.isAutoWhitespaceEdit||!1}}i.sort(I.u);let o=!1;for(let f=0,y=i.length-1;f<y;f++){const k=i[f].range.getEndPosition(),S=i[f+1].range.getStartPosition();if(S.isBeforeOrEqual(k)){if(S.isBefore(k))throw new Error("Overlapping ranges are not allowed!");o=!0}}u&&(i=this.s(i));const t=b||P?I._getInverseEditRanges(i):[],n=[];if(P)for(let f=0;f<i.length;f++){const y=i[f],k=t[f];if(y.isAutoWhitespaceEdit&&y.range.isEmpty())for(let S=k.startLineNumber;S<=k.endLineNumber;S++){let D="";S===k.startLineNumber&&(D=this.getLineContent(y.range.startLineNumber),h.$xf(D)!==-1)||n.push({lineNumber:S,oldContent:D})}}let r=null;if(b){let f=0;r=[];for(let y=0;y<i.length;y++){const k=i[y],S=t[y],D=this.getValueInRange(k.range),T=k.rangeOffset+f;f+=k.text.length-D.length,r[y]={sortIndex:k.sortIndex,identifier:k.identifier,range:S,text:D,textChange:new m.$lu(k.rangeOffset,D,T,k.text)}}o||r.sort((y,k)=>y.sortIndex-k.sortIndex)}this.g=a,this.h=$,this.j=p;const d=this.t(i);let l=null;if(P&&n.length>0){n.sort((f,y)=>y.lineNumber-f.lineNumber),l=[];for(let f=0,y=n.length;f<y;f++){const k=n[f].lineNumber;if(f>0&&n[f-1].lineNumber===k)continue;const S=n[f].oldContent,D=this.getLineContent(k);D.length===0||D===S||h.$xf(D)!==-1||l.push(k)}}return this.m.fire(),new A.$pw(r,d,l)}s(g){return g.length<1e3?g:[this._toSingleEditOperation(g)]}_toSingleEditOperation(g){let P=!1;const b=g[0].range,a=g[g.length-1].range,$=new R.$Ut(b.startLineNumber,b.startColumn,a.endLineNumber,a.endColumn);let p=b.startLineNumber,u=b.startColumn;const i=[];for(let d=0,l=g.length;d<l;d++){const f=g[d],y=f.range;P=P||f.forceMoveMarkers,i.push(this.getValueInRange(new R.$Ut(p,u,y.startLineNumber,y.startColumn))),f.text.length>0&&i.push(f.text),p=y.endLineNumber,u=y.endColumn}const o=i.join(""),[t,n,r]=(0,C.$Fu)(o);return{sortIndex:0,identifier:g[0].identifier,range:$,rangeOffset:this.getOffsetAt($.startLineNumber,$.startColumn),rangeLength:this.getValueLengthInRange($,A.EndOfLinePreference.TextDefined),text:o,eolCount:t,firstLineLength:n,lastLineLength:r,forceMoveMarkers:P,isAutoWhitespaceEdit:!1}}t(g){g.sort(I.w);const P=[];for(let b=0;b<g.length;b++){const a=g[b],$=a.range.startLineNumber,p=a.range.startColumn,u=a.range.endLineNumber,i=a.range.endColumn;if($===u&&p===i&&a.text.length===0)continue;a.text?(this.c.delete(a.rangeOffset,a.rangeLength),this.c.insert(a.rangeOffset,a.text,!0)):this.c.delete(a.rangeOffset,a.rangeLength);const o=new R.$Ut($,p,u,i);P.push({range:o,rangeLength:a.rangeLength,text:a.text,rangeOffset:a.rangeOffset,forceMoveMarkers:a.forceMoveMarkers})}return P}findMatchesLineByLine(g,P,b,a){return this.c.findMatchesLineByLine(g,P,b,a)}getPieceTree(){return this.c}static _getInverseEditRange(g,P){const b=g.startLineNumber,a=g.startColumn,[$,p,u]=(0,C.$Fu)(P);let i;if(P.length>0){const o=$+1;o===1?i=new R.$Ut(b,a,b,a+p):i=new R.$Ut(b,a,b+o-1,u+1)}else i=new R.$Ut(b,a,b,a);return i}static _getInverseEditRanges(g){const P=[];let b=0,a=0,$=null;for(let p=0,u=g.length;p<u;p++){const i=g[p];let o,t;$?$.range.endLineNumber===i.range.startLineNumber?(o=b,t=a+(i.range.startColumn-$.range.endColumn)):(o=b+(i.range.startLineNumber-$.range.endLineNumber),t=i.range.startColumn):(o=i.range.startLineNumber,t=i.range.startColumn);let n;if(i.text.length>0){const r=i.eolCount+1;r===1?n=new R.$Ut(o,t,o,t+i.firstLineLength):n=new R.$Ut(o,t,o+r-1,i.lastLineLength+1)}else n=new R.$Ut(o,t,o,t);b=n.endLineNumber,a=n.endColumn,P.push(n),$=i}return P}static u(g,P){const b=R.$Ut.compareRangesUsingEnds(g.range,P.range);return b===0?g.sortIndex-P.sortIndex:b}static w(g,P){const b=R.$Ut.compareRangesUsingEnds(g.range,P.range);return b===0?P.sortIndex-g.sortIndex:-b}}e.$GD=I}),define(Re[210],Ce([1,0,26,13,58,143,209]),function(ge,e,s,h,R,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HD=void 0,h=Ue(h);class C{constructor(I,E,g,P,b,a,$,p,u){this.a=I,this.b=E,this.c=g,this.d=P,this.e=b,this.f=a,this.g=$,this.h=p,this.j=u}k(I){const E=this.c+this.d+this.e,g=this.c+this.e;return E===0?I===R.DefaultEndOfLine.LF?`
`:`\r
`:g>E/2?`\r
`:`
`}create(I){const E=this.k(I),g=this.a;if(this.j&&(E===`\r
`&&(this.c>0||this.d>0)||E===`
`&&(this.c>0||this.e>0)))for(let b=0,a=g.length;b<a;b++){const $=g[b].buffer.replace(/\r\n|\r|\n/g,E),p=(0,A.$BD)($);g[b]=new A.$ED($,p)}const P=new O.$GD(g,this.b,E,this.f,this.g,this.h,this.j);return{textBuffer:P,disposable:P}}getFirstLineText(I){return this.a[0].buffer.substr(0,I).split(/\r\n|\r|\n/)[0]}}class m{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(I){if(I.length===0)return;this.a.length===0&&h.$8f(I)&&(this.b=h.$7f,I=I.substr(1));const E=I.charCodeAt(I.length-1);E===s.CharCode.CarriageReturn||E>=55296&&E<=56319?(this.m(I.substr(0,I.length-1),!1),this.c=!0,this.d=E):(this.m(I,!1),this.c=!1,this.d=E)}m(I,E){!E&&I.length===0||(this.c?this.n(String.fromCharCode(this.d)+I):this.n(I))}n(I){const E=(0,A.$CD)(this.e,I);this.a.push(new A.$ED(I,E.lineStarts)),this.f+=E.cr,this.g+=E.lf,this.h+=E.crlf,E.isBasicASCII||(this.l=!1,this.j||(this.j=h.$Wf(I)),this.k||(this.k=h.$Zf(I)))}finish(I=!0){return this.o(),new C(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,I)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const I=this.a[this.a.length-1];I.buffer+=String.fromCharCode(this.d);const E=(0,A.$BD)(I.buffer);I.lineStarts=E,this.d===s.CharCode.CarriageReturn&&this.f++}}}e.$HD=m}),define(Re[144],Ce([1,0,21,10]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oeb=m,e.$peb=I,h=Ue(h);var R;(function(E){E[E.Full=1]="Full",E[E.Delta=2]="Delta"})(R||(R={}));function A(E){for(let g=0,P=E.length;g<P;g+=4){const b=E[g+0],a=E[g+1],$=E[g+2],p=E[g+3];E[g+0]=p,E[g+1]=$,E[g+2]=a,E[g+3]=b}}function O(E){const g=new Uint8Array(E.buffer,E.byteOffset,E.length*4);return h.$E()||A(g),s.$Qe.wrap(g)}function C(E){const g=E.buffer;if(h.$E()||A(g),g.byteOffset%4===0)return new Uint32Array(g.buffer,g.byteOffset,g.length/4);{const P=new Uint8Array(g.byteLength);return P.set(g),new Uint32Array(P.buffer,P.byteOffset,P.length/4)}}function m(E){const g=new Uint32Array(c(E));let P=0;if(g[P++]=E.id,E.type==="full")g[P++]=R.Full,g[P++]=E.data.length,g.set(E.data,P),P+=E.data.length;else{g[P++]=R.Delta,g[P++]=E.deltas.length;for(const b of E.deltas)g[P++]=b.start,g[P++]=b.deleteCount,b.data?(g[P++]=b.data.length,g.set(b.data,P),P+=b.data.length):g[P++]=0}return O(g)}function c(E){let g=0;if(g+=2,E.type==="full")g+=1+E.data.length;else{g+=1,g+=3*E.deltas.length;for(const P of E.deltas)P.data&&(g+=P.data.length)}return g}function I(E){const g=C(E);let P=0;const b=g[P++];if(g[P++]===R.Full){const u=g[P++],i=g.subarray(P,P+u);return P+=u,{id:b,type:"full",data:i}}const $=g[P++],p=[];for(let u=0;u<$;u++){const i=g[P++],o=g[P++],t=g[P++];let n;t>0&&(n=g.subarray(P,P+t),P+=t),p[u]={start:i,deleteCount:o,data:n}}return{id:b,type:"delta",deltas:p}}}),define(Re[211],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dab=e.$cab=void 0;class s{constructor(){this.a=new Map}removeDragOperationTransfer(A){if(A&&this.a.has(A)){const O=this.a.get(A);return this.a.delete(A),O}}addDragOperationTransfer(A,O){this.a.set(A,O)}}e.$cab=s;class h{constructor(A){this.identifier=A}}e.$dab=h}),define(Re[212],Ce([1,0,4,3,110]),function(ge,e,s,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eu=void 0;class A{constructor(){this.a=new Map,this.b=new Map,this.c=new s.$oe,this.onDidChange=this.c.event,this.d=null}handleChange(m){this.c.fire({changedLanguages:m,changedColorMap:!1})}register(m,c){return this.a.set(m,c),this.handleChange([m]),(0,h.$Vc)(()=>{this.a.get(m)===c&&(this.a.delete(m),this.handleChange([m]))})}get(m){return this.a.get(m)||null}registerFactory(m,c){this.b.get(m)?.dispose();const I=new O(this,m,c);return this.b.set(m,I),(0,h.$Vc)(()=>{const E=this.b.get(m);!E||E!==I||(this.b.delete(m),E.dispose())})}async getOrCreate(m){const c=this.get(m);if(c)return c;const I=this.b.get(m);return!I||I.isResolved?null:(await I.resolve(),this.get(m))}isResolved(m){if(this.get(m))return!0;const I=this.b.get(m);return!!(!I||I.isResolved)}setColorMap(m){this.d=m,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>R.ColorId.DefaultBackground?this.d[R.ColorId.DefaultBackground]:null}}e.$Eu=A;class O extends h.$Xc{get isResolved(){return this.c}constructor(m,c,I){super(),this.f=m,this.g=c,this.h=I,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const m=await this.h.tokenizationSupport;this.c=!0,m&&!this.a&&this.B(this.f.register(this.g,m))}}}),define(Re[8],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localize=R,e.localize2=O;const s=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function h(C,m){let c;return m.length===0?c=C:c=C.replace(/\{(\d+)\}/g,(I,E)=>{const g=E[0],P=m[g];let b=I;return typeof P=="string"?b=P:(typeof P=="number"||typeof P=="boolean"||P===void 0||P===null)&&(b=String(P)),b}),s&&(c="\uFF3B"+c.replace(/[aouei]/g,"$&$&")+"\uFF3D"),c}function R(C,m,...c){return h(typeof C=="number"?A(C,m):m,c)}function A(C,m){const c=globalThis._VSCODE_NLS_MESSAGES?.[C];if(typeof c!="string"){if(typeof m=="string")return m;throw new Error(`!!! NLS MISSING: ${C} !!!`)}return c}function O(C,m,...c){let I;typeof C=="number"?I=A(C,m):I=m;const E=h(I,c);return{value:E,original:m===I?E:h(m,c)}}}),define(Re[213],Ce([1,0,4,3,8]),function(ge,e,s,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=void 0,e.$sj=I,R=Ue(R);class A extends h.$Xc{constructor(g,P="",b="",a=!0,$){super(),this.j=this.B(new s.$oe),this.onDidChange=this.j.event,this.z=!0,this.m=g,this.n=P,this.w=b,this.z=a,this.D=$}get id(){return this.m}get label(){return this.n}set label(g){this.F(g)}F(g){this.n!==g&&(this.n=g,this.j.fire({label:g}))}get tooltip(){return this.u||""}set tooltip(g){this.G(g)}G(g){this.u!==g&&(this.u=g,this.j.fire({tooltip:g}))}get class(){return this.w}set class(g){this.H(g)}H(g){this.w!==g&&(this.w=g,this.j.fire({class:g}))}get enabled(){return this.z}set enabled(g){this.I(g)}I(g){this.z!==g&&(this.z=g,this.j.fire({enabled:g}))}get checked(){return this.C}set checked(g){this.J(g)}J(g){this.C!==g&&(this.C=g,this.j.fire({checked:g}))}async run(g,P){this.D&&await this.D(g)}}e.$nj=A;class O extends h.$Xc{constructor(){super(...arguments),this.f=this.B(new s.$oe),this.onWillRun=this.f.event,this.m=this.B(new s.$oe),this.onDidRun=this.m.event}async run(g,P){if(!g.enabled)return;this.f.fire({action:g});let b;try{await this.u(g,P)}catch(a){b=a}this.m.fire({action:g,error:b})}async u(g,P){await g.run(P)}}e.$oj=O;class C{constructor(){this.id=C.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...g){let P=[];for(const b of g)b.length&&(P.length?P=[...P,new C,...b]:P=b);return P}static{this.ID="vs.actions.separator"}async run(){}}e.$pj=C;class m{get actions(){return this.a}constructor(g,P,b,a){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=g,this.label=P,this.class=a,this.a=b}async run(){}}e.$qj=m;class c extends A{static{this.ID="vs.actions.empty"}constructor(){super(c.ID,R.localize(41,null),void 0,!1)}}e.$rj=c;function I(E){return{id:E.id,label:E.label,tooltip:E.tooltip??E.label,class:E.class,enabled:E.enabled??!0,checked:E.checked,run:async(...g)=>E.run(...g)}}}),define(Re[214],Ce([1,0,8]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=c,e.$6m=I,e.$7m=E,e.$8m=g;const h=60,R=h*60,A=R*24,O=A*7,C=A*30,m=A*365;function c(P,b,a,$){typeof P!="number"&&(P=P.getTime());const p=Math.round((new Date().getTime()-P)/1e3);if(p<-30)return(0,s.localize)(42,null,c(new Date().getTime()+p*1e3,!1));if(!$&&p<30)return(0,s.localize)(43,null);let u;return p<h?(u=p,b?u===1?a?(0,s.localize)(44,null,u):(0,s.localize)(45,null,u):a?(0,s.localize)(46,null,u):(0,s.localize)(47,null,u):u===1?a?(0,s.localize)(48,null,u):(0,s.localize)(49,null,u):a?(0,s.localize)(50,null,u):(0,s.localize)(51,null,u)):p<R?(u=Math.floor(p/h),b?u===1?a?(0,s.localize)(52,null,u):(0,s.localize)(53,null,u):a?(0,s.localize)(54,null,u):(0,s.localize)(55,null,u):u===1?a?(0,s.localize)(56,null,u):(0,s.localize)(57,null,u):a?(0,s.localize)(58,null,u):(0,s.localize)(59,null,u)):p<A?(u=Math.floor(p/R),b?u===1?a?(0,s.localize)(60,null,u):(0,s.localize)(61,null,u):a?(0,s.localize)(62,null,u):(0,s.localize)(63,null,u):u===1?a?(0,s.localize)(64,null,u):(0,s.localize)(65,null,u):a?(0,s.localize)(66,null,u):(0,s.localize)(67,null,u)):p<O?(u=Math.floor(p/A),b?u===1?(0,s.localize)(68,null,u):(0,s.localize)(69,null,u):u===1?(0,s.localize)(70,null,u):(0,s.localize)(71,null,u)):p<C?(u=Math.floor(p/O),b?u===1?a?(0,s.localize)(72,null,u):(0,s.localize)(73,null,u):a?(0,s.localize)(74,null,u):(0,s.localize)(75,null,u):u===1?a?(0,s.localize)(76,null,u):(0,s.localize)(77,null,u):a?(0,s.localize)(78,null,u):(0,s.localize)(79,null,u)):p<m?(u=Math.floor(p/C),b?u===1?a?(0,s.localize)(80,null,u):(0,s.localize)(81,null,u):a?(0,s.localize)(82,null,u):(0,s.localize)(83,null,u):u===1?a?(0,s.localize)(84,null,u):(0,s.localize)(85,null,u):a?(0,s.localize)(86,null,u):(0,s.localize)(87,null,u)):(u=Math.floor(p/m),b?u===1?a?(0,s.localize)(88,null,u):(0,s.localize)(89,null,u):a?(0,s.localize)(90,null,u):(0,s.localize)(91,null,u):u===1?a?(0,s.localize)(92,null,u):(0,s.localize)(93,null,u):a?(0,s.localize)(94,null,u):(0,s.localize)(95,null,u))}function I(P,b,a){typeof P!="number"&&(P=P.getTime());const $=new Date;$.setHours(0,0,0,0);const p=new Date($.getTime());return p.setDate(p.getDate()-1),P>$.getTime()?(0,s.localize)(96,null):P>p.getTime()?(0,s.localize)(97,null):c(P,b,a)}function E(P,b){const a=Math.abs(P/1e3);return a<1?b?(0,s.localize)(98,null,P):(0,s.localize)(99,null,P):a<h?b?(0,s.localize)(100,null,Math.round(P)/1e3):(0,s.localize)(101,null,Math.round(P)/1e3):a<R?b?(0,s.localize)(102,null,Math.round(P/(1e3*h))):(0,s.localize)(103,null,Math.round(P/(1e3*h))):a<A?b?(0,s.localize)(104,null,Math.round(P/(1e3*R))):(0,s.localize)(105,null,Math.round(P/(1e3*R))):(0,s.localize)(106,null,Math.round(P/(1e3*A)))}function g(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Re[52],Ce([1,0,18,17,8]),function(ge,e,s,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=m,e.$uj=c,e.$vj=I,s=Ue(s),h=Ue(h),R=Ue(R);function A(E,g){return g&&(E.stack||E.stacktrace)?R.localize(107,null,C(E),O(E.stack)||O(E.stacktrace)):C(E)}function O(E){return Array.isArray(E)?E.join(`
`):E}function C(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?R.localize(108,null,E.message):E.message||R.localize(109,null)}function m(E=null,g=!1){if(!E)return R.localize(110,null);if(Array.isArray(E)){const P=s.$Jb(E),b=m(P[0],g);return P.length>1?R.localize(111,null,b,P.length):b}if(h.$hg(E))return E;if(E.detail){const P=E.detail;if(P.error)return A(P.error,g);if(P.exception)return A(P.exception,g)}return E.stack?A(E,g):E.message?E.message:R.localize(112,null)}function c(E){const g=E;return g instanceof Error&&Array.isArray(g.actions)}function I(E,g){let P;return typeof E=="string"?P=new Error(E):P=E,P.actions=g,P}}),define(Re[88],Ce([1,0,84,2,197,30,212,8]),function(ge,e,s,h,R,A,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$Yu=e.$Xu=e.$Wu=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$Vu=e.$Uu=e.SymbolKinds=e.SymbolTag=e.$Su=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$Qu=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.$Pu=e.$Ou=e.$Nu=void 0,e.$Ru=d,e.$Tu=f;class m{constructor(B,Y,x){this.offset=B,this.type=Y,this.language=x,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Nu=m;class c{constructor(B,Y){this.tokens=B,this.endState=Y,this._tokenizationResultBrand=void 0}}e.$Ou=c;class I{constructor(B,Y){this.tokens=B,this.endState=Y,this._encodedTokenizationResultBrand=void 0}}e.$Pu=I;var E;(function(W){W[W.Increase=0]="Increase",W[W.Decrease=1]="Decrease"})(E||(e.HoverVerbosityAction=E={}));var g;(function(W){W[W.Method=0]="Method",W[W.Function=1]="Function",W[W.Constructor=2]="Constructor",W[W.Field=3]="Field",W[W.Variable=4]="Variable",W[W.Class=5]="Class",W[W.Struct=6]="Struct",W[W.Interface=7]="Interface",W[W.Module=8]="Module",W[W.Property=9]="Property",W[W.Event=10]="Event",W[W.Operator=11]="Operator",W[W.Unit=12]="Unit",W[W.Value=13]="Value",W[W.Constant=14]="Constant",W[W.Enum=15]="Enum",W[W.EnumMember=16]="EnumMember",W[W.Keyword=17]="Keyword",W[W.Text=18]="Text",W[W.Color=19]="Color",W[W.File=20]="File",W[W.Reference=21]="Reference",W[W.Customcolor=22]="Customcolor",W[W.Folder=23]="Folder",W[W.TypeParameter=24]="TypeParameter",W[W.User=25]="User",W[W.Issue=26]="Issue",W[W.Snippet=27]="Snippet"})(g||(e.CompletionItemKind=g={}));var P;(function(W){const B=new Map;B.set(g.Method,s.$8j.symbolMethod),B.set(g.Function,s.$8j.symbolFunction),B.set(g.Constructor,s.$8j.symbolConstructor),B.set(g.Field,s.$8j.symbolField),B.set(g.Variable,s.$8j.symbolVariable),B.set(g.Class,s.$8j.symbolClass),B.set(g.Struct,s.$8j.symbolStruct),B.set(g.Interface,s.$8j.symbolInterface),B.set(g.Module,s.$8j.symbolModule),B.set(g.Property,s.$8j.symbolProperty),B.set(g.Event,s.$8j.symbolEvent),B.set(g.Operator,s.$8j.symbolOperator),B.set(g.Unit,s.$8j.symbolUnit),B.set(g.Value,s.$8j.symbolValue),B.set(g.Enum,s.$8j.symbolEnum),B.set(g.Constant,s.$8j.symbolConstant),B.set(g.Enum,s.$8j.symbolEnum),B.set(g.EnumMember,s.$8j.symbolEnumMember),B.set(g.Keyword,s.$8j.symbolKeyword),B.set(g.Snippet,s.$8j.symbolSnippet),B.set(g.Text,s.$8j.symbolText),B.set(g.Color,s.$8j.symbolColor),B.set(g.File,s.$8j.symbolFile),B.set(g.Reference,s.$8j.symbolReference),B.set(g.Customcolor,s.$8j.symbolCustomColor),B.set(g.Folder,s.$8j.symbolFolder),B.set(g.TypeParameter,s.$8j.symbolTypeParameter),B.set(g.User,s.$8j.account),B.set(g.Issue,s.$8j.issues);function Y(ie){let me=B.get(ie);return me||(console.info("No codicon found for CompletionItemKind "+ie),me=s.$8j.symbolProperty),me}W.toIcon=Y;const x=new Map;x.set("method",g.Method),x.set("function",g.Function),x.set("constructor",g.Constructor),x.set("field",g.Field),x.set("variable",g.Variable),x.set("class",g.Class),x.set("struct",g.Struct),x.set("interface",g.Interface),x.set("module",g.Module),x.set("property",g.Property),x.set("event",g.Event),x.set("operator",g.Operator),x.set("unit",g.Unit),x.set("value",g.Value),x.set("constant",g.Constant),x.set("enum",g.Enum),x.set("enum-member",g.EnumMember),x.set("enumMember",g.EnumMember),x.set("keyword",g.Keyword),x.set("snippet",g.Snippet),x.set("text",g.Text),x.set("color",g.Color),x.set("file",g.File),x.set("reference",g.Reference),x.set("customcolor",g.Customcolor),x.set("folder",g.Folder),x.set("type-parameter",g.TypeParameter),x.set("typeParameter",g.TypeParameter),x.set("account",g.User),x.set("issue",g.Issue);function oe(ie,me){let ue=x.get(ie);return typeof ue>"u"&&!me&&(ue=g.Property),ue}W.fromString=oe})(P||(e.CompletionItemKinds=P={}));var b;(function(W){W[W.Deprecated=1]="Deprecated"})(b||(e.CompletionItemTag=b={}));var a;(function(W){W[W.None=0]="None",W[W.KeepWhitespace=1]="KeepWhitespace",W[W.InsertAsSnippet=4]="InsertAsSnippet"})(a||(e.CompletionItemInsertTextRule=a={}));var $;(function(W){W[W.Word=0]="Word",W[W.Line=1]="Line",W[W.Suggest=2]="Suggest"})($||(e.PartialAcceptTriggerKind=$={}));var p;(function(W){W[W.Invoke=0]="Invoke",W[W.TriggerCharacter=1]="TriggerCharacter",W[W.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(p||(e.CompletionTriggerKind=p={}));var u;(function(W){W[W.Automatic=0]="Automatic",W[W.Explicit=1]="Explicit"})(u||(e.InlineCompletionTriggerKind=u={}));class i{constructor(B,Y,x,oe){this.range=B,this.text=Y,this.completionKind=x,this.isSnippetText=oe}equals(B){return A.$Ut.lift(this.range).equalsRange(B.range)&&this.text===B.text&&this.completionKind===B.completionKind&&this.isSnippetText===B.isSnippetText}}e.$Qu=i;var o;(function(W){W[W.Invoke=1]="Invoke",W[W.Auto=2]="Auto"})(o||(e.CodeActionTriggerType=o={}));var t;(function(W){W[W.Automatic=0]="Automatic",W[W.PasteAs=1]="PasteAs"})(t||(e.DocumentPasteTriggerKind=t={}));var n;(function(W){W[W.Invoke=1]="Invoke",W[W.TriggerCharacter=2]="TriggerCharacter",W[W.ContentChange=3]="ContentChange"})(n||(e.SignatureHelpTriggerKind=n={}));var r;(function(W){W[W.Text=0]="Text",W[W.Read=1]="Read",W[W.Write=2]="Write"})(r||(e.DocumentHighlightKind=r={}));function d(W){return W&&h.URI.isUri(W.uri)&&A.$Ut.isIRange(W.range)&&(A.$Ut.isIRange(W.originSelectionRange)||A.$Ut.isIRange(W.targetSelectionRange))}var l;(function(W){W[W.File=0]="File",W[W.Module=1]="Module",W[W.Namespace=2]="Namespace",W[W.Package=3]="Package",W[W.Class=4]="Class",W[W.Method=5]="Method",W[W.Property=6]="Property",W[W.Field=7]="Field",W[W.Constructor=8]="Constructor",W[W.Enum=9]="Enum",W[W.Interface=10]="Interface",W[W.Function=11]="Function",W[W.Variable=12]="Variable",W[W.Constant=13]="Constant",W[W.String=14]="String",W[W.Number=15]="Number",W[W.Boolean=16]="Boolean",W[W.Array=17]="Array",W[W.Object=18]="Object",W[W.Key=19]="Key",W[W.Null=20]="Null",W[W.EnumMember=21]="EnumMember",W[W.Struct=22]="Struct",W[W.Event=23]="Event",W[W.Operator=24]="Operator",W[W.TypeParameter=25]="TypeParameter"})(l||(e.SymbolKind=l={})),e.$Su={[l.Array]:(0,C.localize)(788,null),[l.Boolean]:(0,C.localize)(789,null),[l.Class]:(0,C.localize)(790,null),[l.Constant]:(0,C.localize)(791,null),[l.Constructor]:(0,C.localize)(792,null),[l.Enum]:(0,C.localize)(793,null),[l.EnumMember]:(0,C.localize)(794,null),[l.Event]:(0,C.localize)(795,null),[l.Field]:(0,C.localize)(796,null),[l.File]:(0,C.localize)(797,null),[l.Function]:(0,C.localize)(798,null),[l.Interface]:(0,C.localize)(799,null),[l.Key]:(0,C.localize)(800,null),[l.Method]:(0,C.localize)(801,null),[l.Module]:(0,C.localize)(802,null),[l.Namespace]:(0,C.localize)(803,null),[l.Null]:(0,C.localize)(804,null),[l.Number]:(0,C.localize)(805,null),[l.Object]:(0,C.localize)(806,null),[l.Operator]:(0,C.localize)(807,null),[l.Package]:(0,C.localize)(808,null),[l.Property]:(0,C.localize)(809,null),[l.String]:(0,C.localize)(810,null),[l.Struct]:(0,C.localize)(811,null),[l.TypeParameter]:(0,C.localize)(812,null),[l.Variable]:(0,C.localize)(813,null)};function f(W,B){return(0,C.localize)(814,null,W,e.$Su[B])}var y;(function(W){W[W.Deprecated=1]="Deprecated"})(y||(e.SymbolTag=y={}));var k;(function(W){const B=new Map;B.set(l.File,s.$8j.symbolFile),B.set(l.Module,s.$8j.symbolModule),B.set(l.Namespace,s.$8j.symbolNamespace),B.set(l.Package,s.$8j.symbolPackage),B.set(l.Class,s.$8j.symbolClass),B.set(l.Method,s.$8j.symbolMethod),B.set(l.Property,s.$8j.symbolProperty),B.set(l.Field,s.$8j.symbolField),B.set(l.Constructor,s.$8j.symbolConstructor),B.set(l.Enum,s.$8j.symbolEnum),B.set(l.Interface,s.$8j.symbolInterface),B.set(l.Function,s.$8j.symbolFunction),B.set(l.Variable,s.$8j.symbolVariable),B.set(l.Constant,s.$8j.symbolConstant),B.set(l.String,s.$8j.symbolString),B.set(l.Number,s.$8j.symbolNumber),B.set(l.Boolean,s.$8j.symbolBoolean),B.set(l.Array,s.$8j.symbolArray),B.set(l.Object,s.$8j.symbolObject),B.set(l.Key,s.$8j.symbolKey),B.set(l.Null,s.$8j.symbolNull),B.set(l.EnumMember,s.$8j.symbolEnumMember),B.set(l.Struct,s.$8j.symbolStruct),B.set(l.Event,s.$8j.symbolEvent),B.set(l.Operator,s.$8j.symbolOperator),B.set(l.TypeParameter,s.$8j.symbolTypeParameter);function Y(x){let oe=B.get(x);return oe||(console.info("No codicon found for SymbolKind "+x),oe=s.$8j.symbolProperty),oe}W.toIcon=Y})(k||(e.SymbolKinds=k={}));class S{static asEditOperation(B){return R.$Vt.replace(A.$Ut.lift(B.range),B.text)}}e.$Uu=S;class D{static{this.Comment=new D("comment")}static{this.Imports=new D("imports")}static{this.Region=new D("region")}static fromValue(B){switch(B){case"comment":return D.Comment;case"imports":return D.Imports;case"region":return D.Region}return new D(B)}constructor(B){this.value=B}}e.$Vu=D;var T;(function(W){W[W.AIGenerated=1]="AIGenerated"})(T||(e.NewSymbolNameTag=T={}));var v;(function(W){W[W.Invoke=0]="Invoke",W[W.Automatic=1]="Automatic"})(v||(e.NewSymbolNameTriggerKind=v={}));var w;(function(W){function B(Y){return!Y||typeof Y!="object"?!1:typeof Y.id=="string"&&typeof Y.title=="string"}W.is=B})(w||(e.Command=w={}));var M;(function(W){W[W.Collapsed=0]="Collapsed",W[W.Expanded=1]="Expanded"})(M||(e.CommentThreadCollapsibleState=M={}));var L;(function(W){W[W.Unresolved=0]="Unresolved",W[W.Resolved=1]="Resolved"})(L||(e.CommentThreadState=L={}));var N;(function(W){W[W.Current=0]="Current",W[W.Outdated=1]="Outdated"})(N||(e.CommentThreadApplicability=N={}));var F;(function(W){W[W.Editing=0]="Editing",W[W.Preview=1]="Preview"})(F||(e.CommentMode=F={}));var V;(function(W){W[W.Published=0]="Published",W[W.Draft=1]="Draft"})(V||(e.CommentState=V={}));var j;(function(W){W[W.Type=1]="Type",W[W.Parameter=2]="Parameter"})(j||(e.InlayHintKind=j={}));class U{constructor(B){this.b=B,this.a=null}dispose(){this.a&&this.a.then(B=>{B&&B.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Wu=U,e.$Xu=new O.$Eu,e.$Yu=new O.$Eu;var z;(function(W){W[W.None=0]="None",W[W.Option=1]="Option",W[W.Default=2]="Default",W[W.Preferred=3]="Preferred"})(z||(e.ExternalUriOpenerPriority=z={}));var _;(function(W){W[W.Invoke=0]="Invoke",W[W.Automatic=1]="Automatic"})(_||(e.InlineEditTriggerKind=_={}))}),define(Re[215],Ce([1,0,26,12,8]),function(ge,e,s,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dj=e.TokenType=void 0;var A;(function(I){I[I.LParen=0]="LParen",I[I.RParen=1]="RParen",I[I.Neg=2]="Neg",I[I.Eq=3]="Eq",I[I.NotEq=4]="NotEq",I[I.Lt=5]="Lt",I[I.LtEq=6]="LtEq",I[I.Gt=7]="Gt",I[I.GtEq=8]="GtEq",I[I.RegexOp=9]="RegexOp",I[I.RegexStr=10]="RegexStr",I[I.True=11]="True",I[I.False=12]="False",I[I.In=13]="In",I[I.Not=14]="Not",I[I.And=15]="And",I[I.Or=16]="Or",I[I.Str=17]="Str",I[I.QuotedStr=18]="QuotedStr",I[I.Error=19]="Error",I[I.EOF=20]="EOF"})(A||(e.TokenType=A={}));function O(...I){switch(I.length){case 1:return(0,R.localize)(1693,null,I[0]);case 2:return(0,R.localize)(1694,null,I[0],I[1]);case 3:return(0,R.localize)(1695,null,I[0],I[1],I[2]);default:return}}const C=(0,R.localize)(1696,null),m=(0,R.localize)(1697,null);class c{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(E){switch(E.type){case A.LParen:return"(";case A.RParen:return")";case A.Neg:return"!";case A.Eq:return E.isTripleEq?"===":"==";case A.NotEq:return E.isTripleEq?"!==":"!=";case A.Lt:return"<";case A.LtEq:return"<=";case A.Gt:return">=";case A.GtEq:return">=";case A.RegexOp:return"=~";case A.RegexStr:return E.lexeme;case A.True:return"true";case A.False:return"false";case A.In:return"in";case A.Not:return"not";case A.And:return"&&";case A.Or:return"||";case A.Str:return E.lexeme;case A.QuotedStr:return E.lexeme;case A.Error:return E.lexeme;case A.EOF:return"EOF";default:throw(0,h.$0)(`unhandled token type: ${JSON.stringify(E)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(E=>E.charCodeAt(0)))}static{this.b=new Map([["not",A.Not],["in",A.In],["false",A.False],["true",A.True]])}get errors(){return this.g}reset(E){return this.c=E,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case s.CharCode.OpenParen:this.k(A.LParen);break;case s.CharCode.CloseParen:this.k(A.RParen);break;case s.CharCode.ExclamationMark:if(this.h(s.CharCode.Equals)){const g=this.h(s.CharCode.Equals);this.f.push({type:A.NotEq,offset:this.d,isTripleEq:g})}else this.k(A.Neg);break;case s.CharCode.SingleQuote:this.o();break;case s.CharCode.Slash:this.q();break;case s.CharCode.Equals:if(this.h(s.CharCode.Equals)){const g=this.h(s.CharCode.Equals);this.f.push({type:A.Eq,offset:this.d,isTripleEq:g})}else this.h(s.CharCode.Tilde)?this.k(A.RegexOp):this.l(O("==","=~"));break;case s.CharCode.LessThan:this.k(this.h(s.CharCode.Equals)?A.LtEq:A.Lt);break;case s.CharCode.GreaterThan:this.k(this.h(s.CharCode.Equals)?A.GtEq:A.Gt);break;case s.CharCode.Ampersand:this.h(s.CharCode.Ampersand)?this.k(A.And):this.l(O("&&"));break;case s.CharCode.Pipe:this.h(s.CharCode.Pipe)?this.k(A.Or):this.l(O("||"));break;case s.CharCode.Space:case s.CharCode.CarriageReturn:case s.CharCode.Tab:case s.CharCode.LineFeed:case s.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(A.EOF),Array.from(this.f)}h(E){return this.r()||this.c.charCodeAt(this.e)!==E?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?s.CharCode.Null:this.c.charCodeAt(this.e)}k(E){this.f.push({type:E,offset:this.d})}l(E){const g=this.d,P=this.c.substring(this.d,this.e),b={type:A.Error,offset:this.d,lexeme:P};this.g.push({offset:g,lexeme:P,additionalInfo:E}),this.f.push(b)}n(){this.m.lastIndex=this.d;const E=this.m.exec(this.c);if(E){this.e=this.d+E[0].length;const g=this.c.substring(this.d,this.e),P=c.b.get(g);P?this.k(P):this.f.push({type:A.Str,lexeme:g,offset:this.d})}}o(){for(;this.j()!==s.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(C);return}this.i(),this.f.push({type:A.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let E=this.e,g=!1,P=!1;for(;;){if(E>=this.c.length){this.e=E,this.l(m);return}const a=this.c.charCodeAt(E);if(g)g=!1;else if(a===s.CharCode.Slash&&!P){E++;break}else a===s.CharCode.OpenSquareBracket?P=!0:a===s.CharCode.Backslash?g=!0:a===s.CharCode.CloseSquareBracket&&(P=!1);E++}for(;E<this.c.length&&c.a.has(this.c.charCodeAt(E));)E++;this.e=E;const b=this.c.substring(this.d,this.e);this.f.push({type:A.RegexStr,lexeme:b,offset:this.d})}r(){return this.e>=this.c.length}}e.$Dj=c}),define(Re[145],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const s={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDebugCreateConfiguration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDebugCreateConfiguration.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewContainerTitle:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewContainerTitle.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:4},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookReplDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookReplDocument.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(s)}),define(Re[112],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=void 0;class s{constructor(R,A=[],O=!1){this.ctor=R,this.staticArguments=A,this.supportsDelayedInstantiation=O}}e.$Fi=s}),define(Re[89],Ce([1,0,112]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Xs=A,e.$Ys=O;const h=[];var R;(function(C){C[C.Eager=0]="Eager",C[C.Delayed=1]="Delayed"})(R||(e.InstantiationType=R={}));function A(C,m,c){m instanceof s.$Fi||(m=new s.$Fi(m,[],!!c)),h.push([C,m])}function O(){return h}}),define(Re[216],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=e.$Ar=void 0;class s{constructor(A,O){this.key=A,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.$Ar=s;class h{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const O of this.a.values())O.outgoing.size===0&&A.push(O);return A}insertEdge(A,O){const C=this.lookupOrInsertNode(A),m=this.lookupOrInsertNode(O);C.outgoing.set(m.key,m),m.incoming.set(C.key,C)}removeNode(A){const O=this.b(A);this.a.delete(O);for(const C of this.a.values())C.outgoing.delete(O),C.incoming.delete(O)}lookupOrInsertNode(A){const O=this.b(A);let C=this.a.get(O);return C||(C=new s(O,A),this.a.set(O,C)),C}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[O,C]of this.a)A.push(`${O}
	(-> incoming)[${[...C.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...C.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,O]of this.a){const C=new Set([A]),m=this.c(O,C);if(m)return m}}c(A,O){for(const[C,m]of A.outgoing){if(O.has(C))return[...O,C].join(" -> ");O.add(C);const c=this.c(m,O);if(c)return c;O.delete(C)}}}e.$Br=h}),define(Re[5],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=e._util=void 0,e.$Ii=R,e.$Ji=A;var s;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function C(m){return m[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=C})(s||(e._util=s={})),e.$Hi=R("instantiationService");function h(O,C,m){C[s.DI_TARGET]===C?C[s.DI_DEPENDENCIES].push({id:O,index:m}):(C[s.DI_DEPENDENCIES]=[{id:O,index:m}],C[s.DI_TARGET]=C)}function R(O){if(s.serviceIds.has(O))return s.serviceIds.get(O);const C=function(m,c,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");h(C,m,I)};return C.toString=()=>O,s.serviceIds.set(O,C),C}function A(O){return O}}),define(Re[46],Ce([1,0,17,2,5]),function(ge,e,s,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$cj=void 0,e.$dj=A,e.$ej=O,e.$fj=m,e.$gj=c,e.$hj=I,e.$ij=E,e.$jj=g,e.$kj=b,e.$lj=a,e.$mj=$,s=Ue(s),e.$cj=(0,R.$Ii)("configurationService");function A(p){return p&&typeof p=="object"&&(!p.overrideIdentifier||typeof p.overrideIdentifier=="string")&&(!p.resource||p.resource instanceof h.URI)}function O(p){return p&&typeof p=="object"&&(!p.overrideIdentifiers||Array.isArray(p.overrideIdentifiers))&&!p.overrideIdentifier&&(!p.resource||p.resource instanceof h.URI)}var C;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.USER=2]="USER",p[p.USER_LOCAL=3]="USER_LOCAL",p[p.USER_REMOTE=4]="USER_REMOTE",p[p.WORKSPACE=5]="WORKSPACE",p[p.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",p[p.DEFAULT=7]="DEFAULT",p[p.MEMORY=8]="MEMORY"})(C||(e.ConfigurationTarget=C={}));function m(p){switch(p){case C.APPLICATION:return"APPLICATION";case C.USER:return"USER";case C.USER_LOCAL:return"USER_LOCAL";case C.USER_REMOTE:return"USER_REMOTE";case C.WORKSPACE:return"WORKSPACE";case C.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case C.DEFAULT:return"DEFAULT";case C.MEMORY:return"MEMORY"}}function c(p){return p.applicationValue!==void 0||p.userValue!==void 0||p.userLocalValue!==void 0||p.userRemoteValue!==void 0||p.workspaceValue!==void 0||p.workspaceFolderValue!==void 0}function I(p,u){const i=Object.create(null);for(const o in p)E(i,o,p[o],u);return i}function E(p,u,i,o){const t=u.split("."),n=t.pop();let r=p;for(let d=0;d<t.length;d++){const l=t[d];let f=r[l];switch(typeof f){case"undefined":f=r[l]=Object.create(null);break;case"object":if(f===null){o(`Ignoring ${u} as ${t.slice(0,d+1).join(".")} is null`);return}break;default:o(`Ignoring ${u} as ${t.slice(0,d+1).join(".")} is ${JSON.stringify(f)}`);return}r=f}if(typeof r=="object"&&r!==null)try{r[n]=i}catch{o(`Ignoring ${u} as ${t.join(".")} is ${JSON.stringify(r)}`)}else o(`Ignoring ${u} as ${t.join(".")} is ${JSON.stringify(r)}`)}function g(p,u){const i=u.split(".");P(p,i)}function P(p,u){const i=u.shift();if(u.length===0){delete p[i];return}if(Object.keys(p).indexOf(i)!==-1){const o=p[i];typeof o=="object"&&!Array.isArray(o)&&(P(o,u),Object.keys(o).length===0&&delete p[i])}}function b(p,u,i){function o(r,d){let l=r;for(const f of d){if(typeof l!="object"||l===null)return;l=l[f]}return l}const t=u.split("."),n=o(p,t);return typeof n>"u"?i:n}function a(p,u,i){Object.keys(u).forEach(o=>{o!=="__proto__"&&(o in p?s.$jg(p[o])&&s.$jg(u[o])?a(p[o],u[o],i):i&&(p[o]=u[o]):p[o]=u[o])})}function $(p){return p.replace(/[\[\]]/g,"")}}),define(Re[36],Ce([1,0,26,10,13,215,5,8,12]),function(ge,e,s,h,R,A,O,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Gj=e.$Fj=e.ContextKeyExprType=void 0,e.$Ej=I,e.$Hj=d,e.$Ij=l,e.$2j=ie;const c=new Map;c.set("false",!1),c.set("true",!0),c.set("isMac",h.$k),c.set("isLinux",h.$l),c.set("isWindows",h.$j),c.set("isWeb",h.$p),c.set("isMacNative",h.$k&&!h.$p),c.set("isEdge",h.$I),c.set("isFirefox",h.$G),c.set("isChrome",h.$F),c.set("isSafari",h.$H);function I(X,q){if(c.get(X)!==void 0)throw(0,m.$9)("contextkey.setConstant(k, v) invoked with already set constant `k`");c.set(X,q)}const E=Object.prototype.hasOwnProperty;var g;(function(X){X[X.False=0]="False",X[X.True=1]="True",X[X.Defined=2]="Defined",X[X.Not=3]="Not",X[X.Equals=4]="Equals",X[X.NotEquals=5]="NotEquals",X[X.And=6]="And",X[X.Regex=7]="Regex",X[X.NotRegex=8]="NotRegex",X[X.Or=9]="Or",X[X.In=10]="In",X[X.NotIn=11]="NotIn",X[X.Greater=12]="Greater",X[X.GreaterEquals=13]="GreaterEquals",X[X.Smaller=14]="Smaller",X[X.SmallerEquals=15]="SmallerEquals"})(g||(e.ContextKeyExprType=g={}));const P={regexParsingWithErrorRecovery:!0},b=(0,C.localize)(1673,null),a=(0,C.localize)(1674,null),$=(0,C.localize)(1675,null),p=(0,C.localize)(1676,null),u=(0,C.localize)(1677,null),i=(0,C.localize)(1678,null),o=(0,C.localize)(1679,null),t=(0,C.localize)(1680,null);class n{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(q=P){this.k=q,this.d=new A.$Dj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(q){if(q===""){this.h.push({message:b,offset:0,lexeme:"",additionalInfo:a});return}this.f=this.d.reset(q).scan(),this.g=0,this.h=[];try{const se=this.l();if(!this.E()){const be=this.D(),ae=be.type===A.TokenType.Str?i:void 0;throw this.h.push({message:u,offset:be.offset,lexeme:A.$Dj.getLexeme(be),additionalInfo:ae}),n.c}return se}catch(se){if(se!==n.c)throw se;return}}l(){return this.m()}m(){const q=[this.o()];for(;this.y(A.TokenType.Or);){const se=this.o();q.push(se)}return q.length===1?q[0]:r.or(...q)}o(){const q=[this.s()];for(;this.y(A.TokenType.And);){const se=this.s();q.push(se)}return q.length===1?q[0]:r.and(...q)}s(){if(this.y(A.TokenType.Neg)){const q=this.D();switch(q.type){case A.TokenType.True:return this.z(),y.INSTANCE;case A.TokenType.False:return this.z(),k.INSTANCE;case A.TokenType.LParen:{this.z();const se=this.l();return this.A(A.TokenType.RParen,p),se?.negate()}case A.TokenType.Str:return this.z(),M.create(q.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",q)}}return this.t()}t(){const q=this.D();switch(q.type){case A.TokenType.True:return this.z(),r.true();case A.TokenType.False:return this.z(),r.false();case A.TokenType.LParen:{this.z();const se=this.l();return this.A(A.TokenType.RParen,p),se}case A.TokenType.Str:{const se=q.lexeme;if(this.z(),this.y(A.TokenType.RegexOp)){const ae=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ae.type!==A.TokenType.RegexStr)throw this.B("REGEX",ae);const we=ae.lexeme,$e=we.lastIndexOf("/"),pe=$e===we.length-1?void 0:this.w(we.substring($e+1));let Ae;try{Ae=new RegExp(we.substring(1,$e),pe)}catch{throw this.B("REGEX",ae)}return U.create(se,Ae)}switch(ae.type){case A.TokenType.RegexStr:case A.TokenType.Error:{const we=[ae.lexeme];this.z();let $e=this.D(),pe=0;for(let xe=0;xe<ae.lexeme.length;xe++)ae.lexeme.charCodeAt(xe)===s.CharCode.OpenParen?pe++:ae.lexeme.charCodeAt(xe)===s.CharCode.CloseParen&&pe--;for(;!this.E()&&$e.type!==A.TokenType.And&&$e.type!==A.TokenType.Or;){switch($e.type){case A.TokenType.LParen:pe++;break;case A.TokenType.RParen:pe--;break;case A.TokenType.RegexStr:case A.TokenType.QuotedStr:for(let xe=0;xe<$e.lexeme.length;xe++)$e.lexeme.charCodeAt(xe)===s.CharCode.OpenParen?pe++:ae.lexeme.charCodeAt(xe)===s.CharCode.CloseParen&&pe--}if(pe<0)break;we.push(A.$Dj.getLexeme($e)),this.z(),$e=this.D()}const Ae=we.join(""),je=Ae.lastIndexOf("/"),He=je===Ae.length-1?void 0:this.w(Ae.substring(je+1));let Ye;try{Ye=new RegExp(Ae.substring(1,je),He)}catch{throw this.B("REGEX",ae)}return r.regex(se,Ye)}case A.TokenType.QuotedStr:{const we=ae.lexeme;this.z();let $e=null;if(!(0,R.$ff)(we)){const pe=we.indexOf("/"),Ae=we.lastIndexOf("/");if(pe!==Ae&&pe>=0){const je=we.slice(pe+1,Ae),He=we[Ae+1]==="i"?"i":"";try{$e=new RegExp(je,He)}catch{throw this.B("REGEX",ae)}}}if($e===null)throw this.B("REGEX",ae);return U.create(se,$e)}default:throw this.B("REGEX",this.D())}}if(this.y(A.TokenType.Not)){this.A(A.TokenType.In,$);const ae=this.u();return r.notIn(se,ae)}switch(this.D().type){case A.TokenType.Eq:{this.z();const ae=this.u();if(this.x().type===A.TokenType.QuotedStr)return r.equals(se,ae);switch(ae){case"true":return r.has(se);case"false":return r.not(se);default:return r.equals(se,ae)}}case A.TokenType.NotEq:{this.z();const ae=this.u();if(this.x().type===A.TokenType.QuotedStr)return r.notEquals(se,ae);switch(ae){case"true":return r.not(se);case"false":return r.has(se);default:return r.notEquals(se,ae)}}case A.TokenType.Lt:return this.z(),V.create(se,this.u());case A.TokenType.LtEq:return this.z(),j.create(se,this.u());case A.TokenType.Gt:return this.z(),N.create(se,this.u());case A.TokenType.GtEq:return this.z(),F.create(se,this.u());case A.TokenType.In:return this.z(),r.in(se,this.u());default:return r.has(se)}}case A.TokenType.EOF:throw this.h.push({message:o,offset:q.offset,lexeme:"",additionalInfo:t}),n.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const q=this.D();switch(q.type){case A.TokenType.Str:case A.TokenType.QuotedStr:return this.z(),q.lexeme;case A.TokenType.True:return this.z(),"true";case A.TokenType.False:return this.z(),"false";case A.TokenType.In:return this.z(),"in";default:return""}}w(q){return q.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(q){return this.C(q)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(q,se){if(this.C(q))return this.z();throw this.B(se,this.D())}B(q,se,be){const ae=(0,C.localize)(1681,null,q,A.$Dj.getLexeme(se)),we=se.offset,$e=A.$Dj.getLexeme(se);return this.h.push({message:ae,offset:we,lexeme:$e,additionalInfo:be}),n.c}C(q){return this.D().type===q}D(){return this.f[this.g]}E(){return this.D().type===A.TokenType.EOF}}e.$Fj=n;class r{static false(){return y.INSTANCE}static true(){return k.INSTANCE}static has(q){return S.create(q)}static equals(q,se){return D.create(q,se)}static notEquals(q,se){return w.create(q,se)}static regex(q,se){return U.create(q,se)}static in(q,se){return T.create(q,se)}static notIn(q,se){return v.create(q,se)}static not(q){return M.create(q)}static and(...q){return W.create(q,null,!0)}static or(...q){return B.create(q,null,!0)}static greater(q,se){return N.create(q,se)}static greaterEquals(q,se){return F.create(q,se)}static smaller(q,se){return V.create(q,se)}static smallerEquals(q,se){return j.create(q,se)}static{this.c=new n({regexParsingWithErrorRecovery:!1})}static deserialize(q){return q==null?void 0:this.c.parse(q)}}e.$Gj=r;function d(X){const q=new n({regexParsingWithErrorRecovery:!1});return X.map(se=>(q.parse(se),q.lexingErrors.length>0?q.lexingErrors.map(be=>({errorMessage:be.additionalInfo?(0,C.localize)(1682,null,be.additionalInfo):(0,C.localize)(1683,null),offset:be.offset,length:be.lexeme.length})):q.parsingErrors.length>0?q.parsingErrors.map(be=>({errorMessage:be.additionalInfo?`${be.message}. ${be.additionalInfo}`:be.message,offset:be.offset,length:be.lexeme.length})):[]))}function l(X,q){const se=X?X.substituteConstants():void 0,be=q?q.substituteConstants():void 0;return!se&&!be?!0:!se||!be?!1:se.equals(be)}function f(X,q){return X.cmp(q)}class y{static{this.INSTANCE=new y}constructor(){this.type=g.False}cmp(q){return this.type-q.type}equals(q){return q.type===this.type}substituteConstants(){return this}evaluate(q){return!1}serialize(){return"false"}keys(){return[]}map(q){return this}negate(){return k.INSTANCE}}e.$Jj=y;class k{static{this.INSTANCE=new k}constructor(){this.type=g.True}cmp(q){return this.type-q.type}equals(q){return q.type===this.type}substituteConstants(){return this}evaluate(q){return!0}serialize(){return"true"}keys(){return[]}map(q){return this}negate(){return y.INSTANCE}}e.$Kj=k;class S{static create(q,se=null){const be=c.get(q);return typeof be=="boolean"?be?k.INSTANCE:y.INSTANCE:new S(q,se)}constructor(q,se){this.key=q,this.c=se,this.type=g.Defined}cmp(q){return q.type!==this.type?this.type-q.type:x(this.key,q.key)}equals(q){return q.type===this.type?this.key===q.key:!1}substituteConstants(){const q=c.get(this.key);return typeof q=="boolean"?q?k.INSTANCE:y.INSTANCE:this}evaluate(q){return!!q.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(q){return q.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$Lj=S;class D{static create(q,se,be=null){if(typeof se=="boolean")return se?S.create(q,be):M.create(q,be);const ae=c.get(q);return typeof ae=="boolean"?se===(ae?"true":"false")?k.INSTANCE:y.INSTANCE:new D(q,se,be)}constructor(q,se,be){this.c=q,this.d=se,this.f=be,this.type=g.Equals}cmp(q){return q.type!==this.type?this.type-q.type:oe(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){const q=c.get(this.c);if(typeof q=="boolean"){const se=q?"true":"false";return this.d===se?k.INSTANCE:y.INSTANCE}return this}evaluate(q){return q.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(q){return q.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.$Mj=D;class T{static create(q,se){return new T(q,se)}constructor(q,se){this.d=q,this.f=se,this.type=g.In,this.c=null}cmp(q){return q.type!==this.type?this.type-q.type:oe(this.d,this.f,q.d,q.f)}equals(q){return q.type===this.type?this.d===q.d&&this.f===q.f:!1}substituteConstants(){return this}evaluate(q){const se=q.getValue(this.f),be=q.getValue(this.d);return Array.isArray(se)?se.includes(be):typeof be=="string"&&typeof se=="object"&&se!==null?E.call(se,be):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(q){return q.mapIn(this.d,this.f)}negate(){return this.c||(this.c=v.create(this.d,this.f)),this.c}}e.$Nj=T;class v{static create(q,se){return new v(q,se)}constructor(q,se){this.d=q,this.f=se,this.type=g.NotIn,this.c=T.create(q,se)}cmp(q){return q.type!==this.type?this.type-q.type:this.c.cmp(q.c)}equals(q){return q.type===this.type?this.c.equals(q.c):!1}substituteConstants(){return this}evaluate(q){return!this.c.evaluate(q)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(q){return q.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Oj=v;class w{static create(q,se,be=null){if(typeof se=="boolean")return se?M.create(q,be):S.create(q,be);const ae=c.get(q);return typeof ae=="boolean"?se===(ae?"true":"false")?y.INSTANCE:k.INSTANCE:new w(q,se,be)}constructor(q,se,be){this.c=q,this.d=se,this.f=be,this.type=g.NotEquals}cmp(q){return q.type!==this.type?this.type-q.type:oe(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){const q=c.get(this.c);if(typeof q=="boolean"){const se=q?"true":"false";return this.d===se?y.INSTANCE:k.INSTANCE}return this}evaluate(q){return q.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(q){return q.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$Pj=w;class M{static create(q,se=null){const be=c.get(q);return typeof be=="boolean"?be?y.INSTANCE:k.INSTANCE:new M(q,se)}constructor(q,se){this.c=q,this.d=se,this.type=g.Not}cmp(q){return q.type!==this.type?this.type-q.type:x(this.c,q.c)}equals(q){return q.type===this.type?this.c===q.c:!1}substituteConstants(){const q=c.get(this.c);return typeof q=="boolean"?q?y.INSTANCE:k.INSTANCE:this}evaluate(q){return!q.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(q){return q.mapNot(this.c)}negate(){return this.d||(this.d=S.create(this.c,this)),this.d}}e.$Qj=M;function L(X,q){if(typeof X=="string"){const se=parseFloat(X);isNaN(se)||(X=se)}return typeof X=="string"||typeof X=="number"?q(X):y.INSTANCE}class N{static create(q,se,be=null){return L(se,ae=>new N(q,ae,be))}constructor(q,se,be){this.c=q,this.d=se,this.f=be,this.type=g.Greater}cmp(q){return q.type!==this.type?this.type-q.type:oe(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(q){return q.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Rj=N;class F{static create(q,se,be=null){return L(se,ae=>new F(q,ae,be))}constructor(q,se,be){this.c=q,this.d=se,this.f=be,this.type=g.GreaterEquals}cmp(q){return q.type!==this.type?this.type-q.type:oe(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(q){return q.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Sj=F;class V{static create(q,se,be=null){return L(se,ae=>new V(q,ae,be))}constructor(q,se,be){this.c=q,this.d=se,this.f=be,this.type=g.Smaller}cmp(q){return q.type!==this.type?this.type-q.type:oe(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(q){return q.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Tj=V;class j{static create(q,se,be=null){return L(se,ae=>new j(q,ae,be))}constructor(q,se,be){this.c=q,this.d=se,this.f=be,this.type=g.SmallerEquals}cmp(q){return q.type!==this.type?this.type-q.type:oe(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(q){return q.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Uj=j;class U{static create(q,se){return new U(q,se)}constructor(q,se){this.d=q,this.f=se,this.type=g.Regex,this.c=null}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.d<q.d)return-1;if(this.d>q.d)return 1;const se=this.f?this.f.source:"",be=q.f?q.f.source:"";return se<be?-1:se>be?1:0}equals(q){if(q.type===this.type){const se=this.f?this.f.source:"",be=q.f?q.f.source:"";return this.d===q.d&&se===be}return!1}substituteConstants(){return this}evaluate(q){const se=q.getValue(this.d);return this.f?this.f.test(se):!1}serialize(){const q=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${q}`}keys(){return[this.d]}map(q){return q.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=z.create(this)),this.c}}e.$Vj=U;class z{static create(q){return new z(q)}constructor(q){this.c=q,this.type=g.NotRegex}cmp(q){return q.type!==this.type?this.type-q.type:this.c.cmp(q.c)}equals(q){return q.type===this.type?this.c.equals(q.c):!1}substituteConstants(){return this}evaluate(q){return!this.c.evaluate(q)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(q){return new z(this.c.map(q))}negate(){return this.c}}e.$Wj=z;function _(X){let q=null;for(let se=0,be=X.length;se<be;se++){const ae=X[se].substituteConstants();if(X[se]!==ae&&q===null){q=[];for(let we=0;we<se;we++)q[we]=X[we]}q!==null&&(q[se]=ae)}return q===null?X:q}class W{static create(q,se,be){return W.d(q,se,be)}constructor(q,se){this.expr=q,this.c=se,this.type=g.And}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.expr.length<q.expr.length)return-1;if(this.expr.length>q.expr.length)return 1;for(let se=0,be=this.expr.length;se<be;se++){const ae=f(this.expr[se],q.expr[se]);if(ae!==0)return ae}return 0}equals(q){if(q.type===this.type){if(this.expr.length!==q.expr.length)return!1;for(let se=0,be=this.expr.length;se<be;se++)if(!this.expr[se].equals(q.expr[se]))return!1;return!0}return!1}substituteConstants(){const q=_(this.expr);return q===this.expr?this:W.create(q,this.c,!1)}evaluate(q){for(let se=0,be=this.expr.length;se<be;se++)if(!this.expr[se].evaluate(q))return!1;return!0}static d(q,se,be){const ae=[];let we=!1;for(const $e of q)if($e){if($e.type===g.True){we=!0;continue}if($e.type===g.False)return y.INSTANCE;if($e.type===g.And){ae.push(...$e.expr);continue}ae.push($e)}if(ae.length===0&&we)return k.INSTANCE;if(ae.length!==0){if(ae.length===1)return ae[0];ae.sort(f);for(let $e=1;$e<ae.length;$e++)ae[$e-1].equals(ae[$e])&&(ae.splice($e,1),$e--);if(ae.length===1)return ae[0];for(;ae.length>1;){const $e=ae[ae.length-1];if($e.type!==g.Or)break;ae.pop();const pe=ae.pop(),Ae=ae.length===0,je=B.create($e.expr.map(He=>W.create([He,pe],null,be)),null,Ae);je&&(ae.push(je),ae.sort(f))}if(ae.length===1)return ae[0];if(be){for(let $e=0;$e<ae.length;$e++)for(let pe=$e+1;pe<ae.length;pe++)if(ae[$e].negate().equals(ae[pe]))return y.INSTANCE;if(ae.length===1)return ae[0]}return new W(ae,se)}}serialize(){return this.expr.map(q=>q.serialize()).join(" && ")}keys(){const q=[];for(const se of this.expr)q.push(...se.keys());return q}map(q){return new W(this.expr.map(se=>se.map(q)),null)}negate(){if(!this.c){const q=[];for(const se of this.expr)q.push(se.negate());this.c=B.create(q,this,!0)}return this.c}}e.$Xj=W;class B{static create(q,se,be){return B.d(q,se,be)}constructor(q,se){this.expr=q,this.c=se,this.type=g.Or}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.expr.length<q.expr.length)return-1;if(this.expr.length>q.expr.length)return 1;for(let se=0,be=this.expr.length;se<be;se++){const ae=f(this.expr[se],q.expr[se]);if(ae!==0)return ae}return 0}equals(q){if(q.type===this.type){if(this.expr.length!==q.expr.length)return!1;for(let se=0,be=this.expr.length;se<be;se++)if(!this.expr[se].equals(q.expr[se]))return!1;return!0}return!1}substituteConstants(){const q=_(this.expr);return q===this.expr?this:B.create(q,this.c,!1)}evaluate(q){for(let se=0,be=this.expr.length;se<be;se++)if(this.expr[se].evaluate(q))return!0;return!1}static d(q,se,be){let ae=[],we=!1;if(q){for(let $e=0,pe=q.length;$e<pe;$e++){const Ae=q[$e];if(Ae){if(Ae.type===g.False){we=!0;continue}if(Ae.type===g.True)return k.INSTANCE;if(Ae.type===g.Or){ae=ae.concat(Ae.expr);continue}ae.push(Ae)}}if(ae.length===0&&we)return y.INSTANCE;ae.sort(f)}if(ae.length!==0){if(ae.length===1)return ae[0];for(let $e=1;$e<ae.length;$e++)ae[$e-1].equals(ae[$e])&&(ae.splice($e,1),$e--);if(ae.length===1)return ae[0];if(be){for(let $e=0;$e<ae.length;$e++)for(let pe=$e+1;pe<ae.length;pe++)if(ae[$e].negate().equals(ae[pe]))return k.INSTANCE;if(ae.length===1)return ae[0]}return new B(ae,se)}}serialize(){return this.expr.map(q=>q.serialize()).join(" || ")}keys(){const q=[];for(const se of this.expr)q.push(...se.keys());return q}map(q){return new B(this.expr.map(se=>se.map(q)),null)}negate(){if(!this.c){const q=[];for(const se of this.expr)q.push(se.negate());for(;q.length>1;){const se=q.shift(),be=q.shift(),ae=[];for(const we of ue(se))for(const $e of ue(be))ae.push(W.create([we,$e],null,!1));q.unshift(B.create(ae,null,!1))}this.c=B.create(q,this,!0)}return this.c}}e.$Yj=B;class Y extends S{static{this.d=[]}static all(){return Y.d.values()}constructor(q,se,be){super(q,null),this.f=se,typeof be=="object"?Y.d.push({...be,key:q}):be!==!0&&Y.d.push({key:q,description:be,type:se!=null?typeof se:void 0})}bindTo(q){return q.createKey(this.key,this.f)}getValue(q){return q.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(q){return D.create(this.key,q)}notEqualsTo(q){return w.create(this.key,q)}}e.$Zj=Y,e.$1j=(0,O.$Ii)("contextKeyService");function x(X,q){return X<q?-1:X>q?1:0}function oe(X,q,se,be){return X<se?-1:X>se?1:q<be?-1:q>be?1:0}function ie(X,q){if(X.type===g.False||q.type===g.True)return!0;if(X.type===g.Or)return q.type===g.Or?me(X.expr,q.expr):!1;if(q.type===g.Or){for(const se of q.expr)if(ie(X,se))return!0;return!1}if(X.type===g.And){if(q.type===g.And)return me(q.expr,X.expr);for(const se of X.expr)if(ie(se,q))return!0;return!1}return X.equals(q)}function me(X,q){let se=0,be=0;for(;se<X.length&&be<q.length;){const ae=X[se].cmp(q[be]);if(ae<0)return!1;ae===0&&se++,be++}return se===X.length}function ue(X){return X.type===g.Or?X.expr:[X]}}),define(Re[217],Ce([1,0,36,5]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$At=e.$yt=e.AccessibilitySupport=e.$xt=void 0,e.$zt=A,e.$xt=(0,h.$Ii)("accessibilityService");var R;(function(O){O[O.Unknown=0]="Unknown",O[O.Disabled=1]="Disabled",O[O.Enabled=2]="Enabled"})(R||(e.AccessibilitySupport=R={})),e.$yt=new s.$Zj("accessibilityModeEnabled",!1);function A(O){return O&&typeof O=="object"&&typeof O.label=="string"&&(typeof O.role>"u"||typeof O.role=="string")}e.$At="ACCESSIBLE_VIEW_SHOWN_"}),define(Re[113],Ce([1,0,18,24,10,188,85,201,142,8,217]),function(ge,e,s,h,R,A,O,C,m,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=i,e.clampedInt=t,e.clampedFloat=r,e.stringSet=f,e.cursorStyleToString=L,e.filterValidationDecorations=We,s=Ue(s),h=Ue(h),R=Ue(R),c=Ue(c);var E;(function(ne){ne[ne.None=0]="None",ne[ne.Keep=1]="Keep",ne[ne.Brackets=2]="Brackets",ne[ne.Advanced=3]="Advanced",ne[ne.Full=4]="Full"})(E||(e.EditorAutoIndentStrategy=E={})),e.MINIMAP_GUTTER_WIDTH=8;class g{constructor(J){this.c=J}hasChanged(J){return this.c[J]}}e.ConfigurationChangedEvent=g;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class b{constructor(J,Pe,Ge,Je){this.id=J,this.name=Pe,this.defaultValue=Ge,this.schema=Je}applyUpdate(J,Pe){return $(J,Pe)}compute(J,Pe,Ge){return Ge}}class a{constructor(J,Pe){this.newValue=J,this.didChange=Pe}}e.ApplyUpdateResult=a;function $(ne,J){if(typeof ne!="object"||typeof J!="object"||!ne||!J)return new a(J,ne!==J);if(Array.isArray(ne)||Array.isArray(J)){const Ge=Array.isArray(ne)&&Array.isArray(J)&&s.$wb(ne,J);return new a(J,!Ge)}let Pe=!1;for(const Ge in J)if(J.hasOwnProperty(Ge)){const Je=$(ne[Ge],J[Ge]);Je.didChange&&(ne[Ge]=Je.newValue,Pe=!0)}return new a(ne,Pe)}class p{constructor(J){this.schema=void 0,this.id=J,this.name="_never_",this.defaultValue=void 0}applyUpdate(J,Pe){return $(J,Pe)}validate(J){return this.defaultValue}}class u{constructor(J,Pe,Ge,Je){this.id=J,this.name=Pe,this.defaultValue=Ge,this.schema=Je}applyUpdate(J,Pe){return $(J,Pe)}validate(J){return typeof J>"u"?this.defaultValue:J}compute(J,Pe,Ge){return Ge}}function i(ne,J){return typeof ne>"u"?J:ne==="false"?!1:!!ne}class o extends u{constructor(J,Pe,Ge,Je=void 0){typeof Je<"u"&&(Je.type="boolean",Je.default=Ge),super(J,Pe,Ge,Je)}validate(J){return i(J,this.defaultValue)}}function t(ne,J,Pe,Ge){if(typeof ne>"u")return J;let Je=parseInt(ne,10);return isNaN(Je)?J:(Je=Math.max(Pe,Je),Je=Math.min(Ge,Je),Je|0)}class n extends u{static clampedInt(J,Pe,Ge,Je){return t(J,Pe,Ge,Je)}constructor(J,Pe,Ge,Je,st,ht=void 0){typeof ht<"u"&&(ht.type="integer",ht.default=Ge,ht.minimum=Je,ht.maximum=st),super(J,Pe,Ge,ht),this.minimum=Je,this.maximum=st}validate(J){return n.clampedInt(J,this.defaultValue,this.minimum,this.maximum)}}function r(ne,J,Pe,Ge){if(typeof ne>"u")return J;const Je=d.float(ne,J);return d.clamp(Je,Pe,Ge)}class d extends u{static clamp(J,Pe,Ge){return J<Pe?Pe:J>Ge?Ge:J}static float(J,Pe){if(typeof J=="number")return J;if(typeof J>"u")return Pe;const Ge=parseFloat(J);return isNaN(Ge)?Pe:Ge}constructor(J,Pe,Ge,Je,st){typeof st<"u"&&(st.type="number",st.default=Ge),super(J,Pe,Ge,st),this.validationFn=Je}validate(J){return this.validationFn(d.float(J,this.defaultValue))}}class l extends u{static string(J,Pe){return typeof J!="string"?Pe:J}constructor(J,Pe,Ge,Je=void 0){typeof Je<"u"&&(Je.type="string",Je.default=Ge),super(J,Pe,Ge,Je)}validate(J){return l.string(J,this.defaultValue)}}function f(ne,J,Pe,Ge){return typeof ne!="string"?J:Ge&&ne in Ge?Ge[ne]:Pe.indexOf(ne)===-1?J:ne}class y extends u{constructor(J,Pe,Ge,Je,st=void 0){typeof st<"u"&&(st.type="string",st.enum=Je,st.default=Ge),super(J,Pe,Ge,st),this.c=Je}validate(J){return f(J,this.defaultValue,this.c)}}class k extends b{constructor(J,Pe,Ge,Je,st,ht,ft=void 0){typeof ft<"u"&&(ft.type="string",ft.enum=st,ft.default=Je),super(J,Pe,Ge,ft),this.c=st,this.d=ht}validate(J){return typeof J!="string"?this.defaultValue:this.c.indexOf(J)===-1?this.defaultValue:this.d(J)}}function S(ne){switch(ne){case"none":return E.None;case"keep":return E.Keep;case"brackets":return E.Brackets;case"advanced":return E.Advanced;case"full":return E.Full}}class D extends b{constructor(){super(ke.accessibilitySupport,"accessibilitySupport",I.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(302,null),c.localize(303,null),c.localize(304,null)],default:"auto",tags:["accessibility"],description:c.localize(305,null)})}validate(J){switch(J){case"auto":return I.AccessibilitySupport.Unknown;case"off":return I.AccessibilitySupport.Disabled;case"on":return I.AccessibilitySupport.Enabled}return this.defaultValue}compute(J,Pe,Ge){return Ge===I.AccessibilitySupport.Unknown?J.accessibilitySupport:Ge}}class T extends b{constructor(){const J={insertSpace:!0,ignoreEmptyLines:!0};super(ke.comments,"comments",J,{"editor.comments.insertSpace":{type:"boolean",default:J.insertSpace,description:c.localize(306,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:J.ignoreEmptyLines,description:c.localize(307,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Pe=J;return{insertSpace:i(Pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:i(Pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var v;(function(ne){ne[ne.Hidden=0]="Hidden",ne[ne.Blink=1]="Blink",ne[ne.Smooth=2]="Smooth",ne[ne.Phase=3]="Phase",ne[ne.Expand=4]="Expand",ne[ne.Solid=5]="Solid"})(v||(e.TextEditorCursorBlinkingStyle=v={}));function w(ne){switch(ne){case"blink":return v.Blink;case"smooth":return v.Smooth;case"phase":return v.Phase;case"expand":return v.Expand;case"solid":return v.Solid}}var M;(function(ne){ne[ne.Line=1]="Line",ne[ne.Block=2]="Block",ne[ne.Underline=3]="Underline",ne[ne.LineThin=4]="LineThin",ne[ne.BlockOutline=5]="BlockOutline",ne[ne.UnderlineThin=6]="UnderlineThin"})(M||(e.TextEditorCursorStyle=M={}));function L(ne){switch(ne){case M.Line:return"line";case M.Block:return"block";case M.Underline:return"underline";case M.LineThin:return"line-thin";case M.BlockOutline:return"block-outline";case M.UnderlineThin:return"underline-thin"}}function N(ne){switch(ne){case"line":return M.Line;case"block":return M.Block;case"underline":return M.Underline;case"line-thin":return M.LineThin;case"block-outline":return M.BlockOutline;case"underline-thin":return M.UnderlineThin}}class F extends p{constructor(){super(ke.editorClassName)}compute(J,Pe,Ge){const Je=["monaco-editor"];return Pe.get(ke.extraEditorClassName)&&Je.push(Pe.get(ke.extraEditorClassName)),J.extraEditorClassName&&Je.push(J.extraEditorClassName),Pe.get(ke.mouseStyle)==="default"?Je.push("mouse-default"):Pe.get(ke.mouseStyle)==="copy"&&Je.push("mouse-copy"),Pe.get(ke.showUnused)&&Je.push("showUnused"),Pe.get(ke.showDeprecated)&&Je.push("showDeprecated"),Je.join(" ")}}class V extends o{constructor(){super(ke.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:c.localize(308,null)})}compute(J,Pe,Ge){return Ge&&J.emptySelectionClipboard}}class j extends b{constructor(){const J={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(ke.find,"find",J,{"editor.find.cursorMoveOnType":{type:"boolean",default:J.cursorMoveOnType,description:c.localize(309,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:J.seedSearchStringFromSelection,enumDescriptions:[c.localize(310,null),c.localize(311,null),c.localize(312,null)],description:c.localize(313,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:J.autoFindInSelection,enumDescriptions:[c.localize(314,null),c.localize(315,null),c.localize(316,null)],description:c.localize(317,null)},"editor.find.globalFindClipboard":{type:"boolean",default:J.globalFindClipboard,description:c.localize(318,null),included:R.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:J.addExtraSpaceOnTop,description:c.localize(319,null)},"editor.find.loop":{type:"boolean",default:J.loop,description:c.localize(320,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Pe=J;return{cursorMoveOnType:i(Pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof J.seedSearchStringFromSelection=="boolean"?J.seedSearchStringFromSelection?"always":"never":f(Pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof J.autoFindInSelection=="boolean"?J.autoFindInSelection?"always":"never":f(Pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:i(Pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:i(Pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:i(Pe.loop,this.defaultValue.loop)}}}class U extends b{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(ke.fontLigatures,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:c.localize(321,null)},{type:"string",description:c.localize(322,null)}],description:c.localize(323,null),default:!1})}validate(J){return typeof J>"u"?this.defaultValue:typeof J=="string"?J==="false"||J.length===0?U.OFF:J==="true"?U.ON:J:J?U.ON:U.OFF}}e.EditorFontLigatures=U;class z extends b{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(ke.fontVariations,"fontVariations",z.OFF,{anyOf:[{type:"boolean",description:c.localize(324,null)},{type:"string",description:c.localize(325,null)}],description:c.localize(326,null),default:!1})}validate(J){return typeof J>"u"?this.defaultValue:typeof J=="string"?J==="false"?z.OFF:J==="true"?z.TRANSLATE:J:J?z.TRANSLATE:z.OFF}compute(J,Pe,Ge){return J.fontInfo.fontVariationSettings}}e.EditorFontVariations=z;class _ extends p{constructor(){super(ke.fontInfo)}compute(J,Pe,Ge){return J.fontInfo}}class W extends u{constructor(){super(ke.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(327,null)})}validate(J){const Pe=d.float(J,this.defaultValue);return Pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(Pe,6,100)}compute(J,Pe,Ge){return J.fontInfo.fontSize}}class B extends b{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(ke.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:B.d,maximum:B.e,errorMessage:c.localize(328,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:B.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(329,null)})}validate(J){return J==="normal"||J==="bold"?J:String(n.clampedInt(J,e.EDITOR_FONT_DEFAULTS.fontWeight,B.d,B.e))}}class Y extends b{constructor(){const J={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",multipleTests:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:"",alternativeTestsCommand:""},Pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:J.multiple,enumDescriptions:[c.localize(330,null),c.localize(331,null),c.localize(332,null)]},Ge=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(ke.gotoLocation,"gotoLocation",J,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(333,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(334,null),...Pe},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(335,null),...Pe},"editor.gotoLocation.multipleDeclarations":{description:c.localize(336,null),...Pe},"editor.gotoLocation.multipleImplementations":{description:c.localize(337,null),...Pe},"editor.gotoLocation.multipleReferences":{description:c.localize(338,null),...Pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:J.alternativeDefinitionCommand,enum:Ge,description:c.localize(339,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:J.alternativeTypeDefinitionCommand,enum:Ge,description:c.localize(340,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:J.alternativeDeclarationCommand,enum:Ge,description:c.localize(341,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:J.alternativeImplementationCommand,enum:Ge,description:c.localize(342,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:J.alternativeReferenceCommand,enum:Ge,description:c.localize(343,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Pe=J;return{multiple:f(Pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Pe.multipleDefinitions??f(Pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Pe.multipleTypeDefinitions??f(Pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Pe.multipleDeclarations??f(Pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Pe.multipleImplementations??f(Pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Pe.multipleReferences??f(Pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),multipleTests:Pe.multipleTests??f(Pe.multipleTests,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:l.string(Pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:l.string(Pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:l.string(Pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:l.string(Pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:l.string(Pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand),alternativeTestsCommand:l.string(Pe.alternativeTestsCommand,this.defaultValue.alternativeTestsCommand)}}}class x extends b{constructor(){const J={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(ke.hover,"hover",J,{"editor.hover.enabled":{type:"boolean",default:J.enabled,description:c.localize(344,null)},"editor.hover.delay":{type:"number",default:J.delay,minimum:0,maximum:1e4,description:c.localize(345,null)},"editor.hover.sticky":{type:"boolean",default:J.sticky,description:c.localize(346,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:J.hidingDelay,description:c.localize(347,null)},"editor.hover.above":{type:"boolean",default:J.above,description:c.localize(348,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Pe=J;return{enabled:i(Pe.enabled,this.defaultValue.enabled),delay:n.clampedInt(Pe.delay,this.defaultValue.delay,0,1e4),sticky:i(Pe.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt(Pe.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:i(Pe.above,this.defaultValue.above)}}}var oe;(function(ne){ne[ne.None=0]="None",ne[ne.Text=1]="Text",ne[ne.Blocks=2]="Blocks"})(oe||(e.RenderMinimap=oe={}));class ie extends p{constructor(){super(ke.layoutInfo)}compute(J,Pe,Ge){return ie.computeLayout(Pe,{memory:J.memory,outerWidth:J.outerWidth,outerHeight:J.outerHeight,isDominatedByLongLines:J.isDominatedByLongLines,lineHeight:J.fontInfo.lineHeight,viewLineCount:J.viewLineCount,lineNumbersDigitCount:J.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:J.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:J.fontInfo.maxDigitWidth,pixelRatio:J.pixelRatio,glyphMarginDecorationLaneCount:J.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(J){const Pe=J.height/J.lineHeight,Ge=Math.floor(J.paddingTop/J.lineHeight);let Je=Math.floor(J.paddingBottom/J.lineHeight);J.scrollBeyondLastLine&&(Je=Math.max(Je,Pe-1));const st=(Ge+J.viewLineCount+Je)/(J.pixelRatio*J.height),ht=Math.floor(J.viewLineCount/st);return{typicalViewportLineCount:Pe,extraLinesBeforeFirstLine:Ge,extraLinesBeyondLastLine:Je,desiredRatio:st,minimapLineCount:ht}}static c(J,Pe){const Ge=J.outerWidth,Je=J.outerHeight,st=J.pixelRatio;if(!J.minimap.enabled)return{renderMinimap:oe.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(st*Je),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Je};const ht=Pe.stableMinimapLayoutInput,ft=ht&&J.outerHeight===ht.outerHeight&&J.lineHeight===ht.lineHeight&&J.typicalHalfwidthCharacterWidth===ht.typicalHalfwidthCharacterWidth&&J.pixelRatio===ht.pixelRatio&&J.scrollBeyondLastLine===ht.scrollBeyondLastLine&&J.paddingTop===ht.paddingTop&&J.paddingBottom===ht.paddingBottom&&J.minimap.enabled===ht.minimap.enabled&&J.minimap.side===ht.minimap.side&&J.minimap.size===ht.minimap.size&&J.minimap.showSlider===ht.minimap.showSlider&&J.minimap.renderCharacters===ht.minimap.renderCharacters&&J.minimap.maxColumn===ht.minimap.maxColumn&&J.minimap.scale===ht.minimap.scale&&J.verticalScrollbarWidth===ht.verticalScrollbarWidth&&J.isViewportWrapping===ht.isViewportWrapping,St=J.lineHeight,At=J.typicalHalfwidthCharacterWidth,Qt=J.scrollBeyondLastLine,ei=J.minimap.renderCharacters;let tt=st>=2?Math.round(J.minimap.scale*2):J.minimap.scale;const Ot=J.minimap.maxColumn,zt=J.minimap.size,bt=J.minimap.side,Dt=J.verticalScrollbarWidth,ti=J.viewLineCount,ii=J.remainingWidth,Gt=J.isViewportWrapping,wt=ei?2:3;let Lt=Math.floor(st*Je);const ai=Lt/st;let Zt=!1,et=!1,ni=wt*tt,ci=tt/st,ui=1;if(zt==="fill"||zt==="fit"){const{typicalViewportLineCount:si,extraLinesBeforeFirstLine:Kt,extraLinesBeyondLastLine:Jt,desiredRatio:li,minimapLineCount:Mt}=ie.computeContainedMinimapLineCount({viewLineCount:ti,scrollBeyondLastLine:Qt,paddingTop:J.paddingTop,paddingBottom:J.paddingBottom,height:Je,lineHeight:St,pixelRatio:st});if(ti/Mt>1)Zt=!0,et=!0,tt=1,ni=1,ci=tt/st;else{let vt=!1,Xt=tt+1;if(zt==="fit"){const Et=Math.ceil((Kt+ti+Jt)*ni);Gt&&ft&&ii<=Pe.stableFitRemainingWidth?(vt=!0,Xt=Pe.stableFitMaxMinimapScale):vt=Et>Lt}if(zt==="fill"||vt){Zt=!0;const Et=tt;ni=Math.min(St*st,Math.max(1,Math.floor(1/li))),Gt&&ft&&ii<=Pe.stableFitRemainingWidth&&(Xt=Pe.stableFitMaxMinimapScale),tt=Math.min(Xt,Math.max(1,Math.floor(ni/wt))),tt>Et&&(ui=Math.min(2,tt/Et)),ci=tt/st/ui,Lt=Math.ceil(Math.max(si,Kt+ti+Jt)*ni),Gt?(Pe.stableMinimapLayoutInput=J,Pe.stableFitRemainingWidth=ii,Pe.stableFitMaxMinimapScale=tt):(Pe.stableMinimapLayoutInput=null,Pe.stableFitRemainingWidth=0)}}}const kt=Math.floor(Ot*ci),Ut=Math.min(kt,Math.max(0,Math.floor((ii-Dt-2)*ci/(At+ci)))+e.MINIMAP_GUTTER_WIDTH);let Nt=Math.floor(st*Ut);const Bt=Nt/st;Nt=Math.floor(Nt*ui);const oi=ei?oe.Text:oe.Blocks,ri=bt==="left"?0:Ge-Ut-Dt;return{renderMinimap:oi,minimapLeft:ri,minimapWidth:Ut,minimapHeightIsEditorHeight:Zt,minimapIsSampling:et,minimapScale:tt,minimapLineHeight:ni,minimapCanvasInnerWidth:Nt,minimapCanvasInnerHeight:Lt,minimapCanvasOuterWidth:Bt,minimapCanvasOuterHeight:ai}}static computeLayout(J,Pe){const Ge=Pe.outerWidth|0,Je=Pe.outerHeight|0,st=Pe.lineHeight|0,ht=Pe.lineNumbersDigitCount|0,ft=Pe.typicalHalfwidthCharacterWidth,St=Pe.maxDigitWidth,At=Pe.pixelRatio,Qt=Pe.viewLineCount,ei=J.get(ke.wordWrapOverride2),tt=ei==="inherit"?J.get(ke.wordWrapOverride1):ei,Ot=tt==="inherit"?J.get(ke.wordWrap):tt,zt=J.get(ke.wordWrapColumn),bt=Pe.isDominatedByLongLines,Dt=J.get(ke.glyphMargin),ti=J.get(ke.lineNumbers).renderType!==xe.Off,ii=J.get(ke.lineNumbersMinChars),Gt=J.get(ke.scrollBeyondLastLine),wt=J.get(ke.padding),Lt=J.get(ke.minimap),ai=J.get(ke.scrollbar),Zt=ai.verticalScrollbarSize,et=ai.verticalHasArrows,ni=ai.arrowSize,ci=ai.horizontalScrollbarSize,ui=J.get(ke.folding),kt=J.get(ke.showFoldingControls)!=="never";let Ut=J.get(ke.lineDecorationsWidth);ui&&kt&&(Ut+=16);let Nt=0;if(ti){const Yt=Math.max(ht,ii);Nt=Math.round(Yt*St)}let Bt=0;Dt&&(Bt=st*Pe.glyphMarginDecorationLaneCount);let oi=0,ri=oi+Bt,si=ri+Nt,Kt=si+Ut;const Jt=Ge-Bt-Nt-Ut;let li=!1,Mt=!1,Rt=-1;tt==="inherit"&&bt?(li=!0,Mt=!0):Ot==="on"||Ot==="bounded"?Mt=!0:Ot==="wordWrapColumn"&&(Rt=zt);const vt=ie.c({outerWidth:Ge,outerHeight:Je,lineHeight:st,typicalHalfwidthCharacterWidth:ft,pixelRatio:At,scrollBeyondLastLine:Gt,paddingTop:wt.top,paddingBottom:wt.bottom,minimap:Lt,verticalScrollbarWidth:Zt,viewLineCount:Qt,remainingWidth:Jt,isViewportWrapping:Mt},Pe.memory||new P);vt.renderMinimap!==oe.None&&vt.minimapLeft===0&&(oi+=vt.minimapWidth,ri+=vt.minimapWidth,si+=vt.minimapWidth,Kt+=vt.minimapWidth);const Xt=Jt-vt.minimapWidth,Et=Math.max(1,Math.floor((Xt-Zt-2)/ft)),hi=et?ni:0;return Mt&&(Rt=Math.max(1,Et),Ot==="bounded"&&(Rt=Math.min(Rt,zt))),{width:Ge,height:Je,glyphMarginLeft:oi,glyphMarginWidth:Bt,glyphMarginDecorationLaneCount:Pe.glyphMarginDecorationLaneCount,lineNumbersLeft:ri,lineNumbersWidth:Nt,decorationsLeft:si,decorationsWidth:Ut,contentLeft:Kt,contentWidth:Xt,minimap:vt,viewportColumn:Et,isWordWrapMinified:li,isViewportWrapping:Mt,wrappingColumn:Rt,verticalScrollbarWidth:Zt,horizontalScrollbarHeight:ci,overviewRuler:{top:hi,width:Zt,height:Je-2*hi,right:0}}}}e.EditorLayoutInfoComputer=ie;class me extends b{constructor(){super(ke.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[c.localize(349,null),c.localize(350,null)],type:"string",enum:["simple","advanced"],default:"simple",description:c.localize(351,null)}})}validate(J){return f(J,"simple",["simple","advanced"])}compute(J,Pe,Ge){return Pe.get(ke.accessibilitySupport)===I.AccessibilitySupport.Enabled?"advanced":Ge}}var ue;(function(ne){ne.Off="off",ne.OnCode="onCode",ne.On="on"})(ue||(e.ShowLightbulbIconMode=ue={}));class X extends b{constructor(){const J={enabled:ue.OnCode};super(ke.lightbulb,"lightbulb",J,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[ue.Off,ue.OnCode,ue.On],default:J.enabled,enumDescriptions:[c.localize(352,null),c.localize(353,null),c.localize(354,null)],description:c.localize(355,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:f(J.enabled,this.defaultValue.enabled,[ue.Off,ue.OnCode,ue.On])}}}class q extends b{constructor(){const J={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(ke.stickyScroll,"stickyScroll",J,{"editor.stickyScroll.enabled":{type:"boolean",default:J.enabled,description:c.localize(356,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:J.maxLineCount,minimum:1,maximum:20,description:c.localize(357,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:J.defaultModel,description:c.localize(358,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:J.scrollWithEditor,description:c.localize(359,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Pe=J;return{enabled:i(Pe.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt(Pe.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:f(Pe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:i(Pe.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class se extends b{constructor(){const J={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(ke.inlayHints,"inlayHints",J,{"editor.inlayHints.enabled":{type:"string",default:J.enabled,description:c.localize(360,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[c.localize(361,null),c.localize(362,null,R.$k?"Ctrl+Option":"Ctrl+Alt"),c.localize(363,null,R.$k?"Ctrl+Option":"Ctrl+Alt"),c.localize(364,null)]},"editor.inlayHints.fontSize":{type:"number",default:J.fontSize,markdownDescription:c.localize(365,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:J.fontFamily,markdownDescription:c.localize(366,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:J.padding,description:c.localize(367,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Pe=J;return typeof Pe.enabled=="boolean"&&(Pe.enabled=Pe.enabled?"on":"off"),{enabled:f(Pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt(Pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:l.string(Pe.fontFamily,this.defaultValue.fontFamily),padding:i(Pe.padding,this.defaultValue.padding)}}}class be extends b{constructor(){super(ke.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(J){return typeof J=="string"&&/^\d+(\.\d+)?ch$/.test(J)?-parseFloat(J.substring(0,J.length-2)):n.clampedInt(J,this.defaultValue,0,1e3)}compute(J,Pe,Ge){return Ge<0?n.clampedInt(-Ge*J.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ge}}class ae extends d{constructor(){super(ke.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,J=>d.clamp(J,0,150),{markdownDescription:c.localize(368,null)})}compute(J,Pe,Ge){return J.fontInfo.lineHeight}}class we extends b{constructor(){const J={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(ke.minimap,"minimap",J,{"editor.minimap.enabled":{type:"boolean",default:J.enabled,description:c.localize(369,null)},"editor.minimap.autohide":{type:"boolean",default:J.autohide,description:c.localize(370,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(371,null),c.localize(372,null),c.localize(373,null)],default:J.size,description:c.localize(374,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:J.side,description:c.localize(375,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:J.showSlider,description:c.localize(376,null)},"editor.minimap.scale":{type:"number",default:J.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(377,null)},"editor.minimap.renderCharacters":{type:"boolean",default:J.renderCharacters,description:c.localize(378,null)},"editor.minimap.maxColumn":{type:"number",default:J.maxColumn,description:c.localize(379,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:J.showRegionSectionHeaders,description:c.localize(380,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:J.showMarkSectionHeaders,description:c.localize(381,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:J.sectionHeaderFontSize,description:c.localize(382,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:J.sectionHeaderLetterSpacing,description:c.localize(383,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Pe=J;return{enabled:i(Pe.enabled,this.defaultValue.enabled),autohide:i(Pe.autohide,this.defaultValue.autohide),size:f(Pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:f(Pe.side,this.defaultValue.side,["right","left"]),showSlider:f(Pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:i(Pe.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt(Pe.scale,1,1,3),maxColumn:n.clampedInt(Pe.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:i(Pe.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:i(Pe.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:d.clamp(Pe.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:d.clamp(Pe.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function $e(ne){return ne==="ctrlCmd"?R.$k?"metaKey":"ctrlKey":"altKey"}class pe extends b{constructor(){super(ke.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(384,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(385,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Pe=J;return{top:n.clampedInt(Pe.top,0,0,1e3),bottom:n.clampedInt(Pe.bottom,0,0,1e3)}}}class Ae extends b{constructor(){const J={enabled:!0,cycle:!0};super(ke.parameterHints,"parameterHints",J,{"editor.parameterHints.enabled":{type:"boolean",default:J.enabled,description:c.localize(386,null)},"editor.parameterHints.cycle":{type:"boolean",default:J.cycle,description:c.localize(387,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Pe=J;return{enabled:i(Pe.enabled,this.defaultValue.enabled),cycle:i(Pe.cycle,this.defaultValue.cycle)}}}class je extends p{constructor(){super(ke.pixelRatio)}compute(J,Pe,Ge){return J.pixelRatio}}class He extends b{constructor(){super(ke.placeholder,"placeholder",void 0)}validate(J){return typeof J>"u"?this.defaultValue:typeof J=="string"?J:this.defaultValue}}class Ye extends b{constructor(){const J={other:"on",comments:"off",strings:"off"},Pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[c.localize(388,null),c.localize(389,null),c.localize(390,null)]}];super(ke.quickSuggestions,"quickSuggestions",J,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Pe,default:J.strings,description:c.localize(391,null)},comments:{anyOf:Pe,default:J.comments,description:c.localize(392,null)},other:{anyOf:Pe,default:J.other,description:c.localize(393,null)}},default:J,markdownDescription:c.localize(394,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=J}validate(J){if(typeof J=="boolean"){const At=J?"on":"off";return{comments:At,strings:At,other:At}}if(!J||typeof J!="object")return this.defaultValue;const{other:Pe,comments:Ge,strings:Je}=J,st=["on","inline","off"];let ht,ft,St;return typeof Pe=="boolean"?ht=Pe?"on":"off":ht=f(Pe,this.defaultValue.other,st),typeof Ge=="boolean"?ft=Ge?"on":"off":ft=f(Ge,this.defaultValue.comments,st),typeof Je=="boolean"?St=Je?"on":"off":St=f(Je,this.defaultValue.strings,st),{other:ht,comments:ft,strings:St}}}var xe;(function(ne){ne[ne.Off=0]="Off",ne[ne.On=1]="On",ne[ne.Relative=2]="Relative",ne[ne.Interval=3]="Interval",ne[ne.Custom=4]="Custom"})(xe||(e.RenderLineNumbersType=xe={}));class Fe extends b{constructor(){super(ke.lineNumbers,"lineNumbers",{renderType:xe.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(395,null),c.localize(396,null),c.localize(397,null),c.localize(398,null)],default:"on",description:c.localize(399,null)})}validate(J){let Pe=this.defaultValue.renderType,Ge=this.defaultValue.renderFn;return typeof J<"u"&&(typeof J=="function"?(Pe=xe.Custom,Ge=J):J==="interval"?Pe=xe.Interval:J==="relative"?Pe=xe.Relative:J==="on"?Pe=xe.On:Pe=xe.Off),{renderType:Pe,renderFn:Ge}}}function We(ne){const J=ne.get(ke.renderValidationDecorations);return J==="editable"?ne.get(ke.readOnly):J!=="on"}class Ne extends b{constructor(){const J=[],Pe={type:"number",description:c.localize(400,null)};super(ke.rulers,"rulers",J,{type:"array",items:{anyOf:[Pe,{type:["object"],properties:{column:Pe,color:{type:"string",description:c.localize(401,null),format:"color-hex"}}}]},default:J,description:c.localize(402,null)})}validate(J){if(Array.isArray(J)){const Pe=[];for(const Ge of J)if(typeof Ge=="number")Pe.push({column:n.clampedInt(Ge,0,0,1e4),color:null});else if(Ge&&typeof Ge=="object"){const Je=Ge;Pe.push({column:n.clampedInt(Je.column,0,0,1e4),color:Je.color})}return Pe.sort((Ge,Je)=>Ge.column-Je.column),Pe}return this.defaultValue}}class H extends b{constructor(){super(ke.readOnlyMessage,"readOnlyMessage",void 0)}validate(J){return!J||typeof J!="object"?this.defaultValue:J}}function G(ne,J){if(typeof ne!="string")return J;switch(ne){case"hidden":return A.ScrollbarVisibility.Hidden;case"visible":return A.ScrollbarVisibility.Visible;default:return A.ScrollbarVisibility.Auto}}class Z extends b{constructor(){const J={vertical:A.ScrollbarVisibility.Auto,horizontal:A.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(ke.scrollbar,"scrollbar",J,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(403,null),c.localize(404,null),c.localize(405,null)],default:"auto",description:c.localize(406,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(407,null),c.localize(408,null),c.localize(409,null)],default:"auto",description:c.localize(410,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:J.verticalScrollbarSize,description:c.localize(411,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:J.horizontalScrollbarSize,description:c.localize(412,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:J.scrollByPage,description:c.localize(413,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:J.ignoreHorizontalScrollbarInContentHeight,description:c.localize(414,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Pe=J,Ge=n.clampedInt(Pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Je=n.clampedInt(Pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt(Pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:G(Pe.vertical,this.defaultValue.vertical),horizontal:G(Pe.horizontal,this.defaultValue.horizontal),useShadows:i(Pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:i(Pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:i(Pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:i(Pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:i(Pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ge,horizontalSliderSize:n.clampedInt(Pe.horizontalSliderSize,Ge,0,1e3),verticalScrollbarSize:Je,verticalSliderSize:n.clampedInt(Pe.verticalSliderSize,Je,0,1e3),scrollByPage:i(Pe.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:i(Pe.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ee extends b{constructor(){const J={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(ke.unicodeHighlighting,"unicodeHighlight",J,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:J.nonBasicASCII,description:c.localize(415,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:J.invisibleCharacters,description:c.localize(416,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:J.ambiguousCharacters,description:c.localize(417,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:J.includeComments,description:c.localize(418,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:J.includeStrings,description:c.localize(419,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:J.allowedCharacters,description:c.localize(420,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:J.allowedLocales,description:c.localize(421,null)}})}applyUpdate(J,Pe){let Ge=!1;Pe.allowedCharacters&&J&&(h.$mo(J.allowedCharacters,Pe.allowedCharacters)||(J={...J,allowedCharacters:Pe.allowedCharacters},Ge=!0)),Pe.allowedLocales&&J&&(h.$mo(J.allowedLocales,Pe.allowedLocales)||(J={...J,allowedLocales:Pe.allowedLocales},Ge=!0));const Je=super.applyUpdate(J,Pe);return Ge?new a(Je.newValue,!0):Je}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Pe=J;return{nonBasicASCII:Ke(Pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:i(Pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:i(Pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ke(Pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ke(Pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(J.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(J.allowedLocales,this.defaultValue.allowedLocales)}}c(J,Pe){if(typeof J!="object"||!J)return Pe;const Ge={};for(const[Je,st]of Object.entries(J))st===!0&&(Ge[Je]=!0);return Ge}}class le extends b{constructor(){const J={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(ke.inlineSuggest,"inlineSuggest",J,{"editor.inlineSuggest.enabled":{type:"boolean",default:J.enabled,description:c.localize(422,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:J.showToolbar,enum:["always","onHover","never"],enumDescriptions:[c.localize(423,null),c.localize(424,null),c.localize(425,null)],description:c.localize(426,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:J.suppressSuggestions,description:c.localize(427,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:J.fontFamily,description:c.localize(428,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Pe=J;return{enabled:i(Pe.enabled,this.defaultValue.enabled),mode:f(Pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:f(Pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:i(Pe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:i(Pe.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:l.string(Pe.fontFamily,this.defaultValue.fontFamily)}}}class ye extends b{constructor(){const J={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1};super(ke.inlineEdit,"experimentalInlineEdit",J,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:J.enabled,description:c.localize(429,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:J.showToolbar,enum:["always","onHover","never"],enumDescriptions:[c.localize(430,null),c.localize(431,null),c.localize(432,null)],description:c.localize(433,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:J.fontFamily,description:c.localize(434,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Pe=J;return{enabled:i(Pe.enabled,this.defaultValue.enabled),showToolbar:f(Pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:l.string(Pe.fontFamily,this.defaultValue.fontFamily),keepOnBlur:i(Pe.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Te extends b{constructor(){const J={enabled:C.$rt.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:C.$rt.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(ke.bracketPairColorization,"bracketPairColorization",J,{"editor.bracketPairColorization.enabled":{type:"boolean",default:J.enabled,markdownDescription:c.localize(435,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:J.independentColorPoolPerBracketType,description:c.localize(436,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Pe=J;return{enabled:i(Pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:i(Pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Ve extends b{constructor(){const J={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(ke.guides,"guides",J,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(437,null),c.localize(438,null),c.localize(439,null)],default:J.bracketPairs,description:c.localize(440,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(441,null),c.localize(442,null),c.localize(443,null)],default:J.bracketPairsHorizontal,description:c.localize(444,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:J.highlightActiveBracketPair,description:c.localize(445,null)},"editor.guides.indentation":{type:"boolean",default:J.indentation,description:c.localize(446,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[c.localize(447,null),c.localize(448,null),c.localize(449,null)],default:J.highlightActiveIndentation,description:c.localize(450,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Pe=J;return{bracketPairs:Ke(Pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ke(Pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:i(Pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:i(Pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ke(Pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ke(ne,J,Pe){const Ge=Pe.indexOf(ne);return Ge===-1?J:Pe[Ge]}class rt extends b{constructor(){const J={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(ke.suggest,"suggest",J,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(451,null),c.localize(452,null)],default:J.insertMode,description:c.localize(453,null)},"editor.suggest.filterGraceful":{type:"boolean",default:J.filterGraceful,description:c.localize(454,null)},"editor.suggest.localityBonus":{type:"boolean",default:J.localityBonus,description:c.localize(455,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:J.shareSuggestSelections,markdownDescription:c.localize(456,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[c.localize(457,null),c.localize(458,null),c.localize(459,null),c.localize(460,null)],default:J.selectionMode,markdownDescription:c.localize(461,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:J.snippetsPreventQuickSuggestions,description:c.localize(462,null)},"editor.suggest.showIcons":{type:"boolean",default:J.showIcons,description:c.localize(463,null)},"editor.suggest.showStatusBar":{type:"boolean",default:J.showStatusBar,description:c.localize(464,null)},"editor.suggest.preview":{type:"boolean",default:J.preview,description:c.localize(465,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:J.showInlineDetails,description:c.localize(466,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(467,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(468,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(469,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(470,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(471,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(472,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:c.localize(473,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(474,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(475,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(476,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(477,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(478,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(479,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(480,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(481,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(482,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(483,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(484,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(485,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(486,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(487,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(488,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(489,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(490,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(491,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(492,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(493,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(494,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(495,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(496,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(497,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(498,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Pe=J;return{insertMode:f(Pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:i(Pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:i(Pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:i(Pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:i(Pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:f(Pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:i(Pe.showIcons,this.defaultValue.showIcons),showStatusBar:i(Pe.showStatusBar,this.defaultValue.showStatusBar),preview:i(Pe.preview,this.defaultValue.preview),previewMode:f(Pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:i(Pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:i(Pe.showMethods,this.defaultValue.showMethods),showFunctions:i(Pe.showFunctions,this.defaultValue.showFunctions),showConstructors:i(Pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:i(Pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:i(Pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:i(Pe.showFields,this.defaultValue.showFields),showVariables:i(Pe.showVariables,this.defaultValue.showVariables),showClasses:i(Pe.showClasses,this.defaultValue.showClasses),showStructs:i(Pe.showStructs,this.defaultValue.showStructs),showInterfaces:i(Pe.showInterfaces,this.defaultValue.showInterfaces),showModules:i(Pe.showModules,this.defaultValue.showModules),showProperties:i(Pe.showProperties,this.defaultValue.showProperties),showEvents:i(Pe.showEvents,this.defaultValue.showEvents),showOperators:i(Pe.showOperators,this.defaultValue.showOperators),showUnits:i(Pe.showUnits,this.defaultValue.showUnits),showValues:i(Pe.showValues,this.defaultValue.showValues),showConstants:i(Pe.showConstants,this.defaultValue.showConstants),showEnums:i(Pe.showEnums,this.defaultValue.showEnums),showEnumMembers:i(Pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:i(Pe.showKeywords,this.defaultValue.showKeywords),showWords:i(Pe.showWords,this.defaultValue.showWords),showColors:i(Pe.showColors,this.defaultValue.showColors),showFiles:i(Pe.showFiles,this.defaultValue.showFiles),showReferences:i(Pe.showReferences,this.defaultValue.showReferences),showFolders:i(Pe.showFolders,this.defaultValue.showFolders),showTypeParameters:i(Pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:i(Pe.showSnippets,this.defaultValue.showSnippets),showUsers:i(Pe.showUsers,this.defaultValue.showUsers),showIssues:i(Pe.showIssues,this.defaultValue.showIssues)}}}class ot extends b{constructor(){super(ke.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(499,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:c.localize(500,null),default:!0,type:"boolean"}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:i(J.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:i(J.selectSubwords,this.defaultValue.selectSubwords)}}}class ut extends b{constructor(){const J=[];super(ke.wordSegmenterLocales,"wordSegmenterLocales",J,{anyOf:[{description:c.localize(501,null),type:"string"},{description:c.localize(502,null),type:"array",items:{type:"string"}}]})}validate(J){if(typeof J=="string"&&(J=[J]),Array.isArray(J)){const Pe=[];for(const Ge of J)if(typeof Ge=="string")try{Intl.Segmenter.supportedLocalesOf(Ge).length>0&&Pe.push(Ge)}catch{}return Pe}return this.defaultValue}}var at;(function(ne){ne[ne.None=0]="None",ne[ne.Same=1]="Same",ne[ne.Indent=2]="Indent",ne[ne.DeepIndent=3]="DeepIndent"})(at||(e.WrappingIndent=at={}));class lt extends b{constructor(){super(ke.wrappingIndent,"wrappingIndent",at.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[c.localize(503,null),c.localize(504,null),c.localize(505,null),c.localize(506,null)],description:c.localize(507,null),default:"same"}})}validate(J){switch(J){case"none":return at.None;case"same":return at.Same;case"indent":return at.Indent;case"deepIndent":return at.DeepIndent}return at.Same}compute(J,Pe,Ge){return Pe.get(ke.accessibilitySupport)===I.AccessibilitySupport.Enabled?at.None:Ge}}class $t extends p{constructor(){super(ke.wrappingInfo)}compute(J,Pe,Ge){const Je=Pe.get(ke.layoutInfo);return{isDominatedByLongLines:J.isDominatedByLongLines,isWordWrapMinified:Je.isWordWrapMinified,isViewportWrapping:Je.isViewportWrapping,wrappingColumn:Je.wrappingColumn}}}class it extends b{constructor(){const J={enabled:!0,showDropSelector:"afterDrop"};super(ke.dropIntoEditor,"dropIntoEditor",J,{"editor.dropIntoEditor.enabled":{type:"boolean",default:J.enabled,markdownDescription:c.localize(508,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:c.localize(509,null),enum:["afterDrop","never"],enumDescriptions:[c.localize(510,null),c.localize(511,null)],default:"afterDrop"}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Pe=J;return{enabled:i(Pe.enabled,this.defaultValue.enabled),showDropSelector:f(Pe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Ie extends b{constructor(){const J={enabled:!0,showPasteSelector:"afterPaste"};super(ke.pasteAs,"pasteAs",J,{"editor.pasteAs.enabled":{type:"boolean",default:J.enabled,markdownDescription:c.localize(512,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:c.localize(513,null),enum:["afterPaste","never"],enumDescriptions:[c.localize(514,null),c.localize(515,null)],default:"afterPaste"}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Pe=J;return{enabled:i(Pe.enabled,this.defaultValue.enabled),showPasteSelector:f(Pe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const re="Consolas, 'Courier New', monospace",ce="Menlo, Monaco, 'Courier New', monospace",Se="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:R.$k?ce:R.$l?Se:re,fontWeight:"normal",fontSize:R.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function de(ne){return e.editorOptionsRegistry[ne.id]=ne,ne}var ke;(function(ne){ne[ne.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ne[ne.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ne[ne.accessibilitySupport=2]="accessibilitySupport",ne[ne.accessibilityPageSize=3]="accessibilityPageSize",ne[ne.ariaLabel=4]="ariaLabel",ne[ne.ariaRequired=5]="ariaRequired",ne[ne.autoClosingBrackets=6]="autoClosingBrackets",ne[ne.autoClosingComments=7]="autoClosingComments",ne[ne.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ne[ne.autoClosingDelete=9]="autoClosingDelete",ne[ne.autoClosingOvertype=10]="autoClosingOvertype",ne[ne.autoClosingQuotes=11]="autoClosingQuotes",ne[ne.autoIndent=12]="autoIndent",ne[ne.automaticLayout=13]="automaticLayout",ne[ne.autoSurround=14]="autoSurround",ne[ne.bracketPairColorization=15]="bracketPairColorization",ne[ne.guides=16]="guides",ne[ne.codeLens=17]="codeLens",ne[ne.codeLensFontFamily=18]="codeLensFontFamily",ne[ne.codeLensFontSize=19]="codeLensFontSize",ne[ne.colorDecorators=20]="colorDecorators",ne[ne.colorDecoratorsLimit=21]="colorDecoratorsLimit",ne[ne.columnSelection=22]="columnSelection",ne[ne.comments=23]="comments",ne[ne.contextmenu=24]="contextmenu",ne[ne.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ne[ne.cursorBlinking=26]="cursorBlinking",ne[ne.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ne[ne.cursorStyle=28]="cursorStyle",ne[ne.cursorSurroundingLines=29]="cursorSurroundingLines",ne[ne.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ne[ne.cursorWidth=31]="cursorWidth",ne[ne.disableLayerHinting=32]="disableLayerHinting",ne[ne.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ne[ne.domReadOnly=34]="domReadOnly",ne[ne.dragAndDrop=35]="dragAndDrop",ne[ne.dropIntoEditor=36]="dropIntoEditor",ne[ne.emptySelectionClipboard=37]="emptySelectionClipboard",ne[ne.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ne[ne.extraEditorClassName=39]="extraEditorClassName",ne[ne.fastScrollSensitivity=40]="fastScrollSensitivity",ne[ne.find=41]="find",ne[ne.fixedOverflowWidgets=42]="fixedOverflowWidgets",ne[ne.folding=43]="folding",ne[ne.foldingStrategy=44]="foldingStrategy",ne[ne.foldingHighlight=45]="foldingHighlight",ne[ne.foldingImportsByDefault=46]="foldingImportsByDefault",ne[ne.foldingMaximumRegions=47]="foldingMaximumRegions",ne[ne.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ne[ne.fontFamily=49]="fontFamily",ne[ne.fontInfo=50]="fontInfo",ne[ne.fontLigatures=51]="fontLigatures",ne[ne.fontSize=52]="fontSize",ne[ne.fontWeight=53]="fontWeight",ne[ne.fontVariations=54]="fontVariations",ne[ne.formatOnPaste=55]="formatOnPaste",ne[ne.formatOnType=56]="formatOnType",ne[ne.glyphMargin=57]="glyphMargin",ne[ne.gotoLocation=58]="gotoLocation",ne[ne.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ne[ne.hover=60]="hover",ne[ne.inDiffEditor=61]="inDiffEditor",ne[ne.inlineSuggest=62]="inlineSuggest",ne[ne.inlineEdit=63]="inlineEdit",ne[ne.letterSpacing=64]="letterSpacing",ne[ne.lightbulb=65]="lightbulb",ne[ne.lineDecorationsWidth=66]="lineDecorationsWidth",ne[ne.lineHeight=67]="lineHeight",ne[ne.lineNumbers=68]="lineNumbers",ne[ne.lineNumbersMinChars=69]="lineNumbersMinChars",ne[ne.linkedEditing=70]="linkedEditing",ne[ne.links=71]="links",ne[ne.matchBrackets=72]="matchBrackets",ne[ne.minimap=73]="minimap",ne[ne.mouseStyle=74]="mouseStyle",ne[ne.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ne[ne.mouseWheelZoom=76]="mouseWheelZoom",ne[ne.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ne[ne.multiCursorModifier=78]="multiCursorModifier",ne[ne.multiCursorPaste=79]="multiCursorPaste",ne[ne.multiCursorLimit=80]="multiCursorLimit",ne[ne.occurrencesHighlight=81]="occurrencesHighlight",ne[ne.overviewRulerBorder=82]="overviewRulerBorder",ne[ne.overviewRulerLanes=83]="overviewRulerLanes",ne[ne.padding=84]="padding",ne[ne.pasteAs=85]="pasteAs",ne[ne.parameterHints=86]="parameterHints",ne[ne.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ne[ne.placeholder=88]="placeholder",ne[ne.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",ne[ne.quickSuggestions=90]="quickSuggestions",ne[ne.quickSuggestionsDelay=91]="quickSuggestionsDelay",ne[ne.readOnly=92]="readOnly",ne[ne.readOnlyMessage=93]="readOnlyMessage",ne[ne.renameOnType=94]="renameOnType",ne[ne.renderControlCharacters=95]="renderControlCharacters",ne[ne.renderFinalNewline=96]="renderFinalNewline",ne[ne.renderLineHighlight=97]="renderLineHighlight",ne[ne.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",ne[ne.renderValidationDecorations=99]="renderValidationDecorations",ne[ne.renderWhitespace=100]="renderWhitespace",ne[ne.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",ne[ne.roundedSelection=102]="roundedSelection",ne[ne.rulers=103]="rulers",ne[ne.scrollbar=104]="scrollbar",ne[ne.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",ne[ne.scrollBeyondLastLine=106]="scrollBeyondLastLine",ne[ne.scrollPredominantAxis=107]="scrollPredominantAxis",ne[ne.selectionClipboard=108]="selectionClipboard",ne[ne.selectionHighlight=109]="selectionHighlight",ne[ne.selectOnLineNumbers=110]="selectOnLineNumbers",ne[ne.showFoldingControls=111]="showFoldingControls",ne[ne.showUnused=112]="showUnused",ne[ne.snippetSuggestions=113]="snippetSuggestions",ne[ne.smartSelect=114]="smartSelect",ne[ne.smoothScrolling=115]="smoothScrolling",ne[ne.stickyScroll=116]="stickyScroll",ne[ne.stickyTabStops=117]="stickyTabStops",ne[ne.stopRenderingLineAfter=118]="stopRenderingLineAfter",ne[ne.suggest=119]="suggest",ne[ne.suggestFontSize=120]="suggestFontSize",ne[ne.suggestLineHeight=121]="suggestLineHeight",ne[ne.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",ne[ne.suggestSelection=123]="suggestSelection",ne[ne.tabCompletion=124]="tabCompletion",ne[ne.tabIndex=125]="tabIndex",ne[ne.unicodeHighlighting=126]="unicodeHighlighting",ne[ne.unusualLineTerminators=127]="unusualLineTerminators",ne[ne.useShadowDOM=128]="useShadowDOM",ne[ne.useTabStops=129]="useTabStops",ne[ne.wordBreak=130]="wordBreak",ne[ne.wordSegmenterLocales=131]="wordSegmenterLocales",ne[ne.wordSeparators=132]="wordSeparators",ne[ne.wordWrap=133]="wordWrap",ne[ne.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",ne[ne.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",ne[ne.wordWrapColumn=136]="wordWrapColumn",ne[ne.wordWrapOverride1=137]="wordWrapOverride1",ne[ne.wordWrapOverride2=138]="wordWrapOverride2",ne[ne.wrappingIndent=139]="wrappingIndent",ne[ne.wrappingStrategy=140]="wrappingStrategy",ne[ne.showDeprecated=141]="showDeprecated",ne[ne.inlayHints=142]="inlayHints",ne[ne.editorClassName=143]="editorClassName",ne[ne.pixelRatio=144]="pixelRatio",ne[ne.tabFocusMode=145]="tabFocusMode",ne[ne.layoutInfo=146]="layoutInfo",ne[ne.wrappingInfo=147]="wrappingInfo",ne[ne.defaultColorDecorators=148]="defaultColorDecorators",ne[ne.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",ne[ne.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(ke||(e.EditorOption=ke={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:de(new o(ke.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(516,null)})),acceptSuggestionOnEnter:de(new y(ke.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(517,null),""],markdownDescription:c.localize(518,null)})),accessibilitySupport:de(new D),accessibilityPageSize:de(new n(ke.accessibilityPageSize,"accessibilityPageSize",10,1,O.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(519,null),tags:["accessibility"]})),ariaLabel:de(new l(ke.ariaLabel,"ariaLabel",c.localize(520,null))),ariaRequired:de(new o(ke.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:de(new o(ke.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:c.localize(521,null),tags:["accessibility"]})),autoClosingBrackets:de(new y(ke.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(522,null),c.localize(523,null),""],description:c.localize(524,null)})),autoClosingComments:de(new y(ke.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(525,null),c.localize(526,null),""],description:c.localize(527,null)})),autoClosingDelete:de(new y(ke.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(528,null),""],description:c.localize(529,null)})),autoClosingOvertype:de(new y(ke.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(530,null),""],description:c.localize(531,null)})),autoClosingQuotes:de(new y(ke.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(532,null),c.localize(533,null),""],description:c.localize(534,null)})),autoIndent:de(new k(ke.autoIndent,"autoIndent",E.Full,"full",["none","keep","brackets","advanced","full"],S,{enumDescriptions:[c.localize(535,null),c.localize(536,null),c.localize(537,null),c.localize(538,null),c.localize(539,null)],description:c.localize(540,null)})),automaticLayout:de(new o(ke.automaticLayout,"automaticLayout",!1)),autoSurround:de(new y(ke.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(541,null),c.localize(542,null),c.localize(543,null),""],description:c.localize(544,null)})),bracketPairColorization:de(new Te),bracketPairGuides:de(new Ve),stickyTabStops:de(new o(ke.stickyTabStops,"stickyTabStops",!1,{description:c.localize(545,null)})),codeLens:de(new o(ke.codeLens,"codeLens",!0,{description:c.localize(546,null)})),codeLensFontFamily:de(new l(ke.codeLensFontFamily,"codeLensFontFamily","",{description:c.localize(547,null)})),codeLensFontSize:de(new n(ke.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(548,null)})),colorDecorators:de(new o(ke.colorDecorators,"colorDecorators",!0,{description:c.localize(549,null)})),colorDecoratorActivatedOn:de(new y(ke.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[c.localize(550,null),c.localize(551,null),c.localize(552,null)],description:c.localize(553,null)})),colorDecoratorsLimit:de(new n(ke.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:c.localize(554,null)})),columnSelection:de(new o(ke.columnSelection,"columnSelection",!1,{description:c.localize(555,null)})),comments:de(new T),contextmenu:de(new o(ke.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:de(new o(ke.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:c.localize(556,null)})),cursorBlinking:de(new k(ke.cursorBlinking,"cursorBlinking",v.Blink,"blink",["blink","smooth","phase","expand","solid"],w,{description:c.localize(557,null)})),cursorSmoothCaretAnimation:de(new y(ke.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[c.localize(558,null),c.localize(559,null),c.localize(560,null)],description:c.localize(561,null)})),cursorStyle:de(new k(ke.cursorStyle,"cursorStyle",M.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],N,{description:c.localize(562,null)})),cursorSurroundingLines:de(new n(ke.cursorSurroundingLines,"cursorSurroundingLines",0,0,O.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(563,null)})),cursorSurroundingLinesStyle:de(new y(ke.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(564,null),c.localize(565,null)],markdownDescription:c.localize(566,null)})),cursorWidth:de(new n(ke.cursorWidth,"cursorWidth",0,0,O.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:c.localize(567,null)})),disableLayerHinting:de(new o(ke.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:de(new o(ke.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:de(new o(ke.domReadOnly,"domReadOnly",!1)),dragAndDrop:de(new o(ke.dragAndDrop,"dragAndDrop",!0,{description:c.localize(568,null)})),emptySelectionClipboard:de(new V),dropIntoEditor:de(new it),stickyScroll:de(new q),experimentalWhitespaceRendering:de(new y(ke.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[c.localize(569,null),c.localize(570,null),c.localize(571,null)],description:c.localize(572,null)})),extraEditorClassName:de(new l(ke.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:de(new d(ke.fastScrollSensitivity,"fastScrollSensitivity",5,ne=>ne<=0?5:ne,{markdownDescription:c.localize(573,null)})),find:de(new j),fixedOverflowWidgets:de(new o(ke.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:de(new o(ke.folding,"folding",!0,{description:c.localize(574,null)})),foldingStrategy:de(new y(ke.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(575,null),c.localize(576,null)],description:c.localize(577,null)})),foldingHighlight:de(new o(ke.foldingHighlight,"foldingHighlight",!0,{description:c.localize(578,null)})),foldingImportsByDefault:de(new o(ke.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:c.localize(579,null)})),foldingMaximumRegions:de(new n(ke.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:c.localize(580,null)})),unfoldOnClickAfterEndOfLine:de(new o(ke.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(581,null)})),fontFamily:de(new l(ke.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(582,null)})),fontInfo:de(new _),fontLigatures2:de(new U),fontSize:de(new W),fontWeight:de(new B),fontVariations:de(new z),formatOnPaste:de(new o(ke.formatOnPaste,"formatOnPaste",!1,{description:c.localize(583,null)})),formatOnType:de(new o(ke.formatOnType,"formatOnType",!1,{description:c.localize(584,null)})),glyphMargin:de(new o(ke.glyphMargin,"glyphMargin",!0,{description:c.localize(585,null)})),gotoLocation:de(new Y),hideCursorInOverviewRuler:de(new o(ke.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:c.localize(586,null)})),hover:de(new x),inDiffEditor:de(new o(ke.inDiffEditor,"inDiffEditor",!1)),letterSpacing:de(new d(ke.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ne=>d.clamp(ne,-5,20),{description:c.localize(587,null)})),lightbulb:de(new X),lineDecorationsWidth:de(new be),lineHeight:de(new ae),lineNumbers:de(new Fe),lineNumbersMinChars:de(new n(ke.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:de(new o(ke.linkedEditing,"linkedEditing",!1,{description:c.localize(588,null)})),links:de(new o(ke.links,"links",!0,{description:c.localize(589,null)})),matchBrackets:de(new y(ke.matchBrackets,"matchBrackets","always",["always","near","never"],{description:c.localize(590,null)})),minimap:de(new we),mouseStyle:de(new y(ke.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:de(new d(ke.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,ne=>ne===0?1:ne,{markdownDescription:c.localize(591,null)})),mouseWheelZoom:de(new o(ke.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:R.$k?c.localize(592,null):c.localize(593,null)})),multiCursorMergeOverlapping:de(new o(ke.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:c.localize(594,null)})),multiCursorModifier:de(new k(ke.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],$e,{markdownEnumDescriptions:[c.localize(595,null),c.localize(596,null)],markdownDescription:c.localize(597,null)})),multiCursorPaste:de(new y(ke.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(598,null),c.localize(599,null)],markdownDescription:c.localize(600,null)})),multiCursorLimit:de(new n(ke.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:c.localize(601,null)})),occurrencesHighlight:de(new y(ke.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[c.localize(602,null),c.localize(603,null),c.localize(604,null)],markdownDescription:c.localize(605,null)})),overviewRulerBorder:de(new o(ke.overviewRulerBorder,"overviewRulerBorder",!0,{description:c.localize(606,null)})),overviewRulerLanes:de(new n(ke.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:de(new pe),pasteAs:de(new Ie),parameterHints:de(new Ae),peekWidgetDefaultFocus:de(new y(ke.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(607,null),c.localize(608,null)],description:c.localize(609,null)})),placeholder:de(new He),definitionLinkOpensInPeek:de(new o(ke.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:c.localize(610,null)})),quickSuggestions:de(new Ye),quickSuggestionsDelay:de(new n(ke.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,O.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(611,null)})),readOnly:de(new o(ke.readOnly,"readOnly",!1)),readOnlyMessage:de(new H),renameOnType:de(new o(ke.renameOnType,"renameOnType",!1,{description:c.localize(612,null),markdownDeprecationMessage:c.localize(613,null)})),renderControlCharacters:de(new o(ke.renderControlCharacters,"renderControlCharacters",!0,{description:c.localize(614,null),restricted:!0})),renderFinalNewline:de(new y(ke.renderFinalNewline,"renderFinalNewline",R.$l?"dimmed":"on",["off","on","dimmed"],{description:c.localize(615,null)})),renderLineHighlight:de(new y(ke.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(616,null)],description:c.localize(617,null)})),renderLineHighlightOnlyWhenFocus:de(new o(ke.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(618,null)})),renderValidationDecorations:de(new y(ke.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:de(new y(ke.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(619,null),c.localize(620,null),c.localize(621,null),""],description:c.localize(622,null)})),revealHorizontalRightPadding:de(new n(ke.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:de(new o(ke.roundedSelection,"roundedSelection",!0,{description:c.localize(623,null)})),rulers:de(new Ne),scrollbar:de(new Z),scrollBeyondLastColumn:de(new n(ke.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,O.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(624,null)})),scrollBeyondLastLine:de(new o(ke.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:c.localize(625,null)})),scrollPredominantAxis:de(new o(ke.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:c.localize(626,null)})),selectionClipboard:de(new o(ke.selectionClipboard,"selectionClipboard",!0,{description:c.localize(627,null),included:R.$l})),selectionHighlight:de(new o(ke.selectionHighlight,"selectionHighlight",!0,{description:c.localize(628,null)})),selectOnLineNumbers:de(new o(ke.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:de(new y(ke.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[c.localize(629,null),c.localize(630,null),c.localize(631,null)],description:c.localize(632,null)})),showUnused:de(new o(ke.showUnused,"showUnused",!0,{description:c.localize(633,null)})),showDeprecated:de(new o(ke.showDeprecated,"showDeprecated",!0,{description:c.localize(634,null)})),inlayHints:de(new se),snippetSuggestions:de(new y(ke.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(635,null),c.localize(636,null),c.localize(637,null),c.localize(638,null)],description:c.localize(639,null)})),smartSelect:de(new ot),smoothScrolling:de(new o(ke.smoothScrolling,"smoothScrolling",!1,{description:c.localize(640,null)})),stopRenderingLineAfter:de(new n(ke.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,O.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:de(new rt),inlineSuggest:de(new le),inlineEdit:de(new ye),inlineCompletionsAccessibilityVerbose:de(new o(ke.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:c.localize(641,null)})),suggestFontSize:de(new n(ke.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(642,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:de(new n(ke.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(643,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:de(new o(ke.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:c.localize(644,null)})),suggestSelection:de(new y(ke.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(645,null),c.localize(646,null),c.localize(647,null)],description:c.localize(648,null)})),tabCompletion:de(new y(ke.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(649,null),c.localize(650,null),c.localize(651,null)],description:c.localize(652,null)})),tabIndex:de(new n(ke.tabIndex,"tabIndex",0,-1,O.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:de(new ee),unusualLineTerminators:de(new y(ke.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(653,null),c.localize(654,null),c.localize(655,null)],description:c.localize(656,null)})),useShadowDOM:de(new o(ke.useShadowDOM,"useShadowDOM",!0)),useTabStops:de(new o(ke.useTabStops,"useTabStops",!0,{description:c.localize(657,null)})),wordBreak:de(new y(ke.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[c.localize(658,null),c.localize(659,null)],description:c.localize(660,null)})),wordSegmenterLocales:de(new ut),wordSeparators:de(new l(ke.wordSeparators,"wordSeparators",m.$st,{description:c.localize(661,null)})),wordWrap:de(new y(ke.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(662,null),c.localize(663,null),c.localize(664,null),c.localize(665,null)],description:c.localize(666,null)})),wordWrapBreakAfterCharacters:de(new l(ke.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:de(new l(ke.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:de(new n(ke.wordWrapColumn,"wordWrapColumn",80,1,O.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:c.localize(667,null)})),wordWrapOverride1:de(new y(ke.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:de(new y(ke.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:de(new F),defaultColorDecorators:de(new o(ke.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:c.localize(668,null)})),pixelRatio:de(new je),tabFocusMode:de(new o(ke.tabFocusMode,"tabFocusMode",!1,{markdownDescription:c.localize(669,null)})),layoutInfo:de(new ie),wrappingInfo:de(new $t),wrappingIndent:de(new lt),wrappingStrategy:de(new me)}});var Ht=this&&this.__importDefault||function(ge){return ge&&ge.__esModule?ge:{default:ge}};define(Re[218],Ce([1,0,22,44,8,5,107,10,24]),function(ge,e,s,h,R,A,O,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$gx=e.$fx=e.$ex=void 0,e.$hx=P,e.$ix=b,h=Ht(h),e.$ex=(0,A.$Ii)("dialogService");var c;(function(a){a[a.Confirmation=1]="Confirmation",a[a.Prompt=2]="Prompt",a[a.Input=3]="Input"})(c||(c={}));class I{a($){return this.d($,c.Confirmation)}b($){return this.d($,c.Prompt)}c($){return this.d($,c.Input)}d($,p){const u=[];switch(p){case c.Confirmation:{const i=$;i.primaryButton?u.push(i.primaryButton):u.push((0,R.localize)(1698,null)),i.cancelButton?u.push(i.cancelButton):u.push((0,R.localize)(1699,null));break}case c.Prompt:{const i=$;Array.isArray(i.buttons)&&i.buttons.length>0&&u.push(...i.buttons.map(o=>o.label)),i.cancelButton&&(i.cancelButton===!0?u.push((0,R.localize)(1700,null)):typeof i.cancelButton=="string"?u.push(i.cancelButton):i.cancelButton.label?u.push(i.cancelButton.label):u.push((0,R.localize)(1701,null))),u.length===0&&u.push((0,R.localize)(1702,null));break}case c.Input:{const i=$;i.primaryButton?u.push(i.primaryButton):u.push((0,R.localize)(1703,null)),i.cancelButton?u.push(i.cancelButton):u.push((0,R.localize)(1704,null));break}}return u}e($){if(typeof $=="string")return $;if(typeof $=="number")return $===h.default.Info?"info":$===h.default.Error?"error":$===h.default.Warning?"warning":"none"}f($,p,u){const i=[...$.buttons??[]];$.cancelButton&&typeof $.cancelButton!="string"&&typeof $.cancelButton!="boolean"&&i.push($.cancelButton);let o=i[p]?.run({checkboxChecked:u});return o instanceof Promise||(o=Promise.resolve(o)),{result:o,checkboxChecked:u}}}e.$fx=I,e.$gx=(0,A.$Ii)("fileDialogService");var E;(function(a){a[a.SAVE=0]="SAVE",a[a.DONT_SAVE=1]="DONT_SAVE",a[a.CANCEL=2]="CANCEL"})(E||(e.ConfirmResult=E={}));const g=10;function P(a){const $=[];return $.push(...a.slice(0,g).map(p=>typeof p=="string"?p:(0,s.$gh)(p))),a.length>g&&(a.length-g===1?$.push((0,R.localize)(1705,null)):$.push((0,R.localize)(1706,null,a.length-g))),$.push(""),$.join(`
`)}function b(a,$){const p=(0,m.$io)(a);let u=(p.buttons??[]).map(n=>(0,O.$bx)(n)),i=(a.buttons||[]).map((n,r)=>r),o=0,t=p.cancelId??u.length-1;if(u.length>1){const n=typeof t=="number"?u[t]:void 0;if(C.$l||C.$k){if(typeof n=="string"&&u.length>1&&t!==1){u.splice(t,1),u.splice(1,0,n);const r=i[t];i.splice(t,1),i.splice(1,0,r),t=1}C.$l&&u.length>1&&(u=u.reverse(),i=i.reverse(),o=u.length-1,typeof n=="string"&&(t=o-1))}else if(C.$j&&typeof n=="string"&&u.length>1&&t!==u.length-1){u.splice(t,1),u.push(n);const r=i[t];i.splice(t,1),i.push(r),t=u.length-1}}return p.buttons=u,p.defaultId=o,p.cancelId=t,p.noLink=!0,p.title=p.title||$.nameLong,{options:p,buttonIndeces:i}}}),define(Re[146],Ce([1,0,5]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=void 0,e.$Pi=(0,s.$Ii)("environmentService"),e.$Qi=(0,s.$Ji)(e.$Pi)}),define(Re[219],Ce([1,0,5]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K$b=e.$J$b=void 0,e.$J$b=(0,s.$Ii)("externalTerminal"),e.$K$b="Terminal.app"}),define(Re[220],Ce([1,0,56,60,14,16,10,104,33,109,8,219]),function(ge,e,s,h,R,A,O,C,m,c,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ghc=e.$Fhc=e.$Ehc=void 0,s=Ue(s),A=Ue(A),O=Ue(O),m=Ue(m),c=Ue(c),I=Ue(I);const g=I.localize(1851,null);class P{async getDefaultTerminalForPlatforms(){return{windows:b.getDefaultTerminalWindows(),linux:await $.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class b extends P{static{this.b="cmd.exe"}openTerminal(t,n){return this.spawnTerminal(s,t,c.$Bm(),n)}spawnTerminal(t,n,r,d){const l=n.windowsExec||b.getDefaultTerminalWindows();d&&d[1]===":"&&(d=d[0].toUpperCase()+d.substr(1));const f=A.$qc(l,".exe").toLowerCase();if(f==="cmder")return t.spawn(l,d?[d]:void 0),Promise.resolve(void 0);const y=["/c","start","/wait"];return l.indexOf(" ")>=0&&y.push(l),y.push(l),f==="wt"&&y.push("-d ."),new Promise((k,S)=>{const D=p(process),T=t.spawn(r,y,{cwd:d,env:D,detached:!0});T.on("error",S),T.on("exit",()=>k())})}async runInTerminal(t,n,r,d,l){const f="windowsExec"in l&&l.windowsExec?l.windowsExec:b.getDefaultTerminalWindows(),y=await b.f();return new Promise((k,S)=>{const D=`"${n} - ${g}"`,T=`"${r.join('" "')}" & pause`,v=Object.assign({},p(process),d);Object.keys(v).filter(F=>v[F]===null).forEach(F=>delete v[F]);const w={cwd:n,env:v,windowsVerbatimArguments:!0};let M,L;A.$qc(f,".exe")==="wt"?(M=f,L=["-d",".",b.b,"/c",T]):y?(M=y,L=["-d",".",f,"/c",T]):(M=b.b,L=["/c","start",D,"/wait",f,"/c",`"${T}"`]),s.spawn(M,L,w).on("error",F=>{S(u(F))}),k(void 0)})}static getDefaultTerminalWindows(){if(!b.d){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");b.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return b.d}static async f(){try{const t=await c.win32.findExecutable("wt");return await m.Promises.exists(t)?t:void 0}catch{return}}}e.$Ehc=b,Ze([h.$ai],b,"f",null);class a extends P{static{this.b="/usr/bin/osascript"}openTerminal(t,n){return this.spawnTerminal(s,t,n)}runInTerminal(t,n,r,d,l){const f=l.osxExec||E.$K$b;return new Promise((y,k)=>{if(f===E.$K$b||f==="iTerm.app"){const S=f===E.$K$b?"TerminalHelper":"iTermHelper",T=[R.$3g.asFileUri(`vs/workbench/contrib/externalTerminal/node/${S}.scpt`).fsPath,"-t",t||g,"-w",n];for(const M of r)T.push("-a"),T.push(M);if(d){const M=Object.assign({},p(process),d);for(const L in M){const N=M[L];N===null?(T.push("-u"),T.push(L)):(T.push("-e"),T.push(`${L}=${N}`))}}let v="";const w=s.spawn(a.b,T);w.on("error",M=>{k(u(M))}),w.stderr.on("data",M=>{v+=M.toString()}),w.on("exit",M=>{if(M===0)y(void 0);else if(v){const L=v.split(`
`,1);k(new Error(L[0]))}else k(new Error(I.localize(1852,null,S,M)))})}else k(new Error(I.localize(1853,null,f)))})}spawnTerminal(t,n,r){const d=n.osxExec||E.$K$b;return new Promise((l,f)=>{const y=["-a",d];r&&y.push(r);const k=p(process),S=t.spawn("/usr/bin/open",y,{cwd:r,env:k});S.on("error",f),S.on("exit",()=>l())})}}e.$Fhc=a;class $ extends P{static{this.b=I.localize(1854,null)}openTerminal(t,n){return this.spawnTerminal(s,t,n)}runInTerminal(t,n,r,d,l){const f=l.linuxExec?Promise.resolve(l.linuxExec):$.getDefaultTerminalLinuxReady();return new Promise((y,k)=>{const S=[];f.then(D=>{D.indexOf("gnome-terminal")>=0?S.push("-x"):S.push("-e"),S.push("bash"),S.push("-c");const T=`${i(r)}; echo; read -p "${$.b}" -n1;`;S.push(`''${T}''`);const v=Object.assign({},p(process),d);Object.keys(v).filter(N=>v[N]===null).forEach(N=>delete v[N]);const w={cwd:n,env:v};let M="";const L=s.spawn(D,S,w);L.on("error",N=>{k(u(N))}),L.stderr.on("data",N=>{M+=N.toString()}),L.on("exit",N=>{if(N===0)y(void 0);else if(M){const F=M.split(`
`,1);k(new Error(F[0]))}else k(new Error(I.localize(1855,null,D,N)))})})})}static async getDefaultTerminalLinuxReady(){if(!$.d)if(!O.$l)$.d=Promise.resolve("xterm");else{const t=await m.Promises.exists("/etc/debian_version");$.d=new Promise(n=>{t?n("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?n("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?n("konsole"):process.env.COLORTERM?n(process.env.COLORTERM):process.env.TERM?n(process.env.TERM):n("xterm")})}return $.d}spawnTerminal(t,n,r){const d=n.linuxExec?Promise.resolve(n.linuxExec):$.getDefaultTerminalLinuxReady();return new Promise((l,f)=>{d.then(y=>{const k=p(process),S=t.spawn(y,[],{cwd:r,env:k});S.on("error",f),S.on("exit",()=>l())})})}}e.$Ghc=$;function p(o){const t={...o.env};return(0,C.$om)(t),t}function u(o){return"errno"in o&&o.errno==="ENOENT"&&"path"in o&&typeof o.path=="string"?new Error(I.localize(1856,null,o.path)):o}function i(o){let t="";for(const n of o)n.indexOf(" ")>=0?t+='"'+n+'"':t+=n,t+=" ";return t}}),define(Re[27],Ce([1,0,62,16,13,17,2,8,5,10,14,50]),function(ge,e,s,h,R,A,O,C,m,c,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=e.$Il=e.FileKind=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=e.$Cl=e.$Bl=e.FileOperationResult=e.$Al=e.$zl=e.$yl=e.$wl=e.FileChangeType=e.$vl=e.FileOperation=e.$pl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$dl=void 0,e.$el=g,e.$fl=$,e.$gl=u,e.$hl=i,e.$il=o,e.$jl=t,e.$kl=n,e.$ll=r,e.$ml=d,e.$nl=l,e.$ol=f,e.$ql=S,e.$rl=D,e.$sl=T,e.$tl=v,e.$ul=w,e.$xl=V,e.$Jl=B,e.$Kl=Y,e.$Ml=oe,e.$dl=(0,m.$Ii)("fileService");function g(ie){return ie.create===!0}var P;(function(ie){ie[ie.Unknown=0]="Unknown",ie[ie.File=1]="File",ie[ie.Directory=2]="Directory",ie[ie.SymbolicLink=64]="SymbolicLink"})(P||(e.FileType=P={}));var b;(function(ie){ie[ie.Readonly=1]="Readonly",ie[ie.Locked=2]="Locked"})(b||(e.FilePermission=b={}));var a;(function(ie){ie[ie.UPDATED=2]="UPDATED",ie[ie.ADDED=4]="ADDED",ie[ie.DELETED=8]="DELETED"})(a||(e.FileChangeFilter=a={}));function $(ie){const me=ie;return!!me&&typeof me.onDidChange=="function"}var p;(function(ie){ie[ie.None=0]="None",ie[ie.FileReadWrite=2]="FileReadWrite",ie[ie.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ie[ie.FileReadStream=16]="FileReadStream",ie[ie.FileFolderCopy=8]="FileFolderCopy",ie[ie.PathCaseSensitive=1024]="PathCaseSensitive",ie[ie.Readonly=2048]="Readonly",ie[ie.Trash=4096]="Trash",ie[ie.FileWriteUnlock=8192]="FileWriteUnlock",ie[ie.FileAtomicRead=16384]="FileAtomicRead",ie[ie.FileAtomicWrite=32768]="FileAtomicWrite",ie[ie.FileAtomicDelete=65536]="FileAtomicDelete",ie[ie.FileClone=131072]="FileClone"})(p||(e.FileSystemProviderCapabilities=p={}));function u(ie){return!!(ie.capabilities&p.FileReadWrite)}function i(ie){return!!(ie.capabilities&p.FileFolderCopy)}function o(ie){return!!(ie.capabilities&p.FileClone)}function t(ie){return!!(ie.capabilities&p.FileOpenReadWriteClose)}function n(ie){return!!(ie.capabilities&p.FileReadStream)}function r(ie){return u(ie)?!!(ie.capabilities&p.FileAtomicRead):!1}function d(ie){return u(ie)?!!(ie.capabilities&p.FileAtomicWrite):!1}function l(ie){return!!(ie.capabilities&p.FileAtomicDelete)}function f(ie){return!!(ie.capabilities&p.Readonly)}var y;(function(ie){ie.FileExists="EntryExists",ie.FileNotFound="EntryNotFound",ie.FileNotADirectory="EntryNotADirectory",ie.FileIsADirectory="EntryIsADirectory",ie.FileExceedsStorageQuota="EntryExceedsStorageQuota",ie.FileTooLarge="EntryTooLarge",ie.FileWriteLocked="EntryWriteLocked",ie.NoPermissions="NoPermissions",ie.Unavailable="Unavailable",ie.Unknown="Unknown"})(y||(e.FileSystemProviderErrorCode=y={}));class k extends Error{static create(me,ue){const X=new k(me.toString(),ue);return T(X,ue),X}constructor(me,ue){super(me),this.code=ue}}e.$pl=k;function S(ie,me){return k.create(ie,me)}function D(ie){return ie||S((0,C.localize)(1865,null),y.Unknown)}function T(ie,me){return ie.name=me?`${me} (FileSystemError)`:"FileSystemError",ie}function v(ie){if(!ie)return y.Unknown;if(ie instanceof k)return ie.code;const me=/^(.+) \(FileSystemError\)$/.exec(ie.name);if(!me)return y.Unknown;switch(me[1]){case y.FileExists:return y.FileExists;case y.FileIsADirectory:return y.FileIsADirectory;case y.FileNotADirectory:return y.FileNotADirectory;case y.FileNotFound:return y.FileNotFound;case y.FileTooLarge:return y.FileTooLarge;case y.FileWriteLocked:return y.FileWriteLocked;case y.NoPermissions:return y.NoPermissions;case y.Unavailable:return y.Unavailable}return y.Unknown}function w(ie){if(ie instanceof j)return ie.fileOperationResult;switch(v(ie)){case y.FileNotFound:return _.FILE_NOT_FOUND;case y.FileIsADirectory:return _.FILE_IS_DIRECTORY;case y.FileNotADirectory:return _.FILE_NOT_DIRECTORY;case y.FileWriteLocked:return _.FILE_WRITE_LOCKED;case y.NoPermissions:return _.FILE_PERMISSION_DENIED;case y.FileExists:return _.FILE_MOVE_CONFLICT;case y.FileTooLarge:return _.FILE_TOO_LARGE;default:return _.FILE_OTHER_ERROR}}var M;(function(ie){ie[ie.CREATE=0]="CREATE",ie[ie.DELETE=1]="DELETE",ie[ie.MOVE=2]="MOVE",ie[ie.COPY=3]="COPY",ie[ie.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class L{constructor(me,ue,X){this.resource=me,this.operation=ue,this.target=X}isOperation(me){return this.operation===me}}e.$vl=L;var N;(function(ie){ie[ie.UPDATED=0]="UPDATED",ie[ie.ADDED=1]="ADDED",ie[ie.DELETED=2]="DELETED"})(N||(e.FileChangeType=N={}));class F{static{this.a=null}constructor(me,ue){this.c=ue,this.b=void 0,this.d=new E.$W(()=>{const X=s.$Oi.forUris(()=>this.c);return X.fill(this.rawAdded.map(q=>[q,!0])),X}),this.f=new E.$W(()=>{const X=s.$Oi.forUris(()=>this.c);return X.fill(this.rawUpdated.map(q=>[q,!0])),X}),this.g=new E.$W(()=>{const X=s.$Oi.forUris(()=>this.c);return X.fill(this.rawDeleted.map(q=>[q,!0])),X}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const X of me){switch(X.type){case N.ADDED:this.rawAdded.push(X.resource);break;case N.UPDATED:this.rawUpdated.push(X.resource);break;case N.DELETED:this.rawDeleted.push(X.resource);break}this.b!==F.a&&(typeof X.cId=="number"?this.b===void 0?this.b=X.cId:this.b!==X.cId&&(this.b=F.a):this.b!==void 0&&(this.b=F.a))}}contains(me,...ue){return this.h(me,{includeChildren:!1},...ue)}affects(me,...ue){return this.h(me,{includeChildren:!0},...ue)}h(me,ue,...X){if(!me)return!1;const q=X.length>0;return!!((!q||X.includes(N.ADDED))&&(this.d.value.get(me)||ue.includeChildren&&this.d.value.findSuperstr(me))||(!q||X.includes(N.UPDATED))&&(this.f.value.get(me)||ue.includeChildren&&this.f.value.findSuperstr(me))||(!q||X.includes(N.DELETED))&&(this.g.value.findSubstr(me)||ue.includeChildren&&this.g.value.findSuperstr(me)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(me){return this.b===me}hasCorrelation(){return typeof this.b=="number"}}e.$wl=F;function V(ie,me,ue){return!ie||!me||ie===me||me.length>ie.length?!1:(me.charAt(me.length-1)!==h.sep&&(me+=h.sep),ue?(0,R.$Jf)(ie,me):ie.indexOf(me)===0)}class j extends Error{constructor(me,ue,X){super(me),this.fileOperationResult=ue,this.options=X}}e.$yl=j;class U extends j{constructor(me,ue,X,q){super(me,ue,q),this.fileOperationResult=ue,this.size=X}}e.$zl=U;class z extends j{constructor(me,ue,X){super(me,_.FILE_NOT_MODIFIED_SINCE,X),this.stat=ue}}e.$Al=z;var _;(function(ie){ie[ie.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ie[ie.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ie[ie.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ie[ie.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ie[ie.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ie[ie.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ie[ie.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ie[ie.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ie[ie.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ie[ie.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ie[ie.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(_||(e.FileOperationResult=_={})),e.$Bl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Cl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Dl="files.associations",e.$El="files.exclude",e.$Fl="files.readonlyInclude",e.$Gl="files.readonlyExclude",e.$Hl="files.readonlyFromPermissions";var W;(function(ie){ie[ie.FILE=0]="FILE",ie[ie.FOLDER=1]="FOLDER",ie[ie.ROOT_FOLDER=2]="ROOT_FOLDER"})(W||(e.FileKind=W={})),e.$Il="";function B(ie){if(!(typeof ie.size!="number"||typeof ie.mtime!="number"))return ie.mtime.toString(29)+ie.size.toString(31)}async function Y(ie,me){if(!me.hasProvider(O.URI.from({scheme:ie.scheme})))return new Promise(ue=>{const X=me.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===ie.scheme&&q.added&&(X.dispose(),ue())})})}class x{static{this.KB=1024}static{this.MB=x.KB*x.KB}static{this.GB=x.MB*x.KB}static{this.TB=x.GB*x.KB}static formatSize(me){return(0,A.$lg)(me)||(me=0),me<x.KB?(0,C.localize)(1866,null,me.toFixed(0)):me<x.MB?(0,C.localize)(1867,null,(me/x.KB).toFixed(2)):me<x.GB?(0,C.localize)(1868,null,(me/x.MB).toFixed(2)):me<x.TB?(0,C.localize)(1869,null,(me/x.GB).toFixed(2)):(0,C.localize)(1870,null,(me/x.TB).toFixed(2))}}e.$Ll=x;function oe(ie){const me=typeof ie=="string"||ie?.scheme===I.Schemas.vscodeRemote;return typeof ie!="string"&&ie?.scheme===I.Schemas.file?1024*x.MB:me?10*x.MB:c.$p?50*x.MB:1024*x.MB}}),define(Re[221],Ce([1,0,21,12,8,27]),function(ge,e,s,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=O;async function O(I,E,g,P,b,a){let $;try{await C(I,E,g,P,b,a)}catch(p){$=p}finally{$&&b.errorTransformer&&($=b.errorTransformer($)),typeof $<"u"&&g.error($),g.end()}}async function C(I,E,g,P,b,a){m(a);const $=await I.open(E,{create:!1});try{m(a);let p=0,u=0,i=b&&typeof b.length=="number"?b.length:void 0,o=s.$Qe.alloc(Math.min(b.bufferSize,typeof i=="number"?i:b.bufferSize)),t=b&&typeof b.position=="number"?b.position:0,n=0;do u=await I.read($,t,o.buffer,n,o.byteLength-n),t+=u,n+=u,p+=u,typeof i=="number"&&(i-=u),n===o.byteLength&&(await g.write(P(o)),o=s.$Qe.alloc(Math.min(b.bufferSize,typeof i=="number"?i:b.bufferSize)),n=0);while(u>0&&(typeof i!="number"||i>0)&&m(a)&&c(p,b));if(n>0){let r=n;typeof i=="number"&&(r=Math.min(n,i)),g.write(P(o.slice(0,r)))}}catch(p){throw(0,A.$rl)(p)}finally{await I.close($)}}function m(I){if(I.isCancellationRequested)throw(0,h.$8)();return!0}function c(I,E){if(typeof E?.limits?.size=="number"&&I>E.limits.size)throw(0,A.$ql)((0,R.localize)(1898,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Re[71],Ce([1,0,39,3,16,10,2,27]),function(ge,e,s,h,R,A,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=e.$ar=e.$_q=void 0,e.$0q=m,e.$$q=c,e.$cr=P,e.$dr=b,e.$er=a,e.$fr=$,e.$gr=u,e.$hr=i;function m(o){return typeof o.correlationId=="number"}function c(o){return o.recursive===!0}class I extends h.$Xc{static{this.a=5}constructor(t,n,r,d){super(),this.h=t,this.j=n,this.m=r,this.n=d,this.c=this.B(new h.$Yc),this.f=void 0,this.g=0}s(){const t=new h.$Wc;this.c.value=t,this.b=this.r(t),this.b.setVerboseLogging(this.m),t.add(this.b.onDidChangeFile(n=>this.h(n))),t.add(this.b.onDidLogMessage(n=>this.j(n))),t.add(this.b.onDidError(n=>this.t(n.error,n.request)))}t(t,n){this.u(t,n)?this.g<I.a&&this.f?(this.y(`restarting watcher after unexpected error: ${t}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${t}`):this.y(t)}u(t,n){return!(!this.n.restartOnError||n||t.indexOf("No space left on device")!==-1||t.indexOf("EMFILE")!==-1)}w(t){this.g++,this.s(),this.watch(t)}async watch(t){this.f=t,await this.b?.watch(t)}async setVerboseLogging(t){this.m=t,await this.b?.setVerboseLogging(t)}y(t){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${t}`})}z(t){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${t}`})}dispose(){return this.b=void 0,super.dispose()}}e.$_q=I;class E extends I{constructor(t,n,r){super(t,n,r,{type:"node.js",restartOnError:!1})}}e.$ar=E;class g extends I{constructor(t,n,r){super(t,n,r,{type:"universal",restartOnError:!0})}}e.$br=g;function P(o){return o.map(t=>({type:t.type,resource:O.URI.revive(t.resource),cId:t.cId}))}function b(o){const t=new p;for(const n of o)t.processEvent(n);return t.coalesce()}function a(o,t){return typeof t=="string"&&!t.startsWith(s.$zk)&&!(0,R.$lc)(t)?{base:o,pattern:t}:t}function $(o,t){const n=[];for(const r of t)n.push((0,s.$Dk)(a(o,r)));return n}class p{constructor(){this.a=new Set,this.b=new Map}c(t){return A.$l?t.resource.fsPath:t.resource.fsPath.toLowerCase()}processEvent(t){const n=this.b.get(this.c(t));let r=!1;if(n){const d=n.type,l=t.type;n.resource.fsPath!==t.resource.fsPath&&(t.type===C.FileChangeType.DELETED||t.type===C.FileChangeType.ADDED)?r=!0:d===C.FileChangeType.ADDED&&l===C.FileChangeType.DELETED?(this.b.delete(this.c(t)),this.a.delete(n)):d===C.FileChangeType.DELETED&&l===C.FileChangeType.ADDED?n.type=C.FileChangeType.UPDATED:d===C.FileChangeType.ADDED&&l===C.FileChangeType.UPDATED||(n.type=l)}else r=!0;r&&(this.a.add(t),this.b.set(this.c(t),t))}coalesce(){const t=[],n=[];return Array.from(this.a).filter(r=>r.type!==C.FileChangeType.DELETED?(t.push(r),!1):!0).sort((r,d)=>r.resource.fsPath.length-d.resource.fsPath.length).filter(r=>n.some(d=>(0,C.$xl)(r.resource.fsPath,d,!A.$l))?!1:(n.push(r.resource.fsPath),!0)).concat(t)}}function u(o,t){if(typeof t=="number")switch(o.type){case C.FileChangeType.ADDED:return(t&C.FileChangeFilter.ADDED)===0;case C.FileChangeType.DELETED:return(t&C.FileChangeFilter.DELETED)===0;case C.FileChangeType.UPDATED:return(t&C.FileChangeFilter.UPDATED)===0}return!1}function i(o){if(typeof o=="number"){const t=[];return o&C.FileChangeFilter.ADDED&&t.push("Added"),o&C.FileChangeFilter.DELETED&&t.push("Deleted"),o&C.FileChangeFilter.UPDATED&&t.push("Updated"),t.length===0?"<all>":`[${t.join(", ")}]`}return"<none>"}}),define(Re[222],Ce([1,0,45,3,71,4,27,2,7]),function(ge,e,s,h,R,A,O,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;class c extends h.$Xc{constructor(){super(),this.a=this.B(new A.$oe),this.onDidChangeFile=this.a.event,this.b=this.B(new A.$oe),this.onDidLogMessage=this.b.event,this.c=this.B(new A.$oe),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new h.$7c),this.m=new Set,this.n=this.B(new m.$Gh(this.y())),this.r=5007,this.s=new m.$6h,this.R=!1,this.B(this.f(E=>this.t(E)))}t(E){this.u(E)&&this.z(E)}u(E){return(0,R.$0q)(E)}async watch(E){this.s.isSettled||this.s.complete(),this.s=new m.$6h;try{this.h.clear(),this.g.clear();for(const g of E)this.u(g)?this.h.set(g.correlationId,g):this.g.add(g);for(const[g]of this.j)this.h.has(g)||(this.j.deleteAndDispose(g),this.m.delete(g));return await this.w(!1)}finally{this.s.complete()}}w(E){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(g=>!this.j.has(g.correlationId))]),E?this.y():0)}y(){return 800}isSuspended(E){return typeof E.correlationId!="number"?!1:this.m.has(E.correlationId)?"polling":this.j.has(E.correlationId)}async z(E){if(this.j.has(E.correlationId))return;const g=new h.$Wc;this.j.set(E.correlationId,g),await this.s.p,!g.isDisposed&&(this.D(E,g),this.w(!0))}C(E){this.j.deleteAndDispose(E.correlationId),this.m.delete(E.correlationId),this.w(!1)}D(E,g){this.F(E,g)?(this.P(`reusing an existing recursive watcher to monitor ${E.path}`),this.m.delete(E.correlationId)):(this.G(E,g),this.m.add(E.correlationId))}F(E,g){const P=this.O?.subscribe(E.path,(b,a)=>{g.isDisposed||(b?this.D(E,g):a?.type===O.FileChangeType.ADDED&&this.H(E))});return P?(g.add(P),!0):!1}G(E,g){let P=!1;const b=(a,$)=>{if(g.isDisposed)return;const p=this.I(a),u=this.I($),i=P;P=p,!p&&(u||i)&&this.H(E)};this.P(`starting fs.watchFile() on ${E.path} (correlationId: ${E.correlationId})`);try{(0,s.watchFile)(E.path,{persistent:!1,interval:this.r},b)}catch(a){this.Q(`fs.watchFile() failed with error ${a} on path ${E.path} (correlationId: ${E.correlationId})`)}g.add((0,h.$Vc)(()=>{this.P(`stopping fs.watchFile() on ${E.path} (correlationId: ${E.correlationId})`);try{(0,s.unwatchFile)(E.path,b)}catch(a){this.Q(`fs.unwatchFile() failed with error ${a} on path ${E.path} (correlationId: ${E.correlationId})`)}}))}H(E){this.P(`detected ${E.path} exists again, resuming watcher (correlationId: ${E.correlationId})`);const g={resource:C.URI.file(E.path),type:O.FileChangeType.ADDED,cId:E.correlationId};this.a.fire([g]),this.J(g,E),this.C(E)}I(E){return E.ctimeMs===0&&E.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(E,g){if(this.R){const P=` >> normalized ${E.type===O.FileChangeType.ADDED?"[ADDED]":E.type===O.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${E.resource.fsPath}`;this.L(P,g)}}L(E,g){this.R&&this.P(`${E}${typeof g.correlationId=="number"?` <${g.correlationId}> `:""}`)}M(E){return`${E.path} (excludes: ${E.excludes.length>0?E.excludes:"<none>"}, includes: ${E.includes&&E.includes.length>0?JSON.stringify(E.includes):"<all>"}, filter: ${(0,R.$hr)(E.filter)}, correlationId: ${typeof E.correlationId=="number"?E.correlationId:"<none>"})`}async setVerboseLogging(E){this.R=E}}e.$qr=c}),define(Re[223],Ce([1,0,45,7,20,31,3,83,16,10,22,2,108,33,27,71]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=void 0,e.$wr=p;class $ extends O.$Xc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(i,o,t,n,r,d){super(),this.s=i,this.t=o,this.u=t,this.w=n,this.y=r,this.z=d,this.c=this.B(new h.$Xh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},l=>this.u(l))),this.f=this.B(new h.$Wh(l=>this.M(l),$.b)),this.g=(0,a.$fr)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,a.$fr)(this.s.path,this.s.includes):void 0,this.j=(0,a.$0q)(this.s)?this.s.filter:void 0,this.m=new R.$ze,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const i=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const o=await s.promises.stat(i);if(this.m.token.isCancellationRequested)return;this.B(await this.G(i,o.isDirectory()))}catch(i){i.code!=="ENOENT"?this.O(i):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${i})`),this.D()}}D(){this.r=!0,this.w?.()}async F(i){let o=i.path;try{o=await P.Promises.realpath(i.path),i.path===o&&(o=await(0,g.$sr)(i.path,this.m.token)??i.path),i.path!==o&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${o})`)}catch{}return o}async G(i,o){const t=new O.$Wc;return this.H(i,o,t)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(i,o,t)),t}H(i,o,t){if(o)return!1;const n=E.URI.file(this.s.path),r=this.t?.subscribe(this.s.path,async(d,l)=>{if(!t.isDisposed)if(d){const f=await this.G(i,o);t.isDisposed?f.dispose():t.add(f)}else l&&(typeof l.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:n,type:l.type,cId:this.s.correlationId},!0)});return r?(t.add(r),!0):!1}async I(i,o,t){if(c.$k&&(0,A.$Hg)(i,"/Volumes/",!0)){this.O(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const n=new R.$ze(this.m.token);t.add((0,O.$Vc)(()=>n.dispose(!0)));const r=new O.$Wc;t.add(r);try{const d=E.URI.file(this.s.path),l=(0,m.$qc)(i),f=(0,s.watch)(i);r.add((0,O.$Vc)(()=>{f.removeAllListeners(),f.close()})),this.Q(`Started watching: '${i}'`);const y=new Set;if(o)try{for(const S of await P.Promises.readdir(i))y.add(S)}catch(S){this.O(S)}if(n.token.isCancellationRequested)return;const k=new Map;r.add((0,O.$Vc)(()=>{for(const[,S]of k)S.dispose();k.clear()})),f.on("error",(S,D)=>{n.token.isCancellationRequested||(this.O(`Failed to watch ${i} for changes using fs.watch() (${S}, ${D})`),this.D())}),f.on("change",(S,D)=>{if(n.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${S}"] ${D}`);let T="";if(D&&(T=D.toString(),c.$k&&(T=(0,C.$qm)(T))),!(!T||S!=="change"&&S!=="rename"))if(o)if(S==="rename"){k.get(T)?.dispose();const v=setTimeout(async()=>{if(k.delete(T),T===l&&!await P.Promises.exists(i)){this.J(d);return}if(n.token.isCancellationRequested)return;const w=await this.N((0,m.$mc)(i,T));if(n.token.isCancellationRequested)return;let M;w?y.has(T)?M=b.FileChangeType.UPDATED:(M=b.FileChangeType.ADDED,y.add(T)):(y.delete(T),M=b.FileChangeType.DELETED),this.L({resource:(0,I.$jh)(d,T),type:M,cId:this.s.correlationId})},$.a);k.set(T,(0,O.$Vc)(()=>clearTimeout(v)))}else{let v;y.has(T)?v=b.FileChangeType.UPDATED:(v=b.FileChangeType.ADDED,y.add(T)),this.L({resource:(0,I.$jh)(d,T),type:v,cId:this.s.correlationId})}else if(S==="rename"||T!==l){const v=setTimeout(async()=>{const w=await P.Promises.exists(i);n.token.isCancellationRequested||(w?(this.L({resource:d,type:b.FileChangeType.UPDATED,cId:this.s.correlationId},!0),r.add(await this.G(i,!1))):this.J(d))},$.a);r.clear(),r.add((0,O.$Vc)(()=>clearTimeout(v)))}else this.L({resource:d,type:b.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(d){n.token.isCancellationRequested||this.O(`Failed to watch ${i} for changes using fs.watch() (${d.toString()})`),this.D()}}J(i){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:i,type:b.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(i,o=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${i.type===b.FileChangeType.ADDED?"[ADDED]":i.type===b.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!o&&this.g.some(t=>t(i.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${i.resource.fsPath}`):!o&&this.h&&this.h.length>0&&!this.h.some(t=>t(i.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}M(i){const o=(0,a.$dr)(i),t=[];for(const r of o){if((0,a.$gr)(r,this.j)){this.z&&this.R(` >> ignored (filtered) ${r.resource.fsPath}`);continue}t.push(r)}if(t.length===0)return;if(this.z)for(const r of t)this.R(` >> normalized ${r.type===b.FileChangeType.ADDED?"[ADDED]":r.type===b.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${r.resource.fsPath}`);this.c.work(t)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${t.length}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(i){if(c.$l)return P.Promises.exists(i);try{const o=(0,m.$qc)(i);return(await P.Promises.readdir((0,m.$pc)(i))).some(n=>n===o)}catch(o){return this.Q(o),!1}}setVerboseLogging(i){this.z=i}O(i){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}P(i){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}Q(i){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}R(i){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${i}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$vr=$;async function p(u,i,o,t,n=512){const r=await P.Promises.open(u,"r"),d=Buffer.allocUnsafe(n),l=new R.$ze(t);let f,y=!1;const k={path:u,excludes:[],recursive:!1},S=new $(k,void 0,D=>{(async()=>{for(const{type:T}of D)if(T===b.FileChangeType.UPDATED){if(y)return;y=!0;try{for(;!l.token.isCancellationRequested;){const{bytesRead:v}=await P.Promises.read(r,d,0,n,null);if(!v||l.token.isCancellationRequested)break;i(d.slice(0,v))}}catch(v){f=new Error(v),l.dispose(!0)}finally{y=!1}}})()});return await S.ready,o(),new Promise((D,T)=>{l.token.onCancellationRequested(async()=>{S.dispose();try{await P.Promises.close(r)}catch(v){f=new Error(v)}f?T(f):D()})})}}),define(Re[224],Ce([1,0,4,39,222,10,223,31]),function(ge,e,s,h,R,A,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=void 0;class m extends R.$qr{constructor(I){super(),this.O=I,this.onDidError=s.Event.None,this.watchers=new Set}async N(I){I=this.Z(I);const E=[],g=new Set(Array.from(this.watchers));for(const P of I){const b=this.W(P);b&&(0,h.$Hk)(b.request.excludes,P.excludes)&&(0,h.$Hk)(b.request.includes,P.includes)?g.delete(b):E.push(P)}E.length&&this.P(`Request to start watching: ${E.map(P=>this.M(P)).join(",")}`),g.size&&this.P(`Request to stop watching: ${Array.from(g).map(P=>this.M(P.request)).join(",")}`);for(const P of g)this.Y(P);for(const P of E)this.X(P)}W(I){for(const E of this.watchers)if(typeof I.correlationId=="number"||typeof E.request.correlationId=="number"){if(E.request.correlationId===I.correlationId)return E}else if((0,C.$Gg)(E.request.path,I.path,!A.$l))return E}X(I){const E=new O.$vr(I,this.O,P=>this.a.fire(P),()=>this.c.fire(I),P=>this.b.fire(P),this.R),g={request:I,instance:E};this.watchers.add(g)}async stop(){await super.stop();for(const I of this.watchers)this.Y(I)}Y(I){this.P("stopping file watcher",I),this.watchers.delete(I),I.instance.dispose()}Z(I){const E=new Map;for(const g of I){const P=A.$l?g.path:g.path.toLowerCase();let b=E.get(g.correlationId);b||(b=new Map,E.set(g.correlationId,b)),b.has(P)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(g)}`),b.set(P,g)}return Array.from(E.values()).map(g=>Array.from(g.values())).flat()}async setVerboseLogging(I){super.setVerboseLogging(I);for(const E of this.watchers)E.instance.setVerboseLogging(I)}P(I,E){this.R&&this.b.fire({type:"trace",message:this.bb(I,E)})}Q(I){this.b.fire({type:"warn",message:this.bb(I)})}bb(I,E){return E?`[File Watcher (node.js)] ${I} (${this.M(E.request)})`:`[File Watcher (node.js)] ${I}`}}e.$xr=m}),define(Re[225],Ce([1,0,71,224]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=void 0;class R extends s.$ar{constructor(O,C,m){super(O,C,m),this.s()}r(O){return O.add(new h.$xr(void 0))}}e.$yr=R}),define(Re[226],Ce([1,0,14,87,194,71]),function(ge,e,s,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;class O extends A.$br{constructor(m,c,I){super(m,c,I),this.s()}r(m){const c=m.add(new R.$or(s.$3g.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return m.add(c.onDidProcessExit(({code:I,signal:E})=>this.t(`terminated by itself with code ${I}, signal: ${E} (ETERM)`))),h.ProxyChannel.toService((0,h.$pi)(c.getChannel("watcher")))}}e.$pr=O}),define(Re[114],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=void 0;class s{constructor(...R){this.a=new Map;for(const[A,O]of R)this.set(A,O)}set(R,A){const O=this.a.get(R);return this.a.set(R,A),O}has(R){return this.a.has(R)}get(R){return this.a.get(R)}}e.$Gi=s}),define(Re[227],Ce([1,0,7,12,3,112,216,5,114,82]),function(ge,e,s,h,R,A,O,C,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=void 0;const I=!1;class E extends Error{constructor($){super("cyclic dependency between services"),this.message=$.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${$.toString()}`}}class g{constructor($=new m.$Gi,p=!1,u,i=I){this.i=$,this.j=p,this.k=u,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(C.$Hi,this),this._globalGraph=i?u?._globalGraph??new O.$Br(o=>o):void 0}dispose(){if(!this.f){this.f=!0,(0,R.$Sc)(this.h),this.h.clear();for(const $ of this.g)(0,R.$Rc)($)&&$.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild($,p){this.m();const u=this,i=new class extends g{dispose(){u.h.delete(i),super.dispose()}}($,this.j,this,this.l);return this.h.add(i),p?.add(i),i}invokeFunction($,...p){this.m();const u=b.traceInvocation(this.l,$);let i=!1;try{return $({get:t=>{if(i)throw(0,h.$0)("service accessor is only valid during the invocation of its target method");const n=this.s(t,u);if(!n)throw new Error(`[invokeFunction] unknown service '${t}'`);return n}},...p)}finally{i=!0,u.stop()}}createInstance($,...p){this.m();let u,i;return $ instanceof A.$Fi?(u=b.traceCreation(this.l,$.ctor),i=this.o($.ctor,$.staticArguments.concat(p),u)):(u=b.traceCreation(this.l,$),i=this.o($,p,u)),u.stop(),i}o($,p=[],u){const i=C._util.getServiceDependencies($).sort((n,r)=>n.index-r.index),o=[];for(const n of i){const r=this.s(n.id,u);r||this.y(`[createInstance] ${$.name} depends on UNKNOWN service ${n.id}.`,!1),o.push(r)}const t=i.length>0?i[0].index:p.length;if(p.length!==t){console.trace(`[createInstance] First service dependency of ${$.name} at position ${t+1} conflicts with ${p.length} static arguments`);const n=t-p.length;n>0?p=p.concat(new Array(n)):p=p.slice(0,t)}return Reflect.construct($,p.concat(o))}q($,p){if(this.i.get($)instanceof A.$Fi)this.i.set($,p);else if(this.k)this.k.q($,p);else throw new Error("illegalState - setting UNKNOWN service instance")}r($){const p=this.i.get($);return!p&&this.k?this.k.r($):p}s($,p){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String($));const u=this.r($);return u instanceof A.$Fi?this.u($,u,p.branch($,!0)):(p.branch($,!1),u)}u($,p,u){if(this.t.has($))throw new Error(`illegal state - RECURSIVELY instantiating service '${$}'`);this.t.add($);try{return this.v($,p,u)}finally{this.t.delete($)}}v($,p,u){const i=new O.$Br(r=>r.id.toString());let o=0;const t=[{id:$,desc:p,_trace:u}],n=new Set;for(;t.length;){const r=t.pop();if(!n.has(String(r.id))){if(n.add(String(r.id)),i.lookupOrInsertNode(r),o++>1e3)throw new E(i);for(const d of C._util.getServiceDependencies(r.desc.ctor)){const l=this.r(d.id);if(l||this.y(`[createInstance] ${$} depends on ${d.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(r.id),String(d.id)),l instanceof A.$Fi){const f={id:d.id,desc:l,_trace:r._trace.branch(d.id,!0)};i.insertEdge(r,f),t.push(f)}}}}for(;;){const r=i.roots();if(r.length===0){if(!i.isEmpty())throw new E(i);break}for(const{data:d}of r){if(this.r(d.id)instanceof A.$Fi){const f=this.w(d.id,d.desc.ctor,d.desc.staticArguments,d.desc.supportsDelayedInstantiation,d._trace);this.q(d.id,f)}i.removeNode(d)}}return this.r($)}w($,p,u=[],i,o){if(this.i.get($)instanceof A.$Fi)return this.x($,p,u,i,o,this.g);if(this.k)return this.k.w($,p,u,i,o);throw new Error(`illegalState - creating UNKNOWN service instance ${p.name}`)}x($,p,u=[],i,o,t){if(i){const n=new g(void 0,this.j,this,this.l);n.c=String($);const r=new Map,d=new s.$2h(()=>{const l=n.o(p,u,o);for(const[f,y]of r){const k=l[f];if(typeof k=="function")for(const S of y)S.disposable=k.apply(l,S.listener)}return r.clear(),t.add(l),l});return new Proxy(Object.create(null),{get(l,f){if(!d.isInitialized&&typeof f=="string"&&(f.startsWith("onDid")||f.startsWith("onWill"))){let S=r.get(f);return S||(S=new c.$8c,r.set(f,S)),(T,v,w)=>{if(d.isInitialized)return d.value[f](T,v,w);{const M={listener:[T,v,w],disposable:void 0},L=S.push(M);return(0,R.$Vc)(()=>{L(),M.disposable?.dispose()})}}}if(f in l)return l[f];const y=d.value;let k=y[f];return typeof k!="function"||(k=k.bind(y),l[f]=k),k},set(l,f,y){return d.value[f]=y,!0},getPrototypeOf(l){return p.prototype}})}else{const n=this.o(p,u,o);return t.add(n),n}}y($,p){if(p&&console.warn($),this.j)throw new Error($)}}e.$Cr=g;var P;(function(a){a[a.None=0]="None",a[a.Creation=1]="Creation",a[a.Invocation=2]="Invocation",a[a.Branch=3]="Branch"})(P||(P={}));class b{static{this.all=new Set}static{this.c=new class extends b{constructor(){super(P.None,null)}stop(){}branch(){return this}}}static traceInvocation($,p){return $?new b(P.Invocation,p.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):b.c}static traceCreation($,p){return $?new b(P.Creation,p.name):b.c}static{this.f=0}constructor($,p){this.type=$,this.name=p,this.g=Date.now(),this.h=[]}branch($,p){const u=new b(P.Branch,$.toString());return this.h.push([$,p,u]),u}stop(){const $=Date.now()-this.g;b.f+=$;let p=!1;function u(o,t){const n=[],r=new Array(o+1).join("	");for(const[d,l,f]of t.h)if(l&&f){p=!0,n.push(`${r}CREATES -> ${d}`);const y=u(o+1,f);y&&n.push(y)}else n.push(`${r}uses -> ${d}`);return n.join(`
`)}const i=[`${this.type===P.Creation?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${$.toFixed(2)}ms (grand total ${b.f.toFixed(2)}ms)`];($>2||p)&&b.all.add(i.join(`
`))}}e.$Dr=b}),define(Re[11],Ce([1,0,8,52,4,61,3,28,10,22,17,2,36,5]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$gk=e.LogLevel=e.$ek=e.$dk=void 0,e.$fk=a,e.log=p,e.$rk=k,e.$sk=S,e.$tk=D,e.$uk=T,s=Ue(s),e.$dk=(0,P.$Ii)("logService"),e.$ek=(0,P.$Ii)("loggerService");function b(){return new Date().toISOString()}function a(v){return(0,I.$lg)(v)}var $;(function(v){v[v.Off=0]="Off",v[v.Trace=1]="Trace",v[v.Debug=2]="Debug",v[v.Info=3]="Info",v[v.Warning=4]="Warning",v[v.Error=5]="Error"})($||(e.LogLevel=$={})),e.$gk=$.Info;function p(v,w,M){switch(w){case $.Trace:v.trace(M);break;case $.Debug:v.debug(M);break;case $.Info:v.info(M);break;case $.Warning:v.warn(M);break;case $.Error:v.error(M);break;case $.Off:break;default:throw new Error(`Invalid log level ${w}`)}}function u(v,w=!1){let M="";for(let L=0;L<v.length;L++){let N=v[L];if(N instanceof Error&&(N=(0,h.$tj)(N,w)),typeof N=="object")try{N=JSON.stringify(N)}catch{}M+=(L>0?" ":"")+N}return M}class i extends O.$Xc{constructor(){super(...arguments),this.b=e.$gk,this.c=this.B(new R.$oe),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==$.Off&&this.b<=w}}e.$ik=i;class o extends i{constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...M){this.f($.Trace)&&this.g($.Trace,u([w,...M],!0))}debug(w,...M){this.f($.Debug)&&this.g($.Debug,u([w,...M]))}info(w,...M){this.f($.Info)&&this.g($.Info,u([w,...M]))}warn(w,...M){this.f($.Warning)&&this.g($.Warning,u([w,...M]))}error(w,...M){if(this.f($.Error))if(w instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=w.stack,this.g($.Error,u(L))}else this.g($.Error,u([w,...M]))}flush(){}}e.$jk=o;class t extends i{constructor(w=e.$gk){super(),this.setLevel(w),this.g=!m.$j}trace(w,...M){this.f($.Trace)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,w,...M):console.log(`[main ${b()}]`,w,...M))}debug(w,...M){this.f($.Debug)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,w,...M):console.log(`[main ${b()}]`,w,...M))}info(w,...M){this.f($.Info)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,w,...M):console.log(`[main ${b()}]`,w,...M))}warn(w,...M){this.f($.Warning)&&(this.g?console.warn(`\x1B[93m[main ${b()}]\x1B[0m`,w,...M):console.warn(`[main ${b()}]`,w,...M))}error(w,...M){this.f($.Error)&&(this.g?console.error(`\x1B[91m[main ${b()}]\x1B[0m`,w,...M):console.error(`[main ${b()}]`,w,...M))}flush(){}}e.$kk=t;class n extends i{constructor(w=e.$gk,M=!0){super(),this.g=M,this.setLevel(w)}trace(w,...M){this.f($.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...M):console.log(w,...M))}debug(w,...M){this.f($.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...M):console.log(w,...M))}info(w,...M){this.f($.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...M):console.log(w,...M))}warn(w,...M){this.f($.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...M):console.log(w,...M))}error(w,...M){this.f($.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...M):console.error(w,...M))}flush(){}}e.$lk=n;class r extends i{constructor(w,M=e.$gk){super(),this.g=w,this.setLevel(M)}trace(w,...M){this.f($.Trace)&&this.g.log($.Trace,[this.h(w),...M])}debug(w,...M){this.f($.Debug)&&this.g.log($.Debug,[this.h(w),...M])}info(w,...M){this.f($.Info)&&this.g.log($.Info,[this.h(w),...M])}warn(w,...M){this.f($.Warning)&&this.g.log($.Warning,[this.h(w),...M])}error(w,...M){this.f($.Error)&&this.g.log($.Error,[this.h(w),...M])}h(w){return typeof w=="string"?w:(0,h.$tj)(w,this.f($.Trace))}flush(){}}e.$mk=r;class d extends i{constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const M of this.g)M.setLevel(w);super.setLevel(w)}trace(w,...M){for(const L of this.g)L.trace(w,...M)}debug(w,...M){for(const L of this.g)L.debug(w,...M)}info(w,...M){for(const L of this.g)L.info(w,...M)}warn(w,...M){for(const L of this.g)L.warn(w,...M)}error(w,...M){for(const L of this.g)L.error(w,...M)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose();super.dispose()}}e.$nk=d;class l extends O.$Xc{constructor(w,M,L){if(super(),this.h=w,this.j=M,this.b=new C.$Dc,this.c=this.B(new R.$oe),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.$oe),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.$oe),this.onDidChangeVisibility=this.g.event,L)for(const N of L)this.b.set(N.resource,{logger:void 0,info:N})}m(w){return(0,I.$hg)(w)?[...this.b.values()].find(M=>M.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,M){const L=this.n(w),N=(0,I.$hg)(w)?w:M?.id??(0,A.$wj)(L.toString()).toString(16);let F=this.b.get(L)?.logger;const V=M?.logLevel==="always"?$.Trace:M?.logLevel;F||(F=this.s(L,V??this.getLogLevel(L)??this.h,{...M,id:N}));const j={logger:F,info:{resource:L,id:N,logLevel:V,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(j.info),this.b.set(L,j),F}n(w){return(0,I.$hg)(w)?(0,c.$jh)(this.j,`${w}.log`):w}setLogLevel(w,M){if(E.URI.isUri(w)){const L=w,N=M,F=this.b.get(L);F&&N!==F.info.logLevel&&(F.info.logLevel=N===this.h?void 0:N,F.logger?.setLevel(N),this.b.set(F.info.resource,F),this.f.fire([L,N]))}else{this.h=w;for(const[L,N]of this.b.entries())this.b.get(L)?.info.logLevel===void 0&&N.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,M){const L=this.m(w);L&&M!==!L.info.hidden&&(L.info.hidden=!M,this.b.set(L.info.resource,L),this.g.fire([L.info.resource,M]))}getLogLevel(w){let M;return w&&(M=this.b.get(w)?.info.logLevel),M??this.h}registerLogger(w){const M=this.b.get(w.resource);M?M.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const M=this.b.get(w);M&&(M.logger&&M.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ok=l;class f{constructor(){this.onDidChangeLogLevel=new R.$oe().event}setLevel(w){}getLevel(){return $.Info}trace(w,...M){}debug(w,...M){}info(w,...M){}warn(w,...M){}error(w,...M){}critical(w,...M){}dispose(){}flush(){}}e.$pk=f;class y extends f{}e.$qk=y;function k(v){if(v.verbose)return $.Trace;if(typeof v.logLevel=="string"){const w=T(v.logLevel.toLowerCase());if(w!==void 0)return w}return e.$gk}function S(v){switch(v){case $.Trace:return"trace";case $.Debug:return"debug";case $.Info:return"info";case $.Warning:return"warn";case $.Error:return"error";case $.Off:return"off"}}function D(v){switch(v){case $.Trace:return{original:"Trace",value:s.localize(1959,null)};case $.Debug:return{original:"Debug",value:s.localize(1960,null)};case $.Info:return{original:"Info",value:s.localize(1961,null)};case $.Warning:return{original:"Warning",value:s.localize(1962,null)};case $.Error:return{original:"Error",value:s.localize(1963,null)};case $.Off:return{original:"Off",value:s.localize(1964,null)}}}function T(v){switch(v){case"trace":return $.Trace;case"debug":return $.Debug;case"info":return $.Info;case"warn":return $.Warning;case"error":return $.Error;case"critical":return $.Error;case"off":return $.Off}}e.$vk=new g.$Zj("logLevel",S($.Info))}),define(Re[228],Ce([1,0,18,7,12,4,31,3,16,71,11]),function(ge,e,s,h,R,A,O,C,m,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=void 0;class E extends C.$Xc{constructor(P,b){super(),this.a=P,this.b=b,this.c=this.B(new A.$oe),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$oe),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new h.$Gh(0)),this.w=[],this.y=this.B(new h.$Gh(0))}watch(P,b){return b.recursive||this.b?.watcher?.forceUniversal?this.n(P,b):this.z(P,b)}n(P,b){const a={path:this.J(P),excludes:b.excludes,includes:b.includes,recursive:b.recursive,filter:b.filter,correlationId:b.correlationId},$=(0,s.$Vb)(this.j,a);return this.r(),(0,C.$Vc)(()=>{$(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(P=>(0,R.$2)(P))}s(){this.h||(this.h=this.B(this.t(b=>this.c.fire((0,c.$cr)(b)),b=>this.G(b),this.a.getLevel()===I.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===I.LogLevel.Trace)})));const P=this.b?.watcher?.recursive?.usePolling;if(P===!0)for(const b of this.j)(0,c.$$q)(b)&&(b.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(P))for(const b of this.j)(0,c.$$q)(b)&&P.includes(b.path)&&(b.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(P,b){const a={path:this.J(P),excludes:b.excludes,includes:b.includes,recursive:!1,filter:b.filter,correlationId:b.correlationId},$=(0,s.$Vb)(this.w,a);return this.C(),(0,C.$Vc)(()=>{$(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(P=>(0,R.$2)(P))}D(){return this.u||(this.u=this.B(this.F(P=>this.c.fire((0,c.$cr)(P)),P=>this.G(P),this.a.getLevel()===I.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===I.LogLevel.Trace)}))),this.u.watch(this.w)}G(P){P.type==="error"&&this.g.fire(P.message),this.H(P)}H(P){this.a[P.type](P.message)}I(P){return(0,m.$kc)(P.fsPath)}J(P){const b=this.I(P);return(0,O.$Kg)(b)}}e.$ir=E}),define(Re[229],Ce([1,0,45,7,28,21,4,31,3,16,10,22,105,33,8,27,221,228,226,225]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P,b,a,$,p,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=void 0;class o extends p.$ir{static{this.L=!1}constructor(n,r){super(n,r),this.onDidChangeCapabilities=O.Event.None,this.P=new R.$Dc(d=>E.$ah.getComparisonKey(d)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=a.FileSystemProviderCapabilities.FileReadWrite|a.FileSystemProviderCapabilities.FileOpenReadWriteClose|a.FileSystemProviderCapabilities.FileReadStream|a.FileSystemProviderCapabilities.FileFolderCopy|a.FileSystemProviderCapabilities.FileWriteUnlock|a.FileSystemProviderCapabilities.FileAtomicRead|a.FileSystemProviderCapabilities.FileAtomicWrite|a.FileSystemProviderCapabilities.FileAtomicDelete|a.FileSystemProviderCapabilities.FileClone,I.$l&&(this.M|=a.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(n){try{const{stat:r,symbolicLink:d}=await P.SymlinkSupport.stat(this.I(n));return{type:this.O(r,d),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size,permissions:r.mode&128?void 0:a.FilePermission.Locked}}catch(r){throw this.hb(r)}}async N(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const r=await P.Promises.readdir(this.I(n),{withFileTypes:!0}),d=[];return await Promise.all(r.map(async l=>{try{let f;l.isSymbolicLink()?f=(await this.stat((0,E.$jh)(n,l.name))).type:f=this.O(l),d.push([l.name,f])}catch(f){this.a.trace(f)}})),d}catch(r){throw this.hb(r)}}O(n,r){let d;return r?.dangling?d=a.FileType.Unknown:n.isFile()?d=a.FileType.File:n.isDirectory()?d=a.FileType.Directory:d=a.FileType.Unknown,r&&(d|=a.FileType.SymbolicLink),d}async Q(n){const r=this.I(n);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let d;for(;d=this.P.get(n);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await d.wait();const l=new h.$Hh;return this.P.set(n,l),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,m.$Vc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.P.get(n)===l&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.P.delete(n)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),l.open()})}async readFile(n,r){let d;try{r?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(n)})`),d=await this.Q(n));const l=this.I(n);return await s.promises.readFile(l)}catch(l){throw this.hb(l)}finally{d?.dispose()}}R(n){o.L&&this.a.trace(n)}readFileStream(n,r,d){const l=(0,g.$Ee)(f=>A.$Qe.concat(f.map(y=>A.$Qe.wrap(y))).buffer);return(0,$.$8q)(this,n,l,f=>f.buffer,{...r,bufferSize:256*1024},d),l}async writeFile(n,r,d){return d?.atomic!==!1&&d?.atomic?.postfix&&await this.S(n)?this.U(n,(0,E.$jh)((0,E.$ih)(n),`${(0,E.$gh)(n)}${d.atomic.postfix}`),r,d):this.W(n,r,d)}async S(n){try{const r=this.I(n),{symbolicLink:d}=await P.SymlinkSupport.stat(r);if(d)return!1}catch{}return!0}async U(n,r,d,l){const f=new m.$Wc;try{f.add(await this.Q(n)),f.add(await this.Q(r)),await this.W(r,d,l,!0);try{await this.rename(r,n,{overwrite:!0})}catch(y){try{await this.delete(r,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw y}}finally{f.dispose()}}async W(n,r,d,l){let f;try{const y=this.I(n);if(!d.create||!d.overwrite){if(await P.Promises.exists(y)){if(!d.overwrite)throw(0,a.$ql)((0,b.localize)(1901,null),a.FileSystemProviderErrorCode.FileExists)}else if(!d.create)throw(0,a.$ql)((0,b.localize)(1902,null),a.FileSystemProviderErrorCode.FileNotFound)}f=await this.open(n,{create:!0,unlock:d.unlock},l),await this.write(f,0,r,0,r.byteLength)}catch(y){throw await this.ib(n,y)}finally{typeof f=="number"&&await this.close(f)}}static{this.$=!0}static configureFlushOnWrite(n){o.$=n}async open(n,r,d){const l=this.I(n);let f;(0,a.$el)(r)&&!d&&(f=await this.Q(n));let y;try{if((0,a.$el)(r)&&r.unlock)try{const{stat:S}=await P.SymlinkSupport.stat(l);S.mode&128||await s.promises.chmod(l,S.mode|128)}catch(S){S.code!=="ENOENT"&&this.a.trace(S)}let k;if((0,a.$el)(r)){if(I.$j)try{await s.promises.truncate(l,0),k="r+"}catch(S){S.code!=="ENOENT"&&this.a.trace(S)}k||(k="w")}else k="r";y=await P.Promises.open(l,k)}catch(k){throw f?.dispose(),(0,a.$el)(r)?await this.ib(n,k):this.hb(k)}if(this.X.set(y,0),(0,a.$el)(r)&&this.Z.set(y,n),f){const k=this.Y.get(y);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${y} (${l})`),this.Y.set(y,f),k&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${y} (${l})`),k.dispose())}return y}async close(n){const r=this.Y.get(n);try{if(this.X.delete(n),this.Z.delete(n)&&o.$)try{await P.Promises.fdatasync(n)}catch(d){o.configureFlushOnWrite(!1),this.a.error(d)}return await P.Promises.close(n)}catch(d){throw this.hb(d)}finally{r&&(this.Y.get(n)===r&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.Y.delete(n)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),r.dispose())}}async read(n,r,d,l,f){const y=this.ab(n,r);let k=null;try{k=(await P.Promises.read(n,d,l,f,y)).bytesRead}catch(S){throw this.hb(S)}finally{this.bb(n,y,k)}return k}ab(n,r){return r===this.X.get(n)?null:r}bb(n,r,d){const l=this.X.get(n);typeof l=="number"&&(typeof r=="number"||(typeof d=="number"?this.X.set(n,l+d):this.X.delete(n)))}async write(n,r,d,l,f){return(0,h.$3h)(()=>this.cb(n,r,d,l,f),100,3)}async cb(n,r,d,l,f){const y=this.ab(n,r);let k=null;try{k=(await P.Promises.write(n,d,l,f,y)).bytesWritten}catch(S){throw await this.ib(this.Z.get(n),S)}finally{this.bb(n,y,k)}return k}async mkdir(n){try{await s.promises.mkdir(this.I(n))}catch(r){throw this.hb(r)}}async delete(n,r){try{const d=this.I(n);if(r.recursive){let l;r?.atomic!==!1&&r.atomic.postfix&&(l=(0,c.$mc)((0,c.$pc)(d),`${(0,c.$qc)(d)}${r.atomic.postfix}`)),await P.Promises.rm(d,P.RimRafMode.MOVE,l)}else try{await s.promises.unlink(d)}catch(l){if(l.code==="EPERM"||l.code==="EISDIR"){let f=!1;try{const{stat:y,symbolicLink:k}=await P.SymlinkSupport.stat(d);f=y.isDirectory()&&!k}catch{}if(f)await s.promises.rmdir(d);else throw l}else throw l}}catch(d){throw this.hb(d)}}async rename(n,r,d){const l=this.I(n),f=this.I(r);if(l!==f)try{await this.db(n,r,"move",d.overwrite),await P.Promises.rename(l,f)}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,b.localize)(1903,null,(0,c.$qc)(l),(0,c.$qc)((0,c.$pc)(f)),y.toString()))),this.hb(y)}}async copy(n,r,d){const l=this.I(n),f=this.I(r);if(l!==f)try{await this.db(n,r,"copy",d.overwrite),await P.Promises.copy(l,f,{preserveSymlinks:!0})}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,b.localize)(1904,null,(0,c.$qc)(l),(0,c.$qc)((0,c.$pc)(f)),y.toString()))),this.hb(y)}}async db(n,r,d,l){const f=this.I(n),y=this.I(r);let k=!1;if(!!(this.capabilities&a.FileSystemProviderCapabilities.PathCaseSensitive)||(k=(0,C.$Gg)(f,y,!0)),k){if(d==="copy")throw(0,a.$ql)((0,b.localize)(1905,null),a.FileSystemProviderErrorCode.FileExists);if(d==="move")return}const D=await this.N(n);if(!D)throw(0,a.$ql)((0,b.localize)(1906,null),a.FileSystemProviderErrorCode.FileNotFound);const T=await this.N(r);if(T){if(!l)throw(0,a.$ql)((0,b.localize)(1907,null),a.FileSystemProviderErrorCode.FileExists);D.type&a.FileType.File&&T.type&a.FileType.File||await this.delete(r,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,r){return this.eb(n,r,!1)}async eb(n,r,d){const l=this.I(n),f=this.I(r),y=!!(this.capabilities&a.FileSystemProviderCapabilities.PathCaseSensitive);if((0,C.$Gg)(l,f,!y))return;const k=new m.$Wc;try{k.add(await this.Q(n)),k.add(await this.Q(r)),d&&await s.promises.mkdir((0,c.$pc)(f),{recursive:!0}),await s.promises.copyFile(l,f)}catch(S){if(S.code==="ENOENT"&&!d)return this.eb(n,r,!0);throw this.hb(S)}finally{k.dispose()}}t(n,r,d){return new u.$pr(l=>n(l),l=>r(l),d)}F(n,r,d){return new i.$yr(l=>n(l),l=>r(l),d)}hb(n){if(n instanceof a.$pl)return n;let r=n,d;switch(n.code){case"ENOENT":d=a.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":d=a.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":d=a.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":d=a.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":d=a.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":r=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,d=a.FileSystemProviderErrorCode.Unknown;break;default:d=a.FileSystemProviderErrorCode.Unknown}return(0,a.$ql)(r,d)}async ib(n,r){let d=this.hb(r);if(n&&d.code===a.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await P.SymlinkSupport.stat(this.I(n));l.mode&128||(d=(0,a.$ql)(r,a.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return d}}e.$zr=o}),define(Re[230],Ce([1,0,3,11]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4R=void 0;class R extends s.$Xc{constructor(O,C=[]){super(),this.a=new h.$nk([O,...C]),this.B(O.onDidChangeLogLevel(m=>this.setLevel(m)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(O){this.a.setLevel(O)}getLevel(){return this.a.getLevel()}trace(O,...C){this.a.trace(O,...C)}debug(O,...C){this.a.debug(O,...C)}info(O,...C){this.a.info(O,...C)}warn(O,...C){this.a.warn(O,...C)}error(O,...C){this.a.error(O,...C)}flush(){this.a.flush()}}e.$4R=R}),define(Re[231],Ce([1,0,27,11]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SR=void 0;var R;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(R||(R={}));async function A(c,I,E,g,P){try{const b=await new Promise(($,p)=>{ge(["@vscode/spdlog"],$,p)}).then(Ue);b.setFlushOn(R.Trace);const a=await b.createAsyncRotatingLogger(c,I,E,g);return P?a.clearFormatters():a.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),a}catch(b){console.error(b)}return null}function O(c,I,E){switch(I){case h.LogLevel.Trace:c.trace(E);break;case h.LogLevel.Debug:c.debug(E);break;case h.LogLevel.Info:c.info(E);break;case h.LogLevel.Warning:c.warn(E);break;case h.LogLevel.Error:c.error(E);break;case h.LogLevel.Off:break;default:throw new Error(`Invalid log level ${I}`)}}function C(c,I){switch(I){case h.LogLevel.Trace:c.setLevel(R.Trace);break;case h.LogLevel.Debug:c.setLevel(R.Debug);break;case h.LogLevel.Info:c.setLevel(R.Info);break;case h.LogLevel.Warning:c.setLevel(R.Warning);break;case h.LogLevel.Error:c.setLevel(R.Error);break;case h.LogLevel.Off:c.setLevel(R.Off);break;default:throw new Error(`Invalid log level ${I}`)}}class m extends h.$jk{constructor(I,E,g,P,b){super(),this.m=[],this.setLevel(b),this.n=this.s(I,E,g,P),this.B(this.onDidChangeLogLevel(a=>{this.r&&C(this.r,a)}))}async s(I,E,g,P){const b=g?6:1,a=30/b*s.$Ll.MB,$=await A(I,E,a,b,P);if($){this.r=$,C(this.r,this.getLevel());for(const{level:p,message:u}of this.m)O(this.r,p,u);this.m=[]}}g(I,E){this.r?O(this.r,I,E):this.getLevel()<=I&&this.m.push({level:I,message:E})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$SR=m});var Ht=this&&this.__importDefault||function(ge){return ge&&ge.__esModule?ge:{default:ge}};define(Re[147],Ce([1,0,44,8,5]),function(ge,e,s,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mu=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,s=Ht(s);var A;(function(m){m[m.Unnecessary=1]="Unnecessary",m[m.Deprecated=2]="Deprecated"})(A||(e.MarkerTag=A={}));var O;(function(m){m[m.Hint=1]="Hint",m[m.Info=2]="Info",m[m.Warning=4]="Warning",m[m.Error=8]="Error"})(O||(e.MarkerSeverity=O={})),function(m){function c(b,a){return a-b}m.compare=c;const I=Object.create(null);I[m.Error]=(0,h.localize)(1965,null),I[m.Warning]=(0,h.localize)(1966,null),I[m.Info]=(0,h.localize)(1967,null);function E(b){return I[b]||""}m.toString=E;function g(b){switch(b){case s.default.Error:return m.Error;case s.default.Warning:return m.Warning;case s.default.Info:return m.Info;case s.default.Ignore:return m.Hint}}m.fromSeverity=g;function P(b){switch(b){case m.Error:return s.default.Error;case m.Warning:return s.default.Warning;case m.Info:return s.default.Info;case m.Hint:return s.default.Ignore}}m.toSeverity=P}(O||(e.MarkerSeverity=O={}));var C;(function(m){const c="";function I(g){return E(g,!0)}m.makeKey=I;function E(g,P){const b=[c];return g.source?b.push(g.source.replace("\xA6","\\\xA6")):b.push(c),g.code?typeof g.code=="string"?b.push(g.code.replace("\xA6","\\\xA6")):b.push(g.code.value.replace("\xA6","\\\xA6")):b.push(c),g.severity!==void 0&&g.severity!==null?b.push(O.toString(g.severity)):b.push(c),g.message&&P?b.push(g.message.replace("\xA6","\\\xA6")):b.push(c),g.startLineNumber!==void 0&&g.startLineNumber!==null?b.push(g.startLineNumber.toString()):b.push(c),g.startColumn!==void 0&&g.startColumn!==null?b.push(g.startColumn.toString()):b.push(c),g.endLineNumber!==void 0&&g.endLineNumber!==null?b.push(g.endLineNumber.toString()):b.push(c),g.endColumn!==void 0&&g.endColumn!==null?b.push(g.endColumn.toString()):b.push(c),b.push(c),b.join("\xA6")}m.makeKeyOptionalMessage=E})(C||(e.IMarkerData=C={})),e.$Mu=(0,R.$Ii)("markerService")});var Ht=this&&this.__importDefault||function(ge){return ge&&ge.__esModule?ge:{default:ge}};define(Re[232],Ce([1,0,4,44,5]),function(ge,e,s,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dw=e.$Cw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Aw=e.Severity=void 0,e.$Bw=C,h=Ht(h),e.Severity=h.default,e.$Aw=(0,R.$Ii)("notificationService");var A;(function(E){E[E.DEFAULT=0]="DEFAULT",E[E.SILENT=1]="SILENT",E[E.URGENT=2]="URGENT"})(A||(e.NotificationPriority=A={}));var O;(function(E){E[E.WORKSPACE=0]="WORKSPACE",E[E.PROFILE=1]="PROFILE",E[E.APPLICATION=2]="APPLICATION"})(O||(e.NeverShowAgainScope=O={}));function C(E){if(E){const g=E;return typeof g.id=="string"&&typeof g.label=="string"}return!1}var m;(function(E){E[E.OFF=0]="OFF",E[E.ERROR=1]="ERROR"})(m||(e.NotificationsFilter=m={}));class c{constructor(){this.progress=new I,this.onDidClose=s.Event.None,this.onDidChangeVisibility=s.Event.None}updateSeverity(g){}updateMessage(g){}updateActions(g){}close(){}}e.$Cw=c;class I{infinite(){}done(){}total(g){}worked(g){}}e.$Dw=I}),define(Re[233],Ce([1,0,55]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let h;const R=globalThis.vscode;if(typeof R<"u"&&typeof R.context<"u"){const A=R.context.configuration();if(A)h=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(h=globalThis._VSCODE_PRODUCT_JSON,s.env.VSCODE_DEV&&Object.assign(h,{nameShort:`${h.nameShort} Dev`,nameLong:`${h.nameLong} Dev`,dataFolderName:`${h.dataFolderName}-dev`,serverDataFolderName:h.serverDataFolderName?`${h.serverDataFolderName}-dev`:void 0}),!h.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(h,{version:A.version})}}else h={},Object.keys(h).length===0&&Object.assign(h,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=h}),define(Re[115],Ce([1,0,5]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=e.$wk=void 0,e.$wk=(0,s.$Ii)("productService"),e.$xk="vscode://schemas/vscode-product"});var qe=this&&this.__param||function(ge,e){return function(s,h){e(s,h,ge)}};define(Re[90],Ce([1,0,7,20,3,5]),function(ge,e,s,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kw=e.$Jw=e.$Iw=e.$Hw=e.$Gw=e.$Fw=e.ProgressLocation=e.$Ew=void 0,e.$Ew=(0,A.$Ii)("progressService");var O;(function(E){E[E.Explorer=1]="Explorer",E[E.Scm=3]="Scm",E[E.Extensions=5]="Extensions",E[E.Window=10]="Window",E[E.Notification=15]="Notification",E[E.Dialog=20]="Dialog"})(O||(e.ProgressLocation=O={})),e.$Fw=Object.freeze({total(){},worked(){},done(){}});class C{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(g){this.b=g}report(g){this.a=g,this.b(this.a)}}e.$Gw=C;class m{get value(){return this.a}constructor(g){this.e=g}report(g){this.b?this.b.push(g):this.b=[g],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const g=this.b.shift();this.a=g,await this.e(this.a)}}finally{this.c=!1;const g=this.d;this.d=void 0,g?.()}}drain(){return this.c?new Promise(g=>{const P=this.d;this.d=()=>{P?.(),g()}}):Promise.resolve()}}e.$Hw=m;let c=class extends R.$Xc{constructor(g,P){super(),this.a=new s.$6h,P.withProgress(g,b=>(this.b=b,this.c&&b.report(this.c),this.a.p)),this.B((0,R.$Vc)(()=>this.a.complete()))}report(g){this.b?this.b.report(g):this.c=g}};e.$Iw=c,e.$Iw=c=Ze([qe(1,e.$Ew)],c);class I extends R.$Xc{constructor(g){super(),this.g=g,this.a=0,this.b=this.B(new R.$Wc)}start(g){this.stop();const P=++this.a,b=new h.$ze;return this.f=setTimeout(()=>{P===this.a&&(this.c=this.g.show(!0))},g),this.b.add((0,R.$Vc)(()=>clearTimeout(this.f))),this.b.add((0,R.$Vc)(()=>b.cancel())),this.b.add((0,R.$Vc)(()=>this.c?this.c.done():void 0)),{id:P,token:b.token,stop:()=>this.h(P),isCurrent:()=>this.a===P}}stop(){this.h(this.a)}h(g){this.a===g&&this.b.clear()}}e.$Jw=I,e.$Kw=(0,A.$Ii)("editorProgressService")}),define(Re[37],Ce([1,0,67,17]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vo=void 0,s=Ue(s),h=Ue(h);class R{constructor(){this.a=new Map}add(O,C){s.ok(h.$hg(O)),s.ok(h.$jg(C)),s.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,C)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.$vo=new R}),define(Re[116],Ce([1,0,4,180,37]),function(ge,e,s,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=void 0,R=Ue(R),e.$wo={JSONContribution:"base.contributions.json"};function A(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class O{constructor(){this.b=new s.$oe,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(c,I){this.a[A(c)]=I,this.b.fire(c)}notifySchemaChanged(c){this.b.fire(c)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(c){const I=this.a[c];return I?(0,h.$$j)(I):void 0}hasSchemaContent(c){return!!this.a[c]}}const C=new O;R.$vo.add(e.$wo.JSONContribution,C)}),define(Re[72],Ce([1,0,18,4,17,8,46,116,37]),function(ge,e,s,h,R,A,O,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.ConfigurationScope=e.$Ao=e.EditPresentationTypes=void 0,e.$Lo=a,e.$Mo=$,e.$No=p,e.$Oo=i,e.$Po=o,e.$Qo=t,e.$Ro=n,R=Ue(R),A=Ue(A);var c;(function(r){r.Multiline="multilineText",r.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$Ao={Configuration:"base.contributions.configuration"};var I;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.MACHINE=2]="MACHINE",r[r.WINDOW=3]="WINDOW",r[r.RESOURCE=4]="RESOURCE",r[r.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",r[r.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I||(e.ConfigurationScope=I={})),e.$Bo={properties:{},patternProperties:{}},e.$Co={properties:{},patternProperties:{}},e.$Do={properties:{},patternProperties:{}},e.$Eo={properties:{},patternProperties:{}},e.$Fo={properties:{},patternProperties:{}},e.$Go={properties:{},patternProperties:{}},e.$Ho="vscode://schemas/settings/resourceLanguage",e.$Io="vscode://schemas/settings/configurationDefaults";const E=m.$vo.as(C.$wo.JSONContribution);class g{constructor(){this.a=[],this.i=new Set,this.j=new h.$oe,this.onDidSchemaChange=this.j.event,this.k=new h.$oe,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:A.localize(1662,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},E.registerSchema(e.$Ho,this.h),this.z()}registerConfiguration(d,l=!0){this.registerConfigurations([d],l)}registerConfigurations(d,l=!0){const f=new Set;this.r(d,l,f),E.registerSchema(e.$Ho,this.h),this.j.fire(),this.k.fire({properties:f})}deregisterConfigurations(d){const l=new Set;this.s(d,l),E.registerSchema(e.$Ho,this.h),this.j.fire(),this.k.fire({properties:l})}updateConfigurations({add:d,remove:l}){const f=new Set;this.s(l,f),this.r(d,!1,f),E.registerSchema(e.$Ho,this.h),this.j.fire(),this.k.fire({properties:f})}registerDefaultConfigurations(d){const l=new Set;this.l(d,l),this.j.fire(),this.k.fire({properties:l,defaultsOverrides:!0})}l(d,l){this.a.push(...d);const f=[];for(const{overrides:y,source:k}of d)for(const S in y){l.add(S);const D=this.b.get(S)??this.b.set(S,{configurationDefaultOverrides:[]}).get(S),T=y[S];if(D.configurationDefaultOverrides.push({value:T,source:k}),e.$Ko.test(S)){const v=this.o(S,T,k,D.configurationDefaultOverrideValue);if(!v)continue;D.configurationDefaultOverrideValue=v,this.n(S,v,k),f.push(...a(S))}else{const v=this.p(S,T,k,D.configurationDefaultOverrideValue);if(!v)continue;D.configurationDefaultOverrideValue=v;const w=this.e[S];w&&(this.A(S,w),this.w(S,w))}}this.q(f)}deregisterDefaultConfigurations(d){const l=new Set;this.m(d,l),this.j.fire(),this.k.fire({properties:l,defaultsOverrides:!0})}m(d,l){for(const f of d){const y=this.a.indexOf(f);y!==-1&&this.a.splice(y,1)}for(const{overrides:f,source:y}of d)for(const k in f){const S=this.b.get(k);if(!S)continue;const D=S.configurationDefaultOverrides.findIndex(T=>y?T.source?.id===y.id:T.value===f[k]);if(D!==-1){if(S.configurationDefaultOverrides.splice(D,1),S.configurationDefaultOverrides.length===0&&this.b.delete(k),e.$Ko.test(k)){let T;for(const v of S.configurationDefaultOverrides)T=this.o(k,v.value,v.source,T);T&&!R.$ug(T.value)?(S.configurationDefaultOverrideValue=T,this.n(k,T,y)):(this.b.delete(k),delete this.e[k],delete this.c.properties[k])}else{let T;for(const w of S.configurationDefaultOverrides)T=this.p(k,w.value,w.source,T);S.configurationDefaultOverrideValue=T;const v=this.e[k];v&&(this.A(k,v),this.w(k,v))}l.add(k)}}this.y()}n(d,l,f){const y={type:"object",default:l.value,description:A.localize(1663,null,(0,O.$mj)(d)),$ref:e.$Ho,defaultDefaultValue:l.value,source:f,defaultValueSource:f};this.e[d]=y,this.c.properties[d]=y}o(d,l,f,y){const k=y?.value||{},S=y?.source??new Map;if(!(S instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const D of Object.keys(l)){const T=l[D];if(R.$jg(T)&&(R.$og(k[D])||R.$jg(k[D]))){if(k[D]={...k[D]??{},...T},f)for(const w in T)S.set(`${D}.${w}`,f)}else k[D]=T,f?S.set(D,f):S.delete(D)}return{value:k,source:S}}p(d,l,f,y){const k=this.e[d],S=y?.value??k?.defaultDefaultValue;let D=f;if(R.$jg(l)&&(k!==void 0&&k.type==="object"||k===void 0&&(R.$og(S)||R.$jg(S)))){if(D=y?.source??new Map,!(D instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const v in l)f&&D.set(`${d}.${v}`,f);l={...R.$jg(S)?S:{},...l}}return{value:l,source:D}}deltaConfiguration(d){let l=!1;const f=new Set;d.removedDefaults&&(this.m(d.removedDefaults,f),l=!0),d.addedDefaults&&(this.l(d.addedDefaults,f),l=!0),d.removedConfigurations&&this.s(d.removedConfigurations,f),d.addedConfigurations&&this.r(d.addedConfigurations,!1,f),this.j.fire(),this.k.fire({properties:f,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...d){this.j.fire()}registerOverrideIdentifiers(d){this.q(d),this.j.fire()}q(d){for(const l of d)this.i.add(l);this.y()}r(d,l,f){d.forEach(y=>{this.u(y,l,y.extensionInfo,y.restrictedProperties,void 0,f),this.d.push(y),this.v(y)})}s(d,l){const f=y=>{if(y.properties)for(const k in y.properties){l.add(k);const S=this.e[k];S?.policy?.name&&this.f.delete(S.policy.name),delete this.e[k],this.x(k,y.properties[k])}y.allOf?.forEach(k=>f(k))};for(const y of d){f(y);const k=this.d.indexOf(y);k!==-1&&this.d.splice(k,1)}}u(d,l=!0,f,y,k=I.WINDOW,S){k=R.$qg(d.scope)?k:d.scope;const D=d.properties;if(D)for(const v in D){const w=D[v];if(l&&i(v,w)){delete D[v];continue}if(w.source=f,w.defaultDefaultValue=D[v].default,this.A(v,w),e.$Ko.test(v)?w.scope=void 0:(w.scope=R.$qg(w.scope)?k:w.scope,w.restricted=R.$qg(w.restricted)?!!y?.includes(v):w.restricted),D[v].hasOwnProperty("included")&&!D[v].included){this.g[v]=D[v],delete D[v];continue}else this.e[v]=D[v],D[v].policy?.name&&this.f.set(D[v].policy.name,v);!D[v].deprecationMessage&&D[v].markdownDeprecationMessage&&(D[v].deprecationMessage=D[v].markdownDeprecationMessage),S.add(v)}const T=d.allOf;if(T)for(const v of T)this.u(v,l,f,y,k,S)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const d=new Map;for(const[l,f]of this.b)f.configurationDefaultOverrideValue&&d.set(l,f.configurationDefaultOverrideValue);return d}v(d){const l=f=>{const y=f.properties;if(y)for(const S in y)this.w(S,y[S]);f.allOf?.forEach(l)};l(d)}w(d,l){switch(e.$Bo.properties[d]=l,l.scope){case I.APPLICATION:e.$Co.properties[d]=l;break;case I.MACHINE:e.$Do.properties[d]=l;break;case I.MACHINE_OVERRIDABLE:e.$Eo.properties[d]=l;break;case I.WINDOW:e.$Fo.properties[d]=l;break;case I.RESOURCE:e.$Go.properties[d]=l;break;case I.LANGUAGE_OVERRIDABLE:e.$Go.properties[d]=l,this.h.properties[d]=l;break}}x(d,l){switch(delete e.$Bo.properties[d],l.scope){case I.APPLICATION:delete e.$Co.properties[d];break;case I.MACHINE:delete e.$Do.properties[d];break;case I.MACHINE_OVERRIDABLE:delete e.$Eo.properties[d];break;case I.WINDOW:delete e.$Fo.properties[d];break;case I.RESOURCE:case I.LANGUAGE_OVERRIDABLE:delete e.$Go.properties[d],delete this.h.properties[d];break}}y(){for(const d of this.i.values()){const l=`[${d}]`,f={type:"object",description:A.localize(1664,null),errorMessage:A.localize(1665,null),$ref:e.$Ho};this.A(l,f),e.$Bo.properties[l]=f,e.$Co.properties[l]=f,e.$Do.properties[l]=f,e.$Eo.properties[l]=f,e.$Fo.properties[l]=f,e.$Go.properties[l]=f}}z(){const d={type:"object",description:A.localize(1666,null),errorMessage:A.localize(1667,null),$ref:e.$Ho};e.$Bo.patternProperties[e.$Jo]=d,e.$Co.patternProperties[e.$Jo]=d,e.$Do.patternProperties[e.$Jo]=d,e.$Eo.patternProperties[e.$Jo]=d,e.$Fo.patternProperties[e.$Jo]=d,e.$Go.patternProperties[e.$Jo]=d,this.j.fire()}A(d,l){const f=this.b.get(d)?.configurationDefaultOverrideValue;let y,k;f&&(!l.disallowConfigurationDefault||!f.source)&&(y=f.value,k=f.source),R.$og(y)&&(y=l.defaultDefaultValue,k=void 0),R.$og(y)&&(y=p(l.type)),l.default=y,l.defaultValueSource=k}}const P="\\[([^\\]]+)\\]",b=new RegExp(P,"g");e.$Jo=`^(${P})+$`,e.$Ko=new RegExp(e.$Jo);function a(r){const d=[];if(e.$Ko.test(r)){let l=b.exec(r);for(;l?.length;){const f=l[1].trim();f&&d.push(f),l=b.exec(r)}}return(0,s.$Ob)(d)}function $(r){return r.reduce((d,l)=>`${d}[${l}]`,"")}function p(r){switch(Array.isArray(r)?r[0]:r){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const u=new g;m.$vo.add(e.$Ao.Configuration,u);function i(r,d){return r.trim()?e.$Ko.test(r)?A.localize(1669,null,r):u.getConfigurationProperties()[r]!==void 0?A.localize(1670,null,r):d.policy?.name&&u.getPolicyConfigurations().get(d.policy?.name)!==void 0?A.localize(1671,null,r,d.policy?.name,u.getPolicyConfigurations().get(d.policy?.name)):null:A.localize(1668,null)}function o(){const r=[],d=u.getConfigurationProperties();for(const l of Object.keys(d))r.push([l,d[l].scope]);return r.push(["launch",I.RESOURCE]),r.push(["task",I.RESOURCE]),r}function t(r){const d={};for(const l of r){const f=l.properties;if(R.$jg(f))for(const y in f)d[y]=f[y];l.allOf&&Object.assign(d,t(l.allOf))}return d}function n(r){switch(r){case"application":return I.APPLICATION;case"machine":return I.MACHINE;case"resource":return I.RESOURCE;case"machine-overridable":return I.MACHINE_OVERRIDABLE;case"language-overridable":return I.LANGUAGE_OVERRIDABLE;default:return I.WINDOW}}}),define(Re[234],Ce([1,0,18,4,179,3,28,24,17,2,46,72,27,37]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Vo=e.$Uo=e.$To=e.$So=void 0,e.$Wo=o,s=Ue(s),R=Ue(R),C=Ue(C),m=Ue(m);function b(d){return Object.isFrozen(d)?d:C.$jo(d)}class a{static createEmptyModel(l){return new a({},[],[],void 0,l)}constructor(l,f,y,k,S){this.b=l,this.c=f,this.d=y,this.raw=k,this.f=S,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const l=this.raw.map(f=>{if(f instanceof a)return f;const y=new $("",this.f);return y.parseRaw(f),y.configurationModel});this.g=l.reduce((f,y)=>y===f?y:f.merge(y),l[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(l){return l?(0,I.$kj)(this.contents,l):this.contents}inspect(l,f){const y=this;return{get value(){return b(y.rawConfiguration.getValue(l))},get override(){return f?b(y.rawConfiguration.getOverrideValue(l,f)):void 0},get merged(){return b(f?y.rawConfiguration.override(f).getValue(l):y.rawConfiguration.getValue(l))},get overrides(){const k=[];for(const{contents:S,identifiers:D,keys:T}of y.rawConfiguration.overrides){const v=new a(S,T,[],void 0,y.f).getValue(l);v!==void 0&&k.push({identifiers:D,value:v})}return k.length?b(k):void 0}}}getOverrideValue(l,f){const y=this.j(f);return y?l?(0,I.$kj)(y,l):y:void 0}getKeysForOverrideIdentifier(l){const f=[];for(const y of this.overrides)y.identifiers.includes(l)&&f.push(...y.keys);return s.$Ob(f)}getAllOverrideIdentifiers(){const l=[];for(const f of this.overrides)l.push(...f.identifiers);return s.$Ob(l)}override(l){let f=this.a.get(l);return f||(f=this.h(l),this.a.set(l,f)),f}merge(...l){const f=C.$io(this.contents),y=C.$io(this.overrides),k=[...this.keys],S=this.raw?.length?[...this.raw]:[this];for(const D of l)if(S.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.i(f,D.contents);for(const T of D.overrides){const[v]=y.filter(w=>s.$wb(w.identifiers,T.identifiers));v?(this.i(v.contents,T.contents),v.keys.push(...T.keys),v.keys=s.$Ob(v.keys)):y.push(C.$io(T))}for(const T of D.keys)k.indexOf(T)===-1&&k.push(T)}return new a(f,k,y,S.every(D=>D instanceof a)?void 0:S,this.f)}h(l){const f=this.j(l);if(!f||typeof f!="object"||!Object.keys(f).length)return this;const y={};for(const k of s.$Ob([...Object.keys(this.contents),...Object.keys(f)])){let S=this.contents[k];const D=f[k];D&&(typeof S=="object"&&typeof D=="object"?(S=C.$io(S),this.i(S,D)):S=D),y[k]=S}return new a(y,this.keys,this.overrides,void 0,this.f)}i(l,f){for(const y of Object.keys(f)){if(y in l&&m.$jg(l[y])&&m.$jg(f[y])){this.i(l[y],f[y]);continue}l[y]=C.$io(f[y])}}j(l){let f=null,y=null;const k=S=>{S&&(y?this.i(y,S):y=C.$io(S))};for(const S of this.overrides)S.identifiers.length===1&&S.identifiers[0]===l?f=S.contents:S.identifiers.includes(l)&&k(S.contents);return k(f),y}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(l,f){this.k(l,f,!0)}setValue(l,f){this.k(l,f,!1)}removeValue(l){const f=this.keys.indexOf(l);f!==-1&&(this.keys.splice(f,1),(0,I.$jj)(this.contents,l),E.$Ko.test(l)&&this.overrides.splice(this.overrides.findIndex(y=>s.$wb(y.identifiers,(0,E.$Lo)(l))),1))}k(l,f,y){if((0,I.$ij)(this.contents,l,f,k=>this.f.error(k)),y=y||this.keys.indexOf(l)===-1,y&&this.keys.push(l),E.$Ko.test(l)){const k=(0,E.$Lo)(l),S={identifiers:k,keys:Object.keys(this.contents[l]),contents:(0,I.$hj)(this.contents[l],T=>this.f.error(T))},D=this.overrides.findIndex(T=>s.$wb(T.identifiers,k));D!==-1?this.overrides[D]=S:this.overrides.push(S)}}}e.$So=a;class ${constructor(l,f){this.f=l,this.g=f,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||a.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(l,f){if(!m.$qg(l)){const y=this.h(l);this.parseRaw(y,f)}}reparse(l){this.a&&this.parseRaw(this.a,l)}parseRaw(l,f){this.a=l;const{contents:y,keys:k,overrides:S,restricted:D,hasExcludedProperties:T}=this.i(l,f);this.b=new a(y,k,S,T?[l]:void 0,this.g),this.c=D||[]}h(l){let f={},y=null,k=[];const S=[],D=[];function T(w){Array.isArray(k)?k.push(w):y!==null&&(k[y]=w)}const v={onObjectBegin:()=>{const w={};T(w),S.push(k),k=w,y=null},onObjectProperty:w=>{y=w},onObjectEnd:()=>{k=S.pop()},onArrayBegin:()=>{const w=[];T(w),S.push(k),k=w,y=null},onArrayEnd:()=>{k=S.pop()},onLiteralValue:T,onError:(w,M,L)=>{D.push({error:w,offset:M,length:L})}};if(l)try{R.$0n(l,v),f=k[0]||{}}catch(w){this.g.error(`Error while parsing settings file ${this.f}: ${w}`),this.d=[w]}return f}i(l,f){const y=P.$vo.as(E.$Ao.Configuration).getConfigurationProperties(),k=this.j(l,y,!0,f);l=k.raw;const S=(0,I.$hj)(l,v=>this.g.error(`Conflict in settings file ${this.f}: ${v}`)),D=Object.keys(l),T=this.l(l,v=>this.g.error(`Conflict in settings file ${this.f}: ${v}`));return{contents:S,keys:D,overrides:T,restricted:k.restricted,hasExcludedProperties:k.hasExcludedProperties}}j(l,f,y,k){let S=!1;if(!k?.scopes&&!k?.skipRestricted&&!k?.exclude?.length)return{raw:l,restricted:[],hasExcludedProperties:S};const D={},T=[];for(const v in l)if(E.$Ko.test(v)&&y){const w=this.j(l[v],f,!1,k);D[v]=w.raw,S=S||w.hasExcludedProperties,T.push(...w.restricted)}else{const w=f[v],M=w?typeof w.scope<"u"?w.scope:E.ConfigurationScope.WINDOW:void 0;w?.restricted&&T.push(v),!k.exclude?.includes(v)&&(k.include?.includes(v)||(M===void 0||k.scopes===void 0||k.scopes.includes(M))&&!(k.skipRestricted&&w?.restricted))?D[v]=l[v]:S=!0}return{raw:D,restricted:T,hasExcludedProperties:S}}l(l,f){const y=[];for(const k of Object.keys(l))if(E.$Ko.test(k)){const S={};for(const D in l[k])S[D]=l[k][D];y.push({identifiers:(0,E.$Lo)(k),keys:Object.keys(S),contents:(0,I.$hj)(S,f)})}return y}}e.$To=$;class p extends A.$Xc{constructor(l,f,y,k,S){super(),this.c=l,this.f=f,this.g=k,this.h=S,this.b=this.B(new h.$oe),this.onDidChange=this.b.event,this.a=new $(this.c.toString(),S),this.B(this.g.watch(y.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(h.Event.any(h.Event.filter(this.g.onDidFilesChange,D=>D.contains(this.c)),h.Event.filter(this.g.onDidRunOperation,D=>(D.isOperation(g.FileOperation.CREATE)||D.isOperation(g.FileOperation.COPY)||D.isOperation(g.FileOperation.DELETE)||D.isOperation(g.FileOperation.WRITE))&&y.isEqual(D.resource,l)))(()=>this.b.fire()))}async loadConfiguration(){try{const l=await this.g.readFile(this.c);return this.a.parse(l.value.toString()||"{}",this.f),this.a.configurationModel}catch{return a.createEmptyModel(this.h)}}reparse(l){return l&&(this.f=l),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Uo=p;class u{constructor(l,f,y,k,S,D,T,v,w,M,L,N,F){this.a=l,this.b=f,this.c=y,this.overrideIdentifiers=k,this.d=S,this.f=D,this.g=T,this.h=v,this.i=w,this.j=M,this.k=L,this.l=N,this.m=F}get value(){return b(this.c)}n(l){return l?.value!==void 0||l?.override!==void 0||l?.overrides!==void 0?l:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(l,f,y,k,S,D,T,v,w,M){this.j=l,this.l=f,this.m=y,this.n=k,this.p=S,this.q=D,this.r=T,this.s=v,this.t=w,this.u=M,this.h=null,this.i=new O.$Dc,this.v=null}getValue(l,f,y){return this.w(l,f,y).getValue(l)}updateValue(l,f,y={}){let k;y.resource?(k=this.t.get(y.resource),k||(k=a.createEmptyModel(this.u),this.t.set(y.resource,k))):k=this.s,f===void 0?k.removeValue(l):k.setValue(l,f),y.resource||(this.h=null)}inspect(l,f,y){const k=this.w(l,f,y),S=this.A(f.resource,y),D=f.resource?this.t.get(f.resource)||this.s:this.s,T=new Set;for(const v of k.overrides)for(const w of v.identifiers)k.getOverrideValue(l,w)!==void 0&&T.add(w);return new u(l,f,k.getValue(l),T.size?[...T]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,y?this.q:void 0,S||void 0,D)}keys(l){const f=this.A(void 0,l);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:f?f.keys.slice(0):[]}}updateDefaultConfiguration(l){this.j=l,this.h=null,this.i.clear()}updatePolicyConfiguration(l){this.l=l}updateApplicationConfiguration(l){this.m=l,this.h=null,this.i.clear()}updateLocalUserConfiguration(l){this.n=l,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(l){this.p=l,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(l){this.q=l,this.h=null,this.i.clear()}updateFolderConfiguration(l,f){this.r.set(l,f),this.i.delete(l)}deleteFolderConfiguration(l){this.folderConfigurations.delete(l),this.i.delete(l)}compareAndUpdateDefaultConfiguration(l,f){const y=[];if(!f){const{added:k,updated:S,removed:D}=n(this.j,l);f=[...k,...S,...D]}for(const k of f)for(const S of(0,E.$Lo)(k)){const D=this.j.getKeysForOverrideIdentifier(S),T=l.getKeysForOverrideIdentifier(S),v=[...T.filter(w=>D.indexOf(w)===-1),...D.filter(w=>T.indexOf(w)===-1),...D.filter(w=>!C.$mo(this.j.override(S).getValue(w),l.override(S).getValue(w)))];y.push([S,v])}return this.updateDefaultConfiguration(l),{keys:f,overrides:y}}compareAndUpdatePolicyConfiguration(l){const{added:f,updated:y,removed:k}=n(this.l,l),S=[...f,...y,...k];return S.length&&this.updatePolicyConfiguration(l),{keys:S,overrides:[]}}compareAndUpdateApplicationConfiguration(l){const{added:f,updated:y,removed:k,overrides:S}=n(this.applicationConfiguration,l),D=[...f,...y,...k];return D.length&&this.updateApplicationConfiguration(l),{keys:D,overrides:S}}compareAndUpdateLocalUserConfiguration(l){const{added:f,updated:y,removed:k,overrides:S}=n(this.localUserConfiguration,l),D=[...f,...y,...k];return D.length&&this.updateLocalUserConfiguration(l),{keys:D,overrides:S}}compareAndUpdateRemoteUserConfiguration(l){const{added:f,updated:y,removed:k,overrides:S}=n(this.remoteUserConfiguration,l),D=[...f,...y,...k];return D.length&&this.updateRemoteUserConfiguration(l),{keys:D,overrides:S}}compareAndUpdateWorkspaceConfiguration(l){const{added:f,updated:y,removed:k,overrides:S}=n(this.workspaceConfiguration,l),D=[...f,...y,...k];return D.length&&this.updateWorkspaceConfiguration(l),{keys:D,overrides:S}}compareAndUpdateFolderConfiguration(l,f){const y=this.folderConfigurations.get(l),{added:k,updated:S,removed:D,overrides:T}=n(y,f),v=[...k,...S,...D];return(v.length||!y)&&this.updateFolderConfiguration(l,f),{keys:v,overrides:T}}compareAndDeleteFolderConfiguration(l){const f=this.folderConfigurations.get(l);if(!f)throw new Error("Unknown folder");this.deleteFolderConfiguration(l);const{added:y,updated:k,removed:S,overrides:D}=n(f,void 0);return{keys:[...y,...k,...S],overrides:D}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(l,f,y){let k=this.x(f,y);return f.overrideIdentifier&&(k=k.override(f.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(l)!==void 0&&(k=k.merge(this.l)),k}x({resource:l},f){let y=this.y();if(f&&l){const k=f.getFolder(l);k&&(y=this.z(k.uri)||y);const S=this.t.get(l);S&&(y=y.merge(S))}return y}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(l){let f=this.i.get(l);if(!f){const y=this.y(),k=this.r.get(l);k?(f=y.merge(k),this.i.set(l,f)):f=y}return f}A(l,f){if(f&&l){const y=f.getFolder(l);if(y)return this.r.get(y.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((l,f)=>{const{contents:y,overrides:k,keys:S}=this.r.get(f);return l.push([f,{contents:y,overrides:k,keys:S}]),l},[])}}allKeys(){const l=new Set;return this.j.keys.forEach(f=>l.add(f)),this.userConfiguration.keys.forEach(f=>l.add(f)),this.q.keys.forEach(f=>l.add(f)),this.r.forEach(f=>f.keys.forEach(y=>l.add(y))),[...l.values()]}B(){const l=new Set;return this.j.getAllOverrideIdentifiers().forEach(f=>l.add(f)),this.userConfiguration.getAllOverrideIdentifiers().forEach(f=>l.add(f)),this.q.getAllOverrideIdentifiers().forEach(f=>l.add(f)),this.r.forEach(f=>f.getAllOverrideIdentifiers().forEach(y=>l.add(y))),[...l.values()]}D(l){const f=new Set;return this.j.getKeysForOverrideIdentifier(l).forEach(y=>f.add(y)),this.userConfiguration.getKeysForOverrideIdentifier(l).forEach(y=>f.add(y)),this.q.getKeysForOverrideIdentifier(l).forEach(y=>f.add(y)),this.r.forEach(y=>y.getKeysForOverrideIdentifier(l).forEach(k=>f.add(k))),[...f.values()]}static parse(l,f){const y=this.E(l.defaults,f),k=this.E(l.policy,f),S=this.E(l.application,f),D=this.E(l.user,f),T=this.E(l.workspace,f),v=l.folders.reduce((w,M)=>(w.set(c.URI.revive(M[0]),this.E(M[1],f)),w),new O.$Dc);return new i(y,k,S,D,a.createEmptyModel(f),T,v,a.createEmptyModel(f),new O.$Dc,f)}static E(l,f){return new a(l.contents,l.keys,l.overrides,void 0,f)}}e.$Vo=i;function o(...d){if(d.length===0)return{keys:[],overrides:[]};if(d.length===1)return d[0];const l=new Set,f=new Map;for(const k of d)k.keys.forEach(S=>l.add(S)),k.overrides.forEach(([S,D])=>{const T=(0,O.$Ac)(f,S,new Set);D.forEach(v=>T.add(v))});const y=[];return f.forEach((k,S)=>y.push([S,[...k.values()]])),{keys:[...l.values()],overrides:y}}class t{constructor(l,f,y,k,S){this.change=l,this.f=f,this.g=y,this.h=k,this.i=S,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const D of l.keys)this.affectedKeys.add(D);for(const[,D]of l.overrides)for(const T of D)this.affectedKeys.add(T);this.d=this.a;for(const D of this.affectedKeys)this.d+=D+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=i.parse(this.f.data,this.i)),this.j}affectsConfiguration(l,f){const y=this.a+l,k=this.d.indexOf(y);if(k<0)return!1;const S=k+y.length;if(S>=this.d.length)return!1;const D=this.d.charCodeAt(S);if(D!==this.b&&D!==this.c)return!1;if(f){const T=this.previousConfiguration?this.previousConfiguration.getValue(l,f,this.f?.workspace):void 0,v=this.g.getValue(l,f,this.h);return!C.$mo(T,v)}return!0}}e.$Xo=t;function n(d,l){const{added:f,removed:y,updated:k}=r(l?.rawConfiguration,d?.rawConfiguration),S=[],D=d?.getAllOverrideIdentifiers()||[],T=l?.getAllOverrideIdentifiers()||[];if(l){const v=T.filter(w=>!D.includes(w));for(const w of v)S.push([w,l.getKeysForOverrideIdentifier(w)])}if(d){const v=D.filter(w=>!T.includes(w));for(const w of v)S.push([w,d.getKeysForOverrideIdentifier(w)])}if(l&&d){for(const v of D)if(T.includes(v)){const w=r({contents:d.getOverrideValue(void 0,v)||{},keys:d.getKeysForOverrideIdentifier(v)},{contents:l.getOverrideValue(void 0,v)||{},keys:l.getKeysForOverrideIdentifier(v)});S.push([v,[...w.added,...w.removed,...w.updated]])}}return{added:f,removed:y,updated:k,overrides:S}}function r(d,l){const f=d?l?d.keys.filter(S=>l.keys.indexOf(S)===-1):[...d.keys]:[],y=l?d?l.keys.filter(S=>d.keys.indexOf(S)===-1):[...l.keys]:[],k=[];if(d&&l){for(const S of l.keys)if(d.keys.indexOf(S)!==-1){const D=(0,I.$kj)(l.contents,S),T=(0,I.$kj)(d.contents,S);C.$mo(D,T)||k.push(S)}}return{added:f,removed:y,updated:k}}}),define(Re[235],Ce([1,0,21,4,3,70]),function(ge,e,s,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_xb=e.$0xb=e.$9xb=void 0,e.$$xb=C;const O=(c,I,E)=>{const g=new Uint8Array(16);for(let a=0;a<16;a++)g[a]=Math.round(Math.random()*256);const P=(0,s.$$e)(s.$Qe.wrap(g));return[`GET ws://localhost${c}?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${P}`].join(`\r
`)+`\r
\r
`};e.$9xb=O,e.$0xb=s.$Qe.fromString(`\r
\r
`);async function C(c,I,E,g,P){c.write(s.$Qe.fromString((0,e.$9xb)(I,E,g)));const b=new R.$Wc;try{return await new Promise((a,$)=>{let p;b.add(c.onData(u=>{p?p=s.$Qe.concat([p,u],p.byteLength+u.byteLength):p=u;const i=p.indexOf(e.$0xb);if(i===-1)return;a(c),c.pauseData();const o=p.slice(i+e.$0xb.byteLength);o.byteLength&&P.onData.fire(o)})),b.add(c.onClose(u=>$(u??new Error("socket closed")))),b.add(c.onEnd(()=>$(new Error("socket ended"))))})}catch(a){throw c.dispose(),a}finally{b.dispose()}}class m extends R.$Xc{constructor(I,E){super(),this.g=I,this.a=this.B(new h.$re),this.onData=(...g)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...g)),this.b=this.B(new h.$oe),this.onDidDispose=this.b.event,this.f=!1,this.B(E.onData),this.B(E.onData.event(g=>this.a.fire(g))),this.onClose=this.B(E.onClose).event,this.onEnd=this.B(E.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(I,E){A.SocketDiagnostics.traceSocketEvent(this,this.g,I,E)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$_xb=m}),define(Re[73],Ce([1,0,12,5]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xl=e.RemoteAuthorityResolverErrorCode=e.$Wl=e.$Vl=e.RemoteConnectionType=e.$Ul=void 0,e.$Yl=c,e.$Ul=(0,h.$Ii)("remoteAuthorityResolverService");var R;(function(I){I[I.WebSocket=0]="WebSocket",I[I.Managed=1]="Managed"})(R||(e.RemoteConnectionType=R={}));class A{constructor(E){this.id=E,this.type=R.Managed}toString(){return`Managed(${this.id})`}}e.$Vl=A;class O{constructor(E,g){this.host=E,this.port=g,this.type=R.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Wl=O;var C;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound",I.InvalidAuthority="InvalidAuthority"})(C||(e.RemoteAuthorityResolverErrorCode=C={}));class m extends s.$db{static isNotAvailable(E){return E instanceof m&&E._code===C.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof m&&E._code===C.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof m&&E._code===C.NoResolverFound}static isInvalidAuthority(E){return E instanceof m&&E._code===C.InvalidAuthority}static isHandled(E){return E instanceof m&&E.isHandled}constructor(E,g=C.Unknown,P){super(E),this._message=E,this._code=g,this._detail=P,this.isHandled=g===C.NotAvailable&&P===!0,Object.setPrototypeOf(this,m.prototype)}}e.$Xl=m;function c(I){const E=I.indexOf("+");return E===-1?I:I.substring(0,E)}}),define(Re[236],Ce([1,0,7,21,20,12,4,3,14,63,43,32,70,73]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$4l=S,e.$5l=D,e.$6l=v,c=Ue(c);const b=30*1e3;var a;(function(ue){ue[ue.Management=1]="Management",ue[ue.ExtensionHost=2]="ExtensionHost",ue[ue.Tunnel=3]="Tunnel"})(a||(e.ConnectionType=a={}));function $(ue){switch(ue){case a.Management:return"Management";case a.ExtensionHost:return"ExtensionHost";case a.Tunnel:return"Tunnel"}}function p(ue){const X=new R.$ze;return setTimeout(()=>X.cancel(),ue),X.token}function u(ue,X){if(ue.isCancellationRequested||X.isCancellationRequested)return R.CancellationToken.Cancelled;const q=new R.$ze;return ue.onCancellationRequested(()=>q.cancel()),X.onCancellationRequested(()=>q.cancel()),q.token}class i{get didTimeout(){return this.c==="timedout"}constructor(X){this.c="pending",this.d=new C.$Wc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,s.$Bh)(),X.isCancellationRequested?this.h():this.d.add(X.onCancellationRequested(()=>this.h()))}registerDisposable(X){this.c==="pending"?this.d.add(X):X.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const X=new Error("Time limit reached");return X.code="ETIMEDOUT",X.syscall="connect",X}resolve(X){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(X))}reject(X){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(X))}}function o(ue,X){const q=new i(X);return q.registerDisposable(ue.onControlMessage(se=>{const be=JSON.parse(se.toString()),ae=B(be);ae?q.reject(ae):q.resolve(be)})),q.promise}function t(ue,X,q,se,be,ae,we,$e){const pe=new i($e),Ae=I.$ie.create(!1);return ue.info(`Creating a socket (${we})...`),c.mark(`code/willCreateSocket/${ae}`),X.connect(q,se,be,we).then(je=>{pe.didTimeout?(c.mark(`code/didCreateSocketError/${ae}`),ue.info(`Creating a socket (${we}) finished after ${Ae.elapsed()} ms, but this is too late and has timed out already.`),je?.dispose()):(c.mark(`code/didCreateSocketOK/${ae}`),ue.info(`Creating a socket (${we}) was successful after ${Ae.elapsed()} ms.`),pe.resolve(je))},je=>{c.mark(`code/didCreateSocketError/${ae}`),ue.info(`Creating a socket (${we}) returned an error after ${Ae.elapsed()} ms.`),ue.error(je),pe.reject(je)}),pe.promise}function n(ue,X){const q=new i(X);return ue.then(se=>{q.didTimeout||q.resolve(se)},se=>{q.didTimeout||q.reject(se)}),q.promise}async function r(ue,X,q,se){const be=ie(ue,X);ue.logService.trace(`${be} 1/6. invoking socketFactory.connect().`);let ae;try{ae=await t(ue.logService,ue.remoteSocketFactoryService,ue.connectTo,m.$Vg.getServerRootPath(),`reconnectionToken=${ue.reconnectionToken}&reconnection=${ue.reconnectionProtocol?"true":"false"}`,$(X),`renderer-${$(X)}-${ue.reconnectionToken}`,se)}catch(je){throw ue.logService.error(`${be} socketFactory.connect() failed or timed out. Error:`),ue.logService.error(je),je}ue.logService.trace(`${be} 2/6. socketFactory.connect() was successful.`);let we,$e;ue.reconnectionProtocol?(ue.reconnectionProtocol.beginAcceptReconnection(ae,null),we=ue.reconnectionProtocol,$e=!1):(we=new g.$wi({socket:ae}),$e=!0),ue.logService.trace(`${be} 3/6. sending AuthRequest control message.`);const pe=await n(ue.signService.createNewMessage((0,E.$5g)()),se),Ae={type:"auth",auth:ue.connectionToken||"00000000000000000000",data:pe.data};we.sendControl(h.$Qe.fromString(JSON.stringify(Ae)));try{const je=await o(we,u(se,p(1e4)));if(je.type!=="sign"||typeof je.data!="string"){const Fe=new Error("Unexpected handshake message");throw Fe.code="VSCODE_CONNECTION_ERROR",Fe}if(ue.logService.trace(`${be} 4/6. received SignRequest control message.`),!await n(ue.signService.validate(pe,je.signedData),se)){const Fe=new Error("Refused to connect to unsupported server");throw Fe.code="VSCODE_CONNECTION_ERROR",Fe}const Ye=await n(ue.signService.sign(je.data),se),xe={type:"connectionType",commit:ue.commit,signedData:Ye,desiredConnectionType:X};return q&&(xe.args=q),ue.logService.trace(`${be} 5/6. sending ConnectionTypeRequest control message.`),we.sendControl(h.$Qe.fromString(JSON.stringify(xe))),{protocol:we,ownsProtocol:$e}}catch(je){throw je&&je.code==="ETIMEDOUT"&&(ue.logService.error(`${be} the handshake timed out. Error:`),ue.logService.error(je)),je&&je.code==="VSCODE_CONNECTION_ERROR"&&(ue.logService.error(`${be} received error control message when negotiating connection. Error:`),ue.logService.error(je)),$e&&W(we),je}}async function d(ue,X,q,se){const be=Date.now(),ae=ie(ue,X),{protocol:we,ownsProtocol:$e}=await r(ue,X,q,se),pe=new i(se);return pe.registerDisposable(we.onControlMessage(Ae=>{const je=JSON.parse(Ae.toString()),He=B(je);He?(ue.logService.error(`${ae} received error control message when negotiating connection. Error:`),ue.logService.error(He),$e&&W(we),pe.reject(He)):(ue.reconnectionProtocol?.endAcceptReconnection(),ue.logService.trace(`${ae} 6/6. handshake finished, connection is up and running after ${me(be)}!`),pe.resolve({protocol:we,firstMessage:je}))})),pe.promise}async function l(ue,X){const{protocol:q}=await d(ue,a.Management,void 0,X);return{protocol:q}}async function f(ue,X,q){const{protocol:se,firstMessage:be}=await d(ue,a.ExtensionHost,X,q),ae=be&&be.debugPort;return{protocol:se,debugPort:ae}}async function y(ue,X,q){const se=Date.now(),be=ie(ue,a.Tunnel),{protocol:ae}=await r(ue,a.Tunnel,X,q);return ue.logService.trace(`${be} 6/6. handshake finished, connection is up and running after ${me(se)}!`),ae}async function k(ue,X,q){const{connectTo:se,connectionToken:be}=await ue.addressProvider.getAddress();return{commit:ue.commit,quality:ue.quality,connectTo:se,connectionToken:be,reconnectionToken:X,reconnectionProtocol:q,remoteSocketFactoryService:ue.remoteSocketFactoryService,signService:ue.signService,logService:ue.logService}}async function S(ue,X,q){return T(ue,async se=>{const{protocol:be}=await l(se,R.CancellationToken.None);return new z(ue,X,q,se.reconnectionToken,be)})}async function D(ue,X){return T(ue,async q=>{const{protocol:se,debugPort:be}=await f(q,X,R.CancellationToken.None);return new _(ue,X,q.reconnectionToken,se,be)})}async function T(ue,X){for(let se=1;;se++)try{const be=(0,E.$5g)(),ae=await k(ue,be,null);return await X(ae)}catch(be){if(se<5)ue.logService.error(`[remote-connection][attempt ${se}] An error occurred in initial connection! Will retry... Error:`),ue.logService.error(be);else throw ue.logService.error(`[remote-connection][attempt ${se}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),ue.logService.error(be),U.triggerPermanentFailure(0,0,P.$Xl.isHandled(be)),be}}async function v(ue,X,q){const se=await k(ue,(0,E.$5g)(),null);return await y(se,{host:X,port:q},R.CancellationToken.None)}function w(ue){return(0,s.$vh)(X=>new Promise((q,se)=>{const be=setTimeout(q,ue*1e3);X.onCancellationRequested(()=>{clearTimeout(be),q()})}))}var M;(function(ue){ue[ue.ConnectionLost=0]="ConnectionLost",ue[ue.ReconnectionWait=1]="ReconnectionWait",ue[ue.ReconnectionRunning=2]="ReconnectionRunning",ue[ue.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",ue[ue.ConnectionGain=4]="ConnectionGain"})(M||(e.PersistentConnectionEventType=M={}));class L{constructor(X,q){this.reconnectionToken=X,this.millisSinceLastIncomingData=q,this.type=M.ConnectionLost}}e.$7l=L;class N{constructor(X,q,se,be){this.reconnectionToken=X,this.millisSinceLastIncomingData=q,this.durationSeconds=se,this.c=be,this.type=M.ReconnectionWait}skipWait(){this.c.cancel()}}e.$8l=N;class F{constructor(X,q,se){this.reconnectionToken=X,this.millisSinceLastIncomingData=q,this.attempt=se,this.type=M.ReconnectionRunning}}e.$9l=F;class V{constructor(X,q,se){this.reconnectionToken=X,this.millisSinceLastIncomingData=q,this.attempt=se,this.type=M.ConnectionGain}}e.$0l=V;class j{constructor(X,q,se,be){this.reconnectionToken=X,this.millisSinceLastIncomingData=q,this.attempt=se,this.handled=be,this.type=M.ReconnectionPermanentFailure}}e.$$l=j;class U extends C.$Xc{static triggerPermanentFailure(X,q,se){this._permanentFailure=!0,this.f=X,this.g=q,this.h=se,this.j.forEach(be=>be.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(X=>X.y())}static debugPauseSocketWriting(){this.j.forEach(X=>X.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||U._permanentFailure}constructor(X,q,se,be,ae){super(),this.t=X,this.u=q,this.reconnectionToken=se,this.protocol=be,this.w=ae,this.m=this.B(new O.$oe),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new V(this.reconnectionToken,0,0)),this.B(be.onSocketClose(we=>{const $e=oe(this.t,this.reconnectionToken,!0);we?we.type===g.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${$e} received socket close event (hadError: ${we.hadError}).`),we.error&&this.u.logService.error(we.error)):(this.u.logService.info(`${$e} received socket close event (wasClean: ${we.wasClean}, code: ${we.code}, reason: ${we.reason}).`),we.event&&this.u.logService.error(we.event)):this.u.logService.info(`${$e} received socket close event.`),this.y()})),this.B(be.onSocketTimeout(we=>{const $e=oe(this.t,this.reconnectionToken,!0);this.u.logService.info(`${$e} received socket timeout event (unacknowledgedMsgCount: ${we.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${we.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${we.timeSinceLastReceivedSomeData}).`),this.y()})),U.j.push(this),this.B((0,C.$Vc)(()=>{const we=U.j.indexOf(this);we>=0&&U.j.splice(we,1)})),this.n&&this.D(U.f,U.g,U.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const X=oe(this.t,this.reconnectionToken,!0);this.u.logService.info(`${X} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new L(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const q=[0,5,5,10,10,10,10,10,30];let se=-1;do{se++;const be=se<q.length?q[se]:q[q.length-1];try{if(be>0){const we=w(be);this.m.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),be,we)),this.u.logService.info(`${X} waiting for ${be} seconds before reconnecting...`);try{await we}catch{}}if(this.n){this.u.logService.error(`${X} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),se+1)),this.u.logService.info(`${X} resolving connection...`);const ae=await k(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${X} connecting to ${ae.connectTo}...`),await this.G(ae,p(b)),this.u.logService.info(`${X} reconnected!`),this.m.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),se+1));break}catch(ae){if(ae.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${X} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(ae),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}if(se>360){this.u.logService.error(`${X} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(ae),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}if(P.$Xl.isTemporarilyNotAvailable(ae)){this.u.logService.info(`${X} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ae);continue}if((ae.code==="ETIMEDOUT"||ae.code==="ENETUNREACH"||ae.code==="ECONNREFUSED"||ae.code==="ECONNRESET")&&ae.syscall==="connect"){this.u.logService.info(`${X} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ae);continue}if((0,A.$6)(ae)){this.u.logService.info(`${X} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ae);continue}if(ae instanceof P.$Xl){this.u.logService.error(`${X} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(ae),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,P.$Xl.isHandled(ae));break}this.u.logService.error(`${X} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(ae),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}}while(!this.n&&!this.s)}C(X,q,se){this.w?U.triggerPermanentFailure(X,q,se):this.D(X,q,se)}D(X,q,se){this.m.fire(new j(this.reconnectionToken,X,q,se)),W(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$_l=U;class z extends U{constructor(X,q,se,be,ae){super(a.Management,X,be,ae,!0),this.client=this.B(new g.$ui(ae,{remoteAuthority:q,clientId:se},X.ipcLogger))}async G(X,q){await l(X,q)}}e.$am=z;class _ extends U{constructor(X,q,se,be,ae){super(a.ExtensionHost,X,se,be,!1),this.H=q,this.debugPort=ae}async G(X,q){await f(X,this.H,q)}}e.$bm=_;function W(ue){try{ue.acceptDisconnect();const X=ue.getSocket();ue.dispose(),X.dispose()}catch(X){(0,A.$2)(X)}}function B(ue){if(ue&&ue.type==="error"){const X=new Error(`Connection error: ${ue.reason}`);return X.code="VSCODE_CONNECTION_ERROR",X}return null}function Y(ue,X){for(;ue.length<X;)ue+=" ";return ue}function x(ue,X){return`[remote-connection][${Y($(ue),13)}][${X.substr(0,5)}\u2026]`}function oe(ue,X,q){return`${x(ue,X)}[${q?"reconnect":"initial"}]`}function ie(ue,X){return`${oe(X,ue.reconnectionToken,!!ue.reconnectionProtocol)}[${ue.connectTo}]`}function me(ue){return`${Date.now()-ue} ms`}}),define(Re[91],Ce([1,0,14]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=h,e.$mn=R,e.$nn=A,e.$on=O;function h(m){return m.scheme===s.Schemas.vscodeRemote?m.authority:void 0}function R(m){if(!m)return;const c=m.indexOf("+");return c<0?m:m.substr(0,c)}function A(m){const{host:c,port:I}=C(m);if(typeof I>"u")throw new Error(`Invalid remote authority: ${m}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:c,port:I}}function O(m,c){let{host:I,port:E}=C(m);return typeof E>"u"&&(E=c),{host:I,port:E}}function C(m){const c=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(c)return{host:c[1],port:parseInt(c[2],10)};const I=m.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const E=m.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:m,port:void 0}}}),define(Re[23],Ce([1,0,13,5,91]),function(ge,e,s,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=e.$xn=e.$wn=e.$vn=e.TargetPlatform=e.ExtensionType=e.$un=e.$sn=e.$rn=e.$qn=e.$pn=void 0,e.$tn=A,e.$yn=E,e.$zn=g,e.$An=P,e.$Bn=b,e.$Cn=a,e.$Dn=$,s=Ue(s),e.$pn="extensions.user.cache",e.$qn="extensions.builtin.cache",e.$rn="undefined_publisher",e.$sn=["ui","workspace","web"];function A(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.$un=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var O;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(O||(e.ExtensionType=O={}));var C;(function(p){p.WIN32_X64="win32-x64",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(C||(e.TargetPlatform=C={}));class m{constructor(u){this.value=u,this._lower=u.toLowerCase()}static equals(u,i){if(typeof u>"u"||u===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof u=="string"||typeof i=="string"){const o=typeof u=="string"?u:u.value,t=typeof i=="string"?i:i.value;return s.$If(o,t)}return u._lower===i._lower}static toKey(u){return typeof u=="string"?u.toLowerCase():u._lower}}e.$vn=m;class c{get size(){return this.c.size}constructor(u){if(this.c=new Set,u)for(const i of u)this.add(i)}add(u){this.c.add(m.toKey(u))}delete(u){return this.c.delete(m.toKey(u))}has(u){return this.c.has(m.toKey(u))}}e.$wn=c;class I{constructor(){this.c=new Map}clear(){this.c.clear()}delete(u){this.c.delete(m.toKey(u))}get(u){return this.c.get(m.toKey(u))}has(u){return this.c.has(m.toKey(u))}set(u,i){this.c.set(m.toKey(u),i)}values(){return this.c.values()}forEach(u){this.c.forEach(u)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$xn=I;function E(p){return g(p)}function g(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}function P(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}function b(p,u){if(u){const i=`onResolveRemoteAuthority:${(0,R.$mn)(u)}`;return!!p.activationEvents?.includes(i)}return!1}function a(p){return p.map(u=>{const[i,o]=u.split("@");return{proposalName:i,version:o?parseInt(o):void 0}})}function $(p){return p.map(u=>u.split("@")[0])}e.$En=(0,h.$Ii)("IBuiltinExtensionsScannerService")}),define(Re[148],Ce([1,0,10,8,23,5]),function(ge,e,s,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.$tp=e.$sp=e.$rp=e.ExtensionManagementErrorCode=e.$qp=e.ExtensionGalleryErrorCode=e.$pp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=void 0,e.$jp=C,e.$kp=m,e.$lp=c,e.$mp=I,e.$np=E,e.$op=g,e.$cp="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$dp=new RegExp(e.$cp),e.$ep="__web_extension",e.$fp="skipWalkthrough",e.$gp="extensionInstallSource",e.$hp="dependecyOrPackExtensionInstall",e.$ip="clientTargetPlatform";var O;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(O||(e.ExtensionInstallSource=O={}));function C(t){switch(t){case R.TargetPlatform.WIN32_X64:return"Windows 64 bit";case R.TargetPlatform.WIN32_ARM64:return"Windows ARM";case R.TargetPlatform.LINUX_X64:return"Linux 64 bit";case R.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case R.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case R.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case R.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case R.TargetPlatform.DARWIN_X64:return"Mac";case R.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case R.TargetPlatform.WEB:return"Web";case R.TargetPlatform.UNIVERSAL:return R.TargetPlatform.UNIVERSAL;case R.TargetPlatform.UNKNOWN:return R.TargetPlatform.UNKNOWN;case R.TargetPlatform.UNDEFINED:return R.TargetPlatform.UNDEFINED}}function m(t){switch(t){case R.TargetPlatform.WIN32_X64:return R.TargetPlatform.WIN32_X64;case R.TargetPlatform.WIN32_ARM64:return R.TargetPlatform.WIN32_ARM64;case R.TargetPlatform.LINUX_X64:return R.TargetPlatform.LINUX_X64;case R.TargetPlatform.LINUX_ARM64:return R.TargetPlatform.LINUX_ARM64;case R.TargetPlatform.LINUX_ARMHF:return R.TargetPlatform.LINUX_ARMHF;case R.TargetPlatform.ALPINE_X64:return R.TargetPlatform.ALPINE_X64;case R.TargetPlatform.ALPINE_ARM64:return R.TargetPlatform.ALPINE_ARM64;case R.TargetPlatform.DARWIN_X64:return R.TargetPlatform.DARWIN_X64;case R.TargetPlatform.DARWIN_ARM64:return R.TargetPlatform.DARWIN_ARM64;case R.TargetPlatform.WEB:return R.TargetPlatform.WEB;case R.TargetPlatform.UNIVERSAL:return R.TargetPlatform.UNIVERSAL;default:return R.TargetPlatform.UNKNOWN}}function c(t,n){switch(t){case s.Platform.Windows:return n==="x64"?R.TargetPlatform.WIN32_X64:n==="arm64"?R.TargetPlatform.WIN32_ARM64:R.TargetPlatform.UNKNOWN;case s.Platform.Linux:return n==="x64"?R.TargetPlatform.LINUX_X64:n==="arm64"?R.TargetPlatform.LINUX_ARM64:n==="arm"?R.TargetPlatform.LINUX_ARMHF:R.TargetPlatform.UNKNOWN;case"alpine":return n==="x64"?R.TargetPlatform.ALPINE_X64:n==="arm64"?R.TargetPlatform.ALPINE_ARM64:R.TargetPlatform.UNKNOWN;case s.Platform.Mac:return n==="x64"?R.TargetPlatform.DARWIN_X64:n==="arm64"?R.TargetPlatform.DARWIN_ARM64:R.TargetPlatform.UNKNOWN;case s.Platform.Web:return R.TargetPlatform.WEB}}function I(t,n){return n===R.TargetPlatform.WEB&&!t.includes(R.TargetPlatform.WEB)}function E(t,n,r){return I(n,r)?!1:t===R.TargetPlatform.UNDEFINED||t===R.TargetPlatform.UNIVERSAL?!0:t===R.TargetPlatform.UNKNOWN?!1:t===r}function g(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var P;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(P||(e.SortBy=P={}));var b;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(b||(e.SortOrder=b={}));var a;(function(t){t.Install="install",t.Uninstall="uninstall"})(a||(e.StatisticType=a={}));var $;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})($||(e.InstallOperation=$={})),e.$pp=(0,A.$Ii)("extensionGalleryService");var p;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting",t.Offline="Offline"})(p||(e.ExtensionGalleryErrorCode=p={}));class u extends Error{constructor(n,r){super(n),this.code=r,this.name=r}}e.$qp=u;var i;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(i||(e.ExtensionManagementErrorCode=i={}));class o extends Error{constructor(n,r){super(n),this.code=r,this.name=r}}e.$rp=o,e.$sp=(0,A.$Ii)("extensionManagementService"),e.$tp="extensionsIdentifiers/disabled",e.$up="extensionsIdentifiers/enabled",e.$vp=(0,A.$Ii)("IGlobalExtensionEnablementService"),e.$wp=(0,A.$Ii)("IExtensionTipsService"),e.$xp=(0,h.localize2)(1780,"Extensions"),e.$yp=(0,h.localize2)(1781,"Preferences")}),define(Re[149],Ce([1,0,12,23]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cH=e.$bH=void 0;class R{constructor(){this.a=new Map,this.b=new WeakMap}register(O,C){this.a.set(O,C)}readActivationEvents(O){return this.b.has(O)||this.b.set(O,this.c(O)),this.b.get(O)}createActivationEventsMap(O){const C=Object.create(null);for(const m of O){const c=this.readActivationEvents(m);c.length>0&&(C[h.$vn.toKey(m.identifier)]=c)}return C}c(O){if(typeof O.main>"u"&&typeof O.browser>"u")return[];const C=Array.isArray(O.activationEvents)?O.activationEvents.slice(0):[];for(let m=0;m<C.length;m++)C[m]==="onUri"&&(C[m]=`onUri:${h.$vn.toKey(O.identifier)}`);if(!O.contributes)return C;for(const m in O.contributes){const c=this.a.get(m);if(!c)continue;const I=O.contributes[m],E=Array.isArray(I)?I:[I];try{c(E,C)}catch(g){(0,s.$2)(g)}}return C}}e.$bH=R,e.$cH=new R});var Ht=this&&this.__importDefault||function(ge){return ge&&ge.__esModule?ge:{default:ge}};define(Re[237],Ce([1,0,22,44,8,362,23,145]),function(ge,e,s,h,R,A,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=I,e.$5p=E,e.$6p=g,e.$7p=P,e.$8p=b,e.$9p=a,e.$0p=$,e.$$p=p,h=Ht(h),R=Ue(R),A=Ue(A);const m=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,c=/^-(\d{4})(\d{2})(\d{2})$/;function I(o){return o=o.trim(),o==="*"||m.test(o)}function E(o){if(!I(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=o.match(m);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function g(o){if(!o)return null;const t=o.majorBase,n=o.majorMustEqual,r=o.minorBase;let d=o.minorMustEqual;const l=o.patchBase;let f=o.patchMustEqual;o.hasCaret&&(t===0||(d=!1),f=!1);let y=0;if(o.preRelease){const k=c.exec(o.preRelease);if(k){const[,S,D,T]=k;y=Date.UTC(Number(S),Number(D)-1,Number(T))}}return{majorBase:t,majorMustEqual:n,minorBase:r,minorMustEqual:d,patchBase:l,patchMustEqual:f,isMinimum:o.hasGreaterEquals,notBefore:y}}function P(o,t,n){let r;typeof o=="string"?r=g(E(o)):r=o;let d;t instanceof Date?d=t.getTime():typeof t=="string"&&(d=new Date(t).getTime());let l;if(typeof n=="string"?l=g(E(n)):l=n,!r||!l)return!1;const f=r.majorBase,y=r.minorBase,k=r.patchBase;let S=l.majorBase,D=l.minorBase,T=l.patchBase;const v=l.notBefore;let w=l.majorMustEqual,M=l.minorMustEqual,L=l.patchMustEqual;return l.isMinimum?f>S?!0:f<S?!1:y>D?!0:y<D||d&&d<v?!1:k>=T:(f===1&&S===0&&(!w||!M||!L)&&(S=1,D=0,T=0,w=!0,M=!1,L=!1),f<S?!1:f>S?!w:y<D?!1:y>D?!M:k<T?!1:k>T?!L:!(d&&d<v))}function b(o,t,n,r,d,l){const f=[];if(typeof r.publisher<"u"&&typeof r.publisher!="string")return f.push([h.default.Error,R.localize(1832,null)]),f;if(typeof r.name!="string")return f.push([h.default.Error,R.localize(1833,null,"name")]),f;if(typeof r.version!="string")return f.push([h.default.Error,R.localize(1834,null,"version")]),f;if(!r.engines)return f.push([h.default.Error,R.localize(1835,null,"engines")]),f;if(typeof r.engines.vscode!="string")return f.push([h.default.Error,R.localize(1836,null,"engines.vscode")]),f;if(typeof r.extensionDependencies<"u"&&!i(r.extensionDependencies))return f.push([h.default.Error,R.localize(1837,null,"extensionDependencies")]),f;if(typeof r.activationEvents<"u"){if(!i(r.activationEvents))return f.push([h.default.Error,R.localize(1838,null,"activationEvents")]),f;if(typeof r.main>"u"&&typeof r.browser>"u")return f.push([h.default.Error,R.localize(1839,null,"activationEvents","main","browser")]),f}if(typeof r.extensionKind<"u"&&typeof r.main>"u"&&f.push([h.default.Warning,R.localize(1840,null,"extensionKind")]),typeof r.main<"u"){if(typeof r.main!="string")return f.push([h.default.Error,R.localize(1841,null,"main")]),f;{const S=(0,s.$jh)(n,r.main);(0,s.$dh)(S,n)||f.push([h.default.Warning,R.localize(1842,null,S.path,n.path)])}}if(typeof r.browser<"u"){if(typeof r.browser!="string")return f.push([h.default.Error,R.localize(1843,null,"browser")]),f;{const S=(0,s.$jh)(n,r.browser);(0,s.$dh)(S,n)||f.push([h.default.Warning,R.localize(1844,null,S.path,n.path)])}}if(!A.valid(r.version))return f.push([h.default.Error,R.localize(1845,null)]),f;const y=[];if(!a(o,t,r,d,y))for(const S of y)f.push([h.default.Error,S]);if(l&&r.enabledApiProposals?.length){const S=[];if(!p([...r.enabledApiProposals],S))for(const D of S)f.push([h.default.Error,D])}return f}function a(o,t,n,r,d){return r||typeof n.main>"u"&&typeof n.browser>"u"?!0:u(o,t,n.engines.vscode,d)}function $(o,t,n){return o==="*"||u(t,n,o)}function p(o,t){if(o.length===0)return!0;const n=Array.isArray(t)?t:void 0,r=(n?void 0:t)??C.allApiProposals,d=[],l=(0,O.$Cn)(o);for(const{proposalName:f,version:y}of l){const k=r[f];k&&y&&k.version!==y&&d.push(R.localize(1846,null,f))}return n?.push(...d),d.length===0}function u(o,t,n,r=[]){const d=g(E(n));if(!d)return r.push(R.localize(1847,null,n)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return r.push(R.localize(1848,null,n)),!1}else if(!d.majorMustEqual)return r.push(R.localize(1849,null,n)),!1;return P(o,t,d)?!0:(r.push(R.localize(1850,null,o,n)),!1)}function i(o){if(!Array.isArray(o))return!1;for(let t=0,n=o.length;t<n;t++)if(typeof o[t]!="string")return!1;return!0}}),define(Re[238],Ce([1,0,3,5]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1l=e.$Zl=void 0,e.$Zl=(0,h.$Ii)("remoteSocketFactoryService");class R{constructor(){this.a={}}register(O,C){return this.a[O]??=[],this.a[O].push(C),(0,s.$Vc)(()=>{const m=this.a[O]?.indexOf(C);typeof m=="number"&&m>=0&&this.a[O]?.splice(m,1)})}b(O){return(this.a[O.type]||[]).find(m=>m.supports(O))}connect(O,C,m,c){const I=this.b(O);if(!I)throw new Error(`No socket factory found for ${O}`);return I.connect(O,C,m,c)}}e.$1l=R}),define(Re[239],Ce([1,0,21,12,3,8,72,5,11,37]),function(ge,e,s,h,R,A,O,C,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$_p=void 0,e.$bq=g,e.$cq=P,e.$dq=b,e.$eq=a,e.$fq=$,e.$gq=p,e.$_p=(0,C.$Ii)("requestService");class I{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const n in this.b)n.toLowerCase()==="authorization"||n.toLowerCase()==="proxy-authorization"?t[n]="*****":t[n]=this.b[n];this.a=t}return this.a}}class E extends R.$Xc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,A.localize)(2050,null),when:m.$vk.isEqualTo((0,m.$sk)(m.LogLevel.Trace)).serialize()})}async c(t,n,r){const d=`${t} #${++this.b}: ${n.url}`;this.a.trace(`${d} - begin`,n.type,new I(n.headers??{}));try{const l=await r();return this.a.trace(`${d} - end`,n.type,l.res.statusCode,l.res.headers),l}catch(l){throw this.a.error(`${d} - error`,n.type,(0,h.$_)(l)),l}}}e.$aq=E;function g(o){return o.res.statusCode&&o.res.statusCode>=200&&o.res.statusCode<300||o.res.statusCode===1223}function P(o){return o.res.statusCode===204}async function b(o){return P(o)?null:(await(0,s.$3e)(o.stream)).toString()}async function a(o){if(!g(o))throw new Error("Server returned "+o.res.statusCode);return b(o)}async function $(o){if(!g(o))throw new Error("Server returned "+o.res.statusCode);if(P(o))return null;const n=(await(0,s.$3e)(o.stream)).toString();try{return JSON.parse(n)}catch(r){throw r.message+=`:
`+n,r}}function p(o){i(o)}let u;function i(o){const t=c.$vo.as(O.$Ao.Configuration),n=u;u={id:"http",order:15,title:(0,A.localize)(2051,null),type:"object",scope:o,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2052,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(2053,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(2054,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,A.localize)(2055,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(2056,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(2057,null),(0,A.localize)(2058,null),(0,A.localize)(2059,null),(0,A.localize)(2060,null)],default:"override",description:(0,A.localize)(2061,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(2062,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(2063,null),restricted:!0}}},t.updateConfigurations({add:[u],remove:n?[n]:[]})}i(O.ConfigurationScope.APPLICATION)}),define(Re[240],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndc=void 0;class s{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(R){try{const A=await this.c();if(A){const O=String(s.a++);return this.b.set(O,A),{id:O,data:A.createNewMessage(R)}}}catch{}return{id:"",data:R}}async validate(R,A){if(!R.id)return!0;const O=this.b.get(R.id);if(!O)return!1;this.b.delete(R.id);try{return O.validate(A)==="ok"}catch{return!1}finally{O.dispose?.()}}async sign(R){try{return await this.d(R)}catch{}return R}}e.$Ndc=s}),define(Re[117],Ce([1,0,5]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3l=e.$2l=void 0,e.$2l="signService",e.$3l=(0,s.$Ii)(e.$2l)}),define(Re[150],Ce([1,0,139,240]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wic=void 0;class R extends h.$Ndc{c(){return this.h().then(O=>new O.validator)}d(O){return this.h().then(C=>new C.signer().sign(O))}async h(){return(0,s.$xq)("vsda","index.js")}}e.$Wic=R}),define(Re[241],Ce([1,0,10,55,32]),function(ge,e,s,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=O,e.$Ap=C;function A(m){if(s.$v===s.Platform.Linux&&/^penguin(\.|$)/i.test(m))return"chromebook"}function O(m,c,I,E,g,P,b,a,$,p){const u=Object.create(null);u["common.machineId"]=P,u["common.sqmId"]=b,u["common.devDeviceId"]=a,u.sessionID=(0,R.$5g)()+Date.now(),u.commitHash=E,u.version=g,u["common.platformVersion"]=(m||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,s.$i)(s.$v),u["common.nodePlatform"]=h.$gc,u["common.nodeArch"]=I,u["common.product"]=p||"desktop",$&&(u["common.msftInternal"]=$);let i=0;const o=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),s.$m&&(u["common.snap"]="true");const t=A(c);return t&&(u["common.platformDetail"]=t),u}function C(m){const c=h.env.USERDNSDOMAIN;if(!c)return!1;const I=c.toLowerCase();return m.some(E=>I===E)}}),define(Re[151],Ce([1,0,5]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=void 0,e.$cm=(0,s.$Ii)("telemetryService"),e.$dm=(0,s.$Ii)("customEndpointTelemetryService"),e.$em="telemetry.currentSessionDate",e.$fm="telemetry.firstSessionDate",e.$gm="telemetry.lastSessionDate",e.$hm="telemetry.machineId",e.$im="telemetry.sqmId",e.$jm="telemetry.devDeviceId",e.$km="telemetry",e.$lm="telemetry.telemetryLevel",e.$mm="telemetry.enableCrashReporter",e.$nm="telemetry.enableTelemetry";var h;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(h||(e.TelemetryLevel=h={}));var R;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(R||(e.TelemetryConfiguration=R={}))}),define(Re[92],Ce([1,0,24,17,91,241,151]),function(ge,e,s,h,R,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=e.$Gp=e.$Fp=e.$Ep=e.$Dp=e.$Cp=e.$Bp=void 0,e.$Ip=I,e.$Jp=E,e.$Kp=g,e.$Lp=P,e.$Mp=a,e.$Np=p,e.$Op=u,e.$Pp=t;class C{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.$Bp=C;class m{constructor(){this.telemetryLevel=O.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Cp=m,e.$Dp=new m;class c{async publicLog(r,d,l){}async publicLogError(r,d,l){}}e.$Ep=c,e.$Fp="telemetry",e.$Gp="extensionTelemetryLog",e.$Hp={log:()=>null,flush:()=>Promise.resolve(null)};function I(n,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!n.enableTelemetry)}function E(n,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}function g(n){const r=n.getValue(O.$lm),d=n.getValue(O.$mm);if(n.getValue(O.$nm)===!1||d===!1)return O.TelemetryLevel.NONE;switch(r??O.TelemetryConfiguration.ON){case O.TelemetryConfiguration.ON:return O.TelemetryLevel.USAGE;case O.TelemetryConfiguration.ERROR:return O.TelemetryLevel.ERROR;case O.TelemetryConfiguration.CRASH:return O.TelemetryLevel.CRASH;case O.TelemetryConfiguration.OFF:return O.TelemetryLevel.NONE}}function P(n){const r={},d={},l={};$(n,l);for(let f in l){f=f.length>150?f.substr(f.length-149):f;const y=l[f];typeof y=="number"?d[f]=y:typeof y=="boolean"?d[f]=y?1:0:typeof y=="string"?(y.length>8192&&console.warn(`Telemetry property: ${f} has been trimmed to 8192, the original length is ${y.length}`),r[f]=y.substring(0,8191)):typeof y<"u"&&y!==null&&(r[f]=y)}return{properties:r,measurements:d}}const b=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(n){if(!n)return"none";const r=(0,R.$mn)(n);return b.has(r)?r:"other"}function $(n,r,d=0,l){if(n)for(const f of Object.getOwnPropertyNames(n)){const y=n[f],k=l?l+f:f;Array.isArray(y)?r[k]=(0,s.$no)(y):y instanceof Date?r[k]=y.toISOString():(0,h.$jg)(y)?d<2?$(y,r,d+1,k+"."):r[k]=(0,s.$no)(y):r[k]=y}}function p(n,r){const d=n.msftInternalDomains||[],l=r.getValue("telemetry.internalTesting");return(0,A.$Ap)(d)||l}function u(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}function i(n,r){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let d=n;const l=[];for(const S of r)for(;;){const D=S.exec(n);if(!D)break;l.push([D.index,S.lastIndex])}const f=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let k=0;for(d="";;){const S=y.exec(n);if(!S)break;const D=l.some(([T,v])=>S.index<v&&T<y.lastIndex);!f.test(S[0])&&!D&&(d+=n.substring(k,S.index)+"<REDACTED: user-file-path>",k=y.lastIndex)}return k<n.length&&(d+=n.substr(k)),d}function o(n){if(!n)return n;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of r)if(d.regex.test(n))return`<REDACTED: ${d.label}>`;return n}function t(n,r){return(0,s.$ko)(n,d=>{if(d instanceof C||Object.hasOwnProperty.call(d,"isTrustedTelemetryValue"))return d.value;if(typeof d=="string"){let l=d.replaceAll("%20"," ");l=i(l,r);for(const f of r)l=l.replace(f,"");return l=o(l),l}})}}),define(Re[242],Ce([1,0,13,148,23,10,2,12,55,92]),function(ge,e,s,h,R,A,O,C,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=e.$Rp=void 0,e.$Qp=I,e.$Sp=b,e.$Tp=a,e.$Up=$,e.$Vp=p,e.$Wp=u,e.$Xp=i,e.$Yp=o,e.$1p=t,e.$2p=r;function I(d,l){return d.uuid&&l.uuid?d.uuid===l.uuid:d.id===l.id?!0:(0,s.$Df)(d.id,l.id)===0}const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class g{static create(l){const f=l.manifest?l.manifest.version:l.version,y=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new g(l.identifier,f,y)}static parse(l){const f=E.exec(l);return f&&f[1]&&f[2]?new g({id:f[1]},f[2],f[4]||void 0):null}constructor(l,f,y=R.TargetPlatform.UNDEFINED){this.identifier=l,this.version=f,this.targetPlatform=y,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==R.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof g?I(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.$Rp=g;const P=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function b(d){const l=P.exec(d);return l&&l[1]?[$(l[1]),l[2]]:[$(d),void 0]}function a(d,l){return`${d}.${l}`}function $(d){return d.toLowerCase()}function p(d,l){return $(a(d??R.$rn,l))}function u(d,l){const f=[],y=k=>{for(const S of f)if(S.some(D=>I(l(D),l(k))))return S;return null};for(const k of d){const S=y(k);S?S.push(k):f.push([k])}return f}function i(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}function o(d){return{id:new c.$Bp(d.identifier.id),name:new c.$Bp(d.name),version:d.version,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),isSigned:d.isSigned,...d.telemetryData}}e.$Zp=new R.$vn("pprice.better-merge");function t(d,l){const f=[],y=l.manifest.extensionDependencies?.slice(0)??[];for(;y.length;){const k=y.shift();if(k&&f.every(S=>!I(S.identifier,{id:k}))){const S=d.filter(D=>I(D.identifier,{id:k}));S.length===1&&(f.push(S[0]),y.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return f}async function n(d,l){if(!A.$l)return!1;let f;try{f=(await d.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{f=(await d.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(k){l.debug("Error while getting the os-release file.",(0,C.$_)(k))}}return!!f&&(f.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(d,l){const f=await n(d,l),y=(0,h.$lp)(f?"alpine":A.$v,m.$hc);return l.debug("ComputeTargetPlatform:",y),y}}),define(Re[243],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ls=s,e.$Ms=h,e.$Ns=R,e.$Os=A,e.$Ps=O,e.$Qs=C;function s(m){return[...m.entries()]}function h(m){return m?[...m.entries()]:[]}function R(m){return new Map(m)}function A(m){return new Map(m??[])}function O(m){return Array.from(m.entries()).map(c=>[c[0],s(c[1].map),h(c[1].descriptionMap)])}function C(m){return new Map(m.map(c=>[c[0],{map:R(c[1]),descriptionMap:A(c[2])}]))}}),define(Re[244],Ce([1,0,5,36,37]),function(ge,e,s,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=e.$xs=e.$ws=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$vs=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.GeneralShellType=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$us=void 0,e.$us=new h.$Zj("terminalTabFocusMode",!1,!0);var A;(function(n){n.AutomationProfile="terminal.integrated.automationProfile.",n.DefaultProfile="terminal.integrated.defaultProfile.",n.Profiles="terminal.integrated.profiles."})(A||(e.TerminalSettingPrefix=A={}));var O;(function(n){n.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",n.AutomationProfileLinux="terminal.integrated.automationProfile.linux",n.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",n.AutomationProfileWindows="terminal.integrated.automationProfile.windows",n.ProfilesWindows="terminal.integrated.profiles.windows",n.ProfilesMacOs="terminal.integrated.profiles.osx",n.ProfilesLinux="terminal.integrated.profiles.linux",n.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",n.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",n.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",n.UseWslProfiles="terminal.integrated.useWslProfiles",n.TabsDefaultColor="terminal.integrated.tabs.defaultColor",n.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",n.TabsEnabled="terminal.integrated.tabs.enabled",n.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",n.TabsHideCondition="terminal.integrated.tabs.hideCondition",n.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",n.TabsShowActions="terminal.integrated.tabs.showActions",n.TabsLocation="terminal.integrated.tabs.location",n.TabsFocusMode="terminal.integrated.tabs.focusMode",n.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",n.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",n.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",n.CopyOnSelection="terminal.integrated.copyOnSelection",n.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",n.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",n.FontFamily="terminal.integrated.fontFamily",n.FontSize="terminal.integrated.fontSize",n.LetterSpacing="terminal.integrated.letterSpacing",n.LineHeight="terminal.integrated.lineHeight",n.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",n.TabStopWidth="terminal.integrated.tabStopWidth",n.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",n.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",n.BellDuration="terminal.integrated.bellDuration",n.FontWeight="terminal.integrated.fontWeight",n.FontWeightBold="terminal.integrated.fontWeightBold",n.CursorBlinking="terminal.integrated.cursorBlinking",n.CursorStyle="terminal.integrated.cursorStyle",n.CursorStyleInactive="terminal.integrated.cursorStyleInactive",n.CursorWidth="terminal.integrated.cursorWidth",n.Scrollback="terminal.integrated.scrollback",n.DetectLocale="terminal.integrated.detectLocale",n.DefaultLocation="terminal.integrated.defaultLocation",n.GpuAcceleration="terminal.integrated.gpuAcceleration",n.TerminalTitleSeparator="terminal.integrated.tabs.separator",n.TerminalTitle="terminal.integrated.tabs.title",n.TerminalDescription="terminal.integrated.tabs.description",n.RightClickBehavior="terminal.integrated.rightClickBehavior",n.MiddleClickBehavior="terminal.integrated.middleClickBehavior",n.Cwd="terminal.integrated.cwd",n.ConfirmOnExit="terminal.integrated.confirmOnExit",n.ConfirmOnKill="terminal.integrated.confirmOnKill",n.EnableBell="terminal.integrated.enableBell",n.EnableVisualBell="terminal.integrated.enableVisualBell",n.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",n.AllowChords="terminal.integrated.allowChords",n.AllowMnemonics="terminal.integrated.allowMnemonics",n.TabFocusMode="terminal.integrated.tabFocusMode",n.EnvMacOs="terminal.integrated.env.osx",n.EnvLinux="terminal.integrated.env.linux",n.EnvWindows="terminal.integrated.env.windows",n.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",n.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",n.ExperimentalWindowsUseConptyDll="terminal.integrated.experimental.windowsUseConptyDll",n.ShowExitAlert="terminal.integrated.showExitAlert",n.SplitCwd="terminal.integrated.splitCwd",n.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",n.WordSeparators="terminal.integrated.wordSeparators",n.EnableFileLinks="terminal.integrated.enableFileLinks",n.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",n.UnicodeVersion="terminal.integrated.unicodeVersion",n.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",n.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",n.HideOnStartup="terminal.integrated.hideOnStartup",n.CustomGlyphs="terminal.integrated.customGlyphs",n.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",n.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",n.InheritEnv="terminal.integrated.inheritEnv",n.ShowLinkHover="terminal.integrated.showLinkHover",n.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",n.AutoReplies="terminal.integrated.autoReplies",n.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",n.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",n.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",n.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",n.EnableImages="terminal.integrated.enableImages",n.SmoothScrolling="terminal.integrated.smoothScrolling",n.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",n.FocusAfterRun="terminal.integrated.focusAfterRun",n.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",n.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",n.DevMode="terminal.integrated.developer.devMode"})(O||(e.TerminalSettingId=O={}));var C;(function(n){n.Bash="bash",n.Fish="fish",n.Sh="sh",n.Csh="csh",n.Ksh="ksh",n.Zsh="zsh"})(C||(e.PosixShellType=C={}));var m;(function(n){n.CommandPrompt="cmd",n.Wsl="wsl",n.GitBash="gitbash"})(m||(e.WindowsShellType=m={}));var c;(function(n){n.PowerShell="pwsh",n.Python="python",n.Julia="julia",n.NuShell="nu"})(c||(e.GeneralShellType=c={}));var I;(function(n){n[n.Api=0]="Api",n[n.Process=1]="Process",n[n.Sequence=2]="Sequence",n[n.Config=3]="Config"})(I||(e.TitleEventSource=I={}));var E;(function(n){n.LocalPty="localPty",n.PtyHost="ptyHost",n.PtyHostWindow="ptyHostWindow",n.Logger="logger",n.Heartbeat="heartbeat"})(E||(e.TerminalIpcChannels=E={}));var g;(function(n){n.Cwd="cwd",n.InitialCwd="initialCwd",n.FixedDimensions="fixedDimensions",n.Title="title",n.ShellType="shellType",n.HasChildProcesses="hasChildProcesses",n.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",n.OverrideDimensions="overrideDimensions",n.FailedShellIntegrationActivation="failedShellIntegrationActivation",n.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(g||(e.ProcessPropertyType=g={})),e.$vs=(0,s.$Ii)("ptyService");var P;(function(n){n[n.BeatInterval=5e3]="BeatInterval",n[n.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",n[n.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",n[n.SecondWaitMultiplier=1]="SecondWaitMultiplier",n[n.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(P||(e.HeartbeatConstants=P={}));var b;(function(n){n[n.Panel=1]="Panel",n[n.Editor=2]="Editor"})(b||(e.TerminalLocation=b={}));var a;(function(n){n.TerminalView="view",n.Editor="editor"})(a||(e.TerminalLocationString=a={}));var $;(function(n){n[n.GraceTime=6e4]="GraceTime",n[n.ShortGraceTime=6e3]="ShortGraceTime"})($||(e.LocalReconnectConstants=$={}));var p;(function(n){n[n.HighWatermarkChars=1e5]="HighWatermarkChars",n[n.LowWatermarkChars=5e3]="LowWatermarkChars",n[n.CharCountAckSize=5e3]="CharCountAckSize"})(p||(e.FlowControlConstants=p={}));var u;(function(n){n.GitBash="Git Bash",n.Pwsh="PowerShell"})(u||(e.ProfileSource=u={}));var i;(function(n){n[n.Off=0]="Off",n[n.FinalTerm=1]="FinalTerm",n[n.VSCode=2]="VSCode"})(i||(e.ShellIntegrationStatus=i={}));var o;(function(n){n[n.Unknown=0]="Unknown",n[n.Shutdown=1]="Shutdown",n[n.Process=2]="Process",n[n.User=3]="User",n[n.Extension=4]="Extension"})(o||(e.TerminalExitReason=o={})),e.$ws={Backend:"workbench.contributions.terminal.processBackend"};class t{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(r){const d=this.b(r.remoteAuthority);if(this.a.has(d))throw new Error(`A terminal backend with remote authority '${d}' was already registered.`);this.a.set(d,r)}getTerminalBackend(r){return this.a.get(this.b(r))}b(r){return r?.toLowerCase()??""}}R.$vo.add(e.$ws.Backend,new t),e.$xs=(0,s.$Ii)("localPtyService"),e.$ys=(0,s.$Ii)("terminalLogService")}),define(Re[245],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ryb=void 0;class s{constructor(R){this.b=R,this.a=new Map}dispose(){for(const R of this.a.values())R.dispose()}startBuffering(R,A,O=5){const C=A(m=>{const c=typeof m=="string"?m:m.data;let I=this.a.get(R);if(I){I.data.push(c);return}const E=setTimeout(()=>this.flushBuffer(R),O);I={data:[c],timeoutId:E,dispose:()=>{clearTimeout(E),this.flushBuffer(R),C.dispose()}},this.a.set(R,I)});return C}stopBuffering(R){this.a.get(R)?.dispose()}flushBuffer(R){const A=this.a.get(R);A&&(this.a.delete(R),this.b(R,A.data.join("")))}}e.$ryb=s}),define(Re[246],Ce([1,0,7,84,106,51,4,17,2,8,116,37]),function(ge,e,s,h,R,A,O,C,m,c,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Px=e.$Ox=e.$Nx=e.$Mx=e.$Lx=e.$Kx=e.IconFontDefinition=e.IconContribution=e.$Hx=void 0,e.$Ix=$,e.$Jx=p,E=Ue(E),e.$Hx={IconContribution:"base.contributions.icons"};var g;(function(t){function n(r,d){let l=r.defaults;for(;A.ThemeIcon.isThemeIcon(l);){const f=a.getIcon(l.id);if(!f)return;l=f.defaults}return l}t.getDefinition=n})(g||(e.IconContribution=g={}));var P;(function(t){function n(d){return{weight:d.weight,style:d.style,src:d.src.map(l=>({format:l.format,location:l.location.toString()}))}}t.toJSONObject=n;function r(d){const l=f=>(0,C.$hg)(f)?f:void 0;if(d&&Array.isArray(d.src)&&d.src.every(f=>(0,C.$hg)(f.format)&&(0,C.$hg)(f.location)))return{weight:l(d.weight),style:l(d.style),src:d.src.map(f=>({format:f.format,location:m.URI.parse(f.location)}))}}t.fromJSONObject=r})(P||(e.IconFontDefinition=P={}));class b{constructor(){this.a=new O.$oe,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,c.localize)(2364,null)},fontCharacter:{type:"string",description:(0,c.localize)(2365,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${A.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(n,r,d,l){const f=this.b[n];if(f){if(d&&!f.description){f.description=d,this.d.properties[n].markdownDescription=`${d} $(${n})`;const S=this.e.enum.indexOf(n);S!==-1&&(this.e.enumDescriptions[S]=d),this.a.fire()}return f}const y={id:n,description:d,defaults:r,deprecationMessage:l};this.b[n]=y;const k={$ref:"#/definitions/icons"};return l&&(k.deprecationMessage=l),d&&(k.markdownDescription=`${d}: $(${n})`),this.d.properties[n]=k,this.e.enum.push(n),this.e.enumDescriptions.push(d||""),this.a.fire(),{id:n}}deregisterIcon(n){delete this.b[n],delete this.d.properties[n];const r=this.e.enum.indexOf(n);r!==-1&&(this.e.enum.splice(r,1),this.e.enumDescriptions.splice(r,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(n=>this.b[n])}getIcon(n){return this.b[n]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(n,r){const d=this.f[n];return d||(this.f[n]=r,this.a.fire(),r)}deregisterIconFont(n){delete this.f[n]}getIconFont(n){return this.f[n]}toString(){const n=(f,y)=>f.id.localeCompare(y.id),r=f=>{for(;A.ThemeIcon.isThemeIcon(f.defaults);)f=this.b[f.defaults.id];return`codicon codicon-${f?f.id:""}`},d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.b).map(f=>this.b[f]);for(const f of l.filter(y=>!!y.description).sort(n))d.push(`|<i class="${r(f)}"></i>|${f.id}|${A.ThemeIcon.isThemeIcon(f.defaults)?f.defaults.id:f.id}|${f.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const f of l.filter(y=>!A.ThemeIcon.isThemeIcon(y.defaults)).sort(n))d.push(`|<i class="${r(f)}"></i>|${f.id}|`);return d.join(`
`)}}const a=new b;E.$vo.add(e.$Hx.IconContribution,a);function $(t,n,r,d){return a.registerIcon(t,n,r,d)}function p(){return a}function u(){const t=(0,R.$4j)();for(const n in t){const r="\\"+t[n].toString(16);a.registerIcon(n,{fontCharacter:r})}}u(),e.$Kx="vscode://schemas/icons";const i=E.$vo.as(I.$wo.JSONContribution);i.registerSchema(e.$Kx,a.getIconSchema());const o=new s.$Uh(()=>i.notifySchemaChanged(e.$Kx),200);a.onDidChange(()=>{o.isScheduled()||o.schedule()}),e.$Lx=$("widget-close",h.$8j.close,(0,c.localize)(2366,null)),e.$Mx=$("goto-previous-location",h.$8j.arrowUp,(0,c.localize)(2367,null)),e.$Nx=$("goto-next-location",h.$8j.arrowDown,(0,c.localize)(2368,null)),e.$Ox=A.ThemeIcon.modify(h.$8j.sync,"spin"),e.$Px=A.ThemeIcon.modify(h.$8j.loading,"spin")}),define(Re[93],Ce([1,0,4,3,10,2,46,5,11]),function(ge,e,s,h,R,A,O,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ww=e.$Vw=e.$Sw=e.$Qw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Mw=e.$Lw=void 0,e.$Nw=E,e.$Ow=P,e.$Pw=b,e.$Rw=a,e.$Tw=$,e.$Uw=p,e.$Lw=(0,C.$Ii)("tunnelService"),e.$Mw=(0,C.$Ii)("sharedTunnelsService");var c;(function(o){o.Http="http",o.Https="https"})(c||(e.TunnelProtocol=c={}));var I;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})(I||(e.TunnelPrivacyId=I={}));function E(o){return!!o.forwardPort}var g;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function P(o){if(o.scheme!=="http"&&o.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(t)return{address:t[1],port:+t[2]}}function b(o){if(o.scheme!=="http"&&o.scheme!=="https"||!o.query)return;const t=o.query.split("&");for(const n of t){const r=n.split("=")[1];if(/^https?:/.exec(r)){const d=P(A.URI.parse(r));if(d)return d}}}e.$Qw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function a(o){return e.$Qw.indexOf(o)>=0}e.$Sw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function $(o){return e.$Sw.indexOf(o)>=0}function p(o,t,n,r){if(n===R.OperatingSystem.Windows)return!1;if(n===R.OperatingSystem.Macintosh&&$(t)){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(r);if(d?.length===4&&parseInt(d[1])>=18)return!1}return o<1024}class u{constructor(t,n,r){this.remoteAddress=t,this.localAddress=n,this.b=r,this.a=new s.$oe,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Vw=u;let i=class extends h.$Xc{constructor(t,n){super(),this.r=t,this.s=n,this.a=new s.$oe,this.onTunnelOpened=this.a.event,this.b=new s.$oe,this.onTunnelClosed=this.b.event,this.c=new s.$oe,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const t=this.s.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.g=t,t?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.h=t.elevation,this.m=t.privacyOptions,this.j=t.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const t=[],n=Array.from(this.f.values());for(const r of n){const d=Array.from(r.values());for(const l of d){const f=await l.value;f&&typeof f!="string"&&t.push(f)}}return t}async dispose(){super.dispose();for(const t of this.f.values()){for(const{value:n}of t.values())await n.then(r=>typeof r!="string"?r?.dispose():void 0);t.clear()}this.f.clear()}setEnvironmentTunnel(t,n,r,d,l){this.z(t,n,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:n,localAddress:r,privacy:d,protocol:l,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,n){($(t)||a(t))&&(t=e.$Qw[0]);const r=this.D(t,n);if(r)return++r.refcount,r.value}openTunnel(t,n,r,d,l,f=!1,y,k){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${n}:${r} on local port ${l}.`);const S=this.g??t;if(!S)return;if(n||(n="localhost"),d||(d=this.t),this.g&&this.n.has(r)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const D=this.F(S,n,r,d,l,f,y,k);return D?D.then(T=>{if(T){if(typeof T=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(n,r),T}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(n,r);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const v=this.w(T);return(T.tunnelRemoteHost!==n||T.tunnelRemotePort!==r)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),y&&T.privacy!==y&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(v),v}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),D)}w(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const n=this.f.get(t.tunnelRemoteHost);if(n){const r=n.get(t.tunnelRemotePort);r&&(r.refcount--,await this.y(t.tunnelRemoteHost,t.tunnelRemotePort,r))}}}}async y(t,n,r){if(r.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${n}.`);const d=r.value.then(async l=>{l&&typeof l!="string"&&(await l.dispose(!0),this.b.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this.f.has(t)&&this.f.get(t).delete(n),d}}async closeTunnel(t,n){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${n} `);const r=this.f.get(t);if(r&&r.has(n)){const d=r.get(n);d.refcount=0,await this.y(t,n,d)}}z(t,n,r){this.f.has(t)||this.f.set(t,new Map),this.f.get(t).set(n,{refcount:1,value:r})}async C(t,n){const r=this.f.get(t);if(r){const d=r.get(n),l=d?await d.value:void 0;(!l||typeof l=="string")&&r.delete(n),r.size===0&&this.f.delete(t)}}D(t,n){const r=[t];a(t)?(r.push(...e.$Qw),r.push(...e.$Sw)):$(t)&&r.push(...e.$Sw);const d=r.map(l=>this.f.get(l));for(const l of d){const f=l?.get(n);if(f)return f}}canTunnel(t){return!!P(t)}G(t,n,r,d,l,f,y){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${n}:${r} on local port ${d}.`);const k=r;this.n.add(k);const S=d===void 0?r:d,D={elevationRequired:l?this.isPortPrivileged(S):!1},T={remoteAddress:{host:n,port:r},localAddressPort:d,privacy:f,public:f?f!==I.Private:void 0,protocol:y},v=t.forwardPort(T,D);return v?(this.z(n,r,v),v.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(k)})):this.n.delete(k),v}};e.$Ww=i,e.$Ww=i=Ze([qe(0,m.$dk),qe(1,O.$cj)],i)}),define(Re[152],Ce([1,0,5]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=void 0,e.$Nl=(0,s.$Ii)("IUriIdentityService")}),define(Re[247],Ce([1,0,5]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Xw=void 0,e.$Xw=(0,s.$Ii)("editSessionIdentityService");var h;(function(R){R[R.Complete=100]="Complete",R[R.Partial=50]="Partial",R[R.None=0]="None"})(h||(e.EditSessionIdentityMatch=h={}))}),define(Re[248],Ce([1,0,14]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zN=h,e.$AN=R,e.$BN=A,e.$CN=O,e.$DN=C;function h(m){return m.scheme!==s.Schemas.file&&m.scheme!==s.Schemas.vscodeRemote}function R(m){if(m.folders.length)return m.folders.every(c=>h(c.uri))?m.folders[0].uri:void 0;if(m.configuration&&h(m.configuration))return m.configuration}function A(m){return R(m)?.scheme}function O(m){return R(m)?.authority}function C(m){return R(m)!==void 0}}),define(Re[47],Ce([1,0,8,16,62,22,2,5,14]),function(ge,e,s,h,R,A,O,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$i=e.$8i=e.$7i=e.$6i=e.$5i=e.$3i=e.$2i=e.WorkbenchState=e.$Vi=e.$Ui=e.$Ri=void 0,e.$Si=c,e.$Ti=I,e.$Wi=E,e.$Xi=g,e.$Yi=P,e.$Zi=a,e.$1i=$,e.$4i=i,e.$9i=o,e.$0i=t,e.$_i=n,e.$aj=r,e.$bj=d,e.$Ri=(0,C.$Ii)("contextService");function c(l){const f=l;return typeof f?.id=="string"&&O.URI.isUri(f.uri)}function I(l){return typeof l?.id=="string"&&!c(l)&&!g(l)}e.$Ui={id:"ext-dev"},e.$Vi={id:"empty-window"};function E(l,f){if(typeof l=="string"||typeof l>"u")return typeof l=="string"?{id:(0,h.$qc)(l)}:f?e.$Ui:e.$Vi;const y=l;return y.configuration?{id:y.id,configPath:y.configuration}:y.folders.length===1?{id:y.id,uri:y.folders[0].uri}:{id:y.id}}function g(l){const f=l;return typeof f?.id=="string"&&O.URI.isUri(f.configPath)}function P(l){const f=l;if(f?.uri)return{id:f.id,uri:O.URI.revive(f.uri)};const y=l;if(y?.configPath)return{id:y.id,configPath:O.URI.revive(y.configPath)};if(l?.id)return{id:l.id}}var b;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(b||(e.WorkbenchState=b={}));function a(l){const f=l;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}function $(l){const f=l;return!!(f&&typeof f=="object"&&O.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}class p{constructor(f,y,k,S,D){this.h=f,this.j=k,this.k=S,this.l=D,this.c=R.$Oi.forUris(this.l,()=>!0),this.folders=y}update(f){this.h=f.id,this.k=f.configuration,this.j=f.transient,this.l=f.l,this.folders=f.folders}get folders(){return this.g}set folders(f){this.g=f,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(f){this.k=f}getFolder(f){return f&&this.c.findSubstr(f)||null}n(){this.c=R.$Oi.forUris(this.l,()=>!0);for(const f of this.folders)this.c.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$2i=p;class u{constructor(f,y){this.raw=y,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return(0,A.$jh)(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$3i=u;function i(l){return new u({uri:l,index:0,name:(0,A.$fh)(l)},{uri:l.toString()})}e.$5i="code-workspace",e.$6i=`.${e.$5i}`,e.$7i=[{name:(0,s.localize)(2489,null),extensions:[e.$5i]}],e.$8i="workspace.json";function o(l,f){return A.$ah.isEqualOrParent(l,f.untitledWorkspacesHome)}function t(l){let f;return O.URI.isUri(l)?f=l:f=l.configuration,f?.scheme===m.Schemas.tmp}e.$$i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(l){return l.id===e.$$i}function r(l,f){return!o(l,f)&&!t(l)}function d(l){return(typeof l=="string"?(0,h.$rc)(l):(0,A.$hh)(l))===e.$6i}}),define(Re[153],Ce([1,0,61,4,3,22,2,8,146,27,5,11,47,28,152,7,32,13,17]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P,b,a,$,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=e.$Pl=e.ProfileResourceType=void 0,e.$Ol=o,e.$Ql=t,e.$Rl=n;var i;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Tasks="tasks",l.Extensions="extensions",l.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function o(l){const f=l;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&typeof f.isDefault=="boolean"&&typeof f.name=="string"&&O.URI.isUri(f.location)&&O.URI.isUri(f.globalStorageHome)&&O.URI.isUri(f.settingsResource)&&O.URI.isUri(f.keybindingsResource)&&O.URI.isUri(f.tasksResource)&&O.URI.isUri(f.snippetsHome)&&O.URI.isUri(f.extensionsResource))}e.$Pl=(0,I.$Ii)("IUserDataProfilesService");function t(l,f){return{id:l.id,isDefault:l.isDefault,name:l.name,shortName:l.shortName,icon:l.icon,location:O.URI.revive(l.location).with({scheme:f}),globalStorageHome:O.URI.revive(l.globalStorageHome).with({scheme:f}),settingsResource:O.URI.revive(l.settingsResource).with({scheme:f}),keybindingsResource:O.URI.revive(l.keybindingsResource).with({scheme:f}),tasksResource:O.URI.revive(l.tasksResource).with({scheme:f}),snippetsHome:O.URI.revive(l.snippetsHome).with({scheme:f}),extensionsResource:O.URI.revive(l.extensionsResource).with({scheme:f}),cacheHome:O.URI.revive(l.cacheHome).with({scheme:f}),useDefaultFlags:l.useDefaultFlags,isTransient:l.isTransient}}function n(l,f,y,k,S,D){return{id:l,name:f,location:y,isDefault:!1,shortName:S?.shortName,icon:S?.icon,globalStorageHome:D&&S?.useDefaultFlags?.globalState?D.globalStorageHome:(0,A.$jh)(y,"globalStorage"),settingsResource:D&&S?.useDefaultFlags?.settings?D.settingsResource:(0,A.$jh)(y,"settings.json"),keybindingsResource:D&&S?.useDefaultFlags?.keybindings?D.keybindingsResource:(0,A.$jh)(y,"keybindings.json"),tasksResource:D&&S?.useDefaultFlags?.tasks?D.tasksResource:(0,A.$jh)(y,"tasks.json"),snippetsHome:D&&S?.useDefaultFlags?.snippets?D.snippetsHome:(0,A.$jh)(y,"snippets"),extensionsResource:D&&S?.useDefaultFlags?.extensions?D.extensionsResource:(0,A.$jh)(y,"extensions.json"),cacheHome:(0,A.$jh)(k,l),useDefaultFlags:S?.useDefaultFlags,isTransient:S?.transient}}let r=class extends R.$Xc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(f,y,k,S){super(),this.t=f,this.u=y,this.w=k,this.y=S,this.f=!0,this.h=this.B(new h.$oe),this.onDidChangeProfiles=this.h.event,this.j=this.B(new h.$oe),this.onWillCreateProfile=this.j.event,this.m=this.B(new h.$oe),this.onWillRemoveProfile=this.m.event,this.n=this.B(new h.$oe),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new P.$Dc,workspaces:new P.$Dc,emptyWindows:new Map},this.profilesHome=(0,A.$jh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$jh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(f){this.f!==f&&(this.z=void 0,this.f=f)}isEnabled(){return this.f}get C(){if(!this.z){const f=this.D(),y=[f];if(this.f)try{for(const D of this.O()){if(!D.name||!(0,u.$hg)(D.name)||!D.location){this.y.warn("Skipping the invalid stored profile",D.location||D.name);continue}y.push(n((0,A.$gh)(D.location),D.name,D.location,this.g,{shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags},f))}}catch(D){this.y.error(D)}const k=new P.$Dc,S=new Map;if(y.length)try{const D=this.Q();if(D.workspaces)for(const[T,v]of Object.entries(D.workspaces)){const w=O.URI.parse(T),M=y.find(L=>L.id===v);M&&k.set(w,M)}if(D.emptyWindows)for(const[T,v]of Object.entries(D.emptyWindows)){const w=y.find(M=>M.id===v);w&&S.set(T,w)}}catch(D){this.y.error(D)}this.z={profiles:y,workspaces:k,emptyWindows:S}}return this.z}D(){const f=n("__default__profile__",(0,C.localize)(2442,null),this.t.userRoamingDataHome,this.g);return{...f,extensionsResource:this.S()??f.extensionsResource,isDefault:!0}}async createTransientProfile(f){const y="Temp",k=new RegExp(`${(0,p.$kf)(y)}\\s(\\d+)`);let S=0;for(const T of this.profiles){const v=k.exec(T.name),w=v?parseInt(v[1]):0;S=w>S?w:S}const D=`${y} ${S+1}`;return this.createProfile((0,s.$wj)((0,$.$5g)()).toString(16),D,{transient:!0},f)}async createNamedProfile(f,y,k){return this.createProfile((0,s.$wj)((0,$.$5g)()).toString(16),f,y,k)}async createProfile(f,y,k,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=await this.F(f,y,k);return S&&await this.setProfileForWorkspace(S,D),D}async F(f,y,k){if(!(0,u.$hg)(y)||!y)throw new Error("Name of the profile is mandatory and must be of type `string`");let S=this.r.get(y);return S||(S=(async()=>{try{if(this.profiles.find(w=>w.name===y||w.id===f))throw new Error(`Profile with ${y} name already exists`);const T=n(f,y,(0,A.$jh)(this.profilesHome,f),this.g,k,this.defaultProfile);await this.u.createFolder(T.location);const v=[];return this.j.fire({profile:T,join(w){v.push(w)}}),await a.Promises.settled(v),this.I([T],[],[]),T}finally{this.r.delete(y)}})(),this.r.set(y,S)),S}async updateProfile(f,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let k=this.profiles.find(S=>S.id===f.id);if(!k)throw new Error(`Profile '${f.name}' does not exist`);return k=n(k.id,y.name??k.name,k.location,this.g,{shortName:y.shortName??k.shortName,icon:y.icon===null?void 0:y.icon??k.icon,transient:y.transient??k.isTransient,useDefaultFlags:y.useDefaultFlags??k.useDefaultFlags},this.defaultProfile),this.I([],[],[k]),k}async removeProfile(f){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(f.isDefault)throw new Error("Cannot remove default profile");const y=this.profiles.find(S=>S.id===f.id);if(!y)throw new Error(`Profile '${f.name}' does not exist`);const k=[];this.m.fire({profile:y,join(S){k.push(S)}});try{await Promise.allSettled(k)}catch(S){this.y.error(S)}for(const S of[...this.C.emptyWindows.keys()])y.id===this.C.emptyWindows.get(S)?.id&&this.C.emptyWindows.delete(S);for(const S of[...this.C.workspaces.keys()])y.id===this.C.workspaces.get(S)?.id&&this.C.workspaces.delete(S);this.M(),this.I([],[y],[]);try{await this.u.del(y.cacheHome,{recursive:!0})}catch(S){(0,c.$ul)(S)!==c.FileOperationResult.FILE_NOT_FOUND&&this.y.error(S)}}async setProfileForWorkspace(f,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=this.profiles.find(S=>S.id===y.id);if(!k)throw new Error(`Profile '${y.name}' does not exist`);this.L(f,k)}unsetWorkspace(f,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(f,void 0,y)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const f=await this.u.resolve(this.profilesHome);await Promise.all((f.children||[]).filter(y=>y.isDirectory&&this.profiles.every(k=>!this.w.extUri.isEqual(k.location,y.resource))).map(y=>this.u.del(y.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const f=this.s.profiles.filter(y=>!this.H(y));await Promise.allSettled(f.map(y=>this.removeProfile(y)))}getProfileForWorkspace(f){const y=this.G(f),k=O.URI.isUri(y)?this.C.workspaces.get(y):this.C.emptyWindows.get(y);return k||((0,g.$Si)(f)?this.s.folders.get(f.uri):(0,g.$Xi)(f)?this.s.workspaces.get(f.configPath):this.s.emptyWindows.get(f.id))}G(f){return(0,g.$Si)(f)?f.uri:(0,g.$Xi)(f)?f.configPath:f.id}H(f){return!!([...this.C.emptyWindows.values()].some(y=>this.w.extUri.isEqual(y.location,f.location))||[...this.C.workspaces.values()].some(y=>this.w.extUri.isEqual(y.location,f.location))||[...this.s.emptyWindows.values()].some(y=>this.w.extUri.isEqual(y.location,f.location))||[...this.s.workspaces.values()].some(y=>this.w.extUri.isEqual(y.location,f.location))||[...this.s.folders.values()].some(y=>this.w.extUri.isEqual(y.location,f.location)))}I(f,y,k){const S=[...this.profiles,...f],D=[],T=this.s.profiles;this.s.profiles=[];for(let v of S){if(v.isDefault||y.some(M=>v.id===M.id))continue;v=k.find(M=>v.id===M.id)??v;const w=T.find(M=>v.id===M.id);if(v.isTransient)this.s.profiles.push(v);else{if(w){for(const[M,L]of this.s.emptyWindows.entries())if(v.id===L.id){this.L({id:M},v);break}for(const[M,L]of this.s.workspaces.entries())if(v.id===L.id){this.L({id:"",configPath:M},v);break}for(const[M,L]of this.s.folders.entries())if(v.id===L.id){this.L({id:"",uri:M},v);break}}D.push({location:v.location,name:v.name,shortName:v.shortName,icon:v.icon,useDefaultFlags:v.useDefaultFlags})}}this.P(D),this.z=void 0,this.J(f,y,k)}J(f,y,k){this.h.fire({added:f,removed:y,updated:k,all:this.profiles})}L(f,y,k){if(k=y?.isTransient?!0:k,k)(0,g.$Si)(f)?(this.s.folders.delete(f.uri),y&&this.s.folders.set(f.uri,y)):(0,g.$Xi)(f)?(this.s.workspaces.delete(f.configPath),y&&this.s.workspaces.set(f.configPath,y)):(this.s.emptyWindows.delete(f.id),y&&this.s.emptyWindows.set(f.id,y));else{this.L(f,void 0,!0);const S=this.G(f);O.URI.isUri(S)?(this.C.workspaces.delete(S),y&&this.C.workspaces.set(S,y)):(this.C.emptyWindows.delete(S),y&&this.C.emptyWindows.set(S,y)),this.M()}}M(){const f={};for(const[k,S]of this.C.workspaces.entries())f[k.toString()]=S.id;const y={};for(const[k,S]of this.C.emptyWindows.entries())y[k.toString()]=S.id;this.R({workspaces:f,emptyWindows:y}),this.z=void 0}N(f){const y={},k=this.D();if(f.workspaces)for(const[D,T]of Object.entries(f.workspaces)){const v=O.URI.parse(T);y[D]=this.w.extUri.isEqual(v,k.location)?k.id:this.w.extUri.basename(v)}const S={};if(f.emptyWindows)for(const[D,T]of Object.entries(f.emptyWindows)){const v=O.URI.parse(T);S[D]=this.w.extUri.isEqual(v,k.location)?k.id:this.w.extUri.basename(v)}return{workspaces:y,emptyWindows:S}}O(){return[]}P(f){throw new Error("not implemented")}Q(){return{}}R(f){throw new Error("not implemented")}S(){}};e.$Sl=r,e.$Sl=r=Ze([qe(0,m.$Pi),qe(1,c.$dl),qe(2,b.$Nl),qe(3,E.$dk)],r);class d extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(f){this.a=f}Q(){return this.X}R(f){this.X=f}}e.$Tl=d}),define(Re[154],Ce([1,0,7,4,3,63,17,195,5,153]),function(ge,e,s,h,R,A,O,C,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=e.$oq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$mq=e.$lq=e.$kq=void 0,e.$nq=P,e.$pq=a,e.$rq=p,e.$kq="__$__isNewStorageMarker",e.$lq="__$__targetStorageMarker",e.$mq=(0,m.$Ii)("storageService");var I;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(I||(e.WillSaveStateReason=I={}));var E;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(E||(e.StorageScope=E={}));var g;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(g||(e.StorageTarget=g={}));function P(u){const i=u.get(e.$lq);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class b extends R.$Xc{static{this.a=60*1e3}constructor(i={flushInterval:b.a}){super(),this.m=i,this.b=this.B(new h.$re),this.c=this.B(new h.$re),this.onDidChangeTarget=this.c.event,this.f=this.B(new h.$oe),this.onWillSaveState=this.f.event,this.h=this.B(new s.$Uh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new R.$Yc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,o,t){return h.Event.filter(this.b.event,n=>n.scope===i&&(o===void 0||n.key===o),t)}n(){this.j.value=(0,s.$Yh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,R.$Sc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,o){const{key:t,external:n}=o;if(t===e.$lq){switch(i){case E.APPLICATION:this.H=void 0;break;case E.PROFILE:this.F=void 0;break;case E.WORKSPACE:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:t,target:this.J(i)[t],external:n})}w(i){this.f.fire({reason:i})}get(i,o,t){return this.P(o)?.get(i,t)}getBoolean(i,o,t){return this.P(o)?.getBoolean(i,t)}getNumber(i,o,t){return this.P(o)?.getNumber(i,t)}getObject(i,o,t){return this.P(o)?.getObject(i,t)}storeAll(i,o){this.y(()=>{for(const t of i)this.store(t.key,t.value,t.scope,t.target,o)})}store(i,o,t,n,r=!1){if((0,O.$qg)(o)){this.remove(i,t,r);return}this.y(()=>{this.z(i,t,n),this.P(t)?.set(i,o,r)})}remove(i,o,t=!1){this.y(()=>{this.z(i,o,void 0),this.P(o)?.delete(i,t)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,o){const t=[],n=this.J(i);for(const r of Object.keys(n))n[r]===o&&t.push(r);return t}z(i,o,t,n=!1){const r=this.J(o);typeof t=="number"?r[i]!==t&&(r[i]=t,this.P(o)?.set(e.$lq,JSON.stringify(r),n)):typeof r[i]=="number"&&(delete r[i],this.P(o)?.set(e.$lq,JSON.stringify(r),n))}get D(){return this.C||(this.C=this.L(E.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(E.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(E.APPLICATION)),this.H}J(i){switch(i){case E.APPLICATION:return this.I;case E.PROFILE:return this.G;default:return this.D}}L(i){const o=this.P(i);return o?P(o):Object.create(null)}isNew(i){return this.getBoolean(e.$kq,i)===!0}async flush(i=I.NONE){this.f.fire({reason:i});const o=this.P(E.APPLICATION),t=this.P(E.PROFILE),n=this.P(E.WORKSPACE);switch(i){case I.NONE:await s.Promises.settled([o?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await s.Promises.settled([o?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(E.APPLICATION)?.items??new Map,o=this.P(E.PROFILE)?.items??new Map,t=this.P(E.WORKSPACE)?.items??new Map;return p(i,o,t,this.Q(E.APPLICATION)??"",this.Q(E.PROFILE)??"",this.Q(E.WORKSPACE)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,o){return this.w(I.NONE),(0,c.$Ol)(i)?this.R(i,o):this.S(i,o)}M(i,o){return!(i.id===o.id||a(o)&&a(i))}N(i,o,t){this.y(()=>{const n=new Set;for(const[r,d]of i)n.add(r),o.get(r)!==d&&this.u(t,{key:r,external:!0});for(const[r]of o.items)n.has(r)||this.u(t,{key:r,external:!0})})}}e.$oq=b;function a(u){return u.isDefault||!!u.useDefaultFlags?.globalState}class $ extends b{constructor(){super(),this.U=this.B(new C.$iq(new C.$jq,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new C.$iq(new C.$jq,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new C.$iq(new C.$jq,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(E.WORKSPACE,i))),this.B(this.W.onDidChangeStorage(i=>this.u(E.PROFILE,i))),this.B(this.U.onDidChangeStorage(i=>this.u(E.APPLICATION,i)))}P(i){switch(i){case E.APPLICATION:return this.U;case E.PROFILE:return this.W;default:return this.X}}Q(i){switch(i){case E.APPLICATION:return"inMemory (application)";case E.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$qq=$;async function p(u,i,o,t,n,r){const d=w=>{try{return JSON.parse(w)}catch{return w}},l=new Map,f=new Map;u.forEach((w,M)=>{l.set(M,w),f.set(M,d(w))});const y=new Map,k=new Map;i.forEach((w,M)=>{y.set(M,w),k.set(M,d(w))});const S=new Map,D=new Map;o.forEach((w,M)=>{S.set(M,w),D.set(M,d(w))}),console.group(t!==n?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const T=[];if(l.forEach((w,M)=>{T.push({key:M,value:w})}),console.table(T),console.groupEnd(),console.log(f),t!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const w=[];y.forEach((M,L)=>{w.push({key:L,value:M})}),console.table(w),console.groupEnd(),console.log(k)}console.group(`Storage: Workspace (path: ${r})`);const v=[];S.forEach((w,M)=>{v.push({key:M,value:w})}),console.table(v),console.groupEnd(),console.log(D)}}),define(Re[118],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xqc=void 0;class s{static{this.a=!1}constructor(R){this.d=R,this.b=new Map,this.c=1}add(R){const A=this.c++;return this.b.set(A,R),this.e(),A}get(R,A){return this.b.has(R)?this.b.get(R)[A]:void 0}delete(R){this.b.delete(R),this.e()}e(){s.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$xqc=s}),define(Re[64],Ce([1,0,14,22,27,5]),function(ge,e,s,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dqc=e.$Cqc=void 0;class O{constructor(){this.a=new Set(Object.keys(s.Schemas)),this.b=new Map,this.extUri=new h.$$g(m=>{const c=this.b.get(m.scheme);return!(c===void 0||c&R.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos(m,c){c===null?this.b.delete(m.scheme):this.b.set(m.scheme,c)}isFreeScheme(m){return!this.b.has(m)&&!this.a.has(m)}getCapabilities(m){return this.b.get(m)}}e.$Cqc=O,e.$Dqc=(0,A.$Ii)("IExtHostFileSystemInfo")}),define(Re[29],Ce([1,0,5]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TQ=void 0,e.$TQ=(0,s.$Ii)("IExtHostInitDataService")}),define(Re[249],Ce([1,0,8,11,230,29]),function(ge,e,s,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qsc=void 0;let O=class extends R.$4R{constructor(m,c,I){const E=I.remote.isRemote?"remoteexthost":m?"workerexthost":"exthost",g=I.remote.isRemote?(0,s.localize)(2706,null):m?(0,s.localize)(2707,null):(0,s.localize)(2708,null);super(c.createLogger(E,{name:g}))}};e.$Qsc=O,e.$Qsc=O=Ze([qe(1,h.$ek),qe(2,A.$TQ)],O)}),define(Re[250],Ce([1,0,7]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jrc=e.$irc=void 0;class h{constructor(O,C,m){this.h=new Map,this.a=O,this.b=C,this.c=m,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(c=>(this.f=c,this)),this.g=this.c.onDidChangeStorage(c=>{c.shared===this.b&&c.key===this.a&&(this.f=c.value)}),this.i=new s.$Uh(()=>{const c=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const I of c.values())I.complete()}catch(I){for(const E of c.values())E.error(I)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,O])=>O!==void 0).map(([O])=>O)}get whenReady(){return this.d}get(O,C){let m=this.f[O];return typeof m>"u"&&(m=C),m}update(O,C){this.f[O]=C;const m=this.h.get(O);if(m!==void 0)return m.p;const c=new s.$6h;return this.h.set(O,c),this.i.isScheduled()||this.i.schedule(),c.p}dispose(){this.g.dispose()}}e.$irc=h;class R extends h{setKeysForSync(O){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},O)}constructor(O,C){super(O.identifier.value,!0,C),this.j=O}}e.$jrc=R}),define(Re[251],Ce([1,0,4,2]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$isc=void 0;class R{constructor(O){this.c=O,this.a=new s.$oe,this.onDidSaveNotebookDocument=this.a.event,this.b=new s.$oe,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(O,C,m,c){const E=this.c.getNotebookDocument(h.URI.revive(O)).acceptModelChanged(C.value,m,c);this.b.fire(E)}$acceptDirtyStateChanged(O,C){this.c.getNotebookDocument(h.URI.revive(O)).acceptDirty(C)}$acceptModelSaved(O){const C=this.c.getNotebookDocument(h.URI.revive(O));this.a.fire(C.apiNotebook)}}e.$isc=R}),define(Re[19],Ce([1,0,5]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EQ=e.$DQ=void 0,e.$DQ=(0,s.$Ii)("IExtHostRpcService");class h{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.$EQ=h}),define(Re[252],Ce([1,0,23,4,3]),function(ge,e,s,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$src=void 0;class A{#e;constructor(C,m){this.disposables=new R.$Wc,this.a=s.$vn.toKey(C.identifier),this.#e=m,this.onDidChange=h.Event.map(h.Event.filter(this.#e.onDidChangePassword,c=>c.extensionId===this.a),c=>({key:c.key}),this.disposables)}dispose(){this.disposables.dispose()}get(C){return this.#e.get(this.a,C)}store(C,m){return this.#e.store(this.a,C,m)}delete(C){return this.#e.delete(this.a,C)}}e.$src=A}),define(Re[74],Ce([1,0,5]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tqc=e.$Sqc=void 0,e.$Sqc=(0,s.$Ii)("IURITransformerService");class h{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=O=>O,this.transformOutgoing=O=>O,this.transformOutgoingURI=O=>O,this.transformOutgoingScheme=O=>O)}}e.$Tqc=h}),define(Re[253],Ce([1,0,254,363,364,69,2,11,365]),function(ge,e,s,h,R,A,O,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ntc=I,s=Ue(s),h=Ue(h),R=Ue(R),A=Ue(A);const c=!1;function I(i,o,t,n,r,d){const l=d.environment.useHostProxy,f=typeof l=="boolean"?l:!d.remote.isRemote,y={resolveProxy:D=>i.resolveProxy(D),lookupProxyAuthorization:$.bind(void 0,i,n,r,o,{},{},d.remote.isRemote,f),getProxyURL:()=>o.getConfiguration("http").get("proxy"),getProxySupport:()=>o.getConfiguration("http").get("proxySupport")||"off",getNoProxyConfig:()=>o.getConfiguration("http").get("noProxy")||[],addCertificatesV1:()=>g(o),addCertificatesV2:()=>P(o),log:n,getLogLevel:()=>{const D=n.getLevel();switch(D){case C.LogLevel.Trace:return m.LogLevel.Trace;case C.LogLevel.Debug:return m.LogLevel.Debug;case C.LogLevel.Info:return m.LogLevel.Info;case C.LogLevel.Warning:return m.LogLevel.Warning;case C.LogLevel.Error:return m.LogLevel.Error;case C.LogLevel.Off:return m.LogLevel.Off;default:return T(D)}function T(v){return n.error("Unknown log level",v),m.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:f,loadAdditionalCertificates:async()=>{const D=[];if(d.remote.isRemote&&D.push((0,m.loadSystemCertificates)({log:n})),f){n.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const T=i.loadCertificates();T.then(v=>n.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",v.length)),D.push(T)}return d.environment.extensionTestsLocationURI&&h.globalAgent.testCertificates?.length&&(n.trace("ProxyResolver#loadAdditionalCertificates: Loading test certificates"),D.push(Promise.resolve(h.globalAgent.testCertificates))),(await Promise.all(D)).flat()},env:process.env},k=(0,m.createProxyResolver)(y),S=E(y,k);return a(t,S)}function E(i,o){function t(n,r){return Object.assign(n.default||n,r)}return{http:t(s,(0,m.createHttpPatch)(i,s,o)),https:t(h,(0,m.createHttpPatch)(i,h,o)),net:t(A,(0,m.createNetPatch)(i,A)),tls:t(R,(0,m.createTlsPatch)(i,R))}}function g(i){const o=i.getConfiguration("http");return!o.get("experimental.systemCertificatesV2",c)&&!!o.get("systemCertificates")}function P(i){const o=i.getConfiguration("http");return!!o.get("experimental.systemCertificatesV2",c)&&!!o.get("systemCertificates")}const b=new Map;function a(i,o){return i.getExtensionPathIndex().then(t=>{const n=globalThis._VSCODE_NODE_MODULES.module,r=n._load;n._load=function(l,f,y){if(l==="net")return o.net;if(l==="tls")return o.tls;if(l!=="http"&&l!=="https")return r.apply(this,arguments);const k=t.findSubstr(O.URI.file(f.filename));let S=b.get(k);if(S||b.set(k,S={}),!S[l]){const D=o[l];S[l]={...D}}return S[l]}})}async function $(i,o,t,n,r,d,l,f,y,k,S){const D=r[y];k&&(r[y]=k),o.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${y}`,`proxyAuthenticate:${k}`,`proxyAuthenticateCache:${D}`);const T=k||D,v=Array.isArray(T)?T:typeof T=="string"?[T]:[];if(u(t,v,l),v.some(M=>/^(Negotiate|Kerberos)( |$)/i.test(M))&&!S.kerberosRequested){S.kerberosRequested=!0;try{const M=await new Promise((j,U)=>{ge(["kerberos"],j,U)}).then(Ue),L=new URL(y),N=n.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${L.hostname}`:`HTTP@${L.hostname}`);return o.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${y}`,`spn:${N}`),"Negotiate "+await(await M.initializeClient(N)).step("")}catch(M){o.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",M)}if(l&&f){o.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup on host",`proxyURL:${y}`);const M=await i.lookupKerberosAuthorization(y);if(M)return"Negotiate "+M}}const w=v.find(M=>/^Basic( |$)/i.test(M));if(w)try{const M=d[y];if(M)if(S.basicAuthCacheUsed)o.debug("ProxyResolver#lookupProxyAuthorization Basic authentication deleting cached credentials",`proxyURL:${y}`),delete d[y];else return o.debug("ProxyResolver#lookupProxyAuthorization Basic authentication using cached credentials",`proxyURL:${y}`),S.basicAuthCacheUsed=!0,M;S.basicAuthAttempt=(S.basicAuthAttempt||0)+1;const L=/ realm="([^"]+)"/i.exec(w)?.[1];o.debug("ProxyResolver#lookupProxyAuthorization Basic authentication lookup",`proxyURL:${y}`,`realm:${L}`);const N=new URL(y),F={scheme:"basic",host:N.hostname,port:Number(N.port),realm:L||"",isProxy:!0,attempt:S.basicAuthAttempt},V=await i.lookupAuthorization(F);if(V){o.debug("ProxyResolver#lookupProxyAuthorization Basic authentication received credentials",`proxyURL:${y}`,`realm:${L}`);const j="Basic "+Buffer.from(`${V.username}:${V.password}`).toString("base64");return d[y]=j,j}else o.debug("ProxyResolver#lookupProxyAuthorization Basic authentication received no credentials",`proxyURL:${y}`,`realm:${L}`)}catch(M){o.error("ProxyResolver#lookupProxyAuthorization Basic authentication failed",M)}}let p=!1;function u(i,o,t){p||!o.length||(p=!0,i.$publicLog2("proxyAuthenticationRequest",{authenticationType:o.map(n=>n.split(" ")[0]).join(","),extensionHostType:t?"remote":"local"}))}}),define(Re[255],Ce([1,0,140]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2s=R;function h(A){return{transformIncoming:O=>O.scheme==="vscode-remote"?{scheme:"file",path:O.path,query:O.query,fragment:O.fragment}:O.scheme==="file"?{scheme:"vscode-local",path:O.path,query:O.query,fragment:O.fragment}:O,transformOutgoing:O=>O.scheme==="file"?{scheme:"vscode-remote",authority:A,path:O.path,query:O.query,fragment:O.fragment}:O.scheme==="vscode-local"?{scheme:"file",path:O.path,query:O.query,fragment:O.fragment}:O,transformOutgoingScheme:O=>O==="file"?"vscode-remote":O==="vscode-local"?"file":O}}function R(A){return new s.$Qn(h(A))}});var Ht=this&&this.__importDefault||function(ge){return ge&&ge.__esModule?ge:{default:ge}};define(Re[155],Ce([1,0,8,17,2,3,5,37,27,14,52,213,44]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$EG=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$uG=e.EditorInputCapabilities=e.$tG=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=void 0,e.$kG=a,e.$lG=$,e.$mG=p,e.$nG=u,e.$oG=i,e.$pG=o,e.$qG=t,e.$rG=n,e.$sG=r,e.$vG=S,e.$wG=T,e.$xG=v,e.$yG=w,e.$zG=M,e.$AG=L,e.$BG=N,e.$CG=F,e.$DG=W,e.$FG=x,e.$GG=ie,e.$HG=me,e.$IG=ue,g=Ht(g),e.$fG={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$gG={id:"default",displayName:(0,s.localize)(4055,null),providerDisplayName:(0,s.localize)(4056,null)},e.$hG="workbench.editor.sidebysideEditor",e.$iG="workbench.editors.textDiffEditor",e.$jG="workbench.editors.binaryResourceDiffEditor";var P;(function(X){X[X.PROGRAMMATIC=1]="PROGRAMMATIC",X[X.USER=2]="USER",X[X.EDIT=3]="EDIT",X[X.NAVIGATION=4]="NAVIGATION",X[X.JUMP=5]="JUMP"})(P||(e.EditorPaneSelectionChangeReason=P={}));var b;(function(X){X[X.IDENTICAL=1]="IDENTICAL",X[X.SIMILAR=2]="SIMILAR",X[X.DIFFERENT=3]="DIFFERENT"})(b||(e.EditorPaneSelectionCompareResult=b={}));function a(X){const q=X;return!!q&&typeof q.getSelection=="function"&&!!q.onDidChangeSelection}function $(X){const q=X;return!!q&&typeof q.getScrollPosition=="function"&&typeof q.setScrollPosition=="function"&&!!q.onDidChangeScroll}function p(X,q,se){for(const be of se.visibleEditorPanes)if(be.group.id===q&&X.matches(be.input))return be.getViewState()}function u(X){if(S(X))return!1;const q=X;return R.URI.isUri(q?.resource)}function i(X){if(S(X))return!1;const q=X;return q?.original!==void 0&&q.modified!==void 0}function o(X){if(S(X))return!1;const q=X;return!q||q.resources&&!Array.isArray(q.resources)?!1:!!q.resources||!!q.multiDiffSource}function t(X){if(S(X)||i(X))return!1;const q=X;return q?.primary!==void 0&&q.secondary!==void 0}function n(X){if(S(X))return!1;const q=X;return q?q.resource===void 0||q.resource.scheme===c.Schemas.untitled||q.forceUntitled===!0:!1}function r(X){if(S(X))return!1;const q=X;return R.URI.isUri(q?.base?.resource)&&R.URI.isUri(q?.input1?.resource)&&R.URI.isUri(q?.input2?.resource)&&R.URI.isUri(q?.result?.resource)}var d;(function(X){X[X.SHORT=0]="SHORT",X[X.MEDIUM=1]="MEDIUM",X[X.LONG=2]="LONG"})(d||(e.Verbosity=d={}));var l;(function(X){X[X.EXPLICIT=1]="EXPLICIT",X[X.AUTO=2]="AUTO",X[X.FOCUS_CHANGE=3]="FOCUS_CHANGE",X[X.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l||(e.SaveReason=l={}));class f{constructor(){this.a=new Map}registerSource(q,se){let be=this.a.get(q);return be||(be={source:q,label:se},this.a.set(q,be)),be.source}getSourceLabel(q){return this.a.get(q)?.label??q}}e.$tG=new f;var y;(function(X){X[X.None=0]="None",X[X.Readonly=2]="Readonly",X[X.Untitled=4]="Untitled",X[X.Singleton=8]="Singleton",X[X.RequiresTrust=16]="RequiresTrust",X[X.CanSplitInGroup=32]="CanSplitInGroup",X[X.ForceDescription=64]="ForceDescription",X[X.CanDropIntoEditor=128]="CanDropIntoEditor",X[X.MultipleEditors=256]="MultipleEditors",X[X.Scratchpad=512]="Scratchpad"})(y||(e.EditorInputCapabilities=y={}));class k extends A.$Xc{}e.$uG=k;function S(X){return X instanceof k}function D(X){const q=X;return R.URI.isUri(q?.preferredResource)}function T(X){const q=X;return S(q?.primary)&&S(q?.secondary)}function v(X){const q=X;return S(q?.modified)&&S(q?.original)}function w(X,q,se,be,ae){return ue(be,[(0,E.$sj)({id:"workbench.action.openLargeFile",label:(0,s.localize)(4057,null),run:()=>{const we={...se,limits:{size:Number.MAX_VALUE}};X.openEditor(q,we)}}),(0,E.$sj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,s.localize)(4058,null),run:()=>ae.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:g.default.Warning})}function M(X){return S(X?.editor)}function L(X){const q=X;return M(X)&&q?.group!==void 0}function N(X){const q=X;return typeof q?.groupId=="number"&&S(q.editor)}function F(X){return typeof X?.groupId=="number"}var V;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.REPLACE=1]="REPLACE",X[X.MOVE=2]="MOVE",X[X.UNPIN=3]="UNPIN"})(V||(e.EditorCloseContext=V={}));var j;(function(X){X[X.GROUP_ACTIVE=0]="GROUP_ACTIVE",X[X.GROUP_INDEX=1]="GROUP_INDEX",X[X.GROUP_LABEL=2]="GROUP_LABEL",X[X.GROUP_LOCKED=3]="GROUP_LOCKED",X[X.EDITORS_SELECTION=4]="EDITORS_SELECTION",X[X.EDITOR_OPEN=5]="EDITOR_OPEN",X[X.EDITOR_CLOSE=6]="EDITOR_CLOSE",X[X.EDITOR_MOVE=7]="EDITOR_MOVE",X[X.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",X[X.EDITOR_LABEL=9]="EDITOR_LABEL",X[X.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",X[X.EDITOR_PIN=11]="EDITOR_PIN",X[X.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",X[X.EDITOR_STICKY=13]="EDITOR_STICKY",X[X.EDITOR_DIRTY=14]="EDITOR_DIRTY",X[X.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(j||(e.GroupModelChangeKind=j={}));var U;(function(X){X[X.PRIMARY=1]="PRIMARY",X[X.SECONDARY=2]="SECONDARY",X[X.BOTH=3]="BOTH",X[X.ANY=4]="ANY"})(U||(e.SideBySideEditor=U={}));class z{getOriginalUri(q,se){if(!q)return;if(r(q))return e.$EG.getOriginalUri(q.result,se);if(se?.supportSideBySide){const{primary:ae,secondary:we}=this.a(q);if(ae&&we){if(se?.supportSideBySide===U.BOTH)return{primary:this.getOriginalUri(ae,{filterByScheme:se.filterByScheme}),secondary:this.getOriginalUri(we,{filterByScheme:se.filterByScheme})};if(se?.supportSideBySide===U.ANY)return this.getOriginalUri(ae,{filterByScheme:se.filterByScheme})??this.getOriginalUri(we,{filterByScheme:se.filterByScheme});q=se.supportSideBySide===U.PRIMARY?ae:we}}if(i(q)||o(q)||t(q)||r(q))return;const be=D(q)?q.preferredResource:q.resource;return!be||!se||!se.filterByScheme?be:this.b(be,se.filterByScheme)}a(q){return T(q)||t(q)?{primary:q.primary,secondary:q.secondary}:v(q)||i(q)?{primary:q.modified,secondary:q.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(q,se){if(!q)return;if(r(q))return e.$EG.getCanonicalUri(q.result,se);if(se?.supportSideBySide){const{primary:ae,secondary:we}=this.a(q);if(ae&&we){if(se?.supportSideBySide===U.BOTH)return{primary:this.getCanonicalUri(ae,{filterByScheme:se.filterByScheme}),secondary:this.getCanonicalUri(we,{filterByScheme:se.filterByScheme})};if(se?.supportSideBySide===U.ANY)return this.getCanonicalUri(ae,{filterByScheme:se.filterByScheme})??this.getCanonicalUri(we,{filterByScheme:se.filterByScheme});q=se.supportSideBySide===U.PRIMARY?ae:we}}if(i(q)||o(q)||t(q)||r(q))return;const be=q.resource;return!be||!se||!se.filterByScheme?be:this.b(be,se.filterByScheme)}b(q,se){if(Array.isArray(se)){if(se.some(be=>q.scheme===be))return q}else if(se===q.scheme)return q}}var _;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.KEYBOARD=1]="KEYBOARD",X[X.MOUSE=2]="MOUSE"})(_||(e.EditorCloseMethod=_={}));function W(X,q,se,be){if(!X.isSticky(q))return!1;switch(be.preventPinnedEditorClose){case"keyboardAndMouse":return se===_.MOUSE||se===_.KEYBOARD;case"mouse":return se===_.MOUSE;case"keyboard":return se===_.KEYBOARD}return!1}e.$EG=new z;var B;(function(X){X[X.LEFT=0]="LEFT",X[X.RIGHT=1]="RIGHT"})(B||(e.CloseDirection=B={}));class Y{constructor(){this.c=new Map,this.d=new Map}start(q){const se=this.a=q.get(O.$Hi);for(const[be,ae]of this.c)this.e(be,ae,se);this.c.clear()}e(q,se,be){const ae=be.createInstance(se);this.d.set(q,ae)}registerFileEditorFactory(q){if(this.b)throw new Error("Can only register one file editor factory.");this.b=q}getFileEditorFactory(){return(0,h.$sg)(this.b)}registerEditorSerializer(q,se){if(this.c.has(q)||this.d.has(q))throw new Error(`A editor serializer with type ID '${q}' was already registered.`);return this.a?this.e(q,se,this.a):this.c.set(q,se),(0,A.$Vc)(()=>{this.c.delete(q),this.d.delete(q)})}getEditorSerializer(q){return this.d.get(typeof q=="string"?q:q.typeId)}}C.$vo.add(e.$fG.EditorFactory,new Y);async function x(X,q,se){return!X||!X.length?[]:await Promise.all(X.map(async be=>{const ae=R.URI.revive(be.fileUri);if(!ae){se.info("Cannot resolve the path because it is not valid.",be);return}if(!await q.canHandleResource(ae)){se.info("Cannot resolve the path because it cannot be handled",be);return}let $e=be.exists,pe=be.type;if(typeof $e!="boolean"||typeof pe!="number")try{pe=(await q.stat(ae)).isDirectory?m.FileType.Directory:m.FileType.Unknown,$e=!0}catch(je){se.error(je),$e=!1}if(!$e&&be.openOnlyIfExists){se.info("Cannot resolve the path because it does not exist",be);return}if(pe===m.FileType.Directory){se.info("Cannot resolve the path because it is a directory",be);return}const Ae={...be.options,pinned:!0};return $e?{resource:ae,options:Ae}:{resource:ae,options:Ae,forceUntitled:!0}}))}var oe;(function(X){X[X.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",X[X.SEQUENTIAL=1]="SEQUENTIAL"})(oe||(e.EditorsOrder=oe={}));function ie(X){const q=X;if(!q)return!1;const se=q;if(se.modified)return ie(se.modified);const be=q;return!!(be.contributionsState&&be.viewState&&Array.isArray(be.cursorState))}function me(X){return(0,I.$uj)(X)}function ue(X,q,se){const be=(0,I.$vj)(X,q);return be.forceMessage=se?.forceMessage,be.forceSeverity=se?.forceSeverity,be.allowDialog=se?.allowDialog,be}}),define(Re[256],Ce([1,0,4,8,5,3,28,37,24,84,246]),function(ge,e,s,h,R,A,O,C,m,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QG=e.$PG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$OG=e.ViewContentGroups=e.$MG=e.ViewContainerLocation=e.Extensions=e.$LG=e.$KG=e.$JG=void 0,e.$NG=P,e.$JG="views",e.$KG=(0,h.localize)(4218,null),e.$LG=(0,I.$Ix)("default-view-icon",c.$8j.window,(0,h.localize)(4219,null));var E;(function(n){n.ViewContainersRegistry="workbench.registry.view.containers",n.ViewsRegistry="workbench.registry.view"})(E||(e.Extensions=E={}));var g;(function(n){n[n.Sidebar=0]="Sidebar",n[n.Panel=1]="Panel",n[n.AuxiliaryBar=2]="AuxiliaryBar"})(g||(e.ViewContainerLocation=g={})),e.$MG=[g.Sidebar,g.Panel,g.AuxiliaryBar];function P(n){switch(n){case g.Sidebar:return"sidebar";case g.Panel:return"panel";case g.AuxiliaryBar:return"auxiliarybar"}}class b extends A.$Xc{constructor(){super(...arguments),this.c=this.B(new s.$oe),this.onDidRegister=this.c.event,this.f=this.B(new s.$oe),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(r,d,l){const f=this.get(r.id);if(f)return f;const y=r;return y.openCommandActionDescriptor=l?.doNotRegisterOpenCommand?void 0:y.openCommandActionDescriptor??{id:y.id},(0,O.$Ac)(this.g,d,[]).push(y),l?.isDefault&&this.h.push(y),this.c.fire({viewContainer:y,viewContainerLocation:d}),y}deregisterViewContainer(r){for(const d of this.g.keys()){const l=this.g.get(d),f=l?.indexOf(r);if(f!==-1){l?.splice(f,1),l.length===0&&this.g.delete(d),this.f.fire({viewContainer:r,viewContainerLocation:d});return}}}get(r){return this.all.filter(d=>d.id===r)[0]}getViewContainers(r){return[...this.g.get(r)||[]]}getViewContainerLocation(r){return[...this.g.keys()].filter(d=>this.getViewContainers(d).filter(l=>l?.id===r.id).length>0)[0]}getDefaultViewContainer(r){return this.h.find(d=>this.getViewContainerLocation(d)===r)}}C.$vo.add(E.ViewContainersRegistry,new b);var a;(function(n){n.Open="2_open",n.Debug="4_debug",n.SCM="5_scm",n.More="9_more"})(a||(e.ViewContentGroups=a={}));function $(n,r){const d=n.group??a.More,l=r.group??a.More;return d!==l?d.localeCompare(l):(n.order??5)-(r.order??5)}class p extends A.$Xc{constructor(){super(...arguments),this.c=this.B(new s.$oe),this.onViewsRegistered=this.c.event,this.f=this.B(new s.$oe),this.onViewsDeregistered=this.f.event,this.g=this.B(new s.$oe),this.onDidChangeContainer=this.g.event,this.h=this.B(new s.$oe),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new O.$Kc}registerViews(r,d){this.registerViews2([{views:r,viewContainer:d}])}registerViews2(r){r.forEach(({views:d,viewContainer:l})=>this.r(d,l)),this.c.fire(r)}deregisterViews(r,d){const l=this.s(r,d);l.length&&this.f.fire({views:l,viewContainer:d})}moveViews(r,d){for(const l of this.m.keys())if(l!==d){const f=this.s(r,l);f.length&&(this.r(f,d),this.g.fire({views:f,from:l,to:d}))}}getViews(r){return this.m.get(r)||[]}getView(r){for(const d of this.j){const l=(this.m.get(d)||[]).filter(f=>f.id===r)[0];if(l)return l}return null}getViewContainer(r){for(const d of this.j)if((this.m.get(d)||[]).filter(f=>f.id===r)[0])return d;return null}registerViewWelcomeContent(r,d){return this.n.add(r,d),this.h.fire(r),(0,A.$Vc)(()=>{this.n.delete(r,d),this.h.fire(r)})}registerViewWelcomeContent2(r,d){const l=new Map;for(const[f,y]of d)this.n.add(r,y),l.set(f,(0,A.$Vc)(()=>{this.n.delete(r,y),this.h.fire(r)}));return this.h.fire(r),l}getViewWelcomeContent(r){const d=[];return this.n.forEach(r,l=>d.push(l)),d.sort($)}r(r,d){let l=this.m.get(d);l||(l=[],this.m.set(d,l),this.j.push(d));for(const f of r){if(this.getView(f.id)!==null)throw new Error((0,h.localize)(4220,null,f.id));l.push(f)}}s(r,d){const l=this.m.get(d);if(!l)return[];const f=[],y=[];for(const k of l)r.includes(k)?f.push(k):y.push(k);return f.length&&(y.length?this.m.set(d,y):(this.m.delete(d),this.j.splice(this.j.indexOf(d),1))),f}}C.$vo.add(E.ViewsRegistry,new p),e.$OG=(0,R.$Ii)("viewDescriptorService");var u;(function(n){n[n.Default=0]="Default",n[n.Expand=1]="Expand"})(u||(e.ViewVisibilityState=u={}));var i;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class o{constructor(r,d){this.c=!1,this.d=!1,(0,m.$lo)(this,r),this.d=!!d,this.resolve=async l=>{if(d&&!this.c){const f=await d(l);f&&(this.tooltip=this.tooltip??f.tooltip,this.command=this.command??f.command)}l.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$PG=o;class t extends Error{constructor(r){super((0,h.localize)(4221,null,r)),this.name="NoTreeViewError"}static is(r){return!!r&&r.name==="NoTreeViewError"}}e.$QG=t}),define(Re[257],Ce([1,0,8,36]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=void 0,e.$UG=new h.$Zj("chatSessionResponseVote","",{type:"string",description:(0,s.localize)(4707,null)}),e.$VG=new h.$Zj("chatVoteUpEnabled",!1,{type:"boolean",description:(0,s.localize)(4708,null)}),e.$WG=new h.$Zj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,s.localize)(4709,null)}),e.$XG=new h.$Zj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,s.localize)(4710,null)}),e.$YG=new h.$Zj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,s.localize)(4711,null)}),e.$ZG=new h.$Zj("chatSessionResponseError",!1,{type:"boolean",description:(0,s.localize)(4712,null)}),e.$1G=new h.$Zj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,s.localize)(4713,null)}),e.$2G=new h.$Zj("chatResponse",!1,{type:"boolean",description:(0,s.localize)(4714,null)}),e.$3G=new h.$Zj("chatRequest",!1,{type:"boolean",description:(0,s.localize)(4715,null)}),e.$4G=new h.$Zj("chatEditApplied",!1,{type:"boolean",description:(0,s.localize)(4716,null)}),e.$5G=new h.$Zj("chatInputHasText",!1,{type:"boolean",description:(0,s.localize)(4717,null)}),e.$6G=new h.$Zj("chatInputHasFocus",!1,{type:"boolean",description:(0,s.localize)(4718,null)}),e.$7G=new h.$Zj("inChatInput",!1,{type:"boolean",description:(0,s.localize)(4719,null)}),e.$8G=new h.$Zj("inChat",!1,{type:"boolean",description:(0,s.localize)(4720,null)}),e.$9G=new h.$Zj("chatIsEnabled",!1,{type:"boolean",description:(0,s.localize)(4721,null)}),e.$0G=new h.$Zj("chatCursorAtTop",!1),e.$$G=new h.$Zj("chatInputHasAgent",!1),e.$_G=new h.$Zj("chatLocation",void 0),e.$aH=new h.$Zj("quickChatHasFocus",!1,{type:"boolean",description:(0,s.localize)(4722,null)})}),define(Re[156],Ce([1,0,132,7,20,4,40,3,38,185,13,36,23,5,11,115,239,154,257]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P,b,a,$,p,u){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.ChatAgentLocation=void 0,e.$jI=d,e.$kI=l;var o;(function(f){f.Panel="panel",f.Terminal="terminal",f.Notebook="notebook",f.Editor="editor"})(o||(e.ChatAgentLocation=o={})),function(f){function y(k){switch(k){case"panel":return f.Panel;case"terminal":return f.Terminal;case"notebook":return f.Notebook;case"editor":return f.Editor}return f.Panel}f.fromRaw=y}(o||(e.ChatAgentLocation=o={})),e.$eI=(0,P.$Ii)("chatAgentService");let t=class{static{this.AGENT_LEADER="@"}constructor(y){this.f=y,this.b=new Map,this.d=new A.$oe,this.onDidChangeAgents=this.d.event,this.g=new Map,this.i=new Map,this.e=u.$9G.bindTo(this.f)}registerAgent(y,k){if(this.getAgent(y))throw new Error(`Agent already registered: ${JSON.stringify(y)}`);const D=this,T=k.slashCommands;k={...k,get slashCommands(){return T.filter(w=>!w.when||D.f.contextMatchesRules(E.$Gj.deserialize(w.when)))}};const v={data:k};return this.b.set(y,v),(0,C.$Vc)(()=>{this.b.delete(y),this.d.fire(void 0)})}registerAgentImplementation(y,k){const S=this.b.get(y);if(!S)throw new Error(`Unknown agent: ${JSON.stringify(y)}`);if(S.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(y)}`);return S.data.isDefault&&this.e.set(!0),S.impl=k,this.d.fire(new n(S.data,k)),(0,C.$Vc)(()=>{S.impl=void 0,this.d.fire(void 0),S.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(y,k){y.isDynamic=!0;const S={data:y,impl:k};return this.b.set(y.id,S),this.d.fire(new n(y,k)),(0,C.$Vc)(()=>{this.b.delete(y.id),this.d.fire(void 0)})}registerAgentCompletionProvider(y,k){return this.g.set(y,k),{dispose:()=>{this.g.delete(y)}}}async getAgentCompletionItems(y,k,S){return await this.g.get(y)?.(k,S)??[]}updateAgent(y,k){const S=this.b.get(y);if(!S?.impl)throw new Error(`No activated agent with id ${JSON.stringify(y)} registered`);S.data.metadata={...S.data.metadata,...k},this.d.fire(new n(S.data,S.impl))}getDefaultAgent(y){return(0,s.$hb)(this.getActivatedAgents(),k=>!!k.isDefault&&k.locations.includes(y))}getContributedDefaultAgent(y){return this.getAgents().find(k=>!!k.isDefault&&k.locations.includes(y))}getSecondaryAgent(){return O.Iterable.find(this.b.values(),y=>!!y.data.metadata.isSecondary)?.data}getAgent(y){if(this.h(y))return this.b.get(y)?.data}h(y){const k=this.b.get(y);return!k?.data.when||this.f.contextMatchesRules(E.$Gj.deserialize(k.data.when))}getAgentByFullyQualifiedId(y){const k=O.Iterable.find(this.b.values(),S=>d(S.data)===y)?.data;if(!(k&&!this.h(k.id)))return k}getAgents(){return Array.from(this.b.values()).map(y=>y.data).filter(y=>this.h(y.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(y=>!!y.impl).filter(y=>this.h(y.data.id)).map(y=>new n(y.data,y.impl))}getAgentsByName(y){return this.getAgents().filter(k=>k.name===y)}agentHasDupeName(y){const k=this.getAgent(y);return k?this.getAgentsByName(k.name).filter(S=>S.extensionId.value!==k.extensionId.value).length>0:!1}async invokeAgent(y,k,S,D,T){const v=this.b.get(y);if(!v?.impl)throw new Error(`No activated agent with id "${y}"`);return await v.impl.invoke(k,S,D,T)}async getFollowups(y,k,S,D,T){const v=this.b.get(y);if(!v?.impl)throw new Error(`No activated agent with id "${y}"`);return v.impl?.provideFollowups?v.impl.provideFollowups(k,S,D,T):[]}async getChatTitle(y,k,S){const D=this.b.get(y);if(!D?.impl)throw new Error(`No activated agent with id "${y}"`);if(D.impl?.provideChatTitle)return D.impl.provideChatTitle(k,S)}registerChatParticipantDetectionProvider(y,k){return this.i.set(y,k),(0,C.$Vc)(()=>{this.i.delete(y)})}hasChatParticipantDetectionProviders(){return this.i.size>0}async detectAgentOrCommand(y,k,S,D){const T=O.Iterable.first(this.i.values());if(!T)return;const v=this.getAgents().reduce((N,F)=>{N.push({participant:F.id,disambiguation:F.disambiguation??[]});for(const V of F.slashCommands)N.push({participant:F.id,command:V.name,disambiguation:[]});return N},[]),w=await T.provideParticipantDetection(y,k,{...S,participants:v},D);if(!w)return;const M=this.getAgent(w.participant);if(!M)return;if(!w.command)return{agent:M};const L=M?.slashCommands.find(N=>N.name===w.command);if(L)return{agent:M,command:L}}};e.$fI=t,e.$fI=t=Ze([qe(0,E.$1j)],t);class n{constructor(y,k){this.b=y,this.d=k}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get locations(){return this.b.locations}get disambiguation(){return this.b.disambiguation}async invoke(y,k,S,D){return this.d.invoke(y,k,S,D)}async provideFollowups(y,k,S,D){return this.d.provideFollowups?this.d.provideFollowups(y,k,S,D):[]}provideWelcomeMessage(y,k){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(y,k)}provideSampleQuestions(y,k){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(y,k)}toJSON(){return this.b}}e.$gI=n,e.$hI=(0,P.$Ii)("chatAgentNameService");let r=class{static{i=this}static{this.b="chat.participantNameRegistry"}constructor(y,k,S,D){if(this.g=k,this.h=S,this.i=D,this.e=(0,c.$9d)(this,Object.create(null)),this.f=!1,!y.chatParticipantRegistry)return;this.d=y.chatParticipantRegistry;const T=D.get(i.b,p.StorageScope.APPLICATION);try{this.e.set(JSON.parse(T??"{}"),void 0)}catch{D.remove(i.b,p.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(y=>this.h.warn("Failed to fetch chat participant registry",y)).then(()=>(0,h.$Jh)(5*60*1e3)).then(()=>this.j())}async k(){const y=await this.g.request({type:"GET",url:this.d},R.CancellationToken.None);if(y.res.statusCode!==200)throw new Error("Could not get extensions report.");const k=await(0,$.$fq)(y);if(!k||k.version!==1)throw new Error("Unexpected chat participant registry response.");const S=k.restrictedChatParticipants;this.e.set(S,void 0),this.i.store(i.b,JSON.stringify(S),p.StorageScope.APPLICATION,p.StorageTarget.MACHINE)}getAgentNameRestriction(y){const k=this.l(y.name,y).get(),S=!y.fullName||this.l(y.fullName.replace(/\s/g,""),y).get();return k&&S}l(y,k){return this.e.map(D=>D[y.toLowerCase()]).map(D=>D?D.some(T=>(0,I.$If)(T,T.includes(".")?k.extensionId.value:k.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$iI=r,e.$iI=r=i=Ze([qe(0,a.$wk),qe(1,$.$_p),qe(2,b.$dk),qe(3,p.$mq)],r);function d(f){return`${f.extensionId.value}.${f.id}`}function l(f){const y="name"in f?f:{...f,name:f.id};return"extensionPublisherId"in y||(y.extensionPublisherId=y.extensionPublisher??""),"extensionDisplayName"in y||(y.extensionDisplayName=""),"extensionId"in y||(y.extensionId=new g.$vn("")),(0,m.$fi)(y)}}),define(Re[258],Ce([1,0,2,30,5]),function(ge,e,s,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MH=e.$LH=e.ChatCopyKind=e.ChatAgentVoteDirection=e.ChatResponseReferencePartStatusKind=void 0,e.$JH=A,e.$KH=O;function A(I){return!!I&&typeof I=="object"&&"uri"in I&&I.uri instanceof s.URI&&"version"in I&&typeof I.version=="number"&&"ranges"in I&&Array.isArray(I.ranges)&&I.ranges.every(h.$Ut.isIRange)}function O(I){return!!I&&typeof I=="object"&&"documents"in I&&Array.isArray(I.documents)&&I.documents.every(A)}var C;(function(I){I[I.Complete=1]="Complete",I[I.Partial=2]="Partial",I[I.Omitted=3]="Omitted"})(C||(e.ChatResponseReferencePartStatusKind=C={}));var m;(function(I){I[I.Down=0]="Down",I[I.Up=1]="Up"})(m||(e.ChatAgentVoteDirection=m={}));var c;(function(I){I[I.Action=1]="Action",I[I.Toolbar=2]="Toolbar"})(c||(e.ChatCopyKind=c={})),e.$LH=(0,R.$Ii)("IChatService"),e.$MH="accessibility.voice.keywordActivation"}),define(Re[157],Ce([1,0,4,7,8]),function(ge,e,s,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dub=void 0;class A{constructor(){this.f=new Map,this.m=[],this.n=new s.$oe,this.o=new s.$oe,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(C){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=C}onEvent(C){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=C}onRequest(C){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=C}sendResponse(C){C.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${C.command}`)):this.u("response",C)}sendRequest(C,m,c,I){const E={command:C};if(m&&Object.keys(m).length>0&&(E.arguments=m),this.u("request",E),typeof I=="number"){const g=setTimeout(()=>{clearTimeout(g);const P=this.f.get(E.seq);if(P){this.f.delete(E.seq);const b={type:"response",seq:0,request_seq:E.seq,success:!1,command:C,message:(0,R.localize)(5721,null,I,C)};P(b)}},I)}return c&&this.f.set(E.seq,c),E.seq}acceptMessage(C){this.k?this.k(C):(this.m.push(C),this.m.length===1&&this.s())}q(C,m){return C.type!=="event"||m.type!=="event"}async s(){let C;for(;this.m.length;){if((!C||this.q(this.m[0],C))&&await(0,h.$Jh)(0),C=this.m.shift(),!C)return;switch(C.type){case"event":this.j?.(C);break;case"request":this.g?.(C);break;case"response":{const m=C,c=this.f.get(m.request_seq);c&&(this.f.delete(m.request_seq),c(m));break}}}}u(C,m){m.type=C,m.seq=this.d++,this.sendMessage(m)}async w(){if(this.f.size===0)return Promise.resolve();const C=new Map;this.f.forEach((m,c)=>C.set(c,m)),await(0,h.$Jh)(500),C.forEach((m,c)=>{m({type:"response",seq:0,request_seq:c,success:!1,command:"canceled",message:"canceled"}),this.f.delete(c)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Dub=A}),define(Re[119],Ce([1,0,2,8,36,5]),function(ge,e,s,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$8K=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$6K=e.MemoryRangeType=e.State=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.$XK=e.$WK=e.$VK=e.$UK=e.$TK=e.$SK=e.$RK=e.$QK=e.$PK=e.$OK=e.$NK=e.$MK=e.$LK=e.$KK=e.$JK=e.$IK=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=void 0,e.$5K=m,e.$7K=I,h=Ue(h),e.$SJ="workbench.view.debug",e.$TJ="workbench.debug.variablesView",e.$UJ="workbench.debug.watchExpressionsView",e.$VJ="workbench.debug.callStackView",e.$WJ="workbench.debug.loadedScriptsView",e.$XJ="workbench.debug.breakPointsView",e.$YJ="workbench.debug.disassemblyView",e.$ZJ="workbench.panel.repl",e.$1J="workbench.panel.repl.view",e.$2J=new R.$Zj("debugType",void 0,{type:"string",description:h.localize(5722,null)}),e.$3J=new R.$Zj("debugConfigurationType",void 0,{type:"string",description:h.localize(5723,null)}),e.$4J=new R.$Zj("debugState","inactive",{type:"string",description:h.localize(5724,null)}),e.$5J="debugUx",e.$6J=new R.$Zj(e.$5J,"default",{type:"string",description:h.localize(5725,null)}),e.$7J=new R.$Zj("hasDebugged",!1,{type:"boolean",description:h.localize(5726,null)}),e.$8J=new R.$Zj("inDebugMode",!1,{type:"boolean",description:h.localize(5727,null)}),e.$9J=new R.$Zj("inDebugRepl",!1,{type:"boolean",description:h.localize(5728,null)}),e.$0J=new R.$Zj("breakpointWidgetVisible",!1,{type:"boolean",description:h.localize(5729,null)}),e.$$J=new R.$Zj("inBreakpointWidget",!1,{type:"boolean",description:h.localize(5730,null)}),e.$_J=new R.$Zj("breakpointsFocused",!0,{type:"boolean",description:h.localize(5731,null)}),e.$aK=new R.$Zj("watchExpressionsFocused",!0,{type:"boolean",description:h.localize(5732,null)}),e.$bK=new R.$Zj("watchExpressionsExist",!1,{type:"boolean",description:h.localize(5733,null)}),e.$cK=new R.$Zj("variablesFocused",!0,{type:"boolean",description:h.localize(5734,null)}),e.$dK=new R.$Zj("expressionSelected",!1,{type:"boolean",description:h.localize(5735,null)}),e.$eK=new R.$Zj("breakpointInputFocused",!1,{type:"boolean",description:h.localize(5736,null)}),e.$fK=new R.$Zj("callStackItemType",void 0,{type:"string",description:h.localize(5737,null)}),e.$gK=new R.$Zj("callStackSessionIsAttach",!1,{type:"boolean",description:h.localize(5738,null)}),e.$hK=new R.$Zj("callStackItemStopped",!1,{type:"boolean",description:h.localize(5739,null)}),e.$iK=new R.$Zj("callStackSessionHasOneThread",!1,{type:"boolean",description:h.localize(5740,null)}),e.$jK=new R.$Zj("watchItemType",void 0,{type:"string",description:h.localize(5741,null)}),e.$kK=new R.$Zj("canViewMemory",void 0,{type:"boolean",description:h.localize(5742,null)}),e.$lK=new R.$Zj("breakpointItemType",void 0,{type:"string",description:h.localize(5743,null)}),e.$mK=new R.$Zj("breakpointItemBytes",void 0,{type:"boolean",description:h.localize(5744,null)}),e.$nK=new R.$Zj("breakpointHasModes",!1,{type:"boolean",description:h.localize(5745,null)}),e.$oK=new R.$Zj("breakpointSupportsCondition",!1,{type:"boolean",description:h.localize(5746,null)}),e.$pK=new R.$Zj("loadedScriptsSupported",!1,{type:"boolean",description:h.localize(5747,null)}),e.$qK=new R.$Zj("loadedScriptsItemType",void 0,{type:"string",description:h.localize(5748,null)}),e.$rK=new R.$Zj("focusedSessionIsAttach",!1,{type:"boolean",description:h.localize(5749,null)}),e.$sK=new R.$Zj("focusedSessionIsNoDebug",!1,{type:"boolean",description:h.localize(5750,null)}),e.$tK=new R.$Zj("stepBackSupported",!1,{type:"boolean",description:h.localize(5751,null)}),e.$uK=new R.$Zj("restartFrameSupported",!1,{type:"boolean",description:h.localize(5752,null)}),e.$vK=new R.$Zj("stackFrameSupportsRestart",!1,{type:"boolean",description:h.localize(5753,null)}),e.$wK=new R.$Zj("jumpToCursorSupported",!1,{type:"boolean",description:h.localize(5754,null)}),e.$xK=new R.$Zj("stepIntoTargetsSupported",!1,{type:"boolean",description:h.localize(5755,null)}),e.$yK=new R.$Zj("breakpointsExist",!1,{type:"boolean",description:h.localize(5756,null)}),e.$zK=new R.$Zj("debuggersAvailable",!1,{type:"boolean",description:h.localize(5757,null)}),e.$AK=new R.$Zj("debugExtensionAvailable",!0,{type:"boolean",description:h.localize(5758,null)}),e.$BK=new R.$Zj("debugProtocolVariableMenuContext",void 0,{type:"string",description:h.localize(5759,null)}),e.$CK=new R.$Zj("debugSetVariableSupported",!1,{type:"boolean",description:h.localize(5760,null)}),e.$DK=new R.$Zj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:h.localize(5761,null)}),e.$EK=new R.$Zj("debugSetExpressionSupported",!1,{type:"boolean",description:h.localize(5762,null)}),e.$FK=new R.$Zj("breakWhenValueChangesSupported",!1,{type:"boolean",description:h.localize(5763,null)}),e.$GK=new R.$Zj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:h.localize(5764,null)}),e.$HK=new R.$Zj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:h.localize(5765,null)}),e.$IK=new R.$Zj("terminateDebuggeeSupported",!1,{type:"boolean",description:h.localize(5766,null)}),e.$JK=new R.$Zj("suspendDebuggeeSupported",!1,{type:"boolean",description:h.localize(5767,null)}),e.$KK=new R.$Zj("variableEvaluateNamePresent",!1,{type:"boolean",description:h.localize(5768,null)}),e.$LK=new R.$Zj("variableIsReadonly",!1,{type:"boolean",description:h.localize(5769,null)}),e.$MK=new R.$Zj("variableValue",!1,{type:"string",description:h.localize(5770,null)}),e.$NK=new R.$Zj("variableType",!1,{type:"string",description:h.localize(5771,null)}),e.$OK=new R.$Zj("variableInterfaces",!1,{type:"array",description:h.localize(5772,null)}),e.$PK=new R.$Zj("variableName",!1,{type:"string",description:h.localize(5773,null)}),e.$QK=new R.$Zj("variableLanguage",!1,{type:"string",description:h.localize(5774,null)}),e.$RK=new R.$Zj("variableExtensionId",!1,{type:"string",description:h.localize(5775,null)}),e.$SK=new R.$Zj("exceptionWidgetVisible",!1,{type:"boolean",description:h.localize(5776,null)}),e.$TK=new R.$Zj("multiSessionRepl",!1,{type:"boolean",description:h.localize(5777,null)}),e.$UK=new R.$Zj("multiSessionDebug",!1,{type:"boolean",description:h.localize(5778,null)}),e.$VK=new R.$Zj("disassembleRequestSupported",!1,{type:"boolean",description:h.localize(5779,null)}),e.$WK=new R.$Zj("disassemblyViewFocus",!1,{type:"boolean",description:h.localize(5780,null)}),e.$XK=new R.$Zj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:h.localize(5781,null)}),e.$YK=new R.$Zj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:h.localize(5782,null)});const O=i=>h.localize(5783,null,i);e.$ZK=O,e.$1K="editor.contrib.debug",e.$2K="editor.contrib.breakpoint",e.$3K="debug",e.$4K={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:h.localize(5784,null)};var C;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(C||(e.State=C={}));function m(i){switch(i){case C.Initializing:return"initializing";case C.Stopped:return"stopped";case C.Running:return"running";default:return"inactive"}}var c;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(c||(e.MemoryRangeType=c={})),e.$6K="vscode-debug-memory";function I(i){const o=i.presentationHint??i.source.presentationHint;return o==="deemphasize"||o==="subtle"}var E;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(E||(e.DataBreakpointSetType=E={}));var g;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(g||(e.DebugConfigurationProviderTriggerKind=g={}));var P;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(P||(e.DebuggerString=P={})),e.$8K=(0,A.$Ii)("debugService");var b;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(b||(e.BreakpointWidgetContext=b={}));var a;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(a||(e.DebugVisualizationType=a={}));var $;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})($||(e.DebugTreeItemCollapsibleState=$={}));var p;(function(i){i.deserialize=o=>o,i.serialize=o=>o})(p||(e.IDebugVisualizationTreeItem=p={}));var u;(function(i){i.deserialize=o=>({id:o.id,name:o.name,iconPath:o.iconPath&&{light:s.URI.revive(o.iconPath.light),dark:s.URI.revive(o.iconPath.dark)},iconClass:o.iconClass,visualization:o.visualization}),i.serialize=o=>o})(u||(e.IDebugVisualization=u={}))}),define(Re[259],Ce([1,0,13,2,16,24,14,30,20,18]),function(ge,e,s,h,R,A,O,C,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zI=void 0,e.$nI=E,e.$oI=g,e.$pI=P,e.$qI=b,e.$rI=a,e.$sI=$,e.$tI=p,e.$uI=i,e.$vI=n,e.$wI=r,e.$xI=l,e.$yI=y;const I=/{([^}]+)}/g;function E(S,D,T){return S.replace(I,function(v,w){return D&&w.length>0&&w[0]!=="_"?v:T&&T.hasOwnProperty(w)?T[w]:v})}function g(S){const D={};for(const T of Object.keys(S))T.startsWith("!")||(D[T]=S[T]);return D}function P(S){return S.configuration.request==="attach"&&!b(S)&&(!S.parentSession||P(S.parentSession))}function b(S){let D=S.configuration.type;if(D)return D==="vslsShare"&&(D=S.configuration.adapterProxy.configuration.type),(0,s.$If)(D,"extensionhost")||(0,s.$If)(D,"pwa-extensionhost")?S:S.parentSession?b(S.parentSession):void 0}function a(S){return S.type&&(S.label||S.program||S.runtime)}function $(S,D,T){let v,w=0;const M=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let L=null;for(;L=M.exec(S);){const N=L.index+1,F=N+L[0].length;if(N<=D&&F>=T){v=L[0],w=N;break}}if(v){const N=/(\w|\p{L})+/gu;let F=null;for(;(F=N.exec(v))&&!(F.index+1+w+F[0].length>=T););F&&(v=v.substring(0,N.lastIndex))}return v?{start:w,end:w+v.length-1}:{start:0,end:0}}async function p(S,D,T,v){if(S.evaluatableExpressionProvider.has(D)){const w=S.evaluatableExpressionProvider.ordered(D),M=(0,c.$Jb)(await Promise.all(w.map(async L=>{try{return await L.provideEvaluatableExpression(D,T,v??m.CancellationToken.None)}catch{return}})));if(M.length>0){let L=M[0].expression;const N=M[0].range;return L||(L=D.getLineContent(T.lineNumber).substring(N.startColumn-1,N.endColumn-1)),{range:N,matchingExpression:L}}}else{const w=D.getLineContent(T.lineNumber),{start:M,end:L}=$(w,T.column,T.column),N=w.substring(M-1,L);return{matchingExpression:N,range:new C.$Ut(T.lineNumber,M,T.lineNumber,M+N.length)}}return null}const u=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(S){return!!(S&&S.match(u))}function o(S){if(typeof S.path=="string"&&!(typeof S.sourceReference=="number"&&S.sourceReference>0)){if(i(S.path))return h.URI.parse(S.path);if((0,R.$lc)(S.path))return h.URI.file(S.path)}return S.path}function t(S){if(typeof S.path=="object"){const D=h.URI.revive(S.path);if(D)return D.scheme===O.Schemas.file?D.fsPath:D.toString()}return S.path}function n(S,D){const T=D?o:t,v=(0,A.$io)(S);return d(v,(w,M)=>{w&&M&&(M.path=T(M))}),v}function r(S,D){const T=D?o:t,v=(0,A.$io)(S);return d(v,(w,M)=>{!w&&M&&(M.path=T(M))}),v}function d(S,D){switch(S.type){case"event":{const T=S;switch(T.event){case"output":D(!1,T.body.source);break;case"loadedSource":D(!1,T.body.source);break;case"breakpoint":D(!1,T.body.breakpoint.source);break;default:break}break}case"request":{const T=S;switch(T.command){case"setBreakpoints":D(!0,T.arguments.source);break;case"breakpointLocations":D(!0,T.arguments.source);break;case"source":D(!0,T.arguments.source);break;case"gotoTargets":D(!0,T.arguments.source);break;case"launchVSCode":T.arguments.args.forEach(v=>D(!1,v));break;default:break}break}case"response":{const T=S;if(T.success&&T.body)switch(T.command){case"stackTrace":T.body.stackFrames.forEach(v=>D(!1,v.source));break;case"loadedSources":T.body.sources.forEach(v=>D(!1,v));break;case"scopes":T.body.scopes.forEach(v=>D(!1,v.source));break;case"setFunctionBreakpoints":T.body.breakpoints.forEach(v=>D(!1,v.source));break;case"setBreakpoints":T.body.breakpoints.forEach(v=>D(!1,v.source));break;case"disassemble":T.body?.instructions.forEach(w=>D(!1,w.location));break;case"locations":D(!1,T.body?.source);break;default:break}break}}}function l(S){return S.filter(D=>!D.presentation?.hidden).sort((D,T)=>D.presentation?T.presentation?D.presentation.group?T.presentation.group?D.presentation.group!==T.presentation.group?D.presentation.group.localeCompare(T.presentation.group):f(D.presentation.order,T.presentation.order):-1:T.presentation.group?1:f(D.presentation.order,T.presentation.order):-1:T.presentation?1:0)}function f(S,D){return typeof S!="number"?typeof D!="number"?0:1:typeof D!="number"?-1:S-D}async function y(S,D){const T=S.getValue("debug.saveBeforeStart",{overrideIdentifier:D.activeTextEditorLanguageId});if(T!=="none"&&(await D.saveAll(),T==="allEditorsInActiveGroup")){const v=D.activeEditorPane;v&&v.input.resource?.scheme===O.Schemas.untitled&&await D.save({editor:v.input,groupId:v.group.id})}await S.reloadConfiguration()}const k=(S,D)=>!S||!D?S===D:S.name===D.name&&S.path===D.path&&S.sourceReference===D.sourceReference;e.$zI=k}),define(Re[260],Ce([1,0,56,69,24,16,10,13,33,8,157]),function(ge,e,s,h,R,A,O,C,m,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1sc=e.$Zsc=e.$Ysc=e.$Xsc=e.$Wsc=void 0,s=Ue(s),h=Ue(h),R=Ue(R),A=Ue(A),O=Ue(O),C=Ue(C),c=Ue(c);class E extends I.$Dub{static{this.b=`\r
\r
`}static{this.i=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(p,u){this.p=u,this.r=Buffer.allocUnsafe(0),this.t=-1,p.on("data",i=>this.x(i))}sendMessage(p){if(this.p){const u=JSON.stringify(p);this.p.write(`Content-Length: ${Buffer.byteLength(u,"utf8")}${E.b}${u}`,"utf8")}}x(p){for(this.r=Buffer.concat([this.r,p]);;){if(this.t>=0){if(this.r.length>=this.t){const u=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,u.length>0)try{this.acceptMessage(JSON.parse(u))}catch(i){this.n.fire(new Error((i.message||i)+`
`+u))}continue}}else{const u=this.r.indexOf(E.b);if(u!==-1){const o=this.r.toString("utf8",0,u).split(E.i);for(const t of o){const n=t.split(E.l);n[0]==="Content-Length"&&(this.t=Number(n[1]))}this.r=this.r.slice(u+E.b.length);continue}}break}}}e.$Wsc=E;class g extends E{startSession(){return new Promise((p,u)=>{let i=!1;this.y=this.z(()=>{this.v(this.y,this.y),p(),i=!0}),this.y.on("close",()=>{i?this.n.fire(new Error("connection closed")):u(new Error("connection closed"))}),this.y.on("error",o=>{i?this.n.fire(o):u(o)})})}async stopSession(){await this.w(),this.y&&(this.y.end(),this.y=void 0)}}e.$Xsc=g;class P extends g{constructor(p){super(),this.A=p}z(p){return h.createConnection(this.A.port,this.A.host||"127.0.0.1",p)}}e.$Ysc=P;class b extends g{constructor(p){super(),this.A=p}z(p){return h.createConnection(this.A.path,p)}}e.$Zsc=b;class a extends E{constructor(p,u){super(),this.z=p,this.A=u}async startSession(){const p=this.z.command,u=this.z.args,i=this.z.options||{};try{if(p)if(A.$lc(p)){if(!await m.Promises.exists(p))throw new Error(c.localize(5858,null,p))}else p.indexOf("/")<0&&p.indexOf("\\")<0;else throw new Error(c.localize(5859,null,this.A));let o=process.env;if(i.env&&Object.keys(i.env).length>0&&(o=R.$lo(R.$io(process.env),i.env)),p==="node")if(Array.isArray(u)&&u.length>0){const t=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,n={env:o,execArgv:t?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};i.cwd&&(n.cwd=i.cwd);const r=s.fork(u[0],u.slice(1),n);if(!r.pid)throw new Error(c.localize(5860,null,u[0]));this.y=r}else throw new Error(c.localize(5861,null));else{let t=p,n=u;const r={env:o};i.cwd&&(r.cwd=i.cwd),O.$j&&(p.endsWith(".bat")||p.endsWith(".cmd"))&&(r.shell=!0,t=`"${p}"`,n=u.map(d=>(d=d.replace(/"/g,'\\"'),`"${d}"`))),this.y=s.spawn(t,n,r)}this.y.on("error",t=>{this.n.fire(t)}),this.y.on("exit",(t,n)=>{this.o.fire(t)}),this.y.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.y.stdout.on("error",t=>{this.n.fire(t)}),this.y.stdin.on("error",t=>{this.n.fire(t)}),this.y.stderr.resume(),this.v(this.y.stdout,this.y.stdin)}catch(o){this.n.fire(o)}}async stopSession(){return this.y?(await this.w(),O.$j?new Promise((p,u)=>{const i=s.exec(`taskkill /F /T /PID ${this.y.pid}`,function(o,t,n){if(o)return u(o)});i.on("exit",p),i.on("error",u)}):(this.y.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static B(p,u){if(!p)return;const i=Object.create(null);p.runtime&&(p.runtime.indexOf("./")===0?i.runtime=A.$mc(u,p.runtime):i.runtime=p.runtime),p.runtimeArgs&&(i.runtimeArgs=p.runtimeArgs),p.program&&(A.$lc(p.program)?i.program=p.program:i.program=A.$mc(u,p.program)),p.args&&(i.args=p.args);const o=p;return o.win&&(i.win=a.B(o.win,u)),o.winx86&&(i.winx86=a.B(o.winx86,u)),o.windows&&(i.windows=a.B(o.windows,u)),o.osx&&(i.osx=a.B(o.osx,u)),o.linux&&(i.linux=a.B(o.linux,u)),i}static platformAdapterExecutable(p,u){let i=Object.create(null);u=u.toLowerCase();for(const l of p)if(l.contributes){const f=l.contributes.debuggers;f&&f.length>0&&f.filter(y=>typeof y.type=="string"&&C.$If(y.type,u)).forEach(y=>{const k=a.B(y,l.extensionLocation.fsPath);i=R.$lo(i,k,l.isBuiltin)})}let o;O.$j&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?o=i.winx86||i.win||i.windows:O.$j?o=i.win||i.windows:O.$k?o=i.osx:O.$l&&(o=i.linux),o=o||i;const t=o.program||i.program,n=o.args||i.args,r=o.runtime||i.runtime,d=o.runtimeArgs||i.runtimeArgs;if(r)return{type:"executable",command:r,args:(d||[]).concat(typeof t=="string"?[t]:[]).concat(n||[])};if(t)return{type:"executable",command:t,args:n||[]}}}e.$1sc=a}),define(Re[261],Ce([1,0,56,31,10]),function(ge,e,s,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2sc=O,e.$3sc=m,s=Ue(s),R=Ue(R);function A(c,I){return new Promise((E,g)=>{let P="";const b=s.spawn(c,I);b.pid&&b.stdout.on("data",a=>{P+=a.toString()}),b.on("error",a=>{g(a)}),b.on("close",a=>{E(P)})})}async function O(c){if(c)if(R.$j){const I=await new Promise((E,g)=>{ge(["@vscode/windows-process-tree"],E,g)}).then(Ue);return new Promise(E=>{I.getProcessTree(c,g=>{E(!!g&&g.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(c)]).then(I=>{const E=I.trim();return!(E.length===0||E.indexOf(" tmux")>=0)},I=>!0);return Promise.resolve(!0)}var C;(function(c){c[c.cmd=0]="cmd",c[c.powershell=1]="powershell",c[c.bash=2]="bash"})(C||(C={}));function m(c,I,E,g,P){c=c.trim().toLowerCase();let b;c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0?b=C.powershell:c.indexOf("cmd.exe")>=0?b=C.cmd:c.indexOf("bash")>=0?b=C.bash:R.$j?b=C.cmd:b=C.bash;let a,$=" ";switch(b){case C.powershell:if(a=p=>(p=p.replace(/\'/g,"''"),p.length>0&&p.charAt(p.length-1)==="\\"?`'${p}\\'`:`'${p}'`),g){const p=(0,h.$Ng)(g);p&&($+=`${p}:; `),$+=`cd ${a(g)}; `}if(P)for(const p in P){const u=P[p];u===null?$+=`Remove-Item env:${p}; `:$+=`\${env:${p}}='${u}'; `}if(I.length>0){const p=I.shift(),u=E?p:a(p);$+=u[0]==="'"?`& ${u} `:`${u} `;for(const i of I)$+=i==="<"||i===">"||E?i:a(i),$+=" "}break;case C.cmd:if(a=p=>(p=p.replace(/\"/g,'""'),p=p.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(u=>p.includes(u))||p.length===0?`"${p}"`:p),g){const p=(0,h.$Ng)(g);p&&($+=`${p}: && `),$+=`cd ${a(g)} && `}if(P){$+='cmd /C "';for(const p in P){let u=P[p];u===null?$+=`set "${p}=" && `:(u=u.replace(/[&^|<>]/g,i=>`^${i}`),$+=`set "${p}=${u}" && `)}}for(const p of I)$+=p==="<"||p===">"||E?p:a(p),$+=" ";P&&($+='"');break;case C.bash:{a=u=>(u=u.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),u.length===0?'""':u);const p=u=>/[^\w@%\/+=,.:^-]/.test(u)?`'${u.replace(/'/g,"'\\''")}'`:u;if(g&&($+=`cd ${a(g)} ; `),P){$+="/usr/bin/env";for(const u in P){const i=P[u];i===null?$+=` -u ${p(u)}`:$+=` ${p(`${u}=${i}`)}`}$+=" "}for(const u of I)$+=u==="<"||u===">"||E?u:a(u),$+=" ";break}}return $}}),define(Re[262],Ce([1,0,5]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dL=e.CellExecutionUpdateType=void 0;var h;(function(R){R[R.Output=1]="Output",R[R.OutputItems=2]="OutputItems",R[R.ExecutionState=3]="ExecutionState"})(h||(e.CellExecutionUpdateType=h={})),e.$dL=(0,s.$Ii)("INotebookExecutionService")}),define(Re[263],Ce([1,0,5]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hL=e.$gL=e.ProxyKernelState=e.$fL=void 0,e.$fL=100;var h;(function(R){R[R.Disconnected=1]="Disconnected",R[R.Connected=2]="Connected",R[R.Initializing=3]="Initializing"})(h||(e.ProxyKernelState=h={})),e.$gL=(0,s.$Ii)("INotebookKernelService"),e.$hL=(0,s.$Ii)("INotebookKernelHistoryService")}),define(Re[264],Ce([1,0,3,30,58,210,111]),function(ge,e,s,h,R,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r2b=void 0;class C extends s.$Xc{constructor(c,I,E){super(),this._source=c,this.b=I,this.c=E,this.a=void 0}f(c){const I=c.getLineCount();return new h.$Ut(1,1,I,this.g(c,I))}g(c,I){if(I<1||I>c.getLineCount())throw new Error("Illegal value for lineNumber");return c.getLineLength(I)+1}get inputTextBuffer(){if(!this.b){const c=new A.$HD;c.acceptChunk(this._source);const I=c.finish(!0),{textBuffer:E,disposable:g}=I.create(R.DefaultEndOfLine.LF);this.b=E,this.B(g)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(c=>{const I=new A.$HD;I.acceptChunk(c);const E=I.finish(!0),{textBuffer:g,disposable:P}=E.create(R.DefaultEndOfLine.LF);return this.B(P),g})),this.a}findInInputs(c){const E=new O.$vD(c,!1,!1,null).parseSearchRequest();if(!E)return[];const g=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(g,E,!0,5e3)}findInOutputs(c){const E=new O.$vD(c,!1,!1,null).parseSearchRequest();return E?this.outputTextBuffers.map(g=>{const P=g.findMatchesLineByLine(this.f(g),E,!0,5e3);if(P.length!==0)return{textBuffer:g,matches:P}}).filter(g=>!!g):[]}}e.$r2b=C}),define(Re[75],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mJ=e.TestPosition=e.TestIdPathParts=void 0;var s;(function(A){A.Delimiter="\0"})(s||(e.TestIdPathParts=s={}));var h;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(h||(e.TestPosition=h={}));class R{static fromExtHostTestItem(O,C,m=O.parent){if(O._isRoot)return new R([C]);const c=[O.id];for(let I=m;I&&I.id!==C;I=I.parent)c.push(I.id);return c.push(C),new R(c.reverse())}static isRoot(O){return!O.includes(s.Delimiter)}static root(O){const C=O.indexOf(s.Delimiter);return C===-1?O:O.slice(0,C)}static fromString(O){return new R(O.split(s.Delimiter))}static join(O,C){return new R([...O.path,C])}static joinToString(O,C){return O.toString()+s.Delimiter+C}static parentId(O){const C=O.lastIndexOf(s.Delimiter);return C===-1?void 0:O.slice(0,C)}static localId(O){const C=O.lastIndexOf(s.Delimiter);return C===-1?O:O.slice(C+s.Delimiter.length)}static isChild(O,C){return C[O.length]===s.Delimiter&&C.startsWith(O)}static compare(O,C){return O===C?h.IsSame:R.isChild(O,C)?h.IsChild:R.isChild(C,O)?h.IsParent:h.Disconnected}static getLengthOfCommonPrefix(O,C){if(O===0)return 0;let m=0;for(;m<O-1;){for(let c=1;c<O;c++){const I=C(c-1),E=C(c);if(I.path[m]!==E.path[m])return m}m++}return m}constructor(O,C=O.length){if(this.path=O,this.d=C,O.length===0||C<1)throw new Error("cannot create test with empty path")}get rootId(){return new R(this.path,1)}get parentId(){return this.d>1?new R(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let O=1;O<=this.d;O++)yield new R(this.path,O)}*idsToRoot(){for(let O=this.d;O>0;O--)yield new R(this.path,O)}compare(O){if(typeof O=="string")return R.compare(this.toString(),O);for(let C=0;C<O.d&&C<this.d;C++)if(O.path[C]!==this.path[C])return h.Disconnected;return O.d>this.d?h.IsChild:O.d<this.d?h.IsParent:h.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let O=1;O<this.d;O++)this.c+=s.Delimiter,this.c+=this.path[O]}return this.c}}e.$mJ=R}),define(Re[76],Ce([1,0,2,57,30,75]),function(ge,e,s,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vJ=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$uJ=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$tJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$sJ=e.$rJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$qJ=e.ITestErrorMessage=e.ITestMessageStackFrame=e.TestMessageType=e.IRichLocation=e.$pJ=e.$oJ=e.TestRunProfileBitset=e.TestControllerCapability=e.ExtTestRunProfileKind=e.$nJ=e.TestResultState=void 0;var O;(function(U){U[U.Unset=0]="Unset",U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(O||(e.TestResultState=O={})),e.$nJ={[O.Unset]:"unset",[O.Queued]:"queued",[O.Running]:"running",[O.Passed]:"passed",[O.Failed]:"failed",[O.Skipped]:"skipped",[O.Errored]:"errored"};var C;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(C||(e.ExtTestRunProfileKind=C={}));var m;(function(U){U[U.Refresh=2]="Refresh",U[U.CodeRelatedToTest=4]="CodeRelatedToTest",U[U.TestRelatedToCode=8]="TestRelatedToCode"})(m||(e.TestControllerCapability=m={}));var c;(function(U){U[U.Run=2]="Run",U[U.Debug=4]="Debug",U[U.Coverage=8]="Coverage",U[U.HasNonDefaultProfile=16]="HasNonDefaultProfile",U[U.HasConfigurable=32]="HasConfigurable",U[U.SupportsContinuousRun=64]="SupportsContinuousRun"})(c||(e.TestRunProfileBitset=c={})),e.$oJ=[c.Run,c.Debug,c.Coverage,c.HasNonDefaultProfile,c.HasConfigurable,c.SupportsContinuousRun];const I=U=>"runId"in U;e.$pJ=I;var E;(function(U){U.serialize=z=>({range:z.range.toJSON(),uri:z.uri.toJSON()}),U.deserialize=(z,_)=>({range:R.$Ut.lift(_.range),uri:z.asCanonicalUri(s.URI.revive(_.uri))})})(E||(e.IRichLocation=E={}));var g;(function(U){U[U.Error=0]="Error",U[U.Output=1]="Output"})(g||(e.TestMessageType=g={}));var P;(function(U){U.serialize=z=>({label:z.label,uri:z.uri?.toJSON(),position:z.position?.toJSON()}),U.deserialize=(z,_)=>({label:_.label,uri:_.uri?z.asCanonicalUri(s.URI.revive(_.uri)):void 0,position:_.position?h.$Tt.lift(_.position):void 0})})(P||(e.ITestMessageStackFrame=P={}));var b;(function(U){U.serialize=z=>({message:z.message,type:g.Error,expected:z.expected,actual:z.actual,contextValue:z.contextValue,location:z.location&&E.serialize(z.location),stackTrace:z.stackTrace?.map(P.serialize)}),U.deserialize=(z,_)=>({message:_.message,type:g.Error,expected:_.expected,actual:_.actual,contextValue:_.contextValue,location:_.location&&E.deserialize(z,_.location),stackTrace:_.stackTrace&&_.stackTrace.map(W=>P.deserialize(z,W))})})(b||(e.ITestErrorMessage=b={}));const a=(U,z)=>`${z?"s":"e"}${U}`;e.$qJ=a;var $;(function(U){U.serialize=z=>({message:z.message,type:g.Output,offset:z.offset,length:z.length,location:z.location&&E.serialize(z.location)}),U.deserialize=(z,_)=>({message:_.message,type:g.Output,offset:_.offset,length:_.length,location:_.location&&E.deserialize(z,_.location)})})($||(e.ITestOutputMessage=$={}));var p;(function(U){U.serialize=z=>z.type===g.Error?b.serialize(z):$.serialize(z),U.deserialize=(z,_)=>_.type===g.Error?b.deserialize(z,_):$.deserialize(z,_),U.isDiffable=z=>z.type===g.Error&&z.actual!==void 0&&z.expected!==void 0})(p||(e.ITestMessage=p={}));var u;(function(U){U.serializeWithoutMessages=z=>({state:z.state,duration:z.duration,messages:[]}),U.serialize=z=>({state:z.state,duration:z.duration,messages:z.messages.map(p.serialize)}),U.deserialize=(z,_)=>({state:_.state,duration:_.duration,messages:_.messages.map(W=>p.deserialize(z,W))})})(u||(e.ITestTaskState=u={}));const i="\0",o=(U,z)=>U+i+z;e.$rJ=o;const t=U=>{const z=U.indexOf(i);return{ctrlId:U.slice(0,z),tagId:U.slice(z+1)}};e.$sJ=t;var n;(function(U){U.serialize=z=>({extId:z.extId,label:z.label,tags:z.tags,busy:z.busy,children:void 0,uri:z.uri?.toJSON(),range:z.range?.toJSON()||null,description:z.description,error:z.error,sortText:z.sortText}),U.deserialize=(z,_)=>({extId:_.extId,label:_.label,tags:_.tags,busy:_.busy,children:void 0,uri:_.uri?z.asCanonicalUri(s.URI.revive(_.uri)):void 0,range:_.range?R.$Ut.lift(_.range):null,description:_.description,error:_.error,sortText:_.sortText})})(n||(e.ITestItem=n={}));var r;(function(U){U[U.NotExpandable=0]="NotExpandable",U[U.Expandable=1]="Expandable",U[U.BusyExpanding=2]="BusyExpanding",U[U.Expanded=3]="Expanded"})(r||(e.TestItemExpandState=r={}));var d;(function(U){U.serialize=z=>({expand:z.expand,item:n.serialize(z.item)}),U.deserialize=(z,_)=>({controllerId:A.$mJ.root(_.item.extId),expand:_.expand,item:n.deserialize(z,_.item)})})(d||(e.InternalTestItem=d={}));var l;(function(U){U.serialize=z=>{let _;return z.item&&(_={},z.item.label!==void 0&&(_.label=z.item.label),z.item.tags!==void 0&&(_.tags=z.item.tags),z.item.busy!==void 0&&(_.busy=z.item.busy),z.item.uri!==void 0&&(_.uri=z.item.uri?.toJSON()),z.item.range!==void 0&&(_.range=z.item.range?.toJSON()),z.item.description!==void 0&&(_.description=z.item.description),z.item.error!==void 0&&(_.error=z.item.error),z.item.sortText!==void 0&&(_.sortText=z.item.sortText)),{extId:z.extId,expand:z.expand,item:_}},U.deserialize=z=>{let _;return z.item&&(_={},z.item.label!==void 0&&(_.label=z.item.label),z.item.tags!==void 0&&(_.tags=z.item.tags),z.item.busy!==void 0&&(_.busy=z.item.busy),z.item.range!==void 0&&(_.range=z.item.range?R.$Ut.lift(z.item.range):null),z.item.description!==void 0&&(_.description=z.item.description),z.item.error!==void 0&&(_.error=z.item.error),z.item.sortText!==void 0&&(_.sortText=z.item.sortText)),{extId:z.extId,expand:z.expand,item:_}}})(l||(e.ITestItemUpdate=l={}));const f=(U,z)=>{z.expand!==void 0&&(U.expand=z.expand),z.item!==void 0&&(U.item=U.item?Object.assign(U.item,z.item):z.item)};e.$tJ=f;var y;(function(U){U.serializeWithoutMessages=z=>({...d.serialize(z),ownComputedState:z.ownComputedState,computedState:z.computedState,tasks:z.tasks.map(u.serializeWithoutMessages)}),U.serialize=z=>({...d.serialize(z),ownComputedState:z.ownComputedState,computedState:z.computedState,tasks:z.tasks.map(u.serialize)}),U.deserialize=(z,_)=>({...d.deserialize(z,_),ownComputedState:_.ownComputedState,computedState:_.computedState,tasks:_.tasks.map(W=>u.deserialize(z,W)),retired:!0})})(y||(e.TestResultItem=y={}));var k;(function(U){U.empty=()=>({covered:0,total:0}),U.sum=(z,_)=>{z.covered+=_.covered,z.total+=_.total}})(k||(e.ICoverageCount=k={}));var S;(function(U){U.serialize=z=>({id:z.id,statement:z.statement,branch:z.branch,declaration:z.declaration,testIds:z.testIds,uri:z.uri.toJSON()}),U.deserialize=(z,_)=>({id:_.id,statement:_.statement,branch:_.branch,declaration:_.declaration,testIds:_.testIds,uri:z.asCanonicalUri(s.URI.revive(_.uri))}),U.empty=(z,_)=>({id:z,uri:_,statement:k.empty()})})(S||(e.IFileCoverage=S={}));function D(U){return{...U,location:U.location?.toJSON()}}function T(U){return U.location=U.location?h.$Tt.isIPosition(U.location)?h.$Tt.lift(U.location):R.$Ut.lift(U.location):void 0,U}e.$uJ=3;var v;(function(U){U[U.Declaration=0]="Declaration",U[U.Statement=1]="Statement",U[U.Branch=2]="Branch"})(v||(e.DetailType=v={}));var w;(function(U){U.serialize=z=>z.type===v.Declaration?L.serialize(z):N.serialize(z),U.deserialize=z=>z.type===v.Declaration?L.deserialize(z):N.deserialize(z)})(w||(e.CoverageDetails=w={}));var M;(function(U){U.serialize=D,U.deserialize=T})(M||(e.IBranchCoverage=M={}));var L;(function(U){U.serialize=D,U.deserialize=T})(L||(e.IDeclarationCoverage=L={}));var N;(function(U){U.serialize=z=>({...D(z),branches:z.branches?.map(M.serialize)}),U.deserialize=z=>({...T(z),branches:z.branches?.map(M.deserialize)})})(N||(e.IStatementCoverage=N={}));var F;(function(U){U[U.Add=0]="Add",U[U.Update=1]="Update",U[U.DocumentSynced=2]="DocumentSynced",U[U.Remove=3]="Remove",U[U.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",U[U.Retire=5]="Retire",U[U.AddTag=6]="AddTag",U[U.RemoveTag=7]="RemoveTag"})(F||(e.TestDiffOpType=F={}));var V;(function(U){U.deserialize=(z,_)=>_.op===F.Add?{op:_.op,item:d.deserialize(z,_.item)}:_.op===F.Update?{op:_.op,item:l.deserialize(_.item)}:_.op===F.DocumentSynced?{op:_.op,uri:z.asCanonicalUri(s.URI.revive(_.uri)),docv:_.docv}:_,U.serialize=z=>z.op===F.Add?{op:z.op,item:d.serialize(z.item)}:z.op===F.Update?{op:z.op,item:l.serialize(z.item)}:z})(V||(e.TestsDiffOp=V={}));class j{constructor(z){this.l=z,this.f=new Map,this.g=new Map,this.h=new Set,this.j=0,this.k=0,this.tags=this.f}apply(z){const _=this.x();for(const W of z)switch(W.op){case F.Add:this.p(d.deserialize(this.l,W.item),_);break;case F.Update:this.q(l.deserialize(W.item),_);break;case F.Remove:this.v(W.itemId,_);break;case F.Retire:this.w(W.itemId);break;case F.IncrementPendingExtHosts:this.updatePendingRoots(W.amount);break;case F.AddTag:this.f.set(W.tag.id,W.tag);break;case F.RemoveTag:this.f.delete(W.id);break}_.complete?.()}p(z,_){const W=A.$mJ.parentId(z.item.extId)?.toString();let B;if(!W)B=this.y(z),this.h.add(B),this.g.set(z.item.extId,B);else if(this.g.has(W)){const Y=this.g.get(W);Y.children.add(z.item.extId),B=this.y(z,Y),this.g.set(z.item.extId,B)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(z)}`);return}return _.add?.(B),z.expand===r.BusyExpanding&&this.j++,B}q(z,_){const W=this.g.get(z.extId);if(W)return z.expand!==void 0&&(W.expand===r.BusyExpanding&&this.j--,z.expand===r.BusyExpanding&&this.j++),(0,e.$tJ)(W,z),_.update?.(W),W}v(z,_){const W=this.g.get(z);if(!W)return;const B=A.$mJ.parentId(W.item.extId)?.toString();B?this.g.get(B).children.delete(W.item.extId):this.h.delete(W);const Y=[[z]];for(;Y.length;)for(const x of Y.pop()){const oe=this.g.get(x);oe&&(Y.push(oe.children),this.g.delete(x),_.remove?.(oe,oe!==W),oe.expand===r.BusyExpanding&&this.j--)}}w(z){}updatePendingRoots(z){this.k+=z}x(){return{}}}e.$vJ=j}),define(Re[265],Ce([1,0,138,8,76]),function(ge,e,s,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$hHb=e.$gHb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var A;(function(E){E.ViewletId="workbench.view.extension.test",E.ExplorerViewId="workbench.view.testing",E.OutputPeekContributionId="editor.contrib.testingOutputPeek",E.DecorationsContributionId="editor.contrib.testingDecorations",E.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",E.CoverageViewId="workbench.view.testCoverage",E.ResultsPanelId="workbench.panel.testResults",E.ResultsViewId="workbench.panel.testResults.view",E.MessageLanguageId="vscodeInternalTestMessage"})(A||(e.Testing=A={}));var O;(function(E){E.List="list",E.Tree="true"})(O||(e.TestExplorerViewMode=O={}));var C;(function(E){E.ByLocation="location",E.ByStatus="status",E.ByDuration="duration"})(C||(e.TestExplorerViewSorting=C={}));const m={[R.TestResultState.Errored]:(0,h.localize)(10851,null),[R.TestResultState.Failed]:(0,h.localize)(10852,null),[R.TestResultState.Passed]:(0,h.localize)(10853,null),[R.TestResultState.Queued]:(0,h.localize)(10854,null),[R.TestResultState.Running]:(0,h.localize)(10855,null),[R.TestResultState.Skipped]:(0,h.localize)(10856,null),[R.TestResultState.Unset]:(0,h.localize)(10857,null)},c=(E,g)=>(0,h.localize)(10858,null,(0,s.$3k)(E),m[g]);e.$gHb=c,e.$hHb={[R.TestRunProfileBitset.Debug]:(0,h.localize)(10859,null),[R.TestRunProfileBitset.Run]:(0,h.localize)(10860,null),[R.TestRunProfileBitset.Coverage]:(0,h.localize)(10861,null)};var I;(function(E){E.CancelTestRefreshAction="testing.cancelTestRefresh",E.CancelTestRunAction="testing.cancelRun",E.ClearTestResultsAction="testing.clearTestResults",E.CollapseAllAction="testing.collapseAll",E.ConfigureTestProfilesAction="testing.configureProfile",E.ContinousRunUsingForTest="testing.continuousRunUsingForTest",E.CoverageAtCursor="testing.coverageAtCursor",E.CoverageByUri="testing.coverage.uri",E.CoverageClear="testing.coverage.close",E.CoverageCurrentFile="testing.coverageCurrentFile",E.CoverageFilterToTest="testing.coverageFilterToTest",E.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",E.CoverageLastRun="testing.coverageLastRun",E.CoverageSelectedAction="testing.coverageSelected",E.CoverageToggleToolbar="testing.coverageToggleToolbar",E.CoverageViewChangeSorting="testing.coverageViewChangeSorting",E.DebugAction="testing.debug",E.DebugAllAction="testing.debugAll",E.DebugAtCursor="testing.debugAtCursor",E.DebugByUri="testing.debug.uri",E.DebugCurrentFile="testing.debugCurrentFile",E.DebugFailedTests="testing.debugFailTests",E.DebugLastRun="testing.debugLastRun",E.DebugSelectedAction="testing.debugSelected",E.FilterAction="workbench.actions.treeView.testExplorer.filter",E.GetExplorerSelection="_testing.getExplorerSelection",E.GetSelectedProfiles="testing.getSelectedProfiles",E.GoToTest="testing.editFocusedTest",E.GoToRelatedTest="testing.goToRelatedTest",E.PeekRelatedTest="testing.peekRelatedTest",E.GoToRelatedCode="testing.goToRelatedCode",E.PeekRelatedCode="testing.peekRelatedCode",E.HideTestAction="testing.hideTest",E.OpenCoverage="testing.openCoverage",E.OpenOutputPeek="testing.openOutputPeek",E.RefreshTestsAction="testing.refreshTests",E.ReRunFailedTests="testing.reRunFailTests",E.ReRunLastRun="testing.reRunLastRun",E.RunAction="testing.run",E.RunAllAction="testing.runAll",E.RunAllWithCoverageAction="testing.coverageAll",E.RunAtCursor="testing.runAtCursor",E.RunByUri="testing.run.uri",E.RunCurrentFile="testing.runCurrentFile",E.RunSelectedAction="testing.runSelected",E.RunUsingProfileAction="testing.runUsing",E.RunWithCoverageAction="testing.coverage",E.SearchForTestExtension="testing.searchForTestExtension",E.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",E.ShowMostRecentOutputAction="testing.showMostRecentOutput",E.StartContinousRun="testing.startContinuousRun",E.StopContinousRun="testing.stopContinuousRun",E.TestingSortByDurationAction="testing.sortByDuration",E.TestingSortByLocationAction="testing.sortByLocation",E.TestingSortByStatusAction="testing.sortByStatus",E.TestingViewAsListAction="testing.viewAsList",E.TestingViewAsTreeAction="testing.viewAsTree",E.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",E.ToggleInlineTestOutput="testing.toggleInlineTestOutput",E.UnhideAllTestsAction="testing.unhideAllTests",E.UnhideTestAction="testing.unhideTest"})(I||(e.TestCommandId=I={}))}),define(Re[120],Ce([1,0,7,4,3,67,76,75]),function(ge,e,s,h,R,A,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xQ=e.$wQ=e.$vQ=e.$uQ=e.$tQ=e.TestItemEventOp=void 0;var m;(function(u){u[u.Upsert=0]="Upsert",u[u.SetTags=1]="SetTags",u[u.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",u[u.RemoveChild=3]="RemoveChild",u[u.SetProp=4]="SetProp",u[u.Bulk=5]="Bulk",u[u.DocumentSynced=6]="DocumentSynced"})(m||(e.TestItemEventOp=m={}));const c=(u,i)=>u===i,E=Object.entries({range:(u,i)=>u===i?!0:!u||!i?!1:u.equalsRange(i),busy:c,label:c,description:c,error:c,sortText:c,tags:(u,i)=>!(u.length!==i.length||u.some(o=>!i.includes(o)))}),g=(u,i)=>{let o;for(const[t,n]of E)n(u[t],i[t])||(o?o[t]=i[t]:o={[t]:i[t]});return o};class P extends R.$Xc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new s.$Uh(()=>this.flushDiff(),200)),this.g=this.B(new h.$oe),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const o of this.tree.values())this.J(o)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case O.TestDiffOpType.DocumentSynced:{for(const o of this.m)if(o.op===O.TestDiffOpType.DocumentSynced&&o.uri===i.uri){o.docv=i.docv;return}break}case O.TestDiffOpType.Update:{const o=this.m[this.m.length-1];if(o){if(o.op===O.TestDiffOpType.Update&&o.item.extId===i.item.extId){(0,O.$tJ)(o.item,i.item);return}if(o.op===O.TestDiffOpType.Add&&o.item.item.extId===i.item.extId){(0,O.$tJ)(o.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,o){const t=this.tree.get(i);if(t){if((t.expandLevels===void 0||o>t.expandLevels)&&(t.expandLevels=o),t.expand===O.TestItemExpandState.Expandable){const n=this.M(t);return n.isOpen()?this.L(t,o-1):n.wait().then(()=>this.L(t,o-1))}else if(t.expand===O.TestItemExpandState.Expanded)return t.resolveBarrier?.isOpen()===!1?t.resolveBarrier.wait().then(()=>this.L(t,o-1)):this.L(t,o-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,o){switch(o.op){case m.RemoveChild:this.O(C.$mJ.joinToString(i.fullId,o.id));break;case m.Upsert:this.z(o.item,i);break;case m.Bulk:for(const t of o.ops)this.w(i,t);break;case m.SetTags:this.C(o.new,o.old,i.fullId.toString());break;case m.UpdateCanResolveChildren:this.J(i);break;case m.SetProp:this.pushDiff({op:O.TestDiffOpType.Update,item:{extId:i.fullId.toString(),item:o.update}});break;case m.DocumentSynced:this.y(i.actual.uri);break;default:(0,A.$hd)(o)}}y(i){i&&this.pushDiff({op:O.TestDiffOpType.DocumentSynced,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,o){const t=C.$mJ.fromExtHostTestItem(i,this.root.id,o?.actual),n=this.s.getApiFor(i);n.parent&&n.parent!==o?.actual&&this.s.getChildren(n.parent).delete(i.id);let r=this.tree.get(t.toString());if(!r){r={fullId:t,actual:i,expandLevels:o?.expandLevels?o.expandLevels-1:void 0,expand:O.TestItemExpandState.NotExpandable},i.tags.forEach(this.D,this),this.tree.set(r.fullId.toString(),r),this.G(i,o),this.pushDiff({op:O.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:r.expand,item:this.s.toITestItem(i)}}),this.I(i,r,o);return}if(r.actual===i){this.H(i,r,o);return}if(r.actual.uri?.toString()!==i.uri?.toString())return this.O(t.toString()),this.z(i,o);const d=this.s.getChildren(r.actual),l=r.actual,f=g(this.s.toITestItem(l),this.s.toITestItem(i));this.s.getApiFor(l).listener=void 0,r.actual=i,r.resolveBarrier=void 0,r.expand=O.TestItemExpandState.NotExpandable,f&&(f.hasOwnProperty("tags")&&(this.C(i.tags,l.tags,t.toString()),delete f.tags),this.w(r,{op:m.SetProp,update:f})),this.I(i,r,o);for(const[k,S]of d)this.s.getChildren(i).get(S.id)||this.O(C.$mJ.joinToString(t,S.id));const y=r.expandLevels;y!==void 0&&queueMicrotask(()=>{r.expand===O.TestItemExpandState.Expandable&&(r.expandLevels=void 0,this.expand(t.toString(),y))}),this.y(r.actual.uri)}C(i,o,t){const n=new Set(o.map(r=>r.id));for(const r of i)n.delete(r.id)||this.D(r);this.pushDiff({op:O.TestDiffOpType.Update,item:{extId:t,item:{tags:i.map(r=>(0,O.$rJ)(this.s.controllerId,r.id))}}}),n.forEach(this.F,this)}D(i){const o=this.j.get(i.id);o?o.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:O.TestDiffOpType.AddTag,tag:{id:(0,O.$rJ)(this.s.controllerId,i.id)}}))}F(i){const o=this.j.get(i);o&&!--o.refCount&&(this.j.delete(i),this.pushDiff({op:O.TestDiffOpType.RemoveTag,id:(0,O.$rJ)(this.s.controllerId,i)}))}G(i,o){this.s.getApiFor(i).parent=o&&o.actual!==this.root?o.actual:void 0}H(i,o,t){this.G(i,t);const n=this.s.getApiFor(i);n.parent=t?.actual,n.listener=r=>this.w(o,r),this.J(o)}I(i,o,t){this.H(i,o,t);for(const[n,r]of this.s.getChildren(i))this.z(r,o)}J(i){let o;this.h?i.resolveBarrier?o=i.resolveBarrier.isOpen()?O.TestItemExpandState.Expanded:O.TestItemExpandState.BusyExpanding:o=i.actual.canResolveChildren?O.TestItemExpandState.Expandable:O.TestItemExpandState.NotExpandable:o=O.TestItemExpandState.NotExpandable,o!==i.expand&&(i.expand=o,this.pushDiff({op:O.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:o}}),o===O.TestItemExpandState.Expandable&&i.expandLevels!==void 0&&this.M(i))}L(i,o){if(o<0)return;const t=[];for(const[n,r]of this.s.getChildren(i.actual)){const d=this.expand(C.$mJ.joinToString(i.fullId,r.id),o);(0,s.$uh)(d)&&t.push(d)}if(t.length)return Promise.all(t).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const r=new s.$Hh;return r.open(),r}i.expand=O.TestItemExpandState.BusyExpanding,this.N(i);const o=i.resolveBarrier=new s.$Hh,t=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,r)};let n;try{n=this.h(i.actual===this.root?void 0:i.actual)}catch(r){t(r)}return(0,s.$uh)(n)?n.catch(t).then(()=>{o.open(),this.J(i)}):(o.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:O.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const o=this.tree.get(i);if(!o)throw new Error("attempting to remove non-existent child");this.pushDiff({op:O.TestDiffOpType.Remove,itemId:i});const t=[o];for(;t.length;){const n=t.pop();if(n){this.s.getApiFor(n.actual).listener=void 0;for(const r of n.actual.tags)this.F(r.id);this.tree.delete(n.fullId.toString());for(const[r,d]of this.s.getChildren(n.actual))t.push(this.tree.get(C.$mJ.joinToString(n.fullId,d.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$tQ=P;class b extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$uQ=b;class a extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$vQ=a;class $ extends Error{constructor(i,o,t){super(`TestItem with ID "${i}" is from controller "${o}" and cannot be added as a child of an item from controller "${t}".`)}}e.$wQ=$;const p=(u,i,o)=>{let t=new Map;return{get size(){return t.size},forEach(n,r){for(const d of t.values())n.call(r,d,this)},[Symbol.iterator](){return t.entries()},replace(n){const r=new Map,d=new Set(t.keys()),l={op:m.Bulk,ops:[]};for(const f of n){if(!(f instanceof o))throw new a(f.id);const y=i(f).controllerId;if(y!==u.controllerId)throw new $(f.id,y,u.controllerId);if(r.has(f.id))throw new b(f.id);r.set(f.id,f),d.delete(f.id),l.ops.push({op:m.Upsert,item:f})}for(const f of d.keys())l.ops.push({op:m.RemoveChild,id:f});u.listener?.(l),t=r},add(n){if(!(n instanceof o))throw new a(n.id);t.set(n.id,n),u.listener?.({op:m.Upsert,item:n})},delete(n){t.delete(n)&&u.listener?.({op:m.RemoveChild,id:n})},get(n){return t.get(n)},toJSON(){return Array.from(t.values())}}};e.$xQ=p}),define(Re[158],Ce([1,0,120]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zQ=e.$yQ=void 0;const h=new WeakMap,R=(O,C)=>{const m={controllerId:C};return h.set(O,m),m};e.$yQ=R;const A=O=>{const C=h.get(O);if(!C)throw new s.$vQ(O?.id||"<unknown>");return C};e.$zQ=A}),define(Re[121],Ce([1,0,26,14,2]),function(ge,e,s,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$Db=e.$0Db=e.$9Db=void 0,e.$_Db=A,e.$aEb=C,e.$9Db="vscode-cdn.net",e.$0Db=`vscode-resource.${e.$9Db}`,e.$$Db=`'self' https://*.${e.$9Db}`;function A(m,c){return m.scheme===h.Schemas.http||m.scheme===h.Schemas.https?m:(c&&c.authority&&c.isRemote&&m.scheme===h.Schemas.file&&(m=R.URI.from({scheme:h.Schemas.vscodeRemote,authority:c.authority,path:m.path})),R.URI.from({scheme:h.Schemas.https,authority:`${m.scheme}+${O(m.authority)}.${e.$0Db}`,path:m.path,fragment:m.fragment,query:m.query}))}function O(m){return m.replace(/./g,c=>{const I=c.charCodeAt(0);return I>=s.CharCode.a&&I<=s.CharCode.z||I>=s.CharCode.A&&I<=s.CharCode.Z||I>=s.CharCode.Digit0&&I<=s.CharCode.Digit9?c:"-"+I.toString(16).padStart(4,"0")})}function C(m){return m.replace(/-([0-9a-f]{4})/g,(c,I)=>String.fromCharCode(parseInt(I,16)))}}),define(Re[266],Ce([1,0,4,3,121]),function(ge,e,s,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qqc=void 0;class A{constructor(C,m,c){this.d=C,this.e=m,this.f=c,this.a=0,this.b=new h.$Wc,this.c=new Map,this.b.add(m.onDidChangeVisibleTextEditors(()=>{const I=m.getVisibleTextEditors();for(const E of this.c.values())I.indexOf(E.editor)<0&&E.inset.dispose()}))}dispose(){this.c.forEach(C=>C.inset.dispose()),this.b.dispose()}createWebviewEditorInset(C,m,c,I,E){let g;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===C){g=i;break}if(!g)throw new Error("not a visible editor");const P=this,b=this.a++,a=new s.$oe,$=new s.$oe,p=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,R.$_Db)(i,P.f)}get cspSource(){return R.$$Db}set options(i){this.b=i,P.d.$setOptions(b,i)}get options(){return this.b}set html(i){this.a=i,P.d.$setHtml(b,i)}get html(){return this.a}get onDidReceiveMessage(){return a.event}postMessage(i){return P.d.$postMessage(b,i)}},u=new class{constructor(){this.editor=C,this.line=m,this.height=c,this.webview=p,this.onDidDispose=$.event}dispose(){P.c.has(b)&&(P.c.delete(b),P.d.$disposeEditorInset(b),$.fire(),$.dispose(),a.dispose())}};return this.d.$createEditorInset(b,g.id,g.value.document.uri,m+1,c,I||{},E.identifier,E.extensionLocation),this.c.set(b,{editor:C,inset:u,onDidReceiveMessage:a}),u}$onDidDispose(C){const m=this.c.get(C);m&&m.inset.dispose()}$onDidReceiveMessage(C,m){this.c.get(C)?.onDidReceiveMessage.fire(m)}}e.$Qqc=A}),define(Re[159],Ce([1,0,5]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8M=e.$7M=e.$6M=void 0,e.$6M="__",e.$7M=(0,s.$Ii)("IAuthenticationService"),e.$8M=(0,s.$Ii)("IAuthenticationExtensionsService")}),define(Re[267],Ce([1,0,5,12]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sR=e.VariableKind=e.$rR=void 0,e.$rR=(0,s.$Ii)("configurationResolverService");var R;(function(O){O.Unknown="unknown",O.Env="env",O.Config="config",O.Command="command",O.Input="input",O.ExtensionInstallFolder="extensionInstallFolder",O.WorkspaceFolder="workspaceFolder",O.Cwd="cwd",O.WorkspaceFolderBasename="workspaceFolderBasename",O.UserHome="userHome",O.LineNumber="lineNumber",O.SelectedText="selectedText",O.File="file",O.FileWorkspaceFolder="fileWorkspaceFolder",O.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",O.RelativeFile="relativeFile",O.RelativeFileDirname="relativeFileDirname",O.FileDirname="fileDirname",O.FileExtname="fileExtname",O.FileBasename="fileBasename",O.FileBasenameNoExtension="fileBasenameNoExtension",O.FileDirnameBasename="fileDirnameBasename",O.ExecPath="execPath",O.ExecInstallFolder="execInstallFolder",O.PathSeparator="pathSeparator",O.PathSeparatorAlias="/"})(R||(e.VariableKind=R={}));class A extends h.$db{constructor(C,m){super(m),this.variable=C}}e.$sR=A}),define(Re[268],Ce([1,0,16,55,17,24,10,107,8,267,13]),function(ge,e,s,h,R,A,O,C,m,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HR=void 0,s=Ue(s),h=Ue(h),R=Ue(R),A=Ue(A);class E{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(P,b,a,$){this.h=new Map,this.a=P,this.b=b,this.g=a,$&&(this.c=$.then(p=>this.i(p)))}i(P){if(O.$j){const b=Object.create(null);return Object.keys(P).forEach(a=>{b[a.toLowerCase()]=P[a]}),b}return P}resolveWithEnvironment(P,b,a){return this.l({env:this.i(P),userHome:void 0},b?b.uri:void 0,a)}async resolveAsync(P,b){const a={env:await this.c,userHome:await this.g};return this.l(a,P?P.uri:void 0,b)}async j(P,b,a,$){const p=A.$io(b);O.$j&&p.windows?Object.keys(p.windows).forEach(i=>p[i]=p.windows[i]):O.$k&&p.osx?Object.keys(p.osx).forEach(i=>p[i]=p.osx[i]):O.$l&&p.linux&&Object.keys(p.linux).forEach(i=>p[i]=p.linux[i]),delete p.windows,delete p.osx,delete p.linux;const u={env:await this.c,userHome:await this.g};return this.l(u,P?P.uri:void 0,p,a,$)}async resolveAnyAsync(P,b,a){return this.j(P,b,a)}async resolveAnyMap(P,b,a){const $=new Map;return{newConfig:await this.j(P,b,a,$),resolvedVariables:$}}resolveWithInteractionReplace(P,b,a,$){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(P,b,a,$){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(P,b){if(this.h.has(P))throw new Error("Variable "+P+" is contributed twice.");this.h.set(P,b)}async l(P,b,a,$,p){if(R.$hg(a))return this.m(P,b,a,$,p);if(Array.isArray(a))return Promise.all(a.map(u=>this.l(P,b,u,$,p)));if(R.$jg(a)){const u=Object.create(null),i=await Promise.all(Object.keys(a).map(async o=>[await this.m(P,b,o,$,p),await this.l(P,b,a[o],$,p)]));for(const[o,t]of i)u[o]=t;return u}return a}m(P,b,a,$,p){return(0,I.$Af)(a,E.VARIABLE_REGEXP,async(u,i)=>{if(i.includes(E.VARIABLE_LHS))return u;let o=await this.o(P,u,i,b,$);return p?.set(i,o),o!==u&&R.$hg(o)&&o.match(E.VARIABLE_REGEXP)&&(o=await this.m(P,b,o,$,p)),o})}n(P){return this.b?this.b.getUriLabel(P,{noPrefix:!0}):P.fsPath}async o(P,b,a,$,p){let u;const i=a.split(":");i.length>1&&(a=i[0],u=i[1]);const o=r=>{const d=this.a.getFilePath();if(d)return(0,C.$8w)(d);throw new c.$sR(r,(0,m.localize)(12142,null,b))},t=r=>{const d=o(r);if(this.a.getWorkspaceFolderPathForFile){const l=this.a.getWorkspaceFolderPathForFile();if(l)return(0,C.$8w)(l)}throw new c.$sR(r,(0,m.localize)(12143,null,b,s.$qc(d)))},n=r=>{if(u){const d=this.a.getFolderUri(u);if(d)return d;throw new c.$sR(r,(0,m.localize)(12144,null,b,u))}if($)return $;throw this.a.getWorkspaceFolderCount()>1?new c.$sR(r,(0,m.localize)(12145,null,b)):new c.$sR(r,(0,m.localize)(12146,null,b))};switch(a){case"env":if(u){if(P.env){const r=P.env[O.$j?u.toLowerCase():u];if(R.$hg(r))return r}return""}throw new c.$sR(c.VariableKind.Env,(0,m.localize)(12147,null,b));case"config":if(u){const r=this.a.getConfigurationValue($,u);if(R.$qg(r))throw new c.$sR(c.VariableKind.Config,(0,m.localize)(12148,null,b,u));if(R.$jg(r))throw new c.$sR(c.VariableKind.Config,(0,m.localize)(12149,null,b,u));return r}throw new c.$sR(c.VariableKind.Config,(0,m.localize)(12150,null,b));case"command":return this.p(c.VariableKind.Command,b,u,p,"command");case"input":return this.p(c.VariableKind.Input,b,u,p,"input");case"extensionInstallFolder":if(u){const r=await this.a.getExtension(u);if(!r)throw new c.$sR(c.VariableKind.ExtensionInstallFolder,(0,m.localize)(12151,null,b,u));return this.n(r.extensionLocation)}throw new c.$sR(c.VariableKind.ExtensionInstallFolder,(0,m.localize)(12152,null,b));default:switch(a){case"workspaceRoot":case"workspaceFolder":return(0,C.$8w)(this.n(n(c.VariableKind.WorkspaceFolder)));case"cwd":return $||u?(0,C.$8w)(this.n(n(c.VariableKind.Cwd))):h.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,C.$8w)(s.$qc(this.n(n(c.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(P.userHome)return P.userHome;throw new c.$sR(c.VariableKind.UserHome,(0,m.localize)(12153,null,b))}case"lineNumber":{const r=this.a.getLineNumber();if(r)return r;throw new c.$sR(c.VariableKind.LineNumber,(0,m.localize)(12154,null,b))}case"selectedText":{const r=this.a.getSelectedText();if(r)return r;throw new c.$sR(c.VariableKind.SelectedText,(0,m.localize)(12155,null,b))}case"file":return o(c.VariableKind.File);case"fileWorkspaceFolder":return t(c.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return s.$qc(t(c.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return $||u?s.$oc(this.n(n(c.VariableKind.RelativeFile)),o(c.VariableKind.RelativeFile)):o(c.VariableKind.RelativeFile);case"relativeFileDirname":{const r=s.$pc(o(c.VariableKind.RelativeFileDirname));if($||u){const d=s.$oc(this.n(n(c.VariableKind.RelativeFileDirname)),r);return d.length===0?".":d}return r}case"fileDirname":return s.$pc(o(c.VariableKind.FileDirname));case"fileExtname":return s.$rc(o(c.VariableKind.FileExtname));case"fileBasename":return s.$qc(o(c.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=s.$qc(o(c.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-s.$rc(r).length)}case"fileDirnameBasename":return s.$qc(s.$pc(o(c.VariableKind.FileDirnameBasename)));case"execPath":{const r=this.a.getExecPath();return r||b}case"execInstallFolder":{const r=this.a.getAppRoot();return r||b}case"pathSeparator":case"/":return s.sep;default:try{const r=u?`${a}:${u}`:a;return this.p(c.VariableKind.Unknown,b,r,p,void 0)}catch{return b}}}}p(P,b,a,$,p){if(a&&$){const u=p===void 0?$[a]:$[p+":"+a];if(typeof u=="string")return u;throw new c.$sR(P,(0,m.localize)(12156,null,b))}return b}}e.$HR=E}),define(Re[160],Ce([1,0,5,155]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$JE=void 0,e.$KE=c,e.$LE=g,e.$ME=P,e.$JE=(0,s.$Ii)("editorGroupsService");var R;(function(b){b[b.UP=0]="UP",b[b.DOWN=1]="DOWN",b[b.LEFT=2]="LEFT",b[b.RIGHT=3]="RIGHT"})(R||(e.GroupDirection=R={}));var A;(function(b){b[b.HORIZONTAL=0]="HORIZONTAL",b[b.VERTICAL=1]="VERTICAL"})(A||(e.GroupOrientation=A={}));var O;(function(b){b[b.FIRST=0]="FIRST",b[b.LAST=1]="LAST",b[b.NEXT=2]="NEXT",b[b.PREVIOUS=3]="PREVIOUS"})(O||(e.GroupLocation=O={}));var C;(function(b){b[b.MAXIMIZE=0]="MAXIMIZE",b[b.EXPAND=1]="EXPAND",b[b.EVEN=2]="EVEN"})(C||(e.GroupsArrangement=C={}));var m;(function(b){b[b.COPY_EDITORS=0]="COPY_EDITORS",b[b.MOVE_EDITORS=1]="MOVE_EDITORS"})(m||(e.MergeGroupMode=m={}));function c(b){const a=b;return(0,h.$vG)(a?.editor)&&(0,h.$vG)(a?.replacement)}var I;(function(b){b[b.CREATION_TIME=0]="CREATION_TIME",b[b.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",b[b.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(I||(e.GroupsOrder=I={}));var E;(function(b){b[b.NEW_EDITOR=1]="NEW_EDITOR",b[b.MOVE_EDITOR=2]="MOVE_EDITOR",b[b.COPY_EDITOR=3]="COPY_EDITOR"})(E||(e.OpenEditorContext=E={}));function g(b){const a=b;return!!a&&typeof a.id=="number"&&Array.isArray(a.editors)}function P(b){return b.getValue("workbench.editor.openSideBySideDirection")==="down"?R.DOWN:R.RIGHT}}),define(Re[269],Ce([1,0,5,160]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QE=e.$PE=e.$OE=e.$NE=void 0,e.$RE=R,e.$NE=(0,s.$Ii)("editorService"),e.$OE=-1,e.$PE=-2,e.$QE=-3;function R(A){const O=A;return typeof A=="number"||(0,h.$LE)(O)}}),define(Re[161],Ce([1,0,5,146]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nN=void 0,e.$nN=(0,s.$Ji)(h.$Pi)}),define(Re[162],Ce([1,0,23,4,16,3,7]),function(ge,e,s,h,R,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rec=e.$Qec=e.$Pec=e.$Oec=e.$Nec=void 0,R=Ue(R);class C{constructor(u,i){this.versionId=u,this.removedDueToLooping=i}}e.$Nec=C;class m{static isHostExtension(u,i,o){if(i.getExtensionDescription(u))return!1;const t=o.getExtensionDescription(u);return t?!!((t.main||t.browser)&&t.api==="none"):!1}constructor(u,i){this.j=u,this.c=new h.$oe,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(a),this.f=new s.$xn,this.g=[],this.h=new Map;for(const u of this.e){if(this.f.has(u.identifier)){console.error("Extension `"+u.identifier.value+"` is already registered");continue}this.f.set(u.identifier,u),this.g.push(u);const i=this.j.readActivationEvents(u);for(const o of i)this.h.has(o)||this.h.set(o,[]),this.h.get(o).push(u)}}set(u){return this.e=u,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(u,i){this.e=$(this.e,i),this.e=this.e.concat(u);const o=m.l(this.e);return this.e=$(this.e,o.map(t=>t.identifier)),this.k(),this.d++,this.c.fire(void 0),new C(this.d,o)}static l(u){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(d){this.d.has(d)||(this.d.add(d),this.e.push(d))}addArc(d,l){this.addNode(d),this.addNode(l),this.c.has(d)?this.c.get(d).push(l):this.c.set(d,[l])}getArcs(d){return this.c.has(d)?this.c.get(d):[]}hasOnlyGoodArcs(d,l){const f=i.getArcs(d);for(let y=0;y<f.length;y++)if(!l.has(f[y]))return!1;return!0}getNodes(){return this.e}},o=new s.$xn;for(const d of u)if(o.set(d.identifier,d),d.extensionDependencies)for(const l of d.extensionDependencies)i.addArc(s.$vn.toKey(d.identifier),s.$vn.toKey(l));const t=new Set;i.getNodes().filter(d=>i.getArcs(d).length===0).forEach(d=>t.add(d));const n=i.getNodes().filter(d=>!t.has(d));let r;do{r=!1;for(let d=0;d<n.length;d++){const l=n[d];i.hasOnlyGoodArcs(l,t)&&(n.splice(d,1),d--,t.add(l),r=!0)}}while(r);return n.map(d=>o.get(d))}containsActivationEvent(u){return this.h.has(u)}containsExtension(u){return this.f.has(u)}getExtensionDescriptionsForActivationEvent(u){const i=this.h.get(u);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new c(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(u){const i=this.f.get(u);return i||void 0}getExtensionDescriptionByUUID(u){for(const i of this.g)if(i.uuid===u)return i}getExtensionDescriptionByIdOrUUID(u,i){return this.getExtensionDescription(u)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$Oec=m;class c{constructor(u,i){this.versionId=u,this.extensions=i}}e.$Pec=c;class I{constructor(u){this.d=new P,this.c=new m(u,[])}async acquireLock(u){const i=await this.d.acquire(u);return new E(this,i)}deltaExtensions(u,i,o){if(!u.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,o)}containsActivationEvent(u){return this.c.containsActivationEvent(u)}containsExtension(u){return this.c.containsExtension(u)}getExtensionDescriptionsForActivationEvent(u){return this.c.getExtensionDescriptionsForActivationEvent(u)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(u){return this.c.getExtensionDescription(u)}getExtensionDescriptionByUUID(u){return this.c.getExtensionDescriptionByUUID(u)}getExtensionDescriptionByIdOrUUID(u,i){return this.c.getExtensionDescriptionByIdOrUUID(u,i)}}e.$Qec=I;class E extends A.$Xc{constructor(u,i){super(),this.f=u,this.c=!1,this.B(i)}isAcquiredFor(u){return!this.c&&this.f===u}}e.$Rec=E;class g{constructor(u){this.name=u;const i=(0,O.$Bh)();this.promise=i.promise,this.c=i.resolve}resolve(u){this.c(u)}}class P{constructor(){this.c=[],this.d=!1}async acquire(u){const i=new g(u);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const u=this.c.shift();this.d=!0;let i=!0;const o=setTimeout(()=>{i&&console.warn(`The customer named ${u.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),t=()=>{i&&(clearTimeout(o),i=!1,this.d=!1,this.e())};u.resolve((0,A.$Vc)(t))}}var b;(function(p){p[p.Builtin=0]="Builtin",p[p.User=1]="User",p[p.Dev=2]="Dev"})(b||(b={}));function a(p,u){const i=p.isBuiltin?b.Builtin:p.isUnderDevelopment?b.Dev:b.User,o=u.isBuiltin?b.Builtin:u.isUnderDevelopment?b.Dev:b.User;if(i!==o)return i-o;const t=R.$jc.basename(p.extensionLocation.path),n=R.$jc.basename(u.extensionLocation.path);return t<n?-1:t>n?1:0}function $(p,u){const i=new s.$wn(u);return p.filter(o=>!i.has(o.identifier))}}),define(Re[270],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=e.$hn=e.$gn=e.ExtHostConnectionType=void 0,e.$jn=C,e.$kn=m;var s;(function(I){I[I.IPC=1]="IPC",I[I.Socket=2]="Socket",I[I.MessagePort=3]="MessagePort"})(s||(e.ExtHostConnectionType=s={}));class h{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(E){this.pipeName=E,this.type=s.IPC}serialize(E){E[h.ENV_KEY]=this.pipeName}}e.$gn=h;class R{constructor(){this.type=s.Socket}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(E){E[R.ENV_KEY]="1"}}e.$hn=R;class A{constructor(){this.type=s.MessagePort}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(E){E[A.ENV_KEY]="1"}}e.$in=A;function O(I){delete I[h.ENV_KEY],delete I[R.ENV_KEY],delete I[A.ENV_KEY]}function C(I,E){O(E),I.serialize(E)}function m(I){if(I[h.ENV_KEY])return c(I,new h(I[h.ENV_KEY]));if(I[R.ENV_KEY])return c(I,new R);if(I[A.ENV_KEY])return c(I,new A);throw new Error("No connection information defined in environment!")}function c(I,E){return O(I),E}}),define(Re[94],Ce([1,0,21]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Fn=O,e.$Gn=C;var h;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(h||(e.UIKind=h={}));var R;(function(c){c[c.VersionMismatch=55]="VersionMismatch",c[c.UnexpectedError=81]="UnexpectedError"})(R||(e.ExtensionHostExitCode=R={}));var A;(function(c){c[c.Initialized=0]="Initialized",c[c.Ready=1]="Ready",c[c.Terminate=2]="Terminate"})(A||(e.MessageType=A={}));function O(c){const I=s.$Qe.alloc(1);switch(c){case A.Initialized:I.writeUInt8(1,0);break;case A.Ready:I.writeUInt8(2,0);break;case A.Terminate:I.writeUInt8(3,0);break}return I}function C(c,I){if(c.byteLength!==1)return!1;switch(c.readUInt8(0)){case 1:return I===A.Initialized;case 2:return I===A.Ready;case 3:return I===A.Terminate;default:return!1}}var m;(function(c){c.Start="START_NATIVE_LOG",c.End="END_NATIVE_LOG"})(m||(e.NativeLogMarkers=m={}))}),define(Re[95],Ce([1,0,5,4,151,11,29,94,91,92,24,2,3,8]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XQ=e.$VQ=e.$UQ=void 0,e.$WQ=$;let b=class extends g.$Xc{constructor(u,i){super(),this.s=u,this.t=i,this.a=this.B(new h.$oe),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new h.$oe),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=R.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=E.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:c.$Gp,name:(0,P.localize)(2713,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(o=>{(0,A.$fk)(o)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===A.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===R.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=R.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=R.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=R.TelemetryLevel.USAGE:!1}}instantiateLogger(u,i,o){const t=this.getTelemetryDetails(),n=new a(i,o,u,this.n,this.j,this.getBuiltInCommonProperties(u),{isUsageEnabled:t.isUsageEnabled,isErrorsEnabled:t.isErrorsEnabled}),r=this.r.get(u.identifier.value)??[];return this.r.set(u.identifier.value,[...r,n]),n.apiTelemetryLogger}$initializeTelemetryLevel(u,i,o){this.f=u,this.g=i,this.c=o??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(u){const i=Object.create(null);switch(i["common.extname"]=`${u.publisher}.${u.name}`,i["common.extversion"]=u.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=$(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case C.UIKind.Web:i["common.uikind"]="web";break;case C.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,m.$mn)((0,c.$Mp)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(u){this.h=this.getTelemetryConfiguration(),this.f=u;const i=this.getTelemetryDetails();this.r.forEach((o,t)=>{const n=o.filter(r=>!r.isDisposed);n.length===0?this.r.delete(t):this.r.set(t,n)}),this.r.forEach(o=>{for(const t of o)t.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(u,i){const t=this.r.get(u.value)?.filter(r=>!r.isDisposed);if(!t)return this.r.delete(u.value),!1;let n=!1;for(const r of t)r.ignoreUnhandledExtHostErrors||(r.logError(i),n=!0);return n}};e.$UQ=b,e.$UQ=b=Ze([qe(0,O.$TQ),qe(1,A.$ek)],b);class a{static validateSender(u){if(typeof u!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof u.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof u.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof u.flush<"u"&&typeof u.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(u,i,o,t,n,r,d){this.g=o,this.h=t,this.i=n,this.j=r,this.a=new h.$oe,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=u,this.d={isUsageEnabled:d.isUsageEnabled,isErrorsEnabled:d.isErrorsEnabled}}updateTelemetryEnablements(u,i){this.e&&(this.d={isUsageEnabled:u,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(u){let i="properties"in u?u.properties??{}:u;return i=(0,c.$Pp)(i,[]),this.c&&(i=(0,I.$lo)(i,this.c)),this.b||(i=(0,I.$lo)(i,this.j)),"properties"in u?u.properties=i:u=i,u}k(u,i){this.f&&(this.g.publisher==="vscode"?u=this.g.name+"/"+u:u=this.g.identifier.value+"/"+u,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(u,i),this.h.trace(u,i))}logUsage(u,i){this.d.isUsageEnabled&&this.k(u,i)}logError(u,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof u=="string")this.k(u,i);else{const o={name:u.name,message:u.message,stack:u.stack,cause:u.cause},t=(0,c.$Pp)(o,[]),n=new Error(t.message,{cause:t.cause});n.stack=t.stack,n.name=t.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(n,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const u=this,i={logUsage:u.logUsage.bind(u),get isUsageEnabled(){return u.d.isUsageEnabled},get isErrorsEnabled(){return u.d.isErrorsEnabled},logError:u.logError.bind(u),dispose:u.dispose.bind(u),onDidChangeEnableStates:u.a.event.bind(u)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let u=this.f;this.f=void 0,Promise.resolve(u.flush()).then(u=void 0),this.e=void 0}else this.f=void 0}}e.$VQ=a;function $(p){const u=Date.now()-new Date(p).getTime();return isNaN(u)?!1:u<1e3*60*60*24}e.$XQ=(0,s.$Ii)("IExtHostTelemetry")}),define(Re[25],Ce([1,0,4,2,242,149,23,5]),function(ge,e,s,h,R,A,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BH=e.ActivationKind=e.$yH=e.$xH=e.$uH=e.ExtensionHostStartup=e.$tH=e.$sH=e.$rH=e.$qH=void 0,e.$vH=g,e.$wH=P,e.$zH=p,e.$AH=u,e.$qH=Object.freeze({identifier:new O.$vn("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:h.URI.parse("void:location"),isBuiltin:!1,targetPlatform:O.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$rH="extensions.webWorker",e.$sH=(0,C.$Ii)("extensionService");class m{constructor(t){this.dependency=t}}e.$tH=m;var c;(function(o){o[o.EagerAutoStart=1]="EagerAutoStart",o[o.EagerManualStart=2]="EagerManualStart",o[o.Lazy=3]="Lazy"})(c||(e.ExtensionHostStartup=c={}));class I{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(t,n,r){this.c=t,this.d=n.slice(0),this.e=r.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:A.$cH.createActivationEventsMap(this.d)}}set(t,n,r){if(this.c>t)throw new Error(`ExtensionHostExtensions: invalid versionId ${t} (current: ${this.c})`);const d=[],l=[],f=[],y=[],k=E(this.d),S=E(n),D=(L,N)=>L.extensionLocation.toString()===N.extensionLocation.toString()||L.isBuiltin===N.isBuiltin||L.isUserBuiltin===N.isUserBuiltin||L.isUnderDevelopment===N.isUnderDevelopment;for(const L of this.d){const N=S.get(L.identifier);if(!N){d.push(L.identifier),k.delete(L.identifier);continue}if(!D(L,N)){d.push(L.identifier),k.delete(L.identifier);continue}}for(const L of n){const N=k.get(L.identifier);if(!N){l.push(L);continue}if(!D(N,L)){d.push(N.identifier),k.delete(N.identifier);continue}}const T=new O.$wn(this.e),v=new O.$wn(r);for(const L of this.e)v.has(L)||f.push(L);for(const L of r)T.has(L)||y.push(L);const w=A.$cH.createActivationEventsMap(l),M={versionId:t,toRemove:d,toAdd:l,addActivationEvents:w,myToRemove:f,myToAdd:y};return this.delta(M),M}delta(t){if(this.c>=t.versionId)return null;const{toRemove:n,toAdd:r,myToRemove:d,myToAdd:l}=t,f=new O.$wn(n),y=new O.$wn(d);for(let k=0;k<this.d.length;k++)f.has(this.d[k].identifier)&&(this.d.splice(k,1),k--);for(let k=0;k<this.e.length;k++)y.has(this.e[k])&&(this.e.splice(k,1),k--);for(const k of r)this.d.push(k);for(const k of l)this.e.push(k);return this.f=null,t}containsExtension(t){for(const n of this.e)if(O.$vn.equals(n,t))return!0;return!1}containsActivationEvent(t){return this.f||(this.f=this.g()),this.f.has(t)}g(){const t=new Set;for(const n of this.d){if(!this.containsExtension(n.identifier))continue;const r=A.$cH.readActivationEvents(n);for(const d of r)t.add(d)}return t}}e.$uH=I;function E(o){const t=new O.$xn;for(const n of o)t.set(n.identifier,n);return t}function g(o,t){return o.enabledApiProposals?o.enabledApiProposals.includes(t):!1}function P(o,t){if(!g(o,t))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}class b{constructor(t,n,r,d){this.codeLoadingTime=t,this.activateCallTime=n,this.activateResolvedTime=r,this.activationReason=d}}e.$xH=b;class a{constructor(t,n){this.description=t,this.value=n}}e.$yH=a;var $;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})($||(e.ActivationKind=$={}));function p(o){return{type:o.isBuiltin?O.ExtensionType.System:O.ExtensionType.User,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,R.$Vp)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}function u(o,t){const n=(0,R.$Tp)(o.manifest.publisher,o.manifest.name);return{id:n,identifier:new O.$vn(n),isBuiltin:o.type===O.ExtensionType.System,isUserBuiltin:o.type===O.ExtensionType.User&&o.isBuiltin,isUnderDevelopment:!!t,extensionLocation:o.location,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform,publisherDisplayName:o.publisherDisplayName,...o.manifest}}class i{constructor(){this.onDidRegisterExtensions=s.Event.None,this.onDidChangeExtensionsStatus=s.Event.None,this.onDidChangeExtensions=s.Event.None,this.onWillActivateByEvent=s.Event.None,this.onDidChangeResponsiveChange=s.Event.None,this.onWillStop=s.Event.None,this.extensions=[]}activateByEvent(t){return Promise.resolve(void 0)}activateById(t,n){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(t,n){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$BH=i}),define(Re[271],Ce([1,0,12,3,162,23,25,11,7]),function(ge,e,s,h,R,A,O,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$frc=e.$erc=e.$drc=e.$crc=e.$brc=e.$arc=void 0,s=Ue(s);class c{static{this.NONE=new c(!1,-1,-1,-1)}constructor(u,i,o,t){this.startup=u,this.codeLoadingTime=i,this.activateCallTime=o,this.activateResolvedTime=t}}e.$arc=c;class I{constructor(u){this.a=u,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(u,i){return u===-1||i===-1?-1:i-u}build(){return new c(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$brc=I;class E{constructor(u,i,o,t,n,r){this.activationFailed=u,this.activationFailedError=i,this.activationTimes=o,this.module=t,this.exports=n,this.disposable=r}}e.$crc=E;class g extends E{constructor(u){super(!1,null,u,{activate:void 0,deactivate:void 0},void 0,h.$Xc.None)}}e.$drc=g;class P extends E{constructor(){super(!1,null,c.NONE,{activate:void 0,deactivate:void 0},void 0,h.$Xc.None)}}e.$erc=P;class b extends E{constructor(u){super(!0,u,c.NONE,{activate:void 0,deactivate:void 0},void 0,h.$Xc.None)}}let a=class{constructor(u,i,o,t){this.g=t,this.a=u,this.b=i,this.c=o,this.d=new A.$xn,this.f=Object.create(null)}dispose(){for(const[u,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const u=[];for(const[i,o]of this.d)u.push(o.wait());await Promise.all(u)}isActivated(u){const i=this.d.get(u);return!!(i&&i.value)}getActivatedExtension(u){const i=this.d.get(u);if(!i||!i.value)throw new Error(`Extension '${u.value}' is not known or not activated`);return i.value}async activateByEvent(u,i){if(this.f[u])return;const o=this.a.getExtensionDescriptionsForActivationEvent(u);await this.h(o.map(t=>({id:t.identifier,reason:{startup:i,extensionId:t.identifier,activationEvent:u}}))),this.f[u]=!0}activateById(u,i){const o=this.a.getExtensionDescription(u);if(!o)throw new Error(`Extension '${u.value}' is not known`);return this.h([{id:o.identifier,reason:i}])}async h(u){const i=u.filter(o=>!this.isActivated(o.id)).map(o=>this.j(o));await Promise.all(i.map(o=>o.wait()))}j(u){if(this.d.has(u.id))return this.d.get(u.id);if(this.l(u.id))return this.k(u,null,[],null);const i=this.a.getExtensionDescription(u.id);if(!i){const n=new Error(`Cannot activate unknown extension '${u.id.value}'`),r=this.k(u,null,[],new b(n));return this.c.onExtensionActivationError(u.id,n,new O.$tH(u.id.value)),r}const o=[],t=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const n of t){if(this.m(n))continue;const r=this.d.get(n);if(r){o.push(r);continue}if(this.l(n)){o.push(this.j({id:this.b.getExtensionDescription(n).identifier,reason:u.reason}));continue}const d=this.a.getExtensionDescription(n);if(d){if(!d.main&&!d.browser)continue;o.push(this.j({id:d.identifier,reason:u.reason}));continue}const l=i.displayName||i.identifier.value,f=new Error(`Cannot activate the '${l}' extension because it depends on unknown extension '${n}'`),y=this.k(u,i.displayName,[],new b(f));return this.c.onExtensionActivationError(i.identifier,f,new O.$tH(n)),y}return this.k(u,i.displayName,o,null)}k(u,i,o,t){const n=new $(u.id,i,u.reason,o,t,this.c,this.g);return this.d.set(u.id,n),n}l(u){return R.$Oec.isHostExtension(u,this.a,this.b)}m(u){const i=this.b.getExtensionDescription(u);return i?!i.main&&!i.browser:!1}};e.$frc=a,e.$frc=a=Ze([qe(3,C.$dk)],a);let $=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(u,i,o,t,n,r,d){this.c=u,this.d=i,this.f=o,this.g=t,this.h=n,this.j=r,this.k=d,this.a=new m.$Hh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let u=0;u<this.g.length;u++){const i=this.g[u];if(i.value&&!i.value.activationFailed){this.g.splice(u,1),u--;continue}if(i.value&&i.value.activationFailed){const o=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);o.detail=i.value.activationFailedError,this.h=new b(o),this.j.onExtensionActivationError(this.c,o,null);return}}this.g.length>0&&await Promise.race(this.g.map(u=>u.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(u){const i=new Error;if(u&&u.name&&(i.name=u.name),u&&u.message?i.message=`Activating extension '${this.c.value}' failed: ${u.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${u}.`,u&&u.stack&&(i.stack=u.stack),this.h=new b(i),this.b&&s.$6(u))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(u)}}};$=Ze([qe(6,C.$dk)],$)});var Ht=this&&this.__importDefault||function(ge){return ge&&ge.__esModule?ge:{default:ge}};define(Re[163],Ce([1,0,8,12,44,148,116,37,23,115,149,145]),function(ge,e,s,h,R,A,O,C,m,c,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=void 0,s=Ue(s),R=Ht(R);const g=C.$vo.as(O.$wo.JSONContribution);class P{constructor(t,n,r){this.a=t,this.b=n,this.c=r}d(t,n){this.a({type:t,message:n,extensionId:this.b.identifier,extensionPointId:this.c})}error(t){this.d(R.default.Error,t)}warn(t){this.d(R.default.Warning,t)}info(t){this.d(R.default.Info,t)}}e.$kH=P;class b{static a(t){const n=new m.$wn;for(let r=0,d=t.length;r<d;r++)n.add(t[r].description.identifier);return n}static compute(t,n){if(!t||!t.length)return new b(n,[]);if(!n||!n.length)return new b([],t);const r=this.a(t),d=this.a(n),l=n.filter(y=>!r.has(y.description.identifier)),f=t.filter(y=>!d.has(y.description.identifier));return new b(l,f)}constructor(t,n){this.added=t,this.removed=n}}e.$lH=b;class a{constructor(t,n){this.name=t,this.defaultExtensionKind=n,this.a=null,this.b=null,this.c=null}setHandler(t){if(this.a!==null)throw new Error("Handler already set!");return this.a=t,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(t){this.c=b.compute(this.b,t),this.b=t,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(t){(0,h.$2)(t)}}}e.$mH=a;const $={type:"string",enum:["ui","workspace"],enumDescriptions:[s.localize(12311,null),s.localize(12312,null)]},p="vscode://schemas/vscode-extensions";e.$nH={properties:{engines:{type:"object",description:s.localize(12313,null),properties:{vscode:{type:"string",description:s.localize(12314,null),default:"^1.22.0"}}},publisher:{description:s.localize(12315,null),type:"string"},displayName:{description:s.localize(12316,null),type:"string"},categories:{description:s.localize(12317,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:m.$un},{type:"string",const:"Languages",deprecationMessage:s.localize(12318,null)}]}},galleryBanner:{type:"object",description:s.localize(12319,null),properties:{color:{description:s.localize(12320,null),type:"string"},theme:{description:s.localize(12321,null),type:"string",enum:["dark","light"]}}},contributes:{description:s.localize(12322,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:s.localize(12323,null)},enableProposedApi:{type:"boolean",deprecationMessage:s.localize(12324,null)},enabledApiProposals:{markdownDescription:s.localize(12325,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals).map(o=>o),markdownEnumDescriptions:Object.values(E.allApiProposals).map(o=>o.proposal)}},api:{markdownDescription:s.localize(12326,null),type:"string",enum:["none"],enumDescriptions:[s.localize(12327,null)]},activationEvents:{description:s.localize(12328,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:s.localize(12329,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:s.localize(12330,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:s.localize(12331,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:s.localize(12332,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:s.localize(12333,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:s.localize(12334,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:s.localize(12335,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:s.localize(12336,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:s.localize(12337,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:s.localize(12338,null),body:"onStartupFinished"},{label:"onTaskType",description:s.localize(12339,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:s.localize(12340,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:s.localize(12341,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:s.localize(12342,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:s.localize(12343,null)},{label:"onUri",body:"onUri",description:s.localize(12344,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:s.localize(12345,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:s.localize(12346,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:s.localize(12347,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:s.localize(12348,null)},{label:"onRenderer",description:s.localize(12349,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:s.localize(12350,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:s.localize(12351,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:s.localize(12352,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:s.localize(12353,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:s.localize(12354,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolId}",description:s.localize(12355,null)},{label:"*",description:s.localize(12356,null),body:"*"}]}},badges:{type:"array",description:s.localize(12357,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:s.localize(12358,null)},href:{type:"string",description:s.localize(12359,null)},description:{type:"string",description:s.localize(12360,null)}}}},markdown:{type:"string",description:s.localize(12361,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:s.localize(12362,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:s.localize(12363,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.$cp}},extensionPack:{description:s.localize(12364,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.$cp}},extensionKind:{description:s.localize(12365,null),type:"array",items:$,default:["workspace"],defaultSnippets:[{body:["ui"],description:s.localize(12366,null)},{body:["workspace"],description:s.localize(12367,null)},{body:["ui","workspace"],description:s.localize(12368,null)},{body:["workspace","ui"],description:s.localize(12369,null)},{body:[],description:s.localize(12370,null)}]},capabilities:{description:s.localize(12371,null),type:"object",properties:{virtualWorkspaces:{description:s.localize(12372,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:s.localize(12373,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[s.localize(12374,null),s.localize(12375,null),s.localize(12376,null)]},description:{type:"string",markdownDescription:s.localize(12377,null)}}},untrustedWorkspaces:{description:s.localize(12378,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:s.localize(12379,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[s.localize(12380,null),s.localize(12381,null),s.localize(12382,null)]},restrictedConfigurations:{description:s.localize(12383,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:s.localize(12384,null)}}}}},sponsor:{description:s.localize(12385,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:s.localize(12386,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:s.localize(12387,null),type:"string"},"vscode:uninstall":{description:s.localize(12388,null),type:"string"}}},icon:{type:"string",description:s.localize(12389,null)},l10n:{type:"string",description:s.localize(12390,null)},pricing:{type:"string",markdownDescription:s.localize(12391,null),enum:["Free","Trial"],default:"Free"}}};class u{constructor(){this.a=new Map}registerExtensionPoint(t){if(this.a.has(t.extensionPoint))throw new Error("Duplicate extension point: "+t.extensionPoint);const n=new a(t.extensionPoint,t.defaultExtensionKind);return this.a.set(t.extensionPoint,n),t.activationEventsGenerator&&I.$cH.register(t.extensionPoint,t.activationEventsGenerator),e.$nH.properties.contributes.properties[t.extensionPoint]=t.jsonSchema,g.registerSchema(p,e.$nH),n}getExtensionPoints(){return Array.from(this.a.values())}}e.$oH=u;const i={ExtensionsRegistry:"ExtensionsRegistry"};C.$vo.add(i.ExtensionsRegistry,new u),e.$pH=C.$vo.as(i.ExtensionsRegistry),g.registerSchema(p,e.$nH),g.registerSchema(c.$xk,{properties:{extensionEnabledApiProposals:{description:s.localize(12392,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals).map(o=>o.proposal)}}]}}}})}),define(Re[272],Ce([1,0,4,40,3,13,8,23,5,11,25,163]),function(ge,e,s,h,R,A,O,C,m,c,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EH=e.$DH=e.$CH=e.ChatMessageRole=void 0;var g;(function(a){a[a.System=0]="System",a[a.User=1]="User",a[a.Assistant=2]="Assistant"})(g||(e.ChatMessageRole=g={})),e.$CH=(0,m.$Ii)("ILanguageModelsService");const P={type:"object",properties:{vendor:{type:"string",description:(0,O.localize)(4728,null)}}};e.$DH=E.$pH.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,O.localize)(4729,null),oneOf:[P,{type:"array",items:P}]},activationEventsGenerator:(a,$)=>{for(const p of a)$.push(`onLanguageModelChat:${p.vendor}`)}});let b=class{constructor($,p){this.e=$,this.f=p,this.a=new R.$Wc,this.b=new Map,this.c=new Set,this.d=this.a.add(new s.$oe),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$DH.setHandler(u=>{this.c.clear();for(const o of u){if(!(0,I.$vH)(o.description,"chatProvider")){o.collector.error((0,O.localize)(4730,null));continue}for(const t of h.Iterable.wrap(o.value)){if(this.c.has(t.vendor)){o.collector.error((0,O.localize)(4731,null,t.vendor));continue}if((0,A.$ff)(t.vendor)){o.collector.error((0,O.localize)(4732,null));continue}if(t.vendor.trim()!==t.vendor){o.collector.error((0,O.localize)(4733,null));continue}this.c.add(t.vendor)}}const i=[];for(const[o,t]of this.b)this.c.has(t.metadata.vendor)||(this.b.delete(o),i.push(o));i.length>0&&this.d.fire({removed:i})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel($){return this.b.get($)?.metadata}async selectLanguageModels($){if($.vendor)await this.e.activateByEvent(`onLanguageModelChat:${$.vendor}}`);else{const u=Array.from(this.c).map(i=>this.e.activateByEvent(`onLanguageModelChat:${i}`));await Promise.all(u)}const p=[];for(const[u,i]of this.b)($.vendor===void 0||i.metadata.vendor===$.vendor)&&($.family===void 0||i.metadata.family===$.family)&&($.version===void 0||i.metadata.version===$.version)&&($.identifier===void 0||i.metadata.id===$.identifier)&&(!i.metadata.targetExtensions||i.metadata.targetExtensions.some(o=>C.$vn.equals(o,$.extension)))&&p.push(u);return this.f.trace("[LM] selected language models",$,p),p}registerLanguageModelChat($,p){if(this.f.trace("[LM] registering language model chat",$,p.metadata),!this.c.has(p.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${p.metadata.vendor}.`);if(this.b.has($))throw new Error(`Chat response provider with identifier ${$} is already registered.`);return this.b.set($,p),this.d.fire({added:[{identifier:$,metadata:p.metadata}]}),(0,R.$Vc)(()=>{this.b.delete($)&&(this.d.fire({removed:[$]}),this.f.trace("[LM] UNregistered language model chat",$,p.metadata))})}async sendChatRequest($,p,u,i,o){const t=this.b.get($);if(!t)throw new Error(`Chat response provider with identifier ${$} is not registered.`);return t.sendChatRequest(u,p,i,o)}computeTokenLength($,p,u){const i=this.b.get($);if(!i)throw new Error(`Chat response provider with identifier ${$} is not registered.`);return i.provideTokenCount(p,u)}};e.$EH=b,e.$EH=b=Ze([qe(0,I.$sH),qe(1,c.$dk)],b)}),define(Re[273],Ce([1,0,8,17,24,163,36,4]),function(ge,e,s,h,R,A,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aJ=void 0,s=Ue(s),h=Ue(h),R=Ue(R);const m={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:s.localize(9889,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:s.localize(9890,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:s.localize(9891,null),default:""}}};var c;(function(g){function P(b,a,$){if(!b)return;const p=h.$hg(b.type)?b.type:void 0;if(!p||p.length===0){$.error(s.localize(9892,null));return}const u=[];if(Array.isArray(b.required))for(const i of b.required)h.$hg(i)&&u.push(i);return{extensionId:a.value,taskType:p,required:u,properties:b.properties?R.$io(b.properties):{},when:b.when?O.$Gj.deserialize(b.when):void 0}}g.from=P})(c||(c={}));const I=A.$pH.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(g,P)=>{for(const b of g)b.type&&P.push(`onTaskType:${b.type}`)},jsonSchema:{description:s.localize(9893,null),type:"array",items:m}});class E{constructor(){this.d=new C.$oe,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((P,b)=>{I.setHandler((a,$)=>{this.c=void 0;try{for(const p of $.removed){const u=p.value;for(const i of u)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const p of $.added){const u=p.value;for(const i of u){const o=c.from(i,p.description.identifier,p.collector);o&&(this.a[o.taskType]=o)}}($.removed.length>0||$.added.length>0)&&this.d.fire()}catch{}P(void 0)})})}onReady(){return this.b}get(P){return this.a[P]}all(){return Object.keys(this.a).map(P=>this.a[P])}getJsonSchema(){if(this.c===void 0){const P=[];for(const b of this.all()){const a={type:"object",additionalProperties:!1};b.required.length>0&&(a.required=b.required.slice(0)),b.properties!==void 0?a.properties=R.$io(b.properties):a.properties=Object.create(null),a.properties.type={type:"string",enum:[b.taskType]},P.push(a)}this.c={oneOf:P}}return this.c}}e.$aJ=new E}),define(Re[274],Ce([1,0,8,17,22,24,36,273,46]),function(ge,e,s,h,R,A,O,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$kJ=e.JsonSchemaVersion=e.ExecutionEngine=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$eJ=e.ShellQuoting=e.$dJ=e.$cJ=e.$bJ=void 0,s=Ue(s),h=Ue(h),R=Ue(R),A=Ue(A),e.$bJ="settings",e.$cJ=new O.$Zj("taskRunning",!1,s.localize(9894,null)),e.$dJ=s.localize2(9896,"Tasks");var c;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(c||(e.ShellQuoting=c={})),e.$eJ="$customized",function(j){function U(z){if(!z)return j.Strong;switch(z.toLowerCase()){case"escape":return j.Escape;case"strong":return j.Strong;case"weak":return j.Weak;default:return j.Strong}}j.from=U}(c||(e.ShellQuoting=c={}));var I;(function(j){j.defaults={cwd:"${workspaceFolder}"}})(I||(e.CommandOptions=I={}));var E;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(E||(e.RevealKind=E={})),function(j){function U(z){switch(z.toLowerCase()){case"always":return j.Always;case"silent":return j.Silent;case"never":return j.Never;default:return j.Always}}j.fromString=U}(E||(e.RevealKind=E={}));var g;(function(j){j[j.Never=1]="Never",j[j.OnProblem=2]="OnProblem",j[j.Always=3]="Always"})(g||(e.RevealProblemKind=g={})),function(j){function U(z){switch(z.toLowerCase()){case"always":return j.Always;case"never":return j.Never;case"onproblem":return j.OnProblem;default:return j.OnProblem}}j.fromString=U}(g||(e.RevealProblemKind=g={}));var P;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(P||(e.PanelKind=P={})),function(j){function U(z){switch(z.toLowerCase()){case"shared":return j.Shared;case"dedicated":return j.Dedicated;case"new":return j.New;default:return j.Shared}}j.fromString=U}(P||(e.PanelKind=P={}));var b;(function(j){j.defaults={echo:!0,reveal:E.Always,revealProblems:g.Never,focus:!1,panel:P.Shared,showReuseMessage:!0,clear:!1}})(b||(e.PresentationOptions=b={}));var a;(function(j){j[j.Shell=1]="Shell",j[j.Process=2]="Process",j[j.CustomExecution=3]="CustomExecution"})(a||(e.RuntimeType=a={})),function(j){function U(_){switch(_.toLowerCase()){case"shell":return j.Shell;case"process":return j.Process;case"customExecution":return j.CustomExecution;default:return j.Process}}j.fromString=U;function z(_){switch(_){case j.Shell:return"shell";case j.Process:return"process";case j.CustomExecution:return"customExecution";default:return"process"}}j.toString=z}(a||(e.RuntimeType=a={}));var $;(function(j){function U(z){return h.$hg(z)?z:z.value}j.value=U})($||(e.CommandString=$={}));var p;(function(j){j.Clean={_id:"clean",isDefault:!1},j.Build={_id:"build",isDefault:!1},j.Rebuild={_id:"rebuild",isDefault:!1},j.Test={_id:"test",isDefault:!1};function U(_){return _===j.Clean._id||_===j.Build._id||_===j.Rebuild._id||_===j.Test._id}j.is=U;function z(_){if(_!==void 0)return h.$hg(_)?U(_)?{_id:_,isDefault:!1}:void 0:_}j.from=z})(p||(e.TaskGroup=p={}));var u;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.Folder=3]="Folder"})(u||(e.TaskScope=u={}));var i;(function(j){j.Workspace="workspace",j.Extension="extension",j.InMemory="inMemory",j.WorkspaceFile="workspaceFile",j.User="user";function U(z){switch(z){case j.User:return m.ConfigurationTarget.USER;case j.WorkspaceFile:return m.ConfigurationTarget.WORKSPACE;default:return m.ConfigurationTarget.WORKSPACE_FOLDER}}j.toConfigurationTarget=U})(i||(e.TaskSourceKind=i={}));var o;(function(j){j.parallel="parallel",j.sequence="sequence"})(o||(e.DependsOrder=o={}));var t;(function(j){j[j.default=1]="default",j[j.folderOpen=2]="folderOpen"})(t||(e.RunOnOptions=t={}));var n;(function(j){j.defaults={reevaluateOnRerun:!0,runOn:t.default,instanceLimit:1}})(n||(e.RunOptions=n={}));class r{constructor(U,z,_,W,B,Y){this._label="",this._id=U,z&&(this._label=z),_&&(this.type=_),this.runOptions=W,this.configurationProperties=B,this._source=Y}getDefinition(U){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const U={folder:this.d(),id:this._id};return JSON.stringify(U)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(U,z=!1){if(U===void 0)return!1;if(h.$hg(U))return U===this._label||U===this.configurationProperties.identifier||z&&U===this._id;const _=this.getDefinition(!0);return _!==void 0&&_._key===U._key}getQualifiedLabel(){const U=this.getWorkspaceFolder();return U?`${this._label} (${U.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(U){this.c===void 0&&(this.c=[]),U&&(this.c=this.c.concat(U))}get taskLoadMessages(){return this.c}}e.$fJ=r;class d extends r{constructor(U,z,_,W,B,Y,x,oe){super(U,_,void 0,x,oe,z),this.command={},this._source=z,this.hasDefinedMatchers=Y,B&&(this.command=B)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(U=!1){if(U&&this._source.customizes!==void 0)return this._source.customizes;{let z;switch(this.command?this.command.runtime:void 0){case a.Shell:z="shell";break;case a.Process:z="process";break;case a.CustomExecution:z="customExecution";break;case void 0:z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:z,_key:this._id,id:this._id}}}static is(U){return U instanceof d}getMapKey(){const U=this._source.config.workspaceFolder;return U?`${U.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$bJ:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const U=this.d();if(!U)return;let z=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(z+=this._source.kind);const _={type:e.$eJ,folder:U,id:z};return JSON.stringify(_)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?R.$gh(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(U){return new d(U._id,U._source,U._label,U.type,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.$gJ=d;class l extends r{constructor(U,z,_,W,B,Y,x){super(U,_,W,Y,x,z),this._source=z,this.configures=B}static is(U){return U instanceof l}f(U){return U}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?R.$gh(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$bJ:this._source.config.workspaceFolder?.uri.toString()}getKey(){const U=this.d();if(!U)return;let z=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(z+=this._source.kind);const _={type:e.$eJ,folder:U,id:z};return JSON.stringify(_)}}e.$hJ=l;class f extends r{constructor(U,z,_,W,B,Y,x,oe,ie){super(U,_,W,oe,ie,z),this.defines=B,this.hasDefinedMatchers=x,this.command=Y,this.icon=ie.icon,this.hide=ie.hide}clone(){return new f(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(U){return U instanceof f}getMapKey(){const U=this._source.workspaceFolder;return U?`${this._source.scope.toString()}|${U.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===u.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const U={type:"contributed",scope:this._source.scope,id:this._id};return U.folder=this.d(),JSON.stringify(U)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(U){return new f(U._id,U._source,U._label,U.type,U.defines,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.$iJ=f;class y extends r{constructor(U,z,_,W,B,Y){super(U,_,W,B,Y,z),this._source=z}clone(){return new y(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(U){return U instanceof y}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(U){return new y(U._id,U._source,U._label,U.type,U.runOptions,U.configurationProperties)}}e.$jJ=y;var k;(function(j){j[j.Process=1]="Process",j[j.Terminal=2]="Terminal"})(k||(e.ExecutionEngine=k={})),function(j){j._default=j.Terminal}(k||(e.ExecutionEngine=k={}));var S;(function(j){j[j.V0_1_0=1]="V0_1_0",j[j.V2_0_0=2]="V2_0_0"})(S||(e.JsonSchemaVersion=S={}));class D{constructor(U){this.c=new Map;for(let z=0;z<U.length;z++)this.c.set(U[z].uri.toString(),z)}compare(U,z){const _=U.getWorkspaceFolder(),W=z.getWorkspaceFolder();if(_&&W){let B=this.c.get(_.uri.toString());B=B===void 0?0:B+1;let Y=this.c.get(W.uri.toString());return Y=Y===void 0?0:Y+1,B===Y?U._label.localeCompare(z._label):B-Y}else return!_&&W?-1:_&&!W?1:0}}e.$kJ=D;var T;(function(j){j.DependsOnStarted="dependsOnStarted",j.AcquiredInput="acquiredInput",j.Start="start",j.ProcessStarted="processStarted",j.Active="active",j.Inactive="inactive",j.Changed="changed",j.Terminated="terminated",j.ProcessEnded="processEnded",j.End="end"})(T||(e.TaskEventKind=T={}));var v;(function(j){j.SingleRun="singleRun",j.Background="background"})(v||(e.TaskRunType=v={}));var w;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.FolderOpen=2]="FolderOpen",j[j.ConfigurationChange=3]="ConfigurationChange",j[j.Reconnect=4]="Reconnect"})(w||(e.TaskRunSource=w={}));var M;(function(j){function U(oe){return{taskId:oe._id,taskName:oe.configurationProperties.name,runType:oe.configurationProperties.isBackground?v.Background:v.SingleRun,group:oe.configurationProperties.group,__task:oe}}function z(oe,ie,me){return{...U(oe),kind:T.Start,terminalId:ie,resolvedVariables:me}}j.start=z;function _(oe,ie,me){return{...U(oe),kind:T.ProcessStarted,terminalId:ie,processId:me}}j.processStarted=_;function W(oe,ie,me){return{...U(oe),kind:T.ProcessEnded,terminalId:ie,exitCode:me}}j.processEnded=W;function B(oe,ie,me){return{...U(oe),kind:T.Terminated,exitReason:me,terminalId:ie}}j.terminated=B;function Y(oe,ie,me){return{...U(ie),kind:oe,terminalId:me}}j.general=Y;function x(){return{kind:T.Changed}}j.changed=x})(M||(e.TaskEvent=M={}));var L;(function(j){function U(_){const W=Object.keys(_).sort();let B="";for(const Y of W){let x=_[Y];x instanceof Object?x=U(x):typeof x=="string"&&(x=x.replace(/,/g,",,")),B+=Y+","+x+","}return B}function z(_){const B={_key:U(_),type:_.taskType};return Object.assign(B,_),B}j.create=z})(L||(e.KeyedTaskIdentifier=L={}));var N;(function(j){j.AutoDetect="task.autoDetect",j.SaveBeforeRun="task.saveBeforeRun",j.ShowDecorations="task.showDecorations",j.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",j.SlowProviderWarning="task.slowProviderWarning",j.QuickOpenHistory="task.quickOpen.history",j.QuickOpenDetail="task.quickOpen.detail",j.QuickOpenSkip="task.quickOpen.skip",j.QuickOpenShowAll="task.quickOpen.showAll",j.AllowAutomaticTasks="task.allowAutomaticTasks",j.Reconnection="task.reconnection",j.VerboseLogging="task.verboseLogging"})(N||(e.TaskSettingId=N={}));var F;(function(j){j.Tasks="tasks",j.SuppressTaskName="tasks.suppressTaskName",j.Windows="tasks.windows",j.Osx="tasks.osx",j.Linux="tasks.linux",j.ShowOutput="tasks.showOutput",j.IsShellCommand="tasks.isShellCommand",j.ServiceTestSetting="tasks.service.testSetting"})(F||(e.TasksSchemaProperties=F={}));var V;(function(j){function U(z,_){const W=C.$aJ.get(z.type);if(W===void 0){const oe=A.$io(z);return delete oe._key,L.create(oe)}const B=Object.create(null);B.type=W.taskType;const Y=new Set;W.required.forEach(oe=>Y.add(oe));const x=W.properties;for(const oe of Object.keys(x)){const ie=z[oe];if(ie!=null)B[oe]=ie;else if(Y.has(oe)){const me=x[oe];if(me.default!==void 0)B[oe]=A.$io(me.default);else switch(me.type){case"boolean":B[oe]=!1;break;case"number":case"integer":B[oe]=0;break;case"string":B[oe]="";break;default:_.error(s.localize(9895,null,JSON.stringify(z,void 0,0),oe));return}}}return L.create(B)}j.createTaskIdentifier=U})(V||(e.TaskDefinition=V={}))}),define(Re[275],Ce([1,0,12]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tec=e.$Sec=void 0;class h{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((O,C)=>{this.b=O,this.d=C,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(O){this.f||this.h||(this.f=!0,this.g=O,this.a&&this.b(O))}resolveErr(O){this.f||this.h||(this.h=!0,this.i=O,this.a?this.d(O):(0,s.$2)(O))}then(O,C){return this.j().then(O,C)}catch(O){return this.j().then(void 0,O)}finally(O){return this.j().finally(O)}}e.$Sec=h;class R extends h{constructor(){super(),this.h=!0,this.i=new s.$7}}e.$Tec=R}),define(Re[53],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5w=e.$2w=void 0,e.$3w=R,e.$4w=A;class s{static{this.count=0}constructor(m){this._proxyIdentifierBrand=void 0,this.sid=m,this.nid=++s.count}}e.$2w=s;const h=[];function R(C){const m=new s(C);return h[m.nid]=m,m}function A(C){return h[C].sid}class O{constructor(m){this.value=m}}e.$5w=O}),define(Re[6],Ce([1,0,53]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4N=e.$3N=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$2N=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var h;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(h||(e.TextEditorRevealType=h={}));var R;(function(a){a[a.UnknownInput=0]="UnknownInput",a[a.TextInput=1]="TextInput",a[a.TextDiffInput=2]="TextDiffInput",a[a.TextMergeInput=3]="TextMergeInput",a[a.NotebookInput=4]="NotebookInput",a[a.NotebookDiffInput=5]="NotebookDiffInput",a[a.CustomEditorInput=6]="CustomEditorInput",a[a.WebviewEditorInput=7]="WebviewEditorInput",a[a.TerminalEditorInput=8]="TerminalEditorInput",a[a.InteractiveEditorInput=9]="InteractiveEditorInput",a[a.ChatEditorInput=10]="ChatEditorInput",a[a.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(R||(e.TabInputKind=R={}));var A;(function(a){a[a.TAB_OPEN=0]="TAB_OPEN",a[a.TAB_CLOSE=1]="TAB_CLOSE",a[a.TAB_UPDATE=2]="TAB_UPDATE",a[a.TAB_MOVE=3]="TAB_MOVE"})(A||(e.TabModelOperationKind=A={}));var O;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(O||(e.WebviewEditorCapabilities=O={}));var C;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(C||(e.WebviewMessageArrayBufferViewType=C={}));var m;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(m||(e.CellOutputKind=m={}));var c;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(c||(e.NotebookEditorRevealType=c={}));var I;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output",a[a.Hybrid=3]="Hybrid"})(I||(e.CandidatePortSource=I={}));class E{static{this.a=0}static mixin($){return $._id=E.a++,$}}e.$2N=E;var g;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.kindModifier="m",a.commandIdent="n",a.commandId="o",a.commandArguments="p"})(g||(e.ISuggestDataDtoField=g={}));var P;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(P||(e.ISuggestResultDtoField=P={}));var b;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(b||(e.ExtHostTestingResource=b={})),e.$3N={MainThreadAuthentication:(0,s.$3w)("MainThreadAuthentication"),MainThreadBulkEdits:(0,s.$3w)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,s.$3w)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,s.$3w)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,s.$3w)("MainThreadChatAgents2"),MainThreadChatVariables:(0,s.$3w)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,s.$3w)("MainThreadChatSkills"),MainThreadClipboard:(0,s.$3w)("MainThreadClipboard"),MainThreadCommands:(0,s.$3w)("MainThreadCommands"),MainThreadComments:(0,s.$3w)("MainThreadComments"),MainThreadConfiguration:(0,s.$3w)("MainThreadConfiguration"),MainThreadConsole:(0,s.$3w)("MainThreadConsole"),MainThreadDebugService:(0,s.$3w)("MainThreadDebugService"),MainThreadDecorations:(0,s.$3w)("MainThreadDecorations"),MainThreadDiagnostics:(0,s.$3w)("MainThreadDiagnostics"),MainThreadDialogs:(0,s.$3w)("MainThreadDiaglogs"),MainThreadDocuments:(0,s.$3w)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,s.$3w)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,s.$3w)("MainThreadTextEditors"),MainThreadEditorInsets:(0,s.$3w)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,s.$3w)("MainThreadEditorTabs"),MainThreadErrors:(0,s.$3w)("MainThreadErrors"),MainThreadTreeViews:(0,s.$3w)("MainThreadTreeViews"),MainThreadDownloadService:(0,s.$3w)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,s.$3w)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,s.$3w)("MainThreadLanguages"),MainThreadLogger:(0,s.$3w)("MainThreadLogger"),MainThreadMessageService:(0,s.$3w)("MainThreadMessageService"),MainThreadOutputService:(0,s.$3w)("MainThreadOutputService"),MainThreadProgress:(0,s.$3w)("MainThreadProgress"),MainThreadQuickDiff:(0,s.$3w)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,s.$3w)("MainThreadQuickOpen"),MainThreadStatusBar:(0,s.$3w)("MainThreadStatusBar"),MainThreadSecretState:(0,s.$3w)("MainThreadSecretState"),MainThreadStorage:(0,s.$3w)("MainThreadStorage"),MainThreadSpeech:(0,s.$3w)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,s.$3w)("MainThreadTelemetry"),MainThreadTerminalService:(0,s.$3w)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,s.$3w)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,s.$3w)("MainThreadWebviews"),MainThreadWebviewPanels:(0,s.$3w)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,s.$3w)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,s.$3w)("MainThreadCustomEditors"),MainThreadUrls:(0,s.$3w)("MainThreadUrls"),MainThreadUriOpeners:(0,s.$3w)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,s.$3w)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,s.$3w)("MainThreadWorkspace"),MainThreadFileSystem:(0,s.$3w)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,s.$3w)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,s.$3w)("MainThreadExtensionService"),MainThreadSCM:(0,s.$3w)("MainThreadSCM"),MainThreadSearch:(0,s.$3w)("MainThreadSearch"),MainThreadShare:(0,s.$3w)("MainThreadShare"),MainThreadTask:(0,s.$3w)("MainThreadTask"),MainThreadWindow:(0,s.$3w)("MainThreadWindow"),MainThreadLabelService:(0,s.$3w)("MainThreadLabelService"),MainThreadNotebook:(0,s.$3w)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,s.$3w)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,s.$3w)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,s.$3w)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,s.$3w)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,s.$3w)("MainThreadInteractive"),MainThreadTheming:(0,s.$3w)("MainThreadTheming"),MainThreadTunnelService:(0,s.$3w)("MainThreadTunnelService"),MainThreadManagedSockets:(0,s.$3w)("MainThreadManagedSockets"),MainThreadTimeline:(0,s.$3w)("MainThreadTimeline"),MainThreadTesting:(0,s.$3w)("MainThreadTesting"),MainThreadLocalization:(0,s.$3w)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,s.$3w)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,s.$3w)("MainThreadAiEmbeddingVector")},e.$4N={ExtHostCommands:(0,s.$3w)("ExtHostCommands"),ExtHostConfiguration:(0,s.$3w)("ExtHostConfiguration"),ExtHostDiagnostics:(0,s.$3w)("ExtHostDiagnostics"),ExtHostDebugService:(0,s.$3w)("ExtHostDebugService"),ExtHostDecorations:(0,s.$3w)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,s.$3w)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,s.$3w)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,s.$3w)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,s.$3w)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,s.$3w)("ExtHostEditors"),ExtHostTreeViews:(0,s.$3w)("ExtHostTreeViews"),ExtHostFileSystem:(0,s.$3w)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,s.$3w)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,s.$3w)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,s.$3w)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,s.$3w)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,s.$3w)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,s.$3w)("ExtHostQuickDiff"),ExtHostStatusBar:(0,s.$3w)("ExtHostStatusBar"),ExtHostShare:(0,s.$3w)("ExtHostShare"),ExtHostExtensionService:(0,s.$3w)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,s.$3w)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,s.$3w)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,s.$3w)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,s.$3w)("ExtHostSCM"),ExtHostSearch:(0,s.$3w)("ExtHostSearch"),ExtHostTask:(0,s.$3w)("ExtHostTask"),ExtHostWorkspace:(0,s.$3w)("ExtHostWorkspace"),ExtHostWindow:(0,s.$3w)("ExtHostWindow"),ExtHostWebviews:(0,s.$3w)("ExtHostWebviews"),ExtHostWebviewPanels:(0,s.$3w)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,s.$3w)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,s.$3w)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,s.$3w)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,s.$3w)("ExtHostEditorTabs"),ExtHostProgress:(0,s.$3w)("ExtHostProgress"),ExtHostComments:(0,s.$3w)("ExtHostComments"),ExtHostSecretState:(0,s.$3w)("ExtHostSecretState"),ExtHostStorage:(0,s.$3w)("ExtHostStorage"),ExtHostUrls:(0,s.$3w)("ExtHostUrls"),ExtHostUriOpeners:(0,s.$3w)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,s.$3w)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,s.$3w)("ExtHostOutputService"),ExtHostLabelService:(0,s.$3w)("ExtHostLabelService"),ExtHostNotebook:(0,s.$3w)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,s.$3w)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,s.$3w)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,s.$3w)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,s.$3w)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,s.$3w)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,s.$3w)("ExtHostInteractive"),ExtHostChatAgents2:(0,s.$3w)("ExtHostChatAgents"),ExtHostChatVariables:(0,s.$3w)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,s.$3w)("ExtHostChatSkills"),ExtHostChatProvider:(0,s.$3w)("ExtHostChatProvider"),ExtHostSpeech:(0,s.$3w)("ExtHostSpeech"),ExtHostEmbeddings:(0,s.$3w)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,s.$3w)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,s.$3w)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,s.$3w)("ExtHostTheming"),ExtHostTunnelService:(0,s.$3w)("ExtHostTunnelService"),ExtHostManagedSockets:(0,s.$3w)("ExtHostManagedSockets"),ExtHostAuthentication:(0,s.$3w)("ExtHostAuthentication"),ExtHostTimeline:(0,s.$3w)("ExtHostTimeline"),ExtHostTesting:(0,s.$3w)("ExtHostTesting"),ExtHostTelemetry:(0,s.$3w)("ExtHostTelemetry"),ExtHostLocalization:(0,s.$3w)("ExtHostLocalization")}}),define(Re[96],Ce([1,0,5,11,6,19]),function(ge,e,s,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bqc=e.$Aqc=e.$zqc=void 0,R=Ue(R),e.$zqc=(0,s.$Ii)("IExtHostApiDeprecationService");let O=class{constructor(m,c){this.c=c,this.a=new Set,this.b=m.getProxy(R.$3N.MainThreadTelemetry)}report(m,c,I){const E=this.d(m,c);this.a.has(E)||(this.a.add(E),c.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${m}' is deprecated. ${I}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:c.identifier.value,apiId:m}))}d(m,c){return`${m}-${c.identifier.value}`}};e.$Aqc=O,e.$Aqc=O=Ze([qe(0,A.$DQ),qe(1,h.$dk)],O),e.$Bqc=Object.freeze(new class{report(C,m,c){}})}),define(Re[276],Ce([1,0,6]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oqc=void 0;class h{constructor(A){const O=A.getProxy(s.$3N.MainThreadClipboard);this.value=Object.freeze({readText(){return O.$readText()},writeText(C){return O.$writeText(C)}})}}e.$Oqc=h}),define(Re[277],Ce([1,0,24,6,29,19]),function(ge,e,s,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Psc=void 0;let O=class{constructor(I,E){this.a=I.getProxy(h.$3N.MainThreadConsole),this.b=E.consoleForward.includeStack,this.c=E.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(I,E){const g=this,P=console[I];Object.defineProperty(console,I,{set:()=>{},get:()=>function(){g.e(I,E,P,arguments)}})}e(I,E,g,P){this.a.$logExtensionHostMessage({type:"__$console",severity:E,arguments:m(P,this.b)}),this.c&&this.f(I,g,P)}};e.$Psc=O,e.$Psc=O=Ze([qe(0,A.$DQ),qe(1,R.$TQ)],O);const C=1e5;function m(c,I){const E=[];if(c.length)for(let g=0;g<c.length;g++){let P=c[g];if(typeof P>"u")P="undefined";else if(P instanceof Error){const b=P;b.stack?P=b.stack:P=b.toString()}E.push(P)}if(I){const g=new Error().stack;g&&E.push({__$stack:g.split(`
`).slice(3).join(`
`)})}try{const g=(0,s.$no)(E);return g.length>C?"Output omitted for a large object that exceeds the limits":g}catch(g){return`Output omitted for an object that cannot be inspected ('${g.toString()}')`}}}),define(Re[278],Ce([1,0,2,6,25]),function(ge,e,s,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qrc=void 0;class A{constructor(C){this.a=C.getProxy(h.$3N.MainThreadDialogs)}showOpenDialog(C,m){return m?.allowUIResources&&(0,R.$wH)(C,"showLocal"),this.a.$showOpenDialog(m).then(c=>c?c.map(I=>s.URI.revive(I)):void 0)}showSaveDialog(C){return this.a.$showSaveDialog(C).then(m=>m?s.URI.revive(m):void 0)}}e.$Qrc=A}),define(Re[279],Ce([1,0,20,4,3,6]),function(ge,e,s,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Trc=void 0;class O{constructor(m){this.b=new Map,this.c=new h.$oe,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=m.getProxy(A.$3N.MainThreadEmbeddings)}registerEmbeddingsProvider(m,c,I){if(this.d.has(c))throw new Error("An embeddings provider for this model is already registered");const E=this.e++;return this.a.$registerEmbeddingProvider(E,c),this.b.set(E,{id:c,provider:I}),(0,R.$Vc)(()=>{this.d.delete(c),this.a.$unregisterEmbeddingProvider(E),this.b.delete(E)})}async computeEmbeddings(m,c,I){I??=s.CancellationToken.None;let E=!1;typeof c=="string"&&(c=[c],E=!0);const g=await this.a.$computeEmbeddings(m,c,I);if(g.length!==c.length)throw new Error;if(E){if(g.length!==1)throw new Error;return g[0]}return g}async $provideEmbeddings(m,c,I){const E=this.b.get(m);if(!E)return[];const g=await E.provider.provideEmbeddings(c,I);return g||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels(m){this.d=new Set(m),this.c.fire()}}e.$Trc=O}),define(Re[280],Ce([1,0,3,6]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dsc=void 0;class R{constructor(O){this.b=0,this.a=O.getProxy(h.$3N.MainThreadLabelService)}$registerResourceLabelFormatter(O){const C=this.b++;return this.a.$registerResourceLabelFormatter(C,O),(0,s.$Vc)(()=>{this.a.$unregisterResourceLabelFormatter(C)})}}e.$dsc=R}),define(Re[122],Ce([1,0,10,13,2,5,11,6,29,19]),function(ge,e,s,h,R,A,O,C,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$urc=e.$trc=void 0;let I=class{constructor(g,P,b){this.f=b,this.d=new Map,this.a=P.getProxy(C.$3N.MainThreadLocalization),this.b=g.environment.appLanguage,this.c=this.b===s.$h}getMessage(g,P){const{message:b,args:a,comment:$}=P;if(this.c)return(0,h.$hf)(b,a??{});let p=b;$&&$.length>0&&(p+=`/${Array.isArray($)?$.join(""):$}`);const u=this.d.get(g)?.contents[p];return u||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${p}`),(0,h.$hf)(u??b,a??{})}getBundle(g){return this.d.get(g)?.contents}getBundleUri(g){return this.d.get(g)?.uri}async initializeLocalizedMessages(g){if(this.c||!g.l10n&&!g.isBuiltin||this.d.has(g.identifier.value))return;let P;const b=await this.g(g);if(!b){this.f.error(`No bundle location found for extension ${g.identifier.value}`);return}try{const a=await this.a.$fetchBundleContents(b),$=JSON.parse(a);P=g.isBuiltin?$.contents?.bundle:$}catch(a){this.f.error(`Failed to load translations for ${g.identifier.value} from ${b}: ${a.message}`);return}P&&this.d.set(g.identifier.value,{contents:P,uri:b})}async g(g){if(g.isBuiltin){const P=await this.a.$fetchBuiltInBundleUri(g.identifier.value,this.b);return R.URI.revive(P)}return g.l10n?R.URI.joinPath(g.extensionLocation,g.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$trc=I,e.$trc=I=Ze([qe(0,m.$TQ),qe(1,c.$DQ),qe(2,O.$dk)],I),e.$urc=(0,A.$Ii)("IExtHostLocalizationService")}),define(Re[164],Ce([1,0,11,6,29,19,2,38]),function(ge,e,s,h,R,A,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Osc=void 0;let m=class extends s.$ok{constructor(E,g){super(g.logLevel,g.logsLocation,g.loggers.map(P=>(0,C.$fi)(P))),this.r=E.getProxy(h.$3N.MainThreadLogger)}$setLogLevel(E,g){g?this.setLogLevel(O.URI.revive(g),E):this.setLogLevel(E)}setVisibility(E,g){super.setVisibility(E,g),this.r.$setVisibility(E,g)}s(E,g,P){return new c(this.r,E,g,P)}};e.$Osc=m,e.$Osc=m=Ze([qe(0,A.$DQ),qe(1,R.$TQ)],m);class c extends s.$jk{constructor(E,g,P,b){super(b?.logLevel==="always"),this.r=E,this.s=g,this.m=!1,this.n=[],this.setLevel(P),this.r.$createLogger(g,b).then(()=>{this.u(this.n),this.m=!0})}g(E,g){const P=[[E,g]];this.m?this.u(P):this.n.push(...P)}u(E){this.r.$log(this.s,E)}flush(){this.r.$flush(this.s)}}}),define(Re[123],Ce([1,0,6,5,3,19,21]),function(ge,e,s,h,R,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wrc=e.$vrc=void 0,e.$vrc=(0,h.$Ii)("IExtHostManagedSockets");let C=class{constructor(E){this.b=0,this.c=null,this.d=new Map,this.a=E.getProxy(s.$3N.MainThreadManagedSockets)}setFactory(E,g){for(const P of this.d.values())P.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new m(E,g),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(E){if(!this.c||this.c.socketFactoryId!==E)throw new Error(`No socket factory with id ${E}`);const g=++this.b,P=await this.c.makeConnection(),b=new R.$Wc;return this.d.set(g,new c(g,P,b)),b.add((0,R.$Vc)(()=>this.d.delete(g))),b.add(P.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(g),b.dispose()})),b.add(P.onDidClose(a=>{this.a.$onDidManagedSocketClose(g,a?.stack??a?.message),b.dispose()})),b.add(P.onDidReceiveMessage(a=>this.a.$onDidManagedSocketHaveData(g,O.$Qe.wrap(a)))),g}$remoteSocketWrite(E,g){this.d.get(E)?.actual.send(g.buffer)}$remoteSocketEnd(E){const g=this.d.get(E);g&&(g.actual.end(),g.dispose())}async $remoteSocketDrain(E){await this.d.get(E)?.actual.drain?.()}};e.$wrc=C,e.$wrc=C=Ze([qe(0,A.$DQ)],C);class m{constructor(E,g){this.socketFactoryId=E,this.makeConnection=g}}class c extends R.$Xc{constructor(E,g,P){super(),this.socketId=E,this.actual=g,this.B(P)}}}),define(Re[281],Ce([1,0,6,11,25]),function(ge,e,s,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gsc=void 0;function A(C){return C&&C.title}let O=class{constructor(m,c){this.b=c,this.a=m.getProxy(s.$3N.MainThreadMessageService)}showMessage(m,c,I,E,g){const P={source:{identifier:m.identifier,label:m.displayName||m.name}};let b;typeof E=="string"||A(E)?b=[E,...g]:(P.modal=E?.modal,P.useCustom=E?.useCustom,P.detail=E?.detail,b=g),P.useCustom&&(0,R.$wH)(m,"resolvers");const a=[];let $=!1;for(let p=0;p<b.length;p++){const u=b[p];if(typeof u=="string")a.push({title:u,handle:p,isCloseAffordance:!1});else if(typeof u=="object"){const{title:i,isCloseAffordance:o}=u;a.push({title:i,isCloseAffordance:!!o,handle:p}),o&&($?this.b.warn(`[${m.identifier}] Only one message item can have 'isCloseAffordance':`,u):$=!0)}else this.b.warn(`[${m.identifier}] Invalid message item:`,u)}return this.a.$showMessage(c,I,P,a).then(p=>{if(typeof p=="number")return b[p]})}};e.$gsc=O,e.$gsc=O=Ze([qe(1,h.$dk)],O)}),define(Re[282],Ce([1,0,3,17,2,25,6]),function(ge,e,s,h,R,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$psc=void 0;class C{constructor(c){this.b=new Map,this.a=c.getProxy(O.$3N.MainThreadProfileContentHandlers)}registerProfileContentHandler(c,I,E){if((0,A.$wH)(c,"profileContentHandlers"),this.b.has(I))throw new Error(`Handler with id '${I}' already registered`);return this.b.set(I,E),this.a.$registerProfileContentHandler(I,E.name,E.description,c.identifier.value),(0,s.$Vc)(()=>{this.b.delete(I),this.a.$unregisterProfileContentHandler(I)})}async $saveProfile(c,I,E,g){const P=this.b.get(c);if(!P)throw new Error(`Unknown handler with id: ${c}`);return P.saveProfile(I,E,g)}async $readProfile(c,I,E){const g=this.b.get(c);if(!g)throw new Error(`Unknown handler with id: ${c}`);return g.readProfile((0,h.$hg)(I)?I:R.URI.revive(I),E)}}e.$psc=C}),define(Re[124],Ce([1,0,6,4,5]),function(ge,e,s,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rrc=e.$qrc=void 0;class A{constructor(C){this.b=new h.$oe,this.onDidChangePassword=this.b.event,this.a=C.getProxy(s.$3N.MainThreadSecretState)}async $onDidChangePassword(C){this.b.fire(C)}get(C,m){return this.a.$getPassword(C,m)}store(C,m,c){return this.a.$setPassword(C,m,c)}delete(C,m){return this.a.$deletePassword(C,m)}}e.$qrc=A,e.$rrc=(0,R.$Ii)("IExtHostSecretState")}),define(Re[283],Ce([1,0,20,3,6]),function(ge,e,s,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wsc=void 0;class A{static{this.a=1}constructor(C){this.c=new Map,this.d=new Map,this.f=new Map,this.b=C.getProxy(R.$3N.MainThreadSpeech)}async $createSpeechToTextSession(C,m,c){const I=this.c.get(C);if(!I)return;const E=new h.$Wc,g=new s.$ze;this.d.set(m,g);const P=await I.provideSpeechToTextSession(g.token,c?{language:c}:void 0);P&&(E.add(P.onDidChange(b=>{g.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(m,b)})),E.add(g.token.onCancellationRequested(()=>E.dispose())))}async $cancelSpeechToTextSession(C){this.d.get(C)?.dispose(!0),this.d.delete(C)}async $createTextToSpeechSession(C,m,c){const I=this.c.get(C);if(!I)return;const E=new h.$Wc,g=new s.$ze;this.d.set(m,g);const P=await I.provideTextToSpeechSession(g.token,c?{language:c}:void 0);P&&(this.f.set(m,P),E.add(P.onDidChange(b=>{g.token.isCancellationRequested||this.b.$emitTextToSpeechEvent(m,b)})),E.add(g.token.onCancellationRequested(()=>E.dispose())))}async $synthesizeSpeech(C,m){this.f.get(C)?.synthesize(m)}async $cancelTextToSpeechSession(C){this.d.get(C)?.dispose(!0),this.d.delete(C),this.f.delete(C)}async $createKeywordRecognitionSession(C,m){const c=this.c.get(C);if(!c)return;const I=new h.$Wc,E=new s.$ze;this.d.set(m,E);const g=await c.provideKeywordRecognitionSession(E.token);g&&(I.add(g.onDidChange(P=>{E.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(m,P)})),I.add(E.token.onCancellationRequested(()=>I.dispose())))}async $cancelKeywordRecognitionSession(C){this.d.get(C)?.dispose(!0),this.d.delete(C)}registerProvider(C,m,c){const I=A.a++;return this.c.set(I,c),this.b.$registerProvider(I,m,{extension:C,displayName:C.value}),(0,h.$Vc)(()=>{this.b.$unregisterProvider(I),this.c.delete(I)})}}e.$wsc=A}),define(Re[125],Ce([1,0,6,4,5]),function(ge,e,s,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hrc=e.$grc=void 0;class A{constructor(C,m){this.c=m,this.b=new h.$oe,this.onDidChangeStorage=this.b.event,this.a=C.getProxy(s.$3N.MainThreadStorage)}registerExtensionStorageKeysToSync(C,m){this.a.$registerExtensionStorageKeysToSync(C,m)}async initializeExtensionStorage(C,m,c){const I=await this.a.$initializeExtensionStorage(C,m);let E;return I&&(E=this.d(C,m,I)),E||c}setValue(C,m,c){return this.a.$setValue(C,m,c)}$acceptValue(C,m,c){const I=this.d(C,m,c);I&&this.b.fire({shared:C,key:m,value:I})}d(C,m,c){try{return JSON.parse(c)}catch(I){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${m}, global: ${C}): ${I}`)}}}e.$grc=A,e.$hrc=(0,R.$Ii)("IExtHostStorage")}),define(Re[284],Ce([1,0,3,14,2,6]),function(ge,e,s,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Isc=void 0;class O{static{this.a=new Set([h.Schemas.http,h.Schemas.https])}constructor(m){this.c=new Map,this.b=m.getProxy(A.$3N.MainThreadUriOpeners)}registerExternalUriOpener(m,c,I,E){if(this.c.has(c))throw new Error(`Opener with id '${c}' already registered`);const g=E.schemes.find(P=>!O.a.has(P));if(g)throw new Error(`Scheme '${g}' is not supported. Only http and https are currently supported.`);return this.c.set(c,I),this.b.$registerUriOpener(c,E.schemes,m,E.label),(0,s.$Vc)(()=>{this.c.delete(c),this.b.$unregisterUriOpener(c)})}async $canOpenUri(m,c,I){const E=this.c.get(m);if(!E)throw new Error(`Unknown opener with id: ${m}`);const g=R.URI.revive(c);return E.canOpenExternalUri(g,I)}async $openUri(m,c,I){const E=this.c.get(m);if(!E)throw new Error(`Unknown opener id: '${m}'`);return E.openExternalUri(R.URI.revive(c.resolvedUri),{sourceUri:R.URI.revive(c.sourceUri)},I)}}e.$Isc=O}),define(Re[285],Ce([1,0,6,2,3,12,23]),function(ge,e,s,h,R,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jsc=void 0;class C{static{this.a=0}constructor(c){this.c=new O.$wn,this.d=new Map,this.b=c.getProxy(s.$3N.MainThreadUrls)}registerUriHandler(c,I){const E=c.identifier;if(this.c.has(E))throw new Error(`Protocol handler already registered for extension ${E}`);const g=C.a++;return this.c.add(E),this.d.set(g,I),this.b.$registerUriHandler(g,E,c.displayName||c.name),(0,R.$Vc)(()=>{this.c.delete(E),this.d.delete(g),this.b.$unregisterUriHandler(g)})}$handleExternalUri(c,I){const E=this.d.get(c);if(!E)return Promise.resolve(void 0);try{E.handleUri(h.URI.revive(I))}catch(g){(0,A.$2)(g)}return Promise.resolve(void 0)}async createAppUri(c){return h.URI.revive(await this.b.$createAppUri(c))}}e.$Jsc=C}),define(Re[286],Ce([1,0,21,6]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qub=A,e.$rub=C,h=Ue(h);class R{constructor(){this.buffers=[]}add(c){let I=this.buffers.indexOf(c);return I<0&&(I=this.buffers.length,this.buffers.push(c)),I}}function A(m,c){if(c.serializeBuffersForPostMessage){const I=new R,g=JSON.stringify(m,(b,a)=>{if(a instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:I.add(a)};if(ArrayBuffer.isView(a)){const $=O(a);if($)return{$$vscode_array_buffer_reference$$:!0,index:I.add(a.buffer),view:{type:$,byteLength:a.byteLength,byteOffset:a.byteOffset}}}return a}),P=I.buffers.map(b=>{const a=new Uint8Array(b);return s.$Qe.wrap(a)});return{message:g,buffers:P}}else return{message:JSON.stringify(m),buffers:[]}}function O(m){switch(m.constructor.name){case"Int8Array":return h.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return h.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return h.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return h.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return h.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return h.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return h.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return h.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return h.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return h.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return h.WebviewMessageArrayBufferViewType.BigUint64Array}}function C(m,c){const I=c.map(P=>{const b=new ArrayBuffer(P.byteLength);return new Uint8Array(b).set(P.buffer),b}),E=c.length?(P,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const a=b,{index:$}=a,p=I[$];if(a.view)switch(a.view.type){case h.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(p,a.view.byteOffset,a.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(p,a.view.byteOffset,a.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(p,a.view.byteOffset,a.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(p,a.view.byteOffset,a.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(p,a.view.byteOffset,a.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(p,a.view.byteOffset,a.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(p,a.view.byteOffset,a.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(p,a.view.byteOffset,a.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(p,a.view.byteOffset,a.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(p,a.view.byteOffset,a.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(p,a.view.byteOffset,a.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return p}return b}:void 0;return{message:JSON.parse(m,E),arrayBuffers:I}}}),define(Re[97],Ce([1,0,4,3,14,24,2,237,286,121,6]),function(ge,e,s,h,R,A,O,C,m,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6qc=e.$4qc=void 0,e.$5qc=g,e.$7qc=a,e.$8qc=$,A=Ue(A),I=Ue(I);class E{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;constructor(o,t,n,r,d,l,f){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new s.$oe,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new s.$oe,this._onDidDispose=this.#h.event,this.#e=o,this.#t=t,this.#o=n,this.#n=r,this.#s=d,this.#r=l,this.#u=g(l),this.#d=P(l),this.#i=f}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(o){return this.#l=!0,(0,c.$_Db)(o,this.#n)}get cspSource(){const o=this.#r.extensionLocation;if(o.scheme===R.Schemas.https||o.scheme===R.Schemas.http){let t=o.toString();return t.endsWith("/")||(t+="/"),t+" "+c.$$Db}return c.$$Db}get html(){return this.a(),this.#a}set html(o){this.a(),this.#a!==o&&(this.#a=o,this.#d&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(o)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(o)))}get options(){return this.a(),this.#o}set options(o){this.a(),A.$mo(this.#o,o)||this.#t.$setOptions(this.#e,$(this.#r,this.#s,o)),this.#o=o}async postMessage(o){if(this.#c)return!1;const t=(0,m.$qub)(o,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,t.message,...t.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(o){if(!this.#d)return o;const t=this.#r.extensionLocation?.scheme===R.Schemas.vscodeRemote,n=this.#r.extensionLocation.scheme===R.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return o.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,d,l,f,y,k)=>{const S=O.URI.from({scheme:f||"file",path:decodeURIComponent(y)}),D=(0,c.$_Db)(S,{isRemote:t,authority:n}).toString();return`${d}${D}${k}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,d,l,f,y,k)=>{const S=O.URI.from({scheme:f||"file",path:decodeURIComponent(y)}),D=(0,c.$_Db)(S,{isRemote:t,authority:n}).toString();return`${d}${D}${k}`})}}e.$4qc=E;function g(i){try{const o=(0,C.$6p)((0,C.$5p)(i.engines.vscode));return!!o&&o.majorBase>=1&&o.minorBase>=57}catch{return!1}}function P(i){try{const o=(0,C.$6p)((0,C.$5p)(i.engines.vscode));return o?o.majorBase<1||o.majorBase===1&&o.minorBase<60:!1}catch{return!1}}class b extends h.$Xc{constructor(o,t,n,r,d){super(),this.c=t,this.f=n,this.g=r,this.h=d,this.b=new Map,this.a=o.getProxy(I.$3N.MainThreadWebviews)}dispose(){super.dispose();for(const o of this.b.values())o.dispose();this.b.clear()}$onMessage(o,t,n){const r=this.j(o);if(r){const{message:d}=(0,m.$rub)(t,n.value);r._onMessageEmitter.fire(d)}}$onMissingCsp(o,t){this.g.warn(`${t} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(o,t,n){const r=new E(o,this.a,p(t),this.c,this.f,n,this.h);this.b.set(o,r);const d=r._onDidDispose(()=>{d.dispose(),this.deleteWebview(o)});return r}deleteWebview(o){this.b.delete(o)}j(o){return this.b.get(o)}}e.$6qc=b;function a(i){return{id:i.identifier,location:i.extensionLocation}}function $(i,o,t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots||u(i,o)}}function p(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(o=>O.URI.from(o))}}function u(i,o){return[...(o?.getWorkspaceFolders()||[]).map(t=>t.uri),i.extensionLocation]}}),define(Re[165],Ce([1,0,4,14,13,2,5,19,6]),function(ge,e,s,h,R,A,O,C,m){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$Msc=e.$Lsc=void 0;let I=class{static{c=this}static{this.a={focused:!0,active:!0}}getState(){const g=this.d;return{get focused(){return g.focused},get active(){return g.active}}}constructor(g){this.c=new s.$oe,this.onDidChangeWindowState=this.c.event,this.d=c.a,this.b=g.getProxy(m.$3N.MainThreadWindow),this.b.$getInitialState().then(({isFocused:P,isActive:b})=>{this.onDidChangeWindowProperty("focused",P),this.onDidChangeWindowProperty("active",b)})}$onDidChangeWindowFocus(g){this.onDidChangeWindowProperty("focused",g)}$onDidChangeWindowActive(g){this.onDidChangeWindowProperty("active",g)}onDidChangeWindowProperty(g,P){P!==this.d[g]&&(this.d={...this.d,[g]:P},this.c.fire(this.d))}openUri(g,P){let b;if(typeof g=="string"){b=g;try{g=A.URI.parse(g)}catch{return Promise.reject(`Invalid uri - '${g}'`)}}return(0,R.$ff)(g.scheme)?Promise.reject("Invalid scheme - cannot be empty"):g.scheme===h.Schemas.command?Promise.reject(`Invalid scheme '${g.scheme}'`):this.b.$openUri(g,b,P)}async asExternalUri(g,P){if((0,R.$ff)(g.scheme))return Promise.reject("Invalid scheme - cannot be empty");const b=await this.b.$asExternalUri(g,P);return A.URI.from(b)}};e.$Lsc=I,e.$Lsc=I=c=Ze([qe(0,C.$DQ)],I),e.$Msc=(0,O.$Ii)("IExtHostWindow")}),define(Re[287],Ce([1,0,277,29,19,94]),function(ge,e,s,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ptc=void 0;const O=1024*1024;let C=class extends s.$Psc{constructor(c,I){super(c,I),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(c,I,E){const g=c==="error"||c==="warn"?process.stderr:process.stdout;this.g=!0,g.write(`
${A.NativeLogMarkers.Start}
`),I.apply(console,E),g.write(`
${A.NativeLogMarkers.End}
`),this.g=!1}j(c,I){const E=process[c],g=E.write;let P="";Object.defineProperty(E,"write",{set:()=>{},get:()=>(b,a,$)=>{if(!this.g){P+=b.toString(a);const p=P.length>O?P.length:P.lastIndexOf(`
`);p!==-1&&(console[I](P.slice(0,p)),P=P.slice(p+1))}g.call(E,b,a,$)}})}};e.$ptc=C,e.$ptc=C=Ze([qe(0,R.$DQ),qe(1,h.$TQ)],C)}),define(Re[288],Ce([1,0,164,14,231,32]),function(ge,e,s,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Btc=void 0;class O extends s.$Osc{s(m,c,I){return m.scheme===h.Schemas.file?new R.$SR(I?.name||(0,A.$5g)(),m.fsPath,!I?.donotRotate,!!I?.donotUseFormatters,c):super.s(m,c,I)}registerLogger(m){super.registerLogger(m),this.r.$registerLogger(m)}deregisterLogger(m){super.deregisterLogger(m),this.r.$deregisterLogger(m)}}e.$Btc=O}),define(Re[289],Ce([1,0,7,21,20,26,12,4,3,41,140,275,53]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Wec=e.ResponsiveState=e.RequestInitiator=void 0,e.$Uec=u,e.$Vec=i,O=Ue(O);function b(M,L){try{return JSON.stringify(M,L)}catch{return"null"}}const a="$$ref$$",$={[a]:-1};class p{constructor(L,N){this.jsonString=L,this.referencedBuffers=N}}function u(M,L=null,N=!1){const F=[];return{jsonString:(N?b:JSON.stringify)(M,(j,U)=>{if(typeof U>"u")return $;if(typeof U=="object"){if(U instanceof h.$Qe){const z=F.push(U)-1;return{[a]:z}}if(L)return L(j,U)}return U}),referencedBuffers:F}}function i(M,L,N){return JSON.parse(M,(F,V)=>{if(V){const j=V[a];if(typeof j=="number")return L[j];if(N&&V.$mid===c.MarshalledId.Uri)return N.transformIncoming(V)}return V})}function o(M,L){return JSON.stringify(M,L)}function t(M){return M?(L,N)=>N&&N.$mid===c.MarshalledId.Uri?M.transformOutgoing(N):N:null}var n;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(n||(e.RequestInitiator=n={}));var r;(function(M){M[M.Responsive=0]="Responsive",M[M.Unresponsive=1]="Unresponsive"})(r||(e.ResponsiveState=r={}));const d=()=>{},l=Symbol.for("rpcProtocol"),f=Symbol.for("rpcProxy");class y extends m.$Xc{static{P=l}static{this.a=3*1e3}constructor(L,N=null,F=null){super(),this[P]=!0,this.b=this.B(new C.$oe),this.onDidChangeResponsiveState=this.b.event,this.c=L,this.f=N,this.g=F,this.h=t(this.g),this.j=!1,this.m=[],this.s=[];for(let V=0,j=g.$2w.count;V<j;V++)this.m[V]=null,this.s[V]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=r.Responsive,this.z=0,this.C=0,this.D=this.B(new s.$Uh(()=>this.H(),1e3)),this.B(this.c.onMessage(V=>this.L(V)))}dispose(){this.j=!0,Object.keys(this.w).forEach(L=>{const N=this.w[L];delete this.w[L],N.resolveErr(O.$8())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(L){this.z===0&&(this.C=Date.now()+y.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(L){this.C=Date.now()+y.a,this.z--,this.z===0&&this.D.cancel(),this.I(r.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(r.Unresponsive):this.D.schedule())}I(L){this.y!==L&&(this.y=L,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(L){return this.g?(0,I.$Tn)(L,this.g):L}getProxy(L){const{nid:N,sid:F}=L;return this.s[N]||(this.s[N]=this.J(N,F)),this.s[N]}J(L,N){const F={get:(V,j)=>(typeof j=="string"&&!V[j]&&j.charCodeAt(0)===A.CharCode.DollarSign&&(V[j]=(...U)=>this.U(L,j,U)),j===f?N:V[j])};return new Proxy(Object.create(null),F)}set(L,N){return this.m[L.nid]=N,N}assertRegistered(L){for(let N=0,F=L.length;N<F;N++){const V=L[N];if(!this.m[V.nid])throw new Error(`Missing proxy instance ${V.sid}`)}}L(L){if(this.j)return;const N=L.byteLength,F=S.read(L,0),V=F.readUInt8(),j=F.readUInt32();switch(V){case v.RequestJSONArgs:case v.RequestJSONArgsWithCancellation:{let{rpcId:U,method:z,args:_}=T.deserializeRequestJSONArgs(F);this.g&&(_=(0,I.$Tn)(_,this.g)),this.M(N,j,U,z,_,V===v.RequestJSONArgsWithCancellation);break}case v.RequestMixedArgs:case v.RequestMixedArgsWithCancellation:{let{rpcId:U,method:z,args:_}=T.deserializeRequestMixedArgs(F);this.g&&(_=(0,I.$Tn)(_,this.g)),this.M(N,j,U,z,_,V===v.RequestMixedArgsWithCancellation);break}case v.Acknowledged:{this.f?.logIncoming(N,j,n.LocalSide,"ack"),this.G(j);break}case v.Cancel:{this.N(N,j);break}case v.ReplyOKEmpty:{this.O(N,j,void 0);break}case v.ReplyOKJSON:{let U=T.deserializeReplyOKJSON(F);this.g&&(U=(0,I.$Tn)(U,this.g)),this.O(N,j,U);break}case v.ReplyOKJSONWithBuffers:{const U=T.deserializeReplyOKJSONWithBuffers(F,this.g);this.O(N,j,U);break}case v.ReplyOKVSBuffer:{const U=T.deserializeReplyOKVSBuffer(F);this.O(N,j,U);break}case v.ReplyErrError:{let U=T.deserializeReplyErrError(F);this.g&&(U=(0,I.$Tn)(U,this.g)),this.P(N,j,U);break}case v.ReplyErrEmpty:{this.P(N,j,void 0);break}default:console.error("received unexpected message"),console.error(L)}}M(L,N,F,V,j,U){this.f?.logIncoming(L,N,n.OtherSide,`receiveRequest ${(0,g.$4w)(F)}.${V}(`,j);const z=String(N);let _,W;if(U){const Y=new R.$ze;j.push(Y.token),_=this.Q(F,V,j),W=()=>Y.cancel()}else _=this.Q(F,V,j),W=d;this.u[z]=W;const B=T.serializeAcknowledged(N);this.f?.logOutgoing(B.byteLength,N,n.OtherSide,"ack"),this.c.send(B),_.then(Y=>{delete this.u[z];const x=T.serializeReplyOK(N,Y,this.h);this.f?.logOutgoing(x.byteLength,N,n.OtherSide,"reply:",Y),this.c.send(x)},Y=>{delete this.u[z];const x=T.serializeReplyErr(N,Y);this.f?.logOutgoing(x.byteLength,N,n.OtherSide,"replyErr:",Y),this.c.send(x)})}N(L,N){this.f?.logIncoming(L,N,n.OtherSide,"receiveCancel");const F=String(N);this.u[F]?.()}O(L,N,F){this.f?.logIncoming(L,N,n.LocalSide,"receiveReply:",F);const V=String(N);if(!this.w.hasOwnProperty(V))return;const j=this.w[V];delete this.w[V],j.resolveOk(F)}P(L,N,F){this.f?.logIncoming(L,N,n.LocalSide,"receiveReplyErr:",F);const V=String(N);if(!this.w.hasOwnProperty(V))return;const j=this.w[V];delete this.w[V];let U;F&&(F.$isError?(U=new Error,U.name=F.name,U.message=F.message,U.stack=F.stack):U=F),j.resolveErr(U)}Q(L,N,F){try{return Promise.resolve(this.S(L,N,F))}catch(V){return Promise.reject(V)}}S(L,N,F){const V=this.m[L];if(!V)throw new Error("Unknown actor "+(0,g.$4w)(L));const j=V[N];if(typeof j!="function")throw new Error("Unknown method "+N+" on actor "+(0,g.$4w)(L));return j.apply(V,F)}U(L,N,F){if(this.j)return new E.$Tec;let V=null;if(F.length>0&&R.CancellationToken.isCancellationToken(F[F.length-1])&&(V=F.pop()),V&&V.isCancellationRequested)return Promise.reject(O.$8());const j=T.serializeRequestArguments(F,this.h),U=++this.t,z=String(U),_=new E.$Sec,W=new m.$Wc;V&&W.add(V.onCancellationRequested(()=>{const Y=T.serializeCancel(U);this.f?.logOutgoing(Y.byteLength,U,n.LocalSide,"cancel"),this.c.send(T.serializeCancel(U))})),this.w[z]=new k(_,W),this.F(U);const B=T.serializeRequest(U,L,N,j,!!V);return this.f?.logOutgoing(B.byteLength,U,n.LocalSide,`request: ${(0,g.$4w)(L)}.${N}(`,F),this.c.send(B),_}}e.$Wec=y;class k{constructor(L,N){this.a=L,this.b=N}resolveOk(L){this.a.resolveOk(L),this.b.dispose()}resolveErr(L){this.a.resolveErr(L),this.b.dispose()}}class S{static alloc(L,N,F){const V=new S(h.$Qe.alloc(F+1+4),0);return V.writeUInt8(L),V.writeUInt32(N),V}static read(L,N){return new S(L,N)}get buffer(){return this.a}constructor(L,N){this.a=L,this.b=N}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(L){this.a.writeUInt8(L,this.b),this.b+=1}readUInt8(){const L=this.a.readUInt8(this.b);return this.b+=1,L}writeUInt32(L){this.a.writeUInt32BE(L,this.b),this.b+=4}readUInt32(){const L=this.a.readUInt32BE(this.b);return this.b+=4,L}static sizeShortString(L){return 1+L.byteLength}writeShortString(L){this.a.writeUInt8(L.byteLength,this.b),this.b+=1,this.a.set(L,this.b),this.b+=L.byteLength}readShortString(){const L=this.a.readUInt8(this.b);this.b+=1;const F=this.a.slice(this.b,this.b+L).toString();return this.b+=L,F}static sizeLongString(L){return 4+L.byteLength}writeLongString(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readLongString(){const L=this.a.readUInt32BE(this.b);this.b+=4;const F=this.a.slice(this.b,this.b+L).toString();return this.b+=L,F}writeBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}static sizeVSBuffer(L){return 4+L.byteLength}writeVSBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readVSBuffer(){const L=this.a.readUInt32BE(this.b);this.b+=4;const N=this.a.slice(this.b,this.b+L);return this.b+=L,N}static sizeMixedArray(L){let N=0;N+=1;for(let F=0,V=L.length;F<V;F++){const j=L[F];switch(N+=1,j.type){case w.String:N+=this.sizeLongString(j.value);break;case w.VSBuffer:N+=this.sizeVSBuffer(j.value);break;case w.SerializedObjectWithBuffers:N+=this.sizeUInt32,N+=this.sizeLongString(j.value);for(let U=0;U<j.buffers.length;++U)N+=this.sizeVSBuffer(j.buffers[U]);break;case w.Undefined:break}}return N}writeMixedArray(L){this.a.writeUInt8(L.length,this.b),this.b+=1;for(let N=0,F=L.length;N<F;N++){const V=L[N];switch(V.type){case w.String:this.writeUInt8(w.String),this.writeLongString(V.value);break;case w.VSBuffer:this.writeUInt8(w.VSBuffer),this.writeVSBuffer(V.value);break;case w.SerializedObjectWithBuffers:this.writeUInt8(w.SerializedObjectWithBuffers),this.writeUInt32(V.buffers.length),this.writeLongString(V.value);for(let j=0;j<V.buffers.length;++j)this.writeBuffer(V.buffers[j]);break;case w.Undefined:this.writeUInt8(w.Undefined);break}}}readMixedArray(){const L=this.a.readUInt8(this.b);this.b+=1;const N=new Array(L);for(let F=0;F<L;F++)switch(this.readUInt8()){case w.String:N[F]=this.readLongString();break;case w.VSBuffer:N[F]=this.readVSBuffer();break;case w.SerializedObjectWithBuffers:{const j=this.readUInt32(),U=this.readLongString(),z=[];for(let _=0;_<j;++_)z.push(this.readVSBuffer());N[F]=new g.$5w(i(U,z,null));break}case w.Undefined:N[F]=void 0;break}return N}}var D;(function(M){M[M.Simple=0]="Simple",M[M.Mixed=1]="Mixed"})(D||(D={}));class T{static a(L){for(let N=0,F=L.length;N<F;N++)if(L[N]instanceof h.$Qe||L[N]instanceof g.$5w||typeof L[N]>"u")return!0;return!1}static serializeRequestArguments(L,N){if(this.a(L)){const F=[];for(let V=0,j=L.length;V<j;V++){const U=L[V];if(U instanceof h.$Qe)F[V]={type:w.VSBuffer,value:U};else if(typeof U>"u")F[V]={type:w.Undefined};else if(U instanceof g.$5w){const{jsonString:z,referencedBuffers:_}=u(U.value,N);F[V]={type:w.SerializedObjectWithBuffers,value:h.$Qe.fromString(z),buffers:_}}else F[V]={type:w.String,value:h.$Qe.fromString(o(U,N))}}return{type:D.Mixed,args:F}}return{type:D.Simple,args:o(L,N)}}static serializeRequest(L,N,F,V,j){switch(V.type){case D.Simple:return this.b(L,N,F,V.args,j);case D.Mixed:return this.c(L,N,F,V.args,j)}}static b(L,N,F,V,j){const U=h.$Qe.fromString(F),z=h.$Qe.fromString(V);let _=0;_+=S.sizeUInt8(),_+=S.sizeShortString(U),_+=S.sizeLongString(z);const W=S.alloc(j?v.RequestJSONArgsWithCancellation:v.RequestJSONArgs,L,_);return W.writeUInt8(N),W.writeShortString(U),W.writeLongString(z),W.buffer}static deserializeRequestJSONArgs(L){const N=L.readUInt8(),F=L.readShortString(),V=L.readLongString();return{rpcId:N,method:F,args:JSON.parse(V)}}static c(L,N,F,V,j){const U=h.$Qe.fromString(F);let z=0;z+=S.sizeUInt8(),z+=S.sizeShortString(U),z+=S.sizeMixedArray(V);const _=S.alloc(j?v.RequestMixedArgsWithCancellation:v.RequestMixedArgs,L,z);return _.writeUInt8(N),_.writeShortString(U),_.writeMixedArray(V),_.buffer}static deserializeRequestMixedArgs(L){const N=L.readUInt8(),F=L.readShortString(),V=L.readMixedArray(),j=new Array(V.length);for(let U=0,z=V.length;U<z;U++){const _=V[U];typeof _=="string"?j[U]=JSON.parse(_):j[U]=_}return{rpcId:N,method:F,args:j}}static serializeAcknowledged(L){return S.alloc(v.Acknowledged,L,0).buffer}static serializeCancel(L){return S.alloc(v.Cancel,L,0).buffer}static serializeReplyOK(L,N,F){if(typeof N>"u")return this.d(L);if(N instanceof h.$Qe)return this.e(L,N);if(N instanceof g.$5w){const{jsonString:V,referencedBuffers:j}=u(N.value,F,!0);return this.g(L,V,j)}else return this.f(L,b(N,F))}static d(L){return S.alloc(v.ReplyOKEmpty,L,0).buffer}static e(L,N){let F=0;F+=S.sizeVSBuffer(N);const V=S.alloc(v.ReplyOKVSBuffer,L,F);return V.writeVSBuffer(N),V.buffer}static deserializeReplyOKVSBuffer(L){return L.readVSBuffer()}static f(L,N){const F=h.$Qe.fromString(N);let V=0;V+=S.sizeLongString(F);const j=S.alloc(v.ReplyOKJSON,L,V);return j.writeLongString(F),j.buffer}static g(L,N,F){const V=h.$Qe.fromString(N);let j=0;j+=S.sizeUInt32,j+=S.sizeLongString(V);for(const z of F)j+=S.sizeVSBuffer(z);const U=S.alloc(v.ReplyOKJSONWithBuffers,L,j);U.writeUInt32(F.length),U.writeLongString(V);for(const z of F)U.writeBuffer(z);return U.buffer}static deserializeReplyOKJSON(L){const N=L.readLongString();return JSON.parse(N)}static deserializeReplyOKJSONWithBuffers(L,N){const F=L.readUInt32(),V=L.readLongString(),j=[];for(let U=0;U<F;++U)j.push(L.readVSBuffer());return new g.$5w(i(V,j,N))}static serializeReplyErr(L,N){const F=N?b(O.$4(N),null):void 0;if(typeof F!="string")return this.h(L);const V=h.$Qe.fromString(F);let j=0;j+=S.sizeLongString(V);const U=S.alloc(v.ReplyErrError,L,j);return U.writeLongString(V),U.buffer}static deserializeReplyErrError(L){const N=L.readLongString();return JSON.parse(N)}static h(L){return S.alloc(v.ReplyErrEmpty,L,0).buffer}}var v;(function(M){M[M.RequestJSONArgs=1]="RequestJSONArgs",M[M.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",M[M.RequestMixedArgs=3]="RequestMixedArgs",M[M.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",M[M.Acknowledged=5]="Acknowledged",M[M.Cancel=6]="Cancel",M[M.ReplyOKEmpty=7]="ReplyOKEmpty",M[M.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",M[M.ReplyOKJSON=9]="ReplyOKJSON",M[M.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",M[M.ReplyErrError=11]="ReplyErrError",M[M.ReplyErrEmpty=12]="ReplyErrEmpty"})(v||(v={}));var w;(function(M){M[M.String=1]="String",M[M.VSBuffer=2]="VSBuffer",M[M.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",M[M.Undefined=4]="Undefined"})(w||(w={}))}),define(Re[290],Ce([1,0,21,28,14,89,5]),function(ge,e,s,h,R,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ML=e.$JL=void 0,e.$KL=I,e.$LL=E,e.$JL=(0,O.$Ii)("notebookDocumentService");const C=["W","X","Y","Z","a","b","c","d","e","f"],m=new RegExp(`^[${C.join("")}]+`),c=7;function I(P){if(P.scheme!==R.Schemas.vscodeNotebookCell)return;const b=P.fragment.indexOf("s");if(b<0)return;const a=parseInt(P.fragment.substring(0,b).replace(m,""),c),$=(0,s.$0e)(P.fragment.substring(b+1)).toString();if(!isNaN(a))return{handle:a,notebook:P.with({scheme:$,fragment:null})}}function E(P,b){const a=b.toString(c),p=`${a.length<C.length?C[a.length-1]:"z"}${a}s${(0,s.$$e)(s.$Qe.fromString(P.scheme),!0,!0)}`;return P.with({scheme:R.Schemas.vscodeNotebookCell,fragment:p})}class g{constructor(){this.a=new h.$Dc}getNotebook(b){if(b.scheme===R.Schemas.vscodeNotebookCell){const a=I(b);if(a){const $=this.a.get(a.notebook);if($)return $}}return this.a.get(b)}addNotebookDocument(b){this.a.set(b.uri,b)}removeNotebookDocument(b){this.a.delete(b.uri)}}e.$ML=g,(0,A.$Xs)(e.$JL,g,A.InstantiationType.Delayed)}),define(Re[126],Ce([1,0,21,39,40,103,14,16,10,36,290]),function(ge,e,s,h,R,A,O,C,m,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8L=e.$5L=e.CellStatusbarAlignment=e.$4L=e.NotebookFindScopeType=e.NotebookEditorPriority=e.$1L=e.$ZL=e.$XL=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$WL=e.$VL=e.$UL=e.$TL=e.CellKind=e.$SL=e.$RL=e.$QL=e.$PL=e.$OL=e.$NL=void 0,e.$YL=r,e.$2L=f,e.$3L=y,e.$6L=D,e.$7L=v,h=Ue(h),e.$NL="workbench.editor.notebook",e.$OL="workbench.editor.notebookTextDiffEditor",e.$PL="workbench.editor.notebookMultiTextDiffEditor",e.$QL="workbench.editor.interactive",e.$RL="workbench.editor.repl",e.$SL="replNotebook.input.execute";var E;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(E||(e.CellKind=E={})),e.$TL=["application/json","application/javascript","text/html","image/svg+xml",A.$et.latex,A.$et.markdown,"image/png","image/jpeg",A.$et.text],e.$UL=[A.$et.latex,A.$et.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",A.$et.text],e.$VL=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$WL="_notAvailable";var g;(function(z){z[z.Running=1]="Running",z[z.Idle=2]="Idle"})(g||(e.NotebookRunState=g={}));var P;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(P||(e.NotebookCellExecutionState=P={}));var b;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(b||(e.NotebookExecutionState=b={}));var a;(function(z){z[z.WithHardKernelDependency=0]="WithHardKernelDependency",z[z.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",z[z.Pure=2]="Pure",z[z.Never=3]="Never"})(a||(e.NotebookRendererMatch=a={}));var $;(function(z){z.Always="always",z.Never="never",z.Optional="optional"})($||(e.RendererMessagingSpec=$={}));var p;(function(z){z[z.ModelChange=1]="ModelChange",z[z.Move=2]="Move",z[z.ChangeCellLanguage=5]="ChangeCellLanguage",z[z.Initialize=6]="Initialize",z[z.ChangeCellMetadata=7]="ChangeCellMetadata",z[z.Output=8]="Output",z[z.OutputItem=9]="OutputItem",z[z.ChangeCellContent=10]="ChangeCellContent",z[z.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",z[z.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",z[z.ChangeCellMime=13]="ChangeCellMime",z[z.Unknown=100]="Unknown"})(p||(e.NotebookCellsChangeType=p={}));var u;(function(z){z[z.Handle=0]="Handle",z[z.Index=1]="Index"})(u||(e.SelectionStateType=u={}));var i;(function(z){z[z.Replace=1]="Replace",z[z.Output=2]="Output",z[z.Metadata=3]="Metadata",z[z.CellLanguage=4]="CellLanguage",z[z.DocumentMetadata=5]="DocumentMetadata",z[z.Move=6]="Move",z[z.OutputItems=7]="OutputItems",z[z.PartialMetadata=8]="PartialMetadata",z[z.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var o;(function(z){z.scheme=O.Schemas.vscodeNotebookCell;function _(ie,me){return(0,I.$LL)(ie,me)}z.generate=_;function W(ie){return(0,I.$KL)(ie)}z.parse=W;function B(ie,me){return ie.with({scheme:O.Schemas.vscodeNotebookCellOutput,fragment:`op${me??""},${ie.scheme!==O.Schemas.file?ie.scheme:""}`})}z.generateCellOutputUri=B;function Y(ie){if(ie.scheme!==O.Schemas.vscodeNotebookCellOutput)return;const me=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ie.fragment);if(!me)return;const ue=me[1]&&me[1]!==""?me[1]:void 0,X=me[2];return{outputId:ue,notebook:ie.with({scheme:X||O.Schemas.file,fragment:null})}}z.parseCellOutputUri=Y;function x(ie,me,ue){return z.generate(ie,me).with({scheme:ue})}z.generateCellPropertyUri=x;function oe(ie,me){if(ie.scheme===me)return z.parse(ie.with({scheme:z.scheme}))}z.parseCellPropertyUri=oe})(o||(e.CellUri=o={}));const t=z=>m.$j?z.replace(/\//g,"\\"):z;class n{constructor(_=[],W=e.$TL){this.e=W,this.d=[...new Set(_)].map(B=>({pattern:B,matches:h.$Dk(t(B))}))}sort(_){const W=new Map(R.Iterable.map(_,Y=>[Y,t(Y)]));let B=[];for(const{matches:Y}of this.d)for(const[x,oe]of W)if(Y(oe)){B.push(x),W.delete(x);break}return W.size&&(B=B.concat([...W.keys()].sort((Y,x)=>this.e.indexOf(Y)-this.e.indexOf(x)))),B}prioritize(_,W){const B=this.f(_);if(B===-1){this.d.unshift({pattern:_,matches:h.$Dk(t(_))});return}const Y=new Set(W.map(oe=>this.f(oe,B)));Y.delete(-1);const x=Array.from(Y).sort();this.d.splice(B+1,0,...x.map(oe=>this.d[oe]));for(let oe=x.length-1;oe>=0;oe--)this.d.splice(x[oe],1)}toArray(){return this.d.map(_=>_.pattern)}f(_,W=this.d.length){const B=t(_);for(let Y=0;Y<W;Y++)if(this.d[Y].matches(B))return Y;return-1}}e.$XL=n;function r(z,_,W,B=(Y,x)=>Y===x){const Y=[];function x(me,ue,X){if(ue===0&&X.length===0)return;const q=Y[Y.length-1];q&&q.start+q.deleteCount===me?(q.deleteCount+=ue,q.toInsert.push(...X)):Y.push({start:me,deleteCount:ue,toInsert:X})}let oe=0,ie=0;for(;;){if(oe===z.length){x(oe,0,_.slice(ie));break}if(ie===_.length){x(oe,z.length-oe,[]);break}const me=z[oe],ue=_[ie];if(B(me,ue)){oe+=1,ie+=1;continue}W(ue)?(x(oe,1,[]),oe+=1):(x(oe,0,[ue]),ie+=1)}return Y}e.$ZL=new c.$Zj("notebookEditorCursorAtBoundary","none"),e.$1L=new c.$Zj("notebookEditorCursorAtLineBoundary","none");var d;(function(z){z.default="default",z.option="option"})(d||(e.NotebookEditorPriority=d={}));var l;(function(z){z.Cells="cells",z.Text="text",z.None="none"})(l||(e.NotebookFindScopeType=l={}));function f(z){const _=z;return!!((typeof _.include=="string"||h.$Ek(_.include))&&(typeof _.exclude=="string"||h.$Ek(_.exclude)))}function y(z,_,W){if(Array.isArray(z.viewType)&&z.viewType.indexOf(_)>=0||z.viewType===_)return!0;if(z.filenamePattern){const B=f(z.filenamePattern)?z.filenamePattern.include:z.filenamePattern,Y=f(z.filenamePattern)?z.filenamePattern.exclude:void 0;if(h.$Ck(B,(0,C.$qc)(W.fsPath).toLowerCase()))return!(Y&&h.$Ck(Y,(0,C.$qc)(W.fsPath).toLowerCase()))}return!1}e.$4L={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var k;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(k||(e.CellStatusbarAlignment=k={}));class S{static{this.d="notebook/"}static create(_){return`${S.d}${_}`}static parse(_){if(_.startsWith(S.d))return _.substring(S.d.length)}}e.$5L=S;function D(z){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(z)}const T=new TextDecoder;function v(z){const _=[];let W=!1;for(const oe of z)(_.length===0||W)&&(_.push(oe),W=!0);let B=L(_);const Y=s.$Qe.concat(_.map(oe=>s.$Qe.wrap(oe))),x=U(Y);return B=B||x.byteLength!==Y.byteLength,{data:x,didCompression:B}}e.$8L="\x1B[A";const w=e.$8L.split("").map(z=>z.charCodeAt(0)),M=10;function L(z){let _=!1;return z.forEach((W,B)=>{if(B===0||W.length<e.$8L.length)return;const Y=z[B-1],x=W.subarray(0,e.$8L.length);if(x[0]===w[0]&&x[1]===w[1]&&x[2]===w[2]){const oe=Y.lastIndexOf(M);if(oe===-1)return;_=!0,z[B-1]=Y.subarray(0,oe),z[B]=W.subarray(e.$8L.length)}}),_}function N(z){let _=z;do z=_,_=z.replace(/[^\n]\x08/gm,"");while(_.length<z.length);return z}function F(z){for(z=z.replace(/\r+\n/gm,`
`);z.search(/\r[^$]/g)>-1;){const _=z.match(/^(.*)\r+/m)[1];let W=z.match(/\r+(.*)$/m)[1];W=W+_.slice(W.length,_.length),z=z.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,W)}return z}const V=8,j=13;function U(z){return!z.buffer.includes(V)&&!z.buffer.includes(j)?z:s.$Qe.fromString(F(N(T.decode(z.buffer))))}}),define(Re[9],Ce([1,0,18,12,86,28,103,13,17,2,32,23,27,73,126]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P,b){"use strict";var a,$,p,u,i,o,t,n,r,d,l,f,y,k,S,D,T;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$sQ=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$rQ=e.$qQ=e.$pQ=e.$oQ=e.$nQ=e.$mQ=e.$lQ=e.$kQ=e.LanguageModelChatMessageRole=e.$jQ=e.$iQ=e.ChatResponseReferencePartStatusKind=e.ChatLocation=e.$hQ=e.$gQ=e.$fQ=e.$eQ=e.$dQ=e.$cQ=e.$bQ=e.$aQ=e.$_P=e.$$P=e.$0P=e.$9P=e.$8P=e.$7P=e.$6P=e.$5P=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$4P=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$3P=e.$2P=e.$1P=e.$ZP=e.$YP=e.$XP=e.$WP=e.$VP=e.$UP=e.$TP=e.$SP=e.$RP=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$QP=e.$PP=e.$OP=e.$NP=e.$LP=e.$KP=e.$JP=e.$IP=e.$HP=e.TestRunProfileKind=e.TestResultState=e.$GP=e.$FP=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$EP=e.NotebookVariablesRequestKind=e.$DP=e.$CP=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$BP=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$AP=e.$zP=e.$yP=e.$xP=e.$wP=e.ColorThemeKind=e.$vP=e.$uP=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$tP=e.QuickInputButtonLocation=e.$sP=e.DebugConsoleMode=e.$rP=e.$qP=e.$pP=e.$oP=e.$nP=e.CommentThreadFocus=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$mP=e.$lP=e.FileChangeType=e.$kP=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$jP=e.$iP=e.$hP=e.$gP=e.InlineCompletionTriggerKind=e.$fP=e.$eP=e.$dP=e.$cP=e.$bP=e.$aP=e.$_O=e.$$O=e.$0O=e.$9O=e.$8O=e.$6O=e.ConfigurationTarget=e.$5O=e.$4O=e.$3O=e.$2O=e.DocumentPasteTriggerKind=e.$1O=e.$ZO=e.$YO=e.$XO=e.$WO=e.$VO=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$UO=e.ViewBadge=e.ProgressLocation=e.$TO=e.$SO=e.TaskScope=e.ShellQuoting=e.$RO=e.$QO=e.$PO=e.TaskPanelKind=e.TaskRevealKind=e.$OO=e.TerminalLocation=e.$NO=e.$MO=e.$LO=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$KO=e.$JO=e.$IO=e.$HO=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$FO=e.$EO=e.$DO=e.$CO=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$BO=e.$AO=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$zO=e.$yO=e.$xO=e.$wO=e.$vO=e.LanguageStatusSeverity=e.$uO=e.$tO=e.$sO=e.$rO=e.$qO=e.$pO=e.CodeActionTriggerKind=e.$oO=e.$nO=e.SymbolTag=e.SymbolKind=e.$mO=e.$lO=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.DiagnosticSeverity=e.DiagnosticTag=e.$fO=e.$eO=e.FileEditType=e.$dO=e.$cO=e.$bO=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$aO=e.$_N=e.$$N=e.$8N=e.$7N=e.$6N=e.$5N=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$9N=j,e.$0N=U,e.$GO=ht,e.$7O=Ui,e.$MP=Rn;function v(K){return Object.assign(K,{apply:function(...fe){if(fe.length===0)return Reflect.construct(K,[]);{const Oe=fe.length===1?[]:fe[1];return Reflect.construct(K,Oe,fe[0].constructor)}},call:function(...fe){if(fe.length===0)return Reflect.construct(K,[]);{const[Oe,..._e]=fe;return Reflect.construct(K,_e,Oe.constructor)}}})}var w;(function(K){K[K.Top=0]="Top",K[K.Bottom=1]="Bottom"})(w||(e.TerminalOutputAnchor=w={}));var M;(function(K){K[K.TerminalCommand=0]="TerminalCommand",K[K.Opener=1]="Opener",K[K.Command=3]="Command"})(M||(e.TerminalQuickFixType=M={}));let L=a=class{static from(...Q){let fe=Q;return new a(function(){if(fe){for(const Oe of fe)Oe&&typeof Oe.dispose=="function"&&Oe.dispose();fe=void 0}})}#e;constructor(Q){this.#e=Q}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$5N=L,e.$5N=L=a=Ze([v],L);let N=$=class{static Min(...Q){if(Q.length===0)throw new TypeError;let fe=Q[0];for(let Oe=1;Oe<Q.length;Oe++){const _e=Q[Oe];_e.isBefore(fe)&&(fe=_e)}return fe}static Max(...Q){if(Q.length===0)throw new TypeError;let fe=Q[0];for(let Oe=1;Oe<Q.length;Oe++){const _e=Q[Oe];_e.isAfter(fe)&&(fe=_e)}return fe}static isPosition(Q){if(!Q)return!1;if(Q instanceof $)return!0;const{line:fe,character:Oe}=Q;return typeof fe=="number"&&typeof Oe=="number"}static of(Q){if(Q instanceof $)return Q;if(this.isPosition(Q))return new $(Q.line,Q.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(Q,fe){if(Q<0)throw(0,h.$9)("line must be non-negative");if(fe<0)throw(0,h.$9)("character must be non-negative");this.c=Q,this.e=fe}isBefore(Q){return this.c<Q.c?!0:Q.c<this.c?!1:this.e<Q.e}isBeforeOrEqual(Q){return this.c<Q.c?!0:Q.c<this.c?!1:this.e<=Q.e}isAfter(Q){return!this.isBeforeOrEqual(Q)}isAfterOrEqual(Q){return!this.isBefore(Q)}isEqual(Q){return this.c===Q.c&&this.e===Q.e}compareTo(Q){return this.c<Q.c?-1:this.c>Q.line?1:this.e<Q.e?-1:this.e>Q.e?1:0}translate(Q,fe=0){if(Q===null||fe===null)throw(0,h.$9)();let Oe;return typeof Q>"u"?Oe=0:typeof Q=="number"?Oe=Q:(Oe=typeof Q.lineDelta=="number"?Q.lineDelta:0,fe=typeof Q.characterDelta=="number"?Q.characterDelta:0),Oe===0&&fe===0?this:new $(this.line+Oe,this.character+fe)}with(Q,fe=this.character){if(Q===null||fe===null)throw(0,h.$9)();let Oe;return typeof Q>"u"?Oe=this.line:typeof Q=="number"?Oe=Q:(Oe=typeof Q.line=="number"?Q.line:this.line,fe=typeof Q.character=="number"?Q.character:this.character),Oe===this.line&&fe===this.character?this:new $(Oe,fe)}toJSON(){return{line:this.line,character:this.character}}[Symbol.for("debug.description")](){return`(${this.line}:${this.character})`}};e.$6N=N,e.$6N=N=$=Ze([v],N);let F=p=class{static isRange(Q){return Q instanceof p?!0:Q?N.isPosition(Q.start)&&N.isPosition(Q.end):!1}static of(Q){if(Q instanceof p)return Q;if(this.isRange(Q))return new p(Q.start,Q.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(Q,fe,Oe,_e){let ct,pt;if(typeof Q=="number"&&typeof fe=="number"&&typeof Oe=="number"&&typeof _e=="number"?(ct=new N(Q,fe),pt=new N(Oe,_e)):N.isPosition(Q)&&N.isPosition(fe)&&(ct=N.of(Q),pt=N.of(fe)),!ct||!pt)throw new Error("Invalid arguments");ct.isBefore(pt)?(this.c=ct,this.e=pt):(this.c=pt,this.e=ct)}contains(Q){return p.isRange(Q)?this.contains(Q.start)&&this.contains(Q.end):N.isPosition(Q)?!(N.of(Q).isBefore(this.c)||this.e.isBefore(Q)):!1}isEqual(Q){return this.c.isEqual(Q.c)&&this.e.isEqual(Q.e)}intersection(Q){const fe=N.Max(Q.start,this.c),Oe=N.Min(Q.end,this.e);if(!fe.isAfter(Oe))return new p(fe,Oe)}union(Q){if(this.contains(Q))return this;if(Q.contains(this))return Q;const fe=N.Min(Q.start,this.c),Oe=N.Max(Q.end,this.end);return new p(fe,Oe)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(Q,fe=this.end){if(Q===null||fe===null)throw(0,h.$9)();let Oe;return Q?N.isPosition(Q)?Oe=Q:(Oe=Q.start||this.start,fe=Q.end||this.end):Oe=this.start,Oe.isEqual(this.c)&&fe.isEqual(this.end)?this:new p(Oe,fe)}toJSON(){return[this.start,this.end]}[Symbol.for("debug.description")](){return j(this)}};e.$7N=F,e.$7N=F=p=Ze([v],F);let V=u=class extends F{static isSelection(Q){return Q instanceof u?!0:Q?F.isRange(Q)&&N.isPosition(Q.anchor)&&N.isPosition(Q.active)&&typeof Q.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(Q,fe,Oe,_e){let ct,pt;if(typeof Q=="number"&&typeof fe=="number"&&typeof Oe=="number"&&typeof _e=="number"?(ct=new N(Q,fe),pt=new N(Oe,_e)):N.isPosition(Q)&&N.isPosition(fe)&&(ct=N.of(Q),pt=N.of(fe)),!ct||!pt)throw new Error("Invalid arguments");super(ct,pt),this.f=ct,this.g=pt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}[Symbol.for("debug.description")](){return U(this)}};e.$8N=V,e.$8N=V=u=Ze([v],V);function j(K){return K.isEmpty?`[${K.start.line}:${K.start.character})`:`[${K.start.line}:${K.start.character} -> ${K.end.line}:${K.end.character})`}function U(K){let Q=j(K);return K.isEmpty||(K.active.isEqual(K.start)?Q=`|${Q}`:Q=`${Q}|`),Q}const z=K=>{if(typeof K!="string"||K.length===0||!/^[0-9A-Za-z_\-]+$/.test(K))throw(0,h.$9)("connectionToken")};class _{static isResolvedAuthority(Q){return Q&&typeof Q=="object"&&typeof Q.host=="string"&&typeof Q.port=="number"&&(Q.connectionToken===void 0||typeof Q.connectionToken=="string")}constructor(Q,fe,Oe){if(typeof Q!="string"||Q.length===0)throw(0,h.$9)("host");if(typeof fe!="number"||fe===0||Math.round(fe)!==fe)throw(0,h.$9)("port");typeof Oe<"u"&&z(Oe),this.host=Q,this.port=Math.round(fe),this.connectionToken=Oe}}e.$$N=_;class W{static isManagedResolvedAuthority(Q){return Q&&typeof Q=="object"&&typeof Q.makeConnection=="function"&&(Q.connectionToken===void 0||typeof Q.connectionToken=="string")}constructor(Q,fe){this.makeConnection=Q,this.connectionToken=fe,typeof fe<"u"&&z(fe)}}e.$_N=W;class B extends Error{static NotAvailable(Q,fe){return new B(Q,P.RemoteAuthorityResolverErrorCode.NotAvailable,fe)}static TemporarilyNotAvailable(Q){return new B(Q,P.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(Q,fe=P.RemoteAuthorityResolverErrorCode.Unknown,Oe){super(Q),this._message=Q,this._code=fe,this._detail=Oe,Object.setPrototypeOf(this,B.prototype)}}e.$aO=B;var Y;(function(K){K[K.LF=1]="LF",K[K.CRLF=2]="CRLF"})(Y||(e.EndOfLine=Y={}));var x;(function(K){K[K.Replace=1]="Replace",K[K.Append=2]="Append",K[K.Prepend=3]="Prepend"})(x||(e.EnvironmentVariableMutatorType=x={}));let oe=i=class{static isTextEdit(Q){return Q instanceof i?!0:Q?F.isRange(Q)&&typeof Q.newText=="string":!1}static replace(Q,fe){return new i(Q,fe)}static insert(Q,fe){return i.replace(new F(Q,Q),fe)}static delete(Q){return i.replace(Q,"")}static setEndOfLine(Q){const fe=new i(new F(new N(0,0),new N(0,0)),"");return fe.newEol=Q,fe}get range(){return this.c}set range(Q){if(Q&&!F.isRange(Q))throw(0,h.$9)("range");this.c=Q}get newText(){return this.e||""}set newText(Q){if(Q&&typeof Q!="string")throw(0,h.$9)("newText");this.e=Q}get newEol(){return this.f}set newEol(Q){if(Q&&typeof Q!="number")throw(0,h.$9)("newEol");this.f=Q}constructor(Q,fe){this.c=Q,this.e=fe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$bO=oe,e.$bO=oe=i=Ze([v],oe);let ie=o=class{static isNotebookCellEdit(Q){return Q instanceof o?!0:Q?ki.isNotebookRange(Q)&&Array.isArray(Q.newCells):!1}static replaceCells(Q,fe){return new o(Q,fe)}static insertCells(Q,fe){return new o(new ki(Q,Q),fe)}static deleteCells(Q){return new o(Q,[])}static updateCellMetadata(Q,fe){const Oe=new o(new ki(Q,Q),[]);return Oe.newCellMetadata=fe,Oe}static updateNotebookMetadata(Q){const fe=new o(new ki(0,0),[]);return fe.newNotebookMetadata=Q,fe}constructor(Q,fe){this.range=Q,this.newCells=fe}};e.$cO=ie,e.$cO=ie=o=Ze([v],ie);class me{static isSnippetTextEdit(Q){return Q instanceof me?!0:Q?F.isRange(Q.range)&&q.isSnippetString(Q.snippet):!1}static replace(Q,fe){return new me(Q,fe)}static insert(Q,fe){return me.replace(new F(Q,Q),fe)}constructor(Q,fe){this.range=Q,this.snippet=fe}}e.$dO=me;var ue;(function(K){K[K.File=1]="File",K[K.Text=2]="Text",K[K.Cell=3]="Cell",K[K.CellReplace=5]="CellReplace",K[K.Snippet=6]="Snippet"})(ue||(e.FileEditType=ue={}));let X=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(Q,fe,Oe,_e){this.c.push({_type:ue.File,from:Q,to:fe,options:Oe,metadata:_e})}createFile(Q,fe,Oe){this.c.push({_type:ue.File,from:void 0,to:Q,options:fe,metadata:Oe})}deleteFile(Q,fe,Oe){this.c.push({_type:ue.File,from:Q,to:void 0,options:fe,metadata:Oe})}e(Q,fe,Oe){this.c.push({_type:ue.Cell,metadata:Oe,uri:Q,edit:{editType:b.CellEditType.DocumentMetadata,metadata:fe},notebookMetadata:fe})}f(Q,fe,Oe,_e){const ct=fe.start,pt=fe.end;(ct!==pt||Oe.length>0)&&this.c.push({_type:ue.CellReplace,uri:Q,index:ct,count:pt-ct,cells:Oe,metadata:_e})}g(Q,fe,Oe,_e){this.c.push({_type:ue.Cell,metadata:_e,uri:Q,edit:{editType:b.CellEditType.Metadata,index:fe,metadata:Oe}})}replace(Q,fe,Oe,_e){this.c.push({_type:ue.Text,uri:Q,edit:new oe(fe,Oe),metadata:_e})}insert(Q,fe,Oe,_e){this.replace(Q,new F(fe,fe),Oe,_e)}delete(Q,fe,Oe){this.replace(Q,fe,"",Oe)}has(Q){return this.c.some(fe=>fe._type===ue.Text&&fe.uri.toString()===Q.toString())}set(Q,fe){if(fe)for(const Oe of fe){if(!Oe)continue;let _e,ct;Array.isArray(Oe)?(_e=Oe[0],ct=Oe[1]):_e=Oe,ie.isNotebookCellEdit(_e)?_e.newCellMetadata?this.g(Q,_e.range.start,_e.newCellMetadata,ct):_e.newNotebookMetadata?this.e(Q,_e.newNotebookMetadata,ct):this.f(Q,_e.range,_e.newCells,ct):me.isSnippetTextEdit(_e)?this.c.push({_type:ue.Snippet,uri:Q,range:_e.range,edit:_e.snippet,metadata:ct}):this.c.push({_type:ue.Text,uri:Q,edit:_e,metadata:ct})}else{for(let Oe=0;Oe<this.c.length;Oe++){const _e=this.c[Oe];switch(_e._type){case ue.Text:case ue.Snippet:case ue.Cell:case ue.CellReplace:_e.uri.toString()===Q.toString()&&(this.c[Oe]=void 0);break}}(0,s.$Kb)(this.c)}}get(Q){const fe=[];for(const Oe of this.c)Oe._type===ue.Text&&Oe.uri.toString()===Q.toString()&&fe.push(Oe.edit);return fe}entries(){const Q=new A.$Dc;for(const fe of this.c)if(fe._type===ue.Text){let Oe=Q.get(fe.uri);Oe||(Oe=[fe.uri,[]],Q.set(fe.uri,Oe)),Oe[1].push(fe.edit)}return[...Q.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$eO=X,e.$eO=X=Ze([v],X);let q=t=class{static isSnippetString(Q){return Q instanceof t?!0:Q?typeof Q.value=="string":!1}static c(Q){return Q.replace(/\$|}|\\/g,"\\$&")}constructor(Q){this.e=1,this.value=Q||""}appendText(Q){return this.value+=t.c(Q),this}appendTabstop(Q=this.e++){return this.value+="$",this.value+=Q,this}appendPlaceholder(Q,fe=this.e++){if(typeof Q=="function"){const Oe=new t;Oe.e=this.e,Q(Oe),this.e=Oe.e,Q=Oe.value}else Q=t.c(Q);return this.value+="${",this.value+=fe,this.value+=":",this.value+=Q,this.value+="}",this}appendChoice(Q,fe=this.e++){const Oe=Q.map(_e=>_e.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=fe,this.value+="|",this.value+=Oe,this.value+="|}",this}appendVariable(Q,fe){if(typeof fe=="function"){const Oe=new t;Oe.e=this.e,fe(Oe),this.e=Oe.e,fe=Oe.value}else typeof fe=="string"&&(fe=fe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=Q,fe&&(this.value+=":",this.value+=fe),this.value+="}",this}};e.$fO=q,e.$fO=q=t=Ze([v],q);var se;(function(K){K[K.Unnecessary=1]="Unnecessary",K[K.Deprecated=2]="Deprecated"})(se||(e.DiagnosticTag=se={}));var be;(function(K){K[K.Hint=3]="Hint",K[K.Information=2]="Information",K[K.Warning=1]="Warning",K[K.Error=0]="Error"})(be||(e.DiagnosticSeverity=be={}));let ae=n=class{static isLocation(Q){return Q instanceof n?!0:Q?F.isRange(Q.range)&&c.URI.isUri(Q.uri):!1}constructor(Q,fe){if(this.uri=Q,fe)if(F.isRange(fe))this.range=F.of(fe);else if(N.isPosition(fe))this.range=new F(fe,fe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$gO=ae,e.$gO=ae=n=Ze([v],ae);let we=class{static is(Q){return Q?typeof Q.message=="string"&&Q.location&&F.isRange(Q.location.range)&&c.URI.isUri(Q.location.uri):!1}constructor(Q,fe){this.location=Q,this.message=fe}static isEqual(Q,fe){return Q===fe?!0:!Q||!fe?!1:Q.message===fe.message&&Q.location.range.isEqual(fe.location.range)&&Q.location.uri.toString()===fe.location.uri.toString()}};e.$hO=we,e.$hO=we=Ze([v],we);let $e=class{constructor(Q,fe,Oe=be.Error){if(!F.isRange(Q))throw new TypeError("range must be set");if(!fe)throw new TypeError("message must be set");this.range=Q,this.message=fe,this.severity=Oe}toJSON(){return{severity:be[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(Q,fe){return Q===fe?!0:!Q||!fe?!1:Q.message===fe.message&&Q.severity===fe.severity&&Q.code===fe.code&&Q.severity===fe.severity&&Q.source===fe.source&&Q.range.isEqual(fe.range)&&(0,s.$wb)(Q.tags,fe.tags)&&(0,s.$wb)(Q.relatedInformation,fe.relatedInformation,we.isEqual)}};e.$iO=$e,e.$iO=$e=Ze([v],$e);let pe=class{constructor(Q,fe){if(!Q)throw new Error("Illegal argument, contents must be defined");Array.isArray(Q)?this.contents=Q:this.contents=[Q],this.range=fe}};e.$jO=pe,e.$jO=pe=Ze([v],pe);let Ae=class extends pe{constructor(Q,fe,Oe,_e){super(Q,fe),this.canIncreaseVerbosity=Oe,this.canDecreaseVerbosity=_e}};e.$kO=Ae,e.$kO=Ae=Ze([v],Ae);var je;(function(K){K[K.Increase=0]="Increase",K[K.Decrease=1]="Decrease"})(je||(e.HoverVerbosityAction=je={}));var He;(function(K){K[K.Text=0]="Text",K[K.Read=1]="Read",K[K.Write=2]="Write"})(He||(e.DocumentHighlightKind=He={}));let Ye=class{constructor(Q,fe=He.Text){this.range=Q,this.kind=fe}toJSON(){return{range:this.range,kind:He[this.kind]}}};e.$lO=Ye,e.$lO=Ye=Ze([v],Ye);let xe=class{constructor(Q,fe){this.uri=Q,this.highlights=fe}toJSON(){return{uri:this.uri,highlights:this.highlights.map(Q=>Q.toJSON())}}};e.$mO=xe,e.$mO=xe=Ze([v],xe);var Fe;(function(K){K[K.File=0]="File",K[K.Module=1]="Module",K[K.Namespace=2]="Namespace",K[K.Package=3]="Package",K[K.Class=4]="Class",K[K.Method=5]="Method",K[K.Property=6]="Property",K[K.Field=7]="Field",K[K.Constructor=8]="Constructor",K[K.Enum=9]="Enum",K[K.Interface=10]="Interface",K[K.Function=11]="Function",K[K.Variable=12]="Variable",K[K.Constant=13]="Constant",K[K.String=14]="String",K[K.Number=15]="Number",K[K.Boolean=16]="Boolean",K[K.Array=17]="Array",K[K.Object=18]="Object",K[K.Key=19]="Key",K[K.Null=20]="Null",K[K.EnumMember=21]="EnumMember",K[K.Struct=22]="Struct",K[K.Event=23]="Event",K[K.Operator=24]="Operator",K[K.TypeParameter=25]="TypeParameter"})(Fe||(e.SymbolKind=Fe={}));var We;(function(K){K[K.Deprecated=1]="Deprecated"})(We||(e.SymbolTag=We={}));let Ne=r=class{static validate(Q){if(!Q.name)throw new Error("name must not be falsy")}constructor(Q,fe,Oe,_e,ct){this.name=Q,this.kind=fe,this.containerName=ct,typeof Oe=="string"&&(this.containerName=Oe),_e instanceof ae?this.location=_e:Oe instanceof F&&(this.location=new ae(_e,Oe)),r.validate(this)}toJSON(){return{name:this.name,kind:Fe[this.kind],location:this.location,containerName:this.containerName}}};e.$nO=Ne,e.$nO=Ne=r=Ze([v],Ne);let H=d=class{static validate(Q){if(!Q.name)throw new Error("name must not be falsy");if(!Q.range.contains(Q.selectionRange))throw new Error("selectionRange must be contained in fullRange");Q.children?.forEach(d.validate)}constructor(Q,fe,Oe,_e,ct){this.name=Q,this.detail=fe,this.kind=Oe,this.range=_e,this.selectionRange=ct,this.children=[],d.validate(this)}};e.$oO=H,e.$oO=H=d=Ze([v],H);var G;(function(K){K[K.Invoke=1]="Invoke",K[K.Automatic=2]="Automatic"})(G||(e.CodeActionTriggerKind=G={}));let Z=class{constructor(Q,fe){this.title=Q,this.kind=fe}};e.$pO=Z,e.$pO=Z=Ze([v],Z);let ee=class{static{l=this}static{this.c="."}constructor(Q){this.value=Q}append(Q){return new l(this.value?this.value+l.c+Q:Q)}intersects(Q){return this.contains(Q)||Q.contains(this)}contains(Q){return this.value===Q.value||Q.value.startsWith(this.value+l.c)}};e.$qO=ee,e.$qO=ee=l=Ze([v],ee),ee.Empty=new ee(""),ee.QuickFix=ee.Empty.append("quickfix"),ee.Refactor=ee.Empty.append("refactor"),ee.RefactorExtract=ee.Refactor.append("extract"),ee.RefactorInline=ee.Refactor.append("inline"),ee.RefactorMove=ee.Refactor.append("move"),ee.RefactorRewrite=ee.Refactor.append("rewrite"),ee.Source=ee.Empty.append("source"),ee.SourceOrganizeImports=ee.Source.append("organizeImports"),ee.SourceFixAll=ee.Source.append("fixAll"),ee.Notebook=ee.Empty.append("notebook");let le=class{constructor(Q,fe){if(this.range=Q,this.parent=fe,fe&&!fe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$rO=le,e.$rO=le=Ze([v],le);class ye{constructor(Q,fe,Oe,_e,ct,pt){this.kind=Q,this.name=fe,this.detail=Oe,this.uri=_e,this.range=ct,this.selectionRange=pt}}e.$sO=ye;class Te{constructor(Q,fe){this.fromRanges=fe,this.from=Q}}e.$tO=Te;class Ve{constructor(Q,fe){this.fromRanges=fe,this.to=Q}}e.$uO=Ve;var Ke;(function(K){K[K.Information=0]="Information",K[K.Warning=1]="Warning",K[K.Error=2]="Error"})(Ke||(e.LanguageStatusSeverity=Ke={}));let rt=class{constructor(Q,fe){this.range=Q,this.command=fe}get isResolved(){return!!this.command}};e.$vO=rt,e.$vO=rt=Ze([v],rt);let ot=f=class{#e;static isMarkdownString(Q){return Q instanceof f?!0:Q&&Q.appendCodeblock&&Q.appendMarkdown&&Q.appendText&&Q.value!==void 0}constructor(Q,fe=!1){this.#e=new R.$7k(Q,{supportThemeIcons:fe})}get value(){return this.#e.value}set value(Q){this.#e.value=Q}get isTrusted(){return this.#e.isTrusted}set isTrusted(Q){this.#e.isTrusted=Q}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(Q){this.#e.supportThemeIcons=Q}get supportHtml(){return this.#e.supportHtml}set supportHtml(Q){this.#e.supportHtml=Q}get baseUri(){return this.#e.baseUri}set baseUri(Q){this.#e.baseUri=Q}appendText(Q){return this.#e.appendText(Q),this}appendMarkdown(Q){return this.#e.appendMarkdown(Q),this}appendCodeblock(Q,fe){return this.#e.appendCodeblock(fe??"",Q),this}};e.$wO=ot,e.$wO=ot=f=Ze([v],ot);let ut=class{constructor(Q,fe){this.label=Q,this.documentation=fe}};e.$xO=ut,e.$xO=ut=Ze([v],ut);let at=class{constructor(Q,fe){this.label=Q,this.documentation=fe,this.parameters=[]}};e.$yO=at,e.$yO=at=Ze([v],at);let lt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$zO=lt,e.$zO=lt=Ze([v],lt);var $t;(function(K){K[K.Invoke=1]="Invoke",K[K.TriggerCharacter=2]="TriggerCharacter",K[K.ContentChange=3]="ContentChange"})($t||(e.SignatureHelpTriggerKind=$t={}));var it;(function(K){K[K.Type=1]="Type",K[K.Parameter=2]="Parameter"})(it||(e.InlayHintKind=it={}));let Ie=class{constructor(Q){this.value=Q}};e.$AO=Ie,e.$AO=Ie=Ze([v],Ie);let re=class{constructor(Q,fe,Oe){this.position=Q,this.label=fe,this.kind=Oe}};e.$BO=re,e.$BO=re=Ze([v],re);var ce;(function(K){K[K.Invoke=0]="Invoke",K[K.TriggerCharacter=1]="TriggerCharacter",K[K.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ce||(e.CompletionTriggerKind=ce={}));var Se;(function(K){K[K.Text=0]="Text",K[K.Method=1]="Method",K[K.Function=2]="Function",K[K.Constructor=3]="Constructor",K[K.Field=4]="Field",K[K.Variable=5]="Variable",K[K.Class=6]="Class",K[K.Interface=7]="Interface",K[K.Module=8]="Module",K[K.Property=9]="Property",K[K.Unit=10]="Unit",K[K.Value=11]="Value",K[K.Enum=12]="Enum",K[K.Keyword=13]="Keyword",K[K.Snippet=14]="Snippet",K[K.Color=15]="Color",K[K.File=16]="File",K[K.Reference=17]="Reference",K[K.Folder=18]="Folder",K[K.EnumMember=19]="EnumMember",K[K.Constant=20]="Constant",K[K.Struct=21]="Struct",K[K.Event=22]="Event",K[K.Operator=23]="Operator",K[K.TypeParameter=24]="TypeParameter",K[K.User=25]="User",K[K.Issue=26]="Issue"})(Se||(e.CompletionItemKind=Se={}));var de;(function(K){K[K.Deprecated=1]="Deprecated"})(de||(e.CompletionItemTag=de={}));let ke=class{constructor(Q,fe){this.label=Q,this.kind=fe}toJSON(){return{label:this.label,kind:this.kind&&Se[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$CO=ke,e.$CO=ke=Ze([v],ke);let ne=class{constructor(Q=[],fe=!1){this.items=Q,this.isIncomplete=fe}};e.$DO=ne,e.$DO=ne=Ze([v],ne);let J=class{constructor(Q,fe,Oe){this.insertText=Q,this.range=fe,this.command=Oe}};e.$EO=J,e.$EO=J=Ze([v],J);let Pe=class{constructor(Q){this.commands=void 0,this.suppressSuggestions=void 0,this.items=Q}};e.$FO=Pe,e.$FO=Pe=Ze([v],Pe);var Ge;(function(K){K[K.Unknown=0]="Unknown",K[K.Word=1]="Word",K[K.Line=2]="Line",K[K.Suggest=3]="Suggest"})(Ge||(e.PartialAcceptTriggerKind=Ge={}));var Je;(function(K){K[K.Active=-1]="Active",K[K.Beside=-2]="Beside",K[K.One=1]="One",K[K.Two=2]="Two",K[K.Three=3]="Three",K[K.Four=4]="Four",K[K.Five=5]="Five",K[K.Six=6]="Six",K[K.Seven=7]="Seven",K[K.Eight=8]="Eight",K[K.Nine=9]="Nine"})(Je||(e.ViewColumn=Je={}));var st;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(st||(e.StatusBarAlignment=st={}));function ht(K,Q){return`${E.$vn.toKey(K)}.${Q}`}var ft;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative",K[K.Interval=3]="Interval"})(ft||(e.TextEditorLineNumbersStyle=ft={}));var St;(function(K){K[K.Manual=1]="Manual",K[K.AfterDelay=2]="AfterDelay",K[K.FocusOut=3]="FocusOut"})(St||(e.TextDocumentSaveReason=St={}));var At;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(At||(e.TextEditorRevealType=At={}));var Qt;(function(K){K[K.Keyboard=1]="Keyboard",K[K.Mouse=2]="Mouse",K[K.Command=3]="Command"})(Qt||(e.TextEditorSelectionChangeKind=Qt={}));var ei;(function(K){K[K.Undo=1]="Undo",K[K.Redo=2]="Redo"})(ei||(e.TextDocumentChangeReason=ei={}));var tt;(function(K){K[K.OpenOpen=0]="OpenOpen",K[K.ClosedClosed=1]="ClosedClosed",K[K.OpenClosed=2]="OpenClosed",K[K.ClosedOpen=3]="ClosedOpen"})(tt||(e.DecorationRangeBehavior=tt={})),function(K){function Q(fe){switch(fe){case"keyboard":return K.Keyboard;case"mouse":return K.Mouse;case"api":return K.Command}}K.fromValue=Q}(Qt||(e.TextEditorSelectionChangeKind=Qt={}));var Ot;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(Ot||(e.SyntaxTokenType=Ot={})),function(K){function Q(fe){switch(fe){case K.Other:return"other";case K.Comment:return"comment";case K.String:return"string";case K.RegEx:return"regex"}return"other"}K.toString=Q}(Ot||(e.SyntaxTokenType=Ot={}));let zt=class{constructor(Q,fe){if(fe&&!c.URI.isUri(fe))throw(0,h.$9)("target");if(!F.isRange(Q)||Q.isEmpty)throw(0,h.$9)("range");this.range=Q,this.target=fe}};e.$HO=zt,e.$HO=zt=Ze([v],zt);let bt=class{constructor(Q,fe,Oe,_e){this.red=Q,this.green=fe,this.blue=Oe,this.alpha=_e}};e.$IO=bt,e.$IO=bt=Ze([v],bt);let Dt=class{constructor(Q,fe){if(fe&&!(fe instanceof bt))throw(0,h.$9)("color");if(!F.isRange(Q)||Q.isEmpty)throw(0,h.$9)("range");this.range=Q,this.color=fe}};e.$JO=Dt,e.$JO=Dt=Ze([v],Dt);let ti=class{constructor(Q){if(!Q||typeof Q!="string")throw(0,h.$9)("label");this.label=Q}};e.$KO=ti,e.$KO=ti=Ze([v],ti);var ii;(function(K){K[K.RGB=0]="RGB",K[K.HEX=1]="HEX",K[K.HSL=2]="HSL"})(ii||(e.ColorFormat=ii={}));var Gt;(function(K){K[K.Error=0]="Error",K[K.Warning=1]="Warning",K[K.Information=2]="Information"})(Gt||(e.SourceControlInputBoxValidationType=Gt={}));var wt;(function(K){K[K.Unknown=0]="Unknown",K[K.Shutdown=1]="Shutdown",K[K.Process=2]="Process",K[K.User=3]="User",K[K.Extension=4]="Extension"})(wt||(e.TerminalExitReason=wt={}));var Lt;(function(K){K[K.Low=0]="Low",K[K.Medium=1]="Medium",K[K.High=2]="High"})(Lt||(e.TerminalShellExecutionCommandLineConfidence=Lt={}));class ai{constructor(Q,fe,Oe){if(this.startIndex=Q,this.length=fe,this.tooltip=Oe,typeof Q!="number"||Q<0)throw(0,h.$9)("startIndex");if(typeof fe!="number"||fe<1)throw(0,h.$9)("length");if(Oe!==void 0&&typeof Oe!="string")throw(0,h.$9)("tooltip")}}e.$LO=ai;class Zt{constructor(Q){this.uri=Q}}e.$MO=Zt;class et{constructor(Q){this.terminalCommand=Q}}e.$NO=et;var ni;(function(K){K[K.Panel=1]="Panel",K[K.Editor=2]="Editor"})(ni||(e.TerminalLocation=ni={}));class ci{constructor(Q){if(this.options=Q,typeof Q!="object")throw(0,h.$9)("options")}}e.$OO=ci;var ui;(function(K){K[K.Always=1]="Always",K[K.Silent=2]="Silent",K[K.Never=3]="Never"})(ui||(e.TaskRevealKind=ui={}));var kt;(function(K){K[K.Shared=1]="Shared",K[K.Dedicated=2]="Dedicated",K[K.New=3]="New"})(kt||(e.TaskPanelKind=kt={}));let Ut=class{static{y=this}static{this.Clean=new y("clean","Clean")}static{this.Build=new y("build","Build")}static{this.Rebuild=new y("rebuild","Rebuild")}static{this.Test=new y("test","Test")}static from(Q){switch(Q){case"clean":return y.Clean;case"build":return y.Build;case"rebuild":return y.Rebuild;case"test":return y.Test;default:return}}constructor(Q,fe){if(this.label=fe,typeof Q!="string"||typeof fe!="string")throw(0,h.$9)("name");this.c=Q}get id(){return this.c}};e.$PO=Ut,e.$PO=Ut=y=Ze([v],Ut);function Nt(K){let Q="";for(let fe=0;fe<K.length;fe++)Q+=K[fe].replace(/,/g,",,")+",";return Q}let Bt=class{constructor(Q,fe,Oe){if(typeof Q!="string")throw(0,h.$9)("process");this.e=[],this.c=Q,fe!==void 0&&(Array.isArray(fe)?(this.e=fe,this.f=Oe):this.f=fe)}get process(){return this.c}set process(Q){if(typeof Q!="string")throw(0,h.$9)("process");this.c=Q}get args(){return this.e}set args(Q){Array.isArray(Q)||(Q=[]),this.e=Q}get options(){return this.f}set options(Q){this.f=Q}computeId(){const Q=[];if(Q.push("process"),this.c!==void 0&&Q.push(this.c),this.e&&this.e.length>0)for(const fe of this.e)Q.push(fe);return Nt(Q)}};e.$QO=Bt,e.$QO=Bt=Ze([v],Bt);let oi=class{constructor(Q,fe,Oe){if(this.f=[],Array.isArray(fe)){if(!Q)throw(0,h.$9)("command can't be undefined or null");if(typeof Q!="string"&&typeof Q.value!="string")throw(0,h.$9)("command");this.e=Q,this.f=fe,this.g=Oe}else{if(typeof Q!="string")throw(0,h.$9)("commandLine");this.c=Q,this.g=fe}}get commandLine(){return this.c}set commandLine(Q){if(typeof Q!="string")throw(0,h.$9)("commandLine");this.c=Q}get command(){return this.e?this.e:""}set command(Q){if(typeof Q!="string"&&typeof Q.value!="string")throw(0,h.$9)("command");this.e=Q}get args(){return this.f}set args(Q){this.f=Q||[]}get options(){return this.g}set options(Q){this.g=Q}computeId(){const Q=[];if(Q.push("shell"),this.c!==void 0&&Q.push(this.c),this.e!==void 0&&Q.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const fe of this.f)Q.push(typeof fe=="string"?fe:fe.value);return Nt(Q)}};e.$RO=oi,e.$RO=oi=Ze([v],oi);var ri;(function(K){K[K.Escape=1]="Escape",K[K.Strong=2]="Strong",K[K.Weak=3]="Weak"})(ri||(e.ShellQuoting=ri={}));var si;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace"})(si||(e.TaskScope=si={}));class Kt{constructor(Q){this.c=Q}computeId(){return"customExecution"+(0,I.$5g)()}set callback(Q){this.c=Q}get callback(){return this.c}}e.$SO=Kt;let Jt=class{static{k=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(Q,fe,Oe,_e,ct,pt){this.k=!1,this.l=this.definition=Q;let yt;typeof fe=="string"?(this.o=this.name=fe,this.w=this.source=Oe,this.execution=_e,yt=ct,this.k=!0):fe===si.Global||fe===si.Workspace?(this.target=fe,this.o=this.name=Oe,this.w=this.source=_e,this.execution=ct,yt=pt):(this.target=fe,this.o=this.name=Oe,this.w=this.source=_e,this.execution=ct,yt=pt),typeof yt=="string"?(this.r=[yt],this.t=!0):Array.isArray(yt)?(this.r=yt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(Q){this.j=Q}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Bt?this.l={type:k.e,id:this.q.computeId()}:this.q instanceof oi?this.l={type:k.f,id:this.q.computeId()}:this.q instanceof Kt?this.l={type:k.c,id:this.q.computeId()}:this.l={type:k.g,id:(0,I.$5g)()}}get definition(){return this.l}set definition(Q){if(Q==null)throw(0,h.$9)("Kind can't be undefined or null");this.B(),this.l=Q}get scope(){return this.m}set target(Q){this.B(),this.m=Q}get name(){return this.o}set name(Q){if(typeof Q!="string")throw(0,h.$9)("name");this.B(),this.o=Q}get execution(){return this.q}set execution(Q){Q===null&&(Q=void 0),this.B(),this.q=Q;const fe=this.l.type;(k.g===fe||k.e===fe||k.f===fe||k.c===fe)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(Q){if(Array.isArray(Q))this.B(),this.r=Q,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(Q){Q!==!0&&Q!==!1&&(Q=!1),this.B(),this.u=Q}get source(){return this.w}set source(Q){if(typeof Q!="string"||Q.length===0)throw(0,h.$9)("source must be a string of length > 0");this.B(),this.w=Q}get group(){return this.x}set group(Q){Q===null&&(Q=void 0),this.B(),this.x=Q}get detail(){return this.A}set detail(Q){Q===null&&(Q=void 0),this.A=Q}get presentationOptions(){return this.y}set presentationOptions(Q){Q==null&&(Q=Object.create(null)),this.B(),this.y=Q}get runOptions(){return this.z}set runOptions(Q){Q==null&&(Q=Object.create(null)),this.B(),this.z=Q}};e.$TO=Jt,e.$TO=Jt=k=Ze([v],Jt);var li;(function(K){K[K.SourceControl=1]="SourceControl",K[K.Window=10]="Window",K[K.Notification=15]="Notification"})(li||(e.ProgressLocation=li={}));var Mt;(function(K){function Q(fe){const Oe=fe;return(0,m.$lg)(Oe.value)?Oe.tooltip&&!(0,m.$hg)(Oe.tooltip)?(console.log("INVALID view badge, invalid tooltip",Oe.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Oe.value),!1)}K.isViewBadge=Q})(Mt||(e.ViewBadge=Mt={}));let Rt=S=class{static isTreeItem(Q,fe){const Oe=Q;if(Oe.checkboxState!==void 0){const _e=(0,m.$lg)(Oe.checkboxState)?Oe.checkboxState:(0,m.$jg)(Oe.checkboxState)&&(0,m.$lg)(Oe.checkboxState.state)?Oe.checkboxState.state:void 0,ct=!(0,m.$lg)(Oe.checkboxState)&&(0,m.$jg)(Oe.checkboxState)?Oe.checkboxState.tooltip:void 0;if(_e===void 0||_e!==Xt.Checked&&_e!==Xt.Unchecked||ct!==void 0&&!(0,m.$hg)(ct))return console.log("INVALID tree item, invalid checkboxState",Oe.checkboxState),!1}if(Q instanceof S)return!0;if(Oe.label!==void 0&&!(0,m.$hg)(Oe.label)&&!Oe.label?.label)return console.log("INVALID tree item, invalid label",Oe.label),!1;if(Oe.id!==void 0&&!(0,m.$hg)(Oe.id))return console.log("INVALID tree item, invalid id",Oe.id),!1;if(Oe.iconPath!==void 0&&!(0,m.$hg)(Oe.iconPath)&&!c.URI.isUri(Oe.iconPath)&&(!Oe.iconPath||!(0,m.$hg)(Oe.iconPath.id))){const _e=Oe.iconPath;if(!_e||!(0,m.$hg)(_e.light)&&!c.URI.isUri(_e.light)&&!(0,m.$hg)(_e.dark)&&!c.URI.isUri(_e.dark))return console.log("INVALID tree item, invalid iconPath",Oe.iconPath),!1}return Oe.description!==void 0&&!(0,m.$hg)(Oe.description)&&typeof Oe.description!="boolean"?(console.log("INVALID tree item, invalid description",Oe.description),!1):Oe.resourceUri!==void 0&&!c.URI.isUri(Oe.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Oe.resourceUri),!1):Oe.tooltip!==void 0&&!(0,m.$hg)(Oe.tooltip)&&!(Oe.tooltip instanceof ot)?(console.log("INVALID tree item, invalid tooltip",Oe.tooltip),!1):Oe.command!==void 0&&!Oe.command.command?(console.log("INVALID tree item, invalid command",Oe.command),!1):Oe.collapsibleState!==void 0&&Oe.collapsibleState<vt.None&&Oe.collapsibleState>vt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Oe.collapsibleState),!1):Oe.contextValue!==void 0&&!(0,m.$hg)(Oe.contextValue)?(console.log("INVALID tree item, invalid contextValue",Oe.contextValue),!1):Oe.accessibilityInformation!==void 0&&!Oe.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Oe.accessibilityInformation),!1):!0}constructor(Q,fe=vt.None){this.collapsibleState=fe,c.URI.isUri(Q)?this.resourceUri=Q:this.label=Q}};e.$UO=Rt,e.$UO=Rt=S=Ze([v],Rt);var vt;(function(K){K[K.None=0]="None",K[K.Collapsed=1]="Collapsed",K[K.Expanded=2]="Expanded"})(vt||(e.TreeItemCollapsibleState=vt={}));var Xt;(function(K){K[K.Unchecked=0]="Unchecked",K[K.Checked=1]="Checked"})(Xt||(e.TreeItemCheckboxState=Xt={}));let Et=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(Q){this.value=Q}};e.$VO=Et,e.$VO=Et=Ze([v],Et);class hi extends Et{}e.$WO=hi;class Yt extends hi{#e;constructor(Q){super(""),this.#e=Q}asFile(){return this.#e}}e.$XO=Yt;class Mi{constructor(Q,fe,Oe,_e){this.name=Q,this.uri=fe,this._itemId=Oe,this.c=_e}data(){return this.c()}}e.$YO=Mi;let di=class{#e=new Map;constructor(Q){for(const[fe,Oe]of Q??[]){const _e=this.#e.get(this.#t(fe));_e?_e.push(Oe):this.#e.set(this.#t(fe),[Oe])}}get(Q){return this.#e.get(this.#t(Q))?.[0]}set(Q,fe){this.#e.set(this.#t(Q),[fe])}forEach(Q,fe){for(const[Oe,_e]of this.#e)for(const ct of _e)Q.call(fe,ct,Oe,this)}*[Symbol.iterator](){for(const[Q,fe]of this.#e)for(const Oe of fe)yield[Q,Oe]}#t(Q){return Q.toLowerCase()}};e.$ZO=di,e.$ZO=di=Ze([v],di);let yi=class{constructor(Q,fe,Oe){this.insertText=Q,this.title=fe,this.kind=Oe}};e.$1O=yi,e.$1O=yi=Ze([v],yi);var qt;(function(K){K[K.Automatic=0]="Automatic",K[K.PasteAs=1]="PasteAs"})(qt||(e.DocumentPasteTriggerKind=qt={}));class fi{static{this.c="."}constructor(Q){this.value=Q}append(...Q){return new fi((this.value?[this.value,...Q]:Q).join(fi.c))}intersects(Q){return this.contains(Q)||Q.contains(this)}contains(Q){return this.value===Q.value||Q.value.startsWith(this.value+fi.c)}}e.$2O=fi,fi.Empty=new fi("");class ji{constructor(Q,fe,Oe){this.title=fe,this.insertText=Q,this.kind=Oe}}e.$3O=ji;let Ct=class{constructor(Q,fe){this.id=Q,this.color=fe}static isThemeIcon(Q){return typeof Q.id!="string"?(console.log("INVALID ThemeIcon, invalid id",Q.id),!1):!0}};e.$4O=Ct,e.$4O=Ct=Ze([v],Ct),Ct.File=new Ct("file"),Ct.Folder=new Ct("folder");let Ei=class{constructor(Q){this.id=Q}};e.$5O=Ei,e.$5O=Ei=Ze([v],Ei);var Oi;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace",K[K.WorkspaceFolder=3]="WorkspaceFolder"})(Oi||(e.ConfigurationTarget=Oi={}));let gi=class{get base(){return this.c}set base(Q){this.c=Q,this.e=c.URI.file(Q)}get baseUri(){return this.e}set baseUri(Q){this.e=Q,this.c=Q.fsPath}constructor(Q,fe){if(typeof Q!="string"&&(!Q||!c.URI.isUri(Q)&&!c.URI.isUri(Q.uri)))throw(0,h.$9)("base");if(typeof fe!="string")throw(0,h.$9)("pattern");typeof Q=="string"?this.baseUri=c.URI.file(Q):c.URI.isUri(Q)?this.baseUri=Q:this.baseUri=Q.uri,this.pattern=fe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$6O=gi,e.$6O=gi=Ze([v],gi);const Fi=new WeakMap;function Ui(K,Q){Fi.set(K,Q)}let Ft=class{constructor(Q,fe,Oe,_e,ct){this.enabled=typeof Q=="boolean"?Q:!0,typeof fe=="string"&&(this.condition=fe),typeof Oe=="string"&&(this.hitCondition=Oe),typeof _e=="string"&&(this.logMessage=_e),typeof ct=="string"&&(this.mode=ct)}get id(){return this.c||(this.c=Fi.get(this)??(0,I.$5g)()),this.c}};e.$8O=Ft,e.$8O=Ft=Ze([v],Ft);let Pi=class extends Ft{constructor(Q,fe,Oe,_e,ct,pt){if(super(fe,Oe,_e,ct,pt),Q===null)throw(0,h.$9)("location");this.location=Q}};e.$9O=Pi,e.$9O=Pi=Ze([v],Pi);let Di=class extends Ft{constructor(Q,fe,Oe,_e,ct,pt){super(fe,Oe,_e,ct,pt),this.functionName=Q}};e.$0O=Di,e.$0O=Di=Ze([v],Di);let bi=class extends Ft{constructor(Q,fe,Oe,_e,ct,pt,yt,_t){if(super(_e,ct,pt,yt,_t),!fe)throw(0,h.$9)("dataId");this.label=Q,this.dataId=fe,this.canPersist=Oe}};e.$$O=bi,e.$$O=bi=Ze([v],bi);let wi=class{constructor(Q,fe,Oe){this.command=Q,this.args=fe||[],this.options=Oe}};e.$_O=wi,e.$_O=wi=Ze([v],wi);let De=class{constructor(Q,fe){this.port=Q,this.host=fe}};e.$aP=De,e.$aP=De=Ze([v],De);let Me=class{constructor(Q){this.path=Q}};e.$bP=Me,e.$bP=Me=Ze([v],Me);let ve=class{constructor(Q){this.implementation=Q}};e.$cP=ve,e.$cP=ve=Ze([v],ve);class te{constructor(Q,fe,Oe){this.session=Q,this.threadId=fe,this.frameId=Oe}}e.$dP=te;class Le{constructor(Q,fe){this.session=Q,this.threadId=fe}}e.$eP=Le;let Qe=class{constructor(Q,fe){this.range=Q,this.expression=fe}};e.$fP=Qe,e.$fP=Qe=Ze([v],Qe);var nt;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(nt||(e.InlineCompletionTriggerKind=nt={}));let Xe=class{constructor(Q,fe){this.range=Q,this.text=fe}};e.$gP=Xe,e.$gP=Xe=Ze([v],Xe);let mt=class{constructor(Q,fe,Oe=!0){this.range=Q,this.variableName=fe,this.caseSensitiveLookup=Oe}};e.$hP=mt,e.$hP=mt=Ze([v],mt);let Tt=class{constructor(Q,fe){this.range=Q,this.expression=fe}};e.$iP=Tt,e.$iP=Tt=Ze([v],Tt);let xt=class{constructor(Q,fe){this.frameId=Q,this.stoppedLocation=fe}};e.$jP=xt,e.$jP=xt=Ze([v],xt);var Vt;(function(K){K[K.AIGenerated=1]="AIGenerated"})(Vt||(e.NewSymbolNameTag=Vt={}));var Wt;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(Wt||(e.NewSymbolNameTriggerKind=Wt={}));class Li{constructor(Q,fe){this.newSymbolName=Q,this.tags=fe}}e.$kP=Li;var en;(function(K){K[K.Changed=1]="Changed",K[K.Created=2]="Created",K[K.Deleted=3]="Deleted"})(en||(e.FileChangeType=en={}));let Vi=D=class extends Error{static FileExists(Q){return new D(Q,g.FileSystemProviderErrorCode.FileExists,D.FileExists)}static FileNotFound(Q){return new D(Q,g.FileSystemProviderErrorCode.FileNotFound,D.FileNotFound)}static FileNotADirectory(Q){return new D(Q,g.FileSystemProviderErrorCode.FileNotADirectory,D.FileNotADirectory)}static FileIsADirectory(Q){return new D(Q,g.FileSystemProviderErrorCode.FileIsADirectory,D.FileIsADirectory)}static NoPermissions(Q){return new D(Q,g.FileSystemProviderErrorCode.NoPermissions,D.NoPermissions)}static Unavailable(Q){return new D(Q,g.FileSystemProviderErrorCode.Unavailable,D.Unavailable)}constructor(Q,fe=g.FileSystemProviderErrorCode.Unknown,Oe){super(c.URI.isUri(Q)?Q.toString(!0):Q),this.code=Oe?.name??"Unknown",(0,g.$sl)(this,fe),Object.setPrototypeOf(this,D.prototype),typeof Error.captureStackTrace=="function"&&typeof Oe=="function"&&Error.captureStackTrace(this,Oe)}};e.$lP=Vi,e.$lP=Vi=D=Ze([v],Vi);let Si=class{constructor(Q,fe,Oe){this.start=Q,this.end=fe,this.kind=Oe}};e.$mP=Si,e.$mP=Si=Ze([v],Si);var tn;(function(K){K[K.Comment=1]="Comment",K[K.Imports=2]="Imports",K[K.Region=3]="Region"})(tn||(e.FoldingRangeKind=tn={}));var nn;(function(K){K[K.Collapsed=0]="Collapsed",K[K.Expanded=1]="Expanded"})(nn||(e.CommentThreadCollapsibleState=nn={}));var zi;(function(K){K[K.Editing=0]="Editing",K[K.Preview=1]="Preview"})(zi||(e.CommentMode=zi={}));var rn;(function(K){K[K.Published=0]="Published",K[K.Draft=1]="Draft"})(rn||(e.CommentState=rn={}));var Bi;(function(K){K[K.Unresolved=0]="Unresolved",K[K.Resolved=1]="Resolved"})(Bi||(e.CommentThreadState=Bi={}));var Hi;(function(K){K[K.Current=0]="Current",K[K.Outdated=1]="Outdated"})(Hi||(e.CommentThreadApplicability=Hi={}));var sn;(function(K){K[K.Reply=1]="Reply",K[K.Comment=2]="Comment"})(sn||(e.CommentThreadFocus=sn={}));class on{constructor(Q,fe=[]){this.tokenTypes=Q,this.tokenModifiers=fe}}e.$nP=on;function bn(K){return typeof K>"u"||(0,m.$ig)(K)}class Ri{constructor(Q){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,Q){this.m=!0;for(let fe=0,Oe=Q.tokenTypes.length;fe<Oe;fe++)this.k.set(Q.tokenTypes[fe],fe);for(let fe=0,Oe=Q.tokenModifiers.length;fe<Oe;fe++)this.l.set(Q.tokenModifiers[fe],fe)}}push(Q,fe,Oe,_e,ct){if(typeof Q=="number"&&typeof fe=="number"&&typeof Oe=="number"&&typeof _e=="number"&&(typeof ct=="number"||typeof ct>"u"))return typeof ct>"u"&&(ct=0),this.q(Q,fe,Oe,_e,ct);if(F.isRange(Q)&&typeof fe=="string"&&bn(Oe))return this.o(Q,fe,Oe);throw(0,h.$9)()}o(Q,fe,Oe){if(!this.m)throw new Error("Legend must be provided in constructor");if(Q.start.line!==Q.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(fe))throw new Error("`tokenType` is not in the provided legend");const _e=Q.start.line,ct=Q.start.character,pt=Q.end.character-Q.start.character,yt=this.k.get(fe);let _t=0;if(Oe)for(const pi of Oe){if(!this.l.has(pi))throw new Error("`tokenModifier` is not in the provided legend");const vi=this.l.get(pi);_t|=1<<vi>>>0}this.q(_e,ct,pt,yt,_t)}q(Q,fe,Oe,_e,ct){if(this.f&&(Q<this.c||Q===this.c&&fe<this.e)){this.f=!1;const _t=this.g.length/5|0;let pi=0,vi=0;for(let Ii=0;Ii<_t;Ii++){let Ti=this.g[5*Ii],xi=this.g[5*Ii+1];Ti===0?(Ti=pi,xi+=vi):Ti+=pi,this.g[5*Ii]=Ti,this.g[5*Ii+1]=xi,pi=Ti,vi=xi}}let pt=Q,yt=fe;this.f&&this.j>0&&(pt-=this.c,pt===0&&(yt-=this.e)),this.g[this.j++]=pt,this.g[this.j++]=yt,this.g[this.j++]=Oe,this.g[this.j++]=_e,this.g[this.j++]=ct,this.c=Q,this.e=fe}static r(Q){const fe=[],Oe=Q.length/5|0;for(let yt=0;yt<Oe;yt++)fe[yt]=yt;fe.sort((yt,_t)=>{const pi=Q[5*yt],vi=Q[5*_t];if(pi===vi){const Ii=Q[5*yt+1],Ti=Q[5*_t+1];return Ii-Ti}return pi-vi});const _e=new Uint32Array(Q.length);let ct=0,pt=0;for(let yt=0;yt<Oe;yt++){const _t=5*fe[yt],pi=Q[_t+0],vi=Q[_t+1],Ii=Q[_t+2],Ti=Q[_t+3],xi=Q[_t+4],Hn=pi-ct,Mr=Hn===0?vi-pt:vi,_i=5*yt;_e[_i+0]=Hn,_e[_i+1]=Mr,_e[_i+2]=Ii,_e[_i+3]=Ti,_e[_i+4]=xi,ct=pi,pt=vi}return _e}build(Q){return this.f?new Qi(new Uint32Array(this.g),Q):new Qi(Ri.r(this.g),Q)}}e.$oP=Ri;class Qi{constructor(Q,fe){this.resultId=fe,this.data=Q}}e.$pP=Qi;class wn{constructor(Q,fe,Oe){this.start=Q,this.deleteCount=fe,this.data=Oe}}e.$qP=wn;class vn{constructor(Q,fe){this.resultId=fe,this.edits=Q}}e.$rP=vn;var Wi;(function(K){K[K.Separate=0]="Separate",K[K.MergeWithParent=1]="MergeWithParent"})(Wi||(e.DebugConsoleMode=Wi={}));class an{constructor(Q){this.name=Q}}e.$sP=an;var Be;(function(K){K[K.Title=1]="Title",K[K.Inline=2]="Inline"})(Be||(e.QuickInputButtonLocation=Be={}));let mi=class{static{this.Back={iconPath:new Ct("arrow-left")}}constructor(){}};e.$tP=mi,e.$tP=mi=Ze([v],mi);var Gi;(function(K){K[K.Separator=-1]="Separator",K[K.Default=0]="Default"})(Gi||(e.QuickPickItemKind=Gi={}));var dt;(function(K){K[K.Info=1]="Info",K[K.Warning=2]="Warning",K[K.Error=3]="Error"})(dt||(e.InputBoxValidationSeverity=dt={}));var It;(function(K){K[K.UI=1]="UI",K[K.Workspace=2]="Workspace"})(It||(e.ExtensionKind=It={}));class yn{static validate(Q){if(typeof Q.badge=="string"){let fe=(0,C.$Sf)(Q.badge,0);if(fe<Q.badge.length&&(fe+=(0,C.$Sf)(Q.badge,fe)),Q.badge.length>fe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(Q.badge&&!Ct.isThemeIcon(Q.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!Q.color&&!Q.badge&&!Q.tooltip)throw new Error("The decoration is empty");return!0}constructor(Q,fe,Oe){this.badge=Q,this.tooltip=fe,this.color=Oe}}e.$uP=yn;let Ki=class{constructor(Q){this.kind=Q}};e.$vP=Ki,e.$vP=Ki=Ze([v],Ki);var Ji;(function(K){K[K.Light=1]="Light",K[K.Dark=2]="Dark",K[K.HighContrast=3]="HighContrast",K[K.HighContrastLight=4]="HighContrastLight"})(Ji||(e.ColorThemeKind=Ji={}));class ki{static isNotebookRange(Q){return Q instanceof ki?!0:Q?typeof Q.start=="number"&&typeof Q.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(Q,fe){if(Q<0)throw(0,h.$9)("start must be positive");if(fe<0)throw(0,h.$9)("end must be positive");Q<=fe?(this.c=Q,this.e=fe):(this.c=fe,this.e=Q)}with(Q){let fe=this.c,Oe=this.e;return Q.start!==void 0&&(fe=Q.start),Q.end!==void 0&&(Oe=Q.end),fe===this.c&&Oe===this.e?this:new ki(fe,Oe)}}e.$wP=ki;class Ci{static validate(Q){if(typeof Q.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof Q.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof Q.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(Q){return Array.isArray(Q)&&Q.every(fe=>Ci.isNotebookCellData(fe))}static isNotebookCellData(Q){return!0}constructor(Q,fe,Oe,_e,ct,pt,yt){this.kind=Q,this.value=fe,this.languageId=Oe,this.mime=_e,this.outputs=ct??[],this.metadata=pt,this.executionSummary=yt,Ci.validate(this)}}e.$xP=Ci;class En{constructor(Q){this.cells=Q}}e.$yP=En;class $i{static isNotebookCellOutputItem(Q){return Q instanceof $i?!0:Q?typeof Q.mime=="string"&&Q.data instanceof Uint8Array:!1}static error(Q){const fe={name:Q.name,message:Q.message,stack:Q.stack};return $i.json(fe,"application/vnd.code.notebook.error")}static stdout(Q){return $i.text(Q,"application/vnd.code.notebook.stdout")}static stderr(Q){return $i.text(Q,"application/vnd.code.notebook.stderr")}static bytes(Q,fe="application/octet-stream"){return new $i(Q,fe)}static#e=new TextEncoder;static text(Q,fe=O.$et.text){const Oe=$i.#e.encode(String(Q));return new $i(Oe,fe)}static json(Q,fe="text/x-json"){const Oe=JSON.stringify(Q,void 0,"	");return $i.text(Oe,fe)}constructor(Q,fe){this.data=Q,this.mime=fe;const Oe=(0,O.$it)(fe,!0);if(!Oe)throw new Error(`INVALID mime type: ${fe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Oe}}e.$zP=$i;class qi{static isNotebookCellOutput(Q){return Q instanceof qi?!0:!Q||typeof Q!="object"?!1:typeof Q.id=="string"&&Array.isArray(Q.items)}static ensureUniqueMimeTypes(Q,fe=!1){const Oe=new Set,_e=new Set;for(let ct=0;ct<Q.length;ct++){const pt=Q[ct],yt=(0,O.$it)(pt.mime);if(!Oe.has(yt)||(0,b.$6L)(yt)){Oe.add(yt);continue}_e.add(ct),fe&&console.warn(`DUPLICATED mime type '${pt.mime}' will be dropped`)}return _e.size===0?Q:Q.filter((ct,pt)=>!_e.has(pt))}constructor(Q,fe,Oe){this.items=qi.ensureUniqueMimeTypes(Q,!0),typeof fe=="string"?(this.id=fe,this.metadata=Oe):(this.id=(0,I.$5g)(),this.metadata=fe??Oe)}}e.$AP=qi;var Xi;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(Xi||(e.NotebookCellKind=Xi={}));var cn;(function(K){K[K.Idle=1]="Idle",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(cn||(e.NotebookCellExecutionState=cn={}));var ln;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(ln||(e.NotebookCellStatusBarAlignment=ln={}));var un;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(un||(e.NotebookEditorRevealType=un={}));class Sn{constructor(Q,fe){this.text=Q,this.alignment=fe}}e.$BP=Sn;var hn;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred"})(hn||(e.NotebookControllerAffinity=hn={}));var dn;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred",K[K.Hidden=-1]="Hidden"})(dn||(e.NotebookControllerAffinity2=dn={}));class kn{constructor(Q,fe=[]){this.uri=Q,this.provides=(0,s.$4b)(fe)}}e.$CP=kn;class In{constructor(Q){this.label=Q}}e.$DP=In;var fn;(function(K){K[K.Named=1]="Named",K[K.Indexed=2]="Indexed"})(fn||(e.NotebookVariablesRequestKind=fn={}));let Zi=class{constructor(Q,fe){this.label=Q,this.timestamp=fe}};e.$EP=Zi,e.$EP=Zi=Ze([v],Zi);var gn;(function(K){K[K.Production=1]="Production",K[K.Development=2]="Development",K[K.Test=3]="Test"})(gn||(e.ExtensionMode=gn={}));var he;(function(K){K[K.Node=1]="Node",K[K.Webworker=2]="Webworker"})(he||(e.ExtensionRuntime=he={}));var Ee;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(Ee||(e.StandardTokenType=Ee={}));class ze{constructor(Q,fe){this.ranges=Q,this.wordPattern=fe}}e.$FP=ze;class gt{constructor(Q){this.c=Q}get autoForwardAction(){return this.c}}e.$GP=gt;var Pt;(function(K){K[K.Queued=1]="Queued",K[K.Running=2]="Running",K[K.Passed=3]="Passed",K[K.Failed=4]="Failed",K[K.Skipped=5]="Skipped",K[K.Errored=6]="Errored"})(Pt||(e.TestResultState=Pt={}));var jt;(function(K){K[K.Run=1]="Run",K[K.Debug=2]="Debug",K[K.Coverage=3]="Coverage"})(jt||(e.TestRunProfileKind=jt={}));let Ai=class{constructor(Q=void 0,fe=void 0,Oe=void 0,_e=!1,ct=!0){this.include=Q,this.exclude=fe,this.profile=Oe,this.continuous=_e,this.preserveFocus=ct}};e.$HP=Ai,e.$HP=Ai=Ze([v],Ai);let Yi=T=class{static diff(Q,fe,Oe){const _e=new T(Q);return _e.expectedOutput=fe,_e.actualOutput=Oe,_e}constructor(Q){this.message=Q}};e.$IP=Yi,e.$IP=Yi=T=Ze([v],Yi);let Pn=class{constructor(Q){this.id=Q}};e.$JP=Pn,e.$JP=Pn=Ze([v],Pn);class Kn{constructor(Q,fe,Oe){this.label=Q,this.uri=fe,this.position=Oe}}e.$KP=Kn;class mn{constructor(Q,fe){this.covered=Q,this.total=fe,Rn(this)}}e.$LP=mn;function Rn(K){if(K){if(K.covered>K.total)throw new Error(`The total number of covered items (${K.covered}) cannot be greater than the total (${K.total})`);if(K.total<0)throw new Error(`The number of covered items (${K.total}) cannot be negative`)}}class Dn{static fromDetails(Q,fe){const Oe=new mn(0,0),_e=new mn(0,0),ct=new mn(0,0);for(const yt of fe)if("branches"in yt){Oe.total+=1,Oe.covered+=yt.executed?1:0;for(const _t of yt.branches)_e.total+=1,_e.covered+=_t.executed?1:0}else ct.total+=1,ct.covered+=yt.executed?1:0;const pt=new Dn(Q,Oe,_e.total>0?_e:void 0,ct.total>0?ct:void 0);return pt.detailedCoverage=fe,pt}constructor(Q,fe,Oe,_e,ct=[]){this.uri=Q,this.statementCoverage=fe,this.branchCoverage=Oe,this.declarationCoverage=_e,this.fromTests=ct}}e.$NP=Dn;class Jn{get executionCount(){return+this.executed}set executionCount(Q){this.executed=Q}constructor(Q,fe,Oe=[]){this.executed=Q,this.location=fe,this.branches=Oe}}e.$OP=Jn;class Xn{get executionCount(){return+this.executed}set executionCount(Q){this.executed=Q}constructor(Q,fe,Oe){this.executed=Q,this.location=fe,this.label=Oe}}e.$PP=Xn;class Zn{get executionCount(){return+this.executed}set executionCount(Q){this.executed=Q}constructor(Q,fe,Oe){this.name=Q,this.executed=fe,this.location=Oe}}e.$QP=Zn;var Cn;(function(K){K[K.None=0]="None",K[K.Option=1]="Option",K[K.Default=2]="Default",K[K.Preferred=3]="Preferred"})(Cn||(e.ExternalUriOpenerPriority=Cn={}));var An;(function(K){K[K.Untrusted=0]="Untrusted",K[K.Trusted=1]="Trusted",K[K.Unspecified=2]="Unspecified"})(An||(e.WorkspaceTrustState=An={}));var Tn;(function(K){K[K.Notify=1]="Notify",K[K.OpenBrowser=2]="OpenBrowser",K[K.OpenPreview=3]="OpenPreview",K[K.Silent=4]="Silent",K[K.Ignore=5]="Ignore",K[K.OpenBrowserOnce=6]="OpenBrowserOnce"})(Tn||(e.PortAutoForwardAction=Tn={}));class Yn{constructor(Q,fe,Oe,_e,ct,pt){this.kind=Q,this.name=fe,this.detail=Oe,this.uri=_e,this.range=ct,this.selectionRange=pt}}e.$RP=Yn;class xn{constructor(Q){this.uri=Q}}e.$SP=xn;class _n{constructor(Q,fe){this.original=Q,this.modified=fe}}e.$TP=_n;class er{constructor(Q,fe,Oe,_e){this.base=Q,this.input1=fe,this.input2=Oe,this.result=_e}}e.$UP=er;class tr{constructor(Q,fe){this.uri=Q,this.viewType=fe}}e.$VP=tr;class ir{constructor(Q){this.viewType=Q}}e.$WP=ir;class nr{constructor(Q,fe){this.uri=Q,this.notebookType=fe}}e.$XP=nr;class rr{constructor(Q,fe,Oe){this.original=Q,this.modified=fe,this.notebookType=Oe}}e.$YP=rr;class sr{constructor(){}}e.$ZP=sr;class or{constructor(Q,fe){this.uri=Q,this.inputBoxUri=fe}}e.$1P=or;class ar{constructor(){}}e.$2P=ar;class cr{constructor(Q){this.textDiffs=Q}}e.$3P=cr;var On;(function(K){K[K.Down=0]="Down",K[K.Up=1]="Up"})(On||(e.InteractiveSessionVoteDirection=On={}));var Ln;(function(K){K[K.Action=1]="Action",K[K.Toolbar=2]="Toolbar"})(Ln||(e.ChatCopyKind=Ln={}));var Nn;(function(K){K[K.Short=1]="Short",K[K.Medium=2]="Medium",K[K.Full=3]="Full"})(Nn||(e.ChatVariableLevel=Nn={}));class lr{constructor(Q,fe,Oe){this.id=Q,this.label=fe,this.values=Oe}}e.$4P=lr;var Mn;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful",K[K.Undone=2]="Undone",K[K.Accepted=3]="Accepted",K[K.Bug=4]="Bug"})(Mn||(e.InteractiveEditorResponseFeedbackKind=Mn={}));var jn;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful"})(jn||(e.ChatResultFeedbackKind=jn={}));class ur{constructor(Q){if(typeof Q!="string"&&Q.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof Q=="string"?new ot(Q):Q}}e.$5P=ur;class hr{constructor(Q,fe){if(typeof Q!="string"&&Q.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof Q=="string"?new ot(Q):Q,this.vulnerabilities=fe}}e.$6P=hr;class dr{constructor(Q,fe){this.participant=Q,this.command=fe}}e.$7P=dr;class fr{constructor(Q,fe,Oe,_e){this.title=Q,this.message=fe,this.data=Oe,this.buttons=_e}}e.$8P=fr;class gr{constructor(Q,fe){this.value=Q,this.baseUri=fe}}e.$9P=gr;class mr{constructor(Q,fe){this.value=Q,this.title=fe}}e.$0P=mr;class $r{constructor(Q){this.value=Q}}e.$$P=$r;class pr{constructor(Q,fe){this.value=Q,this.task=fe}}e.$_P=pr;class br{constructor(Q){if(typeof Q!="string"&&Q.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof Q=="string"?new ot(Q):Q}}e.$aQ=br;class wr{constructor(Q){this.value=Q}}e.$bQ=wr;class vr{constructor(Q,fe,Oe){this.value=Q,this.iconPath=fe,this.options=Oe}}e.$cQ=vr;class yr{constructor(Q,fe,Oe){this.value=Q,this.license=fe,this.snippet=Oe}}e.$dQ=yr;class Er{constructor(Q,fe){this.uri=Q,this.range=fe}}e.$eQ=Er;class Sr{constructor(Q,fe){this.uri=Q,this.edits=Array.isArray(fe)?fe:[fe]}}e.$fQ=Sr;class kr{constructor(Q,fe,Oe,_e){this.prompt=Q,this.command=fe,this.references=Oe,this.participant=_e}}e.$gQ=kr;class Ir{constructor(Q,fe,Oe,_e){this.response=Q,this.result=fe,this.participant=Oe,this.command=_e}}e.$hQ=Ir;var Fn;(function(K){K[K.Panel=1]="Panel",K[K.Terminal=2]="Terminal",K[K.Notebook=3]="Notebook",K[K.Editor=4]="Editor"})(Fn||(e.ChatLocation=Fn={}));var zn;(function(K){K[K.Complete=1]="Complete",K[K.Partial=2]="Partial",K[K.Omitted=3]="Omitted"})(zn||(e.ChatResponseReferencePartStatusKind=zn={}));class Pr{constructor(Q,fe,Oe){this.document=Q,this.selection=fe,this.wholeRange=Oe}}e.$iQ=Pr;class Dr{constructor(Q){this.cell=Q}}e.$jQ=Dr;var $n;(function(K){K[K.User=1]="User",K[K.Assistant=2]="Assistant",K[K.System=3]="System"})($n||(e.LanguageModelChatMessageRole=$n={}));class Rr{constructor(Q,fe,Oe){this.name=Q,this.content=fe,this.isError=Oe??!1}}e.$kQ=Rr;class pn{static User(Q,fe){const Oe=new pn($n.User,typeof Q=="string"?Q:"",fe);return Oe.content2=Q,Oe}static Assistant(Q,fe){return new pn($n.Assistant,Q,fe)}constructor(Q,fe,Oe){this.role=Q,this.content=fe,this.content2=fe,this.name=Oe}}e.$lQ=pn;class Cr{constructor(Q,fe){this.name=Q,this.parameters=fe}}e.$mQ=Cr;class Ar{constructor(Q){this.value=Q}}e.$nQ=Ar;class Tr{constructor(Q){this.content=Q}}e.$oQ=Tr;class Or{constructor(Q,fe){this.content=Q,this.name=fe}}e.$pQ=Or;class Lr{constructor(Q,fe){this.content=Q,this.name=fe}}e.$qQ=Lr;class Ni extends Error{static NotFound(Q){return new Ni(Q,Ni.NotFound.name)}static NoPermissions(Q){return new Ni(Q,Ni.NoPermissions.name)}static Blocked(Q){return new Ni(Q,Ni.Blocked.name)}constructor(Q,fe,Oe){super(Q,{cause:Oe}),this.name="LanguageModelError",this.code=fe??""}}e.$rQ=Ni;var Un;(function(K){K[K.SymbolInformation=1]="SymbolInformation",K[K.CommandInformation=2]="CommandInformation",K[K.SearchInformation=3]="SearchInformation",K[K.SettingInformation=4]="SettingInformation"})(Un||(e.RelatedInformationType=Un={}));var Bn;(function(K){K[K.Started=1]="Started",K[K.Recognizing=2]="Recognizing",K[K.Recognized=3]="Recognized",K[K.Stopped=4]="Stopped",K[K.Error=5]="Error"})(Bn||(e.SpeechToTextStatus=Bn={}));var Wn;(function(K){K[K.Started=1]="Started",K[K.Stopped=2]="Stopped",K[K.Error=3]="Error"})(Wn||(e.TextToSpeechStatus=Wn={}));var qn;(function(K){K[K.Recognized=1]="Recognized",K[K.Stopped=2]="Stopped"})(qn||(e.KeywordRecognitionStatus=qn={}));class Nr{constructor(Q,fe){this.text=Q,this.range=fe}}e.$sQ=Nr;var Vn;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(Vn||(e.InlineEditTriggerKind=Vn={}))}),define(Re[291],Ce([1,0,6,9]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yqc=void 0;class R{constructor(O){this.a=new Map,this.b=0,this.c=O.getProxy(s.$3N.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(O,C,m){if(this.a.size===0)throw new Error("No related information providers registered");const c=this.a.get(O);if(!c)throw new Error("related information provider not found");return await c.provideRelatedInformation(C,m)??[]}getRelatedInformation(O,C,m){return this.c.$getAiRelatedInformation(C,m)}registerRelatedInformationProvider(O,C,m){const c=this.b;return this.b++,this.a.set(c,m),this.c.$registerAiRelatedInformationProvider(c,C),new h.$5N(()=>{this.c.$unregisterAiRelatedInformationProvider(c),this.a.delete(c)})}}e.$yqc=R}),define(Re[127],Ce([1,0,4,6,9,23,159,5,19]),function(ge,e,s,h,R,A,O,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kqc=e.$Jqc=void 0,e.$Jqc=(0,C.$Ii)("IExtHostAuthentication");let c=class{constructor(g){this.b=new Map,this.c=new s.$oe,this.onDidChangeSessions=this.c.event,this.d=new I,this.a=g.getProxy(h.$3N.MainThreadAuthentication)}async getSession(g,P,b,a={}){const $=A.$vn.toKey(g.identifier),p=[...b].sort().join(" ");return await this.d.getOrCreate(`${$} ${P} ${p}`,async()=>{await this.a.$ensureProvider(P);const u=g.displayName||g.name;return this.a.$getSession(P,b,$,u,a)})}async getAccounts(g){return await this.a.$ensureProvider(g),await this.a.$getAccounts(g)}async removeSession(g,P){const b=this.b.get(g);return b?b.provider.removeSession(P):this.a.$removeSession(g,P)}registerAuthenticationProvider(g,P,b,a){if(this.b.get(g))throw new Error(`An authentication provider with id '${g}' is already registered.`);this.b.set(g,{label:P,provider:b,options:a??{supportsMultipleAccounts:!1}});const $=b.onDidChangeSessions(p=>this.a.$sendDidChangeSessions(g,p));return this.a.$registerAuthenticationProvider(g,P,a?.supportsMultipleAccounts??!1),new R.$5N(()=>{$.dispose(),this.b.delete(g),this.a.$unregisterAuthenticationProvider(g)})}async $createSession(g,P,b){const a=this.b.get(g);if(a)return await a.provider.createSession(P,b);throw new Error(`Unable to find authentication provider with handle: ${g}`)}async $removeSession(g,P){const b=this.b.get(g);if(b)return await b.provider.removeSession(P);throw new Error(`Unable to find authentication provider with handle: ${g}`)}async $getSessions(g,P,b){const a=this.b.get(g);if(a)return await a.provider.getSessions(P,b);throw new Error(`Unable to find authentication provider with handle: ${g}`)}$onDidChangeAuthenticationSessions(g,P){return g.startsWith(O.$6M)||this.c.fire({provider:{id:g,label:P}}),Promise.resolve()}};e.$Kqc=c,e.$Kqc=c=Ze([qe(0,m.$DQ)],c);class I{constructor(){this.a=new Map}getOrCreate(g,P){const b=this.a.get(g);if(b)return b;const a=P().finally(()=>this.a.delete(g));return this.a.set(g,a),a}}}),define(Re[166],Ce([1,0,2,6,9,5,19,11,18,13,16,25]),function(ge,e,s,h,R,A,O,C,m,c,I,E){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$Prc=e.$Orc=void 0;let P=class{static{g=this}static{this.c=0}static{this.d=250}constructor(a,$){this.h=$,this.f=new Map,this.g=a.getProxy(h.$3N.MainThreadDecorations)}registerFileDecorationProvider(a,$){const p=g.c++;this.f.set(p,{provider:a,extensionDescription:$}),this.g.$registerDecorationProvider(p,$.identifier.value);const u=a.onDidChangeFileDecorations&&a.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(p,null);return}const o=(0,m.$4b)(i);if(o.length<=g.d){this.g.$onDidChange(p,o);return}this.h.warn("[Decorations] CAPPING events from decorations provider",$.identifier.value,o.length);const t=o.map(d=>({uri:d,rank:(0,c.$lf)(d.path,"/")})),n=(0,m.$Bb)(t,(d,l)=>d.rank-l.rank||(0,c.$Bf)(d.uri.path,l.uri.path)),r=[];e:for(const d of n){let l;for(const f of d){const y=(0,I.$pc)(f.uri.path);if(l!==y&&(l=y,r.push(f.uri)>=g.d))break e}}this.g.$onDidChange(p,r)});return new R.$5N(()=>{u?.dispose(),this.g.$unregisterDecorationProvider(p),this.f.delete(p)})}async $provideDecorations(a,$,p){if(!this.f.has(a))return Object.create(null);const u=Object.create(null),{provider:i,extensionDescription:o}=this.f.get(a);return await Promise.all($.map(async t=>{try{const{uri:n,id:r}=t,d=await Promise.resolve(i.provideFileDecoration(s.URI.revive(n),p));if(!d)return;try{R.$uP.validate(d),d.badge&&typeof d.badge!="string"&&(0,E.$wH)(o,"codiconDecoration"),u[r]=[d.propagate,d.tooltip,d.badge,d.color]}catch(l){this.h.warn(`INVALID decoration from extension '${o.identifier.value}': ${l}`)}}catch(n){this.h.error(n)}})),u}};e.$Orc=P,e.$Orc=P=g=Ze([qe(0,O.$DQ),qe(1,C.$dk)],P),e.$Prc=(0,A.$Ii)("IExtHostDecorations")}),define(Re[292],Ce([1,0,12,2,9,6,14,20,13]),function(ge,e,s,h,R,A,O,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rrc=void 0;class c{static{this.a=0}constructor(E,g,P){this.d=g,this.e=P,this.b=new Map,this.c=E.getProxy(A.$3N.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(E,g){if(Object.keys(O.Schemas).indexOf(E)>=0)throw new Error(`scheme '${E}' already registered`);const P=c.a++;this.b.set(P,g),this.c.$registerTextContentProvider(P,E);let b;if(typeof g.onDidChange=="function"){let a;b=g.onDidChange(async $=>{if($.scheme!==E){this.e.warn(`Provider for scheme '${E}' is firing event for schema '${$.scheme}' which will be IGNORED`);return}if(!this.d.getDocument($))return;a&&await a;const p=this.$provideTextDocumentContent(P,$).then(async u=>{if(!u&&typeof u!="string")return;const i=this.d.getDocument($);if(!i)return;const o=(0,m.$vf)(u);if(!i.equalLines(o))return this.c.$onVirtualDocumentChange($,u)}).catch(s.$2).finally(()=>{a===p&&(a=void 0)});a=p})}return new R.$5N(()=>{this.b.delete(P)&&this.c.$unregisterTextContentProvider(P),b&&(b.dispose(),b=void 0)})}$provideTextDocumentContent(E,g){const P=this.b.get(E);return P?Promise.resolve(P.provideTextDocumentContent(h.URI.revive(g),C.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${g.scheme}`))}}e.$Rrc=c}),define(Re[167],Ce([1,0,67,14,13,208,142,9,18]),function(ge,e,s,h,R,A,O,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HQ=e.$GQ=void 0,e.$FQ=I;const c=new Map;function I(b,a){a?c.set(b,a):c.delete(b)}function E(b){return c.get(b)}class g extends A.$ww{constructor(a,$,p,u,i,o,t){super($,p,u,i),this.o=a,this.p=o,this.q=t,this.n=!1}dispose(){(0,s.ok)(!this.n),this.n=!0,this.q=!1}equalLines(a){return(0,m.$wb)(this.b,a)}get document(){if(!this.m){const a=this;this.m={get uri(){return a.a},get fileName(){return a.a.fsPath},get isUntitled(){return a.a.scheme===h.Schemas.untitled},get languageId(){return a.p},get version(){return a.d},get isClosed(){return a.n},get isDirty(){return a.q},save(){return a.r()},getText($){return $?a.s($):a.getText()},get eol(){return a.c===`
`?C.EndOfLine.LF:C.EndOfLine.CRLF},get lineCount(){return a.b.length},lineAt($){return a.t($)},offsetAt($){return a.u($)},positionAt($){return a.v($)},validateRange($){return a.w($)},validatePosition($){return a.x($)},getWordRangeAtPosition($,p){return a.y($,p)},[Symbol.for("debug.description")](){return`TextDocument(${a.a.toString()})`}}}return Object.freeze(this.m)}_acceptLanguageId(a){(0,s.ok)(!this.n),this.p=a}_acceptIsDirty(a){(0,s.ok)(!this.n),this.q=a}r(){return this.n?Promise.reject(new Error("Document has been closed")):this.o.$trySaveDocument(this.a)}s(a){const $=this.w(a);if($.isEmpty)return"";if($.isSingleLine)return this.b[$.start.line].substring($.start.character,$.end.character);const p=this.c,u=$.start.line,i=$.end.line,o=[];o.push(this.b[u].substring($.start.character));for(let t=u+1;t<i;t++)o.push(this.b[t]);return o.push(this.b[i].substring(0,$.end.character)),o.join(p)}t(a){let $;if(a instanceof C.$6N?$=a.line:typeof a=="number"&&($=a),typeof $!="number"||$<0||$>=this.b.length||Math.floor($)!==$)throw new Error("Illegal value for `line`");return new P($,this.b[$],$===this.b.length-1)}u(a){return a=this.x(a),this.h(),this.f.getPrefixSum(a.line-1)+a.character}v(a){a=Math.floor(a),a=Math.max(0,a),this.h();const $=this.f.getIndexOf(a),p=this.b[$.index].length;return new C.$6N($.index,Math.min($.remainder,p))}w(a){if(!(a instanceof C.$7N))throw new Error("Invalid argument");const $=this.x(a.start),p=this.x(a.end);return $===a.start&&p===a.end?a:new C.$7N($.line,$.character,p.line,p.character)}x(a){if(!(a instanceof C.$6N))throw new Error("Invalid argument");if(this.b.length===0)return a.with(0,0);let{line:$,character:p}=a,u=!1;if($<0)$=0,p=0,u=!0;else if($>=this.b.length)$=this.b.length-1,p=this.b[$].length,u=!0;else{const i=this.b[$].length;p<0?(p=0,u=!0):p>i&&(p=i,u=!0)}return u?new C.$6N($,p):a}y(a,$){const p=this.x(a);if(!$)$=E(this.p);else if((0,R.$uf)($))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${$.source}' because it matches the empty string.`);const u=(0,O.$wt)(p.character+1,(0,O.$ut)($),this.b[p.line],0);if(u)return new C.$7N(p.line,u.startColumn-1,p.line,u.endColumn-1)}}e.$GQ=g;class P{constructor(a,$,p){this.a=a,this.b=$,this.c=p}get lineNumber(){return this.a}get text(){return this.b}get range(){return new C.$7N(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new C.$7N(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$HQ=P}),define(Re[293],Ce([1,0,6,9]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Urc=void 0;class R{constructor(O){this.a=new Map,this.b=0,this.c=O.getProxy(s.$3N.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(O,C,m){if(this.a.size===0)throw new Error("No embedding vector providers registered");const c=this.a.get(O);if(!c)throw new Error("Embedding vector provider not found");const I=await c.provideEmbeddingVector(C,m);if(!I)throw new Error("Embedding vector provider returned undefined");return I}registerEmbeddingVectorProvider(O,C,m){const c=this.b;return this.b++,this.a.set(c,m),this.c.$registerAiEmbeddingVectorProvider(C,c),new h.$5N(()=>{this.c.$unregisterAiEmbeddingVectorProvider(c),this.a.delete(c)})}}e.$Urc=R}),define(Re[77],Ce([1,0,6,27,9,21,5,19,64,3,7,22,14]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$1qc=e.$Zqc=void 0,h=Ue(h);let b=P=class{constructor($,p){this.b=new Map,this.c=new I.$Rh,this.a=$.getProxy(s.$3N.MainThreadFileSystem);const u=this;this.value=Object.freeze({async stat(i){try{let o;const t=u.b.get(i.scheme);return t?(await u.a.$ensureActivation(i.scheme),o=await t.impl.stat(i)):o=await u.a.$stat(i),{type:o.type,ctime:o.ctime,mtime:o.mtime,size:o.size,permissions:o.permissions===h.FilePermission.Readonly?1:void 0}}catch(o){P.e(o)}},async readDirectory(i){try{const o=u.b.get(i.scheme);return o?(await u.a.$ensureActivation(i.scheme),(await o.impl.readDirectory(i)).slice()):await u.a.$readdir(i)}catch(o){return P.e(o)}},async createDirectory(i){try{const o=u.b.get(i.scheme);return o&&!o.isReadonly?(await u.a.$ensureActivation(i.scheme),await u.d(o.impl,o.extUri,i)):await u.a.$mkdir(i)}catch(o){return P.e(o)}},async readFile(i){try{const o=u.b.get(i.scheme);return o?(await u.a.$ensureActivation(i.scheme),(await o.impl.readFile(i)).slice()):(await u.a.$readFile(i)).buffer}catch(o){return P.e(o)}},async writeFile(i,o){try{const t=u.b.get(i.scheme);return t&&!t.isReadonly?(await u.a.$ensureActivation(i.scheme),await u.d(t.impl,t.extUri,t.extUri.dirname(i)),await u.c.queueFor(i,()=>Promise.resolve(t.impl.writeFile(i,o,{create:!0,overwrite:!0})))):await u.a.$writeFile(i,A.$Qe.wrap(o))}catch(t){return P.e(t)}},async delete(i,o){try{const t=u.b.get(i.scheme);return t&&!t.isReadonly&&!o?.useTrash?(await u.a.$ensureActivation(i.scheme),await t.impl.delete(i,{recursive:!1,...o})):await u.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...o})}catch(t){return P.e(t)}},async rename(i,o,t){try{return await u.a.$rename(i,o,{overwrite:!1,...t})}catch(n){return P.e(n)}},async copy(i,o,t){try{return await u.a.$copy(i,o,{overwrite:!1,...t})}catch(n){return P.e(n)}},isWritableFileSystem(i){const o=p.getCapabilities(i);if(typeof o=="number")return!(o&h.FileSystemProviderCapabilities.Readonly)}})}async d($,p,u){const i=[];for(;!p.isEqual(u,p.dirname(u));)try{if(!((await $.stat(u)).type&h.FileType.Directory))throw R.$lP.FileExists(`Unable to create folder '${u.scheme===g.Schemas.file?u.fsPath:u.toString(!0)}' that already exists but is not a directory`);break}catch(o){if(h.$tl(o)!==h.FileSystemProviderErrorCode.FileNotFound)throw o;i.push(p.basename(u)),u=p.dirname(u)}for(let o=i.length-1;o>=0;o--){u=p.joinPath(u,i[o]);try{await $.createDirectory(u)}catch(t){if(h.$tl(t)!==h.FileSystemProviderErrorCode.FileExists)throw t}}}static e($){if($ instanceof R.$lP)throw $;if($ instanceof h.$pl)switch($.code){case h.FileSystemProviderErrorCode.FileExists:throw R.$lP.FileExists($.message);case h.FileSystemProviderErrorCode.FileNotFound:throw R.$lP.FileNotFound($.message);case h.FileSystemProviderErrorCode.FileNotADirectory:throw R.$lP.FileNotADirectory($.message);case h.FileSystemProviderErrorCode.FileIsADirectory:throw R.$lP.FileIsADirectory($.message);case h.FileSystemProviderErrorCode.NoPermissions:throw R.$lP.NoPermissions($.message);case h.FileSystemProviderErrorCode.Unavailable:throw R.$lP.Unavailable($.message);default:throw new R.$lP($.message,$.name)}if(!($ instanceof Error))throw new R.$lP(String($));if($.name==="ENOPRO"||$.message.includes("ENOPRO"))throw R.$lP.Unavailable($.message);switch($.name){case h.FileSystemProviderErrorCode.FileExists:throw R.$lP.FileExists($.message);case h.FileSystemProviderErrorCode.FileNotFound:throw R.$lP.FileNotFound($.message);case h.FileSystemProviderErrorCode.FileNotADirectory:throw R.$lP.FileNotADirectory($.message);case h.FileSystemProviderErrorCode.FileIsADirectory:throw R.$lP.FileIsADirectory($.message);case h.FileSystemProviderErrorCode.NoPermissions:throw R.$lP.NoPermissions($.message);case h.FileSystemProviderErrorCode.Unavailable:throw R.$lP.Unavailable($.message);default:throw new R.$lP($.message,$.name)}}addFileSystemProvider($,p,u){return this.b.set($,{impl:p,extUri:u?.isCaseSensitive?E.$_g:E.$bh,isReadonly:!!u?.isReadonly}),(0,c.$Vc)(()=>this.b.delete($))}getFileSystemProviderExtUri($){return this.b.get($)?.extUri??E.$_g}};e.$Zqc=b,e.$Zqc=b=P=Ze([qe(0,C.$DQ),qe(1,m.$Dqc)],b),e.$1qc=(0,O.$Ii)("IExtHostConsumerFileSystem")}),define(Re[98],Ce([1,0,5,29,11,77,2]),function(ge,e,s,h,R,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3qc=e.$2qc=void 0,e.$2qc=(0,s.$Ii)("IExtensionStoragePaths");let C=class{constructor(c,I,E){this.d=I,this.f=E,this.a=c.workspace??void 0,this.b=c.environment,this.whenReady=this.h().then(g=>this.c=g)}async g(c){return O.URI.joinPath(this.b.workspaceStorageHome,c)}async h(){if(!this.a)return Promise.resolve(void 0);const c=this.a.id,I=await this.g(c);try{return await this.f.value.stat(I),this.d.trace("[ExtHostStorage] storage dir already exists",I),I}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",I),await this.f.value.createDirectory(I),await this.f.value.writeFile(O.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:O.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),I}catch(E){this.d.error("[ExtHostStorage]",E);return}}workspaceValue(c){if(this.c)return O.URI.joinPath(this.c,c.identifier.value)}globalValue(c){return O.URI.joinPath(this.b.globalStorageHome,c.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$3qc=C,e.$3qc=C=Ze([qe(0,h.$TQ),qe(1,R.$dk),qe(2,A.$1qc)],C)}),define(Re[294],Ce([1,0,9,19,4]),function(ge,e,s,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Esc=void 0;let A=class{constructor(C){this.a=new s.$vP(s.ColorThemeKind.Dark),this.b=new R.$oe}get activeColorTheme(){return this.a}$onColorThemeChange(C){let m;switch(C){case"light":m=s.ColorThemeKind.Light;break;case"hcDark":m=s.ColorThemeKind.HighContrast;break;case"hcLight":m=s.ColorThemeKind.HighContrastLight;break;default:m=s.ColorThemeKind.Dark}this.a=new s.$vP(m),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Esc=A,e.$Esc=A=Ze([qe(0,h.$DQ)],A)}),define(Re[78],Ce([1,0,20,4,3,8,5,11,93,6,29,19,9]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QGb=e.$PGb=e.TunnelDtoConverter=void 0,A=Ue(A),g=Ue(g);class P extends m.$Vw{}var b;(function($){function p(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?m.TunnelPrivacyId.Public:m.TunnelPrivacyId.Private),protocol:i.protocol}}$.fromApiTunnel=p;function u(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==m.TunnelPrivacyId.ConstantPrivate&&i.privacy!==m.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}$.fromServiceTunnel=u})(b||(e.TunnelDtoConverter=b={})),e.$PGb=(0,O.$Ii)("IExtHostTunnelService");let a=class extends R.$Xc{constructor(p,u,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new h.$oe,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=p.getProxy(c.$3N.MainThreadTunnelService)}async openTunnel(p,u){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${p.identifier.value} called openTunnel API for ${u.remoteAddress.host}:${u.remoteAddress.port}.`);const i=await this.a.$openTunnel(u,p.displayName);if(i){const o=new P(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(o),o}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(p,u){p.portRange===void 0&&p.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:p,provider:u}),this.a.$registerPortsAttributesProvider(p,i),new g.$5N(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(p,u,i,o,t){const n=[];for(const d of p){const l=this.r.get(d);if(!l)return[];n.push(...await Promise.all(u.map(async f=>{let y;try{y=await l.provider.providePortAttributes({port:f,pid:i,commandLine:o},t)}catch{y=await l.provider.providePortAttributes(f,i,o,t)}return{providedAttributes:y,port:f}})))}const r=n.filter(d=>!!d.providedAttributes);return r.length>0?r.map(d=>({autoForwardAction:d.providedAttributes.autoForwardAction,port:d.port})):[]}async $registerCandidateFinder(p){}registerTunnelProvider(p,u){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(o,t)=>await p.provideTunnel(o,t,s.CancellationToken.None)??void 0;const i=u.tunnelFeatures?{elevation:!!u.tunnelFeatures?.elevation,privacyOptions:u.tunnelFeatures?.privacyOptions,protocol:u.tunnelFeatures.protocol===void 0?!0:u.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,R.$Vc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(p,u){if(p){p.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(p.candidatePortSource),p.showCandidatePort&&(this.f=p.showCandidatePort,this.a.$setCandidateFilter());const i=p.tunnelFactory??(u?this.w(u):void 0);if(i){this.b=i;let o=p.tunnelFeatures?.privacyOptions??[];p.tunnelFeatures?.public&&o.length===0&&(o=[{id:"private",label:A.localize(2716,null),themeIcon:"lock"},{id:"public",label:A.localize(2717,null),themeIcon:"eye"}]);const t=p.tunnelFeatures?{elevation:!!p.tunnelFeatures?.elevation,public:!!p.tunnelFeatures?.public,privacyOptions:o,protocol:!0}:void 0;this.a.$setTunnelProvider(t)}}else this.b=void 0;return(0,R.$Vc)(()=>{this.b=void 0})}w(p){}async $closeTunnel(p,u){if(this.g.has(p.host)){const i=this.g.get(p.host);i.has(p.port)&&(u&&i.get(p.port).disposeListener.dispose(),await i.get(p.port).tunnel.dispose(),i.delete(p.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(p,u){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(p,u);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const o=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),o===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(p.remoteAddress.host)||this.g.set(p.remoteAddress.host,new Map);const t=this.B(o.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(o.remoteAddress))));return this.g.get(p.remoteAddress.host).set(p.remoteAddress.port,{tunnel:o,disposeListener:t}),b.fromApiTunnel(o)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(p){const u=await Promise.all(p.map(o=>this.f(o.host,o.port,o.detail??""))),i=p.filter((o,t)=>u[t]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${p.map(o=>o.port).join(", ")} to ${i.map(o=>o.port).join(", ")}`),i}};e.$QGb=a,e.$QGb=a=Ze([qe(0,E.$DQ),qe(1,I.$TQ),qe(2,C.$dk)],a)}),define(Re[15],Ce([1,0,18,21,192,81,86,28,181,38,103,24,186,22,51,17,2,113,30,110,88,58,147,90,158,155,156,272,119,126,75,76,269,9]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P,b,a,$,p,u,i,o,t,n,r,d,l,f,y,k,S,D,T,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.LanguageModelToolResult=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatLanguageModelToolReference=e.ChatPromptReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseCodeCitationPart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseMovePart=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$AQ=x,e.$BQ=ie,e.$CQ=me,O=Ue(O),m=Ue(m),u=Ue(u),i=Ue(i),o=Ue(o),y=Ue(y),S=Ue(S),w=Ue(w);var M;(function(De){function Me(te){const{selectionStartLineNumber:Le,selectionStartColumn:Qe,positionLineNumber:nt,positionColumn:Xe}=te,mt=new w.$6N(Le-1,Qe-1),Tt=new w.$6N(nt-1,Xe-1);return new w.$8N(mt,Tt)}De.to=Me;function ve(te){const{anchor:Le,active:Qe}=te;return{selectionStartLineNumber:Le.line+1,selectionStartColumn:Le.character+1,positionLineNumber:Qe.line+1,positionColumn:Qe.character+1}}De.from=ve})(M||(e.Selection=M={}));var L;(function(De){function Me(te){if(!te)return;const{start:Le,end:Qe}=te;return{startLineNumber:Le.line+1,startColumn:Le.character+1,endLineNumber:Qe.line+1,endColumn:Qe.character+1}}De.from=Me;function ve(te){if(!te)return;const{startLineNumber:Le,startColumn:Qe,endLineNumber:nt,endColumn:Xe}=te;return new w.$7N(Le-1,Qe-1,nt-1,Xe-1)}De.to=ve})(L||(e.Range=L={}));var N;(function(De){function Me(te){return{uri:te.uri,range:L.from(te.range)}}De.from=Me;function ve(te){return new w.$gO($.URI.revive(te.uri),L.to(te.range))}De.to=ve})(N||(e.Location=N={}));var F;(function(De){function Me(ve){switch(ve){case i.StandardTokenType.Comment:return w.StandardTokenType.Comment;case i.StandardTokenType.Other:return w.StandardTokenType.Other;case i.StandardTokenType.RegEx:return w.StandardTokenType.RegEx;case i.StandardTokenType.String:return w.StandardTokenType.String}}De.to=Me})(F||(e.TokenType=F={}));var V;(function(De){function Me(te){return new w.$6N(te.lineNumber-1,te.column-1)}De.to=Me;function ve(te){return{lineNumber:te.line+1,column:te.character+1}}De.from=ve})(V||(e.Position=V={}));var j;(function(De){function Me(Le,Qe,nt){return(0,s.$Jb)((0,s.$4b)(Le).map(Xe=>ve(Xe,Qe,nt)))}De.from=Me;function ve(Le,Qe,nt){if(typeof Le=="string")return{$serialized:!0,language:Le,isBuiltin:nt?.isBuiltin};if(Le)return{$serialized:!0,language:Le.language,scheme:te(Le.scheme,Qe),pattern:Je.from(Le.pattern)??void 0,exclusive:Le.exclusive,notebookType:Le.notebookType,isBuiltin:nt?.isBuiltin}}function te(Le,Qe){return Qe&&typeof Le=="string"?Qe.transformOutgoingScheme(Le):Le}})(j||(e.DocumentSelector=j={}));var U;(function(De){function Me(te){switch(te){case w.DiagnosticTag.Unnecessary:return n.MarkerTag.Unnecessary;case w.DiagnosticTag.Deprecated:return n.MarkerTag.Deprecated}}De.from=Me;function ve(te){switch(te){case n.MarkerTag.Unnecessary:return w.DiagnosticTag.Unnecessary;case n.MarkerTag.Deprecated:return w.DiagnosticTag.Deprecated;default:return}}De.to=ve})(U||(e.DiagnosticTag=U={}));var z;(function(De){function Me(te){let Le;return te.code&&((0,a.$hg)(te.code)||(0,a.$lg)(te.code)?Le=String(te.code):Le={value:String(te.code.value),target:te.code.target}),{...L.from(te.range),message:te.message,source:te.source,code:Le,severity:W.from(te.severity),relatedInformation:te.relatedInformation&&te.relatedInformation.map(_.from),tags:Array.isArray(te.tags)?(0,s.$Jb)(te.tags.map(U.from)):void 0}}De.from=Me;function ve(te){const Le=new w.$iO(L.to(te),te.message,W.to(te.severity));return Le.source=te.source,Le.code=(0,a.$hg)(te.code)?te.code:te.code?.value,Le.relatedInformation=te.relatedInformation&&te.relatedInformation.map(_.to),Le.tags=te.tags&&(0,s.$Jb)(te.tags.map(U.to)),Le}De.to=ve})(z||(e.Diagnostic=z={}));var _;(function(De){function Me(te){return{...L.from(te.location.range),message:te.message,resource:te.location.uri}}De.from=Me;function ve(te){return new w.$hO(new w.$gO(te.resource,L.to(te)),te.message)}De.to=ve})(_||(e.DiagnosticRelatedInformation=_={}));var W;(function(De){function Me(te){switch(te){case w.DiagnosticSeverity.Error:return n.MarkerSeverity.Error;case w.DiagnosticSeverity.Warning:return n.MarkerSeverity.Warning;case w.DiagnosticSeverity.Information:return n.MarkerSeverity.Info;case w.DiagnosticSeverity.Hint:return n.MarkerSeverity.Hint}return n.MarkerSeverity.Error}De.from=Me;function ve(te){switch(te){case n.MarkerSeverity.Info:return w.DiagnosticSeverity.Information;case n.MarkerSeverity.Warning:return w.DiagnosticSeverity.Warning;case n.MarkerSeverity.Error:return w.DiagnosticSeverity.Error;case n.MarkerSeverity.Hint:return w.DiagnosticSeverity.Hint;default:return w.DiagnosticSeverity.Error}}De.to=ve})(W||(e.DiagnosticSeverity=W={}));var B;(function(De){function Me(te){return typeof te=="number"&&te>=w.ViewColumn.One?te-1:te===w.ViewColumn.Beside?v.$PE:v.$OE}De.from=Me;function ve(te){if(typeof te=="number"&&te>=0)return te+1;throw new Error("invalid 'EditorGroupColumn'")}De.to=ve})(B||(e.ViewColumn=B={}));function Y(De){return typeof De.range<"u"}function x(De){return De.length===0?!0:!!Y(De[0])}var oe;(function(De){function Me(Xe){return Xe.map(De.from)}De.fromMany=Me;function ve(Xe){return Xe&&typeof Xe=="object"&&typeof Xe.language=="string"&&typeof Xe.value=="string"}function te(Xe){let mt;if(ve(Xe)){const{language:Vt,value:Wt}=Xe;mt={value:"```"+Vt+`
`+Wt+"\n```\n"}}else w.$wO.isMarkdownString(Xe)?mt={value:Xe.value,isTrusted:Xe.isTrusted,supportThemeIcons:Xe.supportThemeIcons,supportHtml:Xe.supportHtml,baseUri:Xe.baseUri}:typeof Xe=="string"?mt={value:Xe}:mt={value:""};const Tt=Object.create(null);mt.uris=Tt;const xt=({href:Vt})=>{try{let Wt=$.URI.parse(Vt,!0);Wt=Wt.with({query:Le(Wt.query,Tt)}),Tt[Vt]=Wt}catch{}return""};return m.marked.walkTokens(m.marked.lexer(mt.value),Vt=>{Vt.type==="link"?xt({href:Vt.href}):Vt.type==="image"&&typeof Vt.href=="string"&&xt(O.$cl(Vt.href))}),mt}De.from=te;function Le(Xe,mt){if(!Xe)return Xe;let Tt;try{Tt=(0,c.$ei)(Xe)}catch{}if(!Tt)return Xe;let xt=!1;return Tt=(0,E.$ko)(Tt,Vt=>{if($.URI.isUri(Vt)){const Wt=`__uri_${Math.random().toString(16).slice(2,8)}`;return mt[Wt]=Vt,xt=!0,Wt}else return}),xt?JSON.stringify(Tt):Xe}function Qe(Xe){const mt=new w.$wO(Xe.value,Xe.supportThemeIcons);return mt.isTrusted=Xe.isTrusted,mt.supportHtml=Xe.supportHtml,mt.baseUri=Xe.baseUri?$.URI.from(Xe.baseUri):void 0,mt}De.to=Qe;function nt(Xe){if(Xe)return typeof Xe=="string"?Xe:De.from(Xe)}De.fromStrict=nt})(oe||(e.MarkdownString=oe={}));function ie(De){return x(De)?De.map(Me=>({range:L.from(Me.range),hoverMessage:Array.isArray(Me.hoverMessage)?oe.fromMany(Me.hoverMessage):Me.hoverMessage?oe.from(Me.hoverMessage):void 0,renderOptions:Me.renderOptions})):De.map(Me=>({range:L.from(Me)}))}function me(De){return typeof De>"u"?De:typeof De=="string"?$.URI.file(De):De}var ue;(function(De){function Me(ve){return typeof ve>"u"?ve:{contentText:ve.contentText,contentIconPath:ve.contentIconPath?me(ve.contentIconPath):void 0,border:ve.border,borderColor:ve.borderColor,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,color:ve.color,backgroundColor:ve.backgroundColor,margin:ve.margin,width:ve.width,height:ve.height}}De.from=Me})(ue||(e.ThemableDecorationAttachmentRenderOptions=ue={}));var X;(function(De){function Me(ve){return typeof ve>"u"?ve:{backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?me(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?ue.from(ve.before):void 0,after:ve.after?ue.from(ve.after):void 0}}De.from=Me})(X||(e.ThemableDecorationRenderOptions=X={}));var q;(function(De){function Me(ve){if(typeof ve>"u")return ve;switch(ve){case w.DecorationRangeBehavior.OpenOpen:return t.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case w.DecorationRangeBehavior.ClosedClosed:return t.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case w.DecorationRangeBehavior.OpenClosed:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case w.DecorationRangeBehavior.ClosedOpen:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}De.from=Me})(q||(e.DecorationRangeBehavior=q={}));var se;(function(De){function Me(ve){return{isWholeLine:ve.isWholeLine,rangeBehavior:ve.rangeBehavior?q.from(ve.rangeBehavior):void 0,overviewRulerLane:ve.overviewRulerLane,light:ve.light?X.from(ve.light):void 0,dark:ve.dark?X.from(ve.dark):void 0,backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?me(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?ue.from(ve.before):void 0,after:ve.after?ue.from(ve.after):void 0}}De.from=Me})(se||(e.DecorationRenderOptions=se={}));var be;(function(De){function Me(te){return{text:te.newText,eol:te.newEol&&ke.from(te.newEol),range:L.from(te.range)}}De.from=Me;function ve(te){const Le=new w.$bO(L.to(te.range),te.text);return Le.newEol=typeof te.eol>"u"?void 0:ke.to(te.eol),Le}De.to=ve})(be||(e.TextEdit=be={}));var ae;(function(De){function Me(te,Le){const Qe={edits:[]};if(te instanceof w.$eO){const nt=new C.$Ec;for(const Xe of te._allEntries())Xe._type===w.FileEditType.File&&$.URI.isUri(Xe.to)&&Xe.from===void 0&&nt.add(Xe.to);for(const Xe of te._allEntries())if(Xe._type===w.FileEditType.File){let mt;Xe.options?.contents&&(ArrayBuffer.isView(Xe.options.contents)?mt={type:"base64",value:(0,h.$$e)(h.$Qe.wrap(Xe.options.contents))}:mt={type:"dataTransferItem",id:Xe.options.contents._itemId}),Qe.edits.push({oldResource:Xe.from,newResource:Xe.to,options:{...Xe.options,contents:mt},metadata:Xe.metadata})}else Xe._type===w.FileEditType.Text?Qe.edits.push({resource:Xe.uri,textEdit:be.from(Xe.edit),versionId:nt.has(Xe.uri)?void 0:Le?.getTextDocumentVersion(Xe.uri),metadata:Xe.metadata}):Xe._type===w.FileEditType.Snippet?Qe.edits.push({resource:Xe.uri,textEdit:{range:L.from(Xe.range),text:Xe.edit.value,insertAsSnippet:!0},versionId:nt.has(Xe.uri)?void 0:Le?.getTextDocumentVersion(Xe.uri),metadata:Xe.metadata}):Xe._type===w.FileEditType.Cell?Qe.edits.push({metadata:Xe.metadata,resource:Xe.uri,cellEdit:Xe.edit,notebookMetadata:Xe.notebookMetadata,notebookVersionId:Le?.getNotebookDocumentVersion(Xe.uri)}):Xe._type===w.FileEditType.CellReplace&&Qe.edits.push({metadata:Xe.metadata,resource:Xe.uri,notebookVersionId:Le?.getNotebookDocumentVersion(Xe.uri),cellEdit:{editType:S.CellEditType.Replace,index:Xe.index,count:Xe.count,cells:Xe.cells.map(tt.from)}})}return Qe}De.from=Me;function ve(te){const Le=new w.$eO,Qe=new C.$Dc;for(const nt of te.edits)if(nt.textEdit){const Xe=nt,mt=$.URI.revive(Xe.resource),Tt=L.to(Xe.textEdit.range),xt=Xe.textEdit.text,Vt=Xe.textEdit.insertAsSnippet;let Wt;Vt?Wt=w.$dO.replace(Tt,new w.$fO(xt)):Wt=w.$bO.replace(Tt,xt);const Li=Qe.get(mt);Li?Li.push(Wt):Qe.set(mt,[Wt])}else Le.renameFile($.URI.revive(nt.oldResource),$.URI.revive(nt.newResource),nt.options);for(const[nt,Xe]of Qe)Le.set(nt,Xe);return Le}De.to=ve})(ae||(e.WorkspaceEdit=ae={}));var we;(function(De){const Me=Object.create(null);Me[w.SymbolKind.File]=o.SymbolKind.File,Me[w.SymbolKind.Module]=o.SymbolKind.Module,Me[w.SymbolKind.Namespace]=o.SymbolKind.Namespace,Me[w.SymbolKind.Package]=o.SymbolKind.Package,Me[w.SymbolKind.Class]=o.SymbolKind.Class,Me[w.SymbolKind.Method]=o.SymbolKind.Method,Me[w.SymbolKind.Property]=o.SymbolKind.Property,Me[w.SymbolKind.Field]=o.SymbolKind.Field,Me[w.SymbolKind.Constructor]=o.SymbolKind.Constructor,Me[w.SymbolKind.Enum]=o.SymbolKind.Enum,Me[w.SymbolKind.Interface]=o.SymbolKind.Interface,Me[w.SymbolKind.Function]=o.SymbolKind.Function,Me[w.SymbolKind.Variable]=o.SymbolKind.Variable,Me[w.SymbolKind.Constant]=o.SymbolKind.Constant,Me[w.SymbolKind.String]=o.SymbolKind.String,Me[w.SymbolKind.Number]=o.SymbolKind.Number,Me[w.SymbolKind.Boolean]=o.SymbolKind.Boolean,Me[w.SymbolKind.Array]=o.SymbolKind.Array,Me[w.SymbolKind.Object]=o.SymbolKind.Object,Me[w.SymbolKind.Key]=o.SymbolKind.Key,Me[w.SymbolKind.Null]=o.SymbolKind.Null,Me[w.SymbolKind.EnumMember]=o.SymbolKind.EnumMember,Me[w.SymbolKind.Struct]=o.SymbolKind.Struct,Me[w.SymbolKind.Event]=o.SymbolKind.Event,Me[w.SymbolKind.Operator]=o.SymbolKind.Operator,Me[w.SymbolKind.TypeParameter]=o.SymbolKind.TypeParameter;function ve(Le){return typeof Me[Le]=="number"?Me[Le]:o.SymbolKind.Property}De.from=ve;function te(Le){for(const Qe in Me)if(Me[Qe]===Le)return Number(Qe);return w.SymbolKind.Property}De.to=te})(we||(e.SymbolKind=we={}));var $e;(function(De){function Me(te){switch(te){case w.SymbolTag.Deprecated:return o.SymbolTag.Deprecated}}De.from=Me;function ve(te){switch(te){case o.SymbolTag.Deprecated:return w.SymbolTag.Deprecated}}De.to=ve})($e||(e.SymbolTag=$e={}));var pe;(function(De){function Me(te){return{name:te.name,kind:we.from(te.kind),tags:te.tags&&te.tags.map($e.from),containerName:te.containerName,location:xe.from(te.location)}}De.from=Me;function ve(te){const Le=new w.$nO(te.name,we.to(te.kind),te.containerName,xe.to(te.location));return Le.tags=te.tags&&te.tags.map($e.to),Le}De.to=ve})(pe||(e.WorkspaceSymbol=pe={}));var Ae;(function(De){function Me(te){const Le={name:te.name||"!!MISSING: name!!",detail:te.detail,range:L.from(te.range),selectionRange:L.from(te.selectionRange),kind:we.from(te.kind),tags:te.tags?.map($e.from)??[]};return te.children&&(Le.children=te.children.map(Me)),Le}De.from=Me;function ve(te){const Le=new w.$oO(te.name,te.detail,we.to(te.kind),L.to(te.range),L.to(te.selectionRange));return(0,s.$Nb)(te.tags)&&(Le.tags=te.tags.map($e.to)),te.children&&(Le.children=te.children.map(ve)),Le}De.to=ve})(Ae||(e.DocumentSymbol=Ae={}));var je;(function(De){function Me(te){const Le=new w.$sO(we.to(te.kind),te.name,te.detail||"",$.URI.revive(te.uri),L.to(te.range),L.to(te.selectionRange));return Le._sessionId=te._sessionId,Le._itemId=te._itemId,Le}De.to=Me;function ve(te,Le,Qe){if(Le=Le??te._sessionId,Qe=Qe??te._itemId,Le===void 0||Qe===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:Qe,name:te.name,detail:te.detail,kind:we.from(te.kind),uri:te.uri,range:L.from(te.range),selectionRange:L.from(te.selectionRange),tags:te.tags?.map($e.from)}}De.from=ve})(je||(e.CallHierarchyItem=je={}));var He;(function(De){function Me(ve){return new w.$tO(je.to(ve.from),ve.fromRanges.map(te=>L.to(te)))}De.to=Me})(He||(e.CallHierarchyIncomingCall=He={}));var Ye;(function(De){function Me(ve){return new w.$uO(je.to(ve.to),ve.fromRanges.map(te=>L.to(te)))}De.to=Me})(Ye||(e.CallHierarchyOutgoingCall=Ye={}));var xe;(function(De){function Me(te){return{range:te.range&&L.from(te.range),uri:te.uri}}De.from=Me;function ve(te){return new w.$gO($.URI.revive(te.uri),L.to(te.range))}De.to=ve})(xe||(e.location=xe={}));var Fe;(function(De){function Me(te){const Le=te,Qe=te;return{originSelectionRange:Le.originSelectionRange?L.from(Le.originSelectionRange):void 0,uri:Le.targetUri?Le.targetUri:Qe.uri,range:L.from(Le.targetRange?Le.targetRange:Qe.range),targetSelectionRange:Le.targetSelectionRange?L.from(Le.targetSelectionRange):void 0}}De.from=Me;function ve(te){return{targetUri:$.URI.revive(te.uri),targetRange:L.to(te.range),targetSelectionRange:te.targetSelectionRange?L.to(te.targetSelectionRange):void 0,originSelectionRange:te.originSelectionRange?L.to(te.originSelectionRange):void 0}}De.to=ve})(Fe||(e.DefinitionLink=Fe={}));var We;(function(De){function Me(te){return{range:L.from(te.range),contents:oe.fromMany(te.contents),canIncreaseVerbosity:te.canIncreaseVerbosity,canDecreaseVerbosity:te.canDecreaseVerbosity}}De.from=Me;function ve(te){const Le=te.contents.map(oe.to),Qe=L.to(te.range),nt=te.canIncreaseVerbosity,Xe=te.canDecreaseVerbosity;return new w.$kO(Le,Qe,nt,Xe)}De.to=ve})(We||(e.Hover=We={}));var Ne;(function(De){function Me(te){return{range:L.from(te.range),expression:te.expression}}De.from=Me;function ve(te){return new w.$fP(L.to(te.range),te.expression)}De.to=ve})(Ne||(e.EvaluatableExpression=Ne={}));var H;(function(De){function Me(te){if(te instanceof w.$gP)return{type:"text",range:L.from(te.range),text:te.text};if(te instanceof w.$hP)return{type:"variable",range:L.from(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};if(te instanceof w.$iP)return{type:"expression",range:L.from(te.range),expression:te.expression};throw new Error("Unknown 'InlineValue' type")}De.from=Me;function ve(te){switch(te.type){case"text":return{range:L.to(te.range),text:te.text};case"variable":return{range:L.to(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};case"expression":return{range:L.to(te.range),expression:te.expression}}}De.to=ve})(H||(e.InlineValue=H={}));var G;(function(De){function Me(te){return{frameId:te.frameId,stoppedLocation:L.from(te.stoppedLocation)}}De.from=Me;function ve(te){return new w.$jP(te.frameId,L.to(te.stoppedLocation))}De.to=ve})(G||(e.InlineValueContext=G={}));var Z;(function(De){function Me(te){return{range:L.from(te.range),kind:te.kind}}De.from=Me;function ve(te){return new w.$lO(L.to(te.range),te.kind)}De.to=ve})(Z||(e.DocumentHighlight=Z={}));var ee;(function(De){function Me(te){return{uri:te.uri,highlights:te.highlights.map(Z.from)}}De.from=Me;function ve(te){return new w.$mO($.URI.revive(te.uri),te.highlights.map(Z.to))}De.to=ve})(ee||(e.MultiDocumentHighlight=ee={}));var le;(function(De){function Me(ve){switch(ve){case o.CompletionTriggerKind.TriggerCharacter:return w.CompletionTriggerKind.TriggerCharacter;case o.CompletionTriggerKind.TriggerForIncompleteCompletions:return w.CompletionTriggerKind.TriggerForIncompleteCompletions;case o.CompletionTriggerKind.Invoke:default:return w.CompletionTriggerKind.Invoke}}De.to=Me})(le||(e.CompletionTriggerKind=le={}));var ye;(function(De){function Me(ve){return{triggerKind:le.to(ve.triggerKind),triggerCharacter:ve.triggerCharacter}}De.to=Me})(ye||(e.CompletionContext=ye={}));var Te;(function(De){function Me(te){switch(te){case w.CompletionItemTag.Deprecated:return o.CompletionItemTag.Deprecated}}De.from=Me;function ve(te){switch(te){case o.CompletionItemTag.Deprecated:return w.CompletionItemTag.Deprecated}}De.to=ve})(Te||(e.CompletionItemTag=Te={}));var Ve;(function(De){const Me=new Map([[w.CompletionItemKind.Method,o.CompletionItemKind.Method],[w.CompletionItemKind.Function,o.CompletionItemKind.Function],[w.CompletionItemKind.Constructor,o.CompletionItemKind.Constructor],[w.CompletionItemKind.Field,o.CompletionItemKind.Field],[w.CompletionItemKind.Variable,o.CompletionItemKind.Variable],[w.CompletionItemKind.Class,o.CompletionItemKind.Class],[w.CompletionItemKind.Interface,o.CompletionItemKind.Interface],[w.CompletionItemKind.Struct,o.CompletionItemKind.Struct],[w.CompletionItemKind.Module,o.CompletionItemKind.Module],[w.CompletionItemKind.Property,o.CompletionItemKind.Property],[w.CompletionItemKind.Unit,o.CompletionItemKind.Unit],[w.CompletionItemKind.Value,o.CompletionItemKind.Value],[w.CompletionItemKind.Constant,o.CompletionItemKind.Constant],[w.CompletionItemKind.Enum,o.CompletionItemKind.Enum],[w.CompletionItemKind.EnumMember,o.CompletionItemKind.EnumMember],[w.CompletionItemKind.Keyword,o.CompletionItemKind.Keyword],[w.CompletionItemKind.Snippet,o.CompletionItemKind.Snippet],[w.CompletionItemKind.Text,o.CompletionItemKind.Text],[w.CompletionItemKind.Color,o.CompletionItemKind.Color],[w.CompletionItemKind.File,o.CompletionItemKind.File],[w.CompletionItemKind.Reference,o.CompletionItemKind.Reference],[w.CompletionItemKind.Folder,o.CompletionItemKind.Folder],[w.CompletionItemKind.Event,o.CompletionItemKind.Event],[w.CompletionItemKind.Operator,o.CompletionItemKind.Operator],[w.CompletionItemKind.TypeParameter,o.CompletionItemKind.TypeParameter],[w.CompletionItemKind.Issue,o.CompletionItemKind.Issue],[w.CompletionItemKind.User,o.CompletionItemKind.User]]);function ve(Qe){return Me.get(Qe)??o.CompletionItemKind.Property}De.from=ve;const te=new Map([[o.CompletionItemKind.Method,w.CompletionItemKind.Method],[o.CompletionItemKind.Function,w.CompletionItemKind.Function],[o.CompletionItemKind.Constructor,w.CompletionItemKind.Constructor],[o.CompletionItemKind.Field,w.CompletionItemKind.Field],[o.CompletionItemKind.Variable,w.CompletionItemKind.Variable],[o.CompletionItemKind.Class,w.CompletionItemKind.Class],[o.CompletionItemKind.Interface,w.CompletionItemKind.Interface],[o.CompletionItemKind.Struct,w.CompletionItemKind.Struct],[o.CompletionItemKind.Module,w.CompletionItemKind.Module],[o.CompletionItemKind.Property,w.CompletionItemKind.Property],[o.CompletionItemKind.Unit,w.CompletionItemKind.Unit],[o.CompletionItemKind.Value,w.CompletionItemKind.Value],[o.CompletionItemKind.Constant,w.CompletionItemKind.Constant],[o.CompletionItemKind.Enum,w.CompletionItemKind.Enum],[o.CompletionItemKind.EnumMember,w.CompletionItemKind.EnumMember],[o.CompletionItemKind.Keyword,w.CompletionItemKind.Keyword],[o.CompletionItemKind.Snippet,w.CompletionItemKind.Snippet],[o.CompletionItemKind.Text,w.CompletionItemKind.Text],[o.CompletionItemKind.Color,w.CompletionItemKind.Color],[o.CompletionItemKind.File,w.CompletionItemKind.File],[o.CompletionItemKind.Reference,w.CompletionItemKind.Reference],[o.CompletionItemKind.Folder,w.CompletionItemKind.Folder],[o.CompletionItemKind.Event,w.CompletionItemKind.Event],[o.CompletionItemKind.Operator,w.CompletionItemKind.Operator],[o.CompletionItemKind.TypeParameter,w.CompletionItemKind.TypeParameter],[o.CompletionItemKind.User,w.CompletionItemKind.User],[o.CompletionItemKind.Issue,w.CompletionItemKind.Issue]]);function Le(Qe){return te.get(Qe)??w.CompletionItemKind.Property}De.to=Le})(Ve||(e.CompletionItemKind=Ve={}));var Ke;(function(De){function Me(ve,te){const Le=new w.$CO(ve.label);return Le.insertText=ve.insertText,Le.kind=Ve.to(ve.kind),Le.tags=ve.tags?.map(Te.to),Le.detail=ve.detail,Le.documentation=O.$9k(ve.documentation)?oe.to(ve.documentation):ve.documentation,Le.sortText=ve.sortText,Le.filterText=ve.filterText,Le.preselect=ve.preselect,Le.commitCharacters=ve.commitCharacters,u.$Ut.isIRange(ve.range)?Le.range=L.to(ve.range):typeof ve.range=="object"&&(Le.range={inserting:L.to(ve.range.insert),replacing:L.to(ve.range.replace)}),Le.keepWhitespace=typeof ve.insertTextRules>"u"?!1:!!(ve.insertTextRules&o.CompletionItemInsertTextRule.KeepWhitespace),typeof ve.insertTextRules<"u"&&ve.insertTextRules&o.CompletionItemInsertTextRule.InsertAsSnippet?Le.insertText=new w.$fO(ve.insertText):(Le.insertText=ve.insertText,Le.textEdit=Le.range instanceof w.$7N?new w.$bO(Le.range,Le.insertText):void 0),ve.additionalTextEdits&&ve.additionalTextEdits.length>0&&(Le.additionalTextEdits=ve.additionalTextEdits.map(Qe=>be.to(Qe))),Le.command=te&&ve.command?te.fromInternal(ve.command):void 0,Le}De.to=Me})(Ke||(e.CompletionItem=Ke={}));var rt;(function(De){function Me(te){if(typeof te.label!="string"&&!Array.isArray(te.label))throw new TypeError("Invalid label");return{label:te.label,documentation:oe.fromStrict(te.documentation)}}De.from=Me;function ve(te){return{label:te.label,documentation:O.$9k(te.documentation)?oe.to(te.documentation):te.documentation}}De.to=ve})(rt||(e.ParameterInformation=rt={}));var ot;(function(De){function Me(te){return{label:te.label,documentation:oe.fromStrict(te.documentation),parameters:Array.isArray(te.parameters)?te.parameters.map(rt.from):[],activeParameter:te.activeParameter}}De.from=Me;function ve(te){return{label:te.label,documentation:O.$9k(te.documentation)?oe.to(te.documentation):te.documentation,parameters:Array.isArray(te.parameters)?te.parameters.map(rt.to):[],activeParameter:te.activeParameter}}De.to=ve})(ot||(e.SignatureInformation=ot={}));var ut;(function(De){function Me(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(ot.from):[]}}De.from=Me;function ve(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(ot.to):[]}}De.to=ve})(ut||(e.SignatureHelp=ut={}));var at;(function(De){function Me(ve,te){const Le=new w.$BO(V.to(te.position),typeof te.label=="string"?te.label:te.label.map(lt.to.bind(void 0,ve)),te.kind&&$t.to(te.kind));return Le.textEdits=te.textEdits&&te.textEdits.map(be.to),Le.tooltip=O.$9k(te.tooltip)?oe.to(te.tooltip):te.tooltip,Le.paddingLeft=te.paddingLeft,Le.paddingRight=te.paddingRight,Le}De.to=Me})(at||(e.InlayHint=at={}));var lt;(function(De){function Me(ve,te){const Le=new w.$AO(te.label);return Le.tooltip=O.$9k(te.tooltip)?oe.to(te.tooltip):te.tooltip,o.Command.is(te.command)&&(Le.command=ve.fromInternal(te.command)),te.location&&(Le.location=xe.to(te.location)),Le}De.to=Me})(lt||(e.InlayHintLabelPart=lt={}));var $t;(function(De){function Me(te){return te}De.from=Me;function ve(te){return te}De.to=ve})($t||(e.InlayHintKind=$t={}));var it;(function(De){function Me(te){return{range:L.from(te.range),url:te.target,tooltip:te.tooltip}}De.from=Me;function ve(te){let Le;if(te.url)try{Le=typeof te.url=="string"?$.URI.parse(te.url,!0):$.URI.revive(te.url)}catch{}const Qe=new w.$HO(L.to(te.range),Le);return Qe.tooltip=te.tooltip,Qe}De.to=ve})(it||(e.DocumentLink=it={}));var Ie;(function(De){function Me(te){const Le=new w.$KO(te.label);return te.textEdit&&(Le.textEdit=be.to(te.textEdit)),te.additionalTextEdits&&(Le.additionalTextEdits=te.additionalTextEdits.map(Qe=>be.to(Qe))),Le}De.to=Me;function ve(te){return{label:te.label,textEdit:te.textEdit?be.from(te.textEdit):void 0,additionalTextEdits:te.additionalTextEdits?te.additionalTextEdits.map(Le=>be.from(Le)):void 0}}De.from=ve})(Ie||(e.ColorPresentation=Ie={}));var re;(function(De){function Me(te){return new w.$IO(te[0],te[1],te[2],te[3])}De.to=Me;function ve(te){return[te.red,te.green,te.blue,te.alpha]}De.from=ve})(re||(e.Color=re={}));var ce;(function(De){function Me(te){return{range:L.from(te.range)}}De.from=Me;function ve(te){return new w.$rO(L.to(te.range))}De.to=ve})(ce||(e.SelectionRange=ce={}));var Se;(function(De){function Me(ve){switch(ve){case l.SaveReason.AUTO:return w.TextDocumentSaveReason.AfterDelay;case l.SaveReason.EXPLICIT:return w.TextDocumentSaveReason.Manual;case l.SaveReason.FOCUS_CHANGE:case l.SaveReason.WINDOW_CHANGE:return w.TextDocumentSaveReason.FocusOut}}De.to=Me})(Se||(e.TextDocumentSaveReason=Se={}));var de;(function(De){function Me(te){switch(te){case w.TextEditorLineNumbersStyle.Off:return p.RenderLineNumbersType.Off;case w.TextEditorLineNumbersStyle.Relative:return p.RenderLineNumbersType.Relative;case w.TextEditorLineNumbersStyle.Interval:return p.RenderLineNumbersType.Interval;case w.TextEditorLineNumbersStyle.On:default:return p.RenderLineNumbersType.On}}De.from=Me;function ve(te){switch(te){case p.RenderLineNumbersType.Off:return w.TextEditorLineNumbersStyle.Off;case p.RenderLineNumbersType.Relative:return w.TextEditorLineNumbersStyle.Relative;case p.RenderLineNumbersType.Interval:return w.TextEditorLineNumbersStyle.Interval;case p.RenderLineNumbersType.On:default:return w.TextEditorLineNumbersStyle.On}}De.to=ve})(de||(e.TextEditorLineNumbersStyle=de={}));var ke;(function(De){function Me(te){if(te===w.EndOfLine.CRLF)return t.EndOfLineSequence.CRLF;if(te===w.EndOfLine.LF)return t.EndOfLineSequence.LF}De.from=Me;function ve(te){if(te===t.EndOfLineSequence.CRLF)return w.EndOfLine.CRLF;if(te===t.EndOfLineSequence.LF)return w.EndOfLine.LF}De.to=ve})(ke||(e.EndOfLine=ke={}));var ne;(function(De){function Me(ve){if(typeof ve=="object")return ve.viewId;switch(ve){case w.ProgressLocation.SourceControl:return r.ProgressLocation.Scm;case w.ProgressLocation.Window:return r.ProgressLocation.Window;case w.ProgressLocation.Notification:return r.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}De.from=Me})(ne||(e.ProgressLocation=ne={}));var J;(function(De){function Me(te){const Le={start:te.start+1,end:te.end+1};return te.kind&&(Le.kind=Pe.from(te.kind)),Le}De.from=Me;function ve(te){const Le={start:te.start-1,end:te.end-1};return te.kind&&(Le.kind=Pe.to(te.kind)),Le}De.to=ve})(J||(e.FoldingRange=J={}));var Pe;(function(De){function Me(te){if(te)switch(te){case w.FoldingRangeKind.Comment:return o.$Vu.Comment;case w.FoldingRangeKind.Imports:return o.$Vu.Imports;case w.FoldingRangeKind.Region:return o.$Vu.Region}}De.from=Me;function ve(te){if(te)switch(te.value){case o.$Vu.Comment.value:return w.FoldingRangeKind.Comment;case o.$Vu.Imports.value:return w.FoldingRangeKind.Imports;case o.$Vu.Region.value:return w.FoldingRangeKind.Region}}De.to=ve})(Pe||(e.FoldingRangeKind=Pe={}));var Ge;(function(De){function Me(ve){if(ve)return{pinned:typeof ve.preview=="boolean"?!ve.preview:void 0,inactive:ve.background,preserveFocus:ve.preserveFocus,selection:typeof ve.selection=="object"?L.from(ve.selection):void 0,override:typeof ve.override=="boolean"?l.$gG.id:void 0}}De.from=Me})(Ge||(e.TextEditorOpenOptions=Ge={}));var Je;(function(De){function Me(Qe){return Qe instanceof w.$6O?Qe.toJSON():typeof Qe=="string"?Qe:ve(Qe)||te(Qe)?new w.$6O(Qe.baseUri??Qe.base,Qe.pattern).toJSON():Qe}De.from=Me;function ve(Qe){const nt=Qe;return nt?$.URI.isUri(nt.baseUri)&&typeof nt.pattern=="string":!1}function te(Qe){const nt=Qe;return nt?typeof nt.base=="string"&&typeof nt.pattern=="string":!1}function Le(Qe){return typeof Qe=="string"?Qe:new w.$6O($.URI.revive(Qe.baseUri),Qe.pattern)}De.to=Le})(Je||(e.GlobPattern=Je={}));var st;(function(De){function Me(ve){if(ve){if(Array.isArray(ve))return ve.map(Me);if(typeof ve=="string")return ve;{const te=ve;return{language:te.language,scheme:te.scheme,pattern:Je.from(te.pattern),exclusive:te.exclusive,notebookType:te.notebookType}}}else return}De.from=Me})(st||(e.LanguageSelector=st={}));var ht;(function(De){function Me(te){return!!te&&typeof te=="object"&&"documents"in te&&Array.isArray(te.documents)&&te.documents.every(Le=>Array.isArray(Le)&&Le.every(Qe=>Qe&&typeof Qe=="object"&&"uri"in Qe&&$.URI.isUri(Qe.uri)&&"version"in Qe&&typeof Qe.version=="number"&&"ranges"in Qe&&Array.isArray(Qe.ranges)&&Qe.ranges.every(nt=>nt instanceof w.$7N)))}De.is=Me;function ve(te){return{documents:te.documents.map(Le=>Le.map(Qe=>({uri:$.URI.from(Qe.uri),version:Qe.version,ranges:Qe.ranges.map(nt=>L.from(nt))})))}}De.from=ve})(ht||(e.MappedEditsContext=ht={}));var ft;(function(De){function Me(te){return{start:te.start,end:te.end}}De.from=Me;function ve(te){return new w.$wP(te.start,te.end)}De.to=ve})(ft||(e.NotebookRange=ft={}));var St;(function(De){function Me(te){return{timing:typeof te.runStartTime=="number"&&typeof te.runEndTime=="number"?{startTime:te.runStartTime,endTime:te.runEndTime}:void 0,executionOrder:te.executionOrder,success:te.lastRunSuccess}}De.to=Me;function ve(te){return{lastRunSuccess:te.success,runStartTime:te.timing?.startTime,runEndTime:te.timing?.endTime,executionOrder:te.executionOrder}}De.from=ve})(St||(e.NotebookCellExecutionSummary=St={}));var At;(function(De){function Me(ve){if(ve===S.NotebookCellExecutionState.Unconfirmed)return w.NotebookCellExecutionState.Pending;if(ve===S.NotebookCellExecutionState.Pending)return;if(ve===S.NotebookCellExecutionState.Executing)return w.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ve}`)}De.to=Me})(At||(e.NotebookCellExecutionState=At={}));var Qt;(function(De){function Me(te){switch(te){case w.NotebookCellKind.Markup:return S.CellKind.Markup;case w.NotebookCellKind.Code:default:return S.CellKind.Code}}De.from=Me;function ve(te){switch(te){case S.CellKind.Markup:return w.NotebookCellKind.Markup;case S.CellKind.Code:default:return w.NotebookCellKind.Code}}De.to=ve})(Qt||(e.NotebookCellKind=Qt={}));var ei;(function(De){function Me(te){const Le={metadata:te.metadata??Object.create(null),cells:[]};for(const Qe of te.cells)w.$xP.validate(Qe),Le.cells.push(tt.from(Qe));return Le}De.from=Me;function ve(te){const Le=new w.$yP(te.cells.map(tt.to));return(0,a.$ug)(te.metadata)||(Le.metadata=te.metadata),Le}De.to=ve})(ei||(e.NotebookData=ei={}));var tt;(function(De){function Me(te){return{cellKind:Qt.from(te.kind),language:te.languageId,mime:te.mime,source:te.value,metadata:te.metadata,internalMetadata:St.from(te.executionSummary??{}),outputs:te.outputs?te.outputs.map(zt.from):[]}}De.from=Me;function ve(te){return new w.$xP(Qt.to(te.cellKind),te.source,te.language,te.mime,te.outputs?te.outputs.map(zt.to):void 0,te.metadata,te.internalMetadata?St.to(te.internalMetadata):void 0)}De.to=ve})(tt||(e.NotebookCellData=tt={}));var Ot;(function(De){function Me(te){return{mime:te.mime,valueBytes:h.$Qe.wrap(te.data)}}De.from=Me;function ve(te){return new w.$zP(te.valueBytes.buffer,te.mime)}De.to=ve})(Ot||(e.NotebookCellOutputItem=Ot={}));var zt;(function(De){function Me(te){return{outputId:te.id,items:te.items.map(Ot.from),metadata:te.metadata}}De.from=Me;function ve(te){const Le=te.items.map(Ot.to);return new w.$AP(Le,te.outputId,te.metadata)}De.to=ve})(zt||(e.NotebookCellOutput=zt={}));var bt;(function(De){function Me(Le){return te(Le)?{include:Je.from(Le.include)??void 0,exclude:Je.from(Le.exclude)??void 0}:Je.from(Le)??void 0}De.from=Me;function ve(Le){return te(Le)?{include:Je.to(Le.include),exclude:Je.to(Le.exclude)}:Je.to(Le)}De.to=ve;function te(Le){const Qe=Le;return Qe?!(0,a.$qg)(Qe.include)&&!(0,a.$qg)(Qe.exclude):!1}})(bt||(e.NotebookExclusiveDocumentPattern=bt={}));var Dt;(function(De){function Me(ve,te,Le){const Qe=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{alignment:ve.alignment===w.NotebookCellStatusBarAlignment.Left?S.CellStatusbarAlignment.Left:S.CellStatusbarAlignment.Right,command:te.toInternal(Qe,Le),text:ve.text,tooltip:ve.tooltip,accessibilityInformation:ve.accessibilityInformation,priority:ve.priority}}De.from=Me})(Dt||(e.NotebookStatusBarItem=Dt={}));var ti;(function(De){function Me(ve,te,Le){const Qe=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{command:te.toInternal(Qe,Le),label:ve.label,description:ve.description,detail:ve.detail,documentation:ve.documentation}}De.from=Me})(ti||(e.NotebookKernelSourceAction=ti={}));var ii;(function(De){function Me(ve){return{transientOutputs:ve?.transientOutputs??!1,transientCellMetadata:ve?.transientCellMetadata??{},transientDocumentMetadata:ve?.transientDocumentMetadata??{},cellContentMetadata:ve?.cellContentMetadata??{}}}De.from=Me})(ii||(e.NotebookDocumentContentOptions=ii={}));var Gt;(function(De){function Me(te){return{uri:te.uri,provides:te.provides}}De.from=Me;function ve(te){return new w.$CP($.URI.revive(te.uri),te.provides)}De.to=ve})(Gt||(e.NotebookRendererScript=Gt={}));var wt;(function(De){function Me(te){return{message:oe.fromStrict(te.message)||"",type:T.TestMessageType.Error,expected:te.expectedOutput,actual:te.actualOutput,contextValue:te.contextValue,location:te.location&&{range:L.from(te.location.range),uri:te.location.uri},stackTrace:te.stackTrace?.map(Le=>({label:Le.label,position:Le.position&&V.from(Le.position),uri:Le.uri&&$.URI.revive(Le.uri).toJSON()}))}}De.from=Me;function ve(te){const Le=new w.$IP(typeof te.message=="string"?te.message:oe.to(te.message));return Le.actualOutput=te.actual,Le.expectedOutput=te.expected,Le.contextValue=te.contextValue,Le.location=te.location?xe.to(te.location):void 0,Le}De.to=ve})(wt||(e.TestMessage=wt={}));var Lt;(function(De){De.namespace=T.$rJ,De.denamespace=T.$sJ})(Lt||(e.TestTag=Lt={}));var ai;(function(De){function Me(te){const Le=(0,d.$zQ)(te).controllerId;return{extId:D.$mJ.fromExtHostTestItem(te,Le).toString(),label:te.label,uri:$.URI.revive(te.uri),busy:te.busy,tags:te.tags.map(Qe=>Lt.namespace(Le,Qe.id)),range:u.$Ut.lift(L.from(te.range)),description:te.description||null,sortText:te.sortText||null,error:te.error&&oe.fromStrict(te.error)||null}}De.from=Me;function ve(te){return{parent:void 0,error:void 0,id:D.$mJ.fromString(te.extId).localId,label:te.label,uri:$.URI.revive(te.uri),tags:(te.tags||[]).map(Le=>{const{tagId:Qe}=Lt.denamespace(Le);return new w.$JP(Qe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:L.to(te.range||void 0),canResolveChildren:!1,busy:te.busy,description:te.description||void 0,sortText:te.sortText||void 0}}De.toPlain=ve})(ai||(e.TestItem=ai={})),function(De){function Me(te){return{id:te.id}}De.from=Me;function ve(te){return new w.$JP(te.id)}De.to=ve}(Lt||(e.TestTag=Lt={}));var Zt;(function(De){const Me=(te,Le)=>{const Qe=te.value;if(!Qe)return;const nt={...ai.toPlain(Qe.item),parent:Le,taskStates:Qe.tasks.map(Xe=>({state:Xe.state,duration:Xe.duration,messages:Xe.messages.filter(mt=>mt.type===T.TestMessageType.Error).map(wt.to)})),children:[]};if(te.children)for(const Xe of te.children.values()){const mt=Me(Xe,nt);mt&&nt.children.push(mt)}return nt};function ve(te){const Le=new g.$lJ;for(const Xe of te.items)Le.insert(D.$mJ.fromString(Xe.item.extId).path,Xe);const Qe=[Le.nodes],nt=[];for(;Qe.length;)for(const Xe of Qe.pop())Xe.value?nt.push(Xe):Xe.children&&Qe.push(Xe.children.values());return{completedAt:te.completedAt,results:nt.map(Xe=>Me(Xe)).filter(a.$pg)}}De.to=ve})(Zt||(e.TestResults=Zt={}));var et;(function(De){function Me(Qe){return{covered:Qe.covered,total:Qe.total}}function ve(Qe){return"line"in Qe?V.from(Qe):L.from(Qe)}function te(Qe){if(typeof Qe.executed=="number"&&Qe.executed<0)throw new Error(`Invalid coverage count ${Qe.executed}`);return"branches"in Qe?{count:Qe.executed,location:ve(Qe.location),type:T.DetailType.Statement,branches:Qe.branches.length?Qe.branches.map(nt=>({count:nt.executed,location:nt.location&&ve(nt.location),label:nt.label})):void 0}:{type:T.DetailType.Declaration,name:Qe.name,count:Qe.executed,location:ve(Qe.location)}}De.fromDetails=te;function Le(Qe,nt,Xe){return w.$MP(Xe.statementCoverage),w.$MP(Xe.branchCoverage),w.$MP(Xe.declarationCoverage),{id:nt,uri:Xe.uri,statement:Me(Xe.statementCoverage),branch:Xe.branchCoverage&&Me(Xe.branchCoverage),declaration:Xe.declarationCoverage&&Me(Xe.declarationCoverage),testIds:Xe instanceof w.$NP&&Xe.fromTests.length?Xe.fromTests.map(mt=>D.$mJ.fromExtHostTestItem(mt,Qe).toString()):void 0}}De.fromFile=Le})(et||(e.TestCoverage=et={}));var ni;(function(De){function Me(ve){switch(ve){case o.CodeActionTriggerType.Invoke:return w.CodeActionTriggerKind.Invoke;case o.CodeActionTriggerType.Auto:return w.CodeActionTriggerKind.Automatic}}De.to=Me})(ni||(e.CodeActionTriggerKind=ni={}));var ci;(function(De){function Me(te){const Le=new w.$RP(we.to(te.kind),te.name,te.detail||"",$.URI.revive(te.uri),L.to(te.range),L.to(te.selectionRange));return Le._sessionId=te._sessionId,Le._itemId=te._itemId,Le}De.to=Me;function ve(te,Le,Qe){if(Le=Le??te._sessionId,Qe=Qe??te._itemId,Le===void 0||Qe===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:Qe,kind:we.from(te.kind),name:te.name,detail:te.detail??"",uri:te.uri,range:L.from(te.range),selectionRange:L.from(te.selectionRange),tags:te.tags?.map($e.from)}}De.from=ve})(ci||(e.TypeHierarchyItem=ci={}));var ui;(function(De){function Me(ve){if(ve)return{value:ve.value,tooltip:ve.tooltip}}De.from=Me})(ui||(e.ViewBadge=ui={}));var kt;(function(De){function Me(Qe,nt,Xe){const mt=nt.fileData;return mt?new w.$XO(new w.$YO(mt.name,$.URI.revive(mt.uri),mt.id,(0,A.$fb)(()=>Xe(mt.id)))):Qe===I.$et.uriList&&nt.uriListData?new w.$WO(Le(nt.uriListData)):new w.$WO(nt.asString)}De.to=Me;async function ve(Qe,nt){const Xe=await nt.asString();if(Qe===I.$et.uriList)return{asString:Xe,fileData:void 0,uriListData:te(Xe)};const mt=nt.asFile();return{asString:Xe,fileData:mt?{name:mt.name,uri:mt.uri,id:mt._itemId??mt.id}:void 0}}De.from=ve;function te(Qe){return R.$zu.split(Qe).map(nt=>{if(nt.startsWith("#"))return nt;try{return $.URI.parse(nt)}catch{}return nt})}function Le(Qe){return R.$zu.create(Qe.map(nt=>typeof nt=="string"?nt:$.URI.revive(nt)))}})(kt||(e.DataTransferItem=kt={}));var Ut;(function(De){function Me(te,Le){const Qe=te.items.map(([nt,Xe])=>[nt,kt.to(nt,Xe,Le)]);return new w.$ZO(Qe)}De.toDataTransfer=Me;async function ve(te){const Le={items:[]},Qe=[];for(const[nt,Xe]of te)Qe.push((async()=>{Le.items.push([nt,await kt.from(nt,Xe)])})());return await Promise.all(Qe),Le}De.from=ve})(Ut||(e.DataTransfer=Ut={}));var Nt;(function(De){function Me(te,Le){return{kind:"reply",agentId:te.participant??Le?.agentId??"",subCommand:te.command??Le?.command,message:te.prompt,title:te.label}}De.from=Me;function ve(te){return{prompt:te.message,label:te.title,participant:te.agentId,command:te.subCommand}}De.to=ve})(Nt||(e.ChatFollowup=Nt={}));var Bt;(function(De){function Me(te){switch(te){case y.ChatMessageRole.System:return w.LanguageModelChatMessageRole.System;case y.ChatMessageRole.User:return w.LanguageModelChatMessageRole.User;case y.ChatMessageRole.Assistant:return w.LanguageModelChatMessageRole.Assistant}}De.to=Me;function ve(te){switch(te){case w.LanguageModelChatMessageRole.System:return y.ChatMessageRole.System;case w.LanguageModelChatMessageRole.User:return y.ChatMessageRole.User;case w.LanguageModelChatMessageRole.Assistant:return y.ChatMessageRole.Assistant}return y.ChatMessageRole.User}De.from=ve})(Bt||(e.LanguageModelChatMessageRole=Bt={}));var oi;(function(De){function Me(te){let Le="",Qe;te.content.type==="text"?Le=te.content.value:Qe=new w.$kQ(te.content.name,te.content.value,te.content.isError);const nt=Bt.to(te.role),Xe=new w.$lQ(nt,Le,te.name);return Qe!==void 0&&(Xe.content2=Qe),Xe}De.to=Me;function ve(te){const Le=Bt.from(te.role),Qe=te.name;let nt;return te.content2 instanceof w.$kQ?nt={type:"function_result",name:te.content2.name,value:te.content2.content,isError:te.content2.isError}:nt={type:"text",value:te.content},{role:Le,name:Qe,content:nt}}De.from=ve})(oi||(e.LanguageModelChatMessage=oi={}));var ri;(function(De){function Me(te){return{kind:"markdownContent",content:oe.from(te.value)}}De.from=Me;function ve(te){return new w.$5P(oe.to(te.content))}De.to=ve})(ri||(e.ChatResponseMarkdownPart=ri={}));var si;(function(De){function Me(te){return{kind:"markdownVuln",content:oe.from(te.value),vulnerabilities:te.vulnerabilities}}De.from=Me;function ve(te){return new w.$6P(oe.to(te.content),te.vulnerabilities)}De.to=ve})(si||(e.ChatResponseMarkdownWithVulnerabilitiesPart=si={}));var Kt;(function(De){function Me(te){return{kind:"agentDetection",agentId:te.participant,command:te.command}}De.from=Me;function ve(te){return new w.$7P(te.agentId,te.command)}De.to=ve})(Kt||(e.ChatResponseDetectedParticipantPart=Kt={}));var Jt;(function(De){function Me(ve){return{kind:"confirmation",title:ve.title,message:ve.message,data:ve.data,buttons:ve.buttons}}De.from=Me})(Jt||(e.ChatResponseConfirmationPart=Jt={}));var li;(function(De){function Me(te){const{value:Le,baseUri:Qe}=te;function nt(Xe,mt){return Xe.map(Tt=>{const xt=$.URI.joinPath(mt,Tt.name);return{label:Tt.name,uri:xt,children:Tt.children&&nt(Tt.children,xt)}})}return{kind:"treeData",treeData:{label:(0,P.$gh)(Qe),uri:Qe,children:nt(Le,Qe)}}}De.from=Me;function ve(te){const Le=(0,c.$fi)(te.treeData);function Qe(mt){return mt.map(Tt=>({name:Tt.label,children:Tt.children&&Qe(Tt.children)}))}const nt=Le.uri,Xe=Le.children?Qe(Le.children):[];return new w.$9P(Xe,nt)}De.to=ve})(li||(e.ChatResponseFilesPart=li={}));var Mt;(function(De){function Me(te){const Le=Qe=>$.URI.isUri(Qe);return{kind:"inlineReference",name:te.title,inlineReference:Le(te.value)?te.value:N.from(te.value)}}De.from=Me;function ve(te){const Le=(0,c.$fi)(te);return new w.$0P($.URI.isUri(Le.inlineReference)?Le.inlineReference:N.to(Le.inlineReference),te.name)}De.to=ve})(Mt||(e.ChatResponseAnchorPart=Mt={}));var Rt;(function(De){function Me(te){return{kind:"progressMessage",content:oe.from(te.value)}}De.from=Me;function ve(te){return new w.$$P(te.content.value)}De.to=ve})(Rt||(e.ChatResponseProgressPart=Rt={}));var vt;(function(De){function Me(te){return{kind:"warning",content:oe.from(te.value)}}De.from=Me;function ve(te){return new w.$aQ(te.content.value)}De.to=ve})(vt||(e.ChatResponseWarningPart=vt={}));var Xt;(function(De){function Me(te){return{kind:"move",uri:te.uri,range:L.from(te.range)}}De.from=Me;function ve(te){return new w.$eQ($.URI.revive(te.uri),L.to(te.range))}De.to=ve})(Xt||(e.ChatResponseMovePart=Xt={}));var Et;(function(De){function Me(ve){return{kind:"progressTask",content:oe.from(ve.value)}}De.from=Me})(Et||(e.ChatTask=Et={}));var hi;(function(De){function Me(ve){return{kind:"progressTaskResult",content:typeof ve=="string"?oe.from(ve):void 0}}De.from=Me})(hi||(e.ChatTaskResult=hi={}));var Yt;(function(De){function Me(te,Le,Qe){return{kind:"command",command:Le.toInternal(te.value,Qe)??{command:te.value.command,title:te.value.title}}}De.from=Me;function ve(te,Le){return new w.$bQ(Le.fromInternal(te.command)??{command:te.command.id,title:te.command.title})}De.to=ve})(Yt||(e.ChatResponseCommandButtonPart=Yt={}));var Mi;(function(De){function Me(te){return{kind:"textEdit",uri:te.uri,edits:te.edits.map(Le=>be.from(Le))}}De.from=Me;function ve(te){return new w.$fQ($.URI.revive(te.uri),te.edits.map(Le=>be.to(Le)))}De.to=ve})(Mi||(e.ChatResponseTextEditPart=Mi={}));var di;(function(De){function Me(te){const Le=b.ThemeIcon.isThemeIcon(te.iconPath)?te.iconPath:$.URI.isUri(te.iconPath)?{light:$.URI.revive(te.iconPath)}:te.iconPath&&"light"in te.iconPath&&"dark"in te.iconPath&&$.URI.isUri(te.iconPath.light)&&$.URI.isUri(te.iconPath.dark)?{light:$.URI.revive(te.iconPath.light),dark:$.URI.revive(te.iconPath.dark)}:void 0;return typeof te.value=="object"&&"variableName"in te.value?{kind:"reference",reference:{variableName:te.value.variableName,value:$.URI.isUri(te.value.value)||!te.value.value?te.value.value:N.from(te.value.value)},iconPath:Le,options:te.options}:{kind:"reference",reference:$.URI.isUri(te.value)||typeof te.value=="string"?te.value:N.from(te.value),iconPath:Le,options:te.options}}De.from=Me;function ve(te){const Le=(0,c.$fi)(te),Qe=nt=>$.URI.isUri(nt)?nt:N.to(nt);return new w.$cQ(typeof Le.reference=="string"?Le.reference:"variableName"in Le.reference?{variableName:Le.reference.variableName,value:Le.reference.value&&Qe(Le.reference.value)}:Qe(Le.reference))}De.to=ve})(di||(e.ChatResponseReferencePart=di={}));var yi;(function(De){function Me(ve){return{kind:"codeCitation",value:ve.value,license:ve.license,snippet:ve.snippet}}De.from=Me})(yi||(e.ChatResponseCodeCitationPart=yi={}));var qt;(function(De){function Me(Le,Qe,nt){return Le instanceof w.$5P?ri.from(Le):Le instanceof w.$0P?Mt.from(Le):Le instanceof w.$cQ?di.from(Le):Le instanceof w.$$P?Rt.from(Le):Le instanceof w.$9P?li.from(Le):Le instanceof w.$bQ?Yt.from(Le,Qe,nt):Le instanceof w.$fQ?Mi.from(Le):Le instanceof w.$6P?si.from(Le):Le instanceof w.$7P?Kt.from(Le):Le instanceof w.$aQ?vt.from(Le):Le instanceof w.$8P?Jt.from(Le):Le instanceof w.$dQ?yi.from(Le):Le instanceof w.$eQ?Xt.from(Le):{kind:"markdownContent",content:oe.from("")}}De.from=Me;function ve(Le,Qe){switch(Le.kind){case"reference":return di.to(Le);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return te(Le,Qe)}}De.to=ve;function te(Le,Qe){switch(Le.kind){case"markdownContent":return ri.to(Le);case"inlineReference":return Mt.to(Le);case"progressMessage":return;case"treeData":return li.to(Le);case"command":return Yt.to(Le,Qe)}}De.toContent=te})(qt||(e.ChatResponsePart=qt={}));var fi;(function(De){function Me(ve,te){const Le=ve.variables.variables.filter(nt=>nt.isTool),Qe=ve.variables.variables.filter(nt=>!nt.isTool);return{prompt:ve.message,command:ve.command,attempt:ve.attempt??0,enableCommandDetection:ve.enableCommandDetection??!0,isParticipantDetected:ve.isParticipantDetected??!1,references:Qe.map(Ct.to),toolReferences:Le.map(Ei.to),location:ji.to(ve.location),acceptedConfirmationData:ve.acceptedConfirmationData,rejectedConfirmationData:ve.rejectedConfirmationData,location2:te}}De.to=Me})(fi||(e.ChatAgentRequest=fi={}));var ji;(function(De){function Me(te){switch(te){case f.ChatAgentLocation.Notebook:return w.ChatLocation.Notebook;case f.ChatAgentLocation.Terminal:return w.ChatLocation.Terminal;case f.ChatAgentLocation.Panel:return w.ChatLocation.Panel;case f.ChatAgentLocation.Editor:return w.ChatLocation.Editor}}De.to=Me;function ve(te){switch(te){case w.ChatLocation.Notebook:return f.ChatAgentLocation.Notebook;case w.ChatLocation.Terminal:return f.ChatAgentLocation.Terminal;case w.ChatLocation.Panel:return f.ChatAgentLocation.Panel;case w.ChatLocation.Editor:return f.ChatAgentLocation.Editor}}De.from=ve})(ji||(e.ChatLocation=ji={}));var Ct;(function(De){function Me(ve){const te=ve.value;if(!te)throw new Error("Invalid value reference");return{id:ve.id,name:ve.name,range:ve.range&&[ve.range.start,ve.range.endExclusive],value:(0,$.$yc)(te)?$.URI.revive(te):te&&typeof te=="object"&&"uri"in te&&"range"in te&&(0,$.$yc)(te.uri)?N.to((0,c.$fi)(te)):te,modelDescription:ve.modelDescription}}De.to=Me})(Ct||(e.ChatPromptReference=Ct={}));var Ei;(function(De){function Me(ve){if(ve.value)throw new Error("Invalid tool reference");return{id:ve.id,range:ve.range&&[ve.range.start,ve.range.endExclusive]}}De.to=Me})(Ei||(e.ChatLanguageModelToolReference=Ei={}));var Oi;(function(De){function Me(ve,te,Le){return{id:ve.id,label:ve.label,fullName:ve.fullName,icon:ve.icon?.id,value:ve.values[0].value,insertText:ve.insertText,detail:ve.detail,documentation:ve.documentation,command:te.toInternal(ve.command,Le)}}De.from=Me})(Oi||(e.ChatAgentCompletionItem=Oi={}));var gi;(function(De){function Me(ve){return{errorDetails:ve.errorDetails,metadata:ve.metadata,nextQuestion:ve.nextQuestion}}De.to=Me})(gi||(e.ChatAgentResult=gi={}));var Fi;(function(De){function Me(ve,te,Le){if(te.action.kind==="vote")return;const Qe=gi.to(ve);if(te.action.kind==="command"){const nt=te.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Le.fromInternal(nt)??{command:nt.id,title:nt.title}}},result:Qe}}else return te.action.kind==="followUp"?{action:{kind:"followUp",followup:Nt.to(te.action.followup)},result:Qe}:te.action.kind==="inlineChat"?{action:{kind:"editor",accepted:te.action.action==="accepted"},result:Qe}:{action:te.action,result:Qe}}De.to=Me})(Fi||(e.ChatAgentUserActionEvent=Fi={}));var Ui;(function(De){function Me(te){return{...te,string:te.toString()}}De.from=Me;function ve(te){const Le={...te,toString:()=>te.string};return delete Le.string,Le}De.to=ve})(Ui||(e.LanguageModelToolResult=Ui={}));var Ft;(function(De){function Me(ve,te,Le){return"terminalCommand"in ve?{terminalCommand:ve.terminalCommand,shouldExecute:ve.shouldExecute}:"uri"in ve?{uri:ve.uri}:te.toInternal(ve,Le)}De.from=Me})(Ft||(e.TerminalQuickFix=Ft={}));var Pi;(function(De){function Me(ve){return{kind:Di.to(ve.kind)}}De.to=Me})(Pi||(e.PartialAcceptInfo=Pi={}));var Di;(function(De){function Me(ve){switch(ve){case o.PartialAcceptTriggerKind.Word:return w.PartialAcceptTriggerKind.Word;case o.PartialAcceptTriggerKind.Line:return w.PartialAcceptTriggerKind.Line;case o.PartialAcceptTriggerKind.Suggest:return w.PartialAcceptTriggerKind.Suggest;default:return w.PartialAcceptTriggerKind.Unknown}}De.to=Me})(Di||(e.PartialAcceptTriggerKind=Di={}));var bi;(function(De){function Me(ve,te){return{id:te,label:ve.label,description:ve.description,canEdit:ve.canEdit,collapsibleState:ve.collapsibleState||k.DebugTreeItemCollapsibleState.None,contextValue:ve.contextValue}}De.from=Me})(bi||(e.DebugTreeItem=bi={}));var wi;(function(De){function Me(ve){return{id:ve.id,modelDescription:ve.modelDescription,parametersSchema:ve.parametersSchema,displayName:ve.displayName}}De.to=Me})(wi||(e.LanguageModelToolDescription=wi={}))}),define(Re[295],Ce([1,0,6,19,15,53]),function(ge,e,s,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lqc=void 0;let O=class{constructor(m,c){this.a=m.getProxy(s.$3N.MainThreadBulkEdits),this.b={getTextDocumentVersion:I=>c.getDocument(I)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,c,I){const E=new A.$5w(R.WorkspaceEdit.from(m,this.b));return this.a.$tryApplyWorkspaceEdit(E,void 0,I?.isRefactoring??!1)}};e.$Lqc=O,e.$Lqc=O=Ze([qe(0,h.$DQ)],O)}),define(Re[296],Ce([1,0,18,7,52,4,40,3,38,43,17,2,23,6,15,9,156,258,25]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P,b,a,$,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mqc=void 0,b=Ue(b),a=Ue(a);class i{constructor(r,d,l,f,y){this.j=r,this.k=d,this.l=l,this.m=f,this.n=y,this.b=c.$ie.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let d=function(f){if(r.c){const y=new Error("Response stream has been closed");throw Error.captureStackTrace(y,f),y}};const r=this;this.b.reset();const l=(f,y)=>{if(typeof this.d>"u"&&(f.kind==="markdownContent"||f.kind==="markdownVuln")&&(this.d=this.b.elapsed()),y){const k=this.l.$handleProgressChunk(this.k.requestId,f),S={report:D=>{k?.then(T=>{T&&(a.$wO.isMarkdownString(D.value)?this.l.$handleProgressChunk(this.k.requestId,b.ChatResponseWarningPart.from(D),T):this.l.$handleProgressChunk(this.k.requestId,b.ChatResponseReferencePart.from(D),T))})}};Promise.all([k,y?.(S)]).then(([D,T])=>{D!==void 0&&this.l.$handleProgressChunk(this.k.requestId,b.ChatTaskResult.from(T),D)})}else this.l.$handleProgressChunk(this.k.requestId,f)};this.g={markdown(f){d(this.markdown);const y=new a.$5P(f),k=b.ChatResponseMarkdownPart.from(y);return l(k),this},markdownWithVulnerabilities(f,y){d(this.markdown),y&&(0,u.$wH)(r.j,"chatParticipantAdditions");const k=new a.$6P(f,y),S=b.ChatResponseMarkdownWithVulnerabilitiesPart.from(k);return l(S),this},filetree(f,y){d(this.filetree);const k=new a.$9P(f,y),S=b.ChatResponseFilesPart.from(k);return l(S),this},anchor(f,y){d(this.anchor);const k=new a.$0P(f,y),S=b.ChatResponseAnchorPart.from(k);return l(S),this},button(f){d(this.anchor);const y=new a.$bQ(f),k=b.ChatResponseCommandButtonPart.from(y,r.m,r.n);return l(k),this},progress(f,y){d(this.progress);const k=new a.$_P(f,y),S=y?b.ChatTask.from(k):b.ChatResponseProgressPart.from(k);return l(S,y),this},warning(f){d(this.progress),(0,u.$wH)(r.j,"chatParticipantAdditions");const y=new a.$aQ(f),k=b.ChatResponseWarningPart.from(y);return l(k),this},reference(f,y){return this.reference2(f,y)},reference2(f,y,k){if(d(this.reference),typeof f=="object"&&"variableName"in f&&(0,u.$wH)(r.j,"chatParticipantAdditions"),typeof f=="object"&&"variableName"in f&&!f.value){const S=r.k.variables.variables.find(D=>D.name===f.variableName);if(S){let D;if(S.references?.length)D=S.references.map(T=>({kind:"reference",reference:{variableName:f.variableName,value:T.reference}}));else{const T=new a.$cQ(f,y,k);D=[b.ChatResponseReferencePart.from(T)]}return D.forEach(T=>l(T)),this}}else{const S=new a.$cQ(f,y,k),D=b.ChatResponseReferencePart.from(S);l(D)}return this},codeCitation(f,y,k){d(this.codeCitation),(0,u.$wH)(r.j,"chatParticipantAdditions");const S=new a.$dQ(f,y,k),D=b.ChatResponseCodeCitationPart.from(S);l(D)},textEdit(f,y){d(this.textEdit),(0,u.$wH)(r.j,"chatParticipantAdditions");const k=new a.$fQ(f,y),S=b.ChatResponseTextEditPart.from(k);return l(S),this},detectedParticipant(f,y){d(this.detectedParticipant),(0,u.$wH)(r.j,"chatParticipantAdditions");const k=new a.$7P(f,y),S=b.ChatResponseDetectedParticipantPart.from(k);return l(S),this},confirmation(f,y,k,S){d(this.confirmation),(0,u.$wH)(r.j,"chatParticipantAdditions");const D=new a.$8P(f,y,k,S),T=b.ChatResponseConfirmationPart.from(D);return l(T),this},push(f){if(d(this.push),(f instanceof a.$fQ||f instanceof a.$6P||f instanceof a.$7P||f instanceof a.$aQ||f instanceof a.$8P||f instanceof a.$dQ||f instanceof a.$eQ)&&(0,u.$wH)(r.j,"chatParticipantAdditions"),f instanceof a.$cQ)this.reference2(f.value,f.iconPath,f.options);else{const y=b.ChatResponsePart.from(f,r.m,r.n);l(y)}return this}}}return this.g}}class o extends C.$Xc{static{this.b=0}static{this.j=0}constructor(r,d,l,f){super(),this.t=d,this.u=l,this.w=f,this.c=new Map,this.m=new Map,this.n=this.B(new C.$7c),this.s=this.B(new C.$7c),this.g=r.getProxy(P.$3N.MainThreadChatAgents2)}transferActiveChat(r){this.g.$transferActiveChatSession(r)}createChatAgent(r,d,l){const f=o.b++,y=new t(r,d,this.g,f,l);return this.c.set(f,y),this.g.$registerAgent(f,r.identifier,d,{},void 0),y.apiAgent}createDynamicChatAgent(r,d,l,f){const y=o.b++,k=new t(r,d,this.g,y,f);return this.c.set(y,k),this.g.$registerAgent(y,r.identifier,d,{isSticky:!0},l),k.apiAgent}registerChatParticipantDetectionProvider(r){const d=o.j++;return this.m.set(d,r),this.g.$registerChatParticipantDetectionProvider(d),(0,C.$Vc)(()=>{this.m.delete(d),this.g.$unregisterChatParticipantDetectionProvider(d)})}async $detectChatParticipant(r,d,l,f,y){const{request:k,location:S,history:D}=await this.y(d,l),T=this.m.get(r);if(T)return T.provideParticipantDetection(b.ChatAgentRequest.to(k,S),{history:D},{participants:f.participants,location:b.ChatLocation.to(f.location)},y)}async y(r,d){const l=(0,m.$fi)(r),f=await this.z(l.agentId,d);let y;if(l.locationData?.type===$.ChatAgentLocation.Editor){const k=this.w.getDocument(l.locationData.document);y=new a.$iQ(k,b.Selection.to(l.locationData.selection),b.Range.to(l.locationData.wholeRange))}else if(l.locationData?.type===$.ChatAgentLocation.Notebook){const k=this.w.getDocument(l.locationData.sessionInputUri);y=new a.$jQ(k)}else l.locationData?.type,$.ChatAgentLocation.Terminal;return{request:l,location:y,history:f}}async $invokeAgent(r,d,l,f){const y=this.c.get(r);if(!y)throw new Error(`[CHAT](${r}) CANNOT invoke agent because the agent is not registered`);let k;try{const{request:S,location:D,history:T}=await this.y(d,l);let v=this.n.get(S.sessionId);v||(v=new C.$Wc,this.n.set(S.sessionId,v)),k=new i(y.extension,S,this.g,this.u.converter,v);const w=y.invoke(b.ChatAgentRequest.to(S,D),{history:T},k.apiObject,f);return await(0,h.$wh)(Promise.resolve(w).then(M=>{if(M?.metadata)try{JSON.stringify(M.metadata)}catch(N){const F=`result.metadata MUST be JSON.stringify-able. Got error: ${N.message}`;return this.t.error(`[${y.extension.identifier.value}] [@${y.id}] ${F}`,y.extension),{errorDetails:{message:F},timings:k?.timings,nextQuestion:M.nextQuestion}}let L;return M?.errorDetails&&(L={...M.errorDetails,responseIsIncomplete:!0}),L?.responseIsRedacted&&(0,u.$wH)(y.extension,"chatParticipantPrivate"),{errorDetails:L,timings:k?.timings,metadata:M?.metadata,nextQuestion:M?.nextQuestion}}),f)}catch(S){return this.t.error(S,y.extension),S instanceof a.$rQ&&S.cause&&(S=S.cause),{errorDetails:{message:(0,R.$tj)(S),responseIsIncomplete:!0}}}finally{k?.close()}}async z(r,d){const l=[];for(const f of d.history){const y=b.ChatAgentResult.to(f.result),k=r===f.request.agentId?y:{...y,metadata:void 0},S=f.request.variables.variables.filter(w=>!w.isTool).map(b.ChatPromptReference.to),D=f.request.variables.variables.filter(w=>w.isTool).map(b.ChatLanguageModelToolReference.to),T=new a.$gQ(f.request.message,f.request.command,S,f.request.agentId);T.toolReferences=D,l.push(T);const v=(0,s.$Jb)(f.response.map(w=>b.ChatResponsePart.toContent(w,this.u.converter)));l.push(new a.$hQ(v,k,f.request.agentId,f.request.command))}return l}$releaseSession(r){this.n.deleteAndDispose(r)}async $provideFollowups(r,d,l,f,y){const k=this.c.get(d);if(!k)return Promise.resolve([]);const S=(0,m.$fi)(r),D=await this.z(k.id,f),T=b.ChatAgentResult.to(l);return(await k.provideFollowups(T,{history:D},y)).filter(v=>{const w=!v.participant||O.Iterable.some(this.c.values(),M=>M.id===v.participant&&g.$vn.equals(M.extension.identifier,k.extension.identifier));return w||this.t.warn(`[@${k.id}] ChatFollowup refers to an unknown participant: ${v.participant}`),w}).map(v=>b.ChatFollowup.from(v,S))}$acceptFeedback(r,d,l,f){const y=this.c.get(r);if(!y)return;const k=b.ChatAgentResult.to(d);let S;switch(l){case p.ChatAgentVoteDirection.Down:S=a.ChatResultFeedbackKind.Unhelpful;break;case p.ChatAgentVoteDirection.Up:S=a.ChatResultFeedbackKind.Helpful;break}y.acceptFeedback(Object.freeze(f?{result:k,kind:S,reportIssue:f}:{result:k,kind:S}))}$acceptAction(r,d,l){const f=this.c.get(r);if(!f||l.action.kind==="vote")return;const y=b.ChatAgentUserActionEvent.to(d,l,this.u.converter);y&&f.acceptAction(Object.freeze(y))}async $invokeCompletionProvider(r,d,l){const f=this.c.get(r);if(!f)return[];let y=this.s.get(r);return y?y.clear():(y=new C.$Wc,this.s.set(r,y)),(await f.invokeCompletionProvider(d,l)).map(S=>b.ChatAgentCompletionItem.from(S,this.u.converter,y))}async $provideWelcomeMessage(r,d,l){const f=this.c.get(r);if(f)return await f.provideWelcomeMessage(b.ChatLocation.to(d),l)}async $provideChatTitle(r,d,l){const f=this.c.get(r);if(!f)return;const y=await this.z(f.id,{history:d});return await f.provideTitle({history:y},l)}async $provideSampleQuestions(r,d,l){const f=this.c.get(r);if(f)return(await f.provideSampleQuestions(b.ChatLocation.to(d),l)).map(y=>b.ChatFollowup.from(y,void 0))}}e.$Mqc=o;class t{constructor(r,d,l,f,y){this.extension=r,this.id=d,this.w=l,this.x=f,this.y=y,this.l=new A.$oe,this.m=new A.$oe}acceptFeedback(r){this.l.fire(r)}acceptAction(r){this.m.fire(r)}async invokeCompletionProvider(r,d){return this.o?await this.o.provider.provideCompletionItems(r,d)??[]:[]}async provideFollowups(r,d,l){if(!this.b)return[];const f=await this.b.provideFollowups(r,d,l);return f?f.filter(y=>!(y&&"commandId"in y)).filter(y=>!(y&&"message"in y)):[]}async provideWelcomeMessage(r,d){if(!this.q)return[];const l=await this.q.provideWelcomeMessage(r,d);return l?l.map(f=>typeof f=="string"?f:b.MarkdownString.from(f)):[]}async provideTitle(r,d){if(this.s)return await this.s.provideChatTitle(r,d)??void 0}async provideSampleQuestions(r,d){if(!this.q||!this.q.provideSampleQuestions)return[];const l=await this.q.provideSampleQuestions(r,d);return l||[]}get apiAgent(){let r=!1,d=!1;const l=()=>{r||d||(d=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{icon:this.c?this.c instanceof E.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof a.$4O?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.k,helpTextPrefix:!this.d||typeof this.d=="string"?this.d:b.MarkdownString.from(this.d),helpTextVariablesPrefix:!this.g||typeof this.g=="string"?this.g:b.MarkdownString.from(this.g),helpTextPostfix:!this.j||typeof this.j=="string"?this.j:b.MarkdownString.from(this.j),supportIssueReporting:this.n,requester:this.t,supportsSlowVariables:this.u}),d=!1}))},f=this;return{get id(){return f.id},get iconPath(){return f.c},set iconPath(y){f.c=y,l()},get requestHandler(){return f.y},set requestHandler(y){(0,I.$rg)(typeof y=="function","Invalid request handler"),f.y=y},get followupProvider(){return f.b},set followupProvider(y){f.b=y,l()},get helpTextPrefix(){return(0,u.$wH)(f.extension,"defaultChatParticipant"),f.d},set helpTextPrefix(y){(0,u.$wH)(f.extension,"defaultChatParticipant"),f.d=y,l()},get helpTextVariablesPrefix(){return(0,u.$wH)(f.extension,"defaultChatParticipant"),f.g},set helpTextVariablesPrefix(y){(0,u.$wH)(f.extension,"defaultChatParticipant"),f.g=y,l()},get helpTextPostfix(){return(0,u.$wH)(f.extension,"defaultChatParticipant"),f.j},set helpTextPostfix(y){(0,u.$wH)(f.extension,"defaultChatParticipant"),f.j=y,l()},get isSecondary(){return(0,u.$wH)(f.extension,"defaultChatParticipant"),f.k},set isSecondary(y){(0,u.$wH)(f.extension,"defaultChatParticipant"),f.k=y,l()},get supportIssueReporting(){return(0,u.$wH)(f.extension,"chatParticipantPrivate"),f.n},set supportIssueReporting(y){(0,u.$wH)(f.extension,"chatParticipantPrivate"),f.n=y,l()},get onDidReceiveFeedback(){return f.l.event},set participantVariableProvider(y){if((0,u.$wH)(f.extension,"chatParticipantAdditions"),f.o=y,y){if(!y.triggerCharacters.length)throw new Error("triggerCharacters are required");f.w.$registerAgentCompletionsProvider(f.x,f.id,y.triggerCharacters)}else f.w.$unregisterAgentCompletionsProvider(f.x,f.id)},get participantVariableProvider(){return(0,u.$wH)(f.extension,"chatParticipantAdditions"),f.o},set welcomeMessageProvider(y){(0,u.$wH)(f.extension,"defaultChatParticipant"),f.q=y,l()},get welcomeMessageProvider(){return(0,u.$wH)(f.extension,"defaultChatParticipant"),f.q},set titleProvider(y){(0,u.$wH)(f.extension,"defaultChatParticipant"),f.s=y,l()},get titleProvider(){return(0,u.$wH)(f.extension,"defaultChatParticipant"),f.s},onDidPerformAction:(0,u.$vH)(this.extension,"chatParticipantAdditions")?this.m.event:void 0,set requester(y){f.t=y,l()},get requester(){return f.t},set supportsSlowReferences(y){(0,u.$wH)(f.extension,"chatParticipantPrivate"),f.u=y,l()},get supportsSlowReferences(){return(0,u.$wH)(f.extension,"chatParticipantPrivate"),f.u},dispose(){r=!0,f.b=void 0,f.l.dispose(),f.w.$unregisterAgent(f.x)}}}invoke(r,d,l,f){return this.y(r,d,l,f)}}}),define(Re[297],Ce([1,0,12,3,51,6,15,9,25]),function(ge,e,s,h,R,A,O,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nqc=void 0,O=Ue(O),C=Ue(C);class c{static{this.a=0}constructor(g){this.b=new Map,this.c=g.getProxy(A.$3N.MainThreadChatVariables)}async $resolveVariable(g,P,b,a){const $=this.b.get(g);if($)try{if($.resolver.resolve2){(0,m.$wH)($.extension,"chatParticipantAdditions");const p=new I(P,this.c),u=await $.resolver.resolve2($.data.name,{prompt:b},p.apiObject,a);if(u&&u[0])return u[0].value}else{const p=await $.resolver.resolve($.data.name,{prompt:b},a);if(p&&p[0])return p[0].value}}catch(p){(0,s.$3)(p)}}registerVariableResolver(g,P,b,a,$,p,u,i,o){const t=c.a++,n=o?R.ThemeIcon.fromId(o):void 0;return this.b.set(t,{extension:g,data:{id:P,name:b,description:a,modelDescription:$,icon:n},resolver:u}),this.c.$registerVariable(t,{id:P,name:b,description:a,modelDescription:$,isSlow:p,fullName:i,icon:n}),(0,h.$Vc)(()=>{this.b.delete(t),this.c.$unregisterVariable(t)})}}e.$Nqc=c;class I{constructor(g,P){this.c=g,this.d=P,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let P=function(a){if(g.a){const $=new Error("Response stream has been closed");throw Error.captureStackTrace($,a),$}};const g=this,b=a=>{this.d.$handleProgressChunk(this.c,a)};this.b={progress(a){P(this.progress);const $=new C.$$P(a),p=O.ChatResponseProgressPart.from($);return b(p),this},reference(a){P(this.reference);const $=new C.$cQ(a),p=O.ChatResponseReferencePart.from($);return b(p),this},push(a){return P(this.push),a instanceof C.$cQ?b(O.ChatResponseReferencePart.from(a)):a instanceof C.$$P&&b(O.ChatResponseProgressPart.from(a)),this}}}return this.b}}}),define(Re[298],Ce([1,0,7,60,4,3,41,2,88,23,15,9,6,25]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rqc=b,m=Ue(m),I=Ue(I),E=Ue(E);function b(a,$,p){const u=a.getProxy(g.$3N.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new c.$xn,$.registerArgumentProcessor({processArgument:S=>{if(S&&S.$mid===O.MarshalledId.CommentController){const D=this.b.get(S.handle);return D?D.value:S}else if(S&&S.$mid===O.MarshalledId.CommentThread){const D=S,T=this.b.get(D.commentControlHandle);if(!T)return D;const v=T.getCommentThread(D.commentThreadHandle);return v?v.value:D}else if(S&&(S.$mid===O.MarshalledId.CommentThreadReply||S.$mid===O.MarshalledId.CommentThreadInstance)){const D=this.b.get(S.thread.commentControlHandle);if(!D)return S;const T=D.getCommentThread(S.thread.commentThreadHandle);return T?S.$mid===O.MarshalledId.CommentThreadInstance?T.value:{thread:T.value,text:S.text}:S}else if(S&&S.$mid===O.MarshalledId.CommentNode){const D=this.b.get(S.thread.commentControlHandle);if(!D)return S;const T=D.getCommentThread(S.thread.commentThreadHandle);if(!T)return S;const v=S.commentUniqueId,w=T.getCommentByUniqueId(v);return w||S}else if(S&&S.$mid===O.MarshalledId.CommentThreadNode){const D=this.b.get(S.thread.commentControlHandle);if(!D)return S;const T=D.getCommentThread(S.thread.commentThreadHandle);if(!T)return S;const v=S.text,w=S.commentUniqueId,M=T.getCommentByUniqueId(w);return M?(typeof M.body=="string"?M.body=v:M.body=new E.$wO(v),M):S}return S}})}createCommentController(S,D,T){const v=i.a++,w=new t(S,v,D,T);this.b.set(w.handle,w);const M=this.c.get(S.identifier)||[];return M.push(w),this.c.set(S.identifier,M),w.value}async $createCommentThreadTemplate(S,D,T,v){const w=this.b.get(S);w&&w.$createCommentThreadTemplate(D,T,v)}async $setActiveComment(S,D){const T=this.b.get(S);T&&T.$setActiveComment(D??void 0)}async $updateCommentThreadTemplate(S,D,T){const v=this.b.get(S);v&&v.$updateCommentThreadTemplate(D,T)}$deleteCommentThread(S,D){this.b.get(S)?.$deleteCommentThread(D)}async $provideCommentingRanges(S,D,T){const v=this.b.get(S);if(!v||!v.commentingRangeProvider)return Promise.resolve(void 0);const w=await p.ensureDocumentData(C.URI.revive(D));return(0,s.$Ah)(async()=>{const M=await v.commentingRangeProvider.provideCommentingRanges(w.document,T);let L;return Array.isArray(M)?L={ranges:M,fileComments:!1}:M?L={ranges:M.ranges||[],fileComments:M.enableFileComments||!1}:L=M??void 0,L}).then(M=>{let L;return M&&(L={ranges:M.ranges.map(N=>I.Range.from(N)),fileComments:M.fileComments}),L})}$toggleReaction(S,D,T,v,w){const M=this.b.get(S);return!M||!M.reactionHandler?Promise.resolve(void 0):(0,s.$Ah)(()=>{const L=M.getCommentThread(D);if(L){const N=L.getCommentByUniqueId(v.uniqueIdInThread);if(M!==void 0&&N&&M.reactionHandler)return M.reactionHandler(N,d(w))}return Promise.resolve(void 0)})}}class o{static{this.a=0}set threadId(S){this.n=S}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(S){(S===void 0!=(this.p===void 0)||!S||!this.p||!S.isEqual(this.p))&&(this.p=S,this.b.range=S,this.c.fire())}get range(){return this.p}set canReply(S){this.d!==S&&(this.d=S,this.b.canReply=S,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(S){this.e=S,this.b.label=S,this.c.fire()}get contextValue(){return this.f}set contextValue(S){this.f=S,this.b.contextValue=S,this.c.fire()}get comments(){return this.q}set comments(S){this.q=S,this.b.comments=S,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(S){this.g=S,this.b.collapsibleState=S,this.c.fire()}get state(){return this.h}set state(S){this.h=S,typeof S=="object"?((0,P.$wH)(this.extensionDescription,"commentThreadApplicability"),this.b.state=S.resolved,this.b.applicability=S.applicability):this.b.state=S,this.c.fire()}get isDisposed(){return this.j}constructor(S,D,T,v,w,M,L,N,F){this.m=D,this.n=T,this.o=v,this.p=w,this.q=M,this.extensionDescription=L,this.r=N,this.handle=o.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new R.$oe,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new A.$Yc,this.l.value=new A.$Wc,this.n===void 0&&(this.n=`${S}.${this.handle}`),u.$createCommentThread(D,this.handle,this.n,this.o,I.Range.from(this.p),this.q.map(j=>n(this,j,this.k,this.extensionDescription)),L.identifier,this.r,F),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.i.push({dispose:()=>{u.$deleteCommentThread(D,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(j){V.range=j},get comments(){return V.comments},set comments(j){V.comments=j},get collapsibleState(){return V.collapsibleState},set collapsibleState(j){V.collapsibleState=j},get canReply(){return V.canReply},set canReply(j){V.canReply=j},get contextValue(){return V.contextValue},set contextValue(j){V.contextValue=j},get label(){return V.label},set label(j){V.label=j},get state(){return V.state},set state(j){V.state=j},reveal:(j,U)=>V.reveal(j,U),hide:()=>V.hide(),dispose:()=>{V.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new A.$Wc);const S=T=>Object.prototype.hasOwnProperty.call(this.b,T),D={};S("range")&&(D.range=I.Range.from(this.p)),S("label")&&(D.label=this.label),S("contextValue")&&(D.contextValue=this.contextValue??null),S("comments")&&(D.comments=this.q.map(T=>n(this,T,this.k,this.extensionDescription))),S("collapsibleState")&&(D.collapseState=l(this.g)),S("canReply")&&(D.canReply=this.canReply),S("state")&&(D.state=f(this.h)),S("applicability")&&(D.applicability=y(this.h)),S("isTemplate")&&(D.isTemplate=this.r),this.b={},u.$updateCommentThread(this.m,this.handle,this.n,this.o,D)}getCommentByUniqueId(S){for(const D of this.k){const T=D[0],v=D[1];if(S===v)return T}}async reveal(S,D){(0,P.$wH)(this.extensionDescription,"commentReveal");let T;S&&S.body!==void 0?T=S:D=D??S;let v=T?this.k.get(T):void 0;v??=this.k.get(this.q[0]);let w=!0,M=!1;return D?.focus===E.CommentThreadFocus.Reply?(M=!0,w=!1):D?.focus===E.CommentThreadFocus.Comment&&(w=!1),u.$revealCommentThread(this.m,this.handle,v,{preserveFocus:w,focusReply:M})}async hide(){return u.$hideCommentThread(this.m,this.handle)}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(S=>S.dispose())}}Ze([(0,h.$bi)(100)],o.prototype,"eventuallyUpdateCommentThread",null);class t{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(S){this.b=S,S?.resourceHints&&(0,P.$wH)(this.h,"commentingRangeHint"),u.$updateCommentingRanges(this.handle,S?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(S){this.c=S,u.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!S})}get options(){return this.d}set options(S){this.d=S,u.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,P.$wH)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,P.$wH)(this.h,"activeComment"),this.f?.value}constructor(S,D,T,v){this.h=S,this.i=D,this.j=T,this.k=v,this.a=new Map,u.$registerCommentController(this.handle,T,v,this.h.identifier.value);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(M){w.options=M},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(M){w.commentingRangeProvider=M},get reactionHandler(){return w.reactionHandler},set reactionHandler(M){w.reactionHandler=M},get activeCommentThread(){return w.activeCommentThread},createCommentThread(M,L,N){return w.createCommentThread(M,L,N).value},dispose:()=>{w.dispose()}}),this.g=[],this.g.push({dispose:()=>{u.$unregisterCommentController(this.handle)}})}createCommentThread(S,D,T){D===void 0&&(0,P.$wH)(this.h,"fileComments");const v=new o(this.id,this.handle,void 0,S,D,T,this.h,!1);return this.a.set(v.handle,v),v}$setActiveComment(S){if(!S){this.e=void 0,this.f=void 0;return}const D=this.a.get(S.commentThreadHandle);D&&(this.e=S.uniqueIdInThread?D.getCommentByUniqueId(S.uniqueIdInThread):void 0,this.f=D)}$createCommentThreadTemplate(S,D,T){const v=new o(this.id,this.handle,void 0,C.URI.revive(S),I.Range.to(D),[],this.h,!0,T);return v.collapsibleState=m.CommentThreadCollapsibleState.Expanded,this.a.set(v.handle,v),v}$updateCommentThreadTemplate(S,D){const T=this.a.get(S);T&&(T.range=I.Range.to(D))}$deleteCommentThread(S){this.a.get(S)?.dispose(),this.a.delete(S)}getCommentThread(S){return this.a.get(S)}dispose(){this.a.forEach(S=>{S.dispose()}),this.g.forEach(S=>S.dispose())}}function n(k,S,D,T){let v=D.get(S);return v||(v=++k.commentHandle,D.set(S,v)),S.state!==void 0&&(0,P.$wH)(T,"commentsDraftState"),S.reactions?.some(w=>w.reactors!==void 0)&&(0,P.$wH)(T,"commentReactor"),{mode:S.mode,contextValue:S.contextValue,uniqueIdInThread:v,body:typeof S.body=="string"?S.body:I.MarkdownString.from(S.body),userName:S.author.name,userIconPath:S.author.iconPath,label:S.label,commentReactions:S.reactions?S.reactions.map(w=>r(w)):void 0,state:S.state,timestamp:S.timestamp?.toJSON()}}function r(k){return{label:k.label,iconPath:k.iconPath?I.$CQ(k.iconPath):void 0,count:k.count,hasReacted:k.authorHasReacted,reactors:k.reactors&&k.reactors.length>0&&typeof k.reactors[0]!="string"?k.reactors.map(S=>S.name):k.reactors}}function d(k){return{label:k.label||"",count:k.count||0,iconPath:k.iconPath?C.URI.revive(k.iconPath):"",authorHasReacted:k.hasReacted||!1,reactors:k.reactors?.map(S=>({name:S}))}}function l(k){if(k!==void 0)switch(k){case E.CommentThreadCollapsibleState.Expanded:return m.CommentThreadCollapsibleState.Expanded;case E.CommentThreadCollapsibleState.Collapsed:return m.CommentThreadCollapsibleState.Collapsed}return m.CommentThreadCollapsibleState.Collapsed}function f(k){let S;if(typeof k=="object"?S=k.resolved:S=k,S!==void 0)switch(S){case E.CommentThreadState.Unresolved:return m.CommentThreadState.Unresolved;case E.CommentThreadState.Resolved:return m.CommentThreadState.Resolved}return m.CommentThreadState.Unresolved}function y(k){let S;if(typeof k=="object"&&(S=k.applicability),S!==void 0)switch(S){case E.CommentThreadApplicability.Current:return m.CommentThreadApplicability.Current;case E.CommentThreadApplicability.Outdated:return m.CommentThreadApplicability.Outdated}return m.CommentThreadApplicability.Current}return new i}}),define(Re[299],Ce([1,0,20,61,3,14,22,2,15,97,118,6,9]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0qc=void 0,m=Ue(m),E=Ue(E),g=Ue(g);class P{constructor(r,d){this.document=r,this.b=d,this.a=1,this.c=new I.$xqc("custom documents")}addEdit(r){return this.c.add([r])}async undo(r,d){await this.f(r).undo(),d||this.disposeBackup()}async redo(r,d){await this.f(r).redo(),d||this.disposeBackup()}disposeEdits(r){for(const d of r)this.c.delete(d)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const r=t(this.document.uri)+this.a++;return(0,O.$jh)(this.b,r)}updateBackup(r){this.d?.delete(),this.d=r}disposeBackup(){this.d?.delete(),this.d=void 0}f(r){const d=this.c.get(r,0);if(!d)throw new Error("No edit found");return d}}class b{constructor(){this.a=new Map}get(r,d){return this.a.get(this.b(r,d))}add(r,d,l){const f=this.b(r,d.uri);if(this.a.has(f))throw new Error(`Document already exists for viewType:${r} resource:${d.uri}`);const y=new P(d,l);return this.a.set(f,y),y}delete(r,d){const l=this.b(r,d.uri);this.a.delete(l)}b(r,d){return`${r}@@@${d}`}}var a;(function(n){n[n.Text=0]="Text",n[n.Custom=1]="Custom"})(a||(a={}));class ${constructor(){this.a=new Map}addTextProvider(r,d,l){return this.b(r,{type:a.Text,extension:d,provider:l})}addCustomProvider(r,d,l){return this.b(r,{type:a.Custom,extension:d,provider:l})}get(r){return this.a.get(r)}b(r,d){if(this.a.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this.a.set(r,d),new g.$5N(()=>this.a.delete(r))}}class p{constructor(r,d,l,f,y){this.d=d,this.f=l,this.g=f,this.h=y,this.b=new $,this.c=new b,this.a=r.getProxy(E.$3N.MainThreadCustomEditors)}registerCustomEditorProvider(r,d,l,f){const y=new R.$Wc;return i(l)?(y.add(this.b.addTextProvider(d,r,l)),this.a.$registerTextEditorProvider((0,c.$7qc)(r),d,f.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,c.$5qc)(r))):(y.add(this.b.addCustomProvider(d,r,l)),u(l)&&y.add(l.onDidChangeCustomDocument(k=>{const S=this.i(d,k.document.uri);if(o(k)){const D=S.addEdit(k);this.a.$onDidEdit(k.document.uri,d,D,k.label)}else this.a.$onContentChange(k.document.uri,d)})),this.a.$registerCustomEditorProvider((0,c.$7qc)(r),d,f.webviewOptions||{},!!f.supportsMultipleEditorsPerDocument,(0,c.$5qc)(r))),g.$5N.from(y,new g.$5N(()=>{this.a.$unregisterEditorProvider(d)}))}async $createCustomDocument(r,d,l,f,y){const k=this.b.get(d);if(!k)throw new Error(`No provider found for '${d}'`);if(k.type!==a.Custom)throw new Error(`Invalid provide type for '${d}'`);const S=C.URI.revive(r),D=await k.provider.openCustomDocument(S,{backupId:l,untitledDocumentData:f?.buffer},y);let T;return u(k.provider)&&this.f&&(T=this.f.workspaceValue(k.extension)??this.f.globalValue(k.extension)),this.c.add(d,D,T),{editable:u(k.provider)}}async $disposeCustomDocument(r,d){const l=this.b.get(d);if(!l)throw new Error(`No provider found for '${d}'`);if(l.type!==a.Custom)throw new Error(`Invalid provider type for '${d}'`);const f=C.URI.revive(r),{document:y}=this.i(d,f);this.c.delete(d,y),y.dispose()}async $resolveCustomEditor(r,d,l,f,y,k){const S=this.b.get(l);if(!S)throw new Error(`No provider found for '${l}'`);const D=m.ViewColumn.to(y),T=this.g.createNewWebview(d,f.contentOptions,S.extension),v=this.h.createNewWebviewPanel(d,l,f.title,D,f.options,T,f.active),w=C.URI.revive(r);switch(S.type){case a.Custom:{const{document:M}=this.i(l,w);return S.provider.resolveCustomEditor(M,v,k)}case a.Text:{const M=this.d.getDocument(w);return S.provider.resolveCustomTextEditor(M,v,k)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,d,l){this.i(d,r).disposeEdits(l)}async $onMoveCustomEditor(r,d,l){const f=this.b.get(l);if(!f)throw new Error(`No provider found for '${l}'`);if(!f.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const y=this.h.getWebviewPanel(r);if(!y)throw new Error("No webview found");const k=C.URI.revive(d),S=this.d.getDocument(k);await f.provider.moveCustomTextEditor(S,y,s.CancellationToken.None)}async $undo(r,d,l,f){return this.i(d,r).undo(l,f)}async $redo(r,d,l,f){return this.i(d,r).redo(l,f)}async $revert(r,d,l){const f=this.i(d,r);await this.j(d).revertCustomDocument(f.document,l),f.disposeBackup()}async $onSave(r,d,l){const f=this.i(d,r);await this.j(d).saveCustomDocument(f.document,l),f.disposeBackup()}async $onSaveAs(r,d,l,f){const y=this.i(d,r);return this.j(d).saveCustomDocumentAs(y.document,C.URI.revive(l),f)}async $backup(r,d,l){const f=this.i(d,r),k=await this.j(d).backupCustomDocument(f.document,{destination:f.getNewBackupUri()},l);return f.updateBackup(k),k.id}i(r,d){const l=this.c.get(r,C.URI.revive(d));if(!l)throw new Error("No custom document found");return l}j(r){const l=this.b.get(r)?.provider;if(!l||!u(l))throw new Error("Custom document is not editable");return l}}e.$0qc=p;function u(n){return!!n.onDidChangeCustomDocument}function i(n){return typeof n.resolveCustomTextEditor=="function"}function o(n){return typeof n.undo=="function"&&typeof n.redo=="function"}function t(n){const r=n.scheme===A.Schemas.file||n.scheme===A.Schemas.untitled?n.fsPath:n.toString();return(0,h.$wj)(r)+""}}),define(Re[300],Ce([1,0,8,147,2,6,9,15,4,11,28,64]),function(ge,e,s,h,R,A,O,C,m,c,I,E){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fqc=e.$Eqc=void 0,C=Ue(C);class P{#e;#t;#i;constructor($,p,u,i,o,t,n,r){this.d=$,this.e=p,this.f=u,this.g=i,this.h=o,this.c=!1,this.f=Math.max(i,u),this.#i=new I.$Dc(d=>t.getComparisonKey(d)),this.#e=n,this.#t=r}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set($,p){if(!$){this.clear();return}this.j();let u=[];if(R.URI.isUri($)){if(!p){this.delete($);return}this.#i.set($,p.slice()),u=[$]}else if(Array.isArray($)){u=[];let t;$=[...$].sort(P.k);for(const n of $){const[r,d]=n;if((!t||r.toString()!==t.toString())&&(t&&this.#i.get(t).length===0&&this.#i.delete(t),t=r,u.push(r),this.#i.set(r,[])),d)this.#i.get(r)?.push(...d);else{const l=this.#i.get(r);l&&(l.length=0)}}}if(this.#t.fire(u),!this.#e)return;const i=[];let o=0;for(const t of u){let n=[];const r=this.#i.get(t);if(r)if(r.length>this.g){n=[];const d=[O.DiagnosticSeverity.Error,O.DiagnosticSeverity.Warning,O.DiagnosticSeverity.Information,O.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(const f of r)if(f.severity===d[l]&&n.push({...C.Diagnostic.from(f),modelVersionId:this.h(t)})===this.g)break e;n.push({severity:h.MarkerSeverity.Info,message:(0,s.localize)(2700,null,r.length-this.g),startLineNumber:n[n.length-1].startLineNumber,startColumn:n[n.length-1].startColumn,endLineNumber:n[n.length-1].endLineNumber,endColumn:n[n.length-1].endColumn})}else n=r.map(d=>({...C.Diagnostic.from(d),modelVersionId:this.h(t)}));if(i.push([t,n]),o+=n.length,o>this.f)break}this.#e.$changeMany(this.e,i)}delete($){this.j(),this.#t.fire([$]),this.#i.delete($),this.#e?.$changeMany(this.e,[[$,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach($,p){this.j();for(const[u,i]of this)$.call(p,u,i,this)}*[Symbol.iterator](){this.j();for(const $ of this.#i.keys())yield[$,this.get($)]}get($){this.j();const p=this.#i.get($);return Array.isArray(p)?Object.freeze(p.slice(0)):[]}has($){return this.j(),Array.isArray(this.#i.get($))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k($,p){return $[0].toString()<p[0].toString()?-1:$[0].toString()>p[0].toString()?1:0}}e.$Eqc=P;let b=class{static{g=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*this.d}static _mapper($){const p=new I.$Dc;for(const u of $)p.set(u,u);return{uris:Object.freeze(Array.from(p.values()))}}constructor($,p,u,i){this.j=p,this.k=u,this.l=i,this.g=new Map,this.h=new m.$se({merge:o=>o.flat(),delay:50}),this.onDidChangeDiagnostics=m.Event.map(this.h.event,g._mapper),this.f=$.getProxy(A.$3N.MainThreadDiagnostics)}createDiagnosticCollection($,p){const{g:u,f:i,h:o,j:t,k:n,l:r}=this,d=new class{$changeMany(y,k){i.$changeMany(y,k),t.trace("[DiagnosticCollection] change many (extension, owner, uris)",$.value,y,k.length===0?"CLEARING":k)}$clear(y){i.$clear(y),t.trace("[DiagnosticCollection] remove all (extension, owner)",$.value,y)}dispose(){i.dispose()}};let l;if(!p)p="_generated_diagnostic_collection_name_#"+g.c++,l=p;else if(!u.has(p))l=p;else{this.j.warn(`DiagnosticCollection with name '${p}' does already exist.`);do l=p+g.c++;while(u.has(l))}return new class extends P{constructor(){super(p,l,g.e,g.d,y=>r.getDocument(y)?.version,n.extUri,d,o),u.set(l,this)}dispose(){super.dispose(),u.delete(l)}}}getDiagnostics($){if($)return this.m($);{const p=new Map,u=[];for(const i of this.g.values())i.forEach((o,t)=>{let n=p.get(o.toString());typeof n>"u"&&(n=u.length,p.set(o.toString(),n),u.push([o,[]])),u[n][1]=u[n][1].concat(...t)});return u}}m($){let p=[];for(const u of this.g.values())u.has($)&&(p=p.concat(u.get($)));return p}$acceptMarkersChange($){if(!this.n){const p="_generated_mirror",u=new P(p,p,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(p,u),this.n=u}for(const[p,u]of $)this.n.set(R.URI.revive(p),u.map(C.Diagnostic.to))}};e.$Fqc=b,e.$Fqc=b=g=Ze([qe(1,c.$dk),qe(2,E.$Dqc)],b)}),define(Re[301],Ce([1,0,2,12,9,15,82,53]),function(ge,e,s,h,R,A,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Src=void 0;class m{constructor(I,E,g,P={timeout:1500,errors:3}){this.c=I,this.d=E,this.f=g,this.g=P,this.a=new O.$8c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(I){return(E,g,P)=>{const a={dispose:this.a.push([E,g,I])};return Array.isArray(P)&&P.push(a),a}}async $participateInSave(I,E){const g=s.URI.revive(I);let P=!1;const b=setTimeout(()=>P=!0,this.g.timeout),a=[];try{for(const $ of[...this.a]){if(P)break;const p=this.d.getDocument(g),u=await this.h($,{document:p,reason:A.TextDocumentSaveReason.to(E)});a.push(u)}}finally{clearTimeout(b)}return a}h([I,E,g],P){const b=this.b.get(I);return typeof b=="number"&&b>this.g.errors?Promise.resolve(!1):this.i(g,I,E,P).then(()=>!0,a=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${g.identifier.value}' threw ERROR`),this.c.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const $=this.b.get(I);this.b.set(I,$?$+1:1),typeof $=="number"&&$>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${g.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(I,E,g,P){const b=[],a=Date.now(),{document:$,reason:p}=P,{version:u}=$,i=Object.freeze({document:$,reason:p,waitUntil(o){if(Object.isFrozen(b))throw(0,h.$0)("waitUntil can not be called async");b.push(Promise.resolve(o))}});try{E.apply(g,[i])}catch(o){return Promise.reject(o)}return Object.freeze(b),new Promise((o,t)=>{const n=setTimeout(()=>t(new Error("timeout")),this.g.timeout);return Promise.all(b).then(r=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(n),o(r)}).catch(r=>{clearTimeout(n),t(r)})}).then(o=>{const t={edits:[]};for(const n of o)if(Array.isArray(n)&&n.every(r=>r instanceof R.$bO))for(const{newText:r,newEol:d,range:l}of n)t.edits.push({resource:$.uri,versionId:void 0,textEdit:{range:l&&A.Range.from(l),text:r,eol:d&&A.EndOfLine.from(d)}});if(t.edits.length!==0)return u===$.version?this.f.$tryApplyWorkspaceEdit(new C.$5w(t)):Promise.reject(new Error("concurrent_edits"))})}}e.$Src=m}),define(Re[302],Ce([1,0,4,3,2,6,167,15,17,24,9]),function(ge,e,s,h,R,A,O,C,m,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gqc=void 0,C=Ue(C);class E{constructor(P,b){this.a=new s.$oe,this.b=new s.$oe,this.c=new s.$oe,this.d=new s.$oe,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new h.$Wc,this.h=new Map,this.f=P.getProxy(A.$3N.MainThreadDocuments),this.g=b,this.g.onDidRemoveDocuments(a=>{for(const $ of a)this.b.fire($.document)},void 0,this.e),this.g.onDidAddDocuments(a=>{for(const $ of a)this.a.fire($.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(P){if(!P)return;const b=this.g.getDocument(P);if(b)return b}getDocument(P){const b=this.getDocumentData(P);if(!b?.document)throw new Error(`Unable to retrieve document from URI '${P}'`);return b.document}ensureDocumentData(P){const b=this.g.getDocument(P);if(b)return Promise.resolve(b);let a=this.h.get(P.toString());return a||(a=this.f.$tryOpenDocument(P).then($=>{this.h.delete(P.toString());const p=R.URI.revive($);return(0,m.$sg)(this.g.getDocument(p))},$=>(this.h.delete(P.toString()),Promise.reject($))),this.h.set(P.toString(),a)),a}createDocumentData(P){return this.f.$tryCreateDocument(P).then(b=>R.URI.revive(b))}$acceptModelLanguageChanged(P,b){const a=R.URI.revive(P),$=this.g.getDocument(a);if(!$)throw new Error("unknown document");this.b.fire($.document),$._acceptLanguageId(b),this.a.fire($.document)}$acceptModelSaved(P){const b=R.URI.revive(P),a=this.g.getDocument(b);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(P,!1),this.d.fire(a.document)}$acceptDirtyStateChanged(P,b){const a=R.URI.revive(P),$=this.g.getDocument(a);if(!$)throw new Error("unknown document");$._acceptIsDirty(b),this.c.fire({document:$.document,contentChanges:[],reason:void 0})}$acceptModelChanged(P,b,a){const $=R.URI.revive(P),p=this.g.getDocument($);if(!p)throw new Error("unknown document");p._acceptIsDirty(a),p.onEvents(b);let u;b.isUndoing?u=I.TextDocumentChangeReason.Undo:b.isRedoing&&(u=I.TextDocumentChangeReason.Redo),this.c.fire((0,c.$jo)({document:p.document,contentChanges:b.changes.map(i=>({range:C.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:u}))}setWordDefinitionFor(P,b){(0,O.$FQ)(P,b)}}e.$Gqc=E}),define(Re[79],Ce([1,0,80,4,17,2,5,6,19,15,9]),function(ge,e,s,h,R,A,O,C,m,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_qc=e.$$qc=void 0,c=Ue(c),e.$$qc=(0,O.$Ii)("IExtHostEditorTabs");class E{constructor($,p,u){this.e=u,this.d=p,this.acceptDtoUpdate($)}get apiObject(){if(!this.a){const $=this,p={get isActive(){return $.b.id===$.e()},get label(){return $.b.label},get input(){return $.c},get isDirty(){return $.b.isDirty},get isPinned(){return $.b.isPinned},get isPreview(){return $.b.isPreview},get group(){return $.d.apiObject}};this.a=Object.freeze(p)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate($){this.b=$,this.c=this.f()}f(){switch(this.b.input.kind){case C.TabInputKind.TextInput:return new I.$SP(A.URI.revive(this.b.input.uri));case C.TabInputKind.TextDiffInput:return new I.$TP(A.URI.revive(this.b.input.original),A.URI.revive(this.b.input.modified));case C.TabInputKind.TextMergeInput:return new I.$UP(A.URI.revive(this.b.input.base),A.URI.revive(this.b.input.input1),A.URI.revive(this.b.input.input2),A.URI.revive(this.b.input.result));case C.TabInputKind.CustomEditorInput:return new I.$VP(A.URI.revive(this.b.input.uri),this.b.input.viewType);case C.TabInputKind.WebviewEditorInput:return new I.$WP(this.b.input.viewType);case C.TabInputKind.NotebookInput:return new I.$XP(A.URI.revive(this.b.input.uri),this.b.input.notebookType);case C.TabInputKind.NotebookDiffInput:return new I.$YP(A.URI.revive(this.b.input.original),A.URI.revive(this.b.input.modified),this.b.input.notebookType);case C.TabInputKind.TerminalEditorInput:return new I.$ZP;case C.TabInputKind.InteractiveEditorInput:return new I.$1P(A.URI.revive(this.b.input.uri),A.URI.revive(this.b.input.inputBoxUri));case C.TabInputKind.ChatEditorInput:return new I.$2P;case C.TabInputKind.MultiDiffEditorInput:return new I.$3P(this.b.input.diffEditors.map($=>new I.$TP(A.URI.revive($.original),A.URI.revive($.modified))));default:return}}}class g{constructor($,p){this.c=[],this.d="",this.b=$,this.e=p;for(const u of $.tabs)u.isActive&&(this.d=u.id),this.c.push(new E(u,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const $=this,p={get isActive(){return $.b.groupId===$.e()},get viewColumn(){return c.ViewColumn.to($.b.viewColumn)},get activeTab(){return $.c.find(u=>u.tabId===$.d)?.apiObject},get tabs(){return Object.freeze($.c.map(u=>u.apiObject))}};this.a=Object.freeze(p)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate($){this.b=$}acceptTabOperation($){if($.kind===C.TabModelOperationKind.TAB_OPEN){const u=new E($.tabDto,this,()=>this.activeTabId());return this.c.splice($.index,0,u),$.tabDto.isActive&&(this.d=u.tabId),u}else if($.kind===C.TabModelOperationKind.TAB_CLOSE){const u=this.c.splice($.index,1)[0];if(!u)throw new Error(`Tab close updated received for index ${$.index} which does not exist`);return u.tabId===this.d&&(this.d=""),u}else if($.kind===C.TabModelOperationKind.TAB_MOVE){if($.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const u=this.c.splice($.oldIndex,1)[0];if(!u)throw new Error(`Tab move updated received for index ${$.oldIndex} which does not exist`);return this.c.splice($.index,0,u),u}const p=this.c.find(u=>u.tabId===$.tabDto.id);if(!p)throw new Error("INVALID tab");return $.tabDto.isActive?this.d=$.tabDto.id:this.d===$.tabDto.id&&!$.tabDto.isActive&&(this.d=""),p.acceptDtoUpdate($.tabDto),p}activeTabId(){return this.d}}let P=class{constructor($){this.b=new h.$oe,this.c=new h.$oe,this.e=[],this.a=$.getProxy(C.$3N.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const $=this,p={onDidChangeTabGroups:$.c.event,onDidChangeTabs:$.b.event,get all(){return Object.freeze($.e.map(u=>u.apiObject))},get activeTabGroup(){const u=$.d;return(0,R.$sg)($.e.find(o=>o.groupId===u)?.apiObject)},close:async(u,i)=>{const o=Array.isArray(u)?u:[u];return o.length?b(o[0])?this.j(o,i):this.i(o,i):!0}};this.f=Object.freeze(p)}return this.f}$acceptEditorTabModel($){const p=new Set(this.e.map(d=>d.groupId)),u=new Set($.map(d=>d.groupId)),i=(0,s.$d)(p,u),o=this.e.filter(d=>i.removed.includes(d.groupId)).map(d=>d.apiObject),t=[],n=[];this.e=$.map(d=>{const l=new g(d,()=>this.d);return i.added.includes(l.groupId)?t.push(l.apiObject):n.push(l.apiObject),l});const r=(0,R.$sg)($.find(d=>d.isActive===!0)?.groupId);r!==void 0&&this.d!==r&&(this.d=r),this.c.fire(Object.freeze({opened:t,closed:o,changed:n}))}$acceptTabGroupUpdate($){const p=this.e.find(u=>u.groupId===$.groupId);if(!p)throw new Error("Update Group IPC call received before group creation.");p.acceptGroupDtoUpdate($),$.isActive&&(this.d=$.groupId),this.c.fire(Object.freeze({changed:[p.apiObject],opened:[],closed:[]}))}$acceptTabOperation($){const p=this.e.find(i=>i.groupId===$.groupId);if(!p)throw new Error("Update Tabs IPC call received before group creation.");const u=p.acceptTabOperation($);switch($.kind){case C.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[u.apiObject],closed:[],changed:[]}));return;case C.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[u.apiObject],changed:[]}));return;case C.TabModelOperationKind.TAB_MOVE:case C.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[u.apiObject]}));return}}g($){for(const p of this.e)for(const u of p.tabs)if(u.apiObject===$)return u}h($){return this.e.find(p=>p.apiObject===$)}async i($,p){const u=[];for(const i of $){const o=this.g(i);if(!o)throw new Error("Tab close: Invalid tab not found!");u.push(o.tabId)}return this.a.$closeTab(u,p)}async j($,p){const u=[];for(const i of $){const o=this.h(i);if(!o)throw new Error("Group close: Invalid group not found!");u.push(o.groupId)}return this.a.$closeGroup(u,p)}};e.$_qc=P,e.$_qc=P=Ze([qe(0,m.$DQ)],P);function b(a){return a.tabs!==void 0}}),define(Re[303],Ce([1,0,2,6,27,3,9,15,205,13,26,21,25,86]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vrc=void 0,R=Ue(R),C=Ue(C);class b{constructor(){this.a=[]}add(p){this.b=void 0,this.a.push(p)}delete(p){const u=this.a.indexOf(p);u>=0&&(this.a.splice(u,1),this.b=void 0)}c(){if(!this.b){const p=this.a.sort(),u=[];let i,o,t=m.State.LastKnownState,n=m.State.LastKnownState;for(const r of p){let d=i?(0,c.$Kf)(i,r):0;for(d===0?o=m.State.Start:o=n;d<r.length;d++)d+1===r.length?(t=n,n=m.State.BeforeColon):n+=1,u.push([o,r.toUpperCase().charCodeAt(d),n]),u.push([o,r.toLowerCase().charCodeAt(d),n]),o=n;i=r,n=t}u.push([m.State.BeforeColon,I.CharCode.Colon,m.State.AfterColon]),u.push([m.State.AfterColon,I.CharCode.Slash,m.State.End]),this.b=new m.$34(u)}}provideDocumentLinks(p){this.c();const u=[],i=m.$44.computeLinks({getLineContent(o){return p.lineAt(o-1).text},getLineCount(){return p.lineCount}},this.b);for(const o of i){const t=C.DocumentLink.to(o);t.target&&u.push(t)}return u}}class a{constructor(p,u){this.i=u,this.b=new b,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=p.getProxy(h.$3N.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(p,u,i,o={}){if(a.j(i),this.d.has(u))throw new Error(`a provider for the scheme '${u}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(p,"*",this.b));const t=this.h++;this.b.add(u),this.d.add(u),this.c.set(t,i);let n=R.FileSystemProviderCapabilities.FileReadWrite;o.isCaseSensitive&&(n+=R.FileSystemProviderCapabilities.PathCaseSensitive),o.isReadonly&&(n+=R.FileSystemProviderCapabilities.Readonly),typeof i.copy=="function"&&(n+=R.FileSystemProviderCapabilities.FileFolderCopy),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,g.$wH)(p,"fsChunks"),n+=R.FileSystemProviderCapabilities.FileOpenReadWriteClose);let r;o.isReadonly&&(0,P.$9k)(o.isReadonly)&&o.isReadonly.value!==""&&(r={value:o.isReadonly.value,isTrusted:o.isReadonly.isTrusted,supportThemeIcons:o.isReadonly.supportThemeIcons,supportHtml:o.isReadonly.supportHtml,baseUri:o.isReadonly.baseUri,uris:o.isReadonly.uris}),this.a.$registerFileSystemProvider(t,u,n,r).catch(l=>{console.error(`FAILED to register filesystem provider of ${p.identifier.value}-extension for the scheme ${u}`),console.error(l)});const d=i.onDidChangeFile(l=>{const f=[];for(const y of l){const{uri:k,type:S}=y;if(k.scheme!==u)continue;let D;switch(S){case O.FileChangeType.Changed:D=R.FileChangeType.UPDATED;break;case O.FileChangeType.Created:D=R.FileChangeType.ADDED;break;case O.FileChangeType.Deleted:D=R.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}f.push({resource:k,type:D})}this.a.$onFileSystemChange(t,f)});return(0,A.$Vc)(()=>{d.dispose(),this.b.delete(u),this.d.delete(u),this.c.delete(t),this.a.$unregisterProvider(t)})}static j(p){if(!p)throw new Error("MISSING provider");if(typeof p.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof p.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof p.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof p.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof p.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof p.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof p.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof p.rename!="function")throw new Error("Provider does NOT implement rename")}static k(p){const{type:u,ctime:i,mtime:o,size:t,permissions:n}=p;return{type:u,ctime:i,mtime:o,size:t,permissions:n}}$stat(p,u){return Promise.resolve(this.l(p).stat(s.URI.revive(u))).then(i=>a.k(i))}$readdir(p,u){return Promise.resolve(this.l(p).readDirectory(s.URI.revive(u)))}$readFile(p,u){return Promise.resolve(this.l(p).readFile(s.URI.revive(u))).then(i=>E.$Qe.wrap(i))}$writeFile(p,u,i,o){return Promise.resolve(this.l(p).writeFile(s.URI.revive(u),i.buffer,o))}$delete(p,u,i){return Promise.resolve(this.l(p).delete(s.URI.revive(u),i))}$rename(p,u,i,o){return Promise.resolve(this.l(p).rename(s.URI.revive(u),s.URI.revive(i),o))}$copy(p,u,i,o){const t=this.l(p);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(s.URI.revive(u),s.URI.revive(i),o))}$mkdir(p,u){return Promise.resolve(this.l(p).createDirectory(s.URI.revive(u)))}$watch(p,u,i,o){const t=this.l(p).watch(s.URI.revive(i),o);this.f.set(u,t)}$unwatch(p,u){const i=this.f.get(u);i&&(i.dispose(),this.f.delete(u))}$open(p,u,i){const o=this.l(p);if(!o.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(o.open(s.URI.revive(u),i))}$close(p,u){const i=this.l(p);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(u))}$read(p,u,i,o){const t=this.l(p);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const n=E.$Qe.alloc(o);return Promise.resolve(t.read(u,i,n.buffer,0,o)).then(r=>n.slice(0,r))}$write(p,u,i,o){const t=this.l(p);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(u,i,o.buffer,0,o.byteLength))}l(p){const u=this.c.get(p);if(!u){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return u}}e.$Vrc=a}),define(Re[304],Ce([1,0,4,39,2,6,15,9,27,50]),function(ge,e,s,h,R,A,O,C,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wrc=void 0,O=Ue(O);class I{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(b,a,$,p,u,i){this.a=Math.random(),this.b=new s.$oe,this.c=new s.$oe,this.d=new s.$oe,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const o=(0,h.$Dk)(u),t=typeof u=="string",n=i?.correlate,r=p(d=>{if(!(typeof d.session=="number"&&d.session!==this.a)&&!(n&&typeof d.session>"u")){if(!i?.ignoreCreateEvents)for(const l of d.created){const f=R.URI.revive(l);o(f.fsPath)&&(!t||a.getWorkspaceFolder(f))&&this.b.fire(f)}if(!i?.ignoreChangeEvents)for(const l of d.changed){const f=R.URI.revive(l);o(f.fsPath)&&(!t||a.getWorkspaceFolder(f))&&this.c.fire(f)}if(!i?.ignoreDeleteEvents)for(const l of d.deleted){const f=R.URI.revive(l);o(f.fsPath)&&(!t||a.getWorkspaceFolder(f))&&this.d.fire(f)}}});this.g=C.$5N.from(this.i(b,$,u,i,i?.correlate),this.b,this.c,this.d,r)}i(b,a,$,p,u){const i=C.$5N.from();if(typeof $=="string"||p?.ignoreChangeEvents&&p?.ignoreCreateEvents&&p?.ignoreDeleteEvents)return i;const o=b.getProxy(A.$3N.MainThreadFileSystemEventService);let t=!1;($.pattern.includes(h.$zk)||$.pattern.includes(h.$Ak))&&(t=!0);let n;return u&&(p?.ignoreChangeEvents||p?.ignoreCreateEvents||p?.ignoreDeleteEvents)&&(n=m.FileChangeFilter.UPDATED|m.FileChangeFilter.ADDED|m.FileChangeFilter.DELETED,p?.ignoreChangeEvents&&(n&=~m.FileChangeFilter.UPDATED),p?.ignoreCreateEvents&&(n&=~m.FileChangeFilter.ADDED),p?.ignoreDeleteEvents&&(n&=~m.FileChangeFilter.DELETED)),o.$watch(a.identifier.value,this.a,$.baseUri,{recursive:t,excludes:p?.excludes??[],filter:n},!!u),C.$5N.from({dispose:()=>o.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class E{constructor(b){this.a=b,this.session=this.a.session,this.b=new c.$W(()=>this.a.created.map(R.URI.revive)),this.c=new c.$W(()=>this.a.changed.map(R.URI.revive)),this.d=new c.$W(()=>this.a.deleted.map(R.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class g{constructor(b,a,$){this.j=b,this.k=a,this.l=$,this.a=new s.$oe,this.b=new s.$oe,this.c=new s.$oe,this.d=new s.$oe,this.g=new s.$qe,this.h=new s.$qe,this.i=new s.$qe,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(b,a,$,p){return new I(this.j,b,a,this.a.event,O.GlobPattern.from($),p)}$onFileEvent(b){this.a.fire(new E(b))}$onDidRunFileOperation(b,a){switch(b){case m.FileOperation.MOVE:this.b.fire(Object.freeze({files:a.map($=>({oldUri:R.URI.revive($.source),newUri:R.URI.revive($.target)}))}));break;case m.FileOperation.DELETE:this.d.fire(Object.freeze({files:a.map($=>R.URI.revive($.target))}));break;case m.FileOperation.CREATE:case m.FileOperation.COPY:this.c.fire(Object.freeze({files:a.map($=>R.URI.revive($.target))}));break;default:}}getOnWillRenameFileEvent(b){return this.m(b,this.g)}getOnWillCreateFileEvent(b){return this.m(b,this.h)}getOnWillDeleteFileEvent(b){return this.m(b,this.i)}m(b,a){return($,p,u)=>{const i=function(t){$.call(p,t)};return i.extension=b,a.event(i,void 0,u)}}async $onWillRunFileOperation(b,a,$,p){switch(b){case m.FileOperation.MOVE:return await this.n(this.g,{files:a.map(u=>({oldUri:R.URI.revive(u.source),newUri:R.URI.revive(u.target)}))},$,p);case m.FileOperation.DELETE:return await this.n(this.i,{files:a.map(u=>R.URI.revive(u.target))},$,p);case m.FileOperation.CREATE:case m.FileOperation.COPY:return await this.n(this.h,{files:a.map(u=>R.URI.revive(u.target))},$,p)}}async n(b,a,$,p){const u=new Set,i=[];if(await b.fireAsync(a,p,async(t,n)=>{const r=Date.now(),d=await Promise.resolve(t);d instanceof C.$eO&&(i.push([n.extension,d]),u.add(n.extension.displayName??n.extension.identifier.value)),Date.now()-r>$&&this.k.warn("SLOW file-participant",n.extension.identifier)}),p.isCancellationRequested||i.length===0)return;const o={edits:[]};for(const[,t]of i){const{edits:n}=O.WorkspaceEdit.from(t,{getTextDocumentVersion:r=>this.l.getDocument(r)?.version,getNotebookDocumentVersion:()=>{}});o.edits=o.edits.concat(n)}return{edit:o,extensionNames:Array.from(u)}}}e.$Wrc=g}),define(Re[305],Ce([1,0,18,7,20,12,133,3,24,43,13,17,2,30,198,88,144,8,23,15,9,25,118,6]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P,b,a,$,p,u,i,o,t,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hqc=void 0,a=Ue(a),i=Ue(i),r=Ue(r);class d{constructor(H,G){this.d=H,this.e=G}async provideDocumentSymbols(H,G){const Z=this.d.getDocument(H),ee=await this.e.provideDocumentSymbols(Z,G);if(!(0,s.$Mb)(ee))return ee[0]instanceof o.$oO?ee.map(i.DocumentSymbol.from):d.f(ee)}static f(H){H=H.slice(0).sort((ee,le)=>{let ye=ee.location.range.start.compareTo(le.location.range.start);return ye===0&&(ye=le.location.range.end.compareTo(ee.location.range.end)),ye});const G=[],Z=[];for(const ee of H){const le={name:ee.name||"!!MISSING: name!!",kind:i.SymbolKind.from(ee.kind),tags:ee.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:ee.containerName,range:i.Range.from(ee.location.range),selectionRange:i.Range.from(ee.location.range),children:[]};for(;;){if(Z.length===0){Z.push(le),G.push(le);break}const ye=Z[Z.length-1];if(P.$Ut.containsRange(ye.range,le.range)&&!P.$Ut.equalsRange(ye.range,le.range)){ye.children?.push(le),Z.push(le);break}Z.pop()}}return G}}class l{constructor(H,G,Z,ee,le,ye){this.f=H,this.g=G,this.h=Z,this.j=ee,this.k=le,this.l=ye,this.d=new n.$xqc("CodeLens"),this.e=new Map}async provideCodeLenses(H,G){const Z=this.f.getDocument(H),ee=await this.h.provideCodeLenses(Z,G);if(!ee||G.isCancellationRequested)return;const le=this.d.add(ee),ye=new C.$Wc;this.e.set(le,ye);const Te={cacheId:le,lenses:[]};for(let Ve=0;Ve<ee.length;Ve++)Te.lenses.push({cacheId:[le,Ve],range:i.Range.from(ee[Ve].range),command:this.g.toInternal(ee[Ve].command,ye)});return Te}async resolveCodeLens(H,G){const Z=H.cacheId&&this.d.get(...H.cacheId);if(!Z)return;let ee;if(typeof this.h.resolveCodeLens!="function"||Z.isResolved?ee=Z:ee=await this.h.resolveCodeLens(Z,G),ee||(ee=Z),G.isCancellationRequested)return;const le=H.cacheId&&this.e.get(H.cacheId[0]);if(le){if(!ee.command){const ye=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,ye),this.l.error(ye);return}return H.command=this.g.toInternal(ee.command,le),H}}releaseCodeLenses(H){this.e.get(H)?.dispose(),this.e.delete(H),this.d.delete(H)}}function f(Ne){return Array.isArray(Ne)?Ne.map(i.DefinitionLink.from):Ne?[i.DefinitionLink.from(Ne)]:[]}class y{constructor(H,G){this.d=H,this.e=G}async provideDefinition(H,G,Z){const ee=this.d.getDocument(H),le=i.Position.to(G),ye=await this.e.provideDefinition(ee,le,Z);return f(ye)}}class k{constructor(H,G){this.d=H,this.e=G}async provideDeclaration(H,G,Z){const ee=this.d.getDocument(H),le=i.Position.to(G),ye=await this.e.provideDeclaration(ee,le,Z);return f(ye)}}class S{constructor(H,G){this.d=H,this.e=G}async provideImplementation(H,G,Z){const ee=this.d.getDocument(H),le=i.Position.to(G),ye=await this.e.provideImplementation(ee,le,Z);return f(ye)}}class D{constructor(H,G){this.d=H,this.e=G}async provideTypeDefinition(H,G,Z){const ee=this.d.getDocument(H),le=i.Position.to(G),ye=await this.e.provideTypeDefinition(ee,le,Z);return f(ye)}}class T{static{this.f=10}constructor(H,G){this.g=H,this.h=G,this.d=0,this.e=new Map}async provideHover(H,G,Z,ee){const le=this.g.getDocument(H),ye=i.Position.to(G);let Te;if(Z&&Z.verbosityRequest){const ot=Z.verbosityRequest.previousHover.id,ut=this.e.get(ot);if(!ut)throw new Error(`Hover with id ${ot} not found`);const at={verbosityDelta:Z.verbosityRequest.verbosityDelta,previousHover:ut};Te=await this.h.provideHover(le,ye,ee,at)}else Te=await this.h.provideHover(le,ye,ee);if(!Te||(0,s.$Mb)(Te.contents))return;Te.range||(Te.range=le.getWordRangeAtPosition(ye)),Te.range||(Te.range=new o.$7N(ye,ye));const Ve=i.Hover.from(Te),Ke=this.d;if(this.e.size===T.f){const ot=Math.min(...this.e.keys());this.e.delete(ot)}return this.e.set(Ke,Te),this.d+=1,{...Ve,id:Ke}}releaseHover(H){this.e.delete(H)}}class v{constructor(H,G){this.d=H,this.e=G}async provideEvaluatableExpression(H,G,Z){const ee=this.d.getDocument(H),le=i.Position.to(G),ye=await this.e.provideEvaluatableExpression(ee,le,Z);if(ye)return i.EvaluatableExpression.from(ye)}}class w{constructor(H,G){this.d=H,this.e=G}async provideInlineValues(H,G,Z,ee){const le=this.d.getDocument(H),ye=await this.e.provideInlineValues(le,i.Range.to(G),i.InlineValueContext.to(Z),ee);if(Array.isArray(ye))return ye.map(Te=>i.InlineValue.from(Te))}}class M{constructor(H,G){this.d=H,this.e=G}async provideDocumentHighlights(H,G,Z){const ee=this.d.getDocument(H),le=i.Position.to(G),ye=await this.e.provideDocumentHighlights(ee,le,Z);if(Array.isArray(ye))return ye.map(i.DocumentHighlight.from)}}class L{constructor(H,G){this.d=H,this.e=G}async provideMultiDocumentHighlights(H,G,Z,ee){const le=this.d.getDocument(H),ye=Z.map(Ke=>this.d.getDocument(Ke)),Te=i.Position.to(G),Ve=await this.e.provideMultiDocumentHighlights(le,Te,ye,ee);if(Array.isArray(Ve))return Ve.map(i.MultiDocumentHighlight.from)}}class N{constructor(H,G){this.d=H,this.e=G}async provideLinkedEditingRanges(H,G,Z){const ee=this.d.getDocument(H),le=i.Position.to(G),ye=await this.e.provideLinkedEditingRanges(ee,le,Z);if(ye&&Array.isArray(ye.ranges))return{ranges:(0,s.$Jb)(ye.ranges.map(i.Range.from)),wordPattern:ye.wordPattern}}}class F{constructor(H,G){this.d=H,this.e=G}async provideReferences(H,G,Z,ee){const le=this.d.getDocument(H),ye=i.Position.to(G),Te=await this.e.provideReferences(le,ye,Z,ee);if(Array.isArray(Te))return Te.map(i.location.from)}}class V{static{this.d=1e3}constructor(H,G,Z,ee,le,ye,Te){this.g=H,this.h=G,this.j=Z,this.k=ee,this.l=le,this.m=ye,this.n=Te,this.e=new n.$xqc("CodeAction"),this.f=new Map}async provideCodeActions(H,G,Z,ee){const le=this.g.getDocument(H),ye=b.$Wt.isISelection(G)?i.Selection.to(G):i.Range.to(G),Te=[];for(const at of this.j.getDiagnostics(H))if(ye.intersection(at.range)&&Te.push(at)>V.d)break;const Ve={diagnostics:Te,only:Z.only?new o.$qO(Z.only):void 0,triggerKind:i.CodeActionTriggerKind.to(Z.trigger)},Ke=await this.k.provideCodeActions(le,ye,Ve,ee);if(!(0,s.$Nb)(Ke)||ee.isCancellationRequested)return;const rt=this.e.add(Ke),ot=new C.$Wc;this.f.set(rt,ot);const ut=[];for(let at=0;at<Ke.length;at++){const lt=Ke[at];if(lt)if(V.o(lt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),ut.push({_isSynthetic:!0,title:lt.title,command:this.h.toInternal(lt,ot)});else{Ve.only&&(lt.kind?Ve.only.contains(lt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value}' requested but returned code action is of kind '${lt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value}' requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const $t=lt.ranges??[];ut.push({cacheId:[rt,at],title:lt.title,command:lt.command&&this.h.toInternal(lt.command,ot),diagnostics:lt.diagnostics&&lt.diagnostics.map(i.Diagnostic.from),edit:lt.edit&&i.WorkspaceEdit.from(lt.edit,void 0),kind:lt.kind&&lt.kind.value,isPreferred:lt.isPreferred,isAI:(0,t.$vH)(this.m,"codeActionAI")?lt.isAI:!1,ranges:(0,t.$vH)(this.m,"codeActionRanges")?(0,s.$Jb)($t.map(i.Range.from)):void 0,disabled:lt.disabled?.reason})}}return{cacheId:rt,actions:ut}}async resolveCodeAction(H,G){const[Z,ee]=H,le=this.e.get(Z,ee);if(!le||V.o(le))return{};if(!this.k.resolveCodeAction)return{};const ye=await this.k.resolveCodeAction(le,G)??le;let Te;ye.edit&&(Te=i.WorkspaceEdit.from(ye.edit,void 0));let Ve;if(ye.command){const Ke=this.f.get(Z);Ke&&(Ve=this.h.toInternal(ye.command,Ke))}return{edit:Te,command:Ve}}releaseCodeActions(H){this.f.get(H)?.dispose(),this.f.delete(H),this.e.delete(H)}static o(H){return typeof H.command=="string"&&typeof H.title=="string"}}class j{constructor(H,G,Z,ee,le){this.e=H,this.f=G,this.g=Z,this.h=ee,this.j=le,this.d=new n.$xqc("DocumentPasteEdit")}async prepareDocumentPaste(H,G,Z,ee){if(!this.g.prepareDocumentPaste)return;const le=this.f.getDocument(H),ye=G.map(Ke=>i.Range.to(Ke)),Te=i.DataTransfer.toDataTransfer(Z,()=>{throw new A.$ab});if(await this.g.prepareDocumentPaste(le,ye,Te,ee),ee.isCancellationRequested)return;const Ve=Array.from(Te).filter(([,Ke])=>!(Ke instanceof o.$WO));return i.DataTransfer.from(Ve)}async providePasteEdits(H,G,Z,ee,le,ye){if(!this.g.provideDocumentPasteEdits)return[];const Te=this.f.getDocument(G),Ve=Z.map(ut=>i.Range.to(ut)),Ke=i.DataTransfer.toDataTransfer(ee,async ut=>(await this.e.$resolvePasteFileData(this.h,H,ut)).buffer),rt=await this.g.provideDocumentPasteEdits(Te,Ve,Ke,{only:le.only?new o.$2O(le.only):void 0,triggerKind:le.triggerKind},ye);if(!rt||ye.isCancellationRequested)return[];const ot=this.d.add(rt);return rt.map((ut,at)=>({_cacheId:[ot,at],title:ut.title??(0,p.localize)(2703,null,this.j.displayName||this.j.name),kind:ut.kind,yieldTo:ut.yieldTo?.map(lt=>lt.value),insertText:typeof ut.insertText=="string"?ut.insertText:{snippet:ut.insertText.value},additionalEdit:ut.additionalEdit?i.WorkspaceEdit.from(ut.additionalEdit,void 0):void 0}))}async resolvePasteEdit(H,G){const[Z,ee]=H,le=this.d.get(Z,ee);if(!le||!this.g.resolveDocumentPasteEdit)return{};const ye=await this.g.resolveDocumentPasteEdit(le,G)??le;return{additionalEdit:ye.additionalEdit?i.WorkspaceEdit.from(ye.additionalEdit,void 0):void 0}}releasePasteEdits(H){this.d.delete(H)}}class U{constructor(H,G){this.d=H,this.e=G}async provideDocumentFormattingEdits(H,G,Z){const ee=this.d.getDocument(H),le=await this.e.provideDocumentFormattingEdits(ee,G,Z);if(Array.isArray(le))return le.map(i.TextEdit.from)}}class z{constructor(H,G){this.d=H,this.e=G}async provideDocumentRangeFormattingEdits(H,G,Z,ee){const le=this.d.getDocument(H),ye=i.Range.to(G),Te=await this.e.provideDocumentRangeFormattingEdits(le,ye,Z,ee);if(Array.isArray(Te))return Te.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(H,G,Z,ee){(0,E.$rg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const le=this.d.getDocument(H),ye=G.map(i.Range.to),Te=await this.e.provideDocumentRangesFormattingEdits(le,ye,Z,ee);if(Array.isArray(Te))return Te.map(i.TextEdit.from)}}class _{constructor(H,G){this.d=H,this.e=G,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(H,G,Z,ee,le){const ye=this.d.getDocument(H),Te=i.Position.to(G),Ve=await this.e.provideOnTypeFormattingEdits(ye,Te,Z,ee,le);if(Array.isArray(Ve))return Ve.map(i.TextEdit.from)}}class W{constructor(H,G){this.e=H,this.f=G,this.d=new n.$xqc("WorkspaceSymbols")}async provideWorkspaceSymbols(H,G){const Z=await this.e.provideWorkspaceSymbols(H,G);if(!(0,s.$Nb)(Z))return{symbols:[]};const ee=this.d.add(Z),le={cacheId:ee,symbols:[]};for(let ye=0;ye<Z.length;ye++){const Te=Z[ye];if(!Te||!Te.name){this.f.warn("INVALID SymbolInformation",Te);continue}le.symbols.push({...i.WorkspaceSymbol.from(Te),cacheId:[ee,ye]})}return le}async resolveWorkspaceSymbol(H,G){if(typeof this.e.resolveWorkspaceSymbol!="function"||!H.cacheId)return H;const Z=this.d.get(...H.cacheId);if(Z){const ee=await this.e.resolveWorkspaceSymbol(Z,G);return ee&&(0,m.$lo)(H,i.WorkspaceSymbol.from(ee),!0)}}releaseWorkspaceSymbols(H){this.d.delete(H)}}class B{static supportsResolving(H){return typeof H.prepareRename=="function"}constructor(H,G,Z){this.d=H,this.e=G,this.f=Z}async provideRenameEdits(H,G,Z,ee){const le=this.d.getDocument(H),ye=i.Position.to(G);try{const Te=await this.e.provideRenameEdits(le,ye,Z,ee);return Te?i.WorkspaceEdit.from(Te):void 0}catch(Te){const Ve=B.g(Te);return Ve?{rejectReason:Ve,edits:void 0}:Promise.reject(Te)}}async resolveRenameLocation(H,G,Z){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const ee=this.d.getDocument(H),le=i.Position.to(G);try{const ye=await this.e.prepareRename(ee,le,Z);let Te,Ve;if(o.$7N.isRange(ye)?(Te=ye,Ve=ee.getText(ye)):(0,E.$jg)(ye)&&(Te=ye.range,Ve=ye.placeholder),!Te||!Ve)return;if(Te.start.line>le.line||Te.end.line<le.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Te),text:Ve}}catch(ye){const Te=B.g(ye);return Te?{rejectReason:Te,range:void 0,text:void 0}:Promise.reject(ye)}}static g(H){return typeof H=="string"?H:H instanceof Error&&typeof H.message=="string"?H.message:void 0}}class Y{static{this.d={[a.NewSymbolNameTriggerKind.Invoke]:o.NewSymbolNameTriggerKind.Invoke,[a.NewSymbolNameTriggerKind.Automatic]:o.NewSymbolNameTriggerKind.Automatic}}constructor(H,G,Z){this.e=H,this.f=G,this.g=Z}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(H,G,Z,ee){const le=this.e.getDocument(H),ye=i.Range.to(G);try{const Te=Y.d[Z],Ve=await this.f.provideNewSymbolNames(le,ye,Te,ee);return Ve?Ve.map(Ke=>typeof Ke=="string"?{newSymbolName:Ke}:{newSymbolName:Ke.newSymbolName,tags:Ke.tags}):void 0}catch(Te){this.g.error(Y.h(Te)??JSON.stringify(Te,null,"	"));return}}static h(H){return typeof H=="string"?H:H instanceof Error&&typeof H.message=="string"?H.message:void 0}}class x{constructor(H,G){this.resultId=H,this.tokens=G}}class oe{constructor(H,G){this.f=H,this.g=G,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(H,G,Z){const ee=this.f.getDocument(H),le=G!==0?this.d.get(G):null;let ye=typeof le?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(ee,le.resultId,Z):await this.g.provideDocumentSemanticTokens(ee,Z);return le&&this.d.delete(G),ye?(ye=oe.h(ye),this.o(oe.n(le,ye),ye)):null}async releaseDocumentSemanticColoring(H){this.d.delete(H)}static h(H){return oe.j(H)?oe.k(H)?H:new o.$pP(new Uint32Array(H.data),H.resultId):oe.l(H)?oe.m(H)?H:new o.$rP(H.edits.map(G=>new o.$qP(G.start,G.deleteCount,G.data?new Uint32Array(G.data):G.data)),H.resultId):H}static j(H){return H&&!!H.data}static k(H){return H.data instanceof Uint32Array}static l(H){return H&&Array.isArray(H.edits)}static m(H){for(const G of H.edits)if(!(G.data instanceof Uint32Array))return!1;return!0}static n(H,G){if(!oe.j(G)||!H||!H.tokens)return G;const Z=H.tokens,ee=Z.length,le=G.data,ye=le.length;let Te=0;const Ve=Math.min(ee,ye);for(;Te<Ve&&Z[Te]===le[Te];)Te++;if(Te===ee&&Te===ye)return new o.$rP([],G.resultId);let Ke=0;const rt=Ve-Te;for(;Ke<rt&&Z[ee-Ke-1]===le[ye-Ke-1];)Ke++;return new o.$rP([{start:Te,deleteCount:ee-Te-Ke,data:le.subarray(Te,ye-Ke)}],G.resultId)}o(H,G){if(oe.j(H)){const Z=this.e++;return this.d.set(Z,new x(H.resultId,H.data)),(0,$.$oeb)({id:Z,type:"full",data:H.data})}if(oe.l(H)){const Z=this.e++;return oe.j(G)?this.d.set(Z,new x(G.resultId,G.data)):this.d.set(Z,new x(H.resultId)),(0,$.$oeb)({id:Z,type:"delta",deltas:(H.edits||[]).map(ee=>({start:ee.start,deleteCount:ee.deleteCount,data:ee.data}))})}return null}}class ie{constructor(H,G){this.d=H,this.e=G}async provideDocumentRangeSemanticTokens(H,G,Z){const ee=this.d.getDocument(H),le=await this.e.provideDocumentRangeSemanticTokens(ee,i.Range.to(G),Z);return le?this.f(le):null}f(H){return(0,$.$oeb)({id:0,type:"full",data:H.data})}}class me{static supportsResolving(H){return typeof H.resolveCompletionItem=="function"}constructor(H,G,Z,ee,le){this.f=H,this.g=G,this.h=Z,this.j=ee,this.k=le,this.d=new n.$xqc("CompletionItem"),this.e=new Map}async provideCompletionItems(H,G,Z,ee){const le=this.f.getDocument(H),ye=i.Position.to(G),Te=le.getWordRangeAtPosition(ye)||new o.$7N(ye,ye),Ve=Te.with({end:ye}),Ke=new c.$ie,rt=await this.h.provideCompletionItems(le,ye,ee,i.CompletionContext.to(Z));if(!rt||ee.isCancellationRequested)return;const ot=Array.isArray(rt)?new o.$DO(rt):rt,ut=me.supportsResolving(this.h)?this.d.add(ot.items):this.d.add([]),at=new C.$Wc;this.e.set(ut,at);const lt=[],$t={x:ut,[r.ISuggestResultDtoField.completions]:lt,[r.ISuggestResultDtoField.defaultRanges]:{replace:i.Range.from(Te),insert:i.Range.from(Ve)},[r.ISuggestResultDtoField.isIncomplete]:ot.isIncomplete||void 0,[r.ISuggestResultDtoField.duration]:Ke.elapsed()};for(let it=0;it<ot.items.length;it++){const Ie=ot.items[it],re=this.l(Ie,[ut,it],Ve,Te);lt.push(re)}return $t}async resolveCompletionItem(H,G){if(typeof this.h.resolveCompletionItem!="function")return;const Z=this.d.get(...H);if(!Z)return;const ee=this.l(Z,H),le=await this.h.resolveCompletionItem(Z,G);if(!le)return;const ye=this.l(le,H);return(ee[r.ISuggestDataDtoField.insertText]!==ye[r.ISuggestDataDtoField.insertText]||ee[r.ISuggestDataDtoField.insertTextRules]!==ye[r.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(ee[r.ISuggestDataDtoField.commandIdent]!==ye[r.ISuggestDataDtoField.commandIdent]||ee[r.ISuggestDataDtoField.commandId]!==ye[r.ISuggestDataDtoField.commandId]||!(0,m.$mo)(ee[r.ISuggestDataDtoField.commandArguments],ye[r.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...ee,[r.ISuggestDataDtoField.documentation]:ye[r.ISuggestDataDtoField.documentation],[r.ISuggestDataDtoField.detail]:ye[r.ISuggestDataDtoField.detail],[r.ISuggestDataDtoField.additionalTextEdits]:ye[r.ISuggestDataDtoField.additionalTextEdits],[r.ISuggestDataDtoField.insertText]:ye[r.ISuggestDataDtoField.insertText],[r.ISuggestDataDtoField.insertTextRules]:ye[r.ISuggestDataDtoField.insertTextRules],[r.ISuggestDataDtoField.commandIdent]:ye[r.ISuggestDataDtoField.commandIdent],[r.ISuggestDataDtoField.commandId]:ye[r.ISuggestDataDtoField.commandId],[r.ISuggestDataDtoField.commandArguments]:ye[r.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(H){this.e.get(H)?.dispose(),this.e.delete(H),this.d.delete(H)}l(H,G,Z,ee){const le=this.e.get(G[0]);if(!le)throw Error("DisposableStore is missing...");const ye=this.g.toInternal(H.command,le),Te={x:G,[r.ISuggestDataDtoField.label]:H.label,[r.ISuggestDataDtoField.kind]:H.kind!==void 0?i.CompletionItemKind.from(H.kind):void 0,[r.ISuggestDataDtoField.kindModifier]:H.tags&&H.tags.map(i.CompletionItemTag.from),[r.ISuggestDataDtoField.detail]:H.detail,[r.ISuggestDataDtoField.documentation]:typeof H.documentation>"u"?void 0:i.MarkdownString.fromStrict(H.documentation),[r.ISuggestDataDtoField.sortText]:H.sortText!==H.label?H.sortText:void 0,[r.ISuggestDataDtoField.filterText]:H.filterText!==H.label?H.filterText:void 0,[r.ISuggestDataDtoField.preselect]:H.preselect||void 0,[r.ISuggestDataDtoField.insertTextRules]:H.keepWhitespace?a.CompletionItemInsertTextRule.KeepWhitespace:a.CompletionItemInsertTextRule.None,[r.ISuggestDataDtoField.commitCharacters]:H.commitCharacters?.join(""),[r.ISuggestDataDtoField.additionalTextEdits]:H.additionalTextEdits&&H.additionalTextEdits.map(i.TextEdit.from),[r.ISuggestDataDtoField.commandIdent]:ye?.$ident,[r.ISuggestDataDtoField.commandId]:ye?.id,[r.ISuggestDataDtoField.commandArguments]:ye?.$ident?void 0:ye?.arguments};H.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Te[r.ISuggestDataDtoField.insertText]=H.textEdit.newText):typeof H.insertText=="string"?Te[r.ISuggestDataDtoField.insertText]=H.insertText:H.insertText instanceof o.$fO&&(Te[r.ISuggestDataDtoField.insertText]=H.insertText.value,Te[r.ISuggestDataDtoField.insertTextRules]|=a.CompletionItemInsertTextRule.InsertAsSnippet);let Ve;return H.textEdit?Ve=H.textEdit.range:H.range&&(Ve=H.range),o.$7N.isRange(Ve)?Te[r.ISuggestDataDtoField.range]=i.Range.from(Ve):Ve&&(!Z?.isEqual(Ve.inserting)||!ee?.isEqual(Ve.replacing))&&(Te[r.ISuggestDataDtoField.range]={insert:i.Range.from(Ve.inserting),replace:i.Range.from(Ve.replacing)}),Te}}class ue{async provideInlineCompletions(H,G,Z,ee){}async provideInlineEdits(H,G,Z,ee){}disposeCompletions(H){}handleDidShowCompletionItem(H,G,Z){}handlePartialAccept(H,G,Z,ee){}}class X extends ue{constructor(H,G,Z,ee){super(),this.f=H,this.g=G,this.h=Z,this.j=ee,this.d=new se,this.e=(0,t.$vH)(this.f,"inlineCompletionsAdditions"),this.k={[a.InlineCompletionTriggerKind.Automatic]:o.InlineCompletionTriggerKind.Automatic,[a.InlineCompletionTriggerKind.Explicit]:o.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$vH)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(H,G,Z,ee){const le=this.g.getDocument(H),ye=i.Position.to(G),Te=await this.h.provideInlineCompletionItems(le,ye,{selectedCompletionInfo:Z.selectedSuggestionInfo?{range:i.Range.to(Z.selectedSuggestionInfo.range),text:Z.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[Z.triggerKind]},ee);if(!Te||ee.isCancellationRequested)return;const Ve=Array.isArray(Te)?Te:Te.items,Ke=this.e?Array.isArray(Te)?[]:Te.commands||[]:[],rt=this.e&&!Array.isArray(Te)?Te.enableForwardStability:void 0;let ot;return{pid:this.d.createReferenceId({dispose(){ot?.dispose()},items:Ve}),items:Ve.map((at,lt)=>{let $t;at.command&&(ot||(ot=new C.$Wc),$t=this.j.toInternal(at.command,ot));const it=at.insertText;return{insertText:typeof it=="string"?it:{snippet:it.value},filterText:at.filterText,range:at.range?i.Range.from(at.range):void 0,command:$t,idx:lt,completeBracketPairs:this.e?at.completeBracketPairs:!1}}),commands:Ke.map(at=>(ot||(ot=new C.$Wc),this.j.toInternal(at,ot))),suppressSuggestions:!1,enableForwardStability:rt}}async provideInlineEdits(H,G,Z,ee){if(!this.h.provideInlineEdits)return;(0,t.$wH)(this.f,"inlineCompletionsAdditions");const le=this.g.getDocument(H),ye=i.Range.to(G),Te=await this.h.provideInlineEdits(le,ye,{selectedCompletionInfo:Z.selectedSuggestionInfo?{range:i.Range.to(Z.selectedSuggestionInfo.range),text:Z.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[Z.triggerKind],userPrompt:Z.userPrompt},ee);if(!Te||ee.isCancellationRequested)return;const Ve=Array.isArray(Te)?Te:Te.items,Ke=this.e?Array.isArray(Te)?[]:Te.commands||[]:[],rt=this.e&&!Array.isArray(Te)?Te.enableForwardStability:void 0;let ot;return{pid:this.d.createReferenceId({dispose(){ot?.dispose()},items:Ve}),items:Ve.map((at,lt)=>{let $t;at.command&&(ot||(ot=new C.$Wc),$t=this.j.toInternal(at.command,ot));const it=at.insertText;return{insertText:typeof it=="string"?it:{snippet:it.value},filterText:at.filterText,range:at.range?i.Range.from(at.range):void 0,command:$t,idx:lt,completeBracketPairs:this.e?at.completeBracketPairs:!1}}),commands:Ke.map(at=>(ot||(ot=new C.$Wc),this.j.toInternal(at,ot))),suppressSuggestions:!1,enableForwardStability:rt}}disposeCompletions(H){this.d.disposeReferenceId(H)?.dispose()}handleDidShowCompletionItem(H,G,Z){const ee=this.d.get(H)?.items[G];ee&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(ee,Z)}handlePartialAccept(H,G,Z,ee){const le=this.d.get(H)?.items[G];le&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(le,Z),this.h.handleDidPartiallyAcceptCompletionItem(le,i.PartialAcceptInfo.to(ee)))}}class q{async provideInlineEdits(H,G,Z){const ee=this.f.getDocument(H),le=await this.g.provideInlineEdit(ee,{triggerKind:this.e[G.triggerKind]},Z);if(!le||Z.isCancellationRequested)return;let ye;const Te=this.d.createReferenceId({dispose(){ye?.dispose()},item:le});let Ve;le.accepted&&(ye||(ye=new C.$Wc),Ve=this.h.toInternal(le.accepted,ye));let Ke;return le.rejected&&(ye||(ye=new C.$Wc),Ke=this.h.toInternal(le.rejected,ye)),{pid:Te,text:le.text,range:i.Range.from(le.range),accepted:Ve,rejected:Ke}}disposeEdit(H){this.d.disposeReferenceId(H)?.dispose()}constructor(H,G,Z,ee){this.f=G,this.g=Z,this.h=ee,this.d=new se,this.e={[a.InlineEditTriggerKind.Automatic]:o.InlineEditTriggerKind.Automatic,[a.InlineEditTriggerKind.Invoke]:o.InlineEditTriggerKind.Invoke}}}class se{constructor(){this.d=new Map,this.e=1}createReferenceId(H){const G=this.e++;return this.d.set(G,H),G}disposeReferenceId(H){const G=this.d.get(H);return this.d.delete(H),G}get(H){return this.d.get(H)}}class be{constructor(H,G){this.e=H,this.f=G,this.d=new n.$xqc("SignatureHelp")}async provideSignatureHelp(H,G,Z,ee){const le=this.e.getDocument(H),ye=i.Position.to(G),Te=this.g(Z),Ve=await this.f.provideSignatureHelp(le,ye,ee,Te);if(Ve){const Ke=this.d.add([Ve]);return{...i.SignatureHelp.from(Ve),id:Ke}}}g(H){let G;if(H.activeSignatureHelp){const Z=i.SignatureHelp.to(H.activeSignatureHelp),ee=this.d.get(H.activeSignatureHelp.id,0);ee?(G=ee,G.activeSignature=Z.activeSignature,G.activeParameter=Z.activeParameter):G=Z}return{...H,activeSignatureHelp:G}}releaseSignatureHelp(H){this.d.delete(H)}}class ae{constructor(H,G,Z,ee,le){this.f=H,this.g=G,this.h=Z,this.j=ee,this.k=le,this.d=new n.$xqc("InlayHints"),this.e=new Map}async provideInlayHints(H,G,Z){const ee=this.f.getDocument(H),le=i.Range.to(G),ye=await this.h.provideInlayHints(ee,le,Z);if(!Array.isArray(ye)||ye.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(G)}`);return}if(Z.isCancellationRequested)return;const Te=this.d.add(ye);this.e.set(Te,new C.$Wc);const Ve={hints:[],cacheId:Te};for(let Ke=0;Ke<ye.length;Ke++)this.l(ye[Ke],le)&&Ve.hints.push(this.m(ye[Ke],[Te,Ke]));return this.j.trace(`[InlayHints] ${Ve.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(G)}`),Ve}async resolveInlayHint(H,G){if(typeof this.h.resolveInlayHint!="function")return;const Z=this.d.get(...H);if(!Z)return;const ee=await this.h.resolveInlayHint(Z,G);if(ee&&this.l(ee))return this.m(ee,H)}releaseHints(H){this.e.get(H)?.dispose(),this.e.delete(H),this.d.delete(H)}l(H,G){return H.label.length===0||Array.isArray(H.label)&&H.label.every(Z=>Z.value.length===0)?(console.log("INVALID inlay hint, empty label",H),!1):!(G&&!G.contains(H.position))}m(H,G){const Z=this.e.get(G[0]);if(!Z)throw Error("DisposableStore is missing...");const ee={label:"",cacheId:G,tooltip:i.MarkdownString.fromStrict(H.tooltip),position:i.Position.from(H.position),textEdits:H.textEdits&&H.textEdits.map(i.TextEdit.from),kind:H.kind&&i.InlayHintKind.from(H.kind),paddingLeft:H.paddingLeft,paddingRight:H.paddingRight};if(typeof H.label=="string")ee.label=H.label;else{const le=[];ee.label=le;for(const ye of H.label){if(!ye.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Te={label:ye.value,tooltip:i.MarkdownString.fromStrict(ye.tooltip)};o.$gO.isLocation(ye.location)&&(Te.location=i.location.from(ye.location)),ye.command&&(Te.command=this.g.toInternal(ye.command,Z)),le.push(Te)}}return ee}}class we{constructor(H,G){this.e=H,this.f=G,this.d=new n.$xqc("DocumentLink")}async provideLinks(H,G){const Z=this.e.getDocument(H),ee=await this.f.provideDocumentLinks(Z,G);if(!(!Array.isArray(ee)||ee.length===0)&&!G.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:ee.filter(we.g).map(i.DocumentLink.from)};{const le=this.d.add(ee),ye={links:[],cacheId:le};for(let Te=0;Te<ee.length;Te++){if(!we.g(ee[Te]))continue;const Ve=i.DocumentLink.from(ee[Te]);Ve.cacheId=[le,Te],ye.links.push(Ve)}return ye}}}static g(H){return H.target&&H.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(H,G){if(typeof this.f.resolveDocumentLink!="function")return;const Z=this.d.get(...H);if(!Z)return;const ee=await this.f.resolveDocumentLink(Z,G);if(!(!ee||!we.g(ee)))return i.DocumentLink.from(ee)}releaseLinks(H){this.d.delete(H)}}class $e{constructor(H,G){this.d=H,this.e=G}async provideColors(H,G){const Z=this.d.getDocument(H),ee=await this.e.provideDocumentColors(Z,G);return Array.isArray(ee)?ee.map(ye=>({color:i.Color.from(ye.color),range:i.Range.from(ye.range)})):[]}async provideColorPresentations(H,G,Z){const ee=this.d.getDocument(H),le=i.Range.to(G.range),ye=i.Color.to(G.color),Te=await this.e.provideColorPresentations(ye,{document:ee,range:le},Z);if(Array.isArray(Te))return Te.map(i.ColorPresentation.from)}}class pe{constructor(H,G){this.d=H,this.e=G}async provideFoldingRanges(H,G,Z){const ee=this.d.getDocument(H),le=await this.e.provideFoldingRanges(ee,G,Z);if(Array.isArray(le))return le.map(i.FoldingRange.from)}}class Ae{constructor(H,G,Z){this.d=H,this.e=G,this.f=Z}async provideSelectionRanges(H,G,Z){const ee=this.d.getDocument(H),le=G.map(i.Position.to),ye=await this.e.provideSelectionRanges(ee,le,Z);if(!(0,s.$Nb)(ye))return[];if(ye.length!==le.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Te=[];for(let Ve=0;Ve<le.length;Ve++){const Ke=[];Te.push(Ke);let rt=le[Ve],ot=ye[Ve];for(;;){if(!ot.range.contains(rt))throw new Error("INVALID selection range, must contain the previous range");if(Ke.push(i.SelectionRange.from(ot)),!ot.parent)break;rt=ot.range,ot=ot.parent}}return Te}}class je{constructor(H,G){this.f=H,this.g=G,this.d=new O.$IQ(""),this.e=new Map}async prepareSession(H,G,Z){const ee=this.f.getDocument(H),le=i.Position.to(G),ye=await this.g.prepareCallHierarchy(ee,le,Z);if(!ye)return;const Te=this.d.nextId();return this.e.set(Te,new Map),Array.isArray(ye)?ye.map(Ve=>this.h(Te,Ve)):[this.h(Te,ye)]}async provideCallsTo(H,G,Z){const ee=this.j(H,G);if(!ee)throw new Error("missing call hierarchy item");const le=await this.g.provideCallHierarchyIncomingCalls(ee,Z);if(le)return le.map(ye=>({from:this.h(H,ye.from),fromRanges:ye.fromRanges.map(Te=>i.Range.from(Te))}))}async provideCallsFrom(H,G,Z){const ee=this.j(H,G);if(!ee)throw new Error("missing call hierarchy item");const le=await this.g.provideCallHierarchyOutgoingCalls(ee,Z);if(le)return le.map(ye=>({to:this.h(H,ye.to),fromRanges:ye.fromRanges.map(Te=>i.Range.from(Te))}))}releaseSession(H){this.e.delete(H)}h(H,G){const Z=this.e.get(H),ee=i.CallHierarchyItem.from(G,H,Z.size.toString(36));return Z.set(ee._itemId,G),ee}j(H,G){return this.e.get(H)?.get(G)}}class He{constructor(H,G){this.f=H,this.g=G,this.d=new O.$IQ(""),this.e=new Map}async prepareSession(H,G,Z){const ee=this.f.getDocument(H),le=i.Position.to(G),ye=await this.g.prepareTypeHierarchy(ee,le,Z);if(!ye)return;const Te=this.d.nextId();return this.e.set(Te,new Map),Array.isArray(ye)?ye.map(Ve=>this.h(Te,Ve)):[this.h(Te,ye)]}async provideSupertypes(H,G,Z){const ee=this.j(H,G);if(!ee)throw new Error("missing type hierarchy item");const le=await this.g.provideTypeHierarchySupertypes(ee,Z);if(le)return le.map(ye=>this.h(H,ye))}async provideSubtypes(H,G,Z){const ee=this.j(H,G);if(!ee)throw new Error("missing type hierarchy item");const le=await this.g.provideTypeHierarchySubtypes(ee,Z);if(le)return le.map(ye=>this.h(H,ye))}releaseSession(H){this.e.delete(H)}h(H,G){const Z=this.e.get(H),ee=i.TypeHierarchyItem.from(G,H,Z.size.toString(36));return Z.set(ee._itemId,G),ee}j(H,G){return this.e.get(H)?.get(G)}}class Ye{constructor(H,G,Z,ee,le){this.e=H,this.f=G,this.g=Z,this.h=ee,this.j=le,this.d=new n.$xqc("DocumentDropEdit")}async provideDocumentOnDropEdits(H,G,Z,ee,le){const ye=this.f.getDocument(G),Te=i.Position.to(Z),Ve=i.DataTransfer.toDataTransfer(ee,async ut=>(await this.e.$resolveDocumentOnDropFileData(this.h,H,ut)).buffer),Ke=await this.g.provideDocumentDropEdits(ye,Te,Ve,le);if(!Ke)return;const rt=(0,s.$4b)(Ke),ot=this.d.add(rt);return rt.map((ut,at)=>({_cacheId:[ot,at],title:ut.title??(0,p.localize)(2704,null,this.j.displayName||this.j.name),kind:ut.kind?.value,yieldTo:ut.yieldTo?.map(lt=>lt.value),insertText:typeof ut.insertText=="string"?ut.insertText:{snippet:ut.insertText.value},additionalEdit:ut.additionalEdit?i.WorkspaceEdit.from(ut.additionalEdit,void 0):void 0}))}async resolveDropEdit(H,G){const[Z,ee]=H,le=this.d.get(Z,ee);if(!le||!this.g.resolveDocumentDropEdit)return{};const ye=await this.g.resolveDocumentDropEdit(le,G)??le;return{additionalEdit:ye.additionalEdit?i.WorkspaceEdit.from(ye.additionalEdit,void 0):void 0}}releaseDropEdits(H){this.d.delete(H)}}class xe{constructor(H,G){this.d=H,this.e=G}async provideMappedEdits(H,G,Z,ee){const le=g.URI.revive(H),ye=this.d.getDocument(le),Te=Z.documents.map(rt=>rt.map(ot=>({uri:g.URI.revive(ot.uri),version:ot.version,ranges:ot.ranges.map(ut=>i.Range.to(ut))}))),Ve={documents:Te,selections:Te[0]?.[0]?.ranges??[]},Ke=await this.e.provideMappedEdits(ye,G,Ve,ee);return Ke?i.WorkspaceEdit.from(Ke):null}}class Fe{constructor(H,G){this.adapter=H,this.extension=G}}class We{static{this.d=0}constructor(H,G,Z,ee,le,ye,Te,Ve){this.g=G,this.h=Z,this.j=ee,this.k=le,this.l=ye,this.m=Te,this.n=Ve,this.f=new Map,this.e=H.getProxy(r.$3N.MainThreadLanguageFeatures)}o(H,G){return i.DocumentSelector.from(H,this.g,G)}p(H){return new o.$5N(()=>{this.f.delete(H),this.e.$unregister(H)})}q(){return We.d++}async s(H,G,Z,ee,le,ye=!1){const Te=this.f.get(H);if(!Te||!(Te.adapter instanceof G))return ee;const Ve=Date.now();ye||this.l.trace(`[${Te.extension.identifier.value}] INVOKE provider '${Z.toString().replace(/[\r\n]/g,"")}'`);const Ke=Z(Te.adapter,Te.extension);return Promise.resolve(Ke).catch(rt=>{(0,A.$6)(rt)||(this.l.error(`[${Te.extension.identifier.value}] provider FAILED`),this.l.error(rt),this.n.onExtensionError(Te.extension.identifier,rt))}).finally(()=>{ye||this.l.trace(`[${Te.extension.identifier.value}] provider DONE after ${Date.now()-Ve}ms`)}),R.CancellationToken.isCancellationToken(le)?(0,h.$xh)(Ke,le):Ke}t(H,G){const Z=this.q();return this.f.set(Z,new Fe(H,G)),Z}static u(H){return H.displayName||H.name}static w(H){return H.identifier.value}registerDocumentSymbolProvider(H,G,Z,ee){const le=this.t(new d(this.h,Z),H),ye=ee&&ee.label||We.u(H);return this.e.$registerDocumentSymbolProvider(le,this.o(G,H),ye),this.p(le)}$provideDocumentSymbols(H,G,Z){return this.s(H,d,ee=>ee.provideDocumentSymbols(g.URI.revive(G),Z),void 0,Z)}registerCodeLensProvider(H,G,Z){const ee=this.q(),le=typeof Z.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(ee,new Fe(new l(this.h,this.j.converter,Z,H,this.n,this.l),H)),this.e.$registerCodeLensSupport(ee,this.o(G,H),le);let ye=this.p(ee);if(le!==void 0){const Te=Z.onDidChangeCodeLenses(Ve=>this.e.$emitCodeLensEvent(le));ye=o.$5N.from(ye,Te)}return ye}$provideCodeLenses(H,G,Z){return this.s(H,l,ee=>ee.provideCodeLenses(g.URI.revive(G),Z),void 0,Z)}$resolveCodeLens(H,G,Z){return this.s(H,l,ee=>ee.resolveCodeLens(G,Z),void 0,void 0)}$releaseCodeLenses(H,G){this.s(H,l,Z=>Promise.resolve(Z.releaseCodeLenses(G)),void 0,void 0)}registerDefinitionProvider(H,G,Z){const ee=this.t(new y(this.h,Z),H);return this.e.$registerDefinitionSupport(ee,this.o(G,H)),this.p(ee)}$provideDefinition(H,G,Z,ee){return this.s(H,y,le=>le.provideDefinition(g.URI.revive(G),Z,ee),[],ee)}registerDeclarationProvider(H,G,Z){const ee=this.t(new k(this.h,Z),H);return this.e.$registerDeclarationSupport(ee,this.o(G,H)),this.p(ee)}$provideDeclaration(H,G,Z,ee){return this.s(H,k,le=>le.provideDeclaration(g.URI.revive(G),Z,ee),[],ee)}registerImplementationProvider(H,G,Z){const ee=this.t(new S(this.h,Z),H);return this.e.$registerImplementationSupport(ee,this.o(G,H)),this.p(ee)}$provideImplementation(H,G,Z,ee){return this.s(H,S,le=>le.provideImplementation(g.URI.revive(G),Z,ee),[],ee)}registerTypeDefinitionProvider(H,G,Z){const ee=this.t(new D(this.h,Z),H);return this.e.$registerTypeDefinitionSupport(ee,this.o(G,H)),this.p(ee)}$provideTypeDefinition(H,G,Z,ee){return this.s(H,D,le=>le.provideTypeDefinition(g.URI.revive(G),Z,ee),[],ee)}registerHoverProvider(H,G,Z,ee){const le=this.t(new T(this.h,Z),H);return this.e.$registerHoverProvider(le,this.o(G,H)),this.p(le)}$provideHover(H,G,Z,ee,le){return this.s(H,T,ye=>ye.provideHover(g.URI.revive(G),Z,ee,le),void 0,le)}$releaseHover(H,G){this.s(H,T,Z=>Promise.resolve(Z.releaseHover(G)),void 0,void 0)}registerEvaluatableExpressionProvider(H,G,Z,ee){const le=this.t(new v(this.h,Z),H);return this.e.$registerEvaluatableExpressionProvider(le,this.o(G,H)),this.p(le)}$provideEvaluatableExpression(H,G,Z,ee){return this.s(H,v,le=>le.provideEvaluatableExpression(g.URI.revive(G),Z,ee),void 0,ee)}registerInlineValuesProvider(H,G,Z,ee){const le=typeof Z.onDidChangeInlineValues=="function"?this.q():void 0,ye=this.t(new w(this.h,Z),H);this.e.$registerInlineValuesProvider(ye,this.o(G,H),le);let Te=this.p(ye);if(le!==void 0){const Ve=Z.onDidChangeInlineValues(Ke=>this.e.$emitInlineValuesEvent(le));Te=o.$5N.from(Te,Ve)}return Te}$provideInlineValues(H,G,Z,ee,le){return this.s(H,w,ye=>ye.provideInlineValues(g.URI.revive(G),Z,ee,le),void 0,le)}registerDocumentHighlightProvider(H,G,Z){const ee=this.t(new M(this.h,Z),H);return this.e.$registerDocumentHighlightProvider(ee,this.o(G,H)),this.p(ee)}registerMultiDocumentHighlightProvider(H,G,Z){const ee=this.t(new L(this.h,Z),H);return this.e.$registerMultiDocumentHighlightProvider(ee,this.o(G,H)),this.p(ee)}$provideDocumentHighlights(H,G,Z,ee){return this.s(H,M,le=>le.provideDocumentHighlights(g.URI.revive(G),Z,ee),void 0,ee)}$provideMultiDocumentHighlights(H,G,Z,ee,le){return this.s(H,L,ye=>ye.provideMultiDocumentHighlights(g.URI.revive(G),Z,ee.map(Te=>g.URI.revive(Te)),le),void 0,le)}registerLinkedEditingRangeProvider(H,G,Z){const ee=this.t(new N(this.h,Z),H);return this.e.$registerLinkedEditingRangeProvider(ee,this.o(G,H)),this.p(ee)}$provideLinkedEditingRanges(H,G,Z,ee){return this.s(H,N,async le=>{const ye=await le.provideLinkedEditingRanges(g.URI.revive(G),Z,ee);if(ye)return{ranges:ye.ranges,wordPattern:ye.wordPattern?We.y(ye.wordPattern):void 0}},void 0,ee)}registerReferenceProvider(H,G,Z){const ee=this.t(new F(this.h,Z),H);return this.e.$registerReferenceSupport(ee,this.o(G,H)),this.p(ee)}$provideReferences(H,G,Z,ee,le){return this.s(H,F,ye=>ye.provideReferences(g.URI.revive(G),Z,ee,le),void 0,le)}registerCodeActionProvider(H,G,Z,ee){const le=new C.$Wc,ye=this.t(new V(this.h,this.j.converter,this.k,Z,this.l,H,this.m),H);return this.e.$registerCodeActionSupport(ye,this.o(G,H),{providedKinds:ee?.providedCodeActionKinds?.map(Te=>Te.value),documentation:ee?.documentation?.map(Te=>({kind:Te.kind.value,command:this.j.converter.toInternal(Te.command,le)}))},We.u(H),We.w(H),!!Z.resolveCodeAction),le.add(this.p(ye)),le}$provideCodeActions(H,G,Z,ee,le){return this.s(H,V,ye=>ye.provideCodeActions(g.URI.revive(G),Z,ee,le),void 0,le)}$resolveCodeAction(H,G,Z){return this.s(H,V,ee=>ee.resolveCodeAction(G,Z),{},void 0)}$releaseCodeActions(H,G){this.s(H,V,Z=>Promise.resolve(Z.releaseCodeActions(G)),void 0,void 0)}registerDocumentFormattingEditProvider(H,G,Z){const ee=this.t(new U(this.h,Z),H);return this.e.$registerDocumentFormattingSupport(ee,this.o(G,H),H.identifier,H.displayName||H.name),this.p(ee)}$provideDocumentFormattingEdits(H,G,Z,ee){return this.s(H,U,le=>le.provideDocumentFormattingEdits(g.URI.revive(G),Z,ee),void 0,ee)}registerDocumentRangeFormattingEditProvider(H,G,Z){const ee=typeof Z.provideDocumentRangesFormattingEdits=="function",le=this.t(new z(this.h,Z),H);return this.e.$registerRangeFormattingSupport(le,this.o(G,H),H.identifier,H.displayName||H.name,ee),this.p(le)}$provideDocumentRangeFormattingEdits(H,G,Z,ee,le){return this.s(H,z,ye=>ye.provideDocumentRangeFormattingEdits(g.URI.revive(G),Z,ee,le),void 0,le)}$provideDocumentRangesFormattingEdits(H,G,Z,ee,le){return this.s(H,z,ye=>ye.provideDocumentRangesFormattingEdits(g.URI.revive(G),Z,ee,le),void 0,le)}registerOnTypeFormattingEditProvider(H,G,Z,ee){const le=this.t(new _(this.h,Z),H);return this.e.$registerOnTypeFormattingSupport(le,this.o(G,H),ee,H.identifier),this.p(le)}$provideOnTypeFormattingEdits(H,G,Z,ee,le,ye){return this.s(H,_,Te=>Te.provideOnTypeFormattingEdits(g.URI.revive(G),Z,ee,le,ye),void 0,ye)}registerWorkspaceSymbolProvider(H,G){const Z=this.t(new W(G,this.l),H);return this.e.$registerNavigateTypeSupport(Z,typeof G.resolveWorkspaceSymbol=="function"),this.p(Z)}$provideWorkspaceSymbols(H,G,Z){return this.s(H,W,ee=>ee.provideWorkspaceSymbols(G,Z),{symbols:[]},Z)}$resolveWorkspaceSymbol(H,G,Z){return this.s(H,W,ee=>ee.resolveWorkspaceSymbol(G,Z),void 0,void 0)}$releaseWorkspaceSymbols(H,G){this.s(H,W,Z=>Z.releaseWorkspaceSymbols(G),void 0,void 0)}registerRenameProvider(H,G,Z){const ee=this.t(new B(this.h,Z,this.l),H);return this.e.$registerRenameSupport(ee,this.o(G,H),B.supportsResolving(Z)),this.p(ee)}$provideRenameEdits(H,G,Z,ee,le){return this.s(H,B,ye=>ye.provideRenameEdits(g.URI.revive(G),Z,ee,le),void 0,le)}$resolveRenameLocation(H,G,Z,ee){return this.s(H,B,le=>le.resolveRenameLocation(g.URI.revive(G),Z,ee),void 0,ee)}registerNewSymbolNamesProvider(H,G,Z){const ee=this.t(new Y(this.h,Z,this.l),H);return this.e.$registerNewSymbolNamesProvider(ee,this.o(G,H)),this.p(ee)}$supportsAutomaticNewSymbolNamesTriggerKind(H){return this.s(H,Y,G=>G.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(H,G,Z,ee,le){return this.s(H,Y,ye=>ye.provideNewSymbolNames(g.URI.revive(G),Z,ee,le),void 0,le)}registerDocumentSemanticTokensProvider(H,G,Z,ee){const le=this.t(new oe(this.h,Z),H),ye=typeof Z.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(le,this.o(G,H),ee,ye);let Te=this.p(le);if(ye){const Ve=Z.onDidChangeSemanticTokens(Ke=>this.e.$emitDocumentSemanticTokensEvent(ye));Te=o.$5N.from(Te,Ve)}return Te}$provideDocumentSemanticTokens(H,G,Z,ee){return this.s(H,oe,le=>le.provideDocumentSemanticTokens(g.URI.revive(G),Z,ee),null,ee)}$releaseDocumentSemanticTokens(H,G){this.s(H,oe,Z=>Z.releaseDocumentSemanticColoring(G),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(H,G,Z,ee){const le=this.t(new ie(this.h,Z),H);return this.e.$registerDocumentRangeSemanticTokensProvider(le,this.o(G,H),ee),this.p(le)}$provideDocumentRangeSemanticTokens(H,G,Z,ee){return this.s(H,ie,le=>le.provideDocumentRangeSemanticTokens(g.URI.revive(G),Z,ee),null,ee)}registerCompletionItemProvider(H,G,Z,ee){const le=this.t(new me(this.h,this.j.converter,Z,this.m,H),H);return this.e.$registerCompletionsProvider(le,this.o(G,H),ee,me.supportsResolving(Z),H.identifier),this.p(le)}$provideCompletionItems(H,G,Z,ee,le){return this.s(H,me,ye=>ye.provideCompletionItems(g.URI.revive(G),Z,ee,le),void 0,le)}$resolveCompletionItem(H,G,Z){return this.s(H,me,ee=>ee.resolveCompletionItem(G,Z),void 0,Z)}$releaseCompletionItems(H,G){this.s(H,me,Z=>Z.releaseCompletionItems(G),void 0,void 0)}registerInlineCompletionsProvider(H,G,Z,ee){const le=new X(H,this.h,Z,this.j.converter),ye=this.t(le,H);return this.e.$registerInlineCompletionsSupport(ye,this.o(G,H),le.supportsHandleEvents,u.$vn.toKey(H.identifier.value),ee?.yieldTo?.map(Te=>u.$vn.toKey(Te))||[]),this.p(ye)}$provideInlineCompletions(H,G,Z,ee,le){return this.s(H,ue,ye=>ye.provideInlineCompletions(g.URI.revive(G),Z,ee,le),void 0,le)}$provideInlineEdits(H,G,Z,ee,le){return this.s(H,ue,ye=>ye.provideInlineEdits(g.URI.revive(G),Z,ee,le),void 0,le)}$handleInlineCompletionDidShow(H,G,Z,ee){this.s(H,ue,async le=>{le.handleDidShowCompletionItem(G,Z,ee)},void 0,void 0)}$handleInlineCompletionPartialAccept(H,G,Z,ee,le){this.s(H,ue,async ye=>{ye.handlePartialAccept(G,Z,ee,le)},void 0,void 0)}$freeInlineCompletionsList(H,G){this.s(H,ue,async Z=>{Z.disposeCompletions(G)},void 0,void 0)}registerInlineEditProvider(H,G,Z){const ee=new q(H,this.h,Z,this.j.converter),le=this.t(ee,H);return this.e.$registerInlineEditProvider(le,this.o(G,H),H.identifier),this.p(le)}$provideInlineEdit(H,G,Z,ee){return this.s(H,q,le=>le.provideInlineEdits(g.URI.revive(G),Z,ee),void 0,ee)}$freeInlineEdit(H,G){this.s(H,q,async Z=>{Z.disposeEdit(G)},void 0,void 0)}registerSignatureHelpProvider(H,G,Z,ee){const le=Array.isArray(ee)?{triggerCharacters:ee,retriggerCharacters:[]}:ee,ye=this.t(new be(this.h,Z),H);return this.e.$registerSignatureHelpProvider(ye,this.o(G,H),le),this.p(ye)}$provideSignatureHelp(H,G,Z,ee,le){return this.s(H,be,ye=>ye.provideSignatureHelp(g.URI.revive(G),Z,ee,le),void 0,le)}$releaseSignatureHelp(H,G){this.s(H,be,Z=>Z.releaseSignatureHelp(G),void 0,void 0)}registerInlayHintsProvider(H,G,Z){const ee=typeof Z.onDidChangeInlayHints=="function"?this.q():void 0,le=this.t(new ae(this.h,this.j.converter,Z,this.l,H),H);this.e.$registerInlayHintsProvider(le,this.o(G,H),typeof Z.resolveInlayHint=="function",ee,We.u(H));let ye=this.p(le);if(ee!==void 0){const Te=Z.onDidChangeInlayHints(Ve=>this.e.$emitInlayHintsEvent(ee));ye=o.$5N.from(ye,Te)}return ye}$provideInlayHints(H,G,Z,ee){return this.s(H,ae,le=>le.provideInlayHints(g.URI.revive(G),Z,ee),void 0,ee)}$resolveInlayHint(H,G,Z){return this.s(H,ae,ee=>ee.resolveInlayHint(G,Z),void 0,Z)}$releaseInlayHints(H,G){this.s(H,ae,Z=>Z.releaseHints(G),void 0,void 0)}registerDocumentLinkProvider(H,G,Z){const ee=this.t(new we(this.h,Z),H);return this.e.$registerDocumentLinkProvider(ee,this.o(G,H),typeof Z.resolveDocumentLink=="function"),this.p(ee)}$provideDocumentLinks(H,G,Z){return this.s(H,we,ee=>ee.provideLinks(g.URI.revive(G),Z),void 0,Z,G.scheme==="output")}$resolveDocumentLink(H,G,Z){return this.s(H,we,ee=>ee.resolveLink(G,Z),void 0,void 0,!0)}$releaseDocumentLinks(H,G){this.s(H,we,Z=>Z.releaseLinks(G),void 0,void 0,!0)}registerColorProvider(H,G,Z){const ee=this.t(new $e(this.h,Z),H);return this.e.$registerDocumentColorProvider(ee,this.o(G,H)),this.p(ee)}$provideDocumentColors(H,G,Z){return this.s(H,$e,ee=>ee.provideColors(g.URI.revive(G),Z),[],Z)}$provideColorPresentations(H,G,Z,ee){return this.s(H,$e,le=>le.provideColorPresentations(g.URI.revive(G),Z,ee),void 0,ee)}registerFoldingRangeProvider(H,G,Z){const ee=this.q(),le=typeof Z.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(ee,new Fe(new pe(this.h,Z),H)),this.e.$registerFoldingRangeProvider(ee,this.o(G,H),H.identifier,le);let ye=this.p(ee);if(le!==void 0){const Te=Z.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(le));ye=o.$5N.from(ye,Te)}return ye}$provideFoldingRanges(H,G,Z,ee){return this.s(H,pe,le=>le.provideFoldingRanges(g.URI.revive(G),Z,ee),void 0,ee)}registerSelectionRangeProvider(H,G,Z){const ee=this.t(new Ae(this.h,Z,this.l),H);return this.e.$registerSelectionRangeProvider(ee,this.o(G,H)),this.p(ee)}$provideSelectionRanges(H,G,Z,ee){return this.s(H,Ae,le=>le.provideSelectionRanges(g.URI.revive(G),Z,ee),[],ee)}registerCallHierarchyProvider(H,G,Z){const ee=this.t(new je(this.h,Z),H);return this.e.$registerCallHierarchyProvider(ee,this.o(G,H)),this.p(ee)}$prepareCallHierarchy(H,G,Z,ee){return this.s(H,je,le=>Promise.resolve(le.prepareSession(g.URI.revive(G),Z,ee)),void 0,ee)}$provideCallHierarchyIncomingCalls(H,G,Z,ee){return this.s(H,je,le=>le.provideCallsTo(G,Z,ee),void 0,ee)}$provideCallHierarchyOutgoingCalls(H,G,Z,ee){return this.s(H,je,le=>le.provideCallsFrom(G,Z,ee),void 0,ee)}$releaseCallHierarchy(H,G){this.s(H,je,Z=>Promise.resolve(Z.releaseSession(G)),void 0,void 0)}registerTypeHierarchyProvider(H,G,Z){const ee=this.t(new He(this.h,Z),H);return this.e.$registerTypeHierarchyProvider(ee,this.o(G,H)),this.p(ee)}$prepareTypeHierarchy(H,G,Z,ee){return this.s(H,He,le=>Promise.resolve(le.prepareSession(g.URI.revive(G),Z,ee)),void 0,ee)}$provideTypeHierarchySupertypes(H,G,Z,ee){return this.s(H,He,le=>le.provideSupertypes(G,Z,ee),void 0,ee)}$provideTypeHierarchySubtypes(H,G,Z,ee){return this.s(H,He,le=>le.provideSubtypes(G,Z,ee),void 0,ee)}$releaseTypeHierarchy(H,G){this.s(H,He,Z=>Promise.resolve(Z.releaseSession(G)),void 0,void 0)}registerDocumentOnDropEditProvider(H,G,Z,ee){const le=this.q();return this.f.set(le,new Fe(new Ye(this.e,this.h,Z,le,H),H)),this.e.$registerDocumentOnDropEditProvider(le,this.o(G,H),(0,t.$vH)(H,"documentPaste")&&ee?{supportsResolve:!!Z.resolveDocumentDropEdit,dropMimeTypes:ee.dropMimeTypes}:void 0),this.p(le)}$provideDocumentOnDropEdits(H,G,Z,ee,le,ye){return this.s(H,Ye,Te=>Promise.resolve(Te.provideDocumentOnDropEdits(G,g.URI.revive(Z),ee,le,ye)),void 0,void 0)}$resolveDropEdit(H,G,Z){return this.s(H,Ye,ee=>ee.resolveDropEdit(G,Z),{},void 0)}$releaseDocumentOnDropEdits(H,G){this.s(H,Ye,Z=>Promise.resolve(Z.releaseDropEdits(G)),void 0,void 0)}registerMappedEditsProvider(H,G,Z){const ee=this.t(new xe(this.h,Z),H);return this.e.$registerMappedEditsProvider(ee,this.o(G,H),H.displayName??H.name),this.p(ee)}$provideMappedEdits(H,G,Z,ee,le){return this.s(H,xe,ye=>Promise.resolve(ye.provideMappedEdits(G,Z,ee,le)),null,le)}registerDocumentPasteEditProvider(H,G,Z,ee){const le=this.q();return this.f.set(le,new Fe(new j(this.e,this.h,Z,le,H),H)),this.e.$registerPasteEditProvider(le,this.o(G,H),{supportsCopy:!!Z.prepareDocumentPaste,supportsPaste:!!Z.provideDocumentPasteEdits,supportsResolve:!!Z.resolveDocumentPasteEdit,providedPasteEditKinds:ee.providedPasteEditKinds?.map(ye=>ye.value),copyMimeTypes:ee.copyMimeTypes,pasteMimeTypes:ee.pasteMimeTypes}),this.p(le)}$prepareDocumentPaste(H,G,Z,ee,le){return this.s(H,j,ye=>ye.prepareDocumentPaste(g.URI.revive(G),Z,ee,le),void 0,le)}$providePasteEdits(H,G,Z,ee,le,ye,Te){return this.s(H,j,Ve=>Ve.providePasteEdits(G,g.URI.revive(Z),ee,le,ye,Te),void 0,Te)}$resolvePasteEdit(H,G,Z){return this.s(H,j,ee=>ee.resolvePasteEdit(G,Z),{},void 0)}$releasePasteEdits(H,G){this.s(H,j,Z=>Promise.resolve(Z.releasePasteEdits(G)),void 0,void 0)}static y(H){return{pattern:H.source,flags:H.flags}}static z(H){return{decreaseIndentPattern:We.y(H.decreaseIndentPattern),increaseIndentPattern:We.y(H.increaseIndentPattern),indentNextLinePattern:H.indentNextLinePattern?We.y(H.indentNextLinePattern):void 0,unIndentedLinePattern:H.unIndentedLinePattern?We.y(H.unIndentedLinePattern):void 0}}static B(H){return{beforeText:We.y(H.beforeText),afterText:H.afterText?We.y(H.afterText):void 0,previousLineText:H.previousLineText?We.y(H.previousLineText):void 0,action:H.action}}static C(H){return H.map(We.B)}static D(H){return{open:H.open,close:H.close,notIn:H.notIn?H.notIn.map(G=>o.SyntaxTokenType.toString(G)):void 0}}static E(H){return H.map(We.D)}setLanguageConfiguration(H,G,Z){const{wordPattern:ee}=Z;if(ee&&(0,I.$uf)(ee))throw new Error(`Invalid language configuration: wordPattern '${ee}' is not allowed to match the empty string.`);ee?this.h.setWordDefinitionFor(G,ee):this.h.setWordDefinitionFor(G,void 0),Z.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",H,"Do not use."),Z.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",H,"Do not use.");const le=this.q(),ye={comments:Z.comments,brackets:Z.brackets,wordPattern:Z.wordPattern?We.y(Z.wordPattern):void 0,indentationRules:Z.indentationRules?We.z(Z.indentationRules):void 0,onEnterRules:Z.onEnterRules?We.C(Z.onEnterRules):void 0,__electricCharacterSupport:Z.__electricCharacterSupport,__characterPairSupport:Z.__characterPairSupport,autoClosingPairs:Z.autoClosingPairs?We.E(Z.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(le,G,ye),this.p(le)}$setWordDefinitions(H){for(const G of H)this.h.setWordDefinitionFor(G.languageId,new RegExp(G.regexSource,G.regexFlags))}}e.$Hqc=We}),define(Re[306],Ce([1,0,3,38,6,15]),function(ge,e,s,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$esc=void 0,A=Ue(A);class O{constructor(m){this.a=new Map,this.c=new Map,this.b=m.getProxy(R.$3N.MainThreadLanguageModelTools),this.b.$getTools().then(c=>{for(const I of c)this.c.set(I.id,(0,h.$fi)(I))})}async invokeTool(m,c,I){const E=await this.b.$invokeTool(m,c,I);return A.LanguageModelToolResult.to(E)}async $acceptToolDelta(m){m.added&&this.c.set(m.added.id,m.added),m.removed&&this.c.delete(m.removed)}get tools(){return Array.from(this.c.values()).map(m=>A.LanguageModelToolDescription.to(m))}async $invokeTool(m,c,I){const E=this.a.get(m);if(!E)throw new Error(`Unknown tool ${m}`);const g=await E.tool.invoke(c,I);return A.LanguageModelToolResult.from(g)}registerTool(m,c,I){return this.a.set(c,{extension:m,tool:I}),this.b.$registerTool(c),(0,s.$Vc)(()=>{this.a.delete(c),this.b.$unregisterTool(c)})}}e.$esc=O}),define(Re[128],Ce([1,0,7,20,52,12,4,40,3,8,23,5,11,90,6,127,19,15,9,159,25]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P,b,a,$,p,u,i,o){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$prc=e.$orc=void 0,p=Ue(p),u=Ue(u),e.$orc=(0,E.$Ii)("IExtHostLanguageModels");class n{constructor(f,y){this.option=f,this.stream=new s.$_h,this.stream=y??new s.$_h}}class r{constructor(){this.a=new Map,this.b=new s.$_h,this.c=!1;const f=this;this.apiObject={get stream(){return f.b.asyncIterable},get text(){return s.$9h.map(f.b.asyncIterable,y=>{if(y instanceof u.$nQ)return y.value}).coalesce()}}}*d(){if(this.a.size>0)for(const[,f]of this.a)yield f.stream;else yield this.b}handleFragment(f){if(this.c)return;let y=this.a.get(f.index);y||(this.a.size===0?y=new n(f.index,this.b):y=new n(f.index),this.a.set(f.index,y));let k;f.part.type==="text"?k=new u.$nQ(f.part.value):k=new u.$mQ(f.part.name,f.part.parameters),y.stream.emitOne(k)}reject(f){this.c=!0;for(const y of this.d())y.reject(f)}resolve(){this.c=!0;for(const f of this.d())f.resolve()}}let d=class{static{t=this}static{this.a=1}constructor(f,y,k){this.j=y,this.k=k,this.c=new O.$oe,this.d=new O.$oe,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new I.$xn,this.i=new Map,this.s=new Set,this.b=f.getProxy(b.$3N.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(f,y,k,S){const D=t.a++;this.f.set(D,{extension:f.identifier,provider:k,languageModelId:y});let T;S.auth&&(T={providerLabel:f.displayName||f.name,accountLabel:typeof S.auth=="object"?S.auth.label:void 0}),this.b.$registerLanguageModelProvider(D,`${I.$vn.toKey(f.identifier)}/${D}/${y}`,{extension:f.identifier,id:y,vendor:S.vendor??I.$vn.toKey(f.identifier),name:S.name??"",family:S.family??"",version:S.version,maxInputTokens:S.maxInputTokens,maxOutputTokens:S.maxOutputTokens,auth:T,targetExtensions:S.extensions});const v=k.onDidReceiveLanguageModelResponse2?.(({extensionId:w,participant:M,tokenCount:L})=>{this.b.$whenLanguageModelChatRequestMade(y,new I.$vn(w),M,L)});return(0,m.$Vc)(()=>{this.f.delete(D),this.b.$unregisterProvider(D),v?.dispose()})}async $startChatRequest(f,y,k,S,D,T){const v=this.f.get(f);if(!v)throw new Error("Provider not found");const w=new P.$Gw(async L=>{if(T.isCancellationRequested){this.j.warn(`[CHAT](${v.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let N;if(L.part instanceof u.$mQ?N={type:"function_use",name:L.part.name,parameters:L.part.parameters}:L.part instanceof u.$nQ&&(N={type:"text",value:L.part.value}),!N){this.j.warn(`[CHAT](${v.extension.value}) UNKNOWN part ${JSON.stringify(L)}`);return}this.b.$reportResponsePart(y,{index:L.index,part:N})});let M;if(v.provider.provideLanguageModelResponse2)M=Promise.resolve(v.provider.provideLanguageModelResponse2(S.map(p.LanguageModelChatMessage.to),D,I.$vn.toKey(k),w,T));else{const L=new P.$Gw(async N=>{w.report({index:N.index,part:new u.$nQ(N.part)})});M=Promise.resolve(v.provider.provideLanguageModelResponse(S.map(p.LanguageModelChatMessage.to),D?.modelOptions??{},I.$vn.toKey(k),L,T))}M.then(()=>{this.b.$reportResponseDone(y,void 0)},L=>{this.b.$reportResponseDone(y,(0,A.$4)(L))})}$provideTokenLength(f,y,k){const S=this.f.get(f);return S?Promise.resolve(S.provider.provideTokenCount(y,k)):Promise.resolve(0)}$acceptChatModelMetadata(f){if(f.added)for(const{identifier:y,metadata:k}of f.added)this.g.set(y,{metadata:k,apiObjects:new I.$xn});if(f.removed)for(const y of f.removed){this.g.delete(y);for(const[k,S]of this.i)S.languageModelId===y&&(S.res.reject(new A.$7),this.i.delete(k))}f.added?.forEach(y=>this.q(y.metadata)),this.d.fire(void 0)}async selectLanguageModels(f,y){const k=await this.b.$selectChatModels({...y,extension:f.identifier}),S=[],D=this;for(const T of k){const v=this.g.get(T);if(!v)continue;this.o(f.identifier,v.metadata)&&await this.q(v.metadata);let w=v.apiObjects.get(f.identifier);w||(w={id:T,vendor:v.metadata.vendor,family:v.metadata.family,version:v.metadata.version,name:v.metadata.name,maxInputTokens:v.metadata.maxInputTokens,countTokens(M,L){if(!D.g.has(T))throw u.$rQ.NotFound(T);return D.r(T,M,L??h.CancellationToken.None)},sendRequest(M,L,N){if(!D.g.has(T))throw u.$rQ.NotFound(T);return D.l(f,T,M,L??{},N??h.CancellationToken.None)}},Object.freeze(w),v.apiObjects.set(f.identifier,w)),S.push(w)}return S}async l(f,y,k,S,D){const T=this.m(f,k),v=f.identifier,w=this.g.get(y)?.metadata;if(!w||!this.g.has(y))throw u.$rQ.NotFound(`Language model '${y}' is unknown.`);if(this.o(v,w)&&(!await this.n(f,{identifier:w.extension,displayName:w.auth.providerLabel},S.justification,!1)||!this.h.get(v)?.has(w.extension)))throw u.$rQ.NoPermissions(`Language model '${y}' cannot be used by '${v.value}'.`);try{const M=Math.random()*1e6|0,L=new r;this.i.set(M,{languageModelId:y,res:L});try{await this.b.$tryStartChatRequest(v,y,M,T,S,D)}catch(N){throw this.i.delete(M),N}return L.apiObject}catch(M){throw M.name===u.$rQ.name?M:new u.$rQ(`Language model '${y}' errored: ${(0,R.$tj)(M)}`,"Unknown",M)}}m(f,y){const k=[];for(const S of y)S.role===u.LanguageModelChatMessageRole.System&&(0,o.$wH)(f,"languageModelSystem"),S.content2 instanceof u.$kQ&&(0,o.$wH)(f,"lmTools"),k.push(p.LanguageModelChatMessage.from(S));return k}async $acceptResponsePart(f,y){const k=this.i.get(f);k&&k.res.handleFragment(y)}async $acceptResponseDone(f,y){const k=this.i.get(f);k&&(this.i.delete(f),y?k.res.reject((0,A.$5)(y)):k.res.resolve())}async n(f,y,k,S){const D=i.$6M+y.identifier.value;if(await this.k.getSession(f,D,[],{silent:!0}))return this.$updateModelAccesslist([{from:f.identifier,to:y.identifier,enabled:!0}]),!0;if(S)return!1;try{const v=k?(0,c.localize)(2705,null,y.displayName,k):void 0;return await this.k.getSession(f,D,[],{forceNewSession:{detail:v}}),this.$updateModelAccesslist([{from:f.identifier,to:y.identifier,enabled:!0}]),!0}catch{return!1}}o(f,y){return!!y.auth&&!I.$vn.equals(y.extension,f)}async q(f){if(f.auth)for(const y of this.s)try{await this.n(y,{identifier:f.extension,displayName:""},void 0,!0)}catch(k){this.j.error("Fake Auth request failed"),this.j.error(k)}}async r(f,y,k){if(!this.g.get(f))throw u.$rQ.NotFound(`Language model '${f}' is unknown.`);const D=C.Iterable.find(this.f.values(),T=>T.languageModelId===f);return D?D.provider.provideTokenCount(y,k):this.b.$countTokens(f,typeof y=="string"?y:p.LanguageModelChatMessage.from(y),k)}$updateModelAccesslist(f){const y=new Array;for(const{from:k,to:S,enabled:D}of f){const T=this.h.get(k)??new I.$wn;if(T.has(S)!==D){D?T.add(S):T.delete(S),this.h.set(k,T);const w={from:k,to:S};y.push(w),this.c.fire(w)}}}createLanguageModelAccessInformation(f){this.s.add(f);const y=this,k=O.Event.signal(O.Event.filter(this.c.event,D=>I.$vn.equals(D.from,f.identifier))),S=O.Event.signal(this.d.event);return{get onDidChange(){return O.Event.any(k,S)},canSendRequest(D){let T;e:for(const[w,M]of y.g)for(const L of M.apiObjects.values())if(L===D){T=M.metadata;break e}if(!T)return;if(!y.o(f.identifier,T))return!0;const v=y.h.get(f.identifier);if(v)return v.has(T.extension)}}}};e.$prc=d,e.$prc=d=t=Ze([qe(0,$.$DQ),qe(1,g.$dk),qe(2,a.$Jqc)],d)});var Ht=this&&this.__importDefault||function(ge){return ge&&ge.__esModule?ge:{default:ge}};define(Re[307],Ce([1,0,6,15,9,44,7,3,25]),function(ge,e,s,h,R,A,O,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fsc=void 0,h=Ue(h),A=Ht(A);class c{constructor(E,g,P,b){this.c=g,this.d=P,this.e=b,this.b=[],this.f=0,this.g=new Set,this.a=E.getProxy(s.$3N.MainThreadLanguages)}$acceptLanguageIds(E){this.b=E}async getLanguages(){return this.b.slice(0)}async changeLanguage(E,g){await this.a.$changeLanguage(E,g);const P=this.c.getDocumentData(E);if(!P)throw new Error(`document '${E.toString()}' NOT found`);return P.document}async tokenAtPosition(E,g){const P=E.version,b=h.Position.from(g),a=await this.a.$tokensAtPosition(E.uri,b),$={type:R.StandardTokenType.Other,range:E.getWordRangeAtPosition(g)??new R.$7N(g.line,g.character,g.line,g.character)};if(!a)return $;const p={range:h.Range.to(a.range),type:h.TokenType.to(a.type)};return!p.range.contains(g)||P!==E.version?$:p}createLanguageStatusItem(E,g,P){const b=this.f++,a=this.a,$=this.g,p=`${E.identifier.value}/${g}`;if($.has(p))throw new Error(`LanguageStatusItem with id '${g}' ALREADY exists`);$.add(p);const u={selector:P,id:g,name:E.displayName??E.name,severity:R.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const o=new C.$Wc,t=()=>{if(i?.dispose(),!$.has(p)){console.warn(`LanguageStatusItem (${g}) from ${E.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,O.$Kh)(()=>{o.clear(),this.a.$setLanguageStatus(b,{id:p,name:u.name??E.displayName??E.name,source:E.displayName??E.name,selector:h.DocumentSelector.from(u.selector,this.e),label:u.text,detail:u.detail??"",severity:u.severity===R.LanguageStatusSeverity.Error?A.default.Error:u.severity===R.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:u.command&&this.d.toInternal(u.command,o),accessibilityInfo:u.accessibilityInformation,busy:u.busy})},0)},n={dispose(){o.dispose(),i?.dispose(),a.$removeLanguageStatus(b),$.delete(p)},get id(){return u.id},get name(){return u.name},set name(r){u.name=r,t()},get selector(){return u.selector},set selector(r){u.selector=r,t()},get text(){return u.text},set text(r){u.text=r,t()},set text2(r){(0,m.$wH)(E,"languageStatusText"),u.text=r,t()},get text2(){return(0,m.$wH)(E,"languageStatusText"),u.text},get detail(){return u.detail},set detail(r){u.detail=r,t()},get severity(){return u.severity},set severity(r){u.severity=r,t()},get accessibilityInformation(){return u.accessibilityInformation},set accessibilityInformation(r){u.accessibilityInformation=r,t()},get command(){return u.command},set command(r){u.command=r,t()},get busy(){return u.busy},set busy(r){u.busy=r,t()}};return t(),n}}e.$fsc=c}),define(Re[308],Ce([1,0,14,2,15,9,126]),function(ge,e,s,h,R,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yrc=e.$Xrc=void 0,R=Ue(R),O=Ue(O);class C{constructor(E,g,P,b){this.start=E,this.deletedCount=g,this.deletedItems=P,this.items=b}asApiEvent(){return{range:new A.$wP(this.start,this.start+this.deletedCount),addedCells:this.items.map(E=>E.apiCell),removedCells:this.deletedItems}}}class m{static asModelAddData(E){return{EOL:E.eol,lines:E.source,languageId:E.language,uri:E.uri,isDirty:!1,versionId:1}}constructor(E,g,P){this.notebook=E,this.h=g,this.j=P,this.handle=P.handle,this.uri=h.URI.revive(P.uri),this.cellKind=P.cellKind,this.a=P.outputs.map(R.NotebookCellOutput.to),this.e=P.internalMetadata??{},this.b=Object.freeze(P.metadata??{}),this.d=Object.freeze(R.NotebookCellExecutionSummary.to(P.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const E=this,g=this.h.getDocument(this.uri);if(!g)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const P={get index(){return E.notebook.getCellIndex(E)},notebook:E.notebook.apiNotebook,kind:R.NotebookCellKind.to(this.j.cellKind),document:g.document,get mime(){return E.g},set mime(b){E.g=b},get outputs(){return E.a.slice(0)},get metadata(){return E.b},get executionSummary(){return E.d}};this.f=Object.freeze(P)}return this.f}setOutputs(E){this.a=E.map(R.NotebookCellOutput.to)}setOutputItems(E,g,P){const b=P.map(R.NotebookCellOutputItem.to),a=this.a.find($=>$.id===E);if(a&&(g||(a.items.length=0),a.items.push(...b),a.items.length>1&&a.items.every($=>O.$6L($.mime)))){const $=new Map,p=[];a.items.forEach(u=>{let i;$.has(u.mime)?i=$.get(u.mime):(i=[],$.set(u.mime,i),p.push(u.mime)),i.push(u.data)}),a.items.length=0,p.forEach(u=>{const i=O.$7L($.get(u));a.items.push({mime:u,data:i.data.buffer})})}}setMetadata(E){this.b=Object.freeze(E)}setInternalMetadata(E){this.e=E,this.d=Object.freeze(R.NotebookCellExecutionSummary.to(E))}setMime(E){}}e.$Xrc=m;class c{static{this.a=0}constructor(E,g,P,b,a){this.k=E,this.l=g,this.m=P,this.uri=b,this.handle=c.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=a.viewType,this.f=Object.freeze(a.metadata??Object.create(null)),this.r([[0,0,a.cells]],!0,void 0),this.g=a.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const E=this,g={get uri(){return E.uri},get version(){return E.g},get notebookType(){return E.d},get isDirty(){return E.h},get isUntitled(){return E.uri.scheme===s.Schemas.untitled},get isClosed(){return E.j},get metadata(){return E.f},get cellCount(){return E.b.length},cellAt(P){return P=E.n(P),E.b[P].apiCell},getCells(P){return(P?E.p(P):E.b).map(a=>a.apiCell)},save(){return E.q()},[Symbol.for("debug.description")](){return`NotebookDocument(${this.uri.toString()})`}};this.e=Object.freeze(g)}return this.e}acceptDocumentPropertiesChanged(E){E.metadata&&(this.f=Object.freeze({...this.f,...E.metadata}))}acceptDirty(E){this.h=E}acceptModelChanged(E,g,P){this.g=E.versionId,this.h=g,this.acceptDocumentPropertiesChanged({metadata:P});const b={notebook:this.apiNotebook,metadata:P,cellChanges:[],contentChanges:[]},a=[];for(const p of E.rawEvents)p.kind===O.NotebookCellsChangeType.ModelChange?this.r(p.changes,!1,b.contentChanges):p.kind===O.NotebookCellsChangeType.Move?this.s(p.index,p.length,p.newIdx,b.contentChanges):p.kind===O.NotebookCellsChangeType.Output?(this.t(p.index,p.outputs),a.push({cell:this.b[p.index].apiCell,outputs:this.b[p.index].apiCell.outputs})):p.kind===O.NotebookCellsChangeType.OutputItem?(this.u(p.index,p.outputId,p.append,p.outputItems),a.push({cell:this.b[p.index].apiCell,outputs:this.b[p.index].apiCell.outputs})):p.kind===O.NotebookCellsChangeType.ChangeCellLanguage?(this.v(p.index,p.language),a.push({cell:this.b[p.index].apiCell,document:this.b[p.index].apiCell.document})):p.kind===O.NotebookCellsChangeType.ChangeCellContent?a.push({cell:this.b[p.index].apiCell,document:this.b[p.index].apiCell.document}):p.kind===O.NotebookCellsChangeType.ChangeCellMime?this.w(p.index,p.mime):p.kind===O.NotebookCellsChangeType.ChangeCellMetadata?(this.x(p.index,p.metadata),a.push({cell:this.b[p.index].apiCell,metadata:this.b[p.index].apiCell.metadata})):p.kind===O.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(p.index,p.internalMetadata),a.push({cell:this.b[p.index].apiCell,executionSummary:this.b[p.index].apiCell.executionSummary}));const $=new Map;for(let p=0;p<a.length;p++){const u=a[p],i=$.get(u.cell);if(i===void 0){const o=b.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...u});$.set(u.cell,o-1)}else b.cellChanges[i]={...b.cellChanges[i],...u}}return Object.freeze(b),Object.freeze(b.cellChanges),Object.freeze(b.contentChanges),b}n(E){return E=E|0,E<0?0:E>=this.b.length?this.b.length-1:E}o(E){let g=E.start|0,P=E.end|0;return g<0&&(g=0),P>this.b.length&&(P=this.b.length),E.with({start:g,end:P})}p(E){E=this.o(E);const g=[];for(let P=E.start;P<E.end;P++)g.push(this.b[P]);return g}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(E,g,P){if(this.j)return;const b=[],a=[],$=[];if(E.reverse().forEach(p=>{const i=p[2].map(n=>{const r=new m(this,this.l,n);return g||a.push(m.asModelAddData(n)),r}),o=new C(p[0],p[1],[],i),t=this.b.splice(p[0],p[1],...i);for(const n of t)$.push(n.uri),o.deletedItems.push(n.apiCell);b.push(o)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:$}),P)for(const p of b)P.push(p.asApiEvent())}s(E,g,P,b){const a=this.b.splice(E,g);this.b.splice(P,0,...a);const $=[new C(E,g,a.map(p=>p.apiCell),[]),new C(P,0,[],a)];for(const p of $)b.push(p.asApiEvent())}t(E,g){this.b[E].setOutputs(g)}u(E,g,P,b){this.b[E].setOutputItems(g,P,b)}v(E,g){const P=this.b[E];P.apiCell.document.languageId!==g&&this.m.$acceptModelLanguageChanged(P.uri,g)}w(E,g){const P=this.b[E];P.apiCell.mime=g}x(E,g){this.b[E].setMetadata(g)}y(E,g){this.b[E].setInternalMetadata(g)}getCellFromApiCell(E){return this.b.find(g=>g.apiCell===E)}getCellFromIndex(E){return this.b[E]}getCell(E){return this.b.find(g=>g.handle===E)}getCellIndex(E){return this.b.indexOf(E)}}e.$Yrc=c}),define(Re[309],Ce([1,0,4,2,15,9,53]),function(ge,e,s,h,R,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hsc=void 0;class C{constructor(c,I,E,g={timeout:1500,errors:3}){this.b=c,this.c=I,this.d=E,this.f=g,this.a=new s.$qe}dispose(){}getOnWillSaveNotebookDocumentEvent(c){return(I,E,g)=>{const P=function(a){I.call(E,a)};return P.extension=c,this.a.event(P,void 0,g)}}async $participateInSave(c,I,E){const g=h.URI.revive(c),P=this.c.getNotebookDocument(g);if(!P)throw new Error("Unable to resolve notebook document");const b=[];if(await this.a.fireAsync({notebook:P.apiNotebook,reason:R.TextDocumentSaveReason.to(I)},E,async($,p)=>{const u=Date.now(),i=await await Promise.resolve($);Date.now()-u>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",p.extension.identifier),!E.isCancellationRequested&&i&&(i instanceof A.$eO?b.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",p.extension.identifier,"ignored due to invalid data"))}),E.isCancellationRequested)return!1;if(b.length===0)return!0;const a={edits:[]};for(const $ of b){const{edits:p}=R.WorkspaceEdit.from($);a.edits=a.edits.concat(p)}return this.d.$tryApplyWorkspaceEdit(new O.$5w(a))}}e.$hsc=C}),define(Re[168],Ce([1,0,12,15,9]),function(ge,e,s,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zrc=void 0,h=Ue(h),R=Ue(R);class A{static{this.apiEditorsToExtHost=new WeakMap}constructor(C,m,c,I,E,g){this.id=C,this.f=m,this.notebookData=c,this.a=[],this.b=[],this.d=!1,this.a=E,this.b=I,this.c=g}get apiEditor(){if(!this.e){const C=this;this.e={get notebook(){return C.notebookData.apiNotebook},get selection(){return C.a[0]},set selection(m){this.selections=[m]},get selections(){return C.a},set selections(m){if(!Array.isArray(m)||!m.every(R.$wP.isNotebookRange))throw(0,s.$9)("selections");C.a=m,C.g(m)},get visibleRanges(){return C.b},revealRange(m,c){C.f.$tryRevealRange(C.id,h.NotebookRange.from(m),c??R.NotebookEditorRevealType.Default)},get viewColumn(){return C.c},[Symbol.for("debug.description")](){return`NotebookEditor(${this.notebook.uri.toString()})`}},A.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(C){this.d=C}_acceptVisibleRanges(C){this.b=C}_acceptSelections(C){this.a=C}g(C){this.f.$trySetSelections(this.id,C.map(h.NotebookRange.from))}_acceptViewColumn(C){this.c=C}}e.$Zrc=A}),define(Re[310],Ce([1,0,4,11,15]),function(ge,e,s,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jsc=void 0,R=Ue(R);let A=class{constructor(C,m){this.c=C,this.d=m,this.a=new s.$oe,this.b=new s.$oe,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(C,m){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",C,m);const c=this.d.getEditorById(C);m.visibleRanges&&c._acceptVisibleRanges(m.visibleRanges.ranges.map(R.NotebookRange.to)),m.selections&&c._acceptSelections(m.selections.selections.map(R.NotebookRange.to)),m.visibleRanges&&this.b.fire({notebookEditor:c.apiEditor,visibleRanges:c.apiEditor.visibleRanges}),m.selections&&this.a.fire(Object.freeze({notebookEditor:c.apiEditor,selections:c.apiEditor.selections}))}$acceptEditorViewColumns(C){for(const m in C)this.d.getEditorById(m)._acceptViewColumn(R.ViewColumn.to(C[m]))}};e.$jsc=A,e.$jsc=A=Ze([qe(0,h.$dk)],A)}),define(Re[311],Ce([1,0,4,6,168]),function(ge,e,s,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$msc=void 0;class A{constructor(C,m){this.c=m,this.a=new Map,this.b=C.getProxy(h.$3N.MainThreadNotebookRenderers)}$postRendererMessage(C,m,c){const I=this.c.getEditorById(C);this.a.get(m)?.fire({editor:I.apiEditor,message:c})}createRendererMessaging(C,m){if(!C.contributes?.notebookRenderer?.some(I=>I.id===m))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${m})`);return{onDidReceiveMessage:(I,E,g)=>this.d(m).event(I,E,g),postMessage:(I,E)=>{R.$Zrc.apiEditorsToExtHost.has(I)&&([I,E]=[E,I]);const g=E&&R.$Zrc.apiEditorsToExtHost.get(E);return this.b.$postMessage(g?.id,m,I)}}}d(C){let m=this.a.get(C);return m||(m=new s.$oe({onDidRemoveLastListener:()=>{m?.dispose(),this.a.delete(C)}}),this.a.set(C,m),m)}}e.$msc=A}),define(Re[312],Ce([1,0,15,90,20,60,12]),function(ge,e,s,h,R,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qsc=void 0;class C{constructor(E){this.b=0,this.c=new Map,this.a=E}async withProgress(E,g,P){const b=this.b++,{title:a,location:$,cancellable:p}=g,u={label:E.displayName||E.name,id:E.identifier.value};return this.a.$startProgress(b,{location:s.ProgressLocation.from($),title:a,source:u,cancellable:p},E.isUnderDevelopment?void 0:E.identifier.value).catch(O.$3),this.d(b,P,!!p)}d(E,g,P){let b;P&&(b=new R.$ze,this.c.set(E,b));const a=p=>{this.a.$progressEnd(p),this.c.delete(p),b?.dispose()};let $;try{$=g(new c(this.a,E),P&&b?b.token:R.CancellationToken.None)}catch(p){throw a(E),p}return $.then(p=>a(E),p=>a(E)),$}$acceptProgressCanceled(E){const g=this.c.get(E);g&&(g.cancel(),this.c.delete(E))}}e.$qsc=C;function m(I,E){return I.message=E.message,typeof E.increment=="number"&&(typeof I.increment=="number"?I.increment+=E.increment:I.increment=E.increment),I}class c extends h.$Gw{constructor(E,g){super(P=>this.throttledReport(P)),this.c=E,this.d=g}throttledReport(E){this.c.$progressReport(this.d,E)}}Ze([(0,A.$ci)(100,(I,E)=>m(I,E),()=>Object.create(null))],c.prototype,"throttledReport",null)}),define(Re[313],Ce([1,0,2,6,7,15]),function(ge,e,s,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rsc=void 0;class O{static{this.a=0}constructor(m,c){this.d=c,this.c=new Map,this.b=m.getProxy(h.$3N.MainThreadQuickDiff)}$provideOriginalResource(m,c,I){const E=s.URI.revive(c),g=this.c.get(m);return g?(0,R.$Ah)(()=>g.provideOriginalResource(E,I)).then(P=>P||null):Promise.resolve(null)}registerQuickDiffProvider(m,c,I,E){const g=O.a++;return this.c.set(g,c),this.b.$registerQuickDiffProvider(g,A.DocumentSelector.from(m,this.d),I,E),{dispose:()=>{this.b.$unregisterQuickDiffProvider(g),this.c.delete(g)}}}}e.$rsc=O});var Ht=this&&this.__importDefault||function(ge){return ge&&ge.__esModule?ge:{default:ge}};define(Re[314],Ce([1,0,20,4,3,6,2,9,12,18,44,51,25,15]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ssc=b,I=Ht(I);function b(a,$,p){const u=a.getProxy(A.$3N.MainThreadQuickOpen);class i{constructor(k,S){this.e=new Map,this.f=0,this.a=k,this.b=S}showQuickPick(k,S,D,T=s.CancellationToken.None){this.c=void 0;const v=Promise.resolve(S),w=++this.f,M=u.$show(w,{title:D?.title,placeHolder:D?.placeHolder,matchOnDescription:D?.matchOnDescription,matchOnDetail:D?.matchOnDetail,ignoreFocusLost:D?.ignoreFocusOut,canPickMany:D?.canPickMany},T),L={},N=M.then(()=>L);return Promise.race([N,v]).then(F=>{if(F===L)return;const V=(0,g.$vH)(k,"quickPickItemTooltip");return v.then(j=>{const U=[];for(let z=0;z<j.length;z++){const _=j[z];if(typeof _=="string")U.push({label:_,handle:z});else if(_.kind===C.QuickPickItemKind.Separator)U.push({type:"separator",label:_.label});else{_.tooltip&&!V&&console.warn(`Extension '${k.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${k.identifier.value}`);const W=_.iconPath?d(_.iconPath):void 0;U.push({label:_.label,iconPath:W?.iconPath,iconClass:W?.iconClass,description:_.description,detail:_.detail,picked:_.picked,alwaysShow:_.alwaysShow,tooltip:V?P.MarkdownString.fromStrict(_.tooltip):void 0,handle:z})}}return D&&typeof D.onDidSelectItem=="function"&&(this.c=z=>{D.onDidSelectItem(j[z])}),u.$setItems(w,U),M.then(z=>{if(typeof z=="number")return j[z];if(Array.isArray(z))return z.map(_=>j[_])})})}).then(void 0,F=>{if(!(0,m.$6)(F))return u.$setError(w,F),Promise.reject(F)})}$onItemSelected(k){this.c?.(k)}showInput(k,S=s.CancellationToken.None){return this.d=k?.validateInput,u.$input(k,typeof this.d=="function",S).then(void 0,D=>{if(!(0,m.$6)(D))return Promise.reject(D)})}async $validateInput(k){if(!this.d)return;const S=await this.d(k);if(!S||typeof S=="string")return S;let D;switch(S.severity){case C.InputBoxValidationSeverity.Info:D=I.default.Info;break;case C.InputBoxValidationSeverity.Warning:D=I.default.Warning;break;case C.InputBoxValidationSeverity.Error:D=I.default.Error;break;default:D=S.message?I.default.Error:I.default.Ignore;break}return{content:S.message,severity:D}}async showWorkspaceFolderPick(k,S=s.CancellationToken.None){const D=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[k]);if(!D)return;const T=await this.a.getWorkspaceFolders2();if(T)return T.find(v=>v.uri.toString()===D.uri.toString())}createQuickPick(k){const S=new l(k,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}createInputBox(k){const S=new f(k,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}$onDidChangeValue(k,S){this.e.get(k)?._fireDidChangeValue(S)}$onDidAccept(k){this.e.get(k)?._fireDidAccept()}$onDidChangeActive(k,S){const D=this.e.get(k);D instanceof l&&D._fireDidChangeActive(S)}$onDidChangeSelection(k,S){const D=this.e.get(k);D instanceof l&&D._fireDidChangeSelection(S)}$onDidTriggerButton(k,S){this.e.get(k)?._fireDidTriggerButton(S)}$onDidTriggerItemButton(k,S,D){const T=this.e.get(k);T instanceof l&&T._fireDidTriggerItemButton(S,D)}$onDidHide(k){this.e.get(k)?._fireDidHide()}}class o{static{this.a=1}constructor(k,S){this.x=k,this.y=S,this._id=l.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new h.$oe,this.q=new h.$oe,this.r=new h.$oe,this.s=new h.$oe,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(k){this.b=k,this.z({title:k})}get step(){return this.c}set step(k){this.c=k,this.z({step:k})}get totalSteps(){return this.d}set totalSteps(k){this.d=k,this.z({totalSteps:k})}get enabled(){return this.g}set enabled(k){this.g=k,this.z({enabled:k})}get busy(){return this.j}set busy(k){this.j=k,this.z({busy:k})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(k){this.k=k,this.z({ignoreFocusOut:k})}get value(){return this.l}set value(k){this.l=k,this.z({value:k})}get placeholder(){return this.m}set placeholder(k){this.m=k,this.z({placeholder:k})}get buttons(){return this.n}set buttons(k){const S=(0,g.$vH)(this.x,"quickInputButtonLocation");!S&&k.some(D=>D.location)&&console.warn(`Extension '${this.x.identifier.value}' uses a button location which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.x.identifier.value}`),this.n=k.slice(),this.o.clear(),k.forEach((D,T)=>{const v=D===C.$tP.Back?-1:T;this.o.set(v,D)}),this.z({buttons:k.map((D,T)=>({...d(D.iconPath),tooltip:D.tooltip,handle:D===C.$tP.Back?-1:T,location:S?D.location:void 0}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(k){this.l=k,this.q.fire(k)}_fireDidTriggerButton(k){const S=this.o.get(k);S&&this.r.fire(S)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,R.$Sc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),u.$dispose(this._id))}z(k){if(!this.v){for(const S of Object.keys(k)){const D=k[S];this.u[S]=D===void 0?null:D}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){u.$createOrUpdate(this.u),this.u={id:this._id}}}function t(y){if(y instanceof C.$4O)return{id:y.id};const k=r(y),S=n(y);return{dark:typeof k=="string"?O.URI.file(k):k,light:typeof S=="string"?O.URI.file(S):S}}function n(y){return typeof y=="object"&&"light"in y?y.light:y}function r(y){return typeof y=="object"&&"dark"in y?y.dark:y}function d(y){const k=t(y);let S,D;return"id"in k?D=E.ThemeIcon.asClassName(k):S=k,{iconPath:S,iconClass:D}}class l extends o{constructor(k,S){super(k,S),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new h.$oe,this.L=[],this.M=new h.$oe,this.N=new h.$oe,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(k){this.B=k.slice(),this.C.clear(),this.D.clear(),k.forEach((T,v)=>{this.C.set(v,T),this.D.set(T,v)});const S=(0,g.$vH)(this.x,"quickPickItemTooltip"),D=[];for(let T=0;T<k.length;T++){const v=k[T];if(v.kind===C.QuickPickItemKind.Separator)D.push({type:"separator",label:v.label});else{v.tooltip&&!S&&console.warn(`Extension '${this.x.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.x.identifier.value}`);const w=v.iconPath?d(v.iconPath):void 0;D.push({handle:T,label:v.label,iconPath:w?.iconPath,iconClass:w?.iconClass,description:v.description,detail:v.detail,picked:v.picked,alwaysShow:v.alwaysShow,tooltip:S?P.MarkdownString.fromStrict(v.tooltip):void 0,buttons:v.buttons?.map((M,L)=>({...d(M.iconPath),tooltip:M.tooltip,handle:L}))})}}this.z({items:D})}get canSelectMany(){return this.E}set canSelectMany(k){this.E=k,this.z({canSelectMany:k})}get matchOnDescription(){return this.F}set matchOnDescription(k){this.F=k,this.z({matchOnDescription:k})}get matchOnDetail(){return this.G}set matchOnDetail(k){this.G=k,this.z({matchOnDetail:k})}get sortByLabel(){return this.H}set sortByLabel(k){this.H=k,this.z({sortByLabel:k})}get keepScrollPosition(){return this.I}set keepScrollPosition(k){this.I=k,this.z({keepScrollPosition:k})}get activeItems(){return this.J}set activeItems(k){this.J=k.filter(S=>this.D.has(S)),this.z({activeItems:this.J.map(S=>this.D.get(S))})}get selectedItems(){return this.L}set selectedItems(k){this.L=k.filter(S=>this.D.has(S)),this.z({selectedItems:this.L.map(S=>this.D.get(S))})}_fireDidChangeActive(k){const S=(0,c.$Jb)(k.map(D=>this.C.get(D)));this.J=S,this.K.fire(S)}_fireDidChangeSelection(k){const S=(0,c.$Jb)(k.map(D=>this.C.get(D)));this.L=S,this.M.fire(S)}_fireDidTriggerItemButton(k,S){const D=this.C.get(k);if(!D||!D.buttons||!D.buttons.length)return;const T=D.buttons[S];T&&this.N.fire({button:T,item:D})}}class f extends o{constructor(k,S){super(k,S),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(k){this.B=k,this.z({password:k})}get prompt(){return this.C}set prompt(k){this.C=k,this.z({prompt:k})}get valueSelection(){return this.D}set valueSelection(k){this.D=k,this.z({valueSelection:k})}get validationMessage(){return this.E}set validationMessage(k){this.E=k,k?typeof k=="string"?this.z({validationMessage:k,severity:I.default.Error}):this.z({validationMessage:k.message,severity:k.severity??I.default.Error}):this.z({validationMessage:void 0,severity:I.default.Ignore})}}return new i($,p)}}),define(Re[315],Ce([1,0,2,4,60,3,7,6,18,135,11,23,41,51,15,25,14,10]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P,b,a,$,p){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$usc=e.$tsc=void 0;function i(L){return L instanceof s.URI}function o(L,N){return L.scheme===$.Schemas.file&&N.scheme===$.Schemas.file&&p.$l?L.toString()===N.toString():L.toString().toLowerCase()===N.toString().toLowerCase()}function t(L){if(L)return typeof L.iconPath=="string"?s.URI.file(L.iconPath):s.URI.isUri(L.iconPath)||P.ThemeIcon.isThemeIcon(L.iconPath)?L.iconPath:void 0}function n(L){if(L){if(s.URI.isUri(L))return L;if(P.ThemeIcon.isThemeIcon(L))return L;{const N=L;return{light:N.light,dark:N.dark}}}else return}function r(L){const N=n(L.icon),F=L.labels?.map(V=>({title:V.title,icon:n(V.icon)}));return{...L,icon:N,labels:F}}function d(L,N){if(!L.iconPath&&!N.iconPath)return 0;if(L.iconPath){if(!N.iconPath)return 1}else return-1;const F=typeof L.iconPath=="string"?L.iconPath:s.URI.isUri(L.iconPath)?L.iconPath.fsPath:L.iconPath.id,V=typeof N.iconPath=="string"?N.iconPath:s.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id;return(0,c.$Qr)(F,V)}function l(L,N){let F=0;if(L.strikeThrough!==N.strikeThrough)return L.strikeThrough?1:-1;if(L.faded!==N.faded)return L.faded?1:-1;if(L.tooltip!==N.tooltip)return(L.tooltip||"").localeCompare(N.tooltip||"");if(F=d(L,N),F!==0)return F;if(L.light&&N.light)F=d(L.light,N.light);else{if(L.light)return 1;if(N.light)return-1}if(F!==0)return F;if(L.dark&&N.dark)F=d(L.dark,N.dark);else{if(L.dark)return 1;if(N.dark)return-1}return F}function f(L,N){if(L.command!==N.command)return L.command<N.command?-1:1;if(L.title!==N.title)return L.title<N.title?-1:1;if(L.tooltip!==N.tooltip){if(L.tooltip!==void 0&&N.tooltip!==void 0)return L.tooltip<N.tooltip?-1:1;if(L.tooltip!==void 0)return 1;if(N.tooltip!==void 0)return-1}if(L.arguments===N.arguments)return 0;if(L.arguments)if(N.arguments){if(L.arguments.length!==N.arguments.length)return L.arguments.length-N.arguments.length}else return 1;else return-1;for(let F=0;F<L.arguments.length;F++){const V=L.arguments[F],j=N.arguments[F];if(V!==j&&!(i(V)&&i(j)&&o(V,j)))return V<j?-1:1}return 0}function y(L,N){let F=(0,c.$Qr)(L.resourceUri.fsPath,N.resourceUri.fsPath,!0);if(F!==0)return F;if(L.command&&N.command)F=f(L.command,N.command);else{if(L.command)return 1;if(N.command)return-1}if(F!==0)return F;if(L.decorations&&N.decorations)F=l(L.decorations,N.decorations);else{if(L.decorations)return 1;if(N.decorations)return-1}if(L.multiFileDiffEditorModifiedUri&&N.multiFileDiffEditorModifiedUri)F=(0,c.$Qr)(L.multiFileDiffEditorModifiedUri.fsPath,N.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(L.multiFileDiffEditorModifiedUri)return 1;if(N.multiFileDiffEditorModifiedUri)return-1}if(L.multiDiffEditorOriginalUri&&N.multiDiffEditorOriginalUri)F=(0,c.$Qr)(L.multiDiffEditorOriginalUri.fsPath,N.multiDiffEditorOriginalUri.fsPath,!0);else{if(L.multiDiffEditorOriginalUri)return 1;if(N.multiDiffEditorOriginalUri)return-1}return F}function k(L,N){for(let F=0;F<L.length;F++)if(L[F]!==N[F])return!1;return!0}function S(L,N){return L.command===N.command&&L.title===N.title&&L.tooltip===N.tooltip&&(L.arguments&&N.arguments?k(L.arguments,N.arguments):L.arguments===N.arguments)}function D(L,N){return(0,m.$wb)(L,N,S)}class T{#e;#t;get value(){return this.d}set value(N){N=N??"",this.#e.$setInputBoxValue(this.m,N),this.o(N)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(N){this.#e.$setInputBoxPlaceholder(this.m,N),this.f=N}get validateInput(){return(0,a.$wH)(this.k,"scmValidation"),this.g}set validateInput(N){if((0,a.$wH)(this.k,"scmValidation"),N&&typeof N!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=N,this.#e.$setValidationProviderIsEnabled(this.m,!!N)}get enabled(){return this.h}set enabled(N){N=!!N,this.h!==N&&(this.h=N,this.#e.$setInputBoxEnablement(this.m,N))}get visible(){return this.j}set visible(N){N=!!N,this.j!==N&&(this.j=N,this.#e.$setInputBoxVisibility(this.m,N))}get document(){return(0,a.$wH)(this.k,"scmTextDocument"),this.#t.getDocument(this.n)}constructor(N,F,V,j,U){this.k=N,this.m=j,this.n=U,this.d="",this.e=new h.$oe,this.f="",this.h=!0,this.j=!0,this.#t=F,this.#e=V}showValidationMessage(N,F){(0,a.$wH)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.m,N,F)}$onInputBoxValueChange(N){this.o(N)}o(N){this.d=N,this.e.fire(N)}}e.$tsc=T;class v{static{this.d=0}get disposed(){return this.m}get id(){return this.v}get label(){return this.w}set label(N){this.w=N,this.s.$updateGroupLabel(this.u,this.handle,N)}get hideWhenEmpty(){return this.q}set hideWhenEmpty(N){this.q=N,this.s.$updateGroup(this.u,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(N){this.f=[...N],this.k.fire()}constructor(N,F,V,j,U,z,_){this.s=N,this.t=F,this.u=V,this.v=j,this.w=U,this.multiDiffEditorEnableViewChanges=z,this.x=_,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new h.$oe,this.onDidUpdateResourceStates=this.k.event,this.m=!1,this.n=new h.$oe,this.onDidDispose=this.n.event,this.o=[],this.p=[],this.q=void 0,this.handle=v.d++}getResourceState(N){return this.g.get(N)}$executeResourceCommand(N,F){const V=this.h.get(N);return V?(0,O.$Ah)(()=>this.t.executeCommand(V.command,...V.arguments||[],F)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const N=[...this.f].sort(y),V=(0,m.$Fb)(this.p,N,y).map(z=>{const _=z.toInsert.map(W=>{const B=this.e++;this.g.set(B,W);const Y=W.resourceUri;let x;if(W.command)if(W.command.command==="vscode.open"||W.command.command==="vscode.diff"||W.command.command==="vscode.changes"){const Ae=new A.$Wc;x=this.t.converter.toInternal(W.command,Ae),this.j.set(B,Ae)}else this.h.set(B,W.command);const oe=(0,a.$vH)(this.x,"scmMultiDiffEditor"),ie=oe?W.multiDiffEditorOriginalUri:void 0,me=oe?W.multiFileDiffEditorModifiedUri:void 0,ue=t(W.decorations),X=W.decorations&&t(W.decorations.light)||ue,q=W.decorations&&t(W.decorations.dark)||ue,se=[X,q],be=W.decorations&&W.decorations.tooltip||"",ae=W.decorations&&!!W.decorations.strikeThrough,we=W.decorations&&!!W.decorations.faded,$e=W.contextValue||"";return{rawResource:[B,Y,se,be,ae,we,$e,x,ie,me],handle:B}});return{start:z.start,deleteCount:z.deleteCount,toInsert:_}}),j=V.map(({start:z,deleteCount:_,toInsert:W})=>[z,_,W.map(B=>B.rawResource)]),U=V.reverse();for(const{start:z,deleteCount:_,toInsert:W}of U){const B=W.map(x=>x.handle),Y=this.o.splice(z,_,...B);for(const x of Y)this.g.delete(x),this.h.delete(x),this.j.get(x)?.dispose(),this.j.delete(x)}return this.p=N,j}dispose(){this.m=!0,this.n.fire()}}class w{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(N){this.g!==N&&(this.g=N,this.#e.$updateSourceControl(this.x,{count:N}))}get quickDiffProvider(){return this.h}set quickDiffProvider(N){this.h=N;let F;(0,a.$vH)(this.y,"quickDiffProvider")&&(F=N?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!N,quickDiffLabel:F})}get historyProvider(){return(0,a.$wH)(this.y,"scmHistoryProvider"),this.j}set historyProvider(N){(0,a.$wH)(this.y,"scmHistoryProvider"),this.j=N,this.k.value=new A.$Wc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!N}),N&&this.k.value.add(N.onDidChangeCurrentHistoryItemGroup(()=>{this.m=N?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.m)}))}get commitTemplate(){return this.n}set commitTemplate(N){N!==this.n&&(this.n=N,this.#e.$updateSourceControl(this.x,{commitTemplate:N}))}get acceptInputCommand(){return this.p}set acceptInputCommand(N){this.o.value=new A.$Wc,this.p=N;const F=this.z.converter.toInternal(N,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:F})}get actionButton(){return(0,a.$wH)(this.y,"scmActionButton"),this.s}set actionButton(N){(0,a.$wH)(this.y,"scmActionButton"),this.q.value=new A.$Wc,this.s=N;const F=N!==void 0?{command:this.z.converter.toInternal(N.command,this.q.value),secondaryCommands:N.secondaryCommands?.map(V=>V.map(j=>this.z.converter.toInternal(j,this.q.value))),description:N.description,enabled:N.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:F??null})}get statusBarCommands(){return this.u}set statusBarCommands(N){if(this.u&&N&&D(this.u,N))return;this.t.value=new A.$Wc,this.u=N;const F=(N||[]).map(V=>this.z.converter.toInternal(V,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:F})}get selected(){return this.v}constructor(N,F,V,j,U,z,_){this.y=N,this.z=j,this.A=U,this.B=z,this.C=_,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new A.$Yc,this.n=void 0,this.o=new A.$Yc,this.p=void 0,this.q=new A.$Yc,this.t=new A.$Yc,this.u=void 0,this.v=!1,this.w=new h.$oe,this.onDidChangeSelection=this.w.event,this.x=w.d++,this.D=new Map,this.E=new Set,this.#e=V;const W=s.URI.from({scheme:$.Schemas.vscodeSourceControl,path:`${U}/scm${this.x}/input`,query:_?`rootUri=${encodeURIComponent(_.toString())}`:void 0});this.f=new T(N,F,this.#e,this.x,W),this.#e.$registerSourceControl(this.x,U,z,_,W)}createResourceGroup(N,F,V){const j=(0,a.$vH)(this.y,"scmMultiDiffEditor")&&V?.multiDiffEditorEnableViewChanges===!0,U=new v(this.#e,this.z,this.x,N,F,j,this.y),z=h.Event.once(U.onDidDispose)(()=>this.D.delete(U));return this.D.set(U,z),this.eventuallyAddResourceGroups(),U}eventuallyAddResourceGroups(){const N=[],F=[];for(const[V,j]of this.D){j.dispose();const U=V.onDidUpdateResourceStates(()=>{this.E.add(V),this.eventuallyUpdateResourceStates()});h.Event.once(V.onDidDispose)(()=>{this.E.delete(V),U.dispose(),this.e.delete(V.handle),this.#e.$unregisterGroup(this.x,V.handle)}),N.push([V.handle,V.id,V.label,V.features,V.multiDiffEditorEnableViewChanges]);const z=V._takeResourceStateSnapshot();z.length>0&&F.push([V.handle,z]),this.e.set(V.handle,V)}this.#e.$registerGroups(this.x,N,F),this.D.clear()}eventuallyUpdateResourceStates(){const N=[];this.E.forEach(F=>{const V=F._takeResourceStateSnapshot();V.length!==0&&N.push([F.handle,V])}),N.length>0&&this.#e.$spliceResourceStates(this.x,N),this.E.clear()}getResourceGroup(N){return this.e.get(N)}setSelectionState(N){this.v=N,this.w.fire(N)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(N=>N.dispose()),this.#e.$unregisterSourceControl(this.x)}}Ze([(0,R.$bi)(100)],w.prototype,"eventuallyAddResourceGroups",null),Ze([(0,R.$bi)(100)],w.prototype,"eventuallyUpdateResourceStates",null);let M=class{static{u=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(N,F,V,j){this.m=F,this.n=V,this.o=j,this.g=new Map,this.h=new E.$xn,this.j=new h.$oe,this.e=N.getProxy(C.$3N.MainThreadSCM),this.f=N.getProxy(C.$3N.MainThreadTelemetry),F.registerArgumentProcessor({processArgument:U=>{if(U&&U.$mid===g.MarshalledId.ScmResource){const z=this.g.get(U.sourceControlHandle);if(!z)return U;const _=z.getResourceGroup(U.groupHandle);return _?_.getResourceState(U.handle):U}else if(U&&U.$mid===g.MarshalledId.ScmResourceGroup){const z=this.g.get(U.sourceControlHandle);return z?z.getResourceGroup(U.groupHandle):U}else if(U&&U.$mid===g.MarshalledId.ScmProvider){const z=this.g.get(U.handle);return z||U}return U}})}createSourceControl(N,F,V,j){this.o.trace("ExtHostSCM#createSourceControl",N.identifier.value,F,V,j),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:N.identifier.value});const U=u.d++,z=new w(N,this.n,this.e,this.m,F,V,j);this.g.set(U,z);const _=this.h.get(N.identifier)||[];return _.push(z),this.h.set(N.identifier,_),z}getLastInputBox(N){this.o.trace("ExtHostSCM#getLastInputBox",N.identifier.value);const F=this.h.get(N.identifier),V=F&&F[F.length-1];return V&&V.inputBox}$provideOriginalResource(N,F,V){const j=s.URI.revive(F);this.o.trace("ExtHostSCM#$provideOriginalResource",N,j.toString());const U=this.g.get(N);return!U||!U.quickDiffProvider||!U.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,O.$Ah)(()=>U.quickDiffProvider.provideOriginalResource(j,V)).then(z=>z||null)}$onInputBoxValueChange(N,F){this.o.trace("ExtHostSCM#$onInputBoxValueChange",N);const V=this.g.get(N);return V&&V.inputBox.$onInputBoxValueChange(F),Promise.resolve(void 0)}$executeResourceCommand(N,F,V,j){this.o.trace("ExtHostSCM#$executeResourceCommand",N,F,V);const U=this.g.get(N);if(!U)return Promise.resolve(void 0);const z=U.getResourceGroup(F);return z?z.$executeResourceCommand(V,j):Promise.resolve(void 0)}$validateInput(N,F,V){this.o.trace("ExtHostSCM#$validateInput",N);const j=this.g.get(N);return!j||!j.inputBox.validateInput?Promise.resolve(void 0):(0,O.$Ah)(()=>j.inputBox.validateInput(F,V)).then(U=>{if(!U)return Promise.resolve(void 0);const z=b.MarkdownString.fromStrict(U.message);return z?Promise.resolve([z,U.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(N){return this.o.trace("ExtHostSCM#$setSelectedSourceControl",N),N!==void 0&&this.g.get(N)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=N,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(N,F,V,j){return await this.g.get(N)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(F,V,j)??void 0}async $resolveHistoryItemGroupCommonAncestor2(N,F,V){return await this.g.get(N)?.historyProvider?.resolveHistoryItemGroupCommonAncestor2(F,V)??void 0}async $provideHistoryItems(N,F,V,j){return(await this.g.get(N)?.historyProvider?.provideHistoryItems(F,V,j))?.map(_=>r(_))??void 0}async $provideHistoryItems2(N,F,V){return(await this.g.get(N)?.historyProvider?.provideHistoryItems2(F,V))?.map(z=>r(z))??void 0}async $provideHistoryItemSummary(N,F,V,j){const U=this.g.get(N)?.historyProvider;if(typeof U?.provideHistoryItemSummary!="function")return;const z=await U.provideHistoryItemSummary(F,V,j);return z?r(z):void 0}async $provideHistoryItemChanges(N,F,V,j){return await this.g.get(N)?.historyProvider?.provideHistoryItemChanges(F,V,j)??void 0}};e.$usc=M,e.$usc=M=u=Ze([qe(3,I.$dk)],M)}),define(Re[316],Ce([1,0,6,15,2]),function(ge,e,s,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vsc=void 0;class A{static{this.a=0}constructor(C,m){this.d=m,this.c=new Map,this.b=C.getProxy(s.$3N.MainThreadShare)}async $provideShare(C,m,c){return await this.c.get(C)?.provideShare({selection:h.Range.to(m.selection),resourceUri:R.URI.revive(m.resourceUri)},c)??void 0}registerShareProvider(C,m){const c=A.a++;return this.c.set(c,m),this.b.$registerShareProvider(c,h.DocumentSelector.from(C,this.d),m.id,m.label,m.priority),{dispose:()=>{this.b.$unregisterShareProvider(c),this.c.delete(c)}}}}e.$vsc=A}),define(Re[317],Ce([1,0,9,6,8,3,15,17]),function(ge,e,s,h,R,A,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ysc=e.$xsc=void 0;class m{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new s.$5O("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new s.$5O("statusBarItem.warningForeground")]])}#e;#t;constructor(g,P,b,a,$,p=s.StatusBarAlignment.Left,u){if(this.i=!1,this.k="",this.q=new A.$Wc,this.#e=g,this.#t=P,$&&a){this.c=(0,s.$GO)(a.identifier,$);const i=b.get(this.c);i&&(p=i.alignLeft?s.StatusBarAlignment.Left:s.StatusBarAlignment.Right,u=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(m.a++);this.e=a,this.f=$,this.g=p,this.h=this.u(u)}u(g){if((0,C.$lg)(g))return g===Number.POSITIVE_INFINITY?Number.MAX_VALUE:g===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:g}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(g){this.k=g,this.v()}set name(g){this.m=g,this.v()}set tooltip(g){this.l=g,this.v()}set color(g){this.n=g,this.v()}set backgroundColor(g){g&&!m.b.has(g.id)&&(g=void 0),this.o=g,this.v()}set command(g){this.r?.fromApi!==g&&(this.p&&this.q.add(this.p),this.p=new A.$Wc,typeof g=="string"?this.r={fromApi:g,internal:this.#t.toInternal({title:"",command:g},this.p)}:g?this.r={fromApi:g,internal:this.#t.toInternal(g,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(g){this.t=g,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let g;this.e?this.f?g=`${this.e.identifier.value}.${this.f}`:g=this.e.identifier.value:g=this.f;let P;this.m?P=this.m:P=(0,R.localize)(2711,null,this.e.displayName||this.e.name);let b=this.n;this.o&&(b=m.b.get(this.o.id));const a=O.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,g,this.e?.identifier.value,P,this.k,a,this.r?.internal,b,this.o,this.g===s.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$xsc=m;class c{constructor(g){this.b=[],this.a=g.createStatusBarEntry(void 0,"status.extensionMessage",s.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,R.localize)(2712,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(g){const P={message:g};return this.b.unshift(P),this.c(),new s.$5N(()=>{const b=this.b.indexOf(P);b>=0&&(this.b.splice(b,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class I{constructor(g,P){this.e=new Map,this.a=g.getProxy(h.$3N.MainThreadStatusBar),this.b=P,this.c=new c(this)}$acceptStaticEntries(g){for(const P of g)this.e.set(P.entryId,P)}createStatusBarEntry(g,P,b,a){return new m(this.a,this.b,this.e,g,P,b,a)}setStatusBarMessage(g,P){const b=this.c.setMessage(g);let a;return typeof P=="number"?a=setTimeout(()=>b.dispose(),P):typeof P<"u"&&P.then(()=>b.dispose(),()=>b.dispose()),new s.$5N(()=>{b.dispose(),clearTimeout(a)})}}e.$ysc=I}),define(Re[169],Ce([1,0,30,158,75,120,76,15,2]),function(ge,e,s,h,R,A,O,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SQ=e.$RQ=e.$QQ=e.$PQ=void 0,s=Ue(s),C=Ue(C);const c=(i,o,t,n)=>{let r=o;return{enumerable:!0,configurable:!1,get(){return r},set(d){if(!t(r,d)){const l=r;r=d,i.listener?.(n(d,l))}}}},I=(i,o)=>i===o,E={range:(i,o)=>i===o?!0:!i||!o?!1:i.isEqual(o),label:I,description:I,sortText:I,busy:I,error:I,canResolveChildren:I,tags:(i,o)=>!(i.length!==o.length||i.some(t=>!o.find(n=>t.id===n.id)))},g=i=>o=>({op:A.TestItemEventOp.SetProp,update:i(o)}),P=(i,o)=>({range:(()=>{let t;const n=g(r=>({range:s.$Ut.lift(C.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return t},set(r){i.listener?.({op:A.TestItemEventOp.DocumentSynced}),E.range(t,r)||(t=r,i.listener?.(n(r)))}}})(),label:c(i,o,E.label,g(t=>({label:t}))),description:c(i,void 0,E.description,g(t=>({description:t}))),sortText:c(i,void 0,E.sortText,g(t=>({sortText:t}))),canResolveChildren:c(i,!1,E.canResolveChildren,t=>({op:A.TestItemEventOp.UpdateCanResolveChildren,state:t})),busy:c(i,!1,E.busy,g(t=>({busy:t}))),error:c(i,void 0,E.error,g(t=>({error:C.MarkdownString.fromStrict(t)||null}))),tags:c(i,[],E.tags,(t,n)=>({op:A.TestItemEventOp.SetTags,new:t.map(C.TestTag.from),old:n.map(C.TestTag.from)}))}),b=i=>{const o=R.$mJ.fromString(i.extId),t=new $(o.controllerId,o.localId,i.label,m.URI.revive(i.uri)||void 0);return t.range=C.Range.to(i.range||void 0),t.description=i.description||void 0,t.sortText=i.sortText||void 0,t.tags=i.tags.map(n=>C.TestTag.to({id:(0,O.$sJ)(n).tagId})),t},a=i=>{let o;for(const t of i.tests){const n=b(t.item);(0,h.$zQ)(n).parent=o,o=n}return o};e.$PQ=a;class ${constructor(o,t,n,r){if(t.includes(R.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(t)} symbol`);const d=(0,h.$yQ)(this,o);Object.defineProperties(this,{id:{value:t,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return d.parent instanceof p?void 0:d.parent}},children:{value:(0,A.$xQ)(d,h.$zQ,$),enumerable:!0,writable:!1},...P(d,n)})}}e.$QQ=$;class p extends ${constructor(o,t){super(o,o,t,void 0),this._isRoot=!0}}e.$RQ=p;class u extends A.$tQ{constructor(o,t,n){super({controllerId:o,getDocumentVersion:r=>r&&n.getDocument(r)?.version,getApiFor:h.$zQ,getChildren:r=>r.children,root:new p(o,t),toITestItem:C.TestItem.from})}}e.$SQ=u}),define(Re[34],Ce([1,0,17,9,15,24,6,18,11,38,30,57,2,3,5,19,169,21,53,52,43,92,95,32]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P,b,a,$,p,u,i,o,t,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4Q=e.$3Q=e.$2Q=e.$1Q=e.$ZQ=e.$YQ=void 0,h=Ue(h),R=Ue(R);let d=class{#e;#t;#i;constructor(D,T,v){this.b=new Map,this.c=new Map,this.#e=D.getProxy(O.$3N.MainThreadCommands),this.d=T,this.#i=v,this.#t=D.getProxy(O.$3N.MainThreadTelemetry),this.converter=new l(this,w=>{const M=this.c.get(w);return M?.result===y.Void?M:void 0},T),this.f=[{processArgument(w){return(0,c.$fi)(w)}},{processArgument(w){return(0,A.$ko)(w,function(M){if(I.$Ut.isIRange(M))return R.Range.to(M);if(E.$Tt.isIPosition(M))return R.Position.to(M);if(I.$Ut.isIRange(M.range)&&g.URI.isUri(M.uri))return R.location.to(M);if(M instanceof p.$Qe)return M.buffer.buffer;if(!Array.isArray(M))return M})}}]}registerArgumentProcessor(D){this.f.push(D)}registerApiCommand(D){const T=this.registerCommand(!1,D.id,async(...v)=>{const w=D.args.map((L,N)=>{if(!L.validate(v[N]))throw new Error(`Invalid argument '${L.name}' when running '${D.id}', received: ${typeof v[N]=="object"?JSON.stringify(v[N],null,"	"):v[N]} `);return L.convert(v[N])}),M=await this.executeCommand(D.internalId,...w);return D.result.convert(M,v,this.converter)},void 0,{description:D.description,args:D.args,returns:D.result.description});return this.c.set(D.id,D),new h.$5N(()=>{T.dispose(),this.c.delete(D.id)})}registerCommand(D,T,v,w,M,L){if(this.d.trace("ExtHostCommands#registerCommand",T),!T.trim().length)throw new Error("invalid id");if(this.b.has(T))throw new Error(`command '${T}' already exists`);return this.b.set(T,{callback:v,thisArg:w,metadata:M,extension:L}),D&&this.#e.$registerCommand(T),new h.$5N(()=>{this.b.delete(T)&&D&&this.#e.$unregisterCommand(T)})}executeCommand(D,...T){return this.d.trace("ExtHostCommands#executeCommand",D),this.g(D,T,!0)}async g(D,T,v){if(this.b.has(D))return this.#e.$fireCommandActivationEvent(D),this.h(D,T,!1);{let w=!1;const M=(0,A.$ko)(T,function(L){if(L instanceof h.$6N)return R.Position.from(L);if(L instanceof h.$7N)return R.Range.from(L);if(L instanceof h.$gO)return R.location.from(L);if(h.$wP.isNotebookRange(L))return R.NotebookRange.from(L);if(L instanceof ArrayBuffer)return w=!0,p.$Qe.wrap(new Uint8Array(L));if(L instanceof Uint8Array)return w=!0,p.$Qe.wrap(L);if(L instanceof p.$Qe)return w=!0,L;if(!Array.isArray(L))return L});try{const L=await this.#e.$executeCommand(D,w?new u.$5w(M):M,v);return(0,c.$fi)(L)}catch(L){if(L instanceof Error&&L.message==="$executeCommand:retry")return this.g(D,T,!1);throw L}}}async h(D,T,v){const w=this.b.get(D);if(!w)throw new Error("Unknown command");const{callback:M,thisArg:L,metadata:N}=w;if(N?.args)for(let V=0;V<N.args.length;V++)try{(0,s.$yg)(T[V],N.args[V].constraint)}catch{throw new Error(`Running the contributed command: '${D}' failed. Illegal argument '${N.args[V].name}' - ${N.args[V].description}`)}const F=o.$ie.create();try{return await M.apply(L,T)}catch(V){if(D===this.converter.delegatingCommandId){const j=this.converter.getActualCommand(...T);j&&(D=j.command)}if(this.d.error(V,D,w.extension?.identifier),!v)throw V;if(w.extension?.identifier){const j=this.#i.onExtensionError(w.extension.identifier,V);this.d.trace("forwarded error to extension?",j,w.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$tj)(V)),this.id=D,this.source=w.extension?.displayName??w.extension?.name}}}finally{this.j(w,D,F.elapsed())}}j(D,T,v){D.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:D.extension.identifier.value,id:new t.$Bp(T),duration:v})}$executeContributedCommand(D,...T){this.d.trace("ExtHostCommands#$executeContributedCommand",D);const v=this.b.get(D);return v?(T=T.map(w=>this.f.reduce((M,L)=>L.processArgument(M,v.extension?.identifier),w)),this.h(D,T,!0)):Promise.reject(new Error(`Contributed command '${D}' does not exist.`))}getCommands(D=!1){return this.d.trace("ExtHostCommands#getCommands",D),this.#e.$getCommands().then(T=>(D&&(T=T.filter(v=>v[0]!=="_")),T))}$getContributedCommandMetadata(){const D=Object.create(null);for(const[T,v]of this.b){const{metadata:w}=v;w&&(D[T]=w)}return Promise.resolve(D)}};e.$YQ=d,e.$YQ=d=Ze([qe(0,a.$DQ),qe(1,m.$dk),qe(2,n.$XQ)],d),e.$ZQ=(0,b.$Ii)("IExtHostCommands");class l{constructor(D,T,v){this.d=D,this.f=T,this.g=v,this.delegatingCommandId=`__vsc${(0,r.$5g)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(D,T){if(!D)return;const v={$ident:void 0,id:D.command,title:D.title,tooltip:D.tooltip};if(!D.command)return v;const w=this.f(D.command);if(w)v.id=w.internalId,v.arguments=w.args.map((M,L)=>M.convert(D.arguments&&D.arguments[L]));else if((0,C.$Nb)(D.arguments)){const M=`${D.command} /${++this.c}`;this.b.set(M,D),T.add((0,P.$Vc)(()=>{this.b.delete(M),this.g.trace("CommandsConverter#DISPOSE",M)})),v.$ident=M,v.id=this.delegatingCommandId,v.arguments=[M],this.g.trace("CommandsConverter#CREATE",D.command,M)}return v}fromInternal(D){return typeof D.$ident=="string"?this.b.get(D.$ident):{command:D.id,title:D.title,arguments:D.arguments}}getActualCommand(...D){return this.b.get(D[0])}h(...D){const T=this.getActualCommand(...D);return this.g.trace("CommandsConverter#EXECUTE",D[0],T?T.command:"MISSING"),T?this.d.executeCommand(T.command,...T.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${D[0]}`)}}e.$1Q=l;class f{static{this.Uri=new f("uri","Uri of a text document",D=>g.URI.isUri(D),D=>D)}static{this.Position=new f("position","A position in a text document",D=>h.$6N.isPosition(D),R.Position.from)}static{this.Range=new f("range","A range in a text document",D=>h.$7N.isRange(D),R.Range.from)}static{this.Selection=new f("selection","A selection in a text document",D=>h.$8N.isSelection(D),R.Selection.from)}static{this.Number=new f("number","",D=>typeof D=="number",D=>D)}static{this.String=new f("string","",D=>typeof D=="string",D=>D)}static{this.StringArray=f.Arr(f.String)}static Arr(D){return new f(`${D.name}_array`,`Array of ${D.name}, ${D.description}`,T=>Array.isArray(T)&&T.every(v=>D.validate(v)),T=>T.map(v=>D.convert(v)))}static{this.CallHierarchyItem=new f("item","A call hierarchy item",D=>D instanceof h.$sO,R.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new f("item","A type hierarchy item",D=>D instanceof h.$RP,R.TypeHierarchyItem.from)}static{this.TestItem=new f("testItem","A VS Code TestItem",D=>D instanceof $.$QQ,R.TestItem.from)}constructor(D,T,v,w){this.name=D,this.description=T,this.validate=v,this.convert=w}optional(){return new f(this.name,`(optional) ${this.description}`,D=>D==null||this.validate(D),D=>D===void 0?void 0:D===null?null:this.convert(D))}with(D,T){return new f(D??this.name,T??this.description,this.validate,this.convert)}}e.$2Q=f;class y{static{this.Void=new y("no result",D=>D)}constructor(D,T){this.description=D,this.convert=T}}e.$3Q=y;class k{constructor(D,T,v,w,M){this.id=D,this.internalId=T,this.description=v,this.args=w,this.result=M}}e.$4Q=k}),define(Re[318],Ce([1,0,18,14,2,88,144,36,34,15,9]),function(ge,e,s,h,R,A,O,C,m,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iqc=void 0,A=Ue(A),c=Ue(c),I=Ue(I);const E=[new m.$4Q("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[m.$2Q.Uri,m.$2Q.Position],new m.$3Q("A promise that resolves to an array of DocumentHighlight-instances.",P(c.DocumentHighlight.to))),new m.$4Q("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[m.$2Q.Uri],new m.$3Q("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,$)=>{if((0,s.$Mb)(a))return;class p extends I.$nO{static to(i){const o=new p(i.name,c.SymbolKind.to(i.kind),i.containerName||"",new I.$gO($[0],c.Range.to(i.range)));return o.detail=i.detail,o.range=o.location.range,o.selectionRange=c.Range.to(i.selectionRange),o.children=i.children?i.children.map(p.to):[],o}}return a.map(p.to)})),new m.$4Q("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[m.$2Q.Uri,new m.$2Q("options","Formatting options",a=>!0,a=>a)],new m.$3Q("A promise that resolves to an array of TextEdits.",P(c.TextEdit.to))),new m.$4Q("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[m.$2Q.Uri,m.$2Q.Range,new m.$2Q("options","Formatting options",a=>!0,a=>a)],new m.$3Q("A promise that resolves to an array of TextEdits.",P(c.TextEdit.to))),new m.$4Q("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[m.$2Q.Uri,m.$2Q.Position,new m.$2Q("ch","Trigger character",a=>typeof a=="string",a=>a),new m.$2Q("options","Formatting options",a=>!0,a=>a)],new m.$3Q("A promise that resolves to an array of TextEdits.",P(c.TextEdit.to))),new m.$4Q("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[m.$2Q.Uri,m.$2Q.Position],new m.$3Q("A promise that resolves to an array of Location or LocationLink instances.",b)),new m.$4Q("vscode.experimental.executeDefinitionProvider_recursive","_executeDefinitionProvider_recursive","Execute all definition providers.",[m.$2Q.Uri,m.$2Q.Position],new m.$3Q("A promise that resolves to an array of Location or LocationLink instances.",b)),new m.$4Q("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[m.$2Q.Uri,m.$2Q.Position],new m.$3Q("A promise that resolves to an array of Location or LocationLink instances.",b)),new m.$4Q("vscode.experimental.executeTypeDefinitionProvider_recursive","_executeTypeDefinitionProvider_recursive","Execute all type definition providers.",[m.$2Q.Uri,m.$2Q.Position],new m.$3Q("A promise that resolves to an array of Location or LocationLink instances.",b)),new m.$4Q("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[m.$2Q.Uri,m.$2Q.Position],new m.$3Q("A promise that resolves to an array of Location or LocationLink instances.",b)),new m.$4Q("vscode.experimental.executeDeclarationProvider_recursive","_executeDeclarationProvider_recursive","Execute all declaration providers.",[m.$2Q.Uri,m.$2Q.Position],new m.$3Q("A promise that resolves to an array of Location or LocationLink instances.",b)),new m.$4Q("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[m.$2Q.Uri,m.$2Q.Position],new m.$3Q("A promise that resolves to an array of Location or LocationLink instances.",b)),new m.$4Q("vscode.experimental.executeImplementationProvider_recursive","_executeImplementationProvider_recursive","Execute all implementation providers.",[m.$2Q.Uri,m.$2Q.Position],new m.$3Q("A promise that resolves to an array of Location or LocationLink instances.",b)),new m.$4Q("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[m.$2Q.Uri,m.$2Q.Position],new m.$3Q("A promise that resolves to an array of Location-instances.",P(c.location.to))),new m.$4Q("vscode.experimental.executeReferenceProvider","_executeReferenceProvider_recursive","Execute all reference providers.",[m.$2Q.Uri,m.$2Q.Position],new m.$3Q("A promise that resolves to an array of Location-instances.",P(c.location.to))),new m.$4Q("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[m.$2Q.Uri,m.$2Q.Position],new m.$3Q("A promise that resolves to an array of Hover-instances.",P(c.Hover.to))),new m.$4Q("vscode.experimental.executeHoverProvider_recursive","_executeHoverProvider_recursive","Execute all hover providers.",[m.$2Q.Uri,m.$2Q.Position],new m.$3Q("A promise that resolves to an array of Hover-instances.",P(c.Hover.to))),new m.$4Q("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[m.$2Q.Uri,new m.$2Q("position","A position in a text document",a=>Array.isArray(a)&&a.every($=>I.$6N.isPosition($)),a=>a.map(c.Position.from))],new m.$3Q("A promise that resolves to an array of ranges.",a=>a.map($=>{let p;for(const u of $.reverse())p=new I.$rO(c.Range.to(u),p);return p}))),new m.$4Q("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[m.$2Q.String.with("query","Search string")],new m.$3Q("A promise that resolves to an array of SymbolInformation-instances.",a=>a.map(c.WorkspaceSymbol.to))),new m.$4Q("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[m.$2Q.Uri,m.$2Q.Position],new m.$3Q("A promise that resolves to an array of CallHierarchyItem-instances",a=>a.map(c.CallHierarchyItem.to))),new m.$4Q("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[m.$2Q.CallHierarchyItem],new m.$3Q("A promise that resolves to an array of CallHierarchyIncomingCall-instances",a=>a.map(c.CallHierarchyIncomingCall.to))),new m.$4Q("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[m.$2Q.CallHierarchyItem],new m.$3Q("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",a=>a.map(c.CallHierarchyOutgoingCall.to))),new m.$4Q("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[m.$2Q.Uri,m.$2Q.Position],new m.$3Q("A promise that resolves to a range and placeholder text.",a=>{if(a)return{range:c.Range.to(a.range),placeholder:a.text}})),new m.$4Q("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[m.$2Q.Uri,m.$2Q.Position,m.$2Q.String.with("newName","The new symbol name")],new m.$3Q("A promise that resolves to a WorkspaceEdit.",a=>{if(a){if(a.rejectReason)throw new Error(a.rejectReason);return c.WorkspaceEdit.to(a)}})),new m.$4Q("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[m.$2Q.Uri,m.$2Q.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new m.$3Q("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(c.DocumentLink.to))),new m.$4Q("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[m.$2Q.Uri],new m.$3Q("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new I.$nP(a.tokenTypes,a.tokenModifiers)})),new m.$4Q("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[m.$2Q.Uri],new m.$3Q("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const $=(0,O.$peb)(a);if($.type==="full")return new I.$pP($.data,void 0)})),new m.$4Q("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[m.$2Q.Uri,m.$2Q.Range.optional()],new m.$3Q("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new I.$nP(a.tokenTypes,a.tokenModifiers)})),new m.$4Q("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[m.$2Q.Uri,m.$2Q.Range],new m.$3Q("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const $=(0,O.$peb)(a);if($.type==="full")return new I.$pP($.data,void 0)})),new m.$4Q("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[m.$2Q.Uri,m.$2Q.Position,m.$2Q.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),m.$2Q.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new m.$3Q("A promise that resolves to a CompletionList-instance.",(a,$,p)=>{if(!a)return new I.$DO([]);const u=a.suggestions.map(i=>c.CompletionItem.to(i,p));return new I.$DO(u,a.incomplete)})),new m.$4Q("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[m.$2Q.Uri,m.$2Q.Position,m.$2Q.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new m.$3Q("A promise that resolves to SignatureHelp.",a=>{if(a)return c.SignatureHelp.to(a)})),new m.$4Q("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[m.$2Q.Uri,m.$2Q.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new m.$3Q("A promise that resolves to an array of CodeLens-instances.",(a,$,p)=>P(u=>new I.$vO(c.Range.to(u.range),u.command&&p.fromInternal(u.command)))(a))),new m.$4Q("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[m.$2Q.Uri,new m.$2Q("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>I.$7N.isRange(a),a=>I.$8N.isSelection(a)?c.Selection.from(a):c.Range.from(a)),m.$2Q.String.with("kind","Code action kind to return code actions for").optional(),m.$2Q.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new m.$3Q("A promise that resolves to an array of Command-instances.",(a,$,p)=>P(u=>{if(u._isSynthetic){if(!u.command)throw new Error("Synthetic code actions must have a command");return p.fromInternal(u.command)}else{const i=new I.$pO(u.title,u.kind?new I.$qO(u.kind):void 0);return u.edit&&(i.edit=c.WorkspaceEdit.to(u.edit)),u.command&&(i.command=p.fromInternal(u.command)),i.isPreferred=u.isPreferred,i}})(a))),new m.$4Q("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[m.$2Q.Uri],new m.$3Q("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map($=>new I.$JO(c.Range.to($.range),c.Color.to($.color))):[])),new m.$4Q("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new m.$2Q("color","The color to show and insert",a=>a instanceof I.$IO,c.Color.from),new m.$2Q("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:c.Range.from(a.range)}))],new m.$3Q("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(c.ColorPresentation.to):[])),new m.$4Q("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[m.$2Q.Uri,m.$2Q.Range],new m.$3Q("A promise that resolves to an array of Inlay objects",(a,$,p)=>a.map(c.InlayHint.to.bind(void 0,p)))),new m.$4Q("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[m.$2Q.Uri],new m.$3Q("A promise that resolves to an array of FoldingRange objects",(a,$)=>{if(a)return a.map(c.FoldingRange.to)})),new m.$4Q("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new m.$3Q("A promise that resolves to an array of NotebookContentProvider static info objects.",P(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map($=>c.NotebookExclusiveDocumentPattern.to($))})))),new m.$4Q("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[m.$2Q.Uri,m.$2Q.Range,new m.$2Q("context","An InlineValueContext",a=>a&&typeof a.frameId=="number"&&a.stoppedLocation instanceof I.$7N,a=>c.InlineValueContext.from(a))],new m.$3Q("A promise that resolves to an array of InlineValue objects",a=>a.map(c.InlineValue.to))),new m.$4Q("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new m.$2Q("uriOrString","Uri-instance or string (only http/https)",a=>R.URI.isUri(a)||typeof a=="string"&&(0,h.$Sg)(a,h.Schemas.http,h.Schemas.https),a=>a),new m.$2Q("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[c.ViewColumn.from(a),void 0]:[c.ViewColumn.from(a.viewColumn),c.TextEditorOpenOptions.from(a)])).optional(),m.$2Q.String.with("label","").optional()],m.$3Q.Void),new m.$4Q("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[m.$2Q.Uri.with("resource","Resource to open"),m.$2Q.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new m.$2Q("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[c.ViewColumn.from(a),void 0]:[c.ViewColumn.from(a.viewColumn),c.TextEditorOpenOptions.from(a)])).optional()],m.$3Q.Void),new m.$4Q("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[m.$2Q.Uri.with("left","Left-hand side resource of the diff editor"),m.$2Q.Uri.with("right","Right-hand side resource of the diff editor"),m.$2Q.String.with("title","Human readable title for the diff editor").optional(),new m.$2Q("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[c.ViewColumn.from(a.viewColumn),c.TextEditorOpenOptions.from(a)]).optional()],m.$3Q.Void),new m.$4Q("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[m.$2Q.String.with("title","Human readable title for the changes editor"),new m.$2Q("resourceList","List of resources to compare",a=>{for(const $ of a){if($.length!==3)return!1;const[p,u,i]=$;if(!R.URI.isUri(p)||!R.URI.isUri(u)&&u!==void 0&&u!==null||!R.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},a=>a)],m.$3Q.Void),new m.$4Q("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[m.$2Q.Uri,m.$2Q.Position],new m.$3Q("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(c.TypeHierarchyItem.to))),new m.$4Q("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[m.$2Q.TypeHierarchyItem],new m.$3Q("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(c.TypeHierarchyItem.to))),new m.$4Q("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[m.$2Q.TypeHierarchyItem],new m.$3Q("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(c.TypeHierarchyItem.to))),new m.$4Q("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[m.$2Q.TestItem],m.$3Q.Void),new m.$4Q("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[m.$2Q.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],m.$3Q.Void),new m.$4Q("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[m.$2Q.String.with("name","The context key name"),new m.$2Q("value","The context key value",()=>!0,a=>a)],m.$3Q.Void),new m.$4Q("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[m.$2Q.Uri,m.$2Q.StringArray,new m.$2Q("MappedEditsContext","Mapped Edits Context",a=>c.MappedEditsContext.is(a),a=>c.MappedEditsContext.from(a))],new m.$3Q("A promise that resolves to a workspace edit or null",a=>a?c.WorkspaceEdit.to(a):null)),new m.$4Q("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new m.$2Q("Run arguments","",a=>!0,a=>{if(a)return{initialRange:a.initialRange?c.Range.from(a.initialRange):void 0,initialSelection:I.$8N.isSelection(a.initialSelection)?c.Selection.from(a.initialSelection):void 0,message:a.message,autoSend:a.autoSend,position:a.position?c.Position.from(a.position):void 0}})],m.$3Q.Void)];class g{static register($){E.forEach($.registerApiCommand,$),this.a($)}static a($){$.registerCommand(!1,"_validateWhenClauses",C.$Hj)}}e.$Iqc=g;function P(a){return $=>{if(Array.isArray($))return $.map(a)}}function b(a){if(!Array.isArray(a))return;const $=[];for(const p of a)A.$Ru(p)?$.push(c.DefinitionLink.to(p)):$.push(c.location.to(p));return $}}),define(Re[319],Ce([1,0,2,34]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$csc=void 0;class R{constructor(O,C,m,c,I){this.a=C,this.b=m,this.c=c;const E=new h.$4Q("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new h.$2Q("showOptions","Show Options",g=>!0,g=>g),new h.$2Q("resource","Interactive resource Uri",g=>!0,g=>g),new h.$2Q("controllerId","Notebook controller Id",g=>!0,g=>g),new h.$2Q("title","Interactive editor title",g=>!0,g=>g)],new h.$3Q("Notebook and input URI",g=>{if(I.debug("[ExtHostInteractive] open iw with notebook editor id",g.notebookEditorId),g.notebookEditorId!==void 0){const P=this.a.getEditorById(g.notebookEditorId);return I.debug("[ExtHostInteractive] notebook editor found",P.id),{notebookUri:s.URI.revive(g.notebookUri),inputUri:s.URI.revive(g.inputUri),notebookEditor:P.apiEditor}}return I.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",g.notebookUri,g.inputUri),{notebookUri:s.URI.revive(g.notebookUri),inputUri:s.URI.revive(g.inputUri)}}));this.c.registerApiCommand(E)}$willAddInteractiveDocument(O,C,m,c){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:C,lines:[""],languageId:m,uri:O,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(O,C){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[O]})}}e.$csc=R}),define(Re[320],Ce([1,0,18,7,20,4,3,28,2,23,11,6,34,15,9,121,262,25,53,263]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P,b,a,$,p,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ksc=void 0,e.$lsc=f,P=Ue(P);let o=class{constructor(k,S,D,T,v){this.m=S,this.n=D,this.o=T,this.q=v,this.b=new C.$Dc,this.c=new C.$Dc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new A.$oe,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=k.getProxy(E.$3N.MainThreadNotebookKernels);const w=new g.$4Q("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new g.$2Q("options","Select kernel options",L=>!0,L=>{if(L&&"notebookEditor"in L&&"id"in L){const N=this.n.getIdByEditor(L.notebookEditor);return{id:L.id,extension:L.extension,notebookEditorId:N}}else if(L&&"notebookEditor"in L){const N=this.n.getIdByEditor(L.notebookEditor);if(N===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${L.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:N}}return L})],g.$3Q.Void),M=new g.$4Q("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[g.$2Q.Uri],new g.$3Q("A promise that resolves to an array of variables",(L,N)=>L.map(F=>({variable:{name:F.name,value:F.value,expression:F.expression,type:F.type,language:F.language},hasNamedChildren:F.hasNamedChildren,indexedChildrenCount:F.indexedChildrenCount}))));this.o.registerApiCommand(w),this.o.registerApiCommand(M)}createNotebookController(k,S,D,T,v,w){for(const ie of this.j.values())if(ie.controller.id===S&&c.$vn.equals(k.identifier,ie.extensionId))throw new Error(`notebook controller with id '${S}' ALREADY exist`);const M=this.k++,L=this;this.q.trace(`NotebookController[${M}], CREATED by ${k.identifier.value}, ${S}`);const N=()=>console.warn(`NO execute handler from notebook controller '${U.id}' of extension: '${k.identifier}'`);let F=!1;const V=new A.$oe,j=new A.$oe,U={id:f(k.identifier,S),notebookType:D,extensionId:k.identifier,extensionLocation:k.extensionLocation,label:T||k.identifier.value,preloads:w?w.map(P.NotebookRendererScript.from):[]};let z=v??N,_,W;this.a.$addKernel(M,U).catch(ie=>{console.log(ie),F=!0});let B=0;const Y=()=>{if(F)return;const ie=++B;Promise.resolve().then(()=>{ie===B&&this.a.$updateKernel(M,U)})},x=new C.$Dc,oe={get id(){return S},get notebookType(){return U.notebookType},onDidChangeSelectedNotebooks:V.event,get label(){return U.label},set label(ie){U.label=ie??k.displayName??k.name,Y()},get detail(){return U.detail??""},set detail(ie){U.detail=ie,Y()},get description(){return U.description??""},set description(ie){U.description=ie,Y()},get supportedLanguages(){return U.supportedLanguages},set supportedLanguages(ie){U.supportedLanguages=ie,Y()},get supportsExecutionOrder(){return U.supportsExecutionOrder??!1},set supportsExecutionOrder(ie){U.supportsExecutionOrder=ie,Y()},get rendererScripts(){return U.preloads?U.preloads.map(P.NotebookRendererScript.to):[]},get executeHandler(){return z},set executeHandler(ie){z=ie??N},get interruptHandler(){return _},set interruptHandler(ie){_=ie,U.supportsInterrupt=!!ie,Y()},set variableProvider(ie){(0,p.$wH)(k,"notebookVariableProvider"),W=ie,U.hasVariableProvider=!!ie,ie?.onDidChangeVariables(me=>L.a.$variablesUpdated(me.uri)),Y()},get variableProvider(){return W},createNotebookCellExecution(ie){if(F)throw new Error("notebook controller is DISPOSED");if(!x.has(ie.notebook.uri))throw L.q.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(x.keys()).map(me=>me.toString())),new Error(`notebook controller is NOT associated to notebook: ${ie.notebook.uri.toString()}`);return L._createNotebookCellExecution(ie,f(k.identifier,this.id))},createNotebookExecution(ie){if((0,p.$wH)(k,"notebookExecution"),F)throw new Error("notebook controller is DISPOSED");if(!x.has(ie.uri))throw L.q.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(x.keys()).map(me=>me.toString())),new Error(`notebook controller is NOT associated to notebook: ${ie.uri.toString()}`);return L._createNotebookExecution(ie,f(k.identifier,this.id))},dispose:()=>{F||(this.q.trace(`NotebookController[${M}], DISPOSED`),F=!0,this.j.delete(M),V.dispose(),j.dispose(),this.a.$removeKernel(M))},updateNotebookAffinity(ie,me){me===b.NotebookControllerAffinity2.Hidden&&(0,p.$wH)(k,"notebookControllerAffinityHidden"),L.a.$updateNotebookPriority(M,ie.uri,me)},onDidReceiveMessage:j.event,postMessage(ie,me){return(0,p.$wH)(k,"notebookMessaging"),L.a.$postMessage(M,me&&L.n.getIdByEditor(me),ie)},asWebviewUri(ie){return(0,p.$wH)(k,"notebookMessaging"),(0,a.$_Db)(ie,L.m.remote)}};return this.j.set(M,{extensionId:k.identifier,controller:oe,onDidReceiveMessage:j,onDidChangeSelection:V,associatedNotebooks:x}),oe}getIdByController(k){for(const[S,D]of this.j)if(D.controller===k)return f(D.extensionId,k.id);return null}createNotebookControllerDetectionTask(k,S){const D=this.g++,T=this;this.q.trace(`NotebookControllerDetectionTask[${D}], CREATED by ${k.identifier.value}`),this.a.$addKernelDetectionTask(D,S);const v={dispose:()=>{this.f.delete(D),T.a.$removeKernelDetectionTask(D)}};return this.f.set(D,v),v}registerKernelSourceActionProvider(k,S,D){const T=this.i++,v=typeof D.onDidChangeNotebookKernelSourceActions=="function"?T:void 0,w=this;this.h.set(T,D),this.q.trace(`NotebookKernelSourceActionProvider[${T}], CREATED by ${k.identifier.value}`),this.a.$addKernelSourceActionProvider(T,T,S);let M;return v!==void 0&&(M=D.onDidChangeNotebookKernelSourceActions(L=>this.a.$emitNotebookKernelSourceActionsChangeEvent(v))),{dispose:()=>{this.h.delete(T),w.a.$removeKernelSourceActionProvider(T,T),M?.dispose()}}}async $provideKernelSourceActions(k,S){const D=this.h.get(k);if(D){const T=new O.$Wc;return(await D.provideNotebookKernelSourceActions(S)??[]).map(w=>P.NotebookKernelSourceAction.from(w,this.o.converter,T))}return[]}$acceptNotebookAssociation(k,S,D){const T=this.j.get(k);if(T){const v=this.n.getNotebookDocument(m.URI.revive(S));D?T.associatedNotebooks.set(v.uri,!0):T.associatedNotebooks.delete(v.uri),this.q.trace(`NotebookController[${k}] ASSOCIATE notebook`,v.uri.toString(),D),T.onDidChangeSelection.fire({selected:D,notebook:v.apiNotebook})}}async $executeCells(k,S,D){const T=this.j.get(k);if(!T)return;const v=this.n.getNotebookDocument(m.URI.revive(S)),w=[];for(const M of D){const L=v.getCell(M);L&&w.push(L.apiCell)}try{this.q.trace(`NotebookController[${k}] EXECUTE cells`,v.uri.toString(),w.length),await T.controller.executeHandler.call(T.controller,w,v.apiNotebook,T.controller)}catch(M){this.q.error(`NotebookController[${k}] execute cells FAILED`,M),console.error(M)}}async $cancelCells(k,S,D){const T=this.j.get(k);if(!T)return;const v=this.n.getNotebookDocument(m.URI.revive(S));if(T.controller.interruptHandler)await T.controller.interruptHandler.call(T.controller,v.apiNotebook);else for(const w of D){const M=v.getCell(w);M&&this.b.get(M.uri)?.cancel()}if(T.controller.interruptHandler){const w=this.c.get(v.uri);this.c.delete(v.uri),D.length&&Array.isArray(w)&&w.length&&w.forEach(M=>M.dispose())}}async $provideVariables(k,S,D,T,v,w,M){const L=this.j.get(k);if(!L)return;const N=this.n.getNotebookDocument(m.URI.revive(D)),F=L.controller.variableProvider;if(!F)return;let V;if(T!==void 0){if(V=this.s[T],!V)return}else this.s={};const j=v==="named"?b.NotebookVariablesRequestKind.Named:b.NotebookVariablesRequestKind.Indexed,U=F.provideVariables(N.apiNotebook,V,j,w,M);let z=0;for await(const _ of U){if(M.isCancellationRequested)return;const W={id:this.r++,name:_.variable.name,value:_.variable.value,type:_.variable.type,interfaces:_.variable.interfaces,language:_.variable.language,expression:_.variable.expression,hasNamedChildren:_.hasNamedChildren,indexedChildrenCount:_.indexedChildrenCount,extensionId:L.extensionId.value};if(this.s[W.id]=_.variable,this.a.$receiveVariable(S,W),z++>=i.$fL)return}}$acceptKernelMessageFromRenderer(k,S,D){const T=this.j.get(k);if(!T)return;const v=this.n.getEditorById(S);T.onDidReceiveMessage.fire(Object.freeze({editor:v.apiEditor,message:D}))}$cellExecutionChanged(k,S,D){const v=this.n.getNotebookDocument(m.URI.revive(k)).getCell(S);if(v){const w=D?P.NotebookCellExecutionState.to(D):b.NotebookCellExecutionState.Idle;w!==void 0&&this.l.fire({cell:v.apiCell,state:w})}}_createNotebookCellExecution(k,S){if(k.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const T=this.n.getNotebookDocument(k.notebook.uri).getCellFromApiCell(k);if(!T)throw new Error("invalid cell");if(this.b.has(T.uri))throw new Error(`duplicate execution for ${T.uri}`);const v=new n(S,T,this.a);this.b.set(T.uri,v);const w=v.onDidChangeState(()=>{v.state===t.Resolved&&(v.dispose(),w.dispose(),this.b.delete(T.uri))});return v.asApiObject()}_createNotebookExecution(k,S){const D=this.n.getNotebookDocument(k.uri),T=k.getCells().find(M=>{const L=D.getCellFromApiCell(M);return L&&this.b.has(L.uri)});if(T)throw new Error(`duplicate cell execution for ${T.document.uri}`);if(this.c.has(D.uri))throw new Error(`duplicate notebook execution for ${D.uri}`);const v=new d(S,D,this.a),w=v.onDidChangeState(()=>{v.state===r.Resolved&&(v.dispose(),w.dispose(),this.c.delete(D.uri))});return this.c.set(D.uri,[v,w]),v.asApiObject()}};e.$ksc=o,e.$ksc=o=Ze([qe(4,I.$dk)],o);var t;(function(y){y[y.Init=0]="Init",y[y.Started=1]="Started",y[y.Resolved=2]="Resolved"})(t||(t={}));class n extends O.$Xc{static{this.a=0}get state(){return this.f}constructor(k,S,D){super(),this.m=S,this.n=D,this.b=n.a++,this.c=new A.$oe,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new R.$ze),this.h=new l(10,T=>this.s(T)),this.j=S.internalMetadata.executionOrder,this.n.$createExecution(this.b,k,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(k){await this.h.addItem(k)}async s(k){const S=Array.isArray(k)?k:[k];return this.n.$updateExecution(this.b,new u.$5w(S))}t(){if(this.f===t.Init)throw new Error("Must call start before modifying cell output");if(this.f===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(k){let S=this.m;if(k&&(S=this.m.notebook.getCellFromApiCell(k)),!S)throw new Error("INVALID cell");return S.handle}y(k){return k.map(S=>{const D=b.$AP.ensureUniqueMimeTypes(S.items,!0);return D===S.items?P.NotebookCellOutput.from(S):P.NotebookCellOutput.from({items:D,id:S.id,metadata:S.metadata})})}async z(k,S,D){const T=this.w(S),v=this.y((0,s.$4b)(k));return this.r({editType:$.CellExecutionUpdateType.Output,cellHandle:T,append:D,outputs:v})}async C(k,S,D){return k=b.$AP.ensureUniqueMimeTypes((0,s.$4b)(k),!0),this.r({editType:$.CellExecutionUpdateType.OutputItems,items:k.map(P.NotebookCellOutputItem.from),outputId:S.id,append:D})}asApiObject(){const k=this;return Object.freeze({get token(){return k.g.token},get cell(){return k.m.apiCell},get executionOrder(){return k.j},set executionOrder(D){k.j=D,k.s([{editType:$.CellExecutionUpdateType.ExecutionState,executionOrder:k.j}])},start(D){if(k.f===t.Resolved||k.f===t.Started)throw new Error("Cannot call start again");k.f=t.Started,k.c.fire(),k.s({editType:$.CellExecutionUpdateType.ExecutionState,runStartTime:D})},end(D,T,v){if(k.f===t.Resolved)throw new Error("Cannot call resolve twice");k.f=t.Resolved,k.c.fire(),k.h.flush();const w=v?{message:v.message,stack:v.stack,location:v?.location?{startLineNumber:v.location.start.line,startColumn:v.location.start.character,endLineNumber:v.location.end.line,endColumn:v.location.end.character}:void 0,uri:v.uri}:void 0;k.n.$completeExecution(k.b,new u.$5w({runEndTime:T,lastRunSuccess:D,error:w}))},clearOutput(D){return k.t(),k.z([],D,!1)},appendOutput(D,T){return k.t(),k.z(D,T,!0)},replaceOutput(D,T){return k.t(),k.z(D,T,!1)},appendOutputItems(D,T){return k.t(),k.C(D,T,!0)},replaceOutputItems(D,T){return k.t(),k.C(D,T,!1)}})}}var r;(function(y){y[y.Init=0]="Init",y[y.Started=1]="Started",y[y.Resolved=2]="Resolved"})(r||(r={}));class d extends O.$Xc{static{this.a=0}get state(){return this.f}constructor(k,S,D){super(),this.h=S,this.j=D,this.b=d.a++,this.c=new A.$oe,this.onDidChangeState=this.c.event,this.f=r.Init,this.g=this.B(new R.$ze),this.j.$createNotebookExecution(this.b,k,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===r.Resolved||this.f===r.Started)throw new Error("Cannot call start again");this.f=r.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===r.Resolved)throw new Error("Cannot call resolve twice");this.f=r.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class l{constructor(k,S){this.f=k,this.g=S,this.a=[],this.b=Date.now()}addItem(k){return this.a.push(k),this.c||(this.c=new h.$6h,this.b=Date.now(),(0,h.$Jh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const k=this.c;this.c=void 0;const S=this.a;return this.a=[],this.g(S).finally(()=>k.complete())}}function f(y,k){return`${y.value}/${k}`}}),define(Re[48],Ce([1,0,4,6,5,2,19,3,9,8,12,243,20,32,244,245,51,7,15,34,41]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P,b,a,$,p,u,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nrc=e.$mrc=e.$lrc=e.$krc=void 0,e.$krc=(0,R.$Ii)("IExtHostTerminalService");class t extends C.$Xc{constructor(v,w,M,L){super(),this.u=v,this._id=w,this.w=M,this.y=L,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new s.$oe),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(F=>this.g=F);const N=this;this.value={get name(){return N.y||""},get processId(){return N.b},get creationOptions(){return N.w},get exitStatus(){return N.j},get state(){return N.m},get selection(){return N.n},get shellIntegration(){return N.shellIntegration},sendText(F,V=!0){N.C(),N.u.$sendText(N._id,F,V)},show(F){N.C(),N.u.$show(N._id,F)},hide(){N.C(),N.u.$hide(N._id)},dispose(){N.a||(N.a=!0,N.u.$dispose(N._id))},get dimensions(){if(!(N.f===void 0||N.h===void 0))return{columns:N.f,rows:N.h}}}}dispose(){this.s.fire(),super.dispose()}async create(v,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:v.name,shellPath:v.shellPath??void 0,shellArgs:v.shellArgs??void 0,cwd:v.cwd??w?.cwd??void 0,env:v.env??void 0,icon:k(v.iconPath)??void 0,color:$.ThemeColor.isThemeColor(v.color)?v.color.id:void 0,initialText:v.message??void 0,strictEnv:v.strictEnv??void 0,hideFromUser:v.hideFromUser??void 0,forceShellIntegration:w?.forceShellIntegration??void 0,isFeatureTerminal:w?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:w?.useShellEnvironment??void 0,location:w?.location||this.z(v.location,w?.resolvedExtHostIdentifier),isTransient:v.isTransient??void 0})}async createExtensionTerminal(v,w,M,L,N){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:L,color:$.ThemeColor.isThemeColor(N)?N.id:void 0,location:w?.location||this.z(v,M),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(v,w){return typeof v=="object"?"parentTerminal"in v&&v.parentTerminal&&w?{parentTerminal:w}:"viewColumn"in v?{viewColumn:u.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus}:void 0:v}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(v){this.y=v}setExitStatus(v,w){this.j=Object.freeze({code:v,reason:w})}setDimensions(v,w){return v===this.f&&w===this.h||v===0||w===0?!1:(this.f=v,this.h=w,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(v){this.n=v}_setProcessId(v){this.g?(this.g(v),this.g=void 0):this.b.then(w=>{w!==v&&(this.b=Promise.resolve(v))})}}e.$lrc=t;class n{get onProcessReady(){return this.b.event}constructor(v){this.g=v,this.id=0,this.shouldPersist=!1,this.a=new s.$oe,this.onProcessData=this.a.event,this.b=new s.$oe,this.d=new s.$oe,this.onDidChangeProperty=this.d.event,this.f=new s.$oe,this.onProcessExit=this.f.event}refreshProperty(v){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${v}`)}updateProperty(v,w){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${v}, value: ${w}`)}async start(){}shutdown(){this.g.close()}input(v){this.g.handleInput?.(v)}resize(v,w){this.g.setDimensions?.({columns:v,rows:w})}clearBuffer(){}async processBinary(v){}acknowledgeDataEvent(v){}async setUnicodeVersion(v){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(v){this.g.onDidWrite(w=>this.a.fire(w)),this.g.onDidClose?.((w=void 0)=>{this.f.fire(w===void 0?void 0:w)}),this.g.onDidOverrideDimensions?.(w=>{w&&this.d.fire({type:b.ProcessPropertyType.OverrideDimensions,value:{cols:w.columns,rows:w.rows}})}),this.g.onDidChangeName?.(w=>{this.d.fire({type:b.ProcessPropertyType.Title,value:w})}),this.g.open(v||void 0),v&&this.g.setDimensions?.(v),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let r=1,d=class extends C.$Xc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(v=>v.value)}constructor(v,w,M){super(),this.Q=w,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new C.$Yc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new s.$oe,this.onDidCloseTerminal=this.H.event,this.I=new s.$oe,this.onDidOpenTerminal=this.I.event,this.J=new s.$oe,this.onDidChangeActiveTerminal=this.J.event,this.L=new s.$oe,this.onDidChangeTerminalDimensions=this.L.event,this.M=new s.$oe,this.onDidChangeTerminalState=this.M.event,this.N=new s.$oe,this.onDidChangeShell=this.N.event,this.O=new s.$oe({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new s.$oe({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=M.getProxy(h.$3N.MainThreadTerminalService),this.y=new a.$ryb(this.a.$sendProcessData),this.a.$registerProcessSupport(v),this.Q.registerArgumentProcessor({processArgument:L=>{const N=F=>{const V=F;return this.getTerminalById(V.instanceId)?.value};switch(L?.$mid){case o.MarshalledId.TerminalContext:return N(L);default:{if(Array.isArray(L))for(let F=0;F<L.length&&L[F].$mid===o.MarshalledId.TerminalContext;F++)L[F]=N(L[F]);return L}}}}),this.B({dispose:()=>{for(const[L,N]of this.g)N.shutdown(!0)}})}getDefaultShell(v){return(v?this.u:this.s)?.path||""}getDefaultShellArgs(v){return(v?this.u:this.s)?.args||[]}createExtensionTerminal(v,w){const M=new t(this.a,(0,P.$5g)(),v,v.name),L=new n(v.pty);return M.createExtensionTerminal(v.location,w,this.R(v,w).resolvedExtHostIdentifier,k(v.iconPath),S(v.color)).then(N=>{const F=this.S(N,L);this.h[N]=F}),this.f.push(M),M.value}R(v,w){if(w=w||{},v.location&&typeof v.location=="object"&&"parentTerminal"in v.location){const M=v.location.parentTerminal;if(M){const L=this.f.find(N=>N.value===M);L&&(w.resolvedExtHostIdentifier=L._id)}}else v.location&&typeof v.location!="object"?w.location=v.location:w.location&&typeof w.location=="object"&&"splitActiveTerminal"in w.location&&(w.location={splitActiveTerminal:!0});return w}attachPtyToTerminal(v,w){if(!this.getTerminalById(v))throw new Error(`Cannot resolve terminal with id ${v} for virtual process`);const L=new n(w),N=this.S(v,L);this.h[v]=N}async $acceptActiveTerminalChanged(v){const w=this.b;if(v===null){this.b=void 0,w!==this.b&&this.J.fire(this.b);return}const M=this.getTerminalById(v);M&&(this.b=M,w!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(v,w){const M=this.getTerminalById(v);M&&this.O.fire({terminal:M.value,data:w})}async $acceptTerminalDimensions(v,w,M){const L=this.getTerminalById(v);L&&L.setDimensions(w,M)&&this.L.fire({terminal:L.value,dimensions:L.value.dimensions})}async $acceptDidExecuteCommand(v,w){const M=this.getTerminalById(v);M&&this.P.fire({terminal:M.value,...w})}async $acceptTerminalMaximumDimensions(v,w,M){this.g.get(v)?.resize(w,M)}async $acceptTerminalTitleChange(v,w){const M=this.getTerminalById(v);M&&(M.name=w)}async $acceptTerminalClosed(v,w,M){const L=this.X(this.f,v);if(L!==null){const N=this.f.splice(L,1)[0];N.setExitStatus(w,M),this.H.fire(N.value)}}$acceptTerminalOpened(v,w,M,L){if(w){const V=this.X(this.f,w);if(V!==null){this.f[V]._id=v,this.I.fire(this.terminals[V]),this.f[V].isOpen=!0;return}}const N={name:L.name,shellPath:L.executable,shellArgs:L.args,cwd:typeof L.cwd=="string"?L.cwd:A.URI.revive(L.cwd),env:L.env,hideFromUser:L.hideFromUser},F=new t(this.a,v,N,M);this.f.push(F),this.I.fire(F.value),F.isOpen=!0}async $acceptTerminalProcessId(v,w){this.getTerminalById(v)?._setProcessId(w)}async $startExtensionTerminal(v,w){const M=this.getTerminalById(v);if(!M)return{message:(0,c.localize)(2714,null,v)};M.isOpen||await new Promise(N=>{const F=this.onDidOpenTerminal(async V=>{V===M.value&&(F.dispose(),N())})});const L=this.g.get(v);L?L.startSendingEvents(w):this.j[v]={initialDimensions:w}}S(v,w){const M=new C.$Wc;M.add(w.onProcessReady(N=>this.a.$sendProcessReady(v,N.pid,N.cwd,N.windowsPty))),M.add(w.onDidChangeProperty(N=>this.a.$sendProcessProperty(v,N))),this.y.startBuffering(v,w.onProcessData),M.add(w.onProcessExit(N=>this.U(v,N))),this.g.set(v,w);const L=this.j[v];return L&&w instanceof n&&(w.startSendingEvents(L.initialDimensions),delete this.j[v]),M}$acceptProcessAckDataEvent(v,w){this.g.get(v)?.acknowledgeDataEvent(w)}$acceptProcessInput(v,w){this.g.get(v)?.input(w)}$acceptTerminalInteraction(v){const w=this.getTerminalById(v);w?.setInteractedWith()&&this.M.fire(w.value)}$acceptTerminalSelection(v,w){this.getTerminalById(v)?.setSelection(w)}$acceptProcessResize(v,w,M){try{this.g.get(v)?.resize(w,M)}catch(L){if(L.code!=="EPIPE"&&L.code!=="ERR_IPC_CHANNEL_CLOSED")throw L}}$acceptProcessShutdown(v,w){this.g.get(v)?.shutdown(w)}$acceptProcessRequestInitialCwd(v){this.g.get(v)?.getInitialCwd().then(w=>this.a.$sendProcessProperty(v,{type:b.ProcessPropertyType.InitialCwd,value:w}))}$acceptProcessRequestCwd(v){this.g.get(v)?.getCwd().then(w=>this.a.$sendProcessProperty(v,{type:b.ProcessPropertyType.Cwd,value:w}))}$acceptProcessRequestLatency(v){return Promise.resolve(v)}registerLinkProvider(v){return this.z.add(v),this.z.size===1&&this.a.$startLinkProvider(),new m.$5N(()=>{this.z.delete(v),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(v,w,M){if(this.C.has(w))throw new Error(`Terminal profile provider "${w}" already registered`);return this.C.set(w,M),this.a.$registerProfileProvider(w,v.identifier.value),new m.$5N(()=>{this.C.delete(w),this.a.$unregisterProfileProvider(w)})}registerTerminalQuickFixProvider(v,w,M){if(this.D.has(v))throw new Error(`Terminal quick fix provider "${v}" is already registered`);return this.D.set(v,M),this.a.$registerQuickFixProvider(v,w),new m.$5N(()=>{this.D.delete(v),this.a.$unregisterQuickFixProvider(v)})}async $provideTerminalQuickFixes(v,w){const M=new g.$ze().token;if(M.isCancellationRequested)return;const L=this.D.get(v);if(!L)return;const N=await L.provideTerminalQuickFixes(w,M);if(N===null||Array.isArray(N)&&N.length===0)return;const F=new C.$Wc;if(this.w.value=F,!Array.isArray(N))return N?u.TerminalQuickFix.from(N,this.Q.converter,F):void 0;const V=[];for(const j of N){const U=u.TerminalQuickFix.from(j,this.Q.converter,F);U&&V.push(U)}return V}async $createContributedProfileTerminal(v,w){const M=new g.$ze().token;let L=await this.C.get(v)?.provideTerminalProfile(M);if(!M.isCancellationRequested){if(L&&!("options"in L)&&(L={options:L}),!L||!("options"in L))throw new Error(`No terminal profile options provided for id "${v}"`);if("pty"in L.options){this.createExtensionTerminal(L.options,w);return}this.createTerminalFromOptions(L.options,w)}}async $provideLinks(v,w){const M=this.getTerminalById(v);if(!M)return[];this.F.delete(v),this.G.get(v)?.dispose(!0);const N=new g.$ze;this.G.set(v,N);const F=[],V={terminal:M.value,line:w},j=[];for(const _ of this.z)j.push(p.Promises.withAsyncBody(async W=>{N.token.onCancellationRequested(()=>W({provider:_,links:[]}));const B=await _.provideTerminalLinks(V,N.token)||[];N.token.isCancellationRequested||W({provider:_,links:B})}));const U=await Promise.all(j);if(N.token.isCancellationRequested)return[];const z=new Map;for(const _ of U)_&&_.links.length>0&&F.push(..._.links.map(W=>{const B={id:r++,startIndex:W.startIndex,length:W.length,label:W.tooltip};return z.set(B.id,{provider:_.provider,link:W}),B}));return this.F.set(v,z),F}$activateLink(v,w){const M=this.F.get(v)?.get(w);M&&M.provider.handleTerminalLink(M.link)}U(v,w){this.y.stopBuffering(v),this.g.delete(v),delete this.j[v];const M=this.h[v];M&&(M.dispose(),delete this.h[v]),this.a.$sendProcessExit(v,w)}getTerminalById(v){return this.W(this.f,v)}getTerminalIdByApiObject(v){const w=this.f.findIndex(M=>M.value===v);return w>=0?w:null}W(v,w){const M=this.X(v,w);return M!==null?v[M]:null}X(v,w){const M=v.findIndex(L=>L._id===w);return M>=0?M:null}getEnvironmentVariableCollection(v){let w=this.n.get(v.identifier.value);return w||(w=this.B(new l),this.Z(v.identifier.value,w)),w.getScopedEnvironmentVariableCollection(void 0)}Y(v,w){const M=(0,E.$Ls)(w.map),L=(0,E.$Ms)(w.descriptionMap);this.a.$setEnvironmentVariableCollection(v,w.persistent,M.length===0?void 0:M,L)}$initEnvironmentVariableCollections(v){v.forEach(w=>{const M=w[0],L=this.B(new l(w[1]));this.Z(M,L)})}$acceptDefaultProfile(v,w){const M=this.s;this.s=v,this.u=w,M?.path!==v.path&&this.N.fire(v.path)}Z(v,w){this.n.set(v,w),this.B(w.onDidChangeCollection(()=>{this.Y(v,w)}))}};e.$mrc=d,e.$mrc=d=Ze([qe(1,i.$ZQ),qe(2,O.$DQ)],d);class l extends C.$Xc{get persistent(){return this.b}set persistent(v){this.b=v,this.f.fire()}get onDidChangeCollection(){return this.f&&this.f.event}constructor(v){super(),this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.f=new s.$oe,this.map=new Map(v)}getScopedEnvironmentVariableCollection(v){const w=this.j(v);let M=this.a.get(w);return M||(M=new f(this,v),this.a.set(w,M),this.B(M.onDidChangeCollection(()=>this.f.fire()))),M}replace(v,w,M,L){this.g(v,{value:w,type:m.EnvironmentVariableMutatorType.Replace,options:M??{applyAtProcessCreation:!0},scope:L})}append(v,w,M,L){this.g(v,{value:w,type:m.EnvironmentVariableMutatorType.Append,options:M??{applyAtProcessCreation:!0},scope:L})}prepend(v,w,M,L){this.g(v,{value:w,type:m.EnvironmentVariableMutatorType.Prepend,options:M??{applyAtProcessCreation:!0},scope:L})}g(v,w){if(w.options&&w.options.applyAtProcessCreation===!1&&!w.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const M=this.h(v,w.scope),L=this.map.get(M),N=w.options?{applyAtProcessCreation:w.options.applyAtProcessCreation??!1,applyAtShellIntegration:w.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!L||L.value!==w.value||L.type!==w.type||L.options?.applyAtProcessCreation!==N.applyAtProcessCreation||L.options?.applyAtShellIntegration!==N.applyAtShellIntegration||L.scope?.workspaceFolder?.index!==w.scope?.workspaceFolder?.index){const F=this.h(v,w.scope),V={variable:v,...w,options:N};this.map.set(F,V),this.f.fire()}}get(v,w){const M=this.h(v,w),L=this.map.get(M);return L?D(L):void 0}h(v,w){const M=this.j(w);return M.length?`${v}:::${M}`:v}j(v){return this.m(v?.workspaceFolder)??""}m(v){return v?v.uri.toString():void 0}getVariableMap(v){const w=new Map;for(const[M,L]of this.map)this.j(L.scope)===this.j(v)&&w.set(L.variable,D(L));return w}delete(v,w){const M=this.h(v,w);this.map.delete(M),this.f.fire()}clear(v){if(v?.workspaceFolder){for(const[w,M]of this.map)M.scope?.workspaceFolder?.index===v.workspaceFolder.index&&this.map.delete(w);this.n(v)}else this.map.clear(),this.descriptionMap.clear();this.f.fire()}setDescription(v,w){const M=this.j(w),L=this.descriptionMap.get(M);if(!L||L.description!==v){let N;typeof v=="string"?N=v:N=v?.value.split(`

`)[0];const F={description:N,scope:w};this.descriptionMap.set(M,F),this.f.fire()}}getDescription(v){const w=this.j(v);return this.descriptionMap.get(w)?.description}n(v){const w=this.j(v);this.descriptionMap.delete(w)}}class f{get persistent(){return this.b.persistent}set persistent(v){this.b.persistent=v}get onDidChangeCollection(){return this.a&&this.a.event}constructor(v,w){this.b=v,this.d=w,this.a=new s.$oe}getScoped(v){return this.b.getScopedEnvironmentVariableCollection(v)}replace(v,w,M){this.b.replace(v,w,M,this.d)}append(v,w,M){this.b.append(v,w,M,this.d)}prepend(v,w,M){this.b.prepend(v,w,M,this.d)}get(v){return this.b.get(v,this.d)}forEach(v,w){this.b.getVariableMap(this.d).forEach((M,L)=>v.call(w,L,M,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(v){this.b.delete(v,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(v){this.b.setDescription(v,this.d)}get description(){return this.b.getDescription(this.d)}}let y=class extends d{constructor(v,w){super(!1,v,w)}createTerminal(v,w,M){throw new I.$bb}createTerminalFromOptions(v,w){throw new I.$bb}};e.$nrc=y,e.$nrc=y=Ze([qe(0,i.$ZQ),qe(1,O.$DQ)],y);function k(T){if(!(!T||typeof T=="string"))return"id"in T?{id:T.id,color:T.color}:T}function S(T){return $.ThemeColor.isThemeColor(T)?T:void 0}function D(T){const v={...T};return delete v.scope,v.options=v.options??void 0,delete v.variable,v}}),define(Re[170],Ce([1,0,9,3,5,6,19,48,4,2,7]),function(ge,e,s,h,R,A,O,C,m,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dsc=e.$Csc=void 0,e.$Csc=(0,R.$Ii)("IExtHostTerminalShellIntegration");let E=class extends h.$Xc{constructor($,p){super(),this.h=p,this.b=new Map,this.c=new m.$oe,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new m.$oe,this.onDidStartTerminalShellExecution=this.f.event,this.g=new m.$oe,this.onDidEndTerminalShellExecution=this.g.event,this.a=$.getProxy(A.$3N.MainThreadTerminalShellIntegration),this.B((0,h.$Vc)(()=>{for(const[u,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange($){const p=this.h.getTerminalById($);if(!p)return;const u=p.value;let i=this.b.get($);i||(i=new g(p.value,this.f),this.b.set($,i),i.store.add(p.onWillDispose(()=>this.b.get($)?.dispose())),i.store.add(i.onDidRequestShellExecution(o=>this.a.$executeCommand($,o))),i.store.add(i.onDidRequestEndExecution(o=>this.g.fire(o))),i.store.add(i.onDidRequestChangeShellIntegration(o=>this.c.fire(o))),p.shellIntegration=i.value),this.c.fire({terminal:u,shellIntegration:i.value})}$shellExecutionStart($,p,u,i,o){this.b.has($)||this.$shellIntegrationChange($);const t={value:p,confidence:u,isTrusted:i};this.b.get($)?.startShellExecution(t,c.URI.revive(o))}$shellExecutionEnd($,p,u,i,o){const t={value:p,confidence:u,isTrusted:i};this.b.get($)?.endShellExecution(t,o)}$shellExecutionData($,p){this.b.get($)?.emitData(p)}$cwdChange($,p){this.b.get($)?.setCwd(c.URI.revive(p))}$closeTerminal($){this.b.get($)?.dispose(),this.b.delete($)}};e.$Dsc=E,e.$Dsc=E=Ze([qe(0,O.$DQ),qe(1,C.$krc)],E);class g extends h.$Xc{get currentExecution(){return this.a}constructor($,p){super(),this.j=$,this.m=p,this.b=!1,this.store=this.B(new h.$Wc),this.f=this.B(new m.$oe),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new m.$oe),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new m.$oe),this.onDidRequestEndExecution=this.h.event;const u=this;this.value={get cwd(){return u.c},executeCommand(i,o){let t=i;o&&(t+=` "${o.map(d=>`${d.replaceAll('"','\\"')}`).join('" "')}"`),u.g.fire(t);const n={value:t,confidence:s.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},r=u.startShellExecution(n,u.c,!0).value;return u.b=!0,r}}}startShellExecution($,p,u){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new P($,p??this.c);u?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData($){this.currentExecution?.emitData($)}endShellExecution($,p){this.a&&(this.a.endExecution($),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:p}),this.a=void 0)}setCwd($){let p=!1;c.URI.isUri(this.c)?p=!c.URI.isUri($)||this.c.toString()!==$.toString():this.c!==$&&(p=!0),p&&(this.c=$,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class P{constructor($,p){this.c=$,this.cwd=p,this.b=!1;const u=this;this.value={get commandLine(){return u.c},get cwd(){return u.cwd},read(){return u.d()}}}d(){if(!this.a){if(this.b)return I.$9h.EMPTY;this.a=new b}return this.a.createIterable()}emitData($){this.a?.emitData($)}endExecution($){$&&(this.c=$),this.a?.endExecution(),this.a=void 0,this.b=!0}}class b extends h.$Xc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new I.$Hh);const $=this.a;return new I.$9h(async u=>{this.b.push(u),await $.wait()})}emitData($){for(const p of this.b)p.emitOne($)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Re[171],Ce([1,0,67,12,133,15,9]),function(ge,e,s,h,R,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MQ=e.$LQ=e.$KQ=void 0,A=Ue(A);class C{static{this.c=new R.$IQ("TextEditorDecorationType")}constructor(g,P,b){const a=C.c.nextId();g.$registerTextEditorDecorationType(P.identifier,a,A.DecorationRenderOptions.from(b)),this.value=Object.freeze({key:a,dispose(){g.$removeTextEditorDecorationType(a)}})}}e.$KQ=C;class m{constructor(g,P){this.g=[],this.h=void 0,this.j=!1,this.c=g,this.d=g.version,this.e=P.undoStopBefore,this.f=P.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(g,P){this.k();let b=null;if(g instanceof O.$6N)b=new O.$7N(g,g);else if(g instanceof O.$7N)b=g;else throw new Error("Unrecognized location");this.l(b,P,!1)}insert(g,P){this.k(),this.l(new O.$7N(g,g),P,!0)}delete(g){this.k();let P=null;if(g instanceof O.$7N)P=g;else throw new Error("Unrecognized location");this.l(P,null,!0)}l(g,P,b){const a=this.c.validateRange(g);this.g.push({range:a,text:P,forceMoveMarkers:b})}setEndOfLine(g){if(this.k(),g!==O.EndOfLine.LF&&g!==O.EndOfLine.CRLF)throw(0,h.$9)("endOfLine");this.h=g}}class c{constructor(g,P,b,a){this.c=g,this.d=P,this._accept(b),this.e=a;const $=this;this.value={get tabSize(){return $.f},set tabSize(p){$.n(p)},get indentSize(){return $.g},set indentSize(p){$.p(p)},get insertSpaces(){return $.j},set insertSpaces(p){$.s(p)},get cursorStyle(){return $.k},set cursorStyle(p){$.t(p)},get lineNumbers(){return $.l},set lineNumbers(p){$.u(p)}}}_accept(g){this.f=g.tabSize,this.g=g.indentSize,this.h=g.originalIndentSize,this.j=g.insertSpaces,this.k=g.cursorStyle,this.l=A.TextEditorLineNumbersStyle.to(g.lineNumbers)}m(g){if(g==="auto")return"auto";if(typeof g=="number"){const P=Math.floor(g);return P>0?P:null}if(typeof g=="string"){const P=parseInt(g,10);return isNaN(P)?null:P>0?P:null}return null}n(g){const P=this.m(g);if(P!==null){if(typeof P=="number"){if(this.f===P)return;this.f=P}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:P}))}}o(g){if(g==="tabSize")return"tabSize";if(typeof g=="number"){const P=Math.floor(g);return P>0?P:null}if(typeof g=="string"){const P=parseInt(g,10);return isNaN(P)?null:P>0?P:null}return null}p(g){const P=this.o(g);if(P!==null){if(typeof P=="number"){if(this.h===P)return;this.g=P,this.h=P}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:P}))}}q(g){return g==="auto"?"auto":g==="false"?!1:!!g}s(g){const P=this.q(g);if(typeof P=="boolean"){if(this.j===P)return;this.j=P}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:P}))}t(g){this.k!==g&&(this.k=g,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:g})))}u(g){this.l!==g&&(this.l=g,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:A.TextEditorLineNumbersStyle.from(g)})))}assign(g){const P={};let b=!1;if(typeof g.tabSize<"u"){const a=this.m(g.tabSize);a==="auto"?(b=!0,P.tabSize=a):typeof a=="number"&&this.f!==a&&(this.f=a,b=!0,P.tabSize=a)}if(typeof g.indentSize<"u"){const a=this.o(g.indentSize);a==="tabSize"?(b=!0,P.indentSize=a):typeof a=="number"&&this.h!==a&&(this.g=a,this.h=a,b=!0,P.indentSize=a)}if(typeof g.insertSpaces<"u"){const a=this.q(g.insertSpaces);a==="auto"?(b=!0,P.insertSpaces=a):this.j!==a&&(this.j=a,b=!0,P.insertSpaces=a)}typeof g.cursorStyle<"u"&&this.k!==g.cursorStyle&&(this.k=g.cursorStyle,b=!0,P.cursorStyle=g.cursorStyle),typeof g.lineNumbers<"u"&&this.l!==g.lineNumbers&&(this.l=g.lineNumbers,b=!0,P.lineNumbers=A.TextEditorLineNumbersStyle.from(g.lineNumbers)),b&&this.v("setOptions",this.c.$trySetOptions(this.d,P))}v(g,P){P.catch(b=>{this.e.warn(`ExtHostTextEditorOptions '${g}' failed:'`),this.e.warn(b)})}}e.$LQ=c;class I{constructor(g,P,b,a,$,p,u,i){this.id=g,this.j=P,this.k=b,this.g=!1,this.h=new Set,this.c=$,this.d=new c(this.j,this.id,p,b),this.e=u,this.f=i;const o=this;this.value=Object.freeze({get document(){return a.value},set document(t){throw new h.$$("document")},get selection(){return o.c&&o.c[0]},set selection(t){if(!(t instanceof O.$8N))throw(0,h.$9)("selection");o.c=[t],o.l()},get selections(){return o.c},set selections(t){if(!Array.isArray(t)||t.some(n=>!(n instanceof O.$8N)))throw(0,h.$9)("selections");o.c=t,o.l()},get visibleRanges(){return o.e},set visibleRanges(t){throw new h.$$("visibleRanges")},get options(){return o.d.value},set options(t){o.g||o.d.assign(t)},get viewColumn(){return o.f},set viewColumn(t){throw new h.$$("viewColumn")},edit(t,n={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new m(a.value,n);return t(r),o.m(r)},insertSnippet(t,n,r={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let d;if(!n||Array.isArray(n)&&n.length===0)d=o.c.map(l=>A.Range.from(l));else if(n instanceof O.$6N){const{lineNumber:l,column:f}=A.Position.from(n);d=[{startLineNumber:l,startColumn:f,endLineNumber:l,endColumn:f}]}else if(n instanceof O.$7N)d=[A.Range.from(n)];else{d=[];for(const l of n)if(l instanceof O.$7N)d.push(A.Range.from(l));else{const{lineNumber:f,column:y}=A.Position.from(l);d.push({startLineNumber:f,startColumn:y,endLineNumber:f,endColumn:y})}}return P.$tryInsertSnippet(g,a.value.version,t.value,d,r)},setDecorations(t,n){const r=n.length===0;r&&!o.h.has(t.key)||(r?o.h.delete(t.key):o.h.add(t.key),o.n(()=>{if(A.$AQ(n))return P.$trySetDecorations(g,t.key,A.$BQ(n));{const d=new Array(4*n.length);for(let l=0,f=n.length;l<f;l++){const y=n[l];d[4*l]=y.start.line+1,d[4*l+1]=y.start.character+1,d[4*l+2]=y.end.line+1,d[4*l+3]=y.end.character+1}return P.$trySetDecorationsFast(g,t.key,d)}}))},revealRange(t,n){o.n(()=>P.$tryRevealRange(g,A.Range.from(t),n||O.TextEditorRevealType.Default))},show(t){P.$tryShowEditor(g,A.ViewColumn.from(t))},hide(){P.$tryHideEditor(g)},[Symbol.for("debug.description")](){return`TextEditor(${this.document.uri.toString()})`}})}dispose(){(0,s.ok)(!this.g),this.g=!0}_acceptOptions(g){(0,s.ok)(!this.g),this.d._accept(g)}_acceptVisibleRanges(g){(0,s.ok)(!this.g),this.e=g}_acceptViewColumn(g){(0,s.ok)(!this.g),this.f=g}_acceptSelections(g){(0,s.ok)(!this.g),this.c=g}async l(){const g=this.c.map(A.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,g)),this.value}m(g){const P=g.finalize();if(P.edits.length===0&&!P.setEndOfLine)return Promise.resolve(!0);const b=P.edits.map($=>$.range);b.sort(($,p)=>$.end.line===p.end.line?$.end.character===p.end.character?$.start.line===p.start.line?$.start.character-p.start.character:$.start.line-p.start.line:$.end.character-p.end.character:$.end.line-p.end.line);for(let $=0,p=b.length-1;$<p;$++){const u=b[$].end;if(b[$+1].start.isBefore(u))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=P.edits.map($=>({range:A.Range.from($.range),text:$.text,forceMoveMarkers:$.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,P.documentVersionId,a,{setEndOfLine:typeof P.setEndOfLine=="number"?A.EndOfLine.from(P.setEndOfLine):void 0,undoStopBefore:P.undoStopBefore,undoStopAfter:P.undoStopAfter})}n(g){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):g().then(()=>this,P=>(P instanceof Error&&P.name==="DISPOSED"||this.k.warn(P),null))}}e.$MQ=I}),define(Re[65],Ce([1,0,67,4,3,2,5,6,167,19,171,15,11,28,14,40,50]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P,b,a,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OQ=e.$NQ=void 0,s=Ue(s),E=Ue(E);class p{constructor(o){this.value=o,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let u=class{constructor(o,t){this.h=o,this.i=t,this.a=null,this.b=new Map,this.c=new P.$Dc,this.d=new h.$oe,this.e=new h.$oe,this.f=new h.$oe,this.g=new h.$oe,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const t=[],n=[],r=[];if(o.removedDocuments)for(const d of o.removedDocuments){const l=A.URI.revive(d),f=this.c.get(l);f?.unref()&&(this.c.delete(l),t.push(f.value))}if(o.addedDocuments)for(const d of o.addedDocuments){const l=A.URI.revive(d.uri);let f=this.c.get(l);if(f&&l.scheme!==b.Schemas.vscodeNotebookCell&&l.scheme!==b.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);f||(f=new p(new m.$GQ(this.h.getProxy(C.$3N.MainThreadDocuments),l,d.lines,d.EOL,d.versionId,d.languageId,d.isDirty)),this.c.set(l,f),n.push(f.value)),f.ref()}if(o.removedEditors)for(const d of o.removedEditors){const l=this.b.get(d);this.b.delete(d),l&&r.push(l)}if(o.addedEditors)for(const d of o.addedEditors){const l=A.URI.revive(d.documentUri);s.ok(this.c.has(l),`document '${l}' does not exist`),s.ok(!this.b.has(d.id),`editor '${d.id}' already exists!`);const f=this.c.get(l).value,y=new I.$MQ(d.id,this.h.getProxy(C.$3N.MainThreadTextEditors),this.i,new $.$W(()=>f.document),d.selections.map(E.Selection.to),d.options,d.visibleRanges.map(k=>E.Range.to(k)),typeof d.editorPosition=="number"?E.ViewColumn.to(d.editorPosition):void 0);this.b.set(d.id,y)}o.newActiveEditor!==void 0&&(s.ok(o.newActiveEditor===null||this.b.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this.a=o.newActiveEditor),(0,R.$Sc)(t),(0,R.$Sc)(r),o.removedDocuments&&this.e.fire(t),o.addedDocuments&&this.d.fire(n),(o.removedEditors||o.addedEditors)&&this.f.fire(this.allEditors().map(d=>d.value)),o.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(o){return this.c.get(o)?.value}allDocuments(){return a.Iterable.map(this.c.values(),o=>o.value)}getEditor(o){return this.b.get(o)}activeEditor(o){if(!this.a)return;const t=this.b.get(this.a);return o?t:t?.value}allEditors(){return[...this.b.values()]}};e.$NQ=u,e.$NQ=u=Ze([qe(0,c.$DQ),qe(1,g.$dk)],u),e.$OQ=(0,O.$Ii)("IExtHostDocumentsAndEditors")}),define(Re[99],Ce([1,0,7,21,20,4,81,61,3,41,17,2,32,5,11,6,34,65,19,169,15,9,265,75,120,76,25]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P,b,a,$,p,u,i,o,t,n,r,d,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Irc=e.$Hrc=e.$Grc=e.$Frc=e.$Erc=void 0,o=Ue(o);let y=0;const k=new WeakMap;e.$Erc=(0,P.$Ii)("IExtHostTesting");let S=class extends m.$Xc{constructor(B,Y,x,oe){super(),this.C=Y,this.D=x,this.F=oe,this.f=this.B(new A.$oe),this.g=new Map,this.w=this.B(new A.$oe),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=B.getProxy(a.$3N.MainThreadTesting),this.m=new V(this.h),this.j=new w(this.h,Y),x.registerArgumentProcessor({processArgument:ie=>{switch(ie?.$mid){case c.MarshalledId.TestItemContext:{const me=ie,ue=me.tests[me.tests.length-1].item.extId;return this.g.get(r.$mJ.root(ue))?.collection.tree.get(ue)?.actual??(0,i.$PQ)(ie)}case c.MarshalledId.TestMessageMenuArgs:{const{test:me,message:ue}=ie,X=me.item.extId;return{test:this.g.get(r.$mJ.root(X))?.collection.tree.get(X)?.actual??(0,i.$PQ)({$mid:c.MarshalledId.TestItemContext,tests:[me]}),message:o.TestMessage.to(ue)}}default:return ie}}}),x.registerCommand(!1,"testing.getExplorerSelection",async()=>{const ie=await x.executeCommand(n.TestCommandId.GetExplorerSelection),me=ue=>{const X=this.g.get(r.$mJ.root(ue));if(X)return r.$mJ.isRoot(ue)?X.controller:X.collection.tree.get(ue)?.actual};return{include:ie?.include.map(me).filter(I.$pg)||[],exclude:ie?.exclude.map(me).filter(I.$pg)||[]}})}createTestController(B,Y,x,oe){if(this.g.has(Y))throw new Error(`Attempt to insert a duplicate controller with ID "${Y}"`);const ie=new m.$Wc,me=ie.add(new i.$SQ(Y,x,this.F));me.root.label=x;const ue=new Map,X=new Set,q=this.h,se=()=>{let we=0;oe&&(we|=l.TestControllerCapability.Refresh);const $e=ae.relatedCodeProvider;return $e&&($e?.provideRelatedTests&&(we|=l.TestControllerCapability.TestRelatedToCode),$e?.provideRelatedCode&&(we|=l.TestControllerCapability.CodeRelatedToTest)),we},be={items:me.root.children,get label(){return x},set label(we){x=we,me.root.label=we,q.$updateController(Y,{label:x})},get refreshHandler(){return oe},set refreshHandler(we){oe=we,q.$updateController(Y,{capabilities:se()})},get id(){return Y},get relatedCodeProvider(){return ae.relatedCodeProvider},set relatedCodeProvider(we){(0,f.$wH)(B,"testRelatedCode"),ae.relatedCodeProvider=we,q.$updateController(Y,{capabilities:se()})},createRunProfile:(we,$e,pe,Ae,je,He)=>{let Ye=(0,C.$wj)(we);for(;ue.has(Ye);)Ye++;return new U(this.h,ue,X,this.w.event,Y,Ye,we,$e,pe,Ae,je,He)},createTestItem(we,$e,pe){return new i.$QQ(Y,we,$e,pe)},createTestRun:(we,$e,pe=!0)=>this.j.createTestRun(B,Y,me,we,$e,pe),invalidateTestResults:we=>{if(we===void 0)this.h.$markTestRetired(void 0);else{const $e=we instanceof Array?we:[we];this.h.$markTestRetired($e.map(pe=>r.$mJ.fromExtHostTestItem(pe,Y).toString()))}},set resolveHandler(we){me.resolveHandler=we},get resolveHandler(){return me.resolveHandler},dispose:()=>{ie.dispose()}},ae={controller:be,collection:me,profiles:ue,extension:B,activeProfiles:X};return q.$registerTestController(Y,x,se()),ie.add((0,m.$Vc)(()=>q.$unregisterTestController(Y))),this.g.set(Y,ae),ie.add((0,m.$Vc)(()=>this.g.delete(Y))),ie.add(me.onDidGenerateDiff(we=>q.$publishDiff(Y,we.map(l.TestsDiffOp.serialize)))),be}createTestObserver(){return this.m.checkout()}async runTests(B,Y=R.CancellationToken.None){const x=M(B);if(!x)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const oe=this.g.get(x.controllerId);if(!oe)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:B.preserveFocus??!0,group:z[x.kind],targets:[{testIds:B.include?.map(ie=>r.$mJ.fromExtHostTestItem(ie,oe.collection.root.id).toString())??[oe.collection.root.id],profileId:x.profileId,controllerId:x.controllerId}],exclude:B.exclude?.map(ie=>ie.id)},Y)}registerTestFollowupProvider(B){return this.y.add(B),{dispose:()=>{this.y.delete(B)}}}async $getTestsRelatedToCode(B,Y,x){const oe=this.F.getDocument(E.URI.revive(B));if(!oe)return[];const ie=o.Position.to(Y),me=[];return await Promise.all([...this.g.values()].map(async ue=>{let X;try{X=await ue.relatedCodeProvider?.provideRelatedTests?.(oe.document,ie,x)}catch(q){x.isCancellationRequested||this.C.warn(`Error thrown while providing related tests for ${ue.controller.label}`,q)}if(X){for(const q of X)me.push(r.$mJ.fromExtHostTestItem(q,ue.controller.id).toString());ue.collection.flushDiff()}})),me}async $getCodeRelatedToTest(B,Y){const x=this.g.get(r.$mJ.root(B));if(!x)return[];const oe=x.collection.tree.get(B);return oe?(await x.relatedCodeProvider?.provideRelatedCode?.(oe.actual,Y))?.map(o.location.from)??[]:[]}$syncTests(){for(const{collection:B}of this.g.values())B.flushDiff();return Promise.resolve()}async $getCoverageDetails(B,Y,x){return(await this.j.getCoverageDetails(B,Y,x))?.map(o.TestCoverage.fromDetails)}async $disposeRun(B){this.j.disposeTestRun(B)}$configureRunProfile(B,Y){this.g.get(B)?.profiles.get(Y)?.configureHandler?.()}$setDefaultRunProfiles(B){const Y=new Map;for(const[x,oe]of Object.entries(B)){const ie=this.g.get(x);if(!ie)continue;const me=new Map,ue=oe.filter(q=>!ie.activeProfiles.has(q)),X=[...ie.activeProfiles].filter(q=>!oe.includes(q));for(const q of ue)me.set(q,!0),ie.activeProfiles.add(q);for(const q of X)me.set(q,!1),ie.activeProfiles.delete(q);me.size&&Y.set(x,me)}this.w.fire(Y)}async $refreshTests(B,Y){await this.g.get(B)?.controller.refreshHandler?.(Y)}$publishTestResults(B){this.results=Object.freeze(B.map(Y=>{const x=o.TestResults.to(Y);return k.set(x,Y.id),x}).concat(this.results).sort((Y,x)=>x.completedAt-Y.completedAt).slice(0,32)),this.f.fire()}async $expandTest(B,Y){const x=this.g.get(r.$mJ.fromString(B).controllerId)?.collection;x&&(await x.expand(B,Y<0?1/0:Y),x.flushDiff())}$acceptDiff(B){this.m.applyDiff(B.map(Y=>l.TestsDiffOp.deserialize({asCanonicalUri:x=>x},Y)))}async $runControllerTests(B,Y){return Promise.all(B.map(x=>this.G(x,!1,Y)))}async $startContinuousRun(B,Y){const x=new R.$ze(Y),oe=await Promise.all(B.map(ie=>this.G(ie,!0,x.token)));return!Y.isCancellationRequested&&!oe.some(ie=>ie.error)&&await new Promise(ie=>Y.onCancellationRequested(ie)),x.dispose(!0),oe}async $provideTestFollowups(B,Y){const x=this.results.find(me=>k.get(me)===B.resultId),oe=x&&_(r.$mJ.fromString(B.extId),x?.results);if(!oe)return[];let ie=[];return await Promise.all([...this.y].map(async me=>{try{const ue=await me.provideFollowup(x,oe,B.taskIndex,B.messageIndex,Y);ue&&(ie=ie.concat(ue))}catch(ue){this.C.error("Error thrown while providing followup for test message",ue)}})),Y.isCancellationRequested?[]:ie.map(me=>{const ue=y++;return this.z.set(ue,me),{title:me.title,id:ue}})}$disposeTestFollowups(B){for(const Y of B)this.z.delete(Y)}$executeTestFollowup(B){const Y=this.z.get(B);return Y?this.D.executeCommand(Y.command,...Y.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(B,Y){B===void 0?this.j.cancelAllRuns():this.j.cancelRunById(B,Y)}getMetadataForRun(B){for(const Y of this.j.trackers){const x=Y.getTaskIdForRun(B);if(x)return{taskId:x,runId:Y.id}}}async G(B,Y,x){const oe=this.g.get(B.controllerId);if(!oe)return{};const{collection:ie,profiles:me,extension:ue}=oe,X=me.get(B.profileId);if(!X)return{};const q=B.testIds.map(we=>ie.tree.get(we)).filter(I.$pg),se=B.excludeExtIds.map(we=>oe.collection.tree.get(we)).filter(I.$pg).filter(we=>q.some($e=>$e.fullId.compare(we.fullId)===r.TestPosition.IsChild));if(!q.length)return{};const be=new t.$HP(q.some(we=>we.actual instanceof i.$RQ)?void 0:q.map(we=>we.actual),se.map(we=>we.actual),X,Y),ae=(0,l.$pJ)(B)&&this.j.prepareForMainThreadTestRun(ue,be,L.fromInternal(B,oe.collection),X,x);try{return await X.runHandler(be,x),{}}catch(we){return{error:String(we)}}finally{ae&&ae.hasRunningTasks&&!x.isCancellationRequested&&await A.Event.toPromise(ae.onEnd)}}};e.$Frc=S,e.$Frc=S=Ze([qe(0,u.$DQ),qe(1,b.$dk),qe(2,$.$ZQ),qe(3,p.$OQ)],S);const D=1e4;var T;(function(W){W[W.Running=0]="Running",W[W.Cancelling=1]="Cancelling",W[W.Ended=2]="Ended"})(T||(T={}));class v extends m.$Xc{get hasRunningTasks(){return this.g>0}get id(){return this.C.id}constructor(B,Y,x,oe,ie,me){super(),this.C=B,this.D=Y,this.F=x,this.G=oe,this.H=ie,this.f=T.Running,this.g=0,this.h=new Map,this.j=new Set,this.w=this.B(new A.$oe),this.z=new Map,this.onEnd=this.w.event,this.m=this.B(new R.$ze(me));const ue=this.B(new s.$Uh(()=>this.I(),D));this.B(this.m.token.onCancellationRequested(()=>ue.schedule()));const X=new A.$oe;this.y=X.event,this.B((0,m.$Vc)(()=>{X.fire(),X.dispose()}))}getTaskIdForRun(B){for(const[Y,{run:x}]of this.h)if(x===B)return Y}cancel(B){B?this.h.get(B)?.cts.cancel():this.f===T.Running?(this.m.cancel(),this.f=T.Cancelling):this.f===T.Cancelling&&this.I()}async getCoverageDetails(B,Y,x){const[,oe]=r.$mJ.fromString(B).path,ie=this.z.get(B);if(!ie)return[];const{report:me,extIds:ue}=ie,X=this.h.get(oe);if(!X)throw new Error("unreachable: run task was not found");let q;if(Y&&me instanceof t.$NP){const be=ue.indexOf(Y);if(be===-1)return[];q=me.fromTests[be]}return await(q?this.G?.loadDetailedCoverageForTest?.(X.run,me,q,x):this.G?.loadDetailedCoverage?.(X.run,me,x))??[]}createRun(B){const Y=this.C.id,x=this.C.controllerId,oe=(0,g.$5g)(),ie=se=>(be,...ae)=>{if(ue){this.F.warn(`Setting the state of test "${be.id}" is a no-op after the run ends.`);return}this.L(be),se(be,...ae)},me=(se,be)=>{const ae=be instanceof Array?be.map(o.TestMessage.from):[o.TestMessage.from(be)];if(se.uri&&se.range){const we={range:o.Range.from(se.range),uri:se.uri};for(const $e of ae)$e.location=$e.location||we}this.D.$appendTestMessagesInRun(Y,oe,r.$mJ.fromExtHostTestItem(se,x).toString(),ae)};let ue=!1;const X=this.B(new R.$ze(this.m.token)),q={isPersisted:this.C.isPersisted,token:X.token,name:B,onDidDispose:this.y,addCoverage:se=>{if(ue)return;const be=se instanceof t.$NP?se.fromTests:[];if(be.length){(0,f.$wH)(this.H,"attributableCoverage");for(const $e of be)this.L($e)}const ae=se.uri.toString(),we=new r.$mJ([Y,oe,ae]).toString();this.z.set(we,{report:se,extIds:be.map($e=>r.$mJ.fromExtHostTestItem($e,x).toString())}),this.D.$appendCoverage(Y,oe,o.TestCoverage.fromFile(x,we,se))},enqueued:ie(se=>{this.D.$updateTestStateInRun(Y,oe,r.$mJ.fromExtHostTestItem(se,x).toString(),l.TestResultState.Queued)}),skipped:ie(se=>{this.D.$updateTestStateInRun(Y,oe,r.$mJ.fromExtHostTestItem(se,x).toString(),l.TestResultState.Skipped)}),started:ie(se=>{this.D.$updateTestStateInRun(Y,oe,r.$mJ.fromExtHostTestItem(se,x).toString(),l.TestResultState.Running)}),errored:ie((se,be,ae)=>{me(se,be),this.D.$updateTestStateInRun(Y,oe,r.$mJ.fromExtHostTestItem(se,x).toString(),l.TestResultState.Errored,ae)}),failed:ie((se,be,ae)=>{me(se,be),this.D.$updateTestStateInRun(Y,oe,r.$mJ.fromExtHostTestItem(se,x).toString(),l.TestResultState.Failed,ae)}),passed:ie((se,be)=>{this.D.$updateTestStateInRun(Y,oe,r.$mJ.fromExtHostTestItem(se,this.C.controllerId).toString(),l.TestResultState.Passed,be)}),appendOutput:(se,be,ae)=>{ue||(ae&&this.L(ae),this.D.$appendOutputToRun(Y,oe,h.$Qe.fromString(se),be&&o.location.from(be),ae&&r.$mJ.fromExtHostTestItem(ae,x).toString()))},end:()=>{ue||(ue=!0,this.D.$finishedTestRunTask(Y,oe),--this.g||this.J())}};return this.g++,this.h.set(oe,{run:q,cts:X}),this.D.$startedTestRunTask(Y,{id:oe,ctrlId:this.C.controllerId,name:B||this.H.displayName||this.H.identifier.value,running:!0}),q}I(){for(const{run:B}of this.h.values())B.end()}J(){this.f!==T.Ended&&(this.f=T.Ended,this.w.fire())}L(B){if(!(B instanceof i.$QQ))throw new d.$vQ(B.id);if(this.j.has(r.$mJ.fromExtHostTestItem(B,this.C.controllerId).toString()))return;const Y=[],x=this.C.colllection.root;for(;;){const oe=o.TestItem.from(B);if(Y.unshift(oe),this.j.has(oe.extId)||(this.j.add(oe.extId),B===x))break;B=B.parent||x}this.D.$addTestsToRun(this.C.controllerId,this.C.id,Y)}dispose(){this.J(),super.dispose()}}class w{get trackers(){return this.f.values()}constructor(B,Y){this.h=B,this.j=Y,this.f=new Map,this.g=new Map}getCoverageDetails(B,Y,x){const oe=r.$mJ.root(B);return this.g.get(oe)?.getCoverageDetails(B,Y,x)||[]}disposeTestRun(B){this.g.get(B)?.dispose(),this.g.delete(B);for(const[Y,{id:x}]of this.f)x===B&&this.f.delete(Y)}prepareForMainThreadTestRun(B,Y,x,oe,ie){return this.k(Y,x,oe,B,ie)}cancelRunById(B,Y){this.g.get(B)?.cancel(Y)}cancelAllRuns(){for(const B of this.f.values())B.cancel()}createTestRun(B,Y,x,oe,ie,me){const ue=this.f.get(oe);if(ue)return ue.createRun(ie);const X=L.fromPublic(Y,x,oe,me),q=M(oe);this.h.$startedExtensionTestRun({controllerId:Y,continuous:!!oe.continuous,profile:q&&{group:z[q.kind],id:q.profileId},exclude:oe.exclude?.map(be=>r.$mJ.fromExtHostTestItem(be,x.root.id).toString())??[],id:X.id,include:oe.include?.map(be=>r.$mJ.fromExtHostTestItem(be,x.root.id).toString())??[x.root.id],preserveFocus:oe.preserveFocus??!0,persist:me});const se=this.k(oe,X,oe.profile,B);return A.Event.once(se.onEnd)(()=>{this.h.$finishedExtensionTestRun(X.id)}),se.createRun(ie)}k(B,Y,x,oe,ie){const me=new v(Y,this.h,this.j,x,oe,ie);return this.f.set(B,me),this.g.set(me.id,me),me}}e.$Grc=w;const M=W=>{if(W.profile){if(!(W.profile instanceof U))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return W.profile}};class L{static fromPublic(B,Y,x,oe){return new L(B,(0,g.$5g)(),oe,Y)}static fromInternal(B,Y){return new L(B.controllerId,B.runId,!0,Y)}constructor(B,Y,x,oe){this.controllerId=B,this.id=Y,this.isPersisted=x,this.colllection=oe}}e.$Hrc=L;class N{get isEmpty(){return this.f.size===0&&this.h.size===0&&this.g.size===0}constructor(B){this.k=B,this.f=new Set,this.g=new Set,this.h=new Set,this.j=new Set}add(B){this.f.add(B)}update(B){Object.assign(B.revived,o.TestItem.toPlain(B.item)),this.f.has(B)||this.g.add(B)}remove(B){if(this.f.has(B)){this.f.delete(B);return}this.g.delete(B);const Y=r.$mJ.parentId(B.item.extId);if(Y&&this.j.has(Y.toString())){this.j.add(B.item.extId);return}this.h.add(B)}getChangeEvent(){const{f:B,g:Y,h:x}=this;return{get added(){return[...B].map(oe=>oe.revived)},get updated(){return[...Y].map(oe=>oe.revived)},get removed(){return[...x].map(oe=>oe.revived)}}}complete(){this.isEmpty||this.k.fire(this.getChangeEvent())}}class F extends l.$vJ{constructor(){super(...arguments),this.z=new A.$oe,this.onDidChangeTests=this.z.event}get rootTests(){return this.h}getMirroredTestDataById(B){return this.g.get(B)}getMirroredTestDataByReference(B){return this.g.get(B.id)}y(B,Y){return{...B,revived:o.TestItem.toPlain(B.item),depth:Y?Y.depth+1:0,children:new Set}}x(){return new N(this.z)}}class V{constructor(B){this.g=B}checkout(){this.f||(this.f=this.h());const B=this.f;return B.observers++,{onDidChangeTest:B.tests.onDidChangeTests,get tests(){return[...B.tests.rootTests].map(Y=>Y.revived)},dispose:(0,O.$fb)(()=>{--B.observers===0&&(this.g.$unsubscribeFromDiffs(),this.f=void 0)})}}getMirroredTestDataByReference(B){return this.f?.tests.getMirroredTestDataByReference(B)}applyDiff(B){this.f?.tests.apply(B)}h(){const B=new F({asCanonicalUri:Y=>Y});return this.g.$subscribeToDiffs(),{observers:0,tests:B}}}const j=(W,B,Y,x)=>{Y?Object.assign(Y,x):B.$updateTestRunConfig(W.controllerId,W.profileId,x)};class U{#e;#t;#i;#n;#s;get label(){return this.g}set label(B){B!==this.g&&(this.g=B,j(this,this.#e,this.#n,{label:B}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(B){B!==this.h&&(this.h=B,j(this,this.#e,this.#n,{supportsContinuousRun:B}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(B){B!==this.isDefault&&(B?this.#t.add(this.profileId):this.#t.delete(this.profileId),j(this,this.#e,this.#n,{isDefault:B}))}get tag(){return this._tag}set tag(B){B?.id!==this._tag?.id&&(this._tag=B,j(this,this.#e,this.#n,{tag:B?o.TestTag.namespace(this.controllerId,B.id):null}))}get configureHandler(){return this.f}set configureHandler(B){B!==this.f&&(this.f=B,j(this,this.#e,this.#n,{hasConfigurationHandler:!!B}))}get onDidChangeDefault(){return A.Event.chain(this.#i,B=>B.map(Y=>Y.get(this.controllerId)?.get(this.profileId)).filter(I.$pg))}constructor(B,Y,x,oe,ie,me,ue,X,q,se=!1,be=void 0,ae=!1){this.controllerId=ie,this.profileId=me,this.g=ue,this.kind=X,this.runHandler=q,this._tag=be,this.h=ae,this.#e=B,this.#s=Y,this.#t=x,this.#i=oe,Y.set(me,this);const we=z[X];if(typeof we!="number")throw new Error(`Unknown TestRunProfile.group ${X}`);se&&x.add(me),this.#n={profileId:me,controllerId:ie,tag:be?o.TestTag.namespace(this.controllerId,be.id):null,label:ue,group:we,isDefault:se,hasConfigurationHandler:!1,supportsContinuousRun:ae},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Irc=U;const z={[t.TestRunProfileKind.Coverage]:l.TestRunProfileBitset.Coverage,[t.TestRunProfileKind.Debug]:l.TestRunProfileBitset.Debug,[t.TestRunProfileKind.Run]:l.TestRunProfileBitset.Run};function _(W,B){for(let Y=0;Y<W.path.length;Y++){const x=B.find(oe=>oe.id===W.path[Y]);if(!x)return;if(Y===W.path.length-1)return x;B=x.children}}}),define(Re[321],Ce([1,0,18,4,3,6,171,15,9]),function(ge,e,s,h,R,A,O,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pqc=void 0,s=Ue(s),C=Ue(C);class c extends R.$Xc{constructor(E,g){super(),this.m=g,this.a=new h.$oe,this.b=new h.$oe,this.c=new h.$oe,this.f=new h.$oe,this.g=new h.$oe,this.h=new h.$oe,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.f.event,this.onDidChangeActiveTextEditor=this.g.event,this.onDidChangeVisibleTextEditors=this.h.event,this.j=E.getProxy(A.$3N.MainThreadTextEditors),this.B(this.m.onDidChangeVisibleTextEditors(P=>this.h.fire(P))),this.B(this.m.onDidChangeActiveTextEditor(P=>this.g.fire(P)))}getActiveTextEditor(){return this.m.activeEditor()}getVisibleTextEditors(E){const g=this.m.allEditors();return E?g:g.map(P=>P.value)}async showTextDocument(E,g,P){let b;typeof g=="number"?b={position:C.ViewColumn.from(g),preserveFocus:P}:typeof g=="object"?b={position:C.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus,selection:typeof g.selection=="object"?C.Range.from(g.selection):void 0,pinned:typeof g.preview=="boolean"?!g.preview:void 0}:b={preserveFocus:!1};const a=await this.j.$tryShowTextDocument(E.uri,b),$=a&&this.m.getEditor(a);if($)return $.value;throw a?new Error(`Could NOT open editor for "${E.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${E.uri.toString()}".`)}createTextEditorDecorationType(E,g){return new O.$KQ(this.j,E,g).value}$acceptEditorPropertiesChanged(E,g){const P=this.m.getEditor(E);if(!P)throw new Error("unknown text editor");if(g.options&&P._acceptOptions(g.options),g.selections){const b=g.selections.selections.map(C.Selection.to);P._acceptSelections(b)}if(g.visibleRanges){const b=s.$Jb(g.visibleRanges.map(C.Range.to));P._acceptVisibleRanges(b)}if(g.options&&this.b.fire({textEditor:P.value,options:{...g.options,lineNumbers:C.TextEditorLineNumbersStyle.to(g.options.lineNumbers)}}),g.selections){const b=m.TextEditorSelectionChangeKind.fromValue(g.selections.source),a=g.selections.selections.map(C.Selection.to);this.a.fire({textEditor:P.value,selections:a,kind:b})}if(g.visibleRanges){const b=s.$Jb(g.visibleRanges.map(C.Range.to));this.c.fire({textEditor:P.value,visibleRanges:b})}}$acceptEditorPositionData(E){for(const g in E){const P=this.m.getEditor(g);if(!P)throw new Error("Unknown text editor");const b=C.ViewColumn.to(E[g]);P.value.viewColumn!==b&&(P._acceptViewColumn(b),this.f.fire({textEditor:P.value,viewColumn:b}))}}getDiffInformation(E){return Promise.resolve(this.j.$getDiffInformation(E))}}e.$Pqc=c}),define(Re[322],Ce([1,0,2,5,6,3,9,15,23,41,17]),function(ge,e,s,h,R,A,O,C,m,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gsc=e.$Fsc=void 0,e.$Fsc=(0,h.$Ii)("IExtHostTimeline");class E{constructor(b,a){this.b=new Map,this.c=new Map,this.a=b.getProxy(R.$3N.MainThreadTimeline),a.registerArgumentProcessor({processArgument:($,p)=>{if($&&$.$mid===c.MarshalledId.TimelineActionContext)if(this.b.get($.source)&&m.$vn.equals(p,this.b.get($.source)?.extension)){const u=$.uri===void 0?void 0:s.URI.revive($.uri);return this.c.get($.source)?.get(g(u))?.get($.handle)}else return;return $}})}async $getTimeline(b,a,$,p){return this.b.get(b)?.provider.provideTimeline(s.URI.revive(a),$,p)}registerTimelineProvider(b,a,$,p){const u=new A.$Wc,i=this.d(a.id,p,u).bind(this);let o;a.onDidChange&&(o=a.onDidChange(n=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...n,id:a.id}),this));const t=this.c;return this.f({...a,scheme:b,onDidChange:void 0,async provideTimeline(n,r,d){r?.resetCache&&(u.clear(),t.get(a.id)?.clear());const l=await a.provideTimeline(n,r,d);if(l==null)return;const f=i(n,r);return{...l,source:a.id,items:l.items.map(f)}},dispose(){for(const n of t.values())n.get(a.id)?.clear();o?.dispose(),u.dispose()}},$)}d(b,a,$){return(p,u)=>{let i;if(u?.cacheResults){let o=this.c.get(b);o===void 0&&(o=new Map,this.c.set(b,o));const t=g(p);i=o.get(t),i===void 0&&(i=new Map,o.set(t,i))}return o=>{const{iconPath:t,...n}=o,r=`${b}|${o.id??o.timestamp}`;i?.set(r,o);let d,l,f;o.iconPath&&(t instanceof O.$4O?f={id:t.id,color:t.color}:s.URI.isUri(t)?(d=t,l=t):{light:d,dark:l}=t);let y;return O.$wO.isMarkdownString(n.tooltip)?y=C.MarkdownString.from(n.tooltip):(0,I.$hg)(n.tooltip)?y=n.tooltip:O.$wO.isMarkdownString(n.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),y=C.MarkdownString.from(n.detail)):(0,I.$hg)(n.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),y=n.detail),{...n,id:n.id??void 0,handle:r,source:b,command:o.command?a.toInternal(o.command,$):void 0,icon:d,iconDark:l,themeIcon:f,tooltip:y,accessibilityInformation:o.accessibilityInformation}}}}f(b,a){if(this.b.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this.a.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this.b.set(b.id,{provider:b,extension:a}),(0,A.$Vc)(()=>{for(const p of this.c.values())p.get(b.id)?.clear();this.b.delete(b.id),this.a.$unregisterTimelineProvider(b.id),b.dispose()})}}e.$Gsc=E;function g(P){return P?.toString()}}),define(Re[323],Ce([1,0,8,22,2,4,3,256,7,9,17,18,15,86,20,211,25]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P,b,a,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hsc=void 0,c=Ue(c);function p(o,t){if((0,I.$hg)(o))return{label:o};if(o&&typeof o=="object"&&typeof o.label=="string"){let n;return Array.isArray(o.highlights)&&(n=o.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),n=n.length?n:void 0),{label:o.label,highlights:n}}}class u extends O.$Xc{constructor(t,n,r){super(),this.f=t,this.g=n,this.h=r,this.a=new Map,this.b=new a.$cab;function d(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}n.registerArgumentProcessor({processArgument:l=>d(l)?this.r(l):Array.isArray(l)&&l.length>0?l.map(f=>d(f)?this.r(f):f):l})}registerTreeDataProvider(t,n,r){const d=this.createTreeView(t,{treeDataProvider:n},r);return{dispose:()=>d.dispose()}}createTreeView(t,n,r){if(!n||!n.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=n.dragAndDropController?.dropMimeTypes??[],l=n.dragAndDropController?.dragMimeTypes??[],f=!!n.dragAndDropController?.handleDrag,y=!!n.dragAndDropController?.handleDrop,k=this.m(t,n,r),S={showCollapseAll:!!n.showCollapseAll,canSelectMany:!!n.canSelectMany,dropMimeTypes:d,dragMimeTypes:l,hasHandleDrag:f,hasHandleDrop:y,manuallyManageCheckboxes:!!n.manageCheckboxStateManually},D=this.f.$registerTreeViewDataProvider(t,S),T={get onDidCollapseElement(){return k.onDidCollapseElement},get onDidExpandElement(){return k.onDidExpandElement},get selection(){return k.selectedElements},get onDidChangeSelection(){return k.onDidChangeSelection},get activeItem(){return(0,$.$wH)(r,"treeViewActiveItem"),k.focusedElement},get onDidChangeActiveItem(){return(0,$.$wH)(r,"treeViewActiveItem"),k.onDidChangeActiveItem},get visible(){return k.visible},get onDidChangeVisibility(){return k.onDidChangeVisibility},get onDidChangeCheckboxState(){return k.onDidChangeCheckboxState},get message(){return k.message},set message(v){(0,P.$9k)(v)&&(0,$.$wH)(r,"treeViewMarkdownMessage"),k.message=v},get title(){return k.title},set title(v){k.title=v},get description(){return k.description},set description(v){k.description=v},get badge(){return k.badge},set badge(v){v!==void 0&&c.ViewBadge.isViewBadge(v)?k.badge={value:Math.floor(Math.abs(v.value)),tooltip:v.tooltip}:v===void 0&&(k.badge=void 0)},reveal:(v,w)=>k.reveal(v,w),dispose:async()=>{await D,this.a.delete(t),k.dispose()}};return this.B(T),T}$getChildren(t,n){const r=this.a.get(t);return r?r.getChildren(n):Promise.reject(new C.$QG(t))}async $handleDrop(t,n,r,d,l,f,y,k){const S=this.a.get(t);if(!S)return Promise.reject(new C.$QG(t));const D=g.DataTransfer.toDataTransfer(r,async T=>(await this.f.$resolveDropFileData(t,n,T)).buffer);return y===t&&k&&await this.j(D,S,k,l,f),S.onDrop(D,d,l)}async j(t,n,r,d,l){const f=this.b.removeDragOperationTransfer(l);if(f)(await f)?.forEach((y,k)=>{y&&t.set(k,y)});else if(l&&n.handleDrag){const y=n.handleDrag(r,t,d);this.b.addDragOperationTransfer(l,y),await y}return t}async $handleDrag(t,n,r,d){const l=this.a.get(t);if(!l)return Promise.reject(new C.$QG(t));const f=await this.j(new c.$ZO,l,n,d,r);if(!(!f||d.isCancellationRequested))return g.DataTransfer.from(f)}async $hasResolve(t){const n=this.a.get(t);if(!n)throw new C.$QG(t);return n.hasResolve}$resolve(t,n,r){const d=this.a.get(t);if(!d)throw new C.$QG(t);return d.resolveTreeItem(n,r)}$setExpanded(t,n,r){const d=this.a.get(t);if(!d)throw new C.$QG(t);d.setExpanded(n,r)}$setSelectionAndFocus(t,n,r){const d=this.a.get(t);if(!d)throw new C.$QG(t);d.setSelectionAndFocus(n,r)}$setVisible(t,n){const r=this.a.get(t);if(!r){if(!n)return;throw new C.$QG(t)}r.setVisible(n)}$changeCheckboxState(t,n){const r=this.a.get(t);if(!r)throw new C.$QG(t);r.setCheckboxState(n)}m(t,n,r){const d=this.B(new i(t,n,this.f,this.g.converter,this.h,r));return this.a.set(t,d),d}r(t){const n=this.a.get(t.$treeViewId);return n&&"$treeItemHandle"in t?n.getExtensionElement(t.$treeItemHandle):n&&"$focusedTreeItem"in t&&t.$focusedTreeItem?n.focusedElement:null}}e.$Hsc=u;class i extends O.$Xc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(t=>this.getExtensionElement(t)).filter(t=>!(0,I.$qg)(t))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(t,n,r,d,l,f){if(super(),this.I=t,this.J=r,this.L=d,this.M=l,this.N=f,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new A.$oe),this.onDidExpandElement=this.u.event,this.w=this.B(new A.$oe),this.onDidCollapseElement=this.w.event,this.y=this.B(new A.$oe),this.onDidChangeSelection=this.y.event,this.z=this.B(new A.$oe),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new A.$oe),this.onDidChangeVisibility=this.C.event,this.D=this.B(new A.$oe),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new A.$oe),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new b.$ze,f.contributes&&f.contributes.views)for(const D in f.contributes.views)for(const T of f.contributes.views[D])T.id===t&&(this.P=T.name);this.f=n.treeDataProvider,this.g=n.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(D=>{Array.isArray(D)&&D.length===0||this.F.fire({message:!1,element:D})}));let y,k;const S=A.Event.debounce(this.F.event,(D,T)=>(D||(D={message:!1,elements:[]}),T.element!==!1&&(y||(y=new Promise(v=>k=v),this.G=this.G.then(()=>y)),Array.isArray(T.element)?D.elements.push(...T.element):D.elements.push(T.element)),T.message&&(D.message=!0),D),200,!0);this.B(S(({message:D,elements:T})=>{T.length&&(this.H=this.H.then(()=>{const v=k;return y=null,this.$(T).then(()=>v())})),D&&this.J.$setMessage(this.I,g.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(t){const n=t?this.getExtensionElement(t):void 0;if(t&&!n)return this.M.error(`No tree item with id '${t}' found.`),Promise.resolve([]);let r=this.X(t);return r||(r=await this.Y(n)),r?r.map(d=>d.item):void 0}getExtensionElement(t){return this.j.get(t)}reveal(t,n){n=n||{select:!0,focus:!1};const r=(0,I.$qg)(n.select)?!0:n.select,d=(0,I.$qg)(n.focus)?!1:n.focus,l=(0,I.$qg)(n.expand)?!1:n.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):t?this.G.then(()=>this.S(t)).then(f=>this.W(t,f[f.length-1]).then(y=>this.J.$reveal(this.I,{item:y.item,parentChain:f.map(k=>k.item)},{select:r,focus:d,expand:l})),f=>this.M.error(f)):this.J.$reveal(this.I,void 0,{select:r,focus:d,expand:l})}get message(){return this.O}set message(t){this.O=t,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(t){this.P=t,this.J.$setTitle(this.I,t,this.Q)}get description(){return this.Q}set description(t){this.Q=t,this.J.$setTitle(this.I,this.P,t)}get badge(){return this.R}set badge(t){this.R?.value===t?.value&&this.R?.tooltip===t?.tooltip||(this.R=g.ViewBadge.from(t),this.J.$setBadge(this.I,t))}setExpanded(t,n){const r=this.getExtensionElement(t);r&&(n?this.u.fire(Object.freeze({element:r})):this.w.fire(Object.freeze({element:r})))}setSelectionAndFocus(t,n){const r=!(0,E.$wb)(this.s,t);this.s=t;const d=this.t!==n;this.t=n,r&&this.y.fire(Object.freeze({selection:this.selectedElements})),d&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(t){t!==this.r&&(this.r=t,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(t){const n=(await Promise.all(t.map(async r=>{const d=this.getExtensionElement(r.treeItemHandle);return d?{extensionItem:d,treeItem:await this.f.getTreeItem(d),newState:r.newState?c.TreeItemCheckboxState.Checked:c.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(r=>r!==void 0);n.forEach(r=>{r.treeItem.checkboxState=r.newState?c.TreeItemCheckboxState.Checked:c.TreeItemCheckboxState.Unchecked}),this.D.fire({items:n.map(r=>[r.extensionItem,r.newState])})}async handleDrag(t,n,r){const d=[];for(const l of t){const f=this.getExtensionElement(l);f&&d.push(f)}if(!(!this.g?.handleDrag||d.length===0))return await this.g.handleDrag(d,n,r),n}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(t,n,r){const d=n?this.getExtensionElement(n):void 0;if(!(!d&&n||!this.g?.handleDrop))return(0,m.$Ah)(()=>this.g?.handleDrop?this.g.handleDrop(d,t,r):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(t,n){if(!this.f.resolveTreeItem)return;const r=this.j.get(t);if(r){const d=this.m.get(r);if(d){const l=await this.f.resolveTreeItem(d.extensionItem,r,n)??d.extensionItem;return this.hb(l),d.item.tooltip=this.eb(l.tooltip),d.item.command=this.fb(d.disposableStore,l.command),d.item}}}S(t){return this.U(t).then(n=>n?this.S(n).then(r=>this.W(n,r[r.length-1]).then(d=>(r.push(d),r))):Promise.resolve([]))}U(t){const n=this.m.get(t);return n?Promise.resolve(n.parent?this.j.get(n.parent.item.handle):void 0):(0,m.$Ah)(()=>this.f.getParent(t))}W(t,n){const r=this.m.get(t);return r?Promise.resolve(r):(0,m.$Ah)(()=>this.f.getTreeItem(t)).then(d=>this.kb(t,d,n,!0)).then(d=>this.getChildren(n?n.item.handle:void 0).then(()=>{const l=this.getExtensionElement(d);if(l){const f=this.m.get(l);if(f)return Promise.resolve(f)}throw new Error(`Cannot resolve tree item for element ${d} from extension ${this.N.identifier.value}`)}))}X(t){if(t){let n;if(typeof t=="string"){const r=this.getExtensionElement(t);n=r?this.m.get(r):void 0}else n=t;return n&&n.children||void 0}return this.h}async Y(t){this.rb(t);const n=new b.$ze(this.Z.token);try{const r=t?this.m.get(t):void 0,d=await this.f.getChildren(t);if(n.token.isCancellationRequested)return;const l=(0,E.$Jb)(d||[]),f=await Promise.all((0,E.$Jb)(l).map(k=>this.f.getTreeItem(k)));if(n.token.isCancellationRequested)return;const y=f.map((k,S)=>k?this.db(l[S],k,r):null);return(0,E.$Jb)(y)}finally{n.dispose()}}$(t){if(t.some(r=>!r))return this.Z.dispose(!0),this.Z=new b.$ze,this.tb(),this.J.$refresh(this.I);{const r=this.ab(t);if(r.length)return this.bb(r)}return Promise.resolve(void 0)}ab(t){const n=new Set,r=t.map(l=>this.m.get(l));for(const l of r)if(l&&!n.has(l.item.handle)){let f=l;for(;f&&f.parent&&r.findIndex(y=>f&&f.parent&&y&&y.item.handle===f.parent.item.handle)===-1;){const y=this.j.get(f.parent.item.handle);f=y?this.m.get(y):void 0}f&&!f.parent&&n.add(l.item.handle)}const d=[];return n.forEach(l=>{const f=this.j.get(l);if(f){const y=this.m.get(f);y&&(!y.parent||!n.has(y.parent.item.handle))&&d.push(l)}}),d}bb(t){const n={};return Promise.all(t.map(r=>this.cb(r).then(d=>{d&&(n[r]=d.item)}))).then(()=>Object.keys(n).length?this.J.$refresh(this.I,n):void 0)}cb(t){const n=this.getExtensionElement(t);if(n){const r=this.m.get(n);if(r)return this.rb(n),(0,m.$Ah)(()=>this.f.getTreeItem(n)).then(d=>{if(d){const l=this.ib(n,d,r.parent);return this.pb(n,l,r,r.parent),r.dispose(),l}return null})}return Promise.resolve(null)}db(t,n,r){const d=this.ib(t,n,r);if(n.id&&this.j.has(d.item.handle))throw new Error((0,s.localize)(2715,null,n.id));return this.ob(t,d),this.qb(d,r),d}eb(t){return c.$wO.isMarkdownString(t)?g.MarkdownString.from(t):t}fb(t,n){return n?{...this.L.toInternal(n,t),originalId:n.command}:void 0}gb(t){if(t.checkboxState===void 0)return;let n,r,d;return typeof t.checkboxState=="number"?n=t.checkboxState:(n=t.checkboxState.state,r=t.checkboxState.tooltip,d=t.checkboxState.accessibilityInformation),{isChecked:n===c.TreeItemCheckboxState.Checked,tooltip:r,accessibilityInformation:d}}hb(t){if(!c.$UO.isTreeItem(t,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(t,n,r){this.hb(n);const d=this.B(new O.$Wc),l=this.kb(t,n,r),f=this.lb(n);return{item:{handle:l,parentHandle:r?r.item.handle:void 0,label:p(n.label,this.N),description:n.description,resourceUri:n.resourceUri,tooltip:this.eb(n.tooltip),command:this.fb(d,n.command),contextValue:n.contextValue,icon:f,iconDark:this.mb(n)||f,themeIcon:this.jb(n),collapsibleState:(0,I.$qg)(n.collapsibleState)?c.TreeItemCollapsibleState.None:n.collapsibleState,accessibilityInformation:n.accessibilityInformation,checkbox:this.gb(n)},extensionItem:n,parent:r,children:void 0,disposableStore:d,dispose(){d.dispose()}}}jb(t){return t.iconPath instanceof c.$4O?t.iconPath:void 0}kb(t,{id:n,label:r,resourceUri:d},l,f){if(n)return`${i.b}/${n}`;const y=p(r,this.N),k=l?l.item.handle:i.a;let S=y?y.label:d?(0,h.$gh)(d):"";S=S.indexOf("/")!==-1?S.replace("/","//"):S;const D=this.m.has(t)?this.m.get(t).item.handle:void 0,T=this.X(l)||[];let v,w=0;do{if(v=`${k}/${w}:${S}`,f||!this.j.has(v)||D===v)break;w++}while(w<=T.length);return v}lb(t){if(t.iconPath&&!(t.iconPath instanceof c.$4O))return typeof t.iconPath=="string"||R.URI.isUri(t.iconPath)?this.nb(t.iconPath):this.nb(t.iconPath.light)}mb(t){if(t.iconPath&&!(t.iconPath instanceof c.$4O)&&t.iconPath.dark)return this.nb(t.iconPath.dark)}nb(t){return R.URI.isUri(t)?t:R.URI.file(t)}ob(t,n){this.j.set(n.item.handle,t),this.m.set(t,n)}pb(t,n,r,d){this.j.delete(n.item.handle),this.m.delete(t),n.item.handle!==r.item.handle&&this.j.delete(r.item.handle),this.ob(t,n);const l=this.X(d)||[],f=l.filter(y=>y.item.handle===r.item.handle)[0];f&&l.splice(l.indexOf(f),1,n)}qb(t,n){n?(n.children||(n.children=[]),n.children.push(t)):(this.h||(this.h=[]),this.h.push(t))}rb(t){if(t){const n=this.m.get(t);if(n){if(n.children)for(const r of n.children){const d=this.j.get(r.item.handle);d&&this.sb(d)}n.children=void 0}}else this.tb()}sb(t){const n=this.m.get(t);if(n){if(n.children)for(const r of n.children){const d=this.j.get(r.item.handle);d&&this.sb(d)}this.m.delete(t),this.j.delete(n.item.handle),n.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(t=>t.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Re[324],Ce([1,0,4,3,2,32,15,97,6,9]),function(ge,e,s,h,R,A,O,C,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9qc=void 0,O=Ue(O),m=Ue(m),c=Ue(c);class I extends h.$Xc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;#h;constructor(b,a,$,p){super(),this.#o=void 0,this.#c=!0,this.#u=!1,this.#d=this.B(new s.$oe),this.onDidDispose=this.#d.event,this.#h=this.B(new s.$oe),this.onDidChangeViewState=this.#h.event,this.#e=b,this.#t=a,this.#n=$,this.#i=p.viewType,this.#s=p.panelOptions,this.#o=p.viewColumn,this.#r=p.title,this.#l=p.active}dispose(){this.#u||(this.#u=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(b){this.c(),this.#r!==b&&(this.#r=b,this.#t.$setTitle(this.#e,b))}get iconPath(){return this.c(),this.#a}set iconPath(b){this.c(),this.#a!==b&&(this.#a=b,this.#t.$setIconPath(this.#e,R.URI.isUri(b)?{light:b,dark:b}:b))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#l}get visible(){return this.c(),this.#c}_updateViewState(b){this.#u||(this.active!==b.active||this.visible!==b.visible||this.viewColumn!==b.viewColumn)&&(this.#l=b.active,this.#c=b.visible,this.#o=b.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(b,a){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof b>"u"?void 0:O.ViewColumn.from(b),preserveFocus:!!a})}c(){if(this.#u)throw new Error("Webview is disposed")}}class E extends h.$Xc{static c(){return(0,A.$5g)()}constructor(b,a,$){super(),this.j=a,this.m=$,this.g=new Map,this.h=new Map,this.f=b.getProxy(m.$3N.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(b=>b.dispose()),this.g.clear()}createWebviewPanel(b,a,$,p,u={}){const i=typeof p=="object"?p.viewColumn:p,o={viewColumn:O.ViewColumn.from(i),preserveFocus:typeof p=="object"&&!!p.preserveFocus},t=(0,C.$5qc)(b),n=E.c();this.f.$createWebviewPanel((0,C.$7qc)(b),n,a,{title:$,panelOptions:g(u),webviewOptions:(0,C.$8qc)(b,this.m,u),serializeBuffersForPostMessage:t},o);const r=this.j.createNewWebview(n,u,b);return this.createNewWebviewPanel(n,a,$,i,u,r,!0)}$onDidChangeWebviewPanelViewStates(b){const a=Object.keys(b);a.sort(($,p)=>{const u=b[$],i=b[p];return u.active?1:i.active?-1:+u.visible-+i.visible});for(const $ of a){const p=this.getWebviewPanel($);if(!p)continue;const u=b[$];p._updateViewState({active:u.active,visible:u.visible,viewColumn:O.ViewColumn.to(u.position)})}}async $onDidDisposeWebviewPanel(b){this.getWebviewPanel(b)?.dispose(),this.g.delete(b),this.j.deleteWebview(b)}registerWebviewPanelSerializer(b,a,$){if(this.h.has(a))throw new Error(`Serializer for '${a}' already registered`);return this.h.set(a,{serializer:$,extension:b}),this.f.$registerSerializer(a,{serializeBuffersForPostMessage:(0,C.$5qc)(b)}),new c.$5N(()=>{this.h.delete(a),this.f.$unregisterSerializer(a)})}async $deserializeWebviewPanel(b,a,$,p){const u=this.h.get(a);if(!u)throw new Error(`No serializer found for '${a}'`);const{serializer:i,extension:o}=u,t=this.j.createNewWebview(b,$.webviewOptions,o),n=this.createNewWebviewPanel(b,a,$.title,p,$.panelOptions,t,$.active);await i.deserializeWebviewPanel(n,$.state)}createNewWebviewPanel(b,a,$,p,u,i,o){const t=new I(b,this.f,i,{viewType:a,title:$,viewColumn:p,panelOptions:u,active:o});return this.g.set(b,t),t}getWebviewPanel(b){return this.g.get(b)}}e.$9qc=E;function g(P){return{enableFindWidget:P.enableFindWidget,retainContextWhenHidden:P.retainContextWhenHidden}}}),define(Re[325],Ce([1,0,4,3,97,15,6,9]),function(ge,e,s,h,R,A,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ksc=void 0,O=Ue(O),C=Ue(C);class m extends h.$Xc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(E,g,P,b,a,$){super(),this.#s=!1,this.#l=this.B(new s.$oe),this.onDidChangeVisibility=this.#l.event,this.#u=this.B(new s.$oe),this.onDidDispose=this.#u.event,this.#i=P,this.#a=b,this.#e=E,this.#t=g,this.#n=a,this.#r=$}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#l;#u;get title(){return this.a(),this.#a}set title(E){this.a(),this.#a!==E&&(this.#a=E,this.#t.$setWebviewViewTitle(this.#e,E))}get description(){return this.a(),this.#o}set description(E){this.a(),this.#o!==E&&(this.#o=E,this.#t.$setWebviewViewDescription(this.#e,E))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(E){E===this.#r||this.#s||(this.#r=E,this.#l.fire())}get badge(){return this.a(),this.#c}set badge(E){this.a(),!(E?.value===this.#c?.value&&E?.tooltip===this.#c?.tooltip)&&(this.#c=A.ViewBadge.from(E),this.#t.$setWebviewViewBadge(this.#e,E))}show(E){this.a(),this.#t.$show(this.#e,!!E)}a(){if(this.#s)throw new Error("Webview is disposed")}}class c{constructor(E,g){this.d=g,this.b=new Map,this.c=new Map,this.a=E.getProxy(O.$3N.MainThreadWebviewViews)}registerWebviewViewProvider(E,g,P,b){if(this.b.has(g))throw new Error(`View provider for '${g}' already registered`);return this.b.set(g,{provider:P,extension:E}),this.a.$registerWebviewViewProvider((0,R.$7qc)(E),g,{retainContextWhenHidden:b?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,R.$5qc)(E)}),new C.$5N(()=>{this.b.delete(g),this.a.$unregisterWebviewViewProvider(g)})}async $resolveWebviewView(E,g,P,b,a){const $=this.b.get(g);if(!$)throw new Error(`No view provider found for '${g}'`);const{provider:p,extension:u}=$,i=this.d.createNewWebview(E,{},u),o=new m(E,this.a,g,P,i,!0);this.c.set(E,o),await p.resolveWebviewView(o,{state:b},a)}async $onDidChangeWebviewViewVisibility(E,g){this.e(E)._setVisible(g)}async $disposeWebviewView(E){const g=this.e(E);this.c.delete(E),g.dispose(),this.d.deleteWebview(E)}e(E){const g=this.c.get(E);if(!g)throw new Error("No webview found");return g}}e.$Ksc=c}),define(Re[326],Ce([1,0,77,14,11,229,27,10]),function(ge,e,s,h,R,A,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qtc=void 0;let m=class{constructor(E,g){E.addFileSystemProvider(h.Schemas.file,new c(g),{isCaseSensitive:C.$l})}};e.$qtc=m,e.$qtc=m=Ze([qe(0,s.$1qc),qe(1,R.$dk)],m);class c{constructor(E){this.b=E,this.a=new A.$zr(this.b)}async stat(E){const g=await this.a.stat(E);return{type:g.type,ctime:g.ctime,mtime:g.mtime,size:g.size,permissions:g.permissions===O.FilePermission.Readonly?1:void 0}}readDirectory(E){return this.a.readdir(E)}createDirectory(E){return this.a.mkdir(E)}readFile(E){return this.a.readFile(E)}writeFile(E,g,P){return this.a.writeFile(E,g,{...P,unlock:!1,atomic:!1})}delete(E,g){return this.a.delete(E,{...g,useTrash:!1,atomic:!1})}rename(E,g,P){return this.a.rename(E,g,P)}copy(E,g,P){return this.a.copy(E,g,P)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(E,g){throw new Error("Method not implemented.")}}}),define(Re[327],Ce([1,0,16,68,32,34,3,6,2,19]),function(ge,e,s,h,R,A,O,C,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$otc=void 0;let I=class extends O.$Xc{constructor(g,P){super();const b=g.getProxy(C.$3N.MainThreadDownloadService);P.registerCommand(!1,"_workbench.downloadResource",async a=>{const $=m.URI.file((0,s.$mc)((0,h.tmpdir)(),(0,R.$5g)()));return await b.$download(a,$),$})}};e.$otc=I,e.$otc=I=Ze([qe(0,c.$DQ),qe(1,A.$ZQ)],I)}),define(Re[328],Ce([1,0,45,16,2,98,3,14,7,33]),function(ge,e,s,h,R,A,O,C,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Atc=void 0,s=Ue(s),h=Ue(h);class I extends A.$3qc{constructor(){super(...arguments),this.i=null}async g(n){const r=await super.g(n);if(r.scheme!==C.Schemas.file)return r;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${r.fsPath}.`),r;const d=r.fsPath;let l=0;do{let f;l===0?f=d:f=/[/\\]$/.test(d)?`${d.substr(0,d.length-1)}-${l}`:`${d}-${l}`,await E(f);const y=h.$mc(f,"vscode.lock"),k=await a(this.d,y,!1);if(k)return this.i=k,process.on("exit",()=>{k.dispose()}),R.URI.file(f);l++}while(l<10);return r}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$Atc=I;async function E(t){try{await s.promises.stat(t);return}catch{}try{await s.promises.mkdir(t,{recursive:!0})}catch{}}const g=1e3,P=10*60*1e3;class b extends O.$Xc{constructor(n,r){super(),this.b=n,this.c=r,this.a=this.B(new m.$Th),this.a.cancelAndSet(async()=>{const d=await $(n,r);(!d||d.pid!==process.pid)&&(n.info(`Lock '${r}': The lock was lost unexpectedly.`),this.a.cancel());try{await s.promises.utimes(r,new Date,new Date)}catch(l){n.error(l),n.info(`Lock '${r}': Could not update mtime.`)}},g)}dispose(){super.dispose();try{s.unlinkSync(this.c)}catch{}}async setWillRelease(n){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${n} ms.`);try{const r={pid:process.pid,willReleaseAt:Date.now()+n};await c.Promises.writeFile(this.c,JSON.stringify(r),{flag:"w"})}catch(r){this.b.error(r)}}}async function a(t,n,r){try{const l={pid:process.pid,willReleaseAt:0};await c.Promises.writeFile(n,JSON.stringify(l),{flag:"wx"})}catch(l){t.error(l)}const d=await $(t,n);return!d||d.pid!==process.pid?r?(t.info(`Lock '${n}': Could not acquire lock, giving up.`),null):(t.info(`Lock '${n}': Could not acquire lock, checking if the file is stale.`),i(t,n)):(t.info(`Lock '${n}': Lock acquired.`),new b(t,n))}async function $(t,n){let r;try{r=await s.promises.readFile(n)}catch(d){return t.error(d),null}try{return JSON.parse(String(r))}catch(d){return t.error(d),null}}async function p(t,n){let r;try{r=await s.promises.stat(n)}catch(d){return t.error(d),0}return r.mtime.getTime()}function u(t){try{return process.kill(t,0),!0}catch{return!1}}async function i(t,n){const r=await $(t,n);if(!r)return t.info(`Lock '${n}': Could not read pid of lock holder.`),o(t,n);if(r.willReleaseAt){let k=r.willReleaseAt-Date.now();if(k<5e3){for(k>0?t.info(`Lock '${n}': The lockfile is scheduled to be released in ${k} ms.`):t.info(`Lock '${n}': The lockfile is scheduled to have been released.`);k>0;){if(await(0,m.$Jh)(Math.min(100,k)),await p(t,n)===0)return o(t,n);k=r.willReleaseAt-Date.now()}return o(t,n)}}if(!u(r.pid))return t.info(`Lock '${n}': The pid ${r.pid} appears to be gone.`),o(t,n);const d=await p(t,n),l=Date.now()-d;if(l<=P)return t.info(`Lock '${n}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null;t.info(`Lock '${n}': The lock looks stale, waiting for 2s.`),await(0,m.$Jh)(2e3);const f=await p(t,n),y=Date.now()-f;return y<=P?(t.info(`Lock '${n}': The lock does not look stale, elapsed: ${y} ms, giving up.`),null):(t.info(`Lock '${n}': The lock looks stale even after waiting for 2s.`),o(t,n))}async function o(t,n){t.info(`Lock '${n}': Deleting a stale lock.`);try{await s.promises.unlink(n)}catch{}return a(t,n,!0)}}),define(Re[329],Ce([1,0,32,19,48,34]),function(ge,e,s,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Usc=void 0;let O=class extends R.$mrc{constructor(m,c){super(!0,m,c)}createTerminal(m,c,I){return this.createTerminalFromOptions({name:m,shellPath:c,shellArgs:I})}createTerminalFromOptions(m,c){const I=new R.$lrc(this.a,(0,s.$5g)(),m,m.name);return this.f.push(I),I.create(m,this.R(m,c)),I.value}};e.$Usc=O,e.$Usc=O=Ze([qe(0,A.$ZQ),qe(1,h.$DQ)],O)}),define(Re[330],Ce([1,0,4,37,36,5]),function(ge,e,s,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mN=e.$lN=e.OutputChannelUpdateMode=e.$kN=e.$jN=e.$iN=e.$hN=e.$gN=e.$fN=e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=e.$_M=void 0,e.$_M="text/x-code-output",e.$aN="Log",e.$bN="text/x-code-log-output",e.$cN="log",e.$dN="workbench.panel.output",e.$eN=new R.$Zj("inOutput",!1),e.$fN=new R.$Zj("activeLogOutput",!1),e.$gN=new R.$Zj("activeLogOutput.levelSettable",!1),e.$hN=new R.$Zj("activeLogOutput.level",""),e.$iN=new R.$Zj("activeLogOutput.levelIsDefault",!1),e.$jN=new R.$Zj("outputView.scrollLock",!1),e.$kN=(0,A.$Ii)("outputService");var O;(function(m){m[m.Append=1]="Append",m[m.Replace=2]="Replace",m[m.Clear=3]="Clear"})(O||(e.OutputChannelUpdateMode=O={})),e.$lN={OutputChannels:"workbench.contributions.outputChannels"};class C{constructor(){this.a=new Map,this.b=new s.$oe,this.onDidRegisterChannel=this.b.event,this.c=new s.$oe,this.onDidRemoveChannel=this.c.event}registerChannel(c){this.a.has(c.id)||(this.a.set(c.id,c),this.b.fire(c.id))}getChannels(){const c=[];return this.a.forEach(I=>c.push(I)),c}getChannel(c){return this.a.get(c)}removeChannel(c){this.a.delete(c),this.c.fire(c)}}h.$vo.add(e.$lN.OutputChannels,new C),e.$mN=new R.$Zj("activeOutputChannel","")}),define(Re[172],Ce([1,0,6,5,19,23,11,330,77,29,64,214,21,17,27,4,3]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P,b,a,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$osc=e.$nsc=void 0;class p extends O.$jk{get disposed(){return this.n}constructor(t,n,r,d,l){super(),this.id=t,this.name=n,this.r=r,this.s=d,this.extension=l,this.m=0,this.n=!1,this.visible=!1,this.setLevel(r.getLevel()),this.B(r.onDidChangeLogLevel(f=>this.setLevel(f)))}get logLevel(){return this.getLevel()}appendLine(t){this.append(t+`
`)}append(t){this.info(t)}clear(){const t=this.m;this.r.flush(),this.s.$update(this.id,C.OutputChannelUpdateMode.Clear,t)}replace(t){const n=this.m;this.info(t),this.s.$update(this.id,C.OutputChannelUpdateMode.Replace,n),this.visible&&this.r.flush()}show(t,n){this.r.flush(),this.s.$reveal(this.id,!!(typeof t=="boolean"?t:n))}hide(){this.s.$close(this.id)}g(t,n){this.m+=g.$Qe.fromString(n).byteLength,(0,O.log)(this.r,t,n),this.visible&&(this.r.flush(),this.s.$update(this.id,C.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class u extends p{appendLine(t){this.append(t)}}let i=class{constructor(t,n,r,d,l,f){this.i=n,this.j=r,this.k=d,this.l=l,this.m=f,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=t.getProxy(s.$3N.MainThreadOutputService),this.b=this.k.extUri.joinPath(n.logsLocation,`output_logging_${(0,E.$8m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(t){this.h=t;for(const[n,r]of this.g)r.visible=n===this.h}createOutputChannel(t,n,r){if(t=t.trim(),!t)throw new Error("illegal argument `name`. must not be falsy");const d=typeof n=="object"&&n.log,l=(0,P.$hg)(n)?n:void 0;if((0,P.$hg)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let f;const y=this.i.environment.extensionLogLevel?.find(([S])=>A.$vn.equals(r.identifier,S))?.[1];y&&(f=(0,O.$uk)(y));const k=d?this.o(t,f,r):this.n(t,l,r);return k.then(S=>{this.g.set(S.id,S),S.visible=S.id===this.h}),d?this.r(t,f??this.m.getLevel(),k):this.q(t,k)}async n(t,n,r){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const d=await this.c,l=this.k.extUri.joinPath(d,`${this.f++}-${t.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),f=this.l.createLogger(l,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),y=await this.a.$register(t,l,n,r.identifier.value);return new p(y,t,f,this.a,r)}async o(t,n,r){const d=await this.p(r),l=t.replace(/[\\/:\*\?"<>\|]/g,""),f=this.k.extUri.joinPath(d,`${l}.log`),y=`${r.identifier.value}.${l}`,k=this.l.createLogger(f,{id:y,name:t,logLevel:n,extensionId:r.identifier.value});return new u(y,t,k,this.a,r)}p(t){let n=this.d.get(t.identifier.value);if(!n){const r=this.k.extUri.joinPath(this.i.logsLocation,t.identifier.value);this.d.set(t.identifier.value,n=(async()=>{try{await this.j.value.createDirectory(r)}catch(d){if((0,b.$tl)(d)!==b.FileSystemProviderErrorCode.FileExists)throw d}return r})())}return n}q(t,n){let r=!1;const d=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return t},append(l){d(),n.then(f=>f.append(l))},appendLine(l){d(),n.then(f=>f.appendLine(l))},clear(){d(),n.then(l=>l.clear())},replace(l){d(),n.then(f=>f.replace(l))},show(l,f){d(),n.then(y=>y.show(l,f))},hide(){d(),n.then(l=>l.hide())},dispose(){r=!0,n.then(l=>l.dispose())}}}r(t,n,r){const d=new $.$Wc,l=()=>{if(d.isDisposed)throw new Error("Channel has been closed")},f=d.add(new a.$oe);function y(k){n=k,f.fire(k)}return r.then(k=>{d.add(k),k.logLevel!==n&&y(k.logLevel),d.add(k.onDidChangeLogLevel(S=>y(S)))}),{...this.q(t,r),get logLevel(){return n},onDidChangeLogLevel:f.event,trace(k,...S){l(),r.then(D=>D.trace(k,...S))},debug(k,...S){l(),r.then(D=>D.debug(k,...S))},info(k,...S){l(),r.then(D=>D.info(k,...S))},warn(k,...S){l(),r.then(D=>D.warn(k,...S))},error(k,...S){l(),r.then(D=>D.error(k,...S))},dispose(){d.dispose()}}}};e.$nsc=i,e.$nsc=i=Ze([qe(0,R.$DQ),qe(1,c.$TQ),qe(2,m.$1qc),qe(3,I.$Dqc),qe(4,O.$ek),qe(5,O.$dk)],i),e.$osc=(0,h.$Ii)("IExtHostOutputService")}),define(Re[173],Ce([1,0,5,7]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=e.$Zm=void 0,e.$Zm=(0,s.$Ii)("remoteAgentService"),e.$1m=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(R){let A=1/0;for(let C=0;C<this.maxSampleCount;C++){const m=await R.getRoundTripTime();if(m===void 0)return;A=Math.min(A,m/2),await(0,h.$Jh)(this.sampleDelay)}this.average.push(A),this.average.length>this.maxAverageCount&&this.average.shift();let O;return this.initial.length<this.maxInitialCount?this.initial.push(A):O=this.initial.reduce((C,m)=>C+m,0)/this.initial.length,this.lastMeasurement={initial:O,current:A,average:this.average.reduce((C,m)=>C+m,0)/this.average.length,high:typeof O>"u"?!1:A>this.highLatencyMaxThreshold||A>this.highLatencyMinThreshold&&A>O*this.highLatencyMultiple},this.lastMeasurement}}}),define(Re[331],Ce([1,0,8,72,37,47,46,3,4,173,10,24,7,153]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=void 0,e.$vL=Object.freeze({id:"application",order:100,title:(0,s.localize)(3975,null),type:"object"}),e.$wL=Object.freeze({id:"workbench",order:7,title:(0,s.localize)(3976,null),type:"object"}),e.$xL=Object.freeze({id:"security",scope:h.ConfigurationScope.APPLICATION,title:(0,s.localize)(3977,null),type:"object",order:7}),e.$yL=Object.freeze({id:"problems",title:(0,s.localize)(3978,null),type:"object",order:101}),e.$zL=Object.freeze({id:"window",order:8,title:(0,s.localize)(3979,null),type:"object"}),e.$AL={ConfigurationMigration:"base.contributions.configuration.migration"};class b{constructor(){this.migrations=[],this.a=new m.$oe,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(o){this.migrations.push(...o)}}const a=new b;R.$vo.add(e.$AL.ConfigurationMigration,a);let $=class extends C.$Xc{static{this.ID="workbench.contrib.configurationMigration"}constructor(o,t){super(),this.a=o,this.b=t,this.B(this.b.onDidChangeWorkspaceFolders(async n=>{for(const r of n.added)await this.f(r,a.migrations)})),this.c(a.migrations),this.B(a.onDidRegisterConfigurationMigration(n=>this.c(n)))}async c(o){await this.f(void 0,o);for(const t of this.b.getWorkspace().folders)await this.f(t,o)}async f(o,t){await Promise.all([t.map(n=>this.g(n,o?.uri))])}async g(o,t){const n=this.a.inspect(o.key,{resource:t}),r=this.b.getWorkbenchState()===A.WorkbenchState.WORKSPACE?[["user",O.ConfigurationTarget.USER],["userLocal",O.ConfigurationTarget.USER_LOCAL],["userRemote",O.ConfigurationTarget.USER_REMOTE],["workspace",O.ConfigurationTarget.WORKSPACE],["workspaceFolder",O.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",O.ConfigurationTarget.USER],["userLocal",O.ConfigurationTarget.USER_LOCAL],["userRemote",O.ConfigurationTarget.USER_REMOTE],["workspace",O.ConfigurationTarget.WORKSPACE]];for(const[d,l]of r){const f=n[d];if(!f)continue;const y=[];if(f.value!==void 0){const k=await this.h(o,d,f.value,t,void 0);for(const S of k??[])y.push([S,[]])}for(const{identifiers:k,value:S}of f.overrides??[])if(S!==void 0){const D=await this.h(o,d,S,t,k);for(const T of D??[])y.push([T,k])}y.length&&await Promise.allSettled(y.map(async([[k,S],D])=>this.a.updateValue(k,S.value,{resource:t,overrideIdentifiers:D},l)))}}async h(o,t,n,r,d){const l=y=>{const S=this.a.inspect(y,{resource:r})[t];if(S)return d?S.overrides?.find(({identifiers:D})=>(0,E.$mo)(D,d))?.value:S.value},f=await o.migrateFn(n,l);return Array.isArray(f)?f:[[o.key,f]]}};e.$BL=$,e.$BL=$=Ze([qe(0,O.$cj),qe(1,A.$Ri)],$);let p=class extends C.$Xc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(o){super(),this.b=o,this.a=new g.$6h,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!I.$j&&(await this.b.getEnvironment())?.os!==I.OperatingSystem.Windows)return;R.$vo.as(h.$Ao.Configuration).registerConfiguration({...e.$xL,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,s.localize)(3980,null)},default:[],markdownDescription:(0,s.localize)(3981,null),scope:h.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,s.localize)(3982,null),scope:h.ConfigurationScope.MACHINE}}})}};e.$CL=p,e.$CL=p=Ze([qe(0,c.$Zm)],p),e.$DL="window.newWindowProfile";let u=class extends C.$Xc{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(o,t){super(),this.c=o,this.f=t,this.g(),this.B(this.c.onDidChangeProfiles(n=>this.g())),this.h(),this.j(),this.B(t.onDidChangeConfiguration(n=>{n.source!==O.ConfigurationTarget.DEFAULT&&n.affectsConfiguration(e.$DL)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const o=R.$vo.as(h.$Ao.Configuration),t={...e.$zL,properties:{[e.$DL]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(n=>n.name),null],enumItemLabels:[...this.c.profiles.map(n=>""),(0,s.localize)(3983,null)],description:(0,s.localize)(3984,null),scope:h.ConfigurationScope.APPLICATION}}};this.a?o.updateConfigurations({add:[t],remove:[this.a]}):o.registerConfiguration(t),this.a=t}h(){const o=this.f.getValue(e.$DL);this.b=o?this.c.profiles.find(t=>t.name===o):void 0}j(){const o=this.f.getValue(e.$DL);if(!o)return;const t=this.b?this.c.profiles.find(n=>n.id===this.b.id):void 0;o!==t?.name&&this.f.updateValue(e.$DL,t?.name)}};e.$EL=u,e.$EL=u=Ze([qe(0,P.$Pl),qe(1,O.$cj)],u)}),define(Re[332],Ce([1,0,39,14,16,22,8,331,72,5,37]),function(ge,e,s,h,R,A,O,C,m,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$GL=e.$FL=void 0,e.$HL=a,e.$IL=$,s=Ue(s),e.$FL=(0,c.$Ii)("editorResolverService"),e.$GL="workbench.editorAssociations";const E=I.$vo.as(m.$Ao.Configuration),g={...C.$wL,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,O.localize)(12209,null),additionalProperties:{type:"string"}}}};E.registerConfiguration(g);var P;(function(p){p.builtin="builtin",p.option="option",p.exclusive="exclusive",p.default="default"})(P||(e.RegisteredEditorPriority=P={}));var b;(function(p){p[p.ABORT=1]="ABORT",p[p.NONE=2]="NONE"})(b||(e.ResolvedStatus=b={}));function a(p){switch(p){case P.exclusive:return 5;case P.default:return 4;case P.builtin:return 3;case P.option:default:return 1}}function $(p,u){if(new Set([h.Schemas.extension,h.Schemas.webviewPanel,h.Schemas.vscodeWorkspaceTrust,h.Schemas.vscodeSettings]).has(u.scheme))return!1;const t=typeof p=="string"&&p.indexOf(R.$jc.sep)>=0?`${u.scheme}:${u.path}`:(0,A.$gh)(u);return s.$Ck(typeof p=="string"?p.toLowerCase():p,t.toLowerCase())}}),define(Re[333],Ce([1,0,31,14,16,10,22,2,5,248,47,161,173]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$FN=e.$EN=void 0,e.$EN=(0,m.$Ii)("pathService");let b=P=class{constructor($,p,u,i){this.d=$,this.e=p,this.f=u,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||A.OS)(),this.b=(async()=>{const o=await this.e.getEnvironment();return this.c=o?.userHome??$})()}hasValidBasename($,p,u){return typeof p=="string"||typeof p>"u"?this.a.then(i=>this.h($,i,p)):this.h($,p,u)}h($,p,u){return $.scheme===h.Schemas.file||$.scheme===h.Schemas.vscodeRemote?(0,s.$Fg)(u??(0,O.$gh)($),p===A.OperatingSystem.Windows):!0}get defaultUriScheme(){return P.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme($,p){if($.remoteAuthority)return h.Schemas.vscodeRemote;const u=(0,c.$BN)(p.getWorkspace());if(u)return u;const i=p.getWorkspace().folders[0];if(i)return i.uri.scheme;const o=p.getWorkspace().configuration;return o?o.scheme:h.Schemas.file}userHome($){return $?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then($=>$===A.OperatingSystem.Windows?R.$ic:R.$jc)}async fileURI($){let p="";if(await this.a===A.OperatingSystem.Windows&&($=$.replace(/\\/g,"/")),$[0]==="/"&&$[1]==="/"){const i=$.indexOf("/",2);i===-1?(p=$.substring(2),$="/"):(p=$.substring(2,i),$=$.substring(i)||"/")}return C.URI.from({scheme:h.Schemas.file,authority:p,path:$,query:"",fragment:""})}};e.$FN=b,e.$FN=b=P=Ze([qe(1,g.$Zm),qe(2,E.$nN),qe(3,I.$Ri)],b)}),define(Re[334],Ce([1,0,8,60,4,61,3,2,46,218,11,73,154,93,47,161,25,20,17,24,36]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P,b,a,$,p,u,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yN=e.$xN=e.OnPortForward=e.$sN=e.$rN=e.TunnelSource=e.TunnelCloseReason=e.$pN=e.$oN=void 0,e.$qN=l,e.$tN=k,e.$uN=S,e.$vN=D,e.$wN=v,s=Ue(s);const t=10*1e3,n="remote.tunnels.toRestore",r="remote.tunnels.toRestoreExpiration",d=1e3*60*60*24*14;e.$oN="onTunnel",e.$pN=new o.$Zj("forwardedPortsViewEnabled",!1,s.localize(12592,null));function l(L){const N=L.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(N)return{host:N[1]?.substring(0,N[1].length-1)||"localhost",port:Number(N[2])}}var f;(function(L){L.Other="Other",L.User="User",L.AutoForwardEnd="AutoForwardEnd"})(f||(e.TunnelCloseReason=f={}));var y;(function(L){L[L.User=0]="User",L[L.Auto=1]="Auto",L[L.Extension=2]="Extension"})(y||(e.TunnelSource=y={})),e.$rN={source:y.User,description:s.localize(12593,null)},e.$sN={source:y.Auto,description:s.localize(12594,null)};function k(L,N,F){const V=L.get(D(N,F));if(V)return V;if((0,P.$Rw)(N))for(const j of P.$Qw){const U=D(j,F);if(L.has(U))return L.get(U)}else if((0,P.$Tw)(N))for(const j of P.$Sw){const U=D(j,F);if(L.has(U))return L.get(U)}}function S(L,N,F){const V=k(L,N,F);if(V)return V;const j=(0,P.$Tw)(N)?"localhost":(0,P.$Rw)(N)?"0.0.0.0":void 0;if(j)return k(L,j,F)}function D(L,N){return L+":"+N}var T;(function(L){L.Notify="notify",L.OpenBrowser="openBrowser",L.OpenBrowserOnce="openBrowserOnce",L.OpenPreview="openPreview",L.Silent="silent",L.Ignore="ignore"})(T||(e.OnPortForward=T={}));function v(L){return L&&"host"in L&&typeof L.host=="string"&&"port"in L&&typeof L.port=="number"&&(!("detail"in L)||typeof L.detail=="string")&&(!("pid"in L)||typeof L.pid=="string")}class w extends O.$Xc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(N){super(),this.r=N,this.j=[],this.n=new R.$oe,this.onDidChangeAttributes=this.n.event,this.B(N.onDidChangeConfiguration(F=>{(F.affectsConfiguration(w.c)||F.affectsConfiguration(w.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(N,F,V){let j=this.w(N,F,V,this.j,0);const U={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;j>=0;){const z=this.j[j];z.key===N?(U.onAutoForward=z.onAutoForward??U.onAutoForward,U.elevateIfNeeded=z.elevateIfNeeded!==void 0?z.elevateIfNeeded:U.elevateIfNeeded,U.label=z.label??U.label,U.requireLocalPort=z.requireLocalPort,U.protocol=z.protocol):(U.onAutoForward=U.onAutoForward??z.onAutoForward,U.elevateIfNeeded=U.elevateIfNeeded!==void 0?U.elevateIfNeeded:z.elevateIfNeeded,U.label=U.label??z.label,U.requireLocalPort=U.requireLocalPort!==void 0?U.requireLocalPort:void 0,U.protocol=U.protocol??z.protocol),j=this.w(N,F,V,this.j,j+1)}return U.onAutoForward!==void 0||U.elevateIfNeeded!==void 0||U.label!==void 0||U.requireLocalPort!==void 0||U.protocol!==void 0?U:this.C()}t(N){return N.start!==void 0&&N.end!==void 0}u(N){return N.host!==void 0&&N.port!==void 0&&(0,u.$hg)(N.host)&&(0,u.$lg)(N.port)}w(N,F,V,j,U){if(U>=j.length)return-1;const z=!(0,P.$Rw)(F)&&!(0,P.$Tw)(F),W=j.slice(U).findIndex(B=>(0,u.$lg)(B.key)?z?!1:B.key===N:this.t(B.key)?z?!1:N>=B.key.start&&N<=B.key.end:this.u(B.key)?N===B.key.port&&F===B.key.host:V?B.key.test(V):!1);return W>=0?W+U:-1}y(){const N=this.r.getValue(w.c);if(!N||!(0,u.$jg)(N))return[];const F=[];for(const j in N){if(j===void 0)continue;const U=N[j];let z;if(Number(j))z=Number(j);else if((0,u.$hg)(j))if(w.g.test(j)){const _=j.match(w.g);z={start:Number(_[1]),end:Number(_[2])}}else if(w.h.test(j)){const _=j.match(w.h);z={host:_[1],port:Number(_[2])}}else{let _;try{_=RegExp(j)}catch{}_&&(z=_)}z&&F.push({key:z,elevateIfNeeded:U.elevateIfNeeded,onAutoForward:U.onAutoForward,label:U.label,requireLocalPort:U.requireLocalPort,protocol:U.protocol})}const V=this.r.getValue(w.f);return V&&(this.m={elevateIfNeeded:V.elevateIfNeeded,label:V.label,onAutoForward:V.onAutoForward,requireLocalPort:V.requireLocalPort,protocol:V.protocol}),this.z(F)}z(N){function F(V,j){return(0,u.$lg)(V.key)?V.key:j.t(V.key)?V.key.start:j.u(V.key)?V.key.port:Number.MAX_VALUE}return N.sort((V,j)=>F(V,this)-F(j,this))}C(){return this.m}static providedActionToAction(N){switch(N){case P.ProvidedOnAutoForward.Notify:return T.Notify;case P.ProvidedOnAutoForward.OpenBrowser:return T.OpenBrowser;case P.ProvidedOnAutoForward.OpenBrowserOnce:return T.OpenBrowserOnce;case P.ProvidedOnAutoForward.OpenPreview:return T.OpenPreview;case P.ProvidedOnAutoForward.Silent:return T.Silent;case P.ProvidedOnAutoForward.Ignore:return T.Ignore;default:return}}async addAttributes(N,F,V){const U=this.r.inspect(w.c).userRemoteValue;let z;!U||!(0,u.$jg)(U)?z={}:z=(0,i.$io)(U),z[`${N}`]||(z[`${N}`]={});for(const _ in F)z[`${N}`][_]=F[_];return this.r.updateValue(w.c,z,V)}}e.$xN=w;let M=class extends O.$Xc{constructor(N,F,V,j,U,z,_,W,B,Y){super(),this.H=N,this.I=F,this.J=V,this.L=j,this.M=U,this.N=z,this.O=_,this.P=W,this.Q=B,this.R=Y,this.c=new Map,this.g=new R.$oe,this.onForwardPort=this.g.event,this.h=new R.$oe,this.onClosePort=this.h.event,this.j=new R.$oe,this.onPortName=this.j.event,this.n=new R.$oe,this.onCandidatesChanged=this.n.event,this.t=new R.$oe,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new R.$oe,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new w(V),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async x=>{const oe=await this.getAttributes(x.map(ie=>({port:ie.tunnelRemotePort,host:ie.tunnelRemoteHost})));for(const ie of x)if(ie.localAddress){const me=D(ie.tunnelRemoteHost,ie.tunnelRemotePort),ue=S(this.m??new Map,ie.tunnelRemoteHost,ie.tunnelRemotePort);this.forwarded.set(me,{remotePort:ie.tunnelRemotePort,remoteHost:ie.tunnelRemoteHost,localAddress:ie.localAddress,protocol:oe?.get(ie.tunnelRemotePort)?.protocol??P.TunnelProtocol.Http,localUri:await this.X(ie.localAddress,oe?.get(ie.tunnelRemotePort)),localPort:ie.tunnelLocalPort,name:oe?.get(ie.tunnelRemotePort)?.label,runningProcess:ue?.detail,hasRunningProcess:!!ue,pid:ue?.pid,privacy:ie.privacy,source:e.$rN}),this.f.set(me,ie)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async x=>{const oe=D(x.tunnelRemoteHost,x.tunnelRemotePort);if(!S(this.forwarded,x.tunnelRemoteHost,x.tunnelRemotePort)&&!S(this.detected,x.tunnelRemoteHost,x.tunnelRemotePort)&&!S(this.c,x.tunnelRemoteHost,x.tunnelRemotePort)&&x.localAddress){const ie=S(this.m??new Map,x.tunnelRemoteHost,x.tunnelRemotePort),me=(await this.getAttributes([{port:x.tunnelRemotePort,host:x.tunnelRemoteHost}]))?.get(x.tunnelRemotePort);this.forwarded.set(oe,{remoteHost:x.tunnelRemoteHost,remotePort:x.tunnelRemotePort,localAddress:x.localAddress,protocol:me?.protocol??P.TunnelProtocol.Http,localUri:await this.X(x.localAddress,me),localPort:x.tunnelLocalPort,name:me?.label,closeable:!0,runningProcess:ie?.detail,hasRunningProcess:!!ie,pid:ie?.pid,privacy:x.privacy,source:e.$rN})}await this.cb(),this.f.set(oe,x),this.g.fire(this.forwarded.get(oe))})),this.B(this.H.onTunnelClosed(x=>this.W(x,f.Other))),this.U()}S(){return this.Q.extensions.find(N=>N.activationEvents?.includes(e.$oN))?(this.R.createKey(e.$pN.key,!0),!0):!1}U(){if(this.S())return;const N=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&N.dispose()}))}async W(N,F){const V=D(N.host,N.port);this.forwarded.has(V)&&(this.forwarded.delete(V),await this.cb(),this.h.fire(N))}X(N,F){if(N.startsWith("http"))return C.URI.parse(N);const V=F?.protocol??"http";return C.URI.parse(`${V}://${N}`)}async Y(N){const F=this.N.getWorkspace(),V=F.configuration?(0,A.$wj)(F.configuration.path):F.folders.length>0?(0,A.$wj)(F.folders[0].uri.path):void 0;if(V===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${N}.${this.L.remoteAuthority}.${V}`}async Z(){return this.Y(n)}async $(){return this.Y(r)}async ab(){const N=this.I.get(n,g.StorageScope.WORKSPACE);if(N)return this.I.remove(n,g.StorageScope.WORKSPACE),await this.cb(),N;const F=await this.Z();if(F)return this.I.get(F,g.StorageScope.PROFILE)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const N=await this.s;if(N&&N!==this.y){const F=JSON.parse(N)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${F.map(V=>V.remotePort).join(", ")}`);for(const V of F){const j=S(this.detected,V.remoteHost,V.remotePort);V.source.source!==y.Extension&&!j||V.source.source===y.Extension&&j?await this.fb({remote:{host:V.remoteHost,port:V.remotePort},local:V.localPort,name:V.name,elevateIfNeeded:!0,source:V.source}):V.source.source===y.Extension&&!j&&this.D.set(D(V.remoteHost,V.remotePort),V)}}}if(this.z=!0,this.C.fire(),!this.w){const N=await this.Z();this.w=this.B(new O.$Wc),this.w.add(this.I.onDidChangeValue(g.StorageScope.PROFILE,void 0,this.w)(async F=>{F.key===N&&(this.s=Promise.resolve(this.I.get(N,g.StorageScope.PROFILE)),await this.restoreForwarded())}))}}bb(){const N=this.I.keys(g.StorageScope.PROFILE,g.StorageTarget.USER).filter(F=>F.startsWith(r));for(const F of N){const V=this.I.getNumber(F,g.StorageScope.PROFILE);if(V&&V<Date.now()){this.s=Promise.resolve(void 0);const j=F.replace(r,n);this.I.remove(F,g.StorageScope.PROFILE),this.I.remove(j,g.StorageScope.PROFILE)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const N=Array.from(this.forwarded.values()),F=N.map(z=>({remoteHost:z.remoteHost,remotePort:z.remotePort,localPort:z.localPort,name:z.name,localAddress:z.localAddress,localUri:z.localUri,protocol:z.protocol,source:z.source}));let V;N.length>0&&(V=JSON.stringify(F));const j=await this.Z(),U=await this.$();!V&&j&&U?(this.I.remove(j,g.StorageScope.PROFILE),this.I.remove(U,g.StorageScope.PROFILE)):V!==this.y&&j&&U&&(this.I.store(j,V,g.StorageScope.PROFILE,g.StorageTarget.USER),this.I.store(U,Date.now()+d,g.StorageScope.PROFILE,g.StorageTarget.USER)),this.y=V}}async eb(N,F,V){if(!N.tunnelLocalPort||!V?.requireLocalPort||N.tunnelLocalPort===F)return;const j=new Date;if(this.db.getTime()+t>j.getTime())return;this.db=j;const U=s.localize(12595,null,F,N.tunnelRemotePort,N.tunnelLocalPort);return this.P.info(U)}async forward(N,F){return!this.z&&this.L.remoteAuthority&&await R.Event.toPromise(this.C.event),this.fb(N,F)}async fb(N,F){await this.Q.activateByEvent(e.$oN);const V=S(this.forwarded,N.remote.host,N.remote.port);F=F??(F!==null?(await this.getAttributes([N.remote]))?.get(N.remote.port):void 0);const j=N.local!==void 0?N.local:N.remote.port;let U;if(V)return this.hb(V,N,F);{const z=this.L.remoteAuthority,_=z?{getAddress:async()=>(await this.M.resolveAuthority(z)).authority}:void 0,W=D(N.remote.host,N.remote.port);this.c.set(W,!0),N=this.gb(W,N);const B=await this.H.openTunnel(_,N.remote.host,N.remote.port,void 0,j,N.elevateIfNeeded?N.elevateIfNeeded:F?.elevateIfNeeded,N.privacy,F?.protocol);if(typeof B=="string")U=B;else if(B&&B.localAddress){const Y=S(this.m??new Map,N.remote.host,N.remote.port),x=B.protocol?B.protocol===P.TunnelProtocol.Https?P.TunnelProtocol.Https:P.TunnelProtocol.Http:F?.protocol??P.TunnelProtocol.Http,oe={remoteHost:B.tunnelRemoteHost,remotePort:B.tunnelRemotePort,localPort:B.tunnelLocalPort,name:F?.label??N.name,closeable:!0,localAddress:B.localAddress,protocol:x,localUri:await this.X(B.localAddress,F),runningProcess:Y?.detail,hasRunningProcess:!!Y,pid:Y?.pid,source:N.source??e.$rN,privacy:B.privacy};return this.forwarded.set(W,oe),this.f.set(W,B),this.c.delete(W),await this.cb(),await this.eb(B,j,F),this.g.fire(oe),B}this.c.delete(W)}return U}gb(N,F){const V=this.D.has(N)?this.D:this.F.has(N)?this.F:void 0;if(V){const j=V.get(N);V.delete(N),j&&(F.name=j.name??F.name,F.local=("local"in j?j.local:"localPort"in j?j.localPort:void 0)??F.local,F.privacy=F.privacy)}return F}async hb(N,F,V){const j=V?.label??F.name;let U;(function(_){_[_.None=0]="None",_[_.Fire=1]="Fire",_[_.Reopen=2]="Reopen"})(U||(U={}));let z=U.None;switch(j!==N.name&&(N.name=j,z=U.Fire),(V?.protocol||N.protocol!==P.TunnelProtocol.Http)&&V?.protocol!==N.protocol&&(F.source=N.source,z=U.Reopen),F.privacy&&N.privacy!==F.privacy&&(z=U.Reopen),z){case U.Fire:{this.g.fire();break}case U.Reopen:await this.close(N.remoteHost,N.remotePort,f.User),await this.fb(F,V)}return S(this.f,F.remote.host,F.remote.port)}async name(N,F,V){const j=S(this.forwarded,N,F),U=D(N,F);if(j){j.name=V,await this.cb(),this.j.fire({host:N,port:F});return}else this.detected.has(U)&&(this.detected.get(U).name=V,this.j.fire({host:N,port:F}))}async close(N,F,V){const j=D(N,F),U=this.forwarded.get(j);return V===f.AutoForwardEnd&&U&&U.source.source===y.Auto&&this.F.set(j,{local:U.localPort,name:U.name,privacy:U.privacy}),await this.H.closeTunnel(N,F),this.W({host:N,port:F},V)}address(N,F){const V=D(N,F);return(this.forwarded.get(V)||this.detected.get(V))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(N){if(N)for(const F of N){const V=S(this.m??new Map,F.remoteAddress.host,F.remoteAddress.port),j=typeof F.localAddress=="string"?F.localAddress:D(F.localAddress.host,F.localAddress.port);this.detected.set(D(F.remoteAddress.host,F.remoteAddress.port),{remoteHost:F.remoteAddress.host,remotePort:F.remoteAddress.port,localAddress:j,protocol:P.TunnelProtocol.Http,localUri:this.X(j),closeable:!1,runningProcess:V?.detail,hasRunningProcess:!!V,pid:V?.pid,privacy:P.TunnelPrivacyId.ConstantPrivate,source:{source:y.Extension,description:s.localize(12596,null)}}),this.H.setEnvironmentTunnel(F.remoteAddress.host,F.remoteAddress.port,j,P.TunnelPrivacyId.ConstantPrivate,P.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(N){this.r=N}async setCandidates(N){let F=N;this.r&&(F=await this.r(N));const V=this.ib(F);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(V.values()).map(j=>j.port).join(", ")}`),this.n.fire(V)}ib(N){const F=this.m??new Map,V=new Map;return this.m=V,N.forEach(j=>{const U=D(j.host,j.port);V.set(U,{host:j.host,port:j.port,detail:j.detail,pid:j.pid}),F.has(U)&&F.delete(U);const z=S(this.forwarded,j.host,j.port);z&&(z.runningProcess=j.detail,z.hasRunningProcess=!0,z.pid=j.pid)}),F.forEach((j,U)=>{const z=l(U);if(!z)return;const _=S(this.forwarded,z.host,z.port);_&&(_.runningProcess=void 0,_.hasRunningProcess=!1,_.pid=void 0);const W=S(this.detected,z.host,z.port);W&&(W.runningProcess=void 0,W.hasRunningProcess=!1,W.pid=void 0)}),F}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const N=Array.from(this.forwarded.values()),F=await this.getAttributes(N.map(V=>({port:V.remotePort,host:V.remoteHost})),!1);if(F)for(const V of N){const j=F.get(V.remotePort);(j?.protocol||V.protocol!==P.TunnelProtocol.Http)&&j?.protocol!==V.protocol&&await this.fb({remote:{host:V.remoteHost,port:V.remotePort},local:V.localPort,name:V.name,source:V.source},j),j&&j.label&&j.label!==V.name&&await this.name(V.remoteHost,V.remotePort,j.label)}}async getAttributes(N,F=!0){const V=new Map,j=new Map;N.forEach(B=>{const Y=S(this.m??new Map,P.$Qw[0],B.port)??B;if(Y){V.set(B.port,Y);const x=v(Y)?Y.pid:void 0;j.has(x)||j.set(x,[]),j.get(x)?.push(B.port)}});const U=new Map;if(N.forEach(B=>{const Y=this.configPortsAttributes.getAttributes(B.port,B.host,V.get(B.port)?.detail);Y&&U.set(B.port,Y)}),this.G.length===0||!F)return U.size>0?U:void 0;const z=await Promise.all(this.G.flatMap(B=>Array.from(j.entries()).map(Y=>{const x=Y[1],oe=V.get(x[0]);return B.providePortAttributes(x,oe?.pid,oe?.detail,p.CancellationToken.None)}))),_=new Map;if(z.forEach(B=>B.forEach(Y=>{Y&&_.set(Y.port,Y)})),!U&&!_)return;const W=new Map;return N.forEach(B=>{const Y=U.get(B.port),x=_.get(B.port);W.set(B.port,{elevateIfNeeded:Y?.elevateIfNeeded,label:Y?.label,onAutoForward:Y?.onAutoForward??w.providedActionToAction(x?.autoForwardAction),requireLocalPort:Y?.requireLocalPort,protocol:Y?.protocol})}),W}addAttributesProvider(N){this.G.push(N)}};e.$yN=M,Ze([(0,h.$bi)(1e3)],M.prototype,"cb",null),e.$yN=M=Ze([qe(0,P.$Lw),qe(1,g.$mq),qe(2,m.$cj),qe(3,a.$nN),qe(4,E.$Ul),qe(5,b.$Ri),qe(6,I.$dk),qe(7,c.$ex),qe(8,$.$sH),qe(9,o.$1j)],M)}),define(Re[59],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.ExcludeSettingOptions=e.$gM=e.$fM=e.$eM=e.$dM=void 0;class s{constructor(c,I){this.line=c,this.character=I}isBefore(c){return!1}isBeforeOrEqual(c){return!1}isAfter(c){return!1}isAfterOrEqual(c){return!1}isEqual(c){return!1}compareTo(c){return 0}translate(c,I){return new s(0,0)}with(c){return new s(0,0)}}e.$dM=s;class h{constructor(c,I,E,g){this.isEmpty=!1,this.isSingleLine=!1,this.start=new s(c,I),this.end=new s(E,g)}contains(c){return!1}isEqual(c){return!1}intersection(c){}union(c){return new h(0,0,0,0)}with(c){return new h(0,0,0,0)}}e.$eM=h;class R{constructor(c,I,E){this.uri=c,this.ranges=I,this.previewText=E}}e.$fM=R;class A{constructor(c,I,E){this.uri=c,this.text=I,this.lineNumber=E}}e.$gM=A;var O;(function(m){m[m.None=1]="None",m[m.FilesExclude=2]="FilesExclude",m[m.SearchAndFilesExclude=3]="SearchAndFilesExclude"})(O||(e.ExcludeSettingOptions=O={}));var C;(function(m){m[m.Information=1]="Information",m[m.Warning=2]="Warning"})(C||(e.TextSearchCompleteMessageType=C={}))}),define(Re[35],Ce([1,0,18,39,24,31,13,5,16,12,59,7]),function(ge,e,s,h,R,A,O,C,m,c,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GM=e.$EM=e.$xM=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$uM=e.$tM=e.$sM=e.$rM=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.TextSearchCompleteMessageType=void 0,e.$oM=p,e.$pM=u,e.$qM=i,e.$vM=k,e.$wM=S,e.$yM=v,e.$zM=w,e.$AM=M,e.$BM=L,e.$CM=N,e.$DM=F,e.$FM=j,e.$HM=_,e.$IM=W,e.$JM=Y,h=Ue(h),R=Ue(R),A=Ue(A),m=Ue(m),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return I.TextSearchCompleteMessageType}}),e.$hM="workbench.view.search",e.$iM="workbench.panel.search",e.$jM="workbench.view.search",e.$kM="search-result",e.$lM="search.exclude",e.$mM=2e4;const g="\u27EA ",P=" characters skipped \u27EB",b=(g.length+P.length+5)*2;e.$nM=(0,C.$Ii)("searchService");var a;(function(x){x[x.file=0]="file",x[x.text=1]="text",x[x.aiText=2]="aiText"})(a||(e.SearchProviderType=a={}));var $;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.aiText=3]="aiText"})($||(e.QueryType=$={}));function p(x){return!!x.rangeLocations&&!!x.previewText}function u(x){return!!x.resource}function i(x){return!!x.message}var o;(function(x){x[x.Normal=0]="Normal",x[x.NewSearchStarted=1]="NewSearchStarted"})(o||(e.SearchCompletionExitCode=o={}));class t{constructor(oe){this.resource=oe,this.results=[]}}e.$rM=t;class n{constructor(oe,ie,me,ue){this.rangeLocations=[],this.webviewIndex=ue;const X=Array.isArray(ie)?ie:[ie];if(me&&me.matchLines===1&&r(X)){oe=(0,O.$ag)(oe,me.matchLines);let q="",se=0,be=0;const ae=Math.floor(me.charsPerLine/5);for(const we of X){const $e=Math.max(we.startColumn-ae,0),pe=we.startColumn+me.charsPerLine;if($e>be+ae+b){const Ae=g+($e-be)+P;q+=Ae+oe.slice($e,pe),se+=$e-(be+Ae.length)}else q+=oe.slice(be,pe);be=pe,this.rangeLocations.push({source:we,preview:new l(0,we.startColumn-se,we.endColumn-se)})}this.previewText=q}else{const q=Array.isArray(ie)?ie[0].startLineNumber:ie.startLineNumber,se=(0,s.$3b)(ie,be=>({preview:new d(be.startLineNumber-q,be.startColumn,be.endLineNumber-q,be.endColumn),source:be}));this.rangeLocations=Array.isArray(se)?se:[se],this.previewText=oe}}}e.$sM=n;function r(x){const oe=x[0].startLineNumber;for(const ie of x)if(ie.startLineNumber!==oe||ie.endLineNumber!==oe)return!1;return!0}class d{constructor(oe,ie,me,ue){this.startLineNumber=oe,this.startColumn=ie,this.endLineNumber=me,this.endColumn=ue}}e.$tM=d;class l extends d{constructor(oe,ie,me){super(oe,ie,oe,me)}}e.$uM=l;var f;(function(x){x.List="list",x.Tree="tree"})(f||(e.ViewMode=f={}));var y;(function(x){x.Default="default",x.FileNames="fileNames",x.Type="type",x.Modified="modified",x.CountDescending="countDescending",x.CountAscending="countAscending"})(y||(e.SearchSortOrder=y={}));function k(x,oe=!0){const ie=x&&x.files&&x.files.exclude,me=oe&&x&&x.search&&x.search.exclude;if(!ie&&!me)return;if(!ie||!me)return ie||me||void 0;let ue=Object.create(null);return ue=R.$lo(ue,R.$io(ie)),ue=R.$lo(ue,R.$io(me),!0),ue}function S(x,oe){return x.excludePattern&&h.$Ck(x.excludePattern,oe)?!1:x.includePattern||x.usingSearchPaths?x.includePattern&&h.$Ck(x.includePattern,oe)?!0:x.usingSearchPaths?!!x.folderQueries&&x.folderQueries.some(ie=>{const me=ie.folder.fsPath;if(A.$Hg(oe,me)){const ue=m.$oc(me,oe);return!ie.includePattern||!!h.$Ck(ie.includePattern,ue)}else return!1}):!1:!0}var D;(function(x){x[x.unknownEncoding=1]="unknownEncoding",x[x.regexParseError=2]="regexParseError",x[x.globParseError=3]="globParseError",x[x.invalidLiteral=4]="invalidLiteral",x[x.rgProcessError=5]="rgProcessError",x[x.other=6]="other",x[x.canceled=7]="canceled"})(D||(e.SearchErrorCode=D={}));class T extends Error{constructor(oe,ie){super(oe),this.code=ie}}e.$xM=T;function v(x){const oe=x.message;if((0,c.$6)(x))return new T(oe,D.canceled);try{const ie=JSON.parse(oe);return new T(ie.message,ie.code)}catch{return new T(oe,D.other)}}function w(x){const oe={message:x.message,code:x.code};return new Error(JSON.stringify(oe))}function M(x){return x.type==="error"?!0:x.type==="success"}function L(x){return x.type==="success"}function N(x){return!!x.path}function F(x,oe,ie=!0){const me=x.searchPath?x.searchPath:x.relativePath;return ie?(0,O.$0f)(me,oe):h.$Ck(oe,me)}class V{constructor(oe){this.path=oe,this.results=[]}addMatch(oe){this.results.push(oe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$EM=V;function j(x,oe){const ie={...x||{},...oe||{}};return Object.keys(ie).filter(me=>{const ue=ie[me];return typeof ue=="boolean"&&ue})}class U{constructor(oe,ie){this.c=null,this.a=ie.excludePattern?.map(ue=>({...oe.excludePattern||{},...ue.pattern||{}}))??[],this.a.length===0&&(this.a=[oe.excludePattern||{}]),this.b=this.a.map(ue=>h.$Dk(ue));let me=oe.includePattern;ie.includePattern&&(me?me={...me,...ie.includePattern}:me=ie.includePattern),me&&(this.c=h.$Dk(me))}d(oe,ie,me){let ue=null;for(const X of this.b){const q=X(oe,ie,me);if(typeof q=="string"){ue=q;break}}return ue}matchesExcludesSync(oe,ie,me){return!!(this.b&&this.d(oe,ie,me))}includedInQuerySync(oe,ie,me){return!(this.b&&this.d(oe,ie,me)||this.c&&!this.c(oe,ie,me))}includedInQuery(oe,ie,me){const ue=()=>this.c?!!this.c(oe,ie,me):!0;return Promise.all(this.b.map(X=>{const q=X(oe,ie,me);return(0,E.$uh)(q)?q.then(se=>se?!1:ue()):ue()})).then(X=>X.some(q=>!!q))}hasSiblingExcludeClauses(){return this.a.reduce((oe,ie)=>z(ie)||oe,!1)}}e.$GM=U;function z(x){for(const oe in x)if(typeof x[oe]!="boolean")return!0;return!1}function _(x){if(!x)return;let oe;return ie=>(oe||(oe=(x()||Promise.resolve([])).then(me=>me?B(me):{})),oe.then(me=>!!me[ie]))}function W(x){if(!x)return;let oe;return ie=>{if(!oe){const me=x();oe=me?B(me):{}}return!!oe[ie]}}function B(x){const oe={};for(const ie of x)oe[ie]=!0;return oe}function Y(x){return x.flatMap(oe=>oe.patterns.map(ie=>oe.baseUri?{baseUri:oe.baseUri,pattern:ie}:ie))}}),define(Re[49],Ce([1,0,18,7,20,4,3,62,14,134,22,13,2,8,27,5,11,232,47,64,29,19,15,9,74,35,6,38,59]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P,b,a,$,p,u,i,o,t,n,r,d,l,f,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vqc=e.$Uqc=void 0;function S(V,j,U){return new I.$$g(z=>w(z,U)).isEqual(V,j)}function D(V,j,U){return S(V.uri,j.uri,U)?0:(0,E.$Bf)(V.uri.toString(),j.uri.toString())}function T(V,j,U){return V.index!==j.index?V.index<j.index?-1:1:S(V.uri,j.uri,U)?(0,E.$Bf)(V.name,j.name):(0,E.$Bf)(V.uri.toString(),j.uri.toString())}function v(V,j,U,z){const _=V.slice(0).sort((B,Y)=>U(B,Y,z)),W=j.slice(0).sort((B,Y)=>U(B,Y,z));return(0,s.$Gb)(_,W,(B,Y)=>U(B,Y,z))}function w(V,j){const U=j.getCapabilities(V.scheme);return!(U&&U&b.FileSystemProviderCapabilities.PathCaseSensitive)}class M extends u.$2i{static toExtHostWorkspace(j,U,z,_){if(!j)return{workspace:null,added:[],removed:[]};const{id:W,name:B,folders:Y,configuration:x,transient:oe,isUntitled:ie}=j,me=[],ue=U;U?Y.forEach((be,ae)=>{const we=g.URI.revive(be.uri),$e=M.o(z||U,we,_);$e?($e.name=be.name,$e.index=be.index,me.push($e)):me.push({uri:we,name:be.name,index:ae})}):me.push(...Y.map(({uri:be,name:ae,index:we})=>({uri:g.URI.revive(be),name:ae,index:we}))),me.sort((be,ae)=>be.index<ae.index?-1:1);const X=new M(W,B,me,!!oe,x?g.URI.revive(x):null,!!ie,be=>w(be,_)),{added:q,removed:se}=v(ue?ue.workspaceFolders:[],X.workspaceFolders,D,_);return{workspace:X,added:q,removed:se}}static o(j,U,z){for(let _=0;_<j.folders.length;_++){const W=j.workspaceFolders[_];if(S(W.uri,U,z))return W}}constructor(j,U,z,_,W,B,Y){super(j,z.map(x=>new u.$3i(x)),_,W,Y),this.t=U,this.u=B,this.q=[],this.s=C.$Oi.forUris(Y,()=>!0),z.forEach(x=>{this.q.push(x),this.s.set(x.uri,x)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(j,U){return U&&this.s.get(j)&&(j=(0,I.$ih)(j)),this.s.findSubstr(j)}resolveWorkspaceFolder(j){return this.s.get(j)}}let L=class{constructor(j,U,z,_,W){this.c=new A.$oe,this.onDidChangeWorkspace=this.c.event,this.g=new A.$oe,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.B=0,this.C=new A.$qe,this.D=new Map,this.h=_,this.s=z,this.t=W,this.j=new c.$Qm,this.k=new h.$Hh,this.o=j.getProxy(f.$3N.MainThreadWorkspace),this.q=j.getProxy(f.$3N.MainThreadMessageService);const B=U.workspace;this.l=B?new M(B.id,B.name,[],!!B.transient,B.configuration?g.URI.revive(B.configuration):null,!!B.isUntitled,Y=>w(Y,z)):void 0}$initializeWorkspace(j,U){this.v=U,this.$acceptWorkspaceData(j),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?g.URI.from({scheme:m.Schemas.untitled,path:(0,I.$gh)((0,I.$ih)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(j,U,z,..._){const W=[];if(Array.isArray(_)&&_.forEach(ie=>{g.URI.isUri(ie.uri)&&!W.some(me=>S(me.uri,ie.uri,this.s))&&W.push({uri:ie.uri,name:ie.name||(0,I.$fh)(ie.uri)})}),this.n||[U,z].some(ie=>typeof ie!="number"||ie<0)||z===0&&W.length===0)return!1;const B=this.x?this.x.workspaceFolders:[];if(U+z>B.length)return!1;const Y=B.slice(0);Y.splice(U,z,...W.map(ie=>({uri:ie.uri,name:ie.name||(0,I.$fh)(ie.uri),index:void 0})));for(let ie=0;ie<Y.length;ie++){const me=Y[ie];if(Y.some((ue,X)=>X!==ie&&S(me.uri,ue.uri,this.s)))return!1}Y.forEach((ie,me)=>ie.index=me);const{added:x,removed:oe}=v(B,Y,T,this.s);if(x.length===0&&oe.length===0)return!1;if(this.o){const ie=j.displayName||j.name;this.o.$updateWorkspaceFolders(ie,U,z,W).then(void 0,me=>{this.n=void 0;const ue={source:{identifier:j.identifier,label:j.displayName||j.name}};this.q.$showMessage(p.Severity.Error,(0,P.localize)(2718,null,ie,me.toString()),ue,[])})}return this.y(Y),!0}getWorkspaceFolder(j,U){if(this.x)return this.x.getWorkspaceFolder(j,U)}async getWorkspaceFolder2(j,U){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(j,U)}async resolveWorkspaceFolder(j){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(j)}getPath(){if(!this.x)return;const{folders:j}=this.x;if(j.length!==0)return j[0].uri.fsPath}getRelativePath(j,U){let z,_="";if(typeof j=="string"?(z=g.URI.file(j),_=j):typeof j<"u"&&(z=j,_=j.fsPath),!z)return _;const W=this.getWorkspaceFolder(z,!0);if(!W)return _;typeof U>"u"&&this.x&&(U=this.x.folders.length>1);let B=(0,I.$lh)(W.uri,z);return U&&W.name&&(B=`${W.name}/${B}`),B}y(j){this.x&&(this.n=M.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:j,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(j){const{workspace:U,added:z,removed:_}=M.toExtHostWorkspace(j,this.l,this.n,this.s);this.l=U||void 0,this.n=void 0,this.c.fire(Object.freeze({added:z,removed:_}))}findFiles(j,U,z,_,W=R.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${_.value}, entryPoint: findFiles`);let B="",Y=!0;return U===null?Y=!1:U!==void 0&&(typeof U=="string"?B=U:B=U.pattern),this.z(j,void 0,{exclude:[B],maxResults:z,useExcludeSettings:Y?k.ExcludeSettingOptions.FilesExclude:k.ExcludeSettingOptions.None,useIgnoreFiles:{local:!1}},W)}findFiles2(j,U={},z,_=R.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${z.value}, entryPoint: findFiles2`);const W=U.useDefaultExcludes??!0,B=U.useDefaultSearchExcludes??!0,Y=W?B?k.ExcludeSettingOptions.SearchAndFilesExclude:k.ExcludeSettingOptions.FilesExclude:k.ExcludeSettingOptions.None,x={exclude:U.exclude?[U.exclude]:void 0,useIgnoreFiles:{local:U.useIgnoreFiles,global:U.useGlobalIgnoreFiles,parent:U.useParentIgnoreFiles},useExcludeSettings:Y,followSymlinks:U.followSymlinks,maxResults:U.maxResults};return this.z(void 0,j!==void 0?[j]:[],x,_)}findFiles2New(j,U={},z,_=R.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2New: fileSearch, extension: ${z.value}, entryPoint: findFiles2New`),this.z(void 0,j,U,_)}async z(j,U,z,_=R.CancellationToken.None){if(_&&_.isCancellationRequested)return Promise.resolve([]);const B=(j!==void 0?[j]:U)?.map(Y=>{const x=F(z.exclude),oe={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles?.local=="boolean"?!z.useIgnoreFiles.local:void 0,disregardGlobalIgnoreFiles:typeof z.useIgnoreFiles?.global=="boolean"?!z.useIgnoreFiles.global:void 0,disregardParentIgnoreFiles:typeof z.useIgnoreFiles?.parent=="boolean"?!z.useIgnoreFiles.parent:void 0,disregardExcludeSettings:z.useExcludeSettings!==void 0&&z.useExcludeSettings===k.ExcludeSettingOptions.None,disregardSearchExcludeSettings:z.useExcludeSettings!==void 0&&z.useExcludeSettings!==k.ExcludeSettingOptions.SearchAndFilesExclude,maxResults:z.maxResults,excludePattern:x.length>0?x:void 0,_reason:"startFileSearch",shouldGlobSearch:j?void 0:!0},ie=N(n.GlobPattern.from(Y)),me=ie?.folder;return j?oe.includePattern=ie?.pattern:oe.filePattern=ie?.pattern,{folder:me,options:oe}})??[];return this.A(B,_)}async A(j,U){return(await Promise.all(j?.map(_=>this.o.$startFileSearch(_.folder??null,_.options,U).then(W=>Array.isArray(W)?W.map(B=>g.URI.revive(B)):[]))??[])).flat()}findTextInFilesNew(j,U,z,_){this.h.trace(`extHostWorkspace#findTextInFilesNew: textSearch, extension: ${U.value}, entryPoint: findTextInFilesNew`);const B=(z?.include?.map(oe=>{const ie=N(n.GlobPattern.from(oe)),me=F(z.exclude);return{options:{ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useIgnoreFiles?.global=="boolean"?!z.useIgnoreFiles?.global:void 0,disregardParentIgnoreFiles:typeof z.useIgnoreFiles?.parent=="boolean"?!z.useIgnoreFiles?.parent:void 0,disregardExcludeSettings:z.useExcludeSettings!==void 0&&z.useExcludeSettings===k.ExcludeSettingOptions.None,disregardSearchExcludeSettings:z.useExcludeSettings!==void 0&&z.useExcludeSettings!==k.ExcludeSettingOptions.SearchAndFilesExclude,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:z.previewOptions?{matchLines:z.previewOptions?.numMatchLines??100,charsPerLine:z.previewOptions?.charsPerLine??1e4}:void 0,surroundingContext:z.surroundingContext,includePattern:ie?.pattern,excludePattern:me},folder:ie?.folder}})??[]).filter(oe=>!!oe),Y=Promise.resolve(void 0);return{results:new h.$9h(async oe=>{const ie=(me,ue)=>((0,l.$oM)(me)?oe.emitOne(new k.$fM(ue,me.rangeLocations.map(X=>({previewRange:new r.$7N(X.preview.startLineNumber,X.preview.startColumn,X.preview.endLineNumber,X.preview.endColumn),sourceRange:new r.$7N(X.source.startLineNumber,X.source.startColumn,X.source.endLineNumber,X.source.endColumn)})),me.previewText)):oe.emitOne(new k.$gM(ue,me.text,me.lineNumber)),me);await Y.then(me=>this.findTextInFilesBase(j,B,ie,_))}),complete:Y.then(oe=>({limitHit:oe?.limitHit??!1}))}}async findTextInFilesBase(j,U,z,_=R.CancellationToken.None){const W=this.j.getNext(),B=!1;if(this.u[W]=Y=>{if(B)return;const x=g.URI.revive(Y.resource);Y.results.forEach(oe=>{const ie=(0,y.$fi)(oe);z(ie,x)})},_.isCancellationRequested)return{};try{const Y=await Promise.all(U?.map(x=>this.o.$startTextSearch(j,x.folder??null,x.options,W,_)||{})??[]);return delete this.u[W],Y.reduce((x,oe)=>({limitHit:x?.limitHit||(oe?.limitHit??!1),message:[x?.message??[],oe?.message??[]].flat()}),{})??{limitHit:!1}}catch(Y){throw delete this.u[W],Y}}async findTextInFiles(j,U,z,_,W=R.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${_.value}, entryPoint: findTextInFiles`);const B=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,Y=N(n.GlobPattern.from(U.include)),x=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,oe={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,disregardSearchExcludeSettings:typeof U.useSearchExclude=="boolean"?!U.useSearchExclude:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:B,surroundingContext:U.afterContext,includePattern:Y?.pattern,excludePattern:x?[{pattern:x}]:void 0},ie=(me,ue)=>{(0,l.$oM)(me)?z({uri:ue,preview:{text:me.previewText,matches:(0,s.$3b)(me.rangeLocations,X=>new r.$7N(X.preview.startLineNumber,X.preview.startColumn,X.preview.endLineNumber,X.preview.endColumn))},ranges:(0,s.$3b)(me.rangeLocations,X=>new r.$7N(X.source.startLineNumber,X.source.startColumn,X.source.endLineNumber,X.source.endColumn))}):z({uri:ue,text:me.text,lineNumber:me.lineNumber})};return this.findTextInFilesBase(j,[{options:oe,folder:Y?.folder}],ie,W)}$handleTextSearchResult(j,U){this.u[U]?.(j)}async save(j){const U=await this.o.$save(j,{saveAs:!1});return g.URI.revive(U)}async saveAs(j){const U=await this.o.$save(j,{saveAs:!0});return g.URI.revive(U)}saveAll(j){return this.o.$saveAll(j)}resolveProxy(j){return this.o.$resolveProxy(j)}lookupAuthorization(j){return this.o.$lookupAuthorization(j)}lookupKerberosAuthorization(j){return this.o.$lookupKerberosAuthorization(j)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(j){return this.o.$requestWorkspaceTrust(j)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(j,U){if(this.w.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.w.set(j,U);const z=this.t.transformOutgoingScheme(j),_=this.B++;return this.o.$registerEditSessionIdentityProvider(_,z),(0,O.$Vc)(()=>{this.w.delete(j),this.o.$unregisterEditSessionIdentityProvider(_)})}async $getEditSessionIdentifier(j,U){this.h.info("Getting edit session identifier for workspaceFolder",j);const z=await this.resolveWorkspaceFolder(g.URI.revive(j));if(!z){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",z);const _=this.w.get(z.uri.scheme);if(this.h.info(`Provider for scheme ${z.uri.scheme} is defined: `,!!_),!_)return;const W=await _.provideEditSessionIdentity(z,U);if(this.h.info("Provider returned edit session identifier: ",W),!!W)return W}async $provideEditSessionIdentityMatch(j,U,z,_){this.h.info("Getting edit session identifier for workspaceFolder",j);const W=await this.resolveWorkspaceFolder(g.URI.revive(j));if(!W){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",W);const B=this.w.get(W.uri.scheme);if(this.h.info(`Provider for scheme ${W.uri.scheme} is defined: `,!!B),!B)return;const Y=await B.provideEditSessionIdentityMatch?.(U,z,_);if(this.h.info("Provider returned edit session identifier match result: ",Y),!!Y)return Y}getOnWillCreateEditSessionIdentityEvent(j){return(U,z,_)=>{const W=function(Y){U.call(z,Y)};return W.extension=j,this.C.event(W,void 0,_)}}async $onWillCreateEditSessionIdentity(j,U,z){const _=await this.resolveWorkspaceFolder(g.URI.revive(j));if(_===void 0)throw new Error("Unable to resolve workspace folder");await this.C.fireAsync({workspaceFolder:_},U,async(W,B)=>{const Y=Date.now();await Promise.resolve(W),Date.now()-Y>z&&this.h.warn("SLOW edit session create-participant",B.extension.identifier)}),U.isCancellationRequested}registerCanonicalUriProvider(j,U){if(this.D.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.D.set(j,U);const z=this.t.transformOutgoingScheme(j),_=this.B++;return this.o.$registerCanonicalUriProvider(_,z),(0,O.$Vc)(()=>{this.D.delete(j),this.o.$unregisterCanonicalUriProvider(_)})}async provideCanonicalUri(j,U,z){const _=this.D.get(j.scheme);if(!_)return;const W=await _.provideCanonicalUri?.(g.URI.revive(j),U,z);if(W)return W}async $provideCanonicalUri(j,U,z){return this.provideCanonicalUri(g.URI.revive(j),{targetScheme:U},z)}};e.$Uqc=L,e.$Uqc=L=Ze([qe(0,t.$DQ),qe(1,o.$TQ),qe(2,i.$Dqc),qe(3,$.$dk),qe(4,d.$Sqc)],L),e.$Vqc=(0,a.$Ii)("IExtHostWorkspace");function N(V){let j,U;if(V)return typeof V=="string"?j=V:(j=V.pattern,U=g.URI.revive(V.baseUri)),{pattern:j,folder:U}}function F(V){return(V?.map(j=>{if(typeof j=="string")return j===""?void 0:{pattern:j,uri:void 0};{const U=N(j);return U?{pattern:U.pattern,uri:U.folder}:void 0}})??[]).filter(j=>!!j)}}),define(Re[42],Ce([1,0,24,4,49,6,9,46,234,72,17,7,5,19,11,2]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yqc=e.$Xqc=e.$Wqc=void 0;function $(d,l){if(l){const f=l.split(".");let y=d;for(let k=0;y&&k<f.length;k++)y=y[f[k]];return y}}function p(d){return d instanceof a.URI}function u(d){return d&&d.uri instanceof a.URI&&d.languageId&&typeof d.languageId=="string"}function i(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function o(d){return d&&d.uri instanceof a.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function t(d){if(p(d))return{resource:d};if(u(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(i(d))return{overrideIdentifier:d.languageId};if(o(d))return{resource:d.uri};if(d===null)return{resource:null}}let n=class{constructor(l,f,y){this.a=l.getProxy(A.$3N.MainThreadConfiguration),this.c=f,this.b=y,this.d=new E.$Hh,this.e=null}getConfigProvider(){return this.d.wait().then(l=>this.e)}$initializeConfiguration(l){this.e=new r(this.a,this.c,l,this.b),this.d.open()}$acceptConfigurationChanged(l,f){this.getConfigProvider().then(y=>y.$acceptConfigurationChanged(l,f))}};e.$Wqc=n,e.$Wqc=n=Ze([qe(0,P.$DQ),qe(1,R.$Vqc),qe(2,b.$dk)],n);class r{constructor(l,f,y,k){this.a=new h.$oe,this.b=l,this.f=k,this.c=f,this.e=m.$Vo.parse(y,k),this.d=this.k(y.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(l,f){const y={data:this.e.toData(),workspace:this.c.workspace};this.e=m.$Vo.parse(l,this.f),this.d=this.k(l.configurationScopes),this.a.fire(this.j(f,y))}getConfiguration(l,f,y){const k=t(f)||{},S=this.g(l?$(this.e.getValue(void 0,k,this.c.workspace),l):this.e.getValue(void 0,k,this.c.workspace));l&&this.h(l,k,y?.identifier);function D(v){if(v==null)return null;if(typeof v=="boolean")return v?C.ConfigurationTarget.USER:C.ConfigurationTarget.WORKSPACE;switch(v){case O.ConfigurationTarget.Global:return C.ConfigurationTarget.USER;case O.ConfigurationTarget.Workspace:return C.ConfigurationTarget.WORKSPACE;case O.ConfigurationTarget.WorkspaceFolder:return C.ConfigurationTarget.WORKSPACE_FOLDER}}const T={has(v){return typeof $(S,v)<"u"},get:(v,w)=>{this.h(l?`${l}.${v}`:v,k,y?.identifier);let M=$(S,v);if(typeof M>"u")M=w;else{let L;const N=(F,V)=>{if((0,I.$jg)(F)){let j;const U=()=>{L=L||(0,s.$io)(S),j=j||$(L,V)};return new Proxy(F,{get:(z,_)=>{if(typeof _=="string"&&_.toLowerCase()==="tojson")return U(),()=>j;if(L)return j=j||$(L,V),j[_];const W=z[_];return typeof _=="string"?N(W,`${V}.${_}`):W},set:(z,_,W)=>(U(),j&&(j[_]=W),!0),deleteProperty:(z,_)=>(U(),j&&delete j[_],!0),defineProperty:(z,_,W)=>(U(),j&&Object.defineProperty(j,_,W),!0)})}return Array.isArray(F)?(0,s.$io)(F):F};M=N(M,v)}return M},update:(v,w,M,L)=>{v=l?`${l}.${v}`:v;const N=D(M);return w!==void 0?this.b.$updateConfigurationOption(N,v,w,k,L):this.b.$removeConfigurationOption(N,v,k,L)},inspect:v=>{v=l?`${l}.${v}`:v;const w=this.e.inspect(v,k,this.c.workspace);if(w)return{key:v,defaultValue:(0,s.$io)(w.policy?.value??w.default?.value),globalValue:(0,s.$io)(w.user?.value??w.application?.value),workspaceValue:(0,s.$io)(w.workspace?.value),workspaceFolderValue:(0,s.$io)(w.workspaceFolder?.value),defaultLanguageValue:(0,s.$io)(w.default?.override),globalLanguageValue:(0,s.$io)(w.user?.override??w.application?.override),workspaceLanguageValue:(0,s.$io)(w.workspace?.override),workspaceFolderLanguageValue:(0,s.$io)(w.workspaceFolder?.override),languageIds:(0,s.$io)(w.overrideIdentifiers)}}};return typeof S=="object"&&(0,s.$lo)(T,S,!1),Object.freeze(T)}g(l){const f=y=>(0,I.$jg)(y)?new Proxy(y,{get:(k,S)=>f(k[S]),set:(k,S,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(S)}' of object`)},deleteProperty:(k,S)=>{throw new Error(`TypeError: Cannot delete read only property '${String(S)}' of object`)},defineProperty:(k,S)=>{throw new Error(`TypeError: Cannot define property '${String(S)}' for a readonly object`)},setPrototypeOf:k=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):y;return f(l)}h(l,f,y){const k=c.$Ko.test(l)?c.ConfigurationScope.RESOURCE:this.d.get(l),S=y?`[${y.value}] `:"";if(c.ConfigurationScope.RESOURCE===k){typeof f?.resource>"u"&&this.f.warn(`${S}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${l}', provide the URI of a resource or 'null' for any resource.`);return}if(c.ConfigurationScope.WINDOW===k){f?.resource&&this.f.warn(`${S}Accessing a window scoped configuration for a resource is not expected. To associate '${l}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(l,f){const y=new m.$Xo(l,f,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(k,S)=>y.affectsConfiguration(k,t(S))})}k(l){return l.reduce((f,y)=>(f.set(y[0],y[1]),f),new Map)}}e.$Xqc=r,e.$Yqc=(0,g.$Ii)("IExtHostConfiguration")}),define(Re[100],Ce([1,0,2,7,4,6,9,49,65,42,20,48,19,29,5,14,10,11,96,274,12]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P,b,a,$,p,u,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bsc=e.$Asc=e.$zsc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,O=Ue(O),$=Ue($);var t;(function(L){function N(V){if(V!=null)return V}L.from=N;function F(V){if(V!=null)return V}L.to=F})(t||(t={}));var n;(function(L){function N(V){if(V!=null)return V}L.from=N;function F(V){if(V!=null)return V}L.to=F})(n||(n={}));var r;(function(L){function N(V){if(V!=null)return V}L.from=N;function F(V){if(V!=null)return V}L.to=F})(r||(r={}));var d;(function(L){function N(j){if(j){const U=j;return U&&!!U.process}else return!1}L.is=N;function F(j){if(j==null)return;const U={process:j.process,args:j.args};return j.options&&(U.options=r.from(j.options)),U}L.from=F;function V(j){if(j!=null)return new O.$QO(j.process,j.args,j.options)}L.to=V})(d||(d={}));var l;(function(L){function N(V){if(V!=null)return V}L.from=N;function F(V){if(V!=null)return V}L.to=F})(l||(l={}));var f;(function(L){function N(j){if(j){const U=j;return U&&(!!U.commandLine||!!U.command)}else return!1}L.is=N;function F(j){if(j==null)return;const U={};return j.commandLine!==void 0?U.commandLine=j.commandLine:(U.command=j.command,U.args=j.args),j.options&&(U.options=l.from(j.options)),U}L.from=F;function V(j){if(!(j==null||j.command===void 0&&j.commandLine===void 0))return j.commandLine?new O.$RO(j.commandLine,j.options):new O.$RO(j.command,j.args?j.args:[],j.options)}L.to=V})(f||(f={}));var y;(function(L){function N(j){if(j){const U=j;return U&&U.customExecution==="customExecution"}else return!1}L.is=N;function F(j){return{customExecution:"customExecution"}}L.from=F;function V(j,U){return U.get(j)}L.to=V})(y||(e.CustomExecutionDTO=y={}));var k;(function(L){function N(F,V){let j;return F.scope!==void 0&&typeof F.scope!="number"?j=F.scope.uri:F.scope!==void 0&&typeof F.scope=="number"&&(F.scope===O.TaskScope.Workspace&&V&&V.workspaceFile?j=V.workspaceFile:j=i.$bJ),{id:F._id,workspaceFolder:j}}L.from=N})(k||(e.TaskHandleDTO=k={}));var S;(function(L){function N(F){if(F!=null)return{_id:F.id,isDefault:F.isDefault}}L.from=N})(S||(S={}));var D;(function(L){function N(j,U){if(j==null)return[];const z=[];for(const _ of j){const W=F(_,U);W&&z.push(W)}return z}L.fromMany=N;function F(j,U){if(j==null)return;let z;j.execution instanceof O.$QO?z=d.from(j.execution):j.execution instanceof O.$RO?z=f.from(j.execution):j.execution&&j.execution instanceof O.$SO&&(z=y.from(j.execution));const _=t.from(j.definition);let W;return j.scope?typeof j.scope=="number"?W=j.scope:W=j.scope.uri:W=O.TaskScope.Workspace,!_||!W?void 0:{_id:j._id,definition:_,name:j.name,source:{extensionId:U.identifier.value,label:j.source,scope:W},execution:z,isBackground:j.isBackground,group:S.from(j.group),presentationOptions:n.from(j.presentationOptions),problemMatchers:j.problemMatchers,hasDefinedMatchers:j.hasDefinedMatchers,runOptions:j.runOptions?j.runOptions:{reevaluateOnRerun:!0},detail:j.detail}}L.from=F;async function V(j,U,z){if(j==null)return;let _;d.is(j.execution)?_=d.to(j.execution):f.is(j.execution)?_=f.to(j.execution):y.is(j.execution)&&(_=y.to(j._id,z));const W=t.to(j.definition);let B;if(j.source&&(j.source.scope!==void 0?typeof j.source.scope=="number"?B=j.source.scope:B=await U.resolveWorkspaceFolder(s.URI.revive(j.source.scope)):B=O.TaskScope.Workspace),!W||!B)return;const Y=new O.$TO(W,B,j.name,j.source.label,_,j.problemMatchers);return j.isBackground!==void 0&&(Y.isBackground=j.isBackground),j.group!==void 0&&(Y.group=O.$PO.from(j.group._id),Y.group&&j.group.isDefault&&(Y.group=new O.$PO(Y.group.id,Y.group.label),j.group.isDefault===!0&&(Y.group.isDefault=j.group.isDefault))),j.presentationOptions&&(Y.presentationOptions=n.to(j.presentationOptions)),j._id&&(Y._id=j._id),j.detail&&(Y.detail=j.detail),Y}L.to=V})(D||(e.TaskDTO=D={}));var T;(function(L){function N(V){return V}L.from=N;function F(V){if(V)return Object.assign(Object.create(null),V)}L.to=F})(T||(T={}));class v{#e;constructor(N,F,V){this._id=F,this.a=V,this.#e=N}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(N){}fireDidEndProcess(N){}}let w=class{constructor(N,F,V,j,U,z,_,W){this.q=new R.$oe,this.r=new R.$oe,this.s=new R.$oe,this.u=new R.$oe,this.a=N.getProxy(A.$3N.MainThreadTask),this.b=V,this.c=j,this.d=U,this.e=z,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=_,this.g=W,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(N,F,V){if(!V)return new O.$5N(()=>{});const j=this.x();return this.j.set(j,{type:F,provider:V,extension:N}),this.a.$registerTaskProvider(j,F),new O.$5N(()=>{this.j.delete(j),this.a.$unregisterTaskProvider(j)})}registerTaskSystem(N,F){this.a.$registerTaskSystem(N,F)}fetchTasks(N){return this.a.$fetchTasks(T.from(N)).then(async F=>{const V=[];for(const j of F){const U=await D.to(j,this.b,this.m);U&&V.push(U)}return V})}get taskExecutions(){const N=[];return this.k.forEach(F=>N.push(F)),N}terminateTask(N){if(!(N instanceof v))throw new Error("No valid task execution provided");return this.a.$terminateTask(N._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(N,F,V){const j=this.m.get(N.id);j&&(this.o.set(N.id,j),this.e.attachPtyToTerminal(F,await j.callback(V))),this.p=N.id,this.q.fire({execution:await this.z(N)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(N){if(!this.l.has(N.id))return;const F=await this.z(N);this.l.delete(N.id),this.k.delete(N.id),this.B(N),this.r.fire({execution:F})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(N){const F=await this.z(N.id);this.s.fire({execution:F,processId:N.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(N){const F=await this.z(N.id);this.u.fire({execution:F,exitCode:N.exitCode})}$provideTasks(N,F){const V=this.j.get(N);if(!V)return Promise.reject(new Error("no handler found"));const j=[],U=(0,h.$Ah)(()=>V.provider.provideTasks(I.CancellationToken.None)).then(z=>this.v(F,j,V,z));return new Promise(z=>{U.then(_=>{Promise.all(j).then(()=>{z(_)})})})}async $resolveTask(N,F){const V=this.j.get(N);if(!V)return Promise.reject(new Error("no handler found"));if(F.definition.type!==V.type)throw new Error(`Unexpected: Task of type [${F.definition.type}] cannot be resolved by provider of type [${V.type}].`);const j=await D.to(F,this.b,this.m);if(!j)throw new Error("Unexpected: Task cannot be resolved.");const U=await V.provider.resolveTask(j,I.CancellationToken.None);if(!U)return;this.A(U,V);const z=D.from(U,V.extension);if(!z)throw new Error("Unexpected: Task cannot be resolved.");if(U.definition!==j.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return y.is(z.execution)&&await this.y(z,U,!0),await this.w(z)}x(){return this.h++}async y(N,F,V){const j=await this.a.$createTaskId(N);!V&&!this.m.has(j)&&(this.n.add(j),this.o.set(j,F.execution)),this.m.set(j,F.execution)}async z(N,F){if(typeof N=="string"){const U=this.l.get(N);if(!U)throw new o.$db("Unexpected: The specified task is missing an execution");return U}const V=this.l.get(N.id);if(V)return V;let j;return F?j=Promise.resolve(new v(this,N.id,F)):j=D.to(N.task,this.b,this.m).then(U=>{if(!U)throw new o.$db("Unexpected: Task does not exist.");return new v(this,N.id,U)}),this.l.set(N.id,j),j.then(U=>(this.k.set(N.id,U),U))}A(N,F){N._deprecated&&this.g.report("Task.constructor",F.extension,"Use the Task constructor that takes a `scope` instead.")}B(N){this.o.get(N.id)&&this.o.delete(N.id),this.n.has(N.id)&&this.p!==N.id&&(this.m.delete(N.id),this.n.delete(N.id));const V=this.n.values();let j=V.next();for(;!j.done;)!this.o.has(j.value)&&this.p!==j.value&&(this.m.delete(j.value),this.n.delete(j.value)),j=V.next()}};e.$zsc=w,e.$zsc=w=Ze([qe(0,g.$DQ),qe(1,P.$TQ),qe(2,C.$Vqc),qe(3,m.$OQ),qe(4,c.$Yqc),qe(5,E.$krc),qe(6,p.$dk),qe(7,u.$zqc)],w);let M=class extends w{constructor(N,F,V,j,U,z,_,W){super(N,F,V,j,U,z,_,W),this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:$.$i($.Platform.Web)})}async executeTask(N,F){if(!F.execution)throw new Error("Tasks to execute must include an execution");const V=D.from(F,N);if(V===void 0)throw new Error("Task is not valid");if(y.is(V.execution))await this.y(V,F,!1);else throw new o.$bb;const j=await this.z(await this.a.$getTaskExecution(V),F);return this.a.$executeTask(V).catch(U=>{throw new Error(U)}),j}v(N,F,V,j){const U=[];if(j)for(const z of j){if(this.A(z,V),!z.definition||!N[z.definition.type]){const W=z.source?z.source:"No task source";this.f.warn(`The task [${W}, ${z.name}] uses an undefined task type. The task will be ignored in the future.`)}const _=D.from(z,V.extension);_&&y.is(_.execution)?(U.push(_),F.push(this.y(_,z,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:U,extension:V.extension}}async w(N){if(y.is(N.execution))return N;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(N,F){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(N,F,V){}};e.$Asc=M,e.$Asc=M=Ze([qe(0,g.$DQ),qe(1,P.$TQ),qe(2,C.$Vqc),qe(3,m.$OQ),qe(4,c.$Yqc),qe(5,E.$krc),qe(6,p.$dk),qe(7,u.$zqc)],M),e.$Bsc=(0,b.$Ii)("IExtHostTask")}),define(Re[335],Ce([1,0,35,30]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QM=void 0,e.$PM=R,e.$RM=A;function R(O){return"cellResults"in O}e.$QM="rawCell#";function A(O,C){let m=-1;const c=[];let I=[];return O.forEach(g=>{g.range.startLineNumber!==m&&I.length>0&&(c.push([...I]),I=[]),I.push(g),m=g.range.endLineNumber}),I.length>0&&c.push([...I]),c.map(g=>{const P=[],b=g[0].range.startLineNumber,a=g[g.length-1].range.endLineNumber;for(let $=b;$<=a;$++)P.push(C.getLineContent($));return new s.$sM(P.join(`
`)+`
`,g.map($=>new h.$Ut($.range.startLineNumber-1,$.range.startColumn-1,$.range.endLineNumber-1,$.range.endColumn-1)))})}}),define(Re[336],Ce([1,0,8,21,4,3,28,41,13,17,2,27,118,6,34,15,9,53,308,168,24,14,35,264,335,332]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P,b,a,$,p,u,i,o,t,n,r,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bsc=void 0,E=Ue(E),a=Ue(a),$=Ue($);class f{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(k=>k.apiEditor)}constructor(k,S,D,T,v,w,M){this.q=D,this.r=T,this.s=v,this.t=w,this.u=M,this.f=new Map,this.g=new O.$Dc,this.h=new Map,this.j=new R.$oe,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new R.$oe,this.onDidOpenNotebookDocument=this.m.event,this.n=new R.$oe,this.onDidCloseNotebookDocument=this.n.event,this.o=new R.$oe,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new g.$xqc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=k.getProxy(P.$3N.MainThreadNotebook),this.c=k.getProxy(P.$3N.MainThreadNotebookDocuments),this.d=k.getProxy(P.$3N.MainThreadNotebookEditors),this.i=S.converter,S.registerArgumentProcessor({processArgument:L=>{if(L&&L.$mid===C.MarshalledId.NotebookCellActionContext){const N=L.notebookEditor?.notebookUri,F=L.cell.handle,j=this.g.get(N)?.getCell(F);if(j)return j.apiCell}if(L&&L.$mid===C.MarshalledId.NotebookActionContext){const N=L.uri,F=this.g.get(N);if(F)return F.apiNotebook}return L}}),f.C(S)}getEditorById(k){const S=this.h.get(k);if(!S)throw new Error(`unknown text editor: ${k}. known editors: ${[...this.h.keys()]} `);return S}getIdByEditor(k){for(const[S,D]of this.h)if(D.apiEditor===k)return S}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(k,S){const D=this.g.get(k);if(!D&&!S)throw new Error(`NO notebook document for '${k}'`);return D}static w(k,S){if(!S)return;const D=S.filenamePattern.map(T=>a.NotebookExclusiveDocumentPattern.from(T)).filter(T=>T!==void 0);if(S.filenamePattern&&!D){console.warn(`Notebook content provider view options file name pattern is invalid ${S.filenamePattern}`);return}return{extension:k.identifier,providerDisplayName:k.displayName||k.name,displayName:S.displayName,filenamePattern:D,priority:S.exclusive?l.RegisteredEditorPriority.exclusive:void 0}}registerNotebookCellStatusBarItemProvider(k,S,D){const T=f.a++,v=typeof D.onDidChangeCellStatusBarItems=="function"?f.a++:void 0;this.f.set(T,D),this.b.$registerNotebookCellStatusBarItemProvider(T,v,S);let w;return v!==void 0&&(w=D.onDidChangeCellStatusBarItems(M=>this.b.$emitCellStatusBarEvent(v))),new $.$5N(()=>{this.f.delete(T),this.b.$unregisterNotebookCellStatusBarItemProvider(T,v),w?.dispose()})}async createNotebookDocument(k){const S=await this.c.$tryCreateNotebook({viewType:k.viewType,content:k.content&&a.NotebookData.from(k.content)});return I.URI.revive(S)}async openNotebookDocument(k){const S=this.g.get(k);if(S)return S.apiNotebook;const D=await this.c.$tryOpenNotebook(k),T=this.g.get(I.URI.revive(D));return(0,c.$sg)(T?.apiNotebook)}async showNotebookDocument(k,S){let D;typeof S=="object"?D={position:a.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selections:S.selections&&S.selections.map(a.NotebookRange.from),pinned:typeof S.preview=="boolean"?!S.preview:void 0,label:S?.label}:D={preserveFocus:!1,pinned:!0};const T=S?.asRepl?"repl":k.notebookType,v=await this.d.$tryShowNotebookDocument(k.uri,T,D),w=v&&this.h.get(v)?.apiEditor;if(w)return w;throw v?new Error(`Could NOT open editor for "${k.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${k.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(k,S,D,T){const v=this.f.get(k),w=I.URI.revive(S),M=this.g.get(w);if(!M||!v)return;const L=M.getCellFromIndex(D);if(!L)return;const N=await v.provideCellStatusBarItems(L.apiCell,T);if(!N)return;const F=new A.$Wc,V=this.p.add([F]),U=(Array.isArray(N)?N:[N]).map(z=>a.NotebookStatusBarItem.from(z,this.i,F));return{cacheId:V,items:U}}$releaseNotebookCellStatusBarItems(k){this.p.delete(k)}registerNotebookSerializer(k,S,D,T,v){if((0,m.$ff)(S))throw new Error("viewType cannot be empty or just whitespace");const w=this.x++;return this.y.set(w,{viewType:S,serializer:D,options:T}),this.b.$registerNotebookSerializer(w,{id:k.identifier,location:k.extensionLocation},S,a.NotebookDocumentContentOptions.from(T),f.w(k,v)),(0,A.$Vc)(()=>{this.b.$unregisterNotebookSerializer(w)})}async $dataToNotebook(k,S,D){const T=this.y.get(k);if(!T)throw new Error("NO serializer found");const v=await T.serializer.deserializeNotebook(S.buffer,D);return new p.$5w(a.NotebookData.from(v))}async $notebookToData(k,S,D){const T=this.y.get(k);if(!T)throw new Error("NO serializer found");const v=await T.serializer.serializeNotebook(a.NotebookData.to(S.value),D);return h.$Qe.wrap(v)}async $saveNotebook(k,S,D,T,v){const w=I.URI.revive(S),M=this.y.get(k);if(this.D(`enter saveNotebook(versionId: ${D}, ${w.toString()})`),!M)throw new Error("NO serializer found");const L=this.g.get(w);if(!L)throw new Error("Document NOT found");if(L.versionId!==D)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(w.scheme))throw new E.$yl((0,s.localize)(2709,null,this.A(w)),E.FileOperationResult.FILE_PERMISSION_DENIED);const N={metadata:(0,o.$qo)(L.apiNotebook.metadata,z=>!(M.options?.transientDocumentMetadata??{})[z]),cells:[]};for(const z of L.apiNotebook.getCells()){const _=new $.$xP(z.kind,z.document.getText(),z.document.languageId,z.mime,M.options?.transientOutputs?[]:[...z.outputs],z.metadata,z.executionSummary);_.metadata=(0,o.$qo)(z.metadata,W=>!(M.options?.transientCellMetadata??{})[W]),N.cells.push(_)}if(await this.z(w,T),v.isCancellationRequested)throw new Error("canceled");const F=await M.serializer.serializeNotebook(N,v);if(v.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${D} ${w.toString()}`),await this.s.value.writeFile(w,F),this.D(`Finished write versionId: ${D} ${w.toString()}`);const V=this.s.getFileSystemProviderExtUri(w.scheme),j=await this.s.value.stat(w),U={name:V.basename(w),isFile:(j.type&E.FileType.File)!==0,isDirectory:(j.type&E.FileType.Directory)!==0,isSymbolicLink:(j.type&E.FileType.SymbolicLink)!==0,mtime:j.mtime,ctime:j.ctime,size:j.size,readonly:!!((j.permissions??0)&E.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(w.scheme),locked:!!((j.permissions??0)&E.FilePermission.Locked),etag:E.$Jl({mtime:j.mtime,size:j.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${D}, ${w.toString()})`),U}async $searchInNotebooks(k,S,D,T,v){const w=this.y.get(k)?.serializer;if(!w)return{limitHit:!1,results:[]};const M=new O.$Ec;await(async(j,U,z)=>{await Promise.all(j.map(async _=>await Promise.all(_.filenamePatterns.map(W=>{const B={_reason:z._reason,folderQueries:z.folderQueries,includePattern:z.includePattern,excludePattern:z.excludePattern,maxResults:z.maxResults,type:n.QueryType.File,filePattern:W};return this.t.doInternalFileSearchWithCustomCallback(B,U,Y=>{Y.forEach(x=>{M.has(x)||T.some(ie=>_.isFromSettings&&!ie.isFromSettings?!1:ie.filenamePatterns.some(me=>(0,l.$IL)(me,x)))||M.add(x)})}).catch(Y=>{if(Y.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw Y})}))))})(D,v,S);const N=new O.$Dc;let F=!1;const V=Array.from(M).map(async j=>{const U=[];try{if(v.isCancellationRequested)return;if(S.maxResults&&[...N.values()].reduce((B,Y)=>B+Y.cellResults.length,0)>S.maxResults){F=!0;return}const z=[],_=this.g.get(j);if(_)_.apiNotebook.getCells().forEach(Y=>z.push({input:Y.document.getText(),outputs:Y.outputs.flatMap(x=>x.items.map(oe=>oe.data.toString()))}));else{const B=await this.s.value.readFile(j),Y=h.$Qe.fromString(B.toString()),x=await w.deserializeNotebook(Y.buffer,v);if(v.isCancellationRequested)return;a.NotebookData.from(x).cells.forEach(ie=>z.push({input:ie.source,outputs:ie.outputs.flatMap(me=>me.items.map(ue=>ue.valueBytes.toString()))}))}if(v.isCancellationRequested)return;z.forEach((B,Y)=>{const x=S.contentPattern.pattern,oe=new r.$r2b(B.input,void 0,B.outputs),ie=oe.findInInputs(x),me=oe.findInOutputs(x),ue=me.flatMap(X=>(0,d.$RM)(X.matches,X.textBuffer)).map((X,q)=>(X.webviewIndex=q,X));if(ie.length>0||me.length>0){const X={index:Y,contentResults:(0,d.$RM)(ie,oe.inputTextBuffer),webviewResults:ue};U.push(X)}});const W={resource:j,cellResults:U};N.set(j,W);return}catch{return}});return await Promise.all(V),{limitHit:F,results:[...N.values()]}}async z(k,S){const D=await this.s.value.stat(k);if(typeof S?.mtime=="number"&&typeof S.etag=="string"&&S.etag!==E.$Il&&typeof D.mtime=="number"&&typeof D.size=="number"&&S.mtime<D.mtime&&S.etag!==E.$Jl({mtime:S.mtime,size:D.size}))throw new E.$yl((0,s.localize)(2710,null),E.FileOperationResult.FILE_MODIFIED_SINCE,S)}A(k){return k.scheme===t.Schemas.file?k.fsPath:k.toString()}B(k,S,D){if(this.h.has(S))throw new Error(`editor with id ALREADY EXSIST: ${S}`);const T=new i.$Zrc(S,this.d,k,D.visibleRanges.map(a.NotebookRange.to),D.selections.map(a.NotebookRange.to),typeof D.viewColumn=="number"?a.ViewColumn.to(D.viewColumn):void 0);this.h.set(S,T)}$acceptDocumentAndEditorsDelta(k){if(k.value.removedDocuments)for(const D of k.value.removedDocuments){const T=I.URI.revive(D),v=this.g.get(T);v&&(v.dispose(),this.g.delete(T),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:v.apiNotebook.getCells().map(w=>w.document.uri)}),this.n.fire(v.apiNotebook));for(const w of this.h.values())w.notebookData.uri.toString()===T.toString()&&this.h.delete(w.id)}if(k.value.addedDocuments){const D=[];for(const T of k.value.addedDocuments){const v=I.URI.revive(T.uri);if(this.g.has(v))throw new Error(`adding EXISTING notebook ${v} `);const w=new u.$Yrc(this.c,this.q,this.r,v,T);D.push(...T.cells.map(M=>u.$Xrc.asModelAddData(M))),this.g.get(v)?.dispose(),this.g.set(v,w),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:D}),this.m.fire(w.apiNotebook)}}if(k.value.addedEditors)for(const D of k.value.addedEditors){if(this.h.has(D.id))return;const T=I.URI.revive(D.documentUri),v=this.g.get(T);v&&this.B(v,D.id,D)}const S=[];if(k.value.removedEditors)for(const D of k.value.removedEditors){const T=this.h.get(D);T&&(this.h.delete(D),this.k?.id===T.id&&(this.k=void 0),S.push(T))}if(k.value.visibleEditors){this.l=k.value.visibleEditors.map(T=>this.h.get(T)).filter(T=>!!T);const D=new Set;this.l.forEach(T=>D.add(T.id));for(const T of this.h.values()){const v=D.has(T.id);T._acceptVisibility(v)}this.l=[...this.h.values()].map(T=>T).filter(T=>T.visible),this.o.fire(this.visibleNotebookEditors)}k.value.newActiveEditor===null?this.k=void 0:k.value.newActiveEditor&&(this.h.get(k.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${k.value.newActiveEditor}`),this.k=this.h.get(k.value.newActiveEditor)),k.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(k){const S=b.$2Q.String.with("notebookType","A notebook type"),D=new b.$4Q("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[S,new b.$2Q("data","Bytes to convert to data",v=>v instanceof Uint8Array,v=>h.$Qe.wrap(v))],new b.$3Q("Notebook Data",v=>a.NotebookData.to(v.value))),T=new b.$4Q("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[S,new b.$2Q("NotebookData","Notebook data to convert to bytes",v=>!0,v=>new p.$5w(a.NotebookData.from(v)))],new b.$3Q("Bytes",v=>v.buffer));k.registerApiCommand(D),k.registerApiCommand(T)}D(k){this.u.trace(`[Extension Host Notebook] ${k}`)}}e.$bsc=f}),define(Re[337],Ce([1,0,16,20,52,39,22,43,35,62]),function(ge,e,s,h,R,A,O,C,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1rc=void 0,s=Ue(s),A=Ue(A),O=Ue(O);class I{constructor(P,b,a){this.l=P,this.o=b,this.p=a,this.f=!1,this.g=0,this.h=!1,this.a=P.filePattern,this.b=P.includePattern&&A.$Dk(P.includePattern),this.c=P.maxResults||void 0,this.d=P.exists,this.j=new Set,this.k=P.excludePattern&&A.$Dk(P.excludePattern)}cancel(){this.h=!0,this.j.forEach(P=>P.cancel()),this.j=new Set}search(P){const b=this.l.folderQueries||[];return new Promise((a,$)=>{const p=u=>{this.g++,P(u)};if(this.h)return a({limitHit:this.f});this.l.extraFileResources&&this.l.extraFileResources.forEach(u=>{const i=u.toString(),o=s.$qc(i);this.k&&this.k(i,o)||this.w(p,{base:u,basename:o})}),this.q(b,p).then(u=>{a({limitHit:this.f,stats:u||void 0})},u=>{$(new Error((0,R.$tj)(u)))})})}async q(P,b){const a=new h.$ze,p={folderOptions:P.map(o=>this.r(o)),maxResults:this.l.maxResults??m.$mM,session:this.p},u=c.$Oi.forUris();P.forEach(o=>{const t=new m.$GM(this.l,o),n=!t.hasSiblingExcludeClauses();u.set(o.folder,{queryTester:t,noSiblingsClauses:n,folder:o.folder,tree:this.s()})});let i;try{this.j.add(a),i=C.$ie.create();const o=await this.o.provideFileSearchResults(this.l.filePattern||"",p,a.token),t=i.elapsed(),n=C.$ie.create();return this.h&&!this.f||(o&&o.forEach(r=>{const d=u.findSubstr(r),l=s.$jc.relative(d.folder.path,r.path);if(d.noSiblingsClauses){const f=s.$qc(r.path);this.w(b,{base:d.folder,relativePath:l,basename:f});return}this.u(d.tree,d.folder,l,b)}),this.h&&!this.f)?null:(u.forEach(r=>{this.v(r.tree,r.queryTester,b)}),{providerTime:t,postProcessTime:n.elapsed()})}finally{a.dispose(),this.j.delete(a)}}r(P){const b=(0,m.$FM)(this.l.includePattern,P.includePattern);let a=P.excludePattern?.map(p=>({folder:p.folder,patterns:(0,m.$FM)(this.l.excludePattern,p.pattern)}));a?.length||(a=[{folder:void 0,patterns:(0,m.$FM)(this.l.excludePattern,void 0)}]);const $=(0,m.$JM)(a);return{folder:P.folder,excludes:$,includes:b,useIgnoreFiles:{local:!P.disregardIgnoreFiles,parent:!P.disregardParentIgnoreFiles,global:!P.disregardGlobalIgnoreFiles},followSymlinks:!P.ignoreSymlinks}}s(){const P={rootEntries:[],pathToEntries:Object.create(null)};return P.pathToEntries["."]=P.rootEntries,P}u({pathToEntries:P},b,a,$){if(a===this.a){const u=s.$qc(this.a);this.w($,{base:b,relativePath:this.a,basename:u})}function p(u){const i=s.$qc(u),o=s.$pc(u);let t=P[o];t||(t=P[o]=[],p(o)),t.push({base:b,relativePath:u,basename:i})}p(a)}v({rootEntries:P,pathToEntries:b},a,$){const p=this,u=this.a;function i(o){const t=(0,m.$IM)(()=>o.map(n=>n.basename));for(let n=0,r=o.length;n<r;n++){const d=o[n],{relativePath:l,basename:f}=d;if(a.matchesExcludesSync(l,f,u!==f?t:void 0))continue;const y=b[l];if(y)i(y);else{if(l===u)continue;p.w($,d)}if(p.f)break}}i(P)}w(P,b){(!this.b||b.relativePath&&this.b(b.relativePath,b.basename))&&((this.d||this.c&&this.g>=this.c)&&(this.f=!0,this.cancel()),this.f||P(b))}}class E{constructor(){this.b=new Map}static{this.a=512}fileSearch(P,b,a,$){const p=this.c(P.cacheKey),u=new I(P,b,p&&p.token);let i=0;const o=t=>{i+=t.length,a(t.map(n=>this.d(n)))};return this.f(u,E.a,o,$).then(t=>({limitHit:t.limitHit,stats:t.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:t.stats}:void 0,messages:[]}))}clearCache(P){this.c(P)?.cancel()}c(P){if(P)return this.b.has(P)||this.b.set(P,new h.$ze),this.b.get(P)}d(P){return P.relativePath?{resource:O.$jh(P.base,P.relativePath)}:{resource:P.base}}f(P,b,a,$){const p=$.onCancellationRequested(()=>{P.cancel()}),u=o=>{o&&(i.push(o),b>0&&i.length>=b&&(a(i),i=[]))};let i=[];return P.search(u).then(o=>(i.length&&a(i),p.dispose(),o),o=>(i.length&&a(i),p.dispose(),Promise.reject(o)))}}e.$1rc=E}),define(Re[338],Ce([1,0,18,80,39,107,28,14,16,22,13,17,2,111,8,46,11,152,47,160,333,35]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P,b,a,$,p,u,i,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IN=void 0,e.$GN=n,e.$HN=r,e.$JN=v,s=Ue(s),h=Ue(h),R=Ue(R),m=Ue(m),I=Ue(I),b=Ue(b);function n(w){return typeof w=="object"&&"uri"in w&&"pattern"in w}function r(w){return typeof w=="string"?{pattern:w}:{pattern:w.pattern,uri:w.baseUri}}let d=class{constructor(M,L,N,F,V,j){this.a=M,this.b=L,this.c=N,this.d=F,this.f=V,this.g=j}text(M,L,N={}){M=this.h(M,N);const F=this.a.getValue(),V=L&&L.some(U=>!this.a.getValue({resource:U}).search.useRipgrep);return{...this.j(L?.map(u.$4i),N),type:t.QueryType.Text,contentPattern:M,previewOptions:N.previewOptions,maxFileSize:N.maxFileSize,usePCRE2:F.search.usePCRE2||V||!1,surroundingContext:N.surroundingContext,userDisabledExcludesAndIgnoreFiles:N.disregardExcludeSettings&&N.disregardIgnoreFiles}}h(M,L){const N=this.a.getValue();M.isRegExp&&(M.pattern=M.pattern.replace(/\r?\n/g,"\\n"));const F={...M,wordSeparators:N.editor.wordSeparators};return this.l(M,L)&&(F.isCaseSensitive=!0),this.m(M)&&(F.isMultiline=!0),L.notebookSearchConfig?.includeMarkupInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownInput=L.notebookSearchConfig.includeMarkupInput),L.notebookSearchConfig?.includeMarkupPreview&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownPreview=L.notebookSearchConfig.includeMarkupPreview),L.notebookSearchConfig?.includeCodeInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellInput=L.notebookSearchConfig.includeCodeInput),L.notebookSearchConfig?.includeOutput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellOutput=L.notebookSearchConfig.includeOutput),F}file(M,L={}){return{...this.j(M,L),type:t.QueryType.File,filePattern:L.filePattern?L.filePattern.trim():L.filePattern,exists:L.exists,sortByScore:L.sortByScore,cacheKey:L.cacheKey,shouldGlobMatchFilePattern:L.shouldGlobSearch}}i(M,L){if(!M)return{};if(Array.isArray(M)){if(M=M.filter(N=>N.length>0).map(S),!M.length)return{}}else M=S(M);return L?this.parseSearchPaths(M):{pattern:f(...Array.isArray(M)?M:[M])}}j(M=[],L={}){const N=Array.isArray(L.excludePattern)?L.excludePattern.map(W=>W.pattern).flat():L.excludePattern,F=this.i(L.includePattern,L.expandPatterns),V=this.i(N,L.expandPatterns),j=M.length>1,U=(F.searchPaths&&F.searchPaths.length?F.searchPaths.map(W=>this.t(W,L,V)):M.map(W=>this.u(W,L,V,j))).filter(W=>!!W),z={_reason:L._reason,folderQueries:U,usingSearchPaths:!!(F.searchPaths&&F.searchPaths.length),extraFileResources:L.extraFileResources,excludePattern:V.pattern,includePattern:F.pattern,onlyOpenEditors:L.onlyOpenEditors,maxResults:L.maxResults};if(L.onlyOpenEditors){const W=s.$Jb(this.c.groups.flatMap(x=>x.editors.map(oe=>oe.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(W));const B=W.filter(x=>(0,t.$wM)(z,x.fsPath)),Y=this.k(B);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Y)),{...z,...Y}}const _=L.extraFileResources&&L.extraFileResources.filter(W=>(0,t.$wM)(z,W.fsPath));return z.extraFileResources=_&&_.length?_:void 0,z}k(M){const L=[],N=new O.$Dc,F={};let V=!1;return M.forEach(j=>{if(j.scheme===C.Schemas.walkThrough)return;if((0,c.$nh)(j)){const z=this.b.getWorkspaceFolder(j)?.uri??this.g.extUri.dirname(j);let _=N.get(z);_||(V=!0,_={folder:z,includePattern:{}},L.push(_),N.set(z,_));const W=m.$oc(z.fsPath,j.fsPath);(0,E.$sg)(_.includePattern)[W.replace(/\\/g,"/")]=!0}else j.fsPath&&(V=!0,F[j.fsPath]=!0)}),{folderQueries:L,includePattern:F,usingSearchPaths:!0,excludePattern:V?void 0:{"**/*":!0}}}l(M,L){if(L.isSmartCase){if(M.isRegExp){if(I.$$f(M.pattern,!0))return!0}else if(I.$$f(M.pattern))return!0}return!!M.isCaseSensitive}m(M){return M.isMultiline||M.isRegExp&&(0,P.$wD)(M.pattern)||M.pattern.indexOf(`
`)>=0?!0:!!M.isMultiline}parseSearchPaths(M){const L=B=>m.$lc(B)||/^\.\.?([\/\\]|$)/.test(B),F=(Array.isArray(M)?M:y(M)).map(B=>{const Y=this.f.resolvedUserHome;return Y?(0,A.$0w)(B,Y.scheme===C.Schemas.file?Y.fsPath:Y.path):B}),V=h.$c(F,B=>L(B)?"searchPaths":"exprSegments"),j=(V.exprSegments||[]).map(B=>I.$qf(B,"/")).map(B=>I.$qf(B,"\\")).map(B=>(B[0]==="."&&(B="*"+B),k(B))),U={},z=this.o(V.searchPaths||[]);z&&z.length&&(U.searchPaths=z);const _=j.flat(),W=f(..._);return W&&(U.pattern=W),U}n(M,L){return L.disregardExcludeSettings?void 0:(0,t.$vM)(M,!L.disregardSearchExcludeSettings)}o(M){if(!M||!M.length)return[];const L=M.flatMap(F=>{let{pathPortion:V,globPortion:j}=l(F);return j&&(j=D(j)),this.q(V).flatMap(z=>this.r(z,j))}),N=new Map;return L.forEach(F=>{const V=F.searchPath.toString(),j=N.get(V);j?F.pattern&&(j.pattern=j.pattern||{},j.pattern[F.pattern]=!0):N.set(V,{searchPath:F.searchPath,pattern:F.pattern?f(F.pattern):void 0})}),Array.from(N.values())}q(M){if(m.$lc(M)){const L=this.b.getWorkspace().folders;return L[0]&&L[0].uri.scheme!==C.Schemas.file?[{searchPath:L[0].uri.with({path:M})}]:[{searchPath:g.URI.file(m.$kc(M))}]}if(this.b.getWorkbenchState()===u.WorkbenchState.FOLDER){const L=this.b.getWorkspace().folders[0].uri;if(M=S(M),M.startsWith("../")||M===".."){const F=m.$jc.resolve(L.path,M);return[{searchPath:L.with({path:F})}]}const N=D(M);return[{searchPath:L,pattern:N}]}else{if(M==="./"||M===".\\")return[];{const L=M.replace(/^\.[\/\\]/,""),F=this.b.getWorkspace().folders.map(V=>{const j=L.match(new RegExp(`^${I.$kf(V.name)}(?:/(.*)|$)`));return j?{match:j,folder:V}:null}).filter(E.$pg);if(F.length)return F.map(V=>{const j=V.match[1];return{searchPath:V.folder.uri,pattern:j&&D(j)}});{const V=M.match(/\.[\/\\](.+)[\/\\]?/),j=V?V[1]:M,U=b.localize(12602,null,j);throw new Error(U)}}}}r(M,L){const N=M.pattern&&L?`${M.pattern}/${L}`:M.pattern||L,F=[{searchPath:M.searchPath,pattern:N}];return N&&!N.endsWith("**")&&F.push({searchPath:M.searchPath,pattern:N+"/**"}),F}t(M,L,N){const F=this.u((0,u.$4i)(M.searchPath),L,N,!1);return F?{...F,includePattern:M.pattern}:null}u(M,L,N,F){let V;const j=g.URI.isUri(M)?M:M.uri;let U=L.excludePattern?.map(x=>{const oe=L.excludePattern&&n(x)?x.uri:void 0;return!oe||!(g.URI.isUri(M)&&this.g.extUri.isEqual(M,oe))?oe:void 0});if(U?.length||(U=[void 0]),N.searchPaths){const x=N.searchPaths.filter(oe=>(0,c.$ch)(oe.searchPath,j))[0];if(x&&!x.pattern)return null;x&&(V=x.pattern)}const z=this.a.getValue({resource:j}),W={...this.n(z,L)||{},...V||{}},B=g.URI.isUri(M)?(0,c.$gh)(M):M.name,Y=U.map(x=>Object.keys(W).length>0?{folder:x,pattern:W}:void 0).filter(x=>x);return{folder:j,folderName:F?B:void 0,excludePattern:Y,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof L.disregardIgnoreFiles=="boolean"?L.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof L.disregardGlobalIgnoreFiles=="boolean"?L.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof L.disregardParentIgnoreFiles=="boolean"?L.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof L.ignoreSymlinks=="boolean"?L.ignoreSymlinks:!z.search.followSymlinks}}};e.$IN=d,e.$IN=d=Ze([qe(0,a.$cj),qe(1,u.$Ri),qe(2,i.$JE),qe(3,$.$dk),qe(4,o.$EN),qe(5,p.$Nl)],d);function l(w){const M=w.match(/[\*\{\}\(\)\[\]\?]/);if(M){const L=M.index,N=w.substr(0,L).match(/[/|\\][^/\\]*$/);if(N){let F=w.substr(0,N.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:w.substr((N.index||0)+1)}}}return{pathPortion:w}}function f(...w){return w.length?w.reduce((M,L)=>(M[L]=!0,M),Object.create(null)):void 0}function y(w){return R.$Bk(w,",").map(M=>M.trim()).filter(M=>!!M.length)}function k(w){return[`**/${w}/**`,`**/${w}`].map(L=>L.replace(/\*\*\/\*\*/g,"**"))}function S(w){return w.replace(/\\/g,"/")}function D(w){return S(w).replace(/^\.\//,"").replace(/\/+$/g,"")}function T(w){return w.replace(/([?*[\]])/g,"[$1]")}function v(w,M){w=s.$Ob(w,F=>F.toString());const L=[],N=M.getWorkspace();return w&&w.forEach(F=>{let V;if(M.getWorkbenchState()===u.WorkbenchState.FOLDER)V=(0,c.$lh)(N.folders[0].uri,F),V&&V!=="."&&(V="./"+V);else{const j=M.getWorkspaceFolder(F);if(j){const U=j.name;if(N.folders.filter(_=>_.name===U).length===1){const _=(0,c.$lh)(j.uri,F);_===""?V=`./${j.name}`:V=`./${j.name}/${_}`}else V=F.fsPath}}V&&L.push(T(V))}),L}}),define(Re[339],Ce([1,0,22,2,20,12,5,338,35,47,7]),function(ge,e,s,h,R,A,O,C,m,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0yb=g,e.$$yb=a,s=Ue(s),A=Ue(A);const E=7e3;function g($,p){const u=p.activationEvents;if(!u)return Promise.resolve(void 0);const i=[],o=[];for(const f of u)if(/^workspaceContains:/.test(f)){const y=f.substr(18);y.indexOf("*")>=0||y.indexOf("?")>=0||$.forceUsingSearch?o.push(y):i.push(y)}if(i.length===0&&o.length===0)return Promise.resolve(void 0);const{promise:t,resolve:n}=(0,I.$Bh)(),r=f=>n({activationEvent:f}),d=Promise.all(i.map(f=>P($,f,r))).then(()=>{}),l=b($,p.identifier,o,r);return Promise.all([d,l]).then(()=>{n(void 0)}),t}async function P($,p,u){for(const i of $.folders)if(await $.exists(s.$jh(h.URI.revive(i),p))){u(`workspaceContains:${p}`);return}}async function b($,p,u,i){if(u.length===0)return Promise.resolve(void 0);const o=new R.$ze,t=$.checkExists($.folders,u,o.token),n=setTimeout(async()=>{o.cancel(),$.logService.info(`Not activating extension '${p.value}': Timed out while searching for 'workspaceContains' pattern ${u.join(",")}`)},E);let r=!1;try{r=await t}catch(d){A.$6(d)||A.$2(d)}o.dispose(),clearTimeout(n),r&&i(`workspaceContains:${u.join(",")}`)}function a($,p,u,i){const o=$.get(O.$Hi),t=$.get(m.$nM),r=o.createInstance(C.$IN).file(p.map(d=>(0,c.$4i)(h.URI.revive(d))),{_reason:"checkExists",includePattern:u,exists:!0});return t.fileSearch(r,i).then(d=>!!d.limitHit,d=>A.$6(d)?!1:Promise.reject(d))}}),define(Re[54],Ce([1,0,8,16,63,22,7,3,62,2,11,6,42,271,125,49,25,162,12,23,21,250,9,73,5,29,98,19,114,78,48,128,4,339,124,252,14,122,43,10,123]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P,b,a,$,p,u,i,o,t,n,r,d,l,f,y,k,S,D,T,v,w,M,L,N,F,V,j,U){"use strict";var z;Object.defineProperty(e,"__esModule",{value:!0}),e.$Brc=e.$Arc=e.$zrc=e.$yrc=e.$xrc=void 0,s=Ue(s),h=Ue(h),R=Ue(R),u=Ue(u),e.$xrc=(0,d.$Ii)("IHostUtils");let _=z=class extends C.$Xc{constructor(X,q,se,be,ae,we,$e,pe,Ae,je,He,Ye,xe){super(),this.Y=Ye,this.Z=xe,this.a=this.B(new v.$oe),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=q,this.g=se,this.f=$e,this.j=be,this.m=ae,this.s=we,this.t=Ae,this.u=je,this.w=He,this.y=this.g.getProxy(E.$3N.MainThreadWorkspace),this.z=this.g.getProxy(E.$3N.MainThreadTelemetry),this.C=this.g.getProxy(E.$3N.MainThreadExtensionService),this.D=new O.$Hh,this.F=new O.$Hh,this.G=new O.$Hh,this.H=new O.$Hh,this.I=new me(this.f.extensions.activationEvents),this.L=new p.$Oec(this.I,this.f.extensions.allExtensions);const Fe=new i.$wn(this.f.extensions.myExtensions);this.J=new p.$Oec(this.I,oe(this.L,Fe)),j.$u&&(this.s.info(`Creating extension host with the following global extensions: ${Y(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Y(this.J)}`)),this.M=new b.$grc(this.g,this.s),this.N=new M.$qrc(this.g),this.O=pe,this.h=this.q.add(X.createChild(new k.$Gi([b.$hrc,this.M],[M.$rrc,this.N]))),this.P=this.B(new P.$frc(this.J,this.L,{onExtensionActivationError:(We,Ne,H)=>{this.C.$onExtensionActivationError(We,u.$4(Ne),H)},actualActivateExtension:async(We,Ne)=>{if(p.$Oec.isHostExtension(We,this.J,this.L))return await this.C.$activateExtension(We,Ne),new P.$erc;const H=this.J.getExtensionDescription(We);return this.fb(H,Ne)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),R.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(X){u.$2(X)}}async $(){this.O.onWillDeactivateAll();let X=[];try{X=this.J.getAllExtensionDescriptions().map(ae=>ae.identifier).filter(ae=>this.isActivated(ae)).map(ae=>this.eb(ae))}catch{}await Promise.all(X)}terminate(X,q=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${X}`),this.s.flush(),this.u.dispose(),this.P.dispose(),u.setUnexpectedErrorHandler(be=>{this.s.error(be)}),this.g.dispose();const se=this.$();Promise.race([(0,O.$Jh)(5e3),se]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${q}`):this.s.info(`Extension host exiting with code ${q}`),this.s.flush(),this.s.dispose(),this.c.exit(q)})}isActivated(X){return this.G.isOpen()?this.P.isActivated(X):!1}async getExtension(X){const q=await this.C.$getExtension(X);return q&&{...q,identifier:new i.$vn(q.identifier.value),extensionLocation:c.URI.revive(q.extensionLocation)}}ab(X,q){return this.P.activateByEvent(X,q)}bb(X,q){return this.P.activateById(X,q)}activateByIdWithErrors(X,q){return this.bb(X,q).then(()=>{const se=this.P.getActivatedExtension(X);if(se.activationFailed)return Promise.reject(se.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(X=>this.J)}getExtensionExports(X){if(this.G.isOpen())return this.P.getActivatedExtension(X).exports;try{return this.P.getActivatedExtension(X).exports}catch{return null}}async cb(X){if(X.scheme===N.Schemas.file&&this.c.fsRealpath){const q=X.fsPath;this.R.has(q)||this.R.set(q,this.c.fsRealpath(q));const se=await this.R.get(q);return c.URI.file(se)}return X}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(X=>new ie(X))),this.Q}async db(X){const q=m.$Oi.forUris(se=>A.$ah.ignorePathCasing(se));return await Promise.all(X.map(async se=>{if(this.wb(se)){const be=await this.cb(se.extensionLocation);q.set(be,se)}})),q}eb(X){let q=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(X))return q;const se=this.P.getActivatedExtension(X);if(!se)return q;try{typeof se.module.deactivate=="function"&&(q=Promise.resolve(se.module.deactivate()).then(void 0,be=>(this.s.error(be),Promise.resolve(void 0))))}catch(be){this.s.error(`An error occurred when deactivating the extension '${X.value}':`),this.s.error(be)}try{se.disposable.dispose()}catch(be){this.s.error(`An error occurred when disposing the subscriptions for extension '${X.value}':`),this.s.error(be)}return q}async fb(X,q){return this.f.remote.isRemote?this.C.$onWillActivateExtension(X.identifier):await this.C.$onWillActivateExtension(X.identifier),this.hb(X,q).then(se=>{const be=se.activationTimes;return this.C.$onDidActivateExtension(X.identifier,be.codeLoadingTime,be.activateCallTime,be.activateResolvedTime,q),this.gb(X,q,"success",be),se},se=>{throw this.gb(X,q,"failure"),se})}gb(X,q,se,be){const ae=B(X,q);this.z.$publicLog2("extensionActivationTimes",{...ae,...be||{},outcome:se})}hb(X,q){const se=B(X,q);this.z.$publicLog2("activatePlugin",se);const be=this.wb(X);if(!be)return Promise.resolve(new P.$drc(P.$arc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${X.identifier.value}, startup: ${q.startup}, activationEvent: '${q.activationEvent}'${X.identifier.value!==q.extensionId.value?`, root cause: ${q.extensionId.value}`:""}`),this.s.flush();const ae=new C.$Wc,we=new P.$brc(q.startup);return Promise.all([this.xb(X,(0,A.$jh)(X.extensionLocation,be),we),this.ib(X,ae)]).then($e=>(R.mark(`code/extHost/willActivateExtension/${X.identifier.value}`),z.jb(this.s,X.identifier,$e[0],$e[1],ae,we))).then($e=>(R.mark(`code/extHost/didActivateExtension/${X.identifier.value}`),$e))}ib(X,q){const se=this.Z.createLanguageModelAccessInformation(X),be=q.add(new t.$jrc(X,this.M)),ae=q.add(new t.$irc(X.identifier.value,!1,this.M)),we=q.add(new L.$src(X,this.N)),$e=X.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,pe=this.f.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${X.identifier.value}`),Promise.all([be.whenReady,ae.whenReady,this.O.whenReady]).then(()=>{const Ae=this;let je,He;const Ye=(0,$.$vH)(X,"ipc")?this.f.messagePorts?.get(i.$vn.toKey(X.identifier)):void 0;return Object.freeze({globalState:be,workspaceState:ae,secrets:we,subscriptions:[],get languageModelAccessInformation(){return se},get extensionUri(){return X.extensionLocation},get extensionPath(){return X.extensionLocation.fsPath},asAbsolutePath(xe){return h.$mc(X.extensionLocation.fsPath,xe)},get storagePath(){return Ae.O.workspaceValue(X)?.fsPath},get globalStoragePath(){return Ae.O.globalValue(X).fsPath},get logPath(){return h.$mc(Ae.f.logsLocation.fsPath,X.identifier.value)},get logUri(){return c.URI.joinPath(Ae.f.logsLocation,X.identifier.value)},get storageUri(){return Ae.O.workspaceValue(X)},get globalStorageUri(){return Ae.O.globalValue(X)},get extensionMode(){return $e},get extension(){return je===void 0&&(je=new x(Ae,X.identifier,X,pe,!1)),je},get extensionRuntime(){return(0,$.$wH)(X,"extensionRuntime"),Ae.extensionRuntime},get environmentVariableCollection(){return Ae.u.getEnvironmentVariableCollection(X)},get messagePassingProtocol(){if(!He){if(!Ye)return;const xe=v.Event.buffer(v.Event.fromDOMEventEmitter(Ye,"message",Fe=>Fe.data));Ye.start(),He={onDidReceiveMessage:xe,postMessage:Ye.postMessage.bind(Ye)}}return He}})})}static jb(X,q,se,be,ae,we){return se=se||{activate:void 0,deactivate:void 0},this.kb(X,q,se,be,we).then($e=>new P.$crc(!1,null,we.build(),se,$e,(0,C.$Vc)(()=>{ae.dispose(),(0,C.$Sc)(be.subscriptions)})))}static kb(X,q,se,be,ae){if(typeof se.activate=="function")try{ae.activateCallStart(),X.trace(`ExtensionService#_callActivateOptional ${q.value}`);const we=typeof global=="object"?global:self,$e=se.activate.apply(we,[be]);return ae.activateCallStop(),ae.activateResolveStart(),Promise.resolve($e).then(pe=>(ae.activateResolveStop(),pe))}catch(we){return Promise.reject(we)}else return Promise.resolve(se)}lb(X,q){this.bb(X.identifier,{startup:!1,extensionId:X.identifier,activationEvent:q}).then(void 0,se=>{this.s.error(se)})}mb(X,q=0){const be=Date.now();(0,j.$C)(()=>{for(let ae=q;ae<X.length;ae+=1){const we=X[ae];for(const $e of we.activationEvents??[])if($e==="onStartupFinished")if(Date.now()-be>50){this.mb(X,ae);break}else this.lb(we,$e)}})}nb(){this.C.$setPerformanceMarks(R.getMarks()),this.m.getConfigProvider().then(X=>{const q=X.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),se=this.J.getAllExtensionDescriptions();if(q)this.mb(se);else for(const be of se)if(be.activationEvents)for(const ae of be.activationEvents)ae==="onStartupFinished"&&this.lb(be,ae)})}ob(){const X=this.ab("*",!0).then(void 0,we=>{this.s.error(we)});this.B(this.j.onDidChangeWorkspace(we=>this.pb(we.added)));const q=this.j.workspace?this.j.workspace.folders:[],se=this.pb(q),be=this.rb(),ae=Promise.all([be,X,se]).then(()=>{});return Promise.race([ae,(0,O.$Jh)(1e4)]).then(()=>{this.nb()}),ae}pb(X){return X.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(q=>this.qb(X,q))).then(()=>{})}async qb(X,q){if(this.isActivated(q.identifier))return;const se=!this.f.remote.isRemote&&!!this.f.remote.authority,be={logService:this.s,folders:X.map(we=>we.uri),forceUsingSearch:se||!this.c.fsExists,exists:we=>this.c.fsExists(we.fsPath),checkExists:(we,$e,pe)=>this.y.$checkExists(we,$e,pe)},ae=await(0,w.$0yb)(be,q);if(ae)return this.bb(q.identifier,{startup:!0,extensionId:q.identifier,activationEvent:ae.activationEvent}).then(void 0,we=>this.s.error(we))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(X){throw console.error(X),X}}async sb(){const{extensionDevelopmentLocationURI:X,extensionTestsLocationURI:q}=this.f.environment;if(!X||!q)throw new Error(s.localize(2701,null));const se=await this.xb(null,q,new P.$brc(!1));if(!se||typeof se.run!="function")throw new Error(s.localize(2702,null,q.toString()));return new Promise((be,ae)=>{const we=(Ae,je)=>{Ae?(j.$u&&this.s.error("Test runner called back with error",Ae),ae(Ae)):(j.$u&&(je?this.s.info(`Test runner called back with ${je} failures.`):this.s.info("Test runner called back with successful outcome.")),be(typeof je=="number"&&je>0?1:0))},$e=(0,A.$0g)(q),pe=se.run($e,we);pe&&pe.then&&pe.then(()=>{j.$u&&this.s.info("Test runner finished successfully."),be(0)}).catch(Ae=>{j.$u&&this.s.error("Test runner finished with error",Ae),ae(Ae instanceof Error&&Ae.stack?Ae.stack:String(Ae))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,O.$Jh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(X,q){return this.S[X]=q,(0,C.$Vc)(()=>{delete this.S[X]})}async getRemoteExecServer(X){const{resolver:q}=await this.ub(X);return q?.resolveExecServer?.(X,{resolveAttempt:0})}async ub(X){const q=X.indexOf("+");if(q===-1)throw new n.$aO("Not an authority that can be resolved!",r.RemoteAuthorityResolverErrorCode.InvalidAuthority);const se=X.substr(0,q);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${se}`,!1),{authorityPrefix:se,resolver:this.S[se]}}async $resolveAuthority(X,q){const se=V.$ie.create(!1),be=()=>`[resolveAuthority(${(0,r.$Yl)(X)},${q})][${se.elapsed()}ms] `,ae=G=>this.s.info(`${be()}${G}`),we=G=>this.s.warn(`${be()}${G}`),$e=(G,Z=void 0)=>this.s.error(`${be()}${G}`,Z),pe=G=>{if(G instanceof n.$aO)return{type:"error",error:{code:G._code,message:G._message,detail:G._detail}};throw G},Ae=async G=>{ae(`activating resolver for ${G}...`);const{resolver:Z,authorityPrefix:ee}=await this.ub(G);if(!Z)throw $e(`no resolver for ${ee}`),new n.$aO(`No remote extension installed to resolve ${ee}.`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Z,authorityPrefix:ee,remoteAuthority:G}},je=X.split(/@|%40/g).reverse();ae(`activating remote resolvers ${je.join(" -> ")}`);let He;try{He=await Promise.all(je.map(Ae)).catch(async G=>{if(!(G instanceof n.$aO)||G._code!==r.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw G;return we(`resolving nested authorities failed: ${G.message}`),[await Ae(X)]})}catch(G){return pe(G)}const Ye=new O.$Th;Ye.cancelAndSet(()=>ae("waiting..."),1e3);let xe,Fe;for(const[G,{authorityPrefix:Z,resolver:ee,remoteAuthority:le}]of He.entries())try{if(G===He.length-1)ae("invoking final resolve()..."),R.mark(`code/extHost/willResolveAuthority/${Z}`),xe=await ee.resolve(le,{resolveAttempt:q,execServer:Fe}),R.mark(`code/extHost/didResolveAuthorityOK/${Z}`),ae("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(ee,n.$_N.isManagedResolvedAuthority(xe)?xe:void 0));else{if(ae(`invoking resolveExecServer() for ${le}`),R.mark(`code/extHost/willResolveExecServer/${Z}`),Fe=await ee.resolveExecServer?.(le,{resolveAttempt:q,execServer:Fe}),!Fe)throw new n.$aO(`Exec server was not available for ${le}`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);R.mark(`code/extHost/didResolveExecServerOK/${Z}`)}}catch(ye){return R.mark(`code/extHost/didResolveAuthorityError/${Z}`),$e("returned an error",ye),Ye.dispose(),pe(ye)}Ye.dispose();const We={environmentTunnels:xe.environmentTunnels,features:xe.tunnelFeatures?{elevation:xe.tunnelFeatures.elevation,privacyOptions:xe.tunnelFeatures.privacyOptions,protocol:xe.tunnelFeatures.protocol===void 0?!0:xe.tunnelFeatures.protocol}:void 0},Ne={extensionHostEnv:xe.extensionHostEnv,isTrusted:xe.isTrusted,authenticationSession:xe.authenticationSessionForInitializingExtensions?{id:xe.authenticationSessionForInitializingExtensions.id,providerId:xe.authenticationSessionForInitializingExtensions.providerId}:void 0};ae(`returned ${n.$_N.isManagedResolvedAuthority(xe)?"managed authority":`${xe.host}:${xe.port}`}`);let H;if(n.$_N.isManagedResolvedAuthority(xe)){const G=q;this.Y.setFactory(G,xe.makeConnection),H={authority:X,connectTo:new r.$Vl(G),connectionToken:xe.connectionToken}}else H={authority:X,connectTo:new r.$Wl(xe.host,xe.port),connectionToken:xe.connectionToken};return{type:"ok",value:{authority:H,options:Ne,tunnelInformation:We}}}async $getCanonicalURI(X,q){this.s.info(`$getCanonicalURI invoked for authority (${(0,r.$Yl)(X)})`);const{resolver:se}=await this.ub(X);if(!se)return null;const be=c.URI.revive(q);if(typeof se.getCanonicalURI>"u")return be;const ae=await(0,O.$Ah)(()=>se.getCanonicalURI(be));return ae||be}async $startExtensionHost(X){X.toAdd.forEach(we=>we.extensionLocation=c.URI.revive(we.extensionLocation));const{globalRegistry:q,myExtensions:se}=W(this.I,this.L,this.J,X),be=await this.db(se);return(await this.getExtensionPathIndex()).setSearchTree(be),this.L.set(q.getAllExtensionDescriptions()),this.J.set(se),j.$u&&(this.s.info(`$startExtensionHost: global extensions: ${Y(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Y(this.J)}`)),this.tb()}$activateByEvent(X,q){return q===$.ActivationKind.Immediate?this.D.wait().then(se=>this.ab(X,!1)):this.G.wait().then(se=>this.ab(X,!1))}async $activate(X,q){return await this.G.wait(),this.J.getExtensionDescription(X)?(await this.bb(X,q),!0):!1}async $deltaExtensions(X){X.toAdd.forEach(we=>we.extensionLocation=c.URI.revive(we.extensionLocation));const{globalRegistry:q,myExtensions:se}=W(this.I,this.L,this.J,X),be=await this.db(se);return(await this.getExtensionPathIndex()).setSearchTree(be),this.L.set(q.getAllExtensionDescriptions()),this.J.set(se),j.$u&&(this.s.info(`$deltaExtensions: global extensions: ${Y(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Y(this.J)}`)),Promise.resolve(void 0)}async $test_latency(X){return X}async $test_up(X){return X.byteLength}async $test_down(X){const q=o.$Qe.alloc(X),se=Math.random()%256;for(let be=0;be<X;be++)q.writeUInt8(se,be);return q}async $updateRemoteConnectionData(X){this.X=X,this.a.fire()}};e.$yrc=_,e.$yrc=_=z=Ze([qe(0,d.$Hi),qe(1,e.$xrc),qe(2,y.$DQ),qe(3,a.$Vqc),qe(4,g.$Yqc),qe(5,I.$dk),qe(6,l.$TQ),qe(7,f.$2qc),qe(8,S.$PGb),qe(9,D.$krc),qe(10,F.$urc),qe(11,U.$vrc),qe(12,T.$orc)],_);function W(ue,X,q,se){ue.addActivationEvents(se.addActivationEvents);const be=new p.$Oec(ue,X.getAllExtensionDescriptions());be.deltaExtensions(se.toAdd,se.toRemove);const ae=new i.$wn(q.getAllExtensionDescriptions().map($e=>$e.identifier));for(const $e of se.myToRemove)ae.delete($e);for(const $e of se.myToAdd)ae.add($e);const we=oe(be,ae);return{globalRegistry:be,myExtensions:we}}function B(ue,X){return{id:ue.identifier.value,name:ue.name,extensionVersion:ue.version,publisherDisplayName:ue.publisher,activationEvents:ue.activationEvents?ue.activationEvents.join(","):null,isBuiltin:ue.isBuiltin,reason:X.activationEvent,reasonId:X.extensionId.value}}function Y(ue){return ue.getAllExtensionDescriptions().map(X=>X.identifier.value).join(",")}e.$zrc=(0,d.$Ii)("IExtHostExtensionService");class x{#e;#t;#i;constructor(X,q,se,be,ae){this.#e=X,this.#t=q,this.#i=se.identifier,this.id=se.identifier.value,this.extensionUri=se.extensionLocation,this.extensionPath=h.$kc((0,A.$0g)(se.extensionLocation)),this.packageJSON=se,this.extensionKind=be,this.isFromDifferentExtensionHost=ae}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Arc=x;function oe(ue,X){return ue.getAllExtensionDescriptions().filter(q=>X.has(q.identifier))}class ie{constructor(X){this.a=X}setSearchTree(X){this.a=X}findSubstr(X){return this.a.findSubstr(X)}forEach(X){return this.a.forEach(X)}}e.$Brc=ie;class me{constructor(X){this.a=new i.$xn,this.addActivationEvents(X)}readActivationEvents(X){return this.a.get(X.identifier)??[]}addActivationEvents(X){for(const q of Object.keys(X))this.a.set(q,X[q])}}}),define(Re[340],Ce([1,0,63,2,6,42,25,23,19,29,5,54,11,13]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rsc=void 0,s=Ue(s);let a=class{constructor(o,t,n,r,d,l,f){this.c=o,this.d=t,this.e=n,this.f=r,this.g=d,this.h=l,this.i=f,this.a=new Map,this.b=[]}async install(){this.j(),s.mark("code/extHost/willWaitForConfig");const o=await this.f.getConfigProvider();s.mark("code/extHost/didWaitForConfig");const t=await this.g.getExtensionPathIndex();this.register(new p(this.c,t,this.d,o,this.i)),this.register(this.e.createInstance($)),this.h.remote.isRemote&&this.register(this.e.createInstance(u,t,this.h.environment.appUriScheme))}register(o){if("nodeModuleName"in o)if(Array.isArray(o.nodeModuleName))for(const t of o.nodeModuleName)this.a.set(t,o);else this.a.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this.b.push(t=>o.alternativeModuleName(t))}};e.$Rsc=a,e.$Rsc=a=Ze([qe(2,I.$Hi),qe(3,A.$Yqc),qe(4,E.$zrc),qe(5,c.$TQ),qe(6,g.$dk)],a);let $=class{static{b=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(o){if(o.environment.appRoot&&b.a.size){const t=(0,P.$kf)(this.c(o.environment.appRoot.fsPath)),n="[a-z0-9_.-]",r=`@${n}+\\/${n}+|${n}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${d}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(o){if(!this.b)return;const t=this.b.exec(this.c(o));if(!t)return;const[,n,r,d]=t,l=b.a.get(r);if(l!==void 0)return console.warn(`${r} as been renamed to ${l}, please update your imports`),n+l+d}c(o){return o.replace(/\\/g,"/")}};$=b=Ze([qe(0,c.$TQ)],$);class p{constructor(o,t,n,r,d){this.c=o,this.d=t,this.e=n,this.f=r,this.g=d,this.nodeModuleName="vscode",this.a=new C.$xn}load(o,t){const n=this.d.findSubstr(t);if(n){let r=this.a.get(n.identifier);return r||(r=this.c(n,this.e,this.f),this.a.set(n.identifier,r)),r}if(!this.b){let r="";this.d.forEach((d,l)=>r+=`	${l} -> ${d.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${r}`),this.b=this.c(O.$qH,this.e,this.f)}return this.b}}let u=class{constructor(o,t,n){this.e=o,this.f=t,this.nodeModuleName=["open","opn"],this.d=n.getProxy(R.$3N.MainThreadTelemetry);const r=n.getProxy(R.$3N.MainThreadWindow);this.c=(d,l)=>{const f=h.URI.parse(d);return l?this.g(d,l):f.scheme==="http"||f.scheme==="https"?r.$openUri(f,d,{allowTunneling:!0}):f.scheme==="mailto"||f.scheme===this.f?r.$openUri(f,d,{}):this.g(d,l)}}load(o,t,n){const r=this.e.findSubstr(t);return r&&(this.a=r.identifier.value,this.h()),this.b=n(o),this.c}g(o,t){return this.i(),this.b(o,t)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};u=Ze([qe(2,m.$DQ)],u)}),define(Re[66],Ce([1,0,50,3,16,55,5,65,79,54,9,49,268,42]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Drc=e.$Crc=void 0,R=Ue(R),A=Ue(A),e.$Crc=(0,O.$Ii)("IExtHostVariableResolverProvider");class b extends g.$HR{constructor(p,u,i,o,t,n,r){function d(){if(i){const l=i.activeEditor();if(l)return l.document.uri;const f=o.tabGroups.all.find(y=>y.isActive)?.activeTab;if(f!==void 0){if(f.input instanceof I.$TP||f.input instanceof I.$YP)return f.input.modified;if(f.input instanceof I.$SP||f.input instanceof I.$XP||f.input instanceof I.$VP)return f.input.uri}}}super({getFolderUri:l=>{const f=n.folders.filter(y=>y.name===l);if(f&&f.length>0)return f[0].uri},getWorkspaceFolderCount:()=>n.folders.length,getConfigurationValue:(l,f)=>t.getConfiguration(void 0,l).get(f),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=d();if(l)return R.$kc(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(u){const l=d();if(l){const f=u.getWorkspaceFolder(l);if(f)return R.$kc(f.uri.fsPath)}}},getSelectedText:()=>{if(i){const l=i.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(i){const l=i.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>p.getExtension(l)},void 0,r?Promise.resolve(r):void 0,Promise.resolve(A.env))}}let a=class extends h.$Xc{constructor(p,u,i,o,t){super(),this.b=p,this.c=u,this.g=i,this.h=o,this.j=t,this.a=new s.$W(async()=>{const n=await this.h.getConfigProvider(),d={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async l=>{d.folders=await this.c.getWorkspaceFolders2()||[]})),new b(this.b,this.c,this.g,this.j,n,d,this.m())})}getResolver(){return this.a.value}m(){}};e.$Drc=a,e.$Drc=a=Ze([qe(0,c.$zrc),qe(1,E.$Vqc),qe(2,C.$OQ),qe(3,P.$Yqc),qe(4,m.$$qc)],a)}),define(Re[101],Ce([1,0,7,4,2,3,23,5,6,79,54,19,9,49,157,119,259,42,66,51,34,15,18,99]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P,b,a,$,p,u,i,o,t,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nrc=e.$Mrc=e.$Lrc=e.$Krc=e.$Jrc=void 0,t=Ue(t),e.$Jrc=(0,C.$Ii)("IExtHostDebugService");let d=class extends A.$Xc{get onDidStartDebugSession(){return this.y.event}get onDidTerminateDebugSession(){return this.z.event}get onDidChangeActiveDebugSession(){return this.C.event}get activeDebugSession(){return this.D?.api}get onDidReceiveDebugSessionCustomEvent(){return this.F.event}get activeDebugConsole(){return this.G.value}constructor(T,v,w,M,L,N,F,V){super(),this.Y=v,this.Z=w,this.$=M,this.ab=L,this.bb=N,this.cb=F,this.db=V,this.w=new Map,this.O=0,this.P=new Map,this.Q=new Map,this.R=new WeakMap,this.S=new Map,this.W=new Map,this.X=0,this.f=0,this.g=[],this.h=0,this.j=[],this.m=0,this.n=[],this.M=new Map,this.N=new Map,this.y=this.B(new h.$oe),this.z=this.B(new h.$oe),this.C=this.B(new h.$oe),this.F=this.B(new h.$oe),this.u=T.getProxy(m.$3N.MainThreadDebugService),this.I=this.B(new h.$oe),this.L=this.B(new h.$oe),this.G=new f(this.u),this.H=new Map,this.Z.getExtensionRegistry().then(j=>{this.B(j.onDidChange(U=>{this.fb(j)})),this.fb(j)})}async $getVisualizerTreeItem(T,v){const w=this.gb(v);if(!w)return;const M=await this.Q.get(T)?.getTreeItem?.(w);return M?this.eb(T,M):void 0}registerDebugVisualizationTree(T,v,w){const M=O.$vn.toKey(T.identifier),L=this.ub(M,v);if(this.P.has(L))throw new Error(`A debug visualization provider with id '${v}' is already registered`);return this.Q.set(L,w),this.u.$registerDebugVisualizerTree(L,!!w.editItem),(0,A.$Vc)(()=>{this.u.$unregisterDebugVisualizerTree(L),this.Q.delete(v)})}async $getVisualizerTreeItemChildren(T,v){const w=this.S.get(v)?.item;return w?(await this.Q.get(T)?.getChildren?.(w))?.map(L=>this.eb(T,L))||[]:[]}async $editVisualizerTreeItem(T,v){const w=this.S.get(T);if(!w)return;const M=await this.Q.get(w.provider)?.editItem?.(w.item,v);return this.eb(w.provider,M||w.item)}$disposeVisualizedTree(T){const v=this.S.get(T);if(!v)return;const w=[v.children];for(const M of w)if(M)for(const L of M)w.push(this.S.get(L)?.children),this.S.delete(L)}eb(T,v){let w=this.R.get(v);return w||(w=this.O++,this.R.set(v,w),this.S.set(w,{provider:T,item:v})),t.DebugTreeItem.from(v,w)}asDebugSourceUri(T,v){const w=T;if(typeof w.sourceReference=="number"&&w.sourceReference>0){let M=`debug:${encodeURIComponent(w.path||"")}`,L="?";return v&&(M+=`${L}session=${encodeURIComponent(v.id)}`,L="&"),M+=`${L}ref=${w.sourceReference}`,R.URI.parse(M)}else{if(w.path)return R.URI.file(w.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}fb(T){const v=[];for(const w of T.getAllExtensionDescriptions())if(w.contributes){const M=w.contributes.debuggers;if(M&&M.length>0)for(const L of M)(0,$.$rI)(L)&&v.push(L.type)}this.u.$registerDebugTypes(v)}get activeStackItem(){return this.J}get onDidChangeActiveStackItem(){return this.L.event}get onDidChangeBreakpoints(){return this.I.event}get breakpoints(){const T=[];return this.H.forEach(v=>T.push(v)),T}async $resolveDebugVisualizer(T,v){const w=this.W.get(T);if(!w)throw new Error(`No debug visualizer found with id '${T}'`);let{v:M,provider:L,extensionId:N}=w;if(M.visualization||(M=await L.resolveDebugVisualization?.(M,v)||M,w.v=M),!M.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${L}'`);return this.vb(N,M.visualization)}async $executeDebugVisualizerCommand(T){const v=this.W.get(T);if(!v)throw new Error(`No debug visualizer found with id '${T}'`);const w=v.v.visualization;w&&"command"in w&&this.cb.executeCommand(w.command,...w.arguments||[])}gb(T){const v=this.w.get(T.sessionId);return v&&{session:v.api,variable:T.variable,containerId:T.containerId,frameId:T.frameId,threadId:T.threadId}}async $provideDebugVisualizers(T,v,w,M){const L=this.gb(w),N=this.ub(T,v),F=this.P.get(N);if(!L||!F)return[];const V=await F.provideDebugVisualization(L,M);return V?V.map(j=>{const U=++this.X;this.W.set(U,{v:j,provider:F,extensionId:T});const z=j.iconPath?this.wb(j.iconPath):void 0;return{id:U,name:j.name,iconClass:z?.iconClass,iconPath:z?.iconPath,visualization:this.vb(T,j.visualization)}}):[]}$disposeDebugVisualizers(T){for(const v of T)this.W.delete(v)}registerDebugVisualizationProvider(T,v,w){if(!T.contributes?.debugVisualizers?.some(N=>N.id===v))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${v})`);const M=O.$vn.toKey(T.identifier),L=this.ub(M,v);if(this.P.has(L))throw new Error(`A debug visualization provider with id '${v}' is already registered`);return this.P.set(L,w),this.u.$registerDebugVisualizer(M,v),(0,A.$Vc)(()=>{this.u.$unregisterDebugVisualizer(M,v),this.P.delete(v)})}addBreakpoints(T){const v=T.filter(L=>{const N=L.id;return this.H.has(N)?!1:(this.H.set(N,L),!0)});this.rb(v,[],[]);const w=[],M=new Map;for(const L of v)if(L instanceof g.$9O){let N=M.get(L.location.uri.toString());N||(N={type:"sourceMulti",uri:L.location.uri,lines:[]},M.set(L.location.uri.toString(),N),w.push(N)),N.lines.push({id:L.id,enabled:L.enabled,condition:L.condition,hitCondition:L.hitCondition,logMessage:L.logMessage,line:L.location.range.start.line,character:L.location.range.start.character,mode:L.mode})}else L instanceof g.$0O&&w.push({type:"function",id:L.id,enabled:L.enabled,hitCondition:L.hitCondition,logMessage:L.logMessage,condition:L.condition,functionName:L.functionName,mode:L.mode});return this.u.$registerBreakpoints(w)}removeBreakpoints(T){const v=T.filter(N=>this.H.delete(N.id));this.rb([],v,[]);const w=v.filter(N=>N instanceof g.$9O).map(N=>N.id),M=v.filter(N=>N instanceof g.$0O).map(N=>N.id),L=v.filter(N=>N instanceof g.$$O).map(N=>N.id);return this.u.$unregisterBreakpoints(w,M,L)}startDebugging(T,v,w){const M=w.testRun&&this.db.getMetadataForRun(w.testRun);return this.u.$startDebugging(T?T.uri:void 0,v,{parentSessionID:w.parentSession?w.parentSession.id:void 0,lifecycleManagedByParent:w.lifecycleManagedByParent,repl:w.consoleMode===g.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:w.noDebug,compact:w.compact,suppressSaveBeforeStart:w.suppressSaveBeforeStart,testRun:M&&{runId:M.runId,taskId:M.taskId},suppressDebugStatusbar:w.suppressDebugStatusbar??w.debugUI?.simple,suppressDebugToolbar:w.suppressDebugToolbar??w.debugUI?.simple,suppressDebugView:w.suppressDebugView??w.debugUI?.simple})}stopDebugging(T){return this.u.$stopDebugging(T?T.id:void 0)}registerDebugConfigurationProvider(T,v,w){if(!v)return new g.$5N(()=>{});const M=this.f++;return this.g.push({type:T,handle:M,provider:v}),this.u.$registerDebugConfigurationProvider(T,w,!!v.provideDebugConfigurations,!!v.resolveDebugConfiguration,!!v.resolveDebugConfigurationWithSubstitutedVariables,M),new g.$5N(()=>{this.g=this.g.filter(L=>L.provider!==v),this.u.$unregisterDebugConfigurationProvider(M)})}registerDebugAdapterDescriptorFactory(T,v,w){if(!w)return new g.$5N(()=>{});if(!this.nb(T,v))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${v}' debugger.`);if(this.kb(v))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const M=this.h++;return this.j.push({type:v,handle:M,factory:w}),this.u.$registerDebugAdapterDescriptorFactory(v,M),new g.$5N(()=>{this.j=this.j.filter(L=>L.factory!==w),this.u.$unregisterDebugAdapterDescriptorFactory(M)})}registerDebugAdapterTrackerFactory(T,v){if(!v)return new g.$5N(()=>{});const w=this.m++;return this.n.push({type:T,handle:w,factory:v}),new g.$5N(()=>{this.n=this.n.filter(M=>M.factory!==v)})}async $runInTerminal(T,v){return Promise.resolve(void 0)}async $substituteVariables(T,v){let w;const M=await this.tb(T);return M&&(w={uri:M.uri,name:M.name,index:M.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.bb.getResolver()).resolveAnyAsync(w,v)}hb(T,v){if(T.type==="implementation")return new k(T.implementation)}ib(){}async $startDASession(T,v){const w=this,M=await this.sb(v);return this.pb(this.kb(M.type),M).then(L=>{if(!L)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${M.type}' (extension might have failed to activate)`);const N=this.jb(L),F=this.hb(N,M);if(!F)throw new Error(`Couldn't create a debug adapter for type '${M.type}'.`);const V=F;return this.M.set(T,V),this.ob(M).then(j=>(j&&this.N.set(T,j),V.onMessage(async U=>{if(U.type==="request"&&U.command==="handshake"){const z=U,_={type:"response",seq:0,command:z.command,request_seq:z.seq,success:!0};this.U||(this.U=this.ib());try{if(this.U){const W=await this.U.sign(z.arguments.value);_.body={signature:W},V.sendResponse(_)}else throw new Error("no signer")}catch(W){_.success=!1,_.message=W.message,V.sendResponse(_)}}else j&&j.onDidSendMessage&&j.onDidSendMessage(U),U=(0,$.$wI)(U,!0),w.u.$acceptDAMessage(T,U)}),V.onError(U=>{j&&j.onError&&j.onError(U),this.u.$acceptDAError(T,U.name,U.message,U.stack)}),V.onExit(U=>{j&&j.onExit&&j.onExit(U??void 0,void 0),this.u.$acceptDAExit(T,U??void 0,void 0)}),j&&j.onWillStartSession&&j.onWillStartSession(),V.startSession()))})}$sendDAMessage(T,v){v=(0,$.$vI)(v,!1);const w=this.N.get(T);w&&w.onWillReceiveMessage&&w.onWillReceiveMessage(v),this.M.get(T)?.sendMessage(v)}$stopDASession(T){const v=this.N.get(T);this.N.delete(T),v&&v.onWillStopSession&&v.onWillStopSession();const w=this.M.get(T);return this.M.delete(T),w?w.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(T){const v=[],w=[],M=[];if(T.added)for(const L of T.added){const N=L.id;if(N&&!this.H.has(N)){let F;if(L.type==="function")F=new g.$0O(L.functionName,L.enabled,L.condition,L.hitCondition,L.logMessage,L.mode);else if(L.type==="data")F=new g.$$O(L.label,L.dataId,L.canPersist,L.enabled,L.hitCondition,L.condition,L.logMessage,L.mode);else{const V=R.URI.revive(L.uri);F=new g.$9O(new g.$gO(V,new g.$6N(L.line,L.character)),L.enabled,L.condition,L.hitCondition,L.logMessage,L.mode)}(0,g.$7O)(F,N),this.H.set(N,F),v.push(F)}}if(T.removed)for(const L of T.removed){const N=this.H.get(L);N&&(this.H.delete(L),w.push(N))}if(T.changed){for(const L of T.changed)if(L.id){const N=this.H.get(L.id);if(N){if(N instanceof g.$0O&&L.type==="function"){const F=N;F.enabled=L.enabled,F.condition=L.condition,F.hitCondition=L.hitCondition,F.logMessage=L.logMessage,F.functionName=L.functionName}else if(N instanceof g.$9O&&L.type==="source"){const F=N;F.enabled=L.enabled,F.condition=L.condition,F.hitCondition=L.hitCondition,F.logMessage=L.logMessage,F.location=new g.$gO(R.URI.revive(L.uri),new g.$6N(L.line,L.character))}M.push(N)}}}this.rb(v,w,M)}async $acceptStackFrameFocus(T){let v;if(T){const w=await this.sb(T.sessionId);T.kind==="thread"?v=new g.$eP(w.api,T.threadId):v=new g.$dP(w.api,T.threadId,T.frameId)}this.J=v,this.L.fire(this.J)}$provideDebugConfigurations(T,v,w){return(0,s.$Ah)(async()=>{const M=this.mb(T);if(!M)throw new Error("no DebugConfigurationProvider found");if(!M.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const L=await this.tb(v);return M.provideDebugConfigurations(L,w)}).then(M=>{if(!M)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return M})}$resolveDebugConfiguration(T,v,w,M){return(0,s.$Ah)(async()=>{const L=this.mb(T);if(!L)throw new Error("no DebugConfigurationProvider found");if(!L.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const N=await this.tb(v);return L.resolveDebugConfiguration(N,w,M)})}$resolveDebugConfigurationWithSubstitutedVariables(T,v,w,M){return(0,s.$Ah)(async()=>{const L=this.mb(T);if(!L)throw new Error("no DebugConfigurationProvider found");if(!L.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const N=await this.tb(v);return L.resolveDebugConfigurationWithSubstitutedVariables(N,w,M)})}async $provideDebugAdapter(T,v){const w=this.lb(T);if(!w)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const M=await this.sb(v);return this.pb(w,M).then(L=>{if(!L)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${M.type}'`);return this.jb(L)})}async $acceptDebugSessionStarted(T){const v=await this.sb(T);this.y.fire(v.api)}async $acceptDebugSessionTerminated(T){const v=await this.sb(T);v&&(this.z.fire(v.api),this.w.delete(v.id))}async $acceptDebugSessionActiveChanged(T){this.D=T?await this.sb(T):void 0,this.C.fire(this.D?.api)}async $acceptDebugSessionNameChanged(T,v){(await this.sb(T))?._acceptNameChanged(v)}async $acceptDebugSessionCustomEvent(T,v){const M={session:(await this.sb(T)).api,event:v.event,body:v.body};this.F.fire(M)}jb(T){if(T instanceof g.$_O)return{type:"executable",command:T.command,args:T.args,options:T.options};if(T instanceof g.$aP)return{type:"server",port:T.port,host:T.host};if(T instanceof g.$bP)return{type:"pipeServer",path:T.path};if(T instanceof g.$cP)return{type:"implementation",implementation:T.implementation};throw new Error("convertToDto unexpected type")}kb(T){const v=this.j.filter(w=>w.type===T);if(v.length>0)return v[0].factory}lb(T){const v=this.j.filter(w=>w.handle===T);if(v.length>0)return v[0].factory}mb(T){const v=this.g.filter(w=>w.handle===T);if(v.length>0)return v[0].provider}nb(T,v){if(T.contributes){const w=T.contributes.debuggers;if(w&&w.length>0){for(const M of w)if(M.label&&M.type&&M.type===v)return!0}}return!1}ob(T){const w=T.configuration.type,M=this.n.filter(L=>L.type===w||L.type==="*").map(L=>(0,s.$Ah)(()=>L.factory.createDebugAdapterTracker(T.api)).then(N=>N,N=>null));return Promise.race([Promise.all(M).then(L=>{const N=(0,n.$Jb)(L);if(N.length>0)return new y(N)}),new Promise(L=>setTimeout(()=>L(void 0),1e3))]).catch(L=>{})}async pb(T,v){const w=v.configuration.debugServer;if(typeof w=="number")return Promise.resolve(new g.$aP(w));if(T){const L=await this.Z.getExtensionRegistry();return(0,s.$Ah)(()=>T.createDebugAdapterDescriptor(v.api,this.qb(v,L))).then(N=>{if(N)return N})}const M=await this.Z.getExtensionRegistry();return Promise.resolve(this.qb(v,M))}qb(T,v){}rb(T,v,w){(T.length>0||v.length>0||w.length>0)&&this.I.fire(Object.freeze({added:T,removed:v,changed:w}))}async sb(T){if(T)if(typeof T=="string"){const v=this.w.get(T);if(v)return v}else{let v=this.w.get(T.id);if(!v){const w=await this.tb(T.folderUri),M=T.parent?this.w.get(T.parent):void 0;v=new l(this.u,T.id,T.type,T.name,w,T.configuration,M?.api),this.w.set(v.id,v),this.u.$sessionCached(v.id)}return v}throw new Error("cannot find session")}tb(T){if(T){const v=R.URI.revive(T);return this.Y.resolveWorkspaceFolder(v)}return Promise.resolve(void 0)}ub(T,v){return`${T}\0${v}`}vb(T,v){if(v){if("title"in v&&"command"in v)return{type:a.DebugVisualizationType.Command};if("treeId"in v)return{type:a.DebugVisualizationType.Tree,id:`${T}\0${v.treeId}`};throw new Error("Unsupported debug visualization type")}}wb(T){const v=this.xb(T);let w,M;return"id"in v?M=i.ThemeIcon.asClassName(v):w=v,{iconPath:w,iconClass:M}}xb(T){if(T instanceof g.$4O)return{id:T.id};const v=typeof T=="object"&&"dark"in T?T.dark:T,w=typeof T=="object"&&"light"in T?T.light:T;return{dark:typeof v=="string"?R.URI.file(v):v,light:typeof w=="string"?R.URI.file(w):w}}};e.$Krc=d,e.$Krc=d=Ze([qe(0,E.$DQ),qe(1,P.$Vqc),qe(2,I.$zrc),qe(3,p.$Yqc),qe(4,c.$$qc),qe(5,u.$Crc),qe(6,o.$ZQ),qe(7,r.$Erc)],d);class l{constructor(T,v,w,M,L,N,F){this.f=T,this.g=v,this.h=w,this.j=M,this.k=L,this.l=N,this.m=F}get api(){const T=this;return this.d??=Object.freeze({id:T.g,type:T.h,get name(){return T.j},set name(v){T.j=v,T.f.$setDebugSessionName(T.g,v)},parentSession:T.m,workspaceFolder:T.k,configuration:T.l,customRequest(v,w){return T.f.$customDebugAdapterRequest(T.g,v,w)},getDebugProtocolBreakpoint(v){return T.f.$getDebugProtocolBreakpoint(T.g,v.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(T){this.j=T}get configuration(){return this.l}}e.$Lrc=l;class f{constructor(T){this.value=Object.freeze({append(v){T.$appendDebugConsole(v)},appendLine(v){this.append(v+`
`)}})}}e.$Mrc=f;class y{constructor(T){this.d=T}onWillStartSession(){this.d.forEach(T=>T.onWillStartSession?T.onWillStartSession():void 0)}onWillReceiveMessage(T){this.d.forEach(v=>v.onWillReceiveMessage?v.onWillReceiveMessage(T):void 0)}onDidSendMessage(T){this.d.forEach(v=>v.onDidSendMessage?v.onDidSendMessage(T):void 0)}onWillStopSession(){this.d.forEach(T=>T.onWillStopSession?T.onWillStopSession():void 0)}onError(T){this.d.forEach(v=>v.onError?v.onError(T):void 0)}onExit(T,v){this.d.forEach(w=>w.onExit?w.onExit(T,v):void 0)}}class k extends b.$Dub{constructor(T){super(),this.h=T,T.onDidSendMessage(v=>{this.acceptMessage(v)})}startSession(){return Promise.resolve(void 0)}sendMessage(T){this.h.handleMessage(T)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let S=class extends d{constructor(T,v,w,M,L,N,F,V){super(T,v,w,M,L,N,F,V)}};e.$Nrc=S,e.$Nrc=S=Ze([qe(0,E.$DQ),qe(1,P.$Vqc),qe(2,I.$zrc),qe(3,p.$Yqc),qe(4,c.$$qc),qe(5,u.$Crc),qe(6,o.$ZQ),qe(7,r.$Erc)],S)}),define(Re[341],Ce([1,0,12,63,2,6,289,11,89,114,29,227,19,74,54,95]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tsc=e.$Ssc=void 0,s=Ue(s),h=Ue(h);class ${static async installEarlyHandler(i){Error.stackTraceLimit=100;const o=i.get(C.$dk),n=i.get(g.$DQ).getProxy(A.$3N.MainThreadErrors);s.setUnexpectedErrorHandler(r=>{o.error(r);const d=s.$4(r);n.$onUnexpectedError(d)})}static async installFullHandler(i){const o=i.get(C.$dk),t=i.get(g.$DQ),n=i.get(b.$zrc),r=i.get(a.$XQ),d=t.getProxy(A.$3N.MainThreadExtensionService),l=t.getProxy(A.$3N.MainThreadErrors),f=await n.getExtensionPathIndex(),y=new WeakMap;function k(T,v){if(y.has(T))return y.get(T).stack;let w="",M,L;for(const F of v)w+=`
	at ${F.toString()}`,L=F.getFileName(),!M&&L&&(M=f.findSubstr(R.URI.file(L)));const N=`${T.name||"Error"}: ${T.message||""}${w}`;return y.set(T,{extensionIdentifier:M?.identifier,stack:N}),N}const S=Symbol("prepareStackTrace wrapped");let D=k;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return D},set(T){if(T===k||!T||T[S]){D=T||k;return}D=function(v,w){return k(v,w),T.call(Error,v,w)},Object.assign(D,{[S]:!0})}}),s.setUnexpectedErrorHandler(T=>{o.error(T);const v=s.$4(T),w=y.get(T);if(!w?.extensionIdentifier){l.$onUnexpectedError(v);return}d.$onExtensionRuntimeError(w.extensionIdentifier,v);const M=r.onExtensionError(w.extensionIdentifier,T);o.trace("forwarded error to extension?",M,w)})}}e.$Ssc=$;class p{constructor(i,o,t,n,r){this.a=t,this.b=new O.$Wec(i,null,n),o=p.e(o,this.b);const d=new c.$Gi(...(0,m.$Ys)());d.set(I.$TQ,{_serviceBrand:void 0,...o,messagePorts:r}),d.set(g.$DQ,new g.$EQ(this.b)),d.set(P.$Sqc,new P.$Tqc(n)),d.set(b.$xrc,t);const l=new E.$Cr(d,!0);l.invokeFunction($.installEarlyHandler),this.d=l.invokeFunction(f=>f.get(C.$dk)),h.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",o),this.c=l.invokeFunction(f=>f.get(b.$zrc)),this.c.initialize(),l.invokeFunction($.installFullHandler)}async asBrowserUri(i){const o=this.b.getProxy(A.$3N.MainThreadExtensionService);return R.URI.revive(await o.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,o){i.extensions.allExtensions.forEach(n=>{n.extensionLocation=R.URI.revive(o.transformIncomingURIs(n.extensionLocation))}),i.environment.appRoot=R.URI.revive(o.transformIncomingURIs(i.environment.appRoot));const t=i.environment.extensionDevelopmentLocationURI;return t&&(i.environment.extensionDevelopmentLocationURI=t.map(n=>R.URI.revive(o.transformIncomingURIs(n)))),i.environment.extensionTestsLocationURI=R.URI.revive(o.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=R.URI.revive(o.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=R.URI.revive(o.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=R.URI.revive(o.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=R.URI.revive(o.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=R.URI.revive(o.transformIncomingURIs(i.logsLocation)),i.workspace=o.transformIncomingURIs(i.workspace),i}}e.$Tsc=p}),define(Re[342],Ce([1,0,7,10,8,220,150,101,79,54,19,48,9,66,49,260,261,42,34,99]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P,b,a,$,p,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4sc=void 0,h=Ue(h),R=Ue(R);let o=class extends C.$Krc{constructor(l,f,y,k,S,D,T,v,w){super(l,f,y,k,D,T,v,w),this.Ab=S,this.yb=new r}hb(l,f){switch(l.type){case"server":return new a.$Ysc(l);case"pipeServer":return new a.$Zsc(l);case"executable":return new a.$1sc(l,f.type)}return super.hb(l,f)}qb(l,f){const y=a.$1sc.platformAdapterExecutable(f.getAllExtensionDescriptions(),l.type);if(y)return new g.$_O(y.command,y.args,y.options)}ib(){return new O.$Wic}async $runInTerminal(l,f){if(l.kind==="integrated"){this.zb||(this.zb=this.B(this.Ab.onDidCloseTerminal(V=>{this.yb.onTerminalClosed(V)})));const y=await this.$.getConfigProvider(),k=this.Ab.getDefaultShell(!0),S=this.Ab.getDefaultShellArgs(!0),D=l.title||R.localize(2731,null),T=JSON.stringify({shell:k,shellArgs:S});let v=await this.yb.checkout(T,D),w,M=!1;if(v)w=l.cwd;else{const V={shellPath:k,shellArgs:S,cwd:l.cwd,name:D,iconPath:new g.$4O("debug")};M=!0,v=this.Ab.createTerminalFromOptions(V,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.yb.insert(v,T)}v.show(!0);const L=await v.processId;M?await new Promise(V=>setTimeout(V,1e3)):(v.state.isInteractedWith&&(v.sendText(""),await(0,s.$Jh)(200)),y.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(k.indexOf("powershell")>=0||k.indexOf("pwsh")>=0||k.indexOf("cmd.exe")>=0?v.sendText("cls"):k.indexOf("bash")>=0?v.sendText("clear"):h.$j?v.sendText("cls"):v.sendText("clear")));const N=(0,$.$3sc)(k,l.args,!!l.argsCanBeInterpretedByShell,w,l.env);v.sendText(N);const F=this.onDidTerminateDebugSession(V=>{V.id===f&&(this.yb.free(v),F.dispose())});return L}else if(l.kind==="external")return n(l,await this.$.getConfigProvider());return super.$runInTerminal(l,f)}};e.$4sc=o,e.$4sc=o=Ze([qe(0,I.$DQ),qe(1,b.$Vqc),qe(2,c.$zrc),qe(3,p.$Yqc),qe(4,E.$krc),qe(5,m.$$qc),qe(6,P.$Crc),qe(7,u.$ZQ),qe(8,i.$Erc)],o);let t;function n(d,l){if(!t)if(h.$j)t=new A.$Ehc;else if(h.$k)t=new A.$Fhc;else if(h.$l)t=new A.$Ghc;else throw new Error("external terminals not supported on this platform");const f=l.getConfiguration("terminal");return t.runInTerminal(d.title,d.cwd,d.args,d.env||{},f.external||{})}class r{constructor(){this.b=new Map}static{this.a=1e3}async checkout(l,f,y=!1){const S=[...this.b.entries()].map(([D,T])=>(0,s.$vh)(async v=>{if(D.name!==f||T.lastUsedAt!==-1&&await(0,$.$2sc)(await D.processId))return null;const w=Date.now();return T.lastUsedAt+r.a>w||v.isCancellationRequested?null:T.config!==l?(y&&D.dispose(),null):(T.lastUsedAt=w,D)}));return await(0,s.$Nh)(S,D=>!!D)}insert(l,f){this.b.set(l,{lastUsedAt:Date.now(),config:f})}free(l){const f=this.b.get(l);f&&(f.lastUsedAt=-1)}onTerminalClosed(l){this.b.delete(l)}}}),define(Re[343],Ce([1,0,16,2,109,49,65,42,47,48,19,29,100,14,11,96,22,68,66]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P,b,a,$,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vsc=void 0,s=Ue(s),$=Ue($);let i=class extends g.$zsc{constructor(t,n,r,d,l,f,y,k,S){super(t,n,r,d,l,f,y,k),this.C=r,this.D=S,n.remote.isRemote&&n.remote.authority?this.registerTaskSystem(P.Schemas.vscodeRemote,{scheme:P.Schemas.vscodeRemote,authority:n.remote.authority,platform:process.platform}):this.registerTaskSystem(P.Schemas.file,{scheme:P.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(t,n){const r=n;if(!n.execution&&r._id===void 0)throw new Error("Tasks to execute must include an execution");if(r._id!==void 0){const d=g.TaskHandleDTO.from(r,this.C),l=await this.a.$getTaskExecution(d);if(l.task===void 0)throw new Error("Task from execution DTO is undefined");const f=await this.z(l,n);return this.a.$executeTask(d).catch(()=>{}),f}else{const d=g.TaskDTO.from(n,t);if(d===void 0)return Promise.reject(new Error("Task is not valid"));g.CustomExecutionDTO.is(d.execution)&&await this.y(d,n,!1);const l=await this.z(await this.a.$getTaskExecution(d),n);return this.a.$executeTask(d).catch(()=>{}),l}}v(t,n,r,d){const l=[];if(d)for(const f of d){this.A(f,r),(!f.definition||!t[f.definition.type])&&this.f.warn(`The task [${f.source}, ${f.name}] uses an undefined task type. The task will be ignored in the future.`);const y=g.TaskDTO.from(f,r.extension);y&&(l.push(y),g.CustomExecutionDTO.is(y.execution)&&n.push(this.y(y,f,!0)))}return{tasks:l,extension:r.extension}}async w(t){return t}async G(t){let n=t&&t.length>0?t[0]:void 0;if(!n){const r=h.URI.file((0,p.homedir)());n=new m.$3i({uri:r,name:$.$gh(r),index:0})}return{uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(t,n){const r=h.URI.revive(t),d={process:void 0,variables:Object.create(null)},l=await this.b.resolveWorkspaceFolder(r),f=await this.b.getWorkspaceFolders2()??[],y=await this.D.getResolver(),k=l?{uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(f);for(const S of n.variables)d.variables[S]=await y.resolveAsync(k,S);if(n.process!==void 0){let S;if(n.process.path!==void 0){S=n.process.path.split(s.$wc);for(let D=0;D<S.length;D++)S[D]=await y.resolveAsync(k,S[D])}d.process=await R.win32.findExecutable(await y.resolveAsync(k,n.process.name),n.process.cwd!==void 0?await y.resolveAsync(k,n.process.cwd):void 0,S)}return d}async $jsonTasksSupported(){return!0}async $findExecutable(t,n,r){return R.win32.findExecutable(t,n,r)}};e.$Vsc=i,e.$Vsc=i=Ze([qe(0,I.$DQ),qe(1,E.$TQ),qe(2,A.$Vqc),qe(3,O.$OQ),qe(4,C.$Yqc),qe(5,c.$krc),qe(6,b.$dk),qe(7,a.$zqc),qe(8,u.$Crc)],i)}),define(Re[344],Ce([1,0,68,66]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ctc=void 0;class R extends h.$Drc{m(){return(0,s.homedir)()}}e.$Ctc=R}),define(Re[174],Ce([1,0,18,59]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9rc=e.$8rc=e.$5rc=void 0,e.$6rc=m,e.$7rc=c,e.$0rc=P;function R(b){return"uri"in b&&"ranges"in b&&"preview"in b}function A(b){return b.folderOptions.map(a=>({folder:a.folder,excludes:a.excludes.map($=>typeof $=="string"?$:$.pattern),includes:a.includes,useGlobalIgnoreFiles:a.useIgnoreFiles.global,useIgnoreFiles:a.useIgnoreFiles.local,useParentIgnoreFiles:a.useIgnoreFiles.parent,followSymlinks:a.followSymlinks,maxResults:b.maxResults,session:b.session}))}class O{constructor(a){this.a=a}provideFileSearchResults(a,$,p){return(async()=>{const i=A($);return Promise.all(i.map(o=>this.a.provideFileSearchResults({pattern:a},o,p)))})().then(i=>(0,s.$Jb)(i).flat())}}e.$5rc=O;function C(b){return b.folderOptions.map(a=>({folder:a.folder,excludes:a.excludes.map($=>typeof $=="string"?$:$.pattern),includes:a.includes,useGlobalIgnoreFiles:a.useIgnoreFiles.global,useIgnoreFiles:a.useIgnoreFiles.local,useParentIgnoreFiles:a.useIgnoreFiles.parent,followSymlinks:a.followSymlinks,maxResults:b.maxResults,previewOptions:m(b.previewOptions),maxFileSize:b.maxFileSize,encoding:a.encoding,afterContext:b.surroundingContext,beforeContext:b.surroundingContext}))}function m(b){if(!(!b||b.matchLines===void 0&&b.charsPerLine===void 0))return{matchLines:b.matchLines??100,charsPerLine:b.charsPerLine??1e4}}function c(b){if(R(b)){const a=(0,s.$4b)(b.ranges).map(($,p)=>{const i=(0,s.$4b)(b.preview.matches)[p];return{sourceRange:$,previewRange:i}});return new h.$fM(b.uri,a,b.preview.text)}else return new h.$gM(b.uri,b.text,b.lineNumber)}class I{constructor(a){this.a=a}provideTextSearchResults(a,$,p,u){const i=n=>{g(n)&&p.report(c(n))};return(async()=>(0,s.$Jb)(await Promise.all(C($).map(n=>this.a.provideTextSearchResults(a,n,{report:r=>i(r)},u)))).reduce((n,r)=>({limitHit:n.limitHit||r.limitHit}),{limitHit:!1}))().then(n=>({limitHit:n.limitHit,message:(0,s.$Jb)((0,s.$4b)(n.message))}))}}e.$8rc=I;class E{constructor(a){this.a=a}provideAITextSearchResults(a,$,p,u){const i=n=>{g(n)&&p.report(c(n))};return(async()=>(0,s.$Jb)(await Promise.all(C($).map(n=>this.a.provideAITextSearchResults(a,n,{report:r=>i(r)},u)))).reduce((n,r)=>({limitHit:n.limitHit||r.limitHit}),{limitHit:!1}))().then(n=>({limitHit:n.limitHit,message:(0,s.$Jb)((0,s.$4b)(n.message))}))}}e.$9rc=E;function g(b){if(P(b)){if(Array.isArray(b.ranges)){if(!Array.isArray(b.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(b.preview.matches.length!==b.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(b.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}function P(b){return!!b.preview}}),define(Re[175],Ce([1,0,7,20,52,14,16,22,62,2,35,59]),function(ge,e,s,h,R,A,O,C,m,c,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4rc=e.$3rc=e.$2rc=void 0,O=Ue(O),C=Ue(C);class g{constructor(u,i,o){this.f=u,this.g=i,this.h=o,this.b=null,this.c=!1,this.d=0}get j(){return this.f.query}search(u,i){const o=this.j.folderQueries||[],t=new h.$ze(i);return new Promise((n,r)=>{this.b=new b(u);let d=!1;const l=(f,y)=>{if(!d&&!this.c){const k=this.l(f);f instanceof E.$fM&&typeof this.j.maxResults=="number"&&this.d+k>this.j.maxResults&&(this.c=!0,d=!0,t.cancel(),f=this.m(f,this.j.maxResults-this.d));const S=this.l(f);this.d+=S;const D=f instanceof E.$fM;(S>0||!D)&&this.b.add(f,y)}};this.n(o,l,t.token).then(f=>{t.dispose(),this.b.flush(),n({limitHit:this.c||f?.limitHit,messages:this.k(f),stats:{type:this.h}})},f=>{t.dispose();const y=(0,R.$tj)(f);r(new Error(y))})})}k(u){return u?.message?Array.isArray(u.message)?u.message:[u.message]:[]}l(u){return u instanceof E.$fM?Array.isArray(u.ranges)?u.ranges.length:1:0}m(u,i){return new E.$fM(u.uri,u.ranges.slice(0,i),u.previewText)}async n(u,i,o){const t=m.$Oi.forUris();u.forEach((y,k)=>{const S=new I.$GM(this.j,y);t.set(y.folder,{queryTester:S,folder:y.folder,folderIdx:k})});const n=[],r={report:y=>{const k=t.findSubstr(y.uri),S=k.folder.scheme===A.Schemas.file?(0,I.$HM)(()=>this.g.readdir(C.$ih(y.uri))):void 0,D=C.$lh(k.folder,y.uri);if(D){const T=k.queryTester.includedInQuery(D,O.$qc(D),S);(0,s.$uh)(T)?n.push(T.then(v=>{v&&i(y,k.folderIdx)})):T&&i(y,k.folderIdx)}}},l={folderOptions:u.map(y=>this.o(y)),maxFileSize:this.j.maxFileSize,maxResults:this.j.maxResults??I.$mM,previewOptions:this.j.previewOptions,surroundingContext:this.j.surroundingContext??0};"usePCRE2"in this.j&&(l.usePCRE2=this.j.usePCRE2);let f;return this.f.query.type===I.QueryType.aiText?f=await this.f.provider.provideAITextSearchResults(this.f.query.contentPattern,l,r,o):f=await this.f.provider.provideTextSearchResults(P(this.f.query.contentPattern),l,r,o),n.length&&await Promise.all(n),f}o(u){const i=(0,I.$FM)(this.j.includePattern,u.includePattern);let o=u.excludePattern?.map(r=>({folder:r.folder,patterns:(0,I.$FM)(this.j.excludePattern,r.pattern)}));(!o||o.length===0)&&(o=[{folder:void 0,patterns:(0,I.$FM)(this.j.excludePattern,void 0)}]);const t=(0,I.$JM)(o);return{folder:c.URI.from(u.folder),excludes:t,includes:i,useIgnoreFiles:{local:!u.disregardIgnoreFiles,parent:!u.disregardParentIgnoreFiles,global:!u.disregardGlobalIgnoreFiles},followSymlinks:!u.ignoreSymlinks,encoding:(u.fileEncoding&&this.g.toCanonicalName(u.fileEncoding))??""}}}e.$2rc=g;function P(p){return{isCaseSensitive:p.isCaseSensitive||!1,isRegExp:p.isRegExp||!1,isWordMatch:p.isWordMatch||!1,isMultiline:p.isMultiline||!1,pattern:p.pattern}}class b{constructor(u){this.g=u,this.c=-1,this.f=null,this.b=new $(512,i=>this.j(i))}add(u,i){this.f&&(this.c!==i||!C.$ch(this.d,u.uri))&&(this.h(),this.f=null),this.f||(this.c=i,this.f={resource:u.uri,results:[]}),this.f.results.push(a(u))}h(){const u=this.f&&this.f.results?this.f.results.length:0;this.b.addItem(this.f,u)}flush(){this.h(),this.b.flush()}j(u){this.g(u)}}e.$3rc=b;function a(p){return p instanceof E.$fM?{previewText:p.previewText,rangeLocations:p.ranges.map(u=>({preview:{startLineNumber:u.previewRange.start.line,startColumn:u.previewRange.start.character,endLineNumber:u.previewRange.end.line,endColumn:u.previewRange.end.character},source:{startLineNumber:u.sourceRange.start.line,startColumn:u.sourceRange.start.character,endLineNumber:u.sourceRange.end.line,endColumn:u.sourceRange.end.character}}))}:{text:p.text,lineNumber:p.lineNumber}}class ${static{this.b=4e3}static{this.c=50}constructor(u,i){this.j=u,this.k=i,this.d=0,this.f=[],this.g=0}addItem(u,i){u&&this.l(u,i)}addItems(u,i){u&&this.m(u,i)}l(u,i){this.f.push(u),this.g+=i,this.n()}m(u,i){this.f=this.f.concat(u),this.g+=i,this.n()}n(){this.d<$.c?this.flush():this.g>=this.j?this.flush():this.h||(this.h=setTimeout(()=>{this.flush()},$.b))}flush(){this.g&&(this.d+=this.g,this.k(this.f),this.f=[],this.g=0,this.h&&(clearTimeout(this.h),this.h=0))}}e.$4rc=$}),define(Re[102],Ce([1,0,3,6,5,337,19,74,11,2,175,38,174]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_rc=e.$$rc=void 0,e.$asc=b,e.$$rc=(0,R.$Ii)("IExtHostSearch");let P=class{constructor(p,u,i){this.n=p,this.o=u,this.q=i,this.c=this.n.getProxy(h.$3N.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new A.$1rc}s(p){return this.o.transformOutgoingScheme(p)}registerTextSearchProviderOld(p,u){if(this.g.has(p))throw new Error(`a text search provider for the scheme '${p}' is already registered`);this.g.add(p);const i=this.d++;return this.e.set(i,new g.$8rc(u)),this.c.$registerTextSearchProvider(i,this.s(p)),(0,s.$Vc)(()=>{this.g.delete(p),this.e.delete(i),this.c.$unregisterProvider(i)})}registerTextSearchProvider(p,u){if(this.g.has(p))throw new Error(`a text search provider for the scheme '${p}' is already registered`);this.g.add(p);const i=this.d++;return this.e.set(i,u),this.c.$registerTextSearchProvider(i,this.s(p)),(0,s.$Vc)(()=>{this.g.delete(p),this.e.delete(i),this.c.$unregisterProvider(i)})}registerAITextSearchProviderOld(p,u){if(this.i.has(p))throw new Error(`an AI text search provider for the scheme '${p}'is already registered`);this.i.add(p);const i=this.d++;return this.h.set(i,new g.$9rc(u)),this.c.$registerAITextSearchProvider(i,this.s(p)),(0,s.$Vc)(()=>{this.i.delete(p),this.h.delete(i),this.c.$unregisterProvider(i)})}registerAITextSearchProvider(p,u){if(this.i.has(p))throw new Error(`an AI text search provider for the scheme '${p}'is already registered`);this.i.add(p);const i=this.d++;return this.h.set(i,u),this.c.$registerAITextSearchProvider(i,this.s(p)),(0,s.$Vc)(()=>{this.i.delete(p),this.h.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProviderOld(p,u){if(this.k.has(p))throw new Error(`a file search provider for the scheme '${p}' is already registered`);this.k.add(p);const i=this.d++;return this.j.set(i,new g.$5rc(u)),this.c.$registerFileSearchProvider(i,this.s(p)),(0,s.$Vc)(()=>{this.k.delete(p),this.j.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider(p,u){if(this.k.has(p))throw new Error(`a file search provider for the scheme '${p}' is already registered`);this.k.add(p);const i=this.d++;return this.j.set(i,u),this.c.$registerFileSearchProvider(i,this.s(p)),(0,s.$Vc)(()=>{this.k.delete(p),this.j.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults(p,u,i,o){const t=b(i),n=this.j.get(p);if(n)return this.l.fileSearch(t,n,r=>{this.c.$handleFileMatch(p,u,r.map(d=>d.resource))},o);throw new Error("unknown provider: "+p)}async doInternalFileSearchWithCustomCallback(p,u,i){return{messages:[]}}$clearCache(p){return this.l.clearCache(p),Promise.resolve(void 0)}$provideTextSearchResults(p,u,i,o){const t=this.e.get(p);if(!t||!t.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${p}`);const n=b(i);return this.t(n,t).search(d=>this.c.$handleTextMatch(p,u,d),o)}$provideAITextSearchResults(p,u,i,o){const t=this.h.get(p);if(!t||!t.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${p}`);const n=b(i);return this.v(n,t).search(d=>this.c.$handleTextMatch(p,u,d),o)}$enableExtensionHostSearch(){}t(p,u){return new I.$2rc({query:p,provider:u},{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}v(p,u){return new I.$2rc({query:p,provider:u},{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"aiTextSearchProvider")}};e.$_rc=P,e.$_rc=P=Ze([qe(0,O.$DQ),qe(1,C.$Sqc),qe(2,m.$dk)],P);function b($){return{...$,folderQueries:$.folderQueries&&$.folderQueries.map(a),extraFileResources:$.extraFileResources&&$.extraFileResources.map(p=>c.URI.revive(p))}}function a($){return(0,E.$fi)($)}});var Ht=this&&this.__importDefault||function(ge){return ge&&ge.__esModule?ge:{default:ge}};define(Re[345],Ce([1,0,20,12,4,3,14,44,2,113,203,204,58,23,27,11,91,92,247,6,291,318,96,127,295,296,297,276,266,34,298,42,299,101,166,300,278,292,301,302,65,79,279,293,54,303,77,304,64,29,319,280,305,306,128,307,122,123,281,336,309,251,310,320,311,172,282,312,313,314,19,315,102,124,316,283,317,125,98,100,95,48,170,99,321,294,322,323,78,15,9,284,74,285,97,324,325,165,49,119,94,25,59]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P,b,a,$,p,u,i,o,t,n,r,d,l,f,y,k,S,D,T,v,w,M,L,N,F,V,j,U,z,_,W,B,Y,x,oe,ie,me,ue,X,q,se,be,ae,we,$e,pe,Ae,je,He,Ye,xe,Fe,We,Ne,H,G,Z,ee,le,ye,Te,Ve,Ke,rt,ot,ut,at,lt,$t,it,Ie,re,ce,Se,de,ke,ne,J,Pe,Ge,Je,st,ht,ft,St,At,Qt,ei,tt,Ot){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nsc=zt,h=Ue(h),C=Ht(C),E=Ue(E),b=Ue(b),ne=Ue(ne),J=Ue(J);function zt(bt){const Dt=bt.get(me.$TQ),ti=bt.get(ie.$Dqc),ii=bt.get(x.$1qc),Gt=bt.get(B.$zrc),wt=bt.get(At.$Vqc),Lt=bt.get(lt.$XQ),ai=bt.get(T.$Yqc),Zt=bt.get(Ge.$Sqc),et=bt.get(ee.$DQ),ni=bt.get(ot.$hrc),ci=bt.get(ut.$2qc),ui=bt.get(a.$ek),kt=bt.get(a.$dk),Ut=bt.get(ke.$PGb),Nt=bt.get(n.$zqc),Bt=bt.get(St.$Msc),oi=bt.get(Te.$rrc),ri=bt.get(z.$$qc),si=bt.get($e.$vrc),Kt=bt.get(r.$Jqc),Jt=bt.get(be.$orc);et.set(i.$4N.ExtHostFileSystemInfo,ti),et.set(i.$4N.ExtHostLogLevelServiceShape,ui),et.set(i.$4N.ExtHostWorkspace,wt),et.set(i.$4N.ExtHostConfiguration,ai),et.set(i.$4N.ExtHostExtensionService,Gt),et.set(i.$4N.ExtHostStorage,ni),et.set(i.$4N.ExtHostTunnelService,Ut),et.set(i.$4N.ExtHostWindow,Bt),et.set(i.$4N.ExtHostSecretState,oi),et.set(i.$4N.ExtHostTelemetry,Lt),et.set(i.$4N.ExtHostEditorTabs,ri),et.set(i.$4N.ExtHostManagedSockets,si),et.set(i.$4N.ExtHostAuthentication,Kt),et.set(i.$4N.ExtHostChatProvider,Jt);const li=et.set(i.$4N.ExtHostDecorations,bt.get(M.$Prc)),Mt=et.set(i.$4N.ExtHostDocumentsAndEditors,bt.get(U.$OQ)),Rt=et.set(i.$4N.ExtHostCommands,bt.get(S.$ZQ)),vt=et.set(i.$4N.ExtHostTerminalService,bt.get($t.$krc)),Xt=et.set(i.$4N.ExtHostTerminalShellIntegration,bt.get(it.$Csc)),Et=et.set(i.$4N.ExtHostDebugService,bt.get(w.$Jrc)),hi=et.set(i.$4N.ExtHostSearch,bt.get(ye.$$rc)),Yt=et.set(i.$4N.ExtHostTask,bt.get(at.$Bsc)),Mi=et.set(i.$4N.ExtHostOutputService,bt.get(We.$osc)),di=et.set(i.$4N.ExtHostLocalization,bt.get(we.$urc)),yi=et.set(i.$4N.ExtHostUrls,new Je.$Jsc(et)),qt=et.set(i.$4N.ExtHostDocuments,new j.$Gqc(et,Mt)),fi=et.set(i.$4N.ExtHostDocumentContentProviders,new F.$Rrc(et,Mt,kt)),ji=et.set(i.$4N.ExtHostDocumentSaveParticipant,new V.$Src(kt,qt,et.getProxy(i.$3N.MainThreadBulkEdits))),Ct=et.set(i.$4N.ExtHostNotebook,new Ae.$bsc(et,Rt,Mt,qt,ii,hi,kt)),Ei=et.set(i.$4N.ExtHostNotebookDocuments,new He.$isc(Ct)),Oi=et.set(i.$4N.ExtHostNotebookEditors,new Ye.$jsc(kt,Ct)),gi=et.set(i.$4N.ExtHostNotebookKernels,new xe.$ksc(et,Dt,Ct,Rt,kt)),Fi=et.set(i.$4N.ExtHostNotebookRenderers,new Fe.$msc(et,Ct)),Ui=et.set(i.$4N.ExtHostNotebookDocumentSaveParticipant,new je.$hsc(kt,Ct,et.getProxy(i.$3N.MainThreadBulkEdits))),Ft=et.set(i.$4N.ExtHostEditors,new re.$Pqc(et,Mt)),Pi=et.set(i.$4N.ExtHostTreeViews,new de.$Hsc(et.getProxy(i.$3N.MainThreadTreeViews),Rt,kt)),Di=et.set(i.$4N.ExtHostEditorInsets,new k.$Qqc(et.getProxy(i.$3N.MainThreadEditorInsets),Ft,Dt.remote)),bi=et.set(i.$4N.ExtHostDiagnostics,new L.$Fqc(et,kt,ti,Mt)),wi=et.set(i.$4N.ExtHostLanguages,new ae.$fsc(et,qt,Rt.converter,Zt)),De=et.set(i.$4N.ExtHostLanguageFeatures,new q.$Hqc(et,Zt,qt,Rt,bi,kt,Nt,Lt)),Me=et.set(i.$4N.ExtHostFileSystem,new Y.$Vrc(et,De)),ve=et.set(i.$4N.ExtHostFileSystemEventService,new oe.$Wrc(et,kt,Mt)),te=et.set(i.$4N.ExtHostQuickOpen,(0,Z.$ssc)(et,wt,Rt)),Le=et.set(i.$4N.ExtHostSCM,new le.$usc(et,Rt,qt,kt)),Qe=et.set(i.$4N.ExtHostQuickDiff,new G.$rsc(et,Zt)),nt=et.set(i.$4N.ExtHostShare,new Ve.$vsc(et,Zt)),Xe=et.set(i.$4N.ExtHostComments,(0,D.$Rqc)(et,Rt,qt)),mt=et.set(i.$4N.ExtHostProgress,new H.$qsc(et.getProxy(i.$3N.MainThreadProgress))),Tt=et.set(i.$4N.ExtHostLabelService,new X.$dsc(et)),xt=et.set(i.$4N.ExtHostTheming,new ce.$Esc(et)),Vt=et.set(i.$4N.ExtHostTimeline,new Se.$Gsc(et,Rt)),Wt=et.set(i.$4N.ExtHostWebviews,new st.$6qc(et,Dt.remote,wt,kt,Nt)),Li=et.set(i.$4N.ExtHostWebviewPanels,new ht.$9qc(et,Wt,wt)),en=et.set(i.$4N.ExtHostCustomEditors,new v.$0qc(et,qt,ci,Wt,Li)),Vi=et.set(i.$4N.ExtHostWebviewViews,new ft.$Ksc(et,Wt)),Si=et.set(i.$4N.ExtHostTesting,bt.get(Ie.$Erc)),tn=et.set(i.$4N.ExtHostUriOpeners,new Pe.$Isc(et)),nn=et.set(i.$4N.ExtHostProfileContentHandlers,new Ne.$psc(et));et.set(i.$4N.ExtHostInteractive,new ue.$csc(et,Ct,Mt,Rt,kt));const zi=et.set(i.$4N.ExtHostChatAgents2,new l.$Mqc(et,kt,Rt,qt)),rn=et.set(i.$4N.ExtHostChatVariables,new f.$Nqc(et)),Bi=et.set(i.$4N.ExtHostLanguageModelTools,new se.$esc(et)),Hi=et.set(i.$4N.ExtHostAiRelatedInformation,new o.$yqc(et)),sn=et.set(i.$4N.ExtHostAiEmbeddingVector,new W.$Urc(et)),on=et.set(i.$4N.ExtHostStatusBar,new rt.$ysc(et,Rt.converter)),bn=et.set(i.$4N.ExtHostSpeech,new Ke.$wsc(et)),Ri=et.set(i.$4N.ExtHostEmbeddings,new _.$Trc(et)),Qi=Object.values(i.$4N);et.assertRegistered(Qi);const wn=new d.$Lqc(et,Mt),vn=new y.$Oqc(et),Wi=new pe.$gsc(et,kt),an=new N.$Qrc(et);return t.$Iqc.register(Rt),function(Be,mi,Gi){function dt(he){return(Ee,ze,gt)=>{const Pt=he(jt=>{try{Ee.call(ze,jt)}catch(Ai){h.$3(new Error(`[ExtensionListenerError] Extension '${Be.identifier.value}' FAILED to handle event: ${Ai.toString()}`,{cause:Ai})),Lt.onExtensionError(Be.identifier,Ai)}});return gt?.push(Pt),Pt}}const It=function(){let he=!Be.isUnderDevelopment;function Ee(){he||(kt.info(`Extension '${Be.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),he=!0)}return function ze(gt){if(Array.isArray(gt))gt.forEach(ze);else if(typeof gt=="string")Ee();else{const Pt=gt;typeof Pt.scheme>"u"&&Ee(),typeof Pt.exclusive=="boolean"&&(0,tt.$wH)(Be,"documentFiltersExclusive")}return gt}}(),yn={getSession(he,Ee,ze){return typeof ze?.forceNewSession=="object"&&ze.forceNewSession.learnMore&&(0,tt.$wH)(Be,"authLearnMore"),Kt.getSession(Be,he,Ee,ze)},getAccounts(he){return Kt.getAccounts(he)},async hasSession(he,Ee){return(0,tt.$wH)(Be,"authSession"),!!await Kt.getSession(Be,he,Ee,{silent:!0})},get onDidChangeSessions(){return dt(Kt.onDidChangeSessions)},registerAuthenticationProvider(he,Ee,ze,gt){return Kt.registerAuthenticationProvider(he,Ee,ze,gt)}},Ki={registerCommand(he,Ee,ze){return Rt.registerCommand(!0,he,Ee,ze,void 0,Be)},registerTextEditorCommand(he,Ee,ze){return Rt.registerCommand(!0,he,(...gt)=>{const Pt=Ft.getActiveTextEditor();if(!Pt){kt.warn("Cannot execute "+he+" because there is no active text editor.");return}return Pt.edit(jt=>{Ee.apply(ze,[Pt,jt,...gt])}).then(jt=>{jt||kt.warn("Edits from command "+he+" were not applied.")},jt=>{kt.warn("An error occurred while running command "+he,jt)})},void 0,void 0,Be)},registerDiffInformationCommand:(he,Ee,ze)=>((0,tt.$wH)(Be,"diffCommand"),Rt.registerCommand(!0,he,async(...gt)=>{const Pt=Mt.activeEditor(!0);if(!Pt){kt.warn("Cannot execute "+he+" because there is no active text editor.");return}const jt=await Ft.getDiffInformation(Pt.id);Ee.apply(ze,[jt,...gt])},void 0,void 0,Be)),executeCommand(he,...Ee){return Rt.executeCommand(he,...Ee)},getCommands(he=!1){return Rt.getCommands(he)}},Ji={get machineId(){return Dt.telemetryInfo.machineId},get sessionId(){return Dt.telemetryInfo.sessionId},get language(){return Dt.environment.appLanguage},get appName(){return Dt.environment.appName},get appRoot(){return Dt.environment.appRoot?.fsPath??""},get appHost(){return Dt.environment.appHost},get uriScheme(){return Dt.environment.appUriScheme},get clipboard(){return vn.value},get shell(){return vt.getDefaultShell(!1)},get onDidChangeShell(){return dt(vt.onDidChangeShell)},get isTelemetryEnabled(){return Lt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return dt(Lt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,tt.$wH)(Be,"telemetry"),Lt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,tt.$wH)(Be,"telemetry"),dt(Lt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,lt.$WQ)(Dt.telemetryInfo.firstSessionDate)},createTelemetryLogger(he,Ee){return lt.$VQ.validateSender(he),Lt.instantiateLogger(Be,he,Ee)},openExternal(he,Ee){return Bt.openUri(he,{allowTunneling:!!Dt.remote.authority,allowContributedOpeners:Ee?.allowContributedOpeners})},async asExternalUri(he){if(he.scheme===Dt.environment.appUriScheme)return yi.createAppUri(he);try{return await Bt.asExternalUri(he,{allowTunneling:!!Dt.remote.authority})}catch(Ee){if((0,O.$Rg)(he,O.Schemas.http)||(0,O.$Rg)(he,O.Schemas.https))return he;throw Ee}},get remoteName(){return(0,$.$mn)(Dt.remote.authority)},get remoteAuthority(){return(0,tt.$wH)(Be,"resolvers"),Dt.remote.authority},get uiKind(){return Dt.uiKind},get logLevel(){return kt.getLevel()},get onDidChangeLogLevel(){return dt(kt.onDidChangeLogLevel)},get appQuality(){return(0,tt.$wH)(Be,"resolvers"),Dt.quality},get appCommit(){return(0,tt.$wH)(Be,"resolvers"),Dt.commit}};Dt.environment.extensionTestsLocationURI||Object.freeze(Ji);const ki={createTestController(he,Ee,ze){return Si.createTestController(Be,he,Ee,ze)},createTestObserver(){return(0,tt.$wH)(Be,"testObserver"),Si.createTestObserver()},runTests(he){return(0,tt.$wH)(Be,"testObserver"),Si.runTests(he)},registerTestFollowupProvider(he){return(0,tt.$wH)(Be,"testObserver"),Si.registerTestFollowupProvider(he)},get onDidChangeTestResults(){return(0,tt.$wH)(Be,"testObserver"),dt(Si.onResultsChanged)},get testResults(){return(0,tt.$wH)(Be,"testObserver"),Si.results}},Ci=Dt.remote.isRemote?J.ExtensionKind.Workspace:J.ExtensionKind.UI,En={getExtension(he,Ee){(0,tt.$vH)(Be,"extensionsAny")||(Ee=!1);const ze=mi.mine.getExtensionDescription(he);if(ze)return new B.$Arc(Gt,Be.identifier,ze,Ci,!1);if(Ee){const gt=mi.all.getExtensionDescription(he);if(gt)return new B.$Arc(Gt,Be.identifier,gt,Ci,!0)}},get all(){const he=[];for(const Ee of mi.mine.getAllExtensionDescriptions())he.push(new B.$Arc(Gt,Be.identifier,Ee,Ci,!1));return he},get allAcrossExtensionHosts(){(0,tt.$wH)(Be,"extensionsAny");const he=new P.$wn(mi.mine.getAllExtensionDescriptions().map(ze=>ze.identifier)),Ee=[];for(const ze of mi.all.getAllExtensionDescriptions()){const gt=!he.has(ze.identifier);Ee.push(new B.$Arc(Gt,Be.identifier,ze,Ci,gt))}return Ee},get onDidChange(){return(0,tt.$vH)(Be,"extensionsAny")?dt(R.Event.any(mi.mine.onDidChange,mi.all.onDidChange)):dt(mi.mine.onDidChange)}},$i={createDiagnosticCollection(he){return bi.createDiagnosticCollection(Be.identifier,he)},get onDidChangeDiagnostics(){return dt(bi.onDidChangeDiagnostics)},getDiagnostics:he=>bi.getDiagnostics(he),getLanguages(){return wi.getLanguages()},setTextDocumentLanguage(he,Ee){return wi.changeLanguage(he.uri,Ee)},match(he,Ee){const ze=ne.LanguageSelector.from(he);let gt;return(0,I.$Du)(ze)&&(gt=Ct.notebookDocuments.find(Pt=>Pt.apiNotebook.getCells().find(jt=>jt.document===Ee))?.apiNotebook),(0,I.$Cu)(ze,Ee.uri,Ee.languageId,!0,gt?.uri,gt?.notebookType)},registerCodeActionsProvider(he,Ee,ze){return De.registerCodeActionProvider(Be,It(he),Ee,ze)},registerDocumentPasteEditProvider(he,Ee,ze){return(0,tt.$wH)(Be,"documentPaste"),De.registerDocumentPasteEditProvider(Be,It(he),Ee,ze)},registerCodeLensProvider(he,Ee){return De.registerCodeLensProvider(Be,It(he),Ee)},registerDefinitionProvider(he,Ee){return De.registerDefinitionProvider(Be,It(he),Ee)},registerDeclarationProvider(he,Ee){return De.registerDeclarationProvider(Be,It(he),Ee)},registerImplementationProvider(he,Ee){return De.registerImplementationProvider(Be,It(he),Ee)},registerTypeDefinitionProvider(he,Ee){return De.registerTypeDefinitionProvider(Be,It(he),Ee)},registerHoverProvider(he,Ee){return De.registerHoverProvider(Be,It(he),Ee,Be.identifier)},registerEvaluatableExpressionProvider(he,Ee){return De.registerEvaluatableExpressionProvider(Be,It(he),Ee,Be.identifier)},registerInlineValuesProvider(he,Ee){return De.registerInlineValuesProvider(Be,It(he),Ee,Be.identifier)},registerDocumentHighlightProvider(he,Ee){return De.registerDocumentHighlightProvider(Be,It(he),Ee)},registerMultiDocumentHighlightProvider(he,Ee){return De.registerMultiDocumentHighlightProvider(Be,It(he),Ee)},registerLinkedEditingRangeProvider(he,Ee){return De.registerLinkedEditingRangeProvider(Be,It(he),Ee)},registerReferenceProvider(he,Ee){return De.registerReferenceProvider(Be,It(he),Ee)},registerRenameProvider(he,Ee){return De.registerRenameProvider(Be,It(he),Ee)},registerNewSymbolNamesProvider(he,Ee){return(0,tt.$wH)(Be,"newSymbolNamesProvider"),De.registerNewSymbolNamesProvider(Be,It(he),Ee)},registerDocumentSymbolProvider(he,Ee,ze){return De.registerDocumentSymbolProvider(Be,It(he),Ee,ze)},registerWorkspaceSymbolProvider(he){return De.registerWorkspaceSymbolProvider(Be,he)},registerDocumentFormattingEditProvider(he,Ee){return De.registerDocumentFormattingEditProvider(Be,It(he),Ee)},registerDocumentRangeFormattingEditProvider(he,Ee){return De.registerDocumentRangeFormattingEditProvider(Be,It(he),Ee)},registerOnTypeFormattingEditProvider(he,Ee,ze,...gt){return De.registerOnTypeFormattingEditProvider(Be,It(he),Ee,[ze].concat(gt))},registerDocumentSemanticTokensProvider(he,Ee,ze){return De.registerDocumentSemanticTokensProvider(Be,It(he),Ee,ze)},registerDocumentRangeSemanticTokensProvider(he,Ee,ze){return De.registerDocumentRangeSemanticTokensProvider(Be,It(he),Ee,ze)},registerSignatureHelpProvider(he,Ee,ze,...gt){return typeof ze=="object"?De.registerSignatureHelpProvider(Be,It(he),Ee,ze):De.registerSignatureHelpProvider(Be,It(he),Ee,typeof ze>"u"?[]:[ze,...gt])},registerCompletionItemProvider(he,Ee,...ze){return De.registerCompletionItemProvider(Be,It(he),Ee,ze)},registerInlineCompletionItemProvider(he,Ee,ze){return Ee.handleDidShowCompletionItem&&(0,tt.$wH)(Be,"inlineCompletionsAdditions"),Ee.handleDidPartiallyAcceptCompletionItem&&(0,tt.$wH)(Be,"inlineCompletionsAdditions"),ze&&(0,tt.$wH)(Be,"inlineCompletionsAdditions"),De.registerInlineCompletionsProvider(Be,It(he),Ee,ze)},registerInlineEditProvider(he,Ee){return(0,tt.$wH)(Be,"inlineEdit"),De.registerInlineEditProvider(Be,It(he),Ee)},registerDocumentLinkProvider(he,Ee){return De.registerDocumentLinkProvider(Be,It(he),Ee)},registerColorProvider(he,Ee){return De.registerColorProvider(Be,It(he),Ee)},registerFoldingRangeProvider(he,Ee){return De.registerFoldingRangeProvider(Be,It(he),Ee)},registerSelectionRangeProvider(he,Ee){return De.registerSelectionRangeProvider(Be,he,Ee)},registerCallHierarchyProvider(he,Ee){return De.registerCallHierarchyProvider(Be,he,Ee)},registerTypeHierarchyProvider(he,Ee){return De.registerTypeHierarchyProvider(Be,he,Ee)},setLanguageConfiguration:(he,Ee)=>De.setLanguageConfiguration(Be,he,Ee),getTokenInformationAtPosition(he,Ee){return(0,tt.$wH)(Be,"tokenInformation"),wi.tokenAtPosition(he,Ee)},registerInlayHintsProvider(he,Ee){return De.registerInlayHintsProvider(Be,he,Ee)},createLanguageStatusItem(he,Ee){return wi.createLanguageStatusItem(Be,he,Ee)},registerDocumentDropEditProvider(he,Ee,ze){return De.registerDocumentOnDropEditProvider(Be,he,Ee,(0,tt.$vH)(Be,"documentPaste")?ze:void 0)}},qi={get activeTextEditor(){return Ft.getActiveTextEditor()},get visibleTextEditors(){return Ft.getVisibleTextEditors()},get activeTerminal(){return vt.activeTerminal},get terminals(){return vt.terminals},async showTextDocument(he,Ee,ze){m.URI.isUri(he)&&he.scheme===O.Schemas.vscodeRemote&&!he.authority&&Nt.report("workspace.showTextDocument",Be,"A URI of 'vscode-remote' scheme requires an authority.");const gt=await(m.URI.isUri(he)?Promise.resolve(Xi.openTextDocument(he)):Promise.resolve(he));return Ft.showTextDocument(gt,Ee,ze)},createTextEditorDecorationType(he){return Ft.createTextEditorDecorationType(Be,he)},onDidChangeActiveTextEditor(he,Ee,ze){return dt(Ft.onDidChangeActiveTextEditor)(he,Ee,ze)},onDidChangeVisibleTextEditors(he,Ee,ze){return dt(Ft.onDidChangeVisibleTextEditors)(he,Ee,ze)},onDidChangeTextEditorSelection(he,Ee,ze){return dt(Ft.onDidChangeTextEditorSelection)(he,Ee,ze)},onDidChangeTextEditorOptions(he,Ee,ze){return dt(Ft.onDidChangeTextEditorOptions)(he,Ee,ze)},onDidChangeTextEditorVisibleRanges(he,Ee,ze){return dt(Ft.onDidChangeTextEditorVisibleRanges)(he,Ee,ze)},onDidChangeTextEditorViewColumn(he,Ee,ze){return dt(Ft.onDidChangeTextEditorViewColumn)(he,Ee,ze)},onDidCloseTerminal(he,Ee,ze){return dt(vt.onDidCloseTerminal)(he,Ee,ze)},onDidOpenTerminal(he,Ee,ze){return dt(vt.onDidOpenTerminal)(he,Ee,ze)},onDidChangeActiveTerminal(he,Ee,ze){return dt(vt.onDidChangeActiveTerminal)(he,Ee,ze)},onDidChangeTerminalDimensions(he,Ee,ze){return(0,tt.$wH)(Be,"terminalDimensions"),dt(vt.onDidChangeTerminalDimensions)(he,Ee,ze)},onDidChangeTerminalState(he,Ee,ze){return dt(vt.onDidChangeTerminalState)(he,Ee,ze)},onDidWriteTerminalData(he,Ee,ze){return(0,tt.$wH)(Be,"terminalDataWriteEvent"),dt(vt.onDidWriteTerminalData)(he,Ee,ze)},onDidExecuteTerminalCommand(he,Ee,ze){return(0,tt.$wH)(Be,"terminalExecuteCommandEvent"),dt(vt.onDidExecuteTerminalCommand)(he,Ee,ze)},onDidChangeTerminalShellIntegration(he,Ee,ze){return dt(Xt.onDidChangeTerminalShellIntegration)(he,Ee,ze)},onDidStartTerminalShellExecution(he,Ee,ze){return dt(Xt.onDidStartTerminalShellExecution)(he,Ee,ze)},onDidEndTerminalShellExecution(he,Ee,ze){return dt(Xt.onDidEndTerminalShellExecution)(he,Ee,ze)},get state(){return Bt.getState()},onDidChangeWindowState(he,Ee,ze){return dt(Bt.onDidChangeWindowState)(he,Ee,ze)},showInformationMessage(he,...Ee){return Wi.showMessage(Be,C.default.Info,he,Ee[0],Ee.slice(1))},showWarningMessage(he,...Ee){return Wi.showMessage(Be,C.default.Warning,he,Ee[0],Ee.slice(1))},showErrorMessage(he,...Ee){return Wi.showMessage(Be,C.default.Error,he,Ee[0],Ee.slice(1))},showQuickPick(he,Ee,ze){return te.showQuickPick(Be,he,Ee,ze)},showWorkspaceFolderPick(he){return te.showWorkspaceFolderPick(he)},showInputBox(he,Ee){return te.showInput(he,Ee)},showOpenDialog(he){return an.showOpenDialog(Be,he)},showSaveDialog(he){return an.showSaveDialog(he)},createStatusBarItem(he,Ee,ze){let gt,Pt,jt;return typeof he=="string"?(gt=he,Pt=Ee,jt=ze):(Pt=he,jt=Ee),on.createStatusBarEntry(Be,gt,Pt,jt)},setStatusBarMessage(he,Ee){return on.setStatusBarMessage(he,Ee)},withScmProgress(he){return Nt.report("window.withScmProgress",Be,"Use 'withProgress' instead."),mt.withProgress(Be,{location:J.ProgressLocation.SourceControl},(Ee,ze)=>he({report(gt){}}))},withProgress(he,Ee){return mt.withProgress(Be,he,Ee)},createOutputChannel(he,Ee){return Mi.createOutputChannel(he,Ee,Be)},createWebviewPanel(he,Ee,ze,gt){return Li.createWebviewPanel(Be,he,Ee,ze,gt)},createWebviewTextEditorInset(he,Ee,ze,gt){return(0,tt.$wH)(Be,"editorInsets"),Di.createWebviewEditorInset(he,Ee,ze,gt,Be)},createTerminal(he,Ee,ze){return typeof he=="object"?"pty"in he?vt.createExtensionTerminal(he):vt.createTerminalFromOptions(he):vt.createTerminal(he,Ee,ze)},registerTerminalLinkProvider(he){return vt.registerLinkProvider(he)},registerTerminalProfileProvider(he,Ee){return vt.registerProfileProvider(Be,he,Ee)},registerTerminalQuickFixProvider(he,Ee){return(0,tt.$wH)(Be,"terminalQuickFixProvider"),vt.registerTerminalQuickFixProvider(he,Be.identifier.value,Ee)},registerTreeDataProvider(he,Ee){return Pi.registerTreeDataProvider(he,Ee,Be)},createTreeView(he,Ee){return Pi.createTreeView(he,Ee,Be)},registerWebviewPanelSerializer:(he,Ee)=>Li.registerWebviewPanelSerializer(Be,he,Ee),registerCustomEditorProvider:(he,Ee,ze={})=>en.registerCustomEditorProvider(Be,he,Ee,ze),registerFileDecorationProvider(he){return li.registerFileDecorationProvider(he,Be)},registerUriHandler(he){return yi.registerUriHandler(Be,he)},createQuickPick(){return te.createQuickPick(Be)},createInputBox(){return te.createInputBox(Be)},get activeColorTheme(){return xt.activeColorTheme},onDidChangeActiveColorTheme(he,Ee,ze){return dt(xt.onDidChangeActiveColorTheme)(he,Ee,ze)},registerWebviewViewProvider(he,Ee,ze){return Vi.registerWebviewViewProvider(Be,he,Ee,ze?.webviewOptions)},get activeNotebookEditor(){return Ct.activeNotebookEditor},onDidChangeActiveNotebookEditor(he,Ee,ze){return dt(Ct.onDidChangeActiveNotebookEditor)(he,Ee,ze)},get visibleNotebookEditors(){return Ct.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return dt(Ct.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(he,Ee,ze){return dt(Oi.onDidChangeNotebookEditorSelection)(he,Ee,ze)},onDidChangeNotebookEditorVisibleRanges(he,Ee,ze){return dt(Oi.onDidChangeNotebookEditorVisibleRanges)(he,Ee,ze)},showNotebookDocument(he,Ee){return Ct.showNotebookDocument(he,Ee)},registerExternalUriOpener(he,Ee,ze){return(0,tt.$wH)(Be,"externalUriOpener"),tn.registerExternalUriOpener(Be.identifier,he,Ee,ze)},registerProfileContentHandler(he,Ee){return(0,tt.$wH)(Be,"profileContentHandlers"),nn.registerProfileContentHandler(Be,he,Ee)},registerQuickDiffProvider(he,Ee,ze,gt){return(0,tt.$wH)(Be,"quickDiffProvider"),Qe.registerQuickDiffProvider(It(he),Ee,ze,gt)},get tabGroups(){return ri.tabGroups},registerShareProvider(he,Ee){return(0,tt.$wH)(Be,"shareProvider"),nt.registerShareProvider(It(he),Ee)}},Xi={get rootPath(){return Nt.report("workspace.rootPath",Be,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),wt.getPath()},set rootPath(he){throw new h.$$("rootPath")},getWorkspaceFolder(he){return wt.getWorkspaceFolder(he)},get workspaceFolders(){return wt.getWorkspaceFolders()},get name(){return wt.name},set name(he){throw new h.$$("name")},get workspaceFile(){return wt.workspaceFile},set workspaceFile(he){throw new h.$$("workspaceFile")},updateWorkspaceFolders:(he,Ee,...ze)=>wt.updateWorkspaceFolders(Be,he,Ee||0,...ze),onDidChangeWorkspaceFolders:function(he,Ee,ze){return dt(wt.onDidChangeWorkspace)(he,Ee,ze)},asRelativePath:(he,Ee)=>wt.getRelativePath(he,Ee),findFiles:(he,Ee,ze,gt)=>wt.findFiles(he,Ee,ze,Be.identifier,gt),findFiles2:(he,Ee,ze)=>((0,tt.$wH)(Be,"findFiles2"),wt.findFiles2(he,Ee,Be.identifier,ze)),findFiles2New:(he,Ee,ze)=>((0,tt.$wH)(Be,"findFiles2New"),wt.findFiles2New(he,Ee,Be.identifier,ze)),findTextInFiles:(he,Ee,ze,gt)=>{(0,tt.$wH)(Be,"findTextInFiles");let Pt,jt;return typeof Ee=="object"?(Pt=Ee,jt=ze):(Pt={},jt=Ee,gt=ze),wt.findTextInFiles(he,Pt||{},jt,Be.identifier,gt)},findTextInFilesNew:(he,Ee,ze)=>((0,tt.$wH)(Be,"findTextInFilesNew"),(0,tt.$wH)(Be,"textSearchProviderNew"),wt.findTextInFilesNew(he,Be.identifier,Ee||{},ze)),save:he=>wt.save(he),saveAs:he=>wt.saveAs(he),saveAll:he=>wt.saveAll(he),applyEdit(he,Ee){return wn.applyWorkspaceEdit(he,Be,Ee)},createFileSystemWatcher:(he,Ee,ze,gt)=>{let Pt;return typeof Ee=="boolean"?Pt={ignoreCreateEvents:!!Ee,ignoreChangeEvents:!!ze,ignoreDeleteEvents:!!gt,correlate:!1}:Ee&&((0,tt.$wH)(Be,"createFileSystemWatcher"),Pt={...Ee,correlate:!0}),ve.createFileSystemWatcher(wt,Be,he,Pt)},get textDocuments(){return qt.getAllDocumentData().map(he=>he.document)},set textDocuments(he){throw new h.$$("textDocuments")},openTextDocument(he){let Ee;const ze=he;if(typeof he=="string")Ee=Promise.resolve(m.URI.file(he));else if(m.URI.isUri(he))Ee=Promise.resolve(he);else if(!ze||typeof ze=="object")Ee=qt.createDocumentData(ze);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Ee.then(gt=>(kt.trace(`openTextDocument from ${Be.identifier}`),gt.scheme===O.Schemas.vscodeRemote&&!gt.authority&&Nt.report("workspace.openTextDocument",Be,"A URI of 'vscode-remote' scheme requires an authority."),qt.ensureDocumentData(gt).then(Pt=>Pt.document)))},onDidOpenTextDocument:(he,Ee,ze)=>dt(qt.onDidAddDocument)(he,Ee,ze),onDidCloseTextDocument:(he,Ee,ze)=>dt(qt.onDidRemoveDocument)(he,Ee,ze),onDidChangeTextDocument:(he,Ee,ze)=>dt(qt.onDidChangeDocument)(he,Ee,ze),onDidSaveTextDocument:(he,Ee,ze)=>dt(qt.onDidSaveDocument)(he,Ee,ze),onWillSaveTextDocument:(he,Ee,ze)=>dt(ji.getOnWillSaveTextDocumentEvent(Be))(he,Ee,ze),get notebookDocuments(){return Ct.notebookDocuments.map(he=>he.apiNotebook)},async openNotebookDocument(he,Ee){let ze;if(m.URI.isUri(he))ze=he,await Ct.openNotebookDocument(he);else if(typeof he=="string")ze=m.URI.revive(await Ct.createNotebookDocument({viewType:he,content:Ee}));else throw new Error("Invalid arguments");return Ct.getNotebookDocument(ze).apiNotebook},onDidSaveNotebookDocument(he,Ee,ze){return dt(Ei.onDidSaveNotebookDocument)(he,Ee,ze)},onDidChangeNotebookDocument(he,Ee,ze){return dt(Ei.onDidChangeNotebookDocument)(he,Ee,ze)},onWillSaveNotebookDocument(he,Ee,ze){return dt(Ui.getOnWillSaveNotebookDocumentEvent(Be))(he,Ee,ze)},get onDidOpenNotebookDocument(){return dt(Ct.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return dt(Ct.onDidCloseNotebookDocument)},registerNotebookSerializer(he,Ee,ze,gt){return Ct.registerNotebookSerializer(Be,he,Ee,ze,(0,tt.$vH)(Be,"notebookLiveShare")?gt:void 0)},onDidChangeConfiguration:(he,Ee,ze)=>dt(Gi.onDidChangeConfiguration)(he,Ee,ze),getConfiguration(he,Ee){return Ee=arguments.length===1?void 0:Ee,Gi.getConfiguration(he,Ee,Be)},registerTextDocumentContentProvider(he,Ee){return fi.registerTextDocumentContentProvider(he,Ee)},registerTaskProvider:(he,Ee)=>(Nt.report("window.registerTaskProvider",Be,"Use the corresponding function on the 'tasks' namespace instead"),Yt.registerTaskProvider(Be,he,Ee)),registerFileSystemProvider(he,Ee,ze){return(0,A.$Uc)(Me.registerFileSystemProvider(Be,he,Ee,ze),ii.addFileSystemProvider(he,Ee,ze))},get fs(){return ii.value},registerFileSearchProvider:(he,Ee)=>((0,tt.$wH)(Be,"fileSearchProvider"),hi.registerFileSearchProviderOld(he,Ee)),registerTextSearchProvider:(he,Ee)=>((0,tt.$wH)(Be,"textSearchProvider"),hi.registerTextSearchProviderOld(he,Ee)),registerAITextSearchProvider:(he,Ee)=>((0,tt.$wH)(Be,"aiTextSearchProvider"),(0,tt.$wH)(Be,"textSearchProvider"),hi.registerAITextSearchProviderOld(he,Ee)),registerFileSearchProviderNew:(he,Ee)=>((0,tt.$wH)(Be,"fileSearchProviderNew"),{dispose:()=>{}}),registerTextSearchProviderNew:(he,Ee)=>((0,tt.$wH)(Be,"textSearchProviderNew"),{dispose:()=>{}}),registerAITextSearchProviderNew:(he,Ee)=>((0,tt.$wH)(Be,"aiTextSearchProviderNew"),(0,tt.$wH)(Be,"textSearchProviderNew"),{dispose:()=>{}}),registerRemoteAuthorityResolver:(he,Ee)=>((0,tt.$wH)(Be,"resolvers"),Gt.registerRemoteAuthorityResolver(he,Ee)),registerResourceLabelFormatter:he=>((0,tt.$wH)(Be,"resolvers"),Tt.$registerResourceLabelFormatter(he)),getRemoteExecServer:he=>((0,tt.$wH)(Be,"resolvers"),Gt.getRemoteExecServer(he)),onDidCreateFiles:(he,Ee,ze)=>dt(ve.onDidCreateFile)(he,Ee,ze),onDidDeleteFiles:(he,Ee,ze)=>dt(ve.onDidDeleteFile)(he,Ee,ze),onDidRenameFiles:(he,Ee,ze)=>dt(ve.onDidRenameFile)(he,Ee,ze),onWillCreateFiles:(he,Ee,ze)=>dt(ve.getOnWillCreateFileEvent(Be))(he,Ee,ze),onWillDeleteFiles:(he,Ee,ze)=>dt(ve.getOnWillDeleteFileEvent(Be))(he,Ee,ze),onWillRenameFiles:(he,Ee,ze)=>dt(ve.getOnWillRenameFileEvent(Be))(he,Ee,ze),openTunnel:he=>((0,tt.$wH)(Be,"tunnels"),Ut.openTunnel(Be,he).then(Ee=>{if(!Ee)throw new Error("cannot open tunnel");return Ee})),get tunnels(){return(0,tt.$wH)(Be,"tunnels"),Ut.getTunnels()},onDidChangeTunnels:(he,Ee,ze)=>((0,tt.$wH)(Be,"tunnels"),dt(Ut.onDidChangeTunnels)(he,Ee,ze)),registerPortAttributesProvider:(he,Ee)=>((0,tt.$wH)(Be,"portsAttributes"),Ut.registerPortsAttributesProvider(he,Ee)),registerTunnelProvider:(he,Ee)=>((0,tt.$wH)(Be,"tunnelFactory"),Ut.registerTunnelProvider(he,Ee)),registerTimelineProvider:(he,Ee)=>((0,tt.$wH)(Be,"timeline"),Vt.registerTimelineProvider(he,Ee,Be.identifier,Rt.converter)),get isTrusted(){return wt.trusted},requestWorkspaceTrust:he=>((0,tt.$wH)(Be,"workspaceTrust"),wt.requestWorkspaceTrust(he)),onDidGrantWorkspaceTrust:(he,Ee,ze)=>dt(wt.onDidGrantWorkspaceTrust)(he,Ee,ze),registerEditSessionIdentityProvider:(he,Ee)=>((0,tt.$wH)(Be,"editSessionIdentityProvider"),wt.registerEditSessionIdentityProvider(he,Ee)),onWillCreateEditSessionIdentity:(he,Ee,ze)=>((0,tt.$wH)(Be,"editSessionIdentityProvider"),dt(wt.getOnWillCreateEditSessionIdentityEvent(Be))(he,Ee,ze)),registerCanonicalUriProvider:(he,Ee)=>((0,tt.$wH)(Be,"canonicalUriProvider"),wt.registerCanonicalUriProvider(he,Ee)),getCanonicalUri:(he,Ee,ze)=>((0,tt.$wH)(Be,"canonicalUriProvider"),wt.provideCanonicalUri(he,Ee,ze))},cn={get inputBox(){return Nt.report("scm.inputBox",Be,"Use 'SourceControl.inputBox' instead"),Le.getLastInputBox(Be)},createSourceControl(he,Ee,ze){return Le.createSourceControl(Be,he,Ee,ze)}},ln={createCommentController(he,Ee){return Xe.createCommentController(Be,he,Ee)}},un={get activeDebugSession(){return Et.activeDebugSession},get activeDebugConsole(){return Et.activeDebugConsole},get breakpoints(){return Et.breakpoints},get activeStackItem(){return Et.activeStackItem},registerDebugVisualizationProvider(he,Ee){return(0,tt.$wH)(Be,"debugVisualization"),Et.registerDebugVisualizationProvider(Be,he,Ee)},registerDebugVisualizationTreeProvider(he,Ee){return(0,tt.$wH)(Be,"debugVisualization"),Et.registerDebugVisualizationTree(Be,he,Ee)},onDidStartDebugSession(he,Ee,ze){return dt(Et.onDidStartDebugSession)(he,Ee,ze)},onDidTerminateDebugSession(he,Ee,ze){return dt(Et.onDidTerminateDebugSession)(he,Ee,ze)},onDidChangeActiveDebugSession(he,Ee,ze){return dt(Et.onDidChangeActiveDebugSession)(he,Ee,ze)},onDidReceiveDebugSessionCustomEvent(he,Ee,ze){return dt(Et.onDidReceiveDebugSessionCustomEvent)(he,Ee,ze)},onDidChangeBreakpoints(he,Ee,ze){return dt(Et.onDidChangeBreakpoints)(he,Ee,ze)},onDidChangeActiveStackItem(he,Ee,ze){return dt(Et.onDidChangeActiveStackItem)(he,Ee,ze)},registerDebugConfigurationProvider(he,Ee,ze){return Et.registerDebugConfigurationProvider(he,Ee,ze||Qt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(he,Ee){return Et.registerDebugAdapterDescriptorFactory(Be,he,Ee)},registerDebugAdapterTrackerFactory(he,Ee){return Et.registerDebugAdapterTrackerFactory(he,Ee)},startDebugging(he,Ee,ze){return!ze||typeof ze=="object"&&"configuration"in ze?Et.startDebugging(he,Ee,{parentSession:ze}):Et.startDebugging(he,Ee,ze||{})},stopDebugging(he){return Et.stopDebugging(he)},addBreakpoints(he){return Et.addBreakpoints(he)},removeBreakpoints(he){return Et.removeBreakpoints(he)},asDebugSourceUri(he,Ee){return Et.asDebugSourceUri(he,Ee)}},Sn={registerTaskProvider:(he,Ee)=>Yt.registerTaskProvider(Be,he,Ee),fetchTasks:he=>Yt.fetchTasks(he),executeTask:he=>Yt.executeTask(Be,he),get taskExecutions(){return Yt.taskExecutions},onDidStartTask:(he,Ee,ze)=>dt(Yt.onDidStartTask)(he,Ee,ze),onDidEndTask:(he,Ee,ze)=>dt(Yt.onDidEndTask)(he,Ee,ze),onDidStartTaskProcess:(he,Ee,ze)=>dt(Yt.onDidStartTaskProcess)(he,Ee,ze),onDidEndTaskProcess:(he,Ee,ze)=>dt(Yt.onDidEndTaskProcess)(he,Ee,ze)},hn={createNotebookController(he,Ee,ze,gt,Pt){return gi.createNotebookController(Be,he,Ee,ze,gt,(0,tt.$vH)(Be,"notebookMessaging")?Pt:void 0)},registerNotebookCellStatusBarItemProvider:(he,Ee)=>Ct.registerNotebookCellStatusBarItemProvider(Be,he,Ee),createRendererMessaging(he){return Fi.createRendererMessaging(Be,he)},createNotebookControllerDetectionTask(he){return(0,tt.$wH)(Be,"notebookKernelSource"),gi.createNotebookControllerDetectionTask(Be,he)},registerKernelSourceActionProvider(he,Ee){return(0,tt.$wH)(Be,"notebookKernelSource"),gi.registerKernelSourceActionProvider(Be,he,Ee)},onDidChangeNotebookCellExecutionState(he,Ee,ze){return(0,tt.$wH)(Be,"notebookCellExecutionState"),dt(gi.onDidChangeNotebookCellExecutionState)(he,Ee,ze)}},dn={t(...he){if(typeof he[0]=="string"){const Ee=he.shift(),ze=!he||typeof he[0]!="object"?he:he[0];return di.getMessage(Be.identifier.value,{message:Ee,args:ze})}return di.getMessage(Be.identifier.value,he[0])},get bundle(){return di.getBundle(Be.identifier.value)},get uri(){return di.getBundleUri(Be.identifier.value)}},kn={transferActiveChat(he){return(0,tt.$wH)(Be,"interactive"),zi.transferActiveChat(he)}},In={getRelatedInformation(he,Ee){return(0,tt.$wH)(Be,"aiRelatedInformation"),Hi.getRelatedInformation(Be,he,Ee)},registerRelatedInformationProvider(he,Ee){return(0,tt.$wH)(Be,"aiRelatedInformation"),Hi.registerRelatedInformationProvider(Be,he,Ee)},registerEmbeddingVectorProvider(he,Ee){return(0,tt.$wH)(Be,"aiRelatedInformation"),sn.registerEmbeddingVectorProvider(Be,he,Ee)}},fn={registerChatResponseProvider(he,Ee,ze){return(0,tt.$wH)(Be,"chatProvider"),Jt.registerLanguageModel(Be,he,Ee,ze)},registerChatVariableResolver(he,Ee,ze,gt,Pt,jt,Ai,Yi){return(0,tt.$wH)(Be,"chatVariableResolver"),rn.registerVariableResolver(Be,he,Ee,ze,gt,Pt,jt,Ai,Yi?.id)},registerMappedEditsProvider(he,Ee){return(0,tt.$wH)(Be,"mappedEditsProvider"),De.registerMappedEditsProvider(Be,he,Ee)},createChatParticipant(he,Ee){return zi.createChatAgent(Be,he,Ee)},createDynamicChatParticipant(he,Ee,ze){return(0,tt.$wH)(Be,"chatParticipantPrivate"),zi.createDynamicChatAgent(Be,he,Ee,ze)},registerChatParticipantDetectionProvider(he){return(0,tt.$wH)(Be,"chatParticipantAdditions"),zi.registerChatParticipantDetectionProvider(he)}},Zi={selectChatModels:he=>Jt.selectLanguageModels(Be,he??{}),onDidChangeChatModels:(he,Ee,ze)=>Jt.onDidChangeProviders(he,Ee,ze),registerChatModelProvider:(he,Ee,ze)=>((0,tt.$wH)(Be,"chatProvider"),Jt.registerLanguageModel(Be,he,Ee,ze)),get embeddingModels(){return(0,tt.$wH)(Be,"embeddings"),Ri.embeddingsModels},onDidChangeEmbeddingModels:(he,Ee,ze)=>((0,tt.$wH)(Be,"embeddings"),Ri.onDidChange(he,Ee,ze)),registerEmbeddingsProvider(he,Ee){return(0,tt.$wH)(Be,"embeddings"),Ri.registerEmbeddingsProvider(Be,he,Ee)},async computeEmbeddings(he,Ee,ze){return(0,tt.$wH)(Be,"embeddings"),Ri.computeEmbeddings(he,Ee,ze)},registerTool(he,Ee){return(0,tt.$wH)(Be,"lmTools"),Bi.registerTool(Be,he,Ee)},invokeTool(he,Ee,ze){return(0,tt.$wH)(Be,"lmTools"),Bi.invokeTool(he,Ee,ze)},get tools(){return(0,tt.$wH)(Be,"lmTools"),Bi.tools}},gn={registerSpeechProvider(he,Ee){return(0,tt.$wH)(Be,"speech"),bn.registerProvider(Be.identifier,he,Ee)}};return{version:Dt.version,ai:In,authentication:yn,commands:Ki,comments:ln,chat:fn,debug:un,env:Ji,extensions:En,interactive:kn,l10n:dn,languages:$i,lm:Zi,notebooks:hn,scm:cn,speech:gn,tasks:Sn,tests:ki,window:qi,workspace:Xi,Breakpoint:J.$8O,TerminalOutputAnchor:J.TerminalOutputAnchor,ChatResultFeedbackKind:J.ChatResultFeedbackKind,ChatVariableLevel:J.ChatVariableLevel,ChatCompletionItem:J.$4P,CallHierarchyIncomingCall:J.$tO,CallHierarchyItem:J.$sO,CallHierarchyOutgoingCall:J.$uO,CancellationError:h.$7,CancellationTokenSource:s.$ze,CandidatePortSource:i.CandidatePortSource,CodeAction:J.$pO,CodeActionKind:J.$qO,CodeActionTriggerKind:J.CodeActionTriggerKind,CodeLens:J.$vO,Color:J.$IO,ColorInformation:J.$JO,ColorPresentation:J.$KO,ColorThemeKind:J.ColorThemeKind,CommentMode:J.CommentMode,CommentState:J.CommentState,CommentThreadCollapsibleState:J.CommentThreadCollapsibleState,CommentThreadState:J.CommentThreadState,CommentThreadApplicability:J.CommentThreadApplicability,CommentThreadFocus:J.CommentThreadFocus,CompletionItem:J.$CO,CompletionItemKind:J.CompletionItemKind,CompletionItemTag:J.CompletionItemTag,CompletionList:J.$DO,CompletionTriggerKind:J.CompletionTriggerKind,ConfigurationTarget:J.ConfigurationTarget,CustomExecution:J.$SO,DebugAdapterExecutable:J.$_O,DebugAdapterInlineImplementation:J.$cP,DebugAdapterNamedPipeServer:J.$bP,DebugAdapterServer:J.$aP,DebugConfigurationProviderTriggerKind:Qt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:J.DebugConsoleMode,DebugVisualization:J.$sP,DecorationRangeBehavior:J.DecorationRangeBehavior,Diagnostic:J.$iO,DiagnosticRelatedInformation:J.$hO,DiagnosticSeverity:J.DiagnosticSeverity,DiagnosticTag:J.DiagnosticTag,Disposable:J.$5N,DocumentHighlight:J.$lO,DocumentHighlightKind:J.DocumentHighlightKind,MultiDocumentHighlight:J.$mO,DocumentLink:J.$HO,DocumentSymbol:J.$oO,EndOfLine:J.EndOfLine,EnvironmentVariableMutatorType:J.EnvironmentVariableMutatorType,EvaluatableExpression:J.$fP,InlineValueText:J.$gP,InlineValueVariableLookup:J.$hP,InlineValueEvaluatableExpression:J.$iP,InlineCompletionTriggerKind:J.InlineCompletionTriggerKind,EventEmitter:R.$oe,ExtensionKind:J.ExtensionKind,ExtensionMode:J.ExtensionMode,ExternalUriOpenerPriority:J.ExternalUriOpenerPriority,FileChangeType:J.FileChangeType,FileDecoration:J.$uP,FileDecoration2:J.$uP,FileSystemError:J.$lP,FileType:b.FileType,FilePermission:b.FilePermission,FoldingRange:J.$mP,FoldingRangeKind:J.FoldingRangeKind,FunctionBreakpoint:J.$0O,InlineCompletionItem:J.$EO,InlineCompletionList:J.$FO,Hover:J.$jO,VerboseHover:J.$kO,HoverVerbosityAction:J.HoverVerbosityAction,IndentAction:E.IndentAction,Location:J.$gO,MarkdownString:J.$wO,OverviewRulerLane:g.OverviewRulerLane,ParameterInformation:J.$xO,PortAutoForwardAction:J.PortAutoForwardAction,Position:J.$6N,ProcessExecution:J.$QO,ProgressLocation:J.ProgressLocation,QuickInputButtonLocation:J.QuickInputButtonLocation,QuickInputButtons:J.$tP,Range:J.$7N,RelativePattern:J.$6O,Selection:J.$8N,SelectionRange:J.$rO,SemanticTokens:J.$pP,SemanticTokensBuilder:J.$oP,SemanticTokensEdit:J.$qP,SemanticTokensEdits:J.$rP,SemanticTokensLegend:J.$nP,ShellExecution:J.$RO,ShellQuoting:J.ShellQuoting,SignatureHelp:J.$zO,SignatureHelpTriggerKind:J.SignatureHelpTriggerKind,SignatureInformation:J.$yO,SnippetString:J.$fO,SourceBreakpoint:J.$9O,StandardTokenType:J.StandardTokenType,StatusBarAlignment:J.StatusBarAlignment,SymbolInformation:J.$nO,SymbolKind:J.SymbolKind,SymbolTag:J.SymbolTag,Task:J.$TO,TaskGroup:J.$PO,TaskPanelKind:J.TaskPanelKind,TaskRevealKind:J.TaskRevealKind,TaskScope:J.TaskScope,TerminalLink:J.$LO,TerminalQuickFixTerminalCommand:J.$NO,TerminalQuickFixOpener:J.$MO,TerminalLocation:J.TerminalLocation,TerminalProfile:J.$OO,TerminalExitReason:J.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:J.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:J.TextDocumentSaveReason,TextEdit:J.$bO,SnippetTextEdit:J.$dO,TextEditorCursorStyle:c.TextEditorCursorStyle,TextEditorLineNumbersStyle:J.TextEditorLineNumbersStyle,TextEditorRevealType:J.TextEditorRevealType,TextEditorSelectionChangeKind:J.TextEditorSelectionChangeKind,SyntaxTokenType:J.SyntaxTokenType,TextDocumentChangeReason:J.TextDocumentChangeReason,ThemeColor:J.$5O,ThemeIcon:J.$4O,TreeItem:J.$UO,TreeItemCheckboxState:J.TreeItemCheckboxState,TreeItemCollapsibleState:J.TreeItemCollapsibleState,TypeHierarchyItem:J.$RP,UIKind:ei.UIKind,Uri:m.URI,ViewColumn:J.ViewColumn,WorkspaceEdit:J.$eO,DocumentPasteTriggerKind:J.DocumentPasteTriggerKind,DocumentDropEdit:J.$1O,DocumentDropOrPasteEditKind:J.$2O,DocumentPasteEdit:J.$3O,InlayHint:J.$BO,InlayHintLabelPart:J.$AO,InlayHintKind:J.InlayHintKind,RemoteAuthorityResolverError:J.$aO,ResolvedAuthority:J.$$N,ManagedResolvedAuthority:J.$_N,SourceControlInputBoxValidationType:J.SourceControlInputBoxValidationType,ExtensionRuntime:J.ExtensionRuntime,TimelineItem:J.$EP,NotebookRange:J.$wP,NotebookCellKind:J.NotebookCellKind,NotebookCellExecutionState:J.NotebookCellExecutionState,NotebookCellData:J.$xP,NotebookData:J.$yP,NotebookRendererScript:J.$CP,NotebookCellStatusBarAlignment:J.NotebookCellStatusBarAlignment,NotebookEditorRevealType:J.NotebookEditorRevealType,NotebookCellOutput:J.$AP,NotebookCellOutputItem:J.$zP,NotebookCellStatusBarItem:J.$BP,NotebookControllerAffinity:J.NotebookControllerAffinity,NotebookControllerAffinity2:J.NotebookControllerAffinity2,NotebookEdit:J.$cO,NotebookKernelSourceAction:J.$DP,NotebookVariablesRequestKind:J.NotebookVariablesRequestKind,PortAttributes:J.$GP,LinkedEditingRanges:J.$FP,TestResultState:J.TestResultState,TestRunRequest:J.$HP,TestMessage:J.$IP,TestMessageStackFrame:J.$KP,TestTag:J.$JP,TestRunProfileKind:J.TestRunProfileKind,TextSearchCompleteMessageType:Ot.TextSearchCompleteMessageType,DataTransfer:J.$ZO,DataTransferItem:J.$VO,TestCoverageCount:J.$LP,FileCoverage:J.$NP,FileCoverage2:J.$NP,StatementCoverage:J.$OP,BranchCoverage:J.$PP,DeclarationCoverage:J.$QP,WorkspaceTrustState:J.WorkspaceTrustState,LanguageStatusSeverity:J.LanguageStatusSeverity,QuickPickItemKind:J.QuickPickItemKind,InputBoxValidationSeverity:J.InputBoxValidationSeverity,TabInputText:J.$SP,TabInputTextDiff:J.$TP,TabInputTextMerge:J.$UP,TabInputCustom:J.$VP,TabInputNotebook:J.$XP,TabInputNotebookDiff:J.$YP,TabInputWebview:J.$WP,TabInputTerminal:J.$ZP,TabInputInteractiveWindow:J.$1P,TabInputChat:J.$2P,TabInputTextMultiDiff:J.$3P,TelemetryTrustedValue:p.$Bp,LogLevel:a.LogLevel,EditSessionIdentityMatch:u.EditSessionIdentityMatch,InteractiveSessionVoteDirection:J.InteractiveSessionVoteDirection,ChatCopyKind:J.ChatCopyKind,InteractiveEditorResponseFeedbackKind:J.InteractiveEditorResponseFeedbackKind,DebugStackFrame:J.$dP,DebugThread:J.$eP,RelatedInformationType:J.RelatedInformationType,SpeechToTextStatus:J.SpeechToTextStatus,TextToSpeechStatus:J.TextToSpeechStatus,PartialAcceptTriggerKind:J.PartialAcceptTriggerKind,KeywordRecognitionStatus:J.KeywordRecognitionStatus,ChatResponseMarkdownPart:J.$5P,ChatResponseFileTreePart:J.$9P,ChatResponseAnchorPart:J.$0P,ChatResponseProgressPart:J.$$P,ChatResponseProgressPart2:J.$_P,ChatResponseReferencePart:J.$cQ,ChatResponseReferencePart2:J.$cQ,ChatResponseCodeCitationPart:J.$dQ,ChatResponseWarningPart:J.$aQ,ChatResponseTextEditPart:J.$fQ,ChatResponseMarkdownWithVulnerabilitiesPart:J.$6P,ChatResponseCommandButtonPart:J.$bQ,ChatResponseDetectedParticipantPart:J.$7P,ChatResponseConfirmationPart:J.$8P,ChatResponseMovePart:J.$eQ,ChatResponseReferencePartStatusKind:J.ChatResponseReferencePartStatusKind,ChatRequestTurn:J.$gQ,ChatResponseTurn:J.$hQ,ChatLocation:J.ChatLocation,ChatRequestEditorData:J.$iQ,ChatRequestNotebookData:J.$jQ,LanguageModelChatMessageRole:J.LanguageModelChatMessageRole,LanguageModelChatMessage:J.$lQ,LanguageModelChatMessageFunctionResultPart:J.$kQ,LanguageModelChatResponseTextPart:J.$nQ,LanguageModelChatResponseFunctionUsePart:J.$mQ,LanguageModelError:J.$rQ,NewSymbolName:J.$kP,NewSymbolNameTag:J.NewSymbolNameTag,NewSymbolNameTriggerKind:J.NewSymbolNameTriggerKind,InlineEdit:J.$sQ,InlineEditTriggerKind:J.InlineEditTriggerKind,ExcludeSettingOptions:Ot.ExcludeSettingOptions,TextSearchContextNew:Ot.$gM,TextSearchMatchNew:Ot.$fM,TextSearchCompleteMessageTypeNew:Ot.TextSearchCompleteMessageType}}}}),define(Re[346],Ce([1,0,89,172,49,166,42,34,65,48,100,101,102,125,78,96,165,77,64,124,95,79,164,11,66,122,123,127,128,170,99]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P,b,a,$,p,u,i,o,t,n,r,d,l,f,y,k,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,s.$Xs)(l.$urc,l.$trc,s.InstantiationType.Delayed),(0,s.$Xs)(r.$ek,n.$Osc,s.InstantiationType.Delayed),(0,s.$Xs)(a.$zqc,a.$Aqc,s.InstantiationType.Delayed),(0,s.$Xs)(C.$ZQ,C.$YQ,s.InstantiationType.Eager),(0,s.$Xs)(y.$Jqc,y.$Kqc,s.InstantiationType.Eager),(0,s.$Xs)(k.$orc,k.$prc,s.InstantiationType.Eager),(0,s.$Xs)(O.$Yqc,O.$Wqc,s.InstantiationType.Eager),(0,s.$Xs)(p.$1qc,p.$Zqc,s.InstantiationType.Eager),(0,s.$Xs)(D.$Erc,D.$Frc,s.InstantiationType.Eager),(0,s.$Xs)(E.$Jrc,E.$Nrc,s.InstantiationType.Eager),(0,s.$Xs)(A.$Prc,A.$Orc,s.InstantiationType.Eager),(0,s.$Xs)(m.$OQ,m.$NQ,s.InstantiationType.Eager),(0,s.$Xs)(f.$vrc,f.$wrc,s.InstantiationType.Eager),(0,s.$Xs)(u.$Dqc,u.$Cqc,s.InstantiationType.Eager),(0,s.$Xs)(h.$osc,h.$nsc,s.InstantiationType.Delayed),(0,s.$Xs)(g.$$rc,g.$_rc,s.InstantiationType.Eager),(0,s.$Xs)(P.$hrc,P.$grc,s.InstantiationType.Eager),(0,s.$Xs)(I.$Bsc,I.$Asc,s.InstantiationType.Eager),(0,s.$Xs)(c.$krc,c.$nrc,s.InstantiationType.Eager),(0,s.$Xs)(S.$Csc,S.$Dsc,s.InstantiationType.Eager),(0,s.$Xs)(b.$PGb,b.$QGb,s.InstantiationType.Eager),(0,s.$Xs)($.$Msc,$.$Lsc,s.InstantiationType.Eager),(0,s.$Xs)(R.$Vqc,R.$Uqc,s.InstantiationType.Eager),(0,s.$Xs)(i.$rrc,i.$qrc,s.InstantiationType.Eager),(0,s.$Xs)(o.$XQ,o.$UQ,s.InstantiationType.Eager),(0,s.$Xs)(t.$$qc,t.$_qc,s.InstantiationType.Eager),(0,s.$Xs)(d.$Crc,d.$Drc,s.InstantiationType.Eager)}),define(Re[129],Ce([1,0,11,35,59]),function(ge,e,s,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8sc=void 0,e.$5sc=A,e.$6sc=O,e.$7sc=C,R=Ue(R);function A(c){return c.startsWith("**")||c.startsWith("/")?c:`/${c}`}function O(c){return new h.$tM(c.start.line,c.start.character,c.end.line,c.end.character)}function C(c){return new R.$eM(c.startLineNumber,c.startColumn,c.endLineNumber,c.endColumn)}let m=class{constructor(I,E){this.a=I,this.b=E}appendLine(I){this.b.debug(`${this.a}#search`,I)}};e.$8sc=m,e.$8sc=m=Ze([qe(1,s.$dk)],m)}),define(Re[347],Ce([1,0,56,16,83,31,10,13,129,348]),function(ge,e,s,h,R,A,O,C,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9sc=E,e.$0sc=$,e.$$sc=u,s=Ue(s),h=Ue(h),A=Ue(A),C=Ue(C);const I=c.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function E(i,o,t,n,r){const d=g(i,o,t,n,r),l=o.folder.fsPath;return{cmd:s.spawn(I,d.args,{cwd:l}),rgDiskPath:I,siblingClauses:d.siblingClauses,rgArgs:d,cwd:l}}function g(i,o,t,n,r){const d=["--files","--hidden","--case-sensitive","--no-require-git"];b([o],t,!1).forEach(f=>{const y=(0,m.$5sc)(f);if(d.push("-g",y),O.$k){const k=(0,R.$rm)(y);k!==y&&d.push("-g",k)}});const l=P([o],n,void 0,!1);return l.globArgs.forEach(f=>{const y=`!${(0,m.$5sc)(f)}`;if(d.push("-g",y),O.$k){const k=(0,R.$rm)(y);k!==y&&d.push("-g",k)}}),o.disregardIgnoreFiles!==!1?d.push("--no-ignore"):o.disregardParentIgnoreFiles!==!1&&d.push("--no-ignore-parent"),o.ignoreSymlinks||d.push("--follow"),i.exists&&d.push("--quiet"),r&&d.push("--threads",`${r}`),d.push("--no-config"),o.disregardGlobalIgnoreFiles&&d.push("--no-ignore-global"),{args:d,siblingClauses:l.siblingClauses}}function P(i,o,t,n=!0){const r=[];let d={};return i.forEach(l=>{const f=Object.assign({},l.excludePattern||{},o||{}),y=a(f,n?l.folder.fsPath:void 0,t);r.push(...y.globArgs),y.siblingClauses&&(d=Object.assign(d,y.siblingClauses))}),{globArgs:r,siblingClauses:d}}function b(i,o,t=!0){const n=[];return i.forEach(r=>{const d=Object.assign({},o||{},r.includePattern||{}),l=a(d,t?r.folder.fsPath:void 0);n.push(...l.globArgs)}),n}function a(i,o,t){const n=[],r={};return Object.keys(i).forEach(d=>{if(t&&t.has(d)||!d)return;const l=i[d];d=p(o?$(o,d):d),d.startsWith("\\\\")?d="\\\\"+d.substr(2).replace(/\\/g,"/"):d=d.replace(/\\/g,"/"),typeof l=="boolean"&&l?(d.startsWith("\\\\")&&(d+="**"),n.push(u(d))):l&&l.when&&(r[d]=l)}),{globArgs:n,siblingClauses:r}}function $(i,o){return h.$lc(o)?o:h.$mc(i,o)}function p(i){return i=C.$qf(i,"\\"),C.$qf(i,"/")}function u(i){return A.$Dg(i).toLowerCase()==="c:/"?i.replace(/^c:[/\\]/i,"/"):i}}),define(Re[349],Ce([1,0,56,45,16,350,18,52,39,83,31,10,43,13,17,33,35,347,137]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P,b,a,$,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$atc=e.$_sc=void 0,s=Ue(s),h=Ue(h),R=Ue(R),O=Ue(O),m=Ue(m),c=Ue(c),E=Ue(E),P=Ue(P),b=Ue(b);const i=new Set;process.on("exit",()=>{i.forEach(d=>d())});class o{constructor(l){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=l,this.b=l.filePattern||"",this.d=l.includePattern&&m.$Dk(l.includePattern),this.f=l.maxResults||null,this.g=!!l.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=l.shouldGlobMatchFilePattern?null:(0,u.$Xr)(this.b).normalizedLowercase),this.u=l.excludePattern&&m.$Dk(l.excludePattern),this.t=new Map,l.folderQueries.forEach(f=>{const y={};f.excludePattern?.forEach(S=>{Object.assign(y,S.pattern||{},this.a.excludePattern||{})}),f.excludePattern?.length||Object.assign(y,this.a.excludePattern||{});const k=f.folder.fsPath;l.folderQueries.map(S=>S.folder.fsPath).filter(S=>S!==k).forEach(S=>{(0,I.$Hg)(S,k)&&(y[R.$oc(k,S)]=!0)}),this.t.set(k,new n(y,k))})}cancel(){this.l=!0,i.forEach(l=>l())}walk(l,f,y,k,S,D){if(this.m=g.$ie.create(!1),this.l)return D(null,this.j);f.forEach(T=>{const v=R.$qc(T.fsPath);this.u&&this.u(T.fsPath,v)||this.J(k,{relativePath:T.fsPath,searchPath:void 0})}),this.r=g.$ie.create(!1),this.w(l,(T,v)=>{this.x(this.y,this,T,y,k,S,w=>{if(w){const M=(0,C.$tj)(w);console.error(M),this.q.push(M),v(w,void 0)}else v(null,void 0)})},(T,v)=>{this.m.stop();const w=T?O.$Jb(T)[0]:null;D(w,this.j)})}w(l,f,y){const k=new Array(l.length),S=new Array(l.length);let D=!1,T=0;if(l.length===0)return y(null,[]);l.forEach((v,w)=>{f(v,(M,L)=>{if(M?(D=!0,k[w]=null,S[w]=M):(k[w]=L,S[w]=null),++T===l.length)return y(D?S:null,k)})})}x(l,f,...y){try{l.apply(f,y)}catch(k){y[y.length-1](k)}}y(l,f,y,k,S){const D=l.folder.fsPath,T=E.$k,v=()=>F&&F.kill();i.add(v);let w=z=>{i.delete(v),w=()=>{},S(z)},M="";const L=this.D(),N=(0,p.$9sc)(this.a,l,this.a.includePattern,this.t.get(l.folder.fsPath).expression,f),F=N.cmd,V=!Object.keys(N.siblingClauses).length,j=N.rgArgs.args.map(z=>z.match(/^-/)?z:`'${z}'`).join(" ");let U=`${N.rgDiskPath} ${j}
 - cwd: ${N.cwd}`;N.rgArgs.siblingClauses&&(U+=`
 - Sibling clauses: ${JSON.stringify(N.rgArgs.siblingClauses)}`),k({message:U}),this.s=0,this.z(F,"utf8",k,(z,_,W)=>{if(z){w(z);return}if(this.j){w();return}const Y=(M+(T?c.$qm(_||""):_)).split(`
`);if(W){const x=Y.length;Y[x-1]=Y[x-1].trim(),Y[x-1]||Y.pop()}else M=Y.pop()||"";if(Y.length&&Y[0].indexOf(`
`)!==-1){w(new Error("Splitting up files failed"));return}if(this.s+=Y.length,V){for(const x of Y)if(this.J(y,{base:D,relativePath:x,searchPath:this.N(l,x)}),this.j){v();break}(W||this.j)&&w();return}this.G(l,L,D,Y,y),W&&(this.H(L,D,y),w())})}spawnFindCmd(l){const f=this.t.get(l.folder.fsPath),y=f.getBasenameTerms(),k=f.getPathTerms(),S=["-L","."];if(y.length||k.length){S.push("-not","(","(");for(const D of y)S.push("-name",D),S.push("-o");for(const D of k)S.push("-path",D),S.push("-o");S.pop(),S.push(")","-prune",")")}return S.push("-type","f"),s.spawn("find",S,{cwd:l.folder.fsPath})}readStdout(l,f,y){let k="";this.z(l,f,()=>{},(S,D,T)=>{if(S){y(S);return}k+=D,T&&y(null,k)})}z(l,f,y,k){let S=(v,w,M)=>{(v||M)&&(S=()=>{},this.r?.stop()),k(v,w,M)},D=!1;l.stdout?(this.A(l.stdout,f,S),l.stdout.once("data",()=>D=!0)):y({message:"stdout is null"});let T;l.stderr?T=this.B(l.stderr):y({message:"stderr is null"}),l.on("error",v=>{S(v)}),l.on("close",v=>{let w;!D&&(w=this.C(T,f))&&r(w)?S(new Error(`command failed with error code ${v}: ${this.C(T,f)}`)):(this.g&&v===0&&(this.j=!0),S(null,"",!0))})}A(l,f,y){const k=new A.StringDecoder(f);return l.on("data",S=>{y(null,k.write(S))}),k}B(l){const f=[];return l.on("data",y=>{f.push(y)}),f}C(l,f){const y=new A.StringDecoder(f);return l.map(k=>y.write(k)).join("")}D(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}G(l,{pathToEntries:f},y,k,S){k.indexOf(this.b)!==-1&&this.J(S,{base:y,relativePath:this.b,searchPath:this.N(l,this.b)});const D=T=>{const v=R.$qc(T),w=R.$pc(T);let M=f[w];M||(M=f[w]=[],D(w)),M.push({base:y,relativePath:T,basename:v,searchPath:this.N(l,T)})};k.forEach(D)}H({rootEntries:l,pathToEntries:f},y,k){const S=this,D=this.t.get(y),T=this.b;function v(w){S.o++;const M=(0,$.$IM)(()=>w.map(L=>L.basename));for(let L=0,N=w.length;L<N;L++){const F=w[L],{relativePath:V,basename:j}=F;if(D.test(V,j,T!==j?M:void 0))continue;const U=f[V];if(U)v(U);else{if(S.p++,V===T)continue;S.J(k,F)}if(S.j)break}}v(l)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(l,f,y,k,S){const D=l.folder,T=(0,$.$IM)(()=>y);this.w(y,(v,w)=>{if(this.l||this.j)return w(null);const M=f?[f,v].join(R.sep):v;if(this.t.get(l.folder.fsPath).test(M,v,this.a.filePattern!==v?T:void 0))return w(null);const L=[D.fsPath,M].join(R.sep);h.lstat(L,(N,F)=>{if(N||this.l||this.j)return w(null);this.L(L,F,(V,j)=>V||this.l||this.j?w(null):j.isDirectory()?(this.o++,this.M(L,F,(U,z)=>U||this.l||this.j||(z=z||"",this.v[z])?w(null):(this.v[z]=!0,a.Promises.readdir(L).then(_=>{if(this.l||this.j)return w(null);this.I(l,M,_,k,W=>w(W||null))},_=>{w(null)})))):(this.p++,M===this.b||this.h&&b.$lg(j.size)&&j.size>this.h||this.J(k,{base:D.fsPath,relativePath:M,searchPath:this.N(l,M)}),w(null,void 0)))})},v=>{const w=v&&O.$Jb(v);return S(w&&w.length>0?w[0]:void 0)})}J(l,f){this.K(f)&&(!this.d||this.d(f.relativePath,R.$qc(f.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||l(f))}K(l){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,$.$DM)(l,this.c);if(this.b)return(0,$.$DM)(l,this.b,!1)}return!0}L(l,f,y){return f.isSymbolicLink()?h.stat(l,y):y(null,f)}M(l,f,y){return f.isSymbolicLink()?h.realpath(l,(k,S)=>k?y(k):y(null,S)):y(null,l)}N(l,f){return l.folderName?R.$mc(l.folderName,f):f}}e.$_sc=o;class t{constructor(l,f){this.a=l.folderQueries,this.b=l.extraFileResources||[],this.d=f,this.c=new o(l)}search(l,f,y){this.c.walk(this.a,this.b,this.d,l,f,(k,S)=>{y(k,{limitHit:S,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$atc=t;class n{constructor(l,f){this.expression=l,this.c=f,this.d(l)}d(l){let f,y;Object.keys(l).filter(k=>l[k]).forEach(k=>{R.$lc(k)?(f=f||m.$yk(),f[k]=l[k]):(y=y||m.$yk(),y[k]=l[k])}),this.a=f&&m.$Dk(f,{trimForExclusions:!0}),this.b=y&&m.$Dk(y,{trimForExclusions:!0})}test(l,f,y){return this.b&&this.b(l,f,y)||this.a&&this.a(R.$mc(this.c,l),f,y)}getBasenameTerms(){const l=[];return this.a&&l.push(...m.$Fk(this.a)),this.b&&l.push(...m.$Fk(this.b)),l}getPathTerms(){const l=[];return this.a&&l.push(...m.$Gk(this.a)),this.b&&l.push(...m.$Gk(this.b)),l}}function r(d){const l=d.trim().split(`
`),f=l[0].trim();if(f.startsWith("Error parsing regex"))return f;if(f.startsWith("regex parse error"))return P.$_f(l[l.length-1].trim());if(f.startsWith("error parsing glob")||f.startsWith("unsupported encoding"))return f.charAt(0).toUpperCase()+f.substr(1);if(f==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(f.startsWith("Literal "))return f}}),define(Re[351],Ce([1,0,105,21,139,20,18,131]),function(ge,e,s,h,R,A,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0E=e.$9E=e.$1E=e.DecodeStreamErrorKind=e.$ZE=e.$YE=e.$XE=e.$VE=e.$UE=e.$TE=e.$SE=void 0,e.$WE=m,e.$2E=$,e.$3E=p,e.$4E=u,e.$5E=i,e.$6E=o,e.$7E=k,e.$8E=S,e.$SE="utf8",e.$TE="utf8bom",e.$UE="utf16be",e.$VE="utf16le";function m(D){return[e.$SE,e.$TE,e.$UE,e.$VE].some(T=>T===D)}e.$XE=[254,255],e.$YE=[255,254],e.$ZE=[239,187,191];const c=512,I=512,E=512*8,g=512*128;var P;(function(D){D[D.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(P||(e.DecodeStreamErrorKind=P={}));class b extends Error{constructor(T,v){super(T),this.decodeStreamErrorKind=v}}e.$1E=b;class a{static async create(T){let v;if(T!==e.$SE)v=(await(0,R.$xq)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(i(T));else{const w=new TextDecoder;v={write(M){return w.decode(M,{stream:!0})},end(){return w.decode()}}}return new a(v)}constructor(T){this.a=T}write(T){return this.a.write(T)}end(){return this.a.end()}}function $(D,T){const v=T.minBytesRequiredForDetection??T.guessEncoding?E:I;return new Promise((w,M)=>{const L=(0,s.$Ee)(z=>z.join("")),N=[];let F=0,V;const j=new A.$ze,U=async()=>{try{const z=await S({buffer:h.$Qe.concat(N),bytesRead:F},T.guessEncoding,T.candidateGuessEncodings);if(z.seemsBinary&&T.acceptTextOnly)throw new b("Stream is binary but only text is accepted for decoding",P.STREAM_IS_BINARY);z.encoding=await T.overwriteEncoding(z.encoding),V=await a.create(z.encoding);const _=V.write(h.$Qe.concat(N).buffer);L.write(_),N.length=0,F=0,w({stream:L,detected:z})}catch(z){j.cancel(),L.destroy(),M(z)}};(0,s.$Ie)(D,{onData:async z=>{V?L.write(V.write(z.buffer)):(N.push(z),F+=z.byteLength,F>=v&&(D.pause(),await U(),setTimeout(()=>D.resume())))},onError:z=>L.error(z),onEnd:async()=>{V||await U(),L.end(V?.end())}},j.token)})}async function p(D,T,v){const M=(await(0,R.$xq)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(i(T),v);let L=!1,N=!1;return{read(){if(N)return null;const F=D.read();if(typeof F!="string"){if(N=!0,!L&&v?.addBOM)switch(T){case e.$SE:case e.$TE:return h.$Qe.wrap(Uint8Array.from(e.$ZE));case e.$UE:return h.$Qe.wrap(Uint8Array.from(e.$XE));case e.$VE:return h.$Qe.wrap(Uint8Array.from(e.$YE))}const V=M.end();return V&&V.length>0?(L=!0,h.$Qe.wrap(V)):null}return L=!0,h.$Qe.wrap(M.write(F))}}}async function u(D){return(await(0,R.$xq)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(i(D))}function i(D){return D===e.$TE||D===null?e.$SE:D}function o(D,T){if(!D||T<e.$XE.length)return null;const v=D.readUInt8(0),w=D.readUInt8(1);if(v===e.$XE[0]&&w===e.$XE[1])return e.$UE;if(v===e.$YE[0]&&w===e.$YE[1])return e.$VE;if(T<e.$ZE.length)return null;const M=D.readUInt8(2);return v===e.$ZE[0]&&w===e.$ZE[1]&&M===e.$ZE[2]?e.$TE:null}const t=["ascii","utf-16","utf-32"];async function n(D,T){const v=await(0,R.$xq)("jschardet",C.$T?"dist/jschardet.js":"dist/jschardet.min.js"),w=D.slice(0,g),M=y(w.buffer);T&&(T=(0,O.$Jb)(T.map(F=>f(F))),T.length===0&&(T=void 0));const L=v.detect(M,T?{detectEncodings:T}:void 0);if(!L||!L.encoding)return null;const N=L.encoding.toLowerCase();return 0<=t.indexOf(N)?null:l(L.encoding)}const r={ibm866:"cp866",big5:"cp950"};function d(D){return D.replace(/[^a-zA-Z0-9]/g,"").toLowerCase()}function l(D){const T=d(D);return r[T]||T}function f(D){const T=d(D);return e.$0E[T].guessableName}function y(D){let T="";for(let v=0;v<D.length;v++)T+=String.fromCharCode(D[v]);return T}function k(D){switch(D){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const T=D.match(/windows(\d+)/);return T?"windows-"+T[1]:D}}}function S({buffer:D,bytesRead:T},v,w){let M=o(D,T),L=!1;if(M!==e.$UE&&M!==e.$VE&&D){let N=!0,F=!0,V=!1;for(let j=0;j<T&&j<c;j++){const U=j%2===1,z=D.readUInt8(j)===0;if(z&&(V=!0),N&&(U&&!z||!U&&z)&&(N=!1),F&&(U&&z||!U&&!z)&&(F=!1),z&&!N&&!F)break}V&&(N?M=e.$VE:F?M=e.$UE:L=!0)}return v&&!L&&!M&&D?n(D.slice(0,T),w).then(N=>({seemsBinary:!1,encoding:N})):{seemsBinary:L,encoding:M}}e.$9E={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom",guessableName:"UTF-8"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3,guessableName:"UTF-16LE"},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4,guessableName:"UTF-16BE"},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5,guessableName:"windows-1252"},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16,guessableName:"windows-1250"},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17,guessableName:"ISO-8859-2"},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19,guessableName:"windows-1251"},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20,guessableName:"IBM866"},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21,guessableName:"ISO-8859-5"},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22,guessableName:"KOI8-R"},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25,guessableName:"windows-1253"},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26,guessableName:"ISO-8859-7"},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27,guessableName:"windows-1255"},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28,guessableName:"ISO-8859-8"},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36,guessableName:"Big5"},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38,guessableName:"SHIFT_JIS"},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39,guessableName:"EUC-JP"},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40,guessableName:"EUC-KR"},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45,guessableName:"GB2312"},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}},e.$0E=(()=>{const D={};for(const T in e.$9E)e.$9E[T].guessableName&&(D[T]=e.$9E[T]);return D})()}),define(Re[176],Ce([1,0,351,33,175]),function(ge,e,s,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$itc=void 0,h=Ue(h);class A extends R.$2rc{constructor(C,m,c=h,I="searchProcess"){super({query:C,provider:m},{readdir:E=>c.Promises.readdir(E.fsPath),toCanonicalName:E=>(0,s.$7E)(E)},I)}}e.$itc=A}),define(Re[177],Ce([1,0,56,366,350,18,80,39,13,2,35,59,367,348,129,174]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ctc=e.$btc=void 0,e.$dtc=r,e.$etc=l,e.$ftc=y,e.$gtc=k,e.$htc=D,s=Ue(s);const $=P.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class p{constructor(v,w){this.a=v,this.b=w}provideTextSearchResults(v,w,M,L){return Promise.all(w.folderOptions.map(N=>{const F={folderOptions:N,numThreads:this.b,maxResults:w.maxResults,previewOptions:w.previewOptions,maxFileSize:w.maxFileSize,surroundingContext:w.surroundingContext};return this.provideTextSearchResultsWithRgOptions(v,F,M,L)})).then(N=>({limitHit:N.some(V=>!!V&&V.limitHit)}))}provideTextSearchResultsWithRgOptions(v,w,M,L){return this.a.appendLine(`provideTextSearchResults ${v.pattern}, ${JSON.stringify({...w,folder:w.folderOptions.folder.toString()})}`),new Promise((N,F)=>{L.onCancellationRequested(()=>x());const V={...w,numThreads:this.b},j=r(v,V),U=w.folderOptions.folder.fsPath,z=j.map(X=>X.match(/^-/)?X:`'${X}'`).join(" ");this.a.appendLine(`${$} ${z}
 - cwd: ${U}`);let _=s.spawn($,j,{cwd:U});_.on("error",X=>{console.error(X),this.a.appendLine("Error: "+(X&&X.message)),F((0,I.$zM)(new I.$xM(X&&X.message,I.SearchErrorCode.rgProcessError)))});let W=!1;const B=new o(w.maxResults??I.$mM,w.folderOptions.folder,(0,a.$6rc)(w.previewOptions));B.on("result",X=>{W=!0,ie="",M.report(X)});let Y=!1;const x=()=>{Y=!0,_?.kill(),B?.cancel()};let oe=!1;B.on("hitLimit",()=>{oe=!0,x()});let ie="";_.stdout.on("data",X=>{B.handleData(X),W||(ie+=X)});let me=!1;_.stdout.once("data",()=>me=!0);let ue="";_.stderr.on("data",X=>{const q=X.toString();this.a.appendLine(q),ue.length+q.length<1e6&&(ue+=q)}),_.on("close",()=>{if(this.a.appendLine(me?"Got data from stdout":"No data from stdout"),this.a.appendLine(W?"Got result from parser":"No result from parser"),ie&&this.a.appendLine(`Got data without result: ${ie}`),this.a.appendLine(""),Y)N({limitHit:oe});else{B.flush(),_=null;let X;ue&&!me&&(X=u(ue))?F((0,I.$zM)(new I.$xM(X.message,X.code))):N({limitHit:oe})}})})}}e.$btc=p;function u(T){const v=T.split(`
`),w=v[0].trim();if(v.some(L=>L.startsWith("regex parse error")))return new I.$xM(i(v),I.SearchErrorCode.regexParseError);const M=w.match(/grep config error: unknown encoding: (.*)/);if(M)return new I.$xM(`Unknown encoding: ${M[1]}`,I.SearchErrorCode.unknownEncoding);if(w.startsWith("error parsing glob"))return new I.$xM(w.charAt(0).toUpperCase()+w.substr(1),I.SearchErrorCode.globParseError);if(w.startsWith("the literal"))return new I.$xM(w.charAt(0).toUpperCase()+w.substr(1),I.SearchErrorCode.invalidLiteral);if(w.startsWith("PCRE2: error compiling pattern"))return new I.$xM(w,I.SearchErrorCode.regexParseError)}function i(T){const v=["Regex parse error"],w=T.filter(M=>M.startsWith("PCRE2:"));if(w.length>=1){const M=w[0].replace("PCRE2:","");if(M.indexOf(":")!==-1&&M.split(":").length>=2){const L=M.split(":")[1];v.push(":"+L)}}return v.join("")}class o extends h.EventEmitter{constructor(v,w,M){super(),this.g=v,this.h=w,this.j=M,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new R.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(v,w){return super.on(v,w),this}handleData(v){if(this.b)return;const w=typeof v=="string"?v:this.d.write(v);this.k(w)}k(v){let w=v.indexOf(`
`);const M=this.a+v;if(w>=0)w+=this.a.length;else{this.a=M;return}let L=0;for(;w>=0;)this.m(M.substring(L,w).trim()),L=w+1,w=M.indexOf(`
`,L);this.a=M.substring(L)}m(v){if(this.b||!v)return;let w;try{w=JSON.parse(v)}catch{throw new Error(`malformed line from rg: ${v}`)}if(w.type==="match"){const M=t(w.data.path),L=c.URI.joinPath(this.h,M),N=this.n(w.data,L);this.p(N),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(w.type==="context"){const M=t(w.data.path),L=c.URI.joinPath(this.h,M);this.o(w.data,L).forEach(F=>this.p(F))}}n(v,w){const M=v.line_number-1,L=t(v.lines),N=Buffer.from(L);let F=0,V=0,j=M;v.submatches.length===0&&v.submatches.push(L.length?{start:0,end:1,match:{text:L[0]}}:{start:0,end:0,match:{text:""}});const U=(0,A.$Jb)(v.submatches.map((W,B)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const Y=t(W.match),x=N.slice(F,W.start).toString(),oe=n(x),ie=oe.numLines>0?oe.lastLineLength:oe.lastLineLength+V,me=n(Y),ue=oe.numLines+j,X=me.numLines+ue,q=me.numLines>0?me.lastLineLength:me.lastLineLength+ie;return F=W.end,V=q,j=X,new E.$eM(ue,ie,X,q)})),z=(0,A.$3b)(U,b.$6sc),_=new I.$sM(L,z,this.j);return new E.$fM(w,_.rangeLocations.map(W=>({sourceRange:(0,b.$7sc)(W.source),previewRange:(0,b.$7sc)(W.preview)})),_.previewText)}o(v,w){const M=t(v.lines),L=v.line_number;return M.replace(/\r?\n$/,"").split(`
`).map((N,F)=>new E.$gM(w,N,L+F))}p(v){this.emit("result",v)}}e.$ctc=o;function t(T){return T.bytes?Buffer.from(T.bytes,"base64").toString():T.text}function n(T){const v=/\n/g;let w=0,M=-1,L;for(;L=v.exec(T);)w++,M=L.index;const N=M>=0?T.length-M-1:T.length;return{numLines:w,lastLineLength:N}}function r(T,v){const w=["--hidden","--no-require-git"];w.push(T.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:M,otherIncludes:L}=(0,O.$c)(v.folderOptions.includes,F=>F.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(L&&L.length){const F=new Set;L.forEach(V=>{F.add(V)}),w.push("-g","!*"),F.forEach(V=>{d(V).map(b.$5sc).forEach(j=>{w.push("-g",j)})})}M&&M.length&&M.forEach(F=>{w.push("-g",F)}),v.folderOptions.excludes.map(F=>typeof F=="string"?F:F.pattern).map(b.$5sc).forEach(F=>w.push("-g",`!${F}`)),v.maxFileSize&&w.push("--max-filesize",v.maxFileSize+""),v.folderOptions.useIgnoreFiles.local?v.folderOptions.useIgnoreFiles.parent||w.push("--no-ignore-parent"):w.push("--no-ignore"),v.folderOptions.followSymlinks&&w.push("--follow"),v.folderOptions.encoding&&v.folderOptions.encoding!=="utf8"&&w.push("--encoding",v.folderOptions.encoding),v.numThreads&&w.push("--threads",`${v.numThreads}`),T.pattern==="--"&&(T.isRegExp=!0,T.pattern="\\-\\-"),T.isMultiline&&!T.isRegExp&&(T.pattern=(0,m.$kf)(T.pattern),T.isRegExp=!0),v.usePCRE2&&w.push("--pcre2"),w.push("--crlf"),T.isRegExp&&(T.pattern=l(T.pattern),w.push("--engine","auto"));let N;if(T.isWordMatch){const V=(0,m.$tf)(T.pattern,!!T.isRegExp,{wholeWord:T.isWordMatch}).source.replace(/\\\//g,"/");w.push("--regexp",V)}else if(T.isRegExp){let F=y(T.pattern);F=k(F),w.push("--regexp",F)}else N=T.pattern,w.push("--fixed-strings");return w.push("--no-config"),v.folderOptions.useIgnoreFiles.global||w.push("--no-ignore-global"),w.push("--json"),T.isMultiline&&w.push("--multiline"),v.surroundingContext&&(w.push("--before-context",v.surroundingContext+""),w.push("--after-context",v.surroundingContext+"")),w.push("--"),N&&w.push(N),w.push("."),w}function d(T){return D(T).flatMap(w=>{const M=(0,C.$Bk)(w,"/");return M.map((L,N)=>M.slice(0,N+1).join("/"))})}function l(T){const v=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;T.match(v);)T=T.replace(v,"$1\\x{$2}");const w=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;T.match(w);)T=T.replace(w,"$1\\x{$2}");return T}const f=T=>T.type==="Assertion"&&T.kind==="lookbehind";function y(T){let v;try{v=new g.RegExpParser().parsePattern(T)}catch{return T}let w="",M=0;const L=(V,j,U)=>{w+=T.slice(M,V)+U,M=j},N=[];return new g.RegExpVisitor({onCharacterEnter(V){if(V.raw!=="\\n")return;const j=N[0];if(!j)L(V.start,V.end,"\\r?\\n");else if(!N.some(f))if(j.type==="CharacterClass")if(j.negate){const U=T.slice(j.start+2,V.start)+T.slice(V.end,j.end-1);j.parent?.type==="Quantifier"?L(j.start,j.end,U?`[^${U}]`:"."):L(j.start,j.end,"(?!\\r?\\n"+(U?`|[${U}]`:"")+")")}else{const U=T.slice(j.start+1,V.start)+T.slice(V.end,j.end-1);L(j.start,j.end,U===""?"\\r?\\n":`(?:[${U}]|\\r?\\n)`)}else j.type==="Quantifier"&&L(V.start,V.end,"(?:\\r?\\n)")},onQuantifierEnter(V){N.unshift(V)},onQuantifierLeave(){N.shift()},onCharacterClassRangeEnter(V){N.unshift(V)},onCharacterClassRangeLeave(){N.shift()},onCharacterClassEnter(V){N.unshift(V)},onCharacterClassLeave(){N.shift()},onAssertionEnter(V){f(V)&&N.push(V)},onAssertionLeave(V){N[0]===V&&N.shift()}}).visit(v),w+=T.slice(M),w}function k(T){return T.replace(/\n/g,"\\r?\\n")}function S(T){let v=!1,w=!1,M="",L="";for(let N=0;N<T.length;N++){const F=T[N];switch(F){case"\\":w?(v?L+="\\"+F:M+="\\"+F,w=!1):w=!0;break;case"{":if(w)v?L+=F:M+=F,w=!1;else{if(v)return{strInBraces:M+"{"+L+"{"+T.substring(N+1)};v=!0}break;case"}":if(w)v?L+=F:M+=F,w=!1;else{if(v)return{fixedStart:M,strInBraces:L,fixedEnd:T.substring(N+1)};M+=F}break;default:v?L+=(w?"\\":"")+F:M+=(w?"\\":"")+F,w=!1;break}}return{strInBraces:M+(v?"{"+L:"")}}function D(T){const{fixedStart:v,strInBraces:w,fixedEnd:M}=S(T);if(v===void 0||M===void 0)return[w];let L=(0,C.$Bk)(w,",");L.length||(L=[""]);const N=D(M);return L.flatMap(F=>{const V=v+F;return N.map(j=>V+j)})}}),define(Re[352],Ce([1,0,20,177,90,14]),function(ge,e,s,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ltc=void 0;class O{constructor(c,I){this.b=c,this.c=I,this.a=new Set,process.once("exit",()=>this.f())}async provideTextSearchResults(c,I,E,g){const P=await this.c(),b=new h.$btc(this.b,P);return Promise.all(I.folderOptions.map(a=>{const $={folderOptions:a,numThreads:P,maxResults:I.maxResults,previewOptions:I.previewOptions,maxFileSize:I.maxFileSize,surroundingContext:I.surroundingContext};if(a.folder.scheme===A.Schemas.vscodeUserData){const p={...$,folder:a.folder.with({scheme:A.Schemas.file})},u=new R.$Gw(i=>E.report({...i,uri:i.uri.with({scheme:a.folder.scheme})}));return this.d(g,i=>b.provideTextSearchResultsWithRgOptions(c,p,u,i))}else return this.d(g,p=>b.provideTextSearchResultsWithRgOptions(c,$,E,p))})).then(a=>({limitHit:a.some(p=>!!p&&p.limitHit)}))}async d(c,I){const E=C(c);this.a.add(E);const g=await I(E.token);return this.a.delete(E),g}f(){this.a.forEach(c=>c.cancel())}}e.$ltc=O;function C(m){const c=new s.$ze;return m.onCancellationRequested(()=>c.cancel()),c}}),define(Re[353],Ce([1,0,33,35,177,176]),function(ge,e,s,h,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jtc=void 0,s=Ue(s);class O{constructor(c,I){this.a=c,this.b=I}search(c,I,E){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"},messages:[]});const g={appendLine(b){E({message:b})}},P=new A.$itc(this.a,new R.$btc(g,this.b),s);return new Promise((b,a)=>P.search($=>{I($.map(C))},c).then($=>b({limitHit:$.limitHit??!1,type:"success",stats:$.stats,messages:[]}),a))}}e.$jtc=O;function C(m){return{path:m.resource&&m.resource.fsPath,results:m.results,numMatches:(m.results||[]).reduce((c,I)=>(0,h.$oM)(I)?c+I.rangeLocations.length:c+1,0)}}}),define(Re[354],Ce([1,0,18,7,12,4,137,38,16,43,2,27,35,349,353]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ktc=void 0,s=Ue(s);class a{static{this.a=512}constructor(t="searchProcess",n){this.d=t,this.f=n,this.b=Object.create(null)}fileSearch(t){let n;const r=u(t),d=new A.$oe({onDidAddFirstListener:()=>{n=(0,h.$vh)(async l=>{const f=await this.f?.();return this.doFileSearchWithEngine(P.$atc,r,y=>d.fire(y),l,a.a,f)}),n.then(l=>d.fire(l),l=>d.fire({type:"error",error:{message:l.message,stack:l.stack}}))},onDidRemoveLastListener:()=>{n.cancel()}});return d.event}textSearch(t){let n;const r=u(t),d=new A.$oe({onDidAddFirstListener:()=>{n=(0,h.$vh)(l=>this.g(r,f=>d.fire(f),l)),n.then(l=>d.fire(l),l=>d.fire({type:"error",error:{message:l.message,stack:l.stack}}))},onDidRemoveLastListener:()=>{n.cancel()}});return d.event}async g(t,n,r){t.maxFileSize=this.h().maxFileSize;const d=await this.f?.();return new b.$jtc(t,d).search(r,n,n)}h(){return{maxFileSize:16*E.$Ll.GB}}doFileSearch(t,n,r,d){return this.doFileSearchWithEngine(P.$atc,t,r,d,a.a,n)}doFileSearchWithEngine(t,n,r,d,l=a.a,f){let y=0;const k=D=>{Array.isArray(D)?(y+=D.length,r(D.map(T=>this.j(T)))):D.relativePath?(y++,r(this.j(D))):r(D)};if(n.sortByScore){let D=this.n(n,k,d);if(!D){const T=n.maxResults?Object.assign({},n,{maxResults:null}):n,v=new t(T,f);D=this.k(v,n,r,k,d)}return new Promise((T,v)=>{D.then(([w,M])=>{const L=M.map(N=>this.j(N));this.q(L,r,l),T(w)},v)})}const S=new t(n,f);return this.s(S,k,l,d).then(D=>({limitHit:D.limitHit,type:"success",stats:{detailStats:D.stats,type:this.d,fromCache:!1,resultCount:y,sortingTime:void 0},messages:[]}))}j(t){return{path:t.base?(0,m.$mc)(t.base,t.relativePath):t.relativePath}}k(t,n,r,d,l){const f=new A.$oe;let y=(0,h.$vh)(S=>{let D=[];const T=v=>{Array.isArray(v)?D=v:(d(v),f.fire(v))};return this.s(t,T,-1,S).then(v=>[v,D])}),k;if(n.cacheKey){k=this.l(n.cacheKey);const S={promise:y,event:f.event,resolved:!1};k.resultsToSearchCache[n.filePattern||""]=S,y.then(()=>{S.resolved=!0},D=>{delete k.resultsToSearchCache[n.filePattern||""]}),y=this.t(y)}return y.then(([S,D])=>{const T=k?k.scorerCache:Object.create(null),v=(typeof n.maxResults!="number"||n.maxResults>0)&&c.$ie.create(!1);return this.o(n,D,T,l).then(w=>{const M=v?v.elapsed():-1;return[{type:"success",stats:{detailStats:S.stats,sortingTime:M,fromCache:!1,type:this.d,resultCount:w.length},messages:S.messages,limitHit:S.limitHit||typeof n.maxResults=="number"&&D.length>n.maxResults},w]})})}l(t){const n=this.b[t];return n||(this.b[t]=new $)}n(t,n,r){const d=t.cacheKey&&this.b[t.cacheKey];if(!d)return;const l=this.r(d,t.filePattern||"",n,r);if(l)return l.then(([f,y,k])=>{const S=c.$ie.create(!1);return this.o(t,y,d.scorerCache,r).then(D=>{const T=S.elapsed(),v={fromCache:!0,detailStats:k,type:this.d,resultCount:y.length,sortingTime:T};return[{type:"success",limitHit:f.limitHit||typeof t.maxResults=="number"&&y.length>t.maxResults,stats:v,messages:[]},D]})})}o(t,n,r,d){const l=(0,O.$Xr)(t.filePattern||""),f=(k,S)=>(0,O.$Wr)(k,S,l,!0,p,r),y=typeof t.maxResults=="number"?t.maxResults:g.$mM;return s.$Ib(n,f,y,1e4,d)}q(t,n,r){if(r&&r>0)for(let d=0;d<t.length;d+=r)n(t.slice(d,d+r));else n(t)}r(t,n,r,d){const l=c.$ie.create(!1),f=n.indexOf(m.sep)>=0;let y;for(const T in t.resultsToSearchCache)if(n.startsWith(T)){if(f&&T.indexOf(m.sep)<0&&T!=="")continue;const v=t.resultsToSearchCache[T];y={promise:this.t(v.promise),event:v.event,resolved:v.resolved};break}if(!y)return null;const k=l.elapsed(),S=c.$ie.create(!1),D=y.event(r);return d&&d.onCancellationRequested(()=>{D.dispose()}),y.promise.then(([T,v])=>{if(d&&d.isCancellationRequested)throw(0,R.$8)();const w=[],M=(0,O.$Xr)(n).normalizedLowercase;for(const L of v)(0,g.$DM)(L,M)&&w.push(L);return[T,w,{cacheWasResolved:y.resolved,cacheLookupTime:k,cacheFilterTime:S.elapsed(),cacheEntryCount:v.length}]})}s(t,n,r,d){return new Promise((l,f)=>{let y=[];d?.onCancellationRequested(()=>t.cancel()),t.search(k=>{k&&(r?(y.push(k),r>0&&y.length>=r&&(n(y),y=[])):n(k))},k=>{n(k)},(k,S)=>{y.length&&n(y),k?(n({message:"Search finished. Error: "+k.message}),f(k)):(n({message:"Search finished. Stats: "+JSON.stringify(S.stats)}),l(S))})})}clearCache(t){return delete this.b[t],Promise.resolve(void 0)}t(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(n,r){return t.then(n,r)}catch(n){return this.then(void 0,n)}finally(n){return t.finally(n)}}}}e.$ktc=a;class ${constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const p=new class{getItemLabel(o){return(0,m.$qc)(o.relativePath)}getItemDescription(o){return(0,m.$pc)(o.relativePath)}getItemPath(o){return o.relativePath}};function u(o){return{...o,folderQueries:o.folderQueries&&o.folderQueries.map(i),extraFileResources:o.extraFileResources&&o.extraFileResources.map(t=>I.URI.revive(t))}}function i(o){return(0,C.$fi)(o)}}),define(Re[355],Ce([1,0,3,14,2,33,11,42,29,19,102,74,35,354,352,129,176]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P,b,a,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mtc=void 0,A=Ue(A);let p=class extends I.$_rc{constructor(i,o,t,n,r){super(i,t,r),this.D=n,this.w=A,this.x=-1,this.y=null,this.z=!1,this.B=new s.$Wc,this.C=!1,this.getNumThreads=this.getNumThreads.bind(this),this.getNumThreadsCached=this.getNumThreadsCached.bind(this),this.E=this.E.bind(this);const d=new a.$8sc("RipgrepSearchUD",this.q);this.B.add(this.registerTextSearchProvider(h.Schemas.vscodeUserData,new b.$ltc(d,this.getNumThreadsCached))),o.remote.isRemote&&o.remote.authority&&this.F(),n.getConfigProvider().then(l=>{this.C||this.B.add(l.onDidChangeConfiguration(this.E))})}E(i){i.affectsConfiguration("search")&&(this.A=void 0)}async getNumThreads(){return(await this.D.getConfigProvider()).getConfiguration("search").get("ripgrep.maxThreads")}async getNumThreadsCached(){return this.A||(this.A=this.getNumThreads()),this.A}dispose(){this.C=!0,this.B.dispose()}$enableExtensionHostSearch(){this.F()}F(){if(this.z)return;this.z=!0;const i=new a.$8sc("RipgrepSearchEH",this.q);this.B.add(this.registerTextSearchProvider(h.Schemas.file,new b.$ltc(i,this.getNumThreadsCached))),this.B.add(this.G(h.Schemas.file,new P.$ktc("fileSearchProvider",this.getNumThreadsCached)))}G(i,o){const t=this.d++;return this.y=o,this.x=t,this.c.$registerFileSearchProvider(t,this.s(i)),(0,s.$Vc)(()=>{this.y=null,this.c.$unregisterProvider(t)})}$provideFileSearchResults(i,o,t,n){const r=(0,I.$asc)(t);if(i===this.x){const d=Date.now();return this.H(i,o,r,n).then(l=>{const f=Date.now()-d;return this.q.debug(`Ext host file search time: ${f}ms`),l})}return super.$provideFileSearchResults(i,o,t,n)}async doInternalFileSearchWithCustomCallback(i,o,t){const n=d=>{if((0,g.$CM)(d)&&(d=[d]),Array.isArray(d)){t(d.map(l=>R.URI.file(l.path)));return}d.message&&this.q.debug("ExtHostSearch",d.message)};if(!this.y)throw new Error("No internal file search handler");const r=await this.getNumThreadsCached();return this.y.doFileSearch(i,r,n,o)}async H(i,o,t,n){return this.doInternalFileSearchWithCustomCallback(t,n,r=>{this.c.$handleFileMatch(i,o,r)})}$clearCache(i){return this.y?.clearCache(i),super.$clearCache(i)}t(i,o){return new $.$itc(i,o,void 0,"textSearchProvider")}};e.$mtc=p,e.$mtc=p=Ze([qe(0,c.$DQ),qe(1,m.$TQ),qe(2,E.$Sqc),qe(3,C.$Yqc),qe(4,O.$dk)],p)}),define(Re[130],Ce([1,0,368,69,68,369,21,12,4,3,16,10,32,87,70]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$zi=e.$yi=e.$xi=void 0,e.$Ai=l,e.$Bi=f,e.$Di=S,e.$Ei=D;const a=3e4;class ${traceSocketEvent(v,w){b.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,v,w)}constructor(v,w=""){this.f=!0,this.debugLabel=w,this.socket=v,this.traceSocketEvent(b.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=L=>{if(this.traceSocketEvent(b.SocketDiagnosticsEventType.Error,{code:L?.code,message:L?.message}),L){if(L.code==="EPIPE")return;(0,C.$2)(L)}},this.socket.on("error",this.a);let M;this.b=L=>{this.traceSocketEvent(b.SocketDiagnosticsEventType.Close,{hadError:L}),this.f=!1,M&&clearTimeout(M)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(b.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,M=setTimeout(()=>v.destroy(),a)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(v){const w=M=>{this.traceSocketEvent(b.SocketDiagnosticsEventType.Read,M),v(O.$Qe.wrap(M))};return this.socket.on("data",w),{dispose:()=>this.socket.off("data",w)}}onClose(v){const w=M=>{v({type:b.SocketCloseEventType.NodeSocketCloseEvent,hadError:M,error:void 0})};return this.socket.on("close",w),{dispose:()=>this.socket.off("close",w)}}onEnd(v){const w=()=>{v()};return this.socket.on("end",w),{dispose:()=>this.socket.off("end",w)}}write(v){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(b.SocketDiagnosticsEventType.Write,v),this.socket.write(v.buffer,w=>{if(w){if(w.code==="EPIPE")return;(0,C.$2)(w)}})}catch(w){if(w.code==="EPIPE")return;(0,C.$2)(w)}}end(){this.traceSocketEvent(b.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(b.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((v,w)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(b.SocketDiagnosticsEventType.NodeDrainEnd),v();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent(b.SocketDiagnosticsEventType.NodeDrainEnd),v()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.$xi=$;var p;(function(T){T[T.MinHeaderByteSize=2]="MinHeaderByteSize",T[T.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(p||(p={}));var u;(function(T){T[T.PeekHeader=1]="PeekHeader",T[T.ReadHeader=2]="ReadHeader",T[T.ReadBody=3]="ReadBody",T[T.Fin=4]="Fin"})(u||(u={}));class i extends c.$Xc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(v,w){this.socket.traceSocketEvent(v,w)}constructor(v,w,M,L){super(),this.f=this.B(new m.$oe),this.g=this.B(new m.$oe),this.h=!1,this.j={state:u.PeekHeader,readLen:p.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=v,this.traceSocketEvent(b.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:w,inflateBytesLength:M?.byteLength||0,recordInflateBytes:L}),this.a=this.B(new o(this,w,M,L,this.f,(N,F)=>this.m(N,F))),this.B(this.a.onError(N=>{console.error(N),(0,C.$2)(N),this.g.fire({type:b.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:N})})),this.b=new b.$si,this.B(this.socket.onData(N=>this.n(N))),this.B(this.socket.onClose(async N=>{this.a.isProcessingReadQueue()&&await m.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(N)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(v){return this.f.event(v)}onClose(v){return this.g.event(v)}onEnd(v){return this.socket.onEnd(v)}write(v){let w=0;for(;w<v.byteLength;)this.a.writeMessage(v.slice(w,Math.min(w+p.MaxWebSocketMessageLength,v.byteLength)),{compressed:!0,opcode:2}),w+=p.MaxWebSocketMessageLength}m(v,{compressed:w,opcode:M}){if(this.h)return;this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,v);let L=p.MinHeaderByteSize;v.byteLength<126?L+=0:v.byteLength<2**16?L+=2:L+=8;const N=O.$Qe.alloc(L),F=w?64:0,V=M&15;if(N.writeUInt8(128|F|V,0),v.byteLength<126)N.writeUInt8(v.byteLength,1);else if(v.byteLength<2**16){N.writeUInt8(126,1);let j=1;N.writeUInt8(v.byteLength>>>8&255,++j),N.writeUInt8(v.byteLength>>>0&255,++j)}else{N.writeUInt8(127,1);let j=1;N.writeUInt8(0,++j),N.writeUInt8(0,++j),N.writeUInt8(0,++j),N.writeUInt8(0,++j),N.writeUInt8(v.byteLength>>>24&255,++j),N.writeUInt8(v.byteLength>>>16&255,++j),N.writeUInt8(v.byteLength>>>8&255,++j),N.writeUInt8(v.byteLength>>>0&255,++j)}this.socket.write(O.$Qe.concat([N,v]))}end(){this.h=!0,this.socket.end()}n(v){if(v.byteLength!==0){for(this.b.acceptChunk(v);this.b.byteLength>=this.j.readLen;)if(this.j.state===u.PeekHeader){const w=this.b.peek(this.j.readLen),M=w.readUInt8(0),L=(M&128)>>>7,N=(M&64)>>>6,F=M&15,V=w.readUInt8(1),j=(V&128)>>>7,U=V&127;this.j.state=u.ReadHeader,this.j.readLen=p.MinHeaderByteSize+(j?4:0)+(U===126?2:0)+(U===127?8:0),this.j.fin=L,this.j.firstFrameOfMessage&&(this.j.compressed=!!N),this.j.firstFrameOfMessage=!!L,this.j.mask=0,this.j.opcode=F,this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===u.ReadHeader){const w=this.b.read(this.j.readLen),M=w.readUInt8(1),L=(M&128)>>>7;let N=M&127,F=1;N===126?N=w.readUInt8(++F)*2**8+w.readUInt8(++F):N===127&&(N=w.readUInt8(++F)*0+w.readUInt8(++F)*0+w.readUInt8(++F)*0+w.readUInt8(++F)*0+w.readUInt8(++F)*2**24+w.readUInt8(++F)*2**16+w.readUInt8(++F)*2**8+w.readUInt8(++F));let V=0;L&&(V=w.readUInt8(++F)*2**24+w.readUInt8(++F)*2**16+w.readUInt8(++F)*2**8+w.readUInt8(++F)),this.j.state=u.ReadBody,this.j.readLen=N,this.j.mask=V,this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===u.ReadBody){const w=this.b.read(this.j.readLen);this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,w),r(w,this.j.mask),this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,w),this.j.state=u.PeekHeader,this.j.readLen=p.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(w,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(w,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await m.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$yi=i;class o extends c.$Xc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:O.$Qe.alloc(0)}constructor(v,w,M,L,N,F){super(),this.n=v,this.r=N,this.s=F,this.a=this.B(new m.$oe),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new m.$oe),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new m.$oe),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,w?(this.b=this.B(new t(this.n,L,M,{windowBits:15})),this.f=this.B(new n(this.n,{windowBits:15})),this.B(this.b.onError(V=>this.a.fire(V))),this.B(this.f.onError(V=>this.a.fire(V)))):(this.b=null,this.f=null)}writeMessage(v,w){this.g.push({data:v,options:w}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:v,options:w}=this.g.shift();if(this.f&&w.compressed){const M=await this.w(this.f,v);this.s(M,w)}else this.s(v,{...w,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(v,w){return new Promise((M,L)=>{v.write(w),v.flush(N=>M(N))})}acceptFrame(v,w,M){this.h.push({data:v,isCompressed:w,isLastFrameOfMessage:M}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const v=this.h.shift();if(this.b&&v.isCompressed){const w=await this.C(this.b,v.data,v.isLastFrameOfMessage);this.r.fire(w)}else this.r.fire(v.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(v,w,M){return new Promise((L,N)=>{v.write(w),M&&v.write(O.$Qe.fromByteArray([0,0,255,255])),v.flush(F=>L(F))})}}class t extends c.$Xc{get recordedInflateBytes(){return this.j?O.$Qe.concat(this.f):O.$Qe.alloc(0)}constructor(v,w,M,L){super(),this.h=v,this.j=w,this.a=this.B(new m.$oe),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(L),this.b.on("error",N=>{this.h.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateError,{message:N?.message,code:N?.code}),this.a.fire(N)}),this.b.on("data",N=>{this.h.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateData,N),this.g.push(O.$Qe.wrap(N))}),M&&(this.h.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateInitialWrite,M.buffer),this.b.write(M.buffer),this.b.flush(()=>{this.h.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(v){this.j&&this.f.push(v.clone()),this.h.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateWrite,v),this.b.write(v.buffer)}flush(v){this.b.flush(()=>{this.h.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateFlushFired);const w=O.$Qe.concat(this.g);this.g.length=0,v(w)})}}class n extends c.$Xc{constructor(v,w){super(),this.g=v,this.a=this.B(new m.$oe),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",M=>{this.g.traceSocketEvent(b.SocketDiagnosticsEventType.zlibDeflateError,{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.g.traceSocketEvent(b.SocketDiagnosticsEventType.zlibDeflateData,M),this.f.push(O.$Qe.wrap(M))})}write(v){this.g.traceSocketEvent(b.SocketDiagnosticsEventType.zlibDeflateWrite,v.buffer),this.b.write(v.buffer)}flush(v){this.b.flush(2,()=>{this.g.traceSocketEvent(b.SocketDiagnosticsEventType.zlibDeflateFlushFired);let w=O.$Qe.concat(this.f);this.f.length=0,w=w.slice(0,w.byteLength-4),v(w)})}}function r(T,v){if(v===0)return;const w=T.byteLength>>>2;for(let j=0;j<w;j++){const U=T.readUInt32BE(j*4);T.writeUInt32BE(U^v,j*4)}const M=w*4,L=T.byteLength-M,N=v>>>24&255,F=v>>>16&255,V=v>>>8&255;L>=1&&T.writeUInt8(T.readUInt8(M)^N,M),L>=2&&T.writeUInt8(T.readUInt8(M+1)^F,M+1),L>=3&&T.writeUInt8(T.readUInt8(M+2)^V,M+2)}e.$zi=process.env.XDG_RUNTIME_DIR;const d={[E.Platform.Linux]:107,[E.Platform.Mac]:103};function l(){const T=(0,g.$5g)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${T}-sock`;const v=process.platform!=="darwin"&&e.$zi?e.$zi:(0,R.tmpdir)(),w=(0,I.$mc)(v,`vscode-ipc-${T}.sock`);return y(w),w}function f(T,v,w){const L=(0,s.createHash)("sha256").update(T).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${L}-${w}-${v}-sock`;const N=w.substr(0,4),F=v.substr(0,6);let V;return process.platform!=="darwin"&&e.$zi&&!process.env.VSCODE_PORTABLE?V=(0,I.$mc)(e.$zi,`vscode-${L}-${N}-${F}.sock`):V=(0,I.$mc)(T,`${N}-${F}.sock`),y(V),V}function y(T){const v=d[E.$v];typeof v=="number"&&T.length>=v&&console.warn(`WARNING: IPC handle "${T}" is longer than ${v} chars, try a shorter --user-data-dir`)}class k extends P.$mi{static b(v){const w=m.Event.fromNodeEventEmitter(v,"connection");return m.Event.map(w,M=>({protocol:new b.$ti(new $(M,"ipc-server-connection")),onDidClientDisconnect:m.Event.once(m.Event.fromNodeEventEmitter(M,"close"))}))}constructor(v){super(k.b(v)),this.d=v}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Ci=k;function S(T){return new Promise((v,w)=>{const M=(0,h.createServer)();M.on("error",w),M.listen(T,()=>{M.removeListener("error",w),v(new k(M))})})}function D(T,v){return new Promise((w,M)=>{const L=(0,h.createConnection)(T,()=>{L.removeListener("error",M),w(b.$ui.fromSocket(new $(L,`ipc-client${v}`),v))});L.once("error",M)})}}),define(Re[356],Ce([1,0,69,68,193,130,7,3,10,46,11,115,236,238,117,93,21]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P,b,a,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uic=e.$Tic=e.$Sic=e.$Ric=void 0,s=Ue(s),h=Ue(h);async function p(n,r,d,l,f){let y;for(let k=3;k&&(y?.dispose(),y=await new u(n,r,d,l,f).waitForReady(),!(f&&R.$8g[f]||!R.$8g[y.tunnelLocalPort]));k--);return y}class u extends C.$Xc{constructor(r,d,l,f,y){super(),this.m=d,this.n=y,this.privacy=a.TunnelPrivacyId.Private,this.j=new Map,this.a=r,this.b=s.createServer(),this.c=new O.$Hh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=k=>this.r(k),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=f,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(d=>{d()})}async waitForReady(){const r=this.n??this.tunnelRemotePort,d=(0,a.$Tw)(this.m)?"0.0.0.0":"127.0.0.1";let l=await(0,R.$9g)(r,2,1e3,d),f=null;return this.b.listen(l,this.m),await this.c.wait(),f=this.b.address(),f||(l=0,this.b.listen(l,this.m),await this.c.wait(),f=this.b.address()),this.tunnelLocalPort=f.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${f.port}`,this}async r(r){r.pause();const d=(0,a.$Rw)(this.tunnelRemoteHost)||(0,a.$Tw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,g.$6l)(this.a,d,this.tunnelRemotePort),f=l.getSocket(),y=l.readEntireBuffer();l.dispose(),y.byteLength>0&&r.write(y.buffer),r.on("end",()=>{r.localAddress&&this.j.delete(r.localAddress),f.end()}),r.on("close",()=>f.end()),r.on("error",()=>{r.localAddress&&this.j.delete(r.localAddress),f instanceof A.$xi?f.socket.destroy():f.end()}),f instanceof A.$xi?this.t(r,f):this.s(r,f),r.localAddress&&this.j.set(r.localAddress,()=>{r.end(),f.end()})}s(r,d){d.onClose(()=>r.destroy()),d.onEnd(()=>r.end()),d.onData(l=>r.write(l.buffer)),r.on("data",l=>d.write($.$Qe.wrap(l))),r.resume()}t(r,d){const l=d.socket;l.on("end",()=>r.end()),l.on("close",()=>r.end()),l.on("error",()=>{r.destroy()}),l.pipe(r),r.pipe(l)}}e.$Ric=u;let i=class extends a.$Ww{constructor(r,d,l,f,y){super(d,y),this.H=r,this.I=l,this.J=f}isPortPrivileged(r){return(0,a.$Uw)(r,this.t,m.OS,h.release())}F(r,d,l,f,y,k,S,D){const T=this.D(d,l);if(T)return++T.refcount,T.value;if((0,a.$Nw)(r))return this.G(r,d,l,y,k,S,D);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${d}:${l} on local port ${y}.`);const v={commit:this.J.commit,quality:this.J.quality,addressProvider:r,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},w=p(v,f,d,l,y);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(d,l,w),w}}};e.$Sic=i,e.$Sic=i=Ze([qe(0,P.$Zl),qe(1,I.$dk),qe(2,b.$3l),qe(3,E.$wk),qe(4,c.$cj)],i);let o=class extends i{constructor(r,d,l,f,y){super(r,d,l,f,y)}};e.$Tic=o,e.$Tic=o=Ze([qe(0,P.$Zl),qe(1,I.$dk),qe(2,b.$3l),qe(3,E.$wk),qe(4,c.$cj)],o);let t=class extends C.$Xc{constructor(r,d,l,f,y){super(),this.b=r,this.c=d,this.f=l,this.g=f,this.h=y,this.a=new Map}async openTunnel(r,d,l,f,y,k,S,D,T){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${f} on local port ${k}.`),!this.a.has(r)){const v=new o(this.b,this.c,this.g,this.f,this.h);this.B(v),this.a.set(r,v),v.onTunnelClosed(async()=>{(await v.tunnels).length===0&&(v.dispose(),this.a.delete(r))})}return this.a.get(r).openTunnel(d,l,f,y,k,S,D,T)}};e.$Uic=t,e.$Uic=t=Ze([qe(0,P.$Zl),qe(1,I.$dk),qe(2,E.$wk),qe(3,b.$3l),qe(4,c.$cj)],t)}),define(Re[357],Ce([1,0,130,254,45,34,2,11,47]),function(ge,e,s,h,R,A,O,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6Q=e.$5Q=void 0,h=Ue(h),R=Ue(R);class c{constructor(g,P,b){this.b=g,this.c=P,this.f=b,this.a=h.createServer((a,$)=>this.h(a,$)),this.g().catch(a=>(P.error(a),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",g=>this.c.error(g))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(g,P){const b=($,p)=>{P.writeHead($,{"content-type":"application/json"}),P.end(JSON.stringify(p||null),u=>u&&this.c.error(u))},a=[];g.setEncoding("utf8"),g.on("data",$=>a.push($)),g.on("end",async()=>{try{const $=JSON.parse(a.join(""));let p;switch($.type){case"open":p=await this.i($);break;case"openExternal":p=await this.j($);break;case"status":p=await this.l($);break;case"extensionManagement":p=await this.k($);break;default:b(404,`Unknown message type: ${$.type}`);break}b(200,p)}catch($){const p=$ instanceof Error?$.message:JSON.stringify($);b(500,p),this.c.error("Error while processing pipe request",$)}})}async i(g){const{fileURIs:P,folderURIs:b,forceNewWindow:a,diffMode:$,mergeMode:p,addMode:u,forceReuseWindow:i,gotoLineMode:o,waitMarkerFilePath:t,remoteAuthority:n}=g,r=[];if(Array.isArray(b))for(const y of b)try{r.push({folderUri:O.URI.parse(y)})}catch{}if(Array.isArray(P))for(const y of P)try{(0,m.$bj)(y)?r.push({workspaceUri:O.URI.parse(y)}):r.push({fileUri:O.URI.parse(y)})}catch{}const d=t?O.URI.file(t):void 0,f={forceNewWindow:a,diffMode:$,mergeMode:p,addMode:u,gotoLineMode:o,forceReuseWindow:i,preferNewWindow:!i&&!d&&!u,waitMarkerFileURI:d,remoteAuthority:n};this.b.executeCommand("_remoteCLI.windowOpen",r,f)}async j(g){for(const P of g.uris){const b=O.URI.parse(P),a=b.scheme==="file"?b:P;await this.b.executeCommand("_remoteCLI.openExternal",a)}}async k(g){const P=a=>a?.map($=>/\.vsix$/i.test($)?O.URI.parse($):$),b={list:g.list,install:P(g.install),uninstall:P(g.uninstall),force:g.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",b)}async l(g){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&R.existsSync(this.f)&&R.unlinkSync(this.f)}}e.$5Q=c;let I=class extends c{constructor(g,P){super(g,P,(0,s.$Ai)())}};e.$6Q=I,e.$6Q=I=Ze([qe(0,A.$ZQ),qe(1,C.$dk)],I)}),define(Re[358],Ce([1,0,63,345,340,253,54,327,2,14,9,357,108,287,326]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rtc=void 0,s=Ue(s);class a extends R.$Rsc{j(){const u=this,i=globalThis._VSCODE_NODE_MODULES.module,o=i._load;i._load=function(d,l,f){return d=n(d),u.a.has(d)?u.a.get(d).load(d,m.URI.file((0,g.$ur)(l.filename)),y=>o.apply(this,[y,l,f])):o.apply(this,arguments)};const t=i._resolveLookupPaths;i._resolveLookupPaths=(r,d)=>t.call(this,n(r),d);const n=r=>{for(const d of u.b){const l=d(r);if(l){r=l;break}}return r}}}class $ extends O.$yrc{constructor(){super(...arguments),this.extensionRuntime=I.ExtensionRuntime.Node}async vb(){this.h.createInstance(P.$ptc);const u=this.h.invokeFunction(h.$Nsc);if(this.h.createInstance(C.$otc),this.f.remote.isRemote&&this.f.remote.authority){const t=this.h.createInstance(E.$6Q);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}this.h.createInstance(b.$qtc),await this.h.createInstance(a,u,{mine:this.J,all:this.L}).install(),s.mark("code/extHost/didInitAPI");const o=await this.m.getConfigProvider();await(0,A.$ntc)(this.j,o,this,this.s,this.z,this.f),s.mark("code/extHost/didInitProxyResolver")}wb(u){return u.main}async xb(u,i,o){if(i.scheme!==c.Schemas.file)throw new Error(`Cannot load URI: '${i}', must be of file-scheme`);let t=null;o.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${i.toString(!0)}`),this.s.flush();const n=u?.identifier.value;u&&await this.w.initializeLocalizedMessages(u);try{n&&s.mark(`code/extHost/willLoadExtensionCode/${n}`),t=ge.__$__nodeRequire(i.fsPath)}finally{n&&s.mark(`code/extHost/didLoadExtensionCode/${n}`),o.codeLoadingStop()}return t}async $setRemoteEnvironment(u){if(this.f.remote.isRemote)for(const i in u){const o=u[i];o===null?delete process.env[i]:process.env[i]=o}}}e.$rtc=$}),define(Re[359],Ce([1,0,45,56,21,4,3,134,10,22,2,33,70,11,235,73,117,93,356,29,19,78,334]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P,b,a,$,p,u,i,o,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ztc=void 0,e.$stc=r,e.$ttc=d,e.$utc=l,e.$vtc=f,e.$wtc=k,e.$xtc=S,e.$ytc=D,s=Ue(s),c=Ue(c),E=Ue(E);function r(w){const M=w.trim().split(`
`),L=[];return M.forEach(F=>{const V=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(F);V&&V.length>=3&&L.push({pid:parseInt(V[1],10),socket:parseInt(V[2],10)})}),L.reduce((F,V)=>(F[V.socket]=V,F),{})}function d(...w){const M=[].concat(...w.map(f));return[...new Map(M.filter(L=>L.st==="0A").map(L=>{const N=L.local_address.split(":");return{socket:parseInt(L.inode,10),ip:l(N[0]),port:parseInt(N[1],16)}}).map(L=>[L.ip+":"+L.port,L])).values()]}function l(w){let M="";if(w.length===8)for(let L=w.length-2;L>=0;L-=2)M+=parseInt(w.substr(L,2),16),L!==0&&(M+=".");else for(let L=0;L<w.length;L+=8){const N=w.substring(L,L+8);let F="";for(let V=8;V>=2;V-=2)F+=N.substring(V-2,V),(V===6||V===2)&&(F=parseInt(F,16).toString(16),M+=`${F}`,F="",L+V!==w.length-6&&(M+=":"))}return M}function f(w){const M=w.trim().split(`
`),L=M.shift().trim().split(/\s+/).filter(F=>F!=="rx_queue"&&F!=="tm->when");return M.map(F=>F.trim().split(/\s+/).reduce((V,j,U)=>(V[L[U]||U]=j,V),{}))}function y(w){return!!w.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||w.indexOf("out/server-main.js")!==-1||w.indexOf("_productName=VSCode")!==-1}function k(w){const M=w.trim().split(`
`),L=[];return M.forEach(N=>{const F=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(N);F&&F.length>=4&&L.push({pid:parseInt(F[1],10),ppid:parseInt(F[2]),cmd:F[3]})}),L}async function S(w,M,L){const N=L.reduce((V,j)=>(V[j.pid]=j,V),{}),F=[];return w.forEach(({socket:V,ip:j,port:U})=>{const z=M[V]?M[V].pid:void 0,_=z?N[z]?.cmd:void 0;z&&_&&!y(_)&&F.push({host:j,port:U,detail:_,pid:z})}),F}function D(w,M,L){const N=new Map,F=k(M);for(const V of w){const j=L.get(V.port);if(j){N.set(V.port,j);continue}const U=F.find(z=>z.cmd.includes(`${V.port}`));if(U){let z=U,_;do _=F.find(W=>W.ppid===z.pid),_&&(z=_);while(_);N.set(V.port,{host:V.ip,port:V.port,pid:z.pid,detail:z.cmd,ppid:z.ppid})}else N.set(V.port,{host:V.ip,port:V.port,ppid:Number.MAX_VALUE})}return N}let T=class extends t.$QGb{constructor(M,L,N,F){super(M,L,N),this.D=L,this.F=F,this.y=void 0,this.z=new Map,this.C=!1,m.$l&&L.remote.isRemote&&L.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(M){if(M&&this.C)return;this.C=M;let L;this.y&&(L=this.y,await this.a.$onFoundNewCandidates(this.y));const N=new C.$Rm;let F=0;for(;this.C;){const V=new Date().getTime(),j=(await this.I()).filter(_=>(0,p.$Rw)(_.host)||(0,p.$Tw)(_.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${j.map(_=>_.port).join(", ")}`);const U=new Date().getTime()-V;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${U} ms.`),F++>3&&N.update(U),(!L||JSON.stringify(L)!==JSON.stringify(j))&&(L=j,await this.a.$onFoundNewCandidates(L));const z=this.G(N.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${z} ms.`),await new Promise(_=>setTimeout(()=>_(),z))}}G(M){return Math.max(M*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(M=>M.port).join(", ")}`)}async I(){let M="",L="";try{M=await s.promises.readFile("/proc/net/tcp","utf8"),L=await s.promises.readFile("/proc/net/tcp6","utf8")}catch{}const N=d(M,L),F=await new Promise(Y=>{(0,h.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(x,oe,ie)=>{Y(oe)})}),V=r(F),j=await E.Promises.readdir("/proc"),U=[];for(const Y of j)try{const x=Number(Y),oe=c.$jh(I.URI.file("/proc"),Y);if((await s.promises.stat(oe.fsPath)).isDirectory()&&!isNaN(x)){const me=await s.promises.readlink(c.$jh(oe,"cwd").fsPath),ue=await s.promises.readFile(c.$jh(oe,"cmdline").fsPath,"utf8");U.push({pid:x,cwd:me,cmd:ue})}}catch{}const z=[],_=N.filter(Y=>{const x=V[Y.socket];return x||z.push(Y),x}),W=S(_,V,U);let B;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${z.length}`),z.length>0){const Y=await new Promise(x=>{(0,h.exec)("ps -F -A -l | grep root",(oe,ie,me)=>{x(ie)})});this.z=D(z,Y,this.z),B=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${B.map(x=>x.port).join(", ")}`)}return W.then(Y=>B?Y.concat(B):Y)}w(M){return async L=>{const N=new u.$Ric({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(V,j,U,z){const _=await M.makeConnection();return v.connect(_,j,U,z)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new a.$Vl(0),connectionToken:M.connectionToken})}},signService:this.F},"localhost",L.remoteAddress.host||"localhost",L.remoteAddress.port,L.localAddressPort);await N.waitForReady();const F=new A.$oe;return{localAddress:(0,n.$qN)(N.localAddress)??N.localAddress,remoteAddress:{port:N.tunnelRemotePort,host:N.tunnelRemoteHost},onDidDispose:F.event,dispose:()=>{N.dispose(),F.fire(),F.dispose()}}}}};e.$ztc=T,e.$ztc=T=Ze([qe(0,o.$DQ),qe(1,i.$TQ),qe(2,P.$dk),qe(3,$.$3l)],T);class v extends b.$_xb{static connect(M,L,N,F){const V=new O.$Wc,j={onClose:V.add(new A.$oe),onData:V.add(new A.$oe),onEnd:V.add(new A.$oe)};V.add(M.onDidReceiveMessage(z=>j.onData.fire(R.$Qe.wrap(z)))),V.add(M.onDidEnd(()=>j.onEnd.fire())),V.add(M.onDidClose(z=>j.onClose.fire({type:g.SocketCloseEventType.NodeSocketCloseEvent,error:z,hadError:!!z})));const U=new v(M,F,j);return U.B(V),(0,b.$$xb)(U,L,N,F,j)}constructor(M,L,N){super(L,N),this.n=M}write(M){this.n.send(M.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(Re[360],Ce([1,0,89,329,343,342,355,358,359,101,54,102,100,48,78,98,328,288,11,344,66,249,112,117,150]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P,b,a,$,p,u,i,o,t,n,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,s.$Xs)(I.$zrc,C.$rtc,s.InstantiationType.Eager),(0,s.$Xs)(u.$ek,p.$Btc,s.InstantiationType.Delayed),(0,s.$Xs)(u.$dk,new n.$Fi(t.$Qsc,[!1],!0)),(0,s.$Xs)(r.$3l,d.$Wic,s.InstantiationType.Delayed),(0,s.$Xs)(a.$2qc,$.$Atc,s.InstantiationType.Eager),(0,s.$Xs)(c.$Jrc,A.$4sc,s.InstantiationType.Eager),(0,s.$Xs)(E.$$rc,O.$mtc,s.InstantiationType.Eager),(0,s.$Xs)(g.$Bsc,R.$Vsc,s.InstantiationType.Eager),(0,s.$Xs)(P.$krc,h.$Usc,s.InstantiationType.Eager),(0,s.$Xs)(b.$PGb,m.$ztc,s.InstantiationType.Eager),(0,s.$Xs)(o.$Crc,i.$Ctc,s.InstantiationType.Eager)});var Ht=this&&this.__importDefault||function(ge){return ge&&ge.__esModule?ge:{default:ge}};define(Re[370],Ce([1,0,371,69,7,21,12,63,108,33,70,130,113,233,341,255,270,94,346,360]),function(ge,e,s,h,R,A,O,C,m,c,I,E,g,P,b,a,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),s=Ht(s),h=Ue(h),C=Ue(C),P=Ht(P),function(){for(let k=0;k<process.execArgv.length;k++)process.execArgv[k]==="--inspect-port=0"&&(process.execArgv.splice(k,1),k--)}();const u=(0,s.default)(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const y=globalThis._VSCODE_NODE_MODULES.module,k=y._load;y._load=function(S){if(S==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return k.apply(this,arguments)}})();const i=process.exit.bind(process),o=process.on.bind(process);function t(y){process.exit=function(k){if(y)i(k);else{const S=new Error("An extension called process.exit() and this was prevented.");console.warn(S.stack)}},process.crash=function(){const k=new Error("An extension called process.crash() and this was prevented.");console.warn(k.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(k,S){k==="uncaughtException"&&(S=function(){try{return S.call(void 0,arguments)}catch{}}),o(k,S)}}let n=function(y){i()};function r(){const y=(0,$.$kn)(process.env);if(y.type===$.ExtHostConnectionType.MessagePort)return new Promise((k,S)=>{const D=T=>{const v=T[0],w=new I.$vi;v.on("message",M=>w.fire(A.$Qe.wrap(M.data))),v.on("close",()=>{n("renderer closed the MessagePort")}),v.start(),k({onMessage:w.event,send:M=>v.postMessage(M.buffer)})};process.parentPort.on("message",T=>D(T.ports))});if(y.type===$.ExtHostConnectionType.Socket)return new Promise((k,S)=>{let D=null;const T=setTimeout(()=>{n("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),v=I.ProtocolConstants.ReconnectionGraceTime,w=I.ProtocolConstants.ReconnectionShortGraceTime,M=new R.$Vh(()=>n("renderer disconnected for too long (1)"),v),L=new R.$Vh(()=>n("renderer disconnected for too long (2)"),w);process.on("message",(F,V)=>{if(F&&F.type==="VSCODE_EXTHOST_IPC_SOCKET"){V.setNoDelay(!0);const j=A.$Qe.wrap(Buffer.from(F.initialDataChunk,"base64"));let U;if(F.skipWebSocketFrames)U=new E.$xi(V,"extHost-socket");else{const z=A.$Qe.wrap(Buffer.from(F.inflateBytes,"base64"));U=new E.$yi(new E.$xi(V,"extHost-socket"),F.permessageDeflate,z,!1)}D?(M.cancel(),L.cancel(),D.beginAcceptReconnection(U,j),D.endAcceptReconnection(),D.sendResume()):(clearTimeout(T),D=new I.$wi({socket:U,initialChunk:j}),D.sendResume(),D.onDidDispose(()=>n("renderer disconnected")),k(D),D.onSocketClose(()=>{M.schedule()}))}if(F&&F.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(L.isScheduled())return;M.isScheduled()&&L.schedule()}});const N={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(N)});{const k=y.pipeName;return new Promise((S,D)=>{const T=h.createConnection(k,()=>{T.removeListener("error",D);const v=new I.$wi({socket:new E.$xi(T,"extHost-renderer")});v.sendResume(),S(v)});T.once("error",D),T.on("close",()=>{n("renderer closed the socket")})})}}async function d(){const y=await r();return new class{constructor(){this.a=new I.$vi,this.onMessage=this.a.event,this.b=!1,this.d=y.onMessage(k=>{(0,p.$Gn)(k,p.MessageType.Terminate)?(this.b=!0,this.d.dispose(),n("received terminate message from renderer")):this.a.fire(k)})}send(k){this.b||y.send(k)}async drain(){if(y.drain)return y.drain()}}}function l(y){return new Promise(k=>{const S=y.onMessage(D=>{S.dispose();const T=JSON.parse(D.toString()),v=T.commit,w=P.default.commit;if(v&&w&&v!==w&&i(p.ExtensionHostExitCode.VersionMismatch),T.parentPid){let M=0;setInterval(function(){try{process.kill(T.parentPid,0),M=0}catch(N){N&&N.code==="EPERM"?(M++,M>=3&&n(`parent process ${T.parentPid} does not exist anymore (3 x EPERM): ${N.message} (code: ${N.code}) (errno: ${N.errno})`)):n(`parent process ${T.parentPid} does not exist anymore: ${N.message} (code: ${N.code}) (errno: ${N.errno})`)}},1e3);let L;try{L=globalThis._VSCODE_NODE_MODULES["native-watchdog"],L.start(T.parentPid)}catch(N){(0,O.$2)(N)}}y.send((0,p.$Fn)(p.MessageType.Initialized)),k({protocol:y,initData:T})});y.send((0,p.$Fn)(p.MessageType.Ready))})}async function f(){const y=[];process.on("unhandledRejection",(M,L)=>{y.push(L),setTimeout(()=>{const N=y.indexOf(L);N>=0&&L.catch(F=>{y.splice(N,1),(0,O.$6)(F)||(console.warn(`rejected promise not handled within 1 second: ${F}`),F&&F.stack&&console.warn(`stack trace: ${F.stack}`),M&&(0,O.$2)(M))})},1e3)}),process.on("rejectionHandled",M=>{const L=y.indexOf(M);L>=0&&y.splice(L,1)}),process.on("uncaughtException",function(M){(0,O.$1)(M)||(0,O.$2)(M)}),C.mark("code/extHost/willConnectToRenderer");const k=await d();C.mark("code/extHost/didConnectToRenderer");const S=await l(k);C.mark("code/extHost/didWaitForInitData");const{initData:D}=S;t(!!D.environment.extensionTestsLocationURI),D.environment.useHostProxy=u.useHostProxy!==void 0?u.useHostProxy!=="false":void 0,D.environment.skipWorkspaceStorageLock=(0,g.boolean)(u.skipWorkspaceStorageLock,!1);const T=new class{constructor(){this.pid=process.pid}exit(L){i(L)}fsExists(L){return c.Promises.exists(L)}fsRealpath(L){return(0,m.$tr)(L)}};let v=null;D.remote.authority&&u.transformURIs&&(v=(0,a.$2s)(D.remote.authority));const w=new b.$Tsc(S.protocol,D,T,v);n=M=>w.terminate(M)}f().catch(y=>console.log(y))})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/c2aa3c4625ed4b46448fa546ac5f2e93b0757718/core/vs/workbench/api/node/extensionHostProcess.js.map
