/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Re=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/lifecycle","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/platform/extensions/common/extensions","vs/base/common/cancellation","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/base/common/path","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/base/common/charCode","vs/platform/contextkey/common/contextkey","vs/editor/common/core/range","vs/base/common/marshalling","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/severity","vs/base/common/marshallingIds","vs/base/common/uuid","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/iterator","vs/base/common/glob","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/ternarySearchTree","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/lazy","vs/editor/common/model","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/services/search/common/searchExtTypes","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/mime","vs/base/common/extpath","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/workbench/api/common/extHostTesting","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/iconLabels","vs/base/common/labels","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model/textModelSearch","vs/editor/common/services/semanticTokensDto","vs/platform/extensions/common/extensionsApiProposals","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/telemetry/common/telemetry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/workbench/common/editor","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/jsonSchema","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/comparers","vs/base/common/scrollable","vs/base/common/stream","vs/base/common/filters","vs/base/common/uriIpc","vs/base/common/dataTransfer","vs/base/parts/storage/common/storage","vs/editor/common/core/eolCounter","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/core/textModelDefaults","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/editor/common/services/treeViewsDnd","vs/base/common/actions","vs/base/common/date","vs/platform/contextkey/common/scanner","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/editor/common/core/wordHelper","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensionValidator","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguageModelTools","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/searchExtConversionTypes","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/uint","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/base/common/arraysFind","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Te=function(we){for(var e=[],v=0,D=we.length;v<D;v++)e[v]=Re[we[v]];return e};define(Re[71],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=D,e.$bi=P,e.$ci=N;function v(R){return(O,p,s)=>{let I=null,b=null;if(typeof s.value=="function"?(I="value",b=s.value):typeof s.get=="function"&&(I="get",b=s.get),!b)throw new Error("not supported");s[I]=R(b,p)}}function D(R,O,p){let s=null,I=null;if(typeof p.value=="function"?(s="value",I=p.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(s="get",I=p.get),!I)throw new Error("not supported");const b=`$memoize$${O}`;p[s]=function(...h){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,h)}),this[b]}}function P(R,O,p){return v((s,I)=>{const b=`$debounce$${I}`,h=`$debounce$result$${I}`;return function(...E){this[h]||(this[h]=p?p():void 0),clearTimeout(this[b]),O&&(this[h]=O(this[h],...E),E=[this[h]]),this[b]=setTimeout(()=>{s.apply(this,E),this[h]=p?p():void 0},R)}})}function N(R,O,p){return v((s,I)=>{const b=`$throttle$timer$${I}`,h=`$throttle$result$${I}`,E=`$throttle$lastRun$${I}`,f=`$throttle$pending$${I}`;return function(...r){if(this[h]||(this[h]=p?p():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),O&&(this[h]=O(this[h],...r)),this[f])return;const l=this[E]+R;l<=Date.now()?(this[E]=Date.now(),s.apply(this,[this[h]]),this[h]=p?p():void 0):(this[f]=!0,this[b]=setTimeout(()=>{this[f]=!1,this[E]=Date.now(),s.apply(this,[this[h]]),this[h]=p?p():void 0},l-Date.now()))}})}});var Hn=this&&this.__createBinding||(Object.create?function(we,e,v,D){D===void 0&&(D=v);var P=Object.getOwnPropertyDescriptor(e,v);(!P||("get"in P?!e.__esModule:P.writable||P.configurable))&&(P={enumerable:!0,get:function(){return e[v]}}),Object.defineProperty(we,D,P)}:function(we,e,v,D){D===void 0&&(D=v),we[D]=e[v]}),Kn=this&&this.__setModuleDefault||(Object.create?function(we,e){Object.defineProperty(we,"default",{enumerable:!0,value:e})}:function(we,e){we.default=e}),qe=this&&this.__importStar||function(we){if(we&&we.__esModule)return we;var e={};if(we!=null)for(var v in we)v!=="default"&&Object.prototype.hasOwnProperty.call(we,v)&&Hn(e,we,v);return Kn(e,we),e};define(Re[136],Te([1,0,17]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9c=void 0,e.$0c=P,e.$$c=N,e.$_c=R,e.$ad=O,e.$bd=p,e.$cd=s,v=qe(v);const D=(E,f)=>E===f;e.$9c=D;function P(E=e.$9c){return(f,r)=>v.$wb(f,r,E)}function N(){return(E,f)=>JSON.stringify(E)===JSON.stringify(f)}function R(){return(E,f)=>E.equals(f)}function O(E,f,r){if(r!==void 0){const l=E;return l==null||f===void 0||f===null?f===l:r(l,f)}else{const l=E;return(d,a)=>d==null||a===void 0||a===null?a===d:l(d,a)}}function p(E,f){if(E===f)return!0;if(Array.isArray(E)&&Array.isArray(f)){if(E.length!==f.length)return!1;for(let r=0;r<E.length;r++)if(!p(E[r],f[r]))return!1;return!0}if(E&&typeof E=="object"&&f&&typeof f=="object"&&Object.getPrototypeOf(E)===Object.prototype&&Object.getPrototypeOf(f)===Object.prototype){const r=E,l=f,d=Object.keys(r),a=Object.keys(l),i=new Set(a);if(d.length!==a.length)return!1;for(const n of d)if(!i.has(n)||!p(r[n],l[n]))return!1;return!0}return!1}function s(E){return JSON.stringify(h(E))}let I=0;const b=new WeakMap;function h(E){if(Array.isArray(E))return E.map(h);if(E&&typeof E=="object")if(Object.getPrototypeOf(E)===Object.prototype){const f=E,r=Object.create(null);for(const l of Object.keys(f).sort())r[l]=h(f[l]);return r}else{let f=b.get(E);return f===void 0&&(f=I++,b.set(E,f)),f+"----2b76a038c20c4bcc"}return E}}),define(Re[97],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JQ=e.$IQ=void 0;class v{constructor(P){this.a=P,this.b=0}nextId(){return this.a+ ++this.b}}e.$IQ=v,e.$JQ=new v("id#")}),define(Re[137],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$1n=R,e.$2n=b,e.$3n=h,e.$4n=E,e.$5n=f,e.$6n=r,e.$7n=l,e.$8n=d,e.$9n=a,e.$0n=i,e.$$n=n;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v||(e.ScanError=v={}));var D;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(D||(e.SyntaxKind=D={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var N;(function(t){t.DEFAULT={allowTrailingComma:!0}})(N||(e.ParseOptions=N={}));function R(t,o=!1){let c=0;const m=t.length;let g="",u=0,S=D.Unknown,k=v.None;function y(L){let J=0,Y=0;for(;J<L;){const z=t.charCodeAt(c);if(z>=I._0&&z<=I._9)Y=Y*16+z-I._0;else if(z>=I.A&&z<=I.F)Y=Y*16+z-I.A+10;else if(z>=I.a&&z<=I.f)Y=Y*16+z-I.a+10;else break;c++,J++}return J<L&&(Y=-1),Y}function C(L){c=L,g="",u=0,S=D.Unknown,k=v.None}function T(){const L=c;if(t.charCodeAt(c)===I._0)c++;else for(c++;c<t.length&&s(t.charCodeAt(c));)c++;if(c<t.length&&t.charCodeAt(c)===I.dot)if(c++,c<t.length&&s(t.charCodeAt(c)))for(c++;c<t.length&&s(t.charCodeAt(c));)c++;else return k=v.UnexpectedEndOfNumber,t.substring(L,c);let J=c;if(c<t.length&&(t.charCodeAt(c)===I.E||t.charCodeAt(c)===I.e))if(c++,(c<t.length&&t.charCodeAt(c)===I.plus||t.charCodeAt(c)===I.minus)&&c++,c<t.length&&s(t.charCodeAt(c))){for(c++;c<t.length&&s(t.charCodeAt(c));)c++;J=c}else k=v.UnexpectedEndOfNumber;return t.substring(L,J)}function $(){let L="",J=c;for(;;){if(c>=m){L+=t.substring(J,c),k=v.UnexpectedEndOfString;break}const Y=t.charCodeAt(c);if(Y===I.doubleQuote){L+=t.substring(J,c),c++;break}if(Y===I.backslash){if(L+=t.substring(J,c),c++,c>=m){k=v.UnexpectedEndOfString;break}switch(t.charCodeAt(c++)){case I.doubleQuote:L+='"';break;case I.backslash:L+="\\";break;case I.slash:L+="/";break;case I.b:L+="\b";break;case I.f:L+="\f";break;case I.n:L+=`
`;break;case I.r:L+="\r";break;case I.t:L+="	";break;case I.u:{const Q=y(4);Q>=0?L+=String.fromCharCode(Q):k=v.InvalidUnicode;break}default:k=v.InvalidEscapeCharacter}J=c;continue}if(Y>=0&&Y<=31)if(p(Y)){L+=t.substring(J,c),k=v.UnexpectedEndOfString;break}else k=v.InvalidCharacter;c++}return L}function w(){if(g="",k=v.None,u=c,c>=m)return u=m,S=D.EOF;let L=t.charCodeAt(c);if(O(L)){do c++,g+=String.fromCharCode(L),L=t.charCodeAt(c);while(O(L));return S=D.Trivia}if(p(L))return c++,g+=String.fromCharCode(L),L===I.carriageReturn&&t.charCodeAt(c)===I.lineFeed&&(c++,g+=`
`),S=D.LineBreakTrivia;switch(L){case I.openBrace:return c++,S=D.OpenBraceToken;case I.closeBrace:return c++,S=D.CloseBraceToken;case I.openBracket:return c++,S=D.OpenBracketToken;case I.closeBracket:return c++,S=D.CloseBracketToken;case I.colon:return c++,S=D.ColonToken;case I.comma:return c++,S=D.CommaToken;case I.doubleQuote:return c++,g=$(),S=D.StringLiteral;case I.slash:{const J=c-1;if(t.charCodeAt(c+1)===I.slash){for(c+=2;c<m&&!p(t.charCodeAt(c));)c++;return g=t.substring(J,c),S=D.LineCommentTrivia}if(t.charCodeAt(c+1)===I.asterisk){c+=2;const Y=m-1;let z=!1;for(;c<Y;){if(t.charCodeAt(c)===I.asterisk&&t.charCodeAt(c+1)===I.slash){c+=2,z=!0;break}c++}return z||(c++,k=v.UnexpectedEndOfComment),g=t.substring(J,c),S=D.BlockCommentTrivia}return g+=String.fromCharCode(L),c++,S=D.Unknown}case I.minus:if(g+=String.fromCharCode(L),c++,c===m||!s(t.charCodeAt(c)))return S=D.Unknown;case I._0:case I._1:case I._2:case I._3:case I._4:case I._5:case I._6:case I._7:case I._8:case I._9:return g+=T(),S=D.NumericLiteral;default:for(;c<m&&M(L);)c++,L=t.charCodeAt(c);if(u!==c){switch(g=t.substring(u,c),g){case"true":return S=D.TrueKeyword;case"false":return S=D.FalseKeyword;case"null":return S=D.NullKeyword}return S=D.Unknown}return g+=String.fromCharCode(L),c++,S=D.Unknown}}function M(L){if(O(L)||p(L))return!1;switch(L){case I.closeBrace:case I.closeBracket:case I.openBrace:case I.openBracket:case I.doubleQuote:case I.colon:case I.comma:case I.slash:return!1}return!0}function A(){let L;do L=w();while(L>=D.LineCommentTrivia&&L<=D.Trivia);return L}return{setPosition:C,getPosition:()=>c,scan:o?A:w,getToken:()=>S,getTokenValue:()=>g,getTokenOffset:()=>u,getTokenLength:()=>c-u,getTokenError:()=>k}}function O(t){return t===I.space||t===I.tab||t===I.verticalTab||t===I.formFeed||t===I.nonBreakingSpace||t===I.ogham||t>=I.enQuad&&t<=I.zeroWidthSpace||t===I.narrowNoBreakSpace||t===I.mathematicalSpace||t===I.ideographicSpace||t===I.byteOrderMark}function p(t){return t===I.lineFeed||t===I.carriageReturn||t===I.lineSeparator||t===I.paragraphSeparator}function s(t){return t>=I._0&&t<=I._9}var I;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(I||(I={}));function b(t,o){const c=[],m=new Object;let g;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function k(y,C,T,$){u.value=y,u.offset=C,u.length=T,u.type=$,u.colonOffset=void 0,g=u}try{i(t,{onObjectBegin:(y,C)=>{if(o<=y)throw m;g=void 0,S=o>y,c.push("")},onObjectProperty:(y,C,T)=>{if(o<C||(k(y,C,T,"property"),c[c.length-1]=y,o<=C+T))throw m},onObjectEnd:(y,C)=>{if(o<=y)throw m;g=void 0,c.pop()},onArrayBegin:(y,C)=>{if(o<=y)throw m;g=void 0,c.push(0)},onArrayEnd:(y,C)=>{if(o<=y)throw m;g=void 0,c.pop()},onLiteralValue:(y,C,T)=>{if(o<C||(k(y,C,T,n(y)),o<=C+T))throw m},onSeparator:(y,C,T)=>{if(o<=C)throw m;if(y===":"&&g&&g.type==="property")g.colonOffset=C,S=!1,g=void 0;else if(y===","){const $=c[c.length-1];typeof $=="number"?c[c.length-1]=$+1:(S=!0,c[c.length-1]=""),g=void 0}}})}catch(y){if(y!==m)throw y}return{path:c,previousNode:g,isAtPropertyKey:S,matches:y=>{let C=0;for(let T=0;C<y.length&&T<c.length;T++)if(y[C]===c[T]||y[C]==="*")C++;else if(y[C]!=="**")return!1;return C===y.length}}}function h(t,o=[],c=N.DEFAULT){let m=null,g=[];const u=[];function S(y){Array.isArray(g)?g.push(y):m!==null&&(g[m]=y)}return i(t,{onObjectBegin:()=>{const y={};S(y),u.push(g),g=y,m=null},onObjectProperty:y=>{m=y},onObjectEnd:()=>{g=u.pop()},onArrayBegin:()=>{const y=[];S(y),u.push(g),g=y,m=null},onArrayEnd:()=>{g=u.pop()},onLiteralValue:S,onError:(y,C,T)=>{o.push({error:y,offset:C,length:T})}},c),g[0]}function E(t,o=[],c=N.DEFAULT){let m={type:"array",offset:-1,length:-1,children:[],parent:void 0};function g(y){m.type==="property"&&(m.length=y-m.offset,m=m.parent)}function u(y){return m.children.push(y),y}i(t,{onObjectBegin:y=>{m=u({type:"object",offset:y,length:-1,parent:m,children:[]})},onObjectProperty:(y,C,T)=>{m=u({type:"property",offset:C,length:-1,parent:m,children:[]}),m.children.push({type:"string",value:y,offset:C,length:T,parent:m})},onObjectEnd:(y,C)=>{m.length=y+C-m.offset,m=m.parent,g(y+C)},onArrayBegin:(y,C)=>{m=u({type:"array",offset:y,length:-1,parent:m,children:[]})},onArrayEnd:(y,C)=>{m.length=y+C-m.offset,m=m.parent,g(y+C)},onLiteralValue:(y,C,T)=>{u({type:n(y),offset:C,length:T,parent:m,value:y}),g(C+T)},onSeparator:(y,C,T)=>{m.type==="property"&&(y===":"?m.colonOffset=C:y===","&&g(C))},onError:(y,C,T)=>{o.push({error:y,offset:C,length:T})}},c);const k=m.children[0];return k&&delete k.parent,k}function f(t,o){if(!t)return;let c=t;for(const m of o)if(typeof m=="string"){if(c.type!=="object"||!Array.isArray(c.children))return;let g=!1;for(const u of c.children)if(Array.isArray(u.children)&&u.children[0].value===m){c=u.children[1],g=!0;break}if(!g)return}else{const g=m;if(c.type!=="array"||g<0||!Array.isArray(c.children)||g>=c.children.length)return;c=c.children[g]}return c}function r(t){if(!t.parent||!t.parent.children)return[];const o=r(t.parent);if(t.parent.type==="property"){const c=t.parent.children[0].value;o.push(c)}else if(t.parent.type==="array"){const c=t.parent.children.indexOf(t);c!==-1&&o.push(c)}return o}function l(t){switch(t.type){case"array":return t.children.map(l);case"object":{const o=Object.create(null);for(const c of t.children){const m=c.children[1];m&&(o[c.children[0].value]=l(m))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function d(t,o,c=!1){return o>=t.offset&&o<t.offset+t.length||c&&o===t.offset+t.length}function a(t,o,c=!1){if(d(t,o,c)){const m=t.children;if(Array.isArray(m))for(let g=0;g<m.length&&m[g].offset<=o;g++){const u=a(m[g],o,c);if(u)return u}return t}}function i(t,o,c=N.DEFAULT){const m=R(t,!1);function g(re){return re?()=>re(m.getTokenOffset(),m.getTokenLength()):()=>!0}function u(re){return re?ce=>re(ce,m.getTokenOffset(),m.getTokenLength()):()=>!0}const S=g(o.onObjectBegin),k=u(o.onObjectProperty),y=g(o.onObjectEnd),C=g(o.onArrayBegin),T=g(o.onArrayEnd),$=u(o.onLiteralValue),w=u(o.onSeparator),M=g(o.onComment),A=u(o.onError),L=c&&c.disallowComments,J=c&&c.allowTrailingComma;function Y(){for(;;){const re=m.scan();switch(m.getTokenError()){case v.InvalidUnicode:z(P.InvalidUnicode);break;case v.InvalidEscapeCharacter:z(P.InvalidEscapeCharacter);break;case v.UnexpectedEndOfNumber:z(P.UnexpectedEndOfNumber);break;case v.UnexpectedEndOfComment:L||z(P.UnexpectedEndOfComment);break;case v.UnexpectedEndOfString:z(P.UnexpectedEndOfString);break;case v.InvalidCharacter:z(P.InvalidCharacter);break}switch(re){case D.LineCommentTrivia:case D.BlockCommentTrivia:L?z(P.InvalidCommentToken):M();break;case D.Unknown:z(P.InvalidSymbol);break;case D.Trivia:case D.LineBreakTrivia:break;default:return re}}}function z(re,ce=[],x=[]){if(A(re),ce.length+x.length>0){let $e=m.getToken();for(;$e!==D.EOF;){if(ce.indexOf($e)!==-1){Y();break}else if(x.indexOf($e)!==-1)break;$e=Y()}}}function Q(re){const ce=m.getTokenValue();return re?$(ce):k(ce),Y(),!0}function V(){switch(m.getToken()){case D.NumericLiteral:{let re=0;try{re=JSON.parse(m.getTokenValue()),typeof re!="number"&&(z(P.InvalidNumberFormat),re=0)}catch{z(P.InvalidNumberFormat)}$(re);break}case D.NullKeyword:$(null);break;case D.TrueKeyword:$(!0);break;case D.FalseKeyword:$(!1);break;default:return!1}return Y(),!0}function ie(){return m.getToken()!==D.StringLiteral?(z(P.PropertyNameExpected,[],[D.CloseBraceToken,D.CommaToken]),!1):(Q(!1),m.getToken()===D.ColonToken?(w(":"),Y(),oe()||z(P.ValueExpected,[],[D.CloseBraceToken,D.CommaToken])):z(P.ColonExpected,[],[D.CloseBraceToken,D.CommaToken]),!0)}function le(){S(),Y();let re=!1;for(;m.getToken()!==D.CloseBraceToken&&m.getToken()!==D.EOF;){if(m.getToken()===D.CommaToken){if(re||z(P.ValueExpected,[],[]),w(","),Y(),m.getToken()===D.CloseBraceToken&&J)break}else re&&z(P.CommaExpected,[],[]);ie()||z(P.ValueExpected,[],[D.CloseBraceToken,D.CommaToken]),re=!0}return y(),m.getToken()!==D.CloseBraceToken?z(P.CloseBraceExpected,[D.CloseBraceToken],[]):Y(),!0}function _(){C(),Y();let re=!1;for(;m.getToken()!==D.CloseBracketToken&&m.getToken()!==D.EOF;){if(m.getToken()===D.CommaToken){if(re||z(P.ValueExpected,[],[]),w(","),Y(),m.getToken()===D.CloseBracketToken&&J)break}else re&&z(P.CommaExpected,[],[]);oe()||z(P.ValueExpected,[],[D.CloseBracketToken,D.CommaToken]),re=!0}return T(),m.getToken()!==D.CloseBracketToken?z(P.CloseBracketExpected,[D.CloseBracketToken],[]):Y(),!0}function oe(){switch(m.getToken()){case D.OpenBracketToken:return _();case D.OpenBraceToken:return le();case D.StringLiteral:return Q(!0);default:return V()}}return Y(),m.getToken()===D.EOF?c.allowEmptyContent?!0:(z(P.ValueExpected,[],[]),!1):oe()?(m.getToken()!==D.EOF&&z(P.EndOfFileExpected,[],[]),!0):(z(P.ValueExpected,[],[]),!1)}function n(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(Re[138],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$j=v;function v(N){let R=!1;const O=new Map,p=new Map;if(P(N,r=>{if(N===r)return!0;const l=JSON.stringify(r);if(l.length<30)return!0;const d=O.get(l);if(!d){const a={schemas:[r]};return O.set(l,a),p.set(r,a),!0}return d.schemas.push(r),p.set(r,d),R=!0,!1}),O.clear(),!R)return JSON.stringify(N);let I="$defs";for(;N.hasOwnProperty(I);)I+="_";const b=[];function h(r){return JSON.stringify(r,(l,d)=>{if(d!==r){const a=p.get(d);if(a&&a.schemas.length>1)return a.id||(a.id=`_${b.length}`,b.push(a.schemas[0])),{$ref:`#/${I}/${a.id}`}}return d})}const E=h(N),f=[];for(let r=0;r<b.length;r++)f.push(`"_${r}":${h(b[r])}`);return f.length?`${E.substring(0,E.length-1)},"${I}":{${f.join(",")}}}`:E}function D(N){return typeof N=="object"&&N!==null}function P(N,R){if(!N||typeof N!="object")return;const O=(...E)=>{for(const f of E)D(f)&&b.push(f)},p=(...E)=>{for(const f of E)if(D(f))for(const r in f){const l=f[r];D(l)&&b.push(l)}},s=(...E)=>{for(const f of E)if(Array.isArray(f))for(const r of f)D(r)&&b.push(r)},I=E=>{if(Array.isArray(E))for(const f of E)D(f)&&b.push(f);else D(E)&&b.push(E)},b=[N];let h=b.pop();for(;h;)R(h)&&(O(h.additionalItems,h.additionalProperties,h.not,h.contains,h.propertyNames,h.if,h.then,h.else,h.unevaluatedItems,h.unevaluatedProperties),p(h.definitions,h.$defs,h.properties,h.patternProperties,h.dependencies,h.dependentSchemas),s(h.anyOf,h.allOf,h.oneOf,h.prefixItems),I(h.items)),h=b.pop()}}),function(we,e){typeof define=="function"&&define.amd?define(Re[139],Te([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(we=typeof globalThis<"u"?globalThis:we||self,e(we.marked={}))}(this,function(we){"use strict";function e(){return{async:!1,breaks:!1,extensions:null,gfm:!0,hooks:null,pedantic:!1,renderer:null,silent:!1,tokenizer:null,walkTokens:null}}we.defaults=e();function v(Ye){we.defaults=Ye}const D=/[&<>"']/,P=new RegExp(D.source,"g"),N=/[<>"']|&(?!(#\d{1,7}|#[Xx][a-fA-F0-9]{1,6}|\w+);)/,R=new RegExp(N.source,"g"),O={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=Ye=>O[Ye];function s(Ye,he){if(he){if(D.test(Ye))return Ye.replace(P,p)}else if(N.test(Ye))return Ye.replace(R,p);return Ye}const I=/(^|[^\[])\^/g;function b(Ye,he){let pe=typeof Ye=="string"?Ye:Ye.source;he=he||"";const ye={replace:(Ce,fe)=>{let ve=typeof fe=="string"?fe:fe.source;return ve=ve.replace(I,"$1"),pe=pe.replace(Ce,ve),ye},getRegex:()=>new RegExp(pe,he)};return ye}function h(Ye){try{Ye=encodeURI(Ye).replace(/%25/g,"%")}catch{return null}return Ye}const E={exec:()=>null};function f(Ye,he){const pe=Ye.replace(/\|/g,(fe,ve,Z)=>{let W=!1,de=ve;for(;--de>=0&&Z[de]==="\\";)W=!W;return W?"|":" |"}),ye=pe.split(/ \|/);let Ce=0;if(ye[0].trim()||ye.shift(),ye.length>0&&!ye[ye.length-1].trim()&&ye.pop(),he)if(ye.length>he)ye.splice(he);else for(;ye.length<he;)ye.push("");for(;Ce<ye.length;Ce++)ye[Ce]=ye[Ce].trim().replace(/\\\|/g,"|");return ye}function r(Ye,he,pe){const ye=Ye.length;if(ye===0)return"";let Ce=0;for(;Ce<ye;){const fe=Ye.charAt(ye-Ce-1);if(fe===he&&!pe)Ce++;else if(fe!==he&&pe)Ce++;else break}return Ye.slice(0,ye-Ce)}function l(Ye,he){if(Ye.indexOf(he[1])===-1)return-1;let pe=0;for(let ye=0;ye<Ye.length;ye++)if(Ye[ye]==="\\")ye++;else if(Ye[ye]===he[0])pe++;else if(Ye[ye]===he[1]&&(pe--,pe<0))return ye;return-1}function d(Ye,he,pe,ye){const Ce=he.href,fe=he.title?s(he.title):null,ve=Ye[1].replace(/\\([\[\]])/g,"$1");if(Ye[0].charAt(0)!=="!"){ye.state.inLink=!0;const Z={type:"link",raw:pe,href:Ce,title:fe,text:ve,tokens:ye.inlineTokens(ve)};return ye.state.inLink=!1,Z}return{type:"image",raw:pe,href:Ce,title:fe,text:s(ve)}}function a(Ye,he){const pe=Ye.match(/^(\s+)(?:```)/);if(pe===null)return he;const ye=pe[1];return he.split(`
`).map(Ce=>{const fe=Ce.match(/^\s+/);if(fe===null)return Ce;const[ve]=fe;return ve.length>=ye.length?Ce.slice(ye.length):Ce}).join(`
`)}class i{options;rules;lexer;constructor(he){this.options=he||we.defaults}space(he){const pe=this.rules.block.newline.exec(he);if(pe&&pe[0].length>0)return{type:"space",raw:pe[0]}}code(he){const pe=this.rules.block.code.exec(he);if(pe){const ye=pe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:pe[0],codeBlockStyle:"indented",text:this.options.pedantic?ye:r(ye,`
`)}}}fences(he){const pe=this.rules.block.fences.exec(he);if(pe){const ye=pe[0],Ce=a(ye,pe[3]||"");return{type:"code",raw:ye,lang:pe[2]?pe[2].trim().replace(this.rules.inline.anyPunctuation,"$1"):pe[2],text:Ce}}}heading(he){const pe=this.rules.block.heading.exec(he);if(pe){let ye=pe[2].trim();if(/#$/.test(ye)){const Ce=r(ye,"#");(this.options.pedantic||!Ce||/ $/.test(Ce))&&(ye=Ce.trim())}return{type:"heading",raw:pe[0],depth:pe[1].length,text:ye,tokens:this.lexer.inline(ye)}}}hr(he){const pe=this.rules.block.hr.exec(he);if(pe)return{type:"hr",raw:r(pe[0],`
`)}}blockquote(he){const pe=this.rules.block.blockquote.exec(he);if(pe){let ye=r(pe[0],`
`).split(`
`),Ce="",fe="";const ve=[];for(;ye.length>0;){let Z=!1;const W=[];let de;for(de=0;de<ye.length;de++)if(/^ {0,3}>/.test(ye[de]))W.push(ye[de]),Z=!0;else if(!Z)W.push(ye[de]);else break;ye=ye.slice(de);const je=W.join(`
`),Qe=je.replace(/\n {0,3}((?:=+|-+) *)(?=\n|$)/g,`
    $1`).replace(/^ {0,3}>[ \t]?/gm,"");Ce=Ce?`${Ce}
${je}`:je,fe=fe?`${fe}
${Qe}`:Qe;const st=this.lexer.state.top;if(this.lexer.state.top=!0,this.lexer.blockTokens(Qe,ve,!0),this.lexer.state.top=st,ye.length===0)break;const ht=ve[ve.length-1];if(ht?.type==="code")break;if(ht?.type==="blockquote"){const gt=ht,Rt=gt.raw+`
`+ye.join(`
`),Ot=this.blockquote(Rt);ve[ve.length-1]=Ot,Ce=Ce.substring(0,Ce.length-gt.raw.length)+Ot.raw,fe=fe.substring(0,fe.length-gt.text.length)+Ot.text;break}else if(ht?.type==="list"){const gt=ht,Rt=gt.raw+`
`+ye.join(`
`),Ot=this.list(Rt);ve[ve.length-1]=Ot,Ce=Ce.substring(0,Ce.length-ht.raw.length)+Ot.raw,fe=fe.substring(0,fe.length-gt.raw.length)+Ot.raw,ye=Rt.substring(ve[ve.length-1].raw.length).split(`
`);continue}}return{type:"blockquote",raw:Ce,tokens:ve,text:fe}}}list(he){let pe=this.rules.block.list.exec(he);if(pe){let ye=pe[1].trim();const Ce=ye.length>1,fe={type:"list",raw:"",ordered:Ce,start:Ce?+ye.slice(0,-1):"",loose:!1,items:[]};ye=Ce?`\\d{1,9}\\${ye.slice(-1)}`:`\\${ye}`,this.options.pedantic&&(ye=Ce?ye:"[*+-]");const ve=new RegExp(`^( {0,3}${ye})((?:[	 ][^\\n]*)?(?:\\n|$))`);let Z=!1;for(;he;){let W=!1,de="",je="";if(!(pe=ve.exec(he))||this.rules.block.hr.test(he))break;de=pe[0],he=he.substring(de.length);let Qe=pe[2].split(`
`,1)[0].replace(/^\t+/,Qt=>" ".repeat(3*Qt.length)),st=he.split(`
`,1)[0],ht=!Qe.trim(),gt=0;if(this.options.pedantic?(gt=2,je=Qe.trimStart()):ht?gt=pe[1].length+1:(gt=pe[2].search(/[^ ]/),gt=gt>4?1:gt,je=Qe.slice(gt),gt+=pe[1].length),ht&&/^ *$/.test(st)&&(de+=st+`
`,he=he.substring(st.length+1),W=!0),!W){const Qt=new RegExp(`^ {0,${Math.min(3,gt-1)}}(?:[*+-]|\\d{1,9}[.)])((?:[ 	][^\\n]*)?(?:\\n|$))`),_t=new RegExp(`^ {0,${Math.min(3,gt-1)}}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)`),Xe=new RegExp(`^ {0,${Math.min(3,gt-1)}}(?:\`\`\`|~~~)`),At=new RegExp(`^ {0,${Math.min(3,gt-1)}}#`);for(;he;){const Ut=he.split(`
`,1)[0];if(st=Ut,this.options.pedantic&&(st=st.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Xe.test(st)||At.test(st)||Qt.test(st)||_t.test(he))break;if(st.search(/[^ ]/)>=gt||!st.trim())je+=`
`+st.slice(gt);else{if(ht||Qe.search(/[^ ]/)>=4||Xe.test(Qe)||At.test(Qe)||_t.test(Qe))break;je+=`
`+st}!ht&&!st.trim()&&(ht=!0),de+=Ut+`
`,he=he.substring(Ut.length+1),Qe=st.slice(gt)}}fe.loose||(Z?fe.loose=!0:/\n *\n *$/.test(de)&&(Z=!0));let Rt=null,Ot;this.options.gfm&&(Rt=/^\[[ xX]\] /.exec(je),Rt&&(Ot=Rt[0]!=="[ ] ",je=je.replace(/^\[[ xX]\] +/,""))),fe.items.push({type:"list_item",raw:de,task:!!Rt,checked:Ot,loose:!1,text:je,tokens:[]}),fe.raw+=de}fe.items[fe.items.length-1].raw=fe.items[fe.items.length-1].raw.trimEnd(),fe.items[fe.items.length-1].text=fe.items[fe.items.length-1].text.trimEnd(),fe.raw=fe.raw.trimEnd();for(let W=0;W<fe.items.length;W++)if(this.lexer.state.top=!1,fe.items[W].tokens=this.lexer.blockTokens(fe.items[W].text,[]),!fe.loose){const de=fe.items[W].tokens.filter(Qe=>Qe.type==="space"),je=de.length>0&&de.some(Qe=>/\n.*\n/.test(Qe.raw));fe.loose=je}if(fe.loose)for(let W=0;W<fe.items.length;W++)fe.items[W].loose=!0;return fe}}html(he){const pe=this.rules.block.html.exec(he);if(pe)return{type:"html",block:!0,raw:pe[0],pre:pe[1]==="pre"||pe[1]==="script"||pe[1]==="style",text:pe[0]}}def(he){const pe=this.rules.block.def.exec(he);if(pe){const ye=pe[1].toLowerCase().replace(/\s+/g," "),Ce=pe[2]?pe[2].replace(/^<(.*)>$/,"$1").replace(this.rules.inline.anyPunctuation,"$1"):"",fe=pe[3]?pe[3].substring(1,pe[3].length-1).replace(this.rules.inline.anyPunctuation,"$1"):pe[3];return{type:"def",tag:ye,raw:pe[0],href:Ce,title:fe}}}table(he){const pe=this.rules.block.table.exec(he);if(!pe||!/[:|]/.test(pe[2]))return;const ye=f(pe[1]),Ce=pe[2].replace(/^\||\| *$/g,"").split("|"),fe=pe[3]&&pe[3].trim()?pe[3].replace(/\n[ \t]*$/,"").split(`
`):[],ve={type:"table",raw:pe[0],header:[],align:[],rows:[]};if(ye.length===Ce.length){for(const Z of Ce)/^ *-+: *$/.test(Z)?ve.align.push("right"):/^ *:-+: *$/.test(Z)?ve.align.push("center"):/^ *:-+ *$/.test(Z)?ve.align.push("left"):ve.align.push(null);for(let Z=0;Z<ye.length;Z++)ve.header.push({text:ye[Z],tokens:this.lexer.inline(ye[Z]),header:!0,align:ve.align[Z]});for(const Z of fe)ve.rows.push(f(Z,ve.header.length).map((W,de)=>({text:W,tokens:this.lexer.inline(W),header:!1,align:ve.align[de]})));return ve}}lheading(he){const pe=this.rules.block.lheading.exec(he);if(pe)return{type:"heading",raw:pe[0],depth:pe[2].charAt(0)==="="?1:2,text:pe[1],tokens:this.lexer.inline(pe[1])}}paragraph(he){const pe=this.rules.block.paragraph.exec(he);if(pe){const ye=pe[1].charAt(pe[1].length-1)===`
`?pe[1].slice(0,-1):pe[1];return{type:"paragraph",raw:pe[0],text:ye,tokens:this.lexer.inline(ye)}}}text(he){const pe=this.rules.block.text.exec(he);if(pe)return{type:"text",raw:pe[0],text:pe[0],tokens:this.lexer.inline(pe[0])}}escape(he){const pe=this.rules.inline.escape.exec(he);if(pe)return{type:"escape",raw:pe[0],text:s(pe[1])}}tag(he){const pe=this.rules.inline.tag.exec(he);if(pe)return!this.lexer.state.inLink&&/^<a /i.test(pe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(pe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(pe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(pe[0])&&(this.lexer.state.inRawBlock=!1),{type:"html",raw:pe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,block:!1,text:pe[0]}}link(he){const pe=this.rules.inline.link.exec(he);if(pe){const ye=pe[2].trim();if(!this.options.pedantic&&/^</.test(ye)){if(!/>$/.test(ye))return;const ve=r(ye.slice(0,-1),"\\");if((ye.length-ve.length)%2===0)return}else{const ve=l(pe[2],"()");if(ve>-1){const W=(pe[0].indexOf("!")===0?5:4)+pe[1].length+ve;pe[2]=pe[2].substring(0,ve),pe[0]=pe[0].substring(0,W).trim(),pe[3]=""}}let Ce=pe[2],fe="";if(this.options.pedantic){const ve=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ce);ve&&(Ce=ve[1],fe=ve[3])}else fe=pe[3]?pe[3].slice(1,-1):"";return Ce=Ce.trim(),/^</.test(Ce)&&(this.options.pedantic&&!/>$/.test(ye)?Ce=Ce.slice(1):Ce=Ce.slice(1,-1)),d(pe,{href:Ce&&Ce.replace(this.rules.inline.anyPunctuation,"$1"),title:fe&&fe.replace(this.rules.inline.anyPunctuation,"$1")},pe[0],this.lexer)}}reflink(he,pe){let ye;if((ye=this.rules.inline.reflink.exec(he))||(ye=this.rules.inline.nolink.exec(he))){const Ce=(ye[2]||ye[1]).replace(/\s+/g," "),fe=pe[Ce.toLowerCase()];if(!fe){const ve=ye[0].charAt(0);return{type:"text",raw:ve,text:ve}}return d(ye,fe,ye[0],this.lexer)}}emStrong(he,pe,ye=""){let Ce=this.rules.inline.emStrongLDelim.exec(he);if(!Ce||Ce[3]&&ye.match(/[\p{L}\p{N}]/u))return;if(!(Ce[1]||Ce[2]||"")||!ye||this.rules.inline.punctuation.exec(ye)){const ve=[...Ce[0]].length-1;let Z,W,de=ve,je=0;const Qe=Ce[0][0]==="*"?this.rules.inline.emStrongRDelimAst:this.rules.inline.emStrongRDelimUnd;for(Qe.lastIndex=0,pe=pe.slice(-1*he.length+ve);(Ce=Qe.exec(pe))!=null;){if(Z=Ce[1]||Ce[2]||Ce[3]||Ce[4]||Ce[5]||Ce[6],!Z)continue;if(W=[...Z].length,Ce[3]||Ce[4]){de+=W;continue}else if((Ce[5]||Ce[6])&&ve%3&&!((ve+W)%3)){je+=W;continue}if(de-=W,de>0)continue;W=Math.min(W,W+de+je);const st=[...Ce[0]][0].length,ht=he.slice(0,ve+Ce.index+st+W);if(Math.min(ve,W)%2){const Rt=ht.slice(1,-1);return{type:"em",raw:ht,text:Rt,tokens:this.lexer.inlineTokens(Rt)}}const gt=ht.slice(2,-2);return{type:"strong",raw:ht,text:gt,tokens:this.lexer.inlineTokens(gt)}}}}codespan(he){const pe=this.rules.inline.code.exec(he);if(pe){let ye=pe[2].replace(/\n/g," ");const Ce=/[^ ]/.test(ye),fe=/^ /.test(ye)&&/ $/.test(ye);return Ce&&fe&&(ye=ye.substring(1,ye.length-1)),ye=s(ye,!0),{type:"codespan",raw:pe[0],text:ye}}}br(he){const pe=this.rules.inline.br.exec(he);if(pe)return{type:"br",raw:pe[0]}}del(he){const pe=this.rules.inline.del.exec(he);if(pe)return{type:"del",raw:pe[0],text:pe[2],tokens:this.lexer.inlineTokens(pe[2])}}autolink(he){const pe=this.rules.inline.autolink.exec(he);if(pe){let ye,Ce;return pe[2]==="@"?(ye=s(pe[1]),Ce="mailto:"+ye):(ye=s(pe[1]),Ce=ye),{type:"link",raw:pe[0],text:ye,href:Ce,tokens:[{type:"text",raw:ye,text:ye}]}}}url(he){let pe;if(pe=this.rules.inline.url.exec(he)){let ye,Ce;if(pe[2]==="@")ye=s(pe[0]),Ce="mailto:"+ye;else{let fe;do fe=pe[0],pe[0]=this.rules.inline._backpedal.exec(pe[0])?.[0]??"";while(fe!==pe[0]);ye=s(pe[0]),pe[1]==="www."?Ce="http://"+pe[0]:Ce=pe[0]}return{type:"link",raw:pe[0],text:ye,href:Ce,tokens:[{type:"text",raw:ye,text:ye}]}}}inlineText(he){const pe=this.rules.inline.text.exec(he);if(pe){let ye;return this.lexer.state.inRawBlock?ye=pe[0]:ye=s(pe[0]),{type:"text",raw:pe[0],text:ye}}}}const n=/^(?: *(?:\n|$))+/,t=/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,o=/^ {0,3}(`{3,}(?=[^`\n]*(?:\n|$))|~{3,})([^\n]*)(?:\n|$)(?:|([\s\S]*?)(?:\n|$))(?: {0,3}\1[~`]* *(?=\n|$)|$)/,c=/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,m=/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,g=/(?:[*+-]|\d{1,9}[.)])/,u=b(/^(?!bull |blockCode|fences|blockquote|heading|html)((?:.|\n(?!\s*?\n|bull |blockCode|fences|blockquote|heading|html))+?)\n {0,3}(=+|-+) *(?:\n+|$)/).replace(/bull/g,g).replace(/blockCode/g,/ {4}/).replace(/fences/g,/ {0,3}(?:`{3,}|~{3,})/).replace(/blockquote/g,/ {0,3}>/).replace(/heading/g,/ {0,3}#{1,6}/).replace(/html/g,/ {0,3}<[^\n>]+>\n/).getRegex(),S=/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,k=/^[^\n]+/,y=/(?!\s*\])(?:\\.|[^\[\]\\])+/,C=b(/^ {0,3}\[(label)\]: *(?:\n *)?([^<\s][^\s]*|<.*?>)(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/).replace("label",y).replace("title",/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/).getRegex(),T=b(/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/).replace(/bull/g,g).getRegex(),$="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|search|section|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",w=/<!--(?:-?>|[\s\S]*?(?:-->|$))/,M=b("^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))","i").replace("comment",w).replace("tag",$).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),A=b(S).replace("hr",c).replace("heading"," {0,3}#{1,6}(?:\\s|$)").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$).getRegex(),J={blockquote:b(/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/).replace("paragraph",A).getRegex(),code:t,def:C,fences:o,heading:m,hr:c,html:M,lheading:u,list:T,newline:n,paragraph:A,table:E,text:k},Y=b("^ *([^\\n ].*)\\n {0,3}((?:\\| *)?:?-+:? *(?:\\| *:?-+:? *)*(?:\\| *)?)(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)").replace("hr",c).replace("heading"," {0,3}#{1,6}(?:\\s|$)").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$).getRegex(),z={...J,table:Y,paragraph:b(S).replace("hr",c).replace("heading"," {0,3}#{1,6}(?:\\s|$)").replace("|lheading","").replace("table",Y).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$).getRegex()},Q={...J,html:b(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",w).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:E,lheading:/^(.+?)\n {0,3}(=+|-+) *(?:\n+|$)/,paragraph:b(S).replace("hr",c).replace("heading",` *#{1,6} *[^
]`).replace("lheading",u).replace("|table","").replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").replace("|tag","").getRegex()},V=/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,ie=/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,le=/^( {2,}|\\)\n(?!\s*$)/,_=/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,oe="\\p{P}\\p{S}",re=b(/^((?![*_])[\spunctuation])/,"u").replace(/punctuation/g,oe).getRegex(),ce=/\[[^[\]]*?\]\([^\(\)]*?\)|`[^`]*?`|<[^<>]*?>/g,x=b(/^(?:\*+(?:((?!\*)[punct])|[^\s*]))|^_+(?:((?!_)[punct])|([^\s_]))/,"u").replace(/punct/g,oe).getRegex(),$e=b("^[^_*]*?__[^_*]*?\\*[^_*]*?(?=__)|[^*]+(?=[^*])|(?!\\*)[punct](\\*+)(?=[\\s]|$)|[^punct\\s](\\*+)(?!\\*)(?=[punct\\s]|$)|(?!\\*)[punct\\s](\\*+)(?=[^punct\\s])|[\\s](\\*+)(?!\\*)(?=[punct])|(?!\\*)[punct](\\*+)(?!\\*)(?=[punct])|[^punct\\s](\\*+)(?=[^punct\\s])","gu").replace(/punct/g,oe).getRegex(),Pe=b("^[^_*]*?\\*\\*[^_*]*?_[^_*]*?(?=\\*\\*)|[^_]+(?=[^_])|(?!_)[punct](_+)(?=[\\s]|$)|[^punct\\s](_+)(?!_)(?=[punct\\s]|$)|(?!_)[punct\\s](_+)(?=[^punct\\s])|[\\s](_+)(?!_)(?=[punct])|(?!_)[punct](_+)(?!_)(?=[punct])","gu").replace(/punct/g,oe).getRegex(),X=b(/\\([punct])/,"gu").replace(/punct/g,oe).getRegex(),q=b(/^<(scheme:[^\s\x00-\x1f<>]*|email)>/).replace("scheme",/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/).replace("email",/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/).getRegex(),ne=b(w).replace("(?:-->|$)","-->").getRegex(),be=b("^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>").replace("comment",ne).replace("attribute",/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/).getRegex(),Ie=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Fe=b(/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/).replace("label",Ie).replace("href",/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/).replace("title",/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/).getRegex(),Be=b(/^!?\[(label)\]\[(ref)\]/).replace("label",Ie).replace("ref",y).getRegex(),xe=b(/^!?\[(ref)\](?:\[\])?/).replace("ref",y).getRegex(),nt=b("reflink|nolink(?!\\()","g").replace("reflink",Be).replace("nolink",xe).getRegex(),ut={_backpedal:E,anyPunctuation:X,autolink:q,blockSkip:ce,br:le,code:ie,del:E,emStrongLDelim:x,emStrongRDelimAst:$e,emStrongRDelimUnd:Pe,escape:V,link:Fe,nolink:xe,punctuation:re,reflink:Be,reflinkSearch:nt,tag:be,text:_,url:E},pt={...ut,link:b(/^!?\[(label)\]\((.*?)\)/).replace("label",Ie).getRegex(),reflink:b(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Ie).getRegex()},lt={...ut,escape:b(V).replace("])","~|])").getRegex(),url:b(/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,"i").replace("email",/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/).getRegex(),_backpedal:/(?:[^?!.,:;*_'"~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_'"~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/},et={...lt,br:b(le).replace("{2,}","*").getRegex(),text:b(lt.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()},Ne={normal:J,gfm:z,pedantic:Q},Me={normal:ut,gfm:lt,breaks:et,pedantic:pt};class Le{tokens;options;state;tokenizer;inlineQueue;constructor(he){this.tokens=[],this.tokens.links=Object.create(null),this.options=he||we.defaults,this.options.tokenizer=this.options.tokenizer||new i,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};const pe={block:Ne.normal,inline:Me.normal};this.options.pedantic?(pe.block=Ne.pedantic,pe.inline=Me.pedantic):this.options.gfm&&(pe.block=Ne.gfm,this.options.breaks?pe.inline=Me.breaks:pe.inline=Me.gfm),this.tokenizer.rules=pe}static get rules(){return{block:Ne,inline:Me}}static lex(he,pe){return new Le(pe).lex(he)}static lexInline(he,pe){return new Le(pe).inlineTokens(he)}lex(he){he=he.replace(/\r\n|\r/g,`
`),this.blockTokens(he,this.tokens);for(let pe=0;pe<this.inlineQueue.length;pe++){const ye=this.inlineQueue[pe];this.inlineTokens(ye.src,ye.tokens)}return this.inlineQueue=[],this.tokens}blockTokens(he,pe=[],ye=!1){this.options.pedantic?he=he.replace(/\t/g,"    ").replace(/^ +$/gm,""):he=he.replace(/^( *)(\t+)/gm,(Z,W,de)=>W+"    ".repeat(de.length));let Ce,fe,ve;for(;he;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(Z=>(Ce=Z.call({lexer:this},he,pe))?(he=he.substring(Ce.raw.length),pe.push(Ce),!0):!1))){if(Ce=this.tokenizer.space(he)){he=he.substring(Ce.raw.length),Ce.raw.length===1&&pe.length>0?pe[pe.length-1].raw+=`
`:pe.push(Ce);continue}if(Ce=this.tokenizer.code(he)){he=he.substring(Ce.raw.length),fe=pe[pe.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+Ce.raw,fe.text+=`
`+Ce.text,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):pe.push(Ce);continue}if(Ce=this.tokenizer.fences(he)){he=he.substring(Ce.raw.length),pe.push(Ce);continue}if(Ce=this.tokenizer.heading(he)){he=he.substring(Ce.raw.length),pe.push(Ce);continue}if(Ce=this.tokenizer.hr(he)){he=he.substring(Ce.raw.length),pe.push(Ce);continue}if(Ce=this.tokenizer.blockquote(he)){he=he.substring(Ce.raw.length),pe.push(Ce);continue}if(Ce=this.tokenizer.list(he)){he=he.substring(Ce.raw.length),pe.push(Ce);continue}if(Ce=this.tokenizer.html(he)){he=he.substring(Ce.raw.length),pe.push(Ce);continue}if(Ce=this.tokenizer.def(he)){he=he.substring(Ce.raw.length),fe=pe[pe.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+Ce.raw,fe.text+=`
`+Ce.raw,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):this.tokens.links[Ce.tag]||(this.tokens.links[Ce.tag]={href:Ce.href,title:Ce.title});continue}if(Ce=this.tokenizer.table(he)){he=he.substring(Ce.raw.length),pe.push(Ce);continue}if(Ce=this.tokenizer.lheading(he)){he=he.substring(Ce.raw.length),pe.push(Ce);continue}if(ve=he,this.options.extensions&&this.options.extensions.startBlock){let Z=1/0;const W=he.slice(1);let de;this.options.extensions.startBlock.forEach(je=>{de=je.call({lexer:this},W),typeof de=="number"&&de>=0&&(Z=Math.min(Z,de))}),Z<1/0&&Z>=0&&(ve=he.substring(0,Z+1))}if(this.state.top&&(Ce=this.tokenizer.paragraph(ve))){fe=pe[pe.length-1],ye&&fe?.type==="paragraph"?(fe.raw+=`
`+Ce.raw,fe.text+=`
`+Ce.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):pe.push(Ce),ye=ve.length!==he.length,he=he.substring(Ce.raw.length);continue}if(Ce=this.tokenizer.text(he)){he=he.substring(Ce.raw.length),fe=pe[pe.length-1],fe&&fe.type==="text"?(fe.raw+=`
`+Ce.raw,fe.text+=`
`+Ce.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):pe.push(Ce);continue}if(he){const Z="Infinite loop on byte: "+he.charCodeAt(0);if(this.options.silent){console.error(Z);break}else throw new Error(Z)}}return this.state.top=!0,pe}inline(he,pe=[]){return this.inlineQueue.push({src:he,tokens:pe}),pe}inlineTokens(he,pe=[]){let ye,Ce,fe,ve=he,Z,W,de;if(this.tokens.links){const je=Object.keys(this.tokens.links);if(je.length>0)for(;(Z=this.tokenizer.rules.inline.reflinkSearch.exec(ve))!=null;)je.includes(Z[0].slice(Z[0].lastIndexOf("[")+1,-1))&&(ve=ve.slice(0,Z.index)+"["+"a".repeat(Z[0].length-2)+"]"+ve.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Z=this.tokenizer.rules.inline.blockSkip.exec(ve))!=null;)ve=ve.slice(0,Z.index)+"["+"a".repeat(Z[0].length-2)+"]"+ve.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Z=this.tokenizer.rules.inline.anyPunctuation.exec(ve))!=null;)ve=ve.slice(0,Z.index)+"++"+ve.slice(this.tokenizer.rules.inline.anyPunctuation.lastIndex);for(;he;)if(W||(de=""),W=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(je=>(ye=je.call({lexer:this},he,pe))?(he=he.substring(ye.raw.length),pe.push(ye),!0):!1))){if(ye=this.tokenizer.escape(he)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(ye=this.tokenizer.tag(he)){he=he.substring(ye.raw.length),Ce=pe[pe.length-1],Ce&&ye.type==="text"&&Ce.type==="text"?(Ce.raw+=ye.raw,Ce.text+=ye.text):pe.push(ye);continue}if(ye=this.tokenizer.link(he)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(ye=this.tokenizer.reflink(he,this.tokens.links)){he=he.substring(ye.raw.length),Ce=pe[pe.length-1],Ce&&ye.type==="text"&&Ce.type==="text"?(Ce.raw+=ye.raw,Ce.text+=ye.text):pe.push(ye);continue}if(ye=this.tokenizer.emStrong(he,ve,de)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(ye=this.tokenizer.codespan(he)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(ye=this.tokenizer.br(he)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(ye=this.tokenizer.del(he)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(ye=this.tokenizer.autolink(he)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(!this.state.inLink&&(ye=this.tokenizer.url(he))){he=he.substring(ye.raw.length),pe.push(ye);continue}if(fe=he,this.options.extensions&&this.options.extensions.startInline){let je=1/0;const Qe=he.slice(1);let st;this.options.extensions.startInline.forEach(ht=>{st=ht.call({lexer:this},Qe),typeof st=="number"&&st>=0&&(je=Math.min(je,st))}),je<1/0&&je>=0&&(fe=he.substring(0,je+1))}if(ye=this.tokenizer.inlineText(fe)){he=he.substring(ye.raw.length),ye.raw.slice(-1)!=="_"&&(de=ye.raw.slice(-1)),W=!0,Ce=pe[pe.length-1],Ce&&Ce.type==="text"?(Ce.raw+=ye.raw,Ce.text+=ye.text):pe.push(ye);continue}if(he){const je="Infinite loop on byte: "+he.charCodeAt(0);if(this.options.silent){console.error(je);break}else throw new Error(je)}}return pe}}class B{options;parser;constructor(he){this.options=he||we.defaults}space(he){return""}code({text:he,lang:pe,escaped:ye}){const Ce=(pe||"").match(/^\S*/)?.[0],fe=he.replace(/\n$/,"")+`
`;return Ce?'<pre><code class="language-'+s(Ce)+'">'+(ye?fe:s(fe,!0))+`</code></pre>
`:"<pre><code>"+(ye?fe:s(fe,!0))+`</code></pre>
`}blockquote({tokens:he}){return`<blockquote>
${this.parser.parse(he)}</blockquote>
`}html({text:he}){return he}heading({tokens:he,depth:pe}){return`<h${pe}>${this.parser.parseInline(he)}</h${pe}>
`}hr(he){return`<hr>
`}list(he){const pe=he.ordered,ye=he.start;let Ce="";for(let Z=0;Z<he.items.length;Z++){const W=he.items[Z];Ce+=this.listitem(W)}const fe=pe?"ol":"ul",ve=pe&&ye!==1?' start="'+ye+'"':"";return"<"+fe+ve+`>
`+Ce+"</"+fe+`>
`}listitem(he){let pe="";if(he.task){const ye=this.checkbox({checked:!!he.checked});he.loose?he.tokens.length>0&&he.tokens[0].type==="paragraph"?(he.tokens[0].text=ye+" "+he.tokens[0].text,he.tokens[0].tokens&&he.tokens[0].tokens.length>0&&he.tokens[0].tokens[0].type==="text"&&(he.tokens[0].tokens[0].text=ye+" "+he.tokens[0].tokens[0].text)):he.tokens.unshift({type:"text",raw:ye+" ",text:ye+" "}):pe+=ye+" "}return pe+=this.parser.parse(he.tokens,!!he.loose),`<li>${pe}</li>
`}checkbox({checked:he}){return"<input "+(he?'checked="" ':"")+'disabled="" type="checkbox">'}paragraph({tokens:he}){return`<p>${this.parser.parseInline(he)}</p>
`}table(he){let pe="",ye="";for(let fe=0;fe<he.header.length;fe++)ye+=this.tablecell(he.header[fe]);pe+=this.tablerow({text:ye});let Ce="";for(let fe=0;fe<he.rows.length;fe++){const ve=he.rows[fe];ye="";for(let Z=0;Z<ve.length;Z++)ye+=this.tablecell(ve[Z]);Ce+=this.tablerow({text:ye})}return Ce&&(Ce=`<tbody>${Ce}</tbody>`),`<table>
<thead>
`+pe+`</thead>
`+Ce+`</table>
`}tablerow({text:he}){return`<tr>
${he}</tr>
`}tablecell(he){const pe=this.parser.parseInline(he.tokens),ye=he.header?"th":"td";return(he.align?`<${ye} align="${he.align}">`:`<${ye}>`)+pe+`</${ye}>
`}strong({tokens:he}){return`<strong>${this.parser.parseInline(he)}</strong>`}em({tokens:he}){return`<em>${this.parser.parseInline(he)}</em>`}codespan({text:he}){return`<code>${he}</code>`}br(he){return"<br>"}del({tokens:he}){return`<del>${this.parser.parseInline(he)}</del>`}link({href:he,title:pe,tokens:ye}){const Ce=this.parser.parseInline(ye),fe=h(he);if(fe===null)return Ce;he=fe;let ve='<a href="'+he+'"';return pe&&(ve+=' title="'+pe+'"'),ve+=">"+Ce+"</a>",ve}image({href:he,title:pe,text:ye}){const Ce=h(he);if(Ce===null)return ye;he=Ce;let fe=`<img src="${he}" alt="${ye}"`;return pe&&(fe+=` title="${pe}"`),fe+=">",fe}text(he){return"tokens"in he&&he.tokens?this.parser.parseInline(he.tokens):he.text}}class j{strong({text:he}){return he}em({text:he}){return he}codespan({text:he}){return he}del({text:he}){return he}html({text:he}){return he}text({text:he}){return he}link({text:he}){return""+he}image({text:he}){return""+he}br(){return""}}class H{options;renderer;textRenderer;constructor(he){this.options=he||we.defaults,this.options.renderer=this.options.renderer||new B,this.renderer=this.options.renderer,this.renderer.options=this.options,this.renderer.parser=this,this.textRenderer=new j}static parse(he,pe){return new H(pe).parse(he)}static parseInline(he,pe){return new H(pe).parseInline(he)}parse(he,pe=!0){let ye="";for(let Ce=0;Ce<he.length;Ce++){const fe=he[Ce];if(this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]){const Z=fe,W=this.options.extensions.renderers[Z.type].call({parser:this},Z);if(W!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Z.type)){ye+=W||"";continue}}const ve=fe;switch(ve.type){case"space":{ye+=this.renderer.space(ve);continue}case"hr":{ye+=this.renderer.hr(ve);continue}case"heading":{ye+=this.renderer.heading(ve);continue}case"code":{ye+=this.renderer.code(ve);continue}case"table":{ye+=this.renderer.table(ve);continue}case"blockquote":{ye+=this.renderer.blockquote(ve);continue}case"list":{ye+=this.renderer.list(ve);continue}case"html":{ye+=this.renderer.html(ve);continue}case"paragraph":{ye+=this.renderer.paragraph(ve);continue}case"text":{let Z=ve,W=this.renderer.text(Z);for(;Ce+1<he.length&&he[Ce+1].type==="text";)Z=he[++Ce],W+=`
`+this.renderer.text(Z);pe?ye+=this.renderer.paragraph({type:"paragraph",raw:W,text:W,tokens:[{type:"text",raw:W,text:W}]}):ye+=W;continue}default:{const Z='Token with "'+ve.type+'" type was not found.';if(this.options.silent)return console.error(Z),"";throw new Error(Z)}}}return ye}parseInline(he,pe){pe=pe||this.renderer;let ye="";for(let Ce=0;Ce<he.length;Ce++){const fe=he[Ce];if(this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]){const Z=this.options.extensions.renderers[fe.type].call({parser:this},fe);if(Z!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(fe.type)){ye+=Z||"";continue}}const ve=fe;switch(ve.type){case"escape":{ye+=pe.text(ve);break}case"html":{ye+=pe.html(ve);break}case"link":{ye+=pe.link(ve);break}case"image":{ye+=pe.image(ve);break}case"strong":{ye+=pe.strong(ve);break}case"em":{ye+=pe.em(ve);break}case"codespan":{ye+=pe.codespan(ve);break}case"br":{ye+=pe.br(ve);break}case"del":{ye+=pe.del(ve);break}case"text":{ye+=pe.text(ve);break}default:{const Z='Token with "'+ve.type+'" type was not found.';if(this.options.silent)return console.error(Z),"";throw new Error(Z)}}}return ye}}class G{options;constructor(he){this.options=he||we.defaults}static passThroughHooks=new Set(["preprocess","postprocess","processAllTokens"]);preprocess(he){return he}postprocess(he){return he}processAllTokens(he){return he}}class se{defaults=e();options=this.setOptions;parse=this.parseMarkdown(Le.lex,H.parse);parseInline=this.parseMarkdown(Le.lexInline,H.parseInline);Parser=H;Renderer=B;TextRenderer=j;Lexer=Le;Tokenizer=i;Hooks=G;constructor(...he){this.use(...he)}walkTokens(he,pe){let ye=[];for(const Ce of he)switch(ye=ye.concat(pe.call(this,Ce)),Ce.type){case"table":{const fe=Ce;for(const ve of fe.header)ye=ye.concat(this.walkTokens(ve.tokens,pe));for(const ve of fe.rows)for(const Z of ve)ye=ye.concat(this.walkTokens(Z.tokens,pe));break}case"list":{const fe=Ce;ye=ye.concat(this.walkTokens(fe.items,pe));break}default:{const fe=Ce;this.defaults.extensions?.childTokens?.[fe.type]?this.defaults.extensions.childTokens[fe.type].forEach(ve=>{const Z=fe[ve].flat(1/0);ye=ye.concat(this.walkTokens(Z,pe))}):fe.tokens&&(ye=ye.concat(this.walkTokens(fe.tokens,pe)))}}return ye}use(...he){const pe=this.defaults.extensions||{renderers:{},childTokens:{}};return he.forEach(ye=>{const Ce={...ye};if(Ce.async=this.defaults.async||Ce.async||!1,ye.extensions&&(ye.extensions.forEach(fe=>{if(!fe.name)throw new Error("extension name required");if("renderer"in fe){const ve=pe.renderers[fe.name];ve?pe.renderers[fe.name]=function(...Z){let W=fe.renderer.apply(this,Z);return W===!1&&(W=ve.apply(this,Z)),W}:pe.renderers[fe.name]=fe.renderer}if("tokenizer"in fe){if(!fe.level||fe.level!=="block"&&fe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");const ve=pe[fe.level];ve?ve.unshift(fe.tokenizer):pe[fe.level]=[fe.tokenizer],fe.start&&(fe.level==="block"?pe.startBlock?pe.startBlock.push(fe.start):pe.startBlock=[fe.start]:fe.level==="inline"&&(pe.startInline?pe.startInline.push(fe.start):pe.startInline=[fe.start]))}"childTokens"in fe&&fe.childTokens&&(pe.childTokens[fe.name]=fe.childTokens)}),Ce.extensions=pe),ye.renderer){const fe=this.defaults.renderer||new B(this.defaults);for(const ve in ye.renderer){if(!(ve in fe))throw new Error(`renderer '${ve}' does not exist`);if(["options","parser"].includes(ve))continue;const Z=ve,W=ye.renderer[Z],de=fe[Z];fe[Z]=(...je)=>{let Qe=W.apply(fe,je);return Qe===!1&&(Qe=de.apply(fe,je)),Qe||""}}Ce.renderer=fe}if(ye.tokenizer){const fe=this.defaults.tokenizer||new i(this.defaults);for(const ve in ye.tokenizer){if(!(ve in fe))throw new Error(`tokenizer '${ve}' does not exist`);if(["options","rules","lexer"].includes(ve))continue;const Z=ve,W=ye.tokenizer[Z],de=fe[Z];fe[Z]=(...je)=>{let Qe=W.apply(fe,je);return Qe===!1&&(Qe=de.apply(fe,je)),Qe}}Ce.tokenizer=fe}if(ye.hooks){const fe=this.defaults.hooks||new G;for(const ve in ye.hooks){if(!(ve in fe))throw new Error(`hook '${ve}' does not exist`);if(ve==="options")continue;const Z=ve,W=ye.hooks[Z],de=fe[Z];G.passThroughHooks.has(ve)?fe[Z]=je=>{if(this.defaults.async)return Promise.resolve(W.call(fe,je)).then(st=>de.call(fe,st));const Qe=W.call(fe,je);return de.call(fe,Qe)}:fe[Z]=(...je)=>{let Qe=W.apply(fe,je);return Qe===!1&&(Qe=de.apply(fe,je)),Qe}}Ce.hooks=fe}if(ye.walkTokens){const fe=this.defaults.walkTokens,ve=ye.walkTokens;Ce.walkTokens=function(Z){let W=[];return W.push(ve.call(this,Z)),fe&&(W=W.concat(fe.call(this,Z))),W}}this.defaults={...this.defaults,...Ce}}),this}setOptions(he){return this.defaults={...this.defaults,...he},this}lexer(he,pe){return Le.lex(he,pe??this.defaults)}parser(he,pe){return H.parse(he,pe??this.defaults)}parseMarkdown(he,pe){return(Ce,fe)=>{const ve={...fe},Z={...this.defaults,...ve},W=this.onError(!!Z.silent,!!Z.async);if(this.defaults.async===!0&&ve.async===!1)return W(new Error("marked(): The async option was set to true by an extension. Remove async: false from the parse options object to return a Promise."));if(typeof Ce>"u"||Ce===null)return W(new Error("marked(): input parameter is undefined or null"));if(typeof Ce!="string")return W(new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected"));if(Z.hooks&&(Z.hooks.options=Z),Z.async)return Promise.resolve(Z.hooks?Z.hooks.preprocess(Ce):Ce).then(de=>he(de,Z)).then(de=>Z.hooks?Z.hooks.processAllTokens(de):de).then(de=>Z.walkTokens?Promise.all(this.walkTokens(de,Z.walkTokens)).then(()=>de):de).then(de=>pe(de,Z)).then(de=>Z.hooks?Z.hooks.postprocess(de):de).catch(W);try{Z.hooks&&(Ce=Z.hooks.preprocess(Ce));let de=he(Ce,Z);Z.hooks&&(de=Z.hooks.processAllTokens(de)),Z.walkTokens&&this.walkTokens(de,Z.walkTokens);let je=pe(de,Z);return Z.hooks&&(je=Z.hooks.postprocess(je)),je}catch(de){return W(de)}}}onError(he,pe){return ye=>{if(ye.message+=`
Please report this to https://github.com/markedjs/marked.`,he){const Ce="<p>An error occurred:</p><pre>"+s(ye.message+"",!0)+"</pre>";return pe?Promise.resolve(Ce):Ce}if(pe)return Promise.reject(ye);throw ye}}}const ge=new se;function Ee(Ye,he){return ge.parse(Ye,he)}Ee.options=Ee.setOptions=function(Ye){return ge.setOptions(Ye),Ee.defaults=ge.defaults,v(Ee.defaults),Ee},Ee.getDefaults=e,Ee.defaults=we.defaults,Ee.use=function(...Ye){return ge.use(...Ye),Ee.defaults=ge.defaults,v(Ee.defaults),Ee},Ee.walkTokens=function(Ye,he){return ge.walkTokens(Ye,he)},Ee.parseInline=ge.parseInline,Ee.Parser=H,Ee.parser=H.parse,Ee.Renderer=B,Ee.TextRenderer=j,Ee.Lexer=Le,Ee.lexer=Le.lex,Ee.Tokenizer=i,Ee.Hooks=G,Ee.parse=Ee;const Ue=Ee.options,Je=Ee.setOptions,_e=Ee.use,tt=Ee.walkTokens,at=Ee.parseInline,it=Ee,ot=H.parse,vt=Le.lex;we.Hooks=G,we.Lexer=Le,we.Marked=se,we.Parser=H,we.Renderer=B,we.TextRenderer=j,we.Tokenizer=i,we.getDefaults=e,we.lexer=vt,we.marked=Ee,we.options=Ue,we.parse=it,we.parseInline=at,we.parser=ot,we.setOptions=Je,we.use=_e,we.walkTokens=tt}),define(Re[140],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=v;function v(r){const l=N(r);if(l&&l.length>0)return new Uint32Array(l)}let D=0;const P=new Uint32Array(10);function N(r){if(D=0,R(r,b,p.InitialConsonant),D>0||(R(r,h,p.Vowel),D>0)||(R(r,E,p.FinalConsonant),D>0)||(R(r,f,p.CompatibilityJamo),D))return P.subarray(0,D);if(r>=44032&&r<=55203){const l=r-44032,d=l%588,a=Math.floor(l/588),i=Math.floor(d/28),n=d%28-1;if(a<b.length?R(a,b,0):p.InitialConsonant+a-p.CompatibilityJamo<f.length&&R(p.InitialConsonant+a,f,p.CompatibilityJamo),i<h.length?R(i,h,0):p.Vowel+i-p.CompatibilityJamo<f.length&&R(p.Vowel+i-p.CompatibilityJamo,f,p.CompatibilityJamo),n>=0&&(n<E.length?R(n,E,0):p.FinalConsonant+n-p.CompatibilityJamo<f.length&&R(p.FinalConsonant+n-p.CompatibilityJamo,f,p.CompatibilityJamo)),D>0)return P.subarray(0,D)}}function R(r,l,d){r>=d&&r<d+l.length&&O(l[r-d])}function O(r){r!==s.NUL&&(P[D++]=r&255,r>>8&&(P[D++]=r>>8&255),r>>16&&(P[D++]=r>>16&255))}var p;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})(p||(p={}));var s;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(s||(s={}));var I;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(I||(I={}));const b=new Uint8Array([s.r,s.R,s.s,s.e,s.E,s.f,s.a,s.q,s.Q,s.t,s.T,s.d,s.w,s.W,s.c,s.z,s.x,s.v,s.g]),h=new Uint16Array([s.k,s.o,s.i,s.O,s.j,s.p,s.u,s.P,s.h,I.hk,I.ho,I.hl,s.y,s.n,I.nj,I.np,I.nl,s.b,s.m,I.ml,s.l]),E=new Uint16Array([s.r,s.R,I.rt,s.s,I.sw,I.sg,s.e,s.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,s.a,s.q,I.qt,s.t,s.T,s.d,s.w,s.c,s.z,s.x,s.v,s.g]),f=new Uint16Array([s.r,s.R,I.rt,s.s,I.sw,I.sg,s.e,s.E,s.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,s.a,s.q,s.Q,I.qt,s.t,s.T,s.d,s.w,s.W,s.c,s.z,s.x,s.v,s.g,s.k,s.o,s.i,s.O,s.j,s.p,s.u,s.P,s.h,I.hk,I.ho,I.hl,s.y,s.n,I.nj,I.np,I.nl,s.b,s.m,I.ml,s.l])}),define(Re[141],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Rm=e.$Qm=void 0,e.$Om=v,e.rot=D,e.$Tm=O;function v(p,s,I){return Math.min(Math.max(p,s),I)}function D(p,s){return(s+p%s)%s}class P{constructor(){this.a=0}getNext(){return this.a++}}e.$Qm=P;class N{constructor(){this.a=1,this.b=0}update(s){return this.b=this.b+(s-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Rm=N;class R{constructor(s){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(s),this.c.fill(0,0,s)}update(s){const I=this.c[this.d];return this.c[this.d]=s,this.d=(this.d+1)%this.c.length,this.e-=I,this.e+=s,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Sm=R;function O(p,s,I,b,h,E,f,r){const l=f-I,d=r-b,a=h-I,i=E-b,n=p-I,t=s-b,o=l*l+d*d,c=l*a+d*i,m=l*n+d*t,g=a*a+i*i,u=a*n+i*t,S=1/(o*g-c*c),k=(g*m-c*u)*S,y=(o*u-c*m)*S;return k>=0&&y>=0&&k+y<1}}),define(Re[142],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dd=void 0,e.$ed=N,e.$fd=h;class v{constructor(f,r,l){this.owner=f,this.debugNameSource=r,this.referenceFn=l}getDebugName(f){return N(f,this)}}e.$dd=v;const D=new Map,P=new WeakMap;function N(E,f){const r=P.get(E);if(r)return r;const l=R(E,f);if(l){let d=D.get(l)??0;d++,D.set(l,d);const a=d===1?l:`${l}#${d}`;return P.set(E,a),a}}function R(E,f){const r=P.get(E);if(r)return r;const l=f.owner?I(f.owner)+".":"";let d;const a=f.debugNameSource;if(a!==void 0)if(typeof a=="function"){if(d=a(),d!==void 0)return l+d}else return l+a;const i=f.referenceFn;if(i!==void 0&&(d=h(i),d!==void 0))return l+d;if(f.owner!==void 0){const n=O(f.owner,E);if(n!==void 0)return l+n}}function O(E,f){for(const r in E)if(E[r]===f)return r}const p=new Map,s=new WeakMap;function I(E){const f=s.get(E);if(f)return f;const r=b(E);let l=p.get(r)??0;l++,p.set(r,l);const d=l===1?r:`${r}#${l}`;return s.set(E,d),d}function b(E){const f=E.constructor;return f?f.name:"Object"}function h(E){const f=E.toString(),l=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(f);return(l?l[1]:void 0)?.trim()}}),define(Re[143],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pd=void 0,e.$Nd=D,e.$Od=P;let v;function D(r){v=r}function P(){return v}class N{constructor(){this.a=0,this.d=new WeakMap}b(l){return R([O(E("|  ",this.a)),l])}c(l){return l.hadValue?l.didChange?[O(" "),s(I(l.oldValue,70),{color:"red",strikeThrough:!0}),O(" "),s(I(l.newValue,60),{color:"green"})]:[O(" (unchanged)")]:[O(" "),s(I(l.newValue,60),{color:"green"}),O(" (initial)")]}handleObservableChanged(l,d){console.log(...this.b([p("observable value changed"),s(l.debugName,{color:"BlueViolet"}),...this.c(d)]))}formatChanges(l){if(l.size!==0)return s(" (changed deps: "+[...l].map(d=>d.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(l){const d=l.handleChange;this.d.set(l,new Set),l.handleChange=(a,i)=>(this.d.get(l).add(a),d.apply(l,[a,i]))}handleDerivedRecomputed(l,d){const a=this.d.get(l);console.log(...this.b([p("derived recomputed"),s(l.debugName,{color:"BlueViolet"}),...this.c(d),this.formatChanges(a),{data:[{fn:l._debugNameData.referenceFn??l._computeFn}]}])),a.clear()}handleFromEventObservableTriggered(l,d){console.log(...this.b([p("observable from event triggered"),s(l.debugName,{color:"BlueViolet"}),...this.c(d),{data:[{fn:l._getValue}]}]))}handleAutorunCreated(l){const d=l.handleChange;this.d.set(l,new Set),l.handleChange=(a,i)=>(this.d.get(l).add(a),d.apply(l,[a,i]))}handleAutorunTriggered(l){const d=this.d.get(l);console.log(...this.b([p("autorun"),s(l.debugName,{color:"BlueViolet"}),this.formatChanges(d),{data:[{fn:l._debugNameData.referenceFn??l._runFn}]}])),d.clear(),this.a++}handleAutorunFinished(l){this.a--}handleBeginTransaction(l){let d=l.getDebugName();d===void 0&&(d=""),console.log(...this.b([p("transaction"),s(d,{color:"BlueViolet"}),{data:[{fn:l._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Pd=N;function R(r){const l=new Array,d=[];let a="";function i(t){if("length"in t)for(const o of t)o&&i(o);else"text"in t?(a+=`%c${t.text}`,l.push(t.style),t.data&&d.push(...t.data)):"data"in t&&d.push(...t.data)}i(r);const n=[a,...l];return n.push(...d),n}function O(r){return s(r,{color:"black"})}function p(r){return s(f(`${r}: `,10),{color:"black",bold:!0})}function s(r,l={color:"black"}){function d(i){return Object.entries(i).reduce((n,[t,o])=>`${n}${t}:${o};`,"")}const a={color:l.color};return l.strikeThrough&&(a["text-decoration"]="line-through"),l.bold&&(a["font-weight"]="bold"),{text:r,style:d(a)}}function I(r,l){switch(typeof r){case"number":return""+r;case"string":return r.length+2<=l?`"${r}"`:`"${r.substr(0,l-7)}"+...`;case"boolean":return r?"true":"false";case"undefined":return"undefined";case"object":return r===null?"null":Array.isArray(r)?b(r,l):h(r,l);case"symbol":return r.toString();case"function":return`[[Function${r.name?" "+r.name:""}]]`;default:return""+r}}function b(r,l){let d="[ ",a=!0;for(const i of r){if(a||(d+=", "),d.length-5>l){d+="...";break}a=!1,d+=`${I(i,l-d.length)}`}return d+=" ]",d}function h(r,l){let d="{ ",a=!0;for(const[i,n]of Object.entries(r)){if(a||(d+=", "),d.length-5>l){d+="...";break}a=!1,d+=`${i}: ${I(n,l-d.length)}`}return d+=" }",d}function E(r,l){let d="";for(let a=1;a<=l;a++)d+=r;return d}function f(r,l){for(;r.length<l;)r+=" ";return r}}),define(Re[144],Te([1,0,136,142,143]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_d=e.$0d=e.$8d=e.$3d=e.$2d=void 0,e.$Yd=R,e.$Zd=p,e.$1d=I,e.$4d=E,e.$5d=r,e.$6d=l,e.$7d=d,e.$9d=i,e.$$d=t;let N;function R(c){N=c}let O;function p(c){O=c}let s;function I(c){s=c}class b{get TChange(){return null}reportChanges(){this.get()}read(m){return m?m.readObservable(this):this.get()}map(m,g){const u=g===void 0?void 0:m,S=g===void 0?m:g;return s({owner:u,debugName:()=>{const k=(0,D.$fd)(S);if(k!==void 0)return k;const C=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(S.toString());if(C)return`${this.debugName}.${C[2]}`;if(!u)return`${this.debugName} (mapped)`},debugReferenceFn:S},k=>S(this.read(k),k))}flatten(){return s({owner:void 0,debugName:()=>`${this.debugName} (flattened)`},m=>this.read(m).read(m))}recomputeInitiallyAndOnChange(m,g){return m.add(N(this,g)),this}keepObserved(m){return m.add(O(this)),this}get a(){return this.get()}}e.$2d=b;class h extends b{constructor(){super(...arguments),this.b=new Set}addObserver(m){const g=this.b.size;this.b.add(m),g===0&&this.c()}removeObserver(m){this.b.delete(m)&&this.b.size===0&&this.f()}c(){}f(){}}e.$3d=h;function E(c,m){const g=new a(c,m);try{c(g)}finally{g.finish()}}let f;function r(c){if(f)c(f);else{const m=new a(c,void 0);f=m;try{c(m)}finally{m.finish(),f=void 0}}}async function l(c,m){const g=new a(c,m);try{await c(g)}finally{g.finish()}}function d(c,m,g){c?m(c):E(m,g)}class a{constructor(m,g){this._fn=m,this.b=g,this.a=[],(0,P.$Od)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,D.$fd)(this._fn)}updateObserver(m,g){this.a.push({observer:m,observable:g}),m.beginUpdate(g)}finish(){const m=this.a;for(let g=0;g<m.length;g++){const{observer:u,observable:S}=m[g];u.endUpdate(S)}this.a=null,(0,P.$Od)()?.handleEndTransaction()}}e.$8d=a;function i(c,m){let g;return typeof c=="string"?g=new D.$dd(void 0,c,void 0):g=new D.$dd(c,void 0,void 0),new n(g,m,v.$9c)}class n extends h{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(m,g,u){super(),this.e=m,this.g=u,this.d=g}get(){return this.d}set(m,g,u){if(u===void 0&&this.g(this.d,m))return;let S;g||(g=S=new a(()=>{},()=>`Setting ${this.debugName}`));try{const k=this.d;this.h(m),(0,P.$Od)()?.handleObservableChanged(this,{oldValue:k,newValue:m,change:u,didChange:!0,hadValue:!0});for(const y of this.b)g.updateObserver(y,this),y.handleChange(this,u)}finally{S&&S.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(m){this.d=m}}e.$0d=n;function t(c,m){let g;return typeof c=="string"?g=new D.$dd(void 0,c,void 0):g=new D.$dd(c,void 0,void 0),new o(g,m,v.$9c)}class o extends n{h(m){this.d!==m&&(this.d&&this.d.dispose(),this.d=m)}dispose(){this.d?.dispose()}}e.$_d=o}),function(){function we(P){const N=[];typeof P=="number"&&N.push("code/timeOrigin",P);function R(p){N.push(p,Date.now())}function O(){const p=[];for(let s=0;s<N.length;s+=2)p.push({name:N[s],startTime:N[s+1]});return p}return{mark:R,getMarks:O}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?we():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const R of performance.getEntriesByType("mark"))N.push({name:R.name,startTime:Math.round(P+R.startTime)});return N}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return we(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),we()}function v(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=v(D))}(),define(Re[145],Te([1,0,40]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lJ=void 0;const D=Symbol("unset");class P{constructor(){this.a=new R,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||v.Iterable.empty()}get entries(){return this.a.children?.entries()||v.Iterable.empty()}insert(p,s,I){this.d(p,b=>b._value=s,I)}mutate(p,s){this.d(p,I=>I._value=s(I._value===D?void 0:I._value))}mutatePath(p,s){this.d(p,()=>{},I=>s(I))}delete(p){const s=this.c(p);if(!s)return;let I=s.length-1;const b=s[I].node._value;if(b!==D){for(this.b--,s[I].node._value=D;I>0;I--){const{node:h,part:E}=s[I];if(h.children?.size||h._value!==D)break;s[I-1].node.children.delete(E)}return b}}*deleteRecursive(p){const s=this.c(p);if(!s)return;const I=s[s.length-1].node;for(let b=s.length-1;b>0;b--){const h=s[b-1];if(h.node.children.delete(s[b].part),h.node.children.size>0||h.node._value!==D)break}for(const b of N(I))b._value!==D&&(this.b--,yield b._value)}find(p){let s=this.a;for(const I of p){const b=s.children?.get(I);if(!b)return;s=b}return s._value===D?void 0:s._value}hasKeyOrParent(p){let s=this.a;for(const I of p){const b=s.children?.get(I);if(!b)return!1;if(b._value!==D)return!0;s=b}return!1}hasKeyOrChildren(p){let s=this.a;for(const I of p){const b=s.children?.get(I);if(!b)return!1;s=b}return!0}hasKey(p){let s=this.a;for(const I of p){const b=s.children?.get(I);if(!b)return!1;s=b}return s._value!==D}c(p){const s=[{part:"",node:this.a}];let I=0;for(const b of p){const h=s[I].node.children?.get(b);if(!h)return;s.push({part:b,node:h}),I++}return s}d(p,s,I){let b=this.a;for(const f of p){if(b.children)if(b.children.has(f))b=b.children.get(f);else{const r=new R;b.children.set(f,r),b=r}else{const r=new R;b.children=new Map([[f,r]]),b=r}I?.(b)}const h=b._value===D?0:1;s(b);const E=b._value===D?0:1;this.b+=E-h}*values(){for(const{_value:p}of N(this.a))p!==D&&(yield p)}}e.$lJ=P;function*N(O){const p=[O];for(;p.length>0;){const s=p.pop();if(yield s,s.children)for(const I of s.children.values())p.push(I)}}class R{constructor(){this._value=D}get value(){return this._value===D?void 0:this._value}set value(p){this._value=p===void 0?D:p}}}),define(Re[146],Te([1,0,51,22]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gr=O,e.$Hr=p,e.$Ir=s,e.$Jr=I,e.$Kr=b,e.$Lr=h,e.$Mr=E,e.$Nr=f,e.$Or=r,e.$Pr=l,e.$Qr=u,e.$Rr=S,e.$Sr=k;const P=new v.$W(()=>{const y=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:y,collatorIsNumeric:y.resolvedOptions().numeric}}),N=new v.$W(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new v.$W(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function O(y,C,T=!1){const $=y||"",w=C||"",M=P.value.collator.compare($,w);return P.value.collatorIsNumeric&&M===0&&$!==w?$<w?-1:1:M}function p(y,C){const T=N.value.collator;return y=y||"",C=C||"",n(T,y,C)}function s(y,C){const T=N.value.collator;return y=y||"",C=C||"",m(y,C)||n(T,y,C)}function I(y,C){const T=N.value.collator;return y=y||"",C=C||"",c(y,C)||n(T,y,C)}function b(y,C){return y=y||"",C=C||"",y===C?0:y<C?-1:1}function h(y,C){const[T,$]=a(y),[w,M]=a(C);let A=P.value.collator.compare($,M);if(A===0){if(P.value.collatorIsNumeric&&$!==M)return $<M?-1:1;if(A=P.value.collator.compare(T,w),P.value.collatorIsNumeric&&A===0&&T!==w)return T<w?-1:1}return A}function E(y,C){y=y||"",C=C||"";const T=i(y),$=i(C),w=N.value.collator,M=R.value.collator;return n(M,T,$)||n(w,y,C)}function f(y,C){y=y||"",C=C||"";const T=i(y),$=i(C),w=N.value.collator,M=R.value.collator;return n(M,T,$)||m(y,C)||n(w,y,C)}function r(y,C){y=y||"",C=C||"";const T=i(y),$=i(C),w=N.value.collator,M=R.value.collator;return n(M,T,$)||c(y,C)||n(w,y,C)}function l(y,C){y=y||"",C=C||"";const T=i(y).toLowerCase(),$=i(C).toLowerCase();return T!==$?T<$?-1:1:y!==C?y<C?-1:1:0}const d=/^(.*?)(\.([^.]*))?$/;function a(y,C=!1){const T=y?d.exec(y):[];let $=[T&&T[1]||"",T&&T[3]||""];return C&&(!$[0]&&$[1]||$[0]&&$[0].charAt(0)===".")&&($=[$[0]+"."+$[1],""]),$}function i(y){const C=y?d.exec(y):[];return C&&C[1]&&C[1].charAt(0)!=="."&&C[3]||""}function n(y,C,T){const $=y.compare(C,T);return $!==0?$:C.length!==T.length?C.length<T.length?-1:1:0}function t(y){const C=y.charAt(0);return C.toLocaleUpperCase()!==C}function o(y){const C=y.charAt(0);return C.toLocaleLowerCase()!==C}function c(y,C){return t(y)&&o(C)?-1:o(y)&&t(C)?1:0}function m(y,C){return o(y)&&t(C)?-1:t(y)&&o(C)?1:0}function g(y,C,T=!1){return T||(y=y&&y.toLowerCase(),C=C&&C.toLowerCase()),y===C?0:y<C?-1:1}function u(y,C,T=!1){const $=y.split(D.sep),w=C.split(D.sep),M=$.length-1,A=w.length-1;let L,J;for(let Y=0;;Y++){if(L=M===Y,J=A===Y,L&&J)return O($[Y],w[Y],T);if(L)return-1;if(J)return 1;const z=g($[Y],w[Y],T);if(z!==0)return z}}function S(y,C,T){const $=y.toLowerCase(),w=C.toLowerCase(),M=k(y,C,T);if(M)return M;const A=$.endsWith(T),L=w.endsWith(T);if(A!==L)return A?-1:1;const J=O($,w);return J!==0?J:$.localeCompare(w)}function k(y,C,T){const $=y.toLowerCase(),w=C.toLowerCase(),M=$.startsWith(T),A=w.startsWith(T);if(M!==A)return M?-1:1;if(M&&A){if($.length<w.length)return-1;if($.length>w.length)return 1}return 0}}),define(Re[72],Te([1,0,22]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=void 0,e.$ft=N,e.$gt=R,e.$ht=O,e.$it=s,e.$et=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const D={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function N(I){const b=(0,v.$rc)(I),h=D[b.toLowerCase()];return h!==void 0?h:R(I)}function R(I){const b=(0,v.$rc)(I);return P[b.toLowerCase()]}function O(I){for(const b in P)if(P[b]===I)return b}const p=/^(.+)\/(.+?)(;.+)?$/;function s(I,b){const h=p.exec(I);return h?`${h[1].toLowerCase()}/${h[2].toLowerCase()}${h[3]??""}`:b?void 0:I}}),function(we,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var v=e();for(var D in v)(typeof exports=="object"?exports:we)[D]=v[D]}}(typeof self<"u"?self:this,function(){return function(we){var e={};function v(D){if(e[D])return e[D].exports;var P=e[D]={i:D,l:!1,exports:{}};return we[D].call(P.exports,P,P.exports,v),P.l=!0,P.exports}return v.m=we,v.c=e,v.d=function(D,P,N){v.o(D,P)||Object.defineProperty(D,P,{enumerable:!0,get:N})},v.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},v.t=function(D,P){if(1&P&&(D=v(D)),8&P||4&P&&typeof D=="object"&&D&&D.__esModule)return D;var N=Object.create(null);if(v.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:D}),2&P&&typeof D!="string")for(var R in D)v.d(N,R,function(O){return D[O]}.bind(null,R));return N},v.n=function(D){var P=D&&D.__esModule?function(){return D.default}:function(){return D};return v.d(P,"a",P),P},v.o=function(D,P){return Object.prototype.hasOwnProperty.call(D,P)},v.p="",v(v.s=0)}([function(we,e,v){(function(D){var P;e=we.exports=$e,P=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var j=Array.prototype.slice.call(arguments,0);j.unshift("SEMVER"),console.log.apply(console,j)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,O=e.re=[],p=e.src=[],s=0,I=s++;p[I]="0|[1-9]\\d*";var b=s++;p[b]="[0-9]+";var h=s++;p[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=s++;p[E]="("+p[I]+")\\.("+p[I]+")\\.("+p[I]+")";var f=s++;p[f]="("+p[b]+")\\.("+p[b]+")\\.("+p[b]+")";var r=s++;p[r]="(?:"+p[I]+"|"+p[h]+")";var l=s++;p[l]="(?:"+p[b]+"|"+p[h]+")";var d=s++;p[d]="(?:-("+p[r]+"(?:\\."+p[r]+")*))";var a=s++;p[a]="(?:-?("+p[l]+"(?:\\."+p[l]+")*))";var i=s++;p[i]="[0-9A-Za-z-]+";var n=s++;p[n]="(?:\\+("+p[i]+"(?:\\."+p[i]+")*))";var t=s++,o="v?"+p[E]+p[d]+"?"+p[n]+"?";p[t]="^"+o+"$";var c="[v=\\s]*"+p[f]+p[a]+"?"+p[n]+"?",m=s++;p[m]="^"+c+"$";var g=s++;p[g]="((?:<|>)?=?)";var u=s++;p[u]=p[b]+"|x|X|\\*";var S=s++;p[S]=p[I]+"|x|X|\\*";var k=s++;p[k]="[v=\\s]*("+p[S]+")(?:\\.("+p[S]+")(?:\\.("+p[S]+")(?:"+p[d]+")?"+p[n]+"?)?)?";var y=s++;p[y]="[v=\\s]*("+p[u]+")(?:\\.("+p[u]+")(?:\\.("+p[u]+")(?:"+p[a]+")?"+p[n]+"?)?)?";var C=s++;p[C]="^"+p[g]+"\\s*"+p[k]+"$";var T=s++;p[T]="^"+p[g]+"\\s*"+p[y]+"$";var $=s++;p[$]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var w=s++;p[w]="(?:~>?)";var M=s++;p[M]="(\\s*)"+p[w]+"\\s+",O[M]=new RegExp(p[M],"g");var A=s++;p[A]="^"+p[w]+p[k]+"$";var L=s++;p[L]="^"+p[w]+p[y]+"$";var J=s++;p[J]="(?:\\^)";var Y=s++;p[Y]="(\\s*)"+p[J]+"\\s+",O[Y]=new RegExp(p[Y],"g");var z=s++;p[z]="^"+p[J]+p[k]+"$";var Q=s++;p[Q]="^"+p[J]+p[y]+"$";var V=s++;p[V]="^"+p[g]+"\\s*("+c+")$|^$";var ie=s++;p[ie]="^"+p[g]+"\\s*("+o+")$|^$";var le=s++;p[le]="(\\s*)"+p[g]+"\\s*("+c+"|"+p[k]+")",O[le]=new RegExp(p[le],"g");var _=s++;p[_]="^\\s*("+p[k]+")\\s+-\\s+("+p[k]+")\\s*$";var oe=s++;p[oe]="^\\s*("+p[y]+")\\s+-\\s+("+p[y]+")\\s*$";var re=s++;p[re]="(<|>)?=?\\s*\\*";for(var ce=0;ce<35;ce++)P(ce,p[ce]),O[ce]||(O[ce]=new RegExp(p[ce]));function x(j,H){if(j instanceof $e)return j;if(typeof j!="string"||j.length>N||!(H?O[m]:O[t]).test(j))return null;try{return new $e(j,H)}catch{return null}}function $e(j,H){if(j instanceof $e){if(j.loose===H)return j;j=j.version}else if(typeof j!="string")throw new TypeError("Invalid Version: "+j);if(j.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof $e))return new $e(j,H);P("SemVer",j,H),this.loose=H;var G=j.trim().match(H?O[m]:O[t]);if(!G)throw new TypeError("Invalid Version: "+j);if(this.raw=j,this.major=+G[1],this.minor=+G[2],this.patch=+G[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");G[4]?this.prerelease=G[4].split(".").map(function(se){if(/^[0-9]+$/.test(se)){var ge=+se;if(ge>=0&&ge<R)return ge}return se}):this.prerelease=[],this.build=G[5]?G[5].split("."):[],this.format()}e.parse=x,e.valid=function(j,H){var G=x(j,H);return G?G.version:null},e.clean=function(j,H){var G=x(j.trim().replace(/^[=v]+/,""),H);return G?G.version:null},e.SemVer=$e,$e.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},$e.prototype.toString=function(){return this.version},$e.prototype.compare=function(j){return P("SemVer.compare",this.version,this.loose,j),j instanceof $e||(j=new $e(j,this.loose)),this.compareMain(j)||this.comparePre(j)},$e.prototype.compareMain=function(j){return j instanceof $e||(j=new $e(j,this.loose)),X(this.major,j.major)||X(this.minor,j.minor)||X(this.patch,j.patch)},$e.prototype.comparePre=function(j){if(j instanceof $e||(j=new $e(j,this.loose)),this.prerelease.length&&!j.prerelease.length)return-1;if(!this.prerelease.length&&j.prerelease.length)return 1;if(!this.prerelease.length&&!j.prerelease.length)return 0;var H=0;do{var G=this.prerelease[H],se=j.prerelease[H];if(P("prerelease compare",H,G,se),G===void 0&&se===void 0)return 0;if(se===void 0)return 1;if(G===void 0)return-1;if(G!==se)return X(G,se)}while(++H)},$e.prototype.inc=function(j,H){switch(j){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var G=this.prerelease.length;--G>=0;)typeof this.prerelease[G]=="number"&&(this.prerelease[G]++,G=-2);G===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+j)}return this.format(),this.raw=this.version,this},e.inc=function(j,H,G,se){typeof G=="string"&&(se=G,G=void 0);try{return new $e(j,G).inc(H,se).version}catch{return null}},e.diff=function(j,H){if(Ie(j,H))return null;var G=x(j),se=x(H);if(G.prerelease.length||se.prerelease.length){for(var ge in G)if((ge==="major"||ge==="minor"||ge==="patch")&&G[ge]!==se[ge])return"pre"+ge;return"prerelease"}for(var ge in G)if((ge==="major"||ge==="minor"||ge==="patch")&&G[ge]!==se[ge])return ge},e.compareIdentifiers=X;var Pe=/^[0-9]+$/;function X(j,H){var G=Pe.test(j),se=Pe.test(H);return G&&se&&(j=+j,H=+H),G&&!se?-1:se&&!G?1:j<H?-1:j>H?1:0}function q(j,H,G){return new $e(j,G).compare(new $e(H,G))}function ne(j,H,G){return q(j,H,G)>0}function be(j,H,G){return q(j,H,G)<0}function Ie(j,H,G){return q(j,H,G)===0}function Fe(j,H,G){return q(j,H,G)!==0}function Be(j,H,G){return q(j,H,G)>=0}function xe(j,H,G){return q(j,H,G)<=0}function nt(j,H,G,se){var ge;switch(H){case"===":typeof j=="object"&&(j=j.version),typeof G=="object"&&(G=G.version),ge=j===G;break;case"!==":typeof j=="object"&&(j=j.version),typeof G=="object"&&(G=G.version),ge=j!==G;break;case"":case"=":case"==":ge=Ie(j,G,se);break;case"!=":ge=Fe(j,G,se);break;case">":ge=ne(j,G,se);break;case">=":ge=Be(j,G,se);break;case"<":ge=be(j,G,se);break;case"<=":ge=xe(j,G,se);break;default:throw new TypeError("Invalid operator: "+H)}return ge}function ut(j,H){if(j instanceof ut){if(j.loose===H)return j;j=j.value}if(!(this instanceof ut))return new ut(j,H);P("comparator",j,H),this.loose=H,this.parse(j),this.semver===pt?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(j,H){return X(H,j)},e.major=function(j,H){return new $e(j,H).major},e.minor=function(j,H){return new $e(j,H).minor},e.patch=function(j,H){return new $e(j,H).patch},e.compare=q,e.compareLoose=function(j,H){return q(j,H,!0)},e.rcompare=function(j,H,G){return q(H,j,G)},e.sort=function(j,H){return j.sort(function(G,se){return e.compare(G,se,H)})},e.rsort=function(j,H){return j.sort(function(G,se){return e.rcompare(G,se,H)})},e.gt=ne,e.lt=be,e.eq=Ie,e.neq=Fe,e.gte=Be,e.lte=xe,e.cmp=nt,e.Comparator=ut;var pt={};function lt(j,H){if(j instanceof lt)return j.loose===H?j:new lt(j.raw,H);if(j instanceof ut)return new lt(j.value,H);if(!(this instanceof lt))return new lt(j,H);if(this.loose=H,this.raw=j,this.set=j.split(/\s*\|\|\s*/).map(function(G){return this.parseRange(G.trim())},this).filter(function(G){return G.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+j);this.format()}function et(j){return!j||j.toLowerCase()==="x"||j==="*"}function Ne(j,H,G,se,ge,Ee,Ue,Je,_e,tt,at,it,ot){return((H=et(G)?"":et(se)?">="+G+".0.0":et(ge)?">="+G+"."+se+".0":">="+H)+" "+(Je=et(_e)?"":et(tt)?"<"+(+_e+1)+".0.0":et(at)?"<"+_e+"."+(+tt+1)+".0":it?"<="+_e+"."+tt+"."+at+"-"+it:"<="+Je)).trim()}function Me(j,H){for(var G=0;G<j.length;G++)if(!j[G].test(H))return!1;if(H.prerelease.length){for(G=0;G<j.length;G++)if(P(j[G].semver),j[G].semver!==pt&&j[G].semver.prerelease.length>0){var se=j[G].semver;if(se.major===H.major&&se.minor===H.minor&&se.patch===H.patch)return!0}return!1}return!0}function Le(j,H,G){try{H=new lt(H,G)}catch{return!1}return H.test(j)}function B(j,H,G,se){var ge,Ee,Ue,Je,_e;switch(j=new $e(j,se),H=new lt(H,se),G){case">":ge=ne,Ee=xe,Ue=be,Je=">",_e=">=";break;case"<":ge=be,Ee=Be,Ue=ne,Je="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Le(j,H,se))return!1;for(var tt=0;tt<H.set.length;++tt){var at=H.set[tt],it=null,ot=null;if(at.forEach(function(vt){vt.semver===pt&&(vt=new ut(">=0.0.0")),it=it||vt,ot=ot||vt,ge(vt.semver,it.semver,se)?it=vt:Ue(vt.semver,ot.semver,se)&&(ot=vt)}),it.operator===Je||it.operator===_e||(!ot.operator||ot.operator===Je)&&Ee(j,ot.semver)||ot.operator===_e&&Ue(j,ot.semver))return!1}return!0}ut.prototype.parse=function(j){var H=this.loose?O[V]:O[ie],G=j.match(H);if(!G)throw new TypeError("Invalid comparator: "+j);this.operator=G[1],this.operator==="="&&(this.operator=""),G[2]?this.semver=new $e(G[2],this.loose):this.semver=pt},ut.prototype.toString=function(){return this.value},ut.prototype.test=function(j){return P("Comparator.test",j,this.loose),this.semver===pt||(typeof j=="string"&&(j=new $e(j,this.loose)),nt(j,this.operator,this.semver,this.loose))},ut.prototype.intersects=function(j,H){if(!(j instanceof ut))throw new TypeError("a Comparator is required");var G;if(this.operator==="")return G=new lt(j.value,H),Le(this.value,G,H);if(j.operator==="")return G=new lt(this.value,H),Le(j.semver,G,H);var se=!(this.operator!==">="&&this.operator!==">"||j.operator!==">="&&j.operator!==">"),ge=!(this.operator!=="<="&&this.operator!=="<"||j.operator!=="<="&&j.operator!=="<"),Ee=this.semver.version===j.semver.version,Ue=!(this.operator!==">="&&this.operator!=="<="||j.operator!==">="&&j.operator!=="<="),Je=nt(this.semver,"<",j.semver,H)&&(this.operator===">="||this.operator===">")&&(j.operator==="<="||j.operator==="<"),_e=nt(this.semver,">",j.semver,H)&&(this.operator==="<="||this.operator==="<")&&(j.operator===">="||j.operator===">");return se||ge||Ee&&Ue||Je||_e},e.Range=lt,lt.prototype.format=function(){return this.range=this.set.map(function(j){return j.join(" ").trim()}).join("||").trim(),this.range},lt.prototype.toString=function(){return this.range},lt.prototype.parseRange=function(j){var H=this.loose;j=j.trim(),P("range",j,H);var G=H?O[oe]:O[_];j=j.replace(G,Ne),P("hyphen replace",j),j=j.replace(O[le],"$1$2$3"),P("comparator trim",j,O[le]),j=(j=(j=j.replace(O[M],"$1~")).replace(O[Y],"$1^")).split(/\s+/).join(" ");var se=H?O[V]:O[ie],ge=j.split(" ").map(function(Ee){return function(Ue,Je){return P("comp",Ue),Ue=function(_e,tt){return _e.trim().split(/\s+/).map(function(at){return function(it,ot){P("caret",it,ot);var vt=ot?O[Q]:O[z];return it.replace(vt,function(Ye,he,pe,ye,Ce){var fe;return P("caret",it,Ye,he,pe,ye,Ce),et(he)?fe="":et(pe)?fe=">="+he+".0.0 <"+(+he+1)+".0.0":et(ye)?fe=he==="0"?">="+he+"."+pe+".0 <"+he+"."+(+pe+1)+".0":">="+he+"."+pe+".0 <"+(+he+1)+".0.0":Ce?(P("replaceCaret pr",Ce),Ce.charAt(0)!=="-"&&(Ce="-"+Ce),fe=he==="0"?pe==="0"?">="+he+"."+pe+"."+ye+Ce+" <"+he+"."+pe+"."+(+ye+1):">="+he+"."+pe+"."+ye+Ce+" <"+he+"."+(+pe+1)+".0":">="+he+"."+pe+"."+ye+Ce+" <"+(+he+1)+".0.0"):(P("no pr"),fe=he==="0"?pe==="0"?">="+he+"."+pe+"."+ye+" <"+he+"."+pe+"."+(+ye+1):">="+he+"."+pe+"."+ye+" <"+he+"."+(+pe+1)+".0":">="+he+"."+pe+"."+ye+" <"+(+he+1)+".0.0"),P("caret return",fe),fe})}(at,tt)}).join(" ")}(Ue,Je),P("caret",Ue),Ue=function(_e,tt){return _e.trim().split(/\s+/).map(function(at){return function(it,ot){var vt=ot?O[L]:O[A];return it.replace(vt,function(Ye,he,pe,ye,Ce){var fe;return P("tilde",it,Ye,he,pe,ye,Ce),et(he)?fe="":et(pe)?fe=">="+he+".0.0 <"+(+he+1)+".0.0":et(ye)?fe=">="+he+"."+pe+".0 <"+he+"."+(+pe+1)+".0":Ce?(P("replaceTilde pr",Ce),Ce.charAt(0)!=="-"&&(Ce="-"+Ce),fe=">="+he+"."+pe+"."+ye+Ce+" <"+he+"."+(+pe+1)+".0"):fe=">="+he+"."+pe+"."+ye+" <"+he+"."+(+pe+1)+".0",P("tilde return",fe),fe})}(at,tt)}).join(" ")}(Ue,Je),P("tildes",Ue),Ue=function(_e,tt){return P("replaceXRanges",_e,tt),_e.split(/\s+/).map(function(at){return function(it,ot){it=it.trim();var vt=ot?O[T]:O[C];return it.replace(vt,function(Ye,he,pe,ye,Ce,fe){P("xRange",it,Ye,he,pe,ye,Ce,fe);var ve=et(pe),Z=ve||et(ye),W=Z||et(Ce);return he==="="&&W&&(he=""),ve?Ye=he===">"||he==="<"?"<0.0.0":"*":he&&W?(Z&&(ye=0),W&&(Ce=0),he===">"?(he=">=",Z?(pe=+pe+1,ye=0,Ce=0):W&&(ye=+ye+1,Ce=0)):he==="<="&&(he="<",Z?pe=+pe+1:ye=+ye+1),Ye=he+pe+"."+ye+"."+Ce):Z?Ye=">="+pe+".0.0 <"+(+pe+1)+".0.0":W&&(Ye=">="+pe+"."+ye+".0 <"+pe+"."+(+ye+1)+".0"),P("xRange return",Ye),Ye})}(at,tt)}).join(" ")}(Ue,Je),P("xrange",Ue),Ue=function(_e,tt){return P("replaceStars",_e,tt),_e.trim().replace(O[re],"")}(Ue,Je),P("stars",Ue),Ue}(Ee,H)}).join(" ").split(/\s+/);return this.loose&&(ge=ge.filter(function(Ee){return!!Ee.match(se)})),ge=ge.map(function(Ee){return new ut(Ee,H)})},lt.prototype.intersects=function(j,H){if(!(j instanceof lt))throw new TypeError("a Range is required");return this.set.some(function(G){return G.every(function(se){return j.set.some(function(ge){return ge.every(function(Ee){return se.intersects(Ee,H)})})})})},e.toComparators=function(j,H){return new lt(j,H).set.map(function(G){return G.map(function(se){return se.value}).join(" ").trim().split(" ")})},lt.prototype.test=function(j){if(!j)return!1;typeof j=="string"&&(j=new $e(j,this.loose));for(var H=0;H<this.set.length;H++)if(Me(this.set[H],j))return!0;return!1},e.satisfies=Le,e.maxSatisfying=function(j,H,G){var se=null,ge=null;try{var Ee=new lt(H,G)}catch{return null}return j.forEach(function(Ue){Ee.test(Ue)&&(se&&ge.compare(Ue)!==-1||(ge=new $e(se=Ue,G)))}),se},e.minSatisfying=function(j,H,G){var se=null,ge=null;try{var Ee=new lt(H,G)}catch{return null}return j.forEach(function(Ue){Ee.test(Ue)&&(se&&ge.compare(Ue)!==1||(ge=new $e(se=Ue,G)))}),se},e.validRange=function(j,H){try{return new lt(j,H).range||"*"}catch{return null}},e.ltr=function(j,H,G){return B(j,H,"<",G)},e.gtr=function(j,H,G){return B(j,H,">",G)},e.outside=B,e.prerelease=function(j,H){var G=x(j,H);return G&&G.prerelease.length?G.prerelease:null},e.intersects=function(j,H,G){return j=new lt(j,G),H=new lt(H,G),j.intersects(H)},e.coerce=function(j){if(j instanceof $e)return j;if(typeof j!="string")return null;var H=j.match(O[$]);return H==null?null:x((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,v(1))},function(we,e){var v,D,P=we.exports={};function N(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function O(l){if(v===setTimeout)return setTimeout(l,0);if((v===N||!v)&&setTimeout)return v=setTimeout,setTimeout(l,0);try{return v(l,0)}catch{try{return v.call(null,l,0)}catch{return v.call(this,l,0)}}}(function(){try{v=typeof setTimeout=="function"?setTimeout:N}catch{v=N}try{D=typeof clearTimeout=="function"?clearTimeout:R}catch{D=R}})();var p,s=[],I=!1,b=-1;function h(){I&&p&&(I=!1,p.length?s=p.concat(s):b=-1,s.length&&E())}function E(){if(!I){var l=O(h);I=!0;for(var d=s.length;d;){for(p=s,s=[];++b<d;)p&&p[b].run();b=-1,d=s.length}p=null,I=!1,function(a){if(D===clearTimeout)return clearTimeout(a);if((D===R||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(a);try{D(a)}catch{try{return D.call(null,a)}catch{return D.call(this,a)}}}(l)}}function f(l,d){this.fun=l,this.array=d}function r(){}P.nextTick=function(l){var d=new Array(arguments.length-1);if(arguments.length>1)for(var a=1;a<arguments.length;a++)d[a-1]=arguments[a];s.push(new f(l,d)),s.length!==1||I||O(E)},f.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=r,P.addListener=r,P.once=r,P.off=r,P.removeListener=r,P.removeAllListeners=r,P.emit=r,P.prependListener=r,P.prependOnceListener=r,P.listeners=function(l){return[]},P.binding=function(l){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(l){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Re[147],Te([1,0,6,4]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mt=e.$lt=e.$kt=e.$jt=e.ScrollbarVisibility=void 0;var P;(function(E){E[E.Auto=1]="Auto",E[E.Hidden=2]="Hidden",E[E.Visible=3]="Visible"})(P||(e.ScrollbarVisibility=P={}));class N{constructor(f,r,l,d,a,i,n){this.c=f,this._scrollStateBrand=void 0,this.c&&(r=r|0,l=l|0,d=d|0,a=a|0,i=i|0,n=n|0),this.rawScrollLeft=d,this.rawScrollTop=n,r<0&&(r=0),d+r>l&&(d=l-r),d<0&&(d=0),a<0&&(a=0),n+a>i&&(n=i-a),n<0&&(n=0),this.width=r,this.scrollWidth=l,this.scrollLeft=d,this.height=a,this.scrollHeight=i,this.scrollTop=n}equals(f){return this.rawScrollLeft===f.rawScrollLeft&&this.rawScrollTop===f.rawScrollTop&&this.width===f.width&&this.scrollWidth===f.scrollWidth&&this.scrollLeft===f.scrollLeft&&this.height===f.height&&this.scrollHeight===f.scrollHeight&&this.scrollTop===f.scrollTop}withScrollDimensions(f,r){return new N(this.c,typeof f.width<"u"?f.width:this.width,typeof f.scrollWidth<"u"?f.scrollWidth:this.scrollWidth,r?this.rawScrollLeft:this.scrollLeft,typeof f.height<"u"?f.height:this.height,typeof f.scrollHeight<"u"?f.scrollHeight:this.scrollHeight,r?this.rawScrollTop:this.scrollTop)}withScrollPosition(f){return new N(this.c,this.width,this.scrollWidth,typeof f.scrollLeft<"u"?f.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof f.scrollTop<"u"?f.scrollTop:this.rawScrollTop)}createScrollEvent(f,r){const l=this.width!==f.width,d=this.scrollWidth!==f.scrollWidth,a=this.scrollLeft!==f.scrollLeft,i=this.height!==f.height,n=this.scrollHeight!==f.scrollHeight,t=this.scrollTop!==f.scrollTop;return{inSmoothScrolling:r,oldWidth:f.width,oldScrollWidth:f.scrollWidth,oldScrollLeft:f.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:f.height,oldScrollHeight:f.scrollHeight,oldScrollTop:f.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:l,scrollWidthChanged:d,scrollLeftChanged:a,heightChanged:i,scrollHeightChanged:n,scrollTopChanged:t}}}e.$jt=N;class R extends D.$Xc{constructor(f){super(),this._scrollableBrand=void 0,this.j=this.B(new v.$oe),this.onScroll=this.j.event,this.c=f.smoothScrollDuration,this.f=f.scheduleAtNextAnimationFrame,this.g=new N(f.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(f){this.c=f}validateScrollPosition(f){return this.g.withScrollPosition(f)}getScrollDimensions(){return this.g}setScrollDimensions(f,r){const l=this.g.withScrollDimensions(f,r);this.n(l,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(f){const r=this.g.withScrollPosition(f);this.h&&(this.h.dispose(),this.h=null),this.n(r,!1)}setScrollPositionSmooth(f,r){if(this.c===0)return this.setScrollPositionNow(f);if(this.h){f={scrollLeft:typeof f.scrollLeft>"u"?this.h.to.scrollLeft:f.scrollLeft,scrollTop:typeof f.scrollTop>"u"?this.h.to.scrollTop:f.scrollTop};const l=this.g.withScrollPosition(f);if(this.h.to.scrollLeft===l.scrollLeft&&this.h.to.scrollTop===l.scrollTop)return;let d;r?d=new I(this.h.from,l,this.h.startTime,this.h.duration):d=this.h.combine(this.g,l,this.c),this.h.dispose(),this.h=d}else{const l=this.g.withScrollPosition(f);this.h=I.start(this.g,l,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const f=this.h.tick(),r=this.g.withScrollPosition(f);if(this.n(r,!0),!!this.h){if(f.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(f,r){const l=this.g;l.equals(f)||(this.g=f,this.j.fire(this.g.createScrollEvent(l,r)))}}e.$kt=R;class O{constructor(f,r,l){this.scrollLeft=f,this.scrollTop=r,this.isDone=l}}e.$lt=O;function p(E,f){const r=f-E;return function(l){return E+r*h(l)}}function s(E,f,r){return function(l){return l<r?E(l/r):f((l-r)/(1-r))}}class I{constructor(f,r,l,d){this.from=f,this.to=r,this.duration=d,this.startTime=l,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(f,r,l){if(Math.abs(f-r)>2.5*l){let a,i;return f<r?(a=f+.75*l,i=r-.75*l):(a=f-.75*l,i=r+.75*l),s(p(f,a),p(i,r),.33)}return p(f,r)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(f){this.to=f.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(f){const r=(f-this.startTime)/this.duration;if(r<1){const l=this.c(r),d=this.d(r);return new O(l,d,!1)}return new O(this.to.scrollLeft,this.to.scrollTop,!0)}combine(f,r,l){return I.start(f,r,l)}static start(f,r,l){l=l+10;const d=Date.now()-10;return new I(f,r,d,l)}}e.$mt=I;function b(E){return Math.pow(E,3)}function h(E){return 1-b(1-E)}}),define(Re[148],Te([1,0,12,4]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Be=P,e.$Ce=N,e.$De=R,e.$Ee=O,e.$Fe=s,e.$Ge=I,e.$He=b,e.$Ie=h,e.$Je=E,e.$Ke=f,e.$Le=r,e.$Me=l,e.$Ne=d,e.$Oe=a,e.$Pe=i;function P(n){const t=n;return t?typeof t.read=="function":!1}function N(n){const t=n;return t?[t.on,t.pause,t.resume,t.destroy].every(o=>typeof o=="function"):!1}function R(n){const t=n;return t?N(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function O(n,t){return new p(n,t)}class p{constructor(t,o){this.e=t,this.f=o,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(o=>this.d.push(o))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(o=>o(t))}h(t){this.c.error.length===0?(0,v.$2)(t):this.c.error.slice(0).forEach(o=>o(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,o){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(o),this.resume();break;case"end":this.c.end.push(o),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(o),this.a.flowing&&this.k();break}}removeListener(t,o){if(this.a.destroyed)return;let c;switch(t){case"data":c=this.c.data;break;case"end":c=this.c.end;break;case"error":c=this.c.error;break}if(c){const m=c.indexOf(o);m>=0&&c.splice(m,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const o=[...this.d];this.d.length=0,o.forEach(c=>c())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function s(n,t){const o=[];let c;for(;(c=n.read())!==null;)o.push(c);return t(o)}function I(n,t,o){const c=[];let m;for(;(m=n.read())!==null&&c.length<o;)c.push(m);return m===null&&c.length>0?t(c):{read:()=>{if(c.length>0)return c.shift();if(typeof m<"u"){const g=m;return m=void 0,g}return n.read()}}}function b(n,t){return new Promise((o,c)=>{const m=[];h(n,{onData:g=>{t&&m.push(g)},onError:g=>{t?c(g):o(void 0)},onEnd:()=>{o(t?t(m):void 0)}})})}function h(n,t,o){n.on("error",c=>{o?.isCancellationRequested||t.onError(c)}),n.on("end",()=>{o?.isCancellationRequested||t.onEnd()}),n.on("data",c=>{o?.isCancellationRequested||t.onData(c)})}function E(n,t){return new Promise((o,c)=>{const m=new D.$Wc,g=[],u=y=>{if(g.push(y),g.length>t)return m.dispose(),n.pause(),o({stream:n,buffer:g,ended:!1})},S=y=>(m.dispose(),c(y)),k=()=>(m.dispose(),o({stream:n,buffer:g,ended:!0}));m.add((0,D.$Vc)(()=>n.removeListener("error",S))),n.on("error",S),m.add((0,D.$Vc)(()=>n.removeListener("end",k))),n.on("end",k),m.add((0,D.$Vc)(()=>n.removeListener("data",u))),n.on("data",u)})}function f(n,t){const o=O(t);return o.end(n),o}function r(){const n=O(()=>{throw new Error("not supported")});return n.end(),n}function l(n){let t=!1;return{read:()=>t?null:(t=!0,n)}}function d(n,t,o){const c=O(o);return h(n,{onData:m=>c.write(t.data(m)),onError:m=>c.error(t.error?t.error(m):m),onEnd:()=>c.end()}),c}function a(n,t,o){let c=!1;return{read:()=>{const m=t.read();return c?m:(c=!0,m!==null?o([n,m]):n)}}}function i(n,t,o){let c=!1;const m=O(o);return h(t,{onData:g=>c?m.write(g):(c=!0,m.write(o([n,g]))),onError:g=>m.error(g),onEnd:()=>{c||(c=!0,m.write(n)),m.end()}}),m}}),define(Re[20],Te([1,0,51,148]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qe=void 0,e.$Re=s,e.$Se=I,e.$Te=b,e.$Ue=h,e.$Ve=E,e.$We=f,e.$Xe=r,e.$Ye=l,e.$Ze=d,e.$1e=a,e.$2e=i,e.$3e=n,e.$4e=t,e.$5e=o,e.$6e=c,e.$7e=m,e.$8e=g,e.$9e=u,e.$0e=S,e.$$e=C,D=qe(D);const P=typeof Buffer<"u",N=new v.$W(()=>new Uint8Array(256));let R,O;class p{static alloc($){return P?new p(Buffer.allocUnsafe($)):new p(new Uint8Array($))}static wrap($){return P&&!Buffer.isBuffer($)&&($=Buffer.from($.buffer,$.byteOffset,$.byteLength)),new p($)}static fromString($,w){return!(w?.dontUseNodeBuffer||!1)&&P?new p(Buffer.from($)):(R||(R=new TextEncoder),new p(R.encode($)))}static fromByteArray($){const w=p.alloc($.length);for(let M=0,A=$.length;M<A;M++)w.buffer[M]=$[M];return w}static concat($,w){if(typeof w>"u"){w=0;for(let L=0,J=$.length;L<J;L++)w+=$[L].byteLength}const M=p.alloc(w);let A=0;for(let L=0,J=$.length;L<J;L++){const Y=$[L];M.set(Y,A),A+=Y.byteLength}return M}constructor($){this.buffer=$,this.byteLength=this.buffer.byteLength}clone(){const $=p.alloc(this.byteLength);return $.set(this),$}toString(){return P?this.buffer.toString():(O||(O=new TextDecoder),O.decode(this.buffer))}slice($,w){return new p(this.buffer.subarray($,w))}set($,w){if($ instanceof p)this.buffer.set($.buffer,w);else if($ instanceof Uint8Array)this.buffer.set($,w);else if($ instanceof ArrayBuffer)this.buffer.set(new Uint8Array($),w);else if(ArrayBuffer.isView($))this.buffer.set(new Uint8Array($.buffer,$.byteOffset,$.byteLength),w);else throw new Error("Unknown argument 'array'")}readUInt32BE($){return h(this.buffer,$)}writeUInt32BE($,w){E(this.buffer,$,w)}readUInt32LE($){return f(this.buffer,$)}writeUInt32LE($,w){r(this.buffer,$,w)}readUInt8($){return l(this.buffer,$)}writeUInt8($,w){d(this.buffer,$,w)}indexOf($,w=0){return s(this.buffer,$ instanceof p?$.buffer:$,w)}}e.$Qe=p;function s(T,$,w=0){const M=$.byteLength,A=T.byteLength;if(M===0)return 0;if(M===1)return T.indexOf($[0]);if(M>A-w)return-1;const L=N.value;L.fill($.length);for(let Q=0;Q<$.length;Q++)L[$[Q]]=$.length-Q-1;let J=w+$.length-1,Y=J,z=-1;for(;J<A;)if(T[J]===$[Y]){if(Y===0){z=J;break}J--,Y--}else J+=Math.max($.length-Y,L[T[J]]),Y=$.length-1;return z}function I(T,$){return T[$+0]<<0>>>0|T[$+1]<<8>>>0}function b(T,$,w){T[w+0]=$&255,$=$>>>8,T[w+1]=$&255}function h(T,$){return T[$]*2**24+T[$+1]*2**16+T[$+2]*2**8+T[$+3]}function E(T,$,w){T[w+3]=$,$=$>>>8,T[w+2]=$,$=$>>>8,T[w+1]=$,$=$>>>8,T[w]=$}function f(T,$){return T[$+0]<<0>>>0|T[$+1]<<8>>>0|T[$+2]<<16>>>0|T[$+3]<<24>>>0}function r(T,$,w){T[w+0]=$&255,$=$>>>8,T[w+1]=$&255,$=$>>>8,T[w+2]=$&255,$=$>>>8,T[w+3]=$&255}function l(T,$){return T[$]}function d(T,$,w){T[w]=$}function a(T){return D.$Fe(T,$=>p.concat($))}function i(T){return D.$Me(T)}function n(T){return D.$He(T,$=>p.concat($))}async function t(T){return T.ended?p.concat(T.buffer):p.concat([...T.buffer,await n(T.stream)])}function o(T){return D.$Ke(T,$=>p.concat($))}function c(T){return D.$Ne(T,{data:$=>typeof $=="string"?p.fromString($):p.wrap($)},$=>p.concat($))}function m(T){return D.$Ee($=>p.concat($),T)}function g(T,$){return D.$Oe(T,$,w=>p.concat(w))}function u(T,$){return D.$Pe(T,$,w=>p.concat(w))}function S(T){let $=0,w=0,M=0;const A=new Uint8Array(Math.floor(T.length/4*3)),L=Y=>{switch(w){case 3:A[M++]=$|Y,w=0;break;case 2:A[M++]=$|Y>>>2,$=Y<<6,w=3;break;case 1:A[M++]=$|Y>>>4,$=Y<<4,w=2;break;default:$=Y<<2,w=1}};for(let Y=0;Y<T.length;Y++){const z=T.charCodeAt(Y);if(z>=65&&z<=90)L(z-65);else if(z>=97&&z<=122)L(z-97+26);else if(z>=48&&z<=57)L(z-48+52);else if(z===43||z===45)L(62);else if(z===47||z===95)L(63);else{if(z===61)break;throw new SyntaxError(`Unexpected base64 character ${T[Y]}`)}}const J=M;for(;w>0;)L(0);return p.wrap(A).slice(0,J)}const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function C({buffer:T},$=!0,w=!1){const M=w?y:k;let A="";const L=T.byteLength%3;let J=0;for(;J<T.byteLength-L;J+=3){const Y=T[J+0],z=T[J+1],Q=T[J+2];A+=M[Y>>>2],A+=M[(Y<<4|z>>>4)&63],A+=M[(z<<2|Q>>>6)&63],A+=M[Q&63]}if(L===1){const Y=T[J+0];A+=M[Y>>>2],A+=M[Y<<4&63],$&&(A+="==")}else if(L===2){const Y=T[J+0],z=T[J+1];A+=M[Y>>>2],A+=M[(Y<<4|z>>>4)&63],A+=M[z<<2&63],$&&(A+="=")}return A}}),define(Re[35],Te([1,0,98]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$9j=P;var D;(function(R){function O(p){return p&&typeof p=="object"&&typeof p.id=="string"}R.isThemeColor=O})(D||(e.ThemeColor=D={}));function P(R){return{id:R}}var N;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const O=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function p(a){const i=O.exec(a.id);if(!i)return p(v.$8j.error);const[,n,t]=i,o=["codicon","codicon-"+n];return t&&o.push("codicon-modifier-"+t.substring(1)),o}R.asClassNameArray=p;function s(a){return p(a).join(" ")}R.asClassName=s;function I(a){return"."+p(a).join(".")}R.asCSSSelector=I;function b(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color>"u"||D.isThemeColor(a.color))}R.isThemeIcon=b;const h=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function E(a){const i=h.exec(a);if(!i)return;const[,n]=i;return{id:n}}R.fromString=E;function f(a){return{id:a}}R.fromId=f;function r(a,i){let n=a.id;const t=n.lastIndexOf("~");return t!==-1&&(n=n.substring(0,t)),i&&(n=`${n}~${i}`),{id:n}}R.modify=r;function l(a){const i=a.id.lastIndexOf("~");if(i!==-1)return a.id.substring(i+1)}R.getModifier=l;function d(a,i){return a.id===i.id&&a.color?.id===i.color?.id}R.isEqual=d})(N||(e.ThemeIcon=N={}))}),define(Re[149],Te([1,0,30,27,140,13]),function(we,e,v,D,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wk=e.FuzzyScore=e.$Lk=e.$Kk=void 0,e.or=R,e.$Mk=p,e.$Nk=s,e.$Ok=h,e.$Pk=k,e.$Qk=y,e.$Rk=A,e.$Sk=L,e.$Tk=J,e.$Uk=Y,e.$Vk=ne,e.$Xk=Be,e.$Yk=ut,e.$Zk=pt,N=qe(N);function R(...Ne){return function(Me,Le){for(let B=0,j=Ne.length;B<j;B++){const H=Ne[B](Me,Le);if(H)return H}return null}}e.$Kk=O.bind(void 0,!1),e.$Lk=O.bind(void 0,!0);function O(Ne,Me,Le){if(!Le||Le.length<Me.length)return null;let B;return Ne?B=N.$Jf(Le,Me):B=Le.indexOf(Me)===0,B?Me.length>0?[{start:0,end:Me.length}]:[]:null}function p(Ne,Me){const Le=Me.toLowerCase().indexOf(Ne.toLowerCase());return Le===-1?null:[{start:Le,end:Le+Ne.length}]}function s(Ne,Me){return I(Ne.toLowerCase(),Me.toLowerCase(),0,0)}function I(Ne,Me,Le,B){if(Le===Ne.length)return[];if(B===Me.length)return null;if(Ne[Le]===Me[B]){let j=null;return(j=I(Ne,Me,Le+1,B+1))?t({start:B,end:B+1},j):null}return I(Ne,Me,Le,B+1)}function b(Ne){return v.CharCode.a<=Ne&&Ne<=v.CharCode.z}function h(Ne){return v.CharCode.A<=Ne&&Ne<=v.CharCode.Z}function E(Ne){return v.CharCode.Digit0<=Ne&&Ne<=v.CharCode.Digit9}function f(Ne){return Ne===v.CharCode.Space||Ne===v.CharCode.Tab||Ne===v.CharCode.LineFeed||Ne===v.CharCode.CarriageReturn}const r=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Ne=>r.add(Ne.charCodeAt(0)));function l(Ne){return f(Ne)||r.has(Ne)}function d(Ne,Me){return Ne===Me||l(Ne)&&l(Me)}const a=new Map;function i(Ne){if(a.has(Ne))return a.get(Ne);let Me;const Le=(0,P.$Ik)(Ne);return Le&&(Me=Le),a.set(Ne,Me),Me}function n(Ne){return b(Ne)||h(Ne)||E(Ne)}function t(Ne,Me){return Me.length===0?Me=[Ne]:Ne.end===Me[0].start?Me[0].start=Ne.start:Me.unshift(Ne),Me}function o(Ne,Me){for(let Le=Me;Le<Ne.length;Le++){const B=Ne.charCodeAt(Le);if(h(B)||E(B)||Le>0&&!n(Ne.charCodeAt(Le-1)))return Le}return Ne.length}function c(Ne,Me,Le,B){if(Le===Ne.length)return[];if(B===Me.length)return null;if(Ne[Le]!==Me[B].toLowerCase())return null;{let j=null,H=B+1;for(j=c(Ne,Me,Le+1,B+1);!j&&(H=o(Me,H))<Me.length;)j=c(Ne,Me,Le+1,H),H++;return j===null?null:t({start:B,end:B+1},j)}}function m(Ne){let Me=0,Le=0,B=0,j=0,H=0;for(let Ue=0;Ue<Ne.length;Ue++)H=Ne.charCodeAt(Ue),h(H)&&Me++,b(H)&&Le++,n(H)&&B++,E(H)&&j++;const G=Me/Ne.length,se=Le/Ne.length,ge=B/Ne.length,Ee=j/Ne.length;return{upperPercent:G,lowerPercent:se,alphaPercent:ge,numericPercent:Ee}}function g(Ne){const{upperPercent:Me,lowerPercent:Le}=Ne;return Le===0&&Me>.6}function u(Ne){const{upperPercent:Me,lowerPercent:Le,alphaPercent:B,numericPercent:j}=Ne;return Le>.2&&Me<.8&&B>.6&&j<.2}function S(Ne){let Me=0,Le=0,B=0,j=0;for(let H=0;H<Ne.length;H++)B=Ne.charCodeAt(H),h(B)&&Me++,b(B)&&Le++,f(B)&&j++;return(Me===0||Le===0)&&j===0?Ne.length<=30:Me<=5}function k(Ne,Me){if(!Me||(Me=Me.trim(),Me.length===0)||!S(Ne))return null;Me.length>60&&(Me=Me.substring(0,60));const Le=m(Me);if(!u(Le)){if(!g(Le))return null;Me=Me.toLowerCase()}let B=null,j=0;for(Ne=Ne.toLowerCase();j<Me.length&&(B=c(Ne,Me,0,j))===null;)j=o(Me,j+1);return B}function y(Ne,Me,Le=!1){if(!Me||Me.length===0)return null;let B=null,j=0;for(Ne=Ne.toLowerCase(),Me=Me.toLowerCase();j<Me.length&&(B=C(Ne,Me,0,j,Le),B===null);)j=T(Me,j+1);return B}function C(Ne,Me,Le,B,j){let H=0;if(Le===Ne.length)return[];if(B===Me.length)return null;if(!d(Ne.charCodeAt(Le),Me.charCodeAt(B))){const ge=i(Ne.charCodeAt(Le));if(!ge)return null;for(let Ee=0;Ee<ge.length;Ee++)if(!d(ge[Ee],Me.charCodeAt(B+Ee)))return null;H+=ge.length-1}let G=null,se=B+H+1;if(G=C(Ne,Me,Le+1,se,j),!j)for(;!G&&(se=T(Me,se))<Me.length;)G=C(Ne,Me,Le+1,se,j),se++;if(!G)return null;if(Ne.charCodeAt(Le)!==Me.charCodeAt(B)){const ge=i(Ne.charCodeAt(Le));if(!ge)return G;for(let Ee=0;Ee<ge.length;Ee++)if(ge[Ee]!==Me.charCodeAt(B+Ee))return G}return t({start:B,end:B+H+1},G)}function T(Ne,Me){for(let Le=Me;Le<Ne.length;Le++)if(l(Ne.charCodeAt(Le))||Le>0&&l(Ne.charCodeAt(Le-1)))return Le;return Ne.length}const $=R(e.$Lk,k,p),w=R(e.$Lk,k,s),M=new D.$Gc(1e4);function A(Ne,Me,Le=!1){if(typeof Ne!="string"||typeof Me!="string")return null;let B=M.get(Ne);B||(B=new RegExp(N.$rf(Ne),"i"),M.set(Ne,B));const j=B.exec(Me);return j?[{start:j.index,end:j.index+j[0].length}]:Le?w(Ne,Me):$(Ne,Me)}function L(Ne,Me){const Le=Be(Ne,Ne.toLowerCase(),0,Me,Me.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Le?Y(Le):null}function J(Ne,Me,Le,B,j,H){const G=Math.min(13,Ne.length);for(;Le<G;Le++){const se=Be(Ne,Me,Le,B,j,H,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(se)return se}return[0,H]}function Y(Ne){if(typeof Ne>"u")return[];const Me=[],Le=Ne[1];for(let B=Ne.length-1;B>1;B--){const j=Ne[B]+Le,H=Me[Me.length-1];H&&H.end===j?H.end=j+1:Me.push({start:j,end:j+1})}return Me}const z=128;function Q(){const Ne=[],Me=[];for(let Le=0;Le<=z;Le++)Me[Le]=0;for(let Le=0;Le<=z;Le++)Ne.push(Me.slice(0));return Ne}function V(Ne){const Me=[];for(let Le=0;Le<=Ne;Le++)Me[Le]=0;return Me}const ie=V(2*z),le=V(2*z),_=Q(),oe=Q(),re=Q(),ce=!1;function x(Ne,Me,Le,B,j){function H(se,ge,Ee=" "){for(;se.length<ge;)se=Ee+se;return se}let G=` |   |${B.split("").map(se=>H(se,3)).join("|")}
`;for(let se=0;se<=Le;se++)se===0?G+=" |":G+=`${Me[se-1]}|`,G+=Ne[se].slice(0,j+1).map(ge=>H(ge.toString(),3)).join("|")+`
`;return G}function $e(Ne,Me,Le,B){Ne=Ne.substr(Me),Le=Le.substr(B),console.log(x(oe,Ne,Ne.length,Le,Le.length)),console.log(x(re,Ne,Ne.length,Le,Le.length)),console.log(x(_,Ne,Ne.length,Le,Le.length))}function Pe(Ne,Me){if(Me<0||Me>=Ne.length)return!1;const Le=Ne.codePointAt(Me);switch(Le){case v.CharCode.Underline:case v.CharCode.Dash:case v.CharCode.Period:case v.CharCode.Space:case v.CharCode.Slash:case v.CharCode.Backslash:case v.CharCode.SingleQuote:case v.CharCode.DoubleQuote:case v.CharCode.Colon:case v.CharCode.DollarSign:case v.CharCode.LessThan:case v.CharCode.GreaterThan:case v.CharCode.OpenParen:case v.CharCode.CloseParen:case v.CharCode.OpenSquareBracket:case v.CharCode.CloseSquareBracket:case v.CharCode.OpenCurlyBrace:case v.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!N.$2f(Le)}}function X(Ne,Me){if(Me<0||Me>=Ne.length)return!1;switch(Ne.charCodeAt(Me)){case v.CharCode.Space:case v.CharCode.Tab:return!0;default:return!1}}function q(Ne,Me,Le){return Me[Ne]!==Le[Ne]}function ne(Ne,Me,Le,B,j,H,G=!1){for(;Me<Le&&j<H;)Ne[Me]===B[j]&&(G&&(ie[Me]=j),Me+=1),j+=1;return Me===Le}var be;(function(Ne){Ne[Ne.Diag=1]="Diag",Ne[Ne.Left=2]="Left",Ne[Ne.LeftLeft=3]="LeftLeft"})(be||(be={}));var Ie;(function(Ne){Ne.Default=[-100,0];function Me(Le){return!Le||Le.length===2&&Le[0]===-100&&Le[1]===0}Ne.isDefault=Me})(Ie||(e.FuzzyScore=Ie={}));class Fe{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Me,Le){this.firstMatchCanBeWeak=Me,this.boostFullMatch=Le}}e.$Wk=Fe;function Be(Ne,Me,Le,B,j,H,G=Fe.default){const se=Ne.length>z?z:Ne.length,ge=B.length>z?z:B.length;if(Le>=se||H>=ge||se-Le>ge-H||!ne(Me,Le,se,j,H,ge,!0))return;xe(se,ge,Le,H,Me,j);let Ee=1,Ue=1,Je=Le,_e=H;const tt=[!1];for(Ee=1,Je=Le;Je<se;Ee++,Je++){const Ye=ie[Je],he=le[Je],pe=Je+1<se?le[Je+1]:ge;for(Ue=Ye-H+1,_e=Ye;_e<pe;Ue++,_e++){let ye=Number.MIN_SAFE_INTEGER,Ce=!1;_e<=he&&(ye=nt(Ne,Me,Je,Le,B,j,_e,ge,H,_[Ee-1][Ue-1]===0,tt));let fe=0;ye!==Number.MAX_SAFE_INTEGER&&(Ce=!0,fe=ye+oe[Ee-1][Ue-1]);const ve=_e>Ye,Z=ve?oe[Ee][Ue-1]+(_[Ee][Ue-1]>0?-5:0):0,W=_e>Ye+1&&_[Ee][Ue-1]>0,de=W?oe[Ee][Ue-2]+(_[Ee][Ue-2]>0?-5:0):0;if(W&&(!ve||de>=Z)&&(!Ce||de>=fe))oe[Ee][Ue]=de,re[Ee][Ue]=be.LeftLeft,_[Ee][Ue]=0;else if(ve&&(!Ce||Z>=fe))oe[Ee][Ue]=Z,re[Ee][Ue]=be.Left,_[Ee][Ue]=0;else if(Ce)oe[Ee][Ue]=fe,re[Ee][Ue]=be.Diag,_[Ee][Ue]=_[Ee-1][Ue-1]+1;else throw new Error("not possible")}}if(ce&&$e(Ne,Le,B,H),!tt[0]&&!G.firstMatchCanBeWeak)return;Ee--,Ue--;const at=[oe[Ee][Ue],H];let it=0,ot=0;for(;Ee>=1;){let Ye=Ue;do{const he=re[Ee][Ye];if(he===be.LeftLeft)Ye=Ye-2;else if(he===be.Left)Ye=Ye-1;else break}while(Ye>=1);it>1&&Me[Le+Ee-1]===j[H+Ue-1]&&!q(Ye+H-1,B,j)&&it+1>_[Ee][Ye]&&(Ye=Ue),Ye===Ue?it++:it=1,ot||(ot=Ye),Ee--,Ue=Ye-1,at.push(Ue)}ge-H===se&&G.boostFullMatch&&(at[0]+=2);const vt=ot-se;return at[0]-=vt,at}function xe(Ne,Me,Le,B,j,H){let G=Ne-1,se=Me-1;for(;G>=Le&&se>=B;)j[G]===H[se]&&(le[G]=se,G--),se--}function nt(Ne,Me,Le,B,j,H,G,se,ge,Ee,Ue){if(Me[Le]!==H[G])return Number.MIN_SAFE_INTEGER;let Je=1,_e=!1;return G===Le-B?Je=Ne[Le]===j[G]?7:5:q(G,j,H)&&(G===0||!q(G-1,j,H))?(Je=Ne[Le]===j[G]?7:5,_e=!0):Pe(H,G)&&(G===0||!Pe(H,G-1))?Je=5:(Pe(H,G-1)||X(H,G-1))&&(Je=5,_e=!0),Je>1&&Le===B&&(Ue[0]=!0),_e||(_e=q(G,j,H)||Pe(H,G-1)||X(H,G-1)),Le===B?G>ge&&(Je-=_e?3:5):Ee?Je+=_e?2:0:Je+=_e?0:1,G+1===se&&(Je-=_e?3:5),Je}function ut(Ne,Me,Le,B,j,H,G){return lt(Ne,Me,Le,B,j,H,!0,G)}function pt(Ne,Me,Le,B,j,H,G){return lt(Ne,Me,Le,B,j,H,!1,G)}function lt(Ne,Me,Le,B,j,H,G,se){let ge=Be(Ne,Me,Le,B,j,H,se);if(ge&&!G)return ge;if(Ne.length>=3){const Ee=Math.min(7,Ne.length-1);for(let Ue=Le+1;Ue<Ee;Ue++){const Je=et(Ne,Ue);if(Je){const _e=Be(Je,Je.toLowerCase(),Le,B,j,H,se);_e&&(_e[0]-=3,(!ge||_e[0]>ge[0])&&(ge=_e))}}}return ge}function et(Ne,Me){if(Me+1>=Ne.length)return;const Le=Ne[Me],B=Ne[Me+1];if(Le!==B)return Ne.slice(0,Me)+B+Le+Ne.slice(Me+2)}}),define(Re[99],Te([1,0,149,13,35]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1k=p,e.$2k=I,e.$3k=h,e.$4k=E,e.$5k=r,e.$6k=l;const N="$(",R=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),O=new RegExp(`(\\\\)?${R.source}`,"g");function p(d){return d.replace(O,(a,i)=>i?a:`\\${a}`)}const s=new RegExp(`\\\\${R.source}`,"g");function I(d){return d.replace(s,a=>`\\${a}`)}const b=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function h(d){return d.indexOf(N)===-1?d:d.replace(b,(a,i,n,t)=>n?a:i||t||"")}function E(d){return d?d.replace(/\$\((.*?)\)/g,(a,i)=>` ${i} `).trim():""}const f=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(d){f.lastIndex=0;let a="";const i=[];let n=0;for(;;){const t=f.lastIndex,o=f.exec(d),c=d.substring(t,o?.index);if(c.length>0){a+=c;for(let m=0;m<c.length;m++)i.push(n)}if(!o)break;n+=o[0].length}return{text:a,iconOffsets:i}}function l(d,a,i=!1){const{text:n,iconOffsets:t}=a;if(!t||t.length===0)return(0,v.$Rk)(d,n,i);const o=(0,D.$pf)(n," "),c=n.length-o.length,m=(0,v.$Rk)(d,o,i);if(m)for(const g of m){const u=t[g.start+c]+c;g.start+=u,g.end+=u}return m}}),define(Re[36],Te([1,0,13]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),v=qe(v);var D;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(D||(D={})),function(P){const N="error",R="warning",O="warn",p="info",s="ignore";function I(h){return h?v.$If(N,h)?P.Error:v.$If(R,h)||v.$If(O,h)?P.Warning:v.$If(p,h)?P.Info:P.Ignore:P.Ignore}P.fromValue=I;function b(h){switch(h){case P.Error:return N;case P.Warning:return R;case P.Info:return p;default:return s}}P.toString=b}(D||(D={})),e.default=D}),define(Re[48],Te([1,0,17,30,13]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=void 0;class N{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const r=f.charCodeAt(0),l=this.b.charCodeAt(this.c);return r-l}value(){return this.b[this.c]}}e.$Ki=N;class R{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===D.CharCode.Period)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,P.$Cf)(f,this.b,0,f.length,this.c,this.d):(0,P.$Ef)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Li=R;class O{constructor(f=!0,r=!0){this.f=f,this.g=r}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let r=f.length-1;r>=0;r--,this.c--){const l=this.b.charCodeAt(r);if(!(l===D.CharCode.Slash||this.f&&l===D.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const r=this.b.charCodeAt(this.e);if(r===D.CharCode.Slash||this.f&&r===D.CharCode.Backslash)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,P.$Cf)(f,this.b,0,f.length,this.d,this.e):(0,P.$Ef)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Mi=O;var p;(function(E){E[E.Scheme=1]="Scheme",E[E.Authority=2]="Authority",E[E.Path=3]="Path",E[E.Query=4]="Query",E[E.Fragment=5]="Fragment"})(p||(p={}));class s{constructor(f,r){this.f=f,this.g=r,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(p.Scheme),this.c.authority&&this.d.push(p.Authority),this.c.path&&(this.b=new O(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(p.Path)),this.g(f)||(this.c.query&&this.d.push(p.Query),this.c.fragment&&this.d.push(p.Fragment)),this.e=0,this}next(){return this.d[this.e]===p.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===p.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===p.Scheme)return(0,P.$Df)(f,this.c.scheme);if(this.d[this.e]===p.Authority)return(0,P.$Df)(f,this.c.authority);if(this.d[this.e]===p.Path)return this.b.cmp(f);if(this.d[this.e]===p.Query)return(0,P.$Bf)(f,this.c.query);if(this.d[this.e]===p.Fragment)return(0,P.$Bf)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===p.Scheme)return this.c.scheme;if(this.d[this.e]===p.Authority)return this.c.authority;if(this.d[this.e]===p.Path)return this.b.value();if(this.d[this.e]===p.Query)return this.c.query;if(this.d[this.e]===p.Fragment)return this.c.fragment;throw new Error}}e.$Ni=s;class I{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(E){E[E.Left=-1]="Left",E[E.Mid=0]="Mid",E[E.Right=1]="Right"})(b||(b={}));class h{static forUris(f=()=>!1,r=()=>!1){return new h(new s(f,r))}static forPaths(f=!1){return new h(new O(void 0,!f))}static forStrings(){return new h(new N)}static forConfigKeys(){return new h(new R)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,r){if(r){const l=r.slice(0);(0,v.$Yb)(l);for(const d of l)this.set(d,f)}else{const l=f.slice(0);(0,v.$Yb)(l);for(const d of l)this.set(d[0],d[1])}}set(f,r){const l=this.b.reset(f);let d;this.c||(this.c=new I,this.c.segment=l.value());const a=[];for(d=this.c;;){const n=l.cmp(d.segment);if(n>0)d.left||(d.left=new I,d.left.segment=l.value()),a.push([b.Left,d]),d=d.left;else if(n<0)d.right||(d.right=new I,d.right.segment=l.value()),a.push([b.Right,d]),d=d.right;else if(l.hasNext())l.next(),d.mid||(d.mid=new I,d.mid.segment=l.value()),a.push([b.Mid,d]),d=d.mid;else break}const i=d.value;d.value=r,d.key=f;for(let n=a.length-1;n>=0;n--){const t=a[n][1];t.updateHeight();const o=t.balanceFactor();if(o<-1||o>1){const c=a[n][0],m=a[n+1][0];if(c===b.Right&&m===b.Right)a[n][1]=t.rotateLeft();else if(c===b.Left&&m===b.Left)a[n][1]=t.rotateRight();else if(c===b.Right&&m===b.Left)t.right=a[n+1][1]=a[n+1][1].rotateRight(),a[n][1]=t.rotateLeft();else if(c===b.Left&&m===b.Right)t.left=a[n+1][1]=a[n+1][1].rotateLeft(),a[n][1]=t.rotateRight();else throw new Error;if(n>0)switch(a[n-1][0]){case b.Left:a[n-1][1].left=a[n][1];break;case b.Right:a[n-1][1].right=a[n][1];break;case b.Mid:a[n-1][1].mid=a[n][1];break}else this.c=a[0][1]}}return i}get(f){return this.d(f)?.value}d(f){const r=this.b.reset(f);let l=this.c;for(;l;){const d=r.cmp(l.segment);if(d>0)l=l.left;else if(d<0)l=l.right;else if(r.hasNext())r.next(),l=l.mid;else break}return l}has(f){const r=this.d(f);return!(r?.value===void 0&&r?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,r){const l=this.b.reset(f),d=[];let a=this.c;for(;a;){const i=l.cmp(a.segment);if(i>0)d.push([b.Left,a]),a=a.left;else if(i<0)d.push([b.Right,a]),a=a.right;else if(l.hasNext())l.next(),d.push([b.Mid,a]),a=a.mid;else break}if(a){if(r?(a.left=void 0,a.mid=void 0,a.right=void 0,a.height=1):(a.key=void 0,a.value=void 0),!a.mid&&!a.value)if(a.left&&a.right){const i=this.f(a.right);if(i.key){const{key:n,value:t,segment:o}=i;this.e(i.key,!1),a.key=n,a.value=t,a.segment=o}}else{const i=a.left??a.right;if(d.length>0){const[n,t]=d[d.length-1];switch(n){case b.Left:t.left=i;break;case b.Mid:t.mid=i;break;case b.Right:t.right=i;break}}else this.c=i}for(let i=d.length-1;i>=0;i--){const n=d[i][1];n.updateHeight();const t=n.balanceFactor();if(t>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),d[i][1]=n.rotateLeft()):t<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),d[i][1]=n.rotateRight()),i>0)switch(d[i-1][0]){case b.Left:d[i-1][1].left=d[i][1];break;case b.Right:d[i-1][1].right=d[i][1];break;case b.Mid:d[i-1][1].mid=d[i][1];break}else this.c=d[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const r=this.b.reset(f);let l=this.c,d;for(;l;){const a=r.cmp(l.segment);if(a>0)l=l.left;else if(a<0)l=l.right;else if(r.hasNext())r.next(),d=l.value||d,l=l.mid;else break}return l&&l.value||d}findSuperstr(f){return this.g(f,!1)}g(f,r){const l=this.b.reset(f);let d=this.c;for(;d;){const a=l.cmp(d.segment);if(a>0)d=d.left;else if(a<0)d=d.right;else if(l.hasNext())l.next(),d=d.mid;else return d.mid?this.h(d.mid):r?d.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[r,l]of this)f(l,r)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const r=[];return this.j(f,r),r[Symbol.iterator]()}j(f,r){f&&(f.left&&this.j(f.left,r),f.value&&r.push([f.key,f.value]),f.mid&&this.j(f.mid,r),f.right&&this.j(f.right,r))}_isBalanced(){const f=r=>{if(!r)return!0;const l=r.balanceFactor();return l<-1||l>1?!1:f(r.left)&&f(r.right)};return f(this.c)}}e.$Oi=h}),define(Re[33],Te([1,0,20,2,37]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=N,e.$ei=R,e.$fi=p;function N(s){return JSON.stringify(s,O)}function R(s){let I=JSON.parse(s);return I=p(I),I}function O(s,I){return I instanceof RegExp?{$mid:P.MarshalledId.Regexp,source:I.source,flags:I.flags}:I}function p(s,I=0){if(!s||I>200)return s;if(typeof s=="object"){switch(s.$mid){case P.MarshalledId.Uri:return D.URI.revive(s);case P.MarshalledId.Regexp:return new RegExp(s.source,s.flags);case P.MarshalledId.Date:return new Date(s.source)}if(s instanceof v.$Qe||s instanceof Uint8Array)return s;if(Array.isArray(s))for(let b=0;b<s.length;++b)s[b]=p(s[b],I+1);else for(const b in s)Object.hasOwnProperty.call(s,b)&&(s[b]=p(s[b],I+1))}return s}}),define(Re[41],Te([1,0,17,10,30,73,27,22,23,13]),function(we,e,v,D,P,N,R,O,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=e.$zk=void 0,e.$yk=I,e.$Bk=r,e.$Ck=M,e.$Dk=A,e.$Ek=L,e.$Fk=J,e.$Gk=Y,e.$Hk=ie;function I(){return Object.create(null)}e.$zk="**",e.$Ak="/";const b="[/\\\\]",h="[^/\\\\]",E=/\//g;function f(le,_){switch(le){case 0:return"";case 1:return`${h}*?`;default:return`(?:${b}|${h}+${b}${_?`|${b}${h}+`:""})*?`}}function r(le,_){if(!le)return[];const oe=[];let re=!1,ce=!1,x="";for(const $e of le){switch($e){case _:if(!re&&!ce){oe.push(x),x="";continue}break;case"{":re=!0;break;case"}":re=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}x+=$e}return x&&oe.push(x),oe}function l(le){if(!le)return"";let _="";const oe=r(le,e.$Ak);if(oe.every(re=>re===e.$zk))_=".*";else{let re=!1;oe.forEach((ce,x)=>{if(ce===e.$zk){if(re)return;_+=f(2,x===oe.length-1)}else{let $e=!1,Pe="",X=!1,q="";for(const ne of ce){if(ne!=="}"&&$e){Pe+=ne;continue}if(X&&(ne!=="]"||!q)){let be;ne==="-"?be=ne:(ne==="^"||ne==="!")&&!q?be="^":ne===e.$Ak?be="":be=(0,s.$kf)(ne),q+=be;continue}switch(ne){case"{":$e=!0;continue;case"[":X=!0;continue;case"}":{const Ie=`(?:${r(Pe,",").map(Fe=>l(Fe)).join("|")})`;_+=Ie,$e=!1,Pe="";break}case"]":{_+="["+q+"]",X=!1,q="";break}case"?":_+=h;continue;case"*":_+=f(1);continue;default:_+=(0,s.$kf)(ne)}}x<oe.length-1&&(oe[x+1]!==e.$zk||x+2<oe.length)&&(_+=b)}re=ce===e.$zk})}return _}const d=/^\*\*\/\*\.[\w\.-]+$/,a=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,c=new R.$Gc(1e4),m=function(){return!1},g=function(){return null};function u(le,_){if(!le)return g;let oe;typeof le!="string"?oe=le.pattern:oe=le,oe=oe.trim();const re=`${oe}_${!!_.trimForExclusions}`;let ce=c.get(re);if(ce)return S(ce,le);let x;return d.test(oe)?ce=y(oe.substr(4),oe):(x=a.exec(k(oe,_)))?ce=C(x[1],oe):(_.trimForExclusions?n:i).test(oe)?ce=T(oe,_):(x=t.exec(k(oe,_)))?ce=$(x[1].substr(1),oe,!0):(x=o.exec(k(oe,_)))?ce=$(x[1],oe,!1):ce=w(oe),c.set(re,ce),S(ce,le)}function S(le,_){if(typeof _=="string")return le;const oe=function(re,ce){return(0,N.$Hg)(re,_.base,!p.$l)?le((0,s.$pf)(re.substr(_.base.length),O.sep),ce):null};return oe.allBasenames=le.allBasenames,oe.allPaths=le.allPaths,oe.basenames=le.basenames,oe.patterns=le.patterns,oe}function k(le,_){return _.trimForExclusions&&le.endsWith("/**")?le.substr(0,le.length-2):le}function y(le,_){return function(oe,re){return typeof oe=="string"&&oe.endsWith(le)?_:null}}function C(le,_){const oe=`/${le}`,re=`\\${le}`,ce=function($e,Pe){return typeof $e!="string"?null:Pe?Pe===le?_:null:$e===le||$e.endsWith(oe)||$e.endsWith(re)?_:null},x=[le];return ce.basenames=x,ce.patterns=[_],ce.allBasenames=x,ce}function T(le,_){const oe=V(le.slice(1,-1).split(",").map(Pe=>u(Pe,_)).filter(Pe=>Pe!==g),le),re=oe.length;if(!re)return g;if(re===1)return oe[0];const ce=function(Pe,X){for(let q=0,ne=oe.length;q<ne;q++)if(oe[q](Pe,X))return le;return null},x=oe.find(Pe=>!!Pe.allBasenames);x&&(ce.allBasenames=x.allBasenames);const $e=oe.reduce((Pe,X)=>X.allPaths?Pe.concat(X.allPaths):Pe,[]);return $e.length&&(ce.allPaths=$e),ce}function $(le,_,oe){const re=O.sep===O.$jc.sep,ce=re?le:le.replace(E,O.sep),x=O.sep+ce,$e=O.$jc.sep+le;let Pe;return oe?Pe=function(X,q){return typeof X=="string"&&(X===ce||X.endsWith(x)||!re&&(X===le||X.endsWith($e)))?_:null}:Pe=function(X,q){return typeof X=="string"&&(X===ce||!re&&X===le)?_:null},Pe.allPaths=[(oe?"*/":"./")+le],Pe}function w(le){try{const _=new RegExp(`^${l(le)}$`);return function(oe){return _.lastIndex=0,typeof oe=="string"&&_.test(oe)?le:null}}catch{return g}}function M(le,_,oe){return!le||typeof _!="string"?!1:A(le)(_,void 0,oe)}function A(le,_={}){if(!le)return m;if(typeof le=="string"||L(le)){const oe=u(le,_);if(oe===g)return m;const re=function(ce,x){return!!oe(ce,x)};return oe.allBasenames&&(re.allBasenames=oe.allBasenames),oe.allPaths&&(re.allPaths=oe.allPaths),re}return z(le,_)}function L(le){const _=le;return _?typeof _.base=="string"&&typeof _.pattern=="string":!1}function J(le){return le.allBasenames||[]}function Y(le){return le.allPaths||[]}function z(le,_){const oe=V(Object.getOwnPropertyNames(le).map(Pe=>Q(Pe,le[Pe],_)).filter(Pe=>Pe!==g)),re=oe.length;if(!re)return g;if(!oe.some(Pe=>!!Pe.requiresSiblings)){if(re===1)return oe[0];const Pe=function(ne,be){let Ie;for(let Fe=0,Be=oe.length;Fe<Be;Fe++){const xe=oe[Fe](ne,be);if(typeof xe=="string")return xe;(0,D.$uh)(xe)&&(Ie||(Ie=[]),Ie.push(xe))}return Ie?(async()=>{for(const Fe of Ie){const Be=await Fe;if(typeof Be=="string")return Be}return null})():null},X=oe.find(ne=>!!ne.allBasenames);X&&(Pe.allBasenames=X.allBasenames);const q=oe.reduce((ne,be)=>be.allPaths?ne.concat(be.allPaths):ne,[]);return q.length&&(Pe.allPaths=q),Pe}const ce=function(Pe,X,q){let ne,be;for(let Ie=0,Fe=oe.length;Ie<Fe;Ie++){const Be=oe[Ie];Be.requiresSiblings&&q&&(X||(X=(0,O.$qc)(Pe)),ne||(ne=X.substr(0,X.length-(0,O.$rc)(Pe).length)));const xe=Be(Pe,X,ne,q);if(typeof xe=="string")return xe;(0,D.$uh)(xe)&&(be||(be=[]),be.push(xe))}return be?(async()=>{for(const Ie of be){const Fe=await Ie;if(typeof Fe=="string")return Fe}return null})():null},x=oe.find(Pe=>!!Pe.allBasenames);x&&(ce.allBasenames=x.allBasenames);const $e=oe.reduce((Pe,X)=>X.allPaths?Pe.concat(X.allPaths):Pe,[]);return $e.length&&(ce.allPaths=$e),ce}function Q(le,_,oe){if(_===!1)return g;const re=u(le,oe);if(re===g)return g;if(typeof _=="boolean")return re;if(_){const ce=_.when;if(typeof ce=="string"){const x=($e,Pe,X,q)=>{if(!q||!re($e,Pe))return null;const ne=ce.replace("$(basename)",()=>X),be=q(ne);return(0,D.$uh)(be)?be.then(Ie=>Ie?le:null):be?le:null};return x.requiresSiblings=!0,x}}return re}function V(le,_){const oe=le.filter(Pe=>!!Pe.basenames);if(oe.length<2)return le;const re=oe.reduce((Pe,X)=>{const q=X.basenames;return q?Pe.concat(q):Pe},[]);let ce;if(_){ce=[];for(let Pe=0,X=re.length;Pe<X;Pe++)ce.push(_)}else ce=oe.reduce((Pe,X)=>{const q=X.patterns;return q?Pe.concat(q):Pe},[]);const x=function(Pe,X){if(typeof Pe!="string")return null;if(!X){let ne;for(ne=Pe.length;ne>0;ne--){const be=Pe.charCodeAt(ne-1);if(be===P.CharCode.Slash||be===P.CharCode.Backslash)break}X=Pe.substr(ne)}const q=re.indexOf(X);return q!==-1?ce[q]:null};x.basenames=re,x.patterns=ce,x.allBasenames=re;const $e=le.filter(Pe=>!Pe.basenames);return $e.push(x),$e}function ie(le,_){return(0,v.$wb)(le,_,(oe,re)=>typeof oe=="string"&&typeof re=="string"?oe===re:typeof oe!="string"&&typeof re!="string"?oe.base===re.base&&oe.pattern===re.pattern:!1)}}),define(Re[59],Te([1,0,12,99,24,13,2]),function(we,e,v,D,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7k=e.MarkdownStringTextNewlineStyle=void 0,e.$8k=s,e.$9k=I,e.$0k=b,e.$$k=h,e.$_k=E,e.$al=f,e.$bl=r,e.$cl=l;var O;(function(d){d[d.Paragraph=0]="Paragraph",d[d.Break=1]="Break"})(O||(e.MarkdownStringTextNewlineStyle=O={}));class p{constructor(a="",i=!1){if(this.value=a,typeof this.value!="string")throw(0,v.$9)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(a,i=O.Paragraph){return this.value+=h(this.supportThemeIcons?(0,D.$1k)(a):a).replace(/([ \t]+)/g,(n,t)=>"&nbsp;".repeat(t.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===O.Break?`\\
`:`

`),this}appendMarkdown(a){return this.value+=a,this}appendCodeblock(a,i){return this.value+=`
${E(i,a)}
`,this}appendLink(a,i,n){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(a),")"),n&&(this.value+=` "${this.c(this.c(n,'"'),")")}"`),this.value+=")",this}c(a,i){const n=new RegExp((0,N.$kf)(i),"g");return a.replace(n,(t,o)=>a.charAt(o-1)!=="\\"?`\\${t}`:t)}}e.$7k=p;function s(d){return I(d)?!d.value:Array.isArray(d)?d.every(s):!0}function I(d){return d instanceof p?!0:d&&typeof d=="object"?typeof d.value=="string"&&(typeof d.isTrusted=="boolean"||typeof d.isTrusted=="object"||d.isTrusted===void 0)&&(typeof d.supportThemeIcons=="boolean"||d.supportThemeIcons===void 0):!1}function b(d,a){return d===a?!0:!d||!a?!1:d.value===a.value&&d.isTrusted===a.isTrusted&&d.supportThemeIcons===a.supportThemeIcons&&d.supportHtml===a.supportHtml&&(d.baseUri===a.baseUri||!!d.baseUri&&!!a.baseUri&&(0,P.$ch)(R.URI.from(d.baseUri),R.URI.from(a.baseUri)))}function h(d){return d.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function E(d,a){const i=d.match(/^`+/gm)?.reduce((t,o)=>t.length>o.length?t:o).length??0,n=i>=3?i+1:3;return[`${"`".repeat(n)}${a}`,d,`${"`".repeat(n)}`].join(`
`)}function f(d){return d.replace(/"/g,"&quot;")}function r(d){return d&&d.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function l(d){const a=[],i=d.split("|").map(t=>t.trim());d=i[0];const n=i[1];if(n){const t=/height=(\d+)/.exec(n),o=/width=(\d+)/.exec(n),c=t?t[1]:"",m=o?o[1]:"",g=isFinite(parseInt(m)),u=isFinite(parseInt(c));g&&a.push(`width="${m}"`),u&&a.push(`height="${c}"`)}return{href:d,dimensions:a}}}),define(Re[100],Te([1,0,17,73,22,23,24,13]),function(we,e,v,D,P,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7w=p,e.$8w=I,e.$9w=h,e.$0w=E,e.$$w=d,e.$_w=i,e.$ax=n,e.$bx=t,e.$cx=o,e.$dx=c;function p(g,u){const{os:S,tildify:k,relative:y}=u;if(y){const $=s(g,y,S);if(typeof $=="string")return $}let C=g.fsPath;if(S===N.OperatingSystem.Windows&&!N.$j?C=C.replace(/\//g,"\\"):S!==N.OperatingSystem.Windows&&N.$j&&(C=C.replace(/\\/g,"/")),S!==N.OperatingSystem.Windows&&k?.userHome){const $=k.userHome.fsPath;let w;g.scheme!==k.userHome.scheme&&g.path[0]===P.$jc.sep&&g.path[1]!==P.$jc.sep?w=k.userHome.with({path:g.path}).fsPath:w=C,C=h(w,$,S)}return(S===N.OperatingSystem.Windows?P.$ic:P.$jc).normalize(I(C,S===N.OperatingSystem.Windows))}function s(g,u,S){const k=S===N.OperatingSystem.Windows?P.$ic:P.$jc,y=S===N.OperatingSystem.Linux?R.$_g:R.$bh,C=u.getWorkspace(),T=(0,v.$Qb)(C.folders);if(!T)return;g.scheme!==T.uri.scheme&&g.path[0]===P.$jc.sep&&g.path[1]!==P.$jc.sep&&(g=T.uri.with({path:g.path}));const $=u.getWorkspaceFolder(g);if(!$)return;let w;if(y.isEqual($.uri,g)?w="":w=y.relativePath($.uri,g)??"",w&&(w=k.normalize(w)),C.folders.length>1&&!u.noPrefix){const M=$.name?$.name:y.basenameOrAuthority($.uri);w=w?`${M} \u2022 ${w}`:M}return w}function I(g,u=N.$j){return(0,D.$Mg)(g,u)?g.charAt(0).toUpperCase()+g.slice(1):g}let b=Object.create(null);function h(g,u,S=N.OS){if(S===N.OperatingSystem.Windows||!g||!u)return g;let k=b.original===u?b.normalized:void 0;k||(k=u,N.$j&&(k=(0,D.$Bg)(k)),k=`${(0,O.$qf)(k,P.$jc.sep)}${P.$jc.sep}`,b={original:u,normalized:k});let y=g;return N.$j&&(y=(0,D.$Bg)(y)),(S===N.OperatingSystem.Linux?y.startsWith(k):(0,O.$Jf)(y,k))?`~/${y.substr(k.length)}`:g}function E(g,u){return g.replace(/^~($|\/|\\)/,`${u}$1`)}const f="\u2026",r="\\\\",l="~";function d(g,u=P.sep){const S=new Array(g.length);let k=!1;for(let y=0;y<g.length;y++){const C=g[y];if(C===""){S[y]=`.${u}`;continue}if(!C){S[y]=C;continue}k=!0;let T="",$=C;$.indexOf(r)===0?(T=$.substr(0,$.indexOf(r)+r.length),$=$.substr($.indexOf(r)+r.length)):$.indexOf(u)===0?(T=$.substr(0,$.indexOf(u)+u.length),$=$.substr($.indexOf(u)+u.length)):$.indexOf(l)===0&&(T=$.substr(0,$.indexOf(l)+l.length),$=$.substr($.indexOf(l)+l.length));const w=$.split(u);for(let M=1;k&&M<=w.length;M++)for(let A=w.length-M;k&&A>=0;A--){k=!1;let L=w.slice(A,A+M).join(u);for(let J=0;!k&&J<g.length;J++)if(J!==y&&g[J]&&g[J].indexOf(L)>-1){const Y=A+M===w.length,z=A>0&&g[J].indexOf(u)>-1?u+L:L,Q=g[J].endsWith(z);k=!Y||Q}if(!k){let J="";(w[0].endsWith(":")||T!=="")&&(A===1&&(A=0,M++,L=w[0]+u+L),A>0&&(J=w[0]+u),J=T+J),A>0&&(J=J+f+u),J=J+L,A+M<w.length&&(J=J+u+f),S[y]=J}}k&&(S[y]=C)}return S}var a;(function(g){g[g.TEXT=0]="TEXT",g[g.VARIABLE=1]="VARIABLE",g[g.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function i(g,u=Object.create(null)){const S=[];let k=!1,y="";for(const C of g)if(C==="$"||k&&C==="{")y&&S.push({value:y,type:a.TEXT}),y="",k=!0;else if(C==="}"&&k){const T=u[y];if(typeof T=="string")T.length&&S.push({value:T,type:a.VARIABLE});else if(T){const $=S[S.length-1];(!$||$.type!==a.SEPARATOR)&&S.push({value:T.label,type:a.SEPARATOR})}y="",k=!1}else y+=C;return y&&!k&&S.push({value:y,type:a.TEXT}),S.filter((C,T)=>{if(C.type===a.SEPARATOR){const $=S[T-1],w=S[T+1];return[$,w].every(M=>M&&(M.type===a.VARIABLE||M.type===a.TEXT)&&M.value.length>0)}return!0}).map(C=>C.value).join("")}function n(g,u){return N.$k||u?g.replace(/\(&&\w\)|&&/g,"").replace(/&/g,N.$k?"&":"&&"):g.replace(/&&|&/g,S=>S==="&"?"&&":"&")}function t(g,u){return N.$k||u?g.replace(/\(&&\w\)|&&/g,""):N.$j?g.replace(/&&|&/g,S=>S==="&"?"&&":"&"):g.replace(/&&/g,"_")}function o(g){return g.replace(/&/g,"&&")}function c(g){if(g.endsWith("]")){const u=g.lastIndexOf(" [",g.length-2);if(u!==-1){const S=m(g.substring(0,u)),k=g.substring(u);return{name:S.name+k,parentPath:S.parentPath}}}return m(g)}function m(g){const u=g.indexOf("/")!==-1?P.$jc:P.$ic,S=u.basename(g),k=u.dirname(g);return S.length?{name:S,parentPath:k}:{name:k,parentPath:""}}}),define(Re[150],Te([1,0,20,37,2]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rn=e.$Qn=void 0,e.$Sn=p,e.$Tn=I,e.$Un=b;function N(h){return h.toJSON()}class R{constructor(E){this.a=E}transformIncoming(E){const f=this.a.transformIncoming(E);return f===E?E:N(P.URI.from(f))}transformOutgoing(E){const f=this.a.transformOutgoing(E);return f===E?E:N(P.URI.from(f))}transformOutgoingURI(E){const f=this.a.transformOutgoing(E);return f===E?E:P.URI.from(f)}transformOutgoingScheme(E){return this.a.transformOutgoingScheme(E)}}e.$Qn=R,e.$Rn=new class{transformIncoming(h){return h}transformOutgoing(h){return h}transformOutgoingURI(h){return h}transformOutgoingScheme(h){return h}};function O(h,E,f){if(!h||f>200)return null;if(typeof h=="object"){if(h instanceof P.URI)return E.transformOutgoing(h);for(const r in h)if(Object.hasOwnProperty.call(h,r)){const l=O(h[r],E,f+1);l!==null&&(h[r]=l)}}return null}function p(h,E){const f=O(h,E,0);return f===null?h:f}function s(h,E,f,r){if(!h||r>200)return null;if(typeof h=="object"){if(h.$mid===D.MarshalledId.Uri)return f?P.URI.revive(E.transformIncoming(h)):E.transformIncoming(h);if(h instanceof v.$Qe)return null;for(const l in h)if(Object.hasOwnProperty.call(h,l)){const d=s(h[l],E,f,r+1);d!==null&&(h[l]=d)}}return null}function I(h,E){const f=s(h,E,!1,0);return f===null?h:f}function b(h,E){const f=s(h,E,!0,0);return f===null?h:f}}),define(Re[38],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5g=void 0,e.$4g=D;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(P){return v.test(P)}e.$5g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(O){for(let p=0;p<O.length;p++)O[p]=Math.floor(Math.random()*256);return O};const N=new Uint8Array(16),R=[];for(let O=0;O<256;O++)R.push(O.toString(16).padStart(2,"0"));return function(){P(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let p=0,s="";return s+=R[N[p++]],s+=R[N[p++]],s+=R[N[p++]],s+=R[N[p++]],s+="-",s+=R[N[p++]],s+=R[N[p++]],s+="-",s+=R[N[p++]],s+=R[N[p++]],s+="-",s+=R[N[p++]],s+=R[N[p++]],s+="-",s+=R[N[p++]],s+=R[N[p++]],s+=R[N[p++]],s+=R[N[p++]],s+=R[N[p++]],s+=R[N[p++]],s}}()}),define(Re[151],Te([1,0,17,40,38]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zu=e.$xu=void 0,e.$vu=N,e.$wu=R,e.$yu=s;function N(b){return{asString:async()=>b,asFile:()=>{},value:typeof b=="string"?b:void 0}}function R(b,h,E){const f={id:(0,P.$5g)(),name:b,uri:h,data:E};return{asString:async()=>"",asFile:()=>f,value:void 0}}class O{constructor(){this.a=new Map}get size(){let h=0;for(const E of this.a)h++;return h}has(h){return this.a.has(this.b(h))}matches(h){const E=[...this.a.keys()];return D.Iterable.some(this,([f,r])=>r.asFile())&&E.push("files"),I(p(h),E)}get(h){return this.a.get(this.b(h))?.[0]}append(h,E){const f=this.a.get(h);f?f.push(E):this.a.set(this.b(h),[E])}replace(h,E){this.a.set(this.b(h),[E])}delete(h){this.a.delete(this.b(h))}*[Symbol.iterator](){for(const[h,E]of this.a)for(const f of E)yield[h,f]}b(h){return p(h)}}e.$xu=O;function p(b){return b.toLowerCase()}function s(b,h){return I(p(b),h.map(p))}function I(b,h){if(b==="*/*")return h.length>0;if(h.includes(b))return!0;const E=b.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!E)return!1;const[f,r,l]=E;return l==="*"?h.some(d=>d.startsWith(r+"/")):!1}e.$zu=Object.freeze({create:b=>(0,v.$Ob)(b.map(h=>h.toString())).join(`\r
`),split:b=>b.split(`\r
`),parse:b=>e.$zu.split(b).filter(h=>!h.startsWith("#"))})}),define(Re[152],Te([1,0,10,6,4,33,14]),function(we,e,v,D,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$iq=e.StorageState=e.StorageHint=void 0,e.$hq=p;var O;(function(h){h[h.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",h[h.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(O||(e.StorageHint=O={}));function p(h){const E=h;return E?.changed instanceof Map||E?.deleted instanceof Set}var s;(function(h){h[h.None=0]="None",h[h.Initialized=1]="Initialized",h[h.Closed=2]="Closed"})(s||(e.StorageState=s={}));class I extends P.$Xc{static{this.a=100}constructor(E,f=Object.create(null)){super(),this.r=E,this.s=f,this.b=this.B(new D.$re),this.onDidChangeStorage=this.b.event,this.c=s.None,this.f=new Map,this.g=this.B(new v.$Gh(I.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(E=>this.u(E)))}u(E){this.b.pause();try{E.changed?.forEach((f,r)=>this.w(r,f)),E.deleted?.forEach(f=>this.w(f,void 0))}finally{this.b.resume()}}w(E,f){if(this.c===s.Closed)return;let r=!1;(0,R.$qg)(f)?r=this.f.delete(E):this.f.get(E)!==f&&(this.f.set(E,f),r=!0),r&&this.b.fire({key:E,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===s.None&&(this.c=s.Initialized,this.s.hint!==O.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(E,f){const r=this.f.get(E);return(0,R.$qg)(r)?f:r}getBoolean(E,f){const r=this.get(E);return(0,R.$qg)(r)?f:r==="true"}getNumber(E,f){const r=this.get(E);return(0,R.$qg)(r)?f:parseInt(r,10)}getObject(E,f){const r=this.get(E);return(0,R.$qg)(r)?f:(0,N.$ei)(r)}async set(E,f,r=!1){if(this.c===s.Closed)return;if((0,R.$qg)(f))return this.delete(E,r);const l=(0,R.$jg)(f)||Array.isArray(f)?(0,N.$di)(f):String(f);if(this.f.get(E)!==l)return this.f.set(E,l),this.j.set(E,l),this.h.delete(E),this.b.fire({key:E,external:r}),this.D()}async delete(E,f=!1){if(!(this.c===s.Closed||!this.f.delete(E)))return this.h.has(E)||this.h.add(E),this.j.delete(E),this.b.fire({key:E,external:f}),this.D()}async optimize(){if(this.c!==s.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=s.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const E={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(E).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(E){if(!(this.c===s.Closed||this.m))return this.D(E)}async D(E){return this.s.hint===O.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),E)}async whenFlushed(){if(this.z)return new Promise(E=>this.n.push(E))}isInMemory(){return this.s.hint===O.STORAGE_IN_MEMORY}}e.$iq=I;class b{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(E){E.insert?.forEach((f,r)=>this.a.set(r,f)),E.delete?.forEach(f=>this.a.delete(f))}async optimize(){}async close(){}}e.$jq=b}),define(Re[153],Te([1,0,30]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Fu=P;var D;(function(N){N[N.Unknown=0]="Unknown",N[N.Invalid=3]="Invalid",N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(D||(e.StringEOL=D={}));function P(N){let R=0,O=0,p=0,s=D.Unknown;for(let I=0,b=N.length;I<b;I++){const h=N.charCodeAt(I);h===v.CharCode.CarriageReturn?(R===0&&(O=I),R++,I+1<b&&N.charCodeAt(I+1)===v.CharCode.LineFeed?(s|=D.CRLF,I++):s|=D.Invalid,p=I+1):h===v.CharCode.LineFeed&&(s|=D.LF,R===0&&(O=I),R++,p=I+1)}return R===0&&(O=N.length),[R,O,N.length-p,s]}}),define(Re[154],Te([1,0,13,23,20]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ku=void 0,e.$iu=I,e.$ju=b,v=qe(v),D=qe(D),P=qe(P);let N;function R(){return N||(N=new TextDecoder("UTF-16LE")),N}let O;function p(){return O||(O=new TextDecoder("UTF-16BE")),O}let s;function I(){return s||(s=D.$E()?R():p()),s}function b(f,r,l){const d=new Uint16Array(f.buffer,r,l);return l>0&&(d[0]===65279||d[0]===65534)?h(f,r,l):R().decode(d)}function h(f,r,l){const d=[];let a=0;for(let i=0;i<l;i++){const n=P.$Se(f,r);r+=2,d[a++]=String.fromCharCode(n)}return d.join("")}class E{constructor(r){this.a=r|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const r=new Uint16Array(this.b.buffer,0,this.d);return I().decode(r)}f(){const r=this.e();this.d=0,this.c===null?this.c=[r]:this.c[this.c.length]=r}appendCharCode(r){const l=this.a-this.d;l<=1&&(l===0||v.$Mf(r))&&this.f(),this.b[this.d++]=r}appendASCIICharCode(r){this.d===this.a&&this.f(),this.b[this.d++]=r}appendString(r){const l=r.length;if(this.d+l>=this.a){this.f(),this.c[this.c.length]=r;return}for(let d=0;d<l;d++)this.b[this.d++]=r.charCodeAt(d)}}e.$ku=E}),define(Re[155],Te([1,0,20,154]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lu=void 0,e.$mu=R,v=qe(v);function P(p){return p.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class N{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(s,I,b,h){this.oldPosition=s,this.oldText=I,this.newPosition=b,this.newText=h}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${P(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${P(this.oldText)}")`:`(replace@${this.oldPosition} "${P(this.oldText)}" with "${P(this.newText)}")`}static a(s){return 4+2*s.length}static c(s,I,b){const h=I.length;v.$Ve(s,h,b),b+=4;for(let E=0;E<h;E++)v.$Te(s,I.charCodeAt(E),b),b+=2;return b}static d(s,I){const b=v.$Ue(s,I);return I+=4,(0,D.$ju)(s,I,b)}writeSize(){return 8+N.a(this.oldText)+N.a(this.newText)}write(s,I){return v.$Ve(s,this.oldPosition,I),I+=4,v.$Ve(s,this.newPosition,I),I+=4,I=N.c(s,this.oldText,I),I=N.c(s,this.newText,I),I}static read(s,I,b){const h=v.$Ue(s,I);I+=4;const E=v.$Ue(s,I);I+=4;const f=N.d(s,I);I+=N.a(f);const r=N.d(s,I);return I+=N.a(r),b.push(new N(h,f,E,r)),I}}e.$lu=N;function R(p,s){return p===null||p.length===0?s:new O(p,s).compress()}class O{constructor(s,I){this.a=s,this.c=I,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let s=0,I=0,b=this.n(s),h=this.l(I);for(;s<this.f||I<this.h;){if(b===null){this.k(h),h=this.l(++I);continue}if(h===null){this.m(b),b=this.n(++s);continue}if(h.oldEnd<=b.newPosition){this.k(h),h=this.l(++I);continue}if(b.newEnd<=h.oldPosition){this.m(b),b=this.n(++s);continue}if(h.oldPosition<b.newPosition){const[d,a]=O.r(h,b.newPosition-h.oldPosition);this.k(d),h=a;continue}if(b.newPosition<h.oldPosition){const[d,a]=O.q(b,h.oldPosition-b.newPosition);this.m(d),b=a;continue}let r,l;if(h.oldEnd===b.newEnd)r=b,l=h,b=this.n(++s),h=this.l(++I);else if(h.oldEnd<b.newEnd){const[d,a]=O.q(b,h.oldLength);r=d,l=h,b=a,h=this.l(++I)}else{const[d,a]=O.r(h,b.newLength);r=b,l=d,b=this.n(++s),h=a}this.d[this.e++]=new N(r.oldPosition,r.oldText,l.newPosition,l.newText),this.g+=r.newLength-r.oldLength,this.j+=l.newLength-l.oldLength}const E=O.s(this.d);return O.t(E)}k(s){this.d[this.e++]=O.o(this.g,s),this.j+=s.newLength-s.oldLength}l(s){return s<this.h?this.c[s]:null}m(s){this.d[this.e++]=O.p(this.j,s),this.g+=s.newLength-s.oldLength}n(s){return s<this.f?this.a[s]:null}static o(s,I){return new N(I.oldPosition-s,I.oldText,I.newPosition,I.newText)}static p(s,I){return new N(I.oldPosition,I.oldText,I.newPosition+s,I.newText)}static q(s,I){const b=s.newText.substr(0,I),h=s.newText.substr(I);return[new N(s.oldPosition,s.oldText,s.newPosition,b),new N(s.oldEnd,"",s.newPosition+I,h)]}static r(s,I){const b=s.oldText.substr(0,I),h=s.oldText.substr(I);return[new N(s.oldPosition,b,s.newPosition,s.newText),new N(s.oldPosition+I,h,s.newEnd,"")]}static s(s){if(s.length===0)return s;const I=[];let b=0,h=s[0];for(let E=1;E<s.length;E++){const f=s[E];h.oldEnd===f.oldPosition?h=new N(h.oldPosition,h.oldText+f.oldText,h.newPosition,h.newText+f.newText):(I[b++]=h,h=f)}return I[b++]=h,I}static t(s){if(s.length===0)return s;const I=[];let b=0;for(let h=0;h<s.length;h++){const E=s[h];E.oldText!==E.newText&&(I[b++]=E)}return I}}}),define(Re[156],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rt=void 0,e.$rt={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Re[157],Te([1,0,41,22]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cu=P,e.$Du=N;function P(R,O,p,s,I,b){if(Array.isArray(R)){let h=0;for(const E of R){const f=P(E,O,p,s,I,b);if(f===10)return f;f>h&&(h=f)}return h}else{if(typeof R=="string")return s?R==="*"?5:R===p?10:0:0;if(R){const{language:h,pattern:E,scheme:f,hasAccessToAllModels:r,notebookType:l}=R;if(!s&&!r)return 0;l&&I&&(O=I);let d=0;if(f)if(f===O.scheme)d=10;else if(f==="*")d=5;else return 0;if(h)if(h===p)d=10;else if(h==="*")d=Math.max(d,5);else return 0;if(l)if(l===b)d=10;else if(l==="*"&&b!==void 0)d=Math.max(d,5);else return 0;if(E){let a;if(typeof E=="string"?a=E:a={...E,base:(0,D.$kc)(E.base)},a===O.fsPath||(0,v.$Ck)(a,O.fsPath))d=10;else return 0}return d}else return 0}}function N(R){return typeof R=="string"?!1:Array.isArray(R)?R.some(N):!!R.notebookType}}),define(Re[158],Te([1,0,30,159]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5u=e.$4u=e.IndentAction=void 0;var P;(function(p){p[p.None=0]="None",p[p.Indent=1]="Indent",p[p.IndentOutdent=2]="IndentOutdent",p[p.Outdent=3]="Outdent"})(P||(e.IndentAction=P={}));class N{constructor(s){if(this.e=null,this.f=!1,this.open=s.open,this.close=s.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(s.notIn))for(let I=0,b=s.notIn.length;I<b;I++)switch(s.notIn[I]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(s){switch(s){case D.StandardTokenType.Other:return!0;case D.StandardTokenType.Comment:return this.c;case D.StandardTokenType.String:return this.b;case D.StandardTokenType.RegEx:return this.d}}shouldAutoClose(s,I){if(s.getTokenCount()===0)return!0;const b=s.findTokenIndexAtOffset(I-2),h=s.getStandardTokenType(b);return this.isOK(h)}g(s,I){for(let b=s;b<=I;b++){const h=String.fromCharCode(b);if(!this.open.includes(h)&&!this.close.includes(h))return h}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(v.CharCode.Digit0,v.CharCode.Digit9)),this.e||(this.e=this.g(v.CharCode.a,v.CharCode.z)),this.e||(this.e=this.g(v.CharCode.A,v.CharCode.Z))),this.e}}e.$4u=N;class R{constructor(s){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const I of s)O(this.autoClosingPairsOpenByStart,I.open.charAt(0),I),O(this.autoClosingPairsOpenByEnd,I.open.charAt(I.open.length-1),I),O(this.autoClosingPairsCloseByStart,I.close.charAt(0),I),O(this.autoClosingPairsCloseByEnd,I.close.charAt(I.close.length-1),I),I.close.length===1&&I.open.length===1&&O(this.autoClosingPairsCloseSingleChar,I.close,I)}}e.$5u=R;function O(p,s,I){p.has(s)?p.get(s).push(I):p.set(s,[I])}}),define(Re[160],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mD=e.NodeColor=e.$lD=void 0,e.$nD=P,e.$oD=N,e.$pD=s,e.$qD=I,e.$rD=b,e.$sD=h,e.$tD=E,e.$uD=f;class v{constructor(l,d){this.piece=l,this.color=d,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$mD)return P(this.right);let l=this;for(;l.parent!==e.$mD&&l.parent.left!==l;)l=l.parent;return l.parent===e.$mD?e.$mD:l.parent}prev(){if(this.left!==e.$mD)return N(this.left);let l=this;for(;l.parent!==e.$mD&&l.parent.right!==l;)l=l.parent;return l.parent===e.$mD?e.$mD:l.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$lD=v;var D;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(D||(e.NodeColor=D={})),e.$mD=new v(null,D.Black),e.$mD.parent=e.$mD,e.$mD.left=e.$mD,e.$mD.right=e.$mD,e.$mD.color=D.Black;function P(r){for(;r.left!==e.$mD;)r=r.left;return r}function N(r){for(;r.right!==e.$mD;)r=r.right;return r}function R(r){return r===e.$mD?0:r.size_left+r.piece.length+R(r.right)}function O(r){return r===e.$mD?0:r.lf_left+r.piece.lineFeedCnt+O(r.right)}function p(){e.$mD.parent=e.$mD}function s(r,l){const d=l.right;d.size_left+=l.size_left+(l.piece?l.piece.length:0),d.lf_left+=l.lf_left+(l.piece?l.piece.lineFeedCnt:0),l.right=d.left,d.left!==e.$mD&&(d.left.parent=l),d.parent=l.parent,l.parent===e.$mD?r.root=d:l.parent.left===l?l.parent.left=d:l.parent.right=d,d.left=l,l.parent=d}function I(r,l){const d=l.left;l.left=d.right,d.right!==e.$mD&&(d.right.parent=l),d.parent=l.parent,l.size_left-=d.size_left+(d.piece?d.piece.length:0),l.lf_left-=d.lf_left+(d.piece?d.piece.lineFeedCnt:0),l.parent===e.$mD?r.root=d:l===l.parent.right?l.parent.right=d:l.parent.left=d,d.right=l,l.parent=d}function b(r,l){let d,a;if(l.left===e.$mD?(a=l,d=a.right):l.right===e.$mD?(a=l,d=a.left):(a=P(l.right),d=a.right),a===r.root){r.root=d,d.color=D.Black,l.detach(),p(),r.root.parent=e.$mD;return}const i=a.color===D.Red;if(a===a.parent.left?a.parent.left=d:a.parent.right=d,a===l?(d.parent=a.parent,f(r,d)):(a.parent===l?d.parent=a:d.parent=a.parent,f(r,d),a.left=l.left,a.right=l.right,a.parent=l.parent,a.color=l.color,l===r.root?r.root=a:l===l.parent.left?l.parent.left=a:l.parent.right=a,a.left!==e.$mD&&(a.left.parent=a),a.right!==e.$mD&&(a.right.parent=a),a.size_left=l.size_left,a.lf_left=l.lf_left,f(r,a)),l.detach(),d.parent.left===d){const t=R(d),o=O(d);if(t!==d.parent.size_left||o!==d.parent.lf_left){const c=t-d.parent.size_left,m=o-d.parent.lf_left;d.parent.size_left=t,d.parent.lf_left=o,E(r,d.parent,c,m)}}if(f(r,d.parent),i){p();return}let n;for(;d!==r.root&&d.color===D.Black;)d===d.parent.left?(n=d.parent.right,n.color===D.Red&&(n.color=D.Black,d.parent.color=D.Red,s(r,d.parent),n=d.parent.right),n.left.color===D.Black&&n.right.color===D.Black?(n.color=D.Red,d=d.parent):(n.right.color===D.Black&&(n.left.color=D.Black,n.color=D.Red,I(r,n),n=d.parent.right),n.color=d.parent.color,d.parent.color=D.Black,n.right.color=D.Black,s(r,d.parent),d=r.root)):(n=d.parent.left,n.color===D.Red&&(n.color=D.Black,d.parent.color=D.Red,I(r,d.parent),n=d.parent.left),n.left.color===D.Black&&n.right.color===D.Black?(n.color=D.Red,d=d.parent):(n.left.color===D.Black&&(n.right.color=D.Black,n.color=D.Red,s(r,n),n=d.parent.left),n.color=d.parent.color,d.parent.color=D.Black,n.left.color=D.Black,I(r,d.parent),d=r.root));d.color=D.Black,p()}function h(r,l){for(f(r,l);l!==r.root&&l.parent.color===D.Red;)if(l.parent===l.parent.parent.left){const d=l.parent.parent.right;d.color===D.Red?(l.parent.color=D.Black,d.color=D.Black,l.parent.parent.color=D.Red,l=l.parent.parent):(l===l.parent.right&&(l=l.parent,s(r,l)),l.parent.color=D.Black,l.parent.parent.color=D.Red,I(r,l.parent.parent))}else{const d=l.parent.parent.left;d.color===D.Red?(l.parent.color=D.Black,d.color=D.Black,l.parent.parent.color=D.Red,l=l.parent.parent):(l===l.parent.left&&(l=l.parent,I(r,l)),l.parent.color=D.Black,l.parent.parent.color=D.Red,s(r,l.parent.parent))}r.root.color=D.Black}function E(r,l,d,a){for(;l!==r.root&&l!==e.$mD;)l.parent.left===l&&(l.parent.size_left+=d,l.parent.lf_left+=a),l=l.parent}function f(r,l){let d=0,a=0;if(l!==r.root){for(;l!==r.root&&l===l.parent.right;)l=l.parent;if(l!==r.root)for(l=l.parent,d=R(l.left)-l.size_left,a=O(l.left)-l.lf_left,l.size_left+=d,l.lf_left+=a;l!==r.root&&(d!==0||a!==0);)l.parent.left===l&&(l.parent.size_left+=d,l.parent.lf_left+=a),l=l.parent}}}),define(Re[101],Te([1,0,30,102,32,52,160,103]),function(we,e,v,D,P,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FD=e.$ED=e.$DD=void 0,e.$BD=b,e.$CD=h;const p=65535;function s(a){let i;return a[a.length-1]<65536?i=new Uint16Array(a.length):i=new Uint32Array(a.length),i.set(a,0),i}class I{constructor(i,n,t,o,c){this.lineStarts=i,this.cr=n,this.lf=t,this.crlf=o,this.isBasicASCII=c}}function b(a,i=!0){const n=[0];let t=1;for(let o=0,c=a.length;o<c;o++){const m=a.charCodeAt(o);m===v.CharCode.CarriageReturn?o+1<c&&a.charCodeAt(o+1)===v.CharCode.LineFeed?(n[t++]=o+2,o++):n[t++]=o+1:m===v.CharCode.LineFeed&&(n[t++]=o+1)}return i?s(n):n}function h(a,i){a.length=0,a[0]=0;let n=1,t=0,o=0,c=0,m=!0;for(let u=0,S=i.length;u<S;u++){const k=i.charCodeAt(u);k===v.CharCode.CarriageReturn?u+1<S&&i.charCodeAt(u+1)===v.CharCode.LineFeed?(c++,a[n++]=u+2,u++):(t++,a[n++]=u+1):k===v.CharCode.LineFeed?(o++,a[n++]=u+1):m&&k!==v.CharCode.Tab&&(k<32||k>126)&&(m=!1)}const g=new I(s(a),t,o,c,m);return a.length=0,g}class E{constructor(i,n,t,o,c){this.bufferIndex=i,this.start=n,this.end=t,this.lineFeedCnt=o,this.length=c}}e.$DD=E;class f{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$ED=f;class r{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==R.$mD&&i.iterate(i.root,t=>(t!==R.$mD&&this.a.push(t.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class l{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const t=this.b[n];if(t.nodeStartOffset<=i&&t.nodeStartOffset+t.node.piece.length>=i)return t}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const t=this.b[n];if(t.nodeStartLineNumber&&t.nodeStartLineNumber<i&&t.nodeStartLineNumber+t.node.piece.lineFeedCnt>=i)return t}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const t=this.b;for(let o=0;o<t.length;o++){const c=t[o];if(c.node.parent===null||c.nodeStartOffset>=i){t[o]=null,n=!0;continue}}if(n){const o=[];for(const c of t)c!==null&&o.push(c);this.b=o}}}class d{constructor(i,n,t){this.create(i,n,t)}create(i,n,t){this.a=[new f("",[0])],this.g={line:0,column:0},this.root=R.$mD,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=t;let o=null;for(let c=0,m=i.length;c<m;c++)if(i[c].buffer.length>0){i[c].lineStarts||(i[c].lineStarts=b(i[c].buffer));const g=new E(c+1,{line:0,column:0},{line:i[c].lineStarts.length-1,column:i[c].buffer.length-i[c].lineStarts[i[c].lineStarts.length-1]},i[c].lineStarts.length-1,i[c].buffer.length);this.a.push(i[c]),o=this.S(o,g)}this.h=new l(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=p,t=n-Math.floor(n/3),o=t*2;let c="",m=0;const g=[];if(this.iterate(this.root,u=>{const S=this.R(u),k=S.length;if(m<=t||m+k<o)return c+=S,m+=k,!0;const y=c.replace(/\r\n|\r|\n/g,i);return g.push(new f(y,b(y))),c=S,m=k,!0}),m>0){const u=c.replace(/\r\n|\r|\n/g,i);g.push(new f(u,b(u)))}this.create(g,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new r(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,o=>{if(o===R.$mD)return!0;const c=this.R(o),m=c.length,g=i.G(n),u=i.G(n+m),S=i.getValueInRange2(g,u);return n+=m,c===S})}getOffsetAt(i,n){let t=0,o=this.root;for(;o!==R.$mD;)if(o.left!==R.$mD&&o.lf_left+1>=i)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt+1>=i){t+=o.size_left;const c=this.B(o,i-o.lf_left-2);return t+=c+n-1}else i-=o.lf_left+o.piece.lineFeedCnt,t+=o.size_left+o.piece.length,o=o.right;return t}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,t=0;const o=i;for(;n!==R.$mD;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const c=this.A(n,i-n.size_left);if(t+=n.lf_left+c.index,c.index===0){const m=this.getOffsetAt(t+1,1),g=o-m;return new D.$Tt(t+1,g+1)}return new D.$Tt(t+1,c.remainder+1)}else if(i-=n.size_left+n.piece.length,t+=n.lf_left+n.piece.lineFeedCnt,n.right===R.$mD){const c=this.getOffsetAt(t+1,1),m=o-i-c;return new D.$Tt(t+1,m+1)}else n=n.right;return new D.$Tt(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const t=this.H(i.startLineNumber,i.startColumn),o=this.H(i.endLineNumber,i.endColumn),c=this.getValueInRange2(t,o);return n?n!==this.d||!this.f?c.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?c:c.replace(/\r\n|\r|\n/g,n):c}getValueInRange2(i,n){if(i.node===n.node){const g=i.node,u=this.a[g.piece.bufferIndex].buffer,S=this.u(g.piece.bufferIndex,g.piece.start);return u.substring(S+i.remainder,S+n.remainder)}let t=i.node;const o=this.a[t.piece.bufferIndex].buffer,c=this.u(t.piece.bufferIndex,t.piece.start);let m=o.substring(c+i.remainder,c+t.piece.length);for(t=t.next();t!==R.$mD;){const g=this.a[t.piece.bufferIndex].buffer,u=this.u(t.piece.bufferIndex,t.piece.start);if(t===n.node){m+=g.substring(u,u+n.remainder);break}else m+=g.substr(u,t.piece.length);t=t.next()}return m}getLinesContent(){const i=[];let n=0,t="",o=!1;return this.iterate(this.root,c=>{if(c===R.$mD)return!0;const m=c.piece;let g=m.length;if(g===0)return!0;const u=this.a[m.bufferIndex].buffer,S=this.a[m.bufferIndex].lineStarts,k=m.start.line,y=m.end.line;let C=S[k]+m.start.column;if(o&&(u.charCodeAt(C)===v.CharCode.LineFeed&&(C++,g--),i[n++]=t,t="",o=!1,g===0))return!0;if(k===y)return!this.f&&u.charCodeAt(C+g-1)===v.CharCode.CarriageReturn?(o=!0,t+=u.substr(C,g-1)):t+=u.substr(C,g),!0;t+=this.f?u.substring(C,Math.max(C,S[k+1]-this.e)):u.substring(C,S[k+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=t;for(let T=k+1;T<y;T++)t=this.f?u.substring(S[T],S[T+1]-this.e):u.substring(S[T],S[T+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=t;return!this.f&&u.charCodeAt(S[y]+m.end.column-1)===v.CharCode.CarriageReturn?(o=!0,m.end.column===0?n--:t=u.substr(S[y],m.end.column-1)):t=u.substr(S[y],m.end.column),!0}),o&&(i[n++]=t,t=""),i[n++]=t,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const t=this.a[n.piece.bufferIndex],o=this.u(n.piece.bufferIndex,n.piece.start);return t.buffer.charCodeAt(o)}else{const n=this.a[i.node.piece.bufferIndex],o=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(o)}}getLineCharCode(i,n){const t=this.H(i,n+1);return this.l(t)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}getNearestChunk(i){const n=this.G(i);if(n.remainder===n.node.piece.length){const t=n.node.next();if(!t||t===R.$mD)return"";const o=this.a[t.piece.bufferIndex],c=this.u(t.piece.bufferIndex,t.piece.start);return o.buffer.substring(c,c+t.piece.length)}else{const t=this.a[n.node.piece.bufferIndex],o=this.u(n.node.piece.bufferIndex,n.node.piece.start),c=o+n.remainder,m=o+n.node.piece.length;return t.buffer.substring(c,m)}}findMatchesInNode(i,n,t,o,c,m,g,u,S,k,y){const C=this.a[i.piece.bufferIndex],T=this.u(i.piece.bufferIndex,i.piece.start),$=this.u(i.piece.bufferIndex,c),w=this.u(i.piece.bufferIndex,m);let M;const A={line:0,column:0};let L,J;n._wordSeparators?(L=C.buffer.substring($,w),J=Y=>Y+$,n.reset(0)):(L=C.buffer,J=Y=>Y,n.reset($));do if(M=n.next(L),M){if(J(M.index)>=w)return k;this.s(i,J(M.index)-T,A);const Y=this.t(i.piece.bufferIndex,c,A),z=A.line===c.line?A.column-c.column+o:A.column+1,Q=z+M[0].length;if(y[k++]=(0,O.$xD)(new P.$Ut(t+Y,z,t+Y,Q),M,u),J(M.index)+M[0].length>=w||k>=S)return k}while(M);return k}findMatchesLineByLine(i,n,t,o){const c=[];let m=0;const g=new O.$AD(n.wordSeparators,n.regex);let u=this.H(i.startLineNumber,i.startColumn);if(u===null)return[];const S=this.H(i.endLineNumber,i.endColumn);if(S===null)return[];let k=this.s(u.node,u.remainder);const y=this.s(S.node,S.remainder);if(u.node===S.node)return this.findMatchesInNode(u.node,g,i.startLineNumber,i.startColumn,k,y,n,t,o,m,c),c;let C=i.startLineNumber,T=u.node;for(;T!==S.node;){const w=this.t(T.piece.bufferIndex,k,T.piece.end);if(w>=1){const A=this.a[T.piece.bufferIndex].lineStarts,L=this.u(T.piece.bufferIndex,T.piece.start),J=A[k.line+w],Y=C===i.startLineNumber?i.startColumn:1;if(m=this.findMatchesInNode(T,g,C,Y,k,this.s(T,J-L),n,t,o,m,c),m>=o)return c;C+=w}const M=C===i.startLineNumber?i.startColumn-1:0;if(C===i.endLineNumber){const A=this.getLineContent(C).substring(M,i.endColumn-1);return m=this.n(n,g,A,i.endLineNumber,M,m,c,t,o),c}if(m=this.n(n,g,this.getLineContent(C).substr(M),C,M,m,c,t,o),m>=o)return c;C++,u=this.H(C,1),T=u.node,k=this.s(u.node,u.remainder)}if(C===i.endLineNumber){const w=C===i.startLineNumber?i.startColumn-1:0,M=this.getLineContent(C).substring(w,i.endColumn-1);return m=this.n(n,g,M,i.endLineNumber,w,m,c,t,o),c}const $=C===i.startLineNumber?i.startColumn:1;return m=this.findMatchesInNode(S.node,g,C,$,k,y,n,t,o,m,c),c}n(i,n,t,o,c,m,g,u,S){const k=i.wordSeparators;if(!u&&i.simpleSearch){const C=i.simpleSearch,T=C.length,$=t.length;let w=-T;for(;(w=t.indexOf(C,w+T))!==-1;)if((!k||(0,O.$zD)(k,t,$,w,T))&&(g[m++]=new N.$lw(new P.$Ut(o,w+1+c,o,w+1+T+c),null),m>=S))return m;return m}let y;n.reset(0);do if(y=n.next(t),y&&(g[m++]=(0,O.$xD)(new P.$Ut(o,y.index+1+c,o,y.index+1+y[0].length+c),y,u),m>=S))return m;while(y);return m}insert(i,n,t=!1){if(this.f=this.f&&t,this.j.lineNumber=0,this.j.value="",this.root!==R.$mD){const{node:o,remainder:c,nodeStartOffset:m}=this.G(i),g=o.piece,u=g.bufferIndex,S=this.s(o,c);if(o.piece.bufferIndex===0&&g.end.line===this.g.line&&g.end.column===this.g.column&&m+g.length===i&&n.length<p){this.F(o,n),this.y();return}if(m===i)this.o(n,o),this.h.validate(i);else if(m+o.piece.length>i){const k=[];let y=new E(g.bufferIndex,S,g.end,this.t(g.bufferIndex,S,g.end),this.u(u,g.end)-this.u(u,S));if(this.K()&&this.M(n)&&this.I(o,c)===10){const w={line:y.start.line+1,column:0};y=new E(y.bufferIndex,w,y.end,this.t(y.bufferIndex,w,y.end),y.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(o,c-1)===13){const w=this.s(o,c-1);this.C(o,w),n="\r"+n,o.piece.length===0&&k.push(o)}else this.C(o,S);else this.C(o,S);const C=this.w(n);y.length>0&&this.S(o,y);let T=o;for(let $=0;$<C.length;$++)T=this.S(T,C[$]);this.v(k)}else this.q(n,o)}else{const o=this.w(n);let c=this.T(null,o[0]);for(let m=1;m<o.length;m++)c=this.S(c,o[m])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===R.$mD)return;const t=this.G(i),o=this.G(i+n),c=t.node,m=o.node;if(c===m){const C=this.s(c,t.remainder),T=this.s(c,o.remainder);if(t.nodeStartOffset===i){if(n===c.piece.length){const $=c.next();(0,R.$rD)(this,c),this.N($),this.y();return}this.D(c,T),this.h.validate(i),this.N(c),this.y();return}if(t.nodeStartOffset+c.piece.length===i+n){this.C(c,C),this.O(c),this.y();return}this.E(c,C,T),this.y();return}const g=[],u=this.s(c,t.remainder);this.C(c,u),this.h.validate(i),c.piece.length===0&&g.push(c);const S=this.s(m,o.remainder);this.D(m,S),m.piece.length===0&&g.push(m);const k=c.next();for(let C=k;C!==R.$mD&&C!==m;C=C.next())g.push(C);const y=c.piece.length===0?c.prev():c;this.v(g),this.O(y),this.y()}o(i,n){const t=[];if(this.K()&&this.M(i)&&this.L(n)){const m=n.piece,g={line:m.start.line+1,column:0},u=new E(m.bufferIndex,g,m.end,this.t(m.bufferIndex,g,m.end),m.length-1);n.piece=u,i+=`
`,(0,R.$tD)(this,n,-1,-1),n.piece.length===0&&t.push(n)}const o=this.w(i);let c=this.T(n,o[o.length-1]);for(let m=o.length-2;m>=0;m--)c=this.T(c,o[m]);this.N(c),this.v(t)}q(i,n){this.Q(i,n)&&(i+=`
`);const t=this.w(i),o=this.S(n,t[0]);let c=o;for(let m=1;m<t.length;m++)c=this.S(c,t[m]);this.N(o)}s(i,n,t){const o=i.piece,c=i.piece.bufferIndex,m=this.a[c].lineStarts,u=m[o.start.line]+o.start.column+n;let S=o.start.line,k=o.end.line,y=0,C=0,T=0;for(;S<=k&&(y=S+(k-S)/2|0,T=m[y],y!==k);)if(C=m[y+1],u<T)k=y-1;else if(u>=C)S=y+1;else break;return t?(t.line=y,t.column=u-T,null):{line:y,column:u-T}}t(i,n,t){if(t.column===0)return t.line-n.line;const o=this.a[i].lineStarts;if(t.line===o.length-1)return t.line-n.line;const c=o[t.line+1],m=o[t.line]+t.column;if(c>m+1)return t.line-n.line;const g=m-1;return this.a[i].buffer.charCodeAt(g)===13?t.line-n.line+1:t.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,R.$rD)(this,i[n])}w(i){if(i.length>p){const k=[];for(;i.length>p;){const C=i.charCodeAt(p-1);let T;C===v.CharCode.CarriageReturn||C>=55296&&C<=56319?(T=i.substring(0,p-1),i=i.substring(p-1)):(T=i.substring(0,p),i=i.substring(p));const $=b(T);k.push(new E(this.a.length,{line:0,column:0},{line:$.length-1,column:T.length-$[$.length-1]},$.length-1,T.length)),this.a.push(new f(T,$))}const y=b(i);return k.push(new E(this.a.length,{line:0,column:0},{line:y.length-1,column:i.length-y[y.length-1]},y.length-1,i.length)),this.a.push(new f(i,y)),k}let n=this.a[0].buffer.length;const t=b(i,!1);let o=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},o=this.g;for(let k=0;k<t.length;k++)t[k]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let k=0;k<t.length;k++)t[k]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+=i}const c=this.a[0].buffer.length,m=this.a[0].lineStarts.length-1,g=c-this.a[0].lineStarts[m],u={line:m,column:g},S=new E(0,o,u,this.t(0,o,u),c-n);return this.g=u,[S]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let t=this.root,o="";const c=this.h.get2(i);if(c){t=c.node;const m=this.B(t,i-c.nodeStartLineNumber-1),g=this.a[t.piece.bufferIndex].buffer,u=this.u(t.piece.bufferIndex,t.piece.start);if(c.nodeStartLineNumber+t.piece.lineFeedCnt===i)o=g.substring(u+m,u+t.piece.length);else{const S=this.B(t,i-c.nodeStartLineNumber);return g.substring(u+m,u+S-n)}}else{let m=0;const g=i;for(;t!==R.$mD;)if(t.left!==R.$mD&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const u=this.B(t,i-t.lf_left-2),S=this.B(t,i-t.lf_left-1),k=this.a[t.piece.bufferIndex].buffer,y=this.u(t.piece.bufferIndex,t.piece.start);return m+=t.size_left,this.h.set({node:t,nodeStartOffset:m,nodeStartLineNumber:g-(i-1-t.lf_left)}),k.substring(y+u,y+S-n)}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const u=this.B(t,i-t.lf_left-2),S=this.a[t.piece.bufferIndex].buffer,k=this.u(t.piece.bufferIndex,t.piece.start);o=S.substring(k+u,k+t.piece.length);break}else i-=t.lf_left+t.piece.lineFeedCnt,m+=t.size_left+t.piece.length,t=t.right}for(t=t.next();t!==R.$mD;){const m=this.a[t.piece.bufferIndex].buffer;if(t.piece.lineFeedCnt>0){const g=this.B(t,0),u=this.u(t.piece.bufferIndex,t.piece.start);return o+=m.substring(u,u+g-n),o}else{const g=this.u(t.piece.bufferIndex,t.piece.start);o+=m.substr(g,t.piece.length)}t=t.next()}return o}y(){let i=this.root,n=1,t=0;for(;i!==R.$mD;)n+=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=t,this.h.validate(this.c)}A(i,n){const t=i.piece,o=this.s(i,n),c=o.line-t.start.line;if(this.u(t.bufferIndex,t.end)-this.u(t.bufferIndex,t.start)===n){const m=this.t(i.piece.bufferIndex,t.start,o);if(m!==c)return{index:m,remainder:0}}return{index:c,remainder:o.column}}B(i,n){if(n<0)return 0;const t=i.piece,o=this.a[t.bufferIndex].lineStarts,c=t.start.line+n+1;return c>t.end.line?o[t.end.line]+t.end.column-o[t.start.line]-t.start.column:o[c]-o[t.start.line]-t.start.column}C(i,n){const t=i.piece,o=t.lineFeedCnt,c=this.u(t.bufferIndex,t.end),m=n,g=this.u(t.bufferIndex,m),u=this.t(t.bufferIndex,t.start,m),S=u-o,k=g-c,y=t.length+k;i.piece=new E(t.bufferIndex,t.start,m,u,y),(0,R.$tD)(this,i,k,S)}D(i,n){const t=i.piece,o=t.lineFeedCnt,c=this.u(t.bufferIndex,t.start),m=n,g=this.t(t.bufferIndex,m,t.end),u=this.u(t.bufferIndex,m),S=g-o,k=c-u,y=t.length+k;i.piece=new E(t.bufferIndex,m,t.end,g,y),(0,R.$tD)(this,i,k,S)}E(i,n,t){const o=i.piece,c=o.start,m=o.end,g=o.length,u=o.lineFeedCnt,S=n,k=this.t(o.bufferIndex,o.start,S),y=this.u(o.bufferIndex,n)-this.u(o.bufferIndex,c);i.piece=new E(o.bufferIndex,o.start,S,k,y),(0,R.$tD)(this,i,y-g,k-u);const C=new E(o.bufferIndex,t,m,this.t(o.bufferIndex,t,m),this.u(o.bufferIndex,m)-this.u(o.bufferIndex,t)),T=this.S(i,C);this.N(T)}F(i,n){this.Q(n,i)&&(n+=`
`);const t=this.K()&&this.L(n)&&this.M(i),o=this.a[0].buffer.length;this.a[0].buffer+=n;const c=b(n,!1);for(let T=0;T<c.length;T++)c[T]+=o;if(t){const T=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:o-T}}this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1));const m=this.a[0].lineStarts.length-1,g=this.a[0].buffer.length-this.a[0].lineStarts[m],u={line:m,column:g},S=i.piece.length+n.length,k=i.piece.lineFeedCnt,y=this.t(0,i.piece.start,u),C=y-k;i.piece=new E(i.piece.bufferIndex,i.piece.start,u,y,S),this.g=u,(0,R.$tD)(this,i,n.length,C)}G(i){let n=this.root;const t=this.h.get(i);if(t)return{node:t.node,nodeStartOffset:t.nodeStartOffset,remainder:i-t.nodeStartOffset};let o=0;for(;n!==R.$mD;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){o+=n.size_left;const c={node:n,remainder:i-n.size_left,nodeStartOffset:o};return this.h.set(c),c}else i-=n.size_left+n.piece.length,o+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let t=this.root,o=0;for(;t!==R.$mD;)if(t.left!==R.$mD&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const c=this.B(t,i-t.lf_left-2),m=this.B(t,i-t.lf_left-1);return o+=t.size_left,{node:t,remainder:Math.min(c+n-1,m),nodeStartOffset:o}}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const c=this.B(t,i-t.lf_left-2);if(c+n-1<=t.piece.length)return{node:t,remainder:c+n-1,nodeStartOffset:o};n-=t.piece.length-c;break}else i-=t.lf_left+t.piece.lineFeedCnt,o+=t.size_left+t.piece.length,t=t.right;for(t=t.next();t!==R.$mD;){if(t.piece.lineFeedCnt>0){const c=this.B(t,0),m=this.J(t);return{node:t,remainder:Math.min(n-1,c),nodeStartOffset:m}}else if(t.piece.length>=n-1){const c=this.J(t);return{node:t,remainder:n-1,nodeStartOffset:c}}else n-=t.piece.length;t=t.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const t=this.a[i.piece.bufferIndex],o=this.u(i.piece.bufferIndex,i.piece.start)+n;return t.buffer.charCodeAt(o)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===R.$mD||i.piece.lineFeedCnt===0)return!1;const n=i.piece,t=this.a[n.bufferIndex].lineStarts,o=n.start.line,c=t[o]+n.start.column;return o===t.length-1||t[o+1]>c+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(c)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===R.$mD||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const t=[],o=this.a[i.piece.bufferIndex].lineStarts;let c;i.piece.end.column===0?c={line:i.piece.end.line-1,column:o[i.piece.end.line]-o[i.piece.end.line-1]-1}:c={line:i.piece.end.line,column:i.piece.end.column-1};const m=i.piece.length-1,g=i.piece.lineFeedCnt-1;i.piece=new E(i.piece.bufferIndex,i.piece.start,c,g,m),(0,R.$tD)(this,i,-1,-1),i.piece.length===0&&t.push(i);const u={line:n.piece.start.line+1,column:0},S=n.piece.length-1,k=this.t(n.piece.bufferIndex,u,n.piece.end);n.piece=new E(n.piece.bufferIndex,u,n.piece.end,k,S),(0,R.$tD)(this,n,-1,-1),n.piece.length===0&&t.push(n);const y=this.w(`\r
`);this.S(i,y[0]);for(let C=0;C<t.length;C++)(0,R.$rD)(this,t[C])}Q(i,n){if(this.K()&&this.M(i)){const t=n.next();if(this.L(t)){if(i+=`
`,t.piece.length===1)(0,R.$rD)(this,t);else{const o=t.piece,c={line:o.start.line+1,column:0},m=o.length-1,g=this.t(o.bufferIndex,c,o.end);t.piece=new E(o.bufferIndex,c,o.end,g,m),(0,R.$tD)(this,t,-1,-1)}return!0}}return!1}iterate(i,n){if(i===R.$mD)return n(R.$mD);const t=this.iterate(i.left,n);return t&&n(i)&&this.iterate(i.right,n)}R(i){if(i===R.$mD)return"";const n=this.a[i.piece.bufferIndex],t=i.piece,o=this.u(t.bufferIndex,t.start),c=this.u(t.bufferIndex,t.end);return n.buffer.substring(o,c)}getPieceContent(i){const n=this.a[i.bufferIndex],t=this.u(i.bufferIndex,i.start),o=this.u(i.bufferIndex,i.end);return n.buffer.substring(t,o)}S(i,n){const t=new R.$lD(n,R.NodeColor.Red);if(t.left=R.$mD,t.right=R.$mD,t.parent=R.$mD,t.size_left=0,t.lf_left=0,this.root===R.$mD)this.root=t,t.color=R.NodeColor.Black;else if(i.right===R.$mD)i.right=t,t.parent=i;else{const c=(0,R.$nD)(i.right);c.left=t,t.parent=c}return(0,R.$sD)(this,t),t}T(i,n){const t=new R.$lD(n,R.NodeColor.Red);if(t.left=R.$mD,t.right=R.$mD,t.parent=R.$mD,t.size_left=0,t.lf_left=0,this.root===R.$mD)this.root=t,t.color=R.NodeColor.Black;else if(i.left===R.$mD)i.left=t,t.parent=i;else{const o=(0,R.$oD)(i.left);o.right=t,t.parent=o}return(0,R.$sD)(this,t),t}U(i){let n="";return this.iterate(i,t=>(n+=this.R(t),!0)),n}}e.$FD=d}),define(Re[161],Te([1,0,6,13,32,52,101,153,155,4]),function(we,e,v,D,P,N,R,O,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GD=void 0,D=qe(D);class I extends s.$Xc{constructor(h,E,f,r,l,d,a){super(),this.m=this.B(new v.$oe),this.onDidChangeContent=this.m.event,this.f=E,this.j=!d,this.g=r,this.h=l,this.c=new R.$FD(h,f,a)}equals(h){return!(h instanceof I)||this.f!==h.f||this.getEOL()!==h.getEOL()?!1:this.c.equal(h.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(h){return this.c.createSnapshot(h?this.f:"")}getOffsetAt(h,E){return this.c.getOffsetAt(h,E)}getPositionAt(h){return this.c.getPositionAt(h)}getRangeAt(h,E){const f=h+E,r=this.getPositionAt(h),l=this.getPositionAt(f);return new P.$Ut(r.lineNumber,r.column,l.lineNumber,l.column)}getValueInRange(h,E=N.EndOfLinePreference.TextDefined){if(h.isEmpty())return"";const f=this.n(E);return this.c.getValueInRange(h,f)}getValueLengthInRange(h,E=N.EndOfLinePreference.TextDefined){if(h.isEmpty())return 0;if(h.startLineNumber===h.endLineNumber)return h.endColumn-h.startColumn;const f=this.getOffsetAt(h.startLineNumber,h.startColumn),r=this.getOffsetAt(h.endLineNumber,h.endColumn);let l=0;const d=this.n(E),a=this.getEOL();if(d.length!==a.length){const i=d.length-a.length,n=h.endLineNumber-h.startLineNumber;l=i*n}return r-f+l}getCharacterCountInRange(h,E=N.EndOfLinePreference.TextDefined){if(this.j){let f=0;const r=h.startLineNumber,l=h.endLineNumber;for(let d=r;d<=l;d++){const a=this.getLineContent(d),i=d===r?h.startColumn-1:0,n=d===l?h.endColumn-1:a.length;for(let t=i;t<n;t++)D.$Mf(a.charCodeAt(t))?(f=f+1,t=t+1):f=f+1}return f+=this.n(E).length*(l-r),f}return this.getValueLengthInRange(h,E)}getNearestChunk(h){return this.c.getNearestChunk(h)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(h){return this.c.getLineContent(h)}getLineCharCode(h,E){return this.c.getLineCharCode(h,E)}getCharCode(h){return this.c.getCharCode(h)}getLineLength(h){return this.c.getLineLength(h)}getLineMinColumn(h){return 1}getLineMaxColumn(h){return this.getLineLength(h)+1}getLineFirstNonWhitespaceColumn(h){const E=D.$xf(this.getLineContent(h));return E===-1?0:E+1}getLineLastNonWhitespaceColumn(h){const E=D.$zf(this.getLineContent(h));return E===-1?0:E+2}n(h){switch(h){case N.EndOfLinePreference.LF:return`
`;case N.EndOfLinePreference.CRLF:return`\r
`;case N.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(h){this.c.setEOL(h)}applyEdits(h,E,f){let r=this.g,l=this.h,d=this.j,a=!0,i=[];for(let u=0;u<h.length;u++){const S=h[u];a&&S._isTracked&&(a=!1);const k=S.range;if(S.text){let w=!0;d||(w=!D.$Xf(S.text),d=w),!r&&w&&(r=D.$Wf(S.text)),!l&&w&&(l=D.$Zf(S.text))}let y="",C=0,T=0,$=0;if(S.text){let w;[C,T,$,w]=(0,O.$Fu)(S.text);const M=this.getEOL(),A=M===`\r
`?O.StringEOL.CRLF:O.StringEOL.LF;w===O.StringEOL.Unknown||w===A?y=S.text:y=S.text.replace(/\r\n|\r|\n/g,M)}i[u]={sortIndex:u,identifier:S.identifier||null,range:k,rangeOffset:this.getOffsetAt(k.startLineNumber,k.startColumn),rangeLength:this.getValueLengthInRange(k),text:y,eolCount:C,firstLineLength:T,lastLineLength:$,forceMoveMarkers:!!S.forceMoveMarkers,isAutoWhitespaceEdit:S.isAutoWhitespaceEdit||!1}}i.sort(I.u);let n=!1;for(let u=0,S=i.length-1;u<S;u++){const k=i[u].range.getEndPosition(),y=i[u+1].range.getStartPosition();if(y.isBeforeOrEqual(k)){if(y.isBefore(k))throw new Error("Overlapping ranges are not allowed!");n=!0}}a&&(i=this.s(i));const t=f||E?I._getInverseEditRanges(i):[],o=[];if(E)for(let u=0;u<i.length;u++){const S=i[u],k=t[u];if(S.isAutoWhitespaceEdit&&S.range.isEmpty())for(let y=k.startLineNumber;y<=k.endLineNumber;y++){let C="";y===k.startLineNumber&&(C=this.getLineContent(S.range.startLineNumber),D.$xf(C)!==-1)||o.push({lineNumber:y,oldContent:C})}}let c=null;if(f){let u=0;c=[];for(let S=0;S<i.length;S++){const k=i[S],y=t[S],C=this.getValueInRange(k.range),T=k.rangeOffset+u;u+=k.text.length-C.length,c[S]={sortIndex:k.sortIndex,identifier:k.identifier,range:y,text:C,textChange:new p.$lu(k.rangeOffset,C,T,k.text)}}n||c.sort((S,k)=>S.sortIndex-k.sortIndex)}this.g=r,this.h=l,this.j=d;const m=this.t(i);let g=null;if(E&&o.length>0){o.sort((u,S)=>S.lineNumber-u.lineNumber),g=[];for(let u=0,S=o.length;u<S;u++){const k=o[u].lineNumber;if(u>0&&o[u-1].lineNumber===k)continue;const y=o[u].oldContent,C=this.getLineContent(k);C.length===0||C===y||D.$xf(C)!==-1||g.push(k)}}return this.m.fire(),new N.$pw(c,m,g)}s(h){return h.length<1e3?h:[this._toSingleEditOperation(h)]}_toSingleEditOperation(h){let E=!1;const f=h[0].range,r=h[h.length-1].range,l=new P.$Ut(f.startLineNumber,f.startColumn,r.endLineNumber,r.endColumn);let d=f.startLineNumber,a=f.startColumn;const i=[];for(let m=0,g=h.length;m<g;m++){const u=h[m],S=u.range;E=E||u.forceMoveMarkers,i.push(this.getValueInRange(new P.$Ut(d,a,S.startLineNumber,S.startColumn))),u.text.length>0&&i.push(u.text),d=S.endLineNumber,a=S.endColumn}const n=i.join(""),[t,o,c]=(0,O.$Fu)(n);return{sortIndex:0,identifier:h[0].identifier,range:l,rangeOffset:this.getOffsetAt(l.startLineNumber,l.startColumn),rangeLength:this.getValueLengthInRange(l,N.EndOfLinePreference.TextDefined),text:n,eolCount:t,firstLineLength:o,lastLineLength:c,forceMoveMarkers:E,isAutoWhitespaceEdit:!1}}t(h){h.sort(I.w);const E=[];for(let f=0;f<h.length;f++){const r=h[f],l=r.range.startLineNumber,d=r.range.startColumn,a=r.range.endLineNumber,i=r.range.endColumn;if(l===a&&d===i&&r.text.length===0)continue;r.text?(this.c.delete(r.rangeOffset,r.rangeLength),this.c.insert(r.rangeOffset,r.text,!0)):this.c.delete(r.rangeOffset,r.rangeLength);const n=new P.$Ut(l,d,a,i);E.push({range:n,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return E}findMatchesLineByLine(h,E,f,r){return this.c.findMatchesLineByLine(h,E,f,r)}getPieceTree(){return this.c}static _getInverseEditRange(h,E){const f=h.startLineNumber,r=h.startColumn,[l,d,a]=(0,O.$Fu)(E);let i;if(E.length>0){const n=l+1;n===1?i=new P.$Ut(f,r,f,r+d):i=new P.$Ut(f,r,f+n-1,a+1)}else i=new P.$Ut(f,r,f,r);return i}static _getInverseEditRanges(h){const E=[];let f=0,r=0,l=null;for(let d=0,a=h.length;d<a;d++){const i=h[d];let n,t;l?l.range.endLineNumber===i.range.startLineNumber?(n=f,t=r+(i.range.startColumn-l.range.endColumn)):(n=f+(i.range.startLineNumber-l.range.endLineNumber),t=i.range.startColumn):(n=i.range.startLineNumber,t=i.range.startColumn);let o;if(i.text.length>0){const c=i.eolCount+1;c===1?o=new P.$Ut(n,t,n,t+i.firstLineLength):o=new P.$Ut(n,t,n+c-1,i.lastLineLength+1)}else o=new P.$Ut(n,t,n,t);f=o.endLineNumber,r=o.endColumn,E.push(o),l=i}return E}static u(h,E){const f=P.$Ut.compareRangesUsingEnds(h.range,E.range);return f===0?h.sortIndex-E.sortIndex:f}static w(h,E){const f=P.$Ut.compareRangesUsingEnds(h.range,E.range);return f===0?E.sortIndex-h.sortIndex:-f}}e.$GD=I}),define(Re[162],Te([1,0,30,13,52,101,161]),function(we,e,v,D,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HD=void 0,D=qe(D);class O{constructor(I,b,h,E,f,r,l,d,a){this.a=I,this.b=b,this.c=h,this.d=E,this.e=f,this.f=r,this.g=l,this.h=d,this.j=a}k(I){const b=this.c+this.d+this.e,h=this.c+this.e;return b===0?I===P.DefaultEndOfLine.LF?`
`:`\r
`:h>b/2?`\r
`:`
`}create(I){const b=this.k(I),h=this.a;if(this.j&&(b===`\r
`&&(this.c>0||this.d>0)||b===`
`&&(this.c>0||this.e>0)))for(let f=0,r=h.length;f<r;f++){const l=h[f].buffer.replace(/\r\n|\r|\n/g,b),d=(0,N.$BD)(l);h[f]=new N.$ED(l,d)}const E=new R.$GD(h,this.b,b,this.f,this.g,this.h,this.j);return{textBuffer:E,disposable:E}}getFirstLineText(I){return this.a[0].buffer.substr(0,I).split(/\r\n|\r|\n/)[0]}}class p{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(I){if(I.length===0)return;this.a.length===0&&D.$8f(I)&&(this.b=D.$7f,I=I.substr(1));const b=I.charCodeAt(I.length-1);b===v.CharCode.CarriageReturn||b>=55296&&b<=56319?(this.m(I.substr(0,I.length-1),!1),this.c=!0,this.d=b):(this.m(I,!1),this.c=!1,this.d=b)}m(I,b){!b&&I.length===0||(this.c?this.n(String.fromCharCode(this.d)+I):this.n(I))}n(I){const b=(0,N.$CD)(this.e,I);this.a.push(new N.$ED(I,b.lineStarts)),this.f+=b.cr,this.g+=b.lf,this.h+=b.crlf,b.isBasicASCII||(this.l=!1,this.j||(this.j=D.$Wf(I)),this.k||(this.k=D.$Zf(I)))}finish(I=!0){return this.o(),new O(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,I)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const I=this.a[this.a.length-1];I.buffer+=String.fromCharCode(this.d);const b=(0,N.$BD)(I.buffer);I.lineStarts=b,this.d===v.CharCode.CarriageReturn&&this.f++}}}e.$HD=p}),define(Re[104],Te([1,0,20,23]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oeb=p,e.$peb=I,D=qe(D);var P;(function(b){b[b.Full=1]="Full",b[b.Delta=2]="Delta"})(P||(P={}));function N(b){for(let h=0,E=b.length;h<E;h+=4){const f=b[h+0],r=b[h+1],l=b[h+2],d=b[h+3];b[h+0]=d,b[h+1]=l,b[h+2]=r,b[h+3]=f}}function R(b){const h=new Uint8Array(b.buffer,b.byteOffset,b.length*4);return D.$E()||N(h),v.$Qe.wrap(h)}function O(b){const h=b.buffer;if(D.$E()||N(h),h.byteOffset%4===0)return new Uint32Array(h.buffer,h.byteOffset,h.length/4);{const E=new Uint8Array(h.byteLength);return E.set(h),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function p(b){const h=new Uint32Array(s(b));let E=0;if(h[E++]=b.id,b.type==="full")h[E++]=P.Full,h[E++]=b.data.length,h.set(b.data,E),E+=b.data.length;else{h[E++]=P.Delta,h[E++]=b.deltas.length;for(const f of b.deltas)h[E++]=f.start,h[E++]=f.deleteCount,f.data?(h[E++]=f.data.length,h.set(f.data,E),E+=f.data.length):h[E++]=0}return R(h)}function s(b){let h=0;if(h+=2,b.type==="full")h+=1+b.data.length;else{h+=1,h+=3*b.deltas.length;for(const E of b.deltas)E.data&&(h+=E.data.length)}return h}function I(b){const h=O(b);let E=0;const f=h[E++];if(h[E++]===P.Full){const a=h[E++],i=h.subarray(E,E+a);return E+=a,{id:f,type:"full",data:i}}const l=h[E++],d=[];for(let a=0;a<l;a++){const i=h[E++],n=h[E++],t=h[E++];let o;t>0&&(o=h.subarray(E,E+t),E+=t),d[a]={start:i,deleteCount:n,data:o}}return{id:f,type:"delta",deltas:d}}}),define(Re[163],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dab=e.$cab=void 0;class v{constructor(){this.a=new Map}removeDragOperationTransfer(N){if(N&&this.a.has(N)){const R=this.a.get(N);return this.a.delete(N),R}}addDragOperationTransfer(N,R){this.a.set(N,R)}}e.$cab=v;class D{constructor(N){this.identifier=N}}e.$dab=D}),define(Re[164],Te([1,0,6,4,9]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=void 0,e.$sj=I,P=qe(P);class N extends D.$Xc{constructor(h,E="",f="",r=!0,l){super(),this.j=this.B(new v.$oe),this.onDidChange=this.j.event,this.z=!0,this.m=h,this.n=E,this.w=f,this.z=r,this.D=l}get id(){return this.m}get label(){return this.n}set label(h){this.F(h)}F(h){this.n!==h&&(this.n=h,this.j.fire({label:h}))}get tooltip(){return this.u||""}set tooltip(h){this.G(h)}G(h){this.u!==h&&(this.u=h,this.j.fire({tooltip:h}))}get class(){return this.w}set class(h){this.H(h)}H(h){this.w!==h&&(this.w=h,this.j.fire({class:h}))}get enabled(){return this.z}set enabled(h){this.I(h)}I(h){this.z!==h&&(this.z=h,this.j.fire({enabled:h}))}get checked(){return this.C}set checked(h){this.J(h)}J(h){this.C!==h&&(this.C=h,this.j.fire({checked:h}))}async run(h,E){this.D&&await this.D(h)}}e.$nj=N;class R extends D.$Xc{constructor(){super(...arguments),this.f=this.B(new v.$oe),this.onWillRun=this.f.event,this.m=this.B(new v.$oe),this.onDidRun=this.m.event}async run(h,E){if(!h.enabled)return;this.f.fire({action:h});let f;try{await this.u(h,E)}catch(r){f=r}this.m.fire({action:h,error:f})}async u(h,E){await h.run(E)}}e.$oj=R;class O{constructor(){this.id=O.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...h){let E=[];for(const f of h)f.length&&(E.length?E=[...E,new O,...f]:E=f);return E}static{this.ID="vs.actions.separator"}async run(){}}e.$pj=O;class p{get actions(){return this.a}constructor(h,E,f,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=h,this.label=E,this.class=r,this.a=f}async run(){}}e.$qj=p;class s extends N{static{this.ID="vs.actions.empty"}constructor(){super(s.ID,P.localize(41,null),void 0,!1)}}e.$rj=s;function I(b){return{id:b.id,label:b.label,tooltip:b.tooltip??b.label,class:b.class,enabled:b.enabled??!0,checked:b.checked,run:async(...h)=>b.run(...h)}}}),define(Re[165],Te([1,0,9]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=s,e.$6m=I,e.$7m=b,e.$8m=h;const D=60,P=D*60,N=P*24,R=N*7,O=N*30,p=N*365;function s(E,f,r,l){typeof E!="number"&&(E=E.getTime());const d=Math.round((new Date().getTime()-E)/1e3);if(d<-30)return(0,v.localize)(42,null,s(new Date().getTime()+d*1e3,!1));if(!l&&d<30)return(0,v.localize)(43,null);let a;return d<D?(a=d,f?a===1?r?(0,v.localize)(44,null,a):(0,v.localize)(45,null,a):r?(0,v.localize)(46,null,a):(0,v.localize)(47,null,a):a===1?r?(0,v.localize)(48,null,a):(0,v.localize)(49,null,a):r?(0,v.localize)(50,null,a):(0,v.localize)(51,null,a)):d<P?(a=Math.floor(d/D),f?a===1?r?(0,v.localize)(52,null,a):(0,v.localize)(53,null,a):r?(0,v.localize)(54,null,a):(0,v.localize)(55,null,a):a===1?r?(0,v.localize)(56,null,a):(0,v.localize)(57,null,a):r?(0,v.localize)(58,null,a):(0,v.localize)(59,null,a)):d<N?(a=Math.floor(d/P),f?a===1?r?(0,v.localize)(60,null,a):(0,v.localize)(61,null,a):r?(0,v.localize)(62,null,a):(0,v.localize)(63,null,a):a===1?r?(0,v.localize)(64,null,a):(0,v.localize)(65,null,a):r?(0,v.localize)(66,null,a):(0,v.localize)(67,null,a)):d<R?(a=Math.floor(d/N),f?a===1?(0,v.localize)(68,null,a):(0,v.localize)(69,null,a):a===1?(0,v.localize)(70,null,a):(0,v.localize)(71,null,a)):d<O?(a=Math.floor(d/R),f?a===1?r?(0,v.localize)(72,null,a):(0,v.localize)(73,null,a):r?(0,v.localize)(74,null,a):(0,v.localize)(75,null,a):a===1?r?(0,v.localize)(76,null,a):(0,v.localize)(77,null,a):r?(0,v.localize)(78,null,a):(0,v.localize)(79,null,a)):d<p?(a=Math.floor(d/O),f?a===1?r?(0,v.localize)(80,null,a):(0,v.localize)(81,null,a):r?(0,v.localize)(82,null,a):(0,v.localize)(83,null,a):a===1?r?(0,v.localize)(84,null,a):(0,v.localize)(85,null,a):r?(0,v.localize)(86,null,a):(0,v.localize)(87,null,a)):(a=Math.floor(d/p),f?a===1?r?(0,v.localize)(88,null,a):(0,v.localize)(89,null,a):r?(0,v.localize)(90,null,a):(0,v.localize)(91,null,a):a===1?r?(0,v.localize)(92,null,a):(0,v.localize)(93,null,a):r?(0,v.localize)(94,null,a):(0,v.localize)(95,null,a))}function I(E,f,r){typeof E!="number"&&(E=E.getTime());const l=new Date;l.setHours(0,0,0,0);const d=new Date(l.getTime());return d.setDate(d.getDate()-1),E>l.getTime()?(0,v.localize)(96,null):E>d.getTime()?(0,v.localize)(97,null):s(E,f,r)}function b(E,f){const r=Math.abs(E/1e3);return r<1?f?(0,v.localize)(98,null,E):(0,v.localize)(99,null,E):r<D?f?(0,v.localize)(100,null,Math.round(E)/1e3):(0,v.localize)(101,null,Math.round(E)/1e3):r<P?f?(0,v.localize)(102,null,Math.round(E/(1e3*D))):(0,v.localize)(103,null,Math.round(E/(1e3*D))):r<N?f?(0,v.localize)(104,null,Math.round(E/(1e3*P))):(0,v.localize)(105,null,Math.round(E/(1e3*P))):(0,v.localize)(106,null,Math.round(E/(1e3*N)))}function h(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Re[42],Te([1,0,17,14,9]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=p,e.$uj=s,e.$vj=I,v=qe(v),D=qe(D),P=qe(P);function N(b,h){return h&&(b.stack||b.stacktrace)?P.localize(107,null,O(b),R(b.stack)||R(b.stacktrace)):O(b)}function R(b){return Array.isArray(b)?b.join(`
`):b}function O(b){return b.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${b.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?P.localize(108,null,b.message):b.message||P.localize(109,null)}function p(b=null,h=!1){if(!b)return P.localize(110,null);if(Array.isArray(b)){const E=v.$Jb(b),f=p(E[0],h);return E.length>1?P.localize(111,null,f,E.length):f}if(D.$hg(b))return b;if(b.detail){const E=b.detail;if(E.error)return N(E.error,h);if(E.exception)return N(E.exception,h)}return b.stack?N(b,h):b.message?b.message:P.localize(112,null)}function s(b){const h=b;return h instanceof Error&&Array.isArray(h.actions)}function I(b,h){let E;return typeof b=="string"?E=new Error(b):E=b,E.actions=h,E}}),define(Re[166],Te([1,0,30,12,9]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dj=e.TokenType=void 0;var N;(function(I){I[I.LParen=0]="LParen",I[I.RParen=1]="RParen",I[I.Neg=2]="Neg",I[I.Eq=3]="Eq",I[I.NotEq=4]="NotEq",I[I.Lt=5]="Lt",I[I.LtEq=6]="LtEq",I[I.Gt=7]="Gt",I[I.GtEq=8]="GtEq",I[I.RegexOp=9]="RegexOp",I[I.RegexStr=10]="RegexStr",I[I.True=11]="True",I[I.False=12]="False",I[I.In=13]="In",I[I.Not=14]="Not",I[I.And=15]="And",I[I.Or=16]="Or",I[I.Str=17]="Str",I[I.QuotedStr=18]="QuotedStr",I[I.Error=19]="Error",I[I.EOF=20]="EOF"})(N||(e.TokenType=N={}));function R(...I){switch(I.length){case 1:return(0,P.localize)(1693,null,I[0]);case 2:return(0,P.localize)(1694,null,I[0],I[1]);case 3:return(0,P.localize)(1695,null,I[0],I[1],I[2]);default:return}}const O=(0,P.localize)(1696,null),p=(0,P.localize)(1697,null);class s{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(b){switch(b.type){case N.LParen:return"(";case N.RParen:return")";case N.Neg:return"!";case N.Eq:return b.isTripleEq?"===":"==";case N.NotEq:return b.isTripleEq?"!==":"!=";case N.Lt:return"<";case N.LtEq:return"<=";case N.Gt:return">=";case N.GtEq:return">=";case N.RegexOp:return"=~";case N.RegexStr:return b.lexeme;case N.True:return"true";case N.False:return"false";case N.In:return"in";case N.Not:return"not";case N.And:return"&&";case N.Or:return"||";case N.Str:return b.lexeme;case N.QuotedStr:return b.lexeme;case N.Error:return b.lexeme;case N.EOF:return"EOF";default:throw(0,D.$0)(`unhandled token type: ${JSON.stringify(b)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(b=>b.charCodeAt(0)))}static{this.b=new Map([["not",N.Not],["in",N.In],["false",N.False],["true",N.True]])}get errors(){return this.g}reset(b){return this.c=b,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case v.CharCode.OpenParen:this.k(N.LParen);break;case v.CharCode.CloseParen:this.k(N.RParen);break;case v.CharCode.ExclamationMark:if(this.h(v.CharCode.Equals)){const h=this.h(v.CharCode.Equals);this.f.push({type:N.NotEq,offset:this.d,isTripleEq:h})}else this.k(N.Neg);break;case v.CharCode.SingleQuote:this.o();break;case v.CharCode.Slash:this.q();break;case v.CharCode.Equals:if(this.h(v.CharCode.Equals)){const h=this.h(v.CharCode.Equals);this.f.push({type:N.Eq,offset:this.d,isTripleEq:h})}else this.h(v.CharCode.Tilde)?this.k(N.RegexOp):this.l(R("==","=~"));break;case v.CharCode.LessThan:this.k(this.h(v.CharCode.Equals)?N.LtEq:N.Lt);break;case v.CharCode.GreaterThan:this.k(this.h(v.CharCode.Equals)?N.GtEq:N.Gt);break;case v.CharCode.Ampersand:this.h(v.CharCode.Ampersand)?this.k(N.And):this.l(R("&&"));break;case v.CharCode.Pipe:this.h(v.CharCode.Pipe)?this.k(N.Or):this.l(R("||"));break;case v.CharCode.Space:case v.CharCode.CarriageReturn:case v.CharCode.Tab:case v.CharCode.LineFeed:case v.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(N.EOF),Array.from(this.f)}h(b){return this.r()||this.c.charCodeAt(this.e)!==b?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?v.CharCode.Null:this.c.charCodeAt(this.e)}k(b){this.f.push({type:b,offset:this.d})}l(b){const h=this.d,E=this.c.substring(this.d,this.e),f={type:N.Error,offset:this.d,lexeme:E};this.g.push({offset:h,lexeme:E,additionalInfo:b}),this.f.push(f)}n(){this.m.lastIndex=this.d;const b=this.m.exec(this.c);if(b){this.e=this.d+b[0].length;const h=this.c.substring(this.d,this.e),E=s.b.get(h);E?this.k(E):this.f.push({type:N.Str,lexeme:h,offset:this.d})}}o(){for(;this.j()!==v.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:N.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let b=this.e,h=!1,E=!1;for(;;){if(b>=this.c.length){this.e=b,this.l(p);return}const r=this.c.charCodeAt(b);if(h)h=!1;else if(r===v.CharCode.Slash&&!E){b++;break}else r===v.CharCode.OpenSquareBracket?E=!0:r===v.CharCode.Backslash?h=!0:r===v.CharCode.CloseSquareBracket&&(E=!1);b++}for(;b<this.c.length&&s.a.has(this.c.charCodeAt(b));)b++;this.e=b;const f=this.c.substring(this.d,this.e);this.f.push({type:N.RegexStr,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$Dj=s}),define(Re[105],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const v={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDebugCreateConfiguration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDebugCreateConfiguration.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewContainerTitle:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewContainerTitle.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:4},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookReplDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookReplDocument.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(v)}),define(Re[74],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=void 0;class v{constructor(P,N=[],R=!1){this.ctor=P,this.staticArguments=N,this.supportsDelayedInstantiation=R}}e.$Fi=v}),define(Re[60],Te([1,0,74]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Xs=N,e.$Ys=R;const D=[];var P;(function(O){O[O.Eager=0]="Eager",O[O.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function N(O,p,s){p instanceof v.$Fi||(p=new v.$Fi(p,[],!!s)),D.push([O,p])}function R(){return D}}),define(Re[167],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=e.$Ar=void 0;class v{constructor(N,R){this.key=N,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$Ar=v;class D{constructor(N){this.b=N,this.a=new Map}roots(){const N=[];for(const R of this.a.values())R.outgoing.size===0&&N.push(R);return N}insertEdge(N,R){const O=this.lookupOrInsertNode(N),p=this.lookupOrInsertNode(R);O.outgoing.set(p.key,p),p.incoming.set(O.key,O)}removeNode(N){const R=this.b(N);this.a.delete(R);for(const O of this.a.values())O.outgoing.delete(R),O.incoming.delete(R)}lookupOrInsertNode(N){const R=this.b(N);let O=this.a.get(R);return O||(O=new v(R,N),this.a.set(R,O)),O}lookup(N){return this.a.get(this.b(N))}isEmpty(){return this.a.size===0}toString(){const N=[];for(const[R,O]of this.a)N.push(`${R}
	(-> incoming)[${[...O.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...O.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,R]of this.a){const O=new Set([N]),p=this.c(R,O);if(p)return p}}c(N,R){for(const[O,p]of N.outgoing){if(R.has(O))return[...R,O].join(" -> ");R.add(O);const s=this.c(p,R);if(s)return s;R.delete(O)}}}e.$Br=D}),define(Re[3],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=e._util=void 0,e.$Ii=P,e.$Ji=N;var v;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function O(p){return p[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=O})(v||(e._util=v={})),e.$Hi=P("instantiationService");function D(R,O,p){O[v.DI_TARGET]===O?O[v.DI_DEPENDENCIES].push({id:R,index:p}):(O[v.DI_DEPENDENCIES]=[{id:R,index:p}],O[v.DI_TARGET]=O)}function P(R){if(v.serviceIds.has(R))return v.serviceIds.get(R);const O=function(p,s,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");D(O,p,I)};return O.toString=()=>R,v.serviceIds.set(R,O),O}function N(R){return R}}),define(Re[43],Te([1,0,14,2,3]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$cj=void 0,e.$dj=N,e.$ej=R,e.$fj=p,e.$gj=s,e.$hj=I,e.$ij=b,e.$jj=h,e.$kj=f,e.$lj=r,e.$mj=l,v=qe(v),e.$cj=(0,P.$Ii)("configurationService");function N(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof D.URI)}function R(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof D.URI)}var O;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(O||(e.ConfigurationTarget=O={}));function p(d){switch(d){case O.APPLICATION:return"APPLICATION";case O.USER:return"USER";case O.USER_LOCAL:return"USER_LOCAL";case O.USER_REMOTE:return"USER_REMOTE";case O.WORKSPACE:return"WORKSPACE";case O.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case O.DEFAULT:return"DEFAULT";case O.MEMORY:return"MEMORY"}}function s(d){return d.applicationValue!==void 0||d.userValue!==void 0||d.userLocalValue!==void 0||d.userRemoteValue!==void 0||d.workspaceValue!==void 0||d.workspaceFolderValue!==void 0}function I(d,a){const i=Object.create(null);for(const n in d)b(i,n,d[n],a);return i}function b(d,a,i,n){const t=a.split("."),o=t.pop();let c=d;for(let m=0;m<t.length;m++){const g=t[m];let u=c[g];switch(typeof u){case"undefined":u=c[g]=Object.create(null);break;case"object":if(u===null){n(`Ignoring ${a} as ${t.slice(0,m+1).join(".")} is null`);return}break;default:n(`Ignoring ${a} as ${t.slice(0,m+1).join(".")} is ${JSON.stringify(u)}`);return}c=u}if(typeof c=="object"&&c!==null)try{c[o]=i}catch{n(`Ignoring ${a} as ${t.join(".")} is ${JSON.stringify(c)}`)}else n(`Ignoring ${a} as ${t.join(".")} is ${JSON.stringify(c)}`)}function h(d,a){const i=a.split(".");E(d,i)}function E(d,a){const i=a.shift();if(a.length===0){delete d[i];return}if(Object.keys(d).indexOf(i)!==-1){const n=d[i];typeof n=="object"&&!Array.isArray(n)&&(E(n,a),Object.keys(n).length===0&&delete d[i])}}function f(d,a,i){function n(c,m){let g=c;for(const u of m){if(typeof g!="object"||g===null)return;g=g[u]}return g}const t=a.split("."),o=n(d,t);return typeof o>"u"?i:o}function r(d,a,i){Object.keys(a).forEach(n=>{n!=="__proto__"&&(n in d?v.$jg(d[n])&&v.$jg(a[n])?r(d[n],a[n],i):i&&(d[n]=a[n]):d[n]=a[n])})}function l(d){return d.replace(/[\[\]]/g,"")}}),define(Re[31],Te([1,0,30,23,13,166,3,9,12]),function(we,e,v,D,P,N,R,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Gj=e.$Fj=e.ContextKeyExprType=void 0,e.$Ej=I,e.$Hj=m,e.$Ij=g,e.$2j=x;const s=new Map;s.set("false",!1),s.set("true",!0),s.set("isMac",D.$k),s.set("isLinux",D.$l),s.set("isWindows",D.$j),s.set("isWeb",D.$p),s.set("isMacNative",D.$k&&!D.$p),s.set("isEdge",D.$I),s.set("isFirefox",D.$G),s.set("isChrome",D.$F),s.set("isSafari",D.$H);function I(X,q){if(s.get(X)!==void 0)throw(0,p.$9)("contextkey.setConstant(k, v) invoked with already set constant `k`");s.set(X,q)}const b=Object.prototype.hasOwnProperty;var h;(function(X){X[X.False=0]="False",X[X.True=1]="True",X[X.Defined=2]="Defined",X[X.Not=3]="Not",X[X.Equals=4]="Equals",X[X.NotEquals=5]="NotEquals",X[X.And=6]="And",X[X.Regex=7]="Regex",X[X.NotRegex=8]="NotRegex",X[X.Or=9]="Or",X[X.In=10]="In",X[X.NotIn=11]="NotIn",X[X.Greater=12]="Greater",X[X.GreaterEquals=13]="GreaterEquals",X[X.Smaller=14]="Smaller",X[X.SmallerEquals=15]="SmallerEquals"})(h||(e.ContextKeyExprType=h={}));const E={regexParsingWithErrorRecovery:!0},f=(0,O.localize)(1673,null),r=(0,O.localize)(1674,null),l=(0,O.localize)(1675,null),d=(0,O.localize)(1676,null),a=(0,O.localize)(1677,null),i=(0,O.localize)(1678,null),n=(0,O.localize)(1679,null),t=(0,O.localize)(1680,null);class o{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(q=E){this.k=q,this.d=new N.$Dj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(q){if(q===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:r});return}this.f=this.d.reset(q).scan(),this.g=0,this.h=[];try{const ne=this.l();if(!this.E()){const be=this.D(),Ie=be.type===N.TokenType.Str?i:void 0;throw this.h.push({message:a,offset:be.offset,lexeme:N.$Dj.getLexeme(be),additionalInfo:Ie}),o.c}return ne}catch(ne){if(ne!==o.c)throw ne;return}}l(){return this.m()}m(){const q=[this.o()];for(;this.y(N.TokenType.Or);){const ne=this.o();q.push(ne)}return q.length===1?q[0]:c.or(...q)}o(){const q=[this.s()];for(;this.y(N.TokenType.And);){const ne=this.s();q.push(ne)}return q.length===1?q[0]:c.and(...q)}s(){if(this.y(N.TokenType.Neg)){const q=this.D();switch(q.type){case N.TokenType.True:return this.z(),S.INSTANCE;case N.TokenType.False:return this.z(),k.INSTANCE;case N.TokenType.LParen:{this.z();const ne=this.l();return this.A(N.TokenType.RParen,d),ne?.negate()}case N.TokenType.Str:return this.z(),M.create(q.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",q)}}return this.t()}t(){const q=this.D();switch(q.type){case N.TokenType.True:return this.z(),c.true();case N.TokenType.False:return this.z(),c.false();case N.TokenType.LParen:{this.z();const ne=this.l();return this.A(N.TokenType.RParen,d),ne}case N.TokenType.Str:{const ne=q.lexeme;if(this.z(),this.y(N.TokenType.RegexOp)){const Ie=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Ie.type!==N.TokenType.RegexStr)throw this.B("REGEX",Ie);const Fe=Ie.lexeme,Be=Fe.lastIndexOf("/"),xe=Be===Fe.length-1?void 0:this.w(Fe.substring(Be+1));let nt;try{nt=new RegExp(Fe.substring(1,Be),xe)}catch{throw this.B("REGEX",Ie)}return Q.create(ne,nt)}switch(Ie.type){case N.TokenType.RegexStr:case N.TokenType.Error:{const Fe=[Ie.lexeme];this.z();let Be=this.D(),xe=0;for(let et=0;et<Ie.lexeme.length;et++)Ie.lexeme.charCodeAt(et)===v.CharCode.OpenParen?xe++:Ie.lexeme.charCodeAt(et)===v.CharCode.CloseParen&&xe--;for(;!this.E()&&Be.type!==N.TokenType.And&&Be.type!==N.TokenType.Or;){switch(Be.type){case N.TokenType.LParen:xe++;break;case N.TokenType.RParen:xe--;break;case N.TokenType.RegexStr:case N.TokenType.QuotedStr:for(let et=0;et<Be.lexeme.length;et++)Be.lexeme.charCodeAt(et)===v.CharCode.OpenParen?xe++:Ie.lexeme.charCodeAt(et)===v.CharCode.CloseParen&&xe--}if(xe<0)break;Fe.push(N.$Dj.getLexeme(Be)),this.z(),Be=this.D()}const nt=Fe.join(""),ut=nt.lastIndexOf("/"),pt=ut===nt.length-1?void 0:this.w(nt.substring(ut+1));let lt;try{lt=new RegExp(nt.substring(1,ut),pt)}catch{throw this.B("REGEX",Ie)}return c.regex(ne,lt)}case N.TokenType.QuotedStr:{const Fe=Ie.lexeme;this.z();let Be=null;if(!(0,P.$ff)(Fe)){const xe=Fe.indexOf("/"),nt=Fe.lastIndexOf("/");if(xe!==nt&&xe>=0){const ut=Fe.slice(xe+1,nt),pt=Fe[nt+1]==="i"?"i":"";try{Be=new RegExp(ut,pt)}catch{throw this.B("REGEX",Ie)}}}if(Be===null)throw this.B("REGEX",Ie);return Q.create(ne,Be)}default:throw this.B("REGEX",this.D())}}if(this.y(N.TokenType.Not)){this.A(N.TokenType.In,l);const Ie=this.u();return c.notIn(ne,Ie)}switch(this.D().type){case N.TokenType.Eq:{this.z();const Ie=this.u();if(this.x().type===N.TokenType.QuotedStr)return c.equals(ne,Ie);switch(Ie){case"true":return c.has(ne);case"false":return c.not(ne);default:return c.equals(ne,Ie)}}case N.TokenType.NotEq:{this.z();const Ie=this.u();if(this.x().type===N.TokenType.QuotedStr)return c.notEquals(ne,Ie);switch(Ie){case"true":return c.not(ne);case"false":return c.has(ne);default:return c.notEquals(ne,Ie)}}case N.TokenType.Lt:return this.z(),Y.create(ne,this.u());case N.TokenType.LtEq:return this.z(),z.create(ne,this.u());case N.TokenType.Gt:return this.z(),L.create(ne,this.u());case N.TokenType.GtEq:return this.z(),J.create(ne,this.u());case N.TokenType.In:return this.z(),c.in(ne,this.u());default:return c.has(ne)}}case N.TokenType.EOF:throw this.h.push({message:n,offset:q.offset,lexeme:"",additionalInfo:t}),o.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const q=this.D();switch(q.type){case N.TokenType.Str:case N.TokenType.QuotedStr:return this.z(),q.lexeme;case N.TokenType.True:return this.z(),"true";case N.TokenType.False:return this.z(),"false";case N.TokenType.In:return this.z(),"in";default:return""}}w(q){return q.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(q){return this.C(q)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(q,ne){if(this.C(q))return this.z();throw this.B(ne,this.D())}B(q,ne,be){const Ie=(0,O.localize)(1681,null,q,N.$Dj.getLexeme(ne)),Fe=ne.offset,Be=N.$Dj.getLexeme(ne);return this.h.push({message:Ie,offset:Fe,lexeme:Be,additionalInfo:be}),o.c}C(q){return this.D().type===q}D(){return this.f[this.g]}E(){return this.D().type===N.TokenType.EOF}}e.$Fj=o;class c{static false(){return S.INSTANCE}static true(){return k.INSTANCE}static has(q){return y.create(q)}static equals(q,ne){return C.create(q,ne)}static notEquals(q,ne){return w.create(q,ne)}static regex(q,ne){return Q.create(q,ne)}static in(q,ne){return T.create(q,ne)}static notIn(q,ne){return $.create(q,ne)}static not(q){return M.create(q)}static and(...q){return le.create(q,null,!0)}static or(...q){return _.create(q,null,!0)}static greater(q,ne){return L.create(q,ne)}static greaterEquals(q,ne){return J.create(q,ne)}static smaller(q,ne){return Y.create(q,ne)}static smallerEquals(q,ne){return z.create(q,ne)}static{this.c=new o({regexParsingWithErrorRecovery:!1})}static deserialize(q){return q==null?void 0:this.c.parse(q)}}e.$Gj=c;function m(X){const q=new o({regexParsingWithErrorRecovery:!1});return X.map(ne=>(q.parse(ne),q.lexingErrors.length>0?q.lexingErrors.map(be=>({errorMessage:be.additionalInfo?(0,O.localize)(1682,null,be.additionalInfo):(0,O.localize)(1683,null),offset:be.offset,length:be.lexeme.length})):q.parsingErrors.length>0?q.parsingErrors.map(be=>({errorMessage:be.additionalInfo?`${be.message}. ${be.additionalInfo}`:be.message,offset:be.offset,length:be.lexeme.length})):[]))}function g(X,q){const ne=X?X.substituteConstants():void 0,be=q?q.substituteConstants():void 0;return!ne&&!be?!0:!ne||!be?!1:ne.equals(be)}function u(X,q){return X.cmp(q)}class S{static{this.INSTANCE=new S}constructor(){this.type=h.False}cmp(q){return this.type-q.type}equals(q){return q.type===this.type}substituteConstants(){return this}evaluate(q){return!1}serialize(){return"false"}keys(){return[]}map(q){return this}negate(){return k.INSTANCE}}e.$Jj=S;class k{static{this.INSTANCE=new k}constructor(){this.type=h.True}cmp(q){return this.type-q.type}equals(q){return q.type===this.type}substituteConstants(){return this}evaluate(q){return!0}serialize(){return"true"}keys(){return[]}map(q){return this}negate(){return S.INSTANCE}}e.$Kj=k;class y{static create(q,ne=null){const be=s.get(q);return typeof be=="boolean"?be?k.INSTANCE:S.INSTANCE:new y(q,ne)}constructor(q,ne){this.key=q,this.c=ne,this.type=h.Defined}cmp(q){return q.type!==this.type?this.type-q.type:re(this.key,q.key)}equals(q){return q.type===this.type?this.key===q.key:!1}substituteConstants(){const q=s.get(this.key);return typeof q=="boolean"?q?k.INSTANCE:S.INSTANCE:this}evaluate(q){return!!q.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(q){return q.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$Lj=y;class C{static create(q,ne,be=null){if(typeof ne=="boolean")return ne?y.create(q,be):M.create(q,be);const Ie=s.get(q);return typeof Ie=="boolean"?ne===(Ie?"true":"false")?k.INSTANCE:S.INSTANCE:new C(q,ne,be)}constructor(q,ne,be){this.c=q,this.d=ne,this.f=be,this.type=h.Equals}cmp(q){return q.type!==this.type?this.type-q.type:ce(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){const q=s.get(this.c);if(typeof q=="boolean"){const ne=q?"true":"false";return this.d===ne?k.INSTANCE:S.INSTANCE}return this}evaluate(q){return q.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(q){return q.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.$Mj=C;class T{static create(q,ne){return new T(q,ne)}constructor(q,ne){this.d=q,this.f=ne,this.type=h.In,this.c=null}cmp(q){return q.type!==this.type?this.type-q.type:ce(this.d,this.f,q.d,q.f)}equals(q){return q.type===this.type?this.d===q.d&&this.f===q.f:!1}substituteConstants(){return this}evaluate(q){const ne=q.getValue(this.f),be=q.getValue(this.d);return Array.isArray(ne)?ne.includes(be):typeof be=="string"&&typeof ne=="object"&&ne!==null?b.call(ne,be):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(q){return q.mapIn(this.d,this.f)}negate(){return this.c||(this.c=$.create(this.d,this.f)),this.c}}e.$Nj=T;class ${static create(q,ne){return new $(q,ne)}constructor(q,ne){this.d=q,this.f=ne,this.type=h.NotIn,this.c=T.create(q,ne)}cmp(q){return q.type!==this.type?this.type-q.type:this.c.cmp(q.c)}equals(q){return q.type===this.type?this.c.equals(q.c):!1}substituteConstants(){return this}evaluate(q){return!this.c.evaluate(q)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(q){return q.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Oj=$;class w{static create(q,ne,be=null){if(typeof ne=="boolean")return ne?M.create(q,be):y.create(q,be);const Ie=s.get(q);return typeof Ie=="boolean"?ne===(Ie?"true":"false")?S.INSTANCE:k.INSTANCE:new w(q,ne,be)}constructor(q,ne,be){this.c=q,this.d=ne,this.f=be,this.type=h.NotEquals}cmp(q){return q.type!==this.type?this.type-q.type:ce(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){const q=s.get(this.c);if(typeof q=="boolean"){const ne=q?"true":"false";return this.d===ne?S.INSTANCE:k.INSTANCE}return this}evaluate(q){return q.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(q){return q.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$Pj=w;class M{static create(q,ne=null){const be=s.get(q);return typeof be=="boolean"?be?S.INSTANCE:k.INSTANCE:new M(q,ne)}constructor(q,ne){this.c=q,this.d=ne,this.type=h.Not}cmp(q){return q.type!==this.type?this.type-q.type:re(this.c,q.c)}equals(q){return q.type===this.type?this.c===q.c:!1}substituteConstants(){const q=s.get(this.c);return typeof q=="boolean"?q?S.INSTANCE:k.INSTANCE:this}evaluate(q){return!q.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(q){return q.mapNot(this.c)}negate(){return this.d||(this.d=y.create(this.c,this)),this.d}}e.$Qj=M;function A(X,q){if(typeof X=="string"){const ne=parseFloat(X);isNaN(ne)||(X=ne)}return typeof X=="string"||typeof X=="number"?q(X):S.INSTANCE}class L{static create(q,ne,be=null){return A(ne,Ie=>new L(q,Ie,be))}constructor(q,ne,be){this.c=q,this.d=ne,this.f=be,this.type=h.Greater}cmp(q){return q.type!==this.type?this.type-q.type:ce(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(q){return q.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Rj=L;class J{static create(q,ne,be=null){return A(ne,Ie=>new J(q,Ie,be))}constructor(q,ne,be){this.c=q,this.d=ne,this.f=be,this.type=h.GreaterEquals}cmp(q){return q.type!==this.type?this.type-q.type:ce(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(q){return q.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.$Sj=J;class Y{static create(q,ne,be=null){return A(ne,Ie=>new Y(q,Ie,be))}constructor(q,ne,be){this.c=q,this.d=ne,this.f=be,this.type=h.Smaller}cmp(q){return q.type!==this.type?this.type-q.type:ce(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(q){return q.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=J.create(this.c,this.d,this)),this.f}}e.$Tj=Y;class z{static create(q,ne,be=null){return A(ne,Ie=>new z(q,Ie,be))}constructor(q,ne,be){this.c=q,this.d=ne,this.f=be,this.type=h.SmallerEquals}cmp(q){return q.type!==this.type?this.type-q.type:ce(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(q){return q.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$Uj=z;class Q{static create(q,ne){return new Q(q,ne)}constructor(q,ne){this.d=q,this.f=ne,this.type=h.Regex,this.c=null}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.d<q.d)return-1;if(this.d>q.d)return 1;const ne=this.f?this.f.source:"",be=q.f?q.f.source:"";return ne<be?-1:ne>be?1:0}equals(q){if(q.type===this.type){const ne=this.f?this.f.source:"",be=q.f?q.f.source:"";return this.d===q.d&&ne===be}return!1}substituteConstants(){return this}evaluate(q){const ne=q.getValue(this.d);return this.f?this.f.test(ne):!1}serialize(){const q=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${q}`}keys(){return[this.d]}map(q){return q.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=V.create(this)),this.c}}e.$Vj=Q;class V{static create(q){return new V(q)}constructor(q){this.c=q,this.type=h.NotRegex}cmp(q){return q.type!==this.type?this.type-q.type:this.c.cmp(q.c)}equals(q){return q.type===this.type?this.c.equals(q.c):!1}substituteConstants(){return this}evaluate(q){return!this.c.evaluate(q)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(q){return new V(this.c.map(q))}negate(){return this.c}}e.$Wj=V;function ie(X){let q=null;for(let ne=0,be=X.length;ne<be;ne++){const Ie=X[ne].substituteConstants();if(X[ne]!==Ie&&q===null){q=[];for(let Fe=0;Fe<ne;Fe++)q[Fe]=X[Fe]}q!==null&&(q[ne]=Ie)}return q===null?X:q}class le{static create(q,ne,be){return le.d(q,ne,be)}constructor(q,ne){this.expr=q,this.c=ne,this.type=h.And}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.expr.length<q.expr.length)return-1;if(this.expr.length>q.expr.length)return 1;for(let ne=0,be=this.expr.length;ne<be;ne++){const Ie=u(this.expr[ne],q.expr[ne]);if(Ie!==0)return Ie}return 0}equals(q){if(q.type===this.type){if(this.expr.length!==q.expr.length)return!1;for(let ne=0,be=this.expr.length;ne<be;ne++)if(!this.expr[ne].equals(q.expr[ne]))return!1;return!0}return!1}substituteConstants(){const q=ie(this.expr);return q===this.expr?this:le.create(q,this.c,!1)}evaluate(q){for(let ne=0,be=this.expr.length;ne<be;ne++)if(!this.expr[ne].evaluate(q))return!1;return!0}static d(q,ne,be){const Ie=[];let Fe=!1;for(const Be of q)if(Be){if(Be.type===h.True){Fe=!0;continue}if(Be.type===h.False)return S.INSTANCE;if(Be.type===h.And){Ie.push(...Be.expr);continue}Ie.push(Be)}if(Ie.length===0&&Fe)return k.INSTANCE;if(Ie.length!==0){if(Ie.length===1)return Ie[0];Ie.sort(u);for(let Be=1;Be<Ie.length;Be++)Ie[Be-1].equals(Ie[Be])&&(Ie.splice(Be,1),Be--);if(Ie.length===1)return Ie[0];for(;Ie.length>1;){const Be=Ie[Ie.length-1];if(Be.type!==h.Or)break;Ie.pop();const xe=Ie.pop(),nt=Ie.length===0,ut=_.create(Be.expr.map(pt=>le.create([pt,xe],null,be)),null,nt);ut&&(Ie.push(ut),Ie.sort(u))}if(Ie.length===1)return Ie[0];if(be){for(let Be=0;Be<Ie.length;Be++)for(let xe=Be+1;xe<Ie.length;xe++)if(Ie[Be].negate().equals(Ie[xe]))return S.INSTANCE;if(Ie.length===1)return Ie[0]}return new le(Ie,ne)}}serialize(){return this.expr.map(q=>q.serialize()).join(" && ")}keys(){const q=[];for(const ne of this.expr)q.push(...ne.keys());return q}map(q){return new le(this.expr.map(ne=>ne.map(q)),null)}negate(){if(!this.c){const q=[];for(const ne of this.expr)q.push(ne.negate());this.c=_.create(q,this,!0)}return this.c}}e.$Xj=le;class _{static create(q,ne,be){return _.d(q,ne,be)}constructor(q,ne){this.expr=q,this.c=ne,this.type=h.Or}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.expr.length<q.expr.length)return-1;if(this.expr.length>q.expr.length)return 1;for(let ne=0,be=this.expr.length;ne<be;ne++){const Ie=u(this.expr[ne],q.expr[ne]);if(Ie!==0)return Ie}return 0}equals(q){if(q.type===this.type){if(this.expr.length!==q.expr.length)return!1;for(let ne=0,be=this.expr.length;ne<be;ne++)if(!this.expr[ne].equals(q.expr[ne]))return!1;return!0}return!1}substituteConstants(){const q=ie(this.expr);return q===this.expr?this:_.create(q,this.c,!1)}evaluate(q){for(let ne=0,be=this.expr.length;ne<be;ne++)if(this.expr[ne].evaluate(q))return!0;return!1}static d(q,ne,be){let Ie=[],Fe=!1;if(q){for(let Be=0,xe=q.length;Be<xe;Be++){const nt=q[Be];if(nt){if(nt.type===h.False){Fe=!0;continue}if(nt.type===h.True)return k.INSTANCE;if(nt.type===h.Or){Ie=Ie.concat(nt.expr);continue}Ie.push(nt)}}if(Ie.length===0&&Fe)return S.INSTANCE;Ie.sort(u)}if(Ie.length!==0){if(Ie.length===1)return Ie[0];for(let Be=1;Be<Ie.length;Be++)Ie[Be-1].equals(Ie[Be])&&(Ie.splice(Be,1),Be--);if(Ie.length===1)return Ie[0];if(be){for(let Be=0;Be<Ie.length;Be++)for(let xe=Be+1;xe<Ie.length;xe++)if(Ie[Be].negate().equals(Ie[xe]))return k.INSTANCE;if(Ie.length===1)return Ie[0]}return new _(Ie,ne)}}serialize(){return this.expr.map(q=>q.serialize()).join(" || ")}keys(){const q=[];for(const ne of this.expr)q.push(...ne.keys());return q}map(q){return new _(this.expr.map(ne=>ne.map(q)),null)}negate(){if(!this.c){const q=[];for(const ne of this.expr)q.push(ne.negate());for(;q.length>1;){const ne=q.shift(),be=q.shift(),Ie=[];for(const Fe of Pe(ne))for(const Be of Pe(be))Ie.push(le.create([Fe,Be],null,!1));q.unshift(_.create(Ie,null,!1))}this.c=_.create(q,this,!0)}return this.c}}e.$Yj=_;class oe extends y{static{this.d=[]}static all(){return oe.d.values()}constructor(q,ne,be){super(q,null),this.f=ne,typeof be=="object"?oe.d.push({...be,key:q}):be!==!0&&oe.d.push({key:q,description:be,type:ne!=null?typeof ne:void 0})}bindTo(q){return q.createKey(this.key,this.f)}getValue(q){return q.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(q){return C.create(this.key,q)}notEqualsTo(q){return w.create(this.key,q)}}e.$Zj=oe,e.$1j=(0,R.$Ii)("contextKeyService");function re(X,q){return X<q?-1:X>q?1:0}function ce(X,q,ne,be){return X<ne?-1:X>ne?1:q<be?-1:q>be?1:0}function x(X,q){if(X.type===h.False||q.type===h.True)return!0;if(X.type===h.Or)return q.type===h.Or?$e(X.expr,q.expr):!1;if(q.type===h.Or){for(const ne of q.expr)if(x(X,ne))return!0;return!1}if(X.type===h.And){if(q.type===h.And)return $e(q.expr,X.expr);for(const ne of X.expr)if(x(ne,q))return!0;return!1}return X.equals(q)}function $e(X,q){let ne=0,be=0;for(;ne<X.length&&be<q.length;){const Ie=X[ne].cmp(q[be]);if(Ie<0)return!1;Ie===0&&ne++,be++}return ne===X.length}function Pe(X){return X.type===h.Or?X.expr:[X]}}),define(Re[168],Te([1,0,31,3]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$At=e.$yt=e.AccessibilitySupport=e.$xt=void 0,e.$zt=N,e.$xt=(0,D.$Ii)("accessibilityService");var P;(function(R){R[R.Unknown=0]="Unknown",R[R.Disabled=1]="Disabled",R[R.Enabled=2]="Enabled"})(P||(e.AccessibilitySupport=P={})),e.$yt=new v.$Zj("accessibilityModeEnabled",!1);function N(R){return R&&typeof R=="object"&&typeof R.label=="string"&&(typeof R.role>"u"||typeof R.role=="string")}e.$At="ACCESSIBLE_VIEW_SHOWN_"}),define(Re[106],Te([1,0,17,25,23,147,280,156,169,9,168]),function(we,e,v,D,P,N,R,O,p,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=i,e.clampedInt=t,e.clampedFloat=c,e.stringSet=u,e.cursorStyleToString=A,e.filterValidationDecorations=Me,v=qe(v),D=qe(D),P=qe(P),s=qe(s);var b;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})(b||(e.EditorAutoIndentStrategy=b={})),e.MINIMAP_GUTTER_WIDTH=8;class h{constructor(W){this.c=W}hasChanged(W){return this.c[W]}}e.ConfigurationChangedEvent=h;class E{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=E;class f{constructor(W,de,je,Qe){this.id=W,this.name=de,this.defaultValue=je,this.schema=Qe}applyUpdate(W,de){return l(W,de)}compute(W,de,je){return je}}class r{constructor(W,de){this.newValue=W,this.didChange=de}}e.ApplyUpdateResult=r;function l(Z,W){if(typeof Z!="object"||typeof W!="object"||!Z||!W)return new r(W,Z!==W);if(Array.isArray(Z)||Array.isArray(W)){const je=Array.isArray(Z)&&Array.isArray(W)&&v.$wb(Z,W);return new r(W,!je)}let de=!1;for(const je in W)if(W.hasOwnProperty(je)){const Qe=l(Z[je],W[je]);Qe.didChange&&(Z[je]=Qe.newValue,de=!0)}return new r(Z,de)}class d{constructor(W){this.schema=void 0,this.id=W,this.name="_never_",this.defaultValue=void 0}applyUpdate(W,de){return l(W,de)}validate(W){return this.defaultValue}}class a{constructor(W,de,je,Qe){this.id=W,this.name=de,this.defaultValue=je,this.schema=Qe}applyUpdate(W,de){return l(W,de)}validate(W){return typeof W>"u"?this.defaultValue:W}compute(W,de,je){return je}}function i(Z,W){return typeof Z>"u"?W:Z==="false"?!1:!!Z}class n extends a{constructor(W,de,je,Qe=void 0){typeof Qe<"u"&&(Qe.type="boolean",Qe.default=je),super(W,de,je,Qe)}validate(W){return i(W,this.defaultValue)}}function t(Z,W,de,je){if(typeof Z>"u")return W;let Qe=parseInt(Z,10);return isNaN(Qe)?W:(Qe=Math.max(de,Qe),Qe=Math.min(je,Qe),Qe|0)}class o extends a{static clampedInt(W,de,je,Qe){return t(W,de,je,Qe)}constructor(W,de,je,Qe,st,ht=void 0){typeof ht<"u"&&(ht.type="integer",ht.default=je,ht.minimum=Qe,ht.maximum=st),super(W,de,je,ht),this.minimum=Qe,this.maximum=st}validate(W){return o.clampedInt(W,this.defaultValue,this.minimum,this.maximum)}}function c(Z,W,de,je){if(typeof Z>"u")return W;const Qe=m.float(Z,W);return m.clamp(Qe,de,je)}class m extends a{static clamp(W,de,je){return W<de?de:W>je?je:W}static float(W,de){if(typeof W=="number")return W;if(typeof W>"u")return de;const je=parseFloat(W);return isNaN(je)?de:je}constructor(W,de,je,Qe,st){typeof st<"u"&&(st.type="number",st.default=je),super(W,de,je,st),this.validationFn=Qe}validate(W){return this.validationFn(m.float(W,this.defaultValue))}}class g extends a{static string(W,de){return typeof W!="string"?de:W}constructor(W,de,je,Qe=void 0){typeof Qe<"u"&&(Qe.type="string",Qe.default=je),super(W,de,je,Qe)}validate(W){return g.string(W,this.defaultValue)}}function u(Z,W,de,je){return typeof Z!="string"?W:je&&Z in je?je[Z]:de.indexOf(Z)===-1?W:Z}class S extends a{constructor(W,de,je,Qe,st=void 0){typeof st<"u"&&(st.type="string",st.enum=Qe,st.default=je),super(W,de,je,st),this.c=Qe}validate(W){return u(W,this.defaultValue,this.c)}}class k extends f{constructor(W,de,je,Qe,st,ht,gt=void 0){typeof gt<"u"&&(gt.type="string",gt.enum=st,gt.default=Qe),super(W,de,je,gt),this.c=st,this.d=ht}validate(W){return typeof W!="string"?this.defaultValue:this.c.indexOf(W)===-1?this.defaultValue:this.d(W)}}function y(Z){switch(Z){case"none":return b.None;case"keep":return b.Keep;case"brackets":return b.Brackets;case"advanced":return b.Advanced;case"full":return b.Full}}class C extends f{constructor(){super(ve.accessibilitySupport,"accessibilitySupport",I.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[s.localize(302,null),s.localize(303,null),s.localize(304,null)],default:"auto",tags:["accessibility"],description:s.localize(305,null)})}validate(W){switch(W){case"auto":return I.AccessibilitySupport.Unknown;case"off":return I.AccessibilitySupport.Disabled;case"on":return I.AccessibilitySupport.Enabled}return this.defaultValue}compute(W,de,je){return je===I.AccessibilitySupport.Unknown?W.accessibilitySupport:je}}class T extends f{constructor(){const W={insertSpace:!0,ignoreEmptyLines:!0};super(ve.comments,"comments",W,{"editor.comments.insertSpace":{type:"boolean",default:W.insertSpace,description:s.localize(306,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:W.ignoreEmptyLines,description:s.localize(307,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{insertSpace:i(de.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:i(de.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var $;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})($||(e.TextEditorCursorBlinkingStyle=$={}));function w(Z){switch(Z){case"blink":return $.Blink;case"smooth":return $.Smooth;case"phase":return $.Phase;case"expand":return $.Expand;case"solid":return $.Solid}}var M;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(M||(e.TextEditorCursorStyle=M={}));function A(Z){switch(Z){case M.Line:return"line";case M.Block:return"block";case M.Underline:return"underline";case M.LineThin:return"line-thin";case M.BlockOutline:return"block-outline";case M.UnderlineThin:return"underline-thin"}}function L(Z){switch(Z){case"line":return M.Line;case"block":return M.Block;case"underline":return M.Underline;case"line-thin":return M.LineThin;case"block-outline":return M.BlockOutline;case"underline-thin":return M.UnderlineThin}}class J extends d{constructor(){super(ve.editorClassName)}compute(W,de,je){const Qe=["monaco-editor"];return de.get(ve.extraEditorClassName)&&Qe.push(de.get(ve.extraEditorClassName)),W.extraEditorClassName&&Qe.push(W.extraEditorClassName),de.get(ve.mouseStyle)==="default"?Qe.push("mouse-default"):de.get(ve.mouseStyle)==="copy"&&Qe.push("mouse-copy"),de.get(ve.showUnused)&&Qe.push("showUnused"),de.get(ve.showDeprecated)&&Qe.push("showDeprecated"),Qe.join(" ")}}class Y extends n{constructor(){super(ve.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:s.localize(308,null)})}compute(W,de,je){return je&&W.emptySelectionClipboard}}class z extends f{constructor(){const W={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(ve.find,"find",W,{"editor.find.cursorMoveOnType":{type:"boolean",default:W.cursorMoveOnType,description:s.localize(309,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:W.seedSearchStringFromSelection,enumDescriptions:[s.localize(310,null),s.localize(311,null),s.localize(312,null)],description:s.localize(313,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:W.autoFindInSelection,enumDescriptions:[s.localize(314,null),s.localize(315,null),s.localize(316,null)],description:s.localize(317,null)},"editor.find.globalFindClipboard":{type:"boolean",default:W.globalFindClipboard,description:s.localize(318,null),included:P.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:W.addExtraSpaceOnTop,description:s.localize(319,null)},"editor.find.loop":{type:"boolean",default:W.loop,description:s.localize(320,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{cursorMoveOnType:i(de.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof W.seedSearchStringFromSelection=="boolean"?W.seedSearchStringFromSelection?"always":"never":u(de.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof W.autoFindInSelection=="boolean"?W.autoFindInSelection?"always":"never":u(de.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:i(de.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:i(de.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:i(de.loop,this.defaultValue.loop)}}}class Q extends f{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(ve.fontLigatures,"fontLigatures",Q.OFF,{anyOf:[{type:"boolean",description:s.localize(321,null)},{type:"string",description:s.localize(322,null)}],description:s.localize(323,null),default:!1})}validate(W){return typeof W>"u"?this.defaultValue:typeof W=="string"?W==="false"||W.length===0?Q.OFF:W==="true"?Q.ON:W:W?Q.ON:Q.OFF}}e.EditorFontLigatures=Q;class V extends f{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(ve.fontVariations,"fontVariations",V.OFF,{anyOf:[{type:"boolean",description:s.localize(324,null)},{type:"string",description:s.localize(325,null)}],description:s.localize(326,null),default:!1})}validate(W){return typeof W>"u"?this.defaultValue:typeof W=="string"?W==="false"?V.OFF:W==="true"?V.TRANSLATE:W:W?V.TRANSLATE:V.OFF}compute(W,de,je){return W.fontInfo.fontVariationSettings}}e.EditorFontVariations=V;class ie extends d{constructor(){super(ve.fontInfo)}compute(W,de,je){return W.fontInfo}}class le extends a{constructor(){super(ve.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:s.localize(327,null)})}validate(W){const de=m.float(W,this.defaultValue);return de===0?e.EDITOR_FONT_DEFAULTS.fontSize:m.clamp(de,6,100)}compute(W,de,je){return W.fontInfo.fontSize}}class _ extends f{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(ve.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:_.d,maximum:_.e,errorMessage:s.localize(328,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:_.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:s.localize(329,null)})}validate(W){return W==="normal"||W==="bold"?W:String(o.clampedInt(W,e.EDITOR_FONT_DEFAULTS.fontWeight,_.d,_.e))}}class oe extends f{constructor(){const W={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",multipleTests:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:"",alternativeTestsCommand:""},de={type:"string",enum:["peek","gotoAndPeek","goto"],default:W.multiple,enumDescriptions:[s.localize(330,null),s.localize(331,null),s.localize(332,null)]},je=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(ve.gotoLocation,"gotoLocation",W,{"editor.gotoLocation.multiple":{deprecationMessage:s.localize(333,null)},"editor.gotoLocation.multipleDefinitions":{description:s.localize(334,null),...de},"editor.gotoLocation.multipleTypeDefinitions":{description:s.localize(335,null),...de},"editor.gotoLocation.multipleDeclarations":{description:s.localize(336,null),...de},"editor.gotoLocation.multipleImplementations":{description:s.localize(337,null),...de},"editor.gotoLocation.multipleReferences":{description:s.localize(338,null),...de},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:W.alternativeDefinitionCommand,enum:je,description:s.localize(339,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:W.alternativeTypeDefinitionCommand,enum:je,description:s.localize(340,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:W.alternativeDeclarationCommand,enum:je,description:s.localize(341,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:W.alternativeImplementationCommand,enum:je,description:s.localize(342,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:W.alternativeReferenceCommand,enum:je,description:s.localize(343,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{multiple:u(de.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:de.multipleDefinitions??u(de.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:de.multipleTypeDefinitions??u(de.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:de.multipleDeclarations??u(de.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:de.multipleImplementations??u(de.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:de.multipleReferences??u(de.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),multipleTests:de.multipleTests??u(de.multipleTests,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:g.string(de.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:g.string(de.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:g.string(de.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:g.string(de.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:g.string(de.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand),alternativeTestsCommand:g.string(de.alternativeTestsCommand,this.defaultValue.alternativeTestsCommand)}}}class re extends f{constructor(){const W={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(ve.hover,"hover",W,{"editor.hover.enabled":{type:"boolean",default:W.enabled,description:s.localize(344,null)},"editor.hover.delay":{type:"number",default:W.delay,minimum:0,maximum:1e4,description:s.localize(345,null)},"editor.hover.sticky":{type:"boolean",default:W.sticky,description:s.localize(346,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:W.hidingDelay,description:s.localize(347,null)},"editor.hover.above":{type:"boolean",default:W.above,description:s.localize(348,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{enabled:i(de.enabled,this.defaultValue.enabled),delay:o.clampedInt(de.delay,this.defaultValue.delay,0,1e4),sticky:i(de.sticky,this.defaultValue.sticky),hidingDelay:o.clampedInt(de.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:i(de.above,this.defaultValue.above)}}}var ce;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(ce||(e.RenderMinimap=ce={}));class x extends d{constructor(){super(ve.layoutInfo)}compute(W,de,je){return x.computeLayout(de,{memory:W.memory,outerWidth:W.outerWidth,outerHeight:W.outerHeight,isDominatedByLongLines:W.isDominatedByLongLines,lineHeight:W.fontInfo.lineHeight,viewLineCount:W.viewLineCount,lineNumbersDigitCount:W.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:W.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:W.fontInfo.maxDigitWidth,pixelRatio:W.pixelRatio,glyphMarginDecorationLaneCount:W.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(W){const de=W.height/W.lineHeight,je=Math.floor(W.paddingTop/W.lineHeight);let Qe=Math.floor(W.paddingBottom/W.lineHeight);W.scrollBeyondLastLine&&(Qe=Math.max(Qe,de-1));const st=(je+W.viewLineCount+Qe)/(W.pixelRatio*W.height),ht=Math.floor(W.viewLineCount/st);return{typicalViewportLineCount:de,extraLinesBeforeFirstLine:je,extraLinesBeyondLastLine:Qe,desiredRatio:st,minimapLineCount:ht}}static c(W,de){const je=W.outerWidth,Qe=W.outerHeight,st=W.pixelRatio;if(!W.minimap.enabled)return{renderMinimap:ce.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(st*Qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Qe};const ht=de.stableMinimapLayoutInput,gt=ht&&W.outerHeight===ht.outerHeight&&W.lineHeight===ht.lineHeight&&W.typicalHalfwidthCharacterWidth===ht.typicalHalfwidthCharacterWidth&&W.pixelRatio===ht.pixelRatio&&W.scrollBeyondLastLine===ht.scrollBeyondLastLine&&W.paddingTop===ht.paddingTop&&W.paddingBottom===ht.paddingBottom&&W.minimap.enabled===ht.minimap.enabled&&W.minimap.side===ht.minimap.side&&W.minimap.size===ht.minimap.size&&W.minimap.showSlider===ht.minimap.showSlider&&W.minimap.renderCharacters===ht.minimap.renderCharacters&&W.minimap.maxColumn===ht.minimap.maxColumn&&W.minimap.scale===ht.minimap.scale&&W.verticalScrollbarWidth===ht.verticalScrollbarWidth&&W.isViewportWrapping===ht.isViewportWrapping,Rt=W.lineHeight,Ot=W.typicalHalfwidthCharacterWidth,Qt=W.scrollBeyondLastLine,_t=W.minimap.renderCharacters;let Xe=st>=2?Math.round(W.minimap.scale*2):W.minimap.scale;const At=W.minimap.maxColumn,Ut=W.minimap.size,$t=W.minimap.side,Pt=W.verticalScrollbarWidth,ei=W.viewLineCount,ti=W.remainingWidth,Ht=W.isViewportWrapping,wt=_t?2:3;let Nt=Math.floor(st*Qe);const ai=Nt/st;let Xt=!1,Ge=!1,ii=wt*Xe,ci=Xe/st,ui=1;if(Ut==="fill"||Ut==="fit"){const{typicalViewportLineCount:ri,extraLinesBeforeFirstLine:Kt,extraLinesBeyondLastLine:Gt,desiredRatio:li,minimapLineCount:Mt}=x.computeContainedMinimapLineCount({viewLineCount:ei,scrollBeyondLastLine:Qt,paddingTop:W.paddingTop,paddingBottom:W.paddingBottom,height:Qe,lineHeight:Rt,pixelRatio:st});if(ei/Mt>1)Xt=!0,Ge=!0,Xe=1,ii=1,ci=Xe/st;else{let bt=!1,Jt=Xe+1;if(Ut==="fit"){const St=Math.ceil((Kt+ei+Gt)*ii);Ht&&gt&&ti<=de.stableFitRemainingWidth?(bt=!0,Jt=de.stableFitMaxMinimapScale):bt=St>Nt}if(Ut==="fill"||bt){Xt=!0;const St=Xe;ii=Math.min(Rt*st,Math.max(1,Math.floor(1/li))),Ht&&gt&&ti<=de.stableFitRemainingWidth&&(Jt=de.stableFitMaxMinimapScale),Xe=Math.min(Jt,Math.max(1,Math.floor(ii/wt))),Xe>St&&(ui=Math.min(2,Xe/St)),ci=Xe/st/ui,Nt=Math.ceil(Math.max(ri,Kt+ei+Gt)*ii),Ht?(de.stableMinimapLayoutInput=W,de.stableFitRemainingWidth=ti,de.stableFitMaxMinimapScale=Xe):(de.stableMinimapLayoutInput=null,de.stableFitRemainingWidth=0)}}}const Et=Math.floor(At*ci),jt=Math.min(Et,Math.max(0,Math.floor((ti-Pt-2)*ci/(Ot+ci)))+e.MINIMAP_GUTTER_WIDTH);let Lt=Math.floor(st*jt);const Bt=Lt/st;Lt=Math.floor(Lt*ui);const oi=_t?ce.Text:ce.Blocks,ni=$t==="left"?0:je-jt-Pt;return{renderMinimap:oi,minimapLeft:ni,minimapWidth:jt,minimapHeightIsEditorHeight:Xt,minimapIsSampling:Ge,minimapScale:Xe,minimapLineHeight:ii,minimapCanvasInnerWidth:Lt,minimapCanvasInnerHeight:Nt,minimapCanvasOuterWidth:Bt,minimapCanvasOuterHeight:ai}}static computeLayout(W,de){const je=de.outerWidth|0,Qe=de.outerHeight|0,st=de.lineHeight|0,ht=de.lineNumbersDigitCount|0,gt=de.typicalHalfwidthCharacterWidth,Rt=de.maxDigitWidth,Ot=de.pixelRatio,Qt=de.viewLineCount,_t=W.get(ve.wordWrapOverride2),Xe=_t==="inherit"?W.get(ve.wordWrapOverride1):_t,At=Xe==="inherit"?W.get(ve.wordWrap):Xe,Ut=W.get(ve.wordWrapColumn),$t=de.isDominatedByLongLines,Pt=W.get(ve.glyphMargin),ei=W.get(ve.lineNumbers).renderType!==et.Off,ti=W.get(ve.lineNumbersMinChars),Ht=W.get(ve.scrollBeyondLastLine),wt=W.get(ve.padding),Nt=W.get(ve.minimap),ai=W.get(ve.scrollbar),Xt=ai.verticalScrollbarSize,Ge=ai.verticalHasArrows,ii=ai.arrowSize,ci=ai.horizontalScrollbarSize,ui=W.get(ve.folding),Et=W.get(ve.showFoldingControls)!=="never";let jt=W.get(ve.lineDecorationsWidth);ui&&Et&&(jt+=16);let Lt=0;if(ei){const Zt=Math.max(ht,ti);Lt=Math.round(Zt*Rt)}let Bt=0;Pt&&(Bt=st*de.glyphMarginDecorationLaneCount);let oi=0,ni=oi+Bt,ri=ni+Lt,Kt=ri+jt;const Gt=je-Bt-Lt-jt;let li=!1,Mt=!1,Dt=-1;Xe==="inherit"&&$t?(li=!0,Mt=!0):At==="on"||At==="bounded"?Mt=!0:At==="wordWrapColumn"&&(Dt=Ut);const bt=x.c({outerWidth:je,outerHeight:Qe,lineHeight:st,typicalHalfwidthCharacterWidth:gt,pixelRatio:Ot,scrollBeyondLastLine:Ht,paddingTop:wt.top,paddingBottom:wt.bottom,minimap:Nt,verticalScrollbarWidth:Xt,viewLineCount:Qt,remainingWidth:Gt,isViewportWrapping:Mt},de.memory||new E);bt.renderMinimap!==ce.None&&bt.minimapLeft===0&&(oi+=bt.minimapWidth,ni+=bt.minimapWidth,ri+=bt.minimapWidth,Kt+=bt.minimapWidth);const Jt=Gt-bt.minimapWidth,St=Math.max(1,Math.floor((Jt-Xt-2)/gt)),hi=Ge?ii:0;return Mt&&(Dt=Math.max(1,St),At==="bounded"&&(Dt=Math.min(Dt,Ut))),{width:je,height:Qe,glyphMarginLeft:oi,glyphMarginWidth:Bt,glyphMarginDecorationLaneCount:de.glyphMarginDecorationLaneCount,lineNumbersLeft:ni,lineNumbersWidth:Lt,decorationsLeft:ri,decorationsWidth:jt,contentLeft:Kt,contentWidth:Jt,minimap:bt,viewportColumn:St,isWordWrapMinified:li,isViewportWrapping:Mt,wrappingColumn:Dt,verticalScrollbarWidth:Xt,horizontalScrollbarHeight:ci,overviewRuler:{top:hi,width:Xt,height:Qe-2*hi,right:0}}}}e.EditorLayoutInfoComputer=x;class $e extends f{constructor(){super(ve.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[s.localize(349,null),s.localize(350,null)],type:"string",enum:["simple","advanced"],default:"simple",description:s.localize(351,null)}})}validate(W){return u(W,"simple",["simple","advanced"])}compute(W,de,je){return de.get(ve.accessibilitySupport)===I.AccessibilitySupport.Enabled?"advanced":je}}var Pe;(function(Z){Z.Off="off",Z.OnCode="onCode",Z.On="on"})(Pe||(e.ShowLightbulbIconMode=Pe={}));class X extends f{constructor(){const W={enabled:Pe.OnCode};super(ve.lightbulb,"lightbulb",W,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Pe.Off,Pe.OnCode,Pe.On],default:W.enabled,enumDescriptions:[s.localize(352,null),s.localize(353,null),s.localize(354,null)],description:s.localize(355,null)}})}validate(W){return!W||typeof W!="object"?this.defaultValue:{enabled:u(W.enabled,this.defaultValue.enabled,[Pe.Off,Pe.OnCode,Pe.On])}}}class q extends f{constructor(){const W={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(ve.stickyScroll,"stickyScroll",W,{"editor.stickyScroll.enabled":{type:"boolean",default:W.enabled,description:s.localize(356,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:W.maxLineCount,minimum:1,maximum:20,description:s.localize(357,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:W.defaultModel,description:s.localize(358,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:W.scrollWithEditor,description:s.localize(359,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{enabled:i(de.enabled,this.defaultValue.enabled),maxLineCount:o.clampedInt(de.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:u(de.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:i(de.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ne extends f{constructor(){const W={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(ve.inlayHints,"inlayHints",W,{"editor.inlayHints.enabled":{type:"string",default:W.enabled,description:s.localize(360,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[s.localize(361,null),s.localize(362,null,P.$k?"Ctrl+Option":"Ctrl+Alt"),s.localize(363,null,P.$k?"Ctrl+Option":"Ctrl+Alt"),s.localize(364,null)]},"editor.inlayHints.fontSize":{type:"number",default:W.fontSize,markdownDescription:s.localize(365,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:W.fontFamily,markdownDescription:s.localize(366,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:W.padding,description:s.localize(367,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return typeof de.enabled=="boolean"&&(de.enabled=de.enabled?"on":"off"),{enabled:u(de.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:o.clampedInt(de.fontSize,this.defaultValue.fontSize,0,100),fontFamily:g.string(de.fontFamily,this.defaultValue.fontFamily),padding:i(de.padding,this.defaultValue.padding)}}}class be extends f{constructor(){super(ve.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(W){return typeof W=="string"&&/^\d+(\.\d+)?ch$/.test(W)?-parseFloat(W.substring(0,W.length-2)):o.clampedInt(W,this.defaultValue,0,1e3)}compute(W,de,je){return je<0?o.clampedInt(-je*W.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):je}}class Ie extends m{constructor(){super(ve.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,W=>m.clamp(W,0,150),{markdownDescription:s.localize(368,null)})}compute(W,de,je){return W.fontInfo.lineHeight}}class Fe extends f{constructor(){const W={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(ve.minimap,"minimap",W,{"editor.minimap.enabled":{type:"boolean",default:W.enabled,description:s.localize(369,null)},"editor.minimap.autohide":{type:"boolean",default:W.autohide,description:s.localize(370,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[s.localize(371,null),s.localize(372,null),s.localize(373,null)],default:W.size,description:s.localize(374,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:W.side,description:s.localize(375,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:W.showSlider,description:s.localize(376,null)},"editor.minimap.scale":{type:"number",default:W.scale,minimum:1,maximum:3,enum:[1,2,3],description:s.localize(377,null)},"editor.minimap.renderCharacters":{type:"boolean",default:W.renderCharacters,description:s.localize(378,null)},"editor.minimap.maxColumn":{type:"number",default:W.maxColumn,description:s.localize(379,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:W.showRegionSectionHeaders,description:s.localize(380,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:W.showMarkSectionHeaders,description:s.localize(381,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:W.sectionHeaderFontSize,description:s.localize(382,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:W.sectionHeaderLetterSpacing,description:s.localize(383,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{enabled:i(de.enabled,this.defaultValue.enabled),autohide:i(de.autohide,this.defaultValue.autohide),size:u(de.size,this.defaultValue.size,["proportional","fill","fit"]),side:u(de.side,this.defaultValue.side,["right","left"]),showSlider:u(de.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:i(de.renderCharacters,this.defaultValue.renderCharacters),scale:o.clampedInt(de.scale,1,1,3),maxColumn:o.clampedInt(de.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:i(de.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:i(de.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:m.clamp(de.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:m.clamp(de.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function Be(Z){return Z==="ctrlCmd"?P.$k?"metaKey":"ctrlKey":"altKey"}class xe extends f{constructor(){super(ve.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(384,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(385,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{top:o.clampedInt(de.top,0,0,1e3),bottom:o.clampedInt(de.bottom,0,0,1e3)}}}class nt extends f{constructor(){const W={enabled:!0,cycle:!0};super(ve.parameterHints,"parameterHints",W,{"editor.parameterHints.enabled":{type:"boolean",default:W.enabled,description:s.localize(386,null)},"editor.parameterHints.cycle":{type:"boolean",default:W.cycle,description:s.localize(387,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{enabled:i(de.enabled,this.defaultValue.enabled),cycle:i(de.cycle,this.defaultValue.cycle)}}}class ut extends d{constructor(){super(ve.pixelRatio)}compute(W,de,je){return W.pixelRatio}}class pt extends f{constructor(){super(ve.placeholder,"placeholder",void 0)}validate(W){return typeof W>"u"?this.defaultValue:typeof W=="string"?W:this.defaultValue}}class lt extends f{constructor(){const W={other:"on",comments:"off",strings:"off"},de=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[s.localize(388,null),s.localize(389,null),s.localize(390,null)]}];super(ve.quickSuggestions,"quickSuggestions",W,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:de,default:W.strings,description:s.localize(391,null)},comments:{anyOf:de,default:W.comments,description:s.localize(392,null)},other:{anyOf:de,default:W.other,description:s.localize(393,null)}},default:W,markdownDescription:s.localize(394,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=W}validate(W){if(typeof W=="boolean"){const Ot=W?"on":"off";return{comments:Ot,strings:Ot,other:Ot}}if(!W||typeof W!="object")return this.defaultValue;const{other:de,comments:je,strings:Qe}=W,st=["on","inline","off"];let ht,gt,Rt;return typeof de=="boolean"?ht=de?"on":"off":ht=u(de,this.defaultValue.other,st),typeof je=="boolean"?gt=je?"on":"off":gt=u(je,this.defaultValue.comments,st),typeof Qe=="boolean"?Rt=Qe?"on":"off":Rt=u(Qe,this.defaultValue.strings,st),{other:ht,comments:gt,strings:Rt}}}var et;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(et||(e.RenderLineNumbersType=et={}));class Ne extends f{constructor(){super(ve.lineNumbers,"lineNumbers",{renderType:et.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[s.localize(395,null),s.localize(396,null),s.localize(397,null),s.localize(398,null)],default:"on",description:s.localize(399,null)})}validate(W){let de=this.defaultValue.renderType,je=this.defaultValue.renderFn;return typeof W<"u"&&(typeof W=="function"?(de=et.Custom,je=W):W==="interval"?de=et.Interval:W==="relative"?de=et.Relative:W==="on"?de=et.On:de=et.Off),{renderType:de,renderFn:je}}}function Me(Z){const W=Z.get(ve.renderValidationDecorations);return W==="editable"?Z.get(ve.readOnly):W!=="on"}class Le extends f{constructor(){const W=[],de={type:"number",description:s.localize(400,null)};super(ve.rulers,"rulers",W,{type:"array",items:{anyOf:[de,{type:["object"],properties:{column:de,color:{type:"string",description:s.localize(401,null),format:"color-hex"}}}]},default:W,description:s.localize(402,null)})}validate(W){if(Array.isArray(W)){const de=[];for(const je of W)if(typeof je=="number")de.push({column:o.clampedInt(je,0,0,1e4),color:null});else if(je&&typeof je=="object"){const Qe=je;de.push({column:o.clampedInt(Qe.column,0,0,1e4),color:Qe.color})}return de.sort((je,Qe)=>je.column-Qe.column),de}return this.defaultValue}}class B extends f{constructor(){super(ve.readOnlyMessage,"readOnlyMessage",void 0)}validate(W){return!W||typeof W!="object"?this.defaultValue:W}}function j(Z,W){if(typeof Z!="string")return W;switch(Z){case"hidden":return N.ScrollbarVisibility.Hidden;case"visible":return N.ScrollbarVisibility.Visible;default:return N.ScrollbarVisibility.Auto}}class H extends f{constructor(){const W={vertical:N.ScrollbarVisibility.Auto,horizontal:N.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(ve.scrollbar,"scrollbar",W,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(403,null),s.localize(404,null),s.localize(405,null)],default:"auto",description:s.localize(406,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(407,null),s.localize(408,null),s.localize(409,null)],default:"auto",description:s.localize(410,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:W.verticalScrollbarSize,description:s.localize(411,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:W.horizontalScrollbarSize,description:s.localize(412,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:W.scrollByPage,description:s.localize(413,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:W.ignoreHorizontalScrollbarInContentHeight,description:s.localize(414,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W,je=o.clampedInt(de.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Qe=o.clampedInt(de.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:o.clampedInt(de.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:j(de.vertical,this.defaultValue.vertical),horizontal:j(de.horizontal,this.defaultValue.horizontal),useShadows:i(de.useShadows,this.defaultValue.useShadows),verticalHasArrows:i(de.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:i(de.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:i(de.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:i(de.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:je,horizontalSliderSize:o.clampedInt(de.horizontalSliderSize,je,0,1e3),verticalScrollbarSize:Qe,verticalSliderSize:o.clampedInt(de.verticalSliderSize,Qe,0,1e3),scrollByPage:i(de.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:i(de.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class G extends f{constructor(){const W={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(ve.unicodeHighlighting,"unicodeHighlight",W,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:W.nonBasicASCII,description:s.localize(415,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:W.invisibleCharacters,description:s.localize(416,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:W.ambiguousCharacters,description:s.localize(417,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:W.includeComments,description:s.localize(418,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:W.includeStrings,description:s.localize(419,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:W.allowedCharacters,description:s.localize(420,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:W.allowedLocales,description:s.localize(421,null)}})}applyUpdate(W,de){let je=!1;de.allowedCharacters&&W&&(D.$mo(W.allowedCharacters,de.allowedCharacters)||(W={...W,allowedCharacters:de.allowedCharacters},je=!0)),de.allowedLocales&&W&&(D.$mo(W.allowedLocales,de.allowedLocales)||(W={...W,allowedLocales:de.allowedLocales},je=!0));const Qe=super.applyUpdate(W,de);return je?new r(Qe.newValue,!0):Qe}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{nonBasicASCII:Je(de.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:i(de.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:i(de.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Je(de.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Je(de.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(W.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(W.allowedLocales,this.defaultValue.allowedLocales)}}c(W,de){if(typeof W!="object"||!W)return de;const je={};for(const[Qe,st]of Object.entries(W))st===!0&&(je[Qe]=!0);return je}}class se extends f{constructor(){const W={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(ve.inlineSuggest,"inlineSuggest",W,{"editor.inlineSuggest.enabled":{type:"boolean",default:W.enabled,description:s.localize(422,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:W.showToolbar,enum:["always","onHover","never"],enumDescriptions:[s.localize(423,null),s.localize(424,null),s.localize(425,null)],description:s.localize(426,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:W.suppressSuggestions,description:s.localize(427,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:W.fontFamily,description:s.localize(428,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{enabled:i(de.enabled,this.defaultValue.enabled),mode:u(de.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:u(de.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:i(de.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:i(de.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:g.string(de.fontFamily,this.defaultValue.fontFamily)}}}class ge extends f{constructor(){const W={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1};super(ve.inlineEdit,"experimentalInlineEdit",W,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:W.enabled,description:s.localize(429,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:W.showToolbar,enum:["always","onHover","never"],enumDescriptions:[s.localize(430,null),s.localize(431,null),s.localize(432,null)],description:s.localize(433,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:W.fontFamily,description:s.localize(434,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{enabled:i(de.enabled,this.defaultValue.enabled),showToolbar:u(de.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:g.string(de.fontFamily,this.defaultValue.fontFamily),keepOnBlur:i(de.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Ee extends f{constructor(){const W={enabled:O.$rt.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:O.$rt.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(ve.bracketPairColorization,"bracketPairColorization",W,{"editor.bracketPairColorization.enabled":{type:"boolean",default:W.enabled,markdownDescription:s.localize(435,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:W.independentColorPoolPerBracketType,description:s.localize(436,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{enabled:i(de.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:i(de.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Ue extends f{constructor(){const W={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(ve.guides,"guides",W,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(437,null),s.localize(438,null),s.localize(439,null)],default:W.bracketPairs,description:s.localize(440,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(441,null),s.localize(442,null),s.localize(443,null)],default:W.bracketPairsHorizontal,description:s.localize(444,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:W.highlightActiveBracketPair,description:s.localize(445,null)},"editor.guides.indentation":{type:"boolean",default:W.indentation,description:s.localize(446,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[s.localize(447,null),s.localize(448,null),s.localize(449,null)],default:W.highlightActiveIndentation,description:s.localize(450,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{bracketPairs:Je(de.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Je(de.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:i(de.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:i(de.indentation,this.defaultValue.indentation),highlightActiveIndentation:Je(de.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Je(Z,W,de){const je=de.indexOf(Z);return je===-1?W:de[je]}class _e extends f{constructor(){const W={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(ve.suggest,"suggest",W,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[s.localize(451,null),s.localize(452,null)],default:W.insertMode,description:s.localize(453,null)},"editor.suggest.filterGraceful":{type:"boolean",default:W.filterGraceful,description:s.localize(454,null)},"editor.suggest.localityBonus":{type:"boolean",default:W.localityBonus,description:s.localize(455,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:W.shareSuggestSelections,markdownDescription:s.localize(456,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[s.localize(457,null),s.localize(458,null),s.localize(459,null),s.localize(460,null)],default:W.selectionMode,markdownDescription:s.localize(461,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:W.snippetsPreventQuickSuggestions,description:s.localize(462,null)},"editor.suggest.showIcons":{type:"boolean",default:W.showIcons,description:s.localize(463,null)},"editor.suggest.showStatusBar":{type:"boolean",default:W.showStatusBar,description:s.localize(464,null)},"editor.suggest.preview":{type:"boolean",default:W.preview,description:s.localize(465,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:W.showInlineDetails,description:s.localize(466,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:s.localize(467,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:s.localize(468,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:s.localize(469,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:s.localize(470,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:s.localize(471,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:s.localize(472,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:s.localize(473,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:s.localize(474,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:s.localize(475,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:s.localize(476,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:s.localize(477,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:s.localize(478,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:s.localize(479,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:s.localize(480,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:s.localize(481,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:s.localize(482,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:s.localize(483,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:s.localize(484,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:s.localize(485,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:s.localize(486,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:s.localize(487,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:s.localize(488,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:s.localize(489,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:s.localize(490,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:s.localize(491,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:s.localize(492,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:s.localize(493,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:s.localize(494,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:s.localize(495,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:s.localize(496,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:s.localize(497,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:s.localize(498,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{insertMode:u(de.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:i(de.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:i(de.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:i(de.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:i(de.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:u(de.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:i(de.showIcons,this.defaultValue.showIcons),showStatusBar:i(de.showStatusBar,this.defaultValue.showStatusBar),preview:i(de.preview,this.defaultValue.preview),previewMode:u(de.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:i(de.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:i(de.showMethods,this.defaultValue.showMethods),showFunctions:i(de.showFunctions,this.defaultValue.showFunctions),showConstructors:i(de.showConstructors,this.defaultValue.showConstructors),showDeprecated:i(de.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:i(de.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:i(de.showFields,this.defaultValue.showFields),showVariables:i(de.showVariables,this.defaultValue.showVariables),showClasses:i(de.showClasses,this.defaultValue.showClasses),showStructs:i(de.showStructs,this.defaultValue.showStructs),showInterfaces:i(de.showInterfaces,this.defaultValue.showInterfaces),showModules:i(de.showModules,this.defaultValue.showModules),showProperties:i(de.showProperties,this.defaultValue.showProperties),showEvents:i(de.showEvents,this.defaultValue.showEvents),showOperators:i(de.showOperators,this.defaultValue.showOperators),showUnits:i(de.showUnits,this.defaultValue.showUnits),showValues:i(de.showValues,this.defaultValue.showValues),showConstants:i(de.showConstants,this.defaultValue.showConstants),showEnums:i(de.showEnums,this.defaultValue.showEnums),showEnumMembers:i(de.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:i(de.showKeywords,this.defaultValue.showKeywords),showWords:i(de.showWords,this.defaultValue.showWords),showColors:i(de.showColors,this.defaultValue.showColors),showFiles:i(de.showFiles,this.defaultValue.showFiles),showReferences:i(de.showReferences,this.defaultValue.showReferences),showFolders:i(de.showFolders,this.defaultValue.showFolders),showTypeParameters:i(de.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:i(de.showSnippets,this.defaultValue.showSnippets),showUsers:i(de.showUsers,this.defaultValue.showUsers),showIssues:i(de.showIssues,this.defaultValue.showIssues)}}}class tt extends f{constructor(){super(ve.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:s.localize(499,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:s.localize(500,null),default:!0,type:"boolean"}})}validate(W){return!W||typeof W!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:i(W.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:i(W.selectSubwords,this.defaultValue.selectSubwords)}}}class at extends f{constructor(){const W=[];super(ve.wordSegmenterLocales,"wordSegmenterLocales",W,{anyOf:[{description:s.localize(501,null),type:"string"},{description:s.localize(502,null),type:"array",items:{type:"string"}}]})}validate(W){if(typeof W=="string"&&(W=[W]),Array.isArray(W)){const de=[];for(const je of W)if(typeof je=="string")try{Intl.Segmenter.supportedLocalesOf(je).length>0&&de.push(je)}catch{}return de}return this.defaultValue}}var it;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})(it||(e.WrappingIndent=it={}));class ot extends f{constructor(){super(ve.wrappingIndent,"wrappingIndent",it.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[s.localize(503,null),s.localize(504,null),s.localize(505,null),s.localize(506,null)],description:s.localize(507,null),default:"same"}})}validate(W){switch(W){case"none":return it.None;case"same":return it.Same;case"indent":return it.Indent;case"deepIndent":return it.DeepIndent}return it.Same}compute(W,de,je){return de.get(ve.accessibilitySupport)===I.AccessibilitySupport.Enabled?it.None:je}}class vt extends d{constructor(){super(ve.wrappingInfo)}compute(W,de,je){const Qe=de.get(ve.layoutInfo);return{isDominatedByLongLines:W.isDominatedByLongLines,isWordWrapMinified:Qe.isWordWrapMinified,isViewportWrapping:Qe.isViewportWrapping,wrappingColumn:Qe.wrappingColumn}}}class Ye extends f{constructor(){const W={enabled:!0,showDropSelector:"afterDrop"};super(ve.dropIntoEditor,"dropIntoEditor",W,{"editor.dropIntoEditor.enabled":{type:"boolean",default:W.enabled,markdownDescription:s.localize(508,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:s.localize(509,null),enum:["afterDrop","never"],enumDescriptions:[s.localize(510,null),s.localize(511,null)],default:"afterDrop"}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{enabled:i(de.enabled,this.defaultValue.enabled),showDropSelector:u(de.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class he extends f{constructor(){const W={enabled:!0,showPasteSelector:"afterPaste"};super(ve.pasteAs,"pasteAs",W,{"editor.pasteAs.enabled":{type:"boolean",default:W.enabled,markdownDescription:s.localize(512,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:s.localize(513,null),enum:["afterPaste","never"],enumDescriptions:[s.localize(514,null),s.localize(515,null)],default:"afterPaste"}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{enabled:i(de.enabled,this.defaultValue.enabled),showPasteSelector:u(de.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const pe="Consolas, 'Courier New', monospace",ye="Menlo, Monaco, 'Courier New', monospace",Ce="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.$k?ye:P.$l?Ce:pe,fontWeight:"normal",fontSize:P.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function fe(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var ve;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.ariaRequired=5]="ariaRequired",Z[Z.autoClosingBrackets=6]="autoClosingBrackets",Z[Z.autoClosingComments=7]="autoClosingComments",Z[Z.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Z[Z.autoClosingDelete=9]="autoClosingDelete",Z[Z.autoClosingOvertype=10]="autoClosingOvertype",Z[Z.autoClosingQuotes=11]="autoClosingQuotes",Z[Z.autoIndent=12]="autoIndent",Z[Z.automaticLayout=13]="automaticLayout",Z[Z.autoSurround=14]="autoSurround",Z[Z.bracketPairColorization=15]="bracketPairColorization",Z[Z.guides=16]="guides",Z[Z.codeLens=17]="codeLens",Z[Z.codeLensFontFamily=18]="codeLensFontFamily",Z[Z.codeLensFontSize=19]="codeLensFontSize",Z[Z.colorDecorators=20]="colorDecorators",Z[Z.colorDecoratorsLimit=21]="colorDecoratorsLimit",Z[Z.columnSelection=22]="columnSelection",Z[Z.comments=23]="comments",Z[Z.contextmenu=24]="contextmenu",Z[Z.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=26]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=28]="cursorStyle",Z[Z.cursorSurroundingLines=29]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=31]="cursorWidth",Z[Z.disableLayerHinting=32]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Z[Z.domReadOnly=34]="domReadOnly",Z[Z.dragAndDrop=35]="dragAndDrop",Z[Z.dropIntoEditor=36]="dropIntoEditor",Z[Z.emptySelectionClipboard=37]="emptySelectionClipboard",Z[Z.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Z[Z.extraEditorClassName=39]="extraEditorClassName",Z[Z.fastScrollSensitivity=40]="fastScrollSensitivity",Z[Z.find=41]="find",Z[Z.fixedOverflowWidgets=42]="fixedOverflowWidgets",Z[Z.folding=43]="folding",Z[Z.foldingStrategy=44]="foldingStrategy",Z[Z.foldingHighlight=45]="foldingHighlight",Z[Z.foldingImportsByDefault=46]="foldingImportsByDefault",Z[Z.foldingMaximumRegions=47]="foldingMaximumRegions",Z[Z.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=49]="fontFamily",Z[Z.fontInfo=50]="fontInfo",Z[Z.fontLigatures=51]="fontLigatures",Z[Z.fontSize=52]="fontSize",Z[Z.fontWeight=53]="fontWeight",Z[Z.fontVariations=54]="fontVariations",Z[Z.formatOnPaste=55]="formatOnPaste",Z[Z.formatOnType=56]="formatOnType",Z[Z.glyphMargin=57]="glyphMargin",Z[Z.gotoLocation=58]="gotoLocation",Z[Z.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Z[Z.hover=60]="hover",Z[Z.inDiffEditor=61]="inDiffEditor",Z[Z.inlineSuggest=62]="inlineSuggest",Z[Z.inlineEdit=63]="inlineEdit",Z[Z.letterSpacing=64]="letterSpacing",Z[Z.lightbulb=65]="lightbulb",Z[Z.lineDecorationsWidth=66]="lineDecorationsWidth",Z[Z.lineHeight=67]="lineHeight",Z[Z.lineNumbers=68]="lineNumbers",Z[Z.lineNumbersMinChars=69]="lineNumbersMinChars",Z[Z.linkedEditing=70]="linkedEditing",Z[Z.links=71]="links",Z[Z.matchBrackets=72]="matchBrackets",Z[Z.minimap=73]="minimap",Z[Z.mouseStyle=74]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=76]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=78]="multiCursorModifier",Z[Z.multiCursorPaste=79]="multiCursorPaste",Z[Z.multiCursorLimit=80]="multiCursorLimit",Z[Z.occurrencesHighlight=81]="occurrencesHighlight",Z[Z.overviewRulerBorder=82]="overviewRulerBorder",Z[Z.overviewRulerLanes=83]="overviewRulerLanes",Z[Z.padding=84]="padding",Z[Z.pasteAs=85]="pasteAs",Z[Z.parameterHints=86]="parameterHints",Z[Z.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Z[Z.placeholder=88]="placeholder",Z[Z.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=90]="quickSuggestions",Z[Z.quickSuggestionsDelay=91]="quickSuggestionsDelay",Z[Z.readOnly=92]="readOnly",Z[Z.readOnlyMessage=93]="readOnlyMessage",Z[Z.renameOnType=94]="renameOnType",Z[Z.renderControlCharacters=95]="renderControlCharacters",Z[Z.renderFinalNewline=96]="renderFinalNewline",Z[Z.renderLineHighlight=97]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=99]="renderValidationDecorations",Z[Z.renderWhitespace=100]="renderWhitespace",Z[Z.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",Z[Z.roundedSelection=102]="roundedSelection",Z[Z.rulers=103]="rulers",Z[Z.scrollbar=104]="scrollbar",Z[Z.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=106]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=107]="scrollPredominantAxis",Z[Z.selectionClipboard=108]="selectionClipboard",Z[Z.selectionHighlight=109]="selectionHighlight",Z[Z.selectOnLineNumbers=110]="selectOnLineNumbers",Z[Z.showFoldingControls=111]="showFoldingControls",Z[Z.showUnused=112]="showUnused",Z[Z.snippetSuggestions=113]="snippetSuggestions",Z[Z.smartSelect=114]="smartSelect",Z[Z.smoothScrolling=115]="smoothScrolling",Z[Z.stickyScroll=116]="stickyScroll",Z[Z.stickyTabStops=117]="stickyTabStops",Z[Z.stopRenderingLineAfter=118]="stopRenderingLineAfter",Z[Z.suggest=119]="suggest",Z[Z.suggestFontSize=120]="suggestFontSize",Z[Z.suggestLineHeight=121]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",Z[Z.suggestSelection=123]="suggestSelection",Z[Z.tabCompletion=124]="tabCompletion",Z[Z.tabIndex=125]="tabIndex",Z[Z.unicodeHighlighting=126]="unicodeHighlighting",Z[Z.unusualLineTerminators=127]="unusualLineTerminators",Z[Z.useShadowDOM=128]="useShadowDOM",Z[Z.useTabStops=129]="useTabStops",Z[Z.wordBreak=130]="wordBreak",Z[Z.wordSegmenterLocales=131]="wordSegmenterLocales",Z[Z.wordSeparators=132]="wordSeparators",Z[Z.wordWrap=133]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=136]="wordWrapColumn",Z[Z.wordWrapOverride1=137]="wordWrapOverride1",Z[Z.wordWrapOverride2=138]="wordWrapOverride2",Z[Z.wrappingIndent=139]="wrappingIndent",Z[Z.wrappingStrategy=140]="wrappingStrategy",Z[Z.showDeprecated=141]="showDeprecated",Z[Z.inlayHints=142]="inlayHints",Z[Z.editorClassName=143]="editorClassName",Z[Z.pixelRatio=144]="pixelRatio",Z[Z.tabFocusMode=145]="tabFocusMode",Z[Z.layoutInfo=146]="layoutInfo",Z[Z.wrappingInfo=147]="wrappingInfo",Z[Z.defaultColorDecorators=148]="defaultColorDecorators",Z[Z.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",Z[Z.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(ve||(e.EditorOption=ve={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:fe(new n(ve.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:s.localize(516,null)})),acceptSuggestionOnEnter:fe(new S(ve.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",s.localize(517,null),""],markdownDescription:s.localize(518,null)})),accessibilitySupport:fe(new C),accessibilityPageSize:fe(new o(ve.accessibilityPageSize,"accessibilityPageSize",10,1,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(519,null),tags:["accessibility"]})),ariaLabel:fe(new g(ve.ariaLabel,"ariaLabel",s.localize(520,null))),ariaRequired:fe(new n(ve.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:fe(new n(ve.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:s.localize(521,null),tags:["accessibility"]})),autoClosingBrackets:fe(new S(ve.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(522,null),s.localize(523,null),""],description:s.localize(524,null)})),autoClosingComments:fe(new S(ve.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(525,null),s.localize(526,null),""],description:s.localize(527,null)})),autoClosingDelete:fe(new S(ve.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",s.localize(528,null),""],description:s.localize(529,null)})),autoClosingOvertype:fe(new S(ve.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",s.localize(530,null),""],description:s.localize(531,null)})),autoClosingQuotes:fe(new S(ve.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(532,null),s.localize(533,null),""],description:s.localize(534,null)})),autoIndent:fe(new k(ve.autoIndent,"autoIndent",b.Full,"full",["none","keep","brackets","advanced","full"],y,{enumDescriptions:[s.localize(535,null),s.localize(536,null),s.localize(537,null),s.localize(538,null),s.localize(539,null)],description:s.localize(540,null)})),automaticLayout:fe(new n(ve.automaticLayout,"automaticLayout",!1)),autoSurround:fe(new S(ve.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[s.localize(541,null),s.localize(542,null),s.localize(543,null),""],description:s.localize(544,null)})),bracketPairColorization:fe(new Ee),bracketPairGuides:fe(new Ue),stickyTabStops:fe(new n(ve.stickyTabStops,"stickyTabStops",!1,{description:s.localize(545,null)})),codeLens:fe(new n(ve.codeLens,"codeLens",!0,{description:s.localize(546,null)})),codeLensFontFamily:fe(new g(ve.codeLensFontFamily,"codeLensFontFamily","",{description:s.localize(547,null)})),codeLensFontSize:fe(new o(ve.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:s.localize(548,null)})),colorDecorators:fe(new n(ve.colorDecorators,"colorDecorators",!0,{description:s.localize(549,null)})),colorDecoratorActivatedOn:fe(new S(ve.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[s.localize(550,null),s.localize(551,null),s.localize(552,null)],description:s.localize(553,null)})),colorDecoratorsLimit:fe(new o(ve.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:s.localize(554,null)})),columnSelection:fe(new n(ve.columnSelection,"columnSelection",!1,{description:s.localize(555,null)})),comments:fe(new T),contextmenu:fe(new n(ve.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:fe(new n(ve.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:s.localize(556,null)})),cursorBlinking:fe(new k(ve.cursorBlinking,"cursorBlinking",$.Blink,"blink",["blink","smooth","phase","expand","solid"],w,{description:s.localize(557,null)})),cursorSmoothCaretAnimation:fe(new S(ve.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[s.localize(558,null),s.localize(559,null),s.localize(560,null)],description:s.localize(561,null)})),cursorStyle:fe(new k(ve.cursorStyle,"cursorStyle",M.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:s.localize(562,null)})),cursorSurroundingLines:fe(new o(ve.cursorSurroundingLines,"cursorSurroundingLines",0,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(563,null)})),cursorSurroundingLinesStyle:fe(new S(ve.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[s.localize(564,null),s.localize(565,null)],markdownDescription:s.localize(566,null)})),cursorWidth:fe(new o(ve.cursorWidth,"cursorWidth",0,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:s.localize(567,null)})),disableLayerHinting:fe(new n(ve.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:fe(new n(ve.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:fe(new n(ve.domReadOnly,"domReadOnly",!1)),dragAndDrop:fe(new n(ve.dragAndDrop,"dragAndDrop",!0,{description:s.localize(568,null)})),emptySelectionClipboard:fe(new Y),dropIntoEditor:fe(new Ye),stickyScroll:fe(new q),experimentalWhitespaceRendering:fe(new S(ve.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[s.localize(569,null),s.localize(570,null),s.localize(571,null)],description:s.localize(572,null)})),extraEditorClassName:fe(new g(ve.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:fe(new m(ve.fastScrollSensitivity,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:s.localize(573,null)})),find:fe(new z),fixedOverflowWidgets:fe(new n(ve.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:fe(new n(ve.folding,"folding",!0,{description:s.localize(574,null)})),foldingStrategy:fe(new S(ve.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[s.localize(575,null),s.localize(576,null)],description:s.localize(577,null)})),foldingHighlight:fe(new n(ve.foldingHighlight,"foldingHighlight",!0,{description:s.localize(578,null)})),foldingImportsByDefault:fe(new n(ve.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:s.localize(579,null)})),foldingMaximumRegions:fe(new o(ve.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:s.localize(580,null)})),unfoldOnClickAfterEndOfLine:fe(new n(ve.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:s.localize(581,null)})),fontFamily:fe(new g(ve.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:s.localize(582,null)})),fontInfo:fe(new ie),fontLigatures2:fe(new Q),fontSize:fe(new le),fontWeight:fe(new _),fontVariations:fe(new V),formatOnPaste:fe(new n(ve.formatOnPaste,"formatOnPaste",!1,{description:s.localize(583,null)})),formatOnType:fe(new n(ve.formatOnType,"formatOnType",!1,{description:s.localize(584,null)})),glyphMargin:fe(new n(ve.glyphMargin,"glyphMargin",!0,{description:s.localize(585,null)})),gotoLocation:fe(new oe),hideCursorInOverviewRuler:fe(new n(ve.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:s.localize(586,null)})),hover:fe(new re),inDiffEditor:fe(new n(ve.inDiffEditor,"inDiffEditor",!1)),letterSpacing:fe(new m(ve.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>m.clamp(Z,-5,20),{description:s.localize(587,null)})),lightbulb:fe(new X),lineDecorationsWidth:fe(new be),lineHeight:fe(new Ie),lineNumbers:fe(new Ne),lineNumbersMinChars:fe(new o(ve.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:fe(new n(ve.linkedEditing,"linkedEditing",!1,{description:s.localize(588,null)})),links:fe(new n(ve.links,"links",!0,{description:s.localize(589,null)})),matchBrackets:fe(new S(ve.matchBrackets,"matchBrackets","always",["always","near","never"],{description:s.localize(590,null)})),minimap:fe(new Fe),mouseStyle:fe(new S(ve.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:fe(new m(ve.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:s.localize(591,null)})),mouseWheelZoom:fe(new n(ve.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:P.$k?s.localize(592,null):s.localize(593,null)})),multiCursorMergeOverlapping:fe(new n(ve.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:s.localize(594,null)})),multiCursorModifier:fe(new k(ve.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Be,{markdownEnumDescriptions:[s.localize(595,null),s.localize(596,null)],markdownDescription:s.localize(597,null)})),multiCursorPaste:fe(new S(ve.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[s.localize(598,null),s.localize(599,null)],markdownDescription:s.localize(600,null)})),multiCursorLimit:fe(new o(ve.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:s.localize(601,null)})),occurrencesHighlight:fe(new S(ve.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[s.localize(602,null),s.localize(603,null),s.localize(604,null)],markdownDescription:s.localize(605,null)})),overviewRulerBorder:fe(new n(ve.overviewRulerBorder,"overviewRulerBorder",!0,{description:s.localize(606,null)})),overviewRulerLanes:fe(new o(ve.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:fe(new xe),pasteAs:fe(new he),parameterHints:fe(new nt),peekWidgetDefaultFocus:fe(new S(ve.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[s.localize(607,null),s.localize(608,null)],description:s.localize(609,null)})),placeholder:fe(new pt),definitionLinkOpensInPeek:fe(new n(ve.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:s.localize(610,null)})),quickSuggestions:fe(new lt),quickSuggestionsDelay:fe(new o(ve.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(611,null)})),readOnly:fe(new n(ve.readOnly,"readOnly",!1)),readOnlyMessage:fe(new B),renameOnType:fe(new n(ve.renameOnType,"renameOnType",!1,{description:s.localize(612,null),markdownDeprecationMessage:s.localize(613,null)})),renderControlCharacters:fe(new n(ve.renderControlCharacters,"renderControlCharacters",!0,{description:s.localize(614,null),restricted:!0})),renderFinalNewline:fe(new S(ve.renderFinalNewline,"renderFinalNewline",P.$l?"dimmed":"on",["off","on","dimmed"],{description:s.localize(615,null)})),renderLineHighlight:fe(new S(ve.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",s.localize(616,null)],description:s.localize(617,null)})),renderLineHighlightOnlyWhenFocus:fe(new n(ve.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:s.localize(618,null)})),renderValidationDecorations:fe(new S(ve.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:fe(new S(ve.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",s.localize(619,null),s.localize(620,null),s.localize(621,null),""],description:s.localize(622,null)})),revealHorizontalRightPadding:fe(new o(ve.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:fe(new n(ve.roundedSelection,"roundedSelection",!0,{description:s.localize(623,null)})),rulers:fe(new Le),scrollbar:fe(new H),scrollBeyondLastColumn:fe(new o(ve.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(624,null)})),scrollBeyondLastLine:fe(new n(ve.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:s.localize(625,null)})),scrollPredominantAxis:fe(new n(ve.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:s.localize(626,null)})),selectionClipboard:fe(new n(ve.selectionClipboard,"selectionClipboard",!0,{description:s.localize(627,null),included:P.$l})),selectionHighlight:fe(new n(ve.selectionHighlight,"selectionHighlight",!0,{description:s.localize(628,null)})),selectOnLineNumbers:fe(new n(ve.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:fe(new S(ve.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[s.localize(629,null),s.localize(630,null),s.localize(631,null)],description:s.localize(632,null)})),showUnused:fe(new n(ve.showUnused,"showUnused",!0,{description:s.localize(633,null)})),showDeprecated:fe(new n(ve.showDeprecated,"showDeprecated",!0,{description:s.localize(634,null)})),inlayHints:fe(new ne),snippetSuggestions:fe(new S(ve.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[s.localize(635,null),s.localize(636,null),s.localize(637,null),s.localize(638,null)],description:s.localize(639,null)})),smartSelect:fe(new tt),smoothScrolling:fe(new n(ve.smoothScrolling,"smoothScrolling",!1,{description:s.localize(640,null)})),stopRenderingLineAfter:fe(new o(ve.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,R.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:fe(new _e),inlineSuggest:fe(new se),inlineEdit:fe(new ge),inlineCompletionsAccessibilityVerbose:fe(new n(ve.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:s.localize(641,null)})),suggestFontSize:fe(new o(ve.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:s.localize(642,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:fe(new o(ve.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:s.localize(643,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:fe(new n(ve.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:s.localize(644,null)})),suggestSelection:fe(new S(ve.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[s.localize(645,null),s.localize(646,null),s.localize(647,null)],description:s.localize(648,null)})),tabCompletion:fe(new S(ve.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[s.localize(649,null),s.localize(650,null),s.localize(651,null)],description:s.localize(652,null)})),tabIndex:fe(new o(ve.tabIndex,"tabIndex",0,-1,R.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:fe(new G),unusualLineTerminators:fe(new S(ve.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[s.localize(653,null),s.localize(654,null),s.localize(655,null)],description:s.localize(656,null)})),useShadowDOM:fe(new n(ve.useShadowDOM,"useShadowDOM",!0)),useTabStops:fe(new n(ve.useTabStops,"useTabStops",!0,{description:s.localize(657,null)})),wordBreak:fe(new S(ve.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[s.localize(658,null),s.localize(659,null)],description:s.localize(660,null)})),wordSegmenterLocales:fe(new at),wordSeparators:fe(new g(ve.wordSeparators,"wordSeparators",p.$st,{description:s.localize(661,null)})),wordWrap:fe(new S(ve.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[s.localize(662,null),s.localize(663,null),s.localize(664,null),s.localize(665,null)],description:s.localize(666,null)})),wordWrapBreakAfterCharacters:fe(new g(ve.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:fe(new g(ve.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:fe(new o(ve.wordWrapColumn,"wordWrapColumn",80,1,R.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:s.localize(667,null)})),wordWrapOverride1:fe(new S(ve.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:fe(new S(ve.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:fe(new J),defaultColorDecorators:fe(new n(ve.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:s.localize(668,null)})),pixelRatio:fe(new ut),tabFocusMode:fe(new n(ve.tabFocusMode,"tabFocusMode",!1,{markdownDescription:s.localize(669,null)})),layoutInfo:fe(new x),wrappingInfo:fe(new vt),wrappingIndent:fe(new ot),wrappingStrategy:fe(new $e)}}),define(Re[107],Te([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=void 0,e.$Pi=(0,v.$Ii)("environmentService"),e.$Qi=(0,v.$Ji)(e.$Pi)}),define(Re[28],Te([1,0,48,22,13,14,2,9,3,23,15,51]),function(we,e,v,D,P,N,R,O,p,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=e.$Il=e.FileKind=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=e.$Cl=e.$Bl=e.FileOperationResult=e.$Al=e.$zl=e.$yl=e.$wl=e.FileChangeType=e.$vl=e.FileOperation=e.$pl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$dl=void 0,e.$el=h,e.$fl=l,e.$gl=a,e.$hl=i,e.$il=n,e.$jl=t,e.$kl=o,e.$ll=c,e.$ml=m,e.$nl=g,e.$ol=u,e.$ql=y,e.$rl=C,e.$sl=T,e.$tl=$,e.$ul=w,e.$xl=Y,e.$Jl=_,e.$Kl=oe,e.$Ml=ce,e.$dl=(0,p.$Ii)("fileService");function h(x){return x.create===!0}var E;(function(x){x[x.Unknown=0]="Unknown",x[x.File=1]="File",x[x.Directory=2]="Directory",x[x.SymbolicLink=64]="SymbolicLink"})(E||(e.FileType=E={}));var f;(function(x){x[x.Readonly=1]="Readonly",x[x.Locked=2]="Locked"})(f||(e.FilePermission=f={}));var r;(function(x){x[x.UPDATED=2]="UPDATED",x[x.ADDED=4]="ADDED",x[x.DELETED=8]="DELETED"})(r||(e.FileChangeFilter=r={}));function l(x){const $e=x;return!!$e&&typeof $e.onDidChange=="function"}var d;(function(x){x[x.None=0]="None",x[x.FileReadWrite=2]="FileReadWrite",x[x.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",x[x.FileReadStream=16]="FileReadStream",x[x.FileFolderCopy=8]="FileFolderCopy",x[x.PathCaseSensitive=1024]="PathCaseSensitive",x[x.Readonly=2048]="Readonly",x[x.Trash=4096]="Trash",x[x.FileWriteUnlock=8192]="FileWriteUnlock",x[x.FileAtomicRead=16384]="FileAtomicRead",x[x.FileAtomicWrite=32768]="FileAtomicWrite",x[x.FileAtomicDelete=65536]="FileAtomicDelete",x[x.FileClone=131072]="FileClone"})(d||(e.FileSystemProviderCapabilities=d={}));function a(x){return!!(x.capabilities&d.FileReadWrite)}function i(x){return!!(x.capabilities&d.FileFolderCopy)}function n(x){return!!(x.capabilities&d.FileClone)}function t(x){return!!(x.capabilities&d.FileOpenReadWriteClose)}function o(x){return!!(x.capabilities&d.FileReadStream)}function c(x){return a(x)?!!(x.capabilities&d.FileAtomicRead):!1}function m(x){return a(x)?!!(x.capabilities&d.FileAtomicWrite):!1}function g(x){return!!(x.capabilities&d.FileAtomicDelete)}function u(x){return!!(x.capabilities&d.Readonly)}var S;(function(x){x.FileExists="EntryExists",x.FileNotFound="EntryNotFound",x.FileNotADirectory="EntryNotADirectory",x.FileIsADirectory="EntryIsADirectory",x.FileExceedsStorageQuota="EntryExceedsStorageQuota",x.FileTooLarge="EntryTooLarge",x.FileWriteLocked="EntryWriteLocked",x.NoPermissions="NoPermissions",x.Unavailable="Unavailable",x.Unknown="Unknown"})(S||(e.FileSystemProviderErrorCode=S={}));class k extends Error{static create($e,Pe){const X=new k($e.toString(),Pe);return T(X,Pe),X}constructor($e,Pe){super($e),this.code=Pe}}e.$pl=k;function y(x,$e){return k.create(x,$e)}function C(x){return x||y((0,O.localize)(1865,null),S.Unknown)}function T(x,$e){return x.name=$e?`${$e} (FileSystemError)`:"FileSystemError",x}function $(x){if(!x)return S.Unknown;if(x instanceof k)return x.code;const $e=/^(.+) \(FileSystemError\)$/.exec(x.name);if(!$e)return S.Unknown;switch($e[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}function w(x){if(x instanceof z)return x.fileOperationResult;switch($(x)){case S.FileNotFound:return ie.FILE_NOT_FOUND;case S.FileIsADirectory:return ie.FILE_IS_DIRECTORY;case S.FileNotADirectory:return ie.FILE_NOT_DIRECTORY;case S.FileWriteLocked:return ie.FILE_WRITE_LOCKED;case S.NoPermissions:return ie.FILE_PERMISSION_DENIED;case S.FileExists:return ie.FILE_MOVE_CONFLICT;case S.FileTooLarge:return ie.FILE_TOO_LARGE;default:return ie.FILE_OTHER_ERROR}}var M;(function(x){x[x.CREATE=0]="CREATE",x[x.DELETE=1]="DELETE",x[x.MOVE=2]="MOVE",x[x.COPY=3]="COPY",x[x.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class A{constructor($e,Pe,X){this.resource=$e,this.operation=Pe,this.target=X}isOperation($e){return this.operation===$e}}e.$vl=A;var L;(function(x){x[x.UPDATED=0]="UPDATED",x[x.ADDED=1]="ADDED",x[x.DELETED=2]="DELETED"})(L||(e.FileChangeType=L={}));class J{static{this.a=null}constructor($e,Pe){this.c=Pe,this.b=void 0,this.d=new b.$W(()=>{const X=v.$Oi.forUris(()=>this.c);return X.fill(this.rawAdded.map(q=>[q,!0])),X}),this.f=new b.$W(()=>{const X=v.$Oi.forUris(()=>this.c);return X.fill(this.rawUpdated.map(q=>[q,!0])),X}),this.g=new b.$W(()=>{const X=v.$Oi.forUris(()=>this.c);return X.fill(this.rawDeleted.map(q=>[q,!0])),X}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const X of $e){switch(X.type){case L.ADDED:this.rawAdded.push(X.resource);break;case L.UPDATED:this.rawUpdated.push(X.resource);break;case L.DELETED:this.rawDeleted.push(X.resource);break}this.b!==J.a&&(typeof X.cId=="number"?this.b===void 0?this.b=X.cId:this.b!==X.cId&&(this.b=J.a):this.b!==void 0&&(this.b=J.a))}}contains($e,...Pe){return this.h($e,{includeChildren:!1},...Pe)}affects($e,...Pe){return this.h($e,{includeChildren:!0},...Pe)}h($e,Pe,...X){if(!$e)return!1;const q=X.length>0;return!!((!q||X.includes(L.ADDED))&&(this.d.value.get($e)||Pe.includeChildren&&this.d.value.findSuperstr($e))||(!q||X.includes(L.UPDATED))&&(this.f.value.get($e)||Pe.includeChildren&&this.f.value.findSuperstr($e))||(!q||X.includes(L.DELETED))&&(this.g.value.findSubstr($e)||Pe.includeChildren&&this.g.value.findSuperstr($e)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates($e){return this.b===$e}hasCorrelation(){return typeof this.b=="number"}}e.$wl=J;function Y(x,$e,Pe){return!x||!$e||x===$e||$e.length>x.length?!1:($e.charAt($e.length-1)!==D.sep&&($e+=D.sep),Pe?(0,P.$Jf)(x,$e):x.indexOf($e)===0)}class z extends Error{constructor($e,Pe,X){super($e),this.fileOperationResult=Pe,this.options=X}}e.$yl=z;class Q extends z{constructor($e,Pe,X,q){super($e,Pe,q),this.fileOperationResult=Pe,this.size=X}}e.$zl=Q;class V extends z{constructor($e,Pe,X){super($e,ie.FILE_NOT_MODIFIED_SINCE,X),this.stat=Pe}}e.$Al=V;var ie;(function(x){x[x.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",x[x.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",x[x.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",x[x.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",x[x.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",x[x.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",x[x.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",x[x.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",x[x.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",x[x.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",x[x.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ie||(e.FileOperationResult=ie={})),e.$Bl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Cl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Dl="files.associations",e.$El="files.exclude",e.$Fl="files.readonlyInclude",e.$Gl="files.readonlyExclude",e.$Hl="files.readonlyFromPermissions";var le;(function(x){x[x.FILE=0]="FILE",x[x.FOLDER=1]="FOLDER",x[x.ROOT_FOLDER=2]="ROOT_FOLDER"})(le||(e.FileKind=le={})),e.$Il="";function _(x){if(!(typeof x.size!="number"||typeof x.mtime!="number"))return x.mtime.toString(29)+x.size.toString(31)}async function oe(x,$e){if(!$e.hasProvider(R.URI.from({scheme:x.scheme})))return new Promise(Pe=>{const X=$e.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===x.scheme&&q.added&&(X.dispose(),Pe())})})}class re{static{this.KB=1024}static{this.MB=re.KB*re.KB}static{this.GB=re.MB*re.KB}static{this.TB=re.GB*re.KB}static formatSize($e){return(0,N.$lg)($e)||($e=0),$e<re.KB?(0,O.localize)(1866,null,$e.toFixed(0)):$e<re.MB?(0,O.localize)(1867,null,($e/re.KB).toFixed(2)):$e<re.GB?(0,O.localize)(1868,null,($e/re.MB).toFixed(2)):$e<re.TB?(0,O.localize)(1869,null,($e/re.GB).toFixed(2)):(0,O.localize)(1870,null,($e/re.TB).toFixed(2))}}e.$Ll=re;function ce(x){const $e=typeof x=="string"||x?.scheme===I.Schemas.vscodeRemote;return typeof x!="string"&&x?.scheme===I.Schemas.file?1024*re.MB:$e?10*re.MB:s.$p?50*re.MB:1024*re.MB}}),define(Re[75],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=void 0;class v{constructor(...P){this.a=new Map;for(const[N,R]of P)this.set(N,R)}set(P,N){const R=this.a.get(P);return this.a.set(P,N),R}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$Gi=v}),define(Re[170],Te([1,0,10,12,4,74,167,3,75,171]),function(we,e,v,D,P,N,R,O,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=void 0;const I=!1;class b extends Error{constructor(l){super("cyclic dependency between services"),this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class h{constructor(l=new p.$Gi,d=!1,a,i=I){this.i=l,this.j=d,this.k=a,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(O.$Hi,this),this._globalGraph=i?a?._globalGraph??new R.$Br(n=>n):void 0}dispose(){if(!this.f){this.f=!0,(0,P.$Sc)(this.h),this.h.clear();for(const l of this.g)(0,P.$Rc)(l)&&l.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(l,d){this.m();const a=this,i=new class extends h{dispose(){a.h.delete(i),super.dispose()}}(l,this.j,this,this.l);return this.h.add(i),d?.add(i),i}invokeFunction(l,...d){this.m();const a=f.traceInvocation(this.l,l);let i=!1;try{return l({get:t=>{if(i)throw(0,D.$0)("service accessor is only valid during the invocation of its target method");const o=this.s(t,a);if(!o)throw new Error(`[invokeFunction] unknown service '${t}'`);return o}},...d)}finally{i=!0,a.stop()}}createInstance(l,...d){this.m();let a,i;return l instanceof N.$Fi?(a=f.traceCreation(this.l,l.ctor),i=this.o(l.ctor,l.staticArguments.concat(d),a)):(a=f.traceCreation(this.l,l),i=this.o(l,d,a)),a.stop(),i}o(l,d=[],a){const i=O._util.getServiceDependencies(l).sort((o,c)=>o.index-c.index),n=[];for(const o of i){const c=this.s(o.id,a);c||this.y(`[createInstance] ${l.name} depends on UNKNOWN service ${o.id}.`,!1),n.push(c)}const t=i.length>0?i[0].index:d.length;if(d.length!==t){console.trace(`[createInstance] First service dependency of ${l.name} at position ${t+1} conflicts with ${d.length} static arguments`);const o=t-d.length;o>0?d=d.concat(new Array(o)):d=d.slice(0,t)}return Reflect.construct(l,d.concat(n))}q(l,d){if(this.i.get(l)instanceof N.$Fi)this.i.set(l,d);else if(this.k)this.k.q(l,d);else throw new Error("illegalState - setting UNKNOWN service instance")}r(l){const d=this.i.get(l);return!d&&this.k?this.k.r(l):d}s(l,d){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(l));const a=this.r(l);return a instanceof N.$Fi?this.u(l,a,d.branch(l,!0)):(d.branch(l,!1),a)}u(l,d,a){if(this.t.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this.t.add(l);try{return this.v(l,d,a)}finally{this.t.delete(l)}}v(l,d,a){const i=new R.$Br(c=>c.id.toString());let n=0;const t=[{id:l,desc:d,_trace:a}],o=new Set;for(;t.length;){const c=t.pop();if(!o.has(String(c.id))){if(o.add(String(c.id)),i.lookupOrInsertNode(c),n++>1e3)throw new b(i);for(const m of O._util.getServiceDependencies(c.desc.ctor)){const g=this.r(m.id);if(g||this.y(`[createInstance] ${l} depends on ${m.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(c.id),String(m.id)),g instanceof N.$Fi){const u={id:m.id,desc:g,_trace:c._trace.branch(m.id,!0)};i.insertEdge(c,u),t.push(u)}}}}for(;;){const c=i.roots();if(c.length===0){if(!i.isEmpty())throw new b(i);break}for(const{data:m}of c){if(this.r(m.id)instanceof N.$Fi){const u=this.w(m.id,m.desc.ctor,m.desc.staticArguments,m.desc.supportsDelayedInstantiation,m._trace);this.q(m.id,u)}i.removeNode(m)}}return this.r(l)}w(l,d,a=[],i,n){if(this.i.get(l)instanceof N.$Fi)return this.x(l,d,a,i,n,this.g);if(this.k)return this.k.w(l,d,a,i,n);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}x(l,d,a=[],i,n,t){if(i){const o=new h(void 0,this.j,this,this.l);o.c=String(l);const c=new Map,m=new v.$2h(()=>{const g=o.o(d,a,n);for(const[u,S]of c){const k=g[u];if(typeof k=="function")for(const y of S)y.disposable=k.apply(g,y.listener)}return c.clear(),t.add(g),g});return new Proxy(Object.create(null),{get(g,u){if(!m.isInitialized&&typeof u=="string"&&(u.startsWith("onDid")||u.startsWith("onWill"))){let y=c.get(u);return y||(y=new s.$8c,c.set(u,y)),(T,$,w)=>{if(m.isInitialized)return m.value[u](T,$,w);{const M={listener:[T,$,w],disposable:void 0},A=y.push(M);return(0,P.$Vc)(()=>{A(),M.disposable?.dispose()})}}}if(u in g)return g[u];const S=m.value;let k=S[u];return typeof k!="function"||(k=k.bind(S),g[u]=k),k},set(g,u,S){return m.value[u]=S,!0},getPrototypeOf(g){return d.prototype}})}else{const o=this.o(d,a,n);return t.add(o),o}}y(l,d){if(d&&console.warn(l),this.j)throw new Error(l)}}e.$Cr=h;var E;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(E||(E={}));class f{static{this.all=new Set}static{this.c=new class extends f{constructor(){super(E.None,null)}stop(){}branch(){return this}}}static traceInvocation(l,d){return l?new f(E.Invocation,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(l,d){return l?new f(E.Creation,d.name):f.c}static{this.f=0}constructor(l,d){this.type=l,this.name=d,this.g=Date.now(),this.h=[]}branch(l,d){const a=new f(E.Branch,l.toString());return this.h.push([l,d,a]),a}stop(){const l=Date.now()-this.g;f.f+=l;let d=!1;function a(n,t){const o=[],c=new Array(n+1).join("	");for(const[m,g,u]of t.h)if(g&&u){d=!0,o.push(`${c}CREATES -> ${m}`);const S=a(n+1,u);S&&o.push(S)}else o.push(`${c}uses -> ${m}`);return o.join(`
`)}const i=[`${this.type===E.Creation?"CREATE":"CALL"} ${this.name}`,`${a(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(l>2||d)&&f.all.add(i.join(`
`))}}e.$Dr=f}),define(Re[11],Te([1,0,9,42,6,76,4,27,23,24,14,2,31,3]),function(we,e,v,D,P,N,R,O,p,s,I,b,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$gk=e.LogLevel=e.$ek=e.$dk=void 0,e.$fk=r,e.log=d,e.$rk=k,e.$sk=y,e.$tk=C,e.$uk=T,v=qe(v),e.$dk=(0,E.$Ii)("logService"),e.$ek=(0,E.$Ii)("loggerService");function f(){return new Date().toISOString()}function r($){return(0,I.$lg)($)}var l;(function($){$[$.Off=0]="Off",$[$.Trace=1]="Trace",$[$.Debug=2]="Debug",$[$.Info=3]="Info",$[$.Warning=4]="Warning",$[$.Error=5]="Error"})(l||(e.LogLevel=l={})),e.$gk=l.Info;function d($,w,M){switch(w){case l.Trace:$.trace(M);break;case l.Debug:$.debug(M);break;case l.Info:$.info(M);break;case l.Warning:$.warn(M);break;case l.Error:$.error(M);break;case l.Off:break;default:throw new Error(`Invalid log level ${w}`)}}function a($,w=!1){let M="";for(let A=0;A<$.length;A++){let L=$[A];if(L instanceof Error&&(L=(0,D.$tj)(L,w)),typeof L=="object")try{L=JSON.stringify(L)}catch{}M+=(A>0?" ":"")+L}return M}class i extends R.$Xc{constructor(){super(...arguments),this.b=e.$gk,this.c=this.B(new P.$oe),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==l.Off&&this.b<=w}}e.$ik=i;class n extends i{constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...M){this.f(l.Trace)&&this.g(l.Trace,a([w,...M],!0))}debug(w,...M){this.f(l.Debug)&&this.g(l.Debug,a([w,...M]))}info(w,...M){this.f(l.Info)&&this.g(l.Info,a([w,...M]))}warn(w,...M){this.f(l.Warning)&&this.g(l.Warning,a([w,...M]))}error(w,...M){if(this.f(l.Error))if(w instanceof Error){const A=Array.prototype.slice.call(arguments);A[0]=w.stack,this.g(l.Error,a(A))}else this.g(l.Error,a([w,...M]))}flush(){}}e.$jk=n;class t extends i{constructor(w=e.$gk){super(),this.setLevel(w),this.g=!p.$j}trace(w,...M){this.f(l.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,w,...M):console.log(`[main ${f()}]`,w,...M))}debug(w,...M){this.f(l.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,w,...M):console.log(`[main ${f()}]`,w,...M))}info(w,...M){this.f(l.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,w,...M):console.log(`[main ${f()}]`,w,...M))}warn(w,...M){this.f(l.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,w,...M):console.warn(`[main ${f()}]`,w,...M))}error(w,...M){this.f(l.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,w,...M):console.error(`[main ${f()}]`,w,...M))}flush(){}}e.$kk=t;class o extends i{constructor(w=e.$gk,M=!0){super(),this.g=M,this.setLevel(w)}trace(w,...M){this.f(l.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...M):console.log(w,...M))}debug(w,...M){this.f(l.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...M):console.log(w,...M))}info(w,...M){this.f(l.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...M):console.log(w,...M))}warn(w,...M){this.f(l.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...M):console.log(w,...M))}error(w,...M){this.f(l.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...M):console.error(w,...M))}flush(){}}e.$lk=o;class c extends i{constructor(w,M=e.$gk){super(),this.g=w,this.setLevel(M)}trace(w,...M){this.f(l.Trace)&&this.g.log(l.Trace,[this.h(w),...M])}debug(w,...M){this.f(l.Debug)&&this.g.log(l.Debug,[this.h(w),...M])}info(w,...M){this.f(l.Info)&&this.g.log(l.Info,[this.h(w),...M])}warn(w,...M){this.f(l.Warning)&&this.g.log(l.Warning,[this.h(w),...M])}error(w,...M){this.f(l.Error)&&this.g.log(l.Error,[this.h(w),...M])}h(w){return typeof w=="string"?w:(0,D.$tj)(w,this.f(l.Trace))}flush(){}}e.$mk=c;class m extends i{constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const M of this.g)M.setLevel(w);super.setLevel(w)}trace(w,...M){for(const A of this.g)A.trace(w,...M)}debug(w,...M){for(const A of this.g)A.debug(w,...M)}info(w,...M){for(const A of this.g)A.info(w,...M)}warn(w,...M){for(const A of this.g)A.warn(w,...M)}error(w,...M){for(const A of this.g)A.error(w,...M)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose();super.dispose()}}e.$nk=m;class g extends R.$Xc{constructor(w,M,A){if(super(),this.h=w,this.j=M,this.b=new O.$Dc,this.c=this.B(new P.$oe),this.onDidChangeLoggers=this.c.event,this.f=this.B(new P.$oe),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new P.$oe),this.onDidChangeVisibility=this.g.event,A)for(const L of A)this.b.set(L.resource,{logger:void 0,info:L})}m(w){return(0,I.$hg)(w)?[...this.b.values()].find(M=>M.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,M){const A=this.n(w),L=(0,I.$hg)(w)?w:M?.id??(0,N.$wj)(A.toString()).toString(16);let J=this.b.get(A)?.logger;const Y=M?.logLevel==="always"?l.Trace:M?.logLevel;J||(J=this.s(A,Y??this.getLogLevel(A)??this.h,{...M,id:L}));const z={logger:J,info:{resource:A,id:L,logLevel:Y,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(z.info),this.b.set(A,z),J}n(w){return(0,I.$hg)(w)?(0,s.$jh)(this.j,`${w}.log`):w}setLogLevel(w,M){if(b.URI.isUri(w)){const A=w,L=M,J=this.b.get(A);J&&L!==J.info.logLevel&&(J.info.logLevel=L===this.h?void 0:L,J.logger?.setLevel(L),this.b.set(J.info.resource,J),this.f.fire([A,L]))}else{this.h=w;for(const[A,L]of this.b.entries())this.b.get(A)?.info.logLevel===void 0&&L.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,M){const A=this.m(w);A&&M!==!A.info.hidden&&(A.info.hidden=!M,this.b.set(A.info.resource,A),this.g.fire([A.info.resource,M]))}getLogLevel(w){let M;return w&&(M=this.b.get(w)?.info.logLevel),M??this.h}registerLogger(w){const M=this.b.get(w.resource);M?M.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const M=this.b.get(w);M&&(M.logger&&M.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ok=g;class u{constructor(){this.onDidChangeLogLevel=new P.$oe().event}setLevel(w){}getLevel(){return l.Info}trace(w,...M){}debug(w,...M){}info(w,...M){}warn(w,...M){}error(w,...M){}critical(w,...M){}dispose(){}flush(){}}e.$pk=u;class S extends u{}e.$qk=S;function k($){if($.verbose)return l.Trace;if(typeof $.logLevel=="string"){const w=T($.logLevel.toLowerCase());if(w!==void 0)return w}return e.$gk}function y($){switch($){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Off:return"off"}}function C($){switch($){case l.Trace:return{original:"Trace",value:v.localize(1959,null)};case l.Debug:return{original:"Debug",value:v.localize(1960,null)};case l.Info:return{original:"Info",value:v.localize(1961,null)};case l.Warning:return{original:"Warning",value:v.localize(1962,null)};case l.Error:return{original:"Error",value:v.localize(1963,null)};case l.Off:return{original:"Off",value:v.localize(1964,null)}}}function T($){switch($){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Error;case"off":return l.Off}}e.$vk=new h.$Zj("logLevel",y(l.Info))}),define(Re[172],Te([1,0,4,11]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4R=void 0;class P extends v.$Xc{constructor(R,O=[]){super(),this.a=new D.$nk([R,...O]),this.B(R.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...O){this.a.trace(R,...O)}debug(R,...O){this.a.debug(R,...O)}info(R,...O){this.a.info(R,...O)}warn(R,...O){this.a.warn(R,...O)}error(R,...O){this.a.error(R,...O)}flush(){this.a.flush()}}e.$4R=P});var si=this&&this.__importDefault||function(we){return we&&we.__esModule?we:{default:we}};define(Re[108],Te([1,0,36,9,3]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mu=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,v=si(v);var N;(function(p){p[p.Unnecessary=1]="Unnecessary",p[p.Deprecated=2]="Deprecated"})(N||(e.MarkerTag=N={}));var R;(function(p){p[p.Hint=1]="Hint",p[p.Info=2]="Info",p[p.Warning=4]="Warning",p[p.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(p){function s(f,r){return r-f}p.compare=s;const I=Object.create(null);I[p.Error]=(0,D.localize)(1965,null),I[p.Warning]=(0,D.localize)(1966,null),I[p.Info]=(0,D.localize)(1967,null);function b(f){return I[f]||""}p.toString=b;function h(f){switch(f){case v.default.Error:return p.Error;case v.default.Warning:return p.Warning;case v.default.Info:return p.Info;case v.default.Ignore:return p.Hint}}p.fromSeverity=h;function E(f){switch(f){case p.Error:return v.default.Error;case p.Warning:return v.default.Warning;case p.Info:return v.default.Info;case p.Hint:return v.default.Ignore}}p.toSeverity=E}(R||(e.MarkerSeverity=R={}));var O;(function(p){const s="";function I(h){return b(h,!0)}p.makeKey=I;function b(h,E){const f=[s];return h.source?f.push(h.source.replace("\xA6","\\\xA6")):f.push(s),h.code?typeof h.code=="string"?f.push(h.code.replace("\xA6","\\\xA6")):f.push(h.code.value.replace("\xA6","\\\xA6")):f.push(s),h.severity!==void 0&&h.severity!==null?f.push(R.toString(h.severity)):f.push(s),h.message&&E?f.push(h.message.replace("\xA6","\\\xA6")):f.push(s),h.startLineNumber!==void 0&&h.startLineNumber!==null?f.push(h.startLineNumber.toString()):f.push(s),h.startColumn!==void 0&&h.startColumn!==null?f.push(h.startColumn.toString()):f.push(s),h.endLineNumber!==void 0&&h.endLineNumber!==null?f.push(h.endLineNumber.toString()):f.push(s),h.endColumn!==void 0&&h.endColumn!==null?f.push(h.endColumn.toString()):f.push(s),f.push(s),f.join("\xA6")}p.makeKeyOptionalMessage=b})(O||(e.IMarkerData=O={})),e.$Mu=(0,P.$Ii)("markerService")});var si=this&&this.__importDefault||function(we){return we&&we.__esModule?we:{default:we}};define(Re[173],Te([1,0,6,36,3]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dw=e.$Cw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Aw=e.Severity=void 0,e.$Bw=O,D=si(D),e.Severity=D.default,e.$Aw=(0,P.$Ii)("notificationService");var N;(function(b){b[b.DEFAULT=0]="DEFAULT",b[b.SILENT=1]="SILENT",b[b.URGENT=2]="URGENT"})(N||(e.NotificationPriority=N={}));var R;(function(b){b[b.WORKSPACE=0]="WORKSPACE",b[b.PROFILE=1]="PROFILE",b[b.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function O(b){if(b){const h=b;return typeof h.id=="string"&&typeof h.label=="string"}return!1}var p;(function(b){b[b.OFF=0]="OFF",b[b.ERROR=1]="ERROR"})(p||(e.NotificationsFilter=p={}));class s{constructor(){this.progress=new I,this.onDidClose=v.Event.None,this.onDidChangeVisibility=v.Event.None}updateSeverity(h){}updateMessage(h){}updateActions(h){}close(){}}e.$Cw=s;class I{infinite(){}done(){}total(h){}worked(h){}}e.$Dw=I}),define(Re[109],Te([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=e.$wk=void 0,e.$wk=(0,v.$Ii)("productService"),e.$xk="vscode://schemas/vscode-product"});var Ke=this&&this.__decorate||function(we,e,v,D){var P=arguments.length,N=P<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,v):D,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(we,e,v,D);else for(var O=we.length-1;O>=0;O--)(R=we[O])&&(N=(P<3?R(N):P>3?R(e,v,N):R(e,v))||N);return P>3&&N&&Object.defineProperty(e,v,N),N},We=this&&this.__param||function(we,e){return function(v,D){e(v,D,we)}};define(Re[77],Te([1,0,10,19,4,3]),function(we,e,v,D,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kw=e.$Jw=e.$Iw=e.$Hw=e.$Gw=e.$Fw=e.ProgressLocation=e.$Ew=void 0,e.$Ew=(0,N.$Ii)("progressService");var R;(function(b){b[b.Explorer=1]="Explorer",b[b.Scm=3]="Scm",b[b.Extensions=5]="Extensions",b[b.Window=10]="Window",b[b.Notification=15]="Notification",b[b.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$Fw=Object.freeze({total(){},worked(){},done(){}});class O{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(h){this.b=h}report(h){this.a=h,this.b(this.a)}}e.$Gw=O;class p{get value(){return this.a}constructor(h){this.e=h}report(h){this.b?this.b.push(h):this.b=[h],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const h=this.b.shift();this.a=h,await this.e(this.a)}}finally{this.c=!1;const h=this.d;this.d=void 0,h?.()}}drain(){return this.c?new Promise(h=>{const E=this.d;this.d=()=>{E?.(),h()}}):Promise.resolve()}}e.$Hw=p;let s=class extends P.$Xc{constructor(h,E){super(),this.a=new v.$6h,E.withProgress(h,f=>(this.b=f,this.c&&f.report(this.c),this.a.p)),this.B((0,P.$Vc)(()=>this.a.complete()))}report(h){this.b?this.b.report(h):this.c=h}};e.$Iw=s,e.$Iw=s=Ke([We(1,e.$Ew)],s);class I extends P.$Xc{constructor(h){super(),this.g=h,this.a=0,this.b=this.B(new P.$Wc)}start(h){this.stop();const E=++this.a,f=new D.$ze;return this.f=setTimeout(()=>{E===this.a&&(this.c=this.g.show(!0))},h),this.b.add((0,P.$Vc)(()=>clearTimeout(this.f))),this.b.add((0,P.$Vc)(()=>f.cancel())),this.b.add((0,P.$Vc)(()=>this.c?this.c.done():void 0)),{id:E,token:f.token,stop:()=>this.h(E),isCurrent:()=>this.a===E}}stop(){this.h(this.a)}h(h){this.a===h&&this.b.clear()}}e.$Jw=I,e.$Kw=(0,N.$Ii)("editorProgressService")}),define(Re[29],Te([1,0,61,14]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vo=void 0,v=qe(v),D=qe(D);class P{constructor(){this.a=new Map}add(R,O){v.ok(D.$hg(R)),v.ok(D.$jg(O)),v.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,O)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$vo=new P}),define(Re[78],Te([1,0,6,138,29]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=void 0,P=qe(P),e.$wo={JSONContribution:"base.contributions.json"};function N(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class R{constructor(){this.b=new v.$oe,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(s,I){this.a[N(s)]=I,this.b.fire(s)}notifySchemaChanged(s){this.b.fire(s)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(s){const I=this.a[s];return I?(0,D.$$j)(I):void 0}hasSchemaContent(s){return!!this.a[s]}}const O=new R;P.$vo.add(e.$wo.JSONContribution,O)}),define(Re[53],Te([1,0,17,6,14,9,43,78,29]),function(we,e,v,D,P,N,R,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.ConfigurationScope=e.$Ao=e.EditPresentationTypes=void 0,e.$Lo=r,e.$Mo=l,e.$No=d,e.$Oo=i,e.$Po=n,e.$Qo=t,e.$Ro=o,P=qe(P),N=qe(N);var s;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(s||(e.EditPresentationTypes=s={})),e.$Ao={Configuration:"base.contributions.configuration"};var I;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I||(e.ConfigurationScope=I={})),e.$Bo={properties:{},patternProperties:{}},e.$Co={properties:{},patternProperties:{}},e.$Do={properties:{},patternProperties:{}},e.$Eo={properties:{},patternProperties:{}},e.$Fo={properties:{},patternProperties:{}},e.$Go={properties:{},patternProperties:{}},e.$Ho="vscode://schemas/settings/resourceLanguage",e.$Io="vscode://schemas/settings/configurationDefaults";const b=p.$vo.as(O.$wo.JSONContribution);class h{constructor(){this.a=[],this.i=new Set,this.j=new D.$oe,this.onDidSchemaChange=this.j.event,this.k=new D.$oe,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:N.localize(1662,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},b.registerSchema(e.$Ho,this.h),this.z()}registerConfiguration(m,g=!0){this.registerConfigurations([m],g)}registerConfigurations(m,g=!0){const u=new Set;this.r(m,g,u),b.registerSchema(e.$Ho,this.h),this.j.fire(),this.k.fire({properties:u})}deregisterConfigurations(m){const g=new Set;this.s(m,g),b.registerSchema(e.$Ho,this.h),this.j.fire(),this.k.fire({properties:g})}updateConfigurations({add:m,remove:g}){const u=new Set;this.s(g,u),this.r(m,!1,u),b.registerSchema(e.$Ho,this.h),this.j.fire(),this.k.fire({properties:u})}registerDefaultConfigurations(m){const g=new Set;this.l(m,g),this.j.fire(),this.k.fire({properties:g,defaultsOverrides:!0})}l(m,g){this.a.push(...m);const u=[];for(const{overrides:S,source:k}of m)for(const y in S){g.add(y);const C=this.b.get(y)??this.b.set(y,{configurationDefaultOverrides:[]}).get(y),T=S[y];if(C.configurationDefaultOverrides.push({value:T,source:k}),e.$Ko.test(y)){const $=this.o(y,T,k,C.configurationDefaultOverrideValue);if(!$)continue;C.configurationDefaultOverrideValue=$,this.n(y,$,k),u.push(...r(y))}else{const $=this.p(y,T,k,C.configurationDefaultOverrideValue);if(!$)continue;C.configurationDefaultOverrideValue=$;const w=this.e[y];w&&(this.A(y,w),this.w(y,w))}}this.q(u)}deregisterDefaultConfigurations(m){const g=new Set;this.m(m,g),this.j.fire(),this.k.fire({properties:g,defaultsOverrides:!0})}m(m,g){for(const u of m){const S=this.a.indexOf(u);S!==-1&&this.a.splice(S,1)}for(const{overrides:u,source:S}of m)for(const k in u){const y=this.b.get(k);if(!y)continue;const C=y.configurationDefaultOverrides.findIndex(T=>S?T.source?.id===S.id:T.value===u[k]);if(C!==-1){if(y.configurationDefaultOverrides.splice(C,1),y.configurationDefaultOverrides.length===0&&this.b.delete(k),e.$Ko.test(k)){let T;for(const $ of y.configurationDefaultOverrides)T=this.o(k,$.value,$.source,T);T&&!P.$ug(T.value)?(y.configurationDefaultOverrideValue=T,this.n(k,T,S)):(this.b.delete(k),delete this.e[k],delete this.c.properties[k])}else{let T;for(const w of y.configurationDefaultOverrides)T=this.p(k,w.value,w.source,T);y.configurationDefaultOverrideValue=T;const $=this.e[k];$&&(this.A(k,$),this.w(k,$))}g.add(k)}}this.y()}n(m,g,u){const S={type:"object",default:g.value,description:N.localize(1663,null,(0,R.$mj)(m)),$ref:e.$Ho,defaultDefaultValue:g.value,source:u,defaultValueSource:u};this.e[m]=S,this.c.properties[m]=S}o(m,g,u,S){const k=S?.value||{},y=S?.source??new Map;if(!(y instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const C of Object.keys(g)){const T=g[C];if(P.$jg(T)&&(P.$og(k[C])||P.$jg(k[C]))){if(k[C]={...k[C]??{},...T},u)for(const w in T)y.set(`${C}.${w}`,u)}else k[C]=T,u?y.set(C,u):y.delete(C)}return{value:k,source:y}}p(m,g,u,S){const k=this.e[m],y=S?.value??k?.defaultDefaultValue;let C=u;if(P.$jg(g)&&(k!==void 0&&k.type==="object"||k===void 0&&(P.$og(y)||P.$jg(y)))){if(C=S?.source??new Map,!(C instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const $ in g)u&&C.set(`${m}.${$}`,u);g={...P.$jg(y)?y:{},...g}}return{value:g,source:C}}deltaConfiguration(m){let g=!1;const u=new Set;m.removedDefaults&&(this.m(m.removedDefaults,u),g=!0),m.addedDefaults&&(this.l(m.addedDefaults,u),g=!0),m.removedConfigurations&&this.s(m.removedConfigurations,u),m.addedConfigurations&&this.r(m.addedConfigurations,!1,u),this.j.fire(),this.k.fire({properties:u,defaultsOverrides:g})}notifyConfigurationSchemaUpdated(...m){this.j.fire()}registerOverrideIdentifiers(m){this.q(m),this.j.fire()}q(m){for(const g of m)this.i.add(g);this.y()}r(m,g,u){m.forEach(S=>{this.u(S,g,S.extensionInfo,S.restrictedProperties,void 0,u),this.d.push(S),this.v(S)})}s(m,g){const u=S=>{if(S.properties)for(const k in S.properties){g.add(k);const y=this.e[k];y?.policy?.name&&this.f.delete(y.policy.name),delete this.e[k],this.x(k,S.properties[k])}S.allOf?.forEach(k=>u(k))};for(const S of m){u(S);const k=this.d.indexOf(S);k!==-1&&this.d.splice(k,1)}}u(m,g=!0,u,S,k=I.WINDOW,y){k=P.$qg(m.scope)?k:m.scope;const C=m.properties;if(C)for(const $ in C){const w=C[$];if(g&&i($,w)){delete C[$];continue}if(w.source=u,w.defaultDefaultValue=C[$].default,this.A($,w),e.$Ko.test($)?w.scope=void 0:(w.scope=P.$qg(w.scope)?k:w.scope,w.restricted=P.$qg(w.restricted)?!!S?.includes($):w.restricted),C[$].hasOwnProperty("included")&&!C[$].included){this.g[$]=C[$],delete C[$];continue}else this.e[$]=C[$],C[$].policy?.name&&this.f.set(C[$].policy.name,$);!C[$].deprecationMessage&&C[$].markdownDeprecationMessage&&(C[$].deprecationMessage=C[$].markdownDeprecationMessage),y.add($)}const T=m.allOf;if(T)for(const $ of T)this.u($,g,u,S,k,y)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const m=new Map;for(const[g,u]of this.b)u.configurationDefaultOverrideValue&&m.set(g,u.configurationDefaultOverrideValue);return m}v(m){const g=u=>{const S=u.properties;if(S)for(const y in S)this.w(y,S[y]);u.allOf?.forEach(g)};g(m)}w(m,g){switch(e.$Bo.properties[m]=g,g.scope){case I.APPLICATION:e.$Co.properties[m]=g;break;case I.MACHINE:e.$Do.properties[m]=g;break;case I.MACHINE_OVERRIDABLE:e.$Eo.properties[m]=g;break;case I.WINDOW:e.$Fo.properties[m]=g;break;case I.RESOURCE:e.$Go.properties[m]=g;break;case I.LANGUAGE_OVERRIDABLE:e.$Go.properties[m]=g,this.h.properties[m]=g;break}}x(m,g){switch(delete e.$Bo.properties[m],g.scope){case I.APPLICATION:delete e.$Co.properties[m];break;case I.MACHINE:delete e.$Do.properties[m];break;case I.MACHINE_OVERRIDABLE:delete e.$Eo.properties[m];break;case I.WINDOW:delete e.$Fo.properties[m];break;case I.RESOURCE:case I.LANGUAGE_OVERRIDABLE:delete e.$Go.properties[m],delete this.h.properties[m];break}}y(){for(const m of this.i.values()){const g=`[${m}]`,u={type:"object",description:N.localize(1664,null),errorMessage:N.localize(1665,null),$ref:e.$Ho};this.A(g,u),e.$Bo.properties[g]=u,e.$Co.properties[g]=u,e.$Do.properties[g]=u,e.$Eo.properties[g]=u,e.$Fo.properties[g]=u,e.$Go.properties[g]=u}}z(){const m={type:"object",description:N.localize(1666,null),errorMessage:N.localize(1667,null),$ref:e.$Ho};e.$Bo.patternProperties[e.$Jo]=m,e.$Co.patternProperties[e.$Jo]=m,e.$Do.patternProperties[e.$Jo]=m,e.$Eo.patternProperties[e.$Jo]=m,e.$Fo.patternProperties[e.$Jo]=m,e.$Go.patternProperties[e.$Jo]=m,this.j.fire()}A(m,g){const u=this.b.get(m)?.configurationDefaultOverrideValue;let S,k;u&&(!g.disallowConfigurationDefault||!u.source)&&(S=u.value,k=u.source),P.$og(S)&&(S=g.defaultDefaultValue,k=void 0),P.$og(S)&&(S=d(g.type)),g.default=S,g.defaultValueSource=k}}const E="\\[([^\\]]+)\\]",f=new RegExp(E,"g");e.$Jo=`^(${E})+$`,e.$Ko=new RegExp(e.$Jo);function r(c){const m=[];if(e.$Ko.test(c)){let g=f.exec(c);for(;g?.length;){const u=g[1].trim();u&&m.push(u),g=f.exec(c)}}return(0,v.$Ob)(m)}function l(c){return c.reduce((m,g)=>`${m}[${g}]`,"")}function d(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const a=new h;p.$vo.add(e.$Ao.Configuration,a);function i(c,m){return c.trim()?e.$Ko.test(c)?N.localize(1669,null,c):a.getConfigurationProperties()[c]!==void 0?N.localize(1670,null,c):m.policy?.name&&a.getPolicyConfigurations().get(m.policy?.name)!==void 0?N.localize(1671,null,c,m.policy?.name,a.getPolicyConfigurations().get(m.policy?.name)):null:N.localize(1668,null)}function n(){const c=[],m=a.getConfigurationProperties();for(const g of Object.keys(m))c.push([g,m[g].scope]);return c.push(["launch",I.RESOURCE]),c.push(["task",I.RESOURCE]),c}function t(c){const m={};for(const g of c){const u=g.properties;if(P.$jg(u))for(const S in u)m[S]=u[S];g.allOf&&Object.assign(m,t(g.allOf))}return m}function o(c){switch(c){case"application":return I.APPLICATION;case"machine":return I.MACHINE;case"resource":return I.RESOURCE;case"machine-overridable":return I.MACHINE_OVERRIDABLE;case"language-overridable":return I.LANGUAGE_OVERRIDABLE;default:return I.WINDOW}}}),define(Re[174],Te([1,0,17,6,137,4,27,25,14,2,43,53,28,29]),function(we,e,v,D,P,N,R,O,p,s,I,b,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Vo=e.$Uo=e.$To=e.$So=void 0,e.$Wo=n,v=qe(v),P=qe(P),O=qe(O),p=qe(p);function f(m){return Object.isFrozen(m)?m:O.$jo(m)}class r{static createEmptyModel(g){return new r({},[],[],void 0,g)}constructor(g,u,S,k,y){this.b=g,this.c=u,this.d=S,this.raw=k,this.f=y,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const g=this.raw.map(u=>{if(u instanceof r)return u;const S=new l("",this.f);return S.parseRaw(u),S.configurationModel});this.g=g.reduce((u,S)=>S===u?S:u.merge(S),g[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(g){return g?(0,I.$kj)(this.contents,g):this.contents}inspect(g,u){const S=this;return{get value(){return f(S.rawConfiguration.getValue(g))},get override(){return u?f(S.rawConfiguration.getOverrideValue(g,u)):void 0},get merged(){return f(u?S.rawConfiguration.override(u).getValue(g):S.rawConfiguration.getValue(g))},get overrides(){const k=[];for(const{contents:y,identifiers:C,keys:T}of S.rawConfiguration.overrides){const $=new r(y,T,[],void 0,S.f).getValue(g);$!==void 0&&k.push({identifiers:C,value:$})}return k.length?f(k):void 0}}}getOverrideValue(g,u){const S=this.j(u);return S?g?(0,I.$kj)(S,g):S:void 0}getKeysForOverrideIdentifier(g){const u=[];for(const S of this.overrides)S.identifiers.includes(g)&&u.push(...S.keys);return v.$Ob(u)}getAllOverrideIdentifiers(){const g=[];for(const u of this.overrides)g.push(...u.identifiers);return v.$Ob(g)}override(g){let u=this.a.get(g);return u||(u=this.h(g),this.a.set(g,u)),u}merge(...g){const u=O.$io(this.contents),S=O.$io(this.overrides),k=[...this.keys],y=this.raw?.length?[...this.raw]:[this];for(const C of g)if(y.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.i(u,C.contents);for(const T of C.overrides){const[$]=S.filter(w=>v.$wb(w.identifiers,T.identifiers));$?(this.i($.contents,T.contents),$.keys.push(...T.keys),$.keys=v.$Ob($.keys)):S.push(O.$io(T))}for(const T of C.keys)k.indexOf(T)===-1&&k.push(T)}return new r(u,k,S,y.every(C=>C instanceof r)?void 0:y,this.f)}h(g){const u=this.j(g);if(!u||typeof u!="object"||!Object.keys(u).length)return this;const S={};for(const k of v.$Ob([...Object.keys(this.contents),...Object.keys(u)])){let y=this.contents[k];const C=u[k];C&&(typeof y=="object"&&typeof C=="object"?(y=O.$io(y),this.i(y,C)):y=C),S[k]=y}return new r(S,this.keys,this.overrides,void 0,this.f)}i(g,u){for(const S of Object.keys(u)){if(S in g&&p.$jg(g[S])&&p.$jg(u[S])){this.i(g[S],u[S]);continue}g[S]=O.$io(u[S])}}j(g){let u=null,S=null;const k=y=>{y&&(S?this.i(S,y):S=O.$io(y))};for(const y of this.overrides)y.identifiers.length===1&&y.identifiers[0]===g?u=y.contents:y.identifiers.includes(g)&&k(y.contents);return k(u),S}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(g,u){this.k(g,u,!0)}setValue(g,u){this.k(g,u,!1)}removeValue(g){const u=this.keys.indexOf(g);u!==-1&&(this.keys.splice(u,1),(0,I.$jj)(this.contents,g),b.$Ko.test(g)&&this.overrides.splice(this.overrides.findIndex(S=>v.$wb(S.identifiers,(0,b.$Lo)(g))),1))}k(g,u,S){if((0,I.$ij)(this.contents,g,u,k=>this.f.error(k)),S=S||this.keys.indexOf(g)===-1,S&&this.keys.push(g),b.$Ko.test(g)){const k=(0,b.$Lo)(g),y={identifiers:k,keys:Object.keys(this.contents[g]),contents:(0,I.$hj)(this.contents[g],T=>this.f.error(T))},C=this.overrides.findIndex(T=>v.$wb(T.identifiers,k));C!==-1?this.overrides[C]=y:this.overrides.push(y)}}}e.$So=r;class l{constructor(g,u){this.f=g,this.g=u,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||r.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(g,u){if(!p.$qg(g)){const S=this.h(g);this.parseRaw(S,u)}}reparse(g){this.a&&this.parseRaw(this.a,g)}parseRaw(g,u){this.a=g;const{contents:S,keys:k,overrides:y,restricted:C,hasExcludedProperties:T}=this.i(g,u);this.b=new r(S,k,y,T?[g]:void 0,this.g),this.c=C||[]}h(g){let u={},S=null,k=[];const y=[],C=[];function T(w){Array.isArray(k)?k.push(w):S!==null&&(k[S]=w)}const $={onObjectBegin:()=>{const w={};T(w),y.push(k),k=w,S=null},onObjectProperty:w=>{S=w},onObjectEnd:()=>{k=y.pop()},onArrayBegin:()=>{const w=[];T(w),y.push(k),k=w,S=null},onArrayEnd:()=>{k=y.pop()},onLiteralValue:T,onError:(w,M,A)=>{C.push({error:w,offset:M,length:A})}};if(g)try{P.$0n(g,$),u=k[0]||{}}catch(w){this.g.error(`Error while parsing settings file ${this.f}: ${w}`),this.d=[w]}return u}i(g,u){const S=E.$vo.as(b.$Ao.Configuration).getConfigurationProperties(),k=this.j(g,S,!0,u);g=k.raw;const y=(0,I.$hj)(g,$=>this.g.error(`Conflict in settings file ${this.f}: ${$}`)),C=Object.keys(g),T=this.l(g,$=>this.g.error(`Conflict in settings file ${this.f}: ${$}`));return{contents:y,keys:C,overrides:T,restricted:k.restricted,hasExcludedProperties:k.hasExcludedProperties}}j(g,u,S,k){let y=!1;if(!k?.scopes&&!k?.skipRestricted&&!k?.exclude?.length)return{raw:g,restricted:[],hasExcludedProperties:y};const C={},T=[];for(const $ in g)if(b.$Ko.test($)&&S){const w=this.j(g[$],u,!1,k);C[$]=w.raw,y=y||w.hasExcludedProperties,T.push(...w.restricted)}else{const w=u[$],M=w?typeof w.scope<"u"?w.scope:b.ConfigurationScope.WINDOW:void 0;w?.restricted&&T.push($),!k.exclude?.includes($)&&(k.include?.includes($)||(M===void 0||k.scopes===void 0||k.scopes.includes(M))&&!(k.skipRestricted&&w?.restricted))?C[$]=g[$]:y=!0}return{raw:C,restricted:T,hasExcludedProperties:y}}l(g,u){const S=[];for(const k of Object.keys(g))if(b.$Ko.test(k)){const y={};for(const C in g[k])y[C]=g[k][C];S.push({identifiers:(0,b.$Lo)(k),keys:Object.keys(y),contents:(0,I.$hj)(y,u)})}return S}}e.$To=l;class d extends N.$Xc{constructor(g,u,S,k,y){super(),this.c=g,this.f=u,this.g=k,this.h=y,this.b=this.B(new D.$oe),this.onDidChange=this.b.event,this.a=new l(this.c.toString(),y),this.B(this.g.watch(S.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(D.Event.any(D.Event.filter(this.g.onDidFilesChange,C=>C.contains(this.c)),D.Event.filter(this.g.onDidRunOperation,C=>(C.isOperation(h.FileOperation.CREATE)||C.isOperation(h.FileOperation.COPY)||C.isOperation(h.FileOperation.DELETE)||C.isOperation(h.FileOperation.WRITE))&&S.isEqual(C.resource,g)))(()=>this.b.fire()))}async loadConfiguration(){try{const g=await this.g.readFile(this.c);return this.a.parse(g.value.toString()||"{}",this.f),this.a.configurationModel}catch{return r.createEmptyModel(this.h)}}reparse(g){return g&&(this.f=g),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Uo=d;class a{constructor(g,u,S,k,y,C,T,$,w,M,A,L,J){this.a=g,this.b=u,this.c=S,this.overrideIdentifiers=k,this.d=y,this.f=C,this.g=T,this.h=$,this.i=w,this.j=M,this.k=A,this.l=L,this.m=J}get value(){return f(this.c)}n(g){return g?.value!==void 0||g?.override!==void 0||g?.overrides!==void 0?g:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(g,u,S,k,y,C,T,$,w,M){this.j=g,this.l=u,this.m=S,this.n=k,this.p=y,this.q=C,this.r=T,this.s=$,this.t=w,this.u=M,this.h=null,this.i=new R.$Dc,this.v=null}getValue(g,u,S){return this.w(g,u,S).getValue(g)}updateValue(g,u,S={}){let k;S.resource?(k=this.t.get(S.resource),k||(k=r.createEmptyModel(this.u),this.t.set(S.resource,k))):k=this.s,u===void 0?k.removeValue(g):k.setValue(g,u),S.resource||(this.h=null)}inspect(g,u,S){const k=this.w(g,u,S),y=this.A(u.resource,S),C=u.resource?this.t.get(u.resource)||this.s:this.s,T=new Set;for(const $ of k.overrides)for(const w of $.identifiers)k.getOverrideValue(g,w)!==void 0&&T.add(w);return new a(g,u,k.getValue(g),T.size?[...T]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,S?this.q:void 0,y||void 0,C)}keys(g){const u=this.A(void 0,g);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:u?u.keys.slice(0):[]}}updateDefaultConfiguration(g){this.j=g,this.h=null,this.i.clear()}updatePolicyConfiguration(g){this.l=g}updateApplicationConfiguration(g){this.m=g,this.h=null,this.i.clear()}updateLocalUserConfiguration(g){this.n=g,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(g){this.p=g,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(g){this.q=g,this.h=null,this.i.clear()}updateFolderConfiguration(g,u){this.r.set(g,u),this.i.delete(g)}deleteFolderConfiguration(g){this.folderConfigurations.delete(g),this.i.delete(g)}compareAndUpdateDefaultConfiguration(g,u){const S=[];if(!u){const{added:k,updated:y,removed:C}=o(this.j,g);u=[...k,...y,...C]}for(const k of u)for(const y of(0,b.$Lo)(k)){const C=this.j.getKeysForOverrideIdentifier(y),T=g.getKeysForOverrideIdentifier(y),$=[...T.filter(w=>C.indexOf(w)===-1),...C.filter(w=>T.indexOf(w)===-1),...C.filter(w=>!O.$mo(this.j.override(y).getValue(w),g.override(y).getValue(w)))];S.push([y,$])}return this.updateDefaultConfiguration(g),{keys:u,overrides:S}}compareAndUpdatePolicyConfiguration(g){const{added:u,updated:S,removed:k}=o(this.l,g),y=[...u,...S,...k];return y.length&&this.updatePolicyConfiguration(g),{keys:y,overrides:[]}}compareAndUpdateApplicationConfiguration(g){const{added:u,updated:S,removed:k,overrides:y}=o(this.applicationConfiguration,g),C=[...u,...S,...k];return C.length&&this.updateApplicationConfiguration(g),{keys:C,overrides:y}}compareAndUpdateLocalUserConfiguration(g){const{added:u,updated:S,removed:k,overrides:y}=o(this.localUserConfiguration,g),C=[...u,...S,...k];return C.length&&this.updateLocalUserConfiguration(g),{keys:C,overrides:y}}compareAndUpdateRemoteUserConfiguration(g){const{added:u,updated:S,removed:k,overrides:y}=o(this.remoteUserConfiguration,g),C=[...u,...S,...k];return C.length&&this.updateRemoteUserConfiguration(g),{keys:C,overrides:y}}compareAndUpdateWorkspaceConfiguration(g){const{added:u,updated:S,removed:k,overrides:y}=o(this.workspaceConfiguration,g),C=[...u,...S,...k];return C.length&&this.updateWorkspaceConfiguration(g),{keys:C,overrides:y}}compareAndUpdateFolderConfiguration(g,u){const S=this.folderConfigurations.get(g),{added:k,updated:y,removed:C,overrides:T}=o(S,u),$=[...k,...y,...C];return($.length||!S)&&this.updateFolderConfiguration(g,u),{keys:$,overrides:T}}compareAndDeleteFolderConfiguration(g){const u=this.folderConfigurations.get(g);if(!u)throw new Error("Unknown folder");this.deleteFolderConfiguration(g);const{added:S,updated:k,removed:y,overrides:C}=o(u,void 0);return{keys:[...S,...k,...y],overrides:C}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(g,u,S){let k=this.x(u,S);return u.overrideIdentifier&&(k=k.override(u.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(g)!==void 0&&(k=k.merge(this.l)),k}x({resource:g},u){let S=this.y();if(u&&g){const k=u.getFolder(g);k&&(S=this.z(k.uri)||S);const y=this.t.get(g);y&&(S=S.merge(y))}return S}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(g){let u=this.i.get(g);if(!u){const S=this.y(),k=this.r.get(g);k?(u=S.merge(k),this.i.set(g,u)):u=S}return u}A(g,u){if(u&&g){const S=u.getFolder(g);if(S)return this.r.get(S.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((g,u)=>{const{contents:S,overrides:k,keys:y}=this.r.get(u);return g.push([u,{contents:S,overrides:k,keys:y}]),g},[])}}allKeys(){const g=new Set;return this.j.keys.forEach(u=>g.add(u)),this.userConfiguration.keys.forEach(u=>g.add(u)),this.q.keys.forEach(u=>g.add(u)),this.r.forEach(u=>u.keys.forEach(S=>g.add(S))),[...g.values()]}B(){const g=new Set;return this.j.getAllOverrideIdentifiers().forEach(u=>g.add(u)),this.userConfiguration.getAllOverrideIdentifiers().forEach(u=>g.add(u)),this.q.getAllOverrideIdentifiers().forEach(u=>g.add(u)),this.r.forEach(u=>u.getAllOverrideIdentifiers().forEach(S=>g.add(S))),[...g.values()]}D(g){const u=new Set;return this.j.getKeysForOverrideIdentifier(g).forEach(S=>u.add(S)),this.userConfiguration.getKeysForOverrideIdentifier(g).forEach(S=>u.add(S)),this.q.getKeysForOverrideIdentifier(g).forEach(S=>u.add(S)),this.r.forEach(S=>S.getKeysForOverrideIdentifier(g).forEach(k=>u.add(k))),[...u.values()]}static parse(g,u){const S=this.E(g.defaults,u),k=this.E(g.policy,u),y=this.E(g.application,u),C=this.E(g.user,u),T=this.E(g.workspace,u),$=g.folders.reduce((w,M)=>(w.set(s.URI.revive(M[0]),this.E(M[1],u)),w),new R.$Dc);return new i(S,k,y,C,r.createEmptyModel(u),T,$,r.createEmptyModel(u),new R.$Dc,u)}static E(g,u){return new r(g.contents,g.keys,g.overrides,void 0,u)}}e.$Vo=i;function n(...m){if(m.length===0)return{keys:[],overrides:[]};if(m.length===1)return m[0];const g=new Set,u=new Map;for(const k of m)k.keys.forEach(y=>g.add(y)),k.overrides.forEach(([y,C])=>{const T=(0,R.$Ac)(u,y,new Set);C.forEach($=>T.add($))});const S=[];return u.forEach((k,y)=>S.push([y,[...k.values()]])),{keys:[...g.values()],overrides:S}}class t{constructor(g,u,S,k,y){this.change=g,this.f=u,this.g=S,this.h=k,this.i=y,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const C of g.keys)this.affectedKeys.add(C);for(const[,C]of g.overrides)for(const T of C)this.affectedKeys.add(T);this.d=this.a;for(const C of this.affectedKeys)this.d+=C+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=i.parse(this.f.data,this.i)),this.j}affectsConfiguration(g,u){const S=this.a+g,k=this.d.indexOf(S);if(k<0)return!1;const y=k+S.length;if(y>=this.d.length)return!1;const C=this.d.charCodeAt(y);if(C!==this.b&&C!==this.c)return!1;if(u){const T=this.previousConfiguration?this.previousConfiguration.getValue(g,u,this.f?.workspace):void 0,$=this.g.getValue(g,u,this.h);return!O.$mo(T,$)}return!0}}e.$Xo=t;function o(m,g){const{added:u,removed:S,updated:k}=c(g?.rawConfiguration,m?.rawConfiguration),y=[],C=m?.getAllOverrideIdentifiers()||[],T=g?.getAllOverrideIdentifiers()||[];if(g){const $=T.filter(w=>!C.includes(w));for(const w of $)y.push([w,g.getKeysForOverrideIdentifier(w)])}if(m){const $=C.filter(w=>!T.includes(w));for(const w of $)y.push([w,m.getKeysForOverrideIdentifier(w)])}if(g&&m){for(const $ of C)if(T.includes($)){const w=c({contents:m.getOverrideValue(void 0,$)||{},keys:m.getKeysForOverrideIdentifier($)},{contents:g.getOverrideValue(void 0,$)||{},keys:g.getKeysForOverrideIdentifier($)});y.push([$,[...w.added,...w.removed,...w.updated]])}}return{added:u,removed:S,updated:k,overrides:y}}function c(m,g){const u=m?g?m.keys.filter(y=>g.keys.indexOf(y)===-1):[...m.keys]:[],S=g?m?g.keys.filter(y=>m.keys.indexOf(y)===-1):[...g.keys]:[],k=[];if(m&&g){for(const y of g.keys)if(m.keys.indexOf(y)!==-1){const C=(0,I.$kj)(g.contents,y),T=(0,I.$kj)(m.contents,y);O.$mo(C,T)||k.push(y)}}return{added:u,removed:S,updated:k}}}),define(Re[110],Te([1,0,12,3]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xl=e.RemoteAuthorityResolverErrorCode=e.$Wl=e.$Vl=e.RemoteConnectionType=e.$Ul=void 0,e.$Yl=s,e.$Ul=(0,D.$Ii)("remoteAuthorityResolverService");var P;(function(I){I[I.WebSocket=0]="WebSocket",I[I.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class N{constructor(b){this.id=b,this.type=P.Managed}toString(){return`Managed(${this.id})`}}e.$Vl=N;class R{constructor(b,h){this.host=b,this.port=h,this.type=P.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Wl=R;var O;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound",I.InvalidAuthority="InvalidAuthority"})(O||(e.RemoteAuthorityResolverErrorCode=O={}));class p extends v.$db{static isNotAvailable(b){return b instanceof p&&b._code===O.NotAvailable}static isTemporarilyNotAvailable(b){return b instanceof p&&b._code===O.TemporarilyNotAvailable}static isNoResolverFound(b){return b instanceof p&&b._code===O.NoResolverFound}static isInvalidAuthority(b){return b instanceof p&&b._code===O.InvalidAuthority}static isHandled(b){return b instanceof p&&b.isHandled}constructor(b,h=O.Unknown,E){super(b),this._message=b,this._code=h,this._detail=E,this.isHandled=h===O.NotAvailable&&E===!0,Object.setPrototypeOf(this,p.prototype)}}e.$Xl=p;function s(I){const b=I.indexOf("+");return b===-1?I:I.substring(0,b)}}),define(Re[62],Te([1,0,15]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=D,e.$mn=P,e.$nn=N,e.$on=R;function D(p){return p.scheme===v.Schemas.vscodeRemote?p.authority:void 0}function P(p){if(!p)return;const s=p.indexOf("+");return s<0?p:p.substr(0,s)}function N(p){const{host:s,port:I}=O(p);if(typeof I>"u")throw new Error(`Invalid remote authority: ${p}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:s,port:I}}function R(p,s){let{host:I,port:b}=O(p);return typeof b>"u"&&(b=s),{host:I,port:b}}function O(p){const s=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(s)return{host:s[1],port:parseInt(s[2],10)};const I=p.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const b=p.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:p,port:void 0}}}),define(Re[18],Te([1,0,13,3,62]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=e.$xn=e.$wn=e.$vn=e.TargetPlatform=e.ExtensionType=e.$un=e.$sn=e.$rn=e.$qn=e.$pn=void 0,e.$tn=N,e.$yn=b,e.$zn=h,e.$An=E,e.$Bn=f,e.$Cn=r,e.$Dn=l,v=qe(v),e.$pn="extensions.user.cache",e.$qn="extensions.builtin.cache",e.$rn="undefined_publisher",e.$sn=["ui","workspace","web"];function N(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.$un=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(R||(e.ExtensionType=R={}));var O;(function(d){d.WIN32_X64="win32-x64",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(O||(e.TargetPlatform=O={}));class p{constructor(a){this.value=a,this._lower=a.toLowerCase()}static equals(a,i){if(typeof a>"u"||a===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof a=="string"||typeof i=="string"){const n=typeof a=="string"?a:a.value,t=typeof i=="string"?i:i.value;return v.$If(n,t)}return a._lower===i._lower}static toKey(a){return typeof a=="string"?a.toLowerCase():a._lower}}e.$vn=p;class s{get size(){return this.c.size}constructor(a){if(this.c=new Set,a)for(const i of a)this.add(i)}add(a){this.c.add(p.toKey(a))}delete(a){return this.c.delete(p.toKey(a))}has(a){return this.c.has(p.toKey(a))}}e.$wn=s;class I{constructor(){this.c=new Map}clear(){this.c.clear()}delete(a){this.c.delete(p.toKey(a))}get(a){return this.c.get(p.toKey(a))}has(a){return this.c.has(p.toKey(a))}set(a,i){this.c.set(p.toKey(a),i)}values(){return this.c.values()}forEach(a){this.c.forEach(a)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$xn=I;function b(d){return h(d)}function h(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}function E(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}function f(d,a){if(a){const i=`onResolveRemoteAuthority:${(0,P.$mn)(a)}`;return!!d.activationEvents?.includes(i)}return!1}function r(d){return d.map(a=>{const[i,n]=a.split("@");return{proposalName:i,version:n?parseInt(n):void 0}})}function l(d){return d.map(a=>a.split("@")[0])}e.$En=(0,D.$Ii)("IBuiltinExtensionsScannerService")}),define(Re[111],Te([1,0,23,9,18,3]),function(we,e,v,D,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.$tp=e.$sp=e.$rp=e.ExtensionManagementErrorCode=e.$qp=e.ExtensionGalleryErrorCode=e.$pp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=void 0,e.$jp=O,e.$kp=p,e.$lp=s,e.$mp=I,e.$np=b,e.$op=h,e.$cp="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$dp=new RegExp(e.$cp),e.$ep="__web_extension",e.$fp="skipWalkthrough",e.$gp="extensionInstallSource",e.$hp="dependecyOrPackExtensionInstall",e.$ip="clientTargetPlatform";var R;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(R||(e.ExtensionInstallSource=R={}));function O(t){switch(t){case P.TargetPlatform.WIN32_X64:return"Windows 64 bit";case P.TargetPlatform.WIN32_ARM64:return"Windows ARM";case P.TargetPlatform.LINUX_X64:return"Linux 64 bit";case P.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case P.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case P.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case P.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case P.TargetPlatform.DARWIN_X64:return"Mac";case P.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case P.TargetPlatform.WEB:return"Web";case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;case P.TargetPlatform.UNKNOWN:return P.TargetPlatform.UNKNOWN;case P.TargetPlatform.UNDEFINED:return P.TargetPlatform.UNDEFINED}}function p(t){switch(t){case P.TargetPlatform.WIN32_X64:return P.TargetPlatform.WIN32_X64;case P.TargetPlatform.WIN32_ARM64:return P.TargetPlatform.WIN32_ARM64;case P.TargetPlatform.LINUX_X64:return P.TargetPlatform.LINUX_X64;case P.TargetPlatform.LINUX_ARM64:return P.TargetPlatform.LINUX_ARM64;case P.TargetPlatform.LINUX_ARMHF:return P.TargetPlatform.LINUX_ARMHF;case P.TargetPlatform.ALPINE_X64:return P.TargetPlatform.ALPINE_X64;case P.TargetPlatform.ALPINE_ARM64:return P.TargetPlatform.ALPINE_ARM64;case P.TargetPlatform.DARWIN_X64:return P.TargetPlatform.DARWIN_X64;case P.TargetPlatform.DARWIN_ARM64:return P.TargetPlatform.DARWIN_ARM64;case P.TargetPlatform.WEB:return P.TargetPlatform.WEB;case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;default:return P.TargetPlatform.UNKNOWN}}function s(t,o){switch(t){case v.Platform.Windows:return o==="x64"?P.TargetPlatform.WIN32_X64:o==="arm64"?P.TargetPlatform.WIN32_ARM64:P.TargetPlatform.UNKNOWN;case v.Platform.Linux:return o==="x64"?P.TargetPlatform.LINUX_X64:o==="arm64"?P.TargetPlatform.LINUX_ARM64:o==="arm"?P.TargetPlatform.LINUX_ARMHF:P.TargetPlatform.UNKNOWN;case"alpine":return o==="x64"?P.TargetPlatform.ALPINE_X64:o==="arm64"?P.TargetPlatform.ALPINE_ARM64:P.TargetPlatform.UNKNOWN;case v.Platform.Mac:return o==="x64"?P.TargetPlatform.DARWIN_X64:o==="arm64"?P.TargetPlatform.DARWIN_ARM64:P.TargetPlatform.UNKNOWN;case v.Platform.Web:return P.TargetPlatform.WEB}}function I(t,o){return o===P.TargetPlatform.WEB&&!t.includes(P.TargetPlatform.WEB)}function b(t,o,c){return I(o,c)?!1:t===P.TargetPlatform.UNDEFINED||t===P.TargetPlatform.UNIVERSAL?!0:t===P.TargetPlatform.UNKNOWN?!1:t===c}function h(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var E;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(E||(e.SortBy=E={}));var f;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(f||(e.SortOrder=f={}));var r;(function(t){t.Install="install",t.Uninstall="uninstall"})(r||(e.StatisticType=r={}));var l;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(l||(e.InstallOperation=l={})),e.$pp=(0,N.$Ii)("extensionGalleryService");var d;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting",t.Offline="Offline"})(d||(e.ExtensionGalleryErrorCode=d={}));class a extends Error{constructor(o,c){super(o),this.code=c,this.name=c}}e.$qp=a;var i;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(i||(e.ExtensionManagementErrorCode=i={}));class n extends Error{constructor(o,c){super(o),this.code=c,this.name=c}}e.$rp=n,e.$sp=(0,N.$Ii)("extensionManagementService"),e.$tp="extensionsIdentifiers/disabled",e.$up="extensionsIdentifiers/enabled",e.$vp=(0,N.$Ii)("IGlobalExtensionEnablementService"),e.$wp=(0,N.$Ii)("IExtensionTipsService"),e.$xp=(0,D.localize2)(1780,"Extensions"),e.$yp=(0,D.localize2)(1781,"Preferences")}),define(Re[112],Te([1,0,12,18]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cH=e.$bH=void 0;class P{constructor(){this.a=new Map,this.b=new WeakMap}register(R,O){this.a.set(R,O)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const O=Object.create(null);for(const p of R){const s=this.readActivationEvents(p);s.length>0&&(O[D.$vn.toKey(p.identifier)]=s)}return O}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const O=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let p=0;p<O.length;p++)O[p]==="onUri"&&(O[p]=`onUri:${D.$vn.toKey(R.identifier)}`);if(!R.contributes)return O;for(const p in R.contributes){const s=this.a.get(p);if(!s)continue;const I=R.contributes[p],b=Array.isArray(I)?I:[I];try{s(b,O)}catch(h){(0,v.$2)(h)}}return O}}e.$bH=P,e.$cH=new P});var si=this&&this.__importDefault||function(we){return we&&we.__esModule?we:{default:we}};define(Re[175],Te([1,0,24,36,9,281,18,105]),function(we,e,v,D,P,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=I,e.$5p=b,e.$6p=h,e.$7p=E,e.$8p=f,e.$9p=r,e.$0p=l,e.$$p=d,D=si(D),P=qe(P),N=qe(N);const p=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,s=/^-(\d{4})(\d{2})(\d{2})$/;function I(n){return n=n.trim(),n==="*"||p.test(n)}function b(n){if(!I(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=n.match(p);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function h(n){if(!n)return null;const t=n.majorBase,o=n.majorMustEqual,c=n.minorBase;let m=n.minorMustEqual;const g=n.patchBase;let u=n.patchMustEqual;n.hasCaret&&(t===0||(m=!1),u=!1);let S=0;if(n.preRelease){const k=s.exec(n.preRelease);if(k){const[,y,C,T]=k;S=Date.UTC(Number(y),Number(C)-1,Number(T))}}return{majorBase:t,majorMustEqual:o,minorBase:c,minorMustEqual:m,patchBase:g,patchMustEqual:u,isMinimum:n.hasGreaterEquals,notBefore:S}}function E(n,t,o){let c;typeof n=="string"?c=h(b(n)):c=n;let m;t instanceof Date?m=t.getTime():typeof t=="string"&&(m=new Date(t).getTime());let g;if(typeof o=="string"?g=h(b(o)):g=o,!c||!g)return!1;const u=c.majorBase,S=c.minorBase,k=c.patchBase;let y=g.majorBase,C=g.minorBase,T=g.patchBase;const $=g.notBefore;let w=g.majorMustEqual,M=g.minorMustEqual,A=g.patchMustEqual;return g.isMinimum?u>y?!0:u<y?!1:S>C?!0:S<C||m&&m<$?!1:k>=T:(u===1&&y===0&&(!w||!M||!A)&&(y=1,C=0,T=0,w=!0,M=!1,A=!1),u<y?!1:u>y?!w:S<C?!1:S>C?!M:k<T?!1:k>T?!A:!(m&&m<$))}function f(n,t,o,c,m,g){const u=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return u.push([D.default.Error,P.localize(1832,null)]),u;if(typeof c.name!="string")return u.push([D.default.Error,P.localize(1833,null,"name")]),u;if(typeof c.version!="string")return u.push([D.default.Error,P.localize(1834,null,"version")]),u;if(!c.engines)return u.push([D.default.Error,P.localize(1835,null,"engines")]),u;if(typeof c.engines.vscode!="string")return u.push([D.default.Error,P.localize(1836,null,"engines.vscode")]),u;if(typeof c.extensionDependencies<"u"&&!i(c.extensionDependencies))return u.push([D.default.Error,P.localize(1837,null,"extensionDependencies")]),u;if(typeof c.activationEvents<"u"){if(!i(c.activationEvents))return u.push([D.default.Error,P.localize(1838,null,"activationEvents")]),u;if(typeof c.main>"u"&&typeof c.browser>"u")return u.push([D.default.Error,P.localize(1839,null,"activationEvents","main","browser")]),u}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&u.push([D.default.Warning,P.localize(1840,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return u.push([D.default.Error,P.localize(1841,null,"main")]),u;{const y=(0,v.$jh)(o,c.main);(0,v.$dh)(y,o)||u.push([D.default.Warning,P.localize(1842,null,y.path,o.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return u.push([D.default.Error,P.localize(1843,null,"browser")]),u;{const y=(0,v.$jh)(o,c.browser);(0,v.$dh)(y,o)||u.push([D.default.Warning,P.localize(1844,null,y.path,o.path)])}}if(!N.valid(c.version))return u.push([D.default.Error,P.localize(1845,null)]),u;const S=[];if(!r(n,t,c,m,S))for(const y of S)u.push([D.default.Error,y]);if(g&&c.enabledApiProposals?.length){const y=[];if(!d([...c.enabledApiProposals],y))for(const C of y)u.push([D.default.Error,C])}return u}function r(n,t,o,c,m){return c||typeof o.main>"u"&&typeof o.browser>"u"?!0:a(n,t,o.engines.vscode,m)}function l(n,t,o){return n==="*"||a(t,o,n)}function d(n,t){if(n.length===0)return!0;const o=Array.isArray(t)?t:void 0,c=(o?void 0:t)??O.allApiProposals,m=[],g=(0,R.$Cn)(n);for(const{proposalName:u,version:S}of g){const k=c[u];k&&S&&k.version!==S&&m.push(P.localize(1846,null,u))}return o?.push(...m),m.length===0}function a(n,t,o,c=[]){const m=h(b(o));if(!m)return c.push(P.localize(1847,null,o)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return c.push(P.localize(1848,null,o)),!1}else if(!m.majorMustEqual)return c.push(P.localize(1849,null,o)),!1;return E(n,t,m)?!0:(c.push(P.localize(1850,null,n,o)),!1)}function i(n){if(!Array.isArray(n))return!1;for(let t=0,o=n.length;t<o;t++)if(typeof n[t]!="string")return!1;return!0}}),define(Re[176],Te([1,0,20,12,4,9,53,3,11,29]),function(we,e,v,D,P,N,R,O,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$_p=void 0,e.$bq=h,e.$cq=E,e.$dq=f,e.$eq=r,e.$fq=l,e.$gq=d,e.$_p=(0,O.$Ii)("requestService");class I{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const o in this.b)o.toLowerCase()==="authorization"||o.toLowerCase()==="proxy-authorization"?t[o]="*****":t[o]=this.b[o];this.a=t}return this.a}}class b extends P.$Xc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,N.localize)(2050,null),when:p.$vk.isEqualTo((0,p.$sk)(p.LogLevel.Trace)).serialize()})}async c(t,o,c){const m=`${t} #${++this.b}: ${o.url}`;this.a.trace(`${m} - begin`,o.type,new I(o.headers??{}));try{const g=await c();return this.a.trace(`${m} - end`,o.type,g.res.statusCode,g.res.headers),g}catch(g){throw this.a.error(`${m} - error`,o.type,(0,D.$_)(g)),g}}}e.$aq=b;function h(n){return n.res.statusCode&&n.res.statusCode>=200&&n.res.statusCode<300||n.res.statusCode===1223}function E(n){return n.res.statusCode===204}async function f(n){return E(n)?null:(await(0,v.$3e)(n.stream)).toString()}async function r(n){if(!h(n))throw new Error("Server returned "+n.res.statusCode);return f(n)}async function l(n){if(!h(n))throw new Error("Server returned "+n.res.statusCode);if(E(n))return null;const o=(await(0,v.$3e)(n.stream)).toString();try{return JSON.parse(o)}catch(c){throw c.message+=`:
`+o,c}}function d(n){i(n)}let a;function i(n){const t=s.$vo.as(R.$Ao.Configuration),o=a;a={id:"http",order:15,title:(0,N.localize)(2051,null),type:"object",scope:n,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,N.localize)(2052,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,N.localize)(2053,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,N.localize)(2054,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,N.localize)(2055,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,N.localize)(2056,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,N.localize)(2057,null),(0,N.localize)(2058,null),(0,N.localize)(2059,null),(0,N.localize)(2060,null)],default:"override",description:(0,N.localize)(2061,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,N.localize)(2062,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,N.localize)(2063,null),restricted:!0}}},t.updateConfigurations({add:[a],remove:o?[o]:[]})}i(R.ConfigurationScope.APPLICATION)}),define(Re[177],Te([1,0,23,79,38]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=R,e.$Ap=O;function N(p){if(v.$v===v.Platform.Linux&&/^penguin(\.|$)/i.test(p))return"chromebook"}function R(p,s,I,b,h,E,f,r,l,d){const a=Object.create(null);a["common.machineId"]=E,a["common.sqmId"]=f,a["common.devDeviceId"]=r,a.sessionID=(0,P.$5g)()+Date.now(),a.commitHash=b,a.version=h,a["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),a["common.platform"]=(0,v.$i)(v.$v),a["common.nodePlatform"]=D.$gc,a["common.nodeArch"]=I,a["common.product"]=d||"desktop",l&&(a["common.msftInternal"]=l);let i=0;const n=Date.now();Object.defineProperties(a,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),v.$m&&(a["common.snap"]="true");const t=N(s);return t&&(a["common.platformDetail"]=t),a}function O(p){const s=D.env.USERDNSDOMAIN;if(!s)return!1;const I=s.toLowerCase();return p.some(b=>I===b)}}),define(Re[113],Te([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=void 0,e.$cm=(0,v.$Ii)("telemetryService"),e.$dm=(0,v.$Ii)("customEndpointTelemetryService"),e.$em="telemetry.currentSessionDate",e.$fm="telemetry.firstSessionDate",e.$gm="telemetry.lastSessionDate",e.$hm="telemetry.machineId",e.$im="telemetry.sqmId",e.$jm="telemetry.devDeviceId",e.$km="telemetry",e.$lm="telemetry.telemetryLevel",e.$mm="telemetry.enableCrashReporter",e.$nm="telemetry.enableTelemetry";var D;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(D||(e.TelemetryLevel=D={}));var P;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(Re[63],Te([1,0,25,14,62,177,113]),function(we,e,v,D,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=e.$Gp=e.$Fp=e.$Ep=e.$Dp=e.$Cp=e.$Bp=void 0,e.$Ip=I,e.$Jp=b,e.$Kp=h,e.$Lp=E,e.$Mp=r,e.$Np=d,e.$Op=a,e.$Pp=t;class O{constructor(c){this.value=c,this.isTrustedTelemetryValue=!0}}e.$Bp=O;class p{constructor(){this.telemetryLevel=R.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Cp=p,e.$Dp=new p;class s{async publicLog(c,m,g){}async publicLogError(c,m,g){}}e.$Ep=s,e.$Fp="telemetry",e.$Gp="extensionTelemetryLog",e.$Hp={log:()=>null,flush:()=>Promise.resolve(null)};function I(o,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!o.enableTelemetry)}function b(o,c){return c.extensionTestsLocationURI?!0:!(c.isBuilt||c.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}function h(o){const c=o.getValue(R.$lm),m=o.getValue(R.$mm);if(o.getValue(R.$nm)===!1||m===!1)return R.TelemetryLevel.NONE;switch(c??R.TelemetryConfiguration.ON){case R.TelemetryConfiguration.ON:return R.TelemetryLevel.USAGE;case R.TelemetryConfiguration.ERROR:return R.TelemetryLevel.ERROR;case R.TelemetryConfiguration.CRASH:return R.TelemetryLevel.CRASH;case R.TelemetryConfiguration.OFF:return R.TelemetryLevel.NONE}}function E(o){const c={},m={},g={};l(o,g);for(let u in g){u=u.length>150?u.substr(u.length-149):u;const S=g[u];typeof S=="number"?m[u]=S:typeof S=="boolean"?m[u]=S?1:0:typeof S=="string"?(S.length>8192&&console.warn(`Telemetry property: ${u} has been trimmed to 8192, the original length is ${S.length}`),c[u]=S.substring(0,8191)):typeof S<"u"&&S!==null&&(c[u]=S)}return{properties:c,measurements:m}}const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(o){if(!o)return"none";const c=(0,P.$mn)(o);return f.has(c)?c:"other"}function l(o,c,m=0,g){if(o)for(const u of Object.getOwnPropertyNames(o)){const S=o[u],k=g?g+u:u;Array.isArray(S)?c[k]=(0,v.$no)(S):S instanceof Date?c[k]=S.toISOString():(0,D.$jg)(S)?m<2?l(S,c,m+1,k+"."):c[k]=(0,v.$no)(S):c[k]=S}}function d(o,c){const m=o.msftInternalDomains||[],g=c.getValue("telemetry.internalTesting");return(0,N.$Ap)(m)||g}function a(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}function i(o,c){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let m=o;const g=[];for(const y of c)for(;;){const C=y.exec(o);if(!C)break;g.push([C.index,y.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,S=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let k=0;for(m="";;){const y=S.exec(o);if(!y)break;const C=g.some(([T,$])=>y.index<$&&T<S.lastIndex);!u.test(y[0])&&!C&&(m+=o.substring(k,y.index)+"<REDACTED: user-file-path>",k=S.lastIndex)}return k<o.length&&(m+=o.substr(k)),m}function n(o){if(!o)return o;const c=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const m of c)if(m.regex.test(o))return`<REDACTED: ${m.label}>`;return o}function t(o,c){return(0,v.$ko)(o,m=>{if(m instanceof O||Object.hasOwnProperty.call(m,"isTrustedTelemetryValue"))return m.value;if(typeof m=="string"){let g=m.replaceAll("%20"," ");g=i(g,c);for(const u of c)g=g.replace(u,"");return g=n(g),g}})}}),define(Re[178],Te([1,0,13,111,18,23,2,12,79,63]),function(we,e,v,D,P,N,R,O,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=e.$Rp=void 0,e.$Qp=I,e.$Sp=f,e.$Tp=r,e.$Up=l,e.$Vp=d,e.$Wp=a,e.$Xp=i,e.$Yp=n,e.$1p=t,e.$2p=c;function I(m,g){return m.uuid&&g.uuid?m.uuid===g.uuid:m.id===g.id?!0:(0,v.$Df)(m.id,g.id)===0}const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class h{static create(g){const u=g.manifest?g.manifest.version:g.version,S=g.manifest?g.targetPlatform:g.properties.targetPlatform;return new h(g.identifier,u,S)}static parse(g){const u=b.exec(g);return u&&u[1]&&u[2]?new h({id:u[1]},u[2],u[4]||void 0):null}constructor(g,u,S=P.TargetPlatform.UNDEFINED){this.identifier=g,this.version=u,this.targetPlatform=S,this.id=g.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==P.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(g){return g instanceof h?I(this,g)&&this.version===g.version&&this.targetPlatform===g.targetPlatform:!1}}e.$Rp=h;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(m){const g=E.exec(m);return g&&g[1]?[l(g[1]),g[2]]:[l(m),void 0]}function r(m,g){return`${m}.${g}`}function l(m){return m.toLowerCase()}function d(m,g){return l(r(m??P.$rn,g))}function a(m,g){const u=[],S=k=>{for(const y of u)if(y.some(C=>I(g(C),g(k))))return y;return null};for(const k of m){const y=S(k);y?y.push(k):u.push([k])}return u}function i(m){return{id:m.identifier.id,name:m.manifest.name,galleryId:null,publisherId:m.publisherId,publisherName:m.manifest.publisher,publisherDisplayName:m.publisherDisplayName,dependencies:m.manifest.extensionDependencies&&m.manifest.extensionDependencies.length>0}}function n(m){return{id:new s.$Bp(m.identifier.id),name:new s.$Bp(m.name),version:m.version,galleryId:m.identifier.uuid,publisherId:m.publisherId,publisherName:m.publisher,publisherDisplayName:m.publisherDisplayName,isPreReleaseVersion:m.properties.isPreReleaseVersion,dependencies:!!(m.properties.dependencies&&m.properties.dependencies.length>0),isSigned:m.isSigned,...m.telemetryData}}e.$Zp=new P.$vn("pprice.better-merge");function t(m,g){const u=[],S=g.manifest.extensionDependencies?.slice(0)??[];for(;S.length;){const k=S.shift();if(k&&u.every(y=>!I(y.identifier,{id:k}))){const y=m.filter(C=>I(C.identifier,{id:k}));y.length===1&&(u.push(y[0]),S.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return u}async function o(m,g){if(!N.$l)return!1;let u;try{u=(await m.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{u=(await m.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(k){g.debug("Error while getting the os-release file.",(0,O.$_)(k))}}return!!u&&(u.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function c(m,g){const u=await o(m,g),S=(0,D.$lp)(u?"alpine":N.$v,p.$hc);return g.debug("ComputeTargetPlatform:",S),S}}),define(Re[179],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ls=v,e.$Ms=D,e.$Ns=P,e.$Os=N,e.$Ps=R,e.$Qs=O;function v(p){return[...p.entries()]}function D(p){return p?[...p.entries()]:[]}function P(p){return new Map(p)}function N(p){return new Map(p??[])}function R(p){return Array.from(p.entries()).map(s=>[s[0],v(s[1].map),D(s[1].descriptionMap)])}function O(p){return new Map(p.map(s=>[s[0],{map:P(s[1]),descriptionMap:N(s[2])}]))}}),define(Re[180],Te([1,0,3,31,29]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=e.$xs=e.$ws=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$vs=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.GeneralShellType=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$us=void 0,e.$us=new D.$Zj("terminalTabFocusMode",!1,!0);var N;(function(o){o.AutomationProfile="terminal.integrated.automationProfile.",o.DefaultProfile="terminal.integrated.defaultProfile.",o.Profiles="terminal.integrated.profiles."})(N||(e.TerminalSettingPrefix=N={}));var R;(function(o){o.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",o.AutomationProfileLinux="terminal.integrated.automationProfile.linux",o.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",o.AutomationProfileWindows="terminal.integrated.automationProfile.windows",o.ProfilesWindows="terminal.integrated.profiles.windows",o.ProfilesMacOs="terminal.integrated.profiles.osx",o.ProfilesLinux="terminal.integrated.profiles.linux",o.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",o.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",o.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",o.UseWslProfiles="terminal.integrated.useWslProfiles",o.TabsDefaultColor="terminal.integrated.tabs.defaultColor",o.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",o.TabsEnabled="terminal.integrated.tabs.enabled",o.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",o.TabsHideCondition="terminal.integrated.tabs.hideCondition",o.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",o.TabsShowActions="terminal.integrated.tabs.showActions",o.TabsLocation="terminal.integrated.tabs.location",o.TabsFocusMode="terminal.integrated.tabs.focusMode",o.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",o.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",o.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",o.CopyOnSelection="terminal.integrated.copyOnSelection",o.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",o.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",o.FontFamily="terminal.integrated.fontFamily",o.FontSize="terminal.integrated.fontSize",o.LetterSpacing="terminal.integrated.letterSpacing",o.LineHeight="terminal.integrated.lineHeight",o.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",o.TabStopWidth="terminal.integrated.tabStopWidth",o.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",o.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",o.BellDuration="terminal.integrated.bellDuration",o.FontWeight="terminal.integrated.fontWeight",o.FontWeightBold="terminal.integrated.fontWeightBold",o.CursorBlinking="terminal.integrated.cursorBlinking",o.CursorStyle="terminal.integrated.cursorStyle",o.CursorStyleInactive="terminal.integrated.cursorStyleInactive",o.CursorWidth="terminal.integrated.cursorWidth",o.Scrollback="terminal.integrated.scrollback",o.DetectLocale="terminal.integrated.detectLocale",o.DefaultLocation="terminal.integrated.defaultLocation",o.GpuAcceleration="terminal.integrated.gpuAcceleration",o.TerminalTitleSeparator="terminal.integrated.tabs.separator",o.TerminalTitle="terminal.integrated.tabs.title",o.TerminalDescription="terminal.integrated.tabs.description",o.RightClickBehavior="terminal.integrated.rightClickBehavior",o.MiddleClickBehavior="terminal.integrated.middleClickBehavior",o.Cwd="terminal.integrated.cwd",o.ConfirmOnExit="terminal.integrated.confirmOnExit",o.ConfirmOnKill="terminal.integrated.confirmOnKill",o.EnableBell="terminal.integrated.enableBell",o.EnableVisualBell="terminal.integrated.enableVisualBell",o.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",o.AllowChords="terminal.integrated.allowChords",o.AllowMnemonics="terminal.integrated.allowMnemonics",o.TabFocusMode="terminal.integrated.tabFocusMode",o.EnvMacOs="terminal.integrated.env.osx",o.EnvLinux="terminal.integrated.env.linux",o.EnvWindows="terminal.integrated.env.windows",o.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",o.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",o.ExperimentalWindowsUseConptyDll="terminal.integrated.experimental.windowsUseConptyDll",o.ShowExitAlert="terminal.integrated.showExitAlert",o.SplitCwd="terminal.integrated.splitCwd",o.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",o.WordSeparators="terminal.integrated.wordSeparators",o.EnableFileLinks="terminal.integrated.enableFileLinks",o.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",o.UnicodeVersion="terminal.integrated.unicodeVersion",o.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",o.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",o.HideOnStartup="terminal.integrated.hideOnStartup",o.CustomGlyphs="terminal.integrated.customGlyphs",o.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",o.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",o.InheritEnv="terminal.integrated.inheritEnv",o.ShowLinkHover="terminal.integrated.showLinkHover",o.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",o.AutoReplies="terminal.integrated.autoReplies",o.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",o.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",o.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",o.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",o.EnableImages="terminal.integrated.enableImages",o.SmoothScrolling="terminal.integrated.smoothScrolling",o.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",o.FocusAfterRun="terminal.integrated.focusAfterRun",o.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",o.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",o.DevMode="terminal.integrated.developer.devMode"})(R||(e.TerminalSettingId=R={}));var O;(function(o){o.Bash="bash",o.Fish="fish",o.Sh="sh",o.Csh="csh",o.Ksh="ksh",o.Zsh="zsh"})(O||(e.PosixShellType=O={}));var p;(function(o){o.CommandPrompt="cmd",o.Wsl="wsl",o.GitBash="gitbash"})(p||(e.WindowsShellType=p={}));var s;(function(o){o.PowerShell="pwsh",o.Python="python",o.Julia="julia",o.NuShell="nu"})(s||(e.GeneralShellType=s={}));var I;(function(o){o[o.Api=0]="Api",o[o.Process=1]="Process",o[o.Sequence=2]="Sequence",o[o.Config=3]="Config"})(I||(e.TitleEventSource=I={}));var b;(function(o){o.LocalPty="localPty",o.PtyHost="ptyHost",o.PtyHostWindow="ptyHostWindow",o.Logger="logger",o.Heartbeat="heartbeat"})(b||(e.TerminalIpcChannels=b={}));var h;(function(o){o.Cwd="cwd",o.InitialCwd="initialCwd",o.FixedDimensions="fixedDimensions",o.Title="title",o.ShellType="shellType",o.HasChildProcesses="hasChildProcesses",o.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",o.OverrideDimensions="overrideDimensions",o.FailedShellIntegrationActivation="failedShellIntegrationActivation",o.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(h||(e.ProcessPropertyType=h={})),e.$vs=(0,v.$Ii)("ptyService");var E;(function(o){o[o.BeatInterval=5e3]="BeatInterval",o[o.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",o[o.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",o[o.SecondWaitMultiplier=1]="SecondWaitMultiplier",o[o.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(E||(e.HeartbeatConstants=E={}));var f;(function(o){o[o.Panel=1]="Panel",o[o.Editor=2]="Editor"})(f||(e.TerminalLocation=f={}));var r;(function(o){o.TerminalView="view",o.Editor="editor"})(r||(e.TerminalLocationString=r={}));var l;(function(o){o[o.GraceTime=6e4]="GraceTime",o[o.ShortGraceTime=6e3]="ShortGraceTime"})(l||(e.LocalReconnectConstants=l={}));var d;(function(o){o[o.HighWatermarkChars=1e5]="HighWatermarkChars",o[o.LowWatermarkChars=5e3]="LowWatermarkChars",o[o.CharCountAckSize=5e3]="CharCountAckSize"})(d||(e.FlowControlConstants=d={}));var a;(function(o){o.GitBash="Git Bash",o.Pwsh="PowerShell"})(a||(e.ProfileSource=a={}));var i;(function(o){o[o.Off=0]="Off",o[o.FinalTerm=1]="FinalTerm",o[o.VSCode=2]="VSCode"})(i||(e.ShellIntegrationStatus=i={}));var n;(function(o){o[o.Unknown=0]="Unknown",o[o.Shutdown=1]="Shutdown",o[o.Process=2]="Process",o[o.User=3]="User",o[o.Extension=4]="Extension"})(n||(e.TerminalExitReason=n={})),e.$ws={Backend:"workbench.contributions.terminal.processBackend"};class t{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(c){const m=this.b(c.remoteAuthority);if(this.a.has(m))throw new Error(`A terminal backend with remote authority '${m}' was already registered.`);this.a.set(m,c)}getTerminalBackend(c){return this.a.get(this.b(c))}b(c){return c?.toLowerCase()??""}}P.$vo.add(e.$ws.Backend,new t),e.$xs=(0,v.$Ii)("localPtyService"),e.$ys=(0,v.$Ii)("terminalLogService")}),define(Re[181],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ryb=void 0;class v{constructor(P){this.b=P,this.a=new Map}dispose(){for(const P of this.a.values())P.dispose()}startBuffering(P,N,R=5){const O=N(p=>{const s=typeof p=="string"?p:p.data;let I=this.a.get(P);if(I){I.data.push(s);return}const b=setTimeout(()=>this.flushBuffer(P),R);I={data:[s],timeoutId:b,dispose:()=>{clearTimeout(b),this.flushBuffer(P),O.dispose()}},this.a.set(P,I)});return O}stopBuffering(P){this.a.get(P)?.dispose()}flushBuffer(P){const N=this.a.get(P);N&&(this.a.delete(P),this.b(P,N.data.join("")))}}e.$ryb=v}),define(Re[182],Te([1,0,10,98,282,35,6,14,2,9,78,29]),function(we,e,v,D,P,N,R,O,p,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Px=e.$Ox=e.$Nx=e.$Mx=e.$Lx=e.$Kx=e.IconFontDefinition=e.IconContribution=e.$Hx=void 0,e.$Ix=l,e.$Jx=d,b=qe(b),e.$Hx={IconContribution:"base.contributions.icons"};var h;(function(t){function o(c,m){let g=c.defaults;for(;N.ThemeIcon.isThemeIcon(g);){const u=r.getIcon(g.id);if(!u)return;g=u.defaults}return g}t.getDefinition=o})(h||(e.IconContribution=h={}));var E;(function(t){function o(m){return{weight:m.weight,style:m.style,src:m.src.map(g=>({format:g.format,location:g.location.toString()}))}}t.toJSONObject=o;function c(m){const g=u=>(0,O.$hg)(u)?u:void 0;if(m&&Array.isArray(m.src)&&m.src.every(u=>(0,O.$hg)(u.format)&&(0,O.$hg)(u.location)))return{weight:g(m.weight),style:g(m.style),src:m.src.map(u=>({format:u.format,location:p.URI.parse(u.location)}))}}t.fromJSONObject=c})(E||(e.IconFontDefinition=E={}));class f{constructor(){this.a=new R.$oe,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,s.localize)(2364,null)},fontCharacter:{type:"string",description:(0,s.localize)(2365,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${N.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(o,c,m,g){const u=this.b[o];if(u){if(m&&!u.description){u.description=m,this.d.properties[o].markdownDescription=`${m} $(${o})`;const y=this.e.enum.indexOf(o);y!==-1&&(this.e.enumDescriptions[y]=m),this.a.fire()}return u}const S={id:o,description:m,defaults:c,deprecationMessage:g};this.b[o]=S;const k={$ref:"#/definitions/icons"};return g&&(k.deprecationMessage=g),m&&(k.markdownDescription=`${m}: $(${o})`),this.d.properties[o]=k,this.e.enum.push(o),this.e.enumDescriptions.push(m||""),this.a.fire(),{id:o}}deregisterIcon(o){delete this.b[o],delete this.d.properties[o];const c=this.e.enum.indexOf(o);c!==-1&&(this.e.enum.splice(c,1),this.e.enumDescriptions.splice(c,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(o=>this.b[o])}getIcon(o){return this.b[o]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(o,c){const m=this.f[o];return m||(this.f[o]=c,this.a.fire(),c)}deregisterIconFont(o){delete this.f[o]}getIconFont(o){return this.f[o]}toString(){const o=(u,S)=>u.id.localeCompare(S.id),c=u=>{for(;N.ThemeIcon.isThemeIcon(u.defaults);)u=this.b[u.defaults.id];return`codicon codicon-${u?u.id:""}`},m=[];m.push("| preview     | identifier                        | default codicon ID                | description"),m.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const g=Object.keys(this.b).map(u=>this.b[u]);for(const u of g.filter(S=>!!S.description).sort(o))m.push(`|<i class="${c(u)}"></i>|${u.id}|${N.ThemeIcon.isThemeIcon(u.defaults)?u.defaults.id:u.id}|${u.description||""}|`);m.push("| preview     | identifier                        "),m.push("| ----------- | --------------------------------- |");for(const u of g.filter(S=>!N.ThemeIcon.isThemeIcon(S.defaults)).sort(o))m.push(`|<i class="${c(u)}"></i>|${u.id}|`);return m.join(`
`)}}const r=new f;b.$vo.add(e.$Hx.IconContribution,r);function l(t,o,c,m){return r.registerIcon(t,o,c,m)}function d(){return r}function a(){const t=(0,P.$4j)();for(const o in t){const c="\\"+t[o].toString(16);r.registerIcon(o,{fontCharacter:c})}}a(),e.$Kx="vscode://schemas/icons";const i=b.$vo.as(I.$wo.JSONContribution);i.registerSchema(e.$Kx,r.getIconSchema());const n=new v.$Uh(()=>i.notifySchemaChanged(e.$Kx),200);r.onDidChange(()=>{n.isScheduled()||n.schedule()}),e.$Lx=l("widget-close",D.$8j.close,(0,s.localize)(2366,null)),e.$Mx=l("goto-previous-location",D.$8j.arrowUp,(0,s.localize)(2367,null)),e.$Nx=l("goto-next-location",D.$8j.arrowDown,(0,s.localize)(2368,null)),e.$Ox=N.ThemeIcon.modify(D.$8j.sync,"spin"),e.$Px=N.ThemeIcon.modify(D.$8j.loading,"spin")}),define(Re[183],Te([1,0,6,4,23,2,43,3,11]),function(we,e,v,D,P,N,R,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ww=e.$Vw=e.$Sw=e.$Qw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Mw=e.$Lw=void 0,e.$Nw=b,e.$Ow=E,e.$Pw=f,e.$Rw=r,e.$Tw=l,e.$Uw=d,e.$Lw=(0,O.$Ii)("tunnelService"),e.$Mw=(0,O.$Ii)("sharedTunnelsService");var s;(function(n){n.Http="http",n.Https="https"})(s||(e.TunnelProtocol=s={}));var I;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(I||(e.TunnelPrivacyId=I={}));function b(n){return!!n.forwardPort}var h;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(h||(e.ProvidedOnAutoForward=h={}));function E(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(t)return{address:t[1],port:+t[2]}}function f(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const t=n.query.split("&");for(const o of t){const c=o.split("=")[1];if(/^https?:/.exec(c)){const m=E(N.URI.parse(c));if(m)return m}}}e.$Qw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function r(n){return e.$Qw.indexOf(n)>=0}e.$Sw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function l(n){return e.$Sw.indexOf(n)>=0}function d(n,t,o,c){if(o===P.OperatingSystem.Windows)return!1;if(o===P.OperatingSystem.Macintosh&&l(t)){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(c);if(m?.length===4&&parseInt(m[1])>=18)return!1}return n<1024}class a{constructor(t,o,c){this.remoteAddress=t,this.localAddress=o,this.b=c,this.a=new v.$oe,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Vw=a;let i=class extends D.$Xc{constructor(t,o){super(),this.r=t,this.s=o,this.a=new v.$oe,this.onTunnelOpened=this.a.event,this.b=new v.$oe,this.onTunnelClosed=this.b.event,this.c=new v.$oe,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const t=this.s.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.g=t,t?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.h=t.elevation,this.m=t.privacyOptions,this.j=t.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const t=[],o=Array.from(this.f.values());for(const c of o){const m=Array.from(c.values());for(const g of m){const u=await g.value;u&&typeof u!="string"&&t.push(u)}}return t}async dispose(){super.dispose();for(const t of this.f.values()){for(const{value:o}of t.values())await o.then(c=>typeof c!="string"?c?.dispose():void 0);t.clear()}this.f.clear()}setEnvironmentTunnel(t,o,c,m,g){this.z(t,o,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:o,localAddress:c,privacy:m,protocol:g,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,o){(l(t)||r(t))&&(t=e.$Qw[0]);const c=this.D(t,o);if(c)return++c.refcount,c.value}openTunnel(t,o,c,m,g,u=!1,S,k){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${o}:${c} on local port ${g}.`);const y=this.g??t;if(!y)return;if(o||(o="localhost"),m||(m=this.t),this.g&&this.n.has(c)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const C=this.F(y,o,c,m,g,u,S,k);return C?C.then(T=>{if(T){if(typeof T=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(o,c),T}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(o,c);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const $=this.w(T);return(T.tunnelRemoteHost!==o||T.tunnelRemotePort!==c)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),S&&T.privacy!==S&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire($),$}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),C)}w(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const o=this.f.get(t.tunnelRemoteHost);if(o){const c=o.get(t.tunnelRemotePort);c&&(c.refcount--,await this.y(t.tunnelRemoteHost,t.tunnelRemotePort,c))}}}}async y(t,o,c){if(c.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${o}.`);const m=c.value.then(async g=>{g&&typeof g!="string"&&(await g.dispose(!0),this.b.fire({host:g.tunnelRemoteHost,port:g.tunnelRemotePort}))});return this.f.has(t)&&this.f.get(t).delete(o),m}}async closeTunnel(t,o){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${o} `);const c=this.f.get(t);if(c&&c.has(o)){const m=c.get(o);m.refcount=0,await this.y(t,o,m)}}z(t,o,c){this.f.has(t)||this.f.set(t,new Map),this.f.get(t).set(o,{refcount:1,value:c})}async C(t,o){const c=this.f.get(t);if(c){const m=c.get(o),g=m?await m.value:void 0;(!g||typeof g=="string")&&c.delete(o),c.size===0&&this.f.delete(t)}}D(t,o){const c=[t];r(t)?(c.push(...e.$Qw),c.push(...e.$Sw)):l(t)&&c.push(...e.$Sw);const m=c.map(g=>this.f.get(g));for(const g of m){const u=g?.get(o);if(u)return u}}canTunnel(t){return!!E(t)}G(t,o,c,m,g,u,S){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${o}:${c} on local port ${m}.`);const k=c;this.n.add(k);const y=m===void 0?c:m,C={elevationRequired:g?this.isPortPrivileged(y):!1},T={remoteAddress:{host:o,port:c},localAddressPort:m,privacy:u,public:u?u!==I.Private:void 0,protocol:S},$=t.forwardPort(T,C);return $?(this.z(o,c,$),$.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(k)})):this.n.delete(k),$}};e.$Ww=i,e.$Ww=i=Ke([We(0,p.$dk),We(1,R.$cj)],i)}),define(Re[114],Te([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=void 0,e.$Nl=(0,v.$Ii)("IUriIdentityService")}),define(Re[184],Te([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Xw=void 0,e.$Xw=(0,v.$Ii)("editSessionIdentityService");var D;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(D||(e.EditSessionIdentityMatch=D={}))}),define(Re[185],Te([1,0,15]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zN=D,e.$AN=P,e.$BN=N,e.$CN=R,e.$DN=O;function D(p){return p.scheme!==v.Schemas.file&&p.scheme!==v.Schemas.vscodeRemote}function P(p){if(p.folders.length)return p.folders.every(s=>D(s.uri))?p.folders[0].uri:void 0;if(p.configuration&&D(p.configuration))return p.configuration}function N(p){return P(p)?.scheme}function R(p){return P(p)?.authority}function O(p){return P(p)!==void 0}}),define(Re[49],Te([1,0,9,22,48,24,2,3,15]),function(we,e,v,D,P,N,R,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$i=e.$8i=e.$7i=e.$6i=e.$5i=e.$3i=e.$2i=e.WorkbenchState=e.$Vi=e.$Ui=e.$Ri=void 0,e.$Si=s,e.$Ti=I,e.$Wi=b,e.$Xi=h,e.$Yi=E,e.$Zi=r,e.$1i=l,e.$4i=i,e.$9i=n,e.$0i=t,e.$_i=o,e.$aj=c,e.$bj=m,e.$Ri=(0,O.$Ii)("contextService");function s(g){const u=g;return typeof u?.id=="string"&&R.URI.isUri(u.uri)}function I(g){return typeof g?.id=="string"&&!s(g)&&!h(g)}e.$Ui={id:"ext-dev"},e.$Vi={id:"empty-window"};function b(g,u){if(typeof g=="string"||typeof g>"u")return typeof g=="string"?{id:(0,D.$qc)(g)}:u?e.$Ui:e.$Vi;const S=g;return S.configuration?{id:S.id,configPath:S.configuration}:S.folders.length===1?{id:S.id,uri:S.folders[0].uri}:{id:S.id}}function h(g){const u=g;return typeof u?.id=="string"&&R.URI.isUri(u.configPath)}function E(g){const u=g;if(u?.uri)return{id:u.id,uri:R.URI.revive(u.uri)};const S=g;if(S?.configPath)return{id:S.id,configPath:R.URI.revive(S.configPath)};if(g?.id)return{id:g.id}}var f;(function(g){g[g.EMPTY=1]="EMPTY",g[g.FOLDER=2]="FOLDER",g[g.WORKSPACE=3]="WORKSPACE"})(f||(e.WorkbenchState=f={}));function r(g){const u=g;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&Array.isArray(u.folders))}function l(g){const u=g;return!!(u&&typeof u=="object"&&R.URI.isUri(u.uri)&&typeof u.name=="string"&&typeof u.toResource=="function")}class d{constructor(u,S,k,y,C){this.h=u,this.j=k,this.k=y,this.l=C,this.c=P.$Oi.forUris(this.l,()=>!0),this.folders=S}update(u){this.h=u.id,this.k=u.configuration,this.j=u.transient,this.l=u.l,this.folders=u.folders}get folders(){return this.g}set folders(u){this.g=u,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(u){this.k=u}getFolder(u){return u&&this.c.findSubstr(u)||null}n(){this.c=P.$Oi.forUris(this.l,()=>!0);for(const u of this.folders)this.c.set(u.uri,u)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$2i=d;class a{constructor(u,S){this.raw=S,this.uri=u.uri,this.index=u.index,this.name=u.name}toResource(u){return(0,N.$jh)(this.uri,u)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$3i=a;function i(g){return new a({uri:g,index:0,name:(0,N.$fh)(g)},{uri:g.toString()})}e.$5i="code-workspace",e.$6i=`.${e.$5i}`,e.$7i=[{name:(0,v.localize)(2489,null),extensions:[e.$5i]}],e.$8i="workspace.json";function n(g,u){return N.$ah.isEqualOrParent(g,u.untitledWorkspacesHome)}function t(g){let u;return R.URI.isUri(g)?u=g:u=g.configuration,u?.scheme===p.Schemas.tmp}e.$$i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function o(g){return g.id===e.$$i}function c(g,u){return!n(g,u)&&!t(g)}function m(g){return(typeof g=="string"?(0,D.$rc)(g):(0,N.$hh)(g))===e.$6i}}),define(Re[115],Te([1,0,76,6,4,24,2,9,107,28,3,11,49,27,114,10,38,13,14]),function(we,e,v,D,P,N,R,O,p,s,I,b,h,E,f,r,l,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=e.$Pl=e.ProfileResourceType=void 0,e.$Ol=n,e.$Ql=t,e.$Rl=o;var i;(function(g){g.Settings="settings",g.Keybindings="keybindings",g.Snippets="snippets",g.Tasks="tasks",g.Extensions="extensions",g.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function n(g){const u=g;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&typeof u.isDefault=="boolean"&&typeof u.name=="string"&&R.URI.isUri(u.location)&&R.URI.isUri(u.globalStorageHome)&&R.URI.isUri(u.settingsResource)&&R.URI.isUri(u.keybindingsResource)&&R.URI.isUri(u.tasksResource)&&R.URI.isUri(u.snippetsHome)&&R.URI.isUri(u.extensionsResource))}e.$Pl=(0,I.$Ii)("IUserDataProfilesService");function t(g,u){return{id:g.id,isDefault:g.isDefault,name:g.name,shortName:g.shortName,icon:g.icon,location:R.URI.revive(g.location).with({scheme:u}),globalStorageHome:R.URI.revive(g.globalStorageHome).with({scheme:u}),settingsResource:R.URI.revive(g.settingsResource).with({scheme:u}),keybindingsResource:R.URI.revive(g.keybindingsResource).with({scheme:u}),tasksResource:R.URI.revive(g.tasksResource).with({scheme:u}),snippetsHome:R.URI.revive(g.snippetsHome).with({scheme:u}),extensionsResource:R.URI.revive(g.extensionsResource).with({scheme:u}),cacheHome:R.URI.revive(g.cacheHome).with({scheme:u}),useDefaultFlags:g.useDefaultFlags,isTransient:g.isTransient}}function o(g,u,S,k,y,C){return{id:g,name:u,location:S,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:C&&y?.useDefaultFlags?.globalState?C.globalStorageHome:(0,N.$jh)(S,"globalStorage"),settingsResource:C&&y?.useDefaultFlags?.settings?C.settingsResource:(0,N.$jh)(S,"settings.json"),keybindingsResource:C&&y?.useDefaultFlags?.keybindings?C.keybindingsResource:(0,N.$jh)(S,"keybindings.json"),tasksResource:C&&y?.useDefaultFlags?.tasks?C.tasksResource:(0,N.$jh)(S,"tasks.json"),snippetsHome:C&&y?.useDefaultFlags?.snippets?C.snippetsHome:(0,N.$jh)(S,"snippets"),extensionsResource:C&&y?.useDefaultFlags?.extensions?C.extensionsResource:(0,N.$jh)(S,"extensions.json"),cacheHome:(0,N.$jh)(k,g),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let c=class extends P.$Xc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(u,S,k,y){super(),this.t=u,this.u=S,this.w=k,this.y=y,this.f=!0,this.h=this.B(new D.$oe),this.onDidChangeProfiles=this.h.event,this.j=this.B(new D.$oe),this.onWillCreateProfile=this.j.event,this.m=this.B(new D.$oe),this.onWillRemoveProfile=this.m.event,this.n=this.B(new D.$oe),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new E.$Dc,workspaces:new E.$Dc,emptyWindows:new Map},this.profilesHome=(0,N.$jh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,N.$jh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(u){this.f!==u&&(this.z=void 0,this.f=u)}isEnabled(){return this.f}get C(){if(!this.z){const u=this.D(),S=[u];if(this.f)try{for(const C of this.O()){if(!C.name||!(0,a.$hg)(C.name)||!C.location){this.y.warn("Skipping the invalid stored profile",C.location||C.name);continue}S.push(o((0,N.$gh)(C.location),C.name,C.location,this.g,{shortName:C.shortName,icon:C.icon,useDefaultFlags:C.useDefaultFlags},u))}}catch(C){this.y.error(C)}const k=new E.$Dc,y=new Map;if(S.length)try{const C=this.Q();if(C.workspaces)for(const[T,$]of Object.entries(C.workspaces)){const w=R.URI.parse(T),M=S.find(A=>A.id===$);M&&k.set(w,M)}if(C.emptyWindows)for(const[T,$]of Object.entries(C.emptyWindows)){const w=S.find(M=>M.id===$);w&&y.set(T,w)}}catch(C){this.y.error(C)}this.z={profiles:S,workspaces:k,emptyWindows:y}}return this.z}D(){const u=o("__default__profile__",(0,O.localize)(2442,null),this.t.userRoamingDataHome,this.g);return{...u,extensionsResource:this.S()??u.extensionsResource,isDefault:!0}}async createTransientProfile(u){const S="Temp",k=new RegExp(`${(0,d.$kf)(S)}\\s(\\d+)`);let y=0;for(const T of this.profiles){const $=k.exec(T.name),w=$?parseInt($[1]):0;y=w>y?w:y}const C=`${S} ${y+1}`;return this.createProfile((0,v.$wj)((0,l.$5g)()).toString(16),C,{transient:!0},u)}async createNamedProfile(u,S,k){return this.createProfile((0,v.$wj)((0,l.$5g)()).toString(16),u,S,k)}async createProfile(u,S,k,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const C=await this.F(u,S,k);return y&&await this.setProfileForWorkspace(y,C),C}async F(u,S,k){if(!(0,a.$hg)(S)||!S)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get(S);return y||(y=(async()=>{try{if(this.profiles.find(w=>w.name===S||w.id===u))throw new Error(`Profile with ${S} name already exists`);const T=o(u,S,(0,N.$jh)(this.profilesHome,u),this.g,k,this.defaultProfile);await this.u.createFolder(T.location);const $=[];return this.j.fire({profile:T,join(w){$.push(w)}}),await r.Promises.settled($),this.I([T],[],[]),T}finally{this.r.delete(S)}})(),this.r.set(S,y)),y}async updateProfile(u,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let k=this.profiles.find(y=>y.id===u.id);if(!k)throw new Error(`Profile '${u.name}' does not exist`);return k=o(k.id,S.name??k.name,k.location,this.g,{shortName:S.shortName??k.shortName,icon:S.icon===null?void 0:S.icon??k.icon,transient:S.transient??k.isTransient,useDefaultFlags:S.useDefaultFlags??k.useDefaultFlags},this.defaultProfile),this.I([],[],[k]),k}async removeProfile(u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(u.isDefault)throw new Error("Cannot remove default profile");const S=this.profiles.find(y=>y.id===u.id);if(!S)throw new Error(`Profile '${u.name}' does not exist`);const k=[];this.m.fire({profile:S,join(y){k.push(y)}});try{await Promise.allSettled(k)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])S.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])S.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[S],[]);try{await this.u.del(S.cacheHome,{recursive:!0})}catch(y){(0,s.$ul)(y)!==s.FileOperationResult.FILE_NOT_FOUND&&this.y.error(y)}}async setProfileForWorkspace(u,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=this.profiles.find(y=>y.id===S.id);if(!k)throw new Error(`Profile '${S.name}' does not exist`);this.L(u,k)}unsetWorkspace(u,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(u,void 0,S)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const u=await this.u.resolve(this.profilesHome);await Promise.all((u.children||[]).filter(S=>S.isDirectory&&this.profiles.every(k=>!this.w.extUri.isEqual(k.location,S.resource))).map(S=>this.u.del(S.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const u=this.s.profiles.filter(S=>!this.H(S));await Promise.allSettled(u.map(S=>this.removeProfile(S)))}getProfileForWorkspace(u){const S=this.G(u),k=R.URI.isUri(S)?this.C.workspaces.get(S):this.C.emptyWindows.get(S);return k||((0,h.$Si)(u)?this.s.folders.get(u.uri):(0,h.$Xi)(u)?this.s.workspaces.get(u.configPath):this.s.emptyWindows.get(u.id))}G(u){return(0,h.$Si)(u)?u.uri:(0,h.$Xi)(u)?u.configPath:u.id}H(u){return!!([...this.C.emptyWindows.values()].some(S=>this.w.extUri.isEqual(S.location,u.location))||[...this.C.workspaces.values()].some(S=>this.w.extUri.isEqual(S.location,u.location))||[...this.s.emptyWindows.values()].some(S=>this.w.extUri.isEqual(S.location,u.location))||[...this.s.workspaces.values()].some(S=>this.w.extUri.isEqual(S.location,u.location))||[...this.s.folders.values()].some(S=>this.w.extUri.isEqual(S.location,u.location)))}I(u,S,k){const y=[...this.profiles,...u],C=[],T=this.s.profiles;this.s.profiles=[];for(let $ of y){if($.isDefault||S.some(M=>$.id===M.id))continue;$=k.find(M=>$.id===M.id)??$;const w=T.find(M=>$.id===M.id);if($.isTransient)this.s.profiles.push($);else{if(w){for(const[M,A]of this.s.emptyWindows.entries())if($.id===A.id){this.L({id:M},$);break}for(const[M,A]of this.s.workspaces.entries())if($.id===A.id){this.L({id:"",configPath:M},$);break}for(const[M,A]of this.s.folders.entries())if($.id===A.id){this.L({id:"",uri:M},$);break}}C.push({location:$.location,name:$.name,shortName:$.shortName,icon:$.icon,useDefaultFlags:$.useDefaultFlags})}}this.P(C),this.z=void 0,this.J(u,S,k)}J(u,S,k){this.h.fire({added:u,removed:S,updated:k,all:this.profiles})}L(u,S,k){if(k=S?.isTransient?!0:k,k)(0,h.$Si)(u)?(this.s.folders.delete(u.uri),S&&this.s.folders.set(u.uri,S)):(0,h.$Xi)(u)?(this.s.workspaces.delete(u.configPath),S&&this.s.workspaces.set(u.configPath,S)):(this.s.emptyWindows.delete(u.id),S&&this.s.emptyWindows.set(u.id,S));else{this.L(u,void 0,!0);const y=this.G(u);R.URI.isUri(y)?(this.C.workspaces.delete(y),S&&this.C.workspaces.set(y,S)):(this.C.emptyWindows.delete(y),S&&this.C.emptyWindows.set(y,S)),this.M()}}M(){const u={};for(const[k,y]of this.C.workspaces.entries())u[k.toString()]=y.id;const S={};for(const[k,y]of this.C.emptyWindows.entries())S[k.toString()]=y.id;this.R({workspaces:u,emptyWindows:S}),this.z=void 0}N(u){const S={},k=this.D();if(u.workspaces)for(const[C,T]of Object.entries(u.workspaces)){const $=R.URI.parse(T);S[C]=this.w.extUri.isEqual($,k.location)?k.id:this.w.extUri.basename($)}const y={};if(u.emptyWindows)for(const[C,T]of Object.entries(u.emptyWindows)){const $=R.URI.parse(T);y[C]=this.w.extUri.isEqual($,k.location)?k.id:this.w.extUri.basename($)}return{workspaces:S,emptyWindows:y}}O(){return[]}P(u){throw new Error("not implemented")}Q(){return{}}R(u){throw new Error("not implemented")}S(){}};e.$Sl=c,e.$Sl=c=Ke([We(0,p.$Pi),We(1,s.$dl),We(2,f.$Nl),We(3,b.$dk)],c);class m extends c{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(u){this.a=u}Q(){return this.X}R(u){this.X=u}}e.$Tl=m}),define(Re[186],Te([1,0,10,6,4,64,14,152,3,115]),function(we,e,v,D,P,N,R,O,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=e.$oq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$mq=e.$lq=e.$kq=void 0,e.$nq=E,e.$pq=r,e.$rq=d,e.$kq="__$__isNewStorageMarker",e.$lq="__$__targetStorageMarker",e.$mq=(0,p.$Ii)("storageService");var I;(function(a){a[a.NONE=0]="NONE",a[a.SHUTDOWN=1]="SHUTDOWN"})(I||(e.WillSaveStateReason=I={}));var b;(function(a){a[a.APPLICATION=-1]="APPLICATION",a[a.PROFILE=0]="PROFILE",a[a.WORKSPACE=1]="WORKSPACE"})(b||(e.StorageScope=b={}));var h;(function(a){a[a.USER=0]="USER",a[a.MACHINE=1]="MACHINE"})(h||(e.StorageTarget=h={}));function E(a){const i=a.get(e.$lq);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class f extends P.$Xc{static{this.a=60*1e3}constructor(i={flushInterval:f.a}){super(),this.m=i,this.b=this.B(new D.$re),this.c=this.B(new D.$re),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.$oe),this.onWillSaveState=this.f.event,this.h=this.B(new v.$Uh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new P.$Yc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,n,t){return D.Event.filter(this.b.event,o=>o.scope===i&&(n===void 0||o.key===n),t)}n(){this.j.value=(0,v.$Yh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,P.$Sc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,N.mark)("code/willInitStorage");try{await this.O()}finally{(0,N.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,n){const{key:t,external:o}=n;if(t===e.$lq){switch(i){case b.APPLICATION:this.H=void 0;break;case b.PROFILE:this.F=void 0;break;case b.WORKSPACE:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:t,target:this.J(i)[t],external:o})}w(i){this.f.fire({reason:i})}get(i,n,t){return this.P(n)?.get(i,t)}getBoolean(i,n,t){return this.P(n)?.getBoolean(i,t)}getNumber(i,n,t){return this.P(n)?.getNumber(i,t)}getObject(i,n,t){return this.P(n)?.getObject(i,t)}storeAll(i,n){this.y(()=>{for(const t of i)this.store(t.key,t.value,t.scope,t.target,n)})}store(i,n,t,o,c=!1){if((0,R.$qg)(n)){this.remove(i,t,c);return}this.y(()=>{this.z(i,t,o),this.P(t)?.set(i,n,c)})}remove(i,n,t=!1){this.y(()=>{this.z(i,n,void 0),this.P(n)?.delete(i,t)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,n){const t=[],o=this.J(i);for(const c of Object.keys(o))o[c]===n&&t.push(c);return t}z(i,n,t,o=!1){const c=this.J(n);typeof t=="number"?c[i]!==t&&(c[i]=t,this.P(n)?.set(e.$lq,JSON.stringify(c),o)):typeof c[i]=="number"&&(delete c[i],this.P(n)?.set(e.$lq,JSON.stringify(c),o))}get D(){return this.C||(this.C=this.L(b.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(b.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(b.APPLICATION)),this.H}J(i){switch(i){case b.APPLICATION:return this.I;case b.PROFILE:return this.G;default:return this.D}}L(i){const n=this.P(i);return n?E(n):Object.create(null)}isNew(i){return this.getBoolean(e.$kq,i)===!0}async flush(i=I.NONE){this.f.fire({reason:i});const n=this.P(b.APPLICATION),t=this.P(b.PROFILE),o=this.P(b.WORKSPACE);switch(i){case I.NONE:await v.Promises.settled([n?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),o?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await v.Promises.settled([n?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),o?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(b.APPLICATION)?.items??new Map,n=this.P(b.PROFILE)?.items??new Map,t=this.P(b.WORKSPACE)?.items??new Map;return d(i,n,t,this.Q(b.APPLICATION)??"",this.Q(b.PROFILE)??"",this.Q(b.WORKSPACE)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,n){return this.w(I.NONE),(0,s.$Ol)(i)?this.R(i,n):this.S(i,n)}M(i,n){return!(i.id===n.id||r(n)&&r(i))}N(i,n,t){this.y(()=>{const o=new Set;for(const[c,m]of i)o.add(c),n.get(c)!==m&&this.u(t,{key:c,external:!0});for(const[c]of n.items)o.has(c)||this.u(t,{key:c,external:!0})})}}e.$oq=f;function r(a){return a.isDefault||!!a.useDefaultFlags?.globalState}class l extends f{constructor(){super(),this.U=this.B(new O.$iq(new O.$jq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new O.$iq(new O.$jq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new O.$iq(new O.$jq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(b.WORKSPACE,i))),this.B(this.W.onDidChangeStorage(i=>this.u(b.PROFILE,i))),this.B(this.U.onDidChangeStorage(i=>this.u(b.APPLICATION,i)))}P(i){switch(i){case b.APPLICATION:return this.U;case b.PROFILE:return this.W;default:return this.X}}Q(i){switch(i){case b.APPLICATION:return"inMemory (application)";case b.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$qq=l;async function d(a,i,n,t,o,c){const m=w=>{try{return JSON.parse(w)}catch{return w}},g=new Map,u=new Map;a.forEach((w,M)=>{g.set(M,w),u.set(M,m(w))});const S=new Map,k=new Map;i.forEach((w,M)=>{S.set(M,w),k.set(M,m(w))});const y=new Map,C=new Map;n.forEach((w,M)=>{y.set(M,w),C.set(M,m(w))}),console.group(t!==o?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const T=[];if(g.forEach((w,M)=>{T.push({key:M,value:w})}),console.table(T),console.groupEnd(),console.log(u),t!==o){console.group(`Storage: Profile (path: ${o}, profile specific)`);const w=[];S.forEach((M,A)=>{w.push({key:A,value:M})}),console.table(w),console.groupEnd(),console.log(k)}console.group(`Storage: Workspace (path: ${c})`);const $=[];y.forEach((w,M)=>{$.push({key:M,value:w})}),console.table($),console.groupEnd(),console.log(C)}}),define(Re[80],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xqc=void 0;class v{static{this.a=!1}constructor(P){this.d=P,this.b=new Map,this.c=1}add(P){const N=this.c++;return this.b.set(N,P),this.e(),N}get(P,N){return this.b.has(P)?this.b.get(P)[N]:void 0}delete(P){this.b.delete(P),this.e()}e(){v.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$xqc=v}),define(Re[50],Te([1,0,15,24,28,3]),function(we,e,v,D,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dqc=e.$Cqc=void 0;class R{constructor(){this.a=new Set(Object.keys(v.Schemas)),this.b=new Map,this.extUri=new D.$$g(p=>{const s=this.b.get(p.scheme);return!(s===void 0||s&P.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos(p,s){s===null?this.b.delete(p.scheme):this.b.set(p.scheme,s)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$Cqc=R,e.$Dqc=(0,N.$Ii)("IExtHostFileSystemInfo")}),define(Re[26],Te([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TQ=void 0,e.$TQ=(0,v.$Ii)("IExtHostInitDataService")}),define(Re[187],Te([1,0,9,11,172,26]),function(we,e,v,D,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qsc=void 0;let R=class extends P.$4R{constructor(p,s,I){const b=I.remote.isRemote?"remoteexthost":p?"workerexthost":"exthost",h=I.remote.isRemote?(0,v.localize)(2706,null):p?(0,v.localize)(2707,null):(0,v.localize)(2708,null);super(s.createLogger(b,{name:h}))}};e.$Qsc=R,e.$Qsc=R=Ke([We(1,D.$ek),We(2,N.$TQ)],R)}),define(Re[188],Te([1,0,10]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jrc=e.$irc=void 0;class D{constructor(R,O,p){this.h=new Map,this.a=R,this.b=O,this.c=p,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(s=>(this.f=s,this)),this.g=this.c.onDidChangeStorage(s=>{s.shared===this.b&&s.key===this.a&&(this.f=s.value)}),this.i=new v.$Uh(()=>{const s=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const I of s.values())I.complete()}catch(I){for(const b of s.values())b.error(I)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,O){let p=this.f[R];return typeof p>"u"&&(p=O),p}update(R,O){this.f[R]=O;const p=this.h.get(R);if(p!==void 0)return p.p;const s=new v.$6h;return this.h.set(R,s),this.i.isScheduled()||this.i.schedule(),s.p}dispose(){this.g.dispose()}}e.$irc=D;class P extends D{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,O){super(R.identifier.value,!0,O),this.j=R}}e.$jrc=P}),define(Re[189],Te([1,0,6,2]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$isc=void 0;class P{constructor(R){this.c=R,this.a=new v.$oe,this.onDidSaveNotebookDocument=this.a.event,this.b=new v.$oe,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,O,p,s){const b=this.c.getNotebookDocument(D.URI.revive(R)).acceptModelChanged(O.value,p,s);this.b.fire(b)}$acceptDirtyStateChanged(R,O){this.c.getNotebookDocument(D.URI.revive(R)).acceptDirty(O)}$acceptModelSaved(R){const O=this.c.getNotebookDocument(D.URI.revive(R));this.a.fire(O.apiNotebook)}}e.$isc=P}),define(Re[16],Te([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EQ=e.$DQ=void 0,e.$DQ=(0,v.$Ii)("IExtHostRpcService");class D{constructor(N){this.getProxy=N.getProxy.bind(N),this.set=N.set.bind(N),this.dispose=N.dispose.bind(N),this.assertRegistered=N.assertRegistered.bind(N),this.drain=N.drain.bind(N)}}e.$EQ=D}),define(Re[190],Te([1,0,18,6,4]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$src=void 0;class N{#e;constructor(O,p){this.disposables=new P.$Wc,this.a=v.$vn.toKey(O.identifier),this.#e=p,this.onDidChange=D.Event.map(D.Event.filter(this.#e.onDidChangePassword,s=>s.extensionId===this.a),s=>({key:s.key}),this.disposables)}dispose(){this.disposables.dispose()}get(O){return this.#e.get(this.a,O)}store(O,p){return this.#e.store(this.a,O,p)}delete(O){return this.#e.delete(this.a,O)}}e.$src=N}),define(Re[65],Te([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tqc=e.$Sqc=void 0,e.$Sqc=(0,v.$Ii)("IURITransformerService");class D{constructor(N){N?(this.transformIncoming=N.transformIncoming.bind(N),this.transformOutgoing=N.transformOutgoing.bind(N),this.transformOutgoingURI=N.transformOutgoingURI.bind(N),this.transformOutgoingScheme=N.transformOutgoingScheme.bind(N)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$Tqc=D});var si=this&&this.__importDefault||function(we){return we&&we.__esModule?we:{default:we}};define(Re[116],Te([1,0,9,14,2,4,3,29,28,15,42,164,36]),function(we,e,v,D,P,N,R,O,p,s,I,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$EG=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$uG=e.EditorInputCapabilities=e.$tG=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=void 0,e.$kG=r,e.$lG=l,e.$mG=d,e.$nG=a,e.$oG=i,e.$pG=n,e.$qG=t,e.$rG=o,e.$sG=c,e.$vG=y,e.$wG=T,e.$xG=$,e.$yG=w,e.$zG=M,e.$AG=A,e.$BG=L,e.$CG=J,e.$DG=le,e.$FG=re,e.$GG=x,e.$HG=$e,e.$IG=Pe,h=si(h),e.$fG={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$gG={id:"default",displayName:(0,v.localize)(4055,null),providerDisplayName:(0,v.localize)(4056,null)},e.$hG="workbench.editor.sidebysideEditor",e.$iG="workbench.editors.textDiffEditor",e.$jG="workbench.editors.binaryResourceDiffEditor";var E;(function(X){X[X.PROGRAMMATIC=1]="PROGRAMMATIC",X[X.USER=2]="USER",X[X.EDIT=3]="EDIT",X[X.NAVIGATION=4]="NAVIGATION",X[X.JUMP=5]="JUMP"})(E||(e.EditorPaneSelectionChangeReason=E={}));var f;(function(X){X[X.IDENTICAL=1]="IDENTICAL",X[X.SIMILAR=2]="SIMILAR",X[X.DIFFERENT=3]="DIFFERENT"})(f||(e.EditorPaneSelectionCompareResult=f={}));function r(X){const q=X;return!!q&&typeof q.getSelection=="function"&&!!q.onDidChangeSelection}function l(X){const q=X;return!!q&&typeof q.getScrollPosition=="function"&&typeof q.setScrollPosition=="function"&&!!q.onDidChangeScroll}function d(X,q,ne){for(const be of ne.visibleEditorPanes)if(be.group.id===q&&X.matches(be.input))return be.getViewState()}function a(X){if(y(X))return!1;const q=X;return P.URI.isUri(q?.resource)}function i(X){if(y(X))return!1;const q=X;return q?.original!==void 0&&q.modified!==void 0}function n(X){if(y(X))return!1;const q=X;return!q||q.resources&&!Array.isArray(q.resources)?!1:!!q.resources||!!q.multiDiffSource}function t(X){if(y(X)||i(X))return!1;const q=X;return q?.primary!==void 0&&q.secondary!==void 0}function o(X){if(y(X))return!1;const q=X;return q?q.resource===void 0||q.resource.scheme===s.Schemas.untitled||q.forceUntitled===!0:!1}function c(X){if(y(X))return!1;const q=X;return P.URI.isUri(q?.base?.resource)&&P.URI.isUri(q?.input1?.resource)&&P.URI.isUri(q?.input2?.resource)&&P.URI.isUri(q?.result?.resource)}var m;(function(X){X[X.SHORT=0]="SHORT",X[X.MEDIUM=1]="MEDIUM",X[X.LONG=2]="LONG"})(m||(e.Verbosity=m={}));var g;(function(X){X[X.EXPLICIT=1]="EXPLICIT",X[X.AUTO=2]="AUTO",X[X.FOCUS_CHANGE=3]="FOCUS_CHANGE",X[X.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(g||(e.SaveReason=g={}));class u{constructor(){this.a=new Map}registerSource(q,ne){let be=this.a.get(q);return be||(be={source:q,label:ne},this.a.set(q,be)),be.source}getSourceLabel(q){return this.a.get(q)?.label??q}}e.$tG=new u;var S;(function(X){X[X.None=0]="None",X[X.Readonly=2]="Readonly",X[X.Untitled=4]="Untitled",X[X.Singleton=8]="Singleton",X[X.RequiresTrust=16]="RequiresTrust",X[X.CanSplitInGroup=32]="CanSplitInGroup",X[X.ForceDescription=64]="ForceDescription",X[X.CanDropIntoEditor=128]="CanDropIntoEditor",X[X.MultipleEditors=256]="MultipleEditors",X[X.Scratchpad=512]="Scratchpad"})(S||(e.EditorInputCapabilities=S={}));class k extends N.$Xc{}e.$uG=k;function y(X){return X instanceof k}function C(X){const q=X;return P.URI.isUri(q?.preferredResource)}function T(X){const q=X;return y(q?.primary)&&y(q?.secondary)}function $(X){const q=X;return y(q?.modified)&&y(q?.original)}function w(X,q,ne,be,Ie){return Pe(be,[(0,b.$sj)({id:"workbench.action.openLargeFile",label:(0,v.localize)(4057,null),run:()=>{const Fe={...ne,limits:{size:Number.MAX_VALUE}};X.openEditor(q,Fe)}}),(0,b.$sj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,v.localize)(4058,null),run:()=>Ie.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:h.default.Warning})}function M(X){return y(X?.editor)}function A(X){const q=X;return M(X)&&q?.group!==void 0}function L(X){const q=X;return typeof q?.groupId=="number"&&y(q.editor)}function J(X){return typeof X?.groupId=="number"}var Y;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.REPLACE=1]="REPLACE",X[X.MOVE=2]="MOVE",X[X.UNPIN=3]="UNPIN"})(Y||(e.EditorCloseContext=Y={}));var z;(function(X){X[X.GROUP_ACTIVE=0]="GROUP_ACTIVE",X[X.GROUP_INDEX=1]="GROUP_INDEX",X[X.GROUP_LABEL=2]="GROUP_LABEL",X[X.GROUP_LOCKED=3]="GROUP_LOCKED",X[X.EDITORS_SELECTION=4]="EDITORS_SELECTION",X[X.EDITOR_OPEN=5]="EDITOR_OPEN",X[X.EDITOR_CLOSE=6]="EDITOR_CLOSE",X[X.EDITOR_MOVE=7]="EDITOR_MOVE",X[X.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",X[X.EDITOR_LABEL=9]="EDITOR_LABEL",X[X.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",X[X.EDITOR_PIN=11]="EDITOR_PIN",X[X.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",X[X.EDITOR_STICKY=13]="EDITOR_STICKY",X[X.EDITOR_DIRTY=14]="EDITOR_DIRTY",X[X.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(z||(e.GroupModelChangeKind=z={}));var Q;(function(X){X[X.PRIMARY=1]="PRIMARY",X[X.SECONDARY=2]="SECONDARY",X[X.BOTH=3]="BOTH",X[X.ANY=4]="ANY"})(Q||(e.SideBySideEditor=Q={}));class V{getOriginalUri(q,ne){if(!q)return;if(c(q))return e.$EG.getOriginalUri(q.result,ne);if(ne?.supportSideBySide){const{primary:Ie,secondary:Fe}=this.a(q);if(Ie&&Fe){if(ne?.supportSideBySide===Q.BOTH)return{primary:this.getOriginalUri(Ie,{filterByScheme:ne.filterByScheme}),secondary:this.getOriginalUri(Fe,{filterByScheme:ne.filterByScheme})};if(ne?.supportSideBySide===Q.ANY)return this.getOriginalUri(Ie,{filterByScheme:ne.filterByScheme})??this.getOriginalUri(Fe,{filterByScheme:ne.filterByScheme});q=ne.supportSideBySide===Q.PRIMARY?Ie:Fe}}if(i(q)||n(q)||t(q)||c(q))return;const be=C(q)?q.preferredResource:q.resource;return!be||!ne||!ne.filterByScheme?be:this.b(be,ne.filterByScheme)}a(q){return T(q)||t(q)?{primary:q.primary,secondary:q.secondary}:$(q)||i(q)?{primary:q.modified,secondary:q.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(q,ne){if(!q)return;if(c(q))return e.$EG.getCanonicalUri(q.result,ne);if(ne?.supportSideBySide){const{primary:Ie,secondary:Fe}=this.a(q);if(Ie&&Fe){if(ne?.supportSideBySide===Q.BOTH)return{primary:this.getCanonicalUri(Ie,{filterByScheme:ne.filterByScheme}),secondary:this.getCanonicalUri(Fe,{filterByScheme:ne.filterByScheme})};if(ne?.supportSideBySide===Q.ANY)return this.getCanonicalUri(Ie,{filterByScheme:ne.filterByScheme})??this.getCanonicalUri(Fe,{filterByScheme:ne.filterByScheme});q=ne.supportSideBySide===Q.PRIMARY?Ie:Fe}}if(i(q)||n(q)||t(q)||c(q))return;const be=q.resource;return!be||!ne||!ne.filterByScheme?be:this.b(be,ne.filterByScheme)}b(q,ne){if(Array.isArray(ne)){if(ne.some(be=>q.scheme===be))return q}else if(ne===q.scheme)return q}}var ie;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.KEYBOARD=1]="KEYBOARD",X[X.MOUSE=2]="MOUSE"})(ie||(e.EditorCloseMethod=ie={}));function le(X,q,ne,be){if(!X.isSticky(q))return!1;switch(be.preventPinnedEditorClose){case"keyboardAndMouse":return ne===ie.MOUSE||ne===ie.KEYBOARD;case"mouse":return ne===ie.MOUSE;case"keyboard":return ne===ie.KEYBOARD}return!1}e.$EG=new V;var _;(function(X){X[X.LEFT=0]="LEFT",X[X.RIGHT=1]="RIGHT"})(_||(e.CloseDirection=_={}));class oe{constructor(){this.c=new Map,this.d=new Map}start(q){const ne=this.a=q.get(R.$Hi);for(const[be,Ie]of this.c)this.e(be,Ie,ne);this.c.clear()}e(q,ne,be){const Ie=be.createInstance(ne);this.d.set(q,Ie)}registerFileEditorFactory(q){if(this.b)throw new Error("Can only register one file editor factory.");this.b=q}getFileEditorFactory(){return(0,D.$sg)(this.b)}registerEditorSerializer(q,ne){if(this.c.has(q)||this.d.has(q))throw new Error(`A editor serializer with type ID '${q}' was already registered.`);return this.a?this.e(q,ne,this.a):this.c.set(q,ne),(0,N.$Vc)(()=>{this.c.delete(q),this.d.delete(q)})}getEditorSerializer(q){return this.d.get(typeof q=="string"?q:q.typeId)}}O.$vo.add(e.$fG.EditorFactory,new oe);async function re(X,q,ne){return!X||!X.length?[]:await Promise.all(X.map(async be=>{const Ie=P.URI.revive(be.fileUri);if(!Ie){ne.info("Cannot resolve the path because it is not valid.",be);return}if(!await q.canHandleResource(Ie)){ne.info("Cannot resolve the path because it cannot be handled",be);return}let Be=be.exists,xe=be.type;if(typeof Be!="boolean"||typeof xe!="number")try{xe=(await q.stat(Ie)).isDirectory?p.FileType.Directory:p.FileType.Unknown,Be=!0}catch(ut){ne.error(ut),Be=!1}if(!Be&&be.openOnlyIfExists){ne.info("Cannot resolve the path because it does not exist",be);return}if(xe===p.FileType.Directory){ne.info("Cannot resolve the path because it is a directory",be);return}const nt={...be.options,pinned:!0};return Be?{resource:Ie,options:nt}:{resource:Ie,options:nt,forceUntitled:!0}}))}var ce;(function(X){X[X.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",X[X.SEQUENTIAL=1]="SEQUENTIAL"})(ce||(e.EditorsOrder=ce={}));function x(X){const q=X;if(!q)return!1;const ne=q;if(ne.modified)return x(ne.modified);const be=q;return!!(be.contributionsState&&be.viewState&&Array.isArray(be.cursorState))}function $e(X){return(0,I.$uj)(X)}function Pe(X,q,ne){const be=(0,I.$vj)(X,q);return be.forceMessage=ne?.forceMessage,be.forceSeverity=ne?.forceSeverity,be.allowDialog=ne?.allowDialog,be}}),define(Re[191],Te([1,0,6,9,3,4,27,29,25,98,182]),function(we,e,v,D,P,N,R,O,p,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QG=e.$PG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$OG=e.ViewContentGroups=e.$MG=e.ViewContainerLocation=e.Extensions=e.$LG=e.$KG=e.$JG=void 0,e.$NG=E,e.$JG="views",e.$KG=(0,D.localize)(4218,null),e.$LG=(0,I.$Ix)("default-view-icon",s.$8j.window,(0,D.localize)(4219,null));var b;(function(o){o.ViewContainersRegistry="workbench.registry.view.containers",o.ViewsRegistry="workbench.registry.view"})(b||(e.Extensions=b={}));var h;(function(o){o[o.Sidebar=0]="Sidebar",o[o.Panel=1]="Panel",o[o.AuxiliaryBar=2]="AuxiliaryBar"})(h||(e.ViewContainerLocation=h={})),e.$MG=[h.Sidebar,h.Panel,h.AuxiliaryBar];function E(o){switch(o){case h.Sidebar:return"sidebar";case h.Panel:return"panel";case h.AuxiliaryBar:return"auxiliarybar"}}class f extends N.$Xc{constructor(){super(...arguments),this.c=this.B(new v.$oe),this.onDidRegister=this.c.event,this.f=this.B(new v.$oe),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(c,m,g){const u=this.get(c.id);if(u)return u;const S=c;return S.openCommandActionDescriptor=g?.doNotRegisterOpenCommand?void 0:S.openCommandActionDescriptor??{id:S.id},(0,R.$Ac)(this.g,m,[]).push(S),g?.isDefault&&this.h.push(S),this.c.fire({viewContainer:S,viewContainerLocation:m}),S}deregisterViewContainer(c){for(const m of this.g.keys()){const g=this.g.get(m),u=g?.indexOf(c);if(u!==-1){g?.splice(u,1),g.length===0&&this.g.delete(m),this.f.fire({viewContainer:c,viewContainerLocation:m});return}}}get(c){return this.all.filter(m=>m.id===c)[0]}getViewContainers(c){return[...this.g.get(c)||[]]}getViewContainerLocation(c){return[...this.g.keys()].filter(m=>this.getViewContainers(m).filter(g=>g?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.h.find(m=>this.getViewContainerLocation(m)===c)}}O.$vo.add(b.ViewContainersRegistry,new f);var r;(function(o){o.Open="2_open",o.Debug="4_debug",o.SCM="5_scm",o.More="9_more"})(r||(e.ViewContentGroups=r={}));function l(o,c){const m=o.group??r.More,g=c.group??r.More;return m!==g?m.localeCompare(g):(o.order??5)-(c.order??5)}class d extends N.$Xc{constructor(){super(...arguments),this.c=this.B(new v.$oe),this.onViewsRegistered=this.c.event,this.f=this.B(new v.$oe),this.onViewsDeregistered=this.f.event,this.g=this.B(new v.$oe),this.onDidChangeContainer=this.g.event,this.h=this.B(new v.$oe),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Kc}registerViews(c,m){this.registerViews2([{views:c,viewContainer:m}])}registerViews2(c){c.forEach(({views:m,viewContainer:g})=>this.r(m,g)),this.c.fire(c)}deregisterViews(c,m){const g=this.s(c,m);g.length&&this.f.fire({views:g,viewContainer:m})}moveViews(c,m){for(const g of this.m.keys())if(g!==m){const u=this.s(c,g);u.length&&(this.r(u,m),this.g.fire({views:u,from:g,to:m}))}}getViews(c){return this.m.get(c)||[]}getView(c){for(const m of this.j){const g=(this.m.get(m)||[]).filter(u=>u.id===c)[0];if(g)return g}return null}getViewContainer(c){for(const m of this.j)if((this.m.get(m)||[]).filter(u=>u.id===c)[0])return m;return null}registerViewWelcomeContent(c,m){return this.n.add(c,m),this.h.fire(c),(0,N.$Vc)(()=>{this.n.delete(c,m),this.h.fire(c)})}registerViewWelcomeContent2(c,m){const g=new Map;for(const[u,S]of m)this.n.add(c,S),g.set(u,(0,N.$Vc)(()=>{this.n.delete(c,S),this.h.fire(c)}));return this.h.fire(c),g}getViewWelcomeContent(c){const m=[];return this.n.forEach(c,g=>m.push(g)),m.sort(l)}r(c,m){let g=this.m.get(m);g||(g=[],this.m.set(m,g),this.j.push(m));for(const u of c){if(this.getView(u.id)!==null)throw new Error((0,D.localize)(4220,null,u.id));g.push(u)}}s(c,m){const g=this.m.get(m);if(!g)return[];const u=[],S=[];for(const k of g)c.includes(k)?u.push(k):S.push(k);return u.length&&(S.length?this.m.set(m,S):(this.m.delete(m),this.j.splice(this.j.indexOf(m),1))),u}}O.$vo.add(b.ViewsRegistry,new d),e.$OG=(0,P.$Ii)("viewDescriptorService");var a;(function(o){o[o.Default=0]="Default",o[o.Expand=1]="Expand"})(a||(e.ViewVisibilityState=a={}));var i;(function(o){o[o.None=0]="None",o[o.Collapsed=1]="Collapsed",o[o.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class n{constructor(c,m){this.c=!1,this.d=!1,(0,p.$lo)(this,c),this.d=!!m,this.resolve=async g=>{if(m&&!this.c){const u=await m(g);u&&(this.tooltip=this.tooltip??u.tooltip,this.command=this.command??u.command)}g.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$PG=n;class t extends Error{constructor(c){super((0,D.localize)(4221,null,c)),this.name="NoTreeViewError"}static is(c){return!!c&&c.name==="NoTreeViewError"}}e.$QG=t}),define(Re[192],Te([1,0,9,31]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=void 0,e.$UG=new D.$Zj("chatSessionResponseVote","",{type:"string",description:(0,v.localize)(4707,null)}),e.$VG=new D.$Zj("chatVoteUpEnabled",!1,{type:"boolean",description:(0,v.localize)(4708,null)}),e.$WG=new D.$Zj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,v.localize)(4709,null)}),e.$XG=new D.$Zj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,v.localize)(4710,null)}),e.$YG=new D.$Zj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,v.localize)(4711,null)}),e.$ZG=new D.$Zj("chatSessionResponseError",!1,{type:"boolean",description:(0,v.localize)(4712,null)}),e.$1G=new D.$Zj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,v.localize)(4713,null)}),e.$2G=new D.$Zj("chatResponse",!1,{type:"boolean",description:(0,v.localize)(4714,null)}),e.$3G=new D.$Zj("chatRequest",!1,{type:"boolean",description:(0,v.localize)(4715,null)}),e.$4G=new D.$Zj("chatEditApplied",!1,{type:"boolean",description:(0,v.localize)(4716,null)}),e.$5G=new D.$Zj("chatInputHasText",!1,{type:"boolean",description:(0,v.localize)(4717,null)}),e.$6G=new D.$Zj("chatInputHasFocus",!1,{type:"boolean",description:(0,v.localize)(4718,null)}),e.$7G=new D.$Zj("inChatInput",!1,{type:"boolean",description:(0,v.localize)(4719,null)}),e.$8G=new D.$Zj("inChat",!1,{type:"boolean",description:(0,v.localize)(4720,null)}),e.$9G=new D.$Zj("chatIsEnabled",!1,{type:"boolean",description:(0,v.localize)(4721,null)}),e.$0G=new D.$Zj("chatCursorAtTop",!1),e.$$G=new D.$Zj("chatInputHasAgent",!1),e.$_G=new D.$Zj("chatLocation",void 0),e.$aH=new D.$Zj("quickChatHasFocus",!1,{type:"boolean",description:(0,v.localize)(4722,null)})}),define(Re[117],Te([1,0,283,10,19,6,40,4,33,144,13,31,18,3,11,109,176,186,192]),function(we,e,v,D,P,N,R,O,p,s,I,b,h,E,f,r,l,d,a){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.ChatAgentLocation=void 0,e.$jI=m,e.$kI=g;var n;(function(u){u.Panel="panel",u.Terminal="terminal",u.Notebook="notebook",u.Editor="editor"})(n||(e.ChatAgentLocation=n={})),function(u){function S(k){switch(k){case"panel":return u.Panel;case"terminal":return u.Terminal;case"notebook":return u.Notebook;case"editor":return u.Editor}return u.Panel}u.fromRaw=S}(n||(e.ChatAgentLocation=n={})),e.$eI=(0,E.$Ii)("chatAgentService");let t=class{static{this.AGENT_LEADER="@"}constructor(S){this.f=S,this.b=new Map,this.d=new N.$oe,this.onDidChangeAgents=this.d.event,this.g=new Map,this.i=new Map,this.e=a.$9G.bindTo(this.f)}registerAgent(S,k){if(this.getAgent(S))throw new Error(`Agent already registered: ${JSON.stringify(S)}`);const C=this,T=k.slashCommands;k={...k,get slashCommands(){return T.filter(w=>!w.when||C.f.contextMatchesRules(b.$Gj.deserialize(w.when)))}};const $={data:k};return this.b.set(S,$),(0,O.$Vc)(()=>{this.b.delete(S),this.d.fire(void 0)})}registerAgentImplementation(S,k){const y=this.b.get(S);if(!y)throw new Error(`Unknown agent: ${JSON.stringify(S)}`);if(y.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(S)}`);return y.data.isDefault&&this.e.set(!0),y.impl=k,this.d.fire(new o(y.data,k)),(0,O.$Vc)(()=>{y.impl=void 0,this.d.fire(void 0),y.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(S,k){S.isDynamic=!0;const y={data:S,impl:k};return this.b.set(S.id,y),this.d.fire(new o(S,k)),(0,O.$Vc)(()=>{this.b.delete(S.id),this.d.fire(void 0)})}registerAgentCompletionProvider(S,k){return this.g.set(S,k),{dispose:()=>{this.g.delete(S)}}}async getAgentCompletionItems(S,k,y){return await this.g.get(S)?.(k,y)??[]}updateAgent(S,k){const y=this.b.get(S);if(!y?.impl)throw new Error(`No activated agent with id ${JSON.stringify(S)} registered`);y.data.metadata={...y.data.metadata,...k},this.d.fire(new o(y.data,y.impl))}getDefaultAgent(S){return(0,v.$hb)(this.getActivatedAgents(),k=>!!k.isDefault&&k.locations.includes(S))}getContributedDefaultAgent(S){return this.getAgents().find(k=>!!k.isDefault&&k.locations.includes(S))}getSecondaryAgent(){return R.Iterable.find(this.b.values(),S=>!!S.data.metadata.isSecondary)?.data}getAgent(S){if(this.h(S))return this.b.get(S)?.data}h(S){const k=this.b.get(S);return!k?.data.when||this.f.contextMatchesRules(b.$Gj.deserialize(k.data.when))}getAgentByFullyQualifiedId(S){const k=R.Iterable.find(this.b.values(),y=>m(y.data)===S)?.data;if(!(k&&!this.h(k.id)))return k}getAgents(){return Array.from(this.b.values()).map(S=>S.data).filter(S=>this.h(S.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(S=>!!S.impl).filter(S=>this.h(S.data.id)).map(S=>new o(S.data,S.impl))}getAgentsByName(S){return this.getAgents().filter(k=>k.name===S)}agentHasDupeName(S){const k=this.getAgent(S);return k?this.getAgentsByName(k.name).filter(y=>y.extensionId.value!==k.extensionId.value).length>0:!1}async invokeAgent(S,k,y,C,T){const $=this.b.get(S);if(!$?.impl)throw new Error(`No activated agent with id "${S}"`);return await $.impl.invoke(k,y,C,T)}async getFollowups(S,k,y,C,T){const $=this.b.get(S);if(!$?.impl)throw new Error(`No activated agent with id "${S}"`);return $.impl?.provideFollowups?$.impl.provideFollowups(k,y,C,T):[]}async getChatTitle(S,k,y){const C=this.b.get(S);if(!C?.impl)throw new Error(`No activated agent with id "${S}"`);if(C.impl?.provideChatTitle)return C.impl.provideChatTitle(k,y)}registerChatParticipantDetectionProvider(S,k){return this.i.set(S,k),(0,O.$Vc)(()=>{this.i.delete(S)})}hasChatParticipantDetectionProviders(){return this.i.size>0}async detectAgentOrCommand(S,k,y,C){const T=R.Iterable.first(this.i.values());if(!T)return;const $=this.getAgents().reduce((L,J)=>{L.push({participant:J.id,disambiguation:J.disambiguation??[]});for(const Y of J.slashCommands)L.push({participant:J.id,command:Y.name,disambiguation:[]});return L},[]),w=await T.provideParticipantDetection(S,k,{...y,participants:$},C);if(!w)return;const M=this.getAgent(w.participant);if(!M)return;if(!w.command)return{agent:M};const A=M?.slashCommands.find(L=>L.name===w.command);if(A)return{agent:M,command:A}}};e.$fI=t,e.$fI=t=Ke([We(0,b.$1j)],t);class o{constructor(S,k){this.b=S,this.d=k}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get locations(){return this.b.locations}get disambiguation(){return this.b.disambiguation}async invoke(S,k,y,C){return this.d.invoke(S,k,y,C)}async provideFollowups(S,k,y,C){return this.d.provideFollowups?this.d.provideFollowups(S,k,y,C):[]}provideWelcomeMessage(S,k){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(S,k)}provideSampleQuestions(S,k){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(S,k)}toJSON(){return this.b}}e.$gI=o,e.$hI=(0,E.$Ii)("chatAgentNameService");let c=class{static{i=this}static{this.b="chat.participantNameRegistry"}constructor(S,k,y,C){if(this.g=k,this.h=y,this.i=C,this.e=(0,s.$9d)(this,Object.create(null)),this.f=!1,!S.chatParticipantRegistry)return;this.d=S.chatParticipantRegistry;const T=C.get(i.b,d.StorageScope.APPLICATION);try{this.e.set(JSON.parse(T??"{}"),void 0)}catch{C.remove(i.b,d.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(S=>this.h.warn("Failed to fetch chat participant registry",S)).then(()=>(0,D.$Jh)(5*60*1e3)).then(()=>this.j())}async k(){const S=await this.g.request({type:"GET",url:this.d},P.CancellationToken.None);if(S.res.statusCode!==200)throw new Error("Could not get extensions report.");const k=await(0,l.$fq)(S);if(!k||k.version!==1)throw new Error("Unexpected chat participant registry response.");const y=k.restrictedChatParticipants;this.e.set(y,void 0),this.i.store(i.b,JSON.stringify(y),d.StorageScope.APPLICATION,d.StorageTarget.MACHINE)}getAgentNameRestriction(S){const k=this.l(S.name,S).get(),y=!S.fullName||this.l(S.fullName.replace(/\s/g,""),S).get();return k&&y}l(S,k){return this.e.map(C=>C[S.toLowerCase()]).map(C=>C?C.some(T=>(0,I.$If)(T,T.includes(".")?k.extensionId.value:k.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$iI=c,e.$iI=c=i=Ke([We(0,r.$wk),We(1,l.$_p),We(2,f.$dk),We(3,d.$mq)],c);function m(u){return`${u.extensionId.value}.${u.id}`}function g(u){const S="name"in u?u:{...u,name:u.id};return"extensionPublisherId"in S||(S.extensionPublisherId=S.extensionPublisher??""),"extensionDisplayName"in S||(S.extensionDisplayName=""),"extensionId"in S||(S.extensionId=new h.$vn("")),(0,p.$fi)(S)}}),define(Re[193],Te([1,0,2,32,3]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MH=e.$LH=e.ChatCopyKind=e.ChatAgentVoteDirection=e.ChatResponseReferencePartStatusKind=void 0,e.$JH=N,e.$KH=R;function N(I){return!!I&&typeof I=="object"&&"uri"in I&&I.uri instanceof v.URI&&"version"in I&&typeof I.version=="number"&&"ranges"in I&&Array.isArray(I.ranges)&&I.ranges.every(D.$Ut.isIRange)}function R(I){return!!I&&typeof I=="object"&&"documents"in I&&Array.isArray(I.documents)&&I.documents.every(N)}var O;(function(I){I[I.Complete=1]="Complete",I[I.Partial=2]="Partial",I[I.Omitted=3]="Omitted"})(O||(e.ChatResponseReferencePartStatusKind=O={}));var p;(function(I){I[I.Down=0]="Down",I[I.Up=1]="Up"})(p||(e.ChatAgentVoteDirection=p={}));var s;(function(I){I[I.Action=1]="Action",I[I.Toolbar=2]="Toolbar"})(s||(e.ChatCopyKind=s={})),e.$LH=(0,P.$Ii)("IChatService"),e.$MH="accessibility.voice.keywordActivation"}),define(Re[194],Te([1,0,6,10,9]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dub=void 0;class N{constructor(){this.f=new Map,this.m=[],this.n=new v.$oe,this.o=new v.$oe,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(O){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=O}onEvent(O){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=O}onRequest(O){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=O}sendResponse(O){O.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${O.command}`)):this.u("response",O)}sendRequest(O,p,s,I){const b={command:O};if(p&&Object.keys(p).length>0&&(b.arguments=p),this.u("request",b),typeof I=="number"){const h=setTimeout(()=>{clearTimeout(h);const E=this.f.get(b.seq);if(E){this.f.delete(b.seq);const f={type:"response",seq:0,request_seq:b.seq,success:!1,command:O,message:(0,P.localize)(5721,null,I,O)};E(f)}},I)}return s&&this.f.set(b.seq,s),b.seq}acceptMessage(O){this.k?this.k(O):(this.m.push(O),this.m.length===1&&this.s())}q(O,p){return O.type!=="event"||p.type!=="event"}async s(){let O;for(;this.m.length;){if((!O||this.q(this.m[0],O))&&await(0,D.$Jh)(0),O=this.m.shift(),!O)return;switch(O.type){case"event":this.j?.(O);break;case"request":this.g?.(O);break;case"response":{const p=O,s=this.f.get(p.request_seq);s&&(this.f.delete(p.request_seq),s(p));break}}}}u(O,p){p.type=O,p.seq=this.d++,this.sendMessage(p)}async w(){if(this.f.size===0)return Promise.resolve();const O=new Map;this.f.forEach((p,s)=>O.set(s,p)),await(0,D.$Jh)(500),O.forEach((p,s)=>{p({type:"response",seq:0,request_seq:s,success:!1,command:"canceled",message:"canceled"}),this.f.delete(s)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Dub=N}),define(Re[81],Te([1,0,2,9,31,3]),function(we,e,v,D,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$8K=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$6K=e.MemoryRangeType=e.State=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.$XK=e.$WK=e.$VK=e.$UK=e.$TK=e.$SK=e.$RK=e.$QK=e.$PK=e.$OK=e.$NK=e.$MK=e.$LK=e.$KK=e.$JK=e.$IK=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=void 0,e.$5K=p,e.$7K=I,D=qe(D),e.$SJ="workbench.view.debug",e.$TJ="workbench.debug.variablesView",e.$UJ="workbench.debug.watchExpressionsView",e.$VJ="workbench.debug.callStackView",e.$WJ="workbench.debug.loadedScriptsView",e.$XJ="workbench.debug.breakPointsView",e.$YJ="workbench.debug.disassemblyView",e.$ZJ="workbench.panel.repl",e.$1J="workbench.panel.repl.view",e.$2J=new P.$Zj("debugType",void 0,{type:"string",description:D.localize(5722,null)}),e.$3J=new P.$Zj("debugConfigurationType",void 0,{type:"string",description:D.localize(5723,null)}),e.$4J=new P.$Zj("debugState","inactive",{type:"string",description:D.localize(5724,null)}),e.$5J="debugUx",e.$6J=new P.$Zj(e.$5J,"default",{type:"string",description:D.localize(5725,null)}),e.$7J=new P.$Zj("hasDebugged",!1,{type:"boolean",description:D.localize(5726,null)}),e.$8J=new P.$Zj("inDebugMode",!1,{type:"boolean",description:D.localize(5727,null)}),e.$9J=new P.$Zj("inDebugRepl",!1,{type:"boolean",description:D.localize(5728,null)}),e.$0J=new P.$Zj("breakpointWidgetVisible",!1,{type:"boolean",description:D.localize(5729,null)}),e.$$J=new P.$Zj("inBreakpointWidget",!1,{type:"boolean",description:D.localize(5730,null)}),e.$_J=new P.$Zj("breakpointsFocused",!0,{type:"boolean",description:D.localize(5731,null)}),e.$aK=new P.$Zj("watchExpressionsFocused",!0,{type:"boolean",description:D.localize(5732,null)}),e.$bK=new P.$Zj("watchExpressionsExist",!1,{type:"boolean",description:D.localize(5733,null)}),e.$cK=new P.$Zj("variablesFocused",!0,{type:"boolean",description:D.localize(5734,null)}),e.$dK=new P.$Zj("expressionSelected",!1,{type:"boolean",description:D.localize(5735,null)}),e.$eK=new P.$Zj("breakpointInputFocused",!1,{type:"boolean",description:D.localize(5736,null)}),e.$fK=new P.$Zj("callStackItemType",void 0,{type:"string",description:D.localize(5737,null)}),e.$gK=new P.$Zj("callStackSessionIsAttach",!1,{type:"boolean",description:D.localize(5738,null)}),e.$hK=new P.$Zj("callStackItemStopped",!1,{type:"boolean",description:D.localize(5739,null)}),e.$iK=new P.$Zj("callStackSessionHasOneThread",!1,{type:"boolean",description:D.localize(5740,null)}),e.$jK=new P.$Zj("watchItemType",void 0,{type:"string",description:D.localize(5741,null)}),e.$kK=new P.$Zj("canViewMemory",void 0,{type:"boolean",description:D.localize(5742,null)}),e.$lK=new P.$Zj("breakpointItemType",void 0,{type:"string",description:D.localize(5743,null)}),e.$mK=new P.$Zj("breakpointItemBytes",void 0,{type:"boolean",description:D.localize(5744,null)}),e.$nK=new P.$Zj("breakpointHasModes",!1,{type:"boolean",description:D.localize(5745,null)}),e.$oK=new P.$Zj("breakpointSupportsCondition",!1,{type:"boolean",description:D.localize(5746,null)}),e.$pK=new P.$Zj("loadedScriptsSupported",!1,{type:"boolean",description:D.localize(5747,null)}),e.$qK=new P.$Zj("loadedScriptsItemType",void 0,{type:"string",description:D.localize(5748,null)}),e.$rK=new P.$Zj("focusedSessionIsAttach",!1,{type:"boolean",description:D.localize(5749,null)}),e.$sK=new P.$Zj("focusedSessionIsNoDebug",!1,{type:"boolean",description:D.localize(5750,null)}),e.$tK=new P.$Zj("stepBackSupported",!1,{type:"boolean",description:D.localize(5751,null)}),e.$uK=new P.$Zj("restartFrameSupported",!1,{type:"boolean",description:D.localize(5752,null)}),e.$vK=new P.$Zj("stackFrameSupportsRestart",!1,{type:"boolean",description:D.localize(5753,null)}),e.$wK=new P.$Zj("jumpToCursorSupported",!1,{type:"boolean",description:D.localize(5754,null)}),e.$xK=new P.$Zj("stepIntoTargetsSupported",!1,{type:"boolean",description:D.localize(5755,null)}),e.$yK=new P.$Zj("breakpointsExist",!1,{type:"boolean",description:D.localize(5756,null)}),e.$zK=new P.$Zj("debuggersAvailable",!1,{type:"boolean",description:D.localize(5757,null)}),e.$AK=new P.$Zj("debugExtensionAvailable",!0,{type:"boolean",description:D.localize(5758,null)}),e.$BK=new P.$Zj("debugProtocolVariableMenuContext",void 0,{type:"string",description:D.localize(5759,null)}),e.$CK=new P.$Zj("debugSetVariableSupported",!1,{type:"boolean",description:D.localize(5760,null)}),e.$DK=new P.$Zj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:D.localize(5761,null)}),e.$EK=new P.$Zj("debugSetExpressionSupported",!1,{type:"boolean",description:D.localize(5762,null)}),e.$FK=new P.$Zj("breakWhenValueChangesSupported",!1,{type:"boolean",description:D.localize(5763,null)}),e.$GK=new P.$Zj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:D.localize(5764,null)}),e.$HK=new P.$Zj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:D.localize(5765,null)}),e.$IK=new P.$Zj("terminateDebuggeeSupported",!1,{type:"boolean",description:D.localize(5766,null)}),e.$JK=new P.$Zj("suspendDebuggeeSupported",!1,{type:"boolean",description:D.localize(5767,null)}),e.$KK=new P.$Zj("variableEvaluateNamePresent",!1,{type:"boolean",description:D.localize(5768,null)}),e.$LK=new P.$Zj("variableIsReadonly",!1,{type:"boolean",description:D.localize(5769,null)}),e.$MK=new P.$Zj("variableValue",!1,{type:"string",description:D.localize(5770,null)}),e.$NK=new P.$Zj("variableType",!1,{type:"string",description:D.localize(5771,null)}),e.$OK=new P.$Zj("variableInterfaces",!1,{type:"array",description:D.localize(5772,null)}),e.$PK=new P.$Zj("variableName",!1,{type:"string",description:D.localize(5773,null)}),e.$QK=new P.$Zj("variableLanguage",!1,{type:"string",description:D.localize(5774,null)}),e.$RK=new P.$Zj("variableExtensionId",!1,{type:"string",description:D.localize(5775,null)}),e.$SK=new P.$Zj("exceptionWidgetVisible",!1,{type:"boolean",description:D.localize(5776,null)}),e.$TK=new P.$Zj("multiSessionRepl",!1,{type:"boolean",description:D.localize(5777,null)}),e.$UK=new P.$Zj("multiSessionDebug",!1,{type:"boolean",description:D.localize(5778,null)}),e.$VK=new P.$Zj("disassembleRequestSupported",!1,{type:"boolean",description:D.localize(5779,null)}),e.$WK=new P.$Zj("disassemblyViewFocus",!1,{type:"boolean",description:D.localize(5780,null)}),e.$XK=new P.$Zj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:D.localize(5781,null)}),e.$YK=new P.$Zj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:D.localize(5782,null)});const R=i=>D.localize(5783,null,i);e.$ZK=R,e.$1K="editor.contrib.debug",e.$2K="editor.contrib.breakpoint",e.$3K="debug",e.$4K={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:D.localize(5784,null)};var O;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(O||(e.State=O={}));function p(i){switch(i){case O.Initializing:return"initializing";case O.Stopped:return"stopped";case O.Running:return"running";default:return"inactive"}}var s;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(s||(e.MemoryRangeType=s={})),e.$6K="vscode-debug-memory";function I(i){const n=i.presentationHint??i.source.presentationHint;return n==="deemphasize"||n==="subtle"}var b;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(b||(e.DataBreakpointSetType=b={}));var h;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(h||(e.DebugConfigurationProviderTriggerKind=h={}));var E;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(E||(e.DebuggerString=E={})),e.$8K=(0,N.$Ii)("debugService");var f;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(f||(e.BreakpointWidgetContext=f={}));var r;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(r||(e.DebugVisualizationType=r={}));var l;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(l||(e.DebugTreeItemCollapsibleState=l={}));var d;(function(i){i.deserialize=n=>n,i.serialize=n=>n})(d||(e.IDebugVisualizationTreeItem=d={}));var a;(function(i){i.deserialize=n=>({id:n.id,name:n.name,iconPath:n.iconPath&&{light:v.URI.revive(n.iconPath.light),dark:v.URI.revive(n.iconPath.dark)},iconClass:n.iconClass,visualization:n.visualization}),i.serialize=n=>n})(a||(e.IDebugVisualization=a={}))}),define(Re[195],Te([1,0,13,2,22,25,15,32,19,17]),function(we,e,v,D,P,N,R,O,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zI=void 0,e.$nI=b,e.$oI=h,e.$pI=E,e.$qI=f,e.$rI=r,e.$sI=l,e.$tI=d,e.$uI=i,e.$vI=o,e.$wI=c,e.$xI=g,e.$yI=S;const I=/{([^}]+)}/g;function b(y,C,T){return y.replace(I,function($,w){return C&&w.length>0&&w[0]!=="_"?$:T&&T.hasOwnProperty(w)?T[w]:$})}function h(y){const C={};for(const T of Object.keys(y))T.startsWith("!")||(C[T]=y[T]);return C}function E(y){return y.configuration.request==="attach"&&!f(y)&&(!y.parentSession||E(y.parentSession))}function f(y){let C=y.configuration.type;if(C)return C==="vslsShare"&&(C=y.configuration.adapterProxy.configuration.type),(0,v.$If)(C,"extensionhost")||(0,v.$If)(C,"pwa-extensionhost")?y:y.parentSession?f(y.parentSession):void 0}function r(y){return y.type&&(y.label||y.program||y.runtime)}function l(y,C,T){let $,w=0;const M=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let A=null;for(;A=M.exec(y);){const L=A.index+1,J=L+A[0].length;if(L<=C&&J>=T){$=A[0],w=L;break}}if($){const L=/(\w|\p{L})+/gu;let J=null;for(;(J=L.exec($))&&!(J.index+1+w+J[0].length>=T););J&&($=$.substring(0,L.lastIndex))}return $?{start:w,end:w+$.length-1}:{start:0,end:0}}async function d(y,C,T,$){if(y.evaluatableExpressionProvider.has(C)){const w=y.evaluatableExpressionProvider.ordered(C),M=(0,s.$Jb)(await Promise.all(w.map(async A=>{try{return await A.provideEvaluatableExpression(C,T,$??p.CancellationToken.None)}catch{return}})));if(M.length>0){let A=M[0].expression;const L=M[0].range;return A||(A=C.getLineContent(T.lineNumber).substring(L.startColumn-1,L.endColumn-1)),{range:L,matchingExpression:A}}}else{const w=C.getLineContent(T.lineNumber),{start:M,end:A}=l(w,T.column,T.column),L=w.substring(M-1,A);return{matchingExpression:L,range:new O.$Ut(T.lineNumber,M,T.lineNumber,M+L.length)}}return null}const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(y){return!!(y&&y.match(a))}function n(y){if(typeof y.path=="string"&&!(typeof y.sourceReference=="number"&&y.sourceReference>0)){if(i(y.path))return D.URI.parse(y.path);if((0,P.$lc)(y.path))return D.URI.file(y.path)}return y.path}function t(y){if(typeof y.path=="object"){const C=D.URI.revive(y.path);if(C)return C.scheme===R.Schemas.file?C.fsPath:C.toString()}return y.path}function o(y,C){const T=C?n:t,$=(0,N.$io)(y);return m($,(w,M)=>{w&&M&&(M.path=T(M))}),$}function c(y,C){const T=C?n:t,$=(0,N.$io)(y);return m($,(w,M)=>{!w&&M&&(M.path=T(M))}),$}function m(y,C){switch(y.type){case"event":{const T=y;switch(T.event){case"output":C(!1,T.body.source);break;case"loadedSource":C(!1,T.body.source);break;case"breakpoint":C(!1,T.body.breakpoint.source);break;default:break}break}case"request":{const T=y;switch(T.command){case"setBreakpoints":C(!0,T.arguments.source);break;case"breakpointLocations":C(!0,T.arguments.source);break;case"source":C(!0,T.arguments.source);break;case"gotoTargets":C(!0,T.arguments.source);break;case"launchVSCode":T.arguments.args.forEach($=>C(!1,$));break;default:break}break}case"response":{const T=y;if(T.success&&T.body)switch(T.command){case"stackTrace":T.body.stackFrames.forEach($=>C(!1,$.source));break;case"loadedSources":T.body.sources.forEach($=>C(!1,$));break;case"scopes":T.body.scopes.forEach($=>C(!1,$.source));break;case"setFunctionBreakpoints":T.body.breakpoints.forEach($=>C(!1,$.source));break;case"setBreakpoints":T.body.breakpoints.forEach($=>C(!1,$.source));break;case"disassemble":T.body?.instructions.forEach(w=>C(!1,w.location));break;case"locations":C(!1,T.body?.source);break;default:break}break}}}function g(y){return y.filter(C=>!C.presentation?.hidden).sort((C,T)=>C.presentation?T.presentation?C.presentation.group?T.presentation.group?C.presentation.group!==T.presentation.group?C.presentation.group.localeCompare(T.presentation.group):u(C.presentation.order,T.presentation.order):-1:T.presentation.group?1:u(C.presentation.order,T.presentation.order):-1:T.presentation?1:0)}function u(y,C){return typeof y!="number"?typeof C!="number"?0:1:typeof C!="number"?-1:y-C}async function S(y,C){const T=y.getValue("debug.saveBeforeStart",{overrideIdentifier:C.activeTextEditorLanguageId});if(T!=="none"&&(await C.saveAll(),T==="allEditorsInActiveGroup")){const $=C.activeEditorPane;$&&$.input.resource?.scheme===R.Schemas.untitled&&await C.save({editor:$.input,groupId:$.group.id})}await y.reloadConfiguration()}const k=(y,C)=>!y||!C?y===C:y.name===C.name&&y.path===C.path&&y.sourceReference===C.sourceReference;e.$zI=k}),define(Re[196],Te([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dL=e.CellExecutionUpdateType=void 0;var D;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(D||(e.CellExecutionUpdateType=D={})),e.$dL=(0,v.$Ii)("INotebookExecutionService")}),define(Re[197],Te([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hL=e.$gL=e.ProxyKernelState=e.$fL=void 0,e.$fL=100;var D;(function(P){P[P.Disconnected=1]="Disconnected",P[P.Connected=2]="Connected",P[P.Initializing=3]="Initializing"})(D||(e.ProxyKernelState=D={})),e.$gL=(0,v.$Ii)("INotebookKernelService"),e.$hL=(0,v.$Ii)("INotebookKernelHistoryService")}),define(Re[198],Te([1,0,4,32,52,162,103]),function(we,e,v,D,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r2b=void 0;class O extends v.$Xc{constructor(s,I,b){super(),this._source=s,this.b=I,this.c=b,this.a=void 0}f(s){const I=s.getLineCount();return new D.$Ut(1,1,I,this.g(s,I))}g(s,I){if(I<1||I>s.getLineCount())throw new Error("Illegal value for lineNumber");return s.getLineLength(I)+1}get inputTextBuffer(){if(!this.b){const s=new N.$HD;s.acceptChunk(this._source);const I=s.finish(!0),{textBuffer:b,disposable:h}=I.create(P.DefaultEndOfLine.LF);this.b=b,this.B(h)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(s=>{const I=new N.$HD;I.acceptChunk(s);const b=I.finish(!0),{textBuffer:h,disposable:E}=b.create(P.DefaultEndOfLine.LF);return this.B(E),h})),this.a}findInInputs(s){const b=new R.$vD(s,!1,!1,null).parseSearchRequest();if(!b)return[];const h=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(h,b,!0,5e3)}findInOutputs(s){const b=new R.$vD(s,!1,!1,null).parseSearchRequest();return b?this.outputTextBuffers.map(h=>{const E=h.findMatchesLineByLine(this.f(h),b,!0,5e3);if(E.length!==0)return{textBuffer:h,matches:E}}).filter(h=>!!h):[]}}e.$r2b=O}),define(Re[54],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mJ=e.TestPosition=e.TestIdPathParts=void 0;var v;(function(N){N.Delimiter="\0"})(v||(e.TestIdPathParts=v={}));var D;(function(N){N[N.IsSame=0]="IsSame",N[N.Disconnected=1]="Disconnected",N[N.IsChild=2]="IsChild",N[N.IsParent=3]="IsParent"})(D||(e.TestPosition=D={}));class P{static fromExtHostTestItem(R,O,p=R.parent){if(R._isRoot)return new P([O]);const s=[R.id];for(let I=p;I&&I.id!==O;I=I.parent)s.push(I.id);return s.push(O),new P(s.reverse())}static isRoot(R){return!R.includes(v.Delimiter)}static root(R){const O=R.indexOf(v.Delimiter);return O===-1?R:R.slice(0,O)}static fromString(R){return new P(R.split(v.Delimiter))}static join(R,O){return new P([...R.path,O])}static joinToString(R,O){return R.toString()+v.Delimiter+O}static parentId(R){const O=R.lastIndexOf(v.Delimiter);return O===-1?void 0:R.slice(0,O)}static localId(R){const O=R.lastIndexOf(v.Delimiter);return O===-1?R:R.slice(O+v.Delimiter.length)}static isChild(R,O){return O[R.length]===v.Delimiter&&O.startsWith(R)}static compare(R,O){return R===O?D.IsSame:P.isChild(R,O)?D.IsChild:P.isChild(O,R)?D.IsParent:D.Disconnected}static getLengthOfCommonPrefix(R,O){if(R===0)return 0;let p=0;for(;p<R-1;){for(let s=1;s<R;s++){const I=O(s-1),b=O(s);if(I.path[p]!==b.path[p])return p}p++}return p}constructor(R,O=R.length){if(this.path=R,this.d=O,R.length===0||O<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.d>1?new P(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new P(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new P(this.path,R)}compare(R){if(typeof R=="string")return P.compare(this.toString(),R);for(let O=0;O<R.d&&O<this.d;O++)if(R.path[O]!==this.path[O])return D.Disconnected;return R.d>this.d?D.IsChild:R.d<this.d?D.IsParent:D.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+=v.Delimiter,this.c+=this.path[R]}return this.c}}e.$mJ=P}),define(Re[55],Te([1,0,2,102,32,54]),function(we,e,v,D,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vJ=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$uJ=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$tJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$sJ=e.$rJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$qJ=e.ITestErrorMessage=e.ITestMessageStackFrame=e.TestMessageType=e.IRichLocation=e.$pJ=e.$oJ=e.TestRunProfileBitset=e.TestControllerCapability=e.ExtTestRunProfileKind=e.$nJ=e.TestResultState=void 0;var R;(function(Q){Q[Q.Unset=0]="Unset",Q[Q.Queued=1]="Queued",Q[Q.Running=2]="Running",Q[Q.Passed=3]="Passed",Q[Q.Failed=4]="Failed",Q[Q.Skipped=5]="Skipped",Q[Q.Errored=6]="Errored"})(R||(e.TestResultState=R={})),e.$nJ={[R.Unset]:"unset",[R.Queued]:"queued",[R.Running]:"running",[R.Passed]:"passed",[R.Failed]:"failed",[R.Skipped]:"skipped",[R.Errored]:"errored"};var O;(function(Q){Q[Q.Run=1]="Run",Q[Q.Debug=2]="Debug",Q[Q.Coverage=3]="Coverage"})(O||(e.ExtTestRunProfileKind=O={}));var p;(function(Q){Q[Q.Refresh=2]="Refresh",Q[Q.CodeRelatedToTest=4]="CodeRelatedToTest",Q[Q.TestRelatedToCode=8]="TestRelatedToCode"})(p||(e.TestControllerCapability=p={}));var s;(function(Q){Q[Q.Run=2]="Run",Q[Q.Debug=4]="Debug",Q[Q.Coverage=8]="Coverage",Q[Q.HasNonDefaultProfile=16]="HasNonDefaultProfile",Q[Q.HasConfigurable=32]="HasConfigurable",Q[Q.SupportsContinuousRun=64]="SupportsContinuousRun"})(s||(e.TestRunProfileBitset=s={})),e.$oJ=[s.Run,s.Debug,s.Coverage,s.HasNonDefaultProfile,s.HasConfigurable,s.SupportsContinuousRun];const I=Q=>"runId"in Q;e.$pJ=I;var b;(function(Q){Q.serialize=V=>({range:V.range.toJSON(),uri:V.uri.toJSON()}),Q.deserialize=(V,ie)=>({range:P.$Ut.lift(ie.range),uri:V.asCanonicalUri(v.URI.revive(ie.uri))})})(b||(e.IRichLocation=b={}));var h;(function(Q){Q[Q.Error=0]="Error",Q[Q.Output=1]="Output"})(h||(e.TestMessageType=h={}));var E;(function(Q){Q.serialize=V=>({label:V.label,uri:V.uri?.toJSON(),position:V.position?.toJSON()}),Q.deserialize=(V,ie)=>({label:ie.label,uri:ie.uri?V.asCanonicalUri(v.URI.revive(ie.uri)):void 0,position:ie.position?D.$Tt.lift(ie.position):void 0})})(E||(e.ITestMessageStackFrame=E={}));var f;(function(Q){Q.serialize=V=>({message:V.message,type:h.Error,expected:V.expected,actual:V.actual,contextValue:V.contextValue,location:V.location&&b.serialize(V.location),stackTrace:V.stackTrace?.map(E.serialize)}),Q.deserialize=(V,ie)=>({message:ie.message,type:h.Error,expected:ie.expected,actual:ie.actual,contextValue:ie.contextValue,location:ie.location&&b.deserialize(V,ie.location),stackTrace:ie.stackTrace&&ie.stackTrace.map(le=>E.deserialize(V,le))})})(f||(e.ITestErrorMessage=f={}));const r=(Q,V)=>`${V?"s":"e"}${Q}`;e.$qJ=r;var l;(function(Q){Q.serialize=V=>({message:V.message,type:h.Output,offset:V.offset,length:V.length,location:V.location&&b.serialize(V.location)}),Q.deserialize=(V,ie)=>({message:ie.message,type:h.Output,offset:ie.offset,length:ie.length,location:ie.location&&b.deserialize(V,ie.location)})})(l||(e.ITestOutputMessage=l={}));var d;(function(Q){Q.serialize=V=>V.type===h.Error?f.serialize(V):l.serialize(V),Q.deserialize=(V,ie)=>ie.type===h.Error?f.deserialize(V,ie):l.deserialize(V,ie),Q.isDiffable=V=>V.type===h.Error&&V.actual!==void 0&&V.expected!==void 0})(d||(e.ITestMessage=d={}));var a;(function(Q){Q.serializeWithoutMessages=V=>({state:V.state,duration:V.duration,messages:[]}),Q.serialize=V=>({state:V.state,duration:V.duration,messages:V.messages.map(d.serialize)}),Q.deserialize=(V,ie)=>({state:ie.state,duration:ie.duration,messages:ie.messages.map(le=>d.deserialize(V,le))})})(a||(e.ITestTaskState=a={}));const i="\0",n=(Q,V)=>Q+i+V;e.$rJ=n;const t=Q=>{const V=Q.indexOf(i);return{ctrlId:Q.slice(0,V),tagId:Q.slice(V+1)}};e.$sJ=t;var o;(function(Q){Q.serialize=V=>({extId:V.extId,label:V.label,tags:V.tags,busy:V.busy,children:void 0,uri:V.uri?.toJSON(),range:V.range?.toJSON()||null,description:V.description,error:V.error,sortText:V.sortText}),Q.deserialize=(V,ie)=>({extId:ie.extId,label:ie.label,tags:ie.tags,busy:ie.busy,children:void 0,uri:ie.uri?V.asCanonicalUri(v.URI.revive(ie.uri)):void 0,range:ie.range?P.$Ut.lift(ie.range):null,description:ie.description,error:ie.error,sortText:ie.sortText})})(o||(e.ITestItem=o={}));var c;(function(Q){Q[Q.NotExpandable=0]="NotExpandable",Q[Q.Expandable=1]="Expandable",Q[Q.BusyExpanding=2]="BusyExpanding",Q[Q.Expanded=3]="Expanded"})(c||(e.TestItemExpandState=c={}));var m;(function(Q){Q.serialize=V=>({expand:V.expand,item:o.serialize(V.item)}),Q.deserialize=(V,ie)=>({controllerId:N.$mJ.root(ie.item.extId),expand:ie.expand,item:o.deserialize(V,ie.item)})})(m||(e.InternalTestItem=m={}));var g;(function(Q){Q.serialize=V=>{let ie;return V.item&&(ie={},V.item.label!==void 0&&(ie.label=V.item.label),V.item.tags!==void 0&&(ie.tags=V.item.tags),V.item.busy!==void 0&&(ie.busy=V.item.busy),V.item.uri!==void 0&&(ie.uri=V.item.uri?.toJSON()),V.item.range!==void 0&&(ie.range=V.item.range?.toJSON()),V.item.description!==void 0&&(ie.description=V.item.description),V.item.error!==void 0&&(ie.error=V.item.error),V.item.sortText!==void 0&&(ie.sortText=V.item.sortText)),{extId:V.extId,expand:V.expand,item:ie}},Q.deserialize=V=>{let ie;return V.item&&(ie={},V.item.label!==void 0&&(ie.label=V.item.label),V.item.tags!==void 0&&(ie.tags=V.item.tags),V.item.busy!==void 0&&(ie.busy=V.item.busy),V.item.range!==void 0&&(ie.range=V.item.range?P.$Ut.lift(V.item.range):null),V.item.description!==void 0&&(ie.description=V.item.description),V.item.error!==void 0&&(ie.error=V.item.error),V.item.sortText!==void 0&&(ie.sortText=V.item.sortText)),{extId:V.extId,expand:V.expand,item:ie}}})(g||(e.ITestItemUpdate=g={}));const u=(Q,V)=>{V.expand!==void 0&&(Q.expand=V.expand),V.item!==void 0&&(Q.item=Q.item?Object.assign(Q.item,V.item):V.item)};e.$tJ=u;var S;(function(Q){Q.serializeWithoutMessages=V=>({...m.serialize(V),ownComputedState:V.ownComputedState,computedState:V.computedState,tasks:V.tasks.map(a.serializeWithoutMessages)}),Q.serialize=V=>({...m.serialize(V),ownComputedState:V.ownComputedState,computedState:V.computedState,tasks:V.tasks.map(a.serialize)}),Q.deserialize=(V,ie)=>({...m.deserialize(V,ie),ownComputedState:ie.ownComputedState,computedState:ie.computedState,tasks:ie.tasks.map(le=>a.deserialize(V,le)),retired:!0})})(S||(e.TestResultItem=S={}));var k;(function(Q){Q.empty=()=>({covered:0,total:0}),Q.sum=(V,ie)=>{V.covered+=ie.covered,V.total+=ie.total}})(k||(e.ICoverageCount=k={}));var y;(function(Q){Q.serialize=V=>({id:V.id,statement:V.statement,branch:V.branch,declaration:V.declaration,testIds:V.testIds,uri:V.uri.toJSON()}),Q.deserialize=(V,ie)=>({id:ie.id,statement:ie.statement,branch:ie.branch,declaration:ie.declaration,testIds:ie.testIds,uri:V.asCanonicalUri(v.URI.revive(ie.uri))}),Q.empty=(V,ie)=>({id:V,uri:ie,statement:k.empty()})})(y||(e.IFileCoverage=y={}));function C(Q){return{...Q,location:Q.location?.toJSON()}}function T(Q){return Q.location=Q.location?D.$Tt.isIPosition(Q.location)?D.$Tt.lift(Q.location):P.$Ut.lift(Q.location):void 0,Q}e.$uJ=3;var $;(function(Q){Q[Q.Declaration=0]="Declaration",Q[Q.Statement=1]="Statement",Q[Q.Branch=2]="Branch"})($||(e.DetailType=$={}));var w;(function(Q){Q.serialize=V=>V.type===$.Declaration?A.serialize(V):L.serialize(V),Q.deserialize=V=>V.type===$.Declaration?A.deserialize(V):L.deserialize(V)})(w||(e.CoverageDetails=w={}));var M;(function(Q){Q.serialize=C,Q.deserialize=T})(M||(e.IBranchCoverage=M={}));var A;(function(Q){Q.serialize=C,Q.deserialize=T})(A||(e.IDeclarationCoverage=A={}));var L;(function(Q){Q.serialize=V=>({...C(V),branches:V.branches?.map(M.serialize)}),Q.deserialize=V=>({...T(V),branches:V.branches?.map(M.deserialize)})})(L||(e.IStatementCoverage=L={}));var J;(function(Q){Q[Q.Add=0]="Add",Q[Q.Update=1]="Update",Q[Q.DocumentSynced=2]="DocumentSynced",Q[Q.Remove=3]="Remove",Q[Q.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",Q[Q.Retire=5]="Retire",Q[Q.AddTag=6]="AddTag",Q[Q.RemoveTag=7]="RemoveTag"})(J||(e.TestDiffOpType=J={}));var Y;(function(Q){Q.deserialize=(V,ie)=>ie.op===J.Add?{op:ie.op,item:m.deserialize(V,ie.item)}:ie.op===J.Update?{op:ie.op,item:g.deserialize(ie.item)}:ie.op===J.DocumentSynced?{op:ie.op,uri:V.asCanonicalUri(v.URI.revive(ie.uri)),docv:ie.docv}:ie,Q.serialize=V=>V.op===J.Add?{op:V.op,item:m.serialize(V.item)}:V.op===J.Update?{op:V.op,item:g.serialize(V.item)}:V})(Y||(e.TestsDiffOp=Y={}));class z{constructor(V){this.l=V,this.f=new Map,this.g=new Map,this.h=new Set,this.j=0,this.k=0,this.tags=this.f}apply(V){const ie=this.x();for(const le of V)switch(le.op){case J.Add:this.p(m.deserialize(this.l,le.item),ie);break;case J.Update:this.q(g.deserialize(le.item),ie);break;case J.Remove:this.v(le.itemId,ie);break;case J.Retire:this.w(le.itemId);break;case J.IncrementPendingExtHosts:this.updatePendingRoots(le.amount);break;case J.AddTag:this.f.set(le.tag.id,le.tag);break;case J.RemoveTag:this.f.delete(le.id);break}ie.complete?.()}p(V,ie){const le=N.$mJ.parentId(V.item.extId)?.toString();let _;if(!le)_=this.y(V),this.h.add(_),this.g.set(V.item.extId,_);else if(this.g.has(le)){const oe=this.g.get(le);oe.children.add(V.item.extId),_=this.y(V,oe),this.g.set(V.item.extId,_)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(V)}`);return}return ie.add?.(_),V.expand===c.BusyExpanding&&this.j++,_}q(V,ie){const le=this.g.get(V.extId);if(le)return V.expand!==void 0&&(le.expand===c.BusyExpanding&&this.j--,V.expand===c.BusyExpanding&&this.j++),(0,e.$tJ)(le,V),ie.update?.(le),le}v(V,ie){const le=this.g.get(V);if(!le)return;const _=N.$mJ.parentId(le.item.extId)?.toString();_?this.g.get(_).children.delete(le.item.extId):this.h.delete(le);const oe=[[V]];for(;oe.length;)for(const re of oe.pop()){const ce=this.g.get(re);ce&&(oe.push(ce.children),this.g.delete(re),ie.remove?.(ce,ce!==le),ce.expand===c.BusyExpanding&&this.j--)}}w(V){}updatePendingRoots(V){this.k+=V}x(){return{}}}e.$vJ=z}),define(Re[199],Te([1,0,99,9,55]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$hHb=e.$gHb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var N;(function(b){b.ViewletId="workbench.view.extension.test",b.ExplorerViewId="workbench.view.testing",b.OutputPeekContributionId="editor.contrib.testingOutputPeek",b.DecorationsContributionId="editor.contrib.testingDecorations",b.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",b.CoverageViewId="workbench.view.testCoverage",b.ResultsPanelId="workbench.panel.testResults",b.ResultsViewId="workbench.panel.testResults.view",b.MessageLanguageId="vscodeInternalTestMessage"})(N||(e.Testing=N={}));var R;(function(b){b.List="list",b.Tree="true"})(R||(e.TestExplorerViewMode=R={}));var O;(function(b){b.ByLocation="location",b.ByStatus="status",b.ByDuration="duration"})(O||(e.TestExplorerViewSorting=O={}));const p={[P.TestResultState.Errored]:(0,D.localize)(10851,null),[P.TestResultState.Failed]:(0,D.localize)(10852,null),[P.TestResultState.Passed]:(0,D.localize)(10853,null),[P.TestResultState.Queued]:(0,D.localize)(10854,null),[P.TestResultState.Running]:(0,D.localize)(10855,null),[P.TestResultState.Skipped]:(0,D.localize)(10856,null),[P.TestResultState.Unset]:(0,D.localize)(10857,null)},s=(b,h)=>(0,D.localize)(10858,null,(0,v.$3k)(b),p[h]);e.$gHb=s,e.$hHb={[P.TestRunProfileBitset.Debug]:(0,D.localize)(10859,null),[P.TestRunProfileBitset.Run]:(0,D.localize)(10860,null),[P.TestRunProfileBitset.Coverage]:(0,D.localize)(10861,null)};var I;(function(b){b.CancelTestRefreshAction="testing.cancelTestRefresh",b.CancelTestRunAction="testing.cancelRun",b.ClearTestResultsAction="testing.clearTestResults",b.CollapseAllAction="testing.collapseAll",b.ConfigureTestProfilesAction="testing.configureProfile",b.ContinousRunUsingForTest="testing.continuousRunUsingForTest",b.CoverageAtCursor="testing.coverageAtCursor",b.CoverageByUri="testing.coverage.uri",b.CoverageClear="testing.coverage.close",b.CoverageCurrentFile="testing.coverageCurrentFile",b.CoverageFilterToTest="testing.coverageFilterToTest",b.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",b.CoverageLastRun="testing.coverageLastRun",b.CoverageSelectedAction="testing.coverageSelected",b.CoverageToggleToolbar="testing.coverageToggleToolbar",b.CoverageViewChangeSorting="testing.coverageViewChangeSorting",b.DebugAction="testing.debug",b.DebugAllAction="testing.debugAll",b.DebugAtCursor="testing.debugAtCursor",b.DebugByUri="testing.debug.uri",b.DebugCurrentFile="testing.debugCurrentFile",b.DebugFailedTests="testing.debugFailTests",b.DebugLastRun="testing.debugLastRun",b.DebugSelectedAction="testing.debugSelected",b.FilterAction="workbench.actions.treeView.testExplorer.filter",b.GetExplorerSelection="_testing.getExplorerSelection",b.GetSelectedProfiles="testing.getSelectedProfiles",b.GoToTest="testing.editFocusedTest",b.GoToRelatedTest="testing.goToRelatedTest",b.PeekRelatedTest="testing.peekRelatedTest",b.GoToRelatedCode="testing.goToRelatedCode",b.PeekRelatedCode="testing.peekRelatedCode",b.HideTestAction="testing.hideTest",b.OpenCoverage="testing.openCoverage",b.OpenOutputPeek="testing.openOutputPeek",b.RefreshTestsAction="testing.refreshTests",b.ReRunFailedTests="testing.reRunFailTests",b.ReRunLastRun="testing.reRunLastRun",b.RunAction="testing.run",b.RunAllAction="testing.runAll",b.RunAllWithCoverageAction="testing.coverageAll",b.RunAtCursor="testing.runAtCursor",b.RunByUri="testing.run.uri",b.RunCurrentFile="testing.runCurrentFile",b.RunSelectedAction="testing.runSelected",b.RunUsingProfileAction="testing.runUsing",b.RunWithCoverageAction="testing.coverage",b.SearchForTestExtension="testing.searchForTestExtension",b.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",b.ShowMostRecentOutputAction="testing.showMostRecentOutput",b.StartContinousRun="testing.startContinuousRun",b.StopContinousRun="testing.stopContinuousRun",b.TestingSortByDurationAction="testing.sortByDuration",b.TestingSortByLocationAction="testing.sortByLocation",b.TestingSortByStatusAction="testing.sortByStatus",b.TestingViewAsListAction="testing.viewAsList",b.TestingViewAsTreeAction="testing.viewAsTree",b.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",b.ToggleInlineTestOutput="testing.toggleInlineTestOutput",b.UnhideAllTestsAction="testing.unhideAllTests",b.UnhideTestAction="testing.unhideTest"})(I||(e.TestCommandId=I={}))}),define(Re[82],Te([1,0,10,6,4,61,55,54]),function(we,e,v,D,P,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xQ=e.$wQ=e.$vQ=e.$uQ=e.$tQ=e.TestItemEventOp=void 0;var p;(function(a){a[a.Upsert=0]="Upsert",a[a.SetTags=1]="SetTags",a[a.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",a[a.RemoveChild=3]="RemoveChild",a[a.SetProp=4]="SetProp",a[a.Bulk=5]="Bulk",a[a.DocumentSynced=6]="DocumentSynced"})(p||(e.TestItemEventOp=p={}));const s=(a,i)=>a===i,b=Object.entries({range:(a,i)=>a===i?!0:!a||!i?!1:a.equalsRange(i),busy:s,label:s,description:s,error:s,sortText:s,tags:(a,i)=>!(a.length!==i.length||a.some(n=>!i.includes(n)))}),h=(a,i)=>{let n;for(const[t,o]of b)o(a[t],i[t])||(n?n[t]=i[t]:n={[t]:i[t]});return n};class E extends P.$Xc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new v.$Uh(()=>this.flushDiff(),200)),this.g=this.B(new D.$oe),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const n of this.tree.values())this.J(n)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case R.TestDiffOpType.DocumentSynced:{for(const n of this.m)if(n.op===R.TestDiffOpType.DocumentSynced&&n.uri===i.uri){n.docv=i.docv;return}break}case R.TestDiffOpType.Update:{const n=this.m[this.m.length-1];if(n){if(n.op===R.TestDiffOpType.Update&&n.item.extId===i.item.extId){(0,R.$tJ)(n.item,i.item);return}if(n.op===R.TestDiffOpType.Add&&n.item.item.extId===i.item.extId){(0,R.$tJ)(n.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,n){const t=this.tree.get(i);if(t){if((t.expandLevels===void 0||n>t.expandLevels)&&(t.expandLevels=n),t.expand===R.TestItemExpandState.Expandable){const o=this.M(t);return o.isOpen()?this.L(t,n-1):o.wait().then(()=>this.L(t,n-1))}else if(t.expand===R.TestItemExpandState.Expanded)return t.resolveBarrier?.isOpen()===!1?t.resolveBarrier.wait().then(()=>this.L(t,n-1)):this.L(t,n-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,n){switch(n.op){case p.RemoveChild:this.O(O.$mJ.joinToString(i.fullId,n.id));break;case p.Upsert:this.z(n.item,i);break;case p.Bulk:for(const t of n.ops)this.w(i,t);break;case p.SetTags:this.C(n.new,n.old,i.fullId.toString());break;case p.UpdateCanResolveChildren:this.J(i);break;case p.SetProp:this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:i.fullId.toString(),item:n.update}});break;case p.DocumentSynced:this.y(i.actual.uri);break;default:(0,N.$hd)(n)}}y(i){i&&this.pushDiff({op:R.TestDiffOpType.DocumentSynced,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,n){const t=O.$mJ.fromExtHostTestItem(i,this.root.id,n?.actual),o=this.s.getApiFor(i);o.parent&&o.parent!==n?.actual&&this.s.getChildren(o.parent).delete(i.id);let c=this.tree.get(t.toString());if(!c){c={fullId:t,actual:i,expandLevels:n?.expandLevels?n.expandLevels-1:void 0,expand:R.TestItemExpandState.NotExpandable},i.tags.forEach(this.D,this),this.tree.set(c.fullId.toString(),c),this.G(i,n),this.pushDiff({op:R.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:c.expand,item:this.s.toITestItem(i)}}),this.I(i,c,n);return}if(c.actual===i){this.H(i,c,n);return}if(c.actual.uri?.toString()!==i.uri?.toString())return this.O(t.toString()),this.z(i,n);const m=this.s.getChildren(c.actual),g=c.actual,u=h(this.s.toITestItem(g),this.s.toITestItem(i));this.s.getApiFor(g).listener=void 0,c.actual=i,c.resolveBarrier=void 0,c.expand=R.TestItemExpandState.NotExpandable,u&&(u.hasOwnProperty("tags")&&(this.C(i.tags,g.tags,t.toString()),delete u.tags),this.w(c,{op:p.SetProp,update:u})),this.I(i,c,n);for(const[k,y]of m)this.s.getChildren(i).get(y.id)||this.O(O.$mJ.joinToString(t,y.id));const S=c.expandLevels;S!==void 0&&queueMicrotask(()=>{c.expand===R.TestItemExpandState.Expandable&&(c.expandLevels=void 0,this.expand(t.toString(),S))}),this.y(c.actual.uri)}C(i,n,t){const o=new Set(n.map(c=>c.id));for(const c of i)o.delete(c.id)||this.D(c);this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:t,item:{tags:i.map(c=>(0,R.$rJ)(this.s.controllerId,c.id))}}}),o.forEach(this.F,this)}D(i){const n=this.j.get(i.id);n?n.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:R.TestDiffOpType.AddTag,tag:{id:(0,R.$rJ)(this.s.controllerId,i.id)}}))}F(i){const n=this.j.get(i);n&&!--n.refCount&&(this.j.delete(i),this.pushDiff({op:R.TestDiffOpType.RemoveTag,id:(0,R.$rJ)(this.s.controllerId,i)}))}G(i,n){this.s.getApiFor(i).parent=n&&n.actual!==this.root?n.actual:void 0}H(i,n,t){this.G(i,t);const o=this.s.getApiFor(i);o.parent=t?.actual,o.listener=c=>this.w(n,c),this.J(n)}I(i,n,t){this.H(i,n,t);for(const[o,c]of this.s.getChildren(i))this.z(c,n)}J(i){let n;this.h?i.resolveBarrier?n=i.resolveBarrier.isOpen()?R.TestItemExpandState.Expanded:R.TestItemExpandState.BusyExpanding:n=i.actual.canResolveChildren?R.TestItemExpandState.Expandable:R.TestItemExpandState.NotExpandable:n=R.TestItemExpandState.NotExpandable,n!==i.expand&&(i.expand=n,this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:n}}),n===R.TestItemExpandState.Expandable&&i.expandLevels!==void 0&&this.M(i))}L(i,n){if(n<0)return;const t=[];for(const[o,c]of this.s.getChildren(i.actual)){const m=this.expand(O.$mJ.joinToString(i.fullId,c.id),n);(0,v.$uh)(m)&&t.push(m)}if(t.length)return Promise.all(t).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const c=new v.$Hh;return c.open(),c}i.expand=R.TestItemExpandState.BusyExpanding,this.N(i);const n=i.resolveBarrier=new v.$Hh,t=c=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,c)};let o;try{o=this.h(i.actual===this.root?void 0:i.actual)}catch(c){t(c)}return(0,v.$uh)(o)?o.catch(t).then(()=>{n.open(),this.J(i)}):(n.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const n=this.tree.get(i);if(!n)throw new Error("attempting to remove non-existent child");this.pushDiff({op:R.TestDiffOpType.Remove,itemId:i});const t=[n];for(;t.length;){const o=t.pop();if(o){this.s.getApiFor(o.actual).listener=void 0;for(const c of o.actual.tags)this.F(c.id);this.tree.delete(o.fullId.toString());for(const[c,m]of this.s.getChildren(o.actual))t.push(this.tree.get(O.$mJ.joinToString(o.fullId,m.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$tQ=E;class f extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$uQ=f;class r extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$vQ=r;class l extends Error{constructor(i,n,t){super(`TestItem with ID "${i}" is from controller "${n}" and cannot be added as a child of an item from controller "${t}".`)}}e.$wQ=l;const d=(a,i,n)=>{let t=new Map;return{get size(){return t.size},forEach(o,c){for(const m of t.values())o.call(c,m,this)},[Symbol.iterator](){return t.entries()},replace(o){const c=new Map,m=new Set(t.keys()),g={op:p.Bulk,ops:[]};for(const u of o){if(!(u instanceof n))throw new r(u.id);const S=i(u).controllerId;if(S!==a.controllerId)throw new l(u.id,S,a.controllerId);if(c.has(u.id))throw new f(u.id);c.set(u.id,u),m.delete(u.id),g.ops.push({op:p.Upsert,item:u})}for(const u of m.keys())g.ops.push({op:p.RemoveChild,id:u});a.listener?.(g),t=c},add(o){if(!(o instanceof n))throw new r(o.id);t.set(o.id,o),a.listener?.({op:p.Upsert,item:o})},delete(o){t.delete(o)&&a.listener?.({op:p.RemoveChild,id:o})},get(o){return t.get(o)},toJSON(){return Array.from(t.values())}}};e.$xQ=d}),define(Re[118],Te([1,0,82]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zQ=e.$yQ=void 0;const D=new WeakMap,P=(R,O)=>{const p={controllerId:O};return D.set(R,p),p};e.$yQ=P;const N=R=>{const O=D.get(R);if(!O)throw new v.$vQ(R?.id||"<unknown>");return O};e.$zQ=N}),define(Re[83],Te([1,0,30,15,2]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$Db=e.$0Db=e.$9Db=void 0,e.$_Db=N,e.$aEb=O,e.$9Db="vscode-cdn.net",e.$0Db=`vscode-resource.${e.$9Db}`,e.$$Db=`'self' https://*.${e.$9Db}`;function N(p,s){return p.scheme===D.Schemas.http||p.scheme===D.Schemas.https?p:(s&&s.authority&&s.isRemote&&p.scheme===D.Schemas.file&&(p=P.URI.from({scheme:D.Schemas.vscodeRemote,authority:s.authority,path:p.path})),P.URI.from({scheme:D.Schemas.https,authority:`${p.scheme}+${R(p.authority)}.${e.$0Db}`,path:p.path,fragment:p.fragment,query:p.query}))}function R(p){return p.replace(/./g,s=>{const I=s.charCodeAt(0);return I>=v.CharCode.a&&I<=v.CharCode.z||I>=v.CharCode.A&&I<=v.CharCode.Z||I>=v.CharCode.Digit0&&I<=v.CharCode.Digit9?s:"-"+I.toString(16).padStart(4,"0")})}function O(p){return p.replace(/-([0-9a-f]{4})/g,(s,I)=>String.fromCharCode(parseInt(I,16)))}}),define(Re[200],Te([1,0,6,4,83]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qqc=void 0;class N{constructor(O,p,s){this.d=O,this.e=p,this.f=s,this.a=0,this.b=new D.$Wc,this.c=new Map,this.b.add(p.onDidChangeVisibleTextEditors(()=>{const I=p.getVisibleTextEditors();for(const b of this.c.values())I.indexOf(b.editor)<0&&b.inset.dispose()}))}dispose(){this.c.forEach(O=>O.inset.dispose()),this.b.dispose()}createWebviewEditorInset(O,p,s,I,b){let h;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===O){h=i;break}if(!h)throw new Error("not a visible editor");const E=this,f=this.a++,r=new v.$oe,l=new v.$oe,d=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,P.$_Db)(i,E.f)}get cspSource(){return P.$$Db}set options(i){this.b=i,E.d.$setOptions(f,i)}get options(){return this.b}set html(i){this.a=i,E.d.$setHtml(f,i)}get html(){return this.a}get onDidReceiveMessage(){return r.event}postMessage(i){return E.d.$postMessage(f,i)}},a=new class{constructor(){this.editor=O,this.line=p,this.height=s,this.webview=d,this.onDidDispose=l.event}dispose(){E.c.has(f)&&(E.c.delete(f),E.d.$disposeEditorInset(f),l.fire(),l.dispose(),r.dispose())}};return this.d.$createEditorInset(f,h.id,h.value.document.uri,p+1,s,I||{},b.identifier,b.extensionLocation),this.c.set(f,{editor:O,inset:a,onDidReceiveMessage:r}),a}$onDidDispose(O){const p=this.c.get(O);p&&p.inset.dispose()}$onDidReceiveMessage(O,p){this.c.get(O)?.onDidReceiveMessage.fire(p)}}e.$Qqc=N}),define(Re[119],Te([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8M=e.$7M=e.$6M=void 0,e.$6M="__",e.$7M=(0,v.$Ii)("IAuthenticationService"),e.$8M=(0,v.$Ii)("IAuthenticationExtensionsService")}),define(Re[201],Te([1,0,3,12]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sR=e.VariableKind=e.$rR=void 0,e.$rR=(0,v.$Ii)("configurationResolverService");var P;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator",R.PathSeparatorAlias="/"})(P||(e.VariableKind=P={}));class N extends D.$db{constructor(O,p){super(p),this.variable=O}}e.$sR=N}),define(Re[202],Te([1,0,22,79,14,25,23,100,9,201,13]),function(we,e,v,D,P,N,R,O,p,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HR=void 0,v=qe(v),D=qe(D),P=qe(P),N=qe(N);class b{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(E,f,r,l){this.h=new Map,this.a=E,this.b=f,this.g=r,l&&(this.c=l.then(d=>this.i(d)))}i(E){if(R.$j){const f=Object.create(null);return Object.keys(E).forEach(r=>{f[r.toLowerCase()]=E[r]}),f}return E}resolveWithEnvironment(E,f,r){return this.l({env:this.i(E),userHome:void 0},f?f.uri:void 0,r)}async resolveAsync(E,f){const r={env:await this.c,userHome:await this.g};return this.l(r,E?E.uri:void 0,f)}async j(E,f,r,l){const d=N.$io(f);R.$j&&d.windows?Object.keys(d.windows).forEach(i=>d[i]=d.windows[i]):R.$k&&d.osx?Object.keys(d.osx).forEach(i=>d[i]=d.osx[i]):R.$l&&d.linux&&Object.keys(d.linux).forEach(i=>d[i]=d.linux[i]),delete d.windows,delete d.osx,delete d.linux;const a={env:await this.c,userHome:await this.g};return this.l(a,E?E.uri:void 0,d,r,l)}async resolveAnyAsync(E,f,r){return this.j(E,f,r)}async resolveAnyMap(E,f,r){const l=new Map;return{newConfig:await this.j(E,f,r,l),resolvedVariables:l}}resolveWithInteractionReplace(E,f,r,l){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,f,r,l){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,f){if(this.h.has(E))throw new Error("Variable "+E+" is contributed twice.");this.h.set(E,f)}async l(E,f,r,l,d){if(P.$hg(r))return this.m(E,f,r,l,d);if(Array.isArray(r))return Promise.all(r.map(a=>this.l(E,f,a,l,d)));if(P.$jg(r)){const a=Object.create(null),i=await Promise.all(Object.keys(r).map(async n=>[await this.m(E,f,n,l,d),await this.l(E,f,r[n],l,d)]));for(const[n,t]of i)a[n]=t;return a}return r}m(E,f,r,l,d){return(0,I.$Af)(r,b.VARIABLE_REGEXP,async(a,i)=>{if(i.includes(b.VARIABLE_LHS))return a;let n=await this.o(E,a,i,f,l);return d?.set(i,n),n!==a&&P.$hg(n)&&n.match(b.VARIABLE_REGEXP)&&(n=await this.m(E,f,n,l,d)),n})}n(E){return this.b?this.b.getUriLabel(E,{noPrefix:!0}):E.fsPath}async o(E,f,r,l,d){let a;const i=r.split(":");i.length>1&&(r=i[0],a=i[1]);const n=c=>{const m=this.a.getFilePath();if(m)return(0,O.$8w)(m);throw new s.$sR(c,(0,p.localize)(12142,null,f))},t=c=>{const m=n(c);if(this.a.getWorkspaceFolderPathForFile){const g=this.a.getWorkspaceFolderPathForFile();if(g)return(0,O.$8w)(g)}throw new s.$sR(c,(0,p.localize)(12143,null,f,v.$qc(m)))},o=c=>{if(a){const m=this.a.getFolderUri(a);if(m)return m;throw new s.$sR(c,(0,p.localize)(12144,null,f,a))}if(l)return l;throw this.a.getWorkspaceFolderCount()>1?new s.$sR(c,(0,p.localize)(12145,null,f)):new s.$sR(c,(0,p.localize)(12146,null,f))};switch(r){case"env":if(a){if(E.env){const c=E.env[R.$j?a.toLowerCase():a];if(P.$hg(c))return c}return""}throw new s.$sR(s.VariableKind.Env,(0,p.localize)(12147,null,f));case"config":if(a){const c=this.a.getConfigurationValue(l,a);if(P.$qg(c))throw new s.$sR(s.VariableKind.Config,(0,p.localize)(12148,null,f,a));if(P.$jg(c))throw new s.$sR(s.VariableKind.Config,(0,p.localize)(12149,null,f,a));return c}throw new s.$sR(s.VariableKind.Config,(0,p.localize)(12150,null,f));case"command":return this.p(s.VariableKind.Command,f,a,d,"command");case"input":return this.p(s.VariableKind.Input,f,a,d,"input");case"extensionInstallFolder":if(a){const c=await this.a.getExtension(a);if(!c)throw new s.$sR(s.VariableKind.ExtensionInstallFolder,(0,p.localize)(12151,null,f,a));return this.n(c.extensionLocation)}throw new s.$sR(s.VariableKind.ExtensionInstallFolder,(0,p.localize)(12152,null,f));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,O.$8w)(this.n(o(s.VariableKind.WorkspaceFolder)));case"cwd":return l||a?(0,O.$8w)(this.n(o(s.VariableKind.Cwd))):D.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,O.$8w)(v.$qc(this.n(o(s.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(E.userHome)return E.userHome;throw new s.$sR(s.VariableKind.UserHome,(0,p.localize)(12153,null,f))}case"lineNumber":{const c=this.a.getLineNumber();if(c)return c;throw new s.$sR(s.VariableKind.LineNumber,(0,p.localize)(12154,null,f))}case"selectedText":{const c=this.a.getSelectedText();if(c)return c;throw new s.$sR(s.VariableKind.SelectedText,(0,p.localize)(12155,null,f))}case"file":return n(s.VariableKind.File);case"fileWorkspaceFolder":return t(s.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return v.$qc(t(s.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return l||a?v.$oc(this.n(o(s.VariableKind.RelativeFile)),n(s.VariableKind.RelativeFile)):n(s.VariableKind.RelativeFile);case"relativeFileDirname":{const c=v.$pc(n(s.VariableKind.RelativeFileDirname));if(l||a){const m=v.$oc(this.n(o(s.VariableKind.RelativeFileDirname)),c);return m.length===0?".":m}return c}case"fileDirname":return v.$pc(n(s.VariableKind.FileDirname));case"fileExtname":return v.$rc(n(s.VariableKind.FileExtname));case"fileBasename":return v.$qc(n(s.VariableKind.FileBasename));case"fileBasenameNoExtension":{const c=v.$qc(n(s.VariableKind.FileBasenameNoExtension));return c.slice(0,c.length-v.$rc(c).length)}case"fileDirnameBasename":return v.$qc(v.$pc(n(s.VariableKind.FileDirnameBasename)));case"execPath":{const c=this.a.getExecPath();return c||f}case"execInstallFolder":{const c=this.a.getAppRoot();return c||f}case"pathSeparator":case"/":return v.sep;default:try{const c=a?`${r}:${a}`:r;return this.p(s.VariableKind.Unknown,f,c,d,void 0)}catch{return f}}}}p(E,f,r,l,d){if(r&&l){const a=d===void 0?l[r]:l[d+":"+r];if(typeof a=="string")return a;throw new s.$sR(E,(0,p.localize)(12156,null,f))}return f}}e.$HR=b}),define(Re[120],Te([1,0,3,116]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$JE=void 0,e.$KE=s,e.$LE=h,e.$ME=E,e.$JE=(0,v.$Ii)("editorGroupsService");var P;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var N;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(N||(e.GroupOrientation=N={}));var R;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var O;(function(f){f[f.MAXIMIZE=0]="MAXIMIZE",f[f.EXPAND=1]="EXPAND",f[f.EVEN=2]="EVEN"})(O||(e.GroupsArrangement=O={}));var p;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(p||(e.MergeGroupMode=p={}));function s(f){const r=f;return(0,D.$vG)(r?.editor)&&(0,D.$vG)(r?.replacement)}var I;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(I||(e.GroupsOrder=I={}));var b;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(b||(e.OpenEditorContext=b={}));function h(f){const r=f;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}function E(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?P.DOWN:P.RIGHT}}),define(Re[203],Te([1,0,3,120]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QE=e.$PE=e.$OE=e.$NE=void 0,e.$RE=P,e.$NE=(0,v.$Ii)("editorService"),e.$OE=-1,e.$PE=-2,e.$QE=-3;function P(N){const R=N;return typeof N=="number"||(0,D.$LE)(R)}}),define(Re[204],Te([1,0,3,107]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nN=void 0,e.$nN=(0,v.$Ji)(D.$Pi)}),define(Re[121],Te([1,0,18,6,22,4,10]),function(we,e,v,D,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rec=e.$Qec=e.$Pec=e.$Oec=e.$Nec=void 0,P=qe(P);class O{constructor(a,i){this.versionId=a,this.removedDueToLooping=i}}e.$Nec=O;class p{static isHostExtension(a,i,n){if(i.getExtensionDescription(a))return!1;const t=n.getExtensionDescription(a);return t?!!((t.main||t.browser)&&t.api==="none"):!1}constructor(a,i){this.j=a,this.c=new D.$oe,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(r),this.f=new v.$xn,this.g=[],this.h=new Map;for(const a of this.e){if(this.f.has(a.identifier)){console.error("Extension `"+a.identifier.value+"` is already registered");continue}this.f.set(a.identifier,a),this.g.push(a);const i=this.j.readActivationEvents(a);for(const n of i)this.h.has(n)||this.h.set(n,[]),this.h.get(n).push(a)}}set(a){return this.e=a,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(a,i){this.e=l(this.e,i),this.e=this.e.concat(a);const n=p.l(this.e);return this.e=l(this.e,n.map(t=>t.identifier)),this.k(),this.d++,this.c.fire(void 0),new O(this.d,n)}static l(a){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(m){this.d.has(m)||(this.d.add(m),this.e.push(m))}addArc(m,g){this.addNode(m),this.addNode(g),this.c.has(m)?this.c.get(m).push(g):this.c.set(m,[g])}getArcs(m){return this.c.has(m)?this.c.get(m):[]}hasOnlyGoodArcs(m,g){const u=i.getArcs(m);for(let S=0;S<u.length;S++)if(!g.has(u[S]))return!1;return!0}getNodes(){return this.e}},n=new v.$xn;for(const m of a)if(n.set(m.identifier,m),m.extensionDependencies)for(const g of m.extensionDependencies)i.addArc(v.$vn.toKey(m.identifier),v.$vn.toKey(g));const t=new Set;i.getNodes().filter(m=>i.getArcs(m).length===0).forEach(m=>t.add(m));const o=i.getNodes().filter(m=>!t.has(m));let c;do{c=!1;for(let m=0;m<o.length;m++){const g=o[m];i.hasOnlyGoodArcs(g,t)&&(o.splice(m,1),m--,t.add(g),c=!0)}}while(c);return o.map(m=>n.get(m))}containsActivationEvent(a){return this.h.has(a)}containsExtension(a){return this.f.has(a)}getExtensionDescriptionsForActivationEvent(a){const i=this.h.get(a);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new s(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(a){const i=this.f.get(a);return i||void 0}getExtensionDescriptionByUUID(a){for(const i of this.g)if(i.uuid===a)return i}getExtensionDescriptionByIdOrUUID(a,i){return this.getExtensionDescription(a)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$Oec=p;class s{constructor(a,i){this.versionId=a,this.extensions=i}}e.$Pec=s;class I{constructor(a){this.d=new E,this.c=new p(a,[])}async acquireLock(a){const i=await this.d.acquire(a);return new b(this,i)}deltaExtensions(a,i,n){if(!a.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,n)}containsActivationEvent(a){return this.c.containsActivationEvent(a)}containsExtension(a){return this.c.containsExtension(a)}getExtensionDescriptionsForActivationEvent(a){return this.c.getExtensionDescriptionsForActivationEvent(a)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(a){return this.c.getExtensionDescription(a)}getExtensionDescriptionByUUID(a){return this.c.getExtensionDescriptionByUUID(a)}getExtensionDescriptionByIdOrUUID(a,i){return this.c.getExtensionDescriptionByIdOrUUID(a,i)}}e.$Qec=I;class b extends N.$Xc{constructor(a,i){super(),this.f=a,this.c=!1,this.B(i)}isAcquiredFor(a){return!this.c&&this.f===a}}e.$Rec=b;class h{constructor(a){this.name=a;const i=(0,R.$Bh)();this.promise=i.promise,this.c=i.resolve}resolve(a){this.c(a)}}class E{constructor(){this.c=[],this.d=!1}async acquire(a){const i=new h(a);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const a=this.c.shift();this.d=!0;let i=!0;const n=setTimeout(()=>{i&&console.warn(`The customer named ${a.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),t=()=>{i&&(clearTimeout(n),i=!1,this.d=!1,this.e())};a.resolve((0,N.$Vc)(t))}}var f;(function(d){d[d.Builtin=0]="Builtin",d[d.User=1]="User",d[d.Dev=2]="Dev"})(f||(f={}));function r(d,a){const i=d.isBuiltin?f.Builtin:d.isUnderDevelopment?f.Dev:f.User,n=a.isBuiltin?f.Builtin:a.isUnderDevelopment?f.Dev:f.User;if(i!==n)return i-n;const t=P.$jc.basename(d.extensionLocation.path),o=P.$jc.basename(a.extensionLocation.path);return t<o?-1:t>o?1:0}function l(d,a){const i=new v.$wn(a);return d.filter(n=>!i.has(n.identifier))}}),define(Re[84],Te([1,0,20]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Fn=R,e.$Gn=O;var D;(function(s){s[s.Desktop=1]="Desktop",s[s.Web=2]="Web"})(D||(e.UIKind=D={}));var P;(function(s){s[s.VersionMismatch=55]="VersionMismatch",s[s.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var N;(function(s){s[s.Initialized=0]="Initialized",s[s.Ready=1]="Ready",s[s.Terminate=2]="Terminate"})(N||(e.MessageType=N={}));function R(s){const I=v.$Qe.alloc(1);switch(s){case N.Initialized:I.writeUInt8(1,0);break;case N.Ready:I.writeUInt8(2,0);break;case N.Terminate:I.writeUInt8(3,0);break}return I}function O(s,I){if(s.byteLength!==1)return!1;switch(s.readUInt8(0)){case 1:return I===N.Initialized;case 2:return I===N.Ready;case 3:return I===N.Terminate;default:return!1}}var p;(function(s){s.Start="START_NATIVE_LOG",s.End="END_NATIVE_LOG"})(p||(e.NativeLogMarkers=p={}))}),define(Re[66],Te([1,0,3,6,113,11,26,84,62,63,25,2,4,9]),function(we,e,v,D,P,N,R,O,p,s,I,b,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XQ=e.$VQ=e.$UQ=void 0,e.$WQ=l;let f=class extends h.$Xc{constructor(a,i){super(),this.s=a,this.t=i,this.a=this.B(new D.$oe),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new D.$oe),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=P.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=b.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:s.$Gp,name:(0,E.localize)(2713,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(n=>{(0,N.$fk)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===N.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===P.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=P.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=P.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=P.TelemetryLevel.USAGE:!1}}instantiateLogger(a,i,n){const t=this.getTelemetryDetails(),o=new r(i,n,a,this.n,this.j,this.getBuiltInCommonProperties(a),{isUsageEnabled:t.isUsageEnabled,isErrorsEnabled:t.isErrorsEnabled}),c=this.r.get(a.identifier.value)??[];return this.r.set(a.identifier.value,[...c,o]),o.apiTelemetryLogger}$initializeTelemetryLevel(a,i,n){this.f=a,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(a){const i=Object.create(null);switch(i["common.extname"]=`${a.publisher}.${a.name}`,i["common.extversion"]=a.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=l(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case O.UIKind.Web:i["common.uikind"]="web";break;case O.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,p.$mn)((0,s.$Mp)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(a){this.h=this.getTelemetryConfiguration(),this.f=a;const i=this.getTelemetryDetails();this.r.forEach((n,t)=>{const o=n.filter(c=>!c.isDisposed);o.length===0?this.r.delete(t):this.r.set(t,o)}),this.r.forEach(n=>{for(const t of n)t.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(a,i){const t=this.r.get(a.value)?.filter(c=>!c.isDisposed);if(!t)return this.r.delete(a.value),!1;let o=!1;for(const c of t)c.ignoreUnhandledExtHostErrors||(c.logError(i),o=!0);return o}};e.$UQ=f,e.$UQ=f=Ke([We(0,R.$TQ),We(1,N.$ek)],f);class r{static validateSender(a){if(typeof a!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof a.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof a.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof a.flush<"u"&&typeof a.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(a,i,n,t,o,c,m){this.g=n,this.h=t,this.i=o,this.j=c,this.a=new D.$oe,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=a,this.d={isUsageEnabled:m.isUsageEnabled,isErrorsEnabled:m.isErrorsEnabled}}updateTelemetryEnablements(a,i){this.e&&(this.d={isUsageEnabled:a,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(a){let i="properties"in a?a.properties??{}:a;return i=(0,s.$Pp)(i,[]),this.c&&(i=(0,I.$lo)(i,this.c)),this.b||(i=(0,I.$lo)(i,this.j)),"properties"in a?a.properties=i:a=i,a}k(a,i){this.f&&(this.g.publisher==="vscode"?a=this.g.name+"/"+a:a=this.g.identifier.value+"/"+a,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(a,i),this.h.trace(a,i))}logUsage(a,i){this.d.isUsageEnabled&&this.k(a,i)}logError(a,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof a=="string")this.k(a,i);else{const n={name:a.name,message:a.message,stack:a.stack,cause:a.cause},t=(0,s.$Pp)(n,[]),o=new Error(t.message,{cause:t.cause});o.stack=t.stack,o.name=t.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(o,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const a=this,i={logUsage:a.logUsage.bind(a),get isUsageEnabled(){return a.d.isUsageEnabled},get isErrorsEnabled(){return a.d.isErrorsEnabled},logError:a.logError.bind(a),dispose:a.dispose.bind(a),onDidChangeEnableStates:a.a.event.bind(a)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let a=this.f;this.f=void 0,Promise.resolve(a.flush()).then(a=void 0),this.e=void 0}else this.f=void 0}}e.$VQ=r;function l(d){const a=Date.now()-new Date(d).getTime();return isNaN(a)?!1:a<1e3*60*60*24}e.$XQ=(0,v.$Ii)("IExtHostTelemetry")}),define(Re[21],Te([1,0,6,2,178,112,18,3]),function(we,e,v,D,P,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BH=e.ActivationKind=e.$yH=e.$xH=e.$uH=e.ExtensionHostStartup=e.$tH=e.$sH=e.$rH=e.$qH=void 0,e.$vH=h,e.$wH=E,e.$zH=d,e.$AH=a,e.$qH=Object.freeze({identifier:new R.$vn("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:D.URI.parse("void:location"),isBuiltin:!1,targetPlatform:R.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$rH="extensions.webWorker",e.$sH=(0,O.$Ii)("extensionService");class p{constructor(t){this.dependency=t}}e.$tH=p;var s;(function(n){n[n.EagerAutoStart=1]="EagerAutoStart",n[n.EagerManualStart=2]="EagerManualStart",n[n.Lazy=3]="Lazy"})(s||(e.ExtensionHostStartup=s={}));class I{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(t,o,c){this.c=t,this.d=o.slice(0),this.e=c.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:N.$cH.createActivationEventsMap(this.d)}}set(t,o,c){if(this.c>t)throw new Error(`ExtensionHostExtensions: invalid versionId ${t} (current: ${this.c})`);const m=[],g=[],u=[],S=[],k=b(this.d),y=b(o),C=(A,L)=>A.extensionLocation.toString()===L.extensionLocation.toString()||A.isBuiltin===L.isBuiltin||A.isUserBuiltin===L.isUserBuiltin||A.isUnderDevelopment===L.isUnderDevelopment;for(const A of this.d){const L=y.get(A.identifier);if(!L){m.push(A.identifier),k.delete(A.identifier);continue}if(!C(A,L)){m.push(A.identifier),k.delete(A.identifier);continue}}for(const A of o){const L=k.get(A.identifier);if(!L){g.push(A);continue}if(!C(L,A)){m.push(L.identifier),k.delete(L.identifier);continue}}const T=new R.$wn(this.e),$=new R.$wn(c);for(const A of this.e)$.has(A)||u.push(A);for(const A of c)T.has(A)||S.push(A);const w=N.$cH.createActivationEventsMap(g),M={versionId:t,toRemove:m,toAdd:g,addActivationEvents:w,myToRemove:u,myToAdd:S};return this.delta(M),M}delta(t){if(this.c>=t.versionId)return null;const{toRemove:o,toAdd:c,myToRemove:m,myToAdd:g}=t,u=new R.$wn(o),S=new R.$wn(m);for(let k=0;k<this.d.length;k++)u.has(this.d[k].identifier)&&(this.d.splice(k,1),k--);for(let k=0;k<this.e.length;k++)S.has(this.e[k])&&(this.e.splice(k,1),k--);for(const k of c)this.d.push(k);for(const k of g)this.e.push(k);return this.f=null,t}containsExtension(t){for(const o of this.e)if(R.$vn.equals(o,t))return!0;return!1}containsActivationEvent(t){return this.f||(this.f=this.g()),this.f.has(t)}g(){const t=new Set;for(const o of this.d){if(!this.containsExtension(o.identifier))continue;const c=N.$cH.readActivationEvents(o);for(const m of c)t.add(m)}return t}}e.$uH=I;function b(n){const t=new R.$xn;for(const o of n)t.set(o.identifier,o);return t}function h(n,t){return n.enabledApiProposals?n.enabledApiProposals.includes(t):!1}function E(n,t){if(!h(n,t))throw new Error(`Extension '${n.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${n.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${n.identifier.value}`)}class f{constructor(t,o,c,m){this.codeLoadingTime=t,this.activateCallTime=o,this.activateResolvedTime=c,this.activationReason=m}}e.$xH=f;class r{constructor(t,o){this.description=t,this.value=o}}e.$yH=r;var l;(function(n){n[n.Normal=0]="Normal",n[n.Immediate=1]="Immediate"})(l||(e.ActivationKind=l={}));function d(n){return{type:n.isBuiltin?R.ExtensionType.System:R.ExtensionType.User,isBuiltin:n.isBuiltin||n.isUserBuiltin,identifier:{id:(0,P.$Vp)(n.publisher,n.name),uuid:n.uuid},manifest:n,location:n.extensionLocation,targetPlatform:n.targetPlatform,validations:[],isValid:!0}}function a(n,t){const o=(0,P.$Tp)(n.manifest.publisher,n.manifest.name);return{id:o,identifier:new R.$vn(o),isBuiltin:n.type===R.ExtensionType.System,isUserBuiltin:n.type===R.ExtensionType.User&&n.isBuiltin,isUnderDevelopment:!!t,extensionLocation:n.location,uuid:n.identifier.uuid,targetPlatform:n.targetPlatform,publisherDisplayName:n.publisherDisplayName,...n.manifest}}class i{constructor(){this.onDidRegisterExtensions=v.Event.None,this.onDidChangeExtensionsStatus=v.Event.None,this.onDidChangeExtensions=v.Event.None,this.onWillActivateByEvent=v.Event.None,this.onDidChangeResponsiveChange=v.Event.None,this.onWillStop=v.Event.None,this.extensions=[]}activateByEvent(t){return Promise.resolve(void 0)}activateById(t,o){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(t,o){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$BH=i}),define(Re[205],Te([1,0,12,4,121,18,21,11,10]),function(we,e,v,D,P,N,R,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$frc=e.$erc=e.$drc=e.$crc=e.$brc=e.$arc=void 0,v=qe(v);class s{static{this.NONE=new s(!1,-1,-1,-1)}constructor(a,i,n,t){this.startup=a,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=t}}e.$arc=s;class I{constructor(a){this.a=a,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(a,i){return a===-1||i===-1?-1:i-a}build(){return new s(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$brc=I;class b{constructor(a,i,n,t,o,c){this.activationFailed=a,this.activationFailedError=i,this.activationTimes=n,this.module=t,this.exports=o,this.disposable=c}}e.$crc=b;class h extends b{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,D.$Xc.None)}}e.$drc=h;class E extends b{constructor(){super(!1,null,s.NONE,{activate:void 0,deactivate:void 0},void 0,D.$Xc.None)}}e.$erc=E;class f extends b{constructor(a){super(!0,a,s.NONE,{activate:void 0,deactivate:void 0},void 0,D.$Xc.None)}}let r=class{constructor(a,i,n,t){this.g=t,this.a=a,this.b=i,this.c=n,this.d=new N.$xn,this.f=Object.create(null)}dispose(){for(const[a,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const a=[];for(const[i,n]of this.d)a.push(n.wait());await Promise.all(a)}isActivated(a){const i=this.d.get(a);return!!(i&&i.value)}getActivatedExtension(a){const i=this.d.get(a);if(!i||!i.value)throw new Error(`Extension '${a.value}' is not known or not activated`);return i.value}async activateByEvent(a,i){if(this.f[a])return;const n=this.a.getExtensionDescriptionsForActivationEvent(a);await this.h(n.map(t=>({id:t.identifier,reason:{startup:i,extensionId:t.identifier,activationEvent:a}}))),this.f[a]=!0}activateById(a,i){const n=this.a.getExtensionDescription(a);if(!n)throw new Error(`Extension '${a.value}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(a){const i=a.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(a){if(this.d.has(a.id))return this.d.get(a.id);if(this.l(a.id))return this.k(a,null,[],null);const i=this.a.getExtensionDescription(a.id);if(!i){const o=new Error(`Cannot activate unknown extension '${a.id.value}'`),c=this.k(a,null,[],new f(o));return this.c.onExtensionActivationError(a.id,o,new R.$tH(a.id.value)),c}const n=[],t=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const o of t){if(this.m(o))continue;const c=this.d.get(o);if(c){n.push(c);continue}if(this.l(o)){n.push(this.j({id:this.b.getExtensionDescription(o).identifier,reason:a.reason}));continue}const m=this.a.getExtensionDescription(o);if(m){if(!m.main&&!m.browser)continue;n.push(this.j({id:m.identifier,reason:a.reason}));continue}const g=i.displayName||i.identifier.value,u=new Error(`Cannot activate the '${g}' extension because it depends on unknown extension '${o}'`),S=this.k(a,i.displayName,[],new f(u));return this.c.onExtensionActivationError(i.identifier,u,new R.$tH(o)),S}return this.k(a,i.displayName,n,null)}k(a,i,n,t){const o=new l(a.id,i,a.reason,n,t,this.c,this.g);return this.d.set(a.id,o),o}l(a){return P.$Oec.isHostExtension(a,this.a,this.b)}m(a){const i=this.b.getExtensionDescription(a);return i?!i.main&&!i.browser:!1}};e.$frc=r,e.$frc=r=Ke([We(3,O.$dk)],r);let l=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(a,i,n,t,o,c,m){this.c=a,this.d=i,this.f=n,this.g=t,this.h=o,this.j=c,this.k=m,this.a=new p.$Hh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let a=0;a<this.g.length;a++){const i=this.g[a];if(i.value&&!i.value.activationFailed){this.g.splice(a,1),a--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new f(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(a=>a.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(a){const i=new Error;if(a&&a.name&&(i.name=a.name),a&&a.message?i.message=`Activating extension '${this.c.value}' failed: ${a.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${a}.`,a&&a.stack&&(i.stack=a.stack),this.h=new f(i),this.b&&v.$6(a))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(a)}}};l=Ke([We(6,O.$dk)],l)});var si=this&&this.__importDefault||function(we){return we&&we.__esModule?we:{default:we}};define(Re[122],Te([1,0,9,12,36,111,78,29,18,109,112,105]),function(we,e,v,D,P,N,R,O,p,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=void 0,v=qe(v),P=si(P);const h=O.$vo.as(R.$wo.JSONContribution);class E{constructor(t,o,c){this.a=t,this.b=o,this.c=c}d(t,o){this.a({type:t,message:o,extensionId:this.b.identifier,extensionPointId:this.c})}error(t){this.d(P.default.Error,t)}warn(t){this.d(P.default.Warning,t)}info(t){this.d(P.default.Info,t)}}e.$kH=E;class f{static a(t){const o=new p.$wn;for(let c=0,m=t.length;c<m;c++)o.add(t[c].description.identifier);return o}static compute(t,o){if(!t||!t.length)return new f(o,[]);if(!o||!o.length)return new f([],t);const c=this.a(t),m=this.a(o),g=o.filter(S=>!c.has(S.description.identifier)),u=t.filter(S=>!m.has(S.description.identifier));return new f(g,u)}constructor(t,o){this.added=t,this.removed=o}}e.$lH=f;class r{constructor(t,o){this.name=t,this.defaultExtensionKind=o,this.a=null,this.b=null,this.c=null}setHandler(t){if(this.a!==null)throw new Error("Handler already set!");return this.a=t,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(t){this.c=f.compute(this.b,t),this.b=t,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(t){(0,D.$2)(t)}}}e.$mH=r;const l={type:"string",enum:["ui","workspace"],enumDescriptions:[v.localize(12311,null),v.localize(12312,null)]},d="vscode://schemas/vscode-extensions";e.$nH={properties:{engines:{type:"object",description:v.localize(12313,null),properties:{vscode:{type:"string",description:v.localize(12314,null),default:"^1.22.0"}}},publisher:{description:v.localize(12315,null),type:"string"},displayName:{description:v.localize(12316,null),type:"string"},categories:{description:v.localize(12317,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:p.$un},{type:"string",const:"Languages",deprecationMessage:v.localize(12318,null)}]}},galleryBanner:{type:"object",description:v.localize(12319,null),properties:{color:{description:v.localize(12320,null),type:"string"},theme:{description:v.localize(12321,null),type:"string",enum:["dark","light"]}}},contributes:{description:v.localize(12322,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:v.localize(12323,null)},enableProposedApi:{type:"boolean",deprecationMessage:v.localize(12324,null)},enabledApiProposals:{markdownDescription:v.localize(12325,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(b.allApiProposals).map(n=>n),markdownEnumDescriptions:Object.values(b.allApiProposals).map(n=>n.proposal)}},api:{markdownDescription:v.localize(12326,null),type:"string",enum:["none"],enumDescriptions:[v.localize(12327,null)]},activationEvents:{description:v.localize(12328,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:v.localize(12329,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:v.localize(12330,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:v.localize(12331,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:v.localize(12332,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:v.localize(12333,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:v.localize(12334,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:v.localize(12335,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:v.localize(12336,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:v.localize(12337,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:v.localize(12338,null),body:"onStartupFinished"},{label:"onTaskType",description:v.localize(12339,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:v.localize(12340,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:v.localize(12341,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:v.localize(12342,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:v.localize(12343,null)},{label:"onUri",body:"onUri",description:v.localize(12344,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:v.localize(12345,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:v.localize(12346,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:v.localize(12347,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:v.localize(12348,null)},{label:"onRenderer",description:v.localize(12349,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:v.localize(12350,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:v.localize(12351,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:v.localize(12352,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:v.localize(12353,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:v.localize(12354,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolId}",description:v.localize(12355,null)},{label:"*",description:v.localize(12356,null),body:"*"}]}},badges:{type:"array",description:v.localize(12357,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:v.localize(12358,null)},href:{type:"string",description:v.localize(12359,null)},description:{type:"string",description:v.localize(12360,null)}}}},markdown:{type:"string",description:v.localize(12361,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:v.localize(12362,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:v.localize(12363,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.$cp}},extensionPack:{description:v.localize(12364,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.$cp}},extensionKind:{description:v.localize(12365,null),type:"array",items:l,default:["workspace"],defaultSnippets:[{body:["ui"],description:v.localize(12366,null)},{body:["workspace"],description:v.localize(12367,null)},{body:["ui","workspace"],description:v.localize(12368,null)},{body:["workspace","ui"],description:v.localize(12369,null)},{body:[],description:v.localize(12370,null)}]},capabilities:{description:v.localize(12371,null),type:"object",properties:{virtualWorkspaces:{description:v.localize(12372,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:v.localize(12373,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[v.localize(12374,null),v.localize(12375,null),v.localize(12376,null)]},description:{type:"string",markdownDescription:v.localize(12377,null)}}},untrustedWorkspaces:{description:v.localize(12378,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:v.localize(12379,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[v.localize(12380,null),v.localize(12381,null),v.localize(12382,null)]},restrictedConfigurations:{description:v.localize(12383,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:v.localize(12384,null)}}}}},sponsor:{description:v.localize(12385,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:v.localize(12386,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:v.localize(12387,null),type:"string"},"vscode:uninstall":{description:v.localize(12388,null),type:"string"}}},icon:{type:"string",description:v.localize(12389,null)},l10n:{type:"string",description:v.localize(12390,null)},pricing:{type:"string",markdownDescription:v.localize(12391,null),enum:["Free","Trial"],default:"Free"}}};class a{constructor(){this.a=new Map}registerExtensionPoint(t){if(this.a.has(t.extensionPoint))throw new Error("Duplicate extension point: "+t.extensionPoint);const o=new r(t.extensionPoint,t.defaultExtensionKind);return this.a.set(t.extensionPoint,o),t.activationEventsGenerator&&I.$cH.register(t.extensionPoint,t.activationEventsGenerator),e.$nH.properties.contributes.properties[t.extensionPoint]=t.jsonSchema,h.registerSchema(d,e.$nH),o}getExtensionPoints(){return Array.from(this.a.values())}}e.$oH=a;const i={ExtensionsRegistry:"ExtensionsRegistry"};O.$vo.add(i.ExtensionsRegistry,new a),e.$pH=O.$vo.as(i.ExtensionsRegistry),h.registerSchema(d,e.$nH),h.registerSchema(s.$xk,{properties:{extensionEnabledApiProposals:{description:v.localize(12392,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(b.allApiProposals),markdownEnumDescriptions:Object.values(b.allApiProposals).map(n=>n.proposal)}}]}}}})}),define(Re[206],Te([1,0,6,40,4,13,9,18,3,11,21,122]),function(we,e,v,D,P,N,R,O,p,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EH=e.$DH=e.$CH=e.ChatMessageRole=void 0;var h;(function(r){r[r.System=0]="System",r[r.User=1]="User",r[r.Assistant=2]="Assistant"})(h||(e.ChatMessageRole=h={})),e.$CH=(0,p.$Ii)("ILanguageModelsService");const E={type:"object",properties:{vendor:{type:"string",description:(0,R.localize)(4728,null)}}};e.$DH=b.$pH.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,R.localize)(4729,null),oneOf:[E,{type:"array",items:E}]},activationEventsGenerator:(r,l)=>{for(const d of r)l.push(`onLanguageModelChat:${d.vendor}`)}});let f=class{constructor(l,d){this.e=l,this.f=d,this.a=new P.$Wc,this.b=new Map,this.c=new Set,this.d=this.a.add(new v.$oe),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$DH.setHandler(a=>{this.c.clear();for(const n of a){if(!(0,I.$vH)(n.description,"chatProvider")){n.collector.error((0,R.localize)(4730,null));continue}for(const t of D.Iterable.wrap(n.value)){if(this.c.has(t.vendor)){n.collector.error((0,R.localize)(4731,null,t.vendor));continue}if((0,N.$ff)(t.vendor)){n.collector.error((0,R.localize)(4732,null));continue}if(t.vendor.trim()!==t.vendor){n.collector.error((0,R.localize)(4733,null));continue}this.c.add(t.vendor)}}const i=[];for(const[n,t]of this.b)this.c.has(t.metadata.vendor)||(this.b.delete(n),i.push(n));i.length>0&&this.d.fire({removed:i})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(l){return this.b.get(l)?.metadata}async selectLanguageModels(l){if(l.vendor)await this.e.activateByEvent(`onLanguageModelChat:${l.vendor}}`);else{const a=Array.from(this.c).map(i=>this.e.activateByEvent(`onLanguageModelChat:${i}`));await Promise.all(a)}const d=[];for(const[a,i]of this.b)(l.vendor===void 0||i.metadata.vendor===l.vendor)&&(l.family===void 0||i.metadata.family===l.family)&&(l.version===void 0||i.metadata.version===l.version)&&(l.identifier===void 0||i.metadata.id===l.identifier)&&(!i.metadata.targetExtensions||i.metadata.targetExtensions.some(n=>O.$vn.equals(n,l.extension)))&&d.push(a);return this.f.trace("[LM] selected language models",l,d),d}registerLanguageModelChat(l,d){if(this.f.trace("[LM] registering language model chat",l,d.metadata),!this.c.has(d.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${d.metadata.vendor}.`);if(this.b.has(l))throw new Error(`Chat response provider with identifier ${l} is already registered.`);return this.b.set(l,d),this.d.fire({added:[{identifier:l,metadata:d.metadata}]}),(0,P.$Vc)(()=>{this.b.delete(l)&&(this.d.fire({removed:[l]}),this.f.trace("[LM] UNregistered language model chat",l,d.metadata))})}async sendChatRequest(l,d,a,i,n){const t=this.b.get(l);if(!t)throw new Error(`Chat response provider with identifier ${l} is not registered.`);return t.sendChatRequest(a,d,i,n)}computeTokenLength(l,d,a){const i=this.b.get(l);if(!i)throw new Error(`Chat response provider with identifier ${l} is not registered.`);return i.provideTokenCount(d,a)}};e.$EH=f,e.$EH=f=Ke([We(0,I.$sH),We(1,s.$dk)],f)}),define(Re[207],Te([1,0,9,14,25,122,31,6]),function(we,e,v,D,P,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aJ=void 0,v=qe(v),D=qe(D),P=qe(P);const p={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:v.localize(9889,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:v.localize(9890,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:v.localize(9891,null),default:""}}};var s;(function(h){function E(f,r,l){if(!f)return;const d=D.$hg(f.type)?f.type:void 0;if(!d||d.length===0){l.error(v.localize(9892,null));return}const a=[];if(Array.isArray(f.required))for(const i of f.required)D.$hg(i)&&a.push(i);return{extensionId:r.value,taskType:d,required:a,properties:f.properties?P.$io(f.properties):{},when:f.when?R.$Gj.deserialize(f.when):void 0}}h.from=E})(s||(s={}));const I=N.$pH.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(h,E)=>{for(const f of h)f.type&&E.push(`onTaskType:${f.type}`)},jsonSchema:{description:v.localize(9893,null),type:"array",items:p}});class b{constructor(){this.d=new O.$oe,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((E,f)=>{I.setHandler((r,l)=>{this.c=void 0;try{for(const d of l.removed){const a=d.value;for(const i of a)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const d of l.added){const a=d.value;for(const i of a){const n=s.from(i,d.description.identifier,d.collector);n&&(this.a[n.taskType]=n)}}(l.removed.length>0||l.added.length>0)&&this.d.fire()}catch{}E(void 0)})})}onReady(){return this.b}get(E){return this.a[E]}all(){return Object.keys(this.a).map(E=>this.a[E])}getJsonSchema(){if(this.c===void 0){const E=[];for(const f of this.all()){const r={type:"object",additionalProperties:!1};f.required.length>0&&(r.required=f.required.slice(0)),f.properties!==void 0?r.properties=P.$io(f.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[f.taskType]},E.push(r)}this.c={oneOf:E}}return this.c}}e.$aJ=new b}),define(Re[208],Te([1,0,9,14,24,25,31,207,43]),function(we,e,v,D,P,N,R,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$kJ=e.JsonSchemaVersion=e.ExecutionEngine=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$eJ=e.ShellQuoting=e.$dJ=e.$cJ=e.$bJ=void 0,v=qe(v),D=qe(D),P=qe(P),N=qe(N),e.$bJ="settings",e.$cJ=new R.$Zj("taskRunning",!1,v.localize(9894,null)),e.$dJ=v.localize2(9896,"Tasks");var s;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(s||(e.ShellQuoting=s={})),e.$eJ="$customized",function(z){function Q(V){if(!V)return z.Strong;switch(V.toLowerCase()){case"escape":return z.Escape;case"strong":return z.Strong;case"weak":return z.Weak;default:return z.Strong}}z.from=Q}(s||(e.ShellQuoting=s={}));var I;(function(z){z.defaults={cwd:"${workspaceFolder}"}})(I||(e.CommandOptions=I={}));var b;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(b||(e.RevealKind=b={})),function(z){function Q(V){switch(V.toLowerCase()){case"always":return z.Always;case"silent":return z.Silent;case"never":return z.Never;default:return z.Always}}z.fromString=Q}(b||(e.RevealKind=b={}));var h;(function(z){z[z.Never=1]="Never",z[z.OnProblem=2]="OnProblem",z[z.Always=3]="Always"})(h||(e.RevealProblemKind=h={})),function(z){function Q(V){switch(V.toLowerCase()){case"always":return z.Always;case"never":return z.Never;case"onproblem":return z.OnProblem;default:return z.OnProblem}}z.fromString=Q}(h||(e.RevealProblemKind=h={}));var E;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(E||(e.PanelKind=E={})),function(z){function Q(V){switch(V.toLowerCase()){case"shared":return z.Shared;case"dedicated":return z.Dedicated;case"new":return z.New;default:return z.Shared}}z.fromString=Q}(E||(e.PanelKind=E={}));var f;(function(z){z.defaults={echo:!0,reveal:b.Always,revealProblems:h.Never,focus:!1,panel:E.Shared,showReuseMessage:!0,clear:!1}})(f||(e.PresentationOptions=f={}));var r;(function(z){z[z.Shell=1]="Shell",z[z.Process=2]="Process",z[z.CustomExecution=3]="CustomExecution"})(r||(e.RuntimeType=r={})),function(z){function Q(ie){switch(ie.toLowerCase()){case"shell":return z.Shell;case"process":return z.Process;case"customExecution":return z.CustomExecution;default:return z.Process}}z.fromString=Q;function V(ie){switch(ie){case z.Shell:return"shell";case z.Process:return"process";case z.CustomExecution:return"customExecution";default:return"process"}}z.toString=V}(r||(e.RuntimeType=r={}));var l;(function(z){function Q(V){return D.$hg(V)?V:V.value}z.value=Q})(l||(e.CommandString=l={}));var d;(function(z){z.Clean={_id:"clean",isDefault:!1},z.Build={_id:"build",isDefault:!1},z.Rebuild={_id:"rebuild",isDefault:!1},z.Test={_id:"test",isDefault:!1};function Q(ie){return ie===z.Clean._id||ie===z.Build._id||ie===z.Rebuild._id||ie===z.Test._id}z.is=Q;function V(ie){if(ie!==void 0)return D.$hg(ie)?Q(ie)?{_id:ie,isDefault:!1}:void 0:ie}z.from=V})(d||(e.TaskGroup=d={}));var a;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.Folder=3]="Folder"})(a||(e.TaskScope=a={}));var i;(function(z){z.Workspace="workspace",z.Extension="extension",z.InMemory="inMemory",z.WorkspaceFile="workspaceFile",z.User="user";function Q(V){switch(V){case z.User:return p.ConfigurationTarget.USER;case z.WorkspaceFile:return p.ConfigurationTarget.WORKSPACE;default:return p.ConfigurationTarget.WORKSPACE_FOLDER}}z.toConfigurationTarget=Q})(i||(e.TaskSourceKind=i={}));var n;(function(z){z.parallel="parallel",z.sequence="sequence"})(n||(e.DependsOrder=n={}));var t;(function(z){z[z.default=1]="default",z[z.folderOpen=2]="folderOpen"})(t||(e.RunOnOptions=t={}));var o;(function(z){z.defaults={reevaluateOnRerun:!0,runOn:t.default,instanceLimit:1}})(o||(e.RunOptions=o={}));class c{constructor(Q,V,ie,le,_,oe){this._label="",this._id=Q,V&&(this._label=V),ie&&(this.type=ie),this.runOptions=le,this.configurationProperties=_,this._source=oe}getDefinition(Q){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const Q={folder:this.d(),id:this._id};return JSON.stringify(Q)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(Q,V=!1){if(Q===void 0)return!1;if(D.$hg(Q))return Q===this._label||Q===this.configurationProperties.identifier||V&&Q===this._id;const ie=this.getDefinition(!0);return ie!==void 0&&ie._key===Q._key}getQualifiedLabel(){const Q=this.getWorkspaceFolder();return Q?`${this._label} (${Q.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(Q){this.c===void 0&&(this.c=[]),Q&&(this.c=this.c.concat(Q))}get taskLoadMessages(){return this.c}}e.$fJ=c;class m extends c{constructor(Q,V,ie,le,_,oe,re,ce){super(Q,ie,void 0,re,ce,V),this.command={},this._source=V,this.hasDefinedMatchers=oe,_&&(this.command=_)}clone(){return new m(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(Q=!1){if(Q&&this._source.customizes!==void 0)return this._source.customizes;{let V;switch(this.command?this.command.runtime:void 0){case r.Shell:V="shell";break;case r.Process:V="process";break;case r.CustomExecution:V="customExecution";break;case void 0:V="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:V,_key:this._id,id:this._id}}}static is(Q){return Q instanceof m}getMapKey(){const Q=this._source.config.workspaceFolder;return Q?`${Q.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$bJ:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const Q=this.d();if(!Q)return;let V=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(V+=this._source.kind);const ie={type:e.$eJ,folder:Q,id:V};return JSON.stringify(ie)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$gh(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(Q){return new m(Q._id,Q._source,Q._label,Q.type,Q.command,Q.hasDefinedMatchers,Q.runOptions,Q.configurationProperties)}}e.$gJ=m;class g extends c{constructor(Q,V,ie,le,_,oe,re){super(Q,ie,le,oe,re,V),this._source=V,this.configures=_}static is(Q){return Q instanceof g}f(Q){return Q}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$gh(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$bJ:this._source.config.workspaceFolder?.uri.toString()}getKey(){const Q=this.d();if(!Q)return;let V=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(V+=this._source.kind);const ie={type:e.$eJ,folder:Q,id:V};return JSON.stringify(ie)}}e.$hJ=g;class u extends c{constructor(Q,V,ie,le,_,oe,re,ce,x){super(Q,ie,le,ce,x,V),this.defines=_,this.hasDefinedMatchers=re,this.command=oe,this.icon=x.icon,this.hide=x.hide}clone(){return new u(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(Q){return Q instanceof u}getMapKey(){const Q=this._source.workspaceFolder;return Q?`${this._source.scope.toString()}|${Q.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===a.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const Q={type:"contributed",scope:this._source.scope,id:this._id};return Q.folder=this.d(),JSON.stringify(Q)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(Q){return new u(Q._id,Q._source,Q._label,Q.type,Q.defines,Q.command,Q.hasDefinedMatchers,Q.runOptions,Q.configurationProperties)}}e.$iJ=u;class S extends c{constructor(Q,V,ie,le,_,oe){super(Q,ie,le,_,oe,V),this._source=V}clone(){return new S(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(Q){return Q instanceof S}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(Q){return new S(Q._id,Q._source,Q._label,Q.type,Q.runOptions,Q.configurationProperties)}}e.$jJ=S;var k;(function(z){z[z.Process=1]="Process",z[z.Terminal=2]="Terminal"})(k||(e.ExecutionEngine=k={})),function(z){z._default=z.Terminal}(k||(e.ExecutionEngine=k={}));var y;(function(z){z[z.V0_1_0=1]="V0_1_0",z[z.V2_0_0=2]="V2_0_0"})(y||(e.JsonSchemaVersion=y={}));class C{constructor(Q){this.c=new Map;for(let V=0;V<Q.length;V++)this.c.set(Q[V].uri.toString(),V)}compare(Q,V){const ie=Q.getWorkspaceFolder(),le=V.getWorkspaceFolder();if(ie&&le){let _=this.c.get(ie.uri.toString());_=_===void 0?0:_+1;let oe=this.c.get(le.uri.toString());return oe=oe===void 0?0:oe+1,_===oe?Q._label.localeCompare(V._label):_-oe}else return!ie&&le?-1:ie&&!le?1:0}}e.$kJ=C;var T;(function(z){z.DependsOnStarted="dependsOnStarted",z.AcquiredInput="acquiredInput",z.Start="start",z.ProcessStarted="processStarted",z.Active="active",z.Inactive="inactive",z.Changed="changed",z.Terminated="terminated",z.ProcessEnded="processEnded",z.End="end"})(T||(e.TaskEventKind=T={}));var $;(function(z){z.SingleRun="singleRun",z.Background="background"})($||(e.TaskRunType=$={}));var w;(function(z){z[z.System=0]="System",z[z.User=1]="User",z[z.FolderOpen=2]="FolderOpen",z[z.ConfigurationChange=3]="ConfigurationChange",z[z.Reconnect=4]="Reconnect"})(w||(e.TaskRunSource=w={}));var M;(function(z){function Q(ce){return{taskId:ce._id,taskName:ce.configurationProperties.name,runType:ce.configurationProperties.isBackground?$.Background:$.SingleRun,group:ce.configurationProperties.group,__task:ce}}function V(ce,x,$e){return{...Q(ce),kind:T.Start,terminalId:x,resolvedVariables:$e}}z.start=V;function ie(ce,x,$e){return{...Q(ce),kind:T.ProcessStarted,terminalId:x,processId:$e}}z.processStarted=ie;function le(ce,x,$e){return{...Q(ce),kind:T.ProcessEnded,terminalId:x,exitCode:$e}}z.processEnded=le;function _(ce,x,$e){return{...Q(ce),kind:T.Terminated,exitReason:$e,terminalId:x}}z.terminated=_;function oe(ce,x,$e){return{...Q(x),kind:ce,terminalId:$e}}z.general=oe;function re(){return{kind:T.Changed}}z.changed=re})(M||(e.TaskEvent=M={}));var A;(function(z){function Q(ie){const le=Object.keys(ie).sort();let _="";for(const oe of le){let re=ie[oe];re instanceof Object?re=Q(re):typeof re=="string"&&(re=re.replace(/,/g,",,")),_+=oe+","+re+","}return _}function V(ie){const _={_key:Q(ie),type:ie.taskType};return Object.assign(_,ie),_}z.create=V})(A||(e.KeyedTaskIdentifier=A={}));var L;(function(z){z.AutoDetect="task.autoDetect",z.SaveBeforeRun="task.saveBeforeRun",z.ShowDecorations="task.showDecorations",z.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",z.SlowProviderWarning="task.slowProviderWarning",z.QuickOpenHistory="task.quickOpen.history",z.QuickOpenDetail="task.quickOpen.detail",z.QuickOpenSkip="task.quickOpen.skip",z.QuickOpenShowAll="task.quickOpen.showAll",z.AllowAutomaticTasks="task.allowAutomaticTasks",z.Reconnection="task.reconnection",z.VerboseLogging="task.verboseLogging"})(L||(e.TaskSettingId=L={}));var J;(function(z){z.Tasks="tasks",z.SuppressTaskName="tasks.suppressTaskName",z.Windows="tasks.windows",z.Osx="tasks.osx",z.Linux="tasks.linux",z.ShowOutput="tasks.showOutput",z.IsShellCommand="tasks.isShellCommand",z.ServiceTestSetting="tasks.service.testSetting"})(J||(e.TasksSchemaProperties=J={}));var Y;(function(z){function Q(V,ie){const le=O.$aJ.get(V.type);if(le===void 0){const ce=N.$io(V);return delete ce._key,A.create(ce)}const _=Object.create(null);_.type=le.taskType;const oe=new Set;le.required.forEach(ce=>oe.add(ce));const re=le.properties;for(const ce of Object.keys(re)){const x=V[ce];if(x!=null)_[ce]=x;else if(oe.has(ce)){const $e=re[ce];if($e.default!==void 0)_[ce]=N.$io($e.default);else switch($e.type){case"boolean":_[ce]=!1;break;case"number":case"integer":_[ce]=0;break;case"string":_[ce]="";break;default:ie.error(v.localize(9895,null,JSON.stringify(V,void 0,0),ce));return}}}return A.create(_)}z.createTaskIdentifier=Q})(Y||(e.TaskDefinition=Y={}))}),define(Re[209],Te([1,0,12]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tec=e.$Sec=void 0;class D{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,O)=>{this.b=R,this.d=O,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,v.$2)(R))}then(R,O){return this.j().then(R,O)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$Sec=D;class P extends D{constructor(){super(),this.h=!0,this.i=new v.$7}}e.$Tec=P}),define(Re[39],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5w=e.$2w=void 0,e.$3w=P,e.$4w=N;class v{static{this.count=0}constructor(p){this._proxyIdentifierBrand=void 0,this.sid=p,this.nid=++v.count}}e.$2w=v;const D=[];function P(O){const p=new v(O);return D[p.nid]=p,p}function N(O){return D[O].sid}class R{constructor(p){this.value=p}}e.$5w=R}),define(Re[5],Te([1,0,39]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4N=e.$3N=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$2N=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var D;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(D||(e.TextEditorRevealType=D={}));var P;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput",r[r.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(P||(e.TabInputKind=P={}));var N;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(N||(e.TabModelOperationKind=N={}));var R;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var O;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})(O||(e.WebviewMessageArrayBufferViewType=O={}));var p;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})(p||(e.CellOutputKind=p={}));var s;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(s||(e.NotebookEditorRevealType=s={}));var I;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output",r[r.Hybrid=3]="Hybrid"})(I||(e.CandidatePortSource=I={}));class b{static{this.a=0}static mixin(l){return l._id=b.a++,l}}e.$2N=b;var h;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(h||(e.ISuggestDataDtoField=h={}));var E;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(E||(e.ISuggestResultDtoField=E={}));var f;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(f||(e.ExtHostTestingResource=f={})),e.$3N={MainThreadAuthentication:(0,v.$3w)("MainThreadAuthentication"),MainThreadBulkEdits:(0,v.$3w)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,v.$3w)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,v.$3w)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,v.$3w)("MainThreadChatAgents2"),MainThreadChatVariables:(0,v.$3w)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,v.$3w)("MainThreadChatSkills"),MainThreadClipboard:(0,v.$3w)("MainThreadClipboard"),MainThreadCommands:(0,v.$3w)("MainThreadCommands"),MainThreadComments:(0,v.$3w)("MainThreadComments"),MainThreadConfiguration:(0,v.$3w)("MainThreadConfiguration"),MainThreadConsole:(0,v.$3w)("MainThreadConsole"),MainThreadDebugService:(0,v.$3w)("MainThreadDebugService"),MainThreadDecorations:(0,v.$3w)("MainThreadDecorations"),MainThreadDiagnostics:(0,v.$3w)("MainThreadDiagnostics"),MainThreadDialogs:(0,v.$3w)("MainThreadDiaglogs"),MainThreadDocuments:(0,v.$3w)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,v.$3w)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,v.$3w)("MainThreadTextEditors"),MainThreadEditorInsets:(0,v.$3w)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,v.$3w)("MainThreadEditorTabs"),MainThreadErrors:(0,v.$3w)("MainThreadErrors"),MainThreadTreeViews:(0,v.$3w)("MainThreadTreeViews"),MainThreadDownloadService:(0,v.$3w)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,v.$3w)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,v.$3w)("MainThreadLanguages"),MainThreadLogger:(0,v.$3w)("MainThreadLogger"),MainThreadMessageService:(0,v.$3w)("MainThreadMessageService"),MainThreadOutputService:(0,v.$3w)("MainThreadOutputService"),MainThreadProgress:(0,v.$3w)("MainThreadProgress"),MainThreadQuickDiff:(0,v.$3w)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,v.$3w)("MainThreadQuickOpen"),MainThreadStatusBar:(0,v.$3w)("MainThreadStatusBar"),MainThreadSecretState:(0,v.$3w)("MainThreadSecretState"),MainThreadStorage:(0,v.$3w)("MainThreadStorage"),MainThreadSpeech:(0,v.$3w)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,v.$3w)("MainThreadTelemetry"),MainThreadTerminalService:(0,v.$3w)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,v.$3w)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,v.$3w)("MainThreadWebviews"),MainThreadWebviewPanels:(0,v.$3w)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,v.$3w)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,v.$3w)("MainThreadCustomEditors"),MainThreadUrls:(0,v.$3w)("MainThreadUrls"),MainThreadUriOpeners:(0,v.$3w)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,v.$3w)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,v.$3w)("MainThreadWorkspace"),MainThreadFileSystem:(0,v.$3w)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,v.$3w)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,v.$3w)("MainThreadExtensionService"),MainThreadSCM:(0,v.$3w)("MainThreadSCM"),MainThreadSearch:(0,v.$3w)("MainThreadSearch"),MainThreadShare:(0,v.$3w)("MainThreadShare"),MainThreadTask:(0,v.$3w)("MainThreadTask"),MainThreadWindow:(0,v.$3w)("MainThreadWindow"),MainThreadLabelService:(0,v.$3w)("MainThreadLabelService"),MainThreadNotebook:(0,v.$3w)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,v.$3w)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,v.$3w)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,v.$3w)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,v.$3w)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,v.$3w)("MainThreadInteractive"),MainThreadTheming:(0,v.$3w)("MainThreadTheming"),MainThreadTunnelService:(0,v.$3w)("MainThreadTunnelService"),MainThreadManagedSockets:(0,v.$3w)("MainThreadManagedSockets"),MainThreadTimeline:(0,v.$3w)("MainThreadTimeline"),MainThreadTesting:(0,v.$3w)("MainThreadTesting"),MainThreadLocalization:(0,v.$3w)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,v.$3w)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,v.$3w)("MainThreadAiEmbeddingVector")},e.$4N={ExtHostCommands:(0,v.$3w)("ExtHostCommands"),ExtHostConfiguration:(0,v.$3w)("ExtHostConfiguration"),ExtHostDiagnostics:(0,v.$3w)("ExtHostDiagnostics"),ExtHostDebugService:(0,v.$3w)("ExtHostDebugService"),ExtHostDecorations:(0,v.$3w)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,v.$3w)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,v.$3w)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,v.$3w)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,v.$3w)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,v.$3w)("ExtHostEditors"),ExtHostTreeViews:(0,v.$3w)("ExtHostTreeViews"),ExtHostFileSystem:(0,v.$3w)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,v.$3w)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,v.$3w)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,v.$3w)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,v.$3w)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,v.$3w)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,v.$3w)("ExtHostQuickDiff"),ExtHostStatusBar:(0,v.$3w)("ExtHostStatusBar"),ExtHostShare:(0,v.$3w)("ExtHostShare"),ExtHostExtensionService:(0,v.$3w)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,v.$3w)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,v.$3w)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,v.$3w)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,v.$3w)("ExtHostSCM"),ExtHostSearch:(0,v.$3w)("ExtHostSearch"),ExtHostTask:(0,v.$3w)("ExtHostTask"),ExtHostWorkspace:(0,v.$3w)("ExtHostWorkspace"),ExtHostWindow:(0,v.$3w)("ExtHostWindow"),ExtHostWebviews:(0,v.$3w)("ExtHostWebviews"),ExtHostWebviewPanels:(0,v.$3w)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,v.$3w)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,v.$3w)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,v.$3w)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,v.$3w)("ExtHostEditorTabs"),ExtHostProgress:(0,v.$3w)("ExtHostProgress"),ExtHostComments:(0,v.$3w)("ExtHostComments"),ExtHostSecretState:(0,v.$3w)("ExtHostSecretState"),ExtHostStorage:(0,v.$3w)("ExtHostStorage"),ExtHostUrls:(0,v.$3w)("ExtHostUrls"),ExtHostUriOpeners:(0,v.$3w)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,v.$3w)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,v.$3w)("ExtHostOutputService"),ExtHostLabelService:(0,v.$3w)("ExtHostLabelService"),ExtHostNotebook:(0,v.$3w)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,v.$3w)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,v.$3w)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,v.$3w)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,v.$3w)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,v.$3w)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,v.$3w)("ExtHostInteractive"),ExtHostChatAgents2:(0,v.$3w)("ExtHostChatAgents"),ExtHostChatVariables:(0,v.$3w)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,v.$3w)("ExtHostChatSkills"),ExtHostChatProvider:(0,v.$3w)("ExtHostChatProvider"),ExtHostSpeech:(0,v.$3w)("ExtHostSpeech"),ExtHostEmbeddings:(0,v.$3w)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,v.$3w)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,v.$3w)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,v.$3w)("ExtHostTheming"),ExtHostTunnelService:(0,v.$3w)("ExtHostTunnelService"),ExtHostManagedSockets:(0,v.$3w)("ExtHostManagedSockets"),ExtHostAuthentication:(0,v.$3w)("ExtHostAuthentication"),ExtHostTimeline:(0,v.$3w)("ExtHostTimeline"),ExtHostTesting:(0,v.$3w)("ExtHostTesting"),ExtHostTelemetry:(0,v.$3w)("ExtHostTelemetry"),ExtHostLocalization:(0,v.$3w)("ExtHostLocalization")}}),define(Re[85],Te([1,0,3,11,5,16]),function(we,e,v,D,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bqc=e.$Aqc=e.$zqc=void 0,P=qe(P),e.$zqc=(0,v.$Ii)("IExtHostApiDeprecationService");let R=class{constructor(p,s){this.c=s,this.a=new Set,this.b=p.getProxy(P.$3N.MainThreadTelemetry)}report(p,s,I){const b=this.d(p,s);this.a.has(b)||(this.a.add(b),s.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${p}' is deprecated. ${I}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:s.identifier.value,apiId:p}))}d(p,s){return`${p}-${s.identifier.value}`}};e.$Aqc=R,e.$Aqc=R=Ke([We(0,N.$DQ),We(1,D.$dk)],R),e.$Bqc=Object.freeze(new class{report(O,p,s){}})}),define(Re[210],Te([1,0,5]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oqc=void 0;class D{constructor(N){const R=N.getProxy(v.$3N.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(O){return R.$writeText(O)}})}}e.$Oqc=D}),define(Re[211],Te([1,0,25,5,26,16]),function(we,e,v,D,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Psc=void 0;let R=class{constructor(I,b){this.a=I.getProxy(D.$3N.MainThreadConsole),this.b=b.consoleForward.includeStack,this.c=b.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(I,b){const h=this,E=console[I];Object.defineProperty(console,I,{set:()=>{},get:()=>function(){h.e(I,b,E,arguments)}})}e(I,b,h,E){this.a.$logExtensionHostMessage({type:"__$console",severity:b,arguments:p(E,this.b)}),this.c&&this.f(I,h,E)}};e.$Psc=R,e.$Psc=R=Ke([We(0,N.$DQ),We(1,P.$TQ)],R);const O=1e5;function p(s,I){const b=[];if(s.length)for(let h=0;h<s.length;h++){let E=s[h];if(typeof E>"u")E="undefined";else if(E instanceof Error){const f=E;f.stack?E=f.stack:E=f.toString()}b.push(E)}if(I){const h=new Error().stack;h&&b.push({__$stack:h.split(`
`).slice(3).join(`
`)})}try{const h=(0,v.$no)(b);return h.length>O?"Output omitted for a large object that exceeds the limits":h}catch(h){return`Output omitted for an object that cannot be inspected ('${h.toString()}')`}}}),define(Re[212],Te([1,0,2,5,21]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qrc=void 0;class N{constructor(O){this.a=O.getProxy(D.$3N.MainThreadDialogs)}showOpenDialog(O,p){return p?.allowUIResources&&(0,P.$wH)(O,"showLocal"),this.a.$showOpenDialog(p).then(s=>s?s.map(I=>v.URI.revive(I)):void 0)}showSaveDialog(O){return this.a.$showSaveDialog(O).then(p=>p?v.URI.revive(p):void 0)}}e.$Qrc=N}),define(Re[213],Te([1,0,19,6,4,5]),function(we,e,v,D,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Trc=void 0;class R{constructor(p){this.b=new Map,this.c=new D.$oe,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=p.getProxy(N.$3N.MainThreadEmbeddings)}registerEmbeddingsProvider(p,s,I){if(this.d.has(s))throw new Error("An embeddings provider for this model is already registered");const b=this.e++;return this.a.$registerEmbeddingProvider(b,s),this.b.set(b,{id:s,provider:I}),(0,P.$Vc)(()=>{this.d.delete(s),this.a.$unregisterEmbeddingProvider(b),this.b.delete(b)})}async computeEmbeddings(p,s,I){I??=v.CancellationToken.None;let b=!1;typeof s=="string"&&(s=[s],b=!0);const h=await this.a.$computeEmbeddings(p,s,I);if(h.length!==s.length)throw new Error;if(b){if(h.length!==1)throw new Error;return h[0]}return h}async $provideEmbeddings(p,s,I){const b=this.b.get(p);if(!b)return[];const h=await b.provider.provideEmbeddings(s,I);return h||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels(p){this.d=new Set(p),this.c.fire()}}e.$Trc=R}),define(Re[214],Te([1,0,4,5]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dsc=void 0;class P{constructor(R){this.b=0,this.a=R.getProxy(D.$3N.MainThreadLabelService)}$registerResourceLabelFormatter(R){const O=this.b++;return this.a.$registerResourceLabelFormatter(O,R),(0,v.$Vc)(()=>{this.a.$unregisterResourceLabelFormatter(O)})}}e.$dsc=P}),define(Re[86],Te([1,0,23,13,2,3,11,5,26,16]),function(we,e,v,D,P,N,R,O,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$urc=e.$trc=void 0;let I=class{constructor(h,E,f){this.f=f,this.d=new Map,this.a=E.getProxy(O.$3N.MainThreadLocalization),this.b=h.environment.appLanguage,this.c=this.b===v.$h}getMessage(h,E){const{message:f,args:r,comment:l}=E;if(this.c)return(0,D.$hf)(f,r??{});let d=f;l&&l.length>0&&(d+=`/${Array.isArray(l)?l.join(""):l}`);const a=this.d.get(h)?.contents[d];return a||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${d}`),(0,D.$hf)(a??f,r??{})}getBundle(h){return this.d.get(h)?.contents}getBundleUri(h){return this.d.get(h)?.uri}async initializeLocalizedMessages(h){if(this.c||!h.l10n&&!h.isBuiltin||this.d.has(h.identifier.value))return;let E;const f=await this.g(h);if(!f){this.f.error(`No bundle location found for extension ${h.identifier.value}`);return}try{const r=await this.a.$fetchBundleContents(f),l=JSON.parse(r);E=h.isBuiltin?l.contents?.bundle:l}catch(r){this.f.error(`Failed to load translations for ${h.identifier.value} from ${f}: ${r.message}`);return}E&&this.d.set(h.identifier.value,{contents:E,uri:f})}async g(h){if(h.isBuiltin){const E=await this.a.$fetchBuiltInBundleUri(h.identifier.value,this.b);return P.URI.revive(E)}return h.l10n?P.URI.joinPath(h.extensionLocation,h.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$trc=I,e.$trc=I=Ke([We(0,p.$TQ),We(1,s.$DQ),We(2,R.$dk)],I),e.$urc=(0,N.$Ii)("IExtHostLocalizationService")}),define(Re[215],Te([1,0,11,5,26,16,2,33]),function(we,e,v,D,P,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Osc=void 0;let p=class extends v.$ok{constructor(b,h){super(h.logLevel,h.logsLocation,h.loggers.map(E=>(0,O.$fi)(E))),this.r=b.getProxy(D.$3N.MainThreadLogger)}$setLogLevel(b,h){h?this.setLogLevel(R.URI.revive(h),b):this.setLogLevel(b)}setVisibility(b,h){super.setVisibility(b,h),this.r.$setVisibility(b,h)}s(b,h,E){return new s(this.r,b,h,E)}};e.$Osc=p,e.$Osc=p=Ke([We(0,N.$DQ),We(1,P.$TQ)],p);class s extends v.$jk{constructor(b,h,E,f){super(f?.logLevel==="always"),this.r=b,this.s=h,this.m=!1,this.n=[],this.setLevel(E),this.r.$createLogger(h,f).then(()=>{this.u(this.n),this.m=!0})}g(b,h){const E=[[b,h]];this.m?this.u(E):this.n.push(...E)}u(b){this.r.$log(this.s,b)}flush(){this.r.$flush(this.s)}}}),define(Re[87],Te([1,0,5,3,4,16,20]),function(we,e,v,D,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wrc=e.$vrc=void 0,e.$vrc=(0,D.$Ii)("IExtHostManagedSockets");let O=class{constructor(b){this.b=0,this.c=null,this.d=new Map,this.a=b.getProxy(v.$3N.MainThreadManagedSockets)}setFactory(b,h){for(const E of this.d.values())E.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new p(b,h),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(b){if(!this.c||this.c.socketFactoryId!==b)throw new Error(`No socket factory with id ${b}`);const h=++this.b,E=await this.c.makeConnection(),f=new P.$Wc;return this.d.set(h,new s(h,E,f)),f.add((0,P.$Vc)(()=>this.d.delete(h))),f.add(E.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(h),f.dispose()})),f.add(E.onDidClose(r=>{this.a.$onDidManagedSocketClose(h,r?.stack??r?.message),f.dispose()})),f.add(E.onDidReceiveMessage(r=>this.a.$onDidManagedSocketHaveData(h,R.$Qe.wrap(r)))),h}$remoteSocketWrite(b,h){this.d.get(b)?.actual.send(h.buffer)}$remoteSocketEnd(b){const h=this.d.get(b);h&&(h.actual.end(),h.dispose())}async $remoteSocketDrain(b){await this.d.get(b)?.actual.drain?.()}};e.$wrc=O,e.$wrc=O=Ke([We(0,N.$DQ)],O);class p{constructor(b,h){this.socketFactoryId=b,this.makeConnection=h}}class s extends P.$Xc{constructor(b,h,E){super(),this.socketId=b,this.actual=h,this.B(E)}}}),define(Re[216],Te([1,0,5,11,21]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gsc=void 0;function N(O){return O&&O.title}let R=class{constructor(p,s){this.b=s,this.a=p.getProxy(v.$3N.MainThreadMessageService)}showMessage(p,s,I,b,h){const E={source:{identifier:p.identifier,label:p.displayName||p.name}};let f;typeof b=="string"||N(b)?f=[b,...h]:(E.modal=b?.modal,E.useCustom=b?.useCustom,E.detail=b?.detail,f=h),E.useCustom&&(0,P.$wH)(p,"resolvers");const r=[];let l=!1;for(let d=0;d<f.length;d++){const a=f[d];if(typeof a=="string")r.push({title:a,handle:d,isCloseAffordance:!1});else if(typeof a=="object"){const{title:i,isCloseAffordance:n}=a;r.push({title:i,isCloseAffordance:!!n,handle:d}),n&&(l?this.b.warn(`[${p.identifier}] Only one message item can have 'isCloseAffordance':`,a):l=!0)}else this.b.warn(`[${p.identifier}] Invalid message item:`,a)}return this.a.$showMessage(s,I,E,r).then(d=>{if(typeof d=="number")return f[d]})}};e.$gsc=R,e.$gsc=R=Ke([We(1,D.$dk)],R)}),define(Re[217],Te([1,0,4,14,2,21,5]),function(we,e,v,D,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$psc=void 0;class O{constructor(s){this.b=new Map,this.a=s.getProxy(R.$3N.MainThreadProfileContentHandlers)}registerProfileContentHandler(s,I,b){if((0,N.$wH)(s,"profileContentHandlers"),this.b.has(I))throw new Error(`Handler with id '${I}' already registered`);return this.b.set(I,b),this.a.$registerProfileContentHandler(I,b.name,b.description,s.identifier.value),(0,v.$Vc)(()=>{this.b.delete(I),this.a.$unregisterProfileContentHandler(I)})}async $saveProfile(s,I,b,h){const E=this.b.get(s);if(!E)throw new Error(`Unknown handler with id: ${s}`);return E.saveProfile(I,b,h)}async $readProfile(s,I,b){const h=this.b.get(s);if(!h)throw new Error(`Unknown handler with id: ${s}`);return h.readProfile((0,D.$hg)(I)?I:P.URI.revive(I),b)}}e.$psc=O}),define(Re[88],Te([1,0,5,6,3]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rrc=e.$qrc=void 0;class N{constructor(O){this.b=new D.$oe,this.onDidChangePassword=this.b.event,this.a=O.getProxy(v.$3N.MainThreadSecretState)}async $onDidChangePassword(O){this.b.fire(O)}get(O,p){return this.a.$getPassword(O,p)}store(O,p,s){return this.a.$setPassword(O,p,s)}delete(O,p){return this.a.$deletePassword(O,p)}}e.$qrc=N,e.$rrc=(0,P.$Ii)("IExtHostSecretState")}),define(Re[218],Te([1,0,19,4,5]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wsc=void 0;class N{static{this.a=1}constructor(O){this.c=new Map,this.d=new Map,this.f=new Map,this.b=O.getProxy(P.$3N.MainThreadSpeech)}async $createSpeechToTextSession(O,p,s){const I=this.c.get(O);if(!I)return;const b=new D.$Wc,h=new v.$ze;this.d.set(p,h);const E=await I.provideSpeechToTextSession(h.token,s?{language:s}:void 0);E&&(b.add(E.onDidChange(f=>{h.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(p,f)})),b.add(h.token.onCancellationRequested(()=>b.dispose())))}async $cancelSpeechToTextSession(O){this.d.get(O)?.dispose(!0),this.d.delete(O)}async $createTextToSpeechSession(O,p,s){const I=this.c.get(O);if(!I)return;const b=new D.$Wc,h=new v.$ze;this.d.set(p,h);const E=await I.provideTextToSpeechSession(h.token,s?{language:s}:void 0);E&&(this.f.set(p,E),b.add(E.onDidChange(f=>{h.token.isCancellationRequested||this.b.$emitTextToSpeechEvent(p,f)})),b.add(h.token.onCancellationRequested(()=>b.dispose())))}async $synthesizeSpeech(O,p){this.f.get(O)?.synthesize(p)}async $cancelTextToSpeechSession(O){this.d.get(O)?.dispose(!0),this.d.delete(O),this.f.delete(O)}async $createKeywordRecognitionSession(O,p){const s=this.c.get(O);if(!s)return;const I=new D.$Wc,b=new v.$ze;this.d.set(p,b);const h=await s.provideKeywordRecognitionSession(b.token);h&&(I.add(h.onDidChange(E=>{b.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(p,E)})),I.add(b.token.onCancellationRequested(()=>I.dispose())))}async $cancelKeywordRecognitionSession(O){this.d.get(O)?.dispose(!0),this.d.delete(O)}registerProvider(O,p,s){const I=N.a++;return this.c.set(I,s),this.b.$registerProvider(I,p,{extension:O,displayName:O.value}),(0,D.$Vc)(()=>{this.b.$unregisterProvider(I),this.c.delete(I)})}}e.$wsc=N}),define(Re[89],Te([1,0,5,6,3]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hrc=e.$grc=void 0;class N{constructor(O,p){this.c=p,this.b=new D.$oe,this.onDidChangeStorage=this.b.event,this.a=O.getProxy(v.$3N.MainThreadStorage)}registerExtensionStorageKeysToSync(O,p){this.a.$registerExtensionStorageKeysToSync(O,p)}async initializeExtensionStorage(O,p,s){const I=await this.a.$initializeExtensionStorage(O,p);let b;return I&&(b=this.d(O,p,I)),b||s}setValue(O,p,s){return this.a.$setValue(O,p,s)}$acceptValue(O,p,s){const I=this.d(O,p,s);I&&this.b.fire({shared:O,key:p,value:I})}d(O,p,s){try{return JSON.parse(s)}catch(I){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${p}, global: ${O}): ${I}`)}}}e.$grc=N,e.$hrc=(0,P.$Ii)("IExtHostStorage")}),define(Re[219],Te([1,0,4,15,2,5]),function(we,e,v,D,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Isc=void 0;class R{static{this.a=new Set([D.Schemas.http,D.Schemas.https])}constructor(p){this.c=new Map,this.b=p.getProxy(N.$3N.MainThreadUriOpeners)}registerExternalUriOpener(p,s,I,b){if(this.c.has(s))throw new Error(`Opener with id '${s}' already registered`);const h=b.schemes.find(E=>!R.a.has(E));if(h)throw new Error(`Scheme '${h}' is not supported. Only http and https are currently supported.`);return this.c.set(s,I),this.b.$registerUriOpener(s,b.schemes,p,b.label),(0,v.$Vc)(()=>{this.c.delete(s),this.b.$unregisterUriOpener(s)})}async $canOpenUri(p,s,I){const b=this.c.get(p);if(!b)throw new Error(`Unknown opener with id: ${p}`);const h=P.URI.revive(s);return b.canOpenExternalUri(h,I)}async $openUri(p,s,I){const b=this.c.get(p);if(!b)throw new Error(`Unknown opener id: '${p}'`);return b.openExternalUri(P.URI.revive(s.resolvedUri),{sourceUri:P.URI.revive(s.sourceUri)},I)}}e.$Isc=R}),define(Re[220],Te([1,0,5,2,4,12,18]),function(we,e,v,D,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jsc=void 0;class O{static{this.a=0}constructor(s){this.c=new R.$wn,this.d=new Map,this.b=s.getProxy(v.$3N.MainThreadUrls)}registerUriHandler(s,I){const b=s.identifier;if(this.c.has(b))throw new Error(`Protocol handler already registered for extension ${b}`);const h=O.a++;return this.c.add(b),this.d.set(h,I),this.b.$registerUriHandler(h,b,s.displayName||s.name),(0,P.$Vc)(()=>{this.c.delete(b),this.d.delete(h),this.b.$unregisterUriHandler(h)})}$handleExternalUri(s,I){const b=this.d.get(s);if(!b)return Promise.resolve(void 0);try{b.handleUri(D.URI.revive(I))}catch(h){(0,N.$2)(h)}return Promise.resolve(void 0)}async createAppUri(s){return D.URI.revive(await this.b.$createAppUri(s))}}e.$Jsc=O}),define(Re[221],Te([1,0,20,5]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qub=N,e.$rub=O,D=qe(D);class P{constructor(){this.buffers=[]}add(s){let I=this.buffers.indexOf(s);return I<0&&(I=this.buffers.length,this.buffers.push(s)),I}}function N(p,s){if(s.serializeBuffersForPostMessage){const I=new P,h=JSON.stringify(p,(f,r)=>{if(r instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:I.add(r)};if(ArrayBuffer.isView(r)){const l=R(r);if(l)return{$$vscode_array_buffer_reference$$:!0,index:I.add(r.buffer),view:{type:l,byteLength:r.byteLength,byteOffset:r.byteOffset}}}return r}),E=I.buffers.map(f=>{const r=new Uint8Array(f);return v.$Qe.wrap(r)});return{message:h,buffers:E}}else return{message:JSON.stringify(p),buffers:[]}}function R(p){switch(p.constructor.name){case"Int8Array":return D.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return D.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return D.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return D.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return D.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return D.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return D.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return D.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return D.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return D.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return D.WebviewMessageArrayBufferViewType.BigUint64Array}}function O(p,s){const I=s.map(E=>{const f=new ArrayBuffer(E.byteLength);return new Uint8Array(f).set(E.buffer),f}),b=s.length?(E,f)=>{if(f&&typeof f=="object"&&f.$$vscode_array_buffer_reference$$){const r=f,{index:l}=r,d=I[l];if(r.view)switch(r.view.type){case D.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(d,r.view.byteOffset,r.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(d,r.view.byteOffset,r.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(d,r.view.byteOffset,r.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(d,r.view.byteOffset,r.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(d,r.view.byteOffset,r.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(d,r.view.byteOffset,r.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(d,r.view.byteOffset,r.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(d,r.view.byteOffset,r.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(d,r.view.byteOffset,r.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(d,r.view.byteOffset,r.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(d,r.view.byteOffset,r.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return d}return f}:void 0;return{message:JSON.parse(p,b),arrayBuffers:I}}}),define(Re[67],Te([1,0,6,4,15,25,2,175,221,83,5]),function(we,e,v,D,P,N,R,O,p,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6qc=e.$4qc=void 0,e.$5qc=h,e.$7qc=r,e.$8qc=l,N=qe(N),I=qe(I);class b{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;constructor(n,t,o,c,m,g,u){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new v.$oe,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new v.$oe,this._onDidDispose=this.#h.event,this.#e=n,this.#t=t,this.#o=o,this.#n=c,this.#s=m,this.#r=g,this.#u=h(g),this.#d=E(g),this.#i=u}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(n){return this.#l=!0,(0,s.$_Db)(n,this.#n)}get cspSource(){const n=this.#r.extensionLocation;if(n.scheme===P.Schemas.https||n.scheme===P.Schemas.http){let t=n.toString();return t.endsWith("/")||(t+="/"),t+" "+s.$$Db}return s.$$Db}get html(){return this.a(),this.#a}set html(n){this.a(),this.#a!==n&&(this.#a=n,this.#d&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(n)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(n)))}get options(){return this.a(),this.#o}set options(n){this.a(),N.$mo(this.#o,n)||this.#t.$setOptions(this.#e,l(this.#r,this.#s,n)),this.#o=n}async postMessage(n){if(this.#c)return!1;const t=(0,p.$qub)(n,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,t.message,...t.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(n){if(!this.#d)return n;const t=this.#r.extensionLocation?.scheme===P.Schemas.vscodeRemote,o=this.#r.extensionLocation.scheme===P.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return n.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(c,m,g,u,S,k)=>{const y=R.URI.from({scheme:u||"file",path:decodeURIComponent(S)}),C=(0,s.$_Db)(y,{isRemote:t,authority:o}).toString();return`${m}${C}${k}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(c,m,g,u,S,k)=>{const y=R.URI.from({scheme:u||"file",path:decodeURIComponent(S)}),C=(0,s.$_Db)(y,{isRemote:t,authority:o}).toString();return`${m}${C}${k}`})}}e.$4qc=b;function h(i){try{const n=(0,O.$6p)((0,O.$5p)(i.engines.vscode));return!!n&&n.majorBase>=1&&n.minorBase>=57}catch{return!1}}function E(i){try{const n=(0,O.$6p)((0,O.$5p)(i.engines.vscode));return n?n.majorBase<1||n.majorBase===1&&n.minorBase<60:!1}catch{return!1}}class f extends D.$Xc{constructor(n,t,o,c,m){super(),this.c=t,this.f=o,this.g=c,this.h=m,this.b=new Map,this.a=n.getProxy(I.$3N.MainThreadWebviews)}dispose(){super.dispose();for(const n of this.b.values())n.dispose();this.b.clear()}$onMessage(n,t,o){const c=this.j(n);if(c){const{message:m}=(0,p.$rub)(t,o.value);c._onMessageEmitter.fire(m)}}$onMissingCsp(n,t){this.g.warn(`${t} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(n,t,o){const c=new b(n,this.a,d(t),this.c,this.f,o,this.h);this.b.set(n,c);const m=c._onDidDispose(()=>{m.dispose(),this.deleteWebview(n)});return c}deleteWebview(n){this.b.delete(n)}j(n){return this.b.get(n)}}e.$6qc=f;function r(i){return{id:i.identifier,location:i.extensionLocation}}function l(i,n,t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots||a(i,n)}}function d(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(n=>R.URI.from(n))}}function a(i,n){return[...(n?.getWorkspaceFolders()||[]).map(t=>t.uri),i.extensionLocation]}}),define(Re[123],Te([1,0,6,15,13,2,3,16,5]),function(we,e,v,D,P,N,R,O,p){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Msc=e.$Lsc=void 0;let I=class{static{s=this}static{this.a={focused:!0,active:!0}}getState(){const h=this.d;return{get focused(){return h.focused},get active(){return h.active}}}constructor(h){this.c=new v.$oe,this.onDidChangeWindowState=this.c.event,this.d=s.a,this.b=h.getProxy(p.$3N.MainThreadWindow),this.b.$getInitialState().then(({isFocused:E,isActive:f})=>{this.onDidChangeWindowProperty("focused",E),this.onDidChangeWindowProperty("active",f)})}$onDidChangeWindowFocus(h){this.onDidChangeWindowProperty("focused",h)}$onDidChangeWindowActive(h){this.onDidChangeWindowProperty("active",h)}onDidChangeWindowProperty(h,E){E!==this.d[h]&&(this.d={...this.d,[h]:E},this.c.fire(this.d))}openUri(h,E){let f;if(typeof h=="string"){f=h;try{h=N.URI.parse(h)}catch{return Promise.reject(`Invalid uri - '${h}'`)}}return(0,P.$ff)(h.scheme)?Promise.reject("Invalid scheme - cannot be empty"):h.scheme===D.Schemas.command?Promise.reject(`Invalid scheme '${h.scheme}'`):this.b.$openUri(h,f,E)}async asExternalUri(h,E){if((0,P.$ff)(h.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this.b.$asExternalUri(h,E);return N.URI.from(f)}};e.$Lsc=I,e.$Lsc=I=s=Ke([We(0,O.$DQ)],I),e.$Msc=(0,R.$Ii)("IExtHostWindow")}),define(Re[222],Te([1,0,211,26,16]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2uc=void 0;let N=class extends v.$Psc{constructor(O,p){super(O,p)}f(O,p,s){p.apply(console,s)}};e.$2uc=N,e.$2uc=N=Ke([We(0,P.$DQ),We(1,D.$TQ)],N)}),define(Re[223],Te([1,0,10,20,19,30,12,6,4,37,150,209,39]),function(we,e,v,D,P,N,R,O,p,s,I,b,h){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Wec=e.ResponsiveState=e.RequestInitiator=void 0,e.$Uec=a,e.$Vec=i,R=qe(R);function f(M,A){try{return JSON.stringify(M,A)}catch{return"null"}}const r="$$ref$$",l={[r]:-1};class d{constructor(A,L){this.jsonString=A,this.referencedBuffers=L}}function a(M,A=null,L=!1){const J=[];return{jsonString:(L?f:JSON.stringify)(M,(z,Q)=>{if(typeof Q>"u")return l;if(typeof Q=="object"){if(Q instanceof D.$Qe){const V=J.push(Q)-1;return{[r]:V}}if(A)return A(z,Q)}return Q}),referencedBuffers:J}}function i(M,A,L){return JSON.parse(M,(J,Y)=>{if(Y){const z=Y[r];if(typeof z=="number")return A[z];if(L&&Y.$mid===s.MarshalledId.Uri)return L.transformIncoming(Y)}return Y})}function n(M,A){return JSON.stringify(M,A)}function t(M){return M?(A,L)=>L&&L.$mid===s.MarshalledId.Uri?M.transformOutgoing(L):L:null}var o;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(o||(e.RequestInitiator=o={}));var c;(function(M){M[M.Responsive=0]="Responsive",M[M.Unresponsive=1]="Unresponsive"})(c||(e.ResponsiveState=c={}));const m=()=>{},g=Symbol.for("rpcProtocol"),u=Symbol.for("rpcProxy");class S extends p.$Xc{static{E=g}static{this.a=3*1e3}constructor(A,L=null,J=null){super(),this[E]=!0,this.b=this.B(new O.$oe),this.onDidChangeResponsiveState=this.b.event,this.c=A,this.f=L,this.g=J,this.h=t(this.g),this.j=!1,this.m=[],this.s=[];for(let Y=0,z=h.$2w.count;Y<z;Y++)this.m[Y]=null,this.s[Y]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=c.Responsive,this.z=0,this.C=0,this.D=this.B(new v.$Uh(()=>this.H(),1e3)),this.B(this.c.onMessage(Y=>this.L(Y)))}dispose(){this.j=!0,Object.keys(this.w).forEach(A=>{const L=this.w[A];delete this.w[A],L.resolveErr(R.$8())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(A){this.z===0&&(this.C=Date.now()+S.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(A){this.C=Date.now()+S.a,this.z--,this.z===0&&this.D.cancel(),this.I(c.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(c.Unresponsive):this.D.schedule())}I(A){this.y!==A&&(this.y=A,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(A){return this.g?(0,I.$Tn)(A,this.g):A}getProxy(A){const{nid:L,sid:J}=A;return this.s[L]||(this.s[L]=this.J(L,J)),this.s[L]}J(A,L){const J={get:(Y,z)=>(typeof z=="string"&&!Y[z]&&z.charCodeAt(0)===N.CharCode.DollarSign&&(Y[z]=(...Q)=>this.U(A,z,Q)),z===u?L:Y[z])};return new Proxy(Object.create(null),J)}set(A,L){return this.m[A.nid]=L,L}assertRegistered(A){for(let L=0,J=A.length;L<J;L++){const Y=A[L];if(!this.m[Y.nid])throw new Error(`Missing proxy instance ${Y.sid}`)}}L(A){if(this.j)return;const L=A.byteLength,J=y.read(A,0),Y=J.readUInt8(),z=J.readUInt32();switch(Y){case $.RequestJSONArgs:case $.RequestJSONArgsWithCancellation:{let{rpcId:Q,method:V,args:ie}=T.deserializeRequestJSONArgs(J);this.g&&(ie=(0,I.$Tn)(ie,this.g)),this.M(L,z,Q,V,ie,Y===$.RequestJSONArgsWithCancellation);break}case $.RequestMixedArgs:case $.RequestMixedArgsWithCancellation:{let{rpcId:Q,method:V,args:ie}=T.deserializeRequestMixedArgs(J);this.g&&(ie=(0,I.$Tn)(ie,this.g)),this.M(L,z,Q,V,ie,Y===$.RequestMixedArgsWithCancellation);break}case $.Acknowledged:{this.f?.logIncoming(L,z,o.LocalSide,"ack"),this.G(z);break}case $.Cancel:{this.N(L,z);break}case $.ReplyOKEmpty:{this.O(L,z,void 0);break}case $.ReplyOKJSON:{let Q=T.deserializeReplyOKJSON(J);this.g&&(Q=(0,I.$Tn)(Q,this.g)),this.O(L,z,Q);break}case $.ReplyOKJSONWithBuffers:{const Q=T.deserializeReplyOKJSONWithBuffers(J,this.g);this.O(L,z,Q);break}case $.ReplyOKVSBuffer:{const Q=T.deserializeReplyOKVSBuffer(J);this.O(L,z,Q);break}case $.ReplyErrError:{let Q=T.deserializeReplyErrError(J);this.g&&(Q=(0,I.$Tn)(Q,this.g)),this.P(L,z,Q);break}case $.ReplyErrEmpty:{this.P(L,z,void 0);break}default:console.error("received unexpected message"),console.error(A)}}M(A,L,J,Y,z,Q){this.f?.logIncoming(A,L,o.OtherSide,`receiveRequest ${(0,h.$4w)(J)}.${Y}(`,z);const V=String(L);let ie,le;if(Q){const oe=new P.$ze;z.push(oe.token),ie=this.Q(J,Y,z),le=()=>oe.cancel()}else ie=this.Q(J,Y,z),le=m;this.u[V]=le;const _=T.serializeAcknowledged(L);this.f?.logOutgoing(_.byteLength,L,o.OtherSide,"ack"),this.c.send(_),ie.then(oe=>{delete this.u[V];const re=T.serializeReplyOK(L,oe,this.h);this.f?.logOutgoing(re.byteLength,L,o.OtherSide,"reply:",oe),this.c.send(re)},oe=>{delete this.u[V];const re=T.serializeReplyErr(L,oe);this.f?.logOutgoing(re.byteLength,L,o.OtherSide,"replyErr:",oe),this.c.send(re)})}N(A,L){this.f?.logIncoming(A,L,o.OtherSide,"receiveCancel");const J=String(L);this.u[J]?.()}O(A,L,J){this.f?.logIncoming(A,L,o.LocalSide,"receiveReply:",J);const Y=String(L);if(!this.w.hasOwnProperty(Y))return;const z=this.w[Y];delete this.w[Y],z.resolveOk(J)}P(A,L,J){this.f?.logIncoming(A,L,o.LocalSide,"receiveReplyErr:",J);const Y=String(L);if(!this.w.hasOwnProperty(Y))return;const z=this.w[Y];delete this.w[Y];let Q;J&&(J.$isError?(Q=new Error,Q.name=J.name,Q.message=J.message,Q.stack=J.stack):Q=J),z.resolveErr(Q)}Q(A,L,J){try{return Promise.resolve(this.S(A,L,J))}catch(Y){return Promise.reject(Y)}}S(A,L,J){const Y=this.m[A];if(!Y)throw new Error("Unknown actor "+(0,h.$4w)(A));const z=Y[L];if(typeof z!="function")throw new Error("Unknown method "+L+" on actor "+(0,h.$4w)(A));return z.apply(Y,J)}U(A,L,J){if(this.j)return new b.$Tec;let Y=null;if(J.length>0&&P.CancellationToken.isCancellationToken(J[J.length-1])&&(Y=J.pop()),Y&&Y.isCancellationRequested)return Promise.reject(R.$8());const z=T.serializeRequestArguments(J,this.h),Q=++this.t,V=String(Q),ie=new b.$Sec,le=new p.$Wc;Y&&le.add(Y.onCancellationRequested(()=>{const oe=T.serializeCancel(Q);this.f?.logOutgoing(oe.byteLength,Q,o.LocalSide,"cancel"),this.c.send(T.serializeCancel(Q))})),this.w[V]=new k(ie,le),this.F(Q);const _=T.serializeRequest(Q,A,L,z,!!Y);return this.f?.logOutgoing(_.byteLength,Q,o.LocalSide,`request: ${(0,h.$4w)(A)}.${L}(`,J),this.c.send(_),ie}}e.$Wec=S;class k{constructor(A,L){this.a=A,this.b=L}resolveOk(A){this.a.resolveOk(A),this.b.dispose()}resolveErr(A){this.a.resolveErr(A),this.b.dispose()}}class y{static alloc(A,L,J){const Y=new y(D.$Qe.alloc(J+1+4),0);return Y.writeUInt8(A),Y.writeUInt32(L),Y}static read(A,L){return new y(A,L)}get buffer(){return this.a}constructor(A,L){this.a=A,this.b=L}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(A){this.a.writeUInt8(A,this.b),this.b+=1}readUInt8(){const A=this.a.readUInt8(this.b);return this.b+=1,A}writeUInt32(A){this.a.writeUInt32BE(A,this.b),this.b+=4}readUInt32(){const A=this.a.readUInt32BE(this.b);return this.b+=4,A}static sizeShortString(A){return 1+A.byteLength}writeShortString(A){this.a.writeUInt8(A.byteLength,this.b),this.b+=1,this.a.set(A,this.b),this.b+=A.byteLength}readShortString(){const A=this.a.readUInt8(this.b);this.b+=1;const J=this.a.slice(this.b,this.b+A).toString();return this.b+=A,J}static sizeLongString(A){return 4+A.byteLength}writeLongString(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}readLongString(){const A=this.a.readUInt32BE(this.b);this.b+=4;const J=this.a.slice(this.b,this.b+A).toString();return this.b+=A,J}writeBuffer(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}static sizeVSBuffer(A){return 4+A.byteLength}writeVSBuffer(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}readVSBuffer(){const A=this.a.readUInt32BE(this.b);this.b+=4;const L=this.a.slice(this.b,this.b+A);return this.b+=A,L}static sizeMixedArray(A){let L=0;L+=1;for(let J=0,Y=A.length;J<Y;J++){const z=A[J];switch(L+=1,z.type){case w.String:L+=this.sizeLongString(z.value);break;case w.VSBuffer:L+=this.sizeVSBuffer(z.value);break;case w.SerializedObjectWithBuffers:L+=this.sizeUInt32,L+=this.sizeLongString(z.value);for(let Q=0;Q<z.buffers.length;++Q)L+=this.sizeVSBuffer(z.buffers[Q]);break;case w.Undefined:break}}return L}writeMixedArray(A){this.a.writeUInt8(A.length,this.b),this.b+=1;for(let L=0,J=A.length;L<J;L++){const Y=A[L];switch(Y.type){case w.String:this.writeUInt8(w.String),this.writeLongString(Y.value);break;case w.VSBuffer:this.writeUInt8(w.VSBuffer),this.writeVSBuffer(Y.value);break;case w.SerializedObjectWithBuffers:this.writeUInt8(w.SerializedObjectWithBuffers),this.writeUInt32(Y.buffers.length),this.writeLongString(Y.value);for(let z=0;z<Y.buffers.length;++z)this.writeBuffer(Y.buffers[z]);break;case w.Undefined:this.writeUInt8(w.Undefined);break}}}readMixedArray(){const A=this.a.readUInt8(this.b);this.b+=1;const L=new Array(A);for(let J=0;J<A;J++)switch(this.readUInt8()){case w.String:L[J]=this.readLongString();break;case w.VSBuffer:L[J]=this.readVSBuffer();break;case w.SerializedObjectWithBuffers:{const z=this.readUInt32(),Q=this.readLongString(),V=[];for(let ie=0;ie<z;++ie)V.push(this.readVSBuffer());L[J]=new h.$5w(i(Q,V,null));break}case w.Undefined:L[J]=void 0;break}return L}}var C;(function(M){M[M.Simple=0]="Simple",M[M.Mixed=1]="Mixed"})(C||(C={}));class T{static a(A){for(let L=0,J=A.length;L<J;L++)if(A[L]instanceof D.$Qe||A[L]instanceof h.$5w||typeof A[L]>"u")return!0;return!1}static serializeRequestArguments(A,L){if(this.a(A)){const J=[];for(let Y=0,z=A.length;Y<z;Y++){const Q=A[Y];if(Q instanceof D.$Qe)J[Y]={type:w.VSBuffer,value:Q};else if(typeof Q>"u")J[Y]={type:w.Undefined};else if(Q instanceof h.$5w){const{jsonString:V,referencedBuffers:ie}=a(Q.value,L);J[Y]={type:w.SerializedObjectWithBuffers,value:D.$Qe.fromString(V),buffers:ie}}else J[Y]={type:w.String,value:D.$Qe.fromString(n(Q,L))}}return{type:C.Mixed,args:J}}return{type:C.Simple,args:n(A,L)}}static serializeRequest(A,L,J,Y,z){switch(Y.type){case C.Simple:return this.b(A,L,J,Y.args,z);case C.Mixed:return this.c(A,L,J,Y.args,z)}}static b(A,L,J,Y,z){const Q=D.$Qe.fromString(J),V=D.$Qe.fromString(Y);let ie=0;ie+=y.sizeUInt8(),ie+=y.sizeShortString(Q),ie+=y.sizeLongString(V);const le=y.alloc(z?$.RequestJSONArgsWithCancellation:$.RequestJSONArgs,A,ie);return le.writeUInt8(L),le.writeShortString(Q),le.writeLongString(V),le.buffer}static deserializeRequestJSONArgs(A){const L=A.readUInt8(),J=A.readShortString(),Y=A.readLongString();return{rpcId:L,method:J,args:JSON.parse(Y)}}static c(A,L,J,Y,z){const Q=D.$Qe.fromString(J);let V=0;V+=y.sizeUInt8(),V+=y.sizeShortString(Q),V+=y.sizeMixedArray(Y);const ie=y.alloc(z?$.RequestMixedArgsWithCancellation:$.RequestMixedArgs,A,V);return ie.writeUInt8(L),ie.writeShortString(Q),ie.writeMixedArray(Y),ie.buffer}static deserializeRequestMixedArgs(A){const L=A.readUInt8(),J=A.readShortString(),Y=A.readMixedArray(),z=new Array(Y.length);for(let Q=0,V=Y.length;Q<V;Q++){const ie=Y[Q];typeof ie=="string"?z[Q]=JSON.parse(ie):z[Q]=ie}return{rpcId:L,method:J,args:z}}static serializeAcknowledged(A){return y.alloc($.Acknowledged,A,0).buffer}static serializeCancel(A){return y.alloc($.Cancel,A,0).buffer}static serializeReplyOK(A,L,J){if(typeof L>"u")return this.d(A);if(L instanceof D.$Qe)return this.e(A,L);if(L instanceof h.$5w){const{jsonString:Y,referencedBuffers:z}=a(L.value,J,!0);return this.g(A,Y,z)}else return this.f(A,f(L,J))}static d(A){return y.alloc($.ReplyOKEmpty,A,0).buffer}static e(A,L){let J=0;J+=y.sizeVSBuffer(L);const Y=y.alloc($.ReplyOKVSBuffer,A,J);return Y.writeVSBuffer(L),Y.buffer}static deserializeReplyOKVSBuffer(A){return A.readVSBuffer()}static f(A,L){const J=D.$Qe.fromString(L);let Y=0;Y+=y.sizeLongString(J);const z=y.alloc($.ReplyOKJSON,A,Y);return z.writeLongString(J),z.buffer}static g(A,L,J){const Y=D.$Qe.fromString(L);let z=0;z+=y.sizeUInt32,z+=y.sizeLongString(Y);for(const V of J)z+=y.sizeVSBuffer(V);const Q=y.alloc($.ReplyOKJSONWithBuffers,A,z);Q.writeUInt32(J.length),Q.writeLongString(Y);for(const V of J)Q.writeBuffer(V);return Q.buffer}static deserializeReplyOKJSON(A){const L=A.readLongString();return JSON.parse(L)}static deserializeReplyOKJSONWithBuffers(A,L){const J=A.readUInt32(),Y=A.readLongString(),z=[];for(let Q=0;Q<J;++Q)z.push(A.readVSBuffer());return new h.$5w(i(Y,z,L))}static serializeReplyErr(A,L){const J=L?f(R.$4(L),null):void 0;if(typeof J!="string")return this.h(A);const Y=D.$Qe.fromString(J);let z=0;z+=y.sizeLongString(Y);const Q=y.alloc($.ReplyErrError,A,z);return Q.writeLongString(Y),Q.buffer}static deserializeReplyErrError(A){const L=A.readLongString();return JSON.parse(L)}static h(A){return y.alloc($.ReplyErrEmpty,A,0).buffer}}var $;(function(M){M[M.RequestJSONArgs=1]="RequestJSONArgs",M[M.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",M[M.RequestMixedArgs=3]="RequestMixedArgs",M[M.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",M[M.Acknowledged=5]="Acknowledged",M[M.Cancel=6]="Cancel",M[M.ReplyOKEmpty=7]="ReplyOKEmpty",M[M.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",M[M.ReplyOKJSON=9]="ReplyOKJSON",M[M.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",M[M.ReplyErrError=11]="ReplyErrError",M[M.ReplyErrEmpty=12]="ReplyErrEmpty"})($||($={}));var w;(function(M){M[M.String=1]="String",M[M.VSBuffer=2]="VSBuffer",M[M.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",M[M.Undefined=4]="Undefined"})(w||(w={}))}),define(Re[224],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4uc=void 0;const v=function(N){const R=O=>{globalThis.removeEventListener("message",R);const p=O.data;Object.defineProperties(globalThis,{postMessage:{value(s,I){p.postMessage(s,I)}},onmessage:{get(){return p.onmessage},set(s){p.onmessage=s}}}),p.addEventListener("message",s=>{globalThis.dispatchEvent(new MessageEvent("message",{data:s.data,ports:s.ports?[...s.ports]:void 0}))}),p.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(N)};globalThis.addEventListener("message",R)}.toString();class D extends EventTarget{constructor(N,R,O){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const p=`((${v})('${R}'))`,s=new Blob([p],{type:"application/javascript"}),I=URL.createObjectURL(s),b=new MessageChannel,h=I,E={type:"_newWorker",id:h,port:b.port2,url:I,options:O};N(E,[b.port2]),this.postMessage=b.port1.postMessage.bind(b.port1),this.terminate=()=>{N({type:"_terminateWorker",id:h}),URL.revokeObjectURL(I),b.port1.close(),b.port2.close()},Object.defineProperties(this,{onmessage:{get(){return b.port1.onmessage},set(f){b.port1.onmessage=f}},onmessageerror:{get(){return b.port1.onmessageerror},set(f){b.port1.onmessageerror=f}}}),b.port1.addEventListener("messageerror",f=>{const r=new MessageEvent("messageerror",{data:f.data});this.dispatchEvent(r)}),b.port1.addEventListener("message",f=>{const r=new MessageEvent("message",{data:f.data});this.dispatchEvent(r)}),b.port1.start()}}e.$4uc=D}),define(Re[225],Te([1,0,20,27,15,60,3]),function(we,e,v,D,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ML=e.$JL=void 0,e.$KL=I,e.$LL=b,e.$JL=(0,R.$Ii)("notebookDocumentService");const O=["W","X","Y","Z","a","b","c","d","e","f"],p=new RegExp(`^[${O.join("")}]+`),s=7;function I(E){if(E.scheme!==P.Schemas.vscodeNotebookCell)return;const f=E.fragment.indexOf("s");if(f<0)return;const r=parseInt(E.fragment.substring(0,f).replace(p,""),s),l=(0,v.$0e)(E.fragment.substring(f+1)).toString();if(!isNaN(r))return{handle:r,notebook:E.with({scheme:l,fragment:null})}}function b(E,f){const r=f.toString(s),d=`${r.length<O.length?O[r.length-1]:"z"}${r}s${(0,v.$$e)(v.$Qe.fromString(E.scheme),!0,!0)}`;return E.with({scheme:P.Schemas.vscodeNotebookCell,fragment:d})}class h{constructor(){this.a=new D.$Dc}getNotebook(f){if(f.scheme===P.Schemas.vscodeNotebookCell){const r=I(f);if(r){const l=this.a.get(r.notebook);if(l)return l}}return this.a.get(f)}addNotebookDocument(f){this.a.set(f.uri,f)}removeNotebookDocument(f){this.a.delete(f.uri)}}e.$ML=h,(0,N.$Xs)(e.$JL,h,N.InstantiationType.Delayed)}),define(Re[90],Te([1,0,20,41,40,72,15,22,23,31,225]),function(we,e,v,D,P,N,R,O,p,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8L=e.$5L=e.CellStatusbarAlignment=e.$4L=e.NotebookFindScopeType=e.NotebookEditorPriority=e.$1L=e.$ZL=e.$XL=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$WL=e.$VL=e.$UL=e.$TL=e.CellKind=e.$SL=e.$RL=e.$QL=e.$PL=e.$OL=e.$NL=void 0,e.$YL=c,e.$2L=u,e.$3L=S,e.$6L=C,e.$7L=$,D=qe(D),e.$NL="workbench.editor.notebook",e.$OL="workbench.editor.notebookTextDiffEditor",e.$PL="workbench.editor.notebookMultiTextDiffEditor",e.$QL="workbench.editor.interactive",e.$RL="workbench.editor.repl",e.$SL="replNotebook.input.execute";var b;(function(V){V[V.Markup=1]="Markup",V[V.Code=2]="Code"})(b||(e.CellKind=b={})),e.$TL=["application/json","application/javascript","text/html","image/svg+xml",N.$et.latex,N.$et.markdown,"image/png","image/jpeg",N.$et.text],e.$UL=[N.$et.latex,N.$et.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",N.$et.text],e.$VL=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$WL="_notAvailable";var h;(function(V){V[V.Running=1]="Running",V[V.Idle=2]="Idle"})(h||(e.NotebookRunState=h={}));var E;(function(V){V[V.Unconfirmed=1]="Unconfirmed",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(E||(e.NotebookCellExecutionState=E={}));var f;(function(V){V[V.Unconfirmed=1]="Unconfirmed",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(f||(e.NotebookExecutionState=f={}));var r;(function(V){V[V.WithHardKernelDependency=0]="WithHardKernelDependency",V[V.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",V[V.Pure=2]="Pure",V[V.Never=3]="Never"})(r||(e.NotebookRendererMatch=r={}));var l;(function(V){V.Always="always",V.Never="never",V.Optional="optional"})(l||(e.RendererMessagingSpec=l={}));var d;(function(V){V[V.ModelChange=1]="ModelChange",V[V.Move=2]="Move",V[V.ChangeCellLanguage=5]="ChangeCellLanguage",V[V.Initialize=6]="Initialize",V[V.ChangeCellMetadata=7]="ChangeCellMetadata",V[V.Output=8]="Output",V[V.OutputItem=9]="OutputItem",V[V.ChangeCellContent=10]="ChangeCellContent",V[V.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",V[V.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",V[V.ChangeCellMime=13]="ChangeCellMime",V[V.Unknown=100]="Unknown"})(d||(e.NotebookCellsChangeType=d={}));var a;(function(V){V[V.Handle=0]="Handle",V[V.Index=1]="Index"})(a||(e.SelectionStateType=a={}));var i;(function(V){V[V.Replace=1]="Replace",V[V.Output=2]="Output",V[V.Metadata=3]="Metadata",V[V.CellLanguage=4]="CellLanguage",V[V.DocumentMetadata=5]="DocumentMetadata",V[V.Move=6]="Move",V[V.OutputItems=7]="OutputItems",V[V.PartialMetadata=8]="PartialMetadata",V[V.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var n;(function(V){V.scheme=R.Schemas.vscodeNotebookCell;function ie(x,$e){return(0,I.$LL)(x,$e)}V.generate=ie;function le(x){return(0,I.$KL)(x)}V.parse=le;function _(x,$e){return x.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${$e??""},${x.scheme!==R.Schemas.file?x.scheme:""}`})}V.generateCellOutputUri=_;function oe(x){if(x.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const $e=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(x.fragment);if(!$e)return;const Pe=$e[1]&&$e[1]!==""?$e[1]:void 0,X=$e[2];return{outputId:Pe,notebook:x.with({scheme:X||R.Schemas.file,fragment:null})}}V.parseCellOutputUri=oe;function re(x,$e,Pe){return V.generate(x,$e).with({scheme:Pe})}V.generateCellPropertyUri=re;function ce(x,$e){if(x.scheme===$e)return V.parse(x.with({scheme:V.scheme}))}V.parseCellPropertyUri=ce})(n||(e.CellUri=n={}));const t=V=>p.$j?V.replace(/\//g,"\\"):V;class o{constructor(ie=[],le=e.$TL){this.e=le,this.d=[...new Set(ie)].map(_=>({pattern:_,matches:D.$Dk(t(_))}))}sort(ie){const le=new Map(P.Iterable.map(ie,oe=>[oe,t(oe)]));let _=[];for(const{matches:oe}of this.d)for(const[re,ce]of le)if(oe(ce)){_.push(re),le.delete(re);break}return le.size&&(_=_.concat([...le.keys()].sort((oe,re)=>this.e.indexOf(oe)-this.e.indexOf(re)))),_}prioritize(ie,le){const _=this.f(ie);if(_===-1){this.d.unshift({pattern:ie,matches:D.$Dk(t(ie))});return}const oe=new Set(le.map(ce=>this.f(ce,_)));oe.delete(-1);const re=Array.from(oe).sort();this.d.splice(_+1,0,...re.map(ce=>this.d[ce]));for(let ce=re.length-1;ce>=0;ce--)this.d.splice(re[ce],1)}toArray(){return this.d.map(ie=>ie.pattern)}f(ie,le=this.d.length){const _=t(ie);for(let oe=0;oe<le;oe++)if(this.d[oe].matches(_))return oe;return-1}}e.$XL=o;function c(V,ie,le,_=(oe,re)=>oe===re){const oe=[];function re($e,Pe,X){if(Pe===0&&X.length===0)return;const q=oe[oe.length-1];q&&q.start+q.deleteCount===$e?(q.deleteCount+=Pe,q.toInsert.push(...X)):oe.push({start:$e,deleteCount:Pe,toInsert:X})}let ce=0,x=0;for(;;){if(ce===V.length){re(ce,0,ie.slice(x));break}if(x===ie.length){re(ce,V.length-ce,[]);break}const $e=V[ce],Pe=ie[x];if(_($e,Pe)){ce+=1,x+=1;continue}le(Pe)?(re(ce,1,[]),ce+=1):(re(ce,0,[Pe]),x+=1)}return oe}e.$ZL=new s.$Zj("notebookEditorCursorAtBoundary","none"),e.$1L=new s.$Zj("notebookEditorCursorAtLineBoundary","none");var m;(function(V){V.default="default",V.option="option"})(m||(e.NotebookEditorPriority=m={}));var g;(function(V){V.Cells="cells",V.Text="text",V.None="none"})(g||(e.NotebookFindScopeType=g={}));function u(V){const ie=V;return!!((typeof ie.include=="string"||D.$Ek(ie.include))&&(typeof ie.exclude=="string"||D.$Ek(ie.exclude)))}function S(V,ie,le){if(Array.isArray(V.viewType)&&V.viewType.indexOf(ie)>=0||V.viewType===ie)return!0;if(V.filenamePattern){const _=u(V.filenamePattern)?V.filenamePattern.include:V.filenamePattern,oe=u(V.filenamePattern)?V.filenamePattern.exclude:void 0;if(D.$Ck(_,(0,O.$qc)(le.fsPath).toLowerCase()))return!(oe&&D.$Ck(oe,(0,O.$qc)(le.fsPath).toLowerCase()))}return!1}e.$4L={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var k;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(k||(e.CellStatusbarAlignment=k={}));class y{static{this.d="notebook/"}static create(ie){return`${y.d}${ie}`}static parse(ie){if(ie.startsWith(y.d))return ie.substring(y.d.length)}}e.$5L=y;function C(V){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(V)}const T=new TextDecoder;function $(V){const ie=[];let le=!1;for(const ce of V)(ie.length===0||le)&&(ie.push(ce),le=!0);let _=A(ie);const oe=v.$Qe.concat(ie.map(ce=>v.$Qe.wrap(ce))),re=Q(oe);return _=_||re.byteLength!==oe.byteLength,{data:re,didCompression:_}}e.$8L="\x1B[A";const w=e.$8L.split("").map(V=>V.charCodeAt(0)),M=10;function A(V){let ie=!1;return V.forEach((le,_)=>{if(_===0||le.length<e.$8L.length)return;const oe=V[_-1],re=le.subarray(0,e.$8L.length);if(re[0]===w[0]&&re[1]===w[1]&&re[2]===w[2]){const ce=oe.lastIndexOf(M);if(ce===-1)return;ie=!0,V[_-1]=oe.subarray(0,ce),V[_]=le.subarray(e.$8L.length)}}),ie}function L(V){let ie=V;do V=ie,ie=V.replace(/[^\n]\x08/gm,"");while(ie.length<V.length);return V}function J(V){for(V=V.replace(/\r+\n/gm,`
`);V.search(/\r[^$]/g)>-1;){const ie=V.match(/^(.*)\r+/m)[1];let le=V.match(/\r+(.*)$/m)[1];le=le+ie.slice(le.length,ie.length),V=V.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,le)}return V}const Y=8,z=13;function Q(V){return!V.buffer.includes(Y)&&!V.buffer.includes(z)?V:v.$Qe.fromString(J(L(T.decode(V.buffer))))}}),define(Re[7],Te([1,0,17,12,59,27,72,13,14,2,38,18,28,110,90]),function(we,e,v,D,P,N,R,O,p,s,I,b,h,E,f){"use strict";var r,l,d,a,i,n,t,o,c,m,g,u,S,k,y,C,T;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$sQ=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$rQ=e.$qQ=e.$pQ=e.$oQ=e.$nQ=e.$mQ=e.$lQ=e.$kQ=e.LanguageModelChatMessageRole=e.$jQ=e.$iQ=e.ChatResponseReferencePartStatusKind=e.ChatLocation=e.$hQ=e.$gQ=e.$fQ=e.$eQ=e.$dQ=e.$cQ=e.$bQ=e.$aQ=e.$_P=e.$$P=e.$0P=e.$9P=e.$8P=e.$7P=e.$6P=e.$5P=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$4P=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$3P=e.$2P=e.$1P=e.$ZP=e.$YP=e.$XP=e.$WP=e.$VP=e.$UP=e.$TP=e.$SP=e.$RP=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$QP=e.$PP=e.$OP=e.$NP=e.$LP=e.$KP=e.$JP=e.$IP=e.$HP=e.TestRunProfileKind=e.TestResultState=e.$GP=e.$FP=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$EP=e.NotebookVariablesRequestKind=e.$DP=e.$CP=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$BP=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$AP=e.$zP=e.$yP=e.$xP=e.$wP=e.ColorThemeKind=e.$vP=e.$uP=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$tP=e.QuickInputButtonLocation=e.$sP=e.DebugConsoleMode=e.$rP=e.$qP=e.$pP=e.$oP=e.$nP=e.CommentThreadFocus=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$mP=e.$lP=e.FileChangeType=e.$kP=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$jP=e.$iP=e.$hP=e.$gP=e.InlineCompletionTriggerKind=e.$fP=e.$eP=e.$dP=e.$cP=e.$bP=e.$aP=e.$_O=e.$$O=e.$0O=e.$9O=e.$8O=e.$6O=e.ConfigurationTarget=e.$5O=e.$4O=e.$3O=e.$2O=e.DocumentPasteTriggerKind=e.$1O=e.$ZO=e.$YO=e.$XO=e.$WO=e.$VO=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$UO=e.ViewBadge=e.ProgressLocation=e.$TO=e.$SO=e.TaskScope=e.ShellQuoting=e.$RO=e.$QO=e.$PO=e.TaskPanelKind=e.TaskRevealKind=e.$OO=e.TerminalLocation=e.$NO=e.$MO=e.$LO=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$KO=e.$JO=e.$IO=e.$HO=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$FO=e.$EO=e.$DO=e.$CO=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$BO=e.$AO=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$zO=e.$yO=e.$xO=e.$wO=e.$vO=e.LanguageStatusSeverity=e.$uO=e.$tO=e.$sO=e.$rO=e.$qO=e.$pO=e.CodeActionTriggerKind=e.$oO=e.$nO=e.SymbolTag=e.SymbolKind=e.$mO=e.$lO=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.DiagnosticSeverity=e.DiagnosticTag=e.$fO=e.$eO=e.FileEditType=e.$dO=e.$cO=e.$bO=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$aO=e.$_N=e.$$N=e.$8N=e.$7N=e.$6N=e.$5N=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$9N=z,e.$0N=Q,e.$GO=ht,e.$7O=ji,e.$MP=Cn;function $(U){return Object.assign(U,{apply:function(...te){if(te.length===0)return Reflect.construct(U,[]);{const Se=te.length===1?[]:te[1];return Reflect.construct(U,Se,te[0].constructor)}},call:function(...te){if(te.length===0)return Reflect.construct(U,[]);{const[Se,...He]=te;return Reflect.construct(U,He,Se.constructor)}}})}var w;(function(U){U[U.Top=0]="Top",U[U.Bottom=1]="Bottom"})(w||(e.TerminalOutputAnchor=w={}));var M;(function(U){U[U.TerminalCommand=0]="TerminalCommand",U[U.Opener=1]="Opener",U[U.Command=3]="Command"})(M||(e.TerminalQuickFixType=M={}));let A=r=class{static from(...F){let te=F;return new r(function(){if(te){for(const Se of te)Se&&typeof Se.dispose=="function"&&Se.dispose();te=void 0}})}#e;constructor(F){this.#e=F}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$5N=A,e.$5N=A=r=Ke([$],A);let L=l=class{static Min(...F){if(F.length===0)throw new TypeError;let te=F[0];for(let Se=1;Se<F.length;Se++){const He=F[Se];He.isBefore(te)&&(te=He)}return te}static Max(...F){if(F.length===0)throw new TypeError;let te=F[0];for(let Se=1;Se<F.length;Se++){const He=F[Se];He.isAfter(te)&&(te=He)}return te}static isPosition(F){if(!F)return!1;if(F instanceof l)return!0;const{line:te,character:Se}=F;return typeof te=="number"&&typeof Se=="number"}static of(F){if(F instanceof l)return F;if(this.isPosition(F))return new l(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(F,te){if(F<0)throw(0,D.$9)("line must be non-negative");if(te<0)throw(0,D.$9)("character must be non-negative");this.c=F,this.e=te}isBefore(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<F.e}isBeforeOrEqual(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<=F.e}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this.c===F.c&&this.e===F.e}compareTo(F){return this.c<F.c?-1:this.c>F.line?1:this.e<F.e?-1:this.e>F.e?1:0}translate(F,te=0){if(F===null||te===null)throw(0,D.$9)();let Se;return typeof F>"u"?Se=0:typeof F=="number"?Se=F:(Se=typeof F.lineDelta=="number"?F.lineDelta:0,te=typeof F.characterDelta=="number"?F.characterDelta:0),Se===0&&te===0?this:new l(this.line+Se,this.character+te)}with(F,te=this.character){if(F===null||te===null)throw(0,D.$9)();let Se;return typeof F>"u"?Se=this.line:typeof F=="number"?Se=F:(Se=typeof F.line=="number"?F.line:this.line,te=typeof F.character=="number"?F.character:this.character),Se===this.line&&te===this.character?this:new l(Se,te)}toJSON(){return{line:this.line,character:this.character}}[Symbol.for("debug.description")](){return`(${this.line}:${this.character})`}};e.$6N=L,e.$6N=L=l=Ke([$],L);let J=d=class{static isRange(F){return F instanceof d?!0:F?L.isPosition(F.start)&&L.isPosition(F.end):!1}static of(F){if(F instanceof d)return F;if(this.isRange(F))return new d(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(F,te,Se,He){let rt,mt;if(typeof F=="number"&&typeof te=="number"&&typeof Se=="number"&&typeof He=="number"?(rt=new L(F,te),mt=new L(Se,He)):L.isPosition(F)&&L.isPosition(te)&&(rt=L.of(F),mt=L.of(te)),!rt||!mt)throw new Error("Invalid arguments");rt.isBefore(mt)?(this.c=rt,this.e=mt):(this.c=mt,this.e=rt)}contains(F){return d.isRange(F)?this.contains(F.start)&&this.contains(F.end):L.isPosition(F)?!(L.of(F).isBefore(this.c)||this.e.isBefore(F)):!1}isEqual(F){return this.c.isEqual(F.c)&&this.e.isEqual(F.e)}intersection(F){const te=L.Max(F.start,this.c),Se=L.Min(F.end,this.e);if(!te.isAfter(Se))return new d(te,Se)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const te=L.Min(F.start,this.c),Se=L.Max(F.end,this.end);return new d(te,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(F,te=this.end){if(F===null||te===null)throw(0,D.$9)();let Se;return F?L.isPosition(F)?Se=F:(Se=F.start||this.start,te=F.end||this.end):Se=this.start,Se.isEqual(this.c)&&te.isEqual(this.end)?this:new d(Se,te)}toJSON(){return[this.start,this.end]}[Symbol.for("debug.description")](){return z(this)}};e.$7N=J,e.$7N=J=d=Ke([$],J);let Y=a=class extends J{static isSelection(F){return F instanceof a?!0:F?J.isRange(F)&&L.isPosition(F.anchor)&&L.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(F,te,Se,He){let rt,mt;if(typeof F=="number"&&typeof te=="number"&&typeof Se=="number"&&typeof He=="number"?(rt=new L(F,te),mt=new L(Se,He)):L.isPosition(F)&&L.isPosition(te)&&(rt=L.of(F),mt=L.of(te)),!rt||!mt)throw new Error("Invalid arguments");super(rt,mt),this.f=rt,this.g=mt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}[Symbol.for("debug.description")](){return Q(this)}};e.$8N=Y,e.$8N=Y=a=Ke([$],Y);function z(U){return U.isEmpty?`[${U.start.line}:${U.start.character})`:`[${U.start.line}:${U.start.character} -> ${U.end.line}:${U.end.character})`}function Q(U){let F=z(U);return U.isEmpty||(U.active.isEqual(U.start)?F=`|${F}`:F=`${F}|`),F}const V=U=>{if(typeof U!="string"||U.length===0||!/^[0-9A-Za-z_\-]+$/.test(U))throw(0,D.$9)("connectionToken")};class ie{static isResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.host=="string"&&typeof F.port=="number"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,te,Se){if(typeof F!="string"||F.length===0)throw(0,D.$9)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,D.$9)("port");typeof Se<"u"&&V(Se),this.host=F,this.port=Math.round(te),this.connectionToken=Se}}e.$$N=ie;class le{static isManagedResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.makeConnection=="function"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,te){this.makeConnection=F,this.connectionToken=te,typeof te<"u"&&V(te)}}e.$_N=le;class _ extends Error{static NotAvailable(F,te){return new _(F,E.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(F){return new _(F,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(F,te=E.RemoteAuthorityResolverErrorCode.Unknown,Se){super(F),this._message=F,this._code=te,this._detail=Se,Object.setPrototypeOf(this,_.prototype)}}e.$aO=_;var oe;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(oe||(e.EndOfLine=oe={}));var re;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(re||(e.EnvironmentVariableMutatorType=re={}));let ce=i=class{static isTextEdit(F){return F instanceof i?!0:F?J.isRange(F)&&typeof F.newText=="string":!1}static replace(F,te){return new i(F,te)}static insert(F,te){return i.replace(new J(F,F),te)}static delete(F){return i.replace(F,"")}static setEndOfLine(F){const te=new i(new J(new L(0,0),new L(0,0)),"");return te.newEol=F,te}get range(){return this.c}set range(F){if(F&&!J.isRange(F))throw(0,D.$9)("range");this.c=F}get newText(){return this.e||""}set newText(F){if(F&&typeof F!="string")throw(0,D.$9)("newText");this.e=F}get newEol(){return this.f}set newEol(F){if(F&&typeof F!="number")throw(0,D.$9)("newEol");this.f=F}constructor(F,te){this.c=F,this.e=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$bO=ce,e.$bO=ce=i=Ke([$],ce);let x=n=class{static isNotebookCellEdit(F){return F instanceof n?!0:F?ki.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,te){return new n(F,te)}static insertCells(F,te){return new n(new ki(F,F),te)}static deleteCells(F){return new n(F,[])}static updateCellMetadata(F,te){const Se=new n(new ki(F,F),[]);return Se.newCellMetadata=te,Se}static updateNotebookMetadata(F){const te=new n(new ki(0,0),[]);return te.newNotebookMetadata=F,te}constructor(F,te){this.range=F,this.newCells=te}};e.$cO=x,e.$cO=x=n=Ke([$],x);class $e{static isSnippetTextEdit(F){return F instanceof $e?!0:F?J.isRange(F.range)&&q.isSnippetString(F.snippet):!1}static replace(F,te){return new $e(F,te)}static insert(F,te){return $e.replace(new J(F,F),te)}constructor(F,te){this.range=F,this.snippet=te}}e.$dO=$e;var Pe;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace",U[U.Snippet=6]="Snippet"})(Pe||(e.FileEditType=Pe={}));let X=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(F,te,Se,He){this.c.push({_type:Pe.File,from:F,to:te,options:Se,metadata:He})}createFile(F,te,Se){this.c.push({_type:Pe.File,from:void 0,to:F,options:te,metadata:Se})}deleteFile(F,te,Se){this.c.push({_type:Pe.File,from:F,to:void 0,options:te,metadata:Se})}e(F,te,Se){this.c.push({_type:Pe.Cell,metadata:Se,uri:F,edit:{editType:f.CellEditType.DocumentMetadata,metadata:te},notebookMetadata:te})}f(F,te,Se,He){const rt=te.start,mt=te.end;(rt!==mt||Se.length>0)&&this.c.push({_type:Pe.CellReplace,uri:F,index:rt,count:mt-rt,cells:Se,metadata:He})}g(F,te,Se,He){this.c.push({_type:Pe.Cell,metadata:He,uri:F,edit:{editType:f.CellEditType.Metadata,index:te,metadata:Se}})}replace(F,te,Se,He){this.c.push({_type:Pe.Text,uri:F,edit:new ce(te,Se),metadata:He})}insert(F,te,Se,He){this.replace(F,new J(te,te),Se,He)}delete(F,te,Se){this.replace(F,te,"",Se)}has(F){return this.c.some(te=>te._type===Pe.Text&&te.uri.toString()===F.toString())}set(F,te){if(te)for(const Se of te){if(!Se)continue;let He,rt;Array.isArray(Se)?(He=Se[0],rt=Se[1]):He=Se,x.isNotebookCellEdit(He)?He.newCellMetadata?this.g(F,He.range.start,He.newCellMetadata,rt):He.newNotebookMetadata?this.e(F,He.newNotebookMetadata,rt):this.f(F,He.range,He.newCells,rt):$e.isSnippetTextEdit(He)?this.c.push({_type:Pe.Snippet,uri:F,range:He.range,edit:He.snippet,metadata:rt}):this.c.push({_type:Pe.Text,uri:F,edit:He,metadata:rt})}else{for(let Se=0;Se<this.c.length;Se++){const He=this.c[Se];switch(He._type){case Pe.Text:case Pe.Snippet:case Pe.Cell:case Pe.CellReplace:He.uri.toString()===F.toString()&&(this.c[Se]=void 0);break}}(0,v.$Kb)(this.c)}}get(F){const te=[];for(const Se of this.c)Se._type===Pe.Text&&Se.uri.toString()===F.toString()&&te.push(Se.edit);return te}entries(){const F=new N.$Dc;for(const te of this.c)if(te._type===Pe.Text){let Se=F.get(te.uri);Se||(Se=[te.uri,[]],F.set(te.uri,Se)),Se[1].push(te.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$eO=X,e.$eO=X=Ke([$],X);let q=t=class{static isSnippetString(F){return F instanceof t?!0:F?typeof F.value=="string":!1}static c(F){return F.replace(/\$|}|\\/g,"\\$&")}constructor(F){this.e=1,this.value=F||""}appendText(F){return this.value+=t.c(F),this}appendTabstop(F=this.e++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,te=this.e++){if(typeof F=="function"){const Se=new t;Se.e=this.e,F(Se),this.e=Se.e,F=Se.value}else F=t.c(F);return this.value+="${",this.value+=te,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,te=this.e++){const Se=F.map(He=>He.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(F,te){if(typeof te=="function"){const Se=new t;Se.e=this.e,te(Se),this.e=Se.e,te=Se.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,te&&(this.value+=":",this.value+=te),this.value+="}",this}};e.$fO=q,e.$fO=q=t=Ke([$],q);var ne;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(ne||(e.DiagnosticTag=ne={}));var be;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(be||(e.DiagnosticSeverity=be={}));let Ie=o=class{static isLocation(F){return F instanceof o?!0:F?J.isRange(F.range)&&s.URI.isUri(F.uri):!1}constructor(F,te){if(this.uri=F,te)if(J.isRange(te))this.range=J.of(te);else if(L.isPosition(te))this.range=new J(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$gO=Ie,e.$gO=Ie=o=Ke([$],Ie);let Fe=class{static is(F){return F?typeof F.message=="string"&&F.location&&J.isRange(F.location.range)&&s.URI.isUri(F.location.uri):!1}constructor(F,te){this.location=F,this.message=te}static isEqual(F,te){return F===te?!0:!F||!te?!1:F.message===te.message&&F.location.range.isEqual(te.location.range)&&F.location.uri.toString()===te.location.uri.toString()}};e.$hO=Fe,e.$hO=Fe=Ke([$],Fe);let Be=class{constructor(F,te,Se=be.Error){if(!J.isRange(F))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=F,this.message=te,this.severity=Se}toJSON(){return{severity:be[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,te){return F===te?!0:!F||!te?!1:F.message===te.message&&F.severity===te.severity&&F.code===te.code&&F.severity===te.severity&&F.source===te.source&&F.range.isEqual(te.range)&&(0,v.$wb)(F.tags,te.tags)&&(0,v.$wb)(F.relatedInformation,te.relatedInformation,Fe.isEqual)}};e.$iO=Be,e.$iO=Be=Ke([$],Be);let xe=class{constructor(F,te){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=te}};e.$jO=xe,e.$jO=xe=Ke([$],xe);let nt=class extends xe{constructor(F,te,Se,He){super(F,te),this.canIncreaseVerbosity=Se,this.canDecreaseVerbosity=He}};e.$kO=nt,e.$kO=nt=Ke([$],nt);var ut;(function(U){U[U.Increase=0]="Increase",U[U.Decrease=1]="Decrease"})(ut||(e.HoverVerbosityAction=ut={}));var pt;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(pt||(e.DocumentHighlightKind=pt={}));let lt=class{constructor(F,te=pt.Text){this.range=F,this.kind=te}toJSON(){return{range:this.range,kind:pt[this.kind]}}};e.$lO=lt,e.$lO=lt=Ke([$],lt);let et=class{constructor(F,te){this.uri=F,this.highlights=te}toJSON(){return{uri:this.uri,highlights:this.highlights.map(F=>F.toJSON())}}};e.$mO=et,e.$mO=et=Ke([$],et);var Ne;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(Ne||(e.SymbolKind=Ne={}));var Me;(function(U){U[U.Deprecated=1]="Deprecated"})(Me||(e.SymbolTag=Me={}));let Le=c=class{static validate(F){if(!F.name)throw new Error("name must not be falsy")}constructor(F,te,Se,He,rt){this.name=F,this.kind=te,this.containerName=rt,typeof Se=="string"&&(this.containerName=Se),He instanceof Ie?this.location=He:Se instanceof J&&(this.location=new Ie(He,Se)),c.validate(this)}toJSON(){return{name:this.name,kind:Ne[this.kind],location:this.location,containerName:this.containerName}}};e.$nO=Le,e.$nO=Le=c=Ke([$],Le);let B=m=class{static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach(m.validate)}constructor(F,te,Se,He,rt){this.name=F,this.detail=te,this.kind=Se,this.range=He,this.selectionRange=rt,this.children=[],m.validate(this)}};e.$oO=B,e.$oO=B=m=Ke([$],B);var j;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(j||(e.CodeActionTriggerKind=j={}));let H=class{constructor(F,te){this.title=F,this.kind=te}};e.$pO=H,e.$pO=H=Ke([$],H);let G=class{static{g=this}static{this.c="."}constructor(F){this.value=F}append(F){return new g(this.value?this.value+g.c+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+g.c)}};e.$qO=G,e.$qO=G=g=Ke([$],G),G.Empty=new G(""),G.QuickFix=G.Empty.append("quickfix"),G.Refactor=G.Empty.append("refactor"),G.RefactorExtract=G.Refactor.append("extract"),G.RefactorInline=G.Refactor.append("inline"),G.RefactorMove=G.Refactor.append("move"),G.RefactorRewrite=G.Refactor.append("rewrite"),G.Source=G.Empty.append("source"),G.SourceOrganizeImports=G.Source.append("organizeImports"),G.SourceFixAll=G.Source.append("fixAll"),G.Notebook=G.Empty.append("notebook");let se=class{constructor(F,te){if(this.range=F,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$rO=se,e.$rO=se=Ke([$],se);class ge{constructor(F,te,Se,He,rt,mt){this.kind=F,this.name=te,this.detail=Se,this.uri=He,this.range=rt,this.selectionRange=mt}}e.$sO=ge;class Ee{constructor(F,te){this.fromRanges=te,this.from=F}}e.$tO=Ee;class Ue{constructor(F,te){this.fromRanges=te,this.to=F}}e.$uO=Ue;var Je;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(Je||(e.LanguageStatusSeverity=Je={}));let _e=class{constructor(F,te){this.range=F,this.command=te}get isResolved(){return!!this.command}};e.$vO=_e,e.$vO=_e=Ke([$],_e);let tt=u=class{#e;static isMarkdownString(F){return F instanceof u?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}constructor(F,te=!1){this.#e=new P.$7k(F,{supportThemeIcons:te})}get value(){return this.#e.value}set value(F){this.#e.value=F}get isTrusted(){return this.#e.isTrusted}set isTrusted(F){this.#e.isTrusted=F}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(F){this.#e.supportThemeIcons=F}get supportHtml(){return this.#e.supportHtml}set supportHtml(F){this.#e.supportHtml=F}get baseUri(){return this.#e.baseUri}set baseUri(F){this.#e.baseUri=F}appendText(F){return this.#e.appendText(F),this}appendMarkdown(F){return this.#e.appendMarkdown(F),this}appendCodeblock(F,te){return this.#e.appendCodeblock(te??"",F),this}};e.$wO=tt,e.$wO=tt=u=Ke([$],tt);let at=class{constructor(F,te){this.label=F,this.documentation=te}};e.$xO=at,e.$xO=at=Ke([$],at);let it=class{constructor(F,te){this.label=F,this.documentation=te,this.parameters=[]}};e.$yO=it,e.$yO=it=Ke([$],it);let ot=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$zO=ot,e.$zO=ot=Ke([$],ot);var vt;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(vt||(e.SignatureHelpTriggerKind=vt={}));var Ye;(function(U){U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(Ye||(e.InlayHintKind=Ye={}));let he=class{constructor(F){this.value=F}};e.$AO=he,e.$AO=he=Ke([$],he);let pe=class{constructor(F,te,Se){this.position=F,this.label=te,this.kind=Se}};e.$BO=pe,e.$BO=pe=Ke([$],pe);var ye;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ye||(e.CompletionTriggerKind=ye={}));var Ce;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(Ce||(e.CompletionItemKind=Ce={}));var fe;(function(U){U[U.Deprecated=1]="Deprecated"})(fe||(e.CompletionItemTag=fe={}));let ve=class{constructor(F,te){this.label=F,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&Ce[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$CO=ve,e.$CO=ve=Ke([$],ve);let Z=class{constructor(F=[],te=!1){this.items=F,this.isIncomplete=te}};e.$DO=Z,e.$DO=Z=Ke([$],Z);let W=class{constructor(F,te,Se){this.insertText=F,this.range=te,this.command=Se}};e.$EO=W,e.$EO=W=Ke([$],W);let de=class{constructor(F){this.commands=void 0,this.suppressSuggestions=void 0,this.items=F}};e.$FO=de,e.$FO=de=Ke([$],de);var je;(function(U){U[U.Unknown=0]="Unknown",U[U.Word=1]="Word",U[U.Line=2]="Line",U[U.Suggest=3]="Suggest"})(je||(e.PartialAcceptTriggerKind=je={}));var Qe;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(Qe||(e.ViewColumn=Qe={}));var st;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(st||(e.StatusBarAlignment=st={}));function ht(U,F){return`${b.$vn.toKey(U)}.${F}`}var gt;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative",U[U.Interval=3]="Interval"})(gt||(e.TextEditorLineNumbersStyle=gt={}));var Rt;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(Rt||(e.TextDocumentSaveReason=Rt={}));var Ot;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Ot||(e.TextEditorRevealType=Ot={}));var Qt;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(Qt||(e.TextEditorSelectionChangeKind=Qt={}));var _t;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(_t||(e.TextDocumentChangeReason=_t={}));var Xe;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(Xe||(e.DecorationRangeBehavior=Xe={})),function(U){function F(te){switch(te){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=F}(Qt||(e.TextEditorSelectionChangeKind=Qt={}));var At;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(At||(e.SyntaxTokenType=At={})),function(U){function F(te){switch(te){case U.Other:return"other";case U.Comment:return"comment";case U.String:return"string";case U.RegEx:return"regex"}return"other"}U.toString=F}(At||(e.SyntaxTokenType=At={}));let Ut=class{constructor(F,te){if(te&&!s.URI.isUri(te))throw(0,D.$9)("target");if(!J.isRange(F)||F.isEmpty)throw(0,D.$9)("range");this.range=F,this.target=te}};e.$HO=Ut,e.$HO=Ut=Ke([$],Ut);let $t=class{constructor(F,te,Se,He){this.red=F,this.green=te,this.blue=Se,this.alpha=He}};e.$IO=$t,e.$IO=$t=Ke([$],$t);let Pt=class{constructor(F,te){if(te&&!(te instanceof $t))throw(0,D.$9)("color");if(!J.isRange(F)||F.isEmpty)throw(0,D.$9)("range");this.range=F,this.color=te}};e.$JO=Pt,e.$JO=Pt=Ke([$],Pt);let ei=class{constructor(F){if(!F||typeof F!="string")throw(0,D.$9)("label");this.label=F}};e.$KO=ei,e.$KO=ei=Ke([$],ei);var ti;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(ti||(e.ColorFormat=ti={}));var Ht;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(Ht||(e.SourceControlInputBoxValidationType=Ht={}));var wt;(function(U){U[U.Unknown=0]="Unknown",U[U.Shutdown=1]="Shutdown",U[U.Process=2]="Process",U[U.User=3]="User",U[U.Extension=4]="Extension"})(wt||(e.TerminalExitReason=wt={}));var Nt;(function(U){U[U.Low=0]="Low",U[U.Medium=1]="Medium",U[U.High=2]="High"})(Nt||(e.TerminalShellExecutionCommandLineConfidence=Nt={}));class ai{constructor(F,te,Se){if(this.startIndex=F,this.length=te,this.tooltip=Se,typeof F!="number"||F<0)throw(0,D.$9)("startIndex");if(typeof te!="number"||te<1)throw(0,D.$9)("length");if(Se!==void 0&&typeof Se!="string")throw(0,D.$9)("tooltip")}}e.$LO=ai;class Xt{constructor(F){this.uri=F}}e.$MO=Xt;class Ge{constructor(F){this.terminalCommand=F}}e.$NO=Ge;var ii;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(ii||(e.TerminalLocation=ii={}));class ci{constructor(F){if(this.options=F,typeof F!="object")throw(0,D.$9)("options")}}e.$OO=ci;var ui;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(ui||(e.TaskRevealKind=ui={}));var Et;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(Et||(e.TaskPanelKind=Et={}));let jt=class{static{S=this}static{this.Clean=new S("clean","Clean")}static{this.Build=new S("build","Build")}static{this.Rebuild=new S("rebuild","Rebuild")}static{this.Test=new S("test","Test")}static from(F){switch(F){case"clean":return S.Clean;case"build":return S.Build;case"rebuild":return S.Rebuild;case"test":return S.Test;default:return}}constructor(F,te){if(this.label=te,typeof F!="string"||typeof te!="string")throw(0,D.$9)("name");this.c=F}get id(){return this.c}};e.$PO=jt,e.$PO=jt=S=Ke([$],jt);function Lt(U){let F="";for(let te=0;te<U.length;te++)F+=U[te].replace(/,/g,",,")+",";return F}let Bt=class{constructor(F,te,Se){if(typeof F!="string")throw(0,D.$9)("process");this.e=[],this.c=F,te!==void 0&&(Array.isArray(te)?(this.e=te,this.f=Se):this.f=te)}get process(){return this.c}set process(F){if(typeof F!="string")throw(0,D.$9)("process");this.c=F}get args(){return this.e}set args(F){Array.isArray(F)||(F=[]),this.e=F}get options(){return this.f}set options(F){this.f=F}computeId(){const F=[];if(F.push("process"),this.c!==void 0&&F.push(this.c),this.e&&this.e.length>0)for(const te of this.e)F.push(te);return Lt(F)}};e.$QO=Bt,e.$QO=Bt=Ke([$],Bt);let oi=class{constructor(F,te,Se){if(this.f=[],Array.isArray(te)){if(!F)throw(0,D.$9)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,D.$9)("command");this.e=F,this.f=te,this.g=Se}else{if(typeof F!="string")throw(0,D.$9)("commandLine");this.c=F,this.g=te}}get commandLine(){return this.c}set commandLine(F){if(typeof F!="string")throw(0,D.$9)("commandLine");this.c=F}get command(){return this.e?this.e:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,D.$9)("command");this.e=F}get args(){return this.f}set args(F){this.f=F||[]}get options(){return this.g}set options(F){this.g=F}computeId(){const F=[];if(F.push("shell"),this.c!==void 0&&F.push(this.c),this.e!==void 0&&F.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const te of this.f)F.push(typeof te=="string"?te:te.value);return Lt(F)}};e.$RO=oi,e.$RO=oi=Ke([$],oi);var ni;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(ni||(e.ShellQuoting=ni={}));var ri;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(ri||(e.TaskScope=ri={}));class Kt{constructor(F){this.c=F}computeId(){return"customExecution"+(0,I.$5g)()}set callback(F){this.c=F}get callback(){return this.c}}e.$SO=Kt;let Gt=class{static{k=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(F,te,Se,He,rt,mt){this.k=!1,this.l=this.definition=F;let yt;typeof te=="string"?(this.o=this.name=te,this.w=this.source=Se,this.execution=He,yt=rt,this.k=!0):te===ri.Global||te===ri.Workspace?(this.target=te,this.o=this.name=Se,this.w=this.source=He,this.execution=rt,yt=mt):(this.target=te,this.o=this.name=Se,this.w=this.source=He,this.execution=rt,yt=mt),typeof yt=="string"?(this.r=[yt],this.t=!0):Array.isArray(yt)?(this.r=yt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(F){this.j=F}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Bt?this.l={type:k.e,id:this.q.computeId()}:this.q instanceof oi?this.l={type:k.f,id:this.q.computeId()}:this.q instanceof Kt?this.l={type:k.c,id:this.q.computeId()}:this.l={type:k.g,id:(0,I.$5g)()}}get definition(){return this.l}set definition(F){if(F==null)throw(0,D.$9)("Kind can't be undefined or null");this.B(),this.l=F}get scope(){return this.m}set target(F){this.B(),this.m=F}get name(){return this.o}set name(F){if(typeof F!="string")throw(0,D.$9)("name");this.B(),this.o=F}get execution(){return this.q}set execution(F){F===null&&(F=void 0),this.B(),this.q=F;const te=this.l.type;(k.g===te||k.e===te||k.f===te||k.c===te)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(F){if(Array.isArray(F))this.B(),this.r=F,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.B(),this.u=F}get source(){return this.w}set source(F){if(typeof F!="string"||F.length===0)throw(0,D.$9)("source must be a string of length > 0");this.B(),this.w=F}get group(){return this.x}set group(F){F===null&&(F=void 0),this.B(),this.x=F}get detail(){return this.A}set detail(F){F===null&&(F=void 0),this.A=F}get presentationOptions(){return this.y}set presentationOptions(F){F==null&&(F=Object.create(null)),this.B(),this.y=F}get runOptions(){return this.z}set runOptions(F){F==null&&(F=Object.create(null)),this.B(),this.z=F}};e.$TO=Gt,e.$TO=Gt=k=Ke([$],Gt);var li;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(li||(e.ProgressLocation=li={}));var Mt;(function(U){function F(te){const Se=te;return(0,p.$lg)(Se.value)?Se.tooltip&&!(0,p.$hg)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}U.isViewBadge=F})(Mt||(e.ViewBadge=Mt={}));let Dt=y=class{static isTreeItem(F,te){const Se=F;if(Se.checkboxState!==void 0){const He=(0,p.$lg)(Se.checkboxState)?Se.checkboxState:(0,p.$jg)(Se.checkboxState)&&(0,p.$lg)(Se.checkboxState.state)?Se.checkboxState.state:void 0,rt=!(0,p.$lg)(Se.checkboxState)&&(0,p.$jg)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(He===void 0||He!==Jt.Checked&&He!==Jt.Unchecked||rt!==void 0&&!(0,p.$hg)(rt))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(F instanceof y)return!0;if(Se.label!==void 0&&!(0,p.$hg)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,p.$hg)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,p.$hg)(Se.iconPath)&&!s.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,p.$hg)(Se.iconPath.id))){const He=Se.iconPath;if(!He||!(0,p.$hg)(He.light)&&!s.URI.isUri(He.light)&&!(0,p.$hg)(He.dark)&&!s.URI.isUri(He.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,p.$hg)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!s.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,p.$hg)(Se.tooltip)&&!(Se.tooltip instanceof tt)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<bt.None&&Se.collapsibleState>bt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,p.$hg)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(F,te=bt.None){this.collapsibleState=te,s.URI.isUri(F)?this.resourceUri=F:this.label=F}};e.$UO=Dt,e.$UO=Dt=y=Ke([$],Dt);var bt;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(bt||(e.TreeItemCollapsibleState=bt={}));var Jt;(function(U){U[U.Unchecked=0]="Unchecked",U[U.Checked=1]="Checked"})(Jt||(e.TreeItemCheckboxState=Jt={}));let St=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(F){this.value=F}};e.$VO=St,e.$VO=St=Ke([$],St);class hi extends St{}e.$WO=hi;class Zt extends hi{#e;constructor(F){super(""),this.#e=F}asFile(){return this.#e}}e.$XO=Zt;class Mi{constructor(F,te,Se,He){this.name=F,this.uri=te,this._itemId=Se,this.c=He}data(){return this.c()}}e.$YO=Mi;let di=class{#e=new Map;constructor(F){for(const[te,Se]of F??[]){const He=this.#e.get(this.#t(te));He?He.push(Se):this.#e.set(this.#t(te),[Se])}}get(F){return this.#e.get(this.#t(F))?.[0]}set(F,te){this.#e.set(this.#t(F),[te])}forEach(F,te){for(const[Se,He]of this.#e)for(const rt of He)F.call(te,rt,Se,this)}*[Symbol.iterator](){for(const[F,te]of this.#e)for(const Se of te)yield[F,Se]}#t(F){return F.toLowerCase()}};e.$ZO=di,e.$ZO=di=Ke([$],di);let yi=class{constructor(F,te,Se){this.insertText=F,this.title=te,this.kind=Se}};e.$1O=yi,e.$1O=yi=Ke([$],yi);var qt;(function(U){U[U.Automatic=0]="Automatic",U[U.PasteAs=1]="PasteAs"})(qt||(e.DocumentPasteTriggerKind=qt={}));class fi{static{this.c="."}constructor(F){this.value=F}append(...F){return new fi((this.value?[this.value,...F]:F).join(fi.c))}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+fi.c)}}e.$2O=fi,fi.Empty=new fi("");class Fi{constructor(F,te,Se){this.title=te,this.insertText=F,this.kind=Se}}e.$3O=Fi;let Ct=class{constructor(F,te){this.id=F,this.color=te}static isThemeIcon(F){return typeof F.id!="string"?(console.log("INVALID ThemeIcon, invalid id",F.id),!1):!0}};e.$4O=Ct,e.$4O=Ct=Ke([$],Ct),Ct.File=new Ct("file"),Ct.Folder=new Ct("folder");let Si=class{constructor(F){this.id=F}};e.$5O=Si,e.$5O=Si=Ke([$],Si);var Ai;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(Ai||(e.ConfigurationTarget=Ai={}));let gi=class{get base(){return this.c}set base(F){this.c=F,this.e=s.URI.file(F)}get baseUri(){return this.e}set baseUri(F){this.e=F,this.c=F.fsPath}constructor(F,te){if(typeof F!="string"&&(!F||!s.URI.isUri(F)&&!s.URI.isUri(F.uri)))throw(0,D.$9)("base");if(typeof te!="string")throw(0,D.$9)("pattern");typeof F=="string"?this.baseUri=s.URI.file(F):s.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$6O=gi,e.$6O=gi=Ke([$],gi);const zi=new WeakMap;function ji(U,F){zi.set(U,F)}let zt=class{constructor(F,te,Se,He,rt){this.enabled=typeof F=="boolean"?F:!0,typeof te=="string"&&(this.condition=te),typeof Se=="string"&&(this.hitCondition=Se),typeof He=="string"&&(this.logMessage=He),typeof rt=="string"&&(this.mode=rt)}get id(){return this.c||(this.c=zi.get(this)??(0,I.$5g)()),this.c}};e.$8O=zt,e.$8O=zt=Ke([$],zt);let Pi=class extends zt{constructor(F,te,Se,He,rt,mt){if(super(te,Se,He,rt,mt),F===null)throw(0,D.$9)("location");this.location=F}};e.$9O=Pi,e.$9O=Pi=Ke([$],Pi);let Di=class extends zt{constructor(F,te,Se,He,rt,mt){super(te,Se,He,rt,mt),this.functionName=F}};e.$0O=Di,e.$0O=Di=Ke([$],Di);let wi=class extends zt{constructor(F,te,Se,He,rt,mt,yt,xt){if(super(He,rt,mt,yt,xt),!te)throw(0,D.$9)("dataId");this.label=F,this.dataId=te,this.canPersist=Se}};e.$$O=wi,e.$$O=wi=Ke([$],wi);let bi=class{constructor(F,te,Se){this.command=F,this.args=te||[],this.options=Se}};e.$_O=bi,e.$_O=bi=Ke([$],bi);let me=class{constructor(F,te){this.port=F,this.host=te}};e.$aP=me,e.$aP=me=Ke([$],me);let De=class{constructor(F){this.path=F}};e.$bP=De,e.$bP=De=Ke([$],De);let ae=class{constructor(F){this.implementation=F}};e.$cP=ae,e.$cP=ae=Ke([$],ae);class K{constructor(F,te,Se){this.session=F,this.threadId=te,this.frameId=Se}}e.$dP=K;class ke{constructor(F,te){this.session=F,this.threadId=te}}e.$eP=ke;let ze=class{constructor(F,te){this.range=F,this.expression=te}};e.$fP=ze,e.$fP=ze=Ke([$],ze);var Ze;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(Ze||(e.InlineCompletionTriggerKind=Ze={}));let Ve=class{constructor(F,te){this.range=F,this.text=te}};e.$gP=Ve,e.$gP=Ve=Ke([$],Ve);let ft=class{constructor(F,te,Se=!0){this.range=F,this.variableName=te,this.caseSensitiveLookup=Se}};e.$hP=ft,e.$hP=ft=Ke([$],ft);let Tt=class{constructor(F,te){this.range=F,this.expression=te}};e.$iP=Tt,e.$iP=Tt=Ke([$],Tt);let Yt=class{constructor(F,te){this.frameId=F,this.stoppedLocation=te}};e.$jP=Yt,e.$jP=Yt=Ke([$],Yt);var Vt;(function(U){U[U.AIGenerated=1]="AIGenerated"})(Vt||(e.NewSymbolNameTag=Vt={}));var Wt;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(Wt||(e.NewSymbolNameTriggerKind=Wt={}));class Ni{constructor(F,te){this.newSymbolName=F,this.tags=te}}e.$kP=Ni;var en;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(en||(e.FileChangeType=en={}));let Vi=C=class extends Error{static FileExists(F){return new C(F,h.FileSystemProviderErrorCode.FileExists,C.FileExists)}static FileNotFound(F){return new C(F,h.FileSystemProviderErrorCode.FileNotFound,C.FileNotFound)}static FileNotADirectory(F){return new C(F,h.FileSystemProviderErrorCode.FileNotADirectory,C.FileNotADirectory)}static FileIsADirectory(F){return new C(F,h.FileSystemProviderErrorCode.FileIsADirectory,C.FileIsADirectory)}static NoPermissions(F){return new C(F,h.FileSystemProviderErrorCode.NoPermissions,C.NoPermissions)}static Unavailable(F){return new C(F,h.FileSystemProviderErrorCode.Unavailable,C.Unavailable)}constructor(F,te=h.FileSystemProviderErrorCode.Unknown,Se){super(s.URI.isUri(F)?F.toString(!0):F),this.code=Se?.name??"Unknown",(0,h.$sl)(this,te),Object.setPrototypeOf(this,C.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$lP=Vi,e.$lP=Vi=C=Ke([$],Vi);let Ei=class{constructor(F,te,Se){this.start=F,this.end=te,this.kind=Se}};e.$mP=Ei,e.$mP=Ei=Ke([$],Ei);var tn;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(tn||(e.FoldingRangeKind=tn={}));var nn;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(nn||(e.CommentThreadCollapsibleState=nn={}));var Ui;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(Ui||(e.CommentMode=Ui={}));var rn;(function(U){U[U.Published=0]="Published",U[U.Draft=1]="Draft"})(rn||(e.CommentState=rn={}));var Bi;(function(U){U[U.Unresolved=0]="Unresolved",U[U.Resolved=1]="Resolved"})(Bi||(e.CommentThreadState=Bi={}));var Qi;(function(U){U[U.Current=0]="Current",U[U.Outdated=1]="Outdated"})(Qi||(e.CommentThreadApplicability=Qi={}));var sn;(function(U){U[U.Reply=1]="Reply",U[U.Comment=2]="Comment"})(sn||(e.CommentThreadFocus=sn={}));class on{constructor(F,te=[]){this.tokenTypes=F,this.tokenModifiers=te}}e.$nP=on;function wn(U){return typeof U>"u"||(0,p.$ig)(U)}class Ci{constructor(F){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,F){this.m=!0;for(let te=0,Se=F.tokenTypes.length;te<Se;te++)this.k.set(F.tokenTypes[te],te);for(let te=0,Se=F.tokenModifiers.length;te<Se;te++)this.l.set(F.tokenModifiers[te],te)}}push(F,te,Se,He,rt){if(typeof F=="number"&&typeof te=="number"&&typeof Se=="number"&&typeof He=="number"&&(typeof rt=="number"||typeof rt>"u"))return typeof rt>"u"&&(rt=0),this.q(F,te,Se,He,rt);if(J.isRange(F)&&typeof te=="string"&&wn(Se))return this.o(F,te,Se);throw(0,D.$9)()}o(F,te,Se){if(!this.m)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(te))throw new Error("`tokenType` is not in the provided legend");const He=F.start.line,rt=F.start.character,mt=F.end.character-F.start.character,yt=this.k.get(te);let xt=0;if(Se)for(const $i of Se){if(!this.l.has($i))throw new Error("`tokenModifier` is not in the provided legend");const vi=this.l.get($i);xt|=1<<vi>>>0}this.q(He,rt,mt,yt,xt)}q(F,te,Se,He,rt){if(this.f&&(F<this.c||F===this.c&&te<this.e)){this.f=!1;const xt=this.g.length/5|0;let $i=0,vi=0;for(let Ii=0;Ii<xt;Ii++){let Oi=this.g[5*Ii],xi=this.g[5*Ii+1];Oi===0?(Oi=$i,xi+=vi):Oi+=$i,this.g[5*Ii]=Oi,this.g[5*Ii+1]=xi,$i=Oi,vi=xi}}let mt=F,yt=te;this.f&&this.j>0&&(mt-=this.c,mt===0&&(yt-=this.e)),this.g[this.j++]=mt,this.g[this.j++]=yt,this.g[this.j++]=Se,this.g[this.j++]=He,this.g[this.j++]=rt,this.c=F,this.e=te}static r(F){const te=[],Se=F.length/5|0;for(let yt=0;yt<Se;yt++)te[yt]=yt;te.sort((yt,xt)=>{const $i=F[5*yt],vi=F[5*xt];if($i===vi){const Ii=F[5*yt+1],Oi=F[5*xt+1];return Ii-Oi}return $i-vi});const He=new Uint32Array(F.length);let rt=0,mt=0;for(let yt=0;yt<Se;yt++){const xt=5*te[yt],$i=F[xt+0],vi=F[xt+1],Ii=F[xt+2],Oi=F[xt+3],xi=F[xt+4],Qn=$i-rt,Mr=Qn===0?vi-mt:vi,_i=5*yt;He[_i+0]=Qn,He[_i+1]=Mr,He[_i+2]=Ii,He[_i+3]=Oi,He[_i+4]=xi,rt=$i,mt=vi}return He}build(F){return this.f?new Hi(new Uint32Array(this.g),F):new Hi(Ci.r(this.g),F)}}e.$oP=Ci;class Hi{constructor(F,te){this.resultId=te,this.data=F}}e.$pP=Hi;class bn{constructor(F,te,Se){this.start=F,this.deleteCount=te,this.data=Se}}e.$qP=bn;class vn{constructor(F,te){this.resultId=te,this.edits=F}}e.$rP=vn;var Wi;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(Wi||(e.DebugConsoleMode=Wi={}));class an{constructor(F){this.name=F}}e.$sP=an;var Ae;(function(U){U[U.Title=1]="Title",U[U.Inline=2]="Inline"})(Ae||(e.QuickInputButtonLocation=Ae={}));let mi=class{static{this.Back={iconPath:new Ct("arrow-left")}}constructor(){}};e.$tP=mi,e.$tP=mi=Ke([$],mi);var Ki;(function(U){U[U.Separator=-1]="Separator",U[U.Default=0]="Default"})(Ki||(e.QuickPickItemKind=Ki={}));var ct;(function(U){U[U.Info=1]="Info",U[U.Warning=2]="Warning",U[U.Error=3]="Error"})(ct||(e.InputBoxValidationSeverity=ct={}));var kt;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(kt||(e.ExtensionKind=kt={}));class yn{static validate(F){if(typeof F.badge=="string"){let te=(0,O.$Sf)(F.badge,0);if(te<F.badge.length&&(te+=(0,O.$Sf)(F.badge,te)),F.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}else if(F.badge&&!Ct.isThemeIcon(F.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}constructor(F,te,Se){this.badge=F,this.tooltip=te,this.color=Se}}e.$uP=yn;let Gi=class{constructor(F){this.kind=F}};e.$vP=Gi,e.$vP=Gi=Ke([$],Gi);var Ji;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast",U[U.HighContrastLight=4]="HighContrastLight"})(Ji||(e.ColorThemeKind=Ji={}));class ki{static isNotebookRange(F){return F instanceof ki?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(F,te){if(F<0)throw(0,D.$9)("start must be positive");if(te<0)throw(0,D.$9)("end must be positive");F<=te?(this.c=F,this.e=te):(this.c=te,this.e=F)}with(F){let te=this.c,Se=this.e;return F.start!==void 0&&(te=F.start),F.end!==void 0&&(Se=F.end),te===this.c&&Se===this.e?this:new ki(te,Se)}}e.$wP=ki;class Ri{static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(te=>Ri.isNotebookCellData(te))}static isNotebookCellData(F){return!0}constructor(F,te,Se,He,rt,mt,yt){this.kind=F,this.value=te,this.languageId=Se,this.mime=He,this.outputs=rt??[],this.metadata=mt,this.executionSummary=yt,Ri.validate(this)}}e.$xP=Ri;class Sn{constructor(F){this.cells=F}}e.$yP=Sn;class pi{static isNotebookCellOutputItem(F){return F instanceof pi?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const te={name:F.name,message:F.message,stack:F.stack};return pi.json(te,"application/vnd.code.notebook.error")}static stdout(F){return pi.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return pi.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,te="application/octet-stream"){return new pi(F,te)}static#e=new TextEncoder;static text(F,te=R.$et.text){const Se=pi.#e.encode(String(F));return new pi(Se,te)}static json(F,te="text/x-json"){const Se=JSON.stringify(F,void 0,"	");return pi.text(Se,te)}constructor(F,te){this.data=F,this.mime=te;const Se=(0,R.$it)(te,!0);if(!Se)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$zP=pi;class qi{static isNotebookCellOutput(F){return F instanceof qi?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,te=!1){const Se=new Set,He=new Set;for(let rt=0;rt<F.length;rt++){const mt=F[rt],yt=(0,R.$it)(mt.mime);if(!Se.has(yt)||(0,f.$6L)(yt)){Se.add(yt);continue}He.add(rt),te&&console.warn(`DUPLICATED mime type '${mt.mime}' will be dropped`)}return He.size===0?F:F.filter((rt,mt)=>!He.has(mt))}constructor(F,te,Se){this.items=qi.ensureUniqueMimeTypes(F,!0),typeof te=="string"?(this.id=te,this.metadata=Se):(this.id=(0,I.$5g)(),this.metadata=te??Se)}}e.$AP=qi;var Xi;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(Xi||(e.NotebookCellKind=Xi={}));var cn;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(cn||(e.NotebookCellExecutionState=cn={}));var ln;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(ln||(e.NotebookCellStatusBarAlignment=ln={}));var un;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(un||(e.NotebookEditorRevealType=un={}));class En{constructor(F,te){this.text=F,this.alignment=te}}e.$BP=En;var hn;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(hn||(e.NotebookControllerAffinity=hn={}));var dn;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred",U[U.Hidden=-1]="Hidden"})(dn||(e.NotebookControllerAffinity2=dn={}));class kn{constructor(F,te=[]){this.uri=F,this.provides=(0,v.$4b)(te)}}e.$CP=kn;class In{constructor(F){this.label=F}}e.$DP=In;var fn;(function(U){U[U.Named=1]="Named",U[U.Indexed=2]="Indexed"})(fn||(e.NotebookVariablesRequestKind=fn={}));let Zi=class{constructor(F,te){this.label=F,this.timestamp=te}};e.$EP=Zi,e.$EP=Zi=Ke([$],Zi);var gn;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(gn||(e.ExtensionMode=gn={}));var ee;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(ee||(e.ExtensionRuntime=ee={}));var ue;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(ue||(e.StandardTokenType=ue={}));class Oe{constructor(F,te){this.ranges=F,this.wordPattern=te}}e.$FP=Oe;class dt{constructor(F){this.c=F}get autoForwardAction(){return this.c}}e.$GP=dt;var It;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(It||(e.TestResultState=It={}));var Ft;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(Ft||(e.TestRunProfileKind=Ft={}));let Ti=class{constructor(F=void 0,te=void 0,Se=void 0,He=!1,rt=!0){this.include=F,this.exclude=te,this.profile=Se,this.continuous=He,this.preserveFocus=rt}};e.$HP=Ti,e.$HP=Ti=Ke([$],Ti);let Yi=T=class{static diff(F,te,Se){const He=new T(F);return He.expectedOutput=te,He.actualOutput=Se,He}constructor(F){this.message=F}};e.$IP=Yi,e.$IP=Yi=T=Ke([$],Yi);let Pn=class{constructor(F){this.id=F}};e.$JP=Pn,e.$JP=Pn=Ke([$],Pn);class Gn{constructor(F,te,Se){this.label=F,this.uri=te,this.position=Se}}e.$KP=Gn;class mn{constructor(F,te){this.covered=F,this.total=te,Cn(this)}}e.$LP=mn;function Cn(U){if(U){if(U.covered>U.total)throw new Error(`The total number of covered items (${U.covered}) cannot be greater than the total (${U.total})`);if(U.total<0)throw new Error(`The number of covered items (${U.total}) cannot be negative`)}}class Dn{static fromDetails(F,te){const Se=new mn(0,0),He=new mn(0,0),rt=new mn(0,0);for(const yt of te)if("branches"in yt){Se.total+=1,Se.covered+=yt.executed?1:0;for(const xt of yt.branches)He.total+=1,He.covered+=xt.executed?1:0}else rt.total+=1,rt.covered+=yt.executed?1:0;const mt=new Dn(F,Se,He.total>0?He:void 0,rt.total>0?rt:void 0);return mt.detailedCoverage=te,mt}constructor(F,te,Se,He,rt=[]){this.uri=F,this.statementCoverage=te,this.branchCoverage=Se,this.declarationCoverage=He,this.fromTests=rt}}e.$NP=Dn;class Jn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,Se=[]){this.executed=F,this.location=te,this.branches=Se}}e.$OP=Jn;class Xn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,Se){this.executed=F,this.location=te,this.label=Se}}e.$PP=Xn;class Zn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,Se){this.name=F,this.executed=te,this.location=Se}}e.$QP=Zn;var Rn;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(Rn||(e.ExternalUriOpenerPriority=Rn={}));var Tn;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(Tn||(e.WorkspaceTrustState=Tn={}));var On;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(On||(e.PortAutoForwardAction=On={}));class Yn{constructor(F,te,Se,He,rt,mt){this.kind=F,this.name=te,this.detail=Se,this.uri=He,this.range=rt,this.selectionRange=mt}}e.$RP=Yn;class xn{constructor(F){this.uri=F}}e.$SP=xn;class _n{constructor(F,te){this.original=F,this.modified=te}}e.$TP=_n;class er{constructor(F,te,Se,He){this.base=F,this.input1=te,this.input2=Se,this.result=He}}e.$UP=er;class tr{constructor(F,te){this.uri=F,this.viewType=te}}e.$VP=tr;class ir{constructor(F){this.viewType=F}}e.$WP=ir;class nr{constructor(F,te){this.uri=F,this.notebookType=te}}e.$XP=nr;class rr{constructor(F,te,Se){this.original=F,this.modified=te,this.notebookType=Se}}e.$YP=rr;class sr{constructor(){}}e.$ZP=sr;class or{constructor(F,te){this.uri=F,this.inputBoxUri=te}}e.$1P=or;class ar{constructor(){}}e.$2P=ar;class cr{constructor(F){this.textDiffs=F}}e.$3P=cr;var An;(function(U){U[U.Down=0]="Down",U[U.Up=1]="Up"})(An||(e.InteractiveSessionVoteDirection=An={}));var Nn;(function(U){U[U.Action=1]="Action",U[U.Toolbar=2]="Toolbar"})(Nn||(e.ChatCopyKind=Nn={}));var Ln;(function(U){U[U.Short=1]="Short",U[U.Medium=2]="Medium",U[U.Full=3]="Full"})(Ln||(e.ChatVariableLevel=Ln={}));class lr{constructor(F,te,Se){this.id=F,this.label=te,this.values=Se}}e.$4P=lr;var Mn;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful",U[U.Undone=2]="Undone",U[U.Accepted=3]="Accepted",U[U.Bug=4]="Bug"})(Mn||(e.InteractiveEditorResponseFeedbackKind=Mn={}));var Fn;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful"})(Fn||(e.ChatResultFeedbackKind=Fn={}));class ur{constructor(F){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new tt(F):F}}e.$5P=ur;class hr{constructor(F,te){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new tt(F):F,this.vulnerabilities=te}}e.$6P=hr;class dr{constructor(F,te){this.participant=F,this.command=te}}e.$7P=dr;class fr{constructor(F,te,Se,He){this.title=F,this.message=te,this.data=Se,this.buttons=He}}e.$8P=fr;class gr{constructor(F,te){this.value=F,this.baseUri=te}}e.$9P=gr;class mr{constructor(F,te){this.value=F,this.title=te}}e.$0P=mr;class pr{constructor(F){this.value=F}}e.$$P=pr;class $r{constructor(F,te){this.value=F,this.task=te}}e.$_P=$r;class wr{constructor(F){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new tt(F):F}}e.$aQ=wr;class br{constructor(F){this.value=F}}e.$bQ=br;class vr{constructor(F,te,Se){this.value=F,this.iconPath=te,this.options=Se}}e.$cQ=vr;class yr{constructor(F,te,Se){this.value=F,this.license=te,this.snippet=Se}}e.$dQ=yr;class Sr{constructor(F,te){this.uri=F,this.range=te}}e.$eQ=Sr;class Er{constructor(F,te){this.uri=F,this.edits=Array.isArray(te)?te:[te]}}e.$fQ=Er;class kr{constructor(F,te,Se,He){this.prompt=F,this.command=te,this.references=Se,this.participant=He}}e.$gQ=kr;class Ir{constructor(F,te,Se,He){this.response=F,this.result=te,this.participant=Se,this.command=He}}e.$hQ=Ir;var zn;(function(U){U[U.Panel=1]="Panel",U[U.Terminal=2]="Terminal",U[U.Notebook=3]="Notebook",U[U.Editor=4]="Editor"})(zn||(e.ChatLocation=zn={}));var Un;(function(U){U[U.Complete=1]="Complete",U[U.Partial=2]="Partial",U[U.Omitted=3]="Omitted"})(Un||(e.ChatResponseReferencePartStatusKind=Un={}));class Pr{constructor(F,te,Se){this.document=F,this.selection=te,this.wholeRange=Se}}e.$iQ=Pr;class Dr{constructor(F){this.cell=F}}e.$jQ=Dr;var pn;(function(U){U[U.User=1]="User",U[U.Assistant=2]="Assistant",U[U.System=3]="System"})(pn||(e.LanguageModelChatMessageRole=pn={}));class Cr{constructor(F,te,Se){this.name=F,this.content=te,this.isError=Se??!1}}e.$kQ=Cr;class $n{static User(F,te){const Se=new $n(pn.User,typeof F=="string"?F:"",te);return Se.content2=F,Se}static Assistant(F,te){return new $n(pn.Assistant,F,te)}constructor(F,te,Se){this.role=F,this.content=te,this.content2=te,this.name=Se}}e.$lQ=$n;class Rr{constructor(F,te){this.name=F,this.parameters=te}}e.$mQ=Rr;class Tr{constructor(F){this.value=F}}e.$nQ=Tr;class Or{constructor(F){this.content=F}}e.$oQ=Or;class Ar{constructor(F,te){this.content=F,this.name=te}}e.$pQ=Ar;class Nr{constructor(F,te){this.content=F,this.name=te}}e.$qQ=Nr;class Li extends Error{static NotFound(F){return new Li(F,Li.NotFound.name)}static NoPermissions(F){return new Li(F,Li.NoPermissions.name)}static Blocked(F){return new Li(F,Li.Blocked.name)}constructor(F,te,Se){super(F,{cause:Se}),this.name="LanguageModelError",this.code=te??""}}e.$rQ=Li;var jn;(function(U){U[U.SymbolInformation=1]="SymbolInformation",U[U.CommandInformation=2]="CommandInformation",U[U.SearchInformation=3]="SearchInformation",U[U.SettingInformation=4]="SettingInformation"})(jn||(e.RelatedInformationType=jn={}));var Bn;(function(U){U[U.Started=1]="Started",U[U.Recognizing=2]="Recognizing",U[U.Recognized=3]="Recognized",U[U.Stopped=4]="Stopped",U[U.Error=5]="Error"})(Bn||(e.SpeechToTextStatus=Bn={}));var Wn;(function(U){U[U.Started=1]="Started",U[U.Stopped=2]="Stopped",U[U.Error=3]="Error"})(Wn||(e.TextToSpeechStatus=Wn={}));var qn;(function(U){U[U.Recognized=1]="Recognized",U[U.Stopped=2]="Stopped"})(qn||(e.KeywordRecognitionStatus=qn={}));class Lr{constructor(F,te){this.text=F,this.range=te}}e.$sQ=Lr;var Vn;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(Vn||(e.InlineEditTriggerKind=Vn={}))}),define(Re[226],Te([1,0,5,7]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yqc=void 0;class P{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(v.$3N.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,O,p){if(this.a.size===0)throw new Error("No related information providers registered");const s=this.a.get(R);if(!s)throw new Error("related information provider not found");return await s.provideRelatedInformation(O,p)??[]}getRelatedInformation(R,O,p){return this.c.$getAiRelatedInformation(O,p)}registerRelatedInformationProvider(R,O,p){const s=this.b;return this.b++,this.a.set(s,p),this.c.$registerAiRelatedInformationProvider(s,O),new D.$5N(()=>{this.c.$unregisterAiRelatedInformationProvider(s),this.a.delete(s)})}}e.$yqc=P}),define(Re[91],Te([1,0,6,5,7,18,119,3,16]),function(we,e,v,D,P,N,R,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kqc=e.$Jqc=void 0,e.$Jqc=(0,O.$Ii)("IExtHostAuthentication");let s=class{constructor(h){this.b=new Map,this.c=new v.$oe,this.onDidChangeSessions=this.c.event,this.d=new I,this.a=h.getProxy(D.$3N.MainThreadAuthentication)}async getSession(h,E,f,r={}){const l=N.$vn.toKey(h.identifier),d=[...f].sort().join(" ");return await this.d.getOrCreate(`${l} ${E} ${d}`,async()=>{await this.a.$ensureProvider(E);const a=h.displayName||h.name;return this.a.$getSession(E,f,l,a,r)})}async getAccounts(h){return await this.a.$ensureProvider(h),await this.a.$getAccounts(h)}async removeSession(h,E){const f=this.b.get(h);return f?f.provider.removeSession(E):this.a.$removeSession(h,E)}registerAuthenticationProvider(h,E,f,r){if(this.b.get(h))throw new Error(`An authentication provider with id '${h}' is already registered.`);this.b.set(h,{label:E,provider:f,options:r??{supportsMultipleAccounts:!1}});const l=f.onDidChangeSessions(d=>this.a.$sendDidChangeSessions(h,d));return this.a.$registerAuthenticationProvider(h,E,r?.supportsMultipleAccounts??!1),new P.$5N(()=>{l.dispose(),this.b.delete(h),this.a.$unregisterAuthenticationProvider(h)})}async $createSession(h,E,f){const r=this.b.get(h);if(r)return await r.provider.createSession(E,f);throw new Error(`Unable to find authentication provider with handle: ${h}`)}async $removeSession(h,E){const f=this.b.get(h);if(f)return await f.provider.removeSession(E);throw new Error(`Unable to find authentication provider with handle: ${h}`)}async $getSessions(h,E,f){const r=this.b.get(h);if(r)return await r.provider.getSessions(E,f);throw new Error(`Unable to find authentication provider with handle: ${h}`)}$onDidChangeAuthenticationSessions(h,E){return h.startsWith(R.$6M)||this.c.fire({provider:{id:h,label:E}}),Promise.resolve()}};e.$Kqc=s,e.$Kqc=s=Ke([We(0,p.$DQ)],s);class I{constructor(){this.a=new Map}getOrCreate(h,E){const f=this.a.get(h);if(f)return f;const r=E().finally(()=>this.a.delete(h));return this.a.set(h,r),r}}}),define(Re[124],Te([1,0,2,5,7,3,16,11,17,13,22,21]),function(we,e,v,D,P,N,R,O,p,s,I,b){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$Prc=e.$Orc=void 0;let E=class{static{h=this}static{this.c=0}static{this.d=250}constructor(r,l){this.h=l,this.f=new Map,this.g=r.getProxy(D.$3N.MainThreadDecorations)}registerFileDecorationProvider(r,l){const d=h.c++;this.f.set(d,{provider:r,extensionDescription:l}),this.g.$registerDecorationProvider(d,l.identifier.value);const a=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(d,null);return}const n=(0,p.$4b)(i);if(n.length<=h.d){this.g.$onDidChange(d,n);return}this.h.warn("[Decorations] CAPPING events from decorations provider",l.identifier.value,n.length);const t=n.map(m=>({uri:m,rank:(0,s.$lf)(m.path,"/")})),o=(0,p.$Bb)(t,(m,g)=>m.rank-g.rank||(0,s.$Bf)(m.uri.path,g.uri.path)),c=[];e:for(const m of o){let g;for(const u of m){const S=(0,I.$pc)(u.uri.path);if(g!==S&&(g=S,c.push(u.uri)>=h.d))break e}}this.g.$onDidChange(d,c)});return new P.$5N(()=>{a?.dispose(),this.g.$unregisterDecorationProvider(d),this.f.delete(d)})}async $provideDecorations(r,l,d){if(!this.f.has(r))return Object.create(null);const a=Object.create(null),{provider:i,extensionDescription:n}=this.f.get(r);return await Promise.all(l.map(async t=>{try{const{uri:o,id:c}=t,m=await Promise.resolve(i.provideFileDecoration(v.URI.revive(o),d));if(!m)return;try{P.$uP.validate(m),m.badge&&typeof m.badge!="string"&&(0,b.$wH)(n,"codiconDecoration"),a[c]=[m.propagate,m.tooltip,m.badge,m.color]}catch(g){this.h.warn(`INVALID decoration from extension '${n.identifier.value}': ${g}`)}}catch(o){this.h.error(o)}})),a}};e.$Orc=E,e.$Orc=E=h=Ke([We(0,R.$DQ),We(1,O.$dk)],E),e.$Prc=(0,N.$Ii)("IExtHostDecorations")}),define(Re[227],Te([1,0,12,2,7,5,15,19,13]),function(we,e,v,D,P,N,R,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rrc=void 0;class s{static{this.a=0}constructor(b,h,E){this.d=h,this.e=E,this.b=new Map,this.c=b.getProxy(N.$3N.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(b,h){if(Object.keys(R.Schemas).indexOf(b)>=0)throw new Error(`scheme '${b}' already registered`);const E=s.a++;this.b.set(E,h),this.c.$registerTextContentProvider(E,b);let f;if(typeof h.onDidChange=="function"){let r;f=h.onDidChange(async l=>{if(l.scheme!==b){this.e.warn(`Provider for scheme '${b}' is firing event for schema '${l.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(l))return;r&&await r;const d=this.$provideTextDocumentContent(E,l).then(async a=>{if(!a&&typeof a!="string")return;const i=this.d.getDocument(l);if(!i)return;const n=(0,p.$vf)(a);if(!i.equalLines(n))return this.c.$onVirtualDocumentChange(l,a)}).catch(v.$2).finally(()=>{r===d&&(r=void 0)});r=d})}return new P.$5N(()=>{this.b.delete(E)&&this.c.$unregisterTextContentProvider(E),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(b,h){const E=this.b.get(b);return E?Promise.resolve(E.provideTextDocumentContent(D.URI.revive(h),O.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${h.scheme}`))}}e.$Rrc=s}),define(Re[125],Te([1,0,61,15,13,284,169,7,17]),function(we,e,v,D,P,N,R,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HQ=e.$GQ=void 0,e.$FQ=I;const s=new Map;function I(f,r){r?s.set(f,r):s.delete(f)}function b(f){return s.get(f)}class h extends N.$ww{constructor(r,l,d,a,i,n,t){super(l,d,a,i),this.o=r,this.p=n,this.q=t,this.n=!1}dispose(){(0,v.ok)(!this.n),this.n=!0,this.q=!1}equalLines(r){return(0,p.$wb)(this.b,r)}get document(){if(!this.m){const r=this;this.m={get uri(){return r.a},get fileName(){return r.a.fsPath},get isUntitled(){return r.a.scheme===D.Schemas.untitled},get languageId(){return r.p},get version(){return r.d},get isClosed(){return r.n},get isDirty(){return r.q},save(){return r.r()},getText(l){return l?r.s(l):r.getText()},get eol(){return r.c===`
`?O.EndOfLine.LF:O.EndOfLine.CRLF},get lineCount(){return r.b.length},lineAt(l){return r.t(l)},offsetAt(l){return r.u(l)},positionAt(l){return r.v(l)},validateRange(l){return r.w(l)},validatePosition(l){return r.x(l)},getWordRangeAtPosition(l,d){return r.y(l,d)},[Symbol.for("debug.description")](){return`TextDocument(${r.a.toString()})`}}}return Object.freeze(this.m)}_acceptLanguageId(r){(0,v.ok)(!this.n),this.p=r}_acceptIsDirty(r){(0,v.ok)(!this.n),this.q=r}r(){return this.n?Promise.reject(new Error("Document has been closed")):this.o.$trySaveDocument(this.a)}s(r){const l=this.w(r);if(l.isEmpty)return"";if(l.isSingleLine)return this.b[l.start.line].substring(l.start.character,l.end.character);const d=this.c,a=l.start.line,i=l.end.line,n=[];n.push(this.b[a].substring(l.start.character));for(let t=a+1;t<i;t++)n.push(this.b[t]);return n.push(this.b[i].substring(0,l.end.character)),n.join(d)}t(r){let l;if(r instanceof O.$6N?l=r.line:typeof r=="number"&&(l=r),typeof l!="number"||l<0||l>=this.b.length||Math.floor(l)!==l)throw new Error("Illegal value for `line`");return new E(l,this.b[l],l===this.b.length-1)}u(r){return r=this.x(r),this.h(),this.f.getPrefixSum(r.line-1)+r.character}v(r){r=Math.floor(r),r=Math.max(0,r),this.h();const l=this.f.getIndexOf(r),d=this.b[l.index].length;return new O.$6N(l.index,Math.min(l.remainder,d))}w(r){if(!(r instanceof O.$7N))throw new Error("Invalid argument");const l=this.x(r.start),d=this.x(r.end);return l===r.start&&d===r.end?r:new O.$7N(l.line,l.character,d.line,d.character)}x(r){if(!(r instanceof O.$6N))throw new Error("Invalid argument");if(this.b.length===0)return r.with(0,0);let{line:l,character:d}=r,a=!1;if(l<0)l=0,d=0,a=!0;else if(l>=this.b.length)l=this.b.length-1,d=this.b[l].length,a=!0;else{const i=this.b[l].length;d<0?(d=0,a=!0):d>i&&(d=i,a=!0)}return a?new O.$6N(l,d):r}y(r,l){const d=this.x(r);if(!l)l=b(this.p);else if((0,P.$uf)(l))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${l.source}' because it matches the empty string.`);const a=(0,R.$wt)(d.character+1,(0,R.$ut)(l),this.b[d.line],0);if(a)return new O.$7N(d.line,a.startColumn-1,d.line,a.endColumn-1)}}e.$GQ=h;class E{constructor(r,l,d){this.a=r,this.b=l,this.c=d}get lineNumber(){return this.a}get text(){return this.b}get range(){return new O.$7N(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new O.$7N(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$HQ=E}),define(Re[228],Te([1,0,5,7]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Urc=void 0;class P{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(v.$3N.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,O,p){if(this.a.size===0)throw new Error("No embedding vector providers registered");const s=this.a.get(R);if(!s)throw new Error("Embedding vector provider not found");const I=await s.provideEmbeddingVector(O,p);if(!I)throw new Error("Embedding vector provider returned undefined");return I}registerEmbeddingVectorProvider(R,O,p){const s=this.b;return this.b++,this.a.set(s,p),this.c.$registerAiEmbeddingVectorProvider(O,s),new D.$5N(()=>{this.c.$unregisterAiEmbeddingVectorProvider(s),this.a.delete(s)})}}e.$Urc=P}),define(Re[68],Te([1,0,5,28,7,20,3,16,50,4,10,24,15]),function(we,e,v,D,P,N,R,O,p,s,I,b,h){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$1qc=e.$Zqc=void 0,D=qe(D);let f=E=class{constructor(l,d){this.b=new Map,this.c=new I.$Rh,this.a=l.getProxy(v.$3N.MainThreadFileSystem);const a=this;this.value=Object.freeze({async stat(i){try{let n;const t=a.b.get(i.scheme);return t?(await a.a.$ensureActivation(i.scheme),n=await t.impl.stat(i)):n=await a.a.$stat(i),{type:n.type,ctime:n.ctime,mtime:n.mtime,size:n.size,permissions:n.permissions===D.FilePermission.Readonly?1:void 0}}catch(n){E.e(n)}},async readDirectory(i){try{const n=a.b.get(i.scheme);return n?(await a.a.$ensureActivation(i.scheme),(await n.impl.readDirectory(i)).slice()):await a.a.$readdir(i)}catch(n){return E.e(n)}},async createDirectory(i){try{const n=a.b.get(i.scheme);return n&&!n.isReadonly?(await a.a.$ensureActivation(i.scheme),await a.d(n.impl,n.extUri,i)):await a.a.$mkdir(i)}catch(n){return E.e(n)}},async readFile(i){try{const n=a.b.get(i.scheme);return n?(await a.a.$ensureActivation(i.scheme),(await n.impl.readFile(i)).slice()):(await a.a.$readFile(i)).buffer}catch(n){return E.e(n)}},async writeFile(i,n){try{const t=a.b.get(i.scheme);return t&&!t.isReadonly?(await a.a.$ensureActivation(i.scheme),await a.d(t.impl,t.extUri,t.extUri.dirname(i)),await a.c.queueFor(i,()=>Promise.resolve(t.impl.writeFile(i,n,{create:!0,overwrite:!0})))):await a.a.$writeFile(i,N.$Qe.wrap(n))}catch(t){return E.e(t)}},async delete(i,n){try{const t=a.b.get(i.scheme);return t&&!t.isReadonly&&!n?.useTrash?(await a.a.$ensureActivation(i.scheme),await t.impl.delete(i,{recursive:!1,...n})):await a.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...n})}catch(t){return E.e(t)}},async rename(i,n,t){try{return await a.a.$rename(i,n,{overwrite:!1,...t})}catch(o){return E.e(o)}},async copy(i,n,t){try{return await a.a.$copy(i,n,{overwrite:!1,...t})}catch(o){return E.e(o)}},isWritableFileSystem(i){const n=d.getCapabilities(i);if(typeof n=="number")return!(n&D.FileSystemProviderCapabilities.Readonly)}})}async d(l,d,a){const i=[];for(;!d.isEqual(a,d.dirname(a));)try{if(!((await l.stat(a)).type&D.FileType.Directory))throw P.$lP.FileExists(`Unable to create folder '${a.scheme===h.Schemas.file?a.fsPath:a.toString(!0)}' that already exists but is not a directory`);break}catch(n){if(D.$tl(n)!==D.FileSystemProviderErrorCode.FileNotFound)throw n;i.push(d.basename(a)),a=d.dirname(a)}for(let n=i.length-1;n>=0;n--){a=d.joinPath(a,i[n]);try{await l.createDirectory(a)}catch(t){if(D.$tl(t)!==D.FileSystemProviderErrorCode.FileExists)throw t}}}static e(l){if(l instanceof P.$lP)throw l;if(l instanceof D.$pl)switch(l.code){case D.FileSystemProviderErrorCode.FileExists:throw P.$lP.FileExists(l.message);case D.FileSystemProviderErrorCode.FileNotFound:throw P.$lP.FileNotFound(l.message);case D.FileSystemProviderErrorCode.FileNotADirectory:throw P.$lP.FileNotADirectory(l.message);case D.FileSystemProviderErrorCode.FileIsADirectory:throw P.$lP.FileIsADirectory(l.message);case D.FileSystemProviderErrorCode.NoPermissions:throw P.$lP.NoPermissions(l.message);case D.FileSystemProviderErrorCode.Unavailable:throw P.$lP.Unavailable(l.message);default:throw new P.$lP(l.message,l.name)}if(!(l instanceof Error))throw new P.$lP(String(l));if(l.name==="ENOPRO"||l.message.includes("ENOPRO"))throw P.$lP.Unavailable(l.message);switch(l.name){case D.FileSystemProviderErrorCode.FileExists:throw P.$lP.FileExists(l.message);case D.FileSystemProviderErrorCode.FileNotFound:throw P.$lP.FileNotFound(l.message);case D.FileSystemProviderErrorCode.FileNotADirectory:throw P.$lP.FileNotADirectory(l.message);case D.FileSystemProviderErrorCode.FileIsADirectory:throw P.$lP.FileIsADirectory(l.message);case D.FileSystemProviderErrorCode.NoPermissions:throw P.$lP.NoPermissions(l.message);case D.FileSystemProviderErrorCode.Unavailable:throw P.$lP.Unavailable(l.message);default:throw new P.$lP(l.message,l.name)}}addFileSystemProvider(l,d,a){return this.b.set(l,{impl:d,extUri:a?.isCaseSensitive?b.$_g:b.$bh,isReadonly:!!a?.isReadonly}),(0,s.$Vc)(()=>this.b.delete(l))}getFileSystemProviderExtUri(l){return this.b.get(l)?.extUri??b.$_g}};e.$Zqc=f,e.$Zqc=f=E=Ke([We(0,O.$DQ),We(1,p.$Dqc)],f),e.$1qc=(0,R.$Ii)("IExtHostConsumerFileSystem")}),define(Re[92],Te([1,0,3,26,11,68,2]),function(we,e,v,D,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3qc=e.$2qc=void 0,e.$2qc=(0,v.$Ii)("IExtensionStoragePaths");let O=class{constructor(s,I,b){this.d=I,this.f=b,this.a=s.workspace??void 0,this.b=s.environment,this.whenReady=this.h().then(h=>this.c=h)}async g(s){return R.URI.joinPath(this.b.workspaceStorageHome,s)}async h(){if(!this.a)return Promise.resolve(void 0);const s=this.a.id,I=await this.g(s);try{return await this.f.value.stat(I),this.d.trace("[ExtHostStorage] storage dir already exists",I),I}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",I),await this.f.value.createDirectory(I),await this.f.value.writeFile(R.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),I}catch(b){this.d.error("[ExtHostStorage]",b);return}}workspaceValue(s){if(this.c)return R.URI.joinPath(this.c,s.identifier.value)}globalValue(s){return R.URI.joinPath(this.b.globalStorageHome,s.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$3qc=O,e.$3qc=O=Ke([We(0,D.$TQ),We(1,P.$dk),We(2,N.$1qc)],O)}),define(Re[229],Te([1,0,7,16,6]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Esc=void 0;let N=class{constructor(O){this.a=new v.$vP(v.ColorThemeKind.Dark),this.b=new P.$oe}get activeColorTheme(){return this.a}$onColorThemeChange(O){let p;switch(O){case"light":p=v.ColorThemeKind.Light;break;case"hcDark":p=v.ColorThemeKind.HighContrast;break;case"hcLight":p=v.ColorThemeKind.HighContrastLight;break;default:p=v.ColorThemeKind.Dark}this.a=new v.$vP(p),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Esc=N,e.$Esc=N=Ke([We(0,D.$DQ)],N)}),define(Re[93],Te([1,0,19,6,4,9,3,11,183,5,26,16,7]),function(we,e,v,D,P,N,R,O,p,s,I,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QGb=e.$PGb=e.TunnelDtoConverter=void 0,N=qe(N),h=qe(h);class E extends p.$Vw{}var f;(function(l){function d(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?p.TunnelPrivacyId.Public:p.TunnelPrivacyId.Private),protocol:i.protocol}}l.fromApiTunnel=d;function a(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==p.TunnelPrivacyId.ConstantPrivate&&i.privacy!==p.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}l.fromServiceTunnel=a})(f||(e.TunnelDtoConverter=f={})),e.$PGb=(0,R.$Ii)("IExtHostTunnelService");let r=class extends P.$Xc{constructor(d,a,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new D.$oe,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=d.getProxy(s.$3N.MainThreadTunnelService)}async openTunnel(d,a){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${d.identifier.value} called openTunnel API for ${a.remoteAddress.host}:${a.remoteAddress.port}.`);const i=await this.a.$openTunnel(a,d.displayName);if(i){const n=new E(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(n),n}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(d,a){d.portRange===void 0&&d.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:d,provider:a}),this.a.$registerPortsAttributesProvider(d,i),new h.$5N(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(d,a,i,n,t){const o=[];for(const m of d){const g=this.r.get(m);if(!g)return[];o.push(...await Promise.all(a.map(async u=>{let S;try{S=await g.provider.providePortAttributes({port:u,pid:i,commandLine:n},t)}catch{S=await g.provider.providePortAttributes(u,i,n,t)}return{providedAttributes:S,port:u}})))}const c=o.filter(m=>!!m.providedAttributes);return c.length>0?c.map(m=>({autoForwardAction:m.providedAttributes.autoForwardAction,port:m.port})):[]}async $registerCandidateFinder(d){}registerTunnelProvider(d,a){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(n,t)=>await d.provideTunnel(n,t,v.CancellationToken.None)??void 0;const i=a.tunnelFeatures?{elevation:!!a.tunnelFeatures?.elevation,privacyOptions:a.tunnelFeatures?.privacyOptions,protocol:a.tunnelFeatures.protocol===void 0?!0:a.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,P.$Vc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(d,a){if(d){d.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(d.candidatePortSource),d.showCandidatePort&&(this.f=d.showCandidatePort,this.a.$setCandidateFilter());const i=d.tunnelFactory??(a?this.w(a):void 0);if(i){this.b=i;let n=d.tunnelFeatures?.privacyOptions??[];d.tunnelFeatures?.public&&n.length===0&&(n=[{id:"private",label:N.localize(2716,null),themeIcon:"lock"},{id:"public",label:N.localize(2717,null),themeIcon:"eye"}]);const t=d.tunnelFeatures?{elevation:!!d.tunnelFeatures?.elevation,public:!!d.tunnelFeatures?.public,privacyOptions:n,protocol:!0}:void 0;this.a.$setTunnelProvider(t)}}else this.b=void 0;return(0,P.$Vc)(()=>{this.b=void 0})}w(d){}async $closeTunnel(d,a){if(this.g.has(d.host)){const i=this.g.get(d.host);i.has(d.port)&&(a&&i.get(d.port).disposeListener.dispose(),await i.get(d.port).tunnel.dispose(),i.delete(d.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(d,a){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(d,a);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const n=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),n===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(d.remoteAddress.host)||this.g.set(d.remoteAddress.host,new Map);const t=this.B(n.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(n.remoteAddress))));return this.g.get(d.remoteAddress.host).set(d.remoteAddress.port,{tunnel:n,disposeListener:t}),f.fromApiTunnel(n)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(d){const a=await Promise.all(d.map(n=>this.f(n.host,n.port,n.detail??""))),i=d.filter((n,t)=>a[t]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${d.map(n=>n.port).join(", ")} to ${i.map(n=>n.port).join(", ")}`),i}};e.$QGb=r,e.$QGb=r=Ke([We(0,b.$DQ),We(1,I.$TQ),We(2,O.$dk)],r)}),define(Re[8],Te([1,0,17,20,151,230,59,27,139,33,72,25,145,24,35,14,2,106,32,159,94,52,108,77,118,116,117,206,81,90,54,55,203,7]),function(we,e,v,D,P,N,R,O,p,s,I,b,h,E,f,r,l,d,a,i,n,t,o,c,m,g,u,S,k,y,C,T,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.LanguageModelToolResult=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatLanguageModelToolReference=e.ChatPromptReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseCodeCitationPart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseMovePart=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$AQ=re,e.$BQ=x,e.$CQ=$e,R=qe(R),p=qe(p),a=qe(a),i=qe(i),n=qe(n),S=qe(S),y=qe(y),w=qe(w);var M;(function(me){function De(K){const{selectionStartLineNumber:ke,selectionStartColumn:ze,positionLineNumber:Ze,positionColumn:Ve}=K,ft=new w.$6N(ke-1,ze-1),Tt=new w.$6N(Ze-1,Ve-1);return new w.$8N(ft,Tt)}me.to=De;function ae(K){const{anchor:ke,active:ze}=K;return{selectionStartLineNumber:ke.line+1,selectionStartColumn:ke.character+1,positionLineNumber:ze.line+1,positionColumn:ze.character+1}}me.from=ae})(M||(e.Selection=M={}));var A;(function(me){function De(K){if(!K)return;const{start:ke,end:ze}=K;return{startLineNumber:ke.line+1,startColumn:ke.character+1,endLineNumber:ze.line+1,endColumn:ze.character+1}}me.from=De;function ae(K){if(!K)return;const{startLineNumber:ke,startColumn:ze,endLineNumber:Ze,endColumn:Ve}=K;return new w.$7N(ke-1,ze-1,Ze-1,Ve-1)}me.to=ae})(A||(e.Range=A={}));var L;(function(me){function De(K){return{uri:K.uri,range:A.from(K.range)}}me.from=De;function ae(K){return new w.$gO(l.URI.revive(K.uri),A.to(K.range))}me.to=ae})(L||(e.Location=L={}));var J;(function(me){function De(ae){switch(ae){case i.StandardTokenType.Comment:return w.StandardTokenType.Comment;case i.StandardTokenType.Other:return w.StandardTokenType.Other;case i.StandardTokenType.RegEx:return w.StandardTokenType.RegEx;case i.StandardTokenType.String:return w.StandardTokenType.String}}me.to=De})(J||(e.TokenType=J={}));var Y;(function(me){function De(K){return new w.$6N(K.lineNumber-1,K.column-1)}me.to=De;function ae(K){return{lineNumber:K.line+1,column:K.character+1}}me.from=ae})(Y||(e.Position=Y={}));var z;(function(me){function De(ke,ze,Ze){return(0,v.$Jb)((0,v.$4b)(ke).map(Ve=>ae(Ve,ze,Ze)))}me.from=De;function ae(ke,ze,Ze){if(typeof ke=="string")return{$serialized:!0,language:ke,isBuiltin:Ze?.isBuiltin};if(ke)return{$serialized:!0,language:ke.language,scheme:K(ke.scheme,ze),pattern:Qe.from(ke.pattern)??void 0,exclusive:ke.exclusive,notebookType:ke.notebookType,isBuiltin:Ze?.isBuiltin}}function K(ke,ze){return ze&&typeof ke=="string"?ze.transformOutgoingScheme(ke):ke}})(z||(e.DocumentSelector=z={}));var Q;(function(me){function De(K){switch(K){case w.DiagnosticTag.Unnecessary:return o.MarkerTag.Unnecessary;case w.DiagnosticTag.Deprecated:return o.MarkerTag.Deprecated}}me.from=De;function ae(K){switch(K){case o.MarkerTag.Unnecessary:return w.DiagnosticTag.Unnecessary;case o.MarkerTag.Deprecated:return w.DiagnosticTag.Deprecated;default:return}}me.to=ae})(Q||(e.DiagnosticTag=Q={}));var V;(function(me){function De(K){let ke;return K.code&&((0,r.$hg)(K.code)||(0,r.$lg)(K.code)?ke=String(K.code):ke={value:String(K.code.value),target:K.code.target}),{...A.from(K.range),message:K.message,source:K.source,code:ke,severity:le.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(ie.from),tags:Array.isArray(K.tags)?(0,v.$Jb)(K.tags.map(Q.from)):void 0}}me.from=De;function ae(K){const ke=new w.$iO(A.to(K),K.message,le.to(K.severity));return ke.source=K.source,ke.code=(0,r.$hg)(K.code)?K.code:K.code?.value,ke.relatedInformation=K.relatedInformation&&K.relatedInformation.map(ie.to),ke.tags=K.tags&&(0,v.$Jb)(K.tags.map(Q.to)),ke}me.to=ae})(V||(e.Diagnostic=V={}));var ie;(function(me){function De(K){return{...A.from(K.location.range),message:K.message,resource:K.location.uri}}me.from=De;function ae(K){return new w.$hO(new w.$gO(K.resource,A.to(K)),K.message)}me.to=ae})(ie||(e.DiagnosticRelatedInformation=ie={}));var le;(function(me){function De(K){switch(K){case w.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case w.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case w.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case w.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}me.from=De;function ae(K){switch(K){case o.MarkerSeverity.Info:return w.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return w.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return w.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return w.DiagnosticSeverity.Hint;default:return w.DiagnosticSeverity.Error}}me.to=ae})(le||(e.DiagnosticSeverity=le={}));var _;(function(me){function De(K){return typeof K=="number"&&K>=w.ViewColumn.One?K-1:K===w.ViewColumn.Beside?$.$PE:$.$OE}me.from=De;function ae(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}me.to=ae})(_||(e.ViewColumn=_={}));function oe(me){return typeof me.range<"u"}function re(me){return me.length===0?!0:!!oe(me[0])}var ce;(function(me){function De(Ve){return Ve.map(me.from)}me.fromMany=De;function ae(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function K(Ve){let ft;if(ae(Ve)){const{language:Vt,value:Wt}=Ve;ft={value:"```"+Vt+`
`+Wt+"\n```\n"}}else w.$wO.isMarkdownString(Ve)?ft={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons,supportHtml:Ve.supportHtml,baseUri:Ve.baseUri}:typeof Ve=="string"?ft={value:Ve}:ft={value:""};const Tt=Object.create(null);ft.uris=Tt;const Yt=({href:Vt})=>{try{let Wt=l.URI.parse(Vt,!0);Wt=Wt.with({query:ke(Wt.query,Tt)}),Tt[Vt]=Wt}catch{}return""};return p.marked.walkTokens(p.marked.lexer(ft.value),Vt=>{Vt.type==="link"?Yt({href:Vt.href}):Vt.type==="image"&&typeof Vt.href=="string"&&Yt(R.$cl(Vt.href))}),ft}me.from=K;function ke(Ve,ft){if(!Ve)return Ve;let Tt;try{Tt=(0,s.$ei)(Ve)}catch{}if(!Tt)return Ve;let Yt=!1;return Tt=(0,b.$ko)(Tt,Vt=>{if(l.URI.isUri(Vt)){const Wt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ft[Wt]=Vt,Yt=!0,Wt}else return}),Yt?JSON.stringify(Tt):Ve}function ze(Ve){const ft=new w.$wO(Ve.value,Ve.supportThemeIcons);return ft.isTrusted=Ve.isTrusted,ft.supportHtml=Ve.supportHtml,ft.baseUri=Ve.baseUri?l.URI.from(Ve.baseUri):void 0,ft}me.to=ze;function Ze(Ve){if(Ve)return typeof Ve=="string"?Ve:me.from(Ve)}me.fromStrict=Ze})(ce||(e.MarkdownString=ce={}));function x(me){return re(me)?me.map(De=>({range:A.from(De.range),hoverMessage:Array.isArray(De.hoverMessage)?ce.fromMany(De.hoverMessage):De.hoverMessage?ce.from(De.hoverMessage):void 0,renderOptions:De.renderOptions})):me.map(De=>({range:A.from(De)}))}function $e(me){return typeof me>"u"?me:typeof me=="string"?l.URI.file(me):me}var Pe;(function(me){function De(ae){return typeof ae>"u"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?$e(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}me.from=De})(Pe||(e.ThemableDecorationAttachmentRenderOptions=Pe={}));var X;(function(me){function De(ae){return typeof ae>"u"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?$e(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?Pe.from(ae.before):void 0,after:ae.after?Pe.from(ae.after):void 0}}me.from=De})(X||(e.ThemableDecorationRenderOptions=X={}));var q;(function(me){function De(ae){if(typeof ae>"u")return ae;switch(ae){case w.DecorationRangeBehavior.OpenOpen:return t.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case w.DecorationRangeBehavior.ClosedClosed:return t.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case w.DecorationRangeBehavior.OpenClosed:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case w.DecorationRangeBehavior.ClosedOpen:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}me.from=De})(q||(e.DecorationRangeBehavior=q={}));var ne;(function(me){function De(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?q.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?X.from(ae.light):void 0,dark:ae.dark?X.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?$e(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?Pe.from(ae.before):void 0,after:ae.after?Pe.from(ae.after):void 0}}me.from=De})(ne||(e.DecorationRenderOptions=ne={}));var be;(function(me){function De(K){return{text:K.newText,eol:K.newEol&&ve.from(K.newEol),range:A.from(K.range)}}me.from=De;function ae(K){const ke=new w.$bO(A.to(K.range),K.text);return ke.newEol=typeof K.eol>"u"?void 0:ve.to(K.eol),ke}me.to=ae})(be||(e.TextEdit=be={}));var Ie;(function(me){function De(K,ke){const ze={edits:[]};if(K instanceof w.$eO){const Ze=new O.$Ec;for(const Ve of K._allEntries())Ve._type===w.FileEditType.File&&l.URI.isUri(Ve.to)&&Ve.from===void 0&&Ze.add(Ve.to);for(const Ve of K._allEntries())if(Ve._type===w.FileEditType.File){let ft;Ve.options?.contents&&(ArrayBuffer.isView(Ve.options.contents)?ft={type:"base64",value:(0,D.$$e)(D.$Qe.wrap(Ve.options.contents))}:ft={type:"dataTransferItem",id:Ve.options.contents._itemId}),ze.edits.push({oldResource:Ve.from,newResource:Ve.to,options:{...Ve.options,contents:ft},metadata:Ve.metadata})}else Ve._type===w.FileEditType.Text?ze.edits.push({resource:Ve.uri,textEdit:be.from(Ve.edit),versionId:Ze.has(Ve.uri)?void 0:ke?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===w.FileEditType.Snippet?ze.edits.push({resource:Ve.uri,textEdit:{range:A.from(Ve.range),text:Ve.edit.value,insertAsSnippet:!0},versionId:Ze.has(Ve.uri)?void 0:ke?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===w.FileEditType.Cell?ze.edits.push({metadata:Ve.metadata,resource:Ve.uri,cellEdit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:ke?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===w.FileEditType.CellReplace&&ze.edits.push({metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:ke?.getNotebookDocumentVersion(Ve.uri),cellEdit:{editType:y.CellEditType.Replace,index:Ve.index,count:Ve.count,cells:Ve.cells.map(Xe.from)}})}return ze}me.from=De;function ae(K){const ke=new w.$eO,ze=new O.$Dc;for(const Ze of K.edits)if(Ze.textEdit){const Ve=Ze,ft=l.URI.revive(Ve.resource),Tt=A.to(Ve.textEdit.range),Yt=Ve.textEdit.text,Vt=Ve.textEdit.insertAsSnippet;let Wt;Vt?Wt=w.$dO.replace(Tt,new w.$fO(Yt)):Wt=w.$bO.replace(Tt,Yt);const Ni=ze.get(ft);Ni?Ni.push(Wt):ze.set(ft,[Wt])}else ke.renameFile(l.URI.revive(Ze.oldResource),l.URI.revive(Ze.newResource),Ze.options);for(const[Ze,Ve]of ze)ke.set(Ze,Ve);return ke}me.to=ae})(Ie||(e.WorkspaceEdit=Ie={}));var Fe;(function(me){const De=Object.create(null);De[w.SymbolKind.File]=n.SymbolKind.File,De[w.SymbolKind.Module]=n.SymbolKind.Module,De[w.SymbolKind.Namespace]=n.SymbolKind.Namespace,De[w.SymbolKind.Package]=n.SymbolKind.Package,De[w.SymbolKind.Class]=n.SymbolKind.Class,De[w.SymbolKind.Method]=n.SymbolKind.Method,De[w.SymbolKind.Property]=n.SymbolKind.Property,De[w.SymbolKind.Field]=n.SymbolKind.Field,De[w.SymbolKind.Constructor]=n.SymbolKind.Constructor,De[w.SymbolKind.Enum]=n.SymbolKind.Enum,De[w.SymbolKind.Interface]=n.SymbolKind.Interface,De[w.SymbolKind.Function]=n.SymbolKind.Function,De[w.SymbolKind.Variable]=n.SymbolKind.Variable,De[w.SymbolKind.Constant]=n.SymbolKind.Constant,De[w.SymbolKind.String]=n.SymbolKind.String,De[w.SymbolKind.Number]=n.SymbolKind.Number,De[w.SymbolKind.Boolean]=n.SymbolKind.Boolean,De[w.SymbolKind.Array]=n.SymbolKind.Array,De[w.SymbolKind.Object]=n.SymbolKind.Object,De[w.SymbolKind.Key]=n.SymbolKind.Key,De[w.SymbolKind.Null]=n.SymbolKind.Null,De[w.SymbolKind.EnumMember]=n.SymbolKind.EnumMember,De[w.SymbolKind.Struct]=n.SymbolKind.Struct,De[w.SymbolKind.Event]=n.SymbolKind.Event,De[w.SymbolKind.Operator]=n.SymbolKind.Operator,De[w.SymbolKind.TypeParameter]=n.SymbolKind.TypeParameter;function ae(ke){return typeof De[ke]=="number"?De[ke]:n.SymbolKind.Property}me.from=ae;function K(ke){for(const ze in De)if(De[ze]===ke)return Number(ze);return w.SymbolKind.Property}me.to=K})(Fe||(e.SymbolKind=Fe={}));var Be;(function(me){function De(K){switch(K){case w.SymbolTag.Deprecated:return n.SymbolTag.Deprecated}}me.from=De;function ae(K){switch(K){case n.SymbolTag.Deprecated:return w.SymbolTag.Deprecated}}me.to=ae})(Be||(e.SymbolTag=Be={}));var xe;(function(me){function De(K){return{name:K.name,kind:Fe.from(K.kind),tags:K.tags&&K.tags.map(Be.from),containerName:K.containerName,location:et.from(K.location)}}me.from=De;function ae(K){const ke=new w.$nO(K.name,Fe.to(K.kind),K.containerName,et.to(K.location));return ke.tags=K.tags&&K.tags.map(Be.to),ke}me.to=ae})(xe||(e.WorkspaceSymbol=xe={}));var nt;(function(me){function De(K){const ke={name:K.name||"!!MISSING: name!!",detail:K.detail,range:A.from(K.range),selectionRange:A.from(K.selectionRange),kind:Fe.from(K.kind),tags:K.tags?.map(Be.from)??[]};return K.children&&(ke.children=K.children.map(De)),ke}me.from=De;function ae(K){const ke=new w.$oO(K.name,K.detail,Fe.to(K.kind),A.to(K.range),A.to(K.selectionRange));return(0,v.$Nb)(K.tags)&&(ke.tags=K.tags.map(Be.to)),K.children&&(ke.children=K.children.map(ae)),ke}me.to=ae})(nt||(e.DocumentSymbol=nt={}));var ut;(function(me){function De(K){const ke=new w.$sO(Fe.to(K.kind),K.name,K.detail||"",l.URI.revive(K.uri),A.to(K.range),A.to(K.selectionRange));return ke._sessionId=K._sessionId,ke._itemId=K._itemId,ke}me.to=De;function ae(K,ke,ze){if(ke=ke??K._sessionId,ze=ze??K._itemId,ke===void 0||ze===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:ze,name:K.name,detail:K.detail,kind:Fe.from(K.kind),uri:K.uri,range:A.from(K.range),selectionRange:A.from(K.selectionRange),tags:K.tags?.map(Be.from)}}me.from=ae})(ut||(e.CallHierarchyItem=ut={}));var pt;(function(me){function De(ae){return new w.$tO(ut.to(ae.from),ae.fromRanges.map(K=>A.to(K)))}me.to=De})(pt||(e.CallHierarchyIncomingCall=pt={}));var lt;(function(me){function De(ae){return new w.$uO(ut.to(ae.to),ae.fromRanges.map(K=>A.to(K)))}me.to=De})(lt||(e.CallHierarchyOutgoingCall=lt={}));var et;(function(me){function De(K){return{range:K.range&&A.from(K.range),uri:K.uri}}me.from=De;function ae(K){return new w.$gO(l.URI.revive(K.uri),A.to(K.range))}me.to=ae})(et||(e.location=et={}));var Ne;(function(me){function De(K){const ke=K,ze=K;return{originSelectionRange:ke.originSelectionRange?A.from(ke.originSelectionRange):void 0,uri:ke.targetUri?ke.targetUri:ze.uri,range:A.from(ke.targetRange?ke.targetRange:ze.range),targetSelectionRange:ke.targetSelectionRange?A.from(ke.targetSelectionRange):void 0}}me.from=De;function ae(K){return{targetUri:l.URI.revive(K.uri),targetRange:A.to(K.range),targetSelectionRange:K.targetSelectionRange?A.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?A.to(K.originSelectionRange):void 0}}me.to=ae})(Ne||(e.DefinitionLink=Ne={}));var Me;(function(me){function De(K){return{range:A.from(K.range),contents:ce.fromMany(K.contents),canIncreaseVerbosity:K.canIncreaseVerbosity,canDecreaseVerbosity:K.canDecreaseVerbosity}}me.from=De;function ae(K){const ke=K.contents.map(ce.to),ze=A.to(K.range),Ze=K.canIncreaseVerbosity,Ve=K.canDecreaseVerbosity;return new w.$kO(ke,ze,Ze,Ve)}me.to=ae})(Me||(e.Hover=Me={}));var Le;(function(me){function De(K){return{range:A.from(K.range),expression:K.expression}}me.from=De;function ae(K){return new w.$fP(A.to(K.range),K.expression)}me.to=ae})(Le||(e.EvaluatableExpression=Le={}));var B;(function(me){function De(K){if(K instanceof w.$gP)return{type:"text",range:A.from(K.range),text:K.text};if(K instanceof w.$hP)return{type:"variable",range:A.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof w.$iP)return{type:"expression",range:A.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}me.from=De;function ae(K){switch(K.type){case"text":return{range:A.to(K.range),text:K.text};case"variable":return{range:A.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:A.to(K.range),expression:K.expression}}}me.to=ae})(B||(e.InlineValue=B={}));var j;(function(me){function De(K){return{frameId:K.frameId,stoppedLocation:A.from(K.stoppedLocation)}}me.from=De;function ae(K){return new w.$jP(K.frameId,A.to(K.stoppedLocation))}me.to=ae})(j||(e.InlineValueContext=j={}));var H;(function(me){function De(K){return{range:A.from(K.range),kind:K.kind}}me.from=De;function ae(K){return new w.$lO(A.to(K.range),K.kind)}me.to=ae})(H||(e.DocumentHighlight=H={}));var G;(function(me){function De(K){return{uri:K.uri,highlights:K.highlights.map(H.from)}}me.from=De;function ae(K){return new w.$mO(l.URI.revive(K.uri),K.highlights.map(H.to))}me.to=ae})(G||(e.MultiDocumentHighlight=G={}));var se;(function(me){function De(ae){switch(ae){case n.CompletionTriggerKind.TriggerCharacter:return w.CompletionTriggerKind.TriggerCharacter;case n.CompletionTriggerKind.TriggerForIncompleteCompletions:return w.CompletionTriggerKind.TriggerForIncompleteCompletions;case n.CompletionTriggerKind.Invoke:default:return w.CompletionTriggerKind.Invoke}}me.to=De})(se||(e.CompletionTriggerKind=se={}));var ge;(function(me){function De(ae){return{triggerKind:se.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}me.to=De})(ge||(e.CompletionContext=ge={}));var Ee;(function(me){function De(K){switch(K){case w.CompletionItemTag.Deprecated:return n.CompletionItemTag.Deprecated}}me.from=De;function ae(K){switch(K){case n.CompletionItemTag.Deprecated:return w.CompletionItemTag.Deprecated}}me.to=ae})(Ee||(e.CompletionItemTag=Ee={}));var Ue;(function(me){const De=new Map([[w.CompletionItemKind.Method,n.CompletionItemKind.Method],[w.CompletionItemKind.Function,n.CompletionItemKind.Function],[w.CompletionItemKind.Constructor,n.CompletionItemKind.Constructor],[w.CompletionItemKind.Field,n.CompletionItemKind.Field],[w.CompletionItemKind.Variable,n.CompletionItemKind.Variable],[w.CompletionItemKind.Class,n.CompletionItemKind.Class],[w.CompletionItemKind.Interface,n.CompletionItemKind.Interface],[w.CompletionItemKind.Struct,n.CompletionItemKind.Struct],[w.CompletionItemKind.Module,n.CompletionItemKind.Module],[w.CompletionItemKind.Property,n.CompletionItemKind.Property],[w.CompletionItemKind.Unit,n.CompletionItemKind.Unit],[w.CompletionItemKind.Value,n.CompletionItemKind.Value],[w.CompletionItemKind.Constant,n.CompletionItemKind.Constant],[w.CompletionItemKind.Enum,n.CompletionItemKind.Enum],[w.CompletionItemKind.EnumMember,n.CompletionItemKind.EnumMember],[w.CompletionItemKind.Keyword,n.CompletionItemKind.Keyword],[w.CompletionItemKind.Snippet,n.CompletionItemKind.Snippet],[w.CompletionItemKind.Text,n.CompletionItemKind.Text],[w.CompletionItemKind.Color,n.CompletionItemKind.Color],[w.CompletionItemKind.File,n.CompletionItemKind.File],[w.CompletionItemKind.Reference,n.CompletionItemKind.Reference],[w.CompletionItemKind.Folder,n.CompletionItemKind.Folder],[w.CompletionItemKind.Event,n.CompletionItemKind.Event],[w.CompletionItemKind.Operator,n.CompletionItemKind.Operator],[w.CompletionItemKind.TypeParameter,n.CompletionItemKind.TypeParameter],[w.CompletionItemKind.Issue,n.CompletionItemKind.Issue],[w.CompletionItemKind.User,n.CompletionItemKind.User]]);function ae(ze){return De.get(ze)??n.CompletionItemKind.Property}me.from=ae;const K=new Map([[n.CompletionItemKind.Method,w.CompletionItemKind.Method],[n.CompletionItemKind.Function,w.CompletionItemKind.Function],[n.CompletionItemKind.Constructor,w.CompletionItemKind.Constructor],[n.CompletionItemKind.Field,w.CompletionItemKind.Field],[n.CompletionItemKind.Variable,w.CompletionItemKind.Variable],[n.CompletionItemKind.Class,w.CompletionItemKind.Class],[n.CompletionItemKind.Interface,w.CompletionItemKind.Interface],[n.CompletionItemKind.Struct,w.CompletionItemKind.Struct],[n.CompletionItemKind.Module,w.CompletionItemKind.Module],[n.CompletionItemKind.Property,w.CompletionItemKind.Property],[n.CompletionItemKind.Unit,w.CompletionItemKind.Unit],[n.CompletionItemKind.Value,w.CompletionItemKind.Value],[n.CompletionItemKind.Constant,w.CompletionItemKind.Constant],[n.CompletionItemKind.Enum,w.CompletionItemKind.Enum],[n.CompletionItemKind.EnumMember,w.CompletionItemKind.EnumMember],[n.CompletionItemKind.Keyword,w.CompletionItemKind.Keyword],[n.CompletionItemKind.Snippet,w.CompletionItemKind.Snippet],[n.CompletionItemKind.Text,w.CompletionItemKind.Text],[n.CompletionItemKind.Color,w.CompletionItemKind.Color],[n.CompletionItemKind.File,w.CompletionItemKind.File],[n.CompletionItemKind.Reference,w.CompletionItemKind.Reference],[n.CompletionItemKind.Folder,w.CompletionItemKind.Folder],[n.CompletionItemKind.Event,w.CompletionItemKind.Event],[n.CompletionItemKind.Operator,w.CompletionItemKind.Operator],[n.CompletionItemKind.TypeParameter,w.CompletionItemKind.TypeParameter],[n.CompletionItemKind.User,w.CompletionItemKind.User],[n.CompletionItemKind.Issue,w.CompletionItemKind.Issue]]);function ke(ze){return K.get(ze)??w.CompletionItemKind.Property}me.to=ke})(Ue||(e.CompletionItemKind=Ue={}));var Je;(function(me){function De(ae,K){const ke=new w.$CO(ae.label);return ke.insertText=ae.insertText,ke.kind=Ue.to(ae.kind),ke.tags=ae.tags?.map(Ee.to),ke.detail=ae.detail,ke.documentation=R.$9k(ae.documentation)?ce.to(ae.documentation):ae.documentation,ke.sortText=ae.sortText,ke.filterText=ae.filterText,ke.preselect=ae.preselect,ke.commitCharacters=ae.commitCharacters,a.$Ut.isIRange(ae.range)?ke.range=A.to(ae.range):typeof ae.range=="object"&&(ke.range={inserting:A.to(ae.range.insert),replacing:A.to(ae.range.replace)}),ke.keepWhitespace=typeof ae.insertTextRules>"u"?!1:!!(ae.insertTextRules&n.CompletionItemInsertTextRule.KeepWhitespace),typeof ae.insertTextRules<"u"&&ae.insertTextRules&n.CompletionItemInsertTextRule.InsertAsSnippet?ke.insertText=new w.$fO(ae.insertText):(ke.insertText=ae.insertText,ke.textEdit=ke.range instanceof w.$7N?new w.$bO(ke.range,ke.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(ke.additionalTextEdits=ae.additionalTextEdits.map(ze=>be.to(ze))),ke.command=K&&ae.command?K.fromInternal(ae.command):void 0,ke}me.to=De})(Je||(e.CompletionItem=Je={}));var _e;(function(me){function De(K){if(typeof K.label!="string"&&!Array.isArray(K.label))throw new TypeError("Invalid label");return{label:K.label,documentation:ce.fromStrict(K.documentation)}}me.from=De;function ae(K){return{label:K.label,documentation:R.$9k(K.documentation)?ce.to(K.documentation):K.documentation}}me.to=ae})(_e||(e.ParameterInformation=_e={}));var tt;(function(me){function De(K){return{label:K.label,documentation:ce.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(_e.from):[],activeParameter:K.activeParameter}}me.from=De;function ae(K){return{label:K.label,documentation:R.$9k(K.documentation)?ce.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(_e.to):[],activeParameter:K.activeParameter}}me.to=ae})(tt||(e.SignatureInformation=tt={}));var at;(function(me){function De(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(tt.from):[]}}me.from=De;function ae(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(tt.to):[]}}me.to=ae})(at||(e.SignatureHelp=at={}));var it;(function(me){function De(ae,K){const ke=new w.$BO(Y.to(K.position),typeof K.label=="string"?K.label:K.label.map(ot.to.bind(void 0,ae)),K.kind&&vt.to(K.kind));return ke.textEdits=K.textEdits&&K.textEdits.map(be.to),ke.tooltip=R.$9k(K.tooltip)?ce.to(K.tooltip):K.tooltip,ke.paddingLeft=K.paddingLeft,ke.paddingRight=K.paddingRight,ke}me.to=De})(it||(e.InlayHint=it={}));var ot;(function(me){function De(ae,K){const ke=new w.$AO(K.label);return ke.tooltip=R.$9k(K.tooltip)?ce.to(K.tooltip):K.tooltip,n.Command.is(K.command)&&(ke.command=ae.fromInternal(K.command)),K.location&&(ke.location=et.to(K.location)),ke}me.to=De})(ot||(e.InlayHintLabelPart=ot={}));var vt;(function(me){function De(K){return K}me.from=De;function ae(K){return K}me.to=ae})(vt||(e.InlayHintKind=vt={}));var Ye;(function(me){function De(K){return{range:A.from(K.range),url:K.target,tooltip:K.tooltip}}me.from=De;function ae(K){let ke;if(K.url)try{ke=typeof K.url=="string"?l.URI.parse(K.url,!0):l.URI.revive(K.url)}catch{}const ze=new w.$HO(A.to(K.range),ke);return ze.tooltip=K.tooltip,ze}me.to=ae})(Ye||(e.DocumentLink=Ye={}));var he;(function(me){function De(K){const ke=new w.$KO(K.label);return K.textEdit&&(ke.textEdit=be.to(K.textEdit)),K.additionalTextEdits&&(ke.additionalTextEdits=K.additionalTextEdits.map(ze=>be.to(ze))),ke}me.to=De;function ae(K){return{label:K.label,textEdit:K.textEdit?be.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(ke=>be.from(ke)):void 0}}me.from=ae})(he||(e.ColorPresentation=he={}));var pe;(function(me){function De(K){return new w.$IO(K[0],K[1],K[2],K[3])}me.to=De;function ae(K){return[K.red,K.green,K.blue,K.alpha]}me.from=ae})(pe||(e.Color=pe={}));var ye;(function(me){function De(K){return{range:A.from(K.range)}}me.from=De;function ae(K){return new w.$rO(A.to(K.range))}me.to=ae})(ye||(e.SelectionRange=ye={}));var Ce;(function(me){function De(ae){switch(ae){case g.SaveReason.AUTO:return w.TextDocumentSaveReason.AfterDelay;case g.SaveReason.EXPLICIT:return w.TextDocumentSaveReason.Manual;case g.SaveReason.FOCUS_CHANGE:case g.SaveReason.WINDOW_CHANGE:return w.TextDocumentSaveReason.FocusOut}}me.to=De})(Ce||(e.TextDocumentSaveReason=Ce={}));var fe;(function(me){function De(K){switch(K){case w.TextEditorLineNumbersStyle.Off:return d.RenderLineNumbersType.Off;case w.TextEditorLineNumbersStyle.Relative:return d.RenderLineNumbersType.Relative;case w.TextEditorLineNumbersStyle.Interval:return d.RenderLineNumbersType.Interval;case w.TextEditorLineNumbersStyle.On:default:return d.RenderLineNumbersType.On}}me.from=De;function ae(K){switch(K){case d.RenderLineNumbersType.Off:return w.TextEditorLineNumbersStyle.Off;case d.RenderLineNumbersType.Relative:return w.TextEditorLineNumbersStyle.Relative;case d.RenderLineNumbersType.Interval:return w.TextEditorLineNumbersStyle.Interval;case d.RenderLineNumbersType.On:default:return w.TextEditorLineNumbersStyle.On}}me.to=ae})(fe||(e.TextEditorLineNumbersStyle=fe={}));var ve;(function(me){function De(K){if(K===w.EndOfLine.CRLF)return t.EndOfLineSequence.CRLF;if(K===w.EndOfLine.LF)return t.EndOfLineSequence.LF}me.from=De;function ae(K){if(K===t.EndOfLineSequence.CRLF)return w.EndOfLine.CRLF;if(K===t.EndOfLineSequence.LF)return w.EndOfLine.LF}me.to=ae})(ve||(e.EndOfLine=ve={}));var Z;(function(me){function De(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case w.ProgressLocation.SourceControl:return c.ProgressLocation.Scm;case w.ProgressLocation.Window:return c.ProgressLocation.Window;case w.ProgressLocation.Notification:return c.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}me.from=De})(Z||(e.ProgressLocation=Z={}));var W;(function(me){function De(K){const ke={start:K.start+1,end:K.end+1};return K.kind&&(ke.kind=de.from(K.kind)),ke}me.from=De;function ae(K){const ke={start:K.start-1,end:K.end-1};return K.kind&&(ke.kind=de.to(K.kind)),ke}me.to=ae})(W||(e.FoldingRange=W={}));var de;(function(me){function De(K){if(K)switch(K){case w.FoldingRangeKind.Comment:return n.$Vu.Comment;case w.FoldingRangeKind.Imports:return n.$Vu.Imports;case w.FoldingRangeKind.Region:return n.$Vu.Region}}me.from=De;function ae(K){if(K)switch(K.value){case n.$Vu.Comment.value:return w.FoldingRangeKind.Comment;case n.$Vu.Imports.value:return w.FoldingRangeKind.Imports;case n.$Vu.Region.value:return w.FoldingRangeKind.Region}}me.to=ae})(de||(e.FoldingRangeKind=de={}));var je;(function(me){function De(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?A.from(ae.selection):void 0,override:typeof ae.override=="boolean"?g.$gG.id:void 0}}me.from=De})(je||(e.TextEditorOpenOptions=je={}));var Qe;(function(me){function De(ze){return ze instanceof w.$6O?ze.toJSON():typeof ze=="string"?ze:ae(ze)||K(ze)?new w.$6O(ze.baseUri??ze.base,ze.pattern).toJSON():ze}me.from=De;function ae(ze){const Ze=ze;return Ze?l.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function K(ze){const Ze=ze;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function ke(ze){return typeof ze=="string"?ze:new w.$6O(l.URI.revive(ze.baseUri),ze.pattern)}me.to=ke})(Qe||(e.GlobPattern=Qe={}));var st;(function(me){function De(ae){if(ae){if(Array.isArray(ae))return ae.map(De);if(typeof ae=="string")return ae;{const K=ae;return{language:K.language,scheme:K.scheme,pattern:Qe.from(K.pattern),exclusive:K.exclusive,notebookType:K.notebookType}}}else return}me.from=De})(st||(e.LanguageSelector=st={}));var ht;(function(me){function De(K){return!!K&&typeof K=="object"&&"documents"in K&&Array.isArray(K.documents)&&K.documents.every(ke=>Array.isArray(ke)&&ke.every(ze=>ze&&typeof ze=="object"&&"uri"in ze&&l.URI.isUri(ze.uri)&&"version"in ze&&typeof ze.version=="number"&&"ranges"in ze&&Array.isArray(ze.ranges)&&ze.ranges.every(Ze=>Ze instanceof w.$7N)))}me.is=De;function ae(K){return{documents:K.documents.map(ke=>ke.map(ze=>({uri:l.URI.from(ze.uri),version:ze.version,ranges:ze.ranges.map(Ze=>A.from(Ze))})))}}me.from=ae})(ht||(e.MappedEditsContext=ht={}));var gt;(function(me){function De(K){return{start:K.start,end:K.end}}me.from=De;function ae(K){return new w.$wP(K.start,K.end)}me.to=ae})(gt||(e.NotebookRange=gt={}));var Rt;(function(me){function De(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}me.to=De;function ae(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}me.from=ae})(Rt||(e.NotebookCellExecutionSummary=Rt={}));var Ot;(function(me){function De(ae){if(ae===y.NotebookCellExecutionState.Unconfirmed)return w.NotebookCellExecutionState.Pending;if(ae===y.NotebookCellExecutionState.Pending)return;if(ae===y.NotebookCellExecutionState.Executing)return w.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ae}`)}me.to=De})(Ot||(e.NotebookCellExecutionState=Ot={}));var Qt;(function(me){function De(K){switch(K){case w.NotebookCellKind.Markup:return y.CellKind.Markup;case w.NotebookCellKind.Code:default:return y.CellKind.Code}}me.from=De;function ae(K){switch(K){case y.CellKind.Markup:return w.NotebookCellKind.Markup;case y.CellKind.Code:default:return w.NotebookCellKind.Code}}me.to=ae})(Qt||(e.NotebookCellKind=Qt={}));var _t;(function(me){function De(K){const ke={metadata:K.metadata??Object.create(null),cells:[]};for(const ze of K.cells)w.$xP.validate(ze),ke.cells.push(Xe.from(ze));return ke}me.from=De;function ae(K){const ke=new w.$yP(K.cells.map(Xe.to));return(0,r.$ug)(K.metadata)||(ke.metadata=K.metadata),ke}me.to=ae})(_t||(e.NotebookData=_t={}));var Xe;(function(me){function De(K){return{cellKind:Qt.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:Rt.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(Ut.from):[]}}me.from=De;function ae(K){return new w.$xP(Qt.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(Ut.to):void 0,K.metadata,K.internalMetadata?Rt.to(K.internalMetadata):void 0)}me.to=ae})(Xe||(e.NotebookCellData=Xe={}));var At;(function(me){function De(K){return{mime:K.mime,valueBytes:D.$Qe.wrap(K.data)}}me.from=De;function ae(K){return new w.$zP(K.valueBytes.buffer,K.mime)}me.to=ae})(At||(e.NotebookCellOutputItem=At={}));var Ut;(function(me){function De(K){return{outputId:K.id,items:K.items.map(At.from),metadata:K.metadata}}me.from=De;function ae(K){const ke=K.items.map(At.to);return new w.$AP(ke,K.outputId,K.metadata)}me.to=ae})(Ut||(e.NotebookCellOutput=Ut={}));var $t;(function(me){function De(ke){return K(ke)?{include:Qe.from(ke.include)??void 0,exclude:Qe.from(ke.exclude)??void 0}:Qe.from(ke)??void 0}me.from=De;function ae(ke){return K(ke)?{include:Qe.to(ke.include),exclude:Qe.to(ke.exclude)}:Qe.to(ke)}me.to=ae;function K(ke){const ze=ke;return ze?!(0,r.$qg)(ze.include)&&!(0,r.$qg)(ze.exclude):!1}})($t||(e.NotebookExclusiveDocumentPattern=$t={}));var Pt;(function(me){function De(ae,K,ke){const ze=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===w.NotebookCellStatusBarAlignment.Left?y.CellStatusbarAlignment.Left:y.CellStatusbarAlignment.Right,command:K.toInternal(ze,ke),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}me.from=De})(Pt||(e.NotebookStatusBarItem=Pt={}));var ei;(function(me){function De(ae,K,ke){const ze=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{command:K.toInternal(ze,ke),label:ae.label,description:ae.description,detail:ae.detail,documentation:ae.documentation}}me.from=De})(ei||(e.NotebookKernelSourceAction=ei={}));var ti;(function(me){function De(ae){return{transientOutputs:ae?.transientOutputs??!1,transientCellMetadata:ae?.transientCellMetadata??{},transientDocumentMetadata:ae?.transientDocumentMetadata??{},cellContentMetadata:ae?.cellContentMetadata??{}}}me.from=De})(ti||(e.NotebookDocumentContentOptions=ti={}));var Ht;(function(me){function De(K){return{uri:K.uri,provides:K.provides}}me.from=De;function ae(K){return new w.$CP(l.URI.revive(K.uri),K.provides)}me.to=ae})(Ht||(e.NotebookRendererScript=Ht={}));var wt;(function(me){function De(K){return{message:ce.fromStrict(K.message)||"",type:T.TestMessageType.Error,expected:K.expectedOutput,actual:K.actualOutput,contextValue:K.contextValue,location:K.location&&{range:A.from(K.location.range),uri:K.location.uri},stackTrace:K.stackTrace?.map(ke=>({label:ke.label,position:ke.position&&Y.from(ke.position),uri:ke.uri&&l.URI.revive(ke.uri).toJSON()}))}}me.from=De;function ae(K){const ke=new w.$IP(typeof K.message=="string"?K.message:ce.to(K.message));return ke.actualOutput=K.actual,ke.expectedOutput=K.expected,ke.contextValue=K.contextValue,ke.location=K.location?et.to(K.location):void 0,ke}me.to=ae})(wt||(e.TestMessage=wt={}));var Nt;(function(me){me.namespace=T.$rJ,me.denamespace=T.$sJ})(Nt||(e.TestTag=Nt={}));var ai;(function(me){function De(K){const ke=(0,m.$zQ)(K).controllerId;return{extId:C.$mJ.fromExtHostTestItem(K,ke).toString(),label:K.label,uri:l.URI.revive(K.uri),busy:K.busy,tags:K.tags.map(ze=>Nt.namespace(ke,ze.id)),range:a.$Ut.lift(A.from(K.range)),description:K.description||null,sortText:K.sortText||null,error:K.error&&ce.fromStrict(K.error)||null}}me.from=De;function ae(K){return{parent:void 0,error:void 0,id:C.$mJ.fromString(K.extId).localId,label:K.label,uri:l.URI.revive(K.uri),tags:(K.tags||[]).map(ke=>{const{tagId:ze}=Nt.denamespace(ke);return new w.$JP(ze)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:A.to(K.range||void 0),canResolveChildren:!1,busy:K.busy,description:K.description||void 0,sortText:K.sortText||void 0}}me.toPlain=ae})(ai||(e.TestItem=ai={})),function(me){function De(K){return{id:K.id}}me.from=De;function ae(K){return new w.$JP(K.id)}me.to=ae}(Nt||(e.TestTag=Nt={}));var Xt;(function(me){const De=(K,ke)=>{const ze=K.value;if(!ze)return;const Ze={...ai.toPlain(ze.item),parent:ke,taskStates:ze.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter(ft=>ft.type===T.TestMessageType.Error).map(wt.to)})),children:[]};if(K.children)for(const Ve of K.children.values()){const ft=De(Ve,Ze);ft&&Ze.children.push(ft)}return Ze};function ae(K){const ke=new h.$lJ;for(const Ve of K.items)ke.insert(C.$mJ.fromString(Ve.item.extId).path,Ve);const ze=[ke.nodes],Ze=[];for(;ze.length;)for(const Ve of ze.pop())Ve.value?Ze.push(Ve):Ve.children&&ze.push(Ve.children.values());return{completedAt:K.completedAt,results:Ze.map(Ve=>De(Ve)).filter(r.$pg)}}me.to=ae})(Xt||(e.TestResults=Xt={}));var Ge;(function(me){function De(ze){return{covered:ze.covered,total:ze.total}}function ae(ze){return"line"in ze?Y.from(ze):A.from(ze)}function K(ze){if(typeof ze.executed=="number"&&ze.executed<0)throw new Error(`Invalid coverage count ${ze.executed}`);return"branches"in ze?{count:ze.executed,location:ae(ze.location),type:T.DetailType.Statement,branches:ze.branches.length?ze.branches.map(Ze=>({count:Ze.executed,location:Ze.location&&ae(Ze.location),label:Ze.label})):void 0}:{type:T.DetailType.Declaration,name:ze.name,count:ze.executed,location:ae(ze.location)}}me.fromDetails=K;function ke(ze,Ze,Ve){return w.$MP(Ve.statementCoverage),w.$MP(Ve.branchCoverage),w.$MP(Ve.declarationCoverage),{id:Ze,uri:Ve.uri,statement:De(Ve.statementCoverage),branch:Ve.branchCoverage&&De(Ve.branchCoverage),declaration:Ve.declarationCoverage&&De(Ve.declarationCoverage),testIds:Ve instanceof w.$NP&&Ve.fromTests.length?Ve.fromTests.map(ft=>C.$mJ.fromExtHostTestItem(ft,ze).toString()):void 0}}me.fromFile=ke})(Ge||(e.TestCoverage=Ge={}));var ii;(function(me){function De(ae){switch(ae){case n.CodeActionTriggerType.Invoke:return w.CodeActionTriggerKind.Invoke;case n.CodeActionTriggerType.Auto:return w.CodeActionTriggerKind.Automatic}}me.to=De})(ii||(e.CodeActionTriggerKind=ii={}));var ci;(function(me){function De(K){const ke=new w.$RP(Fe.to(K.kind),K.name,K.detail||"",l.URI.revive(K.uri),A.to(K.range),A.to(K.selectionRange));return ke._sessionId=K._sessionId,ke._itemId=K._itemId,ke}me.to=De;function ae(K,ke,ze){if(ke=ke??K._sessionId,ze=ze??K._itemId,ke===void 0||ze===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:ze,kind:Fe.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:A.from(K.range),selectionRange:A.from(K.selectionRange),tags:K.tags?.map(Be.from)}}me.from=ae})(ci||(e.TypeHierarchyItem=ci={}));var ui;(function(me){function De(ae){if(ae)return{value:ae.value,tooltip:ae.tooltip}}me.from=De})(ui||(e.ViewBadge=ui={}));var Et;(function(me){function De(ze,Ze,Ve){const ft=Ze.fileData;return ft?new w.$XO(new w.$YO(ft.name,l.URI.revive(ft.uri),ft.id,(0,N.$fb)(()=>Ve(ft.id)))):ze===I.$et.uriList&&Ze.uriListData?new w.$WO(ke(Ze.uriListData)):new w.$WO(Ze.asString)}me.to=De;async function ae(ze,Ze){const Ve=await Ze.asString();if(ze===I.$et.uriList)return{asString:Ve,fileData:void 0,uriListData:K(Ve)};const ft=Ze.asFile();return{asString:Ve,fileData:ft?{name:ft.name,uri:ft.uri,id:ft._itemId??ft.id}:void 0}}me.from=ae;function K(ze){return P.$zu.split(ze).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return l.URI.parse(Ze)}catch{}return Ze})}function ke(ze){return P.$zu.create(ze.map(Ze=>typeof Ze=="string"?Ze:l.URI.revive(Ze)))}})(Et||(e.DataTransferItem=Et={}));var jt;(function(me){function De(K,ke){const ze=K.items.map(([Ze,Ve])=>[Ze,Et.to(Ze,Ve,ke)]);return new w.$ZO(ze)}me.toDataTransfer=De;async function ae(K){const ke={items:[]},ze=[];for(const[Ze,Ve]of K)ze.push((async()=>{ke.items.push([Ze,await Et.from(Ze,Ve)])})());return await Promise.all(ze),ke}me.from=ae})(jt||(e.DataTransfer=jt={}));var Lt;(function(me){function De(K,ke){return{kind:"reply",agentId:K.participant??ke?.agentId??"",subCommand:K.command??ke?.command,message:K.prompt,title:K.label}}me.from=De;function ae(K){return{prompt:K.message,label:K.title,participant:K.agentId,command:K.subCommand}}me.to=ae})(Lt||(e.ChatFollowup=Lt={}));var Bt;(function(me){function De(K){switch(K){case S.ChatMessageRole.System:return w.LanguageModelChatMessageRole.System;case S.ChatMessageRole.User:return w.LanguageModelChatMessageRole.User;case S.ChatMessageRole.Assistant:return w.LanguageModelChatMessageRole.Assistant}}me.to=De;function ae(K){switch(K){case w.LanguageModelChatMessageRole.System:return S.ChatMessageRole.System;case w.LanguageModelChatMessageRole.User:return S.ChatMessageRole.User;case w.LanguageModelChatMessageRole.Assistant:return S.ChatMessageRole.Assistant}return S.ChatMessageRole.User}me.from=ae})(Bt||(e.LanguageModelChatMessageRole=Bt={}));var oi;(function(me){function De(K){let ke="",ze;K.content.type==="text"?ke=K.content.value:ze=new w.$kQ(K.content.name,K.content.value,K.content.isError);const Ze=Bt.to(K.role),Ve=new w.$lQ(Ze,ke,K.name);return ze!==void 0&&(Ve.content2=ze),Ve}me.to=De;function ae(K){const ke=Bt.from(K.role),ze=K.name;let Ze;return K.content2 instanceof w.$kQ?Ze={type:"function_result",name:K.content2.name,value:K.content2.content,isError:K.content2.isError}:Ze={type:"text",value:K.content},{role:ke,name:ze,content:Ze}}me.from=ae})(oi||(e.LanguageModelChatMessage=oi={}));var ni;(function(me){function De(K){return{kind:"markdownContent",content:ce.from(K.value)}}me.from=De;function ae(K){return new w.$5P(ce.to(K.content))}me.to=ae})(ni||(e.ChatResponseMarkdownPart=ni={}));var ri;(function(me){function De(K){return{kind:"markdownVuln",content:ce.from(K.value),vulnerabilities:K.vulnerabilities}}me.from=De;function ae(K){return new w.$6P(ce.to(K.content),K.vulnerabilities)}me.to=ae})(ri||(e.ChatResponseMarkdownWithVulnerabilitiesPart=ri={}));var Kt;(function(me){function De(K){return{kind:"agentDetection",agentId:K.participant,command:K.command}}me.from=De;function ae(K){return new w.$7P(K.agentId,K.command)}me.to=ae})(Kt||(e.ChatResponseDetectedParticipantPart=Kt={}));var Gt;(function(me){function De(ae){return{kind:"confirmation",title:ae.title,message:ae.message,data:ae.data,buttons:ae.buttons}}me.from=De})(Gt||(e.ChatResponseConfirmationPart=Gt={}));var li;(function(me){function De(K){const{value:ke,baseUri:ze}=K;function Ze(Ve,ft){return Ve.map(Tt=>{const Yt=l.URI.joinPath(ft,Tt.name);return{label:Tt.name,uri:Yt,children:Tt.children&&Ze(Tt.children,Yt)}})}return{kind:"treeData",treeData:{label:(0,E.$gh)(ze),uri:ze,children:Ze(ke,ze)}}}me.from=De;function ae(K){const ke=(0,s.$fi)(K.treeData);function ze(ft){return ft.map(Tt=>({name:Tt.label,children:Tt.children&&ze(Tt.children)}))}const Ze=ke.uri,Ve=ke.children?ze(ke.children):[];return new w.$9P(Ve,Ze)}me.to=ae})(li||(e.ChatResponseFilesPart=li={}));var Mt;(function(me){function De(K){const ke=ze=>l.URI.isUri(ze);return{kind:"inlineReference",name:K.title,inlineReference:ke(K.value)?K.value:L.from(K.value)}}me.from=De;function ae(K){const ke=(0,s.$fi)(K);return new w.$0P(l.URI.isUri(ke.inlineReference)?ke.inlineReference:L.to(ke.inlineReference),K.name)}me.to=ae})(Mt||(e.ChatResponseAnchorPart=Mt={}));var Dt;(function(me){function De(K){return{kind:"progressMessage",content:ce.from(K.value)}}me.from=De;function ae(K){return new w.$$P(K.content.value)}me.to=ae})(Dt||(e.ChatResponseProgressPart=Dt={}));var bt;(function(me){function De(K){return{kind:"warning",content:ce.from(K.value)}}me.from=De;function ae(K){return new w.$aQ(K.content.value)}me.to=ae})(bt||(e.ChatResponseWarningPart=bt={}));var Jt;(function(me){function De(K){return{kind:"move",uri:K.uri,range:A.from(K.range)}}me.from=De;function ae(K){return new w.$eQ(l.URI.revive(K.uri),A.to(K.range))}me.to=ae})(Jt||(e.ChatResponseMovePart=Jt={}));var St;(function(me){function De(ae){return{kind:"progressTask",content:ce.from(ae.value)}}me.from=De})(St||(e.ChatTask=St={}));var hi;(function(me){function De(ae){return{kind:"progressTaskResult",content:typeof ae=="string"?ce.from(ae):void 0}}me.from=De})(hi||(e.ChatTaskResult=hi={}));var Zt;(function(me){function De(K,ke,ze){return{kind:"command",command:ke.toInternal(K.value,ze)??{command:K.value.command,title:K.value.title}}}me.from=De;function ae(K,ke){return new w.$bQ(ke.fromInternal(K.command)??{command:K.command.id,title:K.command.title})}me.to=ae})(Zt||(e.ChatResponseCommandButtonPart=Zt={}));var Mi;(function(me){function De(K){return{kind:"textEdit",uri:K.uri,edits:K.edits.map(ke=>be.from(ke))}}me.from=De;function ae(K){return new w.$fQ(l.URI.revive(K.uri),K.edits.map(ke=>be.to(ke)))}me.to=ae})(Mi||(e.ChatResponseTextEditPart=Mi={}));var di;(function(me){function De(K){const ke=f.ThemeIcon.isThemeIcon(K.iconPath)?K.iconPath:l.URI.isUri(K.iconPath)?{light:l.URI.revive(K.iconPath)}:K.iconPath&&"light"in K.iconPath&&"dark"in K.iconPath&&l.URI.isUri(K.iconPath.light)&&l.URI.isUri(K.iconPath.dark)?{light:l.URI.revive(K.iconPath.light),dark:l.URI.revive(K.iconPath.dark)}:void 0;return typeof K.value=="object"&&"variableName"in K.value?{kind:"reference",reference:{variableName:K.value.variableName,value:l.URI.isUri(K.value.value)||!K.value.value?K.value.value:L.from(K.value.value)},iconPath:ke,options:K.options}:{kind:"reference",reference:l.URI.isUri(K.value)||typeof K.value=="string"?K.value:L.from(K.value),iconPath:ke,options:K.options}}me.from=De;function ae(K){const ke=(0,s.$fi)(K),ze=Ze=>l.URI.isUri(Ze)?Ze:L.to(Ze);return new w.$cQ(typeof ke.reference=="string"?ke.reference:"variableName"in ke.reference?{variableName:ke.reference.variableName,value:ke.reference.value&&ze(ke.reference.value)}:ze(ke.reference))}me.to=ae})(di||(e.ChatResponseReferencePart=di={}));var yi;(function(me){function De(ae){return{kind:"codeCitation",value:ae.value,license:ae.license,snippet:ae.snippet}}me.from=De})(yi||(e.ChatResponseCodeCitationPart=yi={}));var qt;(function(me){function De(ke,ze,Ze){return ke instanceof w.$5P?ni.from(ke):ke instanceof w.$0P?Mt.from(ke):ke instanceof w.$cQ?di.from(ke):ke instanceof w.$$P?Dt.from(ke):ke instanceof w.$9P?li.from(ke):ke instanceof w.$bQ?Zt.from(ke,ze,Ze):ke instanceof w.$fQ?Mi.from(ke):ke instanceof w.$6P?ri.from(ke):ke instanceof w.$7P?Kt.from(ke):ke instanceof w.$aQ?bt.from(ke):ke instanceof w.$8P?Gt.from(ke):ke instanceof w.$dQ?yi.from(ke):ke instanceof w.$eQ?Jt.from(ke):{kind:"markdownContent",content:ce.from("")}}me.from=De;function ae(ke,ze){switch(ke.kind){case"reference":return di.to(ke);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return K(ke,ze)}}me.to=ae;function K(ke,ze){switch(ke.kind){case"markdownContent":return ni.to(ke);case"inlineReference":return Mt.to(ke);case"progressMessage":return;case"treeData":return li.to(ke);case"command":return Zt.to(ke,ze)}}me.toContent=K})(qt||(e.ChatResponsePart=qt={}));var fi;(function(me){function De(ae,K){const ke=ae.variables.variables.filter(Ze=>Ze.isTool),ze=ae.variables.variables.filter(Ze=>!Ze.isTool);return{prompt:ae.message,command:ae.command,attempt:ae.attempt??0,enableCommandDetection:ae.enableCommandDetection??!0,isParticipantDetected:ae.isParticipantDetected??!1,references:ze.map(Ct.to),toolReferences:ke.map(Si.to),location:Fi.to(ae.location),acceptedConfirmationData:ae.acceptedConfirmationData,rejectedConfirmationData:ae.rejectedConfirmationData,location2:K}}me.to=De})(fi||(e.ChatAgentRequest=fi={}));var Fi;(function(me){function De(K){switch(K){case u.ChatAgentLocation.Notebook:return w.ChatLocation.Notebook;case u.ChatAgentLocation.Terminal:return w.ChatLocation.Terminal;case u.ChatAgentLocation.Panel:return w.ChatLocation.Panel;case u.ChatAgentLocation.Editor:return w.ChatLocation.Editor}}me.to=De;function ae(K){switch(K){case w.ChatLocation.Notebook:return u.ChatAgentLocation.Notebook;case w.ChatLocation.Terminal:return u.ChatAgentLocation.Terminal;case w.ChatLocation.Panel:return u.ChatAgentLocation.Panel;case w.ChatLocation.Editor:return u.ChatAgentLocation.Editor}}me.from=ae})(Fi||(e.ChatLocation=Fi={}));var Ct;(function(me){function De(ae){const K=ae.value;if(!K)throw new Error("Invalid value reference");return{id:ae.id,name:ae.name,range:ae.range&&[ae.range.start,ae.range.endExclusive],value:(0,l.$yc)(K)?l.URI.revive(K):K&&typeof K=="object"&&"uri"in K&&"range"in K&&(0,l.$yc)(K.uri)?L.to((0,s.$fi)(K)):K,modelDescription:ae.modelDescription}}me.to=De})(Ct||(e.ChatPromptReference=Ct={}));var Si;(function(me){function De(ae){if(ae.value)throw new Error("Invalid tool reference");return{id:ae.id,range:ae.range&&[ae.range.start,ae.range.endExclusive]}}me.to=De})(Si||(e.ChatLanguageModelToolReference=Si={}));var Ai;(function(me){function De(ae,K,ke){return{id:ae.id,label:ae.label,fullName:ae.fullName,icon:ae.icon?.id,value:ae.values[0].value,insertText:ae.insertText,detail:ae.detail,documentation:ae.documentation,command:K.toInternal(ae.command,ke)}}me.from=De})(Ai||(e.ChatAgentCompletionItem=Ai={}));var gi;(function(me){function De(ae){return{errorDetails:ae.errorDetails,metadata:ae.metadata,nextQuestion:ae.nextQuestion}}me.to=De})(gi||(e.ChatAgentResult=gi={}));var zi;(function(me){function De(ae,K,ke){if(K.action.kind==="vote")return;const ze=gi.to(ae);if(K.action.kind==="command"){const Ze=K.action.commandButton.command;return{action:{kind:"command",commandButton:{command:ke.fromInternal(Ze)??{command:Ze.id,title:Ze.title}}},result:ze}}else return K.action.kind==="followUp"?{action:{kind:"followUp",followup:Lt.to(K.action.followup)},result:ze}:K.action.kind==="inlineChat"?{action:{kind:"editor",accepted:K.action.action==="accepted"},result:ze}:{action:K.action,result:ze}}me.to=De})(zi||(e.ChatAgentUserActionEvent=zi={}));var ji;(function(me){function De(K){return{...K,string:K.toString()}}me.from=De;function ae(K){const ke={...K,toString:()=>K.string};return delete ke.string,ke}me.to=ae})(ji||(e.LanguageModelToolResult=ji={}));var zt;(function(me){function De(ae,K,ke){return"terminalCommand"in ae?{terminalCommand:ae.terminalCommand,shouldExecute:ae.shouldExecute}:"uri"in ae?{uri:ae.uri}:K.toInternal(ae,ke)}me.from=De})(zt||(e.TerminalQuickFix=zt={}));var Pi;(function(me){function De(ae){return{kind:Di.to(ae.kind)}}me.to=De})(Pi||(e.PartialAcceptInfo=Pi={}));var Di;(function(me){function De(ae){switch(ae){case n.PartialAcceptTriggerKind.Word:return w.PartialAcceptTriggerKind.Word;case n.PartialAcceptTriggerKind.Line:return w.PartialAcceptTriggerKind.Line;case n.PartialAcceptTriggerKind.Suggest:return w.PartialAcceptTriggerKind.Suggest;default:return w.PartialAcceptTriggerKind.Unknown}}me.to=De})(Di||(e.PartialAcceptTriggerKind=Di={}));var wi;(function(me){function De(ae,K){return{id:K,label:ae.label,description:ae.description,canEdit:ae.canEdit,collapsibleState:ae.collapsibleState||k.DebugTreeItemCollapsibleState.None,contextValue:ae.contextValue}}me.from=De})(wi||(e.DebugTreeItem=wi={}));var bi;(function(me){function De(ae){return{id:ae.id,modelDescription:ae.modelDescription,parametersSchema:ae.parametersSchema,displayName:ae.displayName}}me.to=De})(bi||(e.LanguageModelToolDescription=bi={}))}),define(Re[231],Te([1,0,5,16,8,39]),function(we,e,v,D,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lqc=void 0;let R=class{constructor(p,s){this.a=p.getProxy(v.$3N.MainThreadBulkEdits),this.b={getTextDocumentVersion:I=>s.getDocument(I)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(p,s,I){const b=new N.$5w(P.WorkspaceEdit.from(p,this.b));return this.a.$tryApplyWorkspaceEdit(b,void 0,I?.isRefactoring??!1)}};e.$Lqc=R,e.$Lqc=R=Ke([We(0,D.$DQ)],R)}),define(Re[232],Te([1,0,17,10,42,6,40,4,33,69,14,2,18,5,8,7,117,193,21]),function(we,e,v,D,P,N,R,O,p,s,I,b,h,E,f,r,l,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mqc=void 0,f=qe(f),r=qe(r);class i{constructor(c,m,g,u,S){this.j=c,this.k=m,this.l=g,this.m=u,this.n=S,this.b=s.$ie.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let m=function(u){if(c.c){const S=new Error("Response stream has been closed");throw Error.captureStackTrace(S,u),S}};const c=this;this.b.reset();const g=(u,S)=>{if(typeof this.d>"u"&&(u.kind==="markdownContent"||u.kind==="markdownVuln")&&(this.d=this.b.elapsed()),S){const k=this.l.$handleProgressChunk(this.k.requestId,u),y={report:C=>{k?.then(T=>{T&&(r.$wO.isMarkdownString(C.value)?this.l.$handleProgressChunk(this.k.requestId,f.ChatResponseWarningPart.from(C),T):this.l.$handleProgressChunk(this.k.requestId,f.ChatResponseReferencePart.from(C),T))})}};Promise.all([k,S?.(y)]).then(([C,T])=>{C!==void 0&&this.l.$handleProgressChunk(this.k.requestId,f.ChatTaskResult.from(T),C)})}else this.l.$handleProgressChunk(this.k.requestId,u)};this.g={markdown(u){m(this.markdown);const S=new r.$5P(u),k=f.ChatResponseMarkdownPart.from(S);return g(k),this},markdownWithVulnerabilities(u,S){m(this.markdown),S&&(0,a.$wH)(c.j,"chatParticipantAdditions");const k=new r.$6P(u,S),y=f.ChatResponseMarkdownWithVulnerabilitiesPart.from(k);return g(y),this},filetree(u,S){m(this.filetree);const k=new r.$9P(u,S),y=f.ChatResponseFilesPart.from(k);return g(y),this},anchor(u,S){m(this.anchor);const k=new r.$0P(u,S),y=f.ChatResponseAnchorPart.from(k);return g(y),this},button(u){m(this.anchor);const S=new r.$bQ(u),k=f.ChatResponseCommandButtonPart.from(S,c.m,c.n);return g(k),this},progress(u,S){m(this.progress);const k=new r.$_P(u,S),y=S?f.ChatTask.from(k):f.ChatResponseProgressPart.from(k);return g(y,S),this},warning(u){m(this.progress),(0,a.$wH)(c.j,"chatParticipantAdditions");const S=new r.$aQ(u),k=f.ChatResponseWarningPart.from(S);return g(k),this},reference(u,S){return this.reference2(u,S)},reference2(u,S,k){if(m(this.reference),typeof u=="object"&&"variableName"in u&&(0,a.$wH)(c.j,"chatParticipantAdditions"),typeof u=="object"&&"variableName"in u&&!u.value){const y=c.k.variables.variables.find(C=>C.name===u.variableName);if(y){let C;if(y.references?.length)C=y.references.map(T=>({kind:"reference",reference:{variableName:u.variableName,value:T.reference}}));else{const T=new r.$cQ(u,S,k);C=[f.ChatResponseReferencePart.from(T)]}return C.forEach(T=>g(T)),this}}else{const y=new r.$cQ(u,S,k),C=f.ChatResponseReferencePart.from(y);g(C)}return this},codeCitation(u,S,k){m(this.codeCitation),(0,a.$wH)(c.j,"chatParticipantAdditions");const y=new r.$dQ(u,S,k),C=f.ChatResponseCodeCitationPart.from(y);g(C)},textEdit(u,S){m(this.textEdit),(0,a.$wH)(c.j,"chatParticipantAdditions");const k=new r.$fQ(u,S),y=f.ChatResponseTextEditPart.from(k);return g(y),this},detectedParticipant(u,S){m(this.detectedParticipant),(0,a.$wH)(c.j,"chatParticipantAdditions");const k=new r.$7P(u,S),y=f.ChatResponseDetectedParticipantPart.from(k);return g(y),this},confirmation(u,S,k,y){m(this.confirmation),(0,a.$wH)(c.j,"chatParticipantAdditions");const C=new r.$8P(u,S,k,y),T=f.ChatResponseConfirmationPart.from(C);return g(T),this},push(u){if(m(this.push),(u instanceof r.$fQ||u instanceof r.$6P||u instanceof r.$7P||u instanceof r.$aQ||u instanceof r.$8P||u instanceof r.$dQ||u instanceof r.$eQ)&&(0,a.$wH)(c.j,"chatParticipantAdditions"),u instanceof r.$cQ)this.reference2(u.value,u.iconPath,u.options);else{const S=f.ChatResponsePart.from(u,c.m,c.n);g(S)}return this}}}return this.g}}class n extends O.$Xc{static{this.b=0}static{this.j=0}constructor(c,m,g,u){super(),this.t=m,this.u=g,this.w=u,this.c=new Map,this.m=new Map,this.n=this.B(new O.$7c),this.s=this.B(new O.$7c),this.g=c.getProxy(E.$3N.MainThreadChatAgents2)}transferActiveChat(c){this.g.$transferActiveChatSession(c)}createChatAgent(c,m,g){const u=n.b++,S=new t(c,m,this.g,u,g);return this.c.set(u,S),this.g.$registerAgent(u,c.identifier,m,{},void 0),S.apiAgent}createDynamicChatAgent(c,m,g,u){const S=n.b++,k=new t(c,m,this.g,S,u);return this.c.set(S,k),this.g.$registerAgent(S,c.identifier,m,{isSticky:!0},g),k.apiAgent}registerChatParticipantDetectionProvider(c){const m=n.j++;return this.m.set(m,c),this.g.$registerChatParticipantDetectionProvider(m),(0,O.$Vc)(()=>{this.m.delete(m),this.g.$unregisterChatParticipantDetectionProvider(m)})}async $detectChatParticipant(c,m,g,u,S){const{request:k,location:y,history:C}=await this.y(m,g),T=this.m.get(c);if(T)return T.provideParticipantDetection(f.ChatAgentRequest.to(k,y),{history:C},{participants:u.participants,location:f.ChatLocation.to(u.location)},S)}async y(c,m){const g=(0,p.$fi)(c),u=await this.z(g.agentId,m);let S;if(g.locationData?.type===l.ChatAgentLocation.Editor){const k=this.w.getDocument(g.locationData.document);S=new r.$iQ(k,f.Selection.to(g.locationData.selection),f.Range.to(g.locationData.wholeRange))}else if(g.locationData?.type===l.ChatAgentLocation.Notebook){const k=this.w.getDocument(g.locationData.sessionInputUri);S=new r.$jQ(k)}else g.locationData?.type,l.ChatAgentLocation.Terminal;return{request:g,location:S,history:u}}async $invokeAgent(c,m,g,u){const S=this.c.get(c);if(!S)throw new Error(`[CHAT](${c}) CANNOT invoke agent because the agent is not registered`);let k;try{const{request:y,location:C,history:T}=await this.y(m,g);let $=this.n.get(y.sessionId);$||($=new O.$Wc,this.n.set(y.sessionId,$)),k=new i(S.extension,y,this.g,this.u.converter,$);const w=S.invoke(f.ChatAgentRequest.to(y,C),{history:T},k.apiObject,u);return await(0,D.$wh)(Promise.resolve(w).then(M=>{if(M?.metadata)try{JSON.stringify(M.metadata)}catch(L){const J=`result.metadata MUST be JSON.stringify-able. Got error: ${L.message}`;return this.t.error(`[${S.extension.identifier.value}] [@${S.id}] ${J}`,S.extension),{errorDetails:{message:J},timings:k?.timings,nextQuestion:M.nextQuestion}}let A;return M?.errorDetails&&(A={...M.errorDetails,responseIsIncomplete:!0}),A?.responseIsRedacted&&(0,a.$wH)(S.extension,"chatParticipantPrivate"),{errorDetails:A,timings:k?.timings,metadata:M?.metadata,nextQuestion:M?.nextQuestion}}),u)}catch(y){return this.t.error(y,S.extension),y instanceof r.$rQ&&y.cause&&(y=y.cause),{errorDetails:{message:(0,P.$tj)(y),responseIsIncomplete:!0}}}finally{k?.close()}}async z(c,m){const g=[];for(const u of m.history){const S=f.ChatAgentResult.to(u.result),k=c===u.request.agentId?S:{...S,metadata:void 0},y=u.request.variables.variables.filter(w=>!w.isTool).map(f.ChatPromptReference.to),C=u.request.variables.variables.filter(w=>w.isTool).map(f.ChatLanguageModelToolReference.to),T=new r.$gQ(u.request.message,u.request.command,y,u.request.agentId);T.toolReferences=C,g.push(T);const $=(0,v.$Jb)(u.response.map(w=>f.ChatResponsePart.toContent(w,this.u.converter)));g.push(new r.$hQ($,k,u.request.agentId,u.request.command))}return g}$releaseSession(c){this.n.deleteAndDispose(c)}async $provideFollowups(c,m,g,u,S){const k=this.c.get(m);if(!k)return Promise.resolve([]);const y=(0,p.$fi)(c),C=await this.z(k.id,u),T=f.ChatAgentResult.to(g);return(await k.provideFollowups(T,{history:C},S)).filter($=>{const w=!$.participant||R.Iterable.some(this.c.values(),M=>M.id===$.participant&&h.$vn.equals(M.extension.identifier,k.extension.identifier));return w||this.t.warn(`[@${k.id}] ChatFollowup refers to an unknown participant: ${$.participant}`),w}).map($=>f.ChatFollowup.from($,y))}$acceptFeedback(c,m,g,u){const S=this.c.get(c);if(!S)return;const k=f.ChatAgentResult.to(m);let y;switch(g){case d.ChatAgentVoteDirection.Down:y=r.ChatResultFeedbackKind.Unhelpful;break;case d.ChatAgentVoteDirection.Up:y=r.ChatResultFeedbackKind.Helpful;break}S.acceptFeedback(Object.freeze(u?{result:k,kind:y,reportIssue:u}:{result:k,kind:y}))}$acceptAction(c,m,g){const u=this.c.get(c);if(!u||g.action.kind==="vote")return;const S=f.ChatAgentUserActionEvent.to(m,g,this.u.converter);S&&u.acceptAction(Object.freeze(S))}async $invokeCompletionProvider(c,m,g){const u=this.c.get(c);if(!u)return[];let S=this.s.get(c);return S?S.clear():(S=new O.$Wc,this.s.set(c,S)),(await u.invokeCompletionProvider(m,g)).map(y=>f.ChatAgentCompletionItem.from(y,this.u.converter,S))}async $provideWelcomeMessage(c,m,g){const u=this.c.get(c);if(u)return await u.provideWelcomeMessage(f.ChatLocation.to(m),g)}async $provideChatTitle(c,m,g){const u=this.c.get(c);if(!u)return;const S=await this.z(u.id,{history:m});return await u.provideTitle({history:S},g)}async $provideSampleQuestions(c,m,g){const u=this.c.get(c);if(u)return(await u.provideSampleQuestions(f.ChatLocation.to(m),g)).map(S=>f.ChatFollowup.from(S,void 0))}}e.$Mqc=n;class t{constructor(c,m,g,u,S){this.extension=c,this.id=m,this.w=g,this.x=u,this.y=S,this.l=new N.$oe,this.m=new N.$oe}acceptFeedback(c){this.l.fire(c)}acceptAction(c){this.m.fire(c)}async invokeCompletionProvider(c,m){return this.o?await this.o.provider.provideCompletionItems(c,m)??[]:[]}async provideFollowups(c,m,g){if(!this.b)return[];const u=await this.b.provideFollowups(c,m,g);return u?u.filter(S=>!(S&&"commandId"in S)).filter(S=>!(S&&"message"in S)):[]}async provideWelcomeMessage(c,m){if(!this.q)return[];const g=await this.q.provideWelcomeMessage(c,m);return g?g.map(u=>typeof u=="string"?u:f.MarkdownString.from(u)):[]}async provideTitle(c,m){if(this.s)return await this.s.provideChatTitle(c,m)??void 0}async provideSampleQuestions(c,m){if(!this.q||!this.q.provideSampleQuestions)return[];const g=await this.q.provideSampleQuestions(c,m);return g||[]}get apiAgent(){let c=!1,m=!1;const g=()=>{c||m||(m=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{icon:this.c?this.c instanceof b.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof r.$4O?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.k,helpTextPrefix:!this.d||typeof this.d=="string"?this.d:f.MarkdownString.from(this.d),helpTextVariablesPrefix:!this.g||typeof this.g=="string"?this.g:f.MarkdownString.from(this.g),helpTextPostfix:!this.j||typeof this.j=="string"?this.j:f.MarkdownString.from(this.j),supportIssueReporting:this.n,requester:this.t,supportsSlowVariables:this.u}),m=!1}))},u=this;return{get id(){return u.id},get iconPath(){return u.c},set iconPath(S){u.c=S,g()},get requestHandler(){return u.y},set requestHandler(S){(0,I.$rg)(typeof S=="function","Invalid request handler"),u.y=S},get followupProvider(){return u.b},set followupProvider(S){u.b=S,g()},get helpTextPrefix(){return(0,a.$wH)(u.extension,"defaultChatParticipant"),u.d},set helpTextPrefix(S){(0,a.$wH)(u.extension,"defaultChatParticipant"),u.d=S,g()},get helpTextVariablesPrefix(){return(0,a.$wH)(u.extension,"defaultChatParticipant"),u.g},set helpTextVariablesPrefix(S){(0,a.$wH)(u.extension,"defaultChatParticipant"),u.g=S,g()},get helpTextPostfix(){return(0,a.$wH)(u.extension,"defaultChatParticipant"),u.j},set helpTextPostfix(S){(0,a.$wH)(u.extension,"defaultChatParticipant"),u.j=S,g()},get isSecondary(){return(0,a.$wH)(u.extension,"defaultChatParticipant"),u.k},set isSecondary(S){(0,a.$wH)(u.extension,"defaultChatParticipant"),u.k=S,g()},get supportIssueReporting(){return(0,a.$wH)(u.extension,"chatParticipantPrivate"),u.n},set supportIssueReporting(S){(0,a.$wH)(u.extension,"chatParticipantPrivate"),u.n=S,g()},get onDidReceiveFeedback(){return u.l.event},set participantVariableProvider(S){if((0,a.$wH)(u.extension,"chatParticipantAdditions"),u.o=S,S){if(!S.triggerCharacters.length)throw new Error("triggerCharacters are required");u.w.$registerAgentCompletionsProvider(u.x,u.id,S.triggerCharacters)}else u.w.$unregisterAgentCompletionsProvider(u.x,u.id)},get participantVariableProvider(){return(0,a.$wH)(u.extension,"chatParticipantAdditions"),u.o},set welcomeMessageProvider(S){(0,a.$wH)(u.extension,"defaultChatParticipant"),u.q=S,g()},get welcomeMessageProvider(){return(0,a.$wH)(u.extension,"defaultChatParticipant"),u.q},set titleProvider(S){(0,a.$wH)(u.extension,"defaultChatParticipant"),u.s=S,g()},get titleProvider(){return(0,a.$wH)(u.extension,"defaultChatParticipant"),u.s},onDidPerformAction:(0,a.$vH)(this.extension,"chatParticipantAdditions")?this.m.event:void 0,set requester(S){u.t=S,g()},get requester(){return u.t},set supportsSlowReferences(S){(0,a.$wH)(u.extension,"chatParticipantPrivate"),u.u=S,g()},get supportsSlowReferences(){return(0,a.$wH)(u.extension,"chatParticipantPrivate"),u.u},dispose(){c=!0,u.b=void 0,u.l.dispose(),u.w.$unregisterAgent(u.x)}}}invoke(c,m,g,u){return this.y(c,m,g,u)}}}),define(Re[233],Te([1,0,12,4,35,5,8,7,21]),function(we,e,v,D,P,N,R,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nqc=void 0,R=qe(R),O=qe(O);class s{static{this.a=0}constructor(h){this.b=new Map,this.c=h.getProxy(N.$3N.MainThreadChatVariables)}async $resolveVariable(h,E,f,r){const l=this.b.get(h);if(l)try{if(l.resolver.resolve2){(0,p.$wH)(l.extension,"chatParticipantAdditions");const d=new I(E,this.c),a=await l.resolver.resolve2(l.data.name,{prompt:f},d.apiObject,r);if(a&&a[0])return a[0].value}else{const d=await l.resolver.resolve(l.data.name,{prompt:f},r);if(d&&d[0])return d[0].value}}catch(d){(0,v.$3)(d)}}registerVariableResolver(h,E,f,r,l,d,a,i,n){const t=s.a++,o=n?P.ThemeIcon.fromId(n):void 0;return this.b.set(t,{extension:h,data:{id:E,name:f,description:r,modelDescription:l,icon:o},resolver:a}),this.c.$registerVariable(t,{id:E,name:f,description:r,modelDescription:l,isSlow:d,fullName:i,icon:o}),(0,D.$Vc)(()=>{this.b.delete(t),this.c.$unregisterVariable(t)})}}e.$Nqc=s;class I{constructor(h,E){this.c=h,this.d=E,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let E=function(r){if(h.a){const l=new Error("Response stream has been closed");throw Error.captureStackTrace(l,r),l}};const h=this,f=r=>{this.d.$handleProgressChunk(this.c,r)};this.b={progress(r){E(this.progress);const l=new O.$$P(r),d=R.ChatResponseProgressPart.from(l);return f(d),this},reference(r){E(this.reference);const l=new O.$cQ(r),d=R.ChatResponseReferencePart.from(l);return f(d),this},push(r){return E(this.push),r instanceof O.$cQ?f(R.ChatResponseReferencePart.from(r)):r instanceof O.$$P&&f(R.ChatResponseProgressPart.from(r)),this}}}return this.b}}}),define(Re[234],Te([1,0,10,71,6,4,37,2,94,18,8,7,5,21]),function(we,e,v,D,P,N,R,O,p,s,I,b,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rqc=f,p=qe(p),I=qe(I),b=qe(b);function f(r,l,d){const a=r.getProxy(h.$3N.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new s.$xn,l.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===R.MarshalledId.CommentController){const C=this.b.get(y.handle);return C?C.value:y}else if(y&&y.$mid===R.MarshalledId.CommentThread){const C=y,T=this.b.get(C.commentControlHandle);if(!T)return C;const $=T.getCommentThread(C.commentThreadHandle);return $?$.value:C}else if(y&&(y.$mid===R.MarshalledId.CommentThreadReply||y.$mid===R.MarshalledId.CommentThreadInstance)){const C=this.b.get(y.thread.commentControlHandle);if(!C)return y;const T=C.getCommentThread(y.thread.commentThreadHandle);return T?y.$mid===R.MarshalledId.CommentThreadInstance?T.value:{thread:T.value,text:y.text}:y}else if(y&&y.$mid===R.MarshalledId.CommentNode){const C=this.b.get(y.thread.commentControlHandle);if(!C)return y;const T=C.getCommentThread(y.thread.commentThreadHandle);if(!T)return y;const $=y.commentUniqueId,w=T.getCommentByUniqueId($);return w||y}else if(y&&y.$mid===R.MarshalledId.CommentThreadNode){const C=this.b.get(y.thread.commentControlHandle);if(!C)return y;const T=C.getCommentThread(y.thread.commentThreadHandle);if(!T)return y;const $=y.text,w=y.commentUniqueId,M=T.getCommentByUniqueId(w);return M?(typeof M.body=="string"?M.body=$:M.body=new b.$wO($),M):y}return y}})}createCommentController(y,C,T){const $=i.a++,w=new t(y,$,C,T);this.b.set(w.handle,w);const M=this.c.get(y.identifier)||[];return M.push(w),this.c.set(y.identifier,M),w.value}async $createCommentThreadTemplate(y,C,T,$){const w=this.b.get(y);w&&w.$createCommentThreadTemplate(C,T,$)}async $setActiveComment(y,C){const T=this.b.get(y);T&&T.$setActiveComment(C??void 0)}async $updateCommentThreadTemplate(y,C,T){const $=this.b.get(y);$&&$.$updateCommentThreadTemplate(C,T)}$deleteCommentThread(y,C){this.b.get(y)?.$deleteCommentThread(C)}async $provideCommentingRanges(y,C,T){const $=this.b.get(y);if(!$||!$.commentingRangeProvider)return Promise.resolve(void 0);const w=await d.ensureDocumentData(O.URI.revive(C));return(0,v.$Ah)(async()=>{const M=await $.commentingRangeProvider.provideCommentingRanges(w.document,T);let A;return Array.isArray(M)?A={ranges:M,fileComments:!1}:M?A={ranges:M.ranges||[],fileComments:M.enableFileComments||!1}:A=M??void 0,A}).then(M=>{let A;return M&&(A={ranges:M.ranges.map(L=>I.Range.from(L)),fileComments:M.fileComments}),A})}$toggleReaction(y,C,T,$,w){const M=this.b.get(y);return!M||!M.reactionHandler?Promise.resolve(void 0):(0,v.$Ah)(()=>{const A=M.getCommentThread(C);if(A){const L=A.getCommentByUniqueId($.uniqueIdInThread);if(M!==void 0&&L&&M.reactionHandler)return M.reactionHandler(L,m(w))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(y){this.n=y}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(y){(y===void 0!=(this.p===void 0)||!y||!this.p||!y.isEqual(this.p))&&(this.p=y,this.b.range=y,this.c.fire())}get range(){return this.p}set canReply(y){this.d!==y&&(this.d=y,this.b.canReply=y,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(y){this.e=y,this.b.label=y,this.c.fire()}get contextValue(){return this.f}set contextValue(y){this.f=y,this.b.contextValue=y,this.c.fire()}get comments(){return this.q}set comments(y){this.q=y,this.b.comments=y,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(y){this.g=y,this.b.collapsibleState=y,this.c.fire()}get state(){return this.h}set state(y){this.h=y,typeof y=="object"?((0,E.$wH)(this.extensionDescription,"commentThreadApplicability"),this.b.state=y.resolved,this.b.applicability=y.applicability):this.b.state=y,this.c.fire()}get isDisposed(){return this.j}constructor(y,C,T,$,w,M,A,L,J){this.m=C,this.n=T,this.o=$,this.p=w,this.q=M,this.extensionDescription=A,this.r=L,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new P.$oe,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new N.$Yc,this.l.value=new N.$Wc,this.n===void 0&&(this.n=`${y}.${this.handle}`),a.$createCommentThread(C,this.handle,this.n,this.o,I.Range.from(this.p),this.q.map(z=>o(this,z,this.k,this.extensionDescription)),A.identifier,this.r,J),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.i.push({dispose:()=>{a.$deleteCommentThread(C,this.handle)}});const Y=this;this.value={get uri(){return Y.uri},get range(){return Y.range},set range(z){Y.range=z},get comments(){return Y.comments},set comments(z){Y.comments=z},get collapsibleState(){return Y.collapsibleState},set collapsibleState(z){Y.collapsibleState=z},get canReply(){return Y.canReply},set canReply(z){Y.canReply=z},get contextValue(){return Y.contextValue},set contextValue(z){Y.contextValue=z},get label(){return Y.label},set label(z){Y.label=z},get state(){return Y.state},set state(z){Y.state=z},reveal:(z,Q)=>Y.reveal(z,Q),hide:()=>Y.hide(),dispose:()=>{Y.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new N.$Wc);const y=T=>Object.prototype.hasOwnProperty.call(this.b,T),C={};y("range")&&(C.range=I.Range.from(this.p)),y("label")&&(C.label=this.label),y("contextValue")&&(C.contextValue=this.contextValue??null),y("comments")&&(C.comments=this.q.map(T=>o(this,T,this.k,this.extensionDescription))),y("collapsibleState")&&(C.collapseState=g(this.g)),y("canReply")&&(C.canReply=this.canReply),y("state")&&(C.state=u(this.h)),y("applicability")&&(C.applicability=S(this.h)),y("isTemplate")&&(C.isTemplate=this.r),this.b={},a.$updateCommentThread(this.m,this.handle,this.n,this.o,C)}getCommentByUniqueId(y){for(const C of this.k){const T=C[0],$=C[1];if(y===$)return T}}async reveal(y,C){(0,E.$wH)(this.extensionDescription,"commentReveal");let T;y&&y.body!==void 0?T=y:C=C??y;let $=T?this.k.get(T):void 0;$??=this.k.get(this.q[0]);let w=!0,M=!1;return C?.focus===b.CommentThreadFocus.Reply?(M=!0,w=!1):C?.focus===b.CommentThreadFocus.Comment&&(w=!1),a.$revealCommentThread(this.m,this.handle,$,{preserveFocus:w,focusReply:M})}async hide(){return a.$hideCommentThread(this.m,this.handle)}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(y=>y.dispose())}}Ke([(0,D.$bi)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class t{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(y){this.b=y,y?.resourceHints&&(0,E.$wH)(this.h,"commentingRangeHint"),a.$updateCommentingRanges(this.handle,y?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(y){this.c=y,a.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!y})}get options(){return this.d}set options(y){this.d=y,a.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,E.$wH)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,E.$wH)(this.h,"activeComment"),this.f?.value}constructor(y,C,T,$){this.h=y,this.i=C,this.j=T,this.k=$,this.a=new Map,a.$registerCommentController(this.handle,T,$,this.h.identifier.value);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(M){w.options=M},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(M){w.commentingRangeProvider=M},get reactionHandler(){return w.reactionHandler},set reactionHandler(M){w.reactionHandler=M},get activeCommentThread(){return w.activeCommentThread},createCommentThread(M,A,L){return w.createCommentThread(M,A,L).value},dispose:()=>{w.dispose()}}),this.g=[],this.g.push({dispose:()=>{a.$unregisterCommentController(this.handle)}})}createCommentThread(y,C,T){C===void 0&&(0,E.$wH)(this.h,"fileComments");const $=new n(this.id,this.handle,void 0,y,C,T,this.h,!1);return this.a.set($.handle,$),$}$setActiveComment(y){if(!y){this.e=void 0,this.f=void 0;return}const C=this.a.get(y.commentThreadHandle);C&&(this.e=y.uniqueIdInThread?C.getCommentByUniqueId(y.uniqueIdInThread):void 0,this.f=C)}$createCommentThreadTemplate(y,C,T){const $=new n(this.id,this.handle,void 0,O.URI.revive(y),I.Range.to(C),[],this.h,!0,T);return $.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set($.handle,$),$}$updateCommentThreadTemplate(y,C){const T=this.a.get(y);T&&(T.range=I.Range.to(C))}$deleteCommentThread(y){this.a.get(y)?.dispose(),this.a.delete(y)}getCommentThread(y){return this.a.get(y)}dispose(){this.a.forEach(y=>{y.dispose()}),this.g.forEach(y=>y.dispose())}}function o(k,y,C,T){let $=C.get(y);return $||($=++k.commentHandle,C.set(y,$)),y.state!==void 0&&(0,E.$wH)(T,"commentsDraftState"),y.reactions?.some(w=>w.reactors!==void 0)&&(0,E.$wH)(T,"commentReactor"),{mode:y.mode,contextValue:y.contextValue,uniqueIdInThread:$,body:typeof y.body=="string"?y.body:I.MarkdownString.from(y.body),userName:y.author.name,userIconPath:y.author.iconPath,label:y.label,commentReactions:y.reactions?y.reactions.map(w=>c(w)):void 0,state:y.state,timestamp:y.timestamp?.toJSON()}}function c(k){return{label:k.label,iconPath:k.iconPath?I.$CQ(k.iconPath):void 0,count:k.count,hasReacted:k.authorHasReacted,reactors:k.reactors&&k.reactors.length>0&&typeof k.reactors[0]!="string"?k.reactors.map(y=>y.name):k.reactors}}function m(k){return{label:k.label||"",count:k.count||0,iconPath:k.iconPath?O.URI.revive(k.iconPath):"",authorHasReacted:k.hasReacted||!1,reactors:k.reactors?.map(y=>({name:y}))}}function g(k){if(k!==void 0)switch(k){case b.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case b.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function u(k){let y;if(typeof k=="object"?y=k.resolved:y=k,y!==void 0)switch(y){case b.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case b.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}function S(k){let y;if(typeof k=="object"&&(y=k.applicability),y!==void 0)switch(y){case b.CommentThreadApplicability.Current:return p.CommentThreadApplicability.Current;case b.CommentThreadApplicability.Outdated:return p.CommentThreadApplicability.Outdated}return p.CommentThreadApplicability.Current}return new i}}),define(Re[235],Te([1,0,19,76,4,15,24,2,8,67,80,5,7]),function(we,e,v,D,P,N,R,O,p,s,I,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0qc=void 0,p=qe(p),b=qe(b),h=qe(h);class E{constructor(c,m){this.document=c,this.b=m,this.a=1,this.c=new I.$xqc("custom documents")}addEdit(c){return this.c.add([c])}async undo(c,m){await this.f(c).undo(),m||this.disposeBackup()}async redo(c,m){await this.f(c).redo(),m||this.disposeBackup()}disposeEdits(c){for(const m of c)this.c.delete(m)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const c=t(this.document.uri)+this.a++;return(0,R.$jh)(this.b,c)}updateBackup(c){this.d?.delete(),this.d=c}disposeBackup(){this.d?.delete(),this.d=void 0}f(c){const m=this.c.get(c,0);if(!m)throw new Error("No edit found");return m}}class f{constructor(){this.a=new Map}get(c,m){return this.a.get(this.b(c,m))}add(c,m,g){const u=this.b(c,m.uri);if(this.a.has(u))throw new Error(`Document already exists for viewType:${c} resource:${m.uri}`);const S=new E(m,g);return this.a.set(u,S),S}delete(c,m){const g=this.b(c,m.uri);this.a.delete(g)}b(c,m){return`${c}@@@${m}`}}var r;(function(o){o[o.Text=0]="Text",o[o.Custom=1]="Custom"})(r||(r={}));class l{constructor(){this.a=new Map}addTextProvider(c,m,g){return this.b(c,{type:r.Text,extension:m,provider:g})}addCustomProvider(c,m,g){return this.b(c,{type:r.Custom,extension:m,provider:g})}get(c){return this.a.get(c)}b(c,m){if(this.a.has(c))throw new Error(`Provider for viewType:${c} already registered`);return this.a.set(c,m),new h.$5N(()=>this.a.delete(c))}}class d{constructor(c,m,g,u,S){this.d=m,this.f=g,this.g=u,this.h=S,this.b=new l,this.c=new f,this.a=c.getProxy(b.$3N.MainThreadCustomEditors)}registerCustomEditorProvider(c,m,g,u){const S=new P.$Wc;return i(g)?(S.add(this.b.addTextProvider(m,c,g)),this.a.$registerTextEditorProvider((0,s.$7qc)(c),m,u.webviewOptions||{},{supportsMove:!!g.moveCustomTextEditor},(0,s.$5qc)(c))):(S.add(this.b.addCustomProvider(m,c,g)),a(g)&&S.add(g.onDidChangeCustomDocument(k=>{const y=this.i(m,k.document.uri);if(n(k)){const C=y.addEdit(k);this.a.$onDidEdit(k.document.uri,m,C,k.label)}else this.a.$onContentChange(k.document.uri,m)})),this.a.$registerCustomEditorProvider((0,s.$7qc)(c),m,u.webviewOptions||{},!!u.supportsMultipleEditorsPerDocument,(0,s.$5qc)(c))),h.$5N.from(S,new h.$5N(()=>{this.a.$unregisterEditorProvider(m)}))}async $createCustomDocument(c,m,g,u,S){const k=this.b.get(m);if(!k)throw new Error(`No provider found for '${m}'`);if(k.type!==r.Custom)throw new Error(`Invalid provide type for '${m}'`);const y=O.URI.revive(c),C=await k.provider.openCustomDocument(y,{backupId:g,untitledDocumentData:u?.buffer},S);let T;return a(k.provider)&&this.f&&(T=this.f.workspaceValue(k.extension)??this.f.globalValue(k.extension)),this.c.add(m,C,T),{editable:a(k.provider)}}async $disposeCustomDocument(c,m){const g=this.b.get(m);if(!g)throw new Error(`No provider found for '${m}'`);if(g.type!==r.Custom)throw new Error(`Invalid provider type for '${m}'`);const u=O.URI.revive(c),{document:S}=this.i(m,u);this.c.delete(m,S),S.dispose()}async $resolveCustomEditor(c,m,g,u,S,k){const y=this.b.get(g);if(!y)throw new Error(`No provider found for '${g}'`);const C=p.ViewColumn.to(S),T=this.g.createNewWebview(m,u.contentOptions,y.extension),$=this.h.createNewWebviewPanel(m,g,u.title,C,u.options,T,u.active),w=O.URI.revive(c);switch(y.type){case r.Custom:{const{document:M}=this.i(g,w);return y.provider.resolveCustomEditor(M,$,k)}case r.Text:{const M=this.d.getDocument(w);return y.provider.resolveCustomTextEditor(M,$,k)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(c,m,g){this.i(m,c).disposeEdits(g)}async $onMoveCustomEditor(c,m,g){const u=this.b.get(g);if(!u)throw new Error(`No provider found for '${g}'`);if(!u.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${g}'`);const S=this.h.getWebviewPanel(c);if(!S)throw new Error("No webview found");const k=O.URI.revive(m),y=this.d.getDocument(k);await u.provider.moveCustomTextEditor(y,S,v.CancellationToken.None)}async $undo(c,m,g,u){return this.i(m,c).undo(g,u)}async $redo(c,m,g,u){return this.i(m,c).redo(g,u)}async $revert(c,m,g){const u=this.i(m,c);await this.j(m).revertCustomDocument(u.document,g),u.disposeBackup()}async $onSave(c,m,g){const u=this.i(m,c);await this.j(m).saveCustomDocument(u.document,g),u.disposeBackup()}async $onSaveAs(c,m,g,u){const S=this.i(m,c);return this.j(m).saveCustomDocumentAs(S.document,O.URI.revive(g),u)}async $backup(c,m,g){const u=this.i(m,c),k=await this.j(m).backupCustomDocument(u.document,{destination:u.getNewBackupUri()},g);return u.updateBackup(k),k.id}i(c,m){const g=this.c.get(c,O.URI.revive(m));if(!g)throw new Error("No custom document found");return g}j(c){const g=this.b.get(c)?.provider;if(!g||!a(g))throw new Error("Custom document is not editable");return g}}e.$0qc=d;function a(o){return!!o.onDidChangeCustomDocument}function i(o){return typeof o.resolveCustomTextEditor=="function"}function n(o){return typeof o.undo=="function"&&typeof o.redo=="function"}function t(o){const c=o.scheme===N.Schemas.file||o.scheme===N.Schemas.untitled?o.fsPath:o.toString();return(0,D.$wj)(c)+""}}),define(Re[236],Te([1,0,9,108,2,5,7,8,6,11,27,50]),function(we,e,v,D,P,N,R,O,p,s,I,b){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fqc=e.$Eqc=void 0,O=qe(O);class E{#e;#t;#i;constructor(l,d,a,i,n,t,o,c){this.d=l,this.e=d,this.f=a,this.g=i,this.h=n,this.c=!1,this.f=Math.max(i,a),this.#i=new I.$Dc(m=>t.getComparisonKey(m)),this.#e=o,this.#t=c}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(l,d){if(!l){this.clear();return}this.j();let a=[];if(P.URI.isUri(l)){if(!d){this.delete(l);return}this.#i.set(l,d.slice()),a=[l]}else if(Array.isArray(l)){a=[];let t;l=[...l].sort(E.k);for(const o of l){const[c,m]=o;if((!t||c.toString()!==t.toString())&&(t&&this.#i.get(t).length===0&&this.#i.delete(t),t=c,a.push(c),this.#i.set(c,[])),m)this.#i.get(c)?.push(...m);else{const g=this.#i.get(c);g&&(g.length=0)}}}if(this.#t.fire(a),!this.#e)return;const i=[];let n=0;for(const t of a){let o=[];const c=this.#i.get(t);if(c)if(c.length>this.g){o=[];const m=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let g=0;g<4;g++)for(const u of c)if(u.severity===m[g]&&o.push({...O.Diagnostic.from(u),modelVersionId:this.h(t)})===this.g)break e;o.push({severity:D.MarkerSeverity.Info,message:(0,v.localize)(2700,null,c.length-this.g),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=c.map(m=>({...O.Diagnostic.from(m),modelVersionId:this.h(t)}));if(i.push([t,o]),n+=o.length,n>this.f)break}this.#e.$changeMany(this.e,i)}delete(l){this.j(),this.#t.fire([l]),this.#i.delete(l),this.#e?.$changeMany(this.e,[[l,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(l,d){this.j();for(const[a,i]of this)l.call(d,a,i,this)}*[Symbol.iterator](){this.j();for(const l of this.#i.keys())yield[l,this.get(l)]}get(l){this.j();const d=this.#i.get(l);return Array.isArray(d)?Object.freeze(d.slice(0)):[]}has(l){return this.j(),Array.isArray(this.#i.get(l))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(l,d){return l[0].toString()<d[0].toString()?-1:l[0].toString()>d[0].toString()?1:0}}e.$Eqc=E;let f=class{static{h=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*this.d}static _mapper(l){const d=new I.$Dc;for(const a of l)d.set(a,a);return{uris:Object.freeze(Array.from(d.values()))}}constructor(l,d,a,i){this.j=d,this.k=a,this.l=i,this.g=new Map,this.h=new p.$se({merge:n=>n.flat(),delay:50}),this.onDidChangeDiagnostics=p.Event.map(this.h.event,h._mapper),this.f=l.getProxy(N.$3N.MainThreadDiagnostics)}createDiagnosticCollection(l,d){const{g:a,f:i,h:n,j:t,k:o,l:c}=this,m=new class{$changeMany(S,k){i.$changeMany(S,k),t.trace("[DiagnosticCollection] change many (extension, owner, uris)",l.value,S,k.length===0?"CLEARING":k)}$clear(S){i.$clear(S),t.trace("[DiagnosticCollection] remove all (extension, owner)",l.value,S)}dispose(){i.dispose()}};let g;if(!d)d="_generated_diagnostic_collection_name_#"+h.c++,g=d;else if(!a.has(d))g=d;else{this.j.warn(`DiagnosticCollection with name '${d}' does already exist.`);do g=d+h.c++;while(a.has(g))}return new class extends E{constructor(){super(d,g,h.e,h.d,S=>c.getDocument(S)?.version,o.extUri,m,n),a.set(g,this)}dispose(){super.dispose(),a.delete(g)}}}getDiagnostics(l){if(l)return this.m(l);{const d=new Map,a=[];for(const i of this.g.values())i.forEach((n,t)=>{let o=d.get(n.toString());typeof o>"u"&&(o=a.length,d.set(n.toString(),o),a.push([n,[]])),a[o][1]=a[o][1].concat(...t)});return a}}m(l){let d=[];for(const a of this.g.values())a.has(l)&&(d=d.concat(a.get(l)));return d}$acceptMarkersChange(l){if(!this.n){const d="_generated_mirror",a=new E(d,d,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(d,a),this.n=a}for(const[d,a]of l)this.n.set(P.URI.revive(d),a.map(O.Diagnostic.to))}};e.$Fqc=f,e.$Fqc=f=h=Ke([We(1,s.$dk),We(2,b.$Dqc)],f)}),define(Re[237],Te([1,0,2,12,7,8,171,39]),function(we,e,v,D,P,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Src=void 0;class p{constructor(I,b,h,E={timeout:1500,errors:3}){this.c=I,this.d=b,this.f=h,this.g=E,this.a=new R.$8c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(I){return(b,h,E)=>{const r={dispose:this.a.push([b,h,I])};return Array.isArray(E)&&E.push(r),r}}async $participateInSave(I,b){const h=v.URI.revive(I);let E=!1;const f=setTimeout(()=>E=!0,this.g.timeout),r=[];try{for(const l of[...this.a]){if(E)break;const d=this.d.getDocument(h),a=await this.h(l,{document:d,reason:N.TextDocumentSaveReason.to(b)});r.push(a)}}finally{clearTimeout(f)}return r}h([I,b,h],E){const f=this.b.get(I);return typeof f=="number"&&f>this.g.errors?Promise.resolve(!1):this.i(h,I,b,E).then(()=>!0,r=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${h.identifier.value}' threw ERROR`),this.c.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const l=this.b.get(I);this.b.set(I,l?l+1:1),typeof l=="number"&&l>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${h.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(I,b,h,E){const f=[],r=Date.now(),{document:l,reason:d}=E,{version:a}=l,i=Object.freeze({document:l,reason:d,waitUntil(n){if(Object.isFrozen(f))throw(0,D.$0)("waitUntil can not be called async");f.push(Promise.resolve(n))}});try{b.apply(h,[i])}catch(n){return Promise.reject(n)}return Object.freeze(f),new Promise((n,t)=>{const o=setTimeout(()=>t(new Error("timeout")),this.g.timeout);return Promise.all(f).then(c=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(o),n(c)}).catch(c=>{clearTimeout(o),t(c)})}).then(n=>{const t={edits:[]};for(const o of n)if(Array.isArray(o)&&o.every(c=>c instanceof P.$bO))for(const{newText:c,newEol:m,range:g}of o)t.edits.push({resource:l.uri,versionId:void 0,textEdit:{range:g&&N.Range.from(g),text:c,eol:m&&N.EndOfLine.from(m)}});if(t.edits.length!==0)return a===l.version?this.f.$tryApplyWorkspaceEdit(new O.$5w(t)):Promise.reject(new Error("concurrent_edits"))})}}e.$Src=p}),define(Re[238],Te([1,0,6,4,2,5,125,8,14,25,7]),function(we,e,v,D,P,N,R,O,p,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gqc=void 0,O=qe(O);class b{constructor(E,f){this.a=new v.$oe,this.b=new v.$oe,this.c=new v.$oe,this.d=new v.$oe,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new D.$Wc,this.h=new Map,this.f=E.getProxy(N.$3N.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(r=>{for(const l of r)this.b.fire(l.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const l of r)this.a.fire(l.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(E){if(!E)return;const f=this.g.getDocument(E);if(f)return f}getDocument(E){const f=this.getDocumentData(E);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return f.document}ensureDocumentData(E){const f=this.g.getDocument(E);if(f)return Promise.resolve(f);let r=this.h.get(E.toString());return r||(r=this.f.$tryOpenDocument(E).then(l=>{this.h.delete(E.toString());const d=P.URI.revive(l);return(0,p.$sg)(this.g.getDocument(d))},l=>(this.h.delete(E.toString()),Promise.reject(l))),this.h.set(E.toString(),r)),r}createDocumentData(E){return this.f.$tryCreateDocument(E).then(f=>P.URI.revive(f))}$acceptModelLanguageChanged(E,f){const r=P.URI.revive(E),l=this.g.getDocument(r);if(!l)throw new Error("unknown document");this.b.fire(l.document),l._acceptLanguageId(f),this.a.fire(l.document)}$acceptModelSaved(E){const f=P.URI.revive(E),r=this.g.getDocument(f);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(E,f){const r=P.URI.revive(E),l=this.g.getDocument(r);if(!l)throw new Error("unknown document");l._acceptIsDirty(f),this.c.fire({document:l.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,f,r){const l=P.URI.revive(E),d=this.g.getDocument(l);if(!d)throw new Error("unknown document");d._acceptIsDirty(r),d.onEvents(f);let a;f.isUndoing?a=I.TextDocumentChangeReason.Undo:f.isRedoing&&(a=I.TextDocumentChangeReason.Redo),this.c.fire((0,s.$jo)({document:d.document,contentChanges:f.changes.map(i=>({range:O.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:a}))}setWordDefinitionFor(E,f){(0,R.$FQ)(E,f)}}e.$Gqc=b}),define(Re[70],Te([1,0,239,6,14,2,3,5,16,8,7]),function(we,e,v,D,P,N,R,O,p,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_qc=e.$$qc=void 0,s=qe(s),e.$$qc=(0,R.$Ii)("IExtHostEditorTabs");class b{constructor(l,d,a){this.e=a,this.d=d,this.acceptDtoUpdate(l)}get apiObject(){if(!this.a){const l=this,d={get isActive(){return l.b.id===l.e()},get label(){return l.b.label},get input(){return l.c},get isDirty(){return l.b.isDirty},get isPinned(){return l.b.isPinned},get isPreview(){return l.b.isPreview},get group(){return l.d.apiObject}};this.a=Object.freeze(d)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(l){this.b=l,this.c=this.f()}f(){switch(this.b.input.kind){case O.TabInputKind.TextInput:return new I.$SP(N.URI.revive(this.b.input.uri));case O.TabInputKind.TextDiffInput:return new I.$TP(N.URI.revive(this.b.input.original),N.URI.revive(this.b.input.modified));case O.TabInputKind.TextMergeInput:return new I.$UP(N.URI.revive(this.b.input.base),N.URI.revive(this.b.input.input1),N.URI.revive(this.b.input.input2),N.URI.revive(this.b.input.result));case O.TabInputKind.CustomEditorInput:return new I.$VP(N.URI.revive(this.b.input.uri),this.b.input.viewType);case O.TabInputKind.WebviewEditorInput:return new I.$WP(this.b.input.viewType);case O.TabInputKind.NotebookInput:return new I.$XP(N.URI.revive(this.b.input.uri),this.b.input.notebookType);case O.TabInputKind.NotebookDiffInput:return new I.$YP(N.URI.revive(this.b.input.original),N.URI.revive(this.b.input.modified),this.b.input.notebookType);case O.TabInputKind.TerminalEditorInput:return new I.$ZP;case O.TabInputKind.InteractiveEditorInput:return new I.$1P(N.URI.revive(this.b.input.uri),N.URI.revive(this.b.input.inputBoxUri));case O.TabInputKind.ChatEditorInput:return new I.$2P;case O.TabInputKind.MultiDiffEditorInput:return new I.$3P(this.b.input.diffEditors.map(l=>new I.$TP(N.URI.revive(l.original),N.URI.revive(l.modified))));default:return}}}class h{constructor(l,d){this.c=[],this.d="",this.b=l,this.e=d;for(const a of l.tabs)a.isActive&&(this.d=a.id),this.c.push(new b(a,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const l=this,d={get isActive(){return l.b.groupId===l.e()},get viewColumn(){return s.ViewColumn.to(l.b.viewColumn)},get activeTab(){return l.c.find(a=>a.tabId===l.d)?.apiObject},get tabs(){return Object.freeze(l.c.map(a=>a.apiObject))}};this.a=Object.freeze(d)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(l){this.b=l}acceptTabOperation(l){if(l.kind===O.TabModelOperationKind.TAB_OPEN){const a=new b(l.tabDto,this,()=>this.activeTabId());return this.c.splice(l.index,0,a),l.tabDto.isActive&&(this.d=a.tabId),a}else if(l.kind===O.TabModelOperationKind.TAB_CLOSE){const a=this.c.splice(l.index,1)[0];if(!a)throw new Error(`Tab close updated received for index ${l.index} which does not exist`);return a.tabId===this.d&&(this.d=""),a}else if(l.kind===O.TabModelOperationKind.TAB_MOVE){if(l.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const a=this.c.splice(l.oldIndex,1)[0];if(!a)throw new Error(`Tab move updated received for index ${l.oldIndex} which does not exist`);return this.c.splice(l.index,0,a),a}const d=this.c.find(a=>a.tabId===l.tabDto.id);if(!d)throw new Error("INVALID tab");return l.tabDto.isActive?this.d=l.tabDto.id:this.d===l.tabDto.id&&!l.tabDto.isActive&&(this.d=""),d.acceptDtoUpdate(l.tabDto),d}activeTabId(){return this.d}}let E=class{constructor(l){this.b=new D.$oe,this.c=new D.$oe,this.e=[],this.a=l.getProxy(O.$3N.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const l=this,d={onDidChangeTabGroups:l.c.event,onDidChangeTabs:l.b.event,get all(){return Object.freeze(l.e.map(a=>a.apiObject))},get activeTabGroup(){const a=l.d;return(0,P.$sg)(l.e.find(n=>n.groupId===a)?.apiObject)},close:async(a,i)=>{const n=Array.isArray(a)?a:[a];return n.length?f(n[0])?this.j(n,i):this.i(n,i):!0}};this.f=Object.freeze(d)}return this.f}$acceptEditorTabModel(l){const d=new Set(this.e.map(m=>m.groupId)),a=new Set(l.map(m=>m.groupId)),i=(0,v.$d)(d,a),n=this.e.filter(m=>i.removed.includes(m.groupId)).map(m=>m.apiObject),t=[],o=[];this.e=l.map(m=>{const g=new h(m,()=>this.d);return i.added.includes(g.groupId)?t.push(g.apiObject):o.push(g.apiObject),g});const c=(0,P.$sg)(l.find(m=>m.isActive===!0)?.groupId);c!==void 0&&this.d!==c&&(this.d=c),this.c.fire(Object.freeze({opened:t,closed:n,changed:o}))}$acceptTabGroupUpdate(l){const d=this.e.find(a=>a.groupId===l.groupId);if(!d)throw new Error("Update Group IPC call received before group creation.");d.acceptGroupDtoUpdate(l),l.isActive&&(this.d=l.groupId),this.c.fire(Object.freeze({changed:[d.apiObject],opened:[],closed:[]}))}$acceptTabOperation(l){const d=this.e.find(i=>i.groupId===l.groupId);if(!d)throw new Error("Update Tabs IPC call received before group creation.");const a=d.acceptTabOperation(l);switch(l.kind){case O.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[a.apiObject],closed:[],changed:[]}));return;case O.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[a.apiObject],changed:[]}));return;case O.TabModelOperationKind.TAB_MOVE:case O.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[a.apiObject]}));return}}g(l){for(const d of this.e)for(const a of d.tabs)if(a.apiObject===l)return a}h(l){return this.e.find(d=>d.apiObject===l)}async i(l,d){const a=[];for(const i of l){const n=this.g(i);if(!n)throw new Error("Tab close: Invalid tab not found!");a.push(n.tabId)}return this.a.$closeTab(a,d)}async j(l,d){const a=[];for(const i of l){const n=this.h(i);if(!n)throw new Error("Group close: Invalid group not found!");a.push(n.groupId)}return this.a.$closeGroup(a,d)}};e.$_qc=E,e.$_qc=E=Ke([We(0,p.$DQ)],E);function f(r){return r.tabs!==void 0}}),define(Re[240],Te([1,0,2,5,28,4,7,8,285,13,30,20,21,59]),function(we,e,v,D,P,N,R,O,p,s,I,b,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vrc=void 0,P=qe(P),O=qe(O);class f{constructor(){this.a=[]}add(d){this.b=void 0,this.a.push(d)}delete(d){const a=this.a.indexOf(d);a>=0&&(this.a.splice(a,1),this.b=void 0)}c(){if(!this.b){const d=this.a.sort(),a=[];let i,n,t=p.State.LastKnownState,o=p.State.LastKnownState;for(const c of d){let m=i?(0,s.$Kf)(i,c):0;for(m===0?n=p.State.Start:n=o;m<c.length;m++)m+1===c.length?(t=o,o=p.State.BeforeColon):o+=1,a.push([n,c.toUpperCase().charCodeAt(m),o]),a.push([n,c.toLowerCase().charCodeAt(m),o]),n=o;i=c,o=t}a.push([p.State.BeforeColon,I.CharCode.Colon,p.State.AfterColon]),a.push([p.State.AfterColon,I.CharCode.Slash,p.State.End]),this.b=new p.$34(a)}}provideDocumentLinks(d){this.c();const a=[],i=p.$44.computeLinks({getLineContent(n){return d.lineAt(n-1).text},getLineCount(){return d.lineCount}},this.b);for(const n of i){const t=O.DocumentLink.to(n);t.target&&a.push(t)}return a}}class r{constructor(d,a){this.i=a,this.b=new f,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=d.getProxy(D.$3N.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(d,a,i,n={}){if(r.j(i),this.d.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(d,"*",this.b));const t=this.h++;this.b.add(a),this.d.add(a),this.c.set(t,i);let o=P.FileSystemProviderCapabilities.FileReadWrite;n.isCaseSensitive&&(o+=P.FileSystemProviderCapabilities.PathCaseSensitive),n.isReadonly&&(o+=P.FileSystemProviderCapabilities.Readonly),typeof i.copy=="function"&&(o+=P.FileSystemProviderCapabilities.FileFolderCopy),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,h.$wH)(d,"fsChunks"),o+=P.FileSystemProviderCapabilities.FileOpenReadWriteClose);let c;n.isReadonly&&(0,E.$9k)(n.isReadonly)&&n.isReadonly.value!==""&&(c={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(t,a,o,c).catch(g=>{console.error(`FAILED to register filesystem provider of ${d.identifier.value}-extension for the scheme ${a}`),console.error(g)});const m=i.onDidChangeFile(g=>{const u=[];for(const S of g){const{uri:k,type:y}=S;if(k.scheme!==a)continue;let C;switch(y){case R.FileChangeType.Changed:C=P.FileChangeType.UPDATED;break;case R.FileChangeType.Created:C=P.FileChangeType.ADDED;break;case R.FileChangeType.Deleted:C=P.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}u.push({resource:k,type:C})}this.a.$onFileSystemChange(t,u)});return(0,N.$Vc)(()=>{m.dispose(),this.b.delete(a),this.d.delete(a),this.c.delete(t),this.a.$unregisterProvider(t)})}static j(d){if(!d)throw new Error("MISSING provider");if(typeof d.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof d.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof d.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof d.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof d.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof d.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof d.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof d.rename!="function")throw new Error("Provider does NOT implement rename")}static k(d){const{type:a,ctime:i,mtime:n,size:t,permissions:o}=d;return{type:a,ctime:i,mtime:n,size:t,permissions:o}}$stat(d,a){return Promise.resolve(this.l(d).stat(v.URI.revive(a))).then(i=>r.k(i))}$readdir(d,a){return Promise.resolve(this.l(d).readDirectory(v.URI.revive(a)))}$readFile(d,a){return Promise.resolve(this.l(d).readFile(v.URI.revive(a))).then(i=>b.$Qe.wrap(i))}$writeFile(d,a,i,n){return Promise.resolve(this.l(d).writeFile(v.URI.revive(a),i.buffer,n))}$delete(d,a,i){return Promise.resolve(this.l(d).delete(v.URI.revive(a),i))}$rename(d,a,i,n){return Promise.resolve(this.l(d).rename(v.URI.revive(a),v.URI.revive(i),n))}$copy(d,a,i,n){const t=this.l(d);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(v.URI.revive(a),v.URI.revive(i),n))}$mkdir(d,a){return Promise.resolve(this.l(d).createDirectory(v.URI.revive(a)))}$watch(d,a,i,n){const t=this.l(d).watch(v.URI.revive(i),n);this.f.set(a,t)}$unwatch(d,a){const i=this.f.get(a);i&&(i.dispose(),this.f.delete(a))}$open(d,a,i){const n=this.l(d);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(v.URI.revive(a),i))}$close(d,a){const i=this.l(d);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(a))}$read(d,a,i,n){const t=this.l(d);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const o=b.$Qe.alloc(n);return Promise.resolve(t.read(a,i,o.buffer,0,n)).then(c=>o.slice(0,c))}$write(d,a,i,n){const t=this.l(d);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(a,i,n.buffer,0,n.byteLength))}l(d){const a=this.c.get(d);if(!a){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return a}}e.$Vrc=r}),define(Re[241],Te([1,0,6,41,2,5,8,7,28,51]),function(we,e,v,D,P,N,R,O,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wrc=void 0,R=qe(R);class I{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(f,r,l,d,a,i){this.a=Math.random(),this.b=new v.$oe,this.c=new v.$oe,this.d=new v.$oe,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,D.$Dk)(a),t=typeof a=="string",o=i?.correlate,c=d(m=>{if(!(typeof m.session=="number"&&m.session!==this.a)&&!(o&&typeof m.session>"u")){if(!i?.ignoreCreateEvents)for(const g of m.created){const u=P.URI.revive(g);n(u.fsPath)&&(!t||r.getWorkspaceFolder(u))&&this.b.fire(u)}if(!i?.ignoreChangeEvents)for(const g of m.changed){const u=P.URI.revive(g);n(u.fsPath)&&(!t||r.getWorkspaceFolder(u))&&this.c.fire(u)}if(!i?.ignoreDeleteEvents)for(const g of m.deleted){const u=P.URI.revive(g);n(u.fsPath)&&(!t||r.getWorkspaceFolder(u))&&this.d.fire(u)}}});this.g=O.$5N.from(this.i(f,l,a,i,i?.correlate),this.b,this.c,this.d,c)}i(f,r,l,d,a){const i=O.$5N.from();if(typeof l=="string"||d?.ignoreChangeEvents&&d?.ignoreCreateEvents&&d?.ignoreDeleteEvents)return i;const n=f.getProxy(N.$3N.MainThreadFileSystemEventService);let t=!1;(l.pattern.includes(D.$zk)||l.pattern.includes(D.$Ak))&&(t=!0);let o;return a&&(d?.ignoreChangeEvents||d?.ignoreCreateEvents||d?.ignoreDeleteEvents)&&(o=p.FileChangeFilter.UPDATED|p.FileChangeFilter.ADDED|p.FileChangeFilter.DELETED,d?.ignoreChangeEvents&&(o&=~p.FileChangeFilter.UPDATED),d?.ignoreCreateEvents&&(o&=~p.FileChangeFilter.ADDED),d?.ignoreDeleteEvents&&(o&=~p.FileChangeFilter.DELETED)),n.$watch(r.identifier.value,this.a,l.baseUri,{recursive:t,excludes:d?.excludes??[],filter:o},!!a),O.$5N.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class b{constructor(f){this.a=f,this.session=this.a.session,this.b=new s.$W(()=>this.a.created.map(P.URI.revive)),this.c=new s.$W(()=>this.a.changed.map(P.URI.revive)),this.d=new s.$W(()=>this.a.deleted.map(P.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class h{constructor(f,r,l){this.j=f,this.k=r,this.l=l,this.a=new v.$oe,this.b=new v.$oe,this.c=new v.$oe,this.d=new v.$oe,this.g=new v.$qe,this.h=new v.$qe,this.i=new v.$qe,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(f,r,l,d){return new I(this.j,f,r,this.a.event,R.GlobPattern.from(l),d)}$onFileEvent(f){this.a.fire(new b(f))}$onDidRunFileOperation(f,r){switch(f){case p.FileOperation.MOVE:this.b.fire(Object.freeze({files:r.map(l=>({oldUri:P.URI.revive(l.source),newUri:P.URI.revive(l.target)}))}));break;case p.FileOperation.DELETE:this.d.fire(Object.freeze({files:r.map(l=>P.URI.revive(l.target))}));break;case p.FileOperation.CREATE:case p.FileOperation.COPY:this.c.fire(Object.freeze({files:r.map(l=>P.URI.revive(l.target))}));break;default:}}getOnWillRenameFileEvent(f){return this.m(f,this.g)}getOnWillCreateFileEvent(f){return this.m(f,this.h)}getOnWillDeleteFileEvent(f){return this.m(f,this.i)}m(f,r){return(l,d,a)=>{const i=function(t){l.call(d,t)};return i.extension=f,r.event(i,void 0,a)}}async $onWillRunFileOperation(f,r,l,d){switch(f){case p.FileOperation.MOVE:return await this.n(this.g,{files:r.map(a=>({oldUri:P.URI.revive(a.source),newUri:P.URI.revive(a.target)}))},l,d);case p.FileOperation.DELETE:return await this.n(this.i,{files:r.map(a=>P.URI.revive(a.target))},l,d);case p.FileOperation.CREATE:case p.FileOperation.COPY:return await this.n(this.h,{files:r.map(a=>P.URI.revive(a.target))},l,d)}}async n(f,r,l,d){const a=new Set,i=[];if(await f.fireAsync(r,d,async(t,o)=>{const c=Date.now(),m=await Promise.resolve(t);m instanceof O.$eO&&(i.push([o.extension,m]),a.add(o.extension.displayName??o.extension.identifier.value)),Date.now()-c>l&&this.k.warn("SLOW file-participant",o.extension.identifier)}),d.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,t]of i){const{edits:o}=R.WorkspaceEdit.from(t,{getTextDocumentVersion:c=>this.l.getDocument(c)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(o)}return{edit:n,extensionNames:Array.from(a)}}}e.$Wrc=h}),define(Re[242],Te([1,0,17,10,19,12,97,4,25,69,13,14,2,32,286,94,104,9,18,8,7,21,80,5]),function(we,e,v,D,P,N,R,O,p,s,I,b,h,E,f,r,l,d,a,i,n,t,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hqc=void 0,r=qe(r),i=qe(i),c=qe(c);class m{constructor(B,j){this.d=B,this.e=j}async provideDocumentSymbols(B,j){const H=this.d.getDocument(B),G=await this.e.provideDocumentSymbols(H,j);if(!(0,v.$Mb)(G))return G[0]instanceof n.$oO?G.map(i.DocumentSymbol.from):m.f(G)}static f(B){B=B.slice(0).sort((G,se)=>{let ge=G.location.range.start.compareTo(se.location.range.start);return ge===0&&(ge=se.location.range.end.compareTo(G.location.range.end)),ge});const j=[],H=[];for(const G of B){const se={name:G.name||"!!MISSING: name!!",kind:i.SymbolKind.from(G.kind),tags:G.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:G.containerName,range:i.Range.from(G.location.range),selectionRange:i.Range.from(G.location.range),children:[]};for(;;){if(H.length===0){H.push(se),j.push(se);break}const ge=H[H.length-1];if(E.$Ut.containsRange(ge.range,se.range)&&!E.$Ut.equalsRange(ge.range,se.range)){ge.children?.push(se),H.push(se);break}H.pop()}}return j}}class g{constructor(B,j,H,G,se,ge){this.f=B,this.g=j,this.h=H,this.j=G,this.k=se,this.l=ge,this.d=new o.$xqc("CodeLens"),this.e=new Map}async provideCodeLenses(B,j){const H=this.f.getDocument(B),G=await this.h.provideCodeLenses(H,j);if(!G||j.isCancellationRequested)return;const se=this.d.add(G),ge=new O.$Wc;this.e.set(se,ge);const Ee={cacheId:se,lenses:[]};for(let Ue=0;Ue<G.length;Ue++)Ee.lenses.push({cacheId:[se,Ue],range:i.Range.from(G[Ue].range),command:this.g.toInternal(G[Ue].command,ge)});return Ee}async resolveCodeLens(B,j){const H=B.cacheId&&this.d.get(...B.cacheId);if(!H)return;let G;if(typeof this.h.resolveCodeLens!="function"||H.isResolved?G=H:G=await this.h.resolveCodeLens(H,j),G||(G=H),j.isCancellationRequested)return;const se=B.cacheId&&this.e.get(B.cacheId[0]);if(se){if(!G.command){const ge=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,ge),this.l.error(ge);return}return B.command=this.g.toInternal(G.command,se),B}}releaseCodeLenses(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}}function u(Le){return Array.isArray(Le)?Le.map(i.DefinitionLink.from):Le?[i.DefinitionLink.from(Le)]:[]}class S{constructor(B,j){this.d=B,this.e=j}async provideDefinition(B,j,H){const G=this.d.getDocument(B),se=i.Position.to(j),ge=await this.e.provideDefinition(G,se,H);return u(ge)}}class k{constructor(B,j){this.d=B,this.e=j}async provideDeclaration(B,j,H){const G=this.d.getDocument(B),se=i.Position.to(j),ge=await this.e.provideDeclaration(G,se,H);return u(ge)}}class y{constructor(B,j){this.d=B,this.e=j}async provideImplementation(B,j,H){const G=this.d.getDocument(B),se=i.Position.to(j),ge=await this.e.provideImplementation(G,se,H);return u(ge)}}class C{constructor(B,j){this.d=B,this.e=j}async provideTypeDefinition(B,j,H){const G=this.d.getDocument(B),se=i.Position.to(j),ge=await this.e.provideTypeDefinition(G,se,H);return u(ge)}}class T{static{this.f=10}constructor(B,j){this.g=B,this.h=j,this.d=0,this.e=new Map}async provideHover(B,j,H,G){const se=this.g.getDocument(B),ge=i.Position.to(j);let Ee;if(H&&H.verbosityRequest){const tt=H.verbosityRequest.previousHover.id,at=this.e.get(tt);if(!at)throw new Error(`Hover with id ${tt} not found`);const it={verbosityDelta:H.verbosityRequest.verbosityDelta,previousHover:at};Ee=await this.h.provideHover(se,ge,G,it)}else Ee=await this.h.provideHover(se,ge,G);if(!Ee||(0,v.$Mb)(Ee.contents))return;Ee.range||(Ee.range=se.getWordRangeAtPosition(ge)),Ee.range||(Ee.range=new n.$7N(ge,ge));const Ue=i.Hover.from(Ee),Je=this.d;if(this.e.size===T.f){const tt=Math.min(...this.e.keys());this.e.delete(tt)}return this.e.set(Je,Ee),this.d+=1,{...Ue,id:Je}}releaseHover(B){this.e.delete(B)}}class ${constructor(B,j){this.d=B,this.e=j}async provideEvaluatableExpression(B,j,H){const G=this.d.getDocument(B),se=i.Position.to(j),ge=await this.e.provideEvaluatableExpression(G,se,H);if(ge)return i.EvaluatableExpression.from(ge)}}class w{constructor(B,j){this.d=B,this.e=j}async provideInlineValues(B,j,H,G){const se=this.d.getDocument(B),ge=await this.e.provideInlineValues(se,i.Range.to(j),i.InlineValueContext.to(H),G);if(Array.isArray(ge))return ge.map(Ee=>i.InlineValue.from(Ee))}}class M{constructor(B,j){this.d=B,this.e=j}async provideDocumentHighlights(B,j,H){const G=this.d.getDocument(B),se=i.Position.to(j),ge=await this.e.provideDocumentHighlights(G,se,H);if(Array.isArray(ge))return ge.map(i.DocumentHighlight.from)}}class A{constructor(B,j){this.d=B,this.e=j}async provideMultiDocumentHighlights(B,j,H,G){const se=this.d.getDocument(B),ge=H.map(Je=>this.d.getDocument(Je)),Ee=i.Position.to(j),Ue=await this.e.provideMultiDocumentHighlights(se,Ee,ge,G);if(Array.isArray(Ue))return Ue.map(i.MultiDocumentHighlight.from)}}class L{constructor(B,j){this.d=B,this.e=j}async provideLinkedEditingRanges(B,j,H){const G=this.d.getDocument(B),se=i.Position.to(j),ge=await this.e.provideLinkedEditingRanges(G,se,H);if(ge&&Array.isArray(ge.ranges))return{ranges:(0,v.$Jb)(ge.ranges.map(i.Range.from)),wordPattern:ge.wordPattern}}}class J{constructor(B,j){this.d=B,this.e=j}async provideReferences(B,j,H,G){const se=this.d.getDocument(B),ge=i.Position.to(j),Ee=await this.e.provideReferences(se,ge,H,G);if(Array.isArray(Ee))return Ee.map(i.location.from)}}class Y{static{this.d=1e3}constructor(B,j,H,G,se,ge,Ee){this.g=B,this.h=j,this.j=H,this.k=G,this.l=se,this.m=ge,this.n=Ee,this.e=new o.$xqc("CodeAction"),this.f=new Map}async provideCodeActions(B,j,H,G){const se=this.g.getDocument(B),ge=f.$Wt.isISelection(j)?i.Selection.to(j):i.Range.to(j),Ee=[];for(const it of this.j.getDiagnostics(B))if(ge.intersection(it.range)&&Ee.push(it)>Y.d)break;const Ue={diagnostics:Ee,only:H.only?new n.$qO(H.only):void 0,triggerKind:i.CodeActionTriggerKind.to(H.trigger)},Je=await this.k.provideCodeActions(se,ge,Ue,G);if(!(0,v.$Nb)(Je)||G.isCancellationRequested)return;const _e=this.e.add(Je),tt=new O.$Wc;this.f.set(_e,tt);const at=[];for(let it=0;it<Je.length;it++){const ot=Je[it];if(ot)if(Y.o(ot))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),at.push({_isSynthetic:!0,title:ot.title,command:this.h.toInternal(ot,tt)});else{Ue.only&&(ot.kind?Ue.only.contains(ot.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ue.only.value}' requested but returned code action is of kind '${ot.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ue.only.value}' requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const vt=ot.ranges??[];at.push({cacheId:[_e,it],title:ot.title,command:ot.command&&this.h.toInternal(ot.command,tt),diagnostics:ot.diagnostics&&ot.diagnostics.map(i.Diagnostic.from),edit:ot.edit&&i.WorkspaceEdit.from(ot.edit,void 0),kind:ot.kind&&ot.kind.value,isPreferred:ot.isPreferred,isAI:(0,t.$vH)(this.m,"codeActionAI")?ot.isAI:!1,ranges:(0,t.$vH)(this.m,"codeActionRanges")?(0,v.$Jb)(vt.map(i.Range.from)):void 0,disabled:ot.disabled?.reason})}}return{cacheId:_e,actions:at}}async resolveCodeAction(B,j){const[H,G]=B,se=this.e.get(H,G);if(!se||Y.o(se))return{};if(!this.k.resolveCodeAction)return{};const ge=await this.k.resolveCodeAction(se,j)??se;let Ee;ge.edit&&(Ee=i.WorkspaceEdit.from(ge.edit,void 0));let Ue;if(ge.command){const Je=this.f.get(H);Je&&(Ue=this.h.toInternal(ge.command,Je))}return{edit:Ee,command:Ue}}releaseCodeActions(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}static o(B){return typeof B.command=="string"&&typeof B.title=="string"}}class z{constructor(B,j,H,G,se){this.e=B,this.f=j,this.g=H,this.h=G,this.j=se,this.d=new o.$xqc("DocumentPasteEdit")}async prepareDocumentPaste(B,j,H,G){if(!this.g.prepareDocumentPaste)return;const se=this.f.getDocument(B),ge=j.map(Je=>i.Range.to(Je)),Ee=i.DataTransfer.toDataTransfer(H,()=>{throw new N.$ab});if(await this.g.prepareDocumentPaste(se,ge,Ee,G),G.isCancellationRequested)return;const Ue=Array.from(Ee).filter(([,Je])=>!(Je instanceof n.$WO));return i.DataTransfer.from(Ue)}async providePasteEdits(B,j,H,G,se,ge){if(!this.g.provideDocumentPasteEdits)return[];const Ee=this.f.getDocument(j),Ue=H.map(at=>i.Range.to(at)),Je=i.DataTransfer.toDataTransfer(G,async at=>(await this.e.$resolvePasteFileData(this.h,B,at)).buffer),_e=await this.g.provideDocumentPasteEdits(Ee,Ue,Je,{only:se.only?new n.$2O(se.only):void 0,triggerKind:se.triggerKind},ge);if(!_e||ge.isCancellationRequested)return[];const tt=this.d.add(_e);return _e.map((at,it)=>({_cacheId:[tt,it],title:at.title??(0,d.localize)(2703,null,this.j.displayName||this.j.name),kind:at.kind,yieldTo:at.yieldTo?.map(ot=>ot.value),insertText:typeof at.insertText=="string"?at.insertText:{snippet:at.insertText.value},additionalEdit:at.additionalEdit?i.WorkspaceEdit.from(at.additionalEdit,void 0):void 0}))}async resolvePasteEdit(B,j){const[H,G]=B,se=this.d.get(H,G);if(!se||!this.g.resolveDocumentPasteEdit)return{};const ge=await this.g.resolveDocumentPasteEdit(se,j)??se;return{additionalEdit:ge.additionalEdit?i.WorkspaceEdit.from(ge.additionalEdit,void 0):void 0}}releasePasteEdits(B){this.d.delete(B)}}class Q{constructor(B,j){this.d=B,this.e=j}async provideDocumentFormattingEdits(B,j,H){const G=this.d.getDocument(B),se=await this.e.provideDocumentFormattingEdits(G,j,H);if(Array.isArray(se))return se.map(i.TextEdit.from)}}class V{constructor(B,j){this.d=B,this.e=j}async provideDocumentRangeFormattingEdits(B,j,H,G){const se=this.d.getDocument(B),ge=i.Range.to(j),Ee=await this.e.provideDocumentRangeFormattingEdits(se,ge,H,G);if(Array.isArray(Ee))return Ee.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,j,H,G){(0,b.$rg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const se=this.d.getDocument(B),ge=j.map(i.Range.to),Ee=await this.e.provideDocumentRangesFormattingEdits(se,ge,H,G);if(Array.isArray(Ee))return Ee.map(i.TextEdit.from)}}class ie{constructor(B,j){this.d=B,this.e=j,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,j,H,G,se){const ge=this.d.getDocument(B),Ee=i.Position.to(j),Ue=await this.e.provideOnTypeFormattingEdits(ge,Ee,H,G,se);if(Array.isArray(Ue))return Ue.map(i.TextEdit.from)}}class le{constructor(B,j){this.e=B,this.f=j,this.d=new o.$xqc("WorkspaceSymbols")}async provideWorkspaceSymbols(B,j){const H=await this.e.provideWorkspaceSymbols(B,j);if(!(0,v.$Nb)(H))return{symbols:[]};const G=this.d.add(H),se={cacheId:G,symbols:[]};for(let ge=0;ge<H.length;ge++){const Ee=H[ge];if(!Ee||!Ee.name){this.f.warn("INVALID SymbolInformation",Ee);continue}se.symbols.push({...i.WorkspaceSymbol.from(Ee),cacheId:[G,ge]})}return se}async resolveWorkspaceSymbol(B,j){if(typeof this.e.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const H=this.d.get(...B.cacheId);if(H){const G=await this.e.resolveWorkspaceSymbol(H,j);return G&&(0,p.$lo)(B,i.WorkspaceSymbol.from(G),!0)}}releaseWorkspaceSymbols(B){this.d.delete(B)}}class _{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,j,H){this.d=B,this.e=j,this.f=H}async provideRenameEdits(B,j,H,G){const se=this.d.getDocument(B),ge=i.Position.to(j);try{const Ee=await this.e.provideRenameEdits(se,ge,H,G);return Ee?i.WorkspaceEdit.from(Ee):void 0}catch(Ee){const Ue=_.g(Ee);return Ue?{rejectReason:Ue,edits:void 0}:Promise.reject(Ee)}}async resolveRenameLocation(B,j,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const G=this.d.getDocument(B),se=i.Position.to(j);try{const ge=await this.e.prepareRename(G,se,H);let Ee,Ue;if(n.$7N.isRange(ge)?(Ee=ge,Ue=G.getText(ge)):(0,b.$jg)(ge)&&(Ee=ge.range,Ue=ge.placeholder),!Ee||!Ue)return;if(Ee.start.line>se.line||Ee.end.line<se.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Ee),text:Ue}}catch(ge){const Ee=_.g(ge);return Ee?{rejectReason:Ee,range:void 0,text:void 0}:Promise.reject(ge)}}static g(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class oe{static{this.d={[r.NewSymbolNameTriggerKind.Invoke]:n.NewSymbolNameTriggerKind.Invoke,[r.NewSymbolNameTriggerKind.Automatic]:n.NewSymbolNameTriggerKind.Automatic}}constructor(B,j,H){this.e=B,this.f=j,this.g=H}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(B,j,H,G){const se=this.e.getDocument(B),ge=i.Range.to(j);try{const Ee=oe.d[H],Ue=await this.f.provideNewSymbolNames(se,ge,Ee,G);return Ue?Ue.map(Je=>typeof Je=="string"?{newSymbolName:Je}:{newSymbolName:Je.newSymbolName,tags:Je.tags}):void 0}catch(Ee){this.g.error(oe.h(Ee)??JSON.stringify(Ee,null,"	"));return}}static h(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class re{constructor(B,j){this.resultId=B,this.tokens=j}}class ce{constructor(B,j){this.f=B,this.g=j,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(B,j,H){const G=this.f.getDocument(B),se=j!==0?this.d.get(j):null;let ge=typeof se?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(G,se.resultId,H):await this.g.provideDocumentSemanticTokens(G,H);return se&&this.d.delete(j),ge?(ge=ce.h(ge),this.o(ce.n(se,ge),ge)):null}async releaseDocumentSemanticColoring(B){this.d.delete(B)}static h(B){return ce.j(B)?ce.k(B)?B:new n.$pP(new Uint32Array(B.data),B.resultId):ce.l(B)?ce.m(B)?B:new n.$rP(B.edits.map(j=>new n.$qP(j.start,j.deleteCount,j.data?new Uint32Array(j.data):j.data)),B.resultId):B}static j(B){return B&&!!B.data}static k(B){return B.data instanceof Uint32Array}static l(B){return B&&Array.isArray(B.edits)}static m(B){for(const j of B.edits)if(!(j.data instanceof Uint32Array))return!1;return!0}static n(B,j){if(!ce.j(j)||!B||!B.tokens)return j;const H=B.tokens,G=H.length,se=j.data,ge=se.length;let Ee=0;const Ue=Math.min(G,ge);for(;Ee<Ue&&H[Ee]===se[Ee];)Ee++;if(Ee===G&&Ee===ge)return new n.$rP([],j.resultId);let Je=0;const _e=Ue-Ee;for(;Je<_e&&H[G-Je-1]===se[ge-Je-1];)Je++;return new n.$rP([{start:Ee,deleteCount:G-Ee-Je,data:se.subarray(Ee,ge-Je)}],j.resultId)}o(B,j){if(ce.j(B)){const H=this.e++;return this.d.set(H,new re(B.resultId,B.data)),(0,l.$oeb)({id:H,type:"full",data:B.data})}if(ce.l(B)){const H=this.e++;return ce.j(j)?this.d.set(H,new re(j.resultId,j.data)):this.d.set(H,new re(B.resultId)),(0,l.$oeb)({id:H,type:"delta",deltas:(B.edits||[]).map(G=>({start:G.start,deleteCount:G.deleteCount,data:G.data}))})}return null}}class x{constructor(B,j){this.d=B,this.e=j}async provideDocumentRangeSemanticTokens(B,j,H){const G=this.d.getDocument(B),se=await this.e.provideDocumentRangeSemanticTokens(G,i.Range.to(j),H);return se?this.f(se):null}f(B){return(0,l.$oeb)({id:0,type:"full",data:B.data})}}class $e{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,j,H,G,se){this.f=B,this.g=j,this.h=H,this.j=G,this.k=se,this.d=new o.$xqc("CompletionItem"),this.e=new Map}async provideCompletionItems(B,j,H,G){const se=this.f.getDocument(B),ge=i.Position.to(j),Ee=se.getWordRangeAtPosition(ge)||new n.$7N(ge,ge),Ue=Ee.with({end:ge}),Je=new s.$ie,_e=await this.h.provideCompletionItems(se,ge,G,i.CompletionContext.to(H));if(!_e||G.isCancellationRequested)return;const tt=Array.isArray(_e)?new n.$DO(_e):_e,at=$e.supportsResolving(this.h)?this.d.add(tt.items):this.d.add([]),it=new O.$Wc;this.e.set(at,it);const ot=[],vt={x:at,[c.ISuggestResultDtoField.completions]:ot,[c.ISuggestResultDtoField.defaultRanges]:{replace:i.Range.from(Ee),insert:i.Range.from(Ue)},[c.ISuggestResultDtoField.isIncomplete]:tt.isIncomplete||void 0,[c.ISuggestResultDtoField.duration]:Je.elapsed()};for(let Ye=0;Ye<tt.items.length;Ye++){const he=tt.items[Ye],pe=this.l(he,[at,Ye],Ue,Ee);ot.push(pe)}return vt}async resolveCompletionItem(B,j){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...B);if(!H)return;const G=this.l(H,B),se=await this.h.resolveCompletionItem(H,j);if(!se)return;const ge=this.l(se,B);return(G[c.ISuggestDataDtoField.insertText]!==ge[c.ISuggestDataDtoField.insertText]||G[c.ISuggestDataDtoField.insertTextRules]!==ge[c.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(G[c.ISuggestDataDtoField.commandIdent]!==ge[c.ISuggestDataDtoField.commandIdent]||G[c.ISuggestDataDtoField.commandId]!==ge[c.ISuggestDataDtoField.commandId]||!(0,p.$mo)(G[c.ISuggestDataDtoField.commandArguments],ge[c.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...G,[c.ISuggestDataDtoField.documentation]:ge[c.ISuggestDataDtoField.documentation],[c.ISuggestDataDtoField.detail]:ge[c.ISuggestDataDtoField.detail],[c.ISuggestDataDtoField.additionalTextEdits]:ge[c.ISuggestDataDtoField.additionalTextEdits],[c.ISuggestDataDtoField.insertText]:ge[c.ISuggestDataDtoField.insertText],[c.ISuggestDataDtoField.insertTextRules]:ge[c.ISuggestDataDtoField.insertTextRules],[c.ISuggestDataDtoField.commandIdent]:ge[c.ISuggestDataDtoField.commandIdent],[c.ISuggestDataDtoField.commandId]:ge[c.ISuggestDataDtoField.commandId],[c.ISuggestDataDtoField.commandArguments]:ge[c.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,j,H,G){const se=this.e.get(j[0]);if(!se)throw Error("DisposableStore is missing...");const ge=this.g.toInternal(B.command,se),Ee={x:j,[c.ISuggestDataDtoField.label]:B.label,[c.ISuggestDataDtoField.kind]:B.kind!==void 0?i.CompletionItemKind.from(B.kind):void 0,[c.ISuggestDataDtoField.kindModifier]:B.tags&&B.tags.map(i.CompletionItemTag.from),[c.ISuggestDataDtoField.detail]:B.detail,[c.ISuggestDataDtoField.documentation]:typeof B.documentation>"u"?void 0:i.MarkdownString.fromStrict(B.documentation),[c.ISuggestDataDtoField.sortText]:B.sortText!==B.label?B.sortText:void 0,[c.ISuggestDataDtoField.filterText]:B.filterText!==B.label?B.filterText:void 0,[c.ISuggestDataDtoField.preselect]:B.preselect||void 0,[c.ISuggestDataDtoField.insertTextRules]:B.keepWhitespace?r.CompletionItemInsertTextRule.KeepWhitespace:r.CompletionItemInsertTextRule.None,[c.ISuggestDataDtoField.commitCharacters]:B.commitCharacters?.join(""),[c.ISuggestDataDtoField.additionalTextEdits]:B.additionalTextEdits&&B.additionalTextEdits.map(i.TextEdit.from),[c.ISuggestDataDtoField.commandIdent]:ge?.$ident,[c.ISuggestDataDtoField.commandId]:ge?.id,[c.ISuggestDataDtoField.commandArguments]:ge?.$ident?void 0:ge?.arguments};B.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ee[c.ISuggestDataDtoField.insertText]=B.textEdit.newText):typeof B.insertText=="string"?Ee[c.ISuggestDataDtoField.insertText]=B.insertText:B.insertText instanceof n.$fO&&(Ee[c.ISuggestDataDtoField.insertText]=B.insertText.value,Ee[c.ISuggestDataDtoField.insertTextRules]|=r.CompletionItemInsertTextRule.InsertAsSnippet);let Ue;return B.textEdit?Ue=B.textEdit.range:B.range&&(Ue=B.range),n.$7N.isRange(Ue)?Ee[c.ISuggestDataDtoField.range]=i.Range.from(Ue):Ue&&(!H?.isEqual(Ue.inserting)||!G?.isEqual(Ue.replacing))&&(Ee[c.ISuggestDataDtoField.range]={insert:i.Range.from(Ue.inserting),replace:i.Range.from(Ue.replacing)}),Ee}}class Pe{async provideInlineCompletions(B,j,H,G){}async provideInlineEdits(B,j,H,G){}disposeCompletions(B){}handleDidShowCompletionItem(B,j,H){}handlePartialAccept(B,j,H,G){}}class X extends Pe{constructor(B,j,H,G){super(),this.f=B,this.g=j,this.h=H,this.j=G,this.d=new ne,this.e=(0,t.$vH)(this.f,"inlineCompletionsAdditions"),this.k={[r.InlineCompletionTriggerKind.Automatic]:n.InlineCompletionTriggerKind.Automatic,[r.InlineCompletionTriggerKind.Explicit]:n.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$vH)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,j,H,G){const se=this.g.getDocument(B),ge=i.Position.to(j),Ee=await this.h.provideInlineCompletionItems(se,ge,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:i.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},G);if(!Ee||G.isCancellationRequested)return;const Ue=Array.isArray(Ee)?Ee:Ee.items,Je=this.e?Array.isArray(Ee)?[]:Ee.commands||[]:[],_e=this.e&&!Array.isArray(Ee)?Ee.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:Ue}),items:Ue.map((it,ot)=>{let vt;it.command&&(tt||(tt=new O.$Wc),vt=this.j.toInternal(it.command,tt));const Ye=it.insertText;return{insertText:typeof Ye=="string"?Ye:{snippet:Ye.value},filterText:it.filterText,range:it.range?i.Range.from(it.range):void 0,command:vt,idx:ot,completeBracketPairs:this.e?it.completeBracketPairs:!1}}),commands:Je.map(it=>(tt||(tt=new O.$Wc),this.j.toInternal(it,tt))),suppressSuggestions:!1,enableForwardStability:_e}}async provideInlineEdits(B,j,H,G){if(!this.h.provideInlineEdits)return;(0,t.$wH)(this.f,"inlineCompletionsAdditions");const se=this.g.getDocument(B),ge=i.Range.to(j),Ee=await this.h.provideInlineEdits(se,ge,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:i.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind],userPrompt:H.userPrompt},G);if(!Ee||G.isCancellationRequested)return;const Ue=Array.isArray(Ee)?Ee:Ee.items,Je=this.e?Array.isArray(Ee)?[]:Ee.commands||[]:[],_e=this.e&&!Array.isArray(Ee)?Ee.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:Ue}),items:Ue.map((it,ot)=>{let vt;it.command&&(tt||(tt=new O.$Wc),vt=this.j.toInternal(it.command,tt));const Ye=it.insertText;return{insertText:typeof Ye=="string"?Ye:{snippet:Ye.value},filterText:it.filterText,range:it.range?i.Range.from(it.range):void 0,command:vt,idx:ot,completeBracketPairs:this.e?it.completeBracketPairs:!1}}),commands:Je.map(it=>(tt||(tt=new O.$Wc),this.j.toInternal(it,tt))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(B){this.d.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,j,H){const G=this.d.get(B)?.items[j];G&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(G,H)}handlePartialAccept(B,j,H,G){const se=this.d.get(B)?.items[j];se&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(se,H),this.h.handleDidPartiallyAcceptCompletionItem(se,i.PartialAcceptInfo.to(G)))}}class q{async provideInlineEdits(B,j,H){const G=this.f.getDocument(B),se=await this.g.provideInlineEdit(G,{triggerKind:this.e[j.triggerKind]},H);if(!se||H.isCancellationRequested)return;let ge;const Ee=this.d.createReferenceId({dispose(){ge?.dispose()},item:se});let Ue;se.accepted&&(ge||(ge=new O.$Wc),Ue=this.h.toInternal(se.accepted,ge));let Je;return se.rejected&&(ge||(ge=new O.$Wc),Je=this.h.toInternal(se.rejected,ge)),{pid:Ee,text:se.text,range:i.Range.from(se.range),accepted:Ue,rejected:Je}}disposeEdit(B){this.d.disposeReferenceId(B)?.dispose()}constructor(B,j,H,G){this.f=j,this.g=H,this.h=G,this.d=new ne,this.e={[r.InlineEditTriggerKind.Automatic]:n.InlineEditTriggerKind.Automatic,[r.InlineEditTriggerKind.Invoke]:n.InlineEditTriggerKind.Invoke}}}class ne{constructor(){this.d=new Map,this.e=1}createReferenceId(B){const j=this.e++;return this.d.set(j,B),j}disposeReferenceId(B){const j=this.d.get(B);return this.d.delete(B),j}get(B){return this.d.get(B)}}class be{constructor(B,j){this.e=B,this.f=j,this.d=new o.$xqc("SignatureHelp")}async provideSignatureHelp(B,j,H,G){const se=this.e.getDocument(B),ge=i.Position.to(j),Ee=this.g(H),Ue=await this.f.provideSignatureHelp(se,ge,G,Ee);if(Ue){const Je=this.d.add([Ue]);return{...i.SignatureHelp.from(Ue),id:Je}}}g(B){let j;if(B.activeSignatureHelp){const H=i.SignatureHelp.to(B.activeSignatureHelp),G=this.d.get(B.activeSignatureHelp.id,0);G?(j=G,j.activeSignature=H.activeSignature,j.activeParameter=H.activeParameter):j=H}return{...B,activeSignatureHelp:j}}releaseSignatureHelp(B){this.d.delete(B)}}class Ie{constructor(B,j,H,G,se){this.f=B,this.g=j,this.h=H,this.j=G,this.k=se,this.d=new o.$xqc("InlayHints"),this.e=new Map}async provideInlayHints(B,j,H){const G=this.f.getDocument(B),se=i.Range.to(j),ge=await this.h.provideInlayHints(G,se,H);if(!Array.isArray(ge)||ge.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(j)}`);return}if(H.isCancellationRequested)return;const Ee=this.d.add(ge);this.e.set(Ee,new O.$Wc);const Ue={hints:[],cacheId:Ee};for(let Je=0;Je<ge.length;Je++)this.l(ge[Je],se)&&Ue.hints.push(this.m(ge[Je],[Ee,Je]));return this.j.trace(`[InlayHints] ${Ue.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(j)}`),Ue}async resolveInlayHint(B,j){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...B);if(!H)return;const G=await this.h.resolveInlayHint(H,j);if(G&&this.l(G))return this.m(G,B)}releaseHints(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,j){return B.label.length===0||Array.isArray(B.label)&&B.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(j&&!j.contains(B.position))}m(B,j){const H=this.e.get(j[0]);if(!H)throw Error("DisposableStore is missing...");const G={label:"",cacheId:j,tooltip:i.MarkdownString.fromStrict(B.tooltip),position:i.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(i.TextEdit.from),kind:B.kind&&i.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};if(typeof B.label=="string")G.label=B.label;else{const se=[];G.label=se;for(const ge of B.label){if(!ge.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ee={label:ge.value,tooltip:i.MarkdownString.fromStrict(ge.tooltip)};n.$gO.isLocation(ge.location)&&(Ee.location=i.location.from(ge.location)),ge.command&&(Ee.command=this.g.toInternal(ge.command,H)),se.push(Ee)}}return G}}class Fe{constructor(B,j){this.e=B,this.f=j,this.d=new o.$xqc("DocumentLink")}async provideLinks(B,j){const H=this.e.getDocument(B),G=await this.f.provideDocumentLinks(H,j);if(!(!Array.isArray(G)||G.length===0)&&!j.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:G.filter(Fe.g).map(i.DocumentLink.from)};{const se=this.d.add(G),ge={links:[],cacheId:se};for(let Ee=0;Ee<G.length;Ee++){if(!Fe.g(G[Ee]))continue;const Ue=i.DocumentLink.from(G[Ee]);Ue.cacheId=[se,Ee],ge.links.push(Ue)}return ge}}}static g(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,j){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...B);if(!H)return;const G=await this.f.resolveDocumentLink(H,j);if(!(!G||!Fe.g(G)))return i.DocumentLink.from(G)}releaseLinks(B){this.d.delete(B)}}class Be{constructor(B,j){this.d=B,this.e=j}async provideColors(B,j){const H=this.d.getDocument(B),G=await this.e.provideDocumentColors(H,j);return Array.isArray(G)?G.map(ge=>({color:i.Color.from(ge.color),range:i.Range.from(ge.range)})):[]}async provideColorPresentations(B,j,H){const G=this.d.getDocument(B),se=i.Range.to(j.range),ge=i.Color.to(j.color),Ee=await this.e.provideColorPresentations(ge,{document:G,range:se},H);if(Array.isArray(Ee))return Ee.map(i.ColorPresentation.from)}}class xe{constructor(B,j){this.d=B,this.e=j}async provideFoldingRanges(B,j,H){const G=this.d.getDocument(B),se=await this.e.provideFoldingRanges(G,j,H);if(Array.isArray(se))return se.map(i.FoldingRange.from)}}class nt{constructor(B,j,H){this.d=B,this.e=j,this.f=H}async provideSelectionRanges(B,j,H){const G=this.d.getDocument(B),se=j.map(i.Position.to),ge=await this.e.provideSelectionRanges(G,se,H);if(!(0,v.$Nb)(ge))return[];if(ge.length!==se.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ee=[];for(let Ue=0;Ue<se.length;Ue++){const Je=[];Ee.push(Je);let _e=se[Ue],tt=ge[Ue];for(;;){if(!tt.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(Je.push(i.SelectionRange.from(tt)),!tt.parent)break;_e=tt.range,tt=tt.parent}}return Ee}}class ut{constructor(B,j){this.f=B,this.g=j,this.d=new R.$IQ(""),this.e=new Map}async prepareSession(B,j,H){const G=this.f.getDocument(B),se=i.Position.to(j),ge=await this.g.prepareCallHierarchy(G,se,H);if(!ge)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(ge)?ge.map(Ue=>this.h(Ee,Ue)):[this.h(Ee,ge)]}async provideCallsTo(B,j,H){const G=this.j(B,j);if(!G)throw new Error("missing call hierarchy item");const se=await this.g.provideCallHierarchyIncomingCalls(G,H);if(se)return se.map(ge=>({from:this.h(B,ge.from),fromRanges:ge.fromRanges.map(Ee=>i.Range.from(Ee))}))}async provideCallsFrom(B,j,H){const G=this.j(B,j);if(!G)throw new Error("missing call hierarchy item");const se=await this.g.provideCallHierarchyOutgoingCalls(G,H);if(se)return se.map(ge=>({to:this.h(B,ge.to),fromRanges:ge.fromRanges.map(Ee=>i.Range.from(Ee))}))}releaseSession(B){this.e.delete(B)}h(B,j){const H=this.e.get(B),G=i.CallHierarchyItem.from(j,B,H.size.toString(36));return H.set(G._itemId,j),G}j(B,j){return this.e.get(B)?.get(j)}}class pt{constructor(B,j){this.f=B,this.g=j,this.d=new R.$IQ(""),this.e=new Map}async prepareSession(B,j,H){const G=this.f.getDocument(B),se=i.Position.to(j),ge=await this.g.prepareTypeHierarchy(G,se,H);if(!ge)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(ge)?ge.map(Ue=>this.h(Ee,Ue)):[this.h(Ee,ge)]}async provideSupertypes(B,j,H){const G=this.j(B,j);if(!G)throw new Error("missing type hierarchy item");const se=await this.g.provideTypeHierarchySupertypes(G,H);if(se)return se.map(ge=>this.h(B,ge))}async provideSubtypes(B,j,H){const G=this.j(B,j);if(!G)throw new Error("missing type hierarchy item");const se=await this.g.provideTypeHierarchySubtypes(G,H);if(se)return se.map(ge=>this.h(B,ge))}releaseSession(B){this.e.delete(B)}h(B,j){const H=this.e.get(B),G=i.TypeHierarchyItem.from(j,B,H.size.toString(36));return H.set(G._itemId,j),G}j(B,j){return this.e.get(B)?.get(j)}}class lt{constructor(B,j,H,G,se){this.e=B,this.f=j,this.g=H,this.h=G,this.j=se,this.d=new o.$xqc("DocumentDropEdit")}async provideDocumentOnDropEdits(B,j,H,G,se){const ge=this.f.getDocument(j),Ee=i.Position.to(H),Ue=i.DataTransfer.toDataTransfer(G,async at=>(await this.e.$resolveDocumentOnDropFileData(this.h,B,at)).buffer),Je=await this.g.provideDocumentDropEdits(ge,Ee,Ue,se);if(!Je)return;const _e=(0,v.$4b)(Je),tt=this.d.add(_e);return _e.map((at,it)=>({_cacheId:[tt,it],title:at.title??(0,d.localize)(2704,null,this.j.displayName||this.j.name),kind:at.kind?.value,yieldTo:at.yieldTo?.map(ot=>ot.value),insertText:typeof at.insertText=="string"?at.insertText:{snippet:at.insertText.value},additionalEdit:at.additionalEdit?i.WorkspaceEdit.from(at.additionalEdit,void 0):void 0}))}async resolveDropEdit(B,j){const[H,G]=B,se=this.d.get(H,G);if(!se||!this.g.resolveDocumentDropEdit)return{};const ge=await this.g.resolveDocumentDropEdit(se,j)??se;return{additionalEdit:ge.additionalEdit?i.WorkspaceEdit.from(ge.additionalEdit,void 0):void 0}}releaseDropEdits(B){this.d.delete(B)}}class et{constructor(B,j){this.d=B,this.e=j}async provideMappedEdits(B,j,H,G){const se=h.URI.revive(B),ge=this.d.getDocument(se),Ee=H.documents.map(_e=>_e.map(tt=>({uri:h.URI.revive(tt.uri),version:tt.version,ranges:tt.ranges.map(at=>i.Range.to(at))}))),Ue={documents:Ee,selections:Ee[0]?.[0]?.ranges??[]},Je=await this.e.provideMappedEdits(ge,j,Ue,G);return Je?i.WorkspaceEdit.from(Je):null}}class Ne{constructor(B,j){this.adapter=B,this.extension=j}}class Me{static{this.d=0}constructor(B,j,H,G,se,ge,Ee,Ue){this.g=j,this.h=H,this.j=G,this.k=se,this.l=ge,this.m=Ee,this.n=Ue,this.f=new Map,this.e=B.getProxy(c.$3N.MainThreadLanguageFeatures)}o(B,j){return i.DocumentSelector.from(B,this.g,j)}p(B){return new n.$5N(()=>{this.f.delete(B),this.e.$unregister(B)})}q(){return Me.d++}async s(B,j,H,G,se,ge=!1){const Ee=this.f.get(B);if(!Ee||!(Ee.adapter instanceof j))return G;const Ue=Date.now();ge||this.l.trace(`[${Ee.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const Je=H(Ee.adapter,Ee.extension);return Promise.resolve(Je).catch(_e=>{(0,N.$6)(_e)||(this.l.error(`[${Ee.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Ee.extension.identifier,_e))}).finally(()=>{ge||this.l.trace(`[${Ee.extension.identifier.value}] provider DONE after ${Date.now()-Ue}ms`)}),P.CancellationToken.isCancellationToken(se)?(0,D.$xh)(Je,se):Je}t(B,j){const H=this.q();return this.f.set(H,new Ne(B,j)),H}static u(B){return B.displayName||B.name}static w(B){return B.identifier.value}registerDocumentSymbolProvider(B,j,H,G){const se=this.t(new m(this.h,H),B),ge=G&&G.label||Me.u(B);return this.e.$registerDocumentSymbolProvider(se,this.o(j,B),ge),this.p(se)}$provideDocumentSymbols(B,j,H){return this.s(B,m,G=>G.provideDocumentSymbols(h.URI.revive(j),H),void 0,H)}registerCodeLensProvider(B,j,H){const G=this.q(),se=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(G,new Ne(new g(this.h,this.j.converter,H,B,this.n,this.l),B)),this.e.$registerCodeLensSupport(G,this.o(j,B),se);let ge=this.p(G);if(se!==void 0){const Ee=H.onDidChangeCodeLenses(Ue=>this.e.$emitCodeLensEvent(se));ge=n.$5N.from(ge,Ee)}return ge}$provideCodeLenses(B,j,H){return this.s(B,g,G=>G.provideCodeLenses(h.URI.revive(j),H),void 0,H)}$resolveCodeLens(B,j,H){return this.s(B,g,G=>G.resolveCodeLens(j,H),void 0,void 0)}$releaseCodeLenses(B,j){this.s(B,g,H=>Promise.resolve(H.releaseCodeLenses(j)),void 0,void 0)}registerDefinitionProvider(B,j,H){const G=this.t(new S(this.h,H),B);return this.e.$registerDefinitionSupport(G,this.o(j,B)),this.p(G)}$provideDefinition(B,j,H,G){return this.s(B,S,se=>se.provideDefinition(h.URI.revive(j),H,G),[],G)}registerDeclarationProvider(B,j,H){const G=this.t(new k(this.h,H),B);return this.e.$registerDeclarationSupport(G,this.o(j,B)),this.p(G)}$provideDeclaration(B,j,H,G){return this.s(B,k,se=>se.provideDeclaration(h.URI.revive(j),H,G),[],G)}registerImplementationProvider(B,j,H){const G=this.t(new y(this.h,H),B);return this.e.$registerImplementationSupport(G,this.o(j,B)),this.p(G)}$provideImplementation(B,j,H,G){return this.s(B,y,se=>se.provideImplementation(h.URI.revive(j),H,G),[],G)}registerTypeDefinitionProvider(B,j,H){const G=this.t(new C(this.h,H),B);return this.e.$registerTypeDefinitionSupport(G,this.o(j,B)),this.p(G)}$provideTypeDefinition(B,j,H,G){return this.s(B,C,se=>se.provideTypeDefinition(h.URI.revive(j),H,G),[],G)}registerHoverProvider(B,j,H,G){const se=this.t(new T(this.h,H),B);return this.e.$registerHoverProvider(se,this.o(j,B)),this.p(se)}$provideHover(B,j,H,G,se){return this.s(B,T,ge=>ge.provideHover(h.URI.revive(j),H,G,se),void 0,se)}$releaseHover(B,j){this.s(B,T,H=>Promise.resolve(H.releaseHover(j)),void 0,void 0)}registerEvaluatableExpressionProvider(B,j,H,G){const se=this.t(new $(this.h,H),B);return this.e.$registerEvaluatableExpressionProvider(se,this.o(j,B)),this.p(se)}$provideEvaluatableExpression(B,j,H,G){return this.s(B,$,se=>se.provideEvaluatableExpression(h.URI.revive(j),H,G),void 0,G)}registerInlineValuesProvider(B,j,H,G){const se=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,ge=this.t(new w(this.h,H),B);this.e.$registerInlineValuesProvider(ge,this.o(j,B),se);let Ee=this.p(ge);if(se!==void 0){const Ue=H.onDidChangeInlineValues(Je=>this.e.$emitInlineValuesEvent(se));Ee=n.$5N.from(Ee,Ue)}return Ee}$provideInlineValues(B,j,H,G,se){return this.s(B,w,ge=>ge.provideInlineValues(h.URI.revive(j),H,G,se),void 0,se)}registerDocumentHighlightProvider(B,j,H){const G=this.t(new M(this.h,H),B);return this.e.$registerDocumentHighlightProvider(G,this.o(j,B)),this.p(G)}registerMultiDocumentHighlightProvider(B,j,H){const G=this.t(new A(this.h,H),B);return this.e.$registerMultiDocumentHighlightProvider(G,this.o(j,B)),this.p(G)}$provideDocumentHighlights(B,j,H,G){return this.s(B,M,se=>se.provideDocumentHighlights(h.URI.revive(j),H,G),void 0,G)}$provideMultiDocumentHighlights(B,j,H,G,se){return this.s(B,A,ge=>ge.provideMultiDocumentHighlights(h.URI.revive(j),H,G.map(Ee=>h.URI.revive(Ee)),se),void 0,se)}registerLinkedEditingRangeProvider(B,j,H){const G=this.t(new L(this.h,H),B);return this.e.$registerLinkedEditingRangeProvider(G,this.o(j,B)),this.p(G)}$provideLinkedEditingRanges(B,j,H,G){return this.s(B,L,async se=>{const ge=await se.provideLinkedEditingRanges(h.URI.revive(j),H,G);if(ge)return{ranges:ge.ranges,wordPattern:ge.wordPattern?Me.y(ge.wordPattern):void 0}},void 0,G)}registerReferenceProvider(B,j,H){const G=this.t(new J(this.h,H),B);return this.e.$registerReferenceSupport(G,this.o(j,B)),this.p(G)}$provideReferences(B,j,H,G,se){return this.s(B,J,ge=>ge.provideReferences(h.URI.revive(j),H,G,se),void 0,se)}registerCodeActionProvider(B,j,H,G){const se=new O.$Wc,ge=this.t(new Y(this.h,this.j.converter,this.k,H,this.l,B,this.m),B);return this.e.$registerCodeActionSupport(ge,this.o(j,B),{providedKinds:G?.providedCodeActionKinds?.map(Ee=>Ee.value),documentation:G?.documentation?.map(Ee=>({kind:Ee.kind.value,command:this.j.converter.toInternal(Ee.command,se)}))},Me.u(B),Me.w(B),!!H.resolveCodeAction),se.add(this.p(ge)),se}$provideCodeActions(B,j,H,G,se){return this.s(B,Y,ge=>ge.provideCodeActions(h.URI.revive(j),H,G,se),void 0,se)}$resolveCodeAction(B,j,H){return this.s(B,Y,G=>G.resolveCodeAction(j,H),{},void 0)}$releaseCodeActions(B,j){this.s(B,Y,H=>Promise.resolve(H.releaseCodeActions(j)),void 0,void 0)}registerDocumentFormattingEditProvider(B,j,H){const G=this.t(new Q(this.h,H),B);return this.e.$registerDocumentFormattingSupport(G,this.o(j,B),B.identifier,B.displayName||B.name),this.p(G)}$provideDocumentFormattingEdits(B,j,H,G){return this.s(B,Q,se=>se.provideDocumentFormattingEdits(h.URI.revive(j),H,G),void 0,G)}registerDocumentRangeFormattingEditProvider(B,j,H){const G=typeof H.provideDocumentRangesFormattingEdits=="function",se=this.t(new V(this.h,H),B);return this.e.$registerRangeFormattingSupport(se,this.o(j,B),B.identifier,B.displayName||B.name,G),this.p(se)}$provideDocumentRangeFormattingEdits(B,j,H,G,se){return this.s(B,V,ge=>ge.provideDocumentRangeFormattingEdits(h.URI.revive(j),H,G,se),void 0,se)}$provideDocumentRangesFormattingEdits(B,j,H,G,se){return this.s(B,V,ge=>ge.provideDocumentRangesFormattingEdits(h.URI.revive(j),H,G,se),void 0,se)}registerOnTypeFormattingEditProvider(B,j,H,G){const se=this.t(new ie(this.h,H),B);return this.e.$registerOnTypeFormattingSupport(se,this.o(j,B),G,B.identifier),this.p(se)}$provideOnTypeFormattingEdits(B,j,H,G,se,ge){return this.s(B,ie,Ee=>Ee.provideOnTypeFormattingEdits(h.URI.revive(j),H,G,se,ge),void 0,ge)}registerWorkspaceSymbolProvider(B,j){const H=this.t(new le(j,this.l),B);return this.e.$registerNavigateTypeSupport(H,typeof j.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(B,j,H){return this.s(B,le,G=>G.provideWorkspaceSymbols(j,H),{symbols:[]},H)}$resolveWorkspaceSymbol(B,j,H){return this.s(B,le,G=>G.resolveWorkspaceSymbol(j,H),void 0,void 0)}$releaseWorkspaceSymbols(B,j){this.s(B,le,H=>H.releaseWorkspaceSymbols(j),void 0,void 0)}registerRenameProvider(B,j,H){const G=this.t(new _(this.h,H,this.l),B);return this.e.$registerRenameSupport(G,this.o(j,B),_.supportsResolving(H)),this.p(G)}$provideRenameEdits(B,j,H,G,se){return this.s(B,_,ge=>ge.provideRenameEdits(h.URI.revive(j),H,G,se),void 0,se)}$resolveRenameLocation(B,j,H,G){return this.s(B,_,se=>se.resolveRenameLocation(h.URI.revive(j),H,G),void 0,G)}registerNewSymbolNamesProvider(B,j,H){const G=this.t(new oe(this.h,H,this.l),B);return this.e.$registerNewSymbolNamesProvider(G,this.o(j,B)),this.p(G)}$supportsAutomaticNewSymbolNamesTriggerKind(B){return this.s(B,oe,j=>j.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(B,j,H,G,se){return this.s(B,oe,ge=>ge.provideNewSymbolNames(h.URI.revive(j),H,G,se),void 0,se)}registerDocumentSemanticTokensProvider(B,j,H,G){const se=this.t(new ce(this.h,H),B),ge=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(se,this.o(j,B),G,ge);let Ee=this.p(se);if(ge){const Ue=H.onDidChangeSemanticTokens(Je=>this.e.$emitDocumentSemanticTokensEvent(ge));Ee=n.$5N.from(Ee,Ue)}return Ee}$provideDocumentSemanticTokens(B,j,H,G){return this.s(B,ce,se=>se.provideDocumentSemanticTokens(h.URI.revive(j),H,G),null,G)}$releaseDocumentSemanticTokens(B,j){this.s(B,ce,H=>H.releaseDocumentSemanticColoring(j),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,j,H,G){const se=this.t(new x(this.h,H),B);return this.e.$registerDocumentRangeSemanticTokensProvider(se,this.o(j,B),G),this.p(se)}$provideDocumentRangeSemanticTokens(B,j,H,G){return this.s(B,x,se=>se.provideDocumentRangeSemanticTokens(h.URI.revive(j),H,G),null,G)}registerCompletionItemProvider(B,j,H,G){const se=this.t(new $e(this.h,this.j.converter,H,this.m,B),B);return this.e.$registerCompletionsProvider(se,this.o(j,B),G,$e.supportsResolving(H),B.identifier),this.p(se)}$provideCompletionItems(B,j,H,G,se){return this.s(B,$e,ge=>ge.provideCompletionItems(h.URI.revive(j),H,G,se),void 0,se)}$resolveCompletionItem(B,j,H){return this.s(B,$e,G=>G.resolveCompletionItem(j,H),void 0,H)}$releaseCompletionItems(B,j){this.s(B,$e,H=>H.releaseCompletionItems(j),void 0,void 0)}registerInlineCompletionsProvider(B,j,H,G){const se=new X(B,this.h,H,this.j.converter),ge=this.t(se,B);return this.e.$registerInlineCompletionsSupport(ge,this.o(j,B),se.supportsHandleEvents,a.$vn.toKey(B.identifier.value),G?.yieldTo?.map(Ee=>a.$vn.toKey(Ee))||[]),this.p(ge)}$provideInlineCompletions(B,j,H,G,se){return this.s(B,Pe,ge=>ge.provideInlineCompletions(h.URI.revive(j),H,G,se),void 0,se)}$provideInlineEdits(B,j,H,G,se){return this.s(B,Pe,ge=>ge.provideInlineEdits(h.URI.revive(j),H,G,se),void 0,se)}$handleInlineCompletionDidShow(B,j,H,G){this.s(B,Pe,async se=>{se.handleDidShowCompletionItem(j,H,G)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,j,H,G,se){this.s(B,Pe,async ge=>{ge.handlePartialAccept(j,H,G,se)},void 0,void 0)}$freeInlineCompletionsList(B,j){this.s(B,Pe,async H=>{H.disposeCompletions(j)},void 0,void 0)}registerInlineEditProvider(B,j,H){const G=new q(B,this.h,H,this.j.converter),se=this.t(G,B);return this.e.$registerInlineEditProvider(se,this.o(j,B),B.identifier),this.p(se)}$provideInlineEdit(B,j,H,G){return this.s(B,q,se=>se.provideInlineEdits(h.URI.revive(j),H,G),void 0,G)}$freeInlineEdit(B,j){this.s(B,q,async H=>{H.disposeEdit(j)},void 0,void 0)}registerSignatureHelpProvider(B,j,H,G){const se=Array.isArray(G)?{triggerCharacters:G,retriggerCharacters:[]}:G,ge=this.t(new be(this.h,H),B);return this.e.$registerSignatureHelpProvider(ge,this.o(j,B),se),this.p(ge)}$provideSignatureHelp(B,j,H,G,se){return this.s(B,be,ge=>ge.provideSignatureHelp(h.URI.revive(j),H,G,se),void 0,se)}$releaseSignatureHelp(B,j){this.s(B,be,H=>H.releaseSignatureHelp(j),void 0,void 0)}registerInlayHintsProvider(B,j,H){const G=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,se=this.t(new Ie(this.h,this.j.converter,H,this.l,B),B);this.e.$registerInlayHintsProvider(se,this.o(j,B),typeof H.resolveInlayHint=="function",G,Me.u(B));let ge=this.p(se);if(G!==void 0){const Ee=H.onDidChangeInlayHints(Ue=>this.e.$emitInlayHintsEvent(G));ge=n.$5N.from(ge,Ee)}return ge}$provideInlayHints(B,j,H,G){return this.s(B,Ie,se=>se.provideInlayHints(h.URI.revive(j),H,G),void 0,G)}$resolveInlayHint(B,j,H){return this.s(B,Ie,G=>G.resolveInlayHint(j,H),void 0,H)}$releaseInlayHints(B,j){this.s(B,Ie,H=>H.releaseHints(j),void 0,void 0)}registerDocumentLinkProvider(B,j,H){const G=this.t(new Fe(this.h,H),B);return this.e.$registerDocumentLinkProvider(G,this.o(j,B),typeof H.resolveDocumentLink=="function"),this.p(G)}$provideDocumentLinks(B,j,H){return this.s(B,Fe,G=>G.provideLinks(h.URI.revive(j),H),void 0,H,j.scheme==="output")}$resolveDocumentLink(B,j,H){return this.s(B,Fe,G=>G.resolveLink(j,H),void 0,void 0,!0)}$releaseDocumentLinks(B,j){this.s(B,Fe,H=>H.releaseLinks(j),void 0,void 0,!0)}registerColorProvider(B,j,H){const G=this.t(new Be(this.h,H),B);return this.e.$registerDocumentColorProvider(G,this.o(j,B)),this.p(G)}$provideDocumentColors(B,j,H){return this.s(B,Be,G=>G.provideColors(h.URI.revive(j),H),[],H)}$provideColorPresentations(B,j,H,G){return this.s(B,Be,se=>se.provideColorPresentations(h.URI.revive(j),H,G),void 0,G)}registerFoldingRangeProvider(B,j,H){const G=this.q(),se=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(G,new Ne(new xe(this.h,H),B)),this.e.$registerFoldingRangeProvider(G,this.o(j,B),B.identifier,se);let ge=this.p(G);if(se!==void 0){const Ee=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(se));ge=n.$5N.from(ge,Ee)}return ge}$provideFoldingRanges(B,j,H,G){return this.s(B,xe,se=>se.provideFoldingRanges(h.URI.revive(j),H,G),void 0,G)}registerSelectionRangeProvider(B,j,H){const G=this.t(new nt(this.h,H,this.l),B);return this.e.$registerSelectionRangeProvider(G,this.o(j,B)),this.p(G)}$provideSelectionRanges(B,j,H,G){return this.s(B,nt,se=>se.provideSelectionRanges(h.URI.revive(j),H,G),[],G)}registerCallHierarchyProvider(B,j,H){const G=this.t(new ut(this.h,H),B);return this.e.$registerCallHierarchyProvider(G,this.o(j,B)),this.p(G)}$prepareCallHierarchy(B,j,H,G){return this.s(B,ut,se=>Promise.resolve(se.prepareSession(h.URI.revive(j),H,G)),void 0,G)}$provideCallHierarchyIncomingCalls(B,j,H,G){return this.s(B,ut,se=>se.provideCallsTo(j,H,G),void 0,G)}$provideCallHierarchyOutgoingCalls(B,j,H,G){return this.s(B,ut,se=>se.provideCallsFrom(j,H,G),void 0,G)}$releaseCallHierarchy(B,j){this.s(B,ut,H=>Promise.resolve(H.releaseSession(j)),void 0,void 0)}registerTypeHierarchyProvider(B,j,H){const G=this.t(new pt(this.h,H),B);return this.e.$registerTypeHierarchyProvider(G,this.o(j,B)),this.p(G)}$prepareTypeHierarchy(B,j,H,G){return this.s(B,pt,se=>Promise.resolve(se.prepareSession(h.URI.revive(j),H,G)),void 0,G)}$provideTypeHierarchySupertypes(B,j,H,G){return this.s(B,pt,se=>se.provideSupertypes(j,H,G),void 0,G)}$provideTypeHierarchySubtypes(B,j,H,G){return this.s(B,pt,se=>se.provideSubtypes(j,H,G),void 0,G)}$releaseTypeHierarchy(B,j){this.s(B,pt,H=>Promise.resolve(H.releaseSession(j)),void 0,void 0)}registerDocumentOnDropEditProvider(B,j,H,G){const se=this.q();return this.f.set(se,new Ne(new lt(this.e,this.h,H,se,B),B)),this.e.$registerDocumentOnDropEditProvider(se,this.o(j,B),(0,t.$vH)(B,"documentPaste")&&G?{supportsResolve:!!H.resolveDocumentDropEdit,dropMimeTypes:G.dropMimeTypes}:void 0),this.p(se)}$provideDocumentOnDropEdits(B,j,H,G,se,ge){return this.s(B,lt,Ee=>Promise.resolve(Ee.provideDocumentOnDropEdits(j,h.URI.revive(H),G,se,ge)),void 0,void 0)}$resolveDropEdit(B,j,H){return this.s(B,lt,G=>G.resolveDropEdit(j,H),{},void 0)}$releaseDocumentOnDropEdits(B,j){this.s(B,lt,H=>Promise.resolve(H.releaseDropEdits(j)),void 0,void 0)}registerMappedEditsProvider(B,j,H){const G=this.t(new et(this.h,H),B);return this.e.$registerMappedEditsProvider(G,this.o(j,B),B.displayName??B.name),this.p(G)}$provideMappedEdits(B,j,H,G,se){return this.s(B,et,ge=>Promise.resolve(ge.provideMappedEdits(j,H,G,se)),null,se)}registerDocumentPasteEditProvider(B,j,H,G){const se=this.q();return this.f.set(se,new Ne(new z(this.e,this.h,H,se,B),B)),this.e.$registerPasteEditProvider(se,this.o(j,B),{supportsCopy:!!H.prepareDocumentPaste,supportsPaste:!!H.provideDocumentPasteEdits,supportsResolve:!!H.resolveDocumentPasteEdit,providedPasteEditKinds:G.providedPasteEditKinds?.map(ge=>ge.value),copyMimeTypes:G.copyMimeTypes,pasteMimeTypes:G.pasteMimeTypes}),this.p(se)}$prepareDocumentPaste(B,j,H,G,se){return this.s(B,z,ge=>ge.prepareDocumentPaste(h.URI.revive(j),H,G,se),void 0,se)}$providePasteEdits(B,j,H,G,se,ge,Ee){return this.s(B,z,Ue=>Ue.providePasteEdits(j,h.URI.revive(H),G,se,ge,Ee),void 0,Ee)}$resolvePasteEdit(B,j,H){return this.s(B,z,G=>G.resolvePasteEdit(j,H),{},void 0)}$releasePasteEdits(B,j){this.s(B,z,H=>Promise.resolve(H.releasePasteEdits(j)),void 0,void 0)}static y(B){return{pattern:B.source,flags:B.flags}}static z(B){return{decreaseIndentPattern:Me.y(B.decreaseIndentPattern),increaseIndentPattern:Me.y(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?Me.y(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?Me.y(B.unIndentedLinePattern):void 0}}static B(B){return{beforeText:Me.y(B.beforeText),afterText:B.afterText?Me.y(B.afterText):void 0,previousLineText:B.previousLineText?Me.y(B.previousLineText):void 0,action:B.action}}static C(B){return B.map(Me.B)}static D(B){return{open:B.open,close:B.close,notIn:B.notIn?B.notIn.map(j=>n.SyntaxTokenType.toString(j)):void 0}}static E(B){return B.map(Me.D)}setLanguageConfiguration(B,j,H){const{wordPattern:G}=H;if(G&&(0,I.$uf)(G))throw new Error(`Invalid language configuration: wordPattern '${G}' is not allowed to match the empty string.`);G?this.h.setWordDefinitionFor(j,G):this.h.setWordDefinitionFor(j,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const se=this.q(),ge={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?Me.y(H.wordPattern):void 0,indentationRules:H.indentationRules?Me.z(H.indentationRules):void 0,onEnterRules:H.onEnterRules?Me.C(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport,autoClosingPairs:H.autoClosingPairs?Me.E(H.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(se,j,ge),this.p(se)}$setWordDefinitions(B){for(const j of B)this.h.setWordDefinitionFor(j.languageId,new RegExp(j.regexSource,j.regexFlags))}}e.$Hqc=Me}),define(Re[243],Te([1,0,4,33,5,8]),function(we,e,v,D,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$esc=void 0,N=qe(N);class R{constructor(p){this.a=new Map,this.c=new Map,this.b=p.getProxy(P.$3N.MainThreadLanguageModelTools),this.b.$getTools().then(s=>{for(const I of s)this.c.set(I.id,(0,D.$fi)(I))})}async invokeTool(p,s,I){const b=await this.b.$invokeTool(p,s,I);return N.LanguageModelToolResult.to(b)}async $acceptToolDelta(p){p.added&&this.c.set(p.added.id,p.added),p.removed&&this.c.delete(p.removed)}get tools(){return Array.from(this.c.values()).map(p=>N.LanguageModelToolDescription.to(p))}async $invokeTool(p,s,I){const b=this.a.get(p);if(!b)throw new Error(`Unknown tool ${p}`);const h=await b.tool.invoke(s,I);return N.LanguageModelToolResult.from(h)}registerTool(p,s,I){return this.a.set(s,{extension:p,tool:I}),this.b.$registerTool(s),(0,v.$Vc)(()=>{this.a.delete(s),this.b.$unregisterTool(s)})}}e.$esc=R}),define(Re[95],Te([1,0,10,19,42,12,6,40,4,9,18,3,11,77,5,91,16,8,7,119,21]),function(we,e,v,D,P,N,R,O,p,s,I,b,h,E,f,r,l,d,a,i,n){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$prc=e.$orc=void 0,d=qe(d),a=qe(a),e.$orc=(0,b.$Ii)("IExtHostLanguageModels");class o{constructor(u,S){this.option=u,this.stream=new v.$_h,this.stream=S??new v.$_h}}class c{constructor(){this.a=new Map,this.b=new v.$_h,this.c=!1;const u=this;this.apiObject={get stream(){return u.b.asyncIterable},get text(){return v.$9h.map(u.b.asyncIterable,S=>{if(S instanceof a.$nQ)return S.value}).coalesce()}}}*d(){if(this.a.size>0)for(const[,u]of this.a)yield u.stream;else yield this.b}handleFragment(u){if(this.c)return;let S=this.a.get(u.index);S||(this.a.size===0?S=new o(u.index,this.b):S=new o(u.index),this.a.set(u.index,S));let k;u.part.type==="text"?k=new a.$nQ(u.part.value):k=new a.$mQ(u.part.name,u.part.parameters),S.stream.emitOne(k)}reject(u){this.c=!0;for(const S of this.d())S.reject(u)}resolve(){this.c=!0;for(const u of this.d())u.resolve()}}let m=class{static{t=this}static{this.a=1}constructor(u,S,k){this.j=S,this.k=k,this.c=new R.$oe,this.d=new R.$oe,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new I.$xn,this.i=new Map,this.s=new Set,this.b=u.getProxy(f.$3N.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(u,S,k,y){const C=t.a++;this.f.set(C,{extension:u.identifier,provider:k,languageModelId:S});let T;y.auth&&(T={providerLabel:u.displayName||u.name,accountLabel:typeof y.auth=="object"?y.auth.label:void 0}),this.b.$registerLanguageModelProvider(C,`${I.$vn.toKey(u.identifier)}/${C}/${S}`,{extension:u.identifier,id:S,vendor:y.vendor??I.$vn.toKey(u.identifier),name:y.name??"",family:y.family??"",version:y.version,maxInputTokens:y.maxInputTokens,maxOutputTokens:y.maxOutputTokens,auth:T,targetExtensions:y.extensions});const $=k.onDidReceiveLanguageModelResponse2?.(({extensionId:w,participant:M,tokenCount:A})=>{this.b.$whenLanguageModelChatRequestMade(S,new I.$vn(w),M,A)});return(0,p.$Vc)(()=>{this.f.delete(C),this.b.$unregisterProvider(C),$?.dispose()})}async $startChatRequest(u,S,k,y,C,T){const $=this.f.get(u);if(!$)throw new Error("Provider not found");const w=new E.$Gw(async A=>{if(T.isCancellationRequested){this.j.warn(`[CHAT](${$.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let L;if(A.part instanceof a.$mQ?L={type:"function_use",name:A.part.name,parameters:A.part.parameters}:A.part instanceof a.$nQ&&(L={type:"text",value:A.part.value}),!L){this.j.warn(`[CHAT](${$.extension.value}) UNKNOWN part ${JSON.stringify(A)}`);return}this.b.$reportResponsePart(S,{index:A.index,part:L})});let M;if($.provider.provideLanguageModelResponse2)M=Promise.resolve($.provider.provideLanguageModelResponse2(y.map(d.LanguageModelChatMessage.to),C,I.$vn.toKey(k),w,T));else{const A=new E.$Gw(async L=>{w.report({index:L.index,part:new a.$nQ(L.part)})});M=Promise.resolve($.provider.provideLanguageModelResponse(y.map(d.LanguageModelChatMessage.to),C?.modelOptions??{},I.$vn.toKey(k),A,T))}M.then(()=>{this.b.$reportResponseDone(S,void 0)},A=>{this.b.$reportResponseDone(S,(0,N.$4)(A))})}$provideTokenLength(u,S,k){const y=this.f.get(u);return y?Promise.resolve(y.provider.provideTokenCount(S,k)):Promise.resolve(0)}$acceptChatModelMetadata(u){if(u.added)for(const{identifier:S,metadata:k}of u.added)this.g.set(S,{metadata:k,apiObjects:new I.$xn});if(u.removed)for(const S of u.removed){this.g.delete(S);for(const[k,y]of this.i)y.languageModelId===S&&(y.res.reject(new N.$7),this.i.delete(k))}u.added?.forEach(S=>this.q(S.metadata)),this.d.fire(void 0)}async selectLanguageModels(u,S){const k=await this.b.$selectChatModels({...S,extension:u.identifier}),y=[],C=this;for(const T of k){const $=this.g.get(T);if(!$)continue;this.o(u.identifier,$.metadata)&&await this.q($.metadata);let w=$.apiObjects.get(u.identifier);w||(w={id:T,vendor:$.metadata.vendor,family:$.metadata.family,version:$.metadata.version,name:$.metadata.name,maxInputTokens:$.metadata.maxInputTokens,countTokens(M,A){if(!C.g.has(T))throw a.$rQ.NotFound(T);return C.r(T,M,A??D.CancellationToken.None)},sendRequest(M,A,L){if(!C.g.has(T))throw a.$rQ.NotFound(T);return C.l(u,T,M,A??{},L??D.CancellationToken.None)}},Object.freeze(w),$.apiObjects.set(u.identifier,w)),y.push(w)}return y}async l(u,S,k,y,C){const T=this.m(u,k),$=u.identifier,w=this.g.get(S)?.metadata;if(!w||!this.g.has(S))throw a.$rQ.NotFound(`Language model '${S}' is unknown.`);if(this.o($,w)&&(!await this.n(u,{identifier:w.extension,displayName:w.auth.providerLabel},y.justification,!1)||!this.h.get($)?.has(w.extension)))throw a.$rQ.NoPermissions(`Language model '${S}' cannot be used by '${$.value}'.`);try{const M=Math.random()*1e6|0,A=new c;this.i.set(M,{languageModelId:S,res:A});try{await this.b.$tryStartChatRequest($,S,M,T,y,C)}catch(L){throw this.i.delete(M),L}return A.apiObject}catch(M){throw M.name===a.$rQ.name?M:new a.$rQ(`Language model '${S}' errored: ${(0,P.$tj)(M)}`,"Unknown",M)}}m(u,S){const k=[];for(const y of S)y.role===a.LanguageModelChatMessageRole.System&&(0,n.$wH)(u,"languageModelSystem"),y.content2 instanceof a.$kQ&&(0,n.$wH)(u,"lmTools"),k.push(d.LanguageModelChatMessage.from(y));return k}async $acceptResponsePart(u,S){const k=this.i.get(u);k&&k.res.handleFragment(S)}async $acceptResponseDone(u,S){const k=this.i.get(u);k&&(this.i.delete(u),S?k.res.reject((0,N.$5)(S)):k.res.resolve())}async n(u,S,k,y){const C=i.$6M+S.identifier.value;if(await this.k.getSession(u,C,[],{silent:!0}))return this.$updateModelAccesslist([{from:u.identifier,to:S.identifier,enabled:!0}]),!0;if(y)return!1;try{const $=k?(0,s.localize)(2705,null,S.displayName,k):void 0;return await this.k.getSession(u,C,[],{forceNewSession:{detail:$}}),this.$updateModelAccesslist([{from:u.identifier,to:S.identifier,enabled:!0}]),!0}catch{return!1}}o(u,S){return!!S.auth&&!I.$vn.equals(S.extension,u)}async q(u){if(u.auth)for(const S of this.s)try{await this.n(S,{identifier:u.extension,displayName:""},void 0,!0)}catch(k){this.j.error("Fake Auth request failed"),this.j.error(k)}}async r(u,S,k){if(!this.g.get(u))throw a.$rQ.NotFound(`Language model '${u}' is unknown.`);const C=O.Iterable.find(this.f.values(),T=>T.languageModelId===u);return C?C.provider.provideTokenCount(S,k):this.b.$countTokens(u,typeof S=="string"?S:d.LanguageModelChatMessage.from(S),k)}$updateModelAccesslist(u){const S=new Array;for(const{from:k,to:y,enabled:C}of u){const T=this.h.get(k)??new I.$wn;if(T.has(y)!==C){C?T.add(y):T.delete(y),this.h.set(k,T);const w={from:k,to:y};S.push(w),this.c.fire(w)}}}createLanguageModelAccessInformation(u){this.s.add(u);const S=this,k=R.Event.signal(R.Event.filter(this.c.event,C=>I.$vn.equals(C.from,u.identifier))),y=R.Event.signal(this.d.event);return{get onDidChange(){return R.Event.any(k,y)},canSendRequest(C){let T;e:for(const[w,M]of S.g)for(const A of M.apiObjects.values())if(A===C){T=M.metadata;break e}if(!T)return;if(!S.o(u.identifier,T))return!0;const $=S.h.get(u.identifier);if($)return $.has(T.extension)}}}};e.$prc=m,e.$prc=m=t=Ke([We(0,l.$DQ),We(1,h.$dk),We(2,r.$Jqc)],m)});var si=this&&this.__importDefault||function(we){return we&&we.__esModule?we:{default:we}};define(Re[244],Te([1,0,5,8,7,36,10,4,21]),function(we,e,v,D,P,N,R,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fsc=void 0,D=qe(D),N=si(N);class s{constructor(b,h,E,f){this.c=h,this.d=E,this.e=f,this.b=[],this.f=0,this.g=new Set,this.a=b.getProxy(v.$3N.MainThreadLanguages)}$acceptLanguageIds(b){this.b=b}async getLanguages(){return this.b.slice(0)}async changeLanguage(b,h){await this.a.$changeLanguage(b,h);const E=this.c.getDocumentData(b);if(!E)throw new Error(`document '${b.toString()}' NOT found`);return E.document}async tokenAtPosition(b,h){const E=b.version,f=D.Position.from(h),r=await this.a.$tokensAtPosition(b.uri,f),l={type:P.StandardTokenType.Other,range:b.getWordRangeAtPosition(h)??new P.$7N(h.line,h.character,h.line,h.character)};if(!r)return l;const d={range:D.Range.to(r.range),type:D.TokenType.to(r.type)};return!d.range.contains(h)||E!==b.version?l:d}createLanguageStatusItem(b,h,E){const f=this.f++,r=this.a,l=this.g,d=`${b.identifier.value}/${h}`;if(l.has(d))throw new Error(`LanguageStatusItem with id '${h}' ALREADY exists`);l.add(d);const a={selector:E,id:h,name:b.displayName??b.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const n=new O.$Wc,t=()=>{if(i?.dispose(),!l.has(d)){console.warn(`LanguageStatusItem (${h}) from ${b.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,R.$Kh)(()=>{n.clear(),this.a.$setLanguageStatus(f,{id:d,name:a.name??b.displayName??b.name,source:b.displayName??b.name,selector:D.DocumentSelector.from(a.selector,this.e),label:a.text,detail:a.detail??"",severity:a.severity===P.LanguageStatusSeverity.Error?N.default.Error:a.severity===P.LanguageStatusSeverity.Warning?N.default.Warning:N.default.Info,command:a.command&&this.d.toInternal(a.command,n),accessibilityInfo:a.accessibilityInformation,busy:a.busy})},0)},o={dispose(){n.dispose(),i?.dispose(),r.$removeLanguageStatus(f),l.delete(d)},get id(){return a.id},get name(){return a.name},set name(c){a.name=c,t()},get selector(){return a.selector},set selector(c){a.selector=c,t()},get text(){return a.text},set text(c){a.text=c,t()},set text2(c){(0,p.$wH)(b,"languageStatusText"),a.text=c,t()},get text2(){return(0,p.$wH)(b,"languageStatusText"),a.text},get detail(){return a.detail},set detail(c){a.detail=c,t()},get severity(){return a.severity},set severity(c){a.severity=c,t()},get accessibilityInformation(){return a.accessibilityInformation},set accessibilityInformation(c){a.accessibilityInformation=c,t()},get command(){return a.command},set command(c){a.command=c,t()},get busy(){return a.busy},set busy(c){a.busy=c,t()}};return t(),o}}e.$fsc=s}),define(Re[245],Te([1,0,15,2,8,7,90]),function(we,e,v,D,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yrc=e.$Xrc=void 0,P=qe(P),R=qe(R);class O{constructor(b,h,E,f){this.start=b,this.deletedCount=h,this.deletedItems=E,this.items=f}asApiEvent(){return{range:new N.$wP(this.start,this.start+this.deletedCount),addedCells:this.items.map(b=>b.apiCell),removedCells:this.deletedItems}}}class p{static asModelAddData(b){return{EOL:b.eol,lines:b.source,languageId:b.language,uri:b.uri,isDirty:!1,versionId:1}}constructor(b,h,E){this.notebook=b,this.h=h,this.j=E,this.handle=E.handle,this.uri=D.URI.revive(E.uri),this.cellKind=E.cellKind,this.a=E.outputs.map(P.NotebookCellOutput.to),this.e=E.internalMetadata??{},this.b=Object.freeze(E.metadata??{}),this.d=Object.freeze(P.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const b=this,h=this.h.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const E={get index(){return b.notebook.getCellIndex(b)},notebook:b.notebook.apiNotebook,kind:P.NotebookCellKind.to(this.j.cellKind),document:h.document,get mime(){return b.g},set mime(f){b.g=f},get outputs(){return b.a.slice(0)},get metadata(){return b.b},get executionSummary(){return b.d}};this.f=Object.freeze(E)}return this.f}setOutputs(b){this.a=b.map(P.NotebookCellOutput.to)}setOutputItems(b,h,E){const f=E.map(P.NotebookCellOutputItem.to),r=this.a.find(l=>l.id===b);if(r&&(h||(r.items.length=0),r.items.push(...f),r.items.length>1&&r.items.every(l=>R.$6L(l.mime)))){const l=new Map,d=[];r.items.forEach(a=>{let i;l.has(a.mime)?i=l.get(a.mime):(i=[],l.set(a.mime,i),d.push(a.mime)),i.push(a.data)}),r.items.length=0,d.forEach(a=>{const i=R.$7L(l.get(a));r.items.push({mime:a,data:i.data.buffer})})}}setMetadata(b){this.b=Object.freeze(b)}setInternalMetadata(b){this.e=b,this.d=Object.freeze(P.NotebookCellExecutionSummary.to(b))}setMime(b){}}e.$Xrc=p;class s{static{this.a=0}constructor(b,h,E,f,r){this.k=b,this.l=h,this.m=E,this.uri=f,this.handle=s.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=r.viewType,this.f=Object.freeze(r.metadata??Object.create(null)),this.r([[0,0,r.cells]],!0,void 0),this.g=r.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const b=this,h={get uri(){return b.uri},get version(){return b.g},get notebookType(){return b.d},get isDirty(){return b.h},get isUntitled(){return b.uri.scheme===v.Schemas.untitled},get isClosed(){return b.j},get metadata(){return b.f},get cellCount(){return b.b.length},cellAt(E){return E=b.n(E),b.b[E].apiCell},getCells(E){return(E?b.p(E):b.b).map(r=>r.apiCell)},save(){return b.q()},[Symbol.for("debug.description")](){return`NotebookDocument(${this.uri.toString()})`}};this.e=Object.freeze(h)}return this.e}acceptDocumentPropertiesChanged(b){b.metadata&&(this.f=Object.freeze({...this.f,...b.metadata}))}acceptDirty(b){this.h=b}acceptModelChanged(b,h,E){this.g=b.versionId,this.h=h,this.acceptDocumentPropertiesChanged({metadata:E});const f={notebook:this.apiNotebook,metadata:E,cellChanges:[],contentChanges:[]},r=[];for(const d of b.rawEvents)d.kind===R.NotebookCellsChangeType.ModelChange?this.r(d.changes,!1,f.contentChanges):d.kind===R.NotebookCellsChangeType.Move?this.s(d.index,d.length,d.newIdx,f.contentChanges):d.kind===R.NotebookCellsChangeType.Output?(this.t(d.index,d.outputs),r.push({cell:this.b[d.index].apiCell,outputs:this.b[d.index].apiCell.outputs})):d.kind===R.NotebookCellsChangeType.OutputItem?(this.u(d.index,d.outputId,d.append,d.outputItems),r.push({cell:this.b[d.index].apiCell,outputs:this.b[d.index].apiCell.outputs})):d.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(d.index,d.language),r.push({cell:this.b[d.index].apiCell,document:this.b[d.index].apiCell.document})):d.kind===R.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this.b[d.index].apiCell,document:this.b[d.index].apiCell.document}):d.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(d.index,d.mime):d.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(d.index,d.metadata),r.push({cell:this.b[d.index].apiCell,metadata:this.b[d.index].apiCell.metadata})):d.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(d.index,d.internalMetadata),r.push({cell:this.b[d.index].apiCell,executionSummary:this.b[d.index].apiCell.executionSummary}));const l=new Map;for(let d=0;d<r.length;d++){const a=r[d],i=l.get(a.cell);if(i===void 0){const n=f.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...a});l.set(a.cell,n-1)}else f.cellChanges[i]={...f.cellChanges[i],...a}}return Object.freeze(f),Object.freeze(f.cellChanges),Object.freeze(f.contentChanges),f}n(b){return b=b|0,b<0?0:b>=this.b.length?this.b.length-1:b}o(b){let h=b.start|0,E=b.end|0;return h<0&&(h=0),E>this.b.length&&(E=this.b.length),b.with({start:h,end:E})}p(b){b=this.o(b);const h=[];for(let E=b.start;E<b.end;E++)h.push(this.b[E]);return h}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(b,h,E){if(this.j)return;const f=[],r=[],l=[];if(b.reverse().forEach(d=>{const i=d[2].map(o=>{const c=new p(this,this.l,o);return h||r.push(p.asModelAddData(o)),c}),n=new O(d[0],d[1],[],i),t=this.b.splice(d[0],d[1],...i);for(const o of t)l.push(o.uri),n.deletedItems.push(o.apiCell);f.push(n)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:l}),E)for(const d of f)E.push(d.asApiEvent())}s(b,h,E,f){const r=this.b.splice(b,h);this.b.splice(E,0,...r);const l=[new O(b,h,r.map(d=>d.apiCell),[]),new O(E,0,[],r)];for(const d of l)f.push(d.asApiEvent())}t(b,h){this.b[b].setOutputs(h)}u(b,h,E,f){this.b[b].setOutputItems(h,E,f)}v(b,h){const E=this.b[b];E.apiCell.document.languageId!==h&&this.m.$acceptModelLanguageChanged(E.uri,h)}w(b,h){const E=this.b[b];E.apiCell.mime=h}x(b,h){this.b[b].setMetadata(h)}y(b,h){this.b[b].setInternalMetadata(h)}getCellFromApiCell(b){return this.b.find(h=>h.apiCell===b)}getCellFromIndex(b){return this.b[b]}getCell(b){return this.b.find(h=>h.handle===b)}getCellIndex(b){return this.b.indexOf(b)}}e.$Yrc=s}),define(Re[246],Te([1,0,6,2,8,7,39]),function(we,e,v,D,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hsc=void 0;class O{constructor(s,I,b,h={timeout:1500,errors:3}){this.b=s,this.c=I,this.d=b,this.f=h,this.a=new v.$qe}dispose(){}getOnWillSaveNotebookDocumentEvent(s){return(I,b,h)=>{const E=function(r){I.call(b,r)};return E.extension=s,this.a.event(E,void 0,h)}}async $participateInSave(s,I,b){const h=D.URI.revive(s),E=this.c.getNotebookDocument(h);if(!E)throw new Error("Unable to resolve notebook document");const f=[];if(await this.a.fireAsync({notebook:E.apiNotebook,reason:P.TextDocumentSaveReason.to(I)},b,async(l,d)=>{const a=Date.now(),i=await await Promise.resolve(l);Date.now()-a>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",d.extension.identifier),!b.isCancellationRequested&&i&&(i instanceof N.$eO?f.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",d.extension.identifier,"ignored due to invalid data"))}),b.isCancellationRequested)return!1;if(f.length===0)return!0;const r={edits:[]};for(const l of f){const{edits:d}=P.WorkspaceEdit.from(l);r.edits=r.edits.concat(d)}return this.d.$tryApplyWorkspaceEdit(new R.$5w(r))}}e.$hsc=O}),define(Re[126],Te([1,0,12,8,7]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zrc=void 0,D=qe(D),P=qe(P);class N{static{this.apiEditorsToExtHost=new WeakMap}constructor(O,p,s,I,b,h){this.id=O,this.f=p,this.notebookData=s,this.a=[],this.b=[],this.d=!1,this.a=b,this.b=I,this.c=h}get apiEditor(){if(!this.e){const O=this;this.e={get notebook(){return O.notebookData.apiNotebook},get selection(){return O.a[0]},set selection(p){this.selections=[p]},get selections(){return O.a},set selections(p){if(!Array.isArray(p)||!p.every(P.$wP.isNotebookRange))throw(0,v.$9)("selections");O.a=p,O.g(p)},get visibleRanges(){return O.b},revealRange(p,s){O.f.$tryRevealRange(O.id,D.NotebookRange.from(p),s??P.NotebookEditorRevealType.Default)},get viewColumn(){return O.c},[Symbol.for("debug.description")](){return`NotebookEditor(${this.notebook.uri.toString()})`}},N.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(O){this.d=O}_acceptVisibleRanges(O){this.b=O}_acceptSelections(O){this.a=O}g(O){this.f.$trySetSelections(this.id,O.map(D.NotebookRange.from))}_acceptViewColumn(O){this.c=O}}e.$Zrc=N}),define(Re[247],Te([1,0,6,11,8]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jsc=void 0,P=qe(P);let N=class{constructor(O,p){this.c=O,this.d=p,this.a=new v.$oe,this.b=new v.$oe,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(O,p){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",O,p);const s=this.d.getEditorById(O);p.visibleRanges&&s._acceptVisibleRanges(p.visibleRanges.ranges.map(P.NotebookRange.to)),p.selections&&s._acceptSelections(p.selections.selections.map(P.NotebookRange.to)),p.visibleRanges&&this.b.fire({notebookEditor:s.apiEditor,visibleRanges:s.apiEditor.visibleRanges}),p.selections&&this.a.fire(Object.freeze({notebookEditor:s.apiEditor,selections:s.apiEditor.selections}))}$acceptEditorViewColumns(O){for(const p in O)this.d.getEditorById(p)._acceptViewColumn(P.ViewColumn.to(O[p]))}};e.$jsc=N,e.$jsc=N=Ke([We(0,D.$dk)],N)}),define(Re[248],Te([1,0,6,5,126]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$msc=void 0;class N{constructor(O,p){this.c=p,this.a=new Map,this.b=O.getProxy(D.$3N.MainThreadNotebookRenderers)}$postRendererMessage(O,p,s){const I=this.c.getEditorById(O);this.a.get(p)?.fire({editor:I.apiEditor,message:s})}createRendererMessaging(O,p){if(!O.contributes?.notebookRenderer?.some(I=>I.id===p))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${p})`);return{onDidReceiveMessage:(I,b,h)=>this.d(p).event(I,b,h),postMessage:(I,b)=>{P.$Zrc.apiEditorsToExtHost.has(I)&&([I,b]=[b,I]);const h=b&&P.$Zrc.apiEditorsToExtHost.get(b);return this.b.$postMessage(h?.id,p,I)}}}d(O){let p=this.a.get(O);return p||(p=new v.$oe({onDidRemoveLastListener:()=>{p?.dispose(),this.a.delete(O)}}),this.a.set(O,p),p)}}e.$msc=N}),define(Re[249],Te([1,0,8,77,19,71,12]),function(we,e,v,D,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qsc=void 0;class O{constructor(b){this.b=0,this.c=new Map,this.a=b}async withProgress(b,h,E){const f=this.b++,{title:r,location:l,cancellable:d}=h,a={label:b.displayName||b.name,id:b.identifier.value};return this.a.$startProgress(f,{location:v.ProgressLocation.from(l),title:r,source:a,cancellable:d},b.isUnderDevelopment?void 0:b.identifier.value).catch(R.$3),this.d(f,E,!!d)}d(b,h,E){let f;E&&(f=new P.$ze,this.c.set(b,f));const r=d=>{this.a.$progressEnd(d),this.c.delete(d),f?.dispose()};let l;try{l=h(new s(this.a,b),E&&f?f.token:P.CancellationToken.None)}catch(d){throw r(b),d}return l.then(d=>r(b),d=>r(b)),l}$acceptProgressCanceled(b){const h=this.c.get(b);h&&(h.cancel(),this.c.delete(b))}}e.$qsc=O;function p(I,b){return I.message=b.message,typeof b.increment=="number"&&(typeof I.increment=="number"?I.increment+=b.increment:I.increment=b.increment),I}class s extends D.$Gw{constructor(b,h){super(E=>this.throttledReport(E)),this.c=b,this.d=h}throttledReport(b){this.c.$progressReport(this.d,b)}}Ke([(0,N.$ci)(100,(I,b)=>p(I,b),()=>Object.create(null))],s.prototype,"throttledReport",null)}),define(Re[250],Te([1,0,2,5,10,8]),function(we,e,v,D,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rsc=void 0;class R{static{this.a=0}constructor(p,s){this.d=s,this.c=new Map,this.b=p.getProxy(D.$3N.MainThreadQuickDiff)}$provideOriginalResource(p,s,I){const b=v.URI.revive(s),h=this.c.get(p);return h?(0,P.$Ah)(()=>h.provideOriginalResource(b,I)).then(E=>E||null):Promise.resolve(null)}registerQuickDiffProvider(p,s,I,b){const h=R.a++;return this.c.set(h,s),this.b.$registerQuickDiffProvider(h,N.DocumentSelector.from(p,this.d),I,b),{dispose:()=>{this.b.$unregisterQuickDiffProvider(h),this.c.delete(h)}}}}e.$rsc=R});var si=this&&this.__importDefault||function(we){return we&&we.__esModule?we:{default:we}};define(Re[251],Te([1,0,19,6,4,5,2,7,12,17,36,35,21,8]),function(we,e,v,D,P,N,R,O,p,s,I,b,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ssc=f,I=si(I);function f(r,l,d){const a=r.getProxy(N.$3N.MainThreadQuickOpen);class i{constructor(k,y){this.e=new Map,this.f=0,this.a=k,this.b=y}showQuickPick(k,y,C,T=v.CancellationToken.None){this.c=void 0;const $=Promise.resolve(y),w=++this.f,M=a.$show(w,{title:C?.title,placeHolder:C?.placeHolder,matchOnDescription:C?.matchOnDescription,matchOnDetail:C?.matchOnDetail,ignoreFocusLost:C?.ignoreFocusOut,canPickMany:C?.canPickMany},T),A={},L=M.then(()=>A);return Promise.race([L,$]).then(J=>{if(J===A)return;const Y=(0,h.$vH)(k,"quickPickItemTooltip");return $.then(z=>{const Q=[];for(let V=0;V<z.length;V++){const ie=z[V];if(typeof ie=="string")Q.push({label:ie,handle:V});else if(ie.kind===O.QuickPickItemKind.Separator)Q.push({type:"separator",label:ie.label});else{ie.tooltip&&!Y&&console.warn(`Extension '${k.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${k.identifier.value}`);const le=ie.iconPath?m(ie.iconPath):void 0;Q.push({label:ie.label,iconPath:le?.iconPath,iconClass:le?.iconClass,description:ie.description,detail:ie.detail,picked:ie.picked,alwaysShow:ie.alwaysShow,tooltip:Y?E.MarkdownString.fromStrict(ie.tooltip):void 0,handle:V})}}return C&&typeof C.onDidSelectItem=="function"&&(this.c=V=>{C.onDidSelectItem(z[V])}),a.$setItems(w,Q),M.then(V=>{if(typeof V=="number")return z[V];if(Array.isArray(V))return V.map(ie=>z[ie])})})}).then(void 0,J=>{if(!(0,p.$6)(J))return a.$setError(w,J),Promise.reject(J)})}$onItemSelected(k){this.c?.(k)}showInput(k,y=v.CancellationToken.None){return this.d=k?.validateInput,a.$input(k,typeof this.d=="function",y).then(void 0,C=>{if(!(0,p.$6)(C))return Promise.reject(C)})}async $validateInput(k){if(!this.d)return;const y=await this.d(k);if(!y||typeof y=="string")return y;let C;switch(y.severity){case O.InputBoxValidationSeverity.Info:C=I.default.Info;break;case O.InputBoxValidationSeverity.Warning:C=I.default.Warning;break;case O.InputBoxValidationSeverity.Error:C=I.default.Error;break;default:C=y.message?I.default.Error:I.default.Ignore;break}return{content:y.message,severity:C}}async showWorkspaceFolderPick(k,y=v.CancellationToken.None){const C=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[k]);if(!C)return;const T=await this.a.getWorkspaceFolders2();if(T)return T.find($=>$.uri.toString()===C.uri.toString())}createQuickPick(k){const y=new g(k,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}createInputBox(k){const y=new u(k,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}$onDidChangeValue(k,y){this.e.get(k)?._fireDidChangeValue(y)}$onDidAccept(k){this.e.get(k)?._fireDidAccept()}$onDidChangeActive(k,y){const C=this.e.get(k);C instanceof g&&C._fireDidChangeActive(y)}$onDidChangeSelection(k,y){const C=this.e.get(k);C instanceof g&&C._fireDidChangeSelection(y)}$onDidTriggerButton(k,y){this.e.get(k)?._fireDidTriggerButton(y)}$onDidTriggerItemButton(k,y,C){const T=this.e.get(k);T instanceof g&&T._fireDidTriggerItemButton(y,C)}$onDidHide(k){this.e.get(k)?._fireDidHide()}}class n{static{this.a=1}constructor(k,y){this.x=k,this.y=y,this._id=g.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new D.$oe,this.q=new D.$oe,this.r=new D.$oe,this.s=new D.$oe,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(k){this.b=k,this.z({title:k})}get step(){return this.c}set step(k){this.c=k,this.z({step:k})}get totalSteps(){return this.d}set totalSteps(k){this.d=k,this.z({totalSteps:k})}get enabled(){return this.g}set enabled(k){this.g=k,this.z({enabled:k})}get busy(){return this.j}set busy(k){this.j=k,this.z({busy:k})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(k){this.k=k,this.z({ignoreFocusOut:k})}get value(){return this.l}set value(k){this.l=k,this.z({value:k})}get placeholder(){return this.m}set placeholder(k){this.m=k,this.z({placeholder:k})}get buttons(){return this.n}set buttons(k){const y=(0,h.$vH)(this.x,"quickInputButtonLocation");!y&&k.some(C=>C.location)&&console.warn(`Extension '${this.x.identifier.value}' uses a button location which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.x.identifier.value}`),this.n=k.slice(),this.o.clear(),k.forEach((C,T)=>{const $=C===O.$tP.Back?-1:T;this.o.set($,C)}),this.z({buttons:k.map((C,T)=>({...m(C.iconPath),tooltip:C.tooltip,handle:C===O.$tP.Back?-1:T,location:y?C.location:void 0}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(k){this.l=k,this.q.fire(k)}_fireDidTriggerButton(k){const y=this.o.get(k);y&&this.r.fire(y)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,P.$Sc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),a.$dispose(this._id))}z(k){if(!this.v){for(const y of Object.keys(k)){const C=k[y];this.u[y]=C===void 0?null:C}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){a.$createOrUpdate(this.u),this.u={id:this._id}}}function t(S){if(S instanceof O.$4O)return{id:S.id};const k=c(S),y=o(S);return{dark:typeof k=="string"?R.URI.file(k):k,light:typeof y=="string"?R.URI.file(y):y}}function o(S){return typeof S=="object"&&"light"in S?S.light:S}function c(S){return typeof S=="object"&&"dark"in S?S.dark:S}function m(S){const k=t(S);let y,C;return"id"in k?C=b.ThemeIcon.asClassName(k):y=k,{iconPath:y,iconClass:C}}class g extends n{constructor(k,y){super(k,y),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new D.$oe,this.L=[],this.M=new D.$oe,this.N=new D.$oe,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(k){this.B=k.slice(),this.C.clear(),this.D.clear(),k.forEach((T,$)=>{this.C.set($,T),this.D.set(T,$)});const y=(0,h.$vH)(this.x,"quickPickItemTooltip"),C=[];for(let T=0;T<k.length;T++){const $=k[T];if($.kind===O.QuickPickItemKind.Separator)C.push({type:"separator",label:$.label});else{$.tooltip&&!y&&console.warn(`Extension '${this.x.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.x.identifier.value}`);const w=$.iconPath?m($.iconPath):void 0;C.push({handle:T,label:$.label,iconPath:w?.iconPath,iconClass:w?.iconClass,description:$.description,detail:$.detail,picked:$.picked,alwaysShow:$.alwaysShow,tooltip:y?E.MarkdownString.fromStrict($.tooltip):void 0,buttons:$.buttons?.map((M,A)=>({...m(M.iconPath),tooltip:M.tooltip,handle:A}))})}}this.z({items:C})}get canSelectMany(){return this.E}set canSelectMany(k){this.E=k,this.z({canSelectMany:k})}get matchOnDescription(){return this.F}set matchOnDescription(k){this.F=k,this.z({matchOnDescription:k})}get matchOnDetail(){return this.G}set matchOnDetail(k){this.G=k,this.z({matchOnDetail:k})}get sortByLabel(){return this.H}set sortByLabel(k){this.H=k,this.z({sortByLabel:k})}get keepScrollPosition(){return this.I}set keepScrollPosition(k){this.I=k,this.z({keepScrollPosition:k})}get activeItems(){return this.J}set activeItems(k){this.J=k.filter(y=>this.D.has(y)),this.z({activeItems:this.J.map(y=>this.D.get(y))})}get selectedItems(){return this.L}set selectedItems(k){this.L=k.filter(y=>this.D.has(y)),this.z({selectedItems:this.L.map(y=>this.D.get(y))})}_fireDidChangeActive(k){const y=(0,s.$Jb)(k.map(C=>this.C.get(C)));this.J=y,this.K.fire(y)}_fireDidChangeSelection(k){const y=(0,s.$Jb)(k.map(C=>this.C.get(C)));this.L=y,this.M.fire(y)}_fireDidTriggerItemButton(k,y){const C=this.C.get(k);if(!C||!C.buttons||!C.buttons.length)return;const T=C.buttons[y];T&&this.N.fire({button:T,item:C})}}class u extends n{constructor(k,y){super(k,y),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(k){this.B=k,this.z({password:k})}get prompt(){return this.C}set prompt(k){this.C=k,this.z({prompt:k})}get valueSelection(){return this.D}set valueSelection(k){this.D=k,this.z({valueSelection:k})}get validationMessage(){return this.E}set validationMessage(k){this.E=k,k?typeof k=="string"?this.z({validationMessage:k,severity:I.default.Error}):this.z({validationMessage:k.message,severity:k.severity??I.default.Error}):this.z({validationMessage:void 0,severity:I.default.Ignore})}}return new i(l,d)}}),define(Re[252],Te([1,0,2,6,71,4,10,5,17,146,11,18,37,35,8,21,15,23]),function(we,e,v,D,P,N,R,O,p,s,I,b,h,E,f,r,l,d){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$usc=e.$tsc=void 0;function i(A){return A instanceof v.URI}function n(A,L){return A.scheme===l.Schemas.file&&L.scheme===l.Schemas.file&&d.$l?A.toString()===L.toString():A.toString().toLowerCase()===L.toString().toLowerCase()}function t(A){if(A)return typeof A.iconPath=="string"?v.URI.file(A.iconPath):v.URI.isUri(A.iconPath)||E.ThemeIcon.isThemeIcon(A.iconPath)?A.iconPath:void 0}function o(A){if(A){if(v.URI.isUri(A))return A;if(E.ThemeIcon.isThemeIcon(A))return A;{const L=A;return{light:L.light,dark:L.dark}}}else return}function c(A){const L=o(A.icon),J=A.labels?.map(Y=>({title:Y.title,icon:o(Y.icon)}));return{...A,icon:L,labels:J}}function m(A,L){if(!A.iconPath&&!L.iconPath)return 0;if(A.iconPath){if(!L.iconPath)return 1}else return-1;const J=typeof A.iconPath=="string"?A.iconPath:v.URI.isUri(A.iconPath)?A.iconPath.fsPath:A.iconPath.id,Y=typeof L.iconPath=="string"?L.iconPath:v.URI.isUri(L.iconPath)?L.iconPath.fsPath:L.iconPath.id;return(0,s.$Qr)(J,Y)}function g(A,L){let J=0;if(A.strikeThrough!==L.strikeThrough)return A.strikeThrough?1:-1;if(A.faded!==L.faded)return A.faded?1:-1;if(A.tooltip!==L.tooltip)return(A.tooltip||"").localeCompare(L.tooltip||"");if(J=m(A,L),J!==0)return J;if(A.light&&L.light)J=m(A.light,L.light);else{if(A.light)return 1;if(L.light)return-1}if(J!==0)return J;if(A.dark&&L.dark)J=m(A.dark,L.dark);else{if(A.dark)return 1;if(L.dark)return-1}return J}function u(A,L){if(A.command!==L.command)return A.command<L.command?-1:1;if(A.title!==L.title)return A.title<L.title?-1:1;if(A.tooltip!==L.tooltip){if(A.tooltip!==void 0&&L.tooltip!==void 0)return A.tooltip<L.tooltip?-1:1;if(A.tooltip!==void 0)return 1;if(L.tooltip!==void 0)return-1}if(A.arguments===L.arguments)return 0;if(A.arguments)if(L.arguments){if(A.arguments.length!==L.arguments.length)return A.arguments.length-L.arguments.length}else return 1;else return-1;for(let J=0;J<A.arguments.length;J++){const Y=A.arguments[J],z=L.arguments[J];if(Y!==z&&!(i(Y)&&i(z)&&n(Y,z)))return Y<z?-1:1}return 0}function S(A,L){let J=(0,s.$Qr)(A.resourceUri.fsPath,L.resourceUri.fsPath,!0);if(J!==0)return J;if(A.command&&L.command)J=u(A.command,L.command);else{if(A.command)return 1;if(L.command)return-1}if(J!==0)return J;if(A.decorations&&L.decorations)J=g(A.decorations,L.decorations);else{if(A.decorations)return 1;if(L.decorations)return-1}if(A.multiFileDiffEditorModifiedUri&&L.multiFileDiffEditorModifiedUri)J=(0,s.$Qr)(A.multiFileDiffEditorModifiedUri.fsPath,L.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(A.multiFileDiffEditorModifiedUri)return 1;if(L.multiFileDiffEditorModifiedUri)return-1}if(A.multiDiffEditorOriginalUri&&L.multiDiffEditorOriginalUri)J=(0,s.$Qr)(A.multiDiffEditorOriginalUri.fsPath,L.multiDiffEditorOriginalUri.fsPath,!0);else{if(A.multiDiffEditorOriginalUri)return 1;if(L.multiDiffEditorOriginalUri)return-1}return J}function k(A,L){for(let J=0;J<A.length;J++)if(A[J]!==L[J])return!1;return!0}function y(A,L){return A.command===L.command&&A.title===L.title&&A.tooltip===L.tooltip&&(A.arguments&&L.arguments?k(A.arguments,L.arguments):A.arguments===L.arguments)}function C(A,L){return(0,p.$wb)(A,L,y)}class T{#e;#t;get value(){return this.d}set value(L){L=L??"",this.#e.$setInputBoxValue(this.m,L),this.o(L)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(L){this.#e.$setInputBoxPlaceholder(this.m,L),this.f=L}get validateInput(){return(0,r.$wH)(this.k,"scmValidation"),this.g}set validateInput(L){if((0,r.$wH)(this.k,"scmValidation"),L&&typeof L!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=L,this.#e.$setValidationProviderIsEnabled(this.m,!!L)}get enabled(){return this.h}set enabled(L){L=!!L,this.h!==L&&(this.h=L,this.#e.$setInputBoxEnablement(this.m,L))}get visible(){return this.j}set visible(L){L=!!L,this.j!==L&&(this.j=L,this.#e.$setInputBoxVisibility(this.m,L))}get document(){return(0,r.$wH)(this.k,"scmTextDocument"),this.#t.getDocument(this.n)}constructor(L,J,Y,z,Q){this.k=L,this.m=z,this.n=Q,this.d="",this.e=new D.$oe,this.f="",this.h=!0,this.j=!0,this.#t=J,this.#e=Y}showValidationMessage(L,J){(0,r.$wH)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.m,L,J)}$onInputBoxValueChange(L){this.o(L)}o(L){this.d=L,this.e.fire(L)}}e.$tsc=T;class ${static{this.d=0}get disposed(){return this.m}get id(){return this.v}get label(){return this.w}set label(L){this.w=L,this.s.$updateGroupLabel(this.u,this.handle,L)}get hideWhenEmpty(){return this.q}set hideWhenEmpty(L){this.q=L,this.s.$updateGroup(this.u,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(L){this.f=[...L],this.k.fire()}constructor(L,J,Y,z,Q,V,ie){this.s=L,this.t=J,this.u=Y,this.v=z,this.w=Q,this.multiDiffEditorEnableViewChanges=V,this.x=ie,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new D.$oe,this.onDidUpdateResourceStates=this.k.event,this.m=!1,this.n=new D.$oe,this.onDidDispose=this.n.event,this.o=[],this.p=[],this.q=void 0,this.handle=$.d++}getResourceState(L){return this.g.get(L)}$executeResourceCommand(L,J){const Y=this.h.get(L);return Y?(0,R.$Ah)(()=>this.t.executeCommand(Y.command,...Y.arguments||[],J)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const L=[...this.f].sort(S),Y=(0,p.$Fb)(this.p,L,S).map(V=>{const ie=V.toInsert.map(le=>{const _=this.e++;this.g.set(_,le);const oe=le.resourceUri;let re;if(le.command)if(le.command.command==="vscode.open"||le.command.command==="vscode.diff"||le.command.command==="vscode.changes"){const nt=new N.$Wc;re=this.t.converter.toInternal(le.command,nt),this.j.set(_,nt)}else this.h.set(_,le.command);const ce=(0,r.$vH)(this.x,"scmMultiDiffEditor"),x=ce?le.multiDiffEditorOriginalUri:void 0,$e=ce?le.multiFileDiffEditorModifiedUri:void 0,Pe=t(le.decorations),X=le.decorations&&t(le.decorations.light)||Pe,q=le.decorations&&t(le.decorations.dark)||Pe,ne=[X,q],be=le.decorations&&le.decorations.tooltip||"",Ie=le.decorations&&!!le.decorations.strikeThrough,Fe=le.decorations&&!!le.decorations.faded,Be=le.contextValue||"";return{rawResource:[_,oe,ne,be,Ie,Fe,Be,re,x,$e],handle:_}});return{start:V.start,deleteCount:V.deleteCount,toInsert:ie}}),z=Y.map(({start:V,deleteCount:ie,toInsert:le})=>[V,ie,le.map(_=>_.rawResource)]),Q=Y.reverse();for(const{start:V,deleteCount:ie,toInsert:le}of Q){const _=le.map(re=>re.handle),oe=this.o.splice(V,ie,..._);for(const re of oe)this.g.delete(re),this.h.delete(re),this.j.get(re)?.dispose(),this.j.delete(re)}return this.p=L,z}dispose(){this.m=!0,this.n.fire()}}class w{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(L){this.g!==L&&(this.g=L,this.#e.$updateSourceControl(this.x,{count:L}))}get quickDiffProvider(){return this.h}set quickDiffProvider(L){this.h=L;let J;(0,r.$vH)(this.y,"quickDiffProvider")&&(J=L?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!L,quickDiffLabel:J})}get historyProvider(){return(0,r.$wH)(this.y,"scmHistoryProvider"),this.j}set historyProvider(L){(0,r.$wH)(this.y,"scmHistoryProvider"),this.j=L,this.k.value=new N.$Wc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!L}),L&&this.k.value.add(L.onDidChangeCurrentHistoryItemGroup(()=>{this.m=L?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.m)}))}get commitTemplate(){return this.n}set commitTemplate(L){L!==this.n&&(this.n=L,this.#e.$updateSourceControl(this.x,{commitTemplate:L}))}get acceptInputCommand(){return this.p}set acceptInputCommand(L){this.o.value=new N.$Wc,this.p=L;const J=this.z.converter.toInternal(L,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:J})}get actionButton(){return(0,r.$wH)(this.y,"scmActionButton"),this.s}set actionButton(L){(0,r.$wH)(this.y,"scmActionButton"),this.q.value=new N.$Wc,this.s=L;const J=L!==void 0?{command:this.z.converter.toInternal(L.command,this.q.value),secondaryCommands:L.secondaryCommands?.map(Y=>Y.map(z=>this.z.converter.toInternal(z,this.q.value))),description:L.description,enabled:L.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:J??null})}get statusBarCommands(){return this.u}set statusBarCommands(L){if(this.u&&L&&C(this.u,L))return;this.t.value=new N.$Wc,this.u=L;const J=(L||[]).map(Y=>this.z.converter.toInternal(Y,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:J})}get selected(){return this.v}constructor(L,J,Y,z,Q,V,ie){this.y=L,this.z=z,this.A=Q,this.B=V,this.C=ie,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new N.$Yc,this.n=void 0,this.o=new N.$Yc,this.p=void 0,this.q=new N.$Yc,this.t=new N.$Yc,this.u=void 0,this.v=!1,this.w=new D.$oe,this.onDidChangeSelection=this.w.event,this.x=w.d++,this.D=new Map,this.E=new Set,this.#e=Y;const le=v.URI.from({scheme:l.Schemas.vscodeSourceControl,path:`${Q}/scm${this.x}/input`,query:ie?`rootUri=${encodeURIComponent(ie.toString())}`:void 0});this.f=new T(L,J,this.#e,this.x,le),this.#e.$registerSourceControl(this.x,Q,V,ie,le)}createResourceGroup(L,J,Y){const z=(0,r.$vH)(this.y,"scmMultiDiffEditor")&&Y?.multiDiffEditorEnableViewChanges===!0,Q=new $(this.#e,this.z,this.x,L,J,z,this.y),V=D.Event.once(Q.onDidDispose)(()=>this.D.delete(Q));return this.D.set(Q,V),this.eventuallyAddResourceGroups(),Q}eventuallyAddResourceGroups(){const L=[],J=[];for(const[Y,z]of this.D){z.dispose();const Q=Y.onDidUpdateResourceStates(()=>{this.E.add(Y),this.eventuallyUpdateResourceStates()});D.Event.once(Y.onDidDispose)(()=>{this.E.delete(Y),Q.dispose(),this.e.delete(Y.handle),this.#e.$unregisterGroup(this.x,Y.handle)}),L.push([Y.handle,Y.id,Y.label,Y.features,Y.multiDiffEditorEnableViewChanges]);const V=Y._takeResourceStateSnapshot();V.length>0&&J.push([Y.handle,V]),this.e.set(Y.handle,Y)}this.#e.$registerGroups(this.x,L,J),this.D.clear()}eventuallyUpdateResourceStates(){const L=[];this.E.forEach(J=>{const Y=J._takeResourceStateSnapshot();Y.length!==0&&L.push([J.handle,Y])}),L.length>0&&this.#e.$spliceResourceStates(this.x,L),this.E.clear()}getResourceGroup(L){return this.e.get(L)}setSelectionState(L){this.v=L,this.w.fire(L)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(L=>L.dispose()),this.#e.$unregisterSourceControl(this.x)}}Ke([(0,P.$bi)(100)],w.prototype,"eventuallyAddResourceGroups",null),Ke([(0,P.$bi)(100)],w.prototype,"eventuallyUpdateResourceStates",null);let M=class{static{a=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(L,J,Y,z){this.m=J,this.n=Y,this.o=z,this.g=new Map,this.h=new b.$xn,this.j=new D.$oe,this.e=L.getProxy(O.$3N.MainThreadSCM),this.f=L.getProxy(O.$3N.MainThreadTelemetry),J.registerArgumentProcessor({processArgument:Q=>{if(Q&&Q.$mid===h.MarshalledId.ScmResource){const V=this.g.get(Q.sourceControlHandle);if(!V)return Q;const ie=V.getResourceGroup(Q.groupHandle);return ie?ie.getResourceState(Q.handle):Q}else if(Q&&Q.$mid===h.MarshalledId.ScmResourceGroup){const V=this.g.get(Q.sourceControlHandle);return V?V.getResourceGroup(Q.groupHandle):Q}else if(Q&&Q.$mid===h.MarshalledId.ScmProvider){const V=this.g.get(Q.handle);return V||Q}return Q}})}createSourceControl(L,J,Y,z){this.o.trace("ExtHostSCM#createSourceControl",L.identifier.value,J,Y,z),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:L.identifier.value});const Q=a.d++,V=new w(L,this.n,this.e,this.m,J,Y,z);this.g.set(Q,V);const ie=this.h.get(L.identifier)||[];return ie.push(V),this.h.set(L.identifier,ie),V}getLastInputBox(L){this.o.trace("ExtHostSCM#getLastInputBox",L.identifier.value);const J=this.h.get(L.identifier),Y=J&&J[J.length-1];return Y&&Y.inputBox}$provideOriginalResource(L,J,Y){const z=v.URI.revive(J);this.o.trace("ExtHostSCM#$provideOriginalResource",L,z.toString());const Q=this.g.get(L);return!Q||!Q.quickDiffProvider||!Q.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$Ah)(()=>Q.quickDiffProvider.provideOriginalResource(z,Y)).then(V=>V||null)}$onInputBoxValueChange(L,J){this.o.trace("ExtHostSCM#$onInputBoxValueChange",L);const Y=this.g.get(L);return Y&&Y.inputBox.$onInputBoxValueChange(J),Promise.resolve(void 0)}$executeResourceCommand(L,J,Y,z){this.o.trace("ExtHostSCM#$executeResourceCommand",L,J,Y);const Q=this.g.get(L);if(!Q)return Promise.resolve(void 0);const V=Q.getResourceGroup(J);return V?V.$executeResourceCommand(Y,z):Promise.resolve(void 0)}$validateInput(L,J,Y){this.o.trace("ExtHostSCM#$validateInput",L);const z=this.g.get(L);return!z||!z.inputBox.validateInput?Promise.resolve(void 0):(0,R.$Ah)(()=>z.inputBox.validateInput(J,Y)).then(Q=>{if(!Q)return Promise.resolve(void 0);const V=f.MarkdownString.fromStrict(Q.message);return V?Promise.resolve([V,Q.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(L){return this.o.trace("ExtHostSCM#$setSelectedSourceControl",L),L!==void 0&&this.g.get(L)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=L,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(L,J,Y,z){return await this.g.get(L)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(J,Y,z)??void 0}async $resolveHistoryItemGroupCommonAncestor2(L,J,Y){return await this.g.get(L)?.historyProvider?.resolveHistoryItemGroupCommonAncestor2(J,Y)??void 0}async $provideHistoryItems(L,J,Y,z){return(await this.g.get(L)?.historyProvider?.provideHistoryItems(J,Y,z))?.map(ie=>c(ie))??void 0}async $provideHistoryItems2(L,J,Y){return(await this.g.get(L)?.historyProvider?.provideHistoryItems2(J,Y))?.map(V=>c(V))??void 0}async $provideHistoryItemSummary(L,J,Y,z){const Q=this.g.get(L)?.historyProvider;if(typeof Q?.provideHistoryItemSummary!="function")return;const V=await Q.provideHistoryItemSummary(J,Y,z);return V?c(V):void 0}async $provideHistoryItemChanges(L,J,Y,z){return await this.g.get(L)?.historyProvider?.provideHistoryItemChanges(J,Y,z)??void 0}};e.$usc=M,e.$usc=M=a=Ke([We(3,I.$dk)],M)}),define(Re[253],Te([1,0,5,8,2]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vsc=void 0;class N{static{this.a=0}constructor(O,p){this.d=p,this.c=new Map,this.b=O.getProxy(v.$3N.MainThreadShare)}async $provideShare(O,p,s){return await this.c.get(O)?.provideShare({selection:D.Range.to(p.selection),resourceUri:P.URI.revive(p.resourceUri)},s)??void 0}registerShareProvider(O,p){const s=N.a++;return this.c.set(s,p),this.b.$registerShareProvider(s,D.DocumentSelector.from(O,this.d),p.id,p.label,p.priority),{dispose:()=>{this.b.$unregisterShareProvider(s),this.c.delete(s)}}}}e.$vsc=N}),define(Re[254],Te([1,0,7,5,9,4,8,14]),function(we,e,v,D,P,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ysc=e.$xsc=void 0;class p{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new v.$5O("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new v.$5O("statusBarItem.warningForeground")]])}#e;#t;constructor(h,E,f,r,l,d=v.StatusBarAlignment.Left,a){if(this.i=!1,this.k="",this.q=new N.$Wc,this.#e=h,this.#t=E,l&&r){this.c=(0,v.$GO)(r.identifier,l);const i=f.get(this.c);i&&(d=i.alignLeft?v.StatusBarAlignment.Left:v.StatusBarAlignment.Right,a=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(p.a++);this.e=r,this.f=l,this.g=d,this.h=this.u(a)}u(h){if((0,O.$lg)(h))return h===Number.POSITIVE_INFINITY?Number.MAX_VALUE:h===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:h}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(h){this.k=h,this.v()}set name(h){this.m=h,this.v()}set tooltip(h){this.l=h,this.v()}set color(h){this.n=h,this.v()}set backgroundColor(h){h&&!p.b.has(h.id)&&(h=void 0),this.o=h,this.v()}set command(h){this.r?.fromApi!==h&&(this.p&&this.q.add(this.p),this.p=new N.$Wc,typeof h=="string"?this.r={fromApi:h,internal:this.#t.toInternal({title:"",command:h},this.p)}:h?this.r={fromApi:h,internal:this.#t.toInternal(h,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(h){this.t=h,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let h;this.e?this.f?h=`${this.e.identifier.value}.${this.f}`:h=this.e.identifier.value:h=this.f;let E;this.m?E=this.m:E=(0,P.localize)(2711,null,this.e.displayName||this.e.name);let f=this.n;this.o&&(f=p.b.get(this.o.id));const r=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,h,this.e?.identifier.value,E,this.k,r,this.r?.internal,f,this.o,this.g===v.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$xsc=p;class s{constructor(h){this.b=[],this.a=h.createStatusBarEntry(void 0,"status.extensionMessage",v.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,P.localize)(2712,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(h){const E={message:h};return this.b.unshift(E),this.c(),new v.$5N(()=>{const f=this.b.indexOf(E);f>=0&&(this.b.splice(f,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class I{constructor(h,E){this.e=new Map,this.a=h.getProxy(D.$3N.MainThreadStatusBar),this.b=E,this.c=new s(this)}$acceptStaticEntries(h){for(const E of h)this.e.set(E.entryId,E)}createStatusBarEntry(h,E,f,r){return new p(this.a,this.b,this.e,h,E,f,r)}setStatusBarMessage(h,E){const f=this.c.setMessage(h);let r;return typeof E=="number"?r=setTimeout(()=>f.dispose(),E):typeof E<"u"&&E.then(()=>f.dispose(),()=>f.dispose()),new v.$5N(()=>{f.dispose(),clearTimeout(r)})}}e.$ysc=I}),define(Re[127],Te([1,0,32,118,54,82,55,8,2]),function(we,e,v,D,P,N,R,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SQ=e.$RQ=e.$QQ=e.$PQ=void 0,v=qe(v),O=qe(O);const s=(i,n,t,o)=>{let c=n;return{enumerable:!0,configurable:!1,get(){return c},set(m){if(!t(c,m)){const g=c;c=m,i.listener?.(o(m,g))}}}},I=(i,n)=>i===n,b={range:(i,n)=>i===n?!0:!i||!n?!1:i.isEqual(n),label:I,description:I,sortText:I,busy:I,error:I,canResolveChildren:I,tags:(i,n)=>!(i.length!==n.length||i.some(t=>!n.find(o=>t.id===o.id)))},h=i=>n=>({op:N.TestItemEventOp.SetProp,update:i(n)}),E=(i,n)=>({range:(()=>{let t;const o=h(c=>({range:v.$Ut.lift(O.Range.from(c))}));return{enumerable:!0,configurable:!1,get(){return t},set(c){i.listener?.({op:N.TestItemEventOp.DocumentSynced}),b.range(t,c)||(t=c,i.listener?.(o(c)))}}})(),label:s(i,n,b.label,h(t=>({label:t}))),description:s(i,void 0,b.description,h(t=>({description:t}))),sortText:s(i,void 0,b.sortText,h(t=>({sortText:t}))),canResolveChildren:s(i,!1,b.canResolveChildren,t=>({op:N.TestItemEventOp.UpdateCanResolveChildren,state:t})),busy:s(i,!1,b.busy,h(t=>({busy:t}))),error:s(i,void 0,b.error,h(t=>({error:O.MarkdownString.fromStrict(t)||null}))),tags:s(i,[],b.tags,(t,o)=>({op:N.TestItemEventOp.SetTags,new:t.map(O.TestTag.from),old:o.map(O.TestTag.from)}))}),f=i=>{const n=P.$mJ.fromString(i.extId),t=new l(n.controllerId,n.localId,i.label,p.URI.revive(i.uri)||void 0);return t.range=O.Range.to(i.range||void 0),t.description=i.description||void 0,t.sortText=i.sortText||void 0,t.tags=i.tags.map(o=>O.TestTag.to({id:(0,R.$sJ)(o).tagId})),t},r=i=>{let n;for(const t of i.tests){const o=f(t.item);(0,D.$zQ)(o).parent=n,n=o}return n};e.$PQ=r;class l{constructor(n,t,o,c){if(t.includes(P.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(t)} symbol`);const m=(0,D.$yQ)(this,n);Object.defineProperties(this,{id:{value:t,enumerable:!0,writable:!1},uri:{value:c,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return m.parent instanceof d?void 0:m.parent}},children:{value:(0,N.$xQ)(m,D.$zQ,l),enumerable:!0,writable:!1},...E(m,o)})}}e.$QQ=l;class d extends l{constructor(n,t){super(n,n,t,void 0),this._isRoot=!0}}e.$RQ=d;class a extends N.$tQ{constructor(n,t,o){super({controllerId:n,getDocumentVersion:c=>c&&o.getDocument(c)?.version,getApiFor:D.$zQ,getChildren:c=>c.children,root:new d(n,t),toITestItem:O.TestItem.from})}}e.$SQ=a}),define(Re[34],Te([1,0,14,7,8,25,5,17,11,33,32,102,2,4,3,16,127,20,39,42,69,63,66,38]),function(we,e,v,D,P,N,R,O,p,s,I,b,h,E,f,r,l,d,a,i,n,t,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4Q=e.$3Q=e.$2Q=e.$1Q=e.$ZQ=e.$YQ=void 0,D=qe(D),P=qe(P);let m=class{#e;#t;#i;constructor(C,T,$){this.b=new Map,this.c=new Map,this.#e=C.getProxy(R.$3N.MainThreadCommands),this.d=T,this.#i=$,this.#t=C.getProxy(R.$3N.MainThreadTelemetry),this.converter=new g(this,w=>{const M=this.c.get(w);return M?.result===S.Void?M:void 0},T),this.f=[{processArgument(w){return(0,s.$fi)(w)}},{processArgument(w){return(0,N.$ko)(w,function(M){if(I.$Ut.isIRange(M))return P.Range.to(M);if(b.$Tt.isIPosition(M))return P.Position.to(M);if(I.$Ut.isIRange(M.range)&&h.URI.isUri(M.uri))return P.location.to(M);if(M instanceof d.$Qe)return M.buffer.buffer;if(!Array.isArray(M))return M})}}]}registerArgumentProcessor(C){this.f.push(C)}registerApiCommand(C){const T=this.registerCommand(!1,C.id,async(...$)=>{const w=C.args.map((A,L)=>{if(!A.validate($[L]))throw new Error(`Invalid argument '${A.name}' when running '${C.id}', received: ${typeof $[L]=="object"?JSON.stringify($[L],null,"	"):$[L]} `);return A.convert($[L])}),M=await this.executeCommand(C.internalId,...w);return C.result.convert(M,$,this.converter)},void 0,{description:C.description,args:C.args,returns:C.result.description});return this.c.set(C.id,C),new D.$5N(()=>{T.dispose(),this.c.delete(C.id)})}registerCommand(C,T,$,w,M,A){if(this.d.trace("ExtHostCommands#registerCommand",T),!T.trim().length)throw new Error("invalid id");if(this.b.has(T))throw new Error(`command '${T}' already exists`);return this.b.set(T,{callback:$,thisArg:w,metadata:M,extension:A}),C&&this.#e.$registerCommand(T),new D.$5N(()=>{this.b.delete(T)&&C&&this.#e.$unregisterCommand(T)})}executeCommand(C,...T){return this.d.trace("ExtHostCommands#executeCommand",C),this.g(C,T,!0)}async g(C,T,$){if(this.b.has(C))return this.#e.$fireCommandActivationEvent(C),this.h(C,T,!1);{let w=!1;const M=(0,N.$ko)(T,function(A){if(A instanceof D.$6N)return P.Position.from(A);if(A instanceof D.$7N)return P.Range.from(A);if(A instanceof D.$gO)return P.location.from(A);if(D.$wP.isNotebookRange(A))return P.NotebookRange.from(A);if(A instanceof ArrayBuffer)return w=!0,d.$Qe.wrap(new Uint8Array(A));if(A instanceof Uint8Array)return w=!0,d.$Qe.wrap(A);if(A instanceof d.$Qe)return w=!0,A;if(!Array.isArray(A))return A});try{const A=await this.#e.$executeCommand(C,w?new a.$5w(M):M,$);return(0,s.$fi)(A)}catch(A){if(A instanceof Error&&A.message==="$executeCommand:retry")return this.g(C,T,!1);throw A}}}async h(C,T,$){const w=this.b.get(C);if(!w)throw new Error("Unknown command");const{callback:M,thisArg:A,metadata:L}=w;if(L?.args)for(let Y=0;Y<L.args.length;Y++)try{(0,v.$yg)(T[Y],L.args[Y].constraint)}catch{throw new Error(`Running the contributed command: '${C}' failed. Illegal argument '${L.args[Y].name}' - ${L.args[Y].description}`)}const J=n.$ie.create();try{return await M.apply(A,T)}catch(Y){if(C===this.converter.delegatingCommandId){const z=this.converter.getActualCommand(...T);z&&(C=z.command)}if(this.d.error(Y,C,w.extension?.identifier),!$)throw Y;if(w.extension?.identifier){const z=this.#i.onExtensionError(w.extension.identifier,Y);this.d.trace("forwarded error to extension?",z,w.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$tj)(Y)),this.id=C,this.source=w.extension?.displayName??w.extension?.name}}}finally{this.j(w,C,J.elapsed())}}j(C,T,$){C.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:C.extension.identifier.value,id:new t.$Bp(T),duration:$})}$executeContributedCommand(C,...T){this.d.trace("ExtHostCommands#$executeContributedCommand",C);const $=this.b.get(C);return $?(T=T.map(w=>this.f.reduce((M,A)=>A.processArgument(M,$.extension?.identifier),w)),this.h(C,T,!0)):Promise.reject(new Error(`Contributed command '${C}' does not exist.`))}getCommands(C=!1){return this.d.trace("ExtHostCommands#getCommands",C),this.#e.$getCommands().then(T=>(C&&(T=T.filter($=>$[0]!=="_")),T))}$getContributedCommandMetadata(){const C=Object.create(null);for(const[T,$]of this.b){const{metadata:w}=$;w&&(C[T]=w)}return Promise.resolve(C)}};e.$YQ=m,e.$YQ=m=Ke([We(0,r.$DQ),We(1,p.$dk),We(2,o.$XQ)],m),e.$ZQ=(0,f.$Ii)("IExtHostCommands");class g{constructor(C,T,$){this.d=C,this.f=T,this.g=$,this.delegatingCommandId=`__vsc${(0,c.$5g)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(C,T){if(!C)return;const $={$ident:void 0,id:C.command,title:C.title,tooltip:C.tooltip};if(!C.command)return $;const w=this.f(C.command);if(w)$.id=w.internalId,$.arguments=w.args.map((M,A)=>M.convert(C.arguments&&C.arguments[A]));else if((0,O.$Nb)(C.arguments)){const M=`${C.command} /${++this.c}`;this.b.set(M,C),T.add((0,E.$Vc)(()=>{this.b.delete(M),this.g.trace("CommandsConverter#DISPOSE",M)})),$.$ident=M,$.id=this.delegatingCommandId,$.arguments=[M],this.g.trace("CommandsConverter#CREATE",C.command,M)}return $}fromInternal(C){return typeof C.$ident=="string"?this.b.get(C.$ident):{command:C.id,title:C.title,arguments:C.arguments}}getActualCommand(...C){return this.b.get(C[0])}h(...C){const T=this.getActualCommand(...C);return this.g.trace("CommandsConverter#EXECUTE",C[0],T?T.command:"MISSING"),T?this.d.executeCommand(T.command,...T.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${C[0]}`)}}e.$1Q=g;class u{static{this.Uri=new u("uri","Uri of a text document",C=>h.URI.isUri(C),C=>C)}static{this.Position=new u("position","A position in a text document",C=>D.$6N.isPosition(C),P.Position.from)}static{this.Range=new u("range","A range in a text document",C=>D.$7N.isRange(C),P.Range.from)}static{this.Selection=new u("selection","A selection in a text document",C=>D.$8N.isSelection(C),P.Selection.from)}static{this.Number=new u("number","",C=>typeof C=="number",C=>C)}static{this.String=new u("string","",C=>typeof C=="string",C=>C)}static{this.StringArray=u.Arr(u.String)}static Arr(C){return new u(`${C.name}_array`,`Array of ${C.name}, ${C.description}`,T=>Array.isArray(T)&&T.every($=>C.validate($)),T=>T.map($=>C.convert($)))}static{this.CallHierarchyItem=new u("item","A call hierarchy item",C=>C instanceof D.$sO,P.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new u("item","A type hierarchy item",C=>C instanceof D.$RP,P.TypeHierarchyItem.from)}static{this.TestItem=new u("testItem","A VS Code TestItem",C=>C instanceof l.$QQ,P.TestItem.from)}constructor(C,T,$,w){this.name=C,this.description=T,this.validate=$,this.convert=w}optional(){return new u(this.name,`(optional) ${this.description}`,C=>C==null||this.validate(C),C=>C===void 0?void 0:C===null?null:this.convert(C))}with(C,T){return new u(C??this.name,T??this.description,this.validate,this.convert)}}e.$2Q=u;class S{static{this.Void=new S("no result",C=>C)}constructor(C,T){this.description=C,this.convert=T}}e.$3Q=S;class k{constructor(C,T,$,w,M){this.id=C,this.internalId=T,this.description=$,this.args=w,this.result=M}}e.$4Q=k}),define(Re[255],Te([1,0,17,15,2,94,104,31,34,8,7]),function(we,e,v,D,P,N,R,O,p,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iqc=void 0,N=qe(N),s=qe(s),I=qe(I);const b=[new p.$4Q("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of DocumentHighlight-instances.",E(s.DocumentHighlight.to))),new p.$4Q("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[p.$2Q.Uri],new p.$3Q("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,l)=>{if((0,v.$Mb)(r))return;class d extends I.$nO{static to(i){const n=new d(i.name,s.SymbolKind.to(i.kind),i.containerName||"",new I.$gO(l[0],s.Range.to(i.range)));return n.detail=i.detail,n.range=n.location.range,n.selectionRange=s.Range.to(i.selectionRange),n.children=i.children?i.children.map(d.to):[],n}}return r.map(d.to)})),new p.$4Q("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[p.$2Q.Uri,new p.$2Q("options","Formatting options",r=>!0,r=>r)],new p.$3Q("A promise that resolves to an array of TextEdits.",E(s.TextEdit.to))),new p.$4Q("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[p.$2Q.Uri,p.$2Q.Range,new p.$2Q("options","Formatting options",r=>!0,r=>r)],new p.$3Q("A promise that resolves to an array of TextEdits.",E(s.TextEdit.to))),new p.$4Q("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[p.$2Q.Uri,p.$2Q.Position,new p.$2Q("ch","Trigger character",r=>typeof r=="string",r=>r),new p.$2Q("options","Formatting options",r=>!0,r=>r)],new p.$3Q("A promise that resolves to an array of TextEdits.",E(s.TextEdit.to))),new p.$4Q("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of Location or LocationLink instances.",f)),new p.$4Q("vscode.experimental.executeDefinitionProvider_recursive","_executeDefinitionProvider_recursive","Execute all definition providers.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of Location or LocationLink instances.",f)),new p.$4Q("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of Location or LocationLink instances.",f)),new p.$4Q("vscode.experimental.executeTypeDefinitionProvider_recursive","_executeTypeDefinitionProvider_recursive","Execute all type definition providers.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of Location or LocationLink instances.",f)),new p.$4Q("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of Location or LocationLink instances.",f)),new p.$4Q("vscode.experimental.executeDeclarationProvider_recursive","_executeDeclarationProvider_recursive","Execute all declaration providers.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of Location or LocationLink instances.",f)),new p.$4Q("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of Location or LocationLink instances.",f)),new p.$4Q("vscode.experimental.executeImplementationProvider_recursive","_executeImplementationProvider_recursive","Execute all implementation providers.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of Location or LocationLink instances.",f)),new p.$4Q("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of Location-instances.",E(s.location.to))),new p.$4Q("vscode.experimental.executeReferenceProvider","_executeReferenceProvider_recursive","Execute all reference providers.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of Location-instances.",E(s.location.to))),new p.$4Q("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of Hover-instances.",E(s.Hover.to))),new p.$4Q("vscode.experimental.executeHoverProvider_recursive","_executeHoverProvider_recursive","Execute all hover providers.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of Hover-instances.",E(s.Hover.to))),new p.$4Q("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[p.$2Q.Uri,new p.$2Q("position","A position in a text document",r=>Array.isArray(r)&&r.every(l=>I.$6N.isPosition(l)),r=>r.map(s.Position.from))],new p.$3Q("A promise that resolves to an array of ranges.",r=>r.map(l=>{let d;for(const a of l.reverse())d=new I.$rO(s.Range.to(a),d);return d}))),new p.$4Q("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[p.$2Q.String.with("query","Search string")],new p.$3Q("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(s.WorkspaceSymbol.to))),new p.$4Q("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(s.CallHierarchyItem.to))),new p.$4Q("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[p.$2Q.CallHierarchyItem],new p.$3Q("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(s.CallHierarchyIncomingCall.to))),new p.$4Q("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[p.$2Q.CallHierarchyItem],new p.$3Q("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(s.CallHierarchyOutgoingCall.to))),new p.$4Q("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:s.Range.to(r.range),placeholder:r.text}})),new p.$4Q("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[p.$2Q.Uri,p.$2Q.Position,p.$2Q.String.with("newName","The new symbol name")],new p.$3Q("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return s.WorkspaceEdit.to(r)}})),new p.$4Q("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[p.$2Q.Uri,p.$2Q.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new p.$3Q("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(s.DocumentLink.to))),new p.$4Q("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[p.$2Q.Uri],new p.$3Q("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new I.$nP(r.tokenTypes,r.tokenModifiers)})),new p.$4Q("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[p.$2Q.Uri],new p.$3Q("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const l=(0,R.$peb)(r);if(l.type==="full")return new I.$pP(l.data,void 0)})),new p.$4Q("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[p.$2Q.Uri,p.$2Q.Range.optional()],new p.$3Q("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new I.$nP(r.tokenTypes,r.tokenModifiers)})),new p.$4Q("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[p.$2Q.Uri,p.$2Q.Range],new p.$3Q("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const l=(0,R.$peb)(r);if(l.type==="full")return new I.$pP(l.data,void 0)})),new p.$4Q("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[p.$2Q.Uri,p.$2Q.Position,p.$2Q.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),p.$2Q.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new p.$3Q("A promise that resolves to a CompletionList-instance.",(r,l,d)=>{if(!r)return new I.$DO([]);const a=r.suggestions.map(i=>s.CompletionItem.to(i,d));return new I.$DO(a,r.incomplete)})),new p.$4Q("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[p.$2Q.Uri,p.$2Q.Position,p.$2Q.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new p.$3Q("A promise that resolves to SignatureHelp.",r=>{if(r)return s.SignatureHelp.to(r)})),new p.$4Q("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[p.$2Q.Uri,p.$2Q.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new p.$3Q("A promise that resolves to an array of CodeLens-instances.",(r,l,d)=>E(a=>new I.$vO(s.Range.to(a.range),a.command&&d.fromInternal(a.command)))(r))),new p.$4Q("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[p.$2Q.Uri,new p.$2Q("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>I.$7N.isRange(r),r=>I.$8N.isSelection(r)?s.Selection.from(r):s.Range.from(r)),p.$2Q.String.with("kind","Code action kind to return code actions for").optional(),p.$2Q.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new p.$3Q("A promise that resolves to an array of Command-instances.",(r,l,d)=>E(a=>{if(a._isSynthetic){if(!a.command)throw new Error("Synthetic code actions must have a command");return d.fromInternal(a.command)}else{const i=new I.$pO(a.title,a.kind?new I.$qO(a.kind):void 0);return a.edit&&(i.edit=s.WorkspaceEdit.to(a.edit)),a.command&&(i.command=d.fromInternal(a.command)),i.isPreferred=a.isPreferred,i}})(r))),new p.$4Q("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[p.$2Q.Uri],new p.$3Q("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(l=>new I.$JO(s.Range.to(l.range),s.Color.to(l.color))):[])),new p.$4Q("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new p.$2Q("color","The color to show and insert",r=>r instanceof I.$IO,s.Color.from),new p.$2Q("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:s.Range.from(r.range)}))],new p.$3Q("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(s.ColorPresentation.to):[])),new p.$4Q("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[p.$2Q.Uri,p.$2Q.Range],new p.$3Q("A promise that resolves to an array of Inlay objects",(r,l,d)=>r.map(s.InlayHint.to.bind(void 0,d)))),new p.$4Q("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[p.$2Q.Uri],new p.$3Q("A promise that resolves to an array of FoldingRange objects",(r,l)=>{if(r)return r.map(s.FoldingRange.to)})),new p.$4Q("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new p.$3Q("A promise that resolves to an array of NotebookContentProvider static info objects.",E(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(l=>s.NotebookExclusiveDocumentPattern.to(l))})))),new p.$4Q("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[p.$2Q.Uri,p.$2Q.Range,new p.$2Q("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof I.$7N,r=>s.InlineValueContext.from(r))],new p.$3Q("A promise that resolves to an array of InlineValue objects",r=>r.map(s.InlineValue.to))),new p.$4Q("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new p.$2Q("uriOrString","Uri-instance or string (only http/https)",r=>P.URI.isUri(r)||typeof r=="string"&&(0,D.$Sg)(r,D.Schemas.http,D.Schemas.https),r=>r),new p.$2Q("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[s.ViewColumn.from(r),void 0]:[s.ViewColumn.from(r.viewColumn),s.TextEditorOpenOptions.from(r)])).optional(),p.$2Q.String.with("label","").optional()],p.$3Q.Void),new p.$4Q("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[p.$2Q.Uri.with("resource","Resource to open"),p.$2Q.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new p.$2Q("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[s.ViewColumn.from(r),void 0]:[s.ViewColumn.from(r.viewColumn),s.TextEditorOpenOptions.from(r)])).optional()],p.$3Q.Void),new p.$4Q("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[p.$2Q.Uri.with("left","Left-hand side resource of the diff editor"),p.$2Q.Uri.with("right","Right-hand side resource of the diff editor"),p.$2Q.String.with("title","Human readable title for the diff editor").optional(),new p.$2Q("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[s.ViewColumn.from(r.viewColumn),s.TextEditorOpenOptions.from(r)]).optional()],p.$3Q.Void),new p.$4Q("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[p.$2Q.String.with("title","Human readable title for the changes editor"),new p.$2Q("resourceList","List of resources to compare",r=>{for(const l of r){if(l.length!==3)return!1;const[d,a,i]=l;if(!P.URI.isUri(d)||!P.URI.isUri(a)&&a!==void 0&&a!==null||!P.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},r=>r)],p.$3Q.Void),new p.$4Q("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[p.$2Q.Uri,p.$2Q.Position],new p.$3Q("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(s.TypeHierarchyItem.to))),new p.$4Q("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[p.$2Q.TypeHierarchyItem],new p.$3Q("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(s.TypeHierarchyItem.to))),new p.$4Q("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[p.$2Q.TypeHierarchyItem],new p.$3Q("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(s.TypeHierarchyItem.to))),new p.$4Q("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[p.$2Q.TestItem],p.$3Q.Void),new p.$4Q("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[p.$2Q.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],p.$3Q.Void),new p.$4Q("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[p.$2Q.String.with("name","The context key name"),new p.$2Q("value","The context key value",()=>!0,r=>r)],p.$3Q.Void),new p.$4Q("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[p.$2Q.Uri,p.$2Q.StringArray,new p.$2Q("MappedEditsContext","Mapped Edits Context",r=>s.MappedEditsContext.is(r),r=>s.MappedEditsContext.from(r))],new p.$3Q("A promise that resolves to a workspace edit or null",r=>r?s.WorkspaceEdit.to(r):null)),new p.$4Q("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new p.$2Q("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?s.Range.from(r.initialRange):void 0,initialSelection:I.$8N.isSelection(r.initialSelection)?s.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?s.Position.from(r.position):void 0}})],p.$3Q.Void)];class h{static register(l){b.forEach(l.registerApiCommand,l),this.a(l)}static a(l){l.registerCommand(!1,"_validateWhenClauses",O.$Hj)}}e.$Iqc=h;function E(r){return l=>{if(Array.isArray(l))return l.map(r)}}function f(r){if(!Array.isArray(r))return;const l=[];for(const d of r)N.$Ru(d)?l.push(s.DefinitionLink.to(d)):l.push(s.location.to(d));return l}}),define(Re[256],Te([1,0,2,34]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$csc=void 0;class P{constructor(R,O,p,s,I){this.a=O,this.b=p,this.c=s;const b=new D.$4Q("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new D.$2Q("showOptions","Show Options",h=>!0,h=>h),new D.$2Q("resource","Interactive resource Uri",h=>!0,h=>h),new D.$2Q("controllerId","Notebook controller Id",h=>!0,h=>h),new D.$2Q("title","Interactive editor title",h=>!0,h=>h)],new D.$3Q("Notebook and input URI",h=>{if(I.debug("[ExtHostInteractive] open iw with notebook editor id",h.notebookEditorId),h.notebookEditorId!==void 0){const E=this.a.getEditorById(h.notebookEditorId);return I.debug("[ExtHostInteractive] notebook editor found",E.id),{notebookUri:v.URI.revive(h.notebookUri),inputUri:v.URI.revive(h.inputUri),notebookEditor:E.apiEditor}}return I.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",h.notebookUri,h.inputUri),{notebookUri:v.URI.revive(h.notebookUri),inputUri:v.URI.revive(h.inputUri)}}));this.c.registerApiCommand(b)}$willAddInteractiveDocument(R,O,p,s){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:O,lines:[""],languageId:p,uri:R,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(R,O){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$csc=P}),define(Re[257],Te([1,0,17,10,19,6,4,27,2,18,11,5,34,8,7,83,196,21,39,197]),function(we,e,v,D,P,N,R,O,p,s,I,b,h,E,f,r,l,d,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ksc=void 0,e.$lsc=u,E=qe(E);let n=class{constructor(k,y,C,T,$){this.m=y,this.n=C,this.o=T,this.q=$,this.b=new O.$Dc,this.c=new O.$Dc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new N.$oe,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=k.getProxy(b.$3N.MainThreadNotebookKernels);const w=new h.$4Q("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new h.$2Q("options","Select kernel options",A=>!0,A=>{if(A&&"notebookEditor"in A&&"id"in A){const L=this.n.getIdByEditor(A.notebookEditor);return{id:A.id,extension:A.extension,notebookEditorId:L}}else if(A&&"notebookEditor"in A){const L=this.n.getIdByEditor(A.notebookEditor);if(L===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${A.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:L}}return A})],h.$3Q.Void),M=new h.$4Q("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[h.$2Q.Uri],new h.$3Q("A promise that resolves to an array of variables",(A,L)=>A.map(J=>({variable:{name:J.name,value:J.value,expression:J.expression,type:J.type,language:J.language},hasNamedChildren:J.hasNamedChildren,indexedChildrenCount:J.indexedChildrenCount}))));this.o.registerApiCommand(w),this.o.registerApiCommand(M)}createNotebookController(k,y,C,T,$,w){for(const x of this.j.values())if(x.controller.id===y&&s.$vn.equals(k.identifier,x.extensionId))throw new Error(`notebook controller with id '${y}' ALREADY exist`);const M=this.k++,A=this;this.q.trace(`NotebookController[${M}], CREATED by ${k.identifier.value}, ${y}`);const L=()=>console.warn(`NO execute handler from notebook controller '${Q.id}' of extension: '${k.identifier}'`);let J=!1;const Y=new N.$oe,z=new N.$oe,Q={id:u(k.identifier,y),notebookType:C,extensionId:k.identifier,extensionLocation:k.extensionLocation,label:T||k.identifier.value,preloads:w?w.map(E.NotebookRendererScript.from):[]};let V=$??L,ie,le;this.a.$addKernel(M,Q).catch(x=>{console.log(x),J=!0});let _=0;const oe=()=>{if(J)return;const x=++_;Promise.resolve().then(()=>{x===_&&this.a.$updateKernel(M,Q)})},re=new O.$Dc,ce={get id(){return y},get notebookType(){return Q.notebookType},onDidChangeSelectedNotebooks:Y.event,get label(){return Q.label},set label(x){Q.label=x??k.displayName??k.name,oe()},get detail(){return Q.detail??""},set detail(x){Q.detail=x,oe()},get description(){return Q.description??""},set description(x){Q.description=x,oe()},get supportedLanguages(){return Q.supportedLanguages},set supportedLanguages(x){Q.supportedLanguages=x,oe()},get supportsExecutionOrder(){return Q.supportsExecutionOrder??!1},set supportsExecutionOrder(x){Q.supportsExecutionOrder=x,oe()},get rendererScripts(){return Q.preloads?Q.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return V},set executeHandler(x){V=x??L},get interruptHandler(){return ie},set interruptHandler(x){ie=x,Q.supportsInterrupt=!!x,oe()},set variableProvider(x){(0,d.$wH)(k,"notebookVariableProvider"),le=x,Q.hasVariableProvider=!!x,x?.onDidChangeVariables($e=>A.a.$variablesUpdated($e.uri)),oe()},get variableProvider(){return le},createNotebookCellExecution(x){if(J)throw new Error("notebook controller is DISPOSED");if(!re.has(x.notebook.uri))throw A.q.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(re.keys()).map($e=>$e.toString())),new Error(`notebook controller is NOT associated to notebook: ${x.notebook.uri.toString()}`);return A._createNotebookCellExecution(x,u(k.identifier,this.id))},createNotebookExecution(x){if((0,d.$wH)(k,"notebookExecution"),J)throw new Error("notebook controller is DISPOSED");if(!re.has(x.uri))throw A.q.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(re.keys()).map($e=>$e.toString())),new Error(`notebook controller is NOT associated to notebook: ${x.uri.toString()}`);return A._createNotebookExecution(x,u(k.identifier,this.id))},dispose:()=>{J||(this.q.trace(`NotebookController[${M}], DISPOSED`),J=!0,this.j.delete(M),Y.dispose(),z.dispose(),this.a.$removeKernel(M))},updateNotebookAffinity(x,$e){$e===f.NotebookControllerAffinity2.Hidden&&(0,d.$wH)(k,"notebookControllerAffinityHidden"),A.a.$updateNotebookPriority(M,x.uri,$e)},onDidReceiveMessage:z.event,postMessage(x,$e){return(0,d.$wH)(k,"notebookMessaging"),A.a.$postMessage(M,$e&&A.n.getIdByEditor($e),x)},asWebviewUri(x){return(0,d.$wH)(k,"notebookMessaging"),(0,r.$_Db)(x,A.m.remote)}};return this.j.set(M,{extensionId:k.identifier,controller:ce,onDidReceiveMessage:z,onDidChangeSelection:Y,associatedNotebooks:re}),ce}getIdByController(k){for(const[y,C]of this.j)if(C.controller===k)return u(C.extensionId,k.id);return null}createNotebookControllerDetectionTask(k,y){const C=this.g++,T=this;this.q.trace(`NotebookControllerDetectionTask[${C}], CREATED by ${k.identifier.value}`),this.a.$addKernelDetectionTask(C,y);const $={dispose:()=>{this.f.delete(C),T.a.$removeKernelDetectionTask(C)}};return this.f.set(C,$),$}registerKernelSourceActionProvider(k,y,C){const T=this.i++,$=typeof C.onDidChangeNotebookKernelSourceActions=="function"?T:void 0,w=this;this.h.set(T,C),this.q.trace(`NotebookKernelSourceActionProvider[${T}], CREATED by ${k.identifier.value}`),this.a.$addKernelSourceActionProvider(T,T,y);let M;return $!==void 0&&(M=C.onDidChangeNotebookKernelSourceActions(A=>this.a.$emitNotebookKernelSourceActionsChangeEvent($))),{dispose:()=>{this.h.delete(T),w.a.$removeKernelSourceActionProvider(T,T),M?.dispose()}}}async $provideKernelSourceActions(k,y){const C=this.h.get(k);if(C){const T=new R.$Wc;return(await C.provideNotebookKernelSourceActions(y)??[]).map(w=>E.NotebookKernelSourceAction.from(w,this.o.converter,T))}return[]}$acceptNotebookAssociation(k,y,C){const T=this.j.get(k);if(T){const $=this.n.getNotebookDocument(p.URI.revive(y));C?T.associatedNotebooks.set($.uri,!0):T.associatedNotebooks.delete($.uri),this.q.trace(`NotebookController[${k}] ASSOCIATE notebook`,$.uri.toString(),C),T.onDidChangeSelection.fire({selected:C,notebook:$.apiNotebook})}}async $executeCells(k,y,C){const T=this.j.get(k);if(!T)return;const $=this.n.getNotebookDocument(p.URI.revive(y)),w=[];for(const M of C){const A=$.getCell(M);A&&w.push(A.apiCell)}try{this.q.trace(`NotebookController[${k}] EXECUTE cells`,$.uri.toString(),w.length),await T.controller.executeHandler.call(T.controller,w,$.apiNotebook,T.controller)}catch(M){this.q.error(`NotebookController[${k}] execute cells FAILED`,M),console.error(M)}}async $cancelCells(k,y,C){const T=this.j.get(k);if(!T)return;const $=this.n.getNotebookDocument(p.URI.revive(y));if(T.controller.interruptHandler)await T.controller.interruptHandler.call(T.controller,$.apiNotebook);else for(const w of C){const M=$.getCell(w);M&&this.b.get(M.uri)?.cancel()}if(T.controller.interruptHandler){const w=this.c.get($.uri);this.c.delete($.uri),C.length&&Array.isArray(w)&&w.length&&w.forEach(M=>M.dispose())}}async $provideVariables(k,y,C,T,$,w,M){const A=this.j.get(k);if(!A)return;const L=this.n.getNotebookDocument(p.URI.revive(C)),J=A.controller.variableProvider;if(!J)return;let Y;if(T!==void 0){if(Y=this.s[T],!Y)return}else this.s={};const z=$==="named"?f.NotebookVariablesRequestKind.Named:f.NotebookVariablesRequestKind.Indexed,Q=J.provideVariables(L.apiNotebook,Y,z,w,M);let V=0;for await(const ie of Q){if(M.isCancellationRequested)return;const le={id:this.r++,name:ie.variable.name,value:ie.variable.value,type:ie.variable.type,interfaces:ie.variable.interfaces,language:ie.variable.language,expression:ie.variable.expression,hasNamedChildren:ie.hasNamedChildren,indexedChildrenCount:ie.indexedChildrenCount,extensionId:A.extensionId.value};if(this.s[le.id]=ie.variable,this.a.$receiveVariable(y,le),V++>=i.$fL)return}}$acceptKernelMessageFromRenderer(k,y,C){const T=this.j.get(k);if(!T)return;const $=this.n.getEditorById(y);T.onDidReceiveMessage.fire(Object.freeze({editor:$.apiEditor,message:C}))}$cellExecutionChanged(k,y,C){const $=this.n.getNotebookDocument(p.URI.revive(k)).getCell(y);if($){const w=C?E.NotebookCellExecutionState.to(C):f.NotebookCellExecutionState.Idle;w!==void 0&&this.l.fire({cell:$.apiCell,state:w})}}_createNotebookCellExecution(k,y){if(k.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const T=this.n.getNotebookDocument(k.notebook.uri).getCellFromApiCell(k);if(!T)throw new Error("invalid cell");if(this.b.has(T.uri))throw new Error(`duplicate execution for ${T.uri}`);const $=new o(y,T,this.a);this.b.set(T.uri,$);const w=$.onDidChangeState(()=>{$.state===t.Resolved&&($.dispose(),w.dispose(),this.b.delete(T.uri))});return $.asApiObject()}_createNotebookExecution(k,y){const C=this.n.getNotebookDocument(k.uri),T=k.getCells().find(M=>{const A=C.getCellFromApiCell(M);return A&&this.b.has(A.uri)});if(T)throw new Error(`duplicate cell execution for ${T.document.uri}`);if(this.c.has(C.uri))throw new Error(`duplicate notebook execution for ${C.uri}`);const $=new m(y,C,this.a),w=$.onDidChangeState(()=>{$.state===c.Resolved&&($.dispose(),w.dispose(),this.c.delete(C.uri))});return this.c.set(C.uri,[$,w]),$.asApiObject()}};e.$ksc=n,e.$ksc=n=Ke([We(4,I.$dk)],n);var t;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(t||(t={}));class o extends R.$Xc{static{this.a=0}get state(){return this.f}constructor(k,y,C){super(),this.m=y,this.n=C,this.b=o.a++,this.c=new N.$oe,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new P.$ze),this.h=new g(10,T=>this.s(T)),this.j=y.internalMetadata.executionOrder,this.n.$createExecution(this.b,k,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(k){await this.h.addItem(k)}async s(k){const y=Array.isArray(k)?k:[k];return this.n.$updateExecution(this.b,new a.$5w(y))}t(){if(this.f===t.Init)throw new Error("Must call start before modifying cell output");if(this.f===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(k){let y=this.m;if(k&&(y=this.m.notebook.getCellFromApiCell(k)),!y)throw new Error("INVALID cell");return y.handle}y(k){return k.map(y=>{const C=f.$AP.ensureUniqueMimeTypes(y.items,!0);return C===y.items?E.NotebookCellOutput.from(y):E.NotebookCellOutput.from({items:C,id:y.id,metadata:y.metadata})})}async z(k,y,C){const T=this.w(y),$=this.y((0,v.$4b)(k));return this.r({editType:l.CellExecutionUpdateType.Output,cellHandle:T,append:C,outputs:$})}async C(k,y,C){return k=f.$AP.ensureUniqueMimeTypes((0,v.$4b)(k),!0),this.r({editType:l.CellExecutionUpdateType.OutputItems,items:k.map(E.NotebookCellOutputItem.from),outputId:y.id,append:C})}asApiObject(){const k=this;return Object.freeze({get token(){return k.g.token},get cell(){return k.m.apiCell},get executionOrder(){return k.j},set executionOrder(C){k.j=C,k.s([{editType:l.CellExecutionUpdateType.ExecutionState,executionOrder:k.j}])},start(C){if(k.f===t.Resolved||k.f===t.Started)throw new Error("Cannot call start again");k.f=t.Started,k.c.fire(),k.s({editType:l.CellExecutionUpdateType.ExecutionState,runStartTime:C})},end(C,T,$){if(k.f===t.Resolved)throw new Error("Cannot call resolve twice");k.f=t.Resolved,k.c.fire(),k.h.flush();const w=$?{message:$.message,stack:$.stack,location:$?.location?{startLineNumber:$.location.start.line,startColumn:$.location.start.character,endLineNumber:$.location.end.line,endColumn:$.location.end.character}:void 0,uri:$.uri}:void 0;k.n.$completeExecution(k.b,new a.$5w({runEndTime:T,lastRunSuccess:C,error:w}))},clearOutput(C){return k.t(),k.z([],C,!1)},appendOutput(C,T){return k.t(),k.z(C,T,!0)},replaceOutput(C,T){return k.t(),k.z(C,T,!1)},appendOutputItems(C,T){return k.t(),k.C(C,T,!0)},replaceOutputItems(C,T){return k.t(),k.C(C,T,!1)}})}}var c;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(c||(c={}));class m extends R.$Xc{static{this.a=0}get state(){return this.f}constructor(k,y,C){super(),this.h=y,this.j=C,this.b=m.a++,this.c=new N.$oe,this.onDidChangeState=this.c.event,this.f=c.Init,this.g=this.B(new P.$ze),this.j.$createNotebookExecution(this.b,k,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===c.Resolved||this.f===c.Started)throw new Error("Cannot call start again");this.f=c.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===c.Resolved)throw new Error("Cannot call resolve twice");this.f=c.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class g{constructor(k,y){this.f=k,this.g=y,this.a=[],this.b=Date.now()}addItem(k){return this.a.push(k),this.c||(this.c=new D.$6h,this.b=Date.now(),(0,D.$Jh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const k=this.c;this.c=void 0;const y=this.a;return this.a=[],this.g(y).finally(()=>k.complete())}}function u(S,k){return`${S.value}/${k}`}}),define(Re[56],Te([1,0,6,5,3,2,16,4,7,9,12,179,19,38,180,181,35,10,8,34,37]),function(we,e,v,D,P,N,R,O,p,s,I,b,h,E,f,r,l,d,a,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nrc=e.$mrc=e.$lrc=e.$krc=void 0,e.$krc=(0,P.$Ii)("IExtHostTerminalService");class t extends O.$Xc{constructor($,w,M,A){super(),this.u=$,this._id=w,this.w=M,this.y=A,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new v.$oe),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(J=>this.g=J);const L=this;this.value={get name(){return L.y||""},get processId(){return L.b},get creationOptions(){return L.w},get exitStatus(){return L.j},get state(){return L.m},get selection(){return L.n},get shellIntegration(){return L.shellIntegration},sendText(J,Y=!0){L.C(),L.u.$sendText(L._id,J,Y)},show(J){L.C(),L.u.$show(L._id,J)},hide(){L.C(),L.u.$hide(L._id)},dispose(){L.a||(L.a=!0,L.u.$dispose(L._id))},get dimensions(){if(!(L.f===void 0||L.h===void 0))return{columns:L.f,rows:L.h}}}}dispose(){this.s.fire(),super.dispose()}async create($,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:$.name,shellPath:$.shellPath??void 0,shellArgs:$.shellArgs??void 0,cwd:$.cwd??w?.cwd??void 0,env:$.env??void 0,icon:k($.iconPath)??void 0,color:l.ThemeColor.isThemeColor($.color)?$.color.id:void 0,initialText:$.message??void 0,strictEnv:$.strictEnv??void 0,hideFromUser:$.hideFromUser??void 0,forceShellIntegration:w?.forceShellIntegration??void 0,isFeatureTerminal:w?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:w?.useShellEnvironment??void 0,location:w?.location||this.z($.location,w?.resolvedExtHostIdentifier),isTransient:$.isTransient??void 0})}async createExtensionTerminal($,w,M,A,L){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:A,color:l.ThemeColor.isThemeColor(L)?L.id:void 0,location:w?.location||this.z($,M),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z($,w){return typeof $=="object"?"parentTerminal"in $&&$.parentTerminal&&w?{parentTerminal:w}:"viewColumn"in $?{viewColumn:a.ViewColumn.from($.viewColumn),preserveFocus:$.preserveFocus}:void 0:$}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name($){this.y=$}setExitStatus($,w){this.j=Object.freeze({code:$,reason:w})}setDimensions($,w){return $===this.f&&w===this.h||$===0||w===0?!1:(this.f=$,this.h=w,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection($){this.n=$}_setProcessId($){this.g?(this.g($),this.g=void 0):this.b.then(w=>{w!==$&&(this.b=Promise.resolve($))})}}e.$lrc=t;class o{get onProcessReady(){return this.b.event}constructor($){this.g=$,this.id=0,this.shouldPersist=!1,this.a=new v.$oe,this.onProcessData=this.a.event,this.b=new v.$oe,this.d=new v.$oe,this.onDidChangeProperty=this.d.event,this.f=new v.$oe,this.onProcessExit=this.f.event}refreshProperty($){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${$}`)}updateProperty($,w){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${$}, value: ${w}`)}async start(){}shutdown(){this.g.close()}input($){this.g.handleInput?.($)}resize($,w){this.g.setDimensions?.({columns:$,rows:w})}clearBuffer(){}async processBinary($){}acknowledgeDataEvent($){}async setUnicodeVersion($){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents($){this.g.onDidWrite(w=>this.a.fire(w)),this.g.onDidClose?.((w=void 0)=>{this.f.fire(w===void 0?void 0:w)}),this.g.onDidOverrideDimensions?.(w=>{w&&this.d.fire({type:f.ProcessPropertyType.OverrideDimensions,value:{cols:w.columns,rows:w.rows}})}),this.g.onDidChangeName?.(w=>{this.d.fire({type:f.ProcessPropertyType.Title,value:w})}),this.g.open($||void 0),$&&this.g.setDimensions?.($),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let c=1,m=class extends O.$Xc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map($=>$.value)}constructor($,w,M){super(),this.Q=w,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new O.$Yc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new v.$oe,this.onDidCloseTerminal=this.H.event,this.I=new v.$oe,this.onDidOpenTerminal=this.I.event,this.J=new v.$oe,this.onDidChangeActiveTerminal=this.J.event,this.L=new v.$oe,this.onDidChangeTerminalDimensions=this.L.event,this.M=new v.$oe,this.onDidChangeTerminalState=this.M.event,this.N=new v.$oe,this.onDidChangeShell=this.N.event,this.O=new v.$oe({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new v.$oe({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=M.getProxy(D.$3N.MainThreadTerminalService),this.y=new r.$ryb(this.a.$sendProcessData),this.a.$registerProcessSupport($),this.Q.registerArgumentProcessor({processArgument:A=>{const L=J=>{const Y=J;return this.getTerminalById(Y.instanceId)?.value};switch(A?.$mid){case n.MarshalledId.TerminalContext:return L(A);default:{if(Array.isArray(A))for(let J=0;J<A.length&&A[J].$mid===n.MarshalledId.TerminalContext;J++)A[J]=L(A[J]);return A}}}}),this.B({dispose:()=>{for(const[A,L]of this.g)L.shutdown(!0)}})}getDefaultShell($){return($?this.u:this.s)?.path||""}getDefaultShellArgs($){return($?this.u:this.s)?.args||[]}createExtensionTerminal($,w){const M=new t(this.a,(0,E.$5g)(),$,$.name),A=new o($.pty);return M.createExtensionTerminal($.location,w,this.R($,w).resolvedExtHostIdentifier,k($.iconPath),y($.color)).then(L=>{const J=this.S(L,A);this.h[L]=J}),this.f.push(M),M.value}R($,w){if(w=w||{},$.location&&typeof $.location=="object"&&"parentTerminal"in $.location){const M=$.location.parentTerminal;if(M){const A=this.f.find(L=>L.value===M);A&&(w.resolvedExtHostIdentifier=A._id)}}else $.location&&typeof $.location!="object"?w.location=$.location:w.location&&typeof w.location=="object"&&"splitActiveTerminal"in w.location&&(w.location={splitActiveTerminal:!0});return w}attachPtyToTerminal($,w){if(!this.getTerminalById($))throw new Error(`Cannot resolve terminal with id ${$} for virtual process`);const A=new o(w),L=this.S($,A);this.h[$]=L}async $acceptActiveTerminalChanged($){const w=this.b;if($===null){this.b=void 0,w!==this.b&&this.J.fire(this.b);return}const M=this.getTerminalById($);M&&(this.b=M,w!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData($,w){const M=this.getTerminalById($);M&&this.O.fire({terminal:M.value,data:w})}async $acceptTerminalDimensions($,w,M){const A=this.getTerminalById($);A&&A.setDimensions(w,M)&&this.L.fire({terminal:A.value,dimensions:A.value.dimensions})}async $acceptDidExecuteCommand($,w){const M=this.getTerminalById($);M&&this.P.fire({terminal:M.value,...w})}async $acceptTerminalMaximumDimensions($,w,M){this.g.get($)?.resize(w,M)}async $acceptTerminalTitleChange($,w){const M=this.getTerminalById($);M&&(M.name=w)}async $acceptTerminalClosed($,w,M){const A=this.X(this.f,$);if(A!==null){const L=this.f.splice(A,1)[0];L.setExitStatus(w,M),this.H.fire(L.value)}}$acceptTerminalOpened($,w,M,A){if(w){const Y=this.X(this.f,w);if(Y!==null){this.f[Y]._id=$,this.I.fire(this.terminals[Y]),this.f[Y].isOpen=!0;return}}const L={name:A.name,shellPath:A.executable,shellArgs:A.args,cwd:typeof A.cwd=="string"?A.cwd:N.URI.revive(A.cwd),env:A.env,hideFromUser:A.hideFromUser},J=new t(this.a,$,L,M);this.f.push(J),this.I.fire(J.value),J.isOpen=!0}async $acceptTerminalProcessId($,w){this.getTerminalById($)?._setProcessId(w)}async $startExtensionTerminal($,w){const M=this.getTerminalById($);if(!M)return{message:(0,s.localize)(2714,null,$)};M.isOpen||await new Promise(L=>{const J=this.onDidOpenTerminal(async Y=>{Y===M.value&&(J.dispose(),L())})});const A=this.g.get($);A?A.startSendingEvents(w):this.j[$]={initialDimensions:w}}S($,w){const M=new O.$Wc;M.add(w.onProcessReady(L=>this.a.$sendProcessReady($,L.pid,L.cwd,L.windowsPty))),M.add(w.onDidChangeProperty(L=>this.a.$sendProcessProperty($,L))),this.y.startBuffering($,w.onProcessData),M.add(w.onProcessExit(L=>this.U($,L))),this.g.set($,w);const A=this.j[$];return A&&w instanceof o&&(w.startSendingEvents(A.initialDimensions),delete this.j[$]),M}$acceptProcessAckDataEvent($,w){this.g.get($)?.acknowledgeDataEvent(w)}$acceptProcessInput($,w){this.g.get($)?.input(w)}$acceptTerminalInteraction($){const w=this.getTerminalById($);w?.setInteractedWith()&&this.M.fire(w.value)}$acceptTerminalSelection($,w){this.getTerminalById($)?.setSelection(w)}$acceptProcessResize($,w,M){try{this.g.get($)?.resize(w,M)}catch(A){if(A.code!=="EPIPE"&&A.code!=="ERR_IPC_CHANNEL_CLOSED")throw A}}$acceptProcessShutdown($,w){this.g.get($)?.shutdown(w)}$acceptProcessRequestInitialCwd($){this.g.get($)?.getInitialCwd().then(w=>this.a.$sendProcessProperty($,{type:f.ProcessPropertyType.InitialCwd,value:w}))}$acceptProcessRequestCwd($){this.g.get($)?.getCwd().then(w=>this.a.$sendProcessProperty($,{type:f.ProcessPropertyType.Cwd,value:w}))}$acceptProcessRequestLatency($){return Promise.resolve($)}registerLinkProvider($){return this.z.add($),this.z.size===1&&this.a.$startLinkProvider(),new p.$5N(()=>{this.z.delete($),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider($,w,M){if(this.C.has(w))throw new Error(`Terminal profile provider "${w}" already registered`);return this.C.set(w,M),this.a.$registerProfileProvider(w,$.identifier.value),new p.$5N(()=>{this.C.delete(w),this.a.$unregisterProfileProvider(w)})}registerTerminalQuickFixProvider($,w,M){if(this.D.has($))throw new Error(`Terminal quick fix provider "${$}" is already registered`);return this.D.set($,M),this.a.$registerQuickFixProvider($,w),new p.$5N(()=>{this.D.delete($),this.a.$unregisterQuickFixProvider($)})}async $provideTerminalQuickFixes($,w){const M=new h.$ze().token;if(M.isCancellationRequested)return;const A=this.D.get($);if(!A)return;const L=await A.provideTerminalQuickFixes(w,M);if(L===null||Array.isArray(L)&&L.length===0)return;const J=new O.$Wc;if(this.w.value=J,!Array.isArray(L))return L?a.TerminalQuickFix.from(L,this.Q.converter,J):void 0;const Y=[];for(const z of L){const Q=a.TerminalQuickFix.from(z,this.Q.converter,J);Q&&Y.push(Q)}return Y}async $createContributedProfileTerminal($,w){const M=new h.$ze().token;let A=await this.C.get($)?.provideTerminalProfile(M);if(!M.isCancellationRequested){if(A&&!("options"in A)&&(A={options:A}),!A||!("options"in A))throw new Error(`No terminal profile options provided for id "${$}"`);if("pty"in A.options){this.createExtensionTerminal(A.options,w);return}this.createTerminalFromOptions(A.options,w)}}async $provideLinks($,w){const M=this.getTerminalById($);if(!M)return[];this.F.delete($),this.G.get($)?.dispose(!0);const L=new h.$ze;this.G.set($,L);const J=[],Y={terminal:M.value,line:w},z=[];for(const ie of this.z)z.push(d.Promises.withAsyncBody(async le=>{L.token.onCancellationRequested(()=>le({provider:ie,links:[]}));const _=await ie.provideTerminalLinks(Y,L.token)||[];L.token.isCancellationRequested||le({provider:ie,links:_})}));const Q=await Promise.all(z);if(L.token.isCancellationRequested)return[];const V=new Map;for(const ie of Q)ie&&ie.links.length>0&&J.push(...ie.links.map(le=>{const _={id:c++,startIndex:le.startIndex,length:le.length,label:le.tooltip};return V.set(_.id,{provider:ie.provider,link:le}),_}));return this.F.set($,V),J}$activateLink($,w){const M=this.F.get($)?.get(w);M&&M.provider.handleTerminalLink(M.link)}U($,w){this.y.stopBuffering($),this.g.delete($),delete this.j[$];const M=this.h[$];M&&(M.dispose(),delete this.h[$]),this.a.$sendProcessExit($,w)}getTerminalById($){return this.W(this.f,$)}getTerminalIdByApiObject($){const w=this.f.findIndex(M=>M.value===$);return w>=0?w:null}W($,w){const M=this.X($,w);return M!==null?$[M]:null}X($,w){const M=$.findIndex(A=>A._id===w);return M>=0?M:null}getEnvironmentVariableCollection($){let w=this.n.get($.identifier.value);return w||(w=this.B(new g),this.Z($.identifier.value,w)),w.getScopedEnvironmentVariableCollection(void 0)}Y($,w){const M=(0,b.$Ls)(w.map),A=(0,b.$Ms)(w.descriptionMap);this.a.$setEnvironmentVariableCollection($,w.persistent,M.length===0?void 0:M,A)}$initEnvironmentVariableCollections($){$.forEach(w=>{const M=w[0],A=this.B(new g(w[1]));this.Z(M,A)})}$acceptDefaultProfile($,w){const M=this.s;this.s=$,this.u=w,M?.path!==$.path&&this.N.fire($.path)}Z($,w){this.n.set($,w),this.B(w.onDidChangeCollection(()=>{this.Y($,w)}))}};e.$mrc=m,e.$mrc=m=Ke([We(1,i.$ZQ),We(2,R.$DQ)],m);class g extends O.$Xc{get persistent(){return this.b}set persistent($){this.b=$,this.f.fire()}get onDidChangeCollection(){return this.f&&this.f.event}constructor($){super(),this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.f=new v.$oe,this.map=new Map($)}getScopedEnvironmentVariableCollection($){const w=this.j($);let M=this.a.get(w);return M||(M=new u(this,$),this.a.set(w,M),this.B(M.onDidChangeCollection(()=>this.f.fire()))),M}replace($,w,M,A){this.g($,{value:w,type:p.EnvironmentVariableMutatorType.Replace,options:M??{applyAtProcessCreation:!0},scope:A})}append($,w,M,A){this.g($,{value:w,type:p.EnvironmentVariableMutatorType.Append,options:M??{applyAtProcessCreation:!0},scope:A})}prepend($,w,M,A){this.g($,{value:w,type:p.EnvironmentVariableMutatorType.Prepend,options:M??{applyAtProcessCreation:!0},scope:A})}g($,w){if(w.options&&w.options.applyAtProcessCreation===!1&&!w.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const M=this.h($,w.scope),A=this.map.get(M),L=w.options?{applyAtProcessCreation:w.options.applyAtProcessCreation??!1,applyAtShellIntegration:w.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!A||A.value!==w.value||A.type!==w.type||A.options?.applyAtProcessCreation!==L.applyAtProcessCreation||A.options?.applyAtShellIntegration!==L.applyAtShellIntegration||A.scope?.workspaceFolder?.index!==w.scope?.workspaceFolder?.index){const J=this.h($,w.scope),Y={variable:$,...w,options:L};this.map.set(J,Y),this.f.fire()}}get($,w){const M=this.h($,w),A=this.map.get(M);return A?C(A):void 0}h($,w){const M=this.j(w);return M.length?`${$}:::${M}`:$}j($){return this.m($?.workspaceFolder)??""}m($){return $?$.uri.toString():void 0}getVariableMap($){const w=new Map;for(const[M,A]of this.map)this.j(A.scope)===this.j($)&&w.set(A.variable,C(A));return w}delete($,w){const M=this.h($,w);this.map.delete(M),this.f.fire()}clear($){if($?.workspaceFolder){for(const[w,M]of this.map)M.scope?.workspaceFolder?.index===$.workspaceFolder.index&&this.map.delete(w);this.n($)}else this.map.clear(),this.descriptionMap.clear();this.f.fire()}setDescription($,w){const M=this.j(w),A=this.descriptionMap.get(M);if(!A||A.description!==$){let L;typeof $=="string"?L=$:L=$?.value.split(`

`)[0];const J={description:L,scope:w};this.descriptionMap.set(M,J),this.f.fire()}}getDescription($){const w=this.j($);return this.descriptionMap.get(w)?.description}n($){const w=this.j($);this.descriptionMap.delete(w)}}class u{get persistent(){return this.b.persistent}set persistent($){this.b.persistent=$}get onDidChangeCollection(){return this.a&&this.a.event}constructor($,w){this.b=$,this.d=w,this.a=new v.$oe}getScoped($){return this.b.getScopedEnvironmentVariableCollection($)}replace($,w,M){this.b.replace($,w,M,this.d)}append($,w,M){this.b.append($,w,M,this.d)}prepend($,w,M){this.b.prepend($,w,M,this.d)}get($){return this.b.get($,this.d)}forEach($,w){this.b.getVariableMap(this.d).forEach((M,A)=>$.call(w,A,M,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete($){this.b.delete($,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description($){this.b.setDescription($,this.d)}get description(){return this.b.getDescription(this.d)}}let S=class extends m{constructor($,w){super(!1,$,w)}createTerminal($,w,M){throw new I.$bb}createTerminalFromOptions($,w){throw new I.$bb}};e.$nrc=S,e.$nrc=S=Ke([We(0,i.$ZQ),We(1,R.$DQ)],S);function k(T){if(!(!T||typeof T=="string"))return"id"in T?{id:T.id,color:T.color}:T}function y(T){return l.ThemeColor.isThemeColor(T)?T:void 0}function C(T){const $={...T};return delete $.scope,$.options=$.options??void 0,delete $.variable,$}}),define(Re[128],Te([1,0,7,4,3,5,16,56,6,2,10]),function(we,e,v,D,P,N,R,O,p,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dsc=e.$Csc=void 0,e.$Csc=(0,P.$Ii)("IExtHostTerminalShellIntegration");let b=class extends D.$Xc{constructor(l,d){super(),this.h=d,this.b=new Map,this.c=new p.$oe,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new p.$oe,this.onDidStartTerminalShellExecution=this.f.event,this.g=new p.$oe,this.onDidEndTerminalShellExecution=this.g.event,this.a=l.getProxy(N.$3N.MainThreadTerminalShellIntegration),this.B((0,D.$Vc)(()=>{for(const[a,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(l){const d=this.h.getTerminalById(l);if(!d)return;const a=d.value;let i=this.b.get(l);i||(i=new h(d.value,this.f),this.b.set(l,i),i.store.add(d.onWillDispose(()=>this.b.get(l)?.dispose())),i.store.add(i.onDidRequestShellExecution(n=>this.a.$executeCommand(l,n))),i.store.add(i.onDidRequestEndExecution(n=>this.g.fire(n))),i.store.add(i.onDidRequestChangeShellIntegration(n=>this.c.fire(n))),d.shellIntegration=i.value),this.c.fire({terminal:a,shellIntegration:i.value})}$shellExecutionStart(l,d,a,i,n){this.b.has(l)||this.$shellIntegrationChange(l);const t={value:d,confidence:a,isTrusted:i};this.b.get(l)?.startShellExecution(t,s.URI.revive(n))}$shellExecutionEnd(l,d,a,i,n){const t={value:d,confidence:a,isTrusted:i};this.b.get(l)?.endShellExecution(t,n)}$shellExecutionData(l,d){this.b.get(l)?.emitData(d)}$cwdChange(l,d){this.b.get(l)?.setCwd(s.URI.revive(d))}$closeTerminal(l){this.b.get(l)?.dispose(),this.b.delete(l)}};e.$Dsc=b,e.$Dsc=b=Ke([We(0,R.$DQ),We(1,O.$krc)],b);class h extends D.$Xc{get currentExecution(){return this.a}constructor(l,d){super(),this.j=l,this.m=d,this.b=!1,this.store=this.B(new D.$Wc),this.f=this.B(new p.$oe),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new p.$oe),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new p.$oe),this.onDidRequestEndExecution=this.h.event;const a=this;this.value={get cwd(){return a.c},executeCommand(i,n){let t=i;n&&(t+=` "${n.map(m=>`${m.replaceAll('"','\\"')}`).join('" "')}"`),a.g.fire(t);const o={value:t,confidence:v.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},c=a.startShellExecution(o,a.c,!0).value;return a.b=!0,c}}}startShellExecution(l,d,a){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new E(l,d??this.c);a?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(l){this.currentExecution?.emitData(l)}endShellExecution(l,d){this.a&&(this.a.endExecution(l),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:d}),this.a=void 0)}setCwd(l){let d=!1;s.URI.isUri(this.c)?d=!s.URI.isUri(l)||this.c.toString()!==l.toString():this.c!==l&&(d=!0),d&&(this.c=l,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class E{constructor(l,d){this.c=l,this.cwd=d,this.b=!1;const a=this;this.value={get commandLine(){return a.c},get cwd(){return a.cwd},read(){return a.d()}}}d(){if(!this.a){if(this.b)return I.$9h.EMPTY;this.a=new f}return this.a.createIterable()}emitData(l){this.a?.emitData(l)}endExecution(l){l&&(this.c=l),this.a?.endExecution(),this.a=void 0,this.b=!0}}class f extends D.$Xc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new I.$Hh);const l=this.a;return new I.$9h(async a=>{this.b.push(a),await l.wait()})}emitData(l){for(const d of this.b)d.emitOne(l)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Re[129],Te([1,0,61,12,97,8,7]),function(we,e,v,D,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MQ=e.$LQ=e.$KQ=void 0,N=qe(N);class O{static{this.c=new P.$IQ("TextEditorDecorationType")}constructor(h,E,f){const r=O.c.nextId();h.$registerTextEditorDecorationType(E.identifier,r,N.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:r,dispose(){h.$removeTextEditorDecorationType(r)}})}}e.$KQ=O;class p{constructor(h,E){this.g=[],this.h=void 0,this.j=!1,this.c=h,this.d=h.version,this.e=E.undoStopBefore,this.f=E.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(h,E){this.k();let f=null;if(h instanceof R.$6N)f=new R.$7N(h,h);else if(h instanceof R.$7N)f=h;else throw new Error("Unrecognized location");this.l(f,E,!1)}insert(h,E){this.k(),this.l(new R.$7N(h,h),E,!0)}delete(h){this.k();let E=null;if(h instanceof R.$7N)E=h;else throw new Error("Unrecognized location");this.l(E,null,!0)}l(h,E,f){const r=this.c.validateRange(h);this.g.push({range:r,text:E,forceMoveMarkers:f})}setEndOfLine(h){if(this.k(),h!==R.EndOfLine.LF&&h!==R.EndOfLine.CRLF)throw(0,D.$9)("endOfLine");this.h=h}}class s{constructor(h,E,f,r){this.c=h,this.d=E,this._accept(f),this.e=r;const l=this;this.value={get tabSize(){return l.f},set tabSize(d){l.n(d)},get indentSize(){return l.g},set indentSize(d){l.p(d)},get insertSpaces(){return l.j},set insertSpaces(d){l.s(d)},get cursorStyle(){return l.k},set cursorStyle(d){l.t(d)},get lineNumbers(){return l.l},set lineNumbers(d){l.u(d)}}}_accept(h){this.f=h.tabSize,this.g=h.indentSize,this.h=h.originalIndentSize,this.j=h.insertSpaces,this.k=h.cursorStyle,this.l=N.TextEditorLineNumbersStyle.to(h.lineNumbers)}m(h){if(h==="auto")return"auto";if(typeof h=="number"){const E=Math.floor(h);return E>0?E:null}if(typeof h=="string"){const E=parseInt(h,10);return isNaN(E)?null:E>0?E:null}return null}n(h){const E=this.m(h);if(E!==null){if(typeof E=="number"){if(this.f===E)return;this.f=E}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:E}))}}o(h){if(h==="tabSize")return"tabSize";if(typeof h=="number"){const E=Math.floor(h);return E>0?E:null}if(typeof h=="string"){const E=parseInt(h,10);return isNaN(E)?null:E>0?E:null}return null}p(h){const E=this.o(h);if(E!==null){if(typeof E=="number"){if(this.h===E)return;this.g=E,this.h=E}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:E}))}}q(h){return h==="auto"?"auto":h==="false"?!1:!!h}s(h){const E=this.q(h);if(typeof E=="boolean"){if(this.j===E)return;this.j=E}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:E}))}t(h){this.k!==h&&(this.k=h,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:h})))}u(h){this.l!==h&&(this.l=h,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:N.TextEditorLineNumbersStyle.from(h)})))}assign(h){const E={};let f=!1;if(typeof h.tabSize<"u"){const r=this.m(h.tabSize);r==="auto"?(f=!0,E.tabSize=r):typeof r=="number"&&this.f!==r&&(this.f=r,f=!0,E.tabSize=r)}if(typeof h.indentSize<"u"){const r=this.o(h.indentSize);r==="tabSize"?(f=!0,E.indentSize=r):typeof r=="number"&&this.h!==r&&(this.g=r,this.h=r,f=!0,E.indentSize=r)}if(typeof h.insertSpaces<"u"){const r=this.q(h.insertSpaces);r==="auto"?(f=!0,E.insertSpaces=r):this.j!==r&&(this.j=r,f=!0,E.insertSpaces=r)}typeof h.cursorStyle<"u"&&this.k!==h.cursorStyle&&(this.k=h.cursorStyle,f=!0,E.cursorStyle=h.cursorStyle),typeof h.lineNumbers<"u"&&this.l!==h.lineNumbers&&(this.l=h.lineNumbers,f=!0,E.lineNumbers=N.TextEditorLineNumbersStyle.from(h.lineNumbers)),f&&this.v("setOptions",this.c.$trySetOptions(this.d,E))}v(h,E){E.catch(f=>{this.e.warn(`ExtHostTextEditorOptions '${h}' failed:'`),this.e.warn(f)})}}e.$LQ=s;class I{constructor(h,E,f,r,l,d,a,i){this.id=h,this.j=E,this.k=f,this.g=!1,this.h=new Set,this.c=l,this.d=new s(this.j,this.id,d,f),this.e=a,this.f=i;const n=this;this.value=Object.freeze({get document(){return r.value},set document(t){throw new D.$$("document")},get selection(){return n.c&&n.c[0]},set selection(t){if(!(t instanceof R.$8N))throw(0,D.$9)("selection");n.c=[t],n.l()},get selections(){return n.c},set selections(t){if(!Array.isArray(t)||t.some(o=>!(o instanceof R.$8N)))throw(0,D.$9)("selections");n.c=t,n.l()},get visibleRanges(){return n.e},set visibleRanges(t){throw new D.$$("visibleRanges")},get options(){return n.d.value},set options(t){n.g||n.d.assign(t)},get viewColumn(){return n.f},set viewColumn(t){throw new D.$$("viewColumn")},edit(t,o={undoStopBefore:!0,undoStopAfter:!0}){if(n.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const c=new p(r.value,o);return t(c),n.m(c)},insertSnippet(t,o,c={undoStopBefore:!0,undoStopAfter:!0}){if(n.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let m;if(!o||Array.isArray(o)&&o.length===0)m=n.c.map(g=>N.Range.from(g));else if(o instanceof R.$6N){const{lineNumber:g,column:u}=N.Position.from(o);m=[{startLineNumber:g,startColumn:u,endLineNumber:g,endColumn:u}]}else if(o instanceof R.$7N)m=[N.Range.from(o)];else{m=[];for(const g of o)if(g instanceof R.$7N)m.push(N.Range.from(g));else{const{lineNumber:u,column:S}=N.Position.from(g);m.push({startLineNumber:u,startColumn:S,endLineNumber:u,endColumn:S})}}return E.$tryInsertSnippet(h,r.value.version,t.value,m,c)},setDecorations(t,o){const c=o.length===0;c&&!n.h.has(t.key)||(c?n.h.delete(t.key):n.h.add(t.key),n.n(()=>{if(N.$AQ(o))return E.$trySetDecorations(h,t.key,N.$BQ(o));{const m=new Array(4*o.length);for(let g=0,u=o.length;g<u;g++){const S=o[g];m[4*g]=S.start.line+1,m[4*g+1]=S.start.character+1,m[4*g+2]=S.end.line+1,m[4*g+3]=S.end.character+1}return E.$trySetDecorationsFast(h,t.key,m)}}))},revealRange(t,o){n.n(()=>E.$tryRevealRange(h,N.Range.from(t),o||R.TextEditorRevealType.Default))},show(t){E.$tryShowEditor(h,N.ViewColumn.from(t))},hide(){E.$tryHideEditor(h)},[Symbol.for("debug.description")](){return`TextEditor(${this.document.uri.toString()})`}})}dispose(){(0,v.ok)(!this.g),this.g=!0}_acceptOptions(h){(0,v.ok)(!this.g),this.d._accept(h)}_acceptVisibleRanges(h){(0,v.ok)(!this.g),this.e=h}_acceptViewColumn(h){(0,v.ok)(!this.g),this.f=h}_acceptSelections(h){(0,v.ok)(!this.g),this.c=h}async l(){const h=this.c.map(N.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,h)),this.value}m(h){const E=h.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const f=E.edits.map(l=>l.range);f.sort((l,d)=>l.end.line===d.end.line?l.end.character===d.end.character?l.start.line===d.start.line?l.start.character-d.start.character:l.start.line-d.start.line:l.end.character-d.end.character:l.end.line-d.end.line);for(let l=0,d=f.length-1;l<d;l++){const a=f[l].end;if(f[l+1].start.isBefore(a))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=E.edits.map(l=>({range:N.Range.from(l.range),text:l.text,forceMoveMarkers:l.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,E.documentVersionId,r,{setEndOfLine:typeof E.setEndOfLine=="number"?N.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}n(h){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):h().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this.k.warn(E),null))}}e.$MQ=I}),define(Re[57],Te([1,0,61,6,4,2,3,5,125,16,129,8,11,27,15,40,51]),function(we,e,v,D,P,N,R,O,p,s,I,b,h,E,f,r,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OQ=e.$NQ=void 0,v=qe(v),b=qe(b);class d{constructor(n){this.value=n,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let a=class{constructor(n,t){this.h=n,this.i=t,this.a=null,this.b=new Map,this.c=new E.$Dc,this.d=new D.$oe,this.e=new D.$oe,this.f=new D.$oe,this.g=new D.$oe,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(n){this.acceptDocumentsAndEditorsDelta(n)}acceptDocumentsAndEditorsDelta(n){const t=[],o=[],c=[];if(n.removedDocuments)for(const m of n.removedDocuments){const g=N.URI.revive(m),u=this.c.get(g);u?.unref()&&(this.c.delete(g),t.push(u.value))}if(n.addedDocuments)for(const m of n.addedDocuments){const g=N.URI.revive(m.uri);let u=this.c.get(g);if(u&&g.scheme!==f.Schemas.vscodeNotebookCell&&g.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${g} already exists!'`);u||(u=new d(new p.$GQ(this.h.getProxy(O.$3N.MainThreadDocuments),g,m.lines,m.EOL,m.versionId,m.languageId,m.isDirty)),this.c.set(g,u),o.push(u.value)),u.ref()}if(n.removedEditors)for(const m of n.removedEditors){const g=this.b.get(m);this.b.delete(m),g&&c.push(g)}if(n.addedEditors)for(const m of n.addedEditors){const g=N.URI.revive(m.documentUri);v.ok(this.c.has(g),`document '${g}' does not exist`),v.ok(!this.b.has(m.id),`editor '${m.id}' already exists!`);const u=this.c.get(g).value,S=new I.$MQ(m.id,this.h.getProxy(O.$3N.MainThreadTextEditors),this.i,new l.$W(()=>u.document),m.selections.map(b.Selection.to),m.options,m.visibleRanges.map(k=>b.Range.to(k)),typeof m.editorPosition=="number"?b.ViewColumn.to(m.editorPosition):void 0);this.b.set(m.id,S)}n.newActiveEditor!==void 0&&(v.ok(n.newActiveEditor===null||this.b.has(n.newActiveEditor),`active editor '${n.newActiveEditor}' does not exist`),this.a=n.newActiveEditor),(0,P.$Sc)(t),(0,P.$Sc)(c),n.removedDocuments&&this.e.fire(t),n.addedDocuments&&this.d.fire(o),(n.removedEditors||n.addedEditors)&&this.f.fire(this.allEditors().map(m=>m.value)),n.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(n){return this.c.get(n)?.value}allDocuments(){return r.Iterable.map(this.c.values(),n=>n.value)}getEditor(n){return this.b.get(n)}activeEditor(n){if(!this.a)return;const t=this.b.get(this.a);return n?t:t?.value}allEditors(){return[...this.b.values()]}};e.$NQ=a,e.$NQ=a=Ke([We(0,s.$DQ),We(1,h.$dk)],a),e.$OQ=(0,R.$Ii)("IExtHostDocumentsAndEditors")}),define(Re[96],Te([1,0,10,20,19,6,230,76,4,37,14,2,38,3,11,5,34,57,16,127,8,7,199,54,82,55,21]),function(we,e,v,D,P,N,R,O,p,s,I,b,h,E,f,r,l,d,a,i,n,t,o,c,m,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Irc=e.$Hrc=e.$Grc=e.$Frc=e.$Erc=void 0,n=qe(n);let S=0;const k=new WeakMap;e.$Erc=(0,E.$Ii)("IExtHostTesting");let y=class extends p.$Xc{constructor(_,oe,re,ce){super(),this.C=oe,this.D=re,this.F=ce,this.f=this.B(new N.$oe),this.g=new Map,this.w=this.B(new N.$oe),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=_.getProxy(r.$3N.MainThreadTesting),this.m=new Y(this.h),this.j=new w(this.h,oe),re.registerArgumentProcessor({processArgument:x=>{switch(x?.$mid){case s.MarshalledId.TestItemContext:{const $e=x,Pe=$e.tests[$e.tests.length-1].item.extId;return this.g.get(c.$mJ.root(Pe))?.collection.tree.get(Pe)?.actual??(0,i.$PQ)(x)}case s.MarshalledId.TestMessageMenuArgs:{const{test:$e,message:Pe}=x,X=$e.item.extId;return{test:this.g.get(c.$mJ.root(X))?.collection.tree.get(X)?.actual??(0,i.$PQ)({$mid:s.MarshalledId.TestItemContext,tests:[$e]}),message:n.TestMessage.to(Pe)}}default:return x}}}),re.registerCommand(!1,"testing.getExplorerSelection",async()=>{const x=await re.executeCommand(o.TestCommandId.GetExplorerSelection),$e=Pe=>{const X=this.g.get(c.$mJ.root(Pe));if(X)return c.$mJ.isRoot(Pe)?X.controller:X.collection.tree.get(Pe)?.actual};return{include:x?.include.map($e).filter(I.$pg)||[],exclude:x?.exclude.map($e).filter(I.$pg)||[]}})}createTestController(_,oe,re,ce){if(this.g.has(oe))throw new Error(`Attempt to insert a duplicate controller with ID "${oe}"`);const x=new p.$Wc,$e=x.add(new i.$SQ(oe,re,this.F));$e.root.label=re;const Pe=new Map,X=new Set,q=this.h,ne=()=>{let Fe=0;ce&&(Fe|=g.TestControllerCapability.Refresh);const Be=Ie.relatedCodeProvider;return Be&&(Be?.provideRelatedTests&&(Fe|=g.TestControllerCapability.TestRelatedToCode),Be?.provideRelatedCode&&(Fe|=g.TestControllerCapability.CodeRelatedToTest)),Fe},be={items:$e.root.children,get label(){return re},set label(Fe){re=Fe,$e.root.label=Fe,q.$updateController(oe,{label:re})},get refreshHandler(){return ce},set refreshHandler(Fe){ce=Fe,q.$updateController(oe,{capabilities:ne()})},get id(){return oe},get relatedCodeProvider(){return Ie.relatedCodeProvider},set relatedCodeProvider(Fe){(0,u.$wH)(_,"testRelatedCode"),Ie.relatedCodeProvider=Fe,q.$updateController(oe,{capabilities:ne()})},createRunProfile:(Fe,Be,xe,nt,ut,pt)=>{let lt=(0,O.$wj)(Fe);for(;Pe.has(lt);)lt++;return new Q(this.h,Pe,X,this.w.event,oe,lt,Fe,Be,xe,nt,ut,pt)},createTestItem(Fe,Be,xe){return new i.$QQ(oe,Fe,Be,xe)},createTestRun:(Fe,Be,xe=!0)=>this.j.createTestRun(_,oe,$e,Fe,Be,xe),invalidateTestResults:Fe=>{if(Fe===void 0)this.h.$markTestRetired(void 0);else{const Be=Fe instanceof Array?Fe:[Fe];this.h.$markTestRetired(Be.map(xe=>c.$mJ.fromExtHostTestItem(xe,oe).toString()))}},set resolveHandler(Fe){$e.resolveHandler=Fe},get resolveHandler(){return $e.resolveHandler},dispose:()=>{x.dispose()}},Ie={controller:be,collection:$e,profiles:Pe,extension:_,activeProfiles:X};return q.$registerTestController(oe,re,ne()),x.add((0,p.$Vc)(()=>q.$unregisterTestController(oe))),this.g.set(oe,Ie),x.add((0,p.$Vc)(()=>this.g.delete(oe))),x.add($e.onDidGenerateDiff(Fe=>q.$publishDiff(oe,Fe.map(g.TestsDiffOp.serialize)))),be}createTestObserver(){return this.m.checkout()}async runTests(_,oe=P.CancellationToken.None){const re=M(_);if(!re)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const ce=this.g.get(re.controllerId);if(!ce)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:_.preserveFocus??!0,group:V[re.kind],targets:[{testIds:_.include?.map(x=>c.$mJ.fromExtHostTestItem(x,ce.collection.root.id).toString())??[ce.collection.root.id],profileId:re.profileId,controllerId:re.controllerId}],exclude:_.exclude?.map(x=>x.id)},oe)}registerTestFollowupProvider(_){return this.y.add(_),{dispose:()=>{this.y.delete(_)}}}async $getTestsRelatedToCode(_,oe,re){const ce=this.F.getDocument(b.URI.revive(_));if(!ce)return[];const x=n.Position.to(oe),$e=[];return await Promise.all([...this.g.values()].map(async Pe=>{let X;try{X=await Pe.relatedCodeProvider?.provideRelatedTests?.(ce.document,x,re)}catch(q){re.isCancellationRequested||this.C.warn(`Error thrown while providing related tests for ${Pe.controller.label}`,q)}if(X){for(const q of X)$e.push(c.$mJ.fromExtHostTestItem(q,Pe.controller.id).toString());Pe.collection.flushDiff()}})),$e}async $getCodeRelatedToTest(_,oe){const re=this.g.get(c.$mJ.root(_));if(!re)return[];const ce=re.collection.tree.get(_);return ce?(await re.relatedCodeProvider?.provideRelatedCode?.(ce.actual,oe))?.map(n.location.from)??[]:[]}$syncTests(){for(const{collection:_}of this.g.values())_.flushDiff();return Promise.resolve()}async $getCoverageDetails(_,oe,re){return(await this.j.getCoverageDetails(_,oe,re))?.map(n.TestCoverage.fromDetails)}async $disposeRun(_){this.j.disposeTestRun(_)}$configureRunProfile(_,oe){this.g.get(_)?.profiles.get(oe)?.configureHandler?.()}$setDefaultRunProfiles(_){const oe=new Map;for(const[re,ce]of Object.entries(_)){const x=this.g.get(re);if(!x)continue;const $e=new Map,Pe=ce.filter(q=>!x.activeProfiles.has(q)),X=[...x.activeProfiles].filter(q=>!ce.includes(q));for(const q of Pe)$e.set(q,!0),x.activeProfiles.add(q);for(const q of X)$e.set(q,!1),x.activeProfiles.delete(q);$e.size&&oe.set(re,$e)}this.w.fire(oe)}async $refreshTests(_,oe){await this.g.get(_)?.controller.refreshHandler?.(oe)}$publishTestResults(_){this.results=Object.freeze(_.map(oe=>{const re=n.TestResults.to(oe);return k.set(re,oe.id),re}).concat(this.results).sort((oe,re)=>re.completedAt-oe.completedAt).slice(0,32)),this.f.fire()}async $expandTest(_,oe){const re=this.g.get(c.$mJ.fromString(_).controllerId)?.collection;re&&(await re.expand(_,oe<0?1/0:oe),re.flushDiff())}$acceptDiff(_){this.m.applyDiff(_.map(oe=>g.TestsDiffOp.deserialize({asCanonicalUri:re=>re},oe)))}async $runControllerTests(_,oe){return Promise.all(_.map(re=>this.G(re,!1,oe)))}async $startContinuousRun(_,oe){const re=new P.$ze(oe),ce=await Promise.all(_.map(x=>this.G(x,!0,re.token)));return!oe.isCancellationRequested&&!ce.some(x=>x.error)&&await new Promise(x=>oe.onCancellationRequested(x)),re.dispose(!0),ce}async $provideTestFollowups(_,oe){const re=this.results.find($e=>k.get($e)===_.resultId),ce=re&&ie(c.$mJ.fromString(_.extId),re?.results);if(!ce)return[];let x=[];return await Promise.all([...this.y].map(async $e=>{try{const Pe=await $e.provideFollowup(re,ce,_.taskIndex,_.messageIndex,oe);Pe&&(x=x.concat(Pe))}catch(Pe){this.C.error("Error thrown while providing followup for test message",Pe)}})),oe.isCancellationRequested?[]:x.map($e=>{const Pe=S++;return this.z.set(Pe,$e),{title:$e.title,id:Pe}})}$disposeTestFollowups(_){for(const oe of _)this.z.delete(oe)}$executeTestFollowup(_){const oe=this.z.get(_);return oe?this.D.executeCommand(oe.command,...oe.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(_,oe){_===void 0?this.j.cancelAllRuns():this.j.cancelRunById(_,oe)}getMetadataForRun(_){for(const oe of this.j.trackers){const re=oe.getTaskIdForRun(_);if(re)return{taskId:re,runId:oe.id}}}async G(_,oe,re){const ce=this.g.get(_.controllerId);if(!ce)return{};const{collection:x,profiles:$e,extension:Pe}=ce,X=$e.get(_.profileId);if(!X)return{};const q=_.testIds.map(Fe=>x.tree.get(Fe)).filter(I.$pg),ne=_.excludeExtIds.map(Fe=>ce.collection.tree.get(Fe)).filter(I.$pg).filter(Fe=>q.some(Be=>Be.fullId.compare(Fe.fullId)===c.TestPosition.IsChild));if(!q.length)return{};const be=new t.$HP(q.some(Fe=>Fe.actual instanceof i.$RQ)?void 0:q.map(Fe=>Fe.actual),ne.map(Fe=>Fe.actual),X,oe),Ie=(0,g.$pJ)(_)&&this.j.prepareForMainThreadTestRun(Pe,be,A.fromInternal(_,ce.collection),X,re);try{return await X.runHandler(be,re),{}}catch(Fe){return{error:String(Fe)}}finally{Ie&&Ie.hasRunningTasks&&!re.isCancellationRequested&&await N.Event.toPromise(Ie.onEnd)}}};e.$Frc=y,e.$Frc=y=Ke([We(0,a.$DQ),We(1,f.$dk),We(2,l.$ZQ),We(3,d.$OQ)],y);const C=1e4;var T;(function(le){le[le.Running=0]="Running",le[le.Cancelling=1]="Cancelling",le[le.Ended=2]="Ended"})(T||(T={}));class $ extends p.$Xc{get hasRunningTasks(){return this.g>0}get id(){return this.C.id}constructor(_,oe,re,ce,x,$e){super(),this.C=_,this.D=oe,this.F=re,this.G=ce,this.H=x,this.f=T.Running,this.g=0,this.h=new Map,this.j=new Set,this.w=this.B(new N.$oe),this.z=new Map,this.onEnd=this.w.event,this.m=this.B(new P.$ze($e));const Pe=this.B(new v.$Uh(()=>this.I(),C));this.B(this.m.token.onCancellationRequested(()=>Pe.schedule()));const X=new N.$oe;this.y=X.event,this.B((0,p.$Vc)(()=>{X.fire(),X.dispose()}))}getTaskIdForRun(_){for(const[oe,{run:re}]of this.h)if(re===_)return oe}cancel(_){_?this.h.get(_)?.cts.cancel():this.f===T.Running?(this.m.cancel(),this.f=T.Cancelling):this.f===T.Cancelling&&this.I()}async getCoverageDetails(_,oe,re){const[,ce]=c.$mJ.fromString(_).path,x=this.z.get(_);if(!x)return[];const{report:$e,extIds:Pe}=x,X=this.h.get(ce);if(!X)throw new Error("unreachable: run task was not found");let q;if(oe&&$e instanceof t.$NP){const be=Pe.indexOf(oe);if(be===-1)return[];q=$e.fromTests[be]}return await(q?this.G?.loadDetailedCoverageForTest?.(X.run,$e,q,re):this.G?.loadDetailedCoverage?.(X.run,$e,re))??[]}createRun(_){const oe=this.C.id,re=this.C.controllerId,ce=(0,h.$5g)(),x=ne=>(be,...Ie)=>{if(Pe){this.F.warn(`Setting the state of test "${be.id}" is a no-op after the run ends.`);return}this.L(be),ne(be,...Ie)},$e=(ne,be)=>{const Ie=be instanceof Array?be.map(n.TestMessage.from):[n.TestMessage.from(be)];if(ne.uri&&ne.range){const Fe={range:n.Range.from(ne.range),uri:ne.uri};for(const Be of Ie)Be.location=Be.location||Fe}this.D.$appendTestMessagesInRun(oe,ce,c.$mJ.fromExtHostTestItem(ne,re).toString(),Ie)};let Pe=!1;const X=this.B(new P.$ze(this.m.token)),q={isPersisted:this.C.isPersisted,token:X.token,name:_,onDidDispose:this.y,addCoverage:ne=>{if(Pe)return;const be=ne instanceof t.$NP?ne.fromTests:[];if(be.length){(0,u.$wH)(this.H,"attributableCoverage");for(const Be of be)this.L(Be)}const Ie=ne.uri.toString(),Fe=new c.$mJ([oe,ce,Ie]).toString();this.z.set(Fe,{report:ne,extIds:be.map(Be=>c.$mJ.fromExtHostTestItem(Be,re).toString())}),this.D.$appendCoverage(oe,ce,n.TestCoverage.fromFile(re,Fe,ne))},enqueued:x(ne=>{this.D.$updateTestStateInRun(oe,ce,c.$mJ.fromExtHostTestItem(ne,re).toString(),g.TestResultState.Queued)}),skipped:x(ne=>{this.D.$updateTestStateInRun(oe,ce,c.$mJ.fromExtHostTestItem(ne,re).toString(),g.TestResultState.Skipped)}),started:x(ne=>{this.D.$updateTestStateInRun(oe,ce,c.$mJ.fromExtHostTestItem(ne,re).toString(),g.TestResultState.Running)}),errored:x((ne,be,Ie)=>{$e(ne,be),this.D.$updateTestStateInRun(oe,ce,c.$mJ.fromExtHostTestItem(ne,re).toString(),g.TestResultState.Errored,Ie)}),failed:x((ne,be,Ie)=>{$e(ne,be),this.D.$updateTestStateInRun(oe,ce,c.$mJ.fromExtHostTestItem(ne,re).toString(),g.TestResultState.Failed,Ie)}),passed:x((ne,be)=>{this.D.$updateTestStateInRun(oe,ce,c.$mJ.fromExtHostTestItem(ne,this.C.controllerId).toString(),g.TestResultState.Passed,be)}),appendOutput:(ne,be,Ie)=>{Pe||(Ie&&this.L(Ie),this.D.$appendOutputToRun(oe,ce,D.$Qe.fromString(ne),be&&n.location.from(be),Ie&&c.$mJ.fromExtHostTestItem(Ie,re).toString()))},end:()=>{Pe||(Pe=!0,this.D.$finishedTestRunTask(oe,ce),--this.g||this.J())}};return this.g++,this.h.set(ce,{run:q,cts:X}),this.D.$startedTestRunTask(oe,{id:ce,ctrlId:this.C.controllerId,name:_||this.H.displayName||this.H.identifier.value,running:!0}),q}I(){for(const{run:_}of this.h.values())_.end()}J(){this.f!==T.Ended&&(this.f=T.Ended,this.w.fire())}L(_){if(!(_ instanceof i.$QQ))throw new m.$vQ(_.id);if(this.j.has(c.$mJ.fromExtHostTestItem(_,this.C.controllerId).toString()))return;const oe=[],re=this.C.colllection.root;for(;;){const ce=n.TestItem.from(_);if(oe.unshift(ce),this.j.has(ce.extId)||(this.j.add(ce.extId),_===re))break;_=_.parent||re}this.D.$addTestsToRun(this.C.controllerId,this.C.id,oe)}dispose(){this.J(),super.dispose()}}class w{get trackers(){return this.f.values()}constructor(_,oe){this.h=_,this.j=oe,this.f=new Map,this.g=new Map}getCoverageDetails(_,oe,re){const ce=c.$mJ.root(_);return this.g.get(ce)?.getCoverageDetails(_,oe,re)||[]}disposeTestRun(_){this.g.get(_)?.dispose(),this.g.delete(_);for(const[oe,{id:re}]of this.f)re===_&&this.f.delete(oe)}prepareForMainThreadTestRun(_,oe,re,ce,x){return this.k(oe,re,ce,_,x)}cancelRunById(_,oe){this.g.get(_)?.cancel(oe)}cancelAllRuns(){for(const _ of this.f.values())_.cancel()}createTestRun(_,oe,re,ce,x,$e){const Pe=this.f.get(ce);if(Pe)return Pe.createRun(x);const X=A.fromPublic(oe,re,ce,$e),q=M(ce);this.h.$startedExtensionTestRun({controllerId:oe,continuous:!!ce.continuous,profile:q&&{group:V[q.kind],id:q.profileId},exclude:ce.exclude?.map(be=>c.$mJ.fromExtHostTestItem(be,re.root.id).toString())??[],id:X.id,include:ce.include?.map(be=>c.$mJ.fromExtHostTestItem(be,re.root.id).toString())??[re.root.id],preserveFocus:ce.preserveFocus??!0,persist:$e});const ne=this.k(ce,X,ce.profile,_);return N.Event.once(ne.onEnd)(()=>{this.h.$finishedExtensionTestRun(X.id)}),ne.createRun(x)}k(_,oe,re,ce,x){const $e=new $(oe,this.h,this.j,re,ce,x);return this.f.set(_,$e),this.g.set($e.id,$e),$e}}e.$Grc=w;const M=le=>{if(le.profile){if(!(le.profile instanceof Q))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return le.profile}};class A{static fromPublic(_,oe,re,ce){return new A(_,(0,h.$5g)(),ce,oe)}static fromInternal(_,oe){return new A(_.controllerId,_.runId,!0,oe)}constructor(_,oe,re,ce){this.controllerId=_,this.id=oe,this.isPersisted=re,this.colllection=ce}}e.$Hrc=A;class L{get isEmpty(){return this.f.size===0&&this.h.size===0&&this.g.size===0}constructor(_){this.k=_,this.f=new Set,this.g=new Set,this.h=new Set,this.j=new Set}add(_){this.f.add(_)}update(_){Object.assign(_.revived,n.TestItem.toPlain(_.item)),this.f.has(_)||this.g.add(_)}remove(_){if(this.f.has(_)){this.f.delete(_);return}this.g.delete(_);const oe=c.$mJ.parentId(_.item.extId);if(oe&&this.j.has(oe.toString())){this.j.add(_.item.extId);return}this.h.add(_)}getChangeEvent(){const{f:_,g:oe,h:re}=this;return{get added(){return[..._].map(ce=>ce.revived)},get updated(){return[...oe].map(ce=>ce.revived)},get removed(){return[...re].map(ce=>ce.revived)}}}complete(){this.isEmpty||this.k.fire(this.getChangeEvent())}}class J extends g.$vJ{constructor(){super(...arguments),this.z=new N.$oe,this.onDidChangeTests=this.z.event}get rootTests(){return this.h}getMirroredTestDataById(_){return this.g.get(_)}getMirroredTestDataByReference(_){return this.g.get(_.id)}y(_,oe){return{..._,revived:n.TestItem.toPlain(_.item),depth:oe?oe.depth+1:0,children:new Set}}x(){return new L(this.z)}}class Y{constructor(_){this.g=_}checkout(){this.f||(this.f=this.h());const _=this.f;return _.observers++,{onDidChangeTest:_.tests.onDidChangeTests,get tests(){return[..._.tests.rootTests].map(oe=>oe.revived)},dispose:(0,R.$fb)(()=>{--_.observers===0&&(this.g.$unsubscribeFromDiffs(),this.f=void 0)})}}getMirroredTestDataByReference(_){return this.f?.tests.getMirroredTestDataByReference(_)}applyDiff(_){this.f?.tests.apply(_)}h(){const _=new J({asCanonicalUri:oe=>oe});return this.g.$subscribeToDiffs(),{observers:0,tests:_}}}const z=(le,_,oe,re)=>{oe?Object.assign(oe,re):_.$updateTestRunConfig(le.controllerId,le.profileId,re)};class Q{#e;#t;#i;#n;#s;get label(){return this.g}set label(_){_!==this.g&&(this.g=_,z(this,this.#e,this.#n,{label:_}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(_){_!==this.h&&(this.h=_,z(this,this.#e,this.#n,{supportsContinuousRun:_}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(_){_!==this.isDefault&&(_?this.#t.add(this.profileId):this.#t.delete(this.profileId),z(this,this.#e,this.#n,{isDefault:_}))}get tag(){return this._tag}set tag(_){_?.id!==this._tag?.id&&(this._tag=_,z(this,this.#e,this.#n,{tag:_?n.TestTag.namespace(this.controllerId,_.id):null}))}get configureHandler(){return this.f}set configureHandler(_){_!==this.f&&(this.f=_,z(this,this.#e,this.#n,{hasConfigurationHandler:!!_}))}get onDidChangeDefault(){return N.Event.chain(this.#i,_=>_.map(oe=>oe.get(this.controllerId)?.get(this.profileId)).filter(I.$pg))}constructor(_,oe,re,ce,x,$e,Pe,X,q,ne=!1,be=void 0,Ie=!1){this.controllerId=x,this.profileId=$e,this.g=Pe,this.kind=X,this.runHandler=q,this._tag=be,this.h=Ie,this.#e=_,this.#s=oe,this.#t=re,this.#i=ce,oe.set($e,this);const Fe=V[X];if(typeof Fe!="number")throw new Error(`Unknown TestRunProfile.group ${X}`);ne&&re.add($e),this.#n={profileId:$e,controllerId:x,tag:be?n.TestTag.namespace(this.controllerId,be.id):null,label:Pe,group:Fe,isDefault:ne,hasConfigurationHandler:!1,supportsContinuousRun:Ie},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Irc=Q;const V={[t.TestRunProfileKind.Coverage]:g.TestRunProfileBitset.Coverage,[t.TestRunProfileKind.Debug]:g.TestRunProfileBitset.Debug,[t.TestRunProfileKind.Run]:g.TestRunProfileBitset.Run};function ie(le,_){for(let oe=0;oe<le.path.length;oe++){const re=_.find(ce=>ce.id===le.path[oe]);if(!re)return;if(oe===le.path.length-1)return re;_=re.children}}}),define(Re[258],Te([1,0,17,6,4,5,129,8,7]),function(we,e,v,D,P,N,R,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pqc=void 0,v=qe(v),O=qe(O);class s extends P.$Xc{constructor(b,h){super(),this.m=h,this.a=new D.$oe,this.b=new D.$oe,this.c=new D.$oe,this.f=new D.$oe,this.g=new D.$oe,this.h=new D.$oe,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.f.event,this.onDidChangeActiveTextEditor=this.g.event,this.onDidChangeVisibleTextEditors=this.h.event,this.j=b.getProxy(N.$3N.MainThreadTextEditors),this.B(this.m.onDidChangeVisibleTextEditors(E=>this.h.fire(E))),this.B(this.m.onDidChangeActiveTextEditor(E=>this.g.fire(E)))}getActiveTextEditor(){return this.m.activeEditor()}getVisibleTextEditors(b){const h=this.m.allEditors();return b?h:h.map(E=>E.value)}async showTextDocument(b,h,E){let f;typeof h=="number"?f={position:O.ViewColumn.from(h),preserveFocus:E}:typeof h=="object"?f={position:O.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus,selection:typeof h.selection=="object"?O.Range.from(h.selection):void 0,pinned:typeof h.preview=="boolean"?!h.preview:void 0}:f={preserveFocus:!1};const r=await this.j.$tryShowTextDocument(b.uri,f),l=r&&this.m.getEditor(r);if(l)return l.value;throw r?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}createTextEditorDecorationType(b,h){return new R.$KQ(this.j,b,h).value}$acceptEditorPropertiesChanged(b,h){const E=this.m.getEditor(b);if(!E)throw new Error("unknown text editor");if(h.options&&E._acceptOptions(h.options),h.selections){const f=h.selections.selections.map(O.Selection.to);E._acceptSelections(f)}if(h.visibleRanges){const f=v.$Jb(h.visibleRanges.map(O.Range.to));E._acceptVisibleRanges(f)}if(h.options&&this.b.fire({textEditor:E.value,options:{...h.options,lineNumbers:O.TextEditorLineNumbersStyle.to(h.options.lineNumbers)}}),h.selections){const f=p.TextEditorSelectionChangeKind.fromValue(h.selections.source),r=h.selections.selections.map(O.Selection.to);this.a.fire({textEditor:E.value,selections:r,kind:f})}if(h.visibleRanges){const f=v.$Jb(h.visibleRanges.map(O.Range.to));this.c.fire({textEditor:E.value,visibleRanges:f})}}$acceptEditorPositionData(b){for(const h in b){const E=this.m.getEditor(h);if(!E)throw new Error("Unknown text editor");const f=O.ViewColumn.to(b[h]);E.value.viewColumn!==f&&(E._acceptViewColumn(f),this.f.fire({textEditor:E.value,viewColumn:f}))}}getDiffInformation(b){return Promise.resolve(this.j.$getDiffInformation(b))}}e.$Pqc=s}),define(Re[259],Te([1,0,2,3,5,4,7,8,18,37,14]),function(we,e,v,D,P,N,R,O,p,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gsc=e.$Fsc=void 0,e.$Fsc=(0,D.$Ii)("IExtHostTimeline");class b{constructor(f,r){this.b=new Map,this.c=new Map,this.a=f.getProxy(P.$3N.MainThreadTimeline),r.registerArgumentProcessor({processArgument:(l,d)=>{if(l&&l.$mid===s.MarshalledId.TimelineActionContext)if(this.b.get(l.source)&&p.$vn.equals(d,this.b.get(l.source)?.extension)){const a=l.uri===void 0?void 0:v.URI.revive(l.uri);return this.c.get(l.source)?.get(h(a))?.get(l.handle)}else return;return l}})}async $getTimeline(f,r,l,d){return this.b.get(f)?.provider.provideTimeline(v.URI.revive(r),l,d)}registerTimelineProvider(f,r,l,d){const a=new N.$Wc,i=this.d(r.id,d,a).bind(this);let n;r.onDidChange&&(n=r.onDidChange(o=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...o,id:r.id}),this));const t=this.c;return this.f({...r,scheme:f,onDidChange:void 0,async provideTimeline(o,c,m){c?.resetCache&&(a.clear(),t.get(r.id)?.clear());const g=await r.provideTimeline(o,c,m);if(g==null)return;const u=i(o,c);return{...g,source:r.id,items:g.items.map(u)}},dispose(){for(const o of t.values())o.get(r.id)?.clear();n?.dispose(),a.dispose()}},l)}d(f,r,l){return(d,a)=>{let i;if(a?.cacheResults){let n=this.c.get(f);n===void 0&&(n=new Map,this.c.set(f,n));const t=h(d);i=n.get(t),i===void 0&&(i=new Map,n.set(t,i))}return n=>{const{iconPath:t,...o}=n,c=`${f}|${n.id??n.timestamp}`;i?.set(c,n);let m,g,u;n.iconPath&&(t instanceof R.$4O?u={id:t.id,color:t.color}:v.URI.isUri(t)?(m=t,g=t):{light:m,dark:g}=t);let S;return R.$wO.isMarkdownString(o.tooltip)?S=O.MarkdownString.from(o.tooltip):(0,I.$hg)(o.tooltip)?S=o.tooltip:R.$wO.isMarkdownString(o.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),S=O.MarkdownString.from(o.detail)):(0,I.$hg)(o.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),S=o.detail),{...o,id:o.id??void 0,handle:c,source:f,command:n.command?r.toInternal(n.command,l):void 0,icon:m,iconDark:g,themeIcon:u,tooltip:S,accessibilityInformation:n.accessibilityInformation}}}}f(f,r){if(this.b.get(f.id))throw new Error(`Timeline Provider ${f.id} already exists.`);return this.a.$registerTimelineProvider({id:f.id,label:f.label,scheme:f.scheme}),this.b.set(f.id,{provider:f,extension:r}),(0,N.$Vc)(()=>{for(const d of this.c.values())d.get(f.id)?.clear();this.b.delete(f.id),this.a.$unregisterTimelineProvider(f.id),f.dispose()})}}e.$Gsc=b;function h(E){return E?.toString()}}),define(Re[260],Te([1,0,9,24,2,6,4,191,10,7,14,17,8,59,19,163,21]),function(we,e,v,D,P,N,R,O,p,s,I,b,h,E,f,r,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hsc=void 0,s=qe(s);function d(n,t){if((0,I.$hg)(n))return{label:n};if(n&&typeof n=="object"&&typeof n.label=="string"){let o;return Array.isArray(n.highlights)&&(o=n.highlights.filter(c=>c.length===2&&typeof c[0]=="number"&&typeof c[1]=="number"),o=o.length?o:void 0),{label:n.label,highlights:o}}}class a extends R.$Xc{constructor(t,o,c){super(),this.f=t,this.g=o,this.h=c,this.a=new Map,this.b=new r.$cab;function m(g){return g&&g.$treeViewId&&(g.$treeItemHandle||g.$selectedTreeItems||g.$focusedTreeItem)}o.registerArgumentProcessor({processArgument:g=>m(g)?this.r(g):Array.isArray(g)&&g.length>0?g.map(u=>m(u)?this.r(u):u):g})}registerTreeDataProvider(t,o,c){const m=this.createTreeView(t,{treeDataProvider:o},c);return{dispose:()=>m.dispose()}}createTreeView(t,o,c){if(!o||!o.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const m=o.dragAndDropController?.dropMimeTypes??[],g=o.dragAndDropController?.dragMimeTypes??[],u=!!o.dragAndDropController?.handleDrag,S=!!o.dragAndDropController?.handleDrop,k=this.m(t,o,c),y={showCollapseAll:!!o.showCollapseAll,canSelectMany:!!o.canSelectMany,dropMimeTypes:m,dragMimeTypes:g,hasHandleDrag:u,hasHandleDrop:S,manuallyManageCheckboxes:!!o.manageCheckboxStateManually},C=this.f.$registerTreeViewDataProvider(t,y),T={get onDidCollapseElement(){return k.onDidCollapseElement},get onDidExpandElement(){return k.onDidExpandElement},get selection(){return k.selectedElements},get onDidChangeSelection(){return k.onDidChangeSelection},get activeItem(){return(0,l.$wH)(c,"treeViewActiveItem"),k.focusedElement},get onDidChangeActiveItem(){return(0,l.$wH)(c,"treeViewActiveItem"),k.onDidChangeActiveItem},get visible(){return k.visible},get onDidChangeVisibility(){return k.onDidChangeVisibility},get onDidChangeCheckboxState(){return k.onDidChangeCheckboxState},get message(){return k.message},set message($){(0,E.$9k)($)&&(0,l.$wH)(c,"treeViewMarkdownMessage"),k.message=$},get title(){return k.title},set title($){k.title=$},get description(){return k.description},set description($){k.description=$},get badge(){return k.badge},set badge($){$!==void 0&&s.ViewBadge.isViewBadge($)?k.badge={value:Math.floor(Math.abs($.value)),tooltip:$.tooltip}:$===void 0&&(k.badge=void 0)},reveal:($,w)=>k.reveal($,w),dispose:async()=>{await C,this.a.delete(t),k.dispose()}};return this.B(T),T}$getChildren(t,o){const c=this.a.get(t);return c?c.getChildren(o):Promise.reject(new O.$QG(t))}async $handleDrop(t,o,c,m,g,u,S,k){const y=this.a.get(t);if(!y)return Promise.reject(new O.$QG(t));const C=h.DataTransfer.toDataTransfer(c,async T=>(await this.f.$resolveDropFileData(t,o,T)).buffer);return S===t&&k&&await this.j(C,y,k,g,u),y.onDrop(C,m,g)}async j(t,o,c,m,g){const u=this.b.removeDragOperationTransfer(g);if(u)(await u)?.forEach((S,k)=>{S&&t.set(k,S)});else if(g&&o.handleDrag){const S=o.handleDrag(c,t,m);this.b.addDragOperationTransfer(g,S),await S}return t}async $handleDrag(t,o,c,m){const g=this.a.get(t);if(!g)return Promise.reject(new O.$QG(t));const u=await this.j(new s.$ZO,g,o,m,c);if(!(!u||m.isCancellationRequested))return h.DataTransfer.from(u)}async $hasResolve(t){const o=this.a.get(t);if(!o)throw new O.$QG(t);return o.hasResolve}$resolve(t,o,c){const m=this.a.get(t);if(!m)throw new O.$QG(t);return m.resolveTreeItem(o,c)}$setExpanded(t,o,c){const m=this.a.get(t);if(!m)throw new O.$QG(t);m.setExpanded(o,c)}$setSelectionAndFocus(t,o,c){const m=this.a.get(t);if(!m)throw new O.$QG(t);m.setSelectionAndFocus(o,c)}$setVisible(t,o){const c=this.a.get(t);if(!c){if(!o)return;throw new O.$QG(t)}c.setVisible(o)}$changeCheckboxState(t,o){const c=this.a.get(t);if(!c)throw new O.$QG(t);c.setCheckboxState(o)}m(t,o,c){const m=this.B(new i(t,o,this.f,this.g.converter,this.h,c));return this.a.set(t,m),m}r(t){const o=this.a.get(t.$treeViewId);return o&&"$treeItemHandle"in t?o.getExtensionElement(t.$treeItemHandle):o&&"$focusedTreeItem"in t&&t.$focusedTreeItem?o.focusedElement:null}}e.$Hsc=a;class i extends R.$Xc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(t=>this.getExtensionElement(t)).filter(t=>!(0,I.$qg)(t))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(t,o,c,m,g,u){if(super(),this.I=t,this.J=c,this.L=m,this.M=g,this.N=u,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new N.$oe),this.onDidExpandElement=this.u.event,this.w=this.B(new N.$oe),this.onDidCollapseElement=this.w.event,this.y=this.B(new N.$oe),this.onDidChangeSelection=this.y.event,this.z=this.B(new N.$oe),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new N.$oe),this.onDidChangeVisibility=this.C.event,this.D=this.B(new N.$oe),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new N.$oe),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new f.$ze,u.contributes&&u.contributes.views)for(const C in u.contributes.views)for(const T of u.contributes.views[C])T.id===t&&(this.P=T.name);this.f=o.treeDataProvider,this.g=o.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(C=>{Array.isArray(C)&&C.length===0||this.F.fire({message:!1,element:C})}));let S,k;const y=N.Event.debounce(this.F.event,(C,T)=>(C||(C={message:!1,elements:[]}),T.element!==!1&&(S||(S=new Promise($=>k=$),this.G=this.G.then(()=>S)),Array.isArray(T.element)?C.elements.push(...T.element):C.elements.push(T.element)),T.message&&(C.message=!0),C),200,!0);this.B(y(({message:C,elements:T})=>{T.length&&(this.H=this.H.then(()=>{const $=k;return S=null,this.$(T).then(()=>$())})),C&&this.J.$setMessage(this.I,h.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(t){const o=t?this.getExtensionElement(t):void 0;if(t&&!o)return this.M.error(`No tree item with id '${t}' found.`),Promise.resolve([]);let c=this.X(t);return c||(c=await this.Y(o)),c?c.map(m=>m.item):void 0}getExtensionElement(t){return this.j.get(t)}reveal(t,o){o=o||{select:!0,focus:!1};const c=(0,I.$qg)(o.select)?!0:o.select,m=(0,I.$qg)(o.focus)?!1:o.focus,g=(0,I.$qg)(o.expand)?!1:o.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):t?this.G.then(()=>this.S(t)).then(u=>this.W(t,u[u.length-1]).then(S=>this.J.$reveal(this.I,{item:S.item,parentChain:u.map(k=>k.item)},{select:c,focus:m,expand:g})),u=>this.M.error(u)):this.J.$reveal(this.I,void 0,{select:c,focus:m,expand:g})}get message(){return this.O}set message(t){this.O=t,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(t){this.P=t,this.J.$setTitle(this.I,t,this.Q)}get description(){return this.Q}set description(t){this.Q=t,this.J.$setTitle(this.I,this.P,t)}get badge(){return this.R}set badge(t){this.R?.value===t?.value&&this.R?.tooltip===t?.tooltip||(this.R=h.ViewBadge.from(t),this.J.$setBadge(this.I,t))}setExpanded(t,o){const c=this.getExtensionElement(t);c&&(o?this.u.fire(Object.freeze({element:c})):this.w.fire(Object.freeze({element:c})))}setSelectionAndFocus(t,o){const c=!(0,b.$wb)(this.s,t);this.s=t;const m=this.t!==o;this.t=o,c&&this.y.fire(Object.freeze({selection:this.selectedElements})),m&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(t){t!==this.r&&(this.r=t,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(t){const o=(await Promise.all(t.map(async c=>{const m=this.getExtensionElement(c.treeItemHandle);return m?{extensionItem:m,treeItem:await this.f.getTreeItem(m),newState:c.newState?s.TreeItemCheckboxState.Checked:s.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(c=>c!==void 0);o.forEach(c=>{c.treeItem.checkboxState=c.newState?s.TreeItemCheckboxState.Checked:s.TreeItemCheckboxState.Unchecked}),this.D.fire({items:o.map(c=>[c.extensionItem,c.newState])})}async handleDrag(t,o,c){const m=[];for(const g of t){const u=this.getExtensionElement(g);u&&m.push(u)}if(!(!this.g?.handleDrag||m.length===0))return await this.g.handleDrag(m,o,c),o}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(t,o,c){const m=o?this.getExtensionElement(o):void 0;if(!(!m&&o||!this.g?.handleDrop))return(0,p.$Ah)(()=>this.g?.handleDrop?this.g.handleDrop(m,t,c):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(t,o){if(!this.f.resolveTreeItem)return;const c=this.j.get(t);if(c){const m=this.m.get(c);if(m){const g=await this.f.resolveTreeItem(m.extensionItem,c,o)??m.extensionItem;return this.hb(g),m.item.tooltip=this.eb(g.tooltip),m.item.command=this.fb(m.disposableStore,g.command),m.item}}}S(t){return this.U(t).then(o=>o?this.S(o).then(c=>this.W(o,c[c.length-1]).then(m=>(c.push(m),c))):Promise.resolve([]))}U(t){const o=this.m.get(t);return o?Promise.resolve(o.parent?this.j.get(o.parent.item.handle):void 0):(0,p.$Ah)(()=>this.f.getParent(t))}W(t,o){const c=this.m.get(t);return c?Promise.resolve(c):(0,p.$Ah)(()=>this.f.getTreeItem(t)).then(m=>this.kb(t,m,o,!0)).then(m=>this.getChildren(o?o.item.handle:void 0).then(()=>{const g=this.getExtensionElement(m);if(g){const u=this.m.get(g);if(u)return Promise.resolve(u)}throw new Error(`Cannot resolve tree item for element ${m} from extension ${this.N.identifier.value}`)}))}X(t){if(t){let o;if(typeof t=="string"){const c=this.getExtensionElement(t);o=c?this.m.get(c):void 0}else o=t;return o&&o.children||void 0}return this.h}async Y(t){this.rb(t);const o=new f.$ze(this.Z.token);try{const c=t?this.m.get(t):void 0,m=await this.f.getChildren(t);if(o.token.isCancellationRequested)return;const g=(0,b.$Jb)(m||[]),u=await Promise.all((0,b.$Jb)(g).map(k=>this.f.getTreeItem(k)));if(o.token.isCancellationRequested)return;const S=u.map((k,y)=>k?this.db(g[y],k,c):null);return(0,b.$Jb)(S)}finally{o.dispose()}}$(t){if(t.some(c=>!c))return this.Z.dispose(!0),this.Z=new f.$ze,this.tb(),this.J.$refresh(this.I);{const c=this.ab(t);if(c.length)return this.bb(c)}return Promise.resolve(void 0)}ab(t){const o=new Set,c=t.map(g=>this.m.get(g));for(const g of c)if(g&&!o.has(g.item.handle)){let u=g;for(;u&&u.parent&&c.findIndex(S=>u&&u.parent&&S&&S.item.handle===u.parent.item.handle)===-1;){const S=this.j.get(u.parent.item.handle);u=S?this.m.get(S):void 0}u&&!u.parent&&o.add(g.item.handle)}const m=[];return o.forEach(g=>{const u=this.j.get(g);if(u){const S=this.m.get(u);S&&(!S.parent||!o.has(S.parent.item.handle))&&m.push(g)}}),m}bb(t){const o={};return Promise.all(t.map(c=>this.cb(c).then(m=>{m&&(o[c]=m.item)}))).then(()=>Object.keys(o).length?this.J.$refresh(this.I,o):void 0)}cb(t){const o=this.getExtensionElement(t);if(o){const c=this.m.get(o);if(c)return this.rb(o),(0,p.$Ah)(()=>this.f.getTreeItem(o)).then(m=>{if(m){const g=this.ib(o,m,c.parent);return this.pb(o,g,c,c.parent),c.dispose(),g}return null})}return Promise.resolve(null)}db(t,o,c){const m=this.ib(t,o,c);if(o.id&&this.j.has(m.item.handle))throw new Error((0,v.localize)(2715,null,o.id));return this.ob(t,m),this.qb(m,c),m}eb(t){return s.$wO.isMarkdownString(t)?h.MarkdownString.from(t):t}fb(t,o){return o?{...this.L.toInternal(o,t),originalId:o.command}:void 0}gb(t){if(t.checkboxState===void 0)return;let o,c,m;return typeof t.checkboxState=="number"?o=t.checkboxState:(o=t.checkboxState.state,c=t.checkboxState.tooltip,m=t.checkboxState.accessibilityInformation),{isChecked:o===s.TreeItemCheckboxState.Checked,tooltip:c,accessibilityInformation:m}}hb(t){if(!s.$UO.isTreeItem(t,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(t,o,c){this.hb(o);const m=this.B(new R.$Wc),g=this.kb(t,o,c),u=this.lb(o);return{item:{handle:g,parentHandle:c?c.item.handle:void 0,label:d(o.label,this.N),description:o.description,resourceUri:o.resourceUri,tooltip:this.eb(o.tooltip),command:this.fb(m,o.command),contextValue:o.contextValue,icon:u,iconDark:this.mb(o)||u,themeIcon:this.jb(o),collapsibleState:(0,I.$qg)(o.collapsibleState)?s.TreeItemCollapsibleState.None:o.collapsibleState,accessibilityInformation:o.accessibilityInformation,checkbox:this.gb(o)},extensionItem:o,parent:c,children:void 0,disposableStore:m,dispose(){m.dispose()}}}jb(t){return t.iconPath instanceof s.$4O?t.iconPath:void 0}kb(t,{id:o,label:c,resourceUri:m},g,u){if(o)return`${i.b}/${o}`;const S=d(c,this.N),k=g?g.item.handle:i.a;let y=S?S.label:m?(0,D.$gh)(m):"";y=y.indexOf("/")!==-1?y.replace("/","//"):y;const C=this.m.has(t)?this.m.get(t).item.handle:void 0,T=this.X(g)||[];let $,w=0;do{if($=`${k}/${w}:${y}`,u||!this.j.has($)||C===$)break;w++}while(w<=T.length);return $}lb(t){if(t.iconPath&&!(t.iconPath instanceof s.$4O))return typeof t.iconPath=="string"||P.URI.isUri(t.iconPath)?this.nb(t.iconPath):this.nb(t.iconPath.light)}mb(t){if(t.iconPath&&!(t.iconPath instanceof s.$4O)&&t.iconPath.dark)return this.nb(t.iconPath.dark)}nb(t){return P.URI.isUri(t)?t:P.URI.file(t)}ob(t,o){this.j.set(o.item.handle,t),this.m.set(t,o)}pb(t,o,c,m){this.j.delete(o.item.handle),this.m.delete(t),o.item.handle!==c.item.handle&&this.j.delete(c.item.handle),this.ob(t,o);const g=this.X(m)||[],u=g.filter(S=>S.item.handle===c.item.handle)[0];u&&g.splice(g.indexOf(u),1,o)}qb(t,o){o?(o.children||(o.children=[]),o.children.push(t)):(this.h||(this.h=[]),this.h.push(t))}rb(t){if(t){const o=this.m.get(t);if(o){if(o.children)for(const c of o.children){const m=this.j.get(c.item.handle);m&&this.sb(m)}o.children=void 0}}else this.tb()}sb(t){const o=this.m.get(t);if(o){if(o.children)for(const c of o.children){const m=this.j.get(c.item.handle);m&&this.sb(m)}this.m.delete(t),this.j.delete(o.item.handle),o.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(t=>t.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Re[261],Te([1,0,6,4,2,38,8,67,5,7]),function(we,e,v,D,P,N,R,O,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9qc=void 0,R=qe(R),p=qe(p),s=qe(s);class I extends D.$Xc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;#h;constructor(f,r,l,d){super(),this.#o=void 0,this.#c=!0,this.#u=!1,this.#d=this.B(new v.$oe),this.onDidDispose=this.#d.event,this.#h=this.B(new v.$oe),this.onDidChangeViewState=this.#h.event,this.#e=f,this.#t=r,this.#n=l,this.#i=d.viewType,this.#s=d.panelOptions,this.#o=d.viewColumn,this.#r=d.title,this.#l=d.active}dispose(){this.#u||(this.#u=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(f){this.c(),this.#r!==f&&(this.#r=f,this.#t.$setTitle(this.#e,f))}get iconPath(){return this.c(),this.#a}set iconPath(f){this.c(),this.#a!==f&&(this.#a=f,this.#t.$setIconPath(this.#e,P.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#l}get visible(){return this.c(),this.#c}_updateViewState(f){this.#u||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(this.#l=f.active,this.#c=f.visible,this.#o=f.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(f,r){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof f>"u"?void 0:R.ViewColumn.from(f),preserveFocus:!!r})}c(){if(this.#u)throw new Error("Webview is disposed")}}class b extends D.$Xc{static c(){return(0,N.$5g)()}constructor(f,r,l){super(),this.j=r,this.m=l,this.g=new Map,this.h=new Map,this.f=f.getProxy(p.$3N.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(f=>f.dispose()),this.g.clear()}createWebviewPanel(f,r,l,d,a={}){const i=typeof d=="object"?d.viewColumn:d,n={viewColumn:R.ViewColumn.from(i),preserveFocus:typeof d=="object"&&!!d.preserveFocus},t=(0,O.$5qc)(f),o=b.c();this.f.$createWebviewPanel((0,O.$7qc)(f),o,r,{title:l,panelOptions:h(a),webviewOptions:(0,O.$8qc)(f,this.m,a),serializeBuffersForPostMessage:t},n);const c=this.j.createNewWebview(o,a,f);return this.createNewWebviewPanel(o,r,l,i,a,c,!0)}$onDidChangeWebviewPanelViewStates(f){const r=Object.keys(f);r.sort((l,d)=>{const a=f[l],i=f[d];return a.active?1:i.active?-1:+a.visible-+i.visible});for(const l of r){const d=this.getWebviewPanel(l);if(!d)continue;const a=f[l];d._updateViewState({active:a.active,visible:a.visible,viewColumn:R.ViewColumn.to(a.position)})}}async $onDidDisposeWebviewPanel(f){this.getWebviewPanel(f)?.dispose(),this.g.delete(f),this.j.deleteWebview(f)}registerWebviewPanelSerializer(f,r,l){if(this.h.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.h.set(r,{serializer:l,extension:f}),this.f.$registerSerializer(r,{serializeBuffersForPostMessage:(0,O.$5qc)(f)}),new s.$5N(()=>{this.h.delete(r),this.f.$unregisterSerializer(r)})}async $deserializeWebviewPanel(f,r,l,d){const a=this.h.get(r);if(!a)throw new Error(`No serializer found for '${r}'`);const{serializer:i,extension:n}=a,t=this.j.createNewWebview(f,l.webviewOptions,n),o=this.createNewWebviewPanel(f,r,l.title,d,l.panelOptions,t,l.active);await i.deserializeWebviewPanel(o,l.state)}createNewWebviewPanel(f,r,l,d,a,i,n){const t=new I(f,this.f,i,{viewType:r,title:l,viewColumn:d,panelOptions:a,active:n});return this.g.set(f,t),t}getWebviewPanel(f){return this.g.get(f)}}e.$9qc=b;function h(E){return{enableFindWidget:E.enableFindWidget,retainContextWhenHidden:E.retainContextWhenHidden}}}),define(Re[262],Te([1,0,6,4,67,8,5,7]),function(we,e,v,D,P,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ksc=void 0,R=qe(R),O=qe(O);class p extends D.$Xc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(b,h,E,f,r,l){super(),this.#s=!1,this.#l=this.B(new v.$oe),this.onDidChangeVisibility=this.#l.event,this.#u=this.B(new v.$oe),this.onDidDispose=this.#u.event,this.#i=E,this.#a=f,this.#e=b,this.#t=h,this.#n=r,this.#r=l}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#l;#u;get title(){return this.a(),this.#a}set title(b){this.a(),this.#a!==b&&(this.#a=b,this.#t.$setWebviewViewTitle(this.#e,b))}get description(){return this.a(),this.#o}set description(b){this.a(),this.#o!==b&&(this.#o=b,this.#t.$setWebviewViewDescription(this.#e,b))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(b){b===this.#r||this.#s||(this.#r=b,this.#l.fire())}get badge(){return this.a(),this.#c}set badge(b){this.a(),!(b?.value===this.#c?.value&&b?.tooltip===this.#c?.tooltip)&&(this.#c=N.ViewBadge.from(b),this.#t.$setWebviewViewBadge(this.#e,b))}show(b){this.a(),this.#t.$show(this.#e,!!b)}a(){if(this.#s)throw new Error("Webview is disposed")}}class s{constructor(b,h){this.d=h,this.b=new Map,this.c=new Map,this.a=b.getProxy(R.$3N.MainThreadWebviewViews)}registerWebviewViewProvider(b,h,E,f){if(this.b.has(h))throw new Error(`View provider for '${h}' already registered`);return this.b.set(h,{provider:E,extension:b}),this.a.$registerWebviewViewProvider((0,P.$7qc)(b),h,{retainContextWhenHidden:f?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.$5qc)(b)}),new O.$5N(()=>{this.b.delete(h),this.a.$unregisterWebviewViewProvider(h)})}async $resolveWebviewView(b,h,E,f,r){const l=this.b.get(h);if(!l)throw new Error(`No view provider found for '${h}'`);const{provider:d,extension:a}=l,i=this.d.createNewWebview(b,{},a),n=new p(b,this.a,h,E,i,!0);this.c.set(b,n),await d.resolveWebviewView(n,{state:f},r)}async $onDidChangeWebviewViewVisibility(b,h){this.e(b)._setVisible(h)}async $disposeWebviewView(b){const h=this.e(b);this.c.delete(b),h.dispose(),this.d.deleteWebview(b)}e(b){const h=this.c.get(b);if(!h)throw new Error("No webview found");return h}}e.$Ksc=s}),define(Re[263],Te([1,0,6,29,31,3]),function(we,e,v,D,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mN=e.$lN=e.OutputChannelUpdateMode=e.$kN=e.$jN=e.$iN=e.$hN=e.$gN=e.$fN=e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=e.$_M=void 0,e.$_M="text/x-code-output",e.$aN="Log",e.$bN="text/x-code-log-output",e.$cN="log",e.$dN="workbench.panel.output",e.$eN=new P.$Zj("inOutput",!1),e.$fN=new P.$Zj("activeLogOutput",!1),e.$gN=new P.$Zj("activeLogOutput.levelSettable",!1),e.$hN=new P.$Zj("activeLogOutput.level",""),e.$iN=new P.$Zj("activeLogOutput.levelIsDefault",!1),e.$jN=new P.$Zj("outputView.scrollLock",!1),e.$kN=(0,N.$Ii)("outputService");var R;(function(p){p[p.Append=1]="Append",p[p.Replace=2]="Replace",p[p.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$lN={OutputChannels:"workbench.contributions.outputChannels"};class O{constructor(){this.a=new Map,this.b=new v.$oe,this.onDidRegisterChannel=this.b.event,this.c=new v.$oe,this.onDidRemoveChannel=this.c.event}registerChannel(s){this.a.has(s.id)||(this.a.set(s.id,s),this.b.fire(s.id))}getChannels(){const s=[];return this.a.forEach(I=>s.push(I)),s}getChannel(s){return this.a.get(s)}removeChannel(s){this.a.delete(s),this.c.fire(s)}}D.$vo.add(e.$lN.OutputChannels,new O),e.$mN=new P.$Zj("activeOutputChannel","")}),define(Re[130],Te([1,0,5,3,16,18,11,263,68,26,50,165,20,14,28,6,4]),function(we,e,v,D,P,N,R,O,p,s,I,b,h,E,f,r,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$osc=e.$nsc=void 0;class d extends R.$jk{get disposed(){return this.n}constructor(t,o,c,m,g){super(),this.id=t,this.name=o,this.r=c,this.s=m,this.extension=g,this.m=0,this.n=!1,this.visible=!1,this.setLevel(c.getLevel()),this.B(c.onDidChangeLogLevel(u=>this.setLevel(u)))}get logLevel(){return this.getLevel()}appendLine(t){this.append(t+`
`)}append(t){this.info(t)}clear(){const t=this.m;this.r.flush(),this.s.$update(this.id,O.OutputChannelUpdateMode.Clear,t)}replace(t){const o=this.m;this.info(t),this.s.$update(this.id,O.OutputChannelUpdateMode.Replace,o),this.visible&&this.r.flush()}show(t,o){this.r.flush(),this.s.$reveal(this.id,!!(typeof t=="boolean"?t:o))}hide(){this.s.$close(this.id)}g(t,o){this.m+=h.$Qe.fromString(o).byteLength,(0,R.log)(this.r,t,o),this.visible&&(this.r.flush(),this.s.$update(this.id,O.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class a extends d{appendLine(t){this.append(t)}}let i=class{constructor(t,o,c,m,g,u){this.i=o,this.j=c,this.k=m,this.l=g,this.m=u,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=t.getProxy(v.$3N.MainThreadOutputService),this.b=this.k.extUri.joinPath(o.logsLocation,`output_logging_${(0,b.$8m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(t){this.h=t;for(const[o,c]of this.g)c.visible=o===this.h}createOutputChannel(t,o,c){if(t=t.trim(),!t)throw new Error("illegal argument `name`. must not be falsy");const m=typeof o=="object"&&o.log,g=(0,E.$hg)(o)?o:void 0;if((0,E.$hg)(g)&&!g.trim())throw new Error("illegal argument `languageId`. must not be empty");let u;const S=this.i.environment.extensionLogLevel?.find(([y])=>N.$vn.equals(c.identifier,y))?.[1];S&&(u=(0,R.$uk)(S));const k=m?this.o(t,u,c):this.n(t,g,c);return k.then(y=>{this.g.set(y.id,y),y.visible=y.id===this.h}),m?this.r(t,u??this.m.getLevel(),k):this.q(t,k)}async n(t,o,c){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const m=await this.c,g=this.k.extUri.joinPath(m,`${this.f++}-${t.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),u=this.l.createLogger(g,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),S=await this.a.$register(t,g,o,c.identifier.value);return new d(S,t,u,this.a,c)}async o(t,o,c){const m=await this.p(c),g=t.replace(/[\\/:\*\?"<>\|]/g,""),u=this.k.extUri.joinPath(m,`${g}.log`),S=`${c.identifier.value}.${g}`,k=this.l.createLogger(u,{id:S,name:t,logLevel:o,extensionId:c.identifier.value});return new a(S,t,k,this.a,c)}p(t){let o=this.d.get(t.identifier.value);if(!o){const c=this.k.extUri.joinPath(this.i.logsLocation,t.identifier.value);this.d.set(t.identifier.value,o=(async()=>{try{await this.j.value.createDirectory(c)}catch(m){if((0,f.$tl)(m)!==f.FileSystemProviderErrorCode.FileExists)throw m}return c})())}return o}q(t,o){let c=!1;const m=()=>{if(c)throw new Error("Channel has been closed")};return{get name(){return t},append(g){m(),o.then(u=>u.append(g))},appendLine(g){m(),o.then(u=>u.appendLine(g))},clear(){m(),o.then(g=>g.clear())},replace(g){m(),o.then(u=>u.replace(g))},show(g,u){m(),o.then(S=>S.show(g,u))},hide(){m(),o.then(g=>g.hide())},dispose(){c=!0,o.then(g=>g.dispose())}}}r(t,o,c){const m=new l.$Wc,g=()=>{if(m.isDisposed)throw new Error("Channel has been closed")},u=m.add(new r.$oe);function S(k){o=k,u.fire(k)}return c.then(k=>{m.add(k),k.logLevel!==o&&S(k.logLevel),m.add(k.onDidChangeLogLevel(y=>S(y)))}),{...this.q(t,c),get logLevel(){return o},onDidChangeLogLevel:u.event,trace(k,...y){g(),c.then(C=>C.trace(k,...y))},debug(k,...y){g(),c.then(C=>C.debug(k,...y))},info(k,...y){g(),c.then(C=>C.info(k,...y))},warn(k,...y){g(),c.then(C=>C.warn(k,...y))},error(k,...y){g(),c.then(C=>C.error(k,...y))},dispose(){m.dispose()}}}};e.$nsc=i,e.$nsc=i=Ke([We(0,P.$DQ),We(1,s.$TQ),We(2,p.$1qc),We(3,I.$Dqc),We(4,R.$ek),We(5,R.$dk)],i),e.$osc=(0,D.$Ii)("IExtHostOutputService")}),define(Re[131],Te([1,0,3,10]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=e.$Zm=void 0,e.$Zm=(0,v.$Ii)("remoteAgentService"),e.$1m=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(P){let N=1/0;for(let O=0;O<this.maxSampleCount;O++){const p=await P.getRoundTripTime();if(p===void 0)return;N=Math.min(N,p/2),await(0,D.$Jh)(this.sampleDelay)}this.average.push(N),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(N):R=this.initial.reduce((O,p)=>O+p,0)/this.initial.length,this.lastMeasurement={initial:R,current:N,average:this.average.reduce((O,p)=>O+p,0)/this.average.length,high:typeof R>"u"?!1:N>this.highLatencyMaxThreshold||N>this.highLatencyMinThreshold&&N>R*this.highLatencyMultiple},this.lastMeasurement}}}),define(Re[264],Te([1,0,9,53,29,49,43,4,6,131,23,25,10,115]),function(we,e,v,D,P,N,R,O,p,s,I,b,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=void 0,e.$vL=Object.freeze({id:"application",order:100,title:(0,v.localize)(3975,null),type:"object"}),e.$wL=Object.freeze({id:"workbench",order:7,title:(0,v.localize)(3976,null),type:"object"}),e.$xL=Object.freeze({id:"security",scope:D.ConfigurationScope.APPLICATION,title:(0,v.localize)(3977,null),type:"object",order:7}),e.$yL=Object.freeze({id:"problems",title:(0,v.localize)(3978,null),type:"object",order:101}),e.$zL=Object.freeze({id:"window",order:8,title:(0,v.localize)(3979,null),type:"object"}),e.$AL={ConfigurationMigration:"base.contributions.configuration.migration"};class f{constructor(){this.migrations=[],this.a=new p.$oe,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const r=new f;P.$vo.add(e.$AL.ConfigurationMigration,r);let l=class extends O.$Xc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,t){super(),this.a=n,this.b=t,this.B(this.b.onDidChangeWorkspaceFolders(async o=>{for(const c of o.added)await this.f(c,r.migrations)})),this.c(r.migrations),this.B(r.onDidRegisterConfigurationMigration(o=>this.c(o)))}async c(n){await this.f(void 0,n);for(const t of this.b.getWorkspace().folders)await this.f(t,n)}async f(n,t){await Promise.all([t.map(o=>this.g(o,n?.uri))])}async g(n,t){const o=this.a.inspect(n.key,{resource:t}),c=this.b.getWorkbenchState()===N.WorkbenchState.WORKSPACE?[["user",R.ConfigurationTarget.USER],["userLocal",R.ConfigurationTarget.USER_LOCAL],["userRemote",R.ConfigurationTarget.USER_REMOTE],["workspace",R.ConfigurationTarget.WORKSPACE],["workspaceFolder",R.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",R.ConfigurationTarget.USER],["userLocal",R.ConfigurationTarget.USER_LOCAL],["userRemote",R.ConfigurationTarget.USER_REMOTE],["workspace",R.ConfigurationTarget.WORKSPACE]];for(const[m,g]of c){const u=o[m];if(!u)continue;const S=[];if(u.value!==void 0){const k=await this.h(n,m,u.value,t,void 0);for(const y of k??[])S.push([y,[]])}for(const{identifiers:k,value:y}of u.overrides??[])if(y!==void 0){const C=await this.h(n,m,y,t,k);for(const T of C??[])S.push([T,k])}S.length&&await Promise.allSettled(S.map(async([[k,y],C])=>this.a.updateValue(k,y.value,{resource:t,overrideIdentifiers:C},g)))}}async h(n,t,o,c,m){const g=S=>{const y=this.a.inspect(S,{resource:c})[t];if(y)return m?y.overrides?.find(({identifiers:C})=>(0,b.$mo)(C,m))?.value:y.value},u=await n.migrateFn(o,g);return Array.isArray(u)?u:[[n.key,u]]}};e.$BL=l,e.$BL=l=Ke([We(0,R.$cj),We(1,N.$Ri)],l);let d=class extends O.$Xc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new h.$6h,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!I.$j&&(await this.b.getEnvironment())?.os!==I.OperatingSystem.Windows)return;P.$vo.as(D.$Ao.Configuration).registerConfiguration({...e.$xL,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,v.localize)(3980,null)},default:[],markdownDescription:(0,v.localize)(3981,null),scope:D.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,v.localize)(3982,null),scope:D.ConfigurationScope.MACHINE}}})}};e.$CL=d,e.$CL=d=Ke([We(0,s.$Zm)],d),e.$DL="window.newWindowProfile";let a=class extends O.$Xc{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(n,t){super(),this.c=n,this.f=t,this.g(),this.B(this.c.onDidChangeProfiles(o=>this.g())),this.h(),this.j(),this.B(t.onDidChangeConfiguration(o=>{o.source!==R.ConfigurationTarget.DEFAULT&&o.affectsConfiguration(e.$DL)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const n=P.$vo.as(D.$Ao.Configuration),t={...e.$zL,properties:{[e.$DL]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(o=>o.name),null],enumItemLabels:[...this.c.profiles.map(o=>""),(0,v.localize)(3983,null)],description:(0,v.localize)(3984,null),scope:D.ConfigurationScope.APPLICATION}}};this.a?n.updateConfigurations({add:[t],remove:[this.a]}):n.registerConfiguration(t),this.a=t}h(){const n=this.f.getValue(e.$DL);this.b=n?this.c.profiles.find(t=>t.name===n):void 0}j(){const n=this.f.getValue(e.$DL);if(!n)return;const t=this.b?this.c.profiles.find(o=>o.id===this.b.id):void 0;n!==t?.name&&this.f.updateValue(e.$DL,t?.name)}};e.$EL=a,e.$EL=a=Ke([We(0,E.$Pl),We(1,R.$cj)],a)}),define(Re[265],Te([1,0,41,15,22,24,9,264,53,3,29]),function(we,e,v,D,P,N,R,O,p,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$GL=e.$FL=void 0,e.$HL=r,e.$IL=l,v=qe(v),e.$FL=(0,s.$Ii)("editorResolverService"),e.$GL="workbench.editorAssociations";const b=I.$vo.as(p.$Ao.Configuration),h={...O.$wL,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(12209,null),additionalProperties:{type:"string"}}}};b.registerConfiguration(h);var E;(function(d){d.builtin="builtin",d.option="option",d.exclusive="exclusive",d.default="default"})(E||(e.RegisteredEditorPriority=E={}));var f;(function(d){d[d.ABORT=1]="ABORT",d[d.NONE=2]="NONE"})(f||(e.ResolvedStatus=f={}));function r(d){switch(d){case E.exclusive:return 5;case E.default:return 4;case E.builtin:return 3;case E.option:default:return 1}}function l(d,a){if(new Set([D.Schemas.extension,D.Schemas.webviewPanel,D.Schemas.vscodeWorkspaceTrust,D.Schemas.vscodeSettings]).has(a.scheme))return!1;const t=typeof d=="string"&&d.indexOf(P.$jc.sep)>=0?`${a.scheme}:${a.path}`:(0,N.$gh)(a);return v.$Ck(typeof d=="string"?d.toLowerCase():d,t.toLowerCase())}}),define(Re[266],Te([1,0,73,15,22,23,24,2,3,185,49,204,131]),function(we,e,v,D,P,N,R,O,p,s,I,b,h){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$FN=e.$EN=void 0,e.$EN=(0,p.$Ii)("pathService");let f=E=class{constructor(l,d,a,i){this.d=l,this.e=d,this.f=a,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||N.OS)(),this.b=(async()=>{const n=await this.e.getEnvironment();return this.c=n?.userHome??l})()}hasValidBasename(l,d,a){return typeof d=="string"||typeof d>"u"?this.a.then(i=>this.h(l,i,d)):this.h(l,d,a)}h(l,d,a){return l.scheme===D.Schemas.file||l.scheme===D.Schemas.vscodeRemote?(0,v.$Fg)(a??(0,R.$gh)(l),d===N.OperatingSystem.Windows):!0}get defaultUriScheme(){return E.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(l,d){if(l.remoteAuthority)return D.Schemas.vscodeRemote;const a=(0,s.$BN)(d.getWorkspace());if(a)return a;const i=d.getWorkspace().folders[0];if(i)return i.uri.scheme;const n=d.getWorkspace().configuration;return n?n.scheme:D.Schemas.file}userHome(l){return l?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(l=>l===N.OperatingSystem.Windows?P.$ic:P.$jc)}async fileURI(l){let d="";if(await this.a===N.OperatingSystem.Windows&&(l=l.replace(/\\/g,"/")),l[0]==="/"&&l[1]==="/"){const i=l.indexOf("/",2);i===-1?(d=l.substring(2),l="/"):(d=l.substring(2,i),l=l.substring(i)||"/")}return O.URI.from({scheme:D.Schemas.file,authority:d,path:l,query:"",fragment:""})}};e.$FN=f,e.$FN=f=E=Ke([We(1,h.$Zm),We(2,b.$nN),We(3,I.$Ri)],f)}),define(Re[58],Te([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.ExcludeSettingOptions=e.$gM=e.$fM=e.$eM=e.$dM=void 0;class v{constructor(s,I){this.line=s,this.character=I}isBefore(s){return!1}isBeforeOrEqual(s){return!1}isAfter(s){return!1}isAfterOrEqual(s){return!1}isEqual(s){return!1}compareTo(s){return 0}translate(s,I){return new v(0,0)}with(s){return new v(0,0)}}e.$dM=v;class D{constructor(s,I,b,h){this.isEmpty=!1,this.isSingleLine=!1,this.start=new v(s,I),this.end=new v(b,h)}contains(s){return!1}isEqual(s){return!1}intersection(s){}union(s){return new D(0,0,0,0)}with(s){return new D(0,0,0,0)}}e.$eM=D;class P{constructor(s,I,b){this.uri=s,this.ranges=I,this.previewText=b}}e.$fM=P;class N{constructor(s,I,b){this.uri=s,this.text=I,this.lineNumber=b}}e.$gM=N;var R;(function(p){p[p.None=1]="None",p[p.FilesExclude=2]="FilesExclude",p[p.SearchAndFilesExclude=3]="SearchAndFilesExclude"})(R||(e.ExcludeSettingOptions=R={}));var O;(function(p){p[p.Information=1]="Information",p[p.Warning=2]="Warning"})(O||(e.TextSearchCompleteMessageType=O={}))}),define(Re[44],Te([1,0,17,41,25,73,13,3,22,12,58,10]),function(we,e,v,D,P,N,R,O,p,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GM=e.$EM=e.$xM=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$uM=e.$tM=e.$sM=e.$rM=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.TextSearchCompleteMessageType=void 0,e.$oM=d,e.$pM=a,e.$qM=i,e.$vM=k,e.$wM=y,e.$yM=$,e.$zM=w,e.$AM=M,e.$BM=A,e.$CM=L,e.$DM=J,e.$FM=z,e.$HM=ie,e.$IM=le,e.$JM=oe,D=qe(D),P=qe(P),N=qe(N),p=qe(p),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return I.TextSearchCompleteMessageType}}),e.$hM="workbench.view.search",e.$iM="workbench.panel.search",e.$jM="workbench.view.search",e.$kM="search-result",e.$lM="search.exclude",e.$mM=2e4;const h="\u27EA ",E=" characters skipped \u27EB",f=(h.length+E.length+5)*2;e.$nM=(0,O.$Ii)("searchService");var r;(function(re){re[re.file=0]="file",re[re.text=1]="text",re[re.aiText=2]="aiText"})(r||(e.SearchProviderType=r={}));var l;(function(re){re[re.File=1]="File",re[re.Text=2]="Text",re[re.aiText=3]="aiText"})(l||(e.QueryType=l={}));function d(re){return!!re.rangeLocations&&!!re.previewText}function a(re){return!!re.resource}function i(re){return!!re.message}var n;(function(re){re[re.Normal=0]="Normal",re[re.NewSearchStarted=1]="NewSearchStarted"})(n||(e.SearchCompletionExitCode=n={}));class t{constructor(ce){this.resource=ce,this.results=[]}}e.$rM=t;class o{constructor(ce,x,$e,Pe){this.rangeLocations=[],this.webviewIndex=Pe;const X=Array.isArray(x)?x:[x];if($e&&$e.matchLines===1&&c(X)){ce=(0,R.$ag)(ce,$e.matchLines);let q="",ne=0,be=0;const Ie=Math.floor($e.charsPerLine/5);for(const Fe of X){const Be=Math.max(Fe.startColumn-Ie,0),xe=Fe.startColumn+$e.charsPerLine;if(Be>be+Ie+f){const nt=h+(Be-be)+E;q+=nt+ce.slice(Be,xe),ne+=Be-(be+nt.length)}else q+=ce.slice(be,xe);be=xe,this.rangeLocations.push({source:Fe,preview:new g(0,Fe.startColumn-ne,Fe.endColumn-ne)})}this.previewText=q}else{const q=Array.isArray(x)?x[0].startLineNumber:x.startLineNumber,ne=(0,v.$3b)(x,be=>({preview:new m(be.startLineNumber-q,be.startColumn,be.endLineNumber-q,be.endColumn),source:be}));this.rangeLocations=Array.isArray(ne)?ne:[ne],this.previewText=ce}}}e.$sM=o;function c(re){const ce=re[0].startLineNumber;for(const x of re)if(x.startLineNumber!==ce||x.endLineNumber!==ce)return!1;return!0}class m{constructor(ce,x,$e,Pe){this.startLineNumber=ce,this.startColumn=x,this.endLineNumber=$e,this.endColumn=Pe}}e.$tM=m;class g extends m{constructor(ce,x,$e){super(ce,x,ce,$e)}}e.$uM=g;var u;(function(re){re.List="list",re.Tree="tree"})(u||(e.ViewMode=u={}));var S;(function(re){re.Default="default",re.FileNames="fileNames",re.Type="type",re.Modified="modified",re.CountDescending="countDescending",re.CountAscending="countAscending"})(S||(e.SearchSortOrder=S={}));function k(re,ce=!0){const x=re&&re.files&&re.files.exclude,$e=ce&&re&&re.search&&re.search.exclude;if(!x&&!$e)return;if(!x||!$e)return x||$e||void 0;let Pe=Object.create(null);return Pe=P.$lo(Pe,P.$io(x)),Pe=P.$lo(Pe,P.$io($e),!0),Pe}function y(re,ce){return re.excludePattern&&D.$Ck(re.excludePattern,ce)?!1:re.includePattern||re.usingSearchPaths?re.includePattern&&D.$Ck(re.includePattern,ce)?!0:re.usingSearchPaths?!!re.folderQueries&&re.folderQueries.some(x=>{const $e=x.folder.fsPath;if(N.$Hg(ce,$e)){const Pe=p.$oc($e,ce);return!x.includePattern||!!D.$Ck(x.includePattern,Pe)}else return!1}):!1:!0}var C;(function(re){re[re.unknownEncoding=1]="unknownEncoding",re[re.regexParseError=2]="regexParseError",re[re.globParseError=3]="globParseError",re[re.invalidLiteral=4]="invalidLiteral",re[re.rgProcessError=5]="rgProcessError",re[re.other=6]="other",re[re.canceled=7]="canceled"})(C||(e.SearchErrorCode=C={}));class T extends Error{constructor(ce,x){super(ce),this.code=x}}e.$xM=T;function $(re){const ce=re.message;if((0,s.$6)(re))return new T(ce,C.canceled);try{const x=JSON.parse(ce);return new T(x.message,x.code)}catch{return new T(ce,C.other)}}function w(re){const ce={message:re.message,code:re.code};return new Error(JSON.stringify(ce))}function M(re){return re.type==="error"?!0:re.type==="success"}function A(re){return re.type==="success"}function L(re){return!!re.path}function J(re,ce,x=!0){const $e=re.searchPath?re.searchPath:re.relativePath;return x?(0,R.$0f)($e,ce):D.$Ck(ce,$e)}class Y{constructor(ce){this.path=ce,this.results=[]}addMatch(ce){this.results.push(ce)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$EM=Y;function z(re,ce){const x={...re||{},...ce||{}};return Object.keys(x).filter($e=>{const Pe=x[$e];return typeof Pe=="boolean"&&Pe})}class Q{constructor(ce,x){this.c=null,this.a=x.excludePattern?.map(Pe=>({...ce.excludePattern||{},...Pe.pattern||{}}))??[],this.a.length===0&&(this.a=[ce.excludePattern||{}]),this.b=this.a.map(Pe=>D.$Dk(Pe));let $e=ce.includePattern;x.includePattern&&($e?$e={...$e,...x.includePattern}:$e=x.includePattern),$e&&(this.c=D.$Dk($e))}d(ce,x,$e){let Pe=null;for(const X of this.b){const q=X(ce,x,$e);if(typeof q=="string"){Pe=q;break}}return Pe}matchesExcludesSync(ce,x,$e){return!!(this.b&&this.d(ce,x,$e))}includedInQuerySync(ce,x,$e){return!(this.b&&this.d(ce,x,$e)||this.c&&!this.c(ce,x,$e))}includedInQuery(ce,x,$e){const Pe=()=>this.c?!!this.c(ce,x,$e):!0;return Promise.all(this.b.map(X=>{const q=X(ce,x,$e);return(0,b.$uh)(q)?q.then(ne=>ne?!1:Pe()):Pe()})).then(X=>X.some(q=>!!q))}hasSiblingExcludeClauses(){return this.a.reduce((ce,x)=>V(x)||ce,!1)}}e.$GM=Q;function V(re){for(const ce in re)if(typeof re[ce]!="boolean")return!0;return!1}function ie(re){if(!re)return;let ce;return x=>(ce||(ce=(re()||Promise.resolve([])).then($e=>$e?_($e):{})),ce.then($e=>!!$e[x]))}function le(re){if(!re)return;let ce;return x=>{if(!ce){const $e=re();ce=$e?_($e):{}}return!!ce[x]}}function _(re){const ce={};for(const x of re)ce[x]=!0;return ce}function oe(re){return re.flatMap(ce=>ce.patterns.map(x=>ce.baseUri?{baseUri:ce.baseUri,pattern:x}:x))}}),define(Re[45],Te([1,0,17,10,19,6,4,48,15,141,24,13,2,9,28,3,11,173,49,50,26,16,8,7,65,44,5,33,58]),function(we,e,v,D,P,N,R,O,p,s,I,b,h,E,f,r,l,d,a,i,n,t,o,c,m,g,u,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vqc=e.$Uqc=void 0;function y(Y,z,Q){return new I.$$g(V=>w(V,Q)).isEqual(Y,z)}function C(Y,z,Q){return y(Y.uri,z.uri,Q)?0:(0,b.$Bf)(Y.uri.toString(),z.uri.toString())}function T(Y,z,Q){return Y.index!==z.index?Y.index<z.index?-1:1:y(Y.uri,z.uri,Q)?(0,b.$Bf)(Y.name,z.name):(0,b.$Bf)(Y.uri.toString(),z.uri.toString())}function $(Y,z,Q,V){const ie=Y.slice(0).sort((_,oe)=>Q(_,oe,V)),le=z.slice(0).sort((_,oe)=>Q(_,oe,V));return(0,v.$Gb)(ie,le,(_,oe)=>Q(_,oe,V))}function w(Y,z){const Q=z.getCapabilities(Y.scheme);return!(Q&&Q&f.FileSystemProviderCapabilities.PathCaseSensitive)}class M extends a.$2i{static toExtHostWorkspace(z,Q,V,ie){if(!z)return{workspace:null,added:[],removed:[]};const{id:le,name:_,folders:oe,configuration:re,transient:ce,isUntitled:x}=z,$e=[],Pe=Q;Q?oe.forEach((be,Ie)=>{const Fe=h.URI.revive(be.uri),Be=M.o(V||Q,Fe,ie);Be?(Be.name=be.name,Be.index=be.index,$e.push(Be)):$e.push({uri:Fe,name:be.name,index:Ie})}):$e.push(...oe.map(({uri:be,name:Ie,index:Fe})=>({uri:h.URI.revive(be),name:Ie,index:Fe}))),$e.sort((be,Ie)=>be.index<Ie.index?-1:1);const X=new M(le,_,$e,!!ce,re?h.URI.revive(re):null,!!x,be=>w(be,ie)),{added:q,removed:ne}=$(Pe?Pe.workspaceFolders:[],X.workspaceFolders,C,ie);return{workspace:X,added:q,removed:ne}}static o(z,Q,V){for(let ie=0;ie<z.folders.length;ie++){const le=z.workspaceFolders[ie];if(y(le.uri,Q,V))return le}}constructor(z,Q,V,ie,le,_,oe){super(z,V.map(re=>new a.$3i(re)),ie,le,oe),this.t=Q,this.u=_,this.q=[],this.s=O.$Oi.forUris(oe,()=>!0),V.forEach(re=>{this.q.push(re),this.s.set(re.uri,re)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(z,Q){return Q&&this.s.get(z)&&(z=(0,I.$ih)(z)),this.s.findSubstr(z)}resolveWorkspaceFolder(z){return this.s.get(z)}}let A=class{constructor(z,Q,V,ie,le){this.c=new N.$oe,this.onDidChangeWorkspace=this.c.event,this.g=new N.$oe,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.B=0,this.C=new N.$qe,this.D=new Map,this.h=ie,this.s=V,this.t=le,this.j=new s.$Qm,this.k=new D.$Hh,this.o=z.getProxy(u.$3N.MainThreadWorkspace),this.q=z.getProxy(u.$3N.MainThreadMessageService);const _=Q.workspace;this.l=_?new M(_.id,_.name,[],!!_.transient,_.configuration?h.URI.revive(_.configuration):null,!!_.isUntitled,oe=>w(oe,V)):void 0}$initializeWorkspace(z,Q){this.v=Q,this.$acceptWorkspaceData(z),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?h.URI.from({scheme:p.Schemas.untitled,path:(0,I.$gh)((0,I.$ih)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(z,Q,V,...ie){const le=[];if(Array.isArray(ie)&&ie.forEach(x=>{h.URI.isUri(x.uri)&&!le.some($e=>y($e.uri,x.uri,this.s))&&le.push({uri:x.uri,name:x.name||(0,I.$fh)(x.uri)})}),this.n||[Q,V].some(x=>typeof x!="number"||x<0)||V===0&&le.length===0)return!1;const _=this.x?this.x.workspaceFolders:[];if(Q+V>_.length)return!1;const oe=_.slice(0);oe.splice(Q,V,...le.map(x=>({uri:x.uri,name:x.name||(0,I.$fh)(x.uri),index:void 0})));for(let x=0;x<oe.length;x++){const $e=oe[x];if(oe.some((Pe,X)=>X!==x&&y($e.uri,Pe.uri,this.s)))return!1}oe.forEach((x,$e)=>x.index=$e);const{added:re,removed:ce}=$(_,oe,T,this.s);if(re.length===0&&ce.length===0)return!1;if(this.o){const x=z.displayName||z.name;this.o.$updateWorkspaceFolders(x,Q,V,le).then(void 0,$e=>{this.n=void 0;const Pe={source:{identifier:z.identifier,label:z.displayName||z.name}};this.q.$showMessage(d.Severity.Error,(0,E.localize)(2718,null,x,$e.toString()),Pe,[])})}return this.y(oe),!0}getWorkspaceFolder(z,Q){if(this.x)return this.x.getWorkspaceFolder(z,Q)}async getWorkspaceFolder2(z,Q){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(z,Q)}async resolveWorkspaceFolder(z){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(z)}getPath(){if(!this.x)return;const{folders:z}=this.x;if(z.length!==0)return z[0].uri.fsPath}getRelativePath(z,Q){let V,ie="";if(typeof z=="string"?(V=h.URI.file(z),ie=z):typeof z<"u"&&(V=z,ie=z.fsPath),!V)return ie;const le=this.getWorkspaceFolder(V,!0);if(!le)return ie;typeof Q>"u"&&this.x&&(Q=this.x.folders.length>1);let _=(0,I.$lh)(le.uri,V);return Q&&le.name&&(_=`${le.name}/${_}`),_}y(z){this.x&&(this.n=M.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:z,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(z){const{workspace:Q,added:V,removed:ie}=M.toExtHostWorkspace(z,this.l,this.n,this.s);this.l=Q||void 0,this.n=void 0,this.c.fire(Object.freeze({added:V,removed:ie}))}findFiles(z,Q,V,ie,le=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${ie.value}, entryPoint: findFiles`);let _="",oe=!0;return Q===null?oe=!1:Q!==void 0&&(typeof Q=="string"?_=Q:_=Q.pattern),this.z(z,void 0,{exclude:[_],maxResults:V,useExcludeSettings:oe?k.ExcludeSettingOptions.FilesExclude:k.ExcludeSettingOptions.None,useIgnoreFiles:{local:!1}},le)}findFiles2(z,Q={},V,ie=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${V.value}, entryPoint: findFiles2`);const le=Q.useDefaultExcludes??!0,_=Q.useDefaultSearchExcludes??!0,oe=le?_?k.ExcludeSettingOptions.SearchAndFilesExclude:k.ExcludeSettingOptions.FilesExclude:k.ExcludeSettingOptions.None,re={exclude:Q.exclude?[Q.exclude]:void 0,useIgnoreFiles:{local:Q.useIgnoreFiles,global:Q.useGlobalIgnoreFiles,parent:Q.useParentIgnoreFiles},useExcludeSettings:oe,followSymlinks:Q.followSymlinks,maxResults:Q.maxResults};return this.z(void 0,z!==void 0?[z]:[],re,ie)}findFiles2New(z,Q={},V,ie=P.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2New: fileSearch, extension: ${V.value}, entryPoint: findFiles2New`),this.z(void 0,z,Q,ie)}async z(z,Q,V,ie=P.CancellationToken.None){if(ie&&ie.isCancellationRequested)return Promise.resolve([]);const _=(z!==void 0?[z]:Q)?.map(oe=>{const re=J(V.exclude),ce={ignoreSymlinks:typeof V.followSymlinks=="boolean"?!V.followSymlinks:void 0,disregardIgnoreFiles:typeof V.useIgnoreFiles?.local=="boolean"?!V.useIgnoreFiles.local:void 0,disregardGlobalIgnoreFiles:typeof V.useIgnoreFiles?.global=="boolean"?!V.useIgnoreFiles.global:void 0,disregardParentIgnoreFiles:typeof V.useIgnoreFiles?.parent=="boolean"?!V.useIgnoreFiles.parent:void 0,disregardExcludeSettings:V.useExcludeSettings!==void 0&&V.useExcludeSettings===k.ExcludeSettingOptions.None,disregardSearchExcludeSettings:V.useExcludeSettings!==void 0&&V.useExcludeSettings!==k.ExcludeSettingOptions.SearchAndFilesExclude,maxResults:V.maxResults,excludePattern:re.length>0?re:void 0,_reason:"startFileSearch",shouldGlobSearch:z?void 0:!0},x=L(o.GlobPattern.from(oe)),$e=x?.folder;return z?ce.includePattern=x?.pattern:ce.filePattern=x?.pattern,{folder:$e,options:ce}})??[];return this.A(_,ie)}async A(z,Q){return(await Promise.all(z?.map(ie=>this.o.$startFileSearch(ie.folder??null,ie.options,Q).then(le=>Array.isArray(le)?le.map(_=>h.URI.revive(_)):[]))??[])).flat()}findTextInFilesNew(z,Q,V,ie){this.h.trace(`extHostWorkspace#findTextInFilesNew: textSearch, extension: ${Q.value}, entryPoint: findTextInFilesNew`);const _=(V?.include?.map(ce=>{const x=L(o.GlobPattern.from(ce)),$e=J(V.exclude);return{options:{ignoreSymlinks:typeof V.followSymlinks=="boolean"?!V.followSymlinks:void 0,disregardIgnoreFiles:typeof V.useIgnoreFiles=="boolean"?!V.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof V.useIgnoreFiles?.global=="boolean"?!V.useIgnoreFiles?.global:void 0,disregardParentIgnoreFiles:typeof V.useIgnoreFiles?.parent=="boolean"?!V.useIgnoreFiles?.parent:void 0,disregardExcludeSettings:V.useExcludeSettings!==void 0&&V.useExcludeSettings===k.ExcludeSettingOptions.None,disregardSearchExcludeSettings:V.useExcludeSettings!==void 0&&V.useExcludeSettings!==k.ExcludeSettingOptions.SearchAndFilesExclude,fileEncoding:V.encoding,maxResults:V.maxResults,previewOptions:V.previewOptions?{matchLines:V.previewOptions?.numMatchLines??100,charsPerLine:V.previewOptions?.charsPerLine??1e4}:void 0,surroundingContext:V.surroundingContext,includePattern:x?.pattern,excludePattern:$e},folder:x?.folder}})??[]).filter(ce=>!!ce),oe=Promise.resolve(void 0);return{results:new D.$9h(async ce=>{const x=($e,Pe)=>((0,g.$oM)($e)?ce.emitOne(new k.$fM(Pe,$e.rangeLocations.map(X=>({previewRange:new c.$7N(X.preview.startLineNumber,X.preview.startColumn,X.preview.endLineNumber,X.preview.endColumn),sourceRange:new c.$7N(X.source.startLineNumber,X.source.startColumn,X.source.endLineNumber,X.source.endColumn)})),$e.previewText)):ce.emitOne(new k.$gM(Pe,$e.text,$e.lineNumber)),$e);await oe.then($e=>this.findTextInFilesBase(z,_,x,ie))}),complete:oe.then(ce=>({limitHit:ce?.limitHit??!1}))}}async findTextInFilesBase(z,Q,V,ie=P.CancellationToken.None){const le=this.j.getNext(),_=!1;if(this.u[le]=oe=>{if(_)return;const re=h.URI.revive(oe.resource);oe.results.forEach(ce=>{const x=(0,S.$fi)(ce);V(x,re)})},ie.isCancellationRequested)return{};try{const oe=await Promise.all(Q?.map(re=>this.o.$startTextSearch(z,re.folder??null,re.options,le,ie)||{})??[]);return delete this.u[le],oe.reduce((re,ce)=>({limitHit:re?.limitHit||(ce?.limitHit??!1),message:[re?.message??[],ce?.message??[]].flat()}),{})??{limitHit:!1}}catch(oe){throw delete this.u[le],oe}}async findTextInFiles(z,Q,V,ie,le=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${ie.value}, entryPoint: findTextInFiles`);const _=typeof Q.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:Q.previewOptions,oe=L(o.GlobPattern.from(Q.include)),re=typeof Q.exclude=="string"?Q.exclude:Q.exclude?Q.exclude.pattern:void 0,ce={ignoreSymlinks:typeof Q.followSymlinks=="boolean"?!Q.followSymlinks:void 0,disregardIgnoreFiles:typeof Q.useIgnoreFiles=="boolean"?!Q.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof Q.useGlobalIgnoreFiles=="boolean"?!Q.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof Q.useParentIgnoreFiles=="boolean"?!Q.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof Q.useDefaultExcludes=="boolean"?!Q.useDefaultExcludes:!0,disregardSearchExcludeSettings:typeof Q.useSearchExclude=="boolean"?!Q.useSearchExclude:!0,fileEncoding:Q.encoding,maxResults:Q.maxResults,previewOptions:_,surroundingContext:Q.afterContext,includePattern:oe?.pattern,excludePattern:re?[{pattern:re}]:void 0},x=($e,Pe)=>{(0,g.$oM)($e)?V({uri:Pe,preview:{text:$e.previewText,matches:(0,v.$3b)($e.rangeLocations,X=>new c.$7N(X.preview.startLineNumber,X.preview.startColumn,X.preview.endLineNumber,X.preview.endColumn))},ranges:(0,v.$3b)($e.rangeLocations,X=>new c.$7N(X.source.startLineNumber,X.source.startColumn,X.source.endLineNumber,X.source.endColumn))}):V({uri:Pe,text:$e.text,lineNumber:$e.lineNumber})};return this.findTextInFilesBase(z,[{options:ce,folder:oe?.folder}],x,le)}$handleTextSearchResult(z,Q){this.u[Q]?.(z)}async save(z){const Q=await this.o.$save(z,{saveAs:!1});return h.URI.revive(Q)}async saveAs(z){const Q=await this.o.$save(z,{saveAs:!0});return h.URI.revive(Q)}saveAll(z){return this.o.$saveAll(z)}resolveProxy(z){return this.o.$resolveProxy(z)}lookupAuthorization(z){return this.o.$lookupAuthorization(z)}lookupKerberosAuthorization(z){return this.o.$lookupKerberosAuthorization(z)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(z){return this.o.$requestWorkspaceTrust(z)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(z,Q){if(this.w.has(z))throw new Error(`A provider has already been registered for scheme ${z}`);this.w.set(z,Q);const V=this.t.transformOutgoingScheme(z),ie=this.B++;return this.o.$registerEditSessionIdentityProvider(ie,V),(0,R.$Vc)(()=>{this.w.delete(z),this.o.$unregisterEditSessionIdentityProvider(ie)})}async $getEditSessionIdentifier(z,Q){this.h.info("Getting edit session identifier for workspaceFolder",z);const V=await this.resolveWorkspaceFolder(h.URI.revive(z));if(!V){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",V);const ie=this.w.get(V.uri.scheme);if(this.h.info(`Provider for scheme ${V.uri.scheme} is defined: `,!!ie),!ie)return;const le=await ie.provideEditSessionIdentity(V,Q);if(this.h.info("Provider returned edit session identifier: ",le),!!le)return le}async $provideEditSessionIdentityMatch(z,Q,V,ie){this.h.info("Getting edit session identifier for workspaceFolder",z);const le=await this.resolveWorkspaceFolder(h.URI.revive(z));if(!le){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",le);const _=this.w.get(le.uri.scheme);if(this.h.info(`Provider for scheme ${le.uri.scheme} is defined: `,!!_),!_)return;const oe=await _.provideEditSessionIdentityMatch?.(Q,V,ie);if(this.h.info("Provider returned edit session identifier match result: ",oe),!!oe)return oe}getOnWillCreateEditSessionIdentityEvent(z){return(Q,V,ie)=>{const le=function(oe){Q.call(V,oe)};return le.extension=z,this.C.event(le,void 0,ie)}}async $onWillCreateEditSessionIdentity(z,Q,V){const ie=await this.resolveWorkspaceFolder(h.URI.revive(z));if(ie===void 0)throw new Error("Unable to resolve workspace folder");await this.C.fireAsync({workspaceFolder:ie},Q,async(le,_)=>{const oe=Date.now();await Promise.resolve(le),Date.now()-oe>V&&this.h.warn("SLOW edit session create-participant",_.extension.identifier)}),Q.isCancellationRequested}registerCanonicalUriProvider(z,Q){if(this.D.has(z))throw new Error(`A provider has already been registered for scheme ${z}`);this.D.set(z,Q);const V=this.t.transformOutgoingScheme(z),ie=this.B++;return this.o.$registerCanonicalUriProvider(ie,V),(0,R.$Vc)(()=>{this.D.delete(z),this.o.$unregisterCanonicalUriProvider(ie)})}async provideCanonicalUri(z,Q,V){const ie=this.D.get(z.scheme);if(!ie)return;const le=await ie.provideCanonicalUri?.(h.URI.revive(z),Q,V);if(le)return le}async $provideCanonicalUri(z,Q,V){return this.provideCanonicalUri(h.URI.revive(z),{targetScheme:Q},V)}};e.$Uqc=A,e.$Uqc=A=Ke([We(0,t.$DQ),We(1,n.$TQ),We(2,i.$Dqc),We(3,l.$dk),We(4,m.$Sqc)],A),e.$Vqc=(0,r.$Ii)("IExtHostWorkspace");function L(Y){let z,Q;if(Y)return typeof Y=="string"?z=Y:(z=Y.pattern,Q=h.URI.revive(Y.baseUri)),{pattern:z,folder:Q}}function J(Y){return(Y?.map(z=>{if(typeof z=="string")return z===""?void 0:{pattern:z,uri:void 0};{const Q=L(z);return Q?{pattern:Q.pattern,uri:Q.folder}:void 0}})??[]).filter(z=>!!z)}}),define(Re[46],Te([1,0,25,6,45,5,7,43,174,53,14,10,3,16,11,2]),function(we,e,v,D,P,N,R,O,p,s,I,b,h,E,f,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yqc=e.$Xqc=e.$Wqc=void 0;function l(m,g){if(g){const u=g.split(".");let S=m;for(let k=0;S&&k<u.length;k++)S=S[u[k]];return S}}function d(m){return m instanceof r.URI}function a(m){return m&&m.uri instanceof r.URI&&m.languageId&&typeof m.languageId=="string"}function i(m){return m&&!m.uri&&m.languageId&&typeof m.languageId=="string"}function n(m){return m&&m.uri instanceof r.URI&&(!m.name||typeof m.name=="string")&&(!m.index||typeof m.index=="number")}function t(m){if(d(m))return{resource:m};if(a(m))return{resource:m.uri,overrideIdentifier:m.languageId};if(i(m))return{overrideIdentifier:m.languageId};if(n(m))return{resource:m.uri};if(m===null)return{resource:null}}let o=class{constructor(g,u,S){this.a=g.getProxy(N.$3N.MainThreadConfiguration),this.c=u,this.b=S,this.d=new b.$Hh,this.e=null}getConfigProvider(){return this.d.wait().then(g=>this.e)}$initializeConfiguration(g){this.e=new c(this.a,this.c,g,this.b),this.d.open()}$acceptConfigurationChanged(g,u){this.getConfigProvider().then(S=>S.$acceptConfigurationChanged(g,u))}};e.$Wqc=o,e.$Wqc=o=Ke([We(0,E.$DQ),We(1,P.$Vqc),We(2,f.$dk)],o);class c{constructor(g,u,S,k){this.a=new D.$oe,this.b=g,this.f=k,this.c=u,this.e=p.$Vo.parse(S,k),this.d=this.k(S.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(g,u){const S={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$Vo.parse(g,this.f),this.d=this.k(g.configurationScopes),this.a.fire(this.j(u,S))}getConfiguration(g,u,S){const k=t(u)||{},y=this.g(g?l(this.e.getValue(void 0,k,this.c.workspace),g):this.e.getValue(void 0,k,this.c.workspace));g&&this.h(g,k,S?.identifier);function C($){if($==null)return null;if(typeof $=="boolean")return $?O.ConfigurationTarget.USER:O.ConfigurationTarget.WORKSPACE;switch($){case R.ConfigurationTarget.Global:return O.ConfigurationTarget.USER;case R.ConfigurationTarget.Workspace:return O.ConfigurationTarget.WORKSPACE;case R.ConfigurationTarget.WorkspaceFolder:return O.ConfigurationTarget.WORKSPACE_FOLDER}}const T={has($){return typeof l(y,$)<"u"},get:($,w)=>{this.h(g?`${g}.${$}`:$,k,S?.identifier);let M=l(y,$);if(typeof M>"u")M=w;else{let A;const L=(J,Y)=>{if((0,I.$jg)(J)){let z;const Q=()=>{A=A||(0,v.$io)(y),z=z||l(A,Y)};return new Proxy(J,{get:(V,ie)=>{if(typeof ie=="string"&&ie.toLowerCase()==="tojson")return Q(),()=>z;if(A)return z=z||l(A,Y),z[ie];const le=V[ie];return typeof ie=="string"?L(le,`${Y}.${ie}`):le},set:(V,ie,le)=>(Q(),z&&(z[ie]=le),!0),deleteProperty:(V,ie)=>(Q(),z&&delete z[ie],!0),defineProperty:(V,ie,le)=>(Q(),z&&Object.defineProperty(z,ie,le),!0)})}return Array.isArray(J)?(0,v.$io)(J):J};M=L(M,$)}return M},update:($,w,M,A)=>{$=g?`${g}.${$}`:$;const L=C(M);return w!==void 0?this.b.$updateConfigurationOption(L,$,w,k,A):this.b.$removeConfigurationOption(L,$,k,A)},inspect:$=>{$=g?`${g}.${$}`:$;const w=this.e.inspect($,k,this.c.workspace);if(w)return{key:$,defaultValue:(0,v.$io)(w.policy?.value??w.default?.value),globalValue:(0,v.$io)(w.user?.value??w.application?.value),workspaceValue:(0,v.$io)(w.workspace?.value),workspaceFolderValue:(0,v.$io)(w.workspaceFolder?.value),defaultLanguageValue:(0,v.$io)(w.default?.override),globalLanguageValue:(0,v.$io)(w.user?.override??w.application?.override),workspaceLanguageValue:(0,v.$io)(w.workspace?.override),workspaceFolderLanguageValue:(0,v.$io)(w.workspaceFolder?.override),languageIds:(0,v.$io)(w.overrideIdentifiers)}}};return typeof y=="object"&&(0,v.$lo)(T,y,!1),Object.freeze(T)}g(g){const u=S=>(0,I.$jg)(S)?new Proxy(S,{get:(k,y)=>u(k[y]),set:(k,y,C)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(y)}' of object`)},deleteProperty:(k,y)=>{throw new Error(`TypeError: Cannot delete read only property '${String(y)}' of object`)},defineProperty:(k,y)=>{throw new Error(`TypeError: Cannot define property '${String(y)}' for a readonly object`)},setPrototypeOf:k=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):S;return u(g)}h(g,u,S){const k=s.$Ko.test(g)?s.ConfigurationScope.RESOURCE:this.d.get(g),y=S?`[${S.value}] `:"";if(s.ConfigurationScope.RESOURCE===k){typeof u?.resource>"u"&&this.f.warn(`${y}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${g}', provide the URI of a resource or 'null' for any resource.`);return}if(s.ConfigurationScope.WINDOW===k){u?.resource&&this.f.warn(`${y}Accessing a window scoped configuration for a resource is not expected. To associate '${g}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(g,u){const S=new p.$Xo(g,u,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(k,y)=>S.affectsConfiguration(k,t(y))})}k(g){return g.reduce((u,S)=>(u.set(S[0],S[1]),u),new Map)}}e.$Xqc=c,e.$Yqc=(0,h.$Ii)("IExtHostConfiguration")}),define(Re[132],Te([1,0,2,10,6,5,7,45,57,46,19,56,16,26,3,15,23,11,85,208,12]),function(we,e,v,D,P,N,R,O,p,s,I,b,h,E,f,r,l,d,a,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bsc=e.$Asc=e.$zsc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,R=qe(R),l=qe(l);var t;(function(A){function L(Y){if(Y!=null)return Y}A.from=L;function J(Y){if(Y!=null)return Y}A.to=J})(t||(t={}));var o;(function(A){function L(Y){if(Y!=null)return Y}A.from=L;function J(Y){if(Y!=null)return Y}A.to=J})(o||(o={}));var c;(function(A){function L(Y){if(Y!=null)return Y}A.from=L;function J(Y){if(Y!=null)return Y}A.to=J})(c||(c={}));var m;(function(A){function L(z){if(z){const Q=z;return Q&&!!Q.process}else return!1}A.is=L;function J(z){if(z==null)return;const Q={process:z.process,args:z.args};return z.options&&(Q.options=c.from(z.options)),Q}A.from=J;function Y(z){if(z!=null)return new R.$QO(z.process,z.args,z.options)}A.to=Y})(m||(m={}));var g;(function(A){function L(Y){if(Y!=null)return Y}A.from=L;function J(Y){if(Y!=null)return Y}A.to=J})(g||(g={}));var u;(function(A){function L(z){if(z){const Q=z;return Q&&(!!Q.commandLine||!!Q.command)}else return!1}A.is=L;function J(z){if(z==null)return;const Q={};return z.commandLine!==void 0?Q.commandLine=z.commandLine:(Q.command=z.command,Q.args=z.args),z.options&&(Q.options=g.from(z.options)),Q}A.from=J;function Y(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new R.$RO(z.commandLine,z.options):new R.$RO(z.command,z.args?z.args:[],z.options)}A.to=Y})(u||(u={}));var S;(function(A){function L(z){if(z){const Q=z;return Q&&Q.customExecution==="customExecution"}else return!1}A.is=L;function J(z){return{customExecution:"customExecution"}}A.from=J;function Y(z,Q){return Q.get(z)}A.to=Y})(S||(e.CustomExecutionDTO=S={}));var k;(function(A){function L(J,Y){let z;return J.scope!==void 0&&typeof J.scope!="number"?z=J.scope.uri:J.scope!==void 0&&typeof J.scope=="number"&&(J.scope===R.TaskScope.Workspace&&Y&&Y.workspaceFile?z=Y.workspaceFile:z=i.$bJ),{id:J._id,workspaceFolder:z}}A.from=L})(k||(e.TaskHandleDTO=k={}));var y;(function(A){function L(J){if(J!=null)return{_id:J.id,isDefault:J.isDefault}}A.from=L})(y||(y={}));var C;(function(A){function L(z,Q){if(z==null)return[];const V=[];for(const ie of z){const le=J(ie,Q);le&&V.push(le)}return V}A.fromMany=L;function J(z,Q){if(z==null)return;let V;z.execution instanceof R.$QO?V=m.from(z.execution):z.execution instanceof R.$RO?V=u.from(z.execution):z.execution&&z.execution instanceof R.$SO&&(V=S.from(z.execution));const ie=t.from(z.definition);let le;return z.scope?typeof z.scope=="number"?le=z.scope:le=z.scope.uri:le=R.TaskScope.Workspace,!ie||!le?void 0:{_id:z._id,definition:ie,name:z.name,source:{extensionId:Q.identifier.value,label:z.source,scope:le},execution:V,isBackground:z.isBackground,group:y.from(z.group),presentationOptions:o.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}A.from=J;async function Y(z,Q,V){if(z==null)return;let ie;m.is(z.execution)?ie=m.to(z.execution):u.is(z.execution)?ie=u.to(z.execution):S.is(z.execution)&&(ie=S.to(z._id,V));const le=t.to(z.definition);let _;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?_=z.source.scope:_=await Q.resolveWorkspaceFolder(v.URI.revive(z.source.scope)):_=R.TaskScope.Workspace),!le||!_)return;const oe=new R.$TO(le,_,z.name,z.source.label,ie,z.problemMatchers);return z.isBackground!==void 0&&(oe.isBackground=z.isBackground),z.group!==void 0&&(oe.group=R.$PO.from(z.group._id),oe.group&&z.group.isDefault&&(oe.group=new R.$PO(oe.group.id,oe.group.label),z.group.isDefault===!0&&(oe.group.isDefault=z.group.isDefault))),z.presentationOptions&&(oe.presentationOptions=o.to(z.presentationOptions)),z._id&&(oe._id=z._id),z.detail&&(oe.detail=z.detail),oe}A.to=Y})(C||(e.TaskDTO=C={}));var T;(function(A){function L(Y){return Y}A.from=L;function J(Y){if(Y)return Object.assign(Object.create(null),Y)}A.to=J})(T||(T={}));class ${#e;constructor(L,J,Y){this._id=J,this.a=Y,this.#e=L}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(L){}fireDidEndProcess(L){}}let w=class{constructor(L,J,Y,z,Q,V,ie,le){this.q=new P.$oe,this.r=new P.$oe,this.s=new P.$oe,this.u=new P.$oe,this.a=L.getProxy(N.$3N.MainThreadTask),this.b=Y,this.c=z,this.d=Q,this.e=V,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ie,this.g=le,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(L,J,Y){if(!Y)return new R.$5N(()=>{});const z=this.x();return this.j.set(z,{type:J,provider:Y,extension:L}),this.a.$registerTaskProvider(z,J),new R.$5N(()=>{this.j.delete(z),this.a.$unregisterTaskProvider(z)})}registerTaskSystem(L,J){this.a.$registerTaskSystem(L,J)}fetchTasks(L){return this.a.$fetchTasks(T.from(L)).then(async J=>{const Y=[];for(const z of J){const Q=await C.to(z,this.b,this.m);Q&&Y.push(Q)}return Y})}get taskExecutions(){const L=[];return this.k.forEach(J=>L.push(J)),L}terminateTask(L){if(!(L instanceof $))throw new Error("No valid task execution provided");return this.a.$terminateTask(L._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(L,J,Y){const z=this.m.get(L.id);z&&(this.o.set(L.id,z),this.e.attachPtyToTerminal(J,await z.callback(Y))),this.p=L.id,this.q.fire({execution:await this.z(L)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(L){if(!this.l.has(L.id))return;const J=await this.z(L);this.l.delete(L.id),this.k.delete(L.id),this.B(L),this.r.fire({execution:J})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(L){const J=await this.z(L.id);this.s.fire({execution:J,processId:L.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(L){const J=await this.z(L.id);this.u.fire({execution:J,exitCode:L.exitCode})}$provideTasks(L,J){const Y=this.j.get(L);if(!Y)return Promise.reject(new Error("no handler found"));const z=[],Q=(0,D.$Ah)(()=>Y.provider.provideTasks(I.CancellationToken.None)).then(V=>this.v(J,z,Y,V));return new Promise(V=>{Q.then(ie=>{Promise.all(z).then(()=>{V(ie)})})})}async $resolveTask(L,J){const Y=this.j.get(L);if(!Y)return Promise.reject(new Error("no handler found"));if(J.definition.type!==Y.type)throw new Error(`Unexpected: Task of type [${J.definition.type}] cannot be resolved by provider of type [${Y.type}].`);const z=await C.to(J,this.b,this.m);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const Q=await Y.provider.resolveTask(z,I.CancellationToken.None);if(!Q)return;this.A(Q,Y);const V=C.from(Q,Y.extension);if(!V)throw new Error("Unexpected: Task cannot be resolved.");if(Q.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return S.is(V.execution)&&await this.y(V,Q,!0),await this.w(V)}x(){return this.h++}async y(L,J,Y){const z=await this.a.$createTaskId(L);!Y&&!this.m.has(z)&&(this.n.add(z),this.o.set(z,J.execution)),this.m.set(z,J.execution)}async z(L,J){if(typeof L=="string"){const Q=this.l.get(L);if(!Q)throw new n.$db("Unexpected: The specified task is missing an execution");return Q}const Y=this.l.get(L.id);if(Y)return Y;let z;return J?z=Promise.resolve(new $(this,L.id,J)):z=C.to(L.task,this.b,this.m).then(Q=>{if(!Q)throw new n.$db("Unexpected: Task does not exist.");return new $(this,L.id,Q)}),this.l.set(L.id,z),z.then(Q=>(this.k.set(L.id,Q),Q))}A(L,J){L._deprecated&&this.g.report("Task.constructor",J.extension,"Use the Task constructor that takes a `scope` instead.")}B(L){this.o.get(L.id)&&this.o.delete(L.id),this.n.has(L.id)&&this.p!==L.id&&(this.m.delete(L.id),this.n.delete(L.id));const Y=this.n.values();let z=Y.next();for(;!z.done;)!this.o.has(z.value)&&this.p!==z.value&&(this.m.delete(z.value),this.n.delete(z.value)),z=Y.next()}};e.$zsc=w,e.$zsc=w=Ke([We(0,h.$DQ),We(1,E.$TQ),We(2,O.$Vqc),We(3,p.$OQ),We(4,s.$Yqc),We(5,b.$krc),We(6,d.$dk),We(7,a.$zqc)],w);let M=class extends w{constructor(L,J,Y,z,Q,V,ie,le){super(L,J,Y,z,Q,V,ie,le),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:l.$i(l.Platform.Web)})}async executeTask(L,J){if(!J.execution)throw new Error("Tasks to execute must include an execution");const Y=C.from(J,L);if(Y===void 0)throw new Error("Task is not valid");if(S.is(Y.execution))await this.y(Y,J,!1);else throw new n.$bb;const z=await this.z(await this.a.$getTaskExecution(Y),J);return this.a.$executeTask(Y).catch(Q=>{throw new Error(Q)}),z}v(L,J,Y,z){const Q=[];if(z)for(const V of z){if(this.A(V,Y),!V.definition||!L[V.definition.type]){const le=V.source?V.source:"No task source";this.f.warn(`The task [${le}, ${V.name}] uses an undefined task type. The task will be ignored in the future.`)}const ie=C.from(V,Y.extension);ie&&S.is(ie.execution)?(Q.push(ie),J.push(this.y(ie,V,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:Q,extension:Y.extension}}async w(L){if(S.is(L.execution))return L;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(L,J){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(L,J,Y){}};e.$Asc=M,e.$Asc=M=Ke([We(0,h.$DQ),We(1,E.$TQ),We(2,O.$Vqc),We(3,p.$OQ),We(4,s.$Yqc),We(5,b.$krc),We(6,d.$dk),We(7,a.$zqc)],M),e.$Bsc=(0,f.$Ii)("IExtHostTask")}),define(Re[267],Te([1,0,44,32]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QM=void 0,e.$PM=P,e.$RM=N;function P(R){return"cellResults"in R}e.$QM="rawCell#";function N(R,O){let p=-1;const s=[];let I=[];return R.forEach(h=>{h.range.startLineNumber!==p&&I.length>0&&(s.push([...I]),I=[]),I.push(h),p=h.range.endLineNumber}),I.length>0&&s.push([...I]),s.map(h=>{const E=[],f=h[0].range.startLineNumber,r=h[h.length-1].range.endLineNumber;for(let l=f;l<=r;l++)E.push(O.getLineContent(l));return new v.$sM(E.join(`
`)+`
`,h.map(l=>new D.$Ut(l.range.startLineNumber-1,l.range.startColumn-1,l.range.endLineNumber-1,l.range.endColumn-1)))})}}),define(Re[268],Te([1,0,9,20,6,4,27,37,13,14,2,28,80,5,34,8,7,39,245,126,25,15,44,198,267,265]),function(we,e,v,D,P,N,R,O,p,s,I,b,h,E,f,r,l,d,a,i,n,t,o,c,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bsc=void 0,b=qe(b),r=qe(r),l=qe(l);class u{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(k=>k.apiEditor)}constructor(k,y,C,T,$,w,M){this.q=C,this.r=T,this.s=$,this.t=w,this.u=M,this.f=new Map,this.g=new R.$Dc,this.h=new Map,this.j=new P.$oe,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new P.$oe,this.onDidOpenNotebookDocument=this.m.event,this.n=new P.$oe,this.onDidCloseNotebookDocument=this.n.event,this.o=new P.$oe,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new h.$xqc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=k.getProxy(E.$3N.MainThreadNotebook),this.c=k.getProxy(E.$3N.MainThreadNotebookDocuments),this.d=k.getProxy(E.$3N.MainThreadNotebookEditors),this.i=y.converter,y.registerArgumentProcessor({processArgument:A=>{if(A&&A.$mid===O.MarshalledId.NotebookCellActionContext){const L=A.notebookEditor?.notebookUri,J=A.cell.handle,z=this.g.get(L)?.getCell(J);if(z)return z.apiCell}if(A&&A.$mid===O.MarshalledId.NotebookActionContext){const L=A.uri,J=this.g.get(L);if(J)return J.apiNotebook}return A}}),u.C(y)}getEditorById(k){const y=this.h.get(k);if(!y)throw new Error(`unknown text editor: ${k}. known editors: ${[...this.h.keys()]} `);return y}getIdByEditor(k){for(const[y,C]of this.h)if(C.apiEditor===k)return y}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(k,y){const C=this.g.get(k);if(!C&&!y)throw new Error(`NO notebook document for '${k}'`);return C}static w(k,y){if(!y)return;const C=y.filenamePattern.map(T=>r.NotebookExclusiveDocumentPattern.from(T)).filter(T=>T!==void 0);if(y.filenamePattern&&!C){console.warn(`Notebook content provider view options file name pattern is invalid ${y.filenamePattern}`);return}return{extension:k.identifier,providerDisplayName:k.displayName||k.name,displayName:y.displayName,filenamePattern:C,priority:y.exclusive?g.RegisteredEditorPriority.exclusive:void 0}}registerNotebookCellStatusBarItemProvider(k,y,C){const T=u.a++,$=typeof C.onDidChangeCellStatusBarItems=="function"?u.a++:void 0;this.f.set(T,C),this.b.$registerNotebookCellStatusBarItemProvider(T,$,y);let w;return $!==void 0&&(w=C.onDidChangeCellStatusBarItems(M=>this.b.$emitCellStatusBarEvent($))),new l.$5N(()=>{this.f.delete(T),this.b.$unregisterNotebookCellStatusBarItemProvider(T,$),w?.dispose()})}async createNotebookDocument(k){const y=await this.c.$tryCreateNotebook({viewType:k.viewType,content:k.content&&r.NotebookData.from(k.content)});return I.URI.revive(y)}async openNotebookDocument(k){const y=this.g.get(k);if(y)return y.apiNotebook;const C=await this.c.$tryOpenNotebook(k),T=this.g.get(I.URI.revive(C));return(0,s.$sg)(T?.apiNotebook)}async showNotebookDocument(k,y){let C;typeof y=="object"?C={position:r.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selections:y.selections&&y.selections.map(r.NotebookRange.from),pinned:typeof y.preview=="boolean"?!y.preview:void 0,label:y?.label}:C={preserveFocus:!1,pinned:!0};const T=y?.asRepl?"repl":k.notebookType,$=await this.d.$tryShowNotebookDocument(k.uri,T,C),w=$&&this.h.get($)?.apiEditor;if(w)return w;throw $?new Error(`Could NOT open editor for "${k.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${k.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(k,y,C,T){const $=this.f.get(k),w=I.URI.revive(y),M=this.g.get(w);if(!M||!$)return;const A=M.getCellFromIndex(C);if(!A)return;const L=await $.provideCellStatusBarItems(A.apiCell,T);if(!L)return;const J=new N.$Wc,Y=this.p.add([J]),Q=(Array.isArray(L)?L:[L]).map(V=>r.NotebookStatusBarItem.from(V,this.i,J));return{cacheId:Y,items:Q}}$releaseNotebookCellStatusBarItems(k){this.p.delete(k)}registerNotebookSerializer(k,y,C,T,$){if((0,p.$ff)(y))throw new Error("viewType cannot be empty or just whitespace");const w=this.x++;return this.y.set(w,{viewType:y,serializer:C,options:T}),this.b.$registerNotebookSerializer(w,{id:k.identifier,location:k.extensionLocation},y,r.NotebookDocumentContentOptions.from(T),u.w(k,$)),(0,N.$Vc)(()=>{this.b.$unregisterNotebookSerializer(w)})}async $dataToNotebook(k,y,C){const T=this.y.get(k);if(!T)throw new Error("NO serializer found");const $=await T.serializer.deserializeNotebook(y.buffer,C);return new d.$5w(r.NotebookData.from($))}async $notebookToData(k,y,C){const T=this.y.get(k);if(!T)throw new Error("NO serializer found");const $=await T.serializer.serializeNotebook(r.NotebookData.to(y.value),C);return D.$Qe.wrap($)}async $saveNotebook(k,y,C,T,$){const w=I.URI.revive(y),M=this.y.get(k);if(this.D(`enter saveNotebook(versionId: ${C}, ${w.toString()})`),!M)throw new Error("NO serializer found");const A=this.g.get(w);if(!A)throw new Error("Document NOT found");if(A.versionId!==C)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(w.scheme))throw new b.$yl((0,v.localize)(2709,null,this.A(w)),b.FileOperationResult.FILE_PERMISSION_DENIED);const L={metadata:(0,n.$qo)(A.apiNotebook.metadata,V=>!(M.options?.transientDocumentMetadata??{})[V]),cells:[]};for(const V of A.apiNotebook.getCells()){const ie=new l.$xP(V.kind,V.document.getText(),V.document.languageId,V.mime,M.options?.transientOutputs?[]:[...V.outputs],V.metadata,V.executionSummary);ie.metadata=(0,n.$qo)(V.metadata,le=>!(M.options?.transientCellMetadata??{})[le]),L.cells.push(ie)}if(await this.z(w,T),$.isCancellationRequested)throw new Error("canceled");const J=await M.serializer.serializeNotebook(L,$);if($.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${C} ${w.toString()}`),await this.s.value.writeFile(w,J),this.D(`Finished write versionId: ${C} ${w.toString()}`);const Y=this.s.getFileSystemProviderExtUri(w.scheme),z=await this.s.value.stat(w),Q={name:Y.basename(w),isFile:(z.type&b.FileType.File)!==0,isDirectory:(z.type&b.FileType.Directory)!==0,isSymbolicLink:(z.type&b.FileType.SymbolicLink)!==0,mtime:z.mtime,ctime:z.ctime,size:z.size,readonly:!!((z.permissions??0)&b.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(w.scheme),locked:!!((z.permissions??0)&b.FilePermission.Locked),etag:b.$Jl({mtime:z.mtime,size:z.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${C}, ${w.toString()})`),Q}async $searchInNotebooks(k,y,C,T,$){const w=this.y.get(k)?.serializer;if(!w)return{limitHit:!1,results:[]};const M=new R.$Ec;await(async(z,Q,V)=>{await Promise.all(z.map(async ie=>await Promise.all(ie.filenamePatterns.map(le=>{const _={_reason:V._reason,folderQueries:V.folderQueries,includePattern:V.includePattern,excludePattern:V.excludePattern,maxResults:V.maxResults,type:o.QueryType.File,filePattern:le};return this.t.doInternalFileSearchWithCustomCallback(_,Q,oe=>{oe.forEach(re=>{M.has(re)||T.some(x=>ie.isFromSettings&&!x.isFromSettings?!1:x.filenamePatterns.some($e=>(0,g.$IL)($e,re)))||M.add(re)})}).catch(oe=>{if(oe.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw oe})}))))})(C,$,y);const L=new R.$Dc;let J=!1;const Y=Array.from(M).map(async z=>{const Q=[];try{if($.isCancellationRequested)return;if(y.maxResults&&[...L.values()].reduce((_,oe)=>_+oe.cellResults.length,0)>y.maxResults){J=!0;return}const V=[],ie=this.g.get(z);if(ie)ie.apiNotebook.getCells().forEach(oe=>V.push({input:oe.document.getText(),outputs:oe.outputs.flatMap(re=>re.items.map(ce=>ce.data.toString()))}));else{const _=await this.s.value.readFile(z),oe=D.$Qe.fromString(_.toString()),re=await w.deserializeNotebook(oe.buffer,$);if($.isCancellationRequested)return;r.NotebookData.from(re).cells.forEach(x=>V.push({input:x.source,outputs:x.outputs.flatMap($e=>$e.items.map(Pe=>Pe.valueBytes.toString()))}))}if($.isCancellationRequested)return;V.forEach((_,oe)=>{const re=y.contentPattern.pattern,ce=new c.$r2b(_.input,void 0,_.outputs),x=ce.findInInputs(re),$e=ce.findInOutputs(re),Pe=$e.flatMap(X=>(0,m.$RM)(X.matches,X.textBuffer)).map((X,q)=>(X.webviewIndex=q,X));if(x.length>0||$e.length>0){const X={index:oe,contentResults:(0,m.$RM)(x,ce.inputTextBuffer),webviewResults:Pe};Q.push(X)}});const le={resource:z,cellResults:Q};L.set(z,le);return}catch{return}});return await Promise.all(Y),{limitHit:J,results:[...L.values()]}}async z(k,y){const C=await this.s.value.stat(k);if(typeof y?.mtime=="number"&&typeof y.etag=="string"&&y.etag!==b.$Il&&typeof C.mtime=="number"&&typeof C.size=="number"&&y.mtime<C.mtime&&y.etag!==b.$Jl({mtime:y.mtime,size:C.size}))throw new b.$yl((0,v.localize)(2710,null),b.FileOperationResult.FILE_MODIFIED_SINCE,y)}A(k){return k.scheme===t.Schemas.file?k.fsPath:k.toString()}B(k,y,C){if(this.h.has(y))throw new Error(`editor with id ALREADY EXSIST: ${y}`);const T=new i.$Zrc(y,this.d,k,C.visibleRanges.map(r.NotebookRange.to),C.selections.map(r.NotebookRange.to),typeof C.viewColumn=="number"?r.ViewColumn.to(C.viewColumn):void 0);this.h.set(y,T)}$acceptDocumentAndEditorsDelta(k){if(k.value.removedDocuments)for(const C of k.value.removedDocuments){const T=I.URI.revive(C),$=this.g.get(T);$&&($.dispose(),this.g.delete(T),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:$.apiNotebook.getCells().map(w=>w.document.uri)}),this.n.fire($.apiNotebook));for(const w of this.h.values())w.notebookData.uri.toString()===T.toString()&&this.h.delete(w.id)}if(k.value.addedDocuments){const C=[];for(const T of k.value.addedDocuments){const $=I.URI.revive(T.uri);if(this.g.has($))throw new Error(`adding EXISTING notebook ${$} `);const w=new a.$Yrc(this.c,this.q,this.r,$,T);C.push(...T.cells.map(M=>a.$Xrc.asModelAddData(M))),this.g.get($)?.dispose(),this.g.set($,w),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:C}),this.m.fire(w.apiNotebook)}}if(k.value.addedEditors)for(const C of k.value.addedEditors){if(this.h.has(C.id))return;const T=I.URI.revive(C.documentUri),$=this.g.get(T);$&&this.B($,C.id,C)}const y=[];if(k.value.removedEditors)for(const C of k.value.removedEditors){const T=this.h.get(C);T&&(this.h.delete(C),this.k?.id===T.id&&(this.k=void 0),y.push(T))}if(k.value.visibleEditors){this.l=k.value.visibleEditors.map(T=>this.h.get(T)).filter(T=>!!T);const C=new Set;this.l.forEach(T=>C.add(T.id));for(const T of this.h.values()){const $=C.has(T.id);T._acceptVisibility($)}this.l=[...this.h.values()].map(T=>T).filter(T=>T.visible),this.o.fire(this.visibleNotebookEditors)}k.value.newActiveEditor===null?this.k=void 0:k.value.newActiveEditor&&(this.h.get(k.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${k.value.newActiveEditor}`),this.k=this.h.get(k.value.newActiveEditor)),k.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(k){const y=f.$2Q.String.with("notebookType","A notebook type"),C=new f.$4Q("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[y,new f.$2Q("data","Bytes to convert to data",$=>$ instanceof Uint8Array,$=>D.$Qe.wrap($))],new f.$3Q("Notebook Data",$=>r.NotebookData.to($.value))),T=new f.$4Q("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[y,new f.$2Q("NotebookData","Notebook data to convert to bytes",$=>!0,$=>new d.$5w(r.NotebookData.from($)))],new f.$3Q("Bytes",$=>$.buffer));k.registerApiCommand(C),k.registerApiCommand(T)}D(k){this.u.trace(`[Extension Host Notebook] ${k}`)}}e.$bsc=u}),define(Re[269],Te([1,0,22,19,42,41,24,69,44,48]),function(we,e,v,D,P,N,R,O,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1rc=void 0,v=qe(v),N=qe(N),R=qe(R);class I{constructor(E,f,r){this.l=E,this.o=f,this.p=r,this.f=!1,this.g=0,this.h=!1,this.a=E.filePattern,this.b=E.includePattern&&N.$Dk(E.includePattern),this.c=E.maxResults||void 0,this.d=E.exists,this.j=new Set,this.k=E.excludePattern&&N.$Dk(E.excludePattern)}cancel(){this.h=!0,this.j.forEach(E=>E.cancel()),this.j=new Set}search(E){const f=this.l.folderQueries||[];return new Promise((r,l)=>{const d=a=>{this.g++,E(a)};if(this.h)return r({limitHit:this.f});this.l.extraFileResources&&this.l.extraFileResources.forEach(a=>{const i=a.toString(),n=v.$qc(i);this.k&&this.k(i,n)||this.w(d,{base:a,basename:n})}),this.q(f,d).then(a=>{r({limitHit:this.f,stats:a||void 0})},a=>{l(new Error((0,P.$tj)(a)))})})}async q(E,f){const r=new D.$ze,d={folderOptions:E.map(n=>this.r(n)),maxResults:this.l.maxResults??p.$mM,session:this.p},a=s.$Oi.forUris();E.forEach(n=>{const t=new p.$GM(this.l,n),o=!t.hasSiblingExcludeClauses();a.set(n.folder,{queryTester:t,noSiblingsClauses:o,folder:n.folder,tree:this.s()})});let i;try{this.j.add(r),i=O.$ie.create();const n=await this.o.provideFileSearchResults(this.l.filePattern||"",d,r.token),t=i.elapsed(),o=O.$ie.create();return this.h&&!this.f||(n&&n.forEach(c=>{const m=a.findSubstr(c),g=v.$jc.relative(m.folder.path,c.path);if(m.noSiblingsClauses){const u=v.$qc(c.path);this.w(f,{base:m.folder,relativePath:g,basename:u});return}this.u(m.tree,m.folder,g,f)}),this.h&&!this.f)?null:(a.forEach(c=>{this.v(c.tree,c.queryTester,f)}),{providerTime:t,postProcessTime:o.elapsed()})}finally{r.dispose(),this.j.delete(r)}}r(E){const f=(0,p.$FM)(this.l.includePattern,E.includePattern);let r=E.excludePattern?.map(d=>({folder:d.folder,patterns:(0,p.$FM)(this.l.excludePattern,d.pattern)}));r?.length||(r=[{folder:void 0,patterns:(0,p.$FM)(this.l.excludePattern,void 0)}]);const l=(0,p.$JM)(r);return{folder:E.folder,excludes:l,includes:f,useIgnoreFiles:{local:!E.disregardIgnoreFiles,parent:!E.disregardParentIgnoreFiles,global:!E.disregardGlobalIgnoreFiles},followSymlinks:!E.ignoreSymlinks}}s(){const E={rootEntries:[],pathToEntries:Object.create(null)};return E.pathToEntries["."]=E.rootEntries,E}u({pathToEntries:E},f,r,l){if(r===this.a){const a=v.$qc(this.a);this.w(l,{base:f,relativePath:this.a,basename:a})}function d(a){const i=v.$qc(a),n=v.$pc(a);let t=E[n];t||(t=E[n]=[],d(n)),t.push({base:f,relativePath:a,basename:i})}d(r)}v({rootEntries:E,pathToEntries:f},r,l){const d=this,a=this.a;function i(n){const t=(0,p.$IM)(()=>n.map(o=>o.basename));for(let o=0,c=n.length;o<c;o++){const m=n[o],{relativePath:g,basename:u}=m;if(r.matchesExcludesSync(g,u,a!==u?t:void 0))continue;const S=f[g];if(S)i(S);else{if(g===a)continue;d.w(l,m)}if(d.f)break}}i(E)}w(E,f){(!this.b||f.relativePath&&this.b(f.relativePath,f.basename))&&((this.d||this.c&&this.g>=this.c)&&(this.f=!0,this.cancel()),this.f||E(f))}}class b{constructor(){this.b=new Map}static{this.a=512}fileSearch(E,f,r,l){const d=this.c(E.cacheKey),a=new I(E,f,d&&d.token);let i=0;const n=t=>{i+=t.length,r(t.map(o=>this.d(o)))};return this.f(a,b.a,n,l).then(t=>({limitHit:t.limitHit,stats:t.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:t.stats}:void 0,messages:[]}))}clearCache(E){this.c(E)?.cancel()}c(E){if(E)return this.b.has(E)||this.b.set(E,new D.$ze),this.b.get(E)}d(E){return E.relativePath?{resource:R.$jh(E.base,E.relativePath)}:{resource:E.base}}f(E,f,r,l){const d=l.onCancellationRequested(()=>{E.cancel()}),a=n=>{n&&(i.push(n),f>0&&i.length>=f&&(r(i),i=[]))};let i=[];return E.search(a).then(n=>(i.length&&r(i),d.dispose(),n),n=>(i.length&&r(i),d.dispose(),Promise.reject(n)))}}e.$1rc=b}),define(Re[270],Te([1,0,17,239,41,100,27,15,22,24,13,14,2,103,9,43,11,114,49,120,266,44]),function(we,e,v,D,P,N,R,O,p,s,I,b,h,E,f,r,l,d,a,i,n,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IN=void 0,e.$GN=o,e.$HN=c,e.$JN=$,v=qe(v),D=qe(D),P=qe(P),p=qe(p),I=qe(I),f=qe(f);function o(w){return typeof w=="object"&&"uri"in w&&"pattern"in w}function c(w){return typeof w=="string"?{pattern:w}:{pattern:w.pattern,uri:w.baseUri}}let m=class{constructor(M,A,L,J,Y,z){this.a=M,this.b=A,this.c=L,this.d=J,this.f=Y,this.g=z}text(M,A,L={}){M=this.h(M,L);const J=this.a.getValue(),Y=A&&A.some(Q=>!this.a.getValue({resource:Q}).search.useRipgrep);return{...this.j(A?.map(a.$4i),L),type:t.QueryType.Text,contentPattern:M,previewOptions:L.previewOptions,maxFileSize:L.maxFileSize,usePCRE2:J.search.usePCRE2||Y||!1,surroundingContext:L.surroundingContext,userDisabledExcludesAndIgnoreFiles:L.disregardExcludeSettings&&L.disregardIgnoreFiles}}h(M,A){const L=this.a.getValue();M.isRegExp&&(M.pattern=M.pattern.replace(/\r?\n/g,"\\n"));const J={...M,wordSeparators:L.editor.wordSeparators};return this.l(M,A)&&(J.isCaseSensitive=!0),this.m(M)&&(J.isMultiline=!0),A.notebookSearchConfig?.includeMarkupInput&&(J.notebookInfo||(J.notebookInfo={}),J.notebookInfo.isInNotebookMarkdownInput=A.notebookSearchConfig.includeMarkupInput),A.notebookSearchConfig?.includeMarkupPreview&&(J.notebookInfo||(J.notebookInfo={}),J.notebookInfo.isInNotebookMarkdownPreview=A.notebookSearchConfig.includeMarkupPreview),A.notebookSearchConfig?.includeCodeInput&&(J.notebookInfo||(J.notebookInfo={}),J.notebookInfo.isInNotebookCellInput=A.notebookSearchConfig.includeCodeInput),A.notebookSearchConfig?.includeOutput&&(J.notebookInfo||(J.notebookInfo={}),J.notebookInfo.isInNotebookCellOutput=A.notebookSearchConfig.includeOutput),J}file(M,A={}){return{...this.j(M,A),type:t.QueryType.File,filePattern:A.filePattern?A.filePattern.trim():A.filePattern,exists:A.exists,sortByScore:A.sortByScore,cacheKey:A.cacheKey,shouldGlobMatchFilePattern:A.shouldGlobSearch}}i(M,A){if(!M)return{};if(Array.isArray(M)){if(M=M.filter(L=>L.length>0).map(y),!M.length)return{}}else M=y(M);return A?this.parseSearchPaths(M):{pattern:u(...Array.isArray(M)?M:[M])}}j(M=[],A={}){const L=Array.isArray(A.excludePattern)?A.excludePattern.map(le=>le.pattern).flat():A.excludePattern,J=this.i(A.includePattern,A.expandPatterns),Y=this.i(L,A.expandPatterns),z=M.length>1,Q=(J.searchPaths&&J.searchPaths.length?J.searchPaths.map(le=>this.t(le,A,Y)):M.map(le=>this.u(le,A,Y,z))).filter(le=>!!le),V={_reason:A._reason,folderQueries:Q,usingSearchPaths:!!(J.searchPaths&&J.searchPaths.length),extraFileResources:A.extraFileResources,excludePattern:Y.pattern,includePattern:J.pattern,onlyOpenEditors:A.onlyOpenEditors,maxResults:A.maxResults};if(A.onlyOpenEditors){const le=v.$Jb(this.c.groups.flatMap(re=>re.editors.map(ce=>ce.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(le));const _=le.filter(re=>(0,t.$wM)(V,re.fsPath)),oe=this.k(_);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(oe)),{...V,...oe}}const ie=A.extraFileResources&&A.extraFileResources.filter(le=>(0,t.$wM)(V,le.fsPath));return V.extraFileResources=ie&&ie.length?ie:void 0,V}k(M){const A=[],L=new R.$Dc,J={};let Y=!1;return M.forEach(z=>{if(z.scheme===O.Schemas.walkThrough)return;if((0,s.$nh)(z)){const V=this.b.getWorkspaceFolder(z)?.uri??this.g.extUri.dirname(z);let ie=L.get(V);ie||(Y=!0,ie={folder:V,includePattern:{}},A.push(ie),L.set(V,ie));const le=p.$oc(V.fsPath,z.fsPath);(0,b.$sg)(ie.includePattern)[le.replace(/\\/g,"/")]=!0}else z.fsPath&&(Y=!0,J[z.fsPath]=!0)}),{folderQueries:A,includePattern:J,usingSearchPaths:!0,excludePattern:Y?void 0:{"**/*":!0}}}l(M,A){if(A.isSmartCase){if(M.isRegExp){if(I.$$f(M.pattern,!0))return!0}else if(I.$$f(M.pattern))return!0}return!!M.isCaseSensitive}m(M){return M.isMultiline||M.isRegExp&&(0,E.$wD)(M.pattern)||M.pattern.indexOf(`
`)>=0?!0:!!M.isMultiline}parseSearchPaths(M){const A=_=>p.$lc(_)||/^\.\.?([\/\\]|$)/.test(_),J=(Array.isArray(M)?M:S(M)).map(_=>{const oe=this.f.resolvedUserHome;return oe?(0,N.$0w)(_,oe.scheme===O.Schemas.file?oe.fsPath:oe.path):_}),Y=D.$c(J,_=>A(_)?"searchPaths":"exprSegments"),z=(Y.exprSegments||[]).map(_=>I.$qf(_,"/")).map(_=>I.$qf(_,"\\")).map(_=>(_[0]==="."&&(_="*"+_),k(_))),Q={},V=this.o(Y.searchPaths||[]);V&&V.length&&(Q.searchPaths=V);const ie=z.flat(),le=u(...ie);return le&&(Q.pattern=le),Q}n(M,A){return A.disregardExcludeSettings?void 0:(0,t.$vM)(M,!A.disregardSearchExcludeSettings)}o(M){if(!M||!M.length)return[];const A=M.flatMap(J=>{let{pathPortion:Y,globPortion:z}=g(J);return z&&(z=C(z)),this.q(Y).flatMap(V=>this.r(V,z))}),L=new Map;return A.forEach(J=>{const Y=J.searchPath.toString(),z=L.get(Y);z?J.pattern&&(z.pattern=z.pattern||{},z.pattern[J.pattern]=!0):L.set(Y,{searchPath:J.searchPath,pattern:J.pattern?u(J.pattern):void 0})}),Array.from(L.values())}q(M){if(p.$lc(M)){const A=this.b.getWorkspace().folders;return A[0]&&A[0].uri.scheme!==O.Schemas.file?[{searchPath:A[0].uri.with({path:M})}]:[{searchPath:h.URI.file(p.$kc(M))}]}if(this.b.getWorkbenchState()===a.WorkbenchState.FOLDER){const A=this.b.getWorkspace().folders[0].uri;if(M=y(M),M.startsWith("../")||M===".."){const J=p.$jc.resolve(A.path,M);return[{searchPath:A.with({path:J})}]}const L=C(M);return[{searchPath:A,pattern:L}]}else{if(M==="./"||M===".\\")return[];{const A=M.replace(/^\.[\/\\]/,""),J=this.b.getWorkspace().folders.map(Y=>{const z=A.match(new RegExp(`^${I.$kf(Y.name)}(?:/(.*)|$)`));return z?{match:z,folder:Y}:null}).filter(b.$pg);if(J.length)return J.map(Y=>{const z=Y.match[1];return{searchPath:Y.folder.uri,pattern:z&&C(z)}});{const Y=M.match(/\.[\/\\](.+)[\/\\]?/),z=Y?Y[1]:M,Q=f.localize(12602,null,z);throw new Error(Q)}}}}r(M,A){const L=M.pattern&&A?`${M.pattern}/${A}`:M.pattern||A,J=[{searchPath:M.searchPath,pattern:L}];return L&&!L.endsWith("**")&&J.push({searchPath:M.searchPath,pattern:L+"/**"}),J}t(M,A,L){const J=this.u((0,a.$4i)(M.searchPath),A,L,!1);return J?{...J,includePattern:M.pattern}:null}u(M,A,L,J){let Y;const z=h.URI.isUri(M)?M:M.uri;let Q=A.excludePattern?.map(re=>{const ce=A.excludePattern&&o(re)?re.uri:void 0;return!ce||!(h.URI.isUri(M)&&this.g.extUri.isEqual(M,ce))?ce:void 0});if(Q?.length||(Q=[void 0]),L.searchPaths){const re=L.searchPaths.filter(ce=>(0,s.$ch)(ce.searchPath,z))[0];if(re&&!re.pattern)return null;re&&(Y=re.pattern)}const V=this.a.getValue({resource:z}),le={...this.n(V,A)||{},...Y||{}},_=h.URI.isUri(M)?(0,s.$gh)(M):M.name,oe=Q.map(re=>Object.keys(le).length>0?{folder:re,pattern:le}:void 0).filter(re=>re);return{folder:z,folderName:J?_:void 0,excludePattern:oe,fileEncoding:V.files&&V.files.encoding,disregardIgnoreFiles:typeof A.disregardIgnoreFiles=="boolean"?A.disregardIgnoreFiles:!V.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof A.disregardGlobalIgnoreFiles=="boolean"?A.disregardGlobalIgnoreFiles:!V.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof A.disregardParentIgnoreFiles=="boolean"?A.disregardParentIgnoreFiles:!V.search.useParentIgnoreFiles,ignoreSymlinks:typeof A.ignoreSymlinks=="boolean"?A.ignoreSymlinks:!V.search.followSymlinks}}};e.$IN=m,e.$IN=m=Ke([We(0,r.$cj),We(1,a.$Ri),We(2,i.$JE),We(3,l.$dk),We(4,n.$EN),We(5,d.$Nl)],m);function g(w){const M=w.match(/[\*\{\}\(\)\[\]\?]/);if(M){const A=M.index,L=w.substr(0,A).match(/[/|\\][^/\\]*$/);if(L){let J=w.substr(0,L.index);return J.match(/[/\\]/)||(J+="/"),{pathPortion:J,globPortion:w.substr((L.index||0)+1)}}}return{pathPortion:w}}function u(...w){return w.length?w.reduce((M,A)=>(M[A]=!0,M),Object.create(null)):void 0}function S(w){return P.$Bk(w,",").map(M=>M.trim()).filter(M=>!!M.length)}function k(w){return[`**/${w}/**`,`**/${w}`].map(A=>A.replace(/\*\*\/\*\*/g,"**"))}function y(w){return w.replace(/\\/g,"/")}function C(w){return y(w).replace(/^\.\//,"").replace(/\/+$/g,"")}function T(w){return w.replace(/([?*[\]])/g,"[$1]")}function $(w,M){w=v.$Ob(w,J=>J.toString());const A=[],L=M.getWorkspace();return w&&w.forEach(J=>{let Y;if(M.getWorkbenchState()===a.WorkbenchState.FOLDER)Y=(0,s.$lh)(L.folders[0].uri,J),Y&&Y!=="."&&(Y="./"+Y);else{const z=M.getWorkspaceFolder(J);if(z){const Q=z.name;if(L.folders.filter(ie=>ie.name===Q).length===1){const ie=(0,s.$lh)(z.uri,J);ie===""?Y=`./${z.name}`:Y=`./${z.name}/${ie}`}else Y=J.fsPath}}Y&&A.push(T(Y))}),A}}),define(Re[271],Te([1,0,24,2,19,12,3,270,44,49,10]),function(we,e,v,D,P,N,R,O,p,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0yb=h,e.$$yb=r,v=qe(v),N=qe(N);const b=7e3;function h(l,d){const a=d.activationEvents;if(!a)return Promise.resolve(void 0);const i=[],n=[];for(const u of a)if(/^workspaceContains:/.test(u)){const S=u.substr(18);S.indexOf("*")>=0||S.indexOf("?")>=0||l.forceUsingSearch?n.push(S):i.push(S)}if(i.length===0&&n.length===0)return Promise.resolve(void 0);const{promise:t,resolve:o}=(0,I.$Bh)(),c=u=>o({activationEvent:u}),m=Promise.all(i.map(u=>E(l,u,c))).then(()=>{}),g=f(l,d.identifier,n,c);return Promise.all([m,g]).then(()=>{o(void 0)}),t}async function E(l,d,a){for(const i of l.folders)if(await l.exists(v.$jh(D.URI.revive(i),d))){a(`workspaceContains:${d}`);return}}async function f(l,d,a,i){if(a.length===0)return Promise.resolve(void 0);const n=new P.$ze,t=l.checkExists(l.folders,a,n.token),o=setTimeout(async()=>{n.cancel(),l.logService.info(`Not activating extension '${d.value}': Timed out while searching for 'workspaceContains' pattern ${a.join(",")}`)},b);let c=!1;try{c=await t}catch(m){N.$6(m)||N.$2(m)}n.dispose(),clearTimeout(o),c&&i(`workspaceContains:${a.join(",")}`)}function r(l,d,a,i){const n=l.get(R.$Hi),t=l.get(p.$nM),c=n.createInstance(O.$IN).file(d.map(m=>(0,s.$4i)(D.URI.revive(m))),{_reason:"checkExists",includePattern:a,exists:!0});return t.fileSearch(c,i).then(m=>!!m.limitHit,m=>N.$6(m)?!1:Promise.reject(m))}}),define(Re[47],Te([1,0,9,22,64,24,10,4,48,2,11,5,46,205,89,45,21,121,12,18,20,188,7,110,3,26,92,16,75,93,56,95,6,271,88,190,15,86,69,23,87]),function(we,e,v,D,P,N,R,O,p,s,I,b,h,E,f,r,l,d,a,i,n,t,o,c,m,g,u,S,k,y,C,T,$,w,M,A,L,J,Y,z,Q){"use strict";var V;Object.defineProperty(e,"__esModule",{value:!0}),e.$Brc=e.$Arc=e.$zrc=e.$yrc=e.$xrc=void 0,v=qe(v),D=qe(D),P=qe(P),a=qe(a),e.$xrc=(0,m.$Ii)("IHostUtils");let ie=V=class extends O.$Xc{constructor(X,q,ne,be,Ie,Fe,Be,xe,nt,ut,pt,lt,et){super(),this.Y=lt,this.Z=et,this.a=this.B(new $.$oe),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=q,this.g=ne,this.f=Be,this.j=be,this.m=Ie,this.s=Fe,this.t=nt,this.u=ut,this.w=pt,this.y=this.g.getProxy(b.$3N.MainThreadWorkspace),this.z=this.g.getProxy(b.$3N.MainThreadTelemetry),this.C=this.g.getProxy(b.$3N.MainThreadExtensionService),this.D=new R.$Hh,this.F=new R.$Hh,this.G=new R.$Hh,this.H=new R.$Hh,this.I=new $e(this.f.extensions.activationEvents),this.L=new d.$Oec(this.I,this.f.extensions.allExtensions);const Ne=new i.$wn(this.f.extensions.myExtensions);this.J=new d.$Oec(this.I,ce(this.L,Ne)),z.$u&&(this.s.info(`Creating extension host with the following global extensions: ${oe(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${oe(this.J)}`)),this.M=new f.$grc(this.g,this.s),this.N=new M.$qrc(this.g),this.O=xe,this.h=this.q.add(X.createChild(new k.$Gi([f.$hrc,this.M],[M.$rrc,this.N]))),this.P=this.B(new E.$frc(this.J,this.L,{onExtensionActivationError:(Me,Le,B)=>{this.C.$onExtensionActivationError(Me,a.$4(Le),B)},actualActivateExtension:async(Me,Le)=>{if(d.$Oec.isHostExtension(Me,this.J,this.L))return await this.C.$activateExtension(Me,Le),new E.$erc;const B=this.J.getExtensionDescription(Me);return this.fb(B,Le)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),P.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(X){a.$2(X)}}async $(){this.O.onWillDeactivateAll();let X=[];try{X=this.J.getAllExtensionDescriptions().map(Ie=>Ie.identifier).filter(Ie=>this.isActivated(Ie)).map(Ie=>this.eb(Ie))}catch{}await Promise.all(X)}terminate(X,q=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${X}`),this.s.flush(),this.u.dispose(),this.P.dispose(),a.setUnexpectedErrorHandler(be=>{this.s.error(be)}),this.g.dispose();const ne=this.$();Promise.race([(0,R.$Jh)(5e3),ne]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${q}`):this.s.info(`Extension host exiting with code ${q}`),this.s.flush(),this.s.dispose(),this.c.exit(q)})}isActivated(X){return this.G.isOpen()?this.P.isActivated(X):!1}async getExtension(X){const q=await this.C.$getExtension(X);return q&&{...q,identifier:new i.$vn(q.identifier.value),extensionLocation:s.URI.revive(q.extensionLocation)}}ab(X,q){return this.P.activateByEvent(X,q)}bb(X,q){return this.P.activateById(X,q)}activateByIdWithErrors(X,q){return this.bb(X,q).then(()=>{const ne=this.P.getActivatedExtension(X);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(X=>this.J)}getExtensionExports(X){if(this.G.isOpen())return this.P.getActivatedExtension(X).exports;try{return this.P.getActivatedExtension(X).exports}catch{return null}}async cb(X){if(X.scheme===L.Schemas.file&&this.c.fsRealpath){const q=X.fsPath;this.R.has(q)||this.R.set(q,this.c.fsRealpath(q));const ne=await this.R.get(q);return s.URI.file(ne)}return X}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(X=>new x(X))),this.Q}async db(X){const q=p.$Oi.forUris(ne=>N.$ah.ignorePathCasing(ne));return await Promise.all(X.map(async ne=>{if(this.wb(ne)){const be=await this.cb(ne.extensionLocation);q.set(be,ne)}})),q}eb(X){let q=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(X))return q;const ne=this.P.getActivatedExtension(X);if(!ne)return q;try{typeof ne.module.deactivate=="function"&&(q=Promise.resolve(ne.module.deactivate()).then(void 0,be=>(this.s.error(be),Promise.resolve(void 0))))}catch(be){this.s.error(`An error occurred when deactivating the extension '${X.value}':`),this.s.error(be)}try{ne.disposable.dispose()}catch(be){this.s.error(`An error occurred when disposing the subscriptions for extension '${X.value}':`),this.s.error(be)}return q}async fb(X,q){return this.f.remote.isRemote?this.C.$onWillActivateExtension(X.identifier):await this.C.$onWillActivateExtension(X.identifier),this.hb(X,q).then(ne=>{const be=ne.activationTimes;return this.C.$onDidActivateExtension(X.identifier,be.codeLoadingTime,be.activateCallTime,be.activateResolvedTime,q),this.gb(X,q,"success",be),ne},ne=>{throw this.gb(X,q,"failure"),ne})}gb(X,q,ne,be){const Ie=_(X,q);this.z.$publicLog2("extensionActivationTimes",{...Ie,...be||{},outcome:ne})}hb(X,q){const ne=_(X,q);this.z.$publicLog2("activatePlugin",ne);const be=this.wb(X);if(!be)return Promise.resolve(new E.$drc(E.$arc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${X.identifier.value}, startup: ${q.startup}, activationEvent: '${q.activationEvent}'${X.identifier.value!==q.extensionId.value?`, root cause: ${q.extensionId.value}`:""}`),this.s.flush();const Ie=new O.$Wc,Fe=new E.$brc(q.startup);return Promise.all([this.xb(X,(0,N.$jh)(X.extensionLocation,be),Fe),this.ib(X,Ie)]).then(Be=>(P.mark(`code/extHost/willActivateExtension/${X.identifier.value}`),V.jb(this.s,X.identifier,Be[0],Be[1],Ie,Fe))).then(Be=>(P.mark(`code/extHost/didActivateExtension/${X.identifier.value}`),Be))}ib(X,q){const ne=this.Z.createLanguageModelAccessInformation(X),be=q.add(new t.$jrc(X,this.M)),Ie=q.add(new t.$irc(X.identifier.value,!1,this.M)),Fe=q.add(new A.$src(X,this.N)),Be=X.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?o.ExtensionMode.Test:o.ExtensionMode.Development:o.ExtensionMode.Production,xe=this.f.remote.isRemote?o.ExtensionKind.Workspace:o.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${X.identifier.value}`),Promise.all([be.whenReady,Ie.whenReady,this.O.whenReady]).then(()=>{const nt=this;let ut,pt;const lt=(0,l.$vH)(X,"ipc")?this.f.messagePorts?.get(i.$vn.toKey(X.identifier)):void 0;return Object.freeze({globalState:be,workspaceState:Ie,secrets:Fe,subscriptions:[],get languageModelAccessInformation(){return ne},get extensionUri(){return X.extensionLocation},get extensionPath(){return X.extensionLocation.fsPath},asAbsolutePath(et){return D.$mc(X.extensionLocation.fsPath,et)},get storagePath(){return nt.O.workspaceValue(X)?.fsPath},get globalStoragePath(){return nt.O.globalValue(X).fsPath},get logPath(){return D.$mc(nt.f.logsLocation.fsPath,X.identifier.value)},get logUri(){return s.URI.joinPath(nt.f.logsLocation,X.identifier.value)},get storageUri(){return nt.O.workspaceValue(X)},get globalStorageUri(){return nt.O.globalValue(X)},get extensionMode(){return Be},get extension(){return ut===void 0&&(ut=new re(nt,X.identifier,X,xe,!1)),ut},get extensionRuntime(){return(0,l.$wH)(X,"extensionRuntime"),nt.extensionRuntime},get environmentVariableCollection(){return nt.u.getEnvironmentVariableCollection(X)},get messagePassingProtocol(){if(!pt){if(!lt)return;const et=$.Event.buffer($.Event.fromDOMEventEmitter(lt,"message",Ne=>Ne.data));lt.start(),pt={onDidReceiveMessage:et,postMessage:lt.postMessage.bind(lt)}}return pt}})})}static jb(X,q,ne,be,Ie,Fe){return ne=ne||{activate:void 0,deactivate:void 0},this.kb(X,q,ne,be,Fe).then(Be=>new E.$crc(!1,null,Fe.build(),ne,Be,(0,O.$Vc)(()=>{Ie.dispose(),(0,O.$Sc)(be.subscriptions)})))}static kb(X,q,ne,be,Ie){if(typeof ne.activate=="function")try{Ie.activateCallStart(),X.trace(`ExtensionService#_callActivateOptional ${q.value}`);const Fe=typeof global=="object"?global:self,Be=ne.activate.apply(Fe,[be]);return Ie.activateCallStop(),Ie.activateResolveStart(),Promise.resolve(Be).then(xe=>(Ie.activateResolveStop(),xe))}catch(Fe){return Promise.reject(Fe)}else return Promise.resolve(ne)}lb(X,q){this.bb(X.identifier,{startup:!1,extensionId:X.identifier,activationEvent:q}).then(void 0,ne=>{this.s.error(ne)})}mb(X,q=0){const be=Date.now();(0,z.$C)(()=>{for(let Ie=q;Ie<X.length;Ie+=1){const Fe=X[Ie];for(const Be of Fe.activationEvents??[])if(Be==="onStartupFinished")if(Date.now()-be>50){this.mb(X,Ie);break}else this.lb(Fe,Be)}})}nb(){this.C.$setPerformanceMarks(P.getMarks()),this.m.getConfigProvider().then(X=>{const q=X.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ne=this.J.getAllExtensionDescriptions();if(q)this.mb(ne);else for(const be of ne)if(be.activationEvents)for(const Ie of be.activationEvents)Ie==="onStartupFinished"&&this.lb(be,Ie)})}ob(){const X=this.ab("*",!0).then(void 0,Fe=>{this.s.error(Fe)});this.B(this.j.onDidChangeWorkspace(Fe=>this.pb(Fe.added)));const q=this.j.workspace?this.j.workspace.folders:[],ne=this.pb(q),be=this.rb(),Ie=Promise.all([be,X,ne]).then(()=>{});return Promise.race([Ie,(0,R.$Jh)(1e4)]).then(()=>{this.nb()}),Ie}pb(X){return X.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(q=>this.qb(X,q))).then(()=>{})}async qb(X,q){if(this.isActivated(q.identifier))return;const ne=!this.f.remote.isRemote&&!!this.f.remote.authority,be={logService:this.s,folders:X.map(Fe=>Fe.uri),forceUsingSearch:ne||!this.c.fsExists,exists:Fe=>this.c.fsExists(Fe.fsPath),checkExists:(Fe,Be,xe)=>this.y.$checkExists(Fe,Be,xe)},Ie=await(0,w.$0yb)(be,q);if(Ie)return this.bb(q.identifier,{startup:!0,extensionId:q.identifier,activationEvent:Ie.activationEvent}).then(void 0,Fe=>this.s.error(Fe))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(X){throw console.error(X),X}}async sb(){const{extensionDevelopmentLocationURI:X,extensionTestsLocationURI:q}=this.f.environment;if(!X||!q)throw new Error(v.localize(2701,null));const ne=await this.xb(null,q,new E.$brc(!1));if(!ne||typeof ne.run!="function")throw new Error(v.localize(2702,null,q.toString()));return new Promise((be,Ie)=>{const Fe=(nt,ut)=>{nt?(z.$u&&this.s.error("Test runner called back with error",nt),Ie(nt)):(z.$u&&(ut?this.s.info(`Test runner called back with ${ut} failures.`):this.s.info("Test runner called back with successful outcome.")),be(typeof ut=="number"&&ut>0?1:0))},Be=(0,N.$0g)(q),xe=ne.run(Be,Fe);xe&&xe.then&&xe.then(()=>{z.$u&&this.s.info("Test runner finished successfully."),be(0)}).catch(nt=>{z.$u&&this.s.error("Test runner finished with error",nt),Ie(nt instanceof Error&&nt.stack?nt.stack:String(nt))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$Jh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(X,q){return this.S[X]=q,(0,O.$Vc)(()=>{delete this.S[X]})}async getRemoteExecServer(X){const{resolver:q}=await this.ub(X);return q?.resolveExecServer?.(X,{resolveAttempt:0})}async ub(X){const q=X.indexOf("+");if(q===-1)throw new o.$aO("Not an authority that can be resolved!",c.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ne=X.substr(0,q);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this.S[ne]}}async $resolveAuthority(X,q){const ne=Y.$ie.create(!1),be=()=>`[resolveAuthority(${(0,c.$Yl)(X)},${q})][${ne.elapsed()}ms] `,Ie=j=>this.s.info(`${be()}${j}`),Fe=j=>this.s.warn(`${be()}${j}`),Be=(j,H=void 0)=>this.s.error(`${be()}${j}`,H),xe=j=>{if(j instanceof o.$aO)return{type:"error",error:{code:j._code,message:j._message,detail:j._detail}};throw j},nt=async j=>{Ie(`activating resolver for ${j}...`);const{resolver:H,authorityPrefix:G}=await this.ub(j);if(!H)throw Be(`no resolver for ${G}`),new o.$aO(`No remote extension installed to resolve ${G}.`,c.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:H,authorityPrefix:G,remoteAuthority:j}},ut=X.split(/@|%40/g).reverse();Ie(`activating remote resolvers ${ut.join(" -> ")}`);let pt;try{pt=await Promise.all(ut.map(nt)).catch(async j=>{if(!(j instanceof o.$aO)||j._code!==c.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw j;return Fe(`resolving nested authorities failed: ${j.message}`),[await nt(X)]})}catch(j){return xe(j)}const lt=new R.$Th;lt.cancelAndSet(()=>Ie("waiting..."),1e3);let et,Ne;for(const[j,{authorityPrefix:H,resolver:G,remoteAuthority:se}]of pt.entries())try{if(j===pt.length-1)Ie("invoking final resolve()..."),P.mark(`code/extHost/willResolveAuthority/${H}`),et=await G.resolve(se,{resolveAttempt:q,execServer:Ne}),P.mark(`code/extHost/didResolveAuthorityOK/${H}`),Ie("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(G,o.$_N.isManagedResolvedAuthority(et)?et:void 0));else{if(Ie(`invoking resolveExecServer() for ${se}`),P.mark(`code/extHost/willResolveExecServer/${H}`),Ne=await G.resolveExecServer?.(se,{resolveAttempt:q,execServer:Ne}),!Ne)throw new o.$aO(`Exec server was not available for ${se}`,c.RemoteAuthorityResolverErrorCode.NoResolverFound);P.mark(`code/extHost/didResolveExecServerOK/${H}`)}}catch(ge){return P.mark(`code/extHost/didResolveAuthorityError/${H}`),Be("returned an error",ge),lt.dispose(),xe(ge)}lt.dispose();const Me={environmentTunnels:et.environmentTunnels,features:et.tunnelFeatures?{elevation:et.tunnelFeatures.elevation,privacyOptions:et.tunnelFeatures.privacyOptions,protocol:et.tunnelFeatures.protocol===void 0?!0:et.tunnelFeatures.protocol}:void 0},Le={extensionHostEnv:et.extensionHostEnv,isTrusted:et.isTrusted,authenticationSession:et.authenticationSessionForInitializingExtensions?{id:et.authenticationSessionForInitializingExtensions.id,providerId:et.authenticationSessionForInitializingExtensions.providerId}:void 0};Ie(`returned ${o.$_N.isManagedResolvedAuthority(et)?"managed authority":`${et.host}:${et.port}`}`);let B;if(o.$_N.isManagedResolvedAuthority(et)){const j=q;this.Y.setFactory(j,et.makeConnection),B={authority:X,connectTo:new c.$Vl(j),connectionToken:et.connectionToken}}else B={authority:X,connectTo:new c.$Wl(et.host,et.port),connectionToken:et.connectionToken};return{type:"ok",value:{authority:B,options:Le,tunnelInformation:Me}}}async $getCanonicalURI(X,q){this.s.info(`$getCanonicalURI invoked for authority (${(0,c.$Yl)(X)})`);const{resolver:ne}=await this.ub(X);if(!ne)return null;const be=s.URI.revive(q);if(typeof ne.getCanonicalURI>"u")return be;const Ie=await(0,R.$Ah)(()=>ne.getCanonicalURI(be));return Ie||be}async $startExtensionHost(X){X.toAdd.forEach(Fe=>Fe.extensionLocation=s.URI.revive(Fe.extensionLocation));const{globalRegistry:q,myExtensions:ne}=le(this.I,this.L,this.J,X),be=await this.db(ne);return(await this.getExtensionPathIndex()).setSearchTree(be),this.L.set(q.getAllExtensionDescriptions()),this.J.set(ne),z.$u&&(this.s.info(`$startExtensionHost: global extensions: ${oe(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${oe(this.J)}`)),this.tb()}$activateByEvent(X,q){return q===l.ActivationKind.Immediate?this.D.wait().then(ne=>this.ab(X,!1)):this.G.wait().then(ne=>this.ab(X,!1))}async $activate(X,q){return await this.G.wait(),this.J.getExtensionDescription(X)?(await this.bb(X,q),!0):!1}async $deltaExtensions(X){X.toAdd.forEach(Fe=>Fe.extensionLocation=s.URI.revive(Fe.extensionLocation));const{globalRegistry:q,myExtensions:ne}=le(this.I,this.L,this.J,X),be=await this.db(ne);return(await this.getExtensionPathIndex()).setSearchTree(be),this.L.set(q.getAllExtensionDescriptions()),this.J.set(ne),z.$u&&(this.s.info(`$deltaExtensions: global extensions: ${oe(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${oe(this.J)}`)),Promise.resolve(void 0)}async $test_latency(X){return X}async $test_up(X){return X.byteLength}async $test_down(X){const q=n.$Qe.alloc(X),ne=Math.random()%256;for(let be=0;be<X;be++)q.writeUInt8(ne,be);return q}async $updateRemoteConnectionData(X){this.X=X,this.a.fire()}};e.$yrc=ie,e.$yrc=ie=V=Ke([We(0,m.$Hi),We(1,e.$xrc),We(2,S.$DQ),We(3,r.$Vqc),We(4,h.$Yqc),We(5,I.$dk),We(6,g.$TQ),We(7,u.$2qc),We(8,y.$PGb),We(9,C.$krc),We(10,J.$urc),We(11,Q.$vrc),We(12,T.$orc)],ie);function le(Pe,X,q,ne){Pe.addActivationEvents(ne.addActivationEvents);const be=new d.$Oec(Pe,X.getAllExtensionDescriptions());be.deltaExtensions(ne.toAdd,ne.toRemove);const Ie=new i.$wn(q.getAllExtensionDescriptions().map(Be=>Be.identifier));for(const Be of ne.myToRemove)Ie.delete(Be);for(const Be of ne.myToAdd)Ie.add(Be);const Fe=ce(be,Ie);return{globalRegistry:be,myExtensions:Fe}}function _(Pe,X){return{id:Pe.identifier.value,name:Pe.name,extensionVersion:Pe.version,publisherDisplayName:Pe.publisher,activationEvents:Pe.activationEvents?Pe.activationEvents.join(","):null,isBuiltin:Pe.isBuiltin,reason:X.activationEvent,reasonId:X.extensionId.value}}function oe(Pe){return Pe.getAllExtensionDescriptions().map(X=>X.identifier.value).join(",")}e.$zrc=(0,m.$Ii)("IExtHostExtensionService");class re{#e;#t;#i;constructor(X,q,ne,be,Ie){this.#e=X,this.#t=q,this.#i=ne.identifier,this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=D.$kc((0,N.$0g)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=be,this.isFromDifferentExtensionHost=Ie}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Arc=re;function ce(Pe,X){return Pe.getAllExtensionDescriptions().filter(q=>X.has(q.identifier))}class x{constructor(X){this.a=X}setSearchTree(X){this.a=X}findSubstr(X){return this.a.findSubstr(X)}forEach(X){return this.a.forEach(X)}}e.$Brc=x;class $e{constructor(X){this.a=new i.$xn,this.addActivationEvents(X)}readActivationEvents(X){return this.a.get(X.identifier)??[]}addActivationEvents(X){for(const q of Object.keys(X))this.a.set(q,X[q])}}}),define(Re[272],Te([1,0,64,2,5,46,21,18,16,26,3,47,11,13]),function(we,e,v,D,P,N,R,O,p,s,I,b,h,E){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rsc=void 0,v=qe(v);let r=class{constructor(n,t,o,c,m,g,u){this.c=n,this.d=t,this.e=o,this.f=c,this.g=m,this.h=g,this.i=u,this.a=new Map,this.b=[]}async install(){this.j(),v.mark("code/extHost/willWaitForConfig");const n=await this.f.getConfigProvider();v.mark("code/extHost/didWaitForConfig");const t=await this.g.getExtensionPathIndex();this.register(new d(this.c,t,this.d,n,this.i)),this.register(this.e.createInstance(l)),this.h.remote.isRemote&&this.register(this.e.createInstance(a,t,this.h.environment.appUriScheme))}register(n){if("nodeModuleName"in n)if(Array.isArray(n.nodeModuleName))for(const t of n.nodeModuleName)this.a.set(t,n);else this.a.set(n.nodeModuleName,n);typeof n.alternativeModuleName=="function"&&this.b.push(t=>n.alternativeModuleName(t))}};e.$Rsc=r,e.$Rsc=r=Ke([We(2,I.$Hi),We(3,N.$Yqc),We(4,b.$zrc),We(5,s.$TQ),We(6,h.$dk)],r);let l=class{static{f=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(n){if(n.environment.appRoot&&f.a.size){const t=(0,E.$kf)(this.c(n.environment.appRoot.fsPath)),o="[a-z0-9_.-]",c=`@${o}+\\/${o}+|${o}+`,m="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${m}\\/)(${c})(.*)$`,"i")}}alternativeModuleName(n){if(!this.b)return;const t=this.b.exec(this.c(n));if(!t)return;const[,o,c,m]=t,g=f.a.get(c);if(g!==void 0)return console.warn(`${c} as been renamed to ${g}, please update your imports`),o+g+m}c(n){return n.replace(/\\/g,"/")}};l=f=Ke([We(0,s.$TQ)],l);class d{constructor(n,t,o,c,m){this.c=n,this.d=t,this.e=o,this.f=c,this.g=m,this.nodeModuleName="vscode",this.a=new O.$xn}load(n,t){const o=this.d.findSubstr(t);if(o){let c=this.a.get(o.identifier);return c||(c=this.c(o,this.e,this.f),this.a.set(o.identifier,c)),c}if(!this.b){let c="";this.d.forEach((m,g)=>c+=`	${g} -> ${m.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${c}`),this.b=this.c(R.$qH,this.e,this.f)}return this.b}}let a=class{constructor(n,t,o){this.e=n,this.f=t,this.nodeModuleName=["open","opn"],this.d=o.getProxy(P.$3N.MainThreadTelemetry);const c=o.getProxy(P.$3N.MainThreadWindow);this.c=(m,g)=>{const u=D.URI.parse(m);return g?this.g(m,g):u.scheme==="http"||u.scheme==="https"?c.$openUri(u,m,{allowTunneling:!0}):u.scheme==="mailto"||u.scheme===this.f?c.$openUri(u,m,{}):this.g(m,g)}}load(n,t,o){const c=this.e.findSubstr(t);return c&&(this.a=c.identifier.value,this.h()),this.b=o(n),this.c}g(n,t){return this.i(),this.b(n,t)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};a=Ke([We(2,p.$DQ)],a)}),define(Re[133],Te([1,0,51,4,22,79,3,57,70,47,7,45,202,46]),function(we,e,v,D,P,N,R,O,p,s,I,b,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Drc=e.$Crc=void 0,P=qe(P),N=qe(N),e.$Crc=(0,R.$Ii)("IExtHostVariableResolverProvider");class f extends h.$HR{constructor(d,a,i,n,t,o,c){function m(){if(i){const g=i.activeEditor();if(g)return g.document.uri;const u=n.tabGroups.all.find(S=>S.isActive)?.activeTab;if(u!==void 0){if(u.input instanceof I.$TP||u.input instanceof I.$YP)return u.input.modified;if(u.input instanceof I.$SP||u.input instanceof I.$XP||u.input instanceof I.$VP)return u.input.uri}}}super({getFolderUri:g=>{const u=o.folders.filter(S=>S.name===g);if(u&&u.length>0)return u[0].uri},getWorkspaceFolderCount:()=>o.folders.length,getConfigurationValue:(g,u)=>t.getConfiguration(void 0,g).get(u),getAppRoot:()=>N.cwd(),getExecPath:()=>N.env.VSCODE_EXEC_PATH,getFilePath:()=>{const g=m();if(g)return P.$kc(g.fsPath)},getWorkspaceFolderPathForFile:()=>{if(a){const g=m();if(g){const u=a.getWorkspaceFolder(g);if(u)return P.$kc(u.uri.fsPath)}}},getSelectedText:()=>{if(i){const g=i.activeEditor();if(g&&!g.selection.isEmpty)return g.document.getText(g.selection)}},getLineNumber:()=>{if(i){const g=i.activeEditor();if(g)return String(g.selection.end.line+1)}},getExtension:g=>d.getExtension(g)},void 0,c?Promise.resolve(c):void 0,Promise.resolve(N.env))}}let r=class extends D.$Xc{constructor(d,a,i,n,t){super(),this.b=d,this.c=a,this.g=i,this.h=n,this.j=t,this.a=new v.$W(async()=>{const o=await this.h.getConfigProvider(),m={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async g=>{m.folders=await this.c.getWorkspaceFolders2()||[]})),new f(this.b,this.c,this.g,this.j,o,m,this.m())})}getResolver(){return this.a.value}m(){}};e.$Drc=r,e.$Drc=r=Ke([We(0,s.$zrc),We(1,b.$Vqc),We(2,O.$OQ),We(3,E.$Yqc),We(4,p.$$qc)],r)}),define(Re[134],Te([1,0,10,6,2,4,18,3,5,70,47,16,7,45,194,81,195,46,133,35,34,8,17,96]),function(we,e,v,D,P,N,R,O,p,s,I,b,h,E,f,r,l,d,a,i,n,t,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nrc=e.$Mrc=e.$Lrc=e.$Krc=e.$Jrc=void 0,t=qe(t),e.$Jrc=(0,O.$Ii)("IExtHostDebugService");let m=class extends N.$Xc{get onDidStartDebugSession(){return this.y.event}get onDidTerminateDebugSession(){return this.z.event}get onDidChangeActiveDebugSession(){return this.C.event}get activeDebugSession(){return this.D?.api}get onDidReceiveDebugSessionCustomEvent(){return this.F.event}get activeDebugConsole(){return this.G.value}constructor(T,$,w,M,A,L,J,Y){super(),this.Y=$,this.Z=w,this.$=M,this.ab=A,this.bb=L,this.cb=J,this.db=Y,this.w=new Map,this.O=0,this.P=new Map,this.Q=new Map,this.R=new WeakMap,this.S=new Map,this.W=new Map,this.X=0,this.f=0,this.g=[],this.h=0,this.j=[],this.m=0,this.n=[],this.M=new Map,this.N=new Map,this.y=this.B(new D.$oe),this.z=this.B(new D.$oe),this.C=this.B(new D.$oe),this.F=this.B(new D.$oe),this.u=T.getProxy(p.$3N.MainThreadDebugService),this.I=this.B(new D.$oe),this.L=this.B(new D.$oe),this.G=new u(this.u),this.H=new Map,this.Z.getExtensionRegistry().then(z=>{this.B(z.onDidChange(Q=>{this.fb(z)})),this.fb(z)})}async $getVisualizerTreeItem(T,$){const w=this.gb($);if(!w)return;const M=await this.Q.get(T)?.getTreeItem?.(w);return M?this.eb(T,M):void 0}registerDebugVisualizationTree(T,$,w){const M=R.$vn.toKey(T.identifier),A=this.ub(M,$);if(this.P.has(A))throw new Error(`A debug visualization provider with id '${$}' is already registered`);return this.Q.set(A,w),this.u.$registerDebugVisualizerTree(A,!!w.editItem),(0,N.$Vc)(()=>{this.u.$unregisterDebugVisualizerTree(A),this.Q.delete($)})}async $getVisualizerTreeItemChildren(T,$){const w=this.S.get($)?.item;return w?(await this.Q.get(T)?.getChildren?.(w))?.map(A=>this.eb(T,A))||[]:[]}async $editVisualizerTreeItem(T,$){const w=this.S.get(T);if(!w)return;const M=await this.Q.get(w.provider)?.editItem?.(w.item,$);return this.eb(w.provider,M||w.item)}$disposeVisualizedTree(T){const $=this.S.get(T);if(!$)return;const w=[$.children];for(const M of w)if(M)for(const A of M)w.push(this.S.get(A)?.children),this.S.delete(A)}eb(T,$){let w=this.R.get($);return w||(w=this.O++,this.R.set($,w),this.S.set(w,{provider:T,item:$})),t.DebugTreeItem.from($,w)}asDebugSourceUri(T,$){const w=T;if(typeof w.sourceReference=="number"&&w.sourceReference>0){let M=`debug:${encodeURIComponent(w.path||"")}`,A="?";return $&&(M+=`${A}session=${encodeURIComponent($.id)}`,A="&"),M+=`${A}ref=${w.sourceReference}`,P.URI.parse(M)}else{if(w.path)return P.URI.file(w.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}fb(T){const $=[];for(const w of T.getAllExtensionDescriptions())if(w.contributes){const M=w.contributes.debuggers;if(M&&M.length>0)for(const A of M)(0,l.$rI)(A)&&$.push(A.type)}this.u.$registerDebugTypes($)}get activeStackItem(){return this.J}get onDidChangeActiveStackItem(){return this.L.event}get onDidChangeBreakpoints(){return this.I.event}get breakpoints(){const T=[];return this.H.forEach($=>T.push($)),T}async $resolveDebugVisualizer(T,$){const w=this.W.get(T);if(!w)throw new Error(`No debug visualizer found with id '${T}'`);let{v:M,provider:A,extensionId:L}=w;if(M.visualization||(M=await A.resolveDebugVisualization?.(M,$)||M,w.v=M),!M.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${A}'`);return this.vb(L,M.visualization)}async $executeDebugVisualizerCommand(T){const $=this.W.get(T);if(!$)throw new Error(`No debug visualizer found with id '${T}'`);const w=$.v.visualization;w&&"command"in w&&this.cb.executeCommand(w.command,...w.arguments||[])}gb(T){const $=this.w.get(T.sessionId);return $&&{session:$.api,variable:T.variable,containerId:T.containerId,frameId:T.frameId,threadId:T.threadId}}async $provideDebugVisualizers(T,$,w,M){const A=this.gb(w),L=this.ub(T,$),J=this.P.get(L);if(!A||!J)return[];const Y=await J.provideDebugVisualization(A,M);return Y?Y.map(z=>{const Q=++this.X;this.W.set(Q,{v:z,provider:J,extensionId:T});const V=z.iconPath?this.wb(z.iconPath):void 0;return{id:Q,name:z.name,iconClass:V?.iconClass,iconPath:V?.iconPath,visualization:this.vb(T,z.visualization)}}):[]}$disposeDebugVisualizers(T){for(const $ of T)this.W.delete($)}registerDebugVisualizationProvider(T,$,w){if(!T.contributes?.debugVisualizers?.some(L=>L.id===$))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${$})`);const M=R.$vn.toKey(T.identifier),A=this.ub(M,$);if(this.P.has(A))throw new Error(`A debug visualization provider with id '${$}' is already registered`);return this.P.set(A,w),this.u.$registerDebugVisualizer(M,$),(0,N.$Vc)(()=>{this.u.$unregisterDebugVisualizer(M,$),this.P.delete($)})}addBreakpoints(T){const $=T.filter(A=>{const L=A.id;return this.H.has(L)?!1:(this.H.set(L,A),!0)});this.rb($,[],[]);const w=[],M=new Map;for(const A of $)if(A instanceof h.$9O){let L=M.get(A.location.uri.toString());L||(L={type:"sourceMulti",uri:A.location.uri,lines:[]},M.set(A.location.uri.toString(),L),w.push(L)),L.lines.push({id:A.id,enabled:A.enabled,condition:A.condition,hitCondition:A.hitCondition,logMessage:A.logMessage,line:A.location.range.start.line,character:A.location.range.start.character,mode:A.mode})}else A instanceof h.$0O&&w.push({type:"function",id:A.id,enabled:A.enabled,hitCondition:A.hitCondition,logMessage:A.logMessage,condition:A.condition,functionName:A.functionName,mode:A.mode});return this.u.$registerBreakpoints(w)}removeBreakpoints(T){const $=T.filter(L=>this.H.delete(L.id));this.rb([],$,[]);const w=$.filter(L=>L instanceof h.$9O).map(L=>L.id),M=$.filter(L=>L instanceof h.$0O).map(L=>L.id),A=$.filter(L=>L instanceof h.$$O).map(L=>L.id);return this.u.$unregisterBreakpoints(w,M,A)}startDebugging(T,$,w){const M=w.testRun&&this.db.getMetadataForRun(w.testRun);return this.u.$startDebugging(T?T.uri:void 0,$,{parentSessionID:w.parentSession?w.parentSession.id:void 0,lifecycleManagedByParent:w.lifecycleManagedByParent,repl:w.consoleMode===h.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:w.noDebug,compact:w.compact,suppressSaveBeforeStart:w.suppressSaveBeforeStart,testRun:M&&{runId:M.runId,taskId:M.taskId},suppressDebugStatusbar:w.suppressDebugStatusbar??w.debugUI?.simple,suppressDebugToolbar:w.suppressDebugToolbar??w.debugUI?.simple,suppressDebugView:w.suppressDebugView??w.debugUI?.simple})}stopDebugging(T){return this.u.$stopDebugging(T?T.id:void 0)}registerDebugConfigurationProvider(T,$,w){if(!$)return new h.$5N(()=>{});const M=this.f++;return this.g.push({type:T,handle:M,provider:$}),this.u.$registerDebugConfigurationProvider(T,w,!!$.provideDebugConfigurations,!!$.resolveDebugConfiguration,!!$.resolveDebugConfigurationWithSubstitutedVariables,M),new h.$5N(()=>{this.g=this.g.filter(A=>A.provider!==$),this.u.$unregisterDebugConfigurationProvider(M)})}registerDebugAdapterDescriptorFactory(T,$,w){if(!w)return new h.$5N(()=>{});if(!this.nb(T,$))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${$}' debugger.`);if(this.kb($))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const M=this.h++;return this.j.push({type:$,handle:M,factory:w}),this.u.$registerDebugAdapterDescriptorFactory($,M),new h.$5N(()=>{this.j=this.j.filter(A=>A.factory!==w),this.u.$unregisterDebugAdapterDescriptorFactory(M)})}registerDebugAdapterTrackerFactory(T,$){if(!$)return new h.$5N(()=>{});const w=this.m++;return this.n.push({type:T,handle:w,factory:$}),new h.$5N(()=>{this.n=this.n.filter(M=>M.factory!==$)})}async $runInTerminal(T,$){return Promise.resolve(void 0)}async $substituteVariables(T,$){let w;const M=await this.tb(T);return M&&(w={uri:M.uri,name:M.name,index:M.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.bb.getResolver()).resolveAnyAsync(w,$)}hb(T,$){if(T.type==="implementation")return new k(T.implementation)}ib(){}async $startDASession(T,$){const w=this,M=await this.sb($);return this.pb(this.kb(M.type),M).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${M.type}' (extension might have failed to activate)`);const L=this.jb(A),J=this.hb(L,M);if(!J)throw new Error(`Couldn't create a debug adapter for type '${M.type}'.`);const Y=J;return this.M.set(T,Y),this.ob(M).then(z=>(z&&this.N.set(T,z),Y.onMessage(async Q=>{if(Q.type==="request"&&Q.command==="handshake"){const V=Q,ie={type:"response",seq:0,command:V.command,request_seq:V.seq,success:!0};this.U||(this.U=this.ib());try{if(this.U){const le=await this.U.sign(V.arguments.value);ie.body={signature:le},Y.sendResponse(ie)}else throw new Error("no signer")}catch(le){ie.success=!1,ie.message=le.message,Y.sendResponse(ie)}}else z&&z.onDidSendMessage&&z.onDidSendMessage(Q),Q=(0,l.$wI)(Q,!0),w.u.$acceptDAMessage(T,Q)}),Y.onError(Q=>{z&&z.onError&&z.onError(Q),this.u.$acceptDAError(T,Q.name,Q.message,Q.stack)}),Y.onExit(Q=>{z&&z.onExit&&z.onExit(Q??void 0,void 0),this.u.$acceptDAExit(T,Q??void 0,void 0)}),z&&z.onWillStartSession&&z.onWillStartSession(),Y.startSession()))})}$sendDAMessage(T,$){$=(0,l.$vI)($,!1);const w=this.N.get(T);w&&w.onWillReceiveMessage&&w.onWillReceiveMessage($),this.M.get(T)?.sendMessage($)}$stopDASession(T){const $=this.N.get(T);this.N.delete(T),$&&$.onWillStopSession&&$.onWillStopSession();const w=this.M.get(T);return this.M.delete(T),w?w.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(T){const $=[],w=[],M=[];if(T.added)for(const A of T.added){const L=A.id;if(L&&!this.H.has(L)){let J;if(A.type==="function")J=new h.$0O(A.functionName,A.enabled,A.condition,A.hitCondition,A.logMessage,A.mode);else if(A.type==="data")J=new h.$$O(A.label,A.dataId,A.canPersist,A.enabled,A.hitCondition,A.condition,A.logMessage,A.mode);else{const Y=P.URI.revive(A.uri);J=new h.$9O(new h.$gO(Y,new h.$6N(A.line,A.character)),A.enabled,A.condition,A.hitCondition,A.logMessage,A.mode)}(0,h.$7O)(J,L),this.H.set(L,J),$.push(J)}}if(T.removed)for(const A of T.removed){const L=this.H.get(A);L&&(this.H.delete(A),w.push(L))}if(T.changed){for(const A of T.changed)if(A.id){const L=this.H.get(A.id);if(L){if(L instanceof h.$0O&&A.type==="function"){const J=L;J.enabled=A.enabled,J.condition=A.condition,J.hitCondition=A.hitCondition,J.logMessage=A.logMessage,J.functionName=A.functionName}else if(L instanceof h.$9O&&A.type==="source"){const J=L;J.enabled=A.enabled,J.condition=A.condition,J.hitCondition=A.hitCondition,J.logMessage=A.logMessage,J.location=new h.$gO(P.URI.revive(A.uri),new h.$6N(A.line,A.character))}M.push(L)}}}this.rb($,w,M)}async $acceptStackFrameFocus(T){let $;if(T){const w=await this.sb(T.sessionId);T.kind==="thread"?$=new h.$eP(w.api,T.threadId):$=new h.$dP(w.api,T.threadId,T.frameId)}this.J=$,this.L.fire(this.J)}$provideDebugConfigurations(T,$,w){return(0,v.$Ah)(async()=>{const M=this.mb(T);if(!M)throw new Error("no DebugConfigurationProvider found");if(!M.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const A=await this.tb($);return M.provideDebugConfigurations(A,w)}).then(M=>{if(!M)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return M})}$resolveDebugConfiguration(T,$,w,M){return(0,v.$Ah)(async()=>{const A=this.mb(T);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const L=await this.tb($);return A.resolveDebugConfiguration(L,w,M)})}$resolveDebugConfigurationWithSubstitutedVariables(T,$,w,M){return(0,v.$Ah)(async()=>{const A=this.mb(T);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const L=await this.tb($);return A.resolveDebugConfigurationWithSubstitutedVariables(L,w,M)})}async $provideDebugAdapter(T,$){const w=this.lb(T);if(!w)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const M=await this.sb($);return this.pb(w,M).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${M.type}'`);return this.jb(A)})}async $acceptDebugSessionStarted(T){const $=await this.sb(T);this.y.fire($.api)}async $acceptDebugSessionTerminated(T){const $=await this.sb(T);$&&(this.z.fire($.api),this.w.delete($.id))}async $acceptDebugSessionActiveChanged(T){this.D=T?await this.sb(T):void 0,this.C.fire(this.D?.api)}async $acceptDebugSessionNameChanged(T,$){(await this.sb(T))?._acceptNameChanged($)}async $acceptDebugSessionCustomEvent(T,$){const M={session:(await this.sb(T)).api,event:$.event,body:$.body};this.F.fire(M)}jb(T){if(T instanceof h.$_O)return{type:"executable",command:T.command,args:T.args,options:T.options};if(T instanceof h.$aP)return{type:"server",port:T.port,host:T.host};if(T instanceof h.$bP)return{type:"pipeServer",path:T.path};if(T instanceof h.$cP)return{type:"implementation",implementation:T.implementation};throw new Error("convertToDto unexpected type")}kb(T){const $=this.j.filter(w=>w.type===T);if($.length>0)return $[0].factory}lb(T){const $=this.j.filter(w=>w.handle===T);if($.length>0)return $[0].factory}mb(T){const $=this.g.filter(w=>w.handle===T);if($.length>0)return $[0].provider}nb(T,$){if(T.contributes){const w=T.contributes.debuggers;if(w&&w.length>0){for(const M of w)if(M.label&&M.type&&M.type===$)return!0}}return!1}ob(T){const w=T.configuration.type,M=this.n.filter(A=>A.type===w||A.type==="*").map(A=>(0,v.$Ah)(()=>A.factory.createDebugAdapterTracker(T.api)).then(L=>L,L=>null));return Promise.race([Promise.all(M).then(A=>{const L=(0,o.$Jb)(A);if(L.length>0)return new S(L)}),new Promise(A=>setTimeout(()=>A(void 0),1e3))]).catch(A=>{})}async pb(T,$){const w=$.configuration.debugServer;if(typeof w=="number")return Promise.resolve(new h.$aP(w));if(T){const A=await this.Z.getExtensionRegistry();return(0,v.$Ah)(()=>T.createDebugAdapterDescriptor($.api,this.qb($,A))).then(L=>{if(L)return L})}const M=await this.Z.getExtensionRegistry();return Promise.resolve(this.qb($,M))}qb(T,$){}rb(T,$,w){(T.length>0||$.length>0||w.length>0)&&this.I.fire(Object.freeze({added:T,removed:$,changed:w}))}async sb(T){if(T)if(typeof T=="string"){const $=this.w.get(T);if($)return $}else{let $=this.w.get(T.id);if(!$){const w=await this.tb(T.folderUri),M=T.parent?this.w.get(T.parent):void 0;$=new g(this.u,T.id,T.type,T.name,w,T.configuration,M?.api),this.w.set($.id,$),this.u.$sessionCached($.id)}return $}throw new Error("cannot find session")}tb(T){if(T){const $=P.URI.revive(T);return this.Y.resolveWorkspaceFolder($)}return Promise.resolve(void 0)}ub(T,$){return`${T}\0${$}`}vb(T,$){if($){if("title"in $&&"command"in $)return{type:r.DebugVisualizationType.Command};if("treeId"in $)return{type:r.DebugVisualizationType.Tree,id:`${T}\0${$.treeId}`};throw new Error("Unsupported debug visualization type")}}wb(T){const $=this.xb(T);let w,M;return"id"in $?M=i.ThemeIcon.asClassName($):w=$,{iconPath:w,iconClass:M}}xb(T){if(T instanceof h.$4O)return{id:T.id};const $=typeof T=="object"&&"dark"in T?T.dark:T,w=typeof T=="object"&&"light"in T?T.light:T;return{dark:typeof $=="string"?P.URI.file($):$,light:typeof w=="string"?P.URI.file(w):w}}};e.$Krc=m,e.$Krc=m=Ke([We(0,b.$DQ),We(1,E.$Vqc),We(2,I.$zrc),We(3,d.$Yqc),We(4,s.$$qc),We(5,a.$Crc),We(6,n.$ZQ),We(7,c.$Erc)],m);class g{constructor(T,$,w,M,A,L,J){this.f=T,this.g=$,this.h=w,this.j=M,this.k=A,this.l=L,this.m=J}get api(){const T=this;return this.d??=Object.freeze({id:T.g,type:T.h,get name(){return T.j},set name($){T.j=$,T.f.$setDebugSessionName(T.g,$)},parentSession:T.m,workspaceFolder:T.k,configuration:T.l,customRequest($,w){return T.f.$customDebugAdapterRequest(T.g,$,w)},getDebugProtocolBreakpoint($){return T.f.$getDebugProtocolBreakpoint(T.g,$.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(T){this.j=T}get configuration(){return this.l}}e.$Lrc=g;class u{constructor(T){this.value=Object.freeze({append($){T.$appendDebugConsole($)},appendLine($){this.append($+`
`)}})}}e.$Mrc=u;class S{constructor(T){this.d=T}onWillStartSession(){this.d.forEach(T=>T.onWillStartSession?T.onWillStartSession():void 0)}onWillReceiveMessage(T){this.d.forEach($=>$.onWillReceiveMessage?$.onWillReceiveMessage(T):void 0)}onDidSendMessage(T){this.d.forEach($=>$.onDidSendMessage?$.onDidSendMessage(T):void 0)}onWillStopSession(){this.d.forEach(T=>T.onWillStopSession?T.onWillStopSession():void 0)}onError(T){this.d.forEach($=>$.onError?$.onError(T):void 0)}onExit(T,$){this.d.forEach(w=>w.onExit?w.onExit(T,$):void 0)}}class k extends f.$Dub{constructor(T){super(),this.h=T,T.onDidSendMessage($=>{this.acceptMessage($)})}startSession(){return Promise.resolve(void 0)}sendMessage(T){this.h.handleMessage(T)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let y=class extends m{constructor(T,$,w,M,A,L,J,Y){super(T,$,w,M,A,L,J,Y)}};e.$Nrc=y,e.$Nrc=y=Ke([We(0,b.$DQ),We(1,E.$Vqc),We(2,I.$zrc),We(3,d.$Yqc),We(4,s.$$qc),We(5,a.$Crc),We(6,n.$ZQ),We(7,c.$Erc)],y)}),define(Re[273],Te([1,0,12,64,2,5,223,11,60,75,26,170,16,65,47,66]),function(we,e,v,D,P,N,R,O,p,s,I,b,h,E,f,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tsc=e.$Ssc=void 0,v=qe(v),D=qe(D);class l{static async installEarlyHandler(i){Error.stackTraceLimit=100;const n=i.get(O.$dk),o=i.get(h.$DQ).getProxy(N.$3N.MainThreadErrors);v.setUnexpectedErrorHandler(c=>{n.error(c);const m=v.$4(c);o.$onUnexpectedError(m)})}static async installFullHandler(i){const n=i.get(O.$dk),t=i.get(h.$DQ),o=i.get(f.$zrc),c=i.get(r.$XQ),m=t.getProxy(N.$3N.MainThreadExtensionService),g=t.getProxy(N.$3N.MainThreadErrors),u=await o.getExtensionPathIndex(),S=new WeakMap;function k(T,$){if(S.has(T))return S.get(T).stack;let w="",M,A;for(const J of $)w+=`
	at ${J.toString()}`,A=J.getFileName(),!M&&A&&(M=u.findSubstr(P.URI.file(A)));const L=`${T.name||"Error"}: ${T.message||""}${w}`;return S.set(T,{extensionIdentifier:M?.identifier,stack:L}),L}const y=Symbol("prepareStackTrace wrapped");let C=k;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return C},set(T){if(T===k||!T||T[y]){C=T||k;return}C=function($,w){return k($,w),T.call(Error,$,w)},Object.assign(C,{[y]:!0})}}),v.setUnexpectedErrorHandler(T=>{n.error(T);const $=v.$4(T),w=S.get(T);if(!w?.extensionIdentifier){g.$onUnexpectedError($);return}m.$onExtensionRuntimeError(w.extensionIdentifier,$);const M=c.onExtensionError(w.extensionIdentifier,T);n.trace("forwarded error to extension?",M,w)})}}e.$Ssc=l;class d{constructor(i,n,t,o,c){this.a=t,this.b=new R.$Wec(i,null,o),n=d.e(n,this.b);const m=new s.$Gi(...(0,p.$Ys)());m.set(I.$TQ,{_serviceBrand:void 0,...n,messagePorts:c}),m.set(h.$DQ,new h.$EQ(this.b)),m.set(E.$Sqc,new E.$Tqc(o)),m.set(f.$xrc,t);const g=new b.$Cr(m,!0);g.invokeFunction(l.installEarlyHandler),this.d=g.invokeFunction(u=>u.get(O.$dk)),D.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",n),this.c=g.invokeFunction(u=>u.get(f.$zrc)),this.c.initialize(),g.invokeFunction(l.installFullHandler)}async asBrowserUri(i){const n=this.b.getProxy(N.$3N.MainThreadExtensionService);return P.URI.revive(await n.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,n){i.extensions.allExtensions.forEach(o=>{o.extensionLocation=P.URI.revive(n.transformIncomingURIs(o.extensionLocation))}),i.environment.appRoot=P.URI.revive(n.transformIncomingURIs(i.environment.appRoot));const t=i.environment.extensionDevelopmentLocationURI;return t&&(i.environment.extensionDevelopmentLocationURI=t.map(o=>P.URI.revive(n.transformIncomingURIs(o)))),i.environment.extensionTestsLocationURI=P.URI.revive(n.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=P.URI.revive(n.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=P.URI.revive(n.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=P.URI.revive(n.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=P.URI.revive(n.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=P.URI.revive(n.transformIncomingURIs(i.logsLocation)),i.workspace=n.transformIncomingURIs(i.workspace),i}}e.$Tsc=d}),define(Re[274],Te([1,0,17,58]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9rc=e.$8rc=e.$5rc=void 0,e.$6rc=p,e.$7rc=s,e.$0rc=E;function P(f){return"uri"in f&&"ranges"in f&&"preview"in f}function N(f){return f.folderOptions.map(r=>({folder:r.folder,excludes:r.excludes.map(l=>typeof l=="string"?l:l.pattern),includes:r.includes,useGlobalIgnoreFiles:r.useIgnoreFiles.global,useIgnoreFiles:r.useIgnoreFiles.local,useParentIgnoreFiles:r.useIgnoreFiles.parent,followSymlinks:r.followSymlinks,maxResults:f.maxResults,session:f.session}))}class R{constructor(r){this.a=r}provideFileSearchResults(r,l,d){return(async()=>{const i=N(l);return Promise.all(i.map(n=>this.a.provideFileSearchResults({pattern:r},n,d)))})().then(i=>(0,v.$Jb)(i).flat())}}e.$5rc=R;function O(f){return f.folderOptions.map(r=>({folder:r.folder,excludes:r.excludes.map(l=>typeof l=="string"?l:l.pattern),includes:r.includes,useGlobalIgnoreFiles:r.useIgnoreFiles.global,useIgnoreFiles:r.useIgnoreFiles.local,useParentIgnoreFiles:r.useIgnoreFiles.parent,followSymlinks:r.followSymlinks,maxResults:f.maxResults,previewOptions:p(f.previewOptions),maxFileSize:f.maxFileSize,encoding:r.encoding,afterContext:f.surroundingContext,beforeContext:f.surroundingContext}))}function p(f){if(!(!f||f.matchLines===void 0&&f.charsPerLine===void 0))return{matchLines:f.matchLines??100,charsPerLine:f.charsPerLine??1e4}}function s(f){if(P(f)){const r=(0,v.$4b)(f.ranges).map((l,d)=>{const i=(0,v.$4b)(f.preview.matches)[d];return{sourceRange:l,previewRange:i}});return new D.$fM(f.uri,r,f.preview.text)}else return new D.$gM(f.uri,f.text,f.lineNumber)}class I{constructor(r){this.a=r}provideTextSearchResults(r,l,d,a){const i=o=>{h(o)&&d.report(s(o))};return(async()=>(0,v.$Jb)(await Promise.all(O(l).map(o=>this.a.provideTextSearchResults(r,o,{report:c=>i(c)},a)))).reduce((o,c)=>({limitHit:o.limitHit||c.limitHit}),{limitHit:!1}))().then(o=>({limitHit:o.limitHit,message:(0,v.$Jb)((0,v.$4b)(o.message))}))}}e.$8rc=I;class b{constructor(r){this.a=r}provideAITextSearchResults(r,l,d,a){const i=o=>{h(o)&&d.report(s(o))};return(async()=>(0,v.$Jb)(await Promise.all(O(l).map(o=>this.a.provideAITextSearchResults(r,o,{report:c=>i(c)},a)))).reduce((o,c)=>({limitHit:o.limitHit||c.limitHit}),{limitHit:!1}))().then(o=>({limitHit:o.limitHit,message:(0,v.$Jb)((0,v.$4b)(o.message))}))}}e.$9rc=b;function h(f){if(E(f)){if(Array.isArray(f.ranges)){if(!Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(f.preview.matches.length!==f.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}function E(f){return!!f.preview}}),define(Re[275],Te([1,0,10,19,42,15,22,24,48,2,44,58]),function(we,e,v,D,P,N,R,O,p,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4rc=e.$3rc=e.$2rc=void 0,R=qe(R),O=qe(O);class h{constructor(a,i,n){this.f=a,this.g=i,this.h=n,this.b=null,this.c=!1,this.d=0}get j(){return this.f.query}search(a,i){const n=this.j.folderQueries||[],t=new D.$ze(i);return new Promise((o,c)=>{this.b=new f(a);let m=!1;const g=(u,S)=>{if(!m&&!this.c){const k=this.l(u);u instanceof b.$fM&&typeof this.j.maxResults=="number"&&this.d+k>this.j.maxResults&&(this.c=!0,m=!0,t.cancel(),u=this.m(u,this.j.maxResults-this.d));const y=this.l(u);this.d+=y;const C=u instanceof b.$fM;(y>0||!C)&&this.b.add(u,S)}};this.n(n,g,t.token).then(u=>{t.dispose(),this.b.flush(),o({limitHit:this.c||u?.limitHit,messages:this.k(u),stats:{type:this.h}})},u=>{t.dispose();const S=(0,P.$tj)(u);c(new Error(S))})})}k(a){return a?.message?Array.isArray(a.message)?a.message:[a.message]:[]}l(a){return a instanceof b.$fM?Array.isArray(a.ranges)?a.ranges.length:1:0}m(a,i){return new b.$fM(a.uri,a.ranges.slice(0,i),a.previewText)}async n(a,i,n){const t=p.$Oi.forUris();a.forEach((S,k)=>{const y=new I.$GM(this.j,S);t.set(S.folder,{queryTester:y,folder:S.folder,folderIdx:k})});const o=[],c={report:S=>{const k=t.findSubstr(S.uri),y=k.folder.scheme===N.Schemas.file?(0,I.$HM)(()=>this.g.readdir(O.$ih(S.uri))):void 0,C=O.$lh(k.folder,S.uri);if(C){const T=k.queryTester.includedInQuery(C,R.$qc(C),y);(0,v.$uh)(T)?o.push(T.then($=>{$&&i(S,k.folderIdx)})):T&&i(S,k.folderIdx)}}},g={folderOptions:a.map(S=>this.o(S)),maxFileSize:this.j.maxFileSize,maxResults:this.j.maxResults??I.$mM,previewOptions:this.j.previewOptions,surroundingContext:this.j.surroundingContext??0};"usePCRE2"in this.j&&(g.usePCRE2=this.j.usePCRE2);let u;return this.f.query.type===I.QueryType.aiText?u=await this.f.provider.provideAITextSearchResults(this.f.query.contentPattern,g,c,n):u=await this.f.provider.provideTextSearchResults(E(this.f.query.contentPattern),g,c,n),o.length&&await Promise.all(o),u}o(a){const i=(0,I.$FM)(this.j.includePattern,a.includePattern);let n=a.excludePattern?.map(c=>({folder:c.folder,patterns:(0,I.$FM)(this.j.excludePattern,c.pattern)}));(!n||n.length===0)&&(n=[{folder:void 0,patterns:(0,I.$FM)(this.j.excludePattern,void 0)}]);const t=(0,I.$JM)(n);return{folder:s.URI.from(a.folder),excludes:t,includes:i,useIgnoreFiles:{local:!a.disregardIgnoreFiles,parent:!a.disregardParentIgnoreFiles,global:!a.disregardGlobalIgnoreFiles},followSymlinks:!a.ignoreSymlinks,encoding:(a.fileEncoding&&this.g.toCanonicalName(a.fileEncoding))??""}}}e.$2rc=h;function E(d){return{isCaseSensitive:d.isCaseSensitive||!1,isRegExp:d.isRegExp||!1,isWordMatch:d.isWordMatch||!1,isMultiline:d.isMultiline||!1,pattern:d.pattern}}class f{constructor(a){this.g=a,this.c=-1,this.f=null,this.b=new l(512,i=>this.j(i))}add(a,i){this.f&&(this.c!==i||!O.$ch(this.d,a.uri))&&(this.h(),this.f=null),this.f||(this.c=i,this.f={resource:a.uri,results:[]}),this.f.results.push(r(a))}h(){const a=this.f&&this.f.results?this.f.results.length:0;this.b.addItem(this.f,a)}flush(){this.h(),this.b.flush()}j(a){this.g(a)}}e.$3rc=f;function r(d){return d instanceof b.$fM?{previewText:d.previewText,rangeLocations:d.ranges.map(a=>({preview:{startLineNumber:a.previewRange.start.line,startColumn:a.previewRange.start.character,endLineNumber:a.previewRange.end.line,endColumn:a.previewRange.end.character},source:{startLineNumber:a.sourceRange.start.line,startColumn:a.sourceRange.start.character,endLineNumber:a.sourceRange.end.line,endColumn:a.sourceRange.end.character}}))}:{text:d.text,lineNumber:d.lineNumber}}class l{static{this.b=4e3}static{this.c=50}constructor(a,i){this.j=a,this.k=i,this.d=0,this.f=[],this.g=0}addItem(a,i){a&&this.l(a,i)}addItems(a,i){a&&this.m(a,i)}l(a,i){this.f.push(a),this.g+=i,this.n()}m(a,i){this.f=this.f.concat(a),this.g+=i,this.n()}n(){this.d<l.c?this.flush():this.g>=this.j?this.flush():this.h||(this.h=setTimeout(()=>{this.flush()},l.b))}flush(){this.g&&(this.d+=this.g,this.k(this.f),this.f=[],this.g=0,this.h&&(clearTimeout(this.h),this.h=0))}}e.$4rc=l}),define(Re[135],Te([1,0,4,5,3,269,16,65,11,2,275,33,274]),function(we,e,v,D,P,N,R,O,p,s,I,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_rc=e.$$rc=void 0,e.$asc=f,e.$$rc=(0,P.$Ii)("IExtHostSearch");let E=class{constructor(d,a,i){this.n=d,this.o=a,this.q=i,this.c=this.n.getProxy(D.$3N.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new N.$1rc}s(d){return this.o.transformOutgoingScheme(d)}registerTextSearchProviderOld(d,a){if(this.g.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this.g.add(d);const i=this.d++;return this.e.set(i,new h.$8rc(a)),this.c.$registerTextSearchProvider(i,this.s(d)),(0,v.$Vc)(()=>{this.g.delete(d),this.e.delete(i),this.c.$unregisterProvider(i)})}registerTextSearchProvider(d,a){if(this.g.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this.g.add(d);const i=this.d++;return this.e.set(i,a),this.c.$registerTextSearchProvider(i,this.s(d)),(0,v.$Vc)(()=>{this.g.delete(d),this.e.delete(i),this.c.$unregisterProvider(i)})}registerAITextSearchProviderOld(d,a){if(this.i.has(d))throw new Error(`an AI text search provider for the scheme '${d}'is already registered`);this.i.add(d);const i=this.d++;return this.h.set(i,new h.$9rc(a)),this.c.$registerAITextSearchProvider(i,this.s(d)),(0,v.$Vc)(()=>{this.i.delete(d),this.h.delete(i),this.c.$unregisterProvider(i)})}registerAITextSearchProvider(d,a){if(this.i.has(d))throw new Error(`an AI text search provider for the scheme '${d}'is already registered`);this.i.add(d);const i=this.d++;return this.h.set(i,a),this.c.$registerAITextSearchProvider(i,this.s(d)),(0,v.$Vc)(()=>{this.i.delete(d),this.h.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProviderOld(d,a){if(this.k.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this.k.add(d);const i=this.d++;return this.j.set(i,new h.$5rc(a)),this.c.$registerFileSearchProvider(i,this.s(d)),(0,v.$Vc)(()=>{this.k.delete(d),this.j.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider(d,a){if(this.k.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this.k.add(d);const i=this.d++;return this.j.set(i,a),this.c.$registerFileSearchProvider(i,this.s(d)),(0,v.$Vc)(()=>{this.k.delete(d),this.j.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults(d,a,i,n){const t=f(i),o=this.j.get(d);if(o)return this.l.fileSearch(t,o,c=>{this.c.$handleFileMatch(d,a,c.map(m=>m.resource))},n);throw new Error("unknown provider: "+d)}async doInternalFileSearchWithCustomCallback(d,a,i){return{messages:[]}}$clearCache(d){return this.l.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,a,i,n){const t=this.e.get(d);if(!t||!t.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${d}`);const o=f(i);return this.t(o,t).search(m=>this.c.$handleTextMatch(d,a,m),n)}$provideAITextSearchResults(d,a,i,n){const t=this.h.get(d);if(!t||!t.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${d}`);const o=f(i);return this.v(o,t).search(m=>this.c.$handleTextMatch(d,a,m),n)}$enableExtensionHostSearch(){}t(d,a){return new I.$2rc({query:d,provider:a},{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}v(d,a){return new I.$2rc({query:d,provider:a},{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"aiTextSearchProvider")}};e.$_rc=E,e.$_rc=E=Ke([We(0,R.$DQ),We(1,O.$Sqc),We(2,p.$dk)],E);function f(l){return{...l,folderQueries:l.folderQueries&&l.folderQueries.map(r),extraFileResources:l.extraFileResources&&l.extraFileResources.map(d=>s.URI.revive(d))}}function r(l){return(0,b.$fi)(l)}});var si=this&&this.__importDefault||function(we){return we&&we.__esModule?we:{default:we}};define(Re[276],Te([1,0,19,12,6,4,15,36,2,106,157,158,52,18,28,11,62,63,184,5,226,255,85,91,231,232,233,210,200,34,234,46,235,134,124,236,212,227,237,238,57,70,213,228,47,240,68,241,50,26,256,214,242,243,95,244,86,87,216,268,246,189,247,257,248,130,217,249,250,251,16,252,135,88,253,218,254,89,92,132,66,56,128,96,258,229,259,260,93,8,7,219,65,220,67,261,262,123,45,81,84,21,58]),function(we,e,v,D,P,N,R,O,p,s,I,b,h,E,f,r,l,d,a,i,n,t,o,c,m,g,u,S,k,y,C,T,$,w,M,A,L,J,Y,z,Q,V,ie,le,_,oe,re,ce,x,$e,Pe,X,q,ne,be,Ie,Fe,Be,xe,nt,ut,pt,lt,et,Ne,Me,Le,B,j,H,G,se,ge,Ee,Ue,Je,_e,tt,at,it,ot,vt,Ye,he,pe,ye,Ce,fe,ve,Z,W,de,je,Qe,st,ht,gt,Rt,Ot,Qt,_t,Xe,At){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nsc=Ut,D=qe(D),O=si(O),b=qe(b),f=qe(f),Z=qe(Z),W=qe(W);function Ut($t){const Pt=$t.get($e.$TQ),ei=$t.get(x.$Dqc),ti=$t.get(re.$1qc),Ht=$t.get(_.$zrc),wt=$t.get(Ot.$Vqc),Nt=$t.get(ot.$XQ),ai=$t.get(T.$Yqc),Xt=$t.get(je.$Sqc),Ge=$t.get(G.$DQ),ii=$t.get(tt.$hrc),ci=$t.get(at.$2qc),ui=$t.get(r.$ek),Et=$t.get(r.$dk),jt=$t.get(ve.$PGb),Lt=$t.get(o.$zqc),Bt=$t.get(Rt.$Msc),oi=$t.get(Ee.$rrc),ni=$t.get(V.$$qc),ri=$t.get(Be.$vrc),Kt=$t.get(c.$Jqc),Gt=$t.get(be.$orc);Ge.set(i.$4N.ExtHostFileSystemInfo,ei),Ge.set(i.$4N.ExtHostLogLevelServiceShape,ui),Ge.set(i.$4N.ExtHostWorkspace,wt),Ge.set(i.$4N.ExtHostConfiguration,ai),Ge.set(i.$4N.ExtHostExtensionService,Ht),Ge.set(i.$4N.ExtHostStorage,ii),Ge.set(i.$4N.ExtHostTunnelService,jt),Ge.set(i.$4N.ExtHostWindow,Bt),Ge.set(i.$4N.ExtHostSecretState,oi),Ge.set(i.$4N.ExtHostTelemetry,Nt),Ge.set(i.$4N.ExtHostEditorTabs,ni),Ge.set(i.$4N.ExtHostManagedSockets,ri),Ge.set(i.$4N.ExtHostAuthentication,Kt),Ge.set(i.$4N.ExtHostChatProvider,Gt);const li=Ge.set(i.$4N.ExtHostDecorations,$t.get(M.$Prc)),Mt=Ge.set(i.$4N.ExtHostDocumentsAndEditors,$t.get(Q.$OQ)),Dt=Ge.set(i.$4N.ExtHostCommands,$t.get(y.$ZQ)),bt=Ge.set(i.$4N.ExtHostTerminalService,$t.get(vt.$krc)),Jt=Ge.set(i.$4N.ExtHostTerminalShellIntegration,$t.get(Ye.$Csc)),St=Ge.set(i.$4N.ExtHostDebugService,$t.get(w.$Jrc)),hi=Ge.set(i.$4N.ExtHostSearch,$t.get(ge.$$rc)),Zt=Ge.set(i.$4N.ExtHostTask,$t.get(it.$Bsc)),Mi=Ge.set(i.$4N.ExtHostOutputService,$t.get(Me.$osc)),di=Ge.set(i.$4N.ExtHostLocalization,$t.get(Fe.$urc)),yi=Ge.set(i.$4N.ExtHostUrls,new Qe.$Jsc(Ge)),qt=Ge.set(i.$4N.ExtHostDocuments,new z.$Gqc(Ge,Mt)),fi=Ge.set(i.$4N.ExtHostDocumentContentProviders,new J.$Rrc(Ge,Mt,Et)),Fi=Ge.set(i.$4N.ExtHostDocumentSaveParticipant,new Y.$Src(Et,qt,Ge.getProxy(i.$3N.MainThreadBulkEdits))),Ct=Ge.set(i.$4N.ExtHostNotebook,new nt.$bsc(Ge,Dt,Mt,qt,ti,hi,Et)),Si=Ge.set(i.$4N.ExtHostNotebookDocuments,new pt.$isc(Ct)),Ai=Ge.set(i.$4N.ExtHostNotebookEditors,new lt.$jsc(Et,Ct)),gi=Ge.set(i.$4N.ExtHostNotebookKernels,new et.$ksc(Ge,Pt,Ct,Dt,Et)),zi=Ge.set(i.$4N.ExtHostNotebookRenderers,new Ne.$msc(Ge,Ct)),ji=Ge.set(i.$4N.ExtHostNotebookDocumentSaveParticipant,new ut.$hsc(Et,Ct,Ge.getProxy(i.$3N.MainThreadBulkEdits))),zt=Ge.set(i.$4N.ExtHostEditors,new pe.$Pqc(Ge,Mt)),Pi=Ge.set(i.$4N.ExtHostTreeViews,new fe.$Hsc(Ge.getProxy(i.$3N.MainThreadTreeViews),Dt,Et)),Di=Ge.set(i.$4N.ExtHostEditorInsets,new k.$Qqc(Ge.getProxy(i.$3N.MainThreadEditorInsets),zt,Pt.remote)),wi=Ge.set(i.$4N.ExtHostDiagnostics,new A.$Fqc(Ge,Et,ei,Mt)),bi=Ge.set(i.$4N.ExtHostLanguages,new Ie.$fsc(Ge,qt,Dt.converter,Xt)),me=Ge.set(i.$4N.ExtHostLanguageFeatures,new q.$Hqc(Ge,Xt,qt,Dt,wi,Et,Lt,Nt)),De=Ge.set(i.$4N.ExtHostFileSystem,new oe.$Vrc(Ge,me)),ae=Ge.set(i.$4N.ExtHostFileSystemEventService,new ce.$Wrc(Ge,Et,Mt)),K=Ge.set(i.$4N.ExtHostQuickOpen,(0,H.$ssc)(Ge,wt,Dt)),ke=Ge.set(i.$4N.ExtHostSCM,new se.$usc(Ge,Dt,qt,Et)),ze=Ge.set(i.$4N.ExtHostQuickDiff,new j.$rsc(Ge,Xt)),Ze=Ge.set(i.$4N.ExtHostShare,new Ue.$vsc(Ge,Xt)),Ve=Ge.set(i.$4N.ExtHostComments,(0,C.$Rqc)(Ge,Dt,qt)),ft=Ge.set(i.$4N.ExtHostProgress,new B.$qsc(Ge.getProxy(i.$3N.MainThreadProgress))),Tt=Ge.set(i.$4N.ExtHostLabelService,new X.$dsc(Ge)),Yt=Ge.set(i.$4N.ExtHostTheming,new ye.$Esc(Ge)),Vt=Ge.set(i.$4N.ExtHostTimeline,new Ce.$Gsc(Ge,Dt)),Wt=Ge.set(i.$4N.ExtHostWebviews,new st.$6qc(Ge,Pt.remote,wt,Et,Lt)),Ni=Ge.set(i.$4N.ExtHostWebviewPanels,new ht.$9qc(Ge,Wt,wt)),en=Ge.set(i.$4N.ExtHostCustomEditors,new $.$0qc(Ge,qt,ci,Wt,Ni)),Vi=Ge.set(i.$4N.ExtHostWebviewViews,new gt.$Ksc(Ge,Wt)),Ei=Ge.set(i.$4N.ExtHostTesting,$t.get(he.$Erc)),tn=Ge.set(i.$4N.ExtHostUriOpeners,new de.$Isc(Ge)),nn=Ge.set(i.$4N.ExtHostProfileContentHandlers,new Le.$psc(Ge));Ge.set(i.$4N.ExtHostInteractive,new Pe.$csc(Ge,Ct,Mt,Dt,Et));const Ui=Ge.set(i.$4N.ExtHostChatAgents2,new g.$Mqc(Ge,Et,Dt,qt)),rn=Ge.set(i.$4N.ExtHostChatVariables,new u.$Nqc(Ge)),Bi=Ge.set(i.$4N.ExtHostLanguageModelTools,new ne.$esc(Ge)),Qi=Ge.set(i.$4N.ExtHostAiRelatedInformation,new n.$yqc(Ge)),sn=Ge.set(i.$4N.ExtHostAiEmbeddingVector,new le.$Urc(Ge)),on=Ge.set(i.$4N.ExtHostStatusBar,new _e.$ysc(Ge,Dt.converter)),wn=Ge.set(i.$4N.ExtHostSpeech,new Je.$wsc(Ge)),Ci=Ge.set(i.$4N.ExtHostEmbeddings,new ie.$Trc(Ge)),Hi=Object.values(i.$4N);Ge.assertRegistered(Hi);const bn=new m.$Lqc(Ge,Mt),vn=new S.$Oqc(Ge),Wi=new xe.$gsc(Ge,Et),an=new L.$Qrc(Ge);return t.$Iqc.register(Dt),function(Ae,mi,Ki){function ct(ee){return(ue,Oe,dt)=>{const It=ee(Ft=>{try{ue.call(Oe,Ft)}catch(Ti){D.$3(new Error(`[ExtensionListenerError] Extension '${Ae.identifier.value}' FAILED to handle event: ${Ti.toString()}`,{cause:Ti})),Nt.onExtensionError(Ae.identifier,Ti)}});return dt?.push(It),It}}const kt=function(){let ee=!Ae.isUnderDevelopment;function ue(){ee||(Et.info(`Extension '${Ae.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ee=!0)}return function Oe(dt){if(Array.isArray(dt))dt.forEach(Oe);else if(typeof dt=="string")ue();else{const It=dt;typeof It.scheme>"u"&&ue(),typeof It.exclusive=="boolean"&&(0,Xe.$wH)(Ae,"documentFiltersExclusive")}return dt}}(),yn={getSession(ee,ue,Oe){return typeof Oe?.forceNewSession=="object"&&Oe.forceNewSession.learnMore&&(0,Xe.$wH)(Ae,"authLearnMore"),Kt.getSession(Ae,ee,ue,Oe)},getAccounts(ee){return Kt.getAccounts(ee)},async hasSession(ee,ue){return(0,Xe.$wH)(Ae,"authSession"),!!await Kt.getSession(Ae,ee,ue,{silent:!0})},get onDidChangeSessions(){return ct(Kt.onDidChangeSessions)},registerAuthenticationProvider(ee,ue,Oe,dt){return Kt.registerAuthenticationProvider(ee,ue,Oe,dt)}},Gi={registerCommand(ee,ue,Oe){return Dt.registerCommand(!0,ee,ue,Oe,void 0,Ae)},registerTextEditorCommand(ee,ue,Oe){return Dt.registerCommand(!0,ee,(...dt)=>{const It=zt.getActiveTextEditor();if(!It){Et.warn("Cannot execute "+ee+" because there is no active text editor.");return}return It.edit(Ft=>{ue.apply(Oe,[It,Ft,...dt])}).then(Ft=>{Ft||Et.warn("Edits from command "+ee+" were not applied.")},Ft=>{Et.warn("An error occurred while running command "+ee,Ft)})},void 0,void 0,Ae)},registerDiffInformationCommand:(ee,ue,Oe)=>((0,Xe.$wH)(Ae,"diffCommand"),Dt.registerCommand(!0,ee,async(...dt)=>{const It=Mt.activeEditor(!0);if(!It){Et.warn("Cannot execute "+ee+" because there is no active text editor.");return}const Ft=await zt.getDiffInformation(It.id);ue.apply(Oe,[Ft,...dt])},void 0,void 0,Ae)),executeCommand(ee,...ue){return Dt.executeCommand(ee,...ue)},getCommands(ee=!1){return Dt.getCommands(ee)}},Ji={get machineId(){return Pt.telemetryInfo.machineId},get sessionId(){return Pt.telemetryInfo.sessionId},get language(){return Pt.environment.appLanguage},get appName(){return Pt.environment.appName},get appRoot(){return Pt.environment.appRoot?.fsPath??""},get appHost(){return Pt.environment.appHost},get uriScheme(){return Pt.environment.appUriScheme},get clipboard(){return vn.value},get shell(){return bt.getDefaultShell(!1)},get onDidChangeShell(){return ct(bt.onDidChangeShell)},get isTelemetryEnabled(){return Nt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ct(Nt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Xe.$wH)(Ae,"telemetry"),Nt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Xe.$wH)(Ae,"telemetry"),ct(Nt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,ot.$WQ)(Pt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ee,ue){return ot.$VQ.validateSender(ee),Nt.instantiateLogger(Ae,ee,ue)},openExternal(ee,ue){return Bt.openUri(ee,{allowTunneling:!!Pt.remote.authority,allowContributedOpeners:ue?.allowContributedOpeners})},async asExternalUri(ee){if(ee.scheme===Pt.environment.appUriScheme)return yi.createAppUri(ee);try{return await Bt.asExternalUri(ee,{allowTunneling:!!Pt.remote.authority})}catch(ue){if((0,R.$Rg)(ee,R.Schemas.http)||(0,R.$Rg)(ee,R.Schemas.https))return ee;throw ue}},get remoteName(){return(0,l.$mn)(Pt.remote.authority)},get remoteAuthority(){return(0,Xe.$wH)(Ae,"resolvers"),Pt.remote.authority},get uiKind(){return Pt.uiKind},get logLevel(){return Et.getLevel()},get onDidChangeLogLevel(){return ct(Et.onDidChangeLogLevel)},get appQuality(){return(0,Xe.$wH)(Ae,"resolvers"),Pt.quality},get appCommit(){return(0,Xe.$wH)(Ae,"resolvers"),Pt.commit}};Pt.environment.extensionTestsLocationURI||Object.freeze(Ji);const ki={createTestController(ee,ue,Oe){return Ei.createTestController(Ae,ee,ue,Oe)},createTestObserver(){return(0,Xe.$wH)(Ae,"testObserver"),Ei.createTestObserver()},runTests(ee){return(0,Xe.$wH)(Ae,"testObserver"),Ei.runTests(ee)},registerTestFollowupProvider(ee){return(0,Xe.$wH)(Ae,"testObserver"),Ei.registerTestFollowupProvider(ee)},get onDidChangeTestResults(){return(0,Xe.$wH)(Ae,"testObserver"),ct(Ei.onResultsChanged)},get testResults(){return(0,Xe.$wH)(Ae,"testObserver"),Ei.results}},Ri=Pt.remote.isRemote?W.ExtensionKind.Workspace:W.ExtensionKind.UI,Sn={getExtension(ee,ue){(0,Xe.$vH)(Ae,"extensionsAny")||(ue=!1);const Oe=mi.mine.getExtensionDescription(ee);if(Oe)return new _.$Arc(Ht,Ae.identifier,Oe,Ri,!1);if(ue){const dt=mi.all.getExtensionDescription(ee);if(dt)return new _.$Arc(Ht,Ae.identifier,dt,Ri,!0)}},get all(){const ee=[];for(const ue of mi.mine.getAllExtensionDescriptions())ee.push(new _.$Arc(Ht,Ae.identifier,ue,Ri,!1));return ee},get allAcrossExtensionHosts(){(0,Xe.$wH)(Ae,"extensionsAny");const ee=new E.$wn(mi.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),ue=[];for(const Oe of mi.all.getAllExtensionDescriptions()){const dt=!ee.has(Oe.identifier);ue.push(new _.$Arc(Ht,Ae.identifier,Oe,Ri,dt))}return ue},get onDidChange(){return(0,Xe.$vH)(Ae,"extensionsAny")?ct(P.Event.any(mi.mine.onDidChange,mi.all.onDidChange)):ct(mi.mine.onDidChange)}},pi={createDiagnosticCollection(ee){return wi.createDiagnosticCollection(Ae.identifier,ee)},get onDidChangeDiagnostics(){return ct(wi.onDidChangeDiagnostics)},getDiagnostics:ee=>wi.getDiagnostics(ee),getLanguages(){return bi.getLanguages()},setTextDocumentLanguage(ee,ue){return bi.changeLanguage(ee.uri,ue)},match(ee,ue){const Oe=Z.LanguageSelector.from(ee);let dt;return(0,I.$Du)(Oe)&&(dt=Ct.notebookDocuments.find(It=>It.apiNotebook.getCells().find(Ft=>Ft.document===ue))?.apiNotebook),(0,I.$Cu)(Oe,ue.uri,ue.languageId,!0,dt?.uri,dt?.notebookType)},registerCodeActionsProvider(ee,ue,Oe){return me.registerCodeActionProvider(Ae,kt(ee),ue,Oe)},registerDocumentPasteEditProvider(ee,ue,Oe){return(0,Xe.$wH)(Ae,"documentPaste"),me.registerDocumentPasteEditProvider(Ae,kt(ee),ue,Oe)},registerCodeLensProvider(ee,ue){return me.registerCodeLensProvider(Ae,kt(ee),ue)},registerDefinitionProvider(ee,ue){return me.registerDefinitionProvider(Ae,kt(ee),ue)},registerDeclarationProvider(ee,ue){return me.registerDeclarationProvider(Ae,kt(ee),ue)},registerImplementationProvider(ee,ue){return me.registerImplementationProvider(Ae,kt(ee),ue)},registerTypeDefinitionProvider(ee,ue){return me.registerTypeDefinitionProvider(Ae,kt(ee),ue)},registerHoverProvider(ee,ue){return me.registerHoverProvider(Ae,kt(ee),ue,Ae.identifier)},registerEvaluatableExpressionProvider(ee,ue){return me.registerEvaluatableExpressionProvider(Ae,kt(ee),ue,Ae.identifier)},registerInlineValuesProvider(ee,ue){return me.registerInlineValuesProvider(Ae,kt(ee),ue,Ae.identifier)},registerDocumentHighlightProvider(ee,ue){return me.registerDocumentHighlightProvider(Ae,kt(ee),ue)},registerMultiDocumentHighlightProvider(ee,ue){return me.registerMultiDocumentHighlightProvider(Ae,kt(ee),ue)},registerLinkedEditingRangeProvider(ee,ue){return me.registerLinkedEditingRangeProvider(Ae,kt(ee),ue)},registerReferenceProvider(ee,ue){return me.registerReferenceProvider(Ae,kt(ee),ue)},registerRenameProvider(ee,ue){return me.registerRenameProvider(Ae,kt(ee),ue)},registerNewSymbolNamesProvider(ee,ue){return(0,Xe.$wH)(Ae,"newSymbolNamesProvider"),me.registerNewSymbolNamesProvider(Ae,kt(ee),ue)},registerDocumentSymbolProvider(ee,ue,Oe){return me.registerDocumentSymbolProvider(Ae,kt(ee),ue,Oe)},registerWorkspaceSymbolProvider(ee){return me.registerWorkspaceSymbolProvider(Ae,ee)},registerDocumentFormattingEditProvider(ee,ue){return me.registerDocumentFormattingEditProvider(Ae,kt(ee),ue)},registerDocumentRangeFormattingEditProvider(ee,ue){return me.registerDocumentRangeFormattingEditProvider(Ae,kt(ee),ue)},registerOnTypeFormattingEditProvider(ee,ue,Oe,...dt){return me.registerOnTypeFormattingEditProvider(Ae,kt(ee),ue,[Oe].concat(dt))},registerDocumentSemanticTokensProvider(ee,ue,Oe){return me.registerDocumentSemanticTokensProvider(Ae,kt(ee),ue,Oe)},registerDocumentRangeSemanticTokensProvider(ee,ue,Oe){return me.registerDocumentRangeSemanticTokensProvider(Ae,kt(ee),ue,Oe)},registerSignatureHelpProvider(ee,ue,Oe,...dt){return typeof Oe=="object"?me.registerSignatureHelpProvider(Ae,kt(ee),ue,Oe):me.registerSignatureHelpProvider(Ae,kt(ee),ue,typeof Oe>"u"?[]:[Oe,...dt])},registerCompletionItemProvider(ee,ue,...Oe){return me.registerCompletionItemProvider(Ae,kt(ee),ue,Oe)},registerInlineCompletionItemProvider(ee,ue,Oe){return ue.handleDidShowCompletionItem&&(0,Xe.$wH)(Ae,"inlineCompletionsAdditions"),ue.handleDidPartiallyAcceptCompletionItem&&(0,Xe.$wH)(Ae,"inlineCompletionsAdditions"),Oe&&(0,Xe.$wH)(Ae,"inlineCompletionsAdditions"),me.registerInlineCompletionsProvider(Ae,kt(ee),ue,Oe)},registerInlineEditProvider(ee,ue){return(0,Xe.$wH)(Ae,"inlineEdit"),me.registerInlineEditProvider(Ae,kt(ee),ue)},registerDocumentLinkProvider(ee,ue){return me.registerDocumentLinkProvider(Ae,kt(ee),ue)},registerColorProvider(ee,ue){return me.registerColorProvider(Ae,kt(ee),ue)},registerFoldingRangeProvider(ee,ue){return me.registerFoldingRangeProvider(Ae,kt(ee),ue)},registerSelectionRangeProvider(ee,ue){return me.registerSelectionRangeProvider(Ae,ee,ue)},registerCallHierarchyProvider(ee,ue){return me.registerCallHierarchyProvider(Ae,ee,ue)},registerTypeHierarchyProvider(ee,ue){return me.registerTypeHierarchyProvider(Ae,ee,ue)},setLanguageConfiguration:(ee,ue)=>me.setLanguageConfiguration(Ae,ee,ue),getTokenInformationAtPosition(ee,ue){return(0,Xe.$wH)(Ae,"tokenInformation"),bi.tokenAtPosition(ee,ue)},registerInlayHintsProvider(ee,ue){return me.registerInlayHintsProvider(Ae,ee,ue)},createLanguageStatusItem(ee,ue){return bi.createLanguageStatusItem(Ae,ee,ue)},registerDocumentDropEditProvider(ee,ue,Oe){return me.registerDocumentOnDropEditProvider(Ae,ee,ue,(0,Xe.$vH)(Ae,"documentPaste")?Oe:void 0)}},qi={get activeTextEditor(){return zt.getActiveTextEditor()},get visibleTextEditors(){return zt.getVisibleTextEditors()},get activeTerminal(){return bt.activeTerminal},get terminals(){return bt.terminals},async showTextDocument(ee,ue,Oe){p.URI.isUri(ee)&&ee.scheme===R.Schemas.vscodeRemote&&!ee.authority&&Lt.report("workspace.showTextDocument",Ae,"A URI of 'vscode-remote' scheme requires an authority.");const dt=await(p.URI.isUri(ee)?Promise.resolve(Xi.openTextDocument(ee)):Promise.resolve(ee));return zt.showTextDocument(dt,ue,Oe)},createTextEditorDecorationType(ee){return zt.createTextEditorDecorationType(Ae,ee)},onDidChangeActiveTextEditor(ee,ue,Oe){return ct(zt.onDidChangeActiveTextEditor)(ee,ue,Oe)},onDidChangeVisibleTextEditors(ee,ue,Oe){return ct(zt.onDidChangeVisibleTextEditors)(ee,ue,Oe)},onDidChangeTextEditorSelection(ee,ue,Oe){return ct(zt.onDidChangeTextEditorSelection)(ee,ue,Oe)},onDidChangeTextEditorOptions(ee,ue,Oe){return ct(zt.onDidChangeTextEditorOptions)(ee,ue,Oe)},onDidChangeTextEditorVisibleRanges(ee,ue,Oe){return ct(zt.onDidChangeTextEditorVisibleRanges)(ee,ue,Oe)},onDidChangeTextEditorViewColumn(ee,ue,Oe){return ct(zt.onDidChangeTextEditorViewColumn)(ee,ue,Oe)},onDidCloseTerminal(ee,ue,Oe){return ct(bt.onDidCloseTerminal)(ee,ue,Oe)},onDidOpenTerminal(ee,ue,Oe){return ct(bt.onDidOpenTerminal)(ee,ue,Oe)},onDidChangeActiveTerminal(ee,ue,Oe){return ct(bt.onDidChangeActiveTerminal)(ee,ue,Oe)},onDidChangeTerminalDimensions(ee,ue,Oe){return(0,Xe.$wH)(Ae,"terminalDimensions"),ct(bt.onDidChangeTerminalDimensions)(ee,ue,Oe)},onDidChangeTerminalState(ee,ue,Oe){return ct(bt.onDidChangeTerminalState)(ee,ue,Oe)},onDidWriteTerminalData(ee,ue,Oe){return(0,Xe.$wH)(Ae,"terminalDataWriteEvent"),ct(bt.onDidWriteTerminalData)(ee,ue,Oe)},onDidExecuteTerminalCommand(ee,ue,Oe){return(0,Xe.$wH)(Ae,"terminalExecuteCommandEvent"),ct(bt.onDidExecuteTerminalCommand)(ee,ue,Oe)},onDidChangeTerminalShellIntegration(ee,ue,Oe){return ct(Jt.onDidChangeTerminalShellIntegration)(ee,ue,Oe)},onDidStartTerminalShellExecution(ee,ue,Oe){return ct(Jt.onDidStartTerminalShellExecution)(ee,ue,Oe)},onDidEndTerminalShellExecution(ee,ue,Oe){return ct(Jt.onDidEndTerminalShellExecution)(ee,ue,Oe)},get state(){return Bt.getState()},onDidChangeWindowState(ee,ue,Oe){return ct(Bt.onDidChangeWindowState)(ee,ue,Oe)},showInformationMessage(ee,...ue){return Wi.showMessage(Ae,O.default.Info,ee,ue[0],ue.slice(1))},showWarningMessage(ee,...ue){return Wi.showMessage(Ae,O.default.Warning,ee,ue[0],ue.slice(1))},showErrorMessage(ee,...ue){return Wi.showMessage(Ae,O.default.Error,ee,ue[0],ue.slice(1))},showQuickPick(ee,ue,Oe){return K.showQuickPick(Ae,ee,ue,Oe)},showWorkspaceFolderPick(ee){return K.showWorkspaceFolderPick(ee)},showInputBox(ee,ue){return K.showInput(ee,ue)},showOpenDialog(ee){return an.showOpenDialog(Ae,ee)},showSaveDialog(ee){return an.showSaveDialog(ee)},createStatusBarItem(ee,ue,Oe){let dt,It,Ft;return typeof ee=="string"?(dt=ee,It=ue,Ft=Oe):(It=ee,Ft=ue),on.createStatusBarEntry(Ae,dt,It,Ft)},setStatusBarMessage(ee,ue){return on.setStatusBarMessage(ee,ue)},withScmProgress(ee){return Lt.report("window.withScmProgress",Ae,"Use 'withProgress' instead."),ft.withProgress(Ae,{location:W.ProgressLocation.SourceControl},(ue,Oe)=>ee({report(dt){}}))},withProgress(ee,ue){return ft.withProgress(Ae,ee,ue)},createOutputChannel(ee,ue){return Mi.createOutputChannel(ee,ue,Ae)},createWebviewPanel(ee,ue,Oe,dt){return Ni.createWebviewPanel(Ae,ee,ue,Oe,dt)},createWebviewTextEditorInset(ee,ue,Oe,dt){return(0,Xe.$wH)(Ae,"editorInsets"),Di.createWebviewEditorInset(ee,ue,Oe,dt,Ae)},createTerminal(ee,ue,Oe){return typeof ee=="object"?"pty"in ee?bt.createExtensionTerminal(ee):bt.createTerminalFromOptions(ee):bt.createTerminal(ee,ue,Oe)},registerTerminalLinkProvider(ee){return bt.registerLinkProvider(ee)},registerTerminalProfileProvider(ee,ue){return bt.registerProfileProvider(Ae,ee,ue)},registerTerminalQuickFixProvider(ee,ue){return(0,Xe.$wH)(Ae,"terminalQuickFixProvider"),bt.registerTerminalQuickFixProvider(ee,Ae.identifier.value,ue)},registerTreeDataProvider(ee,ue){return Pi.registerTreeDataProvider(ee,ue,Ae)},createTreeView(ee,ue){return Pi.createTreeView(ee,ue,Ae)},registerWebviewPanelSerializer:(ee,ue)=>Ni.registerWebviewPanelSerializer(Ae,ee,ue),registerCustomEditorProvider:(ee,ue,Oe={})=>en.registerCustomEditorProvider(Ae,ee,ue,Oe),registerFileDecorationProvider(ee){return li.registerFileDecorationProvider(ee,Ae)},registerUriHandler(ee){return yi.registerUriHandler(Ae,ee)},createQuickPick(){return K.createQuickPick(Ae)},createInputBox(){return K.createInputBox(Ae)},get activeColorTheme(){return Yt.activeColorTheme},onDidChangeActiveColorTheme(ee,ue,Oe){return ct(Yt.onDidChangeActiveColorTheme)(ee,ue,Oe)},registerWebviewViewProvider(ee,ue,Oe){return Vi.registerWebviewViewProvider(Ae,ee,ue,Oe?.webviewOptions)},get activeNotebookEditor(){return Ct.activeNotebookEditor},onDidChangeActiveNotebookEditor(ee,ue,Oe){return ct(Ct.onDidChangeActiveNotebookEditor)(ee,ue,Oe)},get visibleNotebookEditors(){return Ct.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ct(Ct.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ee,ue,Oe){return ct(Ai.onDidChangeNotebookEditorSelection)(ee,ue,Oe)},onDidChangeNotebookEditorVisibleRanges(ee,ue,Oe){return ct(Ai.onDidChangeNotebookEditorVisibleRanges)(ee,ue,Oe)},showNotebookDocument(ee,ue){return Ct.showNotebookDocument(ee,ue)},registerExternalUriOpener(ee,ue,Oe){return(0,Xe.$wH)(Ae,"externalUriOpener"),tn.registerExternalUriOpener(Ae.identifier,ee,ue,Oe)},registerProfileContentHandler(ee,ue){return(0,Xe.$wH)(Ae,"profileContentHandlers"),nn.registerProfileContentHandler(Ae,ee,ue)},registerQuickDiffProvider(ee,ue,Oe,dt){return(0,Xe.$wH)(Ae,"quickDiffProvider"),ze.registerQuickDiffProvider(kt(ee),ue,Oe,dt)},get tabGroups(){return ni.tabGroups},registerShareProvider(ee,ue){return(0,Xe.$wH)(Ae,"shareProvider"),Ze.registerShareProvider(kt(ee),ue)}},Xi={get rootPath(){return Lt.report("workspace.rootPath",Ae,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),wt.getPath()},set rootPath(ee){throw new D.$$("rootPath")},getWorkspaceFolder(ee){return wt.getWorkspaceFolder(ee)},get workspaceFolders(){return wt.getWorkspaceFolders()},get name(){return wt.name},set name(ee){throw new D.$$("name")},get workspaceFile(){return wt.workspaceFile},set workspaceFile(ee){throw new D.$$("workspaceFile")},updateWorkspaceFolders:(ee,ue,...Oe)=>wt.updateWorkspaceFolders(Ae,ee,ue||0,...Oe),onDidChangeWorkspaceFolders:function(ee,ue,Oe){return ct(wt.onDidChangeWorkspace)(ee,ue,Oe)},asRelativePath:(ee,ue)=>wt.getRelativePath(ee,ue),findFiles:(ee,ue,Oe,dt)=>wt.findFiles(ee,ue,Oe,Ae.identifier,dt),findFiles2:(ee,ue,Oe)=>((0,Xe.$wH)(Ae,"findFiles2"),wt.findFiles2(ee,ue,Ae.identifier,Oe)),findFiles2New:(ee,ue,Oe)=>((0,Xe.$wH)(Ae,"findFiles2New"),wt.findFiles2New(ee,ue,Ae.identifier,Oe)),findTextInFiles:(ee,ue,Oe,dt)=>{(0,Xe.$wH)(Ae,"findTextInFiles");let It,Ft;return typeof ue=="object"?(It=ue,Ft=Oe):(It={},Ft=ue,dt=Oe),wt.findTextInFiles(ee,It||{},Ft,Ae.identifier,dt)},findTextInFilesNew:(ee,ue,Oe)=>((0,Xe.$wH)(Ae,"findTextInFilesNew"),(0,Xe.$wH)(Ae,"textSearchProviderNew"),wt.findTextInFilesNew(ee,Ae.identifier,ue||{},Oe)),save:ee=>wt.save(ee),saveAs:ee=>wt.saveAs(ee),saveAll:ee=>wt.saveAll(ee),applyEdit(ee,ue){return bn.applyWorkspaceEdit(ee,Ae,ue)},createFileSystemWatcher:(ee,ue,Oe,dt)=>{let It;return typeof ue=="boolean"?It={ignoreCreateEvents:!!ue,ignoreChangeEvents:!!Oe,ignoreDeleteEvents:!!dt,correlate:!1}:ue&&((0,Xe.$wH)(Ae,"createFileSystemWatcher"),It={...ue,correlate:!0}),ae.createFileSystemWatcher(wt,Ae,ee,It)},get textDocuments(){return qt.getAllDocumentData().map(ee=>ee.document)},set textDocuments(ee){throw new D.$$("textDocuments")},openTextDocument(ee){let ue;const Oe=ee;if(typeof ee=="string")ue=Promise.resolve(p.URI.file(ee));else if(p.URI.isUri(ee))ue=Promise.resolve(ee);else if(!Oe||typeof Oe=="object")ue=qt.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(dt=>(Et.trace(`openTextDocument from ${Ae.identifier}`),dt.scheme===R.Schemas.vscodeRemote&&!dt.authority&&Lt.report("workspace.openTextDocument",Ae,"A URI of 'vscode-remote' scheme requires an authority."),qt.ensureDocumentData(dt).then(It=>It.document)))},onDidOpenTextDocument:(ee,ue,Oe)=>ct(qt.onDidAddDocument)(ee,ue,Oe),onDidCloseTextDocument:(ee,ue,Oe)=>ct(qt.onDidRemoveDocument)(ee,ue,Oe),onDidChangeTextDocument:(ee,ue,Oe)=>ct(qt.onDidChangeDocument)(ee,ue,Oe),onDidSaveTextDocument:(ee,ue,Oe)=>ct(qt.onDidSaveDocument)(ee,ue,Oe),onWillSaveTextDocument:(ee,ue,Oe)=>ct(Fi.getOnWillSaveTextDocumentEvent(Ae))(ee,ue,Oe),get notebookDocuments(){return Ct.notebookDocuments.map(ee=>ee.apiNotebook)},async openNotebookDocument(ee,ue){let Oe;if(p.URI.isUri(ee))Oe=ee,await Ct.openNotebookDocument(ee);else if(typeof ee=="string")Oe=p.URI.revive(await Ct.createNotebookDocument({viewType:ee,content:ue}));else throw new Error("Invalid arguments");return Ct.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(ee,ue,Oe){return ct(Si.onDidSaveNotebookDocument)(ee,ue,Oe)},onDidChangeNotebookDocument(ee,ue,Oe){return ct(Si.onDidChangeNotebookDocument)(ee,ue,Oe)},onWillSaveNotebookDocument(ee,ue,Oe){return ct(ji.getOnWillSaveNotebookDocumentEvent(Ae))(ee,ue,Oe)},get onDidOpenNotebookDocument(){return ct(Ct.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ct(Ct.onDidCloseNotebookDocument)},registerNotebookSerializer(ee,ue,Oe,dt){return Ct.registerNotebookSerializer(Ae,ee,ue,Oe,(0,Xe.$vH)(Ae,"notebookLiveShare")?dt:void 0)},onDidChangeConfiguration:(ee,ue,Oe)=>ct(Ki.onDidChangeConfiguration)(ee,ue,Oe),getConfiguration(ee,ue){return ue=arguments.length===1?void 0:ue,Ki.getConfiguration(ee,ue,Ae)},registerTextDocumentContentProvider(ee,ue){return fi.registerTextDocumentContentProvider(ee,ue)},registerTaskProvider:(ee,ue)=>(Lt.report("window.registerTaskProvider",Ae,"Use the corresponding function on the 'tasks' namespace instead"),Zt.registerTaskProvider(Ae,ee,ue)),registerFileSystemProvider(ee,ue,Oe){return(0,N.$Uc)(De.registerFileSystemProvider(Ae,ee,ue,Oe),ti.addFileSystemProvider(ee,ue,Oe))},get fs(){return ti.value},registerFileSearchProvider:(ee,ue)=>((0,Xe.$wH)(Ae,"fileSearchProvider"),hi.registerFileSearchProviderOld(ee,ue)),registerTextSearchProvider:(ee,ue)=>((0,Xe.$wH)(Ae,"textSearchProvider"),hi.registerTextSearchProviderOld(ee,ue)),registerAITextSearchProvider:(ee,ue)=>((0,Xe.$wH)(Ae,"aiTextSearchProvider"),(0,Xe.$wH)(Ae,"textSearchProvider"),hi.registerAITextSearchProviderOld(ee,ue)),registerFileSearchProviderNew:(ee,ue)=>((0,Xe.$wH)(Ae,"fileSearchProviderNew"),{dispose:()=>{}}),registerTextSearchProviderNew:(ee,ue)=>((0,Xe.$wH)(Ae,"textSearchProviderNew"),{dispose:()=>{}}),registerAITextSearchProviderNew:(ee,ue)=>((0,Xe.$wH)(Ae,"aiTextSearchProviderNew"),(0,Xe.$wH)(Ae,"textSearchProviderNew"),{dispose:()=>{}}),registerRemoteAuthorityResolver:(ee,ue)=>((0,Xe.$wH)(Ae,"resolvers"),Ht.registerRemoteAuthorityResolver(ee,ue)),registerResourceLabelFormatter:ee=>((0,Xe.$wH)(Ae,"resolvers"),Tt.$registerResourceLabelFormatter(ee)),getRemoteExecServer:ee=>((0,Xe.$wH)(Ae,"resolvers"),Ht.getRemoteExecServer(ee)),onDidCreateFiles:(ee,ue,Oe)=>ct(ae.onDidCreateFile)(ee,ue,Oe),onDidDeleteFiles:(ee,ue,Oe)=>ct(ae.onDidDeleteFile)(ee,ue,Oe),onDidRenameFiles:(ee,ue,Oe)=>ct(ae.onDidRenameFile)(ee,ue,Oe),onWillCreateFiles:(ee,ue,Oe)=>ct(ae.getOnWillCreateFileEvent(Ae))(ee,ue,Oe),onWillDeleteFiles:(ee,ue,Oe)=>ct(ae.getOnWillDeleteFileEvent(Ae))(ee,ue,Oe),onWillRenameFiles:(ee,ue,Oe)=>ct(ae.getOnWillRenameFileEvent(Ae))(ee,ue,Oe),openTunnel:ee=>((0,Xe.$wH)(Ae,"tunnels"),jt.openTunnel(Ae,ee).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,Xe.$wH)(Ae,"tunnels"),jt.getTunnels()},onDidChangeTunnels:(ee,ue,Oe)=>((0,Xe.$wH)(Ae,"tunnels"),ct(jt.onDidChangeTunnels)(ee,ue,Oe)),registerPortAttributesProvider:(ee,ue)=>((0,Xe.$wH)(Ae,"portsAttributes"),jt.registerPortsAttributesProvider(ee,ue)),registerTunnelProvider:(ee,ue)=>((0,Xe.$wH)(Ae,"tunnelFactory"),jt.registerTunnelProvider(ee,ue)),registerTimelineProvider:(ee,ue)=>((0,Xe.$wH)(Ae,"timeline"),Vt.registerTimelineProvider(ee,ue,Ae.identifier,Dt.converter)),get isTrusted(){return wt.trusted},requestWorkspaceTrust:ee=>((0,Xe.$wH)(Ae,"workspaceTrust"),wt.requestWorkspaceTrust(ee)),onDidGrantWorkspaceTrust:(ee,ue,Oe)=>ct(wt.onDidGrantWorkspaceTrust)(ee,ue,Oe),registerEditSessionIdentityProvider:(ee,ue)=>((0,Xe.$wH)(Ae,"editSessionIdentityProvider"),wt.registerEditSessionIdentityProvider(ee,ue)),onWillCreateEditSessionIdentity:(ee,ue,Oe)=>((0,Xe.$wH)(Ae,"editSessionIdentityProvider"),ct(wt.getOnWillCreateEditSessionIdentityEvent(Ae))(ee,ue,Oe)),registerCanonicalUriProvider:(ee,ue)=>((0,Xe.$wH)(Ae,"canonicalUriProvider"),wt.registerCanonicalUriProvider(ee,ue)),getCanonicalUri:(ee,ue,Oe)=>((0,Xe.$wH)(Ae,"canonicalUriProvider"),wt.provideCanonicalUri(ee,ue,Oe))},cn={get inputBox(){return Lt.report("scm.inputBox",Ae,"Use 'SourceControl.inputBox' instead"),ke.getLastInputBox(Ae)},createSourceControl(ee,ue,Oe){return ke.createSourceControl(Ae,ee,ue,Oe)}},ln={createCommentController(ee,ue){return Ve.createCommentController(Ae,ee,ue)}},un={get activeDebugSession(){return St.activeDebugSession},get activeDebugConsole(){return St.activeDebugConsole},get breakpoints(){return St.breakpoints},get activeStackItem(){return St.activeStackItem},registerDebugVisualizationProvider(ee,ue){return(0,Xe.$wH)(Ae,"debugVisualization"),St.registerDebugVisualizationProvider(Ae,ee,ue)},registerDebugVisualizationTreeProvider(ee,ue){return(0,Xe.$wH)(Ae,"debugVisualization"),St.registerDebugVisualizationTree(Ae,ee,ue)},onDidStartDebugSession(ee,ue,Oe){return ct(St.onDidStartDebugSession)(ee,ue,Oe)},onDidTerminateDebugSession(ee,ue,Oe){return ct(St.onDidTerminateDebugSession)(ee,ue,Oe)},onDidChangeActiveDebugSession(ee,ue,Oe){return ct(St.onDidChangeActiveDebugSession)(ee,ue,Oe)},onDidReceiveDebugSessionCustomEvent(ee,ue,Oe){return ct(St.onDidReceiveDebugSessionCustomEvent)(ee,ue,Oe)},onDidChangeBreakpoints(ee,ue,Oe){return ct(St.onDidChangeBreakpoints)(ee,ue,Oe)},onDidChangeActiveStackItem(ee,ue,Oe){return ct(St.onDidChangeActiveStackItem)(ee,ue,Oe)},registerDebugConfigurationProvider(ee,ue,Oe){return St.registerDebugConfigurationProvider(ee,ue,Oe||Qt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ee,ue){return St.registerDebugAdapterDescriptorFactory(Ae,ee,ue)},registerDebugAdapterTrackerFactory(ee,ue){return St.registerDebugAdapterTrackerFactory(ee,ue)},startDebugging(ee,ue,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?St.startDebugging(ee,ue,{parentSession:Oe}):St.startDebugging(ee,ue,Oe||{})},stopDebugging(ee){return St.stopDebugging(ee)},addBreakpoints(ee){return St.addBreakpoints(ee)},removeBreakpoints(ee){return St.removeBreakpoints(ee)},asDebugSourceUri(ee,ue){return St.asDebugSourceUri(ee,ue)}},En={registerTaskProvider:(ee,ue)=>Zt.registerTaskProvider(Ae,ee,ue),fetchTasks:ee=>Zt.fetchTasks(ee),executeTask:ee=>Zt.executeTask(Ae,ee),get taskExecutions(){return Zt.taskExecutions},onDidStartTask:(ee,ue,Oe)=>ct(Zt.onDidStartTask)(ee,ue,Oe),onDidEndTask:(ee,ue,Oe)=>ct(Zt.onDidEndTask)(ee,ue,Oe),onDidStartTaskProcess:(ee,ue,Oe)=>ct(Zt.onDidStartTaskProcess)(ee,ue,Oe),onDidEndTaskProcess:(ee,ue,Oe)=>ct(Zt.onDidEndTaskProcess)(ee,ue,Oe)},hn={createNotebookController(ee,ue,Oe,dt,It){return gi.createNotebookController(Ae,ee,ue,Oe,dt,(0,Xe.$vH)(Ae,"notebookMessaging")?It:void 0)},registerNotebookCellStatusBarItemProvider:(ee,ue)=>Ct.registerNotebookCellStatusBarItemProvider(Ae,ee,ue),createRendererMessaging(ee){return zi.createRendererMessaging(Ae,ee)},createNotebookControllerDetectionTask(ee){return(0,Xe.$wH)(Ae,"notebookKernelSource"),gi.createNotebookControllerDetectionTask(Ae,ee)},registerKernelSourceActionProvider(ee,ue){return(0,Xe.$wH)(Ae,"notebookKernelSource"),gi.registerKernelSourceActionProvider(Ae,ee,ue)},onDidChangeNotebookCellExecutionState(ee,ue,Oe){return(0,Xe.$wH)(Ae,"notebookCellExecutionState"),ct(gi.onDidChangeNotebookCellExecutionState)(ee,ue,Oe)}},dn={t(...ee){if(typeof ee[0]=="string"){const ue=ee.shift(),Oe=!ee||typeof ee[0]!="object"?ee:ee[0];return di.getMessage(Ae.identifier.value,{message:ue,args:Oe})}return di.getMessage(Ae.identifier.value,ee[0])},get bundle(){return di.getBundle(Ae.identifier.value)},get uri(){return di.getBundleUri(Ae.identifier.value)}},kn={transferActiveChat(ee){return(0,Xe.$wH)(Ae,"interactive"),Ui.transferActiveChat(ee)}},In={getRelatedInformation(ee,ue){return(0,Xe.$wH)(Ae,"aiRelatedInformation"),Qi.getRelatedInformation(Ae,ee,ue)},registerRelatedInformationProvider(ee,ue){return(0,Xe.$wH)(Ae,"aiRelatedInformation"),Qi.registerRelatedInformationProvider(Ae,ee,ue)},registerEmbeddingVectorProvider(ee,ue){return(0,Xe.$wH)(Ae,"aiRelatedInformation"),sn.registerEmbeddingVectorProvider(Ae,ee,ue)}},fn={registerChatResponseProvider(ee,ue,Oe){return(0,Xe.$wH)(Ae,"chatProvider"),Gt.registerLanguageModel(Ae,ee,ue,Oe)},registerChatVariableResolver(ee,ue,Oe,dt,It,Ft,Ti,Yi){return(0,Xe.$wH)(Ae,"chatVariableResolver"),rn.registerVariableResolver(Ae,ee,ue,Oe,dt,It,Ft,Ti,Yi?.id)},registerMappedEditsProvider(ee,ue){return(0,Xe.$wH)(Ae,"mappedEditsProvider"),me.registerMappedEditsProvider(Ae,ee,ue)},createChatParticipant(ee,ue){return Ui.createChatAgent(Ae,ee,ue)},createDynamicChatParticipant(ee,ue,Oe){return(0,Xe.$wH)(Ae,"chatParticipantPrivate"),Ui.createDynamicChatAgent(Ae,ee,ue,Oe)},registerChatParticipantDetectionProvider(ee){return(0,Xe.$wH)(Ae,"chatParticipantAdditions"),Ui.registerChatParticipantDetectionProvider(ee)}},Zi={selectChatModels:ee=>Gt.selectLanguageModels(Ae,ee??{}),onDidChangeChatModels:(ee,ue,Oe)=>Gt.onDidChangeProviders(ee,ue,Oe),registerChatModelProvider:(ee,ue,Oe)=>((0,Xe.$wH)(Ae,"chatProvider"),Gt.registerLanguageModel(Ae,ee,ue,Oe)),get embeddingModels(){return(0,Xe.$wH)(Ae,"embeddings"),Ci.embeddingsModels},onDidChangeEmbeddingModels:(ee,ue,Oe)=>((0,Xe.$wH)(Ae,"embeddings"),Ci.onDidChange(ee,ue,Oe)),registerEmbeddingsProvider(ee,ue){return(0,Xe.$wH)(Ae,"embeddings"),Ci.registerEmbeddingsProvider(Ae,ee,ue)},async computeEmbeddings(ee,ue,Oe){return(0,Xe.$wH)(Ae,"embeddings"),Ci.computeEmbeddings(ee,ue,Oe)},registerTool(ee,ue){return(0,Xe.$wH)(Ae,"lmTools"),Bi.registerTool(Ae,ee,ue)},invokeTool(ee,ue,Oe){return(0,Xe.$wH)(Ae,"lmTools"),Bi.invokeTool(ee,ue,Oe)},get tools(){return(0,Xe.$wH)(Ae,"lmTools"),Bi.tools}},gn={registerSpeechProvider(ee,ue){return(0,Xe.$wH)(Ae,"speech"),wn.registerProvider(Ae.identifier,ee,ue)}};return{version:Pt.version,ai:In,authentication:yn,commands:Gi,comments:ln,chat:fn,debug:un,env:Ji,extensions:Sn,interactive:kn,l10n:dn,languages:pi,lm:Zi,notebooks:hn,scm:cn,speech:gn,tasks:En,tests:ki,window:qi,workspace:Xi,Breakpoint:W.$8O,TerminalOutputAnchor:W.TerminalOutputAnchor,ChatResultFeedbackKind:W.ChatResultFeedbackKind,ChatVariableLevel:W.ChatVariableLevel,ChatCompletionItem:W.$4P,CallHierarchyIncomingCall:W.$tO,CallHierarchyItem:W.$sO,CallHierarchyOutgoingCall:W.$uO,CancellationError:D.$7,CancellationTokenSource:v.$ze,CandidatePortSource:i.CandidatePortSource,CodeAction:W.$pO,CodeActionKind:W.$qO,CodeActionTriggerKind:W.CodeActionTriggerKind,CodeLens:W.$vO,Color:W.$IO,ColorInformation:W.$JO,ColorPresentation:W.$KO,ColorThemeKind:W.ColorThemeKind,CommentMode:W.CommentMode,CommentState:W.CommentState,CommentThreadCollapsibleState:W.CommentThreadCollapsibleState,CommentThreadState:W.CommentThreadState,CommentThreadApplicability:W.CommentThreadApplicability,CommentThreadFocus:W.CommentThreadFocus,CompletionItem:W.$CO,CompletionItemKind:W.CompletionItemKind,CompletionItemTag:W.CompletionItemTag,CompletionList:W.$DO,CompletionTriggerKind:W.CompletionTriggerKind,ConfigurationTarget:W.ConfigurationTarget,CustomExecution:W.$SO,DebugAdapterExecutable:W.$_O,DebugAdapterInlineImplementation:W.$cP,DebugAdapterNamedPipeServer:W.$bP,DebugAdapterServer:W.$aP,DebugConfigurationProviderTriggerKind:Qt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:W.DebugConsoleMode,DebugVisualization:W.$sP,DecorationRangeBehavior:W.DecorationRangeBehavior,Diagnostic:W.$iO,DiagnosticRelatedInformation:W.$hO,DiagnosticSeverity:W.DiagnosticSeverity,DiagnosticTag:W.DiagnosticTag,Disposable:W.$5N,DocumentHighlight:W.$lO,DocumentHighlightKind:W.DocumentHighlightKind,MultiDocumentHighlight:W.$mO,DocumentLink:W.$HO,DocumentSymbol:W.$oO,EndOfLine:W.EndOfLine,EnvironmentVariableMutatorType:W.EnvironmentVariableMutatorType,EvaluatableExpression:W.$fP,InlineValueText:W.$gP,InlineValueVariableLookup:W.$hP,InlineValueEvaluatableExpression:W.$iP,InlineCompletionTriggerKind:W.InlineCompletionTriggerKind,EventEmitter:P.$oe,ExtensionKind:W.ExtensionKind,ExtensionMode:W.ExtensionMode,ExternalUriOpenerPriority:W.ExternalUriOpenerPriority,FileChangeType:W.FileChangeType,FileDecoration:W.$uP,FileDecoration2:W.$uP,FileSystemError:W.$lP,FileType:f.FileType,FilePermission:f.FilePermission,FoldingRange:W.$mP,FoldingRangeKind:W.FoldingRangeKind,FunctionBreakpoint:W.$0O,InlineCompletionItem:W.$EO,InlineCompletionList:W.$FO,Hover:W.$jO,VerboseHover:W.$kO,HoverVerbosityAction:W.HoverVerbosityAction,IndentAction:b.IndentAction,Location:W.$gO,MarkdownString:W.$wO,OverviewRulerLane:h.OverviewRulerLane,ParameterInformation:W.$xO,PortAutoForwardAction:W.PortAutoForwardAction,Position:W.$6N,ProcessExecution:W.$QO,ProgressLocation:W.ProgressLocation,QuickInputButtonLocation:W.QuickInputButtonLocation,QuickInputButtons:W.$tP,Range:W.$7N,RelativePattern:W.$6O,Selection:W.$8N,SelectionRange:W.$rO,SemanticTokens:W.$pP,SemanticTokensBuilder:W.$oP,SemanticTokensEdit:W.$qP,SemanticTokensEdits:W.$rP,SemanticTokensLegend:W.$nP,ShellExecution:W.$RO,ShellQuoting:W.ShellQuoting,SignatureHelp:W.$zO,SignatureHelpTriggerKind:W.SignatureHelpTriggerKind,SignatureInformation:W.$yO,SnippetString:W.$fO,SourceBreakpoint:W.$9O,StandardTokenType:W.StandardTokenType,StatusBarAlignment:W.StatusBarAlignment,SymbolInformation:W.$nO,SymbolKind:W.SymbolKind,SymbolTag:W.SymbolTag,Task:W.$TO,TaskGroup:W.$PO,TaskPanelKind:W.TaskPanelKind,TaskRevealKind:W.TaskRevealKind,TaskScope:W.TaskScope,TerminalLink:W.$LO,TerminalQuickFixTerminalCommand:W.$NO,TerminalQuickFixOpener:W.$MO,TerminalLocation:W.TerminalLocation,TerminalProfile:W.$OO,TerminalExitReason:W.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:W.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:W.TextDocumentSaveReason,TextEdit:W.$bO,SnippetTextEdit:W.$dO,TextEditorCursorStyle:s.TextEditorCursorStyle,TextEditorLineNumbersStyle:W.TextEditorLineNumbersStyle,TextEditorRevealType:W.TextEditorRevealType,TextEditorSelectionChangeKind:W.TextEditorSelectionChangeKind,SyntaxTokenType:W.SyntaxTokenType,TextDocumentChangeReason:W.TextDocumentChangeReason,ThemeColor:W.$5O,ThemeIcon:W.$4O,TreeItem:W.$UO,TreeItemCheckboxState:W.TreeItemCheckboxState,TreeItemCollapsibleState:W.TreeItemCollapsibleState,TypeHierarchyItem:W.$RP,UIKind:_t.UIKind,Uri:p.URI,ViewColumn:W.ViewColumn,WorkspaceEdit:W.$eO,DocumentPasteTriggerKind:W.DocumentPasteTriggerKind,DocumentDropEdit:W.$1O,DocumentDropOrPasteEditKind:W.$2O,DocumentPasteEdit:W.$3O,InlayHint:W.$BO,InlayHintLabelPart:W.$AO,InlayHintKind:W.InlayHintKind,RemoteAuthorityResolverError:W.$aO,ResolvedAuthority:W.$$N,ManagedResolvedAuthority:W.$_N,SourceControlInputBoxValidationType:W.SourceControlInputBoxValidationType,ExtensionRuntime:W.ExtensionRuntime,TimelineItem:W.$EP,NotebookRange:W.$wP,NotebookCellKind:W.NotebookCellKind,NotebookCellExecutionState:W.NotebookCellExecutionState,NotebookCellData:W.$xP,NotebookData:W.$yP,NotebookRendererScript:W.$CP,NotebookCellStatusBarAlignment:W.NotebookCellStatusBarAlignment,NotebookEditorRevealType:W.NotebookEditorRevealType,NotebookCellOutput:W.$AP,NotebookCellOutputItem:W.$zP,NotebookCellStatusBarItem:W.$BP,NotebookControllerAffinity:W.NotebookControllerAffinity,NotebookControllerAffinity2:W.NotebookControllerAffinity2,NotebookEdit:W.$cO,NotebookKernelSourceAction:W.$DP,NotebookVariablesRequestKind:W.NotebookVariablesRequestKind,PortAttributes:W.$GP,LinkedEditingRanges:W.$FP,TestResultState:W.TestResultState,TestRunRequest:W.$HP,TestMessage:W.$IP,TestMessageStackFrame:W.$KP,TestTag:W.$JP,TestRunProfileKind:W.TestRunProfileKind,TextSearchCompleteMessageType:At.TextSearchCompleteMessageType,DataTransfer:W.$ZO,DataTransferItem:W.$VO,TestCoverageCount:W.$LP,FileCoverage:W.$NP,FileCoverage2:W.$NP,StatementCoverage:W.$OP,BranchCoverage:W.$PP,DeclarationCoverage:W.$QP,WorkspaceTrustState:W.WorkspaceTrustState,LanguageStatusSeverity:W.LanguageStatusSeverity,QuickPickItemKind:W.QuickPickItemKind,InputBoxValidationSeverity:W.InputBoxValidationSeverity,TabInputText:W.$SP,TabInputTextDiff:W.$TP,TabInputTextMerge:W.$UP,TabInputCustom:W.$VP,TabInputNotebook:W.$XP,TabInputNotebookDiff:W.$YP,TabInputWebview:W.$WP,TabInputTerminal:W.$ZP,TabInputInteractiveWindow:W.$1P,TabInputChat:W.$2P,TabInputTextMultiDiff:W.$3P,TelemetryTrustedValue:d.$Bp,LogLevel:r.LogLevel,EditSessionIdentityMatch:a.EditSessionIdentityMatch,InteractiveSessionVoteDirection:W.InteractiveSessionVoteDirection,ChatCopyKind:W.ChatCopyKind,InteractiveEditorResponseFeedbackKind:W.InteractiveEditorResponseFeedbackKind,DebugStackFrame:W.$dP,DebugThread:W.$eP,RelatedInformationType:W.RelatedInformationType,SpeechToTextStatus:W.SpeechToTextStatus,TextToSpeechStatus:W.TextToSpeechStatus,PartialAcceptTriggerKind:W.PartialAcceptTriggerKind,KeywordRecognitionStatus:W.KeywordRecognitionStatus,ChatResponseMarkdownPart:W.$5P,ChatResponseFileTreePart:W.$9P,ChatResponseAnchorPart:W.$0P,ChatResponseProgressPart:W.$$P,ChatResponseProgressPart2:W.$_P,ChatResponseReferencePart:W.$cQ,ChatResponseReferencePart2:W.$cQ,ChatResponseCodeCitationPart:W.$dQ,ChatResponseWarningPart:W.$aQ,ChatResponseTextEditPart:W.$fQ,ChatResponseMarkdownWithVulnerabilitiesPart:W.$6P,ChatResponseCommandButtonPart:W.$bQ,ChatResponseDetectedParticipantPart:W.$7P,ChatResponseConfirmationPart:W.$8P,ChatResponseMovePart:W.$eQ,ChatResponseReferencePartStatusKind:W.ChatResponseReferencePartStatusKind,ChatRequestTurn:W.$gQ,ChatResponseTurn:W.$hQ,ChatLocation:W.ChatLocation,ChatRequestEditorData:W.$iQ,ChatRequestNotebookData:W.$jQ,LanguageModelChatMessageRole:W.LanguageModelChatMessageRole,LanguageModelChatMessage:W.$lQ,LanguageModelChatMessageFunctionResultPart:W.$kQ,LanguageModelChatResponseTextPart:W.$nQ,LanguageModelChatResponseFunctionUsePart:W.$mQ,LanguageModelError:W.$rQ,NewSymbolName:W.$kP,NewSymbolNameTag:W.NewSymbolNameTag,NewSymbolNameTriggerKind:W.NewSymbolNameTriggerKind,InlineEdit:W.$sQ,InlineEditTriggerKind:W.InlineEditTriggerKind,ExcludeSettingOptions:At.ExcludeSettingOptions,TextSearchContextNew:At.$gM,TextSearchMatchNew:At.$fM,TextSearchCompleteMessageTypeNew:At.TextSearchCompleteMessageType}}}}),define(Re[277],Te([1,0,60,130,45,124,46,34,57,56,132,134,135,89,93,85,123,68,50,88,66,70,215,11,133,86,87,91,95,128,96]),function(we,e,v,D,P,N,R,O,p,s,I,b,h,E,f,r,l,d,a,i,n,t,o,c,m,g,u,S,k,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,v.$Xs)(g.$urc,g.$trc,v.InstantiationType.Delayed),(0,v.$Xs)(c.$ek,o.$Osc,v.InstantiationType.Delayed),(0,v.$Xs)(r.$zqc,r.$Aqc,v.InstantiationType.Delayed),(0,v.$Xs)(O.$ZQ,O.$YQ,v.InstantiationType.Eager),(0,v.$Xs)(S.$Jqc,S.$Kqc,v.InstantiationType.Eager),(0,v.$Xs)(k.$orc,k.$prc,v.InstantiationType.Eager),(0,v.$Xs)(R.$Yqc,R.$Wqc,v.InstantiationType.Eager),(0,v.$Xs)(d.$1qc,d.$Zqc,v.InstantiationType.Eager),(0,v.$Xs)(C.$Erc,C.$Frc,v.InstantiationType.Eager),(0,v.$Xs)(b.$Jrc,b.$Nrc,v.InstantiationType.Eager),(0,v.$Xs)(N.$Prc,N.$Orc,v.InstantiationType.Eager),(0,v.$Xs)(p.$OQ,p.$NQ,v.InstantiationType.Eager),(0,v.$Xs)(u.$vrc,u.$wrc,v.InstantiationType.Eager),(0,v.$Xs)(a.$Dqc,a.$Cqc,v.InstantiationType.Eager),(0,v.$Xs)(D.$osc,D.$nsc,v.InstantiationType.Delayed),(0,v.$Xs)(h.$$rc,h.$_rc,v.InstantiationType.Eager),(0,v.$Xs)(E.$hrc,E.$grc,v.InstantiationType.Eager),(0,v.$Xs)(I.$Bsc,I.$Asc,v.InstantiationType.Eager),(0,v.$Xs)(s.$krc,s.$nrc,v.InstantiationType.Eager),(0,v.$Xs)(y.$Csc,y.$Dsc,v.InstantiationType.Eager),(0,v.$Xs)(f.$PGb,f.$QGb,v.InstantiationType.Eager),(0,v.$Xs)(l.$Msc,l.$Lsc,v.InstantiationType.Eager),(0,v.$Xs)(P.$Vqc,P.$Uqc,v.InstantiationType.Eager),(0,v.$Xs)(i.$rrc,i.$qrc,v.InstantiationType.Eager),(0,v.$Xs)(n.$XQ,n.$UQ,v.InstantiationType.Eager),(0,v.$Xs)(t.$$qc,t.$_qc,v.InstantiationType.Eager),(0,v.$Xs)(m.$Crc,m.$Drc,v.InstantiationType.Eager)}),define(Re[278],Te([1,0,276,47,2,272,7,10,222]),function(we,e,v,D,P,N,R,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3uc=void 0;class s extends N.$Rsc{j(){}getModule(E,f){for(const r of this.b){const l=r(E);if(l){E=l;break}}if(this.a.has(E))return this.a.get(E).load(E,f,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class I extends D.$yrc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async vb(){this.h.createInstance(p.$2uc);const E=this.h.invokeFunction(v.$Nsc);this.r=this.h.createInstance(s,E,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(E){return E.browser}async xb(E,f,r){f=f.with({path:b(f.path,".js")});const l=E?.identifier.value;l&&performance.mark(`code/extHost/willFetchExtensionCode/${l}`);const d=P.URI.revive(await this.C.$asBrowserUri(f)),a=await fetch(d.toString(!0));if(l&&performance.mark(`code/extHost/didFetchExtensionCode/${l}`),a.status!==200)throw new Error(a.statusText);const i=await a.text(),n=`${f.toString(!0)}#vscode-extension`,t=`${i}
//# sourceURL=${n}`;let o;try{o=new Function("module","exports","require",t)}catch(u){throw console.error(l?`Loading code for extension ${l} failed: ${u.message}`:`Loading code failed: ${u.message}`),console.error(`${f.toString(!0)}${typeof u.line=="number"?` line ${u.line}`:""}${typeof u.column=="number"?` column ${u.column}`:""}`),console.error(u),u}E&&await this.w.initializeLocalizedMessages(E);const c={},m={exports:c},g=u=>{const S=this.r.getModule(u,f);if(S===void 0)throw new Error(`Cannot load module '${u}'`);return S};try{return r.codeLoadingStart(),l&&performance.mark(`code/extHost/willLoadExtensionCode/${l}`),o(m,c,g),m.exports!==c?m.exports:c}finally{l&&performance.mark(`code/extHost/didLoadExtensionCode/${l}`),r.codeLoadingStop()}}async $setRemoteEnvironment(E){}async Bb(E=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const f=Date.now()+E;for(;Date.now()<f&&!("__jsDebugIsReady"in globalThis);)await(0,O.$Jh)(10)}}e.$3uc=I;function b(h,E){return h.endsWith(E)?h:h+E}}),define(Re[279],Te([1,0,74,60,11,47,187,92,278]),function(we,e,v,D,P,N,R,O,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$Xs)(P.$dk,new v.$Fi(R.$Qsc,[!0],!0)),(0,D.$Xs)(N.$zrc,p.$3uc,D.InstantiationType.Eager),(0,D.$Xs)(O.$2qc,O.$3qc,D.InstantiationType.Eager)}),define(Re[287],Te([1,0,20,6,84,273,224,22,64,15,2,277,279]),function(we,e,v,D,P,N,R,O,p,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=t,O=qe(O),p=qe(p);const b=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const h=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function E(o){return/^(file|vscode-remote):/i.test(o)}const f=fetch.bind(self);function r(o){self.fetch=async function(c,m){return c instanceof Request||E(String(c))&&(c=(await o(I.URI.parse(String(c)))).toString(!0)),f(c,m)},self.XMLHttpRequest=class extends XMLHttpRequest{open(c,m,g,u,S){(async()=>(E(m.toString())&&(m=(await o(I.URI.parse(m.toString()))).toString(!0)),super.open(c,m,g??!0,u,S)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const o=self.Worker;Worker=function(c,m){if(/^file:/i.test(c.toString()))c=s.$3g.uriToBrowserUri(I.URI.parse(c.toString())).toString(!0);else if(/^vscode-remote:/i.test(c.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const u=`(${function(C){function T(M){return typeof M=="string"||M instanceof URL?String(M).replace(/^file:\/\//i,"vscode-file://vscode-app"):M}const $=fetch.bind(self);self.fetch=function(M,A){return M instanceof Request?$(M,A):$(T(M),A)},self.XMLHttpRequest=class extends XMLHttpRequest{open(M,A,L,J,Y){return super.open(M,T(A),L??!0,J,Y)}};const w=importScripts.bind(self);self.importScripts=(...M)=>{w(...M.map(T))},w(C)}.toString()}('${c}'))`;m=m||{},m.name=`${name} -> ${m.name||O.$qc(c.toString())}`;const S=new Blob([u],{type:"application/javascript"}),k=URL.createObjectURL(S);return new o(k,m)}}else self.Worker=class extends R.$4uc{constructor(o,c){super(h,o,{name:O.$qc(o.toString()),...c})}};const l=new class{constructor(){this.pid=void 0}exit(o){b()}};class d{constructor(){const c=new MessageChannel,m=new D.$oe;let g=!1;h(c.port2,[c.port2]),c.port1.onmessage=u=>{const{data:S}=u;if(!(S instanceof ArrayBuffer)){console.warn("UNKNOWN data received",S);return}const k=v.$Qe.wrap(new Uint8Array(S,0,S.byteLength));if((0,P.$Gn)(k,P.MessageType.Terminate)){g=!0,i("received terminate message from renderer");return}m.fire(k)},this.protocol={onMessage:m.event,send:u=>{if(!g){const S=u.buffer.buffer.slice(u.buffer.byteOffset,u.buffer.byteOffset+u.buffer.byteLength);c.port1.postMessage(S,[S])}}}}}function a(o){return new Promise(c=>{const m=o.onMessage(g=>{m.dispose();const u=JSON.parse(g.toString());o.send((0,P.$Fn)(P.MessageType.Initialized)),c({protocol:o,initData:u})});o.send((0,P.$Fn)(P.MessageType.Ready))})}let i=o=>b();function n(o){return!!o&&typeof o=="object"&&o.type==="vscode.init"&&o.data instanceof Map}function t(){p.mark("code/extHost/willConnectToRenderer");const o=new d;return{onmessage(c){n(c)&&a(o.protocol).then(m=>{p.mark("code/extHost/didWaitForInitData");const g=new N.$Tsc(m.protocol,m.initData,l,null,c.data);r(u=>g.asBrowserUri(u)),i=u=>g.terminate(u)})}}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/c2aa3c4625ed4b46448fa546ac5f2e93b0757718/core/vs/workbench/api/worker/extensionHostWorker.js.map
